(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Plain:: *)
(*<<"LinearAlgebra`MatrixManipulation`"
<<"Statistics`NormalDistribution`"*)
(*<<"Statistics`InverseStatisticalFunctions`"*)
<<"Statistics`Common`DistributionsCommon`"


(* ::Input::Plain:: *)
Unprotect["Hermann`Kronecker`*"];
Clear["Hermann`Kronecker`*"];


(* ::Input::Plain:: *)
Unprotect["Hermann`LSD`*"];
Clear["Hermann`LSD`*"];


(* ::Input::Plain:: *)
Unprotect["Hermann`PARTest`*"];
Clear["Hermann`PARTest`*"];


(* ::Input::Plain:: *)
Clear[LISRELsimul]
LISRELsimul[{n_,Generator_},Theta_,{System_,ThetaFix_}]:=

Block[{p,q,beta,gamma,B1,muexi,sigmaxi,XI,sigmazeta,ZETA,
          ETA,sigmaepsilon,lambdaeta,kp,EPSILON,sigmadelta,lambdaxi,kq,Y,X,DELTA},

{{beta,gamma,muexi,sigmaxi,sigmazeta},
{lambdaeta,lambdaxi,sigmaepsilon,sigmadelta}}=System[Theta,ThetaFix];
{p,q}=Dimensions[gamma];
B1=IdentityMatrix[p]-beta;
sigmaxi=symmetric[sigmaxi];
XI=RandomGauss[muexi,sigmaxi,n,Generator];
sigmazeta=symmetric[sigmazeta];
ZETA=RandomGauss[Shape[0,{p}],sigmazeta,n,Generator];
ETA=(XI.Transpose[gamma]+ZETA).Transpose[Inverse[B1]];
sigmaepsilon=symmetric[sigmaepsilon];
kp=Length[lambdaeta];
EPSILON=RandomGauss[Shape[0,{kp}],sigmaepsilon,n,Generator];
sigmadelta=symmetric[sigmadelta];
kq=Length[lambdaxi];
DELTA=RandomGauss[Shape[0,{kq}],sigmadelta,n,Generator];
Y=ETA.Transpose[lambdaeta]+EPSILON;
X=XI.Transpose[lambdaxi]+DELTA;
{{Y,X,ETA,XI},{ZETA,EPSILON,DELTA},{{beta,gamma,muexi,sigmaxi,sigmazeta},{lambdaeta,lambdaxi,sigmaepsilon,sigmadelta}}}
]


(* ::Input::Plain:: *)
Clear[LISRELlik]
LISRELlik[{S_,m_,n_},Theta_,{System_,ThetaFix_},{Singular_,const_:2 \[Pi]}]:=

Block[{p,q,gamma,beta,B1,muexi,sigmaxi,sigmazeta,sigmaepsilon,lambdaeta,
          kp,sigmadelta,lambdaxi,kq,B11,B11gamma,sigmaetaxi,sigmaeta,sigmayx,
          sigmaxy,sigmax,sigmay,mueeta,muey,muex,SigmaYX,mueYX,l},

{{beta,gamma,muexi,sigmaxi,sigmazeta},
{lambdaeta,lambdaxi,sigmaepsilon,sigmadelta}}=System[Theta,ThetaFix];

{p,q}=Dimensions[gamma];
B1=IdentityMatrix[p]-beta;  
kp=Length[lambdaeta];
kq=Length[lambdaxi];
B11=Inverse[B1];
B11gamma=B11.gamma;  
sigmaetaxi=B11gamma.sigmaxi;
sigmaeta=B11gamma.sigmaxi.Transpose[B11gamma]+B11.sigmazeta.Transpose[B11];
sigmayx=lambdaeta.sigmaetaxi.Transpose[lambdaxi];
sigmaxy=Transpose[sigmayx];
sigmax=lambdaxi.sigmaxi.Transpose[lambdaxi]+sigmadelta; 
sigmay=lambdaeta.sigmaeta.Transpose[lambdaeta]+sigmaepsilon; 
mueeta=B11gamma.muexi; 
muey=lambdaeta.mueeta;
muex=lambdaxi.muexi;
SigmaYX=vv[ii[sigmay,sigmayx],ii[sigmaxy,sigmax]];  
mueYX=Flatten[{muey,muex}];
If[!Singular,
l=-(1/2) n ((kp+kq) Log[const]+Log[Det[SigmaYX]]+Tr[Inverse[SigmaYX].(S+Outer[Times,m-mueYX,m-mueYX])]),

eig=Eigenvalues[SigmaYX];eig=Select[eig,#1>0&];
l=-(1/2) n (Plus@@Log[const eig]+Tr[PseudoInverse[SigmaYX].(S+Outer[Times,m-mueYX,m-mueYX])])]
]


(* ::Input::Plain:: *)
LISRELsimul[{n_,Generator_,X_},Theta_,{System_,ThetaFix_},comp_:True]:=

Block[{p,q,beta,gamma,B1,sigmazeta,ZETA,ETA,sigmaepsilon,lambdaeta,taueta,kp,EPSILON,kq,Y},

{{beta,gamma,sigmazeta},{lambdaeta,taueta,sigmaepsilon}}=System[Theta,ThetaFix];

(*
beta[[1;;10,1;;10]]//MatrixForm//Print;
gamma[[1;;10,1;;10]]//MatrixForm//Print;
sigmazeta[[1;;10,1;;10]]//MatrixForm//Print;
lambdaeta[[1;;10,1;;10]]//MatrixForm//Print;
taueta[[1;;10,1;;10]]//MatrixForm//Print;
sigmaepsilon[[1;;10,1;;10]]//MatrixForm//Print;

Return[];
*)

{p,q}=Dimensions[gamma];
B1=IdentityMatrix[p]-beta;
If[comp,RandomGauss[Shape[0,q],IdentityMatrix[q],n,Generator]];
sigmazeta=symmetric[sigmazeta];
ZETA=RandomGauss[Shape[0,{p}],sigmazeta,n,Generator];
ETA=(X.Transpose[gamma]+ZETA).Transpose[Inverse[B1]];
sigmaepsilon=symmetric[sigmaepsilon];
kp=Length[lambdaeta];
EPSILON=RandomGauss[Shape[0,{kp}],sigmaepsilon,n,Generator];
Y=ETA.Transpose[lambdaeta]+X.Transpose[taueta]+EPSILON;
{{Y,X,ETA},{ZETA,EPSILON},{{beta,gamma,sigmazeta},{lambdaeta,taueta,sigmaepsilon}}}
]


(* ::Input::Plain:: *)
LISRELlik[{S_,m_,n_,Deterministisch_},Theta_,{System_,ThetaFix_},{Singular_,const_:2 \[Pi]}]:=

Block[{p,q,gamma,beta,B1,sigmazeta,sigmaepsilon,lambdaeta,kp,kq,
           B11,sigmaeta,sigmay,M,My,Mx,Myx,MyxCs,CMxy,l,C,Cs,eig},

{{beta,gamma,sigmazeta},{lambdaeta,taueta,sigmaepsilon}}=System[Theta,ThetaFix];
{p,q}=Dimensions[gamma];  
B1=IdentityMatrix[p]-beta;  
kp=Length[lambdaeta];
kq=q;
B11=Inverse[B1]; 
sigmaeta=B11.sigmazeta.Transpose[B11];    
sigmay=lambdaeta.sigmaeta.Transpose[lambdaeta]+sigmaepsilon; 
M=S+Outer[Times,m,m];  
My=M[[Range[kp],Range[kp]]];
Mx=M[[Range[kp+1,kp+kq],Range[kp+1,kp+kq]]];
Myx=M[[Range[kp],Range[kp+1,kp+kq]]];
C=lambdaeta.B11.gamma+taueta;
Cs=Transpose[C];
MyxCs=Myx.Cs;
CMxy=Transpose[MyxCs];  
If[!Singular,

l=-(1/2) n (kp Log[const]+Log[Det[sigmay]]+Tr[Inverse[sigmay].(My+C.Mx.Cs-MyxCs-CMxy)]),

eig=Eigenvalues[sigmay];
eig=Select[eig,#1>0&];
l=-(1/2) n (Plus@@Log[const eig]+Tr[PseudoInverse[sigmay].(My+C.Mx.Cs-MyxCs-CMxy)])]
]


(* ::Input::Plain:: *)
LISRELDet[{S_,m_,n_,Deterministisch_},Theta_,{System_,ThetaFix_},{Singular_,const_:2 \[Pi]}]:=

Block[{p,q,gamma,beta,B1,sigmazeta,sigmaepsilon,lambdaeta,kp,kq,
           B11,sigmaeta,sigmay,M,My,Mx,Myx,MyxCs,CMxy,l,C,Cs,eig},

{{beta,gamma,sigmazeta},{lambdaeta,taueta,sigmaepsilon}}=System[Theta,ThetaFix];
{p,q}=Dimensions[gamma];  
B1=IdentityMatrix[p]-beta;  
kp=Length[lambdaeta];
kq=q;
B11=Inverse[B1]; 
sigmaeta=B11.sigmazeta.Transpose[B11];    
sigmay=lambdaeta.sigmaeta.Transpose[lambdaeta]+sigmaepsilon; 
M=S+Outer[Times,m,m];  
My=M[[Range[kp],Range[kp]]];
Mx=M[[Range[kp+1,kp+kq],Range[kp+1,kp+kq]]];
Myx=M[[Range[kp],Range[kp+1,kp+kq]]];
C=lambdaeta.B11.gamma+taueta;
Cs=Transpose[C];
MyxCs=Myx.Cs;
CMxy=Transpose[MyxCs];  

l=Det[sigmay];
eig=Eigenvalues[sigmay];
{l,eig}

]


(* ::Input::Plain:: *)
LISRELLeastSquares//Clear
LISRELLeastSquares[{S_,m_,n_,Deterministisch_},Theta_,{System_,ThetaFix_},{Singular_,const_:2 \[Pi]}]:=

Block[{p,q,gamma,beta,B1,sigmazeta,sigmaepsilon,lambdaeta,kp,kq,
           B11,sigmaeta,sigmay,M,My,Mx,Myx,MyxCs,CMxy,l,C,Cs,EM,dM},

{{beta,gamma,sigmazeta},{lambdaeta,taueta,sigmaepsilon}}=System[Theta,ThetaFix];
{p,q}=Dimensions[gamma];  
B1=IdentityMatrix[p]-beta;  
kp=Length[lambdaeta];
kq=q;
B11=Inverse[B1]; 
sigmaeta=B11.sigmazeta.Transpose[B11];    
sigmay=lambdaeta.sigmaeta.Transpose[lambdaeta]+sigmaepsilon; 
M=S+Outer[Times,m,m];  
(*My=M[[Range[kp],Range[kp]]];*)
Mx=M[[Range[kp+1,kp+kq],Range[kp+1,kp+kq]]];
(*Myx=M[[Range[kp],Range[kp+1,kp+kq]]];*)
C=lambdaeta.B11.gamma+taueta;
Cs=Transpose[C];
CMx=C.Mx;

EM=((sigmay+CMx.Cs)~ii~CMx)~vv~
         (Transpose[CMx]~ii~Mx);

dM=(M-EM);
yquer=m[[Range[kp]]];
xquer=m[[Range[kp+1,kp+kq]]];
dm=yquer-C.xquer; (*E[yquer]=C.xquer*)

l=-n/2 (Tr[dM.(dM//Transpose)]+dm.dm)

]


(* ::Input::Plain:: *)
NotPosition[List_,pattern_] := 
	Delete[List//Length//Range,Position[List,pattern]];

NormalCorrelation//Clear
NormalCorrelation[{Y_,X_,miss_:-9},Theta_,{System_,ThetaFix_}]:=

Module[{p,q,beta,gamma,sigmazeta,lambdaeta,taueta,sigmaepsilon,
           B1,B11,mueeta,sigmaeta,C,mueY,sel,
           nn,mueetay,sigmaetay,seln,
            lambdaetan,inno,sl,sigmaYn,gain,n},

{{beta,gamma,sigmazeta},{lambdaeta,taueta,sigmaepsilon}}=System[Theta,ThetaFix];

{p,q}=Dimensions[gamma];
B1=IdentityMatrix[p]-beta;
B11=Inverse[B1]; 
sigmazeta=symmetric[sigmazeta];
mueeta=X.Transpose[gamma].Transpose[B11];
sigmaeta=B11.sigmazeta.Transpose[B11];
sigmaepsilon=symmetric[sigmaepsilon];

C=lambdaeta.B11.gamma+taueta;
mueY=X.(C//Transpose);

sel =Map[NotPosition[#,miss]&,Y];
nn=Y//Length;

{mueetay,sigmaetay}=

Table[

seln=sel[[n]];
lambdaetan=lambdaeta[[seln,All]];
           inno=Y[[n,seln]]-mueY[[n,seln]];
sl= sigmaeta.(lambdaetan//Transpose);
sigmaYn=lambdaetan.sl+sigmaepsilon[[seln,seln]];
gain=  sl.Inverse[sigmaYn];
{ mueeta[[n]] + gain.inno,(IdentityMatrix[p]-gain.lambdaetan).sigmaeta},

{n,nn}]//Transpose;


{{mueetay,sigmaetay},{mueeta,sigmaeta},{mueY,sigmaY}}
]


(* ::Input::Plain:: *)
Standard[Dbeta_,COV_]:= Module[{X},
X=Map[Flatten,Dbeta];
Shape[Sqrt@VecDiag[(X//Transpose).COV.X],Dbeta//Dimensions//Rest]]



DeltaTheorem[X_,{Theta_,COV_},{System_,ThetaFix_},{labely_:None,labeleta_:None,labelx_:None}]:=

Module[{inc,system,Dsystem,beta,gamma,sigmazeta,lambdaeta,taueta,sigmaepsilon,
            B1,B11,mueeta,sigmaeta,sigma},

 {{beta,gamma,sigmazeta},{lambdaeta,taueta,sigmaepsilon}}= system=System[Theta,ThetaFix];

  {p,q}=Dimensions[gamma];
   B1=IdentityMatrix[p]-beta;
   B11=Inverse[B1]; 
   sigmazeta=symmetric[sigmazeta];
   mueeta=X.Transpose[gamma].Transpose[B11];
   sigmaeta=B11.sigmazeta.Transpose[B11];
   sigmaepsilon=symmetric[sigmaepsilon];

  Print["System Matrices (Maximum Likelihood)"];

  beta//MatrixForm[#,TableHeadings->{labeleta,labeleta}]&                   //Print["beta\n",#]&;
  gamma//MatrixForm[#,TableHeadings->{labeleta,labelx}]&                     //Print["gamma\n",#]&;
  sigmazeta//MatrixForm[#,TableHeadings->{labeleta,labeleta}]&       //Print["sigmazeta\n",#]&;
  lambdaeta//MatrixForm[#,TableHeadings->{labely,labeleta}]&            //Print["lambdaeta\n",#]&;
  taueta//MatrixForm[#,TableHeadings->{labely,labeleta}]&                  //Print["taueta\n",#]&;
  sigmaepsilon//MatrixForm[#,TableHeadings->{labely,labely}]&         //Print["sigmaepsilon\n",#]&;
  
 
  Print["\nAsymptotic Standard Errors (Delta Theorem)"];

    inc=$MachineEpsilon^.5 * Abs[Theta];
       
         Dsystem=Table[Flatten[System[GRIDI[Theta,i, inc],{}]-system,1],{i,u}]/inc//Transpose;

   stdbeta= Standard[Dsystem[[1]],COV];
   stdbeta//MatrixForm[#,TableHeadings->{labeleta,labeleta}]&//Print["std(beta)\n",#]&;

   stdgamma= Standard[Dsystem[[2]],COV];
   stdgamma//MatrixForm[#,TableHeadings->{labeleta,labelx}]&//Print["std(gamma)\n",#]&;

   stdsigmazeta= Standard[Dsystem[[3]],COV];
   stdsigmazeta//MatrixForm[#,TableHeadings->{labeleta,labeleta}]&//Print["std(sigmazeta)\n",#]&;

   stdlambdaeta=Standard[Dsystem[[4]],COV];
   stdlambdaeta//MatrixForm[#,TableHeadings->{labely,labeleta}]&//Print["std(lambdaeta)\n",#]&;

   stdtaueta=Standard[Dsystem[[5]],COV];
   stdtaueta//MatrixForm[#,TableHeadings->{labely,labeleta}]&//Print["std(taueta)\n",#]&;

   stdsigmaepsilon=Standard[Dsystem[[6]],COV];
   stdsigmaepsilon//MatrixForm[#,TableHeadings->{labely,labely}]&//Print["std(sigmaepsilon)\n",#]&;

   Print["\nMoments of Endogenous Variables (eta)"];

  mueeta[[1]]//MatrixForm[#,TableHeadings->{labeleta,None}]&           //Print["mueeta[[1]]\n",#]&;
  sigmaeta//MatrixForm[#,TableHeadings->{labeleta,labeleta}]&         //Print["sigmaeta\n",#]&;
  sigmaeta//Sigma2Corr//First//MatrixForm[#,TableHeadings->{labeleta,labeleta}]& 
																   //Print["corr(eta)\n",#]&;
 sigmazeta//MatrixForm[#,TableHeadings->{labeleta,labeleta}]&       //Print["sigmazeta\n",#]&;

(*
sigmazeta//Eigenvalues//Print;
sigmaeta//Eigenvalues//Print;

sigmazeta//Det//Print;
sigmaeta//Det//Print;
*)

B11//MatrixForm[#,TableHeadings->{labeleta,labeleta}]&       //Print["(I-B)^-1 = B11\n",#]&;
B11//Det//Print["|(I-B)^-1| =",#]&;

  {1-VecDiag[sigmazeta]/VecDiag[sigmaeta]}//MatrixForm[#,TableHeadings->{None,labeleta}]& 
//Print["\nSquared Multiple Correlations for Structural Equations: 1-sigmazeta/sigmaeta\n",#]&;

  1-Det[sigmazeta]/Det[sigmaeta]//MatrixForm[#,TableHeadings->{labeleta,None}]& 
//Print["Total Coefficient of Determination for Structural Equations: 1-|sigmazeta|/|sigmaeta| = 1-|I-B|^2 = ",#]&;


sigma= lambdaeta.sigmaeta.(lambdaeta//Transpose)+sigmaepsilon;

{1-VecDiag[sigmaepsilon]/VecDiag[sigma]}//MatrixForm[#,TableHeadings->{None,labely}]& 
//Print["\nSquared Multiple Correlations for Observed Variables: 1-sigmaepsilon/sigma=1-MQR/MQT\n",#]&;

  1-Det[sigmaepsilon]/Det[sigma]//MatrixForm[#,TableHeadings->{labely,None}]& 
				//Print["Total Coefficient of Determination for Observed Variables: 1-|sigmaepsilon|/|sigma| = ",#]&;


sigma//MatrixForm[#,TableHeadings->{labely,labely}]& //Print["Fitted Covariance Matrix sigma\n",#]&;

 {beta,gamma,sigmazeta,lambdaeta,taueta,sigmaepsilon,
 stdbeta,stdgamma,stdsigmazeta,stdlambdaeta,stdtaueta,stdsigmaepsilon,
mueeta,sigmaeta,B11,sigma}
]



(* ::Input::Plain:: *)
Symmetrize[A_]:=0.5(A+Transpose[A]);

IndividualLik//Clear
IndividualLik[{Y_,X_,miss_},Theta_,{System_,ThetaFix_},{Singular_:"CholeskyLinearSolve",const_:2 \[Pi] ,option_:0}]:=

Block[{P,Q,K,gamma,beta,B1,sigmazeta,sigmaepsilon,lambdaeta,
           B11,sigmaeta,sigmay,lik,C,n,yn,ymiss,sel,muesel,sigmaysel,Csel,nue,eig,root,nue1},

{{beta,gamma,sigmazeta},{lambdaeta,taueta,sigmaepsilon}}=System[Theta,ThetaFix];
{P,Q}=gamma//Dimensions;
B1=IdentityMatrix[P]-beta;  
B11=Inverse[B1]; 
sigmaeta=B11.sigmazeta.Transpose[B11];    
sigmay=lambdaeta.sigmaeta.Transpose[lambdaeta]+sigmaepsilon; 
C=lambdaeta.B11.gamma+taueta;

n=Y//Length; 
lik={};

Do[   yn=Y[[nn]];

	(*
       ymiss=Map[SameQ[miss,#]&,yn];
       sel=Locate[ymiss,False];
   *)

       sel=NotPosition[yn,miss];

      If[sel=={},l=0,(*keine Messung*)

   (*else*)

	 sigmaysel=sigmay[[sel,sel]];
	 Csel=C[[sel]];
          muesel=Csel.X[[nn]];
          nue=yn[[sel]]- muesel;

         Which[Singular===False, 
                  l=-(1/2) (Log[Det[const sigmaysel]]+nue.Inverse[sigmaysel].nue),

                  Singular===True,

                 eig=Eigenvalues[sigmay];
                 eig=Select[eig,#1>0&];
                l=-(1/2) (Plus@@Log[const eig]+nue.PseudoInverse[sigmaysel].nue),

                Singular==="CholeskyLinearSolve",

                root=CholeskyDecomposition[sigmaysel//Symmetrize]//Transpose;
                nue=LinearSolve[root,nue];
                l=-(1/2) (Log[Det[const sigmaysel]]+nue.nue),

               Singular==="LinearSolve",

                nue1=LinearSolve[sigmaysel,nue];
                l=-(1/2) (Log[Det[const sigmaysel]]+nue.nue1)
         ];
      ];

       lik=Append[lik,l];
,{nn,n}];

If[option==5,{Plus@@lik,lik},Plus@@lik]

]


(* ::Input::Plain:: *)
LeveragePlot//Clear
LeveragePlot[THETA_,{labeta_,labx_},{i_,j_},X_]:=
Module[{sel},
{{beta,gamma,sigmazeta},{lambdaeta,taueta,sigmaepsilon}}=System[THETA,{}];
{{mueetay,sigmaetay},{mueeta,sigmaeta},{mueY,sigmaY}}= NormalCorrelation[{Y,X},THETA,{System,{}}];
{p,p}=beta//Dimensions;
eta//Clear;
Eta=Table[eta[ii],{ii,p}];
x=X[[1]];
EY=lambdaeta.(beta.Eta+gamma.x) +taueta.x;
EEta=beta.Eta+gamma.x;
rule=Map[Rule[#,0]&,Eta];
Print["beta",beta//MatrixForm[#,TableHeadings->{labeta,labeta}]&,"gamma",gamma//MatrixForm[#,TableHeadings->{labeta,labx}]&];
EEta//MatrixForm[#,TableHeadings->{labeta}]&//Print["eqns",#]&;
sel=Complement[p//Range,{i,j}];
EEta[[i]]/. rule[[sel]]//Print;
g1=Plot[EEta[[i]]/.rule[[sel]]//Evaluate,{eta[j],-5,5},DisplayFunction->Identity,
                                                                                                                              Axes->True,FrameLabel->labeta[[{j,i}]]];
g2=plot1[mueetay[[All,{j,i}]],PlotJoined->False,DisplayFunction->Identity];
Show[g1,g2,DisplayFunction->$DisplayFunction]
]


(* ::Input::Plain:: *)
LISRELsimulNonlin[{n_,Generator_,X_},Theta_,{System_,ThetaFix_},comp_:True]:=

Block[{P,Q,K,beta,gamma,B1,sigmazeta,ZETA,ETA,sigmaepsilon,h,dh,EPSILON,Y},

{{beta,gamma,sigmazeta},{h,dh,sigmaepsilon}}=System[Theta,ThetaFix];

{P,Q}=Dimensions[gamma];
B1=IdentityMatrix[P]-beta;
If[comp,RandomGauss[Shape[0,Q],IdentityMatrix[Q],n,Generator]];
sigmazeta=symmetric[sigmazeta];
ZETA=RandomGauss[Shape[0,{P}],sigmazeta,n,Generator];
ETA=(X.Transpose[gamma]+ZETA).Transpose[Inverse[B1]];
sigmaepsilon=symmetric[sigmaepsilon];
K=Length[sigmaepsilon];
EPSILON=RandomGauss[Shape[0,{K}],sigmaepsilon,n,Generator];
(*MapThread[h[#1,#2,Theta]&,{ETA,X}]//Print;*)
Y=MapThread[h[#1,#2,Theta]&,{ETA,X}]+EPSILON;
{{Y,X,ETA},{ZETA,EPSILON},{{beta,gamma,sigmazeta},{h,dh,sigmaepsilon}}}
]


(* ::Input::Plain:: *)
Symmetrize[A_] := 0.5*(A + Transpose[A]); 

Clear[IndividualLikNonlin]
IndividualLikNonlin[{Y_, X_, miss_}, Theta_, {System_, ThetaFix_, m_:3, eps_:10.^(-16), ksigma_:Infinity, text_:0}, 
   {Singular_:False, const_:2*Pi, option_:0, NorKorr_:0}] := 

Block[{P, Q, K, beta, gamma, sigmazeta, h, sigmaepsilon, B1, B11, sigmaeta, n, lik, yn, sel, 
                 xn, mueeta, vals, hl, hlhl, Eh, hh, sigmaepsilonsel, yy, yetasigmaetaI, ynsel, nue, l0, l1, l, etay, H1, E0etay, V0etay,
         sigmaepsilonselI, zaehler, nenner, H, V0yetaI, d, Likratio, L1}, 

{{beta, gamma, sigmazeta}, {h, sigmaepsilon}} = System[Theta, ThetaFix]; 
{P, Q} = Dimensions[gamma]; 
     B1 = IdentityMatrix[P] - beta;
 B11 = Inverse[B1]; 
 sigmaeta = B11 . sigmazeta . Transpose[B11]; 
     {VALS, WEIGHT} = GaussHermitePointsMulti2[m, P, eps, ksigma, text]; 
 n = Length[Y]; 
lik = {}; 

    Do[

yn = Y[[nn]]; 
sel = NotPosition[yn, miss]; 

If[sel == {}, l = 0, 

Which[Singular === False, 

  xn = X[[nn]]; 
  mueeta = B11 . gamma . xn; 
              vals = TrafoMueSigma[VALS, {mueeta, sigmaeta}, 0];
  hl = (h[#1, xn, Theta][[sel]] & ) /@ vals; hlhl = Dyad /@ hl; 
  Eh = WEIGHT . hl; 
              hh = WEIGHT . hlhl - Dyad[Eh]; 
 sigmaepsilonsel = sigmaepsilon[[sel,sel]];
  yy = hh + sigmaepsilonsel;
  yyI = Inverse[yy]; ynsel = yn[[sel]]; 
              nue = ynsel - Eh;
 l0 = -0.5*(Log[Det[const*yy]] + nue . yyI . nue);

 If[NorKorr === 1, l1 = 0, 

                 yeta = WEIGHT . MapThread[Dyad, {hl, vals}] - Dyad[Eh, mueeta]; 
   etay = Transpose[yeta];
   H1 = etay . yyI;
   E0etay = mueeta + H1 . (ynsel - Eh); 
                 V0etay = sigmaeta - H1 . yeta;
   vals = TrafoMueSigma[VALS, {E0etay, V0etay}, 0];
   hl = (h[#1, xn, Theta][[sel]] & ) /@ vals; 
                 nue = (ynsel - #1 & ) /@ hl;
   sigmaepsilonselI = Inverse[sigmaepsilonsel]; 
   zaehler = (#1 . sigmaepsilonselI . #1 & ) /@ nue; 

                 H = yeta . Inverse[sigmaeta];
   V0yetaI = Inverse[yy - H . etay]; 
  d = ynsel - Eh + H . mueeta;
  nue = (d - H . #1 & ) /@ vals; 
                 nenner = (#1 . V0yetaI . #1 & ) /@ nue; 

  Jacobi = (Det[sigmaepsilonselI]/Det[V0yetaI])^0.5; 
Likratio = Exp[-0.5*(zaehler - nenner)];
 
            If[pp > 0, 

Print[plot1[{vals[[All,pp]], Jacobi*Likratio,WEIGHT}//Transpose, 
            PlotJoined -> False, GridLines -> {{E0etay[[pp]]}, None},dicke->{.01,.02}]]];
              

L1 = Jacobi*WEIGHT . Likratio; 
l1 = Log[L1]

]]];

 l = l0 + l1; 
lik = Append[lik, l] , 

{nn, n}]; 

    If[option == 5, {Plus @@ lik, lik}, Plus @@ lik]]


(* ::Input::Plain:: *)
symmetric[A_]:=.5 (A+Transpose[A]);


(* ::Input::Plain:: *)
Unprotect[RandomGauss];
Clear[RandomGauss];
RandomGauss[X_,Theta_,{mue_,sigma_},n_?IntegerQ,Generator_:Gauss]:=
Module[{m,s,s2},
m=mue[X,Theta];s=sigma[X,Theta];s2=CholeskyDecomposition[s];
(m+#1&)/@(Table[Generator//ToExpression,{n},{Length[m]}].s2)]

RandomGauss[mue_,sigma_,n_?IntegerQ,Generator_:Gauss]:=Module[{s2},s2=CholeskyDecomposition[sigma];
(mue+#1&)/@(Table[Generator//ToExpression,{n},{Length[mue]}].s2)]
Gauss[]:=Plus@@Table[Random[],{i,12}]-6.0;
symmetric[A_]:=.5 (A+Transpose[A]);


(* ::Input::Plain:: *)
max[x__]:=Max[x];SetAttributes[max,Listable];


(* ::Input::Plain:: *)
GRIDIJ[PSI_,i_,J_,HI_,HJ_]:=Module[{OUT},OUT=PSI;OUT[[i]]=OUT[[i]]+HI[[i]];OUT[[J]]=OUT[[J]]+HJ[[J]];OUT]


(* ::Input::Plain:: *)
GRIDI[PSI_,i_,HI_]:=Module[{OUT},OUT=PSI;OUT[[i]]=OUT[[i]]+HI[[i]];OUT]


(* ::Input::Plain:: *)
Clear[SubDiagonalMatrix]
SubDiagonalMatrix[astern_,{T_,p_}]:=
Module[{beta,null=Shape[0,{p,p}]},
If[TensorRank[astern]==3,
beta=Table[If[i==j+1,astern[[i]],null],{i,0,T},{j,0,T}],
beta=Table[If[i==j+1,astern,null],{i,0,T},{j,0,T}]
];

beta=ArrayFlatten[beta]
]


(* ::Input::Plain:: *)
DoUntil[range_,cond_,body_]:=Module[{},Do[body;If[cond,Break[]],range]]
Attributes[DoUntil]=HoldAll;


(* ::Input::Plain:: *)
DoWhile[range_,cond_,body_]:=Module[{},Do[If[!cond,Break[]];body,range]]
Attributes[DoWhile]=HoldAll;


(* ::Input::Plain:: *)
VecPrint[veclist_,label_]:=Print[TableForm[Transpose[veclist],TableHeadings->{Automatic,label},TableDirections->{Column,Row},TableSpacing->{1,2}]]


(* ::Input::Plain:: *)
KroneckerProduct[a_,b_]:=Module[{ab,i,j,k,l},ab=Outer[Times,a,b];{i,j,k,l}=Dimensions[ab];ab=Flatten[Transpose[ab,{1,3,2,4}]];Partition[ab,j l]]


(* ::Input::Plain:: *)
Shape[A_,p_]:=Module[{pp,prod,a},a=A;If[Length[a]==0,Return[Array[a&,p]]];If[Length[p]==1,Return[Flatten[a]],If[Length[p]==2,Return[Take[Partition[Flatten[a],p[[2]]],p[[1]]]],pp=Drop[p,1];prod=Times@@pp;a=Partition[Flatten[a],prod];(Shape[#1,pp]&)/@a]]]


(* ::Input::Plain:: *)
Spalte[x_]:=Shape[x,{Length[x],1}]


(* ::Input::Plain:: *)
BlockDiagonalMatrix[{a_List,b_List}]:=Module[{a1,a2,null1,null2},
{a1,a2}=Dimensions[a];{b1,b2}=Dimensions[b];
null1=Shape[0,{a1,b2}];null2=Shape[0,{b1,a2}];
ArrayFlatten[{{a,null1},{null2,b}}]]

BlockDiagonalMatrix[x_List]:=Module[{hilf},hilf=BlockDiagonalMatrix[Drop[x,-1]];BlockDiagonalMatrix[{hilf,Last[x]}]]


(* ::Input::Plain:: *)
all[A_]:=And@@Flatten[A];
gr[x_,y_]:=x>y;SetAttributes[gr,Listable];
ii=AppendRows;
vv = AppendColumns;
VecDiag=Transpose[#1,{1,1}]&;


(* ::Input::Plain:: *)
Varianz[y_]:=Module[{yy,n,SML,S,means},If[TensorRank[y]===1,yy=Spalte[y],yy=y];n=First[Dimensions[yy]];means=mean[yy];SML=Transpose[yy].yy/n-Outer[Times,means,means];S=(n SML)/(n-1);{SML,S,means}]
mean[y_]:=Plus@@y/First[Dimensions[y]];


(* ::Input::Plain:: *)
AddTimeAxis[X_,dt_:1.0]:=
Module[{T},
T=Length[X];
AppendRows[Shape[dt Range[0,T-1],{T,1}],X]]

AddTimeAxis[X_,{t0_,t1_,dt_}]:=AppendRows[Spalte[Range[t0,t1,dt]],X]





(* ::Input::Plain:: *)

nnn = 1000; 

Options[plot1] = {PlotJoined->True,
				  PlotRange->All,
                  Frame->True,
                  Axes->False,
                  dicke->.003,
	                 gestrichelt->1,
	                 color->Range[nnn],
	                 DisplayFunction->$DisplayFunction,
	                 farbmodell->eigene,
	                 text->Array[(" ")&,nnn],
	                 TEXTSHIFT->Array[{0,0}&,nnn],
	                 permute->Range[nnn],
	                 print->False,
	                 Opacity->Array[1&,nnn]};
   

plot1[Data_List,opts___Rule]:= 
	 
	Module[{d,d1,dash,Datai,i,ii,gi,g,f,
			join1,plotrange,dicke1,frame1,axes1,gestrichelt1,color1,epilog1,aspectratio1,
			optionen,display1,farbe1,text1,textcoords,textshift,print1},
	     
	     		
	{join1,     plotrange,dicke1,frame1,axes1,gestrichelt1,color1,display1,       farbe1    ,text1,textshift,permute1,opacity} = 
	{PlotJoined,PlotRange,dicke, Frame, Axes, gestrichelt, color, DisplayFunction,farbmodell,text, TEXTSHIFT,permute,Opacity} /. {opts} /. Options[plot1];
	
	print1=print/. {opts} /. Options[plot1];
		 
		 
 If[TensorRank[      dicke1]==0,      dicke1 = Array[dicke1&,nnn]]; 
 If[TensorRank[gestrichelt1]==0,gestrichelt1 = Array[gestrichelt1&,nnn]];
 If[TensorRank[      color1]==0,      color1 = Array[color1&,nnn]];  
  
  (*Print["Optionen:{dicke,gestrichelt,color,epilog}"];*)
 (* Print[{join1,dicke1,gestrichelt1,color1,epilog1,aspectratio1}];*)
 
 (*gestrichelt1//Print;*)
 
	     Farben = {RGBColor[.1,.1,.9],
	               RGBColor[.1,.9,.8],
	               RGBColor[0.875, 0.202, 0.515],
	               RGBColor[.4,.3,.6],
	               RGBColor[.9,.3,.4],
	               RGBColor[.9,.0,.2],
	               RGBColor[.4,.0,.9],
			             RGBColor[.6,.9,.4],
			             RGBColor[.6,.1,.4],
			             RGBColor[.0,.0,.0]};
			            
	     Farben = {Blue,
	               SpringGreenMedium,
	               Red,            
	               Yellow,
	               (*BlueViolet,*)
	               DarkSlateBlue,
	               CadmiumOrange,
	               Magenta,
	               TurquoiseDark,
	               VioletRedPale,
	               Black};
	               
		 If[farbe1 === eigene,    Farben,
		 If[farbe1 === Hue,       Farben = Map[Hue,Range[.1,1,.1]//Reverse],
		 If[farbe1 === GrayLevel, Farben = Map[GrayLevel,Range[0,.9,.1] ],
		 					                    Farben = farbe1 ]]];
	     f = Length[Farben];
	     color1 = Mod[color1-1,f]+1; (* nur zulaessige Farben*) 
	     		                   		          			
		 dash = Map[Dashing,
		      	.01{{   },
		 		    {1,1},
		 		    {2,4},
	                {1,2},
			    	{4,4},
	           	    {4,1},
	           	    {1,4},
			   		{1,3,1},
			   		{.8},
	           	    {5,2}
	               		}];
	     f = Length[dash];
	     gestrichelt1 = Mod[gestrichelt1-1,f]+1; (* nur zulaessige Muster *) 
	  
		 					
		 d = Dimensions[Data];
		 If[print1,Print["Dimension der Daten  ",d]];
			
			 
		 If[Dimensions[d]=={1}, (* Vektor *)
		 
		 			g = plot1[Data//Spalte//AddTimeAxis,opts];Return[g], (*rekursiver Aufruf*)
		 			
		 (* else *)
		   
		 If[d[[2]]===1, (* Spalten-Vektor *)
		 	  g = plot1[Data//AddTimeAxis,opts];Return[g],         (*rekursiver Aufruf*)
		 	
		 (* else *)
		 
		 d1=d[[1]]//Range;
		 g = {};
		 
		 Do[
		 
		  ii = permute1[[i-1]];
		 	
		 	Datai = Data[[d1,{1,ii+1}]];
		 	
		 	
		 	links  = (Datai//First); 
		 	rechts = (Datai//Last);
		 	mitte  =  Datai[[ d[[1]]/2//Floor ]];
		 	
		 	If[(text1//Last)==="Links", textcoords = links,
		 					 
		 	If[(text1//Last)==="Rechts",textcoords = rechts,
		 								 
		 	If[(text1//Last)==="Mitte",	textcoords = mitte,
		 	
		 	If[IntegerQ[(text1//Last)],	textcoords = Datai[[text1//Last]],
		 	
		 	                            textcoords = rechts
		 	]]]];
		 								 
		 	textcoords = textcoords + textshift[[ii]];
		 	
		 	gi = ListPlot[Datai, FilterRules[{opts}, Options[ListPlot]],
		 	                     DisplayFunction->Identity,
		 				  	     PlotJoined->join1,
		 				  	     PlotRange->plotrange,
		 				  	     Frame->frame1,
		 				  	     Axes->axes1,
			                     PlotStyle->
			                     {Farben[[color1[[ii]] ]],
			                   	 PointSize[ dicke1[[ii]] ],
		 						 Thickness[ dicke1[[ii]] ],
		 						 dash[[ gestrichelt1[[ii]] ]],
		 						 Text[text1[[ii]],textcoords],
		 						 Opacity[opacity[[ii]]]}];
		 	
		   
		    g = Join[g,{gi}],
		 
		 {i, 2, d[[2]]}];
		 		 					
		];
		
		(*FilterRules[{opts}, Options[ListPlot]]//Print;*)
		
		g = Show[g,DisplayFunction->display1];
	
  Return[g];
    
		];
			
    
](*End of plot1*)


(* ::Input::Plain:: *)
connectdatasets//Clear
connectdatasets[X_,opts___]:=
Module[{g1,g2,arrow1},
arrow1=arrow/.{opts};
{t,n,p}=X//Dimensions;
nX=Join[{n//Range},X];
g1=MapThread[plot1[{##2},farbmodell->Hue,dicke->.03,opts,PlotJoined->False,
                   color->#1,DisplayFunction->Identity]&,nX];
g2=MapThread[plot1[{##2},farbmodell->Hue,opts,PlotJoined->True,       
                   color->#1,DisplayFunction->Identity]&,nX];
g3=If[arrow1, phaseplotarrowmultiple[X//Transpose,DisplayFunction->Identity],{},{}];

Show[g1,g2,g3,DisplayFunction->$DisplayFunction]

]


missings[z_,miss_,op_]:=Apply[op,Map[(#===miss)&,z]]
CaseDel[Z_,miss_]:=Select[Z,Not[missings[#,miss,Or]]&]


(* ::Input::Plain:: *)
(*Unprotect[HeadWidth,Arrow];
Clear[HeadWidth,Arrow];
Remove[HeadWidth,Arrow];
<<Graphics`Arrow`
*)


(* ::Input::Plain:: *)
Compress//Unprotect;
Compress[a_,b_]:= Delete[b,Position[a,False]];

APLCompress//Unprotect;
APLCompress[a_,b_]:= Delete[b,Position[a,0]];

SelectIndex[a_,op_]:= 
	Module[{f,a1},
	f = If[op[ #2[[1]],#2[[2]] ],#1,{}]&;
	a1 = MapIndexed[f, a,{2}];
	Map[Flatten,a1]
	]
	
Delta[x_,lag_:1] := Drop[x,lag] - Drop[x,-lag]
Delta[x_,y_,op_,lag_:1]:= MapThread[op,{Drop[x,lag],Drop[y,-lag]}]

pNorm[x_,p_:2]:= Apply[Plus,Abs[x]^p]^(1/p)


arrowshift=.0;textshift=.1;

BlaBlaDiagramm//Clear;
BlaBlaDiagramm[xy_,text_,r_,mask1_:1,mask2_:1,text1_,text2_,fontsize_:18,opts___]:=
Module[{c,c1,t,n,xyij,dxyij,e},

c=Map[Circle[#,r]&,xy];
t=MapThread[Text[#1,#2]&,{text,xy+.02}];

n=xy//Length;
xyij=Table[xy[[{i,j}]],{i,n},{j,i+1,n}]//Flatten[#,1]&;
dxyij=Flatten[Map[Delta,xyij],1];
e=dxyij/Map[pNorm,dxyij];
width=.3;
anfang=xyij[[All,1]]+r e;
ende  =xyij[[All,2]]-r e;

(*
mask1TF=mask1/.{1->True,0->False};
mask2TF=mask2/.{1->True,0->False};
*)

a12=MapThread[Arrow[{#1,#2}]&,{anfang,ende}-arrowshift];
a21=MapThread[Arrow[{#1,#2}]&,{anfang,ende}+arrowshift//Reverse];

a12=APLCompress[mask1TF,a12];
a21=APLCompress[mask2TF,a21];

c1=.4;
mitte=(c1 anfang+(1-c1)ende); 
t12=MapThread[Text[#1,#2,Background-> LightRed]&,{text1,mitte-textshift}];
t21=MapThread[Text[#1,#2,Background->LightBlue]&,{text2,mitte+textshift}];

t12=APLCompress[mask1TF,t12];
t21=APLCompress[mask2TF,t21];
 

Show[
Graphics[{Thickness[.003],Black,c,
          Thickness[.003],Black,t,
          Thickness[.003],Red,a12,
          Thickness[.003],Blue,a21,
          Thickness[.003],Red,t12,
          Thickness[.003],Blue,t21},
          AspectRatio->Automatic,Frame->True,FrameTicks->False,
          TextStyle->{FontFamily->"Helvetica",FontSize->fontsize}],opts]

]


BlaBlaDiagrammMatrix//Clear
BlaBlaDiagrammMatrix[text_,r_,beta_,fontsize_:18,opts___]:=
  Module[{},
    p=text//Length;
    
    (*xy=Take[Map[Reverse,Tuples[p/2//Ceiling//Range,2]],p]//Reverse;*)
    
    dphi=Pi;
    {phi0,phi1}={0, 2 Pi(1-1/p)}+dphi;
    xy = Table[{Cos[phi],-Sin[phi]},{phi,phi0,phi1,(2 Pi/p)}];
    (*xy = Table[{phi,-Sin[phi]},{phi,phi0,phi1,(2 Pi/p)}];*) (*linear*)
    
    beta01=Map[(#=!=0)&,beta//Rationalize,{2}]/.{1->True,0->False}//Rationalize;
    mask2=SelectIndex[beta01,Less]//Flatten;  (*obere H\[ADoubleDot]lfte j->i*)
    mask1=SelectIndex[beta01//Transpose,Less]//Flatten;
    
    text2=SelectIndex[beta,Less]//Flatten;  (*obere H\[ADoubleDot]lfte j->i*)
    text1=SelectIndex[beta//Transpose,Less]//Flatten;
    
    BlaBlaDiagramm[xy,text,r,mask1,mask2,text1,text2,fontsize,opts]
    ]
          
         


(* ::Input::Plain:: *)
RESAMPLING=True;
FDIGITS=Round[-Log[10,$MachineEpsilon]];
TYP=1;
YMAX=1000.;
ANALGRAD=False;
FACTOR=1.0;
MAXSTEP=0.1;
CSEED=-999;
SCALING=1;
STEPREDUCE=4;
FISHER=False;
PRINT={1,1,1,1,1,1,1,1};


(* ::Input::Plain:: *)
Unprotect[Lik]; 
Clear[Lik]; 
Lik[data_, Theta_, {system_, LikN_}, misc_] := 
   Plus @@ (LikN[#1, Theta*SCALING, system, misc] & ) /@ data; 
Protect[Lik]; 


(* ::Input::Plain:: *)
Unprotect[Lik1]; 
Clear[Lik1]; 
Lik1[data_, Theta_, {system_, LikN_}, misc_] := 
   Sum[LikN[data[[i]], Theta*SCALING, system, misc], 
    {i, 1, Length[data]}]; 
Protect[Lik1]; 


(* ::Input::Plain:: *)
Clear[Score]; 
Score[data_, Theta_, {system_, {Lik_, LikN_}}, misc_] := 
   Module[{INC, i, LIK, LIKI, INC1, SNUM, ETA}, 
    LIK = Lik[data, Theta, {system, LikN}, misc]; 
     ETA = Max[$MachineEpsilon, 10.^(-FDIGITS)]; 
     INC = Sqrt[ETA]*max[Abs[Theta], Abs[TYP]]; INC1 = 1./INC; 
     SNUM = {}; u = Length[Theta]; Do[Thetai = GRIDI[Theta, i, INC]; 
       LIKI = Lik[data, Thetai, {system, LikN}, misc]; 
       SNUM = Append[SNUM, N[(LIKI - LIK)*INC1[[i]]]], {i, u}]; 
     {SNUM, LIK}]; 


(* ::Input::Plain:: *)
Clear[Score2]; 
Score2[data_, Theta_, {system_, {Lik_, LikN_}}, misc_] := 
   Module[{INC, i, LIK, LIKup, LIKdo, INC1, SNUM, ETA}, 
    LIK = Lik[data, Theta, {system, LikN}, misc]; 
     ETA = Max[$MachineEpsilon, 10.^(-FDIGITS)]; 
     INC = ETA^(1/3)*max[Abs[Theta], Abs[TYP]]; 
     Print["Score2: INC: ", INC]; INC1 = 1/(2*INC); SNUM = {}; 
     Do[LIKup = Lik[data, GRIDI[Theta, i, INC], {system, LikN}, 
         misc]; LIKdo = Lik[data, GRIDI[Theta, i, -INC], 
         {system, LikN}, misc]; SNUM = Append[SNUM, 
         (LIKup - LIKdo)*INC1[[i]]], {i, Length[Theta]}]; 
     {SNUM, LIK}]; 


(* ::Input::Plain:: *)
Hesse2[data_, Theta_, {system_, {Lik_, LikN_, Score_}}, misc_] := 
   Module[{INC, i, LIK, INC1, Sup, Sdo, DS, S, HNUM, SNUM, ETA}, 
    {S, LIK} = Score[data, Theta, {system, {Lik, LikN}}, misc]; 
     ETA = Max[$MachineEpsilon, 10.^(-FDIGITS)]; INC = ETA^(1/3); 
     INC = INC*max[Abs[Theta], Abs[TYP]]; INC1 = 1/(2*INC); 
     HNUM = {}; SNUM = {}; 
     Do[{Sup, likup} = Score[data, GRIDI[Theta, i, INC], 
         {system, {Lik, LikN}}, misc]; {Sdo, likdo} = 
        Score[data, GRIDI[Theta, i, -INC], {system, {Lik, LikN}}, 
         misc]; HNUM = Append[HNUM, (Sup - Sdo)*INC1[[i]]]; 
       SNUM = Append[SNUM, (likup - likdo)*INC1[[i]]], 
      {i, Length[Theta]}]; HNUM = 0.5*(HNUM + Transpose[HNUM]); 
     DS = S - SNUM; Print[
      "KONTROLLE: NUMERISCHER SCORE - ZENTRALE DIFFERENZEN"]; 
     Print[MatrixForm[Transpose[{SNUM, S, DS, Theta, INC}], 
       TableHeadings -> {Automatic, {"SNUM", "S", "DS", "THETA", 
          "INC"}}]]; {HNUM, LIK}]; 


(* ::Input::Plain:: *)
Hesse[data_, Theta_, {system_, {Lik_, LikN_, Score_}}, misc_] := 
   Module[{LIK, L2, INK, INK2, H4, H, LIJ, LIMJ, LIJM, LIMJM, L2I, 
     LM2I, i, J, ETA}, LIK = Lik[data, Theta, {system, LikN}, misc]; 
     ETA = Max[$MachineEpsilon, 10.^(-FDIGITS)]; INC = ETA^(1/3); 
     INK = INC*max[Abs[Theta], Abs[TYP]]; Print["INK: ", INK]; 
     U = Length[Theta]; INK2 = 2*INK; 
     H4 = 0.25/Outer[Times, INK, INK]; L2 = 2*LIK; 
     H = Shape[0, {U, U}]; Do[{LIJ, LIMJ, LIJM, LIMJM} = 
        (Lik[data, #1, {system, LikN}, misc] & ) /@ 
         {GRIDIJ[Theta, i, J, INK, INK], GRIDIJ[Theta, i, J, INK, 
           -INK], GRIDIJ[Theta, i, J, -INK, INK], GRIDIJ[Theta, i, 
           J, -INK, -INK]}; H[[i,J]] = LIJ - LIMJ - LIJM + LIMJM; , 
      {i, 1, U}, {J, i + 1, U}]; H = H + Transpose[H]; 
     Do[{L2I, LM2I} = (Lik[data, #1, {system, LikN}, misc] & ) /@ 
         {GRIDI[Theta, i, INK2], GRIDI[Theta, i, -INK2]}; 
       H[[i,i]] = L2I - L2 + LM2I; , {i, 1, U}]; H = H*H4; 
     {H, LIK}]; 


(* ::Input::Plain:: *)
Clear[BFGSUP]; 
BFGSUP[F_, SNEU_, S_, STEP_] := Module[{MACHEPS2, Y, FSTEP, A, B, 
     Fup, ETA}, ETA = Max[$MachineEpsilon, 10.^(-FDIGITS)]; 
     TOL = If[ANALGRAD, ETA, ETA^0.5, ETA^0.5]; 
     NOISE = (Max[Abs[SNEU]] + Max[Abs[S]])*TOL; 
     MACHEPS2 = $MachineEpsilon^0.5; Y = -SNEU + S; 
     FSTEP = F . STEP; A = Y . STEP; 
     If[A < MACHEPS2*Max[Abs[STEP]]*Max[Abs[Y]], Return[F]]; 
     If[Max[Abs[Y - FSTEP]] < NOISE, Return[F]]; A = 1/A; 
     B = 1/STEP . FSTEP; 
     (*Print["*BFGSUP ", A, "  ", B];*)
     Fup = F + Outer[Times, A*Y, Y] - Outer[Times, B*FSTEP, FSTEP]; 
     Fup]; 


(* ::Input::Plain:: *)
LikTest[LIKNEU_] := If[ !NumberQ[LIKNEU] || Im[LIKNEU] =!= 0 || 
     LIKNEU > 10.^10, Print["LIKNEU = ", LIKNEU, 
      " reset to -10.^10"]; -10.^10, LIKNEU]; 


(* ::Input::Plain:: *)
Clear[BFGS]; 
BFGS[data_, {THETA0_, F0_}, {system_, {Lik_, LikN_, Score_, Hesse_}}, 
     {misc_, KMAX_, {EPS1_, EPS2_}, OPTION_, PRINT_}] :=
      
   Module[{MINSTEP, BOUND, ALPHA, u, THETA, THETA1, F, S, LIKALT, 
     LIKI, psii, scoreii, STEPL, STEP, LIKNEU, SNEU, likpsi, COV, 
     LIKELI, n, T, T1, Tc, P, Q, k, K, KK, Z, Y, X, ReturnCode}, 
     MINSTEP = 1/10.^10; FMAX = 10^3; BOUND = 1/10.^6; 
     ALPHA = 1/10.^4; 
     
     (*
     T = data[[1,2]]//Length;
     n = data[[1,3]];
     *)
      
     If[PRINT[[1]] == 1, 
       Print["***********************LSDE1**********************************"]; 
       Print["***********************MODUL:    BFGS (skeleton)**************"]; 
       Print["**************************************************************"]; 
       Print["Technical Output"]; Print[LikN]; 
       Print["**************************************************************"]; 
       VecPrint[Spalte[{KMAX, EPS1, EPS2, K, Q, n, T, OPTION}], 
                      {"KMAX", "EPS1", "EPS2", "K", "Q", "n", "T", "OPTION    "}]; 
       Print[""];
       VecPrint[Spalte[{MAXSTEP, MINSTEP, BOUND,STEPREDUCE, FMAX}], {"MAXSTEP", "MINSTEP", "BOUND", 
         "STEPREDUCE", "FMAX"}]; Print[""]; 
       VecPrint[Spalte[{RESAMPLING, FDIGITS, TYP, YMAX, ANALGRAD, 
          FACTOR, CSEED}], {"RESAMPLING", "FDIGITS", "TYP", "YMAX", 
         "ANALGRAD", "FACTOR", "CSEED"}]; Print[""]; 
       Print["    SCALING"]; Print[MatrixForm[
         Transpose[Spalte[SCALING]], TableHeadings -> 
          {Automatic, {"SCALING"}}, TableDepth -> 0]]; Print[""]; 
       Print["**************************************************************"]; 
       Print[""]; 
       Print["STARTWERT THETA0 = ", THETA0]]; 
     
     u = Length[THETA0]; 
     THETA = THETA0; 
     
     F = F0; 
     If[OPTION == 1, F = SHIFT[F, BOUND]]; 
     {S, LIKALT} = Score[data, THETA0, {system, {Lik, LikN}}, misc]; 
     Print[{S, LIKALT}]; LIKI = {}; psii = {}; scoreii = {}; 
     ReturnCode = 0; k = 0; 
     
     DoUntil[{KK, KMAX}, ReturnCode == 3, 
      If[PRINT[[2]] == 1, 
      Print["-----------------------------------------------------------------"]; 
      Print["BFGS: Iteration = ", KK]; ]; LIKI = Append[LIKI, LIKALT]; 
       psii = Append[psii, THETA]; scoreii = Append[scoreii, S]; 
       STEP = LinearSolve[F, S]; STEPL = Max[Abs[STEP]]; 
       STEP = STEP*Min[1, MAXSTEP/STEPL]; THETA1 = THETA + STEP; 
       
       LIKNEU = Lik[data, THETA1, {system, LikN}, misc]; 
       LIKNEU = LikTest[LIKNEU]; 
       
       DoWhile[{half, 100}, LIKNEU < LIKALT + ALPHA*S . STEP && Max[Abs[STEP]] > MINSTEP, 
       
         STEP = STEP/STEPREDUCE; THETA1 = THETA + STEP; 
         LIKNEU = Lik[data, THETA1, {system, LikN}, misc]; 
         LIKNEU = LikTest[LIKNEU]; If[PRINT[[3]] == 1, 
          Print["STEP-REDUCTION:  ", half, "  LIKNEU  ", 
            PaddedForm[LIKNEU, {20, 15}], "  LIKALT  ", 
            PaddedForm[LIKALT, {20, 15}]]; ]; ]; 
         If[LIKNEU - LIKALT < 0, Print["ReturnCode = 4"]; 
         ReturnCode = 4; Break[]
         
         ]; 
         
         If[PRINT[[4]] == 1, 
            Print["LIKNEU  ", PaddedForm[LIKNEU, {20, 15}]]; 
            Print["LIKALT  ", PaddedForm[LIKALT, {20, 15}]]; 
            Print["LIKNEU - LIKALT  ", PaddedForm[LIKNEU - LIKALT, {20, 15}]]; Print[""]; ]; 
           
         If[PRINT[[5]] == 1, 
            Print[PaddedForm[TableForm[(Chop[#1, 1/10^5] & )[
            Transpose[{THETA1, THETA, STEP, S}]], TableHeadings -> 
            {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
            TableDirections -> {Column, Row}, TableSpacing -> 
            {1, 2}], {5, 4}]]]; 
            
         If[PRINT[[6]] == 1, Print["F"]; Print[MatrixForm[F]]; ]; 
        
        {SNEU, LIKALT} = 
        Score[data, THETA1, {system, {Lik, LikN}}, misc]; 
        F = BFGSUP[F, SNEU, S, STEP]; S = SNEU; 
        THETA = THETA1GLOBAL = THETA1; k = KK; 
        relgrad = Max[Abs[S*max[Abs[THETA], TYP]]]/Abs[LIKNEU]; 
        Print["relgrad = ", relgrad, " = Elastizitaet(d l/l)/(d theta/theta)"]; 
        
        If[Max[Abs[S]] < EPS1, Print["ReturnCode = 1"]; ReturnCode = 1]; 
        If[Max[Abs[STEP]] < EPS2, Print["ReturnCode = 2"]; ReturnCode = 2]; 
        
        If[Max[Abs[S]] < EPS1 && Max[Abs[STEP]] < EPS2, Print["ReturnCode = 3"]; ReturnCode = 3]
        
        ]; 
        
      If[PRINT[[7]] == 1, Print["BFGS:  ENDE DER ITERATION  ", k, "  ", KMAX]]; 
       
      If[PRINT[[5]] == 1, 
      Print[TableForm[Transpose[{SNEU}], TableHeadings -> 
         {Automatic, {"SCORE"}}, TableDirections -> {Column, Row}, 
         TableSpacing -> {1, 2}]]]; 
        
      If[PRINT[[6]] == 1, 
         Print["F"]; Print[MatrixForm[F]]; ]; 
         LIKI = Append[LIKI, LIKALT]; psii = Append[psii, THETA]; 
         scoreii = Append[scoreii, S]; likpsi = ii[Spalte[LIKI], psii]; 
         
     If[PRINT[[8]] == 1, Print[TableForm[likpsi, 
        TableHeadings -> {Automatic, {"Likelihood", "THETA"}}, 
        TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]];
         
     If[FISHER && k < KMAX, 
          {F, LIKELI} = Hesse[data, THETA, {system, {Lik, LikN, Score}}, misc];
          F = -F; 
          COV = OUTPUT[THETA, F, 0.05, S, LIKELI]; 
          LKOMP[LIKELI, u, Indeterminate], 
          (*else*)
          COV = Inverse[F]; 
          ]; 
          
     {THETA, COV, LIKI, psii, scoreii, k, ReturnCode}]; 


(* ::Input::Plain:: *)
LKOMP//Clear
LKOMP[LIK_, U_, Nue_] := Module[{EPS, LN, KOMP1, KOMP2, KOMP3}, 
     EPS = 1/10^3; LN = Log[N[Nue]]; KOMP1 = U; KOMP2 = 0.5*U*LN; 
     KOMP3 = 0.5*U*(U + 1)*(1 + EPS)*Log[LN]; 
     Print["--------------------------------------------------------"]; 
     Print["KOMPENSIERTE LIKELIHOOD"]; 
     Print["--------------------------------------------------------"]; 
     Print["U =  ", U, "  Nue = ", Nue]; 
     Print["AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) AZENCOTT/DACUNHA-CASTELLE (A/D)"]; 
     ket = {{0, KOMP1, KOMP2, KOMP3}, {LIK, LIK - KOMP1, LIK - KOMP2, LIK - KOMP3}}; 
     Print[TableForm[ket, TableHeadings -> {{"Kompensator", "komp. Lik."}, 
         {"LIK", "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
       TableSpacing -> {1, 2}]]; ]; 


(* ::Input::Plain:: *)
OUTPUT[THETA_, F_, ALPHA_, SCORE_, LIKELI_] := 
   Module[{COV, EIGF, EIGCOV}, 
    Print[
      "--------------------------------------------------------"]; 
     Print["ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD"]; 
     Print["--------------------------------------------------------\
"]; Print[(MatrixForm[#1, TableHeadings -> {Automatic, 
           {"THETA", "SCORE"}}] & )[Transpose[{THETA, SCORE}]], 
      "   Likelihood = ", N[LIKELI, 25]]; 
     COV = SIGNI[THETA, F, ALPHA]; EIGF = Eigenvalues[F]; 
     EIGCOV = 1/EIGF; 
     Print["--------------------------------------------------------\
"]; Print["GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND EIGENWERTE"]; 
     Print["--------------------------------------------------------\
"]; Print[MatrixForm[Chop[N[COV, 5]]]]; Print[""]; 
     Print[N[EIGCOV, 5]]; 
     Print["--------------------------------------------------------\
"]; Print["GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX UND EIGENWERTE"]; 
     Print[
      "--------------------------------------------------------"]; 
     Print[MatrixForm[Chop[N[F, 5]]]]; Print[""]; Print[N[EIGF, 5]]; 
     COV]; 


(* ::Input::Plain:: *)
SIGNI[THETA_, F_, ALPHA_] := Module[{U, CHI, PROB, Z, COV, AU2, DCOV, STD, STD1, 
     CORR, GRENZE}, U = Length[THETA]; CHI = N[THETA . F . THETA]; 
     If[CHI >= 0, PROB = 1 - CDF[ChiSquareDistribution[U], CHI]; 
       Print["------------------------------------------------------"]; 
       Print["WALD-TEST:"]; 
       Print["------------------------------------------------------"]; 
       VecPrint[Spalte[{CHI, U, Chop[PROB], ALPHA}], {"CHI ", "U ", "PROB ", 
         "ALPHA "}]; If[PROB < ALPHA, 
        Print["NULLHYPOTHESE THETA = 0 ABLEHNEN"]]; , 
      Print["F NICHT POSITIV DEFINIT"]; ]; COV = PseudoInverse[F]; 
     AU2 = ALPHA/(2*U); Z = Quantile[NormalDistribution[0, 1], 1 - AU2]; 
     DCOV = Transpose[COV, {1, 1}]; If[all[gr[DCOV, 0]], 
      STD = Sqrt[DCOV]; STD1 = 1/STD; CORR = DiagonalMatrix[STD1] . COV . 
         DiagonalMatrix[STD1]; GRENZE = Z*STD; 
       Print["------------------------------------------------------"]; 
       Print["BONFERRONI-KONFIDENZINTERVALLE:"]; 
       Print["------------------------------------------------------"]; 
       Print["P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= 1-ALPHA"]; 
       Print["QUANTIL Z(1-ALPHA/2U) = ", N[Z]]; 
       VecPrint[N[{THETA, GRENZE, STD}], {"THETA", "GRENZE", "STD"}]; 
       Print["-------------------------------------------------------"]; 
       Print["Korrelation der ML-Sch\[ADoubleDot]tzer"]; 
       Print["-------------------------------------------------------"]; 
       Print[MatrixForm[Chop[N[CORR, 2]]]]; , 
      Print["Warnung: Negative Diagonalelemente der Kovarianzmatrix"]; ]; 
     Return[COV]; ]; 



