(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     68560,       1616]
NotebookOptionsPosition[     66166,       1536]
NotebookOutlinePosition[     66762,       1560]
CellTagsIndexPosition[     66676,       1555]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{"B", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", "\"\<bla\>\"", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"B", "=", 
  RowBox[{"SparseArray", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}], "\[Rule]", "\"\<bla\>\""}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "3"}], "}"}], "\[Rule]", "1"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", "1"}], "}"}], "\[Rule]", "1"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", "3"}], "}"}], "\[Rule]", "1"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "0"}]}], "}"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"B", "//", "MatrixForm"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "\<\"bla\"\>", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "}"}]], "Output"],

Cell[BoxData[
 TagBox[
  RowBox[{"SparseArray", "[", 
   RowBox[{
    InterpretationBox[
     RowBox[{"\<\"<\"\>", "\[InvisibleSpace]", "4", 
      "\[InvisibleSpace]", "\<\">\"\>"}],
     SequenceForm["<", 4, ">"],
     Editable->False], ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", "3"}], "}"}]}], "]"}],
  False,
  Editable->False]], "Output"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "0", "\<\"bla\"\>", "1"},
      {"2", "1", "0", "1"},
      {"3", "0", "0", "0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[
   SparseArray[
    Automatic, {3, 3}, 0, {
     1, {{0, 2, 4, 4}, {{2}, {3}, {1}, {3}}}, {"bla", 1, 1, 1}}]]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", "Text"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  StyleBox["\<\"\\!\\(\\*RowBox[{\\\"Text\\\", \\\"[\\\", StyleBox[\\\"expr\\\
\", \\\"TI\\\"], \\\"]\\\"}]\\) displays with \\!\\(\\*StyleBox[\\\"expr\\\", \
\\\"TI\\\"]\\) in plain text format. \\n\\!\\(\\*RowBox[{\\\"Text\\\", \
\\\"[\\\", RowBox[{StyleBox[\\\"expr\\\", \\\"TI\\\"], \\\",\\\", StyleBox[\\\
\"coords\\\", \\\"TI\\\"]}], \\\"]\\\"}]\\) is a graphics primitive that \
displays the textual form of \\!\\(\\*StyleBox[\\\"expr\\\", \\\"TI\\\"]\\) \
centered at the point specified by \\!\\(\\*StyleBox[\\\"coords\\\", \\\"TI\\\
\"]\\). \"\>", "MSG"], "\[NonBreakingSpace]", 
  ButtonBox[
   StyleBox["\[RightSkeleton]", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:ref/Text"]}]], "Print", "PrintUsage",
 CellTags->"Info3477913177-4863673"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "Text", "]"}], "=", 
      RowBox[{"{", 
       RowBox[{"Protected", ",", "ReadProtected"}], "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"Options", "[", "Text", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Background", "\[Rule]", "None"}], ",", 
           RowBox[{"ContentSelectable", "\[Rule]", "Automatic"}], ",", 
           RowBox[{"FormatType", "\[RuleDelayed]", "Automatic"}]}], "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[Text],
  Editable->False]], "Print",
 CellTags->"Info3477913177-4863673"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"vrf1", "=", 
   RowBox[{
    RowBox[{"Sphere", "[", 
     RowBox[{"#", ",", "0.05"}], "]"}], "&"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vrf1", "=", 
   RowBox[{
    RowBox[{"Cylinder", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"#", ",", 
        RowBox[{"#", "+", ".1"}]}], "}"}], ",", "0.05"}], "]"}], "&"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vrf1", "=", 
   RowBox[{
    RowBox[{"Cuboid", "[", 
     RowBox[{
      RowBox[{"#", "-", ".1"}], ",", 
      RowBox[{"#", "+", ".1"}]}], "]"}], "&"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vrf2", "=", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"#2", "===", "\"\<bla\>\""}], ",", "\[IndentingNewLine]", 
       "                 ", 
       RowBox[{"(", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"GrayLevel", "[", ".9", "]"}], ",", 
          RowBox[{"EdgeForm", "[", "Black", "]"}], ",", 
          RowBox[{"Rectangle", "[", 
           RowBox[{
            RowBox[{"#", "-", ".1"}], ",", 
            RowBox[{"#", "+", ".1"}]}], "]"}], ",", "Blue", ",", 
          RowBox[{"Text", "[", 
           RowBox[{"#2", ",", "#1"}], "]"}]}], "}"}], ")"}], ",", 
       "\[IndentingNewLine]", "                 ", 
       RowBox[{"(", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"GrayLevel", "[", ".9", "]"}], ",", 
          RowBox[{"EdgeForm", "[", "Black", "]"}], ",", 
          RowBox[{"Disk", "[", 
           RowBox[{"#", ",", ".1"}], "]"}], ",", "Green", ",", 
          RowBox[{"Text", "[", 
           RowBox[{"#2", ",", "#1"}], "]"}]}], "}"}], ")"}]}], "]"}], "&"}]}],
    ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"vrf2", "=", "Automatic"}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"edge", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\"\<bla\>\"", "\[Rule]", "\"\<bla bla\>\""}], ",", 
     RowBox[{"\"\<bla bla\>\"", "\[Rule]", "\"\<bla\>\""}], ",", 
     RowBox[{"\"\<bla bla\>\"", "\[Rule]", "\"\<bla bla\>\""}]}], "}"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"GraphPlot3D", "[", 
  RowBox[{"edge", ",", 
   RowBox[{"VertexLabeling", "\[Rule]", "All"}], ",", 
   RowBox[{"VertexRenderingFunction", "\[Rule]", "vrf1"}], ",", 
   RowBox[{"EdgeRenderingFunction", "\[Rule]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Red", ",", 
        RowBox[{"Arrow", "[", 
         RowBox[{"#1", ",", "0.1"}], "]"}]}], "}"}], "&"}], ")"}]}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"GraphPlot", "[", 
  RowBox[{"edge", ",", 
   RowBox[{"VertexLabeling", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"VertexRenderingFunction", "\[Rule]", "vrf2"}], ",", 
   RowBox[{"EdgeRenderingFunction", "\[Rule]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Red", ",", 
        RowBox[{"Arrow", "[", 
         RowBox[{"#1", ",", "0.1"}], "]"}]}], "}"}], "&"}], ")"}]}]}], 
  "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\<\"bla\"\>", "\[Rule]", "\<\"bla bla\"\>"}], ",", 
   RowBox[{"\<\"bla bla\"\>", "\[Rule]", "\<\"bla\"\>"}], ",", 
   RowBox[{"\<\"bla bla\"\>", "\[Rule]", "\<\"bla bla\"\>"}]}], 
  "}"}]], "Output"],

Cell[BoxData[
 Graphics3DBox[
  TagBox[{{
     {RGBColor[1, 0, 0], Arrow3DBox[CompressedData["
1:eJxTTMoPSmViYGAQAmJmBhj4YM+ABiapVVuFb3ljzzD1t7Zb7Kz9MHFZtwUF
5Rdf2xfkPGt6V7YALl5qMfvkkzev7BM+iTFutl8MF78d2fPuGdsrewF2eynB
jqVw8T9NRb+Oyr+0L/CPnRnovxwuPuVJf/Ip8xf2Dk36R55OWQEXD3Xb9MTG
/7l9w+KP7ekRK+HiWSdS09LSntk/iImbOXMmQtz1u6GxsfFle4dEfhTxnYwz
zdoSL9on5E1HMUdjw+7Cawrn7Q3ETx1Gttev1FDsRcNp+4Ktb2Ygu3Ne4SnX
lCfH7Rd4HJZE9teT9P6bOT5H7CfITmBADoctu6ptlXYdsH8wKQQl3C5sVdRx
i91lz8B0SAs5nGEg+dgRk0XrbtjC+ACtTInv
       "], 0.1]}, 
     {RGBColor[1, 0, 0], Arrow3DBox[CompressedData["
1:eJxTTMoPSmViYGAQAmJmBgRIPnbEZNG6G7YwfsFpNR232F32DvVtum6xs+xh
4j3P62yVdh2wn/BwdfO7sgVwcT25yTdzfI7YN6TfYdxsvxguPm3GOdeUJ8ft
DWpYpAU7lsLFBb+Yir1oOG0/4YjSrED/5XDxTbkHCq8pnLdP+P7lyNMpK+Di
kcWzzdoSL9ovkNjekR6xEi6um29ibGx82Z7hkvKsmTMR4vEs6Wlpac/sE65d
mYksrlK/+YmN/3P7hscxKOb8EJ6YfMr8hX1ATz+KvesWFf86Kv/SfoLWppnI
7pyV3PvuGdsr+wN7O6SQ/cWhNufkkzev7DdMCkUJh1DBhQXlF1/bM3BIoYSb
x8lqq/Atb+wd3vjoIIczBHxA4zMwAAAg0YGa
       "], 0.1]}, 
     {RGBColor[1, 0, 0], Arrow3DBox[CompressedData["
1:eJxTTMoPSmViYGCQBGJmBgRIPnbEZNG6G7ZwgRPP37RpC+wv5pDRCRYt2A8T
Flib3Oj6sm3/67/v6+Y+3wQXL5GyP19mvXT/s94Gr1tLDsLFuWatmzJ52bb9
ebpPnWdkn4CLn2pgT/dkOLx/ro2P+2Obs3DxE2pCnPY7Tu8/FB904NzW83Dx
RyfSNgimXNrv2hRpM20xQjzCsevAh13X9t/1Fn64nh1hjtnCtZ8Wtt/a7/tk
R+Y6cYS9n7ZPfC5fc3f/G1V94a8WCHf2RNXt2hN9f/9UhewM7Y8b4eIQ8GD/
TEPD3h9Nj+Dhc/NJFVh9VOjETKB6e5j4DOFusPl5MftB5sPFZ4UtAbvnQrdL
FtA9cHFH/nqw+x+IzQS5Hy5uNjUK7N+5s2+A/AsXT9n4kwMUPnuqT4HCBy4+
9fOHNFB48szfCwpPuLjSuw5w+FstCXABhj9c/MgqDnB8dSc8B8UXXPwD6/sG
UPzmrNheD4xfuDjDhbMvQemhsLvYApgeEOJQgJ5+AFSQ0is=
       "], 0.1]}}, {
     CuboidBox[{0.9, -0.1, -0.1}, {1.1, 0.1, 0.1}], 
     CuboidBox[{-0.1, -0.09999999991020682, -0.1}, {0.1, 0.10000000008979319`,
       0.1}]}},
   Annotation[#, 
    VertexCoordinateRules -> {{1., 0., 0.}, {0., 8.979318433952318*^-11, 
     0.}}]& ],
  AspectRatio->Automatic,
  PlotRange->All,
  PlotRangePadding->Scaled[0.1]]], "Output"],

Cell[BoxData[
 GraphicsBox[
  TagBox[{{
     {RGBColor[1, 0, 0], 
      ArrowBox[{{1., 0.}, {0.8970142500122213, -0.025746437487119245`}, {
       0.8693196487167288, -0.03215737674619212}, {
       0.8414176881431233, -0.037595361598026455`}, {
       0.8133425387521201, -0.04205373235119059}, {
       0.7851285831021353, -0.045527029010059006`}, {
       0.7568103737422853, -0.048010997961459356`}, {
       0.7284225908972056, -0.049502597183908925`}, {
       0.6999999999955098, -0.04999999997306204}, {
       0.29999999999551036`, -0.04999999993714477}, {
       0.2715774090939039, -0.049502597142887295`}, {
       0.24318962624909202`, -0.04801099791533969}, {
       0.21487141688968808`, -0.045527028958853744`}, {
       0.18665746124032706`, -0.04205373229491838}, {
       0.1585823118501245, -0.03759536153671228}, {
       0.13068035127749555`, -0.03215737667986729}, {
       0.10298574998315435`, -0.025746437415820722`}, {0., 
       8.979318433952318*^-11}}, 0.1]}, 
     {RGBColor[1, 0, 0], 
      ArrowBox[{{0., 8.979318433952318*^-11}, {0.10298574998777865`, 
       0.02574643757691253}, {0.13068035128327116`, 0.03215737683598541}, {
       0.1585823118568767, 0.03759536168781974}, {0.1866574612478799, 
       0.04205373244098387}, {0.21487141689786474`, 0.04552702909985229}, {
       0.24318962625771473`, 0.04801099805125264}, {0.27157740910279454`, 
       0.04950259727370221}, {0.3000000000044903, 0.05000000006285532}, {
       0.7000000000044898, 0.05000000002693805}, {0.7284225909060962, 
       0.04950259723268058}, {0.7568103737509082, 0.04801099800513298}, {
       0.7851285831103121, 0.04552702904864703}, {0.8133425387596731, 
       0.04205373238471166}, {0.8414176881498756, 0.03759536162650556}, {
       0.8693196487225047, 0.03215737676966057}, {0.8970142500168459, 
       0.025746437505614006`}, {1., 0.}}, 0.1]}, 
     {RGBColor[1, 0, 0], ArrowBox[CompressedData["
1:eJxTTMoPSmViYGCQBGIQDQPJx46YLFp3w5bhxPM3bdoC+4s5ZHSCRQv2C6xN
bnR92bb/9d/3dXOfb9pfImV/vsx66f5nvQ1et5Yc3M81a92Uycu27c/Tfeo8
I/vE/lMN7OmeDIf3z7XxcX9sc3b/CTUhTvsdp/cfig86cG7r+f2PTqRtEEy5
tN+1KdJm2uLz+yMcuw582HVt/11v4Yfr2c/uN1u49tPC9lv7fZ/syFwnfmL/
p+0Tn8vX3N3/RlVf+KvFwf09UXW79kTf3z9VITtD++PG/RDXP9g/09Cw90fT
I9ubT6rA8lGhEzOB8vYzhLvB+vNi9oP0288KWwI2/0K3SxbQfHtH/nqw/Q/E
ZoLstzebGgV239zZN0Dus0/Z+JMD5P491adA7ref+vlDGsh/PPP3gvxnr/Su
A+x/qyUBLkD/2x9ZxQEOn+6E56Dwsf/A+r4BFH45K7bXA8PPnuHC2Zeg8C3s
LrYAhq89evgDACEK0io=
       "], 0.1]}}, {
     {GrayLevel[0.9], EdgeForm[GrayLevel[0]], 
      RectangleBox[{0.9, -0.1}, {1.1, 0.1}], 
      {RGBColor[0, 0, 1], InsetBox["\<\"bla\"\>", {1., 0.}]}}, 
     {GrayLevel[0.9], EdgeForm[GrayLevel[0]], 
      DiskBox[{0., 8.979318433952318*^-11}, 0.1], 
      {RGBColor[0, 1, 0], 
       InsetBox["\<\"bla bla\"\>", {0., 8.979318433952318*^-11}]}}}},
   Annotation[#, 
    VertexCoordinateRules -> {{1., 0.}, {0., 8.979318433952318*^-11}}]& ],
  AspectRatio->Automatic,
  FrameTicks->None,
  ImageSize->{477., Automatic},
  PlotRange->All,
  PlotRangePadding->Scaled[0.1]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"B", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "\"\<bla\>\"", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"B", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"Lambda", "=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}], "//", 
   "Transpose"}]}], "\[IndentingNewLine]", 
 RowBox[{"Lambda", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"BL", "=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"B", "//", "Transpose"}], ",", "Lambda", ",", "2"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"BL", "//", "MatrixForm"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "\<\"bla\"\>", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "}"}]], "Output"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "1", "\<\"bla\"\>", "1"},
      {"2", "1", "0", "1"},
      {"3", "0", "0", "0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}]}], "}"}]], "Output"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2"},
      {"1", "1", "0"},
      {"2", "1", "0"},
      {"3", "0", "1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"bla\"\>", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}]}], 
  "}"}]], "Output"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4", "5"},
      {"1", "1", "1", "0", "1", "0"},
      {"2", "\<\"bla\"\>", "0", "0", "1", "0"},
      {"3", "1", "1", "0", "0", "1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"vertex", "=", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"4", ",", "5"}], "}"}], ",", "#2"}], "]"}], ",", 
       "\[IndentingNewLine]", "                 ", 
       RowBox[{"(", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"GrayLevel", "[", ".9", "]"}], ",", 
          RowBox[{"EdgeForm", "[", "Black", "]"}], ",", 
          RowBox[{"Rectangle", "[", 
           RowBox[{
            RowBox[{"#", "-", ".07"}], ",", 
            RowBox[{"#", "+", ".07"}]}], "]"}], ",", "Blue", ",", 
          RowBox[{"Text", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{"#2", ",", "Italic", ",", "12", ",", 
              RowBox[{"FontFamily", "\[Rule]", "\"\<Helvetica\>\""}]}], "]"}],
             ",", "#1"}], "]"}]}], "}"}], ")"}], ",", "\[IndentingNewLine]", 
       "                 ", 
       RowBox[{"(", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"GrayLevel", "[", ".9", "]"}], ",", 
          RowBox[{"EdgeForm", "[", "Black", "]"}], ",", 
          RowBox[{"Disk", "[", 
           RowBox[{"#", ",", ".1"}], "]"}], ",", "Red", ",", 
          RowBox[{"Text", "[", 
           RowBox[{"#2", ",", "#1"}], "]"}]}], "}"}], ")"}]}], "]"}], "&"}]}],
    ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"edge", "=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Green", ",", 
       RowBox[{"Arrowheads", "[", ".02", "]"}], ",", 
       RowBox[{"Arrow", "[", 
        RowBox[{"#1", ",", "0.1"}], "]"}]}], "}"}], "&"}], ")"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"GraphPlot", "[", 
   RowBox[{"BL", ",", 
    RowBox[{"VertexLabeling", "\[Rule]", "All"}], ",", 
    RowBox[{"VertexRenderingFunction", "\[Rule]", "vertex"}], ",", 
    "\[IndentingNewLine]", "                                   ", 
    RowBox[{"EdgeRenderingFunction", "\[Rule]", "edge"}], ",", 
    RowBox[{"Frame", "\[Rule]", "False"}], ",", 
    RowBox[{"SelfLoopStyle", "\[Rule]", "All"}], ",", 
    RowBox[{"Method", "\[Rule]", "Automatic"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"GraphPlot", "[", 
  RowBox[{"BL", ",", 
   RowBox[{"VertexLabeling", "\[Rule]", "All"}], ",", 
   RowBox[{"VertexRenderingFunction", "\[Rule]", "Automatic"}], ",", 
   "\[IndentingNewLine]", "                                 ", 
   RowBox[{"EdgeRenderingFunction", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"DirectedEdges", "\[Rule]", "True"}], ",", 
   RowBox[{"Frame", "\[Rule]", "False"}], ",", 
   RowBox[{"SelfLoopStyle", "\[Rule]", "All"}], ","}], "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"Green", ",", 
    RowBox[{"Arrowheads", "[", "0.02`", "]"}], ",", 
    RowBox[{"Arrow", "[", 
     RowBox[{"#1", ",", "0.1`"}], "]"}]}], "}"}], "&"}]], "Output"],

Cell[BoxData[
 GraphicsBox[
  TagBox[{{
     {RGBColor[0, 1, 0], Arrowheads[0.02], ArrowBox[CompressedData["
1:eJwBoQFe/iFib1JlAgAAABkAAAACAAAA/pAATNJg7D8ArSUAUubnP862tB+v
Qew/iDgBXSXm5z9HlNUgiBXqPwAlSByHMug/lMJvTxkV6D/ga0EyxRfpPwbv
dwZ9aeY/kEMkVHyD6j9hPTDg/zTlPwVHUu9/WOw/dxNDaGCQ5D+Xz905MXHu
P+f9egHTiOQ/0qAg2UFR8D8I04fA8h7lP/9b2Yu4X/E/hEOM+7RG5j/zucT5
Sk7yPxOl4Y1g6Oc/ESKVRdYJ8z/xXrX6dOLpP/JR22FPg/M//xqcW1oM7D8D
2vn297DzP0AWCO2iOe4/ytpAdiaP8z+ywzmuzR7wP6f+1k2RIPM/B61uVXD3
8D/0xDY1F27yP8eV0gFZlfE/WIkGCgmG8T9JC4ou3evxP9+fUtkDe/A/hotv
Ugz08T+UPedS5cTuP0PlqV8+rfE/56j/Wa2l7D+kw4M+IR3xP/3naEvyw+o/
jGm4LkRP8D+uE90QWEbpP57eytNUqO4/O1eqiHpL6D+/u3Ai8H/sP/RWFf94
5+c//pAATNJg7D8ArSUAUubnP9O9z6s=
       "], 0.1]}, 
     {RGBColor[0, 1, 0], Arrowheads[0.02], 
      ArrowBox[{{0.8868190273683749, 0.7468652727961}, {0.8870225699565244, 
       0.}}, 0.1]}, 
     {RGBColor[0, 1, 0], Arrowheads[0.02], 
      ArrowBox[{{0.8868190273683749, 0.7468652727961}, {0., 
       0.37329311629595996`}}, 0.1]}, 
     {RGBColor[0, 1, 0], Arrowheads[0.02], 
      ArrowBox[{{0.8870225699565244, 0.}, {0.8868190273683749, 
       0.7468652727961}}, 0.1]}, 
     {RGBColor[0, 1, 0], Arrowheads[0.02], 
      ArrowBox[{{0.8870225699565244, 0.}, {0., 0.37329311629595996`}}, 
       0.1]}, 
     {RGBColor[0, 1, 0], Arrowheads[0.02], 
      ArrowBox[{{1.8907676441581702`, 0.3734691757741897}, {
       0.8868190273683749, 0.7468652727961}}, 0.1]}, 
     {RGBColor[0, 1, 0], Arrowheads[0.02], 
      ArrowBox[{{1.8907676441581702`, 0.3734691757741897}, {
       0.8870225699565244, 0.}}, 0.1]}, 
     {RGBColor[0, 1, 0], Arrowheads[0.02], 
      ArrowBox[{{1.8907676441581702`, 0.3734691757741897}, {
       3.0290604037330926`, 0.37335517099792853`}}, 0.1]}}, {
     {GrayLevel[0.9], EdgeForm[GrayLevel[0]], 
      DiskBox[{0.8868190273683749, 0.7468652727961}, 0.1], 
      {RGBColor[1, 0, 0], 
       InsetBox["1", {0.8868190273683749, 0.7468652727961}]}}, 
     {GrayLevel[0.9], EdgeForm[GrayLevel[0]], 
      DiskBox[{0.8870225699565244, 0.}, 0.1], 
      {RGBColor[1, 0, 0], InsetBox["2", {0.8870225699565244, 0.}]}}, 
     {GrayLevel[0.9], EdgeForm[GrayLevel[0]], 
      DiskBox[{1.8907676441581702`, 0.3734691757741897}, 0.1], 
      {RGBColor[1, 0, 0], 
       InsetBox["3", {1.8907676441581702`, 0.3734691757741897}]}}, 
     {GrayLevel[0.9], EdgeForm[GrayLevel[0]], 
      RectangleBox[{-0.07, 0.30329311629595995`}, \
{0.07, 0.44329311629595997`}], 
      {RGBColor[0, 0, 1], InsetBox[
        StyleBox["4",
         StripOnInput->False,
         FontFamily->"Helvetica",
         FontSize->12,
         FontSlant->Italic], {0., 0.37329311629595996`}]}}, 
     {GrayLevel[0.9], EdgeForm[GrayLevel[0]], 
      RectangleBox[{2.9590604037330928`, 0.3033551709979285}, \
{3.0990604037330924`, 0.44335517099792854`}], 
      {RGBColor[0, 0, 1], InsetBox[
        StyleBox["5",
         StripOnInput->False,
         FontFamily->"Helvetica",
         FontSize->12,
         FontSlant->Italic], {3.0290604037330926`, 0.37335517099792853`}]}}}},
   
   Annotation[#, 
    VertexCoordinateRules -> {{0.8868190273683749, 0.7468652727961}, {
     0.8870225699565244, 0.}, {1.8907676441581702`, 0.3734691757741897}, {0., 
     0.37329311629595996`}, {3.0290604037330926`, 0.37335517099792853`}}]& ],
  AspectRatio->Automatic,
  Frame->False,
  FrameTicks->None,
  ImageSize->{920., Automatic},
  PlotRange->All,
  PlotRangePadding->Scaled[0.1]]], "Output",
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]],

Cell[BoxData[
 GraphicsBox[
  TagBox[GraphicsComplexBox[CompressedData["
1:eJwB0QEu/iFib1JlAgAAABwAAAACAAAA/pAATNJg7D8ArSUAUubnP17eGCh9
Yuw/AAAAAAAAAACu6L+SlUD+P/zoAELr5tc/AAAAAAAAAABiCZTPCOTXPzQj
XQWEOwhAO6FOFg3l1z/OtrQfr0HsP4g4AV0l5uc/R5TVIIgV6j8AJUgchzLo
P5TCb08ZFeg/4GtBMsUX6T8G73cGfWnmP5BDJFR8g+o/YT0w4P805T8FR1Lv
f1jsP3cTQ2hgkOQ/l8/dOTFx7j/n/XoB04jkP9KgINlBUfA/CNOHwPIe5T//
W9mLuF/xP4RDjPu0RuY/87nE+UpO8j8TpeGNYOjnPxEilUXWCfM/8V61+nTi
6T/yUdthT4PzP/8anFtaDOw/A9r59vew8z9AFgjtojnuP8raQHYmj/M/ssM5
rs0e8D+n/tZNkSDzPwetblVw9/A/9MQ2NRdu8j/HldIBWZXxP1iJBgoJhvE/
SQuKLt3r8T/fn1LZA3vwP4aLb1IM9PE/lD3nUuXE7j9D5alfPq3xP+eo/1mt
pew/pMODPiEd8T/952hL8sPqP4xpuC5ET/A/rhPdEFhG6T+e3srTVKjuPztX
qoh6S+g/v7twIvB/7D/0VhX/eOfnP2293qs=
    "], {
     {RGBColor[0.5, 0., 0.], Arrowheads[{{0.02882190977908458, 0.7}}], 
      ArrowBox[{1, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21,
        22, 23, 24, 25, 26, 27, 28, 1}], ArrowBox[{1, 2}], ArrowBox[{1, 4}], 
      ArrowBox[{2, 1}], ArrowBox[{2, 4}], ArrowBox[{3, 1}], ArrowBox[{3, 2}], 
      ArrowBox[{3, 5}]}, {
      TagBox[
       TooltipBox[InsetBox[
         FrameBox["1",
          Background->RGBColor[1, 1, 0.8],
          FrameStyle->RGBColor[0.94, 0.85, 0.36],
          StripOnInput->False], 1],
        "1"],
       Annotation[#, 1, "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox["2",
          Background->RGBColor[1, 1, 0.8],
          FrameStyle->RGBColor[0.94, 0.85, 0.36],
          StripOnInput->False], 2],
        "2"],
       Annotation[#, 2, "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox["3",
          Background->RGBColor[1, 1, 0.8],
          FrameStyle->RGBColor[0.94, 0.85, 0.36],
          StripOnInput->False], 3],
        "3"],
       Annotation[#, 3, "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox["4",
          Background->RGBColor[1, 1, 0.8],
          FrameStyle->RGBColor[0.94, 0.85, 0.36],
          StripOnInput->False], 4],
        "4"],
       Annotation[#, 4, "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox["5",
          Background->RGBColor[1, 1, 0.8],
          FrameStyle->RGBColor[0.94, 0.85, 0.36],
          StripOnInput->False], 5],
        "5"],
       Annotation[#, 5, "Tooltip"]& ]}}],
   Annotation[#, 
    VertexCoordinateRules -> {{0.8868190273683749, 0.7468652727961}, {
     0.8870225699565244, 0.}, {1.8907676441581702`, 0.3734691757741897}, {0., 
     0.37329311629595996`}, {3.0290604037330926`, 0.37335517099792853`}}]& ],
  AspectRatio->Automatic,
  Frame->False,
  FrameTicks->None,
  ImageSize->{920., Automatic},
  PlotRange->All,
  PlotRangePadding->Scaled[0.1]]], "Output",
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Formativ und Reflexiv   [Beta', Lambda']: P x (P+K): Diagramm: eta_i ->eta_j, \
etai->y_k\
\>", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"B", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
    "\[IndentingNewLine]", "    ", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
    "\[IndentingNewLine]", "    ", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
    "\[IndentingNewLine]", "    ", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}]}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"B", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Lambda", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     "\[IndentingNewLine]", "                ", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     "\[IndentingNewLine]", "                ", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
     "\[IndentingNewLine]", "                ", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Lambda", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"BL", "=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"B", "//", "Transpose"}], ",", 
    RowBox[{"Lambda", "//", "Transpose"}], ",", "2"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"BL", "//", "MatrixForm"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}]}], "}"}]], "Output"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0", "0", "0", "0"},
      {"2", "0", "0", "0", "0"},
      {"3", "1", "1", "0", "0"},
      {"4", "0", "0", "1", "0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "1", "0", "0", "0"},
      {"2", "0", "1", "0", "0"},
      {"3", "0", "0", "0", "1"},
      {"4", "0", "0", "0", "1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
     "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
     "1"}], "}"}]}], "}"}]], "Output"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", "7", 
       "8"},
      {"1", "0", "0", "1", "0", "1", "0", "0", "0"},
      {"2", "0", "0", "1", "0", "0", "1", "0", "0"},
      {"3", "0", "0", "0", "1", "0", "0", "0", "0"},
      {"4", "0", "0", "0", "0", "0", "0", "1", "1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"P", "=", "4"}], ";", 
  RowBox[{"K", "=", "4"}], ";"}], "\n", 
 RowBox[{"messind", "=", 
  RowBox[{"Range", "[", 
   RowBox[{
    RowBox[{"P", "+", "1"}], ",", 
    RowBox[{"P", "+", "K"}]}], "]"}]}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"5", ",", "6", ",", "7", ",", "8"}], "}"}]], "Output"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"texte", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<eta1\>\"", ",", "\"\<eta2\>\"", ",", "\"\<eta3\>\"", ",", 
     "\"\<eta4\>\"", ",", "\"\<y1\>\"", ",", "\"\<y2\>\"", ",", "\"\<y41\>\"",
      ",", "\"\<y42\>\""}], "}"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"vertex", "=", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"MemberQ", "[", 
        RowBox[{"messind", ",", "#2"}], "]"}], ",", "\[IndentingNewLine]", 
       "                 ", 
       RowBox[{"(", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"GrayLevel", "[", ".9", "]"}], ",", 
          RowBox[{"EdgeForm", "[", "Black", "]"}], ",", 
          RowBox[{"Rectangle", "[", 
           RowBox[{
            RowBox[{"#", "-", ".08"}], ",", 
            RowBox[{"#", "+", ".08"}]}], "]"}], ",", "Blue", ",", 
          RowBox[{"Text", "[", 
           RowBox[{
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"texte", "[", 
               RowBox[{"[", "#2", "]"}], "]"}], ",", "Italic", ",", "12", ",", 
              RowBox[{"FontFamily", "\[Rule]", "\"\<Helvetica\>\""}]}], "]"}],
             ",", "#1"}], "]"}]}], "}"}], ")"}], ",", "\[IndentingNewLine]", 
       "                 ", 
       RowBox[{"(", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"GrayLevel", "[", ".9", "]"}], ",", 
          RowBox[{"EdgeForm", "[", "Black", "]"}], ",", 
          RowBox[{"Disk", "[", 
           RowBox[{"#", ",", ".1"}], "]"}], ",", "Red", ",", 
          RowBox[{"Text", "[", 
           RowBox[{
            RowBox[{"texte", "[", 
             RowBox[{"[", "#2", "]"}], "]"}], ",", "#1"}], "]"}]}], "}"}], 
        ")"}]}], "]"}], "&"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"edge", "=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Green", ",", 
       RowBox[{"Arrowheads", "[", ".02", "]"}], ",", 
       RowBox[{"Arrow", "[", 
        RowBox[{"#1", ",", "0.1"}], "]"}]}], "}"}], "&"}], ")"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"GraphPlot", "[", 
  RowBox[{"BL", ",", 
   RowBox[{"VertexLabeling", "\[Rule]", "All"}], ",", 
   RowBox[{"VertexRenderingFunction", "\[Rule]", "vertex"}], ",", 
   "\[IndentingNewLine]", "                                   ", 
   RowBox[{"EdgeRenderingFunction", "\[Rule]", "edge"}], ",", 
   RowBox[{"Frame", "\[Rule]", "False"}], ",", 
   RowBox[{"SelfLoopStyle", "\[Rule]", "All"}], ",", 
   RowBox[{"Method", "\[Rule]", "\"\<SpringElectricalEmbedding\>\""}]}], 
  "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"Green", ",", 
    RowBox[{"Arrowheads", "[", "0.02`", "]"}], ",", 
    RowBox[{"Arrow", "[", 
     RowBox[{"#1", ",", "0.1`"}], "]"}]}], "}"}], "&"}]], "Output"],

Cell[BoxData[
 GraphicsBox[
  TagBox[{{
     {RGBColor[0, 1, 0], Arrowheads[0.02], 
      ArrowBox[{{0.5440792544277437, 2.424936087268765}, {1.203209376198073, 
       1.56286837019346}}, 0.1]}, 
     {RGBColor[0, 1, 0], Arrowheads[0.02], 
      ArrowBox[{{0.5440792544277437, 2.424936087268765}, {0., 
       3.1254478331562403`}}, 0.1]}, 
     {RGBColor[0, 1, 0], Arrowheads[0.02], 
      ArrowBox[{{0.5445374575673996, 0.7007129042490982}, {1.203209376198073, 
       1.56286837019346}}, 0.1]}, 
     {RGBColor[0, 1, 0], Arrowheads[0.02], 
      ArrowBox[{{0.5445374575673996, 0.7007129042490982}, {
       0.0001259376817082103, 0.}}, 0.1]}, 
     {RGBColor[0, 1, 0], Arrowheads[0.02], 
      ArrowBox[{{1.203209376198073, 1.56286837019346}, {2.40452509802369, 
       1.5628490228092504`}}, 0.1]}, 
     {RGBColor[0, 1, 0], Arrowheads[0.02], 
      ArrowBox[{{2.40452509802369, 1.5628490228092504`}, {3.130111279708049, 
       1.0265696989465352`}}, 0.1]}, 
     {RGBColor[0, 1, 0], Arrowheads[0.02], 
      ArrowBox[{{2.40452509802369, 1.5628490228092504`}, {3.1298215496467154`,
        2.099336995312095}}, 0.1]}}, {
     {GrayLevel[0.9], EdgeForm[GrayLevel[0]], 
      DiskBox[{0.5440792544277437, 2.424936087268765}, 0.1], 
      {RGBColor[1, 0, 0], 
       InsetBox["\<\"eta1\"\>", {0.5440792544277437, 2.424936087268765}]}}, 
     {GrayLevel[0.9], EdgeForm[GrayLevel[0]], 
      DiskBox[{0.5445374575673996, 0.7007129042490982}, 0.1], 
      {RGBColor[1, 0, 0], 
       InsetBox["\<\"eta2\"\>", {0.5445374575673996, 0.7007129042490982}]}}, 
     {GrayLevel[0.9], EdgeForm[GrayLevel[0]], 
      DiskBox[{1.203209376198073, 1.56286837019346}, 0.1], 
      {RGBColor[1, 0, 0], 
       InsetBox["\<\"eta3\"\>", {1.203209376198073, 1.56286837019346}]}}, 
     {GrayLevel[0.9], EdgeForm[GrayLevel[0]], 
      DiskBox[{2.40452509802369, 1.5628490228092504`}, 0.1], 
      {RGBColor[1, 0, 0], 
       InsetBox["\<\"eta4\"\>", {2.40452509802369, 1.5628490228092504`}]}}, 
     {GrayLevel[0.9], EdgeForm[GrayLevel[0]], 
      RectangleBox[{-0.08, 3.0454478331562402`}, {0.08, 3.2054478331562404`}], 
      {RGBColor[0, 0, 1], InsetBox[
        StyleBox["\<\"y1\"\>",
         StripOnInput->False,
         FontFamily->"Helvetica",
         FontSize->12,
         FontSlant->Italic], {0., 3.1254478331562403`}]}}, 
     {GrayLevel[0.9], EdgeForm[GrayLevel[0]], 
      RectangleBox[{-0.07987406231829179, -0.08}, \
{0.08012593768170821, 0.08}], 
      {RGBColor[0, 0, 1], InsetBox[
        StyleBox["\<\"y2\"\>",
         StripOnInput->False,
         FontFamily->"Helvetica",
         FontSize->12,
         FontSlant->Italic], {0.0001259376817082103, 0.}]}}, 
     {GrayLevel[0.9], EdgeForm[GrayLevel[0]], 
      RectangleBox[{3.050111279708049, 0.9465696989465352}, \
{3.210111279708049, 1.1065696989465352`}], 
      {RGBColor[0, 0, 1], InsetBox[
        StyleBox["\<\"y41\"\>",
         StripOnInput->False,
         FontFamily->"Helvetica",
         FontSize->12,
         FontSlant->Italic], {3.130111279708049, 1.0265696989465352`}]}}, 
     {GrayLevel[0.9], EdgeForm[GrayLevel[0]], 
      RectangleBox[{3.0498215496467154`, 2.019336995312095}, \
{3.2098215496467155`, 2.179336995312095}], 
      {RGBColor[0, 0, 1], InsetBox[
        StyleBox["\<\"y42\"\>",
         StripOnInput->False,
         FontFamily->"Helvetica",
         FontSize->12,
         FontSlant->Italic], {3.1298215496467154`, 2.099336995312095}]}}}},
   Annotation[#, 
    VertexCoordinateRules -> {{0.5440792544277437, 2.424936087268765}, {
     0.5445374575673996, 0.7007129042490982}, {1.203209376198073, 
     1.56286837019346}, {2.40452509802369, 1.5628490228092504`}, {0., 
     3.1254478331562403`}, {0.0001259376817082103, 0.}, {3.130111279708049, 
     1.0265696989465352`}, {3.1298215496467154`, 2.099336995312095}}]& ],
  AspectRatio->Automatic,
  Frame->False,
  FrameTicks->None,
  ImageSize->{693., Automatic},
  PlotRange->All,
  PlotRangePadding->Scaled[0.1]]], "Output"]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1210, 819},
WindowMargins->{{66, Automatic}, {Automatic, 5}},
ShowSelection->True,
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (February 18, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3477913177-4863673"->{
  Cell[3380, 119, 802, 15, 55, "Print",
   CellTags->"Info3477913177-4863673"],
  Cell[4185, 136, 1146, 32, 53, "Print",
   CellTags->"Info3477913177-4863673"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3477913177-4863673", 66491, 1547}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 981, 31, 58, "Input"],
Cell[1551, 55, 270, 8, 39, "Output"],
Cell[1824, 65, 348, 12, 39, "Output"],
Cell[2175, 79, 1095, 30, 83, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3307, 114, 48, 1, 27, "Input"],
Cell[CellGroupData[{
Cell[3380, 119, 802, 15, 55, "Print",
 CellTags->"Info3477913177-4863673"],
Cell[4185, 136, 1146, 32, 53, "Print",
 CellTags->"Info3477913177-4863673"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5380, 174, 3036, 87, 193, "Input"],
Cell[8419, 263, 252, 6, 39, "Output"],
Cell[8674, 271, 1952, 40, 217, "Output"],
Cell[10629, 313, 3038, 58, 175, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13704, 376, 916, 27, 103, "Input"],
Cell[14623, 405, 270, 8, 39, "Output"],
Cell[14896, 415, 996, 27, 83, "Output"],
Cell[15895, 444, 230, 8, 39, "Output"],
Cell[16128, 454, 966, 27, 83, "Output"],
Cell[17097, 483, 337, 10, 39, "Output"],
Cell[17437, 495, 1036, 27, 83, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18510, 527, 2748, 67, 178, "Input"],
Cell[21261, 596, 213, 6, 39, "Output"],
Cell[21477, 604, 15719, 278, 414, 3436, 75, "CachedBoxData", "BoxData", \
"Output"],
Cell[37199, 884, 15872, 286, 401, 2711, 69, "CachedBoxData", "BoxData", \
"Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[53108, 1175, 119, 3, 34, "Subsection"],
Cell[CellGroupData[{
Cell[53252, 1182, 1477, 40, 193, "Input"],
Cell[54732, 1224, 369, 10, 39, "Output"],
Cell[55104, 1236, 1039, 28, 97, "Output"],
Cell[56146, 1266, 1039, 28, 97, "Output"],
Cell[57188, 1296, 573, 18, 39, "Output"],
Cell[57764, 1316, 1147, 29, 97, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[58948, 1350, 247, 8, 43, "Input"],
Cell[59198, 1360, 93, 2, 39, "Output"]
}, Open  ]],
Cell[59306, 1365, 279, 7, 27, "Input"],
Cell[CellGroupData[{
Cell[59610, 1376, 2341, 60, 133, "Input"],
Cell[61954, 1438, 213, 6, 39, "Output"],
Cell[62170, 1446, 3968, 86, 719, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
