(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    113351,       2112]
NotebookOptionsPosition[    112938,       2094]
NotebookOutlinePosition[    113338,       2111]
CellTagsIndexPosition[    113295,       2108]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Symmetrize", "[", "A_", "]"}], " ", ":=", " ", 
    RowBox[{"0.5", "*", 
     RowBox[{"(", 
      RowBox[{"A", " ", "+", " ", 
       RowBox[{"Transpose", "[", "A", "]"}]}], ")"}]}]}], ";"}], " ", 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{"IndividualLikNonlinNorKorr", "//", "Clear"}], "\n", 
 RowBox[{
  RowBox[{"IndividualLikNonlinNorKorr", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Y_", ",", " ", "X_", ",", " ", "miss_"}], "}"}], ",", " ", 
    "Theta_", ",", " ", 
    RowBox[{"{", 
     RowBox[{"System_", ",", " ", "ThetaFix_", ",", " ", 
      RowBox[{"m_:", "3"}], ",", " ", 
      RowBox[{"eps_:", 
       RowBox[{"10.", "^", 
        RowBox[{"(", 
         RowBox[{"-", "16"}], ")"}]}]}], ",", " ", 
      RowBox[{"ksigma_:", "Infinity"}], ",", " ", 
      RowBox[{"text_:", "0"}]}], "}"}], ",", " ", "\n", 
    "                                                              ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Singular_:", "False"}], ",", " ", 
      RowBox[{"const_:", "2", "*", "Pi"}], ",", " ", 
      RowBox[{"option_:", "0"}], ",", " ", 
      RowBox[{"onlyNorKorr_:", "0"}]}], "}"}]}], "]"}], " ", ":=", " ", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"Block", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "P", ",", " ", "Q", ",", " ", "K", ",", " ", "beta", ",", " ", "gamma", 
      ",", " ", "sigmazeta", ",", " ", "h", ",", "dh", ",", " ", 
      "sigmaepsilon", ",", " ", "B1", ",", " ", "B11", ",", " ", "sigmaeta", 
      ",", " ", "n", ",", " ", "lik", ",", " ", "yn", ",", " ", "sel", ",", 
      " ", "\n", "                 ", "xn", ",", " ", "mueeta", ",", " ", 
      RowBox[{"(*", 
       RowBox[{"vals", ","}], "*)"}], " ", "hl", ",", " ", "hlhl", ",", " ", 
      "Eh", ",", " ", "hh", ",", " ", "sigmaepsilonsel", ",", " ", "yy", ",", 
      " ", "yetasigmaetaI", ",", " ", "ynsel", ",", " ", "nue", ",", 
      "\[IndentingNewLine]", "         ", "l0", ",", " ", "l1", ",", " ", "l",
       ",", " ", "etay", ",", " ", "H1", ",", " ", "E0etay", ",", " ", 
      "V0etay", ",", "sigmaepsilonselI", ",", " ", "zaehler", ",", " ", 
      "nenner", ",", " ", "H", ",", " ", "V0yetaI", ",", " ", "d", ",", " ", 
      "Likratio", ",", " ", "L1", ",", "x"}], "}"}], ",", " ", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"beta", ",", " ", "gamma", ",", " ", "sigmazeta"}], "}"}], 
        ",", " ", 
        RowBox[{"{", 
         RowBox[{"h", ",", "dh", ",", " ", "sigmaepsilon"}], "}"}]}], "}"}], 
      " ", "=", " ", 
      RowBox[{"System", "[", 
       RowBox[{"Theta", ",", " ", "ThetaFix"}], "]"}]}], ";", " ", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"P", ",", " ", "Q"}], "}"}], " ", "=", " ", 
      RowBox[{"Dimensions", "[", "gamma", "]"}]}], ";", " ", "\n", "     ", 
     RowBox[{"B1", " ", "=", " ", 
      RowBox[{
       RowBox[{"IdentityMatrix", "[", "P", "]"}], " ", "-", " ", "beta"}]}], 
     ";", "\[IndentingNewLine]", " ", 
     RowBox[{"B11", " ", "=", " ", 
      RowBox[{"Inverse", "[", "B1", "]"}]}], ";", " ", "\[IndentingNewLine]", 
     " ", 
     RowBox[{"sigmaeta", " ", "=", " ", 
      RowBox[{"B11", " ", ".", " ", "sigmazeta", " ", ".", " ", 
       RowBox[{"Transpose", "[", "B11", "]"}]}]}], ";", " ", "\n", "     ", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"VALS", ",", " ", "WEIGHT"}], "}"}], " ", "=", " ", 
      RowBox[{"GaussHermitePointsMulti2", "[", 
       RowBox[{
       "m", ",", " ", "P", ",", " ", "eps", ",", " ", "ksigma", ",", " ", 
        "text"}], "]"}]}], ";", " ", "\[IndentingNewLine]", " ", 
     RowBox[{"n", " ", "=", " ", 
      RowBox[{"Length", "[", "Y", "]"}]}], ";", " ", "\[IndentingNewLine]", 
     RowBox[{"lik", " ", "=", " ", 
      RowBox[{"{", "}"}]}], ";", " ", "\[IndentingNewLine]", "\n", "    ", 
     RowBox[{"Do", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"yn", " ", "=", " ", 
         RowBox[{"Y", "[", 
          RowBox[{"[", "nn", "]"}], "]"}]}], ";", " ", "\[IndentingNewLine]", 
        
        RowBox[{"sel", " ", "=", " ", 
         RowBox[{"NotPosition", "[", 
          RowBox[{"yn", ",", " ", "miss"}], "]"}]}], ";", " ", 
        RowBox[{"sel", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"sel", " ", "==", " ", 
            RowBox[{"{", "}"}]}], ",", " ", 
           RowBox[{"l", " ", "=", " ", "0"}], ",", " ", "\[IndentingNewLine]",
            "\[IndentingNewLine]", 
           RowBox[{"Which", "[", 
            RowBox[{
             RowBox[{"Singular", " ", "===", " ", "False"}], ",", " ", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", "  ", 
             RowBox[{
              RowBox[{"xn", " ", "=", " ", 
               RowBox[{"X", "[", 
                RowBox[{"[", "nn", "]"}], "]"}]}], ";", " ", 
              "\[IndentingNewLine]", "  ", 
              RowBox[{"mueeta", " ", "=", " ", 
               RowBox[{"B11", " ", ".", " ", "gamma", " ", ".", " ", "xn"}]}],
               ";", " ", "\[IndentingNewLine]", "\n", "                ", 
              RowBox[{"vals", " ", "=", " ", 
               RowBox[{"TrafoMueSigma", "[", 
                RowBox[{"VALS", ",", " ", 
                 RowBox[{"{", 
                  RowBox[{"mueeta", ",", " ", "sigmaeta"}], "}"}], ",", " ", 
                 "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", "  ", 
              RowBox[{"hl", " ", "=", " ", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"h", "[", 
                    RowBox[{"#1", ",", " ", "xn", ",", " ", "Theta"}], "]"}], 
                   "[", 
                   RowBox[{"[", "sel", "]"}], "]"}], " ", "&"}], " ", ")"}], 
                " ", "/@", " ", "vals"}]}], ";", " ", "\[IndentingNewLine]", 
              "  ", 
              RowBox[{"hlhl", " ", "=", " ", 
               RowBox[{"Dyad", " ", "/@", " ", "hl"}]}], ";", " ", 
              "\[IndentingNewLine]", "  ", 
              RowBox[{"Eh", " ", "=", " ", 
               RowBox[{"WEIGHT", " ", ".", " ", "hl"}]}], ";", " ", 
              "\[IndentingNewLine]", "  ", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"Eh", "=", 
                 RowBox[{"h", "[", 
                  RowBox[{"mueeta", ",", "xn", ",", "Theta"}], "]"}]}], ";"}],
                "*)"}], "\[IndentingNewLine]", "\n", "                ", 
              RowBox[{"hh", " ", "=", " ", 
               RowBox[{
                RowBox[{"WEIGHT", " ", ".", " ", "hlhl"}], " ", "-", " ", 
                RowBox[{"Dyad", "[", "Eh", "]"}]}]}], ";", " ", 
              "\[IndentingNewLine]", "  ", 
              RowBox[{"sigmaepsilonsel", " ", "=", " ", 
               RowBox[{"sigmaepsilon", "[", 
                RowBox[{"[", 
                 RowBox[{"sel", ",", "sel"}], "]"}], "]"}]}], ";", 
              "\[IndentingNewLine]", "  ", 
              RowBox[{"yy", " ", "=", " ", 
               RowBox[{"hh", " ", "+", " ", "sigmaepsilonsel"}]}], ";", 
              "\[IndentingNewLine]", "  ", 
              RowBox[{"yyI", " ", "=", " ", 
               RowBox[{"Inverse", "[", "yy", "]"}]}], ";", " ", 
              "\[IndentingNewLine]", "  ", 
              RowBox[{"ynsel", " ", "=", " ", 
               RowBox[{"yn", "[", 
                RowBox[{"[", "sel", "]"}], "]"}]}], ";", " ", "\n", 
              "                ", 
              RowBox[{"nue", " ", "=", " ", 
               RowBox[{"ynsel", " ", "-", " ", "Eh"}]}], ";", 
              "\[IndentingNewLine]", "  ", 
              RowBox[{"l0", " ", "=", " ", 
               RowBox[{
                RowBox[{"-", "0.5"}], "*", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Log", "[", 
                   RowBox[{"Det", "[", 
                    RowBox[{"const", "*", "yy"}], "]"}], "]"}], " ", "+", " ", 
                  RowBox[{
                  "nue", " ", ".", " ", "yyI", " ", ".", " ", "nue"}]}], 
                 ")"}]}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]",
               "\[IndentingNewLine]", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"onlyNorKorr", " ", "===", " ", "1"}], ",", " ", 
                RowBox[{"l1", " ", "=", " ", "0"}], ",", " ", 
                "\[IndentingNewLine]", "\n", "                   ", 
                RowBox[{
                 RowBox[{"yeta", " ", "=", " ", 
                  RowBox[{
                   RowBox[{"WEIGHT", " ", ".", " ", 
                    RowBox[{"MapThread", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Dyad", "[", 
                    RowBox[{"#1", ",", "#2"}], "]"}], "&"}], ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"hl", ",", " ", "vals"}], "}"}]}], "]"}]}], " ", 
                   "-", " ", 
                   RowBox[{"Dyad", "[", 
                    RowBox[{"Eh", ",", " ", "mueeta"}], "]"}]}]}], ";", " ", 
                 "\[IndentingNewLine]", "   ", 
                 RowBox[{"etay", " ", "=", " ", 
                  RowBox[{"Transpose", "[", "yeta", "]"}]}], ";", 
                 "\[IndentingNewLine]", "   ", 
                 RowBox[{"H1", " ", "=", " ", 
                  RowBox[{"etay", " ", ".", " ", "yyI"}]}], ";", 
                 "\[IndentingNewLine]", "   ", 
                 RowBox[{"E0etay", " ", "=", " ", 
                  RowBox[{"mueeta", " ", "+", " ", 
                   RowBox[{"H1", " ", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{"ynsel", " ", "-", " ", "Eh"}], ")"}]}]}]}], ";", 
                 " ", "\n", "                   ", 
                 RowBox[{"V0etay", " ", "=", " ", 
                  RowBox[{"sigmaeta", " ", "-", " ", 
                   RowBox[{"H1", " ", ".", " ", "yeta"}]}]}], ";", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", "   ", 
                 RowBox[{"vals", " ", "=", " ", 
                  RowBox[{"TrafoMueSigma", "[", 
                   RowBox[{"VALS", ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"E0etay", ",", " ", "V0etay"}], "}"}], ",", " ", 
                    "0"}], "]"}]}], ";", " ", 
                 RowBox[{"(*", 
                  RowBox[{"St\[UDoubleDot]tzstellen", " ", "aus", " ", "p0", 
                   RowBox[{"(", 
                    RowBox[{"eta", "|", "y"}], ")"}]}], "*)"}], 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 "\[IndentingNewLine]", 
                 RowBox[{"(*", 
                  RowBox[{"p", 
                   RowBox[{"(", 
                    RowBox[{"y", "|", "eta"}]}]}], "*)"}], "\n", 
                 "                   ", 
                 RowBox[{"nue", " ", "=", " ", 
                  RowBox[{"Map", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"ynsel", " ", "-", " ", 
                    RowBox[{
                    RowBox[{"h", "[", 
                    RowBox[{"#", ",", " ", "xn", ",", " ", "Theta"}], "]"}], 
                    "[", 
                    RowBox[{"[", "sel", "]"}], "]"}]}], ")"}], "&"}], ",", 
                    "vals"}], "]"}]}], ";", "\[IndentingNewLine]", "   ", 
                 RowBox[{"sigmaepsilonselI", " ", "=", " ", 
                  RowBox[{"Inverse", "[", "sigmaepsilonsel", "]"}]}], ";", 
                 " ", "\[IndentingNewLine]", "   ", 
                 RowBox[{"zaehler", " ", "=", " ", 
                  RowBox[{"Map", "[", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    "#", ".", " ", "sigmaepsilonselI", " ", ".", " ", "#"}], 
                    "&"}], " ", ")"}], " ", ",", "nue"}], "]"}]}], ";", " ", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"(*", 
                  RowBox[{"p0", 
                   RowBox[{"(", 
                    RowBox[{"y", "|", "eta"}]}]}], "*)"}], "\n", 
                 "                    ", 
                 RowBox[{"H", " ", "=", " ", 
                  RowBox[{"yeta", " ", ".", " ", 
                   RowBox[{"Inverse", "[", "sigmaeta", "]"}]}]}], ";", 
                 "\[IndentingNewLine]", "   ", 
                 RowBox[{"V0yeta", " ", "=", " ", 
                  RowBox[{"yy", " ", "-", " ", 
                   RowBox[{"H", " ", ".", " ", "etay"}]}]}], ";", 
                 "                    ", 
                 RowBox[{"(*", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"y", ",", "y"}], ")"}], "-", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"y", ",", "eta"}], ")"}], 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"eta", ",", "eta"}], ")"}], "^", 
                    RowBox[{"-", "1"}]}], 
                    RowBox[{"(", 
                    RowBox[{"eta", ",", "y"}], ")"}]}]}], "*)"}], 
                 "\[IndentingNewLine]", "   ", 
                 RowBox[{"V0yetaI", "=", 
                  RowBox[{"V0yeta", "//", "Inverse"}]}], ";", 
                 "\[IndentingNewLine]", "   ", 
                 RowBox[{"d", " ", "=", " ", 
                  RowBox[{"ynsel", " ", "-", " ", "Eh", " ", "+", " ", 
                   RowBox[{"H", " ", ".", " ", "mueeta"}]}]}], ";", 
                 "\[IndentingNewLine]", "   ", 
                 RowBox[{"nue", " ", "=", " ", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"d", " ", "-", " ", 
                    RowBox[{"H", " ", ".", " ", "#"}]}], ")"}], "&"}], " ", "/@",
                    " ", "vals"}]}], ";", " ", "\n", "                    ", 
                 RowBox[{"nenner", " ", "=", " ", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    "#", " ", ".", " ", "V0yetaI", " ", ".", " ", "#"}], " ", 
                    ")"}], "&"}], "/@", " ", "nue"}]}], ";", " ", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", "   ", 
                 RowBox[{"Jacobi", " ", "=", " ", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Det", "[", "sigmaepsilonselI", "]"}], "/", 
                    RowBox[{"Det", "[", "V0yetaI", "]"}]}], ")"}], "^", 
                   "0.5"}]}], ";", " ", "\[IndentingNewLine]", "   ", 
                 RowBox[{"Likratio", " ", "=", " ", 
                  RowBox[{"Exp", "[", 
                   RowBox[{
                    RowBox[{"-", "0.5"}], "*", 
                    RowBox[{"(", 
                    RowBox[{"zaehler", " ", "-", " ", "nenner"}], ")"}]}], 
                   "]"}]}], ";", "\n", "                   ", 
                 RowBox[{"L1", " ", "=", " ", 
                  RowBox[{"Jacobi", "*", 
                   RowBox[{"(", 
                    RowBox[{"WEIGHT", " ", ".", " ", "Likratio"}], ")"}]}]}], 
                 ";", " ", "\[IndentingNewLine]", "  ", 
                 RowBox[{"l1", " ", "=", " ", 
                  RowBox[{"Log", "[", "L1", "]"}]}], ";", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"pp", " ", ">", " ", "0"}], ",", " ", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   "               ", "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", "               ", 
                   RowBox[{
                    RowBox[{"p1", "=", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Det", "[", 
                    RowBox[{"sigmaepsilonselI", "/", "const"}], "]"}], "^", 
                    "0.5"}], "   ", 
                    RowBox[{"Exp", "[", 
                    RowBox[{
                    RowBox[{"-", ".5"}], " ", "zaehler"}], "]"}]}]}], ";", 
                    " ", "\[IndentingNewLine]", "               ", 
                    RowBox[{"p2", "=", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Det", "[", 
                    RowBox[{"V0yetaI", "/", "const"}], "]"}], "^", "0.5"}], "   ", 
                    RowBox[{"Exp", "[", 
                    RowBox[{
                    RowBox[{"-", ".5"}], " ", "nenner"}], "]"}]}]}], ";", " ",
                     "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    "               ", 
                    RowBox[{"p1max", "=", 
                    RowBox[{"p1", "//", "Max"}]}], ";", "\[IndentingNewLine]",
                     "               ", 
                    RowBox[{"p2max", "=", 
                    RowBox[{"p2", "//", "Max"}]}], ";", "\[IndentingNewLine]",
                     "               ", "\[IndentingNewLine]", 
                    "               ", 
                    RowBox[{"maxx", "=", 
                    RowBox[{"Max", "[", 
                    RowBox[{"p1max", ",", "p2max"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", "               ", 
                    RowBox[{"plr", "=", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"plr1", "=", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "4"}], ",", "4"}], "}"}]}], ",", 
                    RowBox[{"plr2", "=", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", 
                    RowBox[{"maxx", " ", "2"}]}], "}"}]}]}], "}"}]}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    "              ", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"!", "scaling"}], ",", 
                    RowBox[{"p1max", "=", 
                    RowBox[{"p2max", "=", "1"}]}], ",", " ", 
                    RowBox[{"plr", "=", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"plr1", "=", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "4"}], ",", "4"}], "}"}]}], ",", 
                    RowBox[{"plr2", "=", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "1.1"}], "}"}]}]}], "}"}]}]}], "]"}], 
                    ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    "               ", 
                    RowBox[{"p1", "=", 
                    RowBox[{"p1", "/", "p1max"}]}], ";", 
                    "\[IndentingNewLine]", "               ", 
                    RowBox[{"p2", "=", 
                    RowBox[{"p2", "/", "p2max"}]}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"sigmaepsilonsel", "//", "Print"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"h", "[", 
                    RowBox[{
                    RowBox[{"{", "2", "}"}], ",", " ", "xn", ",", " ", 
                    "Theta"}], "]"}], "[", 
                    RowBox[{"[", "sel", "]"}], "]"}], "//", "Print"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"ynsel", "//", "Print"}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    "               ", 
                    RowBox[{"p1f", "=", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"GaussDichte", "[", 
                    RowBox[{"ynsel", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"h", "[", 
                    RowBox[{"#", ",", " ", "xn", ",", " ", "Theta"}], "]"}], 
                    "[", 
                    RowBox[{"[", "sel", "]"}], "]"}], ",", 
                    "sigmaepsilonsel"}], "}"}]}], "]"}], "/", "p1max"}], 
                    ")"}], "&"}]}], ";", "\[IndentingNewLine]", 
                    "               ", 
                    RowBox[{"p2f", "=", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"GaussDichte", "[", 
                    RowBox[{"d", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"H", ".", "#"}], ",", "V0yeta"}], "}"}]}], "]"}], 
                    "/", "p2max"}], ")"}], "&"}]}], ";", 
                    "\[IndentingNewLine]", "               ", 
                    RowBox[{"p0etay", "=", 
                    RowBox[{
                    RowBox[{"GaussDichte", "[", 
                    RowBox[{"#", ",", 
                    RowBox[{"{", 
                    RowBox[{"E0etay", ",", " ", "V0etay"}], "}"}]}], "]"}], 
                    "&"}]}], ";", "\[IndentingNewLine]", 
                    "\[IndentingNewLine]", "              ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"plot1", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"vals", "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "pp"}], "]"}], "]"}], ",", 
                    RowBox[{"Jacobi", "*", "Likratio"}], ",", "WEIGHT"}], 
                    "}"}], "//", "Transpose"}], ",", " ", 
                    "\[IndentingNewLine]", "            ", 
                    RowBox[{"PlotJoined", " ", "->", " ", "False"}], ",", " ", 
                    RowBox[{"GridLines", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"ynsel", "[", 
                    RowBox[{"[", "pp", "]"}], "]"}], "}"}], ",", " ", 
                    RowBox[{"{", "1", "}"}]}], "}"}]}], ",", 
                    RowBox[{"dicke", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{".02", ",", ".01"}], "}"}]}], ",", 
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"plr1", ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "10"}], "}"}]}], "}"}]}]}], "]"}], ",", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", "       ", 
                    RowBox[{"plot1", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"vals", "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "pp"}], "]"}], "]"}], ",", " ", 
                    "WEIGHT", ",", "p1", ",", "p2"}], "}"}], "//", 
                    "Transpose"}], ",", " ", "\[IndentingNewLine]", 
                    "            ", 
                    RowBox[{"PlotJoined", " ", "->", " ", "False"}], ",", " ", 
                    RowBox[{"GridLines", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"ynsel", "[", 
                    RowBox[{"[", "pp", "]"}], "]"}], "}"}], ",", " ", 
                    "None"}], "}"}]}], ",", 
                    RowBox[{"dicke", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{".02", ",", ".02", ",", ".015"}], "}"}]}], ",", 
                    "\[IndentingNewLine]", "              ", 
                    RowBox[{"color", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "3", ",", "4"}], "}"}]}], ",", 
                    RowBox[{"PlotRange", "\[Rule]", "plr"}], ",", 
                    RowBox[{"PlotPoints", "\[Rule]", "5"}]}], "]"}], ",", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", "      ", 
                    RowBox[{
                    RowBox[{"arg", "=", 
                    RowBox[{"Tuples", "[", 
                    RowBox[{
                    RowBox[{"Range", "[", 
                    RowBox[{
                    RowBox[{"-", "2"}], ",", "2", ",", "2"}], "]"}], ",", 
                    "P"}], "]"}]}], ";", "\n", 
                    "                                 ", 
                    RowBox[{
                    RowBox[{"arg", "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "pp"}], "]"}], "]"}], "=", "x"}], ";",
                     " ", "\[IndentingNewLine]", "      ", 
                    RowBox[{"pl", "=", 
                    RowBox[{
                    RowBox[{"Plot", "[", 
                    RowBox[{
                    RowBox[{"{", " ", 
                    RowBox[{
                    RowBox[{"p1f", "[", "#", "]"}], ",", 
                    RowBox[{"p2f", "[", "#", "]"}], ",", "0", ",", 
                    RowBox[{"p0etay", "[", "#", "]"}]}], "}"}], ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"x", ",", "plr1"}], "}"}], "//", "Flatten"}], "//",
                     "Evaluate"}], ",", " ", "\[IndentingNewLine]", 
                    "                    ", 
                    RowBox[{"GridLines", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"ynsel", "[", 
                    RowBox[{"[", "pp", "]"}], "]"}], "}"}], ",", " ", 
                    "None"}], "}"}]}], ",", 
                    RowBox[{"PerformanceGoal", "\[Rule]", "\"\<Speed\>\""}], 
                    ",", 
                    RowBox[{"PlotRange", "\[Rule]", "plr"}]}], "]"}], "&"}]}],
                     ";", "\[IndentingNewLine]", "      ", 
                    RowBox[{
                    RowBox[{"Map", "[", 
                    RowBox[{"pl", ",", "arg"}], "]"}], "//", "Show"}]}]}], 
                    "}"}], "//", "GraphicsRow"}], "//", "Print"}], ";"}]}], 
                  "\n", "                          ", "]"}], ";"}]}], 
               "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}]}], 
            "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", " ", 
        RowBox[{"l", " ", "=", " ", 
         RowBox[{"l0", " ", "+", " ", "l1"}]}], ";", " ", 
        "\[IndentingNewLine]", 
        RowBox[{"lik", " ", "=", " ", 
         RowBox[{"Append", "[", 
          RowBox[{"lik", ",", " ", "l"}], "]"}]}]}], " ", ",", " ", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"nn", ",", " ", "n"}], "}"}]}], "]"}], ";", " ", "\n", 
     "\[IndentingNewLine]", "    ", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"option", " ", "==", " ", "5"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Plus", " ", "@@", " ", "lik"}], ",", " ", "lik"}], "}"}], 
       ",", " ", 
       RowBox[{"Plus", " ", "@@", " ", "lik"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]}], "Input",
 PageWidth->Infinity,
 CellMargins->{{39.625, 10.}, {0., 10.}},
 InitializationCell->True,
 CellChangeTimes->{{3.460194284551586*^9, 3.460194430512322*^9}, {
   3.4601944628027267`*^9, 3.460194639371933*^9}, {3.460194707706352*^9, 
   3.4601947269782743`*^9}, {3.460194787282988*^9, 3.4601947879591217`*^9}, {
   3.460195583412208*^9, 3.460195677267837*^9}, {3.460195730531335*^9, 
   3.4601957347363777`*^9}, {3.4601977253341637`*^9, 
   3.4601977303712597`*^9}, {3.460199977089291*^9, 3.460199982306014*^9}, {
   3.4602001100007153`*^9, 3.4602001365337563`*^9}, {3.4602001838757668`*^9, 
   3.46020021505055*^9}, {3.46020039918268*^9, 3.46020043709068*^9}, {
   3.460200544282135*^9, 3.460200546288165*^9}, 3.460200959618925*^9, {
   3.46026324513008*^9, 3.460263282755694*^9}, {3.4602633380999613`*^9, 
   3.4602633493534527`*^9}, {3.460263400721909*^9, 3.460263415929566*^9}, {
   3.460263454575968*^9, 3.4602634803271923`*^9}, {3.460263596468174*^9, 
   3.460263712913571*^9}, {3.460264149260456*^9, 3.460264306447337*^9}, {
   3.460264339903819*^9, 3.460264344426856*^9}, {3.4602643774296494`*^9, 
   3.460264747632288*^9}, {3.460264778447598*^9, 3.460264783659968*^9}, {
   3.460265503837646*^9, 3.460265516171212*^9}, {3.460265587432678*^9, 
   3.460265590909531*^9}, {3.460265773917304*^9, 3.4602657740295877`*^9}, {
   3.460265809524905*^9, 3.460265937981409*^9}, {3.4602659990577393`*^9, 
   3.460266097141539*^9}, {3.460266166568413*^9, 3.460266209126886*^9}, {
   3.460266250084037*^9, 3.4602662808402967`*^9}, {3.460266339683448*^9, 
   3.460266426663334*^9}, {3.460266497330805*^9, 3.4602665255713882`*^9}, {
   3.4602665962854033`*^9, 3.460266599621019*^9}, {3.4602666981599493`*^9, 
   3.460266745666133*^9}, {3.4602668309241867`*^9, 3.460266885864461*^9}, {
   3.4602669348160353`*^9, 3.460266996301594*^9}, {3.460267038525139*^9, 
   3.4602670405577307`*^9}, {3.460267080242529*^9, 3.4602671269901857`*^9}, {
   3.4602671603427677`*^9, 3.460267254900002*^9}, {3.460267290349532*^9, 
   3.460267311072433*^9}, {3.460267360591495*^9, 3.4602673854606743`*^9}, {
   3.46026741568622*^9, 3.460267493972913*^9}, 3.460267531325343*^9, {
   3.460267657409995*^9, 3.460267687307645*^9}, {3.460267744356736*^9, 
   3.460267792177703*^9}, {3.460267867265236*^9, 3.460267951190172*^9}, {
   3.460268008054109*^9, 3.4602682257600193`*^9}, {3.4602682707145157`*^9, 
   3.460268383589704*^9}, {3.4602684145136213`*^9, 3.4602684234894333`*^9}, {
   3.460268495772295*^9, 3.460268548380769*^9}, {3.460268585324235*^9, 
   3.460268588068144*^9}, {3.460268722529909*^9, 3.4602687808529863`*^9}, {
   3.460268847343011*^9, 3.4602688643424892`*^9}, {3.460268906843392*^9, 
   3.4602690975890217`*^9}, {3.460269137274601*^9, 3.460269351221425*^9}, {
   3.460269595751025*^9, 3.460269628454479*^9}, {3.4602696598838882`*^9, 
   3.460269679514669*^9}, {3.460269723422311*^9, 3.460269755767868*^9}, {
   3.460269879713437*^9, 3.460269923345128*^9}, {3.46027001591717*^9, 
   3.460270024031649*^9}, 3.46027010485046*^9, {3.460270149953143*^9, 
   3.4602702537187767`*^9}, {3.4602702846349297`*^9, 3.46027029514499*^9}, 
   3.460270346891515*^9, 3.460270607274858*^9, {3.4602708505804453`*^9, 
   3.460270862797477*^9}, 3.4602710337362003`*^9, {3.460271102575704*^9, 
   3.460271108328334*^9}, {3.460271156184857*^9, 3.4602711590022993`*^9}, {
   3.46027123095223*^9, 3.460271270598349*^9}, {3.460271302970233*^9, 
   3.4602713202526827`*^9}, 3.460271477470911*^9, {3.460273080051744*^9, 
   3.46027308520679*^9}, {3.4602731161468687`*^9, 3.460273141336913*^9}, {
   3.460273653624395*^9, 3.46027366118076*^9}, 3.4602760224893513`*^9, {
   3.460276063965891*^9, 3.46027607080488*^9}, {3.460276134568684*^9, 
   3.460276135994856*^9}, {3.460277295287301*^9, 3.460277326831636*^9}, {
   3.4602773608967543`*^9, 3.460277367275772*^9}, {3.460279569593549*^9, 
   3.460279618455995*^9}, {3.4602796591590967`*^9, 3.460279676488124*^9}, {
   3.4602797108870907`*^9, 3.460279763057753*^9}, {3.46027987202001*^9, 
   3.460279929326695*^9}, {3.460279967324646*^9, 3.46027997674712*^9}, {
   3.460282349939086*^9, 3.4602823549144163`*^9}, {3.460282784722953*^9, 
   3.460282801190708*^9}, {3.460282835222114*^9, 3.460283098220755*^9}, {
   3.4602831366017437`*^9, 3.46028316523487*^9}, {3.460284499977572*^9, 
   3.4602846111225557`*^9}, {3.460284647887047*^9, 3.460284660037141*^9}, {
   3.460284706170504*^9, 3.460284707028002*^9}, {3.460284826503705*^9, 
   3.460284868358535*^9}, {3.460284916695053*^9, 3.460284961298512*^9}, {
   3.460285127766464*^9, 3.460285132950951*^9}, {3.460285226420979*^9, 
   3.4602852820574627`*^9}, {3.460285317086361*^9, 3.460285318206476*^9}, {
   3.4602854642893744`*^9, 3.460285482471323*^9}, {3.4602855234027843`*^9, 
   3.4602855440981197`*^9}, {3.4602857779503307`*^9, 
   3.4602857819794283`*^9}, {3.460285817792054*^9, 3.4602858207826433`*^9}, {
   3.4602859174667187`*^9, 3.460285930023323*^9}, 3.460342692301155*^9, {
   3.460342777814019*^9, 3.46034278769788*^9}, {3.4603433422695503`*^9, 
   3.460343349850721*^9}, {3.460343396242371*^9, 3.460343484730915*^9}, {
   3.4603436369330587`*^9, 3.4603439074483213`*^9}, {3.460343972471846*^9, 
   3.4603440498963337`*^9}, {3.460344227510378*^9, 3.460344265735627*^9}, {
   3.4603444047070417`*^9, 3.460344534150508*^9}, {3.4603445912321587`*^9, 
   3.460344784896298*^9}, {3.460344921653266*^9, 3.460344974081581*^9}, {
   3.4603451096385717`*^9, 3.46034520251552*^9}, 3.460345246115415*^9, 
   3.4603453567706003`*^9, {3.4603454172412558`*^9, 3.460345447428486*^9}, {
   3.46034549581929*^9, 3.4603455420148697`*^9}, 3.4603455735194817`*^9, {
   3.460364040779513*^9, 3.460364070906877*^9}, {3.460364114400744*^9, 
   3.460364118558858*^9}, {3.460364167066555*^9, 3.460364175124312*^9}, {
   3.460364210010396*^9, 3.460364240151005*^9}, {3.460364322034679*^9, 
   3.4603644028696136`*^9}, {3.460364789547168*^9, 3.460364791139002*^9}, {
   3.460364839217485*^9, 3.460364955498816*^9}, {3.460365024686344*^9, 
   3.4603650444987183`*^9}, {3.460365078184608*^9, 3.460365085863439*^9}, {
   3.460365172070264*^9, 3.460365237129417*^9}, {3.460365305570582*^9, 
   3.4603653112242393`*^9}, {3.460365389295981*^9, 3.460365401230237*^9}, {
   3.460365659465868*^9, 3.460365673436064*^9}, {3.4603657435143757`*^9, 
   3.460365779346396*^9}, {3.460365810556965*^9, 3.460365812812614*^9}, {
   3.4603658931474333`*^9, 3.460365963229039*^9}, {3.460366042607856*^9, 
   3.4603662381997623`*^9}, {3.460366298650962*^9, 3.4603664489586897`*^9}, {
   3.460366479298209*^9, 3.460366481733535*^9}, {3.460366720220016*^9, 
   3.460366755444069*^9}, {3.460366809463408*^9, 3.460366835407606*^9}, {
   3.460366869300931*^9, 3.4603668837833767`*^9}, {3.460366939043384*^9, 
   3.460367079108756*^9}, {3.460368677725768*^9, 3.460368783406201*^9}, {
   3.460368825195459*^9, 3.460368856802374*^9}, {3.460368902769106*^9, 
   3.460368936787517*^9}, {3.4603689842944307`*^9, 3.460369207328513*^9}, {
   3.460369284729682*^9, 3.4603693343688183`*^9}, {3.460369420816362*^9, 
   3.4603694798800898`*^9}, {3.460377341544571*^9, 3.460377345834638*^9}, {
   3.46037755503498*^9, 3.460377575443983*^9}, {3.460377710414733*^9, 
   3.460377713134892*^9}, {3.460377786961791*^9, 3.46037779106026*^9}, {
   3.460377997641603*^9, 3.46037802596364*^9}, {3.460378073076664*^9, 
   3.460378121436631*^9}, {3.460427568908971*^9, 3.4604276019906387`*^9}, {
   3.4604276609737883`*^9, 3.460427727018682*^9}, {3.460427776818137*^9, 
   3.460427804953367*^9}, {3.460427861256394*^9, 3.460427888546273*^9}, 
   3.460427929325029*^9, {3.460428073272511*^9, 3.4604281497189293`*^9}, {
   3.4604283568000803`*^9, 3.460428416009344*^9}, {3.460428471757371*^9, 
   3.460428618754621*^9}, {3.460428658779772*^9, 3.460428687329473*^9}, {
   3.4604300698451*^9, 3.460430167368123*^9}, {3.460430296224434*^9, 
   3.460430299850492*^9}, {3.4604305314745417`*^9, 3.4604305352701674`*^9}, 
   3.460430672923388*^9, {3.460430752456835*^9, 3.4604308005481033`*^9}, {
   3.460430838727722*^9, 3.4604308611128197`*^9}, {3.4604309019783993`*^9, 
   3.460431023365191*^9}, {3.460431060814273*^9, 3.4604311187056932`*^9}, {
   3.460431174572468*^9, 3.460431175078052*^9}, {3.4604312571954393`*^9, 
   3.4604312908437757`*^9}, {3.460431334200604*^9, 3.460431354340418*^9}, 
   3.4604314133729877`*^9, {3.460431525033979*^9, 3.460431526840539*^9}, {
   3.4604315895139217`*^9, 3.4604316489357357`*^9}, {3.4604316870424232`*^9, 
   3.460431722479638*^9}, {3.4604320819508123`*^9, 3.4604320820774717`*^9}, {
   3.460432146508539*^9, 3.4604322090097933`*^9}, 3.460432320851774*^9, {
   3.4604323828474483`*^9, 3.4604323856411963`*^9}, {3.4604326356353693`*^9, 
   3.460432637991989*^9}, {3.460432710583696*^9, 3.460432731696748*^9}, {
   3.460432767119719*^9, 3.46043278989487*^9}, {3.460433211747725*^9, 
   3.4604332792568808`*^9}, {3.460433448528161*^9, 3.460433466889031*^9}, {
   3.46043352436405*^9, 3.460433524673403*^9}, {3.4604335971021957`*^9, 
   3.46043361413586*^9}, {3.460433697499262*^9, 3.460433700202601*^9}, {
   3.460433739251953*^9, 3.460433741769038*^9}, {3.460433823126432*^9, 
   3.460433830120185*^9}, {3.4604339637144127`*^9, 3.460433977194812*^9}, 
   3.460434156275477*^9, {3.460434200817587*^9, 3.460434203694149*^9}, {
   3.460434284200204*^9, 3.460434334383589*^9}, {3.460434411272003*^9, 
   3.460434418785829*^9}, {3.460434699932282*^9, 3.46043471210847*^9}, {
   3.4604350568371487`*^9, 3.460435059159986*^9}, {3.460435444123107*^9, 
   3.460435499198696*^9}, {3.460436322381576*^9, 3.4604363546464043`*^9}, {
   3.460436386720928*^9, 3.460436477218676*^9}, {3.460436510520681*^9, 
   3.4604365130893087`*^9}, {3.460436584450457*^9, 3.460436586965917*^9}, {
   3.460436617200162*^9, 3.460436651185149*^9}, {3.46043672713341*^9, 
   3.460436731480103*^9}, {3.460436815657415*^9, 3.4604368580390882`*^9}, {
   3.4604369409210167`*^9, 3.4604370018329*^9}, {3.460437173698595*^9, 
   3.460437174527001*^9}, {3.460437233762413*^9, 3.4604372394688683`*^9}, {
   3.460437601033867*^9, 3.460437602519586*^9}, {3.460439417446375*^9, 
   3.460439434720812*^9}, {3.460440155176543*^9, 3.4604401600175133`*^9}, {
   3.460440791386387*^9, 3.4604408120184317`*^9}, {3.460441700186659*^9, 
   3.460441740555923*^9}, {3.4604420069130917`*^9, 3.460442010992319*^9}, {
   3.460442144519423*^9, 3.46044225362346*^9}, {3.460442314187484*^9, 
   3.4604423161112623`*^9}, {3.460442389730761*^9, 3.460442392545186*^9}, {
   3.460442430271729*^9, 3.460442463917342*^9}, {3.460443384306439*^9, 
   3.460443424044107*^9}, {3.4604437315416613`*^9, 3.4604438446749907`*^9}, {
   3.4604439099863358`*^9, 3.46044391364188*^9}, {3.460444082444788*^9, 
   3.460444082989586*^9}, {3.4604441371682997`*^9, 3.460444175109687*^9}, {
   3.460444256094357*^9, 3.460444256298544*^9}, {3.460444378533813*^9, 
   3.460444381855053*^9}, {3.460444493261649*^9, 3.460444538256547*^9}, {
   3.4604446066262627`*^9, 3.4604446090534687`*^9}, {3.460459166692512*^9, 
   3.460459176714656*^9}, {3.4604592214880657`*^9, 3.460459223001932*^9}, {
   3.460459272658309*^9, 3.460459276245063*^9}, {3.460459348854416*^9, 
   3.460459372461773*^9}, {3.4604595076583843`*^9, 3.4604595174356117`*^9}, {
   3.460459578566516*^9, 3.4604596854236794`*^9}, {3.4604597566520967`*^9, 
   3.460459799473901*^9}, {3.460459873676238*^9, 3.460459893682722*^9}, {
   3.460460174963009*^9, 3.4604602051359*^9}, {3.460460463327959*^9, 
   3.4604604847735147`*^9}, {3.46046051506664*^9, 3.4604605203863497`*^9}, {
   3.460460727701488*^9, 3.460460728541339*^9}, {3.460460878375305*^9, 
   3.460460881382044*^9}, {3.460460924553576*^9, 3.460460989950562*^9}, {
   3.460461038207076*^9, 3.4604610731542253`*^9}, {3.460461116482016*^9, 
   3.4604611309531727`*^9}, {3.460461182415584*^9, 3.460461205008712*^9}, {
   3.460461237842492*^9, 3.460461365974218*^9}, {3.460461571255657*^9, 
   3.4604615713747272`*^9}, {3.460461638283538*^9, 3.460461655743291*^9}, {
   3.460461915290369*^9, 3.4604619309454193`*^9}, {3.460548158364236*^9, 
   3.460548163899393*^9}, {3.4605481948153667`*^9, 3.4605482170919323`*^9}, {
   3.4605485337654467`*^9, 3.4605485338731127`*^9}, {3.460548573233035*^9, 
   3.460548631455434*^9}, {3.460548722629752*^9, 3.460548726493541*^9}, {
   3.460548845714376*^9, 3.4605489613039417`*^9}, {3.4605491427510138`*^9, 
   3.4605491461841297`*^9}, {3.460549285260687*^9, 3.460549298510705*^9}, {
   3.460549372484283*^9, 3.460549493794971*^9}, {3.460549575472906*^9, 
   3.460549575593913*^9}, {3.460549649041542*^9, 3.4605496491732264`*^9}, {
   3.4606073994265413`*^9, 3.460607524636485*^9}, {3.4606078256198883`*^9, 
   3.460607830348865*^9}, {3.4606078823236933`*^9, 3.460607895384727*^9}, {
   3.460608547052947*^9, 3.4606085517376947`*^9}, {3.460619888298315*^9, 
   3.46061989144197*^9}, {3.460620067287648*^9, 3.460620152924345*^9}, {
   3.4606201920007677`*^9, 3.4606202070602617`*^9}, {3.46062028575213*^9, 
   3.460620291792*^9}, {3.4606208857295628`*^9, 3.460620903157618*^9}, {
   3.4606209541126738`*^9, 3.460621015785594*^9}, {3.460621100675983*^9, 
   3.4606211028466454`*^9}, {3.460621483726631*^9, 3.4606214953703747`*^9}, {
   3.460621729374908*^9, 3.460621729500869*^9}, {3.460621815045868*^9, 
   3.460621815185301*^9}, {3.4606218617849827`*^9, 3.460621870561606*^9}, {
   3.4606219520404797`*^9, 3.460621962354082*^9}, {3.460687641624383*^9, 
   3.4606876560810757`*^9}, {3.460689992676633*^9, 3.460690053180187*^9}, {
   3.460690151169332*^9, 3.460690160529695*^9}, {3.4606902075828533`*^9, 
   3.460690207705399*^9}, {3.460691109288431*^9, 3.46069110993495*^9}, {
   3.460691701136313*^9, 3.460691717554266*^9}, {3.4607016425086927`*^9, 
   3.460701644579303*^9}},
 ImageRegion->{{0, 1}, {0, 1}},
 FontWeight->"Plain",
 FontColor->GrayLevel[0]],

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"IndividualLikNonlin", " ", "//", " ", "Clear"}], "\n", 
   RowBox[{
    RowBox[{"IndividualLikNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Y_", ",", " ", "X_", ",", " ", "miss_"}], "}"}], ",", " ", 
      "Theta_", ",", " ", 
      RowBox[{"{", 
       RowBox[{"System_", ",", " ", "ThetaFix_", ",", " ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Imethod_:", " ", "\"\<GH\>\""}], " ", ",", " ", 
          RowBox[{"m_:", " ", "3"}], ",", " ", 
          RowBox[{"eps_:", " ", 
           RowBox[{"10.", "^", 
            RowBox[{"(", 
             RowBox[{"-", "16"}], ")"}]}]}], ",", " ", 
          RowBox[{"ksigma_:", " ", "Infinity"}], ",", " ", 
          RowBox[{"text_:", " ", "0"}]}], "}"}]}], "}"}], ",", " ", "\n", 
      "                                                  ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular_:", " ", "False"}], ",", " ", 
        RowBox[{"const_:", " ", "2", "*", "Pi"}], ",", " ", 
        RowBox[{"option_:", " ", "0"}], ",", " ", 
        RowBox[{"onlyNorKorr_:", " ", "0"}], ",", " ", 
        RowBox[{"method_:", " ", "\"\<NorKorr\>\""}], ",", " ", 
        RowBox[{"support_:", " ", "0"}]}], "}"}]}], "]"}], " ", ":=", " ", 
    "\n", " ", "\n", " ", 
    RowBox[{"Block", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "P", ",", " ", "Q", ",", " ", "K", ",", " ", "beta", ",", " ", "gamma",
         ",", " ", "sigmazeta", ",", " ", "h", ",", " ", "sigmaepsilon", ",", 
        " ", "B1", ",", " ", "B11", ",", " ", "sigmaeta", ",", " ", "n", ",", 
        " ", "lik", ",", " ", "yn", ",", " ", "ynsel", ",", " ", "sel", ",", 
        " ", "\n", "                    ", "xn", ",", " ", "mueeta", ",", " ",
         "vals", ",", " ", "hl", ",", " ", "hlhl", ",", " ", "Eh", ",", " ", 
        "hh", ",", " ", "sigmaepsilonsel", ",", " ", "yy", ",", " ", "yyI", 
        ",", " ", "yetasigmaetaI", ",", " ", "nue", ",", "\n", "            ",
         "l0", ",", " ", "l1", ",", " ", "l", ",", " ", "etay", ",", " ", 
        "H1", ",", " ", "E0etay", ",", " ", "V0etay", ",", " ", 
        "sigmaepsilonselI", ",", " ", "zaehler", ",", " ", "nenner", ",", " ",
         "H", ",", " ", "V0yetaI", ",", " ", "\n", "            ", "d", ",", 
        " ", "Likratio", ",", " ", "LogJacobi", ",", " ", "Jacobi", ",", " ", 
        "L1", ",", " ", "x", ",", " ", "a", ",", " ", "B", ",", " ", "C"}], 
       "}"}], ",", " ", "\n", "  ", "\n", "  ", "\n", "  ", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"beta", ",", " ", "gamma", ",", " ", "sigmazeta"}], "}"}], 
          ",", " ", 
          RowBox[{"{", 
           RowBox[{"h", ",", " ", "dh", ",", " ", "sigmaepsilon"}], "}"}]}], 
         "}"}], " ", "=", " ", 
        RowBox[{"System", "[", 
         RowBox[{"Theta", ",", " ", "ThetaFix"}], "]"}]}], ";", " ", "\n", 
       "  ", "\n", "  ", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"P", ",", " ", "Q"}], "}"}], " ", "=", " ", 
        RowBox[{"Dimensions", "[", "gamma", "]"}]}], ";", " ", "\n", 
       "       ", 
       RowBox[{"B1", " ", "=", " ", 
        RowBox[{
         RowBox[{"IdentityMatrix", "[", "P", "]"}], " ", "-", " ", "beta"}]}],
        ";", "\n", "   ", 
       RowBox[{"B11", " ", "=", " ", 
        RowBox[{"Inverse", "[", "B1", "]"}]}], ";", " ", "\n", "   ", 
       RowBox[{"sigmaeta", " ", "=", " ", 
        RowBox[{"B11", " ", ".", " ", "sigmazeta", " ", ".", " ", 
         RowBox[{"Transpose", "[", "B11", "]"}]}]}], ";", "\n", "  ", "\n", 
       "  ", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"sigmaeta", "//", "Print"}], ";"}], "*)"}], "\n", "  ", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"Imethod", "//", "Print"}], ";"}], " ", "*)"}], "\n", "  ", 
       "\n", "  ", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"Imethod", " ", "===", " ", "\"\<GH\>\""}], ",", " ", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"VALS", ",", " ", "WEIGHT"}], "}"}], " ", "=", " ", 
          RowBox[{"GaussHermitePointsMulti2", "[", 
           RowBox[{
           "m", ",", " ", "P", ",", " ", "eps", ",", " ", "ksigma", ",", " ", 
            "text"}], "]"}]}], ",", " ", 
         RowBox[{"(*", "GH", "*)"}], "\n", "   ", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"Imethod", " ", "===", " ", "\"\<UT\>\""}], ",", " ", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"VALS", ",", " ", "WEIGHT"}], "}"}], " ", "=", " ", 
             RowBox[{"SigmaSampleStand", "[", 
              RowBox[{"P", ",", " ", 
               RowBox[{"kappa", " ", "=", " ", "m"}]}], "]"}]}], ";"}]}], " ", 
          RowBox[{"(*", "UT", "*)"}], "\n", "    ", "]"}]}], "]"}], ";", "\n",
        "  ", "\n", "  ", 
       RowBox[{"(*", "\n", "  ", 
        RowBox[{
         RowBox[{"SeedRandom", "[", "SEED", "]"}], ";", "\n", "  ", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"VALS", ",", " ", "WEIGHT"}], "}"}], " ", "=", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"RandomReal", "[", 
             RowBox[{
              RowBox[{"NormalDistribution", "[", 
               RowBox[{"0", ",", "1"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"m", ",", "P"}], "}"}]}], "]"}], ",", 
            RowBox[{"Array", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1.", "/", "m"}], " ", "&"}], ",", "m"}], "]"}]}], 
           "}"}]}], ";"}], "\n", "  ", "*)"}], "\n", "  ", 
       RowBox[{"(*", "\n", "  ", 
        RowBox[{
         RowBox[{"SeedRandom", "[", "SEED", "]"}], ";", "\n", "  ", 
         RowBox[{"mp", "=", 
          RowBox[{"m", "^", "P"}]}], ";", "\n", "  ", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"VALS", ",", " ", "WEIGHT"}], "}"}], " ", "=", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Tuples", "[", 
             RowBox[{
              RowBox[{"RandomReal", "[", 
               RowBox[{
                RowBox[{"NormalDistribution", "[", 
                 RowBox[{"0", ",", "1"}], "]"}], ",", "m"}], "]"}], ",", 
              "P"}], "]"}], ",", 
            RowBox[{"Array", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"1.", "/", "mp"}], "&"}], ",", "mp"}], "]"}]}], 
           "}"}]}], ";"}], "\n", "  ", "*)"}], "\n", "  ", "\n", "  ", "\n", 
       "   ", 
       RowBox[{"n", " ", "=", " ", 
        RowBox[{"Length", "[", "Y", "]"}]}], ";", " ", "\n", "  ", 
       RowBox[{"lik", " ", "=", " ", 
        RowBox[{"{", "}"}]}], ";", " ", "\n", "  ", "\n", "   ", 
       RowBox[{"Do", "[", "\n", "   ", "\n", "   ", 
        RowBox[{
         RowBox[{
          RowBox[{"yn", " ", "=", " ", 
           RowBox[{"Y", "[", 
            RowBox[{"[", "nn", "]"}], "]"}]}], ";", " ", "\n", "   ", 
          RowBox[{"sel", " ", "=", " ", 
           RowBox[{"NotPosition", "[", 
            RowBox[{"yn", ",", " ", "miss"}], "]"}]}], ";", " ", "\n", "   ", 
          "\n", "   ", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"sel", " ", "==", " ", 
             RowBox[{"{", "}"}]}], ",", " ", 
            RowBox[{"l", " ", "=", " ", "0"}], ",", " ", "\n", "    ", "\n", 
            "    ", 
            RowBox[{"Which", "[", 
             RowBox[{
              RowBox[{"Singular", " ", "===", " ", "False"}], ",", " ", "\n", 
              "     ", "\n", "       ", 
              RowBox[{
               RowBox[{"xn", " ", "=", " ", 
                RowBox[{"X", "[", 
                 RowBox[{"[", "nn", "]"}], "]"}]}], ";", " ", "\n", "       ", 
               RowBox[{"mueeta", " ", "=", " ", 
                RowBox[{
                "B11", " ", ".", " ", "gamma", " ", ".", " ", "xn"}]}], ";", 
               " ", "\n", "       ", 
               RowBox[{"sigmaepsilonsel", " ", "=", " ", 
                RowBox[{"sigmaepsilon", "[", 
                 RowBox[{"[", 
                  RowBox[{"sel", ",", " ", "sel"}], "]"}], "]"}]}], ";", "\n",
                "       ", 
               RowBox[{"sigmaepsilonselI", " ", "=", " ", 
                RowBox[{"Inverse", "[", "sigmaepsilonsel", "]"}]}], ";", "\n",
                "     ", "\n", "     ", "\n", "     ", "\n", "     ", 
               RowBox[{"(*", " ", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Pseudo", "-", 
                   RowBox[{"Messmodell", " ", "y"}]}], "=", " ", 
                  RowBox[{"a", " ", "+", " ", 
                   RowBox[{"B", " ", 
                    RowBox[{"(", 
                    RowBox[{"eta", "-", "mueeta"}], ")"}]}], " ", "+", " ", 
                   "eps"}]}], ";", " ", 
                 RowBox[{
                  RowBox[{"eps", " ", "~", " ", "N"}], 
                  RowBox[{"(", 
                   RowBox[{"0", ",", "C"}], ")"}]}]}], "*)"}], "\n", "     ", 
               "\n", "     ", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"method", " ", "===", " ", "\"\<EKF\>\""}], ",", 
                 "\n", "      ", "\n", "      ", 
                 RowBox[{
                  RowBox[{"a", " ", "=", " ", 
                   RowBox[{"h", "[", 
                    RowBox[{"mueeta", ",", " ", "xn", ",", " ", "Theta"}], 
                    "]"}]}], ";", "  ", "\n", "      ", 
                  RowBox[{"B", " ", "=", " ", 
                   RowBox[{"dh", "[", 
                    RowBox[{"mueeta", ",", " ", "xn", ",", " ", "Theta"}], 
                    "]"}]}], ";", "\n", "      ", 
                  RowBox[{"C", " ", "=", " ", "sigmaepsilonsel"}], ";", 
                  "         ", "\n", "      ", 
                  RowBox[{"yeta", " ", "=", " ", 
                   RowBox[{"B", ".", "sigmaeta"}]}]}], "\n", "      ", "\n", 
                 "       ", ",", 
                 RowBox[{"(*", "else", "*)"}], "\n", "      ", "\n", 
                 "        ", 
                 RowBox[{
                  RowBox[{"vals", " ", "=", " ", 
                   RowBox[{"TrafoMueSigma", "[", 
                    RowBox[{"VALS", ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"mueeta", ",", " ", "sigmaeta"}], "}"}], ",", " ",
                     "0"}], "]"}]}], ";", "\n", "      ", "\n", "        ", 
                  RowBox[{"hl", " ", "=", " ", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"h", "[", 
                    RowBox[{"#1", ",", " ", "xn", ",", " ", "Theta"}], "]"}], 
                    "[", 
                    RowBox[{"[", "sel", "]"}], "]"}], " ", "&"}], " ", ")"}], 
                    " ", "/@", " ", "vals"}]}], ";", " ", "\n", "        ", 
                  RowBox[{"a", " ", "=", " ", 
                   RowBox[{"WEIGHT", " ", ".", " ", "hl"}]}], ";", "      ", 
                  RowBox[{"(*", 
                   RowBox[{"E", "[", "h", "]"}], "*)"}], "\n", "      ", "\n",
                   "        ", 
                  RowBox[{"yeta", " ", "=", " ", 
                   RowBox[{
                    RowBox[{"WEIGHT", " ", ".", " ", 
                    RowBox[{"MapThread", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Dyad", "[", 
                    RowBox[{"#1", ",", " ", "#2"}], "]"}], " ", "&"}], ",", 
                    " ", 
                    RowBox[{"{", 
                    RowBox[{"hl", ",", " ", "vals"}], "}"}]}], "]"}]}], " ", 
                    "-", " ", 
                    RowBox[{"Dyad", "[", 
                    RowBox[{"a", ",", " ", "mueeta"}], "]"}]}]}], ";", " ", 
                  "\n", "        ", 
                  RowBox[{"B", " ", "=", " ", 
                   RowBox[{"yeta", " ", ".", " ", 
                    RowBox[{"Inverse", "[", "sigmaeta", "]"}]}]}], ";", " ", 
                  "\n", "      ", "\n", "        ", 
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"method", " ", "===", " ", "\"\<NorKorr\>\""}], 
                    ",", "  ", "\n", "               ", 
                    RowBox[{
                    RowBox[{"hlhl", " ", "=", " ", 
                    RowBox[{"Dyad", " ", "/@", " ", "hl"}]}], ";", " ", "\n", 
                    "               ", 
                    RowBox[{"hh", " ", "=", " ", 
                    RowBox[{
                    RowBox[{"WEIGHT", " ", ".", " ", "hlhl"}], " ", "-", " ", 
                    
                    RowBox[{"Dyad", "[", "a", "]"}]}]}], ";", "\n", 
                    "               ", 
                    RowBox[{"etay", " ", "=", " ", 
                    RowBox[{"Transpose", "[", "yeta", "]"}]}], ";", "  ", 
                    "\n", "               ", 
                    RowBox[{"C", " ", "=", " ", 
                    RowBox[{
                    "hh", " ", "+", " ", "sigmaepsilonsel", " ", "-", " ", 
                    RowBox[{"B", ".", "etay"}]}]}]}], ",", " ", 
                    RowBox[{"(*", " ", 
                    RowBox[{"=", 
                    RowBox[{"Var0", " ", 
                    RowBox[{"(", 
                    RowBox[{"y", "|", "eta"}], ")"}]}]}], "*)"}], "\n", 
                    "       ", "\n", "        ", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"method", " ", "===", " ", "\"\<StochLin\>\""}], 
                    ",", " ", 
                    RowBox[{"C", " ", "=", " ", "sigmaepsilonsel"}]}], 
                    "]"}]}], "]"}], ";"}]}], " ", "\n", "      ", "\n", 
                "      ", "]"}], ";", "\n", "     ", "\n", "     ", 
               RowBox[{"(*", 
                RowBox[{
                 RowBox[{"Print", "[", 
                  RowBox[{"a", ",", "B", ",", "C"}], "]"}], ";"}], "*)"}], 
               "\n", "     ", "\n", "     ", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"support", " ", "===", " ", "Automatic"}], ",", " ", 
                 "\n", "          ", 
                 RowBox[{
                  RowBox[{"cfac", " ", "=", " ", 
                   RowBox[{
                    RowBox[{"Det", "[", 
                    RowBox[{"B", " ", ".", " ", "sigmaeta", " ", ".", " ", 
                    RowBox[{"Transpose", "[", "B", "]"}]}], "]"}], "/", 
                    RowBox[{"Det", "[", "C", "]"}]}]}], ";", "       ", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Print", "[", 
                    RowBox[{"\"\<cfac=\>\"", ",", " ", "#1"}], "]"}], " ", 
                    "&"}], " ", ")"}], "[", "cfac", "]"}], ";"}], "*)"}], 
                  "\n", "          ", 
                  RowBox[{"C", " ", "=", " ", 
                   RowBox[{"C", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Max", "[", 
                    RowBox[{
                    RowBox[{"cfac", " ", "-", " ", "10"}], ",", " ", "0"}], 
                    "]"}], " ", "+", " ", "1"}], ")"}]}]}], ";", " ", "\n", 
                  "          ", 
                  RowBox[{"cfac", " ", "=", " ", 
                   RowBox[{
                    RowBox[{"Det", "[", 
                    RowBox[{"B", " ", ".", " ", "sigmaeta", " ", ".", " ", 
                    RowBox[{"Transpose", "[", "B", "]"}]}], "]"}], "/", 
                    RowBox[{"Det", "[", "C", "]"}]}]}], ";"}], "       ", 
                 RowBox[{"(*", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Print", "[", 
                    RowBox[{"\"\<cfac=\>\"", ",", " ", "#1"}], "]"}], " ", 
                    "&"}], " ", ")"}], "[", "cfac", "]"}], "*)"}], ",", " ", 
                 "\n", "      ", "\n", "      ", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"support", " ", ">", " ", "0"}], ",", " ", 
                   RowBox[{"C", " ", "=", " ", 
                    RowBox[{"C", "*", "support"}]}]}], "]"}]}], "]"}], ";", 
               "\n", "     ", "\n", "     ", "\n", "       ", 
               RowBox[{"yy", " ", "=", " ", 
                RowBox[{
                 RowBox[{"B", ".", "sigmaeta", ".", 
                  RowBox[{"(", 
                   RowBox[{"B", " ", "//", " ", "Transpose"}], ")"}]}], " ", 
                 "+", " ", "C"}]}], ";", "     ", "\n", "       ", 
               RowBox[{"yyI", " ", "=", " ", 
                RowBox[{"Inverse", "[", "yy", "]"}]}], ";", " ", "\n", 
               "       ", 
               RowBox[{"ynsel", " ", "=", " ", 
                RowBox[{"yn", "[", 
                 RowBox[{"[", "sel", "]"}], "]"}]}], ";", " ", "\n", 
               "       ", 
               RowBox[{"nue", " ", "=", " ", 
                RowBox[{"ynsel", " ", "-", " ", "a"}]}], ";", "\n", "       ", 
               RowBox[{"l0", " ", "=", " ", 
                RowBox[{
                 RowBox[{"-", "0.5"}], "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Log", "[", 
                    RowBox[{"Det", "[", 
                    RowBox[{"const", "*", "yy"}], "]"}], "]"}], " ", "+", " ", 
                   RowBox[{
                   "nue", " ", ".", " ", "yyI", " ", ".", " ", "nue"}]}], 
                  ")"}]}]}], ";", "\n", "     ", "\n", "     ", "\n", 
               "      ", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"onlyNorKorr", " ", "===", " ", "1"}], ",", " ", 
                 RowBox[{"l1", " ", "=", " ", "0"}], ",", " ", "\n", "      ",
                  "\n", "      ", 
                 RowBox[{"(*", 
                  RowBox[{"else", " ", "Korrektur"}], " ", "*)"}], "  ", "\n",
                  "      ", "\n", "         ", 
                 RowBox[{
                  RowBox[{"gain", " ", "=", " ", 
                   RowBox[{"sigmaeta", ".", 
                    RowBox[{"(", 
                    RowBox[{"B", " ", "//", " ", "Transpose"}], ")"}], ".", 
                    "yyI"}]}], ";", "    ", 
                  RowBox[{"(*", " ", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"eta", ",", "eta"}], ")"}], " ", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"eta", ",", "eta"}], ")"}], "^", 
                    RowBox[{"-", "1"}]}], " ", 
                    RowBox[{"(", 
                    RowBox[{"eta", ",", "y"}], ")"}], " ", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"y", ",", "y"}], ")"}], "^", 
                    RowBox[{"-", "1"}]}]}], " ", "=", " ", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"eta", ",", "y"}], ")"}], " ", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"y", ",", "y"}], ")"}], "^", 
                    RowBox[{"-", "1"}]}]}]}], "*)"}], "\n", "         ", 
                  RowBox[{"E0etay", " ", "=", " ", 
                   RowBox[{"mueeta", " ", "+", " ", 
                    RowBox[{"gain", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{"ynsel", " ", "-", " ", "a"}], ")"}]}]}]}], ";", 
                  " ", "\n", "      ", "\n", "                        ", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{"V0etay", " ", "=", " ", 
                    RowBox[{"sigmaeta", " ", "-", " ", 
                    RowBox[{"gain", " ", ".", " ", "yeta"}]}]}], ";"}], "  ", 
                   "*)"}], "    ", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"V0etay", "//", "N"}], "//", "Print"}], ";"}], 
                   "*)"}], "\n", "      ", "\n", "        ", 
                  RowBox[{"(*", "Joseph", "*)"}], "\n", "         ", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"K", ",", " ", "P"}], "}"}], " ", "=", " ", 
                   RowBox[{"B", " ", "//", " ", "Dimensions"}]}], ";", "\n", 
                  "         ", 
                  RowBox[{"ikh", " ", "=", " ", 
                   RowBox[{
                    RowBox[{"IdentityMatrix", "[", "P", "]"}], " ", "-", " ", 
                    
                    RowBox[{"gain", ".", "B"}]}]}], ";", "\n", "         ", 
                  RowBox[{"V0etay", " ", "=", " ", 
                   RowBox[{
                    RowBox[{"ikh", ".", "sigmaeta", ".", 
                    RowBox[{"Transpose", "[", "ikh", "]"}]}], " ", "+", " ", 
                    RowBox[{"gain", ".", "C", ".", 
                    RowBox[{"Transpose", "[", "gain", "]"}]}]}]}], ";", 
                  "      ", "\n", "      ", "\n", "      ", 
                  RowBox[{"(*", "\n", "      ", 
                   RowBox[{
                    RowBox[{"gain", "//", "Print"}], ";", "\n", "      ", 
                    RowBox[{
                    RowBox[{"E0etay", "//", "N"}], "//", "Print"}], ";", "\n",
                     "      ", 
                    RowBox[{
                    RowBox[{"V0etay", "//", "N"}], "//", "Print"}], ";"}], 
                   "\n", "      ", "*)"}], "\n", "      ", "\n", "      ", 
                  "\n", "         ", 
                  RowBox[{"vals", " ", "=", " ", 
                   RowBox[{"TrafoMueSigma", "[", 
                    RowBox[{"VALS", ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"E0etay", ",", " ", "V0etay"}], "}"}], ",", " ", 
                    "0"}], "]"}]}], ";", " ", 
                  RowBox[{"(*", 
                   RowBox[{
                   "St\[UDoubleDot]tzstellen", " ", "aus", " ", "p0", " ", 
                    RowBox[{"(", 
                    RowBox[{"eta", "|", "y"}], ")"}]}], "*)"}], "\n", 
                  "      ", "\n", "      ", "\n", "      ", 
                  RowBox[{"(*", 
                   RowBox[{"p", " ", 
                    RowBox[{"(", 
                    RowBox[{"y", "|", "eta"}]}]}], "*)"}], "\n", 
                  "           ", 
                  RowBox[{"nue", " ", "=", " ", 
                   RowBox[{"Map", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"ynsel", " ", "-", " ", 
                    RowBox[{
                    RowBox[{"h", "[", 
                    RowBox[{"#", ",", " ", "xn", ",", " ", "Theta"}], "]"}], 
                    "[", 
                    RowBox[{"[", "sel", "]"}], "]"}]}], ")"}], " ", "&"}], 
                    ",", " ", "vals"}], "]"}]}], ";", " ", "\n", 
                  "           ", 
                  RowBox[{"zaehler", " ", "=", " ", 
                   RowBox[{"Map", "[", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    "#", ".", " ", "sigmaepsilonselI", " ", ".", " ", "#"}], 
                    " ", "&"}], " ", ")"}], " ", ",", " ", "nue"}], "]"}]}], 
                  ";", " ", "\n", "      ", "\n", "      ", 
                  RowBox[{"(*", 
                   RowBox[{"p0", " ", 
                    RowBox[{"(", 
                    RowBox[{"y", "|", "eta"}]}]}], "*)"}], "\n", 
                  "            ", 
                  RowBox[{"CI", " ", "=", " ", 
                   RowBox[{"C", " ", "//", " ", "Inverse"}]}], ";", "\n", 
                  "            ", 
                  RowBox[{"d", " ", "=", " ", 
                   RowBox[{"ynsel", " ", "-", " ", "a", " ", "+", " ", 
                    RowBox[{"B", ".", " ", "mueeta"}]}]}], ";", "\n", 
                  "            ", 
                  RowBox[{"nue", " ", "=", " ", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"d", " ", "-", " ", 
                    RowBox[{"B", " ", ".", " ", "#"}]}], ")"}], " ", "&"}], 
                    " ", "/@", " ", "vals"}]}], ";", " ", "\n", 
                  "            ", 
                  RowBox[{"nenner", " ", "=", " ", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"#", " ", ".", " ", "CI", " ", ".", " ", "#"}], 
                    " ", ")"}], " ", "&"}], " ", "/@", " ", "nue"}]}], ";", 
                  " ", "\n", "      ", "\n", "          ", 
                  RowBox[{"Jacobi", " ", "=", " ", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Det", "[", "sigmaepsilonselI", "]"}], "/", 
                    RowBox[{"Det", "[", "CI", "]"}]}], ")"}], "^", "0.5"}]}], 
                  ";", "\n", "          ", 
                  RowBox[{"LogJacobi", " ", "=", " ", 
                   RowBox[{".5", " ", 
                    RowBox[{"(", " ", 
                    RowBox[{
                    RowBox[{"Log", "[", 
                    RowBox[{"Det", "[", "sigmaepsilonselI", "]"}], "]"}], " ",
                     "-", " ", 
                    RowBox[{"Log", "[", 
                    RowBox[{"Det", "[", "CI", "]"}], "]"}]}], ")"}]}]}], ";", 
                  "\n", "          ", 
                  RowBox[{"Likratio", " ", "=", " ", 
                   RowBox[{"Exp", "[", 
                    RowBox[{
                    RowBox[{"-", ".5"}], " ", 
                    RowBox[{"(", 
                    RowBox[{"zaehler", " ", "-", " ", "nenner"}], ")"}]}], 
                    "]"}]}], ";", "\n", "          ", 
                  RowBox[{"l1", " ", "=", " ", 
                   RowBox[{"LogJacobi", " ", "+", " ", 
                    RowBox[{"Log", "[", 
                    RowBox[{"WEIGHT", " ", ".", "Likratio"}], "]"}]}]}], ";", 
                  "\n", "          ", "\n", "          ", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{"L1", " ", "=", " ", 
                    RowBox[{"Jacobi", " ", 
                    RowBox[{"(", 
                    RowBox[{"WEIGHT", " ", ".", "Likratio"}], ")"}]}]}], 
                    ";"}], "*)"}], "\n", "          ", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{"l1", " ", "=", " ", 
                    RowBox[{"Log", "[", "L1", "]"}]}], ";", 
                    RowBox[{"l1", "//", "Print"}], ";"}], "*)"}], "\n", 
                  "          ", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{"l1", "//", "Print"}], ";"}], "*)"}], "\n", 
                  "          ", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"Jacobi", "*", "Likratio"}], "//", "Max"}], "//", 
                    "Print"}], ";"}], "*)"}], "\n", "          ", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{"Jacobi", "//", "Print"}], ";"}], "*)"}], "\n", 
                  "          ", "\n", "      ", "\n", "      ", 
                  StyleBox[
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"pp", " ", ">", " ", "0"}], ",", " ", "\n", 
                    "                      ", 
                    RowBox[{
                    RowBox[{"p1", " ", "=", " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Det", "[", 
                    RowBox[{"sigmaepsilonselI", "/", "const"}], "]"}], "^", 
                    "0.5"}], "   ", 
                    RowBox[{"Exp", "[", 
                    RowBox[{
                    RowBox[{"-", ".5"}], " ", "zaehler"}], "]"}]}]}], ";", 
                    " ", "\n", "                      ", 
                    RowBox[{"p2", " ", "=", " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Det", "[", 
                    RowBox[{"CI", "/", "const"}], "]"}], "^", "0.5"}], "   ", 
                    
                    RowBox[{"Exp", "[", 
                    RowBox[{
                    RowBox[{"-", ".5"}], " ", "nenner"}], "]"}]}]}], ";", " ",
                     "\n", "       ", "\n", "                      ", 
                    RowBox[{"p1max", " ", "=", " ", 
                    RowBox[{"p1", " ", "//", " ", "Max"}]}], ";", "\n", 
                    "                      ", 
                    RowBox[{"p2max", " ", "=", " ", 
                    RowBox[{"p2", " ", "//", " ", "Max"}]}], ";", "\n", 
                    "                      ", 
                    RowBox[{"wmax", " ", "=", " ", 
                    RowBox[{"WEIGHT", " ", "//", " ", "Max"}]}], ";", "\n", 
                    "                      ", 
                    RowBox[{"maxx", " ", "=", " ", 
                    RowBox[{"Max", "[", 
                    RowBox[{"p1max", ",", " ", "p2max"}], "]"}]}], ";", "\n", 
                    "                      ", "\n", "                     ", 
                    RowBox[{"plr1", " ", "=", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "3"}], ",", " ", "3"}], "}"}]}], ";", "\n", 
                    "                     ", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    "scaling", ",", "\n", "                          ", 
                    RowBox[{"plr", " ", "=", " ", 
                    RowBox[{"{", 
                    RowBox[{"plr1", ",", " ", 
                    RowBox[{"plr2", " ", "=", " ", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", " ", "1.1"}], "}"}]}]}], "}"}]}], ",", 
                    "\n", "                             ", "\n", 
                    "                          ", 
                    RowBox[{
                    RowBox[{"plr", " ", "=", " ", 
                    RowBox[{"{", 
                    RowBox[{"plr1", ",", " ", 
                    RowBox[{"plr2", " ", "=", " ", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", " ", 
                    RowBox[{"maxx", " ", "2"}]}], "}"}]}]}], "}"}]}], ";", 
                    "\n", "                          ", 
                    RowBox[{"p1max", " ", "=", " ", 
                    RowBox[{"p2max", " ", "=", " ", 
                    RowBox[{"wmax", " ", "=", " ", "1"}]}]}]}]}], "\n", 
                    "                   ", "]"}], ";", "\n", "       ", "\n", 
                    "       ", 
                    RowBox[{"(*", "\n", "       ", 
                    RowBox[{
                    RowBox[{"sigmaepsilonsel", "//", "Print"}], ";", "\n", 
                    "       ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"h", "[", 
                    RowBox[{
                    RowBox[{"{", "2", "}"}], ",", " ", "xn", ",", " ", 
                    "Theta"}], "]"}], "[", 
                    RowBox[{"[", "sel", "]"}], "]"}], "//", "Print"}], ";", 
                    "\n", "       ", 
                    RowBox[{"ynsel", "//", "Print"}], ";"}], "\n", "       ", 
                    "*)"}], "\n", "                      ", 
                    RowBox[{"p1", " ", "=", " ", 
                    RowBox[{"p1", "/", "p1max"}]}], ";", "\n", 
                    "                      ", 
                    RowBox[{"p2", " ", "=", " ", 
                    RowBox[{"p2", "/", "p2max"}]}], ";", "\n", 
                    "                      ", 
                    RowBox[{"WEIGHT", " ", "=", " ", 
                    RowBox[{"WEIGHT", "/", "wmax"}]}], ";", "\n", 
                    "                      ", 
                    RowBox[{"p1f", " ", "=", " ", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"GaussDichte", "[", 
                    RowBox[{"ynsel", ",", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"h", "[", 
                    RowBox[{"#", ",", " ", "xn", ",", " ", "Theta"}], "]"}], 
                    "[", 
                    RowBox[{"[", "sel", "]"}], "]"}], ",", " ", 
                    "sigmaepsilonsel"}], "}"}]}], "]"}], "/", "p1max"}], 
                    ")"}], " ", "&"}]}], ";", "\n", "                      ", 
                    
                    RowBox[{"p2f", " ", "=", " ", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"GaussDichte", "[", 
                    RowBox[{"d", ",", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"B", ".", "#"}], ",", " ", "C"}], "}"}]}], "]"}], 
                    "/", "p2max"}], ")"}], " ", "&"}]}], ";", "\n", 
                    "                      ", 
                    RowBox[{"p0etay", " ", "=", " ", 
                    RowBox[{
                    RowBox[{"GaussDichte", "[", 
                    RowBox[{"#", ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"E0etay", ",", " ", "V0etay"}], "}"}]}], "]"}], 
                    " ", "&"}]}], ";", "\n", "       ", "\n", 
                    "                      ", 
                    RowBox[{"g1", " ", "=", " ", 
                    RowBox[{"plot1", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"vals", "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", " ", "pp"}], "]"}], "]"}], ",", " ", 
                    RowBox[{"Jacobi", "*", "Likratio"}], ",", " ", "WEIGHT"}],
                     "}"}], " ", "//", " ", "Transpose"}], ",", " ", "\n", 
                    "                                ", 
                    RowBox[{"PlotJoined", " ", "->", " ", "False"}], ",", " ", 
                    RowBox[{"GridLines", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"ynsel", "[", 
                    RowBox[{"[", "pp", "]"}], "]"}], "}"}], ",", " ", 
                    RowBox[{"{", "1", "}"}]}], "}"}]}], ",", " ", 
                    RowBox[{"dicke", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{".03", ",", " ", ".01"}], "}"}]}], ",", " ", 
                    RowBox[{"PlotRange", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{"plr1", ",", " ", "All"}], "}"}]}]}], "]"}]}], 
                    ";", "\n", "       ", "\n", "                      ", 
                    RowBox[{"g2", " ", "=", " ", 
                    RowBox[{"plot1", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"vals", "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", " ", "pp"}], "]"}], "]"}], ",", " ", 
                    "WEIGHT", ",", " ", "p1", ",", " ", "p2"}], "}"}], " ", "//",
                     " ", "Transpose"}], ",", " ", "\n", 
                    "                                                  ", 
                    RowBox[{"PlotJoined", " ", "->", " ", "False"}], ",", " ", 
                    RowBox[{"GridLines", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"ynsel", "[", 
                    RowBox[{"[", "pp", "]"}], "]"}], "}"}], ",", " ", 
                    "None"}], "}"}]}], ",", " ", 
                    RowBox[{"dicke", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{".03", ",", " ", ".02", ",", " ", ".015"}], 
                    "}"}]}], ",", "\n", 
                    "                                                    ", 
                    RowBox[{"color", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", " ", "3", ",", " ", "4"}], "}"}]}], ",",
                     " ", 
                    RowBox[{"PlotRange", " ", "->", " ", "plr"}], ",", " ", 
                    RowBox[{"PlotPoints", " ", "->", " ", "5"}]}], "]"}]}], 
                    ";", "\n", "       ", "\n", "                      ", 
                    RowBox[{"arg", " ", "=", " ", 
                    RowBox[{"Tuples", "[", 
                    RowBox[{
                    RowBox[{"Range", "[", 
                    RowBox[{
                    RowBox[{"-", "2"}], ",", " ", "2", ",", " ", "1"}], "]"}],
                     ",", " ", "P"}], "]"}]}], ";", "\n", 
                    "                                       ", 
                    RowBox[{
                    RowBox[{"arg", "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", " ", "pp"}], "]"}], "]"}], " ", "=", 
                    " ", "x"}], ";", " ", "\n", "                      ", 
                    RowBox[{"pl", " ", "=", " ", 
                    RowBox[{
                    RowBox[{"Plot", "[", 
                    RowBox[{
                    RowBox[{"{", " ", 
                    RowBox[{
                    RowBox[{"p1f", "[", "#", "]"}], ",", " ", 
                    RowBox[{"p2f", "[", "#", "]"}], ",", " ", "0", ",", " ", 
                    RowBox[{"p0etay", "[", "#", "]"}]}], "}"}], ",", " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"x", ",", " ", "plr1"}], "}"}], " ", "//", " ", 
                    "Flatten"}], " ", "//", " ", "Evaluate"}], ",", " ", "\n",
                     "                              ", 
                    RowBox[{"GridLines", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ynsel", "[", 
                    RowBox[{"[", "pp", "]"}], "]"}], ",", " ", 
                    RowBox[{"mueeta", "[", 
                    RowBox[{"[", "pp", "]"}], "]"}], ",", " ", 
                    RowBox[{"E0etay", "[", 
                    RowBox[{"[", "pp", "]"}], "]"}]}], "}"}], ",", " ", 
                    "None"}], "}"}]}], ",", "\n", 
                    "                               ", 
                    RowBox[{
                    "PerformanceGoal", " ", "->", " ", "\"\<Speed\>\""}], ",",
                     " ", 
                    RowBox[{"PlotRange", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{"plr1", ",", " ", "All"}], "}"}]}]}], "]"}], " ", 
                    "&"}]}], ";", "\n", "       ", "\n", 
                    "                      ", 
                    RowBox[{"g3", " ", "=", " ", 
                    RowBox[{
                    RowBox[{"Map", "[", 
                    RowBox[{"pl", ",", " ", "arg"}], "]"}], " ", "//", " ", 
                    "Show"}]}], ";", "\n", "       ", "\n", "       \t", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"P", " ", "==", " ", "2"}], ",", " ", 
                    RowBox[{
                    RowBox[{"g4", " ", "=", " ", 
                    RowBox[{"ContourPlot", "[", " ", 
                    RowBox[{
                    RowBox[{"p1f", "[", 
                    RowBox[{"{", 
                    RowBox[{"x", ",", " ", "y"}], "}"}], "]"}], ",", 
                    "        ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"x", ",", " ", "plr1"}], "}"}], " ", "//", " ", 
                    "Flatten"}], " ", "//", " ", "Evaluate"}], ",", " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"y", ",", " ", "plr1"}], "}"}], " ", "//", " ", 
                    "Flatten"}], " ", "//", " ", "Evaluate"}], ",", " ", 
                    RowBox[{"ColorFunction", " ", "->", " ", 
                    RowBox[{"ColorData", "[", "\"\<SolarColors\>\"", "]"}]}], 
                    ",", " ", 
                    RowBox[{"PlotRange", " ", "->", " ", "All"}]}], "]"}]}], 
                    ";", "\n", "                   ", 
                    RowBox[{"g5", " ", "=", " ", 
                    RowBox[{"ContourPlot", "[", " ", 
                    RowBox[{
                    RowBox[{"p2f", "[", 
                    RowBox[{"{", 
                    RowBox[{"x", ",", " ", "y"}], "}"}], "]"}], ",", 
                    "        ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"x", ",", " ", "plr1"}], "}"}], " ", "//", " ", 
                    "Flatten"}], " ", "//", " ", "Evaluate"}], ",", " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"y", ",", " ", "plr1"}], "}"}], " ", "//", " ", 
                    "Flatten"}], " ", "//", " ", "Evaluate"}], ",", " ", 
                    RowBox[{"ColorFunction", " ", "->", " ", 
                    RowBox[{"ColorData", "[", "\"\<SiennaTones\>\"", "]"}]}], 
                    ",", " ", 
                    RowBox[{"PlotRange", " ", "->", " ", "All"}]}], "]"}]}], 
                    ";", "\n", "                   ", 
                    RowBox[{"g6", " ", "=", " ", 
                    RowBox[{"ContourPlot", "[", " ", 
                    RowBox[{
                    RowBox[{"p0etay", "[", 
                    RowBox[{"{", 
                    RowBox[{"x", ",", " ", "y"}], "}"}], "]"}], ",", " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"x", ",", " ", "plr1"}], "}"}], " ", "//", " ", 
                    "Flatten"}], " ", "//", " ", "Evaluate"}], ",", " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"y", ",", " ", "plr1"}], "}"}], " ", "//", " ", 
                    "Flatten"}], " ", "//", " ", "Evaluate"}], ",", " ", 
                    RowBox[{"ColorFunction", " ", "->", " ", 
                    RowBox[{
                    "ColorData", "[", "\"\<AvocadoColors\>\"", "]"}]}], ",", 
                    " ", 
                    RowBox[{"PlotRange", " ", "->", " ", "All"}]}], 
                    "]"}]}]}]}], "\n", "                ", "]"}], ";", "\n", 
                    "       ", "\n", "              ", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"P", " ", "==", " ", "2"}], ",", " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    "g1", ",", " ", "g2", ",", " ", "g3", ",", " ", "g4", ",",
                     " ", "g5", ",", " ", "g6"}], "}"}], " ", "//", " ", 
                    "GraphicsRow"}], " ", "//", " ", "Print"}], ",", " ", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"g1", ",", " ", "g2", ",", " ", "g3"}], "}"}], 
                    " ", "//", " ", "GraphicsRow"}], " ", "//", " ", 
                    "Print"}]}], "]"}], ";"}]}], "\n", 
                    "                           ", "\n", 
                    "                           ", "\n", "          ", "]"}],
                   FontColor->RGBColor[0, 0, 1]], 
                  StyleBox[";",
                   FontColor->RGBColor[0, 0, 1]]}]}], 
                StyleBox["\n",
                 FontColor->RGBColor[0, 0, 1]], 
                StyleBox["      ",
                 FontColor->RGBColor[0, 0, 1]], "\n", "      ", "\n", 
                "      ", "\n", "      ", "\n", "      ", "]"}]}]}], "]"}]}], 
           "]"}], ";", "\n", "   ", "\n", "   ", "\n", "   ", "\n", "   ", 
          "\n", "   ", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"yn", ",", "l0", ",", "l1"}], "}"}], "//", "Print"}], 
            ";"}], "*)"}], "\n", "   ", 
          RowBox[{"l1", " ", "=", " ", 
           RowBox[{"l1", " ", "/.", " ", 
            RowBox[{"{", 
             RowBox[{"Indeterminate", " ", "->", " ", "0"}], "}"}]}]}], ";", 
          "\n", "   ", 
          RowBox[{"l", " ", "=", " ", 
           RowBox[{"l0", " ", "+", " ", "l1"}]}], ";", " ", "\n", "   ", 
          RowBox[{"lik", " ", "=", " ", 
           RowBox[{"Append", "[", 
            RowBox[{"lik", ",", " ", "l"}], "]"}]}], ";"}], "\n", "   ", "\n",
          "    ", ",", " ", 
         RowBox[{"{", 
          RowBox[{"nn", ",", " ", "n"}], "}"}]}], "]"}], ";", " ", "\n", "  ",
        "\n", "      ", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"option", " ", "==", " ", "5"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Plus", " ", "@@", " ", "lik"}], ",", " ", "lik"}], "}"}], 
         ",", " ", 
         RowBox[{"Plus", " ", "@@", " ", "lik"}]}], "]"}]}]}], "\n", "  ", 
     "]"}]}]}]}]], "Code",
 PageWidth->Infinity,
 CellMargins->{{18.625, 10.}, {0., 10.}},
 InitializationCell->True,
 CellChangeTimes->{{3.460194284551586*^9, 3.460194430512322*^9}, {
   3.4601944628027267`*^9, 3.460194639371933*^9}, {3.460194707706352*^9, 
   3.4601947269782743`*^9}, {3.460194787282988*^9, 3.4601947879591217`*^9}, {
   3.460195583412208*^9, 3.460195677267837*^9}, {3.460195730531335*^9, 
   3.4601957347363777`*^9}, {3.4601977253341637`*^9, 
   3.4601977303712597`*^9}, {3.460199977089291*^9, 3.460199982306014*^9}, {
   3.4602001100007153`*^9, 3.4602001365337563`*^9}, {3.4602001838757668`*^9, 
   3.46020021505055*^9}, {3.46020039918268*^9, 3.46020043709068*^9}, {
   3.460200544282135*^9, 3.460200546288165*^9}, 3.460200959618925*^9, {
   3.46026324513008*^9, 3.460263282755694*^9}, {3.4602633380999613`*^9, 
   3.4602633493534527`*^9}, {3.460263400721909*^9, 3.460263415929566*^9}, {
   3.460263454575968*^9, 3.4602634803271923`*^9}, {3.460263596468174*^9, 
   3.460263712913571*^9}, {3.460264149260456*^9, 3.460264306447337*^9}, {
   3.460264339903819*^9, 3.460264344426856*^9}, {3.4602643774296494`*^9, 
   3.460264747632288*^9}, {3.460264778447598*^9, 3.460264783659968*^9}, {
   3.460265503837646*^9, 3.460265516171212*^9}, {3.460265587432678*^9, 
   3.460265590909531*^9}, {3.460265773917304*^9, 3.4602657740295877`*^9}, {
   3.460265809524905*^9, 3.460265937981409*^9}, {3.4602659990577393`*^9, 
   3.460266097141539*^9}, {3.460266166568413*^9, 3.460266209126886*^9}, {
   3.460266250084037*^9, 3.4602662808402967`*^9}, {3.460266339683448*^9, 
   3.460266426663334*^9}, {3.460266497330805*^9, 3.4602665255713882`*^9}, {
   3.4602665962854033`*^9, 3.460266599621019*^9}, {3.4602666981599493`*^9, 
   3.460266745666133*^9}, {3.4602668309241867`*^9, 3.460266885864461*^9}, {
   3.4602669348160353`*^9, 3.460266996301594*^9}, {3.460267038525139*^9, 
   3.4602670405577307`*^9}, {3.460267080242529*^9, 3.4602671269901857`*^9}, {
   3.4602671603427677`*^9, 3.460267254900002*^9}, {3.460267290349532*^9, 
   3.460267311072433*^9}, {3.460267360591495*^9, 3.4602673854606743`*^9}, {
   3.46026741568622*^9, 3.460267493972913*^9}, 3.460267531325343*^9, {
   3.460267657409995*^9, 3.460267687307645*^9}, {3.460267744356736*^9, 
   3.460267792177703*^9}, {3.460267867265236*^9, 3.460267951190172*^9}, {
   3.460268008054109*^9, 3.4602682257600193`*^9}, {3.4602682707145157`*^9, 
   3.460268383589704*^9}, {3.4602684145136213`*^9, 3.4602684234894333`*^9}, {
   3.460268495772295*^9, 3.460268548380769*^9}, {3.460268585324235*^9, 
   3.460268588068144*^9}, {3.460268722529909*^9, 3.4602687808529863`*^9}, {
   3.460268847343011*^9, 3.4602688643424892`*^9}, {3.460268906843392*^9, 
   3.4602690975890217`*^9}, {3.460269137274601*^9, 3.460269351221425*^9}, {
   3.460269595751025*^9, 3.460269628454479*^9}, {3.4602696598838882`*^9, 
   3.460269679514669*^9}, {3.460269723422311*^9, 3.460269755767868*^9}, {
   3.460269879713437*^9, 3.460269923345128*^9}, {3.46027001591717*^9, 
   3.460270024031649*^9}, 3.46027010485046*^9, {3.460270149953143*^9, 
   3.4602702537187767`*^9}, {3.4602702846349297`*^9, 3.46027029514499*^9}, 
   3.460270346891515*^9, 3.460270607274858*^9, {3.4602708505804453`*^9, 
   3.460270862797477*^9}, 3.4602710337362003`*^9, {3.460271102575704*^9, 
   3.460271108328334*^9}, {3.460271156184857*^9, 3.4602711590022993`*^9}, {
   3.46027123095223*^9, 3.460271270598349*^9}, {3.460271302970233*^9, 
   3.4602713202526827`*^9}, 3.460271477470911*^9, {3.460273080051744*^9, 
   3.46027308520679*^9}, {3.4602731161468687`*^9, 3.460273141336913*^9}, {
   3.460273653624395*^9, 3.46027366118076*^9}, 3.4602760224893513`*^9, {
   3.460276063965891*^9, 3.46027607080488*^9}, {3.460276134568684*^9, 
   3.460276135994856*^9}, {3.460277295287301*^9, 3.460277326831636*^9}, {
   3.4602773608967543`*^9, 3.460277367275772*^9}, {3.460279569593549*^9, 
   3.460279618455995*^9}, {3.4602796591590967`*^9, 3.460279676488124*^9}, {
   3.4602797108870907`*^9, 3.460279763057753*^9}, {3.46027987202001*^9, 
   3.460279929326695*^9}, {3.460279967324646*^9, 3.46027997674712*^9}, {
   3.460282349939086*^9, 3.4602823549144163`*^9}, {3.460282784722953*^9, 
   3.460282801190708*^9}, {3.460282835222114*^9, 3.460283098220755*^9}, {
   3.4602831366017437`*^9, 3.46028316523487*^9}, {3.460284499977572*^9, 
   3.4602846111225557`*^9}, {3.460284647887047*^9, 3.460284660037141*^9}, {
   3.460284706170504*^9, 3.460284707028002*^9}, {3.460284826503705*^9, 
   3.460284868358535*^9}, {3.460284916695053*^9, 3.460284961298512*^9}, {
   3.460285127766464*^9, 3.460285132950951*^9}, {3.460285226420979*^9, 
   3.4602852820574627`*^9}, {3.460285317086361*^9, 3.460285318206476*^9}, {
   3.4602854642893744`*^9, 3.460285482471323*^9}, {3.4602855234027843`*^9, 
   3.4602855440981197`*^9}, {3.4602857779503307`*^9, 
   3.4602857819794283`*^9}, {3.460285817792054*^9, 3.4602858207826433`*^9}, {
   3.4602859174667187`*^9, 3.460285930023323*^9}, 3.460342692301155*^9, {
   3.460342777814019*^9, 3.46034278769788*^9}, {3.4603433422695503`*^9, 
   3.460343349850721*^9}, {3.460343396242371*^9, 3.460343484730915*^9}, {
   3.4603436369330587`*^9, 3.4603439074483213`*^9}, {3.460343972471846*^9, 
   3.4603440498963337`*^9}, {3.460344227510378*^9, 3.460344265735627*^9}, {
   3.4603444047070417`*^9, 3.460344534150508*^9}, {3.4603445912321587`*^9, 
   3.460344784896298*^9}, {3.460344921653266*^9, 3.460344974081581*^9}, {
   3.4603451096385717`*^9, 3.46034520251552*^9}, 3.460345246115415*^9, 
   3.4603453567706003`*^9, {3.4603454172412558`*^9, 3.460345447428486*^9}, {
   3.46034549581929*^9, 3.4603455420148697`*^9}, 3.4603455735194817`*^9, {
   3.460364040779513*^9, 3.460364070906877*^9}, {3.460364114400744*^9, 
   3.460364118558858*^9}, {3.460364167066555*^9, 3.460364175124312*^9}, {
   3.460364210010396*^9, 3.460364240151005*^9}, {3.460364322034679*^9, 
   3.4603644028696136`*^9}, {3.460364789547168*^9, 3.460364791139002*^9}, {
   3.460364839217485*^9, 3.460364955498816*^9}, {3.460365024686344*^9, 
   3.4603650444987183`*^9}, {3.460365078184608*^9, 3.460365085863439*^9}, {
   3.460365172070264*^9, 3.460365237129417*^9}, {3.460365305570582*^9, 
   3.4603653112242393`*^9}, {3.460365389295981*^9, 3.460365401230237*^9}, {
   3.460365659465868*^9, 3.460365673436064*^9}, {3.4603657435143757`*^9, 
   3.460365779346396*^9}, {3.460365810556965*^9, 3.460365812812614*^9}, {
   3.4603658931474333`*^9, 3.460365963229039*^9}, {3.460366042607856*^9, 
   3.4603662381997623`*^9}, {3.460366298650962*^9, 3.4603664489586897`*^9}, {
   3.460366479298209*^9, 3.460366481733535*^9}, {3.460366720220016*^9, 
   3.460366755444069*^9}, {3.460366809463408*^9, 3.460366835407606*^9}, {
   3.460366869300931*^9, 3.4603668837833767`*^9}, {3.460366939043384*^9, 
   3.460367079108756*^9}, {3.460368677725768*^9, 3.460368783406201*^9}, {
   3.460368825195459*^9, 3.460368856802374*^9}, {3.460368902769106*^9, 
   3.460368936787517*^9}, {3.4603689842944307`*^9, 3.460369207328513*^9}, {
   3.460369284729682*^9, 3.4603693343688183`*^9}, {3.460369420816362*^9, 
   3.4603694798800898`*^9}, {3.460377341544571*^9, 3.460377345834638*^9}, {
   3.46037755503498*^9, 3.460377575443983*^9}, {3.460377710414733*^9, 
   3.460377713134892*^9}, {3.460377786961791*^9, 3.46037779106026*^9}, {
   3.460377997641603*^9, 3.46037802596364*^9}, {3.460378073076664*^9, 
   3.460378121436631*^9}, {3.460427568908971*^9, 3.4604276019906387`*^9}, {
   3.4604276609737883`*^9, 3.460427727018682*^9}, {3.460427776818137*^9, 
   3.460427804953367*^9}, {3.460427861256394*^9, 3.460427888546273*^9}, 
   3.460427929325029*^9, {3.460428073272511*^9, 3.4604281497189293`*^9}, {
   3.4604283568000803`*^9, 3.460428416009344*^9}, {3.460428471757371*^9, 
   3.460428618754621*^9}, {3.460428658779772*^9, 3.460428687329473*^9}, {
   3.4604300698451*^9, 3.460430167368123*^9}, {3.460430296224434*^9, 
   3.460430299850492*^9}, {3.4604305314745417`*^9, 3.4604305352701674`*^9}, 
   3.460430672923388*^9, {3.460430752456835*^9, 3.4604308005481033`*^9}, {
   3.460430838727722*^9, 3.4604308611128197`*^9}, {3.4604309019783993`*^9, 
   3.460431023365191*^9}, {3.460431060814273*^9, 3.4604311187056932`*^9}, {
   3.460431174572468*^9, 3.460431175078052*^9}, {3.4604312571954393`*^9, 
   3.4604312908437757`*^9}, {3.460431334200604*^9, 3.460431354340418*^9}, 
   3.4604314133729877`*^9, {3.460431525033979*^9, 3.460431526840539*^9}, {
   3.4604315895139217`*^9, 3.4604316489357357`*^9}, {3.4604316870424232`*^9, 
   3.460431722479638*^9}, {3.4604320819508123`*^9, 3.4604320820774717`*^9}, {
   3.460432146508539*^9, 3.4604322090097933`*^9}, 3.460432320851774*^9, {
   3.4604323828474483`*^9, 3.4604323856411963`*^9}, {3.4604326356353693`*^9, 
   3.460432637991989*^9}, {3.460432710583696*^9, 3.460432731696748*^9}, {
   3.460432767119719*^9, 3.46043278989487*^9}, {3.460433211747725*^9, 
   3.4604332792568808`*^9}, {3.460433448528161*^9, 3.460433466889031*^9}, {
   3.46043352436405*^9, 3.460433524673403*^9}, {3.4604335971021957`*^9, 
   3.46043361413586*^9}, {3.460433697499262*^9, 3.460433700202601*^9}, {
   3.460433739251953*^9, 3.460433741769038*^9}, {3.460433823126432*^9, 
   3.460433830120185*^9}, {3.4604339637144127`*^9, 3.460433977194812*^9}, 
   3.460434156275477*^9, {3.460434200817587*^9, 3.460434203694149*^9}, {
   3.460434284200204*^9, 3.460434334383589*^9}, {3.460434411272003*^9, 
   3.460434418785829*^9}, {3.460434699932282*^9, 3.46043471210847*^9}, {
   3.4604350568371487`*^9, 3.460435059159986*^9}, {3.460435444123107*^9, 
   3.460435499198696*^9}, {3.460436322381576*^9, 3.4604363546464043`*^9}, {
   3.460436386720928*^9, 3.460436477218676*^9}, {3.460436510520681*^9, 
   3.4604365130893087`*^9}, {3.460436584450457*^9, 3.460436586965917*^9}, {
   3.460436617200162*^9, 3.460436651185149*^9}, {3.46043672713341*^9, 
   3.460436731480103*^9}, {3.460436815657415*^9, 3.4604368580390882`*^9}, {
   3.4604369409210167`*^9, 3.4604370018329*^9}, {3.460437173698595*^9, 
   3.460437174527001*^9}, {3.460437233762413*^9, 3.4604372394688683`*^9}, {
   3.460437601033867*^9, 3.460437602519586*^9}, {3.460439417446375*^9, 
   3.460439434720812*^9}, {3.460440155176543*^9, 3.4604401600175133`*^9}, {
   3.460440791386387*^9, 3.4604408120184317`*^9}, {3.460441700186659*^9, 
   3.460441740555923*^9}, {3.4604420069130917`*^9, 3.460442010992319*^9}, {
   3.460442144519423*^9, 3.46044225362346*^9}, {3.460442314187484*^9, 
   3.4604423161112623`*^9}, {3.460442389730761*^9, 3.460442392545186*^9}, {
   3.460442430271729*^9, 3.460442463917342*^9}, {3.460443384306439*^9, 
   3.460443424044107*^9}, {3.4604437315416613`*^9, 3.4604438446749907`*^9}, {
   3.4604439099863358`*^9, 3.46044391364188*^9}, {3.460444082444788*^9, 
   3.460444082989586*^9}, {3.4604441371682997`*^9, 3.460444175109687*^9}, {
   3.460444256094357*^9, 3.460444256298544*^9}, {3.460444378533813*^9, 
   3.460444381855053*^9}, {3.460444493261649*^9, 3.460444538256547*^9}, {
   3.4604446066262627`*^9, 3.4604446090534687`*^9}, {3.460459166692512*^9, 
   3.460459176714656*^9}, {3.4604592214880657`*^9, 3.460459223001932*^9}, {
   3.460459272658309*^9, 3.460459276245063*^9}, {3.460459348854416*^9, 
   3.460459372461773*^9}, {3.4604595076583843`*^9, 3.4604595174356117`*^9}, {
   3.460459578566516*^9, 3.4604596854236794`*^9}, {3.4604597566520967`*^9, 
   3.460459799473901*^9}, {3.460459873676238*^9, 3.460459893682722*^9}, {
   3.460460174963009*^9, 3.4604602051359*^9}, {3.460460463327959*^9, 
   3.4604604847735147`*^9}, {3.46046051506664*^9, 3.4604605203863497`*^9}, {
   3.460460727701488*^9, 3.460460728541339*^9}, {3.460460878375305*^9, 
   3.460460881382044*^9}, {3.460460924553576*^9, 3.460460989950562*^9}, {
   3.460461038207076*^9, 3.4604610731542253`*^9}, {3.460461116482016*^9, 
   3.4604611309531727`*^9}, {3.460461182415584*^9, 3.460461205008712*^9}, {
   3.460461237842492*^9, 3.460461365974218*^9}, {3.460461571255657*^9, 
   3.4604615713747272`*^9}, {3.460461638283538*^9, 3.460461655743291*^9}, {
   3.460461915290369*^9, 3.4604619309454193`*^9}, {3.460548158364236*^9, 
   3.460548163899393*^9}, {3.4605481948153667`*^9, 3.4605482170919323`*^9}, {
   3.4605485337654467`*^9, 3.4605485338731127`*^9}, {3.460548573233035*^9, 
   3.460548631455434*^9}, {3.460548722629752*^9, 3.460548726493541*^9}, {
   3.460548845714376*^9, 3.4605489613039417`*^9}, {3.4605491427510138`*^9, 
   3.4605491461841297`*^9}, {3.460549285260687*^9, 3.460549298510705*^9}, {
   3.460549372484283*^9, 3.460549493794971*^9}, {3.460549575472906*^9, 
   3.460549575593913*^9}, {3.460549649041542*^9, 3.4605496491732264`*^9}, {
   3.4606073994265413`*^9, 3.460607524636485*^9}, {3.4606078256198883`*^9, 
   3.460607830348865*^9}, {3.4606078823236933`*^9, 3.460607895384727*^9}, {
   3.460608547052947*^9, 3.4606085517376947`*^9}, {3.460619888298315*^9, 
   3.46061989144197*^9}, {3.460620067287648*^9, 3.460620152924345*^9}, {
   3.4606201920007677`*^9, 3.4606202070602617`*^9}, {3.46062028575213*^9, 
   3.460620291792*^9}, {3.4606208857295628`*^9, 3.460620903157618*^9}, {
   3.4606209541126738`*^9, 3.460621015785594*^9}, {3.460621100675983*^9, 
   3.4606211028466454`*^9}, {3.460621483726631*^9, 3.4606214953703747`*^9}, {
   3.460621729374908*^9, 3.460621729500869*^9}, {3.460621815045868*^9, 
   3.460621815185301*^9}, {3.4606218617849827`*^9, 3.460621870561606*^9}, {
   3.4606219520404797`*^9, 3.460621962354082*^9}, {3.460687641624383*^9, 
   3.4606877727533627`*^9}, {3.460690245463594*^9, 3.460690259532189*^9}, {
   3.4606903207737837`*^9, 3.4606903229702997`*^9}, {3.460691773820984*^9, 
   3.460691875398349*^9}, {3.460691907292839*^9, 3.460692206989871*^9}, {
   3.460692297322962*^9, 3.460692423215905*^9}, {3.460692475799708*^9, 
   3.460692629030727*^9}, {3.460692840968495*^9, 3.460692929011004*^9}, {
   3.460692963392535*^9, 3.460692978319315*^9}, {3.460693038958144*^9, 
   3.460693047637092*^9}, {3.460693170511355*^9, 3.460693171034143*^9}, {
   3.4606932172455378`*^9, 3.4606932290020857`*^9}, {3.4606933974945793`*^9, 
   3.460693443183797*^9}, {3.460693482157715*^9, 3.460693519997848*^9}, {
   3.460693562628227*^9, 3.460693602300104*^9}, {3.460693772077491*^9, 
   3.460693772541234*^9}, {3.460693849452985*^9, 3.460693856040625*^9}, {
   3.460693972331915*^9, 3.4606939809638*^9}, {3.460694031630495*^9, 
   3.4606940581062613`*^9}, {3.4606941398208723`*^9, 3.460694174520041*^9}, 
   3.4606943190752573`*^9, {3.460694482949913*^9, 3.460694484399068*^9}, {
   3.4606946193788967`*^9, 3.460694637702466*^9}, {3.460694678044799*^9, 
   3.460694682025646*^9}, {3.4606948573102207`*^9, 3.460694858687001*^9}, 
   3.4606949012743597`*^9, {3.460695514594143*^9, 3.460695515495895*^9}, {
   3.460695717268115*^9, 3.460695742341132*^9}, {3.4606961497689257`*^9, 
   3.4606961584709578`*^9}, {3.460698103237307*^9, 3.460698110588427*^9}, {
   3.460699618655459*^9, 3.460699623268559*^9}, {3.460699838007228*^9, 
   3.4606998408930902`*^9}, {3.460699977101617*^9, 3.4606999843476257`*^9}, {
   3.460700112179297*^9, 3.460700114702065*^9}, {3.460700417398714*^9, 
   3.4607004224326572`*^9}, {3.460701621739716*^9, 3.460701623276713*^9}, {
   3.460703085844984*^9, 3.460703085969995*^9}, {3.460703164648594*^9, 
   3.460703184754415*^9}, {3.460703267327463*^9, 3.460703273234264*^9}, {
   3.4607034161792192`*^9, 3.460703418473341*^9}, {3.460703480743588*^9, 
   3.460703532028531*^9}, {3.460703580250605*^9, 3.4607035841131887`*^9}, 
   3.460703678699724*^9, {3.460703798789583*^9, 3.4607038317823*^9}, {
   3.460703894435877*^9, 3.460703933010294*^9}, {3.460704009631909*^9, 
   3.460704023202187*^9}, {3.460704067511279*^9, 3.460704096830886*^9}, {
   3.4607041407732267`*^9, 3.460704431858766*^9}, {3.460705113301587*^9, 
   3.460705123802781*^9}, {3.460705414956148*^9, 3.4607054318607473`*^9}, {
   3.4607140253694677`*^9, 3.460714030977676*^9}, {3.460714086392799*^9, 
   3.4607141138286743`*^9}, {3.4607141471751833`*^9, 3.460714152207553*^9}, {
   3.4607142008664207`*^9, 3.4607142015250587`*^9}, {3.4607142608755407`*^9, 
   3.4607142625322523`*^9}, {3.460714306284425*^9, 3.4607143064146233`*^9}, {
   3.460714445394629*^9, 3.460714456326963*^9}, {3.460714500255849*^9, 
   3.460714581892701*^9}, {3.460715038937811*^9, 3.4607150566079817`*^9}, {
   3.460715135874918*^9, 3.460715216692151*^9}, {3.460715256366817*^9, 
   3.4607152673985643`*^9}, {3.460715428804516*^9, 3.4607154293429403`*^9}, 
   3.460715639466076*^9, {3.460715857509809*^9, 3.4607158793363867`*^9}, {
   3.4607159164135027`*^9, 3.460715916943305*^9}, {3.460715960216598*^9, 
   3.460715979306858*^9}, {3.460716036063106*^9, 3.46071605908599*^9}, {
   3.4607162078831377`*^9, 3.46071627495583*^9}, {3.460716488959024*^9, 
   3.460716508529057*^9}, {3.46071797290528*^9, 3.460717984450169*^9}, {
   3.4607180677154903`*^9, 3.4607180741405773`*^9}, {3.460722416061432*^9, 
   3.460722448444261*^9}, {3.460722658762661*^9, 3.460722666645327*^9}, {
   3.460723225506692*^9, 3.4607232261602697`*^9}, {3.46072326271145*^9, 
   3.4607232632246037`*^9}, {3.460732989384954*^9, 3.4607330580881166`*^9}, {
   3.460773589093289*^9, 3.46077364726867*^9}, {3.46077368545492*^9, 
   3.460773694565844*^9}, {3.460773738558391*^9, 3.460773746179614*^9}, {
   3.460773799671062*^9, 3.4607738064797173`*^9}, {3.460773851144024*^9, 
   3.460773925259716*^9}, {3.460773985490119*^9, 3.460773997515195*^9}, {
   3.460774060448476*^9, 3.460774114923661*^9}, {3.460774252044055*^9, 
   3.460774252169572*^9}, {3.460774296160265*^9, 3.460774309305189*^9}, {
   3.460774371778613*^9, 3.460774383918818*^9}, {3.460774437149872*^9, 
   3.4607745811902027`*^9}, {3.4607746284639473`*^9, 3.460774716654611*^9}, {
   3.4607752495917873`*^9, 3.460775254277954*^9}, {3.460775978735615*^9, 
   3.460775989979575*^9}, {3.4607908938871603`*^9, 3.460790921410623*^9}, {
   3.460791024551952*^9, 3.46079106615455*^9}, {3.460791187361931*^9, 
   3.460791199414687*^9}, {3.460791428110305*^9, 3.460791461140527*^9}, {
   3.460791528140003*^9, 3.460791540222382*^9}, {3.4607934039474573`*^9, 
   3.460793413003908*^9}, {3.460793465959197*^9, 3.460793483721533*^9}, {
   3.4607935284914217`*^9, 3.4607935335582247`*^9}, {3.4607935761191797`*^9, 
   3.460793583200418*^9}, {3.460793637976797*^9, 3.460793638125505*^9}, {
   3.4607939463055277`*^9, 3.4607939476876583`*^9}, {3.46079399620286*^9, 
   3.460794041809469*^9}, {3.460794072179988*^9, 3.4607940937492228`*^9}, {
   3.460794131354467*^9, 3.460794133206498*^9}, {3.4607944387914743`*^9, 
   3.460794729778569*^9}, 3.460794815491509*^9, {3.460794854321972*^9, 
   3.4607949269818068`*^9}, {3.460794973961377*^9, 3.4607949840686293`*^9}, {
   3.460795868937008*^9, 3.460795869544935*^9}, {3.4607959092592497`*^9, 
   3.460795909871471*^9}, {3.460795953020149*^9, 3.460795954579884*^9}, {
   3.460795986507588*^9, 3.460795987621863*^9}, {3.460796021838678*^9, 
   3.460796078768896*^9}, 3.460796112738821*^9, {3.460796218462029*^9, 
   3.460796261336216*^9}, 3.4607963034287853`*^9, {3.4608000705309753`*^9, 
   3.4608000740260963`*^9}, {3.460801024171545*^9, 3.460801032688562*^9}, {
   3.460801069358327*^9, 3.46080107453582*^9}, {3.460801112000573*^9, 
   3.4608011221897097`*^9}, {3.460801259550438*^9, 3.460801280229774*^9}, {
   3.460801441433278*^9, 3.460801443076158*^9}, {3.460801682347784*^9, 
   3.460801688981127*^9}, {3.4608026710214033`*^9, 3.460802687465459*^9}, {
   3.460802777221692*^9, 3.460802777726932*^9}, {3.460802944861147*^9, 
   3.4608029545166273`*^9}, {3.460803112488781*^9, 3.460803119898796*^9}, {
   3.4608031728428717`*^9, 3.4608031769747133`*^9}, {3.4608032258470917`*^9, 
   3.460803255186405*^9}, {3.4608032945219097`*^9, 3.460803314100835*^9}, {
   3.460803371524942*^9, 3.460803375630278*^9}, {3.4608034213301487`*^9, 
   3.4608034602644033`*^9}, 3.460803492616128*^9, {3.4608035422441874`*^9, 
   3.4608035432637453`*^9}, {3.4608035894839153`*^9, 3.460803605852401*^9}, {
   3.460803688848466*^9, 3.460803689605044*^9}, {3.460805865734107*^9, 
   3.460805982320256*^9}, 3.460806038455326*^9, {3.46080610117222*^9, 
   3.4608061286439466`*^9}, {3.4608062114651613`*^9, 3.4608062481878*^9}, {
   3.460808370541099*^9, 3.460808389262392*^9}, {3.460808421801009*^9, 
   3.460808422901106*^9}, {3.4608084601283484`*^9, 3.460808460831965*^9}, {
   3.460808545752421*^9, 3.460808589650069*^9}, {3.460808657498539*^9, 
   3.460808662452217*^9}, {3.460808813111576*^9, 3.46080881463383*^9}, 
   3.460808855466391*^9, {3.4608089039151917`*^9, 3.46080891608951*^9}, {
   3.46080895505591*^9, 3.460808997474917*^9}, {3.460809034420907*^9, 
   3.460809034941881*^9}, {3.460809069090588*^9, 3.46080907443106*^9}, {
   3.4608091348026237`*^9, 3.4608091609618053`*^9}, {3.460809375341311*^9, 
   3.460809378861487*^9}, {3.460809411101377*^9, 3.4608094452881737`*^9}, {
   3.46080948676932*^9, 3.460809497970563*^9}, {3.4608095348868313`*^9, 
   3.460809651251011*^9}, {3.4608097087599163`*^9, 3.460809713665476*^9}, {
   3.4608097567273407`*^9, 3.460809760388171*^9}, {3.460810939710677*^9, 
   3.460810943555335*^9}, {3.4608110196391497`*^9, 3.460811022952656*^9}, {
   3.460811062673605*^9, 3.460811066287291*^9}, {3.4608163771049356`*^9, 
   3.460816411616971*^9}, {3.460816450648465*^9, 3.460816454214529*^9}, {
   3.4608166171557503`*^9, 3.460816623841778*^9}, {3.460816718130597*^9, 
   3.460816724534326*^9}, {3.460816784047859*^9, 3.460816802789748*^9}, {
   3.4608168776315823`*^9, 3.4608168885120373`*^9}, {3.4608594511840477`*^9, 
   3.4608594584854097`*^9}, {3.460859489503922*^9, 3.460859511725025*^9}, {
   3.46085963217032*^9, 3.4608596357451267`*^9}, {3.4608610131599827`*^9, 
   3.4608610290340023`*^9}, 3.460861071055821*^9, {3.46086115894928*^9, 
   3.460861168219329*^9}, {3.460861241098703*^9, 3.460861246942329*^9}, {
   3.460861459904879*^9, 3.460861464188553*^9}, {3.4608615283504267`*^9, 
   3.460861546372974*^9}, {3.4608615867089167`*^9, 3.460861591730888*^9}, 
   3.460861736145293*^9, {3.460861779382738*^9, 3.4608617808612537`*^9}, {
   3.460861828686419*^9, 3.4608618308555183`*^9}, 3.4608618801554337`*^9, {
   3.460862009793119*^9, 3.460862018356495*^9}, {3.4608641521055393`*^9, 
   3.460864190970071*^9}, {3.460864237369982*^9, 3.4608642510079536`*^9}, {
   3.460864302663397*^9, 3.4608643163615007`*^9}, {3.46086434931174*^9, 
   3.460864364681967*^9}, {3.460864405706942*^9, 3.460864586311355*^9}, {
   3.460864921612752*^9, 3.460864938797368*^9}, {3.460865009989366*^9, 
   3.460865047943028*^9}, {3.460865167194707*^9, 3.4608651879147797`*^9}, 
   3.460865231482572*^9, {3.460865479277616*^9, 3.4608655090105677`*^9}, {
   3.460866664136902*^9, 3.460866667854333*^9}, {3.460884295869668*^9, 
   3.4608844365894547`*^9}, {3.460884519423401*^9, 3.460884661536573*^9}, {
   3.460884712666898*^9, 3.460884721128777*^9}, {3.460884770472212*^9, 
   3.460884792389983*^9}, {3.46088792154502*^9, 3.460888000850438*^9}, {
   3.460888036371475*^9, 3.4608880431976767`*^9}, {3.460888161376789*^9, 
   3.460888171863413*^9}, {3.460888274951207*^9, 3.4608882901536407`*^9}, {
   3.460888340965372*^9, 3.4608883434644003`*^9}, {3.460888612335044*^9, 
   3.460888617942874*^9}, {3.460888718946876*^9, 3.4608887225407877`*^9}, {
   3.460888805241638*^9, 3.460888822136969*^9}, {3.460889056617136*^9, 
   3.460889061109805*^9}, {3.4608892139621677`*^9, 3.4608892145697603`*^9}, {
   3.4608892630269403`*^9, 3.460889282810165*^9}, 3.460890302342848*^9, {
   3.46089253752285*^9, 3.460892594269291*^9}, 3.46089264384861*^9, 
   3.46089305767199*^9, 3.460893190706695*^9, {3.4608944038545313`*^9, 
   3.460894418045409*^9}, 3.460946278776452*^9, {3.460946328063875*^9, 
   3.460946397908173*^9}, {3.4609728173107224`*^9, 3.460972849601357*^9}, 
   3.460974848139744*^9, {3.461032775504857*^9, 3.461032794905816*^9}, {
   3.461033295417555*^9, 3.461033338771119*^9}, {3.4610336070972357`*^9, 
   3.461033644817749*^9}, {3.461034450462927*^9, 3.461034532746232*^9}, 
   3.461034591354848*^9, {3.461034669978732*^9, 3.461034680674143*^9}, {
   3.461034984375193*^9, 3.461034987173346*^9}, {3.46103503878016*^9, 
   3.461035047219956*^9}, {3.46103551894674*^9, 3.461035520703669*^9}, {
   3.461035750793043*^9, 3.461035763202241*^9}, {3.461036867607264*^9, 
   3.4610369303995037`*^9}, {3.461036990340271*^9, 3.46103700691535*^9}, {
   3.461037199497033*^9, 3.4610372053046713`*^9}, {3.4610373000941563`*^9, 
   3.4610373009291983`*^9}, {3.461037332765676*^9, 3.461037338126088*^9}, {
   3.461037426873289*^9, 3.461037431274927*^9}, {3.461038234530705*^9, 
   3.461038362764758*^9}, {3.461038398561651*^9, 3.461038442006666*^9}, {
   3.461038679092595*^9, 3.461038685762527*^9}, {3.461038720707884*^9, 
   3.461038890349016*^9}, {3.461039322638434*^9, 3.4610393912682953`*^9}, {
   3.461054539810452*^9, 3.461054543393985*^9}, {3.4610546584711533`*^9, 
   3.461054660525765*^9}, {3.46105481558575*^9, 3.4610548318231773`*^9}, {
   3.4610548896361847`*^9, 3.461054909915051*^9}, {3.461055010405937*^9, 
   3.461055014141428*^9}, {3.461065774567938*^9, 3.461065780405266*^9}, {
   3.461066038612464*^9, 3.461066047035771*^9}, {3.461294598988719*^9, 
   3.461294632849757*^9}, {3.4612946757563753`*^9, 3.461294808122293*^9}, {
   3.462762841708178*^9, 3.4627628459220324`*^9}, {3.4627629216906977`*^9, 
   3.462762966908342*^9}, {3.462763017449112*^9, 3.462763020122785*^9}, {
   3.462773445554858*^9, 3.462773457228978*^9}},
 ImageRegion->{{0, 1}, {0, 1}},
 FontWeight->"Plain",
 FontColor->GrayLevel[0]]
},
AutoGeneratedPackage->None,
WindowToolbars->"RulerBar",
WindowSize->{1203, 983},
WindowMargins->{{-141, Automatic}, {920, Automatic}},
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (February 18, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 41370, 772, 1904, "Input",
 InitializationCell->True],
Cell[41918, 794, 71016, 1298, 3302, "Code",
 InitializationCell->True]
}
]
*)

(* End of internal cache information *)
