(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    433969,       7422]
NotebookOptionsPosition[    432606,       7373]
NotebookOutlinePosition[    432948,       7388]
CellTagsIndexPosition[    432905,       7385]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"(", 
   RowBox[{"Sigma", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", ".5"}], ",", ".2"}], "}"}], ",", "\[IndentingNewLine]", 
      "              ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", ".5"}], ",", "2", ",", "1"}], "}"}], ",", 
      "\[IndentingNewLine]", "              ", 
      RowBox[{"{", 
       RowBox[{".2", ",", "   ", "1", ",", "4"}], "}"}]}], "}"}]}], ")"}], "//",
   "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"Sigma1", "=", 
  RowBox[{"Sigma", "//", "Inverse"}]}], "\[IndentingNewLine]", 
 RowBox[{"{", "x", "}"}]}], "Input",
 CellChangeTimes->{{3.461320083884733*^9, 3.4613201291823463`*^9}, {
  3.461320160384636*^9, 3.461320251583099*^9}, {3.46132157347948*^9, 
  3.461321573554088*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "1", 
       RowBox[{"-", "0.5`"}], "0.2`"},
      {"2", 
       RowBox[{"-", "0.5`"}], "2", "1"},
      {"3", "0.2`", "1", "4"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.4613202317072353`*^9, 3.461320252245242*^9}, 
   3.461321574371903*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1.2237762237762237`", ",", "0.3846153846153846`", ",", 
     RowBox[{"-", "0.15734265734265734`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.3846153846153846`", ",", "0.6923076923076923`", ",", 
     RowBox[{"-", "0.19230769230769232`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.15734265734265734`"}], ",", 
     RowBox[{"-", "0.1923076923076923`"}], ",", "0.30594405594405594`"}], 
    "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.4613202317072353`*^9, 3.461320252245242*^9}, 
   3.46132157437507*^9}],

Cell[BoxData[
 RowBox[{"{", "x", "}"}]], "Output",
 CellChangeTimes->{{3.4613202317072353`*^9, 3.461320252245242*^9}, 
   3.461321574376453*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"xp", "=", 
  RowBox[{"Quantile", "[", 
   RowBox[{
    RowBox[{"ChiSquareDistribution", "[", "2", "]"}], ",", ".95"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.461320296842746*^9, 3.46132032671208*^9}}],

Cell[BoxData["5.99146454710798`"], "Output",
 CellChangeTimes->{{3.4613203224130774`*^9, 3.461320327802737*^9}, 
   3.461320405989573*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Clear", "[", 
  RowBox[{"x", ",", "y", ",", "z"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"elli", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x", ",", "y", ",", "z"}], "}"}], ".", "Sigma1", ".", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], "\[Equal]", "xp"}]}]}], \
"Input",
 CellChangeTimes->{{3.46132025979768*^9, 3.461320276575717*^9}, {
  3.461320330467434*^9, 3.4613203519664173`*^9}, {3.46132042945196*^9, 
  3.4613205186049356`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"y", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"0.3846153846153846`", " ", "x"}], "+", 
      RowBox[{"0.6923076923076923`", " ", "y"}], "-", 
      RowBox[{"0.1923076923076923`", " ", "z"}]}], ")"}]}], "+", 
   RowBox[{"x", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"1.2237762237762237`", " ", "x"}], "+", 
      RowBox[{"0.3846153846153846`", " ", "y"}], "-", 
      RowBox[{"0.15734265734265734`", " ", "z"}]}], ")"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "0.15734265734265734`"}], " ", "x"}], "-", 
      RowBox[{"0.19230769230769232`", " ", "y"}], "+", 
      RowBox[{"0.30594405594405594`", " ", "z"}]}], ")"}], " ", "z"}]}], 
  "\[Equal]", "5.99146454710798`"}]], "Output",
 CellChangeTimes->{{3.461320261805538*^9, 3.461320278290325*^9}, {
   3.461320347321883*^9, 3.461320353247118*^9}, {3.461320398154291*^9, 
   3.461320409583403*^9}, {3.461320451171117*^9, 3.461320548589397*^9}, 
   3.461321578193779*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["elli"], "Input",
 CellChangeTimes->{
  3.461320412865345*^9, {3.461320556814687*^9, 3.4613205577583714`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"y", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"1.4893617021276602`", " ", "x"}], "+", 
      RowBox[{"2.042553191489362`", " ", "y"}], "-", 
      RowBox[{"2.3404255319148946`", " ", "z"}]}], ")"}]}], "+", 
   RowBox[{"x", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2.1276595744680855`", " ", "x"}], "+", 
      RowBox[{"1.48936170212766`", " ", "y"}], "-", 
      RowBox[{"1.9148936170212774`", " ", "z"}]}], ")"}]}], "+", 
   RowBox[{"z", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "1.9148936170212774`"}], " ", "x"}], "-", 
      RowBox[{"2.3404255319148946`", " ", "y"}], "+", 
      RowBox[{"3.7234042553191506`", " ", "z"}]}], ")"}]}]}], "\[Equal]", 
  "5.99146454710798`"}]], "Output",
 CellChangeTimes->{3.4613204129742317`*^9, 3.46132055858529*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ContourPlot3D", "[", 
  RowBox[{
   RowBox[{"elli", "//", "Evaluate"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "4"}], ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", 
     RowBox[{"-", "4"}], ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", 
     RowBox[{"-", "4"}], ",", "4"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"PlotPoints", "\[Rule]", "30"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.461320026728283*^9, 3.46132003706004*^9}, {
  3.461320073559725*^9, 3.46132007570839*^9}, {3.4613203563509817`*^9, 
  3.46132037825527*^9}, {3.461320538810978*^9, 3.461320594501153*^9}, {
  3.46132068181994*^9, 3.461320685108103*^9}, {3.4613207298683643`*^9, 
  3.4613207679084063`*^9}, {3.4613208291888123`*^9, 3.461320829650158*^9}, {
  3.4613208627128477`*^9, 3.4613208913605633`*^9}}],

Cell[BoxData[
 Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJx0nXlUzd/3/5u7zYbMY4aQhDSYcm95N4giEkqEIhIRGUKpJGVqRkkpkagM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   "], {{
     {GrayLevel[1], EdgeForm[None], 
      GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJw12XV8FNcWwPG12cmi7UNCintwgnvQNFhwd22xCl5aHsUpFChe3CV4cYfg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         "]], Polygon3DBox[CompressedData["
1:eJxNnAf41lMbx5892kuloYXsFW0vFSE7JJLRJmSTUL0JlSiVUkZUZoPskd2g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         "]], 
        Polygon3DBox[CompressedData["
1:eJwt2nfcT+Ufx/Hz/d7f8x03irLJSjZ3MtpKtriRkchM/SI0zNJEyEz2FjIr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         "]], Polygon3DBox[CompressedData["
1:eJwt1nlQVVUcwPEL7/HeM2dqpjRTC0UWRRwEtFgMHhCbAiogi7gVoyhMpTWT
S02iM6n/pONYapoVIIoYq4gsIouC7G4gCohiY2bWpE0ziu3f35zzx2fufb97
7j2/e5bffS4Z6xPfdzQMYwMseM/BMNwIuMMVzsgktsNkGLuxB5/jOThgB9cC
aBMIf/gih1ia2TBa0IqLaEM6ttLJ3/gH/+IJtuAC9y3leelYhuVoJbZM39uO
DnRiBUYlaZ3Df9IOiVip23ShGz14G7/Tx0dWw9iITViLu8SqnQyjBmdwGpGI
knOuVaESFZiL12Hm3UpQimIU4C9SaaAPX+7zwxzMRROxRnJKIcdUpJnUOzYT
C+B6Po6iAMcQiGjyikEY7Kilzzrspp8Q7rMj2FGN+S5iffRxHb24ikysRQ79
7MQuk5o7Gas/uWcLz3zJZhjjMB5jkG1Vk79Zz8XH2IBn5FPEtVKUoRyTMQHz
ud6GDgzjFhbgJx51kLy+wgHsxRCxx/TzBE8xilhE2lTO13AFl7EGq7EY9Thn
VmPbiESzyk3WzFOM4hE+kN/0kUdf+cjFITwk9qFu89ii1sAIMvAWzypFGcpR
gUgE6bk4jkKcwDw8INff8Mim3iUCdnzCuG7DdpMa82eM8R+4wbNuot+s5mgd
slDFtXjaLcQiLEa13mvX0Is+9GAKusm1BxfRgihEI0mPiayxZpxHsqxB5sYP
PvBGEW1PIo5r1ahBLeqwEEdok4d8HMWLeAFfcs9+fIF9mICJMueOam+uwEqs
QgexjYy3F8dZmOmoash6Yv0c19AmE1nIxk1ixYxpCb7HSYQgGHU4i1ontTdj
MN9J7XGpOWMxBu9KHrrm/Ij7uIcR+Mn40WYB7xdrVu8eL+uLmJ13CMU8BKKL
Z3fjVc5fw2RMQpHOTdZYDuOxDdutqobIWurnWQl6TcpcLJH5JvaZvD9HL/hh
juxDYo0cg2kTgjCEy7wRGzCpe2XuUpCKIWKv0M9EjMc47KHPvbBzPVTmGT44
TdszeINcv0Mu8nRt8Ycn106hErWo07ndllqka7LU2OUYIRatx1xqYAQGJR9M
IwdXuGAqDpHLYZShHKUoxmz4WNRaKsQJq6ohL0vdwQ8m1ZfUcKnVq3CPWACa
TGpMWqT2Iwgp3JOKRYhHq94LZeRWjlIntZbsCEUaY52FbKxDM2uwBud51gU9
VlWYBW/Us4fb0I4OeMAZ900qN/l2vIMMPCBWI/sV+ciTecIkTCGnqXC2qLVU
onNrRwfa0IolSJZcdQ2RGhiFw7zbAQRxHqJri7TZT2wf+jkfxm3cgT980Sjf
GTSgHnGIx0GreubXVrXHn8dYzIAnpsNd9j655stcyjdcj3mI7BMcIZbMcdCk
1uQtDOtvWbjse3SiC92IkG8xLIyVFU5m9Q2S2nicPgpxTNYGZsBTahs1eqeD
+pbJf4mtMleGalOgc8uFOzzwqYP6jyF73MdR1ZzNxLoYi1704Tpmw9OmatEg
hjCga6z8t5muc5Bnusm3Xv8HuIQ3+R0iNROxuCy1ieNZnJOagU7dxhd+es17
W9RcNDup3KQW3cUdnYPUxgbaNOpveg2CdC2SufCAm1XttW+IfWtRa0O+lXGI
t6laLXPaZKixkv9aMiabUE0shrG+ZFK17gquSh00qXsTkIgkm9qbUvPlPA1L
kW5T33rZswncc8OkatqAXgNJmEZOrnCxqDUve7ACMzn30nMqY1uja/gpVOo2
smfDEI4MnvUzHuIX/IrV+B9ZJWKJ
         "]]}]}, {}, {}, {}, {}}, 
    {GrayLevel[0], 
     Line3DBox[{504, 503, 513, 520, 528, 534, 714, 717, 724, 872, 1007, 1125, 
      1231, 1230, 1342, 1450, 1449, 1562, 1560, 1559, 1682, 1679, 1678, 1812, 
      1808, 1804, 1799, 1794, 1788, 1662, 1656, 1536, 1422, 1313, 1192, 1191, 
      1088, 1087, 963, 962, 829, 828, 672, 671, 682, 689, 504}], 
     Line3DBox[{874, 873, 1005, 1004, 1003, 1123, 1122, 1121, 1229, 1228, 
      1340, 1448, 1447, 1558, 1681, 1819, 1968, 1972, 1977, 2153, 2161, 2170, 
      2180, 1999, 1998, 2010, 2023, 1862, 1861, 1724, 1723, 1597, 1596, 1486, 
      1485, 1374, 1262, 1147, 1030, 1023, 896, 891, 887, 883, 880, 877, 
      874}]}},
   VertexNormals->CompressedData["
1:eJwUmXc4le8fx4XQkMoIKZSICiEZ1Z0yk5HIigqlQmSmQTKiEklWZnb23j72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    "]],
  AutomaticImageSize->True,
  Axes->True,
  BoxRatios->{1, 1, 1},
  ImageSize->{360.10383452534853`, 363.14084361722917`},
  PlotRange->{All, All, All},
  PlotRangePadding->{Automatic, Automatic, Automatic},
  ViewPoint->{-0.2622604059257795, -0.13031559837641749`, 3.3710884480095507`},
  ViewVertical->{-0.7283113457523942, 0.405619953442109, 
   0.5522997709740228}]], "Output",
 CellChangeTimes->{
  3.4613203792717543`*^9, {3.4613205234725637`*^9, 3.461320540169792*^9}, {
   3.461320571525635*^9, 3.461320595446664*^9}, 3.461320685255825*^9, 
   3.4613207388534946`*^9, 3.4613207689807262`*^9, 3.461320829876039*^9, {
   3.461320867782044*^9, 3.4613208919161463`*^9}, 3.461321580555513*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Clear", "[", "KonfidenzEllipse3", "]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"KonfidenzEllipse3", "[", 
    RowBox[{"mu_", ",", "Sigma_", ",", 
     RowBox[{"p_", ":", ".95"}], ",", 
     RowBox[{"Farbe_", ":", "LightSeaGreen"}], ",", 
     RowBox[{"opac_", ":", ".4"}], ",", 
     RowBox[{"r_", ":", "1"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "xp", ",", "S", ",", "elli", ",", "z", ",", "x1", ",", "x2", ",", "mu1",
        ",", "mu2"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"xp", "=", 
       RowBox[{"Quantile", "[", 
        RowBox[{
         RowBox[{"ChiSquareDistribution", "[", 
          RowBox[{"Length", "[", "mu", "]"}], "]"}], ",", "p"}], "]"}]}], ";",
       "\[IndentingNewLine]", 
      RowBox[{"S", "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"CholeskyDecomposition", "[", 
         RowBox[{"Symmetrize", "[", "Sigma", "]"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"z", "=", 
       RowBox[{
        RowBox[{"Inverse", "[", "S", "]"}], ".", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"x1", ",", "x2", ",", "x3"}], "}"}], "-", "mu"}], 
         ")"}]}]}], ";", 
      RowBox[{"elli", "=", 
       RowBox[{"z", ".", "z"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"xpr", "=", 
       RowBox[{"{", 
        RowBox[{"xp", ",", "xp", ",", "xp"}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"mu1", "=", 
       RowBox[{"mu", "-", 
        RowBox[{"r", " ", 
         RowBox[{"S", ".", "xpr"}]}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"mu2", "=", 
       RowBox[{"mu", "+", 
        RowBox[{"r", " ", 
         RowBox[{"S", ".", "xpr"}]}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"ContourPlot3D", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"elli", "\[Equal]", "xp"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x1", ",", 
          RowBox[{
          "mu1", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
          
          RowBox[{
          "mu2", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x2", ",", 
          RowBox[{
          "mu1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], ",", 
          
          RowBox[{
          "mu2", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x3", ",", 
          RowBox[{
          "mu1", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], ",", 
          
          RowBox[{
          "mu2", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}], 
         "}"}], ",", "\[IndentingNewLine]", 
        "                                         ", 
        RowBox[{"ContourStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Farbe", ",", 
           RowBox[{"Opacity", "[", "opac", "]"}]}], "}"}]}], ",", 
        RowBox[{"AspectRatio", "\[Rule]", "1"}], ",", 
        RowBox[{"PlotPoints", "\[Rule]", "30"}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], "\n", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.461321092696745*^9, 3.46132117393458*^9}, {
  3.4613212416640463`*^9, 3.461321304504572*^9}, {3.461321356717629*^9, 
  3.4613213644904003`*^9}, {3.4613215029412317`*^9, 3.461321558710421*^9}, {
  3.4613215981507273`*^9, 3.461321661121283*^9}, {3.461321699100321*^9, 
  3.461321789894133*^9}, {3.461321860703413*^9, 3.461321905635203*^9}, {
  3.4613232222707777`*^9, 3.461323223277565*^9}, {3.461324154945689*^9, 
  3.4613242268148937`*^9}, {3.461324293284026*^9, 3.4613243119041443`*^9}, {
  3.461324347843254*^9, 3.461324353750824*^9}, {3.461324405220915*^9, 
  3.461324564274062*^9}, {3.461324632613737*^9, 3.4613246407083893`*^9}, {
  3.4613251227060843`*^9, 3.4613251967176867`*^9}, {3.4613252371722918`*^9, 
  3.4613252392122707`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"KonfidenzEllipse3", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", "Sigma", ",", ".5", ",", 
   "White"}], "]"}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.461321092696745*^9, 3.46132117393458*^9}, {
  3.4613212416640463`*^9, 3.461321304504572*^9}, {3.461321356717629*^9, 
  3.4613213644904003`*^9}, {3.4613215029412317`*^9, 3.461321558710421*^9}, {
  3.4613215981507273`*^9, 3.461321661121283*^9}, {3.461321699100321*^9, 
  3.461321789894133*^9}, {3.461321860703413*^9, 3.461321905635203*^9}, {
  3.4613232222707777`*^9, 3.461323223277565*^9}, {3.461324154945689*^9, 
  3.4613242268148937`*^9}, {3.461324293284026*^9, 3.4613243119041443`*^9}, {
  3.461324347843254*^9, 3.461324353750824*^9}, {3.461324405220915*^9, 
  3.461324564274062*^9}, {3.461324632613737*^9, 3.4613246407083893`*^9}, {
  3.4613251227060843`*^9, 3.4613252192283077`*^9}, {3.4613252892934933`*^9, 
  3.461325290442587*^9}, {3.4613253329753838`*^9, 3.4613253660528316`*^9}}],

Cell[BoxData[
 Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJxlnXlUTd/7x5tn1ccYiWQoiTJk1jlCSEISMkeIzHNCkamohEqRyjwnVBqc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   "], {{
     {GrayLevel[1], Opacity[0.4], EdgeForm[None], 
      GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJwt2HecDecawPE5Z+ac1UvITa4WvQtRogdXjbBh9V6z2JUgrNXC6m2VXWWx
6k100aOzWHWVkFVXEORqkQiCqya/5/M8f3w/zztzZt555523ngLd+4V95Xcc
Z7/PcVwiwZFjST8LOM5TPMd0PMJUrEWOoOOsJP6EGqRTiZWJFVEBozm+hZGo
y3Ft1MINjj8j3iSeCOj1J4kT8QCTAnrNNVxFBn7PiEz4m+O3cEinQwjSYwXn
MhP/SwwSlxAX4B7u4j7m4CXikZVrsiAbFnLsEucT8xK3ETcgF+n1xFWoh2Wo
E9BnLQ/ouy8O6LOWojTGo4S9yziMtXqbhhkoZueLB7R+YjAGm5Gb560LaHkS
sUjqE3FSR9iHolyTJPkQDxIPoCzp0iiF5ICmDxHzEUugIGpyPA/VrB5mYy5K
BjXPImjMh/8UnyEUN6jma6hH+hLxLBqQ/gF1sd2ur4/d2IU9OIgDSMY+hOFz
rEctVEd+uYf89iI36Q+QB0kcFyTuJ24hbsZWu/d7bMAEvIf3UQErUAarUBXl
8SNSccbS4eiFw+iAtjiLCPTGKZzEaStbERTwadm2UpZtKEQ6L/KhJ55y7jG6
W/490MLetyU+kWfzewpq27vXQaQ9ty9+4rf/yLOtbhuiEdrgPufuoKOVuROq
2TtKHZZCaXt3qYeKqISPUM7qoZG11frSX63eciIEi8h7MV472unfEDISsyKT
T69fzbm1jvb3NQFtn9Jnj+EoIi3dF9kwANlR1XOc6wwgaWhKuglCPU3/wbkH
aEH6CfERBtq9/XGE43z8lmzXhKElCuEE545jLu01HrMQh6mIlX4v/RmJGGvt
vzhaYROaYws2Y2tQ+840lAvq2DUPVTAJMzAlqH1kgvWv0zy7KOVIIRbzNF3c
ylYYRfANRmAkZmIG4hCPWZiNMpiKkoi19DRMwHhM9DR/SRfEOMu/AEYhBqPx
gT0rDyqgIiqhMj5GFaRS1tLEs64+V9Ifejomf4d6Qb33Mr+fd/XbVUN1/Oxq
PpeIHxHLoTwuupo+52p/nIKJKEReY2w8kbmjI/GxfFviefRFGiZb3V7GCETb
uTT7jpE4g172u1w3CFfsu8wMahu4gQRrA1etPVzCYHyJTjx7B1rh+4CO5zK2
D0EahiIMGxGK1TI3oQG2oz0+tzwkr7bYGdCxdzf2oxfCZXzmeXtlfEYb7EZb
GafRBR2COu8MtTlL2mRLtLbrWyAsqHNWM+LtgM534aRfSZltHgygO7qhBzpb
/l3xLkbavBaDfyO71WeE1X8KMoQwFlpfeCnznOWZLHWG0chvc4e8l8v1O4hR
VrfR1tfuYykG4mv7RjIv94OH92gjA5EDg2gfQxCF7/AtluNDv47V53CEdA90
wUmcwCl0o511RXe4lvZJm+S3ciiPPhyHoxc6oxO6oB7qor6rz6qAssjr13kq
Ca9l/MNbvMQLvMJj/IGH+EvGfDzz6b15kA/F/Tp3pMi8QbowiqIZmqAp/PDB
9Wt5bhN/ld9IPyT+jhjShVAQYzEG45Abo2RMRJz0R1Sxa0qgCGZjFuZgGmIx
3dIVpJ5cfVYThKIRvkUDrMJKrMYgGYsRhZyWfgeLsBCLLS31WcfKk4B4y0fy
b4ylWIJlVrbqMq7gT+poFmYjzuo2Hh7vH0AQbdEO7dHT2sMXiECI1aEsWL9E
P7/e28uv3y7c0r3tXqnzV/Z9u/n120k+fRCJzuhk7W0sJmAcvsEIjMRQDMNw
RGEQBls6B7JjALIiM7r69VndMdraSS5MxiRMQay1k4LYio3YhO3Yhh1YTFn/
xnyfLsiXERdgDTJwvFLmc7+uu3Ygm5VBypPJr+ul1XZ+s62dclqZ30U6q8/0
fm3nrYlP5NsQZ2EOjuE4Uqw9SzmbyzOxG3tQg+96jXjF3j3Zvt1+JEkf82u/
PoyjSLA+WwYH7fpDlo+0k5rSTvzaLx7hjtXbeL+ul1JxDsdxzNZXyTiEw7iA
ruggayecR3uccXQ9JuvYKqiFqrjs6Po2DaMxAWNwFRHoKfsgR9d7z7EHB2zt
ehvRGIjfHF2zPcAw3EUUbjq6lr6FJ5b/JDzCFIzHQexzdN2bA+8gJ0J0q+Ok
QwHkl/WxvVcndEYC32yetROJCdZOpH/FYppP164zURjtuKet1Y+0pbVYh0Qs
lHWhrGVlXWvvLte2szpsgxZojZFWzsz2vsMxAkOsToY6up7fiV2ItPrsK2td
NEFDNEUYQi1veUZLtEIzNEd/n65RffKejq5dF2Cq1WGso/30Z0TjuvXfIZaW
9vmLtedirra3kq7OL9ImL1i//lr6patt9YBdI2NsKZk7ZP2EsrjEb5eR5tcx
57j19yfWd+Ks3co4fxeJeIH5eGnpVzjj13FMxiKZ72Rc+sLO/4izVrbzuGj9
JY+r/a6wzRcy/hd19b2KY43VbajV4Sb7XssdXc+vwEarc6nnHxzdi8ke5wb1
OwoxmGztLRfWO7oP2mDX/IqbPp2bpDx5sZ4yZSGu8+scVdnmqYqulj/Vr/Um
58/JeGZ9sI6jdSvvK3P9ahmbZE7y670yf1VCVlfzz4b0rl6TQdYErC0CcJGJ
DnOaDnMkqHvnj1EFv/PbA9l7oDPHb4jPbX17BVfRjvPPOPdI1ree3ptKvObq
XuYXDMMFRLu6Fznm6n5E9lkN8SmecE/zgD6rDb9tRivswHbslLmX3+qjHlag
ERriBTpw7192fi1WejqfvkEiXuElXru6HzkldSfHch0WYCH+jwT0t2u+cvX/
hyIoLGtY2VvIutXTPGV+X4CnHM+3fcopnMRp28s8sH3KQ/xpdSXXP7P6lL3M
PUz2tB4ee/ouF63eZB/x0PZB0+VeWz/MRRdZ73LuLRxL++R/CuIce5ebqM25
656uCfeio6v/z9S1fe49ju/iPna7ug7s4Or5yZiI1lzXxtbz8t9IDXyCxrb+
b4ItXJeZ52wktuS4he0jpC01Jd4nZvH0mqxYgjq2b+pjbSPC1f3sYRzFPNtb
yR6tJhJtj1bZ3lH2VvOs/uU7xtuerqyn5ZG2tBXNAlr/v3m6xv4X3vf0mx5A
sqf1KXuTrujD8WGEI9LK0xv7rA6TLC357JI+xT090BNJnraZ/Z7uN2Vvnh+3
Pa3zW57+91UKZex7yXeXPe8gnMEAT/tpN/Sw/nUBlzzdV8oeWfakg3Ee0Zb/
/3DH2mFZ8k7x9F16I8Lqvy8yWtu44Wl5QgLad9bgmqf75eFWHtmPRHm6T7+C
YZ7uu+XeMfgHfrOvbQ==
         "]], Polygon3DBox[CompressedData["
1:eJxNm3ccltP7x5/nHk/TyLeiSfYuIyO0iCSSXZKRyGqhVFoSoiUrIklJduGr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         "]], Polygon3DBox[CompressedData["
1:eJwt2Am4TtUex/H9vvt936NkVokIZeYab8aiSa7KNUvmI2SehziIg2MWCkko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         "]], 
        Polygon3DBox[CompressedData["
1:eJwt1WdslkUcAPC37yi4Ika/IWDpQGbUigURpQJWBFliBASFKjQWRzQao35x
JJpoFVqhFIGAmgJtAyZqHK2MFmfUaNQooqhAhFDrAGkRGfp7cvfhl6fvzf/d
/e9aUHnfzHvTqVRqCvmsyKZS9dSylEu5jIq8VOo6xnMtX2n7Db10rmYJ95AM
dgaXxL4jGMbXGe3p8vfvdHKIGp6nSp/FVLKQk+Y4zSTe5h1aaWMyM9nGdtrp
YBbXsIXXeJ03KOdyc9SxnFU0MJI2a7hIfQED6Mtbytop8fcgivNCm63K+vkW
UsTAZH5lrexlqt/TYmw3sT8V9nBZXONzDI970qnuFm1mcyvz6EqFtS9gLnM4
qryH49zm9+3cwZ2cULbaWGtYmQ1nV8YoCu314zzBkzxFMVfGtb/EetYxhnON
dz8P8CAPcR6jzbGJJjbHvR3DFXGuJDeSs/7O2Lu4S5/P+Jwv+DLmxvfqSuOe
JzGMZncmjHm2+nPSIYY+6XB2Od9sOuTAqWSdrGVGzv4ylRtzIZf+4EJj9aU/
A2jV9z0ma9PEJrawmSl0MEjCX8xg+tOWC7nRzTFOcTLuVZ36elbSQBmlvCqm
tHky6XAXetOobLmxVlBHLWWMokSfIQxlGDuVbaeC65nIeA6Y82A25HCfeBbn
cwFv5oU2EyhnHPu03c8R/o570hVzL7nLzdq0sJHGONckHpZzBziYCjn5G4/w
lz7T1U9jLnM4nA19N/AKL8cYkpir9dnDT/Eu7OPu+K4000ITjVTwLIc5Qjc9
1PCiOf7Mhrl64lkkdzYv5vyidMix6rjnC+1hJfOZR49YjvGDHPgx5uS3PMpj
rFOXr12OsziT9crmG2sH7XzAh/Gu/ZoNZ5Hs7V6e5hlO6/MfJ/g3nnU9vYzX
mywZ1ihbS40zq6WOZfEN6c9Vxhob72xyp5KY99CirpmNbKCUkeyyRxN8J8a3
8QZ2K/tErB/zPjvjG5K8pUViKKQ4P+TeNrFszYU3JFnjR3wa7+yi2Lcj3p02
Zse3KGkzRFxDGc6ITLjjVcbaQXu8U++yIMlpdQXaDMyEt6goE/Z2kG8J/TLh
znbEmGeJ7WZmMJ1DxujMhbMoim/X4EyIIYn550x4Q5K3q5xx/KKsWt8lVLE4
P5xR8o+tOxdy40iSx7zAUv7R7zhH492pj2/p6lw4u1U0MJar+R+/fO63
         
         "]]}]}, {}, {}, {}, {}}, 
    {GrayLevel[0], 
     Line3DBox[{295, 294, 296, 297, 298, 405, 406, 499, 598, 599, 697, 794, 
      892, 990, 992, 1088, 1086, 1084, 989, 987, 891, 793, 696, 694, 597, 497,
       496, 404, 295}], 
     Line3DBox[{799, 798, 895, 894, 994, 1091, 1186, 1280, 1281, 1377, 1466, 
      1468, 1567, 1569, 1572, 1469, 1380, 1379, 1282, 1188, 1187, 1092, 995, 
      897, 896, 802, 801, 800, 799}]}},
   VertexNormals->CompressedData["
1:eJwUWHc81P8fz4jMhhANKynpm1EZyTskIzIrKppmkS0pRdlJhAihsmVG9sve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    "]],
  AspectRatio->1,
  AutomaticImageSize->True,
  Axes->True,
  BoxRatios->{1, 1, 1},
  ImageSize->{425.03008222573436`, 371.5498805280818},
  PlotRange->{{-1.3659738843753382`, 3.365973884375338}, {-0.9469023110776476,
    2.9469023110776478`}, {-5.718043083222133, 7.718043083222133}},
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02], 
    Scaled[0.02]},
  ViewPoint->{-2.7527700083343993`, -1.958491856025375, 0.19122481820337117`},
  
  ViewVertical->{-0.624531582072449, -0.06740850757121261, 
   0.7780850828162085}]], "Output",
 CellChangeTimes->{
  3.461324509979412*^9, {3.461324541820256*^9, 3.46132456512499*^9}, {
   3.461324635623541*^9, 3.461324641910294*^9}, {3.461325214421577*^9, 
   3.461325242213626*^9}, 3.4613252906577187`*^9, {3.461325333793561*^9, 
   3.461325367136401*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"x", "=", 
   RowBox[{"RandomGauss", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", "Sigma", ",", "100"}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.461322669596163*^9, 3.46132271465035*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ListPointPlot3D", "[", "x", "]"}], ",", 
    StyleBox[
     RowBox[{"KonfidenzEllipse3", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", " ", "Sigma", ",", " ",
        ".95", ",", " ", "Red", ",", " ", ".3", ",", " ", "1"}], "]"}],
     FontWeight->"Plain"]}], 
   StyleBox["}",
    FontWeight->"Plain"]}], 
  StyleBox["//",
   FontWeight->"Plain"], 
  RowBox[{
   RowBox[{
    StyleBox["Show",
     FontWeight->"Plain"], 
    StyleBox["[",
     FontWeight->"Plain"], 
    RowBox[{
     StyleBox["#",
      FontWeight->"Plain"], 
     StyleBox[",",
      FontWeight->"Plain"], 
     RowBox[{
      StyleBox["PlotRange",
       FontWeight->"Plain"], 
      StyleBox["\[Rule]",
       FontWeight->"Plain"], "All"}]}], 
    StyleBox["]",
     FontWeight->"Plain"]}], 
   StyleBox["&",
    FontWeight->"Plain"]}]}]], "Input",
 CellChangeTimes->{{3.461322726939172*^9, 3.461322767575614*^9}, {
  3.461322837211657*^9, 3.461322840424758*^9}, {3.461322885126048*^9, 
  3.461322942141605*^9}, {3.461323174166301*^9, 3.4613231926574097`*^9}, {
  3.4613232427513866`*^9, 3.461323279377577*^9}, {3.461323314819504*^9, 
  3.461323315574494*^9}}],

Cell[BoxData[
 Graphics3DBox[{
   {Hue[0.67, 0.6, 0.6], Point3DBox[CompressedData["
1:eJwNlWs41Hkfxv9zYAZtqxYPm8OwnR5bOaSlg/3+QrsJ+7AobZTVaLXNikSj
VU1JJCHZyCFyCimTQyH8hpySFXLMJIeSsxkzxozj48X97r6u+8Xn+ly3rsfZ
Xz3JBEEwV0NZjcBLuv7Ft8sQkNLOpohG8HXXmvl7V2RYyvrIsFGUALu5o7U5
mA9bbrw85G5B4bEOf0upiJmFMs8Z4+07OsDK3E0xcEoGHHzqK8aYDIpMdibe
F4qAz7W73f1AGaUSD7/arToHi/GRl98YyqPK97tKNusqIPaVHfK50Uug+TRa
OaJMgPkdzfnwjRjX0GZWnHVmIHXuYkLLyitwOZ4YHOohjwQpRHhF40fIelfL
Pyo3DF6diqXxtfNQQ0wZKNgKIOeETjuXOguijxs2CjYRPOKK/LflARVg4Vf1
ZvGhCMTRDS1mpAkcFp3CKngqwHVZMtWBok/QR4xbHH0nwQ/cLKp2Z9HQJQ3/
J4kiKYRrW7vqZK1H7h483boPX6Bf6c7h5KkC7MoJOa1i1wjG36iFrcTTELOY
wfsxfxlHpry+MuotwdKCmimdlyPQ53D1XDGDjg6edHZgXxWDl6XP6fLGJeDK
ZS2MTlPQztGJ7NStCsj72aXy3E45dPDRV26pPkMYpnMdE0ulYFgaIjwWMQkX
qTvfuFVQkdVcle9NJwWUKl0i9o6IATm+yVTS7MQ1OvWBp52nMedM3/4RzWfQ
HZOwN8FXgOlbuudK+6eA+13Y1Dn1OfDeIm/hNkRBvI2Jtnlq8ojzx6yhyd4B
qAu2UlEJkkMS30SmqrMIOKOb9v/6dyHOq8rcZXqAhqREi/kelzHM35eR7K9E
oCLlCOJAXD9Wn0nqG1PgY/uBtGrPhmXY1uoSFc0XweFpk6k6hSHoj8tt8m2f
g+sG+ebyBwTwzLHzVOlvw8C5sFj9b2sFZr5yLw/Rk0MPpN1M18gFQCmS86MW
VcCz2F34yu8FDuz1NzYtIaH+8HL/9vReiHLKU1IxoqNlRS31G0lU1FDo08At
nIUYzYwTko9CiCvy1g/ZQ0Nhmq7nL2ouAbUyKj+aMoNjVdJ+FhTRecRZ0sbn
57Ih49KFA9VXyOiu2m5bfeHXiHB3StkSHQvd7bV7A3pmgO56aOCoUz1GGspd
n5brsfhY6bj/1BhEro3wG84YBp/kSY+VTBGwT+U6EGazoHsz4ZYhTEGTtv55
/3gxcNgHtEJil6EiT2Yonqchr+PvQpNOLsBi5EmjE/FzeLNFhr9v7hJGTxIi
ze/1wS8Mv+rQCRpCdPQ1vQ+D2e6YEaMkIWi9T19T+EUO1TD+Ud3AJyG07+xk
wmsq6qgXPyZryiGm0nYTpgYN2fZftd7zRQTPB3NyUshkpOSkGnIMS4A46/Ln
HpyJO/fFPHl5eRHOqfxradFDRy60hEO5ZTOQ3WGtV2G+BE3H8k1MpvnYNUXw
2maXGJwatPhBRz5iq/NxpmzBAubZM/e3MVqAMX+09OeQXKAGB6Drn9chQsiO
WnDuBV5hp9nABjrar1dEbTIioYnTQZuf3JdC43pnIYNMIOaapy+Kry+B146A
UlbbLOglsmsZ2VKIyqcOl2lSEDGkpoMNhnB82w6DMzp0pH/zXavEeR6iFce6
PqrxcWIJt/lyKxl5zLDaj5BIyN6lzyfdQgLqbmtja3SngLNNzToUcoBjd5wV
nCCPot9Umcwrz8FWQvw4bG09PohNt+mtCKDYuPWArqkMXKaveY7L5FH/wzUb
HgsHoSRJONZi+QbnfrI8q3pLhtu+PFtS+UMeHU93/OOWLx+uRzhJQ2vXInrJ
LRWfC4OQb+NvExO1BCcehuhbVq9HjGXtumDvcWBrKpR4PC+F7sTHvVm2q7xe
zcSVuwgANeuvhCt24a07OOTTl4cgW2tDov5zCprNm5R/VDIC6Ayb7WNWht3p
eYHffT8Dzd8Jg/xLFuCXjI1b1zXPQItHbIEZfxZ+GK9bmRgkozNcyk3nXmXE
GCPfq9Qex+KMaCfBb3TEX5YzWvy7HXN65snapwch6SjLp9ytH7MnX9hWnn0L
7dsekDqKF6Co+16LvK4Yijolhl+HLgBzQMdOWCMBFlMsivkfBVk8kJLJjeNg
0sWTuxYqg1M91eK0YILHefnS5NDLW5i183ZCUZcICO08q/LcVxjRNZTWuH6D
PoWzbW/HrfLxqta/a/UZKhT1Lu9To6KDsnC2v7cERgaguOb5IvR+6iWpbBmF
/gYD683/jGJzkiSgOoGM9A17jdOLZjDxJ2/nHb8QaLbys3ZOpaHj+wqt/5Mu
jwy1VOy0uqTATprteKolAnB3ovzuPgguZQ71GbVDwH3spF602oshaySRcySQ
WtGo1LNuDFTWRbq2OPWC8ra0xc8pdeBifpeb/rMMqDRuLEdDAlku63XUbq5D
SGXenXX1FY5Mzm4X2yijkmveXY1Rg6A85JV4NZCOzpeI3qobiqBsZsDK2Kgf
p9KWm+yDR4FQ4t7+tTUNCjKU5H7ybAV75+SxDOEipBbzWH8RmTiBNJJuGkhF
xHJB3t3Az2B6ziDkt/tUxKnT3hVeMgmcPr5atC4Vmbnu+PNQ3wdcFN3subup
E1B3zGRuQRUMe1G5NZxBODJ7MULmQUI1pXlUBUcysg+TaMkqB/H3F0/WK7xf
3Rs59iCPIoWnw3c0W1Y9LqDKOGk6EuA6WZIUzLuwobISbqW8BReddgfdC69B
4Prhd9XXU5htvW9gU6YSarh++xHzLwLZF0+fNB+ZBwvHTy/aJidxpULyP6y/
lBFn8OJ7vf2T0N9G4dnwuDhs4eA2s/u1OKIie3tY8wpMtAdcFfoM4Bzepji/
1f+qceErNweJcJxxuiyfSyA0axP/Q+0ITtVOtMkw+gyZCUfLVYVSYFiEajvu
GgPCf3Kc6t0OPF7OjfTkPFxkF0t0Ns0Bj2kSEYMn4f4Sr5rMkeNtXv/ftsHb
i7i7zCjwJ1sJnLsDLMsGMTRoF7a3JIxgTqXN29aeD3Dy3eK6xGMkdIHprjbt
veqjxmMSAQNgxGn+YbvdZ2ipOVLQs0GITVzfqTskLsCE4syN+eOjEHY5yC8s
cxJ4z5nWxeRufPjH2lMLqRPQ9mUoTc1yDm9dcugMeDYPQUYeo99fEoP/Fpo8
lUVGjGcWpwrHXoO77wWqqGUQOxl89HxEU+T9H+f3sJ8=
     "]]}, 
   GraphicsComplex3DBox[CompressedData["
1:eJxlm3k8Vdv//4/DMRzTMVMpSWUMTVeUs6OkDFFouKZUhiZ001zGSjRQGkwV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    "], {
     {RGBColor[1, 0, 0], Opacity[0.3], EdgeForm[None], 
      GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJwt1WlQTlEYwPF73hZLxjIZGhIJkbRQ0reyDcpY0mTIqCwRCkNTYaSyjHXG
vq+FoQwhydYi+zqTGcsM2SVZypKs/zPn+fCb59x7z3nuued9znnd45JGJ9os
y1oPOyjYpH2Gi1qcxHd8ww/U4ycaUIJfuIDz0qcQFWhEogfEu7DRvifJrxHL
lYn6upT4D5dxEU1tZqwj5tNlHpIxG0mYAz/MhTemYhImIxZTEIfFGIhQxGMa
pkvU1wmIRgwmIArjMRapSEGaXhPmcYd53VZmPoHwlbFd4YkZmIlZ2C459Rw+
MKYaNdiO+9gh6+lN3jqiM7ElWuAl1y7EV8qM7UC7itidOAAe6Ax3aV/n2Qas
QTz84ItZCEQfac9EIm5gEzYqkycEbjYzh2C0Rm/YwwF59HuHI7iFbdiKzbiJ
LcrMuRLPkC3tHDxEM3I8kt80AE7wx1+pnwpZE10bv/X8babG7GUeugZ8babe
vqIfkhCgzDrvxg7sx07s0nWLTziFWnxBHc7Jb6pr6SAO4TCKUYYS6V+EAnTi
He56neS9QQjGU561Iz4htlem7Sp99RgPXOFZBtIt0y7HVZmDzn8eH2Wen/Ee
J5An7SpUoxLP8QJv8BpvcVz2QoJ8byHO4rTsF71H/lhmzg3EXByV/LpWj8le
yJf3nsQeZGMveun6hA8ec91G/55Ed6n5zvDR/WQvOMAejuiGHrIvnNAUzeSe
ftYdbeEKF2TKWmVhFdZhtbRHYCS80NMy+13vfX/0Rpj0CUeE5HRDPX7gJ37J
+pfq9yrzLS5oheZoAUc46DMLTdBY16yuS8u07xAHWeY8GSzro+uqBn0tcyYE
IQf7cAAh8u16TQbRfxEGYCD17IUuCJX32slZWqzMeZiJDGRhKYZjKGLQA55I
RQrS5P5ExCpzDp9T5kweg7UYLXmWYTnGYxyiMQorMQKrpL0a6xGFCJQpcz6X
S59LWIGOiJT6D8MwhEv+brIX1un9IDkjZYybfGMB0uVbcpGMIpnnEmXOH33/
mDJrFYL+8i69PkOU+Z/SefT/jrPMoSUWIB8L8R9jU9Cx
         "]], 
        Polygon3DBox[CompressedData["
1:eJxFmHlwltUVh9/7oZI0hLAFCDQEFBBZZTcJJEBEBIsV1AAuMKC4iwptrYpQ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         "]], 
        Polygon3DBox[CompressedData["
1:eJwt1WdsjlEUwPF732ppxayoTVtaHUqHqt3atFQoghArUau1YoZQWyuEDxKN
L2Kl0aKlpUarVSVGEMQHsSVi7039T+758Mv7Pve9z33OPc895w2cljkqw2OM
mQxvNOEiAM3wzBrzCMOxAZuwBSPQhd87IRLfuP6O49xfiGM4gnwE8nsIQtER
wejA3CAE4hlzHmMN31djFQZiEFKxFdnYjBScYO5RFGAO5iFTnynPPokFGMLc
LKyzbm1ZbxHjp1Bi3Dpy7xd8wHsdP40sXEI1rmC9cbEGIwQvjIu7K9/nIQML
EK/xyVrv8EZjncX4XJ0bi2i8ZfwjPqEYRahAlT57DVahIfny97j3Iu/iAfpi
GZZjCXpjIeYjEwnojpfc/xRPcBCH0YXxmUjHDERYl8tDyMNMiVc/8/Q9Sm5n
YzUuohLlWCnxcf8wJFuX83oSG+NncBZlWIEwxqdgKqYjXLCnMETImUB7jztD
r/DauBxJXu6jKfMD0AT39LxOx1RZGx0RgVhEyz4RqWdjPjKQrvuoxXM8sPCC
t+SW8bas3Qot8FD2ymcN/sIwp0rzfQT5yMNitMN4TMBEPSdLjTtvCzWWGOPW
kLV+4wIq0IzhkUhFMvxxi/E7uIu9yJW4GB+NNJ0v9/mhLny1dn3kvEkdohAr
JQ5cRjWuoNK6fbTGOIzFGLTRT7lOQ0vNxVps1PofisHWxbAD25Gt8cg+52qe
wzX3UnfFKEGR1vcX/MQPnJZ6wXnrci2xSX+RPlOOSxr3Zc2V5CAAzdEabYyb
I3PLtE/k4J++sxp9zi90kBpGMEIQquchQ+Oeo+de9lqqsZ3XWLoyHo84RKGz
1ulv/EGN9optzN2FnRiNkdb1sBStEX89vzGcg1jEwQ8+6MN4IpLgBYt4xhPQ
XXtAA4/rGZ34Lcq6PvKZ655a791k31z/M65frreuByZrDP25PwmJCNJeLO+i
M59RiPa4XP0ybi3pI3H4Zly9Rlr37Ldan1/xHT+0zqXeS43raZ/1dxmrzz2N
0FjONde3pT/oOyvXWjiHWrIX9EKinufH1v0PPcchHEAfxhPQA1waL+lRfCmw
rjalL67QPHrDB9eZcxU3UIdrX3kerhk3R/LeDwNQ27o+5mfd3JtSk5iCPcjF
bkzSupUayJGcI8W4Hi29WmLfj334D4Yg31s=
         "]], 
        Polygon3DBox[CompressedData["
1:eJwt0DsrxmEYB+A/icIsEUUhg0yyUthZDMghjA6FmAiTxKLkTY6jXpuXHL6A
s6LE7mwhDAwueYarnp677sOvoKO3oSc5iqIsUimlnQ7aaKaERdZYZ5VuOqlg
kCGGGaGSGkYZY5wJ6uhimRWWiIVZRWFWC000UkiB5QrJJ4+XpCh65Zsfvvhg
nwOOOOOcC2LMk65XFdVht1oyKVZroplW2ihhhlmmmaKeBhY45oRTDpmjTK8+
+hkImZSH9xYJdtkLWe2FnXdIMMEkG2p33PPIE3Gek/5vf+SBOJvh9k/eeWM7
9EyWVQqppHEZMvl7p5NBJtf+rsghl2yyuDHzll8orEX0
         "]]}]}, {}, {}, {}, {}},
    
    VertexNormals->CompressedData["
1:eJwVmnk4lO8XxslaUcqaZKuEFskSkmNrlTYlRNYoUUQqW76ktNCCkq2EkpRk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     "]]},
  AutomaticImageSize->True,
  Axes->True,
  BoxRatios->{1, 1, 0.4},
  ImageSize->{414.1473138748747, 242.54143155221016`},
  PlotRange->All,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.02]}, {Automatic, Automatic}},
  ViewPoint->{-1.7378626748645887`, -2.6853754389711773`, 1.103898580071041},
  ViewVertical->{-0.3339746352025216, -0.1458312201422681, 
   2.3280815576794662`}]], "Output",
 CellChangeTimes->{
  3.461322840895993*^9, {3.461322894633264*^9, 3.461322942868186*^9}, {
   3.4613231751542253`*^9, 3.461323193020932*^9}, 3.461323244066985*^9, 
   3.4613232810276623`*^9, 3.4613233157526073`*^9, 3.4613252556505613`*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"line", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"t", " ", 
         RowBox[{"Sin", "[", "t", "]"}]}], ",", 
        RowBox[{"t", " ", 
         RowBox[{"Cos", "[", "t", "]"}]}], ",", "t"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"t", ",", "0", ",", "20", ",", 
        RowBox[{"dt", "=", ".1"}]}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ki", "[", "t_", "]"}], ":=", 
  StyleBox[
   RowBox[{"KonfidenzEllipse3", "[", 
    RowBox[{
     RowBox[{"line", "[", 
      RowBox[{"[", "t", "]"}], "]"}], ",", " ", "Sigma", ",", " ", ".95", ",",
      " ", "White", ",", " ", ".4", ",", " ", "1"}], "]"}],
   FontWeight->"Plain"]}]}], "Input",
 CellChangeTimes->{{3.46132383343316*^9, 3.461323838352523*^9}, {
   3.461323959666073*^9, 3.461323984834375*^9}, {3.46132403082036*^9, 
   3.4613240968649807`*^9}, {3.461324659863577*^9, 3.461324678944298*^9}, 
   3.46132470941498*^9, {3.4613253838785467`*^9, 3.461325412779386*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Blue", ",", "Thick", ",", 
       RowBox[{"Line", "[", "line", "]"}]}], "}"}], "//", "Graphics3D"}], ",", 
    RowBox[{"ki", "[", 
     RowBox[{"1", "/", "dt"}], "]"}], ",", 
    RowBox[{"ki", "[", 
     RowBox[{"15", "/", "dt"}], "]"}], ",", 
    RowBox[{"ki", "[", 
     RowBox[{"10", "/", "dt"}], "]"}], ",", 
    RowBox[{"ki", "[", 
     RowBox[{"20", "/", "dt"}], "]"}]}], 
   StyleBox["}",
    FontWeight->"Plain"]}], 
  StyleBox["//",
   FontWeight->"Plain"], 
  StyleBox["Show",
   FontWeight->"Plain"]}]], "Input",
 CellChangeTimes->{{3.46132350567476*^9, 3.461323510237214*^9}, {
  3.4613236385942717`*^9, 3.4613236411910973`*^9}, {3.461323695060096*^9, 
  3.461323895564591*^9}, {3.461323929818264*^9, 3.461323957178216*^9}, {
  3.461323989504697*^9, 3.461324023287695*^9}, {3.461324099907757*^9, 
  3.461324107128437*^9}, {3.461324726336995*^9, 3.4613247490452433`*^9}}],

Cell[BoxData[
 Graphics3DBox[{
   {RGBColor[0, 0, 1], Thickness[Large], Line3DBox[CompressedData["
1:eJx11nk81Nv/B3C7kX2sM7YZM2NmbLOVtH7eUsnlolWLtYUWRUWrytKikrRx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     "]]}, GraphicsComplex3DBox[CompressedData["
1:eJxlm3k0VV3cx7nXcM3XPCSiFDIkoUGdExqUUho8TSpKpRIPJY2KIj3JVEko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    "], {
     {GrayLevel[1], Opacity[0.4], EdgeForm[None], 
      GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJwt1WlQTlEYwPF73hZLxjIZGhIJkbRQ0reyDcpY0mTIqCwRCkNTYaSyjHXG
vq+FoQwhydYi+zqTGcsM2SVZypKs/zPn+fCb59x7z3nuued9znnd45JGJ9os
y1oPOyjYpH2Gi1qcxHd8ww/U4ycaUIJfuIDz0qcQFWhEogfEu7DRvifJrxHL
lYn6upT4D5dxEU1tZqwj5tNlHpIxG0mYAz/MhTemYhImIxZTEIfFGIhQxGMa
pkvU1wmIRgwmIArjMRapSEGaXhPmcYd53VZmPoHwlbFd4YkZmIlZ2C459Rw+
MKYaNdiO+9gh6+lN3jqiM7ElWuAl1y7EV8qM7UC7itidOAAe6Ax3aV/n2Qas
QTz84ItZCEQfac9EIm5gEzYqkycEbjYzh2C0Rm/YwwF59HuHI7iFbdiKzbiJ
LcrMuRLPkC3tHDxEM3I8kt80AE7wx1+pnwpZE10bv/X8babG7GUeugZ8babe
vqIfkhCgzDrvxg7sx07s0nWLTziFWnxBHc7Jb6pr6SAO4TCKUYYS6V+EAnTi
He56neS9QQjGU561Iz4htlem7Sp99RgPXOFZBtIt0y7HVZmDzn8eH2Wen/Ee
J5An7SpUoxLP8QJv8BpvcVz2QoJ8byHO4rTsF71H/lhmzg3EXByV/LpWj8le
yJf3nsQeZGMveun6hA8ec91G/55Ed6n5zvDR/WQvOMAejuiGHrIvnNAUzeSe
ftYdbeEKF2TKWmVhFdZhtbRHYCS80NMy+13vfX/0Rpj0CUeE5HRDPX7gJ37J
+pfq9yrzLS5oheZoAUc46DMLTdBY16yuS8u07xAHWeY8GSzro+uqBn0tcyYE
IQf7cAAh8u16TQbRfxEGYCD17IUuCJX32slZWqzMeZiJDGRhKYZjKGLQA55I
RQrS5P5ExCpzDp9T5kweg7UYLXmWYTnGYxyiMQorMQKrpL0a6xGFCJQpcz6X
S59LWIGOiJT6D8MwhEv+brIX1un9IDkjZYybfGMB0uVbcpGMIpnnEmXOH33/
mDJrFYL+8i69PkOU+Z/SefT/jrPMoSUWIB8L8R9jU9Cx
         "]], 
        Polygon3DBox[CompressedData["
1:eJxFmHlwltUVh9/7oZI0hLAFCDQEFBBZZTcJJEBEBIsV1AAuMKC4iwptrYpQ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         "]], 
        Polygon3DBox[CompressedData["
1:eJwt1WdsjlEUwPF732ppxayoTVtaHUqHqt3atFQoghArUau1YoZQWyuEDxKN
L2Kl0aKlpUarVSVGEMQHsSVi7039T+758Mv7Pve9z33OPc895w2cljkqw2OM
mQxvNOEiAM3wzBrzCMOxAZuwBSPQhd87IRLfuP6O49xfiGM4gnwE8nsIQtER
wejA3CAE4hlzHmMN31djFQZiEFKxFdnYjBScYO5RFGAO5iFTnynPPokFGMLc
LKyzbm1ZbxHjp1Bi3Dpy7xd8wHsdP40sXEI1rmC9cbEGIwQvjIu7K9/nIQML
EK/xyVrv8EZjncX4XJ0bi2i8ZfwjPqEYRahAlT57DVahIfny97j3Iu/iAfpi
GZZjCXpjIeYjEwnojpfc/xRPcBCH0YXxmUjHDERYl8tDyMNMiVc/8/Q9Sm5n
YzUuohLlWCnxcf8wJFuX83oSG+NncBZlWIEwxqdgKqYjXLCnMETImUB7jztD
r/DauBxJXu6jKfMD0AT39LxOx1RZGx0RgVhEyz4RqWdjPjKQrvuoxXM8sPCC
t+SW8bas3Qot8FD2ymcN/sIwp0rzfQT5yMNitMN4TMBEPSdLjTtvCzWWGOPW
kLV+4wIq0IzhkUhFMvxxi/E7uIu9yJW4GB+NNJ0v9/mhLny1dn3kvEkdohAr
JQ5cRjWuoNK6fbTGOIzFGLTRT7lOQ0vNxVps1PofisHWxbAD25Gt8cg+52qe
wzX3UnfFKEGR1vcX/MQPnJZ6wXnrci2xSX+RPlOOSxr3Zc2V5CAAzdEabYyb
I3PLtE/k4J++sxp9zi90kBpGMEIQquchQ+Oeo+de9lqqsZ3XWLoyHo84RKGz
1ulv/EGN9optzN2FnRiNkdb1sBStEX89vzGcg1jEwQ8+6MN4IpLgBYt4xhPQ
XXtAA4/rGZ34Lcq6PvKZ655a791k31z/M65frreuByZrDP25PwmJCNJeLO+i
M59RiPa4XP0ybi3pI3H4Zly9Rlr37Ldan1/xHT+0zqXeS43raZ/1dxmrzz2N
0FjONde3pT/oOyvXWjiHWrIX9EKinufH1v0PPcchHEAfxhPQA1waL+lRfCmw
rjalL67QPHrDB9eZcxU3UIdrX3kerhk3R/LeDwNQ27o+5mfd3JtSk5iCPcjF
bkzSupUayJGcI8W4Hi29WmLfj334D4Yg31s=
         "]], 
        Polygon3DBox[CompressedData["
1:eJwt0DsrxmEYB+A/icIsEUUhg0yyUthZDMghjA6FmAiTxKLkTY6jXpuXHL6A
s6LE7mwhDAwueYarnp677sOvoKO3oSc5iqIsUimlnQ7aaKaERdZYZ5VuOqlg
kCGGGaGSGkYZY5wJ6uhimRWWiIVZRWFWC000UkiB5QrJJ4+XpCh65Zsfvvhg
nwOOOOOcC2LMk65XFdVht1oyKVZroplW2ihhhlmmmaKeBhY45oRTDpmjTK8+
+hkImZSH9xYJdtkLWe2FnXdIMMEkG2p33PPIE3Gek/5vf+SBOJvh9k/eeWM7
9EyWVQqppHEZMvl7p5NBJtf+rsghl2yyuDHzll8orEX0
         "]]}]}, {}, {}, {}, {}},
    
    VertexNormals->CompressedData["
1:eJwVmnc01f8fx20qSplJViWjklBIXlZJaGkgyoq+Ioo0jIpEAxVKVgmFlJSV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     "]], GraphicsComplex3DBox[CompressedData["
1:eJxlm3lUjs3/x6OSCD2t2uve77v1bqEIY6mksi9JyhIlKRJfkuxlaVFCpZIe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    "], {
     {GrayLevel[1], Opacity[0.4], EdgeForm[None], 
      GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJwt1WlQTlEYwPF73hZLxjIZGhIJkbRQ0reyDcpY0mTIqCwRCkNTYaSyjHXG
vq+FoQwhydYi+zqTGcsM2SVZypKs/zPn+fCb59x7z3nuued9znnd45JGJ9os
y1oPOyjYpH2Gi1qcxHd8ww/U4ycaUIJfuIDz0qcQFWhEogfEu7DRvifJrxHL
lYn6upT4D5dxEU1tZqwj5tNlHpIxG0mYAz/MhTemYhImIxZTEIfFGIhQxGMa
pkvU1wmIRgwmIArjMRapSEGaXhPmcYd53VZmPoHwlbFd4YkZmIlZ2C459Rw+
MKYaNdiO+9gh6+lN3jqiM7ElWuAl1y7EV8qM7UC7itidOAAe6Ax3aV/n2Qas
QTz84ItZCEQfac9EIm5gEzYqkycEbjYzh2C0Rm/YwwF59HuHI7iFbdiKzbiJ
LcrMuRLPkC3tHDxEM3I8kt80AE7wx1+pnwpZE10bv/X8babG7GUeugZ8babe
vqIfkhCgzDrvxg7sx07s0nWLTziFWnxBHc7Jb6pr6SAO4TCKUYYS6V+EAnTi
He56neS9QQjGU561Iz4htlem7Sp99RgPXOFZBtIt0y7HVZmDzn8eH2Wen/Ee
J5An7SpUoxLP8QJv8BpvcVz2QoJ8byHO4rTsF71H/lhmzg3EXByV/LpWj8le
yJf3nsQeZGMveun6hA8ec91G/55Ed6n5zvDR/WQvOMAejuiGHrIvnNAUzeSe
ftYdbeEKF2TKWmVhFdZhtbRHYCS80NMy+13vfX/0Rpj0CUeE5HRDPX7gJ37J
+pfq9yrzLS5oheZoAUc46DMLTdBY16yuS8u07xAHWeY8GSzro+uqBn0tcyYE
IQf7cAAh8u16TQbRfxEGYCD17IUuCJX32slZWqzMeZiJDGRhKYZjKGLQA55I
RQrS5P5ExCpzDp9T5kweg7UYLXmWYTnGYxyiMQorMQKrpL0a6xGFCJQpcz6X
S59LWIGOiJT6D8MwhEv+brIX1un9IDkjZYybfGMB0uVbcpGMIpnnEmXOH33/
mDJrFYL+8i69PkOU+Z/SefT/jrPMoSUWIB8L8R9jU9Cx
         "]], 
        Polygon3DBox[CompressedData["
1:eJxFmHlwltUVh9/7oZI0hLAFCDQEFBBZZTcJJEBEBIsV1AAuMKC4iwptrYpQ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         "]], 
        Polygon3DBox[CompressedData["
1:eJwt1WdsjlEUwPF732ppxayoTVtaHUqHqt3atFQoghArUau1YoZQWyuEDxKN
L2Kl0aKlpUarVSVGEMQHsSVi7039T+758Mv7Pve9z33OPc895w2cljkqw2OM
mQxvNOEiAM3wzBrzCMOxAZuwBSPQhd87IRLfuP6O49xfiGM4gnwE8nsIQtER
wejA3CAE4hlzHmMN31djFQZiEFKxFdnYjBScYO5RFGAO5iFTnynPPokFGMLc
LKyzbm1ZbxHjp1Bi3Dpy7xd8wHsdP40sXEI1rmC9cbEGIwQvjIu7K9/nIQML
EK/xyVrv8EZjncX4XJ0bi2i8ZfwjPqEYRahAlT57DVahIfny97j3Iu/iAfpi
GZZjCXpjIeYjEwnojpfc/xRPcBCH0YXxmUjHDERYl8tDyMNMiVc/8/Q9Sm5n
YzUuohLlWCnxcf8wJFuX83oSG+NncBZlWIEwxqdgKqYjXLCnMETImUB7jztD
r/DauBxJXu6jKfMD0AT39LxOx1RZGx0RgVhEyz4RqWdjPjKQrvuoxXM8sPCC
t+SW8bas3Qot8FD2ymcN/sIwp0rzfQT5yMNitMN4TMBEPSdLjTtvCzWWGOPW
kLV+4wIq0IzhkUhFMvxxi/E7uIu9yJW4GB+NNJ0v9/mhLny1dn3kvEkdohAr
JQ5cRjWuoNK6fbTGOIzFGLTRT7lOQ0vNxVps1PofisHWxbAD25Gt8cg+52qe
wzX3UnfFKEGR1vcX/MQPnJZ6wXnrci2xSX+RPlOOSxr3Zc2V5CAAzdEabYyb
I3PLtE/k4J++sxp9zi90kBpGMEIQquchQ+Oeo+de9lqqsZ3XWLoyHo84RKGz
1ulv/EGN9optzN2FnRiNkdb1sBStEX89vzGcg1jEwQ8+6MN4IpLgBYt4xhPQ
XXtAA4/rGZ34Lcq6PvKZ655a791k31z/M65frreuByZrDP25PwmJCNJeLO+i
M59RiPa4XP0ybi3pI3H4Zly9Rlr37Ldan1/xHT+0zqXeS43raZ/1dxmrzz2N
0FjONde3pT/oOyvXWjiHWrIX9EKinufH1v0PPcchHEAfxhPQA1waL+lRfCmw
rjalL67QPHrDB9eZcxU3UIdrX3kerhk3R/LeDwNQ27o+5mfd3JtSk5iCPcjF
bkzSupUayJGcI8W4Hi29WmLfj334D4Yg31s=
         "]], 
        Polygon3DBox[CompressedData["
1:eJwt0DsrxmEYB+A/icIsEUUhg0yyUthZDMghjA6FmAiTxKLkTY6jXpuXHL6A
s6LE7mwhDAwueYarnp677sOvoKO3oSc5iqIsUimlnQ7aaKaERdZYZ5VuOqlg
kCGGGaGSGkYZY5wJ6uhimRWWiIVZRWFWC000UkiB5QrJJ4+XpCh65Zsfvvhg
nwOOOOOcC2LMk65XFdVht1oyKVZroplW2ihhhlmmmaKeBhY45oRTDpmjTK8+
+hkImZSH9xYJdtkLWe2FnXdIMMEkG2p33PPIE3Gek/5vf+SBOJvh9k/eeWM7
9EyWVQqppHEZMvl7p5NBJtf+rsghl2yyuDHzll8orEX0
         "]]}]}, {}, {}, {}, {}},
    
    VertexNormals->CompressedData["
1:eJwVmnk0lO8bxilbohQiSaiEkoRSyY1IhTbli8gaZYkiLSSR0mIpZBehUMpO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     "]], GraphicsComplex3DBox[CompressedData["
1:eJxtm3k0Vd///823zFyu695ruLi4xqJUlI7QIBpEKUWhNBFNaI7SJGUoGUrJ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    "], {
     {GrayLevel[1], Opacity[0.4], EdgeForm[None], 
      GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJwt1WlQTlEYwPF73hZLxjIZGhIJkbRQ0reyDcpY0mTIqCwRCkNTYaSyjHXG
vq+FoQwhydYi+zqTGcsM2SVZypKs/zPn+fCb59x7z3nuued9znnd45JGJ9os
y1oPOyjYpH2Gi1qcxHd8ww/U4ycaUIJfuIDz0qcQFWhEogfEu7DRvifJrxHL
lYn6upT4D5dxEU1tZqwj5tNlHpIxG0mYAz/MhTemYhImIxZTEIfFGIhQxGMa
pkvU1wmIRgwmIArjMRapSEGaXhPmcYd53VZmPoHwlbFd4YkZmIlZ2C459Rw+
MKYaNdiO+9gh6+lN3jqiM7ElWuAl1y7EV8qM7UC7itidOAAe6Ax3aV/n2Qas
QTz84ItZCEQfac9EIm5gEzYqkycEbjYzh2C0Rm/YwwF59HuHI7iFbdiKzbiJ
LcrMuRLPkC3tHDxEM3I8kt80AE7wx1+pnwpZE10bv/X8babG7GUeugZ8babe
vqIfkhCgzDrvxg7sx07s0nWLTziFWnxBHc7Jb6pr6SAO4TCKUYYS6V+EAnTi
He56neS9QQjGU561Iz4htlem7Sp99RgPXOFZBtIt0y7HVZmDzn8eH2Wen/Ee
J5An7SpUoxLP8QJv8BpvcVz2QoJ8byHO4rTsF71H/lhmzg3EXByV/LpWj8le
yJf3nsQeZGMveun6hA8ec91G/55Ed6n5zvDR/WQvOMAejuiGHrIvnNAUzeSe
ftYdbeEKF2TKWmVhFdZhtbRHYCS80NMy+13vfX/0Rpj0CUeE5HRDPX7gJ37J
+pfq9yrzLS5oheZoAUc46DMLTdBY16yuS8u07xAHWeY8GSzro+uqBn0tcyYE
IQf7cAAh8u16TQbRfxEGYCD17IUuCJX32slZWqzMeZiJDGRhKYZjKGLQA55I
RQrS5P5ExCpzDp9T5kweg7UYLXmWYTnGYxyiMQorMQKrpL0a6xGFCJQpcz6X
S59LWIGOiJT6D8MwhEv+brIX1un9IDkjZYybfGMB0uVbcpGMIpnnEmXOH33/
mDJrFYL+8i69PkOU+Z/SefT/jrPMoSUWIB8L8R9jU9Cx
         "]], 
        Polygon3DBox[CompressedData["
1:eJxFmHlwltUVh9/7oZI0hLAFCDQEFBBZZTcJJEBEBIsV1AAuMKC4iwptrYpQ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         "]], 
        Polygon3DBox[CompressedData["
1:eJwt1WdsjlEUwPF732ppxayoTVtaHUqHqt3atFQoghArUau1YoZQWyuEDxKN
L2Kl0aKlpUarVSVGEMQHsSVi7039T+758Mv7Pve9z33OPc895w2cljkqw2OM
mQxvNOEiAM3wzBrzCMOxAZuwBSPQhd87IRLfuP6O49xfiGM4gnwE8nsIQtER
wejA3CAE4hlzHmMN31djFQZiEFKxFdnYjBScYO5RFGAO5iFTnynPPokFGMLc
LKyzbm1ZbxHjp1Bi3Dpy7xd8wHsdP40sXEI1rmC9cbEGIwQvjIu7K9/nIQML
EK/xyVrv8EZjncX4XJ0bi2i8ZfwjPqEYRahAlT57DVahIfny97j3Iu/iAfpi
GZZjCXpjIeYjEwnojpfc/xRPcBCH0YXxmUjHDERYl8tDyMNMiVc/8/Q9Sm5n
YzUuohLlWCnxcf8wJFuX83oSG+NncBZlWIEwxqdgKqYjXLCnMETImUB7jztD
r/DauBxJXu6jKfMD0AT39LxOx1RZGx0RgVhEyz4RqWdjPjKQrvuoxXM8sPCC
t+SW8bas3Qot8FD2ymcN/sIwp0rzfQT5yMNitMN4TMBEPSdLjTtvCzWWGOPW
kLV+4wIq0IzhkUhFMvxxi/E7uIu9yJW4GB+NNJ0v9/mhLny1dn3kvEkdohAr
JQ5cRjWuoNK6fbTGOIzFGLTRT7lOQ0vNxVps1PofisHWxbAD25Gt8cg+52qe
wzX3UnfFKEGR1vcX/MQPnJZ6wXnrci2xSX+RPlOOSxr3Zc2V5CAAzdEabYyb
I3PLtE/k4J++sxp9zi90kBpGMEIQquchQ+Oeo+de9lqqsZ3XWLoyHo84RKGz
1ulv/EGN9optzN2FnRiNkdb1sBStEX89vzGcg1jEwQ8+6MN4IpLgBYt4xhPQ
XXtAA4/rGZ34Lcq6PvKZ655a791k31z/M65frreuByZrDP25PwmJCNJeLO+i
M59RiPa4XP0ybi3pI3H4Zly9Rlr37Ldan1/xHT+0zqXeS43raZ/1dxmrzz2N
0FjONde3pT/oOyvXWjiHWrIX9EKinufH1v0PPcchHEAfxhPQA1waL+lRfCmw
rjalL67QPHrDB9eZcxU3UIdrX3kerhk3R/LeDwNQ27o+5mfd3JtSk5iCPcjF
bkzSupUayJGcI8W4Hi29WmLfj334D4Yg31s=
         "]], 
        Polygon3DBox[CompressedData["
1:eJwt0DsrxmEYB+A/icIsEUUhg0yyUthZDMghjA6FmAiTxKLkTY6jXpuXHL6A
s6LE7mwhDAwueYarnp677sOvoKO3oSc5iqIsUimlnQ7aaKaERdZYZ5VuOqlg
kCGGGaGSGkYZY5wJ6uhimRWWiIVZRWFWC000UkiB5QrJJ4+XpCh65Zsfvvhg
nwOOOOOcC2LMk65XFdVht1oyKVZroplW2ihhhlmmmaKeBhY45oRTDpmjTK8+
+hkImZSH9xYJdtkLWe2FnXdIMMEkG2p33PPIE3Gek/5vf+SBOJvh9k/eeWM7
9EyWVQqppHEZMvl7p5NBJtf+rsghl2yyuDHzll8orEX0
         "]]}]}, {}, {}, {}, {}},
    
    VertexNormals->CompressedData["
1:eJwVmnk4VI8Xh0WWRJE1yRYSlYSSyrG1on1BlC1KRJHKniUqJBIhWVLSqmxZ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     "]], GraphicsComplex3DBox[CompressedData["
1:eJxtm3lYjc3/x5MsiUShTfui7ax1OmUbUkRU9qJCKVtRki3xoLSjkq2EyFJo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    "], {
     {GrayLevel[1], Opacity[0.4], EdgeForm[None], 
      GraphicsGroup3DBox[{Polygon3DBox[CompressedData["
1:eJwt1WlQTlEYwPF73hZLxjIZGhIJkbRQ0reyDcpY0mTIqCwRCkNTYaSyjHXG
vq+FoQwhydYi+zqTGcsM2SVZypKs/zPn+fCb59x7z3nuued9znnd45JGJ9os
y1oPOyjYpH2Gi1qcxHd8ww/U4ycaUIJfuIDz0qcQFWhEogfEu7DRvifJrxHL
lYn6upT4D5dxEU1tZqwj5tNlHpIxG0mYAz/MhTemYhImIxZTEIfFGIhQxGMa
pkvU1wmIRgwmIArjMRapSEGaXhPmcYd53VZmPoHwlbFd4YkZmIlZ2C459Rw+
MKYaNdiO+9gh6+lN3jqiM7ElWuAl1y7EV8qM7UC7itidOAAe6Ax3aV/n2Qas
QTz84ItZCEQfac9EIm5gEzYqkycEbjYzh2C0Rm/YwwF59HuHI7iFbdiKzbiJ
LcrMuRLPkC3tHDxEM3I8kt80AE7wx1+pnwpZE10bv/X8babG7GUeugZ8babe
vqIfkhCgzDrvxg7sx07s0nWLTziFWnxBHc7Jb6pr6SAO4TCKUYYS6V+EAnTi
He56neS9QQjGU561Iz4htlem7Sp99RgPXOFZBtIt0y7HVZmDzn8eH2Wen/Ee
J5An7SpUoxLP8QJv8BpvcVz2QoJ8byHO4rTsF71H/lhmzg3EXByV/LpWj8le
yJf3nsQeZGMveun6hA8ec91G/55Ed6n5zvDR/WQvOMAejuiGHrIvnNAUzeSe
ftYdbeEKF2TKWmVhFdZhtbRHYCS80NMy+13vfX/0Rpj0CUeE5HRDPX7gJ37J
+pfq9yrzLS5oheZoAUc46DMLTdBY16yuS8u07xAHWeY8GSzro+uqBn0tcyYE
IQf7cAAh8u16TQbRfxEGYCD17IUuCJX32slZWqzMeZiJDGRhKYZjKGLQA55I
RQrS5P5ExCpzDp9T5kweg7UYLXmWYTnGYxyiMQorMQKrpL0a6xGFCJQpcz6X
S59LWIGOiJT6D8MwhEv+brIX1un9IDkjZYybfGMB0uVbcpGMIpnnEmXOH33/
mDJrFYL+8i69PkOU+Z/SefT/jrPMoSUWIB8L8R9jU9Cx
         "]], 
        Polygon3DBox[CompressedData["
1:eJxFmHlwltUVh9/7oZI0hLAFCDQEFBBZZTcJJEBEBIsV1AAuMKC4iwptrYpQ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         "]], 
        Polygon3DBox[CompressedData["
1:eJwt1WdsjlEUwPF732ppxayoTVtaHUqHqt3atFQoghArUau1YoZQWyuEDxKN
L2Kl0aKlpUarVSVGEMQHsSVi7039T+758Mv7Pve9z33OPc895w2cljkqw2OM
mQxvNOEiAM3wzBrzCMOxAZuwBSPQhd87IRLfuP6O49xfiGM4gnwE8nsIQtER
wejA3CAE4hlzHmMN31djFQZiEFKxFdnYjBScYO5RFGAO5iFTnynPPokFGMLc
LKyzbm1ZbxHjp1Bi3Dpy7xd8wHsdP40sXEI1rmC9cbEGIwQvjIu7K9/nIQML
EK/xyVrv8EZjncX4XJ0bi2i8ZfwjPqEYRahAlT57DVahIfny97j3Iu/iAfpi
GZZjCXpjIeYjEwnojpfc/xRPcBCH0YXxmUjHDERYl8tDyMNMiVc/8/Q9Sm5n
YzUuohLlWCnxcf8wJFuX83oSG+NncBZlWIEwxqdgKqYjXLCnMETImUB7jztD
r/DauBxJXu6jKfMD0AT39LxOx1RZGx0RgVhEyz4RqWdjPjKQrvuoxXM8sPCC
t+SW8bas3Qot8FD2ymcN/sIwp0rzfQT5yMNitMN4TMBEPSdLjTtvCzWWGOPW
kLV+4wIq0IzhkUhFMvxxi/E7uIu9yJW4GB+NNJ0v9/mhLny1dn3kvEkdohAr
JQ5cRjWuoNK6fbTGOIzFGLTRT7lOQ0vNxVps1PofisHWxbAD25Gt8cg+52qe
wzX3UnfFKEGR1vcX/MQPnJZ6wXnrci2xSX+RPlOOSxr3Zc2V5CAAzdEabYyb
I3PLtE/k4J++sxp9zi90kBpGMEIQquchQ+Oeo+de9lqqsZ3XWLoyHo84RKGz
1ulv/EGN9optzN2FnRiNkdb1sBStEX89vzGcg1jEwQ8+6MN4IpLgBYt4xhPQ
XXtAA4/rGZ34Lcq6PvKZ655a791k31z/M65frreuByZrDP25PwmJCNJeLO+i
M59RiPa4XP0ybi3pI3H4Zly9Rlr37Ldan1/xHT+0zqXeS43raZ/1dxmrzz2N
0FjONde3pT/oOyvXWjiHWrIX9EKinufH1v0PPcchHEAfxhPQA1waL+lRfCmw
rjalL67QPHrDB9eZcxU3UIdrX3kerhk3R/LeDwNQ27o+5mfd3JtSk5iCPcjF
bkzSupUayJGcI8W4Hi29WmLfj334D4Yg31s=
         "]], 
        Polygon3DBox[CompressedData["
1:eJwt0DsrxmEYB+A/icIsEUUhg0yyUthZDMghjA6FmAiTxKLkTY6jXpuXHL6A
s6LE7mwhDAwueYarnp677sOvoKO3oSc5iqIsUimlnQ7aaKaERdZYZ5VuOqlg
kCGGGaGSGkYZY5wJ6uhimRWWiIVZRWFWC000UkiB5QrJJ4+XpCh65Zsfvvhg
nwOOOOOcC2LMk65XFdVht1oyKVZroplW2ihhhlmmmaKeBhY45oRTDpmjTK8+
+hkImZSH9xYJdtkLWe2FnXdIMMEkG2p33PPIE3Gek/5vf+SBOJvh9k/eeWM7
9EyWVQqppHEZMvl7p5NBJtf+rsghl2yyuDHzll8orEX0
         "]]}]}, {}, {}, {}, {}},
    
    VertexNormals->CompressedData["
1:eJwVmnk0VP8fxilbosiaJFSyVBIiyZsiZWmjspasfaVSlsqWSGmxZCnZIim0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     "]]},
  AutomaticImageSize->True,
  ImageSize->{406.85603001599065`, 414.50547774565746`},
  ViewPoint->{0.08409267756619554, 3.3767202374831964`, 0.20171479705557016`},
  
  ViewVertical->{-0.7684039370940897, -0.04553280649952527, \
-0.7917728645084076}]], "Output",
 CellChangeTimes->{{3.461323730559655*^9, 3.461323750598239*^9}, 
   3.461323809911983*^9, {3.461323844965106*^9, 3.4613238959331217`*^9}, {
   3.461323937674624*^9, 3.4613239452552137`*^9}, {3.4613239930167847`*^9, 
   3.4613241083084*^9}, {3.461324654301358*^9, 3.4613246822827387`*^9}, {
   3.4613247149525433`*^9, 3.461324751244791*^9}, 3.461325267853207*^9, {
   3.4613253912677937`*^9, 3.461325417051929*^9}}]
}, Open  ]]
},
WindowSize->{1068, 725},
WindowMargins->{{139, Automatic}, {Automatic, 33}},
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (February 18, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 830, 22, 88, "Input"],
Cell[1400, 46, 1138, 31, 71, "Output"],
Cell[2541, 79, 608, 15, 27, "Output"],
Cell[3152, 96, 144, 3, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3333, 104, 230, 6, 27, "Input"],
Cell[3566, 112, 138, 2, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3741, 119, 506, 13, 43, InheritFromParent],
Cell[4250, 134, 1034, 26, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5321, 165, 123, 2, 27, "Input"],
Cell[5447, 169, 854, 23, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6338, 197, 895, 20, 27, "Input"],
Cell[7236, 219, 144311, 2376, 378, "Output"]
}, Open  ]],
Cell[151562, 2598, 4020, 98, 223, "Input"],
Cell[CellGroupData[{
Cell[155607, 2700, 1018, 17, 27, "Input"],
Cell[156628, 2719, 100699, 1665, 387, "Output"]
}, Open  ]],
Cell[257342, 4387, 280, 8, 27, "Input"],
Cell[CellGroupData[{
Cell[257647, 4399, 1248, 40, 27, "Input"],
Cell[258898, 4441, 36517, 615, 258, "Output"]
}, Open  ]],
Cell[295430, 5059, 1092, 28, 58, "Input"],
Cell[CellGroupData[{
Cell[296547, 5091, 981, 26, 27, "Input"],
Cell[297531, 5119, 135059, 2251, 430, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
