(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[   7765541,     156291]
NotebookOptionsPosition[   7566133,     151370]
NotebookOutlinePosition[   7567788,     151422]
CellTagsIndexPosition[   7567560,     151414]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Packs", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData["$Path"], "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"/Applications/Mathematica 7.app/SystemFiles/Links\"\>", 
   ",", "\<\"/Users/hermannsinger/Library/Mathematica/Kernel\"\>", 
   ",", "\<\"/Users/hermannsinger/Library/Mathematica/Autoload\"\>", 
   ",", "\<\"/Users/hermannsinger/Library/Mathematica/Applications\"\>", 
   ",", "\<\"/Library/Mathematica/Kernel\"\>", 
   ",", "\<\"/Library/Mathematica/Autoload\"\>", 
   ",", "\<\"/Library/Mathematica/Applications\"\>", ",", "\<\".\"\>", 
   ",", "\<\"/Users/hermannsinger\"\>", 
   ",", "\<\"/Applications/Mathematica 7.app/AddOns/Packages\"\>", 
   ",", "\<\"/Applications/Mathematica 7.app/AddOns/LegacyPackages\"\>", 
   ",", "\<\"/Applications/Mathematica 7.app/SystemFiles/Autoload\"\>", 
   ",", "\<\"/Applications/Mathematica 7.app/AddOns/Autoload\"\>", 
   ",", "\<\"/Applications/Mathematica 7.app/AddOns/Applications\"\>", 
   ",", "\<\"/Applications/Mathematica 7.app/AddOns/ExtraPackages\"\>", 
   ",", "\<\"/Applications/Mathematica 7.app/SystemFiles/Kernel/Packages\"\>",
    ",", "\<\"/Applications/Mathematica \
7.app/Documentation/English/System\"\>", 
   ",", "\<\"/Mathematica/Hermann.Notebooks/\"\>", 
   ",", "\<\"/Mathematica/HermannMath/\"\>", 
   ",", "\<\"/Mathematica/Packages/\"\>", 
   ",", "\<\"/Mathematica/Packages/Hermann/\"\>", 
   ",", "\<\"/Mathematica/Packages/Hermann/maxent\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.459827814922062*^9, 3.460112527311187*^9, 
  3.4601977848071527`*^9, 3.460254102088344*^9, 3.4602791332835827`*^9, 
  3.460363868632575*^9, 3.4607013454879303`*^9, 3.460712502083445*^9, 
  3.46103540339247*^9, 3.461054572698781*^9, 3.461055704353869*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"<<", 
  "\"\</Mathematica/Hermann.Notebooks/LISREL/SEM/SEM0.4/SEM.impl.m\>\""}], "\
\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"<<", "Graphics`Graphics`"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.460113016354664*^9, 3.460113016433527*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDelayed", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(KroneckerProduct\\), \\\"MT\\\
\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(KroneckerProduct[\\(\\(a_, b_\
\\)\\)]\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/SetDelayed\\\", ButtonNote -> \
\\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.46020112524682*^9, 3.4602541025882597`*^9, 
  3.460279133641471*^9, 3.460363868998948*^9, 3.460701345804173*^9, 
  3.460712502459531*^9, 3.4610354039490128`*^9, 3.461054573174946*^9, 
  3.4610557048990517`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["idiographisches Modell, linear", "Section",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460112339653429*^9, 3.460112348475265*^9}, {
  3.460262521364668*^9, 3.460262523294643*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["Matrizen /SDE", "Subsection",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell["\<\
SDE:
dy  = A y dt + B x dt + G dw
z_t = H y_t + D x_t + eps_t\
\>", "Text",
 FontWeight->"Bold",
 FontColor->RGBColor[0, 0, 1]],

Cell["\<\
EDM:
y_{t+1} = astern y_t + bstern x_t + u_t
z_t = H y_t + D x_t +  eps_t
E[y_0] = mue; Var[y_0] = Sigma; \
\>", "Text",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}},
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0, 0]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Theta", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"phi2", "=", 
     RowBox[{"-", ".5"}]}], ",", 
    RowBox[{"phi1", "=", "1"}], ",", "1", ",", 
    RowBox[{"g", "=", "1"}], ",", "0", ",", "0", ",", "1", ",", "0", ",", 
    "1"}], "}"}]}]], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "0.5`"}], ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", 
   ",", "1", ",", "0", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{3.4598278225657988`*^9, 3.460126886028954*^9, 
  3.4601978054591084`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Unprotect", "[", "A", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Clear", "[", "A", "]"}], "\n", 
 RowBox[{
  RowBox[{"A", "[", 
   RowBox[{"{", 
    RowBox[{
    "\[Omega]02_", ",", "gamma_", ",", "b_", ",", "g_", ",", "mu1_", ",", 
     "mu2_", ",", "Sigma11_", ",", "Sigma12_", ",", "Sigma22_"}], "}"}], 
   "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"0", "-", "1"}], ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\[Omega]02", ",", 
      RowBox[{"gamma", "-", "1"}]}], "}"}]}], "}"}]}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.4598278226896772`*^9, 3.4601268863596087`*^9, 
  3.460197805874611*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"A", "[", "Theta", "]"}], "+", "I2"}], "//", "MatrixForm", "   ", 
  RowBox[{"(*", 
   RowBox[{"Astern", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"phi2", ",", "phi1"}], "}"}]}], "}"}]}], "*)"}]}]], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2"},
      {"1", "0", "1"},
      {"2", 
       RowBox[{"-", "0.5`"}], "1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.4598278227408524`*^9, 3.4601268864310093`*^9, 
  3.460197805974761*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Clear", "[", "B", "]"}], "\n", 
 RowBox[{
  RowBox[{"B", "[", 
   RowBox[{"{", 
    RowBox[{
    "w02_", ",", "gamma_", ",", "b_", ",", "g_", ",", "mu1_", ",", "mu2_", 
     ",", "Sigma11_", ",", "Sigma12_", ",", "Sigma22_"}], "}"}], "]"}], ":=", 
  
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", "0", "}"}], ",", 
    RowBox[{"{", "b", "}"}]}], "}"}]}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"B", "[", "Theta", "]"}]], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "0", "}"}], ",", 
   RowBox[{"{", "1", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.459827822805098*^9, 3.4601268865261707`*^9, 
  3.460197806102346*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Clear", "[", "Omega", "]"}], "\n", 
 RowBox[{
  RowBox[{"Omega", "[", 
   RowBox[{"{", 
    RowBox[{
    "w02_", ",", "gamma_", ",", "b_", ",", "g_", ",", "mu1_", ",", "mu2_", 
     ",", "Sigma11_", ",", "Sigma12_", ",", "Sigma22_"}], "}"}], "]"}], ":=", 
  
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"10", "^", 
       RowBox[{"-", "4"}]}], ",", "0"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", 
      SuperscriptBox["g", "2"]}], "}"}]}], "}"}]}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Omega", "[", "Theta", "]"}]], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     FractionBox["1", "10000"], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.459827822865919*^9, 3.46012688660238*^9, 
  3.46019780622537*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Clear", "[", "Mue", "]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Mue", "[", 
    RowBox[{"{", 
     RowBox[{
     "w02_", ",", "gamma_", ",", "b_", ",", "g_", ",", "mu1_", ",", "mu2_", 
      ",", "Sigma11_", ",", "Sigma12_", ",", "Sigma22_"}], "}"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"mu1", ",", "mu2"}], "}"}]}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{"Clear", "[", "Sigma", "]"}], "\n", 
 RowBox[{
  RowBox[{"Sigma", "[", 
   RowBox[{"{", 
    RowBox[{
    "w02_", ",", "gamma_", ",", "b_", ",", "g_", ",", "mu1_", ",", "mu2_", 
     ",", "Sigma11_", ",", "Sigma12_", ",", "Sigma22_"}], "}"}], "]"}], ":=", 
  "\[IndentingNewLine]", "  ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "root", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"root", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Sigma11", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Sigma12", ",", "Sigma22"}], "}"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"root", ".", 
      RowBox[{"Transpose", "[", "root", "]"}]}]}]}], "]"}]}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Mue", "[", 
  RowBox[{"Theta", "+", "1"}], "]"}]], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{3.45982782292763*^9, 3.460126886685533*^9, 
  3.460197806340096*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Sigma", "[", 
  RowBox[{"{", 
   RowBox[{
   "w02_", ",", "gamma_", ",", "b_", ",", "g_", ",", "mu1_", ",", "mu2_", ",",
     "Sigma11_", ",", "Sigma12_", ",", "Sigma22_"}], "}"}], "]"}]], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SuperscriptBox["Sigma11_", "2"], ",", 
     RowBox[{"Sigma11_", " ", "Sigma12_"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Sigma11_", " ", "Sigma12_"}], ",", 
     RowBox[{
      SuperscriptBox["Sigma12_", "2"], "+", 
      SuperscriptBox["Sigma22_", "2"]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.459827822978806*^9, 3.4601268867866497`*^9, 
  3.460197806466785*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Clear", "[", "H", "]"}], "\n", 
 RowBox[{
  RowBox[{"H", "[", 
   RowBox[{"{", 
    RowBox[{
    "w02_", ",", "gamma_", ",", "b_", ",", "g_", ",", "mu1_", ",", "mu2_", 
     ",", "Sigma11_", ",", "Sigma12_", ",", "Sigma22_"}], "}"}], "]"}], ":=", 
  
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], "}"}]}], "\n", 
 RowBox[{"H", "[", "Theta", "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"1", ",", "0"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.4598278230283947`*^9, 3.4601268868431387`*^9, 
  3.460197806579748*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Clear", "[", "R", "]"}], "\n", 
 RowBox[{
  RowBox[{"R", "[", 
   RowBox[{"{", 
    RowBox[{
    "w02_", ",", "gamma_", ",", "b_", ",", "g_", ",", "mu1_", ",", "mu2_", 
     ",", "Sigma11_", ",", "Sigma12_", ",", "Sigma22_"}], "}"}], "]"}], ":=", 
  
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"10", "^", 
     RowBox[{"-", "2"}]}], "}"}], "}"}]}], "\n", 
 RowBox[{"R", "[", "Theta", "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   FractionBox["1", "100"], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.459827823077408*^9, 3.460126886930704*^9, 
  3.460197807120111*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["EDM", "Subsection",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "Idio", "]"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Idio", "[", 
   RowBox[{"th_", ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "beta", ",", "gamma", ",", "sigma", ",", "\[IndentingNewLine]", 
      "             ", "sigmazeta", ",", "lambdaeta", ",", "taueta", ",", 
      "sigmaepsilon"}], "}"}], ",", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"beta", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
        "\[IndentingNewLine]", "           ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"th", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", "0", ",", "0", ",", "0"}], 
         "}"}], ",", "\[IndentingNewLine]", "          ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"th", "[", 
           RowBox[{"[", "4", "]"}], "]"}], ",", 
          RowBox[{"th", "[", 
           RowBox[{"[", "2", "]"}], "]"}], ",", "0", ",", "0"}], "}"}], ",", 
        "\[IndentingNewLine]", "          ", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", 
          RowBox[{"th", "[", 
           RowBox[{"[", "3", "]"}], "]"}], ",", "0"}], "}"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"gamma", "=", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], "//", 
       "Spalte"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"sigmazeta", "=", "I4"}], ";", "\[IndentingNewLine]", 
     RowBox[{"lambdaeta", "=", "I4"}], ";", "\[IndentingNewLine]", 
     RowBox[{"taueta", "=", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], "//", 
       "Spalte"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"sigmaepsilon", "=", 
      RowBox[{
       RowBox[{"10", "^", 
        RowBox[{"-", "2"}]}], " ", "I4"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"lambdaeta", ",", "taueta", ",", "sigmaepsilon"}], "}"}]}], 
      "}"}]}]}], "\[IndentingNewLine]", "]"}]}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460112411326638*^9, 3.460112486848282*^9}, {
   3.460112574501026*^9, 3.460112833350883*^9}, 3.460113258604714*^9, {
   3.4601981935531387`*^9, 3.4601982253887444`*^9}, {3.46019833150395*^9, 
   3.460198339518457*^9}, {3.460198463453682*^9, 3.460198495668239*^9}, {
   3.4602012679397707`*^9, 3.4602012745935698`*^9}, {3.460437742137166*^9, 
   3.4604377442837257`*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"lambdaeta", ",", "taueta", ",", "sigmaepsilon"}], "}"}]}], 
     "}"}], "=", 
    RowBox[{"Idio", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
      RowBox[{"{", "}"}]}], "]"}]}], ";"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{"beta", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"gamma", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"sigmazeta", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"lambdaeta", "//", "MatrixForm"}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.46011249354161*^9, 3.460112502635364*^9}, {
  3.460112738246236*^9, 3.460112740427596*^9}, {3.4601985014479733`*^9, 
  3.4601985021073637`*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0", "0", "0", "0"},
      {"2", "1", "0", "0", "0"},
      {"3", "4", "2", "0", "0"},
      {"4", "0", "0", "3", "0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, 
   3.460279168666212*^9, 3.460363878029005*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0"},
      {"2", "0"},
      {"3", "0"},
      {"4", "0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, 
   3.460279168666212*^9, 3.4603638780319767`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "1", "0", "0", "0"},
      {"2", "0", "1", "0", "0"},
      {"3", "0", "0", "1", "0"},
      {"4", "0", "0", "0", "1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, 
   3.460279168666212*^9, 3.460363878034649*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "1", "0", "0", "0"},
      {"2", "0", "1", "0", "0"},
      {"3", "0", "0", "1", "0"},
      {"4", "0", "0", "0", "1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, 
   3.460279168666212*^9, 3.460363878036635*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Simulation/dt=1", "Subsection",
 PageWidth->Infinity,
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Theta", "=", 
  RowBox[{"{", 
   RowBox[{"1", ",", "2", ",", ".3", ",", 
    RowBox[{"-", ".1"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", "1"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"q", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"X", "=", 
  RowBox[{"Shape", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", "1"}], "}"}]}], "]"}]}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460112861196432*^9, 3.460112900249464*^9}, {
   3.460112950538982*^9, 3.4601129539374437`*^9}, {3.460113005467535*^9, 
   3.460113006401746*^9}, {3.460113958542322*^9, 3.460113959287684*^9}, 
   3.4601141435117283`*^9, {3.46011422532432*^9, 3.460114228762265*^9}, {
   3.460114299482638*^9, 3.460114299662619*^9}, {3.460120919663384*^9, 
   3.460120925946155*^9}},
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "0.3`", ",", 
   RowBox[{"-", "0.1`"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.45982787174109*^9, {3.460112887861902*^9, 3.460112900786964*^9}, 
   3.460112954913162*^9, {3.460113000282473*^9, 3.460113007967648*^9}, 
   3.460113265712655*^9, 3.460113964238937*^9, 3.460114146876112*^9, 
   3.4601142349213667`*^9, 3.460114304518387*^9, 3.460120929697301*^9, {
   3.460126878115456*^9, 3.460126894622835*^9}, 3.4601274604024973`*^9, 
   3.460197817926371*^9, 3.460198252562779*^9, 3.460198349161854*^9, 
   3.460198506587408*^9, 3.460199526323365*^9, 3.460199563520813*^9, 
   3.460199653793846*^9, 3.4602004848983727`*^9, 3.4602006007365503`*^9, 
   3.460201290106146*^9, 3.460201878664384*^9, 3.460254150649612*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "1", "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.45982787174109*^9, {3.460112887861902*^9, 3.460112900786964*^9}, 
   3.460112954913162*^9, {3.460113000282473*^9, 3.460113007967648*^9}, 
   3.460113265712655*^9, 3.460113964238937*^9, 3.460114146876112*^9, 
   3.4601142349213667`*^9, 3.460114304518387*^9, 3.460120929697301*^9, {
   3.460126878115456*^9, 3.460126894622835*^9}, 3.4601274604024973`*^9, 
   3.460197817926371*^9, 3.460198252562779*^9, 3.460198349161854*^9, 
   3.460198506587408*^9, 3.460199526323365*^9, 3.460199563520813*^9, 
   3.460199653793846*^9, 3.4602004848983727`*^9, 3.4602006007365503`*^9, 
   3.460201290106146*^9, 3.460201878664384*^9, 3.4602541506529818`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["n"], "Input",
 CellChangeTimes->{3.460199566938484*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{{3.4601995670369167`*^9, 3.460199582472732*^9}, 
   3.460199654184558*^9, 3.4602006010382977`*^9, 3.460201878968666*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SeedRandom", "[", "12345689999999", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Y", ",", "X", ",", "ETA"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"ZETA", ",", "EPSILON"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"lambdaeta", ",", "taueta", ",", "sigmaepsilon"}], "}"}]}], 
      "}"}]}], "}"}], "=", "\[IndentingNewLine]", 
   RowBox[{"LISRELsimul", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", ",", "\"\<Gauss[]\>\"", ",", "X"}], "}"}], ",", "Theta", 
     ",", 
     RowBox[{"{", 
      RowBox[{"Idio", ",", 
       RowBox[{"{", "}"}]}], "}"}]}], "]"}]}], ";"}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601129177677603`*^9, 3.46011292950504*^9}, {
  3.4601129714155407`*^9, 3.460112981316517*^9}, {3.460198511433001*^9, 
  3.4601985124151077`*^9}},
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData["beta"], "Input",
 CellChangeTimes->{{3.4601269097587757`*^9, 3.460126910241324*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.1`"}], ",", "2", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0.3`", ",", "0"}], "}"}]}], "}"}]], "Output",\

 CellChangeTimes->{
  3.460126911291768*^9, {3.460127448010219*^9, 3.460127463752602*^9}, 
   3.46019781849335*^9, 3.460198255524288*^9, 3.460198352058052*^9, 
   3.4601985156112556`*^9, 3.4601995266377697`*^9, 3.460199577399457*^9, 
   3.46019965430007*^9, 3.460200566230009*^9, 3.460200601139563*^9, 
   3.460201879055964*^9, 3.460254153231098*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BlaBlaDiagrammMatrix", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "}"}], ",", ".2", ",", 
   "beta", ",", "12"}], "]"}]], "Input",
 CellChangeTimes->{{3.460126926202602*^9, 3.460126926264735*^9}, {
  3.460197837062155*^9, 3.4601978744501877`*^9}, {3.460198176014512*^9, 
  3.4601981763542347`*^9}, {3.460198286470953*^9, 3.460198287074853*^9}, {
  3.460201742748698*^9, 3.46020174505478*^9}, {3.460201843262917*^9, 
  3.460201847980236*^9}, {3.4602030757501917`*^9, 3.460203091242997*^9}, {
  3.460203406030672*^9, 3.460203406841346*^9}, {3.4602037079581614`*^9, 
  3.4602037570505037`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.42828427124746193`"}], ",", "0.5717157287525382`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.15999999999999992`", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.42828427124746193`"}], ",", 
     RowBox[{"-", "0.5717157287525382`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.5717157287525382`", ",", "0.42828427124746193`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "0.15999999999999992`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.42828427124746193`", ",", 
     RowBox[{"-", "0.5717157287525382`"}]}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{
  3.460254917284408*^9, {3.460254963273391*^9, 3.460254988668433*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0], Thickness[0.003], CircleBox[{-1, 0}, 0.2], 
    CircleBox[{0, 1}, 0.2], CircleBox[{1, 0}, 0.2], 
    CircleBox[{0, -1}, 0.2]}, 
   {GrayLevel[0], Thickness[0.003], InsetBox["A", {-0.98, 0.02}], 
    InsetBox["B", {0.02, 1.02}], InsetBox["C", {1.02, 0.02}], 
    InsetBox["D", {0.02, -0.98}]}, 
   {RGBColor[1, 0, 0], Thickness[0.003], 
    ArrowBox[{{-0.8585786437626906, 0.1414213562373095}, {-0.1414213562373095,
      0.8585786437626906}}], ArrowBox[{{-0.8, 0.}, {0.8, 0.}}], 
    ArrowBox[{{0.1414213562373095, 0.8585786437626906}, {0.8585786437626906, 
     0.1414213562373095}}], 
    ArrowBox[{{0.8585786437626906, -0.1414213562373095}, {
     0.1414213562373095, -0.8585786437626906}}]}, 
   {RGBColor[0, 0, 1], Thickness[0.003]}, 
   {RGBColor[1, 0, 0], Thickness[0.003], 
    InsetBox["1", {-0.5282842712474619, 0.4717157287525382},
     Background->RGBColor[1, 0.85, 0.85]], InsetBox[
     RowBox[{"-", "0.1`"}], {0.059999999999999915`, -0.1},
     Background->RGBColor[1, 0.85, 0.85]], 
    InsetBox["2", {0.4717157287525382, 0.32828427124746196`},
     Background->RGBColor[1, 0.85, 0.85]], 
    InsetBox["0.3`", {0.32828427124746196`, -0.6717157287525382},
     Background->RGBColor[1, 0.85, 0.85]]}, 
   {RGBColor[0, 0, 1], Thickness[0.003]}},
  AspectRatio->Automatic,
  BaseStyle->{FontFamily -> "Helvetica", FontSize -> 12},
  Frame->True,
  FrameTicks->False,
  ImageSize->{416., Automatic}]], "Output",
 CellChangeTimes->{
  3.4601269281869783`*^9, 3.460127426082061*^9, 3.460127466329838*^9, {
   3.460127585117103*^9, 3.4601276005862913`*^9}, {3.4601978186150627`*^9, 
   3.4601978754337683`*^9}, {3.4601979922064037`*^9, 3.460198015465253*^9}, {
   3.460198108435659*^9, 3.460198177004368*^9}, {3.460198256947486*^9, 
   3.460198287948544*^9}, 3.460198354151993*^9, 3.460198517017171*^9, 
   3.460199526697234*^9, 3.4601995792704763`*^9, 3.460199654370886*^9, 
   3.460200568819632*^9, 3.460200601192975*^9, 3.460201294388686*^9, 
   3.460201422604823*^9, {3.4602014621856337`*^9, 3.4602014755616083`*^9}, {
   3.460201617064205*^9, 3.460201636172051*^9}, 3.460201746377551*^9, {
   3.4602017858617897`*^9, 3.460201848817997*^9}, 3.460201879133306*^9, {
   3.460203077180921*^9, 3.46020309246707*^9}, {3.460203375574904*^9, 
   3.460203407031555*^9}, {3.460203525933297*^9, 3.460203550744958*^9}, {
   3.460203591076667*^9, 3.4602035982917624`*^9}, 3.460203629545972*^9, {
   3.460203698543215*^9, 3.4602037978560038`*^9}, 3.460254157635613*^9, 
   3.460254917290598*^9, {3.460254963282044*^9, 3.4602549886738853`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"B1", "=", 
    RowBox[{
     RowBox[{"I4", "-", "beta"}], "//", "Inverse"}]}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.4602031193688383`*^9, 3.4602031417504272`*^9}, {
  3.460254264329975*^9, 3.460254272840392*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "1.`", "0.`", "0.`", "0.`"},
      {"2", "1.`", "1.`", "0.`", "0.`"},
      {"3", "1.9`", "2.`", "1.`", "0.`"},
      {"4", "0.57`", "0.6`", "0.3`", "1.`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.460203120570764*^9, 3.460203142571908*^9}, 
   3.460254154939602*^9, {3.460254261383683*^9, 3.460254273739875*^9}, 
   3.460254333610758*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BlaBlaDiagrammMatrix", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "}"}], ",", ".2", ",", "B1", 
   ",", "12"}], "]"}]], "Input",
 CellChangeTimes->{
  3.4602541804489317`*^9, {3.460254277098235*^9, 3.460254280231039*^9}, {
   3.460254509599163*^9, 3.4602545160826283`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.42828427124746193`"}], ",", "0.5717157287525382`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.15999999999999992`", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.42828427124746193`"}], ",", 
     RowBox[{"-", "0.5717157287525382`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.5717157287525382`", ",", "0.42828427124746193`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "0.15999999999999992`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.42828427124746193`", ",", 
     RowBox[{"-", "0.5717157287525382`"}]}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{
  3.4602547523447104`*^9, 3.46025483834556*^9, {3.460254893644129*^9, 
   3.4602548990856533`*^9}, {3.460254933959073*^9, 3.4602549831960707`*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0], Thickness[0.003], CircleBox[{-1, 0}, 0.2], 
    CircleBox[{0, 1}, 0.2], CircleBox[{1, 0}, 0.2], 
    CircleBox[{0, -1}, 0.2]}, 
   {GrayLevel[0], Thickness[0.003], InsetBox["A", {-0.98, 0.02}], 
    InsetBox["B", {0.02, 1.02}], InsetBox["C", {1.02, 0.02}], 
    InsetBox["D", {0.02, -0.98}]}, 
   {RGBColor[1, 0, 0], Thickness[0.003], 
    ArrowBox[{{-0.8585786437626906, 0.1414213562373095}, {-0.1414213562373095,
      0.8585786437626906}}], ArrowBox[{{-0.8, 0.}, {0.8, 0.}}], 
    ArrowBox[{{-0.8585786437626906, -0.1414213562373095}, \
{-0.1414213562373095, -0.8585786437626906}}], 
    ArrowBox[{{0.1414213562373095, 0.8585786437626906}, {0.8585786437626906, 
     0.1414213562373095}}], ArrowBox[{{0., 0.8}, {0., -0.8}}], 
    ArrowBox[{{0.8585786437626906, -0.1414213562373095}, {
     0.1414213562373095, -0.8585786437626906}}]}, 
   {RGBColor[0, 0, 1], Thickness[0.003]}, 
   {RGBColor[1, 0, 0], Thickness[0.003], 
    InsetBox["1.`", {-0.5282842712474619, 0.4717157287525382},
     Background->RGBColor[1, 0.85, 0.85]], 
    InsetBox["1.9`", {0.059999999999999915`, -0.1},
     Background->RGBColor[1, 0.85, 0.85]], 
    InsetBox["0.57`", {-0.5282842712474619, -0.6717157287525382},
     Background->RGBColor[1, 0.85, 0.85]], 
    InsetBox["2.`", {0.4717157287525382, 0.32828427124746196`},
     Background->RGBColor[1, 0.85, 0.85]], 
    InsetBox["0.6`", {-0.1, -0.2599999999999999},
     Background->RGBColor[1, 0.85, 0.85]], 
    InsetBox["0.3`", {0.32828427124746196`, -0.6717157287525382},
     Background->RGBColor[1, 0.85, 0.85]]}, 
   {RGBColor[0, 0, 1], Thickness[0.003]}},
  AspectRatio->Automatic,
  BaseStyle->{FontFamily -> "Helvetica", FontSize -> 12},
  Frame->True,
  FrameTicks->False]], "Output",
 CellChangeTimes->{
  3.4602541818218737`*^9, 3.460254280335683*^9, 3.460254334747493*^9, {
   3.460254394251598*^9, 3.460254411277727*^9}, {3.460254511486261*^9, 
   3.4602545320527563`*^9}, 3.460254587240301*^9, 3.460254701501644*^9, 
   3.4602547523545923`*^9, 3.46025483835599*^9, {3.4602548936570463`*^9, 
   3.460254899095298*^9}, {3.4602549339701557`*^9, 3.460254983204011*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"X", "//", "Dimensions"}]], "Input",
 PageWidth->Infinity,
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{3.4598278723739767`*^9, 3.460112961274558*^9, 
  3.4601139646218567`*^9, 3.460114147492792*^9, 3.460114235304534*^9, 
  3.4601143048966722`*^9, 3.4601209300977497`*^9, 3.460197818734274*^9, 
  3.460198377489222*^9, 3.460198430929615*^9, 3.460198522874699*^9, 
  3.4601995267642307`*^9, 3.460199654485032*^9, 3.460200491292087*^9, 
  3.46020060124748*^9, 3.460201879197091*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Y", "//", "MatrixForm"}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{3.460112964110797*^9},
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.06552476067601987`", 
       RowBox[{"-", "1.2137241384580495`"}], 
       RowBox[{"-", "2.659857992147833`"}], 
       RowBox[{"-", "2.8608705618946257`"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.46011296490981*^9, 3.460112976913889*^9}, 
   3.460113026134074*^9, 3.460113268944764*^9, 3.4601139647291594`*^9, 
   3.4601141477280493`*^9, 3.4601142354518623`*^9, 3.4601143049628487`*^9, {
   3.460120930167809*^9, 3.460120941249729*^9}, 3.460197818846628*^9, 
   3.4601983790134907`*^9, 3.460198432454899*^9, 3.46019852602495*^9, 
   3.4601995268397923`*^9, 3.460199654594264*^9, 3.460200492784277*^9, {
   3.460200572211609*^9, 3.4602006012951183`*^9}, {3.460201874721448*^9, 
   3.460201879242372*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ETA", "//", "Dimensions"}]], "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "4"}], "}"}]], "Output",
 CellChangeTimes->{3.459827872458929*^9, 3.460113028341502*^9, 
  3.460113964807403*^9, 3.46011414827166*^9, 3.460114235541856*^9, 
  3.4601143050197973`*^9, 3.460120930265955*^9, 3.460197818944401*^9, 
  3.460198380551972*^9, 3.460198528048911*^9, 3.460199526923008*^9, 
  3.460199654699679*^9, 3.4602004944230347`*^9, 3.4602006013585*^9, 
  3.460201879315258*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ETA", "[", 
  RowBox[{"[", "1", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.460114000133006*^9, 3.460114009445375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "0.5209211781380665`"}], ",", 
   RowBox[{"-", "0.9295408453324674`"}], ",", 
   RowBox[{"-", "1.6418553289176625`"}], ",", 
   RowBox[{"-", "2.1868161753951463`"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.459827872527598*^9, 3.46011303067655*^9, 3.46011396489058*^9, {
   3.4601139984758797`*^9, 3.460114009526347*^9}, 3.46011414834797*^9, 
   3.460114235624238*^9, 3.4601143050940447`*^9, 3.460120930349319*^9, 
   3.460197819413198*^9, 3.460198381508251*^9, 3.46019852964046*^9, 
   3.460199526993176*^9, 3.460199654815744*^9, 3.460200496332955*^9, 
   3.460200601423087*^9, 3.460201879378018*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"plot1", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ETA", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"1", "//", "Range"}], ",", "All"}], " ", "]"}], "]"}], "//", 
      "Transpose"}], "//", "AddTimeAxis"}], ",", 
    RowBox[{"farbmodell", "\[Rule]", "Hue"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3"}], ",", "3"}], "}"}]}]}], "]"}], 
  "\[IndentingNewLine]"}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113047733139*^9, 3.4601131167734203`*^9}, {
  3.46011396933543*^9, 3.460113989452705*^9}, {3.460114029168693*^9, 
  3.460114031766469*^9}, {3.460114161512141*^9, 3.460114164229396*^9}, {
  3.460120949297063*^9, 3.460120987997653*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[1.], PointSize[0.006], Thickness[0.006], Dashing[{}], {}, 
    LineBox[{{0., -0.5209211781380665}, {1., -0.9295408453324674}, {
     2., -1.6418553289176625`}, {3., -2.1868161753951463`}}]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->True,
  PlotRange->{-3, 3},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellChangeTimes->{
  3.459827873013823*^9, {3.460113055090554*^9, 3.460113095483087*^9}, 
   3.460113273581389*^9, {3.460113964976376*^9, 3.4601139901177692`*^9}, 
   3.460114033131361*^9, {3.460114150107635*^9, 3.460114164412263*^9}, 
   3.460114235720495*^9, 3.460114305171029*^9, {3.460120930436802*^9, 
   3.460120988296579*^9}, 3.460197819516024*^9, 3.460198382848845*^9, 
   3.4601985329563026`*^9, 3.4601995270581903`*^9, 3.460199655234778*^9, 
   3.460200501606188*^9, 3.460200601492147*^9, 3.460201879429142*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ML-Sch\[ADoubleDot]tzung", "Subsection",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["Momente", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Z", "=", 
  RowBox[{"AppendRows", "[", 
   RowBox[{"Y", ",", "X"}], "]"}]}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{3.460198538987865*^9},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"0.06552476067601987`", ",", 
    RowBox[{"-", "1.2137241384580495`"}], ",", 
    RowBox[{"-", "2.659857992147833`"}], ",", 
    RowBox[{"-", "2.8608705618946257`"}], ",", "1"}], "}"}], "}"}]], "Output",\

 CellChangeTimes->{
  3.460198540322854*^9, 3.460199659217465*^9, 3.460200505321865*^9, {
   3.4602005758411818`*^9, 3.460200631575717*^9}, 3.460201887146687*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dimensions", "[", "Z", "]"}]], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "5"}], "}"}]], "Output",
 CellChangeTimes->{
  3.460113191525813*^9, 3.460113277697483*^9, 3.460114045451661*^9, 
   3.460114169358086*^9, 3.46011425319956*^9, 3.460114309400132*^9, 
   3.460120996847981*^9, {3.460198391416621*^9, 3.4601984056499777`*^9}, 
   3.460198547821282*^9, 3.460199660306396*^9, 3.4602005071821012`*^9, {
   3.46020057756488*^9, 3.460200633233664*^9}, 3.4602018874285994`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"M", "=", 
   FractionBox[
    RowBox[{
     RowBox[{"Transpose", "[", "Z", "]"}], ".", "Z"}], "n"]}], ";"}]], "Input",\

 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", "M", "]"}]], "Input",
 PageWidth->Infinity],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4", "5"},
      {"1", "0.0042934942616496795`", 
       RowBox[{"-", "0.07952898369917209`"}], 
       RowBox[{"-", "0.17428655836768547`"}], 
       RowBox[{"-", "0.18745785889321584`"}], "0.06552476067601987`"},
      {"2", 
       RowBox[{"-", "0.07952898369917209`"}], "1.4731262842757344`", 
       "3.2283338499403857`", "3.4723076579755507`", 
       RowBox[{"-", "1.2137241384580495`"}]},
      {"3", 
       RowBox[{"-", "0.17428655836768547`"}], "3.2283338499403857`", 
       "7.074844538392701`", "7.6095094285558815`", 
       RowBox[{"-", "2.659857992147833`"}]},
      {"4", 
       RowBox[{"-", "0.18745785889321584`"}], "3.4723076579755507`", 
       "7.6095094285558815`", "8.184580371915272`", 
       RowBox[{"-", "2.8608705618946257`"}]},
      {"5", "0.06552476067601987`", 
       RowBox[{"-", "1.2137241384580495`"}], 
       RowBox[{"-", "2.659857992147833`"}], 
       RowBox[{"-", "2.8608705618946257`"}], "1.`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.460113195968734*^9, 3.460113280145521*^9, 3.460114045552314*^9, 
   3.4601141694927588`*^9, 3.4601142532707663`*^9, 3.4601143094904833`*^9, 
   3.4601209969662247`*^9, {3.460198391522633*^9, 3.460198408531907*^9}, 
   3.460198551777361*^9, 3.4601996626346283`*^9, 3.460200288952312*^9, 
   3.4602005110002823`*^9, {3.460200581420781*^9, 3.460200605760393*^9}, 
   3.4602006370536737`*^9, 3.460201887509522*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Plus", "@@", "Z"}], "/", "n"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.06552476067601987`", ",", 
   RowBox[{"-", "1.2137241384580495`"}], ",", 
   RowBox[{"-", "2.659857992147833`"}], ",", 
   RowBox[{"-", "2.8608705618946257`"}], ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{
  3.460113199651466*^9, 3.46011328199986*^9, 3.4601140456363287`*^9, 
   3.460114169579465*^9, 3.460114253342799*^9, 3.4601143095580606`*^9, 
   3.4601209970184097`*^9, {3.4601983915925293`*^9, 3.460198412010578*^9}, 
   3.460198581439234*^9, 3.4601996644076633`*^9, 3.460200290406837*^9, 
   3.460200514831814*^9, {3.460200587711485*^9, 3.4602006058595333`*^9}, 
   3.460200638224077*^9, 3.460201887581959*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["n"], "Input",
 CellChangeTimes->{3.460199511556486*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{{3.4601995116536627`*^9, 3.460199536598831*^9}, 
   3.460199666583953*^9, 3.4602002921472178`*^9, {3.460200589454166*^9, 
   3.460200605941572*^9}, 3.460201887627214*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"m", "=", 
  FractionBox[
   RowBox[{
    RowBox[{"Transpose", "[", "Z", "]"}], ".", 
    RowBox[{"Shape", "[", 
     RowBox[{"1", ",", "n"}], "]"}]}], "n"]}]], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.06552476067601987`", ",", 
   RowBox[{"-", "1.2137241384580495`"}], ",", 
   RowBox[{"-", "2.659857992147833`"}], ",", 
   RowBox[{"-", "2.8608705618946257`"}], ",", "1.`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.460113201323181*^9, 3.460113283490226*^9, 3.460114045737379*^9, 
   3.460114169651576*^9, 3.4601142534041*^9, 3.460114309609151*^9, 
   3.460120997088842*^9, {3.460198391662445*^9, 3.460198414431184*^9}, 
   3.460199509032115*^9, 3.460199668681004*^9, 3.46020029374*^9, 
   3.4602005189670897`*^9, {3.460200590693624*^9, 3.460200606029511*^9}, 
   3.460201887682212*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"S", "=", 
   RowBox[{"M", "-", 
    RowBox[{"Outer", "[", 
     RowBox[{"Times", ",", "m", ",", "m"}], "]"}]}]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", "S", "]"}], "\n", 
 RowBox[{"Eigenvalues", "[", "S", "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4", "5"},
      {"1", "0.`", "0.`", "0.`", "0.`", "0.`"},
      {"2", "0.`", "0.`", "0.`", "0.`", "0.`"},
      {"3", "0.`", "0.`", "0.`", "0.`", "0.`"},
      {"4", "0.`", "0.`", "0.`", "0.`", "0.`"},
      {"5", "0.`", "0.`", "0.`", "0.`", "0.`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.460113203931658*^9, 3.4601132851319*^9, 3.460114045837867*^9, 
   3.460114169727357*^9, 3.460114253488258*^9, 3.460114309674265*^9, 
   3.460120997134007*^9, 3.460198391744893*^9, 3.460199671648*^9, {
   3.460200296553061*^9, 3.460200298594698*^9}, 3.4602005251794577`*^9, {
   3.4602005944428387`*^9, 3.4602006061118193`*^9}, 3.4602018877328777`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.460113203931658*^9, 3.4601132851319*^9, 3.460114045837867*^9, 
   3.460114169727357*^9, 3.460114253488258*^9, 3.460114309674265*^9, 
   3.460120997134007*^9, 3.460198391744893*^9, 3.460199671648*^9, {
   3.460200296553061*^9, 3.460200298594698*^9}, 3.4602005251794577`*^9, {
   3.4602005944428387`*^9, 3.4602006061118193`*^9}, 3.460201887734655*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"S", "\[IndentingNewLine]", "m"}], "Input",
 CellChangeTimes->{{3.460200304003729*^9, 3.4602003089444647`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"0.`", ",", "0.`", ",", "0.`", ",", "0.`", ",", "0.`"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.460200305039919*^9, 3.460200309843872*^9}, 
   3.46020053070501*^9, 3.460200606247834*^9, 3.460201887781678*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.06552476067601987`", ",", 
   RowBox[{"-", "1.2137241384580495`"}], ",", 
   RowBox[{"-", "2.659857992147833`"}], ",", 
   RowBox[{"-", "2.8608705618946257`"}], ",", "1.`"}], "}"}]], "Output",
 CellChangeTimes->{{3.460200305039919*^9, 3.460200309843872*^9}, 
   3.46020053070501*^9, 3.460200606247834*^9, 3.460201887783475*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Lik", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"S", ",", "m", ",", "n", ",", "Deterministisch"}], "}"}], "}"}], 
   ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Idio", ",", 
       RowBox[{"{", "}"}]}], "}"}], ",", "LISRELlik"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"True", ",", "1"}], "}"}]}], "]"}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601132078416233`*^9, 3.460113208582662*^9}, {
  3.4601996807525387`*^9, 3.460199688300702*^9}}],

Cell[BoxData[
 RowBox[{"-", "3.5099457583513`"}]], "Output",
 CellChangeTimes->{
  3.460113210519113*^9, 3.460113303646483*^9, 3.460114045969905*^9, 
   3.4601141698599157`*^9, 3.460114253556274*^9, 3.460114309744521*^9, 
   3.460120997188068*^9, 3.460198391957541*^9, {3.4601996754432917`*^9, 
   3.460199689278112*^9}, 3.4602003014730988`*^9, 3.460200533248246*^9, 
   3.460200606376255*^9, 3.460201887833675*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LISRELlik", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"S", ",", "m", ",", "n", ",", "Deterministisch"}], "}"}], ",", 
   "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"Idio", ",", 
     RowBox[{"{", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"True", ",", "1"}], "}"}]}], "]"}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{
  3.460113216721052*^9, {3.460199696587295*^9, 3.460199697204668*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"-", "3.5099457583513`"}]], "Output",
 CellChangeTimes->{3.4601133075314198`*^9, 3.4601140460710278`*^9, 
  3.460114169944644*^9, 3.460114253623534*^9, 3.46011430980665*^9, 
  3.460120997245903*^9, 3.460198392055295*^9, 3.460199697924979*^9, 
  3.460200534589554*^9, 3.4602006067006397`*^9, 3.460201887883185*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LISRELlik", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"S", ",", "m", ",", "n", ",", "Deterministisch"}], "}"}], ",", 
   "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"Idio", ",", 
     RowBox[{"{", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"False", ",", "1"}], "}"}]}], "]"}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{
  3.460113220039421*^9, {3.4601997008573027`*^9, 3.460199701660597*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"-", "3.5099457583513`"}]], "Output",
 CellChangeTimes->{3.460113221343851*^9, 3.460113310964349*^9, 
  3.4601140461698093`*^9, 3.4601141700286293`*^9, 3.460114253687913*^9, 
  3.460114309875375*^9, 3.460120997320516*^9, 3.460198392155389*^9, 
  3.4601997034496317`*^9, 3.460199755366691*^9, 3.4602005359158907`*^9, 
  3.460200606781589*^9, 3.4602006412015676`*^9, 3.46020188793311*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["X"], "Input",
 CellChangeTimes->{{3.4601998953814096`*^9, 3.460199899752301*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "1", "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.460199896484832*^9, 3.460199900586775*^9}, 
   3.460200606882386*^9, 3.460201887983314*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndividualLik", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Y", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"Idio", ",", 
     RowBox[{"{", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"True", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.4601997173512297`*^9, 3.460199799018221*^9}, {
  3.4602000328841333`*^9, 3.460200036915626*^9}, {3.460200331405088*^9, 
  3.4602003617479763`*^9}}],

Cell[BoxData[
 RowBox[{"-", "3.5099457583513`"}]], "Output",
 CellChangeTimes->{{3.460199732248258*^9, 3.460199761830679*^9}, {
   3.460199792751666*^9, 3.460199800870702*^9}, 3.4601999880171537`*^9, 
   3.46020003802503*^9, 3.460200277854393*^9, {3.460200336499283*^9, 
   3.460200361862876*^9}, 3.460200428743658*^9, {3.4602005385192633`*^9, 
   3.4602005518989983`*^9}, 3.460200606983478*^9, 3.460201888033589*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ML", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"THETA0", "=", "Theta"}], "\n", 
 RowBox[{"F0", "=", 
  RowBox[{"IdentityMatrix", "[", 
   RowBox[{"Length", "[", "THETA0", "]"}], "]"}]}], "\n", "SCALING", "\n", 
 RowBox[{"FISHER", "=", "True"}], "\n", 
 RowBox[{"MAXSTEP", "=", "1"}], "\n", 
 RowBox[{"STEPREDUCE", "=", "4"}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601143146009274`*^9, 3.460114315759859*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "0.3`", ",", 
   RowBox[{"-", "0.1`"}]}], "}"}]], "Output",
 CellChangeTimes->{3.460113323020094*^9, 3.46011404625578*^9, 
  3.460114170109331*^9, 3.460114257388714*^9, 3.4601143175730677`*^9, 
  3.460121001268158*^9, 3.460200607083859*^9, 3.4602007904542923`*^9, 
  3.460201889717943*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.460113323020094*^9, 3.46011404625578*^9, 
  3.460114170109331*^9, 3.460114257388714*^9, 3.4601143175730677`*^9, 
  3.460121001268158*^9, 3.460200607083859*^9, 3.4602007904542923`*^9, 
  3.460201889721107*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.460113323020094*^9, 3.46011404625578*^9, 
  3.460114170109331*^9, 3.460114257388714*^9, 3.4601143175730677`*^9, 
  3.460121001268158*^9, 3.460200607083859*^9, 3.4602007904542923`*^9, 
  3.460201889764811*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.460113323020094*^9, 3.46011404625578*^9, 
  3.460114170109331*^9, 3.460114257388714*^9, 3.4601143175730677`*^9, 
  3.460121001268158*^9, 3.460200607083859*^9, 3.4602007904542923`*^9, 
  3.4602018898132257`*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.460113323020094*^9, 3.46011404625578*^9, 
  3.460114170109331*^9, 3.460114257388714*^9, 3.4601143175730677`*^9, 
  3.460121001268158*^9, 3.460200607083859*^9, 3.4602007904542923`*^9, 
  3.460201889849812*^9}],

Cell[BoxData["4"], "Output",
 CellChangeTimes->{3.460113323020094*^9, 3.46011404625578*^9, 
  3.460114170109331*^9, 3.460114257388714*^9, 3.4601143175730677`*^9, 
  3.460121001268158*^9, 3.460200607083859*^9, 3.4602007904542923`*^9, 
  3.460201889893659*^9}]
}, Open  ]],

Cell[TextData[StyleBox["Math7/Intel/ OS X",
 FontColor->RGBColor[1, 0, 0]]], "Text",
 PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "scoreii", ",", "k", 
      ",", "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
    RowBox[{"BFGS", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"S", ",", "m", ",", "n", ",", "Deterministisch"}], "}"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      "\t  ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Idio", ",", 
          RowBox[{"{", "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Lik", ",", "LISRELlik", ",", "Score", ",", "Hesse"}], 
         "}"}]}], "}"}], ",", "\[IndentingNewLine]", "            ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Sing", "=", "False"}], ",", "1"}], "}"}], ",", 
        RowBox[{"KMAX", "=", "30"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EPS1", "=", ".0001"}], ",", 
          RowBox[{"EPS2", "=", ".0001"}]}], "}"}], ",", "\[IndentingNewLine]",
         "             ", 
        RowBox[{"OPTION", "=", "0"}], ",", 
        RowBox[{"PRINT", "=", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1"}], "}"}]}]}], "}"}]}], "]"}]}], ";"}], 
  "                                                                           \
     "}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113330285616*^9, 3.460113346379695*^9}, {
   3.460200648978776*^9, 3.4602006503583603`*^9}, {3.460200794874672*^9, 
   3.4602007984595947`*^9}, 3.460201903279232*^9, {3.460201941045977*^9, 
   3.4602019411313553`*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"***********************LSDE1********************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9}],

Cell[BoxData["\<\"***********************MODUL:    BFGS \
(skeleton)**************\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.46020194171246*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201941716675*^9}],

Cell[BoxData["\<\"Technical Output\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417207127`*^9}],

Cell[BoxData["LISRELlik"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417246*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201941728573*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"KMAX\"\>",
       HoldForm], 
      TagBox["\<\"EPS1\"\>",
       HoldForm], 
      TagBox["\<\"EPS2\"\>",
       HoldForm], 
      TagBox["\<\"K\"\>",
       HoldForm], 
      TagBox["\<\"Q\"\>",
       HoldForm], 
      TagBox["\<\"n\"\>",
       HoldForm], 
      TagBox["\<\"T\"\>",
       HoldForm], 
      TagBox["\<\"OPTION    \"\>",
       HoldForm]},
     {"1", "30", "0.0001`", "0.0001`", "K$158844", "Q$158844", "n$158844", 
      "T$158844", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"KMAX", "EPS1", "EPS2", "K", "Q", "n", "T", "OPTION    "}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201941733014*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417390833`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"MAXSTEP\"\>",
       HoldForm], 
      TagBox["\<\"MINSTEP\"\>",
       HoldForm], 
      TagBox["\<\"BOUND\"\>",
       HoldForm], 
      TagBox["\<\"STEPREDUCE\"\>",
       HoldForm], 
      TagBox["\<\"FMAX\"\>",
       HoldForm]},
     {"1", "1", "1.`*^-10", "1.`*^-6", "4", "1000"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"MAXSTEP", "MINSTEP", "BOUND", "STEPREDUCE", "FMAX"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.46020194174477*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201941755761*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"RESAMPLING\"\>",
       HoldForm], 
      TagBox["\<\"FDIGITS\"\>",
       HoldForm], 
      TagBox["\<\"TYP\"\>",
       HoldForm], 
      TagBox["\<\"YMAX\"\>",
       HoldForm], 
      TagBox["\<\"ANALGRAD\"\>",
       HoldForm], 
      TagBox["\<\"FACTOR\"\>",
       HoldForm], 
      TagBox["\<\"CSEED\"\>",
       HoldForm]},
     {"1", "True", "16", "1", "1000.`", "False", "1.`", 
      RowBox[{"-", "999"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {
      "RESAMPLING", "FDIGITS", "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}},
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201941760268*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201941768165*^9}],

Cell[BoxData["\<\"    SCALING\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201941771927*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "::", "\<\"nmtx\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The first two levels of the \
one-dimensional list \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\
\\!\\({}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" cannot be \
transposed.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Transpose\\\", ButtonNote -> \\\"Transpose::nmtx\\\
\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.460113347438837*^9, 3.4601140477211742`*^9, 3.460114171488365*^9, 
   3.4601142582303123`*^9, 3.46011431981378*^9, 3.4601210026174927`*^9, 
   3.4602006082555428`*^9, 3.4602006525509787`*^9, 3.4602007997492933`*^9, {
   3.460201893745349*^9, 3.460201903902554*^9}, 3.4602019417761383`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  RowBox[{"Transpose", "[", 
   RowBox[{"{", "}"}], "]"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
    0]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201941779071*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201941788588*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201941822998*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019418705473`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STARTWERT THETA0 = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "0.3`", ",", 
     RowBox[{"-", "0.1`"}]}], "}"}]}],
  SequenceForm["STARTWERT THETA0 = ", {1, 2, 0.3, -0.1}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201941914929*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0.006632298231124878`", ",", "0.1370125412940979`", ",", 
     "2.600218743085861`", ",", "0.04120755195617676`"}], "}"}], ",", 
   RowBox[{"-", "3.5099457583513`"}]}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019419673967`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201942014317*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["BFGS: Iteration = ", 1],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201942065997*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.636255377350169\"\>",
     -2.636255377350169,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.636255377350169, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019421153173`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -3.509945758351300\"\>",
     -3.5099457583513,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-3.5099457583513, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019421839247`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.873690381001131\"\>",
     0.873690381001131,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.873690381001131, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019422188177`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019422738647`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"THETA1\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox["\<\"STEP\"\>",
        HoldForm], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\" 1.0026\"\>",
        1.0025506693422468`,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\" 0.0026\"\>",
        0.002550669342246901,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0066\"\>",
        0.006632298231124878,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 2.0527\"\>",
        2.052692698127195,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 0.0527\"\>",
        0.05269269812719508,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.1370\"\>",
        0.1370125412940979,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 3.0000\"\>",
        3,
        Editable->False], 
       InterpretationBox["\<\" 1.3000\"\>",
        1.3,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.3000\"\>",
        0.3,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.0000\"\>",
        1.,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.6002\"\>",
        2.600218743085861,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 4.0000\"\>",
        4,
        Editable->False], 
       InterpretationBox["\<\"-0.0842\"\>",
        -0.0841522748554328,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.1000\"\>",
        -0.1,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0158\"\>",
        0.015847725144567212`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0412\"\>",
        0.04120755195617676,
        AutoDelete->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[1.4]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201942324602*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201942371599*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "1", "0", "0", "0"},
      {"2", "0", "1", "0", "0"},
      {"3", "0", "0", "1", "0"},
      {"4", "0", "0", "0", "1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201942414755*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.2345795727938896`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.2345795727938896, " = Elastizitaet(d l/l)/(d theta/theta)"],
  
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201942463356*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019424994993`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "2"}],
  SequenceForm["BFGS: Iteration = ", 2],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019425466557`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.582263473549432\"\>",
     -2.5822634735494323`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.5822634735494323`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201942588427*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.636255377350169\"\>",
     -2.636255377350169,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.636255377350169, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201942632951*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.053991903800737\"\>",
     0.05399190380073682,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.05399190380073682, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201942695344*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019427321444`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"THETA1\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox["\<\"STEP\"\>",
        HoldForm], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\" 0.9531\"\>",
        0.9530751079809243,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.0026\"\>",
        1.0025506693422468`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0495\"\>",
        -0.04947556136132252,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0593\"\>",
        -0.05930939111032324,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 2.0241\"\>",
        2.02406687751127,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.0527\"\>",
        2.052692698127195,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0286\"\>",
        -0.028625820615925446`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0494\"\>",
        -0.049426253849076444`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 3.0000\"\>",
        3,
        Editable->False], 
       InterpretationBox["\<\" 1.1474\"\>",
        1.1473514227472725`,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.3000\"\>",
        1.3,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.1526\"\>",
        -0.1526485772527276,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.4757\"\>",
        -0.475701277072613,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 4.0000\"\>",
        4,
        Editable->False], 
       InterpretationBox["\<\"-0.0943\"\>",
        -0.09429266840180714,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0842\"\>",
        -0.0841522748554328,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0101\"\>",
        -0.010140393546374343`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0167\"\>",
        -0.016677290201187134`,
        AutoDelete->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[1.4]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019427888203`*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019428409147`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "1.001402178016275`", "0.0038487610160104963`", 
       "0.06316568403673108`", "0.0011962516663019968`"},
      {"2", "0.0038487610160104963`", "1.0084924370093613`", 
       "0.1332465786141109`", "0.002663604085483722`"},
      {"3", "0.06316568403673108`", "0.1332465786141109`", 
       "3.068074073317933`", "0.041880479206764576`"},
      {"4", "0.0011962516663019968`", "0.0026636040854837225`", 
       "0.04188047920676459`", "1.0008350774293322`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201942895115*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.08115559663178472`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.08115559663178472, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201942933139*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201942982066*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "3"}],
  SequenceForm["BFGS: Iteration = ", 3],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201943033374*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.572395980697445\"\>",
     -2.572395980697445,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.572395980697445, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.46020194308538*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.582263473549432\"\>",
     -2.5822634735494323`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.5822634735494323`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201943133999*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.009867492851988\"\>",
     0.009867492851987514,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.009867492851987514, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201943198772*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019432329617`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"THETA1\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox["\<\"STEP\"\>",
        HoldForm], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\" 0.9077\"\>",
        0.9077314035704372,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.9531\"\>",
        0.9530751079809243,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0453\"\>",
        -0.04534370441048712,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0305\"\>",
        -0.030529052019119263`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 2.0646\"\>",
        2.064582181936226,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.0241\"\>",
        2.02406687751127,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0405\"\>",
        0.04051530442495615,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0184\"\>",
        0.018422173946651303`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 3.0000\"\>",
        3,
        Editable->False], 
       InterpretationBox["\<\" 1.0433\"\>",
        1.0433049416724005`,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.1474\"\>",
        1.1473514227472725`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.1040\"\>",
        -0.10404648107487201`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.1827\"\>",
        -0.1826512162721482,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 4.0000\"\>",
        4,
        Editable->False], 
       InterpretationBox["\<\"-0.0835\"\>",
        -0.08352793677715198,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0943\"\>",
        -0.09429266840180714,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0108\"\>",
        0.010764731624655159`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0046\"\>",
        0.0045938193798065186`,
        AutoDelete->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[1.4]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201943295384*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201943333303*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.9729417860609203`", "0.006259581743991818`", 
       RowBox[{"-", "0.1280474982504573`"}], "0.0010434327300035007`"},
      {"2", "0.006259581743991804`", "1.0720987308484387`", 
       "0.239946440967759`", "0.021847543848348947`"},
      {"3", 
       RowBox[{"-", "0.12804749825045736`"}], "0.239946440967759`", 
       "1.9117546392800961`", "0.06804401971014692`"},
      {"4", "0.0010434327300035007`", "0.02184754384834895`", 
       "0.06804401971014694`", "1.0065939200329783`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019433849688`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.03086154403344755`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.03086154403344755, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201943434363*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201943483865*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "4"}],
  SequenceForm["BFGS: Iteration = ", 4],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201943534709*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.570649648017715\"\>",
     -2.5706496480177154`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.5706496480177154`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201943585904*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.572395980697445\"\>",
     -2.572395980697445,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.572395980697445, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201943634796*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.001746332679729\"\>",
     0.0017463326797293455`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.0017463326797293455`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201943695112*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201943735587*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"THETA1\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox["\<\"STEP\"\>",
        HoldForm], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\" 0.8875\"\>",
        0.8875117638035633,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.9077\"\>",
        0.9077314035704372,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0202\"\>",
        -0.02021963976687388,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0196\"\>",
        -0.01956823468208313,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 2.0969\"\>",
        2.09690532910725,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.0646\"\>",
        2.064582181936226,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0323\"\>",
        0.032323147171024254`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0385\"\>",
        0.0384523864074547,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 3.0000\"\>",
        3,
        Editable->False], 
       InterpretationBox["\<\" 1.0508\"\>",
        1.0507773229853934`,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.0433\"\>",
        1.0433049416724005`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0075\"\>",
        0.0074723813129928965`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0453\"\>",
        0.04533459361545497,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 4.0000\"\>",
        4,
        Editable->False], 
       InterpretationBox["\<\"-0.0757\"\>",
        -0.07568000714672463,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0835\"\>",
        -0.08352793677715198,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0078\"\>",
        0.007847929630427358,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0096\"\>",
        0.009581536054611206,
        AutoDelete->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[1.4]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201943789289*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201943834775*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.9340904752274806`", "0.04220932077420369`", 
       RowBox[{"-", "0.28426222380017085`"}], "0.01000466137219042`"},
      {"2", "0.042209320774203675`", "1.0732588573012363`", 
       "0.5943298211099044`", "0.02213075681398962`"},
      {"3", 
       RowBox[{"-", "0.28426222380017097`"}], "0.5943298211099044`", 
       "2.562679451656885`", "0.156345123752399`"},
      {"4", "0.010004661372190422`", "0.022130756813989627`", 
       "0.156345123752399`", "1.0066630289734804`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201943886115*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.020201610147980192`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.020201610147980192`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201943938335*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201943985448*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["BFGS: Iteration = ", 5],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019440390873`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.566921475252705\"\>",
     -2.5669214752527054`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.5669214752527054`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019440884533`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.570649648017715\"\>",
     -2.5706496480177154`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.5706496480177154`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201944139477*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.003728172765010\"\>",
     0.0037281727650100294`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.0037281727650100294`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201944186672*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019442196198`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"THETA1\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox["\<\"STEP\"\>",
        HoldForm], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\" 0.7775\"\>",
        0.7775129709676915,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.8875\"\>",
        0.8875117638035633,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.1100\"\>",
        -0.10999879283587188`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0229\"\>",
        -0.022900283336639404`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 2.2155\"\>",
        2.215465798171301,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.0969\"\>",
        2.09690532910725,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.1186\"\>",
        0.11856046906405109`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0248\"\>",
        0.02476566838542298,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 3.0000\"\>",
        3,
        Editable->False], 
       InterpretationBox["\<\" 1.0536\"\>",
        1.05357421720998,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.0508\"\>",
        1.0507773229853934`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0028\"\>",
        0.0027968942245865723`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0190\"\>",
        0.01902278933072196,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 4.0000\"\>",
        4,
        Editable->False], 
       InterpretationBox["\<\"-0.0508\"\>",
        -0.05076069230037647,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0757\"\>",
        -0.07568000714672463,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0249\"\>",
        0.024919314846348156`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0050\"\>",
        0.0049700140953063965`,
        AutoDelete->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[1.4]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201944273386*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019443204117`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.765797315892428`", "0.48383481283684593`", 
       "0.29218608600782525`", "0.12663273657491061`"},
      {"2", "0.4838348128368459`", "0.6610717203678278`", 
       "0.3374941495772992`", 
       RowBox[{"-", "0.05353256974971903`"}]},
      {"3", "0.29218608600782514`", "0.33749414957729906`", 
       "2.7003523389163444`", "0.14433950354885086`"},
      {"4", "0.12663273657491061`", 
       RowBox[{"-", "0.05353256974971904`"}], "0.14433950354885086`", 
       "0.9969217316408429`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019443722267`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.011066613037829201`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.011066613037829201`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201944424651*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201944470663*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "6"}],
  SequenceForm["BFGS: Iteration = ", 6],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019445239687`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.564847394368518\"\>",
     -2.5648473943685177`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.5648473943685177`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201944560657*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.566921475252705\"\>",
     -2.5669214752527054`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.5669214752527054`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201944606799*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.002074080884188\"\>",
     0.002074080884187701,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.002074080884187701, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201944655663*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019446905813`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"THETA1\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox["\<\"STEP\"\>",
        HoldForm], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\" 0.6624\"\>",
        0.6624061337330223,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.7775\"\>",
        0.7775129709676915,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.1151\"\>",
        -0.11510683723466916`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0284\"\>",
        -0.028407126665115356`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 2.2930\"\>",
        2.2929569604353217`,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.2155\"\>",
        2.215465798171301,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0775\"\>",
        0.07749116226402046,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0081\"\>",
        -0.00814996803474382,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 3.0000\"\>",
        3,
        Editable->False], 
       InterpretationBox["\<\" 1.0514\"\>",
        1.0513541084723481`,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.0536\"\>",
        1.05357421720998,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0022\"\>",
        -0.002220108737631987,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0111\"\>",
        -0.01111544075418505,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 4.0000\"\>",
        4,
        Editable->False], 
       InterpretationBox["\<\"-0.0400\"\>",
        -0.039976786896031735`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0508\"\>",
        -0.05076069230037647,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0108\"\>",
        0.010783905404344735`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0063\"\>",
        -0.006271570920944214,
        AutoDelete->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[1.4]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201944729677*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201944773418*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.6809701355766073`", "0.6340384664215413`", 
       "0.41486224805190175`", "0.1637489800653909`"},
      {"2", "0.6340384664215413`", "0.8481016228577647`", 
       "0.5248058397904621`", "0.02568087042725458`"},
      {"3", "0.41486224805190164`", "0.524805839790462`", 
       "2.884197145125358`", "0.2200925557837062`"},
      {"4", "0.1637489800653909`", "0.02568087042725456`", 
       "0.22009255578370623`", "1.0270532583814251`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201944825534*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.017781623070877262`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.017781623070877262`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019448832207`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201944917307*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "7"}],
  SequenceForm["BFGS: Iteration = ", 7],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201944973833*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.561232272606501\"\>",
     -2.5612322726065013`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.5612322726065013`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201945012664*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.564847394368518\"\>",
     -2.5648473943685177`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.5648473943685177`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201945057775*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.003615121762016\"\>",
     0.0036151217620163933`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.0036151217620163933`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019450953817`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201945141173*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"THETA1\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox["\<\"STEP\"\>",
        HoldForm], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\" 0.4094\"\>",
        0.40939711694259284`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.6624\"\>",
        0.6624061337330223,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.2530\"\>",
        -0.2530090167904294,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0279\"\>",
        -0.027866363525390625`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 2.4155\"\>",
        2.4154684830724804`,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.2930\"\>",
        2.2929569604353217`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.1225\"\>",
        0.1225115226371588,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0199\"\>",
        -0.019890102774682727`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 3.0000\"\>",
        3,
        Editable->False], 
       InterpretationBox["\<\" 1.0483\"\>",
        1.0482847719691863`,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.0514\"\>",
        1.0513541084723481`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0031\"\>",
        -0.00306933650316183,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0151\"\>",
        -0.015053919524926714`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 4.0000\"\>",
        4,
        Editable->False], 
       InterpretationBox["\<\"-0.0319\"\>",
        -0.0318993633269871,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0400\"\>",
        -0.039976786896031735`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0081\"\>",
        0.008077423569044638,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0099\"\>",
        -0.009933024644851685,
        AutoDelete->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[1.4]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019451928387`*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201945224061*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.37033452116157956`", "0.5385025775749099`", 
       "0.2910753938930005`", "0.09312959259051368`"},
      {"2", "0.5385025775749098`", "0.9599626400059561`", 
       "0.536012691964599`", "0.04885512477741502`"},
      {"3", "0.2910753938930004`", "0.5360126919645989`", 
       "2.852060782098808`", "0.20761359161129037`"},
      {"4", "0.09312959259051368`", "0.048855124777415`", 
       "0.2076135916112904`", "1.0252677960928716`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201945264949*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.029196203561970054`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.029196203561970054`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201945309331*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201945346364*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "8"}],
  SequenceForm["BFGS: Iteration = ", 8],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201945393806*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.555336334745125\"\>",
     -2.5553363347451246`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.5553363347451246`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201945431291*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.561232272606501\"\>",
     -2.5612322726065013`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.5612322726065013`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201945475843*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.005895937861377\"\>",
     0.0058959378613767655`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.0058959378613767655`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.46020194551458*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019455588903`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"THETA1\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox["\<\"STEP\"\>",
        HoldForm], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\"-0.1302\"\>",
        -0.13016799613294694`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.4094\"\>",
        0.40939711694259284`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.5396\"\>",
        -0.5395651130755398,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0266\"\>",
        -0.026624619960784912`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 2.6175\"\>",
        2.6175401441152446`,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.4155\"\>",
        2.4154684830724804`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.2021\"\>",
        0.202071661042764,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0310\"\>",
        -0.030958076797337676`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 3.0000\"\>",
        3,
        Editable->False], 
       InterpretationBox["\<\" 1.0452\"\>",
        1.0452115005537144`,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.0483\"\>",
        1.0482847719691863`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0031\"\>",
        -0.0030732714154720125`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0171\"\>",
        -0.017060179741450854`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 4.0000\"\>",
        4,
        Editable->False], 
       InterpretationBox["\<\"-0.0285\"\>",
        -0.028462477132732734`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0319\"\>",
        -0.0318993633269871,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0034\"\>",
        0.0034368861942543636`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0113\"\>",
        -0.011263400316238403`,
        AutoDelete->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[1.4]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019456003447`*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201945641697*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.20169319810955746`", "0.40926819718994284`", 
       "0.19798730742557838`", "0.03170241666306716`"},
      {"2", "0.40926819718994273`", "0.9467237095975761`", 
       "0.4838903436406876`", "0.014506768406760337`"},
      {"3", "0.1979873074255783`", "0.4838903436406875`", 
       "2.804979950638679`", "0.1765561453299636`"},
      {"4", "0.03170241666306716`", "0.01450676840676031`", 
       "0.17655614532996364`", "1.0047803990315896`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019456964684`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.07008030814885692`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.07008030814885692, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201945729271*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019457644444`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "9"}],
  SequenceForm["BFGS: Iteration = ", 9],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201945811223*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.550481227940079\"\>",
     -2.550481227940079,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.550481227940079, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201945849667*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.555336334745125\"\>",
     -2.5553363347451246`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.5553363347451246`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201945900053*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.004855106805046\"\>",
     0.00485510680504575,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.00485510680504575, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019459472933`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201945997532*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"THETA1\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox["\<\"STEP\"\>",
        HoldForm], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\"-0.2700\"\>",
        -0.270023698881212,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.1302\"\>",
        -0.13016799613294694`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.1399\"\>",
        -0.13985570274826506`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0241\"\>",
        -0.024102389812469482`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 2.5926\"\>",
        2.5925954706373764`,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.6175\"\>",
        2.6175401441152446`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0249\"\>",
        -0.02494467347786814,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0684\"\>",
        -0.0684149040332825,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 3.0000\"\>",
        3,
        Editable->False], 
       InterpretationBox["\<\" 1.0408\"\>",
        1.0408045699659698`,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.0452\"\>",
        1.0452115005537144`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0044\"\>",
        -0.004406930587744546,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0450\"\>",
        -0.044994282535187786`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 4.0000\"\>",
        4,
        Editable->False], 
       InterpretationBox["\<\"-0.0305\"\>",
        -0.030464155494571526`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0285\"\>",
        -0.028462477132732734`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0020\"\>",
        -0.00200167836183879,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0004\"\>",
        -0.000371396541595459,
        AutoDelete->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[1.4]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201946033636*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201946078224*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.11515586933865309`", "0.29707825959056355`", 
       "0.1340737616557116`", 
       RowBox[{"-", "0.0020928255356019027`"}]},
      {"2", "0.29707825959056344`", "0.9880615390062242`", 
       "0.5376880975617718`", 
       RowBox[{"-", "0.07474293882615125`"}]},
      {"3", "0.13407376165571153`", "0.5376880975617717`", 
       "2.8577583822024937`", "0.11835344264859204`"},
      {"4", 
       RowBox[{"-", "0.0020928255356019027`"}], 
       RowBox[{"-", "0.07474293882615128`"}], "0.11835344264859207`", 
       "1.0026350701940996`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201946119093*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.07049994859101247`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.07049994859101247, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201946163456*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019462122927`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "10"}],
  SequenceForm["BFGS: Iteration = ", 10],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201946248699*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.535612060507290\"\>",
     -2.5356120605072903`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.550481227940079\"\>",
     -2.550481227940079,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[-2.5356120605072903`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-2.550481227940079, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201946291705*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.535612060507290\"\>",
     -2.5356120605072903`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.5356120605072903`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201946334148*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.550481227940079\"\>",
     -2.550481227940079,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.550481227940079, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019463802967`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.014869167432789\"\>",
     0.014869167432788544`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.014869167432788544`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019464178762`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201946463482*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"THETA1\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox["\<\"STEP\"\>",
        HoldForm], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\"-0.4604\"\>",
        -0.4603765150458742,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.2700\"\>",
        -0.270023698881212,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.1904\"\>",
        -0.19035281616466215`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0179\"\>",
        -0.0179121196269989,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 2.3686\"\>",
        2.3686133758630334`,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.5926\"\>",
        2.5925954706373764`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.2240\"\>",
        -0.22398209477434283`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0694\"\>",
        -0.0693547441120511,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 3.0000\"\>",
        3,
        Editable->False], 
       InterpretationBox["\<\" 1.0328\"\>",
        1.0327791846624834`,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.0408\"\>",
        1.0408045699659698`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0080\"\>",
        -0.008025385303486498,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0355\"\>",
        -0.03547892488627909,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 4.0000\"\>",
        4,
        Editable->False], 
       InterpretationBox["\<\"-0.0408\"\>",
        -0.040839363853360566`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0305\"\>",
        -0.030464155494571526`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0104\"\>",
        -0.010375208358789039`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0046\"\>",
        0.004581660032272339,
        AutoDelete->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[1.4]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019465042257`*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201946548479*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.047914432945631164`", 
       RowBox[{"-", "0.021940560840202683`"}], 
       RowBox[{"-", "0.0055798076910115735`"}], "0.030501126707506286`"},
      {"2", 
       RowBox[{"-", "0.02194056084020285`"}], "0.10197995093316736`", 
       RowBox[{"-", "0.05571055779918577`"}], 
       RowBox[{"-", "0.0847646370650872`"}]},
      {"3", 
       RowBox[{"-", "0.005579807691011657`"}], 
       RowBox[{"-", "0.05571055779918588`"}], "2.5753375129439973`", 
       "0.16789589933834653`"},
      {"4", "0.030501126707506286`", 
       RowBox[{"-", "0.08476463706508722`"}], "0.1678958993383466`", 
       "1.0300459467369938`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019465940857`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0264898438542957`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0264898438542957, " = Elastizitaet(d l/l)/(d theta/theta)"],
  
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201946631379*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201946669594*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "11"}],
  SequenceForm["BFGS: Iteration = ", 11],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019467312393`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.529331662972750\"\>",
     -2.5293316629727505`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.535612060507290\"\>",
     -2.5356120605072903`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[-2.5293316629727505`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-2.5356120605072903`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019467668247`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.529331662972750\"\>",
     -2.5293316629727505`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.5293316629727505`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201946819139*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.535612060507290\"\>",
     -2.5356120605072903`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.5356120605072903`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201946869721*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.006280397534540\"\>",
     0.0062803975345397944`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.0062803975345397944`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019469177713`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201946955792*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"THETA1\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox["\<\"STEP\"\>",
        HoldForm], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\"-0.7007\"\>",
        -0.7006896391667302,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.4604\"\>",
        -0.4603765150458742,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.2403\"\>",
        -0.24031312412085606`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0224\"\>",
        -0.022434473037719727`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 2.2730\"\>",
        2.2729525991442,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.3686\"\>",
        2.3686133758630334`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0957\"\>",
        -0.0956607767188332,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0284\"\>",
        -0.028357505805874136`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 3.0000\"\>",
        3,
        Editable->False], 
       InterpretationBox["\<\" 1.0367\"\>",
        1.0367142264400668`,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.0328\"\>",
        1.0327791846624834`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0039\"\>",
        0.00393504177758333,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0199\"\>",
        0.019922336420419844`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 4.0000\"\>",
        4,
        Editable->False], 
       InterpretationBox["\<\"-0.0423\"\>",
        -0.04227172741956764,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0408\"\>",
        -0.040839363853360566`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0014\"\>",
        -0.0014323635662070724`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0013\"\>",
        0.0012569427490234375`,
        AutoDelete->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[1.4]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019470113363`*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201947051482*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.046074819493904164`", 
       RowBox[{"-", "0.05936509379538066`"}], 
       RowBox[{"-", "0.042555638653776914`"}], "0.033292671740961954`"},
      {"2", 
       RowBox[{"-", "0.05936509379538082`"}], "0.23177277828442244`", 
       "0.1723325699441784`", 
       RowBox[{"-", "0.09623291787711576`"}]},
      {"3", 
       RowBox[{"-", "0.04255563865377699`"}], "0.17233256994417828`", 
       "2.9104344459612244`", "0.14892029840549534`"},
      {"4", "0.033292671740961954`", 
       RowBox[{"-", "0.09623291787711577`"}], "0.1489202984054954`", 
       "1.031038248239217`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201947091653*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.02696190943908423`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.02696190943908423, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201947136354*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201947202394*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "12"}],
  SequenceForm["BFGS: Iteration = ", 12],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.46020194723699*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.527192396859592\"\>",
     -2.5271923968595917`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.5271923968595917`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201947292432*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.529331662972750\"\>",
     -2.5293316629727505`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.5293316629727505`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201947346702*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.002139266113159\"\>",
     0.002139266113158733,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.002139266113158733, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019473921633`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019474399433`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"THETA1\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox["\<\"STEP\"\>",
        HoldForm], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\"-0.9378\"\>",
        -0.9377504860862328,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.7007\"\>",
        -0.7006896391667302,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.2371\"\>",
        -0.2370608469195026,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0046\"\>",
        -0.0045854151248931885`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 2.0120\"\>",
        2.0120167825285735`,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.2730\"\>",
        2.2729525991442,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.2609\"\>",
        -0.26093581661562637`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0300\"\>",
        -0.030003094329444556`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 3.0000\"\>",
        3,
        Editable->False], 
       InterpretationBox["\<\" 1.0514\"\>",
        1.051355074556124,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.0367\"\>",
        1.0367142264400668`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0146\"\>",
        0.014640848116057254`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0088\"\>",
        0.008826046368462287,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 4.0000\"\>",
        4,
        Editable->False], 
       InterpretationBox["\<\"-0.0531\"\>",
        -0.05309379821041624,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0423\"\>",
        -0.04227172741956764,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0108\"\>",
        -0.010822070790848595`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0046\"\>",
        0.0045705437660217285`,
        AutoDelete->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[1.4]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201947487914*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201947539791*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.10690469261623596`", 
       RowBox[{"-", "0.08583325597331348`"}], 
       RowBox[{"-", "0.07627522536563494`"}], "0.0483026690824807`"},
      {"2", 
       RowBox[{"-", "0.08583325597331364`"}], "0.20784569144292284`", 
       "0.1939654783089642`", 
       RowBox[{"-", "0.09644803243798088`"}]},
      {"3", 
       RowBox[{"-", "0.07627522536563501`"}], "0.1939654783089641`", 
       "2.9277590201617056`", "0.13935944808090114`"},
      {"4", "0.0483026690824807`", 
       RowBox[{"-", "0.09644803243798089`"}], "0.1393594480809012`", 
       "1.0336165256225245`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201947592471*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.019986472537210313`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.019986472537210313`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201947643112*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201947699773*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "13"}],
  SequenceForm["BFGS: Iteration = ", 13],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201947743266*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.526205033277134\"\>",
     -2.5262050332771335`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.5262050332771335`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201947791246*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.527192396859592\"\>",
     -2.5271923968595917`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.5271923968595917`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019478410254`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000987363582458\"\>",
     0.0009873635824582117,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.0009873635824582117, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201947893818*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019479411993`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"THETA1\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox["\<\"STEP\"\>",
        HoldForm], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\"-0.8706\"\>",
        -0.8706169467105935,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.9378\"\>",
        -0.9377504860862328,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0671\"\>",
        0.0671335393756393,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0021\"\>",
        -0.0020794272422790527`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 2.1125\"\>",
        2.1124858683833265`,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.0120\"\>",
        2.0120167825285735`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.1005\"\>",
        0.10046908585475323`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0251\"\>",
        0.025103996087251137`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 3.0000\"\>",
        3,
        Editable->False], 
       InterpretationBox["\<\" 1.0497\"\>",
        1.049734010382201,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.0514\"\>",
        1.051355074556124,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0016\"\>",
        -0.0016210641739230472`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0154\"\>",
        0.015352083383584169`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 4.0000\"\>",
        4,
        Editable->False], 
       InterpretationBox["\<\"-0.0536\"\>",
        -0.05364628210475131,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0531\"\>",
        -0.05309379821041624,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0006\"\>",
        -0.0005524838943350689,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0120\"\>",
        -0.011962890625,
        AutoDelete->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[1.4]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201947997861*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201948042592*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.10499457824658721`", 
       RowBox[{"-", "0.09173188798361721`"}], 
       RowBox[{"-", "0.07066366637501163`"}], "0.047813708254226275`"},
      {"2", 
       RowBox[{"-", "0.09173188798361737`"}], "0.3143751605128888`", 
       "0.24786918639567232`", 
       RowBox[{"-", "0.1431883675278617`"}]},
      {"3", 
       RowBox[{"-", "0.0706636663750117`"}], "0.2478691863956722`", 
       "2.921996807973059`", "0.1275346035177004`"},
      {"4", "0.047813708254226275`", 
       RowBox[{"-", "0.1431883675278617`"}], "0.12753460351770046`", 
       "1.0498910999420397`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201948092164*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.003569181401892711`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.003569181401892711, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201948140191*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.46020194821113*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "14"}],
  SequenceForm["BFGS: Iteration = ", 14],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019482441673`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.526170247018752\"\>",
     -2.526170247018752,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.526170247018752, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.46020194829111*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.526205033277134\"\>",
     -2.5262050332771335`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.5262050332771335`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.46020194834587*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000034786258381\"\>",
     0.00003478625838138072,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.00003478625838138072, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201948397954*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201948445923*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"THETA1\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox["\<\"STEP\"\>",
        HoldForm], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\"-0.8648\"\>",
        -0.8648351876600996,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.8706\"\>",
        -0.8706169467105935,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0058\"\>",
        0.005781759050493896,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0017\"\>",
        0.0016613304615020752`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 2.1008\"\>",
        2.1007968722720047`,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.1125\"\>",
        2.1124858683833265`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0117\"\>",
        -0.011688996111321891`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0043\"\>",
        -0.004268186669121137,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 3.0000\"\>",
        3,
        Editable->False], 
       InterpretationBox["\<\" 1.0506\"\>",
        1.0505591893800028`,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.0497\"\>",
        1.049734010382201,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0008\"\>",
        0.0008251789978018729,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0018\"\>",
        -0.0017665899096659242`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 4.0000\"\>",
        4,
        Editable->False], 
       InterpretationBox["\<\"-0.0574\"\>",
        -0.057397620433919896`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0536\"\>",
        -0.05364628210475131,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0038\"\>",
        -0.003751338329168587,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0020\"\>",
        -0.001967877149581909,
        AutoDelete->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[1.4]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201948499839*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201948544763*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.10839167400822416`", 
       RowBox[{"-", "0.1106866558889679`"}], 
       RowBox[{"-", "0.08107674983495036`"}], "0.05125561144022582`"},
      {"2", 
       RowBox[{"-", "0.11068665588896803`"}], "0.37001866176765563`", 
       "0.27264384210486214`", 
       RowBox[{"-", "0.12580673617143984`"}]},
      {"3", 
       RowBox[{"-", "0.08107674983495043`"}], "0.27264384210486203`", 
       "2.9317543460466164`", "0.1413130285619958`"},
      {"4", "0.05125561144022582`", 
       RowBox[{"-", "0.12580673617143986`"}], "0.14131302856199585`", 
       "1.0266703240653359`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201948599059*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0013123581629710347`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0013123581629710347`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019486528397`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201948711769*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "15"}],
  SequenceForm["BFGS: Iteration = ", 15],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201948744913*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.526156022990378\"\>",
     -2.526156022990378,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.526156022990378, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201948795163*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.526170247018752\"\>",
     -2.526170247018752,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.526170247018752, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201948852087*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000014224028374\"\>",
     0.000014224028374254516`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.000014224028374254516`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201948892015*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201948949291*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"THETA1\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox["\<\"STEP\"\>",
        HoldForm], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\"-0.8726\"\>",
        -0.8725564143961155,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.8648\"\>",
        -0.8648351876600996,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0077\"\>",
        -0.007721226736015895,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0008\"\>",
        -0.0007974803447723389,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 2.0943\"\>",
        2.094330476380537,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.1008\"\>",
        2.1007968722720047`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0065\"\>",
        -0.006466395891467669,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0003\"\>",
        0.00031185521156082527`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 3.0000\"\>",
        3,
        Editable->False], 
       InterpretationBox["\<\" 1.0509\"\>",
        1.0509314998577928`,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.0506\"\>",
        1.0505591893800028`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0004\"\>",
        0.00037231047778989146`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0002\"\>",
        -0.00016195323426923056`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 4.0000\"\>",
        4,
        Editable->False], 
       InterpretationBox["\<\"-0.0618\"\>",
        -0.061841168146360426`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0574\"\>",
        -0.057397620433919896`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0044\"\>",
        -0.004443547712440527,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0033\"\>",
        -0.0033152401447296143`,
        AutoDelete->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[1.4]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201948993844*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201949044602*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.1647098718763625`", 
       RowBox[{"-", "0.1857874041187958`"}], 
       RowBox[{"-", "0.10050126609057314`"}], "0.1552082604418758`"},
      {"2", 
       RowBox[{"-", "0.1857874041187959`"}], "0.43333998291885395`", 
       "0.2771341986898507`", 
       RowBox[{"-", "0.3547427778213368`"}]},
      {"3", 
       RowBox[{"-", "0.10050126609057322`"}], "0.27713419868985056`", 
       "2.9260038467653904`", "0.05294614993411295`"},
      {"4", "0.1552082604418758`", 
       RowBox[{"-", "0.3547427778213368`"}], "0.05294614993411301`", 
       "0.9970550354533654`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.46020194909823*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0012832021356899293`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0012832021356899293`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201949147078*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201949205105*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "16"}],
  SequenceForm["BFGS: Iteration = ", 16],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201949246653*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.526126670072039\"\>",
     -2.5261266700720393`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.5261266700720393`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201949302249*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.526156022990378\"\>",
     -2.526156022990378,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.526156022990378, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201949348185*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000029352918339\"\>",
     0.000029352918338609868`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.000029352918338609868`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201949399661*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019494531527`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"THETA1\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox["\<\"STEP\"\>",
        HoldForm], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\"-0.8781\"\>",
        -0.8781498071194256,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.8726\"\>",
        -0.8725564143961155,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0056\"\>",
        -0.005593392723310106,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0002\"\>",
        -0.00018128752708435059`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 2.0860\"\>",
        2.0860367520306102`,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.0943\"\>",
        2.094330476380537,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0083\"\>",
        -0.008293724349926947,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0009\"\>",
        0.000919613741014416,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 3.0000\"\>",
        3,
        Editable->False], 
       InterpretationBox["\<\" 1.0513\"\>",
        1.0512646931608336`,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.0509\"\>",
        1.0509314998577928`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0003\"\>",
        0.00033319330304087106`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0006\"\>",
        -0.0006077687970143773,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 4.0000\"\>",
        4,
        Editable->False], 
       InterpretationBox["\<\"-0.0754\"\>",
        -0.07535021557425309,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0618\"\>",
        -0.061841168146360426`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0135\"\>",
        -0.013509047427892657`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0032\"\>",
        -0.0032415688037872314`,
        AutoDelete->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[1.4]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201949500771*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201949546673*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.17225907047540098`", 
       RowBox[{"-", "0.13177739701328448`"}], 
       RowBox[{"-", "0.1372877969726869`"}], "0.01961329464685624`"},
      {"2", 
       RowBox[{"-", "0.1317773970132846`"}], "0.46840177752380335`", 
       "0.25030749195547725`", 
       RowBox[{"-", "0.294907947914633`"}]},
      {"3", 
       RowBox[{"-", "0.13728779697268698`"}], "0.25030749195547713`", 
       "2.9462574519986844`", "0.020827913599568232`"},
      {"4", "0.01961329464685624`", 
       RowBox[{"-", "0.294907947914633`"}], "0.020827913599568287`", 
       "0.4134036040640966`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.46020194959429*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0011441819084891005`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0011441819084891005`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019496503572`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201952029293*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "17"}],
  SequenceForm["BFGS: Iteration = ", 17],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201952060903*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.526089135240766\"\>",
     -2.526089135240766,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.526089135240766, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019521108103`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.526126670072039\"\>",
     -2.5261266700720393`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.5261266700720393`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019521629543`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000037534831273\"\>",
     0.00003753483127333368,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.00003753483127333368, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201952216028*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201952264805*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"THETA1\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox["\<\"STEP\"\>",
        HoldForm], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\"-0.8786\"\>",
        -0.878593447070802,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.8781\"\>",
        -0.8781498071194256,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0004\"\>",
        -0.0004436399513764556,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0003\"\>",
        0.0002821385860443115,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 2.0774\"\>",
        2.0773563903877106`,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.0860\"\>",
        2.0860367520306102`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0087\"\>",
        -0.008680361642899842,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0014\"\>",
        0.0013855692770679572`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 3.0000\"\>",
        3,
        Editable->False], 
       InterpretationBox["\<\" 1.0511\"\>",
        1.0511395855913241`,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.0513\"\>",
        1.0512646931608336`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0001\"\>",
        -0.00012510756950949176`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0011\"\>",
        -0.0010643072070052567`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 4.0000\"\>",
        4,
        Editable->False], 
       InterpretationBox["\<\"-0.1029\"\>",
        -0.10286048898966416`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0754\"\>",
        -0.07535021557425309,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0275\"\>",
        -0.027510273415411065`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0026\"\>",
        -0.002603501081466675,
        AutoDelete->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[1.4]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201952311194*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201952369295*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.1854730355722529`", 
       RowBox[{"-", "0.11308876404712905`"}], 
       RowBox[{"-", "0.1541608828780136`"}], "0.023137401032305042`"},
      {"2", 
       RowBox[{"-", "0.11308876404712914`"}], "0.4597870299351807`", 
       "0.25145441307389027`", 
       RowBox[{"-", "0.19476270015177893`"}]},
      {"3", 
       RowBox[{"-", "0.1541608828780137`"}], "0.25145441307389016`", 
       "2.949954098571837`", 
       RowBox[{"-", "0.05158355479073527`"}]},
      {"4", "0.02313740103230504`", 
       RowBox[{"-", "0.19476270015177893`"}], 
       RowBox[{"-", "0.05158355479073523`"}], "0.15595266925358736`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019524206553`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0008917139548262538`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0008917139548262538, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201952466207*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019525441837`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "18"}],
  SequenceForm["BFGS: Iteration = ", 18],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201952579949*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.526081167831830\"\>",
     -2.5260811678318302`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.5260811678318302`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201952632015*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.526089135240766\"\>",
     -2.526089135240766,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.526089135240766, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201952680661*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     7.967408935716236\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-6\"\>"]}],
     7.967408935716236*^-6,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[7.967408935716236*^-6, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201952732583*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201952783934*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"THETA1\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox["\<\"STEP\"\>",
        HoldForm], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\"-0.8733\"\>",
        -0.873332507226985,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.8786\"\>",
        -0.878593447070802,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0053\"\>",
        0.00526093984381701,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0005\"\>",
        0.0004995465278625488,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 2.0784\"\>",
        2.0784355151290894`,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.0774\"\>",
        2.0773563903877106`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0011\"\>",
        0.0010791247413789948`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0011\"\>",
        0.0010843343700927344`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 3.0000\"\>",
        3,
        Editable->False], 
       InterpretationBox["\<\" 1.0506\"\>",
        1.0506268759667567`,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.0511\"\>",
        1.0511395855913241`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0005\"\>",
        -0.0005127096245674586,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0011\"\>",
        -0.0010521572957270056`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 4.0000\"\>",
        4,
        Editable->False], 
       InterpretationBox["\<\"-0.1125\"\>",
        -0.11245850500999065`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.1029\"\>",
        -0.10286048898966416`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0096\"\>",
        -0.009598016020326491,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0009\"\>",
        -0.0009075701236724854,
        AutoDelete->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[1.4]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201952828368*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201952881116*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.1852083702339251`", 
       RowBox[{"-", "0.1211312051458349`"}], 
       RowBox[{"-", "0.149063065504446`"}], "0.04381467519377499`"},
      {"2", 
       RowBox[{"-", "0.121131205145835`"}], "0.42963346997080104`", 
       "0.2761127366284132`", 
       RowBox[{"-", "0.1458151248107074`"}]},
      {"3", 
       RowBox[{"-", "0.1490630655044461`"}], "0.27611273662841307`", 
       "2.9309527752545486`", 
       RowBox[{"-", "0.09760581086372268`"}]},
      {"4", "0.043814675193774986`", 
       RowBox[{"-", "0.14581512481070744`"}], 
       RowBox[{"-", "0.09760581086372264`"}], "0.10739378031391272`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019529352503`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0003148373794816174`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0003148373794816174, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201952982229*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201953044064*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "19"}],
  SequenceForm["BFGS: Iteration = ", 19],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201953078599*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.526080276897755\"\>",
     -2.5260802768977553`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.5260802768977553`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019531339912`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.526081167831830\"\>",
     -2.5260811678318302`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.5260811678318302`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019531839952`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     8.909340749596600\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-7\"\>"]}],
     8.909340749596595*^-7,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[8.909340749596595*^-7, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019532337303`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201953291087*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"THETA1\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox["\<\"STEP\"\>",
        HoldForm], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\"-0.8704\"\>",
        -0.8703904819718301,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.8733\"\>",
        -0.873332507226985,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0029\"\>",
        0.002942025255154902,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0002\"\>",
        0.00021395087242126465`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 2.0806\"\>",
        2.0805674113119874`,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.0784\"\>",
        2.0784355151290894`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0021\"\>",
        0.002131896182898147,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0004\"\>",
        0.0003826458744805665,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 3.0000\"\>",
        3,
        Editable->False], 
       InterpretationBox["\<\" 1.0504\"\>",
        1.0503616443572434`,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.0506\"\>",
        1.0506268759667567`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0003\"\>",
        -0.0002652316095132472,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0004\"\>",
        -0.0004021196600165181,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 4.0000\"\>",
        4,
        Editable->False], 
       InterpretationBox["\<\"-0.1129\"\>",
        -0.11294278044281406`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.1125\"\>",
        -0.11245850500999065`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0005\"\>",
        -0.00048427543282340705`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0001\"\>",
        -0.00011935830116271973`,
        AutoDelete->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[1.4]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201953338619*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019533835163`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.17411328898924675`", 
       RowBox[{"-", "0.14291584265464108`"}], 
       RowBox[{"-", "0.12705814148776726`"}], "0.05639955101873617`"},
      {"2", 
       RowBox[{"-", "0.1429158426546412`"}], "0.38799481503745714`", 
       "0.3186452916847068`", 
       RowBox[{"-", "0.12484224317246555`"}]},
      {"3", 
       RowBox[{"-", "0.12705814148776734`"}], "0.31864529168470673`", 
       "2.887709597752474`", 
       RowBox[{"-", "0.12034842269696257`"}]},
      {"4", "0.056399551018736165`", 
       RowBox[{"-", "0.12484224317246556`"}], 
       RowBox[{"-", "0.12034842269696254`"}], "0.10542907062628432`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201953436016*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "0.00003324634820856275`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.00003324634820856275, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201953486505*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019535467663`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201953584641*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "20"}],
  SequenceForm["BFGS: Iteration = ", 20],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201953636352*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.526080254009861\"\>",
     -2.5260802540098606`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.5260802540098606`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201953687725*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.526080276897755\"\>",
     -2.5260802768977553`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.5260802768977553`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201953745201*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     2.288789469062635\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-8\"\>"]}],
     2.2887894690626354`*^-8,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[2.2887894690626354`*^-8, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019538023987`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201953857665*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"THETA1\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox["\<\"STEP\"\>",
        HoldForm], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\"-0.8700\"\>",
        -0.8699873261737475,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.8704\"\>",
        -0.8703904819718301,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0004\"\>",
        0.0004031557980826114,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0000\"\>",
        0.000029534101486206055`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 2.0810\"\>",
        2.0810368898571308`,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.0806\"\>",
        2.0805674113119874`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0005\"\>",
        0.00046947854514329526`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0000\"\>",
        0.000040365404183451327`,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 3.0000\"\>",
        3,
        Editable->False], 
       InterpretationBox["\<\" 1.0503\"\>",
        1.0503319429942675`,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.0504\"\>",
        1.0503616443572434`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0000\"\>",
        -0.000029701362975982596`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.0000\"\>",
        -0.0000393538943218251,
        AutoDelete->True]},
      {
       InterpretationBox["\<\" 4.0000\"\>",
        4,
        Editable->False], 
       InterpretationBox["\<\"-0.1124\"\>",
        -0.11242557935303063`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.1129\"\>",
        -0.11294278044281406`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0005\"\>",
        0.00051720108978342,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0000\"\>",
        0.00002130866050720215,
        AutoDelete->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[1.4]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201953905345*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201953952318*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.1693493247856078`", 
       RowBox[{"-", "0.14983714925134461`"}], 
       RowBox[{"-", "0.12017814981974001`"}], "0.05420679082214429`"},
      {"2", 
       RowBox[{"-", "0.1498371492513447`"}], "0.37858386099952424`", 
       "0.327804743830001`", 
       RowBox[{"-", "0.12998354847027793`"}]},
      {"3", 
       RowBox[{"-", "0.1201781498197401`"}], "0.32780474383000097`", 
       "2.878858163975948`", 
       RowBox[{"-", "0.11464527150115827`"}]},
      {"4", "0.054206790822144274`", 
       RowBox[{"-", "0.12998354847027793`"}], 
       RowBox[{"-", "0.11464527150115825`"}], "0.11035213580419286`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019540063677`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "1.7696778837719565`*^-6", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 1.7696778837719565`*^-6, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019540789824`*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201954123789*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201954172286*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "21"}],
  SequenceForm["BFGS: Iteration = ", 21],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019542208853`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.526080253835823\"\>",
     -2.5260802538358234`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.5260802538358234`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.46020195426974*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.526080254009861\"\>",
     -2.5260802540098606`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.5260802540098606`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201954320032*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     1.740372290726100\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-10\"\>"]}],
     1.7403722907261*^-10,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[1.7403722907261*^-10, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019543740587`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201954419533*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"THETA1\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox["\<\"STEP\"\>",
        HoldForm], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {
       InterpretationBox["\<\" 1.0000\"\>",
        1,
        Editable->False], 
       InterpretationBox["\<\"-0.8700\"\>",
        -0.8699769238079941,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.8700\"\>",
        -0.8699873261737475,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0000\"\>",
        0.000010402365753416438`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0000\"\>",
        0,
        Editable->False]},
      {
       InterpretationBox["\<\" 2.0000\"\>",
        2,
        Editable->False], 
       InterpretationBox["\<\" 2.0811\"\>",
        2.081066101593224,
        AutoDelete->True], 
       InterpretationBox["\<\" 2.0810\"\>",
        2.0810368898571308`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0000\"\>",
        0.000029211736093210354`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0000\"\>",
        0,
        Editable->False]},
      {
       InterpretationBox["\<\" 3.0000\"\>",
        3,
        Editable->False], 
       InterpretationBox["\<\" 1.0503\"\>",
        1.0503325076091876`,
        AutoDelete->True], 
       InterpretationBox["\<\" 1.0503\"\>",
        1.0503319429942675`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0000\"\>",
        0,
        Editable->False], 
       InterpretationBox["\<\" 0.0000\"\>",
        0,
        Editable->False]},
      {
       InterpretationBox["\<\" 4.0000\"\>",
        4,
        Editable->False], 
       InterpretationBox["\<\"-0.1124\"\>",
        -0.11235175602448581`,
        AutoDelete->True], 
       InterpretationBox["\<\"-0.1124\"\>",
        -0.11242557935303063`,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0001\"\>",
        0.0000738233285448182,
        AutoDelete->True], 
       InterpretationBox["\<\" 0.0000\"\>",
        0,
        Editable->False]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[1.4]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
   Function[BoxForm`e$, 
    TableForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}, 
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201954471932*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019545229883`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.16907726472141432`", 
       RowBox[{"-", "0.1490792135466329`"}], 
       RowBox[{"-", "0.12195624724544181`"}], "0.05143910112521586`"},
      {"2", 
       RowBox[{"-", "0.14907921354663298`"}], "0.38122771107334114`", 
       "0.323748165260195`", 
       RowBox[{"-", "0.13309645639374512`"}]},
      {"3", 
       RowBox[{"-", "0.1219562472454419`"}], "0.32374816526019495`", 
       "2.884309025014389`", 
       RowBox[{"-", "0.11222644749025776`"}]},
      {"4", "0.051439101125215846`", 
       RowBox[{"-", "0.13309645639374512`"}], 
       RowBox[{"-", "0.11222644749025773`"}], "0.10683077362510397`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201954587509*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "2.0056349350797316`*^-7", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 2.0056349350797316`*^-7, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019546198587`*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.46020195466416*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019547255907`*^9}],

Cell[BoxData["\<\"ReturnCode = 3\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201954777165*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS:  ENDE DER ITERATION  \"\>", "\[InvisibleSpace]", "21", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "30"}],
  SequenceForm["BFGS:  ENDE DER ITERATION  ", 21, "  ", 30],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201954824863*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"SCORE\"\>",
       HoldForm]},
     {"1", 
      RowBox[{"-", "2.9802322387695312`*^-8"}]},
     {"2", 
      RowBox[{"-", "1.7184839461781187`*^-7"}]},
     {"3", "4.823610398806517`*^-7"},
     {"4", "1.4901161193847656`*^-7"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201954871464*^9}],

Cell[BoxData["\<\"F\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201954927684*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.1693481001241616`", 
       RowBox[{"-", "0.14849153218848526`"}], 
       RowBox[{"-", "0.12340303175287903`"}], "0.051583156900767535`"},
      {"2", 
       RowBox[{"-", "0.14849153218848535`"}], "0.3812572619025849`", 
       "0.3243645471551605`", 
       RowBox[{"-", "0.1308678401556623`"}]},
      {"3", 
       RowBox[{"-", "0.12340303175287913`"}], "0.32436454715516044`", 
       "2.8807137950215007`", 
       RowBox[{"-", "0.11877297868232718`"}]},
      {"4", "0.051583156900767514`", 
       RowBox[{"-", "0.1308678401556623`"}], 
       RowBox[{"-", "0.11877297868232715`"}], "0.10396019575770443`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201954975293*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"Likelihood\"\>",
       HoldForm], 
      TagBox["\<\"THETA\"\>",
       HoldForm], 
      TagBox[
       StyleBox["\<\"\[Null]\"\>",
        ShowStringCharacters->False],
       StyleForm[#, ShowStringCharacters -> False]& ], 
      TagBox[
       StyleBox["\<\"\[Null]\"\>",
        ShowStringCharacters->False],
       StyleForm[#, ShowStringCharacters -> False]& ], 
      TagBox[
       StyleBox["\<\"\[Null]\"\>",
        ShowStringCharacters->False],
       StyleForm[#, ShowStringCharacters -> False]& ]},
     {"1", 
      RowBox[{"-", "3.5099457583513`"}], "1", "2", "0.3`", 
      RowBox[{"-", "0.1`"}]},
     {"2", 
      RowBox[{"-", "2.636255377350169`"}], "1.0025506693422468`", 
      "2.052692698127195`", "1.3`", 
      RowBox[{"-", "0.0841522748554328`"}]},
     {"3", 
      RowBox[{"-", "2.5822634735494323`"}], "0.9530751079809243`", 
      "2.02406687751127`", "1.1473514227472725`", 
      RowBox[{"-", "0.09429266840180714`"}]},
     {"4", 
      RowBox[{"-", "2.572395980697445`"}], "0.9077314035704372`", 
      "2.064582181936226`", "1.0433049416724005`", 
      RowBox[{"-", "0.08352793677715198`"}]},
     {"5", 
      RowBox[{"-", "2.5706496480177154`"}], "0.8875117638035633`", 
      "2.09690532910725`", "1.0507773229853934`", 
      RowBox[{"-", "0.07568000714672463`"}]},
     {"6", 
      RowBox[{"-", "2.5669214752527054`"}], "0.7775129709676915`", 
      "2.215465798171301`", "1.05357421720998`", 
      RowBox[{"-", "0.05076069230037647`"}]},
     {"7", 
      RowBox[{"-", "2.5648473943685177`"}], "0.6624061337330223`", 
      "2.2929569604353217`", "1.0513541084723481`", 
      RowBox[{"-", "0.039976786896031735`"}]},
     {"8", 
      RowBox[{"-", "2.5612322726065013`"}], "0.40939711694259284`", 
      "2.4154684830724804`", "1.0482847719691863`", 
      RowBox[{"-", "0.0318993633269871`"}]},
     {"9", 
      RowBox[{"-", "2.5553363347451246`"}], 
      RowBox[{"-", "0.13016799613294694`"}], "2.6175401441152446`", 
      "1.0452115005537144`", 
      RowBox[{"-", "0.028462477132732734`"}]},
     {"10", 
      RowBox[{"-", "2.550481227940079`"}], 
      RowBox[{"-", "0.270023698881212`"}], "2.5925954706373764`", 
      "1.0408045699659698`", 
      RowBox[{"-", "0.030464155494571526`"}]},
     {"11", 
      RowBox[{"-", "2.5356120605072903`"}], 
      RowBox[{"-", "0.4603765150458742`"}], "2.3686133758630334`", 
      "1.0327791846624834`", 
      RowBox[{"-", "0.040839363853360566`"}]},
     {"12", 
      RowBox[{"-", "2.5293316629727505`"}], 
      RowBox[{"-", "0.7006896391667302`"}], "2.2729525991442`", 
      "1.0367142264400668`", 
      RowBox[{"-", "0.04227172741956764`"}]},
     {"13", 
      RowBox[{"-", "2.5271923968595917`"}], 
      RowBox[{"-", "0.9377504860862328`"}], "2.0120167825285735`", 
      "1.051355074556124`", 
      RowBox[{"-", "0.05309379821041624`"}]},
     {"14", 
      RowBox[{"-", "2.5262050332771335`"}], 
      RowBox[{"-", "0.8706169467105935`"}], "2.1124858683833265`", 
      "1.049734010382201`", 
      RowBox[{"-", "0.05364628210475131`"}]},
     {"15", 
      RowBox[{"-", "2.526170247018752`"}], 
      RowBox[{"-", "0.8648351876600996`"}], "2.1007968722720047`", 
      "1.0505591893800028`", 
      RowBox[{"-", "0.057397620433919896`"}]},
     {"16", 
      RowBox[{"-", "2.526156022990378`"}], 
      RowBox[{"-", "0.8725564143961155`"}], "2.094330476380537`", 
      "1.0509314998577928`", 
      RowBox[{"-", "0.061841168146360426`"}]},
     {"17", 
      RowBox[{"-", "2.5261266700720393`"}], 
      RowBox[{"-", "0.8781498071194256`"}], "2.0860367520306102`", 
      "1.0512646931608336`", 
      RowBox[{"-", "0.07535021557425309`"}]},
     {"18", 
      RowBox[{"-", "2.526089135240766`"}], 
      RowBox[{"-", "0.878593447070802`"}], "2.0773563903877106`", 
      "1.0511395855913241`", 
      RowBox[{"-", "0.10286048898966416`"}]},
     {"19", 
      RowBox[{"-", "2.5260811678318302`"}], 
      RowBox[{"-", "0.873332507226985`"}], "2.0784355151290894`", 
      "1.0506268759667567`", 
      RowBox[{"-", "0.11245850500999065`"}]},
     {"20", 
      RowBox[{"-", "2.5260802768977553`"}], 
      RowBox[{"-", "0.8703904819718301`"}], "2.0805674113119874`", 
      "1.0503616443572434`", 
      RowBox[{"-", "0.11294278044281406`"}]},
     {"21", 
      RowBox[{"-", "2.5260802540098606`"}], 
      RowBox[{"-", "0.8699873261737475`"}], "2.0810368898571308`", 
      "1.0503319429942675`", 
      RowBox[{"-", "0.11242557935303063`"}]},
     {"22", 
      RowBox[{"-", "2.5260802538358234`"}], 
      RowBox[{"-", "0.8699769238079941`"}], "2.081066101593224`", 
      "1.0503325076091876`", 
      RowBox[{"-", "0.11235175602448581`"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"Likelihood", "THETA"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201955044688*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"INK: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "6.055454452393343`*^-6", ",", "0.000012601800990617544`", ",", 
     "6.36024065969552`*^-6", ",", "6.055454452393343`*^-6"}], "}"}]}],
  SequenceForm[
  "INK: ", {6.055454452393343*^-6, 0.000012601800990617544`, 
   6.36024065969552*^-6, 6.055454452393343*^-6}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201955105318*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019551399117`*^9}],

Cell[BoxData["\<\"ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019551915894`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201955240019*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {
         StyleBox["\[Null]",
          ShowStringCharacters->False], 
         TagBox["\<\"THETA\"\>",
          HoldForm], 
         TagBox["\<\"SCORE\"\>",
          HoldForm]},
        {"1", 
         RowBox[{"-", "0.8699769238079941`"}], 
         RowBox[{"-", "2.9802322387695312`*^-8"}]},
        {"2", "2.081066101593224`", 
         RowBox[{"-", "1.7184839461781187`*^-7"}]},
        {"3", "1.0503325076091876`", "4.823610398806517`*^-7"},
        {"4", 
         RowBox[{"-", "0.11235175602448581`"}], "1.4901161193847656`*^-7"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxDividers->{
        "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
         "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.24]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
     "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[
     BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}]]], 
   "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "2.5260802538358234`"}]}],
  SequenceForm[
   MatrixForm[{{-0.8699769238079941, -2.9802322387695312`*^-8}, {
    2.081066101593224, -1.7184839461781187`*^-7}, {1.0503325076091876`, 
    4.823610398806517*^-7}, {-0.11235175602448581`, 1.4901161193847656`*^-7}},
     TableHeadings -> {Automatic, {"THETA", "SCORE"}}], 
   "   Likelihood = ", -2.5260802538358234`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.46020195529249*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201955341323*^9}],

Cell[BoxData["\<\"WALD-TEST:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201955393024*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019554499807`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"CHI \"\>",
       HoldForm], 
      TagBox["\<\"U \"\>",
       HoldForm], 
      TagBox["\<\"PROB \"\>",
       HoldForm], 
      TagBox["\<\"ALPHA \"\>",
       HoldForm]},
     {"1", "6.611679394015995`", "4", "0.15788828917160946`", "0.05`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", "ALPHA "}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201955506341*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201955551957*^9}],

Cell[BoxData["\<\"BONFERRONI-KONFIDENZINTERVALLE:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019556251163`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201955657219*^9}],

Cell[BoxData["\<\"P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= \
1-ALPHA\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201955697693*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"QUANTIL Z(1-ALPHA/2U) = \"\>", "\[InvisibleSpace]", 
   "2.4977054744123746`"}],
  SequenceForm["QUANTIL Z(1-ALPHA/2U) = ", 2.4977054744123746`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.46020195574746*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"THETA\"\>",
       HoldForm], 
      TagBox["\<\"GRENZE\"\>",
       HoldForm], 
      TagBox["\<\"STD\"\>",
       HoldForm]},
     {"1", 
      RowBox[{"-", "0.8699769238079941`"}], "7.551603528779135`", 
      "3.0234163339677878`"},
     {"2", "2.081066101593224`", "6.2778386468250655`", 
      "2.513442321818199`"},
     {"3", "1.0503325076091876`", "1.666080991388587`", "0.6670446169320902`"},
     {"4", 
      RowBox[{"-", "0.11235175602448581`"}], "10.3588462166355`", 
      "4.147344962308891`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201955799205*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019558471823`*^9}],

Cell[BoxData["\<\"Korrelation der ML-Sch\[ADoubleDot]tzer\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201955894349*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201955946814*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.9999999999999999`", "0.47988819303161445`", 
       "0.015118006684271806`", 
       RowBox[{"-", "0.015607264285390388`"}]},
      {"2", "0.47988819303161473`", "0.9999999999999999`", 
       RowBox[{"-", "0.18661676610917063`"}], "0.5532792694208623`"},
      {"3", "0.015118006684271997`", 
       RowBox[{"-", "0.18661676610917086`"}], "1.0000000000000002`", 
       "0.006105249076812074`"},
      {"4", 
       RowBox[{"-", "0.015607264285390318`"}], "0.5532792694208626`", 
       "0.006105249076812457`", "1.`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201955998103*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201956051887*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND \
EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019561308403`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019561787643`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "9.141046328503219`", "3.646757992164721`", 
       "0.03048929425895317`", 
       RowBox[{"-", "0.19570183579343903`"}]},
      {"2", "3.646757992164723`", "6.317392305106861`", 
       RowBox[{"-", "0.3128775963523776`"}], "5.767445266169401`"},
      {"3", "0.03048929425895356`", 
       RowBox[{"-", "0.31287759635237805`"}], "0.44494852097807897`", 
       "0.016889952585903242`"},
      {"4", 
       RowBox[{"-", "0.19570183579343814`"}], "5.767445266169403`", 
       "0.016889952585904297`", "17.200470236388934`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201956233705*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019562815866`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.3982264531790956`", ",", "2.1780295909226526`", ",", 
   "10.678385736487416`", ",", "19.849215610387912`"}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019563352623`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201956395526*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX \
UND EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019564485703`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201956504858*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.1729861673415203`", 
       RowBox[{"-", "0.15545525145570277`"}], 
       RowBox[{"-", "0.1232240788517862`"}], "0.0542144837122775`"},
      {"2", 
       RowBox[{"-", "0.15545525145570277`"}], "0.3803475451773756`", 
       "0.2830227331376419`", 
       RowBox[{"-", "0.1295799903687615`"}]},
      {"3", 
       RowBox[{"-", "0.1232240788517862`"}], "0.2830227331376419`", 
       "2.458656997272353`", 
       RowBox[{"-", "0.09871590006969888`"}]},
      {"4", "0.0542144837122775`", 
       RowBox[{"-", "0.1295799903687615`"}], 
       RowBox[{"-", "0.09871590006969888`"}], "0.10230084751873295`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201956558988*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019566000853`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2.5111340344591997`", ",", "0.4591305848954889`", ",", 
   "0.09364711340058253`", ",", "0.05037982455471232`"}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201956682473*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019567188053`*^9}],

Cell[BoxData["\<\"KOMPENSIERTE LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201956769703*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201956816412*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"U =  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  Nue = \"\>", "\[InvisibleSpace]", 
   "Indeterminate"}],
  SequenceForm["U =  ", 4, "  Nue = ", Indeterminate],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201956869763*^9}],

Cell[BoxData["\<\"AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) \
AZENCOTT/DACUNHA-CASTELLE (A/D)\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.460201956920805*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"LIK\"\>",
       HoldForm], 
      TagBox["\<\"AIC\"\>",
       HoldForm], 
      TagBox["\<\"SIC/RISS\"\>",
       HoldForm], 
      TagBox["\<\"A/D\"\>",
       HoldForm]},
     {
      TagBox["\<\"Kompensator\"\>",
       HoldForm], "0", "4", "Indeterminate", "Indeterminate"},
     {
      TagBox["\<\"komp. Lik.\"\>",
       HoldForm], 
      RowBox[{"-", "2.5260802538358234`"}], 
      RowBox[{"-", "6.526080253835824`"}], "Indeterminate", "Indeterminate"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {{"Kompensator", "komp. Lik."}, {
      "LIK", "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
    TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019569712553`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "1", 
       RowBox[{"-", "0.8699769238079941`"}], "3.0234163339677878`"},
      {"2", "2", "2.081066101593224`", "2.513442321818199`"},
      {"3", "0.3`", "1.0503325076091876`", "0.6670446169320902`"},
      {"4", 
       RowBox[{"-", "0.1`"}], 
       RowBox[{"-", "0.11235175602448581`"}], "4.147344962308891`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.460113389973647*^9, 3.460114056100081*^9, 
  3.460114179071628*^9, 3.4601142697179193`*^9, 3.460114343759589*^9, 
  3.460121016537031*^9, 3.4602008503444023`*^9, 3.460201923221129*^9, 
  3.460201965915328*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"mit", " ", 
  RowBox[{
   StyleBox["Pseudoinverser",
    FontColor->RGBColor[1, 0, 0]], ":"}]}]], "Input",
 PageWidth->Infinity,
 Evaluatable->False,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "scoreii", ",", "k", 
      ",", "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
    RowBox[{"BFGS", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"S", ",", "m", ",", "n", ",", "Deterministisch"}], "}"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      "\t  ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Idio", ",", 
          RowBox[{"{", "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Lik", ",", "LISRELlik", ",", "Score", ",", "Hesse"}], 
         "}"}]}], "}"}], ",", "\[IndentingNewLine]", "            ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Sing", "=", "True"}], ",", "1"}], "}"}], ",", 
        RowBox[{"KMAX", "=", "30"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EPS1", "=", ".0001"}], ",", 
          RowBox[{"EPS2", "=", ".0001"}]}], "}"}], ",", "\[IndentingNewLine]",
         "             ", 
        RowBox[{"OPTION", "=", "0"}], ",", 
        RowBox[{"PRINT", "=", 
         RowBox[{"0", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
            ",", "1", ",", "1"}], "}"}]}]}]}], "}"}]}], "]"}]}], ";"}], 
  "                                                                           \
     "}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460114070622117*^9, 3.460114071481653*^9}, {
   3.460200823094718*^9, 3.460200840404801*^9}, 3.460201973719617*^9},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0.006632328033447266`", ",", "0.13701245188713074`", ",", 
     "2.6002186834812164`", ",", "0.04120767116546631`"}], "}"}], ",", 
   RowBox[{"-", "3.5099457583513`"}]}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.4602019752029753`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.234579572810432`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.234579572810432, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201975207646*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.08115558508281522`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.08115558508281522, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.4602019752132893`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.030861543958020803`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.030861543958020803`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201975219017*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.020201575304777196`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.020201575304777196`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201975224395*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.011066566650895338`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.011066566650895338`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201975229312*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.01778156481602395`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.01778156481602395, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201975234054*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.029197193915260836`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.029197193915260836`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201975238912*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0700783355005584`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0700783355005584, " = Elastizitaet(d l/l)/(d theta/theta)"],
  
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201975275043*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.07050876231867104`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.07050876231867104, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201975338739*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.02653210735559757`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.02653210735559757, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.4602019754055862`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.026982503407813822`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.026982503407813822`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201975476337*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.020042668626888947`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.020042668626888947`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201975539398*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0035860866038473363`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0035860866038473363`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201975606118*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0013123935541476132`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0013123935541476132`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.4602019756710567`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0012830133696969436`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0012830133696969436`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201975750407*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0011324549883384434`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0011324549883384434`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201975790483*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0008817683865982221`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0008817683865982221, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201975856056*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0003117463423397788`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0003117463423397788, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.4602019759211187`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "0.000032998593303083026`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.000032998593303083026`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201975972678*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.4602019760460176`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "1.8286671465611693`*^-6", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 1.8286671465611693`*^-6, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.46020197609733*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201976144556*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "1.5337208327079706`*^-7", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 1.5337208327079706`*^-7, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201976196013*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201976251651*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.4602019763202133`*^9}],

Cell[BoxData["\<\"ReturnCode = 3\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201976370544*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"INK: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "6.055454452393343`*^-6", ",", "0.000012601808332898575`", ",", 
     "6.360240499785308`*^-6", ",", "6.055454452393343`*^-6"}], "}"}]}],
  SequenceForm[
  "INK: ", {6.055454452393343*^-6, 0.000012601808332898575`, 
   6.360240499785308*^-6, 6.055454452393343*^-6}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201976428541*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201976490275*^9}],

Cell[BoxData["\<\"ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201976545735*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201976600522*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {
         StyleBox["\[Null]",
          ShowStringCharacters->False], 
         TagBox["\<\"THETA\"\>",
          HoldForm], 
         TagBox["\<\"SCORE\"\>",
          HoldForm]},
        {"1", 
         RowBox[{"-", "0.8699758316592928`"}], 
         RowBox[{"-", "1.4901161193847656`*^-7"}]},
        {"2", "2.0810673141002436`", 
         RowBox[{"-", "1.5752760328484852`*^-7"}]},
        {"3", "1.0503324812015558`", "3.6886433388866354`*^-7"},
        {"4", 
         RowBox[{"-", "0.11234980256005944`"}], "1.7881393432617188`*^-7"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxDividers->{
        "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
         "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.24]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
     "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[
     BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}]]], 
   "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "2.526080253835921`"}]}],
  SequenceForm[
   MatrixForm[{{-0.8699758316592928, -1.4901161193847656`*^-7}, {
    2.0810673141002436`, -1.5752760328484852`*^-7}, {1.0503324812015558`, 
    3.6886433388866354`*^-7}, {-0.11234980256005944`, 
    1.7881393432617188`*^-7}}, 
    TableHeadings -> {Automatic, {"THETA", "SCORE"}}], 
   "   Likelihood = ", -2.526080253835921],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.4602019766650677`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201976714488*^9}],

Cell[BoxData["\<\"WALD-TEST:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.4602019767669907`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201976814488*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"CHI \"\>",
       HoldForm], 
      TagBox["\<\"U \"\>",
       HoldForm], 
      TagBox["\<\"PROB \"\>",
       HoldForm], 
      TagBox["\<\"ALPHA \"\>",
       HoldForm]},
     {"1", "6.611577885685533`", "4", "0.1578944416943624`", "0.05`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", "ALPHA "}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.4602019768867817`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201976923213*^9}],

Cell[BoxData["\<\"BONFERRONI-KONFIDENZINTERVALLE:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201976977743*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201977036797*^9}],

Cell[BoxData["\<\"P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= \
1-ALPHA\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201977084285*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"QUANTIL Z(1-ALPHA/2U) = \"\>", "\[InvisibleSpace]", 
   "2.4977054744123746`"}],
  SequenceForm["QUANTIL Z(1-ALPHA/2U) = ", 2.4977054744123746`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.4602019771342793`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"THETA\"\>",
       HoldForm], 
      TagBox["\<\"GRENZE\"\>",
       HoldForm], 
      TagBox["\<\"STD\"\>",
       HoldForm]},
     {"1", 
      RowBox[{"-", "0.8699758316592928`"}], "7.551317163306819`", 
      "3.023301682550617`"},
     {"2", "2.0810673141002436`", "6.277586071250074`", "2.51334119877644`"},
     {"3", "1.0503324812015558`", "1.6660876792014794`", 
      "0.66704729451476`"},
     {"4", 
      RowBox[{"-", "0.11234980256005944`"}], "10.358659374831493`", 
      "4.147270156930146`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201977186335*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.4602019772332907`*^9}],

Cell[BoxData["\<\"Korrelation der ML-Sch\[ADoubleDot]tzer\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.4602019772811403`*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201977326315*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "1.`", "0.47980693777883454`", "0.015100728232264264`", 
       RowBox[{"-", "0.015698725329498713`"}]},
      {"2", "0.479806937778833`", "0.9999999999999998`", 
       RowBox[{"-", "0.18664160934413743`"}], "0.5532742327593535`"},
      {"3", "0.015100728232264415`", 
       RowBox[{"-", "0.18664160934413762`"}], "1.0000000000000002`", 
       "0.006087681088032838`"},
      {"4", 
       RowBox[{"-", "0.015698725329499383`"}], "0.5532742327593534`", 
       "0.006087681088033033`", "1.`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201977407516*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201977443838*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND \
EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201977495706*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201977546598*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "9.140353063713391`", "3.645855563633271`", 
       "0.03045341525372961`", 
       RowBox[{"-", "0.1968376644511176`"}]},
      {"2", "3.6458555636332592`", "6.316883981466991`", 
       RowBox[{"-", "0.31290791437105286`"}], "5.767056702695307`"},
      {"3", "0.030453415253729917`", 
       RowBox[{"-", "0.3129079143710532`"}], "0.444952093119461`", 
       "0.016841115210392443`"},
      {"4", 
       RowBox[{"-", "0.19683766445112605`"}], "5.767056702695305`", 
       "0.016841115210392985`", "17.1998497545634`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.4602019776047583`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.4602019776505127`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.3982307650674179`", ",", "2.1780226842206325`", ",", 
   "10.677814815585677`", ",", "19.847970627989536`"}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201977698102*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201977753408*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX \
UND EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.4602019778013277`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201977850175*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.1729861673415203`", 
       RowBox[{"-", "0.15544497664093726`"}], 
       RowBox[{"-", "0.12320678612817139`"}], "0.05422053916672989`"},
      {"2", 
       RowBox[{"-", "0.15544497664093726`"}], "0.3803485001850273`", 
       "0.28301980500914625`", 
       RowBox[{"-", "0.1295857344368058`"}]},
      {"3", 
       RowBox[{"-", "0.12320678612817139`"}], "0.28301980500914625`", 
       "2.4586324204088883`", 
       RowBox[{"-", "0.09871301991467446`"}]},
      {"4", "0.05422053916672989`", 
       RowBox[{"-", "0.1295857344368058`"}], 
       RowBox[{"-", "0.09871301991467446`"}], "0.10230690297318534`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201977926497*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201977966241*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2.5111068448734906`", ",", "0.45913204083906617`", ",", 
   "0.09365212052004951`", ",", "0.050382984676015374`"}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201978011098*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201978069751*^9}],

Cell[BoxData["\<\"KOMPENSIERTE LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.46020197811418*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201978167848*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"U =  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  Nue = \"\>", "\[InvisibleSpace]", 
   "Indeterminate"}],
  SequenceForm["U =  ", 4, "  Nue = ", Indeterminate],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201978221953*^9}],

Cell[BoxData["\<\"AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) \
AZENCOTT/DACUNHA-CASTELLE (A/D)\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201978267386*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"LIK\"\>",
       HoldForm], 
      TagBox["\<\"AIC\"\>",
       HoldForm], 
      TagBox["\<\"SIC/RISS\"\>",
       HoldForm], 
      TagBox["\<\"A/D\"\>",
       HoldForm]},
     {
      TagBox["\<\"Kompensator\"\>",
       HoldForm], "0", "4", "Indeterminate", "Indeterminate"},
     {
      TagBox["\<\"komp. Lik.\"\>",
       HoldForm], 
      RowBox[{"-", "2.526080253835921`"}], 
      RowBox[{"-", "6.5260802538359215`"}], "Indeterminate", "Indeterminate"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {{"Kompensator", "komp. Lik."}, {
      "LIK", "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
    TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, 
   3.460200924677978*^9, 3.460201978315757*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "1", 
       RowBox[{"-", "0.8699758316592928`"}], "3.023301682550617`"},
      {"2", "2", "2.0810673141002436`", "2.51334119877644`"},
      {"3", "0.3`", "1.0503324812015558`", "0.66704729451476`"},
      {"4", 
       RowBox[{"-", "0.1`"}], 
       RowBox[{"-", "0.11234980256005944`"}], "4.147270156930146`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.460114079856052*^9, 3.46011418230438*^9, 
  3.4601142745898857`*^9, 3.4601143540557423`*^9, 3.460121020511301*^9, 
  3.460200846880375*^9, 3.4602019798915358`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"mit", " ", 
  RowBox[{
   StyleBox["Indiv",
    FontColor->RGBColor[1, 0, 0]], 
   StyleBox[".",
    FontColor->RGBColor[1, 0, 0]], 
   StyleBox[" ",
    FontColor->RGBColor[1, 0, 0]], 
   RowBox[{
    StyleBox["Lik",
     FontColor->RGBColor[1, 0, 0]], ":"}]}]}]], "Input",
 PageWidth->Infinity,
 Evaluatable->False,
 CellChangeTimes->{{3.460200864914688*^9, 3.4602008683517103`*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "scoreii", ",", "k", 
      ",", "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
    RowBox[{"BFGS", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"Y", ",", "X", ",", 
         RowBox[{"-", "9"}]}], "}"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      "\t  ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Idio", ",", 
          RowBox[{"{", "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Lik", ",", "IndividualLik", ",", "Score", ",", "Hesse"}], 
         "}"}]}], "}"}], ",", "\[IndentingNewLine]", "            ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Sing", "=", "\"\<CholeskyLinearSolve\>\""}], ",", "1"}], 
         "}"}], ",", 
        RowBox[{"KMAX", "=", "30"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EPS1", "=", ".0001"}], ",", 
          RowBox[{"EPS2", "=", ".0001"}]}], "}"}], ",", "\[IndentingNewLine]",
         "             ", 
        RowBox[{"OPTION", "=", "0"}], ",", 
        RowBox[{"PRINT", "=", 
         RowBox[{"0", 
          RowBox[{"{", 
           RowBox[{
           "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
            ",", "1", ",", "1"}], "}"}]}]}]}], "}"}]}], "]"}]}], ";"}], 
  "                                                                           \
     "}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460114070622117*^9, 3.460114071481653*^9}, {
  3.460200823094718*^9, 3.460200840404801*^9}, {3.460200880859779*^9, 
  3.460200936174124*^9}, {3.460200969565518*^9, 3.460200979961293*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0.00663226842880249`", ",", "0.1370125114917755`", ",", 
     "2.600218713283539`", ",", "0.04120755195617676`"}], "}"}], ",", 
   RowBox[{"-", "3.5099457583513`"}]}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201989553961*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.23457959551129232`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.23457959551129232`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201989557967*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.08115557360230712`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.08115557360230712, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.4602019895636387`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.030861544030098723`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.030861544030098723`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201989568776*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.020201621740847102`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.020201621740847102`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201989573984*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.011066601508770941`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.011066601508770941`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201989579236*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.017781576603030338`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.017781576603030338`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201989584684*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.029196658292961978`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.029196658292961978`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201989590109*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.07008229939751878`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.07008229939751878, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201989596301*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.07049357185526445`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.07049357185526445, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201989601639*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.02645829016401414`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.02645829016401414, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.4602019896066103`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.026947040680348738`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.026947040680348738`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.4602019896112013`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.019945715559828745`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.019945715559828745`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.46020198961585*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.00355662930256024`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.00355662930256024, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201989620392*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0013123581595964576`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0013123581595964576`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201989624531*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0012833319095624412`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0012833319095624412`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.46020198965943*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.00115290041367291`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.00115290041367291, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.4602019897210693`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0008996538923933732`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0008996538923933732, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201989769249*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0003171261627292037`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0003171261627292037, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201989816249*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "0.00003345870955538527`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.00003345870955538527, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.4602019898778563`*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201989935875*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "1.7460821786583`*^-6", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 1.7460821786583*^-6, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201989988682*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.46020199004288*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "1.7696778838938872`*^-7", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 1.7696778838938872`*^-7, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.4602019901212797`*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201990172385*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201990220347*^9}],

Cell[BoxData["\<\"ReturnCode = 3\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201990268299*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"INK: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "6.055454452393343`*^-6", ",", "0.000012601799789970732`", ",", 
     "6.360240760007171`*^-6", ",", "6.055454452393343`*^-6"}], "}"}]}],
  SequenceForm[
  "INK: ", {6.055454452393343*^-6, 0.000012601799789970732`, 
   6.360240760007171*^-6, 6.055454452393343*^-6}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201990330076*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.4602019903898907`*^9}],

Cell[BoxData["\<\"ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201990465951*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.4602019905323677`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {
         StyleBox["\[Null]",
          ShowStringCharacters->False], 
         TagBox["\<\"THETA\"\>",
          HoldForm], 
         TagBox["\<\"SCORE\"\>",
          HoldForm]},
        {"1", 
         RowBox[{"-", "0.869977093753065`"}], 
         RowBox[{"-", "2.9802322387695312`*^-8"}]},
        {"2", "2.081065903317963`", 
         RowBox[{"-", "1.5752771007490793`*^-7"}]},
        {"3", "1.050332524174691`", "4.2561267553500896`*^-7"},
        {"4", 
         RowBox[{"-", "0.1123519625313493`"}], "2.086162567138672`*^-7"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxDividers->{
        "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
         "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.24]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
     "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[
     BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}]]], 
   "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "2.5260802538358145`"}]}],
  SequenceForm[
   MatrixForm[{{-0.869977093753065, -2.9802322387695312`*^-8}, {
    2.081065903317963, -1.5752771007490793`*^-7}, {1.050332524174691, 
    4.2561267553500896`*^-7}, {-0.1123519625313493, 2.086162567138672*^-7}}, 
    TableHeadings -> {Automatic, {"THETA", "SCORE"}}], 
   "   Likelihood = ", -2.5260802538358145`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201990585039*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201990664053*^9}],

Cell[BoxData["\<\"WALD-TEST:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.4602019907024317`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.4602019907579193`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"CHI \"\>",
       HoldForm], 
      TagBox["\<\"U \"\>",
       HoldForm], 
      TagBox["\<\"PROB \"\>",
       HoldForm], 
      TagBox["\<\"ALPHA \"\>",
       HoldForm]},
     {"1", "6.6116460491369`", "4", "0.1578903102144924`", "0.05`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", "ALPHA "}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201990825612*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.4602019909409523`*^9}],

Cell[BoxData["\<\"BONFERRONI-KONFIDENZINTERVALLE:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.4602019910049057`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201991058743*^9}],

Cell[BoxData["\<\"P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= \
1-ALPHA\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201991122877*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"QUANTIL Z(1-ALPHA/2U) = \"\>", "\[InvisibleSpace]", 
   "2.4977054744123746`"}],
  SequenceForm["QUANTIL Z(1-ALPHA/2U) = ", 2.4977054744123746`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201991180797*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"THETA\"\>",
       HoldForm], 
      TagBox["\<\"GRENZE\"\>",
       HoldForm], 
      TagBox["\<\"STD\"\>",
       HoldForm]},
     {"1", 
      RowBox[{"-", "0.869977093753065`"}], "7.5513988834509265`", 
      "3.0233344006372547`"},
     {"2", "2.081065903317963`", "6.277253298293404`", "2.513207967312571`"},
     {"3", "1.050332524174691`", "1.6660805421857596`", "0.6670444370858946`"},
     {"4", 
      RowBox[{"-", "0.1123519625313493`"}], "10.357766704979232`", 
      "4.146912760967569`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201991246407*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201991317803*^9}],

Cell[BoxData["\<\"Korrelation der ML-Sch\[ADoubleDot]tzer\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.4602019913543653`*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201991415773*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "1.0000000000000002`", "0.47984045479784687`", 
       "0.015131281472907368`", 
       RowBox[{"-", "0.015699913795838797`"}]},
      {"2", "0.47984045479784726`", "1.`", 
       RowBox[{"-", "0.1866195760901757`"}], "0.5532031364148683`"},
      {"3", "0.01513128147290735`", 
       RowBox[{"-", "0.18661957609017574`"}], "1.`", 
       "0.006116014122171726`"},
      {"4", 
       RowBox[{"-", "0.015699913795839293`"}], "0.5532031364148681`", 
       "0.006116014122171696`", "0.9999999999999998`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201991468081*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201991513397*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND \
EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201991560894*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201991619523*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "9.14055089807663`", "3.645956422474636`", "0.03051523103642735`", 
       RowBox[{"-", "0.19683773211977895`"}]},
      {"2", "3.645956422474639`", "6.316214286963385`", 
       RowBox[{"-", "0.3128530498661383`"}], "5.7655130661333125`"},
      {"3", "0.030515231036427313`", 
       RowBox[{"-", "0.3128530498661384`"}], "0.44494828104723794`", 
       "0.016917965904344107`"},
      {"4", 
       RowBox[{"-", "0.19683773211978517`"}], "5.76551306613331`", 
       "0.016917965904344023`", "17.196885447075665`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201991661372*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201991724637*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.3982270249233653`", ",", "2.1780468710851126`", ",", 
   "10.678019271068115`", ",", "19.844305746086338`"}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201991775235*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.4602019918358917`*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX \
UND EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201991874648*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.4602019919307632`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.1729861673415203`", 
       RowBox[{"-", "0.15544799180420577`"}], 
       RowBox[{"-", "0.12322407690833607`"}], "0.05421751143950369`"},
      {"2", 
       RowBox[{"-", "0.15544799180420577`"}], "0.38034971498112463`", 
       "0.28301998529260547`", 
       RowBox[{"-", "0.12957563803702724`"}]},
      {"3", 
       RowBox[{"-", "0.12322407690833607`"}], "0.28301998529260547`", 
       "2.4586541752188125`", 
       RowBox[{"-", "0.0987158985127838`"}]},
      {"4", "0.05421751143950369`", 
       RowBox[{"-", "0.12957563803702724`"}], 
       RowBox[{"-", "0.0987158985127838`"}], "0.10230993070041154`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201991975871*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201992029975*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2.5111304291627112`", ",", "0.45912694225069434`", ",", 
   "0.09365032733266183`", ",", "0.05039228949580251`"}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201992077485*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201992128541*^9}],

Cell[BoxData["\<\"KOMPENSIERTE LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201992178749*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.4602019922266817`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"U =  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  Nue = \"\>", "\[InvisibleSpace]", 
   "Indeterminate"}],
  SequenceForm["U =  ", 4, "  Nue = ", Indeterminate],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201992283983*^9}],

Cell[BoxData["\<\"AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) \
AZENCOTT/DACUNHA-CASTELLE (A/D)\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.460201992358013*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"LIK\"\>",
       HoldForm], 
      TagBox["\<\"AIC\"\>",
       HoldForm], 
      TagBox["\<\"SIC/RISS\"\>",
       HoldForm], 
      TagBox["\<\"A/D\"\>",
       HoldForm]},
     {
      TagBox["\<\"Kompensator\"\>",
       HoldForm], "0", "4", "Indeterminate", "Indeterminate"},
     {
      TagBox["\<\"komp. Lik.\"\>",
       HoldForm], 
      RowBox[{"-", "2.5260802538358145`"}], 
      RowBox[{"-", "6.526080253835815`"}], "Indeterminate", "Indeterminate"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {{"Kompensator", "komp. Lik."}, {
      "LIK", "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
    TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601140595051107`*^9, 3.460114073742881*^9}, 
   3.460114179183425*^9, 3.4601142697981663`*^9, 3.460114348618577*^9, 
   3.460121016671194*^9, {3.4602008257913857`*^9, 3.4602008422755327`*^9}, {
   3.460200909092888*^9, 3.4602009170787907`*^9}, {3.460200973763565*^9, 
   3.460200981380927*^9}, 3.4602019923997507`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "1", 
       RowBox[{"-", "0.869977093753065`"}], "3.0233344006372547`"},
      {"2", "2", "2.081065903317963`", "2.513207967312571`"},
      {"3", "0.3`", "1.050332524174691`", "0.6670444370858946`"},
      {"4", 
       RowBox[{"-", "0.1`"}], 
       RowBox[{"-", "0.1123519625313493`"}], "4.146912760967569`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.460114079856052*^9, 3.46011418230438*^9, 3.4601142745898857`*^9, 
   3.4601143540557423`*^9, 3.460121020511301*^9, 3.460200846880375*^9, 
   3.4602009137294683`*^9, {3.460200976877967*^9, 3.460200986453204*^9}, 
   3.460201997758589*^9}]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Smoothing", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"mueetay", ",", "sigmaetay"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"mueeta", ",", "sigmaeta"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"mueY", ",", "sigmaY"}], "}"}]}], "}"}], "=", 
    RowBox[{"NormalCorrelation", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Y", ",", "X"}], "}"}], ",", "Theta", ",", 
      RowBox[{"{", 
       RowBox[{"Idio", ",", 
        RowBox[{"{", "}"}]}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.460202052412237*^9, 3.460202059962798*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{"s", "\[IndentingNewLine]", "m"}], "Input",
 CellChangeTimes->{{3.460202156885976*^9, 3.4602021599702053`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.6080511980958591`", ",", "0.5241604378706732`", ",", 
   "0.861991341553105`", ",", "0.7188311026524463`"}], "}"}]], "Output",
 CellChangeTimes->{{3.46020214051667*^9, 3.460202160706416*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "0.3466585542170436`"}], ",", 
   RowBox[{"-", "1.1416458763259956`"}], ",", 
   RowBox[{"-", "2.610080427218736`"}], ",", 
   RowBox[{"-", "1.821947345030123`"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.46020214051667*^9, 3.460202160710425*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"stdetay", "=", 
  RowBox[{
   RowBox[{"Map", "[", 
    RowBox[{"VecDiag", ",", "sigmaetay"}], "]"}], "//", "Sqrt"}]}]], "Input",
 CellChangeTimes->{3.4602021474628687`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
   "0.6080511980958591`", ",", "0.5241604378706732`", ",", 
    "0.861991341553105`", ",", "0.7188311026524463`"}], "}"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.460202148217552*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"i", "=", "1"}], ";", " ", 
  RowBox[{"z", "=", "1.96"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m", "=", 
   RowBox[{"mueetay", "[", 
    RowBox[{"[", "i", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"s", "=", 
    RowBox[{"stdetay", "[", 
     RowBox[{"[", "i", "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"KI", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ETA", "[", 
      RowBox[{"[", "i", "]"}], "]"}], ",", "m", ",", 
     RowBox[{"m", "+", 
      RowBox[{"z", " ", "s"}]}], ",", 
     RowBox[{"m", "-", 
      RowBox[{"z", " ", "s"}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"n", ",", "P"}], "}"}], "=", 
   RowBox[{"mueetay", "//", "Dimensions"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sel", "=", 
   RowBox[{"Range", "[", 
    RowBox[{"1", ",", "J1", ",", "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"t", "=", 
    RowBox[{"P", "//", "Range"}]}], ";"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pts", "=", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"PointSize", "[", ".015", "]"}], ",", 
       RowBox[{"Map", "[", 
        RowBox[{"Point", ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"t", ",", 
            RowBox[{"Y", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], "}"}], "//", "Transpose"}]}], 
        "]"}]}], "}"}], "//", "Flatten"}]}], ";"}], 
  "\n"}], "\[IndentingNewLine]", 
 RowBox[{"plot1", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"KI", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "sel"}], "]"}], "]"}], "//", "Transpose"}], "//", 
    RowBox[{
     RowBox[{"AddTimeAxis", "[", 
      RowBox[{"#", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "4", ",", "1"}], "}"}]}], "]"}], "&"}]}], ",", 
   RowBox[{"color", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "2", ",", "2"}], "}"}]}], ",", 
   RowBox[{"dicke", "\[Rule]", 
    RowBox[{".005", 
     RowBox[{"{", 
      RowBox[{"1.5", ",", "1", ",", "1", ",", "1"}], "}"}]}]}], ",", 
   RowBox[{"PlotLabel", "->", "\"\<True and smoothed trajectory\>\""}], ",", 
   "\[IndentingNewLine]", "            ", 
   RowBox[{"GridLines", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"t", ",", "None"}], "}"}]}], ",", 
   RowBox[{"Epilog", "\[Rule]", "pts"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.460202128398244*^9, 3.46020212884766*^9}, {
  3.460202229095125*^9, 3.460202338937739*^9}, {3.460202426491424*^9, 
  3.460202437876296*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {RGBColor[1, 0, 0], PointSize[0.0075], Thickness[0.0075], Dashing[{}], {},
      LineBox[{{1., -0.5209211781380665}, {2., -0.9295408453324674}, {
      3., -1.6418553289176625`}, {4., -2.1868161753951463`}}]}}, {{}, {}, 
    {RGBColor[0, 0, 1], PointSize[0.005], Thickness[0.005], Dashing[{}], {}, 
     LineBox[{{1., -0.3466585542170436}, {2., -1.1416458763259956`}, {
      3., -2.610080427218736}, {4., -1.821947345030123}}]}}, {{}, {}, 
    {RGBColor[0., 0.980407, 0.6039], PointSize[0.005], Thickness[0.005], 
     Dashing[{}], {}, 
     LineBox[{{1., 0.8451217940508401}, {2., -0.11429141809947607`}, {
      3., -0.9205773977746501}, {4., -0.41303838383132807`}}]}}, {{}, {}, 
    {RGBColor[0., 0.980407, 0.6039], PointSize[0.005], Thickness[0.005], 
     Dashing[{}], {}, 
     LineBox[{{1., -1.5384389024849274`}, {2., -2.169000334552515}, {
      3., -4.2995834566628215`}, {4., -3.230856306228918}}]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{1., -2.},
  DisplayFunction->Identity,
  Epilog->{
    PointSize[0.015], 
    PointBox[{1, 0.06552476067601987}], 
    PointBox[{2, -1.2137241384580495`}], 
    PointBox[{3, -2.659857992147833}], 
    PointBox[{4, -2.8608705618946257`}]},
  Frame->True,
  GridLines->{{1, 2, 3, 4}, None},
  PlotLabel->FormBox["\"True and smoothed trajectory\"", TraditionalForm],
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.460202099673654*^9, 3.460202128989832*^9}, {
   3.460202254468831*^9, 3.460202303865058*^9}, 3.4602023390660458`*^9, 
   3.4602024386657963`*^9}]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["idiographisches Modell, nichtlinear,P=4", "Section",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460112339653429*^9, 3.460112348475265*^9}, {
  3.460262521364668*^9, 3.4602625343677998`*^9}, {3.4607747985379753`*^9, 
  3.460774801241493*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"<<", "Kronecker.m"}]], "Input",
 CellChangeTimes->{{3.46026403353458*^9, 3.4602640402033443`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Set", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Correlation\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Options[Correlation]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/Set\\\", ButtonNote -> \
\\\"Set::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4602640404221287`*^9, 3.460279177814375*^9, 
  3.460363882363975*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDelayed", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(KroneckerProduct\\), \\\"MT\\\
\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(KroneckerProduct[\\(\\(a_, b_\
\\)\\)]\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/SetDelayed\\\", ButtonNote -> \
\\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4602640404221287`*^9, 3.460279177814375*^9, 
  3.4603638824149*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDelayed", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Correlation\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Correlation[y_]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/SetDelayed\\\", ButtonNote -> \
\\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4602640404221287`*^9, 3.460279177814375*^9, 
  3.4603638824186687`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDelayed", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Correlation\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Correlation[\\(\\(x_, y_, \\(\
\\(scatter_ : 0\\)\\), opts___\\)\\)]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/SetDelayed\\\", ButtonNote -> \
\\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4602640404221287`*^9, 3.460279177814375*^9, 
  3.46036388242233*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Further output of \\\\\\\"\\\
\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(SetDelayed :: \\\"write\\\
\"\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" will be \
suppressed during this calculation.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/stop\\\", \
ButtonNote -> \\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4602640404221287`*^9, 3.460279177814375*^9, 
  3.460363882499331*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"<<", "Kalman.exakt.impl.m"}]], "Input",
 CellChangeTimes->{{3.460263837588685*^9, 3.460263853906254*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"newpkg\"\>"}], 
  RowBox[{
  ":", " "}], \
"\<\"\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"NumericalMath`GaussianQuadrature`\\\
\"\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is now \
available as the \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"Numerical Differential \
Equation Analysis Package\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\". See the Compatibility \
Guide for updating information.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, \
ButtonData:>\\\"paclet:Compatibility/Tutorials/NumericalMath/\
GaussianQuadrature\\\", ButtonNote -> \\\"General::newpkg\\\"]\\)\"\>"}]], \
"Message", "MSG",
 CellChangeTimes->{3.460263854361351*^9, 3.4602640433774548`*^9, 
  3.460279180358728*^9, 3.460363884441977*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "::", "\<\"wrsym\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Symbol \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(RandomMultinomial\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/Clear\\\", ButtonNote -> \
\\\"Clear::wrsym\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.460263854361351*^9, 3.4602640433774548`*^9, 
  3.460279180358728*^9, 3.460363884521022*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDelayed", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(RandomMultinomial\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(RandomMultinomial[\\(\\(xij_, \
pij_, n_\\)\\)]\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/SetDelayed\\\", ButtonNote -> \
\\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.460263854361351*^9, 3.4602640433774548`*^9, 
  3.460279180358728*^9, 3.460363884528523*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "::", "\<\"wrsym\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Symbol \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(RandomNumbers\\), \\\"MT\\\"]\
\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is Protected.\\\\\\\"\\\", \\\"MT\
\\\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\
\", ButtonFrame->None, ButtonData:>\\\"paclet:ref/Clear\\\", ButtonNote -> \\\
\"Clear::wrsym\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.460263854361351*^9, 3.4602640433774548`*^9, 
  3.460279180358728*^9, 3.4603638845324593`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDelayed", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(RandomNumbers\\), \\\"MT\\\"]\
\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \\\"MT\\\"]\\)\
\[NoBreak]\\!\\(\\*StyleBox[\\!\\(RandomNumbers[\\(\\(\\(\\({x1_, x2_, \
dx_}\\)\\), density_, n_\\)\\)]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/SetDelayed\\\", ButtonNote -> \
\\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.460263854361351*^9, 3.4602640433774548`*^9, 
  3.460279180358728*^9, 3.4603638845873547`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Matrizen /SDE", "Subsection",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell["\<\
SDE:
dy  = A y dt + B x dt + G dw
z_t = H y_t + D x_t + eps_t\
\>", "Text",
 FontWeight->"Bold",
 FontColor->RGBColor[0, 0, 1]],

Cell["\<\
EDM:
y_{t+1} = astern y_t + bstern x_t + u_t
z_t = H y_t + D x_t +  eps_t
E[y_0] = mue; Var[y_0] = Sigma; \
\>", "Text",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}},
 FontWeight->"Bold",
 FontColor->RGBColor[1, 0, 0]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Theta", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"phi2", "=", 
     RowBox[{"-", ".5"}]}], ",", 
    RowBox[{"phi1", "=", "1"}], ",", "1", ",", 
    RowBox[{"g", "=", "1"}], ",", "0", ",", "0", ",", "1", ",", "0", ",", 
    "1"}], "}"}]}]], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "0.5`"}], ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", 
   ",", "1", ",", "0", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{3.4598278225657988`*^9, 3.460126886028954*^9, 
  3.4601978054591084`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Unprotect", "[", "A", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Clear", "[", "A", "]"}], "\n", 
 RowBox[{
  RowBox[{"A", "[", 
   RowBox[{"{", 
    RowBox[{
    "\[Omega]02_", ",", "gamma_", ",", "b_", ",", "g_", ",", "mu1_", ",", 
     "mu2_", ",", "Sigma11_", ",", "Sigma12_", ",", "Sigma22_"}], "}"}], 
   "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"0", "-", "1"}], ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\[Omega]02", ",", 
      RowBox[{"gamma", "-", "1"}]}], "}"}]}], "}"}]}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.4598278226896772`*^9, 3.4601268863596087`*^9, 
  3.460197805874611*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"A", "[", "Theta", "]"}], "+", "I2"}], "//", "MatrixForm", "   ", 
  RowBox[{"(*", 
   RowBox[{"Astern", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"phi2", ",", "phi1"}], "}"}]}], "}"}]}], "*)"}]}]], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2"},
      {"1", "0", "1"},
      {"2", 
       RowBox[{"-", "0.5`"}], "1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.4598278227408524`*^9, 3.4601268864310093`*^9, 
  3.460197805974761*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Clear", "[", "B", "]"}], "\n", 
 RowBox[{
  RowBox[{"B", "[", 
   RowBox[{"{", 
    RowBox[{
    "w02_", ",", "gamma_", ",", "b_", ",", "g_", ",", "mu1_", ",", "mu2_", 
     ",", "Sigma11_", ",", "Sigma12_", ",", "Sigma22_"}], "}"}], "]"}], ":=", 
  
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", "0", "}"}], ",", 
    RowBox[{"{", "b", "}"}]}], "}"}]}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"B", "[", "Theta", "]"}]], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "0", "}"}], ",", 
   RowBox[{"{", "1", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.459827822805098*^9, 3.4601268865261707`*^9, 
  3.460197806102346*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Clear", "[", "Omega", "]"}], "\n", 
 RowBox[{
  RowBox[{"Omega", "[", 
   RowBox[{"{", 
    RowBox[{
    "w02_", ",", "gamma_", ",", "b_", ",", "g_", ",", "mu1_", ",", "mu2_", 
     ",", "Sigma11_", ",", "Sigma12_", ",", "Sigma22_"}], "}"}], "]"}], ":=", 
  
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"10", "^", 
       RowBox[{"-", "4"}]}], ",", "0"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", 
      SuperscriptBox["g", "2"]}], "}"}]}], "}"}]}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Omega", "[", "Theta", "]"}]], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     FractionBox["1", "10000"], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.459827822865919*^9, 3.46012688660238*^9, 
  3.46019780622537*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Clear", "[", "Mue", "]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Mue", "[", 
    RowBox[{"{", 
     RowBox[{
     "w02_", ",", "gamma_", ",", "b_", ",", "g_", ",", "mu1_", ",", "mu2_", 
      ",", "Sigma11_", ",", "Sigma12_", ",", "Sigma22_"}], "}"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"mu1", ",", "mu2"}], "}"}]}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{"Clear", "[", "Sigma", "]"}], "\n", 
 RowBox[{
  RowBox[{"Sigma", "[", 
   RowBox[{"{", 
    RowBox[{
    "w02_", ",", "gamma_", ",", "b_", ",", "g_", ",", "mu1_", ",", "mu2_", 
     ",", "Sigma11_", ",", "Sigma12_", ",", "Sigma22_"}], "}"}], "]"}], ":=", 
  "\[IndentingNewLine]", "  ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "root", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"root", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Sigma11", ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Sigma12", ",", "Sigma22"}], "}"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"root", ".", 
      RowBox[{"Transpose", "[", "root", "]"}]}]}]}], "]"}]}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Mue", "[", 
  RowBox[{"Theta", "+", "1"}], "]"}]], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{3.45982782292763*^9, 3.460126886685533*^9, 
  3.460197806340096*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Sigma", "[", 
  RowBox[{"{", 
   RowBox[{
   "w02_", ",", "gamma_", ",", "b_", ",", "g_", ",", "mu1_", ",", "mu2_", ",",
     "Sigma11_", ",", "Sigma12_", ",", "Sigma22_"}], "}"}], "]"}]], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SuperscriptBox["Sigma11_", "2"], ",", 
     RowBox[{"Sigma11_", " ", "Sigma12_"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Sigma11_", " ", "Sigma12_"}], ",", 
     RowBox[{
      SuperscriptBox["Sigma12_", "2"], "+", 
      SuperscriptBox["Sigma22_", "2"]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.459827822978806*^9, 3.4601268867866497`*^9, 
  3.460197806466785*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Clear", "[", "H", "]"}], "\n", 
 RowBox[{
  RowBox[{"H", "[", 
   RowBox[{"{", 
    RowBox[{
    "w02_", ",", "gamma_", ",", "b_", ",", "g_", ",", "mu1_", ",", "mu2_", 
     ",", "Sigma11_", ",", "Sigma12_", ",", "Sigma22_"}], "}"}], "]"}], ":=", 
  
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], "}"}]}], "\n", 
 RowBox[{"H", "[", "Theta", "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"1", ",", "0"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.4598278230283947`*^9, 3.4601268868431387`*^9, 
  3.460197806579748*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Clear", "[", "R", "]"}], "\n", 
 RowBox[{
  RowBox[{"R", "[", 
   RowBox[{"{", 
    RowBox[{
    "w02_", ",", "gamma_", ",", "b_", ",", "g_", ",", "mu1_", ",", "mu2_", 
     ",", "Sigma11_", ",", "Sigma12_", ",", "Sigma22_"}], "}"}], "]"}], ":=", 
  
  RowBox[{"{", 
   RowBox[{"{", 
    RowBox[{"10", "^", 
     RowBox[{"-", "2"}]}], "}"}], "}"}]}], "\n", 
 RowBox[{"R", "[", "Theta", "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   FractionBox["1", "100"], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.459827823077408*^9, 3.460126886930704*^9, 
  3.460197807120111*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["EDM", "Subsection",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", "Logistic"}]], "Input",
 CellChangeTimes->{{3.460434794971136*^9, 3.4604347955208197`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox["\<\"Logistic[x_]:= Module[{xx=Exp[-x]}, 1/(1+xx)]\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.460460119201024*^9},
 CellTags->"Info3460467319-4560556"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "Logistic", "]"}], "=", 
      RowBox[{"{", 
       RowBox[{"Listable", ",", "Protected"}], "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"Logistic", "[", "x_", "]"}], ":=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Hermann`Kronecker`Private`xx", "=", 
             RowBox[{"Exp", "[", 
              RowBox[{"-", "x"}], "]"}]}], "}"}], ",", 
           FractionBox["1", 
            RowBox[{"1", "+", "Hermann`Kronecker`Private`xx"}]]}], "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[Hermann`Kronecker`Logistic],
  Editable->False]], "Print",
 CellChangeTimes->{3.4604601192098303`*^9},
 CellTags->"Info3460467319-4560556"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Heaviside", "[", 
  RowBox[{"{", 
   RowBox[{"0", ",", "0"}], "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Logistic", "[", 
    RowBox[{"100", 
     RowBox[{"{", " ", 
      RowBox[{"x", ",", 
       RowBox[{"10", " ", "x"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.460280327728023*^9, 3.460280341674404*^9}, {
  3.460434466158127*^9, 3.460434495620612*^9}, {3.4604345344447107`*^9, 
  3.4604345363154173`*^9}, {3.4604347450454597`*^9, 3.460434759093851*^9}, {
  3.460434831060215*^9, 3.4604349201005907`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["1", "2"], ",", 
   FractionBox["1", "2"]}], "}"}]], "Output",
 CellChangeTimes->{
  3.460434496327834*^9, 3.460434537579938*^9, 3.460434571430604*^9, 
   3.460434760012538*^9, 3.4604348407942944`*^9, {3.460434872905922*^9, 
   3.460434920637085*^9}, 3.460460119454465*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJw9zn0803kAB/BVr5Ruh0QhNFIk4ZLrtvb7fZFOx6vkMXk4K6F0N2KX1ykp
zzuPKeo8pVIbaXmah2b7egp1YiZP60jOhiXT6HCMM/e6fV6vz+vzev/30TsX
7Oy/HoPBuK1WtlkV53JS6EJ48ITaedCcjB8adC9hhAuhghbnZzvdbPxyxyed
I3uF8GMYOPrhcRletz42rfWtAEYxPm+/ONCKR8t2rnONEUCVlJuzfjrD+DuW
2bsWjAUwJcQtyrxsDv+xVgPN543CEHOpKDloK+Feo/rVcb1RuF69jpHHsyF8
7lb+cq1+BHKp4wmuS48JdX8/qeoyGYZPZ5rX/ThIOhIW8IXT18SH0phbNap+
+4gqKVsqSWp8+MG69JFbnA2xpGJX0cT5AdjpH9i2tNGLKMTY317c2A+3HnwQ
ONaUTIwx9E2Mde+D2n6pAUeXCom4k5TIr2m9MD/L0TA9n0NkU6ihWXM9UEIw
6E5y7yV65uQH7jreA69/IdPHHaaJ0pvap8IK30Kf7B3FF3AKSMGF7O9aMW/h
vAO7cWCLLnLUUUNvp083PJAfRcD5H0KEllmKwbU8yDMiMRdLHRCqtpqkUZ0H
z+BcoxLbzyEmGzL420O7oKM3k3w4/lekc0K5KaiDC3ffV44UudxCQrkpTznG
XHindsZpMJ6GbGAx3yVIOqBpXW+AHakB0e9xJGWkvYHdB6IvlRYPIFbiidFc
k3aY6E7fMTIrQXwVYy/SXr2GFvoFz05jsOj13bpTZQGvICaOpmjPMEBzkZrQ
ug1tcNbwjKdXMoqyTjvPtRS0wEDtg3v709xR/uXJq13IS6h04/Dt3qIQdCPW
Y+yypAl67BkW3x2LR82fNDmr0hrh4NaIf1qv3kc9rcw45V4N8HgtvcH2ERON
42fvc1Gph+/v4ihz7DcoaQJrPEZlw83W9jr9IaNolc4oxmjmBaw22/ygWGMJ
xTqz+i5418ArIxZsDcdt4Gx8BqPoJRNafH+DXEg1BiX3ROazRyrgsS1pvOT3
1mC+2KYCLS+Fmh15rBfKHiAxwvKSqlMJfEA63FO7PwTg7guCaQgN2swx2eqP
40B1UyaFaPwQKpCFC0q0XJDHTZI8PJAN4/9Q+4gjl4N2zcnFdoV0GNwT0bVb
vwWIkr5R/zMqHOYGS8N/UekDSGWM0540CugJY2qPT/0FNBElBtUwHej8kOek
GC8C+imsTfb7c8AzUy08VvAJZJErzeN2PAJR3yK0fiAGOduTfPx/pwPV4YJ8
MlsMCjhnfzu2kwHKbRtOmEyIgbNF7ruMjjKgtexqbjEvBm4JmyTRaZXA7+Lm
aHepGFi96yTY6VWDlhbcPoUVMTA2uxfzVUUtoFNdLhWuWi2G1N5pWwew19LJ
Q6te7jVSv9PLAYoOluUzq6ZkzpuaVNYDNWFU5OKqg6C3i5K0AZgP9Xosr9p3
oj58+lgTGMIIz6+s2nXbnlxeajO4Fbe3VeaQaRHWeeYluMntn5Q5+U1pZNfp
VvB8W/KCzPTiK1On6tqAAaVbKnNzAtGXi3sNXly3XZF5ybrNqnOiHcRWi9Zs
ueSi31HeCVIzpWv24R+y887kAdLcypoLqkCkk1MPGFn5z68zaAKtoT6AWcs0
mCUrnxwN4sv9UxnBcdx0UG7BjP+pScl7uV2ILK+TqSNyrxcoGJ31FMjNet51
PEhzXG7viIUcuyKR3A5PRxN8Qz7JbVB1+5lZzZTcy/U23bKf//tfYVGyOA==

     "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQBGIQPW1z0uzeFc/2F+nvNr/MJ8Zw727YmnXlz/YbZ3D9
cTu9gOHfubey1mrP9vetyH/SE9TKKHegpf/4laf7d0S3sWQJZTPZbZRmDGl+
un/vFFH+KfqBzFNMZ8n/1Hq639N2RZx6uCfL650SdvMuPdk/e1f91UXrnFhn
HBKtfqH4ZH91xcOF3P4m7B8v83+tOfBo/6K57l0n/4tz7/m2bNtFnQf7ncIP
6JSLRgsVp33dd/3wrf0L+jMar3lYSkXNnpcu73F1f8qRbtEFlp8Viy70rt6n
dWH/jaNvdmcuUNe8Vfim+qLt0f3CFw8KMLD+MEhsm7Ru5dGt++8Gz5R6s9vZ
Ys2MVwZfrDfvv3D6aO3SMA3LH6ucNttt2rD/lk5KXwoLn5XC/Kf5y22X71+3
xXypz5Vr1tsPTy2x0Vq0/1Xofa7n6nts5l7o/rRId9b+DWW9jFdjFtqekXzz
+wzbhP1iup+zX2S22r3qNhS9U1++f5HgnRDr4Cx72y3Ngar9JfaH4ox/mZ16
by9py7euU32C/eplaVv+/39vr9S7m91Le7Z9wbT//0H8aXlbDFrFF9szgMEH
+wX7ErtcpdfB+aHt7J+a+rfA+f+uaYhOubYPzg8RVp1zqe8InG/6J1jp3Kbz
CPO22dcGBl6F87/k8fs9yboF5z/9nBrw5tN9OD/YZne0X98jOJ/pKZtGYtRT
OH/3+oseWZIv4PyYqp+z3Ve+gvO9Vz9pjy94C+erbJu8Vn/HO4T7DzhdBvkb
xgcAHTMm+g==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.460434496327834*^9, 3.460434537579938*^9, 3.460434571430604*^9, 
   3.460434760012538*^9, 3.4604348407942944`*^9, {3.460434872905922*^9, 
   3.460434920637085*^9}, 3.460460119468275*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Plus", "@@", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Heaviside", "[", 
       RowBox[{"x", "-", "#"}], "]"}], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{"c1", ",", "c2"}], "}"}]}], "]"}]}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"x", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"x1", ",", "x2"}], "}"}]}], ",", 
    RowBox[{"c1", "->", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "2"}]}], "}"}]}], ",", 
    RowBox[{"c2", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.4602804139401493`*^9, 3.460280447538992*^9}, {
  3.460280544317827*^9, 3.460280657628171*^9}, {3.460434506601823*^9, 
  3.4604345076725397`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "x1"}], "]"}]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", 
          RowBox[{"1", "+", "x1"}], "]"}]}], ")"}]}]}], ",", 
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "x2"}], "]"}]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", 
          RowBox[{"1", "+", "x2"}], "]"}]}], ")"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "x1"}], "]"}]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", 
          RowBox[{"1", "+", "x1"}], "]"}]}], ")"}]}]}], ",", 
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "x2"}], "]"}]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", 
          RowBox[{"1", "+", "x2"}], "]"}]}], ")"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "x1"}], "]"}]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", 
          RowBox[{"1", "+", "x1"}], "]"}]}], ")"}]}]}], ",", 
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "x2"}], "]"}]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", 
          RowBox[{"1", "+", "x2"}], "]"}]}], ")"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "x1"}], "]"}]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", 
          RowBox[{"1", "+", "x1"}], "]"}]}], ")"}]}]}], ",", 
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "x2"}], "]"}]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", 
          RowBox[{"1", "+", "x2"}], "]"}]}], ")"}]}]}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.460280411758966*^9, 3.4602804482063417`*^9}, {
   3.46028057425738*^9, 3.460280658292327*^9}, 3.46028563184229*^9, 
   3.4602857219474*^9, 3.460285983590343*^9, 3.460286266378318*^9, 
   3.460286301805153*^9, 3.460363891030834*^9, 3.460377024341406*^9, 
   3.460434509256716*^9, 3.460434571668792*^9, 3.460460119542832*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Heaviside", "[", 
     RowBox[{"x", "+", "1"}], "]"}], "+", 
    RowBox[{"Heaviside", "[", 
     RowBox[{"x", "-", "1"}], "]"}], "-", "1"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
   RowBox[{"Axes", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.460280204140476*^9, 3.460280237625312*^9}, {
  3.460280316434142*^9, 3.4602803948226748`*^9}, {3.460281179896861*^9, 
  3.460281180607788*^9}, {3.460281264433981*^9, 3.460281466138386*^9}, {
  3.4604345209580584`*^9, 3.4604345275791397`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAGIQvV+g6N7//+wHGMDgw36L7ULyxzkR/A2xm+P7hNng
/GeySe82/GWG8/XlvMNNuJng/A9HrjDUKzHA+W/3Ts/frfBnP4wvV/RropXz
Dzi/xn6mAZ/2Nzj/Fo/F+YdCX+D8o8eu263n/gznb2goX1fD8gnOXxbrnva4
4SOcP8dKXM7r7wc4f5L486sbKhF8vpe50vpv3kP5wDA4rPVjzbd3cP73Oc+v
aDEi+A8CEvvUxN7A+Rt3hDDKObyA8y+temS56859OP/Kk7dO9iEX4PwFmk/5
n86fCOe/8uLOdrl+zh7G/zzH/JX1tXtwvsrffTOljj2H8/fyM/dNO/MCzg9T
cm8SuvwSzu9wP5/F9eA1nK8YJRzf9uwNnL8rJzyY6e1bOD+ofrZ73ed3cP7r
ifetf/18D+fbOjU/TCr/AOV/sG/dLbb0xEcE/6zJqgy9nI9wvug6W50pzxD8
pQtSNsff/gTnm07uttK+8BnOF2DNsdZ7/BXOf1XmY2P47TucX3VrRmfp1d9w
/gFt1nsnmBkcYPxTznO38QszwfmHpH9v+fqPGc4vbXi91F2EDc6fdULvkDIX
O5wPTe9wPgDcCfWB
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.460280319796722*^9, 3.460280354786551*^9, {3.460280389749917*^9, 
   3.460280394994143*^9}, 3.4602811810928717`*^9, 3.460281274494234*^9, {
   3.460281308314047*^9, 3.460281466274333*^9}, 3.460285631915004*^9, 
   3.4602857220189037`*^9, 3.460285983666174*^9, 3.460286266453809*^9, 
   3.460286301892166*^9, 3.460363891107939*^9, 3.460377024417347*^9, 
   3.4604345292437963`*^9, 3.4604345717561197`*^9, 3.46046011964497*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["th"], "Input",
 CellChangeTimes->{{3.460722238195915*^9, 3.460722238249185*^9}}],

Cell[BoxData["th"], "Output",
 CellChangeTimes->{3.460722238820682*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "Idio", "]"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"Idio", "[", 
   RowBox[{"th_", ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "beta", ",", "gamma", ",", "sigma", ",", "\[IndentingNewLine]", 
      "             ", "sigmazeta", ",", "lambdaeta", ",", "taueta", ",", 
      "sigmaepsilon"}], "}"}], ",", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"beta", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
        "\[IndentingNewLine]", "           ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"th", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", "0", ",", "0", ",", "0"}], 
         "}"}], ",", "\[IndentingNewLine]", "          ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"th", "[", 
           RowBox[{"[", "4", "]"}], "]"}], ",", 
          RowBox[{"th", "[", 
           RowBox[{"[", "2", "]"}], "]"}], ",", "0", ",", "0"}], "}"}], ",", 
        "\[IndentingNewLine]", "          ", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", 
          RowBox[{"th", "[", 
           RowBox[{"[", "3", "]"}], "]"}], ",", "0"}], "}"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"gamma", "=", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], "//", 
       "Spalte"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"sigmazeta", "=", "I4"}], ";", "\[IndentingNewLine]", 
     RowBox[{"lambdaeta", "=", "I4"}], ";", "\[IndentingNewLine]", 
     RowBox[{"taueta", "=", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], "//", 
       "Spalte"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"sigmaepsilon", "=", 
      RowBox[{
       RowBox[{"10", "^", 
        RowBox[{"-", "1"}]}], " ", "I4"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"lambdaeta", ",", "taueta", ",", "sigmaepsilon"}], "}"}]}], 
      "}"}]}]}], "\[IndentingNewLine]", "]"}]}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460112411326638*^9, 3.460112486848282*^9}, {
   3.460112574501026*^9, 3.460112833350883*^9}, 3.460113258604714*^9, {
   3.4601981935531387`*^9, 3.4601982253887444`*^9}, {3.46019833150395*^9, 
   3.460198339518457*^9}, {3.460198463453682*^9, 3.460198495668239*^9}, {
   3.4602012679397707`*^9, 3.4602012745935698`*^9}, {3.460437742137166*^9, 
   3.4604377442837257`*^9}, {3.460459421523945*^9, 3.460459423450386*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "IdioNonlin", "]"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"IdioNonlin", "[", 
   RowBox[{"th_", ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "beta", ",", "gamma", ",", "sigma", ",", "\[IndentingNewLine]", 
      "             ", "sigmazeta", ",", "lambdaeta", ",", "taueta", ",", 
      "sigmaepsilon", ",", "x", ",", "theta", ",", "h", ",", "dh"}], "}"}], 
    ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"beta", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
        "\[IndentingNewLine]", "           ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"th", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", "0", ",", "0", ",", "0"}], 
         "}"}], ",", "\[IndentingNewLine]", "          ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"th", "[", 
           RowBox[{"[", "4", "]"}], "]"}], ",", 
          RowBox[{"th", "[", 
           RowBox[{"[", "2", "]"}], "]"}], ",", "0", ",", "0"}], "}"}], ",", 
        "\[IndentingNewLine]", "          ", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", 
          RowBox[{"th", "[", 
           RowBox[{"[", "3", "]"}], "]"}], ",", "0"}], "}"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"gamma", "=", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], "//", 
       "Spalte"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"sigmazeta", "=", "I4"}], ";", "\[IndentingNewLine]", 
     RowBox[{"c1", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"c2", "=", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"c3", "=", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"h", "[", 
         RowBox[{"eta_", ",", "x_", ",", "theta_"}], "]"}], ":=", 
        RowBox[{
         RowBox[{"Plus", "@@", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Logistic", "[", 
              RowBox[{"100", 
               RowBox[{"(", 
                RowBox[{"eta", "-", "#"}], ")"}]}], "]"}], "&"}], ",", 
            RowBox[{"{", 
             RowBox[{"c1", ",", "c2"}], "}"}]}], "]"}]}], "-", "1"}]}], ";"}],
       "*)"}], "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"h", "[", 
         RowBox[{"eta_", ",", "x_", ",", "theta_"}], "]"}], ":=", 
        RowBox[{
         RowBox[{"Plus", "@@", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Heaviside", "[", 
              RowBox[{"(", 
               RowBox[{"eta", "-", "#"}], ")"}], "]"}], "&"}], ",", 
            RowBox[{"{", 
             RowBox[{"c1", ",", "c2", ",", "c3"}], "}"}]}], "]"}]}], "-", 
         "1"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"h", "[", 
       RowBox[{"eta_", ",", "x_", ",", "theta_"}], "]"}], ":=", 
      RowBox[{"eta", "-", "  ", 
       RowBox[{"1", " ", 
        RowBox[{"eta", "^", "3"}]}]}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"P", ",", "Q"}], "}"}], "=", 
      RowBox[{"gamma", "//", "Dimensions"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Off", "[", 
      RowBox[{"Part", "::", "\"\<partd\>\""}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"eta", "//", "Clear"}], ";", "\[IndentingNewLine]", 
     RowBox[{"etai", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"eta", "[", 
         RowBox[{"[", "i", "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "P"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"hilf", "=", 
      RowBox[{"Outer", "[", 
       RowBox[{"D", ",", 
        RowBox[{"h", "[", 
         RowBox[{"etai", ",", "x", ",", "theta"}], "]"}], ",", "etai"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"dh", "[", 
       RowBox[{"eta_", ",", "x_", ",", "theta_"}], "]"}], "=", "hilf"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"sigmaepsilon", "=", 
      RowBox[{
       RowBox[{"10", "^", 
        RowBox[{"-", "1"}]}], " ", "I4"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"h", ",", "dh", ",", "sigmaepsilon"}], "}"}]}], "}"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460112411326638*^9, 3.460112486848282*^9}, {
   3.460112574501026*^9, 3.460112833350883*^9}, 3.460113258604714*^9, {
   3.4601981935531387`*^9, 3.4601982253887444`*^9}, {3.46019833150395*^9, 
   3.460198339518457*^9}, {3.460198463453682*^9, 3.460198495668239*^9}, {
   3.4602012679397707`*^9, 3.4602012745935698`*^9}, {3.460262544333317*^9, 
   3.460262672020108*^9}, {3.4602627586317263`*^9, 3.46026276001101*^9}, {
   3.4602704141975107`*^9, 3.46027041438337*^9}, {3.460280467176902*^9, 
   3.460280473085874*^9}, {3.4602806924891443`*^9, 3.460280711976782*^9}, {
   3.46028116644274*^9, 3.460281167729628*^9}, {3.460281474946793*^9, 
   3.460281508316875*^9}, {3.4602815479174967`*^9, 3.4602815484137983`*^9}, {
   3.4602816507807617`*^9, 3.460281676993616*^9}, {3.460284307808282*^9, 
   3.460284309899661*^9}, {3.4602847275090322`*^9, 3.460284736183663*^9}, {
   3.4602856192308903`*^9, 3.460285624220776*^9}, {3.460285710934456*^9, 
   3.460285717823205*^9}, {3.4602859764427147`*^9, 3.460285978161388*^9}, {
   3.460286261013752*^9, 3.460286261455785*^9}, {3.4602862948772097`*^9, 
   3.46028629819168*^9}, 3.4603642740349617`*^9, 3.4603644544831877`*^9, 
   3.460365456780478*^9, 3.4603665095654716`*^9, {3.460366607243189*^9, 
   3.4603666125853157`*^9}, {3.4603697272002287`*^9, 3.460369730933084*^9}, {
   3.46037151872565*^9, 3.460371519963439*^9}, {3.460373536249193*^9, 
   3.46037353630791*^9}, {3.460377010128886*^9, 3.4603770349211197`*^9}, {
   3.460377168908317*^9, 3.460377169368896*^9}, 3.46037765815534*^9, 
   3.460431475811249*^9, {3.4604319304909678`*^9, 3.4604319341933823`*^9}, {
   3.460432429495256*^9, 3.460432430269183*^9}, {3.4604331102297277`*^9, 
   3.4604331102918997`*^9}, {3.460433492904319*^9, 3.460433500341628*^9}, {
   3.4604343556223097`*^9, 3.460434355679142*^9}, {3.460434545548963*^9, 
   3.460434546745728*^9}, {3.46043493786023*^9, 3.460434967965836*^9}, {
   3.460435089839349*^9, 3.460435118610239*^9}, {3.460437529942061*^9, 
   3.4604375424215612`*^9}, 3.460438912806677*^9, 3.460439035722678*^9, {
   3.4604393410536213`*^9, 3.460439342272788*^9}, 3.460439840453356*^9, {
   3.460440333630175*^9, 3.460440355270155*^9}, {3.4604590838600483`*^9, 
   3.4604590936409283`*^9}, {3.46045943423339*^9, 3.460459435215295*^9}, {
   3.460460115325142*^9, 3.460460115390798*^9}, {3.460721605284321*^9, 
   3.4607216861135473`*^9}, {3.4607225022010937`*^9, 
   3.4607225180985603`*^9}, {3.46072257741747*^9, 3.4607225784771767`*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData["hilf"], "Input",
 CellChangeTimes->{{3.460721820620864*^9, 3.460721821402771*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"1", "-", 
      RowBox[{"3", " ", 
       SuperscriptBox[
        RowBox[{
        "eta$164918", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
        "2"]}]}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"1", "-", 
      RowBox[{"3", " ", 
       SuperscriptBox[
        RowBox[{
        "eta$164918", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
        "2"]}]}], ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", 
     RowBox[{"1", "-", 
      RowBox[{"3", " ", 
       SuperscriptBox[
        RowBox[{
        "eta$164918", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
        "2"]}]}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", 
     RowBox[{"1", "-", 
      RowBox[{"3", " ", 
       SuperscriptBox[
        RowBox[{
        "eta$164918", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}], 
        "2"]}]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.460721821538653*^9, 3.460722522060307*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"h", "//", "Clear"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"h", ",", "dh", ",", "sigmaepsilon"}], "}"}]}], "}"}], "=", 
    RowBox[{"IdioNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
      RowBox[{"{", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{"beta", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"gamma", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"sigmazeta", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"sigmaepsilon", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"h", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", "0", ",", "0"}], "}"}], ",", "0", ",", 
      "theta"}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"dh", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "0", ",", "0"}], "}"}], ",", "0", ",", 
   "theta"}], "]"}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.46011249354161*^9, 3.460112502635364*^9}, {
   3.460112738246236*^9, 3.460112740427596*^9}, {3.4601985014479733`*^9, 
   3.4601985021073637`*^9}, {3.460262678368519*^9, 3.460262744386445*^9}, {
   3.460270452868237*^9, 3.460270456266705*^9}, {3.46028153495817*^9, 
   3.4602816223627872`*^9}, {3.460284322897622*^9, 3.4602843302074947`*^9}, {
   3.460721841938987*^9, 3.460721842608491*^9}, {3.46072253843577*^9, 
   3.460722560234561*^9}, 3.460722615455822*^9},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0", "0", "0", "0"},
      {"2", "1", "0", "0", "0"},
      {"3", "4", "2", "0", "0"},
      {"4", "0", "0", "3", "0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, 
   3.460721705060134*^9, 3.460721843511634*^9, 3.460722529695512*^9, {
   3.460722561253811*^9, 3.460722582850761*^9}, 3.460722618209428*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0"},
      {"2", "0"},
      {"3", "0"},
      {"4", "0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, 
   3.460721705060134*^9, 3.460721843511634*^9, 3.460722529695512*^9, {
   3.460722561253811*^9, 3.460722582850761*^9}, 3.4607226182202063`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "1", "0", "0", "0"},
      {"2", "0", "1", "0", "0"},
      {"3", "0", "0", "1", "0"},
      {"4", "0", "0", "0", "1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, 
   3.460721705060134*^9, 3.460721843511634*^9, 3.460722529695512*^9, {
   3.460722561253811*^9, 3.460722582850761*^9}, 3.4607226182282763`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", 
       FractionBox["1", "10"], "0", "0", "0"},
      {"2", "0", 
       FractionBox["1", "10"], "0", "0"},
      {"3", "0", "0", 
       FractionBox["1", "10"], "0"},
      {"4", "0", "0", "0", 
       FractionBox["1", "10"]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, 
   3.460721705060134*^9, 3.460721843511634*^9, 3.460722529695512*^9, {
   3.460722561253811*^9, 3.460722582850761*^9}, 3.460722618235879*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwtlnk4FOgDx8fMMG6SqyZy5c7RziSU99XlaBcrm3aFTFtrlwoxqZVsW46t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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, 
   3.460721705060134*^9, 3.460721843511634*^9, 3.460722529695512*^9, {
   3.460722561253811*^9, 3.460722582850761*^9}, 3.460722618243393*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"1", "-", 
      RowBox[{"3", " ", 
       SuperscriptBox["x", "2"]}]}], ",", "0", ",", "0", ",", "0"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, 
   3.460721705060134*^9, 3.460721843511634*^9, 3.460722529695512*^9, {
   3.460722561253811*^9, 3.460722582850761*^9}, 3.460722618278069*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Simulation/dt=1", "Subsection",
 PageWidth->Infinity,
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Theta", "=", 
  RowBox[{"0", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", ".3", ",", 
     RowBox[{"-", ".1"}]}], "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", "1"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"q", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"X", "=", 
  RowBox[{"Shape", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", "1"}], "}"}]}], "]"}]}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460112861196432*^9, 3.460112900249464*^9}, {
   3.460112950538982*^9, 3.4601129539374437`*^9}, {3.460113005467535*^9, 
   3.460113006401746*^9}, {3.460113958542322*^9, 3.460113959287684*^9}, 
   3.4601141435117283`*^9, {3.46011422532432*^9, 3.460114228762265*^9}, {
   3.460114299482638*^9, 3.460114299662619*^9}, {3.460120919663384*^9, 
   3.460120925946155*^9}, {3.460370026377693*^9, 3.460370026423751*^9}, {
   3.460370337087948*^9, 3.460370337140321*^9}, {3.460371593295773*^9, 
   3.460371593877831*^9}, {3.460377254178602*^9, 3.4603772542338552`*^9}, 
   3.460427451561919*^9, 3.4604329049294033`*^9, 3.460433078433264*^9, 
   3.460437042733672*^9, 3.460444571968473*^9, 3.460460037897266*^9, 
   3.460460803716981*^9},
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{
  3.45982787174109*^9, {3.460112887861902*^9, 3.460112900786964*^9}, 
   3.460112954913162*^9, {3.460113000282473*^9, 3.460113007967648*^9}, 
   3.460113265712655*^9, 3.460113964238937*^9, 3.460114146876112*^9, 
   3.4601142349213667`*^9, 3.460114304518387*^9, 3.460120929697301*^9, {
   3.460126878115456*^9, 3.460126894622835*^9}, 3.4601274604024973`*^9, 
   3.460197817926371*^9, 3.460198252562779*^9, 3.460198349161854*^9, 
   3.460198506587408*^9, 3.460199526323365*^9, 3.460199563520813*^9, 
   3.460199653793846*^9, 3.4602004848983727`*^9, 3.4602006007365503`*^9, 
   3.460201290106146*^9, 3.460201878664384*^9, 3.460254150649612*^9, 
   3.4602704732126837`*^9, 3.460279153501918*^9, 3.460279212991139*^9, 
   3.4602816948847113`*^9, {3.460284336364369*^9, 3.460284358322968*^9}, 
   3.460284752117095*^9, 3.460285736075243*^9, 3.46028598941461*^9, 
   3.460286271965789*^9, 3.4602863067892523`*^9, 3.4603638961194057`*^9, 
   3.460366621961207*^9, 3.460369741827793*^9, 3.4603700297393913`*^9, 
   3.460370341259691*^9, 3.460371529118987*^9, 3.4603715972424173`*^9, 
   3.46037354416546*^9, 3.460377043299438*^9, 3.460377177822056*^9, 
   3.460377257847652*^9, 3.46037766509881*^9, 3.460427455891576*^9, {
   3.4604329057405024`*^9, 3.460432914614367*^9}, 3.4604330817497673`*^9, 
   3.460433119701372*^9, 3.46043457776158*^9, 3.460434977961318*^9, 
   3.460437046144434*^9, 3.460437552873603*^9, 3.460437900974538*^9, 
   3.460439351382359*^9, 3.46044036674789*^9, 3.46044457492516*^9, 
   3.460444772196126*^9, 3.4604449403037977`*^9, 3.4604449975762653`*^9, 
   3.4604591002378387`*^9, 3.460460040416348*^9, 3.460460125733479*^9, 
   3.4604608064131107`*^9, 3.460721885700042*^9, 3.4607226257606907`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "1", "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.45982787174109*^9, {3.460112887861902*^9, 3.460112900786964*^9}, 
   3.460112954913162*^9, {3.460113000282473*^9, 3.460113007967648*^9}, 
   3.460113265712655*^9, 3.460113964238937*^9, 3.460114146876112*^9, 
   3.4601142349213667`*^9, 3.460114304518387*^9, 3.460120929697301*^9, {
   3.460126878115456*^9, 3.460126894622835*^9}, 3.4601274604024973`*^9, 
   3.460197817926371*^9, 3.460198252562779*^9, 3.460198349161854*^9, 
   3.460198506587408*^9, 3.460199526323365*^9, 3.460199563520813*^9, 
   3.460199653793846*^9, 3.4602004848983727`*^9, 3.4602006007365503`*^9, 
   3.460201290106146*^9, 3.460201878664384*^9, 3.460254150649612*^9, 
   3.4602704732126837`*^9, 3.460279153501918*^9, 3.460279212991139*^9, 
   3.4602816948847113`*^9, {3.460284336364369*^9, 3.460284358322968*^9}, 
   3.460284752117095*^9, 3.460285736075243*^9, 3.46028598941461*^9, 
   3.460286271965789*^9, 3.4602863067892523`*^9, 3.4603638961194057`*^9, 
   3.460366621961207*^9, 3.460369741827793*^9, 3.4603700297393913`*^9, 
   3.460370341259691*^9, 3.460371529118987*^9, 3.4603715972424173`*^9, 
   3.46037354416546*^9, 3.460377043299438*^9, 3.460377177822056*^9, 
   3.460377257847652*^9, 3.46037766509881*^9, 3.460427455891576*^9, {
   3.4604329057405024`*^9, 3.460432914614367*^9}, 3.4604330817497673`*^9, 
   3.460433119701372*^9, 3.46043457776158*^9, 3.460434977961318*^9, 
   3.460437046144434*^9, 3.460437552873603*^9, 3.460437900974538*^9, 
   3.460439351382359*^9, 3.46044036674789*^9, 3.46044457492516*^9, 
   3.460444772196126*^9, 3.4604449403037977`*^9, 3.4604449975762653`*^9, 
   3.4604591002378387`*^9, 3.460460040416348*^9, 3.460460125733479*^9, 
   3.4604608064131107`*^9, 3.460721885700042*^9, 3.46072262577107*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["n"], "Input",
 CellChangeTimes->{3.460199566938484*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{{3.4601995670369167`*^9, 3.460199582472732*^9}, 
   3.460199654184558*^9, 3.4602006010382977`*^9, 3.460201878968666*^9, 
   3.460270473397647*^9, 3.460279153636557*^9, 3.460279213141574*^9, 
   3.460284358508081*^9, 3.4602847523334084`*^9, 3.460285736259516*^9, 
   3.460285989579775*^9, 3.460286272109499*^9, 3.460286306972591*^9, 
   3.460363896269546*^9, 3.460366622129072*^9, 3.4603697420542707`*^9, 
   3.460370029977702*^9, 3.46037034147106*^9, 3.46037152934341*^9, 
   3.4603715974458637`*^9, 3.46037354437654*^9, 3.460377043500943*^9, 
   3.46037717804631*^9, 3.460377258106838*^9, 3.460377665294299*^9, 
   3.460427456109329*^9, 3.4604329148012323`*^9, 3.460433081953985*^9, 
   3.460433119910708*^9, 3.460434577965878*^9, 3.460434978185719*^9, 
   3.4604370463382597`*^9, 3.460437553079526*^9, 3.4604403669551992`*^9, 
   3.4604445751168613`*^9, 3.460444772429595*^9, 3.460444940510421*^9, 
   3.460444997808488*^9, 3.460459100440379*^9, 3.460460040620708*^9, 
   3.460460125951755*^9, 3.460460806611047*^9, 3.460722626001609*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SeedRandom", "[", "12345689999999", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Y", ",", "X", ",", "ETA"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"ZETA", ",", "EPSILON"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"h", ",", "dh", ",", "sigmaepsilon"}], "}"}]}], "}"}]}], 
    "}"}], "=", "\[IndentingNewLine]", 
   RowBox[{"LISRELsimulNonlin", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", ",", "\"\<Gauss[]\>\"", ",", "X"}], "}"}], ",", "Theta", 
     ",", 
     RowBox[{"{", 
      RowBox[{"IdioNonlin", ",", 
       RowBox[{"{", "}"}]}], "}"}]}], "]"}]}], ";"}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601129177677603`*^9, 3.46011292950504*^9}, {
  3.4601129714155407`*^9, 3.460112981316517*^9}, {3.460198511433001*^9, 
  3.4601985124151077`*^9}, {3.460262802763719*^9, 3.460262821284783*^9}, {
  3.4604447675941477`*^9, 3.460444768681939*^9}, {3.4604449364164333`*^9, 
  3.4604449370413017`*^9}, {3.4604449897999277`*^9, 3.4604449936057873`*^9}, {
  3.460721880513426*^9, 3.460721881301012*^9}},
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[{"beta", "\[IndentingNewLine]", "gamma", "\[IndentingNewLine]", \
"sigmazeta", "\[IndentingNewLine]", "h"}], "Input",
 CellChangeTimes->{{3.4601269097587757`*^9, 3.460126910241324*^9}, {
  3.46026300740036*^9, 3.4602630224003677`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.460126911291768*^9, {3.460127448010219*^9, 3.460127463752602*^9}, 
   3.46019781849335*^9, 3.460198255524288*^9, 3.460198352058052*^9, 
   3.4601985156112556`*^9, 3.4601995266377697`*^9, 3.460199577399457*^9, 
   3.46019965430007*^9, 3.460200566230009*^9, 3.460200601139563*^9, 
   3.460201879055964*^9, 3.460254153231098*^9, {3.46026300470542*^9, 
   3.4602630225053473`*^9}, 3.460270473521778*^9, 3.4602791537878532`*^9, 
   3.460279213318447*^9, 3.460281700761509*^9, {3.460284339881637*^9, 
   3.460284358605403*^9}, 3.460284752501553*^9, 3.460285736426825*^9, 
   3.460285989707677*^9, 3.460286272224893*^9, 3.460286307114214*^9, 
   3.4603638964211063`*^9, 3.460366622238628*^9, 3.4603697421688843`*^9, 
   3.460370030103874*^9, 3.460370341630898*^9, 3.460371529458281*^9, 
   3.460371597568221*^9, 3.460373544538747*^9, 3.460377043635038*^9, 
   3.460377178198557*^9, 3.460377258262187*^9, 3.460377665441781*^9, 
   3.460427456233851*^9, 3.4604319457565603`*^9, {3.460432909977116*^9, 
   3.460432914941457*^9}, 3.4604330820901012`*^9, 3.460433120037969*^9, 
   3.4604345780819597`*^9, 3.460434978336451*^9, 3.460437046470871*^9, 
   3.460437553217643*^9, 3.460440367108382*^9, 3.460444575278883*^9, 
   3.4604447725558567`*^9, 3.460444940639205*^9, 3.460444997936206*^9, 
   3.4604591005903893`*^9, 3.460460040743739*^9, 3.460460126074955*^9, 
   3.4604608067430067`*^9, 3.460721890152472*^9, 3.460722626145686*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "0", "}"}], ",", 
   RowBox[{"{", "0", "}"}], ",", 
   RowBox[{"{", "0", "}"}], ",", 
   RowBox[{"{", "0", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.460126911291768*^9, {3.460127448010219*^9, 3.460127463752602*^9}, 
   3.46019781849335*^9, 3.460198255524288*^9, 3.460198352058052*^9, 
   3.4601985156112556`*^9, 3.4601995266377697`*^9, 3.460199577399457*^9, 
   3.46019965430007*^9, 3.460200566230009*^9, 3.460200601139563*^9, 
   3.460201879055964*^9, 3.460254153231098*^9, {3.46026300470542*^9, 
   3.4602630225053473`*^9}, 3.460270473521778*^9, 3.4602791537878532`*^9, 
   3.460279213318447*^9, 3.460281700761509*^9, {3.460284339881637*^9, 
   3.460284358605403*^9}, 3.460284752501553*^9, 3.460285736426825*^9, 
   3.460285989707677*^9, 3.460286272224893*^9, 3.460286307114214*^9, 
   3.4603638964211063`*^9, 3.460366622238628*^9, 3.4603697421688843`*^9, 
   3.460370030103874*^9, 3.460370341630898*^9, 3.460371529458281*^9, 
   3.460371597568221*^9, 3.460373544538747*^9, 3.460377043635038*^9, 
   3.460377178198557*^9, 3.460377258262187*^9, 3.460377665441781*^9, 
   3.460427456233851*^9, 3.4604319457565603`*^9, {3.460432909977116*^9, 
   3.460432914941457*^9}, 3.4604330820901012`*^9, 3.460433120037969*^9, 
   3.4604345780819597`*^9, 3.460434978336451*^9, 3.460437046470871*^9, 
   3.460437553217643*^9, 3.460440367108382*^9, 3.460444575278883*^9, 
   3.4604447725558567`*^9, 3.460444940639205*^9, 3.460444997936206*^9, 
   3.4604591005903893`*^9, 3.460460040743739*^9, 3.460460126074955*^9, 
   3.4604608067430067`*^9, 3.460721890152472*^9, 3.460722626179943*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1.`", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1.`", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1.`", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1.`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.460126911291768*^9, {3.460127448010219*^9, 3.460127463752602*^9}, 
   3.46019781849335*^9, 3.460198255524288*^9, 3.460198352058052*^9, 
   3.4601985156112556`*^9, 3.4601995266377697`*^9, 3.460199577399457*^9, 
   3.46019965430007*^9, 3.460200566230009*^9, 3.460200601139563*^9, 
   3.460201879055964*^9, 3.460254153231098*^9, {3.46026300470542*^9, 
   3.4602630225053473`*^9}, 3.460270473521778*^9, 3.4602791537878532`*^9, 
   3.460279213318447*^9, 3.460281700761509*^9, {3.460284339881637*^9, 
   3.460284358605403*^9}, 3.460284752501553*^9, 3.460285736426825*^9, 
   3.460285989707677*^9, 3.460286272224893*^9, 3.460286307114214*^9, 
   3.4603638964211063`*^9, 3.460366622238628*^9, 3.4603697421688843`*^9, 
   3.460370030103874*^9, 3.460370341630898*^9, 3.460371529458281*^9, 
   3.460371597568221*^9, 3.460373544538747*^9, 3.460377043635038*^9, 
   3.460377178198557*^9, 3.460377258262187*^9, 3.460377665441781*^9, 
   3.460427456233851*^9, 3.4604319457565603`*^9, {3.460432909977116*^9, 
   3.460432914941457*^9}, 3.4604330820901012`*^9, 3.460433120037969*^9, 
   3.4604345780819597`*^9, 3.460434978336451*^9, 3.460437046470871*^9, 
   3.460437553217643*^9, 3.460440367108382*^9, 3.460444575278883*^9, 
   3.4604447725558567`*^9, 3.460444940639205*^9, 3.460444997936206*^9, 
   3.4604591005903893`*^9, 3.460460040743739*^9, 3.460460126074955*^9, 
   3.4604608067430067`*^9, 3.460721890152472*^9, 3.460722626228324*^9}],

Cell[BoxData["h$165046"], "Output",
 CellChangeTimes->{
  3.460126911291768*^9, {3.460127448010219*^9, 3.460127463752602*^9}, 
   3.46019781849335*^9, 3.460198255524288*^9, 3.460198352058052*^9, 
   3.4601985156112556`*^9, 3.4601995266377697`*^9, 3.460199577399457*^9, 
   3.46019965430007*^9, 3.460200566230009*^9, 3.460200601139563*^9, 
   3.460201879055964*^9, 3.460254153231098*^9, {3.46026300470542*^9, 
   3.4602630225053473`*^9}, 3.460270473521778*^9, 3.4602791537878532`*^9, 
   3.460279213318447*^9, 3.460281700761509*^9, {3.460284339881637*^9, 
   3.460284358605403*^9}, 3.460284752501553*^9, 3.460285736426825*^9, 
   3.460285989707677*^9, 3.460286272224893*^9, 3.460286307114214*^9, 
   3.4603638964211063`*^9, 3.460366622238628*^9, 3.4603697421688843`*^9, 
   3.460370030103874*^9, 3.460370341630898*^9, 3.460371529458281*^9, 
   3.460371597568221*^9, 3.460373544538747*^9, 3.460377043635038*^9, 
   3.460377178198557*^9, 3.460377258262187*^9, 3.460377665441781*^9, 
   3.460427456233851*^9, 3.4604319457565603`*^9, {3.460432909977116*^9, 
   3.460432914941457*^9}, 3.4604330820901012`*^9, 3.460433120037969*^9, 
   3.4604345780819597`*^9, 3.460434978336451*^9, 3.460437046470871*^9, 
   3.460437553217643*^9, 3.460440367108382*^9, 3.460444575278883*^9, 
   3.4604447725558567`*^9, 3.460444940639205*^9, 3.460444997936206*^9, 
   3.4604591005903893`*^9, 3.460460040743739*^9, 3.460460126074955*^9, 
   3.4604608067430067`*^9, 3.460721890152472*^9, 3.4607226262712812`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"Y", "\[IndentingNewLine]", "ETA", "\[IndentingNewLine]", 
 RowBox[{"ETA", "^", "2"}]}], "Input",
 CellChangeTimes->{{3.460263029570212*^9, 3.460263076361992*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"-", "0.194114104762065`"}], ",", 
    RowBox[{"-", "0.4302590760407047`"}], ",", 
    RowBox[{"-", "0.16128956235529737`"}], ",", "2.9559841090067054`"}], 
   "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.460263033034795*^9, 3.4602630471827707`*^9}, 
   3.4602630772167892`*^9, 3.460270473585662*^9, 3.4602791540048*^9, 
   3.460279213559284*^9, 3.460281704010305*^9, {3.4602843427261763`*^9, 
   3.460284358667742*^9}, 3.460284752756671*^9, 3.460285736694447*^9, 
   3.460285989950755*^9, 3.460286272384079*^9, 3.460286307342223*^9, 
   3.460363896672715*^9, 3.460366622305064*^9, 3.4603697424206533`*^9, 
   3.4603700301714983`*^9, 3.4603703417015457`*^9, 3.460371529532394*^9, 
   3.460371597632999*^9, 3.4603735446237793`*^9, 3.460377043887631*^9, 
   3.460377178440894*^9, 3.460377258343234*^9, 3.460377665634234*^9, 
   3.460427456327112*^9, 3.460432915039525*^9, 3.460433082177577*^9, 
   3.460433120294201*^9, 3.460434578318264*^9, 3.460434978586213*^9, 
   3.460437046533617*^9, 3.4604375532813597`*^9, 3.460440367300915*^9, 
   3.4604445755277157`*^9, 3.4604447726233263`*^9, 3.460444940885169*^9, 
   3.460444998006908*^9, 3.460459100825345*^9, 3.4604600408257113`*^9, 
   3.460460126235815*^9, 3.460460806817445*^9, 3.460721893835973*^9, 
   3.460722626378738*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"-", "0.5209211781380665`"}], ",", 
    RowBox[{"-", "0.4086196671944009`"}], ",", "0.16513424393346554`", ",", 
    RowBox[{"-", "1.6942595767198476`"}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.460263033034795*^9, 3.4602630471827707`*^9}, 
   3.4602630772167892`*^9, 3.460270473585662*^9, 3.4602791540048*^9, 
   3.460279213559284*^9, 3.460281704010305*^9, {3.4602843427261763`*^9, 
   3.460284358667742*^9}, 3.460284752756671*^9, 3.460285736694447*^9, 
   3.460285989950755*^9, 3.460286272384079*^9, 3.460286307342223*^9, 
   3.460363896672715*^9, 3.460366622305064*^9, 3.4603697424206533`*^9, 
   3.4603700301714983`*^9, 3.4603703417015457`*^9, 3.460371529532394*^9, 
   3.460371597632999*^9, 3.4603735446237793`*^9, 3.460377043887631*^9, 
   3.460377178440894*^9, 3.460377258343234*^9, 3.460377665634234*^9, 
   3.460427456327112*^9, 3.460432915039525*^9, 3.460433082177577*^9, 
   3.460433120294201*^9, 3.460434578318264*^9, 3.460434978586213*^9, 
   3.460437046533617*^9, 3.4604375532813597`*^9, 3.460440367300915*^9, 
   3.4604445755277157`*^9, 3.4604447726233263`*^9, 3.460444940885169*^9, 
   3.460444998006908*^9, 3.460459100825345*^9, 3.4604600408257113`*^9, 
   3.460460126235815*^9, 3.460460806817445*^9, 3.460721893835973*^9, 
   3.4607226264237957`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
   "0.2713588738327512`", ",", "0.16697003241806296`", ",", 
    "0.027269318519477302`", ",", "2.870515513306917`"}], "}"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.460263033034795*^9, 3.4602630471827707`*^9}, 
   3.4602630772167892`*^9, 3.460270473585662*^9, 3.4602791540048*^9, 
   3.460279213559284*^9, 3.460281704010305*^9, {3.4602843427261763`*^9, 
   3.460284358667742*^9}, 3.460284752756671*^9, 3.460285736694447*^9, 
   3.460285989950755*^9, 3.460286272384079*^9, 3.460286307342223*^9, 
   3.460363896672715*^9, 3.460366622305064*^9, 3.4603697424206533`*^9, 
   3.4603700301714983`*^9, 3.4603703417015457`*^9, 3.460371529532394*^9, 
   3.460371597632999*^9, 3.4603735446237793`*^9, 3.460377043887631*^9, 
   3.460377178440894*^9, 3.460377258343234*^9, 3.460377665634234*^9, 
   3.460427456327112*^9, 3.460432915039525*^9, 3.460433082177577*^9, 
   3.460433120294201*^9, 3.460434578318264*^9, 3.460434978586213*^9, 
   3.460437046533617*^9, 3.4604375532813597`*^9, 3.460440367300915*^9, 
   3.4604445755277157`*^9, 3.4604447726233263`*^9, 3.460444940885169*^9, 
   3.460444998006908*^9, 3.460459100825345*^9, 3.4604600408257113`*^9, 
   3.460460126235815*^9, 3.460460806817445*^9, 3.460721893835973*^9, 
   3.460722626477685*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BlaBlaDiagrammMatrix", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"A", ",", "\"\<B\>\"", ",", "C", ",", "D"}], "}"}], ",", ".2", 
   ",", "beta", ",", "12"}], "]"}]], "Input",
 CellChangeTimes->{{3.460126926202602*^9, 3.460126926264735*^9}, {
  3.460197837062155*^9, 3.4601978744501877`*^9}, {3.460198176014512*^9, 
  3.4601981763542347`*^9}, {3.460198286470953*^9, 3.460198287074853*^9}, {
  3.460201742748698*^9, 3.46020174505478*^9}, {3.460201843262917*^9, 
  3.460201847980236*^9}, {3.4602030757501917`*^9, 3.460203091242997*^9}, {
  3.460203406030672*^9, 3.460203406841346*^9}, {3.4602037079581614`*^9, 
  3.4602037570505037`*^9}, {3.4604314383103333`*^9, 3.460431463763299*^9}, {
  3.46072191343194*^9, 3.4607219215661173`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.42828427124746193`"}], ",", "0.5717157287525382`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.15999999999999992`", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.42828427124746193`"}], ",", 
     RowBox[{"-", "0.5717157287525382`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.5717157287525382`", ",", "0.42828427124746193`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "0.15999999999999992`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.42828427124746193`", ",", 
     RowBox[{"-", "0.5717157287525382`"}]}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{
  3.460254917284408*^9, {3.460254963273391*^9, 3.460254988668433*^9}, 
   3.460263131679799*^9, 3.460270473642482*^9, 3.460279154192683*^9, 
   3.4602792137589703`*^9, 3.460281708328726*^9, {3.460284349028021*^9, 
   3.460284358718511*^9}, 3.460284752983387*^9, 3.4602857368937397`*^9, 
   3.46028599013325*^9, 3.460286272567993*^9, 3.4602863075258303`*^9, 
   3.460363896890669*^9, 3.460366622482728*^9, 3.460369742599053*^9, 
   3.460370030260274*^9, 3.460370341797141*^9, 3.4603715297047777`*^9, 
   3.4603715977842484`*^9, 3.46037354469268*^9, 3.4603770440876493`*^9, 
   3.460377178647592*^9, 3.460377258535486*^9, 3.4603776658339567`*^9, 
   3.460427456527379*^9, {3.460431435575878*^9, 3.460431483660812*^9}, 
   3.460431948603277*^9, 3.460432915103636*^9, 3.4604330823686733`*^9, 
   3.4604331204735403`*^9, 3.460434578514885*^9, 3.4604349787655993`*^9, 
   3.460437046696105*^9, 3.460437553346588*^9, 3.460440367502871*^9, 
   3.460444575746114*^9, 3.460444772689519*^9, 3.460444941088806*^9, 
   3.4604449981449137`*^9, 3.460459101042754*^9, 3.4604600408936377`*^9, 
   3.460460126416513*^9, 3.4604608070131903`*^9, {3.460721895877881*^9, 
   3.46072192223368*^9}, 3.4607226265645323`*^9}],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0], Thickness[0.003], CircleBox[{-1, 0}, 0.2], 
    CircleBox[{0, 1}, 0.2], CircleBox[{1, 0}, 0.2], 
    CircleBox[{0, -1}, 0.2]}, 
   {GrayLevel[0], Thickness[0.003], InsetBox["A", {-0.98, 0.02}], 
    InsetBox["\<\"B\"\>", {0.02, 1.02}], InsetBox["C", {1.02, 0.02}], 
    InsetBox["D", {0.02, -0.98}]}, 
   {RGBColor[1, 0, 0], Thickness[0.003]}, 
   {RGBColor[0, 0, 1], Thickness[0.003]}, 
   {RGBColor[1, 0, 0], Thickness[0.003]}, 
   {RGBColor[0, 0, 1], Thickness[0.003]}},
  AspectRatio->Automatic,
  BaseStyle->{FontFamily -> "Helvetica", FontSize -> 12},
  Frame->True,
  FrameTicks->False,
  ImageSize->{416., Automatic}]], "Output",
 CellChangeTimes->{
  3.4601269281869783`*^9, 3.460127426082061*^9, 3.460127466329838*^9, {
   3.460127585117103*^9, 3.4601276005862913`*^9}, {3.4601978186150627`*^9, 
   3.4601978754337683`*^9}, {3.4601979922064037`*^9, 3.460198015465253*^9}, {
   3.460198108435659*^9, 3.460198177004368*^9}, {3.460198256947486*^9, 
   3.460198287948544*^9}, 3.460198354151993*^9, 3.460198517017171*^9, 
   3.460199526697234*^9, 3.4601995792704763`*^9, 3.460199654370886*^9, 
   3.460200568819632*^9, 3.460200601192975*^9, 3.460201294388686*^9, 
   3.460201422604823*^9, {3.4602014621856337`*^9, 3.4602014755616083`*^9}, {
   3.460201617064205*^9, 3.460201636172051*^9}, 3.460201746377551*^9, {
   3.4602017858617897`*^9, 3.460201848817997*^9}, 3.460201879133306*^9, {
   3.460203077180921*^9, 3.46020309246707*^9}, {3.460203375574904*^9, 
   3.460203407031555*^9}, {3.460203525933297*^9, 3.460203550744958*^9}, {
   3.460203591076667*^9, 3.4602035982917624`*^9}, 3.460203629545972*^9, {
   3.460203698543215*^9, 3.4602037978560038`*^9}, 3.460254157635613*^9, 
   3.460254917290598*^9, {3.460254963282044*^9, 3.4602549886738853`*^9}, 
   3.460263131690372*^9, 3.460270473691039*^9, 3.460279154236169*^9, 
   3.460279213807478*^9, 3.460281708338883*^9, {3.460284349078342*^9, 
   3.46028435872755*^9}, 3.460284753032539*^9, 3.460285736953566*^9, 
   3.4602859901890087`*^9, 3.460286272617923*^9, 3.460286307573679*^9, 
   3.460363896961611*^9, 3.460366622530184*^9, 3.460369742647211*^9, 
   3.460370030312529*^9, 3.46037034184521*^9, 3.460371529755887*^9, 
   3.46037159784545*^9, 3.460373544733478*^9, 3.460377044136137*^9, 
   3.4603771786940317`*^9, 3.460377258585181*^9, 3.460377665886016*^9, 
   3.460427456579464*^9, {3.460431435582724*^9, 3.4604314836711187`*^9}, 
   3.4604319486144123`*^9, 3.460432915151466*^9, 3.460433082416451*^9, 
   3.460433120520093*^9, 3.460434578562842*^9, 3.460434978814953*^9, 
   3.4604370467471027`*^9, 3.460437553357094*^9, 3.4604403675548153`*^9, 
   3.460444575794372*^9, 3.4604447727257557`*^9, 3.460444941147047*^9, 
   3.460444998197179*^9, 3.460459101088204*^9, 3.460460040928624*^9, 
   3.4604601264664707`*^9, 3.460460807058498*^9, {3.4607218959351254`*^9, 
   3.460721922246777*^9}, 3.460722626612988*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"B1", "=", 
    RowBox[{
     RowBox[{"I4", "-", "beta"}], "//", "Inverse"}]}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.4602031193688383`*^9, 3.4602031417504272`*^9}, {
  3.460254264329975*^9, 3.460254272840392*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "1", "0", "0", "0"},
      {"2", "0", "1", "0", "0"},
      {"3", "0", "0", "1", "0"},
      {"4", "0", "0", "0", "1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.460203120570764*^9, 3.460203142571908*^9}, 
   3.460254154939602*^9, {3.460254261383683*^9, 3.460254273739875*^9}, 
   3.460254333610758*^9, 3.460263140602977*^9, 3.460270473788156*^9, 
   3.4602791543419523`*^9, 3.460279213895871*^9, 3.460281712464506*^9, {
   3.460284351900099*^9, 3.460284358790635*^9}, 3.460284753137499*^9, 
   3.460285737065781*^9, 3.460285990287882*^9, 3.460286272704586*^9, 
   3.4602863076641827`*^9, 3.4603638970605183`*^9, 3.460366622635786*^9, 
   3.4603697427595453`*^9, 3.460370030414991*^9, 3.460370341928465*^9, 
   3.460371529857189*^9, 3.4603715979464417`*^9, 3.460373544838743*^9, 
   3.460377044224801*^9, 3.460377178799849*^9, 3.460377258685432*^9, 
   3.460377666002129*^9, 3.460427456683173*^9, 3.460432915252284*^9, 
   3.460433082520834*^9, 3.4604331206095257`*^9, 3.460434578667056*^9, 
   3.4604349789017773`*^9, 3.460437046835697*^9, 3.460437553445334*^9, 
   3.460440367670916*^9, 3.460444575903373*^9, 3.460444772817761*^9, 
   3.460444941257197*^9, 3.460444998286359*^9, 3.460459101179171*^9, 
   3.4604600410360126`*^9, 3.460460126573408*^9, 3.460460807148085*^9, 
   3.460721932075602*^9, 3.460722626715157*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BlaBlaDiagrammMatrix", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"A", ",", "\"\<B\>\"", ",", "C", ",", "D"}], "}"}], ",", ".2", 
   ",", "B1", ",", "12"}], "]"}]], "Input",
 CellChangeTimes->{
  3.4602541804489317`*^9, {3.460254277098235*^9, 3.460254280231039*^9}, {
   3.460254509599163*^9, 3.4602545160826283`*^9}, {3.460722636783688*^9, 
   3.4607226395330267`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.42828427124746193`"}], ",", "0.5717157287525382`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.15999999999999992`", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.42828427124746193`"}], ",", 
     RowBox[{"-", "0.5717157287525382`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.5717157287525382`", ",", "0.42828427124746193`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "0.15999999999999992`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.42828427124746193`", ",", 
     RowBox[{"-", "0.5717157287525382`"}]}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{
  3.4602547523447104`*^9, 3.46025483834556*^9, {3.460254893644129*^9, 
   3.4602548990856533`*^9}, {3.460254933959073*^9, 3.4602549831960707`*^9}, 
   3.460263142507736*^9, 3.460270473863221*^9, 3.4602791544236507`*^9, 
   3.460279213976809*^9, 3.460281716545786*^9, {3.46028435379206*^9, 
   3.460284358834917*^9}, 3.460284753220448*^9, 3.460285737243252*^9, 
   3.460285990365881*^9, 3.460286272786531*^9, 3.460286307743743*^9, 
   3.460363897139267*^9, 3.460366622717486*^9, 3.460369742832102*^9, 
   3.4603700304923477`*^9, 3.460370342014337*^9, 3.4603715299365396`*^9, 
   3.4603715980462112`*^9, 3.460373544916341*^9, 3.4603770443214293`*^9, 
   3.460377178876876*^9, 3.4603772587692833`*^9, 3.4603776660883627`*^9, 
   3.4604274567616053`*^9, 3.460432915331958*^9, 3.460433082603465*^9, 
   3.460433120690646*^9, 3.460434578748467*^9, 3.460434978981639*^9, 
   3.460437046917267*^9, 3.460437553526902*^9, 3.460440367749988*^9, 
   3.46044457598048*^9, 3.46044477289889*^9, 3.460444941340508*^9, 
   3.460444998360343*^9, 3.460459101258813*^9, 3.460460041116373*^9, 
   3.460460126651338*^9, 3.4604608072316723`*^9, 3.460721934334828*^9, {
   3.46072262679858*^9, 3.460722640411352*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0], Thickness[0.003], CircleBox[{-1, 0}, 0.2], 
    CircleBox[{0, 1}, 0.2], CircleBox[{1, 0}, 0.2], 
    CircleBox[{0, -1}, 0.2]}, 
   {GrayLevel[0], Thickness[0.003], InsetBox["A", {-0.98, 0.02}], 
    InsetBox["\<\"B\"\>", {0.02, 1.02}], InsetBox["C", {1.02, 0.02}], 
    InsetBox["D", {0.02, -0.98}]}, 
   {RGBColor[1, 0, 0], Thickness[0.003]}, 
   {RGBColor[0, 0, 1], Thickness[0.003]}, 
   {RGBColor[1, 0, 0], Thickness[0.003]}, 
   {RGBColor[0, 0, 1], Thickness[0.003]}},
  AspectRatio->Automatic,
  BaseStyle->{FontFamily -> "Helvetica", FontSize -> 12},
  Frame->True,
  FrameTicks->False]], "Output",
 CellChangeTimes->{
  3.4602541818218737`*^9, 3.460254280335683*^9, 3.460254334747493*^9, {
   3.460254394251598*^9, 3.460254411277727*^9}, {3.460254511486261*^9, 
   3.4602545320527563`*^9}, 3.460254587240301*^9, 3.460254701501644*^9, 
   3.4602547523545923`*^9, 3.46025483835599*^9, {3.4602548936570463`*^9, 
   3.460254899095298*^9}, {3.4602549339701557`*^9, 3.460254983204011*^9}, 
   3.460263142512862*^9, 3.460270473909836*^9, 3.4602791544692698`*^9, 
   3.460279214020843*^9, 3.460281716552771*^9, {3.460284353799768*^9, 
   3.46028435884326*^9}, 3.460284753268414*^9, 3.460285737301465*^9, 
   3.460285990415246*^9, 3.460286272833438*^9, 3.4602863077868137`*^9, 
   3.4603638971865807`*^9, 3.460366622759886*^9, 3.46036974288822*^9, 
   3.4603700305410748`*^9, 3.460370342056143*^9, 3.460371529983536*^9, 
   3.460371598093424*^9, 3.4603735449649*^9, 3.460377044362979*^9, 
   3.460377178928034*^9, 3.46037725881456*^9, 3.460377666125819*^9, 
   3.4604274568251543`*^9, 3.4604329153801527`*^9, 3.460433082647156*^9, 
   3.4604331207334843`*^9, 3.460434578791883*^9, 3.460434979028728*^9, 
   3.460437046960555*^9, 3.4604375535746403`*^9, 3.460440367795998*^9, 
   3.460444576029722*^9, 3.4604447729447517`*^9, 3.460444941382475*^9, 
   3.4604449984059067`*^9, 3.4604591013052187`*^9, 3.4604600411628523`*^9, 
   3.460460126691949*^9, 3.460460807272231*^9, 3.46072193434873*^9, {
   3.4607226268603*^9, 3.460722640424999*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"X", "//", "Dimensions"}]], "Input",
 PageWidth->Infinity,
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->CompressedData["
1:eJwVzDlIggEYgGG7IOiEpEhUPEtKksAgosILCewQsQwMyp+igsilpgYpNCpa
tKLFosNIxw67BkMytcOEcqjQIAJNLDAwdDH6vuHl2V4moVeN5JBIpGZoM11E
rvbFxQ03vA4bKIquXKMpjz6MulzjMXTpgJpEPQwp3w7yDZrTAOjcF2TRsctI
3gO4mNWWoatTz8soYQpaUV//eEEQ1CZqK1BLd/QQpegvNr5BTqmo8QcMG9WT
v6BZ7p1G74lIJo1/paAuA8p6+Htobt+TBy1W0j/RN4fhC2211Qfp/rh4y/3K
ZoBV/g8HE9x1hQJo6NyTQsOPkkUWeKz2mlHOFdPEBikn5hYuODsxrECTXF0v
OiBQLKCVAdpzG5hv0c+JQLVds44SCZoVPdscVIlB8syoEd1Ze5+XgOWxJi9K
pZJqZKCQViiUg7es7U7UVnKkQxl/wTHUKT1UdIEpOc+Nkltf7tB2ToLRDf4N
EZkA+A9biviO
  "]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Y", "//", "MatrixForm"}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{3.460112964110797*^9},
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", 
       RowBox[{"-", "0.194114104762065`"}], 
       RowBox[{"-", "0.4302590760407047`"}], 
       RowBox[{"-", "0.16128956235529737`"}], "2.9559841090067054`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.46011296490981*^9, 3.460112976913889*^9}, 
   3.460113026134074*^9, 3.460113268944764*^9, 3.4601139647291594`*^9, 
   3.4601141477280493`*^9, 3.4601142354518623`*^9, 3.4601143049628487`*^9, {
   3.460120930167809*^9, 3.460120941249729*^9}, 3.460197818846628*^9, 
   3.4601983790134907`*^9, 3.460198432454899*^9, 3.46019852602495*^9, 
   3.4601995268397923`*^9, 3.460199654594264*^9, 3.460200492784277*^9, {
   3.460200572211609*^9, 3.4602006012951183`*^9}, {3.460201874721448*^9, 
   3.460201879242372*^9}, 3.460263152190097*^9, 3.460270474084289*^9, 
   3.460279154730338*^9, 3.460279214279213*^9, 3.460281721379015*^9, 
   3.460284359000039*^9, 3.460284753558367*^9, 3.460285737466422*^9, 
   3.460285990689506*^9, 3.460286273133246*^9, 3.460286308065976*^9, 
   3.460363897445043*^9, 3.4603644637898617`*^9, 3.460366622919591*^9, 
   3.460369743201943*^9, 3.460370030732067*^9, 3.460370342231176*^9, 
   3.4603715301748133`*^9, 3.460371598282206*^9, 3.460373545137269*^9, 
   3.4603770446472397`*^9, 3.460377179227991*^9, 3.46037725912186*^9, 
   3.460377666437546*^9, 3.460427457128745*^9, 3.460432915568968*^9, 
   3.460433082941379*^9, 3.460433121038333*^9, 3.460434579085343*^9, 
   3.4604349793176937`*^9, 3.460437047148468*^9, 3.4604375537644577`*^9, 
   3.460440368088052*^9, 3.4604445763342*^9, 3.4604447731169786`*^9, 
   3.460444941676173*^9, 3.460444998582546*^9, 3.460459101663012*^9, 
   3.460460041338008*^9, 3.460460126993647*^9, 3.460460807431941*^9, 
   3.460722627166862*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ETA", "//", "Dimensions"}]], "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "4"}], "}"}]], "Output",
 CellChangeTimes->CompressedData["
1:eJwVz00owwEYgPFN1g4iRas5rM3HiM3HjOR7Mi0bzUJmpaGxJJ/TXJTWaGOH
7TJTCy1kDkRqyoGVIeu/5WCWkM3BtqaoyQ6U9z08/c4Pa2hSpiKTSKRqyHSY
kU2/jgqsHyvSbbApsO5Bp44MT2i4d/odLXUwP9ETnYizBxpqBlwE6HZa/tAD
MznTB4qMzybUMxywo4tGguIH7+dLslAbLXaMWhXCii/wNyGf+AY3N7xz6FVl
OPkDNi7xi5NgDp23g3afBS9RL7cwgtaf6+PoxWO5n3ETFfCor3lMsK8s6mSB
/q0XAqWm3SZQjkhizAWDM34Lyteyl/JAQ5GttgCMLY+J0Yh1pAedZUgN6Ood
O9gA6hc0umawy6FcQ2dT8u3ovlwlE4BM37geVfpiyy2gglZ3hcY1FHYreFOV
zm8D1fxdCZoqPB1E+81BNfoWcok7QM8M143GHkJelGhPMDvxTzuaJMB/8/rx
9A==
  "]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"ETA", "\[IndentingNewLine]", "Y"}], "Input",
 CellChangeTimes->{{3.460114000133006*^9, 3.460114009445375*^9}, {
  3.460437707958293*^9, 3.460437712698263*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"-", "0.5209211781380665`"}], ",", 
    RowBox[{"-", "0.4086196671944009`"}], ",", "0.16513424393346554`", ",", 
    RowBox[{"-", "1.6942595767198476`"}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.459827872527598*^9, 3.46011303067655*^9, 3.46011396489058*^9, {
   3.4601139984758797`*^9, 3.460114009526347*^9}, 3.46011414834797*^9, 
   3.460114235624238*^9, 3.4601143050940447`*^9, 3.460120930349319*^9, 
   3.460197819413198*^9, 3.460198381508251*^9, 3.46019852964046*^9, 
   3.460199526993176*^9, 3.460199654815744*^9, 3.460200496332955*^9, 
   3.460200601423087*^9, 3.460201879378018*^9, 3.460270474250579*^9, 
   3.460279154911991*^9, 3.4602792144465427`*^9, 3.460284359140807*^9, 
   3.460284753724605*^9, 3.460285737649325*^9, 3.4602859908555183`*^9, 
   3.460286273308621*^9, 3.460286308214764*^9, 3.460363897608238*^9, 
   3.460366623184637*^9, 3.460369743366684*^9, 3.460370031031135*^9, 
   3.4603703425137777`*^9, 3.460371530458078*^9, 3.4603715985520267`*^9, 
   3.4603735454327793`*^9, 3.460377044823373*^9, 3.460377179413405*^9, 
   3.4603772592727413`*^9, 3.460377666570675*^9, 3.460427457300247*^9, 
   3.460432915847116*^9, 3.460433083104856*^9, 3.460433121209031*^9, 
   3.460434579250781*^9, 3.460434979484872*^9, 3.46043704741685*^9, 
   3.4604375539298477`*^9, {3.460437706464828*^9, 3.4604377134974957`*^9}, 
   3.460439052589326*^9, 3.460439859095868*^9, {3.4604403682553453`*^9, 
   3.460440379020708*^9}, 3.460444576485385*^9, 3.4604447734082127`*^9, {
   3.460444941829196*^9, 3.4604449544662857`*^9}, 3.460444998837132*^9, 
   3.460459101818636*^9, 3.460460041624042*^9, 3.460460127127924*^9, 
   3.460460807717482*^9, 3.4607226273019238`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"-", "0.194114104762065`"}], ",", 
    RowBox[{"-", "0.4302590760407047`"}], ",", 
    RowBox[{"-", "0.16128956235529737`"}], ",", "2.9559841090067054`"}], 
   "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.459827872527598*^9, 3.46011303067655*^9, 3.46011396489058*^9, {
   3.4601139984758797`*^9, 3.460114009526347*^9}, 3.46011414834797*^9, 
   3.460114235624238*^9, 3.4601143050940447`*^9, 3.460120930349319*^9, 
   3.460197819413198*^9, 3.460198381508251*^9, 3.46019852964046*^9, 
   3.460199526993176*^9, 3.460199654815744*^9, 3.460200496332955*^9, 
   3.460200601423087*^9, 3.460201879378018*^9, 3.460270474250579*^9, 
   3.460279154911991*^9, 3.4602792144465427`*^9, 3.460284359140807*^9, 
   3.460284753724605*^9, 3.460285737649325*^9, 3.4602859908555183`*^9, 
   3.460286273308621*^9, 3.460286308214764*^9, 3.460363897608238*^9, 
   3.460366623184637*^9, 3.460369743366684*^9, 3.460370031031135*^9, 
   3.4603703425137777`*^9, 3.460371530458078*^9, 3.4603715985520267`*^9, 
   3.4603735454327793`*^9, 3.460377044823373*^9, 3.460377179413405*^9, 
   3.4603772592727413`*^9, 3.460377666570675*^9, 3.460427457300247*^9, 
   3.460432915847116*^9, 3.460433083104856*^9, 3.460433121209031*^9, 
   3.460434579250781*^9, 3.460434979484872*^9, 3.46043704741685*^9, 
   3.4604375539298477`*^9, {3.460437706464828*^9, 3.4604377134974957`*^9}, 
   3.460439052589326*^9, 3.460439859095868*^9, {3.4604403682553453`*^9, 
   3.460440379020708*^9}, 3.460444576485385*^9, 3.4604447734082127`*^9, {
   3.460444941829196*^9, 3.4604449544662857`*^9}, 3.460444998837132*^9, 
   3.460459101818636*^9, 3.460460041624042*^9, 3.460460127127924*^9, 
   3.460460807717482*^9, 3.4607226273396997`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"plot1", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ETA", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"n", "//", "Range"}], ",", "All"}], " ", "]"}], "]"}], "//", 
     "Transpose"}], "//", "AddTimeAxis"}], ",", 
   RowBox[{"farbmodell", "\[Rule]", "Hue"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "3"}], ",", "3"}], "}"}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plot1", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Y", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"n", "//", "Range"}], ",", "All"}], " ", "]"}], "]"}], "//", 
      "Transpose"}], "//", "AddTimeAxis"}], ",", 
    RowBox[{"farbmodell", "\[Rule]", "Hue"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3"}], ",", "3"}], "}"}]}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113047733139*^9, 3.4601131167734203`*^9}, {
  3.46011396933543*^9, 3.460113989452705*^9}, {3.460114029168693*^9, 
  3.460114031766469*^9}, {3.460114161512141*^9, 3.460114164229396*^9}, {
  3.460120949297063*^9, 3.460120987997653*^9}, {3.460370039524664*^9, 
  3.460370040016472*^9}, {3.460371539333914*^9, 3.460371544125806*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
    {Opacity[1], 
     LineBox[{{0., -0.5209211781380665}, {1., -0.4086196671944009}, {2., 
      0.16513424393346554`}, {3., -1.6942595767198476`}}]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->True,
  PlotRange->{{0., 3.}, {-3, 3}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellChangeTimes->{
  3.459827873013823*^9, {3.460113055090554*^9, 3.460113095483087*^9}, 
   3.460113273581389*^9, {3.460113964976376*^9, 3.4601139901177692`*^9}, 
   3.460114033131361*^9, {3.460114150107635*^9, 3.460114164412263*^9}, 
   3.460114235720495*^9, 3.460114305171029*^9, {3.460120930436802*^9, 
   3.460120988296579*^9}, 3.460197819516024*^9, 3.460198382848845*^9, 
   3.4601985329563026`*^9, 3.4601995270581903`*^9, 3.460199655234778*^9, 
   3.460200501606188*^9, 3.460200601492147*^9, 3.460201879429142*^9, 
   3.460263155619897*^9, 3.460270474422586*^9, 3.460279155040721*^9, 
   3.460279214531389*^9, 3.460281725875258*^9, 3.460284359234613*^9, 
   3.4602847538095922`*^9, 3.460285737715163*^9, 3.460285990939274*^9, 
   3.4602862733933067`*^9, 3.460286308282538*^9, 3.460363898395814*^9, 
   3.460364466117779*^9, 3.4603666232531223`*^9, 3.460369743455418*^9, {
   3.460370031100134*^9, 3.460370040128583*^9}, 3.4603703425836487`*^9, {
   3.460371530559222*^9, 3.460371545091758*^9}, 3.4603715986232557`*^9, 
   3.460373545549732*^9, 3.460377044924808*^9, 3.460377179522697*^9, 
   3.460377259356626*^9, 3.460377666635418*^9, {3.4604274573851433`*^9, 
   3.4604274826315393`*^9}, 3.460431486420775*^9, 3.460431951982443*^9, 
   3.460432442105898*^9, 3.460432915923843*^9, 3.460433083188562*^9, 
   3.460433121276486*^9, 3.460434371750841*^9, 3.460434579330331*^9, 
   3.460434979549678*^9, 3.4604351320544157`*^9, 3.460437047500869*^9, 
   3.460437554166368*^9, 3.4604377000545588`*^9, 3.4604389249118958`*^9, 
   3.460439049759118*^9, 3.460439356387733*^9, 3.460439855697237*^9, 
   3.46044036838757*^9, 3.460444576617157*^9, 3.460444773535759*^9, 
   3.460444941960794*^9, 3.460444998952558*^9, 3.4604591019466887`*^9, 
   3.460459450661531*^9, 3.460460041769643*^9, 3.460460127257649*^9, 
   3.460460807831476*^9, 3.4607219385833406`*^9, 3.4607226274349327`*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
    {Opacity[1], 
     LineBox[{{0., -0.194114104762065}, {1., -0.4302590760407047}, {
      2., -0.16128956235529737`}, {3., 2.9559841090067054`}}]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->True,
  PlotRange->{{0., 3.}, {-3, 3}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellChangeTimes->{
  3.459827873013823*^9, {3.460113055090554*^9, 3.460113095483087*^9}, 
   3.460113273581389*^9, {3.460113964976376*^9, 3.4601139901177692`*^9}, 
   3.460114033131361*^9, {3.460114150107635*^9, 3.460114164412263*^9}, 
   3.460114235720495*^9, 3.460114305171029*^9, {3.460120930436802*^9, 
   3.460120988296579*^9}, 3.460197819516024*^9, 3.460198382848845*^9, 
   3.4601985329563026`*^9, 3.4601995270581903`*^9, 3.460199655234778*^9, 
   3.460200501606188*^9, 3.460200601492147*^9, 3.460201879429142*^9, 
   3.460263155619897*^9, 3.460270474422586*^9, 3.460279155040721*^9, 
   3.460279214531389*^9, 3.460281725875258*^9, 3.460284359234613*^9, 
   3.4602847538095922`*^9, 3.460285737715163*^9, 3.460285990939274*^9, 
   3.4602862733933067`*^9, 3.460286308282538*^9, 3.460363898395814*^9, 
   3.460364466117779*^9, 3.4603666232531223`*^9, 3.460369743455418*^9, {
   3.460370031100134*^9, 3.460370040128583*^9}, 3.4603703425836487`*^9, {
   3.460371530559222*^9, 3.460371545091758*^9}, 3.4603715986232557`*^9, 
   3.460373545549732*^9, 3.460377044924808*^9, 3.460377179522697*^9, 
   3.460377259356626*^9, 3.460377666635418*^9, {3.4604274573851433`*^9, 
   3.4604274826315393`*^9}, 3.460431486420775*^9, 3.460431951982443*^9, 
   3.460432442105898*^9, 3.460432915923843*^9, 3.460433083188562*^9, 
   3.460433121276486*^9, 3.460434371750841*^9, 3.460434579330331*^9, 
   3.460434979549678*^9, 3.4604351320544157`*^9, 3.460437047500869*^9, 
   3.460437554166368*^9, 3.4604377000545588`*^9, 3.4604389249118958`*^9, 
   3.460439049759118*^9, 3.460439356387733*^9, 3.460439855697237*^9, 
   3.46044036838757*^9, 3.460444576617157*^9, 3.460444773535759*^9, 
   3.460444941960794*^9, 3.460444998952558*^9, 3.4604591019466887`*^9, 
   3.460459450661531*^9, 3.460460041769643*^9, 3.460460127257649*^9, 
   3.460460807831476*^9, 3.4607219385833406`*^9, 3.460722627480467*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["ML-Sch\[ADoubleDot]tzung", "Subsection",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["Lik - Oberfl\[ADoubleDot]che", "Subsubsection",
 CellChangeTimes->{{3.460364529885599*^9, 3.460364541900496*^9}}],

Cell[CellGroupData[{

Cell[BoxData["Theta"], "Input",
 CellChangeTimes->{{3.460437891548414*^9, 3.46043789220885*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{{3.460437892920555*^9, 3.4604379072343273`*^9}, 
   3.460438008429319*^9, 3.460462766091174*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"l0", "[", "1", "]"}]], "Input",
 CellChangeTimes->{{3.4607223323764353`*^9, 3.460722337656382*^9}, {
  3.4607226712747793`*^9, 3.4607226714880753`*^9}}],

Cell[BoxData[
 RowBox[{"-", "121.30146038496203`"}]], "Output",
 CellChangeTimes->{
  3.4607223414435387`*^9, {3.460722384360626*^9, 3.460722402115611*^9}, {
   3.460722437822611*^9, 3.460722456627679*^9}, {3.4607226522721863`*^9, 
   3.46072267251086*^9}, 3.460722716943012*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pp", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m", "=", "20"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l0", "=", 
   RowBox[{
    RowBox[{"IndividualLikNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Y", ",", "X", ",", 
        RowBox[{"-", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"#", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"IdioNonlin", ",", 
        RowBox[{"{", "}"}], ",", "m", ",", 
        RowBox[{"eps", "=", 
         RowBox[{"10.", "^", 
          RowBox[{"-", "16"}]}]}], ",", 
        RowBox[{"ksigma", "=", "4"}], ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular", "=", "False"}], ",", 
        RowBox[{"2", "Pi"}], " ", ",", "0", ",", "0", ",", "\"\<EKF\>\""}], 
       "}"}]}], "]"}], "&"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l1", "=", 
   RowBox[{
    RowBox[{"IndividualLikNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Y", ",", "X", ",", 
        RowBox[{"-", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"#1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"IdioNonlin", ",", 
        RowBox[{"{", "}"}], ",", "m", ",", 
        RowBox[{"eps", "=", 
         RowBox[{"10.", "^", 
          RowBox[{"-", "16"}]}]}], ",", 
        RowBox[{"ksigma", "=", "4"}], ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular", "=", "False"}], ",", 
        RowBox[{"2", "Pi"}], " ", ",", "0", ",", "1"}], "}"}]}], "]"}], 
    "&"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"llin", "=", "         ", 
   RowBox[{
    RowBox[{"IndividualLik", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Y", ",", "X", ",", 
        RowBox[{"-", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"#1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"Idio", ",", 
        RowBox[{"{", "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular", "=", "False"}], ",", 
        RowBox[{"2", "Pi"}], " ", ",", "0"}], "}"}]}], "]"}], "&"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.460364582260192*^9, 3.4603646126520233`*^9}, {
   3.46036465518178*^9, 3.460364686245573*^9}, {3.460366575620988*^9, 
   3.460366577034412*^9}, {3.460369778180625*^9, 3.460369781185903*^9}, {
   3.460369813100584*^9, 3.460369815667145*^9}, {3.460369899141048*^9, 
   3.460369901845244*^9}, {3.460370048351585*^9, 3.460370051074534*^9}, {
   3.460370210982068*^9, 3.460370313679085*^9}, {3.4603703667001543`*^9, 
   3.46037042873845*^9}, {3.460371656197792*^9, 3.460371665219153*^9}, {
   3.4603770592671013`*^9, 3.460377059329007*^9}, {3.460378198442006*^9, 
   3.460378213066311*^9}, {3.460435573037374*^9, 3.460435595252637*^9}, {
   3.460437792675404*^9, 3.46043782170634*^9}, {3.460437942682435*^9, 
   3.4604379557884283`*^9}, {3.460438031359991*^9, 3.460438033910181*^9}, {
   3.460438120088056*^9, 3.460438151233536*^9}, {3.460438297231896*^9, 
   3.460438301076235*^9}, {3.460438342395988*^9, 3.460438352382413*^9}, {
   3.460438790848688*^9, 3.460438792927885*^9}, {3.460439368962564*^9, 
   3.4604393693819513`*^9}, {3.460439888830337*^9, 3.460439923834778*^9}, {
   3.460459119343028*^9, 3.460459128428997*^9}, {3.460460010239758*^9, 
   3.460460021008594*^9}, {3.460462070763579*^9, 3.46046210747972*^9}, {
   3.46046218928576*^9, 3.460462192656451*^9}, 3.460462308980558*^9, {
   3.460462691161005*^9, 3.460462693314562*^9}, {3.4604627579016047`*^9, 
   3.4604628925310507`*^9}, {3.460722305186233*^9, 3.460722309185562*^9}, {
   3.460722368526821*^9, 3.4607223969205847`*^9}, {3.4607224312016563`*^9, 
   3.4607224323927298`*^9}, {3.460722711321816*^9, 3.460722711373019*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"l0", "[", "x", "]"}], ",", 
      RowBox[{"l1", "[", "x", "]"}], ",", 
      RowBox[{"llin", "[", "x", "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", 
      RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
    RowBox[{"PlotPoints", "\[Rule]", "20"}], ",", 
    RowBox[{"MaxRecursion", "\[Rule]", "0"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.460364582260192*^9, 3.4603646126520233`*^9}, {
   3.46036465518178*^9, 3.460364686245573*^9}, {3.460366575620988*^9, 
   3.460366577034412*^9}, {3.460369778180625*^9, 3.460369781185903*^9}, {
   3.460369813100584*^9, 3.460369815667145*^9}, {3.460369899141048*^9, 
   3.460369901845244*^9}, {3.460370048351585*^9, 3.460370051074534*^9}, {
   3.460370210982068*^9, 3.460370313679085*^9}, {3.4603703667001543`*^9, 
   3.46037042873845*^9}, {3.460371656197792*^9, 3.460371665219153*^9}, {
   3.4603770592671013`*^9, 3.460377059329007*^9}, {3.460378198442006*^9, 
   3.460378213066311*^9}, {3.460435573037374*^9, 3.460435595252637*^9}, {
   3.460437792675404*^9, 3.46043782170634*^9}, {3.460437942682435*^9, 
   3.4604379557884283`*^9}, {3.460438031359991*^9, 3.460438033910181*^9}, {
   3.460438120088056*^9, 3.460438151233536*^9}, {3.460438297231896*^9, 
   3.460438301076235*^9}, {3.460438342395988*^9, 3.460438352382413*^9}, {
   3.460438790848688*^9, 3.460438792927885*^9}, {3.460439368962564*^9, 
   3.4604393693819513`*^9}, {3.460439888830337*^9, 3.460439923834778*^9}, {
   3.460459119343028*^9, 3.460459128428997*^9}, {3.460460010239758*^9, 
   3.460460021008594*^9}, {3.460462070763579*^9, 3.46046210747972*^9}, {
   3.46046218928576*^9, 3.460462192656451*^9}, 3.460462308980558*^9, {
   3.460462691161005*^9, 3.460462693314562*^9}, {3.4604627579016047`*^9, 
   3.4604628925310507`*^9}, {3.460722305186233*^9, 3.460722309185562*^9}, 
   3.460722368526821*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwBUQGu/iFib1JlAgAAABQAAAACAAAAao6d1f//B8Daav5jN4FewHJAhDX3
kQXAg0fkLHB8XsCpW6QfnO8CwI0x6Dexdl7AHybYRfF5AMBuLonMvnBewJ+7
rdlAIfy/2T89NWdqXsBf/R08+uX2v0L+1Jk0Y17Anp21FhQE8r+G8gscr1xe
wHUggAsSc+m/POwJD4dWXsAtdYHZxx7evzDnQjr+UV7A1EZA+dp5xb8Tl1EM
Z09ewL7J6xwBj8Q/2MHD2G5OXsAuc+64bObdP26Hr4ceT17A1suHbkSR6D8u
bpb3EFFewKxc2StOgPE/SW4c8FhUXsDvdEeomV72P7Ualz5JWF7A07pCEIql
+z9WDX/RRF1ewCETVDvjaQBAcmkGRppiXsCaGXMyUdQCQIsBWS62Z17A5LZY
nxFzBUCUBxp0LG1ewGqOndX//wdAquJAAUZyXsDeA574
     "]]}, 
   {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwBUQGu/iFib1JlAgAAABQAAAACAAAAao6d1f//B8BP2eme/TsnwHJAhDX3
kQXAQ5kNodvLJsCpW6QfnO8CwEAey9ZlRybAHybYRfF5AMB/qZLPZb8lwJ+7
rdlAIfy/ac2pUiUsJcBf/R08+uX2vyBGMPjteSTAnp21FhQE8r/vMaksX8Aj
wHUggAsSc+m/VZ+TharlIsAtdYHZxx7ev0anxjXyEyLA1EZA+dp5xb80SnRI
GI0hwL7J6xwBj8Q/M2zIHLKKIcAuc+64bObdP2mjPEaEECLA1suHbkSR6D+w
WuNSQtEiwKxc2StOgPE/n3BiQuepI8DvdEeomV72P2AXXI0JZSTA07pCEIql
+z9KtKQbCBslwCETVDvjaQBAA6FYCnG6JcCaGXMyUdQCQPQjHbecQCbA5LZY
nxFzBUDNPd2tC8UmwGqOndX//wdA+o7HhBs7J8CisJ98
     "]]}, 
   {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJwBUQGu/iFib1JlAgAAABQAAAACAAAAao6d1f//B8BPpI9NNMUgwHJAhDX3
kQXAWhgeNb6rIMCpW6QfnO8CwE/zH8u6jyDAHybYRfF5AMDCs62ZbXUgwJ+7
rdlAIfy/2KFlpdRbIMBf/R08+uX2v8ltI3PFQCDAnp21FhQE8r/+BU3PyCgg
wHUggAsSc+m/od4jgf4QIMAtdYHZxx7ev+RjClKb+R/A1EZA+dp5xb+5yeH6
RtsfwL7J6xwBj8Q/5mGzQwDEH8Auc+64bObdPxLBEtdYuB/A1suHbkSR6D8I
rTk9zbYfwKxc2StOgPE/quf8tf+/H8DvdEeomV72P6vsGrgN0h/A07pCEIql
+z9LWW4uqu4fwCETVDvjaQBALzQfyisJIMCaGXMyUdQCQOAM8+N5HCDA5LZY
nxFzBUB4ynVEljMgwGqOndX//wdA5g4bQZtLIMDOv6QF
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  Frame->True,
  PlotRange->{{-2.9999996842105263`, 
   2.9999996842105263`}, {-122.01900577397774`, 0.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{
  3.4603646404762897`*^9, 3.460364699141284*^9, {3.4603665639353447`*^9, 
   3.460366581063609*^9}, 3.460366633087812*^9, {3.460369659325509*^9, 
   3.460369665763332*^9}, 3.460369753864559*^9, 3.460369793388811*^9, 
   3.460369836877985*^9, 3.4603699414758453`*^9, 3.460370068395872*^9, 
   3.4603701665431347`*^9, {3.460370200393096*^9, 3.460370433322517*^9}, 
   3.460371569389784*^9, 3.460371630508395*^9, 3.4603716899665337`*^9, 
   3.460373567149763*^9, 3.460377060868331*^9, 3.4603771844497547`*^9, 
   3.4603772624878073`*^9, 3.460377669576057*^9, {3.460378194693892*^9, 
   3.4603782209413853`*^9}, 3.460431915408856*^9, 3.460431970723423*^9, 
   3.460432459979088*^9, 3.460432933635795*^9, 3.460434602602409*^9, 
   3.460435024282065*^9, 3.460435173021772*^9, 3.460435614824098*^9, 
   3.460437075408433*^9, 3.4604375668411837`*^9, 3.460437764211752*^9, 
   3.460438003600037*^9, 3.4604380498120193`*^9, 3.4604381267513323`*^9, 
   3.4604381572691717`*^9, 3.4604383035716963`*^9, 3.460438368055724*^9, 
   3.460438890192803*^9, 3.460438928779546*^9, 3.4604390596546497`*^9, 
   3.460439326285445*^9, {3.4604393591643133`*^9, 3.46043937775913*^9}, {
   3.460439876738007*^9, 3.460439937461564*^9}, 3.460440432214779*^9, 
   3.460441801623301*^9, {3.460459115956283*^9, 3.460459131804435*^9}, 
   3.460459457197721*^9, {3.4604600052420063`*^9, 3.460460050251873*^9}, 
   3.460460136725589*^9, {3.460462096012589*^9, 3.4604621177314463`*^9}, 
   3.460462195669779*^9, 3.460462312739161*^9, {3.4604628192627077`*^9, 
   3.4604629007734118`*^9}, 3.460721958185533*^9, 3.4607222745794353`*^9, 
   3.4607223270755167`*^9, 3.460722682802968*^9, 3.4607227524302464`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["ML", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[{"Theta", "\[IndentingNewLine]", "Y"}], "Input",
 CellChangeTimes->{{3.460427516601119*^9, 3.460427517953906*^9}, {
   3.4604302860648613`*^9, 3.460430286459763*^9}, 3.4604320351169157`*^9, {
   3.460459207514338*^9, 3.460459209125545*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{{3.460444788235248*^9, 3.460444817682623*^9}, 
   3.4604450103485413`*^9, 3.460459143269252*^9, 3.4604592096793203`*^9, 
   3.460459927811483*^9, 3.46046040805451*^9, 3.460461792764674*^9, 
   3.460722834150064*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"-", "0.194114104762065`"}], ",", 
    RowBox[{"-", "0.4302590760407047`"}], ",", 
    RowBox[{"-", "0.16128956235529737`"}], ",", "2.9559841090067054`"}], 
   "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.460444788235248*^9, 3.460444817682623*^9}, 
   3.4604450103485413`*^9, 3.460459143269252*^9, 3.4604592096793203`*^9, 
   3.460459927811483*^9, 3.46046040805451*^9, 3.460461792764674*^9, 
   3.46072283416127*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"maxx", "\[IndentingNewLine]", "p1max"}], "Input",
 CellChangeTimes->{{3.460459716559847*^9, 3.4604597507495623`*^9}, {
  3.4607229553901443`*^9, 3.4607229706246758`*^9}}],

Cell[BoxData["2.2730423049409305`"], "Output",
 CellChangeTimes->{{3.460459717379488*^9, 3.4604597508631268`*^9}, {
   3.460722956780117*^9, 3.460723027920322*^9}, 3.460723114979775*^9}],

Cell[BoxData["1.8996504553875246`*^-113"], "Output",
 CellChangeTimes->{{3.460459717379488*^9, 3.4604597508631268`*^9}, {
   3.460722956780117*^9, 3.460723027920322*^9}, 3.46072311499201*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"WEIGHT", "//", "Max"}]], "Input",
 CellChangeTimes->{{3.460773554552329*^9, 3.460773567154655*^9}}],

Cell[BoxData["0.08090864197530852`"], "Output",
 CellChangeTimes->{{3.4607735617662487`*^9, 3.460773568233426*^9}, 
   3.460773713467126*^9, 3.46077378178973*^9, {3.4607741536142397`*^9, 
   3.4607741762642393`*^9}, 3.460774756623849*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"p1", "//", "Max"}], "\[IndentingNewLine]", 
 RowBox[{"p2", "//", "Max"}]}], "Input",
 CellChangeTimes->{{3.460773523945409*^9, 3.460773532378478*^9}, {
  3.460774761328383*^9, 3.460774764190199*^9}}],

Cell[BoxData["2.0015841593344295`"], "Output",
 CellChangeTimes->{{3.460773524478456*^9, 3.4607735336244593`*^9}, 
   3.4607741796793947`*^9, {3.460774759268715*^9, 3.460774764977831*^9}}],

Cell[BoxData["0.0006699841228630257`"], "Output",
 CellChangeTimes->{{3.460773524478456*^9, 3.4607735336244593`*^9}, 
   3.4607741796793947`*^9, {3.460774759268715*^9, 3.460774764985526*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pp", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m", "=", "5"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"scaling", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"IndividualLikNonlin", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Y", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"IdioNonlin", ",", 
     RowBox[{"{", "}"}], ",", "m", ",", 
     RowBox[{"eps", "=", 
      RowBox[{"10.", "^", 
       RowBox[{"-", "16"}]}]}], ",", 
     RowBox[{"ksigma", "=", "Infinity"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0", ",", "0"}], "}"}]}], "]"}]}], "Input",\

 CellChangeTimes->{{3.460264864897327*^9, 3.460264932378791*^9}, {
   3.460265489300803*^9, 3.460265492492799*^9}, {3.46027038606568*^9, 
   3.460270391802556*^9}, {3.4602704971596107`*^9, 3.4602705817118692`*^9}, {
   3.46027367414145*^9, 3.460273674236417*^9}, {3.460279775378045*^9, 
   3.4602797754444103`*^9}, {3.4602799530257587`*^9, 
   3.4602799533811693`*^9}, {3.460280067013379*^9, 3.460280067130088*^9}, {
   3.4602801040742397`*^9, 3.460280104129944*^9}, {3.4602801453821163`*^9, 
   3.4602801673531218`*^9}, {3.46028174693688*^9, 3.460281763776168*^9}, {
   3.4602818356559362`*^9, 3.460281835739462*^9}, {3.460281898670804*^9, 
   3.460281898732609*^9}, {3.460282025318959*^9, 3.460282025741701*^9}, {
   3.460282062175247*^9, 3.460282071535883*^9}, {3.460283778391947*^9, 
   3.4602837888805027`*^9}, {3.4602838305963707`*^9, 3.460283854615387*^9}, {
   3.46028477341341*^9, 3.460284779157151*^9}, {3.460285035206752*^9, 
   3.460285046973556*^9}, {3.46028555906642*^9, 3.460285574425418*^9}, {
   3.4602857519094887`*^9, 3.4602857519715776`*^9}, {3.460285881590439*^9, 
   3.4602858816380377`*^9}, {3.460286117999454*^9, 3.460286123654068*^9}, {
   3.4602863340289307`*^9, 3.4602863377475977`*^9}, {3.4603641927287188`*^9, 
   3.460364197580667*^9}, {3.460365058304535*^9, 3.4603650587979116`*^9}, {
   3.460365091217347*^9, 3.460365126318194*^9}, {3.4603652464521227`*^9, 
   3.460365260029804*^9}, {3.460365412299954*^9, 3.460365434375272*^9}, {
   3.460365485584791*^9, 3.460365520950554*^9}, {3.460366663535665*^9, 
   3.460366678997499*^9}, {3.4603667867732773`*^9, 3.4603667868283587`*^9}, {
   3.460367092714067*^9, 3.460367098883337*^9}, {3.460369235357655*^9, 
   3.460369263924768*^9}, {3.460369362646221*^9, 3.46036936313859*^9}, {
   3.46036946785526*^9, 3.4603694691077127`*^9}, {3.46037339069245*^9, 
   3.460373390747698*^9}, {3.460373605599341*^9, 3.4603736056503153`*^9}, {
   3.460377091108459*^9, 3.460377126962656*^9}, {3.460377288435691*^9, 
   3.460377301095058*^9}, {3.4603774697122087`*^9, 3.460377479788327*^9}, {
   3.460377585320611*^9, 3.460377603716568*^9}, {3.4603776957101793`*^9, 
   3.460377736561165*^9}, {3.460377923292104*^9, 3.4603779233524303`*^9}, {
   3.460378105932313*^9, 3.46037817981962*^9}, {3.460427531315346*^9, 
   3.460427537420005*^9}, {3.460427638978484*^9, 3.4604276390230217`*^9}, {
   3.4604277414332314`*^9, 3.460427769573126*^9}, {3.4604279604982853`*^9, 
   3.460427960554902*^9}, {3.460430680071252*^9, 3.460430680172152*^9}, {
   3.460430712203142*^9, 3.460430712557424*^9}, {3.460430775931464*^9, 
   3.460430776020101*^9}, {3.460430814349124*^9, 3.460430814950081*^9}, {
   3.46043100067663*^9, 3.460431000775926*^9}, {3.460431035518139*^9, 
   3.460431043615539*^9}, {3.460431139283386*^9, 3.460431139330926*^9}, {
   3.4604311987514153`*^9, 3.460431233744923*^9}, {3.460431314274002*^9, 
   3.460431314321568*^9}, {3.4604316727142878`*^9, 3.4604316728008432`*^9}, {
   3.460431886035831*^9, 3.46043189177104*^9}, {3.460432099991972*^9, 
   3.460432100073539*^9}, {3.460432236204804*^9, 3.4604322362468243`*^9}, {
   3.4604323376555843`*^9, 3.460432357162323*^9}, {3.460432403219545*^9, 
   3.460432403269651*^9}, {3.460432564446265*^9, 3.4604325911495867`*^9}, {
   3.460432813689516*^9, 3.460432813733564*^9}, {3.460432944239506*^9, 
   3.460432989199974*^9}, {3.460433097024789*^9, 3.460433097139295*^9}, {
   3.460433291653358*^9, 3.46043329173923*^9}, {3.460433672964451*^9, 
   3.460433673010107*^9}, {3.460433845665332*^9, 3.4604338457416363`*^9}, {
   3.4604344009903316`*^9, 3.460434401033557*^9}, {3.4604346235115023`*^9, 
   3.460434638473834*^9}, {3.460434675871023*^9, 3.460434675925946*^9}, {
   3.4604350413113747`*^9, 3.4604350414069347`*^9}, {3.460436666989565*^9, 
   3.460436677468376*^9}, {3.460437023691847*^9, 3.460437023772811*^9}, {
   3.460437179838045*^9, 3.460437214787621*^9}, {3.4604373750456057`*^9, 
   3.460437375101828*^9}, {3.460437455923118*^9, 3.4604374559862347`*^9}, {
   3.460437643282413*^9, 3.4604376433404827`*^9}, {3.460439284564681*^9, 
   3.46043929340877*^9}, {3.460439393566842*^9, 3.460439393962884*^9}, {
   3.46044000098571*^9, 3.460440001044331*^9}, {3.460443930270521*^9, 
   3.460443930334333*^9}, {3.460443966799687*^9, 3.46044399790462*^9}, {
   3.460444060284606*^9, 3.460444061730588*^9}, {3.460444101336812*^9, 
   3.46044410138903*^9}, {3.460444186536171*^9, 3.460444194286351*^9}, {
   3.460444233408099*^9, 3.460444248920389*^9}, {3.460444338058318*^9, 
   3.460444355662019*^9}, {3.460444400012597*^9, 3.460444431012135*^9}, {
   3.460444591036777*^9, 3.4604446631572647`*^9}, {3.46044479971354*^9, 
   3.460444799768903*^9}, {3.460444831583193*^9, 3.460444859781989*^9}, {
   3.46044502143334*^9, 3.460445021504759*^9}, {3.460459950502769*^9, 
   3.460459971711813*^9}, {3.460460068419449*^9, 3.460460088588605*^9}, {
   3.460460154598343*^9, 3.46046015516997*^9}, {3.460460281436612*^9, 
   3.460460281521656*^9}, {3.4604604120265713`*^9, 3.460460412125514*^9}, {
   3.4604607607833633`*^9, 3.4604607621971283`*^9}, {3.460460826677142*^9, 
   3.460460827186878*^9}, {3.4604608962826014`*^9, 3.4604608963501987`*^9}, {
   3.460460962965583*^9, 3.460460963358262*^9}, {3.46046100555375*^9, 
   3.4604610220017967`*^9}, {3.46046105589403*^9, 3.460461056004932*^9}, {
   3.460461154113535*^9, 3.460461154227416*^9}, {3.460461800671767*^9, 
   3.4604618154025*^9}, {3.46046184541817*^9, 3.46046186011173*^9}, {
   3.460461896620476*^9, 3.460461896672694*^9}, {3.460461952952413*^9, 
   3.4604619533933907`*^9}, {3.460462913572587*^9, 3.460462920740217*^9}, {
   3.460722765559946*^9, 3.460722812479978*^9}, 3.4607228582030888`*^9, {
   3.460722890758842*^9, 3.460722896366596*^9}, {3.46072298397585*^9, 
   3.4607229875994997`*^9}, {3.460723019415843*^9, 3.460723105990931*^9}, {
   3.460723170191799*^9, 3.460723171657259*^9}, {3.460723268211129*^9, 
   3.460723287189331*^9}, {3.460732937278017*^9, 3.4607329553868093`*^9}, {
   3.460733072671542*^9, 3.460733072733719*^9}, 3.460774164086339*^9, {
   3.460774329652614*^9, 3.4607743297042007`*^9}, {3.4607747308600483`*^9, 
   3.460774745217613*^9}, {3.460774783118621*^9, 3.460774783163679*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0, 0, 1], PointSize[0.02], Thickness[0.02], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJzVmXk01GsfwMe+zYRpGBk0Y4mUZZJu1xCylZQ1ERFJSWUropK69yaXmaxF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           "]]}}, {}}, {{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.01], Thickness[0.01], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJztmktIVHEYxU2iFDLfk4tBZuZaYAVlWkFC10YkCOy1qkYNek1FD9oU1CKC
yIIWtQgqCCoX1apFUVDYgxB6OdokEgVBBZFNMGoE5Tyo4H8u9IPL0O4Ks1EO
h8N/PN/5vu/+7xjcsn/99sKCgoIDf378/d3zpnfiwbEpj7Zt/hm9vHzdcuHg
kH00FT7n4OZfe3o/dN9wsAV+k9Hf/fQysmvD6EPphRe2+hMfl7x1cOnspQe6
DicdvAh8ldG/G7po2Zsu2zpfWHrhxdFPH5s+F9rC5eDnGf2Ms9NWl3SN2fr8
wjpfWHrhRvDVRt9+8+33M1MLW/T3C1eB1/nC1K/N4f8Cc77wTPP5hBvAV8H/
BfB3+/1l78vrA7Zw6tb1msfRRgfvAB8w+jfGT50vLL2wteHakeb2lQ5Og0/V
/etvA/zV+cLSu/FBo3fzPwBe5wtTPz1H/um/8idcDn6+0cvPmcg//a8z/gln
wKfN5x9G/oWlF45tPHEpOxFx8Bzwc43eLf8Z+C+9G5+Bv/OR/zR4nS9MvT/H
/GH+6X8TeB/6owH9wfzT/yj4kNEPYf4ISz8E/4Wz4LPojyb0RxT5z8L/neAt
5NuH/giBz8J/6otd5j/nD/NP/4XXYn9wfgVQH+WH/gsXGf0r46fOF5ZeuN7k
7xX8F/Zjf/iwP0KoD+tngS92mf/CReD96B/q2/L7w9P7YyH8lX/C+vuFd4Bn
/un/8QsH1/R92+pg+3y49Me3Qw4+AT5i9MPwX1h64dr2K/ue3zvt4BbwyRz+
6nxh6YW7wXcYvZv/EfA6X5j6MvhfivzTf+1P4Qx4zh/mn/7LP+EV4JOY/3XY
D9ILX12VqH5qX3FwALwvx35eAf+lFw6DH4W/3N/0X+cLUz9S96//i1Af5p/+
R8Fz/nP+MP/0/yR45SeO/S0sfRz+C4fBj8F/7u+TyD/9J9+JfHN/M/9j8J/6
Cpf5z/nD/NN/4aIc+zuC+iTRPx3g1b8D2N8DmD8DyP8A/Bf+gv3B/d2B+rB+
neDL4T/3dxn4L+gf6lOv8/cPL98/8vvDW/uD+bfgv/InPAe8nv/lp4X803/5
58w38Pr8ceQ/Dv+F+3bbT/beue3gHvC9Ru+Wf/ovvfN8C34W/K1H/um/zhem
vjbH/Ekj//Q/Cz6L/kijP1qQf/ofBq/5PYj5M4j8D8J/4RD4GvjP+zfzH4L/
reDHkW/ev7m/a+A/9Qn0xzzMrxT4uahfFrwf+yOF+nB/+9A/Y+C1//ox//sx
f/qR/374L1yL/cH7N/c360f+q8v8d9vftegf6kvy7688/f4qf//w1v0jvz+8
tT8a/7M/doK3cvRHN/JP/9kfyk8M/RFD/oX1/CPcCp79wfnD/NP/U+C7kG/O
H+af9aG+Ev5XY34FwWdQPwt8MfZHEPXh/XsU/dMJXvfXF6qHOV9YemE9PwqP
g/+K/cH357x/j6N+XeArXea/2/2b+5v69OvJ8f2H5r/OF5ZeWM//cexv4cn2
/YdX318Nwn/hJPaLD/uF+2eyvb/y6v1D81/nx+C/sO4fMexv4cl2/8jvD2/t
D/7/D78/5PtH3l/asD+moz5lqM8I+qcCvPr3Gea/sPTPkH/hBPgS7I9i7I8K
1CeB+lWCl3+c/5w/zD/9F242+t+Xr9TE
           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{-0.16128956235529737`}, {1}},
      PlotRange->{{-4, 4}, {0, 10}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {195., -145.68505432423805`},
      ImageScaled[{0.5, 0.5}], {360., 277.49534156997726`}], InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.03], Thickness[0.03], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJztmktIVHEYxU2iFDLfk4tBZuZaYAVlWkFC10YkCOy1qkYNek1FD9oU1CKC
yIIWtQgqCCoX1apFUVDYgxB6OdokEgVBBZFNMGoE5Tyo4H8u9IPL0O4Ks1EO
h8N/PN/5vu/+7xjcsn/99sKCgoIDf378/d3zpnfiwbEpj7Zt/hm9vHzdcuHg
kH00FT7n4OZfe3o/dN9wsAV+k9Hf/fQysmvD6EPphRe2+hMfl7x1cOnspQe6
DicdvAh8ldG/G7po2Zsu2zpfWHrhxdFPH5s+F9rC5eDnGf2Ms9NWl3SN2fr8
wjpfWHrhRvDVRt9+8+33M1MLW/T3C1eB1/nC1K/N4f8Cc77wTPP5hBvAV8H/
BfB3+/1l78vrA7Zw6tb1msfRRgfvAB8w+jfGT50vLL2wteHakeb2lQ5Og0/V
/etvA/zV+cLSu/FBo3fzPwBe5wtTPz1H/um/8idcDn6+0cvPmcg//a8z/gln
wKfN5x9G/oWlF45tPHEpOxFx8Bzwc43eLf8Z+C+9G5+Bv/OR/zR4nS9MvT/H
/GH+6X8TeB/6owH9wfzT/yj4kNEPYf4ISz8E/4Wz4LPojyb0RxT5z8L/neAt
5NuH/giBz8J/6otd5j/nD/NP/4XXYn9wfgVQH+WH/gsXGf0r46fOF5ZeuN7k
7xX8F/Zjf/iwP0KoD+tngS92mf/CReD96B/q2/L7w9P7YyH8lX/C+vuFd4Bn
/un/8QsH1/R92+pg+3y49Me3Qw4+AT5i9MPwX1h64dr2K/ue3zvt4BbwyRz+
6nxh6YW7wXcYvZv/EfA6X5j6MvhfivzTf+1P4Qx4zh/mn/7LP+EV4JOY/3XY
D9ILX12VqH5qX3FwALwvx35eAf+lFw6DH4W/3N/0X+cLUz9S96//i1Af5p/+
R8Fz/nP+MP/0/yR45SeO/S0sfRz+C4fBj8F/7u+TyD/9J9+JfHN/M/9j8J/6
Cpf5z/nD/NN/4aIc+zuC+iTRPx3g1b8D2N8DmD8DyP8A/Bf+gv3B/d2B+rB+
neDL4T/3dxn4L+gf6lOv8/cPL98/8vvDW/uD+bfgv/InPAe8nv/lp4X803/5
58w38Pr8ceQ/Dv+F+3bbT/beue3gHvC9Ru+Wf/ovvfN8C34W/K1H/um/zhem
vjbH/Ekj//Q/Cz6L/kijP1qQf/ofBq/5PYj5M4j8D8J/4RD4GvjP+zfzH4L/
reDHkW/ev7m/a+A/9Qn0xzzMrxT4uahfFrwf+yOF+nB/+9A/Y+C1//ox//sx
f/qR/374L1yL/cH7N/c360f+q8v8d9vftegf6kvy7688/f4qf//w1v0jvz+8
tT8a/7M/doK3cvRHN/JP/9kfyk8M/RFD/oX1/CPcCp79wfnD/NP/U+C7kG/O
H+af9aG+Ev5XY34FwWdQPwt8MfZHEPXh/XsU/dMJXvfXF6qHOV9YemE9PwqP
g/+K/cH357x/j6N+XeArXea/2/2b+5v69OvJ8f2H5r/OF5ZeWM//cexv4cn2
/YdX318Nwn/hJPaLD/uF+2eyvb/y6v1D81/nx+C/sO4fMexv4cl2/8jvD2/t
D/7/D78/5PtH3l/asD+moz5lqM8I+qcCvPr3Gea/sPTPkH/hBPgS7I9i7I8K
1CeB+lWCl3+c/5w/zD/9F242+t+Xr9TE
           "]]}}, {}}, {{}, 
        {RGBColor[1, 0, 0], PointSize[0.02], Thickness[0.02], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJzVmXk01G0fhy09TOipYaxjHQ1FCpXsYwuRJdKCZGkhyqOVFkmJpCxlqEi2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           "]]}}, {}}, {{}, 
        {RGBColor[1, 1, 0], PointSize[0.015], Thickness[0.015], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxN2nc41l/4B/CH7C0jmQ+yd7byPEaiQULKFiEVmYlkz0gUykxCRJJR8kWy
JbJH9szeIxK/3++6cp/fP9/v9bp0/nnf1+fc59zn4ba6q2dDiMFgnP/3P//3
/9d9FbuV/gRVWFlKnZGMr7hDY7693bgn/gNc0V0QGiPfCFZKPNfVK1wIFv6W
YvnhTxDu08R3E/trK1/SQtPXGohGwT4jGcexlxbAMlmtMx57U2CrZZfj9j5t
4MQ5GdEBqte4ga5EXrxxGr6WSCSgsOcXWPjYTH0A3SZYm0W8isl0BVxMuiFS
HNEHNhD0H0g3ysNRxZDoUJuv4uVT76TheMbAr5YHq5I1l8DvOowININ+gX/3
KF+8mtEOfiSlQnbNMgOn/f7nejQRoQrur9h5niu1YDbLDWnb7XZwUhCB06mZ
ZrAEb1Rd0HIxuD3Z31RWPAzy5GvBbxdRjoGJfhuE1HMtgetG5WIMbX6B1csi
vbgft4N5a85qhGtkQJ7Vrrh7zuv74NLAj7IWRpT4Q5f5JXxMVCYG0zSHHXEb
XoZ/7+tc3ehlV43r+5enQySZTxUpKf7QMlHJa5lGjODTfNZa3Mm0YK666o7U
j9uwPjBoojTEuhny3JuePuv/GIM/dGHYiHmVCjXYTLH8AbaUBDz2iuepJOUq
rNc/Pxjs9r4G8rxnqcaSljEBVh3ocHI0WQWf9wut296cAwdlfzaqV+wCt66a
vblg+gbybNLdC2nomgO/NPEQdC7ZBgeFXYzqsF8Df58MJg9IG0DfU0kKd9HM
e5S/lqIsmSkZ5H20V1LFIIQJLDXgnRz/iQ4srxmmuc+4A+uFJqYsZX5/x/X8
yzOcNqJQGHsUf+gGfrJqMSIsuDW42b55lAX8l5rYpjmHEJypMCioF9UNeUqx
6/ry0FBA3vuxliRzxMfAsgEvvvqO0YMdntYV/e7chfVlPiy89/ZaIU/Dbjzv
rfklsMFCJr2m3h8wFfVPWRaFTfBsnl+ZRM8IuOr0anqxFdpvCpjlcM02k2CS
q6LdnCQo//OYrdPHD+bBpQ8uKOZhusFM4wnuxGrZkKc1z1vy2iBCyHtIronj
qBnKPzi8+9vwLXLwD43qWEv6dVjfa+x9ZZO4Htf1L0899vJdtieU+EM/WFKJ
ZzZmAR9ZK+39MHsU3KQ/cc7Mcg/WL3L1uPNZt0Ge1RPDeQ2tRyDvKe27Yvl+
KH/+vMmETglKsNCzBEJxmw1YX/qIMNIhqgHyjJltXfHw/wX+6Pv6vHTdBvjK
gqf5C+4V8HB+2r016T5wjSUth+ZGLuRZWeK1tfO1CYxVYzBOre4B70Trzp56
h/YnmlvY6cfBZWDlFsuRiVdRkGeE6oeTEVa/wIyDAr0jORvgRYF1UwuqFbCD
fs8MK2MfuKTeg8vvRy6u/V+e9NGbDiG2q2AJXU1irap9cOPRN9n7Y9tgG6u4
x5lzY2D3qNqpiA/FqH+4kDppHpkFp6UFbbGzboEL1Ur0zYTR/jSb99he+ms/
mKOG5hbrl3eQZ/zSX4KK/BawMAGjkJvST3Bs3sujdeZof1pPm2bkjK4ET0ss
jdlmxUCeWt8f1h/wjoJDtfQLL4QsoP6SZ7WrKzAN5pQ7vv04tQ18rUbd/Y/U
a8hTjDL81medv2AVE7vN5Cn0PcSZvZ4YZScCO80yuKuKLaH6kN85fcnhK+z/
a+LXSYtaiaE/cBhJVpFoMIAvJWipuy1Rg2lYg0y03LZgPRNGwllpuQny3Irz
OUJgdAAejUzFchSh7+FIZq65diAx+EWbk0kg7wr8+5nr1+uHX1dDnoRC6VEp
CePgCwKffXzuou/hrY5TmXfoLHh07aZ9H38nGCtk8qeKMwvynF0KY62ROACb
210Yzo2ixB+6ePBb24EtMZiQeLNTk2YFnbdIDOuvRVRDnqrMqVnauuyQdxi/
dOV3IiGwr6o7taYjL1hQZH70nAA1WOnLsjJJzyj0D64vFoLW9HzQDzKqnCsr
U06CE1pjhlPmRMG042coTT4wgX9nvP7KTIO+hxyJvAsjWpyQd/g1yfisamEw
kdc6SWTjCbABb2JxhzgtmHCJr4GaEOU/18odx/ebAH9o1y+Xm159pQWXRMSn
DeWQgXO3Mm/G+62h85dPDn+ZeR3kOb700MA/ggzyzk1XZ9IsYAI33Q2ZEe6j
A6/zKA6NaOyg85WhqXeOZAvUg5Qk/EyeFj/k28SZpNRaIA3m40slGo4TB58z
u1QxssoMnrEVZjjnNwf7f2R89aemWEnoDzouTLovtZXBtk0ffbiq5cDfxLMv
FRzlBg8o3PrBUboO9fghJni9qVsA8tUOxDYU08qCWfSJa9xNJMH1t79jax+x
gJ+LdyU9vrYAeV4uGnTb1KKCvA0piIwv7bOAN/j1yk/bM4DrZMbnPnP9hfV2
FSynstvRfnOMSpt1IJsQ8p6p+Uuw5Y3yryQWqLBLJge7cTu9C5dbh/XdO9lT
o5L1UI+roQm5bStYyPe2Uv6e6ooYmCjl+YGjigCYxVOExMWZHjz5ulLnCd8k
ruNfntY0DfqbskL4Q19d06SaOisH1r6yNHFCWwocM9HMZrV5HBxgkZNq8WcR
6hF5+mV6CScP5Etyho99khDlXzasYtE8LAgWbHY+cyH7KHirpdYnPnIK8jTj
wT37z48Y8k7PiiXlwaD8nTzkpZ0DqcGVqa9+YU5swfoHi/FZ/k9R/35fH8zK
GY3uF0ei+8n5OjbAH/KU9zJF0P600646QKreB9bglDkoJM6DegiP19s630D3
C9kM+0yeX0fBZpUjNCmmaH/iHvRaHCHZgvX3g9UmB52acD/+5dm3u9e42E2L
P/RkIrG8Hzc7WDCpqpKsnwmc9XeUqMsaA74RkmIksNQB9XiheEk7dwzdL6gl
3lw4kGcEi4vWigzaof3px/mX928+2Yb1R25ifE7Loftd78/rNGcE5lE/ueOp
bbC/jc67ky/4HdPR/hSjfnncaXMA7Pijdc+GrwDyZJj/4nVTYgascFVjacp8
EzzvkDey9QLV46TnTCnlL1QPAlFMMU8NqgeDAkabdhPVw3n0jtyCLQMY+1/z
MisvDTjzj8Z0QxKqB3tRhUw/+zfoHynBB35PDemgH7RZFQ3ljrCDOfFqnWV3
mMGKJUMf0jowYGxvqSnWsRPyXKwsMjf2JoW8Bc47c+ZXoXp8kWR7w8RJB/aZ
2aHKF/8N653U3xdLLaF6mAsc0HUNo3owf4z7LzTtN7jDoFjVDrsO7ntumu9S
OAg+WT//MvIpqocEq4+Jmxkp7Eea82YplpmM4K+eG+pjZGj/Go+Schii+Q3r
J7VoS12amiHPY+E3b7vI8UHedPQLaw8rT4LvhCd5PuBA+5e163RhYC+6Lz7z
n/AWUpqF/uFyT8/PK0YC+gFtCIUQ0dQp8PF9IUbat7JgMekY/3gVLFgURxDt
WrcGebrz9Ly+X8APeXexuumEUMmArd/KRl45IQFec+FSqTJF98V05Uitsj/o
vh2AZyMfX6CA/Sj2al58xbdjYOIvN8TMvI6ift8mFa3/Gd0XKz2LivMJUf94
6MYpkGp9FPLOsLX72oDHghkuViRbKB8HdxlQE+CXUb85FvbsYfhwN9SDhW46
dOODJOTLMMDDIOKvDM4lubElMCcH3moXel4qyQ3Wbqwvbfm5Dv1jm6HV0L5P
AfrB04Kva6c2NMBx4osCa1Sq4Ovtsh20cajfcCafuMcV+RfqceWN0HnPASnI
V9JQInUzCg/e6ZFuCwhQAOP2dmzprFG/mbnKW5x2Gt23K9g26lYlmSDvkWc7
Sq8+84DDaWtplpg4wDwHqRr97ajfuB7wqKZK90M9rgzbC73dROfbaIlmv5Ji
FtS/j7jjGCQZUL0e0otuNe2h866h6SA2Dc0Ds1tWJHWs0Pl2zpqiitER5U9l
uLb/7LYUsit5ESUvKzgvc5+IQ3IJ13Y4v9rvNNKbOIk/tJNlptfLAhXwaoh6
R9aCIpiCef9nuQsv+Kr5k+Kb99B97waVhflbfhHIN6mUxO/7X3mwKo4+nyj9
JPgZr+nrjg02cJXmUAIFH7pfJDR2dQmy00G+kQzKc0732cF7tDKWUezM4Abt
Kp8H8Rjwku1UYbZgJ+R5Z8uFRvPNKlilXIfv00l0HyEPas4dVkL704wYU99l
sXGwSzNFzuP9YqhHSxjV7hYJmo/c6f9LuaeH7iNdPFdOehyg/emRwJOSbD8M
mmdxhh+40nbiWg77s2SS81r/MfyhQyP6p64z8IE1zC3zdc2x4KdJao1UT8jA
58tyTvuZDUI9yMzYn8aeQPORkj4mz4oL6D5iZ+da/CAU7U/RJ9h2K7MIwLz/
yfNyWaP79vfE5aFfV9F8JKjGUaZ/B91HkmZCTMgX0P4USslpY7E2ifrL7U1F
f6lSdJ6iF9yK9UPz3Z/jNI8NltB819KnSrqaGPV7n8eYZU/iDrA90c+usDY0
3y1/4ND/tuEA3D/czzfNSAV5217OVcT/QP3+Nq/JTW9TND+Ru6NjnzdVDf3D
jZ3R4W0mKfSDmJY4e4kpRvB/ZHvZd5XowIV1J5rljX7D+vwAw3P6XN+hHuce
vtzEHKD5rirTtvAVchrwRsCM84w+6vd/1FmoaPzQ/CT7giPhXTk0X38tMKKn
K4LytaFk4HTpQPNdJ7sFju581O/poqnPuNeiem5cIT3nuYfmu7fUXuRkzGBg
P+pbVB5tG6MGO3glZMjLon6fuBq/TWqPvqf0mD6rXrZayDOJY9e1sYgTnaeE
P33m5BYB9xokJczRo34/5Hcj/VcyLViirFQkTXUc+kf7cgKNVR8/9ANVYsPC
bxIy4AhjlcscJhLglbXwT33Bx8DzI5LGUiLzkGcx53K4+20s5E3aEukURyQG
jsjT7bAJR/2eUrZcj2cGnbfuXozR3w5B8/UdVT1RRe8j8D10tZTy/ydPDzaa
oKoMrET9vi9TPFuUDn1P708xG+BFGyBPVcfs6ucpFJC3iMZHz3dBx8AFMplc
6+qo3weduqL83u4PrPcgVnxH/+YH1MOuI31sUUgQ8rXc8YqiMZYFBxp26crE
oX4/PDIZbDfGAj6GT8lJLV+A/kGT31Q9visF/aByyXftfj0e7L9ORJz2TgEc
5GZodTOQB6wlzka6d30T6pH537p2RJ8Qmn9cSTJ/0iOH6rHO+qm0HPV7l7+9
L74ls4JvSOjHlpWj+foM/kZGey4N5B2EYRNjYmVD5yuXfQdXKtTvHesFjItj
D2B93GZa78RptN+IvCgh7D1FBHkbUa96UI3Ro/79qmw8sA71ezL+W3c9u9F9
8Yhz0yssXSPUQ/S6rOQ7cx7Id6Mm+MD+FMr/4JuK3XM51O9dr58PFpxD90V6
A2/unL4pXOu/PNWbCrbvGIrgD81rIqaGEVQAa8X02DZXnwSfdSYcO+BjB7+k
D+1zUkXzwJS0j1QUWbzo+9g8cTbfFOU/FnMpZmYbzbNcN3woTp1C95MG5iG2
XTM0X/dguybIdZkU8mYlDe/0SmQEP/V9G3sLg/r9szHvOGFCdD8Z3nUmaixr
hjzV+mrsDyJn0fuUtCF767Mt8FR/kvloGNqf8I2nmAgu/QTf6NNLHLfKR/WI
dSN2OUkK+ep1msRa+DKC3dbjXct60P70eWw8OHZ8G9aPJxfkXoxvxjX/y1OA
NEKvXI0ef+gG4TVlMn9O8DWbLcORgmNgisl7hc11BGC+Xs2BPyFdUI/87A8c
3T/I0Dz3OZ/OmwUm8ErPrU0aUtTv2aQV3JUid2A9oypr4rw/mq8z3O/7+d55
EXyXdeCHP9Euep/SSTk3IoP2p5cZU2aql4fBmJCMG8cDPkCe3kUFz58s1qL3
jChNX2Yf9P1E3UyMcf78HVmZ3tUjsgTNU3yzPR5MhEGeHHFDb0gwE+j8O/Y8
Y68J9ev0M22vqBjnwEcVYtgvRHeCv964nB/xIgv6xy8+7ZlHZxfAJ0PGGkX3
foMZjZpxsXbovlLD8IFYmWMIrMZL4aDQVgB5VsgljaTqTYK1J9NzxDZRv771
yEK/cRL1G6X6MI2lBVTPY0VJYgoi2ZCnb6ep7gJHIzgrAJPrcqkbTEHpSrId
2QY+t83YTNFdit5LUotvX82PRPNZ3GvhcXn0PnjFZPzh46H/9z2MPi9lqkLv
g2FuPZG27V3o/TBVm+0OJXofbLGNzWQyQe+DVjoXPZQV0PmXJ6riYo4Ueg9Z
qE0odp9eg/VPFBqirbvqoH/I+VwPYbxMCf3AejiLTpOXBWw8E6eF/XIUHCZ+
ot8Huwfrw8hf8qjj0PvggcFp35Pp6H3Qe4ZK/JwR+h44DNST0tfQe67Fwbzu
WXn0PpiuwXz7phF6H7y0RffnyUW0fzWS03q5xqPvodHBVuTZ7jJ6360aaLr/
txf9vThl3aQEvQ8az2fHy3Yug6djrpEf50L3PYUvVdvCvWieJXU7+YWDFXq/
8pMttwhfKIQ8L6Ubpn+YROdb3+8V2/Ohx9H77LXtP+xdaJ6l4Pc2nrEKvV/t
ptoPqIm3Q/8wUVF/2eLLBP1AyDWy9tIBD9h/cyBBOIADbDEyOknJSwJ22FR8
axuD3vf6ZLoKn/9C59ucRQ2faR103zM8LlVxXxbtX9FkbWdUOtD7lergepej
ZQfk+YZ5+KOeIZoXBuypWpHJoPuec663BlZkB/6eXBeVGjWG3k9eXaRe/9yK
9hsOWxf691LofpFx/GfpjCXK/xZ14PuQRDRPnI2TfG49i+aJ+rrkkb11aJ5Y
MVWngN1G94s9jbnYLzdR/hYfdaZX+NA88ew0d8BMCponcmdUKepwfYP+keny
iJ79Gh30A1dGrI31ODu4NqiUoNeRGVxUVb4k24UBq+pV3Ny4i+aJot+l2aN9
0P1CJr+GOL0a9euaN8vTCVzofNsWw/10QxLNE3ef4wM7VtA8Ucv2toPrGLpf
vHmrvN2Xjvp19Xmvv9I8aJ446HFrg68EzRM9O5W62WLRPHF7sddR7XErOJu/
yILxAPXrneqfyV7baH/ytuFmU3b/gu7vlaNbn4SfQp7vVcpl6srn0XvIWb6A
uwG/wWFkHo2k5Oj3C3GkW/LXnwyC55/5iFz0KcA1Hf4e4UcBVfLrDXAW4wpd
5WlC/KHXRl4Zrervwd+7xhVt9FSmwEmfoznDI0ohzzqvdx/pc9F7iE5emqic
PPr9iK0L1kPFFO1PskoRi4aRw2B+60pjhYwPkGdJ425DYCL6vdXL2QRyIXb0
+xGa2mMKxkLo9wuFZ1VzxLDovXfjkQC15XIs7n8AwgkQ4Q==
           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{-0.16128956235529737`}, None},
      PlotRange->{{-4, 4}, {0, 4.003168318668859}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {585., -145.68505432423805`},
      ImageScaled[{0.5, 0.5}], {360., 277.49534156997726`}], InsetBox[
     GraphicsBox[{{{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMBy75fe/XnZrOWpz2dd/1w7/2O4b8fholnyAcNXte
urzH1/2P7RPrq+tdxIsu9K7ep/Vhf5TXg3MZNx6J3yp8U33R9un+6yHPtyy9
9VA8sW3SupVHr+7PKPJleGX4RPxVt6Honfrp+7/PeJiWYPVEPLSd/VNT/xV7
Be3uE5/NL4iHCKvOudT3xP7wkb9G7A+PiJv+CVY6t+m9/a/t1TxR7x+JL9hm
XxsY+NV+0sqP6uGf+sW/5PH7Pcn6Ze8blLrMTWqJyNPPqQFvPv23377lBhP/
sW0cwTa7o/36mBxg/mN6yqaRGMUK5+9ef9EjS5IDzo+p+jnbfSUXnO+9+kl7
fAEvQn9ewMTgQwj+DoM9s9xF+OB8lW2T1+rvQPBvVfzfpszFD+dPtM4+IB6D
4Hv8u3aSex2CD00PcD4AHWO9dw==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vk7lAsfgPExlmFmzEhSjrc9JWpoceoU3+fRNirZsxShDCVZOlrssjTZ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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vc/1YsfwPFjHMfhOERWVJLKKFTc3Pi8Px8qMzOhqIxEyLpGN6mshIvI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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMBz5fNaztW7OEtTjt677rh3/tt0jOKZriMkc4ava8
dHmPr/t9BH2/OP1oFC+60Lt6n9aH/fFRJ/bEtSpI3Cp8U33R9un+EJWz7hd8
5SUS2yatW3n06n7N7h+rnLYoSrzqNhS9Uz99/wzWfXfX7laUCG1n/9TUf8Xe
7fGPF1vyeSRChFXnXOp7Yt9898rKY75MEqZ/gpXObXpvP7Fm7uTqmQoSC7bZ
1wYGfrU3SbPUXsh4RvxLHr/fk6xf9imrl6/vnP9Q5Onn1IA3n/7b3736avPv
b585gm12R/v1MTnA/Mf0lE0jMYoVzt+9/qJHliQHnB9T9XO2+0ouON979ZP2
+AJehP68gInBhxD8HQZ7ZrmL8MH5Ktsmr9XfgeDfqvi/TZmLH86faJ19QDwG
wff4d+0k9zoEH5oe4HwAp/K7fw==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vk/1fkewPHjWA7HWYyyDYZiKLJO2+R4f7+ZSqlRlkJUlIOMkGRXsiah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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk7lHsfgGeGmWEwpChpsUaUJDpF8/k+tBAlSyFRCYmKRJQaFKJsYexL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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1AkfwMc5ZowZZ7GtJ1ISrdu2rs/3SwppEdKsK2LIkYYo5VokIrXG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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk7lGsDgMcylsHYibGmEGUp04Lned8QUvYtskcclS0pshTJPrLGkFSK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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMBy75fe/XnZrOWpz2dd/1w7/2O4b8fholnyAcNXte
urzH1/2P7RPrq+tdxIsu9K7ep/Vhf5TXg3MZNx6J3yp8U33R9un+6yHPtyy9
9VA8sW3SupVHr+7PKPJleGX4RPxVt6Honfrp+7/PeJiWYPVEPLSd/VNT/xV7
Be3uE5/NL4iHCKvOudT3xP7wkb9G7A+PiJv+CVY6t+m9/a/t1TxR7x+JL9hm
XxsY+NV+0sqP6uGf+sW/5PH7Pcn6Ze8blLrMTWqJyNPPqQFvPv23377lBhP/
sW0cwTa7o/36mBxg/mN6yqaRGMUK5+9ef9EjS5IDzo+p+jnbfSUXnO+9+kl7
fAEvQn9ewMTgQwj+DoM9s9xF+OB8lW2T1+rvQPBvVfzfpszFD+dPtM4+IB6D
4Hv8u3aSex2CD00PcD4AHWO9dw==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vk7lAsfgPExlmFmzEhSjrc9JWpoceoU3+fRNirZsxShDCVZOlrssjTZ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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vc/1YsfwPFjHMfhOERWVJLKKFTc3Pi8Px8qMzOhqIxEyLpGN6mshIvI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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMBz5fNaztW7OEtTjt677rh3/tt0jOKZriMkc4ava8
dHmPr/t9BH2/OP1oFC+60Lt6n9aH/fFRJ/bEtSpI3Cp8U33R9un+EJWz7hd8
5SUS2yatW3n06n7N7h+rnLYoSrzqNhS9Uz99/wzWfXfX7laUCG1n/9TUf8Xe
7fGPF1vyeSRChFXnXOp7Yt9898rKY75MEqZ/gpXObXpvP7Fm7uTqmQoSC7bZ
1wYGfrU3SbPUXsh4RvxLHr/fk6xf9imrl6/vnP9Q5Onn1IA3n/7b3736avPv
b585gm12R/v1MTnA/Mf0lE0jMYoVzt+9/qJHliQHnB9T9XO2+0ouON979ZP2
+AJehP68gInBhxD8HQZ7ZrmL8MH5Ktsmr9XfgeDfqvi/TZmLH86faJ19QDwG
wff4d+0k9zoEH5oe4HwAp/K7fw==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vk/1fkewPHjWA7HWYyyDYZiKLJO2+R4f7+ZSqlRlkJUlIOMkGRXsiah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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk7lHsfgGeGmWEwpChpsUaUJDpF8/k+tBAlSyFRCYmKRJQaFKJsYexL
yxGyZTcizxO9pEW2OFFSyBLCILv3vNf1/nBf939wX7fsOTczRwqJRHr+L//z
MqHXurIiSuwSlOxYILewtvz9YXAkT5TY9ib+F8O/g2UcZLX8+ZQocWEg7P36
uG6Wl1Pv6npBUSIv3k2R2dnLSjvsurWknEmkDhclni8eYtWpzsFjRybhZx5U
8TR+nDUmEng8YjWTIA1ovZu3nWZJjjNdbr4SIX62jWlbuy+wUEui3wU3EWL3
aN7rgBgypOkL67lKihApv67r6vyiwWKVL7/nS2GiYwrqm9+KgLXGRN0NB2Hi
9Pwv1bijq4GbaX/PT0iYePGzfCX09zqQ3NhuFFQkRNBM/PYeZMrAtWgDZuhJ
IWLW9KZ4VIoCtNErmx6QhIhekyjJ7LMqoMHeHhOXySCSW5X227aqA8fs+Mfb
xxkEcSLTfkRUC6aVbgpdJjMIVdke+i4jbbBYeqxvlS9IqB7skJQ7jQG35U3A
/lOCROhRX5EbZgdAKus3riYgSCTJNzs3bz0MPmzJRalSAeKhpfKrIvFj8MWM
tYd6ToCI/FVStFrOHFjKDp7jTAFCBBR8Qvws4bTUQv+tl3SiNrE89XW2Dfgy
oi0FL9GJmJV8pbYrdpC2oNwQu55O3CiJ7vNTcYTqEVxbroFGFC9SRnPSnKH7
q0VuvjeNuLDzxq6VUVdYbhzdqLOFRly0v8GiPbwKm4jAyPo2KjH//NTBKRsv
gEJp8vEAKnEtz9DXscEHOFpJm+dUqITakRcSAyx/+FWxDtJa+IkH2wXO5D0J
AD2It9nvw08Ydm8O1c8OhoQaiZuDsvxEN7tcW8YtDMYOcRLDG/iIPjVq2H16
FBx4J87VcOcj9nh2F/Sc4EDSsaj2jnV8xPfVY/H2Wgkw0So6fYugEMMzw12M
yhQw5OqF010pxEbL66T+xkeQnnJNMVqaQmS0jnltSv0blvyzXm5oIBMuqVKX
g1ozwMKx60SmF5nwWrVlxME3GwoOM8d2KpAJ7zAPX76cfBBU071b1UwiXq/V
UmwpLoRz4p6b9P1IRCMqsa6xK4GqmYyy5m0kAtHraBedyiHhy50/Qxkr+JgO
a3fb+koof1d+W31qGd/XfN6yxhCH9hcjQt66y7h2l29gHLkGZp7Jxr2MWMI/
ilxzgazXIJFoIcP/ZRGf+VSZwX1YD5ohodmGWxfxOVuLEf+xt3Dcm9CM8lrA
u8h+tzckN4LH+enqjtp5vCb+VgzFohnEwhklZ9fM4xoODrMtIa2QW7z52ZDD
HL7JNvfZ8MQnONypmXa1dBZXJzLTKJx/4CfJMGaBOotLyJV2Jbt3QYDSmZBA
iz94q0vEnfGwbpAx9mSLZM7gRss9MpO8HrBOTnPabDCNH/Hma1hd2AdLtzeY
eKRP4d+0Mj7+TvkJjy4k7aknTeGDVDy99ukg/NSKE3SrmMRlK4MaloRH4d6G
NZM1EpO45odAK6bLb9jGF90peXUCL75FxBaOj8PVpvCcapVxfFmaW+AVxgO+
ytKu4Mkx3D60+clzgWmQ+3TsbHTkKD5qqnWiKXIGzggGOmc2DOOKgS5P88rn
oNN95GYzqx/XUejazl5HQlRhqwH3yV6cvs7Of2cHCaln1JqJZ/7AjXQ+rwmK
JqOgzqSt5mI9eHKFiOKReQo6OySsMnDvK26wlX3cJp0PlW3sIynzOvFT8+QP
Rof4kd3d6Pxn//mEk5Uum/91mYpyE4bVp3Ra8ZU2df+YUSqazdYrhqIm3D7g
pA3pHA2F+GhdFDd9j8dbx44+bqAhmYf9bpmserx/13u8UJ6OymtjPfep1ODy
RLDtbTc6Sm0KnXyy/QW+46v/nVu5dPReamThPa0Av5/tvKzSSUfDoTslvvjF
47pVtkhjlo5YJQGmipEc9KjQ494HmgCSYjHz7ykVIEzp7d4YigCSC6+kG6pW
Is6gEhb+i47iXEvUg9bWoiuc9+kTr+goWTLU1jHxDZLZaVIqe5eOHlXb3T8o
3YicnevuZe2hI7NdKV3Rjc1I7b7m8J5OGjoRTJ+8E9mGxo2rH2ZfpCGs66O2
vmwHSiULrG+boSKVHQkBQsWfkdxzD6zgGhUttytLcNq7Ea3XOfmiGT/yjJ1V
21bSg/zuJN50KuJDLriNOXPpO/o4WtdtwOBDx1crprRE9CEFdsqkdQYZXRkf
Fjbj9SPrP61Ccl9JKOxDAbvZcgA9OdB4ZFqUhF4H7zvTJDOM7leLOkx0L4LW
orlcY9FvlEPP895wbQZUS3NPO4SMo48vDHLEp6Zg36UduXZ/TaBq7y3nuGwe
2HZq6tvETiJl3vmdSWXj4BpVzjl5gIcOCHzrVGkaA18D7R8WPB6qAgrmZzoC
j8oQ29R0Gq1LTfreXjwA2XknOwKmppE7ueVjfkU/lKZ77CyLn0EPdqh02n7p
BSI5PHRQ+w9yk5W3apL+AW+jM/vXd/9Bpi9ej1R590DbvVfo6O1ZNHw6dMn8
21f45t+V6Kcwh3RlrFN+UrtgylXUuM9lHjViZ4dzxj9BNLI27pdeQIb19nOB
d1pBXeyp8c/3C8ijNlA72qgZGnt+Gw+wFxGPbRdUEdUIlwq1jw2qLaHIvVPn
H/3bD8adoGND35ZQt8tYUkRmPWSZNR0bfrCMAtNPRqiVvYZD8tImv3RXUIvV
lvJda2qgn+doMjK5gl53fNv+jxcOiJKutuoICRtYdb6nPqISQhkSWrlpJMz9
ydlYPXEudIjf1dGfIGF7m/veb5stAXnpP7o/9pOx8oOGvu1/FYGb/AUDdhwZ
83dU0qBHP4dK1c/G64bI2DvG+dFe/RygaxqeKNahYDuq989W3MkE832Vp4wj
KBjvQ5bVsmY6XCg8UNo0QMGU9/pofFn3GHy3NDLNdfkw6sTQ4U0dKcBJtrzw
KYkPk1610ueBEiBb7Psryyk+zGTQUDHQjANEkIt051F+bNQkKth//gG0z/M8
bTL5scuSllFV+mEw4sZu7CZRMROuVIOdTzBQ+mnKdtZUDLWe41FdA+AkyBzR
K6Jiu7il4d8l/KEgfu8VeQYNm9PJ3n013AfoE2Yc/nM0LKp22Qk+X4PThpe4
/RU0TFZrS53NiDuU/h30pW4VHauUudmyyfQyCC+lkbKc6ZjTGlaI+YATOFhw
Fe69omNrQu7+2etqD5XPmw1cpASw+2yTOg3fMyD2bDfP8aIAJq25dr9W00lw
eJKcavdSALt26+wtyfUngJtMMrAVFcQG13BrnDRNQTjWcdLKThDz/g/3+ei8
EZyNeJtyvFgQ60pV1ZQvPAQlwTv0TagMLMjCMP2FtR4I3OZMGFkysI0axzjk
VBbY+Mwl6z9jYF1SOnaerX+BT49XogpFCHvSvmI2X6sBCYem4kROCWHedZsO
Vnlvh7Jcd854sRBWYyLeECGmBG3iv6NahYWxyzHBSGVFFiavX4oscxTGgl+c
WzyyIg1i34bCEquFseTawu25pRKgdtDp/q21IpjJ1uTVG9+IgVFOX/CZKyJY
9j7xYuWvgkBxNYkyrxHBCl0V32QZ8ANXvSpJfw0TS7cvWlKoXGG58pTSdc4z
MaeEkD0DxCxLoSwmbweXiQksazSe0uOxOq+vlMkzRLFjWftzSntHWVE6F4m1
NqKYbp/5zn9kB1gGy+0NQvmiGL1/rmik8zvr/3+Lfb9ul5HP7mL9F0BdPPw=

          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1AkfwMc5ZowZZ7GtJ1ISrdu2rs/3SwppEdKsK2LIkYYo5VokIrXG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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk7lGsDgMcylsHYibGmEGUp04Lned8QUvYtskcclS0pshTJPrLGkFSK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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMBy75fe/XnZrOWpz2dd/1w7/2O4b8fholnyAcNXte
urzH1/2P7RPrq+tdxIsu9K7ep/Vhf5TXg3MZNx6J3yp8U33R9un+6yHPtyy9
9VA8sW3SupVHr+7PKPJleGX4RPxVt6Honfrp+7/PeJiWYPVEPLSd/VNT/xV7
Be3uE5/NL4iHCKvOudT3xP7wkb9G7A+PiJv+CVY6t+m9/a/t1TxR7x+JL9hm
XxsY+NV+0sqP6uGf+sW/5PH7Pcn6Ze8blLrMTWqJyNPPqQFvPv23377lBhP/
sW0cwTa7o/36mBxg/mN6yqaRGMUK5+9ef9EjS5IDzo+p+jnbfSUXnO+9+kl7
fAEvQn9ewMTgQwj+DoM9s9xF+OB8lW2T1+rvQPBvVfzfpszFD+dPtM4+IB6D
4Hv8u3aSex2CD00PcD4AHWO9dw==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vk7lAsfgPExlmFmzEhSjrc9JWpoceoU3+fRNirZsxShDCVZOlrssjTZ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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vc/1YsfwPFjHMfhOERWVJLKKFTc3Pi8Px8qMzOhqIxEyLpGN6mshIvI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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMBz5fNaztW7OEtTjt677rh3/tt0jOKZriMkc4ava8
dHmPr/t9BH2/OP1oFC+60Lt6n9aH/fFRJ/bEtSpI3Cp8U33R9un+EJWz7hd8
5SUS2yatW3n06n7N7h+rnLYoSrzqNhS9Uz99/wzWfXfX7laUCG1n/9TUf8Xe
7fGPF1vyeSRChFXnXOp7Yt9898rKY75MEqZ/gpXObXpvP7Fm7uTqmQoSC7bZ
1wYGfrU3SbPUXsh4RvxLHr/fk6xf9imrl6/vnP9Q5Onn1IA3n/7b3736avPv
b585gm12R/v1MTnA/Mf0lE0jMYoVzt+9/qJHliQHnB9T9XO2+0ouON979ZP2
+AJehP68gInBhxD8HQZ7ZrmL8MH5Ktsmr9XfgeDfqvi/TZmLH86faJ19QDwG
wff4d+0k9zoEH5oe4HwAp/K7fw==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vk/1fkewPHjWA7HWYyyDYZiKLJO2+R4f7+ZSqlRlkJUlIOMkGRXsiah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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk7lHsfgGeGmWEwpChpsUaUJDpF8/k+tBAlSyFRCYmKRJQaFKJsYexL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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1AkfwMc5ZowZZ7GtJ1ISrdu2rs/3SwppEdKsK2LIkYYo5VokIrXG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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk7lGsDgMcylsHYibGmEGUp04Lned8QUvYtskcclS0pshTJPrLGkFSK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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB/QX74hqLf4mXpz2dd/1w7/2txfmda3Y9E41ava8
dHmPr/u/vzl8ZlvzZc2iC72r92l92M+ondL94UOh1q3CN9UXbZ/uvytx3Sfq
f4FWYtukdSuPXt2fsMWJ+55lsdarbkPRO/XT9ys3XGx441isFdrO/qmp/4r9
RuFk4bqHcVohwqpzLvU9sd+2UCJ5yoNgLdM/wUrnNr23/7Aj9t9xtiKtBdvs
awMDv9qvlWd4/TlTTutLHr/fk6xf9mF+S9ljlY3Vn35ODXjz6b+91CGxI2Hr
XKWDbXZH+/UxOcD8x/SUTSMxihXO373+okeWJAecH1P1c7b7Si4433v1k/b4
Al6E/ryAicGHEPwdBntmuYvwwfkq2yav1d+B4N+q+L9NmYsfzp9onX1APAbB
9/h37ST3OgQfmh7gfADeo7pN
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vs7lGkDwPExzGjGmFHjkOQwj0NI2HZ5W3LfD2pJpRxKJYUMJYeUpFTW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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vc71W8DwPFjO8MhIiNlrwoJycl9f4yQMkKIJEKiL5H1FTIiI0TISill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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB9StrmguWGcsUZz2dd/1w7/2qzLerkh4qaUWNXte
urzH1/2ftW6e65YW1Cq60Lt6n9aH/RzsrcbPStZr3Sp8U33R9ul+tcrXtwPP
rtVKbJu0buXRq/vXOxQcOHdrg9arbkPRO/XT91dMV7hy7+EGrdB29k9N/Vfs
bdkfWOYLzdYKEVadc6nvif3k3lTdrzkTtUz/BCud2/Tefk/Pr3OGs9drLdhm
XxsY+NU++WFJy+KVUVpf8vj9nmT9so/u4fcROV6g/vRzasCbT//tz8gemniY
sVk62GZ3tF8fkwPMf0xP2TQSo1jh/N3rL3pkSXLA+TFVP2e7r+SC871XP2mP
L+BF6M8LmBh8CMHfYbBnlrsIH5yvsm3yWv0dCP6tiv/blLn44fyJ1tkHxGMQ
fI9/105yr0PwoekBzgcAbHa5wA==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1PkfwMc4BnOaGVRqKSWNkg4d4vX+VMqgyJHkqBSRylFq2yJXohTb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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk31P3/h8cyhhmG7JIiKlGWaLG9nm+UrbKvo+xEuaksdVeSEBLCyJpU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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2q8//5HdWodPrFGz56XLe3zdzzRD
ee0Zk+ucRRd6V+/T+rB/Uc4EySuhpVy3Ct9UX7R9ur+Dy/1Kp1kJV2LbpHUr
j17d330+o+P3nTKuV92Gonfqp+8/pLdYa8KzMq7QdvZPTf1X7G1NPSXbYpK4
QoRV51zqe2LPenP5buvF4Vymf4KVzm16b28TcCb0bH4p14Jt9rWBgV/t5fy7
44tElbi+5PH7Pcn6Zf+opnW5xSEz9qefUwPefPpvD3N/sM3uaL8+JgcYn+kp
m0ZiFCucv3v9RY8sSQ44P6bq52z3lVxwvvfqJ+3xBbwI/XkBE4MPIfg7DPbM
chfhg/NVtk1eq78Dwb9V8X+bMhc/nD/ROvuAeAyC7/Hv2knudQg+ND3A+QBl
r66K
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vk/1PsewHEGgzELisJVlrLlIEUR7+83hCTZQiiUSZajlJwSKmv2SEIo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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnc01Y//xy8u17WzElpGSEVDGb1f7zcNlJWEQiE3koh8VAoJISszKzKy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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB/QX74hqLf4mXpz2dd/1w7/2txfmda3Y9E41ava8
dHmPr/u/vzl8ZlvzZc2iC72r92l92M+ondL94UOh1q3CN9UXbZ/uvytx3Sfq
f4FWYtukdSuPXt2fsMWJ+55lsdarbkPRO/XT9ys3XGx441isFdrO/qmp/4r9
RuFk4bqHcVohwqpzLvU9sd+2UCJ5yoNgLdM/wUrnNr23/7Aj9t9xtiKtBdvs
awMDv9qvlWd4/TlTTutLHr/fk6xf9mF+S9ljlY3Vn35ODXjz6b+91CGxI2Hr
XKWDbXZH+/UxOcD8x/SUTSMxihXO373+okeWJAecH1P1c7b7Si4433v1k/b4
Al6E/ryAicGHEPwdBntmuYvwwfkq2yav1d+B4N+q+L9NmYsfzp9onX1APAbB
9/h37ST3OgQfmh7gfADeo7pN
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vs7lGkDwPExzGjGmFHjkOQwj0NI2HZ5W3LfD2pJpRxKJYUMJYeUpFTW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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vc71W8DwPFjO8MhIiNlrwoJycl9f4yQMkKIJEKiL5H1FTIiI0TISill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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB9StrmguWGcsUZz2dd/1w7/2qzLerkh4qaUWNXte
urzH1/2ftW6e65YW1Cq60Lt6n9aH/RzsrcbPStZr3Sp8U33R9ul+tcrXtwPP
rtVKbJu0buXRq/vXOxQcOHdrg9arbkPRO/XT91dMV7hy7+EGrdB29k9N/Vfs
bdkfWOYLzdYKEVadc6nvif3k3lTdrzkTtUz/BCud2/Tefk/Pr3OGs9drLdhm
XxsY+NU++WFJy+KVUVpf8vj9nmT9so/u4fcROV6g/vRzasCbT//tz8gemniY
sVk62GZ3tF8fkwPMf0xP2TQSo1jh/N3rL3pkSXLA+TFVP2e7r+SC871XP2mP
L+BF6M8LmBh8CMHfYbBnlrsIH5yvsm3yWv0dCP6tiv/blLn44fyJ1tkHxGMQ
fI9/105yr0PwoekBzgcAbHa5wA==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1PkfwMc4BnOaGVRqKSWNkg4d4vX+VMqgyJHkqBSRylFq2yJXohTb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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk31P3/h8cyhhmG7JIiKlGWaLG9nm+UrbKvo+xEuaksdVeSEBLCyJpU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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2q8//5HdWodPrFGz56XLe3zdzzRD
ee0Zk+ucRRd6V+/T+rB/Uc4EySuhpVy3Ct9UX7R9ur+Dy/1Kp1kJV2LbpHUr
j17d330+o+P3nTKuV92Gonfqp+8/pLdYa8KzMq7QdvZPTf1X7G1NPSXbYpK4
QoRV51zqe2LPenP5buvF4Vymf4KVzm16b28TcCb0bH4p14Jt9rWBgV/t5fy7
44tElbi+5PH7Pcn6Zf+opnW5xSEz9qefUwPefPpvD3N/sM3uaL8+JgcYn+kp
m0ZiFCucv3v9RY8sSQ44P6bq52z3lVxwvvfqJ+3xBbwI/XkBE4MPIfg7DPbM
chfhg/NVtk1eq78Dwb9V8X+bMhc/nD/ROvuAeAyC7/Hv2knudQg+ND3A+QBl
r66K
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vk/1PsewHEGgzELisJVlrLlIEUR7+83hCTZQiiUSZajlJwSKmv2SEIo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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnc01Y//xy8u17WzElpGSEVDGb1f7zcNlJWEQiE3koh8VAoJISszKzKy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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB/QX74hqLf4mXpz2dd/1w7/2txfmda3Y9E41ava8
dHmPr/u/vzl8ZlvzZc2iC72r92l92M+ondL94UOh1q3CN9UXbZ/uvytx3Sfq
f4FWYtukdSuPXt2fsMWJ+55lsdarbkPRO/XT9ys3XGx441isFdrO/qmp/4r9
RuFk4bqHcVohwqpzLvU9sd+2UCJ5yoNgLdM/wUrnNr23/7Aj9t9xtiKtBdvs
awMDv9qvlWd4/TlTTutLHr/fk6xf9mF+S9ljlY3Vn35ODXjz6b+91CGxI2Hr
XKWDbXZH+/UxOcD8x/SUTSMxihXO373+okeWJAecH1P1c7b7Si4433v1k/b4
Al6E/ryAicGHEPwdBntmuYvwwfkq2yav1d+B4N+q+L9NmYsfzp9onX1APAbB
9/h37ST3OgQfmh7gfADeo7pN
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vs7lGkDwPExzGjGmFHjkOQwj0NI2HZ5W3LfD2pJpRxKJYUMJYeUpFTW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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vc71W8DwPFjO8MhIiNlrwoJycl9f4yQMkKIJEKiL5H1FTIiI0TISill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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB9StrmguWGcsUZz2dd/1w7/2qzLerkh4qaUWNXte
urzH1/2ftW6e65YW1Cq60Lt6n9aH/RzsrcbPStZr3Sp8U33R9ul+tcrXtwPP
rtVKbJu0buXRq/vXOxQcOHdrg9arbkPRO/XT91dMV7hy7+EGrdB29k9N/Vfs
bdkfWOYLzdYKEVadc6nvif3k3lTdrzkTtUz/BCud2/Tefk/Pr3OGs9drLdhm
XxsY+NU++WFJy+KVUVpf8vj9nmT9so/u4fcROV6g/vRzasCbT//tz8gemniY
sVk62GZ3tF8fkwPMf0xP2TQSo1jh/N3rL3pkSXLA+TFVP2e7r+SC871XP2mP
L+BF6M8LmBh8CMHfYbBnlrsIH5yvsm3yWv0dCP6tiv/blLn44fyJ1tkHxGMQ
fI9/105yr0PwoekBzgcAbHa5wA==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1PkfwMc4BnOaGVRqKSWNkg4d4vX+VMqgyJHkqBSRylFq2yJXohTb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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk31P3/h8cyhhmG7JIiKlGWaLG9nm+UrbKvo+xEuaksdVeSEBLCyJpU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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2q8//5HdWodPrFGz56XLe3zdzzRD
ee0Zk+ucRRd6V+/T+rB/Uc4EySuhpVy3Ct9UX7R9ur+Dy/1Kp1kJV2LbpHUr
j17d330+o+P3nTKuV92Gonfqp+8/pLdYa8KzMq7QdvZPTf1X7G1NPSXbYpK4
QoRV51zqe2LPenP5buvF4Vymf4KVzm16b28TcCb0bH4p14Jt9rWBgV/t5fy7
44tElbi+5PH7Pcn6Zf+opnW5xSEz9qefUwPefPpvD3N/sM3uaL8+JgcYn+kp
m0ZiFCucv3v9RY8sSQ44P6bq52z3lVxwvvfqJ+3xBbwI/XkBE4MPIfg7DPbM
chfhg/NVtk1eq78Dwb9V8X+bMhc/nD/ROvuAeAyC7/Hv2knudQg+ND3A+QBl
r66K
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vk/1PsewHEGgzELisJVlrLlIEUR7+83hCTZQiiUSZajlJwSKmv2SEIo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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnc01Y//xy8u17WzElpGSEVDGb1f7zcNlJWEQiE3koh8VAoJISszKzKy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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB5rWsW4I6hTgKk77uu/64V/7u7Q697jNYZOImj0v
Xd7j6353KYeNmvvfSBdd6F29T+vDfk2PT6XXcrtkbhW+qb5o+3T/XM9lPF85
O2US2yatW3n06n4Xgzr9xKAemVfdhqJ36qfvN5ifk2Qf1yMT2s7+qan/ir3T
kRUzj+4rkwkRVp1zqe+JfWf8iuJv7rkypn+Clc5tem/vPnmbEXNfl8yCbfa1
gYFf7f8+1Vy+M81M5ksev9+TrF/2ottWrrQy9JF8+jk14M2n//Z2YZtm6X6I
5w222R3t18fkAPMf01M2jcQoVjh/9/qLHlmSHHB+TNXP2e4rueB879VP2uML
eBH68wImBh9C8HcY7JnlLsIH56tsm7xWfweCf6vi/zZlLn44f6J19gHxGATf
49+1k9zrEHxoeoDzAe91tQI=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vk/1PkDwPExxtxm5CpJchQrYdtq2+T9/qQ2R5YwHY4ORSRGtToodLBu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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc71X8fgI/tHJvsSCFCRkmF8/p8KDPZI9JOhEhRUUR2yupkp/m1yR4Z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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB96z/tdN+OfDVZz2dd/1w7/2C3KybY665CwRNXte
urzH1/3HtwUo1BpryhRd6F29T+vD/rA5f3gjtI/L3Cp8U33R9ul+p+QVrdGf
j8oktk1at/Lo1f1NM+Lz5a+ckHnVbSh6p376/krRac/b7p2QCW1n/9TUf8U+
zPxy3IwPm2VChFXnXOp7Yn/ehak4a/VKGdM/wUrnNr23D3R68qDH/bjMgm32
tYGBX+2530vUZCwulvmSx+/3JOuXfXZ+xCL+7R2STz+nBrz59N/+tLvPk93/
Z/MG2+yO9utjcoD5j+kpm0ZiFCucv3v9RY8sSQ44P6bq52z3lVxwvvfqJ+3x
BbwI/XkBE4MPIfg7DPbMchfhg/NVtk1eq78Dwb9V8X+bMhc/nD/ROvuAeAyC
7/Hv2knudQg+ND3A+QBBkLkM
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1PkfwMdtxhiaRetrVWprrQpbX21kXp+PCB1LmCi3ashZWtUWsSUp
TCI0jqyrUHKOcQw+b6mwyhnlqJDJkZQrx8yw+308vj88H88/4fnUOn7aliVJ
IpFi/+V/XkF7u1ZXlZDrtc9T8ffCYEv2y7HJx0qI4NTPX066AlYRR1d6nZSQ
88GqTEZMOJz3+vBdI1kJBWWPsancCEjfH/Azt4KGCuwN1uyi34DnW5cgk0VD
3pPa9daPomBK8Rrz1nc01DbpZ298jQ1qX2k+wfWK6FW2mtFam9uAdSaHnTqt
iFqDTe4fkYmHdAvq3gA1RbRmKPtto0ICiGpCpYNqqYhjbM3z35cEjjumn188
SUXFIQMeF3kcqMw9cTNMgYpOnDNXdj6RCmqaPQcjShWQ0t3AseeH0+FcvCUt
+pgCCr+p2dtdnwE7Lm+/k5RLQQeLik5f8MqBBFtm2xUmBTmO8PEa5gOY/ylY
wV+Cgr6k7j7U450H9uJMi6OFZMS46Otumf8QKjubwk2dyCjzh8atBaqPQT3v
C6ErT0YO5okOJSVFcOmymki9XB79ThLuouElwNA+GfSVJo+eLTZ5tLhxwVVd
KAiplUOFoW1iczoPQinxDmQ/OfR98rHE1OEKSBdqNyf+Rw7V/pUVZtxZBXWT
hNHGZln0/vUv5zKH+fDurX1B4QVZ9EZO5tA+1TpYaf2suWeLLBLfKD7QaYAA
SjQkmOEy6C/C+X7D0yeQYJCyfklHBl0KUqrevf8pfKr6HtI7pVFb9hid8fEZ
cJ6oBo9pSSP6a0+fGP9mmDJPSGY3S6FMveipuGMtYNZCr9wRKIV8VNI9OB4v
YbpLaT4ESSK+oVEMc6QdDlTuZcsFSKK5lSvH61c7ICft3OZ4DUk0qS7rEKXd
Bfas/iO55yWQRley/mpWNxTvp0398qMEMhkfeSye6wGyrsn1mg4S0rjquEbE
fAM13x7wOraR0LLr5PWdWD9wBq4ujD9YJaTlm4X0TwNQ0VJxRX9uhfB1Mho7
kfsOvuVrJdXeEhPPiuICmdpD8LvnfN3rhmUCpoOKHHUFoMymcN1VlokFEzOH
UuOPUFC2Pn/85BLBH2AFM21G4SPpwB2hzCLhmn/h58/R4+CYmu613nKeMNPP
3udrOAVn29mP6nS+Euz7kfS7ObMgxS/vj5yZIpr2VanzsTnY2G3tHh/7mdj9
5E8r1d45cCNf885tniDsxJvfFEh/g9BN66ZKPMeJBhZzr3zSN0hjVJ6tkRoj
DurZqr/etAB9gZPBHQwBYZByhqm4cxFkqEdHA2c+EHGaqqEGjxZB/0GDLT13
mMgLjZz4e90SRPSl/GynPEgYSgp2T3xbAvdxqs7ozbfEKj0OOhyXgac5QtKe
7SN23bJNGaxcBo/r8YX5z7qJrts3JI4dF0IBZ0J/bk8X4fj0WtarR0JYfLi3
DErbiXxP0zfcKSHcuGTgS7d5Qbg2Ge96riOCDX8JTucyGomwYbJZn5sIKhoS
g4x1nhAp0+ZVjWwR3GuPnsnaXk2sa1Au8+GK4IX6pPCFbDERUMUfzukSwUT0
L6oDYXcJaf/T5S6fRMDghttsjk3AnF+RX0eKRKDOoBXe/KkY675YvY0nLYaN
bL7cga18zDT75dohKTEkBXD1I9Y2YL6zLa7kZRGkqkW7sJKbsDMM8227R0WQ
UecRtU+jFeO3pZHCWkRguzOtP761AytWG0paeCCCI5FyM1djX2FZLGptw0UR
4P1tRhZar7GI42AzZiECHT1OuEJZL1b3dLqmhSYClXD3F21mAxilaNgntVUI
Kz3aqgk977DfW65qREUKIShxUXcbdxBjV27MajMUgg/hbEcTD2GsdROpeYJl
YH63Oa3z1gh29nFAoObWZTjzdYJqOyvAMk51PAyuWYKYl8WXOxxGMX6Bypcs
iyV4Gmns1r5hAjucwzgzemgRDER2G1tLv2AXQ0Jx3fXfYGt5gevJG1+xswGN
5g7seTD20yvw+HUak1rs6+xanAOXvv9aOCfOYKlNvdoXmmchg4ddtrGZx2S0
qBIfnadhLkDJasRnGRMH+jdt7x+HeMzRSqAhxNzc9Sx3VIyBvvJ9q48vhJh9
rql+CWcU/EqMrMd0xZivVt2FLn8BUK5GWI+/F2ORsu9ovx4fgTzbduuJ2yvY
SMbg7USXDyCYZR2enFnFvAYT6DY+Q4BJ5uiuOUTC+Z718TXRgxBNUTUoSCfh
O4ropXNe72GTxoLJsKkE/mnhiW/KjgE4vemU5eUkCbxwePWk1OM+4G/ttfp+
XAJ3GDTKizXoBTtjvpPVLUn8rVBRRz6wB06VmJW3j0riRS7BuWny3RC6pZVm
ZyKFG3wg2YcUd8FD5aF6hzkpnO3aeZ6h3wEowkej7zdpnHfWwfCOXDv0LM8G
OedK41tc3d8wBl6CpEBW28NRBjeIqEiqbm2GY7Dh0N5SGXwysVrly3IjFN81
PLOJIouvOh0UuJs8B7lp2wTp47I4bnZqYGfmU3A94FcpqJLFS9UoGhHqDVCe
HTHwfI0croKwFL/8eqCK00l53nK44oHhjBVrBPyiDksfdXk8YSSW3lnNB+X8
XbMsX3l8sXe0Nia/Ck5mpd7zqJXH/whL63WsqoDKVJKlixIZv3MuhlM7Vg7U
RNbMUQ8yHvIDp9FoFxfcb/2dxiwj4ztf+iy7ZJQCN1LP4rAMBR9ezEuu2lwC
zpeWUi3yKXh3mX+/2lIBXBo8n6wjqYAP6kdV46yHwDGfS1J0UsA9kz+4XZPO
A15BYMLXMgVcs+RzJa/rPryif4nrolLx7oVzfX+3ZcPMH36xPBYVF/259Llz
PhOU34/HJNdRcaardx/JNAN093lFhaxVxKX2SDj95n0PDj4aiXQ7o4jv5HIT
/W+ngGTA4Ti7J4q4u/U2/mHtf/utX5NioULDs95uSF83kwgBsz/l7PGk4Vqy
Cfe8Ju7Aj7w7j/UqaXiFIcdmXDEe+v5Y5W2iKOEev64pYx+7DXF7fNFaZyV8
yjKW8SqBDZYrPc0KhUq46bMrgSH8KPj/3+Ah2T94C7RuwD/a0W+l
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnk4lPv/xscw1pkhhhJFWghHKlow78+TbKlklyXkUEqRks4hlDUHiex7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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vk7lAsfgPGZwTBjDJVE0qJNSFLqhPk+DynTiBhS2ZVByFLaLCmayDIi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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk4lAsfxsdYxjJmRJEloYUkFE5ePP/nISGV7IQikbQghEOT7CSECWPk
6JClkGwp8TyoLEkpUZI6HTuJsSfj7b2u98N93Z9+H+/fdSu6+1p7kkkk0oPf
+V9zCaN36+t0gsE5Fk056InszH81NlVGJ3R5RlitTecRixhH7kdnOrHHli2l
K+aPBHn9K9EqRCd2VrUF5/gHI7mHfHZVP6IRndry/BrOV5EXu1fgjieNUL0S
ZUdnRSHTotG2yRI0YmYh9ukrgwREcoZ2LqxJlOgOMxZe0L6JoG9Z4Wd9RQk+
vwfvbzQzkVxTqpGPpCjxLG6fI684G/n19CpfYAOV+NY1ckA16w7itG/2xZ8e
VOL5ZrypsrMQqSs6nRAuQiXe7lxz7w8oQyS39B6OqRQh3Gw6gzoXK5HLaWa0
xOMiRNxGUHN2rEN6KPVvbpJECNPbNdweZRzZx9iTnlEkTNRgGYJZX1oQprXt
6whbYeK0SRXO/tqGLCiHiVzkESauimqkhdJeI/Zrd0wdy4WIxbsu5Qp275C6
t21RB5yFiKfN4ZZ9pA+IdPEPXF1QiKjIcp0sq/uMhDIkf0nXCBINnZMDnce/
IQPWiC6/uyBxRtKwzII1giAqHoEzNEHC1I0dt6dpEjkpvTp8pYFCuJUEkUSn
Z5CrwmkOQhcoxGYZehuTNY/krqq035KhEGgU75319WWkcQrXU2oXIBqVNWSq
jLjI4Gf70vJgAcLquOU2BWMycLu+b9HfKUAwU8rko7n8IE9Ep7T28BPyDjJN
i97CAA9leWyj+AnhZZ+f8fl0YOpkb11R5Sfa8xVl6BoSMPl4M+S+5SOKtfLq
tfZKgRFkuhwI5SPkTZO67s3JQlbzprAxRT5C4s7BxXcdCjBtwmQltfMSNWFI
r+6W7WD8Urxu3yVeQiuG3DfApwLZx1J7+zbzEn0XZNNWMtVg9h194QpBJpxa
OIElS5pgXmeURPEhEzf1vlyz7NeCgpzLO9JkyURku/GmfNX9sHatuEGunYfg
2iwJkhf1wN7zk11REM9vvv0SxxyFikO06b3beYh8rFIvVc4IhNQNY592k4jR
2fuHa8aMwV08UN40nEQ0De4PHhY3g6eLhbXdaiRivNGq52HBYcgaiFwaL1zH
l56kT37isYRHLx9FaM5zcZ9ieshYqDX0PpkSCTbk4ncDoS/F2A4WSxQzGpLX
cMtEf9LOM46wiWWvwDfwCw9RkbXaN+oM2vGJ98x3/cKpQuPyJ167gm0woZ0a
tIpPmZym7JFwh4AzC419LT/xbCkOc/RPDxBLEq522/gTt4wSv3JP3AtKq7aW
jHus4A91PxQnTHrDoX7tXP+aZXxD3JTVU8pFGCGZp6/yL+Oxnw51yur4QZSy
a3y0/RJeH6vh3yXsDwoWgQzRokX85Wt/QkIgEJzYuV5bzRZwdzaJy/QLgbUI
OcuAgnkc+37LKKEmFPLOZuu2kuZxOxOvv6rlGDCikyHk+5iDr7lFLdFUIiBB
biOneRMH76d1yHkkRYIab1q/pP8s3v5SzMuAHA3+b5LuN6rO4Mq8uSuLknHA
W1/zKY4zjQ/2rp2mf4gHpffH3NJSvuPTZ/UxocLr4CoU7V3UPoGbd1SfN3BL
hv5LU2HdyDDunthuPEhOB36q4+glzr/4D+/pni1D6aBZ2GItXvQNv3emiNet
iQkx/dm7bMS+4uGPTjCsz2WA2zhVdTThM+5fcbBJUysTarcMkVTm+vHoJcbZ
y5xMOBWbVl7y/D3+2EKuq9OCBaVZE5rz+u9wp1nl/3iPsGD5nlEVVL7Bj1zQ
GJryzYb4UJ3z4laduFaFxi+biWxQ+GvYtwhpxTVvXpGptmXDo5ZbgQaqzXhh
Qq0GWs6G228SOX/veYILBoGcySIbOqWnVjsFKvCIgwETemo5MJG4d9NAeCae
+4WZV3ksB5DqKKsdKUz09YsVmHPLAWmEVp6gXIEKNC9+m3fOAaWkeor57no0
DaQPtWA5kOFTrRkj1YIOe6sfyKXnAFsy8YQnqw3tjxlqXG5jQ17jqesHZbvQ
qcajAsEX2WCtlfMprasbnbBqPzC1lg12cRROZEoPetS41d4hLBuwT6/1TBX7
0OdDoYP2syxQ1ciKEqn6iGqYerK7HFnA7VXZxOwdRLs2fvdpJWVB4K1ldbXq
r6howWeF1gOZcA53saGt/YPmNjXe1GZkgK3Ejpy3yUPoJT5G2asPTPCbmaBa
zw2jpdpGXYqT6XDjVQWj22EUTVCS6OpYToNncQaubxQm0NHLOjKfqamg88tG
qavyB+pdVLAjPPY67K4pPekRP4PenXmZUovHg8EFjdJT+2fRYMPv3Bv8cXCi
X9vU5RYHpXKS9f5qiAKf1EfM48Zz6KxEk2Pkvki4aqb3zX5uDuWr/TvC9vE1
yKtFGVZWC+ju9OKABW4Y3Cs73hc1v4AmuJ5QlS/5E2oKAvbWZi6iTk5tTg6X
g4FgJyWO6S2hJlvedyacvgwdaUXDMoNL6NdbGR9PBgRAT0ITejRiGe3hF/3H
pOASfLn2iRW+fQV9YhD2fH3CF+Z96BZD536iWOpztQ0T3pCGOlkMy66iHwdr
FXVFvEBT7K7FSOcq6q5rvTv9ogd0ff1hMcr4hW4Ndh25I+oOFx7qHRtTX0Np
tdjRyN/+EI6MOTb+ZQ29E2qZFzDjDMXWb45N3OSiCWs6ITlBjmCyTdZy0nAd
LYvcqHXDyQ6G5zwtpzjraJ7Zg4RZpjWg5AL1DUdI2AMZKXV7E0tIFN6kU5pL
wnwKk5hhPkegTzxW33SWhHmvxo4nPzODbbJLht8O8GAJU3hQfvRB8N121oyR
wYMZz1RbrRcYQf3ujxabx3kw+uy2lBA5DCja5nZV+mSMskyTmXumDzYG9c4W
yWRswuMLm39wP5x9aFzzZpSM8U3GZZbt1YarO7toNoa82NJ3XBEE9wKT7XD2
fTYvNpvMe30gXw3uif3T5DDPi3mQKs/9XjIQMedk+4/yYUcw6p63otuh9+dc
oEsRH9ZhEDdws0oBpnwZXYMkfqytaHxZql4WyMMCKqec+DG8PO0+eU4SjoPC
EaNKfuz06cGa9nVxqMj8j982YQHsWYzQo8cudKDMWjP53AUwFlfhkGeXEJw0
v1A3/FgAcxg16WXs5oea/JiBFxsoWGmtvOxhSx6gruWSir0p2P00q7zn+r8Q
D/u67QlNFCxmf6ssNreI1D/oNjsnLYgpoIYOh1gcRKzkjznP84LY8bv20TqM
acTjb/btUw2CWGurn8btqTGkjk0yO0EXwgK8xIL/sB5CqLc8OY6nhLA6n6BU
7diviFtyR45tlRBm5aTk4fmqH6mO0zC15BfGKCejUj+WvUcEI5izhx2EsT1G
zDlZRjfiErrCNi0RxkgTedwj2zuR0K9BLFWyCFYwJtexS/UFkmUynyHqLIKF
WLfskPZqQmpLLzFnqkSw9IhiXBrqkR7xH6nvqFRMlBy2v8qwBuGEXEip9aRi
Zz6nZrbHVyBiX8ZvsBqp2I5ZIvVUQQmiftDr+hUpUcy/IlfJ4m0+cvj+UJyr
nyimJM+NiLiRi5B9LFNtmkUxtDJsBV3IROo0n2abbqRhelF1caYNaYjPnHKB
/hkaJr3zammzQRKyvTa9TKOOhk0Xh9T74rFIf8h67TZhOjYh8NHic2EEkqp/
npByoWM/XSOfRVuHIWbc3naRcjpWt8F3x7DkZeT//xarWfm2FTHwQ/4Lzvc0
LA==
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB5rWsW4I6hTgKk77uu/64V/7u7Q697jNYZOImj0v
Xd7j6353KYeNmvvfSBdd6F29T+vDfk2PT6XXcrtkbhW+qb5o+3T/XM9lPF85
O2US2yatW3n06n4Xgzr9xKAemVfdhqJ36qfvN5ifk2Qf1yMT2s7+qan/ir3T
kRUzj+4rkwkRVp1zqe+JfWf8iuJv7rkypn+Clc5tem/vPnmbEXNfl8yCbfa1
gYFf7f8+1Vy+M81M5ksev9+TrF/2ottWrrQy9JF8+jk14M2n//Z2YZtm6X6I
5w222R3t18fkAPMf01M2jcQoVjh/9/qLHlmSHHB+TNXP2e4rueB879VP2uML
eBH68wImBh9C8HcY7JnlLsIH56tsm7xWfweCf6vi/zZlLn44f6J19gHxGATf
49+1k9zrEHxoeoDzAe91tQI=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vk/1PkDwPExxtxm5CpJchQrYdtq2+T9/qQ2R5YwHY4ORSRGtToodLBu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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc71X8fgI/tHJvsSCFCRkmF8/p8KDPZI9JOhEhRUUR2yupkp/m1yR4Z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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB96z/tdN+OfDVZz2dd/1w7/2C3KybY665CwRNXte
urzH1/3HtwUo1BpryhRd6F29T+vD/rA5f3gjtI/L3Cp8U33R9ul+p+QVrdGf
j8oktk1at/Lo1f1NM+Lz5a+ckHnVbSh6p376/krRac/b7p2QCW1n/9TUf8U+
zPxy3IwPm2VChFXnXOp7Yn/ehak4a/VKGdM/wUrnNr23D3R68qDH/bjMgm32
tYGBX+2530vUZCwulvmSx+/3JOuXfXZ+xCL+7R2STz+nBrz59N/+tLvPk93/
Z/MG2+yO9utjcoD5j+kpm0ZiFCucv3v9RY8sSQ44P6bq52z3lVxwvvfqJ+3x
BbwI/XkBE4MPIfg7DPbMchfhg/NVtk1eq78Dwb9V8X+bMhc/nD/ROvuAeAyC
7/Hv2knudQg+ND3A+QBBkLkM
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1PkfwMdtxhiaRetrVWprrQpbX21kXp+PCB1LmCi3ashZWtUWsSUp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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnk4lPv/xscw1pkhhhJFWghHKlow78+TbKlklyXkUEqRks4hlDUHiex7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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vk7lAsfgPGZwTBjDJVE0qJNSFLqhPk+DynTiBhS2ZVByFLaLCmayDIi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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk4lAsfxsdYxjJmRJEloYUkFE5ePP/nISGV7IQikbQghEOT7CSECWPk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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB5rWsW4I6hTgKk77uu/64V/7u7Q697jNYZOImj0v
Xd7j6353KYeNmvvfSBdd6F29T+vDfk2PT6XXcrtkbhW+qb5o+3T/XM9lPF85
O2US2yatW3n06n4Xgzr9xKAemVfdhqJ36qfvN5ifk2Qf1yMT2s7+qan/ir3T
kRUzj+4rkwkRVp1zqe+JfWf8iuJv7rkypn+Clc5tem/vPnmbEXNfl8yCbfa1
gYFf7f8+1Vy+M81M5ksev9+TrF/2ottWrrQy9JF8+jk14M2n//Z2YZtm6X6I
5w222R3t18fkAPMf01M2jcQoVjh/9/qLHlmSHHB+TNXP2e4rueB879VP2uML
eBH68wImBh9C8HcY7JnlLsIH56tsm7xWfweCf6vi/zZlLn44f6J19gHxGATf
49+1k9zrEHxoeoDzAe91tQI=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vk/1PkDwPExxtxm5CpJchQrYdtq2+T9/qQ2R5YwHY4ORSRGtToodLBu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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc71X8fgI/tHJvsSCFCRkmF8/p8KDPZI9JOhEhRUUR2yupkp/m1yR4Z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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB96z/tdN+OfDVZz2dd/1w7/2C3KybY665CwRNXte
urzH1/3HtwUo1BpryhRd6F29T+vD/rA5f3gjtI/L3Cp8U33R9ul+p+QVrdGf
j8oktk1at/Lo1f1NM+Lz5a+ckHnVbSh6p376/krRac/b7p2QCW1n/9TUf8U+
zPxy3IwPm2VChFXnXOp7Yn/ehak4a/VKGdM/wUrnNr23D3R68qDH/bjMgm32
tYGBX+2530vUZCwulvmSx+/3JOuXfXZ+xCL+7R2STz+nBrz59N/+tLvPk93/
Z/MG2+yO9utjcoD5j+kpm0ZiFCucv3v9RY8sSQ44P6bq52z3lVxwvvfqJ+3x
BbwI/XkBE4MPIfg7DPbMchfhg/NVtk1eq78Dwb9V8X+bMhc/nD/ROvuAeAyC
7/Hv2knudQg+ND3A+QBBkLkM
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1PkfwMdtxhiaRetrVWprrQpbX21kXp+PCB1LmCi3ashZWtUWsSUp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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnk4lPv/xscw1pkhhhJFWghHKlow78+TbKlklyXkUEqRks4hlDUHiex7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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vk7lAsfgPGZwTBjDJVE0qJNSFLqhPk+DynTiBhS2ZVByFLaLCmayDIi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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk4lAsfxsdYxjJmRJEloYUkFE5ePP/nISGV7IQikbQghEOT7CSECWPk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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB0qWWM/J79wgVpz2dd/1w7/21ztmeOTNWaYSNXte
urzH1/0M5ct+RO/v0Si60Lt6n9aH/ZccZq1nydPSvFX4pvqi7dP9kvJ3ritw
aWomtk1at/Lo1f22KxfsmBSko/mq21D0Tv30/cIMgQyFcTqaoe3sn5r6r9j/
87ub+HafmGaIsOqcS31P7FWkg1dpevBqmv4JVjq36b39+ltLlhj2aWku2GZf
Gxj41X5FcvzVB2nXNL7k8fs9yfplr8Fw8Ue24RvVp59TA958+m+fe1CkPPXD
f8lgm93Rfn1MDjD/MT1l00iMYoXzd6+/6JElyQHnx1T9nO2+kgvO9179pD2+
gBehPy9gYvAhBH+HwZ5Z7iJ8cL7Ktslr9Xcg+Lcq/m9T5uKH8ydaZx8Qj0Hw
Pf5dO8m9DsGHpgc4HwC/6bXY
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1PkDgOdwzZhDFCFm5IxCSrWO9/sTFpVUSJKUFpVENms3V1uaFXIf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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vc7lm0DwPHbvN3DbYWskk1WZhnneRlFKTszjxSPPbLKFkmSvUekRCTJ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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMByJ4vj6e9O+NWHHa133XD//av8PRMq720mOVqNnz
0uU9vu6vS9AyWWl8UqPoQu/qfVof9k9sEJvSoJ2ueavwTfVF26f7m4+Lvmr8
nKqZ2DZp3cqjV/fb/ci543UlQ/NVt6Honfrp+50/X03bdC9DM7Sd/VNT/xX7
KXdf2e3+EKwZIqw651LfE/vwyrkR01d7apr+CVY6t+m9veSM4Blb3dM1F2yz
rw0M/GrP/1H/atdiYc0vefx+T7J+2X+Pm3jHaruG2tPPqQFvPv23L2V8dOfN
f2upYJvd0X59TA4w/zE9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9
voAXoT8vYGLwIQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B
8D3+XTvJvQ7Bh6YHOB8AiFG8/Q==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk41XkfxjkcnOOsQslIpBKFapqesXx//4wsTZEtFSWhJiNUYiZREUIY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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk7lHsfgIfBmDHGUqikyFaUpUiF7+chMlTGOgiV7YSKQooaS/ZEWSLL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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2v/Ed3l49eNVLFGz56XLe3zdv8qc
ueyM+ESOogu9q/dpfdi/ydbYmClPn/NW4Zvqi7ZP9895dnjJqWO6nIltk9at
PHp1f37Z16my1w04X3Ubit6pn77/9K2psjr3DDhD29k/NfVfsV/q5ybVyCPN
GSKsOudS3xP7n7aW/5UzBTlN/wQrndv03l5wsma26xR9zgXb7GsDA7/ar7rf
FHlm8S2OL3n8fk+yftnv93xSnH74A+vTz6kBbz79t4e5P9hmd7RfH5MDjM/0
lE0jMYoVzt+9/qJHliQHnB9T9XO2+0ouON979ZP2+AJehP68gInBhxD8HQZ7
ZrmL8MH5Ktsmr9XfgeDfqvi/TZmLH86faJ19QDwGwff4d+0k9zoEH5oe4HwA
2RevhA==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk71Hsfh8dYhzFDtMzjVCokasJ5Ulne328SckoxlLRYshTTkKRkK2PX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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk4lAsfh8dYxowxZJcWS0l0UNFb8vyfxxZRypItSxyEHFQ4bZQty5Aw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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB0qWWM/J79wgVpz2dd/1w7/21ztmeOTNWaYSNXte
urzH1/0M5ct+RO/v0Si60Lt6n9aH/ZccZq1nydPSvFX4pvqi7dP9kvJ3ritw
aWomtk1at/Lo1f22KxfsmBSko/mq21D0Tv30/cIMgQyFcTqaoe3sn5r6r9j/
87ub+HafmGaIsOqcS31P7FWkg1dpevBqmv4JVjq36b39+ltLlhj2aWku2GZf
Gxj41X5FcvzVB2nXNL7k8fs9yfplr8Fw8Ue24RvVp59TA958+m+fe1CkPPXD
f8lgm93Rfn1MDjD/MT1l00iMYoXzd6+/6JElyQHnx1T9nO2+kgvO9179pD2+
gBehPy9gYvAhBH+HwZ5Z7iJ8cL7Ktslr9Xcg+Lcq/m9T5uKH8ydaZx8Qj0Hw
Pf5dO8m9DsGHpgc4HwC/6bXY
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1PkDgOdwzZhDFCFm5IxCSrWO9/sTFpVUSJKUFpVENms3V1uaFXIf
EdluR0OTpnH7vB0VOdYRbUhWxpXEoAhj9/t6fX94Xs+f8DwapwKdfEgEAiHx
P/5nMbLqWl1lolUftSiHqrtA537r2GQRE1E6bk+lVt4Hjhw38btjTLRVvlQc
NfUQhJz+qPCKwkRBg3PauUfzQe6egE38UgbyNDNoeUZ8DF4aLIK7Pgz0Nur5
w/FPRWCKfs0lQYGBKFvYl94n8IDiNMMvrJaO1iaE7I90LAGwM+vymUA6CmiM
UJjeyQe5djSrAEU6QsXcxewIAViuipQIrqah94JRcflyGXA3mXl5yZuGkH/z
4dXySlCW91PMZVka+lW7t/90RQ1QVOvZxymRRWYLu7KzibXglxR7RtxRWdQW
3FK/3FIHTCK2pGbkURHzxe3pS8MvQZqTy19XXKjIelfamRF6E5jXDZM9T6Qi
N1NHLtm7Gbiu3LVzK6agKy+3Td0bbwVlnY1R1scoSJN3lfP2YDtQzv+CG8pQ
kLOGXUP6qw4QGqG4rPxcBqm1/cnNcu8ClnrewdMMGXSnp+r4QF8P8FReEoZX
S6O+/Dh31/q/QSQ15QjFXxrNhFro7mvpBblLek3pKtJoTF3H+/hCP6iZxM02
NkmhrbUF2SZ7PoCB967c4l+lUEh94KcfBgeBuO2zmrmOFDrfqSIzYjQEwFNV
okuUJDpVLxkoYAhBmukt1qK+JDr7rUYcWzcCPpWvB7mdEmjM9lrS5+QxkFm3
LmxMQwKNNigM+kRPginbtKz4JjJaDeer+D+ZAjbN8mUmQWT0mF9eHxA2DWa6
mPPhiIQ8YYMXb1YE9pZZxUsHkFDtquT9oq1z4EHOL9opqiREqduhnB85D1x9
+g7nhRDRPsOac+G2C4C3hzG1VYuIJvOGRCW1i4BiuPuPqg4CCrJZcyHXYQlU
fX0k6NhMQPe4xqE9yWKQ2X/12/ijVTy8Bi3O7CLA0ubSK8ZzYryZx2aZmBDh
1wKNjOqEFfxMdpzJEiTDi77zNW/rv+Pv8l555dZLQ7l4Kv/k2u/4vhehElMi
Gch9xioY917Ev20zjXXYRIUjhL2pS5ILuP5OIimsgAbds3NPs+zn8Zv5E5uv
zMnBn9vjH9foT+NvOcTb3RRFSK583hctmsJP/RYiLyxVhBu7D5xMSfyM37sS
MSj6SQmeoFw7m9c0gdtYFsYr8NfDSE31qae+47iZufK83hFlmGNZ9nMVeQz3
tSYsW31Vhr1Bk2EdlkJc26Pc9YaOKpSkuY0GiT7iv+vpoGNFqtD4Ub2TfN4Q
Xhnm9YhitAFyem9tcpYbxLk2DduvaajBk+M0/dGY97hGoaXWrWQ1KFAbJujN
9uIF3Y3kjUtq0OuPlOKCF914hcKFHT+Wq0Nu5oTxnHkXXuPVLRLIsuBCodUz
UNKOL/SmimtcWfB6qOk5+UMtOOc6P0/zFguy/xQG5lm+ws/ESDfzulmwtD49
2EK/Dr+4sVA2R4INb7fHie5tqcBvHSp+YK/Chi3Kk0stUjw8E2gatxqw4UTc
1nX9l2/izsOSQtUf2NCSH3VIOzENGhg7Caus2FDZklEco8uDn2wcG5zt2HBj
fKX0XoNK6GtabN5vy4YZAXxjjlI9tPDpqHDdzYbZinHHfbIaIT1/nW/jDja8
U+MV+6NqG9w+1s8w12VDp205fSltHdAmz1WrWp4ND0dLi64mvoF1hR5m9SIW
xPr+MrPTeAtfbava01XBgvpGmVGyz95B3+aPfDyUBddGnWz5y6YfruH8cqHS
hAXFPXrr0noG4NP3h8+vDqnD4PQFw838QVhwuXj/6zh16Id7ODNW/oGNbmL5
k1vUoYuCdk5nwjBcDL6rtM5DDV6YnqA5zQrhdc3igPkPG+CNVl5Ex5FReMo2
sbnfYwNsiLY40c6egNHdRjHx1qrQdNl5Y1vJF+g/XXSxvWM9NHjO9fS+Pg0D
C03OGRuuhxb+RlyvnTMw/otvYFK0Ejzeu93OI10EO5PIX7ZvU4R3BDDi0KF5
yGRlfp4PVYBzAUzHYb/v8NzEr30+JDpMge6OQtUlGMTNaWyrkIXGcg8dR1qW
oEzkY63jl6jQ/6nZgTHDFRiz52LFG6oMpF7lHBj/sAJv6vblpA9IwXyn9gMT
SWJYGrvsYlAhCYWzPgcnRauwDqSMkWPJEJIeGK5xIGCH9/Nv7E0iwTjqOlNu
LgEzuDvqvyuXCDVVv+0esiZikxmddpP3VkGg5hn7iAwiZv8z3a/z8wqoNHjn
uH6ciJ1VIe1Mt18GzhaVxxwTSNillYHyh1sWwZmnNs/bR0mY13p1um3WNxCp
08Zw3k3G+pY9MUOlr6BQ7p/aI3NkjFKstrnPfhYgjp9q734JjDI8YEBengE9
32eDPfIksDWJmkvmaBqQhFJ6Xu6SWMTDd9/Pz02Co4DtYFUiibmbJapkjE4A
3s0fLmhSpbAx3kiV4cIYkJ5xSpM4JYXJK27tx7RHgede/zJhuRTmEJ061Xpe
CJ7f5/S/XCONSak53e1o/whoK7mE/LPS2FC1Yrj1/iFQ+aTD3k9ZBmNZsTyv
b/gA5Ap2zPqck8Fio8v9Sl/3A+972be9qmUwN9unHFJuLyjLJtgfZ1Kw6xyx
SVXa34CW7iNy86Jg5BlrtkVRDziZ8DrH5RkFOxhhGzIofAP40UZ2ByWpmHsQ
Q4Zp2QU8Qhez7QqomOWV+CdtWDsIHQzJ0ifJYk0bBvwO3G4FmbZzGfRjslhj
0o00V9FrIOAGpU0/k8XiR+CgVkQjeCP/JbmLRsP2n2jTcTR7CUS/+ScKfGhY
1wF5doxOA5D7MH4jq4aGBf1kzeaBOmD44+nYcCU69kVLO6H2MgL7Hg9Hn7hA
xzi6AiPUWg1IAQeTnevoWFCyU9zvKv/127jqlt1aBlZdc1na6s8yEDCr+8Dc
l4HVH7pZvclNALQEqUVGZQzsyGpvVOJuPuj9bVWgSWVij0a6vy8fKQHJ5ueQ
kgcTuya+GbQ5kwfsxT1NssVMbF6p2IEpLgL//xvskmJIh4PCY/AvKkhDqQ==

          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vc7lm0DwPHbvN3DbYWskk1WZhnneRlFKTszjxSPPbLKFkmSvUekRCTJ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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMByJ4vj6e9O+NWHHa133XD//av8PRMq720mOVqNnz
0uU9vu6vS9AyWWl8UqPoQu/qfVof9k9sEJvSoJ2ueavwTfVF26f7m4+Lvmr8
nKqZ2DZp3cqjV/fb/ci543UlQ/NVt6Honfrp+50/X03bdC9DM7Sd/VNT/xX7
KXdf2e3+EKwZIqw651LfE/vwyrkR01d7apr+CVY6t+m9veSM4Blb3dM1F2yz
rw0M/GrP/1H/atdiYc0vefx+T7J+2X+Pm3jHaruG2tPPqQFvPv23L2V8dOfN
f2upYJvd0X59TA4w/zE9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9
voAXoT8vYGLwIQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B
8D3+XTvJvQ7Bh6YHOB8AiFG8/Q==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk41XkfxjkcnOOsQslIpBKFapqesXx//4wsTZEtFSWhJiNUYiZREUIY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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk7lHsfgIfBmDHGUqikyFaUpUiF7+chMlTGOgiV7YSKQooaS/ZEWSLL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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2v/Ed3l49eNVLFGz56XLe3zdv8qc
ueyM+ESOogu9q/dpfdi/ydbYmClPn/NW4Zvqi7ZP9895dnjJqWO6nIltk9at
PHp1f37Z16my1w04X3Ubit6pn77/9K2psjr3DDhD29k/NfVfsV/q5ybVyCPN
GSKsOudS3xP7n7aW/5UzBTlN/wQrndv03l5wsma26xR9zgXb7GsDA7/ar7rf
FHlm8S2OL3n8fk+yftnv93xSnH74A+vTz6kBbz79t4e5P9hmd7RfH5MDjM/0
lE0jMYoVzt+9/qJHliQHnB9T9XO2+0ouON979ZP2+AJehP68gInBhxD8HQZ7
ZrmL8MH5Ktsmr9XfgeDfqvi/TZmLH86faJ19QDwGwff4d+0k9zoEH5oe4HwA
2RevhA==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk71Hsfh8dYhzFDtMzjVCokasJ5Ulne328SckoxlLRYshTTkKRkK2PX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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk4lAsfh8dYxowxZJcWS0l0UNFb8vyfxxZRypItSxyEHFQ4bZQty5Aw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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB0qWWM/J79wgVpz2dd/1w7/21ztmeOTNWaYSNXte
urzH1/0M5ct+RO/v0Si60Lt6n9aH/ZccZq1nydPSvFX4pvqi7dP9kvJ3ritw
aWomtk1at/Lo1f22KxfsmBSko/mq21D0Tv30/cIMgQyFcTqaoe3sn5r6r9j/
87ub+HafmGaIsOqcS31P7FWkg1dpevBqmv4JVjq36b39+ltLlhj2aWku2GZf
Gxj41X5FcvzVB2nXNL7k8fs9yfplr8Fw8Ue24RvVp59TA958+m+fe1CkPPXD
f8lgm93Rfn1MDjD/MT1l00iMYoXzd6+/6JElyQHnx1T9nO2+kgvO9179pD2+
gBehPy9gYvAhBH+HwZ5Z7iJ8cL7Ktslr9Xcg+Lcq/m9T5uKH8ydaZx8Qj0Hw
Pf5dO8m9DsGHpgc4HwC/6bXY
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1PkDgOdwzZhDFCFm5IxCSrWO9/sTFpVUSJKUFpVENms3V1uaFXIf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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vc7lm0DwPHbvN3DbYWskk1WZhnneRlFKTszjxSPPbLKFkmSvUekRCTJ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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMByJ4vj6e9O+NWHHa133XD//av8PRMq720mOVqNnz
0uU9vu6vS9AyWWl8UqPoQu/qfVof9k9sEJvSoJ2ueavwTfVF26f7m4+Lvmr8
nKqZ2DZp3cqjV/fb/ci543UlQ/NVt6Honfrp+50/X03bdC9DM7Sd/VNT/xX7
KXdf2e3+EKwZIqw651LfE/vwyrkR01d7apr+CVY6t+m9veSM4Blb3dM1F2yz
rw0M/GrP/1H/atdiYc0vefx+T7J+2X+Pm3jHaruG2tPPqQFvPv23L2V8dOfN
f2upYJvd0X59TA4w/zE9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9
voAXoT8vYGLwIQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B
8D3+XTvJvQ7Bh6YHOB8AiFG8/Q==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk41XkfxjkcnOOsQslIpBKFapqesXx//4wsTZEtFSWhJiNUYiZREUIY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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk7lHsfgIfBmDHGUqikyFaUpUiF7+chMlTGOgiV7YSKQooaS/ZEWSLL
K0eiBSlrtueJVEqWiIykU5ZIZStke897Xe8P93X/B/d1y7n6Wnnwkkikh//y
P68Qhl2rqyLEhuxfwYdj5JDS7TdfJ4pFCLuBiuipQSVkHmW/0ucoQlB2WTyv
ad6BAk98WfOCKkJotfhUtlvtQjmmPtvKqxjE8MyrvSy+vei56gL624NByLwX
68tSwtAP4UibxDUMouV2d4JXqxGSnGR4X3wqTOh0Ota4V5oheJsR6ukrTIi0
16w2S1uiHBO6oY+kMPGt0ey+FIuNlupC+ALq6YQEH28Rd9UJHdk59TzInU7M
R/SWr33liqoL3eJCheiE8T7d8fvGnkhSpudg1GMh4kNFW/hzA190LpnJiHcQ
ItKDvUIURQNQN6W24zpJiOj82WT1uygI7eTsSEkrpBEXP15NqDsehlKtbNrD
bWgEz3uxCZ+wSPRL+aLQaR4aET2wNUzsZhxiL/9tYl9CJVzaK9dgA9dQ9duX
EfsdqYTbhjhM4GUKWn/3J64mSCUatSvs3UJuomCO5NL6CkFCOWFwjAdy0Acr
/T38roKELRZVUHMrD+lvdQ+YZAgSbuzvCX6DBejo+sXhS/UUAikVjZ0ffYBC
aMl21FMUQt65ppT3TynKWdzacmMDhbhwafDo4cxy1DCB79vSIkAcyWttlpus
Rh8H2EUl5wUI1TebPJjSDWil7buMrpIAoVixmawi24g2EZHXXnTzE2nWZ+cz
njUj9EiaxyaCn9hdM7jnq/grlKqduXlBhZ84M+y3JzynHX17sg7lvOUjlEu+
an/d2IUMUbrT/mA+Aju9/wSD2otuNkpc/CrHRySfdOzzKu5HPw6kZiS0kIl1
eYHHolM+IaPX4tU7z5IJN5uqR+zXX1AmK6mndx2Z+KHl1xB4fRRNdYn8ukTw
EmcVUpmsuW/IrNowgeLDSzA9HRpcnSZRfvY5xWRpXsLA8pZqqNQMWg67W7+x
hYfgGODO5D2/Eduj37YwkIfIP6iQM9KygEpNGT80FXiI7oRVfgnuMqKqGUTX
dZIIXWorc48uD7iKB2wyCSURaYfueY32kKHud0Fl53YSwZm2cl94IQA3P1ye
GytYxYONalS2u9Kg6nVVuMbsCs7MOJSSco4BPTUTQucNVvD5d3e449Fi8Pue
XFp94jKuEvGTGSG9FiQy2LJ8H5Zwyt63Z16sSIJWbPx9s21LeEQxiyugswFs
zhNaSYGLuPppj2OZr2TA/69fDb1Nf/DS7/Gdo4OyIJpAKz++9g/OHGFP1pPl
oahs870x9wV8m7F+ipeTIphytXL8KubxPwVOikkTyjBCMktZ5J/H8xop2fmV
KhChfCw2kj2Hq8z3TrTV7QBZ8wCOcOFv/P1Qur9/mAYcyco5sZn5CzdNCQ3a
qKAFy+EbLfzzZ/HU3I05//DuhlzPzD0vSLP4GPmOTt+yDoxop1F9n0zjBxTd
vq0x0YO4jWunGyWmcaxJxZmWimA7OZkr6TeFn2VaiZpyMPDrSHjQoDKJ98gr
DzAp+4FcW9EfM/0D96wPCHILMoIt71jHk699x0eya69I/zaGY9RIr8KWcTyI
xZILEjQF7tmJi536wzjZQl39gS0L+On2o2env+C5/FXlge4WoFHQZCVe+Bm/
+21Vsm2DJURxM7dZi37C7yDNDbxBVnB8jK4yGjeAczCXsvhN1lApM0TaOsPF
S86NzKrWWYNLdHLJveZ3uMOzWSbqt4Gim+Mas7pd+NUIYlHd3hbm7xuWoccd
OIX7riiixRZig7VPilu24iLJ0XpuamyQvTXsW6j/Al+qqQkRjmZDVdONAD2V
RrzxVGTe+3Y2/KcjfjpvRw0ulVtuqyVkB63rJxZbBUrxLtXWzAc6djAerynx
ITQdf/pygjliYwf65RGWitdSocbfW3STmx2s12eUxCmXQpDPzkTSMTvYklBL
MVOthbJkB590ph2k+ZRrREk1gdUzPlMpWTvIkox39sh4CdYfRro/DrMht8Hl
irF0GwTNXQg8l8kGq13Z/cltnRDu0Lzr33qBbQxl+vK1bkiy75eaeGsLWH/7
PhO5XpDyEU3QdLEFFfWbEUJlfcBf/ZzD+WIDKz1bJVJ7PkLmJYbKwgtrCLgx
r7a9/BO42XN36Gy3Bm/cyZqx/A+8ogSNJcVagc0axey3iUMwtDjwdqOaJZyZ
HKdbzQzDX2HbW5C3BVx9U8rptBuFgjm9eyLGLHgWo3esQ3YcyMNxegYbDoH2
kvWWtsc/4XNIS7rMB2NQrSg66h47CbnUfZNWHkagd0q9yEVnCkIX6ld/zBuC
M1fLxOnGNMgVM3zqjTDwSapKdTCaAfuOaCNY0YcQ5r7P7JkZeG1SWZ18XRdy
K4FjafkL9sq0ZTuJ68D9YofeiNlfwMPT1FWkqA0V+f6alem/AVwYRSK2u4DI
Soj/um8ODtBlyH65mvAquXB4w8c5iHjU5HuVogHdcU/hcPg8BK8Yq3Su2QGD
Yf0ZoQoLwJC8qPDmsArM+oiYD3n/gTH2edYuR0VIhiPmw9KL0HdgcShzeQto
iN4xH2ldBIVi37SGd7LQ9umn+ShnCUZMGOzzT2Xg1KN9rK9qy2BceyFE8d9+
0C5HscYGl8GXT4rsKSAFd606WOPXV0CVuufC2m1r4YC8tMU3g1W4zonUp2aI
wfCMh8XE9Cr0pf8Q5+QyAHjz1cQOkTBn8eAv1C4axNMktItySJjm6VMMYx8K
9IpH65pMkTDHvlubLb34QF56zuDzfh6s7oQIelLLA77ynkxOGg+2sjdveLpm
BdWq9pmvG+PBdPIqhgQT/yCKlpltmS4vJqpfa5b4+Tey1qt1NE/kxTqH+V1s
Hswgz0dGFR2jvFhU6ICga/4kClFqY1gbkLFyk6Ezt8UnUGqWnee7TDIWpL18
0TBzFN0X/eep3SwZWxJuoou9/IKIKG9p7mE+7EnPgPq76E+o589MgFMhH8Z2
eR4rHtOPJnw5bR9J/NjHrspZH24P4h0W2OpyhB+TzjQNLxx7ixyQ7CHDx/zY
pa1x59Mt2lFp+t4z8jQBLPbzCeeE9y2IMmWVyucqgC081PH0MGpGR81OVQ8/
EcDExIorDfyeoorbUR+ei1GwXwnrOtzj6hB9OYd014uCGQX1hAYbVSF3drVC
3FMK5n2fIc8de4xqH3YyvdcLYnL275PuFJYg0Xu7ZzxOCmKNC9N/O8jeQ+55
Wf9xqRfELFxjm62v5KPqLBLTWYSKYRnUKU08F9FveEzbu1CxbccVJsz1stDx
xFfZNmVUTNQz2S1eMg2Vx6ibWPDTsOQd20ofDiQhwfDUqYN2NOzhXMoNw66r
yCl4IcvkHg1jSy8/2aIZg4I/BWao8AphVSwp+y1Gl9HNA7Npwo5C2CyNpbFY
cglVFp1NnSwTwtaUSY2e8g9E3eI/k7rodGzgsovUtcizaPrCqWuVHnTsTtgx
3+vYSSQ6OHY1o4GOFfg3RTTLeSA14xNXLkkJY8bHX5NbbI+jgw+GYo6dEcaY
gaM9s9sdEK+PRZJ1ozCmlhvSc6HBGlVr1GWarGVgPGyj1PnP5shnRjlf9y8G
diuxZXT/OiZSqEwpVq9mYI8W979Twg0R98JqpTxNBKMrHllZu04fJemeJKSc
RDAvXf8rWORuxFzpaREqEcHkl7p9mS6a6P9/iw0ZbFLyaFRB/wVMqBs1
          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2v/Ed3l49eNVLFGz56XLe3zdv8qc
ueyM+ESOogu9q/dpfdi/ydbYmClPn/NW4Zvqi7ZP9895dnjJqWO6nIltk9at
PHp1f37Z16my1w04X3Ubit6pn77/9K2psjr3DDhD29k/NfVfsV/q5ybVyCPN
GSKsOudS3xP7n7aW/5UzBTlN/wQrndv03l5wsma26xR9zgXb7GsDA7/ar7rf
FHlm8S2OL3n8fk+yftnv93xSnH74A+vTz6kBbz79t4e5P9hmd7RfH5MDjM/0
lE0jMYoVzt+9/qJHliQHnB9T9XO2+0ouON979ZP2+AJehP68gInBhxD8HQZ7
ZrmL8MH5Ktsmr9XfgeDfqvi/TZmLH86faJ19QDwGwff4d+0k9zoEH5oe4HwA
2RevhA==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk71Hsfh8dYhzFDtMzjVCokasJ5Ulne328SckoxlLRYshTTkKRkK2PX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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk4lAsfh8dYxowxZJcWS0l0UNFb8vyfxxZRypItSxyEHFQ4bZQty5Aw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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4DpQHn/ejuxJE2OPd+Wbbuow3Bg31o9wSU19prFaV/3XT/8a/+Zpteh
W9tMzaNmz0uX9/i6f3VL9ifnOGnrogu9q/dpfdifc7crN0Vzp/WtwjfVF22f
7s96UnFt8rXt1oltk9atPHp1P4tjwf1N33ZZv+o2FL1TP33/3W6txP+Mu61D
29k/NfVfsV+6dcKunuVLrUOEVedc6nti719yNazxwWxr0z/BSuc2vbf3CkzU
Z/PYab1gm31tYOBXe/ea2mU7g1Otv+Tx+z3J+mV/8vsbP+XrVRZPP6cGvPn0
3/7fDCFpqYw+nWCb3dF+fUwORxhiyuI81/AxPWXTSIxidYD5f/f6ix5Zkhxw
fkzVz9nuK7ngfO/VT9rjC3jhfKa8gInBhxD8HQZ7ZrmL8MH5Ktsmr9XfgeDf
qvi/TZmLH86faJ19QDwGwff4d+0k9zoEH5oe4HwAHXTBzA==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1PkfwMdgmDFmXDmylaMiIlq2LbxfHzO2UVp35SyKCBGV3XU+SpLk
SIhIKYUaknPk+Hy6pkjOKETKLQmDlGv3+3h8f3g+nv/B8/FUPRJg60kmkUiJ
//E/rxCs9tVVJuG7yW2O3fYCbb7zZnSikEm8VNP1t+e8QpbRDitdzkwiRjNZ
c3axAQV7Dci+pDIJnZVI66K5Nyh7j/+WskoGMWbhufP3Gy2Ir/0D5XgyCNXV
sn0c7zY0KXnePkGWQdyre5t79PBbJD/F8Al9IknIrsoVql/oRNCWEekdIEnw
DCYbDvS/R9kcOstfXpKI+9NZX5jbg5ZqIkRO19KJ2a3yN13r+pDT9mn+Px50
InJYJjid8Qnx8o7GRkrQiRPjukFWI5+R/LpOi+gSCaK8Yqw5aWIQnUk2Z8Q5
ShABIs2/8VVH0PZwnatpeTQiw3V961WtCZRia9981p5GRPv4dke0T6I5jVCJ
E0I0IsnFc2tp1xQ6sJzDcSiiElXt/a39x2YQr+1VFNuZSmic8W6XlZ1FSvnf
cF1xKhG18WTb5v45FBIuv6RULk60KYR2kVu+IxNNj9NTDHGiRNCbvrRhCR1S
WhwKqxUjWpQ8vZ/8tYIiaMkHqX5ihKtix7JLGAmyFzXrU9eKEc6tX4NPtQlB
3QS+S62eQqSLkU9pgDD09R7gFv1FISKfCPlFPBOBlaav64w2U4jtAa2SkW4U
QI+UheyjRImq3QZ510apkGJ4fcMPLVFi8aTdrXYSHb5UKaLsNhEi151/f34X
A9KfrgkdVRUhlmQUE2YvS8Pk7pSM+HphIlXPuTi+XwbMXsvwtgcKE11RToMh
HDmYbmfOhRFkQnW4Zo+HjQLs5bHixfzJxL4gf/077xUhN+vMpmRlMrFsobbP
LmgtHPDs2Z8XLEREcYw4G/vWQfEexqT+RiFieDJOu7J4A1B1TS/UtJIIs7Zz
XMvXKlAzf6+idSuJ8G0kRTg1qUH6h3Pfx+6t4rcHRma5c+pQ+bryrN7sCi7f
69jpoLkJ5gtU02oTlnFzg7sRrIcacOrYXN27Zz/x6zYUpGKiA1LxtDI3uZ+4
0cPmPqsSXeCWbigY8/iBl9y4bKugqAfDpL1XF0UX8F1frm2cyNEHp8xsrw3m
c/gKcS0z8IMBBLXEP6jTmsKJjhsTSeuMQLi6vCdmZhLXeF/LqxIYgVqHlVty
4ld8odP6os9LYzhMPX88r34cVxhQTv3pgSBCff3ko2NjeE7f1vkcHYAsE15Q
jfAofrf2V5Wj0wDdgROhrSZDePNZXdJAKQaidIeRwJkBXLT2+UIrxRT07j2z
lcn7jO+3kxtIP2AK0d3Xt9hJ9ePlLwMdnn8xBbcxutZIbC/esEUxlKfHgop1
gyRNQTdu+JulRW4gC9wvJBcVvOjAIy/a5WYNs4CbPq43a9SO/ymWc8NeiQ0L
91mlqKQFT+rla4Rz2HAxxNBXxqYR57eHPJ85yQaVm0MBeSYv8cpxnltqKhsq
n6WeNtZ6ihc+UowwL2fDjZa4mds6j3GfGN5BQTMbGpUmFhspxXhGRyj57BAb
xuP013yIvIYvx7pf7J9jg0lZlM2mxBR42TvhVSVkBkomjKJYjWKYb6r/dkjM
DNTiq8X2aleDc+TV3tcUM0jzL9OLVngGGddtHpNIZpApH+fqmfEK+Dl3uoQF
bLhV537pD+Um+EV6yurTRzbY/prVk9zUClkPuR/v89mwP0Zs5lziW9C5Odr7
Vx4bsJ7mXRzVd3DkoOoJRjQbtLalR0mUdkE6e63mHVc2yEW5NTabfQBBS4XX
fn02rHRqrknp7IOC4pBfzUlsOJ26oLu1rB/iZr1kbzewwAd3sWMsfwI5QVrv
5SQW2MtuympLGATGojz/NZMFJ6fG6baCIZjevPNNwDNTuPymOLz14AjsPLK2
pj7IFJ7HGB9uURkHKf6tz49fYGC4ZKfWVPIN1CTcLa7EItAu5x7yuDgFsDPK
EQgTMPbbxnXfMQ1uFwZjjQXG4NptwHFJnYGF7DDDv62N4FYFhNvYzIE/uKW0
f98Bs/5My0GfnyAxrx1/870+JIOT5ZDyIhj/XiKnyNQHPam7lsONi/D9eW+S
wx498Hu0y2pUdxnuMsqO1KXoAO1ctNXYx2WAt/lke/WtkG/bYjWetALJaNr+
crUWDAk8rSdmViFd5L6PI00TgJyrK72PhHnL/XJM8d1miKOtMeRmk7AwqS8L
poWbQF35u+lnthAmo1+m4BSsDgHq3ubhaULYzobkxVPH1aBau8tScUwIE9w1
mLY6pgp2xtXOlglkLI5mGJHwcz14PzIrbxkhY35nJlMo1HUQsbmJYWcqjNXN
Vdxf0lGG+1KfnhycFcacbqZ/1HmsAP+FXbn7TxFs1/Ft2vkq8tD5U3DaJU8E
k/KVr1HNkgPyEEXT3UkUCy/uqxRrkQZHpLKPVSKKrceIPzTipaD42s6T6jQK
doK01p3PY4DYtG2KyBEK5mx1icwJocOhvX68oSoKVhR+iHXNlQbld6I/8KXF
MNMHazuC3cWBvpxNyj8uhm0jKe6/dZ4C1Q9bzX2UxLGHOYNYobowSBX8JvD0
Fcc+veF7HaoQAo/bmTfca8Wxhejf+wYOk4CXSTJ3ZVIxL2lWjw9aQfRUzxkH
dyq2gzmrmDW8iNwSGrLsS6mYiH2Hs2PFD1QWs41jLUrDHnhGLxQ8+I5cQn5k
cgpoWD3n6UHHVQEK6Q/O0CJLYKc2FrpO7JhB6btn0ySdJbAHtl6Jz69OoQpu
YMpUqQQGmWQjD9VJ9Fbm25V2Oh1jb6FKGzh+QTN/+yVWeNIxV+6F2K8No0jq
49jljDo6NvBLgeujoGGk+4fXpTAFSex1UFJ+475BZPFgMObwSUnsvJ2lZtX+
z4jsb33F7qkk9oU1P/APtx/x9Gquc+QYmHW3y25Xiz7kL9DINTrGwB46ylya
Cu9BGyuuFm7jMbBghnedzsR71P33aoU6jYmNkv1s2q50oitGvoSCCxNLZFen
vfN5i8xXOusliphYXVEiCjzVhv7/N9jR4LA8ifwW9C8jXTOn
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc/1X0fgI+DcziOkaSkgSRURlHdxuf9VepIkewtQpKspDLKiBySzITc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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4DpgHcAC+c8hzSOPd+Wbbuow3Dg2Ju63KJZ1ZrFaV/3XT/8a3+ErE4F
6/0i86jZ89LlPb7uP5l1TlDuX7h10YXe1fu0Puw/WbA6/BXfN+tbhW+qL9o+
3c/8aOGJx0+/WCe2TVq38ujV/ZxbOySDF3+3ftVtKHqnfvr+TfoHb1it/W4d
2s7+qan/iv2lG63Pzv9+ZB0irDrnUt8T+3knvTW8C25Ym/4JVjq36b19T4L4
8yOa36wXbLOvDQz8as/+9u3E4E2LrL/k8fs9yfplX35JW2BF+3aLp59TA958
+m+vekxUlWXFKZ1gm93Rfn1MDkZ3t1pYnnnBx/SUTSMxitUB5v/d6y96ZEly
wPkxVT9nu6/kgvO9Vz9pjy/ghfOZ8gImBh9C8HcY7JnlLsIH56tsm7xWfweC
f6vi/zZlLn44f6J19gHxGATf49+1k9zrEHxoeoDzAbk+xMc=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1PkfwMcwhjEXSSQVSo4yg5k24v36pKyj1jUdlnIUoqSmpraU2kin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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk/lIsegMdYZ4wh0klyQpQlS0KyvN+XhCSyRCFblFT2StbsSZJp7Br7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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMBxh+KzEe2+HEWZz2dd/1w7/2T/J4HWwx01I8ava8
dHmPr/s7H/H63nJVkC660Lt6n9aH/YzqWuE/Xu+VvlX4pvqi7dP9zzzX/eGL
3COd2DZp3cqjV/c/rf/0zJXjgPSrbkPRO/XT919o3HzwL98B6dB29k9N/Vfs
Z31ca+l2YKV0iLDqnEt9T+yNsiz2e01eIG36J1jp3Kb39hpGeTNSBfZJL9hm
XxsY+NXeZf2ljukxmdJf8vj9nmT9sl+6/McB5tf1Ek8/pwa8+fTf3j/VblmE
yCSeYJvd0X59TA4w/zE9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9
voAXoT8vYGLwIQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B
8D3+XTvJvQ7Bh6YHOB8AggC4yQ==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1fkfR69743I3S1JGUrYsJVqmmeT1+WQqpqaUJQYp6paRpEmSrbGF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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk0lXsfhrdxs7FNEZmnlMTeolPh93+ISIXIzJFCoshwkNJAQoqwzSXF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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4DpQHn/ejuxJE2OPd+Wbbuow3Bg31o9wSU19prFaV/3XT/8a/+Zpteh
W9tMzaNmz0uX9/i6f3VL9ifnOGnrogu9q/dpfdifc7crN0Vzp/WtwjfVF22f
7s96UnFt8rXt1oltk9atPHp1P4tjwf1N33ZZv+o2FL1TP33/3W6txP+Mu61D
29k/NfVfsV+6dcKunuVLrUOEVedc6nti719yNazxwWxr0z/BSuc2vbf3CkzU
Z/PYab1gm31tYOBXe/ea2mU7g1Otv+Tx+z3J+mV/8vsbP+XrVRZPP6cGvPn0
3/7fDCFpqYw+nWCb3dF+fUwORxhiyuI81/AxPWXTSIxidYD5f/f6ix5Zkhxw
fkzVz9nuK7ngfO/VT9rjC3jhfKa8gInBhxD8HQZ7ZrmL8MH5Ktsmr9XfgeDf
qvi/TZmLH86faJ19QDwGwff4d+0k9zoEH5oe4HwAHXTBzA==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1PkfwMdgmDFmXDmylaMiIlq2LbxfHzO2UVp35SyKCBGV3XU+SpLk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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc/1X0fgI+DcziOkaSkgSRURlHdxuf9VepIkewtQpKspDLKiBySzITc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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4DpgHcAC+c8hzSOPd+Wbbuow3Dg2Ju63KJZ1ZrFaV/3XT/8a3+ErE4F
6/0i86jZ89LlPb7uP5l1TlDuX7h10YXe1fu0Puw/WbA6/BXfN+tbhW+qL9o+
3c/8aOGJx0+/WCe2TVq38ujV/ZxbOySDF3+3ftVtKHqnfvr+TfoHb1it/W4d
2s7+qan/iv2lG63Pzv9+ZB0irDrnUt8T+3knvTW8C25Ym/4JVjq36b19T4L4
8yOa36wXbLOvDQz8as/+9u3E4E2LrL/k8fs9yfplX35JW2BF+3aLp59TA958
+m+vekxUlWXFKZ1gm93Rfn1MDkZ3t1pYnnnBx/SUTSMxitUB5v/d6y96ZEly
wPkxVT9nu6/kgvO9Vz9pjy/ghfOZ8gImBh9C8HcY7JnlLsIH56tsm7xWfweC
f6vi/zZlLn44f6J19gHxGATf49+1k9zrEHxoeoDzAbk+xMc=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1PkfwMcwhjEXSSQVSo4yg5k24v36pKyj1jUdlnIUoqSmpraU2kin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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk/lIsegMdYZ4wh0klyQpQlS0KyvN+XhCSyRCFblFT2StbsSZJp7Br7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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMBxh+KzEe2+HEWZz2dd/1w7/2T/J4HWwx01I8ava8
dHmPr/s7H/H63nJVkC660Lt6n9aH/YzqWuE/Xu+VvlX4pvqi7dP9zzzX/eGL
3COd2DZp3cqjV/c/rf/0zJXjgPSrbkPRO/XT919o3HzwL98B6dB29k9N/Vfs
Z31ca+l2YKV0iLDqnEt9T+yNsiz2e01eIG36J1jp3Kb39hpGeTNSBfZJL9hm
XxsY+NXeZf2ljukxmdJf8vj9nmT9sl+6/McB5tf1Ek8/pwa8+fTf3j/VblmE
yCSeYJvd0X59TA4w/zE9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9
voAXoT8vYGLwIQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B
8D3+XTvJvQ7Bh6YHOB8AggC4yQ==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1fkfR69743I3S1JGUrYsJVqmmeT1+WQqpqaUJQYp6paRpEmSrbGF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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk0lXsfhrdxs7FNEZmnlMTeolPh93+ISIXIzJFCoshwkNJAQoqwzSXF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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4DpQHn/ejuxJE2OPd+Wbbuow3Bg31o9wSU19prFaV/3XT/8a/+Zpteh
W9tMzaNmz0uX9/i6f3VL9ifnOGnrogu9q/dpfdifc7crN0Vzp/WtwjfVF22f
7s96UnFt8rXt1oltk9atPHp1P4tjwf1N33ZZv+o2FL1TP33/3W6txP+Mu61D
29k/NfVfsV+6dcKunuVLrUOEVedc6nti719yNazxwWxr0z/BSuc2vbf3CkzU
Z/PYab1gm31tYOBXe/ea2mU7g1Otv+Tx+z3J+mV/8vsbP+XrVRZPP6cGvPn0
3/7fDCFpqYw+nWCb3dF+fUwORxhiyuI81/AxPWXTSIxidYD5f/f6ix5Zkhxw
fkzVz9nuK7ngfO/VT9rjC3jhfKa8gInBhxD8HQZ7ZrmL8MH5Ktsmr9XfgeDf
qvi/TZmLH86faJ19QDwGwff4d+0k9zoEH5oe4HwAHXTBzA==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1PkfwMdgmDFmXDmylaMiIlq2LbxfHzO2UVp35SyKCBGV3XU+SpLk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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc/1X0fgI+DcziOkaSkgSRURlHdxuf9VepIkewtQpKspDLKiBySzITc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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4DpgHcAC+c8hzSOPd+Wbbuow3Dg2Ju63KJZ1ZrFaV/3XT/8a3+ErE4F
6/0i86jZ89LlPb7uP5l1TlDuX7h10YXe1fu0Puw/WbA6/BXfN+tbhW+qL9o+
3c/8aOGJx0+/WCe2TVq38ujV/ZxbOySDF3+3ftVtKHqnfvr+TfoHb1it/W4d
2s7+qan/iv2lG63Pzv9+ZB0irDrnUt8T+3knvTW8C25Ym/4JVjq36b19T4L4
8yOa36wXbLOvDQz8as/+9u3E4E2LrL/k8fs9yfplX35JW2BF+3aLp59TA958
+m+vekxUlWXFKZ1gm93Rfn1MDkZ3t1pYnnnBx/SUTSMxitUB5v/d6y96ZEly
wPkxVT9nu6/kgvO9Vz9pjy/ghfOZ8gImBh9C8HcY7JnlLsIH56tsm7xWfweC
f6vi/zZlLn44f6J19gHxGATf49+1k9zrEHxoeoDzAbk+xMc=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1PkfwMcwhjEXSSQVSo4yg5k24v36pKyj1jUdlnIUoqSmpraU2kin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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk/lIsegMdYZ4wh0klyQpQlS0KyvN+XhCSyRCFblFT2StbsSZJp7Br7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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMBxh+KzEe2+HEWZz2dd/1w7/2T/J4HWwx01I8ava8
dHmPr/s7H/H63nJVkC660Lt6n9aH/YzqWuE/Xu+VvlX4pvqi7dP9zzzX/eGL
3COd2DZp3cqjV/c/rf/0zJXjgPSrbkPRO/XT919o3HzwL98B6dB29k9N/Vfs
Z31ca+l2YKV0iLDqnEt9T+yNsiz2e01eIG36J1jp3Kb39hpGeTNSBfZJL9hm
XxsY+NXeZf2ljukxmdJf8vj9nmT9sl+6/McB5tf1Ek8/pwa8+fTf3j/VblmE
yCSeYJvd0X59TA4w/zE9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9
voAXoT8vYGLwIQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B
8D3+XTvJvQ7Bh6YHOB8AggC4yQ==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1fkfR69743I3S1JGUrYsJVqmmeT1+WQqpqaUJQYp6paRpEmSrbGF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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk0lXsfhrdxs7FNEZmnlMTeolPh93+ISIXIzJFCoshwkNJAQoqwzSXF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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB2TURU5zG4ZLF6d93Xf98K/9E1S0ss9s9deMmj0v
Xd7j6/4LIssPF2mY6BZd6F29T+vD/n2eh/NTOi7p3ip8U33R9un+W9la5671
XdRNbJu0buXRq/sfrjabr3Xnsu6rbkPRO/XT9wukeYrXPrmsG9rO/qmp/4r9
u8Rgf91n+3VDhFXnXOp7Ys8mcdIzoWOLrumfYKVzm97bW6ivdf4y75Lugm32
tYGBX+2TXz/g2pRVr/slj9/vSdYv+94Qx8Wvj0zWevo5NeDNp//2zxner4pJ
XSYXbLM72q+PyUFNVJ5h7tUjDExP2TQSo1gdYP7dvf6iR5YkB5wfU/VztvtK
Ljjfe/WT9vgCXjifKS9gYvAhBH+HwZ5Z7iJ8cL7Ktslr9Xcg+Lcq/m9T5uKH
8ydaZx8Qj0HwPf5dO8m9DsGHpgc4HwCEVLxI
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlns01Hkfx8dgmDHGlFu0NrmOMUlSu0u+n18IWy25VIrIrRblsnRZJeWS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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk3lP3jh8fOzFjKlmixFUOStTDv921M1mxDsi9lyhaSVAqPPQnZl8m0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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB7ptReKPhUyRLk77uu/64V/7KzN+cPSd6daMmj0v
Xd7j6/7S9E3+31YX6hZd6F29T+vD/m/vXj6xsBfQu1X4pvqi7dP9d9ju7nt6
gk8vsW3SupVHr+7P4Np0UCxTUO9Vt6Honfrp++1X1JckFQjqhbazf2rqv2Lv
+/9+4vdvv3VDhFXnXOp7Yi/EG/WWj+GTrumfYKVzm97b55+8GcoQLKC3YJt9
bWDgV/sfjE/Ztnft1v2Sx+/3JOuX/SE2x8NbQy5qPf2cGvDm03979+Xs3WaL
HssF2+yO9utjcuhm+fvoiDMTI9NTNo3EKFYHmH93r7/okSXJAefHVP2c7b6S
C873Xv2kPb6AF85nyguYGHwIwd9hsGeWuwgfnK+ybfJa/R0I/q2K/9uUufjh
/InW2QfEYxB8j3/XTnKvQ/Ch6QHOBwCKPL0/
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk3lG0DgMdYhpkxI1kaY4ZSCYUkvSX3/SARpWwlu2paJFpUslUkJGRC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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk7lHsfgMc6mDGWLKESKUsRIkW+n8eWpQ5CluyMqBwiLceaEBIiZBBa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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2r94/hb7Q7eCOKNmz0uX9/i6P2PK
pM2bfpjzFl3oXb1P68P+K2XRV95xXuO9Vfim+qLt0/3LM/fFaD+8wpvYNmnd
yqNX9zMox9v+mXud91W3oeid+un7Qw5c2v9w+XXe0Hb2T039V+wtbGx1274f
4g0RVp1zqe+JfarQnf9Hs3bwmv4JVjq36b39wbvfgw6rXONdsM2+NjDwq/0n
sfeFUuuaeL/k8fs9yfplL3X/RXF403Sup59TA958+m8Pc3+wze5ovz4mBxif
6SmbRmIUK5y/e/1FjyxJDjg/purnbPeVXHC+9+on7fEFvAj9eQETgw8h+DsM
9sxyF+GD81W2TV6rvwPBv1Xxf5syFz+cP9E6+4B4DILv8e/aSe51CD40PcD5
AH2btr0=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1PkfwMc1DGNIUdg2xy5Foe1SeH0+yRrUIoQKpUzlZlObYxRCCDXu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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc/lQ0fgI/jcIzjkCKjgchIyKiM+3vfR4WQnS3jzYiigZJEIckoHLLS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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB2TURU5zG4ZLF6d93Xf98K/9E1S0ss9s9deMmj0v
Xd7j6/4LIssPF2mY6BZd6F29T+vD/n2eh/NTOi7p3ip8U33R9un+W9la5671
XdRNbJu0buXRq/sfrjabr3Xnsu6rbkPRO/XT9wukeYrXPrmsG9rO/qmp/4r9
u8Rgf91n+3VDhFXnXOp7Ys8mcdIzoWOLrumfYKVzm97bW6ivdf4y75Lugm32
tYGBX+2TXz/g2pRVr/slj9/vSdYv+94Qx8Wvj0zWevo5NeDNp//2zxner4pJ
XSYXbLM72q+PyUFNVJ5h7tUjDExP2TQSo1gdYP7dvf6iR5YkB5wfU/VztvtK
Ljjfe/WT9vgCXjifKS9gYvAhBH+HwZ5Z7iJ8cL7Ktslr9Xcg+Lcq/m9T5uKH
8ydaZx8Qj0HwPf5dO8m9DsGHpgc4HwCEVLxI
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlns01Hkfx8dgmDHGlFu0NrmOMUlSu0u+n18IWy25VIrIrRblsnRZJeWS
JJRbbk2RkpIot5bx+5WQdR2kp0myMsldLqtxfXrOef54n/d5/f0+r3PeGz0D
HXzIJBIp6Xv+1yuEedfqqhxxZHDvqdsGT5DO3dYvY4/liOrHZguvnEuRbYzz
yjsXOSIjAufftX6GTh//JN9IlSP6L7ebDhwvR9xfA/TKKhnEeKd9eA2vEjXo
i1CuD4P4lIspVv32F5qQjXZKlGcQ9BGxm/d/4CGlKYbfuReyxNlbEsbdygSC
zsyI3wNlCbfmS0XKDS8Q15puHqAkSwQNeZ0JqK9DSzUXJEJ5dILZ2GO0a74e
HTb62vCnN53QZj0+iLu/RlUFXnERMnTCM1w2Aok3IyW1nj0xT2UIi+kEZ6/P
rehUsg0j/pAMIeMxz5KK7UBG4ZtS0gtoxHhZnlXvhm6U6uDUfsmJRpj735R0
o/SgOd1zMifFaASPvmCsp/AfdGA519q5mEp08bZ1Ve4RoKrO11EWLlTCRCY7
IOtJL1J5MIkbSFMJn34DizPmH1FYuNKSSrk0YfbYIjla/B9kxvIOnWJIE9u/
uGjvWTeI3FQWhed5UgRH9GqJ/0qILtCSD1JPSBFqoXHMpsQhxF1kNaWpShH3
1CrvcM8Mo9ox3ESjiUJIZthA/cVR1PfhQFHxGQqR4E9cf/poHK20jauZ6lCI
61ndEx9EkwiVrhdzipIkIvfnfxRGTqPUbVkbRGxJwvYMu1yKPItGn69D3E4J
osjXh+uZOYcyXiqe+7JRguhqKxPaKYjQhFVqZkKTOBFCt61KFy0gy+a1VUbB
4kTkrPXW8wtL6GuX3Nx5gkzA3dpWeiEJdleZJ0gFkAnXevmVdEIM8nNOaSev
JxOCixv9bIVkOODzfn/BaTGCHYpVMA9KQsmvjIktWmLEhr5S+sl8ClANdl6u
4ZOIsjoJVsaqFNT8e7+CzyERU/2nBKkfaZDRGzk/fH8Vr1dU56XH0KGyufKS
4ewKHi947tlhyoB/Czem8xKXcVaIHPPHMSaEHJurfVu3gM+81UqQHFQAZgKt
7KjCAi7ITTn7YEIRip5tKBz2FuFdA1EtEatK8Jm0O2VR8hsuz2dTrYxU4HA2
9/gGmznc0zGz+FC7GvzRkfColj2FJ/4i1l7grgni1eXvY6cn8Ljjjl6PvmmC
xhu7o8lJ4/jM7JD/aJIWuFOjfQuaRvAHZrYpxyu14YLmjxOlx4bxsD7L/ldW
OpBjVvVHjfgXvGFTGiOvUwcEwWPn+GZCHCv++aJ6ny5I0p2Hgqc/4WOnU5fy
nFhgeL/OYW3BAH7dzf51XgMLYgRZeo7Mfpzk2J7bnK0HR4fp7KG4D3h6+HuG
04oeVKgNklgzAtw27Z2DigsbPC4nFxfWv8HVCoOXEVkfijJGDGdNu/C/r+nx
qnbrw7eH5s/Q0w7c3+PczuJr+nAlbJv/WvsW/MTAgc6xRn1Qvy0MLDBrxO1U
/bKslvShsi4tdAf7JV7cvWUgWY8Dtzrip/M2/YVfNq62LLbjQIvK2GILpQS/
2ljxISyAAyPxWxR7I27inrpxQf0xHDAri7LXTkqFC4WB+9vSOaBixiiO0y0B
zrq9cx+5HNBIqJbarV8NkeGsFtnvnB5QZhijXAerRPct51QOZCvFH/HJfA2x
ZRWhTZc4cKfW4+qu9W3w2bouJfgYBxy25rxPbuODxEHcxc+cA/tjpaYjk7qh
bC1Z640iB7D37SbWG9+Ce7ToyYNBfWBvzoiSefYO3lyYuOJUpA8KUUdb2i17
wS/YJEzypD6s9LAUU3v6YCRma/K4jj6Epn0z4JT1g/strN9CwAY/3NWRsfwP
GJbwOZaxbHCS187pTByEgLp7hdbtehA0NUJ3mBHCh1x5TbanHlxrLQnnHxyC
zbUPT49OsOBV7A73DvURiHe8PHB7Xhe2LTlqtD2dhK4/qPPxfG3QLy9y874y
BT6Bei1lO7Vhx4nNRR4/fYUiP06cyRMtOCIwtnZNm4ZHoX7nKdGacKcCwu3t
56C0pE5zfsNGmA2Qsx30W4DVwMuxQRdVIBkO2wrXL8K6PLXyU0fXgSHznu3n
lkV47RC0ZmCXMpwoNbH7YrAMN7cbpN/WUARaZIzd8MdlqDV+6VisqgAPHDrs
Rq6vAJ9jFn5bRR6EMz77xqZXYdzU/setm9YAkPMN1uwlYdE4g/fIngnxNMVt
RVwStr3wBy+eiAGa6+d3DliIYaJl+8R77TIQqPm7TXi6GJbtbUH42NGgWv+d
7bphMSzKt5Kr/EEaHHdUu9gmkjHaD6a5VhoU+L3UsrxjiIwVY/Pfmmsl4IJO
G8Nxpzjmpvqno5e/ODxk/vPi4Kw4dme12mF0hgREjN96wW8SWIiMwCufu4p6
FmZCXQsksG27f8ZCQr4rIaSwPA5LYn01Xyh6oSJ0CKnvNX8qiRkr/7Kl8f48
Krn5S5AmjYKZVftmWM3MIamvDqkSnhQsVVNLsc15FrntPlElfE7B8r6PHt4z
jcrvxvQ2rJHC8mJWNgX7f0X0ZS7pga8Uxi+7GoIrTaHqJ3wbPxVpbLpPN/nS
oVHELNw+4+MvjcVfERaE2w0j77zsWx48acxr/LyqyrEhVJVNsjkiR8UaAo1c
BdlCRE/zmXb2oGI0NR3fvZOf0NHEv3OcnlGxu47Lk6tuA6gsdrP1PkkaNljp
6nptuB+5homyrQtpmCY57qRvSi8K6z+dySbLYH7cpFGutABlWM2my7rIYLdM
uwUmJW9RRVFw6tQzGeymF8taLfYN6l47eaOLTsfYBkKRxdUuNH32RFKFDx1r
3ULybq7gI+bH4WuZtXRsf2GE5SS1AxnsOn71vLIstpjIU1cit6I9jwZj3YNk
Mabi8k7jrX8jcsC+G44vZbEdRu9S47oaUZVhTZa1AgM7pPrwjOq9ehQwo5tv
eoyBFUQfc47Kr0NaFSmPN1cxsNcJHpDQ9gIJzq5WaNLkMHEN8gJHnUA3TP0J
ZVc57CePHHOJTTxks9LTJFMsh+XMOpCLjvyF/v9vsKz9b5qMWyvRfwGSnzng

          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk3lP3jh8fOzFjKlmixFUOStTDv921M1mxDsi9lyhaSVAqPPQnZl8m0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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB7ptReKPhUyRLk77uu/64V/7KzN+cPSd6daMmj0v
Xd7j6/7S9E3+31YX6hZd6F29T+vD/m/vXj6xsBfQu1X4pvqi7dP9d9ju7nt6
gk8vsW3SupVHr+7P4Np0UCxTUO9Vt6Honfrp++1X1JckFQjqhbazf2rqv2Lv
+/9+4vdvv3VDhFXnXOp7Yi/EG/WWj+GTrumfYKVzm97b55+8GcoQLKC3YJt9
bWDgV/sfjE/Ztnft1v2Sx+/3JOuX/SE2x8NbQy5qPf2cGvDm03979+Xs3WaL
HssF2+yO9utjcuhm+fvoiDMTI9NTNo3EKFYHmH93r7/okSXJAefHVP2c7b6S
C873Xv2kPb6AF85nyguYGHwIwd9hsGeWuwgfnK+ybfJa/R0I/q2K/9uUufjh
/InW2QfEYxB8j3/XTnKvQ/Ch6QHOBwCKPL0/
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk3lG0DgMdYhpkxI1kaY4ZSCYUkvSX3/SARpWwlu2paJFpUslUkJGRC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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk7lHsfgMc6mDGWLKESKUsRIkW+n8eWpQ5CluyMqBwiLceaEBIiZBBa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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2r94/hb7Q7eCOKNmz0uX9/i6P2PK
pM2bfpjzFl3oXb1P68P+K2XRV95xXuO9Vfim+qLt0/3LM/fFaD+8wpvYNmnd
yqNX9zMox9v+mXud91W3oeid+un7Qw5c2v9w+XXe0Hb2T039V+wtbGx1274f
4g0RVp1zqe+JfarQnf9Hs3bwmv4JVjq36b39wbvfgw6rXONdsM2+NjDwq/0n
sfeFUuuaeL/k8fs9yfplL3X/RXF403Sup59TA958+m8Pc3+wze5ovz4mBxif
6SmbRmIUK5y/e/1FjyxJDjg/purnbPeVXHC+9+on7fEFvAj9eQETgw8h+DsM
9sxyF+GD81W2TV6rvwPBv1Xxf5syFz+cP9E6+4B4DILv8e/aSe51CD40PcD5
AH2btr0=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1PkfwMc1DGNIUdg2xy5Foe1SeH0+yRrUIoQKpUzlZlObYxRCCDXu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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc/lQ0fgI/jcIzjkCKjgchIyKiM+3vfR4WQnS3jzYiigZJEIckoHLLS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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB2TURU5zG4ZLF6d93Xf98K/9E1S0ss9s9deMmj0v
Xd7j6/4LIssPF2mY6BZd6F29T+vD/n2eh/NTOi7p3ip8U33R9un+W9la5671
XdRNbJu0buXRq/sfrjabr3Xnsu6rbkPRO/XT9wukeYrXPrmsG9rO/qmp/4r9
u8Rgf91n+3VDhFXnXOp7Ys8mcdIzoWOLrumfYKVzm97bW6ivdf4y75Lugm32
tYGBX+2TXz/g2pRVr/slj9/vSdYv+94Qx8Wvj0zWevo5NeDNp//2zxner4pJ
XSYXbLM72q+PyUFNVJ5h7tUjDExP2TQSo1gdYP7dvf6iR5YkB5wfU/VztvtK
Ljjfe/WT9vgCXjifKS9gYvAhBH+HwZ5Z7iJ8cL7Ktslr9Xcg+Lcq/m9T5uKH
8ydaZx8Qj0HwPf5dO8m9DsGHpgc4HwCEVLxI
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlns01Hkfx8dgmDHGlFu0NrmOMUlSu0u+n18IWy25VIrIrRblsnRZJeWS
JJRbbk2RkpIot5bx+5WQdR2kp0myMsldLqtxfXrOef54n/d5/f0+r3PeGz0D
HXzIJBIp6Xv+1yuEedfqqhxxZHDvqdsGT5DO3dYvY4/liOrHZguvnEuRbYzz
yjsXOSIjAufftX6GTh//JN9IlSP6L7ebDhwvR9xfA/TKKhnEeKd9eA2vEjXo
i1CuD4P4lIspVv32F5qQjXZKlGcQ9BGxm/d/4CGlKYbfuReyxNlbEsbdygSC
zsyI3wNlCbfmS0XKDS8Q15puHqAkSwQNeZ0JqK9DSzUXJEJ5dILZ2GO0a74e
HTb62vCnN53QZj0+iLu/RlUFXnERMnTCM1w2Aok3IyW1nj0xT2UIi+kEZ6/P
rehUsg0j/pAMIeMxz5KK7UBG4ZtS0gtoxHhZnlXvhm6U6uDUfsmJRpj735R0
o/SgOd1zMifFaASPvmCsp/AfdGA519q5mEp08bZ1Ve4RoKrO11EWLlTCRCY7
IOtJL1J5MIkbSFMJn34DizPmH1FYuNKSSrk0YfbYIjla/B9kxvIOnWJIE9u/
uGjvWTeI3FQWhed5UgRH9GqJ/0qILtCSD1JPSBFqoXHMpsQhxF1kNaWpShH3
1CrvcM8Mo9ox3ESjiUJIZthA/cVR1PfhQFHxGQqR4E9cf/poHK20jauZ6lCI
61ndEx9EkwiVrhdzipIkIvfnfxRGTqPUbVkbRGxJwvYMu1yKPItGn69D3E4J
osjXh+uZOYcyXiqe+7JRguhqKxPaKYjQhFVqZkKTOBFCt61KFy0gy+a1VUbB
4kTkrPXW8wtL6GuX3Nx5gkzA3dpWeiEJdleZJ0gFkAnXevmVdEIM8nNOaSev
JxOCixv9bIVkOODzfn/BaTGCHYpVMA9KQsmvjIktWmLEhr5S+sl8ClANdl6u
4ZOIsjoJVsaqFNT8e7+CzyERU/2nBKkfaZDRGzk/fH8Vr1dU56XH0KGyufKS
4ewKHi947tlhyoB/Czem8xKXcVaIHPPHMSaEHJurfVu3gM+81UqQHFQAZgKt
7KjCAi7ITTn7YEIRip5tKBz2FuFdA1EtEatK8Jm0O2VR8hsuz2dTrYxU4HA2
9/gGmznc0zGz+FC7GvzRkfColj2FJ/4i1l7grgni1eXvY6cn8Ljjjl6PvmmC
xhu7o8lJ4/jM7JD/aJIWuFOjfQuaRvAHZrYpxyu14YLmjxOlx4bxsD7L/ldW
OpBjVvVHjfgXvGFTGiOvUwcEwWPn+GZCHCv++aJ6ny5I0p2Hgqc/4WOnU5fy
nFhgeL/OYW3BAH7dzf51XgMLYgRZeo7Mfpzk2J7bnK0HR4fp7KG4D3h6+HuG
04oeVKgNklgzAtw27Z2DigsbPC4nFxfWv8HVCoOXEVkfijJGDGdNu/C/r+nx
qnbrw7eH5s/Q0w7c3+PczuJr+nAlbJv/WvsW/MTAgc6xRn1Qvy0MLDBrxO1U
/bKslvShsi4tdAf7JV7cvWUgWY8Dtzrip/M2/YVfNq62LLbjQIvK2GILpQS/
2ljxISyAAyPxWxR7I27inrpxQf0xHDAri7LXTkqFC4WB+9vSOaBixiiO0y0B
zrq9cx+5HNBIqJbarV8NkeGsFtnvnB5QZhijXAerRPct51QOZCvFH/HJfA2x
ZRWhTZc4cKfW4+qu9W3w2bouJfgYBxy25rxPbuODxEHcxc+cA/tjpaYjk7qh
bC1Z640iB7D37SbWG9+Ce7ToyYNBfWBvzoiSefYO3lyYuOJUpA8KUUdb2i17
wS/YJEzypD6s9LAUU3v6YCRma/K4jj6Epn0z4JT1g/strN9CwAY/3NWRsfwP
GJbwOZaxbHCS187pTByEgLp7hdbtehA0NUJ3mBHCh1x5TbanHlxrLQnnHxyC
zbUPT49OsOBV7A73DvURiHe8PHB7Xhe2LTlqtD2dhK4/qPPxfG3QLy9y874y
BT6Bei1lO7Vhx4nNRR4/fYUiP06cyRMtOCIwtnZNm4ZHoX7nKdGacKcCwu3t
56C0pE5zfsNGmA2Qsx30W4DVwMuxQRdVIBkO2wrXL8K6PLXyU0fXgSHznu3n
lkV47RC0ZmCXMpwoNbH7YrAMN7cbpN/WUARaZIzd8MdlqDV+6VisqgAPHDrs
Rq6vAJ9jFn5bRR6EMz77xqZXYdzU/setm9YAkPMN1uwlYdE4g/fIngnxNMVt
RVwStr3wBy+eiAGa6+d3DliIYaJl+8R77TIQqPm7TXi6GJbtbUH42NGgWv+d
7bphMSzKt5Kr/EEaHHdUu9gmkjHaD6a5VhoU+L3UsrxjiIwVY/Pfmmsl4IJO
G8Nxpzjmpvqno5e/ODxk/vPi4Kw4dme12mF0hgREjN96wW8SWIiMwCufu4p6
FmZCXQsksG27f8ZCQr4rIaSwPA5LYn01Xyh6oSJ0CKnvNX8qiRkr/7Kl8f48
Krn5S5AmjYKZVftmWM3MIamvDqkSnhQsVVNLsc15FrntPlElfE7B8r6PHt4z
jcrvxvQ2rJHC8mJWNgX7f0X0ZS7pga8Uxi+7GoIrTaHqJ3wbPxVpbLpPN/nS
oVHELNw+4+MvjcVfERaE2w0j77zsWx48acxr/LyqyrEhVJVNsjkiR8UaAo1c
BdlCRE/zmXb2oGI0NR3fvZOf0NHEv3OcnlGxu47Lk6tuA6gsdrP1PkkaNljp
6nptuB+5homyrQtpmCY57qRvSi8K6z+dySbLYH7cpFGutABlWM2my7rIYLdM
uwUmJW9RRVFw6tQzGeymF8taLfYN6l47eaOLTsfYBkKRxdUuNH32RFKFDx1r
3ULybq7gI+bH4WuZtXRsf2GE5SS1AxnsOn71vLIstpjIU1cit6I9jwZj3YNk
Mabi8k7jrX8jcsC+G44vZbEdRu9S47oaUZVhTZa1AgM7pPrwjOq9ehQwo5tv
eoyBFUQfc47Kr0NaFSmPN1cxsNcJHpDQ9gIJzq5WaNLkMHEN8gJHnUA3TP0J
ZVc57CePHHOJTTxks9LTJFMsh+XMOpCLjvyF/v9vsKz9b5qMWyvRfwGSnzng

          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk3lP3jh8fOzFjKlmixFUOStTDv921M1mxDsi9lyhaSVAqPPQnZl8m0
KRGSrFnuGz1Zk30LpUhUskbZPs/3nO8Pr3Od6x+4zkvyrB+NzorD4V78t//j
Nkbp29nhxxQjJja4tPjBocfvvv0o5seklr8Q9rsKAbNo2+0RB35s/nNb33rU
XhB04YtgCw8/9uZBqbulhiRgGvnKl1fxYZ5/j4QnGx4CbxX+gId0Pux5p9Vm
5b+KYJ43yjpRkA/bf5fsWxCjAkQW+LxuNPJikn7BVic6NAHszQ7z8OPFrjON
3a4FA8A0IFJ8RXixoMeybaIf9cBmXSh7YD0RK2WWXqnqNwL2Kotvr7sTMd7K
6JGYOgtQnX8uLozwnxuXZzcyTwORfYMm0WUEzPhro3PokAO4kmLIF29HwKZr
n1iuTbiBfq7a7rs4AubTUQU7Js4DlZAjqRn5eKx0V+Ij6pGLII1m/T7cGo95
5Z/f3qAEgNXDNwgXWfBYgB3bsFJnELDZemhgW8KDUVRjlTbcboLq3tZIPQce
zHkz41wNMxyIPfuFKnHzYBHUlUiDnmgQHCKyKVbBjZnm1NXsLNwGYzTycY6z
3JjgI0OPdxl3AVnOPXCBjxuzjb23VOSSBpzFNqZv1nNhU6GOlmujWSAUn3KG
x4cLU4hai6QBJmBuyLWl7+XCXBmr45z2j0DDD1RLqo0TG/YU9cvSeAomxm2K
Sq5yYl3TtwOP9BSC7a6f+7QPcWJm7WHjirKlYD8WldTSz4EJfh/qqD33CoCX
4izWkRxYqdbVwuwTVSBNPefAHxIH5gKcnEVJdeB7zR7A7GXHhkmej005GwEF
ZDrqBbNjRU/E1+qi3oCsJuEb3yTZsRlrnJhufiuY10/LTmhjw77/GyWKxr4D
1I7d1SqX2LAZGznJ4oc9IMc8eXBoDxuGNDCH7bb6wWIf/+pNjBXT7dPLEpwd
BsbVlAQuX1YsbeeyR5TsOMi7d0U2RZwVO9Xe8/MGyyTY+udZvUQbC4YjR3DH
tX8BNvQPp/ODWLC5ATHxlPWvoNSIb/6YDAv2YSKrUyxzDvAo6cbU9eCw7Ryf
tpCyeXB2d+B+gzAcphPh4fD3+SKo+/20skcRh5FlD9m/MV4BWWMRa7NPd9Dg
Yyqhav+sgaqOqnDllW1009STyJDcAIOvfxCu6m6jpvREQ9sTO+B3gWRGfeIW
el9tVUl0lgUKZ9scZB/bRMNteoPSb7BDtVvxhcbym6hBohzurR0XtL6KqSUH
baCTTfESFnF4ePn8asNQ8180XEb/YA8/HxRIwJe7Cv1FcYt03S+/BGDRqwMF
s+5/0On3kvk/OQWh0agaM6BiHU0ru010NxeGX3HGqRsc6yi6YK0V0CEKIw+7
3IqyWUM91PwjOUP2woNmgSG8+b/RgiAz/Tf0fdCewbxwwHAVNfAOmkAXJOFW
uITF5bwVVF+qw0edIQ0feOQcb8GtoBr8a/WtzrLwq3oGj1/NEspQtueVVJaH
cRJCS03CS6jS5ZHaeh0FqMiWMioSsIjWDJEyDroegQHdCc8bSAsomtsqQlhW
hmy1FR9il+bRSUJJZoWOCpQaMHdNSfqJatKE8vqTVKELT5RnftscmiIUsqR/
SgOOXvpxo4c8jU7K9+dqzGpDDqLtzKWlLyjVm8P/myoZKj9tpu3O/4zqMKh1
DdcAjB7NkbcS+IT+WVueNQ9EoOsskTQTN46SjS+YNHPpwsp9Uzi55VHU6En+
fVKaLnSLSSkp+HcA3ZJ+bfUxlQKLsuaUV7T70AdIng6JTQ+uF1JegbJuVGVR
U1jCQw/eClb33m3Zibb93pL63agHD96f9ssnt6Dl13hPEwWosKo5PVCH1IQm
ZTh5tFhSYW53/NKjI6/RgZXo909jqLBT7MdGJ2cpShY5c5pSQoVz8ceEx8Iy
0cPHhwNMWqmQXB5pKZuUBlNh8+3VfioUI/OVxB0uhQnN3DImPVQolVDLZaxQ
C8VyVces66kww7dcOVq0GSoWm97RzaZChki8Ez27FSqw9ibT6VT4oMHt9knx
LohoKceckKJCmuq9DyldPfDCt3Fv2249eDqWaykiqR+qmQ3ah/jrQeTDey0D
ySE4TXOcPkrQg6SjWZGEVyOQlksf02RQ4PagnHDa4ATM/Xu0tpipCwPT15UU
yz9By+6HXguCutALdbTi25qEPh9GAhQjEGgtKHuvN3EK0h5fFZdhAOi/MEek
LU9DD4WPJHVAhnfelYb0nJmB4T0Xmd6j2vBNrI5L98E5aO5XvFeN+wRU37SS
6ir7BVtuXq8ovqYKFSqKnN1vLcDn7dEGgyQVqONztMhNcxHSpeweUb4qQ6dR
NQPH9CX4S4/nrvuGIvRNrkqzoy7D/Q1xwRZVJBhqqPXZZnkZyop5PrubIAcf
VMIQS8tVmNBqPcWZIAMLi+2GIldW4XOnpGWFQSlYkXf5WGXmb3iiieJDOy4J
MUZC/DetNRiMycf0nj8A21Pyp/dOrEEttvhqt0QJ2B/XCE3D16FNDC017KsY
/PjPh+wwmT8QXLxA5fcVhSu+/GZTXn/hDq7KaIRDEKZAe7Np8Q3of8Zn3HtO
ACoLPDH72rkB5VQPiFZt8cKuT7/MZkI24UvZ5ceK4Xjo81LL/JvSFpwQpZhM
/tcPfES0+ezHLbjrmUiZawQ7fEbrNp+7uw2dNi9/VlxlgfrS4hbfdXdg7tiV
q/ftdsD0Mt3ix9IOFDJtpPQbbADImqe06xQOocnKUeqn1kA8Xli9iIlDAhlW
WVMTK2Bod4y2wSIOCd1MaXFXWgLS4mu6n/VYkP0SI9temb+An7SHYUgGC5J3
Umad7vId1CqMmO2ZZUH0nBgO+vkzgEvN+PQrbVakAmzXXzo7Bax0ah3MElkR
Oec9UqToSeDxklrRPcOKaGVp2rU8GQehh7r4rHTZENGH52y9WUZAGuOMx0AO
G9J4/FGGIOcAKBSYbDyzwobkG3WwNDN7ABbtJT5qyo4c3yHUS116Bwb/Lgc6
5rMj92yrNfZGt4IffiFdEzgOxGTrRZa6wxvAOs0p52bPgaTOx0c+HcaAHTh4
ilLGgUjXW30rnaoFpZkn/KXxnMhxl3n8fY4qwLVIS2M/y4lEqNuR4xbLgLOx
T/V0DSeSlF7WESf0AlQ8jh57u4sLOZvO4Fb1LgDELSbumScXMpWC/1NYkwfc
bapl4hq5kD+dYrl9ww9A7YseQy8xbqSIbBCnZsYAAgUay3RvbqRn5UZmvFsG
cH/EyHWr50ZqbrPt7TRJAdUMnKETPw8yGRQK4wcSADGdvmTrxoNsvY/pDqfc
Aq6J7fesX/EgPLuzVGuKIkF57FEDCw48kppVvPq9Lwxwh6ctmpzBI/Xq18u3
i64Dx+A/DIMCPPLppZGO/7NAEPwpKJvESkAK69aENU/6gyz9lQxeBwLSnnqE
v+SOJ6gsupS28IqA0IbfNQXunAP9u38l9xGJSLpiyEsZdRewdM0nqZJORO5I
qBud0rcFAh9n72Q3EJFukkzfy14aUDp54fZNUV5kWSP8WJOYKTB5PhXr4s+L
xDWPKL/10QesvhbJVk28SFt1s7xmhi6oVq7LMRDiQ0y/oyrESG3gu3w4T/s8
HxLsBm9ZBKkDmcrU4qPVfEjonddF7WXKYPTaTqU0nh8J9BKUODUnD5K1vTFR
R37EQ42n4RKfDDDcHmwjlPAj5Jt9Lad+7wf//2+Rim0p3rkBUfA/YNki2w==

          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB7ptReKPhUyRLk77uu/64V/7KzN+cPSd6daMmj0v
Xd7j6/7S9E3+31YX6hZd6F29T+vD/m/vXj6xsBfQu1X4pvqi7dP9d9ju7nt6
gk8vsW3SupVHr+7P4Np0UCxTUO9Vt6Honfrp++1X1JckFQjqhbazf2rqv2Lv
+/9+4vdvv3VDhFXnXOp7Yi/EG/WWj+GTrumfYKVzm97b55+8GcoQLKC3YJt9
bWDgV/sfjE/Ztnft1v2Sx+/3JOuX/SE2x8NbQy5qPf2cGvDm03979+Xs3WaL
HssF2+yO9utjcuhm+fvoiDMTI9NTNo3EKFYHmH93r7/okSXJAefHVP2c7b6S
C873Xv2kPb6AF85nyguYGHwIwd9hsGeWuwgfnK+ybfJa/R0I/q2K/9uUufjh
/InW2QfEYxB8j3/XTnKvQ/Ch6QHOBwCKPL0/
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk3lG0DgMdYhpkxI1kaY4ZSCYUkvSX3/SARpWwlu2paJFpUslUkJGRC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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk7lHsfgMc6mDGWLKESKUsRIkW+n8eWpQ5CluyMqBwiLceaEBIiZBBa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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2r94/hb7Q7eCOKNmz0uX9/i6P2PK
pM2bfpjzFl3oXb1P68P+K2XRV95xXuO9Vfim+qLt0/3LM/fFaD+8wpvYNmnd
yqNX9zMox9v+mXud91W3oeid+un7Qw5c2v9w+XXe0Hb2T039V+wtbGx1274f
4g0RVp1zqe+JfarQnf9Hs3bwmv4JVjq36b39wbvfgw6rXONdsM2+NjDwq/0n
sfeFUuuaeL/k8fs9yfplL3X/RXF403Sup59TA958+m8Pc3+wze5ovz4mBxif
6SmbRmIUK5y/e/1FjyxJDjg/purnbPeVXHC+9+on7fEFvAj9eQETgw8h+DsM
9sxyF+GD81W2TV6rvwPBv1Xxf5syFz+cP9E6+4B4DILv8e/aSe51CD40PcD5
AH2btr0=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk/1PkfwMc1DGNIUdg2xy5Foe1SeH0+yRrUIoQKpUzlZlObYxRCCDXu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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc/lQ0fgI/jcIzjkCKjgchIyKiM+3vfR4WQnS3jzYiigZJEIckoHLLS
UymRPDZF3TeKNOSYJZXH3tl7vM/7+bw/XJ/rP7g+l6Sbn4U7mUQi/f0v//MG
odu6uclP6KWdY0iUliJ7n3wZHn/JT7igAYoFlCrEJNJ247sDPxGrY0vIJdcg
gZ59Wxu4+YkM5fWkXy31SNZxX/nSCjrxy7Pf0yX2C1K/bxkeudMJ+vkrRTFb
W5FJvgir+K10YtU2yfLXvW+I8BTdO7iGj6gO0qJsj/uNoC1poV5+fIS5csm1
XRr9SJY+TddXmI+wUCU73rcbRdaqr1P839CIJ8JBzcYS04i96nR90GkakSs6
uN/5wAJSmfOf6FBeGhGVoVKj9mINEd7ZYRRZzEtkUSYY6QFkCEg0oMfY8RI+
YcFiYcVUaKNWNd8j8RKZAfv2My3poBqyPyklh4fo81j8qWa7FZgWVl9vWPEQ
2UZZfhKHRGBeNpj3HBsP8WP9W9Cg1i6wXn+kb1vATXCOWnX6sKSgsuVD+BEH
bqJLUSrAzEkWRJ//wZW4uImJ+3ruqpOKcDVEeE20jIsQIJfqfOg+AN0WyGEO
Ny7i48UHGnabGoDInfafonMRvYFNaiIUbTglujpw7Q2VoDBcr5VfxeA6T6IN
91kqYSDbfQfhOwpZq3KNyWJUgoPBebngpAG8Hce1pBo5iWlZY8MY/xPw66d1
fsFlTkI67ovi3w3msNE0sVN7LydhOqap+tLrJOwiIu42tHEQbp5Jj9nL7QCK
xNmswjmIiZkZr/VPp4Cpkb57WYGDsLR+mumU7wZjr0Qgq4VCyDV4+asleYAu
3Hc8cpVCKOyZvIlo+EBqrVDwsCSFqOU753XO9jxM6jHT4hrZiadNGEuFeQmO
fhKsVL3ATizoNCdruV6GdNOEjk4RdsJsWWVQsT0Yplv5568RZELt2L3ALRFh
YFipG0f1JRNr7p9PCFiGQ3ZmgEyiOJmwSmmM+hp7C9bDnr/Z0chGdLuzd1rB
HbB2/3EyJ5CNOBy17F4bEA+Fx+mTB6TZiK6XGXX7HyUAtxLjVjWLRARpMtZ1
7ZngJui/Sz+URBwMSkvv870P1QvPylmKJMI2617sqeF0SO2+uTjybBM3SB1i
eyD/ECo+VdxQmdvABzYOG5LXH0HH63Hey4wN/HBNft2LkmxYyJVMeRO/jrNu
HV0ax3NAKM1agtK9hv+KHF4RlX8B6rdj8gzl1/DEPJmFZwsFYHWZUE8IXMUZ
Ug4x3KlFcMlj/m1n3QoeLSEn4zVZAgJxPKUu21bw+h1GyNWAcsgv2Z07cnoZ
7zsW2Dmr9QqOd6lnXSxbwo/3UnUXGNUwSDJMWuVYwtVoSlfc4nAIl3W+HWG9
iM+f61/pu1sDEib+IXw5C7jgV5UzuSF1YJ+R5bnbYB5na9P4Z9vHBli/scPs
UvYcfjLgvGHSZiP85ZV+uIE0h+e/Xih2tv4Mgxop3H6vZnC9HPMj+0uaIXrH
tplaoRl8hK2OncTfAorsiV3CF6dxyz4+7fGgVrjYHPfircIU/ig35kJuUAew
V5X9iJqZxLNcw8yalL6BVLupS+LdCbzdqKfn2tR3cOaOOJPTOIqTXWbdjBJ+
QteF8WAWMoBTuvg67G70AgfNdujCTB9OFUvrSnfsA5VndRaCOb144w6B/GW1
fojsSpe3FOjBe8Tndz5gDYDLCE1hKPonXj+ATkolD0L5zn6S3GwXPtHceNvM
dAhcbyUW5L5vx7WZzz+6PR6G/NRRlTntVrwtdM1qQWMElvJ0S6C4GS9oTZBj
VY3A7asaPoLmn/G4w6GOC6qjIPFwwC8HacA1lzbqb6SPQkVdsr+OQi3OXAxv
y5sehQfNMTOP97/GI8uu0xsOjcFn0fHVz5yF+JiMr57x2TEYjTkg1B16H69+
7OjQEj8GSGm4ucxdJkpsrzr/4OEYiCL0gmjZQtRgsl60Jn0MpOKqqIb7qlCR
cJE6g7AxSPEtVYncXocWvi2NuWg2BhnCMU7uaR9QG0NziwLeMfjrreudY+JN
aNEmzpZZPAoWapk/EptYaOzt9zLceqNwMoo6c/NuG+rbcKl9on4EsB9ftfQl
O1Fmc/utNGwEFJRTw3lLvqOUGlUfifxh2OiQE2J2/EIl54lNzGkI/JOXlBRL
e9BBzafGBk8HwRt3tKSv/4NSpE1jN/oGwGqrTGZLfD96UrziVYNhP5yfGqVZ
zA6gAhy3uPz+0wexXwpDWDZDaKPhGUrM5V54F6Xj3Cwxijof28grTe0BjTVL
qabiP2jyl7TsRtZ32FeWf+r07SkUXqfai2//BjpnlfNdD02jNIHnouVeHeDU
pa7vmDyDRlMjwqQOtYJvQgXT7ugsmrDC4RFdzoLrBlq91rOz6HP6kJy7fjP8
VY6GmJvPo1Uja1ra2CfIe2nXGT43j6LBnt+MVz5AWfalA+X3F9DdqUU/b7XX
A5ERFzOstYjOr84XtrDewcfEnAGxX4soe3vm8o/JWmiLrkFP3FhCCcndo8KK
NfA77EdaqPQyunvY0SZuCw5zvvwm/d4rqGSMrkuk5itIRO1NBsRXUYg1y9Ly
LQcVgacmg59X0WdcilWevSXQ1PPHZChkDbX/7a2UnVgEZ4u0TIeV1lHDPmXZ
T//2g+dmpOnI73VUYK1WZ4fqC3hu0Ww6em8DbVNRNZj9mgN6e8TNxhibKNpv
YCPYmA0Ds+5m4zOb6Hxq55qd8GNAydlKW4xJmG9T2fXxgocQwyOkkZ9FwlyM
B5iN+RnQKXhLW3+ahP3WOVjcIp4Ke8QXGb1H2DBH25Aunhkm+O3xMghJYcNK
Hmp6rMgkQtW+7yYiI2zYxQLLQh+nu0BVNzxZok3GLCm7t72jxoClTpWDSTwZ
u9hTu+CjHQVeRUfLmofI2PU4lYNiz8Ph+t4muiWDHTMcrd6vwQwDZoaNV3s6
O+bhYN73ticY8gT+qbGZY8carbccdHK6DESkt3jXCQqmZCW/TS3yEnSszPo7
5lCw1ryBDx8Y52HcL6TpF4kDm19liChueAN5gFPO1Z4D81OPEMqz9gA7kDDW
LebAxBxOHrG/7gaF9zXP7+HhxNpYP2IFok4BddqCSXHjxOq8R0gpu+zglOHZ
yoFXnNhe2ej4oxlWUPYksrt+CxUTeGdtZNNlBrT1LNLzM1Ss82m62LlgIzht
XSkdXUPFGv3l+was9aDqb5aBtygXdnaYps4U0wWB3IOz7j5c2FcZhmjoSwRO
P8544PqGC5NgkIWadQ9DZQbJwImfG/OSxP3eN6gBLdl9xtaVG1u8WRbxSEgF
XOI/ZlqVcGN/IjV/fxZWgNIoZX0zDh6sT7BKVU5MBrhuMKeNbHgwy8XJlgUO
SXC8upyhn8uDJWaznJmnxeFqT2CaApkXe1y8dlM+SQhS9eZS+Bx4MeU32HL0
lACU519gTpXwYnvc3nvdiOCBNsE/Ca00GlYhQnvSW0iBmStn75a707Avxldm
pUVIIPB7JDbtLQ2rf9YaUTi/hCgd87xzbTsfZqRFDztqNIsYveiPcj7Ph32p
DOtxq55AyL5mCZa1fFgYkifEZTGEVKpUp+tvo2MHbeSVHyC9iO+sbLa2Bx07
tqP1VFJANyJdnvRSuZKOKbV9DwuU7kC6rmyW7+Hhxw7xkCoylFhIgrYPsd2R
H1usS7V0Tf2IGGx0NPIW8GPqT38qHY56h/z/b7HJjkdLRzJw5L+QwEJy
          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB+JEnl7N/tjIXpz2dd/1w7/2b17MvXJJR4Vo1Ox5
6fIeX/e3n/wRpW4YL1l0oXf1Pq0P+zvjza9Gr/0jeavwTfVF26f7dzx8vNdE
+7dkYtukdSuPXt3PKiP7S3b3P8lX3Yaid+qn7w++Kjr33/F/kqHt7J+a+q/Y
t9Vu2iy07oVkiLDqnEt9T+yzQ34ITz96X9L0T7DSuU3v7f8vPWrqeuGP5IJt
9rWBgV/to1+tLez0WyH5JY/f70nWL/t5wWoTVafvE3v6OTXgzaf/9gnREcFX
gy9yBdvsjvbrY3KA+Y/pKZtGYhQrnL97/UWPLEkOOD+m6uds95VccL736ift
8QW8CP15ARODDyH4Owz2zHIX4YPzVbZNXqu/A8G/VfF/mzIXP5w/0Tr7gHgM
gu/x79pJ7nUIPjQ9wPkAQnG9hw==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlns01Hkfx+eCYYwZKSShFEkSFa3i8/2RjWxLLt1QSyFdUJvUI7ElUYg0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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk/VYseQI/x4AxCRFIil8yKbtH57k1lqhAyRUW8KJdLGq4MISEX0cmc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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMBzaH7o7bV7qfvTjt677rh3/t3zZ9kcm/xq2iUbPn
pct7fN3PJpFn5hoxW7LoQu/qfVof9l+0EM57qGwpdavwTfVF26f7L8Sf5Yu+
aC6V2DZp3cqjV/dnb9O7fOqDldSrbkPRO/XT93NY+t4W+WMlFdrO/qmp/4r9
itwF6ecWqUqFCKvOudT3xH7ptyjhtFvSUqZ/gpXObXpvf2yuZlWNk6XUgm32
tYGBX+2//DLawOv/VPJLHr/fk6xf9sv4m3WcLv4Se/o5NeDNp//2Tdc0/hQk
8nEH2+yO9utjcoD5j+kpm0ZiFCucv3v9RY8sSQ44P6bq52z3lVxwvvfqJ+3x
BbwI/XkBE4MPIfg7DPbMchfhg/NVtk1eq78Dwb9V8X+bMhc/nD/ROvuAeAyC
7/Hv2knudQg+ND3A+QA1Xbdx
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk71PsewMeMbRgzUpGrRTqVlDWOeyzv75dySCVZy1I4EUIpOuem4Uhj
tFia7CGVzqTQWBpq8P3gqESyZUuRkyxHjFkqCffc57k/vJ7XX/B6ntfGgJMu
gWQSiZT6D//zErLtXl5mIGprQ8qy8a+w5c7LielSBrI5s73xQft/wIl1aGnA
m4ECOsOrx8vOw9njf618RmWgX240SLP646BgT8S2qmo6CrjDbJUtjoen2+fh
ViAdlW2kui6kJcCMykW3lJV0pFn92qCZywJ1IT00pkEFjal/zTeZYwPWlRMX
fFIFpSWsPOUceRkK7Gm2EeoqKMT+VTYtNBm+18bKRtXR0MUJibzUIw28TOae
/ucYDdVNxF1I2siBGu4vl+KUaYjsy1KlrEkH9XW9e1kVyihn1Fb42joTojkO
9CuHlVGBe0zrrcxsMGHqX8/kKiF2n4JjhjAf0l3cXsW7KSHm0aJZw4BCkG6N
UQ6XUUKlmpZ5TpO3wGPxlv2hMipaufOzXWzqHajpep6wy5uKmnbFO3M97oLm
vVnCQJGKjLubsEacC+eY6t81HymiFrQw0XugGKx1j0UJ6YrI4TdnH9exUjii
uTB2vk4Bnb7K7Q835kGsEseTGqaAyPmBUo3EcihY0G3J+JcCCo+zja6Zq4D6
acJCp0UeMXWfLQdEV8G7tx4lZb/KI8e9qSx9NT4stX9aZ7lFHskURlgZtlQD
lGvJuCXIofA6M4HpZQGkm+VumNeTQ31Vy9qmf9bB34/XQEGXLGoWjLPXr0CQ
3bg6ZmKjLPLptfEd4DbCzM/pOcktFOSlqx/Yo/on7G5VqzGJpKDjvfHK3inN
MNfNkJ5HZLSjVPs41vIcHGtskxUiyIhSNVShHfICivKiN3O0yIg6diI6b20b
eAS+ceeelUEaw+6/c4hXwNtDnzH+QQZ1nDRZbOzrAKqBTWJtJwklJfWsJw92
Qu3nP/idO0jI2SKkN2axG7KHLnyZ/GOZGG7bnxhk/hqqW6vjjSRLxPU9wWn+
zF74XLwxsy5lkVBHg0Xy+gNwJkha39f0jRjZ+lLjxKphUE1WqvJb9Y1Y2JUj
k+w8AiWVG4onj80T80s/KlzQeg8fSY7XF+S+EgKNq1M69aPgdaPg+AYHKaHM
SH9XseMjnO5IflCvJyTWOV60u901DRTBozds0QyxobqEZs//BDqvD/hxUj8R
sWFnaPuyZuAo9WIIt2WK+PKKrHVmqxBiN62fKQ+aJO5wTwo1OELIs645XUuZ
IKaStxrofBPCYOR0TKf1GCG2bJpd2zAHcrRD45Giv4jllGXebk0RGP3R5KLG
HSWY19YmrIgQAWswd5ur6ghR7xUVdIsmBr9Jmt74pbfEyIrghWl3MfDXfSDp
igcJ33sGMJsrBv9ETllx82vic1MayU5DAiXZU0YSy26CVGgTZ7BfAl/v21ZC
RQfRaGeugsVKIOmc2Qm1g22E3aiy0Pm+BLRvjp3kWj8jpPq1DNtOCVQ3ZURZ
6TUSg6QsHYlIAvkdV0S39Z8Q74tjevYxpNCmOb3QJs8jto1umDTbIoWpK8ar
h+KyiPbp9YfzzaVgXZVwcHNqOhYy/szAbLcUNK3pZZe28rDOopYnZo5S0EkW
KDhuF2C5GvOBOXukkBlRZcTS+KetB0sNfrZSuKF+xTcw5zlWqh+VxDGVQmG9
/2U7rXZssjo6zVJbCi47895w2jux+061TyLkpODOVhBdSO3BdjqF9+z+IAH8
zSsL+419mGZKPJ9HSEDPMDtBuXIAC4h4Q3+RIYFVCX5tr3YPYfbxdw0rgiSw
1Ku7Or33HRacJuueYiKBqIyvBjuqRjC+Nj2KPS+GUMLHlb74HmP275R7IRCD
28rNeV0pH7CkVlPOJxMxnBJO0VzEY9g5y8Tnje9FcPUlj9npOY59jC5tVLwq
gj/ZVkc7tKcwuernEat65sDsu6tOe8Us5vx23nPMQgjbH5UcOZYkxHYeWua3
3pwFqzDDEn/zOeyXPouAkeYZ8B00tffJEGH2Al96veInKORjzIMHpdjlLVMh
285NgiSC4fQh9BtmPMVSdPg6ChzMy2lMawErrDHSU9UZBSPVu04f2xYwilWt
ydsD7yGs3OLAhMEixvd0SEyOHAalC6wDk8OLGHty7+2Ribdwz6XjwFTaEvZk
vhxFhg7BmDjQeVq0jLnfLOkYSB4AjFxksGIfCX/anILh9v1wRWm1WUkBCZ+q
TlApVuqDTVpfbEZ3yeBru2p9GLweOLkp2IGZKYOfdr4ktOB0g2D7gNOaSRlc
P7d/uDm2C1ytBN5OKWRcXeVImuhsBwSX737UMU7GNzDdi6hv2yF2Szvd1YaC
fwovrVD/0Ab3Vd83eEoouE9Zu8Ltf7cAYoVqDe6Xxb9XffFwZT2D3m/iKB+u
LO4oXHHEY6IZyGPyuv5ecrhf4X3e5tlGOAza+2wr5PCfXpqPCLMagJf106lN
SvJ4biHt8HdXBApzLumyAfL451Pem/fb1cMRx7CascfyuGqFwJQjXwuP7rCG
nq5QwG/yFkPOTD0G2mIB6V6IAi7reX40c7YaBA87HUI1FfGgOetx/UNVoFr8
ozjwhCK+0zOGeNddAcdu38j3r1PE35Rgo93Hy6HmBsnBl0HFbZp1z0rUeEDL
CBQd8qfiq02NZT3ulYJfyos8t0oqztzbfL3N7QFUsQ3tneWU8O4G6jbTbcXg
c27+hn2xEl4pG/S6zOYunBs5m6NHVsYLZLS+pPvegeyfJZkq3sp4399Xnn0t
uAX8ksh0YaUyrnq+35xNKYQetdlr3TQavsN7U7m8Wj6IfgtL5QfS8LCHlYwU
r1xQHZ68mlNPw4Ofhg0mDmWBgd3xy+c1VPCjTQ+TyekZsPfBB/bRUyr4ZMze
NbbM60COcL7m2qiCr+3+3c/q8TWoMarNtV9Fx4n+fkqvZhpEiLcWWQbR8dYi
ptPKn5LhB/71UsMaOq4Y+9DiI/MyDP62zN+kxMATeY9S8xfZcM3yBNLwYeCU
05TauUoWOCz1tiiXMXBxnZ/5QF4C/P9vcD479XFiVTz8F4uKYtg=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc71X8fgM+xjjNJUdJAS3yTlorO6/0JRcoeISIrqYySiiQrpIiQlQqR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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvs3lAkfwMeM24wxo0ip0ysqSsWUbZXL93mSmMh9kkUxGXcNalJLKNei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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk7VG0DgMc6xjAkQsouokShGu/znEOKKPtSlizxKjESUZZsqRBiJvva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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB+JEnl7N/tjIXpz2dd/1w7/2b17MvXJJR4Vo1Ox5
6fIeX/e3n/wRpW4YL1l0oXf1Pq0P+zvjza9Gr/0jeavwTfVF26f7dzx8vNdE
+7dkYtukdSuPXt3PKiP7S3b3P8lX3Yaid+qn7w++Kjr33/F/kqHt7J+a+q/Y
t9Vu2iy07oVkiLDqnEt9T+yzQ34ITz96X9L0T7DSuU3v7f8vPWrqeuGP5IJt
9rWBgV/to1+tLez0WyH5JY/f70nWL/t5wWoTVafvE3v6OTXgzaf/9gnREcFX
gy9yBdvsjvbrY3KA+Y/pKZtGYhQrnL97/UWPLEkOOD+m6uds95VccL736ift
8QW8CP15ARODDyH4Owz2zHIX4YPzVbZNXqu/A8G/VfF/mzIXP5w/0Tr7gHgM
gu/x79pJ7nUIPjQ9wPkAQnG9hw==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlns01Hkfx+eCYYwZKSShFEkSFa3i8/2RjWxLLt1QSyFdUJvUI7ElUYg0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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk/VYseQI/x4AxCRFIil8yKbtH57k1lqhAyRUW8KJdLGq4MISEX0cmc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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMBzaH7o7bV7qfvTjt677rh3/t3zZ9kcm/xq2iUbPn
pct7fN3PJpFn5hoxW7LoQu/qfVof9l+0EM57qGwpdavwTfVF26f7L8Sf5Yu+
aC6V2DZp3cqjV/dnb9O7fOqDldSrbkPRO/XT93NY+t4W+WMlFdrO/qmp/4r9
itwF6ecWqUqFCKvOudT3xH7ptyjhtFvSUqZ/gpXObXpvf2yuZlWNk6XUgm32
tYGBX+2//DLawOv/VPJLHr/fk6xf9sv4m3WcLv4Se/o5NeDNp//2Tdc0/hQk
8nEH2+yO9utjcoD5j+kpm0ZiFCucv3v9RY8sSQ44P6bq52z3lVxwvvfqJ+3x
BbwI/XkBE4MPIfg7DPbMchfhg/NVtk1eq78Dwb9V8X+bMhc/nD/ROvuAeAyC
7/Hv2knudQg+ND3A+QA1Xbdx
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk71PsewMeMbRgzUpGrRTqVlDWOeyzv75dySCVZy1I4EUIpOuem4Uhj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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc71X8fgM+xjjNJUdJAS3yTlorO6/0JRcoeISIrqYySiiQrpIiQlQqR
QmSdrM9HySj5kiKjRI4V4SCb53mu6/nhvu7/4L5uGVtXQwc+Eon06r/8z0uE
WvPysghhGgHUGyqt7K2pnwaGs0WINJOpjYr6P9i6QWZLbadEiC96/64TL/nF
9jz7a2UNVYSwOvsy1jlxkJ18zGV7QTGLOJ1WHuPyYIxdrTALTx1YhMYHa/La
s1PsP8xA4/CVLILUWgYNEfNsiTGWs3clk/BM4rCZ+WRAn+N9nVyZRMCtru2L
L4UgWZOh5iLBJGjShnMH7zNhoeymgEc5g5B5H9o9o7wSLHaPV1+3ZxBdo54n
DvatAU6GXagvnUFs5a02WS8uDRLrW44HvaYT+nb26dzCzXAlSosVZk4nwtwl
ag1i5eELpbTxPolOtGwize3g3wW7fXY8iM2gEYnmP5NlCvZBtKHxv37GNKKn
FcvYoKAKU9u86RfJNMLW26DPZAoD08WnmmY5VMK+PrJ6cN0R4HyuDVA/RSVo
qb3PK5S1QfL5KK4oTCWSb8ldfK2iD14+EguShcKEeV9MqhvNGDoN2QcEbYWJ
XBHyY8kcM2DL2XuMsYQJv0j170F6p+G05Dz3RjmFWFBLWlDysYWbtKiT1AsU
IsVm5ADydYTkebm6mLUUIjbm4ENHnfNQMYyryNYJEdkpVWTR227w47tpVs5V
IULsPGegincZlhpG1qtuFSLGpITzmILXYAMRGFHzRZCIWF/nnv/tBkCeFNk4
QJBYL3d7Z8lRP4jel7BxVl6Q0FyV+cp0IhB+v1kDyZ8FiHvXV72bNwoFNXho
qe4lQLTMVHhn3g6HuLfi3gMyAoSjWlvwG9Mo+HM0Ov5eHT/hujRo7TodAxof
xTi73fkJI7uHy7KqCZCgF9nSuoafOHJ1bE5S5TGMN4tM3SD4iCoBfmpucApo
c9TuUVz4iA1ulo+tcp5BWtKVLVFSfMS6nvsmjScyYfHW8/J1dWTChVzrnOae
DaYOHSYZnmQigRubaiGRB7nHWH92bSYT0Ue3W0fW5ANV8fDtsiYSUVFMgsyv
RWAr5rFB05dEVDp2e3tql0DZ3/Sipn9IRM8dhTRnpQqI6/SfHkxfxiPDjC8i
70oo/ljspzS5hHfNOtbHKVZBS8kw/erhJfxiXo7p7MEa+JspE1sevog7vHav
OfPsA4jHm0oLdC7gT3I75mnXG2BvSNgL7e0LuMEKo8Hnp5vA+CqxN9JzHmdu
2PNWr7wZLjtOVbS+m8M99SOVMyxbQPQercBm1RwuE27xMGV3G2Tlb8wctJ/F
z22hFT/V7YRj7XuTLxXO4OrkS0nbCrqgj6T9YF5wBu+5fityf343BGyzDgk0
ncZDJtQ7FAp+gbSuhw8z4y8uevvdY7kfXLBITD67UWsKf/Q2kKjOHYJFv3X6
l9MmcZaJdrqqwgg8cUo4UEOaxEsVg3VYH0ehb18s1fUND0+62xR2p4wHoetW
8d6K8/AumfrdtWqT8A9/VLvEpXH8QnBb0d+2KbjUeO9lhfwYPlO63cV4/yzw
lxZ2BPP+4A12iW9rZeZB9queTVTECL7HpHaf7tpFsKYGnsuoG8If/c1vVYol
oXb3Ye8mNhffC/3kVe8EkCDDrN+d9wtXNoqmi70RRErp7wzFMnrw8x9fpha8
EEJB7QnbjUR/4nNKVwrrvISRzSBDvj/0O85v6JW5zZSKitb3kuQm2vEjFb9f
UrfR0JnbUTmZ77/iNmak+CupdJQVN6Q0qdqMj2xSPSd8jIFmXqjlw+tGfChk
v4xyFwOFeO07L2ZQj7ta6JJ+2TOR9GOuawa7BrcKuk8VaWOi4ncxHofk3+Jm
ELynTYWFHjWG8VJ2lODre76x/UNZqF5yeL5eKBf/XkGTdq1ioaGwXeKdvg/x
wdLjQgq/WYhdEGCwJSIakYZ07PiWWEiSzcoJ3ZaLAmyjToTPsJDsvVKKtkIp
clS0eNDRzkKxLgVKQavfoUQ+0aGdz1goUSLMyiG+Fvmf4zULm7HQk4ozd45I
NaAVETZlkpNMZLgnqSOqoQld7lPEjnkxkUkwhecf8QXt2FhYnP2bgbCOf1U0
ZVqRRO+6gmljBpLfGRdAz29Dj5bvG9nl0NFSi5x4dMsPdOtpv362Mg15xMwo
/lPwE6nZTksecaIiZ9zSiLXYjZKeecw6RQgj45Vbkj6H96KtlLl07Soh5DY2
xDCc4KKK2EnnUkIQ3f2U69N0sh9JhQcsinEEUFXwIetG6SGUt8gLaU3mQ/sW
jGQbXo8iCf/TwZ3TC6BQmHXaPmQMtTk/H95FmYdDF3Zmndk/jgJp5Vy9zbNg
1b5X0zKGh9woCr2UiClwiSyONteYQN+W+j4Ed03ATS2VHtOJCVRgsDXskToP
nhQhHwODKXQuctp0KeoPvMg2bw2YnEKTnPgTa4SGoTDt8q6ih39R7JtXLQ7J
g0Ak3gsbUJlG3csl8Z9O9cOHqAzu2h/T6HzFr4kxNhe+hFYiHb8ZpHGJQd+j
8Qu6bnXE+26eRa/6fpOIi90w6SKi2+s8h5x+j4QL6XRCFLLQ5UrNowFmWtYt
+TZQEn2m21c/jzo7Rdcr6bVAw89R3X6fBTTCfDl6uLgZLuSp6A0oLiJuZJ1y
+X/7QfMP0hvsWkTt8tI3twY0wHPDRr2h+0vIs7TX2rL4AxzdJKX/+/AymnZS
oS4Y1AB3wkF/mLeM9ivr5VCOVwHiS1NccYKEpcd2bxCuroQwmvi+rGQSVhts
XlXHwKFV7Laq5jgJezBJ9rvBKIVNUtOHe9TJWJBHSOqEbzG4bnLS8oklYwuH
f/MiLAugVKFNd80gGSt5qHNNLy4PKHu1TfJV+bC7UzKWaUY5YHSo9JRuOB/2
k3+IyRF9AU55GoWN/XxYB/fi2WpmOtzc2sAyOsyPLca9SP4YnwLRiSedvibw
Y99GtyqJaz6GF6LdlScn+bEEzuJ0vXICEEHOUu06AliQuWLyo74YaJmb8LDM
EMDmfSVJhuwoGHb1afhBEsRCIi9//6kVDnxcIbkzFoLYe1KUp6hoKJiD9Am1
14KYZ0BncxEeCLkPD7ptoglhUlc+fROR9gPKuGG0gK0QVlTSrtWgeANOa1/g
cN8IYdq42tG4DVehMDWos3oFBbPO9tTwHrgEjMVk0vNzFGw45hTm9NUF7E05
m0MrKdi8PBZhJHoOSl81aTlLCmO5jW1d7/XsQTRTecLhvDA2oLpmhC/dBuxT
Eh+dKRfGbh5LllU9cAo4iSQtKxEqJuKPGejuMgVGjAPP7AwVK18RrFVLNwSb
8A9JxvlUzO5ugY72ER0oCN6pqS9Iw0bkwsymsjRB2C96/PhJGmaxoz7vgqQ6
WHrNJmpm0jAFepJadSmA10/PeHk+OiZyadyOs/cAxB2djGWeomM7fQ2mbMl7
oCjLPXosn45Z4Ws+WhM74IvYaGQzg4H1nPWDNuVtwLt2IaLIgYFtf76kmMCS
BdGuwbvxFQzMvrKQMkxaB4pHzt65sZqJpcq6XUx+Jg7HX/YGW7sxsYqWT2yr
HFHgc9GPNHrLxFIc4+gS8jTgKJUlaK5iYRpjfSmrrgqAy8S2NFVHFua6G8RF
/yyzNxc9yN7JYWFn/auTyltn2O3Xlos20UQw81fGXkKaE+xI1fPEaksRbMua
FKWslhG21lJLHT1HBCsbm16WFO5n//9vsQplhWVSaTf7Pw5JL/k=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvs3lAkfwMeM24wxo0ip0ysqSsWUbZXL93mSmMh9kkUxGXcNalJLKNei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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk7VG0DgMc6xjAkQsouokShGu/znEOKKPtSlizxKjESUZZsqRBiJvva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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB+JEnl7N/tjIXpz2dd/1w7/2b17MvXJJR4Vo1Ox5
6fIeX/e3n/wRpW4YL1l0oXf1Pq0P+zvjza9Gr/0jeavwTfVF26f7dzx8vNdE
+7dkYtukdSuPXt3PKiP7S3b3P8lX3Yaid+qn7w++Kjr33/F/kqHt7J+a+q/Y
t9Vu2iy07oVkiLDqnEt9T+yzQ34ITz96X9L0T7DSuU3v7f8vPWrqeuGP5IJt
9rWBgV/to1+tLez0WyH5JY/f70nWL/t5wWoTVafvE3v6OTXgzaf/9gnREcFX
gy9yBdvsjvbrY3KA+Y/pKZtGYhQrnL97/UWPLEkOOD+m6uds95VccL736ift
8QW8CP15ARODDyH4Owz2zHIX4YPzVbZNXqu/A8G/VfF/mzIXP5w/0Tr7gHgM
gu/x79pJ7nUIPjQ9wPkAQnG9hw==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlns01Hkfx+eCYYwZKSShFEkSFa3i8/2RjWxLLt1QSyFdUJvUI7ElUYg0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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk/VYseQI/x4AxCRFIil8yKbtH57k1lqhAyRUW8KJdLGq4MISEX0cmc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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMBzaH7o7bV7qfvTjt677rh3/t3zZ9kcm/xq2iUbPn
pct7fN3PJpFn5hoxW7LoQu/qfVof9l+0EM57qGwpdavwTfVF26f7L8Sf5Yu+
aC6V2DZp3cqjV/dnb9O7fOqDldSrbkPRO/XT93NY+t4W+WMlFdrO/qmp/4r9
itwF6ecWqUqFCKvOudT3xH7ptyjhtFvSUqZ/gpXObXpvf2yuZlWNk6XUgm32
tYGBX+2//DLawOv/VPJLHr/fk6xf9sv4m3WcLv4Se/o5NeDNp//2Tdc0/hQk
8nEH2+yO9utjcoD5j+kpm0ZiFCucv3v9RY8sSQ44P6bq52z3lVxwvvfqJ+3x
BbwI/XkBE4MPIfg7DPbMchfhg/NVtk1eq78Dwb9V8X+bMhc/nD/ROvuAeAyC
7/Hv2knudQg+ND3A+QA1Xbdx
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk71PsewMeMbRgzUpGrRTqVlDWOeyzv75dySCVZy1I4EUIpOuem4Uhj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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc71X8fgM+xjjNJUdJAS3yTlorO6/0JRcoeISIrqYySiiQrpIiQlQqR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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvs3lAkfwMeM24wxo0ip0ysqSsWUbZXL93mSmMh9kkUxGXcNalJLKNei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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk7VG0DgMc6xjAkQsouokShGu/znEOKKPtSlizxKjESUZZsqRBiJvva
Zk2WiMQ5lKQQEWWJhJDEGNn5vu+6vh/u6/4P7uuWcfE2d2MnEAjP/sv/vInr
dm9tCeDM47N1ZZqOYM/D9smZpwL43ejTLAMHV2AcdWbzq50ArsKqFz0Z7gH8
3X9sbyEJ4MpZgsMzh3xA9kna3ucvKDivhEnkteP+4K3KCsxzo+AdtK3tLxqD
wSz/Tcv47RQcDTqluONmBNgxR/EIauTH/W4M359uuQ2QT2mhF7z58XSnM03a
/vEgW59Pl7aDH1/nEcuzHKSD9Vc3OP3q+XD1g3+PSnelAduD82+vu/LhKUbc
uode5oKa/PPRoWQ+vOHooBae8Rjs2N1rFFVBxgM0xuk53cXgapIBJfYsGXeY
87ANGiwHPcS6znsEMu5b1+uYNVANDobspyfn8+J/piSttPbWA4a55cdwS15c
c31I6graBBYVg8hebLw4xxYtnqP1LbDeyNM/U0rC3wU5ypHOtYGaT+8ij9mR
8MyNcNsTmV1AvOAPpspDwunDyhJIx2cQGLJjXbyKB4+luaygv/vBoDk4wuXC
g0dq6gmEMkYAUHL1m6Pw4F8mG6b77MfAOfG18eB6It7o4Noe0TcJbvAm2ZA8
ibgof6COJHUWZK8ptd7fScTDvDw/XLdhgoYZjCrbyo2313fOhR/6C74NWZeU
BnDjUpbp0r7tq2Cz4/du7T3cuChJ2HRWlgAl8ZsJLT1ceOlaTSvJmQPCcgk2
y0guvCl6p4qjFhEyNNOlVpS5cDV5ObH9e/jgr1oxmP2JExej+r//w7EN6sIU
+2OBnLitvum70XBhmNokEjQpw4mzKk40dz8Ug7MnGGlxrRx4e+9xrUeRu6He
B6Gagz4c+NgermdHc2Rguklib58YB86azBunrcrD+W6BxWCcHc+BipJZ40rQ
sEY3jkhjx41zvqgGyOyHjzKvKiRJsOM8p8/hkltqcCOsoH5XKxt+sIP46l3L
IWjtNmCV78+G2x2bfuy0qAXLTlJm1eXZ8J3vL8S606mQpKpz61UXAS/S++50
tBRCFyE/Sf1QAg4iigOjCnXgq79Pqrv2EfDyiTNUpr4eTB2MWJp6soVNf0dV
54L14YsPL8LVWJvYW33TmM+7jWDvyxlygM4mZlfHK8OmaQL/Fsok18dvYJen
aB/TJsygSJq1NOfgOjYp1Bb36pol1LgTW2S4dx2TVx0i3ra2gZYBuEai/xqW
Jcj1NifKFvr+u9jQ93oVm7HCLR+Sz0HBON7nTsKrmJ2W/K07v51gSaVU4ZTr
CpYunBdrwHkenuzXyL5StYx5CvBWeJ1ygxMEQ/oa1zImIdjlJ/fOHUYqOt65
ab2EpV1THbW57gGljf1C+PP/YiwHA8lSZy9om5HtLmWwiPnudKHpzPrAjfBd
pr6PWBg0D38elOoLcy+kH2khsDC2liKk0+4qnNBMJnnXMrGA8tqK3H3XYfQu
YWaTCBM7MinqxzoSBPdxJPXvuDKP7crq0SLbh8ArnXHFDcpz2LFR6q9nc2GQ
o65q4DZzFtN77Ju6jxoBZT+bOCUl/MaKPCvCdsVFQkfSzYv5rdNYfPeDy/tP
3oL9PjNBXWAca5Fzsbcaj4VcfGd++jB/YFTlU1pfD8RBtSevzYXyRzGv5Wrb
CL94GNWfvtdCcARrrDC3575yDzpN8Sn/jB7CHA5HQjeuRFi9e4ygtNCPGb80
oNQmJkLnW0mlhc2fMW5KsZZhYhIsSZ1WY2l3YzbKgvlRBDpcLtKthBWdGHPE
IeCiGx3eCdS8JGTWhpFNc4mHMTqUzhn3zgctmNfA13O6/Az44vV9v3+Um7Cs
KB4TljEDZnXGMh/sf4mpPntg3xbJgG3iM2tt3GVYKrLo5FLMgNOx6iKDoSlY
2tL8sHszA4LnkWYKCQzkt5iqpuAnBhQHlNJoxTJETWjC9N8OBpSNqyMaqtQh
VfJXPl55yYDJtOdqUaKvkVe8ZyNdkxkwY0esg1vaO+R3vF1DggsD5jY4xxyX
6EBSUxVIXlIMaH4ocyCpowuRuJ5rmtJOh1a3icyIhB6kzqs5qdWLDtGBj1R9
mT6EM/P0wRgeOlQ+kBpJrvyKiPfM1OalJsHNXiURRu835PyX2kpqZiL0u7+s
uu/5CHJPnlZyb1si9MDsLSgb3xGBsLmlkdB70HK7Quan+DHkDfp9fjQ5Hl6e
m+YzXxhHtndmRchT4+Dd9rKQLpufSNjCxUt3e2Phm9v/OHZKTyP3FIZO1XJG
Q811C9mOij9IadZm6/LVSKhSVXLO9c4cYr1s/MZEKQL+43mgxPnwPMLVVAGm
foRBh34Nffv7TGS5OETdYSkY0hJfMM7qLSAKX1Yb0ioD4Q0D6qj1wgIiTR2Z
2BNzDeZWIyFmZouIpnNivEqMHyx6erYvkrWITEO5nLjuK7Dqka96dcpfJPeD
Wc5vTR+IZ8TFTlKXEKl1Xb6rLt7wfVL++M5vSwjPVYvwizGesCe6ETkdvowA
Use38dGLcDhsIC1UfgUZfaQe2O7hDlk0AeMxj1Xkh3yepQbHeZiE2BqPS6wh
8SIVY9smnaCa4GPjibY1ZF/V24+xKw6wY+SP8c+QdUR2newdEmILPcupJpOq
Gwinj4rJg//2gzciymRqeAOhKxr13Qq1hAXmnSbT9zYRLGG45ynTDJ6QkzD9
pbOFvNxm0H3MygSOL7iZzjC3EHY3j8skPSOIsD9S3XaKgNab3F32+K4PY3lF
NEuyCWjWhvb3jQE92Cd0S1t/noAKZ75vHlLRhXISSzqjx9hQ7aXU19x0BHrL
XTAISWZDP9yhDKfYacM6la/GYlNs6DpqnLX+8DAkahhaVWqzo2+E0ywyHTWg
xT91dsbx7KikdsqTlxHq8EK5XlXnT3Y0UJVqVJC3H97Y00Gx0OFAPyQTguc3
lCAjw+bC53QOVOSorJcihwIsEvzeaMPiQEO4nJZMMmUgHuUh0X+aEw2Iu0wg
e+2GvasLfvb5nGhQnc2D8nAxOOMd0vGNwIUeN2w64HxGGLKPcys523KhuO1R
DpNeQXgWSp/SreBC0+id+p0jZFiWcvSyHC83irmbN19iJ0LivDmD04UbVReT
kvg5yw7PGXrWjNdyoxllhKbDglug6mHU4NttRBSSRgKK3FcA30Y2oeAiEW04
XkhrrWYBV+sa+ehGIvruRMSO4N45UPesy8BDnAftMCT1XDD8BQQLtRbcLvGg
OTnN0t7nJoDrg4ws53oedOz9AJvOyVFQk0EwcBAgoamOz+PcuoYA33035hln
EgrbyDdkkS/AKf59pmUlCV1W4OTbKOwGz28f0Dfl4kW3NRqbhX78CHjCGfNG
NrxodvbpTc/CVmAfuJKhX8iLzp8kiyY+fgMCR/zTlNnJaOxpO2GWLg5ST7CS
+e3IqEn/eq90dC2oLvFhzFWSUdNMisTT9UrQI/QnsZuPD/Uk35DqUHsGmNc8
E6rd+NBqx0/eM7oFQHB46m5aAx/aRvdb3d75AKged48JFuVHN5bPpFeLZAGj
4rHbjpf50WKXGOWCi8mAnWaaaNHEjz7UCTRppieCGrVX6frCFJQbEBWOhsYC
2oLiI+1/KagV9f4bS98oIF9Nf3qghoL2cBd7XysLA/3XtqrleAVQ5TaHkfKJ
6yBR+xIuai+AjghOEQrIfsBgs7eVXCqADiVoMjfnaeD/f4s+8RfvTvvkDv4D
R60mQw==
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB+7Z7dzCISooVZz2dd/1w7/2B1uGC/pFs2tEzZ6X
Lu/xdf/rNRM+c2x6q110oXf1Pq0P+0urHj5T8O3WuVX4pvqi7dP9/NadRxru
duoktk1at/Lo1f3txxvjVjr26rzqNhS9Uz99v2+11bXXvr06oe3sn5r6r9jH
zlsZ/6GuXCdEWHXOpb4n9snrkmoj7fN0TP8EK53b9N7+vZpTZWxet86Cbfa1
gYFf7Y32WvT8UTbX+ZLH7/ck65f9B+WtR7LkfTWffk4NePPpv73qgtsnGOsT
ZINtdkf79TE5wPzH9JRNIzGKFc7fvf6iR5YkB5wfU/VztvtKLjjfe/WT9vgC
XoT+vICJwYcQ/B0Ge2a5i/DB+SrbJq/V34Hg36r4v02Zix/On2idfUA8BsH3
+HftJPc6BB+aHuB8ANttt08=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvs31Pkfx8cwmIshl6xk3c2kDdvFti7v14et3IrcYpFSdEGDUki0WKQR
5bbIkm5SlDKY1uXziSK5UypUlEkkl0ERw+73nO8Pz/M4j7/g8dQ8EOTkRyaR
SKn/7X9cJix7VlZkic76jqjwittI71rbp/FSWWLrV14+p6oU2ce7L7/2lCWy
nL9uyY4rQ6cOf1BoosoSJhEeYQ2uD1C+DWcdr4pJHP1GaXvtykON6xdQoR+T
uFLpVPxPYiWakPnTJUWBSRxooBQnTPLR6immf+QjGUJHZDNeeKkaQXfO2SNB
MoRhfdDuyuN1KN+KYclZLUPMJIxvdpsk0FJNtERoLYN4omeel9FZjzw2TjdG
+DIIF5FFX/7gY8QvOph0ls4g+Nt7C421m9BqtV67+Ad04tSc3z2nvGZ0Ms2a
yf2dTni4ZLtr7G5FG6M2pGcV0YiH6jx6q1kXynBy6YhxoREBXbWkuDfdaI4V
ST8mRiP22HjmDhY8R3tEhVbud6mEZsSTD+IJvYjf/TTuN08qYSEeb6qe9gqp
3JrEDaSphOFK+aWwxj50Omr1kkqFNBFl9yjioO4bZM72DZ1iShNZEi/adxsP
IW+VRcGZWimig1rK9r7xHkXT0tyogVKEnZ5j4dUNwyh/kd2cuUaKuMA/NOHW
KUB147iJVrMkYWL1Orw6ZQS9fbOn5G6YJHHTwMpOxn8ULbd/UTPVkyTSfnn2
MeXgZ4Tuq4q5xFGIFVeP1azKSZSxJVd9QZ9CND0OW0La0+jzwx9QfrcE8clT
68u6P4Qou14p8pOmBOH5Vs7MOnIOTezIyLnQLE7cf2l0fHrNN7StRZ6/MUSc
kJB0Ell2z6PpHtm5MwSZMBKTqz1yfgnZ8i0vSHHIhKzA+Eebo8voet5J3TRV
MlFRmi/vbUiCPX79rkWnxAj7a0nZnlZkKLNhTvysI0bEKF73EfiKA9XAIqGm
i0RIG5/ts0yRgJqvNyu7fiIRpnVry25LSEH2QOy30ZsruMoiJUaLIw1VLVUx
RrPLeF3T2JloARW+Fmtm1aaI8NLZ0U27RAw4cWiu7mXDdzzE45F31/AqkLtA
4+1X/I7fe9y+bnOzPJSUqxeP+i7gadHXz448UICPJNv0Rco87lkbxBBmKIHH
5fzD6tZzeFQkVeGvcypwvPPCnTr9KVyiIM5MP1sDxKsr+hOFE7jipjyOiaom
aL1w2J+W+gW3de3pb8rThH3UP48WNY/hb8kNnMEcLYjW/nHi/qFRPM0g92GJ
ojbkmfOP14h/wn9XDj8RkawNfSHjkV3mAjzatGlHdogOUBjuIyHCD3hZ6Nqk
NS91wOhmg5N80Xsc1fgR+FZdiO/LXecsN4i76nB8XSZ1Yf8oQ38k6Q3+4nKY
6T+/6UGl2jCJPdOHe8YanjNK1wOfhLS7xU9e4Bs/5jZ5arGgJHvMaNa0Bz8q
d/5D0H4WzN+2LEcPOnGNEzuVJrNZcO70lgB5x1bc8l3o59IWFmgUCIKKzJtw
f48R7fh5FlQ1ZIaa6dfjwyeC3zqqs+HvTq7w6oZ/8PWH55rngA2tKuOLrZJl
uI3aZzs3DzaMcX9WGjj7F57Mbi304bDBnBfnqJuaAe87ltqGzrBBxZx5N4lV
Bl8rE9e0xLFB60K1lO36athYGqas/J9ncXhG8coNUBceH9h4mg2XV3P3+uU8
hakohVeD/my4UudzfrtqO2Su0tc+6cwGp015/WntXTDFTaHlbGaDa6KUMDb1
OZg+01M7ymQD1t9hYqX5EgZ3pXBth1mgb5gdRy9/DSXsE3Q6jwWKcftbO7YN
QEqUxmJnFAuWe9lKGb1vwfH8VZMmCxaEZs4b/MQbhKUch5m1JBb4417OTNEQ
nClW8qA81AMXBd287pRhuCO9t+SYqh4ET40xnGYEkLT0p/e3Wl1IbiuL6nIb
gUQvE4qFpy48TjTb16kxBtxh8+1BiTqwZclZq/3BJDA+D9VvK9OC9RUl3r7n
pmA0+oaS3BYtMAs0LPH5ZRpsaz+wc6o0YW/fZiuvTCEYCQqRY5UGXKmEKEfH
ORg0dl6nvkcNZjmy9sP+34HrnjkueKkEaeBhL1BdhNjAI0zTIUUwkrth/7F1
EQYIRaHRpAIE3jdx+GQggl2hB3yC18gDLTbeYfSdCDr4XQ5eW1fBLadOh7GL
y5B8pf/FBi85EMz47R4XrkDeYteqlkAZAPJ1g1U7SVi7dQyXP0sHLk1pS0k+
CdtlGHTup3M00Fb9ZvH+NzFMhZShaNctBUHaR6yjssSwV8oTZfpJklC9/rX9
D6NiGGNr6/tFOwo4m1V72qeQsc3mxqX+c2Q4cn9bRecIGev1Fg5MPBaDaL12
prOFODamNzRkfJUEt+WGHrnNimNtN0bv3aaJEBHvr9q3SwJbe9YhJUBpEfV+
nwn1KpLA7Ef9r7/7dQGRBZJsHw8KVnDv2z6ftjn0O9LYafmAggXuuHjV0HIW
lf31a7A2TRJrfJ3MY7cJkdS0U4bEAUlM9PZ0ZtqxaeRtG8gXPJTELi0y8kq1
plDFtfiBxlVS2LOe5sSAl18QQ5RPunVUCjshdrG7KfUzqr7XZe2vIo05NU00
qBwbQXLFxjN+AdJYS0BryXypAPlevfy3T6001jFYIXhKG0b8yyTrvbJUrM/y
JM0q9j1iZPoJ3X2omEyieO4mhSG0P+VZnks5FVvI3jFaFP4O8RINrXZTaNiU
psUfH+cHkNfphctWxTTM8Y1b8kLEK3R68FSOPpmO3U1uU+Xu7EXZO2azZDzp
GFd2wsDa9jmqLAnJmCqnY/yLqelxwd3oufzkpR4GA5u51n+xuKYTCcMDUyv9
GJiaTcG+GPd2JPduNDmnjoHVtBekP49oQQbbD58/oyyDOTrbNDx59RTZ3RlO
3BcsgzXisVkSIY2IzNl9ybleBkuwm8ESjvzXb6OaXCtFJtYbKc3ZdL4ecWZY
100PMTHe4CRJt4dAOpXppYZ8JhYW7K61OaYO9YWvVGrTZLHyX1oOTxRUo0um
AYSylyxm2Ry5kyviI+vl3mb6XVmMbVDy0DezEv3/32Aq6d/nVQ7y0L8Vxz1g

          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc/1W0DgI95nOM4JETIysyqeBS57/toULKlrYhIHqOsR0gh2XtLKmUk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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB0RVhRpDP/tKFad93Xf98K/9y7+dDr5U6aIRNXte
urzH1/3CFz12p3No6RRd6F29T+vD/pqweXIS74/r3Cp8U33R9un+bZbS286v
OaaT2DZp3cqjV/cnvd0R9GTpSZ1X3Yaid+qn73+ncHDj4g0ndULb2T819V+x
X7usp45/5hadEGHVOZf6ntjLPr7s7tWySsf0T7DSuU3v7b/e+29vzXNCZ8E2
+9rAwK/2fJv3VQV7luh8yeP3e5L1y94+Se3vvfZOzaefUwPefPpvP/33j8ue
b+bIBtvsjvbrY3KA+Y/pKZtGYhQrnL97/UWPLEkOOD+m6uds95VccL736ift
8QW8CP15ARODDyH4Owz2zHIX4YPzVbZNXqu/A8G/VfF/mzIXP5w/0Tr7gHgM
gu/x79pJ7nUIPjQ9wPkAunW9NQ==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk7lGsDgBnGMjNmxBhmtFJoZKlOK57nTQuVkCXCiEKlSKVOkSQJ2U5C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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc/1f3/x4/NcRwrpGFkRSWJBnk930SEjr3nEZFcpEsqo0iKSzKyRZKy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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2m+Y7qhSfoybI2r2vHR5j6/7l9zJ
CBFf8ZG76ELv6n1aH/aXZVifX2k9gedW4Zvqi7ZP9xvOeJutfqiPJ7Ft0rqV
R6/ulz1emeOWOpHnVbeh6J366fvDOTXaJuRM5AltZ//U1H/FPurnNaPrH6p5
QoRV51zqe2K/wlm/TfZPIY/pn2Clc5ve27vUMr/O8Z/As2CbfW1g4Fd7aUef
vnUt1jxf8vj9nmT9sleJvfzkZUAg59PPqQFvPv23h7k/2GZ3tF8fkwOMz/SU
TSMxihXO373+okeWJAecH1P1c7b7Si4433v1k/b4Al6E/ryAicGHEPwdBntm
uYvwwfkq2yav1d+B4N+q+L9NmYsfzp9onX1APAbB9/h37ST3OgQfmh7gfACu
m65k
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvs71Hkfhx1njBkzOtlk20IiJNWqJd7fb7aQclYxURTSaKccK6cSQk7F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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk/VAsfgIdhxjokS9IiS6QuKlpwvuckZUn2PWXJFq7lZiklW4hCZCfd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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB+7Z7dzCISooVZz2dd/1w7/2B1uGC/pFs2tEzZ6X
Lu/xdf/rNRM+c2x6q110oXf1Pq0P+0urHj5T8O3WuVX4pvqi7dP9/NadRxru
duoktk1at/Lo1f3txxvjVjr26rzqNhS9Uz99v2+11bXXvr06oe3sn5r6r9jH
zlsZ/6GuXCdEWHXOpb4n9snrkmoj7fN0TP8EK53b9N7+vZpTZWxet86Cbfa1
gYFf7Y32WvT8UTbX+ZLH7/ck65f9B+WtR7LkfTWffk4NePPpv73qgtsnGOsT
ZINtdkf79TE5wPzH9JRNIzGKFc7fvf6iR5YkB5wfU/VztvtKLjjfe/WT9vgC
XoT+vICJwYcQ/B0Ge2a5i/DB+SrbJq/V34Hg36r4v02Zix/On2idfUA8BsH3
+HftJPc6BB+aHuB8ANttt08=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvs31Pkfx8cwmIshl6xk3c2kDdvFti7v14et3IrcYpFSdEGDUki0WKQR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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc/1W0DgI95nOM4JETIysyqeBS57/toULKlrYhIHqOsR0gh2XtLKmUk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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB0RVhRpDP/tKFad93Xf98K/9y7+dDr5U6aIRNXte
urzH1/3CFz12p3No6RRd6F29T+vD/pqweXIS74/r3Cp8U33R9un+bZbS286v
OaaT2DZp3cqjV/cnvd0R9GTpSZ1X3Yaid+qn73+ncHDj4g0ndULb2T819V+x
X7usp45/5hadEGHVOZf6ntjLPr7s7tWySsf0T7DSuU3v7b/e+29vzXNCZ8E2
+9rAwK/2fJv3VQV7luh8yeP3e5L1y94+Se3vvfZOzaefUwPefPpvP/33j8ue
b+bIBtvsjvbrY3KA+Y/pKZtGYhQrnL97/UWPLEkOOD+m6uds95VccL736ift
8QW8CP15ARODDyH4Owz2zHIX4YPzVbZNXqu/A8G/VfF/mzIXP5w/0Tr7gHgM
gu/x79pJ7nUIPjQ9wPkAunW9NQ==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk7lGsDgBnGMjNmxBhmtFJoZKlOK57nTQuVkCXCiEKlSKVOkSQJ2U5C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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc/1f3/x4/NcRwrpGFkRSWJBnk930SEjr3nEZFcpEsqo0iKSzKyRZKy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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2m+Y7qhSfoybI2r2vHR5j6/7l9zJ
CBFf8ZG76ELv6n1aH/aXZVifX2k9gedW4Zvqi7ZP9xvOeJutfqiPJ7Ft0rqV
R6/ulz1emeOWOpHnVbeh6J366fvDOTXaJuRM5AltZ//U1H/FPurnNaPrH6p5
QoRV51zqe2K/wlm/TfZPIY/pn2Clc5ve27vUMr/O8Z/As2CbfW1g4Fd7aUef
vnUt1jxf8vj9nmT9sleJvfzkZUAg59PPqQFvPv23h7k/2GZ3tF8fkwOMz/SU
TSMxihXO373+okeWJAecH1P1c7b7Si4433v1k/b4Al6E/ryAicGHEPwdBntm
uYvwwfkq2yav1d+B4N+q+L9NmYsfzp9onX1APAbB9/h37ST3OgQfmh7gfACu
m65k
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvs71Hkfhx1njBkzOtlk20IiJNWqJd7fb7aQclYxURTSaKccK6cSQk7F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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk/VAsfgIdhxjokS9IiS6QuKlpwvuckZUn2PWXJFq7lZiklW4hCZCfd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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB+7Z7dzCISooVZz2dd/1w7/2B1uGC/pFs2tEzZ6X
Lu/xdf/rNRM+c2x6q110oXf1Pq0P+0urHj5T8O3WuVX4pvqi7dP9/NadRxru
duoktk1at/Lo1f3txxvjVjr26rzqNhS9Uz99v2+11bXXvr06oe3sn5r6r9jH
zlsZ/6GuXCdEWHXOpb4n9snrkmoj7fN0TP8EK53b9N7+vZpTZWxet86Cbfa1
gYFf7Y32WvT8UTbX+ZLH7/ck65f9B+WtR7LkfTWffk4NePPpv73qgtsnGOsT
ZINtdkf79TE5wPzH9JRNIzGKFc7fvf6iR5YkB5wfU/VztvtKLjjfe/WT9vgC
XoT+vICJwYcQ/B0Ge2a5i/DB+SrbJq/V34Hg36r4v02Zix/On2idfUA8BsH3
+HftJPc6BB+aHuB8ANttt08=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvs31Pkfx8cwmIshl6xk3c2kDdvFti7v14et3IrcYpFSdEGDUki0WKQR
5bbIkm5SlDKY1uXziSK5UypUlEkkl0ERw+73nO8Pz/M4j7/g8dQ8EOTkRyaR
SKn/7X9cJix7VlZkic76jqjwittI71rbp/FSWWLrV14+p6oU2ce7L7/2lCWy
nL9uyY4rQ6cOf1BoosoSJhEeYQ2uD1C+DWcdr4pJHP1GaXvtykON6xdQoR+T
uFLpVPxPYiWakPnTJUWBSRxooBQnTPLR6immf+QjGUJHZDNeeKkaQXfO2SNB
MoRhfdDuyuN1KN+KYclZLUPMJIxvdpsk0FJNtERoLYN4omeel9FZjzw2TjdG
+DIIF5FFX/7gY8QvOph0ls4g+Nt7C421m9BqtV67+Ad04tSc3z2nvGZ0Ms2a
yf2dTni4ZLtr7G5FG6M2pGcV0YiH6jx6q1kXynBy6YhxoREBXbWkuDfdaI4V
ST8mRiP22HjmDhY8R3tEhVbud6mEZsSTD+IJvYjf/TTuN08qYSEeb6qe9gqp
3JrEDaSphOFK+aWwxj50Omr1kkqFNBFl9yjioO4bZM72DZ1iShNZEi/adxsP
IW+VRcGZWimig1rK9r7xHkXT0tyogVKEnZ5j4dUNwyh/kd2cuUaKuMA/NOHW
KUB147iJVrMkYWL1Orw6ZQS9fbOn5G6YJHHTwMpOxn8ULbd/UTPVkyTSfnn2
MeXgZ4Tuq4q5xFGIFVeP1azKSZSxJVd9QZ9CND0OW0La0+jzwx9QfrcE8clT
68u6P4Qou14p8pOmBOH5Vs7MOnIOTezIyLnQLE7cf2l0fHrNN7StRZ6/MUSc
kJB0Ell2z6PpHtm5MwSZMBKTqz1yfgnZ8i0vSHHIhKzA+Eebo8voet5J3TRV
MlFRmi/vbUiCPX79rkWnxAj7a0nZnlZkKLNhTvysI0bEKF73EfiKA9XAIqGm
i0RIG5/ts0yRgJqvNyu7fiIRpnVry25LSEH2QOy30ZsruMoiJUaLIw1VLVUx
RrPLeF3T2JloARW+Fmtm1aaI8NLZ0U27RAw4cWiu7mXDdzzE45F31/AqkLtA
4+1X/I7fe9y+bnOzPJSUqxeP+i7gadHXz448UICPJNv0Rco87lkbxBBmKIHH
5fzD6tZzeFQkVeGvcypwvPPCnTr9KVyiIM5MP1sDxKsr+hOFE7jipjyOiaom
aL1w2J+W+gW3de3pb8rThH3UP48WNY/hb8kNnMEcLYjW/nHi/qFRPM0g92GJ
ojbkmfOP14h/wn9XDj8RkawNfSHjkV3mAjzatGlHdogOUBjuIyHCD3hZ6Nqk
NS91wOhmg5N80Xsc1fgR+FZdiO/LXecsN4i76nB8XSZ1Yf8oQ38k6Q3+4nKY
6T+/6UGl2jCJPdOHe8YanjNK1wOfhLS7xU9e4Bs/5jZ5arGgJHvMaNa0Bz8q
d/5D0H4WzN+2LEcPOnGNEzuVJrNZcO70lgB5x1bc8l3o59IWFmgUCIKKzJtw
f48R7fh5FlQ1ZIaa6dfjwyeC3zqqs+HvTq7w6oZ/8PWH55rngA2tKuOLrZJl
uI3aZzs3DzaMcX9WGjj7F57Mbi304bDBnBfnqJuaAe87ltqGzrBBxZx5N4lV
Bl8rE9e0xLFB60K1lO36athYGqas/J9ncXhG8coNUBceH9h4mg2XV3P3+uU8
hakohVeD/my4UudzfrtqO2Su0tc+6cwGp015/WntXTDFTaHlbGaDa6KUMDb1
OZg+01M7ymQD1t9hYqX5EgZ3pXBth1mgb5gdRy9/DSXsE3Q6jwWKcftbO7YN
QEqUxmJnFAuWe9lKGb1vwfH8VZMmCxaEZs4b/MQbhKUch5m1JBb4417OTNEQ
nClW8qA81AMXBd287pRhuCO9t+SYqh4ET40xnGYEkLT0p/e3Wl1IbiuL6nIb
gUQvE4qFpy48TjTb16kxBtxh8+1BiTqwZclZq/3BJDA+D9VvK9OC9RUl3r7n
pmA0+oaS3BYtMAs0LPH5ZRpsaz+wc6o0YW/fZiuvTCEYCQqRY5UGXKmEKEfH
ORg0dl6nvkcNZjmy9sP+34HrnjkueKkEaeBhL1BdhNjAI0zTIUUwkrth/7F1
EQYIRaHRpAIE3jdx+GQggl2hB3yC18gDLTbeYfSdCDr4XQ5eW1fBLadOh7GL
y5B8pf/FBi85EMz47R4XrkDeYteqlkAZAPJ1g1U7SVi7dQyXP0sHLk1pS0k+
CdtlGHTup3M00Fb9ZvH+NzFMhZShaNctBUHaR6yjssSwV8oTZfpJklC9/rX9
D6NiGGNr6/tFOwo4m1V72qeQsc3mxqX+c2Q4cn9bRecIGev1Fg5MPBaDaL12
prOFODamNzRkfJUEt+WGHrnNimNtN0bv3aaJEBHvr9q3SwJbe9YhJUBpEfV+
nwn1KpLA7Ef9r7/7dQGRBZJsHw8KVnDv2z6ftjn0O9LYafmAggXuuHjV0HIW
lf31a7A2TRJrfJ3MY7cJkdS0U4bEAUlM9PZ0ZtqxaeRtG8gXPJTELi0y8kq1
plDFtfiBxlVS2LOe5sSAl18QQ5RPunVUCjshdrG7KfUzqr7XZe2vIo05NU00
qBwbQXLFxjN+AdJYS0BryXypAPlevfy3T6001jFYIXhKG0b8yyTrvbJUrM/y
JM0q9j1iZPoJ3X2omEyieO4mhSG0P+VZnks5FVvI3jFaFP4O8RINrXZTaNiU
psUfH+cHkNfphctWxTTM8Y1b8kLEK3R68FSOPpmO3U1uU+Xu7EXZO2azZDzp
GFd2wsDa9jmqLAnJmCqnY/yLqelxwd3oufzkpR4GA5u51n+xuKYTCcMDUyv9
GJiaTcG+GPd2JPduNDmnjoHVtBekP49oQQbbD58/oyyDOTrbNDx59RTZ3RlO
3BcsgzXisVkSIY2IzNl9ybleBkuwm8ESjvzXb6OaXCtFJtYbKc3ZdL4ecWZY
100PMTHe4CRJt4dAOpXppYZ8JhYW7K61OaYO9YWvVGrTZLHyX1oOTxRUo0um
AYSylyxm2Ry5kyviI+vl3mb6XVmMbVDy0DezEv3/32Aq6d/nVQ7y0L8Vxz1g

          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc/1W0DgI95nOM4JETIysyqeBS57/toULKlrYhIHqOsR0gh2XtLKmUk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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB0RVhRpDP/tKFad93Xf98K/9y7+dDr5U6aIRNXte
urzH1/3CFz12p3No6RRd6F29T+vD/pqweXIS74/r3Cp8U33R9un+bZbS286v
OaaT2DZp3cqjV/cnvd0R9GTpSZ1X3Yaid+qn73+ncHDj4g0ndULb2T819V+x
X7usp45/5hadEGHVOZf6ntjLPr7s7tWySsf0T7DSuU3v7b/e+29vzXNCZ8E2
+9rAwK/2fJv3VQV7luh8yeP3e5L1y94+Se3vvfZOzaefUwPefPpvP/33j8ue
b+bIBtvsjvbrY3KA+Y/pKZtGYhQrnL97/UWPLEkOOD+m6uds95VccL736ift
8QW8CP15ARODDyH4Owz2zHIX4YPzVbZNXqu/A8G/VfF/mzIXP5w/0Tr7gHgM
gu/x79pJ7nUIPjQ9wPkAunW9NQ==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk7lGsDgBnGMjNmxBhmtFJoZKlOK57nTQuVkCXCiEKlSKVOkSQJ2U5C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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc/1f3/x4/NcRwrpGFkRSWJBnk930SEjr3nEZFcpEsqo0iKSzKyRZKy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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2m+Y7qhSfoybI2r2vHR5j6/7l9zJ
CBFf8ZG76ELv6n1aH/aXZVifX2k9gedW4Zvqi7ZP9xvOeJutfqiPJ7Ft0rqV
R6/ulz1emeOWOpHnVbeh6J366fvDOTXaJuRM5AltZ//U1H/FPurnNaPrH6p5
QoRV51zqe2K/wlm/TfZPIY/pn2Clc5ve27vUMr/O8Z/As2CbfW1g4Fd7aUef
vnUt1jxf8vj9nmT9sleJvfzkZUAg59PPqQFvPv23h7k/2GZ3tF8fkwOMz/SU
TSMxihXO373+okeWJAecH1P1c7b7Si4433v1k/b4Al6E/ryAicGHEPwdBntm
uYvwwfkq2yav1d+B4N+q+L9NmYsfzp9onX1APAbB9/h37ST3OgQfmh7gfACu
m65k
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvs71Hkfhx1njBkzOtlk20IiJNWqJd7fb7aQclYxURTSaKccK6cSQk7F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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk/VAsfgIdhxjokS9IiS6QuKlpwvuckZUn2PWXJFq7lZiklW4hCZCfd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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB97qVAQ/1dTkKU77uu/64V/7BUx4GblNFKWiZs9L
l/f4ul9BmfOc031WuaILvav3aX3Yf22zbP1l6SVytwrfVF+0fbrf1f93Di/v
YrnEtknrVh69ul/plJxMXc9SuVfdhqJ36qfvV7mzdG/r1KVyoe3sn5r6r9g7
fYpj8fKbKBcirDrnUt8Tew65rp4I9zY50z/BSuc2vbdXreAr9zNZIrdgm31t
YOBXe47WjXE+3IFyX/L4/Z5k/bJ3e2wm7lqcKv30c2rAm0//7W18Ulyf+FTw
B9vsjvbrY3KA+Y/pKZtGYhQrnL97/UWPLEkOOD+m6uds95VccL736ift8QW8
CP15ARODDyH4Owz2zHIX4YPzVbZNXqu/A8G/VfF/mzIXP5w/0Tr7gHgMgu/x
79pJ7nUIPjQ9wPkADiGt5Q==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvs71Hkfh8c4znlGqaztgHSgpIN2n/D+fKmNUuRQilq0SBLlsWUZFE1I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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc7lQ8fxw8Hx+E4R2RFJWWEZKRB53PfqKzsXSqKhnytRJHsJCE6yEjL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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB2I2Lg+P5k/jKU77uu/64V/7kzdHP9msGScVNXte
urzH1/27zj18tkzHWa7oQu/qfVof9r/Z9X/q0wUP5W4Vvqm+aPt0v1hUq0br
5gdyiW2T1q08enX/vpMKs8WfPJJ71W0oeqd++v5N7yzkmd48kgttZ//U1H/F
fuEv9eod4efkQoRV51zqe2KvuGSx7rP2w3Kmf4KVzm16b3/nmtP06G0P5RZs
s68NDPxqf21j1GLnR71yX/L4/Z5k/bKv9tv599fZRdJPP6cGvPn0397ILaVs
ju9W/mCb3dF+fUwOMP8xPWXTSIxihfN3r7/okSXJAefHVP2c7b6SC873Xv2k
Pb6AF6E/L2Bi8CEEf4fBnlnuInxwvsq2yWv1dyD4tyr+b1Pm4ofzJ1pnHxCP
QfA9/l07yb0OwYemBzgfAOa4v04=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvs/lHkfh2duxxljRohkV2E3pQ2rrGeTz/empKzkVElJCpU0IyuV0ApJ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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vc/lX8fwPFjHs45RvZxKqQhJEm78/5cSEQhm0RWSWXlq4GMKCNCstOi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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk7lAsfh2fGMmYxg1JE1kRk63B6C9/nkZyZ6Ni3kOVImhZbqBMpIVtR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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk3VI//x8cyBjOGbJG8oz2VpSjSfd1LypLsayREpLJHJUmSbMkYWQZZ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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB97qVAQ/1dTkKU77uu/64V/7BUx4GblNFKWiZs9L
l/f4ul9BmfOc031WuaILvav3aX3Yf22zbP1l6SVytwrfVF+0fbrf1f93Di/v
YrnEtknrVh69ul/plJxMXc9SuVfdhqJ36qfvV7mzdG/r1KVyoe3sn5r6r9g7
fYpj8fKbKBcirDrnUt8Tew65rp4I9zY50z/BSuc2vbdXreAr9zNZIrdgm31t
YOBXe47WjXE+3IFyX/L4/Z5k/bJ3e2wm7lqcKv30c2rAm0//7W18Ulyf+FTw
B9vsjvbrY3KA+Y/pKZtGYhQrnL97/UWPLEkOOD+m6uds95VccL736ift8QW8
CP15ARODDyH4Owz2zHIX4YPzVbZNXqu/A8G/VfF/mzIXP5w/0Tr7gHgMgu/x
79pJ7nUIPjQ9wPkADiGt5Q==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvs71Hkfh8c4znlGqaztgHSgpIN2n/D+fKmNUuRQilq0SBLlsWUZFE1I
WCLHxFIOyXGMWUbfb6gUaRwriQqJVAyTs9l9ruv54XXd1/0X3C/Nk7627mQS
iRT37/7HRcKsXSZjEeBS02OudgPW5Tz/NHqfRWQ7ydw8jZLAind08bUTizDl
7/BclZoMF071L3lCYRElT1YumG1Pg8x9Phv5VUzCCFR3K7JuwWO9Gch2ZxKP
pn5c+L4iC74yrtjHLmESm5xrLo2Ls2HZGNMr6CGDmI66eTSpPAdQW2qopy+D
ePO68spPD+9ApjndzGcZg4g8O1qvtj0f5kUhCv61dOLOn15R9R8KwXHb+OM/
3OhEyensNJvO+yDM+y0qlEYnwosbf2NGlsKylV2WvHIa8VFMvn7qQDn8nmDB
jD5GIzaP+R4o3cWHbcGbb9zMoxImZm65DdlCSLS1f3HZnkrE0O/KTKTVIF0f
RDsrRyVKT9/2ex5QC0cWss2PFlMI6ZBCSO1yAoRtjeG7nShEyscVPxrGPgT1
/G+4vgqFyAfmXW/NeggMXjavXqlCPNp8vZHV3gAmG9z8x5gqRAbe8dfllEb4
VX1ukFurTKiHXkyWv/MMQqgJDhRvZSKoilcb09kMmXMbnib9oEx0JNmceKf3
Ah6M4ru0nioRG3VPXXnXIYbet0eKii8qEYmth65xN7TBYsuXlUbrlIj+RIvv
BfHtAGUacvbhioSn2DTWOr8LEg3TVs/oKhJk1liuafAr+Pz3CshsUyCkc3uF
r327IaVOLeiTpgLRF6kUZFfeC1/3JqbGPJUnehcPl+qEvYM9TarCbefliVnL
ZS0qovcw3s6ScgkyEXWkrcrebQD2C81ilH3IBHEt2DaoehByM37XSdAgE4uK
+8vq1gzBEfc3h/MuyBGz2YzV91eNQOk+5teta+UI7u7D/RWCz0DRN70qaiUR
W69paWc7fwHR97uC1k0kwjL6Bx0jvzFI6QmbGr4rwzcG7q4N8R+HqqaqywaT
i7ihmUS35JIEvhdo3qyNXcBlS9Qizggm4b8e0gcv62fxgefbrr6NnwF2DJXv
snQWf8XcIfv51SwUVawuGHabwW+HP72zad08fCTtvzGnOI1L6x3iZV2L4Jie
eWq1hRTnfdhqYgVk5CeOufdAdww3NzzvFS5QRvI1lW8iJF9xf+2I1ObzKkir
09olIe4Lvk3Up/5Fl4KcKVdO5z0dwYfmy8aTE6koRHvV1zKPYdyIqxPH2UND
GSZCP5H8J3xmWuBg9o2Gus+PBrWaDOIFB7XCCncykCL96NB5ST9uMbNjk/AJ
AxncrbdVzfuAD1a78DA7JuJ1p220Y7/DrRmmOeuPspDLMF13KOot/kuj2vOH
YhYSrBwgbZjoxv31NLev12Qj16sJxQWPOnEjfpOiXwQbFaWMGEwateMLrABh
cwUbTReaVUC5GO9d6xWo28NGkYGGZ1RtmnGnLzxTbxIHrbk96Jtn8gQ/GbBG
7sIaDqqqT/I31q3DOy/otOgbc9AtcbTkr83VuEmYi+ySHQc1q4/ONSuV4gMJ
JfscPThoJHqrWk9oMu5r/vnlPX8OMuGH2+jEJaLZEcpalVAOUjdhFketL0VL
P0yaT4dzkFZMjfJ+vRqUn7ar8OK/ftOHb8BbXo+G2kvrrgZzUPqy6BPuqY2o
Lq1aXc+Pg7IeuF77RaMFKdSVI19XDrLdnvEmoaUV7fwjRnTSkoMORyhLwuI6
EPtyx5S6AQdhb17sMtd8ifY1PJuSU+Ug3S0p4bSK1yjYpGY+8hsbLQ13aX6x
pwfNekafe9bIRotdG9QSu3rRdssA6cAtNvJPmtbfxH+H3oc+MJn1YSMv/Lgd
c+E9UnXm9ekbs5H9Ep2MttgBlLrNoUovmYXOjY3QbScGUdMMo+gWh4WuPy8N
bnUYQqvKf1aKu8JEDRHGzuI1I+gyzbm/7zADGc7babWUf0N2rdH7kvlUpFdZ
9Ktb5BhqlYaFRSpQkbH3liLXn8YRXnPGB9lQ0InuHebHkyQo3vg9V7lfGWUJ
ULCNjRS5O+mHvJcqoEkfltWA1yz64k1auLdTBgnI0WpQYw5xhZlig64FMGDf
sfrYPIcyBsqybLnz4F22y/qT/gJKOenICO6dAWoYz3q4bwFFTYdUnk2fhnxb
sfXIn4sosW5fZJPLFAxOuB8alcjQpyVZVkuVpIDIufqcAyRMcr3E33VmAqKp
aoZFmSQsPgrnj0xKQFtjyvTDbjnMwVJNpqM4Dr7anhbBN+WwRDQ4tqA+BjV6
r61WDMthOSHSGZHPV7AzrnGyiiVjK4amXnks/wyeZXsqxUNkjM0I5R10G4aQ
dS1MO1N5zP32kfy+hiEoZL9/6DApj1l87NScxgeA4HlpdB9UwM6O7n/Zeawf
umYn/I/nKWBst8/WbKUPQB5U2uDqqIiZOpzxzF3fB8dgzQGzckWMc235jc+S
HihN/s85baoSlnLaeaDvbTcoj9smKpxUwiIVc+MvDr2CX/d7Cwf/VsJSkz7+
ncV8CZU5vJ7HHGVMXrXObLdtJ9AXMkn5p5Wx3LiYdLOydqgpabXwUlfBvred
lr0SiYFdsHPC/YwK5hLae6FutgXc/kq/5VqrgvFFtHYipxmE6SSLEywK1thv
JO31ewb0JHfJUVcKVnfO46C9RyO4xD7LsK+gYLEVlXucuY+BH7HF/JAiFbuq
Uxq+t6IBjgfOpJsXULHfuZtcJ7kPIfDdhVRdMg3TYNBaHd/ikLJ38ibDiYZZ
BAoMghdFICg6nzhWQcN8V0sJ7rFq6FD9Ft9Op2O83zY3Fo5UgSTAO07gTsdo
HDXVkOJKYPcNX099QMcaKs7W3MiuAP1fTl3jLmdgw982l5UQZWB5byDC+RwD
26l/bFikUgpkn0PxdnUMrEMz2IO/8d9+G4jSzJcysbDWjICtIYXgM7E+18iD
idV+f6TTRM2HtYIb97cImdiPq8K0EpruQHeATKBNZWHFfZqCZlEOxBudIZYf
Z2GP0jyjpN3ZYLHY9ZRWzMKubB22qtbKgv//GwyFXEqa1LwF/wCDK1Gp
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc7lQ8fxw8Hx+E4R2RFJWWEZKRB53PfqKzsXSqKhnytRJHsJCE6yEjL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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB2I2Lg+P5k/jKU77uu/64V/7kzdHP9msGScVNXte
urzH1/27zj18tkzHWa7oQu/qfVof9r/Z9X/q0wUP5W4Vvqm+aPt0v1hUq0br
5gdyiW2T1q08enX/vpMKs8WfPJJ71W0oeqd++v5N7yzkmd48kgttZ//U1H/F
fuEv9eod4efkQoRV51zqe2KvuGSx7rP2w3Kmf4KVzm16b3/nmtP06G0P5RZs
s68NDPxqf21j1GLnR71yX/L4/Z5k/bKv9tv599fZRdJPP6cGvPn0397ILaVs
ju9W/mCb3dF+fUwOMP8xPWXTSIxihfN3r7/okSXJAefHVP2c7b6SC873Xv2k
Pb6AF6E/L2Bi8CEEf4fBnlnuInxwvsq2yWv1dyD4tyr+b1Pm4ofzJ1pnHxCP
QfA9/l07yb0OwYemBzgfAOa4v04=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvs/lHkfh2duxxljRohkV2E3pQ2rrGeTz/empKzkVElJCpU0IyuV0ApJ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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vc/lX8fwPFjHs45RvZxKqQhJEm78/5cSEQhm0RWSWXlq4GMKCNCstOi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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk7lAsfh2fGMmYxg1JE1kRk63B6C9/nkZyZ6Ni3kOVImhZbqBMpIVtR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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk3VI//x8cyBjOGbJG8oz2VpSjSfd1LypLsayREpLJHJUmSbMkYWQZZ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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB97qVAQ/1dTkKU77uu/64V/7BUx4GblNFKWiZs9L
l/f4ul9BmfOc031WuaILvav3aX3Yf22zbP1l6SVytwrfVF+0fbrf1f93Di/v
YrnEtknrVh69ul/plJxMXc9SuVfdhqJ36qfvV7mzdG/r1KVyoe3sn5r6r9g7
fYpj8fKbKBcirDrnUt8Tew65rp4I9zY50z/BSuc2vbdXreAr9zNZIrdgm31t
YOBXe47WjXE+3IFyX/L4/Z5k/bJ3e2wm7lqcKv30c2rAm0//7W18Ulyf+FTw
B9vsjvbrY3KA+Y/pKZtGYhQrnL97/UWPLEkOOD+m6uds95VccL736ift8QW8
CP15ARODDyH4Owz2zHIX4YPzVbZNXqu/A8G/VfF/mzIXP5w/0Tr7gHgMgu/x
79pJ7nUIPjQ9wPkADiGt5Q==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvs71Hkfh8c4znlGqaztgHSgpIN2n/D+fKmNUuRQilq0SBLlsWUZFE1I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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc7lQ8fxw8Hx+E4R2RFJWWEZKRB53PfqKzsXSqKhnytRJHsJCE6yEjL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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMB2I2Lg+P5k/jKU77uu/64V/7kzdHP9msGScVNXte
urzH1/27zj18tkzHWa7oQu/qfVof9r/Z9X/q0wUP5W4Vvqm+aPt0v1hUq0br
5gdyiW2T1q08enX/vpMKs8WfPJJ71W0oeqd++v5N7yzkmd48kgttZ//U1H/F
fuEv9eod4efkQoRV51zqe2KvuGSx7rP2w3Kmf4KVzm16b3/nmtP06G0P5RZs
s68NDPxqf21j1GLnR71yX/L4/Z5k/bKv9tv599fZRdJPP6cGvPn0397ILaVs
ju9W/mCb3dF+fUwOMP8xPWXTSIxihfN3r7/okSXJAefHVP2c7b6SC873Xv2k
Pb6AF6E/L2Bi8CEEf4fBnlnuInxwvsq2yWv1dyD4tyr+b1Pm4ofzJ1pnHxCP
QfA9/l07yb0OwYemBzgfAOa4v04=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvs/lHkfh2duxxljRohkV2E3pQ2rrGeTz/empKzkVElJCpU0IyuV0ApJ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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vc/lX8fwPFjHs45RvZxKqQhJEm78/5cSEQhm0RWSWXlq4GMKCNCstOi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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk7lAsfh2fGMmYxg1JE1kRk63B6C9/nkZyZ6Ni3kOVImhZbqBMpIVtR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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk3VI//x8cyBjOGbJG8oz2VpSjSfd1LypLsayREpLJHJUmSbMkYWQZZ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          "]]}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      Frame->True,
      GridLines->{{-0.16128956235529737`, 0, 0.03193852719906851}, None},
      PlotRange->{{-4, 4}, {0, 4.003168318668859}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {975., -145.68505432423805`},
      ImageScaled[{0.5, 0.5}], {360., 277.49534156997726`}], InsetBox[
     GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJx11LFNA0EQRuGDiAxCAgfQhYlwDQgoAEGMjkLcEmRugsw1EAPH6rvgSaxk
jZ58unua+Wevn17vXk6naXr+/S11nIuP1pv9cbs/nq38tjnMm8PJyo8Py/l6
x1fL3/PnypeDb/H9eH7lebxvh7fjeyt//53zXT1wKz/MD/PD/DA/zA/zw/za
l3rgVn6YH+aH+WF+mB/m1zm1L/XArfwwP8wP88P8ML/mpnNqX+qBW/lhfpgf
5of5NcfNTefUvtQDt/LD/DA/zK971Rw3N51T+1IP3MoP88P8uufdq+a4uemc
2pd64FZ+mF/vne5596o5bm46p/alHriVn/rfvdh7qHvfPWuum6POrX2q1w/E
t9MM
       "], 
       PolygonBox[{{23, 22, 32, 33}, {33, 32, 42, 43}, {43, 42, 52, 53}, {53, 
        52, 62, 63}, {63, 62, 72, 73}, {14, 13, 23, 24}, {24, 23, 33, 34}, {
        34, 33, 43, 44}, {44, 43, 53, 54}, {54, 53, 63, 64}, {64, 63, 73, 
        74}, {74, 73, 83, 84}, {15, 14, 24, 25}, {25, 24, 34, 35}, {65, 64, 
        74, 75}, {75, 74, 84, 85}, {16, 15, 25, 26}, {26, 25, 35, 36}, {66, 
        65, 75, 76}, {76, 75, 85, 86}, {17, 16, 26, 27}, {27, 26, 36, 37}, {
        67, 66, 76, 77}, {77, 76, 86, 87}, {18, 17, 27, 28}, {28, 27, 37, 
        38}, {38, 37, 47, 48}, {48, 47, 57, 58}, {58, 57, 67, 68}, {68, 67, 
        77, 78}, {78, 77, 87, 88}, {29, 28, 38, 39}, {39, 38, 48, 49}, {49, 
        48, 58, 59}, {59, 58, 68, 69}, {69, 68, 78, 79}}],
       VertexColors->{
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.], 
         Hue[0.]}],
      AspectRatio->1,
      Frame->True,
      PlotRange->{{-4., 4.}, {-4., 4.}},
      PlotRangeClipping->True,
      PlotRangePadding->{
        Scaled[0.02], 
        Scaled[0.02]}], {1365., -145.68505432423805`}, 
     ImageScaled[{0.5, 0.5}], {360., 277.49534156997726`}], InsetBox[
     GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJx11LFNA0EQRuGDiAxCAgfQhYlwDQgoAEGMjkLcEmRugsw1EAPH6rvgSaxk
jZ58unua+Wevn17vXk6naXr+/S11nIuP1pv9cbs/nq38tjnMm8PJyo8Py/l6
x1fL3/PnypeDb/H9eH7lebxvh7fjeyt//53zXT1wKz/MD/PD/DA/zA/zw/za
l3rgVn6YH+aH+WF+mB/m1zm1L/XArfwwP8wP88P8ML/mpnNqX+qBW/lhfpgf
5of5NcfNTefUvtQDt/LD/DA/zK971Rw3N51T+1IP3MoP88P8uufdq+a4uemc
2pd64FZ+mF/vne5596o5bm46p/alHriVn/rfvdh7qHvfPWuum6POrX2q1w/E
t9MM
       "], PolygonBox[CompressedData["
1:eJwNw2ebgQAAAGBnO6KMRBlFRtmbkMyGRFFyZu77/f9v532eF7f+VMtus9mU
T+en/csfCPhjMBzLZLOZMkWV251OezKdTjY8vzmo6uHn6rAHACAAx+NwFsez
FE1TnW63M2XZKS8IvKpp6vXmdADBIBBHkDhOEDhdqdDdXq/LzmasIIqCdjxq
t7vLGQyFgkgigRC5HFGpViu9fr8347iZKEni8XQ63h9uVwgEQ4lkMpHL53PV
2qDPzeectN1KJ10/PZ4eNwhBYBJFk3mSzNfqw8F8sZhvZXmrG4b+fHk9UDgM
oRiGkoUCWW806sPRaLhYLhfybicb57PxsnzecCQSxlIprFAsFhrNZmPEMKPl
arXcKcrubJpn6/3ti0SjkVQ6nSqWSsVmq9VkxmNmtV6vlP1eMS8X8/37D7ac
QE4=
        "]],
       VertexColors->{
         Hue[0.], 
         Hue[0.00016571029801633498`], 
         Hue[0.0009792270318719721], 
         Hue[0.003174175932184663], 
         Hue[0.006059612849747088], 
         Hue[0.00687191398726393], 
         Hue[0.004633318216401109], 
         Hue[0.0018510952644113293`], 
         Hue[0.00042770983220108926`], 
         Hue[0.00004328554159172475], 
         Hue[0.00015331275303544922`], 
         Hue[0.0015463872562887955`], 
         Hue[0.008385367292354565], 
         Hue[0.026837614289509565`], 
         Hue[0.05109457748805437], 
         Hue[0.05792333838695066], 
         Hue[0.039104165838167074`], 
         Hue[0.01571489007691565], 
         Hue[0.0037489351685558773`], 
         Hue[0.0005172007254353289], 
         Hue[0.0008506456333709346], 
         Hue[0.007826304752143524], 
         Hue[0.04207170465019185], 
         Hue[0.13446919288714346`], 
         Hue[0.25593312474039037`], 
         Hue[0.2901273534934527], 
         Hue[0.19589252808311147`], 
         Hue[0.07877344050780143], 
         Hue[0.01885530814920391], 
         Hue[0.0026727724808258864`], 
         Hue[0.002578185661306629], 
         Hue[0.023383880125619913`], 
         Hue[0.12552466925471767`], 
         Hue[0.4011106571586468], 
         Hue[0.7633906097113586], 
         Hue[0.8653787750969737], 
         Hue[0.5843127206922897], 
         Hue[0.23499175896791413`], 
         Hue[0.056279133608919105`], 
         Hue[0.008012885639885958], 
         Hue[0.004596409185309276], 
         Hue[0.04155924167293748], 
         Hue[0.22301979734959274`], 
         Hue[0.712618388942036], 
         Hue[1.], 
         Hue[1.], 
         Hue[1.], 
         Hue[0.41749605993805255`], 
         Hue[0.10000005681740759`], 
         Hue[0.014251549765851053`], 
         Hue[0.004865139871513984], 
         Hue[0.04397932910257092], 
         Hue[0.23600147770509206`], 
         Hue[0.7540962953902774], 
         Hue[1.], 
         Hue[1.], 
         Hue[1.], 
         Hue[0.44179688957943347`], 
         Hue[0.10582158924708561`], 
         Hue[0.015082240951258666`], 
         Hue[0.003058900761086013], 
         Hue[0.0277130194086747], 
         Hue[0.14874676515873414`], 
         Hue[0.47530782540357774`], 
         Hue[0.904598611596624], 
         Hue[1.], 
         Hue[0.6923967295297392], 
         Hue[0.27846195550839986`], 
         Hue[0.06669289983087491], 
         Hue[0.009498855856829802], 
         Hue[0.0011355075669798257`], 
         Hue[0.010391664125292296`], 
         Hue[0.05583264360281702], 
         Hue[0.1784369168555711], 
         Hue[0.33961009780935547`], 
         Hue[0.3849831771614307], 
         Hue[0.2599409005260953], 
         Hue[0.10453298965981313`], 
         Hue[0.02502629296640372], 
         Hue[0.0035533280312508857`], 
         Hue[0.00023786162806484418`], 
         Hue[0.002307802606869264], 
         Hue[0.012469703493589751`], 
         Hue[0.03988752078995996], 
         Hue[0.07593044744518083], 
         Hue[0.08607716392450197], 
         Hue[0.05811413943805492], 
         Hue[0.0233604918408118], 
         Hue[0.0055805236068835916`], 
         Hue[0.0007785553411473108], 
         Hue[0.000013741792816344126`], 
         Hue[0.0002894637127273302], 
         Hue[0.001643057293955938], 
         Hue[0.005295187138300702], 
         Hue[0.010096205639962708`], 
         Hue[0.011447776615714276`], 
         Hue[0.007723023650837788], 
         Hue[0.0030937407207726132`], 
         Hue[0.0007253992909379461], 
         Hue[0.00008576370560586013]}],
      AspectRatio->1,
      Frame->True,
      PlotRange->{{-4., 4.}, {-4., 4.}},
      PlotRangeClipping->True,
      PlotRangePadding->{
        Scaled[0.02], 
        Scaled[0.02]}], {1755., -145.68505432423805`}, 
     ImageScaled[{0.5, 0.5}], {360., 277.49534156997726`}]}, {}},
  ContentSelectable->True,
  ImageSize->{969., Automatic},
  PlotRangePadding->{6, 5}]], "Print",
 CellChangeTimes->{
  3.4607741726538877`*^9, 3.460774214095277*^9, 3.4607742593307467`*^9, {
   3.460774303107853*^9, 3.460774333703259*^9}, {3.460774503928895*^9, 
   3.460774525339555*^9}, 3.460774568613134*^9, {3.460774643309626*^9, 
   3.460774749234734*^9}, 3.460774787209793*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]],

Cell[BoxData[
 RowBox[{"-", "2.7246443843537644`"}]], "Output",
 CellChangeTimes->{
  3.460774172693623*^9, 3.4607742141360817`*^9, 3.460774259371611*^9, {
   3.460774303149437*^9, 3.460774333742992*^9}, {3.460774503977763*^9, 
   3.460774525387253*^9}, 3.460774568669429*^9, {3.4607746433678713`*^9, 
   3.460774749289826*^9}, 3.4607747872637367`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"IndividualLikNonlin", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Y", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"IdioNonlin", ",", 
     RowBox[{"{", "}"}], ",", "m", ",", 
     RowBox[{"eps", "=", 
      RowBox[{"10.", "^", 
       RowBox[{"-", "16"}]}]}], ",", 
     RowBox[{"ksigma", "=", "Infinity"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0", ",", "1"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"IndividualLik", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Y", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"Idio", ",", 
     RowBox[{"{", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.460264864897327*^9, 3.460264932378791*^9}, {
   3.460265489300803*^9, 3.460265492492799*^9}, {3.46027038606568*^9, 
   3.460270391802556*^9}, {3.4602704971596107`*^9, 3.4602705817118692`*^9}, {
   3.46027367414145*^9, 3.460273674236417*^9}, {3.460279775378045*^9, 
   3.4602797754444103`*^9}, {3.4602799530257587`*^9, 
   3.4602799533811693`*^9}, {3.460280067013379*^9, 3.460280067130088*^9}, {
   3.4602801040742397`*^9, 3.460280104129944*^9}, {3.4602801453821163`*^9, 
   3.4602801673531218`*^9}, {3.46028174693688*^9, 3.460281763776168*^9}, {
   3.4602818356559362`*^9, 3.460281835739462*^9}, {3.460281898670804*^9, 
   3.460281898732609*^9}, {3.460282025318959*^9, 3.460282025741701*^9}, {
   3.460282062175247*^9, 3.460282071535883*^9}, {3.460283778391947*^9, 
   3.4602837888805027`*^9}, {3.4602838305963707`*^9, 3.460283854615387*^9}, {
   3.46028477341341*^9, 3.460284779157151*^9}, {3.460285035206752*^9, 
   3.460285046973556*^9}, {3.46028555906642*^9, 3.460285574425418*^9}, {
   3.4602857519094887`*^9, 3.4602857519715776`*^9}, {3.460285881590439*^9, 
   3.4602858816380377`*^9}, {3.460286117999454*^9, 3.460286123654068*^9}, {
   3.4602863340289307`*^9, 3.4602863377475977`*^9}, {3.4603641927287188`*^9, 
   3.460364197580667*^9}, {3.460365058304535*^9, 3.4603650587979116`*^9}, {
   3.460365091217347*^9, 3.460365126318194*^9}, {3.4603652464521227`*^9, 
   3.460365260029804*^9}, {3.460365412299954*^9, 3.460365434375272*^9}, {
   3.460365485584791*^9, 3.460365520950554*^9}, {3.460366663535665*^9, 
   3.460366678997499*^9}, {3.4603667867732773`*^9, 3.4603667868283587`*^9}, {
   3.460367092714067*^9, 3.460367098883337*^9}, {3.460369235357655*^9, 
   3.460369263924768*^9}, {3.460369362646221*^9, 3.46036936313859*^9}, {
   3.46036946785526*^9, 3.4603694691077127`*^9}, {3.46037339069245*^9, 
   3.460373390747698*^9}, {3.460373605599341*^9, 3.4603736056503153`*^9}, {
   3.460377091108459*^9, 3.460377126962656*^9}, {3.460377288435691*^9, 
   3.460377301095058*^9}, {3.4603774697122087`*^9, 3.460377479788327*^9}, {
   3.460377585320611*^9, 3.460377603716568*^9}, {3.4603776957101793`*^9, 
   3.460377736561165*^9}, {3.460377923292104*^9, 3.4603779233524303`*^9}, {
   3.460378105932313*^9, 3.46037817981962*^9}, {3.460427531315346*^9, 
   3.460427537420005*^9}, {3.460427638978484*^9, 3.4604276390230217`*^9}, {
   3.4604277414332314`*^9, 3.460427769573126*^9}, {3.4604279604982853`*^9, 
   3.460427960554902*^9}, {3.460430680071252*^9, 3.460430680172152*^9}, {
   3.460430712203142*^9, 3.460430712557424*^9}, {3.460430775931464*^9, 
   3.460430776020101*^9}, {3.460430814349124*^9, 3.460430814950081*^9}, {
   3.46043100067663*^9, 3.460431000775926*^9}, {3.460431035518139*^9, 
   3.460431043615539*^9}, {3.460431139283386*^9, 3.460431139330926*^9}, {
   3.4604311987514153`*^9, 3.460431233744923*^9}, {3.460431314274002*^9, 
   3.460431314321568*^9}, {3.4604316727142878`*^9, 3.4604316728008432`*^9}, {
   3.460431886035831*^9, 3.46043189177104*^9}, {3.460432099991972*^9, 
   3.460432100073539*^9}, {3.460432236204804*^9, 3.4604322362468243`*^9}, {
   3.4604323376555843`*^9, 3.460432357162323*^9}, {3.460432403219545*^9, 
   3.460432403269651*^9}, {3.460432564446265*^9, 3.4604325911495867`*^9}, {
   3.460432813689516*^9, 3.460432813733564*^9}, {3.460432944239506*^9, 
   3.460432989199974*^9}, {3.460433097024789*^9, 3.460433097139295*^9}, {
   3.460433291653358*^9, 3.46043329173923*^9}, {3.460433672964451*^9, 
   3.460433673010107*^9}, {3.460433845665332*^9, 3.4604338457416363`*^9}, {
   3.4604344009903316`*^9, 3.460434401033557*^9}, {3.4604346235115023`*^9, 
   3.460434638473834*^9}, {3.460434675871023*^9, 3.460434675925946*^9}, {
   3.4604350413113747`*^9, 3.4604350414069347`*^9}, {3.460436666989565*^9, 
   3.460436677468376*^9}, {3.460437023691847*^9, 3.460437023772811*^9}, {
   3.460437179838045*^9, 3.460437214787621*^9}, {3.4604373750456057`*^9, 
   3.460437375101828*^9}, {3.460437455923118*^9, 3.4604374559862347`*^9}, {
   3.460437643282413*^9, 3.4604376433404827`*^9}, {3.460439284564681*^9, 
   3.46043929340877*^9}, {3.460439393566842*^9, 3.460439393962884*^9}, {
   3.46044000098571*^9, 3.460440001044331*^9}, {3.460443930270521*^9, 
   3.460443930334333*^9}, {3.460443966799687*^9, 3.46044399790462*^9}, {
   3.460444060284606*^9, 3.460444061730588*^9}, {3.460444101336812*^9, 
   3.46044410138903*^9}, {3.460444186536171*^9, 3.460444194286351*^9}, {
   3.460444233408099*^9, 3.460444248920389*^9}, {3.460444338058318*^9, 
   3.460444355662019*^9}, {3.460444400012597*^9, 3.460444431012135*^9}, {
   3.460444591036777*^9, 3.4604446631572647`*^9}, {3.46044479971354*^9, 
   3.460444799768903*^9}, {3.460444831583193*^9, 3.460444859781989*^9}, {
   3.46044502143334*^9, 3.460445021504759*^9}, {3.460459950502769*^9, 
   3.460459971711813*^9}, {3.460460068419449*^9, 3.460460088588605*^9}, {
   3.460460154598343*^9, 3.46046015516997*^9}, {3.460460281436612*^9, 
   3.460460281521656*^9}, {3.4604604120265713`*^9, 3.460460412125514*^9}, {
   3.4604607607833633`*^9, 3.4604607621971283`*^9}, {3.460460826677142*^9, 
   3.460460827186878*^9}, {3.4604608962826014`*^9, 3.4604608963501987`*^9}, {
   3.460460962965583*^9, 3.460460963358262*^9}, {3.46046100555375*^9, 
   3.4604610220017967`*^9}, {3.46046105589403*^9, 3.460461056004932*^9}, {
   3.460461154113535*^9, 3.460461154227416*^9}, {3.460461800671767*^9, 
   3.4604618154025*^9}, {3.46046184541817*^9, 3.46046186011173*^9}, {
   3.460461896620476*^9, 3.460461896672694*^9}, {3.460461952952413*^9, 
   3.4604619533933907`*^9}, {3.460462913572587*^9, 3.460462920740217*^9}, {
   3.460722765559946*^9, 3.460722812479978*^9}, 3.4607228582030888`*^9, {
   3.460722890758842*^9, 3.460722896366596*^9}, {3.46072298397585*^9, 
   3.4607229875994997`*^9}, {3.460723019415843*^9, 3.460723105990931*^9}, {
   3.460723170191799*^9, 3.460723171657259*^9}, {3.460723268211129*^9, 
   3.460723287189331*^9}, {3.460732937278017*^9, 3.4607329553868093`*^9}, {
   3.460733072671542*^9, 3.460733072733719*^9}, 3.460774164086339*^9, {
   3.460774203297064*^9, 3.460774203437456*^9}}],

Cell[BoxData[
 RowBox[{"-", "8.745709115850133`"}]], "Output",
 CellChangeTimes->{
  3.460722864185832*^9, 3.46072290251231*^9, 3.460722994070681*^9, {
   3.4607230259705276`*^9, 3.460723109644692*^9}, 3.4607231775830717`*^9, 
   3.46072323370262*^9, {3.460723272758277*^9, 3.460723291255953*^9}, {
   3.460732942792966*^9, 3.4607329605671864`*^9}, {3.460733023995452*^9, 
   3.460733076751679*^9}, {3.460773704975284*^9, 3.460773732666801*^9}, {
   3.460774198834483*^9, 3.460774204426446*^9}}],

Cell[BoxData[
 RowBox[{"-", "7.951219735067298`"}]], "Output",
 CellChangeTimes->{
  3.460722864185832*^9, 3.46072290251231*^9, 3.460722994070681*^9, {
   3.4607230259705276`*^9, 3.460723109644692*^9}, 3.4607231775830717`*^9, 
   3.46072323370262*^9, {3.460723272758277*^9, 3.460723291255953*^9}, {
   3.460732942792966*^9, 3.4607329605671864`*^9}, {3.460733023995452*^9, 
   3.460733076751679*^9}, {3.460773704975284*^9, 3.460773732666801*^9}, {
   3.460774198834483*^9, 3.4607742044342203`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["Theta"], "Input",
 CellChangeTimes->{{3.460283430587044*^9, 3.460283434302026*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "0.3`", ",", 
   RowBox[{"-", "0.1`"}]}], "}"}]], "Output",
 CellChangeTimes->{3.460283435412422*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["miss"], "Input",
 CellChangeTimes->{{3.460283521968884*^9, 3.460283523407611*^9}}],

Cell[BoxData["miss"], "Output",
 CellChangeTimes->{3.460283523608214*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"l0", "=", 
   RowBox[{
    RowBox[{"IndividualLikNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Y", ",", "X", ",", 
        RowBox[{"-", "9"}]}], "}"}], ",", "Theta", ",", 
      RowBox[{"{", 
       RowBox[{"IdioNonlin", ",", 
        RowBox[{"{", "}"}], ",", "#", ",", 
        RowBox[{"eps", "=", 
         RowBox[{"10.", "^", 
          RowBox[{"-", "16"}]}]}], ",", 
        RowBox[{"ksigma", "=", "Infinity"}], ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular", "=", "False"}], ",", 
        RowBox[{"2", "Pi"}], " ", ",", "0", ",", "0"}], "}"}]}], "]"}], 
    "&"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l1", "=", 
   RowBox[{
    RowBox[{"IndividualLikNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Y", ",", "X", ",", 
        RowBox[{"-", "9"}]}], "}"}], ",", "Theta", ",", 
      RowBox[{"{", 
       RowBox[{"IdioNonlin", ",", 
        RowBox[{"{", "}"}], ",", "#", ",", 
        RowBox[{"eps", "=", 
         RowBox[{"10.", "^", 
          RowBox[{"-", "16"}]}]}], ",", 
        RowBox[{"ksigma", "=", "Infinity"}], ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular", "=", "False"}], ",", 
        RowBox[{"2", "Pi"}], " ", ",", "0", ",", "1"}], "}"}]}], "]"}], 
    "&"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"llin", "=", 
  RowBox[{"IndividualLik", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Y", ",", "X", ",", 
      RowBox[{"-", "9"}]}], "}"}], ",", "Theta", ",", 
    RowBox[{"{", 
     RowBox[{"Idio", ",", 
      RowBox[{"{", "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Singular", "=", "False"}], ",", 
      RowBox[{"2", "Pi"}], " ", ",", "0"}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.460282085817231*^9, 3.4602821105254803`*^9}, {
  3.460282171720809*^9, 3.4602821743115873`*^9}, {3.460282379938203*^9, 
  3.460282383283786*^9}, {3.460282626852909*^9, 3.460282635158669*^9}, {
  3.460283528574358*^9, 3.460283534882937*^9}, {3.460369527766265*^9, 
  3.460369582229149*^9}}],

Cell[BoxData[
 RowBox[{"-", "6.233250237058035`"}]], "Output",
 CellChangeTimes->{{3.460369565336274*^9, 3.460369583537636*^9}, 
   3.460435644523567*^9, 3.460439468908895*^9, {3.460440250542729*^9, 
   3.460440268825201*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"pp", "=", "0"}], ";", 
  RowBox[{"l0", "[", "4", "]"}]}]], "Input",
 CellChangeTimes->{{3.460282153080297*^9, 3.460282158488613*^9}, {
  3.460282193092895*^9, 3.460282220935027*^9}, {3.460282308500825*^9, 
  3.4602823085625467`*^9}, {3.460283195676051*^9, 3.460283196336207*^9}, {
  3.4603662815649853`*^9, 3.460366282970312*^9}}],

Cell[BoxData[
 RowBox[{"-", "6.3293822305981475`"}]], "Output",
 CellChangeTimes->{
  3.4602821586290083`*^9, {3.460282194672504*^9, 3.460282221034252*^9}, {
   3.460282304124085*^9, 3.4602823096094847`*^9}, 3.460282367700007*^9, 
   3.4602826444891653`*^9, {3.460283191195128*^9, 3.460283196443349*^9}, 
   3.460283538479665*^9, 3.4602841996563187`*^9, 3.460284409519916*^9, 
   3.460364431619211*^9, {3.4603662767860107`*^9, 3.460366326918507*^9}, 
   3.460367142375352*^9, 3.460369509450536*^9, 3.460435649149485*^9, 
   3.460439471087428*^9, 3.460440271569412*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"l0", "[", "mm", "]"}], ",", 
        RowBox[{"l1", "[", "mm", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"mm", ",", "2", ",", "10"}], "}"}]}], "]"}], "//", 
    RowBox[{
     RowBox[{"AddTimeAxis", "[", 
      RowBox[{"#", ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "10", ",", "1"}], "}"}]}], "]"}], "&"}]}], "//", 
   RowBox[{
    RowBox[{"plot1", "[", 
     RowBox[{"#", ",", 
      RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
      RowBox[{"GridLines", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"None", ",", 
         RowBox[{"{", "llin", "}"}]}], "}"}]}]}], "]"}], "&"}]}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.460281783177149*^9, 3.460281824576651*^9}, {
  3.460281910255617*^9, 3.460281943368555*^9}, {3.460281981836998*^9, 
  3.4602819975731277`*^9}, {3.4602820319744387`*^9, 3.460282053018779*^9}, {
  3.460282118996468*^9, 3.460282133562097*^9}, {3.460282239307322*^9, 
  3.460282241400333*^9}, {3.46028239420243*^9, 3.4602824371035967`*^9}, {
  3.460284414532241*^9, 3.4602844151683893`*^9}, {3.460284789442216*^9, 
  3.4602847924493017`*^9}, {3.4603644911795893`*^9, 3.460364500191489*^9}, {
  3.4603695897129087`*^9, 3.460369625240038*^9}, {3.460439520790577*^9, 
  3.46043953878603*^9}, {3.460439576047587*^9, 3.46043961923698*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {RGBColor[0, 0, 1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{2., -7.0219705019562735`}, {3., -5.479888153155907}, {
       4., -6.3293822305981475`}, {5., -4.412476048413784}, {
       6., -6.7684610235202385`}, {7., -4.635969982801024}, {
       8., -6.656980931607846}, {9., -5.093526887293728}, {
       10., -6.307814896267469}}]}}}, {{}, {}, 
    {RGBColor[0., 0.980407, 0.6039], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{2., -6.427137876275227}, {3., -6.42761491148058}, {
       4., -6.427614911480584}, {5., -6.4276149114805925`}, {
       6., -6.427614911480569}, {7., -6.427614911480566}, {
       8., -6.427614911480612}, {9., -6.427614911480568}, {
       10., -6.427614911480479}}]}}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{2., -7.},
  DisplayFunction->Identity,
  Frame->True,
  GridLines->{None, {-6.233250237058035}},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.460281797946806*^9, 3.460281825798993*^9}, {
   3.460281904342657*^9, 3.460281945448979*^9}, {3.460281984036024*^9, 
   3.460281999907948*^9}, 3.460282036560417*^9, 3.460282135587686*^9, 
   3.460282242514032*^9, 3.4602823726324577`*^9, {3.460282416693921*^9, 
   3.460282441098826*^9}, 3.4602826518405313`*^9, 3.4602832036099043`*^9, 
   3.4602835481939077`*^9, {3.460284391325081*^9, 3.460284420594182*^9}, 
   3.460284799893792*^9, {3.460364417441619*^9, 3.460364434654419*^9}, {
   3.460364477824107*^9, 3.460364501892661*^9}, 3.460367145808325*^9, 
   3.460369518021393*^9, {3.4603696154135933`*^9, 3.460369627668434*^9}, 
   3.4604356684680777`*^9, 3.460439475436892*^9, 3.4604395415998383`*^9, {
   3.460439582340852*^9, 3.460439621927959*^9}, {3.4604402659294558`*^9, 
   3.46044027553581*^9}}]
}, Open  ]],

Cell[TextData[StyleBox["Math7/Intel/ OS X",
 FontColor->RGBColor[1, 0, 0]]], "Text",
 PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"THETA0", "=", "Theta"}], "\n", 
 RowBox[{"F0", "=", 
  RowBox[{"IdentityMatrix", "[", 
   RowBox[{"Length", "[", "THETA0", "]"}], "]"}]}], "\n", "SCALING", "\n", 
 RowBox[{"FISHER", "=", "True"}], "\n", 
 RowBox[{"MAXSTEP", "=", "1"}], "\n", 
 RowBox[{"STEPREDUCE", "=", "4"}], "\[IndentingNewLine]", 
 RowBox[{"FDIGITS", "=", "2"}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601143146009274`*^9, 3.460114315759859*^9}, 
   3.460282522110393*^9, {3.460283799592029*^9, 3.4602838013662*^9}, {
   3.4604357137809753`*^9, 3.460435744591599*^9}, {3.460435786839238*^9, 
   3.4604357909828987`*^9}, {3.460435825453755*^9, 3.460435826628525*^9}, {
   3.460435861768526*^9, 3.460435863165637*^9}, {3.460435902549529*^9, 
   3.460435902612645*^9}, {3.460435960264574*^9, 3.460435960325345*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "0.3`", ",", 
   RowBox[{"-", "0.1`"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279952099*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440280005438*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440280053413*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440280107785*^9}],

Cell[BoxData["4"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440280153859*^9}],

Cell[BoxData["2"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.4604402802159843`*^9}]
}, Open  ]],

Cell[BoxData["Nichtlinear"], "Input",
 CellChangeTimes->{{3.460367266700344*^9, 3.46036726904226*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "scoreii", ",", "k", 
      ",", "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
    RowBox[{"BFGS", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"Y", ",", "X", ",", 
         RowBox[{"-", "9"}]}], "}"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      "\t  ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"IdioNonlin", ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"m", "=", "10"}], ",", 
          RowBox[{"eps", "=", 
           RowBox[{"10.", "^", 
            RowBox[{"-", "16"}]}]}], ",", 
          RowBox[{"ksigma", "=", "Infinity"}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Lik", ",", "IndividualLikNonlin", ",", "Score", ",", "Hesse"}], 
         "}"}]}], "}"}], ",", "\[IndentingNewLine]", "            ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Sing", "=", "False"}], ",", 
          RowBox[{"2", "Pi"}], ",", "0", ",", 
          RowBox[{"norkorr", "=", "0"}]}], "}"}], ",", 
        RowBox[{"KMAX", "=", "20"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EPS1", "=", ".0001"}], ",", 
          RowBox[{"EPS2", "=", ".0001"}]}], "}"}], ",", "\[IndentingNewLine]",
         "             ", 
        RowBox[{"OPTION", "=", "0"}], ",", 
        RowBox[{"PRINT", "=", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1"}], "}"}]}]}], "}"}]}], "]"}]}], ";"}], 
  "                                                                           \
     "}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113330285616*^9, 3.460113346379695*^9}, {
   3.460200648978776*^9, 3.4602006503583603`*^9}, {3.460200794874672*^9, 
   3.4602007984595947`*^9}, 3.460201903279232*^9, {3.460201941045977*^9, 
   3.4602019411313553`*^9}, {3.460279278878285*^9, 3.460279290392777*^9}, {
   3.460279385569292*^9, 3.4602794078107224`*^9}, 3.460279483282811*^9, {
   3.460282734453003*^9, 3.46028273588818*^9}, {3.460283616696549*^9, 
   3.460283634147719*^9}, {3.4602836706901093`*^9, 3.460283671258127*^9}, {
   3.4602837458995867`*^9, 3.4602837460095263`*^9}, {3.460283977779047*^9, 
   3.4602839782382393`*^9}, {3.460284094017385*^9, 3.460284112248164*^9}, {
   3.4602842039019938`*^9, 3.460284237509654*^9}, {3.460285585933895*^9, 
   3.460285590933837*^9}, 3.460367196326754*^9, {3.460435757860738*^9, 
   3.460435758943184*^9}, {3.460435888109399*^9, 3.460435888167045*^9}, {
   3.4604359232590923`*^9, 3.4604359236923323`*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Tiefe von data = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["Tiefe von data = ", 5],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9}],

Cell[BoxData["\<\"L\[ADoubleDot]nge der Paneldaten\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835997953`*^9}],

Cell[BoxData[
 RowBox[{"{", "1", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402836465397`*^9}],

Cell[BoxData["\<\"***********************LSDE1********************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440283698976*^9}],

Cell[BoxData["\<\"***********************MODUL:    BFGS \
(skeleton)**************\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440283750824*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440283801241*^9}],

Cell[BoxData["\<\"Technical Output\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402838521013`*^9}],

Cell[BoxData["IndividualLikNonlin"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440283903092*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402839491262`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"KMAX\"\>",
       HoldForm], 
      TagBox["\<\"EPS1\"\>",
       HoldForm], 
      TagBox["\<\"EPS2\"\>",
       HoldForm], 
      TagBox["\<\"K\"\>",
       HoldForm], 
      TagBox["\<\"Q\"\>",
       HoldForm], 
      TagBox["\<\"n\"\>",
       HoldForm], 
      TagBox["\<\"T\"\>",
       HoldForm], 
      TagBox["\<\"OPTION\"\>",
       HoldForm]},
     {"1", "20", "0.0001`", "0.0001`", "4", "1", "1", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"KMAX", "EPS1", "EPS2", "K", "Q", "n", "T", "OPTION"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402840042477`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440284063056*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"MAXSTEP\"\>",
       HoldForm], 
      TagBox["\<\"MINSTEP\"\>",
       HoldForm], 
      TagBox["\<\"BOUND\"\>",
       HoldForm], 
      TagBox["\<\"STEPREDUCE\"\>",
       HoldForm], 
      TagBox["\<\"FMAX\"\>",
       HoldForm]},
     {"1", "1", "1.`*^-10", "1.`*^-6", "4", "1000"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"MAXSTEP", "MINSTEP", "BOUND", "STEPREDUCE", "FMAX"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440284101952*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440284151908*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"RESAMPLING\"\>",
       HoldForm], 
      TagBox["\<\"FDIGITS\"\>",
       HoldForm], 
      TagBox["\<\"TYP\"\>",
       HoldForm], 
      TagBox["\<\"YMAX\"\>",
       HoldForm], 
      TagBox["\<\"ANALGRAD\"\>",
       HoldForm], 
      TagBox["\<\"FACTOR\"\>",
       HoldForm], 
      TagBox["\<\"CSEED\"\>",
       HoldForm]},
     {"1", "True", "2", "1", "1.`*^8", "False", "1.`", 
      RowBox[{"-", "999"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {
      "RESAMPLING", "FDIGITS", "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}},
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440284202619*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440284251772*^9}],

Cell[BoxData["\<\"    SCALING\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440284303487*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "::", "\<\"nmtx\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The first two levels of the \
one-dimensional list \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\
\\!\\({}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" cannot be \
transposed.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Transpose\\\", ButtonNote -> \\\"Transpose::nmtx\\\
\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.460113347438837*^9, 3.4601140477211742`*^9, 3.460114171488365*^9, 
   3.4601142582303123`*^9, 3.46011431981378*^9, 3.4601210026174927`*^9, 
   3.4602006082555428`*^9, 3.4602006525509787`*^9, 3.4602007997492933`*^9, {
   3.460201893745349*^9, 3.460201903902554*^9}, 3.4602019417761383`*^9, 
   3.460279294169009*^9, 3.460279424327683*^9, 3.4602794918395157`*^9, 
   3.460282465738028*^9, 3.4602825470673647`*^9, 3.460282687933013*^9, 
   3.4602827362471*^9, 3.460282807351432*^9, 3.460282913928569*^9, 
   3.460283210827161*^9, 3.460283352033407*^9, 3.460283407184712*^9, {
   3.460283619834437*^9, 3.460283671655117*^9}, 3.460283747410516*^9, 
   3.460283804801373*^9, {3.460283909419492*^9, 3.460283979704739*^9}, 
   3.46028403988277*^9, {3.4602840959065733`*^9, 3.460284112635261*^9}, 
   3.460284241484562*^9, 3.4602855917581997`*^9, {3.460367187530768*^9, 
   3.4603671971813374`*^9}, 3.460435693346806*^9, {3.460435725332974*^9, 
   3.460435760027495*^9}, 3.460435797489111*^9, 3.460435835765499*^9, {
   3.460435866970508*^9, 3.460435925364402*^9}, 3.460435963989526*^9, 
   3.460440284356594*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  RowBox[{"Transpose", "[", 
   RowBox[{"{", "}"}], "]"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
    0]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440284407588*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440284454142*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440284504128*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402845660467`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STARTWERT THETA0 = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "0.3`", ",", 
     RowBox[{"-", "0.1`"}]}], "}"}]}],
  SequenceForm["STARTWERT THETA0 = ", {1, 2, 0.3, -0.1}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440284606456*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.1`", ",", "0.2`", ",", "0.1`", ",", "0.1`"}], "}"}]}],
  SequenceForm["Score: INC: ", {0.1, 0.2, 0.1, 0.1}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402846550837`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.7350763865596885`"}], ",", 
     RowBox[{"-", "6.397140431038428`"}], ",", "3.96920310198273`", ",", 
     RowBox[{"-", "3.2357716032410355`"}]}], "}"}], ",", 
   RowBox[{"-", "6.307814896267469`"}]}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.46044028698523*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440287022812*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["BFGS: Iteration = ", 1],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440287072698*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.020973309003183\"\>",
     -6.020973309003183,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-6.020973309003183, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.46044028763428*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.307814896267469\"\>",
     -6.307814896267469,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-6.307814896267469, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440287671492*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.286841587264286\"\>",
     0.286841587264286,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.286841587264286, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440287723154*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402877672167`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7288\"\>",
         0.7287731283588472,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\"-0.2712\"\>",
         -0.2712268716411528,
         AutoDelete->True], 
        InterpretationBox["\<\"-1.7351\"\>",
         -1.7350763865596885`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 1.0000\"\>",
         1.,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\"-1.0000\"\>",
         -1.,
         AutoDelete->True], 
        InterpretationBox["\<\"-6.3971\"\>",
         -6.397140431038428,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.9205\"\>",
         0.9204652132888103,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3000\"\>",
         0.3,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6205\"\>",
         0.6204652132888103,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.9692\"\>",
         3.96920310198273,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.6058\"\>",
         -0.6058153151588361,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1000\"\>",
         -0.1,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.5058\"\>",
         -0.5058153151588362,
         AutoDelete->True], 
        InterpretationBox["\<\"-3.2358\"\>",
         -3.2357716032410355`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440287823132*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402878675413`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440287918536*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.1`", ",", "0.1`", ",", "0.1`", ",", "0.1`"}], "}"}]}],
  SequenceForm["Score: INC: ", {0.1, 0.1, 0.1, 0.1}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402882827063`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "0.8565440972067284`"}],
  SequenceForm["NOISE  ", 0.8565440972067284],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440290681099*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "0.07800920417334063`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "0.5832977711771646`"}],
  SequenceForm["*BFGSUP ", 0.07800920417334063, "  ", 0.5832977711771646],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.46044029071594*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.3601245894557593`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.3601245894557593, " = Elastizitaet(d l/l)/(d theta/theta)"],
  
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402907663937`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.46044029081092*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "2"}],
  SequenceForm["BFGS: Iteration = ", 2],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402908490257`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.262744896681419\"\>",
     -6.262744896681419,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.020973309003183\"\>",
     -6.020973309003183,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[-6.262744896681419, {20, 15}], "  LIKALT  ", 
   PaddedForm[-6.020973309003183, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440291898192*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.626590653587704\"\>",
     -5.626590653587704,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.020973309003183\"\>",
     -6.020973309003183,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[-5.626590653587704, {20, 15}], "  LIKALT  ", 
   PaddedForm[-6.020973309003183, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402925076857`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.626590653587704\"\>",
     -5.626590653587704,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-5.626590653587704, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440292543275*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.020973309003183\"\>",
     -6.020973309003183,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-6.020973309003183, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440292589252*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.394382655415479\"\>",
     0.39438265541547857`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.39438265541547857`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402926372757`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402926744967`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7329\"\>",
         0.732932271358606,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7288\"\>",
         0.7287731283588472,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0042\"\>",
         0.004159142999758682,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4466\"\>",
         0.44655445484381495`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.9375\"\>",
         0.9375,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0000\"\>",
         1.,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0625\"\>",
         -0.06249999999999999,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.2616\"\>",
         -0.26157191914913724`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.8642\"\>",
         0.8641702102371686,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.9205\"\>",
         0.9204652132888103,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0563\"\>",
         -0.05629500305164174,
         AutoDelete->True], 
        InterpretationBox["\<\"-2.1683\"\>",
         -2.168300541028856,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.5799\"\>",
         -0.5798587790090531,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.6058\"\>",
         -0.6058153151588361,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0260\"\>",
         0.025956536149782942`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.2789\"\>",
         1.2789339712414272`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440292722633*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402927724943`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.328\"\>",
         1.3283761048671041`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.886\"\>",
         0.8859897217857425,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.9464\"\>",
         -0.9463637482420242,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6883\"\>",
         0.6883224548483284,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.886\"\>",
         0.8859897217857425,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.353\"\>",
         3.3533743969767666`,
         AutoDelete->True], 
        InterpretationBox["\<\"-2.576\"\>",
         -2.5756824055392125`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.866\"\>",
         1.8658362706018048`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\"-0.9464\"\>",
         -0.9463637482420242,
         AutoDelete->True], 
        InterpretationBox["\<\"-2.576\"\>",
         -2.5756824055392125`,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.714\"\>",
         3.7139686138125945`,
         AutoDelete->True], 
        InterpretationBox["\<\"-1.978\"\>",
         -1.978496104196962,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.6883\"\>",
         0.6883224548483285,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.866\"\>",
         1.8658362706018048`,
         AutoDelete->True], 
        InterpretationBox["\<\"-1.978\"\>",
         -1.978496104196962,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.441\"\>",
         2.440791556701784,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402928261967`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.1`", ",", "0.1`", ",", "0.1`", ",", "0.1`"}], "}"}]}],
  SequenceForm["Score: INC: ", {0.1, 0.1, 0.1, 0.1}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440293166789*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "0.7498022197853471`"}],
  SequenceForm["NOISE  ", 0.7498022197853471],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440295557815*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.9472382095943312`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.9472382095943312, " = Elastizitaet(d l/l)/(d theta/theta)"],
  
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402955912533`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440295633964*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "3"}],
  SequenceForm["BFGS: Iteration = ", 3],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440295685046*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.646807721108810\"\>",
     -6.64680772110881,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.626590653587704\"\>",
     -5.626590653587704,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[-6.64680772110881, {20, 15}], "  LIKALT  ", 
   PaddedForm[-5.626590653587704, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440296751102*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.539349508343284\"\>",
     -5.539349508343284,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.626590653587704\"\>",
     -5.626590653587704,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[-5.539349508343284, {20, 15}], "  LIKALT  ", 
   PaddedForm[-5.626590653587704, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440297360379*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.539349508343284\"\>",
     -5.539349508343284,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-5.539349508343284, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402973973207`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.626590653587704\"\>",
     -5.626590653587704,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-5.626590653587704, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.46044029744543*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.087241145244420\"\>",
     0.08724114524441973,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.08724114524441973, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440297492243*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440297529567*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7322\"\>",
         0.7322399981616949,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7329\"\>",
         0.732932271358606,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0007\"\>",
         -0.000692273196911035,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6280\"\>",
         0.6279911098992486,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.8858\"\>",
         0.8857883184502992,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.9375\"\>",
         0.9375,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0517\"\>",
         -0.05171168154970089,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.9265\"\>",
         -0.9264821192410277,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.8017\"\>",
         0.8016702102371686,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8642\"\>",
         0.8641702102371686,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0625\"\>",
         -0.0625,
         AutoDelete->True], 
        InterpretationBox["\<\"-5.3297\"\>",
         -5.329721656824615,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.5817\"\>",
         -0.5816877652519533,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.5799\"\>",
         -0.5798587790090531,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0018\"\>",
         -0.0018289862429002163`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.2517\"\>",
         1.2516706004772171`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440297578697*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440297630191*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.328\"\>",
         1.3283761048671041`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.886\"\>",
         0.8859897217857425,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.9464\"\>",
         -0.9463637482420242,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6883\"\>",
         0.6883224548483284,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.886\"\>",
         0.8859897217857425,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.353\"\>",
         3.3533743969767666`,
         AutoDelete->True], 
        InterpretationBox["\<\"-2.576\"\>",
         -2.5756824055392125`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.866\"\>",
         1.8658362706018048`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\"-0.9464\"\>",
         -0.9463637482420242,
         AutoDelete->True], 
        InterpretationBox["\<\"-2.576\"\>",
         -2.5756824055392125`,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.714\"\>",
         3.7139686138125945`,
         AutoDelete->True], 
        InterpretationBox["\<\"-1.978\"\>",
         -1.978496104196962,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.6883\"\>",
         0.6883224548483285,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.866\"\>",
         1.8658362706018048`,
         AutoDelete->True], 
        InterpretationBox["\<\"-1.978\"\>",
         -1.978496104196962,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.441\"\>",
         2.440791556701784,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440297680529*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.1`", ",", "0.1`", ",", "0.1`", ",", "0.1`"}], "}"}]}],
  SequenceForm["Score: INC: ", {0.1, 0.1, 0.1, 0.1}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.46044029801085*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "0.7278943217092486`"}],
  SequenceForm["NOISE  ", 0.7278943217092486],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440300388129*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "3.6950142776280903`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "148.84207193026978`"}],
  SequenceForm["*BFGSUP ", 3.6950142776280903`, "  ", 148.84207193026978`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604403004231567`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.35188636451481947`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.35188636451481947`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440300474051*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440300524815*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "4"}],
  SequenceForm["BFGS: Iteration = ", 4],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440300572549*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.273055656968618\"\>",
     -5.273055656968618,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-5.273055656968618, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440301019195*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.539349508343284\"\>",
     -5.539349508343284,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-5.539349508343284, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440301053932*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.266293851374666\"\>",
     0.266293851374666,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.266293851374666, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440301111745*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440301167377*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.9235\"\>",
         0.9235183068025847,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7322\"\>",
         0.7322399981616949,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1913\"\>",
         0.19127830864088974`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4808\"\>",
         0.4808008422961585,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.9113\"\>",
         0.9112967619173298,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8858\"\>",
         0.8857883184502992,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0255\"\>",
         0.025508443467030677`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2371\"\>",
         0.23711231462705484`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.7948\"\>",
         0.794780962787569,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8017\"\>",
         0.8016702102371686,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0069\"\>",
         -0.006889247449599539,
         AutoDelete->True], 
        InterpretationBox["\<\"-1.9492\"\>",
         -1.9492215602678709`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.3622\"\>",
         -0.36221883600066385`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.5817\"\>",
         -0.5816877652519533,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2195\"\>",
         0.2194689292512895,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8603\"\>",
         0.8602865019542527,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440301228251*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440301276865*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.39\"\>",
         1.3899135066335446`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2805\"\>",
         0.28046081961750013`,
         AutoDelete->True], 
        InterpretationBox["\<\"-2.628\"\>",
         -2.627781238958989,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8643\"\>",
         0.8642817189509644,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.2805\"\>",
         0.2804608196175,
         AutoDelete->True], 
        InterpretationBox["\<\" 8.316\"\>",
         8.31594773578581,
         AutoDelete->True], 
        InterpretationBox["\<\" 11.73\"\>",
         11.726947337512996`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2375\"\>",
         0.23752429526992325`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\"-2.628\"\>",
         -2.627781238958989,
         AutoDelete->True], 
        InterpretationBox["\<\" 11.73\"\>",
         11.726947337513,
         AutoDelete->True], 
        InterpretationBox["\<\" 44.61\"\>",
         44.60618235071475,
         AutoDelete->True], 
        InterpretationBox["\<\"-6.554\"\>",
         -6.554081069755092,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.8643\"\>",
         0.8642817189509646,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2375\"\>",
         0.23752429526992325`,
         AutoDelete->True], 
        InterpretationBox["\<\"-6.554\"\>",
         -6.5540810697550915`,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.933\"\>",
         2.933247076968964,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440301331935*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.1`", ",", "0.1`", ",", "0.1`", ",", "0.1`"}], "}"}]}],
  SequenceForm["Score: INC: ", {0.1, 0.1, 0.1, 0.1}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440301709153*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "0.4627989401180974`"}],
  SequenceForm["NOISE  ", 0.4627989401180974],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440304134358*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "6.061860852843295`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "3.3305582558355034`"}],
  SequenceForm["*BFGSUP ", 6.061860852843295, "  ", 3.3305582558355034`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440304168618*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.5080105379454836`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.5080105379454836, " = Elastizitaet(d l/l)/(d theta/theta)"],
  
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440304226342*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440304271508*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["BFGS: Iteration = ", 5],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440304323814*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.257705346615772\"\>",
     -5.257705346615772,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.273055656968618\"\>",
     -5.273055656968618,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[-5.257705346615772, {20, 15}], "  LIKALT  ", 
   PaddedForm[-5.273055656968618, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440305410862*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.257705346615772\"\>",
     -5.257705346615772,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-5.257705346615772, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604403054461613`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.273055656968618\"\>",
     -5.273055656968618,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-5.273055656968618, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604403054970207`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.015350310352846\"\>",
     0.015350310352846286`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.015350310352846286`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440305545506*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440305583535*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.9604\"\>",
         0.9604230641037956,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.9235\"\>",
         0.9235183068025847,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0369\"\>",
         0.0369047573012109,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0851\"\>",
         0.0850928343833246,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 1.0077\"\>",
         1.0076561744978036`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.9113\"\>",
         0.9112967619173298,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0964\"\>",
         0.09635941258047381,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1175\"\>",
         -0.11748352515632554`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.7310\"\>",
         0.7310264512540295,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7948\"\>",
         0.794780962787569,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0638\"\>",
         -0.06375451153353948,
         AutoDelete->True], 
        InterpretationBox["\<\"-2.6788\"\>",
         -2.6787678409131033`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.2810\"\>",
         -0.28097439668266144`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.3622\"\>",
         -0.36221883600066385`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0812\"\>",
         0.0812444393180024,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4718\"\>",
         0.47182001562786624`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440305631754*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440305683179*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.569\"\>",
         1.5691856227278032`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7513\"\>",
         0.7513430936093632,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.244\"\>",
         2.2435581620763543`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4185\"\>",
         0.41849965225432106`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.7513\"\>",
         0.7513430936093632,
         AutoDelete->True], 
        InterpretationBox["\<\" 8.891\"\>",
         8.890903788157047,
         AutoDelete->True], 
        InterpretationBox["\<\" 14.83\"\>",
         14.834447018585886`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3932\"\>",
         0.39315480127928015`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 2.244\"\>",
         2.243558162076355,
         AutoDelete->True], 
        InterpretationBox["\<\" 14.83\"\>",
         14.83444701858589,
         AutoDelete->True], 
        InterpretationBox["\<\" 35.18\"\>",
         35.17819519263953,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7489\"\>",
         0.748852737381208,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.4185\"\>",
         0.4184996522543213,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3932\"\>",
         0.39315480127928026`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7489\"\>",
         0.748852737381208,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.383\"\>",
         1.383097126781562,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440305732669*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"0.1`", ",", "0.10076561744978037`", ",", "0.1`", ",", "0.1`"}], 
    "}"}]}],
  SequenceForm["Score: INC: ", {0.1, 0.10076561744978037`, 0.1, 0.1}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440306069825*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "0.4645216381230144`"}],
  SequenceForm["NOISE  ", 0.4645216381230144],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440308510301*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.3740126938803797`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.3740126938803797, " = Elastizitaet(d l/l)/(d theta/theta)"],
  
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604403085443296`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440308594417*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "6"}],
  SequenceForm["BFGS: Iteration = ", 6],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604403086415157`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.297308621022523\"\>",
     -5.297308621022523,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.257705346615772\"\>",
     -5.257705346615772,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[-5.297308621022523, {20, 15}], "  LIKALT  ", 
   PaddedForm[-5.257705346615772, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440309776232*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.263934028180037\"\>",
     -5.263934028180037,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.257705346615772\"\>",
     -5.257705346615772,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[-5.263934028180037, {20, 15}], "  LIKALT  ", 
   PaddedForm[-5.257705346615772, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440310395856*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.259018802086718\"\>",
     -5.259018802086718,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.257705346615772\"\>",
     -5.257705346615772,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[-5.259018802086718, {20, 15}], "  LIKALT  ", 
   PaddedForm[-5.257705346615772, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440311005131*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.258018238813476\"\>",
     -5.2580182388134755`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.257705346615772\"\>",
     -5.257705346615772,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[-5.2580182388134755`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-5.257705346615772, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440311617948*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.257782598946306\"\>",
     -5.257782598946306,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.257705346615772\"\>",
     -5.257705346615772,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
   PaddedForm[-5.257782598946306, {20, 15}], "  LIKALT  ", 
   PaddedForm[-5.257705346615772, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440312224334*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.257724598970257\"\>",
     -5.257724598970257,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.257705346615772\"\>",
     -5.257705346615772,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
   PaddedForm[-5.257724598970257, {20, 15}], "  LIKALT  ", 
   PaddedForm[-5.257705346615772, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.460440312832775*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.257710155908176\"\>",
     -5.257710155908176,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.257705346615772\"\>",
     -5.257705346615772,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 7, "  LIKNEU  ", 
   PaddedForm[-5.257710155908176, {20, 15}], "  LIKALT  ", 
   PaddedForm[-5.257705346615772, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604403134665127`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "8", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.257706548701611\"\>",
     -5.257706548701611,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -5.257705346615772\"\>",
     -5.257705346615772,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 8, "  LIKNEU  ", 
   PaddedForm[-5.257706548701611, {20, 15}], "  LIKALT  ", 
   PaddedForm[-5.257705346615772, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604403140849648`*^9}]
}, Open  ]],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{
  3.4604357807117*^9, {3.4604358305263567`*^9, 3.46043594902765*^9}, 
   3.460436029507568*^9, 3.460440314346487*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "1", 
       RowBox[{"-", "0.4157159184496983`"}], "1.943456266116643`"},
      {"2", "2", "1.8289295519362603`", "1.5816758008494614`"},
      {"3", "0.3`", "1.0794632379691322`", "0.633903696838826`"},
      {"4", 
       RowBox[{"-", "0.1`"}], 
       RowBox[{"-", "0.10459507881035061`"}], "2.7315582428232643`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.460113389973647*^9, 3.460114056100081*^9, 
  3.460114179071628*^9, 3.4601142697179193`*^9, 3.460114343759589*^9, 
  3.460121016537031*^9, 3.4602008503444023`*^9, 3.460201923221129*^9, 
  3.460201965915328*^9, 3.4602793122704687`*^9, 3.460279517413031*^9, 
  3.46028255805007*^9, 3.4603672164787407`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Nichtlinear", ",", " ", "Norkorr"}]], "Input",
 CellChangeTimes->{{3.460367266700344*^9, 3.4603672898119717`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "scoreii", ",", "k", 
      ",", "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
    RowBox[{"BFGS", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"Y", ",", "X", ",", 
         RowBox[{"-", "9"}]}], "}"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      "\t  ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"IdioNonlin", ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"m", "=", "3"}], ",", 
          RowBox[{"eps", "=", 
           RowBox[{"10.", "^", 
            RowBox[{"-", "16"}]}]}], ",", 
          RowBox[{"ksigma", "=", "Infinity"}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Lik", ",", "IndividualLikNonlin", ",", "Score", ",", "Hesse"}], 
         "}"}]}], "}"}], ",", "\[IndentingNewLine]", "            ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Sing", "=", "False"}], ",", 
          RowBox[{"2", "Pi"}], ",", "0", ",", 
          RowBox[{"norkorr", "=", "1"}]}], "}"}], ",", 
        RowBox[{"KMAX", "=", "20"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EPS1", "=", ".0001"}], ",", 
          RowBox[{"EPS2", "=", ".0001"}]}], "}"}], ",", "\[IndentingNewLine]",
         "             ", 
        RowBox[{"OPTION", "=", "0"}], ",", 
        RowBox[{"PRINT", "=", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1"}], "}"}]}]}], "}"}]}], "]"}]}], ";"}], 
  "                                                                           \
     "}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113330285616*^9, 3.460113346379695*^9}, {
   3.460200648978776*^9, 3.4602006503583603`*^9}, {3.460200794874672*^9, 
   3.4602007984595947`*^9}, 3.460201903279232*^9, {3.460201941045977*^9, 
   3.4602019411313553`*^9}, {3.460279278878285*^9, 3.460279290392777*^9}, {
   3.460279385569292*^9, 3.4602794078107224`*^9}, 3.460279483282811*^9, {
   3.460282734453003*^9, 3.46028273588818*^9}, {3.460283616696549*^9, 
   3.460283634147719*^9}, {3.4602836706901093`*^9, 3.460283671258127*^9}, {
   3.4602837458995867`*^9, 3.4602837460095263`*^9}, {3.460283977779047*^9, 
   3.4602839782382393`*^9}, {3.460284094017385*^9, 3.460284112248164*^9}, {
   3.4602842039019938`*^9, 3.460284237509654*^9}, {3.460285585933895*^9, 
   3.460285590933837*^9}, 3.460367196326754*^9, {3.460367298081849*^9, 
   3.460367298170825*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Tiefe von data = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["Tiefe von data = ", 5],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9}],

Cell[BoxData["\<\"L\[ADoubleDot]nge der Paneldaten\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367299067006*^9}],

Cell[BoxData[
 RowBox[{"{", "1", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603672990822372`*^9}],

Cell[BoxData["\<\"***********************LSDE1********************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367299096623*^9}],

Cell[BoxData["\<\"***********************MODUL:    BFGS \
(skeleton)**************\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367299112047*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367299126872*^9}],

Cell[BoxData["\<\"Technical Output\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367299141508*^9}],

Cell[BoxData["IndividualLikNonlin"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603672991587477`*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367299175606*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"KMAX\"\>",
       HoldForm], 
      TagBox["\<\"EPS1\"\>",
       HoldForm], 
      TagBox["\<\"EPS2\"\>",
       HoldForm], 
      TagBox["\<\"K\"\>",
       HoldForm], 
      TagBox["\<\"Q\"\>",
       HoldForm], 
      TagBox["\<\"n\"\>",
       HoldForm], 
      TagBox["\<\"T\"\>",
       HoldForm], 
      TagBox["\<\"OPTION\"\>",
       HoldForm]},
     {"1", "20", "0.0001`", "0.0001`", "4", "1", "1", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"KMAX", "EPS1", "EPS2", "K", "Q", "n", "T", "OPTION"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367299191182*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367299207294*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"MAXSTEP\"\>",
       HoldForm], 
      TagBox["\<\"MINSTEP\"\>",
       HoldForm], 
      TagBox["\<\"BOUND\"\>",
       HoldForm], 
      TagBox["\<\"STEPREDUCE\"\>",
       HoldForm], 
      TagBox["\<\"FMAX\"\>",
       HoldForm]},
     {"1", "1", "1.`*^-10", "1.`*^-6", "4", "1000"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"MAXSTEP", "MINSTEP", "BOUND", "STEPREDUCE", "FMAX"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367299226161*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367299242632*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"RESAMPLING\"\>",
       HoldForm], 
      TagBox["\<\"FDIGITS\"\>",
       HoldForm], 
      TagBox["\<\"TYP\"\>",
       HoldForm], 
      TagBox["\<\"YMAX\"\>",
       HoldForm], 
      TagBox["\<\"ANALGRAD\"\>",
       HoldForm], 
      TagBox["\<\"FACTOR\"\>",
       HoldForm], 
      TagBox["\<\"CSEED\"\>",
       HoldForm]},
     {"1", "True", "16", "1", "1.`*^8", "False", "1.`", 
      RowBox[{"-", "999"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {
      "RESAMPLING", "FDIGITS", "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}},
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603672992589912`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367299265922*^9}],

Cell[BoxData["\<\"    SCALING\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729927582*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "::", "\<\"nmtx\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The first two levels of the \
one-dimensional list \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\
\\!\\({}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" cannot be \
transposed.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Transpose\\\", ButtonNote -> \\\"Transpose::nmtx\\\
\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.460113347438837*^9, 3.4601140477211742`*^9, 3.460114171488365*^9, 
   3.4601142582303123`*^9, 3.46011431981378*^9, 3.4601210026174927`*^9, 
   3.4602006082555428`*^9, 3.4602006525509787`*^9, 3.4602007997492933`*^9, {
   3.460201893745349*^9, 3.460201903902554*^9}, 3.4602019417761383`*^9, 
   3.460279294169009*^9, 3.460279424327683*^9, 3.4602794918395157`*^9, 
   3.460282465738028*^9, 3.4602825470673647`*^9, 3.460282687933013*^9, 
   3.4602827362471*^9, 3.460282807351432*^9, 3.460282913928569*^9, 
   3.460283210827161*^9, 3.460283352033407*^9, 3.460283407184712*^9, {
   3.460283619834437*^9, 3.460283671655117*^9}, 3.460283747410516*^9, 
   3.460283804801373*^9, {3.460283909419492*^9, 3.460283979704739*^9}, 
   3.46028403988277*^9, {3.4602840959065733`*^9, 3.460284112635261*^9}, 
   3.460284241484562*^9, 3.4602855917581997`*^9, {3.460367187530768*^9, 
   3.4603671971813374`*^9}, 3.4603672993256197`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  RowBox[{"Transpose", "[", 
   RowBox[{"{", "}"}], "]"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
    0]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603672993797703`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367299445589*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367299489793*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367299540718*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STARTWERT THETA0 = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "0.3`", ",", 
     RowBox[{"-", "0.1`"}]}], "}"}]}],
  SequenceForm["STARTWERT THETA0 = ", {1, 2, 0.3, -0.1}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603672995924597`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "2.9802322387695312`*^-8", ",", 
     "1.4901161193847656`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 2.9802322387695312`*^-8, 
   1.4901161193847656`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603672996473227`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.1665818691253662`"}], ",", 
     RowBox[{"-", "0.12218034267425537`"}], ",", "3.2592514157295227`", ",", 
     RowBox[{"-", "0.06820720434188843`"}]}], "}"}], ",", 
   RowBox[{"-", "7.647290149225717`"}]}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729969348*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367299748827*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["BFGS: Iteration = ", 1],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367299811582*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.426363481334434\"\>",
     -6.426363481334434,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-6.426363481334434, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367299857751*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -7.647290149225717\"\>",
     -7.647290149225717,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-7.647290149225717, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367299909409*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     1.220926667891283\"\>",
     1.2209266678912831`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[1.2209266678912831`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367299998001*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367300060358*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.9489\"\>",
         0.9488895307918184,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\"-0.0511\"\>",
         -0.051110469208181644`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1666\"\>",
         -0.1665818691253662,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 1.9625\"\>",
         1.9625127591923106`,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\"-0.0375\"\>",
         -0.03748724080768945,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1222\"\>",
         -0.12218034267425537`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.3000\"\>",
         1.3,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3000\"\>",
         0.3,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0000\"\>",
         1.,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.2593\"\>",
         3.2592514157295227`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.1209\"\>",
         -0.12092726078531794`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1000\"\>",
         -0.1,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0209\"\>",
         -0.020927260785317942`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0682\"\>",
         -0.06820720434188843,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673000962887`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367300142095*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367300177538*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "2.924371896970735`*^-8", ",", 
     "1.9371509552001954`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 2.924371896970735*^-8, 
   1.9371509552001954`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367300211916*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "6.807592404319743`*^-8"}],
  SequenceForm["NOISE  ", 6.807592404319743*^-8],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367300246999*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "0.2195313129906644`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "0.9955642401025658`"}],
  SequenceForm["*BFGSUP ", 0.2195313129906644, "  ", 0.9955642401025658],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730029036*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.26484970407777847`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.26484970407777847`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367300328858*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367300367899*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "2"}],
  SequenceForm["BFGS: Iteration = ", 2],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673004094954`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.285326923522202\"\>",
     -6.285326923522202,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-6.285326923522202, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730045844*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.426363481334434\"\>",
     -6.426363481334434,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-6.426363481334434, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367300496675*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.141036557812232\"\>",
     0.14103655781223168`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.14103655781223168`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673005417643`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367300575492*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7427\"\>",
         0.7426715210080044,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.9489\"\>",
         0.9488895307918184,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.2062\"\>",
         -0.20621800978381397`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.2387\"\>",
         -0.23869162797927856`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 1.6928\"\>",
         1.692802641873854,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.9625\"\>",
         1.9625127591923106`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.2697\"\>",
         -0.2697101173184566,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.3399\"\>",
         -0.3398938161116038,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.0374\"\>",
         1.037411412193135,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.3000\"\>",
         1.3,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.2626\"\>",
         -0.262588587806865,
         AutoDelete->True], 
        InterpretationBox["\<\"-1.3092\"\>",
         -1.309246512559744,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.2354\"\>",
         -0.2353846116843536,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1209\"\>",
         -0.12092726078531794`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1145\"\>",
         -0.11445735089903566`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1395\"\>",
         -0.13950425386428833`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367300613216*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673006465273`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.9985\"\>",
         0.998540830108466,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.001539\"\>",
         0.0015389888997529972`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1232\"\>",
         0.1232046768032847,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000638\"\>",
         0.00006379963100596885,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.001539\"\>",
         0.0015389888997529974`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.009\"\>",
         1.0090065393845922`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2557\"\>",
         0.2556719707891003,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.002627\"\>",
         0.0026266117242778634`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.1232\"\>",
         0.1232046768032847,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2557\"\>",
         0.2556719707891003,
         AutoDelete->True], 
        InterpretationBox["\<\" 4.586\"\>",
         4.586311842664722,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.09234\"\>",
         0.09234026461817957,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.0000638\"\>",
         0.00006379963100596906,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.002627\"\>",
         0.002626611724277864,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.09234\"\>",
         0.09234026461817957,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.001\"\>",
         1.0006799291754125`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730070115*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "2.5224725035933465`*^-8", ",", 
     "1.545863467742704`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 2.5224725035933465`*^-8, 
   1.545863467742704*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367300742609*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "2.41965327160126`*^-8"}],
  SequenceForm["NOISE  ", 2.41965327160126*^-8],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367300776059*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "1.4493584360125193`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "1.9973802614006846`"}],
  SequenceForm["*BFGSUP ", 1.4493584360125193`, "  ", 1.9973802614006846`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367300809037*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.08471795779810225`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.08471795779810225, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367300851637*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367300893951*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "3"}],
  SequenceForm["BFGS: Iteration = ", 3],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367300956852*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.238233992234003\"\>",
     -6.238233992234003,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-6.238233992234003, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367300998685*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.285326923522202\"\>",
     -6.285326923522202,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-6.285326923522202, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730104486*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.047092931288200\"\>",
     0.04709293128819958,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.04709293128819958, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367301079156*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367301111108*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8011\"\>",
         0.8010844817448731,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7427\"\>",
         0.7426715210080044,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0584\"\>",
         0.05841296073686873,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1015\"\>",
         0.1015276312828064,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 1.8965\"\>",
         1.8965144448710562`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.6928\"\>",
         1.692802641873854,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2037\"\>",
         0.20371180299720237`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3146\"\>",
         0.31455531075069626`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.0505\"\>",
         1.0504887846519861`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0374\"\>",
         1.037411412193135,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0131\"\>",
         0.013077372458851162`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2739\"\>",
         0.2738937169035493,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.1714\"\>",
         -0.171424995196168,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.2354\"\>",
         -0.2353846116843536,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0640\"\>",
         0.06395961648818559,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1014\"\>",
         0.10141521692276001`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367301150701*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367301201374*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.053\"\>",
         1.0525046986150768`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1622\"\>",
         0.1622005488673289,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2797\"\>",
         0.27965689689021445`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.05235\"\>",
         0.05235134562811677,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.1622\"\>",
         0.1622005488673289,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.399\"\>",
         1.399019101866013,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8685\"\>",
         0.8684863398616172,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1364\"\>",
         0.1364372384780535,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.2797\"\>",
         0.27965689689021456`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8685\"\>",
         0.8684863398616174,
         AutoDelete->True], 
        InterpretationBox["\<\" 4.795\"\>",
         4.795124401465335,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2803\"\>",
         0.28032662786337154`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.05235\"\>",
         0.05235134562811678,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1364\"\>",
         0.1364372384780535,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2803\"\>",
         0.28032662786337154`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.046\"\>",
         1.0459319791167452`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367301245566*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "2.8260267449484114`*^-8", ",", 
     "1.5653502712428363`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 2.8260267449484114`*^-8, 
   1.5653502712428363`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673012776537`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "5.453446554408213`*^-9"}],
  SequenceForm["NOISE  ", 5.453446554408213*^-9],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367301319874*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "15.11251114943126`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "12.487910521612747`"}],
  SequenceForm["*BFGSUP ", 15.11251114943126, "  ", 12.487910521612747`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367301357229*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.01563221753203196`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.01563221753203196, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367301395422*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367301454337*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "4"}],
  SequenceForm["BFGS: Iteration = ", 4],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367301497519*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236683262802132\"\>",
     -6.236683262802132,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-6.236683262802132, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367301530411*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.238233992234003\"\>",
     -6.238233992234003,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-6.238233992234003, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367301566225*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.001550729431870\"\>",
     0.0015507294318704012`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.0015507294318704012`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730159934*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673016345577`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8244\"\>",
         0.8243776234706608,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8011\"\>",
         0.8010844817448731,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0233\"\>",
         0.023293141725787694`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0262\"\>",
         0.026170670986175537`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 1.9376\"\>",
         1.9375670267943657`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.8965\"\>",
         1.8965144448710562`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0411\"\>",
         0.04105258192330946,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0514\"\>",
         0.05141929240035306,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.0495\"\>",
         1.0494761086661717`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0505\"\>",
         1.0504887846519861`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0010\"\>",
         -0.0010126759858143583`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0349\"\>",
         0.03489079248061612,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.1512\"\>",
         -0.15122543960519413`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1714\"\>",
         -0.171424995196168,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0202\"\>",
         0.020199555590973868`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0226\"\>",
         0.022629976272583008`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367301672398*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367301705782*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.01\"\>",
         1.0096000521720123`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.06305\"\>",
         0.06305389959702881,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2046\"\>",
         0.2045802188606004,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.01349\"\>",
         0.013493464218273306`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.06305\"\>",
         0.06305389959702876,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.21\"\>",
         1.2098010495720888`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.743\"\>",
         0.743023891166784,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.05137\"\>",
         0.05136522578479469,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.2046\"\>",
         0.20458021886060052`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.743\"\>",
         0.7430238911667842,
         AutoDelete->True], 
        InterpretationBox["\<\" 4.722\"\>",
         4.721572100046405,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.218\"\>",
         0.21801717104503138`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.01349\"\>",
         0.013493464218273292`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.05137\"\>",
         0.05136522578479469,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.218\"\>",
         0.21801717104503132`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.011\"\>",
         1.0112983238787665`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367301753096*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "2.8871998590146983`*^-8", ",", 
     "1.5638412664326604`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 2.8871998590146983`*^-8, 
   1.5638412664326604`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367301813343*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "8.199723025768499`*^-10"}],
  
  SequenceForm["NOISE  ", 8.199723025768499*^-10],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673018507843`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "312.62780903114395`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "318.2408401870078`"}],
  SequenceForm["*BFGSUP ", 312.62780903114395`, "  ", 318.2408401870078],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673019081793`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0011209434384390653`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0011209434384390653`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673019451447`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367301979355*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["BFGS: Iteration = ", 5],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730202164*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236663128996462\"\>",
     -6.2366631289964625`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-6.2366631289964625`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673020611353`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236683262802132\"\>",
     -6.236683262802132,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-6.236683262802132, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367302099133*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000020133805670\"\>",
     0.000020133805669786398`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.000020133805669786398`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367302131687*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367302170388*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8261\"\>",
         0.8261499980192529,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8244\"\>",
         0.8243776234706608,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0018\"\>",
         0.0017723745485920895`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0014\"\>",
         0.0014473199844360352`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 1.9349\"\>",
         1.934905955053722,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.9376\"\>",
         1.9375670267943657`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0027\"\>",
         -0.0026610717406435782`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0036\"\>",
         -0.00360811733704361,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.0491\"\>",
         1.0491291310613273`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0495\"\>",
         1.0494761086661717`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0003\"\>",
         -0.0003469776048444226,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0029\"\>",
         -0.0028794895521281083`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.1482\"\>",
         -0.14824600441829375`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1512\"\>",
         -0.15122543960519413`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0030\"\>",
         0.002979435186900375,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0027\"\>",
         0.002726614475250244,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367302211193*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367302244259*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.9827\"\>",
         0.9827275204424598,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.06012\"\>",
         0.0601226419639411,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2059\"\>",
         0.2059239210981843,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.02114\"\>",
         -0.021144815919569925`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.06012\"\>",
         0.06012264196394099,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.315\"\>",
         1.3150321593213596`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8218\"\>",
         0.8218466575716217,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.02345\"\>",
         0.02345415159685177,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.2059\"\>",
         0.20592392109818441`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8218\"\>",
         0.8218466575716219,
         AutoDelete->True], 
        InterpretationBox["\<\" 4.78\"\>",
         4.780149096511347,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2018\"\>",
         0.20176096923575892`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.02114\"\>",
         -0.021144815919569966`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.02345\"\>",
         0.02345415159685177,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2018\"\>",
         0.20176096923575884`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.9722\"\>",
         0.9721677247511386,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367302290366*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "2.883234553119126`*^-8", ",", 
     "1.5633242295106162`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 2.883234553119126*^-8, 
   1.5633242295106162`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367302323049*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "9.663218129401003`*^-11"}],
  
  SequenceForm["NOISE  ", 9.663218129401003*^-11],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367302374426*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "432660.25071590615`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "46971.419811553744`"}],
  SequenceForm["*BFGSUP ", 432660.25071590615`, "  ", 46971.419811553744`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367302419918*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0008083235444246563`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0008083235444246563, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367302452688*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367302488969*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "6"}],
  SequenceForm["BFGS: Iteration = ", 6],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730252171*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236502925017044\"\>",
     -6.236502925017044,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-6.236502925017044, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367302556271*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236663128996462\"\>",
     -6.2366631289964625`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-6.2366631289964625`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367302589354*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000160203979418\"\>",
     0.00016020397941840514`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.00016020397941840514`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367302628088*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367302664544*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8540\"\>",
         0.8540012772377316,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8261\"\>",
         0.8261499980192529,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0279\"\>",
         0.02785127921847859,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0018\"\>",
         0.0018437504768371582`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 1.9019\"\>",
         1.901905004201234,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.9349\"\>",
         1.934905955053722,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0330\"\>",
         -0.033000950852487915`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0026\"\>",
         -0.0026054194689131647`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.0477\"\>",
         1.0476541972530042`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0491\"\>",
         1.0491291310613273`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0015\"\>",
         -0.001474933808323034,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0006\"\>",
         -0.0005940414266650016,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.1053\"\>",
         -0.10534380516338607`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1482\"\>",
         -0.14824600441829375`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0429\"\>",
         0.04290219925490769,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0029\"\>",
         0.002876758575439453,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673027084017`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730275963*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.9523\"\>",
         0.9523304824751043,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4774\"\>",
         0.47739456258273616`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7937\"\>",
         0.7936787362538054,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1808\"\>",
         -0.1807546870658998,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.4774\"\>",
         0.47739456258273605`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.139\"\>",
         1.1385321475045647`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.325\"\>",
         1.3253256640840605`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5507\"\>",
         0.5506930356555182,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.7937\"\>",
         0.7936787362538056,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.325\"\>",
         1.3253256640840607`,
         AutoDelete->True], 
        InterpretationBox["\<\" 6.651\"\>",
         6.650590107997849,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.719\"\>",
         0.719011573193328,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.1808\"\>",
         -0.18075468706589984`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5507\"\>",
         0.5506930356555182,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.719\"\>",
         0.7190115731933279,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6327\"\>",
         0.6327157252715635,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367302809602*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "2.834059304298809`*^-8", ",", 
     "1.5611264068678085`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 2.834059304298809*^-8, 
   1.5611264068678085`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367302854793*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.7196162525460616`*^-10"}],
  SequenceForm["NOISE  ", 1.7196162525460616`*^-10],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673028983593`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "4953.16137603105`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "3822.227136794657`"}],
  SequenceForm["*BFGSUP ", 4953.16137603105, "  ", 3822.227136794657],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367302933405*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.001455340883769894`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.001455340883769894, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673029775753`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367303009747*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "7"}],
  SequenceForm["BFGS: Iteration = ", 7],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673030440903`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236474653667750\"\>",
     -6.2364746536677504`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-6.2364746536677504`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367303094494*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236502925017044\"\>",
     -6.236502925017044,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-6.236502925017044, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367303125938*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000028271349294\"\>",
     0.000028271349293618186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.000028271349293618186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367303159733*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367303204615*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8672\"\>",
         0.8672177986031816,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8540\"\>",
         0.8540012772377316,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0132\"\>",
         0.013216521365449986`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0031\"\>",
         0.0030846595764160156`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 1.8904\"\>",
         1.8903666752236097`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.9019\"\>",
         1.901905004201234,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0115\"\>",
         -0.011538328977624347`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0030\"\>",
         0.0030493905495405163`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.0481\"\>",
         1.0481136064587728`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0477\"\>",
         1.0476541972530042`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0005\"\>",
         0.00045940920576861886`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0087\"\>",
         0.008663390746990877,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0874\"\>",
         -0.08738957356686698,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1053\"\>",
         -0.10534380516338607`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0180\"\>",
         0.017954231596519085`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0020\"\>",
         0.0020333528518676758`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367303241004*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367303274226*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.947\"\>",
         0.9469642953348002,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5305\"\>",
         0.5305124154084381,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8548\"\>",
         0.8547651789100271,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.2062\"\>",
         -0.20621180369409559`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.5305\"\>",
         0.530512415408438,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.271\"\>",
         1.270972693541804,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.579\"\>",
         1.5787030444997012`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5557\"\>",
         0.5557181420360748,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.8548\"\>",
         0.8547651789100273,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.579\"\>",
         1.5787030444997012`,
         AutoDelete->True], 
        InterpretationBox["\<\" 7.074\"\>",
         7.073727480358865,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6869\"\>",
         0.6868702786319254,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.2062\"\>",
         -0.20621180369409564`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5557\"\>",
         0.5557181420360748,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6869\"\>",
         0.6868702786319253,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6046\"\>",
         0.6046073158473292,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673033224583`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "2.8168658542984868`*^-8", ",", 
     "1.561810979930718`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 2.8168658542984868`*^-8, 
   1.561810979930718*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367303366633*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.935398562607812`*^-10"}],
  
  SequenceForm["NOISE  ", 1.935398562607812*^-10],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367303406384*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "27908.106625744305`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "21705.662503402455`"}],
  SequenceForm["*BFGSUP ", 27908.106625744305`, "  ", 21705.662503402455`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730344077*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0007268422445207215`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0007268422445207215, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730347509*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367303511238*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "8"}],
  SequenceForm["BFGS: Iteration = ", 8],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367303549233*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236471224583469\"\>",
     -6.236471224583469,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-6.236471224583469, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367303594131*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236474653667750\"\>",
     -6.2364746536677504`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-6.2364746536677504`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673036283817`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     3.429084281414418\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-6\"\>"]}],
     3.4290842814144185`*^-6,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[3.4290842814144185`*^-6, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367303694882*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730373419*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8707\"\>",
         0.8706652415018115,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8672\"\>",
         0.8672177986031816,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0034\"\>",
         0.00344744289862989,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0015\"\>",
         0.0015411972999572754`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 1.8886\"\>",
         1.888617324472237,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.8904\"\>",
         1.8903666752236097`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0017\"\>",
         -0.0017493507513726867`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0015\"\>",
         0.001513065230320109,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.0487\"\>",
         1.0486607227822378`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0481\"\>",
         1.0481136064587728`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0005\"\>",
         0.0005471163234649325,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0043\"\>",
         0.004324849145393437,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0844\"\>",
         -0.0843755555544976,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0874\"\>",
         -0.08738957356686698,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0030\"\>",
         0.003014018012369383,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0003\"\>",
         0.0002974867820739746,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367303805379*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367303839809*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8069\"\>",
         0.8069170168735293,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3925\"\>",
         0.39251913460160365`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4616\"\>",
         0.46159464842965225`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.2676\"\>",
         -0.26758146775288627`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.3925\"\>",
         0.39251913460160354`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.135\"\>",
         1.1350078321551686`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.191\"\>",
         1.1913005191095432`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4956\"\>",
         0.49555933802291413`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.4616\"\>",
         0.4615946484296526,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.191\"\>",
         1.1913005191095434`,
         AutoDelete->True], 
        InterpretationBox["\<\" 5.97\"\>",
         5.969936030146503,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5147\"\>",
         0.5146886821289891,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.2676\"\>",
         -0.2675814677528863,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4956\"\>",
         0.49555933802291413`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5147\"\>",
         0.514688682128989,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.599\"\>",
         0.5989583095720044,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673038740396`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "2.8142591185454086`*^-8", ",", 
     "1.5626262467834916`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 2.8142591185454086`*^-8, 
   1.5626262467834916`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673039119053`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "7.37436141304225`*^-11"}],
  SequenceForm["NOISE  ", 7.37436141304225*^-11],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673039461393`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "199678.30005193086`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "168658.69527070064`"}],
  SequenceForm["*BFGSUP ", 199678.30005193086`, "  ", 168658.69527070064`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367303979608*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "0.00010005674742694594`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.00010005674742694594`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673040265503`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367304058941*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "9"}],
  SequenceForm["BFGS: Iteration = ", 9],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673040957327`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236470560861720\"\>",
     -6.2364705608617195`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-6.2364705608617195`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673041324987`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236471224583469\"\>",
     -6.236471224583469,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-6.236471224583469, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673041827087`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     6.637217495608638\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-7\"\>"]}],
     6.637217495608638*^-7,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[6.637217495608638*^-7, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367304239073*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367304290433*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8714\"\>",
         0.8713656497832247,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8707\"\>",
         0.8706652415018115,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0007\"\>",
         0.0007004082814133203,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0006\"\>",
         0.0006240010261535645,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 1.8888\"\>",
         1.8888423617676358`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.8886\"\>",
         1.888617324472237,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0002\"\>",
         0.00022503729539870886`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0001\"\>",
         0.0001263659898636985,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.0488\"\>",
         1.0487841908356952`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0487\"\>",
         1.0486607227822378`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0001\"\>",
         0.00012346805345738764`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0004\"\>",
         0.0004058860593269794,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0851\"\>",
         -0.08510826142269327,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0844\"\>",
         -0.0843755555544976,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0007\"\>",
         -0.0007327058681956622,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0004\"\>",
         -0.00040847063064575195`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367304328233*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673043643436`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.5743\"\>",
         0.5742830246176581,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2532\"\>",
         0.2531844309927598,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.05514\"\>",
         0.05514458296759672,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.2156\"\>",
         -0.21561708836850563`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.2532\"\>",
         0.25318443099275967`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.133\"\>",
         1.13285463229466,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.173\"\>",
         1.1727716863711473`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6151\"\>",
         0.6151184011069867,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.05514\"\>",
         0.055144582967597056`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.173\"\>",
         1.1727716863711473`,
         AutoDelete->True], 
        InterpretationBox["\<\" 5.882\"\>",
         5.882003379817645,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8501\"\>",
         0.8501290442091518,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.2156\"\>",
         -0.21561708836850568`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6151\"\>",
         0.6151184011069867,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8501\"\>",
         0.8501290442091517,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6835\"\>",
         0.6835471335622856,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730440063*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "2.814594450246745`*^-8", ",", 
     "1.5628102285201776`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 2.814594450246745*^-8, 
   1.5628102285201776`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367304432108*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.6842211562526066`*^-11"}],
  SequenceForm["NOISE  ", 1.6842211562526066`*^-11],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367304479514*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "3.3065979333238243`*^6", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "1.2271514574048526`*^6"}],
  SequenceForm[
  "*BFGSUP ", 3.3065979333238243`*^6, "  ", 1.2271514574048526`*^6],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367304511091*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "0.00008513760635563955`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.00008513760635563955, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673045425386`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673045834827`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "10"}],
  SequenceForm["BFGS: Iteration = ", 10],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367304629602*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236469222501954\"\>",
     -6.236469222501954,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-6.236469222501954, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673046636143`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236470560861720\"\>",
     -6.2364705608617195`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-6.2364705608617195`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367304699831*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     1.338359765234998\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-6\"\>"]}],
     1.3383597652349977`*^-6,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[1.3383597652349977`*^-6, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367304754777*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367304787539*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8735\"\>",
         0.8735427827898863,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8714\"\>",
         0.8713656497832247,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0022\"\>",
         0.002177133006661562,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0004\"\>",
         0.00038367509841918945`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 1.8890\"\>",
         1.8890260667971315`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.8888\"\>",
         1.8888423617676358`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0002\"\>",
         0.00018370502949577474`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0003\"\>",
         -0.0002524178635596497,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.0489\"\>",
         1.0489196564736194`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0488\"\>",
         1.0487841908356952`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0001\"\>",
         0.00013546563792431182`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0005\"\>",
         -0.0005062606590552248,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0875\"\>",
         -0.08745133581037481,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0851\"\>",
         -0.08510826142269327,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0023\"\>",
         -0.0023430743876815333`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0005\"\>",
         -0.0004954934120178223,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367304834284*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367304883913*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.2874\"\>",
         0.2874358211617477,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4574\"\>",
         0.45742529923469555`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4692\"\>",
         0.4691874826225816,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1663\"\>",
         0.16632038099401653`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.4574\"\>",
         0.45742529923469544`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.588\"\>",
         1.5876804700593785`,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.252\"\>",
         2.2522817602765977`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7875\"\>",
         0.7874548342677756,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.4692\"\>",
         0.4691874826225819,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.252\"\>",
         2.252281760276597,
         AutoDelete->True], 
        InterpretationBox["\<\" 8.431\"\>",
         8.430966117714231,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.316\"\>",
         1.3160512191400553`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.1663\"\>",
         0.16632038099401658`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7875\"\>",
         0.7874548342677756,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.316\"\>",
         1.3160512191400553`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5038\"\>",
         0.5038398016147434,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673049388733`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "2.8148681920724086`*^-8", ",", 
     "1.5630120880508712`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 2.8148681920724086`*^-8, 
   1.5630120880508712`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730498125*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.146217245112576`*^-11"}],
  
  SequenceForm["NOISE  ", 3.146217245112576*^-11],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367305013558*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "920731.3485607048`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "531536.5161358757`"}],
  SequenceForm["*BFGSUP ", 920731.3485607048, "  ", 531536.5161358757],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673050473433`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0002699688462977789`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0002699688462977789, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367305081056*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367305113041*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "11"}],
  SequenceForm["BFGS: Iteration = ", 11],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367305145176*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236468200116804\"\>",
     -6.236468200116804,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-6.236468200116804, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367305178553*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236469222501954\"\>",
     -6.236469222501954,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-6.236469222501954, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367305223525*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     1.022385149873628\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-6\"\>"]}],
     1.022385149873628*^-6,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[1.022385149873628*^-6, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673052610817`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673052985163`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8762\"\>",
         0.8762365172116153,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8735\"\>",
         0.8735427827898863,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0027\"\>",
         0.002693734421729015,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 1.8885\"\>",
         1.888542883262463,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.8890\"\>",
         1.8890260667971315`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0005\"\>",
         -0.0004831835346685964,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0007\"\>",
         -0.0007115541537279305,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.0489\"\>",
         1.0488856270792615`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0489\"\>",
         1.0489196564736194`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0000\"\>",
         -0.00003402939435788127,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0016\"\>",
         -0.0016051299931119207`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0897\"\>",
         -0.08966150486013129,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0875\"\>",
         -0.08745133581037481,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0022\"\>",
         -0.002210169049756474,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0005\"\>",
         -0.0004943609237670898,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367305337229*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367305382431*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.3496\"\>",
         0.3496140107185984,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.674\"\>",
         0.6739956791333817,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.9676\"\>",
         0.9675565332230036,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.267\"\>",
         0.2669627700098276,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.674\"\>",
         0.6739956791333815,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.748\"\>",
         1.7479095540932508`,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.649\"\>",
         2.6488944301878963`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7205\"\>",
         0.7204960747579732,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.9676\"\>",
         0.967556533223004,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.649\"\>",
         2.648894430187896,
         AutoDelete->True], 
        InterpretationBox["\<\" 9.407\"\>",
         9.406529207504018,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.182\"\>",
         1.1815701003631536`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.267\"\>",
         0.26696277000982765`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7205\"\>",
         0.7204960747579732,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.182\"\>",
         1.1815701003631536`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3733\"\>",
         0.37334147436842513`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367305416679*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "2.8141481924987776`*^-8", ",", 
     "1.5629613803018055`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 2.8141481924987776`*^-8, 
   1.5629613803018055`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367305471884*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "4.698043321818683`*^-11"}],
  
  SequenceForm["NOISE  ", 4.698043321818683*^-11],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673055177193`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "1.1095102183219113`*^6", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "679075.7477574071`"}],
  SequenceForm["*BFGSUP ", 1.1095102183219113`*^6, "  ", 679075.7477574071],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673055501537`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "0.00026029676547173925`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.00026029676547173925`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367305593993*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673056269293`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "12"}],
  SequenceForm["BFGS: Iteration = ", 12],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367305668882*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236467742424750\"\>",
     -6.23646774242475,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-6.23646774242475, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367305733849*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236468200116804\"\>",
     -6.236468200116804,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-6.236468200116804, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673057764606`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     4.576920540344531\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-7\"\>"]}],
     4.576920540344531*^-7,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[4.576920540344531*^-7, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367305817593*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367305869713*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8781\"\>",
         0.8781205230113627,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8762\"\>",
         0.8762365172116153,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0019\"\>",
         0.0018840057997473046`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0002\"\>",
         -0.00018864870071411133`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 1.8877\"\>",
         1.8877457218419789`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.8885\"\>",
         1.888542883262463,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0008\"\>",
         -0.0007971614204840516,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0007\"\>",
         -0.0006756933354840814,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.0487\"\>",
         1.048737708249371,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0489\"\>",
         1.0488856270792615`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0001\"\>",
         -0.0001479188298906178,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0015\"\>",
         -0.0015476735103884618`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0907\"\>",
         -0.09074151226064016,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0897\"\>",
         -0.08966150486013129,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0011\"\>",
         -0.001080007400508869,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0003\"\>",
         -0.00031685829162597656`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367305923264*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673059673357`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.3863\"\>",
         0.38625043982389684`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6635\"\>",
         0.6634503577590122,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.9485\"\>",
         0.9484959423840404,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2289\"\>",
         0.2288589224625207,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.6635\"\>",
         0.6634503577590121,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.406\"\>",
         1.4055140065424747`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.876\"\>",
         1.8755830266919462`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4887\"\>",
         0.4886837520383678,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.9485\"\>",
         0.9484959423840408,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.876\"\>",
         1.8755830266919458`,
         AutoDelete->True], 
        InterpretationBox["\<\" 7.661\"\>",
         7.660592497348625,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.654\"\>",
         0.6540298319009499,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.2289\"\>",
         0.22885892246252076`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4887\"\>",
         0.4886837520383678,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.654\"\>",
         0.6540298319009499,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2423\"\>",
         0.2423378463473851,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367306001837*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "2.8129603294163627`*^-8", ",", 
     "1.562740964069025`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 2.8129603294163627`*^-8, 
   1.562740964069025*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673060355043`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.24449634842847`*^-11"}],
  SequenceForm["NOISE  ", 3.24449634842847*^-11],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673060700617`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "1.6850626983591474`*^6", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "1.325625672963328`*^6"}],
  SequenceForm["*BFGSUP ", 1.6850626983591474`*^6, "  ", 1.325625672963328*^6],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673061020203`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "0.00010588683959259983`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.00010588683959259983`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367306134284*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367306167727*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "13"}],
  SequenceForm["BFGS: Iteration = ", 13],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367306214797*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236467686754268\"\>",
     -6.236467686754268,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-6.236467686754268, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730624893*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236467742424750\"\>",
     -6.23646774242475,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-6.23646774242475, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367306281926*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     5.567048244614625\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-8\"\>"]}],
     5.567048244614625*^-8,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[5.567048244614625*^-8, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367306314125*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673063467197`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8783\"\>",
         0.8783320781009248,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8781\"\>",
         0.8781205230113627,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0002\"\>",
         0.00021155508956218665`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0001\"\>",
         -0.00012695789337158203`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 1.8874\"\>",
         1.8874365901205592`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.8877\"\>",
         1.8877457218419789`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0003\"\>",
         -0.00030913172141972266`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0003\"\>",
         -0.00027071984239780927`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.0487\"\>",
         1.0486599743337253`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0487\"\>",
         1.048737708249371,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0001\"\>",
         -0.00007773391564566996,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0006\"\>",
         -0.0006296711315633662,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0906\"\>",
         -0.09064434194312797,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0907\"\>",
         -0.09074151226064016,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0001\"\>",
         0.00009717031751219024,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0001\"\>",
         -0.00008440017700195312,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367306381839*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673064175053`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.3455\"\>",
         0.34548656988104554`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5366\"\>",
         0.5365727767820642,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6569\"\>",
         0.6568865154837554,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1738\"\>",
         0.1737844638572325,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.5366\"\>",
         0.536572776782064,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.077\"\>",
         1.0766406135476934`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.116\"\>",
         1.115756511918716,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3635\"\>",
         0.3634993221461902,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.6569\"\>",
         0.6568865154837558,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.116\"\>",
         1.1157565119187156`,
         AutoDelete->True], 
        InterpretationBox["\<\" 5.905\"\>",
         5.905380348511744,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3635\"\>",
         0.3635395335448023,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.1738\"\>",
         0.17378446385723256`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3635\"\>",
         0.3634993221461902,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3635\"\>",
         0.3635395335448024,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2003\"\>",
         0.20030147379279364`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367306456964*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "2.812499687255262`*^-8", ",", 
     "1.5626251315082986`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 2.812499687255262*^-8, 
   1.5626251315082986`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367306493354*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.0816742976598374`*^-11"}],
  SequenceForm["NOISE  ", 1.0816742976598374`*^-11],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367306533683*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "1.1932515190893384`*^7", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "1.0248514902682789`*^7"}],
  SequenceForm[
  "*BFGSUP ", 1.1932515190893384`*^7, "  ", 1.0248514902682789`*^7],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730657517*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "0.000016180740232016607`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.000016180740232016607`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367306612198*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673066475773`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367306691511*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "14"}],
  SequenceForm["BFGS: Iteration = ", 14],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367306732718*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236467684336905\"\>",
     -6.236467684336905,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-6.236467684336905, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367306767933*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236467686754268\"\>",
     -6.236467686754268,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-6.236467686754268, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367306802306*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     2.417363198503608\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-9\"\>"]}],
     2.417363198503608*^-9,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[2.417363198503608*^-9, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673068416243`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367306874661*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8782\"\>",
         0.8782495538082183,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8783\"\>",
         0.8783320781009248,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0001\"\>",
         -0.0000825242927065149,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0000\"\>",
         -0.000028073787689208984`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 1.8874\"\>",
         1.8873966860569518`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.8874\"\>",
         1.8874365901205592`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0000\"\>",
         -0.00003990406360751487,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0000\"\>",
         -0.00004102200517278667,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.0486\"\>",
         1.0486471719497916`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0487\"\>",
         1.0486599743337253`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0000\"\>",
         -0.000012802383933539189`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0001\"\>",
         -0.00009622820177612933,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0905\"\>",
         -0.09051412323092219,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0906\"\>",
         -0.09064434194312797,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0001\"\>",
         0.0001302187122057856,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367306932337*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367306968297*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.297\"\>",
         0.29697478890695567`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4554\"\>",
         0.4553598742097027,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.467\"\>",
         0.46703116933581157`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1581\"\>",
         0.15806997390679417`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.4554\"\>",
         0.4553598742097026,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.9551\"\>",
         0.9551074008348636,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8308\"\>",
         0.8308481428995622,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3479\"\>",
         0.34792042554138036`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.467\"\>",
         0.467031169335812,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8308\"\>",
         0.830848142899562,
         AutoDelete->True], 
        InterpretationBox["\<\" 5.238\"\>",
         5.237523138753248,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3265\"\>",
         0.3265292188082324,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.1581\"\>",
         0.15806997390679423`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3479\"\>",
         0.34792042554138036`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3265\"\>",
         0.3265292188082324,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2032\"\>",
         0.20319078011123132`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730700299*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "2.8124402255668517`*^-8", ",", 
     "1.5626060544696325`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 2.8124402255668517`*^-8, 
   1.5626060544696325`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673070381603`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.4561164065527037`*^-12"}],
  SequenceForm["NOISE  ", 1.4561164065527037`*^-12],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367307070229*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "2.316317909348565`*^8", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "2.1832837761495054`*^8"}],
  SequenceForm["*BFGSUP ", 2.316317909348565*^8, "  ", 2.1832837761495054`*^8],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673071046963`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "2.3893591609994894`*^-7", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 2.3893591609994894`*^-7, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367307136299*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673071933413`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673072360067`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "15"}],
  SequenceForm["BFGS: Iteration = ", 15],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367307271366*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236467684317764\"\>",
     -6.2364676843177635`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-6.2364676843177635`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367307311809*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -6.236467684336905\"\>",
     -6.236467684336905,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-6.236467684336905, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367307346615*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     1.914113312295740\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-11\"\>"]}],
     1.91411331229574*^-11,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[1.91411331229574*^-11, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367307396412*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673074304867`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8782\"\>",
         0.8782320796482105,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8782\"\>",
         0.8782495538082183,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0000\"\>",
         -0.000017474160007887252`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 1.8874\"\>",
         1.8873995952967793`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.8874\"\>",
         1.8873966860569518`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.0486\"\>",
         1.048647256326272,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0486\"\>",
         1.0486471719497916`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0905\"\>",
         -0.09050077668802063,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0905\"\>",
         -0.09051412323092219,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0.000013346542901560214`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367307480072*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367307516863*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.2886\"\>",
         0.2885942347260945,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.455\"\>",
         0.4549658945858093,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.467\"\>",
         0.4669562766834039,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1641\"\>",
         0.16407400057404606`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.455\"\>",
         0.4549658945858092,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.9727\"\>",
         0.9727080109669819,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8734\"\>",
         0.8734376279672378,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3592\"\>",
         0.35919156067669644`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.467\"\>",
         0.46695627668340434`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8734\"\>",
         0.8734376279672377,
         AutoDelete->True], 
        InterpretationBox["\<\" 5.34\"\>",
         5.340488052115502,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3531\"\>",
         0.3531477119486095,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.1641\"\>",
         0.1640740005740461,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3592\"\>",
         0.35919156067669644`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3531\"\>",
         0.35314771194860944`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2057\"\>",
         0.20574300931357886`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367307551714*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "2.812444560672014`*^-8", ",", 
     "1.5626061802003862`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 2.812444560672014*^-8, 
   1.5626061802003862`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367307592971*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "2.7286312837084753`*^-14"}],
  SequenceForm["NOISE  ", 2.7286312837084753`*^-14],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367307625005*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "2.6529524839182297`*^10", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "2.632034923541114`*^10"}],
  SequenceForm[
  "*BFGSUP ", 2.6529524839182297`*^10, "  ", 2.632034923541114*^10],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673076694927`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "5.734461986416375`*^-8",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 5.734461986416375*^-8, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367307714349*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367307762236*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367307803378*^9}],

Cell[BoxData["\<\"ReturnCode = 3\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367307840844*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS:  ENDE DER ITERATION  \"\>", "\[InvisibleSpace]", "15", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "20"}],
  SequenceForm["BFGS:  ENDE DER ITERATION  ", 15, "  ", 20],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367307881192*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {"1", "2.384185791015625`*^-7"},
      {"2", "1.5790149824107133`*^-7"},
      {"3", "3.410373378606092`*^-7"},
      {"4", "2.980232238769531`*^-7"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}]]]], "Print",\

 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367307926291*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367307959889*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.3094\"\>",
         0.3094170879193477,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4639\"\>",
         0.4638835624449506,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4856\"\>",
         0.4856131704431924,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1714\"\>",
         0.1714111404313779,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.4639\"\>",
         0.4638835624449505,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.9755\"\>",
         0.9754994872486131,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8791\"\>",
         0.87908091256318,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3584\"\>",
         0.35839210438896196`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.4856\"\>",
         0.48561317044319285`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8791\"\>",
         0.8790809125631799,
         AutoDelete->True], 
        InterpretationBox["\<\" 5.352\"\>",
         5.351845006077704,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3507\"\>",
         0.3507201380517371,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.1714\"\>",
         0.17141114043137798`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3584\"\>",
         0.35839210438896196`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3507\"\>",
         0.350720138051737,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1932\"\>",
         0.1932092596355364,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367307995071*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"Likelihood\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox[
        StyleBox["\<\"\[Null]\"\>",
         ShowStringCharacters->False],
        StyleForm[#, ShowStringCharacters -> False]& ], 
       TagBox[
        StyleBox["\<\"\[Null]\"\>",
         ShowStringCharacters->False],
        StyleForm[#, ShowStringCharacters -> False]& ], 
       TagBox[
        StyleBox["\<\"\[Null]\"\>",
         ShowStringCharacters->False],
        StyleForm[#, ShowStringCharacters -> False]& ]},
      {"1", 
       RowBox[{"-", "7.647290149225717`"}], "1", "2", "0.3`", 
       RowBox[{"-", "0.1`"}]},
      {"2", 
       RowBox[{"-", "6.426363481334434`"}], "0.9488895307918184`", 
       "1.9625127591923106`", "1.3`", 
       RowBox[{"-", "0.12092726078531794`"}]},
      {"3", 
       RowBox[{"-", "6.285326923522202`"}], "0.7426715210080044`", 
       "1.692802641873854`", "1.037411412193135`", 
       RowBox[{"-", "0.2353846116843536`"}]},
      {"4", 
       RowBox[{"-", "6.238233992234003`"}], "0.8010844817448731`", 
       "1.8965144448710562`", "1.0504887846519861`", 
       RowBox[{"-", "0.171424995196168`"}]},
      {"5", 
       RowBox[{"-", "6.236683262802132`"}], "0.8243776234706608`", 
       "1.9375670267943657`", "1.0494761086661717`", 
       RowBox[{"-", "0.15122543960519413`"}]},
      {"6", 
       RowBox[{"-", "6.2366631289964625`"}], "0.8261499980192529`", 
       "1.934905955053722`", "1.0491291310613273`", 
       RowBox[{"-", "0.14824600441829375`"}]},
      {"7", 
       RowBox[{"-", "6.236502925017044`"}], "0.8540012772377316`", 
       "1.901905004201234`", "1.0476541972530042`", 
       RowBox[{"-", "0.10534380516338607`"}]},
      {"8", 
       RowBox[{"-", "6.2364746536677504`"}], "0.8672177986031816`", 
       "1.8903666752236097`", "1.0481136064587728`", 
       RowBox[{"-", "0.08738957356686698`"}]},
      {"9", 
       RowBox[{"-", "6.236471224583469`"}], "0.8706652415018115`", 
       "1.888617324472237`", "1.0486607227822378`", 
       RowBox[{"-", "0.0843755555544976`"}]},
      {"10", 
       RowBox[{"-", "6.2364705608617195`"}], "0.8713656497832247`", 
       "1.8888423617676358`", "1.0487841908356952`", 
       RowBox[{"-", "0.08510826142269327`"}]},
      {"11", 
       RowBox[{"-", "6.236469222501954`"}], "0.8735427827898863`", 
       "1.8890260667971315`", "1.0489196564736194`", 
       RowBox[{"-", "0.08745133581037481`"}]},
      {"12", 
       RowBox[{"-", "6.236468200116804`"}], "0.8762365172116153`", 
       "1.888542883262463`", "1.0488856270792615`", 
       RowBox[{"-", "0.08966150486013129`"}]},
      {"13", 
       RowBox[{"-", "6.23646774242475`"}], "0.8781205230113627`", 
       "1.8877457218419789`", "1.048737708249371`", 
       RowBox[{"-", "0.09074151226064016`"}]},
      {"14", 
       RowBox[{"-", "6.236467686754268`"}], "0.8783320781009248`", 
       "1.8874365901205592`", "1.0486599743337253`", 
       RowBox[{"-", "0.09064434194312797`"}]},
      {"15", 
       RowBox[{"-", "6.236467684336905`"}], "0.8782495538082183`", 
       "1.8873966860569518`", "1.0486471719497916`", 
       RowBox[{"-", "0.09051412323092219`"}]},
      {"16", 
       RowBox[{"-", "6.2364676843177635`"}], "0.8782320796482105`", 
       "1.8873995952967793`", "1.048647256326272`", 
       RowBox[{"-", "0.09050077668802063`"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"Likelihood", "THETA"}}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673080292683`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"INK: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "6.055454452393343`*^-6", ",", "0.000011429062282785275`", ",", 
     "6.350035697310988`*^-6", ",", "6.055454452393343`*^-6"}], "}"}]}],
  SequenceForm[
  "INK: ", {6.055454452393343*^-6, 0.000011429062282785275`, 
   6.350035697310988*^-6, 6.055454452393343*^-6}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367308059269*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367308123733*^9}],

Cell[BoxData["\<\"ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367308154882*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367308192855*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {
         StyleBox["\[Null]",
          ShowStringCharacters->False], 
         TagBox["\<\"THETA\"\>",
          HoldForm], 
         TagBox["\<\"SCORE\"\>",
          HoldForm]},
        {"1", "0.8782320796482105`", "2.384185791015625`*^-7"},
        {"2", "1.8873995952967793`", "1.5790149824107133`*^-7"},
        {"3", "1.048647256326272`", "3.410373378606092`*^-7"},
        {"4", 
         RowBox[{"-", "0.09050077668802063`"}], "2.980232238769531`*^-7"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxDividers->{
        "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
         "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.24]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
     "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[
     BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}]]], 
   "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "6.2364676843177635`"}]}],
  SequenceForm[
   MatrixForm[{{0.8782320796482105, 2.384185791015625*^-7}, {
    1.8873995952967793`, 1.5790149824107133`*^-7}, {1.048647256326272, 
    3.410373378606092*^-7}, {-0.09050077668802063, 2.980232238769531*^-7}}, 
    TableHeadings -> {Automatic, {"THETA", "SCORE"}}], 
   "   Likelihood = ", -6.2364676843177635`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367308236846*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367308280908*^9}],

Cell[BoxData["\<\"WALD-TEST:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673083109818`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367308343328*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"CHI \"\>",
       HoldForm], 
      TagBox["\<\"U \"\>",
       HoldForm], 
      TagBox["\<\"PROB \"\>",
       HoldForm], 
      TagBox["\<\"ALPHA \"\>",
       HoldForm]},
     {"1", "14.76968763216199`", "4", "0.005203529947902186`", "0.05`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", "ALPHA "}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730838239*^9}],

Cell[BoxData["\<\"NULLHYPOTHESE THETA = 0 ABLEHNEN\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367308412857*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673084430943`*^9}],

Cell[BoxData["\<\"BONFERRONI-KONFIDENZINTERVALLE:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367308482538*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367308513179*^9}],

Cell[BoxData["\<\"P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= \
1-ALPHA\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673085457373`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"QUANTIL Z(1-ALPHA/2U) = \"\>", "\[InvisibleSpace]", 
   "2.4977054744123746`"}],
  SequenceForm["QUANTIL Z(1-ALPHA/2U) = ", 2.4977054744123746`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673085946913`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"THETA\"\>",
       HoldForm], 
      TagBox["\<\"GRENZE\"\>",
       HoldForm], 
      TagBox["\<\"STD\"\>",
       HoldForm]},
     {"1", "0.8782320796482105`", "9.362744175548903`", "3.7485381168697`"},
     {"2", "1.8873995952967793`", "6.334375569925023`", 
      "2.536077866192485`"},
     {"3", "1.048647256326272`", "1.1394260348579095`", 
      "0.45618910897650083`"},
     {"4", 
      RowBox[{"-", "0.09050077668802063`"}], "9.543499277520471`", 
      "3.820906578172806`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730864014*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367308678813*^9}],

Cell[BoxData["\<\"Korrelation der ML-Sch\[ADoubleDot]tzer\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367308716444*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730874866*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "1.0000000000000002`", 
       RowBox[{"-", "0.7242202341336117`"}], 
       RowBox[{"-", "0.10233058600747362`"}], "0.06264961777244459`"},
      {"2", 
       RowBox[{"-", "0.7242202341336105`"}], "1.0000000000000002`", 
       RowBox[{"-", "0.046061398009393066`"}], 
       RowBox[{"-", "0.594100853548612`"}]},
      {"3", 
       RowBox[{"-", "0.1023305860074732`"}], 
       RowBox[{"-", "0.046061398009392567`"}], "0.9999999999999999`", 
       RowBox[{"-", "0.026757277215488737`"}]},
      {"4", "0.0626496177724431`", 
       RowBox[{"-", "0.5941008535486112`"}], 
       RowBox[{"-", "0.02675727721548847`"}], "1.0000000000000002`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367308783886*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730881806*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND \
EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673088650846`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367308900584*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "14.051538013625038`", 
       RowBox[{"-", "6.884860887722708`"}], 
       RowBox[{"-", "0.17498962692142372`"}], "0.8973188193481629`"},
      {"2", 
       RowBox[{"-", "6.884860887722697`"}], "6.431690943391429`", 
       RowBox[{"-", "0.05328986396204749`"}], 
       RowBox[{"-", "5.756906544051575`"}]},
      {"3", 
       RowBox[{"-", "0.174989626921423`"}], 
       RowBox[{"-", "0.053289863962046914`"}], "0.20810850314877377`", 
       RowBox[{"-", "0.046639431721274556`"}]},
      {"4", "0.8973188193481416`", 
       RowBox[{"-", "5.756906544051568`"}], 
       RowBox[{"-", "0.04663943172127409`"}], "14.599327079124222`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367308939633*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367308988408*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.17888609620340823`", ",", "0.8405489569781021`", ",", 
   "13.477259854460687`", ",", "20.7939696316473`"}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673090358133`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730910775*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX \
UND EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367309145891*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367309181789*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.2980615790557046`", "0.47483384320575733`", 
       "0.41036761223875323`", "0.17023093556568133`"},
      {"2", "0.47483384320575733`", "0.9981729882313571`", 
       "0.7370661800120878`", "0.3667763303903335`"},
      {"3", "0.41036761223875323`", "0.7370661800120878`", 
       "5.402337224657829`", "0.2826810064296586`"},
      {"4", "0.17023093556568133`", "0.3667763303903335`", 
       "0.2826810064296586`", "0.20356621232610664`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730922049*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367309266797*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "5.590149381218078`", ",", "1.1896986983306101`", ",", 
   "0.07419905906681923`", ",", "0.04809086565549533`"}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673093041687`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367309355939*^9}],

Cell[BoxData["\<\"KOMPENSIERTE LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367309402576*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673094362793`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"U =  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  Nue = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["U =  ", 4, "  Nue = ", 1],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036730947091*^9}],

Cell[BoxData["\<\"AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) \
AZENCOTT/DACUNHA-CASTELLE (A/D)\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.4603673095276213`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"LIK\"\>",
       HoldForm], 
      TagBox["\<\"AIC\"\>",
       HoldForm], 
      TagBox["\<\"SIC/RISS\"\>",
       HoldForm], 
      TagBox["\<\"A/D\"\>",
       HoldForm]},
     {
      TagBox["\<\"Kompensator\"\>",
       HoldForm], "0", "4", "0.`", "Indeterminate"},
     {
      TagBox["\<\"komp. Lik.\"\>",
       HoldForm], 
      RowBox[{"-", "6.2364676843177635`"}], 
      RowBox[{"-", "10.236467684317763`"}], 
      RowBox[{"-", "6.2364676843177635`"}], "Indeterminate"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {{"Kompensator", "komp. Lik."}, {
      "LIK", "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
    TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460367309572055*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "1", "0.8782320796482105`", "3.7485381168697`"},
      {"2", "2", "1.8873995952967793`", "2.536077866192485`"},
      {"3", "0.3`", "1.048647256326272`", "0.45618910897650083`"},
      {"4", 
       RowBox[{"-", "0.1`"}], 
       RowBox[{"-", "0.09050077668802063`"}], "3.820906578172806`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.4603673130895653`*^9}]
}, Open  ]],

Cell[BoxData["Linear"], "Input",
 CellChangeTimes->{{3.4603672747359133`*^9, 3.4603672757633257`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "scoreii", ",", "k", 
      ",", "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
    RowBox[{"BFGS", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"Y", ",", "X", ",", 
         RowBox[{"-", "9"}]}], "}"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      "\t  ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Idio", ",", 
          RowBox[{"{", "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Lik", ",", "IndividualLik", ",", "Score", ",", "Hesse"}], 
         "}"}]}], "}"}], ",", "\[IndentingNewLine]", "            ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Sing", "=", "False"}], ",", "1"}], "}"}], ",", 
        RowBox[{"KMAX", "=", "30"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EPS1", "=", ".0001"}], ",", 
          RowBox[{"EPS2", "=", ".0001"}]}], "}"}], ",", "\[IndentingNewLine]",
         "             ", 
        RowBox[{"OPTION", "=", "0"}], ",", 
        RowBox[{"PRINT", "=", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1"}], "}"}]}]}], "}"}]}], "]"}]}], ";"}], 
  "                                                                           \
     "}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113330285616*^9, 3.460113346379695*^9}, {
   3.460200648978776*^9, 3.4602006503583603`*^9}, {3.460200794874672*^9, 
   3.4602007984595947`*^9}, 3.460201903279232*^9, {3.460201941045977*^9, 
   3.4602019411313553`*^9}, {3.460279278878285*^9, 3.460279290392777*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Tiefe von data = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["Tiefe von data = ", 5],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9}],

Cell[BoxData["\<\"L\[ADoubleDot]nge der Paneldaten\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228291422*^9}],

Cell[BoxData[
 RowBox[{"{", "1", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672282958403`*^9}],

Cell[BoxData["\<\"***********************LSDE1********************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672283002863`*^9}],

Cell[BoxData["\<\"***********************MODUL:    BFGS \
(skeleton)**************\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672283046303`*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672283091707`*^9}],

Cell[BoxData["\<\"Technical Output\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228313648*^9}],

Cell[BoxData["IndividualLik"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228317638*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228321612*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"KMAX\"\>",
       HoldForm], 
      TagBox["\<\"EPS1\"\>",
       HoldForm], 
      TagBox["\<\"EPS2\"\>",
       HoldForm], 
      TagBox["\<\"K\"\>",
       HoldForm], 
      TagBox["\<\"Q\"\>",
       HoldForm], 
      TagBox["\<\"n\"\>",
       HoldForm], 
      TagBox["\<\"T\"\>",
       HoldForm], 
      TagBox["\<\"OPTION\"\>",
       HoldForm]},
     {"1", "30", "0.0001`", "0.0001`", "4", "1", "1", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"KMAX", "EPS1", "EPS2", "K", "Q", "n", "T", "OPTION"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228326379*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228371327*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"MAXSTEP\"\>",
       HoldForm], 
      TagBox["\<\"MINSTEP\"\>",
       HoldForm], 
      TagBox["\<\"BOUND\"\>",
       HoldForm], 
      TagBox["\<\"STEPREDUCE\"\>",
       HoldForm], 
      TagBox["\<\"FMAX\"\>",
       HoldForm]},
     {"1", "1", "1.`*^-10", "1.`*^-6", "4", "1000"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"MAXSTEP", "MINSTEP", "BOUND", "STEPREDUCE", "FMAX"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228424752*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672284715242`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"RESAMPLING\"\>",
       HoldForm], 
      TagBox["\<\"FDIGITS\"\>",
       HoldForm], 
      TagBox["\<\"TYP\"\>",
       HoldForm], 
      TagBox["\<\"YMAX\"\>",
       HoldForm], 
      TagBox["\<\"ANALGRAD\"\>",
       HoldForm], 
      TagBox["\<\"FACTOR\"\>",
       HoldForm], 
      TagBox["\<\"CSEED\"\>",
       HoldForm]},
     {"1", "True", "16", "1", "1.`*^8", "False", "1.`", 
      RowBox[{"-", "999"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {
      "RESAMPLING", "FDIGITS", "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}},
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228520392*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672285674753`*^9}],

Cell[BoxData["\<\"    SCALING\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228620823*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "::", "\<\"nmtx\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The first two levels of the \
one-dimensional list \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\
\\!\\({}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" cannot be \
transposed.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Transpose\\\", ButtonNote -> \\\"Transpose::nmtx\\\
\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.460113347438837*^9, 3.4601140477211742`*^9, 3.460114171488365*^9, 
   3.4601142582303123`*^9, 3.46011431981378*^9, 3.4601210026174927`*^9, 
   3.4602006082555428`*^9, 3.4602006525509787`*^9, 3.4602007997492933`*^9, {
   3.460201893745349*^9, 3.460201903902554*^9}, 3.4602019417761383`*^9, 
   3.460279294169009*^9, 3.4603672286821957`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  RowBox[{"Transpose", "[", 
   RowBox[{"{", "}"}], "]"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
    0]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228718684*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672287808523`*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672288252277`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228870615*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STARTWERT THETA0 = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "0.3`", ",", 
     RowBox[{"-", "0.1`"}]}], "}"}]}],
  SequenceForm["STARTWERT THETA0 = ", {1, 2, 0.3, -0.1}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228921979*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "2.9802322387695312`*^-8", ",", 
     "1.4901161193847656`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 2.9802322387695312`*^-8, 
   1.4901161193847656`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228970928*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "0.07098066806793213`", ",", "0.24227303266525269`", ",", 
     "3.459629237651825`", ",", "0.07762807607650757`"}], "}"}], ",", 
   RowBox[{"-", "4.0596465456025665`"}]}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672290216427`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672290751247`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["BFGS: Iteration = ", 1],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367229124764*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.708543494201313\"\>",
     -2.7085434942013134`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.7085434942013134`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367229197445*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -4.059646545602567\"\>",
     -4.0596465456025665`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-4.0596465456025665`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672292438*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     1.351103051401253\"\>",
     1.3511030514012532`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[1.3511030514012532`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367229286407*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672293379927`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.0205\"\>",
         1.0205168424683881`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.0205\"\>",
         0.020516842468388106`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0710\"\>",
         0.07098066806793213,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 2.0700\"\>",
         2.0700286117450237`,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.0700\"\>",
         0.07002861174502391,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2423\"\>",
         0.24227303266525269`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.3000\"\>",
         1.3,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3000\"\>",
         0.3,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0000\"\>",
         1.,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.4596\"\>",
         3.459629237651825,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0776\"\>",
         -0.07756173545082058,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1000\"\>",
         -0.1,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0224\"\>",
         0.02243826454917942,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0776\"\>",
         0.07762807607650757,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672293900757`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367229423893*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367229459447*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.5206885970657887`*^-8", ",", "3.0845830019489284`*^-8", ",", 
     "1.9371509552001954`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.5206885970657887`*^-8, 3.0845830019489284`*^-8, 
   1.9371509552001954`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.46036722949059*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "5.7082322185281626`*^-8"}],
  
  SequenceForm["NOISE  ", 5.7082322185281626`*^-8],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367229521635*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "0.2597996897092546`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "0.9942053506637037`"}],
  SequenceForm["*BFGSUP ", 0.2597996897092546, "  ", 0.9942053506637037],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367229564189*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.17811444686879827`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.17811444686879827`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367229606915*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367229663381*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "2"}],
  SequenceForm["BFGS: Iteration = ", 2],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367229702153*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.680387066456627\"\>",
     -2.680387066456627,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.680387066456627, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367229742654*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.708543494201313\"\>",
     -2.7085434942013134`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.7085434942013134`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367229786786*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.028156427744686\"\>",
     0.028156427744686408`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.028156427744686408`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367229818074*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672298583612`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.0195\"\>",
         1.0194705669205788`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0205\"\>",
         1.0205168424683881`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0010\"\>",
         -0.0010462755478094295`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0065\"\>",
         -0.006528309272201829,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 2.1087\"\>",
         2.1087220166475196`,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.0700\"\>",
         2.0700286117450237`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0387\"\>",
         0.03869340490249573,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0245\"\>",
         0.024467714019303876`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.2012\"\>",
         1.2011727457675212`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.3000\"\>",
         1.3,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0988\"\>",
         -0.09882725423247873,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.3711\"\>",
         -0.3711005586844224,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0644\"\>",
         -0.0643875233959597,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0776\"\>",
         -0.07756173545082058,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0132\"\>",
         0.013174212054860879`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0087\"\>",
         0.008698463439941406,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367229916397*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367229958972*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.001\"\>",
         1.0011422817949311`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.002957\"\>",
         0.002957463499827914,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.05674\"\>",
         0.056740716854041584`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0009303\"\>",
         0.000930327692583886,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.002957\"\>",
         0.002957463499827914,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.007\"\>",
         1.0074490887594834`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1471\"\>",
         0.14714191417040606`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.002338\"\>",
         0.002338218852880152,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.05674\"\>",
         0.056740716854041584`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1471\"\>",
         0.14714191417040604`,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.818\"\>",
         3.818222798683079,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.04629\"\>",
         0.0462920527028782,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.0009303\"\>",
         0.0009303276925838862,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.002338\"\>",
         0.002338218852880152,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.04629\"\>",
         0.046292052702878214`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.001\"\>",
         1.0007338258062022`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367229995448*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.51912952500668`*^-8", ",", "3.142240668308019`*^-8", ",", 
     "1.7898868706338423`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.51912952500668*^-8, 3.142240668308019*^-8, 
   1.7898868706338423`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367230028861*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "7.961326813554273`*^-9"}],
  SequenceForm["NOISE  ", 7.961326813554273*^-9],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367230074709*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "50.34712208416164`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "26.49496920745654`"}],
  SequenceForm["*BFGSUP ", 50.34712208416164, "  ", 26.49496920745654],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672301077213`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.073124293478785`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.073124293478785, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672301674557`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367230201301*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "3"}],
  SequenceForm["BFGS: Iteration = ", 3],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367230241555*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.671465018305430\"\>",
     -2.6714650183054305`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.6714650183054305`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367230271307*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.680387066456627\"\>",
     -2.680387066456627,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.680387066456627, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367230302024*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.008922048151196\"\>",
     0.00892204815119646,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.00892204815119646, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672303437138`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672303818808`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.0254\"\>",
         1.0254457029459714`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0195\"\>",
         1.0194705669205788`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0060\"\>",
         0.0059751360253925455`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0008\"\>",
         0.0008111610756077796,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 2.2018\"\>",
         2.201762326266197,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.1087\"\>",
         2.1087220166475196`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0930\"\>",
         0.09304030961867779,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0409\"\>",
         0.04089274907974925,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.1070\"\>",
         1.106973896498568,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.2012\"\>",
         1.2011727457675212`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0942\"\>",
         -0.09419884926895314,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1632\"\>",
         -0.16317503970594477`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0345\"\>",
         -0.03446896632921938,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0644\"\>",
         -0.0643875233959597,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0299\"\>",
         0.029918557066740317`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0132\"\>",
         0.013157039880752563`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672304210453`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672304592953`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.003\"\>",
         1.002725187380612,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.01326\"\>",
         0.013258978055045714`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.06939\"\>",
         0.06938532475499093,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.004082\"\>",
         0.004082416449863476,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.01326\"\>",
         0.013258978055045714`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.005\"\>",
         1.0051701073113681`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5597\"\>",
         0.559660449459648,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0003863\"\>",
         0.0003862886516066244,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.06939\"\>",
         0.06938532475499093,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5597\"\>",
         0.5596604494596479,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.346\"\>",
         2.3461097726707973`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1785\"\>",
         0.17849232747909122`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.004082\"\>",
         0.004082416449863476,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0003863\"\>",
         0.0003862886516066248,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1785\"\>",
         0.17849232747909122`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.9997\"\>",
         0.9997299754981467,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367230500682*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.528033171513634`*^-8", ",", "3.28088153342336`*^-8", ",", 
     "1.6495196469106794`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.528033171513634*^-8, 3.28088153342336*^-8, 
   1.6495196469106794`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367230542865*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.2356301071224337`*^-9"}],
  
  SequenceForm["NOISE  ", 3.2356301071224337`*^-9],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367230575721*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "45.46150967319389`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "51.08801780747821`"}],
  SequenceForm["*BFGSUP ", 45.46150967319389, "  ", 51.08801780747821],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672306368923`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.022361215698517265`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.022361215698517265`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367230670156*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367230713532*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "4"}],
  SequenceForm["BFGS: Iteration = ", 4],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367230744022*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.670618140888410\"\>",
     -2.6706181408884095`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.6706181408884095`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367230786237*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.671465018305430\"\>",
     -2.6714650183054305`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.6714650183054305`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367230827894*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000846877417021\"\>",
     0.0008468774170209414,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.0008468774170209414, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367230857975*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367230902542*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.0210\"\>",
         1.0210350072622634`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0254\"\>",
         1.0254457029459714`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0044\"\>",
         -0.004410695683707907,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0037\"\>",
         -0.003746194795821703,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 2.2204\"\>",
         2.2203967422656596`,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.2018\"\>",
         2.201762326266197,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0186\"\>",
         0.018634415999462545`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0266\"\>",
         0.026573005531248053`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.1194\"\>",
         1.1193992809351307`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.1070\"\>",
         1.106973896498568,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0124\"\>",
         0.012425384436562758`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0540\"\>",
         0.05396442110724006,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0298\"\>",
         -0.029766087870988958`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0345\"\>",
         -0.03446896632921938,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0047\"\>",
         0.004702878458230418,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0070\"\>",
         0.007047176361083984,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672309429903`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367230983807*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.004\"\>",
         1.0036357848555961`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.01453\"\>",
         0.014531183256987969`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.03116\"\>",
         0.031159515756831915`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.004803\"\>",
         0.004803048334202873,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.01453\"\>",
         0.014531183256987969`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.9291\"\>",
         0.9290619715313571,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7592\"\>",
         0.7591970651803637,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.02312\"\>",
         -0.023122967607895874`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.03116\"\>",
         0.031159515756831915`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7592\"\>",
         0.7591970651803636,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.129\"\>",
         3.129324945766157,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2279\"\>",
         0.22785977613505798`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.004803\"\>",
         0.004803048334202873,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.02312\"\>",
         -0.023122967607895874`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2279\"\>",
         0.22785977613505798`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.9926\"\>",
         0.9925833441243466,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.46036723102345*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.52146072277764`*^-8", ",", "3.3086489770794803`*^-8", ",", 
     "1.668034912549154`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.52146072277764*^-8, 3.3086489770794803`*^-8, 
   1.668034912549154*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367231065*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.0265096757343196`*^-9"}],
  
  SequenceForm["NOISE  ", 1.0265096757343196`*^-9],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367231110824*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "1361.8934299200705`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "822.7971032859999`"}],
  SequenceForm["*BFGSUP ", 1361.8934299200705`, "  ", 822.7971032859999],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367231142346*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.012407629329321579`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.012407629329321579`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367231186224*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367231229693*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["BFGS: Iteration = ", 5],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.46036723126009*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.670171869898160\"\>",
     -2.6701718698981596`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.6701718698981596`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367231309697*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.670618140888410\"\>",
     -2.6706181408884095`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.6706181408884095`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367231360751*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000446270990250\"\>",
     0.00044627099024996397`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.00044627099024996397`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672313998327`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367231430822*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.0060\"\>",
         1.0060466268609078`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0210\"\>",
         1.0210350072622634`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0150\"\>",
         -0.01498838040135548,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0081\"\>",
         -0.008056362760030281,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 2.2531\"\>",
         2.2531074638955633`,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.2204\"\>",
         2.2203967422656596`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0327\"\>",
         0.0327107216299038,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0149\"\>",
         0.014923477116298494`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.1227\"\>",
         1.1226572475270533`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.1194\"\>",
         1.1193992809351307`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0033\"\>",
         0.0032579665919225216`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0123\"\>",
         0.012331604039992764`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0226\"\>",
         -0.022550229595636948`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0298\"\>",
         -0.029766087870988958`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0072\"\>",
         0.007215858275352009,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0030\"\>",
         0.003029048442840576,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367231475987*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367231520336*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.017\"\>",
         1.0173893109105714`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1648\"\>",
         0.16482131414212095`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4419\"\>",
         0.4418813893087353,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.05011\"\>",
         0.05011133878105856,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.1648\"\>",
         0.164821314142121,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5329\"\>",
         0.532889294151118,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2398\"\>",
         0.2398305729455712,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1135\"\>",
         -0.11345451265249493`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.4419\"\>",
         0.4418813893087353,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2398\"\>",
         0.23983057294557097`,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.094\"\>",
         3.09376741307295,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1428\"\>",
         0.14277835996552177`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.05011\"\>",
         0.05011133878105856,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1135\"\>",
         -0.11345451265249493`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1428\"\>",
         0.14277835996552177`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.9737\"\>",
         0.9737092715813529,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367231558688*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4991262955381093`*^-8", ",", "3.3573917506569077`*^-8", ",", 
     "1.672889661084195`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4991262955381093`*^-8, 3.3573917506569077`*^-8, 
   1.672889661084195*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367231614162*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.9995559157721385`*^-10"}],
  SequenceForm["NOISE  ", 3.9995559157721385`*^-10],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367231649907*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "2245.8060755435295`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "1490.4403002793917`"}],
  SequenceForm["*BFGSUP ", 2245.8060755435295`, "  ", 1490.4403002793917`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672316848373`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.00449002800388307`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.00449002800388307, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672317189083`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367231749106*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "6"}],
  SequenceForm["BFGS: Iteration = ", 6],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367231780735*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.669896063186620\"\>",
     -2.66989606318662,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.66989606318662, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367231819112*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.670171869898160\"\>",
     -2.6701718698981596`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.6701718698981596`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.46036723184929*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000275806711540\"\>",
     0.0002758067115395946,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.0002758067115395946, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672318880987`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367231941324*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.9816\"\>",
         0.9815890715355129,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0060\"\>",
         1.0060466268609078`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0245\"\>",
         -0.024457555325394998`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0119\"\>",
         -0.011917088284896295`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 2.2776\"\>",
         2.277589977018285,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.2531\"\>",
         2.2531074638955633`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0245\"\>",
         0.024482513122721723`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0023\"\>",
         0.0023450121282773597`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.1226\"\>",
         1.1225953633807428`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.1227\"\>",
         1.1226572475270533`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0001\"\>",
         -0.00006188414631051955,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0059\"\>",
         -0.005933667394403835,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0196\"\>",
         -0.01957482540319601,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0226\"\>",
         -0.022550229595636948`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0030\"\>",
         0.0029754041924409374`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0014\"\>",
         -0.0014308691024780273`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367231984674*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367232020692*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.9541\"\>",
         0.9541265039186096,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4531\"\>",
         0.45307621599579584`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7483\"\>",
         0.7483214221832764,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1252\"\>",
         0.12515217318452157`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.4531\"\>",
         0.45307621599579584`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5563\"\>",
         0.5562795374831309,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4815\"\>",
         0.4815161058673971,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.05484\"\>",
         -0.05484099134677185,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.7483\"\>",
         0.7483214221832764,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4815\"\>",
         0.4815161058673969,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.616\"\>",
         3.616364593192259,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2701\"\>",
         0.2700528710553493,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.1252\"\>",
         0.12515217318452157`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.05484\"\>",
         -0.05484099134677185,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2701\"\>",
         0.2700528710553493,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.005\"\>",
         1.0047053057748694`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367232066359*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "3.393873538104124`*^-8", ",", 
     "1.6727974465202433`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 3.393873538104124*^-8, 
   1.6727974465202433`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.46036723209794*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.6191899632489446`*^-10"}],
  SequenceForm["NOISE  ", 3.6191899632489446`*^-10],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367232128635*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "7293.044445079051`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "2898.68160839828`"}],
  SequenceForm["*BFGSUP ", 7293.044445079051, "  ", 2898.68160839828],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672321719313`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.004633470414470906`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.004633470414470906, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367232201109*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367232244083*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "7"}],
  SequenceForm["BFGS: Iteration = ", 7],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.46036723229749*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.669431174707674\"\>",
     -2.6694311747076735`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.6694311747076735`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367232344439*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.669896063186620\"\>",
     -2.66989606318662,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.66989606318662, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367232387121*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000464888478946\"\>",
     0.0004648884789464347,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.0004648884789464347, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672324255447`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367232476677*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.9178\"\>",
         0.9177913850456414,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.9816\"\>",
         0.9815890715355129,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0638\"\>",
         -0.0637976864898715,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0124\"\>",
         -0.012370884418487549`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 2.3190\"\>",
         2.3190243086315663`,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.2776\"\>",
         2.277589977018285,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0414\"\>",
         0.041434331613281424`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0035\"\>",
         -0.0034698215740759115`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.1215\"\>",
         1.1214764619442998`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.1226\"\>",
         1.1225953633807428`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0011\"\>",
         -0.0011189014364429027`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0103\"\>",
         -0.010286011678890013`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0192\"\>",
         -0.01920809814380885,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0196\"\>",
         -0.01957482540319601,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0004\"\>",
         0.00036672725938715993`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0035\"\>",
         -0.0034888386726379395`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367232535718*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367232568482*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.544\"\>",
         0.5439663211100921,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5533\"\>",
         0.5533264647398533,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5578\"\>",
         0.5577540619872458,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.08254\"\>",
         0.08253541745737772,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.5533\"\>",
         0.5533264647398533,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7869\"\>",
         0.7869339909203888,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7064\"\>",
         0.7064233976851743,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.04216\"\>",
         0.04215930612972486,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.5578\"\>",
         0.5577540619872458,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7064\"\>",
         0.706423397685174,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.652\"\>",
         3.6524580435346023`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3108\"\>",
         0.31076593216690374`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.08254\"\>",
         0.08253541745737772,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.04216\"\>",
         0.04215930612972486,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3108\"\>",
         0.31076593216690374`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.03\"\>",
         1.0296583689571528`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367232600237*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "3.4556155035370086`*^-8", ",", 
     "1.671130153453797`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 3.4556155035370086`*^-8, 
   1.671130153453797*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672326429367`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.4910208764676873`*^-10"}],
  SequenceForm["NOISE  ", 3.4910208764676873`*^-10],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672326987143`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "2671.517081567149`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "1525.1024644474476`"}],
  SequenceForm["*BFGSUP ", 2671.517081567149, "  ", 1525.1024644474476`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367232742611*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.007314981349322476`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.007314981349322476, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367232785931*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367232827244*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "8"}],
  SequenceForm["BFGS: Iteration = ", 8],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367232873341*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.669130908353829\"\>",
     -2.6691309083538286`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.6691309083538286`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367232903668*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.669431174707674\"\>",
     -2.6694311747076735`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.6694311747076735`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672329469357`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000300266353845\"\>",
     0.0003002663538449468,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.0003002663538449468, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367232988578*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367233051785*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8550\"\>",
         0.8549797485549072,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.9178\"\>",
         0.9177913850456414,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0628\"\>",
         -0.06281163649073415,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0097\"\>",
         -0.009714692831039429,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 2.3442\"\>",
         2.344185065559627,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.3190\"\>",
         2.3190243086315663`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0252\"\>",
         0.02516075692806053,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0084\"\>",
         -0.00842028226422914,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.1204\"\>",
         1.120397113358327,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.1215\"\>",
         1.1214764619442998`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0011\"\>",
         -0.0010793485859728804`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0111\"\>",
         -0.011056960103515532`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0248\"\>",
         -0.024789545358080818`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0192\"\>",
         -0.01920809814380885,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0056\"\>",
         -0.005581447214271966,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0051\"\>",
         -0.005135446786880493,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367233087118*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.46036723311683*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.3294\"\>",
         0.32941499665773954`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4527\"\>",
         0.45273303295368195`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3582\"\>",
         0.35821855753560106`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.005028\"\>",
         0.00502753268206968,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.4527\"\>",
         0.45273303295368195`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.834\"\>",
         0.8340433053053824,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6622\"\>",
         0.6621875153532116,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.04547\"\>",
         0.045473740979834434`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.3582\"\>",
         0.35821855753560106`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6622\"\>",
         0.6621875153532114,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.493\"\>",
         3.4926869441224695`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2594\"\>",
         0.2594271033981407,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.005028\"\>",
         0.00502753268206968,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.04547\"\>",
         0.04547374097983444,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2594\"\>",
         0.2594271033981407,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.018\"\>",
         1.0183381620563812`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367233161871*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "3.493107953011434`*^-8", ",", 
     "1.6695217987274036`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 3.493107953011434*^-8, 
   1.6695217987274036`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367233212614*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "2.668991143883387`*^-10"}],
  
  SequenceForm["NOISE  ", 2.668991143883387*^-10],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367233259902*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "3689.669325123128`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "2278.254012389706`"}],
  SequenceForm["*BFGSUP ", 3689.669325123128, "  ", 2278.254012389706],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.46036723328992*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0060198743561320905`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0060198743561320905`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367233320537*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367233360484*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "9"}],
  SequenceForm["BFGS: Iteration = ", 9],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.46036723341045*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.669021107546062\"\>",
     -2.669021107546062,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.669021107546062, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367233458734*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.669130908353829\"\>",
     -2.6691309083538286`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.6691309083538286`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367233489585*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000109800807766\"\>",
     0.00010980080776645806`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.00010980080776645806`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672335367107`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.46036723356811*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8199\"\>",
         0.8199353241516166,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8550\"\>",
         0.8549797485549072,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0350\"\>",
         -0.03504442440329054,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0049\"\>",
         -0.004914373159408569,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 2.3489\"\>",
         2.348904296042842,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.3442\"\>",
         2.344185065559627,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0047\"\>",
         0.00471923048321473,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0069\"\>",
         -0.006854336265691929,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.1201\"\>",
         1.120094445747174,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.1204\"\>",
         1.120397113358327,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0003\"\>",
         -0.0003026676111529998,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0066\"\>",
         -0.006600257864408262,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0326\"\>",
         -0.03257741520288206,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0248\"\>",
         -0.024789545358080818`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0078\"\>",
         -0.007787869844801242,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0044\"\>",
         -0.004400670528411865,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367233610811*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367233640645*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1994\"\>",
         0.19942549384047456`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2941\"\>",
         0.29410621343228943`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1924\"\>",
         0.19243526155702498`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.09562\"\>",
         -0.09561888059216514,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.2941\"\>",
         0.29410621343228943`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6816\"\>",
         0.6815602267425489,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4758\"\>",
         0.47582589475527287`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0488\"\>",
         -0.04879691029091755,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.1924\"\>",
         0.192435261557025,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4758\"\>",
         0.4758258947552727,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.287\"\>",
         3.2874408171385063`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1421\"\>",
         0.14214478652162665`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.09562\"\>",
         -0.09561888059216513,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0488\"\>",
         -0.04879691029091756,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1421\"\>",
         0.14214478652162665`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.9602\"\>",
         0.9602462316877832,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367233679371*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "3.500140154425564`*^-8", ",", 
     "1.6690707888412088`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 3.500140154425564*^-8, 
   1.6690707888412088`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367233714942*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.4216110960964813`*^-10"}],
  SequenceForm["NOISE  ", 1.4216110960964813`*^-10],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672337611523`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "7639.781392027202`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "5677.182258875337`"}],
  SequenceForm["*BFGSUP ", 7639.781392027202, "  ", 5677.182258875337],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367233791479*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.00209785921589276`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.00209785921589276, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367233821775*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367233860876*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "10"}],
  SequenceForm["BFGS: Iteration = ", 10],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367233891858*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.669005064049269\"\>",
     -2.669005064049269,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.669005064049269, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367233922614*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.669021107546062\"\>",
     -2.669021107546062,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.669021107546062, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367233960747*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000016043496793\"\>",
     0.00001604349679329431,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.00001604349679329431, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672340026503`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367234038137*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8139\"\>",
         0.8139353210113507,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8199\"\>",
         0.8199353241516166,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0060\"\>",
         -0.006000003140265901,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0010\"\>",
         -0.0009991228580474854,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 2.3457\"\>",
         2.3457498527794853`,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.3489\"\>",
         2.348904296042842,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0032\"\>",
         -0.003154443263356492,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0024\"\>",
         -0.002383762734527215,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.1202\"\>",
         1.1202217476556569`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.1201\"\>",
         1.120094445747174,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0001\"\>",
         0.00012730190848288578`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0019\"\>",
         -0.0018768292503256916`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0374\"\>",
         -0.03739304726143527,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0326\"\>",
         -0.03257741520288206,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0048\"\>",
         -0.004815632058553214,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0027\"\>",
         -0.00268593430519104,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367234079959*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367234128154*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1794\"\>",
         0.17942712604631728`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2366\"\>",
         0.2365939159032451,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1496\"\>",
         0.1495750129630666,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1671\"\>",
         -0.1671060727761755,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.2366\"\>",
         0.2365939159032451,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5675\"\>",
         0.5675241544975766,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3803\"\>",
         0.3803129198947498,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1615\"\>",
         -0.1614761426597348,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.1496\"\>",
         0.1495750129630666,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3803\"\>",
         0.3803129198947496,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.211\"\>",
         3.2105728991442892`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.03913\"\>",
         0.03912575333956379,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.1671\"\>",
         -0.16710607277617548`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1615\"\>",
         -0.16147614265973484`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.03913\"\>",
         0.03912575333956379,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8728\"\>",
         0.872765885968674,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367234161004*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "3.495439667671152`*^-8", ",", 
     "1.6692604834670676`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 3.495439667671152*^-8, 
   1.6692604834670676`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367234191616*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "6.553912967888209`*^-11"}],
  
  SequenceForm["NOISE  ", 6.553912967888209*^-11],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672342219687`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "49224.42582766395`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "38153.76671909316`"}],
  SequenceForm["*BFGSUP ", 49224.42582766395, "  ", 38153.76671909316],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672342616034`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0006415582563599861`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0006415582563599861, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367234303581*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672343427153`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "11"}],
  SequenceForm["BFGS: Iteration = ", 11],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367234374165*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.669000688186341\"\>",
     -2.669000688186341,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.669000688186341, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367234413562*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.669005064049269\"\>",
     -2.669005064049269,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.669005064049269, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367234476803*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     4.375862928007734\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-6\"\>"]}],
     4.375862928007734*^-6,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[4.375862928007734*^-6, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367234510982*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672345415297`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8151\"\>",
         0.8150723149298893,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8139\"\>",
         0.8139353210113507,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0011\"\>",
         0.0011369939185385807`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0003\"\>",
         0.0003460347652435303,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 2.3439\"\>",
         2.343916914599519,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.3457\"\>",
         2.3457498527794853`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0018\"\>",
         -0.0018329381799665533`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0001\"\>",
         0.00008246696653921327,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.1203\"\>",
         1.120290825572024,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.1202\"\>",
         1.1202217476556569`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0001\"\>",
         0.00006907791636725397,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0001\"\>",
         -0.00011745643540400192`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0405\"\>",
         -0.040500175588047485`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0374\"\>",
         -0.03739304726143527,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0031\"\>",
         -0.0031071283266122162`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0017\"\>",
         -0.0017123222351074219`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367234574046*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367234606018*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.2304\"\>",
         0.23040935215133518`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.309\"\>",
         0.30902460616855126`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1945\"\>",
         0.19452590574295175`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.205\"\>",
         -0.20502735035566605`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.309\"\>",
         0.30902460616855126`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6501\"\>",
         0.6501192413401763,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4232\"\>",
         0.4232018314503384,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.2876\"\>",
         -0.28756531851547423`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.1945\"\>",
         0.19452590574295175`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4232\"\>",
         0.42320183145033813`,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.229\"\>",
         3.228545640852207,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.06889\"\>",
         -0.06889010018195198,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.205\"\>",
         -0.205027350355666,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.2876\"\>",
         -0.2875653185154743,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.06889\"\>",
         -0.06889010018195198,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6442\"\>",
         0.6441761785113121,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.46036723465066*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "3.492708376943348`*^-8", ",", 
     "1.66936341758374`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 3.492708376943348*^-8, 
   1.66936341758374*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367234681341*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "4.5075942978201056`*^-11"}],
  SequenceForm["NOISE  ", 4.5075942978201056`*^-11],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367234731885*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "423919.36757247784`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "180031.81296914595`"}],
  SequenceForm["*BFGSUP ", 423919.36757247784`, "  ", 180031.81296914595`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672347629757`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0007648330265717259`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0007648330265717259, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367234801208*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367234831087*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "12"}],
  SequenceForm["BFGS: Iteration = ", 12],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367234863037*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.668993128569121\"\>",
     -2.668993128569121,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.668993128569121, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367234903668*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.669000688186341\"\>",
     -2.669000688186341,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.669000688186341, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367234973568*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     7.559617219765613\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-6\"\>"]}],
     7.559617219765613*^-6,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[7.559617219765613*^-6, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672350059977`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672350487633`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8185\"\>",
         0.8184729686027328,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8151\"\>",
         0.8150723149298893,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0034\"\>",
         0.0034006536728434546`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0006\"\>",
         0.000606149435043335,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 2.3424\"\>",
         2.34235963357149,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.3439\"\>",
         2.343916914599519,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0016\"\>",
         -0.0015572810280289353`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0009\"\>",
         0.0008709096562052674,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.1204\"\>",
         1.1203525712614315`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.1203\"\>",
         1.120290825572024,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0001\"\>",
         0.00006174568940741076,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0003\"\>",
         0.00034926171106352286`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0477\"\>",
         -0.04770946310279364,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0405\"\>",
         -0.040500175588047485`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0072\"\>",
         -0.007209287514746156,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0013\"\>",
         -0.0013126730918884277`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367235081667*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367235138391*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.2375\"\>",
         0.2375345646998253,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3908\"\>",
         0.39082685925253124`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2533\"\>",
         0.25330703206364213`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.05429\"\>",
         -0.05428598598692039,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.3908\"\>",
         0.39082685925253124`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.9124\"\>",
         0.9124209113429086,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5809\"\>",
         0.5809397346486933,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1286\"\>",
         -0.12856584098464152`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.2533\"\>",
         0.25330703206364213`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5809\"\>",
         0.5809397346486931,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.318\"\>",
         3.31840250675016,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.02603\"\>",
         -0.026027759112314357`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.05429\"\>",
         -0.05428598598692036,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1286\"\>",
         -0.1285658409846416,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.02603\"\>",
         -0.026027759112314357`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.184\"\>",
         0.18402252575338424`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367235183055*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "3.49038784738107`*^-8", ",", 
     "1.6694554258308284`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 3.49038784738107*^-8, 
   1.6694554258308284`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367235214348*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "4.4330166796159785`*^-11"}],
  SequenceForm["NOISE  ", 4.4330166796159785`*^-11],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672352644053`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "189943.00581100208`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "98134.88415924256`"}],
  SequenceForm["*BFGSUP ", 189943.00581100208`, "  ", 98134.88415924256],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672353025427`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0014588436275658132`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0014588436275658132`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367235331658*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367235376857*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "13"}],
  SequenceForm["BFGS: Iteration = ", 13],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367235406887*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.668984594127900\"\>",
     -2.6689845941279,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.6689845941279, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672354712143`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.668993128569121\"\>",
     -2.668993128569121,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.668993128569121, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367235509776*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     8.534441221286220\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-6\"\>"]}],
     8.534441221286215*^-6,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[8.534441221286215*^-6, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367235540977*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367235578965*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8216\"\>",
         0.8216007361150321,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8185\"\>",
         0.8184729686027328,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0031\"\>",
         0.0031277675122993944`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0007\"\>",
         0.0007370114326477051,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 2.3438\"\>",
         2.3437702921867074`,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.3424\"\>",
         2.34235963357149,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0014\"\>",
         0.0014106586152171894`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0017\"\>",
         0.0016622740427323748`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.1203\"\>",
         1.1203368064900083`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.1204\"\>",
         1.1203525712614315`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0000\"\>",
         -0.000015764771423262028`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0008\"\>",
         0.0008182951195961999,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0580\"\>",
         -0.058017965488910486`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0477\"\>",
         -0.04770946310279364,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0103\"\>",
         -0.010308502386116847`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0007\"\>",
         -0.0006875991821289062,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367235619327*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672356684523`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.2047\"\>",
         0.2047308743045857,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3587\"\>",
         0.35869172425559276`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2442\"\>",
         0.24418985217714353`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.03933\"\>",
         0.039334629163759544`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.3587\"\>",
         0.35869172425559276`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.9569\"\>",
         0.9569404577341365,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6216\"\>",
         0.6215918661992337,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.07758\"\>",
         0.07758133011302834,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.2442\"\>",
         0.24418985217714353`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6216\"\>",
         0.6215918661992335,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.348\"\>",
         3.3482176522755474`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.07465\"\>",
         0.07465138710667438,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.03933\"\>",
         0.03933462916375957,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.07758\"\>",
         0.07758133011302826,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.07465\"\>",
         0.07465138710667438,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.08914\"\>",
         0.08913929808300554,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367235702787*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "3.492489892522555`*^-8", ",", 
     "1.6694319344908123`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 3.492489892522555*^-8, 
   1.6694319344908123`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367235738619*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "5.133213416007012`*^-11"}],
  
  SequenceForm["NOISE  ", 5.133213416007012*^-11],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367235775628*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "156751.66211713717`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "85285.5247617702`"}],
  SequenceForm["*BFGSUP ", 156751.66211713717`, "  ", 85285.5247617702],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367235814184*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0015653623404489464`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0015653623404489464`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672358678207`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367235908955*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "14"}],
  SequenceForm["BFGS: Iteration = ", 14],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672359606047`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.668978181377584\"\>",
     -2.6689781813775837`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.6689781813775837`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672359965687`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.668984594127900\"\>",
     -2.6689845941279,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.6689845941279, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367236027082*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     6.412750316098226\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-6\"\>"]}],
     6.412750316098226*^-6,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[6.412750316098226*^-6, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367236066143*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367236109383*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8221\"\>",
         0.8220560442175313,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8216\"\>",
         0.8216007361150321,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0005\"\>",
         0.000455308102499144,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0006\"\>",
         0.000601351261138916,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 2.3487\"\>",
         2.348690027250187,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.3438\"\>",
         2.3437702921867074`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0049\"\>",
         0.004919735063479479,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0018\"\>",
         0.0017825671674455254`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.1202\"\>",
         1.120232835523609,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.1203\"\>",
         1.1203368064900083`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0001\"\>",
         -0.00010397096639915903`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0009\"\>",
         0.0009292071074466384,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0679\"\>",
         -0.06789071106607812,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0580\"\>",
         -0.058017965488910486`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0099\"\>",
         -0.009872745577167637,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0001\"\>",
         -0.00009360909461975098,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367236153831*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367236184402*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1613\"\>",
         0.16128979164964508`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2516\"\>",
         0.2516491226625906,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1904\"\>",
         0.19039622257338876`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.06992\"\>",
         0.0699234691759276,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.2516\"\>",
         0.2516491226625906,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7236\"\>",
         0.7235515990174868,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5077\"\>",
         0.5076752468048636,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1863\"\>",
         0.1862611964029618,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.1904\"\>",
         0.19039622257338876`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5077\"\>",
         0.5076752468048635,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.293\"\>",
         3.29303815190989,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.133\"\>",
         0.13296495677304535`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.06992\"\>",
         0.06992346917592762,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1863\"\>",
         0.18626119640296174`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.133\"\>",
         0.13296495677304535`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1041\"\>",
         0.1041227136374445,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367236233782*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "3.499820869043748`*^-8", ",", 
     "1.6692770056778328`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 3.499820869043748*^-8, 
   1.6692770056778328`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672362743063`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "4.172725544057301`*^-11"}],
  
  SequenceForm["NOISE  ", 4.172725544057301*^-11],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672363145037`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "144597.63586820036`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "101305.56008539067`"}],
  SequenceForm["*BFGSUP ", 144597.63586820036`, "  ", 101305.56008539067`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672363656797`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0008955732502650089`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0008955732502650089, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672364167233`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367236453678*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "15"}],
  SequenceForm["BFGS: Iteration = ", 15],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367236491188*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.668976556737826\"\>",
     -2.668976556737826,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.668976556737826, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367236521257*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.668978181377584\"\>",
     -2.6689781813775837`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.6689781813775837`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367236564451*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     1.624639757835666\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-6\"\>"]}],
     1.6246397578356664`*^-6,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[1.6246397578356664`*^-6, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672366116343`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367236651183*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8203\"\>",
         0.8202728530164812,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8221\"\>",
         0.8220560442175313,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0018\"\>",
         -0.0017831912010500641`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0003\"\>",
         0.000253826379776001,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 2.3524\"\>",
         2.352392687071018,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.3487\"\>",
         2.348690027250187,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0037\"\>",
         0.003702659820831162,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0010\"\>",
         0.0010177015430091487`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.1201\"\>",
         1.120148061624049,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.1202\"\>",
         1.120232835523609,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0001\"\>",
         -0.0000847738995601938,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0006\"\>",
         0.0005518136510225051,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0704\"\>",
         -0.07041288532140424,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0679\"\>",
         -0.06789071106607812,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0025\"\>",
         -0.0025221742553261203`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0002\"\>",
         0.0002136826515197754,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.46036723669659*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.46036723672711*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1421\"\>",
         0.1421189055418818,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1815\"\>",
         0.1814902011832759,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1528\"\>",
         0.15275321812557557`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.06018\"\>",
         0.06018435398081917,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.1815\"\>",
         0.1814902011832759,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4862\"\>",
         0.4862409770952035,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3816\"\>",
         0.3816142140840163,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1692\"\>",
         0.16917971878412075`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.1528\"\>",
         0.15275321812557557`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3816\"\>",
         0.3816142140840162,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.226\"\>",
         3.226162749728632,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.125\"\>",
         0.12500776837868968`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.06018\"\>",
         0.0601843539808192,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1692\"\>",
         0.1691797187841207,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.125\"\>",
         0.12500776837868968`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1169\"\>",
         0.11688910416831019`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367236766781*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "3.5053382621273665`*^-8", ",", 
     "1.669150682723595`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 3.5053382621273665`*^-8, 
   1.669150682723595*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672368054113`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.8782185123313753`*^-11"}],
  SequenceForm["NOISE  ", 1.8782185123313753`*^-11],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367236844069*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "452610.92322803265`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "366319.50503376586`"}],
  SequenceForm["*BFGSUP ", 452610.92322803265`, "  ", 366319.50503376586`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367236899289*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0002139555320667897`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0002139555320667897, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672369332323`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367236979985*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "16"}],
  SequenceForm["BFGS: Iteration = ", 16],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367237010562*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.668976415044177\"\>",
     -2.6689764150441766`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.6689764150441766`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.46036723704077*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.668976556737826\"\>",
     -2.668976556737826,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.668976556737826, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367237071416*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     1.416936492582010\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-7\"\>"]}],
     1.4169364925820105`*^-7,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[1.4169364925820105`*^-7, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367237109312*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367237140737*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8193\"\>",
         0.8192738355309624,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8203\"\>",
         0.8202728530164812,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0010\"\>",
         -0.0009990174855188333,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0.00003376603126525879,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 2.3533\"\>",
         2.3532857985753437`,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.3524\"\>",
         2.352392687071018,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0009\"\>",
         0.0008931115043260262,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0002\"\>",
         0.00024274956405413717`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.1201\"\>",
         1.1201269551236517`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.1201\"\>",
         1.120148061624049,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0000\"\>",
         -0.00002110650039712574,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0001\"\>",
         0.0001380037617534692,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0698\"\>",
         -0.0697954544359623,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0704\"\>",
         -0.07041288532140424,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0006\"\>",
         0.0006174308854419491,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0001\"\>",
         0.00012150406837463379`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367237181041*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367237212152*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1404\"\>",
         0.1404361230203418,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.164\"\>",
         0.1640492784935718,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1427\"\>",
         0.14266090313509944`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0495\"\>",
         0.049496954220003476`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.164\"\>",
         0.1640492784935718,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3787\"\>",
         0.37865359465747905`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.321\"\>",
         0.3210404536564775,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1218\"\>",
         0.12184978505198692`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.1427\"\>",
         0.14266090313509944`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.321\"\>",
         0.3210404536564774,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.192\"\>",
         3.192123553098528,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.09908\"\>",
         0.09907851138359647,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.0495\"\>",
         0.049496954220003504`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1218\"\>",
         0.12184978505198686`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.09908\"\>",
         0.09907851138359645,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.104\"\>",
         0.10400864039164084`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367237265237*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "3.5066691019763704`*^-8", ",", 
     "1.6691192315871294`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 3.5066691019763704`*^-8, 
   1.6691192315871294`*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672372957*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.917454689565587`*^-12"}],
  
  SequenceForm["NOISE  ", 3.917454689565587*^-12],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367237338827*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "4.407110995298337`*^6", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "3.9188460169353704`*^6"}],
  SequenceForm["*BFGSUP ", 4.407110995298337*^6, "  ", 3.9188460169353704`*^6],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672373721724`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "0.000010339900485988026`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.000010339900485988026`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672374025517`*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367237448103*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367237500381*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "17"}],
  SequenceForm["BFGS: Iteration = ", 17],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367237542758*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.668976411322180\"\>",
     -2.6689764113221806`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.6689764113221806`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672375905857`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.668976415044177\"\>",
     -2.6689764150441766`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.6689764150441766`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367237630372*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     3.721996044703246\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-9\"\>"]}],
     3.7219960447032463`*^-9,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[3.7219960447032463`*^-9, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367237664669*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672376987457`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8191\"\>",
         0.8191010619714398,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8193\"\>",
         0.8192738355309624,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0002\"\>",
         -0.00017277355952255875`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 2.3533\"\>",
         2.353312895164712,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.3533\"\>",
         2.3532857985753437`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0.000027096589368396537`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0.000011726986389716364`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.1201\"\>",
         1.1201267013329037`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.1201\"\>",
         1.1201269551236517`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0695\"\>",
         -0.06951096009358226,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0698\"\>",
         -0.0697954544359623,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0003\"\>",
         0.00028449434238003843`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0.00002014636993408203,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367237762766*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367237793705*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1428\"\>",
         0.14277801885995667`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.172\"\>",
         0.17195013247807373`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1468\"\>",
         0.1468371657148889,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.05098\"\>",
         0.050978301491343386`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.172\"\>",
         0.17195013247807373`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3829\"\>",
         0.3829402026132086,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3216\"\>",
         0.32162381715722604`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1095\"\>",
         0.1094597323240134,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.1468\"\>",
         0.1468371657148889,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3216\"\>",
         0.3216238171572259,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.191\"\>",
         3.1914160362655535`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.09122\"\>",
         0.09122150163507331,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.05098\"\>",
         0.050978301491343414`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1095\"\>",
         0.10945973232401335`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.09122\"\>",
         0.0912215016350733,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.09143\"\>",
         0.09142972080755357,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.46036723783742*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "3.5067094790409684`*^-8", ",", 
     "1.669118853409445`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 3.5067094790409684`*^-8, 
   1.669118853409445*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672378704023`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.341717642179849`*^-13"}],
  
  SequenceForm["NOISE  ", 3.341717642179849*^-13],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367237915477*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "1.5190544575338355`*^8", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "1.427580381842188`*^8"}],
  SequenceForm["*BFGSUP ", 1.5190544575338355`*^8, "  ", 1.427580381842188*^8],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367237961913*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "2.0099158640100847`*^-6", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 2.0099158640100847`*^-6, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367237992024*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238033031*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238079405*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "18"}],
  SequenceForm["BFGS: Iteration = ", 18],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238110113*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.668976411293272\"\>",
     -2.6689764112932717`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-2.6689764112932717`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238150898*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -2.668976411322180\"\>",
     -2.6689764113221806`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-2.6689764113221806`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672381975603`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     2.890887529360953\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-11\"\>"]}],
     2.8908875293609526`*^-11,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[2.8908875293609526`*^-11, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238228857*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238260957*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.8191\"\>",
         0.8190891944657427,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8191\"\>",
         0.8191010619714398,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0000\"\>",
         -0.000011867505697127457`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False]},
       {
        InterpretationBox["\<\" 2.0000\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 2.3533\"\>",
         2.353304500531094,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.3533\"\>",
         2.353312895164712,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False]},
       {
        InterpretationBox["\<\" 3.0000\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 1.1201\"\>",
         1.1201270832337165`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.1201\"\>",
         1.1201267013329037`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False]},
       {
        InterpretationBox["\<\" 4.0000\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\"-0.0695\"\>",
         -0.06948579008703917,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0695\"\>",
         -0.06951096009358226,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0.000025170006543084655`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.46036723830262*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238344124*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1407\"\>",
         0.14067156602043213`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.173\"\>",
         0.17298696311571857`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.148\"\>",
         0.14802613085604607`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.05547\"\>",
         0.05546766272888075,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.173\"\>",
         0.17298696311571857`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3931\"\>",
         0.3931089390513637,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3274\"\>",
         0.32739791358482084`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1171\"\>",
         0.11713855567658472`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.148\"\>",
         0.14802613085604607`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3274\"\>",
         0.3273979135848207,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.195\"\>",
         3.194531874421331,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.09458\"\>",
         0.09457610336678274,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.05547\"\>",
         0.055467662728880776`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1171\"\>",
         0.11713855567658468`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.09458\"\>",
         0.09457610336678274,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.09102\"\>",
         0.0910183627141722,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238386032*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "1.4901161193847656`*^-8", ",", "3.506696970062098`*^-8", ",", 
     "1.669119422486002`*^-8", ",", "1.4901161193847656`*^-8"}], "}"}]}],
  SequenceForm[
  "Score: INC: ", {1.4901161193847656`*^-8, 3.506696970062098*^-8, 
   1.669119422486002*^-8, 1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672384329844`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.7741633862341356`*^-14"}],
  SequenceForm["NOISE  ", 3.7741633862341356`*^-14],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238462785*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "1.8955376114726013`*^10", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "1.790537649552598`*^10"}],
  SequenceForm[
  "*BFGSUP ", 1.8955376114726013`*^10, "  ", 1.790537649552598*^10],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238502742*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "2.2332398489242832`*^-7", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 2.2332398489242832`*^-7, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238551289*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238581129*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238611412*^9}],

Cell[BoxData["\<\"ReturnCode = 3\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238651256*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS:  ENDE DER ITERATION  \"\>", "\[InvisibleSpace]", "18", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "30"}],
  SequenceForm["BFGS:  ENDE DER ITERATION  ", 18, "  ", 30],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.46036723868336*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {"1", 
       RowBox[{"-", "1.4901161193847656`*^-7"}]},
      {"2", 
       RowBox[{"-", "2.532806305428772`*^-7"}]},
      {"3", 
       RowBox[{"-", "1.330309874378647`*^-7"}]},
      {"4", 
       RowBox[{"-", "2.9802322387695312`*^-8"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}]]]], "Print",\

 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.46036723871443*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238744461*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1346\"\>",
         0.13458902939888467`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1632\"\>",
         0.16324570183085518`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1432\"\>",
         0.1432235052439544,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.05534\"\>",
         0.05534397905385702,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 2\"\>",
         2,
         Editable->False], 
        InterpretationBox["\<\" 0.1632\"\>",
         0.16324570183085518`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3779\"\>",
         0.3778928926572291,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3201\"\>",
         0.32011056384225256`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1176\"\>",
         0.11764416011185605`,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 3\"\>",
         3,
         Editable->False], 
        InterpretationBox["\<\" 0.1432\"\>",
         0.1432235052439544,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3201\"\>",
         0.3201105638422524,
         AutoDelete->True], 
        InterpretationBox["\<\" 3.191\"\>",
         3.1911643400591005`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.09522\"\>",
         0.09521763016068542,
         AutoDelete->True]},
       {
        InterpretationBox["\<\" 4\"\>",
         4,
         Editable->False], 
        InterpretationBox["\<\" 0.05534\"\>",
         0.055343979053857045`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1176\"\>",
         0.11764416011185601`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.09522\"\>",
         0.09521763016068542,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0923\"\>",
         0.09230298177058989,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238796082*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"Likelihood\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm], 
       TagBox[
        StyleBox["\<\"\[Null]\"\>",
         ShowStringCharacters->False],
        StyleForm[#, ShowStringCharacters -> False]& ], 
       TagBox[
        StyleBox["\<\"\[Null]\"\>",
         ShowStringCharacters->False],
        StyleForm[#, ShowStringCharacters -> False]& ], 
       TagBox[
        StyleBox["\<\"\[Null]\"\>",
         ShowStringCharacters->False],
        StyleForm[#, ShowStringCharacters -> False]& ]},
      {"1", 
       RowBox[{"-", "4.0596465456025665`"}], "1", "2", "0.3`", 
       RowBox[{"-", "0.1`"}]},
      {"2", 
       RowBox[{"-", "2.7085434942013134`"}], "1.0205168424683881`", 
       "2.0700286117450237`", "1.3`", 
       RowBox[{"-", "0.07756173545082058`"}]},
      {"3", 
       RowBox[{"-", "2.680387066456627`"}], "1.0194705669205788`", 
       "2.1087220166475196`", "1.2011727457675212`", 
       RowBox[{"-", "0.0643875233959597`"}]},
      {"4", 
       RowBox[{"-", "2.6714650183054305`"}], "1.0254457029459714`", 
       "2.201762326266197`", "1.106973896498568`", 
       RowBox[{"-", "0.03446896632921938`"}]},
      {"5", 
       RowBox[{"-", "2.6706181408884095`"}], "1.0210350072622634`", 
       "2.2203967422656596`", "1.1193992809351307`", 
       RowBox[{"-", "0.029766087870988958`"}]},
      {"6", 
       RowBox[{"-", "2.6701718698981596`"}], "1.0060466268609078`", 
       "2.2531074638955633`", "1.1226572475270533`", 
       RowBox[{"-", "0.022550229595636948`"}]},
      {"7", 
       RowBox[{"-", "2.66989606318662`"}], "0.9815890715355129`", 
       "2.277589977018285`", "1.1225953633807428`", 
       RowBox[{"-", "0.01957482540319601`"}]},
      {"8", 
       RowBox[{"-", "2.6694311747076735`"}], "0.9177913850456414`", 
       "2.3190243086315663`", "1.1214764619442998`", 
       RowBox[{"-", "0.01920809814380885`"}]},
      {"9", 
       RowBox[{"-", "2.6691309083538286`"}], "0.8549797485549072`", 
       "2.344185065559627`", "1.120397113358327`", 
       RowBox[{"-", "0.024789545358080818`"}]},
      {"10", 
       RowBox[{"-", "2.669021107546062`"}], "0.8199353241516166`", 
       "2.348904296042842`", "1.120094445747174`", 
       RowBox[{"-", "0.03257741520288206`"}]},
      {"11", 
       RowBox[{"-", "2.669005064049269`"}], "0.8139353210113507`", 
       "2.3457498527794853`", "1.1202217476556569`", 
       RowBox[{"-", "0.03739304726143527`"}]},
      {"12", 
       RowBox[{"-", "2.669000688186341`"}], "0.8150723149298893`", 
       "2.343916914599519`", "1.120290825572024`", 
       RowBox[{"-", "0.040500175588047485`"}]},
      {"13", 
       RowBox[{"-", "2.668993128569121`"}], "0.8184729686027328`", 
       "2.34235963357149`", "1.1203525712614315`", 
       RowBox[{"-", "0.04770946310279364`"}]},
      {"14", 
       RowBox[{"-", "2.6689845941279`"}], "0.8216007361150321`", 
       "2.3437702921867074`", "1.1203368064900083`", 
       RowBox[{"-", "0.058017965488910486`"}]},
      {"15", 
       RowBox[{"-", "2.6689781813775837`"}], "0.8220560442175313`", 
       "2.348690027250187`", "1.120232835523609`", 
       RowBox[{"-", "0.06789071106607812`"}]},
      {"16", 
       RowBox[{"-", "2.668976556737826`"}], "0.8202728530164812`", 
       "2.352392687071018`", "1.120148061624049`", 
       RowBox[{"-", "0.07041288532140424`"}]},
      {"17", 
       RowBox[{"-", "2.6689764150441766`"}], "0.8192738355309624`", 
       "2.3532857985753437`", "1.1201269551236517`", 
       RowBox[{"-", "0.0697954544359623`"}]},
      {"18", 
       RowBox[{"-", "2.6689764113221806`"}], "0.8191010619714398`", 
       "2.353312895164712`", "1.1201267013329037`", 
       RowBox[{"-", "0.06951096009358226`"}]},
      {"19", 
       RowBox[{"-", "2.6689764112932717`"}], "0.8190891944657427`", 
       "2.353304500531094`", "1.1201270832337165`", 
       RowBox[{"-", "0.06948579008703917`"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"Likelihood", "THETA"}}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238830955*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"INK: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
    "6.055454452393343`*^-6", ",", "0.000014250328215578304`", ",", 
     "6.782878533413977`*^-6", ",", "6.055454452393343`*^-6"}], "}"}]}],
  SequenceForm[
  "INK: ", {6.055454452393343*^-6, 0.000014250328215578304`, 
   6.782878533413977*^-6, 6.055454452393343*^-6}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238858801*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238896294*^9}],

Cell[BoxData["\<\"ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238924209*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238967022*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {
         StyleBox["\[Null]",
          ShowStringCharacters->False], 
         TagBox["\<\"THETA\"\>",
          HoldForm], 
         TagBox["\<\"SCORE\"\>",
          HoldForm]},
        {"1", "0.8190891944657427`", 
         RowBox[{"-", "1.4901161193847656`*^-7"}]},
        {"2", "2.353304500531094`", 
         RowBox[{"-", "2.532806305428772`*^-7"}]},
        {"3", "1.1201270832337165`", 
         RowBox[{"-", "1.330309874378647`*^-7"}]},
        {"4", 
         RowBox[{"-", "0.06948579008703917`"}], 
         RowBox[{"-", "2.9802322387695312`*^-8"}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxDividers->{
        "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
         "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.24]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
     "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[
     BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}]]], 
   "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "2.6689764112932717`"}]}],
  SequenceForm[
   MatrixForm[{{0.8190891944657427, -1.4901161193847656`*^-7}, {
    2.353304500531094, -2.532806305428772*^-7}, {
    1.1201270832337165`, -1.330309874378647*^-7}, {-0.06948579008703917, \
-2.9802322387695312`*^-8}}, TableHeadings -> {Automatic, {"THETA", "SCORE"}}],
    "   Likelihood = ", -2.6689764112932717`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367238996797*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367239036974*^9}],

Cell[BoxData["\<\"WALD-TEST:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672390843973`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367239131762*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"CHI \"\>",
       HoldForm], 
      TagBox["\<\"U \"\>",
       HoldForm], 
      TagBox["\<\"PROB \"\>",
       HoldForm], 
      TagBox["\<\"ALPHA \"\>",
       HoldForm]},
     {"1", "7.925222393182364`", "4", "0.09435612008972993`", "0.05`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", "ALPHA "}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367239161849*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672392060213`*^9}],

Cell[BoxData["\<\"BONFERRONI-KONFIDENZINTERVALLE:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.46036723925211*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367239294066*^9}],

Cell[BoxData["\<\"P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= \
1-ALPHA\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367239325536*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"QUANTIL Z(1-ALPHA/2U) = \"\>", "\[InvisibleSpace]", 
   "2.4977054744123746`"}],
  SequenceForm["QUANTIL Z(1-ALPHA/2U) = ", 2.4977054744123746`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367239364078*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"THETA\"\>",
       HoldForm], 
      TagBox["\<\"GRENZE\"\>",
       HoldForm], 
      TagBox["\<\"STD\"\>",
       HoldForm]},
     {"1", "0.8190891944657427`", "10.70868977209689`", 
      "4.287410938479959`"},
     {"2", "2.353304500531094`", "6.95234558121056`", "2.7834929508036614`"},
     {"3", "1.1201270832337165`", "1.549013042130173`", "0.6201744192816022`"},
     {"4", 
      RowBox[{"-", "0.06948579008703917`"}], "10.763528951591892`", 
      "4.309366761557099`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672394033337`*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672394325447`*^9}],

Cell[BoxData["\<\"Korrelation der ML-Sch\[ADoubleDot]tzer\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367239461907*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367239501874*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "1.0000000000000002`", 
       RowBox[{"-", "0.6317115457589797`"}], 
       RowBox[{"-", "0.017376318330759574`"}], "0.012256305496250447`"},
      {"2", 
       RowBox[{"-", "0.6317115457589788`"}], "0.9999999999999998`", 
       RowBox[{"-", "0.17564264036968621`"}], 
       RowBox[{"-", "0.45988673826540843`"}]},
      {"3", 
       RowBox[{"-", "0.01737631833075902`"}], 
       RowBox[{"-", "0.1756426403696877`"}], "0.9999999999999998`", 
       "0.003356469677410826`"},
      {"4", "0.012256305496249679`", 
       RowBox[{"-", "0.4598867382654076`"}], "0.0033564696774097146`", 
       "0.9999999999999998`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672395417337`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367239583498*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND \
EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672396146584`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367239646565*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "18.381892555397606`", 
       RowBox[{"-", "7.538831768054883`"}], 
       RowBox[{"-", "0.0462026328495633`"}], "0.22644782135879105`"},
      {"2", 
       RowBox[{"-", "7.538831768054872`"}], "7.747833007173674`", 
       RowBox[{"-", "0.303203305420058`"}], 
       RowBox[{"-", "5.516383736555152`"}]},
      {"3", 
       RowBox[{"-", "0.04620263284956183`"}], 
       RowBox[{"-", "0.30320330542006063`"}], "0.3846163103312725`", 
       "0.008970363341325234`"},
      {"4", "0.22644782135877684`", 
       RowBox[{"-", "5.5163837365551425`"}], "0.008970363341322264`", 
       "18.570641885613117`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.46036723968368*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367239720045*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.3457518353180903`", ",", "2.4243737097133002`", ",", 
   "18.286138902039824`", ",", "24.028719311444508`"}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672397518263`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367239815413*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX \
UND EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367239850872*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367239882086*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3", "4"},
      {"1", "0.11391823688564956`", "0.1455938642962563`", 
       "0.12748529076190915`", "0.04179777435764497`"},
      {"2", "0.1455938642962563`", "0.35630852135373986`", 
       "0.2959534328037994`", "0.10392264958215854`"},
      {"3", "0.12748529076190915`", "0.2959534328037994`", 
       "2.846634054484029`", "0.08498298578480246`"},
      {"4", "0.04179777435764497`", "0.10392264958215854`", 
       "0.08498298578480246`", "0.08416778916104112`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.4603672399147367`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367239959489*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2.8922478432544083`", ",", "0.4124776621663074`", ",", 
   "0.05468623011982315`", ",", "0.04161686634392185`"}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367240008203*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367240053997*^9}],

Cell[BoxData["\<\"KOMPENSIERTE LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367240094577*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367240138109*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"U =  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  Nue = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["U =  ", 4, "  Nue = ", 1],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367240171139*^9}],

Cell[BoxData["\<\"AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) \
AZENCOTT/DACUNHA-CASTELLE (A/D)\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367240211128*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"LIK\"\>",
       HoldForm], 
      TagBox["\<\"AIC\"\>",
       HoldForm], 
      TagBox["\<\"SIC/RISS\"\>",
       HoldForm], 
      TagBox["\<\"A/D\"\>",
       HoldForm]},
     {
      TagBox["\<\"Kompensator\"\>",
       HoldForm], "0", "4", "0.`", "Indeterminate"},
     {
      TagBox["\<\"komp. Lik.\"\>",
       HoldForm], 
      RowBox[{"-", "2.6689764112932717`"}], 
      RowBox[{"-", "6.668976411293272`"}], 
      RowBox[{"-", "2.6689764112932717`"}], "Indeterminate"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {{"Kompensator", "komp. Lik."}, {
      "LIK", "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
    TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367240252404*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "1", 
       RowBox[{"-", "0.865965508173665`"}], "3.050549548012696`"},
      {"2", "2", "2.103411641228928`", "2.3156426184441834`"},
      {"3", "0.3`", "1.0544327714014827`", "0.5352224778266954`"},
      {"4", 
       RowBox[{"-", "0.1`"}], 
       RowBox[{"-", "0.06613363566911691`"}], "3.771125279391055`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.460113389973647*^9, 3.460114056100081*^9, 
  3.460114179071628*^9, 3.4601142697179193`*^9, 3.460114343759589*^9, 
  3.460121016537031*^9, 3.4602008503444023`*^9, 3.460201923221129*^9, 
  3.460201965915328*^9, 3.4602793122704687`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Smoothing", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"mueetay", ",", "sigmaetay"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"mueeta", ",", "sigmaeta"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"mueY", ",", "sigmaY"}], "}"}]}], "}"}], "=", 
    RowBox[{"NormalCorrelation", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Y", ",", "X"}], "}"}], ",", "Theta", ",", 
      RowBox[{"{", 
       RowBox[{"Idio", ",", 
        RowBox[{"{", "}"}]}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.460202052412237*^9, 3.460202059962798*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{"s", "\[IndentingNewLine]", "m"}], "Input",
 CellChangeTimes->{{3.460202156885976*^9, 3.4602021599702053`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.6080511980958591`", ",", "0.5241604378706732`", ",", 
   "0.861991341553105`", ",", "0.7188311026524463`"}], "}"}]], "Output",
 CellChangeTimes->{{3.46020214051667*^9, 3.460202160706416*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "0.3466585542170436`"}], ",", 
   RowBox[{"-", "1.1416458763259956`"}], ",", 
   RowBox[{"-", "2.610080427218736`"}], ",", 
   RowBox[{"-", "1.821947345030123`"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.46020214051667*^9, 3.460202160710425*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"stdetay", "=", 
  RowBox[{
   RowBox[{"Map", "[", 
    RowBox[{"VecDiag", ",", "sigmaetay"}], "]"}], "//", "Sqrt"}]}]], "Input",
 CellChangeTimes->{3.4602021474628687`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
   "0.6080511980958591`", ",", "0.5241604378706732`", ",", 
    "0.861991341553105`", ",", "0.7188311026524463`"}], "}"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.460202148217552*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"i", "=", "1"}], ";", " ", 
  RowBox[{"z", "=", "1.96"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m", "=", 
   RowBox[{"mueetay", "[", 
    RowBox[{"[", "i", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"s", "=", 
    RowBox[{"stdetay", "[", 
     RowBox[{"[", "i", "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"KI", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ETA", "[", 
      RowBox[{"[", "i", "]"}], "]"}], ",", "m", ",", 
     RowBox[{"m", "+", 
      RowBox[{"z", " ", "s"}]}], ",", 
     RowBox[{"m", "-", 
      RowBox[{"z", " ", "s"}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"n", ",", "P"}], "}"}], "=", 
   RowBox[{"mueetay", "//", "Dimensions"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sel", "=", 
   RowBox[{"Range", "[", 
    RowBox[{"1", ",", "J1", ",", "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"t", "=", 
    RowBox[{"P", "//", "Range"}]}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"pts", "=", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"PointSize", "[", ".015", "]"}], ",", 
       RowBox[{"Map", "[", 
        RowBox[{"Point", ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"t", ",", 
            RowBox[{"Y", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], "}"}], "//", "Transpose"}]}], 
        "]"}]}], "}"}], "//", "Flatten"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{"plot1", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"KI", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "sel"}], "]"}], "]"}], "//", "Transpose"}], "//", 
    RowBox[{
     RowBox[{"AddTimeAxis", "[", 
      RowBox[{"#", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "4", ",", "1"}], "}"}]}], "]"}], "&"}]}], ",", 
   RowBox[{"color", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "2", ",", "2"}], "}"}]}], ",", 
   RowBox[{"dicke", "\[Rule]", 
    RowBox[{".005", 
     RowBox[{"{", 
      RowBox[{"1.5", ",", "1", ",", "1", ",", "1"}], "}"}]}]}], ",", 
   RowBox[{"PlotLabel", "->", "\"\<True and smoothed trajectory\>\""}], ",", 
   "\[IndentingNewLine]", "            ", 
   RowBox[{"GridLines", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"t", ",", "None"}], "}"}]}], ",", 
   RowBox[{"Epilog", "\[Rule]", "pts"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.460202128398244*^9, 3.46020212884766*^9}, {
  3.460202229095125*^9, 3.460202338937739*^9}, {3.460202426491424*^9, 
  3.460202437876296*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {RGBColor[1, 0, 0], PointSize[0.0075], Thickness[0.0075], Dashing[{}], {},
      LineBox[{{1., -0.5209211781380665}, {2., -0.9295408453324674}, {
      3., -1.6418553289176625`}, {4., -2.1868161753951463`}}]}}, {{}, {}, 
    {RGBColor[0, 0, 1], PointSize[0.005], Thickness[0.005], Dashing[{}], {}, 
     LineBox[{{1., -0.3466585542170436}, {2., -1.1416458763259956`}, {
      3., -2.610080427218736}, {4., -1.821947345030123}}]}}, {{}, {}, 
    {RGBColor[0., 0.980407, 0.6039], PointSize[0.005], Thickness[0.005], 
     Dashing[{}], {}, 
     LineBox[{{1., 0.8451217940508401}, {2., -0.11429141809947607`}, {
      3., -0.9205773977746501}, {4., -0.41303838383132807`}}]}}, {{}, {}, 
    {RGBColor[0., 0.980407, 0.6039], PointSize[0.005], Thickness[0.005], 
     Dashing[{}], {}, 
     LineBox[{{1., -1.5384389024849274`}, {2., -2.169000334552515}, {
      3., -4.2995834566628215`}, {4., -3.230856306228918}}]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{1., -2.},
  DisplayFunction->Identity,
  Epilog->{
    PointSize[0.015], 
    PointBox[{1, 0.06552476067601987}], 
    PointBox[{2, -1.2137241384580495`}], 
    PointBox[{3, -2.659857992147833}], 
    PointBox[{4, -2.8608705618946257`}]},
  Frame->True,
  GridLines->{{1, 2, 3, 4}, None},
  PlotLabel->FormBox["\"True and smoothed trajectory\"", TraditionalForm],
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.460202099673654*^9, 3.460202128989832*^9}, {
   3.460202254468831*^9, 3.460202303865058*^9}, 3.4602023390660458`*^9, 
   3.4602024386657963`*^9}]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["idiographisches Modell, nichtlinear,P=2", "Section",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460112339653429*^9, 3.460112348475265*^9}, {
  3.460262521364668*^9, 3.4602625343677998`*^9}, {3.4607747985379753`*^9, 
  3.4607748144156227`*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"<<", "Kronecker.m"}]], "Input",
 CellChangeTimes->{{3.46026403353458*^9, 3.4602640402033443`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Set", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Correlation\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Options[Correlation]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/Set\\\", ButtonNote -> \
\\\"Set::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4602640404221287`*^9, 3.460279177814375*^9, 
  3.460363882363975*^9, 3.4610354059872303`*^9, 3.461054579277351*^9, 
  3.4610557127299137`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDelayed", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(KroneckerProduct\\), \\\"MT\\\
\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(KroneckerProduct[\\(\\(a_, b_\
\\)\\)]\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/SetDelayed\\\", ButtonNote -> \
\\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4602640404221287`*^9, 3.460279177814375*^9, 
  3.460363882363975*^9, 3.4610354059872303`*^9, 3.461054579277351*^9, 
  3.461055712768239*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDelayed", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Correlation\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Correlation[y_]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/SetDelayed\\\", ButtonNote -> \
\\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4602640404221287`*^9, 3.460279177814375*^9, 
  3.460363882363975*^9, 3.4610354059872303`*^9, 3.461054579277351*^9, 
  3.4610557127925463`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDelayed", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Correlation\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Correlation[\\(\\(x_, y_, \\(\
\\(scatter_ : 0\\)\\), opts___\\)\\)]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/SetDelayed\\\", ButtonNote -> \
\\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4602640404221287`*^9, 3.460279177814375*^9, 
  3.460363882363975*^9, 3.4610354059872303`*^9, 3.461054579277351*^9, 
  3.4610557128191*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Further output of \\\\\\\"\\\
\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(SetDelayed :: \\\"write\\\
\"\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" will be \
suppressed during this calculation.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/stop\\\", \
ButtonNote -> \\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4602640404221287`*^9, 3.460279177814375*^9, 
  3.460363882363975*^9, 3.4610354059872303`*^9, 3.461054579277351*^9, 
  3.4610557128405533`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"<<", "Kalman.exakt.impl.m"}]], "Input",
 CellChangeTimes->{{3.460263837588685*^9, 3.460263853906254*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"newpkg\"\>"}], 
  RowBox[{
  ":", " "}], \
"\<\"\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"NumericalMath`GaussianQuadrature`\\\
\"\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is now \
available as the \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"Numerical Differential \
Equation Analysis Package\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\". See the Compatibility \
Guide for updating information.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, \
ButtonData:>\\\"paclet:Compatibility/Tutorials/NumericalMath/\
GaussianQuadrature\\\", ButtonNote -> \\\"General::newpkg\\\"]\\)\"\>"}]], \
"Message", "MSG",
 CellChangeTimes->{3.460263854361351*^9, 3.4602640433774548`*^9, 
  3.460279180358728*^9, 3.460363884441977*^9, 3.461035407495064*^9, 
  3.46105458257034*^9, 3.461055715095333*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "::", "\<\"wrsym\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Symbol \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(RandomMultinomial\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/Clear\\\", ButtonNote -> \
\\\"Clear::wrsym\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.460263854361351*^9, 3.4602640433774548`*^9, 
  3.460279180358728*^9, 3.460363884441977*^9, 3.461035407495064*^9, 
  3.46105458257034*^9, 3.461055715135721*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDelayed", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(RandomMultinomial\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(RandomMultinomial[\\(\\(xij_, \
pij_, n_\\)\\)]\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/SetDelayed\\\", ButtonNote -> \
\\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.460263854361351*^9, 3.4602640433774548`*^9, 
  3.460279180358728*^9, 3.460363884441977*^9, 3.461035407495064*^9, 
  3.46105458257034*^9, 3.461055715159596*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "::", "\<\"wrsym\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Symbol \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(RandomNumbers\\), \\\"MT\\\"]\
\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is Protected.\\\\\\\"\\\", \\\"MT\
\\\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\
\", ButtonFrame->None, ButtonData:>\\\"paclet:ref/Clear\\\", ButtonNote -> \\\
\"Clear::wrsym\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.460263854361351*^9, 3.4602640433774548`*^9, 
  3.460279180358728*^9, 3.460363884441977*^9, 3.461035407495064*^9, 
  3.46105458257034*^9, 3.461055715184902*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDelayed", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(RandomNumbers\\), \\\"MT\\\"]\
\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \\\"MT\\\"]\\)\
\[NoBreak]\\!\\(\\*StyleBox[\\!\\(RandomNumbers[\\(\\(\\(\\({x1_, x2_, \
dx_}\\)\\), density_, n_\\)\\)]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/SetDelayed\\\", ButtonNote -> \
\\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.460263854361351*^9, 3.4602640433774548`*^9, 
  3.460279180358728*^9, 3.460363884441977*^9, 3.461035407495064*^9, 
  3.46105458257034*^9, 3.461055715207054*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["EDM/  h=eta-eta^3", "Subsection",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460945699645706*^9, 3.460945725740242*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", "Logistic"}]], "Input",
 CellChangeTimes->{{3.460434794971136*^9, 3.4604347955208197`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox["\<\"Logistic[x_]:= Module[{xx=Exp[-x]}, 1/(1+xx)]\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.4610557192752132`*^9},
 CellTags->"Info3461062918-2707977"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "Logistic", "]"}], "=", 
      RowBox[{"{", 
       RowBox[{"Listable", ",", "Protected"}], "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"Logistic", "[", "x_", "]"}], ":=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Hermann`Kronecker`Private`xx", "=", 
             RowBox[{"Exp", "[", 
              RowBox[{"-", "x"}], "]"}]}], "}"}], ",", 
           FractionBox["1", 
            RowBox[{"1", "+", "Hermann`Kronecker`Private`xx"}]]}], "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[Hermann`Kronecker`Logistic],
  Editable->False]], "Print",
 CellChangeTimes->{3.4610557192911654`*^9},
 CellTags->"Info3461062918-2707977"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Heaviside", "[", 
  RowBox[{"{", 
   RowBox[{"0", ",", "0"}], "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Logistic", "[", 
    RowBox[{"100", 
     RowBox[{"{", " ", 
      RowBox[{"x", ",", 
       RowBox[{"10", " ", "x"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.460280327728023*^9, 3.460280341674404*^9}, {
  3.460434466158127*^9, 3.460434495620612*^9}, {3.4604345344447107`*^9, 
  3.4604345363154173`*^9}, {3.4604347450454597`*^9, 3.460434759093851*^9}, {
  3.460434831060215*^9, 3.4604349201005907`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["1", "2"], ",", 
   FractionBox["1", "2"]}], "}"}]], "Output",
 CellChangeTimes->{
  3.460434496327834*^9, 3.460434537579938*^9, 3.460434571430604*^9, 
   3.460434760012538*^9, 3.4604348407942944`*^9, {3.460434872905922*^9, 
   3.460434920637085*^9}, 3.460460119454465*^9, 3.4608928017521887`*^9, 
   3.461055719846891*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJw9zn0803kAB/BVr5Ruh0QhNFIk4ZLrtvb7fZFOx6vkMXk4K6F0N2KX1ykp
zzuPKeo8pVIbaXmah2b7egp1YiZP60jOhiXT6HCMM/e6fV6vz+vzev/30TsX
7Oy/HoPBuK1WtlkV53JS6EJ48ITaedCcjB8adC9hhAuhghbnZzvdbPxyxyed
I3uF8GMYOPrhcRletz42rfWtAEYxPm+/ONCKR8t2rnONEUCVlJuzfjrD+DuW
2bsWjAUwJcQtyrxsDv+xVgPN543CEHOpKDloK+Feo/rVcb1RuF69jpHHsyF8
7lb+cq1+BHKp4wmuS48JdX8/qeoyGYZPZ5rX/ThIOhIW8IXT18SH0phbNap+
+4gqKVsqSWp8+MG69JFbnA2xpGJX0cT5AdjpH9i2tNGLKMTY317c2A+3HnwQ
ONaUTIwx9E2Mde+D2n6pAUeXCom4k5TIr2m9MD/L0TA9n0NkU6ihWXM9UEIw
6E5y7yV65uQH7jreA69/IdPHHaaJ0pvap8IK30Kf7B3FF3AKSMGF7O9aMW/h
vAO7cWCLLnLUUUNvp083PJAfRcD5H0KEllmKwbU8yDMiMRdLHRCqtpqkUZ0H
z+BcoxLbzyEmGzL420O7oKM3k3w4/lekc0K5KaiDC3ffV44UudxCQrkpTznG
XHindsZpMJ6GbGAx3yVIOqBpXW+AHakB0e9xJGWkvYHdB6IvlRYPIFbiidFc
k3aY6E7fMTIrQXwVYy/SXr2GFvoFz05jsOj13bpTZQGvICaOpmjPMEBzkZrQ
ug1tcNbwjKdXMoqyTjvPtRS0wEDtg3v709xR/uXJq13IS6h04/Dt3qIQdCPW
Y+yypAl67BkW3x2LR82fNDmr0hrh4NaIf1qv3kc9rcw45V4N8HgtvcH2ERON
42fvc1Gph+/v4ihz7DcoaQJrPEZlw83W9jr9IaNolc4oxmjmBaw22/ygWGMJ
xTqz+i5418ArIxZsDcdt4Gx8BqPoJRNafH+DXEg1BiX3ROazRyrgsS1pvOT3
1mC+2KYCLS+Fmh15rBfKHiAxwvKSqlMJfEA63FO7PwTg7guCaQgN2swx2eqP
40B1UyaFaPwQKpCFC0q0XJDHTZI8PJAN4/9Q+4gjl4N2zcnFdoV0GNwT0bVb
vwWIkr5R/zMqHOYGS8N/UekDSGWM0540CugJY2qPT/0FNBElBtUwHej8kOek
GC8C+imsTfb7c8AzUy08VvAJZJErzeN2PAJR3yK0fiAGOduTfPx/pwPV4YJ8
MlsMCjhnfzu2kwHKbRtOmEyIgbNF7ruMjjKgtexqbjEvBm4JmyTRaZXA7+Lm
aHepGFi96yTY6VWDlhbcPoUVMTA2uxfzVUUtoFNdLhWuWi2G1N5pWwew19LJ
Q6te7jVSv9PLAYoOluUzq6ZkzpuaVNYDNWFU5OKqg6C3i5K0AZgP9Xosr9p3
oj58+lgTGMIIz6+s2nXbnlxeajO4Fbe3VeaQaRHWeeYluMntn5Q5+U1pZNfp
VvB8W/KCzPTiK1On6tqAAaVbKnNzAtGXi3sNXly3XZF5ybrNqnOiHcRWi9Zs
ueSi31HeCVIzpWv24R+y887kAdLcypoLqkCkk1MPGFn5z68zaAKtoT6AWcs0
mCUrnxwN4sv9UxnBcdx0UG7BjP+pScl7uV2ILK+TqSNyrxcoGJ31FMjNet51
PEhzXG7viIUcuyKR3A5PRxN8Qz7JbVB1+5lZzZTcy/U23bKf//tfYVGyOA==

     "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQBGIQPW1z0uzeFc/2F+nvNr/MJ8Zw727YmnXlz/YbZ3D9
cTu9gOHfubey1mrP9vetyH/SE9TKKHegpf/4laf7d0S3sWQJZTPZbZRmDGl+
un/vFFH+KfqBzFNMZ8n/1Hq639N2RZx6uCfL650SdvMuPdk/e1f91UXrnFhn
HBKtfqH4ZH91xcOF3P4m7B8v83+tOfBo/6K57l0n/4tz7/m2bNtFnQf7ncIP
6JSLRgsVp33dd/3wrf0L+jMar3lYSkXNnpcu73F1f8qRbtEFlp8Viy70rt6n
dWH/jaNvdmcuUNe8Vfim+qLt0f3CFw8KMLD+MEhsm7Ru5dGt++8Gz5R6s9vZ
Ys2MVwZfrDfvv3D6aO3SMA3LH6ucNttt2rD/lk5KXwoLn5XC/Kf5y22X71+3
xXypz5Vr1tsPTy2x0Vq0/1Xofa7n6nts5l7o/rRId9b+DWW9jFdjFtqekXzz
+wzbhP1iup+zX2S22r3qNhS9U1++f5HgnRDr4Cx72y3Ngar9JfaH4ox/mZ16
by9py7euU32C/eplaVv+/39vr9S7m91Le7Z9wbT//0H8aXlbDFrFF9szgMEH
+wX7ErtcpdfB+aHt7J+a+rfA+f+uaYhOubYPzg8RVp1zqe8InG/6J1jp3Kbz
CPO22dcGBl6F87/k8fs9yboF5z/9nBrw5tN9OD/YZne0X98jOJ/pKZtGYtRT
OH/3+oseWZIv4PyYqp+z3Ve+gvO9Vz9pjy94C+erbJu8Vn/HO4T7DzhdBvkb
xgcAHTMm+g==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.460434496327834*^9, 3.460434537579938*^9, 3.460434571430604*^9, 
   3.460434760012538*^9, 3.4604348407942944`*^9, {3.460434872905922*^9, 
   3.460434920637085*^9}, 3.460460119454465*^9, 3.4608928017521887`*^9, 
   3.461055719957403*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Plus", "@@", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Heaviside", "[", 
       RowBox[{"x", "-", "#"}], "]"}], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{"c1", ",", "c2"}], "}"}]}], "]"}]}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"x", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"x1", ",", "x2"}], "}"}]}], ",", 
    RowBox[{"c1", "->", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "2"}]}], "}"}]}], ",", 
    RowBox[{"c2", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.4602804139401493`*^9, 3.460280447538992*^9}, {
  3.460280544317827*^9, 3.460280657628171*^9}, {3.460434506601823*^9, 
  3.4604345076725397`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     FractionBox["1", "2"], " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"Sign", "[", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "x1"}], "]"}]}], ")"}]}], "+", 
    RowBox[{
     FractionBox["1", "2"], " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"Sign", "[", 
        RowBox[{"1", "+", "x1"}], "]"}]}], ")"}]}]}], ",", 
   RowBox[{
    RowBox[{
     FractionBox["1", "2"], " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"Sign", "[", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "x2"}], "]"}]}], ")"}]}], "+", 
    RowBox[{
     FractionBox["1", "2"], " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"Sign", "[", 
        RowBox[{"2", "+", "x2"}], "]"}]}], ")"}]}]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.460280411758966*^9, 3.4602804482063417`*^9}, {
   3.46028057425738*^9, 3.460280658292327*^9}, 3.46028563184229*^9, 
   3.4602857219474*^9, 3.460285983590343*^9, 3.460286266378318*^9, 
   3.460286301805153*^9, 3.460363891030834*^9, 3.460377024341406*^9, 
   3.460434509256716*^9, 3.460434571668792*^9, 3.460460119542832*^9, 
   3.460892801867489*^9, 3.4610557201428823`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Heaviside", "[", 
     RowBox[{"x", "+", "1"}], "]"}], "+", 
    RowBox[{"Heaviside", "[", 
     RowBox[{"x", "-", "1"}], "]"}], "-", "1"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
   RowBox[{"Axes", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.460280204140476*^9, 3.460280237625312*^9}, {
  3.460280316434142*^9, 3.4602803948226748`*^9}, {3.460281179896861*^9, 
  3.460281180607788*^9}, {3.460281264433981*^9, 3.460281466138386*^9}, {
  3.4604345209580584`*^9, 3.4604345275791397`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAGIQvV+g6N7//+wHGMDgw36L7ULyxzkR/A2xm+P7hNng
/GeySe82/GWG8/XlvMNNuJng/A9HrjDUKzHA+W/3Ts/frfBnP4wvV/RropXz
Dzi/xn6mAZ/2Nzj/Fo/F+YdCX+D8o8eu263n/gznb2goX1fD8gnOXxbrnva4
4SOcP8dKXM7r7wc4f5L486sbKhF8vpe50vpv3kP5wDA4rPVjzbd3cP73Oc+v
aDEi+A8CEvvUxN7A+Rt3hDDKObyA8y+temS56859OP/Kk7dO9iEX4PwFmk/5
n86fCOe/8uLOdrl+zh7G/zzH/JX1tXtwvsrffTOljj2H8/fyM/dNO/MCzg9T
cm8SuvwSzu9wP5/F9eA1nK8YJRzf9uwNnL8rJzyY6e1bOD+ofrZ73ed3cP7r
ifetf/18D+fbOjU/TCr/AOV/sG/dLbb0xEcE/6zJqgy9nI9wvug6W50pzxD8
pQtSNsff/gTnm07uttK+8BnOF2DNsdZ7/BXOf1XmY2P47TucX3VrRmfp1d9w
/gFt1nsnmBkcYPxTznO38QszwfmHpH9v+fqPGc4vbXi91F2EDc6fdULvkDIX
O5wPTe9wPgDcCfWB
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.460280319796722*^9, 3.460280354786551*^9, {3.460280389749917*^9, 
   3.460280394994143*^9}, 3.4602811810928717`*^9, 3.460281274494234*^9, {
   3.460281308314047*^9, 3.460281466274333*^9}, 3.460285631915004*^9, 
   3.4602857220189037`*^9, 3.460285983666174*^9, 3.460286266453809*^9, 
   3.460286301892166*^9, 3.460363891107939*^9, 3.460377024417347*^9, 
   3.4604345292437963`*^9, 3.4604345717561197`*^9, 3.46046011964497*^9, 
   3.460892801969101*^9, 3.461055720246285*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["th"], "Input",
 CellChangeTimes->{{3.460722238195915*^9, 3.460722238249185*^9}}],

Cell[BoxData["th"], "Output",
 CellChangeTimes->{3.460722238820682*^9, 3.460892802067227*^9, 
  3.461055720383634*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "Idio", "]"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"Idio", "[", 
   RowBox[{"th_", ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "beta", ",", "gamma", ",", "sigma", ",", "\[IndentingNewLine]", 
      "             ", "sigmazeta", ",", "lambdaeta", ",", "taueta", ",", 
      "sigmaepsilon"}], "}"}], ",", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"beta", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
        "           ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"th", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", "0"}], "}"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"gamma", "=", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], "//", "Spalte"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"sigmazeta", "=", "I2"}], ";", "\[IndentingNewLine]", 
     RowBox[{"lambdaeta", "=", "I2"}], ";", "\[IndentingNewLine]", 
     RowBox[{"taueta", "=", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], "//", "Spalte"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"sigmaepsilon", "=", 
      RowBox[{
       RowBox[{"10", "^", 
        RowBox[{"-", "1"}]}], " ", "I2"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"lambdaeta", ",", "taueta", ",", "sigmaepsilon"}], "}"}]}], 
      "}"}]}]}], "\[IndentingNewLine]", "]"}]}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460112411326638*^9, 3.460112486848282*^9}, {
   3.460112574501026*^9, 3.460112833350883*^9}, 3.460113258604714*^9, {
   3.4601981935531387`*^9, 3.4601982253887444`*^9}, {3.46019833150395*^9, 
   3.460198339518457*^9}, {3.460198463453682*^9, 3.460198495668239*^9}, {
   3.4602012679397707`*^9, 3.4602012745935698`*^9}, {3.460437742137166*^9, 
   3.4604377442837257`*^9}, {3.460459421523945*^9, 3.460459423450386*^9}, {
   3.460774832338387*^9, 3.460774867352644*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "IdioNonlin", "]"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"IdioNonlin", "[", 
   RowBox[{"th_", ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "beta", ",", "gamma", ",", "sigma", ",", "\[IndentingNewLine]", 
      "             ", "sigmazeta", ",", "lambdaeta", ",", "taueta", ",", 
      "sigmaepsilon", ",", "x", ",", "theta", ",", "h", ",", "dh"}], "}"}], 
    ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"beta", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
        "           ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"th", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", "0"}], "}"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"gamma", "=", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], "//", "Spalte"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"sigmazeta", "=", "I2"}], ";", "\[IndentingNewLine]", 
     RowBox[{"c1", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"c2", "=", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"c3", "=", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"h", "[", 
         RowBox[{"eta_", ",", "x_", ",", "theta_"}], "]"}], ":=", 
        RowBox[{
         RowBox[{"Plus", "@@", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Logistic", "[", 
              RowBox[{"100", 
               RowBox[{"(", 
                RowBox[{"eta", "-", "#"}], ")"}]}], "]"}], "&"}], ",", 
            RowBox[{"{", 
             RowBox[{"c1", ",", "c2"}], "}"}]}], "]"}]}], "-", "1"}]}], ";"}],
       "*)"}], "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"h", "[", 
         RowBox[{"eta_", ",", "x_", ",", "theta_"}], "]"}], ":=", 
        RowBox[{
         RowBox[{"Plus", "@@", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Heaviside", "[", 
              RowBox[{"(", 
               RowBox[{"eta", "-", "#"}], ")"}], "]"}], "&"}], ",", 
            RowBox[{"{", 
             RowBox[{"c1", ",", "c2", ",", "c3"}], "}"}]}], "]"}]}], "-", 
         "1"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"h", "[", 
       RowBox[{"eta_", ",", "x_", ",", "theta_"}], "]"}], ":=", 
      RowBox[{"eta", "-", " ", 
       RowBox[{"eta", "^", "3"}]}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"P", ",", "Q"}], "}"}], "=", 
      RowBox[{"gamma", "//", "Dimensions"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Off", "[", 
      RowBox[{"Part", "::", "\"\<partd\>\""}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"eta", "//", "Clear"}], ";", "\[IndentingNewLine]", 
     RowBox[{"etai", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"eta", "[", 
         RowBox[{"[", "i", "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "P"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"hilf", "=", 
      RowBox[{"Outer", "[", 
       RowBox[{"D", ",", 
        RowBox[{"h", "[", 
         RowBox[{"etai", ",", "x", ",", "theta"}], "]"}], ",", "etai"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"dh", "[", 
       RowBox[{"eta_", ",", "x_", ",", "theta_"}], "]"}], "=", "hilf"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"sigmaepsilon", "=", 
      RowBox[{
       RowBox[{"10", "^", 
        RowBox[{"-", "1"}]}], " ", "I2"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"h", ",", "dh", ",", "sigmaepsilon"}], "}"}]}], "}"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460112411326638*^9, 3.460112486848282*^9}, {
   3.460112574501026*^9, 3.460112833350883*^9}, 3.460113258604714*^9, {
   3.4601981935531387`*^9, 3.4601982253887444`*^9}, {3.46019833150395*^9, 
   3.460198339518457*^9}, {3.460198463453682*^9, 3.460198495668239*^9}, {
   3.4602012679397707`*^9, 3.4602012745935698`*^9}, {3.460262544333317*^9, 
   3.460262672020108*^9}, {3.4602627586317263`*^9, 3.46026276001101*^9}, {
   3.4602704141975107`*^9, 3.46027041438337*^9}, {3.460280467176902*^9, 
   3.460280473085874*^9}, {3.4602806924891443`*^9, 3.460280711976782*^9}, {
   3.46028116644274*^9, 3.460281167729628*^9}, {3.460281474946793*^9, 
   3.460281508316875*^9}, {3.4602815479174967`*^9, 3.4602815484137983`*^9}, {
   3.4602816507807617`*^9, 3.460281676993616*^9}, {3.460284307808282*^9, 
   3.460284309899661*^9}, {3.4602847275090322`*^9, 3.460284736183663*^9}, {
   3.4602856192308903`*^9, 3.460285624220776*^9}, {3.460285710934456*^9, 
   3.460285717823205*^9}, {3.4602859764427147`*^9, 3.460285978161388*^9}, {
   3.460286261013752*^9, 3.460286261455785*^9}, {3.4602862948772097`*^9, 
   3.46028629819168*^9}, 3.4603642740349617`*^9, 3.4603644544831877`*^9, 
   3.460365456780478*^9, 3.4603665095654716`*^9, {3.460366607243189*^9, 
   3.4603666125853157`*^9}, {3.4603697272002287`*^9, 3.460369730933084*^9}, {
   3.46037151872565*^9, 3.460371519963439*^9}, {3.460373536249193*^9, 
   3.46037353630791*^9}, {3.460377010128886*^9, 3.4603770349211197`*^9}, {
   3.460377168908317*^9, 3.460377169368896*^9}, 3.46037765815534*^9, 
   3.460431475811249*^9, {3.4604319304909678`*^9, 3.4604319341933823`*^9}, {
   3.460432429495256*^9, 3.460432430269183*^9}, {3.4604331102297277`*^9, 
   3.4604331102918997`*^9}, {3.460433492904319*^9, 3.460433500341628*^9}, {
   3.4604343556223097`*^9, 3.460434355679142*^9}, {3.460434545548963*^9, 
   3.460434546745728*^9}, {3.46043493786023*^9, 3.460434967965836*^9}, {
   3.460435089839349*^9, 3.460435118610239*^9}, {3.460437529942061*^9, 
   3.4604375424215612`*^9}, 3.460438912806677*^9, 3.460439035722678*^9, {
   3.4604393410536213`*^9, 3.460439342272788*^9}, 3.460439840453356*^9, {
   3.460440333630175*^9, 3.460440355270155*^9}, {3.4604590838600483`*^9, 
   3.4604590936409283`*^9}, {3.46045943423339*^9, 3.460459435215295*^9}, {
   3.460460115325142*^9, 3.460460115390798*^9}, {3.460721605284321*^9, 
   3.4607216861135473`*^9}, {3.4607225022010937`*^9, 
   3.4607225180985603`*^9}, {3.46072257741747*^9, 3.4607225784771767`*^9}, {
   3.460774880999907*^9, 3.460774925044929*^9}, 3.460775623252143*^9, 
   3.460794302540344*^9, {3.460795102192762*^9, 3.460795103996147*^9}, {
   3.460800859470233*^9, 3.4608008604100513`*^9}, {3.460801991135057*^9, 
   3.460801991431308*^9}, {3.460861292725114*^9, 3.460861293844521*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData["hilf"], "Input",
 CellChangeTimes->{{3.460721820620864*^9, 3.460721821402771*^9}}],

Cell[BoxData["hilf"], "Output",
 CellChangeTimes->{3.460721821538653*^9, 3.460722522060307*^9, 
  3.4607749068155117`*^9, 3.4607749384464817`*^9, 3.46077565699079*^9, 
  3.460892802232217*^9, 3.461055720879394*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"h", "//", "Clear"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"h", ",", "dh", ",", "sigmaepsilon"}], "}"}]}], "}"}], "=", 
    RowBox[{"IdioNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
      RowBox[{"{", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{"beta", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"gamma", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"sigmazeta", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"sigmaepsilon", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"h", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x", ",", "0"}], "}"}], ",", "0", ",", "theta"}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"dh", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", ",", "0"}], "}"}], ",", "0", ",", "theta"}], "]"}]}], "Input",\

 PageWidth->Infinity,
 CellChangeTimes->{{3.46011249354161*^9, 3.460112502635364*^9}, {
   3.460112738246236*^9, 3.460112740427596*^9}, {3.4601985014479733`*^9, 
   3.4601985021073637`*^9}, {3.460262678368519*^9, 3.460262744386445*^9}, {
   3.460270452868237*^9, 3.460270456266705*^9}, {3.46028153495817*^9, 
   3.4602816223627872`*^9}, {3.460284322897622*^9, 3.4602843302074947`*^9}, {
   3.460721841938987*^9, 3.460721842608491*^9}, {3.46072253843577*^9, 
   3.460722560234561*^9}, 3.460722615455822*^9, {3.460775645385498*^9, 
   3.4607756501937037`*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2"},
      {"1", "0", "0"},
      {"2", "1", "0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, 
   3.460721705060134*^9, 3.460721843511634*^9, 3.460722529695512*^9, {
   3.460722561253811*^9, 3.460722582850761*^9}, 3.460722618209428*^9, {
   3.4607749132488937`*^9, 3.4607749356495037`*^9}, {3.4607756287664843`*^9, 
   3.460775652105815*^9}, 3.4607943087026*^9, 3.460795108382183*^9, 
   3.4608008712161503`*^9, 3.460801994583243*^9, 3.460861298027657*^9, {
   3.460892802307872*^9, 3.4608928156860647`*^9}, 3.461055721166134*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0"},
      {"2", "0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, 
   3.460721705060134*^9, 3.460721843511634*^9, 3.460722529695512*^9, {
   3.460722561253811*^9, 3.460722582850761*^9}, 3.460722618209428*^9, {
   3.4607749132488937`*^9, 3.4607749356495037`*^9}, {3.4607756287664843`*^9, 
   3.460775652105815*^9}, 3.4607943087026*^9, 3.460795108382183*^9, 
   3.4608008712161503`*^9, 3.460801994583243*^9, 3.460861298027657*^9, {
   3.460892802307872*^9, 3.4608928156860647`*^9}, 3.461055721218376*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2"},
      {"1", "1", "0"},
      {"2", "0", "1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, 
   3.460721705060134*^9, 3.460721843511634*^9, 3.460722529695512*^9, {
   3.460722561253811*^9, 3.460722582850761*^9}, 3.460722618209428*^9, {
   3.4607749132488937`*^9, 3.4607749356495037`*^9}, {3.4607756287664843`*^9, 
   3.460775652105815*^9}, 3.4607943087026*^9, 3.460795108382183*^9, 
   3.4608008712161503`*^9, 3.460801994583243*^9, 3.460861298027657*^9, {
   3.460892802307872*^9, 3.4608928156860647`*^9}, 3.461055721271923*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2"},
      {"1", 
       FractionBox["1", "10"], "0"},
      {"2", "0", 
       FractionBox["1", "10"]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, 
   3.460721705060134*^9, 3.460721843511634*^9, 3.460722529695512*^9, {
   3.460722561253811*^9, 3.460722582850761*^9}, 3.460722618209428*^9, {
   3.4607749132488937`*^9, 3.4607749356495037`*^9}, {3.4607756287664843`*^9, 
   3.460775652105815*^9}, 3.4607943087026*^9, 3.460795108382183*^9, 
   3.4608008712161503`*^9, 3.460801994583243*^9, 3.460861298027657*^9, {
   3.460892802307872*^9, 3.4608928156860647`*^9}, 3.461055721316979*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwtlnk4FOgDx8fMMG6SqyZy5c7RziSU99XlaBcrm3aFTFtrlwoxqZVsW46t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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, 
   3.460721705060134*^9, 3.460721843511634*^9, 3.460722529695512*^9, {
   3.460722561253811*^9, 3.460722582850761*^9}, 3.460722618209428*^9, {
   3.4607749132488937`*^9, 3.4607749356495037`*^9}, {3.4607756287664843`*^9, 
   3.460775652105815*^9}, 3.4607943087026*^9, 3.460795108382183*^9, 
   3.4608008712161503`*^9, 3.460801994583243*^9, 3.460861298027657*^9, {
   3.460892802307872*^9, 3.4608928156860647`*^9}, 3.461055721353531*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"1", "-", 
      RowBox[{"3", " ", 
       SuperscriptBox["x", "2"]}]}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, 
   3.460721705060134*^9, 3.460721843511634*^9, 3.460722529695512*^9, {
   3.460722561253811*^9, 3.460722582850761*^9}, 3.460722618209428*^9, {
   3.4607749132488937`*^9, 3.4607749356495037`*^9}, {3.4607756287664843`*^9, 
   3.460775652105815*^9}, 3.4607943087026*^9, 3.460795108382183*^9, 
   3.4608008712161503`*^9, 3.460801994583243*^9, 3.460861298027657*^9, {
   3.460892802307872*^9, 3.4608928156860647`*^9}, 3.461055721383665*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Simulation/dt=1", "Subsection",
 PageWidth->Infinity,
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Theta", "=", 
  RowBox[{"{", ".5", "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", "50"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"q", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"X", "=", 
   RowBox[{"Shape", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"n", ",", "1"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460112861196432*^9, 3.460112900249464*^9}, {
   3.460112950538982*^9, 3.4601129539374437`*^9}, {3.460113005467535*^9, 
   3.460113006401746*^9}, {3.460113958542322*^9, 3.460113959287684*^9}, 
   3.4601141435117283`*^9, {3.46011422532432*^9, 3.460114228762265*^9}, {
   3.460114299482638*^9, 3.460114299662619*^9}, {3.460120919663384*^9, 
   3.460120925946155*^9}, {3.460370026377693*^9, 3.460370026423751*^9}, {
   3.460370337087948*^9, 3.460370337140321*^9}, {3.460371593295773*^9, 
   3.460371593877831*^9}, {3.460377254178602*^9, 3.4603772542338552`*^9}, 
   3.460427451561919*^9, 3.4604329049294033`*^9, 3.460433078433264*^9, 
   3.460437042733672*^9, 3.460444571968473*^9, 3.460460037897266*^9, 
   3.460460803716981*^9, {3.460774983456369*^9, 3.460775008455426*^9}, {
   3.4608020132258797`*^9, 3.460802035769421*^9}},
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", "0.5`", "}"}]], "Output",
 CellChangeTimes->{
  3.45982787174109*^9, {3.460112887861902*^9, 3.460112900786964*^9}, 
   3.460112954913162*^9, {3.460113000282473*^9, 3.460113007967648*^9}, 
   3.460113265712655*^9, 3.460113964238937*^9, 3.460114146876112*^9, 
   3.4601142349213667`*^9, 3.460114304518387*^9, 3.460120929697301*^9, {
   3.460126878115456*^9, 3.460126894622835*^9}, 3.4601274604024973`*^9, 
   3.460197817926371*^9, 3.460198252562779*^9, 3.460198349161854*^9, 
   3.460198506587408*^9, 3.460199526323365*^9, 3.460199563520813*^9, 
   3.460199653793846*^9, 3.4602004848983727`*^9, 3.4602006007365503`*^9, 
   3.460201290106146*^9, 3.460201878664384*^9, 3.460254150649612*^9, 
   3.4602704732126837`*^9, 3.460279153501918*^9, 3.460279212991139*^9, 
   3.4602816948847113`*^9, {3.460284336364369*^9, 3.460284358322968*^9}, 
   3.460284752117095*^9, 3.460285736075243*^9, 3.46028598941461*^9, 
   3.460286271965789*^9, 3.4602863067892523`*^9, 3.4603638961194057`*^9, 
   3.460366621961207*^9, 3.460369741827793*^9, 3.4603700297393913`*^9, 
   3.460370341259691*^9, 3.460371529118987*^9, 3.4603715972424173`*^9, 
   3.46037354416546*^9, 3.460377043299438*^9, 3.460377177822056*^9, 
   3.460377257847652*^9, 3.46037766509881*^9, 3.460427455891576*^9, {
   3.4604329057405024`*^9, 3.460432914614367*^9}, 3.4604330817497673`*^9, 
   3.460433119701372*^9, 3.46043457776158*^9, 3.460434977961318*^9, 
   3.460437046144434*^9, 3.460437552873603*^9, 3.460437900974538*^9, 
   3.460439351382359*^9, 3.46044036674789*^9, 3.46044457492516*^9, 
   3.460444772196126*^9, 3.4604449403037977`*^9, 3.4604449975762653`*^9, 
   3.4604591002378387`*^9, 3.460460040416348*^9, 3.460460125733479*^9, 
   3.4604608064131107`*^9, 3.460721885700042*^9, 3.4607226257606907`*^9, {
   3.460774945392398*^9, 3.460774955052388*^9}, {3.460774987146434*^9, 
   3.460775011536562*^9}, 3.460775669381913*^9, 3.460794312885345*^9, 
   3.460795114625*^9, {3.4608020014812107`*^9, 3.4608020361412907`*^9}, 
   3.4608613046036253`*^9, 3.460892845962228*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SeedRandom", "[", "12345689999999", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Y", ",", "X", ",", "ETA"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"ZETA", ",", "EPSILON"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"h", ",", "dh", ",", "sigmaepsilon"}], "}"}]}], "}"}]}], 
    "}"}], "=", "\[IndentingNewLine]", 
   RowBox[{"LISRELsimulNonlin", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", ",", "\"\<Gauss[]\>\"", ",", "X"}], "}"}], ",", "Theta", 
     ",", 
     RowBox[{"{", 
      RowBox[{"IdioNonlin", ",", 
       RowBox[{"{", "}"}]}], "}"}]}], "]"}]}], ";"}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601129177677603`*^9, 3.46011292950504*^9}, {
  3.4601129714155407`*^9, 3.460112981316517*^9}, {3.460198511433001*^9, 
  3.4601985124151077`*^9}, {3.460262802763719*^9, 3.460262821284783*^9}, {
  3.4604447675941477`*^9, 3.460444768681939*^9}, {3.4604449364164333`*^9, 
  3.4604449370413017`*^9}, {3.4604449897999277`*^9, 3.4604449936057873`*^9}, {
  3.460721880513426*^9, 3.460721881301012*^9}},
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[{"beta", "\[IndentingNewLine]", "gamma", "\[IndentingNewLine]", \
"sigmazeta", "\[IndentingNewLine]", "h"}], "Input",
 CellChangeTimes->{{3.4601269097587757`*^9, 3.460126910241324*^9}, {
  3.46026300740036*^9, 3.4602630224003677`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.5`", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.460126911291768*^9, {3.460127448010219*^9, 3.460127463752602*^9}, 
   3.46019781849335*^9, 3.460198255524288*^9, 3.460198352058052*^9, 
   3.4601985156112556`*^9, 3.4601995266377697`*^9, 3.460199577399457*^9, 
   3.46019965430007*^9, 3.460200566230009*^9, 3.460200601139563*^9, 
   3.460201879055964*^9, 3.460254153231098*^9, {3.46026300470542*^9, 
   3.4602630225053473`*^9}, 3.460270473521778*^9, 3.4602791537878532`*^9, 
   3.460279213318447*^9, 3.460281700761509*^9, {3.460284339881637*^9, 
   3.460284358605403*^9}, 3.460284752501553*^9, 3.460285736426825*^9, 
   3.460285989707677*^9, 3.460286272224893*^9, 3.460286307114214*^9, 
   3.4603638964211063`*^9, 3.460366622238628*^9, 3.4603697421688843`*^9, 
   3.460370030103874*^9, 3.460370341630898*^9, 3.460371529458281*^9, 
   3.460371597568221*^9, 3.460373544538747*^9, 3.460377043635038*^9, 
   3.460377178198557*^9, 3.460377258262187*^9, 3.460377665441781*^9, 
   3.460427456233851*^9, 3.4604319457565603`*^9, {3.460432909977116*^9, 
   3.460432914941457*^9}, 3.4604330820901012`*^9, 3.460433120037969*^9, 
   3.4604345780819597`*^9, 3.460434978336451*^9, 3.460437046470871*^9, 
   3.460437553217643*^9, 3.460440367108382*^9, 3.460444575278883*^9, 
   3.4604447725558567`*^9, 3.460444940639205*^9, 3.460444997936206*^9, 
   3.4604591005903893`*^9, 3.460460040743739*^9, 3.460460126074955*^9, 
   3.4604608067430067`*^9, 3.460721890152472*^9, 3.460722626145686*^9, 
   3.4607749553896437`*^9, {3.460774987430462*^9, 3.46077501187606*^9}, 
   3.460775669737484*^9, 3.4607951149764967`*^9, {3.460802001918146*^9, 
   3.460802018432424*^9}, 3.460802060195074*^9, 3.4608613048399267`*^9, 
   3.460892846236662*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "0", "}"}], ",", 
   RowBox[{"{", "0", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.460126911291768*^9, {3.460127448010219*^9, 3.460127463752602*^9}, 
   3.46019781849335*^9, 3.460198255524288*^9, 3.460198352058052*^9, 
   3.4601985156112556`*^9, 3.4601995266377697`*^9, 3.460199577399457*^9, 
   3.46019965430007*^9, 3.460200566230009*^9, 3.460200601139563*^9, 
   3.460201879055964*^9, 3.460254153231098*^9, {3.46026300470542*^9, 
   3.4602630225053473`*^9}, 3.460270473521778*^9, 3.4602791537878532`*^9, 
   3.460279213318447*^9, 3.460281700761509*^9, {3.460284339881637*^9, 
   3.460284358605403*^9}, 3.460284752501553*^9, 3.460285736426825*^9, 
   3.460285989707677*^9, 3.460286272224893*^9, 3.460286307114214*^9, 
   3.4603638964211063`*^9, 3.460366622238628*^9, 3.4603697421688843`*^9, 
   3.460370030103874*^9, 3.460370341630898*^9, 3.460371529458281*^9, 
   3.460371597568221*^9, 3.460373544538747*^9, 3.460377043635038*^9, 
   3.460377178198557*^9, 3.460377258262187*^9, 3.460377665441781*^9, 
   3.460427456233851*^9, 3.4604319457565603`*^9, {3.460432909977116*^9, 
   3.460432914941457*^9}, 3.4604330820901012`*^9, 3.460433120037969*^9, 
   3.4604345780819597`*^9, 3.460434978336451*^9, 3.460437046470871*^9, 
   3.460437553217643*^9, 3.460440367108382*^9, 3.460444575278883*^9, 
   3.4604447725558567`*^9, 3.460444940639205*^9, 3.460444997936206*^9, 
   3.4604591005903893`*^9, 3.460460040743739*^9, 3.460460126074955*^9, 
   3.4604608067430067`*^9, 3.460721890152472*^9, 3.460722626145686*^9, 
   3.4607749553896437`*^9, {3.460774987430462*^9, 3.46077501187606*^9}, 
   3.460775669737484*^9, 3.4607951149764967`*^9, {3.460802001918146*^9, 
   3.460802018432424*^9}, 3.460802060195074*^9, 3.4608613048399267`*^9, 
   3.460892846248949*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1.`", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1.`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.460126911291768*^9, {3.460127448010219*^9, 3.460127463752602*^9}, 
   3.46019781849335*^9, 3.460198255524288*^9, 3.460198352058052*^9, 
   3.4601985156112556`*^9, 3.4601995266377697`*^9, 3.460199577399457*^9, 
   3.46019965430007*^9, 3.460200566230009*^9, 3.460200601139563*^9, 
   3.460201879055964*^9, 3.460254153231098*^9, {3.46026300470542*^9, 
   3.4602630225053473`*^9}, 3.460270473521778*^9, 3.4602791537878532`*^9, 
   3.460279213318447*^9, 3.460281700761509*^9, {3.460284339881637*^9, 
   3.460284358605403*^9}, 3.460284752501553*^9, 3.460285736426825*^9, 
   3.460285989707677*^9, 3.460286272224893*^9, 3.460286307114214*^9, 
   3.4603638964211063`*^9, 3.460366622238628*^9, 3.4603697421688843`*^9, 
   3.460370030103874*^9, 3.460370341630898*^9, 3.460371529458281*^9, 
   3.460371597568221*^9, 3.460373544538747*^9, 3.460377043635038*^9, 
   3.460377178198557*^9, 3.460377258262187*^9, 3.460377665441781*^9, 
   3.460427456233851*^9, 3.4604319457565603`*^9, {3.460432909977116*^9, 
   3.460432914941457*^9}, 3.4604330820901012`*^9, 3.460433120037969*^9, 
   3.4604345780819597`*^9, 3.460434978336451*^9, 3.460437046470871*^9, 
   3.460437553217643*^9, 3.460440367108382*^9, 3.460444575278883*^9, 
   3.4604447725558567`*^9, 3.460444940639205*^9, 3.460444997936206*^9, 
   3.4604591005903893`*^9, 3.460460040743739*^9, 3.460460126074955*^9, 
   3.4604608067430067`*^9, 3.460721890152472*^9, 3.460722626145686*^9, 
   3.4607749553896437`*^9, {3.460774987430462*^9, 3.46077501187606*^9}, 
   3.460775669737484*^9, 3.4607951149764967`*^9, {3.460802001918146*^9, 
   3.460802018432424*^9}, 3.460802060195074*^9, 3.4608613048399267`*^9, 
   3.46089284625742*^9}],

Cell[BoxData["h$6815093"], "Output",
 CellChangeTimes->{
  3.460126911291768*^9, {3.460127448010219*^9, 3.460127463752602*^9}, 
   3.46019781849335*^9, 3.460198255524288*^9, 3.460198352058052*^9, 
   3.4601985156112556`*^9, 3.4601995266377697`*^9, 3.460199577399457*^9, 
   3.46019965430007*^9, 3.460200566230009*^9, 3.460200601139563*^9, 
   3.460201879055964*^9, 3.460254153231098*^9, {3.46026300470542*^9, 
   3.4602630225053473`*^9}, 3.460270473521778*^9, 3.4602791537878532`*^9, 
   3.460279213318447*^9, 3.460281700761509*^9, {3.460284339881637*^9, 
   3.460284358605403*^9}, 3.460284752501553*^9, 3.460285736426825*^9, 
   3.460285989707677*^9, 3.460286272224893*^9, 3.460286307114214*^9, 
   3.4603638964211063`*^9, 3.460366622238628*^9, 3.4603697421688843`*^9, 
   3.460370030103874*^9, 3.460370341630898*^9, 3.460371529458281*^9, 
   3.460371597568221*^9, 3.460373544538747*^9, 3.460377043635038*^9, 
   3.460377178198557*^9, 3.460377258262187*^9, 3.460377665441781*^9, 
   3.460427456233851*^9, 3.4604319457565603`*^9, {3.460432909977116*^9, 
   3.460432914941457*^9}, 3.4604330820901012`*^9, 3.460433120037969*^9, 
   3.4604345780819597`*^9, 3.460434978336451*^9, 3.460437046470871*^9, 
   3.460437553217643*^9, 3.460440367108382*^9, 3.460444575278883*^9, 
   3.4604447725558567`*^9, 3.460444940639205*^9, 3.460444997936206*^9, 
   3.4604591005903893`*^9, 3.460460040743739*^9, 3.460460126074955*^9, 
   3.4604608067430067`*^9, 3.460721890152472*^9, 3.460722626145686*^9, 
   3.4607749553896437`*^9, {3.460774987430462*^9, 3.46077501187606*^9}, 
   3.460775669737484*^9, 3.4607951149764967`*^9, {3.460802001918146*^9, 
   3.460802018432424*^9}, 3.460802060195074*^9, 3.4608613048399267`*^9, 
   3.4608928462659807`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"B", "//", "Clear"}]], "Input",
 CellChangeTimes->{{3.460796396588298*^9, 3.4607963991799088`*^9}}],

Cell[CellGroupData[{

Cell[BoxData["a12"], "Input",
 CellChangeTimes->{{3.460796574557797*^9, 3.460796575368771*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"Arrow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.8`"}], ",", "0.`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.8`", ",", "0.`"}], "}"}]}], "}"}], "]"}], "}"}]], "Output",
 CellChangeTimes->{
  3.460796575512144*^9, {3.460802002468438*^9, 3.4608020188408537`*^9}, 
   3.460861305123418*^9, 3.46089284638268*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BlaBlaDiagrammMatrix", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"A", ",", "B"}], "}"}], ",", ".2", ",", "beta", ",", "12"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.460126926202602*^9, 3.460126926264735*^9}, {
  3.460197837062155*^9, 3.4601978744501877`*^9}, {3.460198176014512*^9, 
  3.4601981763542347`*^9}, {3.460198286470953*^9, 3.460198287074853*^9}, {
  3.460201742748698*^9, 3.46020174505478*^9}, {3.460201843262917*^9, 
  3.460201847980236*^9}, {3.4602030757501917`*^9, 3.460203091242997*^9}, {
  3.460203406030672*^9, 3.460203406841346*^9}, {3.4602037079581614`*^9, 
  3.4602037570505037`*^9}, {3.4604314383103333`*^9, 3.460431463763299*^9}, {
  3.46072191343194*^9, 3.4607219215661173`*^9}, {3.460774964542247*^9, 
  3.46077496528304*^9}, {3.460796389790634*^9, 3.460796390917165*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0], Thickness[0.003], CircleBox[{-1, 0}, 0.2], 
    CircleBox[{1, 0}, 0.2]}, 
   {GrayLevel[0], Thickness[0.003], InsetBox["A", {-0.98, 0.02}], 
    InsetBox["B", {1.02, 0.02}]}, 
   {RGBColor[1, 0, 0], Thickness[0.003], ArrowBox[{{-0.8, 0.}, {0.8, 0.}}]}, 
   {RGBColor[0, 0, 1], Thickness[0.003]}, 
   {RGBColor[1, 0, 0], Thickness[0.003], 
    InsetBox["0.5`", {0.059999999999999915`, -0.1},
     Background->RGBColor[1, 0.85, 0.85]]}, 
   {RGBColor[0, 0, 1], Thickness[0.003]}},
  AspectRatio->Automatic,
  BaseStyle->{FontFamily -> "Helvetica", FontSize -> 12},
  Frame->True,
  FrameTicks->False,
  ImageSize->{416., Automatic}]], "Output",
 CellChangeTimes->{
  3.4601269281869783`*^9, 3.460127426082061*^9, 3.460127466329838*^9, {
   3.460127585117103*^9, 3.4601276005862913`*^9}, {3.4601978186150627`*^9, 
   3.4601978754337683`*^9}, {3.4601979922064037`*^9, 3.460198015465253*^9}, {
   3.460198108435659*^9, 3.460198177004368*^9}, {3.460198256947486*^9, 
   3.460198287948544*^9}, 3.460198354151993*^9, 3.460198517017171*^9, 
   3.460199526697234*^9, 3.4601995792704763`*^9, 3.460199654370886*^9, 
   3.460200568819632*^9, 3.460200601192975*^9, 3.460201294388686*^9, 
   3.460201422604823*^9, {3.4602014621856337`*^9, 3.4602014755616083`*^9}, {
   3.460201617064205*^9, 3.460201636172051*^9}, 3.460201746377551*^9, {
   3.4602017858617897`*^9, 3.460201848817997*^9}, 3.460201879133306*^9, {
   3.460203077180921*^9, 3.46020309246707*^9}, {3.460203375574904*^9, 
   3.460203407031555*^9}, {3.460203525933297*^9, 3.460203550744958*^9}, {
   3.460203591076667*^9, 3.4602035982917624`*^9}, 3.460203629545972*^9, {
   3.460203698543215*^9, 3.4602037978560038`*^9}, 3.460254157635613*^9, 
   3.460254917290598*^9, {3.460254963282044*^9, 3.4602549886738853`*^9}, 
   3.460263131690372*^9, 3.460270473691039*^9, 3.460279154236169*^9, 
   3.460279213807478*^9, 3.460281708338883*^9, {3.460284349078342*^9, 
   3.46028435872755*^9}, 3.460284753032539*^9, 3.460285736953566*^9, 
   3.4602859901890087`*^9, 3.460286272617923*^9, 3.460286307573679*^9, 
   3.460363896961611*^9, 3.460366622530184*^9, 3.460369742647211*^9, 
   3.460370030312529*^9, 3.46037034184521*^9, 3.460371529755887*^9, 
   3.46037159784545*^9, 3.460373544733478*^9, 3.460377044136137*^9, 
   3.4603771786940317`*^9, 3.460377258585181*^9, 3.460377665886016*^9, 
   3.460427456579464*^9, {3.460431435582724*^9, 3.4604314836711187`*^9}, 
   3.4604319486144123`*^9, 3.460432915151466*^9, 3.460433082416451*^9, 
   3.460433120520093*^9, 3.460434578562842*^9, 3.460434978814953*^9, 
   3.4604370467471027`*^9, 3.460437553357094*^9, 3.4604403675548153`*^9, 
   3.460444575794372*^9, 3.4604447727257557`*^9, 3.460444941147047*^9, 
   3.460444998197179*^9, 3.460459101088204*^9, 3.460460040928624*^9, 
   3.4604601264664707`*^9, 3.460460807058498*^9, {3.4607218959351254`*^9, 
   3.460721922246777*^9}, 3.460722626612988*^9, {3.4607749564757357`*^9, 
   3.460775012170724*^9}, 3.460775670176813*^9, 3.4607943173822527`*^9, 
   3.460795115476233*^9, {3.4607963868910303`*^9, 3.460796402499433*^9}, 
   3.460796572498952*^9, {3.4608020025541763`*^9, 3.4608020189421988`*^9}, 
   3.460861305208261*^9, 3.460892846460535*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"B1", "=", 
    RowBox[{
     RowBox[{"I2", "-", "beta"}], "//", "Inverse"}]}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.4602031193688383`*^9, 3.4602031417504272`*^9}, {
  3.460254264329975*^9, 3.460254272840392*^9}, {3.4607749723988*^9, 
  3.460774972467041*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2"},
      {"1", "1.`", "0.`"},
      {"2", "0.5`", "1.`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.460203120570764*^9, 3.460203142571908*^9}, 
   3.460254154939602*^9, {3.460254261383683*^9, 3.460254273739875*^9}, 
   3.460254333610758*^9, 3.460263140602977*^9, 3.460270473788156*^9, 
   3.4602791543419523`*^9, 3.460279213895871*^9, 3.460281712464506*^9, {
   3.460284351900099*^9, 3.460284358790635*^9}, 3.460284753137499*^9, 
   3.460285737065781*^9, 3.460285990287882*^9, 3.460286272704586*^9, 
   3.4602863076641827`*^9, 3.4603638970605183`*^9, 3.460366622635786*^9, 
   3.4603697427595453`*^9, 3.460370030414991*^9, 3.460370341928465*^9, 
   3.460371529857189*^9, 3.4603715979464417`*^9, 3.460373544838743*^9, 
   3.460377044224801*^9, 3.460377178799849*^9, 3.460377258685432*^9, 
   3.460377666002129*^9, 3.460427456683173*^9, 3.460432915252284*^9, 
   3.460433082520834*^9, 3.4604331206095257`*^9, 3.460434578667056*^9, 
   3.4604349789017773`*^9, 3.460437046835697*^9, 3.460437553445334*^9, 
   3.460440367670916*^9, 3.460444575903373*^9, 3.460444772817761*^9, 
   3.460444941257197*^9, 3.460444998286359*^9, 3.460459101179171*^9, 
   3.4604600410360126`*^9, 3.460460126573408*^9, 3.460460807148085*^9, 
   3.460721932075602*^9, 3.460722626715157*^9, {3.460774956818077*^9, 
   3.4607750122761507`*^9}, 3.460775670268469*^9, 3.4607951155784817`*^9, {
   3.460802002784387*^9, 3.460802019037509*^9}, 3.460861305291651*^9, 
   3.460892846519476*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BlaBlaDiagrammMatrix", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"A", ",", "B"}], "}"}], ",", ".2", ",", "B1", ",", "12"}], 
  "]"}]], "Input",
 CellChangeTimes->{
  3.4602541804489317`*^9, {3.460254277098235*^9, 3.460254280231039*^9}, {
   3.460254509599163*^9, 3.4602545160826283`*^9}, {3.460722636783688*^9, 
   3.4607226395330267`*^9}, {3.460774976551556*^9, 3.460774977435566*^9}, {
   3.4607964084250813`*^9, 3.4607964094483423`*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0], Thickness[0.003], CircleBox[{-1, 0}, 0.2], 
    CircleBox[{1, 0}, 0.2]}, 
   {GrayLevel[0], Thickness[0.003], InsetBox["A", {-0.98, 0.02}], 
    InsetBox["B", {1.02, 0.02}]}, 
   {RGBColor[1, 0, 0], Thickness[0.003], ArrowBox[{{-0.8, 0.}, {0.8, 0.}}]}, 
   {RGBColor[0, 0, 1], Thickness[0.003]}, 
   {RGBColor[1, 0, 0], Thickness[0.003], 
    InsetBox["0.5`", {0.059999999999999915`, -0.1},
     Background->RGBColor[1, 0.85, 0.85]]}, 
   {RGBColor[0, 0, 1], Thickness[0.003]}},
  AspectRatio->Automatic,
  BaseStyle->{FontFamily -> "Helvetica", FontSize -> 12},
  Frame->True,
  FrameTicks->False]], "Output",
 CellChangeTimes->{
  3.4602541818218737`*^9, 3.460254280335683*^9, 3.460254334747493*^9, {
   3.460254394251598*^9, 3.460254411277727*^9}, {3.460254511486261*^9, 
   3.4602545320527563`*^9}, 3.460254587240301*^9, 3.460254701501644*^9, 
   3.4602547523545923`*^9, 3.46025483835599*^9, {3.4602548936570463`*^9, 
   3.460254899095298*^9}, {3.4602549339701557`*^9, 3.460254983204011*^9}, 
   3.460263142512862*^9, 3.460270473909836*^9, 3.4602791544692698`*^9, 
   3.460279214020843*^9, 3.460281716552771*^9, {3.460284353799768*^9, 
   3.46028435884326*^9}, 3.460284753268414*^9, 3.460285737301465*^9, 
   3.460285990415246*^9, 3.460286272833438*^9, 3.4602863077868137`*^9, 
   3.4603638971865807`*^9, 3.460366622759886*^9, 3.46036974288822*^9, 
   3.4603700305410748`*^9, 3.460370342056143*^9, 3.460371529983536*^9, 
   3.460371598093424*^9, 3.4603735449649*^9, 3.460377044362979*^9, 
   3.460377178928034*^9, 3.46037725881456*^9, 3.460377666125819*^9, 
   3.4604274568251543`*^9, 3.4604329153801527`*^9, 3.460433082647156*^9, 
   3.4604331207334843`*^9, 3.460434578791883*^9, 3.460434979028728*^9, 
   3.460437046960555*^9, 3.4604375535746403`*^9, 3.460440367795998*^9, 
   3.460444576029722*^9, 3.4604447729447517`*^9, 3.460444941382475*^9, 
   3.4604449984059067`*^9, 3.4604591013052187`*^9, 3.4604600411628523`*^9, 
   3.460460126691949*^9, 3.460460807272231*^9, 3.46072193434873*^9, {
   3.4607226268603*^9, 3.460722640424999*^9}, {3.460774957535947*^9, 
   3.460775012400111*^9}, 3.460775670425413*^9, 3.460795115727992*^9, 
   3.460796410064348*^9, {3.460802002868698*^9, 3.460802019298863*^9}, 
   3.4608613053924007`*^9, 3.460892846588214*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"X", "//", "Dimensions"}]], "Input",
 PageWidth->Infinity,
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"50", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4598278723739767`*^9, 3.460112961274558*^9, 3.4601139646218567`*^9, 
   3.460114147492792*^9, 3.460114235304534*^9, 3.4601143048966722`*^9, 
   3.4601209300977497`*^9, 3.460197818734274*^9, 3.460198377489222*^9, 
   3.460198430929615*^9, 3.460198522874699*^9, 3.4601995267642307`*^9, 
   3.460199654485032*^9, 3.460200491292087*^9, 3.46020060124748*^9, 
   3.460201879197091*^9, 3.460263149826062*^9, 3.460270474001726*^9, 
   3.460279154641218*^9, 3.460279214196114*^9, 3.46028435891831*^9, 
   3.460284753478565*^9, 3.460285737384676*^9, 3.460285990604249*^9, 
   3.4602862729472713`*^9, 3.4602863079894857`*^9, 3.460363897363798*^9, 
   3.460366622836136*^9, 3.460369743118175*^9, 3.460370030648271*^9, 
   3.460370342147684*^9, 3.4603715300882397`*^9, 3.4603715981978397`*^9, 
   3.460373545055071*^9, 3.460377044553479*^9, 3.460377179138245*^9, 
   3.460377259035881*^9, 3.460377666349531*^9, 3.460427456931285*^9, 
   3.460432915486574*^9, 3.460433082739298*^9, 3.4604331209349833`*^9, 
   3.460434578988125*^9, 3.460434979233774*^9, 3.4604370470495157`*^9, 
   3.460437553684456*^9, 3.4604403680034313`*^9, 3.460444576253565*^9, 
   3.4604447730354967`*^9, 3.460444941595415*^9, 3.460444998499771*^9, 
   3.460459101570765*^9, 3.4604600412586613`*^9, 3.4604601267885838`*^9, 
   3.460460807348174*^9, 3.46072262707434*^9, 3.4607749577502823`*^9, {
   3.460774988336665*^9, 3.460775012492605*^9}, 3.460775670662545*^9, 
   3.460795115976261*^9, {3.46080200293657*^9, 3.4608020193935013`*^9}, 
   3.460861305490552*^9, 3.4608928466665707`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ETA", "//", "Dimensions"}]], "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"50", ",", "2"}], "}"}]], "Output",
 CellChangeTimes->{3.4608020727682133`*^9, 3.460861305576969*^9, 
  3.460892846735661*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"ETA", "\[IndentingNewLine]", "Y"}], "Input",
 CellChangeTimes->{{3.460114000133006*^9, 3.460114009445375*^9}, {
  3.460437707958293*^9, 3.460437712698263*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.5616301074727694`", ",", 
     RowBox[{"-", "0.22220807572957746`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.4634756461367502`", ",", "1.8415075286424845`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.4824884137993699`", ",", 
     RowBox[{"-", "1.40408694884235`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9551465569768363`", ",", "1.5424273154349932`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.2884734784812073`", ",", "0.5643718685340828`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.7067866091199786`", ",", "1.7505435707018409`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.45622344636145584`", ",", "1.6676249462896147`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.33799042181662564`"}], ",", "0.06288877022936479`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.8296017016167898`"}], ",", "0.3442555686932689`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.8056093434404543`", ",", 
     RowBox[{"-", "0.2039204098662304`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2.1967575852408245`"}], ",", "0.015985627255467705`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.8825891531062169`"}], ",", "0.3941418359707427`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2.2678672841245238`", ",", "3.159123510574048`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.06611306069769185`", ",", "0.40292632806374584`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.25051791635447174`", ",", "0.35516146332779996`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.0121422898695496`", ",", 
     RowBox[{"-", "0.3062933423038521`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.3335418333916165`", ",", "2.3778288986367158`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.5765123041970615`"}], ",", 
     RowBox[{"-", "0.7907514455529983`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.7857261709076795`"}], ",", "0.008087165417785869`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.1541238427942346`", ",", "0.3247629099989675`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.7809797228607538`"}], ",", 
     RowBox[{"-", "1.1149280092570915`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.058144336719479384`"}], ",", 
     RowBox[{"-", "0.5579552782762516`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.1656347739700479`"}], ",", "0.7638106236727573`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.2989450655871142`", ",", "0.21962104398357685`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.27163802694170247`"}], ",", 
     RowBox[{"-", "0.6289034960394466`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.5906291754652155`", ",", "1.308123666675768`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.756890567785506`", ",", "3.0060135513645454`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.6433529353386698`"}], ",", 
     RowBox[{"-", "0.8930769596842665`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.5026425648206558`"}], ",", "0.06472374745527443`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.49714096255807316`", ",", 
     RowBox[{"-", "0.11579043718669313`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.7045031763393119`"}], ",", 
     RowBox[{"-", "0.8404066066936515`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.6365741876403774`", ",", 
     RowBox[{"-", "0.3036359374358586`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.08472297228268211`", ",", 
     RowBox[{"-", "1.1783204737701167`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.31992973665867375`", ",", "0.49586459701452323`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.5146325857792586`"}], ",", "0.5043208462659772`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.7389772857653192`"}], ",", 
     RowBox[{"-", "2.680394572258897`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.3700060514011758`"}], ",", "0.2568975648749441`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.7165168121457226`"}], ",", 
     RowBox[{"-", "0.2293963409720745`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.372592058493197`"}], ",", "0.03972987460748367`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.13664143282798147`"}], ",", 
     RowBox[{"-", "0.21152664668211196`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.1010113558411394`", ",", "1.2741950479030404`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.7031716594361956`", ",", 
     RowBox[{"-", "0.4127187338428353`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2.040212176564956`"}], ",", 
     RowBox[{"-", "1.2952667538439235`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.365050470016305`"}], ",", 
     RowBox[{"-", "0.1528693876397904`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.04227212767594857`", ",", "0.06422720965410722`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.0516383494021575`", ",", "0.6343772101111966`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.3081229258078952`"}], ",", 
     RowBox[{"-", "1.4467877797589574`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9344552846862566`", ",", 
     RowBox[{"-", "1.0889033744520722`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.5132335571675606`", ",", "1.7078643012918513`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9163039229545173`", ",", 
     RowBox[{"-", "0.01816731645182923`"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.459827872527598*^9, 3.46011303067655*^9, 3.46011396489058*^9, {
   3.4601139984758797`*^9, 3.460114009526347*^9}, 3.46011414834797*^9, 
   3.460114235624238*^9, 3.4601143050940447`*^9, 3.460120930349319*^9, 
   3.460197819413198*^9, 3.460198381508251*^9, 3.46019852964046*^9, 
   3.460199526993176*^9, 3.460199654815744*^9, 3.460200496332955*^9, 
   3.460200601423087*^9, 3.460201879378018*^9, 3.460270474250579*^9, 
   3.460279154911991*^9, 3.4602792144465427`*^9, 3.460284359140807*^9, 
   3.460284753724605*^9, 3.460285737649325*^9, 3.4602859908555183`*^9, 
   3.460286273308621*^9, 3.460286308214764*^9, 3.460363897608238*^9, 
   3.460366623184637*^9, 3.460369743366684*^9, 3.460370031031135*^9, 
   3.4603703425137777`*^9, 3.460371530458078*^9, 3.4603715985520267`*^9, 
   3.4603735454327793`*^9, 3.460377044823373*^9, 3.460377179413405*^9, 
   3.4603772592727413`*^9, 3.460377666570675*^9, 3.460427457300247*^9, 
   3.460432915847116*^9, 3.460433083104856*^9, 3.460433121209031*^9, 
   3.460434579250781*^9, 3.460434979484872*^9, 3.46043704741685*^9, 
   3.4604375539298477`*^9, {3.460437706464828*^9, 3.4604377134974957`*^9}, 
   3.460439052589326*^9, 3.460439859095868*^9, {3.4604403682553453`*^9, 
   3.460440379020708*^9}, 3.460444576485385*^9, 3.4604447734082127`*^9, {
   3.460444941829196*^9, 3.4604449544662857`*^9}, 3.460444998837132*^9, 
   3.460459101818636*^9, 3.460460041624042*^9, 3.460460127127924*^9, 
   3.460460807717482*^9, 3.4607226273019238`*^9, 3.460774957999571*^9, {
   3.46077498857581*^9, 3.460775012897278*^9}, 3.460775670939363*^9, 
   3.4607951162490892`*^9, {3.460802003238473*^9, 3.4608020196537046`*^9}, 
   3.460802078883192*^9, 3.460861305829501*^9, 3.460892846823099*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.16331044431608274`", ",", "0.24158904950299878`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.9024260109848372`"}], ",", 
     RowBox[{"-", "4.577306852383316`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.31569397924174813`", ",", "1.2561045794566605`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"0.1062144278565599`", ",", 
     RowBox[{"-", "2.344273446559722`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.7401945664779092`"}], ",", "0.6954714522151194`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.3204618577244954`", ",", 
     RowBox[{"-", "3.504104223413986`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.41539348712586127`"}], ",", 
     RowBox[{"-", "3.2101260406831975`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.11755585718305658`"}], ",", "0.6410552202963153`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.7085149288456514`"}], ",", "0.31014352577451426`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.027095634070878505`"}], ",", 
     RowBox[{"-", "0.4393346306584965`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8.36035839793744`", ",", "0.10531570308611186`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.4920407313793702`"}], ",", "0.8091771622863534`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "8.85257523047291`"}], ",", 
     RowBox[{"-", "28.013411148317353`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.27482866853903254`"}], ",", "0.8901013223174044`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.1589651383967176`", ",", "0.5118668727857038`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.06615939039743456`"}], ",", "0.22529102437993648`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.47511067401365126`"}], ",", 
     RowBox[{"-", "11.272039967528995`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.18135704778472375`"}], ",", 
     RowBox[{"-", "0.5539883519356288`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.030034723090191395`", ",", "0.2766587127100336`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.06650230986090083`"}], ",", "0.4637445083424453`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.37962647788614595`"}], ",", "0.3931852500998263`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.042798397680071446`"}], ",", "0.0571986254924452`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.17301326592976563`"}], ",", "0.02325863494139324`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.3588259637200597`", ",", "0.36635034645907005`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.3334448199888894`"}], ",", 
     RowBox[{"-", "0.17438462302234756`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.27182195465251746`", ",", 
     RowBox[{"-", "0.888761378684181`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "3.7596718239010563`"}], ",", 
     RowBox[{"-", "24.200952995650198`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.6689717679862257`"}], ",", 
     RowBox[{"-", "0.037849731207946435`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2.0376124765230714`", ",", "0.19056831254802442`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"0.07889087990385335`", ",", 
     RowBox[{"-", "0.22377236732540556`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.99339422398807`"}], ",", 
     RowBox[{"-", "0.44560445250716574`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.30445249932179863`", ",", 
     RowBox[{"-", "0.49971407497401177`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.5524700461096991`"}], ",", "0.2504762584239649`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.004706419202464118`", ",", "0.3192195290519969`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.44775461594055127`"}], ",", "0.3678715547095395`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2.9902660157714407`", ",", "17.07583345294659`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.27104949131161477`"}], ",", "0.13573961512453958`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3.8012015092974862`", ",", "0.015593127070639395`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.18119063588156986`", ",", "0.2891443942575295`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.6058579248545801`"}], ",", 
     RowBox[{"-", "0.4356731793695501`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.05216634711211657`"}], ",", 
     RowBox[{"-", "1.22721748174143`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9762831962434353`", ",", 
     RowBox[{"-", "0.8183252354684216`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6.939383778815693`", ",", "0.5296979366536949`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.8206002791478495`", ",", 
     RowBox[{"-", "0.448518468237541`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.0009564733581090973`"}], ",", "0.225162046263855`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.6524614082039999`"}], ",", "0.4373100577069961`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.7417752441226461`", ",", "1.6664714772436684`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.23827644629832817`"}], ",", "0.20370951770030152`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2.1403485512082234`"}], ",", 
     RowBox[{"-", "3.779345838076979`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.11567026248839957`"}], ",", 
     RowBox[{"-", "0.1178902499703703`"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.459827872527598*^9, 3.46011303067655*^9, 3.46011396489058*^9, {
   3.4601139984758797`*^9, 3.460114009526347*^9}, 3.46011414834797*^9, 
   3.460114235624238*^9, 3.4601143050940447`*^9, 3.460120930349319*^9, 
   3.460197819413198*^9, 3.460198381508251*^9, 3.46019852964046*^9, 
   3.460199526993176*^9, 3.460199654815744*^9, 3.460200496332955*^9, 
   3.460200601423087*^9, 3.460201879378018*^9, 3.460270474250579*^9, 
   3.460279154911991*^9, 3.4602792144465427`*^9, 3.460284359140807*^9, 
   3.460284753724605*^9, 3.460285737649325*^9, 3.4602859908555183`*^9, 
   3.460286273308621*^9, 3.460286308214764*^9, 3.460363897608238*^9, 
   3.460366623184637*^9, 3.460369743366684*^9, 3.460370031031135*^9, 
   3.4603703425137777`*^9, 3.460371530458078*^9, 3.4603715985520267`*^9, 
   3.4603735454327793`*^9, 3.460377044823373*^9, 3.460377179413405*^9, 
   3.4603772592727413`*^9, 3.460377666570675*^9, 3.460427457300247*^9, 
   3.460432915847116*^9, 3.460433083104856*^9, 3.460433121209031*^9, 
   3.460434579250781*^9, 3.460434979484872*^9, 3.46043704741685*^9, 
   3.4604375539298477`*^9, {3.460437706464828*^9, 3.4604377134974957`*^9}, 
   3.460439052589326*^9, 3.460439859095868*^9, {3.4604403682553453`*^9, 
   3.460440379020708*^9}, 3.460444576485385*^9, 3.4604447734082127`*^9, {
   3.460444941829196*^9, 3.4604449544662857`*^9}, 3.460444998837132*^9, 
   3.460459101818636*^9, 3.460460041624042*^9, 3.460460127127924*^9, 
   3.460460807717482*^9, 3.4607226273019238`*^9, 3.460774957999571*^9, {
   3.46077498857581*^9, 3.460775012897278*^9}, 3.460775670939363*^9, 
   3.4607951162490892`*^9, {3.460802003238473*^9, 3.4608020196537046`*^9}, 
   3.460802078883192*^9, 3.460861305829501*^9, 3.46089284687354*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"plot1", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ETA", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"n", "//", "Range"}], ",", "All"}], " ", "]"}], "]"}], "//", 
     "Transpose"}], "//", "AddTimeAxis"}], ",", 
   RowBox[{"farbmodell", "\[Rule]", "Hue"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plot1", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Y", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"n", "//", "Range"}], ",", "All"}], " ", "]"}], "]"}], "//", 
      "Transpose"}], "//", "AddTimeAxis"}], ",", 
    RowBox[{"farbmodell", "\[Rule]", "Hue"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113047733139*^9, 3.4601131167734203`*^9}, {
  3.46011396933543*^9, 3.460113989452705*^9}, {3.460114029168693*^9, 
  3.460114031766469*^9}, {3.460114161512141*^9, 3.460114164229396*^9}, {
  3.460120949297063*^9, 3.460120987997653*^9}, {3.460370039524664*^9, 
  3.460370040016472*^9}, {3.460371539333914*^9, 3.460371544125806*^9}, {
  3.460801595611189*^9, 3.46080160763523*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.5616301074727694}, {
       1., -0.22220807572957746`}}]}}}, {{}, {}, 
    {Hue[0.9], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 1.4634756461367502`}, {1., 
       1.8415075286424845`}}]}}}, {{}, {}, 
    {Hue[0.8], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.4824884137993699}, {
       1., -1.40408694884235}}]}}}, {{}, {}, 
    {Hue[0.7000000000000001], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.9551465569768363}, {1., 
       1.5424273154349932`}}]}}}, {{}, {}, 
    {Hue[0.6], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 1.2884734784812073`}, {1., 
       0.5643718685340828}}]}}}, {{}, {}, 
    {Hue[0.5], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.7067866091199786}, {1., 
       1.7505435707018409`}}]}}}, {{}, {}, 
    {Hue[0.4], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.45622344636145584`}, {1., 
       1.6676249462896147`}}]}}}, {{}, {}, 
    {Hue[0.30000000000000004`], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.33799042181662564`}, {1., 
       0.06288877022936479}}]}}}, {{}, {}, 
    {Hue[0.2], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.8296017016167898}, {1., 
       0.3442555686932689}}]}}}, {{}, {}, 
    {Hue[0.1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.8056093434404543}, {
       1., -0.2039204098662304}}]}}}, {{}, {}, 
    {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -2.1967575852408245`}, {1., 
       0.015985627255467705`}}]}}}, {{}, {}, 
    {Hue[0.9], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.8825891531062169}, {1., 
       0.3941418359707427}}]}}}, {{}, {}, 
    {Hue[0.8], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 2.2678672841245238`}, {1., 
       3.159123510574048}}]}}}, {{}, {}, 
    {Hue[0.7000000000000001], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.06611306069769185}, {1., 
       0.40292632806374584`}}]}}}, {{}, {}, 
    {Hue[0.6], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.25051791635447174`}, {1., 
       0.35516146332779996`}}]}}}, {{}, {}, 
    {Hue[0.5], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 1.0121422898695496`}, {
       1., -0.3062933423038521}}]}}}, {{}, {}, 
    {Hue[0.4], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 1.3335418333916165`}, {1., 
       2.3778288986367158`}}]}}}, {{}, {}, 
    {Hue[0.30000000000000004`], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.5765123041970615}, {
       1., -0.7907514455529983}}]}}}, {{}, {}, 
    {Hue[0.2], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.7857261709076795}, {1., 
       0.008087165417785869}}]}}}, {{}, {}, 
    {Hue[0.1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 1.1541238427942346`}, {1., 
       0.3247629099989675}}]}}}, {{}, {}, 
    {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.7809797228607538}, {
       1., -1.1149280092570915`}}]}}}, {{}, {}, 
    {Hue[0.9], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.058144336719479384`}, {
       1., -0.5579552782762516}}]}}}, {{}, {}, 
    {Hue[0.8], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.1656347739700479}, {1., 
       0.7638106236727573}}]}}}, {{}, {}, 
    {Hue[0.7000000000000001], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.2989450655871142}, {1., 
       0.21962104398357685`}}]}}}, {{}, {}, 
    {Hue[0.6], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.27163802694170247`}, {
       1., -0.6289034960394466}}]}}}, {{}, {}, 
    {Hue[0.5], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.5906291754652155}, {1., 
       1.308123666675768}}]}}}, {{}, {}, 
    {Hue[0.4], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 1.756890567785506}, {1., 
       3.0060135513645454`}}]}}}, {{}, {}, 
    {Hue[0.30000000000000004`], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.6433529353386698}, {
       1., -0.8930769596842665}}]}}}, {{}, {}, 
    {Hue[0.2], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -1.5026425648206558`}, {1., 
       0.06472374745527443}}]}}}, {{}, {}, 
    {Hue[0.1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.49714096255807316`}, {
       1., -0.11579043718669313`}}]}}}, {{}, {}, 
    {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.7045031763393119}, {
       1., -0.8404066066936515}}]}}}, {{}, {}, 
    {Hue[0.9], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.6365741876403774}, {
       1., -0.3036359374358586}}]}}}, {{}, {}, 
    {Hue[0.8], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.08472297228268211}, {
       1., -1.1783204737701167`}}]}}}, {{}, {}, 
    {Hue[0.7000000000000001], PointSize[0.003], Thickness[0.003], Dashing[{}],
      {}, 
     {Opacity[1], 
      LineBox[{{0., 0.31992973665867375`}, {1., 
       0.49586459701452323`}}]}}}, {{}, {}, 
    {Hue[0.6], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.5146325857792586}, {1., 
       0.5043208462659772}}]}}}, {{}, {}, 
    {Hue[0.5], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -1.7389772857653192`}, {
       1., -2.680394572258897}}]}}}, {{}, {}, 
    {Hue[0.4], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.3700060514011758}, {1., 
       0.2568975648749441}}]}}}, {{}, {}, 
    {Hue[0.30000000000000004`], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -1.7165168121457226`}, {
       1., -0.2293963409720745}}]}}}, {{}, {}, 
    {Hue[0.2], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.372592058493197}, {1., 
       0.03972987460748367}}]}}}, {{}, {}, 
    {Hue[0.1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.13664143282798147`}, {
       1., -0.21152664668211196`}}]}}}, {{}, {}, 
    {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.1010113558411394}, {1., 
       1.2741950479030404`}}]}}}, {{}, {}, 
    {Hue[0.9], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.7031716594361956}, {
       1., -0.4127187338428353}}]}}}, {{}, {}, 
    {Hue[0.8], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -2.040212176564956}, {
       1., -1.2952667538439235`}}]}}}, {{}, {}, 
    {Hue[0.7000000000000001], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -1.365050470016305}, {
       1., -0.1528693876397904}}]}}}, {{}, {}, 
    {Hue[0.6], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.04227212767594857}, {1., 
       0.06422720965410722}}]}}}, {{}, {}, 
    {Hue[0.5], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.0516383494021575}, {1., 
       0.6343772101111966}}]}}}, {{}, {}, 
    {Hue[0.4], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -1.3081229258078952`}, {
       1., -1.4467877797589574`}}]}}}, {{}, {}, 
    {Hue[0.30000000000000004`], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.9344552846862566}, {
       1., -1.0889033744520722`}}]}}}, {{}, {}, 
    {Hue[0.2], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 1.5132335571675606`}, {1., 
       1.7078643012918513`}}]}}}, {{}, {}, 
    {Hue[0.1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.9163039229545173}, {1., -0.01816731645182923}}]}}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.459827873013823*^9, {3.460113055090554*^9, 3.460113095483087*^9}, 
   3.460113273581389*^9, {3.460113964976376*^9, 3.4601139901177692`*^9}, 
   3.460114033131361*^9, {3.460114150107635*^9, 3.460114164412263*^9}, 
   3.460114235720495*^9, 3.460114305171029*^9, {3.460120930436802*^9, 
   3.460120988296579*^9}, 3.460197819516024*^9, 3.460198382848845*^9, 
   3.4601985329563026`*^9, 3.4601995270581903`*^9, 3.460199655234778*^9, 
   3.460200501606188*^9, 3.460200601492147*^9, 3.460201879429142*^9, 
   3.460263155619897*^9, 3.460270474422586*^9, 3.460279155040721*^9, 
   3.460279214531389*^9, 3.460281725875258*^9, 3.460284359234613*^9, 
   3.4602847538095922`*^9, 3.460285737715163*^9, 3.460285990939274*^9, 
   3.4602862733933067`*^9, 3.460286308282538*^9, 3.460363898395814*^9, 
   3.460364466117779*^9, 3.4603666232531223`*^9, 3.460369743455418*^9, {
   3.460370031100134*^9, 3.460370040128583*^9}, 3.4603703425836487`*^9, {
   3.460371530559222*^9, 3.460371545091758*^9}, 3.4603715986232557`*^9, 
   3.460373545549732*^9, 3.460377044924808*^9, 3.460377179522697*^9, 
   3.460377259356626*^9, 3.460377666635418*^9, {3.4604274573851433`*^9, 
   3.4604274826315393`*^9}, 3.460431486420775*^9, 3.460431951982443*^9, 
   3.460432442105898*^9, 3.460432915923843*^9, 3.460433083188562*^9, 
   3.460433121276486*^9, 3.460434371750841*^9, 3.460434579330331*^9, 
   3.460434979549678*^9, 3.4604351320544157`*^9, 3.460437047500869*^9, 
   3.460437554166368*^9, 3.4604377000545588`*^9, 3.4604389249118958`*^9, 
   3.460439049759118*^9, 3.460439356387733*^9, 3.460439855697237*^9, 
   3.46044036838757*^9, 3.460444576617157*^9, 3.460444773535759*^9, 
   3.460444941960794*^9, 3.460444998952558*^9, 3.4604591019466887`*^9, 
   3.460459450661531*^9, 3.460460041769643*^9, 3.460460127257649*^9, 
   3.460460807831476*^9, 3.4607219385833406`*^9, 3.4607226274349327`*^9, 
   3.4607749581309834`*^9, {3.460774988718501*^9, 3.460775013027956*^9}, 
   3.46077567107047*^9, 3.460794321343745*^9, 3.4607951163861427`*^9, 
   3.460801546038229*^9, {3.460801599219322*^9, 3.460801608462143*^9}, 
   3.460801650466816*^9, {3.460802003396546*^9, 3.460802020149487*^9}, 
   3.4608020805256367`*^9, 3.460861306263372*^9, 3.460892847303982*^9}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.16331044431608274`}, {1., 
       0.24158904950299878`}}]}}}, {{}, {}, 
    {Hue[0.9], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -1.9024260109848372`}, {
       1., -4.577306852383316}}]}}}, {{}, {}, 
    {Hue[0.8], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.31569397924174813`}, {1., 
       1.2561045794566605`}}]}}}, {{}, {}, 
    {Hue[0.7000000000000001], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.1062144278565599}, {
       1., -2.344273446559722}}]}}}, {{}, {}, 
    {Hue[0.6], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.7401945664779092}, {1., 
       0.6954714522151194}}]}}}, {{}, {}, 
    {Hue[0.5], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.3204618577244954}, {
       1., -3.504104223413986}}]}}}, {{}, {}, 
    {Hue[0.4], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.41539348712586127`}, {
       1., -3.2101260406831975`}}]}}}, {{}, {}, 
    {Hue[0.30000000000000004`], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.11755585718305658`}, {1., 
       0.6410552202963153}}]}}}, {{}, {}, 
    {Hue[0.2], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.7085149288456514}, {1., 
       0.31014352577451426`}}]}}}, {{}, {}, 
    {Hue[0.1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.027095634070878505`}, {
       1., -0.4393346306584965}}]}}}, {{}, {}, 
    {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 8.36035839793744}, {1., 
       0.10531570308611186`}}]}}}, {{}, {}, 
    {Hue[0.9], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.4920407313793702}, {1., 
       0.8091771622863534}}]}}}, {{}, {}, 
    {Hue[0.8], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -8.85257523047291}, {
       1., -28.013411148317353`}}]}}}, {{}, {}, 
    {Hue[0.7000000000000001], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.27482866853903254`}, {1., 
       0.8901013223174044}}]}}}, {{}, {}, 
    {Hue[0.6], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.1589651383967176}, {1., 
       0.5118668727857038}}]}}}, {{}, {}, 
    {Hue[0.5], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.06615939039743456}, {1., 
       0.22529102437993648`}}]}}}, {{}, {}, 
    {Hue[0.4], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.47511067401365126`}, {
       1., -11.272039967528995`}}]}}}, {{}, {}, 
    {Hue[0.30000000000000004`], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.18135704778472375`}, {
       1., -0.5539883519356288}}]}}}, {{}, {}, 
    {Hue[0.2], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.030034723090191395`}, {1., 
       0.2766587127100336}}]}}}, {{}, {}, 
    {Hue[0.1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.06650230986090083}, {1., 
       0.4637445083424453}}]}}}, {{}, {}, 
    {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.37962647788614595`}, {1., 
       0.3931852500998263}}]}}}, {{}, {}, 
    {Hue[0.9], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.042798397680071446`}, {1., 
       0.0571986254924452}}]}}}, {{}, {}, 
    {Hue[0.8], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.17301326592976563`}, {1., 
       0.02325863494139324}}]}}}, {{}, {}, 
    {Hue[0.7000000000000001], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.3588259637200597}, {1., 
       0.36635034645907005`}}]}}}, {{}, {}, 
    {Hue[0.6], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.3334448199888894}, {
       1., -0.17438462302234756`}}]}}}, {{}, {}, 
    {Hue[0.5], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.27182195465251746`}, {
       1., -0.888761378684181}}]}}}, {{}, {}, 
    {Hue[0.4], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -3.7596718239010563`}, {
       1., -24.200952995650198`}}]}}}, {{}, {}, 
    {Hue[0.30000000000000004`], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.6689717679862257}, {
       1., -0.037849731207946435`}}]}}}, {{}, {}, 
    {Hue[0.2], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 2.0376124765230714`}, {1., 
       0.19056831254802442`}}]}}}, {{}, {}, 
    {Hue[0.1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.07889087990385335}, {
       1., -0.22377236732540556`}}]}}}, {{}, {}, 
    {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.99339422398807}, {
       1., -0.44560445250716574`}}]}}}, {{}, {}, 
    {Hue[0.9], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.30445249932179863`}, {
       1., -0.49971407497401177`}}]}}}, {{}, {}, 
    {Hue[0.8], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.5524700461096991}, {1., 
       0.2504762584239649}}]}}}, {{}, {}, 
    {Hue[0.7000000000000001], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.004706419202464118}, {1., 
       0.3192195290519969}}]}}}, {{}, {}, 
    {Hue[0.6], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.44775461594055127`}, {1., 
       0.3678715547095395}}]}}}, {{}, {}, 
    {Hue[0.5], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 2.9902660157714407`}, {1., 
       17.07583345294659}}]}}}, {{}, {}, 
    {Hue[0.4], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.27104949131161477`}, {1., 
       0.13573961512453958`}}]}}}, {{}, {}, 
    {Hue[0.30000000000000004`], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 3.8012015092974862`}, {1., 
       0.015593127070639395`}}]}}}, {{}, {}, 
    {Hue[0.2], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.18119063588156986`}, {1., 
       0.2891443942575295}}]}}}, {{}, {}, 
    {Hue[0.1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.6058579248545801}, {
       1., -0.4356731793695501}}]}}}, {{}, {}, 
    {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.05216634711211657}, {
       1., -1.22721748174143}}]}}}, {{}, {}, 
    {Hue[0.9], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.9762831962434353}, {
       1., -0.8183252354684216}}]}}}, {{}, {}, 
    {Hue[0.8], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 6.939383778815693}, {1., 
       0.5296979366536949}}]}}}, {{}, {}, 
    {Hue[0.7000000000000001], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.8206002791478495}, {
       1., -0.448518468237541}}]}}}, {{}, {}, 
    {Hue[0.6], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.0009564733581090973}, {1., 
       0.225162046263855}}]}}}, {{}, {}, 
    {Hue[0.5], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.6524614082039999}, {1., 
       0.4373100577069961}}]}}}, {{}, {}, 
    {Hue[0.4], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.7417752441226461}, {1., 
       1.6664714772436684`}}]}}}, {{}, {}, 
    {Hue[0.30000000000000004`], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.23827644629832817`}, {1., 
       0.20370951770030152`}}]}}}, {{}, {}, 
    {Hue[0.2], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -2.1403485512082234`}, {
       1., -3.779345838076979}}]}}}, {{}, {}, 
    {Hue[0.1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.11567026248839957`}, {1., -0.1178902499703703}}]}}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0.17},
  DisplayFunction->Identity,
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.459827873013823*^9, {3.460113055090554*^9, 3.460113095483087*^9}, 
   3.460113273581389*^9, {3.460113964976376*^9, 3.4601139901177692`*^9}, 
   3.460114033131361*^9, {3.460114150107635*^9, 3.460114164412263*^9}, 
   3.460114235720495*^9, 3.460114305171029*^9, {3.460120930436802*^9, 
   3.460120988296579*^9}, 3.460197819516024*^9, 3.460198382848845*^9, 
   3.4601985329563026`*^9, 3.4601995270581903`*^9, 3.460199655234778*^9, 
   3.460200501606188*^9, 3.460200601492147*^9, 3.460201879429142*^9, 
   3.460263155619897*^9, 3.460270474422586*^9, 3.460279155040721*^9, 
   3.460279214531389*^9, 3.460281725875258*^9, 3.460284359234613*^9, 
   3.4602847538095922`*^9, 3.460285737715163*^9, 3.460285990939274*^9, 
   3.4602862733933067`*^9, 3.460286308282538*^9, 3.460363898395814*^9, 
   3.460364466117779*^9, 3.4603666232531223`*^9, 3.460369743455418*^9, {
   3.460370031100134*^9, 3.460370040128583*^9}, 3.4603703425836487`*^9, {
   3.460371530559222*^9, 3.460371545091758*^9}, 3.4603715986232557`*^9, 
   3.460373545549732*^9, 3.460377044924808*^9, 3.460377179522697*^9, 
   3.460377259356626*^9, 3.460377666635418*^9, {3.4604274573851433`*^9, 
   3.4604274826315393`*^9}, 3.460431486420775*^9, 3.460431951982443*^9, 
   3.460432442105898*^9, 3.460432915923843*^9, 3.460433083188562*^9, 
   3.460433121276486*^9, 3.460434371750841*^9, 3.460434579330331*^9, 
   3.460434979549678*^9, 3.4604351320544157`*^9, 3.460437047500869*^9, 
   3.460437554166368*^9, 3.4604377000545588`*^9, 3.4604389249118958`*^9, 
   3.460439049759118*^9, 3.460439356387733*^9, 3.460439855697237*^9, 
   3.46044036838757*^9, 3.460444576617157*^9, 3.460444773535759*^9, 
   3.460444941960794*^9, 3.460444998952558*^9, 3.4604591019466887`*^9, 
   3.460459450661531*^9, 3.460460041769643*^9, 3.460460127257649*^9, 
   3.460460807831476*^9, 3.4607219385833406`*^9, 3.4607226274349327`*^9, 
   3.4607749581309834`*^9, {3.460774988718501*^9, 3.460775013027956*^9}, 
   3.46077567107047*^9, 3.460794321343745*^9, 3.4607951163861427`*^9, 
   3.460801546038229*^9, {3.460801599219322*^9, 3.460801608462143*^9}, 
   3.460801650466816*^9, {3.460802003396546*^9, 3.460802020149487*^9}, 
   3.4608020805256367`*^9, 3.460861306263372*^9, 3.460892847637868*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ML-Sch\[ADoubleDot]tzung", "Subsection",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["Lik - Oberfl\[ADoubleDot]che", "Subsubsection",
 CellChangeTimes->{{3.460364529885599*^9, 3.460364541900496*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Y", "//", "Dimensions"}]], "Input",
 CellChangeTimes->{{3.460800890148888*^9, 3.460800895974749*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"50", ",", "2"}], "}"}]], "Output",
 CellChangeTimes->{3.460800896678214*^9, 3.460810789563863*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"l0", "[", "1", "]"}], "\[IndentingNewLine]", 
 RowBox[{"l1", "[", "1", "]"}], "\[IndentingNewLine]", 
 RowBox[{"l2", "[", "1", "]"}]}], "Input",
 CellChangeTimes->{{3.4607223323764353`*^9, 3.460722337656382*^9}, {
   3.4607226712747793`*^9, 3.4607226714880753`*^9}, {3.460775129808877*^9, 
   3.46077512987789*^9}, {3.460795661122266*^9, 3.4607956729433813`*^9}, {
   3.460800986666732*^9, 3.460800992571142*^9}, 3.460801041156788*^9, {
   3.460810799563031*^9, 3.460810804601367*^9}}],

Cell[BoxData[
 RowBox[{"-", "129.3735476308041`"}]], "Output",
 CellChangeTimes->{3.4608013073472958`*^9, 3.460801493659738*^9, 
  3.460801761340925*^9, 3.460802121542934*^9, 3.460809976789194*^9, 
  3.4608108079441347`*^9}],

Cell[BoxData[
 RowBox[{"-", "134.3445353709414`"}]], "Output",
 CellChangeTimes->{3.4608013073472958`*^9, 3.460801493659738*^9, 
  3.460801761340925*^9, 3.460802121542934*^9, 3.460809976789194*^9, 
  3.46081081099333*^9}],

Cell[BoxData[
 RowBox[{"-", "160.42302639704408`"}]], "Output",
 CellChangeTimes->{3.4608013073472958`*^9, 3.460801493659738*^9, 
  3.460801761340925*^9, 3.460802121542934*^9, 3.460809976789194*^9, 
  3.4608108131073923`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pp", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m", "=", "50"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l2", "=", 
   RowBox[{
    RowBox[{"IndividualLikNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Y", ",", "X", ",", 
        RowBox[{"-", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"#", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"IdioNonlin", ",", 
        RowBox[{"{", "}"}], ",", "m", ",", 
        RowBox[{"eps", "=", 
         RowBox[{"10.", "^", 
          RowBox[{"-", "16"}]}]}], ",", 
        RowBox[{"ksigma", "=", "Infinity"}], ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular", "=", "False"}], ",", 
        RowBox[{"2", "Pi"}], " ", ",", "0", ",", "0", ",", "\"\<EKF\>\""}], 
       "}"}]}], "]"}], "&"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l1", "=", 
   RowBox[{
    RowBox[{"IndividualLikNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Y", ",", "X", ",", 
        RowBox[{"-", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"#", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"IdioNonlin", ",", 
        RowBox[{"{", "}"}], ",", "m", ",", 
        RowBox[{"eps", "=", 
         RowBox[{"10.", "^", 
          RowBox[{"-", "16"}]}]}], ",", 
        RowBox[{"ksigma", "=", "Infinity"}], ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular", "=", "False"}], ",", 
        RowBox[{"2", "Pi"}], " ", ",", "0", ",", "0", ",", 
        "\"\<StochLin\>\""}], "}"}]}], "]"}], "&"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l0", "=", 
   RowBox[{
    RowBox[{"IndividualLikNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Y", ",", "X", ",", 
        RowBox[{"-", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"#", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"IdioNonlin", ",", 
        RowBox[{"{", "}"}], ",", "m", ",", 
        RowBox[{"eps", "=", 
         RowBox[{"10.", "^", 
          RowBox[{"-", "16"}]}]}], ",", 
        RowBox[{"ksigma", "=", "Infinity"}], ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular", "=", "False"}], ",", 
        RowBox[{"2", "Pi"}], " ", ",", "0", ",", "0", ",", 
        "\"\<NorKorr\>\""}], "}"}]}], "]"}], "&"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"llin", "=", "         ", 
    RowBox[{
     RowBox[{"IndividualLik", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y", ",", "X", ",", 
         RowBox[{"-", "9"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"#", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"Idio", ",", 
         RowBox[{"{", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", "=", "False"}], ",", 
         RowBox[{"2", "Pi"}], " ", ",", "0"}], "}"}]}], "]"}], "&"}]}], ";"}],
   "\[IndentingNewLine]"}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"l0", "[", "x", "]"}], ",", 
     RowBox[{"l1", "[", "x", "]"}], ",", 
     RowBox[{"l2", "[", "x", "]"}], ",", " ", 
     RowBox[{"llin", "[", "x", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "4"}], "}"}], ",", 
   RowBox[{"PlotPoints", "\[Rule]", "30"}], ",", 
   RowBox[{"MaxRecursion", "\[Rule]", "0"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.460364582260192*^9, 3.4603646126520233`*^9}, {
   3.46036465518178*^9, 3.460364686245573*^9}, {3.460366575620988*^9, 
   3.460366577034412*^9}, {3.460369778180625*^9, 3.460369781185903*^9}, {
   3.460369813100584*^9, 3.460369815667145*^9}, {3.460369899141048*^9, 
   3.460369901845244*^9}, {3.460370048351585*^9, 3.460370051074534*^9}, {
   3.460370210982068*^9, 3.460370313679085*^9}, {3.4603703667001543`*^9, 
   3.46037042873845*^9}, {3.460371656197792*^9, 3.460371665219153*^9}, {
   3.4603770592671013`*^9, 3.460377059329007*^9}, {3.460378198442006*^9, 
   3.460378213066311*^9}, {3.460435573037374*^9, 3.460435595252637*^9}, {
   3.460437792675404*^9, 3.46043782170634*^9}, {3.460437942682435*^9, 
   3.4604379557884283`*^9}, {3.460438031359991*^9, 3.460438033910181*^9}, {
   3.460438120088056*^9, 3.460438151233536*^9}, {3.460438297231896*^9, 
   3.460438301076235*^9}, {3.460438342395988*^9, 3.460438352382413*^9}, {
   3.460438790848688*^9, 3.460438792927885*^9}, {3.460439368962564*^9, 
   3.4604393693819513`*^9}, {3.460439888830337*^9, 3.460439923834778*^9}, {
   3.460459119343028*^9, 3.460459128428997*^9}, {3.460460010239758*^9, 
   3.460460021008594*^9}, {3.460462070763579*^9, 3.46046210747972*^9}, {
   3.46046218928576*^9, 3.460462192656451*^9}, 3.460462308980558*^9, {
   3.460462691161005*^9, 3.460462693314562*^9}, {3.4604627579016047`*^9, 
   3.4604628925310507`*^9}, {3.460722305186233*^9, 3.460722309185562*^9}, {
   3.460722368526821*^9, 3.4607223969205847`*^9}, {3.4607224312016563`*^9, 
   3.4607224323927298`*^9}, {3.460722711321816*^9, 3.460722711373019*^9}, {
   3.4607750530888033`*^9, 3.460775088314494*^9}, {3.460775120467861*^9, 
   3.460775162127316*^9}, 3.4607757020852413`*^9, {3.460775734635962*^9, 
   3.460775741929165*^9}, {3.4607757777161493`*^9, 3.460775777778207*^9}, {
   3.4607758096383142`*^9, 3.460775812088019*^9}, {3.460775870805806*^9, 
   3.460775888373221*^9}, {3.460795055640492*^9, 3.46079508216168*^9}, {
   3.460795160922982*^9, 3.460795321456018*^9}, {3.460795362107229*^9, 
   3.4607953627366257`*^9}, {3.4607963441878967`*^9, 3.460796344251252*^9}, {
   3.4608000805592823`*^9, 3.460800080643939*^9}, {3.4608001156311207`*^9, 
   3.460800116809667*^9}, {3.460800553505842*^9, 3.460800554580531*^9}, {
   3.4608007472554092`*^9, 3.460800765935514*^9}, {3.460800901633608*^9, 
   3.460800916942192*^9}, {3.460800953467207*^9, 3.46080095393979*^9}, {
   3.46080115178001*^9, 3.460801151860321*^9}, {3.460801775013801*^9, 
   3.460801790465601*^9}, {3.460809983936933*^9, 3.460809984051609*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwB8QEO/iFib1JlAgAAAB4AAAACAAAAIkWa3///B8BM3QWL1yNpwH4l4naJ
JAbAgBPQKKHLaMDWUdrCFCEEwDGvNpQfyGfAmGznmsg/AsCUR7lyPttmwErq
52HtZwDAErbCBWSBZcDwZzG7J9D8v2o0awEcx2TAH9i8ysUU+b9NuJQt0OVk
wEfgqENnCfW/Ai2Mj4aHZMBPrnua6hDxv3t9rtOeb2LAVbLwEn656r+XWh+u
TW5jwP43q8MtseK/LHffgFMWYcCc7nJJ/2LWvzbka7/C4l7A8BKqDKq8vr+Z
0dUpCFtiwIIKNzs5icA/crk42446Y8DvG7pdHyfXP5cKOVjvgF3AXSkrPMqk
4z91+TU+LW1hwAO5qw1BkOs/qiTkbi63YcCBR2zXinnxPzgCT5BMC2DAiBqi
vvF69T+oj7TQHaZgwLsQro0HOPk/LnXM0sxLYsD2blnzGUX9P9pDB/LoDGLA
qAOPPaWfAEDgSRrEp+tiwGthXPWUegJA44SRZluqZMAyc3n4gn0EQCvY+boN
gmXAj5aBb0heBkBCXOy3HdhlwPxWlvecNQhA6pxJtZzZZ8Bty/rK7zQKQBqd
qK8/d2nAdFFKEhoSDEB/jFuvtYRqwH6L6aRCFw5AOF4NaXKPbcAiRZrf//8P
QAjNinNqgG3AgYfy7g==
     "]]}, 
   {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwB8QEO/iFib1JlAgAAAB4AAAACAAAAIkWa3///B8DhAq3ewXJpwH4l4naJ
JAbAAqu7WJ+raMDWUdrCFCEEwDYqD2yK0WfAmGznmsg/AsD4iCQwlwlmwErq
52HtZwDAALJchfKSZcDwZzG7J9D8v4UJto7B9WTAH9i8ysUU+b+Uox4UuGpm
wEfgqENnCfW/pHw/vg8AY8BPrnua6hDxv2bedHVS0GHAVbLwEn656r8xULpK
B3phwP43q8MtseK/+tgyv/pVYsCc7nJJ/2LWv8i9KklENWLA8BKqDKq8vr+g
ea/qqxpjwIIKNzs5icA/LWfWHFH/YcDvG7pdHyfXP/yyiGwS8V/AXSkrPMqk
4z9g0UyCKxthwAO5qw1BkOs/cEPqNiGNYcCBR2zXinnxP7Xe4sflBWDAiBqi
vvF69T/07dt0L1JiwLsQro0HOPk/gxTwOFO3Y8D2blnzGUX9PwzKc6ijJWLA
qAOPPaWfAEBMi6CTyhVkwGthXPWUegJAeMl2tIDNY8Ayc3n4gn0EQDhbcBbx
xGXAj5aBb0heBkB6s+o0F+dlwPxWlvecNQhACUxVBwPKZ8Bty/rK7zQKQDAC
BBxM02jAdFFKEhoSDEDHL+dA+OJpwH6L6aRCFw5AnmuWxiJba8AiRZrf//8P
QEgq5n5hOG3AbIzzCQ==
     "]]}, 
   {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJwB8QEO/iFib1JlAgAAAB4AAAACAAAAIkWa3///B8CWftRbJn9qwH4l4naJ
JAbAFN6vfmJWbMDWUdrCFCEEwKnzM/J6WGrAmGznmsg/AsDQJIMQVU5mwErq
52HtZwDALLVVssgkZcDwZzG7J9D8v+l5cLxP5WXAH9i8ysUU+b8Yz962ENRk
wEfgqENnCfW/0m9U7YPHZ8BPrnua6hDxv2cyJriHwWPAVbLwEn656r9yZJDO
5exjwP43q8MtseK/PdMwIM7MX8Cc7nJJ/2LWvybSQSt/f2HA8BKqDKq8vr+M
O8cInIpgwIIKNzs5icA//q/HAneQYMDvG7pdHyfXP0yih9Z6Y2DAXSkrPMqk
4z+qJqZ1CBpiwAO5qw1BkOs/M83VMpaJYcCBR2zXinnxP034B+IvOWPAiBqi
vvF69T/r9+MHqYtiwLsQro0HOPk/0IM676YyYsD2blnzGUX9P0ITBlqPgWLA
qAOPPaWfAEB28jj9yB5jwGthXPWUegJA2HR5oM5xZMAyc3n4gn0EQAQdI+6S
32XAj5aBb0heBkBfHbtDi1xpwPxWlvecNQhAXj05LpeOaMBty/rK7zQKQFt8
D0/g9WjAdFFKEhoSDEBowQK4kBdrwH6L6aRCFw5ARLVFoWMjbcAiRZrf//8P
QBH96s8UJW7AN8z0hg==
     "]]}, 
   {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["
1:eJwB8QEO/iFib1JlAgAAAB4AAAACAAAAIkWa3///B8AiVCMGwr52wH4l4naJ
JAbASK3qkPCIdsDWUdrCFCEEwLdkhpQRRXbAmGznmsg/AsA8OalMq/t1wErq
52HtZwDAinY6u2SpdcDwZzG7J9D8vxR9p/TMQ3XAH9i8ysUU+b/SITpvAdl0
wEfgqENnCfW/B006OFlYdMBPrnua6hDxv/TdEMTjzXPAVbLwEn656r8elo8o
hkNzwP43q8MtseK/nke9XyymcsCc7nJJ/2LWv+T0Zi27D3LA8BKqDKq8vr/P
YuRAlnxxwIIKNzs5icA/g3OJMrjhcMDvG7pdHyfXP/T8+5TBWXDAXSkrPMqk
4z+WRCALeadvwAO5qw1BkOs/WpVOIMjBbsCBR2zXinnxP6xb4K04DW7AiBqi
vvF69T/2vxCe/W9twLsQro0HOPk/1gcqKV4BbcD2blnzGUX9PxjNBN0Kr2zA
qAOPPaWfAEA2XNcnFYFswGthXPWUegJAuFVEBuZxbMAyc3n4gn0EQF9La22M
e2zAj5aBb0heBkDOsk/6TplswPxWlvecNQhAfpFQXZXGbMBty/rK7zQKQMuh
DW5PBm3AdFFKEhoSDEBsCdRIqExtwH6L6aRCFw5ADPKSKwCibcAiRZrf//8P
QBCxy4Yn+W3AwMTyww==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, -350.},
  Frame->True,
  PlotRange->{{-2.9999997586206897`, 
   3.9999997586206897`}, {-363.92236913490535`, -118.01460843630262`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{
  3.4603646404762897`*^9, 3.460364699141284*^9, {3.4603665639353447`*^9, 
   3.460366581063609*^9}, 3.460366633087812*^9, {3.460369659325509*^9, 
   3.460369665763332*^9}, 3.460369753864559*^9, 3.460369793388811*^9, 
   3.460369836877985*^9, 3.4603699414758453`*^9, 3.460370068395872*^9, 
   3.4603701665431347`*^9, {3.460370200393096*^9, 3.460370433322517*^9}, 
   3.460371569389784*^9, 3.460371630508395*^9, 3.4603716899665337`*^9, 
   3.460373567149763*^9, 3.460377060868331*^9, 3.4603771844497547`*^9, 
   3.4603772624878073`*^9, 3.460377669576057*^9, {3.460378194693892*^9, 
   3.4603782209413853`*^9}, 3.460431915408856*^9, 3.460431970723423*^9, 
   3.460432459979088*^9, 3.460432933635795*^9, 3.460434602602409*^9, 
   3.460435024282065*^9, 3.460435173021772*^9, 3.460435614824098*^9, 
   3.460437075408433*^9, 3.4604375668411837`*^9, 3.460437764211752*^9, 
   3.460438003600037*^9, 3.4604380498120193`*^9, 3.4604381267513323`*^9, 
   3.4604381572691717`*^9, 3.4604383035716963`*^9, 3.460438368055724*^9, 
   3.460438890192803*^9, 3.460438928779546*^9, 3.4604390596546497`*^9, 
   3.460439326285445*^9, {3.4604393591643133`*^9, 3.46043937775913*^9}, {
   3.460439876738007*^9, 3.460439937461564*^9}, 3.460440432214779*^9, 
   3.460441801623301*^9, {3.460459115956283*^9, 3.460459131804435*^9}, 
   3.460459457197721*^9, {3.4604600052420063`*^9, 3.460460050251873*^9}, 
   3.460460136725589*^9, {3.460462096012589*^9, 3.4604621177314463`*^9}, 
   3.460462195669779*^9, 3.460462312739161*^9, {3.4604628192627077`*^9, 
   3.4604629007734118`*^9}, 3.460721958185533*^9, 3.4607222745794353`*^9, 
   3.4607223270755167`*^9, 3.460722682802968*^9, 3.4607227524302464`*^9, 
   3.460775037533073*^9, {3.460775069089115*^9, 3.460775095398562*^9}, {
   3.460775149470006*^9, 3.460775166398638*^9}, {3.460775680639656*^9, 
   3.460775707725068*^9}, {3.460775747152223*^9, 3.46077578147184*^9}, {
   3.460775825052527*^9, 3.460775892090784*^9}, 3.460794334408423*^9, {
   3.460795060288437*^9, 3.460795087336123*^9}, 3.460795126636435*^9, {
   3.4607951722227983`*^9, 3.460795325836775*^9}, 3.4607953673125277`*^9, 
   3.460795650330174*^9, 3.460795881185608*^9, {3.460796289272408*^9, 
   3.460796313227943*^9}, 3.460796353233102*^9, {3.4608000618575363`*^9, 
   3.460800091835527*^9}, 3.460800132023862*^9, 3.460800573281756*^9, 
   3.460800753834125*^9, 3.460800813418141*^9, {3.460800909499584*^9, 
   3.460800928931656*^9}, 3.4608009793519773`*^9, 3.460801163467443*^9, 
   3.460801748373828*^9, 3.460801784754333*^9, 3.460801818200878*^9, 
   3.4608021129330597`*^9, 3.460809956086197*^9, 3.4608102613999*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["ML", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[{"Theta", "\[IndentingNewLine]", 
 RowBox[{"Y", "[", 
  RowBox[{"[", "12", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.460427516601119*^9, 3.460427517953906*^9}, {
   3.4604302860648613`*^9, 3.460430286459763*^9}, 3.4604320351169157`*^9, {
   3.460459207514338*^9, 3.460459209125545*^9}, {3.4608083350507927`*^9, 
   3.460808343160981*^9}, {3.4608930848269987`*^9, 3.460893084962487*^9}}],

Cell[BoxData[
 RowBox[{"{", "0.5`", "}"}]], "Output",
 CellChangeTimes->{{3.460444788235248*^9, 3.460444817682623*^9}, 
   3.4604450103485413`*^9, 3.460459143269252*^9, 3.4604592096793203`*^9, 
   3.460459927811483*^9, 3.46046040805451*^9, 3.460461792764674*^9, 
   3.460722834150064*^9, 3.460775197926738*^9, 3.460800148785144*^9, 
   3.4608018347272587`*^9, 3.460802129040563*^9, 3.460808343277852*^9, 
   3.4608613186180477`*^9, 3.4608928803725977`*^9, {3.460893086014701*^9, 
   3.460893108154195*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "0.4920407313793702`"}], ",", "0.8091771622863534`"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.460444788235248*^9, 3.460444817682623*^9}, 
   3.4604450103485413`*^9, 3.460459143269252*^9, 3.4604592096793203`*^9, 
   3.460459927811483*^9, 3.46046040805451*^9, 3.460461792764674*^9, 
   3.460722834150064*^9, 3.460775197926738*^9, 3.460800148785144*^9, 
   3.4608018347272587`*^9, 3.460802129040563*^9, 3.460808343277852*^9, 
   3.4608613186180477`*^9, 3.4608928803725977`*^9, {3.460893086014701*^9, 
   3.460893108164637*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pp", "=", "1"}], ";", 
  RowBox[{"nn", "=", "12"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m", "=", "100"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"scaling", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"IndividualLikNonlin", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Y", "[", 
      RowBox[{"[", 
       RowBox[{"{", "nn", "}"}], "]"}], "]"}], ",", "X", ",", "miss"}], "}"}],
    ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"IdioNonlin", ",", 
     RowBox[{"{", "}"}], ",", "m", ",", 
     RowBox[{"eps", "=", 
      RowBox[{"10.", "^", 
       RowBox[{"-", "16"}]}]}], ",", 
     RowBox[{"ksigma", "=", "Infinity"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0", ",", "0", ",", "\"\<NorKorr\>\""}], 
    "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"IndividualLikNonlin", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Y", "[", 
      RowBox[{"[", 
       RowBox[{"{", "nn", "}"}], "]"}], "]"}], ",", "X", ",", "miss"}], "}"}],
    ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"IdioNonlin", ",", 
     RowBox[{"{", "}"}], ",", "m", ",", 
     RowBox[{"eps", "=", 
      RowBox[{"10.", "^", 
       RowBox[{"-", "16"}]}]}], ",", 
     RowBox[{"ksigma", "=", "Infinity"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0", ",", "0", ",", "\"\<StochLin\>\"", 
     ",", "Automatic"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"IndividualLikNonlin", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Y", "[", 
      RowBox[{"[", 
       RowBox[{"{", "nn", "}"}], "]"}], "]"}], ",", "X", ",", "miss"}], "}"}],
    ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"IdioNonlin", ",", 
     RowBox[{"{", "}"}], ",", "m", ",", 
     RowBox[{"eps", "=", 
      RowBox[{"10.", "^", 
       RowBox[{"-", "16"}]}]}], ",", 
     RowBox[{"ksigma", "=", "Infinity"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0", ",", "0", ",", "\"\<EKF\>\"", ",", 
     "Automatic"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.460264864897327*^9, 3.460264932378791*^9}, {
   3.460265489300803*^9, 3.460265492492799*^9}, {3.46027038606568*^9, 
   3.460270391802556*^9}, {3.4602704971596107`*^9, 3.4602705817118692`*^9}, {
   3.46027367414145*^9, 3.460273674236417*^9}, {3.460279775378045*^9, 
   3.4602797754444103`*^9}, {3.4602799530257587`*^9, 
   3.4602799533811693`*^9}, {3.460280067013379*^9, 3.460280067130088*^9}, {
   3.4602801040742397`*^9, 3.460280104129944*^9}, {3.4602801453821163`*^9, 
   3.4602801673531218`*^9}, {3.46028174693688*^9, 3.460281763776168*^9}, {
   3.4602818356559362`*^9, 3.460281835739462*^9}, {3.460281898670804*^9, 
   3.460281898732609*^9}, {3.460282025318959*^9, 3.460282025741701*^9}, {
   3.460282062175247*^9, 3.460282071535883*^9}, {3.460283778391947*^9, 
   3.4602837888805027`*^9}, {3.4602838305963707`*^9, 3.460283854615387*^9}, {
   3.46028477341341*^9, 3.460284779157151*^9}, {3.460285035206752*^9, 
   3.460285046973556*^9}, {3.46028555906642*^9, 3.460285574425418*^9}, {
   3.4602857519094887`*^9, 3.4602857519715776`*^9}, {3.460285881590439*^9, 
   3.4602858816380377`*^9}, {3.460286117999454*^9, 3.460286123654068*^9}, {
   3.4602863340289307`*^9, 3.4602863377475977`*^9}, {3.4603641927287188`*^9, 
   3.460364197580667*^9}, {3.460365058304535*^9, 3.4603650587979116`*^9}, {
   3.460365091217347*^9, 3.460365126318194*^9}, {3.4603652464521227`*^9, 
   3.460365260029804*^9}, {3.460365412299954*^9, 3.460365434375272*^9}, {
   3.460365485584791*^9, 3.460365520950554*^9}, {3.460366663535665*^9, 
   3.460366678997499*^9}, {3.4603667867732773`*^9, 3.4603667868283587`*^9}, {
   3.460367092714067*^9, 3.460367098883337*^9}, {3.460369235357655*^9, 
   3.460369263924768*^9}, {3.460369362646221*^9, 3.46036936313859*^9}, {
   3.46036946785526*^9, 3.4603694691077127`*^9}, {3.46037339069245*^9, 
   3.460373390747698*^9}, {3.460373605599341*^9, 3.4603736056503153`*^9}, {
   3.460377091108459*^9, 3.460377126962656*^9}, {3.460377288435691*^9, 
   3.460377301095058*^9}, {3.4603774697122087`*^9, 3.460377479788327*^9}, {
   3.460377585320611*^9, 3.460377603716568*^9}, {3.4603776957101793`*^9, 
   3.460377736561165*^9}, {3.460377923292104*^9, 3.4603779233524303`*^9}, {
   3.460378105932313*^9, 3.46037817981962*^9}, {3.460427531315346*^9, 
   3.460427537420005*^9}, {3.460427638978484*^9, 3.4604276390230217`*^9}, {
   3.4604277414332314`*^9, 3.460427769573126*^9}, {3.4604279604982853`*^9, 
   3.460427960554902*^9}, {3.460430680071252*^9, 3.460430680172152*^9}, {
   3.460430712203142*^9, 3.460430712557424*^9}, {3.460430775931464*^9, 
   3.460430776020101*^9}, {3.460430814349124*^9, 3.460430814950081*^9}, {
   3.46043100067663*^9, 3.460431000775926*^9}, {3.460431035518139*^9, 
   3.460431043615539*^9}, {3.460431139283386*^9, 3.460431139330926*^9}, {
   3.4604311987514153`*^9, 3.460431233744923*^9}, {3.460431314274002*^9, 
   3.460431314321568*^9}, {3.4604316727142878`*^9, 3.4604316728008432`*^9}, {
   3.460431886035831*^9, 3.46043189177104*^9}, {3.460432099991972*^9, 
   3.460432100073539*^9}, {3.460432236204804*^9, 3.4604322362468243`*^9}, {
   3.4604323376555843`*^9, 3.460432357162323*^9}, {3.460432403219545*^9, 
   3.460432403269651*^9}, {3.460432564446265*^9, 3.4604325911495867`*^9}, {
   3.460432813689516*^9, 3.460432813733564*^9}, {3.460432944239506*^9, 
   3.460432989199974*^9}, {3.460433097024789*^9, 3.460433097139295*^9}, {
   3.460433291653358*^9, 3.46043329173923*^9}, {3.460433672964451*^9, 
   3.460433673010107*^9}, {3.460433845665332*^9, 3.4604338457416363`*^9}, {
   3.4604344009903316`*^9, 3.460434401033557*^9}, {3.4604346235115023`*^9, 
   3.460434638473834*^9}, {3.460434675871023*^9, 3.460434675925946*^9}, {
   3.4604350413113747`*^9, 3.4604350414069347`*^9}, {3.460436666989565*^9, 
   3.460436677468376*^9}, {3.460437023691847*^9, 3.460437023772811*^9}, {
   3.460437179838045*^9, 3.460437214787621*^9}, {3.4604373750456057`*^9, 
   3.460437375101828*^9}, {3.460437455923118*^9, 3.4604374559862347`*^9}, {
   3.460437643282413*^9, 3.4604376433404827`*^9}, {3.460439284564681*^9, 
   3.46043929340877*^9}, {3.460439393566842*^9, 3.460439393962884*^9}, {
   3.46044000098571*^9, 3.460440001044331*^9}, {3.460443930270521*^9, 
   3.460443930334333*^9}, {3.460443966799687*^9, 3.46044399790462*^9}, {
   3.460444060284606*^9, 3.460444061730588*^9}, {3.460444101336812*^9, 
   3.46044410138903*^9}, {3.460444186536171*^9, 3.460444194286351*^9}, {
   3.460444233408099*^9, 3.460444248920389*^9}, {3.460444338058318*^9, 
   3.460444355662019*^9}, {3.460444400012597*^9, 3.460444431012135*^9}, {
   3.460444591036777*^9, 3.4604446631572647`*^9}, {3.46044479971354*^9, 
   3.460444799768903*^9}, {3.460444831583193*^9, 3.460444859781989*^9}, {
   3.46044502143334*^9, 3.460445021504759*^9}, {3.460459950502769*^9, 
   3.460459971711813*^9}, {3.460460068419449*^9, 3.460460088588605*^9}, {
   3.460460154598343*^9, 3.46046015516997*^9}, {3.460460281436612*^9, 
   3.460460281521656*^9}, {3.4604604120265713`*^9, 3.460460412125514*^9}, {
   3.4604607607833633`*^9, 3.4604607621971283`*^9}, {3.460460826677142*^9, 
   3.460460827186878*^9}, {3.4604608962826014`*^9, 3.4604608963501987`*^9}, {
   3.460460962965583*^9, 3.460460963358262*^9}, {3.46046100555375*^9, 
   3.4604610220017967`*^9}, {3.46046105589403*^9, 3.460461056004932*^9}, {
   3.460461154113535*^9, 3.460461154227416*^9}, {3.460461800671767*^9, 
   3.4604618154025*^9}, {3.46046184541817*^9, 3.46046186011173*^9}, {
   3.460461896620476*^9, 3.460461896672694*^9}, {3.460461952952413*^9, 
   3.4604619533933907`*^9}, {3.460462913572587*^9, 3.460462920740217*^9}, {
   3.460722765559946*^9, 3.460722812479978*^9}, 3.4607228582030888`*^9, {
   3.460722890758842*^9, 3.460722896366596*^9}, {3.46072298397585*^9, 
   3.4607229875994997`*^9}, {3.460723019415843*^9, 3.460723105990931*^9}, {
   3.460723170191799*^9, 3.460723171657259*^9}, {3.460723268211129*^9, 
   3.460723287189331*^9}, {3.460732937278017*^9, 3.4607329553868093`*^9}, {
   3.460733072671542*^9, 3.460733072733719*^9}, 3.460774164086339*^9, {
   3.460774329652614*^9, 3.4607743297042007`*^9}, {3.4607747308600483`*^9, 
   3.460774745217613*^9}, {3.460774783118621*^9, 3.460774783163679*^9}, {
   3.4607752055171013`*^9, 3.460775330022717*^9}, {3.46077593187556*^9, 
   3.4607759414970217`*^9}, {3.4607760276883583`*^9, 
   3.4607760355817633`*^9}, {3.460790937262329*^9, 3.460790951013814*^9}, {
   3.460791568324353*^9, 3.4607915702816963`*^9}, {3.460793424875643*^9, 
   3.4607934256099787`*^9}, {3.4607936492357063`*^9, 3.460793649286522*^9}, {
   3.460793686024284*^9, 3.460793715536209*^9}, 3.46079539824224*^9, {
   3.4608005873682537`*^9, 3.460800587858807*^9}, {3.460801890378409*^9, 
   3.460801906716531*^9}, {3.460801944252364*^9, 3.460801956112904*^9}, {
   3.4608021446565866`*^9, 3.460802155162537*^9}, {3.460802619088133*^9, 
   3.4608026317097387`*^9}, {3.460802812504952*^9, 3.460802849903359*^9}, {
   3.460802897055272*^9, 3.4608028982176*^9}, {3.460802962963353*^9, 
   3.460802992257814*^9}, {3.460803079615142*^9, 3.4608030796689463`*^9}, {
   3.4608037326935062`*^9, 3.460803732755742*^9}, 3.460803767933199*^9, {
   3.4608038073568907`*^9, 3.4608038074115458`*^9}, {3.460805795204329*^9, 
   3.4608058122906427`*^9}, {3.460806262926772*^9, 3.4608062820694227`*^9}, {
   3.4608068052612143`*^9, 3.460806805624588*^9}, {3.460808488211617*^9, 
   3.460808507424265*^9}, {3.4608086121558113`*^9, 3.4608086125013313`*^9}, {
   3.460808753825961*^9, 3.460808793699284*^9}, {3.460809102803755*^9, 
   3.460809103845994*^9}, 3.4608108610750523`*^9, 3.4608595767679577`*^9, 
   3.4608596094553747`*^9, 3.4608596715556*^9, 3.460861076341893*^9, 
   3.460861205108603*^9, {3.460861386456036*^9, 3.460861399732408*^9}, {
   3.460861431058154*^9, 3.4608614312160883`*^9}, {3.460864060411364*^9, 
   3.4608640905515738`*^9}, {3.4608645383490467`*^9, 3.460864544310871*^9}, {
   3.460864603820335*^9, 3.460864712693082*^9}, {3.4608929239332047`*^9, 
   3.4608929753803177`*^9}, {3.460893111220315*^9, 3.460893111289748*^9}, {
   3.460893217607318*^9, 3.4608932187280493`*^9}, {3.460893250965021*^9, 
   3.460893254523731*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0, 0, 1], PointSize[0.03], Thickness[0.03], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJzt0Xk01Pv/B3A0ItsYQ2JU9mXsxj7GjCVbyVJuJSJLQrgRpXUoVBKRm5So
y22lkL1rS6QsNWUrKlsila1Fhd/5nfN7v+4595zv7/c793z7Nuoz/8x5nPf7
/fy8X++njFeIsy8XBwfHCx4Ojv/+16oOp3rfFa/m+J/ffDOXoKxZUNVizP/C
XTmdGwNLxTB/J68gS5YZFYpinqcWfKAoUXKdiPkH9fTDSmZdrgjmn9SbcRff
W+YSMGP+R26RX2a5NE8YM+ZvYr/w5FN+nnjMmL+J4+kNOS+2CGLG/F0s5xr0
584QfsyY2dI6oiIynLsXYcY8Ly14PF9gTSwPZszz0mHemftWnOTGjPmHtIXX
2Fz+7wswY/4hPTr3GzPsJifm/8O7X06v2GOuLYzMHVZfKv7nO3FkHdaoVp1b
piSyy2wccz+Fl4R8VljbObuqAtatiVzcHIdDwRKmsV89nH3AtjmKRrfyY8Gt
g5e8bjqXgae4jn+KcOkDl6lv2ugt9REcftDRtNJ7GhzEX7yV62EH+DQ+x7RC
egX4+PSX0Sfnw5cgP+vNkdAouUdE/lVY3/PpEZ9F7NLH/9chX3HWTcfmqjD/
745rKispWWIniSyV8GXZ9fg6JeTAArWtUmsC1ZFTSGVv3IRJmsiuVrtJrHgl
cDjj4DMLqwcayG7tL4SVqk+Bqdm2brjBDPAJzxekjvS7YIaPocTw62nwFRPK
xKEMKcgXXM8lMOumCtaPb9lsQFAAfwq4/LEm5DWct7/axe/DxINzOu5feqh6
WBU5olfEtY3poYCcuqzthDxdcwm79PNPLd3mbNxS8AXz3+xUsrHi5O/2oshm
faxs7RoVMnJTcoez6s4Dushqso+XDGvtMUSeNhQtG9MJMkKmNnHebdNggO3V
ebv1tIdh/yEpZ7uYbfXgiWcTAeZnusEiGjn9n30F4Xx+0vnq1mBjMOVq2LH+
ly7gfVuKpCReeYAVQk/E0W1Wg93ldJ3waWOQby5t8zb+Sq4B8mVBVp1+ozHM
Z6Fi/IyZqa+GPPCOOkmwziOxS1//1CtLPi29/OTjT+/Py9x88OkKYFvnp5v8
edplkFUrHGK836lQkFO00zTzx0eMkQlVbVTF2HQacp3m5Qba5AJT5LSvFoGm
B4th3f9c44eOF0FgnErjI7HVnuBF5t4N5/DR4LNyv+jFjBaCbQbcdlQxu8Fb
5UxbDO6Mg++QVus6uE6CF/IcuUogs8CjCnf6E1oZ4NhU8+bJ4zuoyJFdr2y6
9rTpI/c+cdILUjyuhtzXvVemUoh3Cbv090+d1nK2SRI3hflv3ieucf/xtCce
uf3tJQG74GoyshTZYoTjtrUhcliXIYEWMElDvl5OjEldnk1HXndFc5g7NB9M
ynj3rrNjHXhfMmv/ViMZcMTikarenQrgXFuidvBuJ/D7t26JRnrRYJ2tbZlF
A7+DD63jzvrcVQDWy1mwpPLZNTCNEie/TSgMfMWDL4T78SlTZMYB+5QjAUtM
kKWHc8SGKJz6yCWLvd7flp9WRubSjY0hJlXj2aW/f5fzL5/d3acxhvlv1m1Y
tIqAeyuJXKDg0HJnYFQLeT2pL6KuzpGKrHeg7aq/kzMd+es+7ZMibywZyNuf
668aoYqDXTs/K5Z01sB+ZqmUxjWnTHBUZkXYu5JCML7TgFLKMwC+3KJ8MPAx
AfIyZHonM+zUwdrDLf396nrgxNMyicYS8mA5q95Ajfv1kLcqrm1Lwsk4U2Sb
DbsuB26XhvkeiH5oLnLUpSALWIZYn8nrlUU+Hc9XXm8hh2OX/v5d/uj+5AOz
6NVP75qWB7e5pnBcyM5v42YGNablkNd3i2gWFAbrISe45p0qTaTRkPU7VvsE
0ifoyGFZs4afxN0ZyK/KyLy1nsJgHb+pwp6Nd2D/6wtZA3FDxeAkX1LhPa4u
8MfahxI2dvxw/pZxqGq/KwVMDShLGpuyBhdafnG8OWkLnuskS+OSlcHkiPZL
n8zTID+BN94h+zwL5olcEFxTLWRuBO8V3pgxelFSE9lHP9ZKo/GJJLv0962s
gj9GHBXq/ek9KZYvPjxxFI/sKz9IHNJQVkXOSFbaVDTZaoj8lpGrY10Za4oc
HH7uk2ihCQPZ2HfiouiMLbijR3dMKXWcjizi5aJ/4Wkp+I1yYvIGn0pwZGLB
4zNbXoG/9D8tvqcuAXkX6D4y2x2pYAXzyFla6V/f+418qGfxRQvw4M2r3amH
+f66n6W46uguHcjfx9h1ONK/3ATZr768JD+lSB95QE7OYdvWLhU4bzJBW+D/
QZhd+vtWvmsjYiP6iPXTO/L4kDhhQ4YkssDpPPHtJx5pITeyvGRcCpyoyHaq
hrEeOA86crPW6RtcJWsZyPGjwtllKUrg8oM8xZyND2F/2ikd4srwPPDdKN1F
Qg9qwSFRDZ8PPZ8Av04iu369Ig15nF/WfOIzoIK3++icrU62AMupcVmKXdAB
15LeUAcE2yFvhXiuS3V/uimyrt/7iMqHNJhP+tWWEaX2QApy0cJr0QrdDnLI
EgfDWDGLv+DYpb9v5V+s8hrm7K/9dMZtOqpkiDPhRF4VrHj0vHqSHHi2te/+
IEUPWdm8brqUIEFDPrrTwfdcXjsduWgvWWrU1JKBzLtErfPRuw+wHq5967fN
WrlgoaxUzqKYc+Aj8buET3lUgxMmbZuf546Dh9T2npQfWQL5EbMO1LQrGmDc
2twbnMe0wCkCJcPu+XjwpX5eh/D7TMjrM2oQ5f6lGubhD1/rFBBOM0LWfn3z
i7Wjvibcl/xZa0+qEYld+vtPueHC8gHK/gb6z2bc+mhO7dxqIWQ7YbsEjt03
yMjFZR0F0g8PGCKTHjmv5umyMUVOD8hbOrCAm4HcrPJ0/MAOUfDNTv+v+oEV
dOQXqmZ/VnREg1Vbxol6+2LB8o1T10Pu5oNTeA0tO7T7wDlWfGp7shZAfvGI
8SzFSwRM9Nmu5IwXALM6dgpQfB/BeY0mUo4XYRbu39P0fg5XlmCCnJEbxT0u
dUYfeX120oSr7JAK8qeR1m2qHi4EdunvP2UvJzWzYN6nP53dZ2p1+na3SSCf
2VLk4G3lrIU8u49yO/rauDFyYtW5vYZVAnTkilWfM0yLeBjIi+aYj//g7Ib1
dkG3k5vyD4GXtrrMXNXbDM7Ct+LMW3aA0/f3d786mw2e9jRKVxZlgTtLttRd
c3sDdrXaaBu44D24SEQwkik8AK6PWjx0pOwwmHnLRag00ckUWTf616al7TMw
3znWROY9CQsKctKtoWBb+XVyyDtajm7w6vTmZpf+/lOOIEoIn1YZ/OG97vKA
7hUZMjhSlEPcWPmdLDJzYdqDbXLNush7pTV4N65rNkF2vNJqVEtOpSObv8fP
6N7iZiBrjL1fe7anFNY1W6ZGaxqDwZxE+4jnjh7gFZ63L3fvZ4JZmfnJ5Av5
4AHdnOH4wk6wSRF5vSDtLTjR9bbmUfoYuM9MaM0K/1bwB93VO6iFZmD8HeY6
F+UYGvJwwy+yOF9hI2QbCuu0ioOCJjIj2pGo5u1NYpf+vpetvfwm1R+M/vBm
ZvYMzSVLCiHzpwcSZub8yMh5GvtMPJ/6GiJzZxvieWcsTZHHCXFqlAe8DORy
0QbKYWNJMF9/xUYl/xo68iay+ctw4zhwpGv3qWeC8eC6vDOrXESLwGQ53MFQ
n0Gw0eo7igHjCyH/yLQyxw53MXDvYF0pr4Uw2PXISoPw3nY4T2QmzfzhsgB8
bHz53dyRNBNkLqJD+UPxYn1kFaEIvwc75OE9hHG2JQea2wns0t/3cqdq/ydD
k4kf3oISYyccj2RLIEfX39O6ZRyshVz47r3n+Lg2Fbn6xfFlnMfc6MjxhOKq
J/vdGci+uobtiSQd8B7WCo0Y7SewXzrLmTtKtQic3UdLcRJtBL/J0ChtPf4J
fH/X2/WVXgqQ94F7j02QuRk49cIVXFCCDfi43BZNzxADcNpJ5lxNXg/kJQ1U
Lig9c9EUeUjx5IXPjRthvprzJ1lBqYUU5OcfQ2m7bcbkkEVftRmYJ9suZJf+
vpcrHfvtthM+/PCOuM99SZ2cI4vsYFXZ7LKzRhfZO/K0jH9WjwlyU3+Q27Rx
Ph1ZrcRo+U5neQasU9LtNEI6YP0rPWGZh/kxsJnp3p4w3r1g+epghZf4jL/y
CuZItXdawI8PUYfM/N6DGwwPd7/G8cH3su2OT9Ma+cEC95cflB4dgf2kCb48
qwMe4B5zUuGlzBwasl9OqGpSiqERsiZ/Ck9gpbcm8ssTM1RaeQuJXfpiF/9q
RD87NzQ97z0c/Csu6vM5fuS02t/8mhzslZFvl7vIBnDv1keO9XzTEh8VbIJc
F8a93abD0BSZaD13apX5KrDmlLPlvYQJGvK9A9kWOlKl4Mf15zP4YirAMZbc
QyvUB8F2MqxnRxzEIE+LrOJzMU8f/IZ4NJ45ZQl25KzM1yyggxmWpmf/3LIQ
nO5O3NRwnwL57UfNBkWeNRsj56i6dLmvmtJFVmwrWekfGwnvQfy4sf7Sandh
dunve5m27nSpfPXMvHeXbPWisaU3CcgrfztkUavaqIyMO3zmDfeOfAqyGSFR
TWli2ADZVyz9d5m1Y4bIXyvTo1Qy68BWkeOL+GhB4LN9btTHEtbgN/b4csaU
Kxinbtf8h8xRsFh6r87mpGJw6DTvF2NBFjiYv6GFL6wLXMDvJma+/C54aYU9
6cL1YHDAHfuFgUeN4P6bm5JvpN8Yh/mmTVRWjuxdowbvRT0m6Ee7KMUufbGL
V1XleBGaORjz3alifB+Lag8LIX9sij1nlftcGrmV3qtE8BRVQd5PlH9+r2dc
FblRxv6yYoifGvK5DsG6qoUksF+w4NVrg62wv/etpVmdZBU49I9Oi5mB5+CE
1V7XrG4Jw/llexnp0XgDcPpQVs9s1Uowv2qhfs5ae/Crutjcq0pq4JprL+tP
bM+C/OishqjAdUMwj47e0uINF/YrIO/cxp8i31FAQrZjtj2L69HlZZe+2MWc
ZuVVyyq45r0T66TeCnn78yPrsQJqMq+GEJBZsllGtrsYRGRVPl5F3RNrwAqy
GdLp66ZFkI3Vl62fVKsGC8gzPcXMa8GJBgEba5+9Bt8mXXKfvEuCvNN7cTfa
TWngWnXPbuGbduA8Fo2naNwC/MLrYP3Oan5wjskJy34xQ8jfE5sananCwiNr
0FZS8e8+L2KX92dXb/idSHe/gsOM+Yd0XHbtrbH0hZgx/5Be3vp45ewxXsyY
56UtXfQ8rzH5MGOel9Y/k/RVNkIAM2a2dAZzZCA+SAgz5u9ixlPXwCMUYcyY
v4ld7lzvD9UmYMb8TdyXbZiariWCGfM/clSoo7SkNhHzT+pTv5aWClBEMf+g
br13dX2ivhjmeeoNVgFfqqmLMX8nJ+YWvqg1F8f8L1zlyfO0dOWSeev/AkVl
lw4=
           "]]}}, {}}, {{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.01], Thickness[0.01], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJx13XdUVlfWx3Ebigo27BIsEQdLgr0rqMEYe0WNHXvHGg2JIhJL7NgSotFE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           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{-0.4920407313793702}, {1}},
      PlotRange->{{-3, 3}, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {195.42857142857142`, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {359.99999999999994`, 291.2461179749811}], 
    InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.03], Thickness[0.03], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJx13XdUVlfWx3Ebigo27BIsEQdLgr0rqMEYe0WNHXvHGg2JIhJL7NgSotFE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           "]]}}, {}}, {{}, 
        {RGBColor[1, 0, 0], PointSize[0.02], Thickness[0.02], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJzt13k0Vm+7B/BHKfP4GDKLzFOZp8eDhFLKmCGzTJlFhoREbyQylEihKFHm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           "]]}}, {}}, {{}, 
        {RGBColor[1, 1, 0], PointSize[0.015], Thickness[0.015], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxN13c01n/YB3BlFWU1iEiRQmSUWW4jJFkVkkgipIQyCoVIGZllhewVsmWH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           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{-0.4920407313793702}, None},
      PlotRange->{{-3, 3}, {0, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {586.2857142857142, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {359.99999999999994`, 291.2461179749811}], 
    InsetBox[
     GraphicsBox[{{{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ5YCTcwfvL04fxw5ApD
vRLDAcctVmoXZm6Sf7t3ev5uhT/7dbmbRUoO/NKWK/o10cr5x/4NIXMuiGkI
G97isTj/UOjL/oOFfo1XjFSN+V7mSuu/eb+/VKQ65erczcYbd4Qwyjm82M+6
uiz82/XTxpdWPbLcdef+fjWNz1sm/ztrfOXJWyf7kAv7w1fG1HzyO268QPMp
/9P5E/fL+ZSKKl7aYvzKizvb5fo5e6OJ1Rq8KZONP88xf2V97Z49/zHldQzc
lcYqf/fNlDr23P5f3dkOEflG49cT71v/+vneftZqmS3BrJuNTSd3W2lf+Gw/
9/lnk6uPThu/KvOxMfz23V5Y/FCnacw3o6pbMzpLr/62t0jT1VE2XKl/QJv1
3glmBoerBRVNK+LZ1U45z93GL8zkoOK23scyi1vwkPTvLV//MTvAwq+04fVS
dxE2OL8u6M+afYEIfocK7xbTfgR/1gm9Q8pc7HD+4ln2J2e5I/hrcgIuCLYi
+NvsEq93HELwoekBzgcAcKHJ/A==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlXs41IkexufCTO6Fdb8VlthDYraw+v4SEbJILTkhtLWFcS+WWJdkdUgS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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc7lY//x8/AMcqOsjKjlJFN537dhIOkSCKVSEYhyWiQJCTzHFGklGgg
SkWl3LfZIVlHQxlHxttM9jjo0/e6vj88ruf1uK7nH/BQ8DjjcJJEIBAK/vF/
iwkH9fz9S8GnhuckxHMpcMw4q/hsNQVXk6OvuVgKwMqJ6sv91yg4PcCu191P
CLKSRu0O0ij4d9uNcRwRUTAsF938kY+Cm9P9bXZh4vCVbTxp2MSD14UI+138
KAnB/CewgmQe3L7X8LminjSI6iakyNjz4FiRGjVdbDM8P/rSLVns31+1MCOz
XAHK9eJftLdy48WRd89891CGyvVuZMlkblyYUqXw3UcVagd1D7ru4cbXmQpd
L2Ftg08f+B/n8HLjTtYjMtbFGtCezl7sr+PCPzme+KR7VRu++5fZqEVz4cIP
1yUfntKBXovEbD+UC/+19NjTpVAfhmQ9fj9fJeOKX2jy3uVGMEmNdHXHyPi2
n7ns2+xdsHg0mykSRcazbuyKsNFEgXj5rV61GRm3usUwVZAxA/57X3ODuMg4
eo7vgJ+xOYhVzggp1ZPwjYzG7RNJliDTIxzBiiPhulznA65LWcOWtR2j0dYk
vHkyLsRsYA9oyu05pCtAwq+aF9FMJu2A90B4kWwzEZd1PZ63VdIe2HHPiBQ6
ERdZjY2Q/uEAb973OP05QMTHcxSqw6sdIXVKqKhTgognqAlxnNudwGeLKbGm
k4BX/nSXeyfgAqhrkFNRNgE3sbtUkhfoCn9qOwiRigQ82SLj2QWP4+Cx37sk
BP+LUXdFcAxX3aFfQuXohMlfjO+2vLNE2Qnw7P7Ff7J8DUvyPaYonXwShh7e
f9O1cw0zEOAwDWK9wefUMS/H4lVMoc37HOT4wqiWjHjT1lXMWViZ0d95GiY+
3DpTIb+CKbGN3xFdAyFYfOCAQD4Ho9K3UAnpZ2H5lJah61YOdmUHy1muJwh4
NjYQONrL2NHSBPK+uyEgF7RMN969iG1iYaVBHy9BqEruBc0PCxh2wO6d2a0I
+Pzd2l3ZYAE79TkyixUcCeGQqSWoPo8RU2j7qAVR8GOdYUuf6Czm9HySubMy
BlpHKHFWKTPYeeW78WK1sVBX/w0pEZjBuJtu8KCNcfD8SlhxONc0VhbectKC
FQ+PjtK8+q9MYazWKf1R1g3INpaUs1n9g9k/2OAa2poAgiP+0prjk1jYjoqu
zDdJQKrZtlg0/xuTITkP+DOSYSH7v45txN9YSVKe7XPPFBgPzXvxRGACe1JI
WTKUTAX2fvfkLRLj2OWiHb6eYanQsU3udJ78GLa96s2QT3sqMLl+0hTVRzGx
pX6tTlU6vO+5pXxfbwRLaGzX3BtGhxdvHIly6DAmxGvx0QOng5Utc2BQ7z9M
gS/EhIeXAb29Jsxn6kOYsgGt34nGgNBzJYUhCoPY+t1G5XMRDFhPUUqhSg5g
e80f8qQWMiAvKyOIe30/lt64w4rdwgATDX6nz6Rf2Fyxd2PxKAPaqyKM0hfZ
WNh+XrN2zj8v+GX0rqsXu9bdp6NFTgNRUa6fBWPdmPbhbpYuMQ0cLqiE31n+
iW2vfjHybJ4BDLalbCLfD6zukNTjp/0MYNF8KsM3fseU0+dyTZkMEC+Jd/NX
/Yp1i43mZOUxwFGikHBMvwMzC7YwHjjPgJsRTQ/sLNoxfYLEZWcLBnQMTJiB
YyvWl8X0MuFngNSgm/XvzibMuHSYY9RAhwTCwLpjAg0YJypxNimKDivSPq2f
d9Vhs4rmBSk6dAgwGE+jBlRhZfe2KdzrTQUsn118GCqw/Zu8aHKxqZDbNaxn
nPsS264YpX5RNRXubx0UGsyhY4fW65hxvU2GlUSL5fKvyeB4fEEwrSUJ7Fw3
xNiZPIFf4oImh3oSoSxfsIH28D0stI2Fmo3cgFEbgdPm35ohjimAhnyJBc8B
ab855zYIitFyneuNAUel0lwrSxZcY02/vDR2DXQf9AhNyn+Dgwu8LS94o0GZ
HWxpJtgJtykrnBbpqyC+WSAinfMDHh/+0dGyMwpmsg1GTb72gJkm19z17suw
T/d5fEQoG6jczdy+3BGgnGUu1x3VB2pNDTY2Jpeg5aQ/Lft2P0A8JJR0hEHe
J2IX5+EAoKuv7ucbhcJF7YxA15JBMGg9whVdEgzKq5WZUvX/QWkGFurYchY+
CJGTM5qGwbhZJQmLDAQnRdpVUdYInKI+2nbyagBM6iaEJneOQqvQ02ItVT+4
Tms5xc8egwqLQp/4CV9QOCzmFjs0Dvujjl6Z6PCGd36HDpAmJmDDV7n6110n
YYzea7K8NAk3pzNJejYeQDWL7vMI+wPUtFL7IeZxiKmQyGdO/YH0v5kRqlXH
4LNugY+G3xQsoj3xefJHYEMxdfvNoSm4QHLQcSl2gaOqbZNLx6fhvp+83R6f
Q5B/3/Ol289p+KaPV4bYHgS9tARj9dYZOEAd0zJLsIeikprlMcdZoKpL5+GX
94FiE+ddUecsBFxse/BY3xYyh3Uu+R+bg/ryghFZI2sQ5vYz0eifA9s7pHLl
KEuIVcjj/PaeB7cF3TtsPnNYpXZVlIzPQ2n2ZumcZlMIPiweHnh2AUS8H2eV
pQOMhtru0p7/58NrgtGzJnCEPF+3KWgRjOXYvbuHDKE5JWcf6fcimEmWmmcp
6QMqY9056rsETuWBhhcf6UDpk2kP1uASoCrqF7b7aoOyXvZ4hfsyZPd1WN9t
0oCMKovQvO5lOC+iaZqvrQ68dpN/E104sOGCUeXygipc/HE7PuQLB3qr6Lsa
JVRAmv8/obeuK3BDflOtq4MivDfSy1jpWwGPzi4VobrNcMQ3Wgb1WQWpbBeT
vnBpWL3dlhv9exWEx4iNsxWScI+5eevH4DW4lR1YFXFOHJBF/xJ+zhro+idL
8GaIQK/qez27qL9Ae/tgsFZDEHB17h4mmYAymp6linTyQZXGxrcvLAiodfjC
mdOqPFCtrX4zK46A3ulJvLV3hgS1usiZ6AYCWqNWo5y2gwB1BvY2fgJEdJh1
76obnYPUG3uqHNxLRAMkT8RJnV1AmNQwApJCRL3UrQa/DMwgDeiNn1vaiOhW
jRrRiM4/SOPuu2VCYiT09aVs0yPh40jDmk9o4n4SelrNq4+wbxhhvtXV50sm
oV+eUun2rweQj8GE+ZhPJNTBclrdLbsPqddsek3iI6P6Ukc0uoe6kbrRWyGR
lmRUp2rj3shDnUht/gm9lWgyKiuiIPUi8AtSc1xz7nwVGX0gsexSKN2OVEtz
Xs2tkVHPU892z19vRpzVNs3kmHKhAtqxLWKODcikroG2zTUu1Cm6TCpjoRaJ
NT14ZraeC300vU7O1aEKkbE79+weHzdqHSC+firlPVJ6mD5mZcuNxu2MYyFX
yhEr75KtM8nc6HFDRS0l25dIz7nP3nfbuFFLyubZO/dLkJArY/k0cR5UTYlq
Gtv9FLnssFJUac+DytJqJKaC8pHryutf6aXwoB1prqH0qgcIfV62oqiJB83k
pPYvOd9Fspga1Ur8FHSybO7VRv3byMMsaMiiUdC0SK/uhD9pSJHf/laRGAo6
/50T88ozFSlD3L9dr6agJaFdZz4O30D+v0dREZTmtWVdLPI/eQQMOQ==
          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk4FPgfB/Bp3BG7btkmx3RRKPcwPrYwjnJFBz/X0G7KTVqFLAmLkULI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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlfs71Ikex+diTEZSWJKyyv3oYYVYt8830bidIk511uZWSi4pt5Ulp5WD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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk01H0fxseMMRlKiDZJIetti2yZ71+bJaGQu2RNcWcrWR6FSKJsyRJu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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk4FPgfB/Bp3BG7btkmx3RRKPcwPrYwjnJFBz/X0G7KTVqFLAmLkULI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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlXk41Iseh2fMMDE0JaRkyJJKN8fNIOL7Q4xcqdBmPaNTKdtJlkeH5NpP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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk31Psfx2cxM0Uh2YrETSKphJKl14eyX0shSdZKynazxh1SQrKXSghh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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk4FPgfB/Bp3BG7btkmx3RRKPcwPrYwjnJFBz/X0G7KTVqFLAmLkULI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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1Xk81Ikfx/G5zOTIyGi2kisqardJuXLs55uELJb4Rc5S/fITiYYt5VjH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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk01H0fh2eMmRGKUkmWSriJJBGR+f5bLFGSrcWWaLGUStEtWZKlJ9uk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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ6I7P9suX9+F8OHI1cY
6pUYDsS317+a1PhR7O3e6fm7Ff7s/6uvsTBT11JZrujXRCvnH/uvit3mq2IP
0rjFY3H+odCX/VuPnNAo+ZysxfcyV1r/zfv93i/1t3iVfdLauCOEUc7hxX73
9/aXK0y4tC+temS56879/VsvO6xYZ8WjfeXJWyf7kAv7196MOnziPav2As2n
/E/nT9wfLHZrQeGMz1qvvLizXa6fsw/ntmV+aX9J6/Mc81fW1+7ZrxC3v75l
4nYtlb/7Zkode27/yS/XVVH2gNbrifetf/18b+9o82r1oWcftUwnd1tpX/hs
r33N+tVmOy7tV2U+NobfvtunREs9DeE21aq6NaOz9Opv+51pQmdmbH2udkCb
9d4JZgaHs74/WZr/u8qecp67jV+YyWHJo/MShmc9OQ5J/97y9R+zAyz8Shte
L3UXYYPz64L+rNkXiOB3qPBuMe1H8Ged0DukzMUO5y+eZX9yljuCvyYn4IJg
K4K/zS7xeschBB+aHuB8AAm80QI=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlXs0lAkfx8cMJoRiskXkukLvul9i6/cUG5WuiNAotlihiClCJGG1QuSe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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtVmk0VYsfvaNblDkpQ5mT95Qyy/mdTFdIQipDmZN3m4ReMt8rShEPSUqF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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ5YCTcwfvL04fxw5ApD
vRLDAcctVmoXZm6Sf7t3ev5uhT/7dbmbRUoO/NKWK/o10cr5x/4NIXMuiGkI
G97isTj/UOjL/oOFfo1XjFSN+V7mSuu/eb+/VKQ65erczcYbd4Qwyjm82M+6
uiz82/XTxpdWPbLcdef+fjWNz1sm/ztrfOXJWyf7kAv7w1fG1HzyO268QPMp
/9P5E/fL+ZSKKl7aYvzKizvb5fo5e6OJ1Rq8KZONP88xf2V97Z49/zHldQzc
lcYqf/fNlDr23P5f3dkOEflG49cT71v/+vneftZqmS3BrJuNTSd3W2lf+Gw/
9/lnk6uPThu/KvOxMfz23V5Y/FCnacw3o6pbMzpLr/62t0jT1VE2XKl/QJv1
3glmBoerBRVNK+LZ1U45z93GL8zkoOK23scyi1vwkPTvLV//MTvAwq+04fVS
dxE2OL8u6M+afYEIfocK7xbTfgR/1gm9Q8pc7HD+4ln2J2e5I/hrcgIuCLYi
+NvsEq93HELwoekBzgcAcKHJ/A==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlXs41IkexufCTO6Fdb8VlthDYraw+v4SEbJILTkhtLWFcS+WWJdkdUgS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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc7lY//x8/AMcqOsjKjlJFN537dhIOkSCKVSEYhyWiQJCTzHFGklGgg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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk4FPgfB/Bp3BG7btkmx3RRKPcwPrYwjnJFBz/X0G7KTVqFLAmLkULI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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlfs71Ikex+diTEZSWJKyyv3oYYVYt8830bidIk511uZWSi4pt5Ulp5WD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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk01H0fxseMMRlKiDZJIetti2yZ71+bJaGQu2RNcWcrWR6FSKJsyRJu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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk4FPgfB/Bp3BG7btkmx3RRKPcwPrYwjnJFBz/X0G7KTVqFLAmLkULI
5hxjEYpUlK8UjWLTpnKFNO4ZN8PMyK/f8+wvn+f5PO/n9e/nn/dHmRzoeAaL
wWCuftv/JfohZHBjQ6gZ8++4E3Krgls2zfNuif5yddMGDyV3vhTZdI1brQdF
SvC7x3aQZ2rW+b5bE2dzUkcU27zD/lg7W2K3zNyLbswVFUyzavCCWzBfqjrr
6a3ARiUeKmA+RDKfuvXDpBnHRalcpBMmquV/57EB55yWges+LjrIDFwr9kg0
FJRvx3APctCeWbcPWx2mCSkBMqPW9WuIvDfORs4z1kiy1as9l7CG9NNm5svX
hY2zFavuTjWtongPPpsKzVhjXAgnnXBkFaUIdGi6fWYZh+8qitB8ykaU+h19
YapOxM4eKy+8PhstW9XQk/SqifiUeUuFeytI+2rbsUnvdWIk5GiJq6+gzqmV
rwn3fjbpXjCV56MuIzNO/gE6JdJEvXRig41bRhXyycJ2KjUmsaevjzOzl1CE
iK+5cHqfSZ+YwZvPkksoVq3+L7dEDHRNCiVYpi0ilUdhXVXBO6G17aNJtegi
ipCL1vCyMICGYtqKTOICcmt7oq5FtIOamItVkfwLSMt/b0TAXi8odSP98iVm
Hj1tIjqGBAVBHkEOZ70+h368uiXKmy8SbsiNv6+JmEPHcoKBmh0P4pP+iprM
WeRtcdldIIcC2Odqq5UrM2i3RmLg5f6bwM4b71bbMoM+KPiKHPstG5jhJffK
RFko44EhRXs4D4btvSi7ZZnotXKms2VQAXSr4c6XKE2jX1M9W6wPFAGdv5+k
oj6F6PPyalKFxfBk8Ba+QHcSKXjfeTXXUQL3HjltwZlOIOzYRrnkQypYHqUz
RnXHkYhe6aO3YaUwNGREv6s+hlowR5JCuaUQHlpdcUF5FPmKL/KYzjTYJqSa
RpRjIF4VeX5XKg1KcrNCBLZ9QYVjIxdiaTQw0th6ohM7gpwrCLt6ymjwz7Mo
w8zVYWR8Tz6BduOby0cMGwaGUN39U++ifWggKcnfXz79CZ0/T27drkIDx4hd
kbc5/ai3N5/GaCuFG8MWO1JE+pCw66ywvX0pvCOdbYqU70GhCVf/4DRSQbo6
ycN/zwe0v0kgVl6YCk6yFRh3vW5kLcIe/6hdAhlRHYW25v8g1Xr75zVQDN0M
1mFw6kKHf3eYy/l2r+2jHlYzvR0oYM3GlyhUCMkYhpi7aDvSxzYWe2fnQ4A+
8yYx4Bk6SxbHh3rmAqIOV7lAIyqvcZ9gPb4FRQMTuoSiWmSURXNh4TKhYN+o
xGh+OmI1C24sGF8HXoo55+EHCqQfYFlte5QMtq4y8bZGZXBXu6Z/xi8Bqv7q
iL/oWQfR+UtZ7gVxUE8VbycVPwHSAd6WmOMxMGi/V1AstAXSeiYDe/guw4ht
+56wjDYg2LNSDS3CYezoOauBB6+ASLFxenEyBKasRc+bffwbmF8TkxkmAeDD
UPRbPvUWZpmHLuFO+YKT6v0iS4t3UKU56uzvcgbMyJa9t7XfA9XgT16IMhl0
CgclZpU+Ql+6AmC2ewB+OMzisHgvvE/o7GBhXUF6p2hUJrcPhKUcudQ3J4Hf
vbB2YmIAXH1e9y65OMNinv6U0YdBKGxOUZtOOA52OjVJUeHDkLsiq0lXdwR8
rhnu0++fwTkxAOvn7QCcjZ77xqkjUCYkaR61xwHenPEn5WV/gSMV1qk2lx2g
5PWWAW4xA46+LNHNCHCESwezglyrR+Fcn4LOJyUnsLulJtDYMAb7RVWXFF+e
APx6U872tnHwlKRX3q9zgacSfJSsjgnoOq1nVIf3hBMqpFjJd5MwcYIS9gDv
A7M6yeGU3ikIfW88vDzkC4mkN+e2Dk/DnZHhDrxYMCi7SHlcG2NCe6Nk1qPZ
cGjwO3kcy2IBv96K1ZPjV8Dxym1S9OIMiP0St2p3PR6m04eMOGuzMJxicA5f
kQrEw3GfyRfnQOn5tVXpVzchvlGWSp+fg9xrneLWkznQqVN+VsNvHjoZElN1
vxWATBVxf8bYPFS+jDJLkC0Btz1vZ9c8F+CoxDW2gQYNqAU+tR79C7DzAEtE
nFUGLIXV8FbnRUh362TIUcpA92YyQb1rEc7Wv+ZLRVSorH7OmXZagksEZXZy
TAGodHAbKnuX4MbAktWhhQzImdC+7O++DMK4wXxIiocfBPyMNL4sw2Mx3wtK
DsFwTbmEO/PrCpzPv/7AYtkJ1okDjdXMFWCI84+72h6CMBfpyKBgNkgNlhUn
bxOEqfCjxgdX2GBmqhZgHfTW5D98K60KIavQdeWP2lsbGSZ/p+XbYWdWAdMg
y5GZsTMx/cmqd8p3Dd6IKfcl7lsn3i9bIL8bXYPru+J7cpzuEPG6ecxGLw7c
4A3FmbO1iFnPzMNLPnFAF7ez/LRerbGw7exGymkutPqpkNJK8MaX+rKTLrzn
gmgqeayMGmekuHVc4rErD9LYP+8/ndlEeGKom8X7zAOjue2CzwMHDdez3xbF
zaxDpotPemjmC/1mdYFBOh/GVC+43aWIMHLw1ZE/6yWksKZuXnmYKK/Rn1oU
uXXLX/lM/9+vF2KmqSRpwe+OduRVNjlsOhG/rU43bdO5dI0W1a1C312cC+25
pE1X+tl3/Ri/6XoTr4+JLZv+91/47v8CZzLiHg==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlXk41Iseh2fMMDE0JaRkyJJKN8fNIOL7Q4xcqdBmPaNTKdtJlkeH5NpP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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk31Psfx2cxM0Uh2YrETSKphJKl14eyX0shSdZKynazxh1SQrKXSghh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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk4FPgfB/Bp3BG7btkmx3RRKPcwPrYwjnJFBz/X0G7KTVqFLAmLkULI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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1Xk81Ikfx/G5zOTIyGi2kisqardJuXLs55uELJb4Rc5S/fITiYYt5VjH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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk01H0fh2eMmRGKUkmWSriJJBGR+f5bLFGSrcWWaLGUStEtWZKlJ9uk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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ6I7P9suX9+F8OHI1cY
6pUYDsS317+a1PhR7O3e6fm7Ff7s/6uvsTBT11JZrujXRCvnH/uvit3mq2IP
0rjFY3H+odCX/VuPnNAo+ZysxfcyV1r/zfv93i/1t3iVfdLauCOEUc7hxX73
9/aXK0y4tC+temS56879/VsvO6xYZ8WjfeXJWyf7kAv7196MOnziPav2As2n
/E/nT9wfLHZrQeGMz1qvvLizXa6fsw/ntmV+aX9J6/Mc81fW1+7ZrxC3v75l
4nYtlb/7Zkode27/yS/XVVH2gNbrifetf/18b+9o82r1oWcftUwnd1tpX/hs
r33N+tVmOy7tV2U+NobfvtunREs9DeE21aq6NaOz9Opv+51pQmdmbH2udkCb
9d4JZgaHs74/WZr/u8qecp67jV+YyWHJo/MShmc9OQ5J/97y9R+zAyz8Shte
L3UXYYPz64L+rNkXiOB3qPBuMe1H8Ged0DukzMUO5y+eZX9yljuCvyYn4IJg
K4K/zS7xeschBB+aHuB8AAm80QI=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlXs0lAkfx8cMJoRiskXkukLvul9i6/cUG5WuiNAotlihiClCJGG1QuSe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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtVmk0VYsfvaNblDkpQ5mT95Qyy/mdTFdIQipDmZN3m4ReMt8rShEPSUqF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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ5YCTcwfvL04fxw5ApD
vRLDAcctVmoXZm6Sf7t3ev5uhT/7dbmbRUoO/NKWK/o10cr5x/4NIXMuiGkI
G97isTj/UOjL/oOFfo1XjFSN+V7mSuu/eb+/VKQ65erczcYbd4Qwyjm82M+6
uiz82/XTxpdWPbLcdef+fjWNz1sm/ztrfOXJWyf7kAv7w1fG1HzyO268QPMp
/9P5E/fL+ZSKKl7aYvzKizvb5fo5e6OJ1Rq8KZONP88xf2V97Z49/zHldQzc
lcYqf/fNlDr23P5f3dkOEflG49cT71v/+vneftZqmS3BrJuNTSd3W2lf+Gw/
9/lnk6uPThu/KvOxMfz23V5Y/FCnacw3o6pbMzpLr/62t0jT1VE2XKl/QJv1
3glmBoerBRVNK+LZ1U45z93GL8zkoOK23scyi1vwkPTvLV//MTvAwq+04fVS
dxE2OL8u6M+afYEIfocK7xbTfgR/1gm9Q8pc7HD+4ln2J2e5I/hrcgIuCLYi
+NvsEq93HELwoekBzgcAcKHJ/A==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlXs41IkexufCTO6Fdb8VlthDYraw+v4SEbJILTkhtLWFcS+WWJdkdUgS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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc7lY//x8/AMcqOsjKjlJFN537dhIOkSCKVSEYhyWiQJCTzHFGklGgg
SkWl3LfZIVlHQxlHxttM9jjo0/e6vj88ruf1uK7nH/BQ8DjjcJJEIBAK/vF/
iwkH9fz9S8GnhuckxHMpcMw4q/hsNQVXk6OvuVgKwMqJ6sv91yg4PcCu191P
CLKSRu0O0ij4d9uNcRwRUTAsF938kY+Cm9P9bXZh4vCVbTxp2MSD14UI+138
KAnB/CewgmQe3L7X8LminjSI6iakyNjz4FiRGjVdbDM8P/rSLVns31+1MCOz
XAHK9eJftLdy48WRd89891CGyvVuZMlkblyYUqXw3UcVagd1D7ru4cbXmQpd
L2Ftg08f+B/n8HLjTtYjMtbFGtCezl7sr+PCPzme+KR7VRu++5fZqEVz4cIP
1yUfntKBXovEbD+UC/+19NjTpVAfhmQ9fj9fJeOKX2jy3uVGMEmNdHXHyPi2
n7ns2+xdsHg0mykSRcazbuyKsNFEgXj5rV61GRm3usUwVZAxA/57X3ODuMg4
eo7vgJ+xOYhVzggp1ZPwjYzG7RNJliDTIxzBiiPhulznA65LWcOWtR2j0dYk
vHkyLsRsYA9oyu05pCtAwq+aF9FMJu2A90B4kWwzEZd1PZ63VdIe2HHPiBQ6
ERdZjY2Q/uEAb973OP05QMTHcxSqw6sdIXVKqKhTgognqAlxnNudwGeLKbGm
k4BX/nSXeyfgAqhrkFNRNgE3sbtUkhfoCn9qOwiRigQ82SLj2QWP4+Cx37sk
BP+LUXdFcAxX3aFfQuXohMlfjO+2vLNE2Qnw7P7Ff7J8DUvyPaYonXwShh7e
f9O1cw0zEOAwDWK9wefUMS/H4lVMoc37HOT4wqiWjHjT1lXMWViZ0d95GiY+
3DpTIb+CKbGN3xFdAyFYfOCAQD4Ho9K3UAnpZ2H5lJah61YOdmUHy1muJwh4
NjYQONrL2NHSBPK+uyEgF7RMN969iG1iYaVBHy9BqEruBc0PCxh2wO6d2a0I
+Pzd2l3ZYAE79TkyixUcCeGQqSWoPo8RU2j7qAVR8GOdYUuf6Czm9HySubMy
BlpHKHFWKTPYeeW78WK1sVBX/w0pEZjBuJtu8KCNcfD8SlhxONc0VhbectKC
FQ+PjtK8+q9MYazWKf1R1g3INpaUs1n9g9k/2OAa2poAgiP+0prjk1jYjoqu
zDdJQKrZtlg0/xuTITkP+DOSYSH7v45txN9YSVKe7XPPFBgPzXvxRGACe1JI
WTKUTAX2fvfkLRLj2OWiHb6eYanQsU3udJ78GLa96s2QT3sqMLl+0hTVRzGx
pX6tTlU6vO+5pXxfbwRLaGzX3BtGhxdvHIly6DAmxGvx0QOng5Utc2BQ7z9M
gS/EhIeXAb29Jsxn6kOYsgGt34nGgNBzJYUhCoPY+t1G5XMRDFhPUUqhSg5g
e80f8qQWMiAvKyOIe30/lt64w4rdwgATDX6nz6Rf2Fyxd2PxKAPaqyKM0hfZ
WNh+XrN2zj8v+GX0rqsXu9bdp6NFTgNRUa6fBWPdmPbhbpYuMQ0cLqiE31n+
iW2vfjHybJ4BDLalbCLfD6zukNTjp/0MYNF8KsM3fseU0+dyTZkMEC+Jd/NX
/Yp1i43mZOUxwFGikHBMvwMzC7YwHjjPgJsRTQ/sLNoxfYLEZWcLBnQMTJiB
YyvWl8X0MuFngNSgm/XvzibMuHSYY9RAhwTCwLpjAg0YJypxNimKDivSPq2f
d9Vhs4rmBSk6dAgwGE+jBlRhZfe2KdzrTQUsn118GCqw/Zu8aHKxqZDbNaxn
nPsS264YpX5RNRXubx0UGsyhY4fW65hxvU2GlUSL5fKvyeB4fEEwrSUJ7Fw3
xNiZPIFf4oImh3oSoSxfsIH28D0stI2Fmo3cgFEbgdPm35ohjimAhnyJBc8B
ab855zYIitFyneuNAUel0lwrSxZcY02/vDR2DXQf9AhNyn+Dgwu8LS94o0GZ
HWxpJtgJtykrnBbpqyC+WSAinfMDHh/+0dGyMwpmsg1GTb72gJkm19z17suw
T/d5fEQoG6jczdy+3BGgnGUu1x3VB2pNDTY2Jpeg5aQ/Lft2P0A8JJR0hEHe
J2IX5+EAoKuv7ucbhcJF7YxA15JBMGg9whVdEgzKq5WZUvX/QWkGFurYchY+
CJGTM5qGwbhZJQmLDAQnRdpVUdYInKI+2nbyagBM6iaEJneOQqvQ02ItVT+4
Tms5xc8egwqLQp/4CV9QOCzmFjs0Dvujjl6Z6PCGd36HDpAmJmDDV7n6110n
YYzea7K8NAk3pzNJejYeQDWL7vMI+wPUtFL7IeZxiKmQyGdO/YH0v5kRqlXH
4LNugY+G3xQsoj3xefJHYEMxdfvNoSm4QHLQcSl2gaOqbZNLx6fhvp+83R6f
Q5B/3/Ol289p+KaPV4bYHgS9tARj9dYZOEAd0zJLsIeikprlMcdZoKpL5+GX
94FiE+ddUecsBFxse/BY3xYyh3Uu+R+bg/ryghFZI2sQ5vYz0eifA9s7pHLl
KEuIVcjj/PaeB7cF3TtsPnNYpXZVlIzPQ2n2ZumcZlMIPiweHnh2AUS8H2eV
pQOMhtru0p7/58NrgtGzJnCEPF+3KWgRjOXYvbuHDKE5JWcf6fcimEmWmmcp
6QMqY9056rsETuWBhhcf6UDpk2kP1uASoCrqF7b7aoOyXvZ4hfsyZPd1WN9t
0oCMKovQvO5lOC+iaZqvrQ68dpN/E104sOGCUeXygipc/HE7PuQLB3qr6Lsa
JVRAmv8/obeuK3BDflOtq4MivDfSy1jpWwGPzi4VobrNcMQ3Wgb1WQWpbBeT
vnBpWL3dlhv9exWEx4iNsxWScI+5eevH4DW4lR1YFXFOHJBF/xJ+zhro+idL
8GaIQK/qez27qL9Ae/tgsFZDEHB17h4mmYAymp6linTyQZXGxrcvLAiodfjC
mdOqPFCtrX4zK46A3ulJvLV3hgS1usiZ6AYCWqNWo5y2gwB1BvY2fgJEdJh1
76obnYPUG3uqHNxLRAMkT8RJnV1AmNQwApJCRL3UrQa/DMwgDeiNn1vaiOhW
jRrRiM4/SOPuu2VCYiT09aVs0yPh40jDmk9o4n4SelrNq4+wbxhhvtXV50sm
oV+eUun2rweQj8GE+ZhPJNTBclrdLbsPqddsek3iI6P6Ukc0uoe6kbrRWyGR
lmRUp2rj3shDnUht/gm9lWgyKiuiIPUi8AtSc1xz7nwVGX0gsexSKN2OVEtz
Xs2tkVHPU892z19vRpzVNs3kmHKhAtqxLWKODcikroG2zTUu1Cm6TCpjoRaJ
NT14ZraeC300vU7O1aEKkbE79+weHzdqHSC+firlPVJ6mD5mZcuNxu2MYyFX
yhEr75KtM8nc6HFDRS0l25dIz7nP3nfbuFFLyubZO/dLkJArY/k0cR5UTYlq
Gtv9FLnssFJUac+DytJqJKaC8pHryutf6aXwoB1prqH0qgcIfV62oqiJB83k
pPYvOd9Fspga1Ur8FHSybO7VRv3byMMsaMiiUdC0SK/uhD9pSJHf/laRGAo6
/50T88ozFSlD3L9dr6agJaFdZz4O30D+v0dREZTmtWVdLPI/eQQMOQ==
          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk4FPgfB/Bp3BG7btkmx3RRKPcwPrYwjnJFBz/X0G7KTVqFLAmLkULI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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlfs71Ikex+diTEZSWJKyyv3oYYVYt8830bidIk511uZWSi4pt5Ulp5WD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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk01H0fxseMMRlKiDZJIetti2yZ71+bJaGQu2RNcWcrWR6FSKJsyRJu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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk4FPgfB/Bp3BG7btkmx3RRKPcwPrYwjnJFBz/X0G7KTVqFLAmLkULI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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlXk41Iseh2fMMDE0JaRkyJJKN8fNIOL7Q4xcqdBmPaNTKdtJlkeH5NpP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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk31Psfx2cxM0Uh2YrETSKphJKl14eyX0shSdZKynazxh1SQrKXSghh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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk4FPgfB/Bp3BG7btkmx3RRKPcwPrYwjnJFBz/X0G7KTVqFLAmLkULI
5hxjEYpUlK8UjWLTpnKFNO4ZN8PMyK/f8+wvn+f5PO/n9e/nn/dHmRzoeAaL
wWCuftv/JfohZHBjQ6gZ8++4E3Krgls2zfNuif5yddMGDyV3vhTZdI1brQdF
SvC7x3aQZ2rW+b5bE2dzUkcU27zD/lg7W2K3zNyLbswVFUyzavCCWzBfqjrr
6a3ARiUeKmA+RDKfuvXDpBnHRalcpBMmquV/57EB55yWges+LjrIDFwr9kg0
FJRvx3APctCeWbcPWx2mCSkBMqPW9WuIvDfORs4z1kiy1as9l7CG9NNm5svX
hY2zFavuTjWtongPPpsKzVhjXAgnnXBkFaUIdGi6fWYZh+8qitB8ykaU+h19
YapOxM4eKy+8PhstW9XQk/SqifiUeUuFeytI+2rbsUnvdWIk5GiJq6+gzqmV
rwn3fjbpXjCV56MuIzNO/gE6JdJEvXRig41bRhXyycJ2KjUmsaevjzOzl1CE
iK+5cHqfSZ+YwZvPkksoVq3+L7dEDHRNCiVYpi0ilUdhXVXBO6G17aNJtegi
ipCL1vCyMICGYtqKTOICcmt7oq5FtIOamItVkfwLSMt/b0TAXi8odSP98iVm
Hj1tIjqGBAVBHkEOZ70+h368uiXKmy8SbsiNv6+JmEPHcoKBmh0P4pP+iprM
WeRtcdldIIcC2Odqq5UrM2i3RmLg5f6bwM4b71bbMoM+KPiKHPstG5jhJffK
RFko44EhRXs4D4btvSi7ZZnotXKms2VQAXSr4c6XKE2jX1M9W6wPFAGdv5+k
oj6F6PPyalKFxfBk8Ba+QHcSKXjfeTXXUQL3HjltwZlOIOzYRrnkQypYHqUz
RnXHkYhe6aO3YaUwNGREv6s+hlowR5JCuaUQHlpdcUF5FPmKL/KYzjTYJqSa
RpRjIF4VeX5XKg1KcrNCBLZ9QYVjIxdiaTQw0th6ohM7gpwrCLt6ymjwz7Mo
w8zVYWR8Tz6BduOby0cMGwaGUN39U++ifWggKcnfXz79CZ0/T27drkIDx4hd
kbc5/ai3N5/GaCuFG8MWO1JE+pCw66ywvX0pvCOdbYqU70GhCVf/4DRSQbo6
ycN/zwe0v0kgVl6YCk6yFRh3vW5kLcIe/6hdAhlRHYW25v8g1Xr75zVQDN0M
1mFw6kKHf3eYy/l2r+2jHlYzvR0oYM3GlyhUCMkYhpi7aDvSxzYWe2fnQ4A+
8yYx4Bk6SxbHh3rmAqIOV7lAIyqvcZ9gPb4FRQMTuoSiWmSURXNh4TKhYN+o
xGh+OmI1C24sGF8HXoo55+EHCqQfYFlte5QMtq4y8bZGZXBXu6Z/xi8Bqv7q
iL/oWQfR+UtZ7gVxUE8VbycVPwHSAd6WmOMxMGi/V1AstAXSeiYDe/guw4ht
+56wjDYg2LNSDS3CYezoOauBB6+ASLFxenEyBKasRc+bffwbmF8TkxkmAeDD
UPRbPvUWZpmHLuFO+YKT6v0iS4t3UKU56uzvcgbMyJa9t7XfA9XgT16IMhl0
CgclZpU+Ql+6AmC2ewB+OMzisHgvvE/o7GBhXUF6p2hUJrcPhKUcudQ3J4Hf
vbB2YmIAXH1e9y65OMNinv6U0YdBKGxOUZtOOA52OjVJUeHDkLsiq0lXdwR8
rhnu0++fwTkxAOvn7QCcjZ77xqkjUCYkaR61xwHenPEn5WV/gSMV1qk2lx2g
5PWWAW4xA46+LNHNCHCESwezglyrR+Fcn4LOJyUnsLulJtDYMAb7RVWXFF+e
APx6U872tnHwlKRX3q9zgacSfJSsjgnoOq1nVIf3hBMqpFjJd5MwcYIS9gDv
A7M6yeGU3ikIfW88vDzkC4mkN+e2Dk/DnZHhDrxYMCi7SHlcG2NCe6Nk1qPZ
cGjwO3kcy2IBv96K1ZPjV8Dxym1S9OIMiP0St2p3PR6m04eMOGuzMJxicA5f
kQrEw3GfyRfnQOn5tVXpVzchvlGWSp+fg9xrneLWkznQqVN+VsNvHjoZElN1
vxWATBVxf8bYPFS+jDJLkC0Btz1vZ9c8F+CoxDW2gQYNqAU+tR79C7DzAEtE
nFUGLIXV8FbnRUh362TIUcpA92YyQb1rEc7Wv+ZLRVSorH7OmXZagksEZXZy
TAGodHAbKnuX4MbAktWhhQzImdC+7O++DMK4wXxIiocfBPyMNL4sw2Mx3wtK
DsFwTbmEO/PrCpzPv/7AYtkJ1okDjdXMFWCI84+72h6CMBfpyKBgNkgNlhUn
bxOEqfCjxgdX2GBmqhZgHfTW5D98K60KIavQdeWP2lsbGSZ/p+XbYWdWAdMg
y5GZsTMx/cmqd8p3Dd6IKfcl7lsn3i9bIL8bXYPru+J7cpzuEPG6ecxGLw7c
4A3FmbO1iFnPzMNLPnFAF7ez/LRerbGw7exGymkutPqpkNJK8MaX+rKTLrzn
gmgqeayMGmekuHVc4rErD9LYP+8/ndlEeGKom8X7zAOjue2CzwMHDdez3xbF
zaxDpotPemjmC/1mdYFBOh/GVC+43aWIMHLw1ZE/6yWksKZuXnmYKK/Rn1oU
uXXLX/lM/9+vF2KmqSRpwe+OduRVNjlsOhG/rU43bdO5dI0W1a1C312cC+25
pE1X+tl3/Ri/6XoTr4+JLZv+91/47v8CZzLiHg==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1Xk81Ikfx/G5zOTIyGi2kisqardJuXLs55uELJb4Rc5S/fITiYYt5VjH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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk01H0fh2eMmRGKUkmWSriJJBGR+f5bLFGSrcWWaLGUStEtWZKlJ9uk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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ6I7P9suX9+F8OHI1cY
6pUYDsS317+a1PhR7O3e6fm7Ff7s/6uvsTBT11JZrujXRCvnH/uvit3mq2IP
0rjFY3H+odCX/VuPnNAo+ZysxfcyV1r/zfv93i/1t3iVfdLauCOEUc7hxX73
9/aXK0y4tC+temS56879/VsvO6xYZ8WjfeXJWyf7kAv7196MOnziPav2As2n
/E/nT9wfLHZrQeGMz1qvvLizXa6fsw/ntmV+aX9J6/Mc81fW1+7ZrxC3v75l
4nYtlb/7Zkode27/yS/XVVH2gNbrifetf/18b+9o82r1oWcftUwnd1tpX/hs
r33N+tVmOy7tV2U+NobfvtunREs9DeE21aq6NaOz9Opv+51pQmdmbH2udkCb
9d4JZgaHs74/WZr/u8qecp67jV+YyWHJo/MShmc9OQ5J/97y9R+zAyz8Shte
L3UXYYPz64L+rNkXiOB3qPBuMe1H8Ged0DukzMUO5y+eZX9yljuCvyYn4IJg
K4K/zS7xeschBB+aHuB8AAm80QI=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlXs0lAkfx8cMJoRiskXkukLvul9i6/cUG5WuiNAotlihiClCJGG1QuSe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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtVmk0VYsfvaNblDkpQ5mT95Qyy/mdTFdIQipDmZN3m4ReMt8rShEPSUqF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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ5YCTcwfvL04fxw5ApD
vRLDAcctVmoXZm6Sf7t3ev5uhT/7dbmbRUoO/NKWK/o10cr5x/4NIXMuiGkI
G97isTj/UOjL/oOFfo1XjFSN+V7mSuu/eb+/VKQ65erczcYbd4Qwyjm82M+6
uiz82/XTxpdWPbLcdef+fjWNz1sm/ztrfOXJWyf7kAv7w1fG1HzyO268QPMp
/9P5E/fL+ZSKKl7aYvzKizvb5fo5e6OJ1Rq8KZONP88xf2V97Z49/zHldQzc
lcYqf/fNlDr23P5f3dkOEflG49cT71v/+vneftZqmS3BrJuNTSd3W2lf+Gw/
9/lnk6uPThu/KvOxMfz23V5Y/FCnacw3o6pbMzpLr/62t0jT1VE2XKl/QJv1
3glmBoerBRVNK+LZ1U45z93GL8zkoOK23scyi1vwkPTvLV//MTvAwq+04fVS
dxE2OL8u6M+afYEIfocK7xbTfgR/1gm9Q8pc7HD+4ln2J2e5I/hrcgIuCLYi
+NvsEq93HELwoekBzgcAcKHJ/A==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlXs41IkexufCTO6Fdb8VlthDYraw+v4SEbJILTkhtLWFcS+WWJdkdUgS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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc7lY//x8/AMcqOsjKjlJFN537dhIOkSCKVSEYhyWiQJCTzHFGklGgg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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk4FPgfB/Bp3BG7btkmx3RRKPcwPrYwjnJFBz/X0G7KTVqFLAmLkULI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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlfs71Ikex+diTEZSWJKyyv3oYYVYt8830bidIk511uZWSi4pt5Ulp5WD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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk01H0fxseMMRlKiDZJIetti2yZ71+bJaGQu2RNcWcrWR6FSKJsyRJu
SbYkW6Wxxe9vRKMQWSP7kl2RffD0nPO8uM715nOucz7vrgN2bueuEAkEwos/
+V+j7e69m5sU3N8pZZu1iQBYaSTl32BQ8Kud97SEKbuBdZnhP3SPgpu8fJft
fG4fJEVMGJrpUHC7+pLUePEDoFbMt/8jJwXHAjvfEsli0N6vMatWz4G/u3iZ
cc5MAjyol1FOJAf+U9TEkOuQDPAph0UJneXAD6ZoXL0fKg+Flm+tI/k58KyW
6iweXSUoVnnw+msTGd9ZOMnZ7KQClVutSTsjyTi/8thoHLc6fBhRNrM4TcYl
deUEPDW14HMF9cWzLWSclRNaVUbWhq9x/ctDNez4WZ+/JbuZx6HTha4vGcSO
P/3U3Pl57hT0nQxPdsbY8d9MK0H3R/owus9upnCdhEvaOfSxCgxhVuuOhS0i
4U6eT3h17p+FZctkJm8gCbe5oZHftWoCbP6lKoxjJPxogvSsYsV5oKa0p7mz
k3BTDwrdqu0C8FfO84jWEvHbdNtcXgNLEOrd7tcSQsQvDLaGGcXZwKGNvyaC
9Ih4R36rfWCFHcgLnzZX5vrDy3cE/hK9AltMfHP3NbLhStQfTBXcAfpD8tgo
0Wy4+4mI8cvp16Dkfe/5nyZseKb67pHrLS7w6BdP7jdBNrwhNvqN0avr4HhI
m636GwHnfHwLVSa6A2bhfj43mYDfd2hkXC/xgF2P0l/FWRPwELe7k3NUb/j5
oZVw5yAB1/xUwvwV6wN2xg4FnvgmcvRCDNlEXxgSFLec1txECgFKp/eO3QH7
nkHqleINNBpn6Hq1OhBG01NLvittoPWWY5uKFUHgeM3qqmn+Onpc0PWKYzgY
JhSEdtRLrSO83eTrLY1QmK544lYuwkIPlyqP+wREgMeOYROuzDU0PKqbZyny
CFavKahZSK2hW/0vdvgkRkNAla/Qq7xVxLubft1bNgY4dtUR1hRXUcagjZpS
VyyEuwqM6NNXkJ7sePP19Hjgq7GtS9JYQSL+CWEjoQkg7L4arXF8GdXKHvOr
zEkGL/E0H/mKJeT6UdPJYvczaOjUsxVTXUJcQ2EG0W2p4AuJCttkFpF7SP0n
xeR0aJ3DdpEyF9CoOveZot2ZIJM1trkkvICerrYJmGRnQRe32pcBvt9If/Dx
F+6ll9A0TgnRjZpHlqd0FZPyXkFNbQetgGseXawq8FN2z4PCAO98X/Y59PyG
pkzLo0LYNu6yV35qFhkI3yuQv10ExGrp5dzFGbT00dBPwfkdLCX/aJVmm0Fz
Se1ENys69BvbRh4SnEI5n+T/cT1eAq3Swk4ZIpNoY6umn59yKTDZu3UOykyg
9yb2LEfRMnhdYsomjI0hlqawjNRSOegaMIdHVH6gkCUuF+L0e+jr02TmyYwi
cZf21e7uCthKEY3S2jmMjGrWiIxnCDKS4t3JW4fQ3cBScXV1HDTlqOcbiIMo
EkQ6i5Nx+JozqF72vQ/1pEgHEoyrgI+PvTtnsgepv7R9UpdYBed8xH3/Xe1G
XZKiHvj3Knjcf2pfOGcXahv2uRG5iwEtOo6Vvrs60Vi4uOuIAQN2FDywdpFo
RwHbI7wDfBhgKviKYHWkFTWc3bQRS2FArF/9c8OTXxH/NvdTqWUMaB2ePgam
TUixVXqloZEBe0as9Wa+1aPb5hG/nboYEEYY5rbiqkM3fF5fHelhAGuvY1PD
0RrkpsHbqPKNAa6qUzFarlXomP4Z2uV6BqDM/vyLUI7C6Nwm/sUMSPs+pqKR
9hadIUlypyUxgCox6HOYmo0+d4bFzHsyIFVqhGfkWTTKNbg7/Vzvz374ydXi
9kgwuDagIs3LAEMLgWBDzWyI5b8bdLqpCvJf1gd72xRBi/mB6CshVUDP3Fan
k/4eJOQetgweqYJeY0kO7pt/PGO6vVT7cBg0rJPwiK2FTIu3Ov0BOEzoczmd
6GiE0Zv8T8PsEdgP73Ve+LsZCqWrY+zjKsFU9E2a7qkW2J+jetemsgKUn/fy
zIp0QLz9twuPWOUwn6w6odneC5ahYUkxJ0rASLnwgZ9XP6SzGRW9PFoMYkkn
hHsCB6C+firDRpkOX6646CQnDEEvnVQ0dqgIxNYrE/fU/gDOoYaqHKVCqOAh
RcbXj8E5c/NZ14h8OH9Q5y5fyziIDY3ZTlflQqjOl2vU/knQ54j7SDV9CQcu
8lvfH52Cn7Pai/pvX0CZs7kJcXoaCNiP6sMHs2Ayuk9zdWUWOs4e/qtJIR20
jgUN2Hn/hLIhW0X9secQXC6Yyfz1E4Z4L0rfyE8FgXwt2djRX6BLycZTG5LB
UqJ5dsVmDkzMvMnodRJkptq/te6egyjvipCENwmgEhOmIdM0D0l12ocCtsRB
bkH16qTpb+CL7Bs/ox4DB+vXynK//YZKrWGYDY2GxLHDt12sFqB76OKt/Kko
2E521pQbWgBsh6zAJ0IE3D+QsTbjsAg3hms/fjn9ENa1vpcXTC1C2e/9jJOf
Q2DCy+Co4uIS1ElsUgwsg+ASabFmt/sy+JyQfhL5MBAao54ZEWeWQTbUnNeo
9A5gQnrfJv5ZgccRmBMrzRfeZM/ZtYysQMc/Th3ERh8QU0meKrddBbdodVfT
I94QX3XSK6NnFRwN//Oc1eEBWwxnN8MvrMGzZaqDWIE73OpKeODZtgZSlJ2l
AiXXYS/1B0+pBQsOBPEW7op3gffqKvGsARZ4e0bX9ey/Bpf+CRLCHNfBn7R2
So3sAOsJzWlBM+vwWTPa1JxmDynM/VIfPTaANknP66m2BdqySwF1bQOKDN1t
P+yzhj6J9yqGgZvwuK0xuFfRAnAZci+TRMA0JNrMiSXmUCW3q/T1SQI2sCWo
/s4bU2AoysQmhRCw2y8EAu04zsEHZZpbUB0Bc2V+njY0M4Ia1bP6zlxsGPfN
jF9UudNQq2EvbnaGDRPbozHJDNEBppY3gRbFhh2Vzy7ONj0BddjD7kPNbNjU
/bfHKaHa8On4UzoPPxF7qHEsoF2WBnUbjl7hxkTMqXb+7iV5DWCWKh/hjCRi
ojNxF+byj8BHD8Ji8GciRqmYoaOnh6FWvv4dkZOEPeBo+w6zClAz8cTzzikS
9ilzys9Y4S/4kHlZhRVEwgjGdMlUISmotpFf+E8VCctREhpVjBYHxt61ooUN
EnZBaI/Aa7+D8Lfk7vln2uzYcoyv98+j+2FWWVVR/x47Fv8r4I6q2R64r23m
9ruWHWtT2nJATkIQhAxv5qVwkrHeDlU180Q+eHMxelLXgIxVB+QIfpDmAV2H
Aqn5SDKmLpTVkcFDhd6bDQ5Pm8nYVT3vGBtEBs+AyUydHRzYKDb01VeICP7n
WLmVZzmwbbPSap5hG7RQsa1FKlEcmONlvQ9u9BVa9OK+8tx6DiwwaiY09t8F
WhJTjiFKpWBkkdBgf5E5WnoS1CXpULCB7V5Z9y7N0HKdjZt4gykYe8pSC8Vu
nEan2XaEMigYvzbhi5z8CO3//xIzDr8wbp41QPsvqDwQgg==
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk4FPgfB/Bp3BG7btkmx3RRKPcwPrYwjnJFBz/X0G7KTVqFLAmLkULI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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlXk41Iseh2fMMDE0JaRkyJJKN8fNIOL7Q4xcqdBmPaNTKdtJlkeH5NpP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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk31Psfx2cxM0Uh2YrETSKphJKl14eyX0shSdZKynazxh1SQrKXSghh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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk4FPgfB/Bp3BG7btkmx3RRKPcwPrYwjnJFBz/X0G7KTVqFLAmLkULI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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1Xk81Ikfx/G5zOTIyGi2kisqardJuXLs55uELJb4Rc5S/fITiYYt5VjH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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk01H0fh2eMmRGKUkmWSriJJBGR+f5bLFGSrcWWaLGUStEtWZKlJ9uk
cItkL9llHfz+dkoluyzZRgzZ17E993PO8+JzrhfXOdfrz75rTobXOQgEQty/
+x8R//3ejQ0qzhUicFxqGdEs1aIy7lVQcX1yk0X9jUraqk2Fx+AzKj7eGPP4
onctLSqIpW+iTcWv6mtrBtxuoKkWbNtTu4mKC2nRa9VkftDa+tQmVRso+L3A
qtzljBbaA24blBpMwV3ueC58HeigbVN6ESJygYLPGdSXbQz20LIscq2CBSj4
RXbyec+xflqB8vPspkYy/qFXLudcDZNWttmKJBhMxo+wgqOSb7JoVUwlEzM9
Mk6KiDtwb26S9qWUOyWWi4y3U2Ksh/VmaU2v+5YGqznx6DLve+snFmkdt/N1
pX04ce2hvKnC5RXaL83AaEeME7d5o0hz/0yAYdFrE1lrJLyVv83XVZQTJjU8
zawRCddv88fNq6iwZBFdt9WbhIfKR37V4eIFokeRcsVJEn45RiYyyosfuN+2
xd/nJOFOb6u9Za8LgEDZLN/+Gg6c8XpUmFa+E0R6+Z80+3PgGmUNyqrJu0Fq
/SDL5wwHnnrrZdWnv/bAITG9i0o8HLgLvZv/10Fx4DJyTxP9RsSrMiYO3hSV
hD7/dCKVTsTldLo94h5LQ2FJr+mU0b/+w8dQ3otyEDrNl9a5k4hPTlU+7rdS
gFtSJ4iVnQRcczmJ9H1QETCz+6Zp0QRc4MTAjFy5MuwKTfj42oqAj0/H2PRw
HIOpqhaCpzgBj5S0Dur8dByuGdzMfIhvoAuV8tuT4zEY3Clp8Ud9A21FJwaY
GqfAtmeA+3rBOvJO3SOof1QLhhPeFXYrriOHLfKry+Fn4Ja95Q3jjDU0MeOg
w+t4DlgKItsbZNaQ4vN8mmW/ATgudpafSlpFtoc032cbG8Gf0ggnxt5VxEpx
H60QNIUH24eMeJJWkIxl0NAM+xKw7RVUzWRW0PNvfOLSiubgVe4u8jGdjUby
O5ylqq2AsquesHKYjVqOmgft7LWGwDs7mLr5y8gmmXljhc8WtlVb10epLaPm
Lofz3e43IFI4I51VtoSOOup9DZGxA7H7bLraqSVU4vbHW0rYEVwk4/8+VLqI
VGVNCCjWCb52nLGWUFlEvLGG3arl90AicFpHKHsBOadcyKMxncEd/lHYIruA
uB43TqWBC7TMYLtISfNIPThj/8WWRyCbPLKxKDaPbmaJDounPIanl0N/j0fO
IYdh8lliiQf85FX93r9tDtm+nCpz5vGGxlGqv07ILFKSD2nd1PoUqmvaaZk8
syiZS0dbtOoZFCekLOwImEEZMkoebj/9IMvLNcOdcwbtPZmi1iv0HJIttG8M
ek2jEZttRlM+LyBaTVBMd20K/WlPlqTtDoYto7eFD41PoqgV4UdBI3TgqDyw
lLYwgSYtgsu1LMNgMfp3ywHiBIpTEefXHH0FfQbWwVI7x1HemHOCKBYJLQfE
HBL3jiEy2acN442COs4ubXFZFhqhyoYfnXgD2YXGRDFsBA0JPaNMzsSCztm6
Iabyb3Rpu7EiVTwOfv1Sr0uXHUY7erSSok3jYTN1f4iG4BDaz2WRt9yfCE2p
A8eKu38hvV7OT153UqFl6M9JMG5EhmvfJgWbcmA30+rMRGcDkrPbh8V45cIL
whCvJU890neblSyU+wR3VMbDNO6Uo3lcVZbtlgcoqS/jCjBQewipq1I4H+K7
R5TV4nPRh9N+YfYF+fBOhsnHjKWjqY1/ymK7C2A1UJNd0BYMO4x9dgnfLQR9
sx2++urv4e+hq3Z27ELI+NDg63r1E9y31b1b51YE+Ulb6rUTSuDrMlvKe6oI
eg2kKbzOFWDhG+48eqUYBvTr/3rwqgbOIb/y60XFMHzW/kx33mc4zSngbs/D
AJYuj8Pp9m8QPpp6/YkBA2yHhB3nL/2AGZ/BnJFnDDDenxOvo9UM/Ak37J3S
GXD6mk7nmyOtkBviT+quZ4BSXC/f5N52EDhe2sT1kwESfQ+0Tm7phFevP5v3
9TBg+x6eJ69XfsLlzFN+Fq0M4LSMyx0Z6YbyzO63L3AGzEarsNTbeqHD1UrH
L5YB55Wynj9x6QMH8kU3qTv/9qJOi/V49wPPXZmWKXkGsDc6co4HDUDi4VCG
1kAxfL9+Wzs6chAMdpg8iwkohsQvxO6VhCHoeqev+US8GNwOh981y2RCYpuz
l2dWEZyPOEBmFA+DxmhN/LkjRSCxVvbP7prfkPHc1Dr2YyGU8pGCwxtGYIG+
r3RBpBBMxbWfbmsehcZngXW5vgUQoP3dnrtvDIx4b4++wvJhjP5Lnb08CXM5
rH4n51xQDnuhJts4C74pQReEWj9CWmYle8x4DhRc3K70W6WCeMNKcVrnHLzN
9n9pPf0e+MmO6vKD80C1ZMbnyCWD377ElYmbC8DsmjYx7kiENY1uRub4AvAc
/Gx9PjgBWC5njx9eWIR1pkpTnXAcmJMWqoXuL8G1k3JSodR38C0k9jzHxBIc
LZRl7VyNgZz3M9eamcsgJ52iXioYBRLK0eMMazaE6c85tWtFQni5pktiDxsW
Dfe6KwaGg9vPyOcPW1egbdDhvcLlMBDm/s1XZLYKjsfsuL6X06HkmHL4av8q
mJaFHbt6KhTM7XxEsFtrsNti7ExEcRCsRf6I95lYg5K86Nly0Rfwtm6PTO2D
dcizO3qkICMAaEu3M7lX1iFzvLf1i4Mf4LLk3joSAbPqIOWK2zyFcvldRdma
BOyd8c/RN3FeUHFY9lWUPwELMISELxQPqFKiOfnUEzCT5HE6bH4M1SoXdB15
iNg3SVP1RsNHUKNmK2lyjoh56H75D2p+CHUargRaCBFbzY+zNgt0hnrsP11S
P4jYXUqtM+nve/D5VEw+nwAHprDUVGIu5wT167dcAg04sEeE2ousJQeoK1I6
uimYA+s7GZERtMUOah8QFny/cGBKiupbd926ATWHGvI4NpGwgktlonSCLVSz
Ih56apEweVs9vWPN1lCVZKO86kPCtsYJOQsWWEHl1UPzj8pJWCabneJxwBwq
hFc+za+TMH/CtpzgpUtwSVpoNvYEJ5b/NszF6JcJTCqpHNZ9xokNjSkERokZ
gd8JE6e5Gk7s6i5VkfF0AxDRd05/u4mMfZ/OutzDfQ5yrtDHdM6SMdeIDY0q
9TOgczNTZjaYjPWV2JYc6deEXuevN2N+kLFwieyu8YmT8NBrLEl7OwWj/J5e
LLmMgYfhalrZBQq2eNYtJ9TnOARIbP6kHELBpo3i6fM/VIG+IMpIa6BgWyq8
w0zpyhBVJ1+xn5uK9RIvR77MU4SEKKiP0qZiR7SaLiUdUYA0R4PGrb5UbCWJ
+OQvkhzk06zbAyqoWPrdqYfZctLw//+Heb6nuSY1S8B/AQHt9o8=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ6I7P9suX9+F8OHI1cY
6pUYDsS317+a1PhR7O3e6fm7Ff7s/6uvsTBT11JZrujXRCvnH/uvit3mq2IP
0rjFY3H+odCX/VuPnNAo+ZysxfcyV1r/zfv93i/1t3iVfdLauCOEUc7hxX73
9/aXK0y4tC+temS56879/VsvO6xYZ8WjfeXJWyf7kAv7196MOnziPav2As2n
/E/nT9wfLHZrQeGMz1qvvLizXa6fsw/ntmV+aX9J6/Mc81fW1+7ZrxC3v75l
4nYtlb/7Zkode27/yS/XVVH2gNbrifetf/18b+9o82r1oWcftUwnd1tpX/hs
r33N+tVmOy7tV2U+NobfvtunREs9DeE21aq6NaOz9Opv+51pQmdmbH2udkCb
9d4JZgaHs74/WZr/u8qecp67jV+YyWHJo/MShmc9OQ5J/97y9R+zAyz8Shte
L3UXYYPz64L+rNkXiOB3qPBuMe1H8Ged0DukzMUO5y+eZX9yljuCvyYn4IJg
K4K/zS7xeschBB+aHuB8AAm80QI=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlXs0lAkfx8cMJoRiskXkukLvul9i6/cUG5WuiNAotlihiClCJGG1QuSe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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtVmk0VYsfvaNblDkpQ5mT95Qyy/mdTFdIQipDmZN3m4ReMt8rShEPSUqF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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ5YCTcwfvL04fxw5ApD
vRLDAcctVmoXZm6Sf7t3ev5uhT/7dbmbRUoO/NKWK/o10cr5x/4NIXMuiGkI
G97isTj/UOjL/oOFfo1XjFSN+V7mSuu/eb+/VKQ65erczcYbd4Qwyjm82M+6
uiz82/XTxpdWPbLcdef+fjWNz1sm/ztrfOXJWyf7kAv7w1fG1HzyO268QPMp
/9P5E/fL+ZSKKl7aYvzKizvb5fo5e6OJ1Rq8KZONP88xf2V97Z49/zHldQzc
lcYqf/fNlDr23P5f3dkOEflG49cT71v/+vneftZqmS3BrJuNTSd3W2lf+Gw/
9/lnk6uPThu/KvOxMfz23V5Y/FCnacw3o6pbMzpLr/62t0jT1VE2XKl/QJv1
3glmBoerBRVNK+LZ1U45z93GL8zkoOK23scyi1vwkPTvLV//MTvAwq+04fVS
dxE2OL8u6M+afYEIfocK7xbTfgR/1gm9Q8pc7HD+4ln2J2e5I/hrcgIuCLYi
+NvsEq93HELwoekBzgcAcKHJ/A==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlXs41IkexufCTO6Fdb8VlthDYraw+v4SEbJILTkhtLWFcS+WWJdkdUgS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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc7lY//x8/AMcqOsjKjlJFN537dhIOkSCKVSEYhyWiQJCTzHFGklGgg
SkWl3LfZIVlHQxlHxttM9jjo0/e6vj88ruf1uK7nH/BQ8DjjcJJEIBAK/vF/
iwkH9fz9S8GnhuckxHMpcMw4q/hsNQVXk6OvuVgKwMqJ6sv91yg4PcCu191P
CLKSRu0O0ij4d9uNcRwRUTAsF938kY+Cm9P9bXZh4vCVbTxp2MSD14UI+138
KAnB/CewgmQe3L7X8LminjSI6iakyNjz4FiRGjVdbDM8P/rSLVns31+1MCOz
XAHK9eJftLdy48WRd89891CGyvVuZMlkblyYUqXw3UcVagd1D7ru4cbXmQpd
L2Ftg08f+B/n8HLjTtYjMtbFGtCezl7sr+PCPzme+KR7VRu++5fZqEVz4cIP
1yUfntKBXovEbD+UC/+19NjTpVAfhmQ9fj9fJeOKX2jy3uVGMEmNdHXHyPi2
n7ns2+xdsHg0mykSRcazbuyKsNFEgXj5rV61GRm3usUwVZAxA/57X3ODuMg4
eo7vgJ+xOYhVzggp1ZPwjYzG7RNJliDTIxzBiiPhulznA65LWcOWtR2j0dYk
vHkyLsRsYA9oyu05pCtAwq+aF9FMJu2A90B4kWwzEZd1PZ63VdIe2HHPiBQ6
ERdZjY2Q/uEAb973OP05QMTHcxSqw6sdIXVKqKhTgognqAlxnNudwGeLKbGm
k4BX/nSXeyfgAqhrkFNRNgE3sbtUkhfoCn9qOwiRigQ82SLj2QWP4+Cx37sk
BP+LUXdFcAxX3aFfQuXohMlfjO+2vLNE2Qnw7P7Ff7J8DUvyPaYonXwShh7e
f9O1cw0zEOAwDWK9wefUMS/H4lVMoc37HOT4wqiWjHjT1lXMWViZ0d95GiY+
3DpTIb+CKbGN3xFdAyFYfOCAQD4Ho9K3UAnpZ2H5lJah61YOdmUHy1muJwh4
NjYQONrL2NHSBPK+uyEgF7RMN969iG1iYaVBHy9BqEruBc0PCxh2wO6d2a0I
+Pzd2l3ZYAE79TkyixUcCeGQqSWoPo8RU2j7qAVR8GOdYUuf6Czm9HySubMy
BlpHKHFWKTPYeeW78WK1sVBX/w0pEZjBuJtu8KCNcfD8SlhxONc0VhbectKC
FQ+PjtK8+q9MYazWKf1R1g3INpaUs1n9g9k/2OAa2poAgiP+0prjk1jYjoqu
zDdJQKrZtlg0/xuTITkP+DOSYSH7v45txN9YSVKe7XPPFBgPzXvxRGACe1JI
WTKUTAX2fvfkLRLj2OWiHb6eYanQsU3udJ78GLa96s2QT3sqMLl+0hTVRzGx
pX6tTlU6vO+5pXxfbwRLaGzX3BtGhxdvHIly6DAmxGvx0QOng5Utc2BQ7z9M
gS/EhIeXAb29Jsxn6kOYsgGt34nGgNBzJYUhCoPY+t1G5XMRDFhPUUqhSg5g
e80f8qQWMiAvKyOIe30/lt64w4rdwgATDX6nz6Rf2Fyxd2PxKAPaqyKM0hfZ
WNh+XrN2zj8v+GX0rqsXu9bdp6NFTgNRUa6fBWPdmPbhbpYuMQ0cLqiE31n+
iW2vfjHybJ4BDLalbCLfD6zukNTjp/0MYNF8KsM3fseU0+dyTZkMEC+Jd/NX
/Yp1i43mZOUxwFGikHBMvwMzC7YwHjjPgJsRTQ/sLNoxfYLEZWcLBnQMTJiB
YyvWl8X0MuFngNSgm/XvzibMuHSYY9RAhwTCwLpjAg0YJypxNimKDivSPq2f
d9Vhs4rmBSk6dAgwGE+jBlRhZfe2KdzrTQUsn118GCqw/Zu8aHKxqZDbNaxn
nPsS264YpX5RNRXubx0UGsyhY4fW65hxvU2GlUSL5fKvyeB4fEEwrSUJ7Fw3
xNiZPIFf4oImh3oSoSxfsIH28D0stI2Fmo3cgFEbgdPm35ohjimAhnyJBc8B
ab855zYIitFyneuNAUel0lwrSxZcY02/vDR2DXQf9AhNyn+Dgwu8LS94o0GZ
HWxpJtgJtykrnBbpqyC+WSAinfMDHh/+0dGyMwpmsg1GTb72gJkm19z17suw
T/d5fEQoG6jczdy+3BGgnGUu1x3VB2pNDTY2Jpeg5aQ/Lft2P0A8JJR0hEHe
J2IX5+EAoKuv7ucbhcJF7YxA15JBMGg9whVdEgzKq5WZUvX/QWkGFurYchY+
CJGTM5qGwbhZJQmLDAQnRdpVUdYInKI+2nbyagBM6iaEJneOQqvQ02ItVT+4
Tms5xc8egwqLQp/4CV9QOCzmFjs0Dvujjl6Z6PCGd36HDpAmJmDDV7n6110n
YYzea7K8NAk3pzNJejYeQDWL7vMI+wPUtFL7IeZxiKmQyGdO/YH0v5kRqlXH
4LNugY+G3xQsoj3xefJHYEMxdfvNoSm4QHLQcSl2gaOqbZNLx6fhvp+83R6f
Q5B/3/Ol289p+KaPV4bYHgS9tARj9dYZOEAd0zJLsIeikprlMcdZoKpL5+GX
94FiE+ddUecsBFxse/BY3xYyh3Uu+R+bg/ryghFZI2sQ5vYz0eifA9s7pHLl
KEuIVcjj/PaeB7cF3TtsPnNYpXZVlIzPQ2n2ZumcZlMIPiweHnh2AUS8H2eV
pQOMhtru0p7/58NrgtGzJnCEPF+3KWgRjOXYvbuHDKE5JWcf6fcimEmWmmcp
6QMqY9056rsETuWBhhcf6UDpk2kP1uASoCrqF7b7aoOyXvZ4hfsyZPd1WN9t
0oCMKovQvO5lOC+iaZqvrQ68dpN/E104sOGCUeXygipc/HE7PuQLB3qr6Lsa
JVRAmv8/obeuK3BDflOtq4MivDfSy1jpWwGPzi4VobrNcMQ3Wgb1WQWpbBeT
vnBpWL3dlhv9exWEx4iNsxWScI+5eevH4DW4lR1YFXFOHJBF/xJ+zhro+idL
8GaIQK/qez27qL9Ae/tgsFZDEHB17h4mmYAymp6linTyQZXGxrcvLAiodfjC
mdOqPFCtrX4zK46A3ulJvLV3hgS1usiZ6AYCWqNWo5y2gwB1BvY2fgJEdJh1
76obnYPUG3uqHNxLRAMkT8RJnV1AmNQwApJCRL3UrQa/DMwgDeiNn1vaiOhW
jRrRiM4/SOPuu2VCYiT09aVs0yPh40jDmk9o4n4SelrNq4+wbxhhvtXV50sm
oV+eUun2rweQj8GE+ZhPJNTBclrdLbsPqddsek3iI6P6Ukc0uoe6kbrRWyGR
lmRUp2rj3shDnUht/gm9lWgyKiuiIPUi8AtSc1xz7nwVGX0gsexSKN2OVEtz
Xs2tkVHPU892z19vRpzVNs3kmHKhAtqxLWKODcikroG2zTUu1Cm6TCpjoRaJ
NT14ZraeC300vU7O1aEKkbE79+weHzdqHSC+firlPVJ6mD5mZcuNxu2MYyFX
yhEr75KtM8nc6HFDRS0l25dIz7nP3nfbuFFLyubZO/dLkJArY/k0cR5UTYlq
Gtv9FLnssFJUac+DytJqJKaC8pHryutf6aXwoB1prqH0qgcIfV62oqiJB83k
pPYvOd9Fspga1Ur8FHSybO7VRv3byMMsaMiiUdC0SK/uhD9pSJHf/laRGAo6
/50T88ozFSlD3L9dr6agJaFdZz4O30D+v0dREZTmtWVdLPI/eQQMOQ==
          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk4FPgfB/Bp3BG7btkmx3RRKPcwPrYwjnJFBz/X0G7KTVqFLAmLkULI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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlfs71Ikex+diTEZSWJKyyv3oYYVYt8830bidIk511uZWSi4pt5Ulp5WD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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk01H0fxseMMRlKiDZJIetti2yZ71+bJaGQu2RNcWcrWR6FSKJsyRJu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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk4FPgfB/Bp3BG7btkmx3RRKPcwPrYwjnJFBz/X0G7KTVqFLAmLkULI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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlXk41Iseh2fMMDE0JaRkyJJKN8fNIOL7Q4xcqdBmPaNTKdtJlkeH5NpP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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk31Psfx2cxM0Uh2YrETSKphJKl14eyX0shSdZKynazxh1SQrKXSghh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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk4FPgfB/Bp3BG7btkmx3RRKPcwPrYwjnJFBz/X0G7KTVqFLAmLkULI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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1Xk81Ikfx/G5zOTIyGi2kisqardJuXLs55uELJb4Rc5S/fITiYYt5VjH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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk01H0fh2eMmRGKUkmWSriJJBGR+f5bLFGSrcWWaLGUStEtWZKlJ9uk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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ6I7P9suX9+F8OHI1cY
6pUYDsS317+a1PhR7O3e6fm7Ff7s/6uvsTBT11JZrujXRCvnH/uvit3mq2IP
0rjFY3H+odCX/VuPnNAo+ZysxfcyV1r/zfv93i/1t3iVfdLauCOEUc7hxX73
9/aXK0y4tC+temS56879/VsvO6xYZ8WjfeXJWyf7kAv7196MOnziPav2As2n
/E/nT9wfLHZrQeGMz1qvvLizXa6fsw/ntmV+aX9J6/Mc81fW1+7ZrxC3v75l
4nYtlb/7Zkode27/yS/XVVH2gNbrifetf/18b+9o82r1oWcftUwnd1tpX/hs
r33N+tVmOy7tV2U+NobfvtunREs9DeE21aq6NaOz9Opv+51pQmdmbH2udkCb
9d4JZgaHs74/WZr/u8qecp67jV+YyWHJo/MShmc9OQ5J/97y9R+zAyz8Shte
L3UXYYPz64L+rNkXiOB3qPBuMe1H8Ged0DukzMUO5y+eZX9yljuCvyYn4IJg
K4K/zS7xeschBB+aHuB8AAm80QI=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlXs0lAkfx8cMJoRiskXkukLvul9i6/cUG5WuiNAotlihiClCJGG1QuSe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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtVmk0VYsfvaNblDkpQ5mT95Qyy/mdTFdIQipDmZN3m4ReMt8rShEPSUqF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          "]]}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      Frame->True,
      GridLines->{{-0.4920407313793702, 0., 0.06412815726441032}, None},
      PlotRange->{{-3, 3}, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {977.1428571428571, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {360., 291.2461179749811}], InsetBox[
     GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJx1lGtIk2EUx03EjPqkJEFRGnRZgmWZWlKPRLWKSDFTupkJIhYUZhf9INlI
IxtFRd4ICU3SWqmhBrN8XjNE2+q1DQ3nZl42U1nTD15Ak0q3/yOc0Qvj8IPt
fX475/yfwOTLsSmeHh4eBf8+89X5+Eior17OP56CNQs8w8HO34wLTjwx/3QK
PupkBp79M/+MCa50vk9wlfO8KOJBWXjRCj8w/MDwA8MPDD8w/MDwI32h7OYB
phV+YPiB4QeGHxh+YPiROVF26wv1ANMKPzD8wPADww8MP7I3lN3mRPtCPcC0
wg8MPzD8wPAje0zZbW/onGhfqAeYVviB4QeGH8kVZbc9pntD50T7Qj3AtMIP
DD+Sc8puuaJ7TPeGzon2hXqAaYUfuXcou+Wc5oruMd0bOifaF+oBphV+/7sX
6T1Ec09zRvea7hGdG+0T9aIV5wWoE94Hl6lFPqOKpj4ph4zs0P40a6dqUuy/
zbJp7ZLT7vnw7X1jLj2rFzk+GKqr7qjTCpae7v46oM4X3//wS1PrpZEEa0Ku
h0VWyyz1XLL57eNR8f6kgj2bnkhWwXUlIVaHySL4qr5j1ibLYq+8zJFN4b6S
YA+bVpG0PkVw4zJz1mFD02KeJ1Uzho0yp7mR8p39AJ9w9aNivCEz0mdQvM+c
8/CtWbGYu/MHFvol2OHsF6P3y++lqsb6mz8Fb9OOBgTOdYl+XIqL2J4btJjv
ucn+7K1do4LVhffau3OGBK/etXPl7aABwfH1H5rPaHrE/5lynQde5ToP85Wy
pu8qpTyO+TZb6s0xI0aWvu7Y8edxdn5l8+B05JyOh/3ISHcUDfPl0RN9bWu0
fLa0+EGExcozC35dCll6n/FE/loV2M/jTQmlR2SJ+ez5XFisM/F9PdKG9U0y
syve6QxTVpZkyk8te3aHb/cs6Ws5PMYaT971twwbWYN33pD/tx4e/SI1fN1H
O/O7tlKO6nTw4Itb3hlffmffLe1+vrF6ptMrTd1pdlZSHjFeVKZlbWlnMiqr
hplU7rfr0XQ+b/VOX3FjxMqUrXv53hqJt5TnVhxQ9LOYWPspr1qZq26FZm82
mNgF5/9nOTuyM+JrbKzXNa8v+okvJ5u72F9XYXsD
       "], {{{}, 
         {RGBColor[
          0.4283246773633719, 0.17918886798604117`, 0.1795906802380395], 
          EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwNw8eSmgAAAFDXsmoUEBtFUEARu6A4s2PDhgKiKCLFtbs55w9yzS2nfHD2
zTz6+ct8+n0+37/vge/xNz/8Hk6GI4nQeyoSZRA0AAJ0FhHKHBQMAf5APpWm
Mtl09AcKgB/NFhgIZmNxMpni2XKHq9QKVJ2iGzTjB+JBCJxvN7kyW8LwCpln
8ZxYrfVq9XKOaJfYJlPkCLJVLCmjMQEnkTiwnS/uR1sSezt5ebOOF/PQb/MP
2xl3xaHQ2czm+nRmLGRNmsj9wXIwVMdSLgE/HffLO7mbrbc1HH0z4AUcSmAg
VESxl+vZa/1k7N7isevBOmrr8960VO2gqOZKWdvH2UaXd0YklXyHE+EkHE2n
ABQBMRTCsUQOR4sMTORwthTLZlJ5MktTCENnqEIcyWKlYnc8IitcoVal6jW6
UWeajWKrWWq3FsaW5dtcR6j1xKrYLQs8wZX5QV8YDn42/oQSUJIk1pOp9/Xa
uM5krUma2ptIojTWHbsvLwZLeaSstKP1MZ/9nv6d6mvlYB7vt8P1Yt2u5uWs
Wgfj5G091309nedjZe7tx32sKvvz539ei1of
             "]], 
            PolygonBox[{{149, 68, 67, 131}, {144, 66, 65, 126}, {122, 58, 68, 
             149}, {103, 53, 43, 133}, {113, 56, 66, 144}, {131, 67, 56, 
             120}, {140, 46, 47, 118}, {120, 56, 46, 140}, {124, 64, 53, 
             103}, {105, 45, 56, 113}, {118, 47, 58, 122}, {135, 44, 45, 
             105}, {133, 43, 44, 101}, {142, 65, 64, 124}}]}]}, 
         {RGBColor[
          0.7165573136132635, 0.1747756171346919, 0.17629054701109748`], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{143, 142, 124, 125}, {125, 124, 103, 104}, {141, 140, 
            118, 119}, {121, 120, 140, 141}, {106, 105, 113, 114}, {123, 122, 
            149, 150}, {114, 113, 144, 145}, {134, 133, 101, 102}, {132, 131, 
            120, 121}, {145, 144, 126, 127}, {119, 118, 122, 123}, {150, 149, 
            131, 132}, {127, 126, 142, 143}, {136, 135, 105, 106}, {102, 101, 
            135, 136}, {104, 103, 133, 134}}]]}, 
         {RGBColor[
          0.8385112431145827, 0.2715619635285623, 0.27544784067205297`], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{102, 54, 134}, {141, 57, 121}, {123, 57, 119}, {125, 
             54, 143}, {104, 54, 125}, {150, 57, 123}, {119, 57, 141}, {134, 
             54, 104}, {132, 57, 150}, {121, 57, 132}}], 
            PolygonBox[{{137, 136, 106, 107}, {107, 106, 114, 115}, {115, 114,
              145, 146}, {146, 145, 127, 128}}], 
            PolygonBox[{{110, 54, 102, 136, 137}, {128, 127, 143, 54, 
             110}}]}]}, 
         {RGBColor[
          0.8888756807345031, 0.44449700943972825`, 0.4516334989679872], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{116, 115, 146, 147}, {111, 110, 137, 138}, {147, 146, 
            128, 129}, {129, 128, 110, 111}, {138, 137, 107, 108}, {108, 107, 
            115, 116}}]]}, 
         {RGBColor[0.9306785570592891, 0.667100457458651, 0.6753911282479358],
           EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{117, 116, 147, 148}, {112, 111, 138, 139}, {139, 138, 
            108, 109}, {109, 108, 116, 117}, {130, 129, 111, 112}, {148, 147, 
            129, 130}}]]}, 
         {RGBColor[
          0.9857832592646734, 0.9344428294789726, 0.9366592113288312], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{112, 55, 130}, {148, 55, 117}, {117, 55, 109}, {109, 
            55, 139}, {139, 55, 112}, {130, 55, 148}}]]}}, {{}, 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{139, 112, 130, 148, 117, 109, 139}]},
           "0.25`"],
          Annotation[#, 0.25, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{138, 111, 129, 147, 116, 108, 138}]},
           "0.2`"],
          Annotation[#, 0.2, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{137, 110, 128, 146, 115, 107, 137}]},
           "0.15`"],
          Annotation[#, 0.15, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{134, 104, 125, 143, 127, 145, 114, 106, 136, 102, 134}], 
            LineBox[{141, 121, 132, 150, 123, 119, 141}]},
           "0.1`"],
          Annotation[#, 0.1, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{103, 133, 101, 135, 105, 113, 144, 126, 142, 124, 103}], 
            LineBox[{120, 140, 118, 122, 149, 131, 120}]},
           "0.05`"],
          Annotation[#, 0.05, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], LineBox[{2, 12, 11}], 
            LineBox[{8, 19, 30}], LineBox[{71, 82, 93}], 
            LineBox[{90, 89, 99}]},
           "0"],
          Annotation[#, 0, "Tooltip"]& ], {}, {}}}],
      AspectRatio->1,
      Frame->True,
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {1368., -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {360.0000000000002, 291.2461179749811}], 
    InsetBox[
     GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJx1lQk0lGsYx8dY0zJCpdBqGVzq6Ca5uq/LVVxFlIpriZtKspXKlYhjKbRf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       "], {{{}, 
         {RGBColor[0.5106289462968165, 0.4160575011315587, 0.328777527414184],
           EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{12, 1, 2}, {93, 82, 83}, {71, 82, 81}, {95, 84, 
             85}, {87, 98, 97}, {188, 23, 106}, {30, 19, 20}, {40, 29, 30}, {
             29, 18, 19}, {32, 21, 22}, {85, 96, 95}, {86, 97, 96}, {88, 99, 
             98}, {79, 90, 89}, {83, 72, 73}, {96, 85, 86}, {78, 89, 88}, {81,
              92, 91}, {82, 93, 92}, {89, 100, 99}, {84, 95, 94}, {83, 94, 
             93}, {42, 31, 32}, {174, 78, 223}, {128, 39, 142}, {196, 32, 
             116}, {73, 62, 63}, {23, 12, 13}, {22, 11, 12}, {19, 8, 9}, {80, 
             69, 70}, {84, 73, 74}, {82, 71, 72}, {89, 78, 79}, {90, 79, 
             80}, {182, 14, 102}, {20, 9, 10}, {18, 7, 8}, {52, 41, 42}, {50, 
             39, 40}, {205, 42, 130}, {72, 61, 62}, {94, 83, 84}, {17, 6, 
             7}, {104, 17, 110}, {14, 3, 4}, {13, 2, 3}, {62, 51, 52}, {110, 
             17, 186}, {101, 5, 180}, {7, 18, 17}, {1, 12, 11}, {115, 23, 
             188}, {195, 39, 128}, {100, 89, 90}, {29, 40, 39}, {99, 88, 
             89}, {97, 86, 87}, {8, 19, 18}, {3, 14, 13}, {2, 13, 12}, {98, 
             87, 88}, {21, 32, 31}, {61, 72, 71}, {171, 74, 169}, {51, 62, 
             61}, {52, 63, 62}, {159, 63, 157}, {212, 60, 156}, {63, 74, 
             73}, {41, 52, 51}, {31, 42, 41}, {223, 78, 175}, {69, 80, 79}, {
             62, 73, 72}, {218, 69, 168}, {19, 30, 29}, {92, 81, 82}, {177, 
             86, 226}, {74, 85, 84}, {178, 87, 227}, {167, 69, 218}, {73, 84, 
             83}, {72, 83, 82}, {11, 22, 21}, {9, 20, 19}, {105, 14, 182}, {
             12, 23, 22}}], 
            PolygonBox[{{144, 50, 60, 212}, {181, 13, 14, 105}, {220, 70, 69, 
             167}, {157, 63, 52, 145}, {187, 22, 23, 115}, {106, 23, 13, 
             181}, {169, 74, 63, 159}, {156, 60, 70, 220}, {114, 29, 39, 
             195}, {175, 78, 88, 228}, {228, 88, 87, 178}, {116, 32, 22, 
             187}, {227, 87, 86, 177}, {145, 52, 42, 205}, {103, 6, 17, 
             104}, {176, 85, 74, 171}, {102, 14, 4, 179}, {186, 17, 18, 
             112}, {142, 39, 50, 144}, {180, 5, 6, 103}, {226, 86, 85, 176}, {
             225, 79, 78, 174}, {112, 18, 29, 114}, {130, 42, 32, 196}, {179, 
             4, 5, 101}, {168, 69, 79, 225}}]}]}, 
         {RGBColor[
          0.6692022335481724, 0.5306536097066918, 0.35210084202014436`], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{107, 15, 184}, {144, 49, 142}, {216, 68, 166}, {204, 
             49, 143}, {161, 64, 158}, {145, 53, 157}, {114, 28, 112}, {101, 
             15, 179}, {159, 64, 169}, {197, 33, 118}, {165, 68, 216}, {173, 
             77, 222}, {228, 77, 175}, {172, 76, 221}, {187, 33, 116}, {117, 
             24, 190}, {220, 59, 156}, {206, 43, 132}, {103, 16, 180}, {212, 
             49, 144}, {179, 15, 102}, {211, 59, 155}, {171, 75, 176}, {205, 
             53, 145}, {196, 43, 130}, {177, 76, 227}, {178, 77, 228}, {115, 
             33, 187}, {225, 68, 168}, {105, 24, 181}, {113, 28, 126}, {190, 
             24, 108}, {195, 28, 114}, {176, 75, 226}, {167, 59, 220}, {181, 
             24, 106}, {104, 16, 103}, {174, 68, 225}, {112, 28, 186}, {109, 
             16, 185}}], 
            PolygonBox[{{158, 64, 53, 147}, {143, 49, 59, 211}, {180, 16, 15, 
             101}, {222, 77, 76, 172}, {221, 76, 75, 170}, {156, 59, 49, 
             212}, {130, 43, 53, 205}, {132, 43, 33, 197}, {116, 33, 43, 
             196}, {170, 75, 64, 161}, {227, 76, 77, 178}, {184, 15, 16, 
             109}, {226, 75, 76, 177}, {169, 64, 75, 171}, {157, 53, 64, 
             159}, {147, 53, 43, 206}}], 
            PolygonBox[{{126, 28, 195, 128, 129}, {224, 223, 175, 77, 173}, {
             118, 33, 115, 188, 189}, {108, 24, 105, 182, 183}, {183, 182, 
             102, 15, 107}, {155, 59, 167, 218, 219}, {185, 16, 104, 110, 
             111}, {129, 128, 142, 49, 204}, {219, 218, 168, 68, 165}, {189, 
             188, 106, 24, 117}, {111, 110, 186, 28, 113}, {166, 68, 174, 223,
              224}}]}]}, 
         {RGBColor[
          0.7678924160706422, 0.6071501472416859, 0.3465583021177923], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{183, 25, 108}, {113, 27, 111}, {189, 34, 118}, {224, 
             67, 166}, {209, 58, 154}, {199, 34, 120}, {119, 25, 192}, {147, 
             54, 158}, {121, 26, 194}, {161, 65, 170}, {131, 34, 199}, {206, 
             54, 147}, {162, 66, 213}, {149, 54, 146}, {211, 48, 143}, {129, 
             38, 126}, {219, 58, 155}, {164, 67, 214}, {203, 48, 140}, {107, 
             25, 183}, {172, 66, 222}, {109, 26, 184}, {117, 34, 189}, {170, 
             65, 221}, {173, 67, 224}, {111, 27, 185}, {204, 38, 129}, {165, 
             58, 219}}], 
            PolygonBox[{{213, 66, 65, 160}, {221, 65, 66, 172}, {133, 132, 
             197, 198}, {214, 67, 66, 162}, {143, 48, 38, 204}, {222, 66, 67, 
             173}, {160, 65, 54, 149}, {158, 54, 65, 161}, {185, 27, 26, 
             109}, {124, 27, 38, 127}, {126, 38, 27, 113}, {155, 58, 48, 
             211}, {184, 26, 25, 107}, {192, 25, 26, 121}, {140, 48, 58, 
             209}, {127, 38, 48, 203}, {194, 26, 27, 124}}], 
            PolygonBox[{{198, 197, 118, 34, 131}, {191, 190, 108, 25, 119}, {
             154, 58, 165, 216, 217}, {120, 34, 117, 190, 191}, {217, 216, 
             166, 67, 164}, {146, 54, 206, 132, 133}}]}]}, 
         {RGBColor[
          0.8620251606600939, 0.7419251089619028, 0.4919112403922754], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{125, 37, 138}, {151, 55, 148}, {207, 57, 153}, {127, 
             37, 124}, {164, 57, 217}, {217, 57, 154}, {119, 35, 191}, {131, 
             44, 198}, {198, 44, 133}, {124, 37, 194}, {152, 57, 207}, {191, 
             35, 120}, {160, 55, 213}, {203, 37, 127}, {134, 35, 201}, {133, 
             44, 146}, {149, 55, 160}, {201, 35, 123}}], 
            PolygonBox[{{193, 192, 121, 122}, {146, 44, 55, 149}, {148, 55, 
             44, 135}, {215, 214, 162, 163}, {141, 140, 209, 210}}], 
            PolygonBox[{{138, 37, 203, 140, 141}, {123, 35, 119, 192, 193}, {
             153, 57, 164, 214, 215}, {163, 162, 213, 55, 151}, {135, 44, 131,
              199, 200}, {122, 121, 194, 37, 125}, {200, 199, 120, 35, 134}, {
             210, 209, 154, 57, 152}}]}]}, 
         {RGBColor[0.9433945421407739, 0.9130548165202323, 0.804407102640674],
           EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{151, 56, 163}, {122, 36, 193}, {134, 45, 200}, {163, 
             56, 215}, {141, 47, 138}, {193, 36, 123}, {210, 47, 141}, {152, 
             47, 210}, {215, 56, 153}, {125, 36, 122}, {200, 45, 135}, {135, 
             45, 148}}], 
            PolygonBox[{{150, 56, 45, 137}, {138, 47, 36, 125}, {136, 36, 47, 
             139}, {148, 45, 56, 151}}], 
            PolygonBox[{{137, 45, 134, 201, 202}, {139, 47, 152, 207, 208}, {
             202, 201, 123, 36, 136}, {208, 207, 153, 56, 150}}]}]}, 
         {RGBColor[0.976303, 0.999222, 0.999207], EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{150, 46, 208}, {202, 46, 137}, {139, 46, 136}, {137, 
            46, 150}, {136, 46, 202}, {208, 46, 139}}]]}}, {{}, 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{202, 137, 150, 208, 139, 136, 202}]},
           "1"],
          Annotation[#, 1, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{193, 123, 201, 134, 200, 135, 148, 151, 163, 215, 153, 
             207, 152, 210, 141, 138, 125, 122, 193}]},
           "0.8`"],
          Annotation[#, 0.8, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{191, 120, 199, 131, 198, 133, 146, 149, 160, 213, 162, 
             214, 164, 217, 154, 209, 140, 203, 127, 124, 194, 121, 192, 119, 
             191}]},
           "0.6`"],
          Annotation[#, 0.6, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{183, 108, 190, 117, 189, 118, 197, 132, 206, 147, 158, 
             161, 170, 221, 172, 222, 173, 224, 166, 216, 165, 219, 155, 211, 
             143, 204, 129, 126, 113, 111, 185, 109, 184, 107, 183}]},
           "0.4`"],
          Annotation[#, 0.4, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{179, 102, 182, 105, 181, 106, 188, 115, 187, 116, 196, 
             130, 205, 145, 157, 159, 169, 171, 176, 226, 177, 227, 178, 228, 
             175, 223, 174, 225, 168, 218, 167, 220, 156, 212, 144, 142, 128, 
             195, 114, 112, 186, 110, 104, 103, 180, 101, 179}]},
           "0.2`"],
          Annotation[#, 0.2, "Tooltip"]& ], {}, {}, {}}}],
      AspectRatio->1,
      Frame->True,
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {1758.8571428571427`, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {360.0000000000002, 291.2461179749811}], 
    InsetBox[
     GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJx11ns41PkeB3AKR7mEY5WOE6nc0xSlR21f0WqKWkUW7SLpVLJySku3QyrZ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       "], {{{}, 
         {RGBColor[0., 0.09543998693346434, 0.01614712196202849], EdgeForm[
          None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNlL1Sk1EQhk+MQNRACMFYSDA0QKThx1RAQoGQAAkaggiohAA6zjjQauN1
cBM0dvbQWFCgtVeg9+D7zvd8I8UzX/bs2T173t2Tse5Z6/ROCOGzSIq0SAiv
5cUD1s7FtLgQ8/yeEdeiIe4raIG1WTEk+kRKDIoe0Ssy4i52UTzknCx+x4yx
9khUxJx4Jg5EW2yLv2JKfBVl8RTb54+LCbEqWuKleC5eiE1RJ8+WWBevyDmA
Bq6vht/xHfzelxOjosA9fc4k9ZWoY1jcsybsT2G/I2ebHDn2LlNXk7xD+H6h
wXvxhnu4nj32+z5vWduiPt9nQ+zwbVD7Gr5dznF8P31O4q+KJfGauCZaVfD9
IGdKvV4J0RwsUIf1XSHvMnaLHtS4R5ozrdGTEPV/iq97/lE8Fl/Eb9Y+ofEI
2oyzZwTdC2jZptY1tKhhX1JPMhHdwX0qk8NzmSVXFt0P0XGHXNvkTnOHPHoN
cBfPSga7S5z1O0Zr9+qINdsJcvld9VBD5lYdrsvzkqOeXnyDxPh8v5lF7riK
XUTTPuKy9Laf8/LoWeScCbT8E6K3fI6Wk/ji3sS98rdE7gI5HD9DvN9ohbqs
cRXbuWbZV8I3h+3ZmSd3GZ/fyTD3r5Gvgn+JvI7xrHnGNtF4F/86fTuhJzfE
18n3Ab1/hv/vxP1u0CPbTfLFPTu+1cMj+lzlnDrxnpsO8V1sz5xn7ypEM+T/
r/g/wF+/3e/U/S1E78Vr8Vv3dz9EM9gh/h8Ya1VC
             "]], 
            PolygonBox[CompressedData["
1:eJwtzz0OAVEUhuE7IiGSQaJQqKaZRqNRaRRUmMISJBiJzNQKVjJbUNDpSUQh
8VNbAXvwnsxXPLk39+d85wSzdJoUnHMNFHFEH11k2KGNAB+8UEMdMaqecxHr
BHdcMVKNE0rcD1kHOOOAnsvP7C5TlmX8sFZWE2/s0dEf+/uAb7mY46m99bRE
mZpj9WC9bNBCiC0Wqu2rVqxZ7M1Kb0JlfnFR75FmrXj5rJZxwx/DXB39
             
             "]]}]}, 
         {RGBColor[0., 0.286319961746909, 0.048441366046222845`], EdgeForm[
          None], GraphicsGroupBox[{
            PolygonBox[{{103, 25, 210}, {105, 26, 104}, {106, 24, 215}, {248, 
             58, 174}, {122, 37, 144}, {209, 24, 102}, {125, 37, 121}, {263, 
             58, 177}, {236, 37, 125}, {177, 58, 173}, {196, 58, 263}, {111, 
             25, 219}, {101, 24, 209}, {104, 26, 211}}], 
            PolygonBox[CompressedData["
1:eJwt0D0KwkAQhuGNpjAKWglqZ+GFPIIgIqipLLQwF4mXiJX2Bo0QwR8shHgC
PYPvkK94YNidzH6T/igcLirOuTZ8rDBAD1PcVXcxwU11B2MEnnM1nKjPSHFE
k7MW5tQzPPBUj/XuccAPX2wQ4Yocdb5tYKn3LdMaF2SufDNQj/Vmuos0q8BH
CmWwLD69Va/MmCqDZUmwwxaxMlk228F2yZXtrf0tk2V76V/YWagZiWbYrD/w
HyvK
             "]], 
            PolygonBox[{{174, 58, 196, 259, 260}, {144, 37, 236, 152, 153}, {
             153, 152, 173, 58, 248}, {213, 212, 102, 24, 106}}]}]}, 
         {RGBColor[
          0.022435415812393774`, 0.461643812321467, 0.0775491678692791], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{238, 54, 157}, {201, 65, 265}, {157, 54, 179}, {192, 
             65, 180}, {160, 54, 155}, {186, 65, 201}}], 
            PolygonBox[CompressedData["
1:eJwt0D0OAVEUhuE7MioSGguwCb0tWILSZH4ailGwBEoqK6CgsgAKktGMkZCY
ZYzOezJf8SQnd86557vTH8ejqOGc68HHCUMMsEOEEDmemGGKFHNccUHHc66L
D/VbPdYbYIICLzyQoUVvGwl1rBmbXWKBL0o06fG9eoftOiqbZTy7eqftznR3
qdlQ2Q/Yu/oOu2tNvcIGW70h1Zl9s0yW7UZ9V+ZCGRPN2GyFn/5JrjcGOqu0
03b/ATzhMLc=
             "]], 
            PolygonBox[{{155, 54, 238, 127, 128}, {204, 203, 265, 65, 
             192}}]}]}, 
         {RGBColor[
          0.1471399822610257, 0.5660569373536044, 0.09213195503145305], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{208, 67, 272}, {253, 67, 195}, {214, 34, 110}, {128, 
             44, 155}, {235, 47, 146}, {154, 47, 145}, {239, 44, 133}, {146, 
             47, 167}, {272, 67, 199}, {225, 34, 115}, {194, 67, 253}, {249, 
             47, 154}, {107, 34, 214}, {224, 44, 128}}], 
            PolygonBox[{{193, 192, 180, 181}, {176, 175, 261, 262}, {269, 268,
              204, 205}, {205, 204, 192, 193}, {181, 180, 160, 161}, {119, 
             118, 123, 124}, {133, 44, 34, 225}, {113, 112, 220, 221}, {217, 
             216, 112, 113}, {110, 34, 44, 224}, {221, 220, 118, 119}}], 
            PolygonBox[{{115, 34, 107, 216, 217}, {262, 261, 199, 67, 194}, {
             167, 47, 249, 175, 176}, {195, 67, 208, 268, 269}, {161, 160, 
             155, 44, 239}, {124, 123, 145, 47, 235}}]}]}, 
         {RGBColor[0.2718445487096577, 0.6704700623857419, 0.106714742193627],
           EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{124, 36, 119}, {205, 66, 269}, {243, 57, 168}, {262, 
             57, 176}, {119, 36, 221}, {235, 36, 124}, {120, 36, 139}, {194, 
             57, 262}, {269, 66, 195}, {187, 66, 250}, {193, 66, 205}, {176, 
             57, 167}}], 
            PolygonBox[{{182, 181, 161, 162}, {218, 217, 113, 114}, {226, 225,
              115, 116}, {162, 161, 239, 240}, {134, 133, 225, 226}, {240, 
             239, 133, 134}, {116, 115, 217, 218}}], 
            PolygonBox[{{114, 113, 221, 36, 120}, {250, 66, 193, 181, 182}, {
             168, 57, 194, 253, 254}, {139, 36, 235, 146, 147}, {147, 146, 
             167, 57, 243}, {254, 253, 195, 66, 187}}]}]}, 
         {RGBColor[
          0.4355866067125528, 0.7391358488964417, 0.12249181265875027`], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{120, 35, 114}, {114, 35, 218}, {218, 35, 116}, {129, 
             35, 231}}], 
            PolygonBox[{{135, 134, 226, 227}, {163, 162, 240, 241}, {169, 168,
              254, 255}, {148, 147, 243, 244}, {251, 250, 182, 183}, {188, 
             187, 250, 251}, {255, 254, 187, 188}, {183, 182, 162, 163}, {140,
              139, 147, 148}, {241, 240, 134, 135}, {244, 243, 168, 169}}], 
            PolygonBox[{{227, 226, 116, 35, 129}, {231, 35, 120, 139, 
             140}}]}]}, 
         {RGBColor[
          0.6056932625551538, 0.8019734578150304, 0.13846359678572295`], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{136, 135, 227, 228}, {232, 231, 140, 141}, {141, 140, 
            148, 149}, {189, 188, 251, 252}, {130, 129, 231, 232}, {184, 183, 
            163, 164}, {252, 251, 183, 184}, {242, 241, 135, 136}, {245, 244, 
            169, 170}, {164, 163, 241, 242}, {256, 255, 188, 189}, {170, 169, 
            255, 256}, {149, 148, 244, 245}, {228, 227, 129, 130}}]]}, 
         {RGBColor[
          0.7575030110266049, 0.8666000004884395, 0.16549466709009075`], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{164, 55, 184}, {165, 55, 158}, {184, 55, 252}, {242, 
             55, 164}}], 
            PolygonBox[{{150, 149, 245, 246}, {233, 232, 141, 142}, {246, 245,
              170, 171}, {171, 170, 256, 257}, {142, 141, 149, 150}, {137, 
             136, 228, 229}, {229, 228, 130, 131}, {131, 130, 232, 233}, {257,
              256, 189, 190}}], 
            PolygonBox[{{190, 189, 252, 55, 165}, {158, 55, 242, 136, 
             137}}]}]}, 
         {RGBColor[
          0.8937092792085126, 0.9327521339087668, 0.2019570227141566], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{143, 142, 150, 151}, {258, 257, 190, 191}, {159, 158, 
            137, 138}, {191, 190, 165, 166}, {172, 171, 257, 258}, {151, 150, 
            246, 247}, {166, 165, 158, 159}, {132, 131, 233, 234}, {138, 137, 
            229, 230}, {247, 246, 171, 172}, {230, 229, 131, 132}, {234, 233, 
            142, 143}}]]}, 
         {RGBColor[1., 0.984375, 0.230411], EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{56, 45, 46}, {230, 45, 138}, {191, 56, 258}, {166, 
             56, 191}, {258, 56, 172}, {143, 46, 234}, {132, 45, 230}, {151, 
             46, 143}, {247, 46, 151}, {138, 45, 159}}], 
            PolygonBox[{{234, 46, 45, 132}, {172, 56, 46, 247}, {159, 45, 56, 
             166}}]}]}}, {{}, 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{230, 138, 159, 166, 191, 258, 172, 247, 151, 143, 234, 
             132, 230}]},
           "0.225`"],
          Annotation[#, 0.225, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{229, 137, 158, 165, 190, 257, 171, 246, 150, 142, 233, 
             131, 229}]},
           "0.2`"],
          Annotation[#, 0.2, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{228, 136, 242, 164, 184, 252, 189, 256, 170, 245, 149, 
             141, 232, 130, 228}]},
           "0.175`"],
          Annotation[#, 0.175, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{227, 135, 241, 163, 183, 251, 188, 255, 169, 244, 148, 
             140, 231, 129, 227}]},
           "0.15`"],
          Annotation[#, 0.15, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{218, 116, 226, 134, 240, 162, 182, 250, 187, 254, 168, 
             243, 147, 139, 120, 114, 218}]},
           "0.125`"],
          Annotation[#, 0.125, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{217, 115, 225, 133, 239, 161, 181, 193, 205, 269, 195, 
             253, 194, 262, 176, 167, 146, 235, 124, 119, 221, 113, 217}]},
           "0.1`"],
          Annotation[#, 0.1, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{214, 110, 224, 128, 155, 160, 180, 192, 204, 268, 208, 
             272, 199, 261, 175, 249, 154, 145, 123, 118, 220, 112, 216, 107, 
             214}]},
           "0.075`"],
          Annotation[#, 0.075, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{213, 109, 223, 127, 238, 157, 179, 186, 201, 265, 203, 
             267, 207, 271, 198, 260, 174, 248, 153, 144, 122, 117, 219, 111, 
             215, 106, 213}]},
           "0.05`"],
          Annotation[#, 0.05, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{209, 102, 212, 108, 222, 126, 237, 156, 178, 185, 200, 
             264, 202, 266, 206, 270, 197, 259, 196, 263, 177, 173, 152, 236, 
             125, 121, 105, 104, 211, 103, 210, 101, 209}]},
           "0.025`"],
          Annotation[#, 0.025, "Tooltip"]& ], {}, {}, {}}}],
      AspectRatio->1,
      Frame->True,
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {2149.7142857142853`, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {359.9999999999998, 291.2461179749811}]}, {}},
  ContentSelectable->True,
  ImageSize->{1107., Automatic},
  PlotRangePadding->{6, 5}]], "Print",
 CellChangeTimes->{{3.46077531487983*^9, 3.46077533113482*^9}, {
   3.460775919496517*^9, 3.460775942214324*^9}, 3.460775994480899*^9, {
   3.460776028742775*^9, 3.460776037026099*^9}, {3.4607909115414753`*^9, 
   3.460790939198042*^9}, {3.460791053541448*^9, 3.460791071088228*^9}, {
   3.460791192918942*^9, 3.46079120390362*^9}, {3.460791447076001*^9, 
   3.460791466900754*^9}, {3.460791545064044*^9, 3.460791570966239*^9}, {
   3.4607934191606007`*^9, 3.460793427137341*^9}, 3.460793490363347*^9, 
   3.460793537533045*^9, 3.460793587457892*^9, {3.460793643757728*^9, 
   3.46079365135855*^9}, {3.460793702770844*^9, 3.46079371762854*^9}, 
   3.4607943489406967`*^9, 3.460794468535598*^9, 3.460794537100586*^9, 
   3.460794606771035*^9, 3.460794647393282*^9, {3.460794683955057*^9, 
   3.460794711541408*^9}, 3.460794743655837*^9, 3.460794821407819*^9, 
   3.460794992687716*^9, {3.460795378587594*^9, 3.460795400763129*^9}, {
   3.460795899873049*^9, 3.460795915454596*^9}, 3.460795960670557*^9, {
   3.460796100655994*^9, 3.460796117353046*^9}, 3.4607962732165003`*^9, 
   3.460800162597351*^9, 3.4608005903774033`*^9, 3.4608019104755707`*^9, {
   3.46080194694875*^9, 3.460801958372828*^9}, {3.460802135395547*^9, 
   3.4608021584324636`*^9}, 3.460802633868291*^9, 3.4608026916143503`*^9, 
   3.460802782534809*^9, {3.460802813107704*^9, 3.460802851003825*^9}, 
   3.460802899121167*^9, {3.460802965047092*^9, 3.460802992739612*^9}, 
   3.460803080117352*^9, 3.4608031238206177`*^9, 3.460803181520192*^9, {
   3.46080323306312*^9, 3.460803259377411*^9}, 3.46080331972618*^9, 
   3.460803380089603*^9, 3.460803500590083*^9, 3.460803634249275*^9, 
   3.460803695867539*^9, 3.460803733168754*^9, 3.4608037682069407`*^9, 
   3.460803808306548*^9, {3.460805796883609*^9, 3.4608058124874477`*^9}, {
   3.460805967269699*^9, 3.460805988517199*^9}, 3.460806043311208*^9, {
   3.4608061104368067`*^9, 3.460806138574252*^9}, {3.460806255006837*^9, 
   3.460806283974195*^9}, 3.460806807263606*^9, {3.460808401910928*^9, 
   3.460808427928109*^9}, {3.460808490273144*^9, 3.4608085097819967`*^9}, 
   3.460808560412644*^9, {3.460808595578998*^9, 3.4608086131948977`*^9}, 
   3.46080866666626*^9, {3.460808755444212*^9, 3.460808819650992*^9}, 
   3.460808864264059*^9, 3.460809006604796*^9, {3.4608090811854763`*^9, 
   3.460809104912641*^9}, {3.460809151929467*^9, 3.460809168752171*^9}, 
   3.4608093860076733`*^9, 3.460809454988336*^9, 3.460809522864664*^9, 
   3.460809555813641*^9, 3.460809599993239*^9, 3.460809658263152*^9, 
   3.460809722507944*^9, {3.460810854015986*^9, 3.460810866689756*^9}, 
   3.4608109498397627`*^9, 3.4608110282394238`*^9, 3.4608110721071033`*^9, 
   3.460816353080124*^9, 3.4608164602305193`*^9, 3.460816634258309*^9, 
   3.460816731670138*^9, 3.4608168084797297`*^9, 3.460816894874284*^9, 
   3.46085946451213*^9, 3.4608595234315767`*^9, 3.460859577166404*^9, 
   3.460859610229175*^9, 3.460859640820545*^9, 3.460859671884251*^9, 
   3.460861034459901*^9, 3.46086107767255*^9, 3.460861174298973*^9, 
   3.46086120538374*^9, 3.460861251291684*^9, 3.460861323178865*^9, {
   3.46086138754945*^9, 3.4608614004495792`*^9}, 3.4608614320313396`*^9, 
   3.460861481320551*^9, 3.4608616211310663`*^9, {3.460861765223168*^9, 
   3.460861786281537*^9}, 3.4608618357668753`*^9, 3.460861918091242*^9, 
   3.460862023167821*^9, {3.460864061052595*^9, 3.460864090834353*^9}, 
   3.460864265960928*^9, {3.4608645935059767`*^9, 3.460864677184669*^9}, 
   3.4608647145529547`*^9, 3.4608928884220953`*^9, {3.460892927185437*^9, 
   3.460892978487932*^9}, {3.460893064002185*^9, 3.46089311369724*^9}, {
   3.460893196424436*^9, 3.460893220994563*^9}, 3.460893257421505*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]],

Cell[BoxData[
 RowBox[{"-", "2.764368974036533`"}]], "Output",
 CellChangeTimes->{
  3.460774172693623*^9, 3.4607742141360817`*^9, 3.460774259371611*^9, {
   3.460774303149437*^9, 3.460774333742992*^9}, {3.460774503977763*^9, 
   3.460774525387253*^9}, 3.460774568669429*^9, {3.4607746433678713`*^9, 
   3.460774749289826*^9}, 3.4607747872637367`*^9, {3.4607752069957323`*^9, 
   3.4607753311834*^9}, {3.4607759195524397`*^9, 3.4607759422690763`*^9}, 
   3.460775994534586*^9, {3.460776028795376*^9, 3.460776037081739*^9}, {
   3.460790911595224*^9, 3.460790939253276*^9}, {3.460791053594666*^9, 
   3.460791071141541*^9}, {3.460791192973082*^9, 3.460791203957177*^9}, {
   3.4607914471303043`*^9, 3.460791466955147*^9}, {3.460791545117042*^9, 
   3.460791571021545*^9}, {3.460793419216103*^9, 3.460793427190727*^9}, 
   3.4607934904166403`*^9, 3.460793537586506*^9, 3.4607935875115547`*^9, {
   3.460793643816039*^9, 3.460793651412258*^9}, {3.4607937028316803`*^9, 
   3.460793717693026*^9}, 3.460794349054253*^9, 3.460794468602188*^9, 
   3.460794537146944*^9, 3.460794606820025*^9, 3.460794647441045*^9, {
   3.460794683999979*^9, 3.460794711587779*^9}, 3.4607947437033663`*^9, 
   3.460794821453476*^9, 3.460794992763452*^9, {3.46079537866004*^9, 
   3.4607954008420343`*^9}, {3.460795899955226*^9, 3.460795915535334*^9}, 
   3.4607959607567463`*^9, {3.460796100730474*^9, 3.460796117431126*^9}, 
   3.460796273298979*^9, 3.46080016267494*^9, 3.46080059045927*^9, 
   3.46080191058669*^9, {3.460801947033931*^9, 3.4608019584551563`*^9}, {
   3.460802135491241*^9, 3.4608021585180397`*^9}, 3.460802633967609*^9, 
   3.460802693048126*^9, 3.460802784188271*^9, {3.46080281423518*^9, 
   3.460802852551197*^9}, 3.460802900679997*^9, {3.460802966464355*^9, 
   3.460802994747815*^9}, 3.460803081703266*^9, 3.460803125487102*^9, 
   3.460803183227213*^9, {3.460803234859148*^9, 3.4608032609697237`*^9}, 
   3.4608033212142887`*^9, 3.460803381478054*^9, 3.4608035021140633`*^9, 
   3.460803635652215*^9, 3.460803697315674*^9, 3.4608037348572693`*^9, 
   3.460803769573984*^9, 3.460803809928953*^9, {3.4608057984622173`*^9, 
   3.460805813824176*^9}, {3.460805968711471*^9, 3.4608059901127863`*^9}, 
   3.460806044738928*^9, {3.460806111860417*^9, 3.460806138661484*^9}, {
   3.4608062551082487`*^9, 3.460806284064145*^9}, 3.460806807365871*^9, {
   3.46080840200484*^9, 3.460808428085409*^9}, {3.4608084903745604`*^9, 
   3.460808509880398*^9}, 3.4608085615495157`*^9, {3.460808596715098*^9, 
   3.460808614316525*^9}, 3.460808667778009*^9, {3.460808756743518*^9, 
   3.460808821361974*^9}, 3.460808866006637*^9, 3.460809008335636*^9, {
   3.4608090829662027`*^9, 3.460809106371428*^9}, {3.4608091533817453`*^9, 
   3.460809170247486*^9}, 3.460809387484213*^9, 3.4608094563846188`*^9, 
   3.4608095239938383`*^9, 3.460809556860118*^9, 3.460809601486121*^9, 
   3.460809659738999*^9, 3.4608097239935083`*^9, {3.46081085410987*^9, 
   3.4608108667828493`*^9}, 3.4608109499384403`*^9, 3.460811028337473*^9, 
   3.46081107221124*^9, 3.4608163531812773`*^9, 3.460816462080289*^9, 
   3.460816636079851*^9, 3.460816733529152*^9, 3.460816810327259*^9, 
   3.460816896707574*^9, 3.460859466583232*^9, 3.460859525199936*^9, 
   3.46085957856656*^9, 3.460859612027454*^9, 3.460859642696507*^9, 
   3.460859673379051*^9, 3.4608610359199123`*^9, 3.460861080130123*^9, 
   3.460861176214602*^9, 3.460861206909174*^9, 3.4608612527872066`*^9, 
   3.4608613245925083`*^9, {3.4608613893716373`*^9, 3.460861402077552*^9}, 
   3.460861433808834*^9, 3.460861482995883*^9, 3.460861622874538*^9, {
   3.460861766989231*^9, 3.460861788062501*^9}, 3.460861837558749*^9, 
   3.460861919837391*^9, 3.46086202490096*^9, {3.460864063005273*^9, 
   3.4608640925582657`*^9}, 3.4608642675973377`*^9, {3.460864595153369*^9, 
   3.460864678530854*^9}, 3.4608647161716623`*^9, 3.4608928885197763`*^9, {
   3.4608929272834787`*^9, 3.4608929785836067`*^9}, {3.460893064106246*^9, 
   3.460893113794902*^9}, {3.4608931965264177`*^9, 3.460893221096546*^9}, 
   3.460893257519649*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"cfac=\"\>", "\[InvisibleSpace]", "3024.999999949349`"}],
  SequenceForm["cfac=", 3024.999999949349],
  Editable->False]], "Print",
 CellChangeTimes->{{3.46077531487983*^9, 3.46077533113482*^9}, {
   3.460775919496517*^9, 3.460775942214324*^9}, 3.460775994480899*^9, {
   3.460776028742775*^9, 3.460776037026099*^9}, {3.4607909115414753`*^9, 
   3.460790939198042*^9}, {3.460791053541448*^9, 3.460791071088228*^9}, {
   3.460791192918942*^9, 3.46079120390362*^9}, {3.460791447076001*^9, 
   3.460791466900754*^9}, {3.460791545064044*^9, 3.460791570966239*^9}, {
   3.4607934191606007`*^9, 3.460793427137341*^9}, 3.460793490363347*^9, 
   3.460793537533045*^9, 3.460793587457892*^9, {3.460793643757728*^9, 
   3.46079365135855*^9}, {3.460793702770844*^9, 3.46079371762854*^9}, 
   3.4607943489406967`*^9, 3.460794468535598*^9, 3.460794537100586*^9, 
   3.460794606771035*^9, 3.460794647393282*^9, {3.460794683955057*^9, 
   3.460794711541408*^9}, 3.460794743655837*^9, 3.460794821407819*^9, 
   3.460794992687716*^9, {3.460795378587594*^9, 3.460795400763129*^9}, {
   3.460795899873049*^9, 3.460795915454596*^9}, 3.460795960670557*^9, {
   3.460796100655994*^9, 3.460796117353046*^9}, 3.4607962732165003`*^9, 
   3.460800162597351*^9, 3.4608005903774033`*^9, 3.4608019104755707`*^9, {
   3.46080194694875*^9, 3.460801958372828*^9}, {3.460802135395547*^9, 
   3.4608021584324636`*^9}, 3.460802633868291*^9, 3.4608026916143503`*^9, 
   3.460802782534809*^9, {3.460802813107704*^9, 3.460802851003825*^9}, 
   3.460802899121167*^9, {3.460802965047092*^9, 3.460802992739612*^9}, 
   3.460803080117352*^9, 3.4608031238206177`*^9, 3.460803181520192*^9, {
   3.46080323306312*^9, 3.460803259377411*^9}, 3.46080331972618*^9, 
   3.460803380089603*^9, 3.460803500590083*^9, 3.460803634249275*^9, 
   3.460803695867539*^9, 3.460803733168754*^9, 3.4608037682069407`*^9, 
   3.460803808306548*^9, {3.460805796883609*^9, 3.4608058124874477`*^9}, {
   3.460805967269699*^9, 3.460805988517199*^9}, 3.460806043311208*^9, {
   3.4608061104368067`*^9, 3.460806138574252*^9}, {3.460806255006837*^9, 
   3.460806283974195*^9}, 3.460806807263606*^9, {3.460808401910928*^9, 
   3.460808427928109*^9}, {3.460808490273144*^9, 3.4608085097819967`*^9}, 
   3.460808560412644*^9, {3.460808595578998*^9, 3.4608086131948977`*^9}, 
   3.46080866666626*^9, {3.460808755444212*^9, 3.460808819650992*^9}, 
   3.460808864264059*^9, 3.460809006604796*^9, {3.4608090811854763`*^9, 
   3.460809104912641*^9}, {3.460809151929467*^9, 3.460809168752171*^9}, 
   3.4608093860076733`*^9, 3.460809454988336*^9, 3.460809522864664*^9, 
   3.460809555813641*^9, 3.460809599993239*^9, 3.460809658263152*^9, 
   3.460809722507944*^9, {3.460810854015986*^9, 3.460810866689756*^9}, 
   3.4608109498397627`*^9, 3.4608110282394238`*^9, 3.4608110721071033`*^9, 
   3.460816353080124*^9, 3.4608164602305193`*^9, 3.460816634258309*^9, 
   3.460816731670138*^9, 3.4608168084797297`*^9, 3.460816894874284*^9, 
   3.46085946451213*^9, 3.4608595234315767`*^9, 3.460859577166404*^9, 
   3.460859610229175*^9, 3.460859640820545*^9, 3.460859671884251*^9, 
   3.460861034459901*^9, 3.46086107767255*^9, 3.460861174298973*^9, 
   3.46086120538374*^9, 3.460861251291684*^9, 3.460861323178865*^9, {
   3.46086138754945*^9, 3.4608614004495792`*^9}, 3.4608614320313396`*^9, 
   3.460861481320551*^9, 3.4608616211310663`*^9, {3.460861765223168*^9, 
   3.460861786281537*^9}, 3.4608618357668753`*^9, 3.460861918091242*^9, 
   3.460862023167821*^9, {3.460864061052595*^9, 3.460864090834353*^9}, 
   3.460864265960928*^9, {3.4608645935059767`*^9, 3.460864677184669*^9}, 
   3.4608647145529547`*^9, 3.4608928884220953`*^9, {3.460892927185437*^9, 
   3.460892978487932*^9}, {3.460893064002185*^9, 3.46089311369724*^9}, {
   3.460893196424436*^9, 3.460893220994563*^9}, 3.460893257531712*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"cfac=\"\>", "\[InvisibleSpace]", "0.0003325544048068737`"}],
  SequenceForm["cfac=", 0.0003325544048068737],
  Editable->False]], "Print",
 CellChangeTimes->{{3.46077531487983*^9, 3.46077533113482*^9}, {
   3.460775919496517*^9, 3.460775942214324*^9}, 3.460775994480899*^9, {
   3.460776028742775*^9, 3.460776037026099*^9}, {3.4607909115414753`*^9, 
   3.460790939198042*^9}, {3.460791053541448*^9, 3.460791071088228*^9}, {
   3.460791192918942*^9, 3.46079120390362*^9}, {3.460791447076001*^9, 
   3.460791466900754*^9}, {3.460791545064044*^9, 3.460791570966239*^9}, {
   3.4607934191606007`*^9, 3.460793427137341*^9}, 3.460793490363347*^9, 
   3.460793537533045*^9, 3.460793587457892*^9, {3.460793643757728*^9, 
   3.46079365135855*^9}, {3.460793702770844*^9, 3.46079371762854*^9}, 
   3.4607943489406967`*^9, 3.460794468535598*^9, 3.460794537100586*^9, 
   3.460794606771035*^9, 3.460794647393282*^9, {3.460794683955057*^9, 
   3.460794711541408*^9}, 3.460794743655837*^9, 3.460794821407819*^9, 
   3.460794992687716*^9, {3.460795378587594*^9, 3.460795400763129*^9}, {
   3.460795899873049*^9, 3.460795915454596*^9}, 3.460795960670557*^9, {
   3.460796100655994*^9, 3.460796117353046*^9}, 3.4607962732165003`*^9, 
   3.460800162597351*^9, 3.4608005903774033`*^9, 3.4608019104755707`*^9, {
   3.46080194694875*^9, 3.460801958372828*^9}, {3.460802135395547*^9, 
   3.4608021584324636`*^9}, 3.460802633868291*^9, 3.4608026916143503`*^9, 
   3.460802782534809*^9, {3.460802813107704*^9, 3.460802851003825*^9}, 
   3.460802899121167*^9, {3.460802965047092*^9, 3.460802992739612*^9}, 
   3.460803080117352*^9, 3.4608031238206177`*^9, 3.460803181520192*^9, {
   3.46080323306312*^9, 3.460803259377411*^9}, 3.46080331972618*^9, 
   3.460803380089603*^9, 3.460803500590083*^9, 3.460803634249275*^9, 
   3.460803695867539*^9, 3.460803733168754*^9, 3.4608037682069407`*^9, 
   3.460803808306548*^9, {3.460805796883609*^9, 3.4608058124874477`*^9}, {
   3.460805967269699*^9, 3.460805988517199*^9}, 3.460806043311208*^9, {
   3.4608061104368067`*^9, 3.460806138574252*^9}, {3.460806255006837*^9, 
   3.460806283974195*^9}, 3.460806807263606*^9, {3.460808401910928*^9, 
   3.460808427928109*^9}, {3.460808490273144*^9, 3.4608085097819967`*^9}, 
   3.460808560412644*^9, {3.460808595578998*^9, 3.4608086131948977`*^9}, 
   3.46080866666626*^9, {3.460808755444212*^9, 3.460808819650992*^9}, 
   3.460808864264059*^9, 3.460809006604796*^9, {3.4608090811854763`*^9, 
   3.460809104912641*^9}, {3.460809151929467*^9, 3.460809168752171*^9}, 
   3.4608093860076733`*^9, 3.460809454988336*^9, 3.460809522864664*^9, 
   3.460809555813641*^9, 3.460809599993239*^9, 3.460809658263152*^9, 
   3.460809722507944*^9, {3.460810854015986*^9, 3.460810866689756*^9}, 
   3.4608109498397627`*^9, 3.4608110282394238`*^9, 3.4608110721071033`*^9, 
   3.460816353080124*^9, 3.4608164602305193`*^9, 3.460816634258309*^9, 
   3.460816731670138*^9, 3.4608168084797297`*^9, 3.460816894874284*^9, 
   3.46085946451213*^9, 3.4608595234315767`*^9, 3.460859577166404*^9, 
   3.460859610229175*^9, 3.460859640820545*^9, 3.460859671884251*^9, 
   3.460861034459901*^9, 3.46086107767255*^9, 3.460861174298973*^9, 
   3.46086120538374*^9, 3.460861251291684*^9, 3.460861323178865*^9, {
   3.46086138754945*^9, 3.4608614004495792`*^9}, 3.4608614320313396`*^9, 
   3.460861481320551*^9, 3.4608616211310663`*^9, {3.460861765223168*^9, 
   3.460861786281537*^9}, 3.4608618357668753`*^9, 3.460861918091242*^9, 
   3.460862023167821*^9, {3.460864061052595*^9, 3.460864090834353*^9}, 
   3.460864265960928*^9, {3.4608645935059767`*^9, 3.460864677184669*^9}, 
   3.4608647145529547`*^9, 3.4608928884220953`*^9, {3.460892927185437*^9, 
   3.460892978487932*^9}, {3.460893064002185*^9, 3.46089311369724*^9}, {
   3.460893196424436*^9, 3.460893220994563*^9}, 3.460893257541172*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0, 0, 1], PointSize[0.03], Thickness[0.03], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJzt0Hk01XkfB/BLhWsZlyuUfd9315K7lStLBiNRRotUk6YJaZrS4mqxS5aS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           "]]}}, {}}, {{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.01], Thickness[0.01], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJx13XlUVvX2x3HUUERwTJQk0BJDtFBzFgE1x5wHyJynnBWHTMMUkRxSE3Eq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           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{-0.4920407313793702}, {1}},
      PlotRange->{{-3, 3}, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {195.42857142857142`, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {359.99999999999994`, 291.2461179749811}], 
    InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.03], Thickness[0.03], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJx13XlUVvX2x3HUUERwTJQk0BJDtFBzFgE1x5wHyJynnBWHTMMUkRxSE3Eq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           "]]}}, {}}, {{}, 
        {RGBColor[1, 0, 0], PointSize[0.02], Thickness[0.02], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJzt0Hk01XkfwHGuXSRLtlzCY99l67ruTUjWGpGQIaJQ2dvUiGui7UGpZHlI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           "]]}}, {}}, {{}, 
        {RGBColor[1, 1, 0], PointSize[0.015], Thickness[0.015], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxN3Xk8lPv7P3DRJpSl7BRJ2ddKqJHs2aKIbFG2hFSUsidaSGWpCG1KEtki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           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{-0.4920407313793702}, None},
      PlotRange->{{-3, 3}, {0, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {586.2857142857142, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {359.99999999999994`, 291.2461179749811}], 
    InsetBox[
     GraphicsBox[{{{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ4U2Oo4rpP35vxw5ApD
vRLDgaT4xmMbr26Uf7t3ev5uhT/7Q+WaFVKX/dSWK/o10cr5x/4SWYZImTgh
w1s8FucfCn3Zb5CpVh8UrGLM9zJXWv/N+/23VaOqGc9vMt64I4RRzuHF/uv8
ygkpm04ZX1r1yHLXnfv7WXae8g85dMb4ypO3TvYhF/ZvnPFml2HkMeMFmk/5
n86fuD9QQXbprG+bjV95cWe7XD9nv1r5SeWs6ZOMP88xf2V97Z690KQPjN+Y
KoxV/u6bKXXsuf1Zh4UR/VkNxq8n3rf+9fO9/fojyw4ct9lkbDq520r7wmf7
I5LxCy7sOWX8qszHxvDbd3uhqN+SJQVfjapuzegsvfrb/vv73Tlt6iv0D2iz
3jvBzOBwdVNTv3kmm9op57nb+IWZHOpbmmN1PLkED0n/3vL1H7MDLPxKG14v
dRdhg/Prgv6s2ReI4Heo8G4x7UfwZ53QO6TMxQ7nL55lf3KWO4K/JifggmAr
gr/NLvF6xyEEH5oe4HwAgkjNyg==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs01GkYx8eMTIwoZEO5JkVHW1Fu45mDmtrakmzp4trNilySku6lslpU
IhPHrdmV3GpcKvFOpEakccllSJMMMvN7XYZyW/a35+wfz3nP57znPOd5vs/3
eYz8gt2OUCkUijcZ/71oYVj33BydX80sOdP9RgZedpyC0Co6P2rTOM1TKIOZ
Q1UXvl6j8z0T+MqCDhnYlGkYvFWm853Lj/18SCaDIk+ed5ymEj9qPDfr8UIC
+pb54aJ/aHwe+sShHCBgjf62vVYMKn+l5sXBAQ4Bw69bKBeNKfx7NXO5zi0E
EBXJweWGM2hQvNTmqCoG/bCp23bOE8h1JMZ4zA6DSNXmwxeNMVTimOEqPYpB
+I1+Y0u8HNFuFS9pP46h5k2bYyFDjpLFHp65IRiKLp0uOKc4ipYHm6+ai8Sg
9i1Ib41sCEXbGYT7x2KgVptP5H3H6GBFr71dPIYfqf0t5goYlQlL08fuYBC7
+sat0Jahk0+oOiYcDC3m+scfGkrRmNXrZclpGASKnWxji0Gk/d0oTZ6B4ckz
dwV91gDaNJkoO/I3hi3bBb0S63402+dvU5GL4fNne0G+RR+qIxjPJvIxLKCb
xDN/6kXlosQ1S4sxPOQkhc1b8BXVMLK1Fcsw2Fuq7HlP7UEvbRrVhc8xNOX2
2L7o+owSl5noaiEMGhqKnbnST8g9pWHG7xUGt0jTcw+mOpFpsFdwSjWGZrZ/
5bkl7ejJ0fVDL99i0CqM8Q4ya0Xi23Gjj2oxuGs/pnhtaEFpu6ZCL9SR/fUS
TuAuREbbeM2fGjDoSry34o56NLtfbYWvEEMspVfVi1GL6iMuddQ3YpjR8xe+
d6hB1BvVg4bNGE5slN1lnniFApve7vFswYC44oL9UI6oKsW6Vz5iyOoasLbL
4qHG3ZL18a0YVMx6Iter5CD934bSr7VhyFglUZek30YF9qkH/drJ/Lc2TZW1
xsHm0S+mNh0YdhxYHL3DPgeatK/PHyW54FF99GmfYvhLOYGaIMJQylWrZWe/
BO8BNw2NTgzdriuVVE9WQdC9oA1nSO7ZUWsWnvgGdlW+C6oiuW97wNaukncQ
J84oGyZ58BfGcZe2Blj9a5gmrQvD4V69wHGPRmAUMRWnyX93k6dZWzY3Q2FI
XbaIZBe/LR0P1n8EIx3/0UySrTK71YcM20BQkDLsSvJycfhmJ7UO2F1kkN5P
1qdlwDh/b1oEjRry2SMkK3pl8gYGuqCZuXlRPdmPPHXjoH1rN5QrRbfpkLzT
qijmfIQYeDyPjUxSj+UcF/1Pl7/AAUeGugup19Rc+1OHP3tgIsrV15LU88OR
IHbq/a9wws9i7Qyp/8M6ha7p7F7YN0Vczifnc3ZtUsiBQgk83mm716mJzPdP
ZYrum36Qqkama3/AUKFOi0uqHwBOpEGC13sMe4zZVzSav4FF21H9WNIfN9kf
AlTEUlCwzTG7Q/rJaL+m9/U+GdSEsPIDazC8CNy7m0oQYNhYIrEg/Se9/dl+
anIIMk4l3vCoxMB0uvrF7/QwpNbO2crLMUSXa3MFI8MwjeKdI0h/Ly5grk7s
G4GImuCT1uQ+eJo1Dk36jELUhhFu6BMM3IzDPO/OUYjtnmQnFWCwvhtrZyGU
A9N23/j9HAx5hdVTUvcxkH17ZryOi8G4fvpFXscYeEt0nxdmYlg4L9De8us4
qCqEsz3IfR6M2O6w9vsPsEtJnu/zB4aDtO81OmEToHwyVOfYdQwN8ek7qXgC
BAaGAXuuYHiaM+rXLJmE/ddKRwjynpwV3Y859XEaigyHixX8MfAt5nULaBTW
/E11l0wdMLxzTitV16SydF0ciy6qYKjSmy4en6WxAqIiub+3EnDqkpTL1lJi
Gci5MbXJBFxwm8mr3KXE0hGVu5knEHBz+YJi63gllu7VrfJTNwngCCyrTFTo
rNpQJ4WGMwRkc6CWw6azVMUed0QhBOQFugoXRdNZK0QOTk3+BJQ6+rbdrKKz
KPx1JiU+BPx/31m0t7nsqx4E/AtsFiVo
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vk/1PsewPExY0yRRkQpVPboUI6lyLy/p42cTiUpp85kO0UiyVKKKEU4
Z2TJZMJMlhapQalQPl9TNMo2xlLITtnGOsg2997H4/7wejz/hdcmN98jp4kE
AiHhv/1PpHCxXSKh4Kd5w6FPoo7DKUvWcz8eBV920nzIN/FPWHDnXeu5ScEf
EySJmR9OAuvfwYOONhR8X3LwmJb6Kdj+WnHDx+UU3O9BSIHXIRdo6rQc3V4l
g6/B73Nrs10hQNYd5TBk8B2s3VqFiu6QR3/hzFCSwcOWujqqfz0Dr82i8+vr
yDjLaFXrANUTSuWdSWsYZPyJbYZwStYLPr+TfcReRsYnyQvmDm7nof5u52xP
uTRuQMWS3F0uwBefV3b6EdL4u8ZS1V8f+EG/upsob5GEi4Razcf/DIBR67CT
roiEP1nr9nbsdSDM0lP5q66T8FvSta9M9C6BbHpTxkVpEi5XaPwifPsVUCqd
pGpVEHE5tS+zDS1XQa1dIVQYRcSvmdT0uTBCwVjj9+OmckR87rerxtFJ4bDM
ISRXvUYKj+NM1utHXIfOqGdSlHgpXHSNR+kKvgF3xqm5X1Wk8MsZWs5KYTdh
7EMDIUyTgCdKHmjVdN8Gt8Me3EBcgsTiEw17dGOgR0WHPmIlQRtayXWtF2Kh
P5Pzps1kCTFZ5wK3qjJg5B3Tt2TjAsJ4KH5GEA8aF+fiLXfPItX7V02KlZkQ
pJMRbPxuBpneomqSK5hQ/WW/q7bFDHLN5qur+t+DEEjZutJwGuntt41yKkuB
hglsLSlbjB4TI6vdXFlg+PCHZEZDjFaWjnmJ51nQsmJ7bZfiFPrZs6f5lkYq
1A1QomzjJlHaUGysQmYqlFc007hyk4g0rLnPfmMaFGc+mla+PYF+z29tE95N
g7zwS89DpCdQBnO9vAEpHR7Sbc70hI8jgsGA3rBHOqRartGwWxxDsr6RhUXv
0yFhzffGvOAxNKBqTLVUYcPKAZ/1xsOjSJ+SNaLmzAbie4PZ3GkR0mYN1Bqz
2DCT+r3BQEqEFJgN6gFVbBgOysp/LDeCzi0IGKViNnQedmXoqgwjUZ55kViW
Aw0GGueyNg4hzxctfr4qHOBLt9poGg6iuk7e5V3qHHjbztTmmA2gFFTwzXMD
B/LfHJXSwH6g11edyzrVOGB7gN/bZ/YdpX1lmras5kBHhxX/mWE/SgzAbekU
DgT5c58GbupD3eefR43+YIM8RSvOek0v2pF2oTL4DRuyWMkXyfI96FjxyM2Y
UDZYGckeqyZ2o5zopL307WyoLwvdcXe2E9UX9sZZDKRDfU73juK2DtShusrH
8046KCpKt+YMfUPV4KivbJYOR4J1Qu7PtaLcxfdbxgVpILTxLA1Z+wXZOOSk
/CtOhdXcaGcfvSb0mu70r0xoKhxVeUo4Zd6AuAmsDo2l+9DQO7ILjtahZzqe
SjUiFqzrc94v+lqFPubSDdTcWBBL6F1xSq4S7R6JfthXlwLnLYYTrc+XoXWS
nElmxj3gbO6j9rHjUXBD8yMnzWQYtJM7t6e5Bq5knu5pDbsDf/eu9xY7CcBH
tfaXiFdxcFSrIMN2nxB0TXXvmPoxwPRBO3V0YzMEFP4ljJmKhclUi0GrpnbI
kb6bxcGi4JBpXnRoUCcoV7grTa2IBG3WHo1v17tgZK6NO991E2pP+9ik3usB
q/D+SPdHNyDrs1TbfGYv1DtcC8TuXYcr25IvnOT2gc6PPfzPCeGgvViasq7i
O2xihHiV2IXCOyqJkVz1AyBLT3Ig4ioc07S5oSgcgD2NOclTNcFw26bWS7Zz
CJ7akf3V2EGw6YSSc2T/MHhZNs3RtAKh2Pu4A3FkBJYiYpmlRf4wFN9hNfdz
FD4dDYoJV/MD610RXW6XxoB1VjklZNYXbpWoZPPHx8BaDru8v9EHlJ9bb0nq
HwdjhuBRcc9ZoOsJRn+6TMCX+/nc10qekM35+4Vz6wSstlLJL6afAbPEWEvD
uknou6vcYrHTHXK57+eGjk5BTKW+9nyeK2hWzRfnfp2Cd5H08HFwgZQfv171
OSUG/abpaEEtHRTI3lZGPWJgL9cgOR86CZGbsuZFHtPQvpD7c8uCEyxat5Vw
h6dhRDtOo1d4DAaDDuzcNj0DN3Y/e9s9dwT+Ik2Xq16cBUtPXhlytYeaOPYh
omgWUpZ1VxRWHQJMbf/XwbM/QfZyEYu08g8oeDzhJuz7CXutRTs33LQDbbPU
4RLXOaB5Vli0GtpCctneoKxvc9BR9DBcj7gPrrTciw5snAdnPych32gXrJf9
Ti06uQCUdcpFJnQM3u4wS17oWgDawzEfTS9r+OtshBrmuQizE/0zCWcsYfGe
ICNCtAiNwS9vNz+xgHT+hs0fA5YggUlIO21kBrRZH67s/BIgx1RjmVET6NB7
a3bwugQ8HNWFwv6tgBuS2/kkAqYbHDd+QdMIyozWFuXvJWAnzpS7Xu42AN42
wyRWFAFLxpvkTab04IMpzTeikoB19WmO3zmsA+UW9nbeclLYlToDGcq4JlRY
/q3j+IcURvgwEh9WuxH41pcItDgpTJC1KrOgSh0qsZhWXYEU9s8vrVvLXNbB
p91pr6hKRMz8+tovCfZroHLJM+ifw0Qs2oftweetBn6RqflyBhFTeBRBPh+k
CB8DCNO3PhMxaiAq8j6jABXGVYXE5SQs4IG99ZF18lA+yAwM20fCLi0wrsx8
Wg4fst3NFiJI2JHMj787NMrAexdj8eUyEpah751UvFUaeOvnX4qXSFg5j2IF
jVLgpK86yf5NGnMai7Gz15TQRk0tttndlMaiPxn2Y9rztMjfHH2nKqQxpQsT
/roPZmhqB/2fpS8nY6UBuZlOsVO0ghPxQ7YHyFjsn8382KZxmq0Hd/Mkg4yl
rPBt9xgV0dr9qz3SBGQsKENSJKgcpAWGD2XbrJbBXBMOi5gG32nXjizkltrL
YNvMKSrLrHtpt7XlX5rFyWAuL/Sp1CddtPhp9ZLcKhlMy0/yx7HKdhqLb8TT
kqVgGgUx3rzqFlomCypZNhTMwKvk7P5DzbRc78N1q25RsBBHh50R0EB7RXNt
vs2jYFvaPq+/Ey+g/f+HsDeGmeI+/xrafwBS432s
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FPwaB3CNUCRdS+oVyvpGdzJFMmY8XqlBZW+RjEg3ZRAhhCSUJVpk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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs41GkUxweTeSKxUrsRuZVbsa1cJ50pamiLsrMSuWRN2wVZmyRaIhsl
VmQlImKRjBCVeCfEkFsiXcYQxn1+r8Ylt7S/fZ79433O8/nnnPd8z/keDa8z
jmxJCoXiQb7/IlIIEHz9SuOWbJrP/ponAnfL1KLfamhc1smrTbwSESz9UvPH
wGUa91oFo+PiMxGYVyhubFhJ486Ui7febxNBsVupR9waae6ysVmVwowIhlS9
iOIvUlyzEX7bg10EGKn9eHi7rCQ34EmEQ2wkAZN1nZQwTQo337H0eX41AaKq
v89Uqi8hpWnT01FzBKgFLCRYWs+hwmx1vUu6GN6vMm/7qDiNHPyEHa9+xtA+
SrtiGz+FPm1g2AtdMLyo797JkZ1C7u87Ans8MBSHBxWFUsUo22U4KeQkhtWj
vipGExiV3zv70DcEg2St/lzhLIGi8gtC3cIwfE4b7tSXIJB34cYtJpEY+g4e
i9u8bgJdL7BQSruKoVNf7fQ99XFkO59FN4jDwKN+YGoajKFmo07trAQMDx+z
JNQYI8g8PXQDMwWD7X7eoNBkGLlW2OQ/vo2ht5fOe2AwhCZv+sTLZWCQo2nF
W307iFR706yP5WC4l5ocsEJuAK2k21E88zDQDWWcWiT7UcD19Kld9zF0FPRb
POX3otmCQXdOMQZFReqHgvEeFCtX561QisExeFPo7YUPyJAWZun8CMNr5onq
0O/eIrAYh7QnGJQ4MR6+Om/Qo0RvdkolBta6+xR3006kJLbbG1JF9jco2g2s
dkQ7Fa47w8WgLPSwI941o4+pAe6XazBcowyucpdtRJWfBfTFWgxLKifaW3a8
QAwOu+rICwx+ZhOJVn7PUfW8oDejHgPK6StygUpktsk1s6UBQxZ/xMQyqxRV
Zmou9fMwyOj0BxvL5CGudPlkbyOGTD2hvDAjAb3a3BpS10Tmj92zUPEmDlit
1K7MlxjsXddG2dPzILfJxcezGUNRfnNUkGcZNC83gFQLhvKc1Y3M7Geg637j
QAzJgoO60qt+rwH29IEkMcn99o06Z5PqoWmcrwitGIb2n7LjP2oC9o0zPD+S
x/bJnrbpboU0t8tll0j2HlTxmXF+BZ3LC+xgkllaJVm2e1/D1kZVmjPJNl62
724bd4F2Jj1FleTtdwXyWL0brHIF65vIetp9Z/fuXv0OxJbNsW4kK22UvXhz
8T1kf6aKu8n/U93vlo6M8CHtft0+C5Kn0szG6G8EYHs4IuUS2a/D9uKYi+f6
wNQn94c7pB7aqTZqPZc+wk7TQO90Uq+Fr29LdlzvB6WGiu/DSD3b2L7MtJQB
4FdHp1qTet97KcFfzB6ENitWzhg5nwvbkv1dOUJw6uxmna0j832pvqVcPwxd
h5JKjJ5jqJKXiktuHoENdHONUwiDkyYzQvH1KNTaHXCKJvcjmtl2SqZvHAaO
mOr6k/uk4bLG48+hCbizvNhmUYHhqc/hnyRFIjgnWMsaLsMwntBLX5jHEKHj
JUNwMFjtjvzoFTQJTfP+o4EPMERVrsvhfZqEYu8nbGEBhrVFVluShj6BOIhi
H0L6wU3nFZ73FIOB41/1d7Mw5GR6l3p8EIP2XMgMh/SPSeI1S4P2KeihfkqI
vIWhkFO7MM6ahs7jLlTJZAyazYtPC99Ng9bLOWnvGxgUVvjQDQdmYNvbhMEO
0s9j5/bv2Db7Gf5RVtZ1u4DhqNTsi/UBc3DRsVtizzkMrfEZDpLEHGzRbvBU
CsBQkif2ei2chyuhem9OkvfkwvuUmMCuRRh92lEz6YSBa7BCwJOiMHITF4Yq
9TA0WaeXy6+RZEyd15+OnyWgRmWxbGZZikEsidL7uAQEho/nMJWkGXXaqmxW
OAF/OC4VVh+SZkioBtsFnycgWluuzCRemnE0fKVHtD8BqTzDGi0ZGoOa8Otx
ticB2anQmMqkMSY5c6HGzgQU+hxs/yaKxuAk2KyecCCgfOex7ugaGsNRY+PW
eCYB/993Bj8oZmIDEPAvOm0uBg==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk31P8ex2djQigyslS2qJSlbBm8Pi0aqSuVKJKEpJSsJTVERGTJehHZ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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FPwaB3CNUCRdS+oVyvpGdzJFMmY8XqlBZW+RjEg3ZRAhhCSUJVpk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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHtYzGkUx6fpMqur7YaiSLRq3UO6OPPkMlEqzIMlTReeLWIYEoWsFeVS
kkgodBGNooYo9Y5JNdkoqkm3mWqa7vN7q6mmq/a3z7N/nOd9Pv+c95zv95yz
wI+98xCVQqGwyPjvRTM54ulpGv+AUvTLlio5eNsnZp0Q0PgrilMt5zbIYdJf
cEF6mcZPpCo0xFI52OXpm5fNoPF3806WWSrl8OpALivaQIN/6wOvsWAuAR3z
/IhXU6r8FTd2+RYFErDczHWPrRaV75GSP2cok4D+TzWUcAsKnyUyq2Z1EiAv
vMcumD+JwlIK50QuwGDGGY+13ziKTPaxfIt3YGjQtqts1R9CC1L/0PYMx1DV
TbvqEqNAU5vZ9MOXMZSU1m3I1lKgKL+bkwFRGF5dDMk6pzaInA3b6wziMOh2
HzVd3odRVGZl3rw0DNRi61HuCIE+brv0Xv85BuXDzhprFQIZhF4Nx1wMLZ6+
0YuN+9CMU19sfXgYaqzNjqTO70W7+AX6Q3kYhGqNDAubHmQr3XObXYDh9Tum
ihm9C/EvHNg9T4DBxU3YLlvTidh2IZy4EgwSiYPwpU0HusOhCPqEGHRoC2Oc
ZrUjz4xBkUslhtTEuxx1HSmKTui65vodg8Myzd1fqG3IxznAY2Uthu8v2tbn
N0mQouavnrQGDPr6ao0vepvRuKjaWLMZw86zi849GG9E1hrPBpgSDNWMgKJz
s3+g3LJZj5KkGAyzo1hHrUTIcYjt/0iGgWmcSfFeW4OYmUXFlzrJ/trlzsCs
QoFlHnSVXgwmMtZWor4CvdNrvXK7D8N1Sru2t1Y52pCUzdQiMEyaBlR9cSxB
oiV70o9gDMfW9cU5HfuIFhVmnsntx4DSWrL2QQGqEbwXtg1geNrUtcb+aS5q
mVkaNzaIQdOq7exqzQxkothep1RgeLxEpidLjkWVtrTY5iEy/43N43miaAjR
VtctGMbgvt8owt0hA6bFOilhIxiynldEhPjwIEts7G6uxPA2TbeckfIB7rzx
10knWez5m4b2SQH437wi0RvF0OZebnXqTikQRj7FXiR3uB3e2vTmM6y9Zv7u
Bsk927SObKr7CqY858Jkkg+2mwYN7/0G0hPv/e+RzFyY89RlSzW81uP+CCZ5
k59L/YPVtcCuD5zrQLLtE7Eenl8H8Rnnl3eS/1u2nNrirFsPitaX+qEkG5pr
nY+faIDXnMlSBVm/mveT3K6uJnCrSN/OJFnxcF2Pg0gMhZJFGQ/Ifj1sX0Wd
P90ConlLjfJIPSwTN5k1/9UKLW7EII/Ua3z6R47jzTaoWLZ2UzypZ+Who4yH
CVJQhC/U3kvqnfqPStNESjtwuxa7T5H+hK68e3x/tgwOyqm6EaR/llNF901K
O2GsqHOWI+l3oZ5q9N2KLhA7DS491Y1htwXjkn51N/A0dWUx5HxEMioPa7b0
AtWU4soh52nBPgPWlY4+iAkXqa1vxZAftGcXVS6HVRuLgqViDL2xEofxMQz7
p3/GS+sxODn/3eoX0g/VGdQVAXUYIgqM04QD/fDpxPCWmhoMRllOv9/pGID6
599U/cl9OGD1DY/5DMII4fU2ogJD2uODuazGQXjy1WQ6phzDmrjr9jZVCphc
1XxsfzEGbnbxeC9zCMpNPjnWIgwWFRP53PohiPeyC171AcNM9SCHZdJh4H7O
336P3Oee026OK0eUIGy/XaKVisFLdaRkDmcUkkL9VxPJGL7GJHtQiVGw85lU
f/cAQ07GoF+1bAyeNaerUMl7EtqQEBVcOwFPq+zPHL+IgW+jLhaqUuiGYT/R
9E4Mnzc+eqtnQKXnrs/UvGWOQWA6wRv+qUpPva58dL+bgOCLvWkMQw362hxm
X14GARd2TnKLdmjQLabSAr8/JiDSUoe3JkaDvmux64QogYBE4TLBQk0a3YAR
m5oUSUBKIpQnMmj0296LW30vEsAN8qz6NYJGV9KUYXpnCHi7wbcuUkCj58zt
v/qMTcD/950+JrGZbf0nAf8CHKk5/g==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk41Hsfh2dhhpEluyOcE4p0Wk1kGt9/spYjQo9DEeWgUFkjkmOpDg06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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FPwaB3CNUCRdS+oVyvpGdzJFMmY8XqlBZW+RjEg3ZRAhhCSUJVpk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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs4lGkYxscwpohq0Ek5t0IpRSqHZxwyBhUl2lpNdNhCB3KIRaVsOqA2
W5qSnNrSRA6rUryTVlEqZXJKDnNA+L43UTSG9tvr2j+e67l+/9zX+9zv/TyG
QQc37qbTaDQeVf91NCO848cPpvBMPX3i2WoCtq/hF4ZVU1yeFRbiQoBiZ3WC
5CRTGJsjYim8CFh1n6X/fCpTWHHNOKmbR8C9gFJeqpaqsCEet1ScJKBnQRB5
b0JZyH4QmL2qgYClep7+1up0oXRCx9BgJgmf/xHRjhrRhAfeMXt5niQQlZcP
PjJQoMiAIX7QSRL0wuUX1riMIf2tl4MLSklom7bqTTdrBEnenTH16SKh4RPz
lHvaMPJ/qcr3kZFQ86zZsUh9GAkmV+jb9pNw71h0YZzKF7Q3t3BJ8TAJmp/2
6y4dxGitjnySx8BAf2o+JvhGoreWukynqRhGr/WKzJVI1B4lXqemgaHLOzD1
p1mDyLxrW8RmbQwic72QPIMBpDTCcmmejaFW5QPHyKIfBQbEWjrpYih+4Kuk
x+5D9EdCu1eGGNy9aqUym16UyWvtsFqIobPTrvauRQ/iXXziFrsIgwbTOM1h
thQpGrhO5ZYY8viXwhkaElQlfV192wqDnaWa3yu6GJV8InqOWWN4VyBeXdHe
ieL6dcZaV2NgsVQ+FAx8RNvKbVjL7TFsjFkYd1X+AXHL8raGOWJo5OytipvT
gpa8MAnMd8agXXSat9+0CXE3m+jwXTH4zrpD275ShCYMvCWRbtR8UsIZfBvQ
Au3Lj8VcDPNkPC7ZWo8c76bMDfXEcJYmnbZdvQ7lJHJjPnphUOjubXhlX4MW
B0e3rFyP4YDt4EWHA0+Qbdj4iiMbMKD8rsKt8Aid6vucnO2NIae9z2ZNTikK
OVggKvHBoGYqjlmhdgsxJou1BRsx3DCTTZdlXUCVZK1byiZK/9xa+f2mVDAy
fbh7jy+G9dt0ktbb3YKSouuWxpsxFN6uT4reUQaVU2OynlJcnq9Zx8l9DD45
6eUcPwwd3otUpx2uhqbWM+FFFIvX15lGpD+DMDXnd3KKe7yCue1/v4DJc4TI
zB9Dv4d6iGvza7j9WCPWnuJdUt3Qr1veQvEfBR7WFPsal+S4uzVCXyfeq0Wx
a5B769UV7+Erz+J9K6Vnnd0xHRs0Q9BSWdopik26ItycNVshpa7zynyKtfXV
4/8cb4NMxpyRDOq9KtuzS/v62iGPVZOloOYbvmbbb9fUAaLwLdc5FG+wvnc6
PqoLDA2Wp/xK+WHCd9X7eLwbtO4qjgdTfsl/tJTYp4gh6mHUUW/Kzze793Ou
ZUigzKkoeS7ld95LpfbxXCnkn2dk11D/E2t16dC2IhkoLzOr911H6U1UXZn3
rBd2/GwaMt8DQ+V05dRL9X0wePNqQoA7Bj8jTiKr8RPs6fWvTqTykcx5E6zW
NQD7rJ6TMVSeDLdq8X7vGYQIkbPYk42hItR/E50gYPf+y7p0Kn8DFzrt5N8x
nLA6fUSXyquD84nuoOjPEOCiuCJYiSHp0az82qHPIDk4r2whlW+dQofF6T1D
wAhm9r+h9iHA9C3+vuMLxHNXsZQWY8i/sauU9+ELhNq2eM4zw2Bz8ewai4Zh
OOSXrMkwxiAoeiof8B2BmMzcm+f1MRjVj1cIWkdAqnVpNW0+hhmMUDtLyVew
qV0UfZba5/4oL3urb6Mwmp5xeJMKhl+Uv9XMDR+DwDtVf3nQMLxOy9pAJ8dA
c1T82ExBQsmtL0GNsu+wbM9vxVnUPYltyzgd+X4cskYTJCHdJAgtGB21yjT2
zCHrc11lJLxwySyfrkVnP2jxjotIJKFad7zs66QyOzwxMzJ1HQmRxwbyOdqq
bDMNJ/cRDRISNioEVT6q7IUZ8uyVqiQkm2iU2aSpsqfYFyXsnCSAX2tZbazG
ZN86fmVKPElALh/q+BwmO/rhlLZ9PQQIQr0bZiYx2a8FsiinDgLKHQObk6uZ
bKGgcki5iYD/7ztbkuoRUPyKgH8BhXcLlw==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk4lAsbgGcxM6GTk2whSaojp4XMIdLzWkcjeyFCyJKSk2MpZSnJdLI0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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ7UHa+W5WzvZPhw5ApD
vRLDgb9aRY7/T3wQe7t3ev5uhT/7i6zy1b8oWyjLFf2aaOX8Y/9CNftpSZ6B
Grd4LM4/FPqynzXYqklSMVmL72WutP6b9/sdXKfeXLT5o9bGHSGMcg4v9q+o
239UV4FT+9KqR5a77tzfH3LD/Cq3ILf2lSdvnexDLuxXPubZVMfBqr1A8yn/
0/kT9+/8GdR97eQnrVde3Nku18/ZX3SZ0FFXf1Hr8xzzV9bX7tm/eP3BxGTm
Ni2Vv/tmSh17bl/6berU8mf7tF5PvG/96+d7+5c1XaosWh+1TCd3W2lf+GzP
xuPw748mp/arMh8bw2/f7cvPK4QX65poVd2a0Vl69bd93TWtA3N3P1M7oM16
7wQzg8NWnhcfJom7yp5ynruNX5jJ4fm1db/V9npwHJL+veXrP2YHWPiVNrxe
6i7CBufXBf1Zsy8Qwe9Q4d1i2o/gzzqhd0iZix3OXzzL/uQsdwR/TU7ABcFW
BH+bXeL1jkMIPjQ9wPkAqUPO1g==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs01GkYx8e4zOa+SFuOKZfNvZJsraFn1m1Qxy2bQpRytiMUKVsikmQr
EiLlkEtJE4pulHeSaogo90vuxjC/12VcMq7723P2j/e85/PPc57n+/0+j4bv
SVc/KoVC8SHffz9SDOlZXaVxqgviX96fFIC3WUZRcBWNs9l2NLlDJIClo1WR
g5dpnEpNvQsrVAJ2vVTa+GkNjdO8YERXWEtAyaFSnwRlKY6t7Wyw/S4CeOq+
4yXL4pztdbdoZ6II2Erf475DhsoxPmp6M7qSgMnqZspFTQonxIPrajxHAH6b
drJi0xLS0jOfe2qIgR6ykGRmNY+2d7k7DB/E0Cm7q6FfaQalRa3RTb2MoXGU
FmeXOI2+/d1jcygew4ePbbuLZaaRfPiDfJkEDCVRYUUXJIRIkukn2pCGQX40
UG0rMYFo6tV51AIM1Pf68+y5cWTnYbj88jGGH/dGmvXFxtEtveqs/cUY+pyP
JGxWJRDFWTLH6QWGZn36ibxNAqTSFjL16DUGrkQXS9NgDKkkpvvjNxievnIT
ozP5yHK5tWLrewx2e7lDw6YjSINnoBv0EUNvL4P7xICH2v0t05JqMMjRtBIt
1g0hYUGiZ1wDhryM2yGScoNoRTEg++A3DIwt0vvrqQNo8s2fnxRbMHwrHPi9
vLsXNY9wM406MSgpSXQVCr6jh6mnXE50Y3A99+uFuwtdyHxF4JDUg6GJdbzy
wi/tiOFOXUwdwKBSHO8TqNOKnm5cfhg6hMFN9THF+7dmFHzuWhyDR843hC3B
rREFXEqujx7FsGHYx368ow4ZV/zVLRrDcI0yJOstU4NOTRkueRAYltSON9ab
f0DUwOd6+RhD0E4i2SLoHfKDn3zbxzGg/L4iD6hA65yO5MxMYMjp5pua5ZQi
G19jvmgSg7TOwDkT6QJ0R5duzJ/CkK03rDCclYRY1tRwJCTrX7dZeNmaAA77
SmQTpzE4eq6NdWQUAEs/NM5qBkPRo7rYsMNl4N96dLSb5Bf58jWs3Dewe7xn
m+cshh5nXSnZ01WgeCfBq5LkAccandCUjyCe6ndCag4Db6+/fffzWqhmZHuZ
kDzmIHPCuu0LKF6p3mpD8rEhtYDZA19BSLvpZUGym9azHDvbJogO18HqJFv7
2nXcNWmBuW0t/Tyy/o77PQoTm9pgiqXGSCdZuy/U1lK+A2KflIqMSVbZKBOR
utgJ9utv0svIfiW875fy+d1QvqazkE7y9L2dY4zWHriOhFnB5LxOO0riI872
wXVde/+7pB7aGdb079H9sFONH/WI1Gthtf2Z+Y0B+MPxJO8uqWeDXyDrXvog
EHs+Z4aQeud9FutezB2CmGOmhUakH+eNb5/yLB6GwCwThXrSP+3lyjsbPo6A
SW2M8BXp91sF8YTbdXyQl3MpluNj2K/JuqTUNAoRs5ktLDIfV1kN/tJ9AoiS
nQ4OIPOk4aHsc4VHgL6vg3B/H4byAPd9VDIHDyLQ5GYyf4KkXsaCaALclQsv
hnVgsLCM6fcNmwQd/RWadhuG2ArVfO7UJPgMZKS9bsawtsjCMIU3BbU1roNZ
5D4c0vk6IToshIEU68eTdRjys4+V+nQJwVvG8JZ+LQbT5GtmBo3TwA6pbz1Y
jYFd/H5B4DYD42wrd9l3GDTrFsvZHTOA8jTl895iUJQMYGwZnIUo2j/WMeQ+
j53da2489wOOetaMij3E4CU+92F9yDyYe0fe2JyL4UtilhN1fB5UOR0aO7Iw
PCsQ+jYNi8C2V91Smrwn5zvT48+0LIKYNvd0biwGjoFkD1ecwix/sv2TnCeG
WqvMFwrKVGa4f3hKhz6GKrXFstkVceZgZI0ja56AM1GCfJaKFNPaPTHoXAUB
ka5L7EoXKWZmtMScUhkBV7XlykwTpZjZB84K09gEZHC3VGlJ05glDa8TjmUS
kJsBNRksGrNJ1siFnUoAO8C58edYGvPAk9763hsEvNh9pO1qFY2ZrJSguhpL
wP/3nSky3GghHUnAvwK1J8Y=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk/1IkfgGcMM0W5zyW5hdaxjpzz/tAyUllX2V0ht1AbOZIhJVdEs6to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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ4U2Oo4rpP35vxw5ApD
vRLDgaT4xmMbr26Uf7t3ev5uhT/7Q+WaFVKX/dSWK/o10cr5x/4SWYZImTgh
w1s8FucfCn3Zb5CpVh8UrGLM9zJXWv/N+/23VaOqGc9vMt64I4RRzuHF/uv8
ygkpm04ZX1r1yHLXnfv7WXae8g85dMb4ypO3TvYhF/ZvnPFml2HkMeMFmk/5
n86fuD9QQXbprG+bjV95cWe7XD9nv1r5SeWs6ZOMP88xf2V97Z690KQPjN+Y
KoxV/u6bKXXsuf1Zh4UR/VkNxq8n3rf+9fO9/fojyw4ct9lkbDq520r7wmf7
I5LxCy7sOWX8qszHxvDbd3uhqN+SJQVfjapuzegsvfrb/vv73Tlt6iv0D2iz
3jvBzOBwdVNTv3kmm9op57nb+IWZHOpbmmN1PLkED0n/3vL1H7MDLPxKG14v
dRdhg/Prgv6s2ReI4Heo8G4x7UfwZ53QO6TMxQ7nL55lf3KWO4K/JifggmAr
gr/NLvF6xyEEH5oe4HwAgkjNyg==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs01GkYx8eMTIwoZEO5JkVHW1Fu45mDmtrakmzp4trNilySku6lslpU
IhPHrdmV3GpcKvFOpEakccllSJMMMvN7XYZyW/a35+wfz3nP57znPOd5vs/3
eYz8gt2OUCkUijcZ/71oYVj33BydX80sOdP9RgZedpyC0Co6P2rTOM1TKIOZ
Q1UXvl6j8z0T+MqCDhnYlGkYvFWm853Lj/18SCaDIk+ed5ymEj9qPDfr8UIC
+pb54aJ/aHwe+sShHCBgjf62vVYMKn+l5sXBAQ4Bw69bKBeNKfx7NXO5zi0E
EBXJweWGM2hQvNTmqCoG/bCp23bOE8h1JMZ4zA6DSNXmwxeNMVTimOEqPYpB
+I1+Y0u8HNFuFS9pP46h5k2bYyFDjpLFHp65IRiKLp0uOKc4ipYHm6+ai8Sg
9i1Ib41sCEXbGYT7x2KgVptP5H3H6GBFr71dPIYfqf0t5goYlQlL08fuYBC7
+sat0Jahk0+oOiYcDC3m+scfGkrRmNXrZclpGASKnWxji0Gk/d0oTZ6B4ckz
dwV91gDaNJkoO/I3hi3bBb0S63402+dvU5GL4fNne0G+RR+qIxjPJvIxLKCb
xDN/6kXlosQ1S4sxPOQkhc1b8BXVMLK1Fcsw2Fuq7HlP7UEvbRrVhc8xNOX2
2L7o+owSl5noaiEMGhqKnbnST8g9pWHG7xUGt0jTcw+mOpFpsFdwSjWGZrZ/
5bkl7ejJ0fVDL99i0CqM8Q4ya0Xi23Gjj2oxuGs/pnhtaEFpu6ZCL9SR/fUS
TuAuREbbeM2fGjDoSry34o56NLtfbYWvEEMspVfVi1GL6iMuddQ3YpjR8xe+
d6hB1BvVg4bNGE5slN1lnniFApve7vFswYC44oL9UI6oKsW6Vz5iyOoasLbL
4qHG3ZL18a0YVMx6Iter5CD934bSr7VhyFglUZek30YF9qkH/drJ/Lc2TZW1
xsHm0S+mNh0YdhxYHL3DPgeatK/PHyW54FF99GmfYvhLOYGaIMJQylWrZWe/
BO8BNw2NTgzdriuVVE9WQdC9oA1nSO7ZUWsWnvgGdlW+C6oiuW97wNaukncQ
J84oGyZ58BfGcZe2Blj9a5gmrQvD4V69wHGPRmAUMRWnyX93k6dZWzY3Q2FI
XbaIZBe/LR0P1n8EIx3/0UySrTK71YcM20BQkDLsSvJycfhmJ7UO2F1kkN5P
1qdlwDh/b1oEjRry2SMkK3pl8gYGuqCZuXlRPdmPPHXjoH1rN5QrRbfpkLzT
qijmfIQYeDyPjUxSj+UcF/1Pl7/AAUeGugup19Rc+1OHP3tgIsrV15LU88OR
IHbq/a9wws9i7Qyp/8M6ha7p7F7YN0Vczifnc3ZtUsiBQgk83mm716mJzPdP
ZYrum36Qqkama3/AUKFOi0uqHwBOpEGC13sMe4zZVzSav4FF21H9WNIfN9kf
AlTEUlCwzTG7Q/rJaL+m9/U+GdSEsPIDazC8CNy7m0oQYNhYIrEg/Se9/dl+
anIIMk4l3vCoxMB0uvrF7/QwpNbO2crLMUSXa3MFI8MwjeKdI0h/Ly5grk7s
G4GImuCT1uQ+eJo1Dk36jELUhhFu6BMM3IzDPO/OUYjtnmQnFWCwvhtrZyGU
A9N23/j9HAx5hdVTUvcxkH17ZryOi8G4fvpFXscYeEt0nxdmYlg4L9De8us4
qCqEsz3IfR6M2O6w9vsPsEtJnu/zB4aDtO81OmEToHwyVOfYdQwN8ek7qXgC
BAaGAXuuYHiaM+rXLJmE/ddKRwjynpwV3Y859XEaigyHixX8MfAt5nULaBTW
/E11l0wdMLxzTitV16SydF0ciy6qYKjSmy4en6WxAqIiub+3EnDqkpTL1lJi
Gci5MbXJBFxwm8mr3KXE0hGVu5knEHBz+YJi63gllu7VrfJTNwngCCyrTFTo
rNpQJ4WGMwRkc6CWw6azVMUed0QhBOQFugoXRdNZK0QOTk3+BJQ6+rbdrKKz
KPx1JiU+BPx/31m0t7nsqx4E/AtsFiVo
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vk/1PsewPExY0yRRkQpVPboUI6lyLy/p42cTiUpp85kO0UiyVKKKEU4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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FPwaB3CNUCRdS+oVyvpGdzJFMmY8XqlBZW+RjEg3ZRAhhCSUJVpk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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs41GkUxweTeSKxUrsRuZVbsa1cJ50pamiLsrMSuWRN2wVZmyRaIhsl
VmQlImKRjBCVeCfEkFsiXcYQxn1+r8Ylt7S/fZ79433O8/nnnPd8z/keDa8z
jmxJCoXiQb7/IlIIEHz9SuOWbJrP/ponAnfL1KLfamhc1smrTbwSESz9UvPH
wGUa91oFo+PiMxGYVyhubFhJ486Ui7febxNBsVupR9waae6ysVmVwowIhlS9
iOIvUlyzEX7bg10EGKn9eHi7rCQ34EmEQ2wkAZN1nZQwTQo337H0eX41AaKq
v89Uqi8hpWnT01FzBKgFLCRYWs+hwmx1vUu6GN6vMm/7qDiNHPyEHa9+xtA+
SrtiGz+FPm1g2AtdMLyo797JkZ1C7u87Ans8MBSHBxWFUsUo22U4KeQkhtWj
vipGExiV3zv70DcEg2St/lzhLIGi8gtC3cIwfE4b7tSXIJB34cYtJpEY+g4e
i9u8bgJdL7BQSruKoVNf7fQ99XFkO59FN4jDwKN+YGoajKFmo07trAQMDx+z
JNQYI8g8PXQDMwWD7X7eoNBkGLlW2OQ/vo2ht5fOe2AwhCZv+sTLZWCQo2nF
W307iFR706yP5WC4l5ocsEJuAK2k21E88zDQDWWcWiT7UcD19Kld9zF0FPRb
POX3otmCQXdOMQZFReqHgvEeFCtX561QisExeFPo7YUPyJAWZun8CMNr5onq
0O/eIrAYh7QnGJQ4MR6+Om/Qo0RvdkolBta6+xR3006kJLbbG1JF9jco2g2s
dkQ7Fa47w8WgLPSwI941o4+pAe6XazBcowyucpdtRJWfBfTFWgxLKifaW3a8
QAwOu+rICwx+ZhOJVn7PUfW8oDejHgPK6StygUpktsk1s6UBQxZ/xMQyqxRV
Zmou9fMwyOj0BxvL5CGudPlkbyOGTD2hvDAjAb3a3BpS10Tmj92zUPEmDlit
1K7MlxjsXddG2dPzILfJxcezGUNRfnNUkGcZNC83gFQLhvKc1Y3M7Geg637j
QAzJgoO60qt+rwH29IEkMcn99o06Z5PqoWmcrwitGIb2n7LjP2oC9o0zPD+S
x/bJnrbpboU0t8tll0j2HlTxmXF+BZ3LC+xgkllaJVm2e1/D1kZVmjPJNl62
724bd4F2Jj1FleTtdwXyWL0brHIF65vIetp9Z/fuXv0OxJbNsW4kK22UvXhz
8T1kf6aKu8n/U93vlo6M8CHtft0+C5Kn0szG6G8EYHs4IuUS2a/D9uKYi+f6
wNQn94c7pB7aqTZqPZc+wk7TQO90Uq+Fr29LdlzvB6WGiu/DSD3b2L7MtJQB
4FdHp1qTet97KcFfzB6ENitWzhg5nwvbkv1dOUJw6uxmna0j832pvqVcPwxd
h5JKjJ5jqJKXiktuHoENdHONUwiDkyYzQvH1KNTaHXCKJvcjmtl2SqZvHAaO
mOr6k/uk4bLG48+hCbizvNhmUYHhqc/hnyRFIjgnWMsaLsMwntBLX5jHEKHj
JUNwMFjtjvzoFTQJTfP+o4EPMERVrsvhfZqEYu8nbGEBhrVFVluShj6BOIhi
H0L6wU3nFZ73FIOB41/1d7Mw5GR6l3p8EIP2XMgMh/SPSeI1S4P2KeihfkqI
vIWhkFO7MM6ahs7jLlTJZAyazYtPC99Ng9bLOWnvGxgUVvjQDQdmYNvbhMEO
0s9j5/bv2Db7Gf5RVtZ1u4DhqNTsi/UBc3DRsVtizzkMrfEZDpLEHGzRbvBU
CsBQkif2ei2chyuhem9OkvfkwvuUmMCuRRh92lEz6YSBa7BCwJOiMHITF4Yq
9TA0WaeXy6+RZEyd15+OnyWgRmWxbGZZikEsidL7uAQEho/nMJWkGXXaqmxW
OAF/OC4VVh+SZkioBtsFnycgWluuzCRemnE0fKVHtD8BqTzDGi0ZGoOa8Otx
ticB2anQmMqkMSY5c6HGzgQU+hxs/yaKxuAk2KyecCCgfOex7ugaGsNRY+PW
eCYB/993Bj8oZmIDEPAvOm0uBg==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk31P8ex2djQigyslS2qJSlbBm8Pi0aqSuVKJKEpJSsJTVERGTJehHZ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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FPwaB3CNUCRdS+oVyvpGdzJFMmY8XqlBZW+RjEg3ZRAhhCSUJVpk
GUqYGa5s0VUhPyk1JDtFQvZl7AxmTHO757w3zznP+Z7Pv88/32eXs6f1BYyA
gED4r/1foi3ePXy+SJXA30PGUwu8qte8er46ZCB8zQdfSip+3LjmIocSxzgp
4d8elneeKuIJ/vZehaOntMUwVQ7+VfvPqKvKzLxvE7ihJFDlxs9uimqO0Zx8
k+RZvnMVMf0O18uta9P1kR60EaNzkV4fQdXy3quDnMtaB+13c1HYgeotOeTb
esLbagW4OA6yb624KIIbx8d6yAyZla6gKC+NcLsnN/Ula5xqqfgVZLInqWcP
W4SQLFeQP165jIpuuYuzPG8SFLw59/GHlhEsv663YrAIfqqZAXvfLKGoBl2Z
nRY2xM9fTZ1UdJdQO/PiAa/JfKJK7KzJ9udsJObfmbEBu0oMghStzZps1JmO
KeawDQ3a5gy3CdIXUa4Yjl7gdN1AkzHKX1JYRI+iz45cmCkwCLO7N8JKXkB8
Ku/4pH+nQdemg40/JBeQdbSZlNwLvkHTmMhtk/h5pEeQZaipKUDNhy8GhWLz
qA1fmuZ5RBfKsrLZMnfm0Edn46Dm+eNQFHqtIGj9HOLJuRRFXj0HDAfSvwZC
Z1FX3buPhEhPSMPLKpjxZpC88KNske5AeCA70l4UMIOIakmVsy/CYfOYu9xe
1jQq1DyVeOnkXcC801jOY08hjZwPt+VFH8JS2kibxrpftipWOO6XBCw/2vMc
sUmUuePjA1SYCn2WTnFqW1noMqXtECsiHdo0FNxoOydQgP9gAs09A5jrv5GU
NMcRv09fWr4lEyp6klSe6oyhZxisRMZsFjx/ZbtOwXAU2dhJnlFooYHJMebg
kM4ICrHOaNh0hw69vfrMfM1hlLI1RFF5IwP8rhY+8901hKZOX83ud2SAuIhy
PFF2EDmLWJHbExhAoyZ6C4kPoOYP0bNyBQzQx4qe/IzpR8GNlnHnCxnQ8jZY
79FyH3q+gBneQf3l3H69su5ehCtV6+tyZ4Ck5PpvuRPfUcyrT037sAywDlAN
SuV8Q1b5C+crO+jwoO+IfOzGLpRlFyuy6QIdWkmulUHbviKCGTG0pYMG0oVR
ju7qHejyIayknQYNbLc+EyAfaENszKmzHeQsSAiuzzA/3IIWq/b4vPHJhLbB
SSOwbUJffQRCZ37d648hR9Opznpkwsx+VGLzFGIEBjeRxWrRkz//cjx09Al4
6LIeEj3eIhP8RtfTZimA6H0FZ6Ac9avfwtagRMjsHtXBZ5agEFVPHNEwAZ7u
HpIYSr+PDsRoSwQpx8Nq7GHOy444oGy3q/n0MBrM7WUizPVz4GTs9rlZ30go
+Hd9xLVzL6DpNG/GszkMSumba0lZFXBNVO1umfkN6LH8U3jT1WoQSluewowE
QL95rbpPwgcY6RAZc7T3heFjl027/1MHjSW9luRELxg3E3Mz/tIAS/xnG/h8
CrgMylEWTzcDnh79eviYK9gqF2eaHGmFghv0dtMAFzB2NulM3d8OkUUoz9TZ
CbQzeiSmd36Bz53i8dItDqDS53PEaHMnmJPfL+4atgNpRbHgR9wuWLmeZJTc
dhLWkzNKRke74bZexftPAbYwn6Y7rt/RA1H7pKx+vrYGC+2iqGC/PoBLgZM4
ihWoUI0Vvt/8ATk03l9b8yyBw/9aTLjbD9EEL7d0b0tovOBOSkseAI3cWFlO
tSXQPq3r5mYNwsyn/fnEPCsIxCVesS8cgn2xru+zjtmARZKGUHnZMFTJUi7N
d5wAFV5lyh8fRuDJhge5iql28EZCMC6xfhRkWlXqeAtkOKlECpNsHQN5TYfr
NpbnYVo7xi+ucxx+VrzqVW10hTukxsuifRPgX84zvnj6Cuw6I+UYOcyCLVs2
dA3wfKGMcsoGMzkJWs2sXs+NIWB9I5UUMj8FR+8t2CzkhcPE/V59zso0OHTQ
Xtp6xwLR6NYP52szcG9zaqTHygOIKN9KZ87OgIe1S7Hs12T4rJ3riqXMQkRR
A1MqMR1kCoh7EoZn4VzWiYYyoyxwUG+eXjk3Bx/7Phs06zGA/tSlxPHbHFBc
SYownA2T25f9ak7MQ+Dtf+rsi8kGnYcxeM2mefB/+9oCumiQV/iOM2G7AFSC
7L0d9HRQqueW5XUugHZYOLKTSYCU0f3X3cmLgBEu9MUywmGLEEUfO7AIVwqw
1BjqFYjcReNOXWQDqDsXH99mCzxid3khiw1uAbPSdndx4HNGOuiK1xKYNGcn
i6gKwbjfMQKOvQQK17t/Ul41GZwVZNds914G253z4zilBIOG+HQLzNQy1NG+
7PZ4bG5guMO0c/zSCshGMvIl2Fxicc6cc+vQCqxjCPs0Sj8mquikscqdOJDL
URJ3MdYiJr497Ef7zoGUc0/bmW7FhA3m0/xYOy5cFCs5PlanTAjsSo7ybeeC
1hFcQFhHmL6c6IjEa/tVaMXLyw9av8FX6Okkrv5YBWQRbNSF/a7HS27OvDXF
gyYtqwFKxTvdKk2hHqaggGFSUVuoZ+APXN2hx6USUhhD0zo1cYnQwR3VctwX
iz8FDf/fr76hE3SStPBvh1iv5lVarfmOivgLnfg1U5nYamVRkd/OokItlbTm
PIpl0z8i1lxq4PTlTvWa//4Xfvu/4NvqCQ==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHtYzGkUx6fpMqur7YaiSLRq3UO6OPPkMlEqzIMlTReeLWIYEoWsFeVS
kkgodBGNooYo9Y5JNdkoqkm3mWqa7vN7q6mmq/a3z7N/nOd9Pv+c95zv95yz
wI+98xCVQqGwyPjvRTM54ulpGv+AUvTLlio5eNsnZp0Q0PgrilMt5zbIYdJf
cEF6mcZPpCo0xFI52OXpm5fNoPF3806WWSrl8OpALivaQIN/6wOvsWAuAR3z
/IhXU6r8FTd2+RYFErDczHWPrRaV75GSP2cok4D+TzWUcAsKnyUyq2Z1EiAv
vMcumD+JwlIK50QuwGDGGY+13ziKTPaxfIt3YGjQtqts1R9CC1L/0PYMx1DV
TbvqEqNAU5vZ9MOXMZSU1m3I1lKgKL+bkwFRGF5dDMk6pzaInA3b6wziMOh2
HzVd3odRVGZl3rw0DNRi61HuCIE+brv0Xv85BuXDzhprFQIZhF4Nx1wMLZ6+
0YuN+9CMU19sfXgYaqzNjqTO70W7+AX6Q3kYhGqNDAubHmQr3XObXYDh9Tum
ihm9C/EvHNg9T4DBxU3YLlvTidh2IZy4EgwSiYPwpU0HusOhCPqEGHRoC2Oc
ZrUjz4xBkUslhtTEuxx1HSmKTui65vodg8Myzd1fqG3IxznAY2Uthu8v2tbn
N0mQouavnrQGDPr6ao0vepvRuKjaWLMZw86zi849GG9E1hrPBpgSDNWMgKJz
s3+g3LJZj5KkGAyzo1hHrUTIcYjt/0iGgWmcSfFeW4OYmUXFlzrJ/trlzsCs
QoFlHnSVXgwmMtZWor4CvdNrvXK7D8N1Sru2t1Y52pCUzdQiMEyaBlR9cSxB
oiV70o9gDMfW9cU5HfuIFhVmnsntx4DSWrL2QQGqEbwXtg1geNrUtcb+aS5q
mVkaNzaIQdOq7exqzQxkothep1RgeLxEpidLjkWVtrTY5iEy/43N43miaAjR
VtctGMbgvt8owt0hA6bFOilhIxiynldEhPjwIEts7G6uxPA2TbeckfIB7rzx
10knWez5m4b2SQH437wi0RvF0OZebnXqTikQRj7FXiR3uB3e2vTmM6y9Zv7u
Bsk927SObKr7CqY858Jkkg+2mwYN7/0G0hPv/e+RzFyY89RlSzW81uP+CCZ5
k59L/YPVtcCuD5zrQLLtE7Eenl8H8Rnnl3eS/1u2nNrirFsPitaX+qEkG5pr
nY+faIDXnMlSBVm/mveT3K6uJnCrSN/OJFnxcF2Pg0gMhZJFGQ/Ifj1sX0Wd
P90ConlLjfJIPSwTN5k1/9UKLW7EII/Ua3z6R47jzTaoWLZ2UzypZ+Who4yH
CVJQhC/U3kvqnfqPStNESjtwuxa7T5H+hK68e3x/tgwOyqm6EaR/llNF901K
O2GsqHOWI+l3oZ5q9N2KLhA7DS491Y1htwXjkn51N/A0dWUx5HxEMioPa7b0
AtWU4soh52nBPgPWlY4+iAkXqa1vxZAftGcXVS6HVRuLgqViDL2xEofxMQz7
p3/GS+sxODn/3eoX0g/VGdQVAXUYIgqM04QD/fDpxPCWmhoMRllOv9/pGID6
599U/cl9OGD1DY/5DMII4fU2ogJD2uODuazGQXjy1WQ6phzDmrjr9jZVCphc
1XxsfzEGbnbxeC9zCMpNPjnWIgwWFRP53PohiPeyC171AcNM9SCHZdJh4H7O
336P3Oee026OK0eUIGy/XaKVisFLdaRkDmcUkkL9VxPJGL7GJHtQiVGw85lU
f/cAQ07GoF+1bAyeNaerUMl7EtqQEBVcOwFPq+zPHL+IgW+jLhaqUuiGYT/R
9E4Mnzc+eqtnQKXnrs/UvGWOQWA6wRv+qUpPva58dL+bgOCLvWkMQw362hxm
X14GARd2TnKLdmjQLabSAr8/JiDSUoe3JkaDvmux64QogYBE4TLBQk0a3YAR
m5oUSUBKIpQnMmj0296LW30vEsAN8qz6NYJGV9KUYXpnCHi7wbcuUkCj58zt
v/qMTcD/950+JrGZbf0nAf8CHKk5/g==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk41Hsfh2dhhpEluyOcE4p0Wk1kGt9/spYjQo9DEeWgUFkjkmOpDg06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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FPwaB3CNUCRdS+oVyvpGdzJFMmY8XqlBZW+RjEg3ZRAhhCSUJVpk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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs4lGkYxscwpohq0Ek5t0IpRSqHZxwyBhUl2lpNdNhCB3KIRaVsOqA2
W5qSnNrSRA6rUryTVlEqZXJKDnNA+L43UTSG9tvr2j+e67l+/9zX+9zv/TyG
QQc37qbTaDQeVf91NCO848cPpvBMPX3i2WoCtq/hF4ZVU1yeFRbiQoBiZ3WC
5CRTGJsjYim8CFh1n6X/fCpTWHHNOKmbR8C9gFJeqpaqsCEet1ScJKBnQRB5
b0JZyH4QmL2qgYClep7+1up0oXRCx9BgJgmf/xHRjhrRhAfeMXt5niQQlZcP
PjJQoMiAIX7QSRL0wuUX1riMIf2tl4MLSklom7bqTTdrBEnenTH16SKh4RPz
lHvaMPJ/qcr3kZFQ86zZsUh9GAkmV+jb9pNw71h0YZzKF7Q3t3BJ8TAJmp/2
6y4dxGitjnySx8BAf2o+JvhGoreWukynqRhGr/WKzJVI1B4lXqemgaHLOzD1
p1mDyLxrW8RmbQwic72QPIMBpDTCcmmejaFW5QPHyKIfBQbEWjrpYih+4Kuk
x+5D9EdCu1eGGNy9aqUym16UyWvtsFqIobPTrvauRQ/iXXziFrsIgwbTOM1h
thQpGrhO5ZYY8viXwhkaElQlfV192wqDnaWa3yu6GJV8InqOWWN4VyBeXdHe
ieL6dcZaV2NgsVQ+FAx8RNvKbVjL7TFsjFkYd1X+AXHL8raGOWJo5OytipvT
gpa8MAnMd8agXXSat9+0CXE3m+jwXTH4zrpD275ShCYMvCWRbtR8UsIZfBvQ
Au3Lj8VcDPNkPC7ZWo8c76bMDfXEcJYmnbZdvQ7lJHJjPnphUOjubXhlX4MW
B0e3rFyP4YDt4EWHA0+Qbdj4iiMbMKD8rsKt8Aid6vucnO2NIae9z2ZNTikK
OVggKvHBoGYqjlmhdgsxJou1BRsx3DCTTZdlXUCVZK1byiZK/9xa+f2mVDAy
fbh7jy+G9dt0ktbb3YKSouuWxpsxFN6uT4reUQaVU2OynlJcnq9Zx8l9DD45
6eUcPwwd3otUpx2uhqbWM+FFFIvX15lGpD+DMDXnd3KKe7yCue1/v4DJc4TI
zB9Dv4d6iGvza7j9WCPWnuJdUt3Qr1veQvEfBR7WFPsal+S4uzVCXyfeq0Wx
a5B769UV7+Erz+J9K6Vnnd0xHRs0Q9BSWdopik26ItycNVshpa7zynyKtfXV
4/8cb4NMxpyRDOq9KtuzS/v62iGPVZOloOYbvmbbb9fUAaLwLdc5FG+wvnc6
PqoLDA2Wp/xK+WHCd9X7eLwbtO4qjgdTfsl/tJTYp4gh6mHUUW/Kzze793Ou
ZUigzKkoeS7ld95LpfbxXCnkn2dk11D/E2t16dC2IhkoLzOr911H6U1UXZn3
rBd2/GwaMt8DQ+V05dRL9X0wePNqQoA7Bj8jTiKr8RPs6fWvTqTykcx5E6zW
NQD7rJ6TMVSeDLdq8X7vGYQIkbPYk42hItR/E50gYPf+y7p0Kn8DFzrt5N8x
nLA6fUSXyquD84nuoOjPEOCiuCJYiSHp0az82qHPIDk4r2whlW+dQofF6T1D
wAhm9r+h9iHA9C3+vuMLxHNXsZQWY8i/sauU9+ELhNq2eM4zw2Bz8ewai4Zh
OOSXrMkwxiAoeiof8B2BmMzcm+f1MRjVj1cIWkdAqnVpNW0+hhmMUDtLyVew
qV0UfZba5/4oL3urb6Mwmp5xeJMKhl+Uv9XMDR+DwDtVf3nQMLxOy9pAJ8dA
c1T82ExBQsmtL0GNsu+wbM9vxVnUPYltyzgd+X4cskYTJCHdJAgtGB21yjT2
zCHrc11lJLxwySyfrkVnP2jxjotIJKFad7zs66QyOzwxMzJ1HQmRxwbyOdqq
bDMNJ/cRDRISNioEVT6q7IUZ8uyVqiQkm2iU2aSpsqfYFyXsnCSAX2tZbazG
ZN86fmVKPElALh/q+BwmO/rhlLZ9PQQIQr0bZiYx2a8FsiinDgLKHQObk6uZ
bKGgcki5iYD/7ztbkuoRUPyKgH8BhXcLlw==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk4lAsbgGcxM6GTk2whSaojp4XMIdLzWkcjeyFCyJKSk2MpZSnJdLI0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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ7UHa+W5WzvZPhw5ApD
vRLDgb9aRY7/T3wQe7t3ev5uhT/7i6zy1b8oWyjLFf2aaOX8Y/9CNftpSZ6B
Grd4LM4/FPqynzXYqklSMVmL72WutP6b9/sdXKfeXLT5o9bGHSGMcg4v9q+o
239UV4FT+9KqR5a77tzfH3LD/Cq3ILf2lSdvnexDLuxXPubZVMfBqr1A8yn/
0/kT9+/8GdR97eQnrVde3Nku18/ZX3SZ0FFXf1Hr8xzzV9bX7tm/eP3BxGTm
Ni2Vv/tmSh17bl/6berU8mf7tF5PvG/96+d7+5c1XaosWh+1TCd3W2lf+GzP
xuPw748mp/arMh8bw2/f7cvPK4QX65poVd2a0Vl69bd93TWtA3N3P1M7oM16
7wQzg8NWnhcfJom7yp5ynruNX5jJ4fm1db/V9npwHJL+veXrP2YHWPiVNrxe
6i7CBufXBf1Zsy8Qwe9Q4d1i2o/gzzqhd0iZix3OXzzL/uQsdwR/TU7ABcFW
BH+bXeL1jkMIPjQ9wPkAqUPO1g==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs01GkYx8e4zOa+SFuOKZfNvZJsraFn1m1Qxy2bQpRytiMUKVsikmQr
EiLlkEtJE4pulHeSaogo90vuxjC/12VcMq7723P2j/e85/PPc57n+/0+j4bv
SVc/KoVC8SHffz9SDOlZXaVxqgviX96fFIC3WUZRcBWNs9l2NLlDJIClo1WR
g5dpnEpNvQsrVAJ2vVTa+GkNjdO8YERXWEtAyaFSnwRlKY6t7Wyw/S4CeOq+
4yXL4pztdbdoZ6II2Erf475DhsoxPmp6M7qSgMnqZspFTQonxIPrajxHAH6b
drJi0xLS0jOfe2qIgR6ykGRmNY+2d7k7DB/E0Cm7q6FfaQalRa3RTb2MoXGU
FmeXOI2+/d1jcygew4ePbbuLZaaRfPiDfJkEDCVRYUUXJIRIkukn2pCGQX40
UG0rMYFo6tV51AIM1Pf68+y5cWTnYbj88jGGH/dGmvXFxtEtveqs/cUY+pyP
JGxWJRDFWTLH6QWGZn36ibxNAqTSFjL16DUGrkQXS9NgDKkkpvvjNxievnIT
ozP5yHK5tWLrewx2e7lDw6YjSINnoBv0EUNvL4P7xICH2v0t05JqMMjRtBIt
1g0hYUGiZ1wDhryM2yGScoNoRTEg++A3DIwt0vvrqQNo8s2fnxRbMHwrHPi9
vLsXNY9wM406MSgpSXQVCr6jh6mnXE50Y3A99+uFuwtdyHxF4JDUg6GJdbzy
wi/tiOFOXUwdwKBSHO8TqNOKnm5cfhg6hMFN9THF+7dmFHzuWhyDR843hC3B
rREFXEqujx7FsGHYx368ow4ZV/zVLRrDcI0yJOstU4NOTRkueRAYltSON9ab
f0DUwOd6+RhD0E4i2SLoHfKDn3zbxzGg/L4iD6hA65yO5MxMYMjp5pua5ZQi
G19jvmgSg7TOwDkT6QJ0R5duzJ/CkK03rDCclYRY1tRwJCTrX7dZeNmaAA77
SmQTpzE4eq6NdWQUAEs/NM5qBkPRo7rYsMNl4N96dLSb5Bf58jWs3Dewe7xn
m+cshh5nXSnZ01WgeCfBq5LkAccandCUjyCe6ndCag4Db6+/fffzWqhmZHuZ
kDzmIHPCuu0LKF6p3mpD8rEhtYDZA19BSLvpZUGym9azHDvbJogO18HqJFv7
2nXcNWmBuW0t/Tyy/o77PQoTm9pgiqXGSCdZuy/U1lK+A2KflIqMSVbZKBOR
utgJ9utv0svIfiW875fy+d1QvqazkE7y9L2dY4zWHriOhFnB5LxOO0riI872
wXVde/+7pB7aGdb079H9sFONH/WI1Gthtf2Z+Y0B+MPxJO8uqWeDXyDrXvog
EHs+Z4aQeud9FutezB2CmGOmhUakH+eNb5/yLB6GwCwThXrSP+3lyjsbPo6A
SW2M8BXp91sF8YTbdXyQl3MpluNj2K/JuqTUNAoRs5ktLDIfV1kN/tJ9AoiS
nQ4OIPOk4aHsc4VHgL6vg3B/H4byAPd9VDIHDyLQ5GYyf4KkXsaCaALclQsv
hnVgsLCM6fcNmwQd/RWadhuG2ArVfO7UJPgMZKS9bsawtsjCMIU3BbU1roNZ
5D4c0vk6IToshIEU68eTdRjys4+V+nQJwVvG8JZ+LQbT5GtmBo3TwA6pbz1Y
jYFd/H5B4DYD42wrd9l3GDTrFsvZHTOA8jTl895iUJQMYGwZnIUo2j/WMeQ+
j53da2489wOOetaMij3E4CU+92F9yDyYe0fe2JyL4UtilhN1fB5UOR0aO7Iw
PCsQ+jYNi8C2V91Smrwn5zvT48+0LIKYNvd0biwGjoFkD1ecwix/sv2TnCeG
WqvMFwrKVGa4f3hKhz6GKrXFstkVceZgZI0ja56AM1GCfJaKFNPaPTHoXAUB
ka5L7EoXKWZmtMScUhkBV7XlykwTpZjZB84K09gEZHC3VGlJ05glDa8TjmUS
kJsBNRksGrNJ1siFnUoAO8C58edYGvPAk9763hsEvNh9pO1qFY2ZrJSguhpL
wP/3nSky3GghHUnAvwK1J8Y=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk/1IkfgGcMM0W5zyW5hdaxjpzz/tAyUllX2V0ht1AbOZIhJVdEs6to
HGOJtpJ0OePziYiaUEQUxhnjNrnGtft9vb4/PK/nH3h+eBS9/3Dy48HhcFn/
8T+jwmGDOzskbDi46IfQbSbZw5ReHtpIwpSmTnn21XWSN30a40avkTDTdqqS
3tEuMv0G2/4EhYS1nTEwPGrcQzauEt3/ZjcJs08MsknN7CP3sEznjZlErNV+
+NkbjwFyOL8P+iCDiNHt7K839rPIogZpmXKORCxHNDwzyWmUXOH+zDNDjIgx
EurSnRUmyFWGqU8+dvJhaOwFKd2cKXLDXk+CVAYfdoNx8KAQbZb8etzghNtR
PiygxUyHILhIflfPf4+xiw9TT651lSzlkD/eYq2NNvNiNMtshn/uCvnz2Uq7
Awm8WMF2dk/7+jp5yDo9LwThxTbq3u2ntm+RJ/Z5z1VsETBVWb+LRHE8zFtc
dvNCCZhJqi+X5EmANfe8VpErBEzmkve0zRIf4ONqDButCFj7r3ISNZ92AX9B
T1EYLwGLCvaSkBDdA2INHCHlFh7MovhlMatCCOQGhWO7knkwkdrJFzAoAmrb
P7ITjvBgrirVJooK4qAjf9TVQIAHW/4pAWd+VxJ2OVPL9rXjsRu+vn7nvGWA
lfwIT6LhsQtQczzhrBxUvxw8ueCMx06b9ET1MvfDzUWhsj5JPHY99OXzH18r
QqCaJb6pD4d1/Hm09Hi3MiBuYSfL8nDYwORFfx9ZNZC+WfzwlicOk3wlHn6q
4AAsvO7GXVbCYbHfDnde9tYCb4eAxxHYDmqz4EaaeqoNo5Kq7rNmO6hU40n+
H3X0wHdghN+vahsVjgyITjXSh4niwuqvP22j+tR7Y4sXDCEwyMPfpXwLpV8K
vi89cwjYunLiTI0t9MHNTx6bxaYQstr36nDJJsoac46aKrSA2frsP+oUNtFn
vQFNFuEIhIuPOQuUbKCr8UwLOwUr4AbpGrtpbKA9pPoqzuJhiH9FlXv4iIvm
poiZsKatgSjdhtvQ46JFbxp3dwvbQvo5iXG7ynWU1R5o/cTHDkSbvdroputo
3BM1o6hvx0A+jEszPbyGisbmnVKmOEKkalG0Tv0qupo+skdvxwnefz7ipXJo
FX24Yz7+7osLqKQv2so8WUFzOR292kMngQp3dAW1VtCEuuoDRQK/QfcSIk0o
WUartHgDo33cQKt0cmdVfhn1MLqjKjLlDv17jDuGRb+jxxMj36c0eUHnFCnZ
NpODRiknhhXa+UBzSy/5sQAHpQxzTd1nfKG2+N6KRMoS2n08KX/gvj9UxEeV
U3mX0DINRXWza4FQ6k7xH41fREeaEtJSqEGQZyolb7e1gFJsinI6/goBwamz
sjoz86i1yKxuHu088DRprpWtzKGW7cd00epQWM371q2Jn0PVz2i+Zs+FAcvB
K0NNcga198+mJ6VGQLemfPBdhWn0embocsRcJLTyfqEoabFRH6bekSCfi/Ck
2gUvj0yiba462uzYGLA91jo2bvgNxdNHT8xQYmFoyKz1kdYEKhxlPCOlehn2
kpQzLaTGUNGGRXOz9Cvw8cGISe3XIZQlU+mYNZsIoqK8Xx5MD6Av2sVY+0jJ
4BStSs3lfkG7I47EZamnQBclsIEq/RnVdAn8rT/mOnSPzVqBSydaYG1RfsUv
Ewo1xoXGGTQ0rNqRGtCUBZvp1tyqngzY/ij/KS3sFti7SSTam/0DFd2TLJzC
bagsEWyjFL8EV+m/Tr29kA2DDgeIey40QgqTkywikwMj9m3q4VktUJWgb3Sz
NgfYdgLBP/e2w93aGE2phTvgOyYbsvzrBzhjqZgTHE0HF+WnRbY2XSC9LChS
tkUHg78HheYVesE+9XrSieVcUGGF21gJ9sE/eImYtYA8EN8vEHtrox/mo++H
bnblAa/H388mJ7/CHvZK5C6TfODkHWKb9QyCWBwhrvV2PvxiUJEaG8kCw5ie
W+2cfFCh/yw/cGUYnpfqz6ZQCoC78/mp+Y0RqMkZu1lMK4AOv7OUvJxR2CW9
XN71oQDuvsN/3Sgeg6XFRPHPJAZc0rt93u3xOFhd2ZcXrc+AX7I1+epqJ0Cj
9nxamgsDVLYa7vzQ8g3605qHpoMYUC9EyLjNnIR6ClfRP5IBJ5UoV0W7pkD+
Dcf+fBQD5g3SIjP62OAa0+C++xwDUigdQfysaQgw9btv+jsDFH8X80yamIHC
5XPDUuYMqA1xdeaZnYWRJpupBjEGOF3OpcRx5kD2dV+p63ABTNOGzLjr89BC
HMDESgrAwiph2DtqAZhrjg66vgWQWCdZ0rq4ADZIv4+ybAG8N3gQqB2yCJH1
72mab/NBotziYNbEIuwKKSpNDc0Hd/UP8+unlyDqoI/NdZF8KCn0feb5ZQnk
FjuTYh7kgeFfaaZanRzgvJ+cvNaaC2WPm7jTLt/Bh4bTrj6cC0rMjdqyvu8w
M1LJdaimgzBfiJn26DLI+BdkPs+8A+zIY+Z6K6sgc81HdZIvGy7156RGfNoA
krJGR/sYDWT5vwnVuG1CWYSmGkePBi9NDG9vDm+C+FXM72T8TdjK+VCUMLcF
P+xTXyBaZwCmxTfYSsAhvUzxmHN7U+GVtnTNE2scsifaRVqjJxka9bSy6Mk4
5MPVV80BpUnQfMjRLkQAj6zdKQzb9rgGLaa+qieO4xHM3GZ+k5IArRZROHIm
HvmDZ3ueaXIV3h7OrxQS40GkbGP17xnHQ9t2YGS6Aw+S4W9qxX4YB601Bka7
M3gQklHDva4VKrToMF/w7CYgC23/eNXXR0MzOzvisg0BmdFI+FhhchFel/gY
biYQkPogk5q+5kholN14vrxNQMhaT5XUBMPh1wMyHIYlL5JUNKJh+Tjsv14O
6dld40XuE05nenmHgpz9hUcFu/kQonGE7AHuWXj6O23a9hgfIixbW0p9Ewy2
AY81OBl8SPml9XeWL85ARPx0CUWciPDv3//u66wfxDltljU4EhHD7w5va1x9
IUVl73PDTCJi9FxU+1KfN9BW9tWVMYmIU9oyVT/MC+it2o3K/CTE4E9rq3WF
01BMhzY6hYQQqr2jX7a5Q1mIQ6dIIgkJNG+cY0e7QSXZqzelkYSAZTq91OE3
+P8vIc5c/Udyx1zhX+9VewQ=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ4U2Oo4rpP35vxw5ApD
vRLDgaT4xmMbr26Uf7t3ev5uhT/7Q+WaFVKX/dSWK/o10cr5x/4SWYZImTgh
w1s8FucfCn3Zb5CpVh8UrGLM9zJXWv/N+/23VaOqGc9vMt64I4RRzuHF/uv8
ygkpm04ZX1r1yHLXnfv7WXae8g85dMb4ypO3TvYhF/ZvnPFml2HkMeMFmk/5
n86fuD9QQXbprG+bjV95cWe7XD9nv1r5SeWs6ZOMP88xf2V97Z690KQPjN+Y
KoxV/u6bKXXsuf1Zh4UR/VkNxq8n3rf+9fO9/fojyw4ct9lkbDq520r7wmf7
I5LxCy7sOWX8qszHxvDbd3uhqN+SJQVfjapuzegsvfrb/vv73Tlt6iv0D2iz
3jvBzOBwdVNTv3kmm9op57nb+IWZHOpbmmN1PLkED0n/3vL1H7MDLPxKG14v
dRdhg/Prgv6s2ReI4Heo8G4x7UfwZ53QO6TMxQ7nL55lf3KWO4K/JifggmAr
gr/NLvF6xyEEH5oe4HwAgkjNyg==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs01GkYx8eMTIwoZEO5JkVHW1Fu45mDmtrakmzp4trNilySku6lslpU
IhPHrdmV3GpcKvFOpEakccllSJMMMvN7XYZyW/a35+wfz3nP57znPOd5vs/3
eYz8gt2OUCkUijcZ/71oYVj33BydX80sOdP9RgZedpyC0Co6P2rTOM1TKIOZ
Q1UXvl6j8z0T+MqCDhnYlGkYvFWm853Lj/18SCaDIk+ed5ymEj9qPDfr8UIC
+pb54aJ/aHwe+sShHCBgjf62vVYMKn+l5sXBAQ4Bw69bKBeNKfx7NXO5zi0E
EBXJweWGM2hQvNTmqCoG/bCp23bOE8h1JMZ4zA6DSNXmwxeNMVTimOEqPYpB
+I1+Y0u8HNFuFS9pP46h5k2bYyFDjpLFHp65IRiKLp0uOKc4ipYHm6+ai8Sg
9i1Ib41sCEXbGYT7x2KgVptP5H3H6GBFr71dPIYfqf0t5goYlQlL08fuYBC7
+sat0Jahk0+oOiYcDC3m+scfGkrRmNXrZclpGASKnWxji0Gk/d0oTZ6B4ckz
dwV91gDaNJkoO/I3hi3bBb0S63402+dvU5GL4fNne0G+RR+qIxjPJvIxLKCb
xDN/6kXlosQ1S4sxPOQkhc1b8BXVMLK1Fcsw2Fuq7HlP7UEvbRrVhc8xNOX2
2L7o+owSl5noaiEMGhqKnbnST8g9pWHG7xUGt0jTcw+mOpFpsFdwSjWGZrZ/
5bkl7ejJ0fVDL99i0CqM8Q4ya0Xi23Gjj2oxuGs/pnhtaEFpu6ZCL9SR/fUS
TuAuREbbeM2fGjDoSry34o56NLtfbYWvEEMspVfVi1GL6iMuddQ3YpjR8xe+
d6hB1BvVg4bNGE5slN1lnniFApve7vFswYC44oL9UI6oKsW6Vz5iyOoasLbL
4qHG3ZL18a0YVMx6Iter5CD934bSr7VhyFglUZek30YF9qkH/drJ/Lc2TZW1
xsHm0S+mNh0YdhxYHL3DPgeatK/PHyW54FF99GmfYvhLOYGaIMJQylWrZWe/
BO8BNw2NTgzdriuVVE9WQdC9oA1nSO7ZUWsWnvgGdlW+C6oiuW97wNaukncQ
J84oGyZ58BfGcZe2Blj9a5gmrQvD4V69wHGPRmAUMRWnyX93k6dZWzY3Q2FI
XbaIZBe/LR0P1n8EIx3/0UySrTK71YcM20BQkDLsSvJycfhmJ7UO2F1kkN5P
1qdlwDh/b1oEjRry2SMkK3pl8gYGuqCZuXlRPdmPPHXjoH1rN5QrRbfpkLzT
qijmfIQYeDyPjUxSj+UcF/1Pl7/AAUeGugup19Rc+1OHP3tgIsrV15LU88OR
IHbq/a9wws9i7Qyp/8M6ha7p7F7YN0Vczifnc3ZtUsiBQgk83mm716mJzPdP
ZYrum36Qqkama3/AUKFOi0uqHwBOpEGC13sMe4zZVzSav4FF21H9WNIfN9kf
AlTEUlCwzTG7Q/rJaL+m9/U+GdSEsPIDazC8CNy7m0oQYNhYIrEg/Se9/dl+
anIIMk4l3vCoxMB0uvrF7/QwpNbO2crLMUSXa3MFI8MwjeKdI0h/Ly5grk7s
G4GImuCT1uQ+eJo1Dk36jELUhhFu6BMM3IzDPO/OUYjtnmQnFWCwvhtrZyGU
A9N23/j9HAx5hdVTUvcxkH17ZryOi8G4fvpFXscYeEt0nxdmYlg4L9De8us4
qCqEsz3IfR6M2O6w9vsPsEtJnu/zB4aDtO81OmEToHwyVOfYdQwN8ek7qXgC
BAaGAXuuYHiaM+rXLJmE/ddKRwjynpwV3Y859XEaigyHixX8MfAt5nULaBTW
/E11l0wdMLxzTitV16SydF0ciy6qYKjSmy4en6WxAqIiub+3EnDqkpTL1lJi
Gci5MbXJBFxwm8mr3KXE0hGVu5knEHBz+YJi63gllu7VrfJTNwngCCyrTFTo
rNpQJ4WGMwRkc6CWw6azVMUed0QhBOQFugoXRdNZK0QOTk3+BJQ6+rbdrKKz
KPx1JiU+BPx/31m0t7nsqx4E/AtsFiVo
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vk/1PsewPExY0yRRkQpVPboUI6lyLy/p42cTiUpp85kO0UiyVKKKEU4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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FPwaB3CNUCRdS+oVyvpGdzJFMmY8XqlBZW+RjEg3ZRAhhCSUJVpk
GUqYGa5s0VUhPyk1JDtFQvZl7AxmTHO757w3zznP+Z7Pv88/32eXs6f1BYyA
gED4r/1foi3ePXy+SJXA30PGUwu8qte8er46ZCB8zQdfSip+3LjmIocSxzgp
4d8elneeKuIJ/vZehaOntMUwVQ7+VfvPqKvKzLxvE7ihJFDlxs9uimqO0Zx8
k+RZvnMVMf0O18uta9P1kR60EaNzkV4fQdXy3quDnMtaB+13c1HYgeotOeTb
esLbagW4OA6yb624KIIbx8d6yAyZla6gKC+NcLsnN/Ula5xqqfgVZLInqWcP
W4SQLFeQP165jIpuuYuzPG8SFLw59/GHlhEsv663YrAIfqqZAXvfLKGoBl2Z
nRY2xM9fTZ1UdJdQO/PiAa/JfKJK7KzJ9udsJObfmbEBu0oMghStzZps1JmO
KeawDQ3a5gy3CdIXUa4Yjl7gdN1AkzHKX1JYRI+iz45cmCkwCLO7N8JKXkB8
Ku/4pH+nQdemg40/JBeQdbSZlNwLvkHTmMhtk/h5pEeQZaipKUDNhy8GhWLz
qA1fmuZ5RBfKsrLZMnfm0Edn46Dm+eNQFHqtIGj9HOLJuRRFXj0HDAfSvwZC
Z1FX3buPhEhPSMPLKpjxZpC88KNske5AeCA70l4UMIOIakmVsy/CYfOYu9xe
1jQq1DyVeOnkXcC801jOY08hjZwPt+VFH8JS2kibxrpftipWOO6XBCw/2vMc
sUmUuePjA1SYCn2WTnFqW1noMqXtECsiHdo0FNxoOydQgP9gAs09A5jrv5GU
NMcRv09fWr4lEyp6klSe6oyhZxisRMZsFjx/ZbtOwXAU2dhJnlFooYHJMebg
kM4ICrHOaNh0hw69vfrMfM1hlLI1RFF5IwP8rhY+8901hKZOX83ud2SAuIhy
PFF2EDmLWJHbExhAoyZ6C4kPoOYP0bNyBQzQx4qe/IzpR8GNlnHnCxnQ8jZY
79FyH3q+gBneQf3l3H69su5ehCtV6+tyZ4Ck5PpvuRPfUcyrT037sAywDlAN
SuV8Q1b5C+crO+jwoO+IfOzGLpRlFyuy6QIdWkmulUHbviKCGTG0pYMG0oVR
ju7qHejyIayknQYNbLc+EyAfaENszKmzHeQsSAiuzzA/3IIWq/b4vPHJhLbB
SSOwbUJffQRCZ37d648hR9Opznpkwsx+VGLzFGIEBjeRxWrRkz//cjx09Al4
6LIeEj3eIhP8RtfTZimA6H0FZ6Ac9avfwtagRMjsHtXBZ5agEFVPHNEwAZ7u
HpIYSr+PDsRoSwQpx8Nq7GHOy444oGy3q/n0MBrM7WUizPVz4GTs9rlZ30go
+Hd9xLVzL6DpNG/GszkMSumba0lZFXBNVO1umfkN6LH8U3jT1WoQSluewowE
QL95rbpPwgcY6RAZc7T3heFjl027/1MHjSW9luRELxg3E3Mz/tIAS/xnG/h8
CrgMylEWTzcDnh79eviYK9gqF2eaHGmFghv0dtMAFzB2NulM3d8OkUUoz9TZ
CbQzeiSmd36Bz53i8dItDqDS53PEaHMnmJPfL+4atgNpRbHgR9wuWLmeZJTc
dhLWkzNKRke74bZexftPAbYwn6Y7rt/RA1H7pKx+vrYGC+2iqGC/PoBLgZM4
ihWoUI0Vvt/8ATk03l9b8yyBw/9aTLjbD9EEL7d0b0tovOBOSkseAI3cWFlO
tSXQPq3r5mYNwsyn/fnEPCsIxCVesS8cgn2xru+zjtmARZKGUHnZMFTJUi7N
d5wAFV5lyh8fRuDJhge5iql28EZCMC6xfhRkWlXqeAtkOKlECpNsHQN5TYfr
NpbnYVo7xi+ucxx+VrzqVW10hTukxsuifRPgX84zvnj6Cuw6I+UYOcyCLVs2
dA3wfKGMcsoGMzkJWs2sXs+NIWB9I5UUMj8FR+8t2CzkhcPE/V59zso0OHTQ
Xtp6xwLR6NYP52szcG9zaqTHygOIKN9KZ87OgIe1S7Hs12T4rJ3riqXMQkRR
A1MqMR1kCoh7EoZn4VzWiYYyoyxwUG+eXjk3Bx/7Phs06zGA/tSlxPHbHFBc
SYownA2T25f9ak7MQ+Dtf+rsi8kGnYcxeM2mefB/+9oCumiQV/iOM2G7AFSC
7L0d9HRQqueW5XUugHZYOLKTSYCU0f3X3cmLgBEu9MUywmGLEEUfO7AIVwqw
1BjqFYjcReNOXWQDqDsXH99mCzxid3khiw1uAbPSdndx4HNGOuiK1xKYNGcn
i6gKwbjfMQKOvQQK17t/Ul41GZwVZNds914G253z4zilBIOG+HQLzNQy1NG+
7PZ4bG5guMO0c/zSCshGMvIl2Fxicc6cc+vQCqxjCPs0Sj8mquikscqdOJDL
URJ3MdYiJr497Ef7zoGUc0/bmW7FhA3m0/xYOy5cFCs5PlanTAjsSo7ybeeC
1hFcQFhHmL6c6IjEa/tVaMXLyw9av8FX6Okkrv5YBWQRbNSF/a7HS27OvDXF
gyYtqwFKxTvdKk2hHqaggGFSUVuoZ+APXN2hx6USUhhD0zo1cYnQwR3VctwX
iz8FDf/fr76hE3SStPBvh1iv5lVarfmOivgLnfg1U5nYamVRkd/OokItlbTm
PIpl0z8i1lxq4PTlTvWa//4Xfvu/4NvqCQ==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs41GkUxweTeSKxUrsRuZVbsa1cJ50pamiLsrMSuWRN2wVZmyRaIhsl
VmQlImKRjBCVeCfEkFsiXcYQxn1+r8Ylt7S/fZ79433O8/nnnPd8z/keDa8z
jmxJCoXiQb7/IlIIEHz9SuOWbJrP/ponAnfL1KLfamhc1smrTbwSESz9UvPH
wGUa91oFo+PiMxGYVyhubFhJ486Ui7febxNBsVupR9waae6ysVmVwowIhlS9
iOIvUlyzEX7bg10EGKn9eHi7rCQ34EmEQ2wkAZN1nZQwTQo337H0eX41AaKq
v89Uqi8hpWnT01FzBKgFLCRYWs+hwmx1vUu6GN6vMm/7qDiNHPyEHa9+xtA+
SrtiGz+FPm1g2AtdMLyo797JkZ1C7u87Ans8MBSHBxWFUsUo22U4KeQkhtWj
vipGExiV3zv70DcEg2St/lzhLIGi8gtC3cIwfE4b7tSXIJB34cYtJpEY+g4e
i9u8bgJdL7BQSruKoVNf7fQ99XFkO59FN4jDwKN+YGoajKFmo07trAQMDx+z
JNQYI8g8PXQDMwWD7X7eoNBkGLlW2OQ/vo2ht5fOe2AwhCZv+sTLZWCQo2nF
W307iFR706yP5WC4l5ocsEJuAK2k21E88zDQDWWcWiT7UcD19Kld9zF0FPRb
POX3otmCQXdOMQZFReqHgvEeFCtX561QisExeFPo7YUPyJAWZun8CMNr5onq
0O/eIrAYh7QnGJQ4MR6+Om/Qo0RvdkolBta6+xR3006kJLbbG1JF9jco2g2s
dkQ7Fa47w8WgLPSwI941o4+pAe6XazBcowyucpdtRJWfBfTFWgxLKifaW3a8
QAwOu+rICwx+ZhOJVn7PUfW8oDejHgPK6StygUpktsk1s6UBQxZ/xMQyqxRV
Zmou9fMwyOj0BxvL5CGudPlkbyOGTD2hvDAjAb3a3BpS10Tmj92zUPEmDlit
1K7MlxjsXddG2dPzILfJxcezGUNRfnNUkGcZNC83gFQLhvKc1Y3M7Geg637j
QAzJgoO60qt+rwH29IEkMcn99o06Z5PqoWmcrwitGIb2n7LjP2oC9o0zPD+S
x/bJnrbpboU0t8tll0j2HlTxmXF+BZ3LC+xgkllaJVm2e1/D1kZVmjPJNl62
724bd4F2Jj1FleTtdwXyWL0brHIF65vIetp9Z/fuXv0OxJbNsW4kK22UvXhz
8T1kf6aKu8n/U93vlo6M8CHtft0+C5Kn0szG6G8EYHs4IuUS2a/D9uKYi+f6
wNQn94c7pB7aqTZqPZc+wk7TQO90Uq+Fr29LdlzvB6WGiu/DSD3b2L7MtJQB
4FdHp1qTet97KcFfzB6ENitWzhg5nwvbkv1dOUJw6uxmna0j832pvqVcPwxd
h5JKjJ5jqJKXiktuHoENdHONUwiDkyYzQvH1KNTaHXCKJvcjmtl2SqZvHAaO
mOr6k/uk4bLG48+hCbizvNhmUYHhqc/hnyRFIjgnWMsaLsMwntBLX5jHEKHj
JUNwMFjtjvzoFTQJTfP+o4EPMERVrsvhfZqEYu8nbGEBhrVFVluShj6BOIhi
H0L6wU3nFZ73FIOB41/1d7Mw5GR6l3p8EIP2XMgMh/SPSeI1S4P2KeihfkqI
vIWhkFO7MM6ahs7jLlTJZAyazYtPC99Ng9bLOWnvGxgUVvjQDQdmYNvbhMEO
0s9j5/bv2Db7Gf5RVtZ1u4DhqNTsi/UBc3DRsVtizzkMrfEZDpLEHGzRbvBU
CsBQkif2ei2chyuhem9OkvfkwvuUmMCuRRh92lEz6YSBa7BCwJOiMHITF4Yq
9TA0WaeXy6+RZEyd15+OnyWgRmWxbGZZikEsidL7uAQEho/nMJWkGXXaqmxW
OAF/OC4VVh+SZkioBtsFnycgWluuzCRemnE0fKVHtD8BqTzDGi0ZGoOa8Otx
ticB2anQmMqkMSY5c6HGzgQU+hxs/yaKxuAk2KyecCCgfOex7ugaGsNRY+PW
eCYB/993Bj8oZmIDEPAvOm0uBg==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk31P8ex2djQigyslS2qJSlbBm8Pi0aqSuVKJKEpJSsJTVERGTJehHZ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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FPwaB3CNUCRdS+oVyvpGdzJFMmY8XqlBZW+RjEg3ZRAhhCSUJVpk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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHtYzGkUx6fpMqur7YaiSLRq3UO6OPPkMlEqzIMlTReeLWIYEoWsFeVS
kkgodBGNooYo9Y5JNdkoqkm3mWqa7vN7q6mmq/a3z7N/nOd9Pv+c95zv95yz
wI+98xCVQqGwyPjvRTM54ulpGv+AUvTLlio5eNsnZp0Q0PgrilMt5zbIYdJf
cEF6mcZPpCo0xFI52OXpm5fNoPF3806WWSrl8OpALivaQIN/6wOvsWAuAR3z
/IhXU6r8FTd2+RYFErDczHWPrRaV75GSP2cok4D+TzWUcAsKnyUyq2Z1EiAv
vMcumD+JwlIK50QuwGDGGY+13ziKTPaxfIt3YGjQtqts1R9CC1L/0PYMx1DV
TbvqEqNAU5vZ9MOXMZSU1m3I1lKgKL+bkwFRGF5dDMk6pzaInA3b6wziMOh2
HzVd3odRVGZl3rw0DNRi61HuCIE+brv0Xv85BuXDzhprFQIZhF4Nx1wMLZ6+
0YuN+9CMU19sfXgYaqzNjqTO70W7+AX6Q3kYhGqNDAubHmQr3XObXYDh9Tum
ihm9C/EvHNg9T4DBxU3YLlvTidh2IZy4EgwSiYPwpU0HusOhCPqEGHRoC2Oc
ZrUjz4xBkUslhtTEuxx1HSmKTui65vodg8Myzd1fqG3IxznAY2Uthu8v2tbn
N0mQouavnrQGDPr6ao0vepvRuKjaWLMZw86zi849GG9E1hrPBpgSDNWMgKJz
s3+g3LJZj5KkGAyzo1hHrUTIcYjt/0iGgWmcSfFeW4OYmUXFlzrJ/trlzsCs
QoFlHnSVXgwmMtZWor4CvdNrvXK7D8N1Sru2t1Y52pCUzdQiMEyaBlR9cSxB
oiV70o9gDMfW9cU5HfuIFhVmnsntx4DSWrL2QQGqEbwXtg1geNrUtcb+aS5q
mVkaNzaIQdOq7exqzQxkothep1RgeLxEpidLjkWVtrTY5iEy/43N43miaAjR
VtctGMbgvt8owt0hA6bFOilhIxiynldEhPjwIEts7G6uxPA2TbeckfIB7rzx
10knWez5m4b2SQH437wi0RvF0OZebnXqTikQRj7FXiR3uB3e2vTmM6y9Zv7u
Bsk927SObKr7CqY858Jkkg+2mwYN7/0G0hPv/e+RzFyY89RlSzW81uP+CCZ5
k59L/YPVtcCuD5zrQLLtE7Eenl8H8Rnnl3eS/1u2nNrirFsPitaX+qEkG5pr
nY+faIDXnMlSBVm/mveT3K6uJnCrSN/OJFnxcF2Pg0gMhZJFGQ/Ifj1sX0Wd
P90ConlLjfJIPSwTN5k1/9UKLW7EII/Ua3z6R47jzTaoWLZ2UzypZ+Who4yH
CVJQhC/U3kvqnfqPStNESjtwuxa7T5H+hK68e3x/tgwOyqm6EaR/llNF901K
O2GsqHOWI+l3oZ5q9N2KLhA7DS491Y1htwXjkn51N/A0dWUx5HxEMioPa7b0
AtWU4soh52nBPgPWlY4+iAkXqa1vxZAftGcXVS6HVRuLgqViDL2xEofxMQz7
p3/GS+sxODn/3eoX0g/VGdQVAXUYIgqM04QD/fDpxPCWmhoMRllOv9/pGID6
599U/cl9OGD1DY/5DMII4fU2ogJD2uODuazGQXjy1WQ6phzDmrjr9jZVCphc
1XxsfzEGbnbxeC9zCMpNPjnWIgwWFRP53PohiPeyC171AcNM9SCHZdJh4H7O
336P3Oee026OK0eUIGy/XaKVisFLdaRkDmcUkkL9VxPJGL7GJHtQiVGw85lU
f/cAQ07GoF+1bAyeNaerUMl7EtqQEBVcOwFPq+zPHL+IgW+jLhaqUuiGYT/R
9E4Mnzc+eqtnQKXnrs/UvGWOQWA6wRv+qUpPva58dL+bgOCLvWkMQw362hxm
X14GARd2TnKLdmjQLabSAr8/JiDSUoe3JkaDvmux64QogYBE4TLBQk0a3YAR
m5oUSUBKIpQnMmj0296LW30vEsAN8qz6NYJGV9KUYXpnCHi7wbcuUkCj58zt
v/qMTcD/950+JrGZbf0nAf8CHKk5/g==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk41Hsfh2dhhpEluyOcE4p0Wk1kGt9/spYjQo9DEeWgUFkjkmOpDg06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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FPwaB3CNUCRdS+oVyvpGdzJFMmY8XqlBZW+RjEg3ZRAhhCSUJVpk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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs4lGkYxscwpohq0Ek5t0IpRSqHZxwyBhUl2lpNdNhCB3KIRaVsOqA2
W5qSnNrSRA6rUryTVlEqZXJKDnNA+L43UTSG9tvr2j+e67l+/9zX+9zv/TyG
QQc37qbTaDQeVf91NCO848cPpvBMPX3i2WoCtq/hF4ZVU1yeFRbiQoBiZ3WC
5CRTGJsjYim8CFh1n6X/fCpTWHHNOKmbR8C9gFJeqpaqsCEet1ScJKBnQRB5
b0JZyH4QmL2qgYClep7+1up0oXRCx9BgJgmf/xHRjhrRhAfeMXt5niQQlZcP
PjJQoMiAIX7QSRL0wuUX1riMIf2tl4MLSklom7bqTTdrBEnenTH16SKh4RPz
lHvaMPJ/qcr3kZFQ86zZsUh9GAkmV+jb9pNw71h0YZzKF7Q3t3BJ8TAJmp/2
6y4dxGitjnySx8BAf2o+JvhGoreWukynqRhGr/WKzJVI1B4lXqemgaHLOzD1
p1mDyLxrW8RmbQwic72QPIMBpDTCcmmejaFW5QPHyKIfBQbEWjrpYih+4Kuk
x+5D9EdCu1eGGNy9aqUym16UyWvtsFqIobPTrvauRQ/iXXziFrsIgwbTOM1h
thQpGrhO5ZYY8viXwhkaElQlfV192wqDnaWa3yu6GJV8InqOWWN4VyBeXdHe
ieL6dcZaV2NgsVQ+FAx8RNvKbVjL7TFsjFkYd1X+AXHL8raGOWJo5OytipvT
gpa8MAnMd8agXXSat9+0CXE3m+jwXTH4zrpD275ShCYMvCWRbtR8UsIZfBvQ
Au3Lj8VcDPNkPC7ZWo8c76bMDfXEcJYmnbZdvQ7lJHJjPnphUOjubXhlX4MW
B0e3rFyP4YDt4EWHA0+Qbdj4iiMbMKD8rsKt8Aid6vucnO2NIae9z2ZNTikK
OVggKvHBoGYqjlmhdgsxJou1BRsx3DCTTZdlXUCVZK1byiZK/9xa+f2mVDAy
fbh7jy+G9dt0ktbb3YKSouuWxpsxFN6uT4reUQaVU2OynlJcnq9Zx8l9DD45
6eUcPwwd3otUpx2uhqbWM+FFFIvX15lGpD+DMDXnd3KKe7yCue1/v4DJc4TI
zB9Dv4d6iGvza7j9WCPWnuJdUt3Qr1veQvEfBR7WFPsal+S4uzVCXyfeq0Wx
a5B769UV7+Erz+J9K6Vnnd0xHRs0Q9BSWdopik26ItycNVshpa7zynyKtfXV
4/8cb4NMxpyRDOq9KtuzS/v62iGPVZOloOYbvmbbb9fUAaLwLdc5FG+wvnc6
PqoLDA2Wp/xK+WHCd9X7eLwbtO4qjgdTfsl/tJTYp4gh6mHUUW/Kzze793Ou
ZUigzKkoeS7ld95LpfbxXCnkn2dk11D/E2t16dC2IhkoLzOr911H6U1UXZn3
rBd2/GwaMt8DQ+V05dRL9X0wePNqQoA7Bj8jTiKr8RPs6fWvTqTykcx5E6zW
NQD7rJ6TMVSeDLdq8X7vGYQIkbPYk42hItR/E50gYPf+y7p0Kn8DFzrt5N8x
nLA6fUSXyquD84nuoOjPEOCiuCJYiSHp0az82qHPIDk4r2whlW+dQofF6T1D
wAhm9r+h9iHA9C3+vuMLxHNXsZQWY8i/sauU9+ELhNq2eM4zw2Bz8ewai4Zh
OOSXrMkwxiAoeiof8B2BmMzcm+f1MRjVj1cIWkdAqnVpNW0+hhmMUDtLyVew
qV0UfZba5/4oL3urb6Mwmp5xeJMKhl+Uv9XMDR+DwDtVf3nQMLxOy9pAJ8dA
c1T82ExBQsmtL0GNsu+wbM9vxVnUPYltyzgd+X4cskYTJCHdJAgtGB21yjT2
zCHrc11lJLxwySyfrkVnP2jxjotIJKFad7zs66QyOzwxMzJ1HQmRxwbyOdqq
bDMNJ/cRDRISNioEVT6q7IUZ8uyVqiQkm2iU2aSpsqfYFyXsnCSAX2tZbazG
ZN86fmVKPElALh/q+BwmO/rhlLZ9PQQIQr0bZiYx2a8FsiinDgLKHQObk6uZ
bKGgcki5iYD/7ztbkuoRUPyKgH8BhXcLlw==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk4lAsbgGcxM6GTk2whSaojp4XMIdLzWkcjeyFCyJKSk2MpZSnJdLI0
NaVQtiNliewzE+/blDVlzfZJU5ZkX7Kb8Z3vur4f93X/u3/fOzwCbL0IOByO
+S//M/prYP/6OgU7La9kYCC6BVx1k19e4lEwk1x6m2m2NKx58iIGblKwcfn9
ooUP5CA5ftTyJI2CdX12mtk6qAA6FZLb60QpWIFmToFiynbo5OtO6TSRMV+p
+rS9AzsgSMwTzU0gY4Vum/PhsCpIat1JVLQhY9zBy7I1nbuhyKXELWELGWt4
H5rv8FYNKqi3X7W1kDCr+S61Hpt9UP2LG1E2gYRNK08oWbw4CO+GtE46m5Ow
KUaTq8oPTXhfJZaTtoGEafHcWQ4BVGh7wF8aqBHBfOI1Ii8b6UC3fzn9t2gR
jP49H+P668EXk7jUC4gItqog9P5l8SgMb/OYLBIQsQg9u7q4IAOY0o90dkeJ
mPPigq8w0giWXFLrN18nYgkdMheO8EwAH8Gm8gyJWKEkh6OBmIHY087MQBEi
Rir4wNqxToct1XMSO2sJGBVlkfNELEGx/9fw9lgC5jsVu9U7zxp2C/eNRh8j
YI0W90pmw23hgJK5g5Y4AUt/xfvpEn4CNthdy9/2EY+dc/riWJNhD/zYAjyF
icfURfmOtkuOUPm6337aDo+lta2qNdx0hrszEvk9MngsZspBRdncFXx3G+Df
9uAwonchGcs5A4hzoH1+Kg4b6UWUVMw9YPpdBy5SBYc124c1Fwm9wMPapzAY
W0c7TNEPrYa+MCCzy2VCbx31zLaVzWX7wdnP38S8KoQoErDzU5q3PwxnpVf2
aQpRb3GdjJTdf4Kvn6v3iZcCtC0ryZFReQlGDypKNakJ0M00Jek5v79goiop
gKu8hlYJdHwmdUIhSGrQTjx7FRV2UjpGNa/Ait9BHWe1VRTZ9mVxxOoqRL25
pphXsIK2lBorxTHDgSzXgFvVWEEdhZWvLy9HQtxF6SF6+TK6f/a90Qvj6yBZ
496QrLuMRh6ZOeCScQOUAleYukZLqPLy4c2WqTEQsivzyoGqRdSCeHazwC0W
PnQfc1fVXkQbzWxuN8FtuAaPD25SX0CZfqSHbg7x0DGLyBGz51H6wQxi491E
UH82sr6oNI+2neKQmn/ehd6NOs1fJX+irXP0P4kR96HlByXWLHEO7bzCrGvq
YEFNbdfRQvE59BM/k1ym9xCKokJfXhOZRe/FHXI6rvsYnrnQvAeiZtBd24Oj
xNqSIVVXVokumEYZy2+eEsNSYdMPf4UD41Po8pm8LspKGhDe7l3KX5hEZ7IN
s0q602Ex9XvHXvwkeu6mXj2ZmwF8a/eE3TLjaE/r9vjue1nwqvIEXgkZQUUr
5X1VGDnQlvvtMKfvC3qd+TjI6GoRdAxOGMKJFnTx8Hlj3nApyA+5HZvsaUIr
McPJEt8yuIMb3Ogq3oCavBkPY3wvg4va4/f1L75BQwuT5s73lgOazX/pBFyU
MTtyo9aiAjL7Rqi6mSVoUFyRXOrrCkhXG5IYSmOiNMFHda87lbAWZ7JS0ZkA
81fICvGzlWDpLB1jqfccGhbaBZ9t2fDyRVNM6JlSUOlpk1/LY0N59qYGWtZr
uGE5UcEUsKHf+jfyxr944A6pWVY0DnyzbNgTxKqFdK+B0gkGB4aP+x3rK2sE
T5MRRJ3HgVG6+Hnjro/gLpCNaZ7lwNlBhQvzjq0g6v/Y21SOCyd2FmeambaD
8eTJ9/NULhh7mPWkHPoEGzoPVb8154JWRr/ElHIXbNiyTeXJKS6o8oNMDTf1
gJHajw/BblyQ2i4e/mC1F2bD9zw1c+GCiGtGychIH6TEZl+TtePCXKr2qF5n
P5iGZriMIVyw0iq6HR7CB5mowBaa6r+9ZGOlz9e/QmZ7wNYgIQdW1ruLj8R/
gzGWLi6pmQPNXv601EcDsJEY7sJP4sA/7/F9q1mDYGbzdwPDgQNhGg//dC4c
gqyh5COtmzhglbSXxOUMw0FObAahmg2qgurH8rXf4ZmAdNrfiw1VEsSEh00j
ULH7Zp0uhQ32KrQbku0/QOLtpZA/MiuBQWv2E+OPwWCYNJNaUwE7nLa43Roe
B77VjmmCZQVwLjjYESYmQGdbsymztRzGmF/0VpanwJXC2pfbWAb6htFfPUKn
oaqjPf4KvQxiuDLZ9TPT0NsrKaNbVwrSL/V/Zw3PQGCtoi+JXQLU+3d01Vvm
oA9nbTMR+wpGQ44f0VhYhGPPZ0+mxLyA08SFmq2BS6Cff0NeO/g5fExMsyJM
LsHf0+FOcC4Hip/PerQPLYPZHx/ktc9kgyo1dZzrvgI5FkZeXz3/gYdvTEL+
+bwCM/XNRf7+WRDW++h28KdVIPomxCL3M0BB7LsE23kNnvMYdPMn6fD6MPXh
2tc1yJvS5Oe4poHgUWtm9KQAeJoRF7d2p8DT+u1qdUFC0G7UEszsS4ajS/6F
YqtCaGderapkPQJMndRfT8Qh/Xg+Y++DB/Bmvxz7lQkOGWMLw2WpLOBpqLOS
Y3HIbZJjgtLQPajRtqFfEMcjZ6O0Ap4F3YVa3bO7TlrgkXK2zxnISYB6/VDc
0UQ8glvj2xyPjoNGoyflElsIyAtVWlrNPQY0CH1D4qwJCLOLr1P97RbUs7X+
EE0gICyNSd7v9BioC8ItxLwnICWahuon6qOh9kBTGUGUiHzS/hl16fQNqBlN
Co40JSKnOcWHq0jX4V22J3Utmojk2hY3dd+KBJ7Caum8kIiEtGtYRMyEgeNv
W+fSDEQQlkG5nkPxZZjS0tag3xRBlHlv7b1SQuCWwcmAn7UiiI7/jrvpuUGg
aPlXwVNREvIu0T6L0h8IxU7MMbPjJEQarVXOPHQJzHwK1eYSSIgUzTpMxC4A
gqPGsmlSZKQlsp1G/XwOImzX8qttyMh/9si4l2f6AEP1l1JqIhmxkBL6SN/3
AubCNm5+ExmR2dirz83zhOT6/bydYhSEfarASm3UHbKSoSGZRkEqV0U1V8zP
QP4F65bNMRSkj2wm9+6JC5Qfde9i8CjI1fI7eS5fneD//4PofMjouuvqCP8F
n51uEw==
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ7UHa+W5WzvZPhw5ApD
vRLDgb9aRY7/T3wQe7t3ev5uhT/7i6zy1b8oWyjLFf2aaOX8Y/9CNftpSZ6B
Grd4LM4/FPqynzXYqklSMVmL72WutP6b9/sdXKfeXLT5o9bGHSGMcg4v9q+o
239UV4FT+9KqR5a77tzfH3LD/Cq3ILf2lSdvnexDLuxXPubZVMfBqr1A8yn/
0/kT9+/8GdR97eQnrVde3Nku18/ZX3SZ0FFXf1Hr8xzzV9bX7tm/eP3BxGTm
Ni2Vv/tmSh17bl/6berU8mf7tF5PvG/96+d7+5c1XaosWh+1TCd3W2lf+GzP
xuPw748mp/arMh8bw2/f7cvPK4QX65poVd2a0Vl69bd93TWtA3N3P1M7oM16
7wQzg8NWnhcfJom7yp5ynruNX5jJ4fm1db/V9npwHJL+veXrP2YHWPiVNrxe
6i7CBufXBf1Zsy8Qwe9Q4d1i2o/gzzqhd0iZix3OXzzL/uQsdwR/TU7ABcFW
BH+bXeL1jkMIPjQ9wPkAqUPO1g==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs01GkYx8e4zOa+SFuOKZfNvZJsraFn1m1Qxy2bQpRytiMUKVsikmQr
EiLlkEtJE4pulHeSaogo90vuxjC/12VcMq7723P2j/e85/PPc57n+/0+j4bv
SVc/KoVC8SHffz9SDOlZXaVxqgviX96fFIC3WUZRcBWNs9l2NLlDJIClo1WR
g5dpnEpNvQsrVAJ2vVTa+GkNjdO8YERXWEtAyaFSnwRlKY6t7Wyw/S4CeOq+
4yXL4pztdbdoZ6II2Erf475DhsoxPmp6M7qSgMnqZspFTQonxIPrajxHAH6b
drJi0xLS0jOfe2qIgR6ykGRmNY+2d7k7DB/E0Cm7q6FfaQalRa3RTb2MoXGU
FmeXOI2+/d1jcygew4ePbbuLZaaRfPiDfJkEDCVRYUUXJIRIkukn2pCGQX40
UG0rMYFo6tV51AIM1Pf68+y5cWTnYbj88jGGH/dGmvXFxtEtveqs/cUY+pyP
JGxWJRDFWTLH6QWGZn36ibxNAqTSFjL16DUGrkQXS9NgDKkkpvvjNxievnIT
ozP5yHK5tWLrewx2e7lDw6YjSINnoBv0EUNvL4P7xICH2v0t05JqMMjRtBIt
1g0hYUGiZ1wDhryM2yGScoNoRTEg++A3DIwt0vvrqQNo8s2fnxRbMHwrHPi9
vLsXNY9wM406MSgpSXQVCr6jh6mnXE50Y3A99+uFuwtdyHxF4JDUg6GJdbzy
wi/tiOFOXUwdwKBSHO8TqNOKnm5cfhg6hMFN9THF+7dmFHzuWhyDR843hC3B
rREFXEqujx7FsGHYx368ow4ZV/zVLRrDcI0yJOstU4NOTRkueRAYltSON9ab
f0DUwOd6+RhD0E4i2SLoHfKDn3zbxzGg/L4iD6hA65yO5MxMYMjp5pua5ZQi
G19jvmgSg7TOwDkT6QJ0R5duzJ/CkK03rDCclYRY1tRwJCTrX7dZeNmaAA77
SmQTpzE4eq6NdWQUAEs/NM5qBkPRo7rYsMNl4N96dLSb5Bf58jWs3Dewe7xn
m+cshh5nXSnZ01WgeCfBq5LkAccandCUjyCe6ndCag4Db6+/fffzWqhmZHuZ
kDzmIHPCuu0LKF6p3mpD8rEhtYDZA19BSLvpZUGym9azHDvbJogO18HqJFv7
2nXcNWmBuW0t/Tyy/o77PQoTm9pgiqXGSCdZuy/U1lK+A2KflIqMSVbZKBOR
utgJ9utv0svIfiW875fy+d1QvqazkE7y9L2dY4zWHriOhFnB5LxOO0riI872
wXVde/+7pB7aGdb079H9sFONH/WI1Gthtf2Z+Y0B+MPxJO8uqWeDXyDrXvog
EHs+Z4aQeud9FutezB2CmGOmhUakH+eNb5/yLB6GwCwThXrSP+3lyjsbPo6A
SW2M8BXp91sF8YTbdXyQl3MpluNj2K/JuqTUNAoRs5ktLDIfV1kN/tJ9AoiS
nQ4OIPOk4aHsc4VHgL6vg3B/H4byAPd9VDIHDyLQ5GYyf4KkXsaCaALclQsv
hnVgsLCM6fcNmwQd/RWadhuG2ArVfO7UJPgMZKS9bsawtsjCMIU3BbU1roNZ
5D4c0vk6IToshIEU68eTdRjys4+V+nQJwVvG8JZ+LQbT5GtmBo3TwA6pbz1Y
jYFd/H5B4DYD42wrd9l3GDTrFsvZHTOA8jTl895iUJQMYGwZnIUo2j/WMeQ+
j53da2489wOOetaMij3E4CU+92F9yDyYe0fe2JyL4UtilhN1fB5UOR0aO7Iw
PCsQ+jYNi8C2V91Smrwn5zvT48+0LIKYNvd0biwGjoFkD1ecwix/sv2TnCeG
WqvMFwrKVGa4f3hKhz6GKrXFstkVceZgZI0ja56AM1GCfJaKFNPaPTHoXAUB
ka5L7EoXKWZmtMScUhkBV7XlykwTpZjZB84K09gEZHC3VGlJ05glDa8TjmUS
kJsBNRksGrNJ1siFnUoAO8C58edYGvPAk9763hsEvNh9pO1qFY2ZrJSguhpL
wP/3nSky3GghHUnAvwK1J8Y=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk/1IkfgGcMM0W5zyW5hdaxjpzz/tAyUllX2V0ht1AbOZIhJVdEs6to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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ4U2Oo4rpP35vxw5ApD
vRLDgaT4xmMbr26Uf7t3ev5uhT/7Q+WaFVKX/dSWK/o10cr5x/4SWYZImTgh
w1s8FucfCn3Zb5CpVh8UrGLM9zJXWv/N+/23VaOqGc9vMt64I4RRzuHF/uv8
ygkpm04ZX1r1yHLXnfv7WXae8g85dMb4ypO3TvYhF/ZvnPFml2HkMeMFmk/5
n86fuD9QQXbprG+bjV95cWe7XD9nv1r5SeWs6ZOMP88xf2V97Z690KQPjN+Y
KoxV/u6bKXXsuf1Zh4UR/VkNxq8n3rf+9fO9/fojyw4ct9lkbDq520r7wmf7
I5LxCy7sOWX8qszHxvDbd3uhqN+SJQVfjapuzegsvfrb/vv73Tlt6iv0D2iz
3jvBzOBwdVNTv3kmm9op57nb+IWZHOpbmmN1PLkED0n/3vL1H7MDLPxKG14v
dRdhg/Prgv6s2ReI4Heo8G4x7UfwZ53QO6TMxQ7nL55lf3KWO4K/JifggmAr
gr/NLvF6xyEEH5oe4HwAgkjNyg==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs01GkYx8eMTIwoZEO5JkVHW1Fu45mDmtrakmzp4trNilySku6lslpU
IhPHrdmV3GpcKvFOpEakccllSJMMMvN7XYZyW/a35+wfz3nP57znPOd5vs/3
eYz8gt2OUCkUijcZ/71oYVj33BydX80sOdP9RgZedpyC0Co6P2rTOM1TKIOZ
Q1UXvl6j8z0T+MqCDhnYlGkYvFWm853Lj/18SCaDIk+ed5ymEj9qPDfr8UIC
+pb54aJ/aHwe+sShHCBgjf62vVYMKn+l5sXBAQ4Bw69bKBeNKfx7NXO5zi0E
EBXJweWGM2hQvNTmqCoG/bCp23bOE8h1JMZ4zA6DSNXmwxeNMVTimOEqPYpB
+I1+Y0u8HNFuFS9pP46h5k2bYyFDjpLFHp65IRiKLp0uOKc4ipYHm6+ai8Sg
9i1Ib41sCEXbGYT7x2KgVptP5H3H6GBFr71dPIYfqf0t5goYlQlL08fuYBC7
+sat0Jahk0+oOiYcDC3m+scfGkrRmNXrZclpGASKnWxji0Gk/d0oTZ6B4ckz
dwV91gDaNJkoO/I3hi3bBb0S63402+dvU5GL4fNne0G+RR+qIxjPJvIxLKCb
xDN/6kXlosQ1S4sxPOQkhc1b8BXVMLK1Fcsw2Fuq7HlP7UEvbRrVhc8xNOX2
2L7o+owSl5noaiEMGhqKnbnST8g9pWHG7xUGt0jTcw+mOpFpsFdwSjWGZrZ/
5bkl7ejJ0fVDL99i0CqM8Q4ya0Xi23Gjj2oxuGs/pnhtaEFpu6ZCL9SR/fUS
TuAuREbbeM2fGjDoSry34o56NLtfbYWvEEMspVfVi1GL6iMuddQ3YpjR8xe+
d6hB1BvVg4bNGE5slN1lnniFApve7vFswYC44oL9UI6oKsW6Vz5iyOoasLbL
4qHG3ZL18a0YVMx6Iter5CD934bSr7VhyFglUZek30YF9qkH/drJ/Lc2TZW1
xsHm0S+mNh0YdhxYHL3DPgeatK/PHyW54FF99GmfYvhLOYGaIMJQylWrZWe/
BO8BNw2NTgzdriuVVE9WQdC9oA1nSO7ZUWsWnvgGdlW+C6oiuW97wNaukncQ
J84oGyZ58BfGcZe2Blj9a5gmrQvD4V69wHGPRmAUMRWnyX93k6dZWzY3Q2FI
XbaIZBe/LR0P1n8EIx3/0UySrTK71YcM20BQkDLsSvJycfhmJ7UO2F1kkN5P
1qdlwDh/b1oEjRry2SMkK3pl8gYGuqCZuXlRPdmPPHXjoH1rN5QrRbfpkLzT
qijmfIQYeDyPjUxSj+UcF/1Pl7/AAUeGugup19Rc+1OHP3tgIsrV15LU88OR
IHbq/a9wws9i7Qyp/8M6ha7p7F7YN0Vczifnc3ZtUsiBQgk83mm716mJzPdP
ZYrum36Qqkama3/AUKFOi0uqHwBOpEGC13sMe4zZVzSav4FF21H9WNIfN9kf
AlTEUlCwzTG7Q/rJaL+m9/U+GdSEsPIDazC8CNy7m0oQYNhYIrEg/Se9/dl+
anIIMk4l3vCoxMB0uvrF7/QwpNbO2crLMUSXa3MFI8MwjeKdI0h/Ly5grk7s
G4GImuCT1uQ+eJo1Dk36jELUhhFu6BMM3IzDPO/OUYjtnmQnFWCwvhtrZyGU
A9N23/j9HAx5hdVTUvcxkH17ZryOi8G4fvpFXscYeEt0nxdmYlg4L9De8us4
qCqEsz3IfR6M2O6w9vsPsEtJnu/zB4aDtO81OmEToHwyVOfYdQwN8ek7qXgC
BAaGAXuuYHiaM+rXLJmE/ddKRwjynpwV3Y859XEaigyHixX8MfAt5nULaBTW
/E11l0wdMLxzTitV16SydF0ciy6qYKjSmy4en6WxAqIiub+3EnDqkpTL1lJi
Gci5MbXJBFxwm8mr3KXE0hGVu5knEHBz+YJi63gllu7VrfJTNwngCCyrTFTo
rNpQJ4WGMwRkc6CWw6azVMUed0QhBOQFugoXRdNZK0QOTk3+BJQ6+rbdrKKz
KPx1JiU+BPx/31m0t7nsqx4E/AtsFiVo
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vk/1PsewPExY0yRRkQpVPboUI6lyLy/p42cTiUpp85kO0UiyVKKKEU4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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FPwaB3CNUCRdS+oVyvpGdzJFMmY8XqlBZW+RjEg3ZRAhhCSUJVpk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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs41GkUxweTeSKxUrsRuZVbsa1cJ50pamiLsrMSuWRN2wVZmyRaIhsl
VmQlImKRjBCVeCfEkFsiXcYQxn1+r8Ylt7S/fZ79433O8/nnnPd8z/keDa8z
jmxJCoXiQb7/IlIIEHz9SuOWbJrP/ponAnfL1KLfamhc1smrTbwSESz9UvPH
wGUa91oFo+PiMxGYVyhubFhJ486Ui7febxNBsVupR9waae6ysVmVwowIhlS9
iOIvUlyzEX7bg10EGKn9eHi7rCQ34EmEQ2wkAZN1nZQwTQo337H0eX41AaKq
v89Uqi8hpWnT01FzBKgFLCRYWs+hwmx1vUu6GN6vMm/7qDiNHPyEHa9+xtA+
SrtiGz+FPm1g2AtdMLyo797JkZ1C7u87Ans8MBSHBxWFUsUo22U4KeQkhtWj
vipGExiV3zv70DcEg2St/lzhLIGi8gtC3cIwfE4b7tSXIJB34cYtJpEY+g4e
i9u8bgJdL7BQSruKoVNf7fQ99XFkO59FN4jDwKN+YGoajKFmo07trAQMDx+z
JNQYI8g8PXQDMwWD7X7eoNBkGLlW2OQ/vo2ht5fOe2AwhCZv+sTLZWCQo2nF
W307iFR706yP5WC4l5ocsEJuAK2k21E88zDQDWWcWiT7UcD19Kld9zF0FPRb
POX3otmCQXdOMQZFReqHgvEeFCtX561QisExeFPo7YUPyJAWZun8CMNr5onq
0O/eIrAYh7QnGJQ4MR6+Om/Qo0RvdkolBta6+xR3006kJLbbG1JF9jco2g2s
dkQ7Fa47w8WgLPSwI941o4+pAe6XazBcowyucpdtRJWfBfTFWgxLKifaW3a8
QAwOu+rICwx+ZhOJVn7PUfW8oDejHgPK6StygUpktsk1s6UBQxZ/xMQyqxRV
Zmou9fMwyOj0BxvL5CGudPlkbyOGTD2hvDAjAb3a3BpS10Tmj92zUPEmDlit
1K7MlxjsXddG2dPzILfJxcezGUNRfnNUkGcZNC83gFQLhvKc1Y3M7Geg637j
QAzJgoO60qt+rwH29IEkMcn99o06Z5PqoWmcrwitGIb2n7LjP2oC9o0zPD+S
x/bJnrbpboU0t8tll0j2HlTxmXF+BZ3LC+xgkllaJVm2e1/D1kZVmjPJNl62
724bd4F2Jj1FleTtdwXyWL0brHIF65vIetp9Z/fuXv0OxJbNsW4kK22UvXhz
8T1kf6aKu8n/U93vlo6M8CHtft0+C5Kn0szG6G8EYHs4IuUS2a/D9uKYi+f6
wNQn94c7pB7aqTZqPZc+wk7TQO90Uq+Fr29LdlzvB6WGiu/DSD3b2L7MtJQB
4FdHp1qTet97KcFfzB6ENitWzhg5nwvbkv1dOUJw6uxmna0j832pvqVcPwxd
h5JKjJ5jqJKXiktuHoENdHONUwiDkyYzQvH1KNTaHXCKJvcjmtl2SqZvHAaO
mOr6k/uk4bLG48+hCbizvNhmUYHhqc/hnyRFIjgnWMsaLsMwntBLX5jHEKHj
JUNwMFjtjvzoFTQJTfP+o4EPMERVrsvhfZqEYu8nbGEBhrVFVluShj6BOIhi
H0L6wU3nFZ73FIOB41/1d7Mw5GR6l3p8EIP2XMgMh/SPSeI1S4P2KeihfkqI
vIWhkFO7MM6ahs7jLlTJZAyazYtPC99Ng9bLOWnvGxgUVvjQDQdmYNvbhMEO
0s9j5/bv2Db7Gf5RVtZ1u4DhqNTsi/UBc3DRsVtizzkMrfEZDpLEHGzRbvBU
CsBQkif2ei2chyuhem9OkvfkwvuUmMCuRRh92lEz6YSBa7BCwJOiMHITF4Yq
9TA0WaeXy6+RZEyd15+OnyWgRmWxbGZZikEsidL7uAQEho/nMJWkGXXaqmxW
OAF/OC4VVh+SZkioBtsFnycgWluuzCRemnE0fKVHtD8BqTzDGi0ZGoOa8Otx
ticB2anQmMqkMSY5c6HGzgQU+hxs/yaKxuAk2KyecCCgfOex7ugaGsNRY+PW
eCYB/993Bj8oZmIDEPAvOm0uBg==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk31P8ex2djQigyslS2qJSlbBm8Pi0aqSuVKJKEpJSsJTVERGTJehHZ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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FPwaB3CNUCRdS+oVyvpGdzJFMmY8XqlBZW+RjEg3ZRAhhCSUJVpk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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHtYzGkUx6fpMqur7YaiSLRq3UO6OPPkMlEqzIMlTReeLWIYEoWsFeVS
kkgodBGNooYo9Y5JNdkoqkm3mWqa7vN7q6mmq/a3z7N/nOd9Pv+c95zv95yz
wI+98xCVQqGwyPjvRTM54ulpGv+AUvTLlio5eNsnZp0Q0PgrilMt5zbIYdJf
cEF6mcZPpCo0xFI52OXpm5fNoPF3806WWSrl8OpALivaQIN/6wOvsWAuAR3z
/IhXU6r8FTd2+RYFErDczHWPrRaV75GSP2cok4D+TzWUcAsKnyUyq2Z1EiAv
vMcumD+JwlIK50QuwGDGGY+13ziKTPaxfIt3YGjQtqts1R9CC1L/0PYMx1DV
TbvqEqNAU5vZ9MOXMZSU1m3I1lKgKL+bkwFRGF5dDMk6pzaInA3b6wziMOh2
HzVd3odRVGZl3rw0DNRi61HuCIE+brv0Xv85BuXDzhprFQIZhF4Nx1wMLZ6+
0YuN+9CMU19sfXgYaqzNjqTO70W7+AX6Q3kYhGqNDAubHmQr3XObXYDh9Tum
ihm9C/EvHNg9T4DBxU3YLlvTidh2IZy4EgwSiYPwpU0HusOhCPqEGHRoC2Oc
ZrUjz4xBkUslhtTEuxx1HSmKTui65vodg8Myzd1fqG3IxznAY2Uthu8v2tbn
N0mQouavnrQGDPr6ao0vepvRuKjaWLMZw86zi849GG9E1hrPBpgSDNWMgKJz
s3+g3LJZj5KkGAyzo1hHrUTIcYjt/0iGgWmcSfFeW4OYmUXFlzrJ/trlzsCs
QoFlHnSVXgwmMtZWor4CvdNrvXK7D8N1Sru2t1Y52pCUzdQiMEyaBlR9cSxB
oiV70o9gDMfW9cU5HfuIFhVmnsntx4DSWrL2QQGqEbwXtg1geNrUtcb+aS5q
mVkaNzaIQdOq7exqzQxkothep1RgeLxEpidLjkWVtrTY5iEy/43N43miaAjR
VtctGMbgvt8owt0hA6bFOilhIxiynldEhPjwIEts7G6uxPA2TbeckfIB7rzx
10knWez5m4b2SQH437wi0RvF0OZebnXqTikQRj7FXiR3uB3e2vTmM6y9Zv7u
Bsk927SObKr7CqY858Jkkg+2mwYN7/0G0hPv/e+RzFyY89RlSzW81uP+CCZ5
k59L/YPVtcCuD5zrQLLtE7Eenl8H8Rnnl3eS/1u2nNrirFsPitaX+qEkG5pr
nY+faIDXnMlSBVm/mveT3K6uJnCrSN/OJFnxcF2Pg0gMhZJFGQ/Ifj1sX0Wd
P90ConlLjfJIPSwTN5k1/9UKLW7EII/Ua3z6R47jzTaoWLZ2UzypZ+Who4yH
CVJQhC/U3kvqnfqPStNESjtwuxa7T5H+hK68e3x/tgwOyqm6EaR/llNF901K
O2GsqHOWI+l3oZ5q9N2KLhA7DS491Y1htwXjkn51N/A0dWUx5HxEMioPa7b0
AtWU4soh52nBPgPWlY4+iAkXqa1vxZAftGcXVS6HVRuLgqViDL2xEofxMQz7
p3/GS+sxODn/3eoX0g/VGdQVAXUYIgqM04QD/fDpxPCWmhoMRllOv9/pGID6
599U/cl9OGD1DY/5DMII4fU2ogJD2uODuazGQXjy1WQ6phzDmrjr9jZVCphc
1XxsfzEGbnbxeC9zCMpNPjnWIgwWFRP53PohiPeyC171AcNM9SCHZdJh4H7O
336P3Oee026OK0eUIGy/XaKVisFLdaRkDmcUkkL9VxPJGL7GJHtQiVGw85lU
f/cAQ07GoF+1bAyeNaerUMl7EtqQEBVcOwFPq+zPHL+IgW+jLhaqUuiGYT/R
9E4Mnzc+eqtnQKXnrs/UvGWOQWA6wRv+qUpPva58dL+bgOCLvWkMQw362hxm
X14GARd2TnKLdmjQLabSAr8/JiDSUoe3JkaDvmux64QogYBE4TLBQk0a3YAR
m5oUSUBKIpQnMmj0296LW30vEsAN8qz6NYJGV9KUYXpnCHi7wbcuUkCj58zt
v/qMTcD/950+JrGZbf0nAf8CHKk5/g==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk41Hsfh2dhhpEluyOcE4p0Wk1kGt9/spYjQo9DEeWgUFkjkmOpDg06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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FPwaB3CNUCRdS+oVyvpGdzJFMmY8XqlBZW+RjEg3ZRAhhCSUJVpk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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs4lGkYxscwpohq0Ek5t0IpRSqHZxwyBhUl2lpNdNhCB3KIRaVsOqA2
W5qSnNrSRA6rUryTVlEqZXJKDnNA+L43UTSG9tvr2j+e67l+/9zX+9zv/TyG
QQc37qbTaDQeVf91NCO848cPpvBMPX3i2WoCtq/hF4ZVU1yeFRbiQoBiZ3WC
5CRTGJsjYim8CFh1n6X/fCpTWHHNOKmbR8C9gFJeqpaqsCEet1ScJKBnQRB5
b0JZyH4QmL2qgYClep7+1up0oXRCx9BgJgmf/xHRjhrRhAfeMXt5niQQlZcP
PjJQoMiAIX7QSRL0wuUX1riMIf2tl4MLSklom7bqTTdrBEnenTH16SKh4RPz
lHvaMPJ/qcr3kZFQ86zZsUh9GAkmV+jb9pNw71h0YZzKF7Q3t3BJ8TAJmp/2
6y4dxGitjnySx8BAf2o+JvhGoreWukynqRhGr/WKzJVI1B4lXqemgaHLOzD1
p1mDyLxrW8RmbQwic72QPIMBpDTCcmmejaFW5QPHyKIfBQbEWjrpYih+4Kuk
x+5D9EdCu1eGGNy9aqUym16UyWvtsFqIobPTrvauRQ/iXXziFrsIgwbTOM1h
thQpGrhO5ZYY8viXwhkaElQlfV192wqDnaWa3yu6GJV8InqOWWN4VyBeXdHe
ieL6dcZaV2NgsVQ+FAx8RNvKbVjL7TFsjFkYd1X+AXHL8raGOWJo5OytipvT
gpa8MAnMd8agXXSat9+0CXE3m+jwXTH4zrpD275ShCYMvCWRbtR8UsIZfBvQ
Au3Lj8VcDPNkPC7ZWo8c76bMDfXEcJYmnbZdvQ7lJHJjPnphUOjubXhlX4MW
B0e3rFyP4YDt4EWHA0+Qbdj4iiMbMKD8rsKt8Aid6vucnO2NIae9z2ZNTikK
OVggKvHBoGYqjlmhdgsxJou1BRsx3DCTTZdlXUCVZK1byiZK/9xa+f2mVDAy
fbh7jy+G9dt0ktbb3YKSouuWxpsxFN6uT4reUQaVU2OynlJcnq9Zx8l9DD45
6eUcPwwd3otUpx2uhqbWM+FFFIvX15lGpD+DMDXnd3KKe7yCue1/v4DJc4TI
zB9Dv4d6iGvza7j9WCPWnuJdUt3Qr1veQvEfBR7WFPsal+S4uzVCXyfeq0Wx
a5B769UV7+Erz+J9K6Vnnd0xHRs0Q9BSWdopik26ItycNVshpa7zynyKtfXV
4/8cb4NMxpyRDOq9KtuzS/v62iGPVZOloOYbvmbbb9fUAaLwLdc5FG+wvnc6
PqoLDA2Wp/xK+WHCd9X7eLwbtO4qjgdTfsl/tJTYp4gh6mHUUW/Kzze793Ou
ZUigzKkoeS7ld95LpfbxXCnkn2dk11D/E2t16dC2IhkoLzOr911H6U1UXZn3
rBd2/GwaMt8DQ+V05dRL9X0wePNqQoA7Bj8jTiKr8RPs6fWvTqTykcx5E6zW
NQD7rJ6TMVSeDLdq8X7vGYQIkbPYk42hItR/E50gYPf+y7p0Kn8DFzrt5N8x
nLA6fUSXyquD84nuoOjPEOCiuCJYiSHp0az82qHPIDk4r2whlW+dQofF6T1D
wAhm9r+h9iHA9C3+vuMLxHNXsZQWY8i/sauU9+ELhNq2eM4zw2Bz8ewai4Zh
OOSXrMkwxiAoeiof8B2BmMzcm+f1MRjVj1cIWkdAqnVpNW0+hhmMUDtLyVew
qV0UfZba5/4oL3urb6Mwmp5xeJMKhl+Uv9XMDR+DwDtVf3nQMLxOy9pAJ8dA
c1T82ExBQsmtL0GNsu+wbM9vxVnUPYltyzgd+X4cskYTJCHdJAgtGB21yjT2
zCHrc11lJLxwySyfrkVnP2jxjotIJKFad7zs66QyOzwxMzJ1HQmRxwbyOdqq
bDMNJ/cRDRISNioEVT6q7IUZ8uyVqiQkm2iU2aSpsqfYFyXsnCSAX2tZbazG
ZN86fmVKPElALh/q+BwmO/rhlLZ9PQQIQr0bZiYx2a8FsiinDgLKHQObk6uZ
bKGgcki5iYD/7ztbkuoRUPyKgH8BhXcLlw==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk4lAsbgGcxM6GTk2whSaojp4XMIdLzWkcjeyFCyJKSk2MpZSnJdLI0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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ7UHa+W5WzvZPhw5ApD
vRLDgb9aRY7/T3wQe7t3ev5uhT/7i6zy1b8oWyjLFf2aaOX8Y/9CNftpSZ6B
Grd4LM4/FPqynzXYqklSMVmL72WutP6b9/sdXKfeXLT5o9bGHSGMcg4v9q+o
239UV4FT+9KqR5a77tzfH3LD/Cq3ILf2lSdvnexDLuxXPubZVMfBqr1A8yn/
0/kT9+/8GdR97eQnrVde3Nku18/ZX3SZ0FFXf1Hr8xzzV9bX7tm/eP3BxGTm
Ni2Vv/tmSh17bl/6berU8mf7tF5PvG/96+d7+5c1XaosWh+1TCd3W2lf+GzP
xuPw748mp/arMh8bw2/f7cvPK4QX65poVd2a0Vl69bd93TWtA3N3P1M7oM16
7wQzg8NWnhcfJom7yp5ynruNX5jJ4fm1db/V9npwHJL+veXrP2YHWPiVNrxe
6i7CBufXBf1Zsy8Qwe9Q4d1i2o/gzzqhd0iZix3OXzzL/uQsdwR/TU7ABcFW
BH+bXeL1jkMIPjQ9wPkAqUPO1g==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs01GkYx8e4zOa+SFuOKZfNvZJsraFn1m1Qxy2bQpRytiMUKVsikmQr
EiLlkEtJE4pulHeSaogo90vuxjC/12VcMq7723P2j/e85/PPc57n+/0+j4bv
SVc/KoVC8SHffz9SDOlZXaVxqgviX96fFIC3WUZRcBWNs9l2NLlDJIClo1WR
g5dpnEpNvQsrVAJ2vVTa+GkNjdO8YERXWEtAyaFSnwRlKY6t7Wyw/S4CeOq+
4yXL4pztdbdoZ6II2Erf475DhsoxPmp6M7qSgMnqZspFTQonxIPrajxHAH6b
drJi0xLS0jOfe2qIgR6ykGRmNY+2d7k7DB/E0Cm7q6FfaQalRa3RTb2MoXGU
FmeXOI2+/d1jcygew4ePbbuLZaaRfPiDfJkEDCVRYUUXJIRIkukn2pCGQX40
UG0rMYFo6tV51AIM1Pf68+y5cWTnYbj88jGGH/dGmvXFxtEtveqs/cUY+pyP
JGxWJRDFWTLH6QWGZn36ibxNAqTSFjL16DUGrkQXS9NgDKkkpvvjNxievnIT
ozP5yHK5tWLrewx2e7lDw6YjSINnoBv0EUNvL4P7xICH2v0t05JqMMjRtBIt
1g0hYUGiZ1wDhryM2yGScoNoRTEg++A3DIwt0vvrqQNo8s2fnxRbMHwrHPi9
vLsXNY9wM406MSgpSXQVCr6jh6mnXE50Y3A99+uFuwtdyHxF4JDUg6GJdbzy
wi/tiOFOXUwdwKBSHO8TqNOKnm5cfhg6hMFN9THF+7dmFHzuWhyDR843hC3B
rREFXEqujx7FsGHYx368ow4ZV/zVLRrDcI0yJOstU4NOTRkueRAYltSON9ab
f0DUwOd6+RhD0E4i2SLoHfKDn3zbxzGg/L4iD6hA65yO5MxMYMjp5pua5ZQi
G19jvmgSg7TOwDkT6QJ0R5duzJ/CkK03rDCclYRY1tRwJCTrX7dZeNmaAA77
SmQTpzE4eq6NdWQUAEs/NM5qBkPRo7rYsMNl4N96dLSb5Bf58jWs3Dewe7xn
m+cshh5nXSnZ01WgeCfBq5LkAccandCUjyCe6ndCag4Db6+/fffzWqhmZHuZ
kDzmIHPCuu0LKF6p3mpD8rEhtYDZA19BSLvpZUGym9azHDvbJogO18HqJFv7
2nXcNWmBuW0t/Tyy/o77PQoTm9pgiqXGSCdZuy/U1lK+A2KflIqMSVbZKBOR
utgJ9utv0svIfiW875fy+d1QvqazkE7y9L2dY4zWHriOhFnB5LxOO0riI872
wXVde/+7pB7aGdb079H9sFONH/WI1Gthtf2Z+Y0B+MPxJO8uqWeDXyDrXvog
EHs+Z4aQeud9FutezB2CmGOmhUakH+eNb5/yLB6GwCwThXrSP+3lyjsbPo6A
SW2M8BXp91sF8YTbdXyQl3MpluNj2K/JuqTUNAoRs5ktLDIfV1kN/tJ9AoiS
nQ4OIPOk4aHsc4VHgL6vg3B/H4byAPd9VDIHDyLQ5GYyf4KkXsaCaALclQsv
hnVgsLCM6fcNmwQd/RWadhuG2ArVfO7UJPgMZKS9bsawtsjCMIU3BbU1roNZ
5D4c0vk6IToshIEU68eTdRjys4+V+nQJwVvG8JZ+LQbT5GtmBo3TwA6pbz1Y
jYFd/H5B4DYD42wrd9l3GDTrFsvZHTOA8jTl895iUJQMYGwZnIUo2j/WMeQ+
j53da2489wOOetaMij3E4CU+92F9yDyYe0fe2JyL4UtilhN1fB5UOR0aO7Iw
PCsQ+jYNi8C2V91Smrwn5zvT48+0LIKYNvd0biwGjoFkD1ecwix/sv2TnCeG
WqvMFwrKVGa4f3hKhz6GKrXFstkVceZgZI0ja56AM1GCfJaKFNPaPTHoXAUB
ka5L7EoXKWZmtMScUhkBV7XlykwTpZjZB84K09gEZHC3VGlJ05glDa8TjmUS
kJsBNRksGrNJ1siFnUoAO8C58edYGvPAk9763hsEvNh9pO1qFY2ZrJSguhpL
wP/3nSky3GghHUnAvwK1J8Y=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk/1IkfgGcMM0W5zyW5hdaxjpzz/tAyUllX2V0ht1AbOZIhJVdEs6to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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ4U2Oo4rpP35vxw5ApD
vRLDgaT4xmMbr26Uf7t3ev5uhT/7Q+WaFVKX/dSWK/o10cr5x/4SWYZImTgh
w1s8FucfCn3Zb5CpVh8UrGLM9zJXWv/N+/23VaOqGc9vMt64I4RRzuHF/uv8
ygkpm04ZX1r1yHLXnfv7WXae8g85dMb4ypO3TvYhF/ZvnPFml2HkMeMFmk/5
n86fuD9QQXbprG+bjV95cWe7XD9nv1r5SeWs6ZOMP88xf2V97Z690KQPjN+Y
KoxV/u6bKXXsuf1Zh4UR/VkNxq8n3rf+9fO9/fojyw4ct9lkbDq520r7wmf7
I5LxCy7sOWX8qszHxvDbd3uhqN+SJQVfjapuzegsvfrb/vv73Tlt6iv0D2iz
3jvBzOBwdVNTv3kmm9op57nb+IWZHOpbmmN1PLkED0n/3vL1H7MDLPxKG14v
dRdhg/Prgv6s2ReI4Heo8G4x7UfwZ53QO6TMxQ7nL55lf3KWO4K/JifggmAr
gr/NLvF6xyEEH5oe4HwAgkjNyg==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs01GkYx8eMTIwoZEO5JkVHW1Fu45mDmtrakmzp4trNilySku6lslpU
IhPHrdmV3GpcKvFOpEakccllSJMMMvN7XYZyW/a35+wfz3nP57znPOd5vs/3
eYz8gt2OUCkUijcZ/71oYVj33BydX80sOdP9RgZedpyC0Co6P2rTOM1TKIOZ
Q1UXvl6j8z0T+MqCDhnYlGkYvFWm853Lj/18SCaDIk+ed5ymEj9qPDfr8UIC
+pb54aJ/aHwe+sShHCBgjf62vVYMKn+l5sXBAQ4Bw69bKBeNKfx7NXO5zi0E
EBXJweWGM2hQvNTmqCoG/bCp23bOE8h1JMZ4zA6DSNXmwxeNMVTimOEqPYpB
+I1+Y0u8HNFuFS9pP46h5k2bYyFDjpLFHp65IRiKLp0uOKc4ipYHm6+ai8Sg
9i1Ib41sCEXbGYT7x2KgVptP5H3H6GBFr71dPIYfqf0t5goYlQlL08fuYBC7
+sat0Jahk0+oOiYcDC3m+scfGkrRmNXrZclpGASKnWxji0Gk/d0oTZ6B4ckz
dwV91gDaNJkoO/I3hi3bBb0S63402+dvU5GL4fNne0G+RR+qIxjPJvIxLKCb
xDN/6kXlosQ1S4sxPOQkhc1b8BXVMLK1Fcsw2Fuq7HlP7UEvbRrVhc8xNOX2
2L7o+owSl5noaiEMGhqKnbnST8g9pWHG7xUGt0jTcw+mOpFpsFdwSjWGZrZ/
5bkl7ejJ0fVDL99i0CqM8Q4ya0Xi23Gjj2oxuGs/pnhtaEFpu6ZCL9SR/fUS
TuAuREbbeM2fGjDoSry34o56NLtfbYWvEEMspVfVi1GL6iMuddQ3YpjR8xe+
d6hB1BvVg4bNGE5slN1lnniFApve7vFswYC44oL9UI6oKsW6Vz5iyOoasLbL
4qHG3ZL18a0YVMx6Iter5CD934bSr7VhyFglUZek30YF9qkH/drJ/Lc2TZW1
xsHm0S+mNh0YdhxYHL3DPgeatK/PHyW54FF99GmfYvhLOYGaIMJQylWrZWe/
BO8BNw2NTgzdriuVVE9WQdC9oA1nSO7ZUWsWnvgGdlW+C6oiuW97wNaukncQ
J84oGyZ58BfGcZe2Blj9a5gmrQvD4V69wHGPRmAUMRWnyX93k6dZWzY3Q2FI
XbaIZBe/LR0P1n8EIx3/0UySrTK71YcM20BQkDLsSvJycfhmJ7UO2F1kkN5P
1qdlwDh/b1oEjRry2SMkK3pl8gYGuqCZuXlRPdmPPHXjoH1rN5QrRbfpkLzT
qijmfIQYeDyPjUxSj+UcF/1Pl7/AAUeGugup19Rc+1OHP3tgIsrV15LU88OR
IHbq/a9wws9i7Qyp/8M6ha7p7F7YN0Vczifnc3ZtUsiBQgk83mm716mJzPdP
ZYrum36Qqkama3/AUKFOi0uqHwBOpEGC13sMe4zZVzSav4FF21H9WNIfN9kf
AlTEUlCwzTG7Q/rJaL+m9/U+GdSEsPIDazC8CNy7m0oQYNhYIrEg/Se9/dl+
anIIMk4l3vCoxMB0uvrF7/QwpNbO2crLMUSXa3MFI8MwjeKdI0h/Ly5grk7s
G4GImuCT1uQ+eJo1Dk36jELUhhFu6BMM3IzDPO/OUYjtnmQnFWCwvhtrZyGU
A9N23/j9HAx5hdVTUvcxkH17ZryOi8G4fvpFXscYeEt0nxdmYlg4L9De8us4
qCqEsz3IfR6M2O6w9vsPsEtJnu/zB4aDtO81OmEToHwyVOfYdQwN8ek7qXgC
BAaGAXuuYHiaM+rXLJmE/ddKRwjynpwV3Y859XEaigyHixX8MfAt5nULaBTW
/E11l0wdMLxzTitV16SydF0ciy6qYKjSmy4en6WxAqIiub+3EnDqkpTL1lJi
Gci5MbXJBFxwm8mr3KXE0hGVu5knEHBz+YJi63gllu7VrfJTNwngCCyrTFTo
rNpQJ4WGMwRkc6CWw6azVMUed0QhBOQFugoXRdNZK0QOTk3+BJQ6+rbdrKKz
KPx1JiU+BPx/31m0t7nsqx4E/AtsFiVo
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vk/1PsewPExY0yRRkQpVPboUI6lyLy/p42cTiUpp85kO0UiyVKKKEU4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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FPwaB3CNUCRdS+oVyvpGdzJFMmY8XqlBZW+RjEg3ZRAhhCSUJVpk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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs41GkUxweTeSKxUrsRuZVbsa1cJ50pamiLsrMSuWRN2wVZmyRaIhsl
VmQlImKRjBCVeCfEkFsiXcYQxn1+r8Ylt7S/fZ79433O8/nnnPd8z/keDa8z
jmxJCoXiQb7/IlIIEHz9SuOWbJrP/ponAnfL1KLfamhc1smrTbwSESz9UvPH
wGUa91oFo+PiMxGYVyhubFhJ486Ui7febxNBsVupR9waae6ysVmVwowIhlS9
iOIvUlyzEX7bg10EGKn9eHi7rCQ34EmEQ2wkAZN1nZQwTQo337H0eX41AaKq
v89Uqi8hpWnT01FzBKgFLCRYWs+hwmx1vUu6GN6vMm/7qDiNHPyEHa9+xtA+
SrtiGz+FPm1g2AtdMLyo797JkZ1C7u87Ans8MBSHBxWFUsUo22U4KeQkhtWj
vipGExiV3zv70DcEg2St/lzhLIGi8gtC3cIwfE4b7tSXIJB34cYtJpEY+g4e
i9u8bgJdL7BQSruKoVNf7fQ99XFkO59FN4jDwKN+YGoajKFmo07trAQMDx+z
JNQYI8g8PXQDMwWD7X7eoNBkGLlW2OQ/vo2ht5fOe2AwhCZv+sTLZWCQo2nF
W307iFR706yP5WC4l5ocsEJuAK2k21E88zDQDWWcWiT7UcD19Kld9zF0FPRb
POX3otmCQXdOMQZFReqHgvEeFCtX561QisExeFPo7YUPyJAWZun8CMNr5onq
0O/eIrAYh7QnGJQ4MR6+Om/Qo0RvdkolBta6+xR3006kJLbbG1JF9jco2g2s
dkQ7Fa47w8WgLPSwI941o4+pAe6XazBcowyucpdtRJWfBfTFWgxLKifaW3a8
QAwOu+rICwx+ZhOJVn7PUfW8oDejHgPK6StygUpktsk1s6UBQxZ/xMQyqxRV
Zmou9fMwyOj0BxvL5CGudPlkbyOGTD2hvDAjAb3a3BpS10Tmj92zUPEmDlit
1K7MlxjsXddG2dPzILfJxcezGUNRfnNUkGcZNC83gFQLhvKc1Y3M7Geg637j
QAzJgoO60qt+rwH29IEkMcn99o06Z5PqoWmcrwitGIb2n7LjP2oC9o0zPD+S
x/bJnrbpboU0t8tll0j2HlTxmXF+BZ3LC+xgkllaJVm2e1/D1kZVmjPJNl62
724bd4F2Jj1FleTtdwXyWL0brHIF65vIetp9Z/fuXv0OxJbNsW4kK22UvXhz
8T1kf6aKu8n/U93vlo6M8CHtft0+C5Kn0szG6G8EYHs4IuUS2a/D9uKYi+f6
wNQn94c7pB7aqTZqPZc+wk7TQO90Uq+Fr29LdlzvB6WGiu/DSD3b2L7MtJQB
4FdHp1qTet97KcFfzB6ENitWzhg5nwvbkv1dOUJw6uxmna0j832pvqVcPwxd
h5JKjJ5jqJKXiktuHoENdHONUwiDkyYzQvH1KNTaHXCKJvcjmtl2SqZvHAaO
mOr6k/uk4bLG48+hCbizvNhmUYHhqc/hnyRFIjgnWMsaLsMwntBLX5jHEKHj
JUNwMFjtjvzoFTQJTfP+o4EPMERVrsvhfZqEYu8nbGEBhrVFVluShj6BOIhi
H0L6wU3nFZ73FIOB41/1d7Mw5GR6l3p8EIP2XMgMh/SPSeI1S4P2KeihfkqI
vIWhkFO7MM6ahs7jLlTJZAyazYtPC99Ng9bLOWnvGxgUVvjQDQdmYNvbhMEO
0s9j5/bv2Db7Gf5RVtZ1u4DhqNTsi/UBc3DRsVtizzkMrfEZDpLEHGzRbvBU
CsBQkif2ei2chyuhem9OkvfkwvuUmMCuRRh92lEz6YSBa7BCwJOiMHITF4Yq
9TA0WaeXy6+RZEyd15+OnyWgRmWxbGZZikEsidL7uAQEho/nMJWkGXXaqmxW
OAF/OC4VVh+SZkioBtsFnycgWluuzCRemnE0fKVHtD8BqTzDGi0ZGoOa8Otx
ticB2anQmMqkMSY5c6HGzgQU+hxs/yaKxuAk2KyecCCgfOex7ugaGsNRY+PW
eCYB/993Bj8oZmIDEPAvOm0uBg==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk31P8ex2djQigyslS2qJSlbBm8Pi0aqSuVKJKEpJSsJTVERGTJehHZ
qlvWyDIT7w9lu6ls2ZJG9l2UZWzf7jn3h8d5nsd5/gMP2UsupxxIBAIh6i//
W7TBrWdtjYrnfBnsjcDOwgXdxFzXKiruaaP8NaHKEpbtqph9D6h4qD/XxZFp
DYmPR03OMKh4sI+aj6TeRdApEdlWy0fFbznlF2p32UIbR3dKp4EXtyg2ze9O
sgMPfjv0KpwXt3S1avcIcIB860KbcFFe3CRYWC77sxOUaIYUNDfy4Dkx+lpv
rjtDhaANWTycB69LiR+WOeICHwY0zlgd48FpNhzFr3tc4WM5/4vUdX//klg9
oU43aI7lLPRVU/DgXHG7vOce0HG92HhHAAXvc+qyKEnwgsEtlybzV8g4a8q7
S27mDkzp+1rZIjJeXvS5BfbdgwXr5LqN98k49I/67UnyBSKzTLPqIBmfFyy7
+UXsPvCntKW7Ucg4/TeykHP3B9GKWWH5GhLeLEYNdRgMAOmeDfdaHpJwTfFX
qdduBoLq1mMWGgIk3OTlfvtfH4Nh3em72Vs+E/FAA8w7MvYRcB7mEKlRRFzU
nVnJvRUGkb+EsztpRHxIv1Cs43AkXFE8QHzfScCdo/elCVlHAWblZp6dTMDD
R6Z1P/o/gekPrQRfOQL+rOLi1PP5GLhk6pjnia8hg5l6h932cdBH2249QV9D
YR4yQ1a98TCY8ay0e+8qKtdzY0wIJsFEebwLW2YZqTLkl1i0NPDY1H9aIGsJ
tY2oCvespAH3qpqO1c4lpMBS0k0fSwfezfWEJXUuYrD5AhS6MmGrGzdK99AC
ohXXfXnPfQld63W+9Ir8Rgn4+NHzFgXQOEJ9aBQxiyTOSTBNZwqguqbdIE9g
FjncjpTyCXsD+X63cu9SZlD7/EZU+K4QnlszLvf5/UJnsrvMu08WQbKu+Fbj
lWm0rtsxwrW/CIRGrkupjk+hMp/wPH5CMZDe71rInptEEoY+pdt8i2E+eah1
F3ESJVvOHHLgFgPH1DZckTaO7oT74kL9JdC6a+u1TJkx5KroN1J+shTqKN8Y
csqjqKrKbVyDVQoFpWbErdgwMmvkFKjeKQOj43X9A5pD6G5cUJZsRxn8+EGv
y1EeRNvtlq19VFjg5Z732lN2AG28ulNp+C4LBKnyEfri/YhJeXdV8j0LMhPj
3HgE+xBvz6JqA4ENdBV+80+kn0jBYCQCabKhufLe/tgFDmp/Xi2NbP/6q5/7
Wd0/UP73T/SUB2wQEaF8ezX2HckekyE3JrPhlPf2u0ncb6jJm07szGbDE86R
LWF8XWjuA//4qyI2tDCuVNzd3IHkaLH1Bn99U16IzXWlNpTgaMWNec0GM9pr
wgWtVmRgVK/zNpENMfca0kwMm1F3aOnj3PtsaO2fOAhmjWi9gIxu/EU2SA7Y
HJ3sbEBCrazcGzpsCCX0r78gUI+eGr7c+2EdG5alrjR+0qtG/qThTXgTC25o
j0fr36hE49TJ1MhoFqAsTq4lsJFaO97hZMKC9O5hTd30QjStz9QKJLHg2c4B
4YHUKNSWxBtz36IMlsMMuSVt4fC0QPNz6nQpmFiJBZrQX0KPVMe2LQGlUJwl
VM/IeAdBMTSV5tgSGDUWuHa4/TMYy3poGzLfgn2/lPOfs02g+MMehBeKwEz+
TbrRkRbITaYUybgUgUZaj/CUTDtwtcJsnpoXwmyy9ii9rQd8KBV77cQKQGGl
4t+SNUOQIjdxMC3wJZQLk8PjGoZB0n1aMc7xBZjLMfxFWkZAly9Mf9eJ5xDM
+HKVnzMG4clL6pNqmSBrKWoTNDgOJ1RbejnKGcBytjhNmpgA56TcwIU96TAW
9YPOXZyCjNDhgTSjZ6B/MKD30q1pkLxcTuf0pkAgm5ZV92sacLaHmhX2FMRy
9XfHDP6CWpOelkSlRLBWappavDgDtVimRXR+AmQ9sy+0+TYDfwgCFi2MeNCM
DtVVbpyF/0hO11DSYiA77z13zOw3BNPPtzGNokGuYYmV3fkbmuhFBmaEJ7CB
x5mu0vcH5GAfQxSLgCDZzKVJxzlIqdVfjRZ6DCv63ey88Tk4FGAZcnLpEYx6
HddTn5sH5b5nA9juh3CePFct4bYAO/C2y8GhgfA5IvUEaXIBzMc5m3aSHgAm
fbRz1GkRIneU85+L8Ic3L2cutQwswrB4bOLRvfdBQTN5nG3LhV+ilfInW30h
rtLQK/M7F2rcm78edL4Hd7oSQjy/LkHWLhFLUSFvkOIfEi6zWgad1ImHw2Ne
8G6/Ztxy7zLcLr5jMz/tAeedAqSxKytgHNGrtUfKHVYSmtIDJleAczUpwu+K
K6TUbdtZ67EKJnSfxYEcFzBYuJ7Hv7QKGdeEErbXOwOuzNNTRyZgTuqjkSWv
HaFSZXNZgSEBOyJeUzLg6QBV6soxiQ8J2KKnf7vDDTv4oGHgElBPwCQ2J6zI
PrGFau2Txs4CROy8/4bNx9/ZQI2u/fYz/yJiLzpSmFjqeajTv0UwiCBi4y3x
vVW156Aee/RNsYmI5Voe1WapWcB/Dz0tFhYlYa5S1manvppB/eoVrzBTEuZ9
NlRZvvUU1JVpaPGFkzDflUWhi2umUOtBmAv8SMJqvBOaPF+YQI1qw1sSHxkj
nU25sDv5GFSPxnv6HiFj5Vdvbqe2G8GHLDvN5QAyxjwxLxZ46gi8v6j653Yl
GdstnBB3j+8wVEktFf1ZJWOeulPYlvkDcHaHxGzqAQrmJ+84ubcXYEpDW934
AQUbKlwffBn0IOjAGZffNRSMEbLNfG5VB6RN3HNS+HiwwLV8/xqaFryxjBoz
Os6DfT+6lOHO3AdGjnk7Z8N5MPqJFQkjFXXocf/k+LSJB1svMKdgZ6ACnn5j
WYxNvFhvn07Q9dhdwDy1nF1xkhejuWqfUY1WgmAFwSLNCF6sNchIa91PBYia
28LObuDF2ognBNXuyEFinUqVPD8Vs9us1xdkJgMZiVCfyKBiQzkFeSJfpSHb
2bRxYyAV03gTrRjqLAHFBrbtwVVULMQDPNPsafD//sFClJqavQtF4R9DIGcd

          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FPwaB3CNUCRdS+oVyvpGdzJFMmY8XqlBZW+RjEg3ZRAhhCSUJVpk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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHtYzGkUx6fpMqur7YaiSLRq3UO6OPPkMlEqzIMlTReeLWIYEoWsFeVS
kkgodBGNooYo9Y5JNdkoqkm3mWqa7vN7q6mmq/a3z7N/nOd9Pv+c95zv95yz
wI+98xCVQqGwyPjvRTM54ulpGv+AUvTLlio5eNsnZp0Q0PgrilMt5zbIYdJf
cEF6mcZPpCo0xFI52OXpm5fNoPF3806WWSrl8OpALivaQIN/6wOvsWAuAR3z
/IhXU6r8FTd2+RYFErDczHWPrRaV75GSP2cok4D+TzWUcAsKnyUyq2Z1EiAv
vMcumD+JwlIK50QuwGDGGY+13ziKTPaxfIt3YGjQtqts1R9CC1L/0PYMx1DV
TbvqEqNAU5vZ9MOXMZSU1m3I1lKgKL+bkwFRGF5dDMk6pzaInA3b6wziMOh2
HzVd3odRVGZl3rw0DNRi61HuCIE+brv0Xv85BuXDzhprFQIZhF4Nx1wMLZ6+
0YuN+9CMU19sfXgYaqzNjqTO70W7+AX6Q3kYhGqNDAubHmQr3XObXYDh9Tum
ihm9C/EvHNg9T4DBxU3YLlvTidh2IZy4EgwSiYPwpU0HusOhCPqEGHRoC2Oc
ZrUjz4xBkUslhtTEuxx1HSmKTui65vodg8Myzd1fqG3IxznAY2Uthu8v2tbn
N0mQouavnrQGDPr6ao0vepvRuKjaWLMZw86zi849GG9E1hrPBpgSDNWMgKJz
s3+g3LJZj5KkGAyzo1hHrUTIcYjt/0iGgWmcSfFeW4OYmUXFlzrJ/trlzsCs
QoFlHnSVXgwmMtZWor4CvdNrvXK7D8N1Sru2t1Y52pCUzdQiMEyaBlR9cSxB
oiV70o9gDMfW9cU5HfuIFhVmnsntx4DSWrL2QQGqEbwXtg1geNrUtcb+aS5q
mVkaNzaIQdOq7exqzQxkothep1RgeLxEpidLjkWVtrTY5iEy/43N43miaAjR
VtctGMbgvt8owt0hA6bFOilhIxiynldEhPjwIEts7G6uxPA2TbeckfIB7rzx
10knWez5m4b2SQH437wi0RvF0OZebnXqTikQRj7FXiR3uB3e2vTmM6y9Zv7u
Bsk927SObKr7CqY858Jkkg+2mwYN7/0G0hPv/e+RzFyY89RlSzW81uP+CCZ5
k59L/YPVtcCuD5zrQLLtE7Eenl8H8Rnnl3eS/1u2nNrirFsPitaX+qEkG5pr
nY+faIDXnMlSBVm/mveT3K6uJnCrSN/OJFnxcF2Pg0gMhZJFGQ/Ifj1sX0Wd
P90ConlLjfJIPSwTN5k1/9UKLW7EII/Ua3z6R47jzTaoWLZ2UzypZ+Who4yH
CVJQhC/U3kvqnfqPStNESjtwuxa7T5H+hK68e3x/tgwOyqm6EaR/llNF901K
O2GsqHOWI+l3oZ5q9N2KLhA7DS491Y1htwXjkn51N/A0dWUx5HxEMioPa7b0
AtWU4soh52nBPgPWlY4+iAkXqa1vxZAftGcXVS6HVRuLgqViDL2xEofxMQz7
p3/GS+sxODn/3eoX0g/VGdQVAXUYIgqM04QD/fDpxPCWmhoMRllOv9/pGID6
599U/cl9OGD1DY/5DMII4fU2ogJD2uODuazGQXjy1WQ6phzDmrjr9jZVCphc
1XxsfzEGbnbxeC9zCMpNPjnWIgwWFRP53PohiPeyC171AcNM9SCHZdJh4H7O
336P3Oee026OK0eUIGy/XaKVisFLdaRkDmcUkkL9VxPJGL7GJHtQiVGw85lU
f/cAQ07GoF+1bAyeNaerUMl7EtqQEBVcOwFPq+zPHL+IgW+jLhaqUuiGYT/R
9E4Mnzc+eqtnQKXnrs/UvGWOQWA6wRv+qUpPva58dL+bgOCLvWkMQw362hxm
X14GARd2TnKLdmjQLabSAr8/JiDSUoe3JkaDvmux64QogYBE4TLBQk0a3YAR
m5oUSUBKIpQnMmj0296LW30vEsAN8qz6NYJGV9KUYXpnCHi7wbcuUkCj58zt
v/qMTcD/950+JrGZbf0nAf8CHKk5/g==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk41Hsfh2dhhpEluyOcE4p0Wk1kGt9/spYjQo9DEeWgUFkjkmOpDg06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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FPwaB3CNUCRdS+oVyvpGdzJFMmY8XqlBZW+RjEg3ZRAhhCSUJVpk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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs4lGkYxscwpohq0Ek5t0IpRSqHZxwyBhUl2lpNdNhCB3KIRaVsOqA2
W5qSnNrSRA6rUryTVlEqZXJKDnNA+L43UTSG9tvr2j+e67l+/9zX+9zv/TyG
QQc37qbTaDQeVf91NCO848cPpvBMPX3i2WoCtq/hF4ZVU1yeFRbiQoBiZ3WC
5CRTGJsjYim8CFh1n6X/fCpTWHHNOKmbR8C9gFJeqpaqsCEet1ScJKBnQRB5
b0JZyH4QmL2qgYClep7+1up0oXRCx9BgJgmf/xHRjhrRhAfeMXt5niQQlZcP
PjJQoMiAIX7QSRL0wuUX1riMIf2tl4MLSklom7bqTTdrBEnenTH16SKh4RPz
lHvaMPJ/qcr3kZFQ86zZsUh9GAkmV+jb9pNw71h0YZzKF7Q3t3BJ8TAJmp/2
6y4dxGitjnySx8BAf2o+JvhGoreWukynqRhGr/WKzJVI1B4lXqemgaHLOzD1
p1mDyLxrW8RmbQwic72QPIMBpDTCcmmejaFW5QPHyKIfBQbEWjrpYih+4Kuk
x+5D9EdCu1eGGNy9aqUym16UyWvtsFqIobPTrvauRQ/iXXziFrsIgwbTOM1h
thQpGrhO5ZYY8viXwhkaElQlfV192wqDnaWa3yu6GJV8InqOWWN4VyBeXdHe
ieL6dcZaV2NgsVQ+FAx8RNvKbVjL7TFsjFkYd1X+AXHL8raGOWJo5OytipvT
gpa8MAnMd8agXXSat9+0CXE3m+jwXTH4zrpD275ShCYMvCWRbtR8UsIZfBvQ
Au3Lj8VcDPNkPC7ZWo8c76bMDfXEcJYmnbZdvQ7lJHJjPnphUOjubXhlX4MW
B0e3rFyP4YDt4EWHA0+Qbdj4iiMbMKD8rsKt8Aid6vucnO2NIae9z2ZNTikK
OVggKvHBoGYqjlmhdgsxJou1BRsx3DCTTZdlXUCVZK1byiZK/9xa+f2mVDAy
fbh7jy+G9dt0ktbb3YKSouuWxpsxFN6uT4reUQaVU2OynlJcnq9Zx8l9DD45
6eUcPwwd3otUpx2uhqbWM+FFFIvX15lGpD+DMDXnd3KKe7yCue1/v4DJc4TI
zB9Dv4d6iGvza7j9WCPWnuJdUt3Qr1veQvEfBR7WFPsal+S4uzVCXyfeq0Wx
a5B769UV7+Erz+J9K6Vnnd0xHRs0Q9BSWdopik26ItycNVshpa7zynyKtfXV
4/8cb4NMxpyRDOq9KtuzS/v62iGPVZOloOYbvmbbb9fUAaLwLdc5FG+wvnc6
PqoLDA2Wp/xK+WHCd9X7eLwbtO4qjgdTfsl/tJTYp4gh6mHUUW/Kzze793Ou
ZUigzKkoeS7ld95LpfbxXCnkn2dk11D/E2t16dC2IhkoLzOr911H6U1UXZn3
rBd2/GwaMt8DQ+V05dRL9X0wePNqQoA7Bj8jTiKr8RPs6fWvTqTykcx5E6zW
NQD7rJ6TMVSeDLdq8X7vGYQIkbPYk42hItR/E50gYPf+y7p0Kn8DFzrt5N8x
nLA6fUSXyquD84nuoOjPEOCiuCJYiSHp0az82qHPIDk4r2whlW+dQofF6T1D
wAhm9r+h9iHA9C3+vuMLxHNXsZQWY8i/sauU9+ELhNq2eM4zw2Bz8ewai4Zh
OOSXrMkwxiAoeiof8B2BmMzcm+f1MRjVj1cIWkdAqnVpNW0+hhmMUDtLyVew
qV0UfZba5/4oL3urb6Mwmp5xeJMKhl+Uv9XMDR+DwDtVf3nQMLxOy9pAJ8dA
c1T82ExBQsmtL0GNsu+wbM9vxVnUPYltyzgd+X4cskYTJCHdJAgtGB21yjT2
zCHrc11lJLxwySyfrkVnP2jxjotIJKFad7zs66QyOzwxMzJ1HQmRxwbyOdqq
bDMNJ/cRDRISNioEVT6q7IUZ8uyVqiQkm2iU2aSpsqfYFyXsnCSAX2tZbazG
ZN86fmVKPElALh/q+BwmO/rhlLZ9PQQIQr0bZiYx2a8FsiinDgLKHQObk6uZ
bKGgcki5iYD/7ztbkuoRUPyKgH8BhXcLlw==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk4lAsbgGcxM6GTk2whSaojp4XMIdLzWkcjeyFCyJKSk2MpZSnJdLI0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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ7UHa+W5WzvZPhw5ApD
vRLDgb9aRY7/T3wQe7t3ev5uhT/7i6zy1b8oWyjLFf2aaOX8Y/9CNftpSZ6B
Grd4LM4/FPqynzXYqklSMVmL72WutP6b9/sdXKfeXLT5o9bGHSGMcg4v9q+o
239UV4FT+9KqR5a77tzfH3LD/Cq3ILf2lSdvnexDLuxXPubZVMfBqr1A8yn/
0/kT9+/8GdR97eQnrVde3Nku18/ZX3SZ0FFXf1Hr8xzzV9bX7tm/eP3BxGTm
Ni2Vv/tmSh17bl/6berU8mf7tF5PvG/96+d7+5c1XaosWh+1TCd3W2lf+GzP
xuPw748mp/arMh8bw2/f7cvPK4QX65poVd2a0Vl69bd93TWtA3N3P1M7oM16
7wQzg8NWnhcfJom7yp5ynruNX5jJ4fm1db/V9npwHJL+veXrP2YHWPiVNrxe
6i7CBufXBf1Zsy8Qwe9Q4d1i2o/gzzqhd0iZix3OXzzL/uQsdwR/TU7ABcFW
BH+bXeL1jkMIPjQ9wPkAqUPO1g==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs01GkYx8e4zOa+SFuOKZfNvZJsraFn1m1Qxy2bQpRytiMUKVsikmQr
EiLlkEtJE4pulHeSaogo90vuxjC/12VcMq7723P2j/e85/PPc57n+/0+j4bv
SVc/KoVC8SHffz9SDOlZXaVxqgviX96fFIC3WUZRcBWNs9l2NLlDJIClo1WR
g5dpnEpNvQsrVAJ2vVTa+GkNjdO8YERXWEtAyaFSnwRlKY6t7Wyw/S4CeOq+
4yXL4pztdbdoZ6II2Erf475DhsoxPmp6M7qSgMnqZspFTQonxIPrajxHAH6b
drJi0xLS0jOfe2qIgR6ykGRmNY+2d7k7DB/E0Cm7q6FfaQalRa3RTb2MoXGU
FmeXOI2+/d1jcygew4ePbbuLZaaRfPiDfJkEDCVRYUUXJIRIkukn2pCGQX40
UG0rMYFo6tV51AIM1Pf68+y5cWTnYbj88jGGH/dGmvXFxtEtveqs/cUY+pyP
JGxWJRDFWTLH6QWGZn36ibxNAqTSFjL16DUGrkQXS9NgDKkkpvvjNxievnIT
ozP5yHK5tWLrewx2e7lDw6YjSINnoBv0EUNvL4P7xICH2v0t05JqMMjRtBIt
1g0hYUGiZ1wDhryM2yGScoNoRTEg++A3DIwt0vvrqQNo8s2fnxRbMHwrHPi9
vLsXNY9wM406MSgpSXQVCr6jh6mnXE50Y3A99+uFuwtdyHxF4JDUg6GJdbzy
wi/tiOFOXUwdwKBSHO8TqNOKnm5cfhg6hMFN9THF+7dmFHzuWhyDR843hC3B
rREFXEqujx7FsGHYx368ow4ZV/zVLRrDcI0yJOstU4NOTRkueRAYltSON9ab
f0DUwOd6+RhD0E4i2SLoHfKDn3zbxzGg/L4iD6hA65yO5MxMYMjp5pua5ZQi
G19jvmgSg7TOwDkT6QJ0R5duzJ/CkK03rDCclYRY1tRwJCTrX7dZeNmaAA77
SmQTpzE4eq6NdWQUAEs/NM5qBkPRo7rYsMNl4N96dLSb5Bf58jWs3Dewe7xn
m+cshh5nXSnZ01WgeCfBq5LkAccandCUjyCe6ndCag4Db6+/fffzWqhmZHuZ
kDzmIHPCuu0LKF6p3mpD8rEhtYDZA19BSLvpZUGym9azHDvbJogO18HqJFv7
2nXcNWmBuW0t/Tyy/o77PQoTm9pgiqXGSCdZuy/U1lK+A2KflIqMSVbZKBOR
utgJ9utv0svIfiW875fy+d1QvqazkE7y9L2dY4zWHriOhFnB5LxOO0riI872
wXVde/+7pB7aGdb079H9sFONH/WI1Gthtf2Z+Y0B+MPxJO8uqWeDXyDrXvog
EHs+Z4aQeud9FutezB2CmGOmhUakH+eNb5/yLB6GwCwThXrSP+3lyjsbPo6A
SW2M8BXp91sF8YTbdXyQl3MpluNj2K/JuqTUNAoRs5ktLDIfV1kN/tJ9AoiS
nQ4OIPOk4aHsc4VHgL6vg3B/H4byAPd9VDIHDyLQ5GYyf4KkXsaCaALclQsv
hnVgsLCM6fcNmwQd/RWadhuG2ArVfO7UJPgMZKS9bsawtsjCMIU3BbU1roNZ
5D4c0vk6IToshIEU68eTdRjys4+V+nQJwVvG8JZ+LQbT5GtmBo3TwA6pbz1Y
jYFd/H5B4DYD42wrd9l3GDTrFsvZHTOA8jTl895iUJQMYGwZnIUo2j/WMeQ+
j53da2489wOOetaMij3E4CU+92F9yDyYe0fe2JyL4UtilhN1fB5UOR0aO7Iw
PCsQ+jYNi8C2V91Smrwn5zvT48+0LIKYNvd0biwGjoFkD1ecwix/sv2TnCeG
WqvMFwrKVGa4f3hKhz6GKrXFstkVceZgZI0ja56AM1GCfJaKFNPaPTHoXAUB
ka5L7EoXKWZmtMScUhkBV7XlykwTpZjZB84K09gEZHC3VGlJ05glDa8TjmUS
kJsBNRksGrNJ1siFnUoAO8C58edYGvPAk9763hsEvNh9pO1qFY2ZrJSguhpL
wP/3nSky3GghHUnAvwK1J8Y=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk/1IkfgGcMM0W5zyW5hdaxjpzz/tAyUllX2V0ht1AbOZIhJVdEs6to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          "]]}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      Frame->True,
      GridLines->{{-0.4920407313793702, 0., -0.0003295591179962097}, None},
      PlotRange->{{-3, 3}, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {977.1428571428571, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {360., 291.2461179749811}], InsetBox[
     GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJx1lGtIk1EYx1/MSjFMMbMFlYqFJeSFjBDxLLx88MIgFdMi1KiMEgVlplj4
wSSZRnYPbXbDLmp9MZXKjmxSmYgsqZzWsHTmramJVk6o5vyfD89LB8bDD96d
9/c+5/8cn8ycfUccJEmq+PezVftyaketf2RbDoIblniBg+3/mRZ8KNm23guO
tzMDW//Y1pTgB/b9BD+0v09JPCgLL1rhB4YfGH5g+IHhB4YfGH6kL5RlHmBa
4QeGHxh+YPiB4QeGHzknyrK+UA8wrfADww8MPzD8wPAjuaEsOyfaF+oBphV+
YPiB4QeGH8kxZVlu6DnRvlAPMK3wA8MPDD8yV5RlOaa5oedE+0I9wLTCDww/
MueUZXNFc0xzQ8+J9oV6gGmFH7l3KMvmnM4VzTHNDT0n2hfqAaYVfv+7F+k9
ROeezhnNNc0RPTfaJ+pFq3hfSZHjG/Pvl4OKijy/2DlZ/hVac2h5a5eY0/Rd
deuKvFsFdyRYnQvba8Tz974b4g8o9YJf7Ql5kZhvYJX1T+42j0yJ/b38an9q
escE3645H5fRPiQ4ZcdiRHbagGDvOr/+bt8ekaPmza/nXHPbBF9Q90VbAjTi
+SCtNvLsJp3gov4cw9YoA6dzIkmnlr5/4cx08p3KIbGfZeNSPxi9H9bHxHk2
WUfE902U+ReYrBbBv9J0q7+qxwWvDDx43TxjFuy+Yt5/7OQXweGPt+QZe4zC
x215f5yHNKa+qM84ysqqA8evBkzyjg3HE1eldvH0j7tre2NGeZLbGtUPTQsP
84hIcssc5sWRo763srTMQxXtnHB6kLsolEE+6XrW53mj2CPYyN9ddt95rdDA
xhdVbalZZlZy5f7CMcfDzLRXd1MV/Zk/L+8ccHCaZCe+vY3yauxiQWvPbatW
TrKJzvCmRtdWdsnyySUgZZQtTuSWxs/W8Pnu4Jln2cNsvjbMuj1Kz/c3ln2I
LR1koVWzIXP5Bq5WtBQ8DTUyabmfDSZd1WyEmf0Fs7EUwg==
       "], {{{}, 
         {RGBColor[
          0.4374585365247443, 0.17762113972633303`, 0.17804021175705356`], 
          EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwNw8eSmgAAAFDXsmoUEBtFUEARu6A4s2PDhgKiKCLFtbs555xbTvmCfHD2
zTz6+ct8+n0+37/vge/xN38yHElFonQWKaJYh6vA7+FE6B0KhtLRH1QmiwKg
UOaysTgYCAL+AIOg7RIrVmu9Wr1O0Q2a8QPxt3gsAAILY5ulqXwqXSHzTab4
0WzxbJkjyFaxVM4RLJ4rYTiZTBFwMpeAd/LyZh2388WAF+5H+2E7F/PwdNzl
YGgsZEnsbWZzuT9Qx9K4KyqjsSZN9Ons5XrXgzUUOrUC5W2NfpvHQAiJAziU
+PJO7mZrr/Xz3jRXiqNvLFU7Gbujtj4oqu7Y8+1mZe5DCegdToSTcCSVjKZT
sWwmjmTRIgOgCIRjiRyOlYoghiZJIkMVEIZO5UmcLYnSuCp2Ca5MVrhCrUrV
a3SjzjQbxVaz1G6xfLss8FxHyJXZWk/82fjDD/ryzuiOR8JwEIRAmMitJ9Ot
507W2lRf9+XFbKP3JtJgKY9VZW0fN67zMZ+NlJV2tFTrYD/u1u16vN8O18vv
6d/9+dM4ed7Xy309nefDvJwlTVUO5n+KMloL
             "]], 
            PolygonBox[{{140, 68, 67, 126}, {127, 43, 44, 101}, {134, 65, 64, 
             120}, {133, 46, 47, 117}, {112, 56, 66, 135}, {126, 67, 56, 
             118}, {120, 64, 53, 102}, {117, 47, 58, 119}, {118, 56, 46, 
             133}, {103, 45, 56, 112}, {128, 44, 45, 103}, {102, 53, 43, 
             127}, {119, 58, 68, 140}, {135, 66, 65, 121}}]}]}, 
         {RGBColor[
          0.7309965087396967, 0.1765591713204274, 0.17815515395709364`], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{126, 57, 140}, {120, 54, 134}, {118, 57, 126}, {127, 
             54, 102}, {133, 57, 118}, {102, 54, 120}, {119, 57, 117}, {101, 
             54, 127}, {140, 57, 119}, {117, 57, 133}}], 
            PolygonBox[{{104, 103, 112, 113}, {129, 128, 103, 104}, {136, 135,
              121, 122}, {113, 112, 135, 136}}], 
            PolygonBox[{{122, 121, 134, 54, 108}, {108, 54, 101, 128, 
             129}}]}]}, 
         {RGBColor[
          0.8442788421197968, 0.28905978555149797`, 0.29331210510950034`], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{123, 122, 108, 109}, {105, 104, 113, 114}, {114, 113, 
            136, 137}, {137, 136, 122, 123}, {130, 129, 104, 105}, {109, 108, 
            129, 130}}]]}, 
         {RGBColor[
          0.8947142599239453, 0.47567624885732696`, 0.4832176087268879], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{124, 123, 109, 110}, {138, 137, 123, 124}, {131, 130, 
            105, 106}, {115, 114, 137, 138}, {106, 105, 114, 115}, {110, 109, 
            130, 131}}]]}, 
         {RGBColor[
          0.9395979805199719, 0.7144308626988547, 0.7225095372394578], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{139, 138, 124, 125}, {125, 124, 110, 111}, {132, 131, 
            106, 107}, {116, 115, 138, 139}, {107, 106, 115, 116}, {111, 110, 
            131, 132}}]]}, 
         {RGBColor[1., 1., 1.], EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{116, 55, 107}, {111, 55, 125}, {125, 55, 139}, {107, 
            55, 132}, {132, 55, 111}, {139, 55, 116}}]]}}, {{}, 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{132, 111, 125, 139, 116, 107, 132}]},
           "0.25`"],
          Annotation[#, 0.25, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{131, 110, 124, 138, 115, 106, 131}]},
           "0.2`"],
          Annotation[#, 0.2, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{130, 109, 123, 137, 114, 105, 130}]},
           "0.15`"],
          Annotation[#, 0.15, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{129, 108, 122, 136, 113, 104, 129}]},
           "0.1`"],
          Annotation[#, 0.1, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{127, 102, 120, 134, 121, 135, 112, 103, 128, 101, 127}], 
            LineBox[{133, 118, 126, 140, 119, 117, 133}]},
           "0.05`"],
          Annotation[#, 0.05, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], LineBox[{2, 12, 11}], 
            LineBox[{8, 19, 30}], LineBox[{71, 82, 93}], 
            LineBox[{90, 89, 99}]},
           "0"],
          Annotation[#, 0, "Tooltip"]& ], {}, {}}}],
      AspectRatio->1,
      Frame->True,
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {1368., -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {360.0000000000002, 291.2461179749811}], 
    InsetBox[
     GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJx1l3dUVEcbxvdyd++qiEoEYkMIIRTRaAwRwTKXpggqhiZKbCAJigpBTIgF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       "], {{{}, 
         {RGBColor[0.406332, 0.330678, 0.278141], EdgeForm[None], 
          GraphicsGroupBox[PolygonBox[{{232, 91, 233}}]]}, 
         {RGBColor[
          0.4963993652616862, 0.4044088903790155, 0.32186901670738755`], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{237, 92, 230}, {353, 100, 254}, {252, 100, 353}, {
             230, 92, 339}}], PolygonBox[{{339, 92, 232, 233, 234}}]}]}, 
         {RGBColor[
          0.6092855573152035, 0.4968197145151466, 0.37667565258273955`], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{255, 1, 101}, {249, 99, 350}, {240, 93, 235}, {207, 
             81, 208}, {234, 81, 339}, {105, 1, 255}, {350, 99, 251}, {235, 
             93, 340}}], PolygonBox[{{253, 252, 353, 354}}], 
            PolygonBox[{{340, 93, 237, 230, 231}, {231, 230, 339, 81, 207}, {
             354, 353, 254, 99, 249}}]}]}, 
         {RGBColor[
          0.6701637861275326, 0.5311637766245352, 0.3515907561426361], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{125, 10, 126}, {231, 82, 340}, {243, 96, 344}, {241, 
             95, 342}, {212, 82, 205}, {258, 2, 107}, {238, 94, 341}, {336, 
             90, 229}, {247, 98, 348}, {207, 82, 231}, {245, 97, 346}, {205, 
             82, 322}, {227, 90, 336}, {102, 2, 258}}], 
            PolygonBox[{{106, 105, 255, 256}, {344, 96, 95, 241}, {346, 97, 
             96, 243}, {250, 249, 350, 351}, {355, 354, 249, 250}, {342, 95, 
             94, 238}, {348, 98, 97, 245}}], 
            PolygonBox[{{229, 90, 253, 354, 355}, {341, 94, 240, 235, 236}, {
             322, 82, 207, 208, 209}, {236, 235, 340, 82, 212}, {256, 255, 
             101, 2, 102}, {351, 350, 251, 98, 247}}]}]}, 
         {RGBColor[
          0.7268954497742075, 0.5632751231793134, 0.32539698943857787`], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{212, 83, 236}, {123, 9, 271}, {333, 89, 226}, {210, 
             83, 323}, {215, 83, 210}, {261, 3, 111}, {209, 71, 322}, {191, 
             71, 192}, {236, 83, 341}, {122, 9, 123}, {272, 11, 104}, {355, 
             89, 229}, {224, 89, 333}, {250, 89, 355}, {131, 11, 272}, {108, 
             3, 261}}], 
            PolygonBox[{{347, 346, 243, 244}, {257, 256, 102, 103}, {343, 342,
              238, 239}, {246, 245, 346, 347}, {349, 348, 245, 246}, {352, 
             351, 247, 248}, {228, 227, 336, 337}, {248, 247, 348, 349}, {103,
              102, 258, 259}, {242, 241, 342, 343}, {244, 243, 344, 345}, {
             345, 344, 241, 242}}], 
            PolygonBox[{{271, 9, 125, 126, 127}, {259, 258, 107, 3, 108}, {
             104, 11, 106, 256, 257}, {239, 238, 341, 83, 215}, {206, 205, 
             322, 71, 191}, {323, 83, 212, 205, 206}, {337, 336, 229, 89, 
             224}, {226, 89, 250, 351, 352}}]}]}, 
         {RGBColor[
          0.7756759353448892, 0.6154800829978647, 0.3505759039060826], 
          EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtkMsKQVEUhvdxl1uJmZIHUQohE8k1KZkwcinJzOUJDDwIL0CZkplIMvAC
SpKhb3fW4Ov/zjp/Z+91Yu1+sWdRSkXBCgcoQMJQakjawY3fyApk8B2ZhRO0
eK6RTxiADZzM5qQXgvhPmR3djUAYX8AIHOBh1pG+gc/IECzhBSWoMr+Iv+S7
ut+DsT4TfMzuugs5fKXMs/SZb7IMdfwrnSb+kLvl8at00vhH9m3gE9IFfsPc
We+exPfiW/lf+r8dZQd9ty6sIQ4bmMpeAd6fZZcU/gcX9iZl
             "]], 
            PolygonBox[{{325, 85, 84, 213}, {269, 7, 8, 120}, {192, 61, 72, 
             191}, {260, 259, 108, 109}, {225, 224, 333, 334}, {338, 337, 224,
              225}, {345, 85, 86, 244}, {265, 5, 6, 116}, {347, 86, 87, 
             246}, {349, 87, 88, 248}, {327, 86, 85, 216}, {331, 88, 87, 
             220}, {263, 4, 5, 113}, {329, 87, 86, 218}, {190, 72, 61, 176}, {
             109, 108, 261, 262}, {343, 84, 85, 242}, {267, 6, 7, 118}}], 
            PolygonBox[{{211, 210, 323, 72, 194}, {270, 8, 122, 123, 124}, {
             262, 261, 111, 4, 112}, {130, 21, 131, 272, 273}, {204, 80, 228, 
             337, 338}, {124, 123, 271, 20, 128}, {110, 12, 103, 259, 260}, {
             273, 272, 104, 12, 129}, {334, 333, 226, 88, 222}, {324, 84, 215,
              210, 211}}]}]}, 
         {RGBColor[0.8252919492679385, 0.676616664709686, 0.3990379843537595],
           EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtz88KQVEQx/G5yO7e8icbubJRygNYWUlZqfsI9v6UDWWBsLLBA8gTULYo
siE7T+BNfKczi0/n1zTnnJlSpx/1YiJSQBwJT8Tn7GGENHxqdbTJb8yQQ4ra
1nJIfonr0d6znjjiixYa1Gtokq9YIdD71Bbi/s2SN/oe9pgig4n1af8QXevX
eX/2b+S5Pu0PyFVUyAcM7K+k5+bWmec42Zw3lKkXOXdY2+55amPLWnvaLnc8
LOt+F3F76X6hvb+0mXS2D/4CvR+6
             "]], PolygonBox[CompressedData["
1:eJwtkLtqgkEQhWclRE3UQq0MKDYBIZ29nXdR8BHSqyi5lalShuQRLK2MpBf0
HRSNRl/F77BbfOz55585e2aLj6P+MGJmObiCrDNLcqbgA1bQhAr8qs7/DGca
3uDa+V7NDOAMJ2hT78AB/Qd1dAP+0Ud5oluwR++giq7BDF2GEjzw/Wn+vjx8
m/eQl2Y0e+d8FvWoV57y1p26ewJjiFO7gR50nc+orF/BW/Pv5jMruzIqawwd
dd5DXsvwFnqTNUxD1gLc0/fM+QS36ERA+oXaq/kdtesGvYV58NPO2l0ZlVUe
8lqEf+r5gQtXYyqP
             "]], 
            PolygonBox[{{202, 79, 225, 334, 335}, {119, 118, 269, 18, 121}, {
             133, 22, 129, 274, 275}, {189, 70, 203, 320, 321}, {214, 213, 
             324, 73, 196}, {115, 14, 112, 263, 264}, {321, 320, 204, 79, 
             201}, {285, 284, 130, 22, 146}, {147, 31, 148, 284, 285}, {275, 
             274, 110, 13, 132}}]}]}, 
         {RGBColor[
          0.8779461966682878, 0.7702313216008748, 0.5321646894523593], 
          EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtkbtKg0EQhXdjIyGgYpGLBGKToMZCCRYxEiwUMV7AR/ABFAwi6RXUgGJE
OwuttFFQ0iRYCEYTH0AQkbyK37Cn+JjD+XfmPzs7vr27tRNxzk3AAPRhAza9
c1mYRN/CAYxADG8RltCv8AJleIMMfpx6DIcu6FG8HGTQ1/AOq/ANVzpjffvU
YYiiz6hpGPOh384cmac5l9ByIcMc3oXOW19dOVP4J9QhSKBPNT+J7qnX7nGu
3htouDDf/rOn3kEfdmE7+YKa5ts+HqAAT8phM9vQgQoU8X6pa3Zn9If0PHoG
SuhH+IN1+4b3KV1CN7XbZ+jqXRZ82J3tcBmd9yGDZZlCz1LvldvyV+FHeVbw
pvWmd/APfLousQ==
             "]], PolygonBox[CompressedData["
1:eJwt0D1qQkEQwPHdYCWBKMRPELQxYrQwvCo+sRN5fhQewQMoCF5BIVZiLRor
sQkkeABR4xlCEK/if9gpfuwsszuzs7n+sDd4MMakEcIKBWQwx6M1JsoawRhh
6+InjHBAHQFOqJHvsnZwgW9d3MYvdvBQRJncUe9KjT0WyGo+T37KOkGcOIFP
zUmNEvsvjeX+D6rW9WrhjHfrYukhvWLsn62rKbWT1s0iM32gqeelxr+s+n6Z
6YaUzi9/MsO39vZ0tqX+nfzhWkn8hlfuBvo+qXlFw7q3Sc8/bPWsjwq5jc4r
f/LC/g49WyX/
             "]], 
            PolygonBox[{{187, 69, 201, 318, 319}, {287, 286, 133, 23, 149}, {
             279, 278, 115, 15, 137}, {282, 17, 121, 140, 141}, {136, 23, 132,
              276, 277}, {313, 312, 189, 69, 186}, {150, 32, 146, 286, 287}, {
             141, 140, 283, 29, 143}, {319, 318, 202, 78, 200}, {174, 60, 188,
              312, 313}}]}]}, 
         {RGBColor[0.9241940904813651, 0.8627805421039715, 0.690751031958014],
           EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtkNtKAlEUhvfkM0TNGMTkxIhDodVc5AHz8AQ+gg+gj5EHxCsti0DqohD0
QjArL6XssfwWe118/N8sZq+19vab7UbrwBgTQALu4RgOHWNCiPBXuFR/gymE
8AKRY11qWbxAzvW89OnABR6TM8jgOfIdTnGfHMMQTmAAZep1cgM/xva8dex5
6bPUb6kvYAV3sFXE8zJHZ33ADmpQovZvbH+Z80tWZAb+R1ahiD+TSTjH07rn
I0zAhRS1HunJe+Gf2ucKHxn7v9yvr31cx95N7ujhX7rPDd7Vnkf4g77/Gf6t
e8b4Wne7xp90boDvAUexJ9A=
             "]], PolygonBox[CompressedData["
1:eJwtkEtOQkEURLuNewDUCaJ5BoIR8E0EEvysgCW4AF2GQQfOTOTjQAaQmDgg
/DagsixPpWtwcru7uuvW7fL9Y/9hL4RwBPtwFUPoUa/hByaQWX+FD+8bUOXu
CRywPoQRfEEONThH68It6zvYwdxv5VFD68BNSHf+4DQmL/UbQzumLLrzC29Q
tn+GlsfkrfdbWLi/ZlhBAb1ELcITLK3lzjp2r8yzldxfMz2rxqTr7AUq9pM+
hKmzKNMZWtN5e+7V8nw6W8NxTFnk8Q4z/0cbLtC+vdZZg/2l/08eG/h0P+Wv
y8v/L78B/APxHyTY
             "]], 
            PolygonBox[{{152, 33, 149, 288, 289}, {289, 288, 136, 24, 151}, {
             311, 310, 187, 68, 185}, {173, 59, 186, 310, 311}}]}]}, 
         {RGBColor[
          0.9588005202119156, 0.9533936784875723, 0.8956019851178866], 
          EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtkEkOwjAMRRO4BpumLUKoQMXQAMfgCBwAjsOobliwQOwQw+14Vv7iyT+x
nW8n2+43u45zrgddqCBCA1foQ+mdmxAL0y7pNazgBDkEai7KF+iD3UHmU631
1PBTb/TpXMrjJc8p92/NMEN/iEuYo7/yXKDPmidHj33qfZiH3r3DSL1RPrXm
CMrZrgOf4k11lXKt5rI/GPqkW3k0mjdqt6f2tHeP6g/6lz8dnxpE
             "]], 
            PolygonBox[{{303, 57, 56, 172}, {163, 44, 54, 302}, {166, 47, 57, 
             303}, {297, 35, 36, 164}, {307, 55, 56, 183}, {173, 58, 48, 
             304}, {152, 34, 44, 296}, {309, 57, 58, 185}, {292, 37, 36, 
             154}, {306, 54, 55, 182}, {293, 38, 37, 155}, {308, 56, 57, 
             184}, {290, 35, 34, 151}, {165, 45, 35, 297}, {167, 48, 38, 
             298}, {291, 36, 35, 153}, {164, 36, 47, 166}, {172, 56, 45, 
             165}}]}]}, 
         {RGBColor[0.976303, 0.999222, 0.999207], EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{166, 46, 164}, {164, 46, 297}, {297, 46, 165}, {172, 
            46, 303}, {303, 46, 166}, {165, 46, 172}}]]}}, {{}, 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{297, 165, 172, 303, 166, 164, 297}]},
           "1"],
          Annotation[#, 1, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{289, 152, 296, 163, 302, 171, 180, 306, 182, 307, 183, 
             308, 184, 309, 185, 311, 173, 304, 167, 298, 158, 156, 293, 155, 
             292, 154, 291, 153, 290, 151, 289}]},
           "0.98`"],
          Annotation[#, 0.98, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{277, 136, 288, 149, 287, 150, 295, 162, 301, 170, 178, 
             181, 195, 314, 197, 315, 198, 316, 199, 317, 200, 319, 187, 310, 
             186, 313, 174, 305, 168, 299, 160, 157, 143, 141, 282, 139, 281, 
             138, 280, 137, 279, 135, 277}]},
           "0.96`"],
          Annotation[#, 0.96, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{159, 145, 142, 283, 140, 121, 119, 268, 117, 266, 114, 
             264, 115, 278, 134, 276, 132, 275, 133, 286, 146, 285, 147, 294, 
             161, 300, 169, 175, 179, 193, 196, 214, 326, 217, 328, 219, 330, 
             221, 332, 223, 335, 202, 318, 201, 321, 189, 312, 188}]},
           "0.94`"],
          Annotation[#, 0.94, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{144, 128, 124, 270, 120, 269, 118, 267, 116, 265, 113, 
             263, 112, 262, 109, 260, 110, 274, 129, 273, 130, 284, 148}], 
            LineBox[{177, 176, 190, 194, 211, 324, 213, 325, 216, 327, 218, 
             329, 220, 331, 222, 334, 225, 338, 204, 320, 203}]},
           "0.92`"],
          Annotation[#, 0.92, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{111, 261, 108, 259, 103, 257, 104, 272, 131}], 
            LineBox[{122, 123, 271, 127}], 
            LineBox[{192, 191, 206, 323, 210, 215, 239, 343, 242, 345, 244, 
             347, 246, 349, 248, 352, 226, 333, 224, 337, 228}]},
           "0.9`"],
          Annotation[#, 0.9, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], LineBox[{106, 256, 102, 258, 107}], 
            LineBox[{126, 125}], 
            LineBox[{209, 322, 205, 212, 236, 341, 238, 342, 241, 344, 243, 
             346, 245, 348, 247, 351, 250, 355, 229, 336, 227}]},
           "0.88`"],
          Annotation[#, 0.88, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], LineBox[{101, 255, 105}], 
            LineBox[{208, 207, 231, 340, 235, 240}], 
            LineBox[{251, 350, 249, 354, 253}]},
           "0.86`"],
          Annotation[#, 0.86, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], LineBox[{237, 230, 339, 234}], 
            LineBox[{254, 353, 252}]},
           "0.84`"],
          Annotation[#, 0.84, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], LineBox[{233, 232}]},
           "0.82`"],
          Annotation[#, 0.82, "Tooltip"]& ], {}, {}, {}}}],
      AspectRatio->1,
      Frame->True,
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {1758.8571428571427`, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {360.0000000000002, 291.2461179749811}], 
    InsetBox[
     GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJx1lws01Gkfx4d1GUqbopTqjd5y21q57aLeZ3IrSpG0SmvdapFbFyRd7NYW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       "], {{{}, 
         {RGBColor[0., 0.11680400311621675`, 0.01976161716457023], EdgeForm[
          None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFk8suQ1EUhjdVrWupMlG3SS9mqh25jVAmOFqXuleRGLRPIPEOBuIRvAKJ
oYiICEOPwNAQ8a+crzH40u6197r8a60zUq551UbnXEUERLtoEGZLiH4RFykx
IAZFEpud30SfOBa7YlUURBXfM/EuhkVNTIoxkRHTYlxkxTn5LsSoGMLH7tLY
1kVZHJDH8u2IeeGJFZHnzuP/FHmWRElsin1RFGtwgG2TPhwSa1tsEWuHs2nb
I3cRPzsvci6gLUnPTEMvPZoTE/TgU+TElYiJFtFKjVbrMnELxPXQmce2QE57
N0vsBbTO0IM8tm30ePQ+QX02ny7RLXpEmDri2KLMOMr9IL8x7ptFCG1tzt8d
ixfkrtP5O9VETVk0R/GzfB3O3zV7F+Gt+W8whzIaCmgKkiNCDXF01OsbINci
fo3kqO91O7VWmHeJPBucv+n/vfiitzfUFUGT1bSOTwCb5Rin/1NoneE8wXxm
qS/l/r+hJPOwfbcdT0OWeHafYW7NaO7ibY53H+S4dv6uDRPvijeX1GT7ME+s
SXym6ZPdnaDlxfn77tHz+h5Yvaf04VUcoftZPNEPa/KD87+rHzQv09NH+vbr
/G9ujbPtXIwZhshnOsPYosysD313zPdW/AHNIky6
             "]], 
            PolygonBox[CompressedData["
1:eJwt0L0OAUEUhuFZUS620mhoFLotVAqVRiORrJ9WgkRk9wokXIOEa5C4AhIl
IohQugRKJeKd+Ions5lz9jszk+tE9TBmjEkjjjMSSKKPLWpoI+YY82VtooE9
Vqio540dAlSxwUe9gWo2w2a1cIRx/t8284C1/i1jiStS8DDERWezewOMkEEe
Y0xQQBZ3TFXzMUOkmr3vTZmeMkLNtLOLeGKBku74UoavvQfm6i1o9gmu3rCL
nma5qv0ANikmjA==
             "]]}]}, 
         {RGBColor[0., 0.35041338814491924`, 0.05928508476691443], EdgeForm[
          None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwt0DELQVEYxvHj+hBKljuYLGaTwaYMPoKiFPeWzUDu/QAWxTdQZLApZFBY
WLCxmcSiLIryP/UMv87bGc7zvMct+UXPMcYkEMUJLnwESGGAMmI4YI08lngi
iwlqiOOIDwrYYK/ZiRjz4sxhhq/mOW7KCnFVhwamen+sDDsvUFdWEw+k0cdK
3XY4q3MVHSTRQltzF3dkMISnN+0eb92PcFG3QDvYXbbKsFk/ZdsOPf2Rza3g
DwxILBc=
             "]], PolygonBox[CompressedData["
1:eJwt0L8KQWEYx/Fz5Boo2xlMljObDDZlcAkGRJ1TNgPJBZyFa1A2m0JG+VP+
xMYNyKQsSvg++Q2fU2/v8z6/5zxeOSwFMcdxEohjiw0++KIJD0mcMUEeRbww
gI8sbljqzmreCPU+gwtaSCGNDmqo4oAj5igghzEi1frKGinLznfssVMP69VT
lmVeUdHsdj4pw7LqaGCqWa3nEzNl2wwL9JVlM3QxVK29eWhHtqsV1mir1v4x
gOva579T2+0P9AIt/g==
             "]], 
            PolygonBox[{{154, 153, 151, 43, 227}, {170, 64, 236, 153, 154}, {
             107, 106, 210, 26, 109}, {201, 200, 253, 75, 194}, {197, 78, 204,
              256, 257}, {105, 23, 101, 206, 207}}]}]}, 
         {RGBColor[
          0.09222427417582411, 0.5200768994302103, 0.08571018471724051], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{109, 25, 107}, {207, 24, 105}, {107, 25, 209}, {203, 
             77, 257}, {117, 25, 218}, {191, 76, 245}, {195, 77, 246}, {194, 
             76, 201}, {104, 24, 207}, {201, 76, 255}, {257, 77, 197}, {112, 
             24, 215}}], 
            PolygonBox[{{209, 25, 24, 104}, {167, 166, 241, 242}, {255, 76, 
             77, 203}, {177, 176, 170, 171}, {215, 24, 25, 117}, {122, 121, 
             126, 127}, {115, 114, 212, 213}, {171, 170, 154, 155}, {246, 77, 
             76, 191}, {221, 220, 114, 115}, {155, 154, 227, 228}, {127, 126, 
             142, 143}, {242, 241, 183, 184}, {149, 148, 233, 234}, {234, 233,
              166, 167}, {184, 183, 249, 250}, {189, 188, 176, 177}, {131, 
             130, 220, 221}, {228, 227, 130, 131}, {143, 142, 148, 149}}], 
            PolygonBox[{{218, 25, 109, 121, 122}, {250, 249, 197, 77, 195}, {
             245, 76, 194, 188, 189}, {213, 212, 105, 24, 112}}]}]}, 
         {RGBColor[
          0.24484456400354448`, 0.6478634100451761, 0.10355739967150383`], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{189, 65, 245}, {155, 54, 171}, {127, 36, 122}, {228, 
             54, 155}, {177, 65, 189}, {122, 36, 218}, {123, 36, 138}, {144, 
             47, 162}, {157, 54, 152}, {234, 47, 149}, {149, 47, 143}, {180, 
             65, 173}}], 
            PolygonBox[{{113, 112, 215, 216}, {243, 242, 184, 185}, {143, 47, 
             36, 127}, {216, 215, 117, 118}, {168, 167, 242, 243}, {132, 131, 
             221, 222}, {247, 246, 191, 192}, {214, 213, 112, 113}, {251, 250,
              195, 196}, {196, 195, 246, 247}, {185, 184, 250, 251}, {222, 
             221, 115, 116}, {171, 54, 65, 177}, {138, 36, 47, 144}, {116, 
             115, 213, 214}, {173, 65, 54, 157}}], 
            PolygonBox[{{152, 54, 228, 131, 132}, {192, 191, 245, 65, 180}, {
             118, 117, 218, 36, 123}, {162, 47, 234, 167, 168}}]}]}, 
         {RGBColor[
          0.43683574495762023`, 0.7395972821080934, 0.12260909770145559`], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{223, 34, 120}, {214, 34, 116}, {251, 67, 185}, {168, 
             57, 162}, {243, 57, 168}, {196, 67, 251}, {113, 34, 214}, {222, 
             44, 132}, {238, 67, 182}, {231, 57, 163}, {132, 44, 152}, {229, 
             44, 135}}], 
            PolygonBox[{{248, 247, 192, 193}, {163, 57, 67, 238}, {174, 173, 
             157, 158}, {217, 216, 118, 119}, {119, 118, 123, 124}, {116, 34, 
             44, 222}, {139, 138, 144, 145}, {135, 44, 34, 223}, {193, 192, 
             180, 181}, {124, 123, 138, 139}, {181, 180, 173, 174}, {185, 67, 
             57, 243}}], 
            PolygonBox[{{158, 157, 152, 44, 229}, {120, 34, 113, 216, 217}, {
             145, 144, 162, 57, 231}, {182, 67, 196, 247, 248}}]}]}, 
         {RGBColor[
          0.6450216025863075, 0.8165013952320211, 0.14215624334289814`], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{133, 35, 226}, {124, 35, 119}, {181, 66, 193}, {248, 
             66, 182}, {178, 66, 237}, {217, 35, 120}, {119, 35, 217}, {193, 
             66, 248}}], 
            PolygonBox[{{175, 174, 158, 159}, {136, 135, 223, 224}, {140, 139,
              145, 146}, {164, 163, 238, 239}, {146, 145, 231, 232}, {230, 
             229, 135, 136}, {232, 231, 163, 164}, {159, 158, 229, 230}}], 
            PolygonBox[{{224, 223, 120, 35, 133}, {237, 66, 181, 174, 175}, {
             226, 35, 124, 139, 140}, {239, 238, 182, 66, 178}}]}]}, 
         {RGBColor[
          0.8194840801848683, 0.8967027263851366, 0.18208697092290813`], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{159, 55, 175}, {232, 46, 146}, {230, 55, 159}, {140, 
             46, 226}, {175, 55, 237}, {146, 46, 140}, {141, 46, 160}, {161, 
             55, 156}}], 
            PolygonBox[{{225, 224, 133, 134}, {165, 164, 239, 240}, {240, 239,
              178, 179}, {137, 136, 224, 225}}], 
            PolygonBox[{{156, 55, 230, 136, 137}, {160, 46, 232, 164, 165}, {
             179, 178, 237, 55, 161}, {134, 133, 226, 46, 141}}]}]}, 
         {RGBColor[
          0.9861807835877694, 0.9776633364321725, 0.2267116020942022], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{179, 56, 240}, {137, 45, 156}, {225, 45, 137}, {165, 
             56, 160}, {161, 56, 179}, {141, 45, 134}, {134, 45, 225}, {240, 
             56, 165}}], 
            PolygonBox[{{156, 45, 56, 161}, {160, 56, 45, 141}}]}]}}, {{}, 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{225, 137, 156, 161, 179, 240, 165, 160, 141, 134, 225}]},
           
           "0.14`"],
          Annotation[#, 0.14, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{224, 136, 230, 159, 175, 237, 178, 239, 164, 232, 146, 
             140, 226, 133, 224}]},
           "0.12`"],
          Annotation[#, 0.12, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{217, 120, 223, 135, 229, 158, 174, 181, 193, 248, 182, 
             238, 163, 231, 145, 139, 124, 119, 217}]},
           "0.1`"],
          Annotation[#, 0.1, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{214, 116, 222, 132, 152, 157, 173, 180, 192, 247, 196, 
             251, 185, 243, 168, 162, 144, 138, 123, 118, 216, 113, 214}]},
           "0.08`"],
          Annotation[#, 0.08, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{213, 115, 221, 131, 228, 155, 171, 177, 189, 245, 191, 
             246, 195, 250, 184, 242, 167, 234, 149, 143, 127, 122, 218, 117, 
             215, 112, 213}]},
           "0.06`"],
          Annotation[#, 0.06, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{207, 105, 212, 114, 220, 130, 227, 154, 170, 176, 188, 
             194, 201, 255, 203, 257, 197, 249, 183, 241, 166, 233, 148, 142, 
             126, 121, 109, 107, 209, 104, 207}]},
           "0.04`"],
          Annotation[#, 0.04, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{205, 102, 211, 111, 219, 129, 151, 153, 236, 172, 187, 
             190, 199, 253, 200, 254, 202, 256, 204, 258, 198, 252, 186, 244, 
             169, 235, 150, 147, 128, 125, 110, 108, 210, 106, 208, 103, 206, 
             101, 205}]},
           "0.02`"],
          Annotation[#, 0.02, "Tooltip"]& ], {}, {}, {}}}],
      AspectRatio->1,
      Frame->True,
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {2149.7142857142853`, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {359.9999999999998, 291.2461179749811}]}, {}},
  ContentSelectable->True,
  ImageSize->{1107., Automatic},
  PlotRangePadding->{6, 5}]], "Print",
 CellChangeTimes->{{3.46077531487983*^9, 3.46077533113482*^9}, {
   3.460775919496517*^9, 3.460775942214324*^9}, 3.460775994480899*^9, {
   3.460776028742775*^9, 3.460776037026099*^9}, {3.4607909115414753`*^9, 
   3.460790939198042*^9}, {3.460791053541448*^9, 3.460791071088228*^9}, {
   3.460791192918942*^9, 3.46079120390362*^9}, {3.460791447076001*^9, 
   3.460791466900754*^9}, {3.460791545064044*^9, 3.460791570966239*^9}, {
   3.4607934191606007`*^9, 3.460793427137341*^9}, 3.460793490363347*^9, 
   3.460793537533045*^9, 3.460793587457892*^9, {3.460793643757728*^9, 
   3.46079365135855*^9}, {3.460793702770844*^9, 3.46079371762854*^9}, 
   3.4607943489406967`*^9, 3.460794468535598*^9, 3.460794537100586*^9, 
   3.460794606771035*^9, 3.460794647393282*^9, {3.460794683955057*^9, 
   3.460794711541408*^9}, 3.460794743655837*^9, 3.460794821407819*^9, 
   3.460794992687716*^9, {3.460795378587594*^9, 3.460795400763129*^9}, {
   3.460795899873049*^9, 3.460795915454596*^9}, 3.460795960670557*^9, {
   3.460796100655994*^9, 3.460796117353046*^9}, 3.4607962732165003`*^9, 
   3.460800162597351*^9, 3.4608005903774033`*^9, 3.4608019104755707`*^9, {
   3.46080194694875*^9, 3.460801958372828*^9}, {3.460802135395547*^9, 
   3.4608021584324636`*^9}, 3.460802633868291*^9, 3.4608026916143503`*^9, 
   3.460802782534809*^9, {3.460802813107704*^9, 3.460802851003825*^9}, 
   3.460802899121167*^9, {3.460802965047092*^9, 3.460802992739612*^9}, 
   3.460803080117352*^9, 3.4608031238206177`*^9, 3.460803181520192*^9, {
   3.46080323306312*^9, 3.460803259377411*^9}, 3.46080331972618*^9, 
   3.460803380089603*^9, 3.460803500590083*^9, 3.460803634249275*^9, 
   3.460803695867539*^9, 3.460803733168754*^9, 3.4608037682069407`*^9, 
   3.460803808306548*^9, {3.460805796883609*^9, 3.4608058124874477`*^9}, {
   3.460805967269699*^9, 3.460805988517199*^9}, 3.460806043311208*^9, {
   3.4608061104368067`*^9, 3.460806138574252*^9}, {3.460806255006837*^9, 
   3.460806283974195*^9}, 3.460806807263606*^9, {3.460808401910928*^9, 
   3.460808427928109*^9}, {3.460808490273144*^9, 3.4608085097819967`*^9}, 
   3.460808560412644*^9, {3.460808595578998*^9, 3.4608086131948977`*^9}, 
   3.46080866666626*^9, {3.460808755444212*^9, 3.460808819650992*^9}, 
   3.460808864264059*^9, 3.460809006604796*^9, {3.4608090811854763`*^9, 
   3.460809104912641*^9}, {3.460809151929467*^9, 3.460809168752171*^9}, 
   3.4608093860076733`*^9, 3.460809454988336*^9, 3.460809522864664*^9, 
   3.460809555813641*^9, 3.460809599993239*^9, 3.460809658263152*^9, 
   3.460809722507944*^9, {3.460810854015986*^9, 3.460810866689756*^9}, 
   3.4608109498397627`*^9, 3.4608110282394238`*^9, 3.4608110721071033`*^9, 
   3.460816353080124*^9, 3.4608164602305193`*^9, 3.460816634258309*^9, 
   3.460816731670138*^9, 3.4608168084797297`*^9, 3.460816894874284*^9, 
   3.46085946451213*^9, 3.4608595234315767`*^9, 3.460859577166404*^9, 
   3.460859610229175*^9, 3.460859640820545*^9, 3.460859671884251*^9, 
   3.460861034459901*^9, 3.46086107767255*^9, 3.460861174298973*^9, 
   3.46086120538374*^9, 3.460861251291684*^9, 3.460861323178865*^9, {
   3.46086138754945*^9, 3.4608614004495792`*^9}, 3.4608614320313396`*^9, 
   3.460861481320551*^9, 3.4608616211310663`*^9, {3.460861765223168*^9, 
   3.460861786281537*^9}, 3.4608618357668753`*^9, 3.460861918091242*^9, 
   3.460862023167821*^9, {3.460864061052595*^9, 3.460864090834353*^9}, 
   3.460864265960928*^9, {3.4608645935059767`*^9, 3.460864677184669*^9}, 
   3.4608647145529547`*^9, 3.4608928884220953`*^9, {3.460892927185437*^9, 
   3.460892978487932*^9}, {3.460893064002185*^9, 3.46089311369724*^9}, {
   3.460893196424436*^9, 3.460893220994563*^9}, 3.460893259107436*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"-", "2.7909679313503135`"}]], "Output",
 CellChangeTimes->{
  3.460774172693623*^9, 3.4607742141360817`*^9, 3.460774259371611*^9, {
   3.460774303149437*^9, 3.460774333742992*^9}, {3.460774503977763*^9, 
   3.460774525387253*^9}, 3.460774568669429*^9, {3.4607746433678713`*^9, 
   3.460774749289826*^9}, 3.4607747872637367`*^9, {3.4607752069957323`*^9, 
   3.4607753311834*^9}, {3.4607759195524397`*^9, 3.4607759422690763`*^9}, 
   3.460775994534586*^9, {3.460776028795376*^9, 3.460776037081739*^9}, {
   3.460790911595224*^9, 3.460790939253276*^9}, {3.460791053594666*^9, 
   3.460791071141541*^9}, {3.460791192973082*^9, 3.460791203957177*^9}, {
   3.4607914471303043`*^9, 3.460791466955147*^9}, {3.460791545117042*^9, 
   3.460791571021545*^9}, {3.460793419216103*^9, 3.460793427190727*^9}, 
   3.4607934904166403`*^9, 3.460793537586506*^9, 3.4607935875115547`*^9, {
   3.460793643816039*^9, 3.460793651412258*^9}, {3.4607937028316803`*^9, 
   3.460793717693026*^9}, 3.460794349054253*^9, 3.460794468602188*^9, 
   3.460794537146944*^9, 3.460794606820025*^9, 3.460794647441045*^9, {
   3.460794683999979*^9, 3.460794711587779*^9}, 3.4607947437033663`*^9, 
   3.460794821453476*^9, 3.460794992763452*^9, {3.46079537866004*^9, 
   3.4607954008420343`*^9}, {3.460795899955226*^9, 3.460795915535334*^9}, 
   3.4607959607567463`*^9, {3.460796100730474*^9, 3.460796117431126*^9}, 
   3.460796273298979*^9, 3.46080016267494*^9, 3.46080059045927*^9, 
   3.46080191058669*^9, {3.460801947033931*^9, 3.4608019584551563`*^9}, {
   3.460802135491241*^9, 3.4608021585180397`*^9}, 3.460802633967609*^9, 
   3.460802693048126*^9, 3.460802784188271*^9, {3.46080281423518*^9, 
   3.460802852551197*^9}, 3.460802900679997*^9, {3.460802966464355*^9, 
   3.460802994747815*^9}, 3.460803081703266*^9, 3.460803125487102*^9, 
   3.460803183227213*^9, {3.460803234859148*^9, 3.4608032609697237`*^9}, 
   3.4608033212142887`*^9, 3.460803381478054*^9, 3.4608035021140633`*^9, 
   3.460803635652215*^9, 3.460803697315674*^9, 3.4608037348572693`*^9, 
   3.460803769573984*^9, 3.460803809928953*^9, {3.4608057984622173`*^9, 
   3.460805813824176*^9}, {3.460805968711471*^9, 3.4608059901127863`*^9}, 
   3.460806044738928*^9, {3.460806111860417*^9, 3.460806138661484*^9}, {
   3.4608062551082487`*^9, 3.460806284064145*^9}, 3.460806807365871*^9, {
   3.46080840200484*^9, 3.460808428085409*^9}, {3.4608084903745604`*^9, 
   3.460808509880398*^9}, 3.4608085615495157`*^9, {3.460808596715098*^9, 
   3.460808614316525*^9}, 3.460808667778009*^9, {3.460808756743518*^9, 
   3.460808821361974*^9}, 3.460808866006637*^9, 3.460809008335636*^9, {
   3.4608090829662027`*^9, 3.460809106371428*^9}, {3.4608091533817453`*^9, 
   3.460809170247486*^9}, 3.460809387484213*^9, 3.4608094563846188`*^9, 
   3.4608095239938383`*^9, 3.460809556860118*^9, 3.460809601486121*^9, 
   3.460809659738999*^9, 3.4608097239935083`*^9, {3.46081085410987*^9, 
   3.4608108667828493`*^9}, 3.4608109499384403`*^9, 3.460811028337473*^9, 
   3.46081107221124*^9, 3.4608163531812773`*^9, 3.460816462080289*^9, 
   3.460816636079851*^9, 3.460816733529152*^9, 3.460816810327259*^9, 
   3.460816896707574*^9, 3.460859466583232*^9, 3.460859525199936*^9, 
   3.46085957856656*^9, 3.460859612027454*^9, 3.460859642696507*^9, 
   3.460859673379051*^9, 3.4608610359199123`*^9, 3.460861080130123*^9, 
   3.460861176214602*^9, 3.460861206909174*^9, 3.4608612527872066`*^9, 
   3.4608613245925083`*^9, {3.4608613893716373`*^9, 3.460861402077552*^9}, 
   3.460861433808834*^9, 3.460861482995883*^9, 3.460861622874538*^9, {
   3.460861766989231*^9, 3.460861788062501*^9}, 3.460861837558749*^9, 
   3.460861919837391*^9, 3.46086202490096*^9, {3.460864063005273*^9, 
   3.4608640925582657`*^9}, 3.4608642675973377`*^9, {3.460864595153369*^9, 
   3.460864678530854*^9}, 3.4608647161716623`*^9, 3.4608928885197763`*^9, {
   3.4608929272834787`*^9, 3.4608929785836067`*^9}, {3.460893064106246*^9, 
   3.460893113794902*^9}, {3.4608931965264177`*^9, 3.460893221096546*^9}, 
   3.460893259209321*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"cfac=\"\>", "\[InvisibleSpace]", "100.`"}],
  SequenceForm["cfac=", 100.],
  Editable->False]], "Print",
 CellChangeTimes->{{3.46077531487983*^9, 3.46077533113482*^9}, {
   3.460775919496517*^9, 3.460775942214324*^9}, 3.460775994480899*^9, {
   3.460776028742775*^9, 3.460776037026099*^9}, {3.4607909115414753`*^9, 
   3.460790939198042*^9}, {3.460791053541448*^9, 3.460791071088228*^9}, {
   3.460791192918942*^9, 3.46079120390362*^9}, {3.460791447076001*^9, 
   3.460791466900754*^9}, {3.460791545064044*^9, 3.460791570966239*^9}, {
   3.4607934191606007`*^9, 3.460793427137341*^9}, 3.460793490363347*^9, 
   3.460793537533045*^9, 3.460793587457892*^9, {3.460793643757728*^9, 
   3.46079365135855*^9}, {3.460793702770844*^9, 3.46079371762854*^9}, 
   3.4607943489406967`*^9, 3.460794468535598*^9, 3.460794537100586*^9, 
   3.460794606771035*^9, 3.460794647393282*^9, {3.460794683955057*^9, 
   3.460794711541408*^9}, 3.460794743655837*^9, 3.460794821407819*^9, 
   3.460794992687716*^9, {3.460795378587594*^9, 3.460795400763129*^9}, {
   3.460795899873049*^9, 3.460795915454596*^9}, 3.460795960670557*^9, {
   3.460796100655994*^9, 3.460796117353046*^9}, 3.4607962732165003`*^9, 
   3.460800162597351*^9, 3.4608005903774033`*^9, 3.4608019104755707`*^9, {
   3.46080194694875*^9, 3.460801958372828*^9}, {3.460802135395547*^9, 
   3.4608021584324636`*^9}, 3.460802633868291*^9, 3.4608026916143503`*^9, 
   3.460802782534809*^9, {3.460802813107704*^9, 3.460802851003825*^9}, 
   3.460802899121167*^9, {3.460802965047092*^9, 3.460802992739612*^9}, 
   3.460803080117352*^9, 3.4608031238206177`*^9, 3.460803181520192*^9, {
   3.46080323306312*^9, 3.460803259377411*^9}, 3.46080331972618*^9, 
   3.460803380089603*^9, 3.460803500590083*^9, 3.460803634249275*^9, 
   3.460803695867539*^9, 3.460803733168754*^9, 3.4608037682069407`*^9, 
   3.460803808306548*^9, {3.460805796883609*^9, 3.4608058124874477`*^9}, {
   3.460805967269699*^9, 3.460805988517199*^9}, 3.460806043311208*^9, {
   3.4608061104368067`*^9, 3.460806138574252*^9}, {3.460806255006837*^9, 
   3.460806283974195*^9}, 3.460806807263606*^9, {3.460808401910928*^9, 
   3.460808427928109*^9}, {3.460808490273144*^9, 3.4608085097819967`*^9}, 
   3.460808560412644*^9, {3.460808595578998*^9, 3.4608086131948977`*^9}, 
   3.46080866666626*^9, {3.460808755444212*^9, 3.460808819650992*^9}, 
   3.460808864264059*^9, 3.460809006604796*^9, {3.4608090811854763`*^9, 
   3.460809104912641*^9}, {3.460809151929467*^9, 3.460809168752171*^9}, 
   3.4608093860076733`*^9, 3.460809454988336*^9, 3.460809522864664*^9, 
   3.460809555813641*^9, 3.460809599993239*^9, 3.460809658263152*^9, 
   3.460809722507944*^9, {3.460810854015986*^9, 3.460810866689756*^9}, 
   3.4608109498397627`*^9, 3.4608110282394238`*^9, 3.4608110721071033`*^9, 
   3.460816353080124*^9, 3.4608164602305193`*^9, 3.460816634258309*^9, 
   3.460816731670138*^9, 3.4608168084797297`*^9, 3.460816894874284*^9, 
   3.46085946451213*^9, 3.4608595234315767`*^9, 3.460859577166404*^9, 
   3.460859610229175*^9, 3.460859640820545*^9, 3.460859671884251*^9, 
   3.460861034459901*^9, 3.46086107767255*^9, 3.460861174298973*^9, 
   3.46086120538374*^9, 3.460861251291684*^9, 3.460861323178865*^9, {
   3.46086138754945*^9, 3.4608614004495792`*^9}, 3.4608614320313396`*^9, 
   3.460861481320551*^9, 3.4608616211310663`*^9, {3.460861765223168*^9, 
   3.460861786281537*^9}, 3.4608618357668753`*^9, 3.460861918091242*^9, 
   3.460862023167821*^9, {3.460864061052595*^9, 3.460864090834353*^9}, 
   3.460864265960928*^9, {3.4608645935059767`*^9, 3.460864677184669*^9}, 
   3.4608647145529547`*^9, 3.4608928884220953`*^9, {3.460892927185437*^9, 
   3.460892978487932*^9}, {3.460893064002185*^9, 3.46089311369724*^9}, {
   3.460893196424436*^9, 3.460893220994563*^9}, 3.460893259217491*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"cfac=\"\>", "\[InvisibleSpace]", "0.01207583625166043`"}],
  SequenceForm["cfac=", 0.01207583625166043],
  Editable->False]], "Print",
 CellChangeTimes->{{3.46077531487983*^9, 3.46077533113482*^9}, {
   3.460775919496517*^9, 3.460775942214324*^9}, 3.460775994480899*^9, {
   3.460776028742775*^9, 3.460776037026099*^9}, {3.4607909115414753`*^9, 
   3.460790939198042*^9}, {3.460791053541448*^9, 3.460791071088228*^9}, {
   3.460791192918942*^9, 3.46079120390362*^9}, {3.460791447076001*^9, 
   3.460791466900754*^9}, {3.460791545064044*^9, 3.460791570966239*^9}, {
   3.4607934191606007`*^9, 3.460793427137341*^9}, 3.460793490363347*^9, 
   3.460793537533045*^9, 3.460793587457892*^9, {3.460793643757728*^9, 
   3.46079365135855*^9}, {3.460793702770844*^9, 3.46079371762854*^9}, 
   3.4607943489406967`*^9, 3.460794468535598*^9, 3.460794537100586*^9, 
   3.460794606771035*^9, 3.460794647393282*^9, {3.460794683955057*^9, 
   3.460794711541408*^9}, 3.460794743655837*^9, 3.460794821407819*^9, 
   3.460794992687716*^9, {3.460795378587594*^9, 3.460795400763129*^9}, {
   3.460795899873049*^9, 3.460795915454596*^9}, 3.460795960670557*^9, {
   3.460796100655994*^9, 3.460796117353046*^9}, 3.4607962732165003`*^9, 
   3.460800162597351*^9, 3.4608005903774033`*^9, 3.4608019104755707`*^9, {
   3.46080194694875*^9, 3.460801958372828*^9}, {3.460802135395547*^9, 
   3.4608021584324636`*^9}, 3.460802633868291*^9, 3.4608026916143503`*^9, 
   3.460802782534809*^9, {3.460802813107704*^9, 3.460802851003825*^9}, 
   3.460802899121167*^9, {3.460802965047092*^9, 3.460802992739612*^9}, 
   3.460803080117352*^9, 3.4608031238206177`*^9, 3.460803181520192*^9, {
   3.46080323306312*^9, 3.460803259377411*^9}, 3.46080331972618*^9, 
   3.460803380089603*^9, 3.460803500590083*^9, 3.460803634249275*^9, 
   3.460803695867539*^9, 3.460803733168754*^9, 3.4608037682069407`*^9, 
   3.460803808306548*^9, {3.460805796883609*^9, 3.4608058124874477`*^9}, {
   3.460805967269699*^9, 3.460805988517199*^9}, 3.460806043311208*^9, {
   3.4608061104368067`*^9, 3.460806138574252*^9}, {3.460806255006837*^9, 
   3.460806283974195*^9}, 3.460806807263606*^9, {3.460808401910928*^9, 
   3.460808427928109*^9}, {3.460808490273144*^9, 3.4608085097819967`*^9}, 
   3.460808560412644*^9, {3.460808595578998*^9, 3.4608086131948977`*^9}, 
   3.46080866666626*^9, {3.460808755444212*^9, 3.460808819650992*^9}, 
   3.460808864264059*^9, 3.460809006604796*^9, {3.4608090811854763`*^9, 
   3.460809104912641*^9}, {3.460809151929467*^9, 3.460809168752171*^9}, 
   3.4608093860076733`*^9, 3.460809454988336*^9, 3.460809522864664*^9, 
   3.460809555813641*^9, 3.460809599993239*^9, 3.460809658263152*^9, 
   3.460809722507944*^9, {3.460810854015986*^9, 3.460810866689756*^9}, 
   3.4608109498397627`*^9, 3.4608110282394238`*^9, 3.4608110721071033`*^9, 
   3.460816353080124*^9, 3.4608164602305193`*^9, 3.460816634258309*^9, 
   3.460816731670138*^9, 3.4608168084797297`*^9, 3.460816894874284*^9, 
   3.46085946451213*^9, 3.4608595234315767`*^9, 3.460859577166404*^9, 
   3.460859610229175*^9, 3.460859640820545*^9, 3.460859671884251*^9, 
   3.460861034459901*^9, 3.46086107767255*^9, 3.460861174298973*^9, 
   3.46086120538374*^9, 3.460861251291684*^9, 3.460861323178865*^9, {
   3.46086138754945*^9, 3.4608614004495792`*^9}, 3.4608614320313396`*^9, 
   3.460861481320551*^9, 3.4608616211310663`*^9, {3.460861765223168*^9, 
   3.460861786281537*^9}, 3.4608618357668753`*^9, 3.460861918091242*^9, 
   3.460862023167821*^9, {3.460864061052595*^9, 3.460864090834353*^9}, 
   3.460864265960928*^9, {3.4608645935059767`*^9, 3.460864677184669*^9}, 
   3.4608647145529547`*^9, 3.4608928884220953`*^9, {3.460892927185437*^9, 
   3.460892978487932*^9}, {3.460893064002185*^9, 3.46089311369724*^9}, {
   3.460893196424436*^9, 3.460893220994563*^9}, 3.460893259227386*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0, 0, 1], PointSize[0.03], Thickness[0.03], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJzt0Xsw1OsfB3CURULYrLstuXVZ24V1W7tSJCWHk9wJSUkUuRSHEokiqZZE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           
           "]]}}, {}}, {{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.01], Thickness[0.01], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJx13Xd0VlXWx3GKgVBCldBiQpRgKBpAekkCDEjvBBl67xA6GCQhhCY9NI0i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           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{-0.4920407313793702}, {1}},
      PlotRange->{{-3, 3}, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {195.42857142857142`, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {359.99999999999994`, 291.2461179749811}], 
    InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.03], Thickness[0.03], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJx13Xd0VlXWx3GKgVBCldBiQpRgKBpAekkCDEjvBBl67xA6GCQhhCY9NI0i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           "]]}}, {}}, {{}, 
        {RGBColor[1, 0, 0], PointSize[0.02], Thickness[0.02], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJzt0Xk01fkbB3D7kizZrr0oe8W1Zb/E0FWWMJdKSSVLtpJsWRMGyRbDHTEp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           "]]}}, {}}, {{}, 
        {RGBColor[1, 1, 0], PointSize[0.015], Thickness[0.015], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxN13c81//3P/7s0ZCRZGQlWSFEwlMSaagQySoy00B2ZEX2yB7Ze+/N0957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           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{-0.4920407313793702}, None},
      PlotRange->{{-3, 3}, {0, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {586.2857142857142, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {359.99999999999994`, 291.2461179749811}], 
    InsetBox[
     GraphicsBox[{{{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ449J9l0brgyfnhyBWG
eiWGA7Pmn78l8nOD/Nu90/N3K/zZ/9T+8y3pzB/ackW/Jlo5/9j/12z6r+dV
goa3eCzOPxT6sn/D4iyLZ+HKxnwvc6X137zfz9VSPi/i2UbjjTtCGOUcXuzv
vb6DVSPjpPGlVY8sd925v/9WvWXp1LjTxleevHWyD7mw/+72wtL9LkeNF2g+
5X86f+L+p3IK7iv/bzJ+5cWd7XL9nH2PTu+7eRsnGn+eY/7K+to9+2ij9YIf
b5YZq/zdN1Pq2HP72xJC6//Y1Ru/nnjf+tfP9/aK9pJr9aM3GptO7rbSvvDZ
3ui3TIRw0UnjV2U+Nobfvtv/Y79z2iH9i1HVrRmdpVd/28e9m264988y/QPa
rPdOMDM4HHjIIf4/mFXtlPPcbfzCTA5+bL69rCycgoekf2/5+o/ZARZ+pQ2v
l7qLsMH5dUF/1uwLRPA7VHi3mPYj+LNO6B1S5mKH8xfPsj85yx3BX5MTcEGw
FcHfZpd4veMQgg9ND3A+ACLc0ec=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtVHs01HkUHwazNaGkKDUVKnGOUiaPkTtEQ0mUymrTkcexipY8jvJOJ63W
sEIGG+NxFIoeoml8JzZLEZVHkTHm9yWMR5KIkf3tOfvHPfd8zr33j/v53M/d
cvbCUV9FCoXiTsZ/Ga0MES8t0UQXaw/7K5/tA09L3r3gepooyzTJY29+H8i9
62OIRJrItbKQZyDuA/MnGpv+WUYTXbb0dbH9WQyVpx+eSVmtIvIeP29IHOqH
oY1nJyoXqaLetOyEHr4EdjIOnTSlK4pSB6VT62IH4PPfHZRYXYroeKPaZJCd
FMaFWRcEm+XodrLDpSYFAkI18TF68QLilL3OV15LwHzALvNTOxZQiV9kZM8O
AlS0mykLJvOI6x6WYO9CACNkPs1y/xwSlnRbzmcREL6VH7lTOIvCjd8nmNwl
oPW9o5e+2SyaMVZLHBAQEAXZu9SMvqFjl8zTivsI6PjC1qYWz6Br0/Gl1eME
GJUML80yZtCr7HWplosE9KwwbxvQ+Ip+cb7jm7EeQ/sI7ZoDdxp9pLZFGhpg
eNHYbX2fPo0MhvxidzMxVMZF3ItS+oIkprKZzMMYSk5z/Ii4KdTAEByZcseQ
a6nFOLj4GeXwVgY+9cagNhKos3NsEr1q/MMhIwKDYoPhXPm3CVTkbbVcLQ7D
bO6nDkOFCZScejRGOQnDWHhRVSl9HMntguiXuRgkLl4p29aOISXb11uCMjF0
GDLOFW2WoVAdH5Y4F0OTUi9H12gUpasO9r7kY3gmztLPZ44gl9wPqXtKMVTV
uCkw2MPI4nvZlFYFBgenJjzI/IQua1UttVVh6O9nNVUYDaEDj4N5sscYwi/e
LwvbMoj2bPP0CajFoErT4+7Twqjnbruq0zMMRbzMEGVVAqXYrDueWoeBZbz8
RKuiFKn5XVMxE2F4+zzaImNOgsaFwXJ4TuK7UounH/uRTSVrUxmJNTSUeu/K
+tCXjTl34kh8NHJrVM58L7LJTeG3kPN/Sg5svLGsB9k9XaXNRRjecfzrorTf
o6HoVt0mIQbN+9fPBG7vQm271wxFCDC4rS2jeO7tQIbvB7h/1WC4Gd1S4Gz/
FtGNW9ytyH068LgtuLWjO97Kia7kvusHzzhOfGhB71w3aH8rx5BMwSs86c3o
YF7DDy2SL7mOf3ur1QsEVMHNJySfQWZj6fuCnqN4Dx92J8k3Kpbc8wABspNW
BweTevA/DjMt+Q9RoLcJ/wapV/6OQfXB22no2HNijS2pr/yG/fyTrhRgjs8u
bCb1dz615qozqxQKfL1QQCCG6mK1Zk7hM5iKkB+yJe9H7GKgsuJiPYTmhcre
OGGQOjdvD73ZCDt1kjXb2RhGD9LP2XW/hj0n7c02bMfgg3XOz7i/gXCrqw6n
yPt103vAdzjwDvwPC2I2qWIwLRCrT27uhmbreHfWFAHTuWajrC4xhDAF6eKH
BBwxrbweHS6BUqbDD3kBAfo8O0Zf/ABIf6KmZnAJaPMN5OTeIqBilJ/K+pWs
L9Zlr2/8BBRdP43fSf8K1akpmS3D0Cz78F2d9PcJXU6CxrsRcKy9bqArk0IS
py1guUQGK+tzrn0RSkGW1s+a/z4JDVcCtkZ4SoGZnmxp1D4NRgxCdDtnAEbD
naxMvs1CaYJL6dcHErjUc+t6WOcC2dfyYm96P4iMlMVNVApbOSlAwzC2D17u
z6tWX63ITqoRjm3z7oV6nYVHMz+obMGEzfHz3h8gLE5WzNFUYX/2EL6Sm3VD
zFF5eZ2rCjvaojrPca4LkvRVHzG5Kmz9Dr2Wqpou4DUZ1+stp7Frf9vU3W/R
BYU8aOZxaOyPLyd8y+Y7ofy8S/uqqzT2oNvpx3mCTqi29upOqqexuYWlV2qj
OuH/f8uuoCslKlh3wr/XiN1c
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk/lIsegMeMoTgiS5SQ6OAQqUG43u9bZISDrJXGHiWSbZyksmU92Zkh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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FHwXB/DJrgllK9lFm45SJDNmrhJDymhIJdtoL0tFemn0WB7hIYps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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlGlQk1cUhkNAMrJWQKAwIrtCpqKWCIJwvroFLUUQiqg1SNxo2OpCFAVR
qxaXBigoGHEBDTrsO1KWG2PF4IggUNYAwQST77IoIosBatOZ/jhz5pl35vx4
3pljw47ZeYhKoVBC1PPfRl8dG/jyhSYsrA5OPfL+LbA8+EVHRTShp+r302fM
ZDB/QHRWdpEmLE65M38YZOBebbT8xWKaUKV5I6CWJ4OSfeWhPGNt4QRquW1K
l8O7ZezxkgVNYUNdFU//6DC4WH2/y1WXKsz0M64fuf4OPvzVQUm0pQgrOXok
cU0BY/UZMbXW88hqIj/UN1EJJ0zkgbqCORTIKrJl31KCirPafa/THAq3ecOd
KFOCtnkTZW6NCqWYdXNi5UqwOqZK9dg0i+Ztk/hSggSuQ06cS/0MCpB9VOwJ
IaG5e1uYvdsM0pn26HOMISEebq02oE+jfvudzfl8Ejo+Euaagim0Tiqf319M
Aj1X+WXGagrdOcBx3f+MhF4995Yho08ooJAQMkgSWknabz7Jk8g7AhjVKhKe
N3Z5F+tOogi+QnJBF0PJuZNF8Vof0aCj8dJJZwy5+5iHZecmUNmoYjJ9PYYs
DzOr7Qsf0IujETlnmBgMyChLl9H3SJIorTQKw0B95jxbMD2OuOOcsYUIDDNZ
ig5njXFUI65L2MjFMMp9WPpYdwzNPXXIHkzEIPUP4zmajqLKHay7HUkYOpyt
Ih5aj6Ajyrti61QMYq0+pi0do2+qKhOfZWKoG8iwv88gkWONxeq6exhKnwRp
WBFK5BhMDdTJxeDjK5YPMxTIJv7Cj8sLMAwOeooL6e+QeOZROacUA/d4cX6s
zTDacV7yaaQSgz7NLtnLTI7G7p8qy6nB8JB/89gifRmKJNsyeHUYPFfpBDdT
36IHSb7s4gYMbU8T1t+YlSIWfe+QllDNeW/X/ykZRBlrU6Z5ajYy0urLG+lH
0Qy6V4iad8Y5xN9W9SHYzWP8gjD8Id267PriXmSzEk101mNoZ4Y3xJt3owS3
y6nXazGYFF8JjVrRiWZ0IjamPsEQZJpPYa3rQA6ri2C4AkN6wqtsvy1tyDX9
u7akErUv+dhGCGpFzSbIPz4fg8Vw6LbxnlfoFH1X2YAAwzWKXI+l24Q2vPR6
lKn2NW8Z3tq84Tk6t34hN0/tM9ptNM0r+ilSul5lLFX7RgJp0R6oRTeTv5V1
q/vIkSgZHjnlqCEwxXda3dd9p2HD4XupyPRqucZ3kep717eoqjt54Ga09U38
fgx+e5de8vN8DP6PNDizgRiqBAZNzAd1ECffxi53xzDgv1Jb77gIHOs/LZ9y
wvDWr2nFifRGKPUvZJ+xwIC360Zs7noNlk1lQ3s+k3BQbhk5FfIGWEtQD1aS
EGRXluOztR28GhRxki4SXLMHDN9bd4E+weomy0mYzHLDnp0D0Bi7L6H9IAk7
XEuuJHClgPP4D178QII9f7NV//khSDE5yDRcR0LLoShmVqYMDp/s9cnWUucL
DbcsGhWwmW3XqcdXQr2hJu/mKyV4S9vSWGeVEGzLvGDUTsLJkki6JVsJScwW
jo50BCbTKxwHVihhJHXQU/X5PXw9G2n9ukABjLRrHvTWSbCJyaspKn0HmOu7
Yc30DPimhXNeXxqG072ZV2L/ngPrtb/e1d8tByF90YBYk0KIigqjXagyeLnp
TpWhMZVwT2nNcskdApHlXMXUP5qEgb5p688/SSH23IiAaaJNOI1cNJ4c7Yez
O+cLGgK0iShx4Ikefj8k2etXMJK1ia7LUnOZTz/wxatEdjo04qXo/PIYgQQe
8KGJz6QR8w1LemYDJVAQ6d+65BKNsJXKL1ZQJVDlHdaVJKIR99KWFAhK++D/
f0u4CY43tezvg38BiNrpkg==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnk01Hsfx2cxJtslJilUKJIbKYOIzy9u9iay5LFvV6R1CimkbCmRwg1T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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FHwXB/DJrgllK9lFm45SJDNmrhJDymhIJdtoL0tFemn0WB7hIYps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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs01HkUwCePmZDHImwy5S0KrdFg6M6WDLISKm2L9JCobIXtwdY6KWFJ
qLx2KaSHVw+imu805bVRXlFoDGaQmd+XEqYh7ew5+8c999xz7/3n87nnGu6J
9N0vRyKRAmTxX0Yax3jfvlE4F6Yf/vDreyEEOeWUH+VSODRFen6NygjM7+X+
PnyOwhlrWLO7zXEEHGo0VzQqyeZzTyyEZ41AZeD94FQtMkdSKrw16zEKIwZ7
cOVXeY5tn9Q1iDsGNtTNO2gqchydCsdCC+VxmHzRRTpjROKER4o139qIgHh6
NfLxynl0tDbWq8RDDFHaAj+V4jm0Sb/ip/oDYpCG2zrsWjWH2G8oWh4JYiDr
NZPm1krRgS8ugTFsMVCPSdOdNkoQ+3jBFutVBMSYXj9p83QWRVKfZ3q6EtD6
1iPEhD6LYiTpCflBBMRCtq2a1QxareS6mXeJgK5PTD354mm0w1axrrGUAKuS
sW+z1GlEK+hYPIAI6F3i8HpQ8zPK1pWnp4kIaPtAueCeNoWSXjCWNnwjoL6h
Z32FyhTCmzsVrLQwVJ79rTxW4ROi2PdcOEHHUBLICh0++xElu/EWAt0x5Dnp
Uj2/TiKal8g7IgCD2ofD+jbiCaQ9FEOWRGOQe24puTuDUd07F3ZGPIbZvNEu
y0UY7aNfUoxMxSCOKaoqVSGQkoG5JDEbA98nJNVMR4zUJOoc/g0MXZbUiKKV
IiQJaMyKLsPQpNDHMrIaR6cX+XLcqjE84V01KbD/gIJN/LP82BiqHvkvojLH
kGen2cncegzuXk0Cof0oQhc5+wtbMAwMMJrKrEaQl173KXYHhpjjFXeiDYUo
v9JizaceDKoU4zQXXQFi3bImO/djKMq5ckxRdRglapkW5Q5gYFgrb2+VG0IR
LtQ6jSEMHc/iHLMkfBRnoKqROyyrbw851vUPoNji1ngnAQZNTYW+26L3qEaN
s3VO1vc9aRqbK+1DLpe89k7I9i/z3QxSlHqR858bWnQGMXSywtixem+R/uVt
VUd5GLQrLgYfNu9GpzP1WKQ+DP46d0hB67rQOdPZdm43hsy4lkLvTR0IX11d
Utsu4yUgNoB/G7LRrzUXvsSwTBjsgd+1oPU4UO+gjEcySbAkSKUZpX8eT7GU
8ZrXD2trda5HCQkH1S1lPI/QxRkuR54hJQdHhzAZb1TML/8ZHiPhwnyZUObj
ev+YvdP1+8jl3HnTGzJfBauE6sK/0xFDPsNuUOZ3PmWTtKY7FRpC4yc9Zf69
dy1N8GaUAmPF0KPuUAzVxWrNrBtPoCxo2/mdLAw8HwvykuNcIDdvYfmtwzDk
3WweldkAb5SMk6NMMIx7qkS49ryCJHXXfrsFAvYJ9A9NB7SDXdnNWgfZ/fob
37vu7tYJ7HRtdL6HAFohT31iZQ88jH9mp1BOwFQefZzRzYOU5zvNqnwJ2EKr
vBgXw4eFcRyh7UCASY4r9f0fg5DwsjeucjkBr/cfZuVdG4aGvMnUvGExmHxl
Zy9rGIWVS6vDk8LE8FRdPvVKyxjERe15mOEuhu1GrHjNzg+QVfJ9w6S5GBJZ
r8OV+SJIeWA4UikQgSh9gCH9MgH03b94XtkuAvuMZCertikIzLz3Ipc2DuMx
Xs5rZ2ZhcQTNelvvGJzqvXYx+s0cXDaTD1Y5MwocK0VekzyJ2V59SrpiSgj/
bMyvVteSY/ph6j1WiAC4+nMPphfkmc2GjaGnBUMQfVZUzNImM9t/TJ2xYA3C
777zd9lbyUz3jdeMuLqDkGii+sA+jczsD8S3I8f4kNNkzTVWpjB7Ve8c1Uji
w40caM5hUZgRy+gEZRcf7h7yafsugcL0SdCD5av5UL0+pCeRS2F+1OcM/yUd
gP//LdPm5it1Vv4A/Auuhdqa
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnk8lIkfx2cMM4uQW86SDik6KMbxfVLOJFctIUdkSuPKsbUoO6ay5FhE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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FHwXB/DJrgllK9lFm45SJDNmrhJDymhIJdtoL0tFemn0WB7hIYps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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHsw1GsYx9dttxCRyqT25JLK7rgUkduzIrvUoYspXeREt+PWyaJROFEm
0iEnCumqbYx7ikrxbttRnEEKkcvata57+b1yP3Zx9sycP5555jvz/evzmecx
Djp/4LQqiUTyV85/G62M5C8tUbhFTLUq4YNhOOGYV3aBR+G+8SzK4LUMgyKY
lyC6RuEGnVI3Zy8Og8Mr/Z8+Ladw95qr2DoEjEBFwIvA9FVk7uqWNztVDUdh
eEMQUbGgxm1aZioOuT8GVtQ9h221VLkMiu+e1HExjP/VTvrdhMTdZEUiB26U
gqz27vm3GxUore94hNhdBlEGgwe1OHJED9oiXRUsg/kQa4djW+XosOh1a36i
DMiGjSS5zTy6ysma/vBOBtTI+UxH9zlkY8paSacRELPpSaxV7SzqdbaxcmAS
0NzlddLMfhYlemepRwUREAe51jq0GXQr2jz4wh0C2icYhmqcaeQYygq0LCeA
9mx0aZY6jbLE7Dm9TwR0azt8FupPId8cSrHHFAGtY5TrrIxJdNje7hfL5Rjq
P3a6lmtNIg9f9pDrBgwVVy6WxalPoKHYT9nNuzA8C2CeEV35gYKDJlJYfhjy
HddSvRfGUd7a5l7RKQw6Y+FGVlKMwKVaNeYqBtUPFnMlMwTyTy72TLyFYTZ/
pN1ChUBC0mN2fT4GaczT54VaMqRhH3bfrRCDYN/JdPM1UhTIrRqeqsTQbkEN
fbpRgnZor07kv8PQoN7DNKGJEX2vRelCPYZ3/Ltmj+zGUHdidc3+FgzPX/up
UBmjiF70fFl3BwbW3obBIbsRxC/sXEvtw9Df79RQShtG5MjL7hdEGGLY5cXR
xkOo3Std/nUUwwqKaYbL2kGU2hxev0uG4WnenUiNFSJUazbjxB3H4GSpeahZ
dQBNqWXq7pnE8PV9/M7sOQHyjXcji6aUuWhgZ01vPxLml8ivT2PQ11fvKZL0
Ie22P+55KvOB2E1x9+Z7kKyiKMRG2f9T4Lnh5vJutFR1I4E1gaGNea4uzrAL
1ZqYL6RhDAblqYHhm7+hJB3heoUEg9+aYtKJHe2IF3DNLHcEQ1Z802Of3V9R
Qa5taPCAktegbBf4tSJJ0Rn/Y70Y1g0FehHfm1BJia2Yo+SRRhrUPqHViAbm
PJmblbwURudam53rUZJJ2GK/kmeEvfS2S8R7dKqNWdqq5I04grKj8BbFugFp
XunjSe+oneOTFyizLbjyuNLXo61DukMPM9FyZ+9fvyj9Km7unn/1LR2mBs7/
4CVh8Dm2OtnHqRD0Evy/t7AxVHN0GpkF7+Dadrmu00EM/H1byNpsHuT4N217
4IZhwKdxc1TWR6DxNgUYW2EQe2uFenS2wM9bqxjpFAynBo3Cpv2/wGzdZWvJ
JAF+ppVPWJ5t4BrKmbnRT4DtY74u3tgJUpff6LkvCZjMtxc7feNDYUHCFuoh
AnxtK1LjYwSQissV2Y4EmOV5UPsShVB5qasGqAR8Ph3OzM8RQanPgy/bRDIw
W6jLXfdxBPgdBt/7lfdbq6uWfqdpFKT3xo607JLBIRNmkn7bGJyt0CvVNJZB
CvNziKZAAopH7h0Xe6Qgyex3mv9Hye36Q5UolhTsbqc50lonoSnWdZG9XgLi
mL3ONjOzsHufotOuegwudeekRnfIoebss6sSn1Hg0jT4DWokhkW9/9H9VcPw
t/v9at1Vqgx6BEWYvXoIeEbyl9OLagzVzdtyH6WJIPqKhMM0IDPo4wXhGgIh
JBxQlNTtJzO6Y5CjvEwIKWYrXtplkBnG1l6G5AQh5DVY8kw1KQyVI/SJ4PVC
KMiDxjwmhbG9hrb/rUQAJWH7WvWSKQxL98fJ1m8FUO16sjOFR2Ekyugl9TcE
8P+/ZTSJiK64owL4FyD44dk=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk4lQkfh8+urI1olCVTEaNIMYzK/0E6to4tZbLNSUqylCzJEtnHlk7W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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ5wrNE86OzdwfDhyBWG
eiWGA+eXBmns+fRe7O3e6fm7Ff7sP798rWT4TzNluaJfE62cf+y/w+Do2lsc
oHGLx+L8Q6Ev+w9/SNOoNEnS4nuZK63/5v3+3Mr5lqtvfNDauCOEUc7hxX7x
/X92J7xk17606pHlrjv39wv21M23OcSpfeXJWyf7kAv7XyyQ0QpkYdFeoPmU
/+n8ifsff/0+K/fhR61XXtzZLtfP2Wce0HnKvfyC1uc55q+sr92zv3AlWHVV
41Ytlb/7Zkode26fsck+yiZjr9brifetf/18b6+rduX2ptAPWqaTu620L3y2
/3hAdO62T+zar8p8bAy/fbfXSPncftvYWKvq1ozO0qu/7fXyHjFnLXqqdkCb
9d4JZgaHpeKn+VcLuciecp67jV+YyWHNR4PHSt3uHIekf2/5+o/ZARZ+pQ2v
l7qLsMH5dUF/1uwLRPA7VHi3mPYj+LNO6B1S5mKH8xfPsj85yx3BX5MTcEGw
FcHfZpd4veMQgg9ND3A+AAXi0O8=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtVHs01HkUn7wmj9AgyhpEZISck0fEnUqNHmtn84icxqL2qCTJYwlbjjYk
kpZM5F2S0Cq1Jd8xIVqWGEYeY8J4zPx+KOs1HrOz5+wf99zzOedz7j3387n3
GgZcOnFWhkAgeEvjv4zUw3gSCZHlzqvJSlkcA4YDs/Iym8iifzcbJDISwGog
O340kcgSEyzi9ekCsH9F0v+gSGRdF1bNLTwWQPXpGr80DQUWhXJs/1bPcRjX
C5iuXpNlJXJ1nJTqJ8CKfOzkHmUZ1qpMgRZjaRJmGzmEX7cTWEme7Q/WNgsB
f5d96a3BKsIjA7vsDUQQrjnmrly6gj4ZGerrOolAfH63va/ZClozs7kT5CMC
BZ1Wwoq1GAWY+VTsuyMCcpg4w+HgEuI2+aTcXRBB5I6iaKt3iyjVmcPOUMeg
ve+Iv7HdInpY3CPqMMMgFnJ2q5ovoLbQQDrhFAacb1Qd2dJ5FOev6jEdioH5
o0nJInkenWvd9pl0E4N+FfuOL6R/UOfH5IrFagw6p4g3XdPnUKihHeFUIwZN
zVznKuU5FDWZITfXi0H1tajKWLlvKMRSmcNexuDRadrPo9e+IvpydPGCIg65
Dtrko2uzqL2/eJfvVhxUpy7qWmEzqO1lv/VzGxxk3lOWKhamUUqUuXfLfhwW
cyc4lA3TiLUUNG/yPQ5YZMnzMmUcbUytsGw7iQOf7p9msgVDSTvabV/548Ch
kC+UGIjQVZ1ot4nzOLTIDdC2mwvRn3pujb5XcKjjZRsX2EwhyJ/5R+MqDs9f
e2wgUydRuovuMbUEHFyPt4wJbCbQQHmJ319JOAwPO7Y8Mx9H4Wb9u8rScIi8
UvU0wlCAbBVsLEozcdhENEp30h5D+V8VZxqycShhZoXJbxpFT0ZzNNeZODha
Knm1y4ygUHkDD588HLoa4vb+vsRHjSWDUd0Ppbh8ZO+bwWHkZ6XHCM7HgUSS
GygXDaEy96tNVlJ8InpH7APxABrZSumzlPLv8g/rpSr2I1ltcvm5XBy6aUH1
sTp9SGsuicHPwUGzKtnvomkvUhngmGZm4eCx5SmBYctBL8R5tIS7ONyLayt0
O9SFaiVPVCtvS/Uaww+ARyc6+3hocIt03m0CvyPTn9uQs67cKu86DrcIYyoM
5VZ0uWf+ARaDw6puUGf7viYk26G+nyrVM8QOy3QKaUCUhLC4fqneqJRfeQre
IpN2wexbqR9Fg5M2DkU1aMCkw1Ug9avATKAmyM9AT0M08kkHpPVSD4lf9aYB
Sf2jnbLUfzdfrRtujmXQa1a+bGmKQ22paiutuA6Y9YVDqxtx4NF3KqhcYUO6
xpeHT5YwGHFrNQ2/1wyRv9h/+G0CA+FR5Qsu3L9B7R7jeB8bgzNjusHz3p8g
UCujrkS6vx5GfxS5Hu6G8NdHuA15GOwp5KnNGHDBsCMRzUVgMJdrJ3Ts5UHZ
zmDhT2QMfthTnRwXyQcd32LJgBwGxkwX8tD1L3DN6pnafaEIOs5epOXeHwVP
yl6XwRoRGK/V52xrnoCY24VGfdL7facmm5bVNgkBXSEJ1voi8NpOSyB1TwEv
1/CNQCKEJFrHeSW+CDIrI2eDkBBEGcOO4uUZyFSgRxnbCcEm85aDeecc2Hpy
R0mGUyCMPL7PemERBvMTLeR7pH367ydH9KyAJE9lbP3mOLDM5XktsgTqbifc
20tFAB8P5tWqachQnYRGdpKUUWDrrryYX5elmlpJmnv1RiDimqiUpqlA7X3p
RInP4EP8idWK+h8VqFraCXWKZ/iQZLzphU26AjU7Zp1TZssHZosl20iJSPV/
T653fz0MxUxoZdKI1LWQS2x9xjBUBNM7N98gUnNjNmgZyQ1DrbM/N4lNpFrE
KRb4l/Pg/39L9UoXOw3TefAv993b6A==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnk81Akfx+dgxtEihNaRckR2Y0RC5vtz1GhyhdSaRSRsKFmyRE054nFl
k2OIwVptkaQchd+PohFFEUnueyZXcjQMzz6v1/PH5/V+vf9///HZ7XXR8RwB
h8Nl/rv/EZUKHtzaImNyrbujw5c4VHcT1sNLTWSs41SB+gXcG+rG2aarYzFk
rD60i3vrQyeVlcy1O0kjY/Si7MqJmC7qoWrpXa9EyRhcITfUsXqoPcMm84fa
SZitMsteX+MTNUTsLHo/hYRpFRhEqxsMUqUNElOVTpAwgoCm+jhghPrIrdIj
RYaEjUjsOhIqO06tNkyoeN8pjC2oOt/P9JqiNvzgQZRPEcY6+fzURQqP+nLC
4CTjuDBGdxjTiE2fp7bVi5Xkiwhjs4u+LTT7r9T3d4bXxpqFMC7T2s7rwDL1
Y2AVXStaCNOZETygRa9Rh44k5QYgQpj2zHK2ju0GdVLZa+6RgIiZq9ffDnbA
wbzZNYYnSsTOBApvz8ohwJpbLmf7dSKWm0cWBOsLA/5qrWGTBRGT7W7LeaEs
AmJ5PYXBQkSMQllX0PYVB5mGJUm1FgKmdJ8i0N8pCUqDUlFdNwlYRCc8rc3f
DpqbP3OjjxGw5dM9YseWZEBX5fgpA3ECFrNmt6qbIgciTpGlym/x2HHpuCux
fjth+GYZnpyGx/p23X7onqEENXWDLgtOeEzOUTtHXEoVbi1KlvbJ4bGDz0v1
3Mh7wE/THP+iD4dNaIpcJx1UB4QR7FKai8OybBdLjhdogsKtogd3PHBYTPKU
W6+dNiy87MZd24PDVJ6g71Crn8DLwbc8FNtC9wrknzh068KYnIbbrOkWelyP
F941TgHvgVGxc9WbqHOlFu1neQOYLGLXfNbfRKPi0enTcQfB77y7j/NDAbpf
UeNSl5ExcPWUZNu1BWhIgyH9MuUwBKz2NVoWb6BDvBrj8HCA2frMi89VN9A8
07oV40RzCJEddxIvXkcPU+Negbcl8M/rHWJor6O8R1ZpdL8jwGyMVHpQxkeV
hHUqIlg0ICm04tYpfPRWtNaW7OYxSLqwY4Je9R0d67HVu5FhA9LNnq0sk+8o
Nndx1tbXHlSC+WkmlmtoYqPbr/7DjnBZozBct34V7WiSTw3udIY3H495qhut
om1zp1V6uS6gnrRovbNiBbXixV4w1f8FIiFbT0JnBe1Uv/vY4R8GdH9FFIjF
y6gcQ1Sv29EddP6e3lpVWUbFD8xLt2SdgU/bDnWMSH9Du/gpchPtZ6FzhnzT
OnUJze7bVvU58Rw0t/RSy8WXUJ9zcpnvf/OFZ0UlKzviv6J4MFaQ8vsNHjHD
HkYKfUWf2m8r6LnpD3+70XzGmItokPh7GbfXgZBrIq9CFyygr461J/soBIHE
TKCi7pd51Mt74PlgVTAQXuxbK12ZQzlaCSp4sRBYzZ3q3oefQ7V7QoqCLoTC
sINniqbcF/T+wVLamYA/oHufiv9fqjxUbmWS6UKKAI5QP22PDhcVkbzwNvrx
FaioccarINMoz/+o7zvza2BtwxmfMJxCGSeaxy1KmDA0ZMop05lEO4PIqjY1
1+EHslqqmfw4uhodpDn4PRre3x81fvZ5CJV8Utu4sBQP0tJC/fd5A+iFNqHf
1PT/A47hGpE5/H6UNkuke4YlQhfNryFS4SPqtygo48umQPf4rAU4d6Ku3WO+
vOY0YGtPSE7kp6Gvxb70kC0zYSPpCL+6JwW4PMkfJ9czwY6xI9bO9B4EuN47
klSRBVXFEq20ojqQZHZa1kixYNBBi7Tt9yaoML+3m1DLglG71r0h6S3g6bfW
cZeRA1y6uL9V71swCTQf8EnOBe9xxYDl0+/gxiyeoi19F5zVHhdaH+2CvxMy
Hm2m3gUrL+u+nAMfYEyb7hxOygODgkHJedVeIB5esNULzQP14ZCjFhJ9MPR6
WxHWnweyu8Sj7qx/AmuPbdgb43wQci+onJ7+DD5lvxAJqfmwlGvENe0ZBHfe
TyDZnw/2Bo8Soi4PQ2ExvcZ/OxvUWVYqA9dHgEppm87TZQN/6+Pjw8mj8NSr
koyzZkPHuUBabtYYrOMZlBBXNvzVhv+8XjQOH/rNvk/6sCGCkhHEKJ8A6p9F
qfRANthn7hN+/mwSjG5p9mf+6+qChuwfW6YgXvFj7FtfNtRLElMy2qfhS94D
J5Nf2eCyh3ZDumsG0gpTEz/R2TBvkHg5pY8LjSX51Y0H2BBP6zgvNsyD8mmO
n4g8G3a7ynjETX4BjB8nx5rJh2cBp5wIs7PAe/Da05eVD47XcmhXl+bAVKmk
qA3JB17akCn/+zz8ocYQUR/IAzOL6BGvsAXIHRD3YIblQexzuWLO4gIEmuyL
6hLNgx0PzX5Kn1yED2cUlSfl74Lb3nfz3898BbmFOrOw9FwoZntXevR/hQfy
TMMCsVwwvJ1ootO5BFL3uK/SJlhQWv6Cz3P+BvoeCgwhKgv2tK8/K+37BntD
SiJ007JBSjjAdP/YMjipnSPv35cF3Ms2hykrq1AZ4aZKPXQHIj5lJYR+WIf9
Na1/OjmmgqLYlGQtYwP6Ppnbqg4nQ52xYcbGyAa8Mfd+6RaSBIKsd4XRcwKo
qxY1J1UmQB5nl/arkE2IDDpQ+MQ9HqhrgeVi65uwYZFs5ypzEzAd4UEOEYfY
DL5+dio7Bhr3K9RWHMEhFjP2NV1B0dBE0Uln3cQh6spRGR6ON6DZ6AQ9QByP
SJgdED1vwIQWE2+Nk7Z4JNPyVLjD+avAMQvDUVPxSDUpqXCWGQmvLe9WScoQ
EOWWtLiI2T+gddPvcpIDAXk7GVug6hEGnFqDg6IpBER0Yc2qeTQUWnTbnxJE
iYiMcNYN0q7foZmbGXrtKBFhl+39Ruy9BC+LzxpuRBMRl8/6oy/yg6BJcf3J
8iYR8Tk6Tue8CIDTWjuX8s2FkJP+Ue71Cef/7ceIQo8RQpaS+961B/tBnPnJ
i99ahJArzqsTZVE+oGT3e1meqDDSYXlNSuIfb3jsmsazthFGLEa0im4veYG1
b7n2Uoow4nLii/UwwxNCmbximiwJGZQQjGbi3OCq40ZpwwkSYhQfEH/jL1eI
V//hiWEqCXmjIrM1dek0pK0oPy9tJyExJ1WCHvq4AIuzv0lNjIxkVKUfbGY6
QxELWlk0MjIVt5Gu2eAIpQEOndtjyYjqpV7DPqUTUEX17I1vIiP6HObiqKE9
/P9fIccSIpQ0Am3gv5dnhFE=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ449J9l0brgyfnhyBWG
eiWGA7Pmn78l8nOD/Nu90/N3K/zZ/9T+8y3pzB/ackW/Jlo5/9j/12z6r+dV
goa3eCzOPxT6sn/D4iyLZ+HKxnwvc6X137zfz9VSPi/i2UbjjTtCGOUcXuzv
vb6DVSPjpPGlVY8sd925v/9WvWXp1LjTxleevHWyD7mw/+72wtL9LkeNF2g+
5X86f+L+p3IK7iv/bzJ+5cWd7XL9nH2PTu+7eRsnGn+eY/7K+to9+2ij9YIf
b5YZq/zdN1Pq2HP72xJC6//Y1Ru/nnjf+tfP9/aK9pJr9aM3GptO7rbSvvDZ
3ui3TIRw0UnjV2U+Nobfvtv/Y79z2iH9i1HVrRmdpVd/28e9m264988y/QPa
rPdOMDM4HHjIIf4/mFXtlPPcbfzCTA5+bL69rCycgoekf2/5+o/ZARZ+pQ2v
l7qLsMH5dUF/1uwLRPA7VHi3mPYj+LNO6B1S5mKH8xfPsj85yx3BX5MTcEGw
FcHfZpd4veMQgg9ND3A+ACLc0ec=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtVHs01HkUHwazNaGkKDUVKnGOUiaPkTtEQ0mUymrTkcexipY8jvJOJ63W
sEIGG+NxFIoeoml8JzZLEZVHkTHm9yWMR5KIkf3tOfvHPfd8zr33j/v53M/d
cvbCUV9FCoXiTsZ/Ga0MES8t0UQXaw/7K5/tA09L3r3gepooyzTJY29+H8i9
62OIRJrItbKQZyDuA/MnGpv+WUYTXbb0dbH9WQyVpx+eSVmtIvIeP29IHOqH
oY1nJyoXqaLetOyEHr4EdjIOnTSlK4pSB6VT62IH4PPfHZRYXYroeKPaZJCd
FMaFWRcEm+XodrLDpSYFAkI18TF68QLilL3OV15LwHzALvNTOxZQiV9kZM8O
AlS0mykLJvOI6x6WYO9CACNkPs1y/xwSlnRbzmcREL6VH7lTOIvCjd8nmNwl
oPW9o5e+2SyaMVZLHBAQEAXZu9SMvqFjl8zTivsI6PjC1qYWz6Br0/Gl1eME
GJUML80yZtCr7HWplosE9KwwbxvQ+Ip+cb7jm7EeQ/sI7ZoDdxp9pLZFGhpg
eNHYbX2fPo0MhvxidzMxVMZF3ItS+oIkprKZzMMYSk5z/Ii4KdTAEByZcseQ
a6nFOLj4GeXwVgY+9cagNhKos3NsEr1q/MMhIwKDYoPhXPm3CVTkbbVcLQ7D
bO6nDkOFCZScejRGOQnDWHhRVSl9HMntguiXuRgkLl4p29aOISXb11uCMjF0
GDLOFW2WoVAdH5Y4F0OTUi9H12gUpasO9r7kY3gmztLPZ44gl9wPqXtKMVTV
uCkw2MPI4nvZlFYFBgenJjzI/IQua1UttVVh6O9nNVUYDaEDj4N5sscYwi/e
LwvbMoj2bPP0CajFoErT4+7Twqjnbruq0zMMRbzMEGVVAqXYrDueWoeBZbz8
RKuiFKn5XVMxE2F4+zzaImNOgsaFwXJ4TuK7UounH/uRTSVrUxmJNTSUeu/K
+tCXjTl34kh8NHJrVM58L7LJTeG3kPN/Sg5svLGsB9k9XaXNRRjecfzrorTf
o6HoVt0mIQbN+9fPBG7vQm271wxFCDC4rS2jeO7tQIbvB7h/1WC4Gd1S4Gz/
FtGNW9ytyH068LgtuLWjO97Kia7kvusHzzhOfGhB71w3aH8rx5BMwSs86c3o
YF7DDy2SL7mOf3ur1QsEVMHNJySfQWZj6fuCnqN4Dx92J8k3Kpbc8wABspNW
BweTevA/DjMt+Q9RoLcJ/wapV/6OQfXB22no2HNijS2pr/yG/fyTrhRgjs8u
bCb1dz615qozqxQKfL1QQCCG6mK1Zk7hM5iKkB+yJe9H7GKgsuJiPYTmhcre
OGGQOjdvD73ZCDt1kjXb2RhGD9LP2XW/hj0n7c02bMfgg3XOz7i/gXCrqw6n
yPt103vAdzjwDvwPC2I2qWIwLRCrT27uhmbreHfWFAHTuWajrC4xhDAF6eKH
BBwxrbweHS6BUqbDD3kBAfo8O0Zf/ABIf6KmZnAJaPMN5OTeIqBilJ/K+pWs
L9Zlr2/8BBRdP43fSf8K1akpmS3D0Cz78F2d9PcJXU6CxrsRcKy9bqArk0IS
py1guUQGK+tzrn0RSkGW1s+a/z4JDVcCtkZ4SoGZnmxp1D4NRgxCdDtnAEbD
naxMvs1CaYJL6dcHErjUc+t6WOcC2dfyYm96P4iMlMVNVApbOSlAwzC2D17u
z6tWX63ITqoRjm3z7oV6nYVHMz+obMGEzfHz3h8gLE5WzNFUYX/2EL6Sm3VD
zFF5eZ2rCjvaojrPca4LkvRVHzG5Kmz9Dr2Wqpou4DUZ1+stp7Frf9vU3W/R
BYU8aOZxaOyPLyd8y+Y7ofy8S/uqqzT2oNvpx3mCTqi29upOqqexuYWlV2qj
OuH/f8uuoCslKlh3wr/XiN1c
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk/lIsegMeMoTgiS5SQ6OAQqUG43u9bZISDrJXGHiWSbZyksmU92Zkh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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FHwXB/DJrgllK9lFm45SJDNmrhJDymhIJdtoL0tFemn0WB7hIYps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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlGlQk1cUhkNAMrJWQKAwIrtCpqKWCIJwvroFLUUQiqg1SNxo2OpCFAVR
qxaXBigoGHEBDTrsO1KWG2PF4IggUNYAwQST77IoIosBatOZ/jhz5pl35vx4
3pljw47ZeYhKoVBC1PPfRl8dG/jyhSYsrA5OPfL+LbA8+EVHRTShp+r302fM
ZDB/QHRWdpEmLE65M38YZOBebbT8xWKaUKV5I6CWJ4OSfeWhPGNt4QRquW1K
l8O7ZezxkgVNYUNdFU//6DC4WH2/y1WXKsz0M64fuf4OPvzVQUm0pQgrOXok
cU0BY/UZMbXW88hqIj/UN1EJJ0zkgbqCORTIKrJl31KCirPafa/THAq3ecOd
KFOCtnkTZW6NCqWYdXNi5UqwOqZK9dg0i+Ztk/hSggSuQ06cS/0MCpB9VOwJ
IaG5e1uYvdsM0pn26HOMISEebq02oE+jfvudzfl8Ejo+Euaagim0Tiqf319M
Aj1X+WXGagrdOcBx3f+MhF4995Yho08ooJAQMkgSWknabz7Jk8g7AhjVKhKe
N3Z5F+tOogi+QnJBF0PJuZNF8Vof0aCj8dJJZwy5+5iHZecmUNmoYjJ9PYYs
DzOr7Qsf0IujETlnmBgMyChLl9H3SJIorTQKw0B95jxbMD2OuOOcsYUIDDNZ
ig5njXFUI65L2MjFMMp9WPpYdwzNPXXIHkzEIPUP4zmajqLKHay7HUkYOpyt
Ih5aj6Ajyrti61QMYq0+pi0do2+qKhOfZWKoG8iwv88gkWONxeq6exhKnwRp
WBFK5BhMDdTJxeDjK5YPMxTIJv7Cj8sLMAwOeooL6e+QeOZROacUA/d4cX6s
zTDacV7yaaQSgz7NLtnLTI7G7p8qy6nB8JB/89gifRmKJNsyeHUYPFfpBDdT
36IHSb7s4gYMbU8T1t+YlSIWfe+QllDNeW/X/ykZRBlrU6Z5ajYy0urLG+lH
0Qy6V4iad8Y5xN9W9SHYzWP8gjD8Id267PriXmSzEk101mNoZ4Y3xJt3owS3
y6nXazGYFF8JjVrRiWZ0IjamPsEQZJpPYa3rQA6ri2C4AkN6wqtsvy1tyDX9
u7akErUv+dhGCGpFzSbIPz4fg8Vw6LbxnlfoFH1X2YAAwzWKXI+l24Q2vPR6
lKn2NW8Z3tq84Tk6t34hN0/tM9ptNM0r+ilSul5lLFX7RgJp0R6oRTeTv5V1
q/vIkSgZHjnlqCEwxXda3dd9p2HD4XupyPRqucZ3kep717eoqjt54Ga09U38
fgx+e5de8vN8DP6PNDizgRiqBAZNzAd1ECffxi53xzDgv1Jb77gIHOs/LZ9y
wvDWr2nFifRGKPUvZJ+xwIC360Zs7noNlk1lQ3s+k3BQbhk5FfIGWEtQD1aS
EGRXluOztR28GhRxki4SXLMHDN9bd4E+weomy0mYzHLDnp0D0Bi7L6H9IAk7
XEuuJHClgPP4D178QII9f7NV//khSDE5yDRcR0LLoShmVqYMDp/s9cnWUucL
DbcsGhWwmW3XqcdXQr2hJu/mKyV4S9vSWGeVEGzLvGDUTsLJkki6JVsJScwW
jo50BCbTKxwHVihhJHXQU/X5PXw9G2n9ukABjLRrHvTWSbCJyaspKn0HmOu7
Yc30DPimhXNeXxqG072ZV2L/ngPrtb/e1d8tByF90YBYk0KIigqjXagyeLnp
TpWhMZVwT2nNcskdApHlXMXUP5qEgb5p688/SSH23IiAaaJNOI1cNJ4c7Yez
O+cLGgK0iShx4Ikefj8k2etXMJK1ia7LUnOZTz/wxatEdjo04qXo/PIYgQQe
8KGJz6QR8w1LemYDJVAQ6d+65BKNsJXKL1ZQJVDlHdaVJKIR99KWFAhK++D/
f0u4CY43tezvg38BiNrpkg==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnk01Hsfx2cxJtslJilUKJIbKYOIzy9u9iay5LFvV6R1CimkbCmRwg1T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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FHwXB/DJrgllK9lFm45SJDNmrhJDymhIJdtoL0tFemn0WB7hIYps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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs01HkUwCePmZDHImwy5S0KrdFg6M6WDLISKm2L9JCobIXtwdY6KWFJ
qLx2KaSHVw+imu805bVRXlFoDGaQmd+XEqYh7ew5+8c999xz7/3n87nnGu6J
9N0vRyKRAmTxX0Yax3jfvlE4F6Yf/vDreyEEOeWUH+VSODRFen6NygjM7+X+
PnyOwhlrWLO7zXEEHGo0VzQqyeZzTyyEZ41AZeD94FQtMkdSKrw16zEKIwZ7
cOVXeY5tn9Q1iDsGNtTNO2gqchydCsdCC+VxmHzRRTpjROKER4o139qIgHh6
NfLxynl0tDbWq8RDDFHaAj+V4jm0Sb/ip/oDYpCG2zrsWjWH2G8oWh4JYiDr
NZPm1krRgS8ugTFsMVCPSdOdNkoQ+3jBFutVBMSYXj9p83QWRVKfZ3q6EtD6
1iPEhD6LYiTpCflBBMRCtq2a1QxareS6mXeJgK5PTD354mm0w1axrrGUAKuS
sW+z1GlEK+hYPIAI6F3i8HpQ8zPK1pWnp4kIaPtAueCeNoWSXjCWNnwjoL6h
Z32FyhTCmzsVrLQwVJ79rTxW4ROi2PdcOEHHUBLICh0++xElu/EWAt0x5Dnp
Uj2/TiKal8g7IgCD2ofD+jbiCaQ9FEOWRGOQe24puTuDUd07F3ZGPIbZvNEu
y0UY7aNfUoxMxSCOKaoqVSGQkoG5JDEbA98nJNVMR4zUJOoc/g0MXZbUiKKV
IiQJaMyKLsPQpNDHMrIaR6cX+XLcqjE84V01KbD/gIJN/LP82BiqHvkvojLH
kGen2cncegzuXk0Cof0oQhc5+wtbMAwMMJrKrEaQl173KXYHhpjjFXeiDYUo
v9JizaceDKoU4zQXXQFi3bImO/djKMq5ckxRdRglapkW5Q5gYFgrb2+VG0IR
LtQ6jSEMHc/iHLMkfBRnoKqROyyrbw851vUPoNji1ngnAQZNTYW+26L3qEaN
s3VO1vc9aRqbK+1DLpe89k7I9i/z3QxSlHqR858bWnQGMXSywtixem+R/uVt
VUd5GLQrLgYfNu9GpzP1WKQ+DP46d0hB67rQOdPZdm43hsy4lkLvTR0IX11d
Utsu4yUgNoB/G7LRrzUXvsSwTBjsgd+1oPU4UO+gjEcySbAkSKUZpX8eT7GU
8ZrXD2trda5HCQkH1S1lPI/QxRkuR54hJQdHhzAZb1TML/8ZHiPhwnyZUObj
ev+YvdP1+8jl3HnTGzJfBauE6sK/0xFDPsNuUOZ3PmWTtKY7FRpC4yc9Zf69
dy1N8GaUAmPF0KPuUAzVxWrNrBtPoCxo2/mdLAw8HwvykuNcIDdvYfmtwzDk
3WweldkAb5SMk6NMMIx7qkS49ryCJHXXfrsFAvYJ9A9NB7SDXdnNWgfZ/fob
37vu7tYJ7HRtdL6HAFohT31iZQ88jH9mp1BOwFQefZzRzYOU5zvNqnwJ2EKr
vBgXw4eFcRyh7UCASY4r9f0fg5DwsjeucjkBr/cfZuVdG4aGvMnUvGExmHxl
Zy9rGIWVS6vDk8LE8FRdPvVKyxjERe15mOEuhu1GrHjNzg+QVfJ9w6S5GBJZ
r8OV+SJIeWA4UikQgSh9gCH9MgH03b94XtkuAvuMZCertikIzLz3Ipc2DuMx
Xs5rZ2ZhcQTNelvvGJzqvXYx+s0cXDaTD1Y5MwocK0VekzyJ2V59SrpiSgj/
bMyvVteSY/ph6j1WiAC4+nMPphfkmc2GjaGnBUMQfVZUzNImM9t/TJ2xYA3C
777zd9lbyUz3jdeMuLqDkGii+sA+jczsD8S3I8f4kNNkzTVWpjB7Ve8c1Uji
w40caM5hUZgRy+gEZRcf7h7yafsugcL0SdCD5av5UL0+pCeRS2F+1OcM/yUd
gP//LdPm5it1Vv4A/Auuhdqa
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnk8lIkfx2cMM4uQW86SDik6KMbxfVLOJFctIUdkSuPKsbUoO6ay5FhE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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FHwXB/DJrgllK9lFm45SJDNmrhJDymhIJdtoL0tFemn0WB7hIYps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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHsw1GsYx9dttxCRyqT25JLK7rgUkduzIrvUoYspXeREt+PWyaJROFEm
0iEnCumqbYx7ikrxbttRnEEKkcvata57+b1yP3Zx9sycP5555jvz/evzmecx
Djp/4LQqiUTyV85/G62M5C8tUbhFTLUq4YNhOOGYV3aBR+G+8SzK4LUMgyKY
lyC6RuEGnVI3Zy8Og8Mr/Z8+Ladw95qr2DoEjEBFwIvA9FVk7uqWNztVDUdh
eEMQUbGgxm1aZioOuT8GVtQ9h221VLkMiu+e1HExjP/VTvrdhMTdZEUiB26U
gqz27vm3GxUore94hNhdBlEGgwe1OHJED9oiXRUsg/kQa4djW+XosOh1a36i
DMiGjSS5zTy6ysma/vBOBtTI+UxH9zlkY8paSacRELPpSaxV7SzqdbaxcmAS
0NzlddLMfhYlemepRwUREAe51jq0GXQr2jz4wh0C2icYhmqcaeQYygq0LCeA
9mx0aZY6jbLE7Dm9TwR0azt8FupPId8cSrHHFAGtY5TrrIxJdNje7hfL5Rjq
P3a6lmtNIg9f9pDrBgwVVy6WxalPoKHYT9nNuzA8C2CeEV35gYKDJlJYfhjy
HddSvRfGUd7a5l7RKQw6Y+FGVlKMwKVaNeYqBtUPFnMlMwTyTy72TLyFYTZ/
pN1ChUBC0mN2fT4GaczT54VaMqRhH3bfrRCDYN/JdPM1UhTIrRqeqsTQbkEN
fbpRgnZor07kv8PQoN7DNKGJEX2vRelCPYZ3/Ltmj+zGUHdidc3+FgzPX/up
UBmjiF70fFl3BwbW3obBIbsRxC/sXEvtw9Df79RQShtG5MjL7hdEGGLY5cXR
xkOo3Std/nUUwwqKaYbL2kGU2hxev0uG4WnenUiNFSJUazbjxB3H4GSpeahZ
dQBNqWXq7pnE8PV9/M7sOQHyjXcji6aUuWhgZ01vPxLml8ivT2PQ11fvKZL0
Ie22P+55KvOB2E1x9+Z7kKyiKMRG2f9T4Lnh5vJutFR1I4E1gaGNea4uzrAL
1ZqYL6RhDAblqYHhm7+hJB3heoUEg9+aYtKJHe2IF3DNLHcEQ1Z802Of3V9R
Qa5taPCAktegbBf4tSJJ0Rn/Y70Y1g0FehHfm1BJia2Yo+SRRhrUPqHViAbm
PJmblbwURudam53rUZJJ2GK/kmeEvfS2S8R7dKqNWdqq5I04grKj8BbFugFp
XunjSe+oneOTFyizLbjyuNLXo61DukMPM9FyZ+9fvyj9Km7unn/1LR2mBs7/
4CVh8Dm2OtnHqRD0Evy/t7AxVHN0GpkF7+Dadrmu00EM/H1byNpsHuT4N217
4IZhwKdxc1TWR6DxNgUYW2EQe2uFenS2wM9bqxjpFAynBo3Cpv2/wGzdZWvJ
JAF+ppVPWJ5t4BrKmbnRT4DtY74u3tgJUpff6LkvCZjMtxc7feNDYUHCFuoh
AnxtK1LjYwSQissV2Y4EmOV5UPsShVB5qasGqAR8Ph3OzM8RQanPgy/bRDIw
W6jLXfdxBPgdBt/7lfdbq6uWfqdpFKT3xo607JLBIRNmkn7bGJyt0CvVNJZB
CvNziKZAAopH7h0Xe6Qgyex3mv9Hye36Q5UolhTsbqc50lonoSnWdZG9XgLi
mL3ONjOzsHufotOuegwudeekRnfIoebss6sSn1Hg0jT4DWokhkW9/9H9VcPw
t/v9at1Vqgx6BEWYvXoIeEbyl9OLagzVzdtyH6WJIPqKhMM0IDPo4wXhGgIh
JBxQlNTtJzO6Y5CjvEwIKWYrXtplkBnG1l6G5AQh5DVY8kw1KQyVI/SJ4PVC
KMiDxjwmhbG9hrb/rUQAJWH7WvWSKQxL98fJ1m8FUO16sjOFR2Ekyugl9TcE
8P+/ZTSJiK64owL4FyD44dk=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk4lQkfh8+urI1olCVTEaNIMYzK/0E6to4tZbLNSUqylCzJEtnHlk7W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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ5wrNE86OzdwfDhyBWG
eiWGA+eXBmns+fRe7O3e6fm7Ff7sP798rWT4TzNluaJfE62cf+y/w+Do2lsc
oHGLx+L8Q6Ev+w9/SNOoNEnS4nuZK63/5v3+3Mr5lqtvfNDauCOEUc7hxX7x
/X92J7xk17606pHlrjv39wv21M23OcSpfeXJWyf7kAv7XyyQ0QpkYdFeoPmU
/+n8ifsff/0+K/fhR61XXtzZLtfP2Wce0HnKvfyC1uc55q+sr92zv3AlWHVV
41Ytlb/7Zkode26fsck+yiZjr9brifetf/18b6+rduX2ptAPWqaTu620L3y2
/3hAdO62T+zar8p8bAy/fbfXSPncftvYWKvq1ozO0qu/7fXyHjFnLXqqdkCb
9d4JZgaHpeKn+VcLuciecp67jV+YyWHNR4PHSt3uHIekf2/5+o/ZARZ+pQ2v
l7qLsMH5dUF/1uwLRPA7VHi3mPYj+LNO6B1S5mKH8xfPsj85yx3BX5MTcEGw
FcHfZpd4veMQgg9ND3A+AAXi0O8=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtVHs01HkUn7wmj9AgyhpEZISck0fEnUqNHmtn84icxqL2qCTJYwlbjjYk
kpZM5F2S0Cq1Jd8xIVqWGEYeY8J4zPx+KOs1HrOz5+wf99zzOedz7j3387n3
GgZcOnFWhkAgeEvjv4zUw3gSCZHlzqvJSlkcA4YDs/Iym8iifzcbJDISwGog
O340kcgSEyzi9ekCsH9F0v+gSGRdF1bNLTwWQPXpGr80DQUWhXJs/1bPcRjX
C5iuXpNlJXJ1nJTqJ8CKfOzkHmUZ1qpMgRZjaRJmGzmEX7cTWEme7Q/WNgsB
f5d96a3BKsIjA7vsDUQQrjnmrly6gj4ZGerrOolAfH63va/ZClozs7kT5CMC
BZ1Wwoq1GAWY+VTsuyMCcpg4w+HgEuI2+aTcXRBB5I6iaKt3iyjVmcPOUMeg
ve+Iv7HdInpY3CPqMMMgFnJ2q5ovoLbQQDrhFAacb1Qd2dJ5FOev6jEdioH5
o0nJInkenWvd9pl0E4N+FfuOL6R/UOfH5IrFagw6p4g3XdPnUKihHeFUIwZN
zVznKuU5FDWZITfXi0H1tajKWLlvKMRSmcNexuDRadrPo9e+IvpydPGCIg65
Dtrko2uzqL2/eJfvVhxUpy7qWmEzqO1lv/VzGxxk3lOWKhamUUqUuXfLfhwW
cyc4lA3TiLUUNG/yPQ5YZMnzMmUcbUytsGw7iQOf7p9msgVDSTvabV/548Ch
kC+UGIjQVZ1ot4nzOLTIDdC2mwvRn3pujb5XcKjjZRsX2EwhyJ/5R+MqDs9f
e2wgUydRuovuMbUEHFyPt4wJbCbQQHmJ319JOAwPO7Y8Mx9H4Wb9u8rScIi8
UvU0wlCAbBVsLEozcdhENEp30h5D+V8VZxqycShhZoXJbxpFT0ZzNNeZODha
Knm1y4ygUHkDD588HLoa4vb+vsRHjSWDUd0Ppbh8ZO+bwWHkZ6XHCM7HgUSS
GygXDaEy96tNVlJ8InpH7APxABrZSumzlPLv8g/rpSr2I1ltcvm5XBy6aUH1
sTp9SGsuicHPwUGzKtnvomkvUhngmGZm4eCx5SmBYctBL8R5tIS7ONyLayt0
O9SFaiVPVCtvS/Uaww+ARyc6+3hocIt03m0CvyPTn9uQs67cKu86DrcIYyoM
5VZ0uWf+ARaDw6puUGf7viYk26G+nyrVM8QOy3QKaUCUhLC4fqneqJRfeQre
IpN2wexbqR9Fg5M2DkU1aMCkw1Ug9avATKAmyM9AT0M08kkHpPVSD4lf9aYB
Sf2jnbLUfzdfrRtujmXQa1a+bGmKQ22paiutuA6Y9YVDqxtx4NF3KqhcYUO6
xpeHT5YwGHFrNQ2/1wyRv9h/+G0CA+FR5Qsu3L9B7R7jeB8bgzNjusHz3p8g
UCujrkS6vx5GfxS5Hu6G8NdHuA15GOwp5KnNGHDBsCMRzUVgMJdrJ3Ts5UHZ
zmDhT2QMfthTnRwXyQcd32LJgBwGxkwX8tD1L3DN6pnafaEIOs5epOXeHwVP
yl6XwRoRGK/V52xrnoCY24VGfdL7facmm5bVNgkBXSEJ1voi8NpOSyB1TwEv
1/CNQCKEJFrHeSW+CDIrI2eDkBBEGcOO4uUZyFSgRxnbCcEm85aDeecc2Hpy
R0mGUyCMPL7PemERBvMTLeR7pH367ydH9KyAJE9lbP3mOLDM5XktsgTqbifc
20tFAB8P5tWqachQnYRGdpKUUWDrrryYX5elmlpJmnv1RiDimqiUpqlA7X3p
RInP4EP8idWK+h8VqFraCXWKZ/iQZLzphU26AjU7Zp1TZssHZosl20iJSPV/
T653fz0MxUxoZdKI1LWQS2x9xjBUBNM7N98gUnNjNmgZyQ1DrbM/N4lNpFrE
KRb4l/Pg/39L9UoXOw3TefAv993b6A==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnk81Akfx+dgxtEihNaRckR2Y0RC5vtz1GhyhdSaRSRsKFmyRE054nFl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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ449J9l0brgyfnhyBWG
eiWGA7Pmn78l8nOD/Nu90/N3K/zZ/9T+8y3pzB/ackW/Jlo5/9j/12z6r+dV
goa3eCzOPxT6sn/D4iyLZ+HKxnwvc6X137zfz9VSPi/i2UbjjTtCGOUcXuzv
vb6DVSPjpPGlVY8sd925v/9WvWXp1LjTxleevHWyD7mw/+72wtL9LkeNF2g+
5X86f+L+p3IK7iv/bzJ+5cWd7XL9nH2PTu+7eRsnGn+eY/7K+to9+2ij9YIf
b5YZq/zdN1Pq2HP72xJC6//Y1Ru/nnjf+tfP9/aK9pJr9aM3GptO7rbSvvDZ
3ui3TIRw0UnjV2U+Nobfvtv/Y79z2iH9i1HVrRmdpVd/28e9m264988y/QPa
rPdOMDM4HHjIIf4/mFXtlPPcbfzCTA5+bL69rCycgoekf2/5+o/ZARZ+pQ2v
l7qLsMH5dUF/1uwLRPA7VHi3mPYj+LNO6B1S5mKH8xfPsj85yx3BX5MTcEGw
FcHfZpd4veMQgg9ND3A+ACLc0ec=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtVHs01HkUHwazNaGkKDUVKnGOUiaPkTtEQ0mUymrTkcexipY8jvJOJ63W
sEIGG+NxFIoeoml8JzZLEZVHkTHm9yWMR5KIkf3tOfvHPfd8zr33j/v53M/d
cvbCUV9FCoXiTsZ/Ga0MES8t0UQXaw/7K5/tA09L3r3gepooyzTJY29+H8i9
62OIRJrItbKQZyDuA/MnGpv+WUYTXbb0dbH9WQyVpx+eSVmtIvIeP29IHOqH
oY1nJyoXqaLetOyEHr4EdjIOnTSlK4pSB6VT62IH4PPfHZRYXYroeKPaZJCd
FMaFWRcEm+XodrLDpSYFAkI18TF68QLilL3OV15LwHzALvNTOxZQiV9kZM8O
AlS0mykLJvOI6x6WYO9CACNkPs1y/xwSlnRbzmcREL6VH7lTOIvCjd8nmNwl
oPW9o5e+2SyaMVZLHBAQEAXZu9SMvqFjl8zTivsI6PjC1qYWz6Br0/Gl1eME
GJUML80yZtCr7HWplosE9KwwbxvQ+Ip+cb7jm7EeQ/sI7ZoDdxp9pLZFGhpg
eNHYbX2fPo0MhvxidzMxVMZF3ItS+oIkprKZzMMYSk5z/Ii4KdTAEByZcseQ
a6nFOLj4GeXwVgY+9cagNhKos3NsEr1q/MMhIwKDYoPhXPm3CVTkbbVcLQ7D
bO6nDkOFCZScejRGOQnDWHhRVSl9HMntguiXuRgkLl4p29aOISXb11uCMjF0
GDLOFW2WoVAdH5Y4F0OTUi9H12gUpasO9r7kY3gmztLPZ44gl9wPqXtKMVTV
uCkw2MPI4nvZlFYFBgenJjzI/IQua1UttVVh6O9nNVUYDaEDj4N5sscYwi/e
LwvbMoj2bPP0CajFoErT4+7Twqjnbruq0zMMRbzMEGVVAqXYrDueWoeBZbz8
RKuiFKn5XVMxE2F4+zzaImNOgsaFwXJ4TuK7UounH/uRTSVrUxmJNTSUeu/K
+tCXjTl34kh8NHJrVM58L7LJTeG3kPN/Sg5svLGsB9k9XaXNRRjecfzrorTf
o6HoVt0mIQbN+9fPBG7vQm271wxFCDC4rS2jeO7tQIbvB7h/1WC4Gd1S4Gz/
FtGNW9ytyH068LgtuLWjO97Kia7kvusHzzhOfGhB71w3aH8rx5BMwSs86c3o
YF7DDy2SL7mOf3ur1QsEVMHNJySfQWZj6fuCnqN4Dx92J8k3Kpbc8wABspNW
BweTevA/DjMt+Q9RoLcJ/wapV/6OQfXB22no2HNijS2pr/yG/fyTrhRgjs8u
bCb1dz615qozqxQKfL1QQCCG6mK1Zk7hM5iKkB+yJe9H7GKgsuJiPYTmhcre
OGGQOjdvD73ZCDt1kjXb2RhGD9LP2XW/hj0n7c02bMfgg3XOz7i/gXCrqw6n
yPt103vAdzjwDvwPC2I2qWIwLRCrT27uhmbreHfWFAHTuWajrC4xhDAF6eKH
BBwxrbweHS6BUqbDD3kBAfo8O0Zf/ABIf6KmZnAJaPMN5OTeIqBilJ/K+pWs
L9Zlr2/8BBRdP43fSf8K1akpmS3D0Cz78F2d9PcJXU6CxrsRcKy9bqArk0IS
py1guUQGK+tzrn0RSkGW1s+a/z4JDVcCtkZ4SoGZnmxp1D4NRgxCdDtnAEbD
naxMvs1CaYJL6dcHErjUc+t6WOcC2dfyYm96P4iMlMVNVApbOSlAwzC2D17u
z6tWX63ITqoRjm3z7oV6nYVHMz+obMGEzfHz3h8gLE5WzNFUYX/2EL6Sm3VD
zFF5eZ2rCjvaojrPca4LkvRVHzG5Kmz9Dr2Wqpou4DUZ1+stp7Frf9vU3W/R
BYU8aOZxaOyPLyd8y+Y7ofy8S/uqqzT2oNvpx3mCTqi29upOqqexuYWlV2qj
OuH/f8uuoCslKlh3wr/XiN1c
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk/lIsegMeMoTgiS5SQ6OAQqUG43u9bZISDrJXGHiWSbZyksmU92Zkh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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FHwXB/DJrgllK9lFm45SJDNmrhJDymhIJdtoL0tFemn0WB7hIYps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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlGlQk1cUhkNAMrJWQKAwIrtCpqKWCIJwvroFLUUQiqg1SNxo2OpCFAVR
qxaXBigoGHEBDTrsO1KWG2PF4IggUNYAwQST77IoIosBatOZ/jhz5pl35vx4
3pljw47ZeYhKoVBC1PPfRl8dG/jyhSYsrA5OPfL+LbA8+EVHRTShp+r302fM
ZDB/QHRWdpEmLE65M38YZOBebbT8xWKaUKV5I6CWJ4OSfeWhPGNt4QRquW1K
l8O7ZezxkgVNYUNdFU//6DC4WH2/y1WXKsz0M64fuf4OPvzVQUm0pQgrOXok
cU0BY/UZMbXW88hqIj/UN1EJJ0zkgbqCORTIKrJl31KCirPafa/THAq3ecOd
KFOCtnkTZW6NCqWYdXNi5UqwOqZK9dg0i+Ztk/hSggSuQ06cS/0MCpB9VOwJ
IaG5e1uYvdsM0pn26HOMISEebq02oE+jfvudzfl8Ejo+Euaagim0Tiqf319M
Aj1X+WXGagrdOcBx3f+MhF4995Yho08ooJAQMkgSWknabz7Jk8g7AhjVKhKe
N3Z5F+tOogi+QnJBF0PJuZNF8Vof0aCj8dJJZwy5+5iHZecmUNmoYjJ9PYYs
DzOr7Qsf0IujETlnmBgMyChLl9H3SJIorTQKw0B95jxbMD2OuOOcsYUIDDNZ
ig5njXFUI65L2MjFMMp9WPpYdwzNPXXIHkzEIPUP4zmajqLKHay7HUkYOpyt
Ih5aj6Ajyrti61QMYq0+pi0do2+qKhOfZWKoG8iwv88gkWONxeq6exhKnwRp
WBFK5BhMDdTJxeDjK5YPMxTIJv7Cj8sLMAwOeooL6e+QeOZROacUA/d4cX6s
zTDacV7yaaQSgz7NLtnLTI7G7p8qy6nB8JB/89gifRmKJNsyeHUYPFfpBDdT
36IHSb7s4gYMbU8T1t+YlSIWfe+QllDNeW/X/ykZRBlrU6Z5ajYy0urLG+lH
0Qy6V4iad8Y5xN9W9SHYzWP8gjD8Id267PriXmSzEk101mNoZ4Y3xJt3owS3
y6nXazGYFF8JjVrRiWZ0IjamPsEQZJpPYa3rQA6ri2C4AkN6wqtsvy1tyDX9
u7akErUv+dhGCGpFzSbIPz4fg8Vw6LbxnlfoFH1X2YAAwzWKXI+l24Q2vPR6
lKn2NW8Z3tq84Tk6t34hN0/tM9ptNM0r+ilSul5lLFX7RgJp0R6oRTeTv5V1
q/vIkSgZHjnlqCEwxXda3dd9p2HD4XupyPRqucZ3kep717eoqjt54Ga09U38
fgx+e5de8vN8DP6PNDizgRiqBAZNzAd1ECffxi53xzDgv1Jb77gIHOs/LZ9y
wvDWr2nFifRGKPUvZJ+xwIC360Zs7noNlk1lQ3s+k3BQbhk5FfIGWEtQD1aS
EGRXluOztR28GhRxki4SXLMHDN9bd4E+weomy0mYzHLDnp0D0Bi7L6H9IAk7
XEuuJHClgPP4D178QII9f7NV//khSDE5yDRcR0LLoShmVqYMDp/s9cnWUucL
DbcsGhWwmW3XqcdXQr2hJu/mKyV4S9vSWGeVEGzLvGDUTsLJkki6JVsJScwW
jo50BCbTKxwHVihhJHXQU/X5PXw9G2n9ukABjLRrHvTWSbCJyaspKn0HmOu7
Yc30DPimhXNeXxqG072ZV2L/ngPrtb/e1d8tByF90YBYk0KIigqjXagyeLnp
TpWhMZVwT2nNcskdApHlXMXUP5qEgb5p688/SSH23IiAaaJNOI1cNJ4c7Yez
O+cLGgK0iShx4Ikefj8k2etXMJK1ia7LUnOZTz/wxatEdjo04qXo/PIYgQQe
8KGJz6QR8w1LemYDJVAQ6d+65BKNsJXKL1ZQJVDlHdaVJKIR99KWFAhK++D/
f0u4CY43tezvg38BiNrpkg==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnk01Hsfx2cxJtslJilUKJIbKYOIzy9u9iay5LFvV6R1CimkbCmRwg1T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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FHwXB/DJrgllK9lFm45SJDNmrhJDymhIJdtoL0tFemn0WB7hIYps
E2WZ0WZJlDL4oWiUiixlSbIOxs5ghry95zxv7jn3fM/n3/vP92q6e1NOC2Ew
mL9/7/8Srb7SubQkXoH5d1xw9LzLVcteOFl1o+fvZe8pllV/J7nsZ86FrjFy
Yn/cr+o++mxR+I+3q1kfNcAKVVwLTtPJ19RWGH/bhPlLC1ORzJUO8fT/R3ek
LMmbpbGARq93Bz6SbDTyle+1wzIFKKlic5GfW/Ee/oUde05sEaAAilJ0POGm
sdi6WoxAn4/ONIvtxY5wcNFeCn0HXs4j6yL6rvNvg/Cy1dRaOm4evU+IVKz5
KGaSrJyXO1Q+h2St9FbikoNM1K7w7+DM5lD/JjOPEbNhEz+dTP/tZbPo6OVP
ZyzcKISP36yo2kaz6IiyOpV4PYegHT1hqVTAQ6xK4W2+DXwCDVJ2SOvyUKDa
j9caOqbEpknTdcLMGSTK0BTMSwcQdbM5S7NqMwgrMdaYfzmXGHL89gA3eRpJ
n9l5rYXwjdi2as/nn7LTSGL1fo1x3V/E+kHxcMvYKWTgec5hd4EKVNd8JeZj
p1B2Yd7zmxt3Q0nWQ55CxCRCdmJscvBBeBZ0LY8mMomCfkVES9m6QrYz6UxP
0ASqV5E3ssJ4QSpurdqBxXHkEHsb2LH+ELd2oPmZ/zh6bCXT/7EoFKQHPZW3
c8eQ8XqhuZDhKBB6s3UuhzeKKiuaA1PU4mA2daBp64pR5Ip9oSZvnwhcP0bB
I+wISgqxIZofp0OXLTVmoyIX1WgqJy0spUHTVrWLDI1hRKIpvpFOTAe2SDtJ
S3cI/fNhrPrQYAaUdiZppxsOorZOIn6EnwkFr+xXqJlykEoYNv1OfRZYHmT3
9hkOIDmL0bQXgQz48QPPztXtR7YfZHVi5xjg55P/9KpmH3qg5Jqmas0EKfEN
sYS1vQiexrgEBzKBQU+8IirVg3I6a61iE5iA11vp8FGoG6mcWiX7LpEJXyoD
jRPmutBUq2RyeMhvP+k2Lun4garTayTOH2OCrKxI+5Ph74hqrXq6SZkJFH8d
2j1+O3pVc7s6hc2AuC4L1WjJNqT0cO+X004MaCSdK6et+4aWROWTsM1ZIJ8f
6eq5qQXlOC1mDezIAnvFpxiX3U3ohvUCBeedCXcD6zJszL+gTT7TWy7fzoCm
3pF9YF+PyHgl4aO/77W+z9VqtLUOqWp0PA2QewBRmN5VLthatHaj+mJ4Uyp4
GXHjCV6VSLjasSZ4TTIgZleeI7DQXkqljEt2AmR2cAxxmYXoe4vWfKl5PKRv
6ZPpe3AHlaVISdlk3oKFaHN+cUsMPM4V6ZG0jgSbEwphNvhHMNU5KK7iFgZ5
j+vCrrkVgfNnN8xjTjC8ZErXkrJKgUStvH/1QyB02m4WW+VTBZHMTmd69n+g
26Z2k+/dGvD2nzimb+cL/QcvWHW8eA+RfLeS+tJLMHQAe3H/10/ArmhxMU+5
CKd6lT1mjjXAiTjJzWSNs2C/4XmmpUUjaOiZcMVpJ2G/u2XrvV3NQHHl2ppG
uYFBRqfMmMZXkEnF7zCgOoF2l6/FPulWSDG7ZfaWeQzk1bGBCYI2EBc2idpe
cgREXDIKOZwOcCuTuRtKs4OpVKMhfEsn1J9Lcz3+5TCQDZ5FBvp1QWktXSTv
ri1o0/erfQ/+CXiPtydfsMjAX/r23ORWN+wU1XU6YkOGz6c9SanJPVDZ5vXW
YoAMjA8rOgRZvcCI/ys8o8EWAvQTL53I74PTq9SbOc4UICdtFWWV9MOv6K34
OrY9aC+Wp6yvGQC3/sIGqssxKJMRjkms4wDOV79P2s8ZHLRIIbKNg/D6vv/k
Bao7jBlE+cW0DkFBRPE2s9SzEEH6fGFl1zDoiqBiTxVv0HSUc73Zz4VtJeVL
bSO+UOJx1E5oZAQe1myu6E6gAeWve6QbU6OQ83jAdlduKAzf+YHnz49BgLuX
l49sFBD2hf50vzYOFJ/DHa+k4yCMpchkT4wDxiPLsYaRBB8NnpzT85gAEyUn
SyeZ+6CQR9h2t38CqpntvgH2meC8qWFs3m0SHJz6lHo2MoGZfqrQtX0SJCwP
u6WVZ8OI0pxf9ZEpuJFTX8Y7mw2G8VE43fop8ImMkbD5lgU5+W/4w/bT4GjU
ofhU9T5o1QlKclqngXfQWIqrEg8pnF3XPV1mIMabjKvMDoXVoh54vZ4ZEHO6
JUWhe8NNTYZg9CwPriSp+7PU7WCR0MHK5/Kg6zxZDl+0A3wd5WmXLs+CqWKh
ub+6CAz5HTTR581CxTv7e/qNn4lOwrxqpStzIDUd6qCzJZ74KfYBWWh0Dg69
euheonWIaKpi1Tp0fh4WHxUnbk/lE54/mnRv7JuHYByNIp97j6BtmMplUfnQ
pPLV3YGnR0isNPdjfOdD+BpEGQ4vMJGwGVuKPi6AycMPzsm3aJkEtCVHXm0W
wEPWRC1tJBivvHJA5vWJBaArdEpt4bBwpcaGiQs/F0DRhb7YUd1uvJjckBk6
ugg74yr1rNlVRhW6op1sYYxpqqDqEj6zS/+9WdpLGTkh02kJ9VP+IT0qVcqC
oplfwqb/79erQcNMkrzYH9+gLOSUH152hLZUkWHssulsvaoNK8X/OIsOtXTS
snM8bOvXhC37JZH6NaJq2f/+C3/8X/5C3CA=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs01HkUwCePmZDHImwy5S0KrdFg6M6WDLISKm2L9JCobIXtwdY6KWFJ
qLx2KaSHVw+imu805bVRXlFoDGaQmd+XEqYh7ew5+8c999xz7/3n87nnGu6J
9N0vRyKRAmTxX0Yax3jfvlE4F6Yf/vDreyEEOeWUH+VSODRFen6NygjM7+X+
PnyOwhlrWLO7zXEEHGo0VzQqyeZzTyyEZ41AZeD94FQtMkdSKrw16zEKIwZ7
cOVXeY5tn9Q1iDsGNtTNO2gqchydCsdCC+VxmHzRRTpjROKER4o139qIgHh6
NfLxynl0tDbWq8RDDFHaAj+V4jm0Sb/ip/oDYpCG2zrsWjWH2G8oWh4JYiDr
NZPm1krRgS8ugTFsMVCPSdOdNkoQ+3jBFutVBMSYXj9p83QWRVKfZ3q6EtD6
1iPEhD6LYiTpCflBBMRCtq2a1QxareS6mXeJgK5PTD354mm0w1axrrGUAKuS
sW+z1GlEK+hYPIAI6F3i8HpQ8zPK1pWnp4kIaPtAueCeNoWSXjCWNnwjoL6h
Z32FyhTCmzsVrLQwVJ79rTxW4ROi2PdcOEHHUBLICh0++xElu/EWAt0x5Dnp
Uj2/TiKal8g7IgCD2ofD+jbiCaQ9FEOWRGOQe24puTuDUd07F3ZGPIbZvNEu
y0UY7aNfUoxMxSCOKaoqVSGQkoG5JDEbA98nJNVMR4zUJOoc/g0MXZbUiKKV
IiQJaMyKLsPQpNDHMrIaR6cX+XLcqjE84V01KbD/gIJN/LP82BiqHvkvojLH
kGen2cncegzuXk0Cof0oQhc5+wtbMAwMMJrKrEaQl173KXYHhpjjFXeiDYUo
v9JizaceDKoU4zQXXQFi3bImO/djKMq5ckxRdRglapkW5Q5gYFgrb2+VG0IR
LtQ6jSEMHc/iHLMkfBRnoKqROyyrbw851vUPoNji1ngnAQZNTYW+26L3qEaN
s3VO1vc9aRqbK+1DLpe89k7I9i/z3QxSlHqR858bWnQGMXSywtixem+R/uVt
VUd5GLQrLgYfNu9GpzP1WKQ+DP46d0hB67rQOdPZdm43hsy4lkLvTR0IX11d
Utsu4yUgNoB/G7LRrzUXvsSwTBjsgd+1oPU4UO+gjEcySbAkSKUZpX8eT7GU
8ZrXD2trda5HCQkH1S1lPI/QxRkuR54hJQdHhzAZb1TML/8ZHiPhwnyZUObj
ev+YvdP1+8jl3HnTGzJfBauE6sK/0xFDPsNuUOZ3PmWTtKY7FRpC4yc9Zf69
dy1N8GaUAmPF0KPuUAzVxWrNrBtPoCxo2/mdLAw8HwvykuNcIDdvYfmtwzDk
3WweldkAb5SMk6NMMIx7qkS49ryCJHXXfrsFAvYJ9A9NB7SDXdnNWgfZ/fob
37vu7tYJ7HRtdL6HAFohT31iZQ88jH9mp1BOwFQefZzRzYOU5zvNqnwJ2EKr
vBgXw4eFcRyh7UCASY4r9f0fg5DwsjeucjkBr/cfZuVdG4aGvMnUvGExmHxl
Zy9rGIWVS6vDk8LE8FRdPvVKyxjERe15mOEuhu1GrHjNzg+QVfJ9w6S5GBJZ
r8OV+SJIeWA4UikQgSh9gCH9MgH03b94XtkuAvuMZCertikIzLz3Ipc2DuMx
Xs5rZ2ZhcQTNelvvGJzqvXYx+s0cXDaTD1Y5MwocK0VekzyJ2V59SrpiSgj/
bMyvVteSY/ph6j1WiAC4+nMPphfkmc2GjaGnBUMQfVZUzNImM9t/TJ2xYA3C
777zd9lbyUz3jdeMuLqDkGii+sA+jczsD8S3I8f4kNNkzTVWpjB7Ve8c1Uji
w40caM5hUZgRy+gEZRcf7h7yafsugcL0SdCD5av5UL0+pCeRS2F+1OcM/yUd
gP//LdPm5it1Vv4A/Auuhdqa
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnk8lIkfx2cMM4uQW86SDik6KMbxfVLOJFctIUdkSuPKsbUoO6ay5FhE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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FHwXB/DJrgllK9lFm45SJDNmrhJDymhIJdtoL0tFemn0WB7hIYps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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHsw1GsYx9dttxCRyqT25JLK7rgUkduzIrvUoYspXeREt+PWyaJROFEm
0iEnCumqbYx7ikrxbttRnEEKkcvata57+b1yP3Zx9sycP5555jvz/evzmecx
Djp/4LQqiUTyV85/G62M5C8tUbhFTLUq4YNhOOGYV3aBR+G+8SzK4LUMgyKY
lyC6RuEGnVI3Zy8Og8Mr/Z8+Ladw95qr2DoEjEBFwIvA9FVk7uqWNztVDUdh
eEMQUbGgxm1aZioOuT8GVtQ9h221VLkMiu+e1HExjP/VTvrdhMTdZEUiB26U
gqz27vm3GxUore94hNhdBlEGgwe1OHJED9oiXRUsg/kQa4djW+XosOh1a36i
DMiGjSS5zTy6ysma/vBOBtTI+UxH9zlkY8paSacRELPpSaxV7SzqdbaxcmAS
0NzlddLMfhYlemepRwUREAe51jq0GXQr2jz4wh0C2icYhmqcaeQYygq0LCeA
9mx0aZY6jbLE7Dm9TwR0azt8FupPId8cSrHHFAGtY5TrrIxJdNje7hfL5Rjq
P3a6lmtNIg9f9pDrBgwVVy6WxalPoKHYT9nNuzA8C2CeEV35gYKDJlJYfhjy
HddSvRfGUd7a5l7RKQw6Y+FGVlKMwKVaNeYqBtUPFnMlMwTyTy72TLyFYTZ/
pN1ChUBC0mN2fT4GaczT54VaMqRhH3bfrRCDYN/JdPM1UhTIrRqeqsTQbkEN
fbpRgnZor07kv8PQoN7DNKGJEX2vRelCPYZ3/Ltmj+zGUHdidc3+FgzPX/up
UBmjiF70fFl3BwbW3obBIbsRxC/sXEvtw9Df79RQShtG5MjL7hdEGGLY5cXR
xkOo3Std/nUUwwqKaYbL2kGU2hxev0uG4WnenUiNFSJUazbjxB3H4GSpeahZ
dQBNqWXq7pnE8PV9/M7sOQHyjXcji6aUuWhgZ01vPxLml8ivT2PQ11fvKZL0
Ie22P+55KvOB2E1x9+Z7kKyiKMRG2f9T4Lnh5vJutFR1I4E1gaGNea4uzrAL
1ZqYL6RhDAblqYHhm7+hJB3heoUEg9+aYtKJHe2IF3DNLHcEQ1Z802Of3V9R
Qa5taPCAktegbBf4tSJJ0Rn/Y70Y1g0FehHfm1BJia2Yo+SRRhrUPqHViAbm
PJmblbwURudam53rUZJJ2GK/kmeEvfS2S8R7dKqNWdqq5I04grKj8BbFugFp
XunjSe+oneOTFyizLbjyuNLXo61DukMPM9FyZ+9fvyj9Km7unn/1LR2mBs7/
4CVh8Dm2OtnHqRD0Evy/t7AxVHN0GpkF7+Dadrmu00EM/H1byNpsHuT4N217
4IZhwKdxc1TWR6DxNgUYW2EQe2uFenS2wM9bqxjpFAynBo3Cpv2/wGzdZWvJ
JAF+ppVPWJ5t4BrKmbnRT4DtY74u3tgJUpff6LkvCZjMtxc7feNDYUHCFuoh
AnxtK1LjYwSQissV2Y4EmOV5UPsShVB5qasGqAR8Ph3OzM8RQanPgy/bRDIw
W6jLXfdxBPgdBt/7lfdbq6uWfqdpFKT3xo607JLBIRNmkn7bGJyt0CvVNJZB
CvNziKZAAopH7h0Xe6Qgyex3mv9Hye36Q5UolhTsbqc50lonoSnWdZG9XgLi
mL3ONjOzsHufotOuegwudeekRnfIoebss6sSn1Hg0jT4DWokhkW9/9H9VcPw
t/v9at1Vqgx6BEWYvXoIeEbyl9OLagzVzdtyH6WJIPqKhMM0IDPo4wXhGgIh
JBxQlNTtJzO6Y5CjvEwIKWYrXtplkBnG1l6G5AQh5DVY8kw1KQyVI/SJ4PVC
KMiDxjwmhbG9hrb/rUQAJWH7WvWSKQxL98fJ1m8FUO16sjOFR2Ekyugl9TcE
8P+/ZTSJiK64owL4FyD44dk=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk4lQkfh8+urI1olCVTEaNIMYzK/0E6to4tZbLNSUqylCzJEtnHlk7W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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ5wrNE86OzdwfDhyBWG
eiWGA+eXBmns+fRe7O3e6fm7Ff7sP798rWT4TzNluaJfE62cf+y/w+Do2lsc
oHGLx+L8Q6Ev+w9/SNOoNEnS4nuZK63/5v3+3Mr5lqtvfNDauCOEUc7hxX7x
/X92J7xk17606pHlrjv39wv21M23OcSpfeXJWyf7kAv7XyyQ0QpkYdFeoPmU
/+n8ifsff/0+K/fhR61XXtzZLtfP2Wce0HnKvfyC1uc55q+sr92zv3AlWHVV
41Ytlb/7Zkode26fsck+yiZjr9brifetf/18b6+rduX2ptAPWqaTu620L3y2
/3hAdO62T+zar8p8bAy/fbfXSPncftvYWKvq1ozO0qu/7fXyHjFnLXqqdkCb
9d4JZgaHpeKn+VcLuciecp67jV+YyWHNR4PHSt3uHIekf2/5+o/ZARZ+pQ2v
l7qLsMH5dUF/1uwLRPA7VHi3mPYj+LNO6B1S5mKH8xfPsj85yx3BX5MTcEGw
FcHfZpd4veMQgg9ND3A+AAXi0O8=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtVHs01HkUn7wmj9AgyhpEZISck0fEnUqNHmtn84icxqL2qCTJYwlbjjYk
kpZM5F2S0Cq1Jd8xIVqWGEYeY8J4zPx+KOs1HrOz5+wf99zzOedz7j3387n3
GgZcOnFWhkAgeEvjv4zUw3gSCZHlzqvJSlkcA4YDs/Iym8iifzcbJDISwGog
O340kcgSEyzi9ekCsH9F0v+gSGRdF1bNLTwWQPXpGr80DQUWhXJs/1bPcRjX
C5iuXpNlJXJ1nJTqJ8CKfOzkHmUZ1qpMgRZjaRJmGzmEX7cTWEme7Q/WNgsB
f5d96a3BKsIjA7vsDUQQrjnmrly6gj4ZGerrOolAfH63va/ZClozs7kT5CMC
BZ1Wwoq1GAWY+VTsuyMCcpg4w+HgEuI2+aTcXRBB5I6iaKt3iyjVmcPOUMeg
ve+Iv7HdInpY3CPqMMMgFnJ2q5ovoLbQQDrhFAacb1Qd2dJ5FOev6jEdioH5
o0nJInkenWvd9pl0E4N+FfuOL6R/UOfH5IrFagw6p4g3XdPnUKihHeFUIwZN
zVznKuU5FDWZITfXi0H1tajKWLlvKMRSmcNexuDRadrPo9e+IvpydPGCIg65
Dtrko2uzqL2/eJfvVhxUpy7qWmEzqO1lv/VzGxxk3lOWKhamUUqUuXfLfhwW
cyc4lA3TiLUUNG/yPQ5YZMnzMmUcbUytsGw7iQOf7p9msgVDSTvabV/548Ch
kC+UGIjQVZ1ot4nzOLTIDdC2mwvRn3pujb5XcKjjZRsX2EwhyJ/5R+MqDs9f
e2wgUydRuovuMbUEHFyPt4wJbCbQQHmJ319JOAwPO7Y8Mx9H4Wb9u8rScIi8
UvU0wlCAbBVsLEozcdhENEp30h5D+V8VZxqycShhZoXJbxpFT0ZzNNeZODha
Knm1y4ygUHkDD588HLoa4vb+vsRHjSWDUd0Ppbh8ZO+bwWHkZ6XHCM7HgUSS
GygXDaEy96tNVlJ8InpH7APxABrZSumzlPLv8g/rpSr2I1ltcvm5XBy6aUH1
sTp9SGsuicHPwUGzKtnvomkvUhngmGZm4eCx5SmBYctBL8R5tIS7ONyLayt0
O9SFaiVPVCtvS/Uaww+ARyc6+3hocIt03m0CvyPTn9uQs67cKu86DrcIYyoM
5VZ0uWf+ARaDw6puUGf7viYk26G+nyrVM8QOy3QKaUCUhLC4fqneqJRfeQre
IpN2wexbqR9Fg5M2DkU1aMCkw1Ug9avATKAmyM9AT0M08kkHpPVSD4lf9aYB
Sf2jnbLUfzdfrRtujmXQa1a+bGmKQ22paiutuA6Y9YVDqxtx4NF3KqhcYUO6
xpeHT5YwGHFrNQ2/1wyRv9h/+G0CA+FR5Qsu3L9B7R7jeB8bgzNjusHz3p8g
UCujrkS6vx5GfxS5Hu6G8NdHuA15GOwp5KnNGHDBsCMRzUVgMJdrJ3Ts5UHZ
zmDhT2QMfthTnRwXyQcd32LJgBwGxkwX8tD1L3DN6pnafaEIOs5epOXeHwVP
yl6XwRoRGK/V52xrnoCY24VGfdL7facmm5bVNgkBXSEJ1voi8NpOSyB1TwEv
1/CNQCKEJFrHeSW+CDIrI2eDkBBEGcOO4uUZyFSgRxnbCcEm85aDeecc2Hpy
R0mGUyCMPL7PemERBvMTLeR7pH367ydH9KyAJE9lbP3mOLDM5XktsgTqbifc
20tFAB8P5tWqachQnYRGdpKUUWDrrryYX5elmlpJmnv1RiDimqiUpqlA7X3p
RInP4EP8idWK+h8VqFraCXWKZ/iQZLzphU26AjU7Zp1TZssHZosl20iJSPV/
T653fz0MxUxoZdKI1LWQS2x9xjBUBNM7N98gUnNjNmgZyQ1DrbM/N4lNpFrE
KRb4l/Pg/39L9UoXOw3TefAv993b6A==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnk81Akfx+dgxtEihNaRckR2Y0RC5vtz1GhyhdSaRSRsKFmyRE054nFl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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ449J9l0brgyfnhyBWG
eiWGA7Pmn78l8nOD/Nu90/N3K/zZ/9T+8y3pzB/ackW/Jlo5/9j/12z6r+dV
goa3eCzOPxT6sn/D4iyLZ+HKxnwvc6X137zfz9VSPi/i2UbjjTtCGOUcXuzv
vb6DVSPjpPGlVY8sd925v/9WvWXp1LjTxleevHWyD7mw/+72wtL9LkeNF2g+
5X86f+L+p3IK7iv/bzJ+5cWd7XL9nH2PTu+7eRsnGn+eY/7K+to9+2ij9YIf
b5YZq/zdN1Pq2HP72xJC6//Y1Ru/nnjf+tfP9/aK9pJr9aM3GptO7rbSvvDZ
3ui3TIRw0UnjV2U+Nobfvtv/Y79z2iH9i1HVrRmdpVd/28e9m264988y/QPa
rPdOMDM4HHjIIf4/mFXtlPPcbfzCTA5+bL69rCycgoekf2/5+o/ZARZ+pQ2v
l7qLsMH5dUF/1uwLRPA7VHi3mPYj+LNO6B1S5mKH8xfPsj85yx3BX5MTcEGw
FcHfZpd4veMQgg9ND3A+ACLc0ec=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtVHs01HkUHwazNaGkKDUVKnGOUiaPkTtEQ0mUymrTkcexipY8jvJOJ63W
sEIGG+NxFIoeoml8JzZLEZVHkTHm9yWMR5KIkf3tOfvHPfd8zr33j/v53M/d
cvbCUV9FCoXiTsZ/Ga0MES8t0UQXaw/7K5/tA09L3r3gepooyzTJY29+H8i9
62OIRJrItbKQZyDuA/MnGpv+WUYTXbb0dbH9WQyVpx+eSVmtIvIeP29IHOqH
oY1nJyoXqaLetOyEHr4EdjIOnTSlK4pSB6VT62IH4PPfHZRYXYroeKPaZJCd
FMaFWRcEm+XodrLDpSYFAkI18TF68QLilL3OV15LwHzALvNTOxZQiV9kZM8O
AlS0mykLJvOI6x6WYO9CACNkPs1y/xwSlnRbzmcREL6VH7lTOIvCjd8nmNwl
oPW9o5e+2SyaMVZLHBAQEAXZu9SMvqFjl8zTivsI6PjC1qYWz6Br0/Gl1eME
GJUML80yZtCr7HWplosE9KwwbxvQ+Ip+cb7jm7EeQ/sI7ZoDdxp9pLZFGhpg
eNHYbX2fPo0MhvxidzMxVMZF3ItS+oIkprKZzMMYSk5z/Ii4KdTAEByZcseQ
a6nFOLj4GeXwVgY+9cagNhKos3NsEr1q/MMhIwKDYoPhXPm3CVTkbbVcLQ7D
bO6nDkOFCZScejRGOQnDWHhRVSl9HMntguiXuRgkLl4p29aOISXb11uCMjF0
GDLOFW2WoVAdH5Y4F0OTUi9H12gUpasO9r7kY3gmztLPZ44gl9wPqXtKMVTV
uCkw2MPI4nvZlFYFBgenJjzI/IQua1UttVVh6O9nNVUYDaEDj4N5sscYwi/e
LwvbMoj2bPP0CajFoErT4+7Twqjnbruq0zMMRbzMEGVVAqXYrDueWoeBZbz8
RKuiFKn5XVMxE2F4+zzaImNOgsaFwXJ4TuK7UounH/uRTSVrUxmJNTSUeu/K
+tCXjTl34kh8NHJrVM58L7LJTeG3kPN/Sg5svLGsB9k9XaXNRRjecfzrorTf
o6HoVt0mIQbN+9fPBG7vQm271wxFCDC4rS2jeO7tQIbvB7h/1WC4Gd1S4Gz/
FtGNW9ytyH068LgtuLWjO97Kia7kvusHzzhOfGhB71w3aH8rx5BMwSs86c3o
YF7DDy2SL7mOf3ur1QsEVMHNJySfQWZj6fuCnqN4Dx92J8k3Kpbc8wABspNW
BweTevA/DjMt+Q9RoLcJ/wapV/6OQfXB22no2HNijS2pr/yG/fyTrhRgjs8u
bCb1dz615qozqxQKfL1QQCCG6mK1Zk7hM5iKkB+yJe9H7GKgsuJiPYTmhcre
OGGQOjdvD73ZCDt1kjXb2RhGD9LP2XW/hj0n7c02bMfgg3XOz7i/gXCrqw6n
yPt103vAdzjwDvwPC2I2qWIwLRCrT27uhmbreHfWFAHTuWajrC4xhDAF6eKH
BBwxrbweHS6BUqbDD3kBAfo8O0Zf/ABIf6KmZnAJaPMN5OTeIqBilJ/K+pWs
L9Zlr2/8BBRdP43fSf8K1akpmS3D0Cz78F2d9PcJXU6CxrsRcKy9bqArk0IS
py1guUQGK+tzrn0RSkGW1s+a/z4JDVcCtkZ4SoGZnmxp1D4NRgxCdDtnAEbD
naxMvs1CaYJL6dcHErjUc+t6WOcC2dfyYm96P4iMlMVNVApbOSlAwzC2D17u
z6tWX63ITqoRjm3z7oV6nYVHMz+obMGEzfHz3h8gLE5WzNFUYX/2EL6Sm3VD
zFF5eZ2rCjvaojrPca4LkvRVHzG5Kmz9Dr2Wqpou4DUZ1+stp7Frf9vU3W/R
BYU8aOZxaOyPLyd8y+Y7ofy8S/uqqzT2oNvpx3mCTqi29upOqqexuYWlV2qj
OuH/f8uuoCslKlh3wr/XiN1c
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk/lIsegMeMoTgiS5SQ6OAQqUG43u9bZISDrJXGHiWSbZyksmU92Zkh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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FHwXB/DJrgllK9lFm45SJDNmrhJDymhIJdtoL0tFemn0WB7hIYps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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlGlQk1cUhkNAMrJWQKAwIrtCpqKWCIJwvroFLUUQiqg1SNxo2OpCFAVR
qxaXBigoGHEBDTrsO1KWG2PF4IggUNYAwQST77IoIosBatOZ/jhz5pl35vx4
3pljw47ZeYhKoVBC1PPfRl8dG/jyhSYsrA5OPfL+LbA8+EVHRTShp+r302fM
ZDB/QHRWdpEmLE65M38YZOBebbT8xWKaUKV5I6CWJ4OSfeWhPGNt4QRquW1K
l8O7ZezxkgVNYUNdFU//6DC4WH2/y1WXKsz0M64fuf4OPvzVQUm0pQgrOXok
cU0BY/UZMbXW88hqIj/UN1EJJ0zkgbqCORTIKrJl31KCirPafa/THAq3ecOd
KFOCtnkTZW6NCqWYdXNi5UqwOqZK9dg0i+Ztk/hSggSuQ06cS/0MCpB9VOwJ
IaG5e1uYvdsM0pn26HOMISEebq02oE+jfvudzfl8Ejo+Euaagim0Tiqf319M
Aj1X+WXGagrdOcBx3f+MhF4995Yho08ooJAQMkgSWknabz7Jk8g7AhjVKhKe
N3Z5F+tOogi+QnJBF0PJuZNF8Vof0aCj8dJJZwy5+5iHZecmUNmoYjJ9PYYs
DzOr7Qsf0IujETlnmBgMyChLl9H3SJIorTQKw0B95jxbMD2OuOOcsYUIDDNZ
ig5njXFUI65L2MjFMMp9WPpYdwzNPXXIHkzEIPUP4zmajqLKHay7HUkYOpyt
Ih5aj6Ajyrti61QMYq0+pi0do2+qKhOfZWKoG8iwv88gkWONxeq6exhKnwRp
WBFK5BhMDdTJxeDjK5YPMxTIJv7Cj8sLMAwOeooL6e+QeOZROacUA/d4cX6s
zTDacV7yaaQSgz7NLtnLTI7G7p8qy6nB8JB/89gifRmKJNsyeHUYPFfpBDdT
36IHSb7s4gYMbU8T1t+YlSIWfe+QllDNeW/X/ykZRBlrU6Z5ajYy0urLG+lH
0Qy6V4iad8Y5xN9W9SHYzWP8gjD8Id267PriXmSzEk101mNoZ4Y3xJt3owS3
y6nXazGYFF8JjVrRiWZ0IjamPsEQZJpPYa3rQA6ri2C4AkN6wqtsvy1tyDX9
u7akErUv+dhGCGpFzSbIPz4fg8Vw6LbxnlfoFH1X2YAAwzWKXI+l24Q2vPR6
lKn2NW8Z3tq84Tk6t34hN0/tM9ptNM0r+ilSul5lLFX7RgJp0R6oRTeTv5V1
q/vIkSgZHjnlqCEwxXda3dd9p2HD4XupyPRqucZ3kep717eoqjt54Ga09U38
fgx+e5de8vN8DP6PNDizgRiqBAZNzAd1ECffxi53xzDgv1Jb77gIHOs/LZ9y
wvDWr2nFifRGKPUvZJ+xwIC360Zs7noNlk1lQ3s+k3BQbhk5FfIGWEtQD1aS
EGRXluOztR28GhRxki4SXLMHDN9bd4E+weomy0mYzHLDnp0D0Bi7L6H9IAk7
XEuuJHClgPP4D178QII9f7NV//khSDE5yDRcR0LLoShmVqYMDp/s9cnWUucL
DbcsGhWwmW3XqcdXQr2hJu/mKyV4S9vSWGeVEGzLvGDUTsLJkki6JVsJScwW
jo50BCbTKxwHVihhJHXQU/X5PXw9G2n9ukABjLRrHvTWSbCJyaspKn0HmOu7
Yc30DPimhXNeXxqG072ZV2L/ngPrtb/e1d8tByF90YBYk0KIigqjXagyeLnp
TpWhMZVwT2nNcskdApHlXMXUP5qEgb5p688/SSH23IiAaaJNOI1cNJ4c7Yez
O+cLGgK0iShx4Ikefj8k2etXMJK1ia7LUnOZTz/wxatEdjo04qXo/PIYgQQe
8KGJz6QR8w1LemYDJVAQ6d+65BKNsJXKL1ZQJVDlHdaVJKIR99KWFAhK++D/
f0u4CY43tezvg38BiNrpkg==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnk01Hsfx2cxJtslJilUKJIbKYOIzy9u9iay5LFvV6R1CimkbCmRwg1T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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FHwXB/DJrgllK9lFm45SJDNmrhJDymhIJdtoL0tFemn0WB7hIYps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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs01HkUwCePmZDHImwy5S0KrdFg6M6WDLISKm2L9JCobIXtwdY6KWFJ
qLx2KaSHVw+imu805bVRXlFoDGaQmd+XEqYh7ew5+8c999xz7/3n87nnGu6J
9N0vRyKRAmTxX0Yax3jfvlE4F6Yf/vDreyEEOeWUH+VSODRFen6NygjM7+X+
PnyOwhlrWLO7zXEEHGo0VzQqyeZzTyyEZ41AZeD94FQtMkdSKrw16zEKIwZ7
cOVXeY5tn9Q1iDsGNtTNO2gqchydCsdCC+VxmHzRRTpjROKER4o139qIgHh6
NfLxynl0tDbWq8RDDFHaAj+V4jm0Sb/ip/oDYpCG2zrsWjWH2G8oWh4JYiDr
NZPm1krRgS8ugTFsMVCPSdOdNkoQ+3jBFutVBMSYXj9p83QWRVKfZ3q6EtD6
1iPEhD6LYiTpCflBBMRCtq2a1QxareS6mXeJgK5PTD354mm0w1axrrGUAKuS
sW+z1GlEK+hYPIAI6F3i8HpQ8zPK1pWnp4kIaPtAueCeNoWSXjCWNnwjoL6h
Z32FyhTCmzsVrLQwVJ79rTxW4ROi2PdcOEHHUBLICh0++xElu/EWAt0x5Dnp
Uj2/TiKal8g7IgCD2ofD+jbiCaQ9FEOWRGOQe24puTuDUd07F3ZGPIbZvNEu
y0UY7aNfUoxMxSCOKaoqVSGQkoG5JDEbA98nJNVMR4zUJOoc/g0MXZbUiKKV
IiQJaMyKLsPQpNDHMrIaR6cX+XLcqjE84V01KbD/gIJN/LP82BiqHvkvojLH
kGen2cncegzuXk0Cof0oQhc5+wtbMAwMMJrKrEaQl173KXYHhpjjFXeiDYUo
v9JizaceDKoU4zQXXQFi3bImO/djKMq5ckxRdRglapkW5Q5gYFgrb2+VG0IR
LtQ6jSEMHc/iHLMkfBRnoKqROyyrbw851vUPoNji1ngnAQZNTYW+26L3qEaN
s3VO1vc9aRqbK+1DLpe89k7I9i/z3QxSlHqR858bWnQGMXSywtixem+R/uVt
VUd5GLQrLgYfNu9GpzP1WKQ+DP46d0hB67rQOdPZdm43hsy4lkLvTR0IX11d
Utsu4yUgNoB/G7LRrzUXvsSwTBjsgd+1oPU4UO+gjEcySbAkSKUZpX8eT7GU
8ZrXD2trda5HCQkH1S1lPI/QxRkuR54hJQdHhzAZb1TML/8ZHiPhwnyZUObj
ev+YvdP1+8jl3HnTGzJfBauE6sK/0xFDPsNuUOZ3PmWTtKY7FRpC4yc9Zf69
dy1N8GaUAmPF0KPuUAzVxWrNrBtPoCxo2/mdLAw8HwvykuNcIDdvYfmtwzDk
3WweldkAb5SMk6NMMIx7qkS49ryCJHXXfrsFAvYJ9A9NB7SDXdnNWgfZ/fob
37vu7tYJ7HRtdL6HAFohT31iZQ88jH9mp1BOwFQefZzRzYOU5zvNqnwJ2EKr
vBgXw4eFcRyh7UCASY4r9f0fg5DwsjeucjkBr/cfZuVdG4aGvMnUvGExmHxl
Zy9rGIWVS6vDk8LE8FRdPvVKyxjERe15mOEuhu1GrHjNzg+QVfJ9w6S5GBJZ
r8OV+SJIeWA4UikQgSh9gCH9MgH03b94XtkuAvuMZCertikIzLz3Ipc2DuMx
Xs5rZ2ZhcQTNelvvGJzqvXYx+s0cXDaTD1Y5MwocK0VekzyJ2V59SrpiSgj/
bMyvVteSY/ph6j1WiAC4+nMPphfkmc2GjaGnBUMQfVZUzNImM9t/TJ2xYA3C
777zd9lbyUz3jdeMuLqDkGii+sA+jczsD8S3I8f4kNNkzTVWpjB7Ve8c1Uji
w40caM5hUZgRy+gEZRcf7h7yafsugcL0SdCD5av5UL0+pCeRS2F+1OcM/yUd
gP//LdPm5it1Vv4A/Auuhdqa
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnk8lIkfx2cMM4uQW86SDik6KMbxfVLOJFctIUdkSuPKsbUoO6ay5FhE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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FHwXB/DJrgllK9lFm45SJDNmrhJDymhIJdtoL0tFemn0WB7hIYps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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHsw1GsYx9dttxCRyqT25JLK7rgUkduzIrvUoYspXeREt+PWyaJROFEm
0iEnCumqbYx7ikrxbttRnEEKkcvata57+b1yP3Zx9sycP5555jvz/evzmecx
Djp/4LQqiUTyV85/G62M5C8tUbhFTLUq4YNhOOGYV3aBR+G+8SzK4LUMgyKY
lyC6RuEGnVI3Zy8Og8Mr/Z8+Ladw95qr2DoEjEBFwIvA9FVk7uqWNztVDUdh
eEMQUbGgxm1aZioOuT8GVtQ9h221VLkMiu+e1HExjP/VTvrdhMTdZEUiB26U
gqz27vm3GxUore94hNhdBlEGgwe1OHJED9oiXRUsg/kQa4djW+XosOh1a36i
DMiGjSS5zTy6ysma/vBOBtTI+UxH9zlkY8paSacRELPpSaxV7SzqdbaxcmAS
0NzlddLMfhYlemepRwUREAe51jq0GXQr2jz4wh0C2icYhmqcaeQYygq0LCeA
9mx0aZY6jbLE7Dm9TwR0azt8FupPId8cSrHHFAGtY5TrrIxJdNje7hfL5Rjq
P3a6lmtNIg9f9pDrBgwVVy6WxalPoKHYT9nNuzA8C2CeEV35gYKDJlJYfhjy
HddSvRfGUd7a5l7RKQw6Y+FGVlKMwKVaNeYqBtUPFnMlMwTyTy72TLyFYTZ/
pN1ChUBC0mN2fT4GaczT54VaMqRhH3bfrRCDYN/JdPM1UhTIrRqeqsTQbkEN
fbpRgnZor07kv8PQoN7DNKGJEX2vRelCPYZ3/Ltmj+zGUHdidc3+FgzPX/up
UBmjiF70fFl3BwbW3obBIbsRxC/sXEvtw9Df79RQShtG5MjL7hdEGGLY5cXR
xkOo3Std/nUUwwqKaYbL2kGU2hxev0uG4WnenUiNFSJUazbjxB3H4GSpeahZ
dQBNqWXq7pnE8PV9/M7sOQHyjXcji6aUuWhgZ01vPxLml8ivT2PQ11fvKZL0
Ie22P+55KvOB2E1x9+Z7kKyiKMRG2f9T4Lnh5vJutFR1I4E1gaGNea4uzrAL
1ZqYL6RhDAblqYHhm7+hJB3heoUEg9+aYtKJHe2IF3DNLHcEQ1Z802Of3V9R
Qa5taPCAktegbBf4tSJJ0Rn/Y70Y1g0FehHfm1BJia2Yo+SRRhrUPqHViAbm
PJmblbwURudam53rUZJJ2GK/kmeEvfS2S8R7dKqNWdqq5I04grKj8BbFugFp
XunjSe+oneOTFyizLbjyuNLXo61DukMPM9FyZ+9fvyj9Km7unn/1LR2mBs7/
4CVh8Dm2OtnHqRD0Evy/t7AxVHN0GpkF7+Dadrmu00EM/H1byNpsHuT4N217
4IZhwKdxc1TWR6DxNgUYW2EQe2uFenS2wM9bqxjpFAynBo3Cpv2/wGzdZWvJ
JAF+ppVPWJ5t4BrKmbnRT4DtY74u3tgJUpff6LkvCZjMtxc7feNDYUHCFuoh
AnxtK1LjYwSQissV2Y4EmOV5UPsShVB5qasGqAR8Ph3OzM8RQanPgy/bRDIw
W6jLXfdxBPgdBt/7lfdbq6uWfqdpFKT3xo607JLBIRNmkn7bGJyt0CvVNJZB
CvNziKZAAopH7h0Xe6Qgyex3mv9Hye36Q5UolhTsbqc50lonoSnWdZG9XgLi
mL3ONjOzsHufotOuegwudeekRnfIoebss6sSn1Hg0jT4DWokhkW9/9H9VcPw
t/v9at1Vqgx6BEWYvXoIeEbyl9OLagzVzdtyH6WJIPqKhMM0IDPo4wXhGgIh
JBxQlNTtJzO6Y5CjvEwIKWYrXtplkBnG1l6G5AQh5DVY8kw1KQyVI/SJ4PVC
KMiDxjwmhbG9hrb/rUQAJWH7WvWSKQxL98fJ1m8FUO16sjOFR2Ekyugl9TcE
8P+/ZTSJiK64owL4FyD44dk=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk4lQkfh8+urI1olCVTEaNIMYzK/0E6to4tZbLNSUqylCzJEtnHlk7W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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ5wrNE86OzdwfDhyBWG
eiWGA+eXBmns+fRe7O3e6fm7Ff7sP798rWT4TzNluaJfE62cf+y/w+Do2lsc
oHGLx+L8Q6Ev+w9/SNOoNEnS4nuZK63/5v3+3Mr5lqtvfNDauCOEUc7hxX7x
/X92J7xk17606pHlrjv39wv21M23OcSpfeXJWyf7kAv7XyyQ0QpkYdFeoPmU
/+n8ifsff/0+K/fhR61XXtzZLtfP2Wce0HnKvfyC1uc55q+sr92zv3AlWHVV
41Ytlb/7Zkode26fsck+yiZjr9brifetf/18b6+rduX2ptAPWqaTu620L3y2
/3hAdO62T+zar8p8bAy/fbfXSPncftvYWKvq1ozO0qu/7fXyHjFnLXqqdkCb
9d4JZgaHpeKn+VcLuciecp67jV+YyWHNR4PHSt3uHIekf2/5+o/ZARZ+pQ2v
l7qLsMH5dUF/1uwLRPA7VHi3mPYj+LNO6B1S5mKH8xfPsj85yx3BX5MTcEGw
FcHfZpd4veMQgg9ND3A+AAXi0O8=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtVHs01HkUn7wmj9AgyhpEZISck0fEnUqNHmtn84icxqL2qCTJYwlbjjYk
kpZM5F2S0Cq1Jd8xIVqWGEYeY8J4zPx+KOs1HrOz5+wf99zzOedz7j3387n3
GgZcOnFWhkAgeEvjv4zUw3gSCZHlzqvJSlkcA4YDs/Iym8iifzcbJDISwGog
O340kcgSEyzi9ekCsH9F0v+gSGRdF1bNLTwWQPXpGr80DQUWhXJs/1bPcRjX
C5iuXpNlJXJ1nJTqJ8CKfOzkHmUZ1qpMgRZjaRJmGzmEX7cTWEme7Q/WNgsB
f5d96a3BKsIjA7vsDUQQrjnmrly6gj4ZGerrOolAfH63va/ZClozs7kT5CMC
BZ1Wwoq1GAWY+VTsuyMCcpg4w+HgEuI2+aTcXRBB5I6iaKt3iyjVmcPOUMeg
ve+Iv7HdInpY3CPqMMMgFnJ2q5ovoLbQQDrhFAacb1Qd2dJ5FOev6jEdioH5
o0nJInkenWvd9pl0E4N+FfuOL6R/UOfH5IrFagw6p4g3XdPnUKihHeFUIwZN
zVznKuU5FDWZITfXi0H1tajKWLlvKMRSmcNexuDRadrPo9e+IvpydPGCIg65
Dtrko2uzqL2/eJfvVhxUpy7qWmEzqO1lv/VzGxxk3lOWKhamUUqUuXfLfhwW
cyc4lA3TiLUUNG/yPQ5YZMnzMmUcbUytsGw7iQOf7p9msgVDSTvabV/548Ch
kC+UGIjQVZ1ot4nzOLTIDdC2mwvRn3pujb5XcKjjZRsX2EwhyJ/5R+MqDs9f
e2wgUydRuovuMbUEHFyPt4wJbCbQQHmJ319JOAwPO7Y8Mx9H4Wb9u8rScIi8
UvU0wlCAbBVsLEozcdhENEp30h5D+V8VZxqycShhZoXJbxpFT0ZzNNeZODha
Knm1y4ygUHkDD588HLoa4vb+vsRHjSWDUd0Ppbh8ZO+bwWHkZ6XHCM7HgUSS
GygXDaEy96tNVlJ8InpH7APxABrZSumzlPLv8g/rpSr2I1ltcvm5XBy6aUH1
sTp9SGsuicHPwUGzKtnvomkvUhngmGZm4eCx5SmBYctBL8R5tIS7ONyLayt0
O9SFaiVPVCtvS/Uaww+ARyc6+3hocIt03m0CvyPTn9uQs67cKu86DrcIYyoM
5VZ0uWf+ARaDw6puUGf7viYk26G+nyrVM8QOy3QKaUCUhLC4fqneqJRfeQre
IpN2wexbqR9Fg5M2DkU1aMCkw1Ug9avATKAmyM9AT0M08kkHpPVSD4lf9aYB
Sf2jnbLUfzdfrRtujmXQa1a+bGmKQ22paiutuA6Y9YVDqxtx4NF3KqhcYUO6
xpeHT5YwGHFrNQ2/1wyRv9h/+G0CA+FR5Qsu3L9B7R7jeB8bgzNjusHz3p8g
UCujrkS6vx5GfxS5Hu6G8NdHuA15GOwp5KnNGHDBsCMRzUVgMJdrJ3Ts5UHZ
zmDhT2QMfthTnRwXyQcd32LJgBwGxkwX8tD1L3DN6pnafaEIOs5epOXeHwVP
yl6XwRoRGK/V52xrnoCY24VGfdL7facmm5bVNgkBXSEJ1voi8NpOSyB1TwEv
1/CNQCKEJFrHeSW+CDIrI2eDkBBEGcOO4uUZyFSgRxnbCcEm85aDeecc2Hpy
R0mGUyCMPL7PemERBvMTLeR7pH367ydH9KyAJE9lbP3mOLDM5XktsgTqbifc
20tFAB8P5tWqachQnYRGdpKUUWDrrryYX5elmlpJmnv1RiDimqiUpqlA7X3p
RInP4EP8idWK+h8VqFraCXWKZ/iQZLzphU26AjU7Zp1TZssHZosl20iJSPV/
T653fz0MxUxoZdKI1LWQS2x9xjBUBNM7N98gUnNjNmgZyQ1DrbM/N4lNpFrE
KRb4l/Pg/39L9UoXOw3TefAv993b6A==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnk81Akfx+dgxtEihNaRckR2Y0RC5vtz1GhyhdSaRSRsKFmyRE054nFl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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ449J9l0brgyfnhyBWG
eiWGA7Pmn78l8nOD/Nu90/N3K/zZ/9T+8y3pzB/ackW/Jlo5/9j/12z6r+dV
goa3eCzOPxT6sn/D4iyLZ+HKxnwvc6X137zfz9VSPi/i2UbjjTtCGOUcXuzv
vb6DVSPjpPGlVY8sd925v/9WvWXp1LjTxleevHWyD7mw/+72wtL9LkeNF2g+
5X86f+L+p3IK7iv/bzJ+5cWd7XL9nH2PTu+7eRsnGn+eY/7K+to9+2ij9YIf
b5YZq/zdN1Pq2HP72xJC6//Y1Ru/nnjf+tfP9/aK9pJr9aM3GptO7rbSvvDZ
3ui3TIRw0UnjV2U+Nobfvtv/Y79z2iH9i1HVrRmdpVd/28e9m264988y/QPa
rPdOMDM4HHjIIf4/mFXtlPPcbfzCTA5+bL69rCycgoekf2/5+o/ZARZ+pQ2v
l7qLsMH5dUF/1uwLRPA7VHi3mPYj+LNO6B1S5mKH8xfPsj85yx3BX5MTcEGw
FcHfZpd4veMQgg9ND3A+ACLc0ec=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtVHs01HkUHwazNaGkKDUVKnGOUiaPkTtEQ0mUymrTkcexipY8jvJOJ63W
sEIGG+NxFIoeoml8JzZLEZVHkTHm9yWMR5KIkf3tOfvHPfd8zr33j/v53M/d
cvbCUV9FCoXiTsZ/Ga0MES8t0UQXaw/7K5/tA09L3r3gepooyzTJY29+H8i9
62OIRJrItbKQZyDuA/MnGpv+WUYTXbb0dbH9WQyVpx+eSVmtIvIeP29IHOqH
oY1nJyoXqaLetOyEHr4EdjIOnTSlK4pSB6VT62IH4PPfHZRYXYroeKPaZJCd
FMaFWRcEm+XodrLDpSYFAkI18TF68QLilL3OV15LwHzALvNTOxZQiV9kZM8O
AlS0mykLJvOI6x6WYO9CACNkPs1y/xwSlnRbzmcREL6VH7lTOIvCjd8nmNwl
oPW9o5e+2SyaMVZLHBAQEAXZu9SMvqFjl8zTivsI6PjC1qYWz6Br0/Gl1eME
GJUML80yZtCr7HWplosE9KwwbxvQ+Ip+cb7jm7EeQ/sI7ZoDdxp9pLZFGhpg
eNHYbX2fPo0MhvxidzMxVMZF3ItS+oIkprKZzMMYSk5z/Ii4KdTAEByZcseQ
a6nFOLj4GeXwVgY+9cagNhKos3NsEr1q/MMhIwKDYoPhXPm3CVTkbbVcLQ7D
bO6nDkOFCZScejRGOQnDWHhRVSl9HMntguiXuRgkLl4p29aOISXb11uCMjF0
GDLOFW2WoVAdH5Y4F0OTUi9H12gUpasO9r7kY3gmztLPZ44gl9wPqXtKMVTV
uCkw2MPI4nvZlFYFBgenJjzI/IQua1UttVVh6O9nNVUYDaEDj4N5sscYwi/e
LwvbMoj2bPP0CajFoErT4+7Twqjnbruq0zMMRbzMEGVVAqXYrDueWoeBZbz8
RKuiFKn5XVMxE2F4+zzaImNOgsaFwXJ4TuK7UounH/uRTSVrUxmJNTSUeu/K
+tCXjTl34kh8NHJrVM58L7LJTeG3kPN/Sg5svLGsB9k9XaXNRRjecfzrorTf
o6HoVt0mIQbN+9fPBG7vQm271wxFCDC4rS2jeO7tQIbvB7h/1WC4Gd1S4Gz/
FtGNW9ytyH068LgtuLWjO97Kia7kvusHzzhOfGhB71w3aH8rx5BMwSs86c3o
YF7DDy2SL7mOf3ur1QsEVMHNJySfQWZj6fuCnqN4Dx92J8k3Kpbc8wABspNW
BweTevA/DjMt+Q9RoLcJ/wapV/6OQfXB22no2HNijS2pr/yG/fyTrhRgjs8u
bCb1dz615qozqxQKfL1QQCCG6mK1Zk7hM5iKkB+yJe9H7GKgsuJiPYTmhcre
OGGQOjdvD73ZCDt1kjXb2RhGD9LP2XW/hj0n7c02bMfgg3XOz7i/gXCrqw6n
yPt103vAdzjwDvwPC2I2qWIwLRCrT27uhmbreHfWFAHTuWajrC4xhDAF6eKH
BBwxrbweHS6BUqbDD3kBAfo8O0Zf/ABIf6KmZnAJaPMN5OTeIqBilJ/K+pWs
L9Zlr2/8BBRdP43fSf8K1akpmS3D0Cz78F2d9PcJXU6CxrsRcKy9bqArk0IS
py1guUQGK+tzrn0RSkGW1s+a/z4JDVcCtkZ4SoGZnmxp1D4NRgxCdDtnAEbD
naxMvs1CaYJL6dcHErjUc+t6WOcC2dfyYm96P4iMlMVNVApbOSlAwzC2D17u
z6tWX63ITqoRjm3z7oV6nYVHMz+obMGEzfHz3h8gLE5WzNFUYX/2EL6Sm3VD
zFF5eZ2rCjvaojrPca4LkvRVHzG5Kmz9Dr2Wqpou4DUZ1+stp7Frf9vU3W/R
BYU8aOZxaOyPLyd8y+Y7ofy8S/uqqzT2oNvpx3mCTqi29upOqqexuYWlV2qj
OuH/f8uuoCslKlh3wr/XiN1c
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk/lIsegMeMoTgiS5SQ6OAQqUG43u9bZISDrJXGHiWSbZyksmU92Zkh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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FHwXB/DJrgllK9lFm45SJDNmrhJDymhIJdtoL0tFemn0WB7hIYps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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlGlQk1cUhkNAMrJWQKAwIrtCpqKWCIJwvroFLUUQiqg1SNxo2OpCFAVR
qxaXBigoGHEBDTrsO1KWG2PF4IggUNYAwQST77IoIosBatOZ/jhz5pl35vx4
3pljw47ZeYhKoVBC1PPfRl8dG/jyhSYsrA5OPfL+LbA8+EVHRTShp+r302fM
ZDB/QHRWdpEmLE65M38YZOBebbT8xWKaUKV5I6CWJ4OSfeWhPGNt4QRquW1K
l8O7ZezxkgVNYUNdFU//6DC4WH2/y1WXKsz0M64fuf4OPvzVQUm0pQgrOXok
cU0BY/UZMbXW88hqIj/UN1EJJ0zkgbqCORTIKrJl31KCirPafa/THAq3ecOd
KFOCtnkTZW6NCqWYdXNi5UqwOqZK9dg0i+Ztk/hSggSuQ06cS/0MCpB9VOwJ
IaG5e1uYvdsM0pn26HOMISEebq02oE+jfvudzfl8Ejo+Euaagim0Tiqf319M
Aj1X+WXGagrdOcBx3f+MhF4995Yho08ooJAQMkgSWknabz7Jk8g7AhjVKhKe
N3Z5F+tOogi+QnJBF0PJuZNF8Vof0aCj8dJJZwy5+5iHZecmUNmoYjJ9PYYs
DzOr7Qsf0IujETlnmBgMyChLl9H3SJIorTQKw0B95jxbMD2OuOOcsYUIDDNZ
ig5njXFUI65L2MjFMMp9WPpYdwzNPXXIHkzEIPUP4zmajqLKHay7HUkYOpyt
Ih5aj6Ajyrti61QMYq0+pi0do2+qKhOfZWKoG8iwv88gkWONxeq6exhKnwRp
WBFK5BhMDdTJxeDjK5YPMxTIJv7Cj8sLMAwOeooL6e+QeOZROacUA/d4cX6s
zTDacV7yaaQSgz7NLtnLTI7G7p8qy6nB8JB/89gifRmKJNsyeHUYPFfpBDdT
36IHSb7s4gYMbU8T1t+YlSIWfe+QllDNeW/X/ykZRBlrU6Z5ajYy0urLG+lH
0Qy6V4iad8Y5xN9W9SHYzWP8gjD8Id267PriXmSzEk101mNoZ4Y3xJt3owS3
y6nXazGYFF8JjVrRiWZ0IjamPsEQZJpPYa3rQA6ri2C4AkN6wqtsvy1tyDX9
u7akErUv+dhGCGpFzSbIPz4fg8Vw6LbxnlfoFH1X2YAAwzWKXI+l24Q2vPR6
lKn2NW8Z3tq84Tk6t34hN0/tM9ptNM0r+ilSul5lLFX7RgJp0R6oRTeTv5V1
q/vIkSgZHjnlqCEwxXda3dd9p2HD4XupyPRqucZ3kep717eoqjt54Ga09U38
fgx+e5de8vN8DP6PNDizgRiqBAZNzAd1ECffxi53xzDgv1Jb77gIHOs/LZ9y
wvDWr2nFifRGKPUvZJ+xwIC360Zs7noNlk1lQ3s+k3BQbhk5FfIGWEtQD1aS
EGRXluOztR28GhRxki4SXLMHDN9bd4E+weomy0mYzHLDnp0D0Bi7L6H9IAk7
XEuuJHClgPP4D178QII9f7NV//khSDE5yDRcR0LLoShmVqYMDp/s9cnWUucL
DbcsGhWwmW3XqcdXQr2hJu/mKyV4S9vSWGeVEGzLvGDUTsLJkki6JVsJScwW
jo50BCbTKxwHVihhJHXQU/X5PXw9G2n9ukABjLRrHvTWSbCJyaspKn0HmOu7
Yc30DPimhXNeXxqG072ZV2L/ngPrtb/e1d8tByF90YBYk0KIigqjXagyeLnp
TpWhMZVwT2nNcskdApHlXMXUP5qEgb5p688/SSH23IiAaaJNOI1cNJ4c7Yez
O+cLGgK0iShx4Ikefj8k2etXMJK1ia7LUnOZTz/wxatEdjo04qXo/PIYgQQe
8KGJz6QR8w1LemYDJVAQ6d+65BKNsJXKL1ZQJVDlHdaVJKIR99KWFAhK++D/
f0u4CY43tezvg38BiNrpkg==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnk01Hsfx2cxJtslJilUKJIbKYOIzy9u9iay5LFvV6R1CimkbCmRwg1T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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FHwXB/DJrgllK9lFm45SJDNmrhJDymhIJdtoL0tFemn0WB7hIYps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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHs01HkUwCePmZDHImwy5S0KrdFg6M6WDLISKm2L9JCobIXtwdY6KWFJ
qLx2KaSHVw+imu805bVRXlFoDGaQmd+XEqYh7ew5+8c999xz7/3n87nnGu6J
9N0vRyKRAmTxX0Yax3jfvlE4F6Yf/vDreyEEOeWUH+VSODRFen6NygjM7+X+
PnyOwhlrWLO7zXEEHGo0VzQqyeZzTyyEZ41AZeD94FQtMkdSKrw16zEKIwZ7
cOVXeY5tn9Q1iDsGNtTNO2gqchydCsdCC+VxmHzRRTpjROKER4o139qIgHh6
NfLxynl0tDbWq8RDDFHaAj+V4jm0Sb/ip/oDYpCG2zrsWjWH2G8oWh4JYiDr
NZPm1krRgS8ugTFsMVCPSdOdNkoQ+3jBFutVBMSYXj9p83QWRVKfZ3q6EtD6
1iPEhD6LYiTpCflBBMRCtq2a1QxareS6mXeJgK5PTD354mm0w1axrrGUAKuS
sW+z1GlEK+hYPIAI6F3i8HpQ8zPK1pWnp4kIaPtAueCeNoWSXjCWNnwjoL6h
Z32FyhTCmzsVrLQwVJ79rTxW4ROi2PdcOEHHUBLICh0++xElu/EWAt0x5Dnp
Uj2/TiKal8g7IgCD2ofD+jbiCaQ9FEOWRGOQe24puTuDUd07F3ZGPIbZvNEu
y0UY7aNfUoxMxSCOKaoqVSGQkoG5JDEbA98nJNVMR4zUJOoc/g0MXZbUiKKV
IiQJaMyKLsPQpNDHMrIaR6cX+XLcqjE84V01KbD/gIJN/LP82BiqHvkvojLH
kGen2cncegzuXk0Cof0oQhc5+wtbMAwMMJrKrEaQl173KXYHhpjjFXeiDYUo
v9JizaceDKoU4zQXXQFi3bImO/djKMq5ckxRdRglapkW5Q5gYFgrb2+VG0IR
LtQ6jSEMHc/iHLMkfBRnoKqROyyrbw851vUPoNji1ngnAQZNTYW+26L3qEaN
s3VO1vc9aRqbK+1DLpe89k7I9i/z3QxSlHqR858bWnQGMXSywtixem+R/uVt
VUd5GLQrLgYfNu9GpzP1WKQ+DP46d0hB67rQOdPZdm43hsy4lkLvTR0IX11d
Utsu4yUgNoB/G7LRrzUXvsSwTBjsgd+1oPU4UO+gjEcySbAkSKUZpX8eT7GU
8ZrXD2trda5HCQkH1S1lPI/QxRkuR54hJQdHhzAZb1TML/8ZHiPhwnyZUObj
ev+YvdP1+8jl3HnTGzJfBauE6sK/0xFDPsNuUOZ3PmWTtKY7FRpC4yc9Zf69
dy1N8GaUAmPF0KPuUAzVxWrNrBtPoCxo2/mdLAw8HwvykuNcIDdvYfmtwzDk
3WweldkAb5SMk6NMMIx7qkS49ryCJHXXfrsFAvYJ9A9NB7SDXdnNWgfZ/fob
37vu7tYJ7HRtdL6HAFohT31iZQ88jH9mp1BOwFQefZzRzYOU5zvNqnwJ2EKr
vBgXw4eFcRyh7UCASY4r9f0fg5DwsjeucjkBr/cfZuVdG4aGvMnUvGExmHxl
Zy9rGIWVS6vDk8LE8FRdPvVKyxjERe15mOEuhu1GrHjNzg+QVfJ9w6S5GBJZ
r8OV+SJIeWA4UikQgSh9gCH9MgH03b94XtkuAvuMZCertikIzLz3Ipc2DuMx
Xs5rZ2ZhcQTNelvvGJzqvXYx+s0cXDaTD1Y5MwocK0VekzyJ2V59SrpiSgj/
bMyvVteSY/ph6j1WiAC4+nMPphfkmc2GjaGnBUMQfVZUzNImM9t/TJ2xYA3C
777zd9lbyUz3jdeMuLqDkGii+sA+jczsD8S3I8f4kNNkzTVWpjB7Ve8c1Uji
w40caM5hUZgRy+gEZRcf7h7yafsugcL0SdCD5av5UL0+pCeRS2F+1OcM/yUd
gP//LdPm5it1Vv4A/Auuhdqa
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnk8lIkfx2cMM4uQW86SDik6KMbxfVLOJFctIUdkSuPKsbUoO6ay5FhE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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1nk0FHwXB/DJrgllK9lFm45SJDNmrhJDymhIJdtoL0tFemn0WB7hIYps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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlHsw1GsYx9dttxCRyqT25JLK7rgUkduzIrvUoYspXeREt+PWyaJROFEm
0iEnCumqbYx7ikrxbttRnEEKkcvata57+b1yP3Zx9sycP5555jvz/evzmecx
Djp/4LQqiUTyV85/G62M5C8tUbhFTLUq4YNhOOGYV3aBR+G+8SzK4LUMgyKY
lyC6RuEGnVI3Zy8Og8Mr/Z8+Ladw95qr2DoEjEBFwIvA9FVk7uqWNztVDUdh
eEMQUbGgxm1aZioOuT8GVtQ9h221VLkMiu+e1HExjP/VTvrdhMTdZEUiB26U
gqz27vm3GxUore94hNhdBlEGgwe1OHJED9oiXRUsg/kQa4djW+XosOh1a36i
DMiGjSS5zTy6ysma/vBOBtTI+UxH9zlkY8paSacRELPpSaxV7SzqdbaxcmAS
0NzlddLMfhYlemepRwUREAe51jq0GXQr2jz4wh0C2icYhmqcaeQYygq0LCeA
9mx0aZY6jbLE7Dm9TwR0azt8FupPId8cSrHHFAGtY5TrrIxJdNje7hfL5Rjq
P3a6lmtNIg9f9pDrBgwVVy6WxalPoKHYT9nNuzA8C2CeEV35gYKDJlJYfhjy
HddSvRfGUd7a5l7RKQw6Y+FGVlKMwKVaNeYqBtUPFnMlMwTyTy72TLyFYTZ/
pN1ChUBC0mN2fT4GaczT54VaMqRhH3bfrRCDYN/JdPM1UhTIrRqeqsTQbkEN
fbpRgnZor07kv8PQoN7DNKGJEX2vRelCPYZ3/Ltmj+zGUHdidc3+FgzPX/up
UBmjiF70fFl3BwbW3obBIbsRxC/sXEvtw9Df79RQShtG5MjL7hdEGGLY5cXR
xkOo3Std/nUUwwqKaYbL2kGU2hxev0uG4WnenUiNFSJUazbjxB3H4GSpeahZ
dQBNqWXq7pnE8PV9/M7sOQHyjXcji6aUuWhgZ01vPxLml8ivT2PQ11fvKZL0
Ie22P+55KvOB2E1x9+Z7kKyiKMRG2f9T4Lnh5vJutFR1I4E1gaGNea4uzrAL
1ZqYL6RhDAblqYHhm7+hJB3heoUEg9+aYtKJHe2IF3DNLHcEQ1Z802Of3V9R
Qa5taPCAktegbBf4tSJJ0Rn/Y70Y1g0FehHfm1BJia2Yo+SRRhrUPqHViAbm
PJmblbwURudam53rUZJJ2GK/kmeEvfS2S8R7dKqNWdqq5I04grKj8BbFugFp
XunjSe+oneOTFyizLbjyuNLXo61DukMPM9FyZ+9fvyj9Km7unn/1LR2mBs7/
4CVh8Dm2OtnHqRD0Evy/t7AxVHN0GpkF7+Dadrmu00EM/H1byNpsHuT4N217
4IZhwKdxc1TWR6DxNgUYW2EQe2uFenS2wM9bqxjpFAynBo3Cpv2/wGzdZWvJ
JAF+ppVPWJ5t4BrKmbnRT4DtY74u3tgJUpff6LkvCZjMtxc7feNDYUHCFuoh
AnxtK1LjYwSQissV2Y4EmOV5UPsShVB5qasGqAR8Ph3OzM8RQanPgy/bRDIw
W6jLXfdxBPgdBt/7lfdbq6uWfqdpFKT3xo607JLBIRNmkn7bGJyt0CvVNJZB
CvNziKZAAopH7h0Xe6Qgyex3mv9Hye36Q5UolhTsbqc50lonoSnWdZG9XgLi
mL3ONjOzsHufotOuegwudeekRnfIoebss6sSn1Hg0jT4DWokhkW9/9H9VcPw
t/v9at1Vqgx6BEWYvXoIeEbyl9OLagzVzdtyH6WJIPqKhMM0IDPo4wXhGgIh
JBxQlNTtJzO6Y5CjvEwIKWYrXtplkBnG1l6G5AQh5DVY8kw1KQyVI/SJ4PVC
KMiDxjwmhbG9hrb/rUQAJWH7WvWSKQxL98fJ1m8FUO16sjOFR2Ekyugl9TcE
8P+/ZTSJiK64owL4FyD44dk=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk4lQkfh8+urI1olCVTEaNIMYzK/0E6to4tZbLNSUqylCzJEtnHlk7W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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024mQ5wrNE86OzdwfDhyBWG
eiWGA+eXBmns+fRe7O3e6fm7Ff7sP798rWT4TzNluaJfE62cf+y/w+Do2lsc
oHGLx+L8Q6Ev+w9/SNOoNEnS4nuZK63/5v3+3Mr5lqtvfNDauCOEUc7hxX7x
/X92J7xk17606pHlrjv39wv21M23OcSpfeXJWyf7kAv7XyyQ0QpkYdFeoPmU
/+n8ifsff/0+K/fhR61XXtzZLtfP2Wce0HnKvfyC1uc55q+sr92zv3AlWHVV
41Ytlb/7Zkode26fsck+yiZjr9brifetf/18b6+rduX2ptAPWqaTu620L3y2
/3hAdO62T+zar8p8bAy/fbfXSPncftvYWKvq1ozO0qu/7fXyHjFnLXqqdkCb
9d4JZgaHpeKn+VcLuciecp67jV+YyWHNR4PHSt3uHIekf2/5+o/ZARZ+pQ2v
l7qLsMH5dUF/1uwLRPA7VHi3mPYj+LNO6B1S5mKH8xfPsj85yx3BX5MTcEGw
FcHfZpd4veMQgg9ND3A+AAXi0O8=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtVHs01HkUn7wmj9AgyhpEZISck0fEnUqNHmtn84icxqL2qCTJYwlbjjYk
kpZM5F2S0Cq1Jd8xIVqWGEYeY8J4zPx+KOs1HrOz5+wf99zzOedz7j3387n3
GgZcOnFWhkAgeEvjv4zUw3gSCZHlzqvJSlkcA4YDs/Iym8iifzcbJDISwGog
O340kcgSEyzi9ekCsH9F0v+gSGRdF1bNLTwWQPXpGr80DQUWhXJs/1bPcRjX
C5iuXpNlJXJ1nJTqJ8CKfOzkHmUZ1qpMgRZjaRJmGzmEX7cTWEme7Q/WNgsB
f5d96a3BKsIjA7vsDUQQrjnmrly6gj4ZGerrOolAfH63va/ZClozs7kT5CMC
BZ1Wwoq1GAWY+VTsuyMCcpg4w+HgEuI2+aTcXRBB5I6iaKt3iyjVmcPOUMeg
ve+Iv7HdInpY3CPqMMMgFnJ2q5ovoLbQQDrhFAacb1Qd2dJ5FOev6jEdioH5
o0nJInkenWvd9pl0E4N+FfuOL6R/UOfH5IrFagw6p4g3XdPnUKihHeFUIwZN
zVznKuU5FDWZITfXi0H1tajKWLlvKMRSmcNexuDRadrPo9e+IvpydPGCIg65
Dtrko2uzqL2/eJfvVhxUpy7qWmEzqO1lv/VzGxxk3lOWKhamUUqUuXfLfhwW
cyc4lA3TiLUUNG/yPQ5YZMnzMmUcbUytsGw7iQOf7p9msgVDSTvabV/548Ch
kC+UGIjQVZ1ot4nzOLTIDdC2mwvRn3pujb5XcKjjZRsX2EwhyJ/5R+MqDs9f
e2wgUydRuovuMbUEHFyPt4wJbCbQQHmJ319JOAwPO7Y8Mx9H4Wb9u8rScIi8
UvU0wlCAbBVsLEozcdhENEp30h5D+V8VZxqycShhZoXJbxpFT0ZzNNeZODha
Knm1y4ygUHkDD588HLoa4vb+vsRHjSWDUd0Ppbh8ZO+bwWHkZ6XHCM7HgUSS
GygXDaEy96tNVlJ8InpH7APxABrZSumzlPLv8g/rpSr2I1ltcvm5XBy6aUH1
sTp9SGsuicHPwUGzKtnvomkvUhngmGZm4eCx5SmBYctBL8R5tIS7ONyLayt0
O9SFaiVPVCtvS/Uaww+ARyc6+3hocIt03m0CvyPTn9uQs67cKu86DrcIYyoM
5VZ0uWf+ARaDw6puUGf7viYk26G+nyrVM8QOy3QKaUCUhLC4fqneqJRfeQre
IpN2wexbqR9Fg5M2DkU1aMCkw1Ug9avATKAmyM9AT0M08kkHpPVSD4lf9aYB
Sf2jnbLUfzdfrRtujmXQa1a+bGmKQ22paiutuA6Y9YVDqxtx4NF3KqhcYUO6
xpeHT5YwGHFrNQ2/1wyRv9h/+G0CA+FR5Qsu3L9B7R7jeB8bgzNjusHz3p8g
UCujrkS6vx5GfxS5Hu6G8NdHuA15GOwp5KnNGHDBsCMRzUVgMJdrJ3Ts5UHZ
zmDhT2QMfthTnRwXyQcd32LJgBwGxkwX8tD1L3DN6pnafaEIOs5epOXeHwVP
yl6XwRoRGK/V52xrnoCY24VGfdL7facmm5bVNgkBXSEJ1voi8NpOSyB1TwEv
1/CNQCKEJFrHeSW+CDIrI2eDkBBEGcOO4uUZyFSgRxnbCcEm85aDeecc2Hpy
R0mGUyCMPL7PemERBvMTLeR7pH367ydH9KyAJE9lbP3mOLDM5XktsgTqbifc
20tFAB8P5tWqachQnYRGdpKUUWDrrryYX5elmlpJmnv1RiDimqiUpqlA7X3p
RInP4EP8idWK+h8VqFraCXWKZ/iQZLzphU26AjU7Zp1TZssHZosl20iJSPV/
T653fz0MxUxoZdKI1LWQS2x9xjBUBNM7N98gUnNjNmgZyQ1DrbM/N4lNpFrE
KRb4l/Pg/39L9UoXOw3TefAv993b6A==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnk81Akfx+dgxtEihNaRckR2Y0RC5vtz1GhyhdSaRSRsKFmyRE054nFl
k2OIwVptkaQchd+PohFFEUnueyZXcjQMzz6v1/PH5/V+vf9///HZ7XXR8RwB
h8Nl/rv/EZUKHtzaImNyrbujw5c4VHcT1sNLTWSs41SB+gXcG+rG2aarYzFk
rD60i3vrQyeVlcy1O0kjY/Si7MqJmC7qoWrpXa9EyRhcITfUsXqoPcMm84fa
SZitMsteX+MTNUTsLHo/hYRpFRhEqxsMUqUNElOVTpAwgoCm+jhghPrIrdIj
RYaEjUjsOhIqO06tNkyoeN8pjC2oOt/P9JqiNvzgQZRPEcY6+fzURQqP+nLC
4CTjuDBGdxjTiE2fp7bVi5Xkiwhjs4u+LTT7r9T3d4bXxpqFMC7T2s7rwDL1
Y2AVXStaCNOZETygRa9Rh44k5QYgQpj2zHK2ju0GdVLZa+6RgIiZq9ffDnbA
wbzZNYYnSsTOBApvz8ohwJpbLmf7dSKWm0cWBOsLA/5qrWGTBRGT7W7LeaEs
AmJ5PYXBQkSMQllX0PYVB5mGJUm1FgKmdJ8i0N8pCUqDUlFdNwlYRCc8rc3f
DpqbP3OjjxGw5dM9YseWZEBX5fgpA3ECFrNmt6qbIgciTpGlym/x2HHpuCux
fjth+GYZnpyGx/p23X7onqEENXWDLgtOeEzOUTtHXEoVbi1KlvbJ4bGDz0v1
3Mh7wE/THP+iD4dNaIpcJx1UB4QR7FKai8OybBdLjhdogsKtogd3PHBYTPKU
W6+dNiy87MZd24PDVJ6g71Crn8DLwbc8FNtC9wrknzh068KYnIbbrOkWelyP
F941TgHvgVGxc9WbqHOlFu1neQOYLGLXfNbfRKPi0enTcQfB77y7j/NDAbpf
UeNSl5ExcPWUZNu1BWhIgyH9MuUwBKz2NVoWb6BDvBrj8HCA2frMi89VN9A8
07oV40RzCJEddxIvXkcPU+Negbcl8M/rHWJor6O8R1ZpdL8jwGyMVHpQxkeV
hHUqIlg0ICm04tYpfPRWtNaW7OYxSLqwY4Je9R0d67HVu5FhA9LNnq0sk+8o
Nndx1tbXHlSC+WkmlmtoYqPbr/7DjnBZozBct34V7WiSTw3udIY3H495qhut
om1zp1V6uS6gnrRovbNiBbXixV4w1f8FIiFbT0JnBe1Uv/vY4R8GdH9FFIjF
y6gcQ1Sv29EddP6e3lpVWUbFD8xLt2SdgU/bDnWMSH9Du/gpchPtZ6FzhnzT
OnUJze7bVvU58Rw0t/RSy8WXUJ9zcpnvf/OFZ0UlKzviv6J4MFaQ8vsNHjHD
HkYKfUWf2m8r6LnpD3+70XzGmItokPh7GbfXgZBrIq9CFyygr461J/soBIHE
TKCi7pd51Mt74PlgVTAQXuxbK12ZQzlaCSp4sRBYzZ3q3oefQ7V7QoqCLoTC
sINniqbcF/T+wVLamYA/oHufiv9fqjxUbmWS6UKKAI5QP22PDhcVkbzwNvrx
FaioccarINMoz/+o7zvza2BtwxmfMJxCGSeaxy1KmDA0ZMop05lEO4PIqjY1
1+EHslqqmfw4uhodpDn4PRre3x81fvZ5CJV8Utu4sBQP0tJC/fd5A+iFNqHf
1PT/A47hGpE5/H6UNkuke4YlQhfNryFS4SPqtygo48umQPf4rAU4d6Ku3WO+
vOY0YGtPSE7kp6Gvxb70kC0zYSPpCL+6JwW4PMkfJ9czwY6xI9bO9B4EuN47
klSRBVXFEq20ojqQZHZa1kixYNBBi7Tt9yaoML+3m1DLglG71r0h6S3g6bfW
cZeRA1y6uL9V71swCTQf8EnOBe9xxYDl0+/gxiyeoi19F5zVHhdaH+2CvxMy
Hm2m3gUrL+u+nAMfYEyb7hxOygODgkHJedVeIB5esNULzQP14ZCjFhJ9MPR6
WxHWnweyu8Sj7qx/AmuPbdgb43wQci+onJ7+DD5lvxAJqfmwlGvENe0ZBHfe
TyDZnw/2Bo8Soi4PQ2ExvcZ/OxvUWVYqA9dHgEppm87TZQN/6+Pjw8mj8NSr
koyzZkPHuUBabtYYrOMZlBBXNvzVhv+8XjQOH/rNvk/6sCGCkhHEKJ8A6p9F
qfRANthn7hN+/mwSjG5p9mf+6+qChuwfW6YgXvFj7FtfNtRLElMy2qfhS94D
J5Nf2eCyh3ZDumsG0gpTEz/R2TBvkHg5pY8LjSX51Y0H2BBP6zgvNsyD8mmO
n4g8G3a7ynjETX4BjB8nx5rJh2cBp5wIs7PAe/Da05eVD47XcmhXl+bAVKmk
qA3JB17akCn/+zz8ocYQUR/IAzOL6BGvsAXIHRD3YIblQexzuWLO4gIEmuyL
6hLNgx0PzX5Kn1yED2cUlSfl74Lb3nfz3898BbmFOrOw9FwoZntXevR/hQfy
TMMCsVwwvJ1ootO5BFL3uK/SJlhQWv6Cz3P+BvoeCgwhKgv2tK8/K+37BntD
SiJ007JBSjjAdP/YMjipnSPv35cF3Ms2hykrq1AZ4aZKPXQHIj5lJYR+WIf9
Na1/OjmmgqLYlGQtYwP6Ppnbqg4nQ52xYcbGyAa8Mfd+6RaSBIKsd4XRcwKo
qxY1J1UmQB5nl/arkE2IDDpQ+MQ9HqhrgeVi65uwYZFs5ypzEzAd4UEOEYfY
DL5+dio7Bhr3K9RWHMEhFjP2NV1B0dBE0Uln3cQh6spRGR6ON6DZ6AQ9QByP
SJgdED1vwIQWE2+Nk7Z4JNPyVLjD+avAMQvDUVPxSDUpqXCWGQmvLe9WScoQ
EOWWtLiI2T+gddPvcpIDAXk7GVug6hEGnFqDg6IpBER0Yc2qeTQUWnTbnxJE
iYiMcNYN0q7foZmbGXrtKBFhl+39Ruy9BC+LzxpuRBMRl8/6oy/yg6BJcf3J
8iYR8Tk6Tue8CIDTWjuX8s2FkJP+Ue71Cef/7ceIQo8RQpaS+961B/tBnPnJ
i99ahJArzqsTZVE+oGT3e1meqDDSYXlNSuIfb3jsmsazthFGLEa0im4veYG1
b7n2Uoow4nLii/UwwxNCmbximiwJGZQQjGbi3OCq40ZpwwkSYhQfEH/jL1eI
V//hiWEqCXmjIrM1dek0pK0oPy9tJyExJ1WCHvq4AIuzv0lNjIxkVKUfbGY6
QxELWlk0MjIVt5Gu2eAIpQEOndtjyYjqpV7DPqUTUEX17I1vIiP6HObiqKE9
/P9fIccSIpQ0Am3gv5dnhFE=
          "]]}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      Frame->True,
      GridLines->{{-0.4920407313793702, 0., -0.012349381967960225`}, None},
      PlotRange->{{-3, 3}, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {977.1428571428571, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {360., 291.2461179749811}], InsetBox[
     GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJx1lGtIk1EYx5comCJYhIgIlUQRWaFiUQnHpNAPKWh2sVS8NPCWtRalEJUX
MqWk0hhRWfTFNS9TXAaLOFr4flhg4ZiaVtO8ostZKKUjrPn2P4PnpQPj4Qfv
zvt7n/N/zuaccylqL5VKdevvz13l5duF2mRwLy/Bzau8zMHyf+YFZx5zL5vg
IzIzsGvFvZyC9fJ+gp/L74slHpSFF63wA8MPDD8w/MDwA8MPDD/SF8oKDzCt
8APDDww/MPzA8APDj5wTZUVfqAeYVviB4QeGHxh+YPiR3FBWnBPtC/UA0wo/
MPzA8APDj+SYsiI39JxoX6gHmFb4geEHhh+ZK8qKHNPc0HOifaEeYFrhB4Yf
mXPKirmiOaa5oedE+0I9wLTCj9w7lBVzTueK5pjmhp4T7Qv1ANMKv//di/Qe
onNP54zmmuaInhvtE/WiFe+bz/Vlvbq77MDVkapY70VF/tflST0+3yxiTmPT
t6cW/TB5ePdFST3TKJ5/25MUkF8sCR5i11NDNVYWvdE2aElwiv3rkk/EGyan
Bc9XfHxRXflV8KOilwl9hwYFu7pCGgoSe0WOwmqe+JSHmAWnDzuyn717Kp7v
jpSi1mt7BKfqbk49TrNyOidtZ+Tv7zdEOoMix8V++6+t9oPR+8G4eHzo58lJ
z/fOnN2wqXvOk/ewxDj1mhnBt0+FnzccnBB84Z5/g7NsRHBrvU2XXzngmYd/
++M8sqTojKjD9Szd6Bfs+jXLQ/NsfrpaC/dfcSw/HJ3ibYmvw6NzTNyc9P5z
jGWMN+dnlVS161lfTG7ZK7WdG4drU75USyzi07b433sGeElveW6L1sqOLtSs
TVqYYF32jhtB9jrWP1EyvTPQzvne4s66sFnmfznYYRq1sGDt6TtvAhyswFeb
vGXUxHI6K+yl36fYFfP9gjgvPW9ZatoVYRtjl7K9Mzs0Ep8r1bs+aOxsq6E9
sFBj5ZWqpQds3wBLk7+HZTQWmnd0jLM/Fa4btQ==
       "], {{{}, 
         {RGBColor[
          0.4487186011904109, 0.17568847125940937`, 0.17612882084883677`], 
          EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwNw8eSmgAAAFDXsmoUEBtFUEARu6A4s2PDhgKiKCLFtbs555xbTvmCfHD2
zTz6+ct8+n0+37/vge/xN38yHElFonQWKaJYh6vA7+FE6B0KhtLRH1QmiwKg
UOaysTgYCAL+AIOg7RIrVmu9Wr1O0Q2a8QPxt3gsAAILY5ulqXwqXSHzTab4
0WzxbJkjyFaxVM4RLJ4rYTiZTBFwMpeAd/LyZh2388WAF+5H+2E7F/PwdNzl
YGgsZEnsbWZzuT9Qx9K4KyqjsSZN9Ons5XrXgzUUOrUC5W2NfpvHQAiJAziU
+PJO7mZrr/Xz3jRXiqNvLFU7Gbujtj4oqu7Y8+1mZe5DCegdToSTcCSVjKZT
sWwmjmTRIgOgCIRjiRyOlYoghiZJIkMVEIZO5UmcLYnSuCp2Ca5MVrhCrUrV
a3SjzjQbxVaz1G6xfLss8FxHyJXZWk/82fjDD/ryzuiOR8JwEIRAmMitJ9Ot
507W2lRf9+XFbKP3JtJgKY9VZW0fN67zMZ+NlJV2tFTrYD/u1u16vN8O18vv
6d/9+dM4ed7Xy309nefDvJwlTVUO5n+KMloL
             "]], 
            PolygonBox[{{140, 68, 67, 126}, {127, 43, 44, 101}, {134, 65, 64, 
             120}, {133, 46, 47, 117}, {112, 56, 66, 135}, {126, 67, 56, 
             118}, {120, 64, 53, 102}, {117, 47, 58, 119}, {118, 56, 46, 
             133}, {103, 45, 56, 112}, {128, 44, 45, 103}, {102, 53, 43, 
             127}, {119, 58, 68, 140}, {135, 66, 65, 121}}]}]}, 
         {RGBColor[
          0.7480701924001989, 0.17924286426083513`, 0.18094658603319128`], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{126, 57, 140}, {120, 54, 134}, {118, 57, 126}, {127, 
             54, 102}, {133, 57, 118}, {102, 54, 120}, {119, 57, 117}, {101, 
             54, 127}, {140, 57, 119}, {117, 57, 133}}], 
            PolygonBox[{{104, 103, 112, 113}, {129, 128, 103, 104}, {136, 135,
              121, 122}, {113, 112, 135, 136}}], 
            PolygonBox[{{122, 121, 134, 54, 108}, {108, 54, 101, 128, 
             129}}]}]}, 
         {RGBColor[
          0.8513890390931629, 0.31063079995029863`, 0.3153348634218808], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{123, 122, 108, 109}, {105, 104, 113, 114}, {114, 113, 
            136, 137}, {137, 136, 122, 123}, {130, 129, 104, 105}, {109, 108, 
            129, 130}}]]}, 
         {RGBColor[0.9019119600490757, 0.514113479590334, 0.5221539566614773],
           EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{124, 123, 109, 110}, {138, 137, 123, 124}, {131, 130, 
            105, 106}, {115, 114, 137, 138}, {106, 105, 114, 115}, {110, 109, 
            130, 131}}]]}, 
         {RGBColor[0.950881288180056, 0.7735005634201503, 0.7811581428466106],
           EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{139, 138, 124, 125}, {125, 124, 110, 111}, {132, 131, 
            106, 107}, {116, 115, 138, 139}, {107, 106, 115, 116}, {111, 110, 
            131, 132}}]]}, 
         {RGBColor[1., 1., 1.], EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{116, 55, 107}, {111, 55, 125}, {125, 55, 139}, {107, 
            55, 132}, {132, 55, 111}, {139, 55, 116}}]]}}, {{}, 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{132, 111, 125, 139, 116, 107, 132}]},
           "0.25`"],
          Annotation[#, 0.25, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{131, 110, 124, 138, 115, 106, 131}]},
           "0.2`"],
          Annotation[#, 0.2, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{130, 109, 123, 137, 114, 105, 130}]},
           "0.15`"],
          Annotation[#, 0.15, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{129, 108, 122, 136, 113, 104, 129}]},
           "0.1`"],
          Annotation[#, 0.1, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{127, 102, 120, 134, 121, 135, 112, 103, 128, 101, 127}], 
            LineBox[{133, 118, 126, 140, 119, 117, 133}]},
           "0.05`"],
          Annotation[#, 0.05, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], LineBox[{2, 12, 11}], 
            LineBox[{8, 19, 30}], LineBox[{71, 82, 93}], 
            LineBox[{90, 89, 99}]},
           "0"],
          Annotation[#, 0, "Tooltip"]& ], {}, {}}}],
      AspectRatio->1,
      Frame->True,
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {1368., -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {360.0000000000002, 291.2461179749811}], 
    InsetBox[
     GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJx1lns4Vdkbx899S4gpFP1Ko5JqukiTGllbiZQiZdIFEzXNqCnTBemGmtHE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       "], {{{}, 
         {RGBColor[
          0.4327414228321388, 0.35229726524831756`, 0.2909628659386885], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{117, 20, 134}, {20, 9, 10}, {114, 9, 115}}], 
            PolygonBox[{{115, 9, 20, 117}}]}]}, 
         {RGBColor[
          0.5697388941886393, 0.4644460498101915, 0.3574756111371456], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{102, 1, 227}, {110, 7, 234}, {109, 7, 110}, {117, 19,
              115}, {116, 19, 132}, {228, 2, 103}, {135, 30, 151}, {101, 2, 
             228}, {225, 100, 301}, {301, 100, 226}}], 
            PolygonBox[{{134, 30, 19, 117}, {227, 1, 2, 101}, {234, 7, 8, 
             112}, {132, 19, 30, 135}, {112, 8, 19, 116}, {115, 19, 8, 
             114}}]}]}, 
         {RGBColor[0.6623166883080377, 0.527000374856896, 0.3557534965512921],
           EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{116, 18, 112}, {113, 18, 130}, {196, 80, 278}, {108, 
             6, 233}, {223, 99, 299}, {112, 18, 234}, {119, 11, 235}, {133, 
             29, 149}, {299, 99, 224}, {236, 12, 105}, {135, 29, 132}, {290, 
             90, 210}, {118, 12, 236}, {106, 4, 231}, {259, 50, 167}, {167, 
             50, 178}, {104, 3, 230}, {278, 80, 197}, {107, 5, 232}, {101, 12,
              227}}], 
            PolygonBox[{{227, 12, 11, 102}, {231, 4, 5, 107}, {232, 5, 6, 
             108}, {235, 11, 12, 118}, {132, 29, 18, 116}, {151, 40, 29, 
             135}, {130, 18, 29, 133}, {152, 40, 50, 259}, {197, 80, 90, 
             290}, {230, 3, 4, 106}, {149, 29, 40, 152}}], 
            PolygonBox[{{105, 12, 101, 228, 229}, {210, 90, 225, 301, 302}, {
             302, 301, 226, 99, 223}, {233, 6, 109, 110, 111}, {111, 110, 234,
              18, 113}, {229, 228, 103, 3, 104}}]}]}, 
         {RGBColor[
          0.7306444857417339, 0.5672873479399594, 0.3273321209744288], 
          EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwt0DsLgWEUwPEHo1wHk1wmWXwCsw9gk+2d3PJmEUqKFLNImX0Cm0+BGDG5
pSSyGfxPzvDrPJf3XN4nbtnZqtMYE4ELJXhxRg9hjFBDADamSGCsezm/oQI/
rvgiiiGOyCHlMKZN9OGFjn7/RpC7DHEpczj+9aeaI7kbnOBBESutGeN+T7SQ
ZF0nhnDHROecY6DnH5R1hgvc5KSJC60lNdeY6fzyHwXtK/0bun6gr+/T1d4y
w0F7SK8mtshjh5a+7RM/6Zoq5A==
             "]], 
            PolygonBox[{{129, 17, 28, 131}, {240, 14, 15, 125}, {230, 14, 13, 
             104}, {244, 21, 22, 136}, {179, 60, 70, 274}, {231, 15, 14, 
             106}, {130, 28, 17, 113}, {137, 31, 21, 244}, {233, 17, 16, 
             108}, {279, 278, 197, 198}, {243, 16, 17, 129}, {242, 15, 16, 
             127}, {238, 13, 14, 122}, {147, 28, 39, 150}, {235, 22, 21, 
             119}, {149, 39, 28, 133}, {232, 16, 15, 107}, {198, 197, 290, 
             291}}], PolygonBox[{{121, 22, 118, 236, 237}, {209, 89, 223, 299,
              300}, {237, 236, 105, 13, 120}, {165, 39, 259, 167, 168}, {186, 
             70, 196, 278, 279}, {291, 290, 210, 89, 208}, {300, 299, 224, 98,
              221}, {168, 167, 178, 60, 267}}]}]}, 
         {RGBColor[
          0.7898439595937476, 0.6306427269930378, 0.3578889813911077], 
          EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwt0LFLQlEUx/H7sslcFEQxECNRhJZwdA7HoMnBpf6AWgsEFRe1oUEJchVB
2iIaipoExywcHNQ/wcWCBkH6Ht5v+HAe5517zj334OLq7HLHOZdGAH+IoWLR
c+6E+IY430XiO4Y4xgAR8gXiM+Y4R5bcnufXWG1YfV7RwD7qaGuWzfzCKQ6p
vSMmsMEDUtjiHhl0UFON1YY4kyc+4lf1Lc2wWT9oKm//g7rzE16cf9Z62Gy7
wxifKCHp+fvYXgvs8p0j9rBUzRG5lXa50RnLTxBVz5F2sDvc4lr1K72pve2H
etnZb8xQxhRd7d5HVbuv8Q+xFTH9
             "]], PolygonBox[CompressedData["
1:eJwtzz0OAUEYxvEZUVEhQmylkWy5UapFKdQqB6BfQbEnEOICQqETFQfgALiG
jyg1/m/2KX6ZnTzvzjxTH477o4xzroQstojQwBovPBFjgh9qCLDATvMt5Lxz
H9Y3ppjhqMxm8uQP1h4GuGOpu+y8BBd00UbFp3cEmlnhoPMsL5DvWZsIrT/7
r+at4xxnzdo/RZ++IVZH63pSbneWyW/qZh2vYt8dVMk36hLp7X+B9yJ0
             "]], 
            PolygonBox[{{139, 32, 136, 245, 246}, {154, 41, 155, 252, 253}, {
             298, 297, 222, 97, 219}, {195, 79, 208, 288, 289}, {289, 288, 
             209, 88, 206}, {253, 252, 137, 32, 153}, {246, 245, 121, 23, 
             138}, {126, 125, 242, 26, 128}, {207, 88, 221, 297, 298}, {124, 
             23, 120, 238, 239}}]}]}, 
         {RGBColor[
          0.8518314686157797, 0.7238016140816667, 0.46613834073745375`], 
          EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwt0D1LglEYxvFzCgSbCgoKWgRzcHJubmhqcHEr6QPkB1CkOS0wWhJdCoK2
3IqGwAaXXoYWrQ8RLkGF4P/iXMOP+zzn9bqf3GGtfLQQQtjCIkYo4wNrMYQd
6gM2GO9Sn3CJImaoYx3fOEEOP96n/Y9o6jymuEEJ1zjz/B86zvCPTEz393Hu
+SuEmO4/xbKz3ev9mDKP/Lb2tJxP93SdTzkbWGX/HnWItud/McGB3mP91meV
5Yta0TfjFWwzHmAppl7U04Vzqo8X799k/dg96h9kffYOPedUT5+UKgrqz9me
McY+8sy9hTSvdd2r+1+dSeN3zAHQoTI3
             "]], PolygonBox[CompressedData["

1:eJwt0LsOAUEUgOE5QkFISGyyW0pQby3RKbZSbO8SD7AewDuoPAEqGhIFQaXR
S1weQ6nzn8wpvsyeOZeZ2cZkmmY551yAPJZoIcYaP4SIMNecODdiHeKNpvjv
AZ7YYqOz2C+gjbHzPR/s0bH5JfE92pvijp3le6iSr6AsfqbOPiNBFwd87W56
xxmultOaC442q4+6+DfFdkaR+GR5jWvi75Baf0R8s16tCYhX1q//aIGH1esb
XnZmYnsh9X8ERSNd
             "]], 
            PolygonBox[{{287, 286, 207, 87, 204}, {157, 42, 153, 254, 255}, {
             144, 143, 251, 37, 146}, {194, 78, 206, 286, 287}, {255, 254, 
             139, 33, 156}, {261, 260, 154, 42, 169}, {141, 33, 138, 247, 
             248}, {250, 25, 128, 143, 144}, {248, 247, 124, 24, 140}, {205, 
             87, 219, 295, 296}, {296, 295, 220, 96, 218}, {180, 61, 181, 268,
              269}}]}]}, 
         {RGBColor[
          0.9144220323865022, 0.8371934809771028, 0.6329058444985544], 
          EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwt0D9LglEUx/F7Hwl0yIJasiG0FCHoWVpaWpoaWjJ9Ab4AeyMV4axF4iJW
NAgGgWRT9GcV85U8tTx9D/c3fLjnHr3nOecUm+enrcg5V0EGB9hDjBuUEHnn
EsWXWOZ+yDnCqg9vnvCFE2z5UGMbO0ixiy4G2McS/7lXPuvD3fJDzFCzt+R+
OOvWH/Er5zEmWOd+xPmMBRqokltRfow7zfKINR96m2LDh/rvqnem780Vl/n9
UzU3iTvqM9XMNvuL+rb8rWa2+m9oa+5rsfgPV9rJL3I+7LivPmqaO689POhd
rBkutP9Ebyzfw4f2U/Bhfuv5G//zSTAY
             "]], PolygonBox[CompressedData["

1:eJwtzz8OQUEQx/F9olH4kxAJKjxKGo1Go1JoeBzAAbiIKJzg0UpQIZEgOk6A
m1D5Tt6v+GR3MrMzs+XJbDCNOefyiCPmOVfhrCJEjTjgHOGNEvFY8RNHdNFH
llzdi3JW88EObdWkyRWVt54PXNBDBwexewspan+cvvZZ4Ku77TjHXbOtf86L
egbqecNV9yEK5NecTfVc4qx5PdWG6t/ACnvtb28SvPe9qJfNeGGr2rb+etIu
Fmeo3egvNiNJ/Af8+iOg
             "]], 
            PolygonBox[{{257, 256, 141, 34, 158}, {159, 43, 156, 256, 257}, {
             285, 284, 205, 86, 203}, {193, 77, 204, 284, 285}, {173, 52, 169,
              262, 263}, {263, 262, 157, 43, 172}}]}]}, 
         {RGBColor[0.9564200241649319, 0.9471606109725046, 0.88151076311045], 
          EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNkL0SAUEQhGdOICOQUVTJT3hWdj8hG3kED8AbOXI/GZkiPF5KT00rF3zV
dbvd07M33ezW20REJqADxioSoS9QgAzMQQAVKHm+Akug8KfQWlwD/Rl9OTjx
uwvvAToDibouWpnf7J567gaO9Ftuzw7rLFt7NdxlqN5hXWfOi9z1TR3hfqD+
ljtzOXsjMxW77fwB+up7XsGTmYbzilYmyN9neuFZyjd82GH/+AuXXB5n
             "]], 
            PolygonBox[{{283, 75, 76, 203}, {264, 54, 53, 172}, {282, 74, 75, 
             202}, {173, 53, 63, 270}, {193, 76, 66, 275}, {190, 63, 74, 
             192}, {174, 56, 45, 161}, {258, 45, 44, 158}, {183, 66, 56, 
             271}, {159, 44, 54, 264}}]}]}}, {{}, 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{257, 159, 264, 172, 263, 173, 270, 182, 190, 192, 201, 
             282, 202, 283, 203, 285, 193, 275, 183, 271, 175, 174, 161, 160, 
             258, 158, 257}]},
           "0.9`"],
          Annotation[#, 0.9, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{248, 141, 256, 156, 255, 157, 262, 169, 261, 171, 269, 
             180, 187, 191, 281, 200, 214, 292, 216, 293, 217, 294, 218, 296, 
             205, 284, 204, 287, 194, 276, 184, 272, 176, 265, 164, 162, 146, 
             144, 250, 142, 249, 140, 248}]},
           "0.8`"],
          Annotation[#, 0.8, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{181, 268, 170, 260, 154, 253, 153, 254, 139, 246, 138, 
             247, 124, 239, 123, 241, 126, 128, 143, 251, 145, 148, 163, 166, 
             266, 177, 273, 185, 277, 195, 289, 206, 286, 207, 298, 219, 295, 
             220}], LineBox[{189, 188, 280, 199, 211, 215}]},
           "0.7`"],
          Annotation[#, 0.7, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{155, 252, 137, 244, 136, 245, 121, 237, 120, 238, 122, 
             240, 125, 242, 127, 243, 129, 131, 147, 150, 165, 168, 267, 179, 
             274, 186, 279, 198, 291, 208, 288, 209, 300, 221, 297, 222}], 
            LineBox[{213, 212}]},
           "0.6`"],
          Annotation[#, 0.6, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{119, 235, 118, 236, 105, 229, 104, 230, 106, 231, 107, 
             232, 108, 233, 111, 113, 130, 133, 149, 152, 259, 167, 178}], 
            LineBox[{196, 278, 197, 290, 210, 302, 223, 299, 224}]},
           "0.5`"],
          Annotation[#, 0.5, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], LineBox[{102, 227, 101, 228, 103}], 
            LineBox[{109, 110, 234, 112, 116, 132, 135, 151}], 
            LineBox[{225, 301, 226}]},
           "0.4`"],
          Annotation[#, 0.4, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], LineBox[{114, 115, 117, 134}]},
           "0.3`"],
          Annotation[#, 0.3, "Tooltip"]& ], {}, {}, {}}}],
      AspectRatio->1,
      Frame->True,
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {1758.8571428571427`, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {360.0000000000002, 291.2461179749811}], 
    InsetBox[
     GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJx1lns8VOkfxweJpJRr/br8VmJnfxVaaqeSZ1IbUbmsarOSYlTatW5Jy/xQ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       "], {{{}, 
         {RGBColor[0., 0.10676688171883167`, 0.018063475446840855`], EdgeForm[
          None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNk7lOQlEQhs8VEDcEFG1k0QaXSsHOrRKUBjdE3BfUxEKewMKn8CVsTHwE
LWyNMcYYLa31Cfwn9yNYfDmcO+fM+Wf+YeS4sXbZ5pyri4DoEZ6wb0MiJuJi
VkyJnNgX62JDJIn3iUNREZtiXuTFtJgQGTEsZsQkuQrsLfcB+ex+inz9Is2a
IH7w731b90RRrIlVsUTM9iXy2b1l1mbM7u2KI/RW4ZhvFeqx98piW9Q4e0Rs
lRw7Iku/rB+jrFbHGGuaXoZEOzV1iE76Z9/C6FtC74pYpE/NGkpoKRMfFN34
tosmq68XP4Migp8BYkXeSPB+F7nNswW8yVLHDX7diktqvMLXcbw1XwfQ8sV6
Jn6JX+NnmJr30GG1fnO/4fzZGqVnpm8OTVviBG+i1BQiZ8q1ZjCJvg76+3+G
UtRWotYw8Tj9G6SGJ8480psEOXo9v+fP9DJCz0/5/Y5G01pDa5V9AD8iaI+y
txpi7O1OnRznxD+cPxdxztU5Z/7bXJj/ZbxYoFcX5PsUL86f16jXmsusa82l
7TN4ZF6+ojnm+eem8P6H1WYh6PlvP3A/x7lxdNh//h49d87/fxfQO4DXGbw1
j4voXmb/Rs/6PD/vLDnynLN7Hr033/4A4XdJzg==
             "]], 
            PolygonBox[CompressedData["
1:eJwt0L0OQUEQhuE9ovQXEY2G5hQqhe4UKo1GIvHXSpCIHFcg4TbONShIXAKF
FhFEKNVcgXfiK57sZGdnd2dKg1krjDnn8ohjpDiBm1icxBBrBKjbec+5HPrE
PVyxU66JFLk9awM1bHFCW3sHbJSrIkKGmi5rB2ekvX/cVu3D7rV9TLCAjwo+
mNodKCDEXX+3mjGeqs3obKS3y/jiqL9bT9bbUrki3ljprUCzmClnM3thrrd9
/S3r/WdjPV3wA11QJBw=
             "]]}]}, 
         {RGBColor[0., 0.3203010547877868, 0.05419049564445523], EdgeForm[
          None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwt0DELQVEYxvFzsSkWpWS5g8lsMRlsyuAjKEpd95btDkS+gdFnoJDBqlAW
hYUFGysmm/+pZ/j1nnvue5/3nOvWg5ofMcZkEcUTeQwQc4wpUmfwkMENd7gI
cEYFSXpX1BIW8NXv6XubM8EHBYxxRRpNvJFDX+9szxx75ds5DjPK1DWWmrVF
Qzk276F1Cz1ljtDWeUK8dP4OEsrcaLbt7+KguTtcUEWK3p/uMtWz3T8hrvUR
X/3DIf5w/ij4
             "]], PolygonBox[CompressedData["
1:eJwt0D0LQWEYxvHnyKbkpSjbGUzms5gMNmXwEQyOKMpmoORz+AgGMlgVyiov
5SU2Zr6A/51r+NV9npf7vs7j17u1TsQ5l0EUPfjI4okxClp7Y4JAa1+sUUbR
7nvOJZHAge8jrrggRBNp9lI4UZ9xxw0ttDFAHjl0sFL/KmLe/47dTWhWQ1kt
3wNd1ZbvhZFqy/zBBiVUsMNMe7a2wF6zbGac/ludtf2l/iFUZsveV1bLPMRc
ZwO91VRvY/08+v0AqzooYg==
             "]], 
            PolygonBox[{{105, 23, 101, 218, 219}, {146, 37, 241, 151, 152}, {
             213, 212, 271, 75, 206}, {107, 106, 222, 26, 109}, {209, 78, 216,
              274, 275}, {152, 151, 172, 58, 249}}]}]}, 
         {RGBColor[
          0.0594360464637271, 0.49262384444448465`, 0.0818759727090751], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{215, 77, 275}, {207, 77, 263}, {109, 25, 107}, {206, 
             76, 213}, {219, 24, 105}, {104, 24, 219}, {112, 24, 227}, {213, 
             76, 273}, {202, 76, 261}, {107, 25, 221}, {117, 25, 230}, {275, 
             77, 209}}], PolygonBox[CompressedData["
1:eJwtz7EOwVAYxfHbRmJgkRgYvQ+LRzCZSIiBQQeeoBYdeIMaamGsgcQLmCTE
UnMtOvl/cYZfmvTe757ztXrD7sB3ztVRQtlzrsO3jSvuaKKBPsYY4YEnTkhR
Ya6Kl+7azARLLJDhjRmmmCPAFhvk+OCIAxLsccFZ/+xshxgeWT5q3r+rdb7p
jVyZlh1hjS8Kdci0g+2yQqg7kTITdbJulmFZqXYN1D3UbKG3Y3X7Ac6cL88=

             "]], 
            PolygonBox[{{225, 224, 105, 24, 112}, {261, 76, 206, 198, 199}, {
             230, 25, 109, 121, 122}, {268, 267, 209, 77, 207}}]}]}, 
         {RGBColor[
          0.1989409185727924, 0.6094290270367053, 0.09818948805168119], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{250, 47, 153}, {244, 54, 158}, {123, 36, 141}, {127, 
             36, 122}, {148, 47, 167}, {153, 47, 147}, {160, 54, 155}, {251, 
             54, 160}, {122, 36, 230}, {158, 54, 179}}], 
            PolygonBox[{{133, 132, 233, 234}, {200, 199, 185, 186}, {208, 207,
              263, 264}, {195, 194, 268, 269}, {175, 174, 258, 259}, {141, 36,
              47, 148}, {203, 202, 261, 262}, {262, 261, 199, 200}, {147, 47, 
             36, 127}, {264, 263, 202, 203}, {234, 233, 115, 116}, {259, 258, 
             194, 195}, {116, 115, 225, 226}, {113, 112, 227, 228}, {228, 227,
              117, 118}, {269, 268, 207, 208}, {226, 225, 112, 113}}], 
            PolygonBox[{{186, 185, 179, 54, 251}, {167, 47, 250, 174, 175}, {
             118, 117, 230, 36, 123}, {155, 54, 244, 132, 133}}]}]}, 
         {RGBColor[0.3563291865434629, 0.709858059924505, 0.1150501143952044],
           EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{113, 34, 226}, {251, 65, 186}, {226, 34, 116}, {208, 
             67, 269}, {200, 65, 262}, {175, 57, 167}, {259, 57, 175}, {247, 
             57, 168}, {130, 34, 236}, {253, 67, 191}, {236, 34, 120}, {189, 
             65, 181}, {186, 65, 200}, {269, 67, 195}}], 
            PolygonBox[{{229, 228, 118, 119}, {161, 160, 155, 156}, {168, 57, 
             67, 253}, {134, 133, 234, 235}, {265, 264, 203, 204}, {119, 118, 
             123, 124}, {156, 155, 133, 134}, {124, 123, 141, 142}, {195, 67, 
             57, 259}, {142, 141, 148, 149}}], 
            PolygonBox[{{235, 234, 116, 34, 130}, {181, 65, 251, 160, 161}, {
             204, 203, 262, 65, 189}, {120, 34, 113, 228, 229}, {149, 148, 
             167, 57, 247}, {191, 67, 208, 264, 265}}]}]}, 
         {RGBColor[
          0.54662460189217, 0.7801534215577786, 0.13291747695810413`], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{130, 44, 235}, {124, 35, 119}, {119, 35, 229}, {245, 
             44, 138}, {134, 44, 156}, {235, 44, 134}, {229, 35, 120}, {135, 
             35, 240}}], 
            PolygonBox[{{266, 265, 204, 205}, {192, 191, 265, 266}, {143, 142,
              149, 150}, {190, 189, 181, 182}, {248, 247, 168, 169}, {254, 
             253, 191, 192}, {205, 204, 189, 190}, {182, 181, 161, 162}, {169,
              168, 253, 254}, {150, 149, 247, 248}}], 
            PolygonBox[{{240, 35, 124, 142, 143}, {162, 161, 156, 44, 245}, {
             237, 236, 120, 35, 135}, {138, 44, 130, 236, 237}}]}]}, 
         {RGBColor[
          0.7263714470226669, 0.8514801429146197, 0.15716076166123816`], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{248, 46, 150}, {143, 46, 240}, {150, 46, 143}, {144, 
             46, 164}, {190, 66, 205}, {266, 66, 192}, {187, 66, 252}, {205, 
             66, 266}}], 
            PolygonBox[{{246, 245, 138, 139}, {183, 182, 162, 163}, {139, 138,
              237, 238}, {238, 237, 135, 136}, {163, 162, 245, 246}, {170, 
             169, 254, 255}}], 
            PolygonBox[{{252, 66, 190, 182, 183}, {136, 135, 240, 46, 144}, {
             164, 46, 248, 169, 170}, {255, 254, 192, 66, 187}}]}]}, 
         {RGBColor[0.8787430767415924, 0.925483406590982, 0.1979505771667181],
           EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{163, 55, 183}, {166, 55, 159}, {246, 55, 163}, {183, 
             55, 252}}], 
            PolygonBox[{{145, 144, 164, 165}, {140, 139, 238, 239}, {137, 136,
              144, 145}, {171, 170, 255, 256}, {239, 238, 136, 137}, {256, 
             255, 187, 188}, {165, 164, 170, 171}}], 
            PolygonBox[{{159, 55, 246, 139, 140}, {188, 187, 252, 55, 
             166}}]}]}, 
         {RGBColor[1., 0.984375, 0.230411], EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{137, 45, 239}, {171, 56, 165}, {188, 56, 256}, {239, 
             45, 140}, {256, 56, 171}, {140, 45, 159}, {166, 56, 188}, {145, 
             45, 137}}], 
            PolygonBox[{{159, 45, 56, 166}, {165, 56, 45, 145}}]}]}}, {{}, 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{239, 140, 159, 166, 188, 256, 171, 165, 145, 137, 239}]},
           
           "0.16`"],
          Annotation[#, 0.16, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{238, 139, 246, 163, 183, 252, 187, 255, 170, 164, 144, 
             136, 238}]},
           "0.14`"],
          Annotation[#, 0.14, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{237, 138, 245, 162, 182, 190, 205, 266, 192, 254, 169, 
             248, 150, 143, 240, 135, 237}]},
           "0.12`"],
          Annotation[#, 0.12, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{229, 120, 236, 130, 235, 134, 156, 161, 181, 189, 204, 
             265, 191, 253, 168, 247, 149, 142, 124, 119, 229}]},
           "0.1`"],
          Annotation[#, 0.1, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{226, 116, 234, 133, 155, 160, 251, 186, 200, 262, 203, 
             264, 208, 269, 195, 259, 175, 167, 148, 141, 123, 118, 228, 113, 
             226}]},
           "0.08`"],
          Annotation[#, 0.08, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{225, 115, 233, 132, 244, 158, 179, 185, 199, 261, 202, 
             263, 207, 268, 194, 258, 174, 250, 153, 147, 127, 122, 230, 117, 
             227, 112, 225}]},
           "0.06`"],
          Annotation[#, 0.06, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{219, 105, 224, 114, 232, 131, 243, 157, 178, 184, 198, 
             206, 213, 273, 215, 275, 209, 267, 193, 257, 173, 249, 152, 146, 
             126, 121, 109, 107, 221, 104, 219}]},
           "0.04`"],
          Annotation[#, 0.04, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{217, 102, 223, 111, 231, 129, 242, 154, 177, 180, 197, 
             201, 211, 271, 212, 272, 214, 274, 216, 276, 210, 270, 196, 260, 
             176, 172, 151, 241, 128, 125, 110, 108, 222, 106, 220, 103, 218, 
             101, 217}]},
           "0.02`"],
          Annotation[#, 0.02, "Tooltip"]& ], {}, {}, {}}}],
      AspectRatio->1,
      Frame->True,
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {2149.7142857142853`, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {359.9999999999998, 291.2461179749811}]}, {}},
  ContentSelectable->True,
  ImageSize->{1107., Automatic},
  PlotRangePadding->{6, 5}]], "Print",
 CellChangeTimes->{{3.46077531487983*^9, 3.46077533113482*^9}, {
   3.460775919496517*^9, 3.460775942214324*^9}, 3.460775994480899*^9, {
   3.460776028742775*^9, 3.460776037026099*^9}, {3.4607909115414753`*^9, 
   3.460790939198042*^9}, {3.460791053541448*^9, 3.460791071088228*^9}, {
   3.460791192918942*^9, 3.46079120390362*^9}, {3.460791447076001*^9, 
   3.460791466900754*^9}, {3.460791545064044*^9, 3.460791570966239*^9}, {
   3.4607934191606007`*^9, 3.460793427137341*^9}, 3.460793490363347*^9, 
   3.460793537533045*^9, 3.460793587457892*^9, {3.460793643757728*^9, 
   3.46079365135855*^9}, {3.460793702770844*^9, 3.46079371762854*^9}, 
   3.4607943489406967`*^9, 3.460794468535598*^9, 3.460794537100586*^9, 
   3.460794606771035*^9, 3.460794647393282*^9, {3.460794683955057*^9, 
   3.460794711541408*^9}, 3.460794743655837*^9, 3.460794821407819*^9, 
   3.460794992687716*^9, {3.460795378587594*^9, 3.460795400763129*^9}, {
   3.460795899873049*^9, 3.460795915454596*^9}, 3.460795960670557*^9, {
   3.460796100655994*^9, 3.460796117353046*^9}, 3.4607962732165003`*^9, 
   3.460800162597351*^9, 3.4608005903774033`*^9, 3.4608019104755707`*^9, {
   3.46080194694875*^9, 3.460801958372828*^9}, {3.460802135395547*^9, 
   3.4608021584324636`*^9}, 3.460802633868291*^9, 3.4608026916143503`*^9, 
   3.460802782534809*^9, {3.460802813107704*^9, 3.460802851003825*^9}, 
   3.460802899121167*^9, {3.460802965047092*^9, 3.460802992739612*^9}, 
   3.460803080117352*^9, 3.4608031238206177`*^9, 3.460803181520192*^9, {
   3.46080323306312*^9, 3.460803259377411*^9}, 3.46080331972618*^9, 
   3.460803380089603*^9, 3.460803500590083*^9, 3.460803634249275*^9, 
   3.460803695867539*^9, 3.460803733168754*^9, 3.4608037682069407`*^9, 
   3.460803808306548*^9, {3.460805796883609*^9, 3.4608058124874477`*^9}, {
   3.460805967269699*^9, 3.460805988517199*^9}, 3.460806043311208*^9, {
   3.4608061104368067`*^9, 3.460806138574252*^9}, {3.460806255006837*^9, 
   3.460806283974195*^9}, 3.460806807263606*^9, {3.460808401910928*^9, 
   3.460808427928109*^9}, {3.460808490273144*^9, 3.4608085097819967`*^9}, 
   3.460808560412644*^9, {3.460808595578998*^9, 3.4608086131948977`*^9}, 
   3.46080866666626*^9, {3.460808755444212*^9, 3.460808819650992*^9}, 
   3.460808864264059*^9, 3.460809006604796*^9, {3.4608090811854763`*^9, 
   3.460809104912641*^9}, {3.460809151929467*^9, 3.460809168752171*^9}, 
   3.4608093860076733`*^9, 3.460809454988336*^9, 3.460809522864664*^9, 
   3.460809555813641*^9, 3.460809599993239*^9, 3.460809658263152*^9, 
   3.460809722507944*^9, {3.460810854015986*^9, 3.460810866689756*^9}, 
   3.4608109498397627`*^9, 3.4608110282394238`*^9, 3.4608110721071033`*^9, 
   3.460816353080124*^9, 3.4608164602305193`*^9, 3.460816634258309*^9, 
   3.460816731670138*^9, 3.4608168084797297`*^9, 3.460816894874284*^9, 
   3.46085946451213*^9, 3.4608595234315767`*^9, 3.460859577166404*^9, 
   3.460859610229175*^9, 3.460859640820545*^9, 3.460859671884251*^9, 
   3.460861034459901*^9, 3.46086107767255*^9, 3.460861174298973*^9, 
   3.46086120538374*^9, 3.460861251291684*^9, 3.460861323178865*^9, {
   3.46086138754945*^9, 3.4608614004495792`*^9}, 3.4608614320313396`*^9, 
   3.460861481320551*^9, 3.4608616211310663`*^9, {3.460861765223168*^9, 
   3.460861786281537*^9}, 3.4608618357668753`*^9, 3.460861918091242*^9, 
   3.460862023167821*^9, {3.460864061052595*^9, 3.460864090834353*^9}, 
   3.460864265960928*^9, {3.4608645935059767`*^9, 3.460864677184669*^9}, 
   3.4608647145529547`*^9, 3.4608928884220953`*^9, {3.460892927185437*^9, 
   3.460892978487932*^9}, {3.460893064002185*^9, 3.46089311369724*^9}, {
   3.460893196424436*^9, 3.460893220994563*^9}, 3.4608932606886387`*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"-", "2.787036644937139`"}]], "Output",
 CellChangeTimes->{
  3.460774172693623*^9, 3.4607742141360817`*^9, 3.460774259371611*^9, {
   3.460774303149437*^9, 3.460774333742992*^9}, {3.460774503977763*^9, 
   3.460774525387253*^9}, 3.460774568669429*^9, {3.4607746433678713`*^9, 
   3.460774749289826*^9}, 3.4607747872637367`*^9, {3.4607752069957323`*^9, 
   3.4607753311834*^9}, {3.4607759195524397`*^9, 3.4607759422690763`*^9}, 
   3.460775994534586*^9, {3.460776028795376*^9, 3.460776037081739*^9}, {
   3.460790911595224*^9, 3.460790939253276*^9}, {3.460791053594666*^9, 
   3.460791071141541*^9}, {3.460791192973082*^9, 3.460791203957177*^9}, {
   3.4607914471303043`*^9, 3.460791466955147*^9}, {3.460791545117042*^9, 
   3.460791571021545*^9}, {3.460793419216103*^9, 3.460793427190727*^9}, 
   3.4607934904166403`*^9, 3.460793537586506*^9, 3.4607935875115547`*^9, {
   3.460793643816039*^9, 3.460793651412258*^9}, {3.4607937028316803`*^9, 
   3.460793717693026*^9}, 3.460794349054253*^9, 3.460794468602188*^9, 
   3.460794537146944*^9, 3.460794606820025*^9, 3.460794647441045*^9, {
   3.460794683999979*^9, 3.460794711587779*^9}, 3.4607947437033663`*^9, 
   3.460794821453476*^9, 3.460794992763452*^9, {3.46079537866004*^9, 
   3.4607954008420343`*^9}, {3.460795899955226*^9, 3.460795915535334*^9}, 
   3.4607959607567463`*^9, {3.460796100730474*^9, 3.460796117431126*^9}, 
   3.460796273298979*^9, 3.46080016267494*^9, 3.46080059045927*^9, 
   3.46080191058669*^9, {3.460801947033931*^9, 3.4608019584551563`*^9}, {
   3.460802135491241*^9, 3.4608021585180397`*^9}, 3.460802633967609*^9, 
   3.460802693048126*^9, 3.460802784188271*^9, {3.46080281423518*^9, 
   3.460802852551197*^9}, 3.460802900679997*^9, {3.460802966464355*^9, 
   3.460802994747815*^9}, 3.460803081703266*^9, 3.460803125487102*^9, 
   3.460803183227213*^9, {3.460803234859148*^9, 3.4608032609697237`*^9}, 
   3.4608033212142887`*^9, 3.460803381478054*^9, 3.4608035021140633`*^9, 
   3.460803635652215*^9, 3.460803697315674*^9, 3.4608037348572693`*^9, 
   3.460803769573984*^9, 3.460803809928953*^9, {3.4608057984622173`*^9, 
   3.460805813824176*^9}, {3.460805968711471*^9, 3.4608059901127863`*^9}, 
   3.460806044738928*^9, {3.460806111860417*^9, 3.460806138661484*^9}, {
   3.4608062551082487`*^9, 3.460806284064145*^9}, 3.460806807365871*^9, {
   3.46080840200484*^9, 3.460808428085409*^9}, {3.4608084903745604`*^9, 
   3.460808509880398*^9}, 3.4608085615495157`*^9, {3.460808596715098*^9, 
   3.460808614316525*^9}, 3.460808667778009*^9, {3.460808756743518*^9, 
   3.460808821361974*^9}, 3.460808866006637*^9, 3.460809008335636*^9, {
   3.4608090829662027`*^9, 3.460809106371428*^9}, {3.4608091533817453`*^9, 
   3.460809170247486*^9}, 3.460809387484213*^9, 3.4608094563846188`*^9, 
   3.4608095239938383`*^9, 3.460809556860118*^9, 3.460809601486121*^9, 
   3.460809659738999*^9, 3.4608097239935083`*^9, {3.46081085410987*^9, 
   3.4608108667828493`*^9}, 3.4608109499384403`*^9, 3.460811028337473*^9, 
   3.46081107221124*^9, 3.4608163531812773`*^9, 3.460816462080289*^9, 
   3.460816636079851*^9, 3.460816733529152*^9, 3.460816810327259*^9, 
   3.460816896707574*^9, 3.460859466583232*^9, 3.460859525199936*^9, 
   3.46085957856656*^9, 3.460859612027454*^9, 3.460859642696507*^9, 
   3.460859673379051*^9, 3.4608610359199123`*^9, 3.460861080130123*^9, 
   3.460861176214602*^9, 3.460861206909174*^9, 3.4608612527872066`*^9, 
   3.4608613245925083`*^9, {3.4608613893716373`*^9, 3.460861402077552*^9}, 
   3.460861433808834*^9, 3.460861482995883*^9, 3.460861622874538*^9, {
   3.460861766989231*^9, 3.460861788062501*^9}, 3.460861837558749*^9, 
   3.460861919837391*^9, 3.46086202490096*^9, {3.460864063005273*^9, 
   3.4608640925582657`*^9}, 3.4608642675973377`*^9, {3.460864595153369*^9, 
   3.460864678530854*^9}, 3.4608647161716623`*^9, 3.4608928885197763`*^9, {
   3.4608929272834787`*^9, 3.4608929785836067`*^9}, {3.460893064106246*^9, 
   3.460893113794902*^9}, {3.4608931965264177`*^9, 3.460893221096546*^9}, 
   3.4608932609137173`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"IndividualLikNonlin", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Y", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"IdioNonlin", ",", 
     RowBox[{"{", "}"}], ",", "m", ",", 
     RowBox[{"eps", "=", 
      RowBox[{"10.", "^", 
       RowBox[{"-", "16"}]}]}], ",", 
     RowBox[{"ksigma", "=", "Infinity"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0", ",", "1"}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"IndividualLik", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Y", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"Idio", ",", 
     RowBox[{"{", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.460264864897327*^9, 3.460264932378791*^9}, {
   3.460265489300803*^9, 3.460265492492799*^9}, {3.46027038606568*^9, 
   3.460270391802556*^9}, {3.4602704971596107`*^9, 3.4602705817118692`*^9}, {
   3.46027367414145*^9, 3.460273674236417*^9}, {3.460279775378045*^9, 
   3.4602797754444103`*^9}, {3.4602799530257587`*^9, 
   3.4602799533811693`*^9}, {3.460280067013379*^9, 3.460280067130088*^9}, {
   3.4602801040742397`*^9, 3.460280104129944*^9}, {3.4602801453821163`*^9, 
   3.4602801673531218`*^9}, {3.46028174693688*^9, 3.460281763776168*^9}, {
   3.4602818356559362`*^9, 3.460281835739462*^9}, {3.460281898670804*^9, 
   3.460281898732609*^9}, {3.460282025318959*^9, 3.460282025741701*^9}, {
   3.460282062175247*^9, 3.460282071535883*^9}, {3.460283778391947*^9, 
   3.4602837888805027`*^9}, {3.4602838305963707`*^9, 3.460283854615387*^9}, {
   3.46028477341341*^9, 3.460284779157151*^9}, {3.460285035206752*^9, 
   3.460285046973556*^9}, {3.46028555906642*^9, 3.460285574425418*^9}, {
   3.4602857519094887`*^9, 3.4602857519715776`*^9}, {3.460285881590439*^9, 
   3.4602858816380377`*^9}, {3.460286117999454*^9, 3.460286123654068*^9}, {
   3.4602863340289307`*^9, 3.4602863377475977`*^9}, {3.4603641927287188`*^9, 
   3.460364197580667*^9}, {3.460365058304535*^9, 3.4603650587979116`*^9}, {
   3.460365091217347*^9, 3.460365126318194*^9}, {3.4603652464521227`*^9, 
   3.460365260029804*^9}, {3.460365412299954*^9, 3.460365434375272*^9}, {
   3.460365485584791*^9, 3.460365520950554*^9}, {3.460366663535665*^9, 
   3.460366678997499*^9}, {3.4603667867732773`*^9, 3.4603667868283587`*^9}, {
   3.460367092714067*^9, 3.460367098883337*^9}, {3.460369235357655*^9, 
   3.460369263924768*^9}, {3.460369362646221*^9, 3.46036936313859*^9}, {
   3.46036946785526*^9, 3.4603694691077127`*^9}, {3.46037339069245*^9, 
   3.460373390747698*^9}, {3.460373605599341*^9, 3.4603736056503153`*^9}, {
   3.460377091108459*^9, 3.460377126962656*^9}, {3.460377288435691*^9, 
   3.460377301095058*^9}, {3.4603774697122087`*^9, 3.460377479788327*^9}, {
   3.460377585320611*^9, 3.460377603716568*^9}, {3.4603776957101793`*^9, 
   3.460377736561165*^9}, {3.460377923292104*^9, 3.4603779233524303`*^9}, {
   3.460378105932313*^9, 3.46037817981962*^9}, {3.460427531315346*^9, 
   3.460427537420005*^9}, {3.460427638978484*^9, 3.4604276390230217`*^9}, {
   3.4604277414332314`*^9, 3.460427769573126*^9}, {3.4604279604982853`*^9, 
   3.460427960554902*^9}, {3.460430680071252*^9, 3.460430680172152*^9}, {
   3.460430712203142*^9, 3.460430712557424*^9}, {3.460430775931464*^9, 
   3.460430776020101*^9}, {3.460430814349124*^9, 3.460430814950081*^9}, {
   3.46043100067663*^9, 3.460431000775926*^9}, {3.460431035518139*^9, 
   3.460431043615539*^9}, {3.460431139283386*^9, 3.460431139330926*^9}, {
   3.4604311987514153`*^9, 3.460431233744923*^9}, {3.460431314274002*^9, 
   3.460431314321568*^9}, {3.4604316727142878`*^9, 3.4604316728008432`*^9}, {
   3.460431886035831*^9, 3.46043189177104*^9}, {3.460432099991972*^9, 
   3.460432100073539*^9}, {3.460432236204804*^9, 3.4604322362468243`*^9}, {
   3.4604323376555843`*^9, 3.460432357162323*^9}, {3.460432403219545*^9, 
   3.460432403269651*^9}, {3.460432564446265*^9, 3.4604325911495867`*^9}, {
   3.460432813689516*^9, 3.460432813733564*^9}, {3.460432944239506*^9, 
   3.460432989199974*^9}, {3.460433097024789*^9, 3.460433097139295*^9}, {
   3.460433291653358*^9, 3.46043329173923*^9}, {3.460433672964451*^9, 
   3.460433673010107*^9}, {3.460433845665332*^9, 3.4604338457416363`*^9}, {
   3.4604344009903316`*^9, 3.460434401033557*^9}, {3.4604346235115023`*^9, 
   3.460434638473834*^9}, {3.460434675871023*^9, 3.460434675925946*^9}, {
   3.4604350413113747`*^9, 3.4604350414069347`*^9}, {3.460436666989565*^9, 
   3.460436677468376*^9}, {3.460437023691847*^9, 3.460437023772811*^9}, {
   3.460437179838045*^9, 3.460437214787621*^9}, {3.4604373750456057`*^9, 
   3.460437375101828*^9}, {3.460437455923118*^9, 3.4604374559862347`*^9}, {
   3.460437643282413*^9, 3.4604376433404827`*^9}, {3.460439284564681*^9, 
   3.46043929340877*^9}, {3.460439393566842*^9, 3.460439393962884*^9}, {
   3.46044000098571*^9, 3.460440001044331*^9}, {3.460443930270521*^9, 
   3.460443930334333*^9}, {3.460443966799687*^9, 3.46044399790462*^9}, {
   3.460444060284606*^9, 3.460444061730588*^9}, {3.460444101336812*^9, 
   3.46044410138903*^9}, {3.460444186536171*^9, 3.460444194286351*^9}, {
   3.460444233408099*^9, 3.460444248920389*^9}, {3.460444338058318*^9, 
   3.460444355662019*^9}, {3.460444400012597*^9, 3.460444431012135*^9}, {
   3.460444591036777*^9, 3.4604446631572647`*^9}, {3.46044479971354*^9, 
   3.460444799768903*^9}, {3.460444831583193*^9, 3.460444859781989*^9}, {
   3.46044502143334*^9, 3.460445021504759*^9}, {3.460459950502769*^9, 
   3.460459971711813*^9}, {3.460460068419449*^9, 3.460460088588605*^9}, {
   3.460460154598343*^9, 3.46046015516997*^9}, {3.460460281436612*^9, 
   3.460460281521656*^9}, {3.4604604120265713`*^9, 3.460460412125514*^9}, {
   3.4604607607833633`*^9, 3.4604607621971283`*^9}, {3.460460826677142*^9, 
   3.460460827186878*^9}, {3.4604608962826014`*^9, 3.4604608963501987`*^9}, {
   3.460460962965583*^9, 3.460460963358262*^9}, {3.46046100555375*^9, 
   3.4604610220017967`*^9}, {3.46046105589403*^9, 3.460461056004932*^9}, {
   3.460461154113535*^9, 3.460461154227416*^9}, {3.460461800671767*^9, 
   3.4604618154025*^9}, {3.46046184541817*^9, 3.46046186011173*^9}, {
   3.460461896620476*^9, 3.460461896672694*^9}, {3.460461952952413*^9, 
   3.4604619533933907`*^9}, {3.460462913572587*^9, 3.460462920740217*^9}, {
   3.460722765559946*^9, 3.460722812479978*^9}, 3.4607228582030888`*^9, {
   3.460722890758842*^9, 3.460722896366596*^9}, {3.46072298397585*^9, 
   3.4607229875994997`*^9}, {3.460723019415843*^9, 3.460723105990931*^9}, {
   3.460723170191799*^9, 3.460723171657259*^9}, {3.460723268211129*^9, 
   3.460723287189331*^9}, {3.460732937278017*^9, 3.4607329553868093`*^9}, {
   3.460733072671542*^9, 3.460733072733719*^9}, 3.460774164086339*^9, {
   3.460774203297064*^9, 3.460774203437456*^9}}],

Cell[BoxData[
 RowBox[{"-", "277.32398835363915`"}]], "Output",
 CellChangeTimes->{
  3.460722864185832*^9, 3.46072290251231*^9, 3.460722994070681*^9, {
   3.4607230259705276`*^9, 3.460723109644692*^9}, 3.4607231775830717`*^9, 
   3.46072323370262*^9, {3.460723272758277*^9, 3.460723291255953*^9}, {
   3.460732942792966*^9, 3.4607329605671864`*^9}, {3.460733023995452*^9, 
   3.460733076751679*^9}, {3.460773704975284*^9, 3.460773732666801*^9}, {
   3.460774198834483*^9, 3.460774204426446*^9}, 3.460775349894099*^9, 
   3.46079373659339*^9, 3.46079546775951*^9, 3.460796169538375*^9, 
   3.460893268111524*^9}],

Cell[BoxData[
 RowBox[{"-", "898.3524671326632`"}]], "Output",
 CellChangeTimes->{
  3.460722864185832*^9, 3.46072290251231*^9, 3.460722994070681*^9, {
   3.4607230259705276`*^9, 3.460723109644692*^9}, 3.4607231775830717`*^9, 
   3.46072323370262*^9, {3.460723272758277*^9, 3.460723291255953*^9}, {
   3.460732942792966*^9, 3.4607329605671864`*^9}, {3.460733023995452*^9, 
   3.460733076751679*^9}, {3.460773704975284*^9, 3.460773732666801*^9}, {
   3.460774198834483*^9, 3.460774204426446*^9}, 3.460775349894099*^9, 
   3.46079373659339*^9, 3.46079546775951*^9, 3.460796169538375*^9, 
   3.460893268122053*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Theta", "=", 
  RowBox[{"{", ".5", "}"}]}]], "Input",
 CellChangeTimes->{{3.460283430587044*^9, 3.460283434302026*^9}, {
  3.460795527892371*^9, 3.460795530129663*^9}, {3.4607955766409597`*^9, 
  3.460795578808557*^9}, {3.46079571050916*^9, 3.460795710548897*^9}}],

Cell[BoxData[
 RowBox[{"{", "0.5`", "}"}]], "Output",
 CellChangeTimes->{
  3.460283435412422*^9, 3.460775352955998*^9, {3.4607955253867073`*^9, 
   3.460795545862266*^9}, 3.460795586661957*^9, 3.460795711874619*^9, 
   3.460796171791313*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"l0", " ", "=", " ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", " ", "#1", ",", " ", 
         RowBox[{"eps", " ", "=", " ", 
          RowBox[{"1", "/", 
           RowBox[{"10.", "^", "16"}]}]}], ",", " ", 
         RowBox[{"ksigma", " ", "=", " ", "Infinity"}], ",", " ", "0"}], 
        "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "0"}], ",", " ", 
         "\"\<NorKorr\>\""}], "}"}]}], "]"}], " ", "&"}]}], " ", ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"l1", " ", "=", " ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", " ", "#1", ",", " ", 
         RowBox[{"eps", " ", "=", " ", 
          RowBox[{"1", "/", 
           RowBox[{"10.", "^", "16"}]}]}], ",", " ", 
         RowBox[{"ksigma", " ", "=", " ", "Infinity"}], ",", " ", "0"}], 
        "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "0"}], ",", " ", 
         "\"\<StochLin\>\""}], "}"}]}], "]"}], " ", "&"}]}], " ", ";"}], 
  " "}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"l2", " ", "=", " ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", " ", "#1", ",", " ", 
         RowBox[{"eps", " ", "=", " ", 
          RowBox[{"1", "/", 
           RowBox[{"10.", "^", "16"}]}]}], ",", " ", 
         RowBox[{"ksigma", " ", "=", " ", "Infinity"}], ",", " ", "0"}], 
        "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "0"}], ",", " ", 
         "\"\<EKF\>\""}], "}"}]}], "]"}], " ", "&"}]}], " ", ";"}], " ", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"l0lin", " ", "=", " ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", " ", "#1", ",", " ", 
         RowBox[{"eps", " ", "=", " ", 
          RowBox[{"1", "/", 
           RowBox[{"10.", "^", "16"}]}]}], ",", " ", 
         RowBox[{"ksigma", " ", "=", " ", "Infinity"}], ",", " ", "0"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "1"}], ",", " ", 
         "\"\<NorKorr\>\""}], "}"}]}], "]"}], " ", "&"}]}], " ", ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"l1lin", " ", "=", " ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", " ", "#1", ",", " ", 
         RowBox[{"eps", " ", "=", " ", 
          RowBox[{"1", "/", 
           RowBox[{"10.", "^", "16"}]}]}], ",", " ", 
         RowBox[{"ksigma", " ", "=", " ", "Infinity"}], ",", " ", "0"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "1"}], ",", " ", 
         "\"\<StochLin\>\""}], "}"}]}], "]"}], " ", "&"}]}], " ", ";"}], 
  " "}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"l2lin", " ", "=", "  ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", " ", "#1", ",", " ", 
         RowBox[{"eps", " ", "=", " ", 
          RowBox[{"1", "/", 
           RowBox[{"10.", "^", "16"}]}]}], ",", " ", 
         RowBox[{"ksigma", " ", "=", " ", "Infinity"}], ",", " ", "0"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "1"}], ",", " ", 
         "\"\<EKF\>\""}], "}"}]}], "]"}], " ", "&"}]}], " ", ";"}], 
  " "}]}], "Input",
 CellChangeTimes->{{3.460282085817231*^9, 3.4602821105254803`*^9}, {
   3.460282171720809*^9, 3.4602821743115873`*^9}, {3.460282379938203*^9, 
   3.460282383283786*^9}, {3.460282626852909*^9, 3.460282635158669*^9}, {
   3.460283528574358*^9, 3.460283534882937*^9}, {3.460369527766265*^9, 
   3.460369582229149*^9}, {3.4606980537546053`*^9, 3.460698090520545*^9}, {
   3.46069815452689*^9, 3.460698158294612*^9}, {3.46069819069496*^9, 
   3.460698194537347*^9}, {3.460698236984003*^9, 3.460698243324768*^9}, {
   3.460698279984375*^9, 3.460698306778549*^9}, 3.460702914215372*^9, {
   3.4607029469570293`*^9, 3.4607029721967697`*^9}, {3.460704571457388*^9, 
   3.460704576893887*^9}, {3.4607168109795427`*^9, 3.4607168162959433`*^9}, {
   3.46071690711674*^9, 3.46071695341546*^9}, 3.460716991335456*^9, {
   3.460717023444168*^9, 3.460717028564159*^9}, 3.4607170586775084`*^9, {
   3.460717150411056*^9, 3.4607171765473013`*^9}, {3.4607937956619453`*^9, 
   3.460793800181624*^9}, {3.460809863708386*^9, 3.460809877027776*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pp", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"l0", "[", "60", "]"}], "\[IndentingNewLine]", 
 RowBox[{"l1", "[", "60", "]"}], "\[IndentingNewLine]", 
 RowBox[{"l2", "[", "60", "]"}]}], "Input",
 CellChangeTimes->{{3.460282153080297*^9, 3.460282158488613*^9}, {
  3.460282193092895*^9, 3.460282220935027*^9}, {3.460282308500825*^9, 
  3.4602823085625467`*^9}, {3.460283195676051*^9, 3.460283196336207*^9}, {
  3.4603662815649853`*^9, 3.460366282970312*^9}, {3.460698345525057*^9, 
  3.460698345602466*^9}, {3.4606984667172117`*^9, 3.460698470379286*^9}, {
  3.460698596520487*^9, 3.460698604587326*^9}, {3.460698866050302*^9, 
  3.46069888194167*^9}, {3.4606991271651297`*^9, 3.460699135538176*^9}, {
  3.460699290645143*^9, 3.4606992926163483`*^9}, {3.460699354347168*^9, 
  3.460699355452443*^9}, {3.4606994671451*^9, 3.46069947483103*^9}, {
  3.460717000907537*^9, 3.460717010074459*^9}, {3.460717065524967*^9, 
  3.4607170967251673`*^9}, {3.460795730013938*^9, 3.460795739827765*^9}, {
  3.4607958067487707`*^9, 3.460795808448151*^9}}],

Cell[BoxData[
 RowBox[{"-", "133.87944488806454`"}]], "Output",
 CellChangeTimes->{
  3.4602821586290083`*^9, {3.460282194672504*^9, 3.460282221034252*^9}, {
   3.460282304124085*^9, 3.4602823096094847`*^9}, 3.460282367700007*^9, 
   3.4602826444891653`*^9, {3.460283191195128*^9, 3.460283196443349*^9}, 
   3.460283538479665*^9, 3.4602841996563187`*^9, 3.460284409519916*^9, 
   3.460364431619211*^9, {3.4603662767860107`*^9, 3.460366326918507*^9}, 
   3.460367142375352*^9, 3.460369509450536*^9, 3.460435649149485*^9, 
   3.460439471087428*^9, 3.460440271569412*^9, 3.460548292309108*^9, {
   3.4606980666425333`*^9, 3.460698116411084*^9}, 3.460698199230464*^9, {
   3.460698342895336*^9, 3.460698347089931*^9}, 3.460698387658757*^9, {
   3.460698464476142*^9, 3.460698471121516*^9}, {3.4606985974210863`*^9, 
   3.460698605644109*^9}, 3.4606986715579033`*^9, {3.4606988664647093`*^9, 
   3.460698885285829*^9}, 3.4606989539947653`*^9, 3.460699091679224*^9, {
   3.460699128326627*^9, 3.460699136744446*^9}, {3.4606992844926853`*^9, 
   3.4606992930867147`*^9}, 3.4606993563387203`*^9, 3.460699395066133*^9, {
   3.46069946832483*^9, 3.460699475642068*^9}, 3.460700396741952*^9, 
   3.460700670871602*^9, 3.4607014955117397`*^9, 3.460701686286664*^9, 
   3.4607029778271503`*^9, 3.4607045343296432`*^9, 3.460704583786036*^9, 
   3.460705006337816*^9, 3.460712648456737*^9, 3.4607130758606462`*^9, 
   3.460713922767914*^9, 3.460714216772244*^9, 3.460714335040298*^9, 
   3.460715094807499*^9, {3.460715236127408*^9, 3.4607152417533503`*^9}, 
   3.460715272166308*^9, 3.460715931802145*^9, 3.460715996563827*^9, 
   3.460716286449524*^9, 3.460716577625821*^9, 3.46071669162184*^9, {
   3.46071681976187*^9, 3.460716834028303*^9}, {3.4607170060678062`*^9, 
   3.460717100708589*^9}, 3.460717933975918*^9, 3.460718170891859*^9, 
   3.460775417897461*^9, 3.460793744407873*^9, 3.460795029135675*^9, 
   3.460795472902068*^9, 3.4607955398152246`*^9, {3.460795572752206*^9, 
   3.460795588880413*^9}, {3.460795731505034*^9, 3.460795765916101*^9}, {
   3.460795802190332*^9, 3.4607958096274633`*^9}, 3.46079597944132*^9, {
   3.4607960117667627`*^9, 3.4607960312942743`*^9}, 3.460796083897943*^9, 
   3.460796176858696*^9, 3.4607962257853394`*^9, 3.4608002208398037`*^9, 
   3.460809679827621*^9, 3.460809742320033*^9, 3.460809772693162*^9, 
   3.4608098886459627`*^9, 3.460811090518023*^9}],

Cell[BoxData[
 RowBox[{"-", "132.86848563590704`"}]], "Output",
 CellChangeTimes->{
  3.4602821586290083`*^9, {3.460282194672504*^9, 3.460282221034252*^9}, {
   3.460282304124085*^9, 3.4602823096094847`*^9}, 3.460282367700007*^9, 
   3.4602826444891653`*^9, {3.460283191195128*^9, 3.460283196443349*^9}, 
   3.460283538479665*^9, 3.4602841996563187`*^9, 3.460284409519916*^9, 
   3.460364431619211*^9, {3.4603662767860107`*^9, 3.460366326918507*^9}, 
   3.460367142375352*^9, 3.460369509450536*^9, 3.460435649149485*^9, 
   3.460439471087428*^9, 3.460440271569412*^9, 3.460548292309108*^9, {
   3.4606980666425333`*^9, 3.460698116411084*^9}, 3.460698199230464*^9, {
   3.460698342895336*^9, 3.460698347089931*^9}, 3.460698387658757*^9, {
   3.460698464476142*^9, 3.460698471121516*^9}, {3.4606985974210863`*^9, 
   3.460698605644109*^9}, 3.4606986715579033`*^9, {3.4606988664647093`*^9, 
   3.460698885285829*^9}, 3.4606989539947653`*^9, 3.460699091679224*^9, {
   3.460699128326627*^9, 3.460699136744446*^9}, {3.4606992844926853`*^9, 
   3.4606992930867147`*^9}, 3.4606993563387203`*^9, 3.460699395066133*^9, {
   3.46069946832483*^9, 3.460699475642068*^9}, 3.460700396741952*^9, 
   3.460700670871602*^9, 3.4607014955117397`*^9, 3.460701686286664*^9, 
   3.4607029778271503`*^9, 3.4607045343296432`*^9, 3.460704583786036*^9, 
   3.460705006337816*^9, 3.460712648456737*^9, 3.4607130758606462`*^9, 
   3.460713922767914*^9, 3.460714216772244*^9, 3.460714335040298*^9, 
   3.460715094807499*^9, {3.460715236127408*^9, 3.4607152417533503`*^9}, 
   3.460715272166308*^9, 3.460715931802145*^9, 3.460715996563827*^9, 
   3.460716286449524*^9, 3.460716577625821*^9, 3.46071669162184*^9, {
   3.46071681976187*^9, 3.460716834028303*^9}, {3.4607170060678062`*^9, 
   3.460717100708589*^9}, 3.460717933975918*^9, 3.460718170891859*^9, 
   3.460775417897461*^9, 3.460793744407873*^9, 3.460795029135675*^9, 
   3.460795472902068*^9, 3.4607955398152246`*^9, {3.460795572752206*^9, 
   3.460795588880413*^9}, {3.460795731505034*^9, 3.460795765916101*^9}, {
   3.460795802190332*^9, 3.4607958096274633`*^9}, 3.46079597944132*^9, {
   3.4607960117667627`*^9, 3.4607960312942743`*^9}, 3.460796083897943*^9, 
   3.460796176858696*^9, 3.4607962257853394`*^9, 3.4608002208398037`*^9, 
   3.460809679827621*^9, 3.460809742320033*^9, 3.460809772693162*^9, 
   3.4608098886459627`*^9, 3.460811094156362*^9}],

Cell[BoxData[
 RowBox[{"-", "125.8303684275725`"}]], "Output",
 CellChangeTimes->{
  3.4602821586290083`*^9, {3.460282194672504*^9, 3.460282221034252*^9}, {
   3.460282304124085*^9, 3.4602823096094847`*^9}, 3.460282367700007*^9, 
   3.4602826444891653`*^9, {3.460283191195128*^9, 3.460283196443349*^9}, 
   3.460283538479665*^9, 3.4602841996563187`*^9, 3.460284409519916*^9, 
   3.460364431619211*^9, {3.4603662767860107`*^9, 3.460366326918507*^9}, 
   3.460367142375352*^9, 3.460369509450536*^9, 3.460435649149485*^9, 
   3.460439471087428*^9, 3.460440271569412*^9, 3.460548292309108*^9, {
   3.4606980666425333`*^9, 3.460698116411084*^9}, 3.460698199230464*^9, {
   3.460698342895336*^9, 3.460698347089931*^9}, 3.460698387658757*^9, {
   3.460698464476142*^9, 3.460698471121516*^9}, {3.4606985974210863`*^9, 
   3.460698605644109*^9}, 3.4606986715579033`*^9, {3.4606988664647093`*^9, 
   3.460698885285829*^9}, 3.4606989539947653`*^9, 3.460699091679224*^9, {
   3.460699128326627*^9, 3.460699136744446*^9}, {3.4606992844926853`*^9, 
   3.4606992930867147`*^9}, 3.4606993563387203`*^9, 3.460699395066133*^9, {
   3.46069946832483*^9, 3.460699475642068*^9}, 3.460700396741952*^9, 
   3.460700670871602*^9, 3.4607014955117397`*^9, 3.460701686286664*^9, 
   3.4607029778271503`*^9, 3.4607045343296432`*^9, 3.460704583786036*^9, 
   3.460705006337816*^9, 3.460712648456737*^9, 3.4607130758606462`*^9, 
   3.460713922767914*^9, 3.460714216772244*^9, 3.460714335040298*^9, 
   3.460715094807499*^9, {3.460715236127408*^9, 3.4607152417533503`*^9}, 
   3.460715272166308*^9, 3.460715931802145*^9, 3.460715996563827*^9, 
   3.460716286449524*^9, 3.460716577625821*^9, 3.46071669162184*^9, {
   3.46071681976187*^9, 3.460716834028303*^9}, {3.4607170060678062`*^9, 
   3.460717100708589*^9}, 3.460717933975918*^9, 3.460718170891859*^9, 
   3.460775417897461*^9, 3.460793744407873*^9, 3.460795029135675*^9, 
   3.460795472902068*^9, 3.4607955398152246`*^9, {3.460795572752206*^9, 
   3.460795588880413*^9}, {3.460795731505034*^9, 3.460795765916101*^9}, {
   3.460795802190332*^9, 3.4607958096274633`*^9}, 3.46079597944132*^9, {
   3.4607960117667627`*^9, 3.4607960312942743`*^9}, 3.460796083897943*^9, 
   3.460796176858696*^9, 3.4607962257853394`*^9, 3.4608002208398037`*^9, 
   3.460809679827621*^9, 3.460809742320033*^9, 3.460809772693162*^9, 
   3.4608098886459627`*^9, 3.460811096706929*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"l0", "[", "mm", "]"}], ",", 
           RowBox[{"l1", "[", "mm", "]"}], ",", " ", 
           RowBox[{"l2", "[", "mm", "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"mm", ",", "2", ",", 
           RowBox[{"M", "=", "60"}]}], "}"}]}], "]"}], "//", 
       RowBox[{
        RowBox[{"AddTimeAxis", "[", 
         RowBox[{"#", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "M", ",", "1"}], "}"}]}], "]"}], "&"}]}], "//", 
      RowBox[{
       RowBox[{"plot1", "[", 
        RowBox[{"#", ",", 
         RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], "&"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"l0lin", "[", "mm", "]"}], ",", 
           RowBox[{"l1lin", "[", "mm", "]"}], ",", 
           RowBox[{"l2lin", "[", "mm", "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"mm", ",", "2", ",", 
           RowBox[{"M", "=", "20"}]}], "}"}]}], "]"}], "//", 
       RowBox[{
        RowBox[{"AddTimeAxis", "[", 
         RowBox[{"#", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "M", ",", "1"}], "}"}]}], "]"}], "&"}]}], "//", 
      RowBox[{
       RowBox[{"plot1", "[", 
        RowBox[{"#", ",", 
         RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], "&"}]}]}], "}"}], "//",
    "GraphicsRow"}], "\[IndentingNewLine]", "\[IndentingNewLine]"}]], "Input",\

 CellChangeTimes->{{3.460281783177149*^9, 3.460281824576651*^9}, {
   3.460281910255617*^9, 3.460281943368555*^9}, {3.460281981836998*^9, 
   3.4602819975731277`*^9}, {3.4602820319744387`*^9, 3.460282053018779*^9}, {
   3.460282118996468*^9, 3.460282133562097*^9}, {3.460282239307322*^9, 
   3.460282241400333*^9}, {3.46028239420243*^9, 3.4602824371035967`*^9}, {
   3.460284414532241*^9, 3.4602844151683893`*^9}, {3.460284789442216*^9, 
   3.4602847924493017`*^9}, {3.4603644911795893`*^9, 3.460364500191489*^9}, {
   3.4603695897129087`*^9, 3.460369625240038*^9}, {3.460439520790577*^9, 
   3.46043953878603*^9}, {3.460439576047587*^9, 3.46043961923698*^9}, {
   3.460548309147976*^9, 3.4605483174968367`*^9}, {3.460698218433448*^9, 
   3.4606982189993668`*^9}, {3.46069831865662*^9, 3.46069832472578*^9}, {
   3.4606986846777077`*^9, 3.460698686195219*^9}, {3.460698801081359*^9, 
   3.460698839662919*^9}, 3.4606988983413677`*^9, {3.460699493303959*^9, 
   3.460699521539399*^9}, {3.460703038834033*^9, 3.4607030392870197`*^9}, {
   3.460704537168377*^9, 3.460704565215843*^9}, {3.460704964492584*^9, 
   3.4607049654824247`*^9}, {3.460716586378721*^9, 3.4607165874503813`*^9}, {
   3.460716698553081*^9, 3.460716698621357*^9}, {3.460716874013295*^9, 
   3.4607168854884872`*^9}, {3.460717105177659*^9, 3.460717118490457*^9}, {
   3.460717189751791*^9, 3.460717263423542*^9}, {3.460718184809017*^9, 
   3.460718184886208*^9}, {3.460718268047081*^9, 3.460718284726698*^9}, {
   3.4607755347462053`*^9, 3.4607755471913977`*^9}, {3.46077559546695*^9, 
   3.4607755976225233`*^9}, {3.4607941597744217`*^9, 3.460794160368875*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{{}, {}, 
        {RGBColor[0, 0, 1], PointSize[0.003], Thickness[0.003], 
         Dashing[{}], {}, 
         {Opacity[1], LineBox[CompressedData["
1:eJw10GtIU2Ecx/EpepyBImiYaZI2yqZZXkqdpT918zIvrQumJelmM+e0ZZqj
8HKcqET2RrMXDe0i5V40FcIyULbES2iEkXZ5o4TSKgvUSEwXXfD5HzgcvnzO
c57/cwJUuuNqR4FAEPvv/v9kF8bGb7vIqwKeb6YQV74MTflVdlk32wNieamp
07uStRfsbUGjPdklrLehatqZm2gsY+0HYaxpIwmlrHfCDfMdLW8LWQcix3r/
o8imZS1C01kHTf+tc6x3g5sMTh/5RN8PQrb0h7V/SM1ajMmrdR8ClUWsQyDJ
C/Wa76MOBXc0zkO/l/Y7AINnYsW+6GLWYeC6jb0PJpSsw7Ga/VAy03medQRa
ozbSfjaRR2K2XA9OTfsfRJbTKZenPirWhyAbjXrj703zR8GvYiDv5Tp5NB7n
G02uOponBpa6/c1btNQS1IZyETUN1LGQ10i50w20/jCGL7YpGjfIj6BvoUc/
HknzxSEiK7n9CU/7xyPQqn4UXVLAGoDd/KtrhDkPmBarc04Ekydg6Zn+5OIr
8gQMrG33+RxOnoicr66eZn/yRNydlpTZJORJ8L3uePnMMTYfn4QBgeC7sZpc
Cvddvd0tWnYeXoqJP25d3svkMuxpl5SorrHz8DKIhFMtlyrpfMmobbZpC+fY
+3wyFMMz9e9WyVNg+PbbHKwkTwG/Y1aXm0v/LxWDFkOkwYc8FWsOY8VzKvI0
hBSVrfD2fOZpEMusMfEKcjmct97RlQtpvRwXbG6WbnfydHiEr4sFYeTpeF9o
XkjpoPky0Kq8d6NZQ54Bw3KB/aaCPBMrTkv1r43kmXhhmdWsh5FnYcHXqBEN
Flj/AqteEzM=
           "]]}}}, {{}, {}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.003], Thickness[0.003], 
         Dashing[{}], {}, 
         {Opacity[1], LineBox[CompressedData["
1:eJw1kHtIk1EYxj8MbxAlKimilVemmcxrMzWfqZs63Ypa66KiOc2l84LljWxZ
uTQQKlGyHAiaZFBLY1mNss0ukyj2R0TUKrXoIhorRAqW64LnPfBx+PF7z/M+
fMGltTvLXTiOS/n3/b/ZwRPLJXdJY7B5BT2AyPKGeL960wp7Yczz9c+8ty2M
fbEvzLpGN1TF2B88sXA61VHGOBABt5v2jJxSM96IaOEAX7ZWyTgES1Pe1WnD
FYzDcNVzdvG0jjgCcknsjop0yuPB81wRrstpXxTeHOwzBZ4hHw1ZwrU63YKK
cQz6l/n6VSrax8dAZb2W30jzsShqD43h/MoZx+GmgOsK2XCAcTws37X3577R
+wRsd51ofGQvYZwIt5rl6VvvShkn4aT6mSGkkOa3YFAzWdhtpDwBbMoLyiAx
7U9Ghn1BcOIx+a1o5dWPhF+mPimQHDacN9WQT8UdJ3fE1kn5aeiOUOT2FJHf
Bp+zHTzzb+J0wC3/4WId9QOSqg3NleOsfxtw98rqlldq8kJEhTYPCnaRF2LE
x6v1cwzlZSDwWMGmxAjyGahSN783G+l/ZCLM1mOc/EI+Ew59oUZmJZ8FL0e4
7591bF9bFjxERjvfn/JFcM7fOFRQQ16E+eNLtosG8mKoRnUOrZy8GF+FZR8H
XKh/NqY+WeIzwebbsuHYK+hoV9D7HHSN/3gRPUz9cnDPGjc79ZL65UI7a22Q
1pHPRcKH3aNHTeQl6Nuv6IxMIy+Bxr55LHaOfB5qXZN/6S3FzOdhpt37gT6A
fD6kGsXzpgny+ShxnxEVyxlzUqxfqO5V8Slfir7gIWdDEHkZOlTKwaf9Jaa/
xcoWlQ==
           "]]}}}, {{}, {}, 
        {RGBColor[1, 0, 0], PointSize[0.003], Thickness[0.003], 
         Dashing[{}], {}, 
         {Opacity[1], LineBox[CompressedData["
1:eJw1j3tIU2EYh8dOhBaEVlakhZkzL0N0ldepv805nVewNBTRnE3LpCFaQzbt
pCAVYsJKpptlpZDUHxqMIClmSJqdwDIvoeTCiPlHzZgMC7ILfe+Bw+Hh+d73
e84hrb5QJxaJRMl/339f9qCx64Lth9fq+I8+iBPnywR3L2M/NA/EO8vDzIx3
gx9ulW6Kecb7II7od2tn6hgHoVjf7LhxrYZxMKZdgQcXPecZhyDd+inokvMs
41AYKvu8ViVxGDYsTxZ6H9C+cHyXW/TNI2cYR6L/7VVfqYtYCg2XernYW8s4
GgOnDJL9L04zjsG0vGfoQE0V41gYTRNHmhQ6xjL8TOvwXVupZHwUvfVl2yVJ
1YyPQbdntcZkofnj8BEino4LxHEYPtwxuNxF5+MhjywyrUbR/QmYGP5cVNCp
ZZyI0m/lfVfaqT8JMe5Eyc5+4mTcf1fv8ZdRnxyd3NTLED3tS4FaZjMIo9Sb
Cn27/4BrlHrS0DSXmGV8RgyM+RbvEGYY84B2MupNSxTNK3DTHj56vYft5xX4
aP5qNz+kXiWeB3ffW21i53klpPYV7cU28umYnMucdw+RT8dda8OXRxz1qmDq
bDgZ7CSvwvp49Ku6AvIZmDM67Kr3bB+fAU9bgGstl/rUWPbLSxBt0LwapXck
i9xW8plwtiwFWJbKmc9Eyfw8J6mlviwECnsXhnbR/2XBq9nSrfpAXoNtsbOD
jhTyGky1mcdFr6kvG0pbipkzks+GeL3LNqhj94ly0FNlVJxQU38OPA21vyzV
NJ+LTe5WauNv6s8FbxAaS8LI50E1tjHiySafh8LH51pmyyqYz0crd3ss9GKF
4w+dlB4H
           "]]}}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{10., 0},
      DisplayFunction->Identity,
      Frame->True,
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {192., -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{{}, {}, 
        {RGBColor[0, 0, 1], PointSize[0.003], Thickness[0.003], 
         Dashing[{}], {}, 
         {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBmIQDQUOBY7vg5hFpx+AcDkcZK2+nJpmlQnlCzhEhb1Y
lBCVAeWLoPElHGJQ+DIO0Sh8BTT1Smh8FTT1amjyGmh8LTS+jgNLFDJfz6EB
Rd7AgT0GmW/osBBF3shhFoq8sQNHJDLfxMEgFsIHAHymVgQ=
           "]]}}}, {{}, {}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.003], Thickness[0.003], 
         Dashing[{}], {}, 
         {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBmIQDQUOBY7vg5hFpx+AcDkcOjiP2368lQnlC6DxRRy6
UPgSaHwZhzoUvoJDAwpfyWEuCl8FTV7NoRGFr+HQjsLXcpiCwtdxaONC5uuh
ucfAwYEbmW/oMA1F3sihCEXe2GEWinkmDp08ED4AqKVd5Q==
           "]]}}}, {{}, {}, 
        {RGBColor[1, 0, 0], PointSize[0.003], Thickness[0.003], 
         Dashing[{}], {}, 
         {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBmIQDQUOZX7pefJbcg5AuBxofAE0vggaXwKNL4PGV0Dj
K6HxVdD4amh8DTS+FhpfB42vh8Y3QOMbovGN0PjGaHwTOB8AtPVNWw==
           "]]}}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{5., -1400.},
      DisplayFunction->Identity,
      Frame->True,
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {576., -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}]}, {}},
  ContentSelectable->True,
  ImageSize->{591., Automatic},
  PlotRangePadding->{6, 5}]], "Output",
 CellChangeTimes->{
  3.460775425448578*^9, 3.4607754700659657`*^9, 3.460775539899415*^9, {
   3.460775579367695*^9, 3.4607756028765783`*^9}, 3.46079375348527*^9, 
   3.460794109114853*^9, {3.460794141208694*^9, 3.460794166108056*^9}, 
   3.460795038999024*^9, 3.460795481918459*^9, 3.460795596595607*^9, 
   3.46079577538967*^9, 3.460795997989531*^9, 3.460796092546796*^9, 
   3.46079615257302*^9, 3.4607961864423943`*^9, 3.460796233751705*^9, 
   3.460800232377943*^9, 3.460809880932366*^9, 3.460811395614438*^9}]
}, Open  ]],

Cell[BoxData["."], "Input",
 CellChangeTimes->{3.460796153679181*^9}],

Cell[TextData[StyleBox["Math7/Intel/ OS X",
 FontColor->RGBColor[1, 0, 0]]], "Text",
 PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"THETA0", "=", "Theta"}], "\n", 
 RowBox[{"F0", "=", 
  RowBox[{"IdentityMatrix", "[", 
   RowBox[{"Length", "[", "THETA0", "]"}], "]"}]}], "\n", "SCALING", "\n", 
 RowBox[{"FISHER", "=", "True"}], "\n", 
 RowBox[{"MAXSTEP", "=", "1"}], "\n", 
 RowBox[{"STEPREDUCE", "=", "4"}], "\[IndentingNewLine]", 
 RowBox[{"FDIGITS", "=", "16"}], "\[IndentingNewLine]", 
 RowBox[{"pp", "=", "0"}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601143146009274`*^9, 3.460114315759859*^9}, 
   3.460282522110393*^9, {3.460283799592029*^9, 3.4602838013662*^9}, {
   3.4604357137809753`*^9, 3.460435744591599*^9}, {3.460435786839238*^9, 
   3.4604357909828987`*^9}, {3.460435825453755*^9, 3.460435826628525*^9}, {
   3.460435861768526*^9, 3.460435863165637*^9}, {3.460435902549529*^9, 
   3.460435902612645*^9}, {3.460435960264574*^9, 3.460435960325345*^9}, {
   3.460800240094215*^9, 3.46080024273132*^9}, {3.460800295594029*^9, 
   3.460800296159734*^9}, {3.4608954999782867`*^9, 3.460895502131062*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", "0.5`", "}"}]], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460800243362911*^9, 3.4608002973198147`*^9, 3.460893288670948*^9, 
   3.460895516749981*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "1", "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460800243362911*^9, 3.4608002973198147`*^9, 3.460893288670948*^9, 
   3.460895516761245*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460800243362911*^9, 3.4608002973198147`*^9, 3.460893288670948*^9, 
   3.4608955167686253`*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460800243362911*^9, 3.4608002973198147`*^9, 3.460893288670948*^9, 
   3.4608955167764387`*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460800243362911*^9, 3.4608002973198147`*^9, 3.460893288670948*^9, 
   3.460895516783753*^9}],

Cell[BoxData["4"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460800243362911*^9, 3.4608002973198147`*^9, 3.460893288670948*^9, 
   3.460895516790682*^9}],

Cell[BoxData["16"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460800243362911*^9, 3.4608002973198147`*^9, 3.460893288670948*^9, 
   3.460895516797542*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460800243362911*^9, 3.4608002973198147`*^9, 3.460893288670948*^9, 
   3.460895516804824*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Nichtlinear", "/", "NorKorr"}]], "Input",
 CellChangeTimes->{{3.460367266700344*^9, 3.46036726904226*^9}, {
  3.460800444634096*^9, 3.460800460394889*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "scoreii", ",", "k", 
      ",", "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
    RowBox[{"BFGS", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"Y", ",", "X", ",", 
         RowBox[{"-", "9"}]}], "}"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      "\t  ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"IdioNonlin", ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"m", "=", "100"}], ",", 
          RowBox[{"eps", "=", 
           RowBox[{"10.", "^", 
            RowBox[{"-", "16"}]}]}], ",", 
          RowBox[{"ksigma", "=", "Infinity"}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Lik", ",", "IndividualLikNonlin", ",", "Score", ",", "Hesse"}], 
         "}"}]}], "}"}], ",", "\[IndentingNewLine]", "            ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Sing", "=", "False"}], ",", 
          RowBox[{"2", "Pi"}], ",", "0", ",", 
          RowBox[{"onlynorkorr", "=", "0"}], ",", "\"\<NorKorr\>\""}], "}"}], 
        ",", 
        RowBox[{"KMAX", "=", "20"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EPS1", "=", ".0001"}], ",", 
          RowBox[{"EPS2", "=", ".0001"}]}], "}"}], ",", "\[IndentingNewLine]",
         "             ", 
        RowBox[{"OPTION", "=", "0"}], ",", 
        RowBox[{"PRINT", "=", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1"}], "}"}]}]}], "}"}]}], "]"}]}], ";"}], 
  "                                                                           \
     "}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113330285616*^9, 3.460113346379695*^9}, {
   3.460200648978776*^9, 3.4602006503583603`*^9}, {3.460200794874672*^9, 
   3.4602007984595947`*^9}, 3.460201903279232*^9, {3.460201941045977*^9, 
   3.4602019411313553`*^9}, {3.460279278878285*^9, 3.460279290392777*^9}, {
   3.460279385569292*^9, 3.4602794078107224`*^9}, 3.460279483282811*^9, {
   3.460282734453003*^9, 3.46028273588818*^9}, {3.460283616696549*^9, 
   3.460283634147719*^9}, {3.4602836706901093`*^9, 3.460283671258127*^9}, {
   3.4602837458995867`*^9, 3.4602837460095263`*^9}, {3.460283977779047*^9, 
   3.4602839782382393`*^9}, {3.460284094017385*^9, 3.460284112248164*^9}, {
   3.4602842039019938`*^9, 3.460284237509654*^9}, {3.460285585933895*^9, 
   3.460285590933837*^9}, 3.460367196326754*^9, {3.460435757860738*^9, 
   3.460435758943184*^9}, {3.460435888109399*^9, 3.460435888167045*^9}, {
   3.4604359232590923`*^9, 3.4604359236923323`*^9}, {3.460800256155857*^9, 
   3.4608002648029137`*^9}, {3.460800465883931*^9, 3.46080049502407*^9}, 
   3.4608953686428633`*^9, {3.460895402378611*^9, 3.460895402446619*^9}, {
   3.460895484634429*^9, 3.460895486454823*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Tiefe von data = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["Tiefe von data = ", 5],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9}],

Cell[BoxData["\<\"L\[ADoubleDot]nge der Paneldaten\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518358543*^9}],

Cell[BoxData[
 RowBox[{"{", "50", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518372972*^9}],

Cell[BoxData["\<\"***********************LSDE1********************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518388318*^9}],

Cell[BoxData["\<\"***********************MODUL:    BFGS \
(skeleton)**************\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518401721*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518449093*^9}],

Cell[BoxData["\<\"Technical Output\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518514667*^9}],

Cell[BoxData["IndividualLikNonlin"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518563735*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518618251*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"KMAX\"\>",
       HoldForm], 
      TagBox["\<\"EPS1\"\>",
       HoldForm], 
      TagBox["\<\"EPS2\"\>",
       HoldForm], 
      TagBox["\<\"K\"\>",
       HoldForm], 
      TagBox["\<\"Q\"\>",
       HoldForm], 
      TagBox["\<\"n\"\>",
       HoldForm], 
      TagBox["\<\"T\"\>",
       HoldForm], 
      TagBox["\<\"OPTION\"\>",
       HoldForm]},
     {"1", "20", "0.0001`", "0.0001`", "2", "1", "1", "49", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"KMAX", "EPS1", "EPS2", "K", "Q", "n", "T", "OPTION"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518679482*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518728423*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"MAXSTEP\"\>",
       HoldForm], 
      TagBox["\<\"MINSTEP\"\>",
       HoldForm], 
      TagBox["\<\"BOUND\"\>",
       HoldForm], 
      TagBox["\<\"STEPREDUCE\"\>",
       HoldForm], 
      TagBox["\<\"FMAX\"\>",
       HoldForm]},
     {"1", "1", "1.`*^-10", "1.`*^-6", "4", "1000"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"MAXSTEP", "MINSTEP", "BOUND", "STEPREDUCE", "FMAX"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518779587*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608955188250113`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"RESAMPLING\"\>",
       HoldForm], 
      TagBox["\<\"FDIGITS\"\>",
       HoldForm], 
      TagBox["\<\"TYP\"\>",
       HoldForm], 
      TagBox["\<\"YMAX\"\>",
       HoldForm], 
      TagBox["\<\"ANALGRAD\"\>",
       HoldForm], 
      TagBox["\<\"FACTOR\"\>",
       HoldForm], 
      TagBox["\<\"CSEED\"\>",
       HoldForm]},
     {"1", "True", "16", "1", "1.`*^8", "False", "1.`", 
      RowBox[{"-", "999"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {
      "RESAMPLING", "FDIGITS", "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}},
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608955188902187`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518940336*^9}],

Cell[BoxData["\<\"    SCALING\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895519015873*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "::", "\<\"nmtx\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The first two levels of the \
one-dimensional list \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\
\\!\\({}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" cannot be \
transposed.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Transpose\\\", ButtonNote -> \\\"Transpose::nmtx\\\
\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.460113347438837*^9, 3.4601140477211742`*^9, 3.460114171488365*^9, 
   3.4601142582303123`*^9, 3.46011431981378*^9, 3.4601210026174927`*^9, 
   3.4602006082555428`*^9, 3.4602006525509787`*^9, 3.4602007997492933`*^9, {
   3.460201893745349*^9, 3.460201903902554*^9}, 3.4602019417761383`*^9, 
   3.460279294169009*^9, 3.460279424327683*^9, 3.4602794918395157`*^9, 
   3.460282465738028*^9, 3.4602825470673647`*^9, 3.460282687933013*^9, 
   3.4602827362471*^9, 3.460282807351432*^9, 3.460282913928569*^9, 
   3.460283210827161*^9, 3.460283352033407*^9, 3.460283407184712*^9, {
   3.460283619834437*^9, 3.460283671655117*^9}, 3.460283747410516*^9, 
   3.460283804801373*^9, {3.460283909419492*^9, 3.460283979704739*^9}, 
   3.46028403988277*^9, {3.4602840959065733`*^9, 3.460284112635261*^9}, 
   3.460284241484562*^9, 3.4602855917581997`*^9, {3.460367187530768*^9, 
   3.4603671971813374`*^9}, 3.460435693346806*^9, {3.460435725332974*^9, 
   3.460435760027495*^9}, 3.460435797489111*^9, 3.460435835765499*^9, {
   3.460435866970508*^9, 3.460435925364402*^9}, 3.460435963989526*^9, 
   3.460440284356594*^9, {3.460800275063458*^9, 3.460800302789452*^9}, {
   3.460800468359326*^9, 3.460800496223838*^9}, 3.460893308685207*^9, 
   3.460895369843894*^9, 3.4608954034235277`*^9, 3.460895519071595*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  RowBox[{"Transpose", "[", 
   RowBox[{"{", "}"}], "]"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
    0]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895519120216*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895519164266*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608955192151947`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608955192694674`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STARTWERT THETA0 = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.5`", "}"}]}],
  SequenceForm["STARTWERT THETA0 = ", {0.5}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608955193400307`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895524807722*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "2746.7811279296875`", "}"}], ",", 
   RowBox[{"-", "242.61540866155246`"}]}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608955311331673`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895531174357*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["BFGS: Iteration = ", 1],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895531229576*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -222.774732390654600\"\>",
     -222.77473239065455`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-222.77473239065455`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895537572174*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -242.615408661552500\"\>",
     -242.61540866155246`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-242.61540866155246`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895537611356*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    19.840676270897920\"\>",
     19.840676270897916`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[19.840676270897916`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895537671023*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895537720559*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.5000\"\>",
         1.5,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5000\"\>",
         0.5,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0000\"\>",
         1.,
         AutoDelete->True], 
        InterpretationBox["\<\" 2746.8000\"\>",
         2746.7811279296875`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.46089553777262*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895537835382*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895537888165*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "2.2351741790771484`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {2.2351741790771484`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895544092255*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "0.000049062284138775184`"}],
  SequenceForm["NOISE  ", 0.000049062284138775184`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895550491234*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "0.00045432900765033203`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "1.`"}],
  SequenceForm["*BFGSUP ", 0.00045432900765033203`, "  ", 1.],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895550535028*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "3.674561877006842`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 3.674561877006842, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895550588015*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895550638076*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "2"}],
  SequenceForm["BFGS: Iteration = ", 2],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895550687554*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -217.961614003049900\"\>",
     -217.96161400304987`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-217.96161400304987`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895557016013*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -222.774732390654600\"\>",
     -222.77473239065455`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-222.77473239065455`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895557054165*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     4.813118387604675\"\>",
     4.813118387604675,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[4.813118387604675, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895557104353*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895557156466*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.7479\"\>",
         1.7479423440849549`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.5000\"\>",
         1.5,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2479\"\>",
         0.24794234408495475`,
         AutoDelete->True], 
        InterpretationBox["\<\" 545.7300\"\>",
         545.7330258687336,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895557210416*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895557273366*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2201.\"\>",
         2201.048102060954,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895557327248*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "2.6046370626761837`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {2.6046370626761837`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895563544079*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "0.00001787789549899829`"}],
  
  SequenceForm["NOISE  ", 0.00001787789549899829],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608955699761744`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "0.003361654032216214`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "0.007390418986768595`"}],
  SequenceForm["*BFGSUP ", 0.003361654032216214, "  ", 0.007390418986768595],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895570015595*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "5.245009023966128`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 5.245009023966128, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895570076148*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895570126769*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "3"}],
  SequenceForm["BFGS: Iteration = ", 3],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895570175145*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -214.925731697367800\"\>",
     -214.92573169736775`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-214.92573169736775`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608955764661217`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -217.961614003049900\"\>",
     -217.96161400304987`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-217.96161400304987`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895576504889*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     3.035882305682122\"\>",
     3.0358823056821223`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[3.0358823056821223`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895576554357*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895576609857*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.6128\"\>",
         1.6127806667311524`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.7479\"\>",
         1.7479423440849549`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1352\"\>",
         -0.13516167735380258`,
         AutoDelete->True], 
        InterpretationBox["\<\"-654.0300\"\>",
         -654.0322317797546,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895576671138*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895576721078*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 4839.\"\>",
         4838.888097457859,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895576772987*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "2.4032304685281998`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {2.4032304685281998`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608955829961433`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "0.000017817623123769108`"}],
  SequenceForm["NOISE  ", 0.000017817623123769108`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608955894032516`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "0.06585617161621199`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "0.011312205230914632`"}],
  SequenceForm["*BFGSUP ", 0.06585617161621199, "  ", 0.011312205230914632`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895589441429*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "4.064772859118128`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 4.064772859118128, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895589496204*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608955895478497`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "4"}],
  SequenceForm["BFGS: Iteration = ", 4],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608955896020823`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -252.662781321164000\"\>",
     -252.66278132116398`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -214.925731697367800\"\>",
     -214.92573169736775`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[-252.66278132116398`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-214.92573169736775`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895602488345*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -206.780279870119500\"\>",
     -206.78027987011956`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -214.925731697367800\"\>",
     -214.92573169736775`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[-206.78027987011956`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-214.92573169736775`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895608920701*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -206.780279870119500\"\>",
     -206.78027987011956`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-206.78027987011956`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.46089560896658*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -214.925731697367800\"\>",
     -214.92573169736775`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-214.92573169736775`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895609036232*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     8.145451827248200\"\>",
     8.145451827248195,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[8.145451827248195, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895609086321*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895609135982*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.5720\"\>",
         1.5720489203802126`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.6128\"\>",
         1.6127806667311524`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0407\"\>",
         -0.040731746350939735`,
         AutoDelete->True], 
        InterpretationBox["\<\"-541.6900\"\>",
         -541.6882152365216,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895609187263*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895609238625*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 831.2\"\>",
         831.1824678614967,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608956092908907`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "2.3425354367199728`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {2.3425354367199728`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895615626274*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "0.000012211059960888667`"}],
  SequenceForm["NOISE  ", 0.000012211059960888667`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895622162421*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "0.0930288372593189`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "0.7251662188106509`"}],
  SequenceForm["*BFGSUP ", 0.0930288372593189, "  ", 0.7251662188106509],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895622200441*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "2.111841247756344`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 2.111841247756344, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895622264099*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895622316387*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["BFGS: Iteration = ", 5],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895622378408*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -205.026480016230300\"\>",
     -205.02648001623032`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -206.780279870119500\"\>",
     -206.78027987011956`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[-205.02648001623032`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-206.78027987011956`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608956360054197`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -205.026480016230300\"\>",
     -205.02648001623032`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-205.02648001623032`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608956360464773`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -206.780279870119500\"\>",
     -206.78027987011956`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-206.78027987011956`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895636113017*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     1.753799853889234\"\>",
     1.7537998538892339`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[1.7537998538892339`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895636175708*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895636248456*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.5613\"\>",
         1.5613305689361683`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.5720\"\>",
         1.5720489203802126`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0107\"\>",
         -0.010718351444044377`,
         AutoDelete->True], 
        InterpretationBox["\<\"-277.7800\"\>",
         -277.7821469746012,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895636311678*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895636374072*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 6479.\"\>",
         6479.124808156716,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608956364243717`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "2.3265638484599714`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {2.3265638484599714`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895642767782*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "4.7224435477733915`*^-6"}],
  
  SequenceForm["NOISE  ", 4.7224435477733915`*^-6],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895649601844*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "0.3909461929275247`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "1.3434690567457035`"}],
  SequenceForm["*BFGSUP ", 0.3909461929275247, "  ", 1.3434690567457035`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895649643303*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.2980284567559883`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.2980284567559883, " = Elastizitaet(d l/l)/(d theta/theta)"],
  
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608956497020206`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895649775722*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "6"}],
  SequenceForm["BFGS: Iteration = ", 6],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.46089564983926*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -204.994537640915500\"\>",
     -204.9945376409155,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-204.9945376409155, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895656372491*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -205.026480016230300\"\>",
     -205.02648001623032`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-205.02648001623032`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608956564176893`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.031942375314827\"\>",
     0.03194237531482713,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.03194237531482713, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895656476473*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895656539948*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.5596\"\>",
         1.5595728646929798`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.5613\"\>",
         1.5613305689361683`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0018\"\>",
         -0.0017577042431884406`,
         AutoDelete->True], 
        InterpretationBox["\<\"-39.1360\"\>",
         -39.135674820600855`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895656603732*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608956566581306`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"NumberForm", "::", "\<\"sigz\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"In addition to the number of \
digits requested, one or more zeros will appear as placeholders.\\\\\\\"\\\", \
\\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/NumberForm\\\", ButtonNote -> \\\"NumberForm::sigz\
\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.460113347438837*^9, 3.4601140477211742`*^9, 3.460114171488365*^9, 
   3.4601142582303123`*^9, 3.46011431981378*^9, 3.4601210026174927`*^9, 
   3.4602006082555428`*^9, 3.4602006525509787`*^9, 3.4602007997492933`*^9, {
   3.460201893745349*^9, 3.460201903902554*^9}, 3.4602019417761383`*^9, 
   3.460279294169009*^9, 3.460279424327683*^9, 3.4602794918395157`*^9, 
   3.460282465738028*^9, 3.4602825470673647`*^9, 3.460282687933013*^9, 
   3.4602827362471*^9, 3.460282807351432*^9, 3.460282913928569*^9, 
   3.460283210827161*^9, 3.460283352033407*^9, 3.460283407184712*^9, {
   3.460283619834437*^9, 3.460283671655117*^9}, 3.460283747410516*^9, 
   3.460283804801373*^9, {3.460283909419492*^9, 3.460283979704739*^9}, 
   3.46028403988277*^9, {3.4602840959065733`*^9, 3.460284112635261*^9}, 
   3.460284241484562*^9, 3.4602855917581997`*^9, {3.460367187530768*^9, 
   3.4603671971813374`*^9}, 3.460435693346806*^9, {3.460435725332974*^9, 
   3.460435760027495*^9}, 3.460435797489111*^9, 3.460435835765499*^9, {
   3.460435866970508*^9, 3.460435925364402*^9}, 3.460435963989526*^9, 
   3.460440284356594*^9, {3.460800275063458*^9, 3.460800302789452*^9}, {
   3.460800468359326*^9, 3.460800496223838*^9}, 3.460893308685207*^9, 
   3.460895369843894*^9, 3.4608954034235277`*^9, 3.460895656721257*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 22270.\"\>",
         22265.221792722943`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895656766663*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "2.3239446650340853`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {2.3239446650340853`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895663540265*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "6.251947566367298`*^-7"}],
  SequenceForm["NOISE  ", 6.251947566367298*^-7],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895670459416*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "13.559977988774957`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "14.537220306053921`"}],
  SequenceForm["*BFGSUP ", 13.559977988774957`, "  ", 14.537220306053921`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895670499461*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.021457518145851916`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.021457518145851916`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895670552286*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.46089567061541*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "7"}],
  SequenceForm["BFGS: Iteration = ", 7],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895670681842*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -204.994371326930700\"\>",
     -204.9943713269307,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-204.9943713269307, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895677291584*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -204.994537640915500\"\>",
     -204.9945376409155,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-204.9945376409155, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608956773316307`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000166313984806\"\>",
     0.00016631398480626558`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.00016631398480626558`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608956773920927`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895677447886*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.5597\"\>",
         1.5596910236622699`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.5596\"\>",
         1.5595728646929798`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0001\"\>",
         0.00011815896928996889`,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.8204\"\>",
         2.820435076046542,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895677504627*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.46089567755856*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"NumberForm", "::", "\<\"sigz\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"In addition to the number of \
digits requested, one or more zeros will appear as placeholders.\\\\\\\"\\\", \
\\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/NumberForm\\\", ButtonNote -> \\\"NumberForm::sigz\
\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.460113347438837*^9, 3.4601140477211742`*^9, 3.460114171488365*^9, 
   3.4601142582303123`*^9, 3.46011431981378*^9, 3.4601210026174927`*^9, 
   3.4602006082555428`*^9, 3.4602006525509787`*^9, 3.4602007997492933`*^9, {
   3.460201893745349*^9, 3.460201903902554*^9}, 3.4602019417761383`*^9, 
   3.460279294169009*^9, 3.460279424327683*^9, 3.4602794918395157`*^9, 
   3.460282465738028*^9, 3.4602825470673647`*^9, 3.460282687933013*^9, 
   3.4602827362471*^9, 3.460282807351432*^9, 3.460282913928569*^9, 
   3.460283210827161*^9, 3.460283352033407*^9, 3.460283407184712*^9, {
   3.460283619834437*^9, 3.460283671655117*^9}, 3.460283747410516*^9, 
   3.460283804801373*^9, {3.460283909419492*^9, 3.460283979704739*^9}, 
   3.46028403988277*^9, {3.4602840959065733`*^9, 3.460284112635261*^9}, 
   3.460284241484562*^9, 3.4602855917581997`*^9, {3.460367187530768*^9, 
   3.4603671971813374`*^9}, 3.460435693346806*^9, {3.460435725332974*^9, 
   3.460435760027495*^9}, 3.460435797489111*^9, 3.460435835765499*^9, {
   3.460435866970508*^9, 3.460435925364402*^9}, 3.460435963989526*^9, 
   3.460440284356594*^9, {3.460800275063458*^9, 3.460800302789452*^9}, {
   3.460800468359326*^9, 3.460800496223838*^9}, 3.460893308685207*^9, 
   3.460895369843894*^9, 3.4608954034235277`*^9, 3.460895677612369*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 23870.\"\>",
         23869.83479117047,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608956776676083`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "2.3241207356188742`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {2.3241207356188742`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895684153336*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "4.211336773211605`*^-8"}],
  SequenceForm["NOISE  ", 4.211336773211605*^-8],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608956909391623`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "2994.5629445988875`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "3000.662832602259`"}],
  SequenceForm["*BFGSUP ", 2994.5629445988875`, "  ", 3000.662832602259],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895690989286*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "0.00004371204837942753`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.00004371204837942753, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608956910417356`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895691109304*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "8"}],
  SequenceForm["BFGS: Iteration = ", 8],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895691172997*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -204.994371326304100\"\>",
     -204.99437132630413`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-204.99437132630413`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608956980416317`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -204.994371326930700\"\>",
     -204.9943713269307,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-204.9943713269307, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895698080936*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     6.265565843932563\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-10\"\>"]}],
     6.265565843932563*^-10,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[6.265565843932563*^-10, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895698140481*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895698189577*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.5597\"\>",
         1.5596907834631808`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.5597\"\>",
         1.5596910236622699`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\"-0.0057\"\>",
         -0.005745191670022362,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895698251642*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895698303945*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"NumberForm", "::", "\<\"sigz\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"In addition to the number of \
digits requested, one or more zeros will appear as placeholders.\\\\\\\"\\\", \
\\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/NumberForm\\\", ButtonNote -> \\\"NumberForm::sigz\
\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.460113347438837*^9, 3.4601140477211742`*^9, 3.460114171488365*^9, 
   3.4601142582303123`*^9, 3.46011431981378*^9, 3.4601210026174927`*^9, 
   3.4602006082555428`*^9, 3.4602006525509787`*^9, 3.4602007997492933`*^9, {
   3.460201893745349*^9, 3.460201903902554*^9}, 3.4602019417761383`*^9, 
   3.460279294169009*^9, 3.460279424327683*^9, 3.4602794918395157`*^9, 
   3.460282465738028*^9, 3.4602825470673647`*^9, 3.460282687933013*^9, 
   3.4602827362471*^9, 3.460282807351432*^9, 3.460282913928569*^9, 
   3.460283210827161*^9, 3.460283352033407*^9, 3.460283407184712*^9, {
   3.460283619834437*^9, 3.460283671655117*^9}, 3.460283747410516*^9, 
   3.460283804801373*^9, {3.460283909419492*^9, 3.460283979704739*^9}, 
   3.46028403988277*^9, {3.4602840959065733`*^9, 3.460284112635261*^9}, 
   3.460284241484562*^9, 3.4602855917581997`*^9, {3.460367187530768*^9, 
   3.4603671971813374`*^9}, 3.460435693346806*^9, {3.460435725332974*^9, 
   3.460435760027495*^9}, 3.460435797489111*^9, 3.460435835765499*^9, {
   3.460435866970508*^9, 3.460435925364402*^9}, 3.460435963989526*^9, 
   3.460440284356594*^9, {3.460800275063458*^9, 3.460800302789452*^9}, {
   3.460800468359326*^9, 3.460800496223838*^9}, 3.460893308685207*^9, 
   3.460895369843894*^9, 3.4608954034235277`*^9, 3.460895698356534*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Further output of \\\\\\\"\\\
\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(NumberForm :: \
\\\"sigz\\\"\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" will \
be suppressed during this calculation.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/stop\\\", \
ButtonNote -> \\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.460113347438837*^9, 3.4601140477211742`*^9, 3.460114171488365*^9, 
   3.4601142582303123`*^9, 3.46011431981378*^9, 3.4601210026174927`*^9, 
   3.4602006082555428`*^9, 3.4602006525509787`*^9, 3.4602007997492933`*^9, {
   3.460201893745349*^9, 3.460201903902554*^9}, 3.4602019417761383`*^9, 
   3.460279294169009*^9, 3.460279424327683*^9, 3.4602794918395157`*^9, 
   3.460282465738028*^9, 3.4602825470673647`*^9, 3.460282687933013*^9, 
   3.4602827362471*^9, 3.460282807351432*^9, 3.460282913928569*^9, 
   3.460283210827161*^9, 3.460283352033407*^9, 3.460283407184712*^9, {
   3.460283619834437*^9, 3.460283671655117*^9}, 3.460283747410516*^9, 
   3.460283804801373*^9, {3.460283909419492*^9, 3.460283979704739*^9}, 
   3.46028403988277*^9, {3.4602840959065733`*^9, 3.460284112635261*^9}, 
   3.460284241484562*^9, 3.4602855917581997`*^9, {3.460367187530768*^9, 
   3.4603671971813374`*^9}, 3.460435693346806*^9, {3.460435725332974*^9, 
   3.460435760027495*^9}, 3.460435797489111*^9, 3.460435835765499*^9, {
   3.460435866970508*^9, 3.460435925364402*^9}, 3.460435963989526*^9, 
   3.460440284356594*^9, {3.460800275063458*^9, 3.460800302789452*^9}, {
   3.460800468359326*^9, 3.460800496223838*^9}, 3.460893308685207*^9, 
   3.460895369843894*^9, 3.4608954034235277`*^9, 3.460895698408185*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 23920.\"\>",
         23918.457351984474`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895698463811*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "2.3241203776943397`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {2.3241203776943397`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608957053926067`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "8.621137482983981`*^-11"}],
  
  SequenceForm["NOISE  ", 8.621137482983981*^-11],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895712300232*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "7.29769126968136`*^8", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "7.246430339713845`*^8"}],
  SequenceForm["*BFGSUP ", 7.29769126968136*^8, "  ", 7.246430339713845*^8],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895712352285*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "3.0704503970317524`*^-7", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 3.0704503970317524`*^-7, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.46089571240198*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608957124499817`*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895712498904*^9}],

Cell[BoxData["\<\"ReturnCode = 3\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608957125478153`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS:  ENDE DER ITERATION  \"\>", "\[InvisibleSpace]", "8", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "20"}],
  SequenceForm["BFGS:  ENDE DER ITERATION  ", 8, "  ", 20],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608957126142597`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {"1", 
       RowBox[{"-", "0.00004035575868638091`"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}]]]], "Print",\

 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895712679809*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895712721937*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 23750.\"\>",
         23750.447727852406`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895712770997*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"Likelihood\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm]},
      {"1", 
       RowBox[{"-", "242.61540866155246`"}], "0.5`"},
      {"2", 
       RowBox[{"-", "222.77473239065455`"}], "1.5`"},
      {"3", 
       RowBox[{"-", "217.96161400304987`"}], "1.7479423440849549`"},
      {"4", 
       RowBox[{"-", "214.92573169736775`"}], "1.6127806667311524`"},
      {"5", 
       RowBox[{"-", "206.78027987011956`"}], "1.5720489203802126`"},
      {"6", 
       RowBox[{"-", "205.02648001623032`"}], "1.5613305689361683`"},
      {"7", 
       RowBox[{"-", "204.9945376409155`"}], "1.5595728646929798`"},
      {"8", 
       RowBox[{"-", "204.9943713269307`"}], "1.5596910236622699`"},
      {"9", 
       RowBox[{"-", "204.99437132630413`"}], "1.5596907834631808`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"Likelihood", "THETA"}}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895712815049*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"INK: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "9.44463649907898`*^-6", "}"}]}],
  SequenceForm["INK: ", {9.44463649907898*^-6}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608957196791162`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733028986*^9}],

Cell[BoxData["\<\"ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733068858*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733104288*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {
         StyleBox["\[Null]",
          ShowStringCharacters->False], 
         TagBox["\<\"THETA\"\>",
          HoldForm], 
         TagBox["\<\"SCORE\"\>",
          HoldForm]},
        {"1", "1.5596907834631808`", 
         RowBox[{"-", "0.00004035575868638091`"}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxDividers->{
        "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
         "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.24]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
     "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[
     BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}]]], 
   "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "204.99437132630413`"}]}],
  SequenceForm[
   MatrixForm[{{1.5596907834631808`, -0.00004035575868638091}}, 
    TableHeadings -> {Automatic, {"THETA", "SCORE"}}], 
   "   Likelihood = ", -204.99437132630413`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733140758*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733176403*^9}],

Cell[BoxData["\<\"WALD-TEST:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733211894*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733248605*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"CHI \"\>",
       HoldForm], 
      TagBox["\<\"U \"\>",
       HoldForm], 
      TagBox["\<\"PROB \"\>",
       HoldForm], 
      TagBox["\<\"ALPHA \"\>",
       HoldForm]},
     {"1", "58176.52841802087`", "1", "0", "0.05`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", "ALPHA "}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733286886*^9}],

Cell[BoxData["\<\"NULLHYPOTHESE THETA = 0 ABLEHNEN\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733323846*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733361095*^9}],

Cell[BoxData["\<\"BONFERRONI-KONFIDENZINTERVALLE:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608957333972607`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733434473*^9}],

Cell[BoxData["\<\"P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= \
1-ALPHA\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608957334743853`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"QUANTIL Z(1-ALPHA/2U) = \"\>", "\[InvisibleSpace]", 
   "1.9599639845400527`"}],
  SequenceForm["QUANTIL Z(1-ALPHA/2U) = ", 1.9599639845400527`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733510894*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"THETA\"\>",
       HoldForm], 
      TagBox["\<\"GRENZE\"\>",
       HoldForm], 
      TagBox["\<\"STD\"\>",
       HoldForm]},
     {"1", "1.5596907834631808`", "0.012673970615500095`", 
      "0.006466430360695792`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733549138*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733586068*^9}],

Cell[BoxData["\<\"Korrelation der ML-Sch\[ADoubleDot]tzer\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608957336245947`*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733662364*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "1.`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733700613*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733739183*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND \
EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733776856*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733814275*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0.000041814721609728314`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733853243*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733891623*^9}],

Cell[BoxData[
 RowBox[{"{", "0.000041814721609728314`", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608957339337673`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895733973413*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX \
UND EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608957340120173`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895734051608*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "23915.022305621358`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608957340924187`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895734133134*^9}],

Cell[BoxData[
 RowBox[{"{", "23915.022305621358`", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895734174452*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608957342139177`*^9}],

Cell[BoxData["\<\"KOMPENSIERTE LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608957342542057`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.4608957342958603`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"U =  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  Nue = \"\>", "\[InvisibleSpace]", "50"}],
  SequenceForm["U =  ", 1, "  Nue = ", 50],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895734336482*^9}],

Cell[BoxData["\<\"AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) \
AZENCOTT/DACUNHA-CASTELLE (A/D)\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.46089573437708*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"LIK\"\>",
       HoldForm], 
      TagBox["\<\"AIC\"\>",
       HoldForm], 
      TagBox["\<\"SIC/RISS\"\>",
       HoldForm], 
      TagBox["\<\"A/D\"\>",
       HoldForm]},
     {
      TagBox["\<\"Kompensator\"\>",
       HoldForm], "0", "1", "1.956011502714073`", "1.3654186875213339`"},
     {
      TagBox["\<\"komp. Lik.\"\>",
       HoldForm], 
      RowBox[{"-", "204.99437132630413`"}], 
      RowBox[{"-", "205.99437132630413`"}], 
      RowBox[{"-", "206.9503828290182`"}], 
      RowBox[{"-", "206.35979001382546`"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {{"Kompensator", "komp. Lik."}, {
      "LIK", "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
    TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895734420229*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "0.5`", "1.5596907834631808`", "0.006466430360695792`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.460113389973647*^9, 3.460114056100081*^9, 3.460114179071628*^9, 
   3.4601142697179193`*^9, 3.460114343759589*^9, 3.460121016537031*^9, 
   3.4602008503444023`*^9, 3.460201923221129*^9, 3.460201965915328*^9, 
   3.4602793122704687`*^9, 3.460279517413031*^9, 3.46028255805007*^9, 
   3.4603672164787407`*^9, 3.460800336801489*^9, {3.460800482426375*^9, 
   3.460800510638279*^9}, 3.460893981101018*^9, 3.4608953876618633`*^9, 
   3.460901286141897*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Nichtlinear", "/", "NorKorr"}], ",", " ", "onlyNorkorr"}]], "Input",\

 CellChangeTimes->{{3.4608942301762238`*^9, 3.460894230773149*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "scoreii", ",", "k", 
      ",", "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
    RowBox[{"BFGS", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"Y", ",", "X", ",", 
         RowBox[{"-", "9"}]}], "}"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      "\t  ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"IdioNonlin", ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"m", "=", "100"}], ",", 
          RowBox[{"eps", "=", 
           RowBox[{"10.", "^", 
            RowBox[{"-", "16"}]}]}], ",", 
          RowBox[{"ksigma", "=", "Infinity"}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Lik", ",", "IndividualLikNonlin", ",", "Score", ",", "Hesse"}], 
         "}"}]}], "}"}], ",", "\[IndentingNewLine]", "            ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Sing", "=", "False"}], ",", 
          RowBox[{"2", "Pi"}], ",", "0", ",", 
          RowBox[{"onlynorkorr", "=", "1"}], ",", "\"\<NorKorr\>\""}], "}"}], 
        ",", 
        RowBox[{"KMAX", "=", "20"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EPS1", "=", ".0001"}], ",", 
          RowBox[{"EPS2", "=", ".0001"}]}], "}"}], ",", "\[IndentingNewLine]",
         "             ", 
        RowBox[{"OPTION", "=", "0"}], ",", 
        RowBox[{"PRINT", "=", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1"}], "}"}]}]}], "}"}]}], "]"}]}], ";"}], 
  "                                                                           \
     "}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113330285616*^9, 3.460113346379695*^9}, {
   3.460200648978776*^9, 3.4602006503583603`*^9}, {3.460200794874672*^9, 
   3.4602007984595947`*^9}, 3.460201903279232*^9, {3.460201941045977*^9, 
   3.4602019411313553`*^9}, {3.460279278878285*^9, 3.460279290392777*^9}, {
   3.460279385569292*^9, 3.4602794078107224`*^9}, 3.460279483282811*^9, {
   3.460282734453003*^9, 3.46028273588818*^9}, {3.460283616696549*^9, 
   3.460283634147719*^9}, {3.4602836706901093`*^9, 3.460283671258127*^9}, {
   3.4602837458995867`*^9, 3.4602837460095263`*^9}, {3.460283977779047*^9, 
   3.4602839782382393`*^9}, {3.460284094017385*^9, 3.460284112248164*^9}, {
   3.4602842039019938`*^9, 3.460284237509654*^9}, {3.460285585933895*^9, 
   3.460285590933837*^9}, 3.460367196326754*^9, {3.460435757860738*^9, 
   3.460435758943184*^9}, {3.460435888109399*^9, 3.460435888167045*^9}, {
   3.4604359232590923`*^9, 3.4604359236923323`*^9}, {3.460800256155857*^9, 
   3.4608002648029137`*^9}, {3.460800465883931*^9, 3.46080049502407*^9}, {
   3.460894234690484*^9, 3.460894234764517*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Tiefe von data = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["Tiefe von data = ", 5],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9}],

Cell[BoxData["\<\"L\[ADoubleDot]nge der Paneldaten\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236542982*^9}],

Cell[BoxData[
 RowBox[{"{", "50", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236558551*^9}],

Cell[BoxData["\<\"***********************LSDE1********************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942365770283`*^9}],

Cell[BoxData["\<\"***********************MODUL:    BFGS \
(skeleton)**************\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942365941057`*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942366098547`*^9}],

Cell[BoxData["\<\"Technical Output\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236627761*^9}],

Cell[BoxData["IndividualLikNonlin"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236642705*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942366575537`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"KMAX\"\>",
       HoldForm], 
      TagBox["\<\"EPS1\"\>",
       HoldForm], 
      TagBox["\<\"EPS2\"\>",
       HoldForm], 
      TagBox["\<\"K\"\>",
       HoldForm], 
      TagBox["\<\"Q\"\>",
       HoldForm], 
      TagBox["\<\"n\"\>",
       HoldForm], 
      TagBox["\<\"T\"\>",
       HoldForm], 
      TagBox["\<\"OPTION\"\>",
       HoldForm]},
     {"1", "20", "0.0001`", "0.0001`", "2", "1", "1", "49", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"KMAX", "EPS1", "EPS2", "K", "Q", "n", "T", "OPTION"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236672637*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236687277*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"MAXSTEP\"\>",
       HoldForm], 
      TagBox["\<\"MINSTEP\"\>",
       HoldForm], 
      TagBox["\<\"BOUND\"\>",
       HoldForm], 
      TagBox["\<\"STEPREDUCE\"\>",
       HoldForm], 
      TagBox["\<\"FMAX\"\>",
       HoldForm]},
     {"1", "1", "1.`*^-10", "1.`*^-6", "4", "1000"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"MAXSTEP", "MINSTEP", "BOUND", "STEPREDUCE", "FMAX"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236703641*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236758898*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"RESAMPLING\"\>",
       HoldForm], 
      TagBox["\<\"FDIGITS\"\>",
       HoldForm], 
      TagBox["\<\"TYP\"\>",
       HoldForm], 
      TagBox["\<\"YMAX\"\>",
       HoldForm], 
      TagBox["\<\"ANALGRAD\"\>",
       HoldForm], 
      TagBox["\<\"FACTOR\"\>",
       HoldForm], 
      TagBox["\<\"CSEED\"\>",
       HoldForm]},
     {"1", "True", "16", "1", "1.`*^8", "False", "1.`", 
      RowBox[{"-", "999"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {
      "RESAMPLING", "FDIGITS", "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}},
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236819914*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236874263*^9}],

Cell[BoxData["\<\"    SCALING\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.46089423694843*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "::", "\<\"nmtx\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The first two levels of the \
one-dimensional list \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\
\\!\\({}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" cannot be \
transposed.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Transpose\\\", ButtonNote -> \\\"Transpose::nmtx\\\
\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.460113347438837*^9, 3.4601140477211742`*^9, 3.460114171488365*^9, 
   3.4601142582303123`*^9, 3.46011431981378*^9, 3.4601210026174927`*^9, 
   3.4602006082555428`*^9, 3.4602006525509787`*^9, 3.4602007997492933`*^9, {
   3.460201893745349*^9, 3.460201903902554*^9}, 3.4602019417761383`*^9, 
   3.460279294169009*^9, 3.460279424327683*^9, 3.4602794918395157`*^9, 
   3.460282465738028*^9, 3.4602825470673647`*^9, 3.460282687933013*^9, 
   3.4602827362471*^9, 3.460282807351432*^9, 3.460282913928569*^9, 
   3.460283210827161*^9, 3.460283352033407*^9, 3.460283407184712*^9, {
   3.460283619834437*^9, 3.460283671655117*^9}, 3.460283747410516*^9, 
   3.460283804801373*^9, {3.460283909419492*^9, 3.460283979704739*^9}, 
   3.46028403988277*^9, {3.4602840959065733`*^9, 3.460284112635261*^9}, 
   3.460284241484562*^9, 3.4602855917581997`*^9, {3.460367187530768*^9, 
   3.4603671971813374`*^9}, 3.460435693346806*^9, {3.460435725332974*^9, 
   3.460435760027495*^9}, 3.460435797489111*^9, 3.460435835765499*^9, {
   3.460435866970508*^9, 3.460435925364402*^9}, 3.460435963989526*^9, 
   3.460440284356594*^9, {3.460800275063458*^9, 3.460800302789452*^9}, {
   3.460800468359326*^9, 3.460800496223838*^9}, 3.460893308685207*^9, 
   3.460894237002737*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  RowBox[{"Transpose", "[", 
   RowBox[{"{", "}"}], "]"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
    0]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894237056847*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.46089423711543*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894237172935*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894237229887*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STARTWERT THETA0 = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.5`", "}"}]}],
  SequenceForm["STARTWERT THETA0 = ", {0.5}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894237285041*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894239091133*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "56.599002838134766`", "}"}], ",", 
   RowBox[{"-", "277.32398835363915`"}]}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942415350857`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894241572674*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["BFGS: Iteration = ", 1],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894241631749*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -271.121291645243300\"\>",
     -271.12129164524333`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -277.323988353639200\"\>",
     -277.32398835363915`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[-271.12129164524333`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-277.32398835363915`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942463891287`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -271.121291645243300\"\>",
     -271.12129164524333`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-271.12129164524333`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894246432938*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -277.323988353639200\"\>",
     -277.32398835363915`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-277.32398835363915`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894246493309*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     6.202696708395820\"\>",
     6.20269670839582,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[6.20269670839582, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894246545712*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894246610406*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7500\"\>",
         0.75,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5000\"\>",
         0.5,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2500\"\>",
         0.25,
         AutoDelete->True], 
        InterpretationBox["\<\" 56.5990\"\>",
         56.599002838134766`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894246683214*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942467347527`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894246785947*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894248916815*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "9.147075274995586`*^-7"}],
  SequenceForm["NOISE  ", 9.147075274995586*^-7],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942513794937`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "0.06516251696137855`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "16.`"}],
  SequenceForm["*BFGSUP ", 0.06516251696137855, "  ", 16.],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942514166403`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.017652542873216066`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.017652542873216066`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894251467421*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894251523497*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "2"}],
  SequenceForm["BFGS: Iteration = ", 2],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942515789127`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -271.067769633285000\"\>",
     -271.0677696332851,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-271.0677696332851, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942538489933`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -271.121291645243300\"\>",
     -271.12129164524333`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-271.12129164524333`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894253885435*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.053522011958250\"\>",
     0.05352201195825046,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.05352201195825046, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942539407587`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894254008149*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7305\"\>",
         0.7305083426523168,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7500\"\>",
         0.75,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0195\"\>",
         -0.01949165734768317,
         AutoDelete->True], 
        InterpretationBox["\<\"-4.7860\"\>",
         -4.785980224609375,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894254057302*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894254108019*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 245.5\"\>",
         245.53993225097656`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894254154539*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894256351959*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "8.141495300151291`*^-8"}],
  SequenceForm["NOISE  ", 8.141495300151291*^-8],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894258747806*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "12.487904369949348`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "10.71964324524994`"}],
  SequenceForm["*BFGSUP ", 12.487904369949348`, "  ", 10.71964324524994],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.46089425878754*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.002500056664251729`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.002500056664251729, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894258844138*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894258896667*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "3"}],
  SequenceForm["BFGS: Iteration = ", 3],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894258967037*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -271.066704854389200\"\>",
     -271.0667048543892,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-271.0667048543892, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894261259029*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -271.067769633285000\"\>",
     -271.0677696332851,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-271.0677696332851, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894261297122*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.001064778895909\"\>",
     0.0010647788959090576`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.0010647788959090576`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942613570538`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894261410376*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7273\"\>",
         0.7272930919993492,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7305\"\>",
         0.7305083426523168,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0032\"\>",
         -0.003215250652967611,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.6777\"\>",
         -0.6776847839355469,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942614764223`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894261531056*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 210.8\"\>",
         210.77199169839452`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.46089426159086*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894263807411*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.0338226275052875`*^-8"}],
  
  SequenceForm["NOISE  ", 1.0338226275052875`*^-8],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942661989326`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "448.2901992491055`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "458.9416052700707`"}],
  SequenceForm["*BFGSUP ", 448.2901992491055, "  ", 458.9416052700707],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894266237934*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "0.00005940175192985307`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.00005940175192985307, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894266296611*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942663457413`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "4"}],
  SequenceForm["BFGS: Iteration = ", 4],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894266400375*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -271.066704255100300\"\>",
     -271.06670425510026`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-271.06670425510026`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894268672928*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -271.066704854389200\"\>",
     -271.0667048543892,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-271.0667048543892, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942687158833`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     5.992889100525645\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-7\"\>"]}],
     5.992889100525645*^-7,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[5.992889100525645*^-7, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942687731657`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894268822998*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7274\"\>",
         0.7273677135629004,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7273\"\>",
         0.7272930919993492,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0001\"\>",
         0.00007462156355115846,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0161\"\>",
         0.016101837158203125`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894268871971*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942689262743`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 215.8\"\>",
         215.77994874315596`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942689853907`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894271232828*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "2.4061819203780033`*^-10"}],
  SequenceForm["NOISE  ", 2.4061819203780033`*^-10],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894273638607*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "829902.9510044066`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "832262.3055204103`"}],
  SequenceForm["*BFGSUP ", 829902.9510044066, "  ", 832262.3055204103],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894273677414*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "1.688749170182848`*^-7",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 1.688749170182848*^-7, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894273729718*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894273778414*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894273829336*^9}],

Cell[BoxData["\<\"ReturnCode = 3\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894273878669*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS:  ENDE DER ITERATION  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "20"}],
  SequenceForm["BFGS:  ENDE DER ITERATION  ", 4, "  ", 20],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942739322*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {"1", 
       RowBox[{"-", "0.0000457763671875`"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}]]]], "Print",\

 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894273987135*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942740354757`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 216.4\"\>",
         216.3933956478984,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894274083548*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"Likelihood\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm]},
      {"1", 
       RowBox[{"-", "277.32398835363915`"}], "0.5`"},
      {"2", 
       RowBox[{"-", "271.12129164524333`"}], "0.75`"},
      {"3", 
       RowBox[{"-", "271.0677696332851`"}], "0.7305083426523168`"},
      {"4", 
       RowBox[{"-", "271.0667048543892`"}], "0.7272930919993492`"},
      {"5", 
       RowBox[{"-", "271.06670425510026`"}], "0.7273677135629004`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"Likelihood", "THETA"}}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894274146174*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"INK: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "6.055454452393343`*^-6", "}"}]}],
  SequenceForm["INK: ", {6.055454452393343*^-6}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942763842993`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894281242004*^9}],

Cell[BoxData["\<\"ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894281277178*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942813455887`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {
         StyleBox["\[Null]",
          ShowStringCharacters->False], 
         TagBox["\<\"THETA\"\>",
          HoldForm], 
         TagBox["\<\"SCORE\"\>",
          HoldForm]},
        {"1", "0.7273677135629004`", 
         RowBox[{"-", "0.0000457763671875`"}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxDividers->{
        "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
         "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.24]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
     "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[
     BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}]]], 
   "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "271.06670425510026`"}]}],
  SequenceForm[
   MatrixForm[{{0.7273677135629004, -0.0000457763671875}}, 
    TableHeadings -> {Automatic, {"THETA", "SCORE"}}], 
   "   Likelihood = ", -271.06670425510026`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942814012012`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894281453558*^9}],

Cell[BoxData["\<\"WALD-TEST:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894281519889*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.46089428158598*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"CHI \"\>",
       HoldForm], 
      TagBox["\<\"U \"\>",
       HoldForm], 
      TagBox["\<\"PROB \"\>",
       HoldForm], 
      TagBox["\<\"ALPHA \"\>",
       HoldForm]},
     {"1", "114.51628844548283`", "1", "0", "0.05`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", "ALPHA "}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894281638135*^9}],

Cell[BoxData["\<\"NULLHYPOTHESE THETA = 0 ABLEHNEN\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894281702252*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894281773831*^9}],

Cell[BoxData["\<\"BONFERRONI-KONFIDENZINTERVALLE:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942818131857`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894281869111*^9}],

Cell[BoxData["\<\"P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= \
1-ALPHA\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.46089428191558*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"QUANTIL Z(1-ALPHA/2U) = \"\>", "\[InvisibleSpace]", 
   "1.9599639845400527`"}],
  SequenceForm["QUANTIL Z(1-ALPHA/2U) = ", 1.9599639845400527`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894281970461*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"THETA\"\>",
       HoldForm], 
      TagBox["\<\"GRENZE\"\>",
       HoldForm], 
      TagBox["\<\"STD\"\>",
       HoldForm]},
     {"1", "0.7273677135629004`", "0.13321970842397018`", 
      "0.06797048796548832`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894282026082*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942820879993`*^9}],

Cell[BoxData["\<\"Korrelation der ML-Sch\[ADoubleDot]tzer\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942821514807`*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942822068253`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "1.`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894282286652*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.46089428233707*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND \
EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.46089428239089*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942824494553`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0.004619987234266593`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894282510981*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894282569214*^9}],

Cell[BoxData[
 RowBox[{"{", "0.004619987234266593`", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894282623982*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.46089428267432*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX \
UND EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894282729855*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608942827915154`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "216.4508145353667`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894282872931*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894282923853*^9}],

Cell[BoxData[
 RowBox[{"{", "216.4508145353667`", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894282981338*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.46089428304172*^9}],

Cell[BoxData["\<\"KOMPENSIERTE LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894283098309*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894283162266*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"U =  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  Nue = \"\>", "\[InvisibleSpace]", "50"}],
  SequenceForm["U =  ", 1, "  Nue = ", 50],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894283219494*^9}],

Cell[BoxData["\<\"AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) \
AZENCOTT/DACUNHA-CASTELLE (A/D)\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894283289699*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"LIK\"\>",
       HoldForm], 
      TagBox["\<\"AIC\"\>",
       HoldForm], 
      TagBox["\<\"SIC/RISS\"\>",
       HoldForm], 
      TagBox["\<\"A/D\"\>",
       HoldForm]},
     {
      TagBox["\<\"Kompensator\"\>",
       HoldForm], "0", "1", "1.956011502714073`", "1.3654186875213339`"},
     {
      TagBox["\<\"komp. Lik.\"\>",
       HoldForm], 
      RowBox[{"-", "271.06670425510026`"}], 
      RowBox[{"-", "272.06670425510026`"}], 
      RowBox[{"-", "273.02271575781435`"}], 
      RowBox[{"-", "272.4321229426216`"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {{"Kompensator", "komp. Lik."}, {
      "LIK", "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
    TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894283346613*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "0.5`", "0.7273677135629004`", "0.06797048796548832`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.460113389973647*^9, 3.460114056100081*^9, 3.460114179071628*^9, 
   3.4601142697179193`*^9, 3.460114343759589*^9, 3.460121016537031*^9, 
   3.4602008503444023`*^9, 3.460201923221129*^9, 3.460201965915328*^9, 
   3.4602793122704687`*^9, 3.460279517413031*^9, 3.46028255805007*^9, 
   3.4603672164787407`*^9, 3.460800336801489*^9, {3.460800482426375*^9, 
   3.460800510638279*^9}, 3.460893981101018*^9, 3.460894289710239*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Nichtlinear", "/", "EKF"}]], "Input",
 CellChangeTimes->{{3.460367266700344*^9, 3.46036726904226*^9}, {
  3.460800444634096*^9, 3.460800446133922*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "scoreii", ",", "k", 
      ",", "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
    RowBox[{"BFGS", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"Y", ",", "X", ",", 
         RowBox[{"-", "9"}]}], "}"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      "\t  ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"IdioNonlin", ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"m", "=", "100"}], ",", 
          RowBox[{"eps", "=", 
           RowBox[{"10.", "^", 
            RowBox[{"-", "16"}]}]}], ",", 
          RowBox[{"ksigma", "=", "Infinity"}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Lik", ",", "IndividualLikNonlin", ",", "Score", ",", "Hesse"}], 
         "}"}]}], "}"}], ",", "\[IndentingNewLine]", "            ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Sing", "=", "False"}], ",", 
          RowBox[{"2", "Pi"}], ",", "0", ",", 
          RowBox[{"onlynorkorr", "=", "0"}], ",", "\"\<EKF\>\"", ",", 
          RowBox[{"support", "=", "Automatic"}]}], "}"}], ",", 
        RowBox[{"KMAX", "=", "20"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EPS1", "=", ".0001"}], ",", 
          RowBox[{"EPS2", "=", ".0001"}]}], "}"}], ",", "\[IndentingNewLine]",
         "             ", 
        RowBox[{"OPTION", "=", "0"}], ",", 
        RowBox[{"PRINT", "=", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1"}], "}"}]}]}], "}"}]}], "]"}]}], ";"}], 
  "                                                                           \
     "}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113330285616*^9, 3.460113346379695*^9}, {
   3.460200648978776*^9, 3.4602006503583603`*^9}, {3.460200794874672*^9, 
   3.4602007984595947`*^9}, 3.460201903279232*^9, {3.460201941045977*^9, 
   3.4602019411313553`*^9}, {3.460279278878285*^9, 3.460279290392777*^9}, {
   3.460279385569292*^9, 3.4602794078107224`*^9}, 3.460279483282811*^9, {
   3.460282734453003*^9, 3.46028273588818*^9}, {3.460283616696549*^9, 
   3.460283634147719*^9}, {3.4602836706901093`*^9, 3.460283671258127*^9}, {
   3.4602837458995867`*^9, 3.4602837460095263`*^9}, {3.460283977779047*^9, 
   3.4602839782382393`*^9}, {3.460284094017385*^9, 3.460284112248164*^9}, {
   3.4602842039019938`*^9, 3.460284237509654*^9}, {3.460285585933895*^9, 
   3.460285590933837*^9}, 3.460367196326754*^9, {3.460435757860738*^9, 
   3.460435758943184*^9}, {3.460435888109399*^9, 3.460435888167045*^9}, {
   3.4604359232590923`*^9, 3.4604359236923323`*^9}, {3.460800256155857*^9, 
   3.4608002648029137`*^9}, 3.46089401382297*^9, {3.460894325881374*^9, 
   3.460894341428179*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Tiefe von data = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["Tiefe von data = ", 5],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9}],

Cell[BoxData["\<\"L\[ADoubleDot]nge der Paneldaten\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894424012241*^9}],

Cell[BoxData[
 RowBox[{"{", "50", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894424031549*^9}],

Cell[BoxData["\<\"***********************LSDE1********************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894424048319*^9}],

Cell[BoxData["\<\"***********************MODUL:    BFGS \
(skeleton)**************\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894424065206*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894424082377*^9}],

Cell[BoxData["\<\"Technical Output\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944240989447`*^9}],

Cell[BoxData["IndividualLikNonlin"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894424118168*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944241310043`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"KMAX\"\>",
       HoldForm], 
      TagBox["\<\"EPS1\"\>",
       HoldForm], 
      TagBox["\<\"EPS2\"\>",
       HoldForm], 
      TagBox["\<\"K\"\>",
       HoldForm], 
      TagBox["\<\"Q\"\>",
       HoldForm], 
      TagBox["\<\"n\"\>",
       HoldForm], 
      TagBox["\<\"T\"\>",
       HoldForm], 
      TagBox["\<\"OPTION\"\>",
       HoldForm]},
     {"1", "20", "0.0001`", "0.0001`", "2", "1", "1", "49", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"KMAX", "EPS1", "EPS2", "K", "Q", "n", "T", "OPTION"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894424143664*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944241570253`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"MAXSTEP\"\>",
       HoldForm], 
      TagBox["\<\"MINSTEP\"\>",
       HoldForm], 
      TagBox["\<\"BOUND\"\>",
       HoldForm], 
      TagBox["\<\"STEPREDUCE\"\>",
       HoldForm], 
      TagBox["\<\"FMAX\"\>",
       HoldForm]},
     {"1", "1", "1.`*^-10", "1.`*^-6", "4", "1000"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"MAXSTEP", "MINSTEP", "BOUND", "STEPREDUCE", "FMAX"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894424215516*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894424273426*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"RESAMPLING\"\>",
       HoldForm], 
      TagBox["\<\"FDIGITS\"\>",
       HoldForm], 
      TagBox["\<\"TYP\"\>",
       HoldForm], 
      TagBox["\<\"YMAX\"\>",
       HoldForm], 
      TagBox["\<\"ANALGRAD\"\>",
       HoldForm], 
      TagBox["\<\"FACTOR\"\>",
       HoldForm], 
      TagBox["\<\"CSEED\"\>",
       HoldForm]},
     {"1", "True", "16", "1", "1.`*^8", "False", "1.`", 
      RowBox[{"-", "999"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {
      "RESAMPLING", "FDIGITS", "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}},
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894424345909*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894424402013*^9}],

Cell[BoxData["\<\"    SCALING\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894424471259*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "::", "\<\"nmtx\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The first two levels of the \
one-dimensional list \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\
\\!\\({}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" cannot be \
transposed.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Transpose\\\", ButtonNote -> \\\"Transpose::nmtx\\\
\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.460113347438837*^9, 3.4601140477211742`*^9, 3.460114171488365*^9, 
   3.4601142582303123`*^9, 3.46011431981378*^9, 3.4601210026174927`*^9, 
   3.4602006082555428`*^9, 3.4602006525509787`*^9, 3.4602007997492933`*^9, {
   3.460201893745349*^9, 3.460201903902554*^9}, 3.4602019417761383`*^9, 
   3.460279294169009*^9, 3.460279424327683*^9, 3.4602794918395157`*^9, 
   3.460282465738028*^9, 3.4602825470673647`*^9, 3.460282687933013*^9, 
   3.4602827362471*^9, 3.460282807351432*^9, 3.460282913928569*^9, 
   3.460283210827161*^9, 3.460283352033407*^9, 3.460283407184712*^9, {
   3.460283619834437*^9, 3.460283671655117*^9}, 3.460283747410516*^9, 
   3.460283804801373*^9, {3.460283909419492*^9, 3.460283979704739*^9}, 
   3.46028403988277*^9, {3.4602840959065733`*^9, 3.460284112635261*^9}, 
   3.460284241484562*^9, 3.4602855917581997`*^9, {3.460367187530768*^9, 
   3.4603671971813374`*^9}, 3.460435693346806*^9, {3.460435725332974*^9, 
   3.460435760027495*^9}, 3.460435797489111*^9, 3.460435835765499*^9, {
   3.460435866970508*^9, 3.460435925364402*^9}, 3.460435963989526*^9, 
   3.460440284356594*^9, {3.460800275063458*^9, 3.460800302789452*^9}, 
   3.460893988423676*^9, 3.460894037807211*^9, 3.4608943443245583`*^9, 
   3.4608944245151253`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  RowBox[{"Transpose", "[", 
   RowBox[{"{", "}"}], "]"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
    0]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944245565853`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894424608323*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894424682996*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894424737938*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STARTWERT THETA0 = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.5`", "}"}]}],
  SequenceForm["STARTWERT THETA0 = ", {0.5}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944247936993`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894428277134*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"-", "556.8390426635742`"}], "}"}], ",", 
   RowBox[{"-", "180.8702216908081`"}]}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944325339317`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894432571113*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["BFGS: Iteration = ", 1],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944326308413`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -264.411878124181600\"\>",
     -264.4118781241816,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -180.870221690808100\"\>",
     -180.8702216908081,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[-264.4118781241816, {20, 15}], "  LIKALT  ", 
   PaddedForm[-180.8702216908081, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894441032317*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -200.172923185780400\"\>",
     -200.17292318578043`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -180.870221690808100\"\>",
     -180.8702216908081,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[-200.17292318578043`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-180.8702216908081, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894445242498*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -175.332667062694200\"\>",
     -175.3326670626942,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -180.870221690808100\"\>",
     -180.8702216908081,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[-175.3326670626942, {20, 15}], "  LIKALT  ", 
   PaddedForm[-180.8702216908081, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894449459297*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -175.332667062694200\"\>",
     -175.3326670626942,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-175.3326670626942, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944495025597`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -180.870221690808100\"\>",
     -180.8702216908081,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-180.8702216908081, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944495478354`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     5.537554628113895\"\>",
     5.537554628113895,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[5.537554628113895, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894449590477*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894449631572*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.4844\"\>",
         0.484375,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5000\"\>",
         0.5,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0156\"\>",
         -0.015625,
         AutoDelete->True], 
        InterpretationBox["\<\"-556.8400\"\>",
         -556.8390426635742,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894449675453*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944497149477`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894449758833*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944537323303`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "0.000010419952872098293`"}],
  SequenceForm["NOISE  ", 0.000010419952872098293`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894457945511*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "0.15443758850020806`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "4096.`"}],
  SequenceForm["*BFGSUP ", 0.15443758850020806`, "  ", 4096.],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894458005445*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.8123537952317216`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.8123537952317216, " = Elastizitaet(d l/l)/(d theta/theta)"],
  
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894458048918*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894458089202*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "2"}],
  SequenceForm["BFGS: Iteration = ", 2],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894458129099*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -174.978014591242700\"\>",
     -174.97801459124273`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-174.97801459124273`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894462215222*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -175.332667062694200\"\>",
     -175.3326670626942,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-175.3326670626942, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894462252898*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.354652471451487\"\>",
     0.35465247145148737`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.35465247145148737`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944623019953`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944623490047`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.4790\"\>",
         0.4790046682295589,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4844\"\>",
         0.484375,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0054\"\>",
         -0.005370331770441132,
         AutoDelete->True], 
        InterpretationBox["\<\"-142.4300\"\>",
         -142.4321575164795,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944623888893`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894462429575*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"NumberForm", "::", "\<\"sigz\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"In addition to the number of \
digits requested, one or more zeros will appear as placeholders.\\\\\\\"\\\", \
\\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/NumberForm\\\", ButtonNote -> \\\"NumberForm::sigz\
\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.460113347438837*^9, 3.4601140477211742`*^9, 3.460114171488365*^9, 
   3.4601142582303123`*^9, 3.46011431981378*^9, 3.4601210026174927`*^9, 
   3.4602006082555428`*^9, 3.4602006525509787`*^9, 3.4602007997492933`*^9, {
   3.460201893745349*^9, 3.460201903902554*^9}, 3.4602019417761383`*^9, 
   3.460279294169009*^9, 3.460279424327683*^9, 3.4602794918395157`*^9, 
   3.460282465738028*^9, 3.4602825470673647`*^9, 3.460282687933013*^9, 
   3.4602827362471*^9, 3.460282807351432*^9, 3.460282913928569*^9, 
   3.460283210827161*^9, 3.460283352033407*^9, 3.460283407184712*^9, {
   3.460283619834437*^9, 3.460283671655117*^9}, 3.460283747410516*^9, 
   3.460283804801373*^9, {3.460283909419492*^9, 3.460283979704739*^9}, 
   3.46028403988277*^9, {3.4602840959065733`*^9, 3.460284112635261*^9}, 
   3.460284241484562*^9, 3.4602855917581997`*^9, {3.460367187530768*^9, 
   3.4603671971813374`*^9}, 3.460435693346806*^9, {3.460435725332974*^9, 
   3.460435760027495*^9}, 3.460435797489111*^9, 3.460435835765499*^9, {
   3.460435866970508*^9, 3.460435925364402*^9}, 3.460435963989526*^9, 
   3.460440284356594*^9, {3.460800275063458*^9, 3.460800302789452*^9}, 
   3.460893988423676*^9, 3.460894037807211*^9, 3.4608943443245583`*^9, 
   3.460894462471445*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 26520.\"\>",
         26522.040649414062`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894462513125*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944665179367`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "2.286835069753579`*^-6"}],
  SequenceForm["NOISE  ", 2.286835069753579*^-6],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894470751219*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "1.213344574393491`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "1.3073468673355402`"}],
  SequenceForm["*BFGSUP ", 1.213344574393491, "  ", 1.3073468673355402`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944707909317`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.06306361513943141`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.06306361513943141, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944708302183`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894470874815*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "3"}],
  SequenceForm["BFGS: Iteration = ", 3],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894470914034*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -174.975909892797000\"\>",
     -174.97590989279703`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-174.97590989279703`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944751002817`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -174.978014591242700\"\>",
     -174.97801459124273`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-174.97801459124273`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894475140613*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.002104698445692\"\>",
     0.0021046984456916107`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.0021046984456916107`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944751808023`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944752278433`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.4794\"\>",
         0.47939081173354714`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4790\"\>",
         0.4790046682295589,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0004\"\>",
         0.00038614350398824456`,
         AutoDelete->True], 
        InterpretationBox["\<\" 11.0350\"\>",
         11.034746170043945`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894475272387*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944753291283`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"NumberForm", "::", "\<\"sigz\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"In addition to the number of \
digits requested, one or more zeros will appear as placeholders.\\\\\\\"\\\", \
\\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/NumberForm\\\", ButtonNote -> \\\"NumberForm::sigz\
\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.460113347438837*^9, 3.4601140477211742`*^9, 3.460114171488365*^9, 
   3.4601142582303123`*^9, 3.46011431981378*^9, 3.4601210026174927`*^9, 
   3.4602006082555428`*^9, 3.4602006525509787`*^9, 3.4602007997492933`*^9, {
   3.460201893745349*^9, 3.460201903902554*^9}, 3.4602019417761383`*^9, 
   3.460279294169009*^9, 3.460279424327683*^9, 3.4602794918395157`*^9, 
   3.460282465738028*^9, 3.4602825470673647`*^9, 3.460282687933013*^9, 
   3.4602827362471*^9, 3.460282807351432*^9, 3.460282913928569*^9, 
   3.460283210827161*^9, 3.460283352033407*^9, 3.460283407184712*^9, {
   3.460283619834437*^9, 3.460283671655117*^9}, 3.460283747410516*^9, 
   3.460283804801373*^9, {3.460283909419492*^9, 3.460283979704739*^9}, 
   3.46028403988277*^9, {3.4602840959065733`*^9, 3.460284112635261*^9}, 
   3.460284241484562*^9, 3.4602855917581997`*^9, {3.460367187530768*^9, 
   3.4603671971813374`*^9}, 3.460435693346806*^9, {3.460435725332974*^9, 
   3.460435760027495*^9}, 3.460435797489111*^9, 3.460435835765499*^9, {
   3.460435866970508*^9, 3.460435925364402*^9}, 3.460435963989526*^9, 
   3.460440284356594*^9, {3.460800275063458*^9, 3.460800302789452*^9}, 
   3.460893988423676*^9, 3.460894037807211*^9, 3.4608943443245583`*^9, 
   3.460894475374734*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 28580.\"\>",
         28576.80125671589,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894475411667*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894479433752*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.663822217778943`*^-7"}],
  SequenceForm["NOISE  ", 1.663822217778943*^-7],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894483671413*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "231.9340225324109`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "234.68693826632978`"}],
  SequenceForm["*BFGSUP ", 231.9340225324109, "  ", 234.68693826632978`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894483708761*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0007485357461312635`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0007485357461312635, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944837492943`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944837934027`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "4"}],
  SequenceForm["BFGS: Iteration = ", 4],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894483833132*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -174.975909596913300\"\>",
     -174.97590959691325`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-174.97590959691325`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894487944964*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -174.975909892797000\"\>",
     -174.97590989279703`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-174.97590989279703`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894487985763*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     2.958837796995795\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-7\"\>"]}],
     2.9588377969957946`*^-7,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[2.9588377969957946`*^-7, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944880305862`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944880716047`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.4794\"\>",
         0.4793862822078073,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4794\"\>",
         0.47939081173354714`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\"-0.1310\"\>",
         -0.13097572326660156`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894488116536*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894488161957*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"NumberForm", "::", "\<\"sigz\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"In addition to the number of \
digits requested, one or more zeros will appear as placeholders.\\\\\\\"\\\", \
\\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/NumberForm\\\", ButtonNote -> \\\"NumberForm::sigz\
\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.460113347438837*^9, 3.4601140477211742`*^9, 3.460114171488365*^9, 
   3.4601142582303123`*^9, 3.46011431981378*^9, 3.4601210026174927`*^9, 
   3.4602006082555428`*^9, 3.4602006525509787`*^9, 3.4602007997492933`*^9, {
   3.460201893745349*^9, 3.460201903902554*^9}, 3.4602019417761383`*^9, 
   3.460279294169009*^9, 3.460279424327683*^9, 3.4602794918395157`*^9, 
   3.460282465738028*^9, 3.4602825470673647`*^9, 3.460282687933013*^9, 
   3.4602827362471*^9, 3.460282807351432*^9, 3.460282913928569*^9, 
   3.460283210827161*^9, 3.460283352033407*^9, 3.460283407184712*^9, {
   3.460283619834437*^9, 3.460283671655117*^9}, 3.460283747410516*^9, 
   3.460283804801373*^9, {3.460283909419492*^9, 3.460283979704739*^9}, 
   3.46028403988277*^9, {3.4602840959065733`*^9, 3.460284112635261*^9}, 
   3.460284241484562*^9, 3.4602855917581997`*^9, {3.460367187530768*^9, 
   3.4603671971813374`*^9}, 3.460435693346806*^9, {3.460435725332974*^9, 
   3.460435760027495*^9}, 3.460435797489111*^9, 3.460435835765499*^9, {
   3.460435866970508*^9, 3.460435925364402*^9}, 3.460435963989526*^9, 
   3.460440284356594*^9, {3.460800275063458*^9, 3.460800302789452*^9}, 
   3.460893988423676*^9, 3.460894037807211*^9, 3.4608943443245583`*^9, 
   3.4608944882053213`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Further output of \\\\\\\"\\\
\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(NumberForm :: \
\\\"sigz\\\"\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" will \
be suppressed during this calculation.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/stop\\\", \
ButtonNote -> \\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.460113347438837*^9, 3.4601140477211742`*^9, 3.460114171488365*^9, 
   3.4601142582303123`*^9, 3.46011431981378*^9, 3.4601210026174927`*^9, 
   3.4602006082555428`*^9, 3.4602006525509787`*^9, 3.4602007997492933`*^9, {
   3.460201893745349*^9, 3.460201903902554*^9}, 3.4602019417761383`*^9, 
   3.460279294169009*^9, 3.460279424327683*^9, 3.4602794918395157`*^9, 
   3.460282465738028*^9, 3.4602825470673647`*^9, 3.460282687933013*^9, 
   3.4602827362471*^9, 3.460282807351432*^9, 3.460282913928569*^9, 
   3.460283210827161*^9, 3.460283352033407*^9, 3.460283407184712*^9, {
   3.460283619834437*^9, 3.460283671655117*^9}, 3.460283747410516*^9, 
   3.460283804801373*^9, {3.460283909419492*^9, 3.460283979704739*^9}, 
   3.46028403988277*^9, {3.4602840959065733`*^9, 3.460284112635261*^9}, 
   3.460284241484562*^9, 3.4602855917581997`*^9, {3.460367187530768*^9, 
   3.4603671971813374`*^9}, 3.460435693346806*^9, {3.460435725332974*^9, 
   3.460435760027495*^9}, 3.460435797489111*^9, 3.460435835765499*^9, {
   3.460435866970508*^9, 3.460435925364402*^9}, 3.460435963989526*^9, 
   3.460440284356594*^9, {3.460800275063458*^9, 3.460800302789452*^9}, 
   3.460893988423676*^9, 3.460894037807211*^9, 3.4608943443245583`*^9, 
   3.460894488244877*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 28920.\"\>",
         28915.990500905766`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894488284339*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894492252348*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.953395667442237`*^-9"}],
  SequenceForm["NOISE  ", 1.953395667442237*^-9],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894496469225*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "1.6870816288375354`*^6", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "1.6856075299322032`*^6"}],
  SequenceForm[
  "*BFGSUP ", 1.6870816288375354`*^6, "  ", 1.6856075299322032`*^6],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894496507599*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "6.540381372063395`*^-7",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 6.540381372063395*^-7, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944965552387`*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894496596829*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894496638568*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["BFGS: Iteration = ", 5],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608944966865664`*^9}],

Cell[BoxData["\<\"ReturnCode = 4\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894500731889*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS:  ENDE DER ITERATION  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "20"}],
  SequenceForm["BFGS:  ENDE DER ITERATION  ", 4, "  ", 20],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608945007715063`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {"1", 
       RowBox[{"-", "0.00011444091796875`"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}]]]], "Print",\

 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894500812443*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894500857355*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 28890.\"\>",
         28890.724959976753`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608945008984756`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"Likelihood\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm]},
      {"1", 
       RowBox[{"-", "180.8702216908081`"}], "0.5`"},
      {"2", 
       RowBox[{"-", "175.3326670626942`"}], "0.484375`"},
      {"3", 
       RowBox[{"-", "174.97801459124273`"}], "0.4790046682295589`"},
      {"4", 
       RowBox[{"-", "174.97590989279703`"}], "0.47939081173354714`"},
      {"5", 
       RowBox[{"-", "174.97590959691325`"}], "0.4793862822078073`"},
      {"6", 
       RowBox[{"-", "174.97590959691325`"}], "0.4793862822078073`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"Likelihood", "THETA"}}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.46089450095756*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"INK: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "6.055454452393343`*^-6", "}"}]}],
  SequenceForm["INK: ", {6.055454452393343*^-6}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894505042959*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894513573346*^9}],

Cell[BoxData["\<\"ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894513609708*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608945136493387`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {
         StyleBox["\[Null]",
          ShowStringCharacters->False], 
         TagBox["\<\"THETA\"\>",
          HoldForm], 
         TagBox["\<\"SCORE\"\>",
          HoldForm]},
        {"1", "0.4793862822078073`", 
         RowBox[{"-", "0.00011444091796875`"}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxDividers->{
        "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
         "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.24]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
     "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[
     BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}]]], 
   "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "174.97590959691325`"}]}],
  SequenceForm[
   MatrixForm[{{0.4793862822078073, -0.00011444091796875}}, 
    TableHeadings -> {Automatic, {"THETA", "SCORE"}}], 
   "   Likelihood = ", -174.97590959691325`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894513694749*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608945137305193`*^9}],

Cell[BoxData["\<\"WALD-TEST:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608945137772293`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894513814481*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"CHI \"\>",
       HoldForm], 
      TagBox["\<\"U \"\>",
       HoldForm], 
      TagBox["\<\"PROB \"\>",
       HoldForm], 
      TagBox["\<\"ALPHA \"\>",
       HoldForm]},
     {"1", "6639.82425332548`", "1", "0", "0.05`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", "ALPHA "}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894513863361*^9}],

Cell[BoxData["\<\"NULLHYPOTHESE THETA = 0 ABLEHNEN\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608945138992567`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608945139468393`*^9}],

Cell[BoxData["\<\"BONFERRONI-KONFIDENZINTERVALLE:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608945139844503`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608945140216084`*^9}],

Cell[BoxData["\<\"P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= \
1-ALPHA\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894514069145*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"QUANTIL Z(1-ALPHA/2U) = \"\>", "\[InvisibleSpace]", 
   "1.9599639845400527`"}],
  SequenceForm["QUANTIL Z(1-ALPHA/2U) = ", 1.9599639845400527`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608945141071*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"THETA\"\>",
       HoldForm], 
      TagBox["\<\"GRENZE\"\>",
       HoldForm], 
      TagBox["\<\"STD\"\>",
       HoldForm]},
     {"1", "0.4793862822078073`", "0.011530692783834949`", 
      "0.005883114625976594`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608945141447*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894514182478*^9}],

Cell[BoxData["\<\"Korrelation der ML-Sch\[ADoubleDot]tzer\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894514219638*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894514257265*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "1.`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894514295496*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894514333146*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND \
EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894514370055*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894514407672*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0.00003461103770237972`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894514445827*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608945144834623`*^9}],

Cell[BoxData[
 RowBox[{"{", "0.00003461103770237972`", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894514556966*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894514602038*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX \
UND EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894514650516*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894514692684*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "28892.51713857871`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608945147379093`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608945147836313`*^9}],

Cell[BoxData[
 RowBox[{"{", "28892.51713857871`", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894514829125*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.4608945148714333`*^9}],

Cell[BoxData["\<\"KOMPENSIERTE LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894514917379*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894514998123*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"U =  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  Nue = \"\>", "\[InvisibleSpace]", "50"}],
  SequenceForm["U =  ", 1, "  Nue = ", 50],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894515062519*^9}],

Cell[BoxData["\<\"AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) \
AZENCOTT/DACUNHA-CASTELLE (A/D)\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894515106051*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"LIK\"\>",
       HoldForm], 
      TagBox["\<\"AIC\"\>",
       HoldForm], 
      TagBox["\<\"SIC/RISS\"\>",
       HoldForm], 
      TagBox["\<\"A/D\"\>",
       HoldForm]},
     {
      TagBox["\<\"Kompensator\"\>",
       HoldForm], "0", "1", "1.956011502714073`", "1.3654186875213339`"},
     {
      TagBox["\<\"komp. Lik.\"\>",
       HoldForm], 
      RowBox[{"-", "174.97590959691325`"}], 
      RowBox[{"-", "175.97590959691325`"}], 
      RowBox[{"-", "176.93192109962732`"}], 
      RowBox[{"-", "176.34132828443458`"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {{"Kompensator", "komp. Lik."}, {
      "LIK", "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
    TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894515152959*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "0.5`", "0.4793862822078073`", "0.005883114625976594`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.460894523181237*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Nichtlinear", ",", "EKF", ",", "  ", "onlyNorkorr"}]], "Input",
 CellChangeTimes->{{3.460367266700344*^9, 3.4603672898119717`*^9}, {
  3.4608004330917377`*^9, 3.460800434405518*^9}, {3.460894023232317*^9, 
  3.460894025886685*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "scoreii", ",", "k", 
      ",", "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
    RowBox[{"BFGS", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"Y", ",", "X", ",", 
         RowBox[{"-", "9"}]}], "}"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      "\t  ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"IdioNonlin", ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"m", "=", "100"}], ",", 
          RowBox[{"eps", "=", 
           RowBox[{"10.", "^", 
            RowBox[{"-", "16"}]}]}], ",", 
          RowBox[{"ksigma", "=", "Infinity"}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Lik", ",", "IndividualLikNonlin", ",", "Score", ",", "Hesse"}], 
         "}"}]}], "}"}], ",", "\[IndentingNewLine]", "            ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Sing", "=", "False"}], ",", 
          RowBox[{"2", "Pi"}], ",", "0", ",", 
          RowBox[{"onlynorkorr", "=", "1"}], ",", "\"\<EKF\>\""}], "}"}], ",", 
        RowBox[{"KMAX", "=", "20"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EPS1", "=", ".0001"}], ",", 
          RowBox[{"EPS2", "=", ".0001"}]}], "}"}], ",", "\[IndentingNewLine]",
         "             ", 
        RowBox[{"OPTION", "=", "0"}], ",", 
        RowBox[{"PRINT", "=", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1"}], "}"}]}]}], "}"}]}], "]"}]}], ";"}], 
  "                                                                           \
     "}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113330285616*^9, 3.460113346379695*^9}, {
   3.460200648978776*^9, 3.4602006503583603`*^9}, {3.460200794874672*^9, 
   3.4602007984595947`*^9}, 3.460201903279232*^9, {3.460201941045977*^9, 
   3.4602019411313553`*^9}, {3.460279278878285*^9, 3.460279290392777*^9}, {
   3.460279385569292*^9, 3.4602794078107224`*^9}, 3.460279483282811*^9, {
   3.460282734453003*^9, 3.46028273588818*^9}, {3.460283616696549*^9, 
   3.460283634147719*^9}, {3.4602836706901093`*^9, 3.460283671258127*^9}, {
   3.4602837458995867`*^9, 3.4602837460095263`*^9}, {3.460283977779047*^9, 
   3.4602839782382393`*^9}, {3.460284094017385*^9, 3.460284112248164*^9}, {
   3.4602842039019938`*^9, 3.460284237509654*^9}, {3.460285585933895*^9, 
   3.460285590933837*^9}, 3.460367196326754*^9, {3.460367298081849*^9, 
   3.460367298170825*^9}, {3.460800361839476*^9, 3.46080039328863*^9}, {
   3.460800427676429*^9, 3.460800428500475*^9}, 3.460894033446617*^9},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Tiefe von data = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["Tiefe von data = ", 5],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.4608941748051434`*^9}}],

Cell[BoxData["\<\"L\[ADoubleDot]nge der Paneldaten\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894174870493*^9}}],

Cell[BoxData[
 RowBox[{"{", "50", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894174919532*^9}}],

Cell[BoxData["\<\"***********************LSDE1********************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894174986054*^9}}],

Cell[BoxData["\<\"***********************MODUL:    BFGS \
(skeleton)**************\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894175039432*^9}}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.46089417508881*^9}}],

Cell[BoxData["\<\"Technical Output\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894175141404*^9}}],

Cell[BoxData["IndividualLikNonlin"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.4608941751918364`*^9}}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.4608941752068663`*^9}}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"KMAX\"\>",
       HoldForm], 
      TagBox["\<\"EPS1\"\>",
       HoldForm], 
      TagBox["\<\"EPS2\"\>",
       HoldForm], 
      TagBox["\<\"K\"\>",
       HoldForm], 
      TagBox["\<\"Q\"\>",
       HoldForm], 
      TagBox["\<\"n\"\>",
       HoldForm], 
      TagBox["\<\"T\"\>",
       HoldForm], 
      TagBox["\<\"OPTION\"\>",
       HoldForm]},
     {"1", "20", "0.0001`", "0.0001`", "2", "1", "1", "49", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"KMAX", "EPS1", "EPS2", "K", "Q", "n", "T", "OPTION"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894175269857*^9}}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.4608941752844877`*^9}}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"MAXSTEP\"\>",
       HoldForm], 
      TagBox["\<\"MINSTEP\"\>",
       HoldForm], 
      TagBox["\<\"BOUND\"\>",
       HoldForm], 
      TagBox["\<\"STEPREDUCE\"\>",
       HoldForm], 
      TagBox["\<\"FMAX\"\>",
       HoldForm]},
     {"1", "1", "1.`*^-10", "1.`*^-6", "4", "1000"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"MAXSTEP", "MINSTEP", "BOUND", "STEPREDUCE", "FMAX"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.4608941752987947`*^9}}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.46089417534732*^9}}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"RESAMPLING\"\>",
       HoldForm], 
      TagBox["\<\"FDIGITS\"\>",
       HoldForm], 
      TagBox["\<\"TYP\"\>",
       HoldForm], 
      TagBox["\<\"YMAX\"\>",
       HoldForm], 
      TagBox["\<\"ANALGRAD\"\>",
       HoldForm], 
      TagBox["\<\"FACTOR\"\>",
       HoldForm], 
      TagBox["\<\"CSEED\"\>",
       HoldForm]},
     {"1", "True", "16", "1", "1.`*^8", "False", "1.`", 
      RowBox[{"-", "999"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {
      "RESAMPLING", "FDIGITS", "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}},
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894175411921*^9}}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894175470076*^9}}],

Cell[BoxData["\<\"    SCALING\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.4608941755245647`*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "::", "\<\"nmtx\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The first two levels of the \
one-dimensional list \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\
\\!\\({}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" cannot be \
transposed.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Transpose\\\", ButtonNote -> \\\"Transpose::nmtx\\\
\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.460113347438837*^9, 3.4601140477211742`*^9, 3.460114171488365*^9, 
   3.4601142582303123`*^9, 3.46011431981378*^9, 3.4601210026174927`*^9, 
   3.4602006082555428`*^9, 3.4602006525509787`*^9, 3.4602007997492933`*^9, {
   3.460201893745349*^9, 3.460201903902554*^9}, 3.4602019417761383`*^9, 
   3.460279294169009*^9, 3.460279424327683*^9, 3.4602794918395157`*^9, 
   3.460282465738028*^9, 3.4602825470673647`*^9, 3.460282687933013*^9, 
   3.4602827362471*^9, 3.460282807351432*^9, 3.460282913928569*^9, 
   3.460283210827161*^9, 3.460283352033407*^9, 3.460283407184712*^9, {
   3.460283619834437*^9, 3.460283671655117*^9}, 3.460283747410516*^9, 
   3.460283804801373*^9, {3.460283909419492*^9, 3.460283979704739*^9}, 
   3.46028403988277*^9, {3.4602840959065733`*^9, 3.460284112635261*^9}, 
   3.460284241484562*^9, 3.4602855917581997`*^9, {3.460367187530768*^9, 
   3.4603671971813374`*^9}, 3.4603672993256197`*^9, {3.460800371981085*^9, 
   3.4608003947573767`*^9}, {3.460894148050132*^9, 3.4608941755868998`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  RowBox[{"Transpose", "[", 
   RowBox[{"{", "}"}], "]"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
    0]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894175639749*^9}}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.4608941756912823`*^9}}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894175755484*^9}}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.4608941757974787`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STARTWERT THETA0 = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.5`", "}"}]}],
  SequenceForm["STARTWERT THETA0 = ", {0.5}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.4608941758570013`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894175906258*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "296.9759521484375`", "}"}], ",", 
   RowBox[{"-", "898.3524671326632`"}]}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.4608941759635677`*^9}}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894176010376*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["BFGS: Iteration = ", 1],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894176057082*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -677.469202585463700\"\>",
     -677.4692025854637,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-677.4692025854637, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894176108877*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -898.352467132663000\"\>",
     -898.3524671326632,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-898.3524671326632, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894176155458*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"   220.883264547199500\"\>",
     220.88326454719947`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[220.88326454719947`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894176208885*^9}}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894176273539*^9}}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.5000\"\>",
         1.5,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5000\"\>",
         0.5,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0000\"\>",
         1.,
         AutoDelete->True], 
        InterpretationBox["\<\" 296.9800\"\>",
         296.9759521484375,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894176320119*^9}}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894176376863*^9}}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.4608941764245777`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "2.2351741790771484`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {2.2351741790771484`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894176480782*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "6.507796115329256`*^-6"}],
  SequenceForm["NOISE  ", 6.507796115329256*^-6],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894176532784*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "0.006360469434011779`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "1.`"}],
  SequenceForm["*BFGSUP ", 0.006360469434011779, "  ", 1.],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.4608941765842543`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.3094344032796641`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.3094344032796641, " = Elastizitaet(d l/l)/(d theta/theta)"],
  
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894176629673*^9}}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894176677718*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "2"}],
  SequenceForm["BFGS: Iteration = ", 2],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894176723477*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -609.793840404928900\"\>",
     -609.7938404049289,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-609.7938404049289, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894176797764*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -677.469202585463700\"\>",
     -677.4692025854637,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-677.4692025854637, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894176835294*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    67.675362180534760\"\>",
     67.67536218053476,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[67.67536218053476, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894176891664*^9}}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.4608941769476843`*^9}}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.3889\"\>",
         2.3889064662766817`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.5000\"\>",
         1.5,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.8889\"\>",
         0.8889064662766816,
         AutoDelete->True], 
        InterpretationBox["\<\" 139.7500\"\>",
         139.75485229492188`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894177032844*^9}}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894177081162*^9}}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 157.2\"\>",
         157.22109985351562`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.46089417712855*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "3.5597480331013824`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {3.5597480331013824`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894177173211*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "2.3992686461236203`*^-6"}],
  
  SequenceForm["NOISE  ", 2.3992686461236203`*^-6],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.4608941772284184`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "0.00949368253855243`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "0.008049650767648915`"}],
  SequenceForm["*BFGSUP ", 0.00949368253855243, "  ", 0.008049650767648915],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, {
   3.460894147331208*^9, 3.460894177272997*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.08327699617740479`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.08327699617740479, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894177392001*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941774302397`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "3"}],
  SequenceForm["BFGS: Iteration = ", 3],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941774778833`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -607.653559818943500\"\>",
     -607.6535598189434,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-607.6535598189434, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894177526635*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -609.793840404928900\"\>",
     -609.7938404049289,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-609.7938404049289, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894177581596*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     2.140280585985465\"\>",
     2.1402805859854652`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[2.1402805859854652`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894177626957*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894177680664*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.5484\"\>",
         2.548367940533907,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.3889\"\>",
         2.3889064662766817`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1595\"\>",
         0.15946147425722523`,
         AutoDelete->True], 
        InterpretationBox["\<\" 21.2570\"\>",
         21.25734097725228,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894177734311*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894177784297*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 133.3\"\>",
         133.30706414367108`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894177836463*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "3.797364146312933`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {3.797364146312933*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941778979692`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "4.0456741431604935`*^-7"}],
  
  SequenceForm["NOISE  ", 4.0456741431604935`*^-7],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894177934894*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "0.4081523810881538`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "0.29500901410331143`"}],
  SequenceForm["*BFGSUP ", 0.4081523810881538, "  ", 0.29500901410331143`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894177985162*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.02471279060723562`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.02471279060723562, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894178036056*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894178088243*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "4"}],
  SequenceForm["BFGS: Iteration = ", 4],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894178132917*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -607.459965057299700\"\>",
     -607.4599650572998,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-607.4599650572998, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894178187628*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -607.653559818943500\"\>",
     -607.6535598189434,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-607.6535598189434, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894178231813*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.193594761643681\"\>",
     0.1935947616436806,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.1935947616436806, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894178287949*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.46089417833718*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.6095\"\>",
         2.6095254212863797`,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.5484\"\>",
         2.548367940533907,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0612\"\>",
         0.06115748075247277,
         AutoDelete->True], 
        InterpretationBox["\<\" 5.8927\"\>",
         5.892718608915128,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894178397478*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941784339542`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 96.35\"\>",
         96.3531940232327,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894178490973*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "3.888495894203156`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {3.888495894203156*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894178557529*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "9.499274779143925`*^-8"}],
  SequenceForm["NOISE  ", 9.499274779143925*^-8],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894178621402*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "3.02208338620903`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "2.774819320109864`"}],
  SequenceForm["*BFGSUP ", 3.02208338620903, "  ", 2.774819320109864],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941786680307`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.002071162324649161`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.002071162324649161, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894178724579*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894178789318*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["BFGS: Iteration = ", 5],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894178838166*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -607.458617574313800\"\>",
     -607.4586175743138,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-607.4586175743138, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894178891712*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -607.459965057299700\"\>",
     -607.4599650572998,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-607.4599650572998, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894178959344*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.001347482985921\"\>",
     0.0013474829859205784`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.0013474829859205784`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894179018445*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894179073687*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.6150\"\>",
         2.6149751625555298`,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.6095\"\>",
         2.6095254212863797`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0054\"\>",
         0.00544974126915016,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.4821\"\>",
         0.48213678360686907`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894179125731*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894179190774*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 88.47\"\>",
         88.4696648510901,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894179247027*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "3.896616641514793`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {3.896616641514793*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941793084393`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "7.373776350197101`*^-9"}],
  SequenceForm["NOISE  ", 7.373776350197101*^-9],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894179356523*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "390.8906643836487`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "380.5869121126385`"}],
  SequenceForm["*BFGSUP ", 390.8906643836487, "  ", 380.5869121126385],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894179408496*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0000547093112463078`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0000547093112463078, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941794579887`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894179533085*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "6"}],
  SequenceForm["BFGS: Iteration = ", 6],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894179572357*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -607.458616633301000\"\>",
     -607.4586166333011,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-607.4586166333011, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894179627016*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -607.458617574313800\"\>",
     -607.4586175743138,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-607.4586175743138, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894179680344*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     9.410127859155180\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-7\"\>"]}],
     9.410127859155182*^-7,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[9.410127859155182*^-7, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894179743803*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.46089417979251*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.6151\"\>",
         2.6151227051593118`,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.6150\"\>",
         2.6149751625555298`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0001\"\>",
         0.0001475426037819323,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0127\"\>",
         0.012708970644924539`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941798461313`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894179909946*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 86.14\"\>",
         86.13763292200248,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894179962449*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "3.896836497126984`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {3.896836497126984*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941800145693`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.8972620298982163`*^-10"}],
  SequenceForm["NOISE  ", 1.8972620298982163`*^-10],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941800899363`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "534281.9108430458`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "533300.7322072464`"}],
  SequenceForm["*BFGSUP ", 534281.9108430458, "  ", 533300.7322072464],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894180126895*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "1.00476237522604`*^-7", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 1.00476237522604*^-7, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894180181777*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.46089418024625*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894180294545*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "7"}],
  SequenceForm["BFGS: Iteration = ", 7],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.46089418034368*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -607.458616633294200\"\>",
     -607.4586166332942,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-607.4586166332942, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941803965*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -607.458616633301000\"\>",
     -607.4586166333011,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-607.4586166333011, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941804462233`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     6.821210263296962\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-12\"\>"]}],
     6.821210263296962*^-12,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[6.821210263296962*^-12, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894180496973*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941805449877`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.6151\"\>",
         2.6151229766115,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.6151\"\>",
         2.6151227051593118`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0.0000\"\>",
         0.000023339308755793842`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941806157227`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894180663432*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 85.98\"\>",
         85.97944601084909,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894180714077*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "3.8968369016222657`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {3.8968369016222657`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894180761176*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "6.086198762902292`*^-13"}],
  
  SequenceForm["NOISE  ", 6.086198762902292*^-13],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894180815139*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "6.313621172186731`*^11", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "1.578405784566479`*^11"}],
  SequenceForm["*BFGSUP ", 6.313621172186731*^11, "  ", 1.578405784566479*^11],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.46089418086403*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "7.535717814195384`*^-8",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 7.535717814195384*^-8, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.46089418092056*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941809825974`*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894181029736*^9}],

Cell[BoxData["\<\"ReturnCode = 3\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894181083446*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS:  ENDE DER ITERATION  \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "20"}],
  SequenceForm["BFGS:  ENDE DER ITERATION  ", 7, "  ", 20],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894181146755*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {"1", "0.000017504479749863974`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}]]]], "Print",\

 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894181197424*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894181250483*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 21.49\"\>",
         21.494868196271895`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894181299611*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"Likelihood\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm]},
      {"1", 
       RowBox[{"-", "898.3524671326632`"}], "0.5`"},
      {"2", 
       RowBox[{"-", "677.4692025854637`"}], "1.5`"},
      {"3", 
       RowBox[{"-", "609.7938404049289`"}], "2.3889064662766817`"},
      {"4", 
       RowBox[{"-", "607.6535598189434`"}], "2.548367940533907`"},
      {"5", 
       RowBox[{"-", "607.4599650572998`"}], "2.6095254212863797`"},
      {"6", 
       RowBox[{"-", "607.4586175743138`"}], "2.6149751625555298`"},
      {"7", 
       RowBox[{"-", "607.4586166333011`"}], "2.6151227051593118`"},
      {"8", 
       RowBox[{"-", "607.4586166332942`"}], "2.6151229766115`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"Likelihood", "THETA"}}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941813512993`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"INK: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.00001583575807227824`", "}"}]}],
  SequenceForm["INK: ", {0.00001583575807227824}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.46089418139671*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894181450972*^9}],

Cell[BoxData["\<\"ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894181500245*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894181552462*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {
         StyleBox["\[Null]",
          ShowStringCharacters->False], 
         TagBox["\<\"THETA\"\>",
          HoldForm], 
         TagBox["\<\"SCORE\"\>",
          HoldForm]},
        {"1", "2.6151229766115`", "0.000017504479749863974`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxDividers->{
        "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
         "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.24]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
     "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[
     BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}]]], 
   "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "607.4586166332942`"}]}],
  SequenceForm[
   MatrixForm[{{2.6151229766115, 0.000017504479749863974`}}, 
    TableHeadings -> {Automatic, {"THETA", "SCORE"}}], 
   "   Likelihood = ", -607.4586166332942],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941816010427`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894181683196*^9}],

Cell[BoxData["\<\"WALD-TEST:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894181726878*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894181786919*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"CHI \"\>",
       HoldForm], 
      TagBox["\<\"U \"\>",
       HoldForm], 
      TagBox["\<\"PROB \"\>",
       HoldForm], 
      TagBox["\<\"ALPHA \"\>",
       HoldForm]},
     {"1", "587.7073359571085`", "1", "0", "0.05`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", "ALPHA "}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941818430147`*^9}],

Cell[BoxData["\<\"NULLHYPOTHESE THETA = 0 ABLEHNEN\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894181901457*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941819537373`*^9}],

Cell[BoxData["\<\"BONFERRONI-KONFIDENZINTERVALLE:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894182005744*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894182056655*^9}],

Cell[BoxData["\<\"P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= \
1-ALPHA\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894182107752*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"QUANTIL Z(1-ALPHA/2U) = \"\>", "\[InvisibleSpace]", 
   "1.9599639845400527`"}],
  SequenceForm["QUANTIL Z(1-ALPHA/2U) = ", 1.9599639845400527`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941821632633`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"THETA\"\>",
       HoldForm], 
      TagBox["\<\"GRENZE\"\>",
       HoldForm], 
      TagBox["\<\"STD\"\>",
       HoldForm]},
     {"1", "2.6151229766115`", "0.21142661253096387`", "0.1078727028652925`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894182233028*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894182270294*^9}],

Cell[BoxData["\<\"Korrelation der ML-Sch\[ADoubleDot]tzer\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894182339769*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941823875713`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0.9999999999999999`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894182442974*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941824939337`*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND \
EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941825415363`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894182593877*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0.011636520023463687`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941826414127`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894182695818*^9}],

Cell[BoxData[
 RowBox[{"{", "0.011636520023463687`", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894182770615*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894182808855*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX \
UND EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.46089418285675*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941829080276`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "85.93634505708035`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941829648438`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941830420322`*^9}],

Cell[BoxData[
 RowBox[{"{", "85.93634505708035`", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894183094549*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894183142734*^9}],

Cell[BoxData["\<\"KOMPENSIERTE LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894183194564*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941832448807`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"U =  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  Nue = \"\>", "\[InvisibleSpace]", "50"}],
  SequenceForm["U =  ", 1, "  Nue = ", 50],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.4608941833197803`*^9}],

Cell[BoxData["\<\"AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) \
AZENCOTT/DACUNHA-CASTELLE (A/D)\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894183361095*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"LIK\"\>",
       HoldForm], 
      TagBox["\<\"AIC\"\>",
       HoldForm], 
      TagBox["\<\"SIC/RISS\"\>",
       HoldForm], 
      TagBox["\<\"A/D\"\>",
       HoldForm]},
     {
      TagBox["\<\"Kompensator\"\>",
       HoldForm], "0", "1", "1.956011502714073`", "1.3654186875213339`"},
     {
      TagBox["\<\"komp. Lik.\"\>",
       HoldForm], 
      RowBox[{"-", "607.4586166332942`"}], 
      RowBox[{"-", "608.4586166332942`"}], 
      RowBox[{"-", "609.4146281360083`"}], 
      RowBox[{"-", "608.8240353208156`"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {{"Kompensator", "komp. Lik."}, {
      "LIK", "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
    TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.46036729904891*^9, {3.460800371554468*^9, 3.460800394358012*^9}, 
   3.460894147331208*^9, 3.460894183410239*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "0.5`", "2.6151229766115`", "0.1078727028652925`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.4603673130895653`*^9, {3.4608003829702253`*^9, 3.460800402203874*^9}, 
   3.460894189645028*^9}]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["EDM/  h=Ordinal", "Subsection",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460945699645706*^9, 3.460945742885297*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", "Logistic"}]], "Input",
 CellChangeTimes->{{3.460434794971136*^9, 3.4604347955208197`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox["\<\"Logistic[x_]:= Module[{xx=Exp[-x]}, 1/(1+xx)]\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.4610557274904757`*^9},
 CellTags->"Info3461062927-3135492"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "Logistic", "]"}], "=", 
      RowBox[{"{", 
       RowBox[{"Listable", ",", "Protected"}], "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"Logistic", "[", "x_", "]"}], ":=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Hermann`Kronecker`Private`xx", "=", 
             RowBox[{"Exp", "[", 
              RowBox[{"-", "x"}], "]"}]}], "}"}], ",", 
           FractionBox["1", 
            RowBox[{"1", "+", "Hermann`Kronecker`Private`xx"}]]}], "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[Hermann`Kronecker`Logistic],
  Editable->False]], "Print",
 CellChangeTimes->{3.4610557275089893`*^9},
 CellTags->"Info3461062927-3135492"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Heaviside", "[", 
  RowBox[{"{", 
   RowBox[{"0", ",", "0"}], "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Logistic", "[", 
    RowBox[{"100", 
     RowBox[{"{", " ", 
      RowBox[{"x", ",", 
       RowBox[{"10", " ", "x"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.460280327728023*^9, 3.460280341674404*^9}, {
  3.460434466158127*^9, 3.460434495620612*^9}, {3.4604345344447107`*^9, 
  3.4604345363154173`*^9}, {3.4604347450454597`*^9, 3.460434759093851*^9}, {
  3.460434831060215*^9, 3.4604349201005907`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["1", "2"], ",", 
   FractionBox["1", "2"]}], "}"}]], "Output",
 CellChangeTimes->{
  3.460434496327834*^9, 3.460434537579938*^9, 3.460434571430604*^9, 
   3.460434760012538*^9, 3.4604348407942944`*^9, {3.460434872905922*^9, 
   3.460434920637085*^9}, 3.460460119454465*^9, 3.4608928017521887`*^9, 
   3.4609458943669453`*^9, 3.461035418259811*^9, 3.4610545908882113`*^9, 
   3.461055727862813*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJw9zn0803kAB/BVr5Ruh0QhNFIk4ZLrtvb7fZFOx6vkMXk4K6F0N2KX1ykp
zzuPKeo8pVIbaXmah2b7egp1YiZP60jOhiXT6HCMM/e6fV6vz+vzev/30TsX
7Oy/HoPBuK1WtlkV53JS6EJ48ITaedCcjB8adC9hhAuhghbnZzvdbPxyxyed
I3uF8GMYOPrhcRletz42rfWtAEYxPm+/ONCKR8t2rnONEUCVlJuzfjrD+DuW
2bsWjAUwJcQtyrxsDv+xVgPN543CEHOpKDloK+Feo/rVcb1RuF69jpHHsyF8
7lb+cq1+BHKp4wmuS48JdX8/qeoyGYZPZ5rX/ThIOhIW8IXT18SH0phbNap+
+4gqKVsqSWp8+MG69JFbnA2xpGJX0cT5AdjpH9i2tNGLKMTY317c2A+3HnwQ
ONaUTIwx9E2Mde+D2n6pAUeXCom4k5TIr2m9MD/L0TA9n0NkU6ihWXM9UEIw
6E5y7yV65uQH7jreA69/IdPHHaaJ0pvap8IK30Kf7B3FF3AKSMGF7O9aMW/h
vAO7cWCLLnLUUUNvp083PJAfRcD5H0KEllmKwbU8yDMiMRdLHRCqtpqkUZ0H
z+BcoxLbzyEmGzL420O7oKM3k3w4/lekc0K5KaiDC3ffV44UudxCQrkpTznG
XHindsZpMJ6GbGAx3yVIOqBpXW+AHakB0e9xJGWkvYHdB6IvlRYPIFbiidFc
k3aY6E7fMTIrQXwVYy/SXr2GFvoFz05jsOj13bpTZQGvICaOpmjPMEBzkZrQ
ug1tcNbwjKdXMoqyTjvPtRS0wEDtg3v709xR/uXJq13IS6h04/Dt3qIQdCPW
Y+yypAl67BkW3x2LR82fNDmr0hrh4NaIf1qv3kc9rcw45V4N8HgtvcH2ERON
42fvc1Gph+/v4ihz7DcoaQJrPEZlw83W9jr9IaNolc4oxmjmBaw22/ygWGMJ
xTqz+i5418ArIxZsDcdt4Gx8BqPoJRNafH+DXEg1BiX3ROazRyrgsS1pvOT3
1mC+2KYCLS+Fmh15rBfKHiAxwvKSqlMJfEA63FO7PwTg7guCaQgN2swx2eqP
40B1UyaFaPwQKpCFC0q0XJDHTZI8PJAN4/9Q+4gjl4N2zcnFdoV0GNwT0bVb
vwWIkr5R/zMqHOYGS8N/UekDSGWM0540CugJY2qPT/0FNBElBtUwHej8kOek
GC8C+imsTfb7c8AzUy08VvAJZJErzeN2PAJR3yK0fiAGOduTfPx/pwPV4YJ8
MlsMCjhnfzu2kwHKbRtOmEyIgbNF7ruMjjKgtexqbjEvBm4JmyTRaZXA7+Lm
aHepGFi96yTY6VWDlhbcPoUVMTA2uxfzVUUtoFNdLhWuWi2G1N5pWwew19LJ
Q6te7jVSv9PLAYoOluUzq6ZkzpuaVNYDNWFU5OKqg6C3i5K0AZgP9Xosr9p3
oj58+lgTGMIIz6+s2nXbnlxeajO4Fbe3VeaQaRHWeeYluMntn5Q5+U1pZNfp
VvB8W/KCzPTiK1On6tqAAaVbKnNzAtGXi3sNXly3XZF5ybrNqnOiHcRWi9Zs
ueSi31HeCVIzpWv24R+y887kAdLcypoLqkCkk1MPGFn5z68zaAKtoT6AWcs0
mCUrnxwN4sv9UxnBcdx0UG7BjP+pScl7uV2ILK+TqSNyrxcoGJ31FMjNet51
PEhzXG7viIUcuyKR3A5PRxN8Qz7JbVB1+5lZzZTcy/U23bKf//tfYVGyOA==

     "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQBGIQPW1z0uzeFc/2F+nvNr/MJ8Zw727YmnXlz/YbZ3D9
cTu9gOHfubey1mrP9vetyH/SE9TKKHegpf/4laf7d0S3sWQJZTPZbZRmDGl+
un/vFFH+KfqBzFNMZ8n/1Hq639N2RZx6uCfL650SdvMuPdk/e1f91UXrnFhn
HBKtfqH4ZH91xcOF3P4m7B8v83+tOfBo/6K57l0n/4tz7/m2bNtFnQf7ncIP
6JSLRgsVp33dd/3wrf0L+jMar3lYSkXNnpcu73F1f8qRbtEFlp8Viy70rt6n
dWH/jaNvdmcuUNe8Vfim+qLt0f3CFw8KMLD+MEhsm7Ru5dGt++8Gz5R6s9vZ
Ys2MVwZfrDfvv3D6aO3SMA3LH6ucNttt2rD/lk5KXwoLn5XC/Kf5y22X71+3
xXypz5Vr1tsPTy2x0Vq0/1Xofa7n6nts5l7o/rRId9b+DWW9jFdjFtqekXzz
+wzbhP1iup+zX2S22r3qNhS9U1++f5HgnRDr4Cx72y3Ngar9JfaH4ox/mZ16
by9py7euU32C/eplaVv+/39vr9S7m91Le7Z9wbT//0H8aXlbDFrFF9szgMEH
+wX7ErtcpdfB+aHt7J+a+rfA+f+uaYhOubYPzg8RVp1zqe8InG/6J1jp3Kbz
CPO22dcGBl6F87/k8fs9yboF5z/9nBrw5tN9OD/YZne0X98jOJ/pKZtGYtRT
OH/3+oseWZIv4PyYqp+z3Ve+gvO9Vz9pjy94C+erbJu8Vn/HO4T7DzhdBvkb
xgcAHTMm+g==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.460434496327834*^9, 3.460434537579938*^9, 3.460434571430604*^9, 
   3.460434760012538*^9, 3.4604348407942944`*^9, {3.460434872905922*^9, 
   3.460434920637085*^9}, 3.460460119454465*^9, 3.4608928017521887`*^9, 
   3.4609458943669453`*^9, 3.461035418259811*^9, 3.4610545908882113`*^9, 
   3.4610557279354973`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Plus", "@@", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Heaviside", "[", 
       RowBox[{"x", "-", "#"}], "]"}], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{"c1", ",", "c2"}], "}"}]}], "]"}]}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"x", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"x1", ",", "x2"}], "}"}]}], ",", 
    RowBox[{"c1", "->", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "2"}]}], "}"}]}], ",", 
    RowBox[{"c2", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.4602804139401493`*^9, 3.460280447538992*^9}, {
  3.460280544317827*^9, 3.460280657628171*^9}, {3.460434506601823*^9, 
  3.4604345076725397`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", "x1", "]"}]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", 
          RowBox[{"1", "+", "x1"}], "]"}]}], ")"}]}]}], ",", 
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", "x2", "]"}]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", 
          RowBox[{"1", "+", "x2"}], "]"}]}], ")"}]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", "x1", "]"}]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", 
          RowBox[{"1", "+", "x1"}], "]"}]}], ")"}]}]}], ",", 
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", "x2", "]"}]}], ")"}]}], "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"Sign", "[", 
          RowBox[{"1", "+", "x2"}], "]"}]}], ")"}]}]}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.460280411758966*^9, 3.4602804482063417`*^9}, {
   3.46028057425738*^9, 3.460280658292327*^9}, 3.46028563184229*^9, 
   3.4602857219474*^9, 3.460285983590343*^9, 3.460286266378318*^9, 
   3.460286301805153*^9, 3.460363891030834*^9, 3.460377024341406*^9, 
   3.460434509256716*^9, 3.460434571668792*^9, 3.460460119542832*^9, 
   3.460892801867489*^9, 3.460945894493198*^9, 3.46103541847213*^9, 
   3.461054591084621*^9, 3.461055728070616*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Heaviside", "[", 
     RowBox[{"x", "+", "1"}], "]"}], "+", 
    RowBox[{"Heaviside", "[", 
     RowBox[{"x", "-", "1"}], "]"}], "-", "1"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
   RowBox[{"Axes", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.460280204140476*^9, 3.460280237625312*^9}, {
  3.460280316434142*^9, 3.4602803948226748`*^9}, {3.460281179896861*^9, 
  3.460281180607788*^9}, {3.460281264433981*^9, 3.460281466138386*^9}, {
  3.4604345209580584`*^9, 3.4604345275791397`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAGIQvV+g6N7//+wHGMDgw36L7ULyxzkR/A2xm+P7hNng
/GeySe82/GWG8/XlvMNNuJng/A9HrjDUKzHA+W/3Ts/frfBnP4wvV/RropXz
Dzi/xn6mAZ/2Nzj/Fo/F+YdCX+D8o8eu263n/gznb2goX1fD8gnOXxbrnva4
4SOcP8dKXM7r7wc4f5L486sbKhF8vpe50vpv3kP5wDA4rPVjzbd3cP73Oc+v
aDEi+A8CEvvUxN7A+Rt3hDDKObyA8y+temS56859OP/Kk7dO9iEX4PwFmk/5
n86fCOe/8uLOdrl+zh7G/zzH/JX1tXtwvsrffTOljj2H8/fyM/dNO/MCzg9T
cm8SuvwSzu9wP5/F9eA1nK8YJRzf9uwNnL8rJzyY6e1bOD+ofrZ73ed3cP7r
ifetf/18D+fbOjU/TCr/AOV/sG/dLbb0xEcE/6zJqgy9nI9wvug6W50pzxD8
pQtSNsff/gTnm07uttK+8BnOF2DNsdZ7/BXOf1XmY2P47TucX3VrRmfp1d9w
/gFt1nsnmBkcYPxTznO38QszwfmHpH9v+fqPGc4vbXi91F2EDc6fdULvkDIX
O5wPTe9wPgDcCfWB
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.460280319796722*^9, 3.460280354786551*^9, {3.460280389749917*^9, 
   3.460280394994143*^9}, 3.4602811810928717`*^9, 3.460281274494234*^9, {
   3.460281308314047*^9, 3.460281466274333*^9}, 3.460285631915004*^9, 
   3.4602857220189037`*^9, 3.460285983666174*^9, 3.460286266453809*^9, 
   3.460286301892166*^9, 3.460363891107939*^9, 3.460377024417347*^9, 
   3.4604345292437963`*^9, 3.4604345717561197`*^9, 3.46046011964497*^9, 
   3.460892801969101*^9, 3.4609458945866623`*^9, 3.461035418574946*^9, 
   3.461054591186759*^9, 3.461055728168178*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["th"], "Input",
 CellChangeTimes->{{3.460722238195915*^9, 3.460722238249185*^9}}],

Cell[BoxData["th"], "Output",
 CellChangeTimes->{3.460722238820682*^9, 3.460892802067227*^9, 
  3.4609458946780863`*^9, 3.461035418708473*^9, 3.46105459130422*^9, 
  3.461055728271092*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "Idio", "]"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"Idio", "[", 
   RowBox[{"th_", ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "beta", ",", "gamma", ",", "sigma", ",", "\[IndentingNewLine]", 
      "             ", "sigmazeta", ",", "lambdaeta", ",", "taueta", ",", 
      "sigmaepsilon"}], "}"}], ",", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"beta", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
        "           ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"th", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", "0"}], "}"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"gamma", "=", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], "//", "Spalte"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"sigmazeta", "=", "I2"}], ";", "\[IndentingNewLine]", 
     RowBox[{"lambdaeta", "=", "I2"}], ";", "\[IndentingNewLine]", 
     RowBox[{"taueta", "=", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], "//", "Spalte"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"sigmaepsilon", "=", 
      RowBox[{
       RowBox[{"th", "[", 
        RowBox[{"[", "2", "]"}], "]"}], " ", "I2"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"lambdaeta", ",", "taueta", ",", "sigmaepsilon"}], "}"}]}], 
      "}"}]}]}], "\[IndentingNewLine]", "]"}]}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460112411326638*^9, 3.460112486848282*^9}, {
   3.460112574501026*^9, 3.460112833350883*^9}, 3.460113258604714*^9, {
   3.4601981935531387`*^9, 3.4601982253887444`*^9}, {3.46019833150395*^9, 
   3.460198339518457*^9}, {3.460198463453682*^9, 3.460198495668239*^9}, {
   3.4602012679397707`*^9, 3.4602012745935698`*^9}, {3.460437742137166*^9, 
   3.4604377442837257`*^9}, {3.460459421523945*^9, 3.460459423450386*^9}, {
   3.460774832338387*^9, 3.460774867352644*^9}, {3.460945882088838*^9, 
   3.460945882138485*^9}, {3.461291140579208*^9, 3.4612911551673527`*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "IdioNonlin", "]"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"IdioNonlin", "[", 
   RowBox[{"th_", ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "beta", ",", "gamma", ",", "sigma", ",", "\[IndentingNewLine]", 
      "             ", "sigmazeta", ",", "lambdaeta", ",", "taueta", ",", 
      "sigmaepsilon", ",", "x", ",", "theta", ",", "h", ",", "dh"}], "}"}], 
    ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"beta", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "0"}], "}"}], ",", "\[IndentingNewLine]", 
        "           ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"th", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", "0"}], "}"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"gamma", "=", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], "//", "Spalte"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"sigmazeta", "=", "I2"}], ";", "\[IndentingNewLine]", 
     RowBox[{"c1", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"c2", "=", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"c3", "=", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"h", "[", 
         RowBox[{"eta_", ",", "x_", ",", "theta_"}], "]"}], ":=", 
        RowBox[{
         RowBox[{"Plus", "@@", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Logistic", "[", 
              RowBox[{"100", 
               RowBox[{"(", 
                RowBox[{"eta", "-", "#"}], ")"}]}], "]"}], "&"}], ",", 
            RowBox[{"{", 
             RowBox[{"c1", ",", "c2", ",", "c3"}], "}"}]}], "]"}]}], "-", 
         "1"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"h", "[", 
       RowBox[{"eta_", ",", "x_", ",", "theta_"}], "]"}], ":=", 
      RowBox[{
       RowBox[{"Plus", "@@", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Heaviside", "[", 
            RowBox[{"(", 
             RowBox[{"eta", "-", "#"}], ")"}], "]"}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{"c1", ",", "c2", ",", "c3"}], "}"}]}], "]"}]}], "-", 
       "1"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"h", "[", 
         RowBox[{"eta_", ",", "x_", ",", "theta_"}], "]"}], ":=", 
        RowBox[{"eta", "-", " ", 
         RowBox[{"eta", "^", "3"}]}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"P", ",", "Q"}], "}"}], "=", 
      RowBox[{"gamma", "//", "Dimensions"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Off", "[", 
      RowBox[{"Part", "::", "\"\<partd\>\""}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"eta", "//", "Clear"}], ";", "\[IndentingNewLine]", 
     RowBox[{"etai", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"eta", "[", 
         RowBox[{"[", "i", "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "P"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"hilf", "=", 
      RowBox[{"Outer", "[", 
       RowBox[{"D", ",", 
        RowBox[{"h", "[", 
         RowBox[{"etai", ",", "x", ",", "theta"}], "]"}], ",", "etai"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"dh", "[", 
       RowBox[{"eta_", ",", "x_", ",", "theta_"}], "]"}], "=", "hilf"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"sigmaepsilon", "=", 
      RowBox[{
       RowBox[{"th", "[", 
        RowBox[{"[", "2", "]"}], "]"}], " ", " ", "I2"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"h", ",", "dh", ",", "sigmaepsilon"}], "}"}]}], "}"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460112411326638*^9, 3.460112486848282*^9}, {
   3.460112574501026*^9, 3.460112833350883*^9}, 3.460113258604714*^9, {
   3.4601981935531387`*^9, 3.4601982253887444`*^9}, {3.46019833150395*^9, 
   3.460198339518457*^9}, {3.460198463453682*^9, 3.460198495668239*^9}, {
   3.4602012679397707`*^9, 3.4602012745935698`*^9}, {3.460262544333317*^9, 
   3.460262672020108*^9}, {3.4602627586317263`*^9, 3.46026276001101*^9}, {
   3.4602704141975107`*^9, 3.46027041438337*^9}, {3.460280467176902*^9, 
   3.460280473085874*^9}, {3.4602806924891443`*^9, 3.460280711976782*^9}, {
   3.46028116644274*^9, 3.460281167729628*^9}, {3.460281474946793*^9, 
   3.460281508316875*^9}, {3.4602815479174967`*^9, 3.4602815484137983`*^9}, {
   3.4602816507807617`*^9, 3.460281676993616*^9}, {3.460284307808282*^9, 
   3.460284309899661*^9}, {3.4602847275090322`*^9, 3.460284736183663*^9}, {
   3.4602856192308903`*^9, 3.460285624220776*^9}, {3.460285710934456*^9, 
   3.460285717823205*^9}, {3.4602859764427147`*^9, 3.460285978161388*^9}, {
   3.460286261013752*^9, 3.460286261455785*^9}, {3.4602862948772097`*^9, 
   3.46028629819168*^9}, 3.4603642740349617`*^9, 3.4603644544831877`*^9, 
   3.460365456780478*^9, 3.4603665095654716`*^9, {3.460366607243189*^9, 
   3.4603666125853157`*^9}, {3.4603697272002287`*^9, 3.460369730933084*^9}, {
   3.46037151872565*^9, 3.460371519963439*^9}, {3.460373536249193*^9, 
   3.46037353630791*^9}, {3.460377010128886*^9, 3.4603770349211197`*^9}, {
   3.460377168908317*^9, 3.460377169368896*^9}, 3.46037765815534*^9, 
   3.460431475811249*^9, {3.4604319304909678`*^9, 3.4604319341933823`*^9}, {
   3.460432429495256*^9, 3.460432430269183*^9}, {3.4604331102297277`*^9, 
   3.4604331102918997`*^9}, {3.460433492904319*^9, 3.460433500341628*^9}, {
   3.4604343556223097`*^9, 3.460434355679142*^9}, {3.460434545548963*^9, 
   3.460434546745728*^9}, {3.46043493786023*^9, 3.460434967965836*^9}, {
   3.460435089839349*^9, 3.460435118610239*^9}, {3.460437529942061*^9, 
   3.4604375424215612`*^9}, 3.460438912806677*^9, 3.460439035722678*^9, {
   3.4604393410536213`*^9, 3.460439342272788*^9}, 3.460439840453356*^9, {
   3.460440333630175*^9, 3.460440355270155*^9}, {3.4604590838600483`*^9, 
   3.4604590936409283`*^9}, {3.46045943423339*^9, 3.460459435215295*^9}, {
   3.460460115325142*^9, 3.460460115390798*^9}, {3.460721605284321*^9, 
   3.4607216861135473`*^9}, {3.4607225022010937`*^9, 
   3.4607225180985603`*^9}, {3.46072257741747*^9, 3.4607225784771767`*^9}, {
   3.460774880999907*^9, 3.460774925044929*^9}, 3.460775623252143*^9, 
   3.460794302540344*^9, {3.460795102192762*^9, 3.460795103996147*^9}, {
   3.460800859470233*^9, 3.4608008604100513`*^9}, {3.460801991135057*^9, 
   3.460801991431308*^9}, {3.460861292725114*^9, 3.460861293844521*^9}, {
   3.460945759276362*^9, 3.460945770519526*^9}, {3.460945855843624*^9, 
   3.460945855966559*^9}, {3.461291168597953*^9, 3.461291170467628*^9}, {
   3.461292988984144*^9, 3.4612930049775953`*^9}, {3.461294304952091*^9, 
   3.461294316049425*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData["hilf"], "Input",
 CellChangeTimes->{{3.460721820620864*^9, 3.460721821402771*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"1", "-", 
      RowBox[{"3", " ", 
       SuperscriptBox[
        RowBox[{"eta", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}],
         "2"]}]}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"1", "-", 
      RowBox[{"3", " ", 
       SuperscriptBox[
        RowBox[{"eta", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
         "2"]}]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.460721821538653*^9, 3.460722522060307*^9, 
  3.4607749068155117`*^9, 3.4607749384464817`*^9, 3.46077565699079*^9, 
  3.460892802232217*^9, 3.46094578459663*^9, 3.460945894842696*^9, 
  3.461035418874646*^9, 3.461054591500002*^9, 3.461055728464973*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"h", "//", "Clear"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"h", ",", "dh", ",", "sigmaepsilon"}], "}"}]}], "}"}], "=", 
    RowBox[{"IdioNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], ",", 
      RowBox[{"{", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{"beta", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"gamma", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"sigmazeta", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"sigmaepsilon", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"h", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x", ",", "0"}], "}"}], ",", "0", ",", "theta"}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"dh", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", ",", "0"}], "}"}], ",", "0", ",", "theta"}], "]"}]}], "Input",\

 PageWidth->Infinity,
 CellChangeTimes->{{3.46011249354161*^9, 3.460112502635364*^9}, {
   3.460112738246236*^9, 3.460112740427596*^9}, {3.4601985014479733`*^9, 
   3.4601985021073637`*^9}, {3.460262678368519*^9, 3.460262744386445*^9}, {
   3.460270452868237*^9, 3.460270456266705*^9}, {3.46028153495817*^9, 
   3.4602816223627872`*^9}, {3.460284322897622*^9, 3.4602843302074947`*^9}, {
   3.460721841938987*^9, 3.460721842608491*^9}, {3.46072253843577*^9, 
   3.460722560234561*^9}, 3.460722615455822*^9, {3.460775645385498*^9, 
   3.4607756501937037`*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2"},
      {"1", "0", "0"},
      {"2", "1", "0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, 
   3.460721705060134*^9, 3.460721843511634*^9, 3.460722529695512*^9, {
   3.460722561253811*^9, 3.460722582850761*^9}, 3.460722618209428*^9, {
   3.4607749132488937`*^9, 3.4607749356495037`*^9}, {3.4607756287664843`*^9, 
   3.460775652105815*^9}, 3.4607943087026*^9, 3.460795108382183*^9, 
   3.4608008712161503`*^9, 3.460801994583243*^9, 3.460861298027657*^9, {
   3.460892802307872*^9, 3.4608928156860647`*^9}, 3.460945780365108*^9, 
   3.46094586273503*^9, 3.460945894913694*^9, 3.461035418971367*^9, 
   3.461054591618182*^9, 3.46105572854981*^9, 3.461291180020576*^9, 
   3.461293009584627*^9, 3.4612943201626177`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0"},
      {"2", "0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, 
   3.460721705060134*^9, 3.460721843511634*^9, 3.460722529695512*^9, {
   3.460722561253811*^9, 3.460722582850761*^9}, 3.460722618209428*^9, {
   3.4607749132488937`*^9, 3.4607749356495037`*^9}, {3.4607756287664843`*^9, 
   3.460775652105815*^9}, 3.4607943087026*^9, 3.460795108382183*^9, 
   3.4608008712161503`*^9, 3.460801994583243*^9, 3.460861298027657*^9, {
   3.460892802307872*^9, 3.4608928156860647`*^9}, 3.460945780365108*^9, 
   3.46094586273503*^9, 3.460945894913694*^9, 3.461035418971367*^9, 
   3.461054591618182*^9, 3.46105572854981*^9, 3.461291180020576*^9, 
   3.461293009584627*^9, 3.461294320208497*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2"},
      {"1", "1", "0"},
      {"2", "0", "1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, 
   3.460721705060134*^9, 3.460721843511634*^9, 3.460722529695512*^9, {
   3.460722561253811*^9, 3.460722582850761*^9}, 3.460722618209428*^9, {
   3.4607749132488937`*^9, 3.4607749356495037`*^9}, {3.4607756287664843`*^9, 
   3.460775652105815*^9}, 3.4607943087026*^9, 3.460795108382183*^9, 
   3.4608008712161503`*^9, 3.460801994583243*^9, 3.460861298027657*^9, {
   3.460892802307872*^9, 3.4608928156860647`*^9}, 3.460945780365108*^9, 
   3.46094586273503*^9, 3.460945894913694*^9, 3.461035418971367*^9, 
   3.461054591618182*^9, 3.46105572854981*^9, 3.461291180020576*^9, 
   3.461293009584627*^9, 3.4612943202710238`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2"},
      {"1", "2", "0"},
      {"2", "0", "2"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, 
   3.460721705060134*^9, 3.460721843511634*^9, 3.460722529695512*^9, {
   3.460722561253811*^9, 3.460722582850761*^9}, 3.460722618209428*^9, {
   3.4607749132488937`*^9, 3.4607749356495037`*^9}, {3.4607756287664843`*^9, 
   3.460775652105815*^9}, 3.4607943087026*^9, 3.460795108382183*^9, 
   3.4608008712161503`*^9, 3.460801994583243*^9, 3.460861298027657*^9, {
   3.460892802307872*^9, 3.4608928156860647`*^9}, 3.460945780365108*^9, 
   3.46094586273503*^9, 3.460945894913694*^9, 3.461035418971367*^9, 
   3.461054591618182*^9, 3.46105572854981*^9, 3.461291180020576*^9, 
   3.461293009584627*^9, 3.461294320333415*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwB2IQvV+g6N7//+wHGMDgw36L7ULyxzkR/A2xm+P7hNng
/GeySe82/GWG8/XlvMNNuJng/A9HrjDUKzHA+W/3Ts/frfBnP4wvV/RropXz
Dzi/xn6mAZ/2Nzj/Fo/F+YdCX+D8o8eu263n/gznb2goX1fD8gnOXxbrnva4
4SOcP8dKXM7r7wc4f5L486sbKhF8vpe50vpv3kP5wDA4rPVjzbd3cP73Oc+v
aDEi+A8CEvvUxN7A+Rt3hDDKObyA8y+temS56859OP/Kk7dO9iEX4Hypp/Ge
726egfO7GZ7wxHGfhPPzzN9Mts07COfvX/pgXZT9bjh/0Z0XplaLNsP5XOqP
Ko25VsD5CzSf8j+dPxHO/9Pj+mv7tT57qH/t/aJFW/2sV8D561aeaS1P2ALn
b1vKd9J98R44/5HfSfWSKcfg/Fde3Nku18/B+SYL7/G/V7gO53+eY/7K+to9
OF/l776ZUseew/kd7uezuB68hvNfT7xv/evnezjf1qn5YVL5ByifwaF1t9jS
Ex8R/LMmqzL0cj7C+aLrbHWmPEPwly5I2Rx/+xOcbzq520r7wmc4X4A1x1rv
8Vc4/1WZj43ht+9wftWtGZ2lV3/D+Qe0We+dYGZwgPFPOc/dxi/MBOcfkv69
5es/Zji/tOH1UncRNjh/1gm9Q8pc7HA+NH/B+QB5LBPq
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, 
   3.460721705060134*^9, 3.460721843511634*^9, 3.460722529695512*^9, {
   3.460722561253811*^9, 3.460722582850761*^9}, 3.460722618209428*^9, {
   3.4607749132488937`*^9, 3.4607749356495037`*^9}, {3.4607756287664843`*^9, 
   3.460775652105815*^9}, 3.4607943087026*^9, 3.460795108382183*^9, 
   3.4608008712161503`*^9, 3.460801994583243*^9, 3.460861298027657*^9, {
   3.460892802307872*^9, 3.4608928156860647`*^9}, 3.460945780365108*^9, 
   3.46094586273503*^9, 3.460945894913694*^9, 3.461035418971367*^9, 
   3.461054591618182*^9, 3.46105572854981*^9, 3.461291180020576*^9, 
   3.461293009584627*^9, 3.4612943203967133`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{
        SuperscriptBox["Sign", "\[Prime]",
         MultilineFunction->None], "[", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "x"}], "]"}]}], "+", 
      FractionBox[
       RowBox[{
        SuperscriptBox["Sign", "\[Prime]",
         MultilineFunction->None], "[", "x", "]"}], "2"], "+", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{
        SuperscriptBox["Sign", "\[Prime]",
         MultilineFunction->None], "[", 
        RowBox[{"1", "+", "x"}], "]"}]}]}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], " ", 
       RowBox[{
        SuperscriptBox["Sign", "\[Prime]",
         MultilineFunction->None], "[", 
        RowBox[{"-", "1"}], "]"}]}], "+", 
      FractionBox[
       RowBox[{
        SuperscriptBox["Sign", "\[Prime]",
         MultilineFunction->None], "[", "0", "]"}], "2"], "+", 
      FractionBox[
       RowBox[{
        SuperscriptBox["Sign", "\[Prime]",
         MultilineFunction->None], "[", "1", "]"}], "2"]}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, 
   3.460721705060134*^9, 3.460721843511634*^9, 3.460722529695512*^9, {
   3.460722561253811*^9, 3.460722582850761*^9}, 3.460722618209428*^9, {
   3.4607749132488937`*^9, 3.4607749356495037`*^9}, {3.4607756287664843`*^9, 
   3.460775652105815*^9}, 3.4607943087026*^9, 3.460795108382183*^9, 
   3.4608008712161503`*^9, 3.460801994583243*^9, 3.460861298027657*^9, {
   3.460892802307872*^9, 3.4608928156860647`*^9}, 3.460945780365108*^9, 
   3.46094586273503*^9, 3.460945894913694*^9, 3.461035418971367*^9, 
   3.461054591618182*^9, 3.46105572854981*^9, 3.461291180020576*^9, 
   3.461293009584627*^9, 3.461294320452898*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Simulation/dt=1", "Subsection",
 PageWidth->Infinity,
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Theta", "=", 
  RowBox[{"{", 
   RowBox[{".5", ",", 
    RowBox[{"10", "^", 
     RowBox[{"-", "2"}]}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", "50"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"q", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"X", "=", 
   RowBox[{"Shape", "[", 
    RowBox[{"1", ",", 
     RowBox[{"{", 
      RowBox[{"n", ",", "1"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460112861196432*^9, 3.460112900249464*^9}, {
   3.460112950538982*^9, 3.4601129539374437`*^9}, {3.460113005467535*^9, 
   3.460113006401746*^9}, {3.460113958542322*^9, 3.460113959287684*^9}, 
   3.4601141435117283`*^9, {3.46011422532432*^9, 3.460114228762265*^9}, {
   3.460114299482638*^9, 3.460114299662619*^9}, {3.460120919663384*^9, 
   3.460120925946155*^9}, {3.460370026377693*^9, 3.460370026423751*^9}, {
   3.460370337087948*^9, 3.460370337140321*^9}, {3.460371593295773*^9, 
   3.460371593877831*^9}, {3.460377254178602*^9, 3.4603772542338552`*^9}, 
   3.460427451561919*^9, 3.4604329049294033`*^9, 3.460433078433264*^9, 
   3.460437042733672*^9, 3.460444571968473*^9, 3.460460037897266*^9, 
   3.460460803716981*^9, {3.460774983456369*^9, 3.460775008455426*^9}, {
   3.4608020132258797`*^9, 3.460802035769421*^9}, {3.4612911914951887`*^9, 
   3.461291193532696*^9}},
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.5`", ",", 
   FractionBox["1", "100"]}], "}"}]], "Output",
 CellChangeTimes->{
  3.45982787174109*^9, {3.460112887861902*^9, 3.460112900786964*^9}, 
   3.460112954913162*^9, {3.460113000282473*^9, 3.460113007967648*^9}, 
   3.460113265712655*^9, 3.460113964238937*^9, 3.460114146876112*^9, 
   3.4601142349213667`*^9, 3.460114304518387*^9, 3.460120929697301*^9, {
   3.460126878115456*^9, 3.460126894622835*^9}, 3.4601274604024973`*^9, 
   3.460197817926371*^9, 3.460198252562779*^9, 3.460198349161854*^9, 
   3.460198506587408*^9, 3.460199526323365*^9, 3.460199563520813*^9, 
   3.460199653793846*^9, 3.4602004848983727`*^9, 3.4602006007365503`*^9, 
   3.460201290106146*^9, 3.460201878664384*^9, 3.460254150649612*^9, 
   3.4602704732126837`*^9, 3.460279153501918*^9, 3.460279212991139*^9, 
   3.4602816948847113`*^9, {3.460284336364369*^9, 3.460284358322968*^9}, 
   3.460284752117095*^9, 3.460285736075243*^9, 3.46028598941461*^9, 
   3.460286271965789*^9, 3.4602863067892523`*^9, 3.4603638961194057`*^9, 
   3.460366621961207*^9, 3.460369741827793*^9, 3.4603700297393913`*^9, 
   3.460370341259691*^9, 3.460371529118987*^9, 3.4603715972424173`*^9, 
   3.46037354416546*^9, 3.460377043299438*^9, 3.460377177822056*^9, 
   3.460377257847652*^9, 3.46037766509881*^9, 3.460427455891576*^9, {
   3.4604329057405024`*^9, 3.460432914614367*^9}, 3.4604330817497673`*^9, 
   3.460433119701372*^9, 3.46043457776158*^9, 3.460434977961318*^9, 
   3.460437046144434*^9, 3.460437552873603*^9, 3.460437900974538*^9, 
   3.460439351382359*^9, 3.46044036674789*^9, 3.46044457492516*^9, 
   3.460444772196126*^9, 3.4604449403037977`*^9, 3.4604449975762653`*^9, 
   3.4604591002378387`*^9, 3.460460040416348*^9, 3.460460125733479*^9, 
   3.4604608064131107`*^9, 3.460721885700042*^9, 3.4607226257606907`*^9, {
   3.460774945392398*^9, 3.460774955052388*^9}, {3.460774987146434*^9, 
   3.460775011536562*^9}, 3.460775669381913*^9, 3.460794312885345*^9, 
   3.460795114625*^9, {3.4608020014812107`*^9, 3.4608020361412907`*^9}, 
   3.4608613046036253`*^9, 3.460892845962228*^9, 3.460945803647064*^9, 
   3.460945865945681*^9, 3.4609459029451427`*^9, 3.46095274990246*^9, 
   3.4610354242788887`*^9, 3.461054598145165*^9, 3.461055732462867*^9, 
   3.461065841468306*^9, {3.461291194528249*^9, 3.461291200038537*^9}, 
   3.461293017845615*^9, 3.46129432812604*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SeedRandom", "[", "12345689999999", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Y", ",", "X", ",", "ETA"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"ZETA", ",", "EPSILON"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"h", ",", "dh", ",", "sigmaepsilon"}], "}"}]}], "}"}]}], 
    "}"}], "=", "\[IndentingNewLine]", 
   RowBox[{"LISRELsimulNonlin", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", ",", "\"\<Gauss[]\>\"", ",", "X"}], "}"}], ",", "Theta", 
     ",", 
     RowBox[{"{", 
      RowBox[{"IdioNonlin", ",", 
       RowBox[{"{", "}"}]}], "}"}]}], "]"}]}], ";"}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601129177677603`*^9, 3.46011292950504*^9}, {
  3.4601129714155407`*^9, 3.460112981316517*^9}, {3.460198511433001*^9, 
  3.4601985124151077`*^9}, {3.460262802763719*^9, 3.460262821284783*^9}, {
  3.4604447675941477`*^9, 3.460444768681939*^9}, {3.4604449364164333`*^9, 
  3.4604449370413017`*^9}, {3.4604449897999277`*^9, 3.4604449936057873`*^9}, {
  3.460721880513426*^9, 3.460721881301012*^9}},
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[{"beta", "\[IndentingNewLine]", "gamma", "\[IndentingNewLine]", \
"sigmazeta", "\[IndentingNewLine]", "h"}], "Input",
 CellChangeTimes->{{3.4601269097587757`*^9, 3.460126910241324*^9}, {
  3.46026300740036*^9, 3.4602630224003677`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.5`", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.460126911291768*^9, {3.460127448010219*^9, 3.460127463752602*^9}, 
   3.46019781849335*^9, 3.460198255524288*^9, 3.460198352058052*^9, 
   3.4601985156112556`*^9, 3.4601995266377697`*^9, 3.460199577399457*^9, 
   3.46019965430007*^9, 3.460200566230009*^9, 3.460200601139563*^9, 
   3.460201879055964*^9, 3.460254153231098*^9, {3.46026300470542*^9, 
   3.4602630225053473`*^9}, 3.460270473521778*^9, 3.4602791537878532`*^9, 
   3.460279213318447*^9, 3.460281700761509*^9, {3.460284339881637*^9, 
   3.460284358605403*^9}, 3.460284752501553*^9, 3.460285736426825*^9, 
   3.460285989707677*^9, 3.460286272224893*^9, 3.460286307114214*^9, 
   3.4603638964211063`*^9, 3.460366622238628*^9, 3.4603697421688843`*^9, 
   3.460370030103874*^9, 3.460370341630898*^9, 3.460371529458281*^9, 
   3.460371597568221*^9, 3.460373544538747*^9, 3.460377043635038*^9, 
   3.460377178198557*^9, 3.460377258262187*^9, 3.460377665441781*^9, 
   3.460427456233851*^9, 3.4604319457565603`*^9, {3.460432909977116*^9, 
   3.460432914941457*^9}, 3.4604330820901012`*^9, 3.460433120037969*^9, 
   3.4604345780819597`*^9, 3.460434978336451*^9, 3.460437046470871*^9, 
   3.460437553217643*^9, 3.460440367108382*^9, 3.460444575278883*^9, 
   3.4604447725558567`*^9, 3.460444940639205*^9, 3.460444997936206*^9, 
   3.4604591005903893`*^9, 3.460460040743739*^9, 3.460460126074955*^9, 
   3.4604608067430067`*^9, 3.460721890152472*^9, 3.460722626145686*^9, 
   3.4607749553896437`*^9, {3.460774987430462*^9, 3.46077501187606*^9}, 
   3.460775669737484*^9, 3.4607951149764967`*^9, {3.460802001918146*^9, 
   3.460802018432424*^9}, 3.460802060195074*^9, 3.4608613048399267`*^9, 
   3.460892846236662*^9, 3.460945803920627*^9, 3.460945866238797*^9, 
   3.460945903201758*^9, 3.4609527501602793`*^9, 3.461035424616127*^9, 
   3.461054598521549*^9, 3.461055732843862*^9, 3.461065716275152*^9, 
   3.461065841869492*^9, 3.461291200372344*^9, 3.4612930181861143`*^9, 
   3.461294328427698*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "0", "}"}], ",", 
   RowBox[{"{", "0", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.460126911291768*^9, {3.460127448010219*^9, 3.460127463752602*^9}, 
   3.46019781849335*^9, 3.460198255524288*^9, 3.460198352058052*^9, 
   3.4601985156112556`*^9, 3.4601995266377697`*^9, 3.460199577399457*^9, 
   3.46019965430007*^9, 3.460200566230009*^9, 3.460200601139563*^9, 
   3.460201879055964*^9, 3.460254153231098*^9, {3.46026300470542*^9, 
   3.4602630225053473`*^9}, 3.460270473521778*^9, 3.4602791537878532`*^9, 
   3.460279213318447*^9, 3.460281700761509*^9, {3.460284339881637*^9, 
   3.460284358605403*^9}, 3.460284752501553*^9, 3.460285736426825*^9, 
   3.460285989707677*^9, 3.460286272224893*^9, 3.460286307114214*^9, 
   3.4603638964211063`*^9, 3.460366622238628*^9, 3.4603697421688843`*^9, 
   3.460370030103874*^9, 3.460370341630898*^9, 3.460371529458281*^9, 
   3.460371597568221*^9, 3.460373544538747*^9, 3.460377043635038*^9, 
   3.460377178198557*^9, 3.460377258262187*^9, 3.460377665441781*^9, 
   3.460427456233851*^9, 3.4604319457565603`*^9, {3.460432909977116*^9, 
   3.460432914941457*^9}, 3.4604330820901012`*^9, 3.460433120037969*^9, 
   3.4604345780819597`*^9, 3.460434978336451*^9, 3.460437046470871*^9, 
   3.460437553217643*^9, 3.460440367108382*^9, 3.460444575278883*^9, 
   3.4604447725558567`*^9, 3.460444940639205*^9, 3.460444997936206*^9, 
   3.4604591005903893`*^9, 3.460460040743739*^9, 3.460460126074955*^9, 
   3.4604608067430067`*^9, 3.460721890152472*^9, 3.460722626145686*^9, 
   3.4607749553896437`*^9, {3.460774987430462*^9, 3.46077501187606*^9}, 
   3.460775669737484*^9, 3.4607951149764967`*^9, {3.460802001918146*^9, 
   3.460802018432424*^9}, 3.460802060195074*^9, 3.4608613048399267`*^9, 
   3.460892846236662*^9, 3.460945803920627*^9, 3.460945866238797*^9, 
   3.460945903201758*^9, 3.4609527501602793`*^9, 3.461035424616127*^9, 
   3.461054598521549*^9, 3.461055732843862*^9, 3.461065716275152*^9, 
   3.461065841869492*^9, 3.461291200372344*^9, 3.4612930181861143`*^9, 
   3.461294328441422*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1.`", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1.`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.460126911291768*^9, {3.460127448010219*^9, 3.460127463752602*^9}, 
   3.46019781849335*^9, 3.460198255524288*^9, 3.460198352058052*^9, 
   3.4601985156112556`*^9, 3.4601995266377697`*^9, 3.460199577399457*^9, 
   3.46019965430007*^9, 3.460200566230009*^9, 3.460200601139563*^9, 
   3.460201879055964*^9, 3.460254153231098*^9, {3.46026300470542*^9, 
   3.4602630225053473`*^9}, 3.460270473521778*^9, 3.4602791537878532`*^9, 
   3.460279213318447*^9, 3.460281700761509*^9, {3.460284339881637*^9, 
   3.460284358605403*^9}, 3.460284752501553*^9, 3.460285736426825*^9, 
   3.460285989707677*^9, 3.460286272224893*^9, 3.460286307114214*^9, 
   3.4603638964211063`*^9, 3.460366622238628*^9, 3.4603697421688843`*^9, 
   3.460370030103874*^9, 3.460370341630898*^9, 3.460371529458281*^9, 
   3.460371597568221*^9, 3.460373544538747*^9, 3.460377043635038*^9, 
   3.460377178198557*^9, 3.460377258262187*^9, 3.460377665441781*^9, 
   3.460427456233851*^9, 3.4604319457565603`*^9, {3.460432909977116*^9, 
   3.460432914941457*^9}, 3.4604330820901012`*^9, 3.460433120037969*^9, 
   3.4604345780819597`*^9, 3.460434978336451*^9, 3.460437046470871*^9, 
   3.460437553217643*^9, 3.460440367108382*^9, 3.460444575278883*^9, 
   3.4604447725558567`*^9, 3.460444940639205*^9, 3.460444997936206*^9, 
   3.4604591005903893`*^9, 3.460460040743739*^9, 3.460460126074955*^9, 
   3.4604608067430067`*^9, 3.460721890152472*^9, 3.460722626145686*^9, 
   3.4607749553896437`*^9, {3.460774987430462*^9, 3.46077501187606*^9}, 
   3.460775669737484*^9, 3.4607951149764967`*^9, {3.460802001918146*^9, 
   3.460802018432424*^9}, 3.460802060195074*^9, 3.4608613048399267`*^9, 
   3.460892846236662*^9, 3.460945803920627*^9, 3.460945866238797*^9, 
   3.460945903201758*^9, 3.4609527501602793`*^9, 3.461035424616127*^9, 
   3.461054598521549*^9, 3.461055732843862*^9, 3.461065716275152*^9, 
   3.461065841869492*^9, 3.461291200372344*^9, 3.4612930181861143`*^9, 
   3.461294328452374*^9}],

Cell[BoxData["h$1643642"], "Output",
 CellChangeTimes->{
  3.460126911291768*^9, {3.460127448010219*^9, 3.460127463752602*^9}, 
   3.46019781849335*^9, 3.460198255524288*^9, 3.460198352058052*^9, 
   3.4601985156112556`*^9, 3.4601995266377697`*^9, 3.460199577399457*^9, 
   3.46019965430007*^9, 3.460200566230009*^9, 3.460200601139563*^9, 
   3.460201879055964*^9, 3.460254153231098*^9, {3.46026300470542*^9, 
   3.4602630225053473`*^9}, 3.460270473521778*^9, 3.4602791537878532`*^9, 
   3.460279213318447*^9, 3.460281700761509*^9, {3.460284339881637*^9, 
   3.460284358605403*^9}, 3.460284752501553*^9, 3.460285736426825*^9, 
   3.460285989707677*^9, 3.460286272224893*^9, 3.460286307114214*^9, 
   3.4603638964211063`*^9, 3.460366622238628*^9, 3.4603697421688843`*^9, 
   3.460370030103874*^9, 3.460370341630898*^9, 3.460371529458281*^9, 
   3.460371597568221*^9, 3.460373544538747*^9, 3.460377043635038*^9, 
   3.460377178198557*^9, 3.460377258262187*^9, 3.460377665441781*^9, 
   3.460427456233851*^9, 3.4604319457565603`*^9, {3.460432909977116*^9, 
   3.460432914941457*^9}, 3.4604330820901012`*^9, 3.460433120037969*^9, 
   3.4604345780819597`*^9, 3.460434978336451*^9, 3.460437046470871*^9, 
   3.460437553217643*^9, 3.460440367108382*^9, 3.460444575278883*^9, 
   3.4604447725558567`*^9, 3.460444940639205*^9, 3.460444997936206*^9, 
   3.4604591005903893`*^9, 3.460460040743739*^9, 3.460460126074955*^9, 
   3.4604608067430067`*^9, 3.460721890152472*^9, 3.460722626145686*^9, 
   3.4607749553896437`*^9, {3.460774987430462*^9, 3.46077501187606*^9}, 
   3.460775669737484*^9, 3.4607951149764967`*^9, {3.460802001918146*^9, 
   3.460802018432424*^9}, 3.460802060195074*^9, 3.4608613048399267`*^9, 
   3.460892846236662*^9, 3.460945803920627*^9, 3.460945866238797*^9, 
   3.460945903201758*^9, 3.4609527501602793`*^9, 3.461035424616127*^9, 
   3.461054598521549*^9, 3.461055732843862*^9, 3.461065716275152*^9, 
   3.461065841869492*^9, 3.461291200372344*^9, 3.4612930181861143`*^9, 
   3.4612943284620523`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"B", "//", "Clear"}]], "Input",
 CellChangeTimes->{{3.460796396588298*^9, 3.4607963991799088`*^9}}],

Cell[CellGroupData[{

Cell[BoxData["a12"], "Input",
 CellChangeTimes->{{3.460796574557797*^9, 3.460796575368771*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"Arrow", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "0.8`"}], ",", "0.`"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.8`", ",", "0.`"}], "}"}]}], "}"}], "]"}], "}"}]], "Output",
 CellChangeTimes->{
  3.460796575512144*^9, {3.460802002468438*^9, 3.4608020188408537`*^9}, 
   3.460861305123418*^9, 3.46089284638268*^9, 3.460945804050941*^9, 
   3.460945866546947*^9, 3.460945903363902*^9, 3.460952750319762*^9, 
   3.461035425001086*^9, 3.4610545987483664`*^9, 3.461055733122055*^9, 
   3.461065842092367*^9, 3.461291200579225*^9, 3.461293018533043*^9, 
   3.461294328575178*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BlaBlaDiagrammMatrix", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"A", ",", "B"}], "}"}], ",", ".2", ",", "beta", ",", "12"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.460126926202602*^9, 3.460126926264735*^9}, {
  3.460197837062155*^9, 3.4601978744501877`*^9}, {3.460198176014512*^9, 
  3.4601981763542347`*^9}, {3.460198286470953*^9, 3.460198287074853*^9}, {
  3.460201742748698*^9, 3.46020174505478*^9}, {3.460201843262917*^9, 
  3.460201847980236*^9}, {3.4602030757501917`*^9, 3.460203091242997*^9}, {
  3.460203406030672*^9, 3.460203406841346*^9}, {3.4602037079581614`*^9, 
  3.4602037570505037`*^9}, {3.4604314383103333`*^9, 3.460431463763299*^9}, {
  3.46072191343194*^9, 3.4607219215661173`*^9}, {3.460774964542247*^9, 
  3.46077496528304*^9}, {3.460796389790634*^9, 3.460796390917165*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0], Thickness[0.003], CircleBox[{-1, 0}, 0.2], 
    CircleBox[{1, 0}, 0.2]}, 
   {GrayLevel[0], Thickness[0.003], InsetBox["A", {-0.98, 0.02}], 
    InsetBox["B", {1.02, 0.02}]}, 
   {RGBColor[1, 0, 0], Thickness[0.003], ArrowBox[{{-0.8, 0.}, {0.8, 0.}}]}, 
   {RGBColor[0, 0, 1], Thickness[0.003]}, 
   {RGBColor[1, 0, 0], Thickness[0.003], 
    InsetBox["0.5`", {0.059999999999999915`, -0.1},
     Background->RGBColor[1, 0.85, 0.85]]}, 
   {RGBColor[0, 0, 1], Thickness[0.003]}},
  AspectRatio->Automatic,
  BaseStyle->{FontFamily -> "Helvetica", FontSize -> 12},
  Frame->True,
  FrameTicks->False,
  ImageSize->{416., Automatic}]], "Output",
 CellChangeTimes->{
  3.4601269281869783`*^9, 3.460127426082061*^9, 3.460127466329838*^9, {
   3.460127585117103*^9, 3.4601276005862913`*^9}, {3.4601978186150627`*^9, 
   3.4601978754337683`*^9}, {3.4601979922064037`*^9, 3.460198015465253*^9}, {
   3.460198108435659*^9, 3.460198177004368*^9}, {3.460198256947486*^9, 
   3.460198287948544*^9}, 3.460198354151993*^9, 3.460198517017171*^9, 
   3.460199526697234*^9, 3.4601995792704763`*^9, 3.460199654370886*^9, 
   3.460200568819632*^9, 3.460200601192975*^9, 3.460201294388686*^9, 
   3.460201422604823*^9, {3.4602014621856337`*^9, 3.4602014755616083`*^9}, {
   3.460201617064205*^9, 3.460201636172051*^9}, 3.460201746377551*^9, {
   3.4602017858617897`*^9, 3.460201848817997*^9}, 3.460201879133306*^9, {
   3.460203077180921*^9, 3.46020309246707*^9}, {3.460203375574904*^9, 
   3.460203407031555*^9}, {3.460203525933297*^9, 3.460203550744958*^9}, {
   3.460203591076667*^9, 3.4602035982917624`*^9}, 3.460203629545972*^9, {
   3.460203698543215*^9, 3.4602037978560038`*^9}, 3.460254157635613*^9, 
   3.460254917290598*^9, {3.460254963282044*^9, 3.4602549886738853`*^9}, 
   3.460263131690372*^9, 3.460270473691039*^9, 3.460279154236169*^9, 
   3.460279213807478*^9, 3.460281708338883*^9, {3.460284349078342*^9, 
   3.46028435872755*^9}, 3.460284753032539*^9, 3.460285736953566*^9, 
   3.4602859901890087`*^9, 3.460286272617923*^9, 3.460286307573679*^9, 
   3.460363896961611*^9, 3.460366622530184*^9, 3.460369742647211*^9, 
   3.460370030312529*^9, 3.46037034184521*^9, 3.460371529755887*^9, 
   3.46037159784545*^9, 3.460373544733478*^9, 3.460377044136137*^9, 
   3.4603771786940317`*^9, 3.460377258585181*^9, 3.460377665886016*^9, 
   3.460427456579464*^9, {3.460431435582724*^9, 3.4604314836711187`*^9}, 
   3.4604319486144123`*^9, 3.460432915151466*^9, 3.460433082416451*^9, 
   3.460433120520093*^9, 3.460434578562842*^9, 3.460434978814953*^9, 
   3.4604370467471027`*^9, 3.460437553357094*^9, 3.4604403675548153`*^9, 
   3.460444575794372*^9, 3.4604447727257557`*^9, 3.460444941147047*^9, 
   3.460444998197179*^9, 3.460459101088204*^9, 3.460460040928624*^9, 
   3.4604601264664707`*^9, 3.460460807058498*^9, {3.4607218959351254`*^9, 
   3.460721922246777*^9}, 3.460722626612988*^9, {3.4607749564757357`*^9, 
   3.460775012170724*^9}, 3.460775670176813*^9, 3.4607943173822527`*^9, 
   3.460795115476233*^9, {3.4607963868910303`*^9, 3.460796402499433*^9}, 
   3.460796572498952*^9, {3.4608020025541763`*^9, 3.4608020189421988`*^9}, 
   3.460861305208261*^9, 3.460892846460535*^9, 3.460945804131802*^9, 
   3.460945866635064*^9, 3.460945903450736*^9, 3.460952750417239*^9, 
   3.4610354250833473`*^9, 3.461054598851849*^9, 3.4610557332354794`*^9, 
   3.4610658423162937`*^9, 3.4612912006910877`*^9, 3.4612930186386003`*^9, 
   3.4612943286529284`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"B1", "=", 
    RowBox[{
     RowBox[{"I2", "-", "beta"}], "//", "Inverse"}]}], ")"}], "//", 
  "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.4602031193688383`*^9, 3.4602031417504272`*^9}, {
  3.460254264329975*^9, 3.460254272840392*^9}, {3.4607749723988*^9, 
  3.460774972467041*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2"},
      {"1", "1.`", "0.`"},
      {"2", "0.5`", "1.`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.460203120570764*^9, 3.460203142571908*^9}, 
   3.460254154939602*^9, {3.460254261383683*^9, 3.460254273739875*^9}, 
   3.460254333610758*^9, 3.460263140602977*^9, 3.460270473788156*^9, 
   3.4602791543419523`*^9, 3.460279213895871*^9, 3.460281712464506*^9, {
   3.460284351900099*^9, 3.460284358790635*^9}, 3.460284753137499*^9, 
   3.460285737065781*^9, 3.460285990287882*^9, 3.460286272704586*^9, 
   3.4602863076641827`*^9, 3.4603638970605183`*^9, 3.460366622635786*^9, 
   3.4603697427595453`*^9, 3.460370030414991*^9, 3.460370341928465*^9, 
   3.460371529857189*^9, 3.4603715979464417`*^9, 3.460373544838743*^9, 
   3.460377044224801*^9, 3.460377178799849*^9, 3.460377258685432*^9, 
   3.460377666002129*^9, 3.460427456683173*^9, 3.460432915252284*^9, 
   3.460433082520834*^9, 3.4604331206095257`*^9, 3.460434578667056*^9, 
   3.4604349789017773`*^9, 3.460437046835697*^9, 3.460437553445334*^9, 
   3.460440367670916*^9, 3.460444575903373*^9, 3.460444772817761*^9, 
   3.460444941257197*^9, 3.460444998286359*^9, 3.460459101179171*^9, 
   3.4604600410360126`*^9, 3.460460126573408*^9, 3.460460807148085*^9, 
   3.460721932075602*^9, 3.460722626715157*^9, {3.460774956818077*^9, 
   3.4607750122761507`*^9}, 3.460775670268469*^9, 3.4607951155784817`*^9, {
   3.460802002784387*^9, 3.460802019037509*^9}, 3.460861305291651*^9, 
   3.460892846519476*^9, 3.460945804185149*^9, 3.460945866717063*^9, 
   3.4609459035483637`*^9, 3.460952750539568*^9, 3.4610354251696*^9, 
   3.4610545989692287`*^9, 3.461055733370831*^9, 3.461065726886127*^9, 
   3.461065842460681*^9, 3.4612912008059683`*^9, 3.461293018733141*^9, 
   3.461294328742208*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BlaBlaDiagrammMatrix", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"A", ",", "B"}], "}"}], ",", ".2", ",", "B1", ",", "12"}], 
  "]"}]], "Input",
 CellChangeTimes->{
  3.4602541804489317`*^9, {3.460254277098235*^9, 3.460254280231039*^9}, {
   3.460254509599163*^9, 3.4602545160826283`*^9}, {3.460722636783688*^9, 
   3.4607226395330267`*^9}, {3.460774976551556*^9, 3.460774977435566*^9}, {
   3.4607964084250813`*^9, 3.4607964094483423`*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0], Thickness[0.003], CircleBox[{-1, 0}, 0.2], 
    CircleBox[{1, 0}, 0.2]}, 
   {GrayLevel[0], Thickness[0.003], InsetBox["A", {-0.98, 0.02}], 
    InsetBox["B", {1.02, 0.02}]}, 
   {RGBColor[1, 0, 0], Thickness[0.003], ArrowBox[{{-0.8, 0.}, {0.8, 0.}}]}, 
   {RGBColor[0, 0, 1], Thickness[0.003]}, 
   {RGBColor[1, 0, 0], Thickness[0.003], 
    InsetBox["0.5`", {0.059999999999999915`, -0.1},
     Background->RGBColor[1, 0.85, 0.85]]}, 
   {RGBColor[0, 0, 1], Thickness[0.003]}},
  AspectRatio->Automatic,
  BaseStyle->{FontFamily -> "Helvetica", FontSize -> 12},
  Frame->True,
  FrameTicks->False]], "Output",
 CellChangeTimes->{
  3.4602541818218737`*^9, 3.460254280335683*^9, 3.460254334747493*^9, {
   3.460254394251598*^9, 3.460254411277727*^9}, {3.460254511486261*^9, 
   3.4602545320527563`*^9}, 3.460254587240301*^9, 3.460254701501644*^9, 
   3.4602547523545923`*^9, 3.46025483835599*^9, {3.4602548936570463`*^9, 
   3.460254899095298*^9}, {3.4602549339701557`*^9, 3.460254983204011*^9}, 
   3.460263142512862*^9, 3.460270473909836*^9, 3.4602791544692698`*^9, 
   3.460279214020843*^9, 3.460281716552771*^9, {3.460284353799768*^9, 
   3.46028435884326*^9}, 3.460284753268414*^9, 3.460285737301465*^9, 
   3.460285990415246*^9, 3.460286272833438*^9, 3.4602863077868137`*^9, 
   3.4603638971865807`*^9, 3.460366622759886*^9, 3.46036974288822*^9, 
   3.4603700305410748`*^9, 3.460370342056143*^9, 3.460371529983536*^9, 
   3.460371598093424*^9, 3.4603735449649*^9, 3.460377044362979*^9, 
   3.460377178928034*^9, 3.46037725881456*^9, 3.460377666125819*^9, 
   3.4604274568251543`*^9, 3.4604329153801527`*^9, 3.460433082647156*^9, 
   3.4604331207334843`*^9, 3.460434578791883*^9, 3.460434979028728*^9, 
   3.460437046960555*^9, 3.4604375535746403`*^9, 3.460440367795998*^9, 
   3.460444576029722*^9, 3.4604447729447517`*^9, 3.460444941382475*^9, 
   3.4604449984059067`*^9, 3.4604591013052187`*^9, 3.4604600411628523`*^9, 
   3.460460126691949*^9, 3.460460807272231*^9, 3.46072193434873*^9, {
   3.4607226268603*^9, 3.460722640424999*^9}, {3.460774957535947*^9, 
   3.460775012400111*^9}, 3.460775670425413*^9, 3.460795115727992*^9, 
   3.460796410064348*^9, {3.460802002868698*^9, 3.460802019298863*^9}, 
   3.4608613053924007`*^9, 3.460892846588214*^9, 3.460945804286689*^9, 
   3.460945866801765*^9, 3.46094590365129*^9, 3.460952750703953*^9, 
   3.46103542525987*^9, 3.4610545990544*^9, 3.461055733458825*^9, 
   3.461065842547323*^9, 3.461291200891033*^9, 3.461293018822191*^9, 
   3.461294329196948*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"B1", ".", "sigmazeta", ".", 
  RowBox[{"(", 
   RowBox[{"B1", "//", "Transpose"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.461065733866218*^9, 3.46106575571408*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1.`", ",", "0.5`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.5`", ",", "1.25`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.461065757174116*^9, 3.461065842840271*^9, 
  3.46129120098853*^9, 3.461293018924872*^9, 3.461294329543693*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"X", "//", "Dimensions"}]], "Input",
 PageWidth->Infinity,
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"50", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4598278723739767`*^9, 3.460112961274558*^9, 3.4601139646218567`*^9, 
   3.460114147492792*^9, 3.460114235304534*^9, 3.4601143048966722`*^9, 
   3.4601209300977497`*^9, 3.460197818734274*^9, 3.460198377489222*^9, 
   3.460198430929615*^9, 3.460198522874699*^9, 3.4601995267642307`*^9, 
   3.460199654485032*^9, 3.460200491292087*^9, 3.46020060124748*^9, 
   3.460201879197091*^9, 3.460263149826062*^9, 3.460270474001726*^9, 
   3.460279154641218*^9, 3.460279214196114*^9, 3.46028435891831*^9, 
   3.460284753478565*^9, 3.460285737384676*^9, 3.460285990604249*^9, 
   3.4602862729472713`*^9, 3.4602863079894857`*^9, 3.460363897363798*^9, 
   3.460366622836136*^9, 3.460369743118175*^9, 3.460370030648271*^9, 
   3.460370342147684*^9, 3.4603715300882397`*^9, 3.4603715981978397`*^9, 
   3.460373545055071*^9, 3.460377044553479*^9, 3.460377179138245*^9, 
   3.460377259035881*^9, 3.460377666349531*^9, 3.460427456931285*^9, 
   3.460432915486574*^9, 3.460433082739298*^9, 3.4604331209349833`*^9, 
   3.460434578988125*^9, 3.460434979233774*^9, 3.4604370470495157`*^9, 
   3.460437553684456*^9, 3.4604403680034313`*^9, 3.460444576253565*^9, 
   3.4604447730354967`*^9, 3.460444941595415*^9, 3.460444998499771*^9, 
   3.460459101570765*^9, 3.4604600412586613`*^9, 3.4604601267885838`*^9, 
   3.460460807348174*^9, 3.46072262707434*^9, 3.4607749577502823`*^9, {
   3.460774988336665*^9, 3.460775012492605*^9}, 3.460775670662545*^9, 
   3.460795115976261*^9, {3.46080200293657*^9, 3.4608020193935013`*^9}, 
   3.460861305490552*^9, 3.4608928466665707`*^9, 3.4609458043846903`*^9, 
   3.460945866884259*^9, 3.460945903749103*^9, 3.460952750809013*^9, 
   3.461035425350761*^9, 3.461054599138451*^9, 3.4610557338082952`*^9, 
   3.4610658429284897`*^9, 3.4612912010885677`*^9, 3.4612930192261467`*^9, 
   3.461294329645455*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ETA", "//", "Dimensions"}]], "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"50", ",", "2"}], "}"}]], "Output",
 CellChangeTimes->{3.4608020727682133`*^9, 3.460861305576969*^9, 
  3.460892846735661*^9, 3.460945804467008*^9, 3.460945866983993*^9, 
  3.4609459038266478`*^9, 3.460952750906351*^9, 3.461035425602228*^9, 
  3.461054599407049*^9, 3.461055733892192*^9, 3.461065843030575*^9, 
  3.4612912014383698`*^9, 3.461293019318514*^9, 3.4612943297303267`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"ETA", "\[IndentingNewLine]", "Y"}], "Input",
 CellChangeTimes->{{3.460114000133006*^9, 3.460114009445375*^9}, {
  3.460437707958293*^9, 3.460437712698263*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.5616301074727694`", ",", 
     RowBox[{"-", "0.22220807572957746`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.4634756461367502`", ",", "1.8415075286424845`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.4824884137993699`", ",", 
     RowBox[{"-", "1.40408694884235`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9551465569768363`", ",", "1.5424273154349932`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.2884734784812073`", ",", "0.5643718685340828`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.7067866091199786`", ",", "1.7505435707018409`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.45622344636145584`", ",", "1.6676249462896147`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.33799042181662564`"}], ",", "0.06288877022936479`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.8296017016167898`"}], ",", "0.3442555686932689`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.8056093434404543`", ",", 
     RowBox[{"-", "0.2039204098662304`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2.1967575852408245`"}], ",", "0.015985627255467705`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.8825891531062169`"}], ",", "0.3941418359707427`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2.2678672841245238`", ",", "3.159123510574048`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.06611306069769185`", ",", "0.40292632806374584`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.25051791635447174`", ",", "0.35516146332779996`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.0121422898695496`", ",", 
     RowBox[{"-", "0.3062933423038521`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.3335418333916165`", ",", "2.3778288986367158`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.5765123041970615`"}], ",", 
     RowBox[{"-", "0.7907514455529983`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.7857261709076795`"}], ",", "0.008087165417785869`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.1541238427942346`", ",", "0.3247629099989675`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.7809797228607538`"}], ",", 
     RowBox[{"-", "1.1149280092570915`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.058144336719479384`"}], ",", 
     RowBox[{"-", "0.5579552782762516`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.1656347739700479`"}], ",", "0.7638106236727573`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.2989450655871142`", ",", "0.21962104398357685`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.27163802694170247`"}], ",", 
     RowBox[{"-", "0.6289034960394466`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.5906291754652155`", ",", "1.308123666675768`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.756890567785506`", ",", "3.0060135513645454`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.6433529353386698`"}], ",", 
     RowBox[{"-", "0.8930769596842665`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.5026425648206558`"}], ",", "0.06472374745527443`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.49714096255807316`", ",", 
     RowBox[{"-", "0.11579043718669313`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.7045031763393119`"}], ",", 
     RowBox[{"-", "0.8404066066936515`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.6365741876403774`", ",", 
     RowBox[{"-", "0.3036359374358586`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.08472297228268211`", ",", 
     RowBox[{"-", "1.1783204737701167`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.31992973665867375`", ",", "0.49586459701452323`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.5146325857792586`"}], ",", "0.5043208462659772`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.7389772857653192`"}], ",", 
     RowBox[{"-", "2.680394572258897`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.3700060514011758`"}], ",", "0.2568975648749441`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.7165168121457226`"}], ",", 
     RowBox[{"-", "0.2293963409720745`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.372592058493197`"}], ",", "0.03972987460748367`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.13664143282798147`"}], ",", 
     RowBox[{"-", "0.21152664668211196`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.1010113558411394`", ",", "1.2741950479030404`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.7031716594361956`", ",", 
     RowBox[{"-", "0.4127187338428353`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2.040212176564956`"}], ",", 
     RowBox[{"-", "1.2952667538439235`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.365050470016305`"}], ",", 
     RowBox[{"-", "0.1528693876397904`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.04227212767594857`", ",", "0.06422720965410722`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.0516383494021575`", ",", "0.6343772101111966`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.3081229258078952`"}], ",", 
     RowBox[{"-", "1.4467877797589574`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9344552846862566`", ",", 
     RowBox[{"-", "1.0889033744520722`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.5132335571675606`", ",", "1.7078643012918513`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9163039229545173`", ",", 
     RowBox[{"-", "0.01816731645182923`"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.459827872527598*^9, 3.46011303067655*^9, 3.46011396489058*^9, {
   3.4601139984758797`*^9, 3.460114009526347*^9}, 3.46011414834797*^9, 
   3.460114235624238*^9, 3.4601143050940447`*^9, 3.460120930349319*^9, 
   3.460197819413198*^9, 3.460198381508251*^9, 3.46019852964046*^9, 
   3.460199526993176*^9, 3.460199654815744*^9, 3.460200496332955*^9, 
   3.460200601423087*^9, 3.460201879378018*^9, 3.460270474250579*^9, 
   3.460279154911991*^9, 3.4602792144465427`*^9, 3.460284359140807*^9, 
   3.460284753724605*^9, 3.460285737649325*^9, 3.4602859908555183`*^9, 
   3.460286273308621*^9, 3.460286308214764*^9, 3.460363897608238*^9, 
   3.460366623184637*^9, 3.460369743366684*^9, 3.460370031031135*^9, 
   3.4603703425137777`*^9, 3.460371530458078*^9, 3.4603715985520267`*^9, 
   3.4603735454327793`*^9, 3.460377044823373*^9, 3.460377179413405*^9, 
   3.4603772592727413`*^9, 3.460377666570675*^9, 3.460427457300247*^9, 
   3.460432915847116*^9, 3.460433083104856*^9, 3.460433121209031*^9, 
   3.460434579250781*^9, 3.460434979484872*^9, 3.46043704741685*^9, 
   3.4604375539298477`*^9, {3.460437706464828*^9, 3.4604377134974957`*^9}, 
   3.460439052589326*^9, 3.460439859095868*^9, {3.4604403682553453`*^9, 
   3.460440379020708*^9}, 3.460444576485385*^9, 3.4604447734082127`*^9, {
   3.460444941829196*^9, 3.4604449544662857`*^9}, 3.460444998837132*^9, 
   3.460459101818636*^9, 3.460460041624042*^9, 3.460460127127924*^9, 
   3.460460807717482*^9, 3.4607226273019238`*^9, 3.460774957999571*^9, {
   3.46077498857581*^9, 3.460775012897278*^9}, 3.460775670939363*^9, 
   3.4607951162490892`*^9, {3.460802003238473*^9, 3.4608020196537046`*^9}, 
   3.460802078883192*^9, 3.460861305829501*^9, 3.460892846823099*^9, 
   3.460945804580634*^9, {3.4609458424380217`*^9, 3.4609458672455072`*^9}, 
   3.460945903959734*^9, 3.46095275115977*^9, 3.4610354257004337`*^9, 
   3.4610545995176973`*^9, 3.4610557339904957`*^9, 3.461065843193685*^9, 
   3.461291201653839*^9, 3.4612930194350357`*^9, 3.461294329848044*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.9300612997018425`", ",", "0.1431959279476672`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.9267974962390286`", ",", "1.9449807435039461`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9827739633858806`", ",", 
     RowBox[{"-", "1.0341241231760503`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.007100198247379`", ",", "1.9313344093160247`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2.034914428177217`", ",", "1.0983028262533479`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9894849835936792`", ",", "2.034697400061612`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.7543989665015445`", ",", "1.9240638782406403`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.05749759977775222`", ",", "1.182910938617647`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.14226374381392218`"}], ",", "1.0021144055496032`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9020138711565687`", ",", 
     RowBox[{"-", "0.07712603958582287`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.0138740213915147`"}], ",", "1.0282499420994968`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.0939058633817429`"}], ",", "1.150608023527632`"}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{"2.171933806690836`", ",", "2.112485949395273`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.8922761408595081`", ",", "1.1747442799912968`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9760203007220069`", ",", "1.0637215890346656`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.9868984575992843`", ",", "0.15901490112612376`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"2.1779824853027416`", ",", "1.9350287348290762`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.06436560540099122`", ",", 
     RowBox[{"-", "0.08148689149927489`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.10457037879024221`", ",", "1.084929947674714`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2.1001395097982725`", ",", "1.0547816064428783`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.023713664723656526`"}], ",", 
     RowBox[{"-", "0.961361435577159`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.004790650408751241`", ",", "0.13960019013687922`"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.0037702767166775788`"}], ",", "0.9067318531612836`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.0273843968087188`", ",", "1.0497497024913898`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.025883308193485458`"}], ",", "0.06507183471161566`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.964338845582593`", ",", "2.0131423808122935`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.9703913718362518`", ",", "1.985999022773135`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.09230832128991402`"}], ",", "0.04519563324218528`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.9533923639794211`"}], ",", "1.0398812871623249`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9065919711340783`", ",", 
     RowBox[{"-", "0.034637812852586956`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.2019283130266446`"}], ",", 
     RowBox[{"-", "0.06285436919804335`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9765470204590766`", ",", 
     RowBox[{"-", "0.07085772055135724`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.7986941860172684`", ",", 
     RowBox[{"-", "1.0655317318819428`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9106729617156668`", ",", "0.9826956882136102`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.0219527754442721`"}], ",", "0.997413076112083`"}], "}"}],
    ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.1674416687193698`"}], ",", 
     RowBox[{"-", "0.8422362298145062`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.015274140960752459`", ",", "0.9670479138544124`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.8544967274254637`"}], ",", "0.07365514434273504`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.158764572456238`", ",", "1.0788916276793021`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.14918604837377378`"}], ",", 
     RowBox[{"-", "0.07387427829429748`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9518868768837733`", ",", "1.8631796843860242`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.1963126263997874`", ",", 
     RowBox[{"-", "0.15049521955469505`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.8459076810316037`"}], ",", 
     RowBox[{"-", "1.1100867972312942`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.1131885102196186`"}], ",", 
     RowBox[{"-", "0.09462214424767518`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.986353803106205`", ",", "1.0509758470978083`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.7773876494696533`", ",", "1.018413338150548`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.0596225093574083`"}], ",", 
     RowBox[{"-", "0.9731679208548023`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.8871828557022575`", ",", 
     RowBox[{"-", "0.9995292432827879`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.940402068213011`", ",", "1.8400802224752337`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9169479600868365`", ",", 
     RowBox[{"-", "0.03153705663569877`"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.459827872527598*^9, 3.46011303067655*^9, 3.46011396489058*^9, {
   3.4601139984758797`*^9, 3.460114009526347*^9}, 3.46011414834797*^9, 
   3.460114235624238*^9, 3.4601143050940447`*^9, 3.460120930349319*^9, 
   3.460197819413198*^9, 3.460198381508251*^9, 3.46019852964046*^9, 
   3.460199526993176*^9, 3.460199654815744*^9, 3.460200496332955*^9, 
   3.460200601423087*^9, 3.460201879378018*^9, 3.460270474250579*^9, 
   3.460279154911991*^9, 3.4602792144465427`*^9, 3.460284359140807*^9, 
   3.460284753724605*^9, 3.460285737649325*^9, 3.4602859908555183`*^9, 
   3.460286273308621*^9, 3.460286308214764*^9, 3.460363897608238*^9, 
   3.460366623184637*^9, 3.460369743366684*^9, 3.460370031031135*^9, 
   3.4603703425137777`*^9, 3.460371530458078*^9, 3.4603715985520267`*^9, 
   3.4603735454327793`*^9, 3.460377044823373*^9, 3.460377179413405*^9, 
   3.4603772592727413`*^9, 3.460377666570675*^9, 3.460427457300247*^9, 
   3.460432915847116*^9, 3.460433083104856*^9, 3.460433121209031*^9, 
   3.460434579250781*^9, 3.460434979484872*^9, 3.46043704741685*^9, 
   3.4604375539298477`*^9, {3.460437706464828*^9, 3.4604377134974957`*^9}, 
   3.460439052589326*^9, 3.460439859095868*^9, {3.4604403682553453`*^9, 
   3.460440379020708*^9}, 3.460444576485385*^9, 3.4604447734082127`*^9, {
   3.460444941829196*^9, 3.4604449544662857`*^9}, 3.460444998837132*^9, 
   3.460459101818636*^9, 3.460460041624042*^9, 3.460460127127924*^9, 
   3.460460807717482*^9, 3.4607226273019238`*^9, 3.460774957999571*^9, {
   3.46077498857581*^9, 3.460775012897278*^9}, 3.460775670939363*^9, 
   3.4607951162490892`*^9, {3.460802003238473*^9, 3.4608020196537046`*^9}, 
   3.460802078883192*^9, 3.460861305829501*^9, 3.460892846823099*^9, 
   3.460945804580634*^9, {3.4609458424380217`*^9, 3.4609458672455072`*^9}, 
   3.460945903959734*^9, 3.46095275115977*^9, 3.4610354257004337`*^9, 
   3.4610545995176973`*^9, 3.4610557339904957`*^9, 3.461065843193685*^9, 
   3.461291201653839*^9, 3.4612930194350357`*^9, 3.4612943299038467`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Y", "=", 
  RowBox[{"Y", "//", "Round"}]}]], "Input",
 CellChangeTimes->{{3.4609527303047733`*^9, 3.460952734526483*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.460952736005434*^9, 3.460952751346912*^9}, 
   3.461035425892694*^9, 3.461054599745957*^9, 3.461055734178013*^9, 
   3.461065844193943*^9, 3.461291201953761*^9, 3.461293019671586*^9, 
   3.461294330054047*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"plot1", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ETA", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"n", "//", "Range"}], ",", "All"}], " ", "]"}], "]"}], "//", 
     "Transpose"}], "//", "AddTimeAxis"}], ",", 
   RowBox[{"farbmodell", "\[Rule]", "Hue"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plot1", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Y", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"n", "//", "Range"}], ",", "All"}], " ", "]"}], "]"}], "//", 
      "Transpose"}], "//", "AddTimeAxis"}], ",", 
    RowBox[{"farbmodell", "\[Rule]", "Hue"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113047733139*^9, 3.4601131167734203`*^9}, {
  3.46011396933543*^9, 3.460113989452705*^9}, {3.460114029168693*^9, 
  3.460114031766469*^9}, {3.460114161512141*^9, 3.460114164229396*^9}, {
  3.460120949297063*^9, 3.460120987997653*^9}, {3.460370039524664*^9, 
  3.460370040016472*^9}, {3.460371539333914*^9, 3.460371544125806*^9}, {
  3.460801595611189*^9, 3.46080160763523*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.5616301074727694}, {
       1., -0.22220807572957746`}}]}}}, {{}, {}, 
    {Hue[0.9], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 1.4634756461367502`}, {1., 
       1.8415075286424845`}}]}}}, {{}, {}, 
    {Hue[0.8], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.4824884137993699}, {
       1., -1.40408694884235}}]}}}, {{}, {}, 
    {Hue[0.7000000000000001], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.9551465569768363}, {1., 
       1.5424273154349932`}}]}}}, {{}, {}, 
    {Hue[0.6], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 1.2884734784812073`}, {1., 
       0.5643718685340828}}]}}}, {{}, {}, 
    {Hue[0.5], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.7067866091199786}, {1., 
       1.7505435707018409`}}]}}}, {{}, {}, 
    {Hue[0.4], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.45622344636145584`}, {1., 
       1.6676249462896147`}}]}}}, {{}, {}, 
    {Hue[0.30000000000000004`], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.33799042181662564`}, {1., 
       0.06288877022936479}}]}}}, {{}, {}, 
    {Hue[0.2], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.8296017016167898}, {1., 
       0.3442555686932689}}]}}}, {{}, {}, 
    {Hue[0.1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.8056093434404543}, {
       1., -0.2039204098662304}}]}}}, {{}, {}, 
    {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -2.1967575852408245`}, {1., 
       0.015985627255467705`}}]}}}, {{}, {}, 
    {Hue[0.9], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.8825891531062169}, {1., 
       0.3941418359707427}}]}}}, {{}, {}, 
    {Hue[0.8], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 2.2678672841245238`}, {1., 
       3.159123510574048}}]}}}, {{}, {}, 
    {Hue[0.7000000000000001], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.06611306069769185}, {1., 
       0.40292632806374584`}}]}}}, {{}, {}, 
    {Hue[0.6], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.25051791635447174`}, {1., 
       0.35516146332779996`}}]}}}, {{}, {}, 
    {Hue[0.5], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 1.0121422898695496`}, {
       1., -0.3062933423038521}}]}}}, {{}, {}, 
    {Hue[0.4], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 1.3335418333916165`}, {1., 
       2.3778288986367158`}}]}}}, {{}, {}, 
    {Hue[0.30000000000000004`], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.5765123041970615}, {
       1., -0.7907514455529983}}]}}}, {{}, {}, 
    {Hue[0.2], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.7857261709076795}, {1., 
       0.008087165417785869}}]}}}, {{}, {}, 
    {Hue[0.1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 1.1541238427942346`}, {1., 
       0.3247629099989675}}]}}}, {{}, {}, 
    {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.7809797228607538}, {
       1., -1.1149280092570915`}}]}}}, {{}, {}, 
    {Hue[0.9], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.058144336719479384`}, {
       1., -0.5579552782762516}}]}}}, {{}, {}, 
    {Hue[0.8], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.1656347739700479}, {1., 
       0.7638106236727573}}]}}}, {{}, {}, 
    {Hue[0.7000000000000001], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.2989450655871142}, {1., 
       0.21962104398357685`}}]}}}, {{}, {}, 
    {Hue[0.6], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.27163802694170247`}, {
       1., -0.6289034960394466}}]}}}, {{}, {}, 
    {Hue[0.5], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.5906291754652155}, {1., 
       1.308123666675768}}]}}}, {{}, {}, 
    {Hue[0.4], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 1.756890567785506}, {1., 
       3.0060135513645454`}}]}}}, {{}, {}, 
    {Hue[0.30000000000000004`], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.6433529353386698}, {
       1., -0.8930769596842665}}]}}}, {{}, {}, 
    {Hue[0.2], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -1.5026425648206558`}, {1., 
       0.06472374745527443}}]}}}, {{}, {}, 
    {Hue[0.1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.49714096255807316`}, {
       1., -0.11579043718669313`}}]}}}, {{}, {}, 
    {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.7045031763393119}, {
       1., -0.8404066066936515}}]}}}, {{}, {}, 
    {Hue[0.9], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.6365741876403774}, {
       1., -0.3036359374358586}}]}}}, {{}, {}, 
    {Hue[0.8], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.08472297228268211}, {
       1., -1.1783204737701167`}}]}}}, {{}, {}, 
    {Hue[0.7000000000000001], PointSize[0.003], Thickness[0.003], Dashing[{}],
      {}, 
     {Opacity[1], 
      LineBox[{{0., 0.31992973665867375`}, {1., 
       0.49586459701452323`}}]}}}, {{}, {}, 
    {Hue[0.6], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.5146325857792586}, {1., 
       0.5043208462659772}}]}}}, {{}, {}, 
    {Hue[0.5], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -1.7389772857653192`}, {
       1., -2.680394572258897}}]}}}, {{}, {}, 
    {Hue[0.4], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.3700060514011758}, {1., 
       0.2568975648749441}}]}}}, {{}, {}, 
    {Hue[0.30000000000000004`], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -1.7165168121457226`}, {
       1., -0.2293963409720745}}]}}}, {{}, {}, 
    {Hue[0.2], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.372592058493197}, {1., 
       0.03972987460748367}}]}}}, {{}, {}, 
    {Hue[0.1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -0.13664143282798147`}, {
       1., -0.21152664668211196`}}]}}}, {{}, {}, 
    {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.1010113558411394}, {1., 
       1.2741950479030404`}}]}}}, {{}, {}, 
    {Hue[0.9], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.7031716594361956}, {
       1., -0.4127187338428353}}]}}}, {{}, {}, 
    {Hue[0.8], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -2.040212176564956}, {
       1., -1.2952667538439235`}}]}}}, {{}, {}, 
    {Hue[0.7000000000000001], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -1.365050470016305}, {
       1., -0.1528693876397904}}]}}}, {{}, {}, 
    {Hue[0.6], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.04227212767594857}, {1., 
       0.06422720965410722}}]}}}, {{}, {}, 
    {Hue[0.5], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.0516383494021575}, {1., 
       0.6343772101111966}}]}}}, {{}, {}, 
    {Hue[0.4], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., -1.3081229258078952`}, {
       1., -1.4467877797589574`}}]}}}, {{}, {}, 
    {Hue[0.30000000000000004`], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.9344552846862566}, {
       1., -1.0889033744520722`}}]}}}, {{}, {}, 
    {Hue[0.2], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 1.5132335571675606`}, {1., 
       1.7078643012918513`}}]}}}, {{}, {}, 
    {Hue[0.1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{0., 0.9163039229545173}, {1., -0.01816731645182923}}]}}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.459827873013823*^9, {3.460113055090554*^9, 3.460113095483087*^9}, 
   3.460113273581389*^9, {3.460113964976376*^9, 3.4601139901177692`*^9}, 
   3.460114033131361*^9, {3.460114150107635*^9, 3.460114164412263*^9}, 
   3.460114235720495*^9, 3.460114305171029*^9, {3.460120930436802*^9, 
   3.460120988296579*^9}, 3.460197819516024*^9, 3.460198382848845*^9, 
   3.4601985329563026`*^9, 3.4601995270581903`*^9, 3.460199655234778*^9, 
   3.460200501606188*^9, 3.460200601492147*^9, 3.460201879429142*^9, 
   3.460263155619897*^9, 3.460270474422586*^9, 3.460279155040721*^9, 
   3.460279214531389*^9, 3.460281725875258*^9, 3.460284359234613*^9, 
   3.4602847538095922`*^9, 3.460285737715163*^9, 3.460285990939274*^9, 
   3.4602862733933067`*^9, 3.460286308282538*^9, 3.460363898395814*^9, 
   3.460364466117779*^9, 3.4603666232531223`*^9, 3.460369743455418*^9, {
   3.460370031100134*^9, 3.460370040128583*^9}, 3.4603703425836487`*^9, {
   3.460371530559222*^9, 3.460371545091758*^9}, 3.4603715986232557`*^9, 
   3.460373545549732*^9, 3.460377044924808*^9, 3.460377179522697*^9, 
   3.460377259356626*^9, 3.460377666635418*^9, {3.4604274573851433`*^9, 
   3.4604274826315393`*^9}, 3.460431486420775*^9, 3.460431951982443*^9, 
   3.460432442105898*^9, 3.460432915923843*^9, 3.460433083188562*^9, 
   3.460433121276486*^9, 3.460434371750841*^9, 3.460434579330331*^9, 
   3.460434979549678*^9, 3.4604351320544157`*^9, 3.460437047500869*^9, 
   3.460437554166368*^9, 3.4604377000545588`*^9, 3.4604389249118958`*^9, 
   3.460439049759118*^9, 3.460439356387733*^9, 3.460439855697237*^9, 
   3.46044036838757*^9, 3.460444576617157*^9, 3.460444773535759*^9, 
   3.460444941960794*^9, 3.460444998952558*^9, 3.4604591019466887`*^9, 
   3.460459450661531*^9, 3.460460041769643*^9, 3.460460127257649*^9, 
   3.460460807831476*^9, 3.4607219385833406`*^9, 3.4607226274349327`*^9, 
   3.4607749581309834`*^9, {3.460774988718501*^9, 3.460775013027956*^9}, 
   3.46077567107047*^9, 3.460794321343745*^9, 3.4607951163861427`*^9, 
   3.460801546038229*^9, {3.460801599219322*^9, 3.460801608462143*^9}, 
   3.460801650466816*^9, {3.460802003396546*^9, 3.460802020149487*^9}, 
   3.4608020805256367`*^9, 3.460861306263372*^9, 3.460892847303982*^9, 
   3.4609458051500053`*^9, 3.460945867651103*^9, 3.460945904568042*^9, {
   3.4609527386708717`*^9, 3.4609527516956472`*^9}, 3.461035426483574*^9, 
   3.4610546000981913`*^9, 3.461055734562245*^9, 3.4610658445662527`*^9, 
   3.4612912024541187`*^9, 3.461293020050811*^9, 3.461294330431099*^9}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 1.}, {1., 0.}}]}}}, {{}, {}, 
    {Hue[0.9], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 2.}, {1., 2.}}]}}}, {{}, {}, 
    {Hue[0.8], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 1.}, {1., -1.}}]}}}, {{}, {}, 
    {Hue[0.7000000000000001], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 1.}, {1., 2.}}]}}}, {{}, {}, 
    {Hue[0.6], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 2.}, {1., 1.}}]}}}, {{}, {}, 
    {Hue[0.5], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 1.}, {1., 2.}}]}}}, {{}, {}, 
    {Hue[0.4], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 1.}, {1., 2.}}]}}}, {{}, {}, 
    {Hue[0.30000000000000004`], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 0.}, {1., 1.}}]}}}, {{}, {}, 
    {Hue[0.2], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 0.}, {1., 1.}}]}}}, {{}, {}, 
    {Hue[0.1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 1.}, {1., 0.}}]}}}, {{}, {}, 
    {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., -1.}, {1., 1.}}]}}}, {{}, {}, 
    {Hue[0.9], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 0.}, {1., 1.}}]}}}, {{}, {}, 
    {Hue[0.8], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 2.}, {1., 2.}}]}}}, {{}, {}, 
    {Hue[0.7000000000000001], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 1.}, {1., 1.}}]}}}, {{}, {}, 
    {Hue[0.6], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 1.}, {1., 1.}}]}}}, {{}, {}, 
    {Hue[0.5], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 2.}, {1., 0.}}]}}}, {{}, {}, 
    {Hue[0.4], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 2.}, {1., 2.}}]}}}, {{}, {}, 
    {Hue[0.30000000000000004`], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 0.}, {1., 0.}}]}}}, {{}, {}, 
    {Hue[0.2], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 0.}, {1., 1.}}]}}}, {{}, {}, 
    {Hue[0.1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 2.}, {1., 1.}}]}}}, {{}, {}, 
    {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 0.}, {1., -1.}}]}}}, {{}, {}, 
    {Hue[0.9], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 0.}, {1., 0.}}]}}}, {{}, {}, 
    {Hue[0.8], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 0.}, {1., 1.}}]}}}, {{}, {}, 
    {Hue[0.7000000000000001], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 1.}, {1., 1.}}]}}}, {{}, {}, 
    {Hue[0.6], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 0.}, {1., 0.}}]}}}, {{}, {}, 
    {Hue[0.5], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 1.}, {1., 2.}}]}}}, {{}, {}, 
    {Hue[0.4], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 2.}, {1., 2.}}]}}}, {{}, {}, 
    {Hue[0.30000000000000004`], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 0.}, {1., 0.}}]}}}, {{}, {}, 
    {Hue[0.2], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., -1.}, {1., 1.}}]}}}, {{}, {}, 
    {Hue[0.1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 1.}, {1., 0.}}]}}}, {{}, {}, 
    {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 0.}, {1., 0.}}]}}}, {{}, {}, 
    {Hue[0.9], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 1.}, {1., 0.}}]}}}, {{}, {}, 
    {Hue[0.8], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 1.}, {1., -1.}}]}}}, {{}, {}, 
    {Hue[0.7000000000000001], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 1.}, {1., 1.}}]}}}, {{}, {}, 
    {Hue[0.6], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 0.}, {1., 1.}}]}}}, {{}, {}, 
    {Hue[0.5], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., -1.}, {1., -1.}}]}}}, {{}, {}, 
    {Hue[0.4], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 0.}, {1., 1.}}]}}}, {{}, {}, 
    {Hue[0.30000000000000004`], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., -1.}, {1., 0.}}]}}}, {{}, {}, 
    {Hue[0.2], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 0.}, {1., 1.}}]}}}, {{}, {}, 
    {Hue[0.1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 0.}, {1., 0.}}]}}}, {{}, {}, 
    {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 1.}, {1., 2.}}]}}}, {{}, {}, 
    {Hue[0.9], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 1.}, {1., 0.}}]}}}, {{}, {}, 
    {Hue[0.8], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., -1.}, {1., -1.}}]}}}, {{}, {}, 
    {Hue[0.7000000000000001], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., -1.}, {1., 0.}}]}}}, {{}, {}, 
    {Hue[0.6], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 1.}, {1., 1.}}]}}}, {{}, {}, 
    {Hue[0.5], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 1.}, {1., 1.}}]}}}, {{}, {}, 
    {Hue[0.4], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., -1.}, {1., -1.}}]}}}, {{}, {}, 
    {Hue[0.30000000000000004`], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 1.}, {1., -1.}}]}}}, {{}, {}, 
    {Hue[0.2], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 2.}, {1., 2.}}]}}}, {{}, {}, 
    {Hue[0.1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[{{0., 1.}, {1., 0.}}]}}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.459827873013823*^9, {3.460113055090554*^9, 3.460113095483087*^9}, 
   3.460113273581389*^9, {3.460113964976376*^9, 3.4601139901177692`*^9}, 
   3.460114033131361*^9, {3.460114150107635*^9, 3.460114164412263*^9}, 
   3.460114235720495*^9, 3.460114305171029*^9, {3.460120930436802*^9, 
   3.460120988296579*^9}, 3.460197819516024*^9, 3.460198382848845*^9, 
   3.4601985329563026`*^9, 3.4601995270581903`*^9, 3.460199655234778*^9, 
   3.460200501606188*^9, 3.460200601492147*^9, 3.460201879429142*^9, 
   3.460263155619897*^9, 3.460270474422586*^9, 3.460279155040721*^9, 
   3.460279214531389*^9, 3.460281725875258*^9, 3.460284359234613*^9, 
   3.4602847538095922`*^9, 3.460285737715163*^9, 3.460285990939274*^9, 
   3.4602862733933067`*^9, 3.460286308282538*^9, 3.460363898395814*^9, 
   3.460364466117779*^9, 3.4603666232531223`*^9, 3.460369743455418*^9, {
   3.460370031100134*^9, 3.460370040128583*^9}, 3.4603703425836487`*^9, {
   3.460371530559222*^9, 3.460371545091758*^9}, 3.4603715986232557`*^9, 
   3.460373545549732*^9, 3.460377044924808*^9, 3.460377179522697*^9, 
   3.460377259356626*^9, 3.460377666635418*^9, {3.4604274573851433`*^9, 
   3.4604274826315393`*^9}, 3.460431486420775*^9, 3.460431951982443*^9, 
   3.460432442105898*^9, 3.460432915923843*^9, 3.460433083188562*^9, 
   3.460433121276486*^9, 3.460434371750841*^9, 3.460434579330331*^9, 
   3.460434979549678*^9, 3.4604351320544157`*^9, 3.460437047500869*^9, 
   3.460437554166368*^9, 3.4604377000545588`*^9, 3.4604389249118958`*^9, 
   3.460439049759118*^9, 3.460439356387733*^9, 3.460439855697237*^9, 
   3.46044036838757*^9, 3.460444576617157*^9, 3.460444773535759*^9, 
   3.460444941960794*^9, 3.460444998952558*^9, 3.4604591019466887`*^9, 
   3.460459450661531*^9, 3.460460041769643*^9, 3.460460127257649*^9, 
   3.460460807831476*^9, 3.4607219385833406`*^9, 3.4607226274349327`*^9, 
   3.4607749581309834`*^9, {3.460774988718501*^9, 3.460775013027956*^9}, 
   3.46077567107047*^9, 3.460794321343745*^9, 3.4607951163861427`*^9, 
   3.460801546038229*^9, {3.460801599219322*^9, 3.460801608462143*^9}, 
   3.460801650466816*^9, {3.460802003396546*^9, 3.460802020149487*^9}, 
   3.4608020805256367`*^9, 3.460861306263372*^9, 3.460892847303982*^9, 
   3.4609458051500053`*^9, 3.460945867651103*^9, 3.460945904568042*^9, {
   3.4609527386708717`*^9, 3.4609527516956472`*^9}, 3.461035426483574*^9, 
   3.4610546000981913`*^9, 3.461055734562245*^9, 3.4610658445662527`*^9, 
   3.4612912024541187`*^9, 3.461293020050811*^9, 3.461294330745242*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["ML-Sch\[ADoubleDot]tzung", "Subsection",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["Lik - Oberfl\[ADoubleDot]che", "Subsubsection",
 CellChangeTimes->{{3.460364529885599*^9, 3.460364541900496*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Y", "//", "Dimensions"}]], "Input",
 CellChangeTimes->{{3.460800890148888*^9, 3.460800895974749*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"50", ",", "2"}], "}"}]], "Output",
 CellChangeTimes->{3.460800896678214*^9, 3.460810789563863*^9, 
  3.4609459147313623`*^9, 3.460969132249502*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"l0", "[", "2.5", "]"}], "\[IndentingNewLine]", 
 RowBox[{"l1", "[", "2.5", "]"}]}], "Input",
 CellChangeTimes->{{3.4607223323764353`*^9, 3.460722337656382*^9}, {
   3.4607226712747793`*^9, 3.4607226714880753`*^9}, {3.460775129808877*^9, 
   3.46077512987789*^9}, {3.460795661122266*^9, 3.4607956729433813`*^9}, {
   3.460800986666732*^9, 3.460800992571142*^9}, 3.460801041156788*^9, {
   3.460810799563031*^9, 3.460810804601367*^9}, 3.46094685797864*^9, {
   3.460951773346343*^9, 3.4609517786952047`*^9}}],

Cell[BoxData[
 RowBox[{"-", "25.701618748599643`"}]], "Output",
 CellChangeTimes->{
  3.4608013073472958`*^9, 3.460801493659738*^9, 3.460801761340925*^9, 
   3.460802121542934*^9, 3.460809976789194*^9, 3.4608108079441347`*^9, 
   3.460945916124337*^9, 3.460947381013534*^9, {3.460951760636198*^9, 
   3.460951786192219*^9}, 3.4609528900531197`*^9}],

Cell[BoxData[
 RowBox[{"-", "29.839019562477006`"}]], "Output",
 CellChangeTimes->{
  3.4608013073472958`*^9, 3.460801493659738*^9, 3.460801761340925*^9, 
   3.460802121542934*^9, 3.460809976789194*^9, 3.4608108079441347`*^9, 
   3.460945916124337*^9, 3.460947381013534*^9, {3.460951760636198*^9, 
   3.460951786192219*^9}, 3.4609528957846813`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"l0i", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"l0", "[", "x", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"x0", "=", 
        RowBox[{"-", "3"}]}], ",", 
       RowBox[{"x1", "=", "3"}], ",", 
       RowBox[{"dx", "=", ".25"}]}], "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Delta", "[", "l0i", "]"}], "/", "dx"}], "//", 
   RowBox[{
    RowBox[{"AddTimeAxis", "[", 
     RowBox[{"#", ",", 
      RowBox[{"{", 
       RowBox[{"x0", ",", 
        RowBox[{"x1", "-", "dx"}], ",", "dx"}], "}"}]}], "]"}], "&"}]}], "//", 
  RowBox[{
   RowBox[{"plot1", "[", 
    RowBox[{"#", ",", 
     RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}], 
   "&"}]}]}], "Input",
 CellChangeTimes->{{3.460969744048477*^9, 3.460969818370184*^9}, {
   3.460969862379771*^9, 3.460969866872974*^9}, 3.460971006517556*^9, {
   3.460971214855465*^9, 3.460971240702218*^9}, {3.460973021199644*^9, 
   3.46097302895463*^9}, {3.460973149211418*^9, 3.46097315509932*^9}, {
   3.460973230899605*^9, 3.460973252946258*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[0, 0, 1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
    {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQAGIQDQEcBxTWt93XDjlsD+GzHcgw+7Wq4eMDKJ/lAMMi
8/crTRr3Q/hMByYITP2mufwKVJ7hQEPNYYG4bYeg/D/7HSwcJ8ufOQnl/9if
sMtzk14MzPwv+w+k7cu88X4LlP9hP8MC6eCdC5Kh5r/Yr1B1aQ2X0EEo/8F+
hgCLKkvpeVD+hf0PnsiolJdf3A/zQYPuKXlO7kMweXuFwq+KjS9uwfTbM+jv
fDqpezPMfPsFZ1pOHha7BuV/sF/QuXp1xAOY+i/2CXw2/Nw7bkL5P+wVvm1f
d+UTTP6PvcM5Pk+fr5dh9jswhG5nvWxzGxY+DgofwlaaXL4K5bM4MOzbk3O2
6SSUz+bw4Lvcs8eXLu4HAHCcgD0=
      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->True,
  PlotRange->{{-3., 2.75}, {-0.42558742101876135`, 0.5294802989389611}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.46096980554537*^9, 3.460969835431485*^9}, 
   3.460969935723399*^9, {3.4609699926474953`*^9, 3.4609700040452003`*^9}, 
   3.4609700392660313`*^9, 3.460970445823687*^9, {3.460970547616468*^9, 
   3.4609705847888803`*^9}, 3.460970622308964*^9, 3.460970720937595*^9, {
   3.460970846236952*^9, 3.460970860256824*^9}, 3.460970997606698*^9, 
   3.4609710963429956`*^9, 3.46097119407957*^9, {3.4609712297222853`*^9, 
   3.46097124949409*^9}, {3.460972974610758*^9, 3.460973007949645*^9}, {
   3.460973043216044*^9, 3.460973069225363*^9}, 3.460973151651371*^9, {
   3.460973212419733*^9, 3.460973275070609*^9}, {3.46097331739102*^9, 
   3.4609733307394257`*^9}, 3.46097351074986*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pp", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m", "=", "50"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sel", "=", 
   RowBox[{"{", "1", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l2", "=", 
   RowBox[{
    RowBox[{"IndividualLikNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Y", "[", 
         RowBox[{"[", "sel", "]"}], "]"}], ",", "X", ",", 
        RowBox[{"-", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"#", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"IdioNonlin", ",", 
        RowBox[{"{", "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<GH\>\"", ",", "m"}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular", "=", "False"}], ",", 
        RowBox[{"2", "Pi"}], " ", ",", "0", ",", "1", ",", 
        "\"\<NorKorr\>\""}], "}"}]}], "]"}], "&"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l1", "=", 
   RowBox[{
    RowBox[{"IndividualLikNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Y", "[", 
         RowBox[{"[", "sel", "]"}], "]"}], ",", "X", ",", 
        RowBox[{"-", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"#", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"IdioNonlin", ",", 
        RowBox[{"{", "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<GH\>\"", ",", "m"}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular", "=", "False"}], ",", 
        RowBox[{"2", "Pi"}], " ", ",", "0", ",", "0", ",", 
        "\"\<StochLin\>\""}], "}"}]}], "]"}], "&"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l0", "=", 
   RowBox[{
    RowBox[{"IndividualLikNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Y", "[", 
         RowBox[{"[", "sel", "]"}], "]"}], ",", "X", ",", 
        RowBox[{"-", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"#", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"IdioNonlin", ",", 
        RowBox[{"{", "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<GH\>\"", ",", "m"}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular", "=", "False"}], ",", 
        RowBox[{"2", "Pi"}], " ", ",", "0", ",", "0", ",", "\"\<NorKorr\>\"", 
        ",", ".1"}], "}"}]}], "]"}], "&"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"llin", "=", "         ", 
   RowBox[{
    RowBox[{"IndividualLik", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Y", "[", 
         RowBox[{"[", "sel", "]"}], "]"}], ",", "X", ",", 
        RowBox[{"-", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"#", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"Idio", ",", 
        RowBox[{"{", "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular", "=", "False"}], ",", 
        RowBox[{"2", "Pi"}], " ", ",", "0"}], "}"}]}], "]"}], "&"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.460364582260192*^9, 3.4603646126520233`*^9}, {
   3.46036465518178*^9, 3.460364686245573*^9}, {3.460366575620988*^9, 
   3.460366577034412*^9}, {3.460369778180625*^9, 3.460369781185903*^9}, {
   3.460369813100584*^9, 3.460369815667145*^9}, {3.460369899141048*^9, 
   3.460369901845244*^9}, {3.460370048351585*^9, 3.460370051074534*^9}, {
   3.460370210982068*^9, 3.460370313679085*^9}, {3.4603703667001543`*^9, 
   3.46037042873845*^9}, {3.460371656197792*^9, 3.460371665219153*^9}, {
   3.4603770592671013`*^9, 3.460377059329007*^9}, {3.460378198442006*^9, 
   3.460378213066311*^9}, {3.460435573037374*^9, 3.460435595252637*^9}, {
   3.460437792675404*^9, 3.46043782170634*^9}, {3.460437942682435*^9, 
   3.4604379557884283`*^9}, {3.460438031359991*^9, 3.460438033910181*^9}, {
   3.460438120088056*^9, 3.460438151233536*^9}, {3.460438297231896*^9, 
   3.460438301076235*^9}, {3.460438342395988*^9, 3.460438352382413*^9}, {
   3.460438790848688*^9, 3.460438792927885*^9}, {3.460439368962564*^9, 
   3.4604393693819513`*^9}, {3.460439888830337*^9, 3.460439923834778*^9}, {
   3.460459119343028*^9, 3.460459128428997*^9}, {3.460460010239758*^9, 
   3.460460021008594*^9}, {3.460462070763579*^9, 3.46046210747972*^9}, {
   3.46046218928576*^9, 3.460462192656451*^9}, 3.460462308980558*^9, {
   3.460462691161005*^9, 3.460462693314562*^9}, {3.4604627579016047`*^9, 
   3.4604628925310507`*^9}, {3.460722305186233*^9, 3.460722309185562*^9}, {
   3.460722368526821*^9, 3.4607223969205847`*^9}, {3.4607224312016563`*^9, 
   3.4607224323927298`*^9}, {3.460722711321816*^9, 3.460722711373019*^9}, {
   3.4607750530888033`*^9, 3.460775088314494*^9}, {3.460775120467861*^9, 
   3.460775162127316*^9}, 3.4607757020852413`*^9, {3.460775734635962*^9, 
   3.460775741929165*^9}, {3.4607757777161493`*^9, 3.460775777778207*^9}, {
   3.4607758096383142`*^9, 3.460775812088019*^9}, {3.460775870805806*^9, 
   3.460775888373221*^9}, {3.460795055640492*^9, 3.46079508216168*^9}, {
   3.460795160922982*^9, 3.460795321456018*^9}, {3.460795362107229*^9, 
   3.4607953627366257`*^9}, {3.4607963441878967`*^9, 3.460796344251252*^9}, {
   3.4608000805592823`*^9, 3.460800080643939*^9}, {3.4608001156311207`*^9, 
   3.460800116809667*^9}, {3.460800553505842*^9, 3.460800554580531*^9}, {
   3.4608007472554092`*^9, 3.460800765935514*^9}, {3.460800901633608*^9, 
   3.460800916942192*^9}, {3.460800953467207*^9, 3.46080095393979*^9}, {
   3.46080115178001*^9, 3.460801151860321*^9}, {3.460801775013801*^9, 
   3.460801790465601*^9}, {3.460809983936933*^9, 3.460809984051609*^9}, {
   3.460946877754966*^9, 3.460946883371503*^9}, 3.460951748781232*^9, {
   3.460969143911118*^9, 3.4609692097459183`*^9}, {3.46096953837211*^9, 
   3.46096953893395*^9}, {3.4609695744489813`*^9, 3.460969582937428*^9}, {
   3.460969616025275*^9, 3.460969704931069*^9}, {3.460972937976609*^9, 
   3.460972956714368*^9}, {3.460973017085511*^9, 3.460973017793929*^9}, {
   3.4609730488566027`*^9, 3.460973048968391*^9}, {3.460973216918304*^9, 
   3.460973218133788*^9}, {3.46097326521806*^9, 3.460973267145969*^9}, {
   3.460973309302885*^9, 3.460973323770534*^9}, {3.461039237969998*^9, 
   3.461039253732717*^9}, {3.4610560262420597`*^9, 3.461056053557247*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"l0", "[", "x", "]"}], ",", 
     RowBox[{"l1", "[", "x", "]"}], ",", 
     RowBox[{"l2", "[", "x", "]"}], ",", " ", 
     RowBox[{"llin", "[", "x", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "4"}], "}"}], ",", 
   RowBox[{"PlotPoints", "\[Rule]", "30"}], ",", 
   RowBox[{"MaxRecursion", "\[Rule]", "0"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.460364582260192*^9, 3.4603646126520233`*^9}, {
   3.46036465518178*^9, 3.460364686245573*^9}, {3.460366575620988*^9, 
   3.460366577034412*^9}, {3.460369778180625*^9, 3.460369781185903*^9}, {
   3.460369813100584*^9, 3.460369815667145*^9}, {3.460369899141048*^9, 
   3.460369901845244*^9}, {3.460370048351585*^9, 3.460370051074534*^9}, {
   3.460370210982068*^9, 3.460370313679085*^9}, {3.4603703667001543`*^9, 
   3.46037042873845*^9}, {3.460371656197792*^9, 3.460371665219153*^9}, {
   3.4603770592671013`*^9, 3.460377059329007*^9}, {3.460378198442006*^9, 
   3.460378213066311*^9}, {3.460435573037374*^9, 3.460435595252637*^9}, {
   3.460437792675404*^9, 3.46043782170634*^9}, {3.460437942682435*^9, 
   3.4604379557884283`*^9}, {3.460438031359991*^9, 3.460438033910181*^9}, {
   3.460438120088056*^9, 3.460438151233536*^9}, {3.460438297231896*^9, 
   3.460438301076235*^9}, {3.460438342395988*^9, 3.460438352382413*^9}, {
   3.460438790848688*^9, 3.460438792927885*^9}, {3.460439368962564*^9, 
   3.4604393693819513`*^9}, {3.460439888830337*^9, 3.460439923834778*^9}, {
   3.460459119343028*^9, 3.460459128428997*^9}, {3.460460010239758*^9, 
   3.460460021008594*^9}, {3.460462070763579*^9, 3.46046210747972*^9}, {
   3.46046218928576*^9, 3.460462192656451*^9}, 3.460462308980558*^9, {
   3.460462691161005*^9, 3.460462693314562*^9}, {3.4604627579016047`*^9, 
   3.4604628925310507`*^9}, {3.460722305186233*^9, 3.460722309185562*^9}, {
   3.460722368526821*^9, 3.4607223969205847`*^9}, {3.4607224312016563`*^9, 
   3.4607224323927298`*^9}, {3.460722711321816*^9, 3.460722711373019*^9}, {
   3.4607750530888033`*^9, 3.460775088314494*^9}, {3.460775120467861*^9, 
   3.460775162127316*^9}, 3.4607757020852413`*^9, {3.460775734635962*^9, 
   3.460775741929165*^9}, {3.4607757777161493`*^9, 3.460775777778207*^9}, {
   3.4607758096383142`*^9, 3.460775812088019*^9}, {3.460775870805806*^9, 
   3.460775888373221*^9}, {3.460795055640492*^9, 3.46079508216168*^9}, {
   3.460795160922982*^9, 3.460795321456018*^9}, {3.460795362107229*^9, 
   3.4607953627366257`*^9}, {3.4607963441878967`*^9, 3.460796344251252*^9}, {
   3.4608000805592823`*^9, 3.460800080643939*^9}, {3.4608001156311207`*^9, 
   3.460800116809667*^9}, {3.460800553505842*^9, 3.460800554580531*^9}, {
   3.4608007472554092`*^9, 3.460800765935514*^9}, {3.460800901633608*^9, 
   3.460800916942192*^9}, {3.460800953467207*^9, 3.46080095393979*^9}, {
   3.46080115178001*^9, 3.460801151860321*^9}, {3.460801775013801*^9, 
   3.460801790465601*^9}, {3.460809983936933*^9, 3.460809984051609*^9}, {
   3.460946877754966*^9, 3.460946883371503*^9}, 3.460951748781232*^9, {
   3.460969143911118*^9, 3.4609692097459183`*^9}, {3.46096953837211*^9, 
   3.46096953893395*^9}, {3.4609695744489813`*^9, 3.460969582937428*^9}, {
   3.460969616025275*^9, 3.460969704931069*^9}, {3.460972937976609*^9, 
   3.460972956714368*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwB8QEO/iFib1JlAgAAAB4AAAACAAAAIkWa3///B8BESTTUk63RP34l4naJ
JAbAjJ8mVcIv1D/WUdrCFCEEwLgAWaLkaNc/mGznmsg/AsCI3MmH6IDaP0rq
52HtZwDA4GPzl3X73z/wZzG7J9D8vzJmbtdG7+E/H9i8ysUU+b/MyRS3tx/j
P0fgqENnCfW/PnCOsb1q5D9Prnua6hDxvwhn3b0rHeU/VbLwEn656r/IiMHT
TFHlP/43q8MtseK/TG/tJ9Vk5T+c7nJJ/2LWv/QP6aK7YOU/8BKqDKq8vr/s
sK/ZlXrjP4IKNzs5icA/kLjcq8pf4j/vG7pdHyfXP/DZeStdMeA/XSkrPMqk
4z94OoS5JmPfPwO5qw1BkOs/uB7lKSfB1j+BR2zXinnxPwh7Z1T7rNE/iBqi
vvF69T8Qqbc/osnFP7sQro0HOPk/YLa4L6szsj/2blnzGUX9P4DY7ryHhJO/
qAOPPaWfAEAgz2yduOjAv2thXPWUegJAMNsJ+ssMzL8yc3n4gn0EQBCqpjg4
IM2/j5aBb0heBkBoUBf+JMfVv/xWlvecNQhAMBIjl/+l3b9ty/rK7zQKQCi4
5h6myeK/dFFKEhoSDECw1+VLDFrmv36L6aRCFw5AIMk2DclG4r8iRZrf//8P
QJC3I3T2P+S/r2f8Ww==
     "]]}, 
   {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwB8QEO/iFib1JlAgAAAB4AAAACAAAAIkWa3///B8BY6Aw/BDrQP34l4naJ
JAbACALdgjJ91D/WUdrCFCEEwBiPFQJmGNc/mGznmsg/AsCg4PyNDQDdP0rq
52HtZwDAkCtL76Uw4D/wZzG7J9D8v+qQylWe6eE/H9i8ysUU+b/CJRNy12Hj
P0fgqENnCfW/dFj9D3aW5D9Prnua6hDxvzKKLtHR9+U/VbLwEn656r8A0Pmd
BKPmP/43q8MtseK/1KWDKiac5T+c7nJJ/2LWv7yYh1GmF+Y/8BKqDKq8vr8Y
k0tC4D/kP4IKNzs5icA/XJR9KHPy4j/vG7pdHyfXPyizjEbEYuA/XSkrPMqk
4z/IP/Y04BXcPwO5qw1BkOs/MAUX0ef21z+BR2zXinnxPwDrtLV7e9E/iBqi
vvF69T9AuMNpGgvLP7sQro0HOPk/gGglRP3SwD/2blnzGUX9P4APsrlxeLK/
qAOPPaWfAECgDhAKuLnFv2thXPWUegJAULWvZe7fz78yc3n4gn0EQOhY5AZj
sdC/j5aBb0heBkCgT0ZVjN/Xv/xWlvecNQhAQEVRblcm1r9ty/rK7zQKQMA9
6dBtmt6/dFFKEhoSDEDwdYlT8lLkv36L6aRCFw5AQM99Rrww578iRZrf//8P
QOAJcdySM+e/qPD1EQ==
     "]]}, 
   {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJwB8QEO/iFib1JlAgAAAB4AAAACAAAAIkWa3///B8Aj2uW9+z36v34l4naJ
JAbAJau8fbRH+r/WUdrCFCEEwFnjT6JBZPq/mGznmsg/AsCV5lyHTwr7v0rq
52HtZwDAiSbDYso++7/wZzG7J9D8v5wSE1uHD/u/H9i8ysUU+b+RqfU2co77
v0fgqENnCfW/8kzh9m7e+79Prnua6hDxvwhiy3mjsfu/VbLwEn656r++KyKN
pIL9v/43q8MtseK/UoCK9/+//r+c7nJJ/2LWvyKpkFMsr/+/8BKqDKq8vr9F
ctQrUVkAwIIKNzs5icA/KAt3OJmqAMDvG7pdHyfXPxhHYdVTIwHAXSkrPMqk
4z/lZrkcvpsBwAO5qw1BkOs/wMrb3XsNAsCBR2zXinnxPz4lao6rwQLAiBqi
vvF69T/yuIDsnDIDwLsQro0HOPk/9MHnmrrgA8D2blnzGUX9Pxj8IWCjRwTA
qAOPPaWfAEBQ4lweK4gEwGthXPWUegJASqtEVozSBMAyc3n4gn0EQDa4gWMQ
WAXAj5aBb0heBkDy9eDzZ3cFwPxWlvecNQhA/vT8yypfBsBty/rK7zQKQIC0
BakEQwbAdFFKEhoSDEAyzhYCYkMGwH6L6aRCFw5AmlMmwL4OBsAiRZrf//8P
QIjH8SgaAgbA4AX2CQ==
     "]]}, 
   {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["
1:eJwB8QEO/iFib1JlAgAAAB4AAAACAAAAIkWa3///B8CZNrXzRZgZwH4l4naJ
JAbAgchS+klZF8DWUdrCFCEEwFsoo1A9EBXAmGznmsg/AsDkxxpr+BQTwErq
52HtZwDAh1si1vVKEcDwZzG7J9D8vzaC8F8REg/AH9i8ysUU+b8+yHdOZCcM
wEfgqENnCfW/cN7ynedoCcBPrnua6hDxvxJiqcnWJwfAVbLwEn656r/PjoA6
rnUFwP43q8MtseK/QedhsZ4TBMCc7nJJ/2LWv9kCc2vmOAPA8BKqDKq8vr+Y
tqCsrswCwIIKNzs5icA/1FR+z/bOAsDvG7pdHyfXP2XkXRtuQQPAXSkrPMqk
4z+9ZEzUIjcEwAO5qw1BkOs/6n6A07WhBcCBR2zXinnxP6Byahv2XQfAiBqi
vvF69T+uJu4wX7AJwLsQro0HOPk/nqiKeEtBDMD2blnzGUX9P5hWSEi+cw/A
qAOPPaWfAEA2aEwN734RwGthXPWUegJAEj0v3dJQE8Ayc3n4gn0EQBpqs6MQ
dhXAj5aBb0heBkC88YuyX50XwPxWlvecNQhAaA/ZGRvbGcBty/rK7zQKQM7E
knZ/axzAdFFKEhoSDEBzXr622+wewH6L6aRCFw5AWkZkxfbfIMAiRZrf//8P
QEuAseJgQSLA3YLtOg==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  Frame->True,
  PlotRange->{{-2.9999997586206897`, 
   3.9999997586206897`}, {-9.127692302863712, 0.7073996625390464}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{
  3.46096919703545*^9, 3.4609692312676697`*^9, 3.460969561998775*^9, {
   3.460969609445649*^9, 3.4609697205887117`*^9}, 3.46097295178366*^9, 
   3.460973299469364*^9, 3.460973357722184*^9, 3.4610561702310743`*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pp", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m", "=", "5"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sel", "=", 
   RowBox[{"{", "1", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l2", "=", 
   RowBox[{
    RowBox[{"IndividualLikNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Y", "[", 
         RowBox[{"[", "sel", "]"}], "]"}], ",", "X", ",", 
        RowBox[{"-", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"#", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"IdioNonlin", ",", 
        RowBox[{"{", "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<GH\>\"", ",", "m"}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular", "=", "False"}], ",", 
        RowBox[{"2", "Pi"}], " ", ",", "0", ",", "1", ",", 
        "\"\<NorKorr\>\""}], "}"}]}], "]"}], "&"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l1", "=", 
   RowBox[{
    RowBox[{"IndividualLikNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Y", "[", 
         RowBox[{"[", "sel", "]"}], "]"}], ",", "X", ",", 
        RowBox[{"-", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"#", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"IdioNonlin", ",", 
        RowBox[{"{", "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<GH\>\"", ",", "m"}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular", "=", "False"}], ",", 
        RowBox[{"2", "Pi"}], " ", ",", "0", ",", "0", ",", 
        "\"\<StochLin\>\""}], "}"}]}], "]"}], "&"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l0", "=", 
   RowBox[{
    RowBox[{"IndividualLikNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Y", "[", 
         RowBox[{"[", "sel", "]"}], "]"}], ",", "X", ",", 
        RowBox[{"-", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"#", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"IdioNonlin", ",", 
        RowBox[{"{", "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<GH\>\"", ",", "m"}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular", "=", "False"}], ",", 
        RowBox[{"2", "Pi"}], " ", ",", "0", ",", "0", ",", "\"\<NorKorr\>\"", 
        ",", ".1"}], "}"}]}], "]"}], "&"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"llin", "=", "         ", 
   RowBox[{
    RowBox[{"IndividualLik", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Y", "[", 
         RowBox[{"[", "sel", "]"}], "]"}], ",", "X", ",", 
        RowBox[{"-", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"#", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"Idio", ",", 
        RowBox[{"{", "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular", "=", "False"}], ",", 
        RowBox[{"2", "Pi"}], " ", ",", "0"}], "}"}]}], "]"}], "&"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.460364582260192*^9, 3.4603646126520233`*^9}, {
   3.46036465518178*^9, 3.460364686245573*^9}, {3.460366575620988*^9, 
   3.460366577034412*^9}, {3.460369778180625*^9, 3.460369781185903*^9}, {
   3.460369813100584*^9, 3.460369815667145*^9}, {3.460369899141048*^9, 
   3.460369901845244*^9}, {3.460370048351585*^9, 3.460370051074534*^9}, {
   3.460370210982068*^9, 3.460370313679085*^9}, {3.4603703667001543`*^9, 
   3.46037042873845*^9}, {3.460371656197792*^9, 3.460371665219153*^9}, {
   3.4603770592671013`*^9, 3.460377059329007*^9}, {3.460378198442006*^9, 
   3.460378213066311*^9}, {3.460435573037374*^9, 3.460435595252637*^9}, {
   3.460437792675404*^9, 3.46043782170634*^9}, {3.460437942682435*^9, 
   3.4604379557884283`*^9}, {3.460438031359991*^9, 3.460438033910181*^9}, {
   3.460438120088056*^9, 3.460438151233536*^9}, {3.460438297231896*^9, 
   3.460438301076235*^9}, {3.460438342395988*^9, 3.460438352382413*^9}, {
   3.460438790848688*^9, 3.460438792927885*^9}, {3.460439368962564*^9, 
   3.4604393693819513`*^9}, {3.460439888830337*^9, 3.460439923834778*^9}, {
   3.460459119343028*^9, 3.460459128428997*^9}, {3.460460010239758*^9, 
   3.460460021008594*^9}, {3.460462070763579*^9, 3.46046210747972*^9}, {
   3.46046218928576*^9, 3.460462192656451*^9}, 3.460462308980558*^9, {
   3.460462691161005*^9, 3.460462693314562*^9}, {3.4604627579016047`*^9, 
   3.4604628925310507`*^9}, {3.460722305186233*^9, 3.460722309185562*^9}, {
   3.460722368526821*^9, 3.4607223969205847`*^9}, {3.4607224312016563`*^9, 
   3.4607224323927298`*^9}, {3.460722711321816*^9, 3.460722711373019*^9}, {
   3.4607750530888033`*^9, 3.460775088314494*^9}, {3.460775120467861*^9, 
   3.460775162127316*^9}, 3.4607757020852413`*^9, {3.460775734635962*^9, 
   3.460775741929165*^9}, {3.4607757777161493`*^9, 3.460775777778207*^9}, {
   3.4607758096383142`*^9, 3.460775812088019*^9}, {3.460775870805806*^9, 
   3.460775888373221*^9}, {3.460795055640492*^9, 3.46079508216168*^9}, {
   3.460795160922982*^9, 3.460795321456018*^9}, {3.460795362107229*^9, 
   3.4607953627366257`*^9}, {3.4607963441878967`*^9, 3.460796344251252*^9}, {
   3.4608000805592823`*^9, 3.460800080643939*^9}, {3.4608001156311207`*^9, 
   3.460800116809667*^9}, {3.460800553505842*^9, 3.460800554580531*^9}, {
   3.4608007472554092`*^9, 3.460800765935514*^9}, {3.460800901633608*^9, 
   3.460800916942192*^9}, {3.460800953467207*^9, 3.46080095393979*^9}, {
   3.46080115178001*^9, 3.460801151860321*^9}, {3.460801775013801*^9, 
   3.460801790465601*^9}, {3.460809983936933*^9, 3.460809984051609*^9}, {
   3.460946877754966*^9, 3.460946883371503*^9}, 3.460951748781232*^9, {
   3.460969143911118*^9, 3.4609692097459183`*^9}, {3.46096953837211*^9, 
   3.46096953893395*^9}, {3.4609695744489813`*^9, 3.460969582937428*^9}, {
   3.460969616025275*^9, 3.460969704931069*^9}, {3.460972937976609*^9, 
   3.460972956714368*^9}, {3.460973017085511*^9, 3.460973017793929*^9}, {
   3.4609730488566027`*^9, 3.460973048968391*^9}, {3.460973216918304*^9, 
   3.460973218133788*^9}, {3.46097326521806*^9, 3.460973267145969*^9}, {
   3.460973309302885*^9, 3.460973323770534*^9}, {3.461039237969998*^9, 
   3.461039253732717*^9}, {3.4610560262420597`*^9, 3.461056053557247*^9}, 
   3.4610560910881147`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"l0", "[", "x", "]"}], ",", 
      RowBox[{"l1", "[", "x", "]"}], ",", 
      RowBox[{"l2", "[", "x", "]"}], ",", " ", 
      RowBox[{"llin", "[", "x", "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", 
      RowBox[{"-", "3"}], ",", "4"}], "}"}], ",", 
    RowBox[{"PlotPoints", "\[Rule]", "30"}], ",", 
    RowBox[{"MaxRecursion", "\[Rule]", "0"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.460364582260192*^9, 3.4603646126520233`*^9}, {
   3.46036465518178*^9, 3.460364686245573*^9}, {3.460366575620988*^9, 
   3.460366577034412*^9}, {3.460369778180625*^9, 3.460369781185903*^9}, {
   3.460369813100584*^9, 3.460369815667145*^9}, {3.460369899141048*^9, 
   3.460369901845244*^9}, {3.460370048351585*^9, 3.460370051074534*^9}, {
   3.460370210982068*^9, 3.460370313679085*^9}, {3.4603703667001543`*^9, 
   3.46037042873845*^9}, {3.460371656197792*^9, 3.460371665219153*^9}, {
   3.4603770592671013`*^9, 3.460377059329007*^9}, {3.460378198442006*^9, 
   3.460378213066311*^9}, {3.460435573037374*^9, 3.460435595252637*^9}, {
   3.460437792675404*^9, 3.46043782170634*^9}, {3.460437942682435*^9, 
   3.4604379557884283`*^9}, {3.460438031359991*^9, 3.460438033910181*^9}, {
   3.460438120088056*^9, 3.460438151233536*^9}, {3.460438297231896*^9, 
   3.460438301076235*^9}, {3.460438342395988*^9, 3.460438352382413*^9}, {
   3.460438790848688*^9, 3.460438792927885*^9}, {3.460439368962564*^9, 
   3.4604393693819513`*^9}, {3.460439888830337*^9, 3.460439923834778*^9}, {
   3.460459119343028*^9, 3.460459128428997*^9}, {3.460460010239758*^9, 
   3.460460021008594*^9}, {3.460462070763579*^9, 3.46046210747972*^9}, {
   3.46046218928576*^9, 3.460462192656451*^9}, 3.460462308980558*^9, {
   3.460462691161005*^9, 3.460462693314562*^9}, {3.4604627579016047`*^9, 
   3.4604628925310507`*^9}, {3.460722305186233*^9, 3.460722309185562*^9}, {
   3.460722368526821*^9, 3.4607223969205847`*^9}, {3.4607224312016563`*^9, 
   3.4607224323927298`*^9}, {3.460722711321816*^9, 3.460722711373019*^9}, {
   3.4607750530888033`*^9, 3.460775088314494*^9}, {3.460775120467861*^9, 
   3.460775162127316*^9}, 3.4607757020852413`*^9, {3.460775734635962*^9, 
   3.460775741929165*^9}, {3.4607757777161493`*^9, 3.460775777778207*^9}, {
   3.4607758096383142`*^9, 3.460775812088019*^9}, {3.460775870805806*^9, 
   3.460775888373221*^9}, {3.460795055640492*^9, 3.46079508216168*^9}, {
   3.460795160922982*^9, 3.460795321456018*^9}, {3.460795362107229*^9, 
   3.4607953627366257`*^9}, {3.4607963441878967`*^9, 3.460796344251252*^9}, {
   3.4608000805592823`*^9, 3.460800080643939*^9}, {3.4608001156311207`*^9, 
   3.460800116809667*^9}, {3.460800553505842*^9, 3.460800554580531*^9}, {
   3.4608007472554092`*^9, 3.460800765935514*^9}, {3.460800901633608*^9, 
   3.460800916942192*^9}, {3.460800953467207*^9, 3.46080095393979*^9}, {
   3.46080115178001*^9, 3.460801151860321*^9}, {3.460801775013801*^9, 
   3.460801790465601*^9}, {3.460809983936933*^9, 3.460809984051609*^9}, {
   3.460946877754966*^9, 3.460946883371503*^9}, 3.460951748781232*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwB8QEO/iFib1JlAgAAAB4AAAACAAAAIkWa3///B8AaNqXWvCbsv34l4naJ
JAbA8nXKtoNr7L/WUdrCFCEEwGRVYs+XNt+/mGznmsg/AsAwTW8Kp6LDv0rq
52HtZwDAYJxK4Vmaqb/wZzG7J9D8v8AIoN7tTJg/H9i8ysUU+b94A3JtLEjP
v0fgqENnCfW/4IeGdktuvD9Prnua6hDxv5iozOzaA88/VbLwEn656r+gI43N
BLrQP/43q8MtseK/oNwNf/6huT+c7nJJ/2LWv6CKvDuFQcE/8BKqDKq8vr9A
RXckN1Otv4IKNzs5icA/QDYiAOpSr7/vG7pdHyfXP+Bscf3tN7u/XSkrPMqk
4z8kL3hdp4PSvwO5qw1BkOs/kEtO2ZsJ0b+BR2zXinnxP+CJ+cnWU92/iBqi
vvF69T8wv4C/ecPhv7sQro0HOPk/wLfprM3U67/2blnzGUX9P/ahCjue9PG/
qAOPPaWfAECcfX2WG2rzv2thXPWUegJAic+QS6fo+L8yc3n4gn0EQDZzd3HK
uPi/j5aBb0heBkDAeTWA3OT4v/xWlvecNQhAE+bmbR0YA8Bty/rK7zQKQIyx
+/EaHATAdFFKEhoSDEDBsfvxGhwEwH6L6aRCFw5A9z0bvXNmBcAiRZrf//8P
QDv52Az85AvAF7X/Pg==
     "]]}, 
   {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwB4QEe/iFib1JlAgAAAB0AAAACAAAAHXDNlCxgBMAgaYs4Vg4gwNZR2sIU
IQTA6pvB3bbAAcCYbOeayD8CwA4A+On+9/q/SurnYe1nAMCcb16sVRL0v/Bn
Mbsn0Py/eJML9blS478f2LzKxRT5v45rAlwckeq/R+CoQ2cJ9b/AYK2KVeHc
v0+ue5rqEPG/4FbbwU5w0L9VsvASfrnqv8BznjNZoKG//jerwy2x4r8gFHTe
GUGiv5zuckn/Yta/YJrNalQsqL/wEqoMqry+vxCy3wSL4Mm/ggo3OzmJwD+E
Nl44oODRv+8bul0fJ9c/OCwuEkUd0L9dKSs8yqTjP0zXyZO4QuK/A7mrDUGQ
6z/Qu9Y/06jcv4FHbNeKefE/gGpDumX74b+IGqK+8Xr1P0grh51KPem/uxCu
jQc4+T/a+oF8r4Pwv/ZuWfMZRf0/bB9hN20c7r+oA489pZ8AQD4gHdho2/W/
a2Fc9ZR6AkBV7IiOVmv4vzJzefiCfQRAX7ymaIj6+r+PloFvSF4GQCjWdemJ
rwDA/FaW95w1CECYKPoyY2ACwG3L+srvNApACd2xoNVpBsB0UUoSGhIMQOon
Ct7gkwjAfovppEIXDkCkJwre4JMIwCJFmt///w9AM0MjYGBzEMDq7fHV
     "]]}, 
   {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQA2IQreQ66/7//+wHeLh9evc9+re/TvVRWacK24GCaUJG
Z9/+238t8NYhEUWWA4VQ/oyc57NO2DPB5b1ePU98m85woDO8ujlA4v/+D+mG
u9Uv/NnfCuXL39hz6qjIz/1ewQeiOI7+3+/+YIVzOufX/Qbdhw/2MDEc8F9X
PeuVwEc4P3TTB6G6na/2n115zfBeOeOBf+arD+tufLQ/biYvX+09hgNz3hV5
/k+6tv/67rz23JsMBz4IreJZtWff/iyDt79seJgONHGZW1t2HrDfOGGCu+BS
pgPvpXfFyqtftz9yRbZapIzpQKymts2pJY/tkwtTFPOrmA4w71zN6zjhtf2M
eda/VgawHGh0z7neVfnRXr6n+PAiV9YDHVKL9n2s+grn7xZY18tu8dP+XzmX
3+J41gPf8iI/S7r+tT+kqJ6hd4PtwArmftul8xkcDkP52YkxX6dUMTmsCPZ3
Fv3HdsCouPJHUy2LwzIov39aY75HHJvDcij/T9i073NMORz2hr4+9kuM/UDu
6V+n3ptwORyA8ksCvYSkhHgcdkP5dd0vlziJ8znsgfIh8ckPlwcAuejvng==

     "]]}, 
   {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["
1:eJwB4QEe/iFib1JlAgAAAB0AAAACAAAAIkWa3///B8CZNrXzRZgZwH4l4naJ
JAbAgchS+klZF8DWUdrCFCEEwFsoo1A9EBXAmGznmsg/AsDkxxpr+BQTwErq
52HtZwDAh1si1vVKEcDwZzG7J9D8vzaC8F8REg/AH9i8ysUU+b8+yHdOZCcM
wEfgqENnCfW/cN7ynedoCcBPrnua6hDxvxJiqcnWJwfAVbLwEn656r/PjoA6
rnUFwP43q8MtseK/QedhsZ4TBMCc7nJJ/2LWv9kCc2vmOAPA8BKqDKq8vr+Y
tqCsrswCwIIKNzs5icA/1FR+z/bOAsDvG7pdHyfXP2XkXRtuQQPAXSkrPMqk
4z+9ZEzUIjcEwAO5qw1BkOs/6n6A07WhBcCBR2zXinnxP6Byahv2XQfAiBqi
vvF69T+uJu4wX7AJwLsQro0HOPk/nqiKeEtBDMD2blnzGUX9P5hWSEi+cw/A
qAOPPaWfAEA2aEwN734RwGthXPWUegJAEj0v3dJQE8Ayc3n4gn0EQBpqs6MQ
dhXAj5aBb0heBkC88YuyX50XwPxWlvecNQhAaA/ZGRvbGcBty/rK7zQKQM7E
knZ/axzAdFFKEhoSDEBzXr622+wewCGtHgpm6wxAIGmLOFYOIMAvFeKT
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  Frame->True,
  ImageSize->{368., Automatic},
  PlotRange->{{-2.9999997586206897`, 
   3.9999997586206897`}, {-8.028001563089276, 0.2613536841714055}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{
  3.4603646404762897`*^9, 3.460364699141284*^9, {3.4603665639353447`*^9, 
   3.460366581063609*^9}, 3.460366633087812*^9, {3.460369659325509*^9, 
   3.460369665763332*^9}, 3.460369753864559*^9, 3.460369793388811*^9, 
   3.460369836877985*^9, 3.4603699414758453`*^9, 3.460370068395872*^9, 
   3.4603701665431347`*^9, {3.460370200393096*^9, 3.460370433322517*^9}, 
   3.460371569389784*^9, 3.460371630508395*^9, 3.4603716899665337`*^9, 
   3.460373567149763*^9, 3.460377060868331*^9, 3.4603771844497547`*^9, 
   3.4603772624878073`*^9, 3.460377669576057*^9, {3.460378194693892*^9, 
   3.4603782209413853`*^9}, 3.460431915408856*^9, 3.460431970723423*^9, 
   3.460432459979088*^9, 3.460432933635795*^9, 3.460434602602409*^9, 
   3.460435024282065*^9, 3.460435173021772*^9, 3.460435614824098*^9, 
   3.460437075408433*^9, 3.4604375668411837`*^9, 3.460437764211752*^9, 
   3.460438003600037*^9, 3.4604380498120193`*^9, 3.4604381267513323`*^9, 
   3.4604381572691717`*^9, 3.4604383035716963`*^9, 3.460438368055724*^9, 
   3.460438890192803*^9, 3.460438928779546*^9, 3.4604390596546497`*^9, 
   3.460439326285445*^9, {3.4604393591643133`*^9, 3.46043937775913*^9}, {
   3.460439876738007*^9, 3.460439937461564*^9}, 3.460440432214779*^9, 
   3.460441801623301*^9, {3.460459115956283*^9, 3.460459131804435*^9}, 
   3.460459457197721*^9, {3.4604600052420063`*^9, 3.460460050251873*^9}, 
   3.460460136725589*^9, {3.460462096012589*^9, 3.4604621177314463`*^9}, 
   3.460462195669779*^9, 3.460462312739161*^9, {3.4604628192627077`*^9, 
   3.4604629007734118`*^9}, 3.460721958185533*^9, 3.4607222745794353`*^9, 
   3.4607223270755167`*^9, 3.460722682802968*^9, 3.4607227524302464`*^9, 
   3.460775037533073*^9, {3.460775069089115*^9, 3.460775095398562*^9}, {
   3.460775149470006*^9, 3.460775166398638*^9}, {3.460775680639656*^9, 
   3.460775707725068*^9}, {3.460775747152223*^9, 3.46077578147184*^9}, {
   3.460775825052527*^9, 3.460775892090784*^9}, 3.460794334408423*^9, {
   3.460795060288437*^9, 3.460795087336123*^9}, 3.460795126636435*^9, {
   3.4607951722227983`*^9, 3.460795325836775*^9}, 3.4607953673125277`*^9, 
   3.460795650330174*^9, 3.460795881185608*^9, {3.460796289272408*^9, 
   3.460796313227943*^9}, 3.460796353233102*^9, {3.4608000618575363`*^9, 
   3.460800091835527*^9}, 3.460800132023862*^9, 3.460800573281756*^9, 
   3.460800753834125*^9, 3.460800813418141*^9, {3.460800909499584*^9, 
   3.460800928931656*^9}, 3.4608009793519773`*^9, 3.460801163467443*^9, 
   3.460801748373828*^9, 3.460801784754333*^9, 3.460801818200878*^9, 
   3.4608021129330597`*^9, 3.460809956086197*^9, 3.4608102613999*^9, 
   3.4609473623861322`*^9, 3.460953381142844*^9, 3.461056095468404*^9, 
   3.461056188393263*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndividualLikNonlin", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Y", "[", 
      RowBox[{"[", 
       RowBox[{"{", "3", "}"}], "]"}], "]"}], ",", "X", ",", 
     RowBox[{"-", "9"}]}], "}"}], ",", 
   RowBox[{"{", "1", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"IdioNonlin", ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0", ",", "0", ",", "\"\<NorKorr\>\""}], 
    "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.461035454557763*^9, 3.461035454660483*^9}, {
   3.461035488085019*^9, 3.461035507970089*^9}, {3.4610355721180468`*^9, 
   3.461035577583662*^9}, 3.461035621686838*^9, 3.46103567892127*^9, {
   3.461035721634898*^9, 3.4610357378007593`*^9}, {3.461036961058715*^9, 
   3.461036962176406*^9}, {3.461037027012232*^9, 3.461037027064383*^9}, {
   3.461037143810234*^9, 3.461037144202977*^9}, {3.4610371745189037`*^9, 
   3.461037189184057*^9}, {3.461037349210842*^9, 3.4610374512637043`*^9}, {
   3.461037586830924*^9, 3.4610375872131243`*^9}, {3.461037933719467*^9, 
   3.461037933784464*^9}, {3.46103798231667*^9, 3.461037982397069*^9}, {
   3.461038458321086*^9, 3.46103848562219*^9}, {3.461038911295075*^9, 
   3.461038929044546*^9}, {3.461039083577558*^9, 3.4610390859989443`*^9}, {
   3.4610391987004766`*^9, 3.4610392010137987`*^9}, {3.461039415243691*^9, 
   3.461039446842757*^9}}],

Cell[BoxData[
 RowBox[{"-", "1.5985473543823936`"}]], "Output",
 CellChangeTimes->{{3.461035455614449*^9, 3.461035469991006*^9}, {
   3.461035510287184*^9, 3.461035533962076*^9}, 3.4610355790002604`*^9, 
   3.461035622971611*^9, {3.4610357006318417`*^9, 3.461035768460207*^9}, {
   3.461036945329123*^9, 3.461036969788712*^9}, {3.461037012406774*^9, 
   3.461037028335753*^9}, {3.461037146016808*^9, 3.461037190513838*^9}, {
   3.461037279992125*^9, 3.461037308183259*^9}, {3.461037344979973*^9, 
   3.46103745227855*^9}, {3.4610375614255667`*^9, 3.461037587763915*^9}, 
   3.461037935039178*^9, 3.461037983507843*^9, {3.461038478013857*^9, 
   3.4610384873588533`*^9}, {3.461038902424851*^9, 3.461038930950993*^9}, 
   3.461039086936294*^9, 3.46103920215958*^9, {3.461039411325618*^9, 
   3.461039448347226*^9}, 3.461056129131509*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pp", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sel", "=", 
   RowBox[{"n", "//", "Range"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l2", "=", 
   RowBox[{
    RowBox[{"IndividualLikNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Y", "[", 
         RowBox[{"[", "sel", "]"}], "]"}], ",", "X", ",", 
        RowBox[{"-", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"#", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"IdioNonlin", ",", 
        RowBox[{"{", "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<UT\>\"", ",", "m"}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular", "=", "False"}], ",", 
        RowBox[{"2", "Pi"}], " ", ",", "0", ",", "1", ",", 
        "\"\<NorKorr\>\""}], "}"}]}], "]"}], "&"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l1", "=", 
   RowBox[{
    RowBox[{"IndividualLikNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Y", "[", 
         RowBox[{"[", "sel", "]"}], "]"}], ",", "X", ",", 
        RowBox[{"-", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"#", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"IdioNonlin", ",", 
        RowBox[{"{", "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<UT\>\"", ",", "m"}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular", "=", "False"}], ",", 
        RowBox[{"2", "Pi"}], " ", ",", "0", ",", "0", ",", 
        "\"\<StochLin\>\""}], "}"}]}], "]"}], "&"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"l0", "=", 
   RowBox[{
    RowBox[{"IndividualLikNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Y", "[", 
         RowBox[{"[", "sel", "]"}], "]"}], ",", "X", ",", 
        RowBox[{"-", "9"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"#", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"IdioNonlin", ",", 
        RowBox[{"{", "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<UT\>\"", ",", "m"}], "}"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular", "=", "False"}], ",", 
        RowBox[{"2", "Pi"}], " ", ",", "0", ",", "0", ",", "\"\<NorKorr\>\"", 
        ",", ".1"}], "}"}]}], "]"}], "&"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"llin", "=", "         ", 
    RowBox[{
     RowBox[{"IndividualLik", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Y", "[", 
          RowBox[{"[", "sel", "]"}], "]"}], ",", "X", ",", 
         RowBox[{"-", "9"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"#", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"Idio", ",", 
         RowBox[{"{", "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", "=", "False"}], ",", 
         RowBox[{"2", "Pi"}], " ", ",", "0"}], "}"}]}], "]"}], "&"}]}], ";"}],
   "\n"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"l0", "[", "x", "]"}], ",", 
     RowBox[{"l1", "[", "x", "]"}], ",", 
     RowBox[{"l2", "[", "x", "]"}], ",", " ", 
     RowBox[{"llin", "[", "x", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "4"}], "}"}], ",", 
   RowBox[{"PlotPoints", "\[Rule]", "30"}], ",", 
   RowBox[{"MaxRecursion", "\[Rule]", "0"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.460364582260192*^9, 3.4603646126520233`*^9}, {
   3.46036465518178*^9, 3.460364686245573*^9}, {3.460366575620988*^9, 
   3.460366577034412*^9}, {3.460369778180625*^9, 3.460369781185903*^9}, {
   3.460369813100584*^9, 3.460369815667145*^9}, {3.460369899141048*^9, 
   3.460369901845244*^9}, {3.460370048351585*^9, 3.460370051074534*^9}, {
   3.460370210982068*^9, 3.460370313679085*^9}, {3.4603703667001543`*^9, 
   3.46037042873845*^9}, {3.460371656197792*^9, 3.460371665219153*^9}, {
   3.4603770592671013`*^9, 3.460377059329007*^9}, {3.460378198442006*^9, 
   3.460378213066311*^9}, {3.460435573037374*^9, 3.460435595252637*^9}, {
   3.460437792675404*^9, 3.46043782170634*^9}, {3.460437942682435*^9, 
   3.4604379557884283`*^9}, {3.460438031359991*^9, 3.460438033910181*^9}, {
   3.460438120088056*^9, 3.460438151233536*^9}, {3.460438297231896*^9, 
   3.460438301076235*^9}, {3.460438342395988*^9, 3.460438352382413*^9}, {
   3.460438790848688*^9, 3.460438792927885*^9}, {3.460439368962564*^9, 
   3.4604393693819513`*^9}, {3.460439888830337*^9, 3.460439923834778*^9}, {
   3.460459119343028*^9, 3.460459128428997*^9}, {3.460460010239758*^9, 
   3.460460021008594*^9}, {3.460462070763579*^9, 3.46046210747972*^9}, {
   3.46046218928576*^9, 3.460462192656451*^9}, 3.460462308980558*^9, {
   3.460462691161005*^9, 3.460462693314562*^9}, {3.4604627579016047`*^9, 
   3.4604628925310507`*^9}, {3.460722305186233*^9, 3.460722309185562*^9}, {
   3.460722368526821*^9, 3.4607223969205847`*^9}, {3.4607224312016563`*^9, 
   3.4607224323927298`*^9}, {3.460722711321816*^9, 3.460722711373019*^9}, {
   3.4607750530888033`*^9, 3.460775088314494*^9}, {3.460775120467861*^9, 
   3.460775162127316*^9}, 3.4607757020852413`*^9, {3.460775734635962*^9, 
   3.460775741929165*^9}, {3.4607757777161493`*^9, 3.460775777778207*^9}, {
   3.4607758096383142`*^9, 3.460775812088019*^9}, {3.460775870805806*^9, 
   3.460775888373221*^9}, {3.460795055640492*^9, 3.46079508216168*^9}, {
   3.460795160922982*^9, 3.460795321456018*^9}, {3.460795362107229*^9, 
   3.4607953627366257`*^9}, {3.4607963441878967`*^9, 3.460796344251252*^9}, {
   3.4608000805592823`*^9, 3.460800080643939*^9}, {3.4608001156311207`*^9, 
   3.460800116809667*^9}, {3.460800553505842*^9, 3.460800554580531*^9}, {
   3.4608007472554092`*^9, 3.460800765935514*^9}, {3.460800901633608*^9, 
   3.460800916942192*^9}, {3.460800953467207*^9, 3.46080095393979*^9}, {
   3.46080115178001*^9, 3.460801151860321*^9}, {3.460801775013801*^9, 
   3.460801790465601*^9}, {3.460809983936933*^9, 3.460809984051609*^9}, {
   3.460946877754966*^9, 3.460946883371503*^9}, 3.460951748781232*^9, {
   3.460969143911118*^9, 3.4609692097459183`*^9}, {3.46096953837211*^9, 
   3.46096953893395*^9}, {3.4609695744489813`*^9, 3.460969582937428*^9}, {
   3.460969616025275*^9, 3.460969704931069*^9}, {3.460972937976609*^9, 
   3.460972956714368*^9}, {3.460973017085511*^9, 3.460973017793929*^9}, {
   3.4609730488566027`*^9, 3.460973048968391*^9}, {3.460973216918304*^9, 
   3.460973218133788*^9}, {3.46097326521806*^9, 3.460973267145969*^9}, {
   3.460973309302885*^9, 3.460973323770534*^9}, {3.461039237969998*^9, 
   3.461039253732717*^9}, {3.4610560262420597`*^9, 3.461056053557247*^9}, 
   3.4610560910881147`*^9, {3.461056252944471*^9, 3.461056279475284*^9}, {
   3.46105644221879*^9, 3.461056467526144*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQA2IQreQ66/7//+wHsnhD/5h83XGgTvVRWacK24EEKP9a
4K1DIoosB4pAfNWNB2bkPJ91wp7pQAGU7/XqeeLbdIYDa/K2fHOcvfjAh3TD
3eoX/uzfz+hdt/dH3wH5G3tOHRX5ud8he8Wj5S/7Drg/WOGczvl1/7bY7k2P
J+Uf8F9XPeuVwMf9K9Yu7Jr/LPdA6KYPQnU7X+2fAOX/M199WHfjo/0aT5r3
eAVlHZjzrsjzf9K1/UJQ/gehVTyr9uyD85u4zK0tOw/Yxz0Kr9h9PuPAe+ld
sfLq1+H8WE1tm1NLHsP5zDtX8zpOeG3vlhZ7fU1i5oFG95zrXZUf7eWh/A6p
Rfs+Vn21//ZUNSxrYeaB3QLretktfto3R143zfZoPPAtL/KzpOtf+7ZCF45L
EY0HVjD32y6dz+Cw9/pZRTfvSQeyE2O+Tqlicki4VnpWSmvxAaPiyh9NtSwO
WVB+/7TGfI84Noc0KP9P2LTvc0w5HPyg/NzTv069N+FyiIHySwK9hKSEeBwi
oPy67pdLnMT5HAKgfEh88juUXuMP32a6+AAACgT6oQ==
     "]]}, 
   {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQA2IQreQ66/7//+wHzDZ0ln2q23GgTvVRWacK24ET8tnf
L2/ecOBa4K1DIoosB3ojHturcK85MCPn+awT9kwHAtzL+TMilh/wevU88W06
w4GL5mwBSjI9Bz6kG+5Wv/Bnf+22j7/ip3cfkL+x59RRkZ/71zX6bpls3n3A
/cEK53TOr/sd9a6X705NPOC/rnrWK4GP+yt5cxbNtYk7ELrpg1Ddzlf7a6D8
f+arD+tufLR/ybYan3/HIw7MeVfk+T/p2v6KfX9XtW4LP/BBaBXPqj379ldC
+U1c5taWnQfse7hyFws1hB54L70rVl79uv2h6Y+kEq+HHIjV1LY5teSxvdJM
t3JGsdADzDtX8zpOeG3/QHG7mO+F0AON7jnXuyo/2j+E8jukFu37WPXV/tu5
f7yVD8IO7BZY18tu8dO+4sRaV+GQ6gPf8iI/S7r+tX+x80r8Z46aAyuY+22X
zmdwqLvfVJm7tOZAdmLM1ylVTA6Wq0Pvms6ccMCouPJHUy2Lw9G1tmL3U2Yf
6J/WmO8Rx+bAt3NrRpPTogN/wqZ9n2PK4cAP5eee/nXqvQkXnF8S6CUkJcTj
UKXQJibjtehAXffLJU7ifA41UD4kPvkdbKf/ypaLXHQAAKB/9VM=
     "]]}, 
   {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQA2IQreQ66/7//+wH1JV25PStSz1Qp/qorFOF7YAWlH8t
8NYhEUUWuPyMnOezTtgzwfler54nvk1ngPM/pBvuVr/wZ78GlC9/Y8+poyI/
96tB+e4PVjinc37dD1Pvv6561iuBj3B+6KYPQnU7X8H5/8xXH9bd+Gh/9vtc
TQm9pANz3hV5/k+6Bud/EFrFs2rPPji/icvc2rLzgL1Nm6tx94aEA++ld8XK
q1+H82M1tW1OLXkM5zPvXM3rOOG1vfHV8x3b7BIPNLrnXO+q/Ajnd0gt2vex
6iucv1tgXS+7xU97Eyj/W17kZ0nXv3D+CuZ+26XzGRxMofzsxJivU6qYHGDy
RsWVP5pqWeDy/dMa8z3i2Bxg5v8Jm/Z9jikHXH3u6V+n3ptwwfklgV5CUkI8
cH5d98slTuJ8cD4kPvnhfAAoW/J9
     "]]}, 
   {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["
1:eJwB8QEO/iFib1JlAgAAAB4AAAACAAAAIkWa3///B8DmjERoaMx+wH4l4naJ
JAbAYJbAvFlUfMDWUdrCFCEEwFvlRSZbxXnAmGznmsg/AsCmzu4XJYF3wErq
52HtZwDA5vcqwXZodcDwZzG7J9D8v0k/P+o6SXPAH9i8ysUU+b8EBZKwbHVx
wEfgqENnCfW/ClIExNRPb8BPrnua6hDxv+/9wwe+JmzAVbLwEn656r/xa+ct
zo5pwP43q8MtseK/dx33aq8lZ8Cc7nJJ/2LWv9tjfUwLSWXA8BKqDKq8vr89
qxtvKNVjwIIKNzs5icA/UEOI8yiuYsDvG7pdHyfXPzgCCeuoAWLAXSkrPMqk
4z/47B8V+rZhwAO5qw1BkOs/yqSXHcTeYcCBR2zXinnxPysqwgS1Z2LAiBqi
vvF69T8uvOKPLGdjwLsQro0HOPk/PMku5JO3ZMD2blnzGUX9P4wDnG91i2bA
qAOPPaWfAECQUPtpXbtowGthXPWUegJAOLZ9UnEba8Ayc3n4gn0EQN9xhoVY
B27Aj5aBb0heBkCbrHV7AohwwPxWlvecNQhAPJnBxBEncsBty/rK7zQKQOD2
Oa4HDXTAdFFKEhoSDEBXCCcpW/F1wH6L6aRCFw5ALUJ+y9gceMAiRZrf//8P
QF4Thz4rRHrALkzwYw==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  Frame->True,
  PlotRange->{{-2.9999997586206897`, 
   3.9999997586206897`}, {-6389.206975284362, 0.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.461037577920278*^9, 3.4610376079134293`*^9}, {
   3.4610380028135557`*^9, 3.46103801954325*^9}, {3.461038054802126*^9, 
   3.461038085386179*^9}, 3.461038160247623*^9, 3.461039006848875*^9, 
   3.461039473076496*^9, {3.461055951932453*^9, 3.4610559780656548`*^9}, {
   3.4610562656928253`*^9, 3.461056283449112*^9}, {3.461056450202409*^9, 
   3.4610564738470087`*^9}},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["ML", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[{"Theta", "\[IndentingNewLine]", "Y"}], "Input",
 CellChangeTimes->{{3.460427516601119*^9, 3.460427517953906*^9}, {
   3.4604302860648613`*^9, 3.460430286459763*^9}, 3.4604320351169157`*^9, {
   3.460459207514338*^9, 3.460459209125545*^9}, {3.4608083350507927`*^9, 
   3.460808343160981*^9}, {3.4608930848269987`*^9, 3.460893084962487*^9}, {
   3.460952690730555*^9, 3.460952703375231*^9}, {3.4609527668944283`*^9, 
   3.460952768427286*^9}}],

Cell[BoxData[
 RowBox[{"{", "0.5`", "}"}]], "Output",
 CellChangeTimes->{{3.460444788235248*^9, 3.460444817682623*^9}, 
   3.4604450103485413`*^9, 3.460459143269252*^9, 3.4604592096793203`*^9, 
   3.460459927811483*^9, 3.46046040805451*^9, 3.460461792764674*^9, 
   3.460722834150064*^9, 3.460775197926738*^9, 3.460800148785144*^9, 
   3.4608018347272587`*^9, 3.460802129040563*^9, 3.460808343277852*^9, 
   3.4608613186180477`*^9, 3.4608928803725977`*^9, {3.460893086014701*^9, 
   3.460893108154195*^9}, 3.460946003786149*^9, {3.460952695189363*^9, 
   3.460952704132106*^9}, 3.460952769126903*^9, 3.460954785295039*^9, 
   3.4610547900144987`*^9, {3.461065831047728*^9, 3.461065851667341*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.460444788235248*^9, 3.460444817682623*^9}, 
   3.4604450103485413`*^9, 3.460459143269252*^9, 3.4604592096793203`*^9, 
   3.460459927811483*^9, 3.46046040805451*^9, 3.460461792764674*^9, 
   3.460722834150064*^9, 3.460775197926738*^9, 3.460800148785144*^9, 
   3.4608018347272587`*^9, 3.460802129040563*^9, 3.460808343277852*^9, 
   3.4608613186180477`*^9, 3.4608928803725977`*^9, {3.460893086014701*^9, 
   3.460893108154195*^9}, 3.460946003786149*^9, {3.460952695189363*^9, 
   3.460952704132106*^9}, 3.460952769126903*^9, 3.460954785295039*^9, 
   3.4610547900144987`*^9, {3.461065831047728*^9, 3.461065851684166*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pp", "=", "1"}], ";", 
  RowBox[{"nn", "=", 
   RowBox[{"{", "1", "}"}]}], ";", 
  RowBox[{"Y", "[", 
   RowBox[{"[", "nn", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m", "=", "50"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"scaling", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"IndividualLikNonlin", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Y", "[", 
      RowBox[{"[", "nn", "]"}], "]"}], ",", "X", ",", "miss"}], "}"}], ",", 
   "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"IdioNonlin", ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<GH\>\"", ",", "m", ",", 
       RowBox[{"10", "^", 
        RowBox[{"-", "16"}]}], ",", "Infinity", ",", "1"}], "}"}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0", ",", "0", ",", "\"\<NorKorr\>\"", 
     ",", "1"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"IndividualLikNonlin", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Y", "[", 
      RowBox[{"[", "nn", "]"}], "]"}], ",", "X", ",", "miss"}], "}"}], ",", 
   "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"IdioNonlin", ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<GH\>\"", ",", "m"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0", ",", "0", ",", "\"\<StochLin\>\"", 
     ",", "0"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"IndividualLikNonlin", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Y", "[", 
      RowBox[{"[", "nn", "]"}], "]"}], ",", "X", ",", "miss"}], "}"}], ",", 
   "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"IdioNonlin", ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<GH\>\"", ",", "m"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0", ",", "1", ",", "\"\<NorKorr\>\"", 
     ",", "0"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.460264864897327*^9, 3.460264932378791*^9}, {
   3.460265489300803*^9, 3.460265492492799*^9}, {3.46027038606568*^9, 
   3.460270391802556*^9}, {3.4602704971596107`*^9, 3.4602705817118692`*^9}, {
   3.46027367414145*^9, 3.460273674236417*^9}, {3.460279775378045*^9, 
   3.4602797754444103`*^9}, {3.4602799530257587`*^9, 
   3.4602799533811693`*^9}, {3.460280067013379*^9, 3.460280067130088*^9}, {
   3.4602801040742397`*^9, 3.460280104129944*^9}, {3.4602801453821163`*^9, 
   3.4602801673531218`*^9}, {3.46028174693688*^9, 3.460281763776168*^9}, {
   3.4602818356559362`*^9, 3.460281835739462*^9}, {3.460281898670804*^9, 
   3.460281898732609*^9}, {3.460282025318959*^9, 3.460282025741701*^9}, {
   3.460282062175247*^9, 3.460282071535883*^9}, {3.460283778391947*^9, 
   3.4602837888805027`*^9}, {3.4602838305963707`*^9, 3.460283854615387*^9}, {
   3.46028477341341*^9, 3.460284779157151*^9}, {3.460285035206752*^9, 
   3.460285046973556*^9}, {3.46028555906642*^9, 3.460285574425418*^9}, {
   3.4602857519094887`*^9, 3.4602857519715776`*^9}, {3.460285881590439*^9, 
   3.4602858816380377`*^9}, {3.460286117999454*^9, 3.460286123654068*^9}, {
   3.4602863340289307`*^9, 3.4602863377475977`*^9}, {3.4603641927287188`*^9, 
   3.460364197580667*^9}, {3.460365058304535*^9, 3.4603650587979116`*^9}, {
   3.460365091217347*^9, 3.460365126318194*^9}, {3.4603652464521227`*^9, 
   3.460365260029804*^9}, {3.460365412299954*^9, 3.460365434375272*^9}, {
   3.460365485584791*^9, 3.460365520950554*^9}, {3.460366663535665*^9, 
   3.460366678997499*^9}, {3.4603667867732773`*^9, 3.4603667868283587`*^9}, {
   3.460367092714067*^9, 3.460367098883337*^9}, {3.460369235357655*^9, 
   3.460369263924768*^9}, {3.460369362646221*^9, 3.46036936313859*^9}, {
   3.46036946785526*^9, 3.4603694691077127`*^9}, {3.46037339069245*^9, 
   3.460373390747698*^9}, {3.460373605599341*^9, 3.4603736056503153`*^9}, {
   3.460377091108459*^9, 3.460377126962656*^9}, {3.460377288435691*^9, 
   3.460377301095058*^9}, {3.4603774697122087`*^9, 3.460377479788327*^9}, {
   3.460377585320611*^9, 3.460377603716568*^9}, {3.4603776957101793`*^9, 
   3.460377736561165*^9}, {3.460377923292104*^9, 3.4603779233524303`*^9}, {
   3.460378105932313*^9, 3.46037817981962*^9}, {3.460427531315346*^9, 
   3.460427537420005*^9}, {3.460427638978484*^9, 3.4604276390230217`*^9}, {
   3.4604277414332314`*^9, 3.460427769573126*^9}, {3.4604279604982853`*^9, 
   3.460427960554902*^9}, {3.460430680071252*^9, 3.460430680172152*^9}, {
   3.460430712203142*^9, 3.460430712557424*^9}, {3.460430775931464*^9, 
   3.460430776020101*^9}, {3.460430814349124*^9, 3.460430814950081*^9}, {
   3.46043100067663*^9, 3.460431000775926*^9}, {3.460431035518139*^9, 
   3.460431043615539*^9}, {3.460431139283386*^9, 3.460431139330926*^9}, {
   3.4604311987514153`*^9, 3.460431233744923*^9}, {3.460431314274002*^9, 
   3.460431314321568*^9}, {3.4604316727142878`*^9, 3.4604316728008432`*^9}, {
   3.460431886035831*^9, 3.46043189177104*^9}, {3.460432099991972*^9, 
   3.460432100073539*^9}, {3.460432236204804*^9, 3.4604322362468243`*^9}, {
   3.4604323376555843`*^9, 3.460432357162323*^9}, {3.460432403219545*^9, 
   3.460432403269651*^9}, {3.460432564446265*^9, 3.4604325911495867`*^9}, {
   3.460432813689516*^9, 3.460432813733564*^9}, {3.460432944239506*^9, 
   3.460432989199974*^9}, {3.460433097024789*^9, 3.460433097139295*^9}, {
   3.460433291653358*^9, 3.46043329173923*^9}, {3.460433672964451*^9, 
   3.460433673010107*^9}, {3.460433845665332*^9, 3.4604338457416363`*^9}, {
   3.4604344009903316`*^9, 3.460434401033557*^9}, {3.4604346235115023`*^9, 
   3.460434638473834*^9}, {3.460434675871023*^9, 3.460434675925946*^9}, {
   3.4604350413113747`*^9, 3.4604350414069347`*^9}, {3.460436666989565*^9, 
   3.460436677468376*^9}, {3.460437023691847*^9, 3.460437023772811*^9}, {
   3.460437179838045*^9, 3.460437214787621*^9}, {3.4604373750456057`*^9, 
   3.460437375101828*^9}, {3.460437455923118*^9, 3.4604374559862347`*^9}, {
   3.460437643282413*^9, 3.4604376433404827`*^9}, {3.460439284564681*^9, 
   3.46043929340877*^9}, {3.460439393566842*^9, 3.460439393962884*^9}, {
   3.46044000098571*^9, 3.460440001044331*^9}, {3.460443930270521*^9, 
   3.460443930334333*^9}, {3.460443966799687*^9, 3.46044399790462*^9}, {
   3.460444060284606*^9, 3.460444061730588*^9}, {3.460444101336812*^9, 
   3.46044410138903*^9}, {3.460444186536171*^9, 3.460444194286351*^9}, {
   3.460444233408099*^9, 3.460444248920389*^9}, {3.460444338058318*^9, 
   3.460444355662019*^9}, {3.460444400012597*^9, 3.460444431012135*^9}, {
   3.460444591036777*^9, 3.4604446631572647`*^9}, {3.46044479971354*^9, 
   3.460444799768903*^9}, {3.460444831583193*^9, 3.460444859781989*^9}, {
   3.46044502143334*^9, 3.460445021504759*^9}, {3.460459950502769*^9, 
   3.460459971711813*^9}, {3.460460068419449*^9, 3.460460088588605*^9}, {
   3.460460154598343*^9, 3.46046015516997*^9}, {3.460460281436612*^9, 
   3.460460281521656*^9}, {3.4604604120265713`*^9, 3.460460412125514*^9}, {
   3.4604607607833633`*^9, 3.4604607621971283`*^9}, {3.460460826677142*^9, 
   3.460460827186878*^9}, {3.4604608962826014`*^9, 3.4604608963501987`*^9}, {
   3.460460962965583*^9, 3.460460963358262*^9}, {3.46046100555375*^9, 
   3.4604610220017967`*^9}, {3.46046105589403*^9, 3.460461056004932*^9}, {
   3.460461154113535*^9, 3.460461154227416*^9}, {3.460461800671767*^9, 
   3.4604618154025*^9}, {3.46046184541817*^9, 3.46046186011173*^9}, {
   3.460461896620476*^9, 3.460461896672694*^9}, {3.460461952952413*^9, 
   3.4604619533933907`*^9}, {3.460462913572587*^9, 3.460462920740217*^9}, {
   3.460722765559946*^9, 3.460722812479978*^9}, 3.4607228582030888`*^9, {
   3.460722890758842*^9, 3.460722896366596*^9}, {3.46072298397585*^9, 
   3.4607229875994997`*^9}, {3.460723019415843*^9, 3.460723105990931*^9}, {
   3.460723170191799*^9, 3.460723171657259*^9}, {3.460723268211129*^9, 
   3.460723287189331*^9}, {3.460732937278017*^9, 3.4607329553868093`*^9}, {
   3.460733072671542*^9, 3.460733072733719*^9}, 3.460774164086339*^9, {
   3.460774329652614*^9, 3.4607743297042007`*^9}, {3.4607747308600483`*^9, 
   3.460774745217613*^9}, {3.460774783118621*^9, 3.460774783163679*^9}, {
   3.4607752055171013`*^9, 3.460775330022717*^9}, {3.46077593187556*^9, 
   3.4607759414970217`*^9}, {3.4607760276883583`*^9, 
   3.4607760355817633`*^9}, {3.460790937262329*^9, 3.460790951013814*^9}, {
   3.460791568324353*^9, 3.4607915702816963`*^9}, {3.460793424875643*^9, 
   3.4607934256099787`*^9}, {3.4607936492357063`*^9, 3.460793649286522*^9}, {
   3.460793686024284*^9, 3.460793715536209*^9}, 3.46079539824224*^9, {
   3.4608005873682537`*^9, 3.460800587858807*^9}, {3.460801890378409*^9, 
   3.460801906716531*^9}, {3.460801944252364*^9, 3.460801956112904*^9}, {
   3.4608021446565866`*^9, 3.460802155162537*^9}, {3.460802619088133*^9, 
   3.4608026317097387`*^9}, {3.460802812504952*^9, 3.460802849903359*^9}, {
   3.460802897055272*^9, 3.4608028982176*^9}, {3.460802962963353*^9, 
   3.460802992257814*^9}, {3.460803079615142*^9, 3.4608030796689463`*^9}, {
   3.4608037326935062`*^9, 3.460803732755742*^9}, 3.460803767933199*^9, {
   3.4608038073568907`*^9, 3.4608038074115458`*^9}, {3.460805795204329*^9, 
   3.4608058122906427`*^9}, {3.460806262926772*^9, 3.4608062820694227`*^9}, {
   3.4608068052612143`*^9, 3.460806805624588*^9}, {3.460808488211617*^9, 
   3.460808507424265*^9}, {3.4608086121558113`*^9, 3.4608086125013313`*^9}, {
   3.460808753825961*^9, 3.460808793699284*^9}, {3.460809102803755*^9, 
   3.460809103845994*^9}, 3.4608108610750523`*^9, 3.4608595767679577`*^9, 
   3.4608596094553747`*^9, 3.4608596715556*^9, 3.460861076341893*^9, 
   3.460861205108603*^9, {3.460861386456036*^9, 3.460861399732408*^9}, {
   3.460861431058154*^9, 3.4608614312160883`*^9}, {3.460864060411364*^9, 
   3.4608640905515738`*^9}, {3.4608645383490467`*^9, 3.460864544310871*^9}, {
   3.460864603820335*^9, 3.460864712693082*^9}, {3.4608929239332047`*^9, 
   3.4608929753803177`*^9}, {3.460893111220315*^9, 3.460893111289748*^9}, {
   3.460893217607318*^9, 3.4608932187280493`*^9}, {3.460893250965021*^9, 
   3.460893254523731*^9}, {3.4609459593736753`*^9, 3.460945990777905*^9}, 
   3.4609461818371763`*^9, {3.4609462200847073`*^9, 3.46094624876257*^9}, {
   3.4609463854557753`*^9, 3.460946474339522*^9}, {3.460946510045971*^9, 
   3.4609465536310062`*^9}, {3.460946723313528*^9, 3.4609467441760902`*^9}, {
   3.4609468452269077`*^9, 3.460946845373514*^9}, {3.4609694101472178`*^9, 
   3.460969478989313*^9}, {3.46096951664609*^9, 3.460969517193152*^9}, {
   3.460973374151567*^9, 3.460973436715477*^9}, {3.460979759346147*^9, 
   3.460979777342544*^9}, {3.460979814960824*^9, 3.4609798907432756`*^9}, {
   3.461039481544436*^9, 3.461039582981559*^9}, {3.461054688296595*^9, 
   3.461054723384863*^9}, {3.4610547662221727`*^9, 3.461054771490233*^9}, 
   3.4610549713127613`*^9, {3.461065911231505*^9, 3.461065980795754*^9}, {
   3.461066071288073*^9, 3.461066087778966*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"1", ",", "0"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.460774172693623*^9, 3.4607742141360817`*^9, 3.460774259371611*^9, {
   3.460774303149437*^9, 3.460774333742992*^9}, {3.460774503977763*^9, 
   3.460774525387253*^9}, 3.460774568669429*^9, {3.4607746433678713`*^9, 
   3.460774749289826*^9}, 3.4607747872637367`*^9, {3.4607752069957323`*^9, 
   3.4607753311834*^9}, {3.4607759195524397`*^9, 3.4607759422690763`*^9}, 
   3.460775994534586*^9, {3.460776028795376*^9, 3.460776037081739*^9}, {
   3.460790911595224*^9, 3.460790939253276*^9}, {3.460791053594666*^9, 
   3.460791071141541*^9}, {3.460791192973082*^9, 3.460791203957177*^9}, {
   3.4607914471303043`*^9, 3.460791466955147*^9}, {3.460791545117042*^9, 
   3.460791571021545*^9}, {3.460793419216103*^9, 3.460793427190727*^9}, 
   3.4607934904166403`*^9, 3.460793537586506*^9, 3.4607935875115547`*^9, {
   3.460793643816039*^9, 3.460793651412258*^9}, {3.4607937028316803`*^9, 
   3.460793717693026*^9}, 3.460794349054253*^9, 3.460794468602188*^9, 
   3.460794537146944*^9, 3.460794606820025*^9, 3.460794647441045*^9, {
   3.460794683999979*^9, 3.460794711587779*^9}, 3.4607947437033663`*^9, 
   3.460794821453476*^9, 3.460794992763452*^9, {3.46079537866004*^9, 
   3.4607954008420343`*^9}, {3.460795899955226*^9, 3.460795915535334*^9}, 
   3.4607959607567463`*^9, {3.460796100730474*^9, 3.460796117431126*^9}, 
   3.460796273298979*^9, 3.46080016267494*^9, 3.46080059045927*^9, 
   3.46080191058669*^9, {3.460801947033931*^9, 3.4608019584551563`*^9}, {
   3.460802135491241*^9, 3.4608021585180397`*^9}, 3.460802633967609*^9, 
   3.460802693048126*^9, 3.460802784188271*^9, {3.46080281423518*^9, 
   3.460802852551197*^9}, 3.460802900679997*^9, {3.460802966464355*^9, 
   3.460802994747815*^9}, 3.460803081703266*^9, 3.460803125487102*^9, 
   3.460803183227213*^9, {3.460803234859148*^9, 3.4608032609697237`*^9}, 
   3.4608033212142887`*^9, 3.460803381478054*^9, 3.4608035021140633`*^9, 
   3.460803635652215*^9, 3.460803697315674*^9, 3.4608037348572693`*^9, 
   3.460803769573984*^9, 3.460803809928953*^9, {3.4608057984622173`*^9, 
   3.460805813824176*^9}, {3.460805968711471*^9, 3.4608059901127863`*^9}, 
   3.460806044738928*^9, {3.460806111860417*^9, 3.460806138661484*^9}, {
   3.4608062551082487`*^9, 3.460806284064145*^9}, 3.460806807365871*^9, {
   3.46080840200484*^9, 3.460808428085409*^9}, {3.4608084903745604`*^9, 
   3.460808509880398*^9}, 3.4608085615495157`*^9, {3.460808596715098*^9, 
   3.460808614316525*^9}, 3.460808667778009*^9, {3.460808756743518*^9, 
   3.460808821361974*^9}, 3.460808866006637*^9, 3.460809008335636*^9, {
   3.4608090829662027`*^9, 3.460809106371428*^9}, {3.4608091533817453`*^9, 
   3.460809170247486*^9}, 3.460809387484213*^9, 3.4608094563846188`*^9, 
   3.4608095239938383`*^9, 3.460809556860118*^9, 3.460809601486121*^9, 
   3.460809659738999*^9, 3.4608097239935083`*^9, {3.46081085410987*^9, 
   3.4608108667828493`*^9}, 3.4608109499384403`*^9, 3.460811028337473*^9, 
   3.46081107221124*^9, 3.4608163531812773`*^9, 3.460816462080289*^9, 
   3.460816636079851*^9, 3.460816733529152*^9, 3.460816810327259*^9, 
   3.460816896707574*^9, 3.460859466583232*^9, 3.460859525199936*^9, 
   3.46085957856656*^9, 3.460859612027454*^9, 3.460859642696507*^9, 
   3.460859673379051*^9, 3.4608610359199123`*^9, 3.460861080130123*^9, 
   3.460861176214602*^9, 3.460861206909174*^9, 3.4608612527872066`*^9, 
   3.4608613245925083`*^9, {3.4608613893716373`*^9, 3.460861402077552*^9}, 
   3.460861433808834*^9, 3.460861482995883*^9, 3.460861622874538*^9, {
   3.460861766989231*^9, 3.460861788062501*^9}, 3.460861837558749*^9, 
   3.460861919837391*^9, 3.46086202490096*^9, {3.460864063005273*^9, 
   3.4608640925582657`*^9}, 3.4608642675973377`*^9, {3.460864595153369*^9, 
   3.460864678530854*^9}, 3.4608647161716623`*^9, 3.4608928885197763`*^9, {
   3.4608929272834787`*^9, 3.4608929785836067`*^9}, {3.460893064106246*^9, 
   3.460893113794902*^9}, {3.4608931965264177`*^9, 3.460893221096546*^9}, 
   3.460893257519649*^9, 3.4609459317505836`*^9, {3.4609459653975143`*^9, 
   3.4609459931714287`*^9}, 3.4609461850150833`*^9, {3.460946221971449*^9, 
   3.46094625037241*^9}, 3.460946287032295*^9, {3.4609463329038773`*^9, 
   3.460946475537898*^9}, {3.4609465106640263`*^9, 3.460946554340445*^9}, 
   3.460946745286201*^9, 3.460946846249963*^9, 3.46095277278576*^9, 
   3.4609547879814377`*^9, {3.4609693962841597`*^9, 3.460969479832581*^9}, 
   3.460969518067926*^9, {3.460973376833108*^9, 3.460973436855947*^9}, {
   3.46097976178686*^9, 3.4609797783289747`*^9}, {3.460979815577437*^9, 
   3.4609798918056097`*^9}, 3.461033363239642*^9, {3.4610394977541027`*^9, 
   3.461039513242825*^9}, {3.461039546024946*^9, 3.461039584057582*^9}, {
   3.461054619262939*^9, 3.461054635771722*^9}, {3.461054666119218*^9, 
   3.461054724280589*^9}, 3.461054772684753*^9, 3.461054837077591*^9, {
   3.46105489942374*^9, 3.461054926726182*^9}, 3.461054971946405*^9, {
   3.461055759572901*^9, 3.4610557703433237`*^9}, 3.4610628397680902`*^9, 
   3.461065791475391*^9, 3.461065855853307*^9, {3.461065891722114*^9, 
   3.4610659208089657`*^9}, {3.461065953493973*^9, 3.461065982458634*^9}, {
   3.461066052787819*^9, 3.461066088122064*^9}, 3.4612912194563303`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "99", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", 
   "2500", "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-16", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "980"}],
  SequenceForm[
  "Genauigkeit x^", 99, "; ", "Stuetzstellen: ", 2500, "; weight > ", 1.*^-16,
    " und |vals| < ", 
   DirectedInfinity[1], ": ", 980],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.461055771768497*^9, 3.461062841177031*^9, 3.461065791490937*^9, 
   3.461065855900181*^9, {3.461065891743836*^9, 3.461065920834627*^9}, {
   3.461065953516238*^9, 3.461065982473227*^9}, {3.461066052803565*^9, 
   3.4610660881378593`*^9}, 3.4612912195200453`*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0, 0, 1], PointSize[0.03], Thickness[0.03], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxN1mc8lm/YB3B7ZpPyt1dx39z2yB4hm6xKVslKIckeCaFkZVPZVLJJ9ihZ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           "]]}}, {}}, {{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.01], Thickness[0.01], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxd23tcz+f7wPEaNcbXFznMMWoNP0RzpvqE1hxTG9UcJzKkOQ5fjazUb2PI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           
           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{1}, {1}},
      PlotRange->{{-3, 3}, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {195.42857142857142`, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {359.99999999999994`, 291.2461179749811}], 
    InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.03], Thickness[0.03], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxd23tcz+f7wPEaNcbXFznMMWoNP0RzpvqE1hxTG9UcJzKkOQ5fjazUb2PI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           
           "]]}}, {}}, {{}, 
        {RGBColor[1, 0, 0], PointSize[0.02], Thickness[0.02], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJzl2GtIk2EYBuBPSxMEtVpoZM5DVkIpRQjRYkYR4qHUwn8hSAdDJSMZEpXS
6EcHiqIgiQyiFEHSrDSEUEIIIjuASGJIikhWalmprcQoeJ7ggZGM9/62ve3P
uNj2vfd333+2xRUeytsXaBhG9zzD+P3ceyQl2bI5oCPhQEzMrvC9SZ7alRW0
KCp4eC3K7s4fTasZqWiabTfblA9lVXkT+zPOGNM/fc50vyij83dldzg7c/qX
9a2xTcXvcPHrvmrqB2V0ftk3+WVY0PLHTVP8fn8x9Yey6ryy77na8vxBS3TM
N76ev5r6RVl1Xtm/p35TdT+39fIEX18XU/8oq84r91Bl6+T498zFn/g8XUx7
oKw6r9xDlRvKCq4dW/ehfU/joMV67n2qrraHnNh9PLF0E8qq89L+aEdUtsUl
pg/z+bqa9lJldF65D8rll2LvdBUN8Pm6mvZTZXReuQ/KW23Ft1sSevn8/8W0
pyqj88q9zLIjesNo9oIXnEdX054oo/PLvcxyw/bQnXVtrX+/v2hq/r4HMjq/
3Mss5xzecm9wrMFO96urZ/88xu0oo/PT71ezHdt2tbY7/Snn0dW0J8ro/HIv
s3w+NCO2uK6H8+hq2hNldH65l1l+mOZceMPylvPoatoTZXR+uZdZ/hoZWGHt
GeI8upr2RFl1XrmPt3wypdyxv3qE8+lq2hNl1XnlPt5ySePps/UFY5xPV9Oe
KKvOK/fxlp/VHg2zXPlsp9/bupr6R1l1Xvr/wdvOnEh2Rc584Xy6mvZEWXVe
uY+37CgZWnWxaJLz6WLaT5XReeUeZrmr8O6A7fU059HFtJ8qo/PKPczyzT5n
zbusH5xHF9N+qozOK/cwyzlLOzMcT2Y4j7+Y9kEZnV/2j3J43rZXZSuMNDrf
X0x7oIzOL/tHuX6605lwMIDP91VT/yij88u+VTmi+mOqozmQz/MVU78oo/PL
fj111OqQWysD5vP1vWXqD2V0ftnnXP2o6kLpkvwgvp5Zpn5QRueX/blz/PqN
13Obg/nzqkz3i7LqvLIPcuWp6vykyBB+vztTPpT/db47/wJ43oJW
           
           "]]}}, {}}, {{}, 
        {RGBColor[1, 1, 0], PointSize[0.015], Thickness[0.015], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxF0Xc41e//B3CUmWTPjEhKsrLrnEN2JJRKkb1JdkgyK2VGpchOIpI9yshe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           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{1}, None},
      PlotRange->{{-3, 3}, {0, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {586.2857142857142, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {359.99999999999994`, 291.2461179749811}], 
    InsetBox[
     GraphicsBox[{{{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHlNLl5IL5UzQttgvJH+dE8DfEbo7v
E2aD85/JJr3b8JcZzteX8w434WaC8z8cucJQr8QA57/dOz1/t8Kf/TC+XNGv
iVbOP+D8WzwW5x8KfYHz+V7mSuu/eb8/Zv0jEfmeV2Ybd4Qwyjm8gPMvrXpk
uevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs7ejqMupFY11/rzHPNX
1tfuwfkqf/fNlDr2HM5/PfG+9a+f7+F808ndVtoXPtvDzSvzsTH89h3Or7o1
o7P06m84/4A2670TzAwOMP4p57nb+IWZ4PxD0r+3fP3HDOeXNrxe6i7CBufP
OqF3SJmLHc6Hxg+cDwBoEb+u
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlnc41vv/x+9hZGSTVKSMJhE5ue/P+/UpyShyrJRIRmSk7M7JMUqpRKWE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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vc/1W0DwPFzjnHMzKRIiSLKyjzO97q+WQe57VRkNVVKWUWUWVZKZpJk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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQB2IQvV+g6N7//+wHbhx5oP29+aiOxXYh+eOcCP6G2M3x
fcJscP4z2aR3G/4yw/n6ct7hJtxMcP6HI1cY6pUY4Py3e6fn71b4sx/Glyv6
NdHK+Qecf4vH4vxDoS9wPt/LXGn9N+/3e3w4eNmt0sdq444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/D89rr+2X+uz73uWYf/W6bydX7Ro
q5/1Cjh/3cozreUJW+D8bUv5Trov3gPnP/I7qV4y5Ric/8qLO9vl+jk432Th
Pf73Ctfh/M9zzF9ZX7sH56v83TdT6thzOP/1xPvWv36+h/NtnZofJpV/sIe5
t3W32NITHxH8syarMvRyPsL5outsdaY8Q/CXLkjZHH/7E5xvOrnbSvvCZzhf
gDXHWu/xVzj/VZmPjeG373B+1a0ZnaVXf8P5B7RZ751gZnCA8U85z93GL8wE
5x+S/r3l6z9mOL+04fVSdxE2OH/WCb1DylzscD40fcH5AI62TNs=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk7lHsfgMeMsRdt4ogWkihLETHP83kqRSmKiU5EWoRGi61Nkq2cHEtJ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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vk7lHsfwPEZYwlFIUukI8p22u3mvj+3kqEkSUW2lKKOyh4iIqVDJBLS
RuOo7ESI7yAyRyJL2Y2sIfsyjOF5nut6fnhfr3/hrXD+usVFHhKJlP/f/ifa
6NGztibA0Lqyq+tcGujb6yVluVcKMP6O1bTVenhSf+VC5a3+OwKM8hultA9c
Z32dIrFtnwUFGI6EyrltyTH6OXb5DlHi/Iyhl41ObXp9+kNbz0/kcCmMY9YV
kZbjIdRJLMjGEVEYrywnR/LS4qhsu+TaTbcpjI9On1TkzqZRybeKNSsPUhiT
Er0RkatFVKHn31M8eCmMwTal8soIJlW8fFZUsYaHceTuI/HQpQ6qXM/GwOZ7
PIy6nTTlXhin7lzdNRpqwsP4fLfv7q0zXOoe+aNnNIR5GN0k3cYBXRFs3cmA
jK1fyYynOTWrh7zkMda9TLJADJnB6DRiy7jvxj587Dk9dZLMmJlf98tvL449
nBbNaJckM3QunTAazT+Guew0IFe1kxhNx74HnFq1xQgbj9MZySTGUO/bwXFx
V0z6Yeq7xw4khoJBxOO1JX9s6lMLKWg7ieHS7a3/ufA+dt7cOdubsYYcE3mb
TdITsX7JHXa/9ddQsttSBb/dG8yp+6fQxaJV5LJsUyH+4wM2lPryQ9f+VfQm
pdxXbkst5nLF/pJlFhfx9r8q1Fb/gY3ulZP4ospFfS5M1cyNQ5jrYnvFIfoK
+rUlCs/+Nof9LntyvfSPFdTix76wwYeCe0kMnBSmc1BYI9WNemwTvnxlr46N
Kgc5Y88M20Ll8eCKALl3mcvoTp7u1l25aji/NJPE2beM8rG+SKaKNh55bfPg
kcIldHTdDN/tiUO4WLUjM0lvCfWPqGzvpZzAE2SzMkfL2UiGjv9sb7TF5T2W
Y/QOsZFR7jtYO+CC++xI8dtTtohY+ib+UYLeeH2biaOS9iLS07oXnS8XgitF
ThvL5C6g7yv0U3sGovAASNwror6AQviUZ+ekkvCWGUKaQp9HJ96/PDbdQsfV
00bWFuXnUca3ZgUklYeHWD8cHk+YQ5/uWR3aVlCGd6zXaegTm0M3Gc/EqnbW
4o2/BO4ZR8+im3bWvPnGzXh1zQ88W3gWfeipa7kc2oOXpP6zsDl8Bok1SJDv
jg3jOcE3sgJ4ZxDT183bLW4GT7OjXeoPnkanFLl+YYkreLKelPwR7hRyH37D
cWngg0dSw605flNog3taBNt/I4j8uiq7Z3wSOS2UnkvKlAaeKjV2xsIEajgp
4+7bqgCLycMtauQJZBOYzUt6pArjPq9z04V/o2rt20O+e/YDy9wxaqfkODpo
sFik9EYXWtTk/3r9xxg6F7rZumHeAGp5O2nb1UfRM2Qp1D5lDB97nii91PyF
et+LJ47tOgG5HyzJ8sQI2mg84O/gfwaMTWsHBjWHEe2S67NSi3PQ26tfm6k+
hFLHJM12B1wCH8/sd94KgyjJef2t4axrsEFAMRqTGkCmLHrCwTIveJ0U78G3
oR/pCoc5baq5Cfq7hU7X8/xEscY/qCauIdBUEaj7mM1CgmNrQ2Za4dD09qdu
SVcv0ljI3FIfFg1iYrydb8e60dwVw27D1Viw8NsR8HS5E6mlh1+7r5wIj1hG
WyMFO9Bnll/xpwsvoJnmUh4g3YZK3IT9x1xTQSL7vsNV5e8oI7JtsrTtH7CU
fEey12pBVe1T51fWZUJc4JdXZoebUPQIx2pveC60DPw+CJaNiEeY71D/WgFs
GXQwmWj/gpzS2I9ud3+ACNLAenthJvJUeJb2p1YZrMi6NNZTq1Gk2eESTf4K
uKY9Hotdq0C1vAxFUk4VIDor6yyUolRboV8l8TWQ0jWiqZeSjyaMPxn2FDLh
peqg6OCLGJSyty648HAjrEQeXi76HgVp83R6IjSBmc3mMDP9dDDySufEGrVA
IV2ESUv9COOu5tqKVm3QY67Cv96zElbs+h9HmHXATzOmsldcDazXk7xuqtYF
Q6ZXTLre/wvbTXrvuLK6YfSI8F+GP77CUvRk4rFLveA0IOs6b/UN+IscyDNm
LLBUzEsxNmqGYVoi/2g9CwzPG7c/PdAK4xmsftldfaDxqkd08o8fIGXI5067
0gdKLC+jgyLtwCu+ZXk+tA8ktgkHPuZ0wN/NaTvv+/UBr/2r/JGRLrg2629u
cLQPZpO1R/W/94Cujeuk3jILjmvk3A/0YcHZ7Te1rgSyQCnJUL77dh9wLHe8
WSjpheW1tjzqg5/QYPrO1gPrgYaLV2nJCf2wwI47rhnZBa/ryF2c1AHg7Hid
K5XXAf774t1ssgfh9/HvFy+XtIEStzxxS80wGH62/mr+ogXKRClR8V9GYKdI
el18UhOc3k4LEWv+BR20mkKrV40wqRHhE9U+Cp0pX/iUfeohnNZwRYg1BoFC
86UjnUxQOCvucHdoHPQyRApiAmugxPXMSZ7fv0Hu18uuNccqsAh6Srs1OwEv
rGJdPR8wYCymV395aRJ2cAv7IikfATsY2nf+xhTsD1M/slRTBGGlkvTa6Slo
SatYC+ErgHqNty67XadBQiaypaw4BzZnYX/GDU1DQEG+/pbid2Cn/G1y6dwM
iFRpt+B1aUB/6ZTv0DkDi9d4D1c8SYHfMmyf6lOzcNVQXi9Q6jloxkboqTfO
AteXnhyhkgAZ2VXLY5ZzUO7tHyXV8wi2f+GUZLTPQeuToV0n9j+AxJEDN6/a
z4Nqh6i3nuNd2Mjnqr+7fx7acHfv/NVguKvwmjPhvACDpvNU3Ud+wMW6SrPH
F2BKgnqCJOoJXmclAtzcF6H3QZWv1A5XGPUxpe5bWISio1OtUfFOYEtZqJbx
YIN864IIf5A9fI1+cZxngg1pJx9+UHM+DYScSfvo5SUICLEcm7cwh7z0mfPN
g0vQ9hyWXybQQEkzebzUcRksVPweXBwlIL7isM/r7mW4ERPsYiOiA+vMJtci
rTnATrx+xm1xL/h3JNz3buXA7ST7+k1lyiArNCxabLMCnuSgy+ypbfBRVzN+
pW8F6Gc3N3Ubbwbby6FyhAsX1lcqzlVIrwduwreU0AkuqPhLo732PPC8dpvq
Z69V8Pxqv3yTuYjj7KvZQpxVEB4Leb4aMoH3Kn/UNLu9BguRQT6Djv04Q52v
p5ZCIsqKO7bwO7XhFbuli3MPk4gL6YfCnr79ilfuU49Lukci7GpmvnFkqvBP
Gvj1UCaJKBmVvNQSW4RXa5844ipMJvzV0m/WtWbgNXpOO04dIxPZaz7OYb6v
8FrsBgmPJhPU1smB8aU4nEn83bnzG5lQgpMi2nPh+L+HnhWKivMQp41MDrRf
DsSZqy4+keY8xMV7AoLTDe54bbGGlmAUD9FrgJpzL13EP3uRFsLqeAgZ7u6E
mdvWeM2eL+95BCkEmz9L5L2KGV49+sQ7yIhCiDV3ajRlG+Cf6Bc0V0IpRHGw
dTDEaeBV5/bM+1ZQiBmHqJ+VDGW8UpZTML9KId5P1HED9sviVioysy8MeIn4
9nZumvsGfFJDe9+RO7xE2guHw4Wxa9hdg1PX52p4idWYAP/F6ilMzswz87kg
H7F09K8ydloflnc2ZszYlI+QCxqw2OrchBk7Z6vORvERBbfCdczJVViPZ73z
s298hHLhTenz7vmYd/AYnSbBT1h0PXykW5CK3bJYySg/wU9c3RC5OaAvDgtX
2lCgGc1P1Ex4zQXOhmExC1tLM77wE3iotoXtgA+WVLu7UlFIgHijlny9LMsZ
S00CZhJNgBhWfKhAMbPCMlzNGzeFCRBM0/hnN8qNsULc8Ud4pQChY7QV9+Dq
YP//Y+JhjPxBD0FV7D/1wJ/i
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQB2IQvV+g6N7//+wHbhx5oP29+aiOxXYh+eOcCP6G2M3x
fcJscP4z2aR3G/4yw/n6ct7hJtxMcP6HI1cY6pUY4Py3e6fn71b4sx/Glyv6
NdHK+Qecf4vH4vxDoS9wPt/LXGn9N+/3e3w4eNmt0sdq444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/D89rr+2X+uz73uWYf/W6bydX7Ro
q5/1Cjh/3cozreUJW+D8bUv5Trov3gPnP/I7qV4y5Ric/8qLO9vl+jk432Th
Pf73Ctfh/M9zzF9ZX7sH56v83TdT6thzOP/1xPvWv36+h/NtnZofJpV/sIe5
t3W32NITHxH8syarMvRyPsL5outsdaY8Q/CXLkjZHH/7E5xvOrnbSvvCZzhf
gDXHWu/xVzj/VZmPjeG373B+1a0ZnaVXf8P5B7RZ751gZnCA8U85z93GL8wE
5x+S/r3l6z9mOL+04fVSdxE2OH/WCb1DylzscD40fcH5AI62TNs=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vc/1X0fwPEzcHIUlwhF9qiMUkbG9/v+pkJLg1JESOWqUBmlSGVWLqNC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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk41Hsfh2exZIQOKp2QJJGyFMny/3//bWiTLC0KEVmOKKHNUiE6OSSS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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHjN+9EMq/eVDZYruQ/HFOBH9D7Ob4
PmE2OP+ZbNK7DX+Z4Xx9Oe9wE24mOP/DkSsM9UoMcP7bvdPzdyv82Q/jyxX9
mmjl/APOv8Vjcf6h0Bc4n+9lrrT+m/f71yj+O2k+391w444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/Fde3Nku18/Zfzu8/Z3z+5Omn+eY
v7K+dg/OV/m7b6bUsedw/uuJ961//XwP55tO7rbSvvDZHm5emY+N4bfvcH7V
rRmdpVd/w/kHtFnvnWBmcIDxTznP3cYvzATnH5L+veXrP2Y4v7Th9VJ3ETY4
f9YJvUPKXOxwPjR+4HwAAuTkvQ==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk3lG0DgGcMJhRRthRhEMoSEzHPfT92qSRbUsgWylKyVC9vC0UlEqmQ
ylKyTSoU5Z6soyhCZc06ZF/HMpbv+875frjO9Rdc51yybgHWnlwEAiH3v/zP
aHNg9/o6mcH0D6k3L5vRc9ZLLjhfQWa8jtKSixTh0V9xr/i3P5LM2Hvd5VrT
bXF93RIRmVo+MuOS2DjgY9L0Xzu9dYndwsvw6G968eVrhD5rh9vE61USozZU
z9MwRpSmLn3wmLYAF2N/VkZAl0UCbYNNWN6Ob0TGKwOiJEkrndYTlU8kxxMZ
ecW7qZqbCmnvP3bbT9kQGc6b3/w8+BHR7k0L5bWJERnEKMjPsW2geSsaECvb
CIxvua9aVMfbafiJQPu8VALDAnt+dixmmCZxLyP3gQuB4WX7QihEn02bqmoh
XJEjMFy4jMaF1kmYm5UXPZixjujCdo4CFSJYv5iC07j+OnoHsIWiIFnMo6uP
37NkDX1xZrjb7tDAWBnP3nfuXUOnUlur+iIwzPuM82nbglW0cdj7p2ejBTai
sX1rvfIqSql1FvZTccB8F9o+G2WtIGg9yjuW7ImNf3oYULZzBbFK1+k+yhew
oK0DNgJZHNQRtOHtfuwqtnxGQ/eEMgf1JeZqW9rdwa5+Dtuem7+MOKNDUV2/
kjBeiToCR3MZWcpGexvMp2Mx/qKDFsVLqCiJZPYY0jGRate6ZL0l9K0yJ5+Q
8AF7JFWQP1K+iMpTWiP/Mqsw6cDleD2jRXTFbdTZqaYRC1FIv6T+aQFl3Sk9
kMbuwBp+H3Cl6CwgUcX8rxM7hjBKzLS5ZCEbYc2114/NzWBh8LGGoCobaabh
7gdb1rCWGVyClDWPHCUiY1e6NgDVF8PrC9Lz6GdLNHl6YAu4fvze0NijOdSy
7SMWcF8GtG/U/d4rMofoQifVSG27QONfcpR53CyShZ3BMZgWqK75BegCswg7
2JvFfQ8DpRkv2aLRM2hKRuisVbQpeH01tCCMewalLUS2rfIdBS+czE73X51G
LuPCmUrxx0Gqnri0xeoUkth+63I72R3cFx9qfX1pClUodQWkSvkCwb9+Uupj
kwjf2WYv9CgIcFWqLOaxJ9ByB65O0Q4HC6lDLSrECeQcbO8bdS8SjIVkFmYL
jKNQnQLRW5UxoMfKNVZRbAy11g3knltOAC0q0mczd44iwaTS4sm4FMDk7jCT
Ux1B+0Rb23t708HH7oeUZ9S/KJuZpNtc+AoUvrclSuPDSGbGd/b7yUJgfog5
MEgdQtPd2Y4dvSXgzx99Zr4qC+1LOH100YIBQi7Qc4NlB9HaxaLLmptqwCay
fBwmPoCy+VO+LyU3gMzkpECeTf0I5f7xyyhuBvpq/PYNXH2oRLLoXjl/O/jx
OXz/g8UeZM1XIkre3At+5PTtL+38g/6Z0VWq2MMCIiLcHTmjXYj5hHqPuHMM
WF9SCEtZ7kBeI9YhCkXT4H6P6Y4YvnYkfgDmSFLYoNnMuzxM4jfa7n1xIiSc
A7bSb7n4Kf1EEpzGbOUZArQVyyU472tBUb3tgz3l3DAxvP65pckPtDtO2mqz
Lh9sGRg3hLaNqPeq6D7J84Jw26DLgYm2euQqeVtfS00E3iEMbHQWqEOSB82V
cuJF4YqUd2MDrRop121xfnJGEvrrjCVg/p+RUsL07mi0A6KsngJHWIaeFXVr
vrSQhemdw1S99LfI3KHa2GdBHvIr9V3S4s9GkhplD0xZivCZ8qDQ4NN4pOJU
TxAVU4ErMSbLJT9jYXr7mMjFpj3Q8oToDUv9bLg6+ylKflgDFmcJ1pllfITK
PnuK9+lRYbfVLt6NFyqgQcoqqryqA/ss65SCEmtg+q8Aan/jfjhiIXDW+Nc3
eBGztrbyAdBjQMp33qEJEkk2qcY0HNrKv0k3N22GaYxrvBt1DKCxm3lbilYr
1Es8npa10xBqP+8Wmtz5C/o6l7n9mjOElJ4gU0PBNsh+8Mj9Bd0IbpURCH/A
aYcWiae8Qg4bQ27n52+Hhzsh64JJnNJXYzibqjOi/7Mb2v6r8FJD0QQe0X59
KzykB7ISCpmJLiaQkmws3XWtFyoMt2F0XxO4vP77De1uHzR2D7RXO2wCv3v6
maU+6ofCotz4T6IJzPxK7ORkDEB9bVz8UowxvKyZdO4EfRDu9tqsPjBpBI88
VOEpK2XB3Y6bkyvVjSBltfzxtpoheDdiy+1wK0P4SYgUm1Q/DHVzZkK+njCA
9nJm10Wa/8IGHvt9w9Y4jDb7foa/ZxRe0TodN7WXBmUdt7jcZI3BkRfH7oax
9sNS32M2XOPjcMK/c84+WQeOxv/RX16ahA9Na1X5FLQgZhjR6xY6BVuiwwuL
9mjCG2ViWczpKXinbdXhdJoabNDO8VbznYZPjvJQpyRVoWgBtjuRNQ015QkU
yWYl6KTUNLl0agZaVgetKDdQYNYzj7cuHTPQr6brfTWfHByXXAyptpuFDvTu
oF0iMpCacEdPtXEWakuMbhpK2Abz6JXLo7ZzcCQ2jOZqJAbl6jmleW1zUORJ
67vJKyLw8bDWP37O89DC/ge78Iog3Mzjq6/WPw+l/c+Wn5raAG/KZnImvNhw
/pY8XqrHDVexzjL6GBs+Fxb0kDEjwCDHrWHnzi/ADTXjcndXlsBIyCGaJnsB
pr8sy81LmAMnSexqycBFyPQqpfz2mwLf4p4e4ZpYhNjkcr7+phGAbz/QNuKz
BOUUVd80XR8Ab7Jn3JoHl+ARNcdeXb4eQKGmjpW5LsPbzY8V7Vi/QdJnk5DM
rmX4d+HbrYN7m8EGy8n1mOMcWOV/5NoljwZwuf3RreBWDvTJdD93xKEGSPEP
CX04sQLhqLhN1UUG+LifmrTSuwLF+7gDx0Xfg5M+Edtx71WoAlm80qGFYPVR
U3rExCos+LaHQpV5BdKYMsq1QWtQT/h+js/ocwAW/ej8nDW4JYQ02+74GPxR
+ki1vLYO/znPdfjcl3jAUOXpZpII+FHW1z7RymjwWU3iQ6EJAZciuFEdqddA
haZqYnIUAV/byXbNKQ0FVdogIKKOgMtwzH/s1T8HqnWOWvgKEPEbTrUXUsin
QY2eh4LdYSL+nrf0S88rJ8DEQgkgjojfVXLZa9VoA+rw2x2KTUTcPZLb+oGh
Bfhi9KRYaAsXfurYkEOxkQGoW/MOibHiws97bht6p6YDmB+09/HFcuGq/sQS
vRE1UBtEYN/4yoXbC9ZNlV2kgBr1+iIuPhJOemI0yTO+DVSPPAy+YkrCHclm
dvMPhEFVljt1JYKE+7n/812zkRdUnlKfv/iZhAsWbMxR8FjFKqQ47+bXSHiu
6g3Jaw0zmMMuydmnBtz/DSk+2HWVhU1q62haRHLjGqbFC829HdhNA7uAuRpu
vJtcxz5f3Yhtt7yQn8bHg8ulLVUeJ1VhbxzjR80P8eDFe066Hnpdgpl70ZVn
Y3lwn8SnN8Uac7HuCw1eT5p48OtFLUFie59hwVdHs8y28uJ53O5RKUX3sX+t
V/LKj/LikZNrgYWeN7FoyqZ31DhevPJV+J2SZ5exePaOsrx6Xlz+5BfdjHMB
WDJTrUKen4y/CleznfN3wzKSYV2yGRlPs6nzuBxqh+X5WjUK3yDj39d9rzQ1
m2PFwPVXdAUZp4zNsI9H0rD//ymuRCkd+2Gkgf0HvjgrSA==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vk7lG3DwPEZ2xSibJElREJEtszMdZ6XfYxuJVpushYpRFnu3GlPRdZE
JUmWnhZbKFnqnJFllLKTXXZj3xnb877H8fzwPT7/wlfBzfeYOxeBQHj3f/2/
aPvl7s1NEsP4it+tdlsbshM5MftSGYnRuZ2lyVb0IK+dKbvef5fEGJT4IZ26
LYR8qFBkd9VWEqM4IsDwynoGOdcx3zlKlI8BVAcln4ctk4dk3SZz17kZQpRu
pe/sV5QDclYndQW4GPf6erbNvj9I3WIbkin7i8gI8FdOSfE1ofbezyKSYokM
4wefkwNE7KgxM8KZbRJEhlycKTVuOIDqudeI+K2NwBj5om82JhZKxR0un8hM
IjAEu/dfLNgZT5WMSXsf70xgeHysbe6aSqdOlzcRbigSGBETnnankguobkfP
5QQyNlFIk/fOv49WUPsllB0nKJuoPNvPjq+pmXq2q4/fvXAD3TR5WstSHqIO
paV87jy4gUL73to7mSxSPS84edhlr6MCu3tO8+p8GFtLRqxGdR39COmK1+4V
x7yX2pgmGWso1y30lKabMjbx5Ylvifwa+mSYt+jwURcLEBuwFchYRY1hT2Tp
JBOMc0HrkIPqKnJIb21mn7TBbjJDZN5ncZDSzsESwdPOGJ9kNWFVm4PCQ1xc
LHd7YxEXxQfpn1aQrVb4ei93MCZS4VqdSF5BlbGL261E7mFPpbOz2F+XUefo
sSZRmzhM7jInlmyyjD49z+LvL0/BgpRTgw98WUIsEXJmpH429vO3pauSwRJS
r2OZPV8oxpQiZmhSHxaRwsFWqfHGKiwEPtMSUl9Edawpa53OJqxpFpfkzlhA
5bxMo1KJPkz99cjmktwCGuqKdWwVmcJu/x0zPP50HnlgtgWFvhysXfBQ7R+R
eWSt5Ggta8EH6kZJ92nRc8iLqRZ63VsEVFS2ghyBOTRqDwKRthwoTvvPoviD
WbQ1JwPtursP5N78JzuEZxb13Bbu0y/SAa8dLTz6b86g7fWetcTLECSRd8rR
16eRgJ6brnsLDTzaOdycGzyNkksedh/xswVCoz7SB8ankLqKXxlprxPg+qa2
nLk4iWTyC8PxOx5gKWm4SY04icLCbdSssvzAeFD6hzcCE0gz592VxttXQO9R
16i9EuPI1cngw+3uW6BJTc4rXX4M2XmcOs/4HQZYPB0Wiups1CX1JRp/+AiU
dj9RStEbRSqXOhnv3RPBh892RDl8BM3Luvn7pqUC2mHWwKDeMDI63ZeV0f4O
9PRQWFnqQ4jp4Hh1t1o+CPLPeR+oMIjY0ZRMXqkSsI20JxrbOYD82M8fn+eU
gfTEhMu82/qRu5HoTMLx74CiyX/iJ1cfApkbO+OlGkAD85ph/HIv+hDMpdSS
8Rs0vOszLO7sQYR9s0P8Kb1ARISn491YF8oxTRVvqRkEx4KVQ55zOtDSTWFT
mv04eNRrLhuxtR3dLd9idslyFjRaeH4NkfyN3Hycx+Ldl4BYTpizj0oLMnJF
wsW568BO4j3BSb8J7fGzf22awwUfX6t5ZW3WgLR3uWoY2ZJg08CEMbSrQz4f
K98G/hGEuwadLSfbalAuoemvgbc74EPCgKCTQDX6d5kc3u4rDtekPet+UiuQ
nBD17litFLxoMB6HXWQi0kpKskaLHEQZvdn2sASdjNvSf8FcEaZ2juiRU/NR
cdUGmXFNGfKr9AXr8L9B+q49FLKoKkxRHRQefBmL3KaDJ+f4NOBahBmnsCUK
RrtqFtI7taC1g3ioNeUNpOt9/bZ+Tgd+yhCqtkgrhR+LNHTZBEPYfXQfn6B/
GSRVxAvT1imwz7paJeBxJfxm1H1lhB9CNl3Ay7T1F6Rpe8nExBrDswPS3gun
6qHn4eAKoSkTaLcnL5Vm3gjBSI2BHtkMmrrR2p7rNMOG8YP+tt7mUPdVt/CU
fCtUO9K3OX3dAir1BpgbC7XB/a1puXzeNCi2W+Ba/Go73OXxqFRf0xLyOL3K
HxnphKxaP3sC0xLOJRmwKS3dkOfNd9VxeTo8opsbdi2oFzI1AuXrDtOhUqKp
XNetP1Ba6FEpryEdcjZ/51Ej+6BlXMoFmSFLWOvuY5H0tB8WEs8unT9hCdN/
EDtX0wZgR1N1wmQkDf6rneDnkDMI1zWM7yo/soBHnqjxlhQPwfy/TltVnDeH
Sutfn+2qHIZvFXuZ/jJm8Iswd1RCzQgkzoQSzYtM4AlFi9sijaNQatap9I6x
MXxgUXuBv3cM/g777MsbAKCCvajzvaFxaCY8XqFxkQKLvU/ack1MwAJ2q/6z
q4fgWGwPhbMyBVvMpukTKwchZnznj9s/0zAEzu1QTdeCoSUSGayZafhh/WJC
yfx++FP3naem9wwUWKmtEtrYB8Wzsf2Ph2agO5NMjPBQho4q9VMrLrNwtTWK
m19TEWaknM137piFhTxc4S/T5eCE1HJQxfE5OKz/InokWQrqxT0kq9fNwf32
i3+u4+IwM+cbZ8xuHlqZtflQDu6AijWrxZlt8zDsq6PYSKwAfDaic9XHaQHm
RtbW7x3khdt5vSma/Quw8YtLwZohEd5TSF+dPLcIHQTVnUraOWAd6yzJGV+E
/Send6SWzoMAe7EQv0tL8Jl8SgyteAqwgw5TtReX4ChHYe2bwAg4zb1YIXV5
GSr0XB8+59kHfkW/PMI1uQx5UuZ6z813AFzGso19fgWycKcXvduaQd6bWbfG
wRVof8Pm7XRALVDSSxovceVAcmrzrOiRKpDANAtK7+JA4WqRjy8UmGCL9dRm
xN+r0DtJpcGM8xn82/40LLB5Fb48dlUsVTgPSPMPCxc5rMGW8Ngz5lpvQamh
XsLanzU4tiZVlO3+Cpw+f0cG91yHW2vrVSJ/PgHrT+tT70yuw9wJjuOEfAxI
Zu1WrQrYgF2eIS5qr0MBWPbJ4V/dgBePnSg8zAoBPSqleta3NmHS6Te+fnOX
AUOdt5vFTcATmLHnGYWegKkpWfTBjICnxGgJuEi6gDJt9ceJ9wn4Z5Yf/Xu5
HSjXBb53qgl4eu4zgdRIOqgwsKF7CxBxLbUbGXH1OKgkn1U+/hcRL1a8N3JA
Rg+wsH8IIJqI76CP7u/E1UA1Ht6xt56Ib4hqk37tlwffTV58Ehblwt0UX/+I
RaKgesMzKOIoFx6gsc3aq3ALYBXp6m+N4sLx2CtXp3I2sKoAwmLoDy7cwDZE
tXtwFqs8UPORays3fsGDWMWWGMYq2E8Cb5hz48k2kTJwrQMrzzijt3aHGw//
Mi662FCHfXM5sHCFyY1LrFXwi+0ox8qkVwsWNrjxPH2v2wZfC7FT+6TmXhrx
4O1WkSL5qe+wKV0DbfpdHlyS/7TOo2cvsHtGx33nK3lwlXTlXjY9BpOx9s9K
3sqLx7a2/v63/BaWZx87RjvMi3uZes5maPtjtHM5qnNRvLhflG6YVfhZrNv/
57kX9bx4jEwxhVZ5HAu8OZZhIcaH50UXXa3sMseuH1vL/GrDh3++X59jwW+I
PVDaVqAXzYeLvTwV+1JHHYtdlC3JrOHDKRqLzCNHZbFElmbZHn4SfqzOinXm
hDCWlgirEy1IeB0PSan7BQHL9D5atyOUhBP+CCKtqzPUT8C19UEZCS+dDCr0
Bn3U//0oTvM62wf6G6j/BWS1LMg=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHzvgeaD4ScE/aYruQ/HFOBH9D7Ob4
PmE2OP+ZbNK7DX+Z4Xx9Oe9wE24mOP/DkSsM9UoMcP7bvdPzdyv82Q/jyxX9
mmjl/APOv8Vjcf6h0Bc4n+9lrrT+m/f7ldLl5IL5UzQ37ghhlHN4AedfWvXI
cted+3D+lSdvnexDLsD5CzSf8j+dPxHOf+XFne1y/Zz9Tx9WIQm2Z7qf55i/
sr52D85X+btvptSx53D+64n3rX/9fA/nm07uttK+8Nkebl6Zj43ht+9wftWt
GZ2lV3/D+Qe0We+dYGZwgPFPOc/dxi/MBOcfkv695es/Zji/tOH1UncRNjh/
1gm9Q8pc7HA+NH7gfADOsrtn
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vk7lGsDwPFhLCFLlsJIthb0khjrc9/3UwnJiZA2RVJRRExK6VREC4dD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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk4lGsDgMeMsY2lgyIiMSgcHR8S8z7v8+aEqCYKHXWOLZUiyppKm0Qn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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHlNLl5IL5UzQttgvJH+dE8DfEbo7v
E2aD85/JJr3b8JcZzteX8w434WaC8z8cucJQr8QA57/dOz1/t8Kf/TC+XNGv
iVbOP+D8WzwW5x8KfYHz+V7mSuu/eb8/Zv0jEfmeV2Ybd4Qwyjm8gPMvrXpk
uevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs7ejqMupFY11/rzHPNX
1tfuwfkqf/fNlDr2HM5/PfG+9a+f7+F808ndVtoXPtvDzSvzsTH89h3Or7o1
o7P06m84/4A2670TzAwOMP4p57nb+IWZ4PxD0r+3fP3HDOeXNrxe6i7CBufP
OqF3SJmLHc6Hxg+cDwBoEb+u
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlnc41vv/x+9hZGSTVKSMJhE5ue/P+/UpyShyrJRIRmSk7M7JMUqpRKWE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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vc/1W0DwPFzjnHMzKRIiSLKyjzO97q+WQe57VRkNVVKWUWUWVZKZpJk
3HdlhpvM6yA6RAtllOy9jz2f53m9nh8+r/e/8JE852Z5kUQgEHL+2/9E/O49
29tkenhKf/LvojaKAyU571Ytmc6XqRwhfnSMsnG+9t5ACJl+uvSjFo/jFkWz
VHDfR04yfUjPyjTq6UHtAvsix2ghdrrbqQn+8joP7eG956YLNlnobU7b2tyt
glRFiROnVLlJ9J7TdzQzLZOpHFZ+OXs/E+mBSvxqebveUnsf5hLJMUT63ibf
u1uvy6jvK3tsZq2IdCrdZ1ies5H6ZI4vp1OESN9jpkQb1u6guhw6TqzrJNDT
tXapf9cfoeJ27jY5KQT62ats184eWaKKPsnIjnck0EPlHjMfLLJisx/aCPcP
EOjmN6k9hf8IYefML+d70beRm2lhYYqeFDYgctB+SnsbScmK3npRooJd+N3P
dbF0C63xKklGEHWw4Yy0979UtpB0F6FBVs4Cc7nqcMk6bxN9p6sPr6k5YeNK
4sLNhzdR342QIhabG5jrcmeNbtYGivW2qiXs88OmqhLdKvZvoIsHMgR8W8Mx
T+FBK+6sdeThoBqQEZ+ArV1V0rQ7vI5mh0g/hBIzsIAaP/Hs3DXk5lBlt9ZV
gLGLNhLWldeQXoFCpWJ9JRZ1Y+eQcckq8lkm/2TaMjDBeufGZMoqigi7g+56
tGFJYnm549UrqELLQy2fow+TcF+LoeiuoFENy/dOBycx74PpPopVy+gPj2pc
H3kFa+kwcpbWWEYWOlPMp5asQDpqznD3uyV0YbDkDJFdAPjBZ0o75JcQ83xE
QTMUB23zuChL1iL66eOWel5DBsj/Pbq9LLGIDgWoe8kPq4CgM09GJpMWEIeC
+LtjvgB08Wh+6RNcQIN9MM32lCH4OkZ+aPiYidq9nssNiFqB+oafIJ+biTo5
uxN3v7MH5Rn/LO0Mm0fLnrELUz2XQEHA7Tw/1nk0oyhSkel5C/xtT7s0EDCH
TuU5pTEu+YIUyi4J481Z5JXC0RbBCAZPd420F/jMosDVY/djnB6BHWPXxRQn
Z5AFX6FTZUo8INXJreQsTaPKO29PZ5SnguWUkTY54jQ6U3zJczM7C0x6Z757
zT2Frp5PEj1qlQd6zZ2jD4lMIsF3nPOyPP+CNjmJa5n7J5DNa6+4sfVKwGDt
ph2QH0fbJVUkteY6UNmTKJ2mNoZG9oefi29rAu/eWxMl8FF0ddn+oiLnd2Bo
whgcUhtBu+Tl7FUyOsCfP9qMXPlhRB4ySIjP7gXeHvnZXpJDiKNmRyTHmWHA
S5Z6jO0aRFeUUmFZ7hTITE5wZ+MdQFVOS89bQplAW4HLpoXUj3g8NheTb62C
7zX+WvErvejJE2eDTlcC/P62X6v81x8UGO90kp/EBgUFWbvfTvxGW3Va3H1q
XNDS56Df87Vu1NB/9VWiBj982muwN4qzC5F35bv7jwjBVppLtZ9oB1rRrBti
UkShcH6443WZH4h0OeKG//G90Fokm+Cg3obIAj4JYSGSMM6/+ZWp/nck59ob
mvlZGrYNTulA66/o8KdpAzxYFu4ZcjSa7mxG9k1n2l9EH4GRhEEeB+5GpKAd
qkUIVII3NCZjsRs16GN1iWlzmBpEWb15trACUY6kK6qbacL0X6NqlPQiZG7s
Ky9A0YZph4f4hl7GoEJNueOZuTjciNJfK/0RDb1UrVRuOulAU7udoabar2HA
JfP6XD49mPemOfS2UzFUbdfLKinUhyVZOxppGZVQlztG/z5Ogz3msuw8HrXQ
6c3n0yP5hrDftFHGM64BJqbGuAisGMFhk6tGv/5tggODiQJV/CfguDH3Nb2f
n+HSU8mZ1PkT8MKgmOvi6W9QV2ujOTPaBFpLFaYbGrTCh6/YD7HOm0C9c4ad
z4+1w4id/dxn9/wFVV/18M3s/wmDTnSVFLH/BaV7PQ10dnTCN+Pjd0NKTaDw
Pm7/+PUumP5neqZYwQSyOrwqGh39BVV8X/mHup2AzBSNce0fPVD6kEWw2z1j
aKZaEO7v3QsFlldWjtKMoHSynsTvwD6oXsCWMTVAg2vbHYXUR/3wyMeKR6n2
BvDLxeu0lKQBqEriTXxZpQczPxF/rWcMQhXTsClHXl3oq5xw0y5/CDLZQwG7
zXEovVn9bE/DCNQzL7ZqG9aGVXws0QnNo/BnrEj/jwpNaHOAFiTYOgZj0iNK
usvU4IxqpHd05zh0C+Lh5RtTgWG0L1e5eieg5Ud335NmSlDSVsjxwfAklOFy
dmb0ysNy11NWpKkpeEzY27z7uQy0vP+cdo85DYFZil7FFyk4EfNHe211Bg7O
yUYDn/0Q0wnuO3d7FpqxfeOeDRKDoRUiWYy5WVh61nLkUpMIbFF966LgOgcj
xXIdVssF4c487Ejc8Bx888Z2kytyB7SX+Taz6jQPXxSWm+UWc8CstAtFjt3z
8K4dn9TlVhY4tXvFu/4kE45F6bjTYraBWmwkRf4rE1Z9laZVTa+AnPy6tQnr
BRjZd1rEVpIJDjSvl+d0LsDL2fZF1junwLPRY3evOyzCeaOjGi3DQ4CfzVVb
YWARmroZvlyx6QUPJDPXpy8vwWd+spU2Mh1gE/tVkT+5BKXXhThT878BT1th
v5u3lqHA6nca43UjGPc2oSovLUPdRS2Jspu14CzLUv1u9xWonEezGPtdDj4/
fmlGml6BM9flxOqvFAFc3Khz/MoqXPJnL6pozQaFr+fPtQ6twn1fV/5RYWQA
abWUyQrnNXh2Ycd07dBzkFCj7535ew3yuJTTF4JiAYfpzHbUmXUYFd8ooisY
CXy7ksK92tdhG1c49V1aEBDjGuErs9uAp2uOFTxKvQMqtdQSNvo24M9rtunY
3pvg7JVgcdxlE5JlXmZ+HbwANpO+pQdPb8IxeQ1Lw3ZbkMrYd/ij5xY0r1iI
2OC3AGDlej7X+hac/3GuLylAH/yRqVQzDdyGA74hb2zbKYAuz9bDYCHgImEJ
djfilUCNgmjZO30CHvgjrL/YTxrUKsvHJT8k4PWlNiLvhXaDD6rALbiRgL9h
Ya/uurID1GtYGLtyE/HBJt52VgMSaKBcOHjyLyKediea0lGziDGw2wTwmIh7
++hKfH87hjXiEd2HvhFxnWfVfuGEHqxJ90UJnxAJb6owl0t3/IY1brl4R5mT
8Lpl9vtSRR8wRpmqOmc0Ce+8eDvg2O332EdPwlLoJxK+MEZU98vPwRoUm/8l
cbLg1kZnXmTkpWH144le9w1Y8NxdPF0hMBb7kHVebSOYBS/TGOTeIj/A6pwU
F+/UsOCxBX4h/Sw+WK3YevHiFgs+csrbZN9RV+y07G7my+Os+MQzymvDZXts
RlVD2TiEFXcJzyTPx5hhD46fdFtoYMXtnWSrLX1wTNzUIzeVkw1naanx5+ZQ
xgptYyYMTdhwOR+GusEtSczwcv5hZjQbrs9/y0SsUADr8Wi5/OIbGy7yKedt
OYOIeQVMZNGE2fGHRhdPBhbPUe9ZbuRUW7DjSa69E7xe/dQwad5itcfseH5H
cctNkVZqzNLeipxmdjyoSeb4WlwdNZmhUCvFRcbr9fpFSqeKqBnJsDGZRsYP
SPdOPJLIpOa4mn8VCCXjfvJ1xtaH4qglwPlnWC0ZF15+EtzFGkL9/6/iOZSB
mKlyD+p/AEU4Ohs=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQB2IQvV+g6N7//+wHbhx5oP29+aiOxXYh+eOcCP6G2M3x
fcJscP4z2aR3G/4yw/n6ct7hJtxMcP6HI1cY6pUY4Py3e6fn71b4sx/Glyv6
NdHK+Qecf4vH4vxDoS9wPt/LXGn9N+/3e3w4eNmt0sdq444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/D89rr+2X+uz73uWYf/W6bydX7Ro
q5/1Cjh/3cozreUJW+D8bUv5Trov3gPnP/I7qV4y5Ric/8qLO9vl+jk432Th
Pf73Ctfh/M9zzF9ZX7sH56v83TdT6thzOP/1xPvWv36+h/NtnZofJpV/sIe5
t3W32NITHxH8syarMvRyPsL5outsdaY8Q/CXLkjZHH/7E5xvOrnbSvvCZzhf
gDXHWu/xVzj/VZmPjeG373B+1a0ZnaVXf8P5B7RZ751gZnCA8U85z93GL8wE
5x+S/r3l6z9mOL+04fVSdxE2OH/WCb1DylzscD40fcH5AI62TNs=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk7lHsfgMeMsRdt4ogWkihLETHP83kqRSmKiU5EWoRGi61Nkq2cHEtJ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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vk7lHsfwPEZYwlFIUukI8p22u3mvj+3kqEkSUW2lKKOyh4iIqVDJBLS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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQB2IQvV+g6N7//+wHbhx5oP29+aiOxXYh+eOcCP6G2M3x
fcJscP4z2aR3G/4yw/n6ct7hJtxMcP6HI1cY6pUY4Py3e6fn71b4sx/Glyv6
NdHK+Qecf4vH4vxDoS9wPt/LXGn9N+/3e3w4eNmt0sdq444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/D89rr+2X+uz73uWYf/W6bydX7Ro
q5/1Cjh/3cozreUJW+D8bUv5Trov3gPnP/I7qV4y5Ric/8qLO9vl+jk432Th
Pf73Ctfh/M9zzF9ZX7sH56v83TdT6thzOP/1xPvWv36+h/NtnZofJpV/sIe5
t3W32NITHxH8syarMvRyPsL5outsdaY8Q/CXLkjZHH/7E5xvOrnbSvvCZzhf
gDXHWu/xVzj/VZmPjeG373B+1a0ZnaVXf8P5B7RZ751gZnCA8U85z93GL8wE
5x+S/r3l6z9mOL+04fVSdxE2OH/WCb1DylzscD40fcH5AI62TNs=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vc/1X0fwPEzcHIUlwhF9qiMUkbG9/v+pkJLg1JESOWqUBmlSGVWLqNC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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk41Hsfh2exZIQOKp2QJJGyFMny/3//bWiTLC0KEVmOKKHNUiE6OSSS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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHjN+9EMq/eVDZYruQ/HFOBH9D7Ob4
PmE2OP+ZbNK7DX+Z4Xx9Oe9wE24mOP/DkSsM9UoMcP7bvdPzdyv82Q/jyxX9
mmjl/APOv8Vjcf6h0Bc4n+9lrrT+m/f71yj+O2k+391w444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/Fde3Nku18/Zfzu8/Z3z+5Omn+eY
v7K+dg/OV/m7b6bUsedw/uuJ961//XwP55tO7rbSvvDZHm5emY+N4bfvcH7V
rRmdpVd/w/kHtFnvnWBmcIDxTznP3cYvzATnH5L+veXrP2Y4v7Th9VJ3ETY4
f9YJvUPKXOxwPjR+4HwAAuTkvQ==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk3lG0DgGcMJhRRthRhEMoSEzHPfT92qSRbUsgWylKyVC9vC0UlEqmQ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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vk7lG3DwPEZ2xSibJElREJEtszMdZ6XfYxuJVpushYpRFnu3GlPRdZE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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHzvgeaD4ScE/aYruQ/HFOBH9D7Ob4
PmE2OP+ZbNK7DX+Z4Xx9Oe9wE24mOP/DkSsM9UoMcP7bvdPzdyv82Q/jyxX9
mmjl/APOv8Vjcf6h0Bc4n+9lrrT+m/f7ldLl5IL5UzQ37ghhlHN4AedfWvXI
cted+3D+lSdvnexDLsD5CzSf8j+dPxHOf+XFne1y/Zz9Tx9WIQm2Z7qf55i/
sr52D85X+btvptSx53D+64n3rX/9fA/nm07uttK+8Nkebl6Zj43ht+9wftWt
GZ2lV3/D+Qe0We+dYGZwgPFPOc/dxi/MBOcfkv695es/Zji/tOH1UncRNjh/
1gm9Q8pc7HA+NH7gfADOsrtn
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vk7lGsDwPFhLCFLlsJIthb0khjrc9/3UwnJiZA2RVJRRExK6VREC4dD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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk4lGsDgMeMsY2lgyIiMSgcHR8S8z7v8+aEqCYKHXWOLZUiyppKm0Qn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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHlNLl5IL5UzQttgvJH+dE8DfEbo7v
E2aD85/JJr3b8JcZzteX8w434WaC8z8cucJQr8QA57/dOz1/t8Kf/TC+XNGv
iVbOP+D8WzwW5x8KfYHz+V7mSuu/eb8/Zv0jEfmeV2Ybd4Qwyjm8gPMvrXpk
uevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs7ejqMupFY11/rzHPNX
1tfuwfkqf/fNlDr2HM5/PfG+9a+f7+F808ndVtoXPtvDzSvzsTH89h3Or7o1
o7P06m84/4A2670TzAwOMP4p57nb+IWZ4PxD0r+3fP3HDOeXNrxe6i7CBufP
OqF3SJmLHc6Hxg+cDwBoEb+u
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlnc41vv/x+9hZGSTVKSMJhE5ue/P+/UpyShyrJRIRmSk7M7JMUqpRKWE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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vc/1W0DwPFzjnHMzKRIiSLKyjzO97q+WQe57VRkNVVKWUWUWVZKZpJk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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQB2IQvV+g6N7//+wHbhx5oP29+aiOxXYh+eOcCP6G2M3x
fcJscP4z2aR3G/4yw/n6ct7hJtxMcP6HI1cY6pUY4Py3e6fn71b4sx/Glyv6
NdHK+Qecf4vH4vxDoS9wPt/LXGn9N+/3e3w4eNmt0sdq444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/D89rr+2X+uz73uWYf/W6bydX7Ro
q5/1Cjh/3cozreUJW+D8bUv5Trov3gPnP/I7qV4y5Ric/8qLO9vl+jk432Th
Pf73Ctfh/M9zzF9ZX7sH56v83TdT6thzOP/1xPvWv36+h/NtnZofJpV/sIe5
t3W32NITHxH8syarMvRyPsL5outsdaY8Q/CXLkjZHH/7E5xvOrnbSvvCZzhf
gDXHWu/xVzj/VZmPjeG373B+1a0ZnaVXf8P5B7RZ751gZnCA8U85z93GL8wE
5x+S/r3l6z9mOL+04fVSdxE2OH/WCb1DylzscD40fcH5AI62TNs=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk7lHsfgMeMsRdt4ogWkihLETHP83kqRSmKiU5EWoRGi61Nkq2cHEtJ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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vk7lHsfwPEZYwlFIUukI8p22u3mvj+3kqEkSUW2lKKOyh4iIqVDJBLS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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQB2IQvV+g6N7//+wHbhx5oP29+aiOxXYh+eOcCP6G2M3x
fcJscP4z2aR3G/4yw/n6ct7hJtxMcP6HI1cY6pUY4Py3e6fn71b4sx/Glyv6
NdHK+Qecf4vH4vxDoS9wPt/LXGn9N+/3e3w4eNmt0sdq444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/D89rr+2X+uz73uWYf/W6bydX7Ro
q5/1Cjh/3cozreUJW+D8bUv5Trov3gPnP/I7qV4y5Ric/8qLO9vl+jk432Th
Pf73Ctfh/M9zzF9ZX7sH56v83TdT6thzOP/1xPvWv36+h/NtnZofJpV/sIe5
t3W32NITHxH8syarMvRyPsL5outsdaY8Q/CXLkjZHH/7E5xvOrnbSvvCZzhf
gDXHWu/xVzj/VZmPjeG373B+1a0ZnaVXf8P5B7RZ751gZnCA8U85z93GL8wE
5x+S/r3l6z9mOL+04fVSdxE2OH/WCb1DylzscD40fcH5AI62TNs=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vc/1X0fwPEzcHIUlwhF9qiMUkbG9/v+pkJLg1JESOWqUBmlSGVWLqNC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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk41Hsfh2exZIQOKp2QJJGyFMny/3//bWiTLC0KEVmOKKHNUiE6OSSS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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHjN+9EMq/eVDZYruQ/HFOBH9D7Ob4
PmE2OP+ZbNK7DX+Z4Xx9Oe9wE24mOP/DkSsM9UoMcP7bvdPzdyv82Q/jyxX9
mmjl/APOv8Vjcf6h0Bc4n+9lrrT+m/f71yj+O2k+391w444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/Fde3Nku18/Zfzu8/Z3z+5Omn+eY
v7K+dg/OV/m7b6bUsedw/uuJ961//XwP55tO7rbSvvDZHm5emY+N4bfvcH7V
rRmdpVd/w/kHtFnvnWBmcIDxTznP3cYvzATnH5L+veXrP2Y4v7Th9VJ3ETY4
f9YJvUPKXOxwPjR+4HwAAuTkvQ==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk3lG0DgGcMJhRRthRhEMoSEzHPfT92qSRbUsgWylKyVC9vC0UlEqmQ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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vk7lG3DwPEZ2xSibJElREJEtszMdZ6XfYxuJVpushYpRFnu3GlPRdZE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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHzvgeaD4ScE/aYruQ/HFOBH9D7Ob4
PmE2OP+ZbNK7DX+Z4Xx9Oe9wE24mOP/DkSsM9UoMcP7bvdPzdyv82Q/jyxX9
mmjl/APOv8Vjcf6h0Bc4n+9lrrT+m/f7ldLl5IL5UzQ37ghhlHN4AedfWvXI
cted+3D+lSdvnexDLsD5CzSf8j+dPxHOf+XFne1y/Zz9Tx9WIQm2Z7qf55i/
sr52D85X+btvptSx53D+64n3rX/9fA/nm07uttK+8Nkebl6Zj43ht+9wftWt
GZ2lV3/D+Qe0We+dYGZwgPFPOc/dxi/MBOcfkv695es/Zji/tOH1UncRNjh/
1gm9Q8pc7HA+NH7gfADOsrtn
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vk7lGsDwPFhLCFLlsJIthb0khjrc9/3UwnJiZA2RVJRRExK6VREC4dD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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk4lGsDgMeMsY2lgyIiMSgcHR8S8z7v8+aEqCYKHXWOLZUiyppKm0Qn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          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHlNLl5IL5UzQttgvJH+dE8DfEbo7v
E2aD85/JJr3b8JcZzteX8w434WaC8z8cucJQr8QA57/dOz1/t8Kf/TC+XNGv
iVbOP+D8WzwW5x8KfYHz+V7mSuu/eb8/Zv0jEfmeV2Ybd4Qwyjm8gPMvrXpk
uevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs7ejqMupFY11/rzHPNX
1tfuwfkqf/fNlDr2HM5/PfG+9a+f7+F808ndVtoXPtvDzSvzsTH89h3Or7o1
o7P06m84/4A2670TzAwOMP4p57nb+IWZ4PxD0r+3fP3HDOeXNrxe6i7CBufP
OqF3SJmLHc6Hxg+cDwBoEb+u
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlnc41vv/x+9hZGSTVKSMJhE5ue/P+/UpyShyrJRIRmSk7M7JMUqpRKWE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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vc/1W0DwPFzjnHMzKRIiSLKyjzO97q+WQe57VRkNVVKWUWUWVZKZpJk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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQB2IQvV+g6N7//+wHbhx5oP29+aiOxXYh+eOcCP6G2M3x
fcJscP4z2aR3G/4yw/n6ct7hJtxMcP6HI1cY6pUY4Py3e6fn71b4sx/Glyv6
NdHK+Qecf4vH4vxDoS9wPt/LXGn9N+/3e3w4eNmt0sdq444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/D89rr+2X+uz73uWYf/W6bydX7Ro
q5/1Cjh/3cozreUJW+D8bUv5Trov3gPnP/I7qV4y5Ric/8qLO9vl+jk432Th
Pf73Ctfh/M9zzF9ZX7sH56v83TdT6thzOP/1xPvWv36+h/NtnZofJpV/sIe5
t3W32NITHxH8syarMvRyPsL5outsdaY8Q/CXLkjZHH/7E5xvOrnbSvvCZzhf
gDXHWu/xVzj/VZmPjeG373B+1a0ZnaVXf8P5B7RZ751gZnCA8U85z93GL8wE
5x+S/r3l6z9mOL+04fVSdxE2OH/WCb1DylzscD40fcH5AI62TNs=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk7lHsfgMeMsRdt4ogWkihLETHP83kqRSmKiU5EWoRGi61Nkq2cHEtJ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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vk7lHsfwPEZYwlFIUukI8p22u3mvj+3kqEkSUW2lKKOyh4iIqVDJBLS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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQB2IQvV+g6N7//+wHbhx5oP29+aiOxXYh+eOcCP6G2M3x
fcJscP4z2aR3G/4yw/n6ct7hJtxMcP6HI1cY6pUY4Py3e6fn71b4sx/Glyv6
NdHK+Qecf4vH4vxDoS9wPt/LXGn9N+/3e3w4eNmt0sdq444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/D89rr+2X+uz73uWYf/W6bydX7Ro
q5/1Cjh/3cozreUJW+D8bUv5Trov3gPnP/I7qV4y5Ric/8qLO9vl+jk432Th
Pf73Ctfh/M9zzF9ZX7sH56v83TdT6thzOP/1xPvWv36+h/NtnZofJpV/sIe5
t3W32NITHxH8syarMvRyPsL5outsdaY8Q/CXLkjZHH/7E5xvOrnbSvvCZzhf
gDXHWu/xVzj/VZmPjeG373B+1a0ZnaVXf8P5B7RZ751gZnCA8U85z93GL8wE
5x+S/r3l6z9mOL+04fVSdxE2OH/WCb1DylzscD40fcH5AI62TNs=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vc/1X0fwPEzcHIUlwhF9qiMUkbG9/v+pkJLg1JESOWqUBmlSGVWLqNC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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk41Hsfh2exZIQOKp2QJJGyFMny/3//bWiTLC0KEVmOKKHNUiE6OSSS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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHjN+9EMq/eVDZYruQ/HFOBH9D7Ob4
PmE2OP+ZbNK7DX+Z4Xx9Oe9wE24mOP/DkSsM9UoMcP7bvdPzdyv82Q/jyxX9
mmjl/APOv8Vjcf6h0Bc4n+9lrrT+m/f71yj+O2k+391w444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/Fde3Nku18/Zfzu8/Z3z+5Omn+eY
v7K+dg/OV/m7b6bUsedw/uuJ961//XwP55tO7rbSvvDZHm5emY+N4bfvcH7V
rRmdpVd/w/kHtFnvnWBmcIDxTznP3cYvzATnH5L+veXrP2Y4v7Th9VJ3ETY4
f9YJvUPKXOxwPjR+4HwAAuTkvQ==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk3lG0DgGcMJhRRthRhEMoSEzHPfT92qSRbUsgWylKyVC9vC0UlEqmQ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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vk7lG3DwPEZ2xSibJElREJEtszMdZ6XfYxuJVpushYpRFnu3GlPRdZE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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHzvgeaD4ScE/aYruQ/HFOBH9D7Ob4
PmE2OP+ZbNK7DX+Z4Xx9Oe9wE24mOP/DkSsM9UoMcP7bvdPzdyv82Q/jyxX9
mmjl/APOv8Vjcf6h0Bc4n+9lrrT+m/f7ldLl5IL5UzQ37ghhlHN4AedfWvXI
cted+3D+lSdvnexDLsD5CzSf8j+dPxHOf+XFne1y/Zz9Tx9WIQm2Z7qf55i/
sr52D85X+btvptSx53D+64n3rX/9fA/nm07uttK+8Nkebl6Zj43ht+9wftWt
GZ2lV3/D+Qe0We+dYGZwgPFPOc/dxi/MBOcfkv695es/Zji/tOH1UncRNjh/
1gm9Q8pc7HA+NH7gfADOsrtn
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vk7lGsDwPFhLCFLlsJIthb0khjrc9/3UwnJiZA2RVJRRExK6VREC4dD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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk4lGsDgMeMsY2lgyIiMSgcHR8S8z7v8+aEqCYKHXWOLZUiyppKm0Qn
cSzRwSFbiCylBfHYG0VZs4bsBmMZJlma73zX9f24r/vf/fve4ep99DSZRCJF
/8v/jDb5DPD5wlVlS6OGCm0rex1NEgsu1QhXrcbIdm4obTJeP1VzfeSOcJV9
atf9S7V0472vpbe/ExWuwlMz3r5vtTYu+uOFU6SMUJXD3R46WyzTeFzJlVO0
QamaYXQHmw1Zm+xWPnjcgEau+vnw9+2ft4yazNd1kG6okqosFYgwU/NzjNmK
BO9ylXUkQI9e3IbPMpR9VqNNfl1B/lNqjqXUk1iAenrQ7opvqM1Bh3qC5Y41
d1u60I2+oUO0IYpVSAB2Df79i6Q2D/G5PzZ1SsRgHYuEPCVrGfn5yLmZD6Vi
2k8m+d+Ul9G6dFLqzcE87LbDXxMzj5ZQWv3jrD30N1iv+N5PX6WXUCltpoj6
qg5rmRIOOxDFRZqWHlaXvVqx+oYuvJDGRc3q0VZ86S9YWUY2b3P4Iqrep+J5
XGgSK7oZWHBNcBFNvwmYKM7jYk/+sDgzcnMBdVXNihSy+ViyiZyy1cY8yqvE
PtNyREGM3ERnUdA8MhJRDvD3lgWSUxcUd8/MofZ+qIZUVAC5Vmsln8dBLmWU
bdNXd4JvyRMdWgIc1DKclNfm/R8wE5BZnEObRabnR6ej7jPAkLVLpMaWGTQ+
UGCff24/6NBS9shUmUa3my72+VKYgCXYZ6GqzUZ6eldIySN24O1AAv2x4RR6
eCSXdiHfCRS/sRVQJiYRbdi1rbT8DDhwiDU6ZjiBRrJvuGXmXQSDgwzWM+1x
xFow6Tq79zII8C3M898xhlBwpKe81y0gIawWBeRGkcC4VbZmbzjITIz3oUqM
II13BbEGD6IBQ1fMvpk8jE7/Y31PK+oRaKsONn64MoSKtKPtwqhpoO3psHFZ
/yC6N+/9uNwpG0hLC/Y9nf6C4hjT0rd2FYKjQerXklb7EPNjwpMziSUgZshc
KUK0F133XfQMpZaDdgv3ymvy3Sh6cc0GxFYD2cJ7Thc0P6PpYhJ7Kb8B2G7J
Iznu6UDZyxoRVwWbQVxwUxrTrA0pzv1cDM+3gY7RWVNo24IuRiTxc3W7gMKY
kyWnpwlt1TimZN/WD+6TRsUdaY1oQ/bgSkrDV7Cu6N7SjNWjQPZZSf3qMeBl
NBMLvKqR48W7O5nn2QBlDRWcgOVI67nzcmLbHEjvnzQ0SX+Bam2jdJ8IcoGY
5nCQvlgO+ixA88t6wAOPd41JjaVGo0t02dyd91bBeoTZ6uvPkfDOxEKkrDMf
ME9uDmUycqAml+6R40zGC3KbQgOdSyBSTFgOtqXir7IkGy0y3sI9zxPdzcJE
8AHrnULivjWQI/nD+5dFGj7MbNT0i2uAT5Xyaj7cl8LZVjSP/V0fIbtM6qVC
hAzuNqroufxbKwxOOWC2y24zbqv2PP2AeTuUipGSkZCXw/e7HuhJ0u+ElBZL
i9dN8rhB2oDUnEoX1GZGGLafV8DpQ37mppI98KW5iIYIWxGX3U4LfrjWCz9c
OdsDTZVwQce0F5OT/XAtqCCe46GMc5ON2IzPAzBns8RBB+ft+BGDonvBAUNw
7lLyb1YyKjg9cb/yl1tfITXdIELcRgVf5Xc/xx4MQ6ZOIPX1WRX80+kLFsmP
RiCzgJWaZa+CZ34Q6F/LGIVxFaUUW2UV/Ipe/MWThWOwUOmnZ4U3/+0naFHL
y8Yh2aUuLOm6Mk7fqPxboWECBtaoAn+ghFdIUSLjmyYhj2zcJd2siNurWtyW
bp+CZisVk1BPAQ+3+HRebGgaNkgKepWlbMF3nJBxujs+AyOx2zOb38riZZ7H
j5FnZyHbi692plMan44eZKx+n4MlXtFTHpgkDkxDvroGzkPByUW5Sq4YHlq+
JYu1MA+pf1GF8jqF8WaDp+66ngvw+W5OzM9TgvjmAqATN74AV4blhGz0yfgf
mq1z350XodSyx2CkFx9kPXZ74dS3CHsZ/FNKs6tgdutKQL0dF/ryw4/vG+YB
w9j7JtotXDjRnl5nd5AL8gtrV6dtl2D0NltxK9YcUG1aK8vvWYJ8s3CzHs4U
+HtS/+oFx2WYMsDPiOONgk1UT4buyDJsOHLqDWocAnd3ZK5xzvKgUpDMrVsZ
vWAD9JcXzvCgHef2J4X5DuB3QvbaxUvfoM+DMpGPh1sAO+AQpsf7Br8afOxL
0mwEv1N49Vt9VmDPfqbGcGwt+BiVeoTMWYHVh7q85E0qAbHNsod97jtMP0G8
oqu/Bs9zFl3bx75Dg1wuZ0dcMaAbJs+Uu6zCMKff6/dcewriq80CMr+sQvHD
B0OOvc8AIsw5foTDGjzrU6UzafcPuNL76J5/5xp0JZeIDf71ECiKTUiVnlyH
ohI6WxtTIsFbY8P49a/rUMT0QB83LBT8fi5kG+G+AZFL2vuWjWCw8ag1PYSz
AR+qvuzzK/IDKaztu975/YAC2bzcTjNPgK9cKBRb+wEb+mxfH1U9BQY13xoy
b/Ghk476jeknDqBKmzrAopAIMxf5FXERG1CtK19abEYiBopzU+djzEGNnnZc
YhiJ6Ooux8yzAKgzwL1DGklEVAOdn2KpD+qNbKw8aQKEg1B3wdSXnaDBxE3d
7rAAwWY4UkXqtgMWCCThUQKEdt7tfW4KsqCR+LNPo1WA8D28XErbIwre//rP
KykZMjETSzmdf4yPNf5wD4iwJhPf7Z/ty5zlYqxSgz2ikWQiG7ic6daYwt75
kXihH8iEzFX52ITgQaxhd9NLsiiFCOlxO28T2Y7VsxP8b5hTiLQb5l8Y8iys
LuuU4XoIhTBs9F+S9q3Aap13L1+uphBnOsZn/XuLsRrFtZLlHxSCVyvO/zUo
C/tt51Zu6j5BQuuynemz0EfYnIGRntUdQSIiQCcmuuI+to3p+yxFlEroWfYu
a++7hPnfnM6ykBUi2sxa9bd2G2HXj67nV9oIEcPFB/OW/tTCwukSJYZRQoQa
Ot4df0QJS2Tp1qiJCRMkNc9KFx8BLCMRNiZaCBP+6ko1nI+LjHxP65afQoWJ
hebkEmOlUcYr3KUrvEaYeCzxLLvSvpPx//8hzrUk5W/yb2D8F/hkbuY=
          
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHlNLl5IL5UzQttgvJH+dE8DfEbo7v
E2aD85/JJr3b8JcZzteX8w434WaC8z8cucJQr8QA57/dOz1/t8Kf/TC+XNGv
iVbOP+D8WzwW5x8KfYHz+V7mSuu/eb8/Zv0jEfmeV2Ybd4Qwyjm8gPMvrXpk
uevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs7ejqMupFY11/rzHPNX
1tfuwfkqf/fNlDr2HM5/PfG+9a+f7+F808ndVtoXPtvDzSvzsTH89h3Or7o1
o7P06m84/4A2670TzAwOMP4p57nb+IWZ4PxD0r+3fP3HDOeXNrxe6i7CBufP
OqF3SJmLHc6Hxg+cDwBoEb+u
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlnc41vv/x+9hZGSTVKSMJhE5ue/P+/UpyShyrJRIRmSk7M7JMUqpRKWE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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vc/1W0DwPFzjnHMzKRIiSLKyjzO97q+WQe57VRkNVVKWUWUWVZKZpJk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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQB2IQvV+g6N7//+wHbhx5oP29+aiOxXYh+eOcCP6G2M3x
fcJscP4z2aR3G/4yw/n6ct7hJtxMcP6HI1cY6pUY4Py3e6fn71b4sx/Glyv6
NdHK+Qecf4vH4vxDoS9wPt/LXGn9N+/3e3w4eNmt0sdq444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/D89rr+2X+uz73uWYf/W6bydX7Ro
q5/1Cjh/3cozreUJW+D8bUv5Trov3gPnP/I7qV4y5Ric/8qLO9vl+jk432Th
Pf73Ctfh/M9zzF9ZX7sH56v83TdT6thzOP/1xPvWv36+h/NtnZofJpV/sIe5
t3W32NITHxH8syarMvRyPsL5outsdaY8Q/CXLkjZHH/7E5xvOrnbSvvCZzhf
gDXHWu/xVzj/VZmPjeG373B+1a0ZnaVXf8P5B7RZ751gZnCA8U85z93GL8wE
5x+S/r3l6z9mOL+04fVSdxE2OH/WCb1DylzscD40fcH5AI62TNs=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk7lHsfgMeMsRdt4ogWkihLETHP83kqRSmKiU5EWoRGi61Nkq2cHEtJ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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vk7lHsfwPEZYwlFIUukI8p22u3mvj+3kqEkSUW2lKKOyh4iIqVDJBLS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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQB2IQvV+g6N7//+wHbhx5oP29+aiOxXYh+eOcCP6G2M3x
fcJscP4z2aR3G/4yw/n6ct7hJtxMcP6HI1cY6pUY4Py3e6fn71b4sx/Glyv6
NdHK+Qecf4vH4vxDoS9wPt/LXGn9N+/3e3w4eNmt0sdq444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/D89rr+2X+uz73uWYf/W6bydX7Ro
q5/1Cjh/3cozreUJW+D8bUv5Trov3gPnP/I7qV4y5Ric/8qLO9vl+jk432Th
Pf73Ctfh/M9zzF9ZX7sH56v83TdT6thzOP/1xPvWv36+h/NtnZofJpV/sIe5
t3W32NITHxH8syarMvRyPsL5outsdaY8Q/CXLkjZHH/7E5xvOrnbSvvCZzhf
gDXHWu/xVzj/VZmPjeG373B+1a0ZnaVXf8P5B7RZ751gZnCA8U85z93GL8wE
5x+S/r3l6z9mOL+04fVSdxE2OH/WCb1DylzscD40fcH5AI62TNs=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vc/1X0fwPEzcHIUlwhF9qiMUkbG9/v+pkJLg1JESOWqUBmlSGVWLqNC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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk41Hsfh2exZIQOKp2QJJGyFMny/3//bWiTLC0KEVmOKKHNUiE6OSSS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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHjN+9EMq/eVDZYruQ/HFOBH9D7Ob4
PmE2OP+ZbNK7DX+Z4Xx9Oe9wE24mOP/DkSsM9UoMcP7bvdPzdyv82Q/jyxX9
mmjl/APOv8Vjcf6h0Bc4n+9lrrT+m/f71yj+O2k+391w444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/Fde3Nku18/Zfzu8/Z3z+5Omn+eY
v7K+dg/OV/m7b6bUsedw/uuJ961//XwP55tO7rbSvvDZHm5emY+N4bfvcH7V
rRmdpVd/w/kHtFnvnWBmcIDxTznP3cYvzATnH5L+veXrP2Y4v7Th9VJ3ETY4
f9YJvUPKXOxwPjR+4HwAAuTkvQ==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk3lG0DgGcMJhRRthRhEMoSEzHPfT92qSRbUsgWylKyVC9vC0UlEqmQ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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vk7lG3DwPEZ2xSibJElREJEtszMdZ6XfYxuJVpushYpRFnu3GlPRdZE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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHzvgeaD4ScE/aYruQ/HFOBH9D7Ob4
PmE2OP+ZbNK7DX+Z4Xx9Oe9wE24mOP/DkSsM9UoMcP7bvdPzdyv82Q/jyxX9
mmjl/APOv8Vjcf6h0Bc4n+9lrrT+m/f7ldLl5IL5UzQ37ghhlHN4AedfWvXI
cted+3D+lSdvnexDLsD5CzSf8j+dPxHOf+XFne1y/Zz9Tx9WIQm2Z7qf55i/
sr52D85X+btvptSx53D+64n3rX/9fA/nm07uttK+8Nkebl6Zj43ht+9wftWt
GZ2lV3/D+Qe0We+dYGZwgPFPOc/dxi/MBOcfkv695es/Zji/tOH1UncRNjh/
1gm9Q8pc7HA+NH7gfADOsrtn
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwt1vk7lGsDwPFhLCFLlsJIthb0khjrc9/3UwnJiZA2RVJRRExK6VREC4dD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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk4lGsDgMeMsY2lgyIiMSgcHR8S8z7v8+aEqCYKHXWOLZUiyppKm0Qn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          "]]}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      Frame->True,
      GridLines->{{1, 0., 0.42824283396576196`}, None},
      PlotRange->{{-3, 3}, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {977.1428571428571, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {360., 291.2461179749811}], InsetBox[
     GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJx1lD1IlWEYhg9nEpGwoSWCyKExi4agJYlGhzIaXBqkWoMiGlqaqkVxiWgR
R0sXp4TEY9DSWNRg4GAlFhGVZf6BP+/7vNcN537phcPDdX6+7zrPcz/fsaGb
A9ebjUZjbv+VapyOeerk83Sa4qnMWy04fvNLfPVKOh/E/cHn4O3ddH6KJ+J6
4mdxvz7zcJaXV/xg/GD8YPxg/GD8YPysL86VB+wVPxg/GD8YPxg/GD+bk3PV
F/eAveIH4wfjB+MH42e5ca7m5H1xD9grfjB+MH4wfpZj5yo3Pifvi3vAXvGD
8YPxs71yrnLsufE5eV/cA/aKH4yf7blztVeeY8+Nz8n74h6wV/zsueNc7bnv
lefYc+Nz8r64B+wVv/89F/055Hvve+a59hz53LxP7uWV631aTOeHcj7/Mp3v
4rGn6XwT37ubzop4MNdl8ZnT6XwWHzqYzpL4S77fong8X3+hdTh/762eB5P5
/Tfinvz5K/HJzNOt9j61ZuHV7vy5ctiM34uH4/rizrh/tVf0B6Y/MP2B6Q9M
f2D6A9MfmP7A9OdJrpvye/AonQ3xnXzfdfG1G+n8E1/OdU18/kI6f8Wnstcf
8dGedFbFB7Ln7+q52FH6Bj8sfYV3uqPv8Ncyl7Y83389C58tc4WPl7nD0yUX
8JGSG/qFD4wPjA+MT9s+7fvA+MD4wPjA+JBn8kOeyQ95Jj/kmfyQZ/JDnskP
eSY/5Jn8kGfyMxpVeX4f31Oeu+I6ynNv3Ed5vhQeyvPteF8+j+N38pmJ68rn
Y9xXPguFmdeL8n3mxfWY161yP+Z1sfgwrxPFl3nxf5jXu/J/mddI6QfzYr/w
Yb/wYb/wYb/wYb/wYb/wYb/wYb/wYb/w2QNGtJE4
       "], {{{}, 
         {RGBColor[0.5394194000000001, 0.02444500000000001, 0.01345006], 
          EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwNw8eSmgAAAFDXbgQRUWk2LNhwRpRib9goiiKguHY35/xLjjnnmn/MvplH
vX4ZL7fL5frz3fMd+HBDXl/U5494vG4QAN0e2B+IBYIZJI4EQ8kwINQZPALF
Qz8IKJqCY+kYQkZhFABziSRLl8updD1HlQiyks58AGF20K9lc1QSLWB4HsWa
JbpVrtBkqpEv8LU6Q+W5as0TATEwUsSJfpMdtbkv56xOphNemArimOM3M2nA
tp72cdHrK+PJTOyshyOp032fHHk0FpmGNp2d9d1usTysZX2+sFXNUtSjtjFl
5WocjNX6dTxd9sbtYG6l+WmzfVi2s9XvprXsD6aaKpsHEEMDMTiCY74oFERi
AJr0w9FQHIEIPEnlmv0enCLRPBUlCSSTTuSysXRqoirhZAIvFrK1aqpMk3Qp
XSlTTD3fYHL1GlbI/yz+bXREolSsC3y5xVa5NiMKNNus8Rw3HrVHw/3lU5hO
OtKsv1x051JvMecnY3E2Ha5XI3k922jSdrM+GHN9uzL2Y0Ve7HTjelEs034+
zPtt65ysx1072vrZOdyum9PRC0Xm3d7x9XS+3qpt/e7+O71f/wFgNl9X
             "]], 
            PolygonBox[{{110, 45, 35, 155}, {173, 57, 56, 137}, {182, 58, 57, 
             146}, {119, 37, 48, 128}, {128, 48, 58, 182}, {137, 56, 45, 
             110}, {155, 35, 36, 101}, {164, 36, 37, 119}}]}]}, 
         {RGBColor[
          0.6807742000000001, 0.07333500000000003, 0.008702979999999997], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{102, 101, 164, 165}, {138, 137, 110, 111}, {156, 155, 
            101, 102}, {174, 173, 137, 138}, {183, 182, 146, 147}, {120, 119, 
            128, 129}, {129, 128, 182, 183}, {165, 164, 119, 120}, {147, 146, 
            173, 174}, {111, 110, 155, 156}}]]}, 
         {RGBColor[0.822129, 0.12222500000000006`, 0.003955900000000006], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{175, 174, 138, 139}, {103, 102, 165, 166}, {112, 111, 
            156, 157}, {139, 138, 111, 112}, {121, 120, 129, 130}, {130, 129, 
            183, 184}, {166, 165, 120, 121}, {157, 156, 102, 103}, {184, 183, 
            147, 148}, {148, 147, 174, 175}}]]}, 
         {RGBColor[0.8812626, 0.22376740000000003`, 0.015288780000000005`], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{167, 166, 121, 122}, {104, 103, 166, 167}, {140, 139, 
            112, 113}, {149, 148, 175, 176}, {113, 112, 157, 158}, {185, 184, 
            148, 149}, {131, 130, 184, 185}, {158, 157, 103, 104}, {176, 175, 
            139, 140}, {122, 121, 130, 131}}]]}, 
         {RGBColor[
          0.9403962000000001, 0.32530980000000015`, 0.026621660000000016`], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{141, 140, 113, 114}, {186, 185, 149, 150}, {105, 104, 
            167, 168}, {177, 176, 140, 141}, {123, 122, 131, 132}, {150, 149, 
            176, 177}, {168, 167, 122, 123}, {159, 158, 104, 105}, {114, 113, 
            158, 159}, {132, 131, 185, 186}}]]}, 
         {RGBColor[0.9759704, 0.43025060000000015`, 0.041864660000000026`], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{133, 132, 186, 187}, {106, 105, 168, 169}, {124, 123, 
            132, 133}, {115, 114, 159, 160}, {142, 141, 114, 115}, {151, 150, 
            177, 178}, {178, 177, 141, 142}, {160, 159, 105, 106}, {169, 168, 
            123, 124}, {187, 186, 150, 151}}]]}, 
         {RGBColor[0.9879852, 0.5385898, 0.06101778000000001], EdgeForm[None],
           GraphicsGroupBox[
           PolygonBox[{{152, 151, 178, 179}, {134, 133, 187, 188}, {107, 106, 
            169, 170}, {179, 178, 142, 143}, {116, 115, 160, 161}, {143, 142, 
            115, 116}, {188, 187, 151, 152}, {170, 169, 124, 125}, {125, 124, 
            133, 134}, {161, 160, 106, 107}}]]}, 
         {RGBColor[1., 0.6469290000000002, 0.08017090000000004], EdgeForm[
          None], GraphicsGroupBox[
           PolygonBox[{{108, 107, 170, 171}, {180, 179, 143, 144}, {135, 134, 
            188, 189}, {117, 116, 161, 162}, {126, 125, 134, 135}, {153, 152, 
            179, 180}, {162, 161, 107, 108}, {144, 143, 116, 117}, {189, 188, 
            152, 153}, {171, 170, 125, 126}}]]}, 
         {RGBColor[1., 0.7162082000000003, 0.09888454000000006], EdgeForm[
          None], GraphicsGroupBox[
           PolygonBox[{{154, 153, 180, 181}, {163, 162, 108, 109}, {181, 180, 
            144, 145}, {145, 144, 117, 118}, {136, 135, 189, 190}, {109, 108, 
            171, 172}, {127, 126, 135, 136}, {118, 117, 162, 163}, {190, 189, 
            153, 154}, {172, 171, 126, 127}}]]}, 
         {RGBColor[1., 0.7854874000000002, 0.11759818000000004`], EdgeForm[
          None], GraphicsGroupBox[{
            PolygonBox[{{163, 46, 118}, {127, 47, 172}, {145, 46, 181}, {136, 
             47, 127}, {154, 47, 190}, {190, 47, 136}, {118, 46, 145}, {109, 
             46, 163}}], 
            PolygonBox[{{181, 46, 47, 154}, {172, 47, 46, 109}}]}]}}, {{}, 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{163, 118, 145, 181, 154, 190, 136, 127, 172, 109, 163}]},
           
           "0.9`"],
          Annotation[#, 0.9, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{162, 117, 144, 180, 153, 189, 135, 126, 171, 108, 162}]},
           
           "0.8`"],
          Annotation[#, 0.8, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{161, 116, 143, 179, 152, 188, 134, 125, 170, 107, 161}]},
           
           "0.7`"],
          Annotation[#, 0.7, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{160, 115, 142, 178, 151, 187, 133, 124, 169, 106, 160}]},
           
           "0.6`"],
          Annotation[#, 0.6, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{159, 114, 141, 177, 150, 186, 132, 123, 168, 105, 159}]},
           
           "0.5`"],
          Annotation[#, 0.5, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{158, 113, 140, 176, 149, 185, 131, 122, 167, 104, 158}]},
           
           "0.4`"],
          Annotation[#, 0.4, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{157, 112, 139, 175, 148, 184, 130, 121, 166, 103, 157}]},
           
           "0.3`"],
          Annotation[#, 0.3, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{156, 111, 138, 174, 147, 183, 129, 120, 165, 102, 156}]},
           
           "0.2`"],
          Annotation[#, 0.2, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{110, 155, 101, 164, 119, 128, 182, 146, 173, 137, 110}]},
           
           "0.1`"],
          Annotation[#, 0.1, "Tooltip"]& ], {}, {}, {}}}],
      AspectRatio->1,
      Frame->True,
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {1368., -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {360.0000000000002, 291.2461179749811}], 
    InsetBox[
     GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJx1lA9Q02UYx6eiaMpJ4YGBIkQQnjICbUgh7wQOAfnbQZEMEFFQNEZe/sHM
KHBhdgp0uFhmpQ7Gv5Qh4BX18seFgRcbgSDJfzp2JAzc5kAkkrjn7e7Z9d7t
nvvc737bZ8/zfV77vcI39y/mcDglzz7zdeEsr4NaWjJ/FjMu+5efUOCFdyYY
x0XNnw7GwQtMgGfm5o+GsWzh+xgXL/weH3lgZl64gh8w+AGDHzD4AYMfMPgB
gx/qC2YjD2BcwQ8Y/IDBDxj8gMEPGPzQnDAb9QV7AOMKfsDgBwx+wOAHDH4o
N5iN5oT7gj2AcQU/YPADBj9g8EM5xmyUGzwn3BfsAYwr+AGDHzD4ob3CbJRj
nBs8J9wX7AGMK/gBgx/ac8xGe4VzjHOD54T7gj2AcQU/dO9gNtpzvFc4xzg3
eE64L9gDGFfw+797Ed9DeO/xnuFc4xzhueE+YS9c4fvSyxItc4unWc5vTkku
jtcZGI/7tVkGd+kZO+euEBdrtIwTe/hWpqaPGH+98YR4n+0ElVjpziX0K9ne
m3cN9znJGhgfMF1Fok5dYpxW5mvn8EINy5HAxfFO+XfNjPk+aziOPe1GexAx
G5YXc8PA+FHt1DeFv2vptPCBuFrz394o3jbJzJlVM84jm1NTVg4yrguVybPd
7zE2qY78ZOU2A+OdYauPKMRaxh63t7d4fali99cy6VP/kBIFY6/MmfEdATcY
cz812eOSLWV7sWVpRpGHuoFxyPsfzbh5KI322r6tKa5apKEH5oJP87Y+ZM8H
zbdOV3T+yfiWH0+9+3Ev45hZwXHPYgNjzuqMWud0HWOp3dVFawMnje65ggS7
sstjbWxfuQd3vH68t4lxtG3Wtr2NlYyTNumXRR7+lr3/4Frthj+sGhgL53ou
hz+nZP/H4uUP3QI977D974rNjBjtu8Sei2Z6FL7vtdLOGcMHi57cpa2R7Vn5
uilalfpi6KD0J8p/yDtZ6WqgEzFcP+tTR2lFZoFQlaKnXle/WBr/+Adib/N0
n0aqpdaWVZ3kSgvJk8ftNhuYpEEu4Zay4Wf5CaoP27RugjqWSpyu8HsJL+qd
Y53CKfpKfFLiWskIOawM/k3rrqNDPx/b7x2rok03zbN1S8ZpcynHpzVAQQMy
OhzPFo1SfnLYsEhwnf66S9K4ftcIlfcnEteUQhJkFZ8gHx+izs2KaM9VjaRl
0GHOP6+fPh96P03rrSQFApVnzaFuap2kUr7F+4tsOCuvLFL30vOnfY8mvDpE
bDYnvxZ4coSacg9t6Yq8Rwot9DneGRq6JL9LbbbdQKY6QrnDZwboTuF6ua9E
S9LsFV+daFFTs4jPuP53x0ia4aB8YExJeD+29YnSR0mWWL/xl5zbJN7RJrfJ
aYRc48TWOliVk+wLiT7L24eIUrDOVbVGRiumS7UBH/eTnFSpyC28kVY1qQMt
YruJfrB+jzhESQWfX3wp/5yBvHFrRcrfFfXkiISq7yfrSLSgJu/d6+U0W6b+
3tZvkrhXygu6/ZT0Hx2XCJA=
       "], {{{}, 
         {RGBColor[
          0.563868526960279, 0.22824802131146982`, 0.07777177153746773], 
          EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwNw8eSmgAAAFDXbsSCDQso6Iwo6IyoYEGliBUEBWmu3c0ph3xErrkmuWby
pdk387Dnd/3p9Xg8vz/7PgNv3mQgmA5HwGAoFQqj2Vzc5495fQl/IBP5UkqC
MJjCchCSSntjQC4KlNOZKpTvNwmqjpMo1kDKOIwQFbROdXzx2BsQLSaS9RLc
wqpdvEETZC1faFdrg1b7T+0bQ7bYDpWPxQvxhDQai4OhwAxkXlDnkiKIW46/
6MbLcXmaWU9nS3by4Z42M24+HD1t525a4k45afurcbRk5bjZGuuNuZUhIDah
ulyfPh/0/WKpr9bOTr0dTU1azHp9W9ntxLmraosxKyjyXN3FC/lYHgqlwEAy
EQSTiWIBqmI5DM2ila15BOFSOJ1KloopBE6XEWrCAlAukklHc1mUJJAGDuP1
CtH82/lRbbewFtnnZniX6rDjfK36tfiLoPvt4aA1YJr9HsnQNM/1ZlP9ch6I
wkiaT9er8UIyrhdG4DdHYzgXue1G0tTFXlvph7Wh8/J2tlnLlskuF+7Hy3rc
zftNO7k7x1Zdx34+jrfr4fzuT8Qflu28nj9H/xTb+g8S8F9M
             "]], 
            PolygonBox[{{131, 48, 58, 168}, {121, 45, 35, 151}, {107, 35, 25, 
             143}, {113, 27, 38, 119}, {119, 38, 48, 160}, {149, 26, 27, 
             113}, {162, 57, 56, 134}, {134, 56, 45, 121}, {168, 58, 57, 
             140}, {143, 25, 26, 101}}]}]}, 
         {RGBColor[
          0.7576315808808372, 0.33809006393440943`, 0.0947023146124032], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{163, 162, 134, 135}, {135, 134, 121, 122}, {122, 121, 
            151, 152}, {108, 107, 143, 144}, {120, 119, 160, 161}, {114, 113, 
            119, 120}, {144, 143, 101, 102}, {150, 149, 113, 114}, {152, 151, 
            107, 108}, {102, 101, 149, 150}, {161, 160, 131, 132}, {141, 140, 
            162, 163}, {169, 168, 140, 141}, {132, 131, 168, 169}}]]}, 
         {RGBColor[
          0.8524132995204223, 0.4707063861857598, 0.20489043206920443`], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{115, 37, 127}, {120, 37, 114}, {161, 37, 120}, {114, 
             37, 150}}], 
            PolygonBox[{{142, 141, 163, 164}, {109, 108, 144, 145}, {123, 122,
              152, 153}, {133, 132, 169, 170}, {164, 163, 135, 136}, {145, 
             144, 102, 103}, {170, 169, 141, 142}, {136, 135, 122, 123}, {153,
              152, 108, 109}}], 
            PolygonBox[{{127, 37, 161, 132, 133}, {103, 102, 150, 37, 
             115}}]}]}, 
         {RGBColor[
          0.9159748868845815, 0.6062746051282163, 0.34113209383293963`], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{142, 47, 170}, {170, 47, 133}, {133, 47, 127}, {157, 
             47, 128}}], 
            PolygonBox[{{124, 123, 153, 154}, {110, 109, 145, 146}, {154, 153,
              109, 110}, {165, 164, 136, 137}, {146, 145, 103, 104}, {137, 
             136, 123, 124}, {104, 103, 115, 116}}], 
            PolygonBox[{{128, 47, 142, 164, 165}, {116, 115, 127, 47, 
             157}}]}]}, 
         {RGBColor[
          0.9208594259944619, 0.7247727780219925, 0.5083738349280653], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{138, 137, 124, 125}, {129, 128, 165, 166}, {125, 124, 
            154, 155}, {111, 110, 146, 147}, {147, 146, 104, 105}, {117, 116, 
            157, 158}, {105, 104, 116, 117}, {158, 157, 128, 129}, {155, 154, 
            110, 111}, {166, 165, 137, 138}}]]}, 
         {RGBColor[
          0.9207641710060536, 0.8143213383474588, 0.6564008146060567], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{130, 129, 166, 167}, {126, 125, 155, 156}, {159, 158, 
            129, 130}, {148, 147, 105, 106}, {118, 117, 158, 159}, {106, 105, 
            117, 118}, {167, 166, 138, 139}, {112, 111, 147, 148}, {139, 138, 
            125, 126}, {156, 155, 111, 112}}]]}, 
         {RGBColor[0.9141314748253361, 0.8658650362288148, 0.779202780898067],
           EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{148, 36, 112}, {156, 46, 126}, {159, 36, 118}, {118, 
             36, 106}, {126, 46, 139}, {106, 36, 148}, {139, 46, 167}, {167, 
             46, 130}}], 
            PolygonBox[{{112, 36, 46, 156}, {130, 46, 36, 159}}]}]}}, {{}, 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{148, 112, 156, 126, 139, 167, 130, 159, 118, 106, 148}]},
           
           "0.6`"],
          Annotation[#, 0.6, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{147, 111, 155, 125, 138, 166, 129, 158, 117, 105, 147}]},
           
           "0.5`"],
          Annotation[#, 0.5, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{146, 110, 154, 124, 137, 165, 128, 157, 116, 104, 146}]},
           
           "0.4`"],
          Annotation[#, 0.4, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{145, 109, 153, 123, 136, 164, 142, 170, 133, 127, 115, 
             103, 145}]},
           "0.3`"],
          Annotation[#, 0.3, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{144, 108, 152, 122, 135, 163, 141, 169, 132, 161, 120, 
             114, 150, 102, 144}]},
           "0.2`"],
          Annotation[#, 0.2, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{107, 143, 101, 149, 113, 119, 160, 131, 168, 140, 162, 
             134, 121, 151, 107}]},
           "0.1`"],
          Annotation[#, 0.1, "Tooltip"]& ], {}, {}, {}}}],
      AspectRatio->1,
      Frame->True,
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {1758.8571428571427`, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {360.0000000000002, 291.2461179749811}], 
    InsetBox[
     GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJx1lG1Ik2EUhscwXUYJGqZGS+lroGUfPxKhXgsSBTG1WckyhtM0kbLQ7IcY
s9IhqcUQg8RKIvxiFWhqiI/ahqZpxtIlBSq6nLh0LpNIo1rjfn6clx4Yh4tt
73txzn2ekLTLSRlSiURy5+/HVd1H1o3a1Og6Us7N//gnA7v/4+B8Ptl1RjnH
uVkAr/52nUXO9e7ncW5wvy+KeFDmXrTCDww/MPzA8APDDww/MPxIXyiLPMC0
wg8MPzD8wPADww8MPzInyqK+UA8wrfADww8MPzD8wPAjuaEsmhPtC/UA0wo/
MPzA8APDj+SYsig3dE60L9QDTCv8wPADw4/sFWVRjmlu6JxoX6gHmFb4geFH
9pyyaK9ojmlu6JxoX6gHmFb4kXuHsmjP6V7RHNPc0DnRvlAPMK3w+9+9SO8h
uvd0z2iuaY7o3GifqBeteJ7l1kfpXusKz3muM19pGXayotrgsszCbr63Ower
lFP6Xj5nXdmy2lYwz7lOURoeUzwl2iPD96RVeepXzrLYvH6rY4Zzf0RoaMr6
cWYqafcYM7/j90FUQM68IqWTsyJPM5A1+oDnKmwuvn4hxMTZ9qJ+6/10s2gv
Gl5739Y6pplSKi8pzLbz7zsyC+yxs184y4dGkrakT3H2zFBefdNj4RwZWDpy
uM8puhfWze6IqVW95/muLA6r7lV3c35eYZdfU1Xy31/Y7K06EGfk7Hjm25ic
aOa+y6YghUTSw6Jaz4bc3P+SNUxml6a2r7Byvc8ru8koTKf5dVV3OtnFhQ0+
uWNDbDEhIGVpwM42VRgiB092MP89TZ3xN2wsR5ufqA+qE47+OhLcfGiGdXn5
Roe3moSBp4+9/EYm2N0z058+XzELQaf6hociLExp2Nhz75FVOL1WMxfgbWX7
DJ6t5eV2QaMxFU1NvhW0uzTKggSboNZe+uEz3iZ8qGHf1H4zgkynCoze/oTF
KyJ2VzVPCG0eVlnomomt+C+lZx20CC36jhPHr5vZuWPG2kSjU+h/qGvZpjOy
P97QFds=
       "], {{{}, 
         {RGBColor[0., 0.16968323008522995`, 0.028708048891574755`], EdgeForm[
          None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwNz8mOmgAAAFDHZdQKqLigAioYVzDREUTFBQSUzQ0U1HF3kqanHnpv0lN/
oZ9bD+8DHvH4aT28Ho/n34vvBXjzxgLviVAY8vnj78FiKk0iGTgY4ugm6PUl
w9/QWByLw1F/AIcTCACmI0A+kcxFY61ypZTJvgERqkiUc2gNz38djmmi2CgU
f5R/VVCsSZbalepHtUYTJFNvdCn6T+k726DU0ZhII1koKrBdqdcfdxixy8n9
wVKSp1xvMZWe+4MpTmf8UBtPJgxrCKI+Ee6O+3D3GRC62NuzZW813TUX1lzd
6UYVw/lW2zHM08ZaK7OVrFy3u8NyZavasP1xXK33i+Vt50wXphcEmMkYQNLv
8Zg/CgVi0SAcBzMIlM0gJJEqFkTTiOaykXSqPeRhHEvk8TiG+iAwlIAzJRKv
VQuNOkFTlXaLbNJFqoFVX8N2g2XQSrnZ48LJBNVl60ynxQ9ortsZj2Jozr6c
uanYl6WROh8oMitMuqLQk6ZjTZ3omrRcyKultrWV9Uq1LcHQ59ZG3235mbK7
XVfHw2Lvmq6zPOy314t1Pm1On4azUwa8c78dvp7758N93H/3//4Hm3pe4A==

             "]], 
            PolygonBox[{{110, 45, 35, 129}, {103, 35, 25, 127}, {140, 58, 57, 
             126}, {120, 48, 58, 140}, {135, 57, 56, 121}, {127, 25, 26, 
             101}, {121, 56, 45, 110}, {115, 37, 48, 120}, {101, 26, 37, 
             105}}]}]}, 
         {RGBColor[
          0.04324330689659177, 0.4790659244004533, 0.07998241514815518], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{126, 47, 140}, {134, 47, 116}, {140, 47, 120}, {120, 
             47, 115}}], 
            PolygonBox[{{130, 129, 103, 104}, {136, 135, 121, 122}, {102, 101,
              105, 106}, {122, 121, 110, 111}, {128, 127, 101, 102}, {104, 
             103, 127, 128}, {111, 110, 129, 130}}], 
            PolygonBox[{{116, 47, 126, 135, 136}, {106, 105, 115, 47, 
             134}}]}]}, 
         {RGBColor[
          0.2649561781609862, 0.6647025406674222, 0.1059092252469253], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{134, 36, 106}, {106, 36, 102}, {128, 36, 104}, {102, 
             36, 128}}], 
            PolygonBox[{{117, 116, 136, 137}, {137, 136, 122, 123}, {112, 111,
              130, 131}, {123, 122, 111, 112}}], 
            PolygonBox[{{131, 130, 104, 36, 107}, {107, 36, 134, 116, 
             117}}]}]}, 
         {RGBColor[
          0.5585171543220069, 0.7845465451244507, 0.13403410157921136`], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{132, 131, 107, 108}, {113, 112, 131, 132}, {124, 123, 
            112, 113}, {118, 117, 137, 138}, {108, 107, 117, 118}, {138, 137, 
            123, 124}}]]}, 
         {RGBColor[0.8256841188869875, 0.8997139371973, 0.18374671844449592`],
           EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{125, 124, 113, 114}, {133, 132, 108, 109}, {109, 108, 
            118, 119}, {114, 113, 132, 133}, {119, 118, 138, 139}, {139, 138, 
            124, 125}}]]}, 
         {RGBColor[1., 0.984375, 0.230411], EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{119, 46, 109}, {133, 46, 114}, {114, 46, 125}, {139, 
            46, 119}, {125, 46, 139}, {109, 46, 133}}]]}}, {{}, 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{133, 114, 125, 139, 119, 109, 133}]},
           "1"],
          Annotation[#, 1, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{132, 113, 124, 138, 118, 108, 132}]},
           "0.8`"],
          Annotation[#, 0.8, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{131, 112, 123, 137, 117, 107, 131}]},
           "0.6`"],
          Annotation[#, 0.6, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{128, 104, 130, 111, 122, 136, 116, 134, 106, 102, 128}]},
           
           "0.4`"],
          Annotation[#, 0.4, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{103, 127, 101, 105, 115, 120, 140, 126, 135, 121, 110, 
             129, 103}]},
           "0.2`"],
          Annotation[#, 0.2, "Tooltip"]& ], {}, {}, {}}}],
      AspectRatio->1,
      Frame->True,
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {2149.7142857142853`, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {359.9999999999998, 291.2461179749811}]}, {}},
  ContentSelectable->True,
  ImageSize->{884., Automatic},
  PlotRangePadding->{6, 5}]], "Print",
 CellChangeTimes->{
  3.461055771768497*^9, 3.461062841177031*^9, 3.461065791490937*^9, 
   3.461065855900181*^9, {3.461065891743836*^9, 3.461065920834627*^9}, {
   3.461065953516238*^9, 3.461065982473227*^9}, {3.461066052803565*^9, 
   3.4610660881378593`*^9}, 3.4612912214780693`*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell[BoxData["0.5607349829424626`"], "Output",
 CellChangeTimes->{
  3.460774172693623*^9, 3.4607742141360817`*^9, 3.460774259371611*^9, {
   3.460774303149437*^9, 3.460774333742992*^9}, {3.460774503977763*^9, 
   3.460774525387253*^9}, 3.460774568669429*^9, {3.4607746433678713`*^9, 
   3.460774749289826*^9}, 3.4607747872637367`*^9, {3.4607752069957323`*^9, 
   3.4607753311834*^9}, {3.4607759195524397`*^9, 3.4607759422690763`*^9}, 
   3.460775994534586*^9, {3.460776028795376*^9, 3.460776037081739*^9}, {
   3.460790911595224*^9, 3.460790939253276*^9}, {3.460791053594666*^9, 
   3.460791071141541*^9}, {3.460791192973082*^9, 3.460791203957177*^9}, {
   3.4607914471303043`*^9, 3.460791466955147*^9}, {3.460791545117042*^9, 
   3.460791571021545*^9}, {3.460793419216103*^9, 3.460793427190727*^9}, 
   3.4607934904166403`*^9, 3.460793537586506*^9, 3.4607935875115547`*^9, {
   3.460793643816039*^9, 3.460793651412258*^9}, {3.4607937028316803`*^9, 
   3.460793717693026*^9}, 3.460794349054253*^9, 3.460794468602188*^9, 
   3.460794537146944*^9, 3.460794606820025*^9, 3.460794647441045*^9, {
   3.460794683999979*^9, 3.460794711587779*^9}, 3.4607947437033663`*^9, 
   3.460794821453476*^9, 3.460794992763452*^9, {3.46079537866004*^9, 
   3.4607954008420343`*^9}, {3.460795899955226*^9, 3.460795915535334*^9}, 
   3.4607959607567463`*^9, {3.460796100730474*^9, 3.460796117431126*^9}, 
   3.460796273298979*^9, 3.46080016267494*^9, 3.46080059045927*^9, 
   3.46080191058669*^9, {3.460801947033931*^9, 3.4608019584551563`*^9}, {
   3.460802135491241*^9, 3.4608021585180397`*^9}, 3.460802633967609*^9, 
   3.460802693048126*^9, 3.460802784188271*^9, {3.46080281423518*^9, 
   3.460802852551197*^9}, 3.460802900679997*^9, {3.460802966464355*^9, 
   3.460802994747815*^9}, 3.460803081703266*^9, 3.460803125487102*^9, 
   3.460803183227213*^9, {3.460803234859148*^9, 3.4608032609697237`*^9}, 
   3.4608033212142887`*^9, 3.460803381478054*^9, 3.4608035021140633`*^9, 
   3.460803635652215*^9, 3.460803697315674*^9, 3.4608037348572693`*^9, 
   3.460803769573984*^9, 3.460803809928953*^9, {3.4608057984622173`*^9, 
   3.460805813824176*^9}, {3.460805968711471*^9, 3.4608059901127863`*^9}, 
   3.460806044738928*^9, {3.460806111860417*^9, 3.460806138661484*^9}, {
   3.4608062551082487`*^9, 3.460806284064145*^9}, 3.460806807365871*^9, {
   3.46080840200484*^9, 3.460808428085409*^9}, {3.4608084903745604`*^9, 
   3.460808509880398*^9}, 3.4608085615495157`*^9, {3.460808596715098*^9, 
   3.460808614316525*^9}, 3.460808667778009*^9, {3.460808756743518*^9, 
   3.460808821361974*^9}, 3.460808866006637*^9, 3.460809008335636*^9, {
   3.4608090829662027`*^9, 3.460809106371428*^9}, {3.4608091533817453`*^9, 
   3.460809170247486*^9}, 3.460809387484213*^9, 3.4608094563846188`*^9, 
   3.4608095239938383`*^9, 3.460809556860118*^9, 3.460809601486121*^9, 
   3.460809659738999*^9, 3.4608097239935083`*^9, {3.46081085410987*^9, 
   3.4608108667828493`*^9}, 3.4608109499384403`*^9, 3.460811028337473*^9, 
   3.46081107221124*^9, 3.4608163531812773`*^9, 3.460816462080289*^9, 
   3.460816636079851*^9, 3.460816733529152*^9, 3.460816810327259*^9, 
   3.460816896707574*^9, 3.460859466583232*^9, 3.460859525199936*^9, 
   3.46085957856656*^9, 3.460859612027454*^9, 3.460859642696507*^9, 
   3.460859673379051*^9, 3.4608610359199123`*^9, 3.460861080130123*^9, 
   3.460861176214602*^9, 3.460861206909174*^9, 3.4608612527872066`*^9, 
   3.4608613245925083`*^9, {3.4608613893716373`*^9, 3.460861402077552*^9}, 
   3.460861433808834*^9, 3.460861482995883*^9, 3.460861622874538*^9, {
   3.460861766989231*^9, 3.460861788062501*^9}, 3.460861837558749*^9, 
   3.460861919837391*^9, 3.46086202490096*^9, {3.460864063005273*^9, 
   3.4608640925582657`*^9}, 3.4608642675973377`*^9, {3.460864595153369*^9, 
   3.460864678530854*^9}, 3.4608647161716623`*^9, 3.4608928885197763`*^9, {
   3.4608929272834787`*^9, 3.4608929785836067`*^9}, {3.460893064106246*^9, 
   3.460893113794902*^9}, {3.4608931965264177`*^9, 3.460893221096546*^9}, 
   3.460893257519649*^9, 3.4609459317505836`*^9, {3.4609459653975143`*^9, 
   3.4609459931714287`*^9}, 3.4609461850150833`*^9, {3.460946221971449*^9, 
   3.46094625037241*^9}, 3.460946287032295*^9, {3.4609463329038773`*^9, 
   3.460946475537898*^9}, {3.4609465106640263`*^9, 3.460946554340445*^9}, 
   3.460946745286201*^9, 3.460946846249963*^9, 3.46095277278576*^9, 
   3.4609547879814377`*^9, {3.4609693962841597`*^9, 3.460969479832581*^9}, 
   3.460969518067926*^9, {3.460973376833108*^9, 3.460973436855947*^9}, {
   3.46097976178686*^9, 3.4609797783289747`*^9}, {3.460979815577437*^9, 
   3.4609798918056097`*^9}, 3.461033363239642*^9, {3.4610394977541027`*^9, 
   3.461039513242825*^9}, {3.461039546024946*^9, 3.461039584057582*^9}, {
   3.461054619262939*^9, 3.461054635771722*^9}, {3.461054666119218*^9, 
   3.461054724280589*^9}, 3.461054772684753*^9, 3.461054837077591*^9, {
   3.46105489942374*^9, 3.461054926726182*^9}, 3.461054971946405*^9, {
   3.461055759572901*^9, 3.4610557703433237`*^9}, 3.4610628397680902`*^9, 
   3.461065791475391*^9, 3.461065855853307*^9, {3.461065891722114*^9, 
   3.4610659208089657`*^9}, {3.461065953493973*^9, 3.461065982458634*^9}, {
   3.461066052787819*^9, 3.461066088122064*^9}, 3.461291221714295*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0, 0, 1], PointSize[0.03], Thickness[0.03], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxF12c81f//BnBKZhIpo2yRPSvjzJCRlRElQjKzo0JDSrKSkSZZKZEVJV/Z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           "]]}}, {}}, {{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.01], Thickness[0.01], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxd23l4j1cWwPEYy1DGIGgJYplUM4ikqC3Ja4k1hLQkqbVCFIk9rTappSGZ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           
           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{1}, {1}},
      PlotRange->{{-3, 3}, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {195.42857142857142`, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {359.99999999999994`, 291.2461179749811}], 
    InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.03], Thickness[0.03], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxd23l4j1cWwPEYy1DGIGgJYplUM4ikqC3Ja4k1hLQkqbVCFIk9rTappSGZ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           
           "]]}}, {}}, {{}, 
        {RGBColor[1, 0, 0], PointSize[0.02], Thickness[0.02], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJzt2l9IU3EUwPFLvbiEIPOh9rLtQcEgMJilFlyGiwRDYWjGRIkwH2JNAika
JfkWYgX+ARF9MYIiqAUrmA/OUW3kJKLEGFyIprHQLNPCgeVC4wy6nIHM388d
8dyXywfu/d3f+d63y7Wcb3Vc2KUoyuRuRVk793unZhI97wJqTnvtjYJLx7eb
T5uKVnIPvQk0Ponlm7pmj6az/vqdYq/FvOyoD6d6ZGr9eux/rkzk+csfjqV6
ibJ+fTbe+8GCoz1u9Uk3PJ+NO12/m9eSp0asQ1tu2B8b90Z7FtsmXN3ePhXu
z5aT68d3lY07077N7snVtj9Ps26Yh407074HrMWGOtcoOcN8bNyiensa7vmi
Ta/IGeZl4xbV+2zvsUerngg5w7xs3KJ6m6JVzurQW/KG+dm4ZfU3WhInw+Pv
yRt6sHHL6m8zt/WEI1PkDT3YuGX1t9+a7zSPR8kberBxy+qv9b5wD4Q08oYe
bNyy+gd98arl4Efyhh5s3LL6L6pXQp6mT+QNPdi4ZfWfrskpKdJi5A092Lhl
9S89s1TY4pwhb+jBxi2rf9ke73B39DN5Qw82bln9Xxrcr/OccfKGHmzcsvqP
HbarNdoX8oYebNyy+peXDAafn5slZ5ifjVtU76sVtmQgPkfOMC8bt6jeH/bb
I3OX58kZ5mXjFtX7etfdiXDyW9YN87FxZ9q3QOv4mqhcUOF/2WxZvx+2mPez
N7fOdCf/x5Yb9s/GvdGeZSeMjw3T8p36fsBGna5fqav+dsy3KNzwfDZu6NWy
72Df/c6lTRvWZ/9v45GBZ7+bf6Z6pbP++p3iWv/FVr/917b1X1Q+i3E=
           
           "]]}}, {}}, {{}, 
        {RGBColor[1, 1, 0], PointSize[0.015], Thickness[0.015], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxF1Xc01X/8B3ChRBKy0jCyRwmRce81S0SSEZUdQiIl2RTJKqsvIhSSkB0p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           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{1}, None},
      PlotRange->{{-3, 3}, {0, 1.1}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {586.2857142857142, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {359.99999999999994`, 291.2461179749811}], 
    InsetBox[
     GraphicsBox[{{{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHlNLl5IL5UzQttgvJH+dE8DfEbo7v
E2aD85/JJr3b8JcZzteX8w434WaC8z8cucJQr8QA57/dOz1/t8Kf/TC+XNGv
iVbOP+D8WzwW5x8KfYHz+V7mSuu/eb8/Zv0jEfmeV2Ybd4Qwyjm8gPMvrXpk
uevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs7ejqMupFY11/rzHPNX
1tfuwfkqf/fNlDr2HM5/PfG+9a+f7+F808ndVtoXPtvDzSvzsTH89h3Or7o1
o7P06m84/4A2670TzAwOMP4p57nb+IWZ4PxD0r+3fP3HDOeXNrxe6i7CBufP
OqF3SJmLHc6Hxg+cDwBoEb+u
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwBMQLO/SFib1JlAgAAACIAAAACAAAAvxBy3v//B8DoiD/lv+1pCF46mq5x
wgfAFvd+dBZ3Qwn8Y8J+44QHwN6ssJqc+BoKOLcSH8cJB8BXmak5bVnEC7Bd
s1+OEwbArWg4Z1muAQ/mHWLusP0DwAmcGn3+/qAVLx5LVzQLAsC7pluiB65R
G/DE1AB/IgDAEqJ0Jc91cCDtvZdvuyD8v4aSjdo1qHglHnL6kTpD+L9J2TVm
L+ewKdoMOM/hEvS/t6DgaNCaui0O6W0bL+zvv4Bkdgr+RykxsbhUAR5A6L9v
lfnd1CbjM9Kq4jm63N+/Qoo+D297UjbU5O1CP1TQvw1U47my3Bo4oCnlD+Wf
kb/+QYE24QdlOepKC2tE184/TELh7pYGSDrznDfqO9bePzCFqT3Ra6E6JP2+
mRrG5z9xDHM55WB6OuuR3zv6+e8/7HRj3P0OzTk1k4s6K9DzP+rQarHmorE4
6nZMPDH29z+T+xj5JOT4NnramIl11fs/ImOs+QNA4jTAKwXeyAMAQImrnR5w
KRYyykOdtg8TAkBEOMb1brbPLsIb+7T1/gNADbwuwbuTRCt1gOulRxQGQEOY
76lHfOgmflL8rL5RBkDdtGVIMi9gJogkDbQ1jwZAQQbmlMe/0yWayC7CIwoH
QDsXT4IQIbcko5o/yZpHB0DliW30wDImJKxsUNARhQdAbO1UIneqkyO2PmHX
iMIHQOgDCQsGFQAjvxBy3v//B0Dq8LUbikdoIqNhCCg=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwBMQLO/SFib1JlAgAAACIAAAACAAAAvxBy3v//B8DEmcsUAbhECF46mq5x
wgfAKszJr3riIAn8Y8J+44QHwPJr8HxVXvkJOLcSH8cJB8AGitTco22mC7Bd
s1+OEwbA1h9tIeFl6g7mHWLusP0DwNa1WLHqBpcVLx5LVzQLAsA8cFoLO1pT
G/DE1AB/IgDAEXhvtA7XeiDtvZdvuyD8vzmBOjGQlIwlHnL6kTpD+L/pL4aA
ajrJKdoMOM/hEvS/cKOlCRgM2C0O6W0bL+zvv/a8MOH8X0kxsbhUAR5A6L97
Rhl086wDNNKq4jm63N+/IOjkul/0cTbU5O1CP1TQv1rwN3Pu8jY4oCnlD+Wf
kb8s3o26BH99OepKC2tE184/H4XYZGAbWTrznDfqO9beP2fzx61sqqk6JP2+
mRrG5z+2Zv5OUYJ4OuuR3zv6+e8/XhOapnCcvzk1k4s6K9DzP7KU9NJqoJU4
6nZMPDH29z8mm8TEADzONnramIl11fs/maDniYtUpTTAKwXeyAMAQAPOWTDz
lcUxykOdtg8TAkDk5dHqYA5oLsIb+7T1/gNAt0sMDnkJyCp1gOulRxQGQPgH
41lku1ImflL8rL5RBkBk4i2nqKfFJYgkDbQ1jwZAWA7pzgQVNyWayC7CIwoH
QJDz6piBjhQko5o/yZpHB0CX6g7V8SyBI6xsUNARhQdAK5MAb6J26iK2PmHX
iMIHQLmHtvkgzFIivxBy3v//B0DD0CUoQp+4IdN/CwM=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQB2IQvV+g6N7//+wHbhx5oP29+aiOxXYh+eOcCP6G2M3x
fcJscP4z2aR3G/4yw/n6ct7hJtxMcP6HI1cY6pUY4Py3e6fn71b4sx/Glyv6
NdHK+Qecf4vH4vxDoS9wPt/LXGn9N+/3e3w4eNmt0sdq444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/D89rr+2X+uz73uWYf/W6bydX7Ro
q5/1Cjh/3cozreUJW+D8bUv5Trov3gPnP/I7qV4y5Ric/8qLO9vl+jk432Th
Pf73Ctfh/M9zzF9ZX7sH56v83TdT6thzOP/1xPvWv36+h/NtnZofJpV/sIe5
t3W32NITHxH8syarMvRyPsL5outsdaY8Q/CXLkjZHH/7E5xvOrnbSvvCZzhf
gDXHWu/xVzj/VZmPjeG373B+1a0ZnaVXf8P5B7RZ751gZnCA8U85z93GL8wE
5x+S/r3l6z9mOL+04fVSdxE2OH/WCb1DylzscD40fcH5AI62TNs=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwB0QUu+iFib1JlAgAAAFwAAAACAAAAvxBy3v//B8DPT7/QfHmKDV46mq5x
wgfAlLWZeQt7Yw78Y8J+44QHwCMpPzX/dDoPOLcSH8cJB8Dbr/9bXS3jELBd
s1+OEwbAv7vPlBnCHhTmHWLusP0DwEIoKFCB2bgaLx5LVzQLAsCGhZzrH/pl
IPDE1AB/IgDAMsEUBo5zgSXtvZdvuyD8v2kTo698/4UqHnL6kTpD+L9f4qsp
bay5LtoMOM/hEvS/Q4yijOr3wDIO6W0bL+zvv0wz0pdyKys2sbhUAR5A6L8w
PtGIqorhONKq4jm63N+/5DtqR/l3TDsSEgTbquvdv/R7rmLvhYs7UnklfJv6
27/dje3764TIO9NHaL58GNi/r0okLhlzPjwUr4lfbSfWvxKex+I7OXU8VBar
AF421L+/m6ztIUOrPJR9zKFORdK/Gnu/CmMi4DzU5O1CP1TQv91OnVPpmBE9
GuVfSe7ZzL8YDyCJBv1APYsA5AxeC8m/BC5p30BSbj38G2jQzTzFv6woH4dy
A5k9bjfskz1uwb9u2GRRJhPDPb+l4K5aP7u/qmfBKpDk6j2i3Og1OqKzv9ge
i4I+hhE+CifieTMKqL/SrayrzBw1PqAp5Q/ln5G/KgLP4iqDVz78jEX6t9aO
P/blthOKM3s+TlsVhU47qD/sJXU/AbCcPq6pzIV3YLQ/oUZRh6iUuz62pQ7J
R6O8P2T5k/07LNg+3lAoBgxzwj9xu8bYN1DzPuJOySd0lMY/s5CVYT4iDD/m
TGpJ3LXKP4/NbNYVriI/6koLa0TXzj/Dh5rWCJ02P2TkG2z1WNE/Fal9S3m8
Rz9UI7KiSEbTP3059+pw/FY/RGJI2Zsz1T/Iju+lWYlkPzSh3g/vINc/BtBV
nHrtcD8k4HRGQg7ZPxX81s7lvnk/FB8LfZX72j+8gvKvIhCCPwReobPo6Nw/
G3AbNj9ihz/znDfqO9beP0kLX+eu7Ys/TzSwiX124D/hSuZWlOmOPySaRB7d
geE/6vyY3+gfjz/6/9iyPI3iP+M9dSX0gYw/z2VtR5yY4z+ZbaWMjcCHP6TL
Adz7o+Q/gSXsHZ0Agj96MZZwW6/lP0My7bf10ng/T5cqBbu65j/z5XJ6giNv
PyT9vpkaxuc/vbabeQjEYT+9DwOOlszoPz80+jjjrVI/ViJHghLT6T+I5Twi
V+1BP+80i3aO2eo/ZY79Tu5oLz+IR89qCuDrP/MjTQzzHRk/IVoTX4bm7D/+
6K9dXFUCP7psV1MC7e0/gVCcCxxu6D5Sf5tHfvPuPwAIM1Qnt80+65HfO/r5
7z8I5nhmB3+wPj1Cg+Fid/A/cOSTZT1kkj6FuxalyPHwP1j+w9u98HI+zTSq
aC5s8T8fVFZ7fQRSPhWuPSyU5vE/Br2kvgWqLz5dJ9Hv+WDyP064aqdlswk+
paBks1/b8j9q/1Sp4ETjPe0Z+HbFVfM/23y7h4Owuj01k4s6K9DzP8CnXILb
EpE9rK/D+utU9D9T0WIG8RlhPSLM+7qs2fQ/Evg+Y2s0Lz2Z6DN7bV71PwrE
w9ik7vk8EAVsOy7j9T9xLm6JOaHDPIYhpPvuZ/Y/I+aercYRizz9Pdy7r+z2
P2FSEH83AFE8dFoUfHBx9z8ULeDZinMTPOp2TDwx9vc/GZXnUoFF1DtcA/bF
GXL4P9H2LZqgS5c7zo+fTwLu+D9f0uF27q1YO7Ko8mLT5fk/lZDWHcKz1Tp6
2piJddX7P+66wHngS7k5wCsF3sgDAEAppCXSfsrpNspDnbYPEwJAiKGeuKIV
nzPCG/u09f4DQPDAC11XLxEwdYDrpUcUBkA0PjcGjzCxK35S/Ky+UQZAzBm4
4xhGJiuIJA20NY8GQFJ1xlYypJoqmsguwiMKB0Cfu3mMG/p9KaOaP8maRwdA
XMyGNVMz7CisbFDQEYUHQL80+EkJfVgotj5h14jCB0BaGIn7DKHDJ78Qct7/
/wdAld6GNBsMLSfSl9YP
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwB0QUu+iFib1JlAgAAAFwAAAACAAAAvxBy3v//B8C2e4QzqidlDV46mq5x
wgfAf9rr8GknQQ78Y8J+44QHwGuh0CDspBkPOLcSH8cJB8BYrYPxKXLGELBd
s1+OEwbAD3LocvrkCRTmHWLusP0DwCjsYSeHoLUaLx5LVzQLAsBzxvk/+XNx
IPDE1AB/IgDAvhm7s/NClyXtvZdvuyD8vwI8YgYzuacqHnL6kTpD+L/eB80p
PR3kLtoMOM/hEvS/fYIAC45a8jIO6W0bL+zvv5dINKH7jWI2sbhUAR5A6L8S
6ioUjqUbOdKq4jm63N+/E2BQa4EoiDsSEgTbquvdv+6Wz9fjbcc7UnklfJv6
27//eOQp4ekEPNNHaL58GNi//HfK6j/8eTwUr4lfbSfWv7fLfZ3dFbI8VBar
AF421L+kYrP4oyvnPJR9zKFORdK/U42/y4RSGz3U5O1CP1TQv8jlmYlSp009
GuVfSe7ZzL/RYEP5PnV8PYsA5AxeC8m/BSpoQtA3qT38G2jQzTzFv1tNbmR6
otQ9bjfskz1uwb8c4Mqzai7/Pb+l4K5aP7u/X1tHqAzBJT6i3Og1OqKzv90l
3dxCB0w+CifieTMKqL/uiygeMqxwPqAp5Q/ln5G/oMRonMpQkj78jEX6t9aO
P03lte3Y2bQ+TlsVhU47qD+xVIJgbJzVPq6pzIV3YLQ/fr4Ed3Vk9D62pQ7J
R6O8Pz8yUG3UhBE/3lAoBgxzwj80q/NeemcrP+JOySd0lMY/kYOFr4qDQz/m
TGpJ3LXKP56ZTKseTVk/6koLa0TXzj+n2FRm191tP2TkG2z1WNE/CodmC8CV
fj9UI7KiSEbTP2GWx2UD3Yw/RGJI2Zsz1T/Uley2ABqZPzSh3g/vINc/2qe7
VwwepD8k4HRGQg7ZP35WyZY/t60/FB8LfZX72j9DntGonTm0PwReobPo6Nw/
96+zd/teuT/znDfqO9beP1UASKtOVL0/TzSwiX124D+ca6OKg0u/PySaRB7d
geE/PgNe+/BVvj/6/9iyPI3iP7tRzpbPtro/z2VtR5yY4z+uihKsF1+1P6TL
Adz7o+Q/z3quxIMQrz96MZZwW6/lP46UTLqigqQ/T5cqBbu65j+d9x37xpqY
PyT9vpkaxuc/+zXdqXrQij+9DwOOlszoPxWt9uoT6no/ViJHghLT6T+mzEMb
naBoP+80i3aO2eo/N58rNBeLVD+IR89qCuDrPzuAs+KJPj8/IVoTX4bm7D9q
Y8nl9aglP7psV1MC7e0/OOlAOqVgCz9Sf5tHfvPuP+7S1zzWi+8+65HfO/r5
7z/sO1pZl5HQPj1Cg+Fid/A/QoSGUJ2FsT6FuxalyPHwPyqvHYHlGJE+zTSq
aC5s8T9eS9ieMMluPhWuPSyU5vE/TgmtMvGSST5dJ9Hv+WDyP1KhagMRmiM+
paBks1/b8j8TQ0o/qrn7Pe0Z+HbFVfM/PsdC8G8X0j01k4s6K9DzP1eFTd70
yKU9rK/D+utU9D9tAVIS12d0PSLM+7qs2fQ/Dm/VJyBjQT2Z6DN7bV71PwhQ
n4xJ9Ao9EAVsOy7j9T92+ifhbwHTPIYhpPvuZ/Y/EAWGFJJhmDz9Pdy7r+z2
P48axXe4c1w8dFoUfHBx9z88xyBBJTQePOp2TDwx9vc/TP9PB8sq3TtcA/bF
GXL4P1MyEX3qLZ87zo+fTwLu+D/rLEkiHrFeO7Ko8mLT5fk/F6knz6A41zp6
2piJddX7PzvlVox2w7M5wCsF3sgDAECiAUJ2BCXTNspDnbYPEwJAD1uZkWpw
dDPCG/u09f4DQDdo144Bn9MvdYDrpUcUBkAccS4KMEhdK35S/Ky+UQZABqj1
JVDX0CqIJA20NY8GQL+lWeuD3EEqmsguwiMKB0CEJypUW38fKaOaP8maRwdA
FnBrfn0viiisbFDQEYUHQBZwwY50EvQntj5h14jCB0A7nrN7aV9cJ78Qct7/
/wdA1vqiS1B9wib/GNGw
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQB2IQvV+g6N7//+wHbhx5oP29+aiOxXYh+eOcCP6G2M3x
fcJscP4z2aR3G/4yw/n6ct7hJtxMcP6HI1cY6pUY4Py3e6fn71b4sx/Glyv6
NdHK+Qecf4vH4vxDoS9wPt/LXGn9N+/3e3w4eNmt0sdq444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/D89rr+2X+uz73uWYf/W6bydX7Ro
q5/1Cjh/3cozreUJW+D8bUv5Trov3gPnP/I7qV4y5Ric/8qLO9vl+jk432Th
Pf73Ctfh/M9zzF9ZX7sH56v83TdT6thzOP/1xPvWv36+h/NtnZofJpV/sIe5
t3W32NITHxH8syarMvRyPsL5outsdaY8Q/CXLkjZHH/7E5xvOrnbSvvCZzhf
gDXHWu/xVzj/VZmPjeG373B+1a0ZnaVXf8P5B7RZ751gZnCA8U85z93GL8wE
5x+S/r3l6z9mOL+04fVSdxE2OH/WCb1DylzscD40fcH5AI62TNs=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwBYQWe+iFib1JlAgAAAFUAAAACAAAAvxBy3v//B8Ae3xNddRf8DF46mq5x
wgfAQNNC1qpC1A38Y8J+44QHwKh0cOhZ+KoOOLcSH8cJB8BKyv9Q9sdSELBd
s1+OEwbA75zYInLNixPmHWLusP0DwPBS6N7U4CIaLx5LVzQLAsAuyk1Fx2PM
H/DE1AB/IgDAWMw3tkQ64yTtvZdvuyD8v5q2uBkjZeQpHnL6kTpD+L9SPQVi
AEMULtoMOM/hEvS/7/EJm0x+FjIO6W0bL+zvv2lxO0sPWH41sbhUAR5A6L94
l6nfZbIwONKq4jm63N+/LxC6Yf3IljrU5O1CP1TQvyd0CaW09Vc8GuVfSe7Z
zL+mkV6iMa2GPIsA5AxeC8m/tICWe+nWszz8G2jQzTzFvyrPa4uRC+A8bjfs
kz1uwb80sr0Htf0HPb+l4K5aP7u/zyPzi3iUMD2i3Og1OqKzvwtjG2QbL1U9
CifieTMKqL/qqLcqNAV5PaAp5Q/ln5G/KrzXNjtRmz38jEX6t9aOP+cVqjA4
7r49TlsVhU47qD9uT9ETGO3fPa6pzIV3YLQ/sGmO5YAK/j22pQ7JR6O8P8oD
4xzJxBk+3lAoBgxzwj8uBeBecyY0PuJOySd0lMY/CunL2l66TD7mTGpJ3LXK
P7NK4oAnq2I+6koLa0TXzj8SdEfwVh52PmTkG2z1WNE/XOGl6FvBhj5UI7Ki
SEbTP2QYiM8jmZU+RGJI2Zsz1T99QNjZuumiPjSh3g/vINc/Dwx+RiaPrj4k
4HRGQg7ZP2eCM1H4xrY+FB8LfZX72j/ya1tvVFO/PgReobPo6Nw/OSwvEZvf
wz7znDfqO9beP5oKEH2eQ8c+TzSwiX124D+/HqbhCTLJPiSaRB7dgeE/P2BR
+4XSyD76/9iyPI3iPwAOH9jvPsY+z2VtR5yY4z80docwzSLCPqTLAdz7o+Q/
sHboak/muj56MZZwW6/lP4Wv0WurJbI+T5cqBbu65j8MMkqk+UWmPiT9vpka
xuc/FuGlok7emD69DwOOlszoP963u2QsmIk+ViJHghLT6T/oCizdbQt4Pu80
i3aO2eo/taLXUnOeZD6IR89qCuDrP5ucQ4G1I1A+IVoTX4bm7D+yDpsYKRA3
PrpsV1MC7e0/FOLNY0IVHj5Sf5tHfvPuP0keTxGy6AE+65HfO/r57z+yBkM/
snbjPT1Cg+Fid/A/gVvsNptFxT2FuxalyPHwP/FajAR8eaU9zTSqaC5s8T+y
wRw1dgaEPRWuPSyU5vE/gZuzi8c/YT1dJ9Hv+WDyP1YA2RPjcjs9paBks1/b
8j+6NAqHdCwUPe0Z+HbFVfM/fBd7sSlk6zw1k4s6K9DzP4R1qA5LLcE8rK/D
+utU9D93tEnaQ9aQPCLM+7qs2fQ/DahvdswQXjyZ6DN7bV71PwaKjqSPcyg8
EAVsOy7j9T+Fh8ft+hzyO4YhpPvuZ/Y/jsWAMbFxuDv9Pdy7r+z2P+uJawc0
DH476nZMPDH29z+c2i47CygBO1wD9sUZcvg/G42Eom1SwzrOj59PAu74P3kC
Tg6qD4Q6sqjyYtPl+T8YyC3FkPEAOnramIl11fs/Fp+OAQ044jjAKwXeyAMA
QCxtyC7qMA82ykOdtg8TAkDdVpiIzqm/MsIb+7T1/gNAoVnH5kfULS91gOul
RxQGQIdqtOvsFMkqflL8rL5RBkDSbayyMNs/KogkDbQ1jwZAbDd0q4essima
yC7CIwoHQMrEYMILMJQoo5o/yZpHB0C4lSCEdZ0CKKxsUNARhQdAIVwJvmKw
bye2PmHXiMIHQALwauPK5dgmvxBy3v//B0DWbFjWjw5CJvyBk/4=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwBYQWe+iFib1JlAgAAAFUAAAACAAAAvxBy3v//B8Cj2/WIAYTADF46mq5x
wgfAKkVUm3immg38Y8J+44QHwGBShe4d0nMOOLcSH8cJB8AkVWyj/iwhELBd
s1+OEwbAZktsd9trYxPmHWLusP0DwLfBtUrCDw8aLx5LVzQLAsDnmXyy2BHI
H/DE1AB/IgDA3nkCtjbU7iTtvZdvuyD8vxpdy9bsHP4pHnL6kTpD+L+S06Y0
EYY4LtoMOM/hEvS/qlAXieVrRTIO6W0bL+zvv4ML3S5Zv7Q1sbhUAR5A6L/0
a/mv3rNtONKq4jm63N+/sZxyLIra2DrU5O1CP1TQv33tIqIdTJ08GuVfSe7Z
zL92z+2bHPrLPIsA5AxeC8m/X7qckU2r+Dz8G2jQzTzFv3mmBW3xFSQ9bjfs
kz1uwb+wYdrRnTNOPb+l4K5aP7u/DS7hXWT3dD2i3Og1OqKzvwMs/s474Zo9
CifieTMKqL8w9ONNF9K/PaAp5Q/ln5G/mA+/80Zk4T38jEX6t9aOP6r33whl
sQM+TlsVhU47qD8sBSwuIE0kPq6pzIV3YLQ/gxXRpcANQz62pQ7JR6O8P3R5
KdntR2A+3lAoBgxzwj/ODWZVxlR5PuJOySd0lMY/6x5v7NzwkT7mTGpJ3LXK
P/zCXD0PI6c+6koLa0TXzj/0CwbwSSq7PmTkG2z1WNE/krDROOatyz5UI7Ki
SEbTP5Pz/7mL/dk+RGJI2Zsz1T9HmdVDaX3mPjSh3g/vINc/v5Ff/Rrv8T4k
4HRGQg7ZPz1zJwCpW/o+FB8LfZX72j+lsW0wkdkBPwReobPo6Nw/AUrnsYRH
Bj/znDfqO9bePxn4istXoAk/TzSwiX124D+xKAKzBjILPySaRB7dgeE/My24
I/83Cj/6/9iyPI3iP4E4KZ2c9gY/z2VtR5yY4z8PaZcyZ0UCP6TLAdz7o+Q/
buA+iPJp+j56MZZwW6/lP0MDWMtVWPE+T5cqBbu65j8W3plL0LHkPiT9vpka
xuc/94AAZkhu1j69DwOOlszoP0OoG3P8ZMY+ViJHghLT6T/zMLAp5GG0Pu80
i3aO2eo/lZK3hWTpoD6IR89qCuDrP7Ep5ZZ6lYk+IVoTX4bm7D94pORQNqRx
PrpsV1MC7e0/omb9G+0tVj5Sf5tHfvPuP9VXubuhazk+65HfO/r57z8TXMMh
dI8aPj1Cg+Fid/A/zQA8QOXy+z2FuxalyPHwPzmqZpXIIts9zTSqaC5s8T/q
14VSOU+4PRWuPSyU5vE/6IsC4PcXlD1dJ9Hv+WDyP5rOetNApm49paBks1/b
8j87FHgDYZFFPe0Z+HbFVfM/4OOZHuoBHD01k4s6K9DzPyM4yEthx/A8rK/D
+utU9D8jCytnc0O/PCLM+7qs2fQ//5t4CNJ+ijyZ6DN7bV71P9DbsTclbVQ8
EAVsOy7j9T8D37sid6YcPIYhpPvuZ/Y/OG/rBR1H4jv9Pdy7r+z2Pwr53ubz
NqU76nZMPDH29z8O4AGTm4MlO1wD9sUZcvg/PNnMhvLh5jrOj59PAu74PyAK
ZHNYaaY6sqjyYtPl+T+sBKe5QckgOnramIl11fs/GRWIO6wA/DjAKwXeyAMA
QHeXvJAW9xk2ykOdtg8TAkACoOTdW466MsIb+7T1/gNA7Mu4NhR+GC91gOul
RxQGQO5svIXXf6EqflL8rL5RBkAEYNQsTAcUKogkDbQ1jwZA16eNz8oihSma
yC7CIwoHQAp3eGVLc2Ioo5o/yZpHB0DuYiHyPYbOJ6xsUNARhQdAfnIiPPxH
Nye2PmHXiMIHQBuloPFPX6AmvxBy3v//B0DPXV/gZTsFJjYKnnE=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHjN+9EMq/eVDZYruQ/HFOBH9D7Ob4
PmE2OP+ZbNK7DX+Z4Xx9Oe9wE24mOP/DkSsM9UoMcP7bvdPzdyv82Q/jyxX9
mmjl/APOv8Vjcf6h0Bc4n+9lrrT+m/f71yj+O2k+391w444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/Fde3Nku18/Zfzu8/Z3z+5Omn+eY
v7K+dg/OV/m7b6bUsedw/uuJ961//XwP55tO7rbSvvDZHm5emY+N4bfvcH7V
rRmdpVd/w/kHtFnvnWBmcIDxTznP3cYvzATnH5L+veXrP2Y4v7Th9VJ3ETY4
f9YJvUPKXOxwPjR+4HwAAuTkvQ==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwBMQLO/SFib1JlAgAAACIAAAACAAAAvxBy3v//B8B3HNeN3Pm+Bl46mq5x
wgfAtTqHkcDllQf8Y8J+44QHwDQ82WUskmwIOLcSH8cJB8BHPVJUPx0TCrBd
s1+OEwbA2moc0bYdSg3mHWLusP0DwB6ujZvdzt0TLx5LVzQLAsDsV/f1QA6D
GfDE1AB/IgDAGiyAF98Dlh7tvZdvuyD8v1TO/iF1ppMjHnL6kTpD+L+So+/Z
GJ7AJ9oMOM/hEvS/+jFpenP8visO6W0bL+zvv5929iXcmyEvsbhUAR5A6L9E
zaxPC4TQMdKq4jm63N+/FV4B73/zMjTU5O1CP1TQv9NMZi5n8/A1oCnlD+Wf
kb+Q7jgbuX0wN+pKC2tE184//1R2Nop7BjjznDfqO9beP/sRTbl1I1Q4JP2+
mRrG5z+3PK3IbxYiOOuR3zv6+e8/Z81UKX7dZzc1k4s6K9DzP+zYVYRR9UE2
6nZMPDH29z9F71Dfsi1+NHramIl11fs/8UZzgKdFWzLAKwXeyAMAQPPwd8Ct
mYMvykOdtg8TAkAYu413NsIwLMIb+7T1/gNAhAgWvELnmih1gOulRxQGQPMR
ZdMUBDMkflL8rL5RBkB8PIrwb6ynI4gkDbQ1jwZA54mgDG40GyOayC7CIwoH
QP90ILqcQfwho5o/yZpHB0BBx5yj+YlpIaxsUNARhQdAUBVrEaZO1SC2PmHX
iMIHQPyFx2S9aEAgvxBy3v//B0DJzdM2a1SnHx2sCJI=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwBMQLO/SFib1JlAgAAACIAAAACAAAAvxBy3v//B8Dic6aymrdTBl46mq5x
wgfAQAuTF0qoLwf8Y8J+44QHwASjtPhRbQcIOLcSH8cJB8AyiuyiKxm0CbBd
s1+OEwbA7KJ8yGJG9gzmHWLusP0DwLUrroccDqETLx5LVzQLAsC4+EXigmFZ
GfDE1AB/IgDA5Qzt/YQ9fx7tvZdvuyD8v0P+7HfMOY0jHnL6kTpD+L/1qjOQ
i9zGJ9oMOM/hEvS/uuAoCtgd0ysO6W0bL+zvv5E4HiQFvUEvsbhUAR5A6L+h
z6CxSWb4MdKq4jm63N+/4HNEJdyMYzTU5O1CP1TQv0pMge21ISY2oCnlD+Wf
kb86i94oA0FpN+pKC2tE184/zVc92lTkQjjznDfqO9beP/Ku1qHAHpE4JP2+
mRrG5z9BjARimrFcOOuR3zv6+e8/NRkB/QNHoDc1k4s6K9DzP9QWulAVw3M2
6nZMPDH29z/c169nYESoNHramIl11fs/BgVkEjVWfjLAKwXeyAMAQKh8zkAR
7ZovykOdtg8TAkBuYvc/s2E6LMIb+7T1/gNAFzeS7F1glyh1gOulRxQGQE4g
+FsO/B8kflL8rL5RBkDUDGR+VTaSI4gkDbQ1jwZADNNdjI8fAyOayC7CIwoH
QADxyKD4huAho5o/yZpHB0DHGia1zDRLIaxsUNARhQdAs+MBt5eltCC2PmHX
iMIHQJZg/17+5BwgvxBy3v//B0D/ndJ2XKSCH77oBUY=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHzvgeaD4ScE/aYruQ/HFOBH9D7Ob4
PmE2OP+ZbNK7DX+Z4Xx9Oe9wE24mOP/DkSsM9UoMcP7bvdPzdyv82Q/jyxX9
mmjl/APOv8Vjcf6h0Bc4n+9lrrT+m/f7ldLl5IL5UzQ37ghhlHN4AedfWvXI
cted+3D+lSdvnexDLsD5CzSf8j+dPxHOf+XFne1y/Zz9Tx9WIQm2Z7qf55i/
sr52D85X+btvptSx53D+64n3rX/9fA/nm07uttK+8Nkebl6Zj43ht+9wftWt
GZ2lV3/D+Qe0We+dYGZwgPFPOc/dxi/MBOcfkv695es/Zji/tOH1UncRNjh/
1gm9Q8pc7HA+NH7gfADOsrtn
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2Q6IFZgbx9dFMj6TTXq34S/zgU9TNTlnl7xg15fzDjfh
ZjrwMURyR+nULt4PR64w1CsxHHh37rj4c8NZQm/3Ts/frfBn/x/XLzP3r5ks
Llf0a6KV84/9Uw+7cLUE75G+xWNx/qHQl/3C/ZP1P+puk+d7mSut/+b9/ocb
Hl34ayOqvHFHCKOcw4v9pwwzjqj+OqB6adUjy1137u+f7sZwJjJRQePKk7dO
9iEX9v/O1rq0/s0NzQWaT/mfzp+4X71QyZpto4j2Ky/ubJfr5+yXNrmEzt//
XPvzHPNX1tfu2Vv8y599SNZIR+XvvplSx57b58ZLqlwM/639euJ9618/39sv
W3cs/XiGnbbp5G4r7Quf7U/fNei+1ySs9arMx8bw23f7jR2X3c2memtU3ZrR
WXr1t/2e9KJtPmaqage0We+dYGZwuGv58nfSTE/lU85zt/ELMzls0r4XWJL/
Sf6Q9O8tX/8xO7i8naVhZR4pU9rweqm7CJuDkbTuhfff3orXBf1Zsy+QzaFa
wMLCzyNJvEOFd4tpP5vDG84bOg+nXxGbdULvkDIXu0NsuLLk1Z4tootn2Z+c
5c7usNmmmXWbiZLompyAC4Kt7A7pHzZ2XTjWK7LNLvF6xyF2Bz2RC1wGVd+E
oenBQXBbiOe3oHhhAIcx9s8=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2Q5My1+utqnjMMMz2aR3G/4yH/jwRSn5/+Icdn0573AT
bqYDrb/vdS4tU+H9cOQKQ70Sw4GojGslLSYeQm/3Ts/frfBnv860QjP+DaHi
ckW/Jlo5/9h/V+/kqYneE6Rv8Vicfyj0Zf/9k53Xy8VmyfO9zJXWf/N+/9kN
7mrMhuzKG3eEMMo5vNj/4sySnJpl+1QvrXpkuevO/f3TXf/vCmhR17jy5K2T
fciF/e1/bi/9MuGl5gLNp/xP50/cf2pVeuBFTh3tV17c2S7Xz9kzHrunHy7O
ovN5jvkr62v37P17i49W1gbqqPzdN1Pq2HN7nb5KhpUCMjqvJ963/vXzvb0y
wynBxKY4bdPJ3VbaFz7bL+fJbvtw2lDrVZmPjeG37/Ye4m2fLr1N0ai6NaOz
9Opve9Wzt++wKlqqHdBmvXeCmcEh5rDX3rrIUOVTznO38QszOdgGLv3yk/OL
/CHp31u+/mN2uNQrXavJHyhT2vB6qbsIm8OCSyee5UVeE68L+rNmXyCbw8pf
jD/lgj3FO1R4t5j2szn8PBWrWVy6S2zWCb1DylzsDnkf1lYvWjxNdPEs+5Oz
3Nkd7JYzP8ruYhJdkxNwQbCV3UFNkXWOFkOOyDa7xOsdh9gd1nwQXHSw7rIw
ND043EyOj13PbikMAAJs9bw=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHlNLl5IL5UzQttgvJH+dE8DfEbo7v
E2aD85/JJr3b8JcZzteX8w434WaC8z8cucJQr8QA57/dOz1/t8Kf/TC+XNGv
iVbOP+D8WzwW5x8KfYHz+V7mSuu/eb8/Zv0jEfmeV2Ybd4Qwyjm8gPMvrXpk
uevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs7ejqMupFY11/rzHPNX
1tfuwfkqf/fNlDr2HM5/PfG+9a+f7+F808ndVtoXPtvDzSvzsTH89h3Or7o1
o7P06m84/4A2670TzAwOMP4p57nb+IWZ4PxD0r+3fP3HDOeXNrxe6i7CBufP
OqF3SJmLHc6Hxg+cDwBoEb+u
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwBMQLO/SFib1JlAgAAACIAAAACAAAAvxBy3v//B8DoiD/lv+1pCF46mq5x
wgfAFvd+dBZ3Qwn8Y8J+44QHwN6ssJqc+BoKOLcSH8cJB8BXmak5bVnEC7Bd
s1+OEwbArWg4Z1muAQ/mHWLusP0DwAmcGn3+/qAVLx5LVzQLAsC7pluiB65R
G/DE1AB/IgDAEqJ0Jc91cCDtvZdvuyD8v4aSjdo1qHglHnL6kTpD+L9J2TVm
L+ewKdoMOM/hEvS/t6DgaNCaui0O6W0bL+zvv4Bkdgr+RykxsbhUAR5A6L9v
lfnd1CbjM9Kq4jm63N+/Qoo+D297UjbU5O1CP1TQvw1U47my3Bo4oCnlD+Wf
kb/+QYE24QdlOepKC2tE184/TELh7pYGSDrznDfqO9bePzCFqT3Ra6E6JP2+
mRrG5z9xDHM55WB6OuuR3zv6+e8/7HRj3P0OzTk1k4s6K9DzP+rQarHmorE4
6nZMPDH29z+T+xj5JOT4NnramIl11fs/ImOs+QNA4jTAKwXeyAMAQImrnR5w
KRYyykOdtg8TAkBEOMb1brbPLsIb+7T1/gNADbwuwbuTRCt1gOulRxQGQEOY
76lHfOgmflL8rL5RBkDdtGVIMi9gJogkDbQ1jwZAQQbmlMe/0yWayC7CIwoH
QDsXT4IQIbcko5o/yZpHB0DliW30wDImJKxsUNARhQdAbO1UIneqkyO2PmHX
iMIHQOgDCQsGFQAjvxBy3v//B0Dq8LUbikdoIqNhCCg=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwBMQLO/SFib1JlAgAAACIAAAACAAAAvxBy3v//B8DEmcsUAbhECF46mq5x
wgfAKszJr3riIAn8Y8J+44QHwPJr8HxVXvkJOLcSH8cJB8AGitTco22mC7Bd
s1+OEwbA1h9tIeFl6g7mHWLusP0DwNa1WLHqBpcVLx5LVzQLAsA8cFoLO1pT
G/DE1AB/IgDAEXhvtA7XeiDtvZdvuyD8vzmBOjGQlIwlHnL6kTpD+L/pL4aA
ajrJKdoMOM/hEvS/cKOlCRgM2C0O6W0bL+zvv/a8MOH8X0kxsbhUAR5A6L97
Rhl086wDNNKq4jm63N+/IOjkul/0cTbU5O1CP1TQv1rwN3Pu8jY4oCnlD+Wf
kb8s3o26BH99OepKC2tE184/H4XYZGAbWTrznDfqO9beP2fzx61sqqk6JP2+
mRrG5z+2Zv5OUYJ4OuuR3zv6+e8/XhOapnCcvzk1k4s6K9DzP7KU9NJqoJU4
6nZMPDH29z8mm8TEADzONnramIl11fs/maDniYtUpTTAKwXeyAMAQAPOWTDz
lcUxykOdtg8TAkDk5dHqYA5oLsIb+7T1/gNAt0sMDnkJyCp1gOulRxQGQPgH
41lku1ImflL8rL5RBkBk4i2nqKfFJYgkDbQ1jwZAWA7pzgQVNyWayC7CIwoH
QJDz6piBjhQko5o/yZpHB0CX6g7V8SyBI6xsUNARhQdAK5MAb6J26iK2PmHX
iMIHQLmHtvkgzFIivxBy3v//B0DD0CUoQp+4IdN/CwM=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQB2IQvV+g6N7//+wHbhx5oP29+aiOxXYh+eOcCP6G2M3x
fcJscP4z2aR3G/4yw/n6ct7hJtxMcP6HI1cY6pUY4Py3e6fn71b4sx/Glyv6
NdHK+Qecf4vH4vxDoS9wPt/LXGn9N+/3e3w4eNmt0sdq444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/D89rr+2X+uz73uWYf/W6bydX7Ro
q5/1Cjh/3cozreUJW+D8bUv5Trov3gPnP/I7qV4y5Ric/8qLO9vl+jk432Th
Pf73Ctfh/M9zzF9ZX7sH56v83TdT6thzOP/1xPvWv36+h/NtnZofJpV/sIe5
t3W32NITHxH8syarMvRyPsL5outsdaY8Q/CXLkjZHH/7E5xvOrnbSvvCZzhf
gDXHWu/xVzj/VZmPjeG373B+1a0ZnaVXf8P5B7RZ751gZnCA8U85z93GL8wE
5x+S/r3l6z9mOL+04fVSdxE2OH/WCb1DylzscD40fcH5AI62TNs=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwB0QUu+iFib1JlAgAAAFwAAAACAAAAvxBy3v//B8DPT7/QfHmKDV46mq5x
wgfAlLWZeQt7Yw78Y8J+44QHwCMpPzX/dDoPOLcSH8cJB8Dbr/9bXS3jELBd
s1+OEwbAv7vPlBnCHhTmHWLusP0DwEIoKFCB2bgaLx5LVzQLAsCGhZzrH/pl
IPDE1AB/IgDAMsEUBo5zgSXtvZdvuyD8v2kTo698/4UqHnL6kTpD+L9f4qsp
bay5LtoMOM/hEvS/Q4yijOr3wDIO6W0bL+zvv0wz0pdyKys2sbhUAR5A6L8w
PtGIqorhONKq4jm63N+/5DtqR/l3TDsSEgTbquvdv/R7rmLvhYs7UnklfJv6
27/dje3764TIO9NHaL58GNi/r0okLhlzPjwUr4lfbSfWvxKex+I7OXU8VBar
AF421L+/m6ztIUOrPJR9zKFORdK/Gnu/CmMi4DzU5O1CP1TQv91OnVPpmBE9
GuVfSe7ZzL8YDyCJBv1APYsA5AxeC8m/BC5p30BSbj38G2jQzTzFv6woH4dy
A5k9bjfskz1uwb9u2GRRJhPDPb+l4K5aP7u/qmfBKpDk6j2i3Og1OqKzv9ge
i4I+hhE+CifieTMKqL/SrayrzBw1PqAp5Q/ln5G/KgLP4iqDVz78jEX6t9aO
P/blthOKM3s+TlsVhU47qD/sJXU/AbCcPq6pzIV3YLQ/oUZRh6iUuz62pQ7J
R6O8P2T5k/07LNg+3lAoBgxzwj9xu8bYN1DzPuJOySd0lMY/s5CVYT4iDD/m
TGpJ3LXKP4/NbNYVriI/6koLa0TXzj/Dh5rWCJ02P2TkG2z1WNE/Fal9S3m8
Rz9UI7KiSEbTP3059+pw/FY/RGJI2Zsz1T/Iju+lWYlkPzSh3g/vINc/BtBV
nHrtcD8k4HRGQg7ZPxX81s7lvnk/FB8LfZX72j+8gvKvIhCCPwReobPo6Nw/
G3AbNj9ihz/znDfqO9beP0kLX+eu7Ys/TzSwiX124D/hSuZWlOmOPySaRB7d
geE/6vyY3+gfjz/6/9iyPI3iP+M9dSX0gYw/z2VtR5yY4z+ZbaWMjcCHP6TL
Adz7o+Q/gSXsHZ0Agj96MZZwW6/lP0My7bf10ng/T5cqBbu65j/z5XJ6giNv
PyT9vpkaxuc/vbabeQjEYT+9DwOOlszoPz80+jjjrVI/ViJHghLT6T+I5Twi
V+1BP+80i3aO2eo/ZY79Tu5oLz+IR89qCuDrP/MjTQzzHRk/IVoTX4bm7D/+
6K9dXFUCP7psV1MC7e0/gVCcCxxu6D5Sf5tHfvPuPwAIM1Qnt80+65HfO/r5
7z8I5nhmB3+wPj1Cg+Fid/A/cOSTZT1kkj6FuxalyPHwP1j+w9u98HI+zTSq
aC5s8T8fVFZ7fQRSPhWuPSyU5vE/Br2kvgWqLz5dJ9Hv+WDyP064aqdlswk+
paBks1/b8j9q/1Sp4ETjPe0Z+HbFVfM/23y7h4Owuj01k4s6K9DzP8CnXILb
EpE9rK/D+utU9D9T0WIG8RlhPSLM+7qs2fQ/Evg+Y2s0Lz2Z6DN7bV71PwrE
w9ik7vk8EAVsOy7j9T9xLm6JOaHDPIYhpPvuZ/Y/I+aercYRizz9Pdy7r+z2
P2FSEH83AFE8dFoUfHBx9z8ULeDZinMTPOp2TDwx9vc/GZXnUoFF1DtcA/bF
GXL4P9H2LZqgS5c7zo+fTwLu+D9f0uF27q1YO7Ko8mLT5fk/lZDWHcKz1Tp6
2piJddX7P+66wHngS7k5wCsF3sgDAEAppCXSfsrpNspDnbYPEwJAiKGeuKIV
nzPCG/u09f4DQPDAC11XLxEwdYDrpUcUBkA0PjcGjzCxK35S/Ky+UQZAzBm4
4xhGJiuIJA20NY8GQFJ1xlYypJoqmsguwiMKB0Cfu3mMG/p9KaOaP8maRwdA
XMyGNVMz7CisbFDQEYUHQL80+EkJfVgotj5h14jCB0BaGIn7DKHDJ78Qct7/
/wdAld6GNBsMLSfSl9YP
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwB0QUu+iFib1JlAgAAAFwAAAACAAAAvxBy3v//B8C2e4QzqidlDV46mq5x
wgfAf9rr8GknQQ78Y8J+44QHwGuh0CDspBkPOLcSH8cJB8BYrYPxKXLGELBd
s1+OEwbAD3LocvrkCRTmHWLusP0DwCjsYSeHoLUaLx5LVzQLAsBzxvk/+XNx
IPDE1AB/IgDAvhm7s/NClyXtvZdvuyD8vwI8YgYzuacqHnL6kTpD+L/eB80p
PR3kLtoMOM/hEvS/fYIAC45a8jIO6W0bL+zvv5dINKH7jWI2sbhUAR5A6L8S
6ioUjqUbOdKq4jm63N+/E2BQa4EoiDsSEgTbquvdv+6Wz9fjbcc7UnklfJv6
27//eOQp4ekEPNNHaL58GNi//HfK6j/8eTwUr4lfbSfWv7fLfZ3dFbI8VBar
AF421L+kYrP4oyvnPJR9zKFORdK/U42/y4RSGz3U5O1CP1TQv8jlmYlSp009
GuVfSe7ZzL/RYEP5PnV8PYsA5AxeC8m/BSpoQtA3qT38G2jQzTzFv1tNbmR6
otQ9bjfskz1uwb8c4Mqzai7/Pb+l4K5aP7u/X1tHqAzBJT6i3Og1OqKzv90l
3dxCB0w+CifieTMKqL/uiygeMqxwPqAp5Q/ln5G/oMRonMpQkj78jEX6t9aO
P03lte3Y2bQ+TlsVhU47qD+xVIJgbJzVPq6pzIV3YLQ/fr4Ed3Vk9D62pQ7J
R6O8Pz8yUG3UhBE/3lAoBgxzwj80q/NeemcrP+JOySd0lMY/kYOFr4qDQz/m
TGpJ3LXKP56ZTKseTVk/6koLa0TXzj+n2FRm191tP2TkG2z1WNE/CodmC8CV
fj9UI7KiSEbTP2GWx2UD3Yw/RGJI2Zsz1T/Uley2ABqZPzSh3g/vINc/2qe7
VwwepD8k4HRGQg7ZP35WyZY/t60/FB8LfZX72j9DntGonTm0PwReobPo6Nw/
96+zd/teuT/znDfqO9beP1UASKtOVL0/TzSwiX124D+ca6OKg0u/PySaRB7d
geE/PgNe+/BVvj/6/9iyPI3iP7tRzpbPtro/z2VtR5yY4z+uihKsF1+1P6TL
Adz7o+Q/z3quxIMQrz96MZZwW6/lP46UTLqigqQ/T5cqBbu65j+d9x37xpqY
PyT9vpkaxuc/+zXdqXrQij+9DwOOlszoPxWt9uoT6no/ViJHghLT6T+mzEMb
naBoP+80i3aO2eo/N58rNBeLVD+IR89qCuDrPzuAs+KJPj8/IVoTX4bm7D9q
Y8nl9aglP7psV1MC7e0/OOlAOqVgCz9Sf5tHfvPuP+7S1zzWi+8+65HfO/r5
7z/sO1pZl5HQPj1Cg+Fid/A/QoSGUJ2FsT6FuxalyPHwPyqvHYHlGJE+zTSq
aC5s8T9eS9ieMMluPhWuPSyU5vE/TgmtMvGSST5dJ9Hv+WDyP1KhagMRmiM+
paBks1/b8j8TQ0o/qrn7Pe0Z+HbFVfM/PsdC8G8X0j01k4s6K9DzP1eFTd70
yKU9rK/D+utU9D9tAVIS12d0PSLM+7qs2fQ/Dm/VJyBjQT2Z6DN7bV71PwhQ
n4xJ9Ao9EAVsOy7j9T92+ifhbwHTPIYhpPvuZ/Y/EAWGFJJhmDz9Pdy7r+z2
P48axXe4c1w8dFoUfHBx9z88xyBBJTQePOp2TDwx9vc/TP9PB8sq3TtcA/bF
GXL4P1MyEX3qLZ87zo+fTwLu+D/rLEkiHrFeO7Ko8mLT5fk/F6knz6A41zp6
2piJddX7PzvlVox2w7M5wCsF3sgDAECiAUJ2BCXTNspDnbYPEwJAD1uZkWpw
dDPCG/u09f4DQDdo144Bn9MvdYDrpUcUBkAccS4KMEhdK35S/Ky+UQZABqj1
JVDX0CqIJA20NY8GQL+lWeuD3EEqmsguwiMKB0CEJypUW38fKaOaP8maRwdA
FnBrfn0viiisbFDQEYUHQBZwwY50EvQntj5h14jCB0A7nrN7aV9cJ78Qct7/
/wdA1vqiS1B9wib/GNGw
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQB2IQvV+g6N7//+wHbhx5oP29+aiOxXYh+eOcCP6G2M3x
fcJscP4z2aR3G/4yw/n6ct7hJtxMcP6HI1cY6pUY4Py3e6fn71b4sx/Glyv6
NdHK+Qecf4vH4vxDoS9wPt/LXGn9N+/3e3w4eNmt0sdq444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/D89rr+2X+uz73uWYf/W6bydX7Ro
q5/1Cjh/3cozreUJW+D8bUv5Trov3gPnP/I7qV4y5Ric/8qLO9vl+jk432Th
Pf73Ctfh/M9zzF9ZX7sH56v83TdT6thzOP/1xPvWv36+h/NtnZofJpV/sIe5
t3W32NITHxH8syarMvRyPsL5outsdaY8Q/CXLkjZHH/7E5xvOrnbSvvCZzhf
gDXHWu/xVzj/VZmPjeG373B+1a0ZnaVXf8P5B7RZ751gZnCA8U85z93GL8wE
5x+S/r3l6z9mOL+04fVSdxE2OH/WCb1DylzscD40fcH5AI62TNs=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwBYQWe+iFib1JlAgAAAFUAAAACAAAAvxBy3v//B8Ae3xNddRf8DF46mq5x
wgfAQNNC1qpC1A38Y8J+44QHwKh0cOhZ+KoOOLcSH8cJB8BKyv9Q9sdSELBd
s1+OEwbA75zYInLNixPmHWLusP0DwPBS6N7U4CIaLx5LVzQLAsAuyk1Fx2PM
H/DE1AB/IgDAWMw3tkQ64yTtvZdvuyD8v5q2uBkjZeQpHnL6kTpD+L9SPQVi
AEMULtoMOM/hEvS/7/EJm0x+FjIO6W0bL+zvv2lxO0sPWH41sbhUAR5A6L94
l6nfZbIwONKq4jm63N+/LxC6Yf3IljrU5O1CP1TQvyd0CaW09Vc8GuVfSe7Z
zL+mkV6iMa2GPIsA5AxeC8m/tICWe+nWszz8G2jQzTzFvyrPa4uRC+A8bjfs
kz1uwb80sr0Htf0HPb+l4K5aP7u/zyPzi3iUMD2i3Og1OqKzvwtjG2QbL1U9
CifieTMKqL/qqLcqNAV5PaAp5Q/ln5G/KrzXNjtRmz38jEX6t9aOP+cVqjA4
7r49TlsVhU47qD9uT9ETGO3fPa6pzIV3YLQ/sGmO5YAK/j22pQ7JR6O8P8oD
4xzJxBk+3lAoBgxzwj8uBeBecyY0PuJOySd0lMY/CunL2l66TD7mTGpJ3LXK
P7NK4oAnq2I+6koLa0TXzj8SdEfwVh52PmTkG2z1WNE/XOGl6FvBhj5UI7Ki
SEbTP2QYiM8jmZU+RGJI2Zsz1T99QNjZuumiPjSh3g/vINc/Dwx+RiaPrj4k
4HRGQg7ZP2eCM1H4xrY+FB8LfZX72j/ya1tvVFO/PgReobPo6Nw/OSwvEZvf
wz7znDfqO9beP5oKEH2eQ8c+TzSwiX124D+/HqbhCTLJPiSaRB7dgeE/P2BR
+4XSyD76/9iyPI3iPwAOH9jvPsY+z2VtR5yY4z80docwzSLCPqTLAdz7o+Q/
sHboak/muj56MZZwW6/lP4Wv0WurJbI+T5cqBbu65j8MMkqk+UWmPiT9vpka
xuc/FuGlok7emD69DwOOlszoP963u2QsmIk+ViJHghLT6T/oCizdbQt4Pu80
i3aO2eo/taLXUnOeZD6IR89qCuDrP5ucQ4G1I1A+IVoTX4bm7D+yDpsYKRA3
PrpsV1MC7e0/FOLNY0IVHj5Sf5tHfvPuP0keTxGy6AE+65HfO/r57z+yBkM/
snbjPT1Cg+Fid/A/gVvsNptFxT2FuxalyPHwP/FajAR8eaU9zTSqaC5s8T+y
wRw1dgaEPRWuPSyU5vE/gZuzi8c/YT1dJ9Hv+WDyP1YA2RPjcjs9paBks1/b
8j+6NAqHdCwUPe0Z+HbFVfM/fBd7sSlk6zw1k4s6K9DzP4R1qA5LLcE8rK/D
+utU9D93tEnaQ9aQPCLM+7qs2fQ/DahvdswQXjyZ6DN7bV71PwaKjqSPcyg8
EAVsOy7j9T+Fh8ft+hzyO4YhpPvuZ/Y/jsWAMbFxuDv9Pdy7r+z2P+uJawc0
DH476nZMPDH29z+c2i47CygBO1wD9sUZcvg/G42Eom1SwzrOj59PAu74P3kC
Tg6qD4Q6sqjyYtPl+T8YyC3FkPEAOnramIl11fs/Fp+OAQ044jjAKwXeyAMA
QCxtyC7qMA82ykOdtg8TAkDdVpiIzqm/MsIb+7T1/gNAoVnH5kfULS91gOul
RxQGQIdqtOvsFMkqflL8rL5RBkDSbayyMNs/KogkDbQ1jwZAbDd0q4essima
yC7CIwoHQMrEYMILMJQoo5o/yZpHB0C4lSCEdZ0CKKxsUNARhQdAIVwJvmKw
bye2PmHXiMIHQALwauPK5dgmvxBy3v//B0DWbFjWjw5CJvyBk/4=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwBYQWe+iFib1JlAgAAAFUAAAACAAAAvxBy3v//B8Cj2/WIAYTADF46mq5x
wgfAKkVUm3immg38Y8J+44QHwGBShe4d0nMOOLcSH8cJB8AkVWyj/iwhELBd
s1+OEwbAZktsd9trYxPmHWLusP0DwLfBtUrCDw8aLx5LVzQLAsDnmXyy2BHI
H/DE1AB/IgDA3nkCtjbU7iTtvZdvuyD8vxpdy9bsHP4pHnL6kTpD+L+S06Y0
EYY4LtoMOM/hEvS/qlAXieVrRTIO6W0bL+zvv4ML3S5Zv7Q1sbhUAR5A6L/0
a/mv3rNtONKq4jm63N+/sZxyLIra2DrU5O1CP1TQv33tIqIdTJ08GuVfSe7Z
zL92z+2bHPrLPIsA5AxeC8m/X7qckU2r+Dz8G2jQzTzFv3mmBW3xFSQ9bjfs
kz1uwb+wYdrRnTNOPb+l4K5aP7u/DS7hXWT3dD2i3Og1OqKzvwMs/s474Zo9
CifieTMKqL8w9ONNF9K/PaAp5Q/ln5G/mA+/80Zk4T38jEX6t9aOP6r33whl
sQM+TlsVhU47qD8sBSwuIE0kPq6pzIV3YLQ/gxXRpcANQz62pQ7JR6O8P3R5
KdntR2A+3lAoBgxzwj/ODWZVxlR5PuJOySd0lMY/6x5v7NzwkT7mTGpJ3LXK
P/zCXD0PI6c+6koLa0TXzj/0CwbwSSq7PmTkG2z1WNE/krDROOatyz5UI7Ki
SEbTP5Pz/7mL/dk+RGJI2Zsz1T9HmdVDaX3mPjSh3g/vINc/v5Ff/Rrv8T4k
4HRGQg7ZPz1zJwCpW/o+FB8LfZX72j+lsW0wkdkBPwReobPo6Nw/AUrnsYRH
Bj/znDfqO9bePxn4istXoAk/TzSwiX124D+xKAKzBjILPySaRB7dgeE/My24
I/83Cj/6/9iyPI3iP4E4KZ2c9gY/z2VtR5yY4z8PaZcyZ0UCP6TLAdz7o+Q/
buA+iPJp+j56MZZwW6/lP0MDWMtVWPE+T5cqBbu65j8W3plL0LHkPiT9vpka
xuc/94AAZkhu1j69DwOOlszoP0OoG3P8ZMY+ViJHghLT6T/zMLAp5GG0Pu80
i3aO2eo/lZK3hWTpoD6IR89qCuDrP7Ep5ZZ6lYk+IVoTX4bm7D94pORQNqRx
PrpsV1MC7e0/omb9G+0tVj5Sf5tHfvPuP9VXubuhazk+65HfO/r57z8TXMMh
dI8aPj1Cg+Fid/A/zQA8QOXy+z2FuxalyPHwPzmqZpXIIts9zTSqaC5s8T/q
14VSOU+4PRWuPSyU5vE/6IsC4PcXlD1dJ9Hv+WDyP5rOetNApm49paBks1/b
8j87FHgDYZFFPe0Z+HbFVfM/4OOZHuoBHD01k4s6K9DzPyM4yEthx/A8rK/D
+utU9D8jCytnc0O/PCLM+7qs2fQ//5t4CNJ+ijyZ6DN7bV71P9DbsTclbVQ8
EAVsOy7j9T8D37sid6YcPIYhpPvuZ/Y/OG/rBR1H4jv9Pdy7r+z2Pwr53ubz
NqU76nZMPDH29z8O4AGTm4MlO1wD9sUZcvg/PNnMhvLh5jrOj59PAu74PyAK
ZHNYaaY6sqjyYtPl+T+sBKe5QckgOnramIl11fs/GRWIO6wA/DjAKwXeyAMA
QHeXvJAW9xk2ykOdtg8TAkACoOTdW466MsIb+7T1/gNA7Mu4NhR+GC91gOul
RxQGQO5svIXXf6EqflL8rL5RBkAEYNQsTAcUKogkDbQ1jwZA16eNz8oihSma
yC7CIwoHQAp3eGVLc2Ioo5o/yZpHB0DuYiHyPYbOJ6xsUNARhQdAfnIiPPxH
Nye2PmHXiMIHQBuloPFPX6AmvxBy3v//B0DPXV/gZTsFJjYKnnE=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHjN+9EMq/eVDZYruQ/HFOBH9D7Ob4
PmE2OP+ZbNK7DX+Z4Xx9Oe9wE24mOP/DkSsM9UoMcP7bvdPzdyv82Q/jyxX9
mmjl/APOv8Vjcf6h0Bc4n+9lrrT+m/f71yj+O2k+391w444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/Fde3Nku18/Zfzu8/Z3z+5Omn+eY
v7K+dg/OV/m7b6bUsedw/uuJ961//XwP55tO7rbSvvDZHm5emY+N4bfvcH7V
rRmdpVd/w/kHtFnvnWBmcIDxTznP3cYvzATnH5L+veXrP2Y4v7Th9VJ3ETY4
f9YJvUPKXOxwPjR+4HwAAuTkvQ==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwBMQLO/SFib1JlAgAAACIAAAACAAAAvxBy3v//B8B3HNeN3Pm+Bl46mq5x
wgfAtTqHkcDllQf8Y8J+44QHwDQ82WUskmwIOLcSH8cJB8BHPVJUPx0TCrBd
s1+OEwbA2moc0bYdSg3mHWLusP0DwB6ujZvdzt0TLx5LVzQLAsDsV/f1QA6D
GfDE1AB/IgDAGiyAF98Dlh7tvZdvuyD8v1TO/iF1ppMjHnL6kTpD+L+So+/Z
GJ7AJ9oMOM/hEvS/+jFpenP8visO6W0bL+zvv5929iXcmyEvsbhUAR5A6L9E
zaxPC4TQMdKq4jm63N+/FV4B73/zMjTU5O1CP1TQv9NMZi5n8/A1oCnlD+Wf
kb+Q7jgbuX0wN+pKC2tE184//1R2Nop7BjjznDfqO9beP/sRTbl1I1Q4JP2+
mRrG5z+3PK3IbxYiOOuR3zv6+e8/Z81UKX7dZzc1k4s6K9DzP+zYVYRR9UE2
6nZMPDH29z9F71Dfsi1+NHramIl11fs/8UZzgKdFWzLAKwXeyAMAQPPwd8Ct
mYMvykOdtg8TAkAYu413NsIwLMIb+7T1/gNAhAgWvELnmih1gOulRxQGQPMR
ZdMUBDMkflL8rL5RBkB8PIrwb6ynI4gkDbQ1jwZA54mgDG40GyOayC7CIwoH
QP90ILqcQfwho5o/yZpHB0BBx5yj+YlpIaxsUNARhQdAUBVrEaZO1SC2PmHX
iMIHQPyFx2S9aEAgvxBy3v//B0DJzdM2a1SnHx2sCJI=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwBMQLO/SFib1JlAgAAACIAAAACAAAAvxBy3v//B8Dic6aymrdTBl46mq5x
wgfAQAuTF0qoLwf8Y8J+44QHwASjtPhRbQcIOLcSH8cJB8AyiuyiKxm0CbBd
s1+OEwbA7KJ8yGJG9gzmHWLusP0DwLUrroccDqETLx5LVzQLAsC4+EXigmFZ
GfDE1AB/IgDA5Qzt/YQ9fx7tvZdvuyD8v0P+7HfMOY0jHnL6kTpD+L/1qjOQ
i9zGJ9oMOM/hEvS/uuAoCtgd0ysO6W0bL+zvv5E4HiQFvUEvsbhUAR5A6L+h
z6CxSWb4MdKq4jm63N+/4HNEJdyMYzTU5O1CP1TQv0pMge21ISY2oCnlD+Wf
kb86i94oA0FpN+pKC2tE184/zVc92lTkQjjznDfqO9beP/Ku1qHAHpE4JP2+
mRrG5z9BjARimrFcOOuR3zv6+e8/NRkB/QNHoDc1k4s6K9DzP9QWulAVw3M2
6nZMPDH29z/c169nYESoNHramIl11fs/BgVkEjVWfjLAKwXeyAMAQKh8zkAR
7ZovykOdtg8TAkBuYvc/s2E6LMIb+7T1/gNAFzeS7F1glyh1gOulRxQGQE4g
+FsO/B8kflL8rL5RBkDUDGR+VTaSI4gkDbQ1jwZADNNdjI8fAyOayC7CIwoH
QADxyKD4huAho5o/yZpHB0DHGia1zDRLIaxsUNARhQdAs+MBt5eltCC2PmHX
iMIHQJZg/17+5BwgvxBy3v//B0D/ndJ2XKSCH77oBUY=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHzvgeaD4ScE/aYruQ/HFOBH9D7Ob4
PmE2OP+ZbNK7DX+Z4Xx9Oe9wE24mOP/DkSsM9UoMcP7bvdPzdyv82Q/jyxX9
mmjl/APOv8Vjcf6h0Bc4n+9lrrT+m/f7ldLl5IL5UzQ37ghhlHN4AedfWvXI
cted+3D+lSdvnexDLsD5CzSf8j+dPxHOf+XFne1y/Zz9Tx9WIQm2Z7qf55i/
sr52D85X+btvptSx53D+64n3rX/9fA/nm07uttK+8Nkebl6Zj43ht+9wftWt
GZ2lV3/D+Qe0We+dYGZwgPFPOc/dxi/MBOcfkv695es/Zji/tOH1UncRNjh/
1gm9Q8pc7HA+NH7gfADOsrtn
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2Q6IFZgbx9dFMj6TTXq34S/zgU9TNTlnl7xg15fzDjfh
ZjrwMURyR+nULt4PR64w1CsxHHh37rj4c8NZQm/3Ts/frfBn/x/XLzP3r5ks
Llf0a6KV84/9Uw+7cLUE75G+xWNx/qHQl/3C/ZP1P+puk+d7mSut/+b9/ocb
Hl34ayOqvHFHCKOcw4v9pwwzjqj+OqB6adUjy1137u+f7sZwJjJRQePKk7dO
9iEX9v/O1rq0/s0NzQWaT/mfzp+4X71QyZpto4j2Ky/ubJfr5+yXNrmEzt//
XPvzHPNX1tfu2Vv8y599SNZIR+XvvplSx57b58ZLqlwM/639euJ9618/39sv
W3cs/XiGnbbp5G4r7Quf7U/fNei+1ySs9arMx8bw23f7jR2X3c2memtU3ZrR
WXr1t/2e9KJtPmaqage0We+dYGZwuGv58nfSTE/lU85zt/ELMzls0r4XWJL/
Sf6Q9O8tX/8xO7i8naVhZR4pU9rweqm7CJuDkbTuhfff3orXBf1Zsy+QzaFa
wMLCzyNJvEOFd4tpP5vDG84bOg+nXxGbdULvkDIXu0NsuLLk1Z4tootn2Z+c
5c7usNmmmXWbiZLompyAC4Kt7A7pHzZ2XTjWK7LNLvF6xyF2Bz2RC1wGVd+E
oenBQXBbiOe3oHhhAIcx9s8=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2Q5My1+utqnjMMMz2aR3G/4yH/jwRSn5/+Icdn0573AT
bqYDrb/vdS4tU+H9cOQKQ70Sw4GojGslLSYeQm/3Ts/frfBnv860QjP+DaHi
ckW/Jlo5/9h/V+/kqYneE6Rv8Vicfyj0Zf/9k53Xy8VmyfO9zJXWf/N+/9kN
7mrMhuzKG3eEMMo5vNj/4sySnJpl+1QvrXpkuevO/f3TXf/vCmhR17jy5K2T
fciF/e1/bi/9MuGl5gLNp/xP50/cf2pVeuBFTh3tV17c2S7Xz9kzHrunHy7O
ovN5jvkr62v37P17i49W1gbqqPzdN1Pq2HN7nb5KhpUCMjqvJ963/vXzvb0y
wynBxKY4bdPJ3VbaFz7bL+fJbvtw2lDrVZmPjeG37/Ye4m2fLr1N0ai6NaOz
9Opve9Wzt++wKlqqHdBmvXeCmcEh5rDX3rrIUOVTznO38QszOdgGLv3yk/OL
/CHp31u+/mN2uNQrXavJHyhT2vB6qbsIm8OCSyee5UVeE68L+rNmXyCbw8pf
jD/lgj3FO1R4t5j2szn8PBWrWVy6S2zWCb1DylzsDnkf1lYvWjxNdPEs+5Oz
3Nkd7JYzP8ruYhJdkxNwQbCV3UFNkXWOFkOOyDa7xOsdh9gd1nwQXHSw7rIw
ND043EyOj13PbikMAAJs9bw=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHlNLl5IL5UzQttgvJH+dE8DfEbo7v
E2aD85/JJr3b8JcZzteX8w434WaC8z8cucJQr8QA57/dOz1/t8Kf/TC+XNGv
iVbOP+D8WzwW5x8KfYHz+V7mSuu/eb8/Zv0jEfmeV2Ybd4Qwyjm8gPMvrXpk
uevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs7ejqMupFY11/rzHPNX
1tfuwfkqf/fNlDr2HM5/PfG+9a+f7+F808ndVtoXPtvDzSvzsTH89h3Or7o1
o7P06m84/4A2670TzAwOMP4p57nb+IWZ4PxD0r+3fP3HDOeXNrxe6i7CBufP
OqF3SJmLHc6Hxg+cDwBoEb+u
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwBMQLO/SFib1JlAgAAACIAAAACAAAAvxBy3v//B8DoiD/lv+1pCF46mq5x
wgfAFvd+dBZ3Qwn8Y8J+44QHwN6ssJqc+BoKOLcSH8cJB8BXmak5bVnEC7Bd
s1+OEwbArWg4Z1muAQ/mHWLusP0DwAmcGn3+/qAVLx5LVzQLAsC7pluiB65R
G/DE1AB/IgDAEqJ0Jc91cCDtvZdvuyD8v4aSjdo1qHglHnL6kTpD+L9J2TVm
L+ewKdoMOM/hEvS/t6DgaNCaui0O6W0bL+zvv4Bkdgr+RykxsbhUAR5A6L9v
lfnd1CbjM9Kq4jm63N+/Qoo+D297UjbU5O1CP1TQvw1U47my3Bo4oCnlD+Wf
kb/+QYE24QdlOepKC2tE184/TELh7pYGSDrznDfqO9bePzCFqT3Ra6E6JP2+
mRrG5z9xDHM55WB6OuuR3zv6+e8/7HRj3P0OzTk1k4s6K9DzP+rQarHmorE4
6nZMPDH29z+T+xj5JOT4NnramIl11fs/ImOs+QNA4jTAKwXeyAMAQImrnR5w
KRYyykOdtg8TAkBEOMb1brbPLsIb+7T1/gNADbwuwbuTRCt1gOulRxQGQEOY
76lHfOgmflL8rL5RBkDdtGVIMi9gJogkDbQ1jwZAQQbmlMe/0yWayC7CIwoH
QDsXT4IQIbcko5o/yZpHB0DliW30wDImJKxsUNARhQdAbO1UIneqkyO2PmHX
iMIHQOgDCQsGFQAjvxBy3v//B0Dq8LUbikdoIqNhCCg=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwBMQLO/SFib1JlAgAAACIAAAACAAAAvxBy3v//B8DEmcsUAbhECF46mq5x
wgfAKszJr3riIAn8Y8J+44QHwPJr8HxVXvkJOLcSH8cJB8AGitTco22mC7Bd
s1+OEwbA1h9tIeFl6g7mHWLusP0DwNa1WLHqBpcVLx5LVzQLAsA8cFoLO1pT
G/DE1AB/IgDAEXhvtA7XeiDtvZdvuyD8vzmBOjGQlIwlHnL6kTpD+L/pL4aA
ajrJKdoMOM/hEvS/cKOlCRgM2C0O6W0bL+zvv/a8MOH8X0kxsbhUAR5A6L97
Rhl086wDNNKq4jm63N+/IOjkul/0cTbU5O1CP1TQv1rwN3Pu8jY4oCnlD+Wf
kb8s3o26BH99OepKC2tE184/H4XYZGAbWTrznDfqO9beP2fzx61sqqk6JP2+
mRrG5z+2Zv5OUYJ4OuuR3zv6+e8/XhOapnCcvzk1k4s6K9DzP7KU9NJqoJU4
6nZMPDH29z8mm8TEADzONnramIl11fs/maDniYtUpTTAKwXeyAMAQAPOWTDz
lcUxykOdtg8TAkDk5dHqYA5oLsIb+7T1/gNAt0sMDnkJyCp1gOulRxQGQPgH
41lku1ImflL8rL5RBkBk4i2nqKfFJYgkDbQ1jwZAWA7pzgQVNyWayC7CIwoH
QJDz6piBjhQko5o/yZpHB0CX6g7V8SyBI6xsUNARhQdAK5MAb6J26iK2PmHX
iMIHQLmHtvkgzFIivxBy3v//B0DD0CUoQp+4IdN/CwM=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQB2IQvV+g6N7//+wHbhx5oP29+aiOxXYh+eOcCP6G2M3x
fcJscP4z2aR3G/4yw/n6ct7hJtxMcP6HI1cY6pUY4Py3e6fn71b4sx/Glyv6
NdHK+Qecf4vH4vxDoS9wPt/LXGn9N+/3e3w4eNmt0sdq444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/D89rr+2X+uz73uWYf/W6bydX7Ro
q5/1Cjh/3cozreUJW+D8bUv5Trov3gPnP/I7qV4y5Ric/8qLO9vl+jk432Th
Pf73Ctfh/M9zzF9ZX7sH56v83TdT6thzOP/1xPvWv36+h/NtnZofJpV/sIe5
t3W32NITHxH8syarMvRyPsL5outsdaY8Q/CXLkjZHH/7E5xvOrnbSvvCZzhf
gDXHWu/xVzj/VZmPjeG373B+1a0ZnaVXf8P5B7RZ751gZnCA8U85z93GL8wE
5x+S/r3l6z9mOL+04fVSdxE2OH/WCb1DylzscD40fcH5AI62TNs=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwB0QUu+iFib1JlAgAAAFwAAAACAAAAvxBy3v//B8DPT7/QfHmKDV46mq5x
wgfAlLWZeQt7Yw78Y8J+44QHwCMpPzX/dDoPOLcSH8cJB8Dbr/9bXS3jELBd
s1+OEwbAv7vPlBnCHhTmHWLusP0DwEIoKFCB2bgaLx5LVzQLAsCGhZzrH/pl
IPDE1AB/IgDAMsEUBo5zgSXtvZdvuyD8v2kTo698/4UqHnL6kTpD+L9f4qsp
bay5LtoMOM/hEvS/Q4yijOr3wDIO6W0bL+zvv0wz0pdyKys2sbhUAR5A6L8w
PtGIqorhONKq4jm63N+/5DtqR/l3TDsSEgTbquvdv/R7rmLvhYs7UnklfJv6
27/dje3764TIO9NHaL58GNi/r0okLhlzPjwUr4lfbSfWvxKex+I7OXU8VBar
AF421L+/m6ztIUOrPJR9zKFORdK/Gnu/CmMi4DzU5O1CP1TQv91OnVPpmBE9
GuVfSe7ZzL8YDyCJBv1APYsA5AxeC8m/BC5p30BSbj38G2jQzTzFv6woH4dy
A5k9bjfskz1uwb9u2GRRJhPDPb+l4K5aP7u/qmfBKpDk6j2i3Og1OqKzv9ge
i4I+hhE+CifieTMKqL/SrayrzBw1PqAp5Q/ln5G/KgLP4iqDVz78jEX6t9aO
P/blthOKM3s+TlsVhU47qD/sJXU/AbCcPq6pzIV3YLQ/oUZRh6iUuz62pQ7J
R6O8P2T5k/07LNg+3lAoBgxzwj9xu8bYN1DzPuJOySd0lMY/s5CVYT4iDD/m
TGpJ3LXKP4/NbNYVriI/6koLa0TXzj/Dh5rWCJ02P2TkG2z1WNE/Fal9S3m8
Rz9UI7KiSEbTP3059+pw/FY/RGJI2Zsz1T/Iju+lWYlkPzSh3g/vINc/BtBV
nHrtcD8k4HRGQg7ZPxX81s7lvnk/FB8LfZX72j+8gvKvIhCCPwReobPo6Nw/
G3AbNj9ihz/znDfqO9beP0kLX+eu7Ys/TzSwiX124D/hSuZWlOmOPySaRB7d
geE/6vyY3+gfjz/6/9iyPI3iP+M9dSX0gYw/z2VtR5yY4z+ZbaWMjcCHP6TL
Adz7o+Q/gSXsHZ0Agj96MZZwW6/lP0My7bf10ng/T5cqBbu65j/z5XJ6giNv
PyT9vpkaxuc/vbabeQjEYT+9DwOOlszoPz80+jjjrVI/ViJHghLT6T+I5Twi
V+1BP+80i3aO2eo/ZY79Tu5oLz+IR89qCuDrP/MjTQzzHRk/IVoTX4bm7D/+
6K9dXFUCP7psV1MC7e0/gVCcCxxu6D5Sf5tHfvPuPwAIM1Qnt80+65HfO/r5
7z8I5nhmB3+wPj1Cg+Fid/A/cOSTZT1kkj6FuxalyPHwP1j+w9u98HI+zTSq
aC5s8T8fVFZ7fQRSPhWuPSyU5vE/Br2kvgWqLz5dJ9Hv+WDyP064aqdlswk+
paBks1/b8j9q/1Sp4ETjPe0Z+HbFVfM/23y7h4Owuj01k4s6K9DzP8CnXILb
EpE9rK/D+utU9D9T0WIG8RlhPSLM+7qs2fQ/Evg+Y2s0Lz2Z6DN7bV71PwrE
w9ik7vk8EAVsOy7j9T9xLm6JOaHDPIYhpPvuZ/Y/I+aercYRizz9Pdy7r+z2
P2FSEH83AFE8dFoUfHBx9z8ULeDZinMTPOp2TDwx9vc/GZXnUoFF1DtcA/bF
GXL4P9H2LZqgS5c7zo+fTwLu+D9f0uF27q1YO7Ko8mLT5fk/lZDWHcKz1Tp6
2piJddX7P+66wHngS7k5wCsF3sgDAEAppCXSfsrpNspDnbYPEwJAiKGeuKIV
nzPCG/u09f4DQPDAC11XLxEwdYDrpUcUBkA0PjcGjzCxK35S/Ky+UQZAzBm4
4xhGJiuIJA20NY8GQFJ1xlYypJoqmsguwiMKB0Cfu3mMG/p9KaOaP8maRwdA
XMyGNVMz7CisbFDQEYUHQL80+EkJfVgotj5h14jCB0BaGIn7DKHDJ78Qct7/
/wdAld6GNBsMLSfSl9YP
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwB0QUu+iFib1JlAgAAAFwAAAACAAAAvxBy3v//B8C2e4QzqidlDV46mq5x
wgfAf9rr8GknQQ78Y8J+44QHwGuh0CDspBkPOLcSH8cJB8BYrYPxKXLGELBd
s1+OEwbAD3LocvrkCRTmHWLusP0DwCjsYSeHoLUaLx5LVzQLAsBzxvk/+XNx
IPDE1AB/IgDAvhm7s/NClyXtvZdvuyD8vwI8YgYzuacqHnL6kTpD+L/eB80p
PR3kLtoMOM/hEvS/fYIAC45a8jIO6W0bL+zvv5dINKH7jWI2sbhUAR5A6L8S
6ioUjqUbOdKq4jm63N+/E2BQa4EoiDsSEgTbquvdv+6Wz9fjbcc7UnklfJv6
27//eOQp4ekEPNNHaL58GNi//HfK6j/8eTwUr4lfbSfWv7fLfZ3dFbI8VBar
AF421L+kYrP4oyvnPJR9zKFORdK/U42/y4RSGz3U5O1CP1TQv8jlmYlSp009
GuVfSe7ZzL/RYEP5PnV8PYsA5AxeC8m/BSpoQtA3qT38G2jQzTzFv1tNbmR6
otQ9bjfskz1uwb8c4Mqzai7/Pb+l4K5aP7u/X1tHqAzBJT6i3Og1OqKzv90l
3dxCB0w+CifieTMKqL/uiygeMqxwPqAp5Q/ln5G/oMRonMpQkj78jEX6t9aO
P03lte3Y2bQ+TlsVhU47qD+xVIJgbJzVPq6pzIV3YLQ/fr4Ed3Vk9D62pQ7J
R6O8Pz8yUG3UhBE/3lAoBgxzwj80q/NeemcrP+JOySd0lMY/kYOFr4qDQz/m
TGpJ3LXKP56ZTKseTVk/6koLa0TXzj+n2FRm191tP2TkG2z1WNE/CodmC8CV
fj9UI7KiSEbTP2GWx2UD3Yw/RGJI2Zsz1T/Uley2ABqZPzSh3g/vINc/2qe7
VwwepD8k4HRGQg7ZP35WyZY/t60/FB8LfZX72j9DntGonTm0PwReobPo6Nw/
96+zd/teuT/znDfqO9beP1UASKtOVL0/TzSwiX124D+ca6OKg0u/PySaRB7d
geE/PgNe+/BVvj/6/9iyPI3iP7tRzpbPtro/z2VtR5yY4z+uihKsF1+1P6TL
Adz7o+Q/z3quxIMQrz96MZZwW6/lP46UTLqigqQ/T5cqBbu65j+d9x37xpqY
PyT9vpkaxuc/+zXdqXrQij+9DwOOlszoPxWt9uoT6no/ViJHghLT6T+mzEMb
naBoP+80i3aO2eo/N58rNBeLVD+IR89qCuDrPzuAs+KJPj8/IVoTX4bm7D9q
Y8nl9aglP7psV1MC7e0/OOlAOqVgCz9Sf5tHfvPuP+7S1zzWi+8+65HfO/r5
7z/sO1pZl5HQPj1Cg+Fid/A/QoSGUJ2FsT6FuxalyPHwPyqvHYHlGJE+zTSq
aC5s8T9eS9ieMMluPhWuPSyU5vE/TgmtMvGSST5dJ9Hv+WDyP1KhagMRmiM+
paBks1/b8j8TQ0o/qrn7Pe0Z+HbFVfM/PsdC8G8X0j01k4s6K9DzP1eFTd70
yKU9rK/D+utU9D9tAVIS12d0PSLM+7qs2fQ/Dm/VJyBjQT2Z6DN7bV71PwhQ
n4xJ9Ao9EAVsOy7j9T92+ifhbwHTPIYhpPvuZ/Y/EAWGFJJhmDz9Pdy7r+z2
P48axXe4c1w8dFoUfHBx9z88xyBBJTQePOp2TDwx9vc/TP9PB8sq3TtcA/bF
GXL4P1MyEX3qLZ87zo+fTwLu+D/rLEkiHrFeO7Ko8mLT5fk/F6knz6A41zp6
2piJddX7PzvlVox2w7M5wCsF3sgDAECiAUJ2BCXTNspDnbYPEwJAD1uZkWpw
dDPCG/u09f4DQDdo144Bn9MvdYDrpUcUBkAccS4KMEhdK35S/Ky+UQZABqj1
JVDX0CqIJA20NY8GQL+lWeuD3EEqmsguwiMKB0CEJypUW38fKaOaP8maRwdA
FnBrfn0viiisbFDQEYUHQBZwwY50EvQntj5h14jCB0A7nrN7aV9cJ78Qct7/
/wdA1vqiS1B9wib/GNGw
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQB2IQvV+g6N7//+wHbhx5oP29+aiOxXYh+eOcCP6G2M3x
fcJscP4z2aR3G/4yw/n6ct7hJtxMcP6HI1cY6pUY4Py3e6fn71b4sx/Glyv6
NdHK+Qecf4vH4vxDoS9wPt/LXGn9N+/3e3w4eNmt0sdq444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/D89rr+2X+uz73uWYf/W6bydX7Ro
q5/1Cjh/3cozreUJW+D8bUv5Trov3gPnP/I7qV4y5Ric/8qLO9vl+jk432Th
Pf73Ctfh/M9zzF9ZX7sH56v83TdT6thzOP/1xPvWv36+h/NtnZofJpV/sIe5
t3W32NITHxH8syarMvRyPsL5outsdaY8Q/CXLkjZHH/7E5xvOrnbSvvCZzhf
gDXHWu/xVzj/VZmPjeG373B+1a0ZnaVXf8P5B7RZ751gZnCA8U85z93GL8wE
5x+S/r3l6z9mOL+04fVSdxE2OH/WCb1DylzscD40fcH5AI62TNs=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwBYQWe+iFib1JlAgAAAFUAAAACAAAAvxBy3v//B8Ae3xNddRf8DF46mq5x
wgfAQNNC1qpC1A38Y8J+44QHwKh0cOhZ+KoOOLcSH8cJB8BKyv9Q9sdSELBd
s1+OEwbA75zYInLNixPmHWLusP0DwPBS6N7U4CIaLx5LVzQLAsAuyk1Fx2PM
H/DE1AB/IgDAWMw3tkQ64yTtvZdvuyD8v5q2uBkjZeQpHnL6kTpD+L9SPQVi
AEMULtoMOM/hEvS/7/EJm0x+FjIO6W0bL+zvv2lxO0sPWH41sbhUAR5A6L94
l6nfZbIwONKq4jm63N+/LxC6Yf3IljrU5O1CP1TQvyd0CaW09Vc8GuVfSe7Z
zL+mkV6iMa2GPIsA5AxeC8m/tICWe+nWszz8G2jQzTzFvyrPa4uRC+A8bjfs
kz1uwb80sr0Htf0HPb+l4K5aP7u/zyPzi3iUMD2i3Og1OqKzvwtjG2QbL1U9
CifieTMKqL/qqLcqNAV5PaAp5Q/ln5G/KrzXNjtRmz38jEX6t9aOP+cVqjA4
7r49TlsVhU47qD9uT9ETGO3fPa6pzIV3YLQ/sGmO5YAK/j22pQ7JR6O8P8oD
4xzJxBk+3lAoBgxzwj8uBeBecyY0PuJOySd0lMY/CunL2l66TD7mTGpJ3LXK
P7NK4oAnq2I+6koLa0TXzj8SdEfwVh52PmTkG2z1WNE/XOGl6FvBhj5UI7Ki
SEbTP2QYiM8jmZU+RGJI2Zsz1T99QNjZuumiPjSh3g/vINc/Dwx+RiaPrj4k
4HRGQg7ZP2eCM1H4xrY+FB8LfZX72j/ya1tvVFO/PgReobPo6Nw/OSwvEZvf
wz7znDfqO9beP5oKEH2eQ8c+TzSwiX124D+/HqbhCTLJPiSaRB7dgeE/P2BR
+4XSyD76/9iyPI3iPwAOH9jvPsY+z2VtR5yY4z80docwzSLCPqTLAdz7o+Q/
sHboak/muj56MZZwW6/lP4Wv0WurJbI+T5cqBbu65j8MMkqk+UWmPiT9vpka
xuc/FuGlok7emD69DwOOlszoP963u2QsmIk+ViJHghLT6T/oCizdbQt4Pu80
i3aO2eo/taLXUnOeZD6IR89qCuDrP5ucQ4G1I1A+IVoTX4bm7D+yDpsYKRA3
PrpsV1MC7e0/FOLNY0IVHj5Sf5tHfvPuP0keTxGy6AE+65HfO/r57z+yBkM/
snbjPT1Cg+Fid/A/gVvsNptFxT2FuxalyPHwP/FajAR8eaU9zTSqaC5s8T+y
wRw1dgaEPRWuPSyU5vE/gZuzi8c/YT1dJ9Hv+WDyP1YA2RPjcjs9paBks1/b
8j+6NAqHdCwUPe0Z+HbFVfM/fBd7sSlk6zw1k4s6K9DzP4R1qA5LLcE8rK/D
+utU9D93tEnaQ9aQPCLM+7qs2fQ/DahvdswQXjyZ6DN7bV71PwaKjqSPcyg8
EAVsOy7j9T+Fh8ft+hzyO4YhpPvuZ/Y/jsWAMbFxuDv9Pdy7r+z2P+uJawc0
DH476nZMPDH29z+c2i47CygBO1wD9sUZcvg/G42Eom1SwzrOj59PAu74P3kC
Tg6qD4Q6sqjyYtPl+T8YyC3FkPEAOnramIl11fs/Fp+OAQ044jjAKwXeyAMA
QCxtyC7qMA82ykOdtg8TAkDdVpiIzqm/MsIb+7T1/gNAoVnH5kfULS91gOul
RxQGQIdqtOvsFMkqflL8rL5RBkDSbayyMNs/KogkDbQ1jwZAbDd0q4essima
yC7CIwoHQMrEYMILMJQoo5o/yZpHB0C4lSCEdZ0CKKxsUNARhQdAIVwJvmKw
bye2PmHXiMIHQALwauPK5dgmvxBy3v//B0DWbFjWjw5CJvyBk/4=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwBYQWe+iFib1JlAgAAAFUAAAACAAAAvxBy3v//B8Cj2/WIAYTADF46mq5x
wgfAKkVUm3immg38Y8J+44QHwGBShe4d0nMOOLcSH8cJB8AkVWyj/iwhELBd
s1+OEwbAZktsd9trYxPmHWLusP0DwLfBtUrCDw8aLx5LVzQLAsDnmXyy2BHI
H/DE1AB/IgDA3nkCtjbU7iTtvZdvuyD8vxpdy9bsHP4pHnL6kTpD+L+S06Y0
EYY4LtoMOM/hEvS/qlAXieVrRTIO6W0bL+zvv4ML3S5Zv7Q1sbhUAR5A6L/0
a/mv3rNtONKq4jm63N+/sZxyLIra2DrU5O1CP1TQv33tIqIdTJ08GuVfSe7Z
zL92z+2bHPrLPIsA5AxeC8m/X7qckU2r+Dz8G2jQzTzFv3mmBW3xFSQ9bjfs
kz1uwb+wYdrRnTNOPb+l4K5aP7u/DS7hXWT3dD2i3Og1OqKzvwMs/s474Zo9
CifieTMKqL8w9ONNF9K/PaAp5Q/ln5G/mA+/80Zk4T38jEX6t9aOP6r33whl
sQM+TlsVhU47qD8sBSwuIE0kPq6pzIV3YLQ/gxXRpcANQz62pQ7JR6O8P3R5
KdntR2A+3lAoBgxzwj/ODWZVxlR5PuJOySd0lMY/6x5v7NzwkT7mTGpJ3LXK
P/zCXD0PI6c+6koLa0TXzj/0CwbwSSq7PmTkG2z1WNE/krDROOatyz5UI7Ki
SEbTP5Pz/7mL/dk+RGJI2Zsz1T9HmdVDaX3mPjSh3g/vINc/v5Ff/Rrv8T4k
4HRGQg7ZPz1zJwCpW/o+FB8LfZX72j+lsW0wkdkBPwReobPo6Nw/AUrnsYRH
Bj/znDfqO9bePxn4istXoAk/TzSwiX124D+xKAKzBjILPySaRB7dgeE/My24
I/83Cj/6/9iyPI3iP4E4KZ2c9gY/z2VtR5yY4z8PaZcyZ0UCP6TLAdz7o+Q/
buA+iPJp+j56MZZwW6/lP0MDWMtVWPE+T5cqBbu65j8W3plL0LHkPiT9vpka
xuc/94AAZkhu1j69DwOOlszoP0OoG3P8ZMY+ViJHghLT6T/zMLAp5GG0Pu80
i3aO2eo/lZK3hWTpoD6IR89qCuDrP7Ep5ZZ6lYk+IVoTX4bm7D94pORQNqRx
PrpsV1MC7e0/omb9G+0tVj5Sf5tHfvPuP9VXubuhazk+65HfO/r57z8TXMMh
dI8aPj1Cg+Fid/A/zQA8QOXy+z2FuxalyPHwPzmqZpXIIts9zTSqaC5s8T/q
14VSOU+4PRWuPSyU5vE/6IsC4PcXlD1dJ9Hv+WDyP5rOetNApm49paBks1/b
8j87FHgDYZFFPe0Z+HbFVfM/4OOZHuoBHD01k4s6K9DzPyM4yEthx/A8rK/D
+utU9D8jCytnc0O/PCLM+7qs2fQ//5t4CNJ+ijyZ6DN7bV71P9DbsTclbVQ8
EAVsOy7j9T8D37sid6YcPIYhpPvuZ/Y/OG/rBR1H4jv9Pdy7r+z2Pwr53ubz
NqU76nZMPDH29z8O4AGTm4MlO1wD9sUZcvg/PNnMhvLh5jrOj59PAu74PyAK
ZHNYaaY6sqjyYtPl+T+sBKe5QckgOnramIl11fs/GRWIO6wA/DjAKwXeyAMA
QHeXvJAW9xk2ykOdtg8TAkACoOTdW466MsIb+7T1/gNA7Mu4NhR+GC91gOul
RxQGQO5svIXXf6EqflL8rL5RBkAEYNQsTAcUKogkDbQ1jwZA16eNz8oihSma
yC7CIwoHQAp3eGVLc2Ioo5o/yZpHB0DuYiHyPYbOJ6xsUNARhQdAfnIiPPxH
Nye2PmHXiMIHQBuloPFPX6AmvxBy3v//B0DPXV/gZTsFJjYKnnE=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHjN+9EMq/eVDZYruQ/HFOBH9D7Ob4
PmE2OP+ZbNK7DX+Z4Xx9Oe9wE24mOP/DkSsM9UoMcP7bvdPzdyv82Q/jyxX9
mmjl/APOv8Vjcf6h0Bc4n+9lrrT+m/f71yj+O2k+391w444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/Fde3Nku18/Zfzu8/Z3z+5Omn+eY
v7K+dg/OV/m7b6bUsedw/uuJ961//XwP55tO7rbSvvDZHm5emY+N4bfvcH7V
rRmdpVd/w/kHtFnvnWBmcIDxTznP3cYvzATnH5L+veXrP2Y4v7Th9VJ3ETY4
f9YJvUPKXOxwPjR+4HwAAuTkvQ==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwBMQLO/SFib1JlAgAAACIAAAACAAAAvxBy3v//B8B3HNeN3Pm+Bl46mq5x
wgfAtTqHkcDllQf8Y8J+44QHwDQ82WUskmwIOLcSH8cJB8BHPVJUPx0TCrBd
s1+OEwbA2moc0bYdSg3mHWLusP0DwB6ujZvdzt0TLx5LVzQLAsDsV/f1QA6D
GfDE1AB/IgDAGiyAF98Dlh7tvZdvuyD8v1TO/iF1ppMjHnL6kTpD+L+So+/Z
GJ7AJ9oMOM/hEvS/+jFpenP8visO6W0bL+zvv5929iXcmyEvsbhUAR5A6L9E
zaxPC4TQMdKq4jm63N+/FV4B73/zMjTU5O1CP1TQv9NMZi5n8/A1oCnlD+Wf
kb+Q7jgbuX0wN+pKC2tE184//1R2Nop7BjjznDfqO9beP/sRTbl1I1Q4JP2+
mRrG5z+3PK3IbxYiOOuR3zv6+e8/Z81UKX7dZzc1k4s6K9DzP+zYVYRR9UE2
6nZMPDH29z9F71Dfsi1+NHramIl11fs/8UZzgKdFWzLAKwXeyAMAQPPwd8Ct
mYMvykOdtg8TAkAYu413NsIwLMIb+7T1/gNAhAgWvELnmih1gOulRxQGQPMR
ZdMUBDMkflL8rL5RBkB8PIrwb6ynI4gkDbQ1jwZA54mgDG40GyOayC7CIwoH
QP90ILqcQfwho5o/yZpHB0BBx5yj+YlpIaxsUNARhQdAUBVrEaZO1SC2PmHX
iMIHQPyFx2S9aEAgvxBy3v//B0DJzdM2a1SnHx2sCJI=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwBMQLO/SFib1JlAgAAACIAAAACAAAAvxBy3v//B8Dic6aymrdTBl46mq5x
wgfAQAuTF0qoLwf8Y8J+44QHwASjtPhRbQcIOLcSH8cJB8AyiuyiKxm0CbBd
s1+OEwbA7KJ8yGJG9gzmHWLusP0DwLUrroccDqETLx5LVzQLAsC4+EXigmFZ
GfDE1AB/IgDA5Qzt/YQ9fx7tvZdvuyD8v0P+7HfMOY0jHnL6kTpD+L/1qjOQ
i9zGJ9oMOM/hEvS/uuAoCtgd0ysO6W0bL+zvv5E4HiQFvUEvsbhUAR5A6L+h
z6CxSWb4MdKq4jm63N+/4HNEJdyMYzTU5O1CP1TQv0pMge21ISY2oCnlD+Wf
kb86i94oA0FpN+pKC2tE184/zVc92lTkQjjznDfqO9beP/Ku1qHAHpE4JP2+
mRrG5z9BjARimrFcOOuR3zv6+e8/NRkB/QNHoDc1k4s6K9DzP9QWulAVw3M2
6nZMPDH29z/c169nYESoNHramIl11fs/BgVkEjVWfjLAKwXeyAMAQKh8zkAR
7ZovykOdtg8TAkBuYvc/s2E6LMIb+7T1/gNAFzeS7F1glyh1gOulRxQGQE4g
+FsO/B8kflL8rL5RBkDUDGR+VTaSI4gkDbQ1jwZADNNdjI8fAyOayC7CIwoH
QADxyKD4huAho5o/yZpHB0DHGia1zDRLIaxsUNARhQdAs+MBt5eltCC2PmHX
iMIHQJZg/17+5BwgvxBy3v//B0D/ndJ2XKSCH77oBUY=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHzvgeaD4ScE/aYruQ/HFOBH9D7Ob4
PmE2OP+ZbNK7DX+Z4Xx9Oe9wE24mOP/DkSsM9UoMcP7bvdPzdyv82Q/jyxX9
mmjl/APOv8Vjcf6h0Bc4n+9lrrT+m/f7ldLl5IL5UzQ37ghhlHN4AedfWvXI
cted+3D+lSdvnexDLsD5CzSf8j+dPxHOf+XFne1y/Zz9Tx9WIQm2Z7qf55i/
sr52D85X+btvptSx53D+64n3rX/9fA/nm07uttK+8Nkebl6Zj43ht+9wftWt
GZ2lV3/D+Qe0We+dYGZwgPFPOc/dxi/MBOcfkv695es/Zji/tOH1UncRNjh/
1gm9Q8pc7HA+NH7gfADOsrtn
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2Q6IFZgbx9dFMj6TTXq34S/zgU9TNTlnl7xg15fzDjfh
ZjrwMURyR+nULt4PR64w1CsxHHh37rj4c8NZQm/3Ts/frfBn/x/XLzP3r5ks
Llf0a6KV84/9Uw+7cLUE75G+xWNx/qHQl/3C/ZP1P+puk+d7mSut/+b9/ocb
Hl34ayOqvHFHCKOcw4v9pwwzjqj+OqB6adUjy1137u+f7sZwJjJRQePKk7dO
9iEX9v/O1rq0/s0NzQWaT/mfzp+4X71QyZpto4j2Ky/ubJfr5+yXNrmEzt//
XPvzHPNX1tfu2Vv8y599SNZIR+XvvplSx57b58ZLqlwM/639euJ9618/39sv
W3cs/XiGnbbp5G4r7Quf7U/fNei+1ySs9arMx8bw23f7jR2X3c2memtU3ZrR
WXr1t/2e9KJtPmaqage0We+dYGZwuGv58nfSTE/lU85zt/ELMzls0r4XWJL/
Sf6Q9O8tX/8xO7i8naVhZR4pU9rweqm7CJuDkbTuhfff3orXBf1Zsy+QzaFa
wMLCzyNJvEOFd4tpP5vDG84bOg+nXxGbdULvkDIXu0NsuLLk1Z4tootn2Z+c
5c7usNmmmXWbiZLompyAC4Kt7A7pHzZ2XTjWK7LNLvF6xyF2Bz2RC1wGVd+E
oenBQXBbiOe3oHhhAIcx9s8=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2Q5My1+utqnjMMMz2aR3G/4yH/jwRSn5/+Icdn0573AT
bqYDrb/vdS4tU+H9cOQKQ70Sw4GojGslLSYeQm/3Ts/frfBnv860QjP+DaHi
ckW/Jlo5/9h/V+/kqYneE6Rv8Vicfyj0Zf/9k53Xy8VmyfO9zJXWf/N+/9kN
7mrMhuzKG3eEMMo5vNj/4sySnJpl+1QvrXpkuevO/f3TXf/vCmhR17jy5K2T
fciF/e1/bi/9MuGl5gLNp/xP50/cf2pVeuBFTh3tV17c2S7Xz9kzHrunHy7O
ovN5jvkr62v37P17i49W1gbqqPzdN1Pq2HN7nb5KhpUCMjqvJ963/vXzvb0y
wynBxKY4bdPJ3VbaFz7bL+fJbvtw2lDrVZmPjeG37/Ye4m2fLr1N0ai6NaOz
9Opve9Wzt++wKlqqHdBmvXeCmcEh5rDX3rrIUOVTznO38QszOdgGLv3yk/OL
/CHp31u+/mN2uNQrXavJHyhT2vB6qbsIm8OCSyee5UVeE68L+rNmXyCbw8pf
jD/lgj3FO1R4t5j2szn8PBWrWVy6S2zWCb1DylzsDnkf1lYvWjxNdPEs+5Oz
3Nkd7JYzP8ruYhJdkxNwQbCV3UFNkXWOFkOOyDa7xOsdh9gd1nwQXHSw7rIw
ND043EyOj13PbikMAAJs9bw=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHlNLl5IL5UzQttgvJH+dE8DfEbo7v
E2aD85/JJr3b8JcZzteX8w434WaC8z8cucJQr8QA57/dOz1/t8Kf/TC+XNGv
iVbOP+D8WzwW5x8KfYHz+V7mSuu/eb8/Zv0jEfmeV2Ybd4Qwyjm8gPMvrXpk
uevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs7ejqMupFY11/rzHPNX
1tfuwfkqf/fNlDr2HM5/PfG+9a+f7+F808ndVtoXPtvDzSvzsTH89h3Or7o1
o7P06m84/4A2670TzAwOMP4p57nb+IWZ4PxD0r+3fP3HDOeXNrxe6i7CBufP
OqF3SJmLHc6Hxg+cDwBoEb+u
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwBMQLO/SFib1JlAgAAACIAAAACAAAAvxBy3v//B8DoiD/lv+1pCF46mq5x
wgfAFvd+dBZ3Qwn8Y8J+44QHwN6ssJqc+BoKOLcSH8cJB8BXmak5bVnEC7Bd
s1+OEwbArWg4Z1muAQ/mHWLusP0DwAmcGn3+/qAVLx5LVzQLAsC7pluiB65R
G/DE1AB/IgDAEqJ0Jc91cCDtvZdvuyD8v4aSjdo1qHglHnL6kTpD+L9J2TVm
L+ewKdoMOM/hEvS/t6DgaNCaui0O6W0bL+zvv4Bkdgr+RykxsbhUAR5A6L9v
lfnd1CbjM9Kq4jm63N+/Qoo+D297UjbU5O1CP1TQvw1U47my3Bo4oCnlD+Wf
kb/+QYE24QdlOepKC2tE184/TELh7pYGSDrznDfqO9bePzCFqT3Ra6E6JP2+
mRrG5z9xDHM55WB6OuuR3zv6+e8/7HRj3P0OzTk1k4s6K9DzP+rQarHmorE4
6nZMPDH29z+T+xj5JOT4NnramIl11fs/ImOs+QNA4jTAKwXeyAMAQImrnR5w
KRYyykOdtg8TAkBEOMb1brbPLsIb+7T1/gNADbwuwbuTRCt1gOulRxQGQEOY
76lHfOgmflL8rL5RBkDdtGVIMi9gJogkDbQ1jwZAQQbmlMe/0yWayC7CIwoH
QDsXT4IQIbcko5o/yZpHB0DliW30wDImJKxsUNARhQdAbO1UIneqkyO2PmHX
iMIHQOgDCQsGFQAjvxBy3v//B0Dq8LUbikdoIqNhCCg=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwBMQLO/SFib1JlAgAAACIAAAACAAAAvxBy3v//B8DEmcsUAbhECF46mq5x
wgfAKszJr3riIAn8Y8J+44QHwPJr8HxVXvkJOLcSH8cJB8AGitTco22mC7Bd
s1+OEwbA1h9tIeFl6g7mHWLusP0DwNa1WLHqBpcVLx5LVzQLAsA8cFoLO1pT
G/DE1AB/IgDAEXhvtA7XeiDtvZdvuyD8vzmBOjGQlIwlHnL6kTpD+L/pL4aA
ajrJKdoMOM/hEvS/cKOlCRgM2C0O6W0bL+zvv/a8MOH8X0kxsbhUAR5A6L97
Rhl086wDNNKq4jm63N+/IOjkul/0cTbU5O1CP1TQv1rwN3Pu8jY4oCnlD+Wf
kb8s3o26BH99OepKC2tE184/H4XYZGAbWTrznDfqO9beP2fzx61sqqk6JP2+
mRrG5z+2Zv5OUYJ4OuuR3zv6+e8/XhOapnCcvzk1k4s6K9DzP7KU9NJqoJU4
6nZMPDH29z8mm8TEADzONnramIl11fs/maDniYtUpTTAKwXeyAMAQAPOWTDz
lcUxykOdtg8TAkDk5dHqYA5oLsIb+7T1/gNAt0sMDnkJyCp1gOulRxQGQPgH
41lku1ImflL8rL5RBkBk4i2nqKfFJYgkDbQ1jwZAWA7pzgQVNyWayC7CIwoH
QJDz6piBjhQko5o/yZpHB0CX6g7V8SyBI6xsUNARhQdAK5MAb6J26iK2PmHX
iMIHQLmHtvkgzFIivxBy3v//B0DD0CUoQp+4IdN/CwM=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQB2IQvV+g6N7//+wHbhx5oP29+aiOxXYh+eOcCP6G2M3x
fcJscP4z2aR3G/4yw/n6ct7hJtxMcP6HI1cY6pUY4Py3e6fn71b4sx/Glyv6
NdHK+Qecf4vH4vxDoS9wPt/LXGn9N+/3e3w4eNmt0sdq444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/D89rr+2X+uz73uWYf/W6bydX7Ro
q5/1Cjh/3cozreUJW+D8bUv5Trov3gPnP/I7qV4y5Ric/8qLO9vl+jk432Th
Pf73Ctfh/M9zzF9ZX7sH56v83TdT6thzOP/1xPvWv36+h/NtnZofJpV/sIe5
t3W32NITHxH8syarMvRyPsL5outsdaY8Q/CXLkjZHH/7E5xvOrnbSvvCZzhf
gDXHWu/xVzj/VZmPjeG373B+1a0ZnaVXf8P5B7RZ751gZnCA8U85z93GL8wE
5x+S/r3l6z9mOL+04fVSdxE2OH/WCb1DylzscD40fcH5AI62TNs=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwB0QUu+iFib1JlAgAAAFwAAAACAAAAvxBy3v//B8DPT7/QfHmKDV46mq5x
wgfAlLWZeQt7Yw78Y8J+44QHwCMpPzX/dDoPOLcSH8cJB8Dbr/9bXS3jELBd
s1+OEwbAv7vPlBnCHhTmHWLusP0DwEIoKFCB2bgaLx5LVzQLAsCGhZzrH/pl
IPDE1AB/IgDAMsEUBo5zgSXtvZdvuyD8v2kTo698/4UqHnL6kTpD+L9f4qsp
bay5LtoMOM/hEvS/Q4yijOr3wDIO6W0bL+zvv0wz0pdyKys2sbhUAR5A6L8w
PtGIqorhONKq4jm63N+/5DtqR/l3TDsSEgTbquvdv/R7rmLvhYs7UnklfJv6
27/dje3764TIO9NHaL58GNi/r0okLhlzPjwUr4lfbSfWvxKex+I7OXU8VBar
AF421L+/m6ztIUOrPJR9zKFORdK/Gnu/CmMi4DzU5O1CP1TQv91OnVPpmBE9
GuVfSe7ZzL8YDyCJBv1APYsA5AxeC8m/BC5p30BSbj38G2jQzTzFv6woH4dy
A5k9bjfskz1uwb9u2GRRJhPDPb+l4K5aP7u/qmfBKpDk6j2i3Og1OqKzv9ge
i4I+hhE+CifieTMKqL/SrayrzBw1PqAp5Q/ln5G/KgLP4iqDVz78jEX6t9aO
P/blthOKM3s+TlsVhU47qD/sJXU/AbCcPq6pzIV3YLQ/oUZRh6iUuz62pQ7J
R6O8P2T5k/07LNg+3lAoBgxzwj9xu8bYN1DzPuJOySd0lMY/s5CVYT4iDD/m
TGpJ3LXKP4/NbNYVriI/6koLa0TXzj/Dh5rWCJ02P2TkG2z1WNE/Fal9S3m8
Rz9UI7KiSEbTP3059+pw/FY/RGJI2Zsz1T/Iju+lWYlkPzSh3g/vINc/BtBV
nHrtcD8k4HRGQg7ZPxX81s7lvnk/FB8LfZX72j+8gvKvIhCCPwReobPo6Nw/
G3AbNj9ihz/znDfqO9beP0kLX+eu7Ys/TzSwiX124D/hSuZWlOmOPySaRB7d
geE/6vyY3+gfjz/6/9iyPI3iP+M9dSX0gYw/z2VtR5yY4z+ZbaWMjcCHP6TL
Adz7o+Q/gSXsHZ0Agj96MZZwW6/lP0My7bf10ng/T5cqBbu65j/z5XJ6giNv
PyT9vpkaxuc/vbabeQjEYT+9DwOOlszoPz80+jjjrVI/ViJHghLT6T+I5Twi
V+1BP+80i3aO2eo/ZY79Tu5oLz+IR89qCuDrP/MjTQzzHRk/IVoTX4bm7D/+
6K9dXFUCP7psV1MC7e0/gVCcCxxu6D5Sf5tHfvPuPwAIM1Qnt80+65HfO/r5
7z8I5nhmB3+wPj1Cg+Fid/A/cOSTZT1kkj6FuxalyPHwP1j+w9u98HI+zTSq
aC5s8T8fVFZ7fQRSPhWuPSyU5vE/Br2kvgWqLz5dJ9Hv+WDyP064aqdlswk+
paBks1/b8j9q/1Sp4ETjPe0Z+HbFVfM/23y7h4Owuj01k4s6K9DzP8CnXILb
EpE9rK/D+utU9D9T0WIG8RlhPSLM+7qs2fQ/Evg+Y2s0Lz2Z6DN7bV71PwrE
w9ik7vk8EAVsOy7j9T9xLm6JOaHDPIYhpPvuZ/Y/I+aercYRizz9Pdy7r+z2
P2FSEH83AFE8dFoUfHBx9z8ULeDZinMTPOp2TDwx9vc/GZXnUoFF1DtcA/bF
GXL4P9H2LZqgS5c7zo+fTwLu+D9f0uF27q1YO7Ko8mLT5fk/lZDWHcKz1Tp6
2piJddX7P+66wHngS7k5wCsF3sgDAEAppCXSfsrpNspDnbYPEwJAiKGeuKIV
nzPCG/u09f4DQPDAC11XLxEwdYDrpUcUBkA0PjcGjzCxK35S/Ky+UQZAzBm4
4xhGJiuIJA20NY8GQFJ1xlYypJoqmsguwiMKB0Cfu3mMG/p9KaOaP8maRwdA
XMyGNVMz7CisbFDQEYUHQL80+EkJfVgotj5h14jCB0BaGIn7DKHDJ78Qct7/
/wdAld6GNBsMLSfSl9YP
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwB0QUu+iFib1JlAgAAAFwAAAACAAAAvxBy3v//B8C2e4QzqidlDV46mq5x
wgfAf9rr8GknQQ78Y8J+44QHwGuh0CDspBkPOLcSH8cJB8BYrYPxKXLGELBd
s1+OEwbAD3LocvrkCRTmHWLusP0DwCjsYSeHoLUaLx5LVzQLAsBzxvk/+XNx
IPDE1AB/IgDAvhm7s/NClyXtvZdvuyD8vwI8YgYzuacqHnL6kTpD+L/eB80p
PR3kLtoMOM/hEvS/fYIAC45a8jIO6W0bL+zvv5dINKH7jWI2sbhUAR5A6L8S
6ioUjqUbOdKq4jm63N+/E2BQa4EoiDsSEgTbquvdv+6Wz9fjbcc7UnklfJv6
27//eOQp4ekEPNNHaL58GNi//HfK6j/8eTwUr4lfbSfWv7fLfZ3dFbI8VBar
AF421L+kYrP4oyvnPJR9zKFORdK/U42/y4RSGz3U5O1CP1TQv8jlmYlSp009
GuVfSe7ZzL/RYEP5PnV8PYsA5AxeC8m/BSpoQtA3qT38G2jQzTzFv1tNbmR6
otQ9bjfskz1uwb8c4Mqzai7/Pb+l4K5aP7u/X1tHqAzBJT6i3Og1OqKzv90l
3dxCB0w+CifieTMKqL/uiygeMqxwPqAp5Q/ln5G/oMRonMpQkj78jEX6t9aO
P03lte3Y2bQ+TlsVhU47qD+xVIJgbJzVPq6pzIV3YLQ/fr4Ed3Vk9D62pQ7J
R6O8Pz8yUG3UhBE/3lAoBgxzwj80q/NeemcrP+JOySd0lMY/kYOFr4qDQz/m
TGpJ3LXKP56ZTKseTVk/6koLa0TXzj+n2FRm191tP2TkG2z1WNE/CodmC8CV
fj9UI7KiSEbTP2GWx2UD3Yw/RGJI2Zsz1T/Uley2ABqZPzSh3g/vINc/2qe7
VwwepD8k4HRGQg7ZP35WyZY/t60/FB8LfZX72j9DntGonTm0PwReobPo6Nw/
96+zd/teuT/znDfqO9beP1UASKtOVL0/TzSwiX124D+ca6OKg0u/PySaRB7d
geE/PgNe+/BVvj/6/9iyPI3iP7tRzpbPtro/z2VtR5yY4z+uihKsF1+1P6TL
Adz7o+Q/z3quxIMQrz96MZZwW6/lP46UTLqigqQ/T5cqBbu65j+d9x37xpqY
PyT9vpkaxuc/+zXdqXrQij+9DwOOlszoPxWt9uoT6no/ViJHghLT6T+mzEMb
naBoP+80i3aO2eo/N58rNBeLVD+IR89qCuDrPzuAs+KJPj8/IVoTX4bm7D9q
Y8nl9aglP7psV1MC7e0/OOlAOqVgCz9Sf5tHfvPuP+7S1zzWi+8+65HfO/r5
7z/sO1pZl5HQPj1Cg+Fid/A/QoSGUJ2FsT6FuxalyPHwPyqvHYHlGJE+zTSq
aC5s8T9eS9ieMMluPhWuPSyU5vE/TgmtMvGSST5dJ9Hv+WDyP1KhagMRmiM+
paBks1/b8j8TQ0o/qrn7Pe0Z+HbFVfM/PsdC8G8X0j01k4s6K9DzP1eFTd70
yKU9rK/D+utU9D9tAVIS12d0PSLM+7qs2fQ/Dm/VJyBjQT2Z6DN7bV71PwhQ
n4xJ9Ao9EAVsOy7j9T92+ifhbwHTPIYhpPvuZ/Y/EAWGFJJhmDz9Pdy7r+z2
P48axXe4c1w8dFoUfHBx9z88xyBBJTQePOp2TDwx9vc/TP9PB8sq3TtcA/bF
GXL4P1MyEX3qLZ87zo+fTwLu+D/rLEkiHrFeO7Ko8mLT5fk/F6knz6A41zp6
2piJddX7PzvlVox2w7M5wCsF3sgDAECiAUJ2BCXTNspDnbYPEwJAD1uZkWpw
dDPCG/u09f4DQDdo144Bn9MvdYDrpUcUBkAccS4KMEhdK35S/Ky+UQZABqj1
JVDX0CqIJA20NY8GQL+lWeuD3EEqmsguwiMKB0CEJypUW38fKaOaP8maRwdA
FnBrfn0viiisbFDQEYUHQBZwwY50EvQntj5h14jCB0A7nrN7aV9cJ78Qct7/
/wdA1vqiS1B9wib/GNGw
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQB2IQvV+g6N7//+wHbhx5oP29+aiOxXYh+eOcCP6G2M3x
fcJscP4z2aR3G/4yw/n6ct7hJtxMcP6HI1cY6pUY4Py3e6fn71b4sx/Glyv6
NdHK+Qecf4vH4vxDoS9wPt/LXGn9N+/3e3w4eNmt0sdq444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/D89rr+2X+uz73uWYf/W6bydX7Ro
q5/1Cjh/3cozreUJW+D8bUv5Trov3gPnP/I7qV4y5Ric/8qLO9vl+jk432Th
Pf73Ctfh/M9zzF9ZX7sH56v83TdT6thzOP/1xPvWv36+h/NtnZofJpV/sIe5
t3W32NITHxH8syarMvRyPsL5outsdaY8Q/CXLkjZHH/7E5xvOrnbSvvCZzhf
gDXHWu/xVzj/VZmPjeG373B+1a0ZnaVXf8P5B7RZ751gZnCA8U85z93GL8wE
5x+S/r3l6z9mOL+04fVSdxE2OH/WCb1DylzscD40fcH5AI62TNs=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwBYQWe+iFib1JlAgAAAFUAAAACAAAAvxBy3v//B8Ae3xNddRf8DF46mq5x
wgfAQNNC1qpC1A38Y8J+44QHwKh0cOhZ+KoOOLcSH8cJB8BKyv9Q9sdSELBd
s1+OEwbA75zYInLNixPmHWLusP0DwPBS6N7U4CIaLx5LVzQLAsAuyk1Fx2PM
H/DE1AB/IgDAWMw3tkQ64yTtvZdvuyD8v5q2uBkjZeQpHnL6kTpD+L9SPQVi
AEMULtoMOM/hEvS/7/EJm0x+FjIO6W0bL+zvv2lxO0sPWH41sbhUAR5A6L94
l6nfZbIwONKq4jm63N+/LxC6Yf3IljrU5O1CP1TQvyd0CaW09Vc8GuVfSe7Z
zL+mkV6iMa2GPIsA5AxeC8m/tICWe+nWszz8G2jQzTzFvyrPa4uRC+A8bjfs
kz1uwb80sr0Htf0HPb+l4K5aP7u/zyPzi3iUMD2i3Og1OqKzvwtjG2QbL1U9
CifieTMKqL/qqLcqNAV5PaAp5Q/ln5G/KrzXNjtRmz38jEX6t9aOP+cVqjA4
7r49TlsVhU47qD9uT9ETGO3fPa6pzIV3YLQ/sGmO5YAK/j22pQ7JR6O8P8oD
4xzJxBk+3lAoBgxzwj8uBeBecyY0PuJOySd0lMY/CunL2l66TD7mTGpJ3LXK
P7NK4oAnq2I+6koLa0TXzj8SdEfwVh52PmTkG2z1WNE/XOGl6FvBhj5UI7Ki
SEbTP2QYiM8jmZU+RGJI2Zsz1T99QNjZuumiPjSh3g/vINc/Dwx+RiaPrj4k
4HRGQg7ZP2eCM1H4xrY+FB8LfZX72j/ya1tvVFO/PgReobPo6Nw/OSwvEZvf
wz7znDfqO9beP5oKEH2eQ8c+TzSwiX124D+/HqbhCTLJPiSaRB7dgeE/P2BR
+4XSyD76/9iyPI3iPwAOH9jvPsY+z2VtR5yY4z80docwzSLCPqTLAdz7o+Q/
sHboak/muj56MZZwW6/lP4Wv0WurJbI+T5cqBbu65j8MMkqk+UWmPiT9vpka
xuc/FuGlok7emD69DwOOlszoP963u2QsmIk+ViJHghLT6T/oCizdbQt4Pu80
i3aO2eo/taLXUnOeZD6IR89qCuDrP5ucQ4G1I1A+IVoTX4bm7D+yDpsYKRA3
PrpsV1MC7e0/FOLNY0IVHj5Sf5tHfvPuP0keTxGy6AE+65HfO/r57z+yBkM/
snbjPT1Cg+Fid/A/gVvsNptFxT2FuxalyPHwP/FajAR8eaU9zTSqaC5s8T+y
wRw1dgaEPRWuPSyU5vE/gZuzi8c/YT1dJ9Hv+WDyP1YA2RPjcjs9paBks1/b
8j+6NAqHdCwUPe0Z+HbFVfM/fBd7sSlk6zw1k4s6K9DzP4R1qA5LLcE8rK/D
+utU9D93tEnaQ9aQPCLM+7qs2fQ/DahvdswQXjyZ6DN7bV71PwaKjqSPcyg8
EAVsOy7j9T+Fh8ft+hzyO4YhpPvuZ/Y/jsWAMbFxuDv9Pdy7r+z2P+uJawc0
DH476nZMPDH29z+c2i47CygBO1wD9sUZcvg/G42Eom1SwzrOj59PAu74P3kC
Tg6qD4Q6sqjyYtPl+T8YyC3FkPEAOnramIl11fs/Fp+OAQ044jjAKwXeyAMA
QCxtyC7qMA82ykOdtg8TAkDdVpiIzqm/MsIb+7T1/gNAoVnH5kfULS91gOul
RxQGQIdqtOvsFMkqflL8rL5RBkDSbayyMNs/KogkDbQ1jwZAbDd0q4essima
yC7CIwoHQMrEYMILMJQoo5o/yZpHB0C4lSCEdZ0CKKxsUNARhQdAIVwJvmKw
bye2PmHXiMIHQALwauPK5dgmvxBy3v//B0DWbFjWjw5CJvyBk/4=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwBYQWe+iFib1JlAgAAAFUAAAACAAAAvxBy3v//B8Cj2/WIAYTADF46mq5x
wgfAKkVUm3immg38Y8J+44QHwGBShe4d0nMOOLcSH8cJB8AkVWyj/iwhELBd
s1+OEwbAZktsd9trYxPmHWLusP0DwLfBtUrCDw8aLx5LVzQLAsDnmXyy2BHI
H/DE1AB/IgDA3nkCtjbU7iTtvZdvuyD8vxpdy9bsHP4pHnL6kTpD+L+S06Y0
EYY4LtoMOM/hEvS/qlAXieVrRTIO6W0bL+zvv4ML3S5Zv7Q1sbhUAR5A6L/0
a/mv3rNtONKq4jm63N+/sZxyLIra2DrU5O1CP1TQv33tIqIdTJ08GuVfSe7Z
zL92z+2bHPrLPIsA5AxeC8m/X7qckU2r+Dz8G2jQzTzFv3mmBW3xFSQ9bjfs
kz1uwb+wYdrRnTNOPb+l4K5aP7u/DS7hXWT3dD2i3Og1OqKzvwMs/s474Zo9
CifieTMKqL8w9ONNF9K/PaAp5Q/ln5G/mA+/80Zk4T38jEX6t9aOP6r33whl
sQM+TlsVhU47qD8sBSwuIE0kPq6pzIV3YLQ/gxXRpcANQz62pQ7JR6O8P3R5
KdntR2A+3lAoBgxzwj/ODWZVxlR5PuJOySd0lMY/6x5v7NzwkT7mTGpJ3LXK
P/zCXD0PI6c+6koLa0TXzj/0CwbwSSq7PmTkG2z1WNE/krDROOatyz5UI7Ki
SEbTP5Pz/7mL/dk+RGJI2Zsz1T9HmdVDaX3mPjSh3g/vINc/v5Ff/Rrv8T4k
4HRGQg7ZPz1zJwCpW/o+FB8LfZX72j+lsW0wkdkBPwReobPo6Nw/AUrnsYRH
Bj/znDfqO9bePxn4istXoAk/TzSwiX124D+xKAKzBjILPySaRB7dgeE/My24
I/83Cj/6/9iyPI3iP4E4KZ2c9gY/z2VtR5yY4z8PaZcyZ0UCP6TLAdz7o+Q/
buA+iPJp+j56MZZwW6/lP0MDWMtVWPE+T5cqBbu65j8W3plL0LHkPiT9vpka
xuc/94AAZkhu1j69DwOOlszoP0OoG3P8ZMY+ViJHghLT6T/zMLAp5GG0Pu80
i3aO2eo/lZK3hWTpoD6IR89qCuDrP7Ep5ZZ6lYk+IVoTX4bm7D94pORQNqRx
PrpsV1MC7e0/omb9G+0tVj5Sf5tHfvPuP9VXubuhazk+65HfO/r57z8TXMMh
dI8aPj1Cg+Fid/A/zQA8QOXy+z2FuxalyPHwPzmqZpXIIts9zTSqaC5s8T/q
14VSOU+4PRWuPSyU5vE/6IsC4PcXlD1dJ9Hv+WDyP5rOetNApm49paBks1/b
8j87FHgDYZFFPe0Z+HbFVfM/4OOZHuoBHD01k4s6K9DzPyM4yEthx/A8rK/D
+utU9D8jCytnc0O/PCLM+7qs2fQ//5t4CNJ+ijyZ6DN7bV71P9DbsTclbVQ8
EAVsOy7j9T8D37sid6YcPIYhpPvuZ/Y/OG/rBR1H4jv9Pdy7r+z2Pwr53ubz
NqU76nZMPDH29z8O4AGTm4MlO1wD9sUZcvg/PNnMhvLh5jrOj59PAu74PyAK
ZHNYaaY6sqjyYtPl+T+sBKe5QckgOnramIl11fs/GRWIO6wA/DjAKwXeyAMA
QHeXvJAW9xk2ykOdtg8TAkACoOTdW466MsIb+7T1/gNA7Mu4NhR+GC91gOul
RxQGQO5svIXXf6EqflL8rL5RBkAEYNQsTAcUKogkDbQ1jwZA16eNz8oihSma
yC7CIwoHQAp3eGVLc2Ioo5o/yZpHB0DuYiHyPYbOJ6xsUNARhQdAfnIiPPxH
Nye2PmHXiMIHQBuloPFPX6AmvxBy3v//B0DPXV/gZTsFJjYKnnE=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHjN+9EMq/eVDZYruQ/HFOBH9D7Ob4
PmE2OP+ZbNK7DX+Z4Xx9Oe9wE24mOP/DkSsM9UoMcP7bvdPzdyv82Q/jyxX9
mmjl/APOv8Vjcf6h0Bc4n+9lrrT+m/f71yj+O2k+391w444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/Fde3Nku18/Zfzu8/Z3z+5Omn+eY
v7K+dg/OV/m7b6bUsedw/uuJ961//XwP55tO7rbSvvDZHm5emY+N4bfvcH7V
rRmdpVd/w/kHtFnvnWBmcIDxTznP3cYvzATnH5L+veXrP2Y4v7Th9VJ3ETY4
f9YJvUPKXOxwPjR+4HwAAuTkvQ==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwBMQLO/SFib1JlAgAAACIAAAACAAAAvxBy3v//B8B3HNeN3Pm+Bl46mq5x
wgfAtTqHkcDllQf8Y8J+44QHwDQ82WUskmwIOLcSH8cJB8BHPVJUPx0TCrBd
s1+OEwbA2moc0bYdSg3mHWLusP0DwB6ujZvdzt0TLx5LVzQLAsDsV/f1QA6D
GfDE1AB/IgDAGiyAF98Dlh7tvZdvuyD8v1TO/iF1ppMjHnL6kTpD+L+So+/Z
GJ7AJ9oMOM/hEvS/+jFpenP8visO6W0bL+zvv5929iXcmyEvsbhUAR5A6L9E
zaxPC4TQMdKq4jm63N+/FV4B73/zMjTU5O1CP1TQv9NMZi5n8/A1oCnlD+Wf
kb+Q7jgbuX0wN+pKC2tE184//1R2Nop7BjjznDfqO9beP/sRTbl1I1Q4JP2+
mRrG5z+3PK3IbxYiOOuR3zv6+e8/Z81UKX7dZzc1k4s6K9DzP+zYVYRR9UE2
6nZMPDH29z9F71Dfsi1+NHramIl11fs/8UZzgKdFWzLAKwXeyAMAQPPwd8Ct
mYMvykOdtg8TAkAYu413NsIwLMIb+7T1/gNAhAgWvELnmih1gOulRxQGQPMR
ZdMUBDMkflL8rL5RBkB8PIrwb6ynI4gkDbQ1jwZA54mgDG40GyOayC7CIwoH
QP90ILqcQfwho5o/yZpHB0BBx5yj+YlpIaxsUNARhQdAUBVrEaZO1SC2PmHX
iMIHQPyFx2S9aEAgvxBy3v//B0DJzdM2a1SnHx2sCJI=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwBMQLO/SFib1JlAgAAACIAAAACAAAAvxBy3v//B8Dic6aymrdTBl46mq5x
wgfAQAuTF0qoLwf8Y8J+44QHwASjtPhRbQcIOLcSH8cJB8AyiuyiKxm0CbBd
s1+OEwbA7KJ8yGJG9gzmHWLusP0DwLUrroccDqETLx5LVzQLAsC4+EXigmFZ
GfDE1AB/IgDA5Qzt/YQ9fx7tvZdvuyD8v0P+7HfMOY0jHnL6kTpD+L/1qjOQ
i9zGJ9oMOM/hEvS/uuAoCtgd0ysO6W0bL+zvv5E4HiQFvUEvsbhUAR5A6L+h
z6CxSWb4MdKq4jm63N+/4HNEJdyMYzTU5O1CP1TQv0pMge21ISY2oCnlD+Wf
kb86i94oA0FpN+pKC2tE184/zVc92lTkQjjznDfqO9beP/Ku1qHAHpE4JP2+
mRrG5z9BjARimrFcOOuR3zv6+e8/NRkB/QNHoDc1k4s6K9DzP9QWulAVw3M2
6nZMPDH29z/c169nYESoNHramIl11fs/BgVkEjVWfjLAKwXeyAMAQKh8zkAR
7ZovykOdtg8TAkBuYvc/s2E6LMIb+7T1/gNAFzeS7F1glyh1gOulRxQGQE4g
+FsO/B8kflL8rL5RBkDUDGR+VTaSI4gkDbQ1jwZADNNdjI8fAyOayC7CIwoH
QADxyKD4huAho5o/yZpHB0DHGia1zDRLIaxsUNARhQdAs+MBt5eltCC2PmHX
iMIHQJZg/17+5BwgvxBy3v//B0D/ndJ2XKSCH77oBUY=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHzvgeaD4ScE/aYruQ/HFOBH9D7Ob4
PmE2OP+ZbNK7DX+Z4Xx9Oe9wE24mOP/DkSsM9UoMcP7bvdPzdyv82Q/jyxX9
mmjl/APOv8Vjcf6h0Bc4n+9lrrT+m/f7ldLl5IL5UzQ37ghhlHN4AedfWvXI
cted+3D+lSdvnexDLsD5CzSf8j+dPxHOf+XFne1y/Zz9Tx9WIQm2Z7qf55i/
sr52D85X+btvptSx53D+64n3rX/9fA/nm07uttK+8Nkebl6Zj43ht+9wftWt
GZ2lV3/D+Qe0We+dYGZwgPFPOc/dxi/MBOcfkv695es/Zji/tOH1UncRNjh/
1gm9Q8pc7HA+NH7gfADOsrtn
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2Q6IFZgbx9dFMj6TTXq34S/zgU9TNTlnl7xg15fzDjfh
ZjrwMURyR+nULt4PR64w1CsxHHh37rj4c8NZQm/3Ts/frfBn/x/XLzP3r5ks
Llf0a6KV84/9Uw+7cLUE75G+xWNx/qHQl/3C/ZP1P+puk+d7mSut/+b9/ocb
Hl34ayOqvHFHCKOcw4v9pwwzjqj+OqB6adUjy1137u+f7sZwJjJRQePKk7dO
9iEX9v/O1rq0/s0NzQWaT/mfzp+4X71QyZpto4j2Ky/ubJfr5+yXNrmEzt//
XPvzHPNX1tfu2Vv8y599SNZIR+XvvplSx57b58ZLqlwM/639euJ9618/39sv
W3cs/XiGnbbp5G4r7Quf7U/fNei+1ySs9arMx8bw23f7jR2X3c2memtU3ZrR
WXr1t/2e9KJtPmaqage0We+dYGZwuGv58nfSTE/lU85zt/ELMzls0r4XWJL/
Sf6Q9O8tX/8xO7i8naVhZR4pU9rweqm7CJuDkbTuhfff3orXBf1Zsy+QzaFa
wMLCzyNJvEOFd4tpP5vDG84bOg+nXxGbdULvkDIXu0NsuLLk1Z4tootn2Z+c
5c7usNmmmXWbiZLompyAC4Kt7A7pHzZ2XTjWK7LNLvF6xyF2Bz2RC1wGVd+E
oenBQXBbiOe3oHhhAIcx9s8=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2Q5My1+utqnjMMMz2aR3G/4yH/jwRSn5/+Icdn0573AT
bqYDrb/vdS4tU+H9cOQKQ70Sw4GojGslLSYeQm/3Ts/frfBnv860QjP+DaHi
ckW/Jlo5/9h/V+/kqYneE6Rv8Vicfyj0Zf/9k53Xy8VmyfO9zJXWf/N+/9kN
7mrMhuzKG3eEMMo5vNj/4sySnJpl+1QvrXpkuevO/f3TXf/vCmhR17jy5K2T
fciF/e1/bi/9MuGl5gLNp/xP50/cf2pVeuBFTh3tV17c2S7Xz9kzHrunHy7O
ovN5jvkr62v37P17i49W1gbqqPzdN1Pq2HN7nb5KhpUCMjqvJ963/vXzvb0y
wynBxKY4bdPJ3VbaFz7bL+fJbvtw2lDrVZmPjeG37/Ye4m2fLr1N0ai6NaOz
9Opve9Wzt++wKlqqHdBmvXeCmcEh5rDX3rrIUOVTznO38QszOdgGLv3yk/OL
/CHp31u+/mN2uNQrXavJHyhT2vB6qbsIm8OCSyee5UVeE68L+rNmXyCbw8pf
jD/lgj3FO1R4t5j2szn8PBWrWVy6S2zWCb1DylzsDnkf1lYvWjxNdPEs+5Oz
3Nkd7JYzP8ruYhJdkxNwQbCV3UFNkXWOFkOOyDa7xOsdh9gd1nwQXHSw7rIw
ND043EyOj13PbikMAAJs9bw=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHlNLl5IL5UzQttgvJH+dE8DfEbo7v
E2aD85/JJr3b8JcZzteX8w434WaC8z8cucJQr8QA57/dOz1/t8Kf/TC+XNGv
iVbOP+D8WzwW5x8KfYHz+V7mSuu/eb8/Zv0jEfmeV2Ybd4Qwyjm8gPMvrXpk
uevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs7ejqMupFY11/rzHPNX
1tfuwfkqf/fNlDr2HM5/PfG+9a+f7+F808ndVtoXPtvDzSvzsTH89h3Or7o1
o7P06m84/4A2670TzAwOMP4p57nb+IWZ4PxD0r+3fP3HDOeXNrxe6i7CBufP
OqF3SJmLHc6Hxg+cDwBoEb+u
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwBMQLO/SFib1JlAgAAACIAAAACAAAAvxBy3v//B8DoiD/lv+1pCF46mq5x
wgfAFvd+dBZ3Qwn8Y8J+44QHwN6ssJqc+BoKOLcSH8cJB8BXmak5bVnEC7Bd
s1+OEwbArWg4Z1muAQ/mHWLusP0DwAmcGn3+/qAVLx5LVzQLAsC7pluiB65R
G/DE1AB/IgDAEqJ0Jc91cCDtvZdvuyD8v4aSjdo1qHglHnL6kTpD+L9J2TVm
L+ewKdoMOM/hEvS/t6DgaNCaui0O6W0bL+zvv4Bkdgr+RykxsbhUAR5A6L9v
lfnd1CbjM9Kq4jm63N+/Qoo+D297UjbU5O1CP1TQvw1U47my3Bo4oCnlD+Wf
kb/+QYE24QdlOepKC2tE184/TELh7pYGSDrznDfqO9bePzCFqT3Ra6E6JP2+
mRrG5z9xDHM55WB6OuuR3zv6+e8/7HRj3P0OzTk1k4s6K9DzP+rQarHmorE4
6nZMPDH29z+T+xj5JOT4NnramIl11fs/ImOs+QNA4jTAKwXeyAMAQImrnR5w
KRYyykOdtg8TAkBEOMb1brbPLsIb+7T1/gNADbwuwbuTRCt1gOulRxQGQEOY
76lHfOgmflL8rL5RBkDdtGVIMi9gJogkDbQ1jwZAQQbmlMe/0yWayC7CIwoH
QDsXT4IQIbcko5o/yZpHB0DliW30wDImJKxsUNARhQdAbO1UIneqkyO2PmHX
iMIHQOgDCQsGFQAjvxBy3v//B0Dq8LUbikdoIqNhCCg=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwBMQLO/SFib1JlAgAAACIAAAACAAAAvxBy3v//B8DEmcsUAbhECF46mq5x
wgfAKszJr3riIAn8Y8J+44QHwPJr8HxVXvkJOLcSH8cJB8AGitTco22mC7Bd
s1+OEwbA1h9tIeFl6g7mHWLusP0DwNa1WLHqBpcVLx5LVzQLAsA8cFoLO1pT
G/DE1AB/IgDAEXhvtA7XeiDtvZdvuyD8vzmBOjGQlIwlHnL6kTpD+L/pL4aA
ajrJKdoMOM/hEvS/cKOlCRgM2C0O6W0bL+zvv/a8MOH8X0kxsbhUAR5A6L97
Rhl086wDNNKq4jm63N+/IOjkul/0cTbU5O1CP1TQv1rwN3Pu8jY4oCnlD+Wf
kb8s3o26BH99OepKC2tE184/H4XYZGAbWTrznDfqO9beP2fzx61sqqk6JP2+
mRrG5z+2Zv5OUYJ4OuuR3zv6+e8/XhOapnCcvzk1k4s6K9DzP7KU9NJqoJU4
6nZMPDH29z8mm8TEADzONnramIl11fs/maDniYtUpTTAKwXeyAMAQAPOWTDz
lcUxykOdtg8TAkDk5dHqYA5oLsIb+7T1/gNAt0sMDnkJyCp1gOulRxQGQPgH
41lku1ImflL8rL5RBkBk4i2nqKfFJYgkDbQ1jwZAWA7pzgQVNyWayC7CIwoH
QJDz6piBjhQko5o/yZpHB0CX6g7V8SyBI6xsUNARhQdAK5MAb6J26iK2PmHX
iMIHQLmHtvkgzFIivxBy3v//B0DD0CUoQp+4IdN/CwM=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQB2IQvV+g6N7//+wHbhx5oP29+aiOxXYh+eOcCP6G2M3x
fcJscP4z2aR3G/4yw/n6ct7hJtxMcP6HI1cY6pUY4Py3e6fn71b4sx/Glyv6
NdHK+Qecf4vH4vxDoS9wPt/LXGn9N+/3e3w4eNmt0sdq444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/D89rr+2X+uz73uWYf/W6bydX7Ro
q5/1Cjh/3cozreUJW+D8bUv5Trov3gPnP/I7qV4y5Ric/8qLO9vl+jk432Th
Pf73Ctfh/M9zzF9ZX7sH56v83TdT6thzOP/1xPvWv36+h/NtnZofJpV/sIe5
t3W32NITHxH8syarMvRyPsL5outsdaY8Q/CXLkjZHH/7E5xvOrnbSvvCZzhf
gDXHWu/xVzj/VZmPjeG373B+1a0ZnaVXf8P5B7RZ751gZnCA8U85z93GL8wE
5x+S/r3l6z9mOL+04fVSdxE2OH/WCb1DylzscD40fcH5AI62TNs=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwB0QUu+iFib1JlAgAAAFwAAAACAAAAvxBy3v//B8DPT7/QfHmKDV46mq5x
wgfAlLWZeQt7Yw78Y8J+44QHwCMpPzX/dDoPOLcSH8cJB8Dbr/9bXS3jELBd
s1+OEwbAv7vPlBnCHhTmHWLusP0DwEIoKFCB2bgaLx5LVzQLAsCGhZzrH/pl
IPDE1AB/IgDAMsEUBo5zgSXtvZdvuyD8v2kTo698/4UqHnL6kTpD+L9f4qsp
bay5LtoMOM/hEvS/Q4yijOr3wDIO6W0bL+zvv0wz0pdyKys2sbhUAR5A6L8w
PtGIqorhONKq4jm63N+/5DtqR/l3TDsSEgTbquvdv/R7rmLvhYs7UnklfJv6
27/dje3764TIO9NHaL58GNi/r0okLhlzPjwUr4lfbSfWvxKex+I7OXU8VBar
AF421L+/m6ztIUOrPJR9zKFORdK/Gnu/CmMi4DzU5O1CP1TQv91OnVPpmBE9
GuVfSe7ZzL8YDyCJBv1APYsA5AxeC8m/BC5p30BSbj38G2jQzTzFv6woH4dy
A5k9bjfskz1uwb9u2GRRJhPDPb+l4K5aP7u/qmfBKpDk6j2i3Og1OqKzv9ge
i4I+hhE+CifieTMKqL/SrayrzBw1PqAp5Q/ln5G/KgLP4iqDVz78jEX6t9aO
P/blthOKM3s+TlsVhU47qD/sJXU/AbCcPq6pzIV3YLQ/oUZRh6iUuz62pQ7J
R6O8P2T5k/07LNg+3lAoBgxzwj9xu8bYN1DzPuJOySd0lMY/s5CVYT4iDD/m
TGpJ3LXKP4/NbNYVriI/6koLa0TXzj/Dh5rWCJ02P2TkG2z1WNE/Fal9S3m8
Rz9UI7KiSEbTP3059+pw/FY/RGJI2Zsz1T/Iju+lWYlkPzSh3g/vINc/BtBV
nHrtcD8k4HRGQg7ZPxX81s7lvnk/FB8LfZX72j+8gvKvIhCCPwReobPo6Nw/
G3AbNj9ihz/znDfqO9beP0kLX+eu7Ys/TzSwiX124D/hSuZWlOmOPySaRB7d
geE/6vyY3+gfjz/6/9iyPI3iP+M9dSX0gYw/z2VtR5yY4z+ZbaWMjcCHP6TL
Adz7o+Q/gSXsHZ0Agj96MZZwW6/lP0My7bf10ng/T5cqBbu65j/z5XJ6giNv
PyT9vpkaxuc/vbabeQjEYT+9DwOOlszoPz80+jjjrVI/ViJHghLT6T+I5Twi
V+1BP+80i3aO2eo/ZY79Tu5oLz+IR89qCuDrP/MjTQzzHRk/IVoTX4bm7D/+
6K9dXFUCP7psV1MC7e0/gVCcCxxu6D5Sf5tHfvPuPwAIM1Qnt80+65HfO/r5
7z8I5nhmB3+wPj1Cg+Fid/A/cOSTZT1kkj6FuxalyPHwP1j+w9u98HI+zTSq
aC5s8T8fVFZ7fQRSPhWuPSyU5vE/Br2kvgWqLz5dJ9Hv+WDyP064aqdlswk+
paBks1/b8j9q/1Sp4ETjPe0Z+HbFVfM/23y7h4Owuj01k4s6K9DzP8CnXILb
EpE9rK/D+utU9D9T0WIG8RlhPSLM+7qs2fQ/Evg+Y2s0Lz2Z6DN7bV71PwrE
w9ik7vk8EAVsOy7j9T9xLm6JOaHDPIYhpPvuZ/Y/I+aercYRizz9Pdy7r+z2
P2FSEH83AFE8dFoUfHBx9z8ULeDZinMTPOp2TDwx9vc/GZXnUoFF1DtcA/bF
GXL4P9H2LZqgS5c7zo+fTwLu+D9f0uF27q1YO7Ko8mLT5fk/lZDWHcKz1Tp6
2piJddX7P+66wHngS7k5wCsF3sgDAEAppCXSfsrpNspDnbYPEwJAiKGeuKIV
nzPCG/u09f4DQPDAC11XLxEwdYDrpUcUBkA0PjcGjzCxK35S/Ky+UQZAzBm4
4xhGJiuIJA20NY8GQFJ1xlYypJoqmsguwiMKB0Cfu3mMG/p9KaOaP8maRwdA
XMyGNVMz7CisbFDQEYUHQL80+EkJfVgotj5h14jCB0BaGIn7DKHDJ78Qct7/
/wdAld6GNBsMLSfSl9YP
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwB0QUu+iFib1JlAgAAAFwAAAACAAAAvxBy3v//B8C2e4QzqidlDV46mq5x
wgfAf9rr8GknQQ78Y8J+44QHwGuh0CDspBkPOLcSH8cJB8BYrYPxKXLGELBd
s1+OEwbAD3LocvrkCRTmHWLusP0DwCjsYSeHoLUaLx5LVzQLAsBzxvk/+XNx
IPDE1AB/IgDAvhm7s/NClyXtvZdvuyD8vwI8YgYzuacqHnL6kTpD+L/eB80p
PR3kLtoMOM/hEvS/fYIAC45a8jIO6W0bL+zvv5dINKH7jWI2sbhUAR5A6L8S
6ioUjqUbOdKq4jm63N+/E2BQa4EoiDsSEgTbquvdv+6Wz9fjbcc7UnklfJv6
27//eOQp4ekEPNNHaL58GNi//HfK6j/8eTwUr4lfbSfWv7fLfZ3dFbI8VBar
AF421L+kYrP4oyvnPJR9zKFORdK/U42/y4RSGz3U5O1CP1TQv8jlmYlSp009
GuVfSe7ZzL/RYEP5PnV8PYsA5AxeC8m/BSpoQtA3qT38G2jQzTzFv1tNbmR6
otQ9bjfskz1uwb8c4Mqzai7/Pb+l4K5aP7u/X1tHqAzBJT6i3Og1OqKzv90l
3dxCB0w+CifieTMKqL/uiygeMqxwPqAp5Q/ln5G/oMRonMpQkj78jEX6t9aO
P03lte3Y2bQ+TlsVhU47qD+xVIJgbJzVPq6pzIV3YLQ/fr4Ed3Vk9D62pQ7J
R6O8Pz8yUG3UhBE/3lAoBgxzwj80q/NeemcrP+JOySd0lMY/kYOFr4qDQz/m
TGpJ3LXKP56ZTKseTVk/6koLa0TXzj+n2FRm191tP2TkG2z1WNE/CodmC8CV
fj9UI7KiSEbTP2GWx2UD3Yw/RGJI2Zsz1T/Uley2ABqZPzSh3g/vINc/2qe7
VwwepD8k4HRGQg7ZP35WyZY/t60/FB8LfZX72j9DntGonTm0PwReobPo6Nw/
96+zd/teuT/znDfqO9beP1UASKtOVL0/TzSwiX124D+ca6OKg0u/PySaRB7d
geE/PgNe+/BVvj/6/9iyPI3iP7tRzpbPtro/z2VtR5yY4z+uihKsF1+1P6TL
Adz7o+Q/z3quxIMQrz96MZZwW6/lP46UTLqigqQ/T5cqBbu65j+d9x37xpqY
PyT9vpkaxuc/+zXdqXrQij+9DwOOlszoPxWt9uoT6no/ViJHghLT6T+mzEMb
naBoP+80i3aO2eo/N58rNBeLVD+IR89qCuDrPzuAs+KJPj8/IVoTX4bm7D9q
Y8nl9aglP7psV1MC7e0/OOlAOqVgCz9Sf5tHfvPuP+7S1zzWi+8+65HfO/r5
7z/sO1pZl5HQPj1Cg+Fid/A/QoSGUJ2FsT6FuxalyPHwPyqvHYHlGJE+zTSq
aC5s8T9eS9ieMMluPhWuPSyU5vE/TgmtMvGSST5dJ9Hv+WDyP1KhagMRmiM+
paBks1/b8j8TQ0o/qrn7Pe0Z+HbFVfM/PsdC8G8X0j01k4s6K9DzP1eFTd70
yKU9rK/D+utU9D9tAVIS12d0PSLM+7qs2fQ/Dm/VJyBjQT2Z6DN7bV71PwhQ
n4xJ9Ao9EAVsOy7j9T92+ifhbwHTPIYhpPvuZ/Y/EAWGFJJhmDz9Pdy7r+z2
P48axXe4c1w8dFoUfHBx9z88xyBBJTQePOp2TDwx9vc/TP9PB8sq3TtcA/bF
GXL4P1MyEX3qLZ87zo+fTwLu+D/rLEkiHrFeO7Ko8mLT5fk/F6knz6A41zp6
2piJddX7PzvlVox2w7M5wCsF3sgDAECiAUJ2BCXTNspDnbYPEwJAD1uZkWpw
dDPCG/u09f4DQDdo144Bn9MvdYDrpUcUBkAccS4KMEhdK35S/Ky+UQZABqj1
JVDX0CqIJA20NY8GQL+lWeuD3EEqmsguwiMKB0CEJypUW38fKaOaP8maRwdA
FnBrfn0viiisbFDQEYUHQBZwwY50EvQntj5h14jCB0A7nrN7aV9cJ78Qct7/
/wdA1vqiS1B9wib/GNGw
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQB2IQvV+g6N7//+wHbhx5oP29+aiOxXYh+eOcCP6G2M3x
fcJscP4z2aR3G/4yw/n6ct7hJtxMcP6HI1cY6pUY4Py3e6fn71b4sx/Glyv6
NdHK+Qecf4vH4vxDoS9wPt/LXGn9N+/3e3w4eNmt0sdq444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/D89rr+2X+uz73uWYf/W6bydX7Ro
q5/1Cjh/3cozreUJW+D8bUv5Trov3gPnP/I7qV4y5Ric/8qLO9vl+jk432Th
Pf73Ctfh/M9zzF9ZX7sH56v83TdT6thzOP/1xPvWv36+h/NtnZofJpV/sIe5
t3W32NITHxH8syarMvRyPsL5outsdaY8Q/CXLkjZHH/7E5xvOrnbSvvCZzhf
gDXHWu/xVzj/VZmPjeG373B+1a0ZnaVXf8P5B7RZ751gZnCA8U85z93GL8wE
5x+S/r3l6z9mOL+04fVSdxE2OH/WCb1DylzscD40fcH5AI62TNs=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwBYQWe+iFib1JlAgAAAFUAAAACAAAAvxBy3v//B8Ae3xNddRf8DF46mq5x
wgfAQNNC1qpC1A38Y8J+44QHwKh0cOhZ+KoOOLcSH8cJB8BKyv9Q9sdSELBd
s1+OEwbA75zYInLNixPmHWLusP0DwPBS6N7U4CIaLx5LVzQLAsAuyk1Fx2PM
H/DE1AB/IgDAWMw3tkQ64yTtvZdvuyD8v5q2uBkjZeQpHnL6kTpD+L9SPQVi
AEMULtoMOM/hEvS/7/EJm0x+FjIO6W0bL+zvv2lxO0sPWH41sbhUAR5A6L94
l6nfZbIwONKq4jm63N+/LxC6Yf3IljrU5O1CP1TQvyd0CaW09Vc8GuVfSe7Z
zL+mkV6iMa2GPIsA5AxeC8m/tICWe+nWszz8G2jQzTzFvyrPa4uRC+A8bjfs
kz1uwb80sr0Htf0HPb+l4K5aP7u/zyPzi3iUMD2i3Og1OqKzvwtjG2QbL1U9
CifieTMKqL/qqLcqNAV5PaAp5Q/ln5G/KrzXNjtRmz38jEX6t9aOP+cVqjA4
7r49TlsVhU47qD9uT9ETGO3fPa6pzIV3YLQ/sGmO5YAK/j22pQ7JR6O8P8oD
4xzJxBk+3lAoBgxzwj8uBeBecyY0PuJOySd0lMY/CunL2l66TD7mTGpJ3LXK
P7NK4oAnq2I+6koLa0TXzj8SdEfwVh52PmTkG2z1WNE/XOGl6FvBhj5UI7Ki
SEbTP2QYiM8jmZU+RGJI2Zsz1T99QNjZuumiPjSh3g/vINc/Dwx+RiaPrj4k
4HRGQg7ZP2eCM1H4xrY+FB8LfZX72j/ya1tvVFO/PgReobPo6Nw/OSwvEZvf
wz7znDfqO9beP5oKEH2eQ8c+TzSwiX124D+/HqbhCTLJPiSaRB7dgeE/P2BR
+4XSyD76/9iyPI3iPwAOH9jvPsY+z2VtR5yY4z80docwzSLCPqTLAdz7o+Q/
sHboak/muj56MZZwW6/lP4Wv0WurJbI+T5cqBbu65j8MMkqk+UWmPiT9vpka
xuc/FuGlok7emD69DwOOlszoP963u2QsmIk+ViJHghLT6T/oCizdbQt4Pu80
i3aO2eo/taLXUnOeZD6IR89qCuDrP5ucQ4G1I1A+IVoTX4bm7D+yDpsYKRA3
PrpsV1MC7e0/FOLNY0IVHj5Sf5tHfvPuP0keTxGy6AE+65HfO/r57z+yBkM/
snbjPT1Cg+Fid/A/gVvsNptFxT2FuxalyPHwP/FajAR8eaU9zTSqaC5s8T+y
wRw1dgaEPRWuPSyU5vE/gZuzi8c/YT1dJ9Hv+WDyP1YA2RPjcjs9paBks1/b
8j+6NAqHdCwUPe0Z+HbFVfM/fBd7sSlk6zw1k4s6K9DzP4R1qA5LLcE8rK/D
+utU9D93tEnaQ9aQPCLM+7qs2fQ/DahvdswQXjyZ6DN7bV71PwaKjqSPcyg8
EAVsOy7j9T+Fh8ft+hzyO4YhpPvuZ/Y/jsWAMbFxuDv9Pdy7r+z2P+uJawc0
DH476nZMPDH29z+c2i47CygBO1wD9sUZcvg/G42Eom1SwzrOj59PAu74P3kC
Tg6qD4Q6sqjyYtPl+T8YyC3FkPEAOnramIl11fs/Fp+OAQ044jjAKwXeyAMA
QCxtyC7qMA82ykOdtg8TAkDdVpiIzqm/MsIb+7T1/gNAoVnH5kfULS91gOul
RxQGQIdqtOvsFMkqflL8rL5RBkDSbayyMNs/KogkDbQ1jwZAbDd0q4essima
yC7CIwoHQMrEYMILMJQoo5o/yZpHB0C4lSCEdZ0CKKxsUNARhQdAIVwJvmKw
bye2PmHXiMIHQALwauPK5dgmvxBy3v//B0DWbFjWjw5CJvyBk/4=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwBYQWe+iFib1JlAgAAAFUAAAACAAAAvxBy3v//B8Cj2/WIAYTADF46mq5x
wgfAKkVUm3immg38Y8J+44QHwGBShe4d0nMOOLcSH8cJB8AkVWyj/iwhELBd
s1+OEwbAZktsd9trYxPmHWLusP0DwLfBtUrCDw8aLx5LVzQLAsDnmXyy2BHI
H/DE1AB/IgDA3nkCtjbU7iTtvZdvuyD8vxpdy9bsHP4pHnL6kTpD+L+S06Y0
EYY4LtoMOM/hEvS/qlAXieVrRTIO6W0bL+zvv4ML3S5Zv7Q1sbhUAR5A6L/0
a/mv3rNtONKq4jm63N+/sZxyLIra2DrU5O1CP1TQv33tIqIdTJ08GuVfSe7Z
zL92z+2bHPrLPIsA5AxeC8m/X7qckU2r+Dz8G2jQzTzFv3mmBW3xFSQ9bjfs
kz1uwb+wYdrRnTNOPb+l4K5aP7u/DS7hXWT3dD2i3Og1OqKzvwMs/s474Zo9
CifieTMKqL8w9ONNF9K/PaAp5Q/ln5G/mA+/80Zk4T38jEX6t9aOP6r33whl
sQM+TlsVhU47qD8sBSwuIE0kPq6pzIV3YLQ/gxXRpcANQz62pQ7JR6O8P3R5
KdntR2A+3lAoBgxzwj/ODWZVxlR5PuJOySd0lMY/6x5v7NzwkT7mTGpJ3LXK
P/zCXD0PI6c+6koLa0TXzj/0CwbwSSq7PmTkG2z1WNE/krDROOatyz5UI7Ki
SEbTP5Pz/7mL/dk+RGJI2Zsz1T9HmdVDaX3mPjSh3g/vINc/v5Ff/Rrv8T4k
4HRGQg7ZPz1zJwCpW/o+FB8LfZX72j+lsW0wkdkBPwReobPo6Nw/AUrnsYRH
Bj/znDfqO9bePxn4istXoAk/TzSwiX124D+xKAKzBjILPySaRB7dgeE/My24
I/83Cj/6/9iyPI3iP4E4KZ2c9gY/z2VtR5yY4z8PaZcyZ0UCP6TLAdz7o+Q/
buA+iPJp+j56MZZwW6/lP0MDWMtVWPE+T5cqBbu65j8W3plL0LHkPiT9vpka
xuc/94AAZkhu1j69DwOOlszoP0OoG3P8ZMY+ViJHghLT6T/zMLAp5GG0Pu80
i3aO2eo/lZK3hWTpoD6IR89qCuDrP7Ep5ZZ6lYk+IVoTX4bm7D94pORQNqRx
PrpsV1MC7e0/omb9G+0tVj5Sf5tHfvPuP9VXubuhazk+65HfO/r57z8TXMMh
dI8aPj1Cg+Fid/A/zQA8QOXy+z2FuxalyPHwPzmqZpXIIts9zTSqaC5s8T/q
14VSOU+4PRWuPSyU5vE/6IsC4PcXlD1dJ9Hv+WDyP5rOetNApm49paBks1/b
8j87FHgDYZFFPe0Z+HbFVfM/4OOZHuoBHD01k4s6K9DzPyM4yEthx/A8rK/D
+utU9D8jCytnc0O/PCLM+7qs2fQ//5t4CNJ+ijyZ6DN7bV71P9DbsTclbVQ8
EAVsOy7j9T8D37sid6YcPIYhpPvuZ/Y/OG/rBR1H4jv9Pdy7r+z2Pwr53ubz
NqU76nZMPDH29z8O4AGTm4MlO1wD9sUZcvg/PNnMhvLh5jrOj59PAu74PyAK
ZHNYaaY6sqjyYtPl+T+sBKe5QckgOnramIl11fs/GRWIO6wA/DjAKwXeyAMA
QHeXvJAW9xk2ykOdtg8TAkACoOTdW466MsIb+7T1/gNA7Mu4NhR+GC91gOul
RxQGQO5svIXXf6EqflL8rL5RBkAEYNQsTAcUKogkDbQ1jwZA16eNz8oihSma
yC7CIwoHQAp3eGVLc2Ioo5o/yZpHB0DuYiHyPYbOJ6xsUNARhQdAfnIiPPxH
Nye2PmHXiMIHQBuloPFPX6AmvxBy3v//B0DPXV/gZTsFJjYKnnE=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHjN+9EMq/eVDZYruQ/HFOBH9D7Ob4
PmE2OP+ZbNK7DX+Z4Xx9Oe9wE24mOP/DkSsM9UoMcP7bvdPzdyv82Q/jyxX9
mmjl/APOv8Vjcf6h0Bc4n+9lrrT+m/f71yj+O2k+391w444QRjmHF3D+pVWP
LHfduQ/nX3ny1sk+5AKcv0DzKf/T+RPh/Fde3Nku18/Zfzu8/Z3z+5Omn+eY
v7K+dg/OV/m7b6bUsedw/uuJ961//XwP55tO7rbSvvDZHm5emY+N4bfvcH7V
rRmdpVd/w/kHtFnvnWBmcIDxTznP3cYvzATnH5L+veXrP2Y4v7Th9VJ3ETY4
f9YJvUPKXOxwPjR+4HwAAuTkvQ==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwBMQLO/SFib1JlAgAAACIAAAACAAAAvxBy3v//B8B3HNeN3Pm+Bl46mq5x
wgfAtTqHkcDllQf8Y8J+44QHwDQ82WUskmwIOLcSH8cJB8BHPVJUPx0TCrBd
s1+OEwbA2moc0bYdSg3mHWLusP0DwB6ujZvdzt0TLx5LVzQLAsDsV/f1QA6D
GfDE1AB/IgDAGiyAF98Dlh7tvZdvuyD8v1TO/iF1ppMjHnL6kTpD+L+So+/Z
GJ7AJ9oMOM/hEvS/+jFpenP8visO6W0bL+zvv5929iXcmyEvsbhUAR5A6L9E
zaxPC4TQMdKq4jm63N+/FV4B73/zMjTU5O1CP1TQv9NMZi5n8/A1oCnlD+Wf
kb+Q7jgbuX0wN+pKC2tE184//1R2Nop7BjjznDfqO9beP/sRTbl1I1Q4JP2+
mRrG5z+3PK3IbxYiOOuR3zv6+e8/Z81UKX7dZzc1k4s6K9DzP+zYVYRR9UE2
6nZMPDH29z9F71Dfsi1+NHramIl11fs/8UZzgKdFWzLAKwXeyAMAQPPwd8Ct
mYMvykOdtg8TAkAYu413NsIwLMIb+7T1/gNAhAgWvELnmih1gOulRxQGQPMR
ZdMUBDMkflL8rL5RBkB8PIrwb6ynI4gkDbQ1jwZA54mgDG40GyOayC7CIwoH
QP90ILqcQfwho5o/yZpHB0BBx5yj+YlpIaxsUNARhQdAUBVrEaZO1SC2PmHX
iMIHQPyFx2S9aEAgvxBy3v//B0DJzdM2a1SnHx2sCJI=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwBMQLO/SFib1JlAgAAACIAAAACAAAAvxBy3v//B8Dic6aymrdTBl46mq5x
wgfAQAuTF0qoLwf8Y8J+44QHwASjtPhRbQcIOLcSH8cJB8AyiuyiKxm0CbBd
s1+OEwbA7KJ8yGJG9gzmHWLusP0DwLUrroccDqETLx5LVzQLAsC4+EXigmFZ
GfDE1AB/IgDA5Qzt/YQ9fx7tvZdvuyD8v0P+7HfMOY0jHnL6kTpD+L/1qjOQ
i9zGJ9oMOM/hEvS/uuAoCtgd0ysO6W0bL+zvv5E4HiQFvUEvsbhUAR5A6L+h
z6CxSWb4MdKq4jm63N+/4HNEJdyMYzTU5O1CP1TQv0pMge21ISY2oCnlD+Wf
kb86i94oA0FpN+pKC2tE184/zVc92lTkQjjznDfqO9beP/Ku1qHAHpE4JP2+
mRrG5z9BjARimrFcOOuR3zv6+e8/NRkB/QNHoDc1k4s6K9DzP9QWulAVw3M2
6nZMPDH29z/c169nYESoNHramIl11fs/BgVkEjVWfjLAKwXeyAMAQKh8zkAR
7ZovykOdtg8TAkBuYvc/s2E6LMIb+7T1/gNAFzeS7F1glyh1gOulRxQGQE4g
+FsO/B8kflL8rL5RBkDUDGR+VTaSI4gkDbQ1jwZADNNdjI8fAyOayC7CIwoH
QADxyKD4huAho5o/yZpHB0DHGia1zDRLIaxsUNARhQdAs+MBt5eltCC2PmHX
iMIHQJZg/17+5BwgvxBy3v//B0D/ndJ2XKSCH77oBUY=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBmIQvV+g6N7//+wHzvgeaD4ScE/aYruQ/HFOBH9D7Ob4
PmE2OP+ZbNK7DX+Z4Xx9Oe9wE24mOP/DkSsM9UoMcP7bvdPzdyv82Q/jyxX9
mmjl/APOv8Vjcf6h0Bc4n+9lrrT+m/f7ldLl5IL5UzQ37ghhlHN4AedfWvXI
cted+3D+lSdvnexDLsD5CzSf8j+dPxHOf+XFne1y/Zz9Tx9WIQm2Z7qf55i/
sr52D85X+btvptSx53D+64n3rX/9fA/nm07uttK+8Nkebl6Zj43ht+9wftWt
GZ2lV3/D+Qe0We+dYGZwgPFPOc/dxi/MBOcfkv695es/Zji/tOH1UncRNjh/
1gm9Q8pc7HA+NH7gfADOsrtn
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2Q6IFZgbx9dFMj6TTXq34S/zgU9TNTlnl7xg15fzDjfh
ZjrwMURyR+nULt4PR64w1CsxHHh37rj4c8NZQm/3Ts/frfBn/x/XLzP3r5ks
Llf0a6KV84/9Uw+7cLUE75G+xWNx/qHQl/3C/ZP1P+puk+d7mSut/+b9/ocb
Hl34ayOqvHFHCKOcw4v9pwwzjqj+OqB6adUjy1137u+f7sZwJjJRQePKk7dO
9iEX9v/O1rq0/s0NzQWaT/mfzp+4X71QyZpto4j2Ky/ubJfr5+yXNrmEzt//
XPvzHPNX1tfu2Vv8y599SNZIR+XvvplSx57b58ZLqlwM/639euJ9618/39sv
W3cs/XiGnbbp5G4r7Quf7U/fNei+1ySs9arMx8bw23f7jR2X3c2memtU3ZrR
WXr1t/2e9KJtPmaqage0We+dYGZwuGv58nfSTE/lU85zt/ELMzls0r4XWJL/
Sf6Q9O8tX/8xO7i8naVhZR4pU9rweqm7CJuDkbTuhfff3orXBf1Zsy+QzaFa
wMLCzyNJvEOFd4tpP5vDG84bOg+nXxGbdULvkDIXu0NsuLLk1Z4tootn2Z+c
5c7usNmmmXWbiZLompyAC4Kt7A7pHzZ2XTjWK7LNLvF6xyF2Bz2RC1wGVd+E
oenBQXBbiOe3oHhhAIcx9s8=
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2Q5My1+utqnjMMMz2aR3G/4yH/jwRSn5/+Icdn0573AT
bqYDrb/vdS4tU+H9cOQKQ70Sw4GojGslLSYeQm/3Ts/frfBnv860QjP+DaHi
ckW/Jlo5/9h/V+/kqYneE6Rv8Vicfyj0Zf/9k53Xy8VmyfO9zJXWf/N+/9kN
7mrMhuzKG3eEMMo5vNj/4sySnJpl+1QvrXpkuevO/f3TXf/vCmhR17jy5K2T
fciF/e1/bi/9MuGl5gLNp/xP50/cf2pVeuBFTh3tV17c2S7Xz9kzHrunHy7O
ovN5jvkr62v37P17i49W1gbqqPzdN1Pq2HN7nb5KhpUCMjqvJ963/vXzvb0y
wynBxKY4bdPJ3VbaFz7bL+fJbvtw2lDrVZmPjeG37/Ye4m2fLr1N0ai6NaOz
9Opve9Wzt++wKlqqHdBmvXeCmcEh5rDX3rrIUOVTznO38QszOdgGLv3yk/OL
/CHp31u+/mN2uNQrXavJHyhT2vB6qbsIm8OCSyee5UVeE68L+rNmXyCbw8pf
jD/lgj3FO1R4t5j2szn8PBWrWVy6S2zWCb1DylzsDnkf1lYvWjxNdPEs+5Oz
3Nkd7JYzP8ruYhJdkxNwQbCV3UFNkXWOFkOOyDa7xOsdh9gd1nwQXHSw7rIw
ND043EyOj13PbikMAAJs9bw=
          "]]}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      Frame->True,
      GridLines->{{1, 0., 0.519498449204922}, None},
      PlotRange->{{-3, 3}, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {977.1428571428571, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {360., 291.2461179749811}], InsetBox[
     GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJx1lD1IlWEYhg9nEpGwoSWCyKExi4agJYlGhzIaXBqkWoMiGlqaqkVxiWgR
R0sXp4TEY9DSWNRg4GAlFhGVZf6BP+/7vNcN537phcPDdX6+7zrPcz/fsaGb
A9ebjUZjbv+VapyOeerk83Sa4qnMWy04fvNLfPVKOh/E/cHn4O3ddH6KJ+J6
4mdxvz7zcJaXV/xg/GD8YPxg/GD8YPysL86VB+wVPxg/GD8YPxg/GD+bk3PV
F/eAveIH4wfjB+MH42e5ca7m5H1xD9grfjB+MH4wfpZj5yo3Pifvi3vAXvGD
8YPxs71yrnLsufE5eV/cA/aKH4yf7blztVeeY8+Nz8n74h6wV/zsueNc7bnv
lefYc+Nz8r64B+wVv/89F/055Hvve+a59hz53LxP7uWV631aTOeHcj7/Mp3v
4rGn6XwT37ubzop4MNdl8ZnT6XwWHzqYzpL4S77fong8X3+hdTh/762eB5P5
/Tfinvz5K/HJzNOt9j61ZuHV7vy5ctiM34uH4/rizrh/tVf0B6Y/MP2B6Q9M
f2D6A9MfmP7A9OdJrpvye/AonQ3xnXzfdfG1G+n8E1/OdU18/kI6f8Wnstcf
8dGedFbFB7Ln7+q52FH6Bj8sfYV3uqPv8Ncyl7Y83389C58tc4WPl7nD0yUX
8JGSG/qFD4wPjA+MT9s+7fvA+MD4wPjA+JBn8kOeyQ95Jj/kmfyQZ/JDnskP
eSY/5Jn8kGfyMxpVeX4f31Oeu+I6ynNv3Ed5vhQeyvPteF8+j+N38pmJ68rn
Y9xXPguFmdeL8n3mxfWY161yP+Z1sfgwrxPFl3nxf5jXu/J/mddI6QfzYr/w
Yb/wYb/wYb/wYb/wYb/wYb/wYb/wYb/w2QNGtJE4
       "], {{{}, 
         {RGBColor[0.5394194000000001, 0.02444500000000001, 0.01345006], 
          EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwNw8eSmgAAAFDXbgQRUWk2LNhwRpRib9goiiKguHY35/xLjjnnmn/MvplH
vX4ZL7fL5frz3fMd+HBDXl/U5494vG4QAN0e2B+IBYIZJI4EQ8kwINQZPALF
Qz8IKJqCY+kYQkZhFABziSRLl8updD1HlQiyks58AGF20K9lc1QSLWB4HsWa
JbpVrtBkqpEv8LU6Q+W5as0TATEwUsSJfpMdtbkv56xOphNemArimOM3M2nA
tp72cdHrK+PJTOyshyOp032fHHk0FpmGNp2d9d1usTysZX2+sFXNUtSjtjFl
5WocjNX6dTxd9sbtYG6l+WmzfVi2s9XvprXsD6aaKpsHEEMDMTiCY74oFERi
AJr0w9FQHIEIPEnlmv0enCLRPBUlCSSTTuSysXRqoirhZAIvFrK1aqpMk3Qp
XSlTTD3fYHL1GlbI/yz+bXREolSsC3y5xVa5NiMKNNus8Rw3HrVHw/3lU5hO
OtKsv1x051JvMecnY3E2Ha5XI3k922jSdrM+GHN9uzL2Y0Ve7HTjelEs034+
zPtt65ysx1072vrZOdyum9PRC0Xm3d7x9XS+3qpt/e7+O71f/wFgNl9X
             "]], 
            PolygonBox[{{110, 45, 35, 155}, {173, 57, 56, 137}, {182, 58, 57, 
             146}, {119, 37, 48, 128}, {128, 48, 58, 182}, {137, 56, 45, 
             110}, {155, 35, 36, 101}, {164, 36, 37, 119}}]}]}, 
         {RGBColor[
          0.6807742000000001, 0.07333500000000003, 0.008702979999999997], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{102, 101, 164, 165}, {138, 137, 110, 111}, {156, 155, 
            101, 102}, {174, 173, 137, 138}, {183, 182, 146, 147}, {120, 119, 
            128, 129}, {129, 128, 182, 183}, {165, 164, 119, 120}, {147, 146, 
            173, 174}, {111, 110, 155, 156}}]]}, 
         {RGBColor[0.822129, 0.12222500000000006`, 0.003955900000000006], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{175, 174, 138, 139}, {103, 102, 165, 166}, {112, 111, 
            156, 157}, {139, 138, 111, 112}, {121, 120, 129, 130}, {130, 129, 
            183, 184}, {166, 165, 120, 121}, {157, 156, 102, 103}, {184, 183, 
            147, 148}, {148, 147, 174, 175}}]]}, 
         {RGBColor[0.8812626, 0.22376740000000003`, 0.015288780000000005`], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{167, 166, 121, 122}, {104, 103, 166, 167}, {140, 139, 
            112, 113}, {149, 148, 175, 176}, {113, 112, 157, 158}, {185, 184, 
            148, 149}, {131, 130, 184, 185}, {158, 157, 103, 104}, {176, 175, 
            139, 140}, {122, 121, 130, 131}}]]}, 
         {RGBColor[
          0.9403962000000001, 0.32530980000000015`, 0.026621660000000016`], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{141, 140, 113, 114}, {186, 185, 149, 150}, {105, 104, 
            167, 168}, {177, 176, 140, 141}, {123, 122, 131, 132}, {150, 149, 
            176, 177}, {168, 167, 122, 123}, {159, 158, 104, 105}, {114, 113, 
            158, 159}, {132, 131, 185, 186}}]]}, 
         {RGBColor[0.9759704, 0.43025060000000015`, 0.041864660000000026`], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{133, 132, 186, 187}, {106, 105, 168, 169}, {124, 123, 
            132, 133}, {115, 114, 159, 160}, {142, 141, 114, 115}, {151, 150, 
            177, 178}, {178, 177, 141, 142}, {160, 159, 105, 106}, {169, 168, 
            123, 124}, {187, 186, 150, 151}}]]}, 
         {RGBColor[0.9879852, 0.5385898, 0.06101778000000001], EdgeForm[None],
           GraphicsGroupBox[
           PolygonBox[{{152, 151, 178, 179}, {134, 133, 187, 188}, {107, 106, 
            169, 170}, {179, 178, 142, 143}, {116, 115, 160, 161}, {143, 142, 
            115, 116}, {188, 187, 151, 152}, {170, 169, 124, 125}, {125, 124, 
            133, 134}, {161, 160, 106, 107}}]]}, 
         {RGBColor[1., 0.6469290000000002, 0.08017090000000004], EdgeForm[
          None], GraphicsGroupBox[
           PolygonBox[{{108, 107, 170, 171}, {180, 179, 143, 144}, {135, 134, 
            188, 189}, {117, 116, 161, 162}, {126, 125, 134, 135}, {153, 152, 
            179, 180}, {162, 161, 107, 108}, {144, 143, 116, 117}, {189, 188, 
            152, 153}, {171, 170, 125, 126}}]]}, 
         {RGBColor[1., 0.7162082000000003, 0.09888454000000006], EdgeForm[
          None], GraphicsGroupBox[
           PolygonBox[{{154, 153, 180, 181}, {163, 162, 108, 109}, {181, 180, 
            144, 145}, {145, 144, 117, 118}, {136, 135, 189, 190}, {109, 108, 
            171, 172}, {127, 126, 135, 136}, {118, 117, 162, 163}, {190, 189, 
            153, 154}, {172, 171, 126, 127}}]]}, 
         {RGBColor[1., 0.7854874000000002, 0.11759818000000004`], EdgeForm[
          None], GraphicsGroupBox[{
            PolygonBox[{{163, 46, 118}, {127, 47, 172}, {145, 46, 181}, {136, 
             47, 127}, {154, 47, 190}, {190, 47, 136}, {118, 46, 145}, {109, 
             46, 163}}], 
            PolygonBox[{{181, 46, 47, 154}, {172, 47, 46, 109}}]}]}}, {{}, 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{163, 118, 145, 181, 154, 190, 136, 127, 172, 109, 163}]},
           
           "0.9`"],
          Annotation[#, 0.9, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{162, 117, 144, 180, 153, 189, 135, 126, 171, 108, 162}]},
           
           "0.8`"],
          Annotation[#, 0.8, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{161, 116, 143, 179, 152, 188, 134, 125, 170, 107, 161}]},
           
           "0.7`"],
          Annotation[#, 0.7, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{160, 115, 142, 178, 151, 187, 133, 124, 169, 106, 160}]},
           
           "0.6`"],
          Annotation[#, 0.6, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{159, 114, 141, 177, 150, 186, 132, 123, 168, 105, 159}]},
           
           "0.5`"],
          Annotation[#, 0.5, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{158, 113, 140, 176, 149, 185, 131, 122, 167, 104, 158}]},
           
           "0.4`"],
          Annotation[#, 0.4, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{157, 112, 139, 175, 148, 184, 130, 121, 166, 103, 157}]},
           
           "0.3`"],
          Annotation[#, 0.3, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{156, 111, 138, 174, 147, 183, 129, 120, 165, 102, 156}]},
           
           "0.2`"],
          Annotation[#, 0.2, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{110, 155, 101, 164, 119, 128, 182, 146, 173, 137, 110}]},
           
           "0.1`"],
          Annotation[#, 0.1, "Tooltip"]& ], {}, {}, {}}}],
      AspectRatio->1,
      Frame->True,
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {1368., -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {360.0000000000002, 291.2461179749811}], 
    InsetBox[
     GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJx1lE1IVFEYhoeBoAiK2rQLpp+NRJADEkUdkZjAwspGqYSwyKRNUmFhqxC0
so2L6YcWRS3Kn7uKyEKGMxCFTItgpEZKuNaQozOBZmOTWVr3nnk/4T10YPh4
uHPPec73c0MnW2qbgoFAoPPfz4tmLU8g9vd5Kyjs+PxLg80708LH67z1Tni/
YQWeX/TWlHCP2U+415xXSR7M4sURfmD4geEHhh8YfmD4geFHeWG2PMAc4QeG
Hxh+YPiB4QeGH9WJ2coLe4A5wg8MPzD8wPADw4/6htmqE+eFPcAc4QeGHxh+
YPhRHzNbfcN14rywB5gj/MDwA8OP5orZ6mPuG64T54U9wBzhB4YfzTmzNVfc
x9w3XCfOC3uAOcKPvjvM1pzzXHEfc99wnTgv7AHmCL//fRf5O8Rzz3PGfc19
xHXjPLEXR+x35k5w2eDFGR3L3WxPFV5LHSPhhaNbt7nWXJxuHq0/XPVV+MiD
9ac6JseFqz82nhvo/iTcVhb5k2oZ0ZFo+cje60mZ9+SPCyuTb58KT7TOlRe/
PJK+Ofas4v7Yh1fC966mn4cWUsJlu852jf7MC9f0uYmd01nh8+sOFe9mM8Jb
VnQ0FOLu0vNM89ATJ23N+cNNYc9T+vVgRavnKbznRdHzlP+/ueR7Lr1/xffU
v0v5nL1t8uvUmvsHcif2PS7mdX3B3H9s+OWtmqmsjraZ+yfimz/Pjmf0+9L9
Kw+sbtgRd3V/6f6LG4a/XXPSumt3zFkVdlXTjcboxjV5nZn091XbzTlqyOyr
Yt/9c5Rj9lXdl/1zdMjsq9YOGP+c2VclzDn6L7cE+O0=
       "], {{{}, 
         {RGBColor[
          0.5907271875589764, 0.24347388652459118`, 0.08011861579389525], 
          EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwNz1m3oQAAAGDXcjG0yBYJcaxxhBRZ2kQqWwm5dvfM65x5n5f5G/Nrx8P3
Az7i+ct8ul0u1783z1v4ww37PqOBIOjxRj79+XiikEQRf4BrUYDbEwv+wOBI
JoJAXh+ORJNhIBEKZ6OxNAS3y5UimqpkcDcQLqWxKp79CIcQPFPP5alSuYxl
moVip1Kla/UGUejVSbbR/FP8yZANIpFEATAFQjzdmw44uT9QuOHV2m2U2Ww4
uu1skWEltq8LoiFKQo9ZTPj1VFHHk6Ukj9odc67e7b2zWh+M5V43jssVmSeG
VHvSpXcLzVIXtqY/9ofn4fg6Ot/O6WJaHhA4rTfnranxgrQ0NHsHoEk/EgFT
qA+GAlEknEx8RuBgLAqlU8kCEclgMJZGi4X2aBjP5xJEPprFRUMPJeKZSrnQ
bOTJeq5eIxrk39bvEtUqtymsXKp02tSQw6uVZp+t92iS6dXobosbNFiG5ifd
ydi6XlhJHEzlsTrnlOlwpjCi0JelyULltYW8Wk7Xq57AK5u1apmCrs3Nrb63
FzvL+X6tT87yeLDvt5Vz3N2u5uW8PX95IXD/uK/kqXF4hx/H1/M/enJffQ==

             "]], 
            PolygonBox[{{102, 35, 25, 123}, {108, 45, 35, 124}, {101, 26, 37, 
             103}, {130, 57, 56, 118}, {103, 37, 47, 129}, {123, 25, 26, 
             101}, {118, 56, 45, 108}, {113, 47, 57, 130}}]}]}, 
         {RGBColor[
          0.8105393461269393, 0.3901337456519234, 0.1278111031351546], 
          EdgeForm[None], 
          GraphicsGroupBox[{
            PolygonBox[{{101, 36, 123}, {129, 36, 103}, {103, 36, 101}, {123, 
             36, 102}}], 
            PolygonBox[{{109, 108, 124, 125}, {119, 118, 108, 109}, {114, 113,
              130, 131}, {131, 130, 118, 119}}], 
            PolygonBox[{{125, 124, 102, 36, 104}, {104, 36, 129, 113, 
             114}}]}]}, 
         {RGBColor[
          0.9020955768782322, 0.566303576086539, 0.29634290522525764`], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{120, 119, 109, 110}, {105, 104, 114, 115}, {132, 131, 
            119, 120}, {110, 109, 125, 126}, {115, 114, 131, 132}, {126, 125, 
            104, 105}}]]}, 
         {RGBColor[
          0.9207144139943777, 0.7212548090445525, 0.5034087688638561], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{111, 110, 126, 127}, {106, 105, 115, 116}, {133, 132, 
            120, 121}, {116, 115, 132, 133}, {127, 126, 105, 106}, {121, 120, 
            110, 111}}]]}, 
         {RGBColor[
          0.9191222865187412, 0.8270806741687126, 0.6867997109180111], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{122, 121, 111, 112}, {107, 106, 116, 117}, {134, 133, 
            121, 122}, {117, 116, 133, 134}, {112, 111, 127, 128}, {128, 127, 
            106, 107}}]]}, 
         {RGBColor[0.912428, 0.879103, 0.810742], EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{122, 46, 134}, {128, 46, 112}, {107, 46, 128}, {112, 
            46, 122}, {134, 46, 117}, {117, 46, 107}}]]}}, {{}, 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{128, 112, 122, 134, 117, 107, 128}]},
           "0.01`"],
          Annotation[#, 0.01, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{127, 111, 121, 133, 116, 106, 127}]},
           "0.008`"],
          Annotation[#, 0.008, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{126, 110, 120, 132, 115, 105, 126}]},
           "0.006`"],
          Annotation[#, 0.006, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{125, 109, 119, 131, 114, 104, 125}]},
           "0.004`"],
          Annotation[#, 0.004, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{123, 102, 124, 108, 118, 130, 113, 129, 103, 101, 123}]},
           
           "0.002`"],
          Annotation[#, 0.002, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], LineBox[{92, 81}]},
           "0"],
          Annotation[#, 0, "Tooltip"]& ], {}, {}}}],
      AspectRatio->1,
      Frame->True,
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {1758.8571428571427`, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {360.0000000000002, 291.2461179749811}], 
    InsetBox[
     GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJx1lFtIVFEUhkcpCunmeAklR0UnHwoNoiB92GLRQwRFFzMpSdMiiBJKDR9E
S0okwTFNrSQdDLQCI8WXrC0UaiQqoSKiQ6YO2ijZaGaNUJ2z51/BOnRgWHwP
znz+/1onMuPqsSxfk8lU8/ejTfWs78R89lR7fImf6/xLgtXfLBCnndSeIeLD
igXY81t7vhI3qe8jbla/l8g8OJMXn/ADww8MPzD8wPADww8MP5YLZ4MHmE/4
geEHhh8YfmD4geHHeuJsyIV7gPmEHxh+YPiB4QeGH9sbzoaeeC7cA8wn/MDw
A8MPDD+2x5wNe8N74rlwDzCf8APDDww/dlecDXvM94b3xHPhHmA+4QeGH7tz
zoa74nvM94b3xHPhHmA+4cfeO5wNd87viu8x3xveE8+Fe4D5hN//3ov8PcTv
nt8Z32u+R7w3nhP34pP+3/Yjxeb9brlheWdJcEUP9Xgwxd2/ku4w3MXeN9Xp
9Z554vLxVHfIPhfxl9WwW/dyZ4gPbJsI2Ng2Tfw4obHx9rfPxCupF/eY4j4R
P1k6cXdxZFSesxXG2KoH6P1grjm1WNvaTdwTeiYuKruDeNjPvBDtthM7wysL
Vj32f3dsrVvelNNBnBy2Mry5vZvYd/BoSG/NAPGVzOuzHxrmiS2l7/0Hk1zE
fS2W+LHJGeKCoWsZU8VO4lhPT+mcdYrYEWFpXeqaIA4tc7b/7HcQ54+Ur/Mz
jxreOyb/Ii0Hup/MvBQtB2Jb7VktB+KXJYFaDsSdkRVaDvR9QRceaTkQN43/
0HIgjnyn5yArvftw07sfyeWqj8K6oNmwhnmZeF/1MR2/42NCkks2b1V9HBpJ
fHV6ckba16o+WnKSG/OKnXJLtOojMOByWZV1So5tV33kvyjKbe2akGPePl4/
jJX2foeM8vZxZ/i0zeE/KvuCjtfOnXeIt+E+aW03XDJLeYgI5SV6lYcYr9K9
xG7lIb4H617igfIQaWt0L+GjPMQuq+4lLykPkRqje8l65SHMFt1LZisPEa+8
5B+WanXo
       "], {{{}, 
         {RGBColor[0., 0.09842419567115454, 0.01665200868714118], EdgeForm[
          None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwNw1m3oQAAAGDXbqQIFQnlkPUou1CJLC2isuTa3TOv8zh/YR7neX7t3O+c
j3z9Ml9ul8v177vnO/Dhjvr88WAI9Hhj/kA+iVAoBgeCXJOJuD2J0A88GsvE
YMjrI+A4CkSQMJCNJ9JQlC3RBSxFZ4haniym8TKR/QDCGbpUzeWZYqmEZxpU
oUWXO5VqnaS61Vq/3vhT+Nmr1d0RAIuAKRCS+oPZYDjt9edD7rIzt/JC7PYe
+4PQ6a4mvC7NtKkkc6M1LyiCuBiNN7P53d6by9XzcHQ2xlHTD6p20jckgo4Y
lm937LVirdZ7RR2zrS/n/D45r+PpZtkeMHI2tlfTMuaypGvK3o5gaACOgSnM
F4WCcRhAEX8sGkrEoXQKIfOxDB7F0yhFsuNRPEsk8zmYyEw1NYwk8VKRatTz
tWquWiHrtb/N30WmWWIZrEDRLZYZcUSZbgz61W6n1utWOu0mN6z3ex2Bb/MT
63btS9PhfDZZLTl5PlrIvak4mEn8eiUo69lGnxubrijIW2NlmaKqLM2detiv
bcv5ehtnRz8d94/7xjnZ95t5vewun14IPDwfqjjVjofj63l6v/4D3clfng==

             "]], 
            PolygonBox[{{102, 35, 25, 135}, {111, 45, 35, 136}, {101, 26, 37, 
             103}, {145, 57, 56, 127}, {103, 37, 47, 144}, {135, 25, 26, 
             101}, {127, 56, 45, 111}, {119, 47, 57, 145}}]}]}, 
         {RGBColor[0., 0.2952725870134636, 0.04995602606142354], EdgeForm[
          None], GraphicsGroupBox[{
            PolygonBox[{{144, 36, 103}, {103, 36, 101}, {101, 36, 135}, {135, 
             36, 102}}], 
            PolygonBox[{{112, 111, 136, 137}, {120, 119, 145, 146}, {146, 145,
              127, 128}, {128, 127, 111, 112}}], 
            PolygonBox[{{137, 136, 102, 36, 104}, {104, 36, 144, 119, 
             120}}]}]}, 
         {RGBColor[
          0.032183541826545876`, 0.4698057612326479, 0.07868910084000144], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{147, 146, 128, 129}, {113, 112, 137, 138}, {105, 104, 
            120, 121}, {138, 137, 104, 105}, {121, 120, 146, 147}, {129, 128, 
            112, 113}}]]}, 
         {RGBColor[
          0.16078735855716428`, 0.5774836657257071, 0.09372786117600201], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{148, 147, 129, 130}, {130, 129, 113, 114}, {114, 113, 
            138, 139}, {122, 121, 147, 148}, {106, 105, 121, 122}, {139, 138, 
            105, 106}}]]}, 
         {RGBColor[
          0.2894149041240751, 0.6851398412933181, 0.10876734745395876`], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{149, 148, 130, 131}, {131, 130, 114, 115}, {107, 106, 
            122, 123}, {140, 139, 106, 107}, {115, 114, 139, 140}, {123, 122, 
            148, 149}}]]}, 
         {RGBColor[
          0.46484043837386957`, 0.7499422504696109, 0.1252385357770607], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{132, 131, 115, 116}, {116, 115, 140, 141}, {124, 123, 
            149, 150}, {141, 140, 107, 108}, {108, 107, 123, 124}, {150, 149, 
            131, 132}}]]}, 
         {RGBColor[
          0.6402659726236639, 0.8147446596459038, 0.14170972410016267`], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{109, 108, 124, 125}, {125, 124, 150, 151}, {133, 132, 
            116, 117}, {117, 116, 141, 142}, {142, 141, 108, 109}, {151, 150, 
            132, 133}}]]}, 
         {RGBColor[
          0.7894446441814624, 0.8821132893137476, 0.17404542765971756`], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{134, 133, 117, 118}, {126, 125, 151, 152}, {152, 151, 
            133, 134}, {118, 117, 142, 143}, {110, 109, 125, 126}, {143, 142, 
            109, 110}}]]}, 
         {RGBColor[
          0.9299097967389907, 0.9503338612222472, 0.21164788468101314`], 
          EdgeForm[None], 
          GraphicsGroupBox[
           PolygonBox[{{143, 46, 118}, {110, 46, 143}, {118, 46, 134}, {152, 
            46, 126}, {134, 46, 152}, {126, 46, 110}}]]}}, {{}, 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{143, 118, 134, 152, 126, 110, 143}]},
           "0.16`"],
          Annotation[#, 0.16, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{142, 117, 133, 151, 125, 109, 142}]},
           "0.14`"],
          Annotation[#, 0.14, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{141, 116, 132, 150, 124, 108, 141}]},
           "0.12`"],
          Annotation[#, 0.12, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{140, 115, 131, 149, 123, 107, 140}]},
           "0.1`"],
          Annotation[#, 0.1, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{139, 114, 130, 148, 122, 106, 139}]},
           "0.08`"],
          Annotation[#, 0.08, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{138, 113, 129, 147, 121, 105, 138}]},
           "0.06`"],
          Annotation[#, 0.06, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{137, 112, 128, 146, 120, 104, 137}]},
           "0.04`"],
          Annotation[#, 0.04, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], 
            LineBox[{135, 102, 136, 111, 127, 145, 119, 144, 103, 101, 135}]},
           
           "0.02`"],
          Annotation[#, 0.02, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {GrayLevel[0], Opacity[0.4], LineBox[{92, 81}]},
           "0"],
          Annotation[#, 0, "Tooltip"]& ], {}, {}}}],
      AspectRatio->1,
      Frame->True,
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {2149.7142857142853`, -152.90421193686507`},
      ImageScaled[{0.5, 0.5}], {359.9999999999998, 291.2461179749811}]}, {}},
  ContentSelectable->True,
  ImageSize->{884., Automatic},
  PlotRangePadding->{6, 5}]], "Print",
 CellChangeTimes->{
  3.461055771768497*^9, 3.461062841177031*^9, 3.461065791490937*^9, 
   3.461065855900181*^9, {3.461065891743836*^9, 3.461065920834627*^9}, {
   3.461065953516238*^9, 3.461065982473227*^9}, {3.461066052803565*^9, 
   3.4610660881378593`*^9}, 3.461291222173319*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\
eJzlfQl0XMWV9rNa3Za12JJtbGO8mwQwSUMghN12s2X+hKHJCglNGENGkL1Z
BiyWAM2S9EDA7QAWZkAQIzARIQhiGmyE7SZAh0QQRED5/2j+KDMjzknPOZqc
njNH/0//yf3vre3Ve11vk40tZ55Ot17Xq72+e+vWvbfq/e26qy77+2+tu+pr
l6xb9skr1mUv+9olVy476ztXYFBsmmXFrrIsq2uZ1Yj3gLf6l/O6hr6mUOgo
u49BrTYB1Yka+7WQfTfiVw3Da+z/xERthoxaHYfxCZbaOkKGTVSBpwbrFBGG
aaFaZRGtQ1QxPFJtombNUPGqMM4z3Ov5tZibstDQ6tlar/ye3cehOtRNgwi5
Qh5y+T6oYGizeFYupEEMMvt09o2IZ1TcOBTzGQzPQF95tEkED/VkoTPfA/lM
GnqHJ1TlqsOQT2Mu6TyUR6s8kwRUygVHAVZnH2CrZojyh7rTLP98IQeFvkFs
GFgniWcwMQRpTJLJYb1zBRis1KyAbGXVh4t5FpzvK0MVYLoIHh/sgXQmDz35
Tsj2Dv81VN05RrIMqJRY+XY5WRipqaqbENFhQA4DGscmjA/kINMzrJqBvQY9
nZ1QHJ1gtSj1DeC3aAbid6IMqWSBWmZNl0nG+llNxuh3dQCSVo7uW0SSajkP
qfygBvk4A1uuyOgbRgb6YbgKlmwF0guIykGpKw09IxNiABKSRETVi5BK91Lc
Zp9sVc2xYflkGsoTWs2RxWSxc/orLD/IWUkoVmoHfs31YZI1rw71IHCLrIbV
kQEoDlftmhsQoSPnf6p8R6CQzUJXV5fVwL4TkM0WYHgC1FUZ6IJkV6mRJWnG
FEXIdrIk4pOFbL5IRMBakUt3wXAN4iL6SLEAndkuO3q2E/L9IzzrahnSyTzh
UfbDeClHhfHHE4OQwn4oV23sDeII5sraCMZYW4tdGejF0Zkpwga6kpArjbNf
x6p4E0iDXZBVbZ3OGtI/UtUaW0S4sxqxFOY+imt9ZJctW+zfQeNQSKWhVFUt
xvHBVuagwnsECkkk+PL4f98Wa6iwWkXYaD+2opehxmoTYQKX7Fe7CdvY+srY
GIyNjWEr6DuB3xWiIahVhqA718m4a1dxtFE1fJwiOpNUxh2dlU73UNVkkonx
iitJHCpCYuEtKbCWyMYPFlKQ5DyI8mOMoGQGeKtqyBjkUp0wWLVljMpQEXKZ
FDYgCf2jteNE1PHKWF0DxnmDodidw263sM8Yz1CD7dNN/FKle3dTXOsmNd6q
zdQoyyqARF05l4K8GeL/XdqsQ0MCegCnmO7BcUFUvM0uoOo8/A+y/Uh96SSb
opW8qGYmbFI3klfvaM3S5xJJX6q2ODMmuwZEkjq2OzFYUCOkiqjavTWEoM70
jjgY1EgRu75rwDpVhNWqI5DHTipWwuZRretUqJYcnKPbyTkOkGrqAyDFtNqE
LWpMDKHkme6j3zKJPsYmCbA6XISBEV7L/gwrTdW+mMsRkLGxo9CF6QpDVXvt
gBLOGMoRSQ5F2YCJkR4mAbIGVLg0OGoLjTWkhcHeTpSlykoaGe1HoZeBF+eH
LFJcYVDVYLi/j8RaIPGgE5FFfaVE8OoQ9A1weWCsDyXkXFml886TL7LGxwYx
vzQhVXV9bRgySo4a4zLVWO1Ar3ndSCncjPZDrodPJ6PFLFhJxnLUCsKAC/MK
Ygy6O9OQTtEihLNd2RZapGSSYoGS7tb4TCPjsQMo6iYxHGvlWHsWeqHQiYLC
cFWiuFYZhp5sCtLYGy16yZmkWP5koKSWYLzkbDrNOLiV6aWG2b2PvVjuzqLc
nWJpe4ZsxHvnSb0/AcMDPZhnhnpf1piE6XRnAXoL2rrtwKtx3Yg0a4WXChm1
0iyUxpyFuwbfNNFUx8flDOlgoVJPskCETVTHoSr0KYeosKrkb4604+NsgtTY
L6YV+p5WQ9r5Mu1EFcZ5Ifu0DF1XJNPq/aL3m33pSrB3DTlt9AvT1EZX8Hwe
0xonKm59SEW3lVRybaAr0bik3MgUXExFxde4K2WWmt7rUEMxHze0eZah6BWG
tLwMs0ZmQ4hnJnXI5bxHekUUpu0gFVEGk+O81zdYEdXzVOjMEh3iUui0imCX
Gk12HzFW4tYZrMdotTZLlG/S082UdTMom1b41HumqLeHkmimHEinVszmUuPQ
g0Sd7+2BzlQXrd0sj6ZK+ZOWI4UU1yQ3sO8YLfMkiDUGWF9Z1RCDymRDmGcG
hcXlOtrjTETiV4UJ58M12SKzukXCUle3tMo+Nau42kWSQRLWByc0dHsq0trU
Y6M+SPaLqfISGCZFjqy8SWU1VsT1QGeRl1TCRXB2wNhY2Tkk0GcRHaOsgGHo
Lw6rsk314rxuut+yHvHBy9PVDizsQgLOqr2UQyQFVUwlFkz4YTE0HiooWQHW
dCsFWAerybNYswaET6GhNSASfh5aLgW/fJokNfarXdVSqdaE9SDm0N0sit7Y
6SrMrSaKO9REQvli2zwC4ov1vCK2UlcKukpiMURrG17lmSo7e/UsW0tibSbL
+LMYTWfV5XTsp7BxqQsYPGKMrcXhHxPsjv0X95ge75A7usIPkOCEO3ifFR1z
0uvkBmTT6rksc/ov7jE93olCtfC/yuCYCp5sy2N6sOUclPCaUHtQUAI4uFEU
hnf8I4NjdnBQ1L+y4IQ7OEyqWN2sZFIcJ4TiuAZD/d2QYZJYF83aTSHGkV9K
bTnDkx7NakvJqz3U06aZSfFlWyluixz1ulcxQ02q4fUq3rhc0LBLaE7VDFUf
v1HFF7MTF6ZoCqxCgWThQaGpHS8xSxu1xjRDyVZXSEjt5oKZkvDrW+BYCEld
I9MpMwl7JuOrjrkIh2LyYS0B8TgELetjXrVyxWszsJbWPQhrCYgnyz1GDqSm
94wZ6+fiRvirdS+HtWhhslxBy8tlN2qr5qQI0xfdRxniLVNh41DMpZH5jiny
MSmcbUGwWke1Hup7E9WqIgwWAiV9aTpwpQTQqilXph5Ka7kW0dXxLSJJOY+y
4EDFTuKWBe3GqfUvLhvtylLjOmn9O8tQMbnaMqltdfhI0jhfkIYYVm2sgvOg
i4B7voCvKQ+T+rUOxgiu8wXE9DyESXOZyMqkPVCrWbOGQKowjH4zdZqNNnPs
gDJafKq3WCYl55feAT5NjfVJHbXkmiZdudRUuHTlsjIe9gkFvPEx6O1Mkr1N
dKPZCqL4tkGTv8K/8nLZ76F/V5o3zd7QKkob6U2r5XuFL+UtpcxxtleRACBB
dvUC6ySmukhRY9r867hcNs+glGZYY1PQl4gG2N3RIeMj3p3xDfpjPT5iu0ET
gJapWhs1JrKbTFoRqanStSIzZHZmlY4pSZtPES3+tVssBqpS7sb2prEUxHzP
kJJ7DHp8G8sOPb6kN5etRPLgyvAAZFNJKAzaGDZZYnTZw21dWGmurJ7EbRNQ
ulzN8NGq4guVYl8vdKa7YGgCNOA6Gif7o1IqsFIp+0yhxOTAmeZaKQ20prHX
RRI/nn10QFq6vHi1FIV0jXZEHr1QJYrmbxP3TGdWwIRV2EgFjDQSeqibFGlo
/heScekON2qm1aq+RIaR/6uQaKRorNtSlqsw2yak2xWqrrS6beZQQxlKRNEs
JVKSohGU5SqxW7OetBvyk0vkIIQdHxJN7ngByJF6rAg+LAnPJOY10XTP+HVr
IokXj0WgCS8SG7rviuIXhkWgxJdObcrFRvOlZk+YM7ZrkjpBC5MTkR7mmmwk
DnSRVkoRHuKrbKYuvspJxkPQNiUJWYpesTaVcMJtu2FX3zkWrO0ZdjsZ3xGy
TxsMYY9oeN0P+FfSrUECUx1oFrGk9VUXsSSAPeRDU5IAQa7Fp4I8aRuMD/W5
7TF8tFEM/eOE0a/X+j5L2xF1qHkZzrApM4YGCaRVe+YWNRQF1PlY1AlFpqht
Plm3+lRJjtpIf7fJKsEvs4eqGLXZTFiMNuL/bEIBUwXuLf5mz5v24sOeI5Xy
TZuHlxrizTTkJ3tsoFAwqcl4H5ndHTliruGqLt53o6X+aP2+42nTWLCMr6CM
j9Tguh/gf6/EU7HbpNkQ3WN0CBRyZlwVJS9SMQU/a3Q8C5Vkss8Spmf0r4Hd
yqT2Ryb1f9boeBYqyQfROr9nMf2ZYCyzYbCvLxIp5B65yUQevIgmVsTd7/LP
hnc5H9sgfrOa4I2opSua8ZlIhhO+89mGumcxVRz9cse/266KeNZqKgfuclWd
7u+qr/oGV/X4s0Z3cTw44cjpLrsmDa5UolDv9iSMdfbOyVHld3BCeYf/t/Y/
rzlYRGfr3Apb7VhdAsKVck+dWolLfJ6+pSaEtxvCOkKGzWSVjEHz+w8pKpoT
Mq2krLFyfzQ2+tI2E2t1GJe73+RjTv/v+7XEP95h18hnFE6fTW8KENDjVscj
kVTPRiURv3muMT1XERZ3ZEX3mKzuWX0N47JGelpRvRkyH0e+rEpv1LfUoyn8
cZNnVqIp3i0z57xJ5tzo6CdV95gqkNcRv6R/oMmJzk9fGRTfqa/0dARs0JK4
pKwFoiTk7ZBNdUJPbw7Swj1lvXwmJXlNOybnaZevrls1Rb/YWrcVxKz4/mb5
AG666abDPOkFl/xDRQ+ybzGT/R/eNrEC42x3nMgHqwD6tQOehGNxVi69fTbA
/Rj/pYtkVZW8APdPgz9usVi85+BR+fxDhmKWyyRmD7sGLUmw4SZUNnR5sWSJ
KpNLoTuPAHY9X9WoBsVOBGaRKaeh1JUkc9W1Ijddb2VvN7J9j21zsfRg5gyW
iUZMNWHADOtoVlNb3esF0BlugLJMXGF1ClUbITEdIWrSOQlmwKdhCcATqxAN
MVmxBtmmV69k4Dnv/Q/D8RBvMOS00lAi15iF3oYaVoN8xOSz9QOTPGIgrD9h
nQ0+LMAqkEumYEDMlEOFJGkoWJpLKdESV770i4GpxYweE8fRVXd+cG0whNkQ
/oQPYi6CE+ATtEnv/fc5XymvdyDmAWzpY8sxShwycJwJMStUOYtVLUJv6bRl
hvMi+bX5ZIOICO2JxS/lwaNn43IhUsPONJAp0kCyi/T8KTHswvmIWDIXL6ib
5McK9azR8YzN3FGC/QtAwIlnBD31Uc8anc+YwBAh2FGA9Ze90/K4O1jMeH4E
FgcuE3/8/adAsmy5+JVysg/RLTeEeTPdVngJfsqmXHY9gkB5sNmO928vcbL6
4+sszma4OSzXlaZkk9dIVMeKoDzoCnKsMDnIRDTa2bxzHPLEOyt2dpJ3enDA
oDDmtpZgCIzpwMTI9WGNIqyxUbVI2WyCCmJaPcbuVtMdx1VMMHOONY4/H/Fg
pcrDxJp5N7QwvLwBJYDfbWUYuvumb/AYW3BC/qcm+Hd4j8X5E/zJ8mfMUso3
OWREhVJQHnQFQcnkfjJpKE1Ab5rkPI4lLvONmqAkS9++HeCYYwAOPZT/x99q
7xo9O/NMgAsv/JGRDywyhDkm9RD8Jaw9boYhrYkP8bY2w8dhGtyIEzq7Nsfh
3++ZbU/ru74Kd8GViJdpMUMWfvzH5AER5MriF9/oyuLy3/BxZXGuC7PQ25dn
60LlMeNqxlptZFesGGGjvcwQzzQqLYZ4cj2gE3yDClI61rCrSSo2qjmKbRmT
ihZttxjPFy+p4jKh5ERogi/AKh66/Tz4SzdW6aGZbPEI//UnWAcn09ogLEp0
X1vpWDAZFxJTWrqCXEh0x4eILMTW7E04PVgY3FLiKXEDSof/ucShLfBmBAze
KzRQYqQa3SNlzyHIxjRRhWGH2Aj+lzMJf8wvw0JzMtaxmmmPmk133hNTM6Sg
A86AeapG/3dTo4DPe+z32bAMToEWE4TsOWk/q3VNLCAsq+CUG2SEBuMmQBOL
YiBotnvY2WUm9Q2vQUd0wx73SHbs9QqrY5B2m7+F5cgimmW4poGKwRpoh7OA
z81h5Vy2Xt8zi6xpkPhs36hmezHTSzav12qpZw8nvEzWssFBHblahJmWIjrN
Rx77tsj2MDINyzHRd1J4ayHN408TxCf4WWPs0sefJpcvAiftSOO/nxmBJpA0
Ko4vuL4JMUzToTHghJehXmIiqMMZTiiykvrCwWASxptX3jO59tuqD7+xvxlH
n8RMeeljfxz2YhZ5P3iM/XJVwhRk/XuFWwQ4JJj3VFh2z9sgEBWXHEP6H9aR
kkPZHNksMfZbk4d7ZIbwE9hs6z/ACQpcb8AmXJXAvp0QlEuNdjyGvR3bNuQ2
G4qXgl+4MQ8wAps3EXhygAbVrwwGknuE4wV+5oZmo7nB4CoedfD/hH/eg2/B
W/Aa+3WAzAZWEwz35cVaVJk2WcyxYhft2eMNaYPaSB+k0j1qinUd8GG0W5pW
9FHh5j3GZtd/T6zxtUXcLYbQ79CySGT7hOYa7m+faBTfhKHfwdssEJ/r0Hof
//TMzesM6dGus4KoC1SvtHT52zTrDv2JuEZVnsl1tlXKEgZySfKoheoYbRNI
A4r3vDcIaepUEvAwhnI8sl46zdCHtpAjHVSMw2wc0jV0l2BNaNRVJVJH4j2b
mZiCiQHpAHkaHmSBynAVY4pTwZeMaPbWZdSd1WNSdn0sKGqSQSIO9506B753
fAfkjuuA2/E//rY+rKYwmY3raCM7m6PkRtgF+JmHn/kx6zD3bGdJNXadrbTY
xZkBnd8h7c7azmrwMGLuEaMyqUhXe8EBmU1YXrNcdYo/v5jGFJ0uOPTC3b5w
qOcX+qk+0RVa5rR0ESw+yr4T8MNT5sDDZx8MOy9YAs9+YRH8+DOHwMZT5nzI
R9+lH5Nk4iVJ9h0H69RmHLIW/n8uAxD2qiefUQxaO1hA2YDHBiCdzEBXNkVr
GGmecODIbBVlmpBKtWY0ruwxnsQSWoMTs0By91iuoBV6M+MUETSf7Q3VvEQl
rY2ugHNZoIbK2+EyuZwKzaTCOWOoodm7zhjGbOmyUT2dEAxbzlkIb16ynH0G
vrxEIhupa7IOGyC31BsdNj4ieOICdirPyYj5T7aC9ek2sE5vkfg/1Hearcml
mW0i5b9waiVo81VdDfqzSUgXylIM1HbPg4dZE7MYhr7uLujM9dl7EFn9TTRg
T7tM3WxPp5bT6KDZG+IOe4MAmeXWEkfe5CQhSVus0vlo2iKJ/ONRziQfE1Ep
ifxvw6eQKGKOLMMhPxb6fJVG1f7DBOBvjzfAjfyDOKVvLFULS4iw2+INilgW
hvBLCSp/lRAGiN/nT5gNP/3cIbD13IXw0gVLMD+kEfx+4fzFTFAgAWFFCCeW
uMOJxUEbLOXhDO1tJDFwyeEg/KxGwjilmf9P4ecsJI6zBKGc1sLjIQmtcHu/
4LKo3NvrtvuykqsjZSiPTuj0UB4YEhVz7KwHD1ut4s5Dvbh6zvJNiyZl6p7P
GM7VjjCyWFzlEndYWQReLW/L3SSMLv9SgZHhYRgeGYFyXxaSnT0wOj7hb3SR
hESufZ+BD8uKyT67AMWa49UG1frkZsHGAVHX7CCJ5QezpkFhlgV3zCQFFH3H
4M6Z7Df9V2Hfx9+34+e7SDqLAoQiU7l0EXkcLk6moenjKUEg2764CEoXLoXB
i5fBG/h5Ge+JUOj+efyPxGSaUZSwpB3CYhKWDpPnR53ZyieNteyD3bWmGRlE
4uJ2SPwdfr7K/1trW3gUFML9JhPk7+NDdTZwfrASbd51bNvnV70xG6WuPCQp
rDfP9EZlQ79BBKoIa+A+nb4noX6Kvs3su1vvAlop5fI5yLJD6lJQKI5EnWK4
0Yn5BeiUcQ6slHaq0FPMcpWxg3P5kckGJJMtC3ANutDCwd26gFY4j+PvnvkW
5JAsbog3HOLpTuNbEl02YUxH1rkQXkRZ6g1BDEQYRCDbrzoVWeju9WswHc0s
FIZLTaOsJYlRP67FJE8dJtedKD4l/h7hf+EsjJfobMd6rLhuLiy/Zg4s/c5s
SKybBdaJM/jsgjPHSh+ykDptZuwXodyCLqzvIA8G6x7mb/LqTqWYo7ytV/DX
U3CIN0GAnCMRUifX2EWwRUSDujNRglsB3zEZixyU8l0wQIHDBTorJbQ1VoL/
b+AQJAB2JIAOfjLCpkAdWhoR/A4GZXf+4eJESoI8QfypIxvgxaMa4vCzjzYg
09v20Qa6U59tLJSeNcKPj5wGm+dZcDOniIUuryGfQo9gKG6DJz97CLx60VJ4
+9YzCfGwu2stvHXLmTB656fgvQ1nw9jdn4aXr10LxfMWsbh3nDgbW+lUtDiP
eNEbRqidztGOTH85InzpFbNhxfVz8DMXVtwwF8Gw4oY52J6lV82GZf8wGxov
mAnWCQz5HPW6Rob5RohdCP2dKehmKuQKCk5pwMX7nrDxUM4H/zFuEjSMwvsa
+pYesyKM/YrG/TuiGyLZxDwCOazc8GA3pHNlTXz1w3waOftJwgNBw/xqmMnI
ATww72+A5Pw8rsBNCH5hTSO8fmYci9yVou/S6XG6kx9kuqfFY+xZAnZi2HOr
Y/DgYdNg00EK6QeHtF1wJj9Twfzpb5+koP37O/8H/Dp3Bryy+Ruw7a6L4Z3b
zoQXr17NJgOSkgonz1kR0vTB+fosG+nr58Dqe+bDSf84D07dMJ/dr753PqzB
z6k/nA8n5g+CJdkORHsb5/PzxOrAzOPnixGqDvVCZ7YbetlCcijuqglMAu9+
ZwdMDHebBAlvvDfZcApvXfO2rzZ77fZkcclHhM5pSxcGo3L3L8HHcO3MpHsd
6dpaIDR3NxnWDhPHGOuYfynVCDs/Px3eyjS1Qvn8JmSLr53XBC9+bjpsPTEG
W46YBt02vK0FkfA9S+H7BWTh/3bXp+EXD30Ldt53Gbz5oyz875+sh3995jp4
6d5LGWvf8Q+nwnaU8q8/th3uxWXx8kggb68DOQH84ocWwt9tPhgueXghfPUR
vH/gYMjcswCOvw2B/p0OztYJ6PNjy71xLl+7oR9rtOcg9/QikZpYl7BgQtMZ
9N2g12fPjcd1mykl5kZ6M5DMl20cBq5iL0Wp5BNc76MDmlawtJJVGXmuYo9U
d1wamV4H3lcRrbsva4HfXNmG5Pn6t1oxr19+u5Xu2K9G9t0Mr9thsBPjP3V2
An5ych3C5xt8EI7wAPMLha8iZ7gR/vjcd+F3fdcwUP+vH18Npe6vweBNp7Nl
7c++cAjcclwHB7MrXy6HdNQDtzAfLuo+GO7athRu3boYbn1iMdy4ZRGsQzAf
f9tcBlzOpRG8JzHwWsuMTnKhheiEly+Lsgo4p2575j5dIdDfbcXXqKjZjqPq
2tcj1/w4r6YOMULd1+BMT4hF45nNRtj9AqFUun4m/PaOdvjVrbPgjdvaE3SD
6+zBW9vxMwt+ecss2H3DTOi/aAY8l07AU/WIQ+kxCk9tr4Mh8dPK2z+FHVvv
hNeevQfKP7sXXn3gG/DGI1l47foU/Pw6h5i8LBJbnW1EJ7HRG3+0CDbuWAaP
78CV54+XwS2PL4ILNi6AE24nGQIl5kwbR+jJM2ituNSbve5v9x0JQ23mNi7M
1tC3a6loAr33DuzwsBa7N1igBmsyHxHiZefsGaxneML6l7lZULpjNvz2gbkY
a3DjHOz8X22cA7vys+HZK9vg+UuavfB8UCQ4T/eE88tPb8R+xjvSRm+7j8H5
5/d/Hd5Azkri8A5bHF4aCdJzPCGde2wR9DyzAra9fhg8WlwJDz+7Aq5Hpkuw
ZowXmW78gll8ITiH25+WBFlZE/xthClbGTCFXYukFFE31XuSgmWbXsmVqEHs
tdOU66HNseFM/k/APcoFTaMMzRMgokzhzdyJCl4vIOrvmwd/eHphE4qrC5G5
4y28/tB8ePbGdth+DSeGbR7Mfa6nPNHhifxX+n8Ivx9+FbY+ci8M734Edv1k
A7zz+JUOQXnHl5igbC31lCv8Yb4F4b1j5xHw9m+Phu0vrYL7n1wON/QshC9v
nIccfA6DekLTeSyp80JphfGxMRgeHkGZoBeX+1koj8oV2n51VWpRaddKkDk2
b7mcBvxQahZfQp0A6XNOLgTw/jJsNyPcYuD3Qri3j5NzGvVWbzfD5vZp0IuU
8JMjp0FxdSMMfC4Buy5rhtJ3Z8LufAfsvPcgeGvL/Bkw9uxCjE6UUNo0D36F
Yg4RDC0dd53WyAhpK2ZzxywLroo3zA06UNhQM7rsaaKD2X/IFvTza9dC+YbT
4JXNX2fSzu6nNsCbrxXhxZ89Dq8+cw+8u/thJoi/teVyRiyvogRUyiwhYrNM
80TYw4nV3PHJVohfOIsJ4STq0Ery89+bB1dvOhi6UQx6YeAIePPtJAzsPhIe
e2El3N63GC5+cCGccvc8pkaPXzyLW5dOafabO3DayGWzkMnl8D8/erGzMKAO
0bGmjrPXGvrmNlXnJhe8j2pSmsxZnRgopsc8ZHCFUgnv1SwJTvdqdhEc0aIO
idDbaA2Ttl4tN+E9heLE9kMseOyIBnjqFKQgnE+eW9cML1zTCttxMbF940Hw
cvdBzTD48HwcwncfXwAlXFcQ0dFstROJ7pmPOIjOMlHdUSGrR5dOfeTYQxS4
a/1qKF27Bl574JtMGPsFCmZEgW/vfAjee/NJ+M3OHkZ9vxbU98p1/tSn6mN4
l6KJCg+XixJJhd/qgONvmQtfQuq69p8WwqYnlsEzzx0OL5VWwc7SkfDUyx+C
254QFHiXoMB1igL9CDCOwOqDAiOlISa/TcCU9pJbQ99MtT/dkIsf2UXfTjoB
fWkLuvhLBaFMs3Zp3F8nJEVLoqp/gRHmbqFTGhEhBApv9ksjjIKDXYUjAgmr
DXbc3g4v39FBK5sGGPzhnCa6w+XGb77fDru/1uJFWbZMd1TY2qwSa3eio+J5
9XT0q+e74fXnNsGLT9wJ27Z8D0aevMZEQ7a0J7fTm95UqRcrNEySXL7NyeX8
u2xyeWTbStjyHF/sbCgu9SIVowRIV39XF5RGSpBJ2ebPD8qLbk+oxZYIpfQn
nrJfJpJxm3wncbLuK2TqTwlRlzcu3TMcdn6KC3gRebwCz6lnRD7HmlW+pjlp
mcjG7wwr17TEqafJSD3Fi5thx/o2mn8aUPJrbyBtV5zukNzeuK2d7tjnrctb
mW3Bi4RcjDcZvpp0EUGtEjoET7J6+DuYYvTpa7GvSH8QfkryfKem6YC6VfK9
dYLMFn/TJrPrHlzYQLox7EyaiG5+dBFctvWQqJNRE++K2gjk6BUwqW7b0+AD
dMgL67TqwtunDSn8pp/IjhRIVTQldZcrUKuUmc4O00+Gqh6FH6hn4mCnyFTl
c0SYi6pWCRuGg6pO5lT1wiXNuNJqwSF8/dutmO0bFzTB82uiEU5wTegiyB/p
QTjlB7+FK6crUNT8OsLilc3fwO7Ydd9lzCYdRDi8Gv7v+zNRz5HSHUNSj5Tp
NsxjtruL7j8Y0617YCE28Su4ylqzaX4E0lHePyM97I0DVIv97Ztnkt6YHSVm
4/MD3BJefo+xAQvZQj6fg0L/kNqq5umMYRMNV7PJZ2KnjanOtgOG/qYvr4PA
hKcGt1ArAlnFp53nzk2QSboRXjtvegOZqWN0h+XhLd2xXw3sOw6vnBGHp1xr
oTnKrfuosHX5iPDi1kmEPI52rV+Doe/cdhYWT15JkiSWKC9ueQqux5v4GrQi
XPMGIv+EW+fCSXfOg5Py82Jw8p3zsKwTv3cQrLjOKY0tdvts81OgIzjYTRK7
vntmApRea8QTuY9HeGTzXQ2T0xkHe2vM8PTWIHuPJV53bRIv/ehAGmLksx9A
lsKii2SB55nJyeMjwmNJp42nkTa2rabQXadx/6QGuiNknsbCxC/6boTnkw3w
6PyQMlioc9bsfUA2nexevwZ+c+tZpHjDMl+7ns6u+sUNp8Gv1i0LVAOYXtxn
UgN8VG5705Rx5KW37Oo5WOby9fSN97qyzWeKCOO+F9qS3gZBSiyDwkpbspl0
1mzDTxin1EhuHVKVUR0pYj2pvgMwWtU2tXqv4hPKvi6fCTO8Cf/1BxMGHeYm
If9R4YFKkH8BIb8VIf/jVdPamZdpDJ482GLbEcIpu/zPjiNMJsXLvyWSybq4
/UuLE2Rswaj0U75Rd3EYXVbdEDhBnJTbEQjEX5kF8YsQrJe0J2gDAkZNYBDb
vYORFu8XHzz/A69qJhVQXUNBsX3nqUgOM8xkGH/Yswhk2PjYKFQmnOcThGX2
tKvtKwh5+YyAjwQQltnbRhjTyXNHaSB/EUH+CHLoxxZgqY8vINAtQMkY7/B2
I7LtKxrZVjUuzzhcnc2ZHy1wSpAmU+Pz5y/GnF84n/BM25AdeGYp5Huh9X6N
afmJjQJ/00pYpc0CtHPm0g4KO7FZvdF5kfkcx73tQhfwjilcLhu0L0aMpngT
oU4xFFYaD+vgITFFZ2d9Fg5XzzJwHOEsLKZMTh1HCR5ISHp89jTo6ZiG3U/f
fC+kjDd7Lx+wokDxqVa+v/AsWsDSNweKAxRmLraMd3/oOdbvRVk07Ab1gGWL
9pEG255jV6pK+s2Mp0ArO5RfPqNBxsH2nxmn4BlZkSnR7zAsIU66lpxGSmQA
aLR7dO9t43e+nTGabV6OrjwMUz77FI70qdAaiWz37LAr2Qq9tdKmu7886OQ4
Bq2o2NjGeE/Wl7q3LcNjpQKk0jnoi24ZlsNNGw1pv5V8RkOPENgTLr1vj7eS
wmiupwey6SyUKxwhU9gHTVrlPdclnuw7zMF5k7F2/gcUkkno57Y96EmRRiVg
H7cEED8+1X7BD4EJQTWlZwMcnUoJx1+8z7pa1t5tvX9du9SbmQOE+bW8DPaU
H3CmHw/zQW90pq1uA9jaHKYhvkR7lZAjRuU958FHmJQonxGMEE77cKohK1g+
qwQt/m7l3qnohMQGPCHP0A4/uJPbxUubITot3vJ8aSyyEPFVWM3O1JXPaJRx
tKOuJw/QM+7iUCpkId1dholaBXpQLEzmB6eyY81aMWxSbS18neX9B2+vGYeR
PhS0rCx0Y89l8gPh7TWXwznsOCr5jGC3Dk72t9ccKsbCdNxdaIz5JqcrCGam
U/IiTWKjA7z8rnwecoV+EKLP1DjjKcXDQFojgxS70Y/7/U+25CoM80bmSSyP
cNyvBFAOuRUZO+QzOsYJQRVd9+U6I894wqJ3PLd6qu5gPI8ZLKY6JKe0kx3S
aQLsa2oeY7SWw8ADJHv1bOByN2SyBQbqdBcT8MMJuHTc87EaPggriBl/Adc+
nGjc93Ai/1MXzWnpCnqNSNBJQf7TF7uqI1DIpKAz3wuDY9X97lIQrAPx1ndE
X5VHPwjY1sJEFZaegYeZq458RmDbDDdHZ0AHHNRkdJJrxiq899rY9wdv5pda
vSC9i0HHovFjVlocPJDl0qxGwMRv4HUXJtgrcCczKdUf32e/mvJjAfGkw4ea
lNxjLeK5XDX2sr3Z30xXNekujFKAvWgO+1IK/w17crDo4G73YOEAhjEVhzqa
y/v1daHO2/IWQYPPzQp8Y90HYJf1fElNg+h1g+rBON5h3TRNU4t0KaD+5UvJ
Gr11ck/4fULEJnhcfjd/9+GxPozDhEWPk6UiAcYzOV1BgKk7cCo8YPbTISMu
XYbN3taKPOVKl/b1mnb3Smj5LV86INApButUzNNGtwz0lUd5ZZ06/UkhqfPR
L8rZIiyS9tYbqvbW4Rtx0+rfm4PHvDa4mgZq8ruCROyJMgMU/2l88Zz/MkIf
qwueP4O9yN5jrKaOflwewK8Ma9Kutv9fQDNhWvR7YsVyO+Vw1ASRtzdqEl7K
cqUcrpYhnRQKL7Pu3AhtPzqnJednXzuOVgW0OohE5/sRRU3i3NgM9OAinRnn
hBpwChvnYuKZQV9gHDfbVhdNg5HwUsw7gcR19V7vv4sKJFKUnv3rI6XOax9O
GNjqYRy9TiGnj3SnINUj9jdPlRe/uEQ6lt/pPC0ELfDkROeh+1aDOqFxB7Mq
XFtY+Q0l6bnP+P0Sqf821W7KvKGObTXugWSuhHPrINPk6mxwqtjYJuu8YdZd
S2UkvVBobAhbL+1uZmf9qKRMJrXVf5wrX195oMwJXLnYl+Ejnszzl3pNYdtY
tL1+fnMK7dOowEBPFpJpbXujU1etsR4/aZLOhj3pT23szdcnwYwQ0uQes+8a
jg2ttvM9echkCjD6ARub9mQMXQdf+xugTJOCZC0mR+uwFEquVMf/V5N0sTpQ
KLQJpbM8JLmEDUP5lBJSpuBO3OjSV1g3ZjmKdOz+cf8nLk9jjqatiUO5kGbh
8tPZJ47xddHj0SHjO49HSKCYWnDEtzr7lPuKBynT6xyGIZvpgt4+lHHT/DCS
/W3faRP97fK98JTOJsmm/TW6ctC/DMfAx2sN8v3P/ux1pUpaNb3YUHffClbQ
hcqGLn9FXRyGcJ7JFbmeaWSgH4ar5s3JIdUAnDeyc/n3gXGGg6HF7SHBHno4
xFouqwKT4/wPvTAdeeah9w17aKsE0DeRVxz7/6axXWSXQios17DtNurVh5Ow
5ZnT0hWk3WXrq64M9I5MRNXu7iWbT7sYec39gV3evqs172W5Jwa8BThax0VV
5FZQwOGZId1h14F+Uaicgk1IoaX4sX+2mI7nZlgXFikyTH/BoW6Rkxa+YwLi
uS18tCLJpTrtF2ebLXwRjD9HiTB6FTm9ih7/W7MMrVxqSCstM7rdUakCzco1
ExhOkI27+mqqPBuUBH03wp/FHT79Mz2hGL4AmYzaGNiqJZvOc6G5Ogz9xeFw
amN2ZsdfLKY+7oW7w8xEcWJYslj57j8HkQRPQ8F50OXFTlQeVZsWSNbP9Na/
w2AvGY1mhgxrE2GERArH/wqNk8nPD6EeWjtPhDZTlaR92rI+bIgXSgkd05XQ
atKnrSsZoTwNu5SRvFMi8A0oRbRXxqGYy7lftBcZjEF50BUExtF+lBUG2Zvr
oZi1cIUzGBWMy+hfg2D02nN5r6QHV7hHsLR+6cEyp+BnUUsh/kuPtm+PUsre
qMGkm68NDAvTZDbjjGBWqNrTmOc8wCcCesg+HpNCvbbXV4Uf01X4CmqVgRyp
tmSMSZEhQHhjrzqvs1Kqe4Wf30I0KL77nD4SHLozSR4fRaOSFMx8DMiXUoDk
vrorSkw2MbyuNJqeLpqiHpei9mxI6sdOGKnp8lG7oSBTmGmmcQ7uNMfgBuU3
U9XAdjhlr6Njv6KvHMxp6QryApyoVp276cNz1ftE9HrXkroTPfZk5T8pXT2M
QL6rl93XxvjWz0Fpbo7ONv3S+fLOfZNkhikJ+y/7dk8auA87Jpq5y86a3mV8
z6lzzvPUotpRxauFz/OG9UOiEnUqZMYGzxZP/fdE+Dm5m4wJlVIBkkITmCmU
1C6aK8AKMgNgvneeOBuuO6adXjhhfdFgFaAepbcvz2X/MYqLp/dq3S7bZOJa
HSHD9iStyYFbKfWRyqtic+UjWtpgqCR0fqj31xc8IWMnYadE2P33BW/o9Irh
32c8ZCo9OwCq74TaS1pYMISmOyDkgpH1eU8c2enEaSMOWvx8AJiuodBddOfJ
AGKiaL06nzNwgZg8DEUr/nNuVsAq8s+ROsYpa5hq89mQ1i1TDT/r3UEs7F2R
Tw25tZD1om859Ugr29RoaNNnfLSxNY1PmbSxjYZ2fiagne+w+zgMdZOdKQP5
Qg4KfYO2x6XHcsA/fsLQsnPrlgjVoW5Wp1whD7l8n2srRcLQmnONuJJtAG4i
YlepKw09I06//zCahaA85NiZWpj2PSOtptYM47TkMxzLJM7GrGt1OmAMfyvy
4X7w+ho4uN3HBKSV7Z1uaO85hvbK/CoDXfIMBaOZabqhneeEoslGqKDEnmOv
QU1C/2jNXna1iQbqjW7dg7AWr3gs6GNB1WkS/bPxlDms3+hXgwijLOVZZK17
ENbiFc9RxVplCLpznSxWlzjVUlRRDMMCMRT4q0GGkeAoTrJq3cthLW4DgjbA
fOE5UsyRS6gmInsomQ7s4IQ7eN8V7dSm2Vu/XH2vST56/KnWkQfMIHlmJlnn
+EgR0smcrWFzjVSEQZ1qHTn1BsnZXyapYri/j7R7QHb0TtpdJi2hF1KSoyPF
Iv+FAWEQ7s9oXq8XulmhkmkqJcim05Ai5pnpZUe5bgjzjNSvnWlI09sTLG6/
vVzLX2e1cqv0RkPYD0WY7hOh52Nf1+yPUGva/wcmXFEB\
\>"]],

Cell[BoxData["0.4898847943311435`"], "Output",
 CellChangeTimes->{
  3.460774172693623*^9, 3.4607742141360817`*^9, 3.460774259371611*^9, {
   3.460774303149437*^9, 3.460774333742992*^9}, {3.460774503977763*^9, 
   3.460774525387253*^9}, 3.460774568669429*^9, {3.4607746433678713`*^9, 
   3.460774749289826*^9}, 3.4607747872637367`*^9, {3.4607752069957323`*^9, 
   3.4607753311834*^9}, {3.4607759195524397`*^9, 3.4607759422690763`*^9}, 
   3.460775994534586*^9, {3.460776028795376*^9, 3.460776037081739*^9}, {
   3.460790911595224*^9, 3.460790939253276*^9}, {3.460791053594666*^9, 
   3.460791071141541*^9}, {3.460791192973082*^9, 3.460791203957177*^9}, {
   3.4607914471303043`*^9, 3.460791466955147*^9}, {3.460791545117042*^9, 
   3.460791571021545*^9}, {3.460793419216103*^9, 3.460793427190727*^9}, 
   3.4607934904166403`*^9, 3.460793537586506*^9, 3.4607935875115547`*^9, {
   3.460793643816039*^9, 3.460793651412258*^9}, {3.4607937028316803`*^9, 
   3.460793717693026*^9}, 3.460794349054253*^9, 3.460794468602188*^9, 
   3.460794537146944*^9, 3.460794606820025*^9, 3.460794647441045*^9, {
   3.460794683999979*^9, 3.460794711587779*^9}, 3.4607947437033663`*^9, 
   3.460794821453476*^9, 3.460794992763452*^9, {3.46079537866004*^9, 
   3.4607954008420343`*^9}, {3.460795899955226*^9, 3.460795915535334*^9}, 
   3.4607959607567463`*^9, {3.460796100730474*^9, 3.460796117431126*^9}, 
   3.460796273298979*^9, 3.46080016267494*^9, 3.46080059045927*^9, 
   3.46080191058669*^9, {3.460801947033931*^9, 3.4608019584551563`*^9}, {
   3.460802135491241*^9, 3.4608021585180397`*^9}, 3.460802633967609*^9, 
   3.460802693048126*^9, 3.460802784188271*^9, {3.46080281423518*^9, 
   3.460802852551197*^9}, 3.460802900679997*^9, {3.460802966464355*^9, 
   3.460802994747815*^9}, 3.460803081703266*^9, 3.460803125487102*^9, 
   3.460803183227213*^9, {3.460803234859148*^9, 3.4608032609697237`*^9}, 
   3.4608033212142887`*^9, 3.460803381478054*^9, 3.4608035021140633`*^9, 
   3.460803635652215*^9, 3.460803697315674*^9, 3.4608037348572693`*^9, 
   3.460803769573984*^9, 3.460803809928953*^9, {3.4608057984622173`*^9, 
   3.460805813824176*^9}, {3.460805968711471*^9, 3.4608059901127863`*^9}, 
   3.460806044738928*^9, {3.460806111860417*^9, 3.460806138661484*^9}, {
   3.4608062551082487`*^9, 3.460806284064145*^9}, 3.460806807365871*^9, {
   3.46080840200484*^9, 3.460808428085409*^9}, {3.4608084903745604`*^9, 
   3.460808509880398*^9}, 3.4608085615495157`*^9, {3.460808596715098*^9, 
   3.460808614316525*^9}, 3.460808667778009*^9, {3.460808756743518*^9, 
   3.460808821361974*^9}, 3.460808866006637*^9, 3.460809008335636*^9, {
   3.4608090829662027`*^9, 3.460809106371428*^9}, {3.4608091533817453`*^9, 
   3.460809170247486*^9}, 3.460809387484213*^9, 3.4608094563846188`*^9, 
   3.4608095239938383`*^9, 3.460809556860118*^9, 3.460809601486121*^9, 
   3.460809659738999*^9, 3.4608097239935083`*^9, {3.46081085410987*^9, 
   3.4608108667828493`*^9}, 3.4608109499384403`*^9, 3.460811028337473*^9, 
   3.46081107221124*^9, 3.4608163531812773`*^9, 3.460816462080289*^9, 
   3.460816636079851*^9, 3.460816733529152*^9, 3.460816810327259*^9, 
   3.460816896707574*^9, 3.460859466583232*^9, 3.460859525199936*^9, 
   3.46085957856656*^9, 3.460859612027454*^9, 3.460859642696507*^9, 
   3.460859673379051*^9, 3.4608610359199123`*^9, 3.460861080130123*^9, 
   3.460861176214602*^9, 3.460861206909174*^9, 3.4608612527872066`*^9, 
   3.4608613245925083`*^9, {3.4608613893716373`*^9, 3.460861402077552*^9}, 
   3.460861433808834*^9, 3.460861482995883*^9, 3.460861622874538*^9, {
   3.460861766989231*^9, 3.460861788062501*^9}, 3.460861837558749*^9, 
   3.460861919837391*^9, 3.46086202490096*^9, {3.460864063005273*^9, 
   3.4608640925582657`*^9}, 3.4608642675973377`*^9, {3.460864595153369*^9, 
   3.460864678530854*^9}, 3.4608647161716623`*^9, 3.4608928885197763`*^9, {
   3.4608929272834787`*^9, 3.4608929785836067`*^9}, {3.460893064106246*^9, 
   3.460893113794902*^9}, {3.4608931965264177`*^9, 3.460893221096546*^9}, 
   3.460893257519649*^9, 3.4609459317505836`*^9, {3.4609459653975143`*^9, 
   3.4609459931714287`*^9}, 3.4609461850150833`*^9, {3.460946221971449*^9, 
   3.46094625037241*^9}, 3.460946287032295*^9, {3.4609463329038773`*^9, 
   3.460946475537898*^9}, {3.4609465106640263`*^9, 3.460946554340445*^9}, 
   3.460946745286201*^9, 3.460946846249963*^9, 3.46095277278576*^9, 
   3.4609547879814377`*^9, {3.4609693962841597`*^9, 3.460969479832581*^9}, 
   3.460969518067926*^9, {3.460973376833108*^9, 3.460973436855947*^9}, {
   3.46097976178686*^9, 3.4609797783289747`*^9}, {3.460979815577437*^9, 
   3.4609798918056097`*^9}, 3.461033363239642*^9, {3.4610394977541027`*^9, 
   3.461039513242825*^9}, {3.461039546024946*^9, 3.461039584057582*^9}, {
   3.461054619262939*^9, 3.461054635771722*^9}, {3.461054666119218*^9, 
   3.461054724280589*^9}, 3.461054772684753*^9, 3.461054837077591*^9, {
   3.46105489942374*^9, 3.461054926726182*^9}, 3.461054971946405*^9, {
   3.461055759572901*^9, 3.4610557703433237`*^9}, 3.4610628397680902`*^9, 
   3.461065791475391*^9, 3.461065855853307*^9, {3.461065891722114*^9, 
   3.4610659208089657`*^9}, {3.461065953493973*^9, 3.461065982458634*^9}, {
   3.461066052787819*^9, 3.461066088122064*^9}, 3.461291222435852*^9}],

Cell[BoxData[
 RowBox[{"-", "2.1423370471155216`"}]], "Output",
 CellChangeTimes->{
  3.460774172693623*^9, 3.4607742141360817`*^9, 3.460774259371611*^9, {
   3.460774303149437*^9, 3.460774333742992*^9}, {3.460774503977763*^9, 
   3.460774525387253*^9}, 3.460774568669429*^9, {3.4607746433678713`*^9, 
   3.460774749289826*^9}, 3.4607747872637367`*^9, {3.4607752069957323`*^9, 
   3.4607753311834*^9}, {3.4607759195524397`*^9, 3.4607759422690763`*^9}, 
   3.460775994534586*^9, {3.460776028795376*^9, 3.460776037081739*^9}, {
   3.460790911595224*^9, 3.460790939253276*^9}, {3.460791053594666*^9, 
   3.460791071141541*^9}, {3.460791192973082*^9, 3.460791203957177*^9}, {
   3.4607914471303043`*^9, 3.460791466955147*^9}, {3.460791545117042*^9, 
   3.460791571021545*^9}, {3.460793419216103*^9, 3.460793427190727*^9}, 
   3.4607934904166403`*^9, 3.460793537586506*^9, 3.4607935875115547`*^9, {
   3.460793643816039*^9, 3.460793651412258*^9}, {3.4607937028316803`*^9, 
   3.460793717693026*^9}, 3.460794349054253*^9, 3.460794468602188*^9, 
   3.460794537146944*^9, 3.460794606820025*^9, 3.460794647441045*^9, {
   3.460794683999979*^9, 3.460794711587779*^9}, 3.4607947437033663`*^9, 
   3.460794821453476*^9, 3.460794992763452*^9, {3.46079537866004*^9, 
   3.4607954008420343`*^9}, {3.460795899955226*^9, 3.460795915535334*^9}, 
   3.4607959607567463`*^9, {3.460796100730474*^9, 3.460796117431126*^9}, 
   3.460796273298979*^9, 3.46080016267494*^9, 3.46080059045927*^9, 
   3.46080191058669*^9, {3.460801947033931*^9, 3.4608019584551563`*^9}, {
   3.460802135491241*^9, 3.4608021585180397`*^9}, 3.460802633967609*^9, 
   3.460802693048126*^9, 3.460802784188271*^9, {3.46080281423518*^9, 
   3.460802852551197*^9}, 3.460802900679997*^9, {3.460802966464355*^9, 
   3.460802994747815*^9}, 3.460803081703266*^9, 3.460803125487102*^9, 
   3.460803183227213*^9, {3.460803234859148*^9, 3.4608032609697237`*^9}, 
   3.4608033212142887`*^9, 3.460803381478054*^9, 3.4608035021140633`*^9, 
   3.460803635652215*^9, 3.460803697315674*^9, 3.4608037348572693`*^9, 
   3.460803769573984*^9, 3.460803809928953*^9, {3.4608057984622173`*^9, 
   3.460805813824176*^9}, {3.460805968711471*^9, 3.4608059901127863`*^9}, 
   3.460806044738928*^9, {3.460806111860417*^9, 3.460806138661484*^9}, {
   3.4608062551082487`*^9, 3.460806284064145*^9}, 3.460806807365871*^9, {
   3.46080840200484*^9, 3.460808428085409*^9}, {3.4608084903745604`*^9, 
   3.460808509880398*^9}, 3.4608085615495157`*^9, {3.460808596715098*^9, 
   3.460808614316525*^9}, 3.460808667778009*^9, {3.460808756743518*^9, 
   3.460808821361974*^9}, 3.460808866006637*^9, 3.460809008335636*^9, {
   3.4608090829662027`*^9, 3.460809106371428*^9}, {3.4608091533817453`*^9, 
   3.460809170247486*^9}, 3.460809387484213*^9, 3.4608094563846188`*^9, 
   3.4608095239938383`*^9, 3.460809556860118*^9, 3.460809601486121*^9, 
   3.460809659738999*^9, 3.4608097239935083`*^9, {3.46081085410987*^9, 
   3.4608108667828493`*^9}, 3.4608109499384403`*^9, 3.460811028337473*^9, 
   3.46081107221124*^9, 3.4608163531812773`*^9, 3.460816462080289*^9, 
   3.460816636079851*^9, 3.460816733529152*^9, 3.460816810327259*^9, 
   3.460816896707574*^9, 3.460859466583232*^9, 3.460859525199936*^9, 
   3.46085957856656*^9, 3.460859612027454*^9, 3.460859642696507*^9, 
   3.460859673379051*^9, 3.4608610359199123`*^9, 3.460861080130123*^9, 
   3.460861176214602*^9, 3.460861206909174*^9, 3.4608612527872066`*^9, 
   3.4608613245925083`*^9, {3.4608613893716373`*^9, 3.460861402077552*^9}, 
   3.460861433808834*^9, 3.460861482995883*^9, 3.460861622874538*^9, {
   3.460861766989231*^9, 3.460861788062501*^9}, 3.460861837558749*^9, 
   3.460861919837391*^9, 3.46086202490096*^9, {3.460864063005273*^9, 
   3.4608640925582657`*^9}, 3.4608642675973377`*^9, {3.460864595153369*^9, 
   3.460864678530854*^9}, 3.4608647161716623`*^9, 3.4608928885197763`*^9, {
   3.4608929272834787`*^9, 3.4608929785836067`*^9}, {3.460893064106246*^9, 
   3.460893113794902*^9}, {3.4608931965264177`*^9, 3.460893221096546*^9}, 
   3.460893257519649*^9, 3.4609459317505836`*^9, {3.4609459653975143`*^9, 
   3.4609459931714287`*^9}, 3.4609461850150833`*^9, {3.460946221971449*^9, 
   3.46094625037241*^9}, 3.460946287032295*^9, {3.4609463329038773`*^9, 
   3.460946475537898*^9}, {3.4609465106640263`*^9, 3.460946554340445*^9}, 
   3.460946745286201*^9, 3.460946846249963*^9, 3.46095277278576*^9, 
   3.4609547879814377`*^9, {3.4609693962841597`*^9, 3.460969479832581*^9}, 
   3.460969518067926*^9, {3.460973376833108*^9, 3.460973436855947*^9}, {
   3.46097976178686*^9, 3.4609797783289747`*^9}, {3.460979815577437*^9, 
   3.4609798918056097`*^9}, 3.461033363239642*^9, {3.4610394977541027`*^9, 
   3.461039513242825*^9}, {3.461039546024946*^9, 3.461039584057582*^9}, {
   3.461054619262939*^9, 3.461054635771722*^9}, {3.461054666119218*^9, 
   3.461054724280589*^9}, 3.461054772684753*^9, 3.461054837077591*^9, {
   3.46105489942374*^9, 3.461054926726182*^9}, 3.461054971946405*^9, {
   3.461055759572901*^9, 3.4610557703433237`*^9}, 3.4610628397680902`*^9, 
   3.461065791475391*^9, 3.461065855853307*^9, {3.461065891722114*^9, 
   3.4610659208089657`*^9}, {3.461065953493973*^9, 3.461065982458634*^9}, {
   3.461066052787819*^9, 3.461066088122064*^9}, 3.4612912224462013`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"IndividualLikNonlin", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Y", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"IdioNonlin", ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<GH\>\"", ",", "m"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0", ",", 
     RowBox[{"onlynorkorr", "=", "1"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"IndividualLik", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Y", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"Idio", ",", 
     RowBox[{"{", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.460264864897327*^9, 3.460264932378791*^9}, {
   3.460265489300803*^9, 3.460265492492799*^9}, {3.46027038606568*^9, 
   3.460270391802556*^9}, {3.4602704971596107`*^9, 3.4602705817118692`*^9}, {
   3.46027367414145*^9, 3.460273674236417*^9}, {3.460279775378045*^9, 
   3.4602797754444103`*^9}, {3.4602799530257587`*^9, 
   3.4602799533811693`*^9}, {3.460280067013379*^9, 3.460280067130088*^9}, {
   3.4602801040742397`*^9, 3.460280104129944*^9}, {3.4602801453821163`*^9, 
   3.4602801673531218`*^9}, {3.46028174693688*^9, 3.460281763776168*^9}, {
   3.4602818356559362`*^9, 3.460281835739462*^9}, {3.460281898670804*^9, 
   3.460281898732609*^9}, {3.460282025318959*^9, 3.460282025741701*^9}, {
   3.460282062175247*^9, 3.460282071535883*^9}, {3.460283778391947*^9, 
   3.4602837888805027`*^9}, {3.4602838305963707`*^9, 3.460283854615387*^9}, {
   3.46028477341341*^9, 3.460284779157151*^9}, {3.460285035206752*^9, 
   3.460285046973556*^9}, {3.46028555906642*^9, 3.460285574425418*^9}, {
   3.4602857519094887`*^9, 3.4602857519715776`*^9}, {3.460285881590439*^9, 
   3.4602858816380377`*^9}, {3.460286117999454*^9, 3.460286123654068*^9}, {
   3.4602863340289307`*^9, 3.4602863377475977`*^9}, {3.4603641927287188`*^9, 
   3.460364197580667*^9}, {3.460365058304535*^9, 3.4603650587979116`*^9}, {
   3.460365091217347*^9, 3.460365126318194*^9}, {3.4603652464521227`*^9, 
   3.460365260029804*^9}, {3.460365412299954*^9, 3.460365434375272*^9}, {
   3.460365485584791*^9, 3.460365520950554*^9}, {3.460366663535665*^9, 
   3.460366678997499*^9}, {3.4603667867732773`*^9, 3.4603667868283587`*^9}, {
   3.460367092714067*^9, 3.460367098883337*^9}, {3.460369235357655*^9, 
   3.460369263924768*^9}, {3.460369362646221*^9, 3.46036936313859*^9}, {
   3.46036946785526*^9, 3.4603694691077127`*^9}, {3.46037339069245*^9, 
   3.460373390747698*^9}, {3.460373605599341*^9, 3.4603736056503153`*^9}, {
   3.460377091108459*^9, 3.460377126962656*^9}, {3.460377288435691*^9, 
   3.460377301095058*^9}, {3.4603774697122087`*^9, 3.460377479788327*^9}, {
   3.460377585320611*^9, 3.460377603716568*^9}, {3.4603776957101793`*^9, 
   3.460377736561165*^9}, {3.460377923292104*^9, 3.4603779233524303`*^9}, {
   3.460378105932313*^9, 3.46037817981962*^9}, {3.460427531315346*^9, 
   3.460427537420005*^9}, {3.460427638978484*^9, 3.4604276390230217`*^9}, {
   3.4604277414332314`*^9, 3.460427769573126*^9}, {3.4604279604982853`*^9, 
   3.460427960554902*^9}, {3.460430680071252*^9, 3.460430680172152*^9}, {
   3.460430712203142*^9, 3.460430712557424*^9}, {3.460430775931464*^9, 
   3.460430776020101*^9}, {3.460430814349124*^9, 3.460430814950081*^9}, {
   3.46043100067663*^9, 3.460431000775926*^9}, {3.460431035518139*^9, 
   3.460431043615539*^9}, {3.460431139283386*^9, 3.460431139330926*^9}, {
   3.4604311987514153`*^9, 3.460431233744923*^9}, {3.460431314274002*^9, 
   3.460431314321568*^9}, {3.4604316727142878`*^9, 3.4604316728008432`*^9}, {
   3.460431886035831*^9, 3.46043189177104*^9}, {3.460432099991972*^9, 
   3.460432100073539*^9}, {3.460432236204804*^9, 3.4604322362468243`*^9}, {
   3.4604323376555843`*^9, 3.460432357162323*^9}, {3.460432403219545*^9, 
   3.460432403269651*^9}, {3.460432564446265*^9, 3.4604325911495867`*^9}, {
   3.460432813689516*^9, 3.460432813733564*^9}, {3.460432944239506*^9, 
   3.460432989199974*^9}, {3.460433097024789*^9, 3.460433097139295*^9}, {
   3.460433291653358*^9, 3.46043329173923*^9}, {3.460433672964451*^9, 
   3.460433673010107*^9}, {3.460433845665332*^9, 3.4604338457416363`*^9}, {
   3.4604344009903316`*^9, 3.460434401033557*^9}, {3.4604346235115023`*^9, 
   3.460434638473834*^9}, {3.460434675871023*^9, 3.460434675925946*^9}, {
   3.4604350413113747`*^9, 3.4604350414069347`*^9}, {3.460436666989565*^9, 
   3.460436677468376*^9}, {3.460437023691847*^9, 3.460437023772811*^9}, {
   3.460437179838045*^9, 3.460437214787621*^9}, {3.4604373750456057`*^9, 
   3.460437375101828*^9}, {3.460437455923118*^9, 3.4604374559862347`*^9}, {
   3.460437643282413*^9, 3.4604376433404827`*^9}, {3.460439284564681*^9, 
   3.46043929340877*^9}, {3.460439393566842*^9, 3.460439393962884*^9}, {
   3.46044000098571*^9, 3.460440001044331*^9}, {3.460443930270521*^9, 
   3.460443930334333*^9}, {3.460443966799687*^9, 3.46044399790462*^9}, {
   3.460444060284606*^9, 3.460444061730588*^9}, {3.460444101336812*^9, 
   3.46044410138903*^9}, {3.460444186536171*^9, 3.460444194286351*^9}, {
   3.460444233408099*^9, 3.460444248920389*^9}, {3.460444338058318*^9, 
   3.460444355662019*^9}, {3.460444400012597*^9, 3.460444431012135*^9}, {
   3.460444591036777*^9, 3.4604446631572647`*^9}, {3.46044479971354*^9, 
   3.460444799768903*^9}, {3.460444831583193*^9, 3.460444859781989*^9}, {
   3.46044502143334*^9, 3.460445021504759*^9}, {3.460459950502769*^9, 
   3.460459971711813*^9}, {3.460460068419449*^9, 3.460460088588605*^9}, {
   3.460460154598343*^9, 3.46046015516997*^9}, {3.460460281436612*^9, 
   3.460460281521656*^9}, {3.4604604120265713`*^9, 3.460460412125514*^9}, {
   3.4604607607833633`*^9, 3.4604607621971283`*^9}, {3.460460826677142*^9, 
   3.460460827186878*^9}, {3.4604608962826014`*^9, 3.4604608963501987`*^9}, {
   3.460460962965583*^9, 3.460460963358262*^9}, {3.46046100555375*^9, 
   3.4604610220017967`*^9}, {3.46046105589403*^9, 3.460461056004932*^9}, {
   3.460461154113535*^9, 3.460461154227416*^9}, {3.460461800671767*^9, 
   3.4604618154025*^9}, {3.46046184541817*^9, 3.46046186011173*^9}, {
   3.460461896620476*^9, 3.460461896672694*^9}, {3.460461952952413*^9, 
   3.4604619533933907`*^9}, {3.460462913572587*^9, 3.460462920740217*^9}, {
   3.460722765559946*^9, 3.460722812479978*^9}, 3.4607228582030888`*^9, {
   3.460722890758842*^9, 3.460722896366596*^9}, {3.46072298397585*^9, 
   3.4607229875994997`*^9}, {3.460723019415843*^9, 3.460723105990931*^9}, {
   3.460723170191799*^9, 3.460723171657259*^9}, {3.460723268211129*^9, 
   3.460723287189331*^9}, {3.460732937278017*^9, 3.4607329553868093`*^9}, {
   3.460733072671542*^9, 3.460733072733719*^9}, 3.460774164086339*^9, {
   3.460774203297064*^9, 3.460774203437456*^9}, {3.461039595388352*^9, 
   3.461039613321471*^9}, {3.461054996653363*^9, 3.461054998922916*^9}, {
   3.461291237699194*^9, 3.461291243911721*^9}}],

Cell[BoxData[
 RowBox[{"-", "130.67065249419358`"}]], "Output",
 CellChangeTimes->{
  3.460722864185832*^9, 3.46072290251231*^9, 3.460722994070681*^9, {
   3.4607230259705276`*^9, 3.460723109644692*^9}, 3.4607231775830717`*^9, 
   3.46072323370262*^9, {3.460723272758277*^9, 3.460723291255953*^9}, {
   3.460732942792966*^9, 3.4607329605671864`*^9}, {3.460733023995452*^9, 
   3.460733076751679*^9}, {3.460773704975284*^9, 3.460773732666801*^9}, {
   3.460774198834483*^9, 3.460774204426446*^9}, 3.460775349894099*^9, 
   3.46079373659339*^9, 3.46079546775951*^9, 3.460796169538375*^9, 
   3.460893268111524*^9, 3.460946028605698*^9, 3.460952788972106*^9, {
   3.461039601034769*^9, 3.4610396141931953`*^9}, 3.4610550030981007`*^9, {
   3.46129124912394*^9, 3.461291257642768*^9}}],

Cell[BoxData[
 RowBox[{"-", "142.32054698335017`"}]], "Output",
 CellChangeTimes->{
  3.460722864185832*^9, 3.46072290251231*^9, 3.460722994070681*^9, {
   3.4607230259705276`*^9, 3.460723109644692*^9}, 3.4607231775830717`*^9, 
   3.46072323370262*^9, {3.460723272758277*^9, 3.460723291255953*^9}, {
   3.460732942792966*^9, 3.4607329605671864`*^9}, {3.460733023995452*^9, 
   3.460733076751679*^9}, {3.460773704975284*^9, 3.460773732666801*^9}, {
   3.460774198834483*^9, 3.460774204426446*^9}, 3.460775349894099*^9, 
   3.46079373659339*^9, 3.46079546775951*^9, 3.460796169538375*^9, 
   3.460893268111524*^9, 3.460946028605698*^9, 3.460952788972106*^9, {
   3.461039601034769*^9, 3.4610396141931953`*^9}, 3.4610550030981007`*^9, {
   3.46129124912394*^9, 3.461291257655499*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["Theta"], "Input",
 CellChangeTimes->{{3.461291629521944*^9, 3.46129163362153*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.5`", ",", 
   FractionBox["1", "100"]}], "}"}]], "Output",
 CellChangeTimes->{3.461291634941413*^9}]
}, Open  ]],

Cell[TextData[StyleBox["Wahrscheinlichkeit",
 FontColor->RGBColor[1, 0, 0]]], "Text",
 CellChangeTimes->{{3.461291753077998*^9, 3.461291762894685*^9}, 
   3.461292757050872*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"p", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"CDF", "[", 
      RowBox[{
       RowBox[{"NormalDistribution", "[", 
        RowBox[{"0", ",", "1"}], "]"}], ",", "1"}], "]"}], "-", 
     RowBox[{"CDF", "[", 
      RowBox[{
       RowBox[{"NormalDistribution", "[", 
        RowBox[{"0", ",", "1"}], "]"}], ",", "0"}], "]"}]}], "//", "N"}]}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"tab", " ", "=", " ", 
   RowBox[{"Table", "[", "\n", "   ", 
    RowBox[{
     RowBox[{
      RowBox[{"pp", " ", "=", " ", "0"}], ";", "\n", "   ", 
      RowBox[{"m", " ", "=", " ", "mm"}], ";", "\n", "   ", 
      RowBox[{"th", " ", "=", " ", 
       RowBox[{"{", 
        RowBox[{"0", ",", " ", 
         RowBox[{"R2", " ", "=", " ", 
          RowBox[{
           RowBox[{"10", "^", 
            RowBox[{"-", "i"}]}], " ", "//", " ", "Sqrt"}]}]}], "}"}]}], ";", 
      "\n", "   ", 
      RowBox[{"lik", " ", "=", " ", 
       RowBox[{"IndividualLikNonlin", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"1", ",", " ", "1"}], "}"}], "}"}], ",", " ", "X", ",", 
           " ", "miss"}], "}"}], ",", " ", "th", ",", " ", 
         RowBox[{"{", 
          RowBox[{"IdioNonlin", ",", " ", 
           RowBox[{"{", "}"}], ",", " ", 
           RowBox[{"{", 
            RowBox[{"\"\<GH\>\"", ",", " ", "m", ",", " ", 
             RowBox[{"10", "^", 
              RowBox[{"-", "16"}]}], ",", " ", "Infinity", ",", " ", "0"}], 
            "}"}]}], "}"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
           RowBox[{"2", " ", "Pi"}], " ", ",", " ", "0", ",", " ", 
           RowBox[{"onlynorkorr", "=", "0"}], ",", " ", "\"\<StochLin\>\"", 
           ",", " ", "0"}], "}"}]}], "]"}]}], ";", "\n", "   ", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"beta", ",", " ", "gamma", ",", " ", "sigmazeta"}], "}"}], 
         ",", " ", 
         RowBox[{"{", 
          RowBox[{"h", ",", " ", "dh", ",", " ", "sigmaepsilon"}], "}"}]}], 
        "}"}], " ", "=", " ", 
       RowBox[{"IdioNonlin", "[", 
        RowBox[{"th", ",", " ", 
         RowBox[{"{", "}"}]}], "]"}]}], ";", "\n", "   ", 
      RowBox[{"fac", " ", "=", " ", 
       RowBox[{
        RowBox[{"Det", "[", 
         RowBox[{"2", " ", "Pi", " ", "sigmaepsilon"}], "]"}], " ", "//", " ",
         "Sqrt"}]}], ";", "\n", "   ", 
      RowBox[{"probb", " ", "=", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"lik", " ", "//", " ", "Exp"}], ")"}], " ", "fac"}]}], ";", 
      "\n", "   ", 
      RowBox[{"{", 
       RowBox[{"mm", ",", " ", "probb"}], "}"}]}], ",", "\n", "   ", 
     RowBox[{"{", 
      RowBox[{"i", ",", " ", 
       RowBox[{"{", 
        RowBox[{"1", ",", " ", "2", ",", " ", "3", ",", " ", "4"}], "}"}]}], 
      "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"mm", ",", " ", "3", ",", "50"}], "}"}]}], "]"}]}], 
  ";"}]], "Code",
 CellChangeTimes->{{3.461291318661893*^9, 3.4612914009741507`*^9}, {
   3.461291448527267*^9, 3.461291516924535*^9}, {3.461291574249786*^9, 
   3.461291675146378*^9}, {3.4612917069908447`*^9, 3.4612917135480537`*^9}, 
   3.461291768398279*^9, {3.461291805019306*^9, 3.461291963161377*^9}, {
   3.4612920413225117`*^9, 3.461292152456047*^9}, {3.461292200465069*^9, 
   3.4612923030506067`*^9}, {3.461292350452606*^9, 3.461292461834962*^9}, {
   3.461292509442893*^9, 3.461292517932618*^9}, {3.4612926033884363`*^9, 
   3.461292605309628*^9}, {3.4612926435184*^9, 3.461292677609016*^9}, {
   3.461292848230349*^9, 3.4612928483249807`*^9}, {3.4612928887582684`*^9, 
   3.4612929278509073`*^9}, {3.46129488989615*^9, 3.461294915561386*^9}, {
   3.4612950367377462`*^9, 3.4612950998600407`*^9}, {3.4612951299074087`*^9, 
   3.4612951300131893`*^9}, {3.461295187198097*^9, 3.461295192633041*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"p", "^", "2"}]], "Input",
 CellChangeTimes->{{3.461292820678709*^9, 3.461292821315103*^9}}],

Cell[BoxData["0.11651623566859805`"], "Output",
 CellChangeTimes->{3.4612928221164207`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"plot1", "[", 
     RowBox[{
      RowBox[{"tab", "[", 
       RowBox[{"[", "i", "]"}], "]"}], ",", 
      RowBox[{"GridLines", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"None", ",", 
         RowBox[{"{", 
          RowBox[{"p", "^", "2"}], "}"}]}], "}"}]}], ",", 
      RowBox[{"color", "\[Rule]", "i"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", ".15"}], ",", ".40"}], "}"}]}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", "\"\<UT, kappa=-1,...,5\>\""}]}], "]"}],
     ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "4"}], "}"}]}], "]"}], "//", "Show"}]], "Input",
 CellChangeTimes->{{3.461294156805501*^9, 3.461294165792803*^9}, {
  3.461295005246236*^9, 3.461295057602653*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {RGBColor[0, 0, 1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{-1., 0.11980696857153508`}, {0., 0.08862643046306863}, {1., 
       0.19026889704998842`}, {2., 0.2758551846708179}, {3., 
       0.35106154437618636`}, {4., 0.28335341491626764`}, {5., 
       0.3225995213721428}}]}}}, {{}, {}, 
    {RGBColor[0., 0.980407, 0.6039], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{-1., 0.1612291370944794}, {0., 0.17215532684639484`}, {1., 
       0.03185412766026787}, {2., 0.056996803998033155`}, {3., 
       0.0782763406117104}, {4., 0.09687860785263432}, {5., 
       0.11367799665330794`}}]}}}, {{}, {}, 
    {RGBColor[1, 0, 0], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{-1., 0.054748666832827676`}, {0., 0.05894075239825487}, {1., 
       0.09518246946506774}, {2., 0.09727969406823127}, {3., 
       0.1488316667397159}, {4., 0.22500225689363637`}, {5., 
       0.34053362338846777`}}]}}}, {{}, {}, 
    {RGBColor[1, 1, 0], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{-1., 0.01770749997074635}, {0., 0.019120107526416158`}, {1., 
       0.031209125087210226`}, {2., 0.04687302905824932}, {3., 
       0.04515412873521021}, {4., 0.0676913739957699}, {5., 
       0.10192482136688033`}}]}}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->True,
  GridLines->{None, {0.11651623566859805`}},
  PlotLabel->FormBox["\"UT, kappa=-1,...,5\"", TraditionalForm],
  PlotRange->{{-1., 5.}, {-0.15, 0.4}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellChangeTimes->{{3.4612941586935472`*^9, 3.461294167816228*^9}, {
  3.461295006621718*^9, 3.461295060057968*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"plot1", "[", 
     RowBox[{
      RowBox[{"tab", "[", 
       RowBox[{"[", "i", "]"}], "]"}], ",", 
      RowBox[{"GridLines", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"None", ",", 
         RowBox[{"{", 
          RowBox[{"p", "^", "2"}], "}"}]}], "}"}]}], ",", 
      RowBox[{"color", "\[Rule]", "i"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", ".15"}], ",", ".40"}], "}"}]}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", "\"\<Logistic function\>\""}]}], "]"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "4"}], "}"}]}], "]"}], "//", "Show"}]], "Input",
 CellChangeTimes->{{3.461293124337718*^9, 3.461293184412599*^9}, {
  3.461294237504272*^9, 3.461294276939712*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {RGBColor[0, 0, 1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAGIQDQEcDns9xXkuXTlhD+ELOITH3eCbunY/lC/icPzO
kjzhXQegfAmHPbrrdE07rkL5Mg4liz5HRBSeg/IVHLrS5914FncByldyOBuW
v1/yzikoX8WhP2XxhK2fz0L5ag7m7wuU0nJh5ms4GLyM8d1SB1Ov5fB40ebp
HAkw9+k4bD5w2dBOBcbXc9i3e91ThuKjUL6BwzK2LI0/b2DuMXToOBJqfvEI
TN7IQdPlgeDuT2egfGOHlpOTYywOweRNHGYtN3OdehEmb+pg+s792h7B01C+
mUP67uWZeV9g8uYOkX+EUlnEYf6xcNDbdeC+T8NJKN/S4ZhA8uSyXph+K4c9
ghq12t9g+q0dMvrK9kYvhMnbOOgbP7u4Qx/Gt3W4WeIrnScJU2/nsHX7jI3q
02Hm2zs0OAadZ/x4Hsp3cHh4wZLLxxAaPg0ODtJ7K40X/4CFh6PDPp7bMxW+
HYPKOzoktVbnG+2Aud/J4ePNE92lb6Hh0eDkUNv+5ei+Apj9zg633t9LyIiH
6Xd2WNC0Pl2gEuZeF4cHGW/WBy6G6Xdx4LbdeU78F0ze1eHq48fGofeOQOVd
HUr3dQkazoWZ7+YQ7t/+Y4kjTN7NQZwlo076PEy/u0PT5c9PlcVh8u4OPlWp
Eq5HYPIeDn/NOLYvnwiz38NBYVKU1P8ImLynw9PJpwND2U/YAwAQheG6
       
       "]]}}}, {{}, {}, 
    {RGBColor[0., 0.980407, 0.6039], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAGIQDQEcDmezfq3nMVlqD+ELONxr6HM09T8G5Ys4JP5Z
fm7Psh1QvoRD61tL39Nmu6F8GYdTP330fu/cBuUrOPAq6XBkTNsC5Ss5KGvc
eqfmAOOrOBgJSfcFztsI5as55PY4xwvs3gnlazjMDd4Xd8JtD5Sv5aCr7Jsv
I3oIytdxUEhOT1/psAvK13OQXO66Y9esfVC+gcOW5T02xath7jV0aIt2eXhx
Hky9kcOBr3xc1wq2Q/nGDn8tNmsn7IDxTRy+rTJaYGcG84+pw+/98XMFF2yF
8s0cFvOUVjrUHITyzR1M71Vee3Mbpt7CYfaf9/+1bY9C+ZYOnFO4bF+qwvxj
5bDscOn5L5WHoXxrhwBF+eUVB2Dus3HQf9R2Y94VmPm2DstONUzmmQoLHzuH
e1fNbYvqDkD59g6mjeUmU3bC/OvgsOU5U6HXOmh4NDg4WK8wuLlMHSbv6PC0
4z//sa1Q9zQ4OogeXXGlwBgm7+QQdWk981M2aPw2ODn4r+WTfckPs8/Z4VhI
8Xn1o1D3NDg7/GSVcgs3gfnPxSHXa/OK5s8w810cetukWdk0YPpdHf41ZFdL
rd0PlXd1WCNfzlJdDpN3c+Bdt1B7/mKY+90cfq47nFI/Baqewd0hpOnF07rm
vVB5d4d/Bw1U9RRh8e/hsOqaaHR3Lcx+Dwctw2OpW8/C3OfpwFnsZjKpf7c9
AGdm1to=
       "]]}}}, {{}, {}, 
    {RGBColor[1, 0, 0], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAGIQDQEcDgJxfDkbTxywh/AFHFL33ol99/sYlC/iMHP1
uS+PLh6G8iUcQsxWL5iotRvKl3F4t+lM5Y3PR6B8BYdV+ypjftw9COUrORzc
NG0B08pDUL6Kw4qOWzs8nGDyag59O4UOe2jAzNdwaOF+MtnlA8w9Wg4Hqxxm
OnyB8XUclld6JKUshfH1HF5YnYt96rMXyjdwaPjYr/UsECZv6JBxyOVNtcMu
KN/IIXSqTFbRq/1QvrHD8bgJF1qjYHwThzw2mX1JO/ZB+aYOn30LuWVqYfJm
Dir2B81PVcL45g4TvH/XV/LD1Fs4PBZVkHKbArPP0mGf1OxrWW/3QPlWDkv9
bZ57Tt4B5Vs7rFS386n6DwtPGwcmKaPfS+dsg/JtHZTyL+4SMYPJ2zlcObTU
X9lnK5Rv79C9n/nX0zaYfQ4OB6wzas/nQs1vcHC4JbV1mczrnVB5RwcOqVtf
+hdB3dPg6KBWIcX2/CVMv5PDg6uufQlm0PhqcHK49Ym5bPM2WPg6Ozhc/8bC
+w0afw3ODg+tXiaY/IDpd3GYcZ1F76AvTN7FQXhG/YudgTB5V4eNpvFbmNZC
46fB1SH7UZCTVj8sfNwcWPVf/lGWhsm7OfxY+b3v/RaY/90ddCw+9S7Uh4Z/
g7uDtMgOmcoFMPM9HLZkv114wAkaHw0eDtu+9qtMiofJezocWTLbijtnrz0A
2mzgsA==
       "]]}}}, {{}, {}, 
    {RGBColor[1, 1, 0], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAGIQDQEcDvqLwthvBiyzh/AFHBTZ0j7qTF8D5Ys4KC/c
eFhGYR+UL+HwrFtm8vLLB6F8GQdtp6NeThqHoHwFh/V5L15Jr9kK5Ss5RBzM
aSuKPgDlqzhMKigTeR23A8pXc5BbYyPRow3jazjMF7+ctEV6F5Sv5fBhy6PD
ERx7oHwdh3fnWu9u5NsN5es5+ARf/vFOA6bewOHH7d3rxMph8oYODEavLht9
guk3cnBaYcSR1AyTN3aQ8Lj+cEMZzH4TB/VzqfdZbsHMM3U428HRI2y2Hco3
c2A5uX29bibMPHOHAxMLjDjPbYPyLRxSeL5duLkPFj6WDurbpG4r1sPkrRxk
Sk/3TloHCw9rh/29WbnhtjB5G4cHuq+e6R+FhbetA+dJd7XdTDB5O4c4FYWl
+2bD7Ld3aP9x7+QDRpj7HRysxWIUH/yCur/BweFqwYMZxVNg/nV0aNivsDHU
H2p/g6ODAJPV7XMnYPJODiWHFlXm9++Hyjs5BPY2O5Tr7YTKOzvYqUWscveC
uq/B2eFCQKnlpDcw+10cuFXaGC/r74XKuzh4dhYUtcbA3Ovq4PHRrM3EEspv
cHW48NRm5sYLsPB2c/CvMRJ5FA91T4ObwxbpmiLvozD73R2M7RxC1s+D+c/d
oXdv9PaKhbDw8nAwCbBeWfcRqr7Bw+GlZ6TsvASofxg8HdQSbhSHhu60BwCM
mNSh
       "]]}}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{10., 0},
  DisplayFunction->Identity,
  Frame->True,
  GridLines->{None, {0.11651623566859805`}},
  PlotLabel->FormBox["\"Logistic function\"", TraditionalForm],
  PlotRange->{{3., 50.}, {-0.15, 0.4}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellChangeTimes->{{3.4612931139377623`*^9, 3.4612931456627274`*^9}, 
   3.461293185588668*^9, {3.4612942603250523`*^9, 3.461294277498468*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"plot1", "[", 
     RowBox[{
      RowBox[{"tab", "[", 
       RowBox[{"[", "i", "]"}], "]"}], ",", 
      RowBox[{"GridLines", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"None", ",", 
         RowBox[{"{", 
          RowBox[{"p", "^", "2"}], "}"}]}], "}"}]}], ",", 
      RowBox[{"color", "\[Rule]", "i"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", ".15"}], ",", ".40"}], "}"}]}], ",", 
      RowBox[{"PlotLabel", "\[Rule]", "\"\<Step function\>\""}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "4"}], "}"}]}], "]"}], "//", "Show"}]], "Input",
 CellChangeTimes->{{3.4612924444073343`*^9, 3.4612924536864433`*^9}, {
  3.461292563566168*^9, 3.461292580984879*^9}, {3.4612927023957243`*^9, 
  3.461292708498749*^9}, {3.4612927616034603`*^9, 3.461292838197135*^9}, {
  3.461292869930532*^9, 3.46129287527043*^9}, {3.461292955649438*^9, 
  3.4612929556945753`*^9}, {3.461294386144854*^9, 3.461294394697747*^9}, {
  3.461294437532996*^9, 3.4612944489945993`*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {RGBColor[0, 0, 1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAGIQDQEcDnnaQV6zk47ZQ/gCDoyOtfYVgvuhfBEHfUNN
meOtML6EQ7pPul5ox1UoX8bhpVx+1K2gC1C+gsOttTtuPouD8ZUcNPrTRZkv
nofyVRzeeNhd6yo5B+WrObyKWZWWchVmvoaD2aENLp11p6B8LYd+C+e1i2+e
hfJ1HNYdMJm3deNxKF/PIWLf94UnN5+G8g0cln5bXrlHCmafocOB2b/jP0+9
DOUbObzLMJjh9+kMlG/scLIsrzTg6hEo38RB/U/ahyMtMPtMHX69kmc1VIL5
x8zhZtHBpYJvjkL55g4z5oh5JRyGqbdwkJt4ZKfEOpj5lg7n436lSWyAuc/K
wezc/lZjVph6a4cuebZrvjIw9TYOoSt+zjmqD1Nv6yC/7IJDkArMv3YO54M3
XFabfhLKt3e4+3Ae428+WPw5OKy/ILPIxfAEhN/g4NB6mfWcLA+Uz+DokJFw
MfHdV6j6BkeHnA97jmx5BfOPk0NsooNw+T0ov8HJwWhVS79hMcx9zg471osJ
OrfA9Ds7pMvuD9MtgbnXxSHweTJHyDyYfheHa8HnRV/8gYWfq8M0v51rZc5B
w7vB1UFO51vFp3aY+90cPi39vuW4AEzezaG6d6PQjR6Y+9wdYlne9XxKPgyV
d3d42JtrL28A0+/hwP7iveO0o4eg8h4OczgcGHYth7nf00FS8NWefzbH7QHP
Q9+3
       "]]}}}, {{}, {}, 
    {RGBColor[0., 0.980407, 0.6039], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAGIQDQEcDpa72l65r7lgD+ELOChPKDnj738Myhdx2Pqz
pPx3Dowv4XDy9BWf02a7oXwZh4CMtWkP+w5A+QoOGl79m1KnbYHylRwYM3Iq
387fA+WrOIQc4K+WKN0I5as53D2UvbnNbT+Ur+FwszFj4jRvmHoth+bkvgUW
U7ZB+ToOqc2XFm+x2wXl6znwVWXZVAvA7DNwuH5PPDxv+Q4o39CBcc+yaZK5
+6B8I4eW84zN33O3Q/nGDkcij65Q5j4I5Zs45Ag+Tz/nB7PP1KF+/5VZZ3ph
5pk52N9TrnVSh/nX3GGj/E3mmAaYeguHuklTktxrj0L5lg6ll7w1M67D3Gfl
oGtwKt2j+jCUb+0QKrog3mHrISjfxmHGOflHK6/A3GProNeenSm9D2afnQOL
QrHdmnoY396hbinvht5JsPBzcNC4x7LQax3Uvw0ODvl3NiV8SYO5x9Hh7b7M
BZO2QsO3wdFh0ZfChDl1sPB2cqjJldl2lRkavw1ODlPCn6slrIK519nhWudx
+Z3dO6Hyzg7nwhiWRLyHud/F4cQElqXCK6Dua3BxcKh68zNnPiy9uDpcOH50
9aLnUPc2uDq8qpi2aLksTN7NoczCmsVgKcz9bg7MUwRD1k+H2sfg7iCsnd8m
2bwXKu/uUDbFNqDQBxY/Hg7/Zjh9WVkD85+HQxXv7WQRe1j8eDpc/bnUiq1v
tz0AafPZqg==
       "]]}}}, {{}, {}, 
    {RGBColor[1, 0, 0], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAGIQDQEcDpsmnlctijhkD+ELONSJh9S8+30MyhdxYE5M
yT+4YB+UL+GwuPHxvIlau6F8GQeuQ25tJzV3QfkKDhtzFK4se30QyldyCLeb
8/5i6nYoX8XhmrTxZQ8nmLyaw0WGOdPDOjZB+RoOFnMOCrt+OADlazmsmuzN
8Nn7MJSv4/B2oZFF9lKYvJ7Dk4sRvTlW+6F8Awf3Hu8v/EEweUMH8zt6y+e/
hOk3crCNrrb7+xqm3thhu4iWtsxzmHtMHA5aRjkHacDkTR0iLZ5MO88BM8/M
YVee0Lt9orDwMHe4Oe36MvfWvVC+hQPrqtwbaWyw8LF0uLfl8KXARhjfyiHD
YeO2c1N3QPnWDsFbxVb+u7cTyrdxkH4/ZU79nG1Qvq3DqSaTfmd/mHo7B4/5
f+R1Z8Hca+8Q8vbcifkvYe51cLgZ9lT/UTbUvQ0ODmt//tznIAGTd3QwKmaV
uP4FGh4Njg77mr9eXVkNc7+Tw/ewxwemfIWmhwYnhyP5T6YtF4PJOzvwPs/4
OEkSJu/s4GR96Nt+mz1QeReHwpKSUP0oqPsaXBzOqO5tex0Ds9/VoVT0BYf1
Jpj7XB22dDGt03CBme/m0NRyo3SBLEzezaFh3kbGeY9g/nV3ODRx5itHI6h5
De4Ojc8MXtxih8l7OMjf3rTAzQUaPw0eDjNnp5doJMLiz9Nh/m3B97K5e+0B
uZnggA==
       "]]}}}, {{}, {}, 
    {RGBColor[1, 1, 0], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAGIQDQEcDhE3Fv+7e2WXPYQv4LBSOe2jzvQ1UL6Iw8qt
G1/r8MPkJRyUvpev3nP5IJQv4xAUOGHJ4i/boXwFB5s8o4zJRoehfCUH34IX
hufOboXyVRwchctFXsftgPLVHHaePbMh6DpMvYaDnNSVpC3SMPu0HCI+3RZa
L3kAytdxaJeUvLeRbzeUr+fwc+Ps/t12O6F8A4edH2a9EyuHyRs6REtc7/se
AdNv5PCnQan1UTNM3thh/9PyA0wT9kH5Jg5mvqmT/obA5E0dTn/wuslwCuYe
MwcVo6Q53hOOQPnmDj06q7UW34f5x8Lh4C79oJCsQ1C+pYPwlDe8EnGw8LFy
cDJfd0B2N8w91g4dzvNub1PbBuXbOFzdp7cv6DjMPbYOGr1ZyyRm7IXy7Rws
pI7yCM3ZA+XbOxQ5cK3/mgzjOzg4a+ZPMcyExk+Dg8ONtWpneYJg/nF0OLpq
IV9nO9T+BkeHvw4b/3wvhPnPyWHh3s92MhP3Q+WdHArLpLYsvwgLX2eH3x9L
dgR5Qd3X4OxQENv/QUEXJu/i8LnxkNcVfah7G1wccpQDH1bGw8x3dSjepmRo
agl1b4Org2bIQ4fn6rDwc3M41f5/6qN4qHsb3Bxsy77ZXzkA87+7g7bDLMkN
86DmNbg7PNPianmWCvO/h8OV9sMRzR+h7mnwcFizwlc98wXM/54OkUcOBi2Z
vt8eAFf/3og=
       "]]}}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{10., 0},
  DisplayFunction->Identity,
  Frame->True,
  GridLines->{None, {0.11651623566859805`}},
  PlotLabel->FormBox["\"Step function\"", TraditionalForm],
  PlotRange->{{3., 50.}, {-0.15, 0.4}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellChangeTimes->{
  3.461292582102829*^9, 3.4612926982332153`*^9, {3.4612927760083*^9, 
   3.461292876316428*^9}, {3.4612929513214703`*^9, 3.4612929567118053`*^9}, 
   3.4612943953947153`*^9, {3.461294431080503*^9, 3.461294472548542*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"plot1", "[", 
     RowBox[{
      RowBox[{"tab", "[", 
       RowBox[{"[", "i", "]"}], "]"}], ",", 
      RowBox[{"GridLines", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"None", ",", 
         RowBox[{"{", 
          RowBox[{"p", "^", "2"}], "}"}]}], "}"}]}], ",", 
      RowBox[{"color", "\[Rule]", "i"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", ".15"}], ",", ".40"}], "}"}]}], ",", 
      RowBox[{
      "PlotLabel", "\[Rule]", "\"\<ohne Korrektur, Step function\>\""}]}], 
     "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "4"}], "}"}]}], "]"}], "//", "Show"}]], "Input",
 CellChangeTimes->{{3.4612924444073343`*^9, 3.4612924536864433`*^9}, {
  3.461292563566168*^9, 3.461292580984879*^9}, {3.4612927023957243`*^9, 
  3.461292708498749*^9}, {3.4612927616034603`*^9, 3.461292838197135*^9}, {
  3.461292869930532*^9, 3.46129287527043*^9}, {3.461292955649438*^9, 
  3.4612929556945753`*^9}, {3.461294386144854*^9, 3.461294394697747*^9}, {
  3.461294437532996*^9, 3.4612944489945993`*^9}, {3.461295159725518*^9, 
  3.4612951672006493`*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {RGBColor[0, 0, 1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAGIQDQEcDi+WK5Sczz1sD+ELOFywY93NG34ZyhdxaPDV
DhM9fgjKl3B4rejx5cy8C1C+jIPAraQeZq0TUL6Cw/SFtaHTb5+F8pUc8oxT
rzmUHIPyVRwkv8rs3TrnNJSv5nDR9IXWi7MwvoYDo0eb82uWU1C+lkNJvdgJ
0zsw9+g47HQJ8HW9ArNPz2FN6hrdiBkw9QYO/s+t3EufH4fyDR1OGKnKS34/
CeUbOVy1mPtupiZM3tjh99EHVQmFMP+YOFxTCQiY0wtzr6nDj65+3bXXYPaZ
OVjW7mNefhqm3tyhYdLSvh2RMHkLh9N99vdbPWHylg5T7bcsXfkCZp+Vg96c
41vbV52H8q0dtkuy1fg0weRtHDbsPdAvcOsclG/r4NMsyvh9Fix87ByeLWxe
miUHk7d3aDFovr75I8z/Dg7hT7junyuBhn+Dg4PGyV/mq5ph/nF0WMAyeev9
W2eg8o4OheUn4tZcg4WPk0NyvafXbD+YvJPDmhbu4w9+H4XKOztI/Dow3/cc
1D0Nzg7ZdW7lD/bD5F0chN1ydVsiYPIuDhmpLyTcQy5C5V0dYnJ/ajC/gbq3
wdUh/czBEk9VqH0Mbg6Xf/6r39MOk3dzeMf9pDnwEsz/7g4dsl9DT2jB5N0d
orlKQ4SbYfIeDo26b8/FXYH6p8HD4dQKp8QjvLD48HSoCVjy4VLzSXsA/Jzi
Cg==
       "]]}}}, {{}, {}, 
    {RGBColor[0., 0.980407, 0.6039], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAGIQDQEcDrmtgWf3O62yh/AFHM4K2p0N4dgH5Ys4pL3b
+UCICSYv4TCVb9MGffudUL6MQ1zf04uZ3RuhfAWHx4ejjpzw3gblKzk8S+hc
oaK0AcpXcUj2sTs8IX4LlK/mcD5L0FivcjOUr+FQesDA9y07jK/l4FTyMzri
zH4oX8dBujatpoBrE5Sv53CdtVnDihOm3sAhSOXHxER3mHsMHZz3mQuYL4ap
N3KI2jvllvsamHuMHZ7WaZ1K0IP5x8Shrcf921ZdmLypg2iM72HT6zDzzBxe
XAqKkeuDqTd36Lke8cS1CiZv4dBvk3woaeUOKN/SobbZ1e68CkzeyoFZd47C
g7vboXxrh9pHk6fNvwazz8bhwZcgJwcNmLytg3HmyaXKxbDwsnNgTnfd09kK
C197h0Oqh87+fQDzv4PDr/qNZpqft0L4DQ4OkybPf8AnBDPf0aH56a9br/Ng
8o4OvGwlP23ew8LHySGpZJH3l29Q+xqcHKJPcZsrBa6Hyjs7vOd8ULauEybv
7KAw5yX/0c/roPIuDgb83jJHVGHyLg4uMY27vU7sgsq7OnzRfrJR6BTUvQ2u
DsGSFkvYp8L85+bQtNTr9KJSmLybQ/r+aT/NQ2Hy7g7lJnqvF6jD5N0dTkR/
N94hDpP3cMh9dHli+H2ofxo8HLau+vQsPAcWH54O83c0hGvN2WQPAPzF1+c=

       "]]}}}, {{}, {}, 
    {RGBColor[1, 0, 0], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAGIQDQEcDu3i9x0f3Z9gD+ELOFw9+CRHJGwJlC/ioCCl
L631HiYv4ZDz63HDK+aFUL6Mg9iLVRekPKZD+QoOsVZL5017OBfKV3IwvuLf
xB88FcpXcXj4d/Lds/qzoXw1hzr/0ymTtWdC+RoOIZ/T1zUGwPhaDmd5Hx7Q
+7QUytdxmO1082LWB5h9eg48jXYWyoww9QYOxVsC4rIfTYPyDR02362t/Nc1
A8o3cuBYsP5tOA9M3thhCVc3BxM/zD8mDtXRP7QE4mDuNXXYcyA+YkYHzD4z
h/AZXYcTrGHqzR2C7bat3MwHk7dweHJVw2b6rAVQvqVDgQH3vbS5MPusHByf
2zwq4IbJWzt46OWu4zKFyds4XOqaPSNbfD6Ub+uwjbP8u10ELLzsHF4UMxza
ZjQPyrd3ONn7bqNo1ywo38HhR41ZtVYqNPwbHBzCjoXtO6MD84+jA0PlfKa1
q+dA5R0dzr+Nf11hBgs/J4ecy/5uM5lh8k4O8lsuLQ6ZNwUq7+xgWf3Ac0MW
1D0Nzg681fv2GsfD5F0cBJqt9LjuQ93T4OJgzXuuMctkEVTe1WG/aGglRzxM
3tUhLPNa9JQAmP/cHG5//KDm9RLqngY3h/PvghZF/4H5z91hldWr3oU1MHl3
h5uOzx/MXQWT93Co/bbtI7cETN7DQVdj93vrelh4ezosLm1oW7Vrhj0AL9DT
NA==
       "]]}}}, {{}, {}, 
    {RGBColor[1, 1, 0], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAGIQDQEcDrfYXBQV80vtIXwBB94ujrUr3LugfBGHubcq
rQzmweQlHA6FHTfc/6MVypdxaG5+rn77ZS2Ur+CwaWHJWwmnZihfyaHzvcza
IzHVUL6Kw8ZnR9da1jdC+WoOMt77TmX/qYfyNRyuhq/fGePWAOVrOXyYkDxN
amoPlK/jwMYiLbLqYB2Ur+dw5/ILFed/MP0GDt9KDLzYkmDuMXRQy/eZ/ygf
Jm/kcCLG27bSuwbKN3YIaOS6c1ioDco3cZjZGWL8MAPmXlMHnfVXL0ppw+wz
czjfHC9s5ghTb+7gr8B8bkY/zD4LB2UO2U6BfFj4WDr8i2p8mfEPZp+VA5ub
KdONzS1QvrVDN9vnCL8KmLyNQ/cx5v79PDB5Wwf5hiveW+bAwsvOoft81Dr1
clj42jt8jc9/M1kUJu/g8J6dw333hyYIv8HBgd3vsecRZZh/HB0Y1jfdKSmH
yTs6TFvK7O5tDgtvJwfFH+9nzeSEyTs5hHotvnM+uwoq7+xw3a1y24alUPsa
nB2ifLfmOErB5F0cOGUaJKq8YPIuDhfmxDIoTm2Hyrs6qH8NX/j0G9S+BlcH
57sXz7Z0wdzv5vA+162UexVM3s1hZvl15YMhMHl3h4u/1mSrJsPk3R0Y72RN
ylSAyXs4PHjJ3NepCJP3cChX0/HhCYbFh6fDopPdXN4n6+0Bo0HI4w==
       "]]}}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{10., 0},
  DisplayFunction->Identity,
  Frame->True,
  GridLines->{None, {0.11651623566859805`}},
  PlotLabel->FormBox["\"ohne Korrektur, Step function\"", TraditionalForm],
  PlotRange->{{3., 50.}, {-0.15, 0.4}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellChangeTimes->{
  3.461292582102829*^9, 3.4612926982332153`*^9, {3.4612927760083*^9, 
   3.461292876316428*^9}, {3.4612929513214703`*^9, 3.4612929567118053`*^9}, 
   3.4612943953947153`*^9, {3.461294431080503*^9, 3.461294472548542*^9}, {
   3.461295151424674*^9, 3.461295167527522*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"plot1", "[", 
     RowBox[{
      RowBox[{"tab", "[", 
       RowBox[{"[", "i", "]"}], "]"}], ",", 
      RowBox[{"GridLines", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"None", ",", 
         RowBox[{"{", 
          RowBox[{"p", "^", "2"}], "}"}]}], "}"}]}], ",", 
      RowBox[{"color", "\[Rule]", "i"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", ".15"}], ",", ".40"}], "}"}]}], ",", 
      RowBox[{
      "PlotLabel", "\[Rule]", 
       "\"\<Stoch. Linearisierung, Step function\>\""}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "4"}], "}"}]}], "]"}], "//", "Show"}]], "Input",
 CellChangeTimes->{{3.4612924444073343`*^9, 3.4612924536864433`*^9}, {
  3.461292563566168*^9, 3.461292580984879*^9}, {3.4612927023957243`*^9, 
  3.461292708498749*^9}, {3.4612927616034603`*^9, 3.461292838197135*^9}, {
  3.461292869930532*^9, 3.46129287527043*^9}, {3.461292955649438*^9, 
  3.4612929556945753`*^9}, {3.461294386144854*^9, 3.461294394697747*^9}, {
  3.461294437532996*^9, 3.4612944489945993`*^9}, {3.461295159725518*^9, 
  3.4612951672006493`*^9}, {3.461295221550501*^9, 3.4612952322020493`*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {RGBColor[0, 0, 1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAGIQDQEcDod27Ck3X3PYHsIXcGDhnPr1Au9+KF/EwU1K
iadr6gEoX8Lh/bPTncruV6F8GYdJdzzNjHechfIVHP4qzvnys/k8lK/koO8o
peSRdALKV3GwW3vRqnTKGShfzWG5ypodTx/uhvI1HF7dOPFORQymXsth4mLx
eImPp6B8HYeS23Eq1k+OQPl6DruzJ3BuYD4N5Rs4FGkXdH6ygrnH0CH/8lmf
Z88uQPlGDlMf6u0pnwMzz9jh2L3/li/KYOaZOHAxeyVeK4XZb+rwZ8fSCY3z
YeaZOcx/mXBp1ZGjUL65Q3+/2+EQHZj9Fg6nWwOXnOaB+c/SYVq57ao/Mieh
fCuHlYkfXz9hgNlv7XCieM9Xm5jjUL6Nw5lJx2aIWMPst3V4k73cf70+zP12
DqFH5WLi1h+D8u0dtFznnllWeA7Kd3Bw7D98M4oZal6Dg8OHHNM0m/cw/zk6
JE60KvY6AXV/g6MDa+oUuac2MPc7OUyMM5ugsw6qvsHJ4aDcwceWdjD3ODs0
h8lG5myAppcGZweliXPFjM1g7ndxaN0Ytm/+A6h5DS4OCqq5UTl/YeHn6hB1
LeBNyQSo/xtcHYLcNZwOv4K5z80hpF1b5ektmLybA2uT2N7sP7D06e5QvVOm
Xy8Gmr4a3B0mpHyqv6cEk/dwYJB767xVDxoeDR4OUqvm1JvWwsLb04HPfaWR
msRZewCxTtuV
       "]]}}}, {{}, {}, 
    {RGBColor[0., 0.980407, 0.6039], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAGIQDQEcDswPfs28H3DUHsIXcJCv3lf60ekYlC/ioPrg
RMT0sq1QvoTDhUezTV9s2wnlyzjclVepiF+1F8pXcLjblKwUO2MjlK/kUPTq
6qP5W7dB+SoOYbYnpE7Gn4Dy1RysGxZvuV58HMrXcGix0/s/Z9phKF/L4ZDw
9leNKoegfB2HXmPhVB2fA1C+noMz+9K9vgF7oHwDBy3x1ccefN4N5Rs6sGV5
2c1sOAjlGzncv9SrEHsWpt/YgZ1Zdub7rP1QvomDV7D26TylfVC+qcOtG+6n
jqTtgvLNHOxsWnV3e8HUmzv8f2x+f3H1dijfwqGgmFv41i6Y/ZYOxhq+76uF
YOFn5cC6KVCm/PEOKN/aoTycZ+aN6CNQvo3DoQ+ZijFVsPCydbj4zm3TAgtY
eNs5cPcVshUxwvxj72Aepy4wezuM7+AQ0Fx2d5Ys1H0NDg4R57gOvv8Ec6+j
Q+w5nZCn1dDwbHB0UDK8IzdpPsy/Tg6/Huh9r9SCmtfg5CC82PGHwGuYf5wd
rPT1l93lhIZfg7ODx9G/G55bw8LHxcFjR/rpGZxQ8xpcHKK69s5Nug3T7+pQ
UGnMo2kFja8GV4ffPSfFdyfD/OfmIHtfT9FyDtS8BjeHs0HrhGL2w9zn7uD9
x1P7ujFUfYO7Q8FtL37NP7D493Ao+Ocu6HYQmh4bPByi2iXkOdVg8p4OD5c9
reWJ2WMPAL+p1ag=
       "]]}}}, {{}, {}, 
    {RGBColor[1, 0, 0], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAGIQDQEcDssqZ/SdWLrcHsIXcDB6EyFmev4YlC/i4Gnw
jsPz9W4oX8KhsWHf1NCebVC+jINZ4avkDfMOQPkKDlI1Oe9SzsLklRw84wzu
lFyHyas4RMrkWyX+3wPlqzlcWNISwDYBZr6Gw9qqRMarZ/ZC+VoO3UVC5T0u
B6F8HYe+f7957tbsgPL1HP6fNapk5YOZZ+DAbBc34Y/TISjf0KHC872DUinM
PCMHa/6+xR+X7YfyjR1qQrNbNJ7BzDNx6Jd3/Gv0BuYeU4dCr0J17g0w88wc
dEW9v3ImwOTNHawqrjGqJ8L8Z+Fg9WPT96LjMPssHfK33LaWkoXxrRxM/6Vs
fVC0C8q3dnhj4/Fjx699UL6NgzXTlbaP/jDzbB1K/U0aLi+B+c/OISUjbsPj
LJh59g637CXV9nnDzHNwiM44zPxnO9R/DQ4O6ny35e8fh5nv6LB5kfLMDkWo
/gZHhz1N9hN9J8Dsc3Ko9L1bbfscal6Dk4Oxc97Eq30w/c4O3b9Osz8Wgul3
dgju33Bi/XKY+1wcWJ43Be0WgsZXg4vD6synwq1LYO51dVhxpnVR9F+Y+1wd
LDoDhNd5wMLTzWH5GV6X/UJQ+xrcHKYl9u96WrYTKu/ucDmHl9UvBmpfg7tD
xd/k7dMqYenDw+FXSEDc5TyYfg+HmGufCnZOh/nP0+G1wbq9n57vsQcAbmTb
0g==
       "]]}}}, {{}, {}, 
    {RGBColor[1, 1, 0], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAGIQDQEcDr6K/9k1ArrsIXwBhxPxW/nt76+G8kUcer87
pCq9WQDlSzgsFrwsqbtyK5Qv43D7l3zfR+5NUL6Cw80tnas6CvdA+UoOsWW6
ti47N0L5Kg4Fr20kr2QchPLVHPjdn+rFvd0M5Ws46Nnf/vv62V4oX8uBiSPO
JP00zDwdh1ufjz58eROmX89hz6K7evrCML6BQ+DyfNGlrDD9hg56H2y9D9+F
8Y0c4stytjmqwMwzdnh3akvCije7oXwThymTb8S4ToepN3Vo9Hfz238fxjdz
8Pcy0Nodvg/KN3e4+1dKvLRnJ5Rv4fDKxkJ3t+kuKN/SwdX/UvrDTph6K4eT
qwyVi4QOQPnWDo8DrJ4GisHkbRyubFt18XojzH22Dgymbuplx2Dydg4d7/K7
lOtg8vYODaE6Mmf5YXwHh11ht7X/7oGqb3BwiOb/ksHPD3O/o4PxqV0eusdh
8o4O3HLXr8yThpnv5CAoILm4zAtqXoOTw5sPLKx5n2Dyzg56Wk67xBuh7m9w
drgVaxj56gvMfhcH4z+Om/RWwsx3cagQkY9K2bIfKu/q8K0wSurPbJj5rg5c
FWuLl86A6XdzWN/24LcZF9S9DW4OKaeSlL/9hdnv7pA60eHO/X8w890d+E/d
3Mn2CKbfw4Hjk3PHtnSofQ0eDoK8qVbNHrDw9nT4UCL+2HHPXnsAwATXKw==

       "]]}}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{10., 0},
  DisplayFunction->Identity,
  Frame->True,
  GridLines->{None, {0.11651623566859805`}},
  PlotLabel->FormBox[
   "\"Stoch. Linearisierung, Step function\"", TraditionalForm],
  PlotRange->{{3., 50.}, {-0.15, 0.4}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellChangeTimes->{{3.461295213468253*^9, 3.461295233200334*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["Theta"], "Input",
 CellChangeTimes->{{3.460283430587044*^9, 3.460283434302026*^9}, {
  3.460795527892371*^9, 3.460795530129663*^9}, {3.4607955766409597`*^9, 
  3.460795578808557*^9}, {3.46079571050916*^9, 3.460795710548897*^9}, {
  3.4612913099479103`*^9, 3.461291310813904*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.5`", ",", 
   FractionBox["1", "100"]}], "}"}]], "Output",
 CellChangeTimes->{
  3.460283435412422*^9, 3.460775352955998*^9, {3.4607955253867073`*^9, 
   3.460795545862266*^9}, 3.460795586661957*^9, 3.460795711874619*^9, 
   3.460796171791313*^9, 3.4612913115707197`*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"l0", " ", "=", " ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\"\<GH\>\"", ",", " ", "#1"}], "}"}]}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "0"}], ",", " ", 
         "\"\<NorKorr\>\""}], "}"}]}], "]"}], " ", "&"}]}], " ", ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"l1", " ", "=", " ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\"\<GH\>\"", ",", " ", "#1"}], "}"}]}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "0"}], ",", " ", 
         "\"\<StochLin\>\""}], "}"}]}], "]"}], " ", "&"}]}], " ", ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"lUT", "=", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\"\<UT\>\"", ",", " ", "#"}], "}"}]}], "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "0"}], ",", " ", 
         "\"\<NorKorr\>\""}], "}"}]}], "]"}], "&"}]}], ";"}], 
  "\[IndentingNewLine]", "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"l0lin", " ", "=", " ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\"\<GH\>\"", ",", " ", "#1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "1"}], ",", " ", 
         "\"\<NorKorr\>\""}], "}"}]}], "]"}], " ", "&"}]}], " ", ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"l1lin", " ", "=", " ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\"\<GH\>\"", ",", " ", "#1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "1"}], ",", " ", 
         "\"\<StochLin\>\""}], "}"}]}], "]"}], " ", "&"}]}], " ", ";"}], 
  " "}], "\n"}], "Input",
 CellChangeTimes->{{3.460282085817231*^9, 3.4602821105254803`*^9}, {
   3.460282171720809*^9, 3.4602821743115873`*^9}, {3.460282379938203*^9, 
   3.460282383283786*^9}, {3.460282626852909*^9, 3.460282635158669*^9}, {
   3.460283528574358*^9, 3.460283534882937*^9}, {3.460369527766265*^9, 
   3.460369582229149*^9}, {3.4606980537546053`*^9, 3.460698090520545*^9}, {
   3.46069815452689*^9, 3.460698158294612*^9}, {3.46069819069496*^9, 
   3.460698194537347*^9}, {3.460698236984003*^9, 3.460698243324768*^9}, {
   3.460698279984375*^9, 3.460698306778549*^9}, 3.460702914215372*^9, {
   3.4607029469570293`*^9, 3.4607029721967697`*^9}, {3.460704571457388*^9, 
   3.460704576893887*^9}, {3.4607168109795427`*^9, 3.4607168162959433`*^9}, {
   3.46071690711674*^9, 3.46071695341546*^9}, 3.460716991335456*^9, {
   3.460717023444168*^9, 3.460717028564159*^9}, 3.4607170586775084`*^9, {
   3.460717150411056*^9, 3.4607171765473013`*^9}, {3.4607937956619453`*^9, 
   3.460793800181624*^9}, {3.460809863708386*^9, 3.460809877027776*^9}, {
   3.460946071412085*^9, 3.460946075267939*^9}, {3.461039646185474*^9, 
   3.461039703844592*^9}, {3.461062876954748*^9, 3.4610628807089367`*^9}, {
   3.461063589604763*^9, 3.461063609382888*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pp", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"lUT", "[", "0", "]"}], "\[IndentingNewLine]", 
 RowBox[{"l0", "[", "2", "]"}], "\[IndentingNewLine]", 
 RowBox[{"l1", "[", "2", "]"}]}], "Input",
 CellChangeTimes->{{3.460282153080297*^9, 3.460282158488613*^9}, {
   3.460282193092895*^9, 3.460282220935027*^9}, {3.460282308500825*^9, 
   3.4602823085625467`*^9}, {3.460283195676051*^9, 3.460283196336207*^9}, {
   3.4603662815649853`*^9, 3.460366282970312*^9}, {3.460698345525057*^9, 
   3.460698345602466*^9}, {3.4606984667172117`*^9, 3.460698470379286*^9}, {
   3.460698596520487*^9, 3.460698604587326*^9}, {3.460698866050302*^9, 
   3.46069888194167*^9}, {3.4606991271651297`*^9, 3.460699135538176*^9}, {
   3.460699290645143*^9, 3.4606992926163483`*^9}, {3.460699354347168*^9, 
   3.460699355452443*^9}, {3.4606994671451*^9, 3.46069947483103*^9}, {
   3.460717000907537*^9, 3.460717010074459*^9}, {3.460717065524967*^9, 
   3.4607170967251673`*^9}, {3.460795730013938*^9, 3.460795739827765*^9}, {
   3.4607958067487707`*^9, 3.460795808448151*^9}, 3.460946084006742*^9, {
   3.4610545030144253`*^9, 3.461054506669404*^9}, {3.461062908638434*^9, 
   3.461062939934175*^9}, {3.4610629734931173`*^9, 3.4610630122358*^9}, {
   3.461063549117404*^9, 3.461063556122695*^9}, {3.461063629422222*^9, 
   3.461063635605742*^9}}],

Cell[BoxData[
 RowBox[{"-", "83.36530182007027`"}]], "Output",
 CellChangeTimes->{
  3.461055026071499*^9, 3.461055535346114*^9, {3.461062930178684*^9, 
   3.4610629409066877`*^9}, {3.46106297429517*^9, 3.4610630133416023`*^9}, 
   3.461063550463402*^9, 3.461063636489337*^9}],

Cell[BoxData[
 RowBox[{"-", "81.27162892426675`"}]], "Output",
 CellChangeTimes->{
  3.461055026071499*^9, 3.461055535346114*^9, {3.461062930178684*^9, 
   3.4610629409066877`*^9}, {3.46106297429517*^9, 3.4610630133416023`*^9}, 
   3.461063550463402*^9, 3.461063636577858*^9}],

Cell[BoxData[
 RowBox[{"-", "81.27162892426679`"}]], "Output",
 CellChangeTimes->{
  3.461055026071499*^9, 3.461055535346114*^9, {3.461062930178684*^9, 
   3.4610629409066877`*^9}, {3.46106297429517*^9, 3.4610630133416023`*^9}, 
   3.461063550463402*^9, 3.4610636366581993`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"l0", "[", "mm", "]"}], ",", 
           RowBox[{"l1", "[", "mm", "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"mm", ",", "2", ",", 
           RowBox[{"M", "=", "30"}]}], "}"}]}], "]"}], "//", 
       RowBox[{
        RowBox[{"AddTimeAxis", "[", 
         RowBox[{"#", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "M", ",", "1"}], "}"}]}], "]"}], "&"}]}], "//", 
      RowBox[{
       RowBox[{"plot1", "[", 
        RowBox[{"#", ",", 
         RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], "&"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"l0lin", "[", "mm", "]"}], ",", 
           RowBox[{"l1lin", "[", "mm", "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"mm", ",", "2", ",", 
           RowBox[{"M", "=", "20"}]}], "}"}]}], "]"}], "//", 
       RowBox[{
        RowBox[{"AddTimeAxis", "[", 
         RowBox[{"#", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "M", ",", "1"}], "}"}]}], "]"}], "&"}]}], "//", 
      RowBox[{
       RowBox[{"plot1", "[", 
        RowBox[{"#", ",", 
         RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], "&"}]}]}], "}"}], "//",
    "GraphicsRow"}], "\[IndentingNewLine]", "\[IndentingNewLine]"}]], "Input",\

 CellChangeTimes->{{3.460281783177149*^9, 3.460281824576651*^9}, {
   3.460281910255617*^9, 3.460281943368555*^9}, {3.460281981836998*^9, 
   3.4602819975731277`*^9}, {3.4602820319744387`*^9, 3.460282053018779*^9}, {
   3.460282118996468*^9, 3.460282133562097*^9}, {3.460282239307322*^9, 
   3.460282241400333*^9}, {3.46028239420243*^9, 3.4602824371035967`*^9}, {
   3.460284414532241*^9, 3.4602844151683893`*^9}, {3.460284789442216*^9, 
   3.4602847924493017`*^9}, {3.4603644911795893`*^9, 3.460364500191489*^9}, {
   3.4603695897129087`*^9, 3.460369625240038*^9}, {3.460439520790577*^9, 
   3.46043953878603*^9}, {3.460439576047587*^9, 3.46043961923698*^9}, {
   3.460548309147976*^9, 3.4605483174968367`*^9}, {3.460698218433448*^9, 
   3.4606982189993668`*^9}, {3.46069831865662*^9, 3.46069832472578*^9}, {
   3.4606986846777077`*^9, 3.460698686195219*^9}, {3.460698801081359*^9, 
   3.460698839662919*^9}, 3.4606988983413677`*^9, {3.460699493303959*^9, 
   3.460699521539399*^9}, {3.460703038834033*^9, 3.4607030392870197`*^9}, {
   3.460704537168377*^9, 3.460704565215843*^9}, {3.460704964492584*^9, 
   3.4607049654824247`*^9}, {3.460716586378721*^9, 3.4607165874503813`*^9}, {
   3.460716698553081*^9, 3.460716698621357*^9}, {3.460716874013295*^9, 
   3.4607168854884872`*^9}, {3.460717105177659*^9, 3.460717118490457*^9}, {
   3.460717189751791*^9, 3.460717263423542*^9}, {3.460718184809017*^9, 
   3.460718184886208*^9}, {3.460718268047081*^9, 3.460718284726698*^9}, {
   3.4607755347462053`*^9, 3.4607755471913977`*^9}, {3.46077559546695*^9, 
   3.4607755976225233`*^9}, {3.4607941597744217`*^9, 3.460794160368875*^9}, {
   3.460946106514607*^9, 3.460946122597385*^9}, {3.46094659114475*^9, 
   3.460946591194377*^9}, {3.4609548232072563`*^9, 3.4609548232709846`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{{}, {}, 
        {RGBColor[0, 0, 1], PointSize[0.003], Thickness[0.003], 
         Dashing[{}], {}, 
         {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBWIQDQUOT6d7xCUFhhyAcDkcPHPeWNtIKjpA+AIOa6LD
0u6pa0HlRRx2PLzkoMusDpWXcFgTzvz/arsylC/jMMFW5GlNoyqUr+BQ80+2
/4aCLJSv5OD1tKzngxZMvYrDxizDdpZ8IShfzeHKvJmbmxqUoHwNB6sTl5dq
T4W5R8sh50IVR3sZTL+Og/alEm6Z3zC+nsORPZnXT2rC7DdwEJvhmdC5SxPK
N3T417xvVsBNmPlGDl05byYtOKUD5Rs7NNye68xgAbPPxOHK+dnrTbNg/jV1
4PnitFXovxSUb+YgFtxinXJJA8o3dzjCeSyj5QtMv4XDaeHKOS531KB8Swen
rFXtuX0weSuHTd7rPXSPakH51g43bDkrv1xRgfJtHC7JzczWL4aZb+uQ8uzY
Ag1JGN/O4V3Hl8i2dVoOABPVctE=
           "]]}}}, {{}, {}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.003], Thickness[0.003], 
         Dashing[{}], {}, 
         {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBWIQDQUOL6Z7xCUFhhyAcDkcWKSOp3MKh0L5Ag5+nhzp
vjfdoXwRh5vvds/lSXKG8iUcSg5V3fq52wTKl3GIWPZozlshPShfwUHiVWgh
S/yl/RC+ksPWnuPMF25LQOVVHMqNju+UmaLqAOGrOXSsO5bBnMcLlddw+PbY
0+1phSxUXsth8xz2yL6bIlC+joPoVZU96ydpQvl6DlZTp94/yKAO5Rs4THLd
Zx/XqwblGzo41dsdK/kgD+UbOfSsOX/i+hkpKN/YgW22jG/pOhUo38TB5PfB
F2rfYOaZOsy6lGAXthAmb+aw9F2lsd8LZSjf3OHE/guKit0wvoWDzp1QL41g
JSjf0sHNid350EmYe6wcNux/ELr/E8z91g4MVv+4X/jBwsPG4eY/h9YrfDD7
bB2SRTm+/vgC49s5VPxwbr7JpugAALxDeGE=
           "]]}}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{5., 0},
      DisplayFunction->Identity,
      Frame->True,
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {192., -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{{}, {}, 
        {RGBColor[0, 0, 1], PointSize[0.003], Thickness[0.003], 
         Dashing[{}], {}, 
         {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBmIQDQUOSWcWTMktSjgA4XI4VEi9vPxAJhHKF3DoWJnr
EVoD44s41HteN8g8C1Mv4bCgkEOPpRLGl3FQu1FvGLgSxldw+PS27vtkDxhf
yeGT5tcO1vMwvorDgghHZzFvGF/Nwch763GE/RoOfcLSDLwxMHktB69Ypq1O
7TC+joPcgpaC5wUwvp7Dvd3+85bNgPENHExM3uj8zYHxDR1Klrkd72+G8Y0c
HH5NnL+hFMY3djj1Ry44KQzGN3Fwaiqas70h4QAAEFBVWA==
           "]]}}}, {{}, {}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.003], Thickness[0.003], 
         Dashing[{}], {}, 
         {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBmIQDQUOSWcWTMktSjgA4XI4nF228Odur0QoX8BBqGfj
/cZ4GF/EwbFb23vJHph6CQc1/3Dm1H4YX8bhFLvfcbV8GF/B4cGrQw/2+8L4
Sg5GrgpTPlfB+CoOVjdX7i9xgvHVHDKmhTRLbIfZp+EgILR8xXw3mLyWwzOb
qYcMb8H4Og4iFvwbo/1hfD2HBks9BaEzML6Bw2TFl4/VMmB8Q4ftoV6/bs+F
8Y0chI7ERdQnw/jGDmtfFFc8iobxTRxct67k5QHKAwAoMFUx
           "]]}}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{5., -140.},
      DisplayFunction->Identity,
      Frame->True,
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {576., -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}]}, {}},
  ContentSelectable->True,
  ImageSize->{745., Automatic},
  PlotRangePadding->{6, 5}]], "Output",
 CellChangeTimes->{
  3.460775425448578*^9, 3.4607754700659657`*^9, 3.460775539899415*^9, {
   3.460775579367695*^9, 3.4607756028765783`*^9}, 3.46079375348527*^9, 
   3.460794109114853*^9, {3.460794141208694*^9, 3.460794166108056*^9}, 
   3.460795038999024*^9, 3.460795481918459*^9, 3.460795596595607*^9, 
   3.46079577538967*^9, 3.460795997989531*^9, 3.460796092546796*^9, 
   3.46079615257302*^9, 3.4607961864423943`*^9, 3.460796233751705*^9, 
   3.460800232377943*^9, 3.460809880932366*^9, 3.460811395614438*^9, 
   3.460946109764419*^9, 3.46094614542948*^9, 3.460946618824018*^9, 
   3.4609467082716103`*^9, 3.460952867861412*^9, 3.460954831053339*^9, 
   3.460954960474946*^9, 3.461039840364395*^9, 3.461055151318616*^9, 
   3.461055366143911*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pp", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"l0", " ", "=", " ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\"\<GH\>\"", ",", "20", ",", 
           RowBox[{"10", "^", 
            RowBox[{"-", "#"}]}], " ", ",", "Infinity", ",", "1"}], "}"}]}], 
        "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "0"}], ",", " ", 
         "\"\<NorKorr\>\""}], "}"}]}], "]"}], " ", "&"}]}], " ", ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"l1", " ", "=", " ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\"\<GH\>\"", ",", "20", ",", 
           RowBox[{"10", "^", 
            RowBox[{"-", "#"}]}], " ", ",", "Infinity", ",", "1"}], "}"}]}], 
        "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "0"}], ",", " ", 
         "\"\<StochLin\>\""}], "}"}]}], "]"}], " ", "&"}]}], " ", ";"}], 
  " "}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.460282085817231*^9, 3.4602821105254803`*^9}, {
   3.460282171720809*^9, 3.4602821743115873`*^9}, {3.460282379938203*^9, 
   3.460282383283786*^9}, {3.460282626852909*^9, 3.460282635158669*^9}, {
   3.460283528574358*^9, 3.460283534882937*^9}, {3.460369527766265*^9, 
   3.460369582229149*^9}, {3.4606980537546053`*^9, 3.460698090520545*^9}, {
   3.46069815452689*^9, 3.460698158294612*^9}, {3.46069819069496*^9, 
   3.460698194537347*^9}, {3.460698236984003*^9, 3.460698243324768*^9}, {
   3.460698279984375*^9, 3.460698306778549*^9}, 3.460702914215372*^9, {
   3.4607029469570293`*^9, 3.4607029721967697`*^9}, {3.460704571457388*^9, 
   3.460704576893887*^9}, {3.4607168109795427`*^9, 3.4607168162959433`*^9}, {
   3.46071690711674*^9, 3.46071695341546*^9}, 3.460716991335456*^9, {
   3.460717023444168*^9, 3.460717028564159*^9}, 3.4607170586775084`*^9, {
   3.460717150411056*^9, 3.4607171765473013`*^9}, {3.4607937956619453`*^9, 
   3.460793800181624*^9}, {3.460809863708386*^9, 3.460809877027776*^9}, {
   3.460946071412085*^9, 3.460946075267939*^9}, {3.461039646185474*^9, 
   3.461039703844592*^9}, {3.461062876954748*^9, 3.4610628807089367`*^9}, {
   3.461063589604763*^9, 3.461063609382888*^9}, {3.461066129221304*^9, 
   3.461066200840329*^9}, {3.461066249224805*^9, 3.4610662514999037`*^9}, {
   3.461066454764264*^9, 3.461066459104848*^9}, {3.461066539416134*^9, 
   3.461066541518929*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"l0", "[", "mm", "]"}], ",", 
        RowBox[{"l1", "[", "mm", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"mm", ",", "2", ",", 
        RowBox[{"M", "=", "16"}]}], "}"}]}], "]"}], "//", 
    RowBox[{
     RowBox[{"AddTimeAxis", "[", 
      RowBox[{"#", ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "M", ",", "1"}], "}"}]}], "]"}], "&"}]}], "//", 
   RowBox[{
    RowBox[{"plot1", "[", 
     RowBox[{"#", ",", 
      RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], "&"}]}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.460281783177149*^9, 3.460281824576651*^9}, {
   3.460281910255617*^9, 3.460281943368555*^9}, {3.460281981836998*^9, 
   3.4602819975731277`*^9}, {3.4602820319744387`*^9, 3.460282053018779*^9}, {
   3.460282118996468*^9, 3.460282133562097*^9}, {3.460282239307322*^9, 
   3.460282241400333*^9}, {3.46028239420243*^9, 3.4602824371035967`*^9}, {
   3.460284414532241*^9, 3.4602844151683893`*^9}, {3.460284789442216*^9, 
   3.4602847924493017`*^9}, {3.4603644911795893`*^9, 3.460364500191489*^9}, {
   3.4603695897129087`*^9, 3.460369625240038*^9}, {3.460439520790577*^9, 
   3.46043953878603*^9}, {3.460439576047587*^9, 3.46043961923698*^9}, {
   3.460548309147976*^9, 3.4605483174968367`*^9}, {3.460698218433448*^9, 
   3.4606982189993668`*^9}, {3.46069831865662*^9, 3.46069832472578*^9}, {
   3.4606986846777077`*^9, 3.460698686195219*^9}, {3.460698801081359*^9, 
   3.460698839662919*^9}, 3.4606988983413677`*^9, {3.460699493303959*^9, 
   3.460699521539399*^9}, {3.460703038834033*^9, 3.4607030392870197`*^9}, {
   3.460704537168377*^9, 3.460704565215843*^9}, {3.460704964492584*^9, 
   3.4607049654824247`*^9}, {3.460716586378721*^9, 3.4607165874503813`*^9}, {
   3.460716698553081*^9, 3.460716698621357*^9}, {3.460716874013295*^9, 
   3.4607168854884872`*^9}, {3.460717105177659*^9, 3.460717118490457*^9}, {
   3.460717189751791*^9, 3.460717263423542*^9}, {3.460718184809017*^9, 
   3.460718184886208*^9}, {3.460718268047081*^9, 3.460718284726698*^9}, {
   3.4607755347462053`*^9, 3.4607755471913977`*^9}, {3.46077559546695*^9, 
   3.4607755976225233`*^9}, {3.4607941597744217`*^9, 3.460794160368875*^9}, {
   3.460946106514607*^9, 3.460946122597385*^9}, {3.46094659114475*^9, 
   3.460946591194377*^9}, {3.4609548232072563`*^9, 3.4609548232709846`*^9}, {
   3.461066214650826*^9, 3.461066238312064*^9}, {3.4610663052399187`*^9, 
   3.4610663262124643`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", "0.01`", 
   "\[InvisibleSpace]", "\<\" und |vals| < \"\>", "\[InvisibleSpace]", 
   "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   "24"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 0.01, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 24],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066546202401*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", "0.01`", 
   "\[InvisibleSpace]", "\<\" und |vals| < \"\>", "\[InvisibleSpace]", 
   "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   "24"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 0.01, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 24],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066546379109*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", "0.001`",
    "\[InvisibleSpace]", "\<\" und |vals| < \"\>", "\[InvisibleSpace]", 
   "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   "52"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 0.001, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 52],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.4610665465865993`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", "0.001`",
    "\[InvisibleSpace]", "\<\" und |vals| < \"\>", "\[InvisibleSpace]", 
   "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   "52"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 0.001, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 52],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066546996119*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "0.0001`", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "88"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 0.0001, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 88],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.4610665473706093`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "0.0001`", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "88"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 0.0001, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 88],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.4610665480168457`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "0.00001`", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "112"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 0.00001, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 112],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066548632181*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "0.00001`", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "112"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 0.00001, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 112],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066549394985*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-6", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "140"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-6, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 140],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066550124783*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-6", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "140"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-6, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 140],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.4610665510587378`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-7", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "164"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-7, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 164],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066551955522*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-7", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "164"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-7, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 164],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.4610665530345573`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-8", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "184"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-8, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 184],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066554078086*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-8", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "184"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-8, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 184],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.4610665552993917`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-9", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "208"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-9, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 208],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066556451236*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-9", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "208"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-9, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 208],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066557810438*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-10", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "232"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-10, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 232],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066559114731*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-10", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "232"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-10, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 232],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066560619508*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-11", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "260"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-11, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 260],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066562033959*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-11", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "260"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-11, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 260],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066563655533*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-12", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "276"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-12, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 276],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.4610665652238293`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-12", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "276"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-12, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 276],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066566944599*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-13", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "292"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-13, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 292],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066568609373*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-13", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "292"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-13, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 292],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066570440606*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-14", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "316"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-14, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 316],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066572225769*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-14", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "316"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-14, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 316],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.4610665741732073`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-15", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "344"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-15, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 344],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066576066081*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-15", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "344"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-15, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 344],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066578229982*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-16", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "352"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-16, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 352],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066580301497*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Genauigkeit x^\"\>", "\[InvisibleSpace]", "39", 
   "\[InvisibleSpace]", "\<\"; \"\>", 
   "\[InvisibleSpace]", "\<\"Stuetzstellen: \"\>", "\[InvisibleSpace]", "400",
    "\[InvisibleSpace]", "\<\"; weight > \"\>", "\[InvisibleSpace]", 
   "1.`*^-16", "\[InvisibleSpace]", "\<\" und |vals| < \"\>", 
   "\[InvisibleSpace]", "\[Infinity]", "\[InvisibleSpace]", "\<\": \"\>", 
   "\[InvisibleSpace]", "352"}],
  SequenceForm[
  "Genauigkeit x^", 39, "; ", "Stuetzstellen: ", 400, "; weight > ", 1.*^-16, 
   " und |vals| < ", 
   DirectedInfinity[1], ": ", 352],
  Editable->False]], "Print",
 CellChangeTimes->{3.461066463130518*^9, 3.461066582530113*^9}]
}, Closed]],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {RGBColor[0, 0, 1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{2., 13.979825934391767`}, {3., 9.869506663145904}, {4., 
       11.378920554927165`}, {5., 11.187951863594156`}, {6., 
       11.291724341412174`}, {7., 11.437662231832764`}, {8., 
       11.51965353277563}, {9., 11.596958437861634`}, {10., 
       11.622556507875661`}, {11., 11.671528240928808`}, {12., 
       11.680493103914362`}, {13., 11.686626414058585`}, {14., 
       11.698965825198835`}, {15., 11.706252410829869`}, {16., 
       11.707440841455458`}}]}}}, {{}, {}, 
    {RGBColor[0., 0.980407, 0.6039], PointSize[0.003], Thickness[0.003], 
     Dashing[{}], {}, 
     {Opacity[1], 
      LineBox[{{2., -98.80148237374897}, {3., -59.19638871073932}, {
       4., -33.237489077630826`}, {5., -21.32934571591688}, {
       6., -10.6879045314304}, {7., -3.420976311583517}, {8., 
       0.40205926617676213`}, {9., 3.5870128250671747`}, {10., 
       6.379435187755718}, {11., 8.74324717193327}, {12., 
       9.734939897477977}, {13., 10.567063591643794`}, {14., 
       11.266987184558804`}, {15., 11.88656922523753}, {16., 
       11.980765603713373`}}]}}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{2., 10.},
  DisplayFunction->Identity,
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.461066243557496*^9, {3.461066295518341*^9, 3.461066316606876*^9}, 
   3.4610663882267027`*^9, 3.461066521332611*^9, 3.4610665855056353`*^9}]
}, Open  ]],

Cell[TextData[StyleBox["Math7/Intel/ OS X",
 FontColor->RGBColor[1, 0, 0]]], "Text",
 PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"THETA0", "=", 
  RowBox[{"Theta", "+", "2"}]}], "\n", 
 RowBox[{"F0", "=", 
  RowBox[{"IdentityMatrix", "[", 
   RowBox[{"Length", "[", "THETA0", "]"}], "]"}]}], "\n", "SCALING", "\n", 
 RowBox[{"FISHER", "=", "True"}], "\n", 
 RowBox[{"MAXSTEP", "=", "1"}], "\n", 
 RowBox[{"STEPREDUCE", "=", "2"}], "\[IndentingNewLine]", 
 RowBox[{"FDIGITS", "=", "2"}], "\[IndentingNewLine]", 
 RowBox[{"pp", "=", "0"}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601143146009274`*^9, 3.460114315759859*^9}, 
   3.460282522110393*^9, {3.460283799592029*^9, 3.4602838013662*^9}, {
   3.4604357137809753`*^9, 3.460435744591599*^9}, {3.460435786839238*^9, 
   3.4604357909828987`*^9}, {3.460435825453755*^9, 3.460435826628525*^9}, {
   3.460435861768526*^9, 3.460435863165637*^9}, {3.460435902549529*^9, 
   3.460435902612645*^9}, {3.460435960264574*^9, 3.460435960325345*^9}, {
   3.460800240094215*^9, 3.46080024273132*^9}, {3.460800295594029*^9, 
   3.460800296159734*^9}, {3.4608954999782867`*^9, 3.460895502131062*^9}, {
   3.460947612960956*^9, 3.460947613047348*^9}, {3.460947704422284*^9, 
   3.4609477048763227`*^9}, {3.460947806061472*^9, 3.460947807346348*^9}, {
   3.460948187620083*^9, 3.460948188336835*^9}, {3.460948347644432*^9, 
   3.460948347701769*^9}, {3.4609484075164022`*^9, 3.46094840810865*^9}, {
   3.460948460872738*^9, 3.460948462429784*^9}, {3.460948600279028*^9, 
   3.460948616747788*^9}, {3.4609488015429173`*^9, 3.460948801618271*^9}, {
   3.460949639163137*^9, 3.460949639544662*^9}, {3.460954977361505*^9, 
   3.460954977503503*^9}, {3.4609551667043953`*^9, 3.460955166765717*^9}, {
   3.460956292161353*^9, 3.460956292233892*^9}, {3.4609579113582973`*^9, 
   3.460957913418631*^9}, {3.46096094676088*^9, 3.460960946817298*^9}, {
   3.4609737165353203`*^9, 3.4609737165926247`*^9}, {3.46097411129979*^9, 
   3.460974111417828*^9}, {3.460979627304564*^9, 3.4609796273524714`*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", "2.5`", "}"}]], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460800243362911*^9, 3.4608002973198147`*^9, 3.460893288670948*^9, 
   3.460895516749981*^9, 3.460947418702989*^9, 3.460947614141144*^9, 
   3.460947705000287*^9, 3.4609478074844627`*^9, 3.460948189545951*^9, 
   3.460948292412211*^9, 3.460948348442149*^9, 3.460948408932138*^9, 
   3.460948462573689*^9, {3.460948601228479*^9, 3.460948617552438*^9}, 
   3.460948802494253*^9, 3.460949640571453*^9, 3.460954978279376*^9, 
   3.4609551676924257`*^9, 3.460956292544258*^9, 3.4609579142478523`*^9, 
   3.460960947625119*^9, 3.4609737175605164`*^9, 3.460974112701829*^9, 
   3.4609796281605797`*^9, 3.461054293914579*^9, 3.461054402689093*^9, 
   3.46105554596367*^9, 3.461055778912168*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "1", "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460800243362911*^9, 3.4608002973198147`*^9, 3.460893288670948*^9, 
   3.460895516749981*^9, 3.460947418702989*^9, 3.460947614141144*^9, 
   3.460947705000287*^9, 3.4609478074844627`*^9, 3.460948189545951*^9, 
   3.460948292412211*^9, 3.460948348442149*^9, 3.460948408932138*^9, 
   3.460948462573689*^9, {3.460948601228479*^9, 3.460948617552438*^9}, 
   3.460948802494253*^9, 3.460949640571453*^9, 3.460954978279376*^9, 
   3.4609551676924257`*^9, 3.460956292544258*^9, 3.4609579142478523`*^9, 
   3.460960947625119*^9, 3.4609737175605164`*^9, 3.460974112701829*^9, 
   3.4609796281605797`*^9, 3.461054293914579*^9, 3.461054402689093*^9, 
   3.46105554596367*^9, 3.461055778927144*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460800243362911*^9, 3.4608002973198147`*^9, 3.460893288670948*^9, 
   3.460895516749981*^9, 3.460947418702989*^9, 3.460947614141144*^9, 
   3.460947705000287*^9, 3.4609478074844627`*^9, 3.460948189545951*^9, 
   3.460948292412211*^9, 3.460948348442149*^9, 3.460948408932138*^9, 
   3.460948462573689*^9, {3.460948601228479*^9, 3.460948617552438*^9}, 
   3.460948802494253*^9, 3.460949640571453*^9, 3.460954978279376*^9, 
   3.4609551676924257`*^9, 3.460956292544258*^9, 3.4609579142478523`*^9, 
   3.460960947625119*^9, 3.4609737175605164`*^9, 3.460974112701829*^9, 
   3.4609796281605797`*^9, 3.461054293914579*^9, 3.461054402689093*^9, 
   3.46105554596367*^9, 3.46105577893788*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460800243362911*^9, 3.4608002973198147`*^9, 3.460893288670948*^9, 
   3.460895516749981*^9, 3.460947418702989*^9, 3.460947614141144*^9, 
   3.460947705000287*^9, 3.4609478074844627`*^9, 3.460948189545951*^9, 
   3.460948292412211*^9, 3.460948348442149*^9, 3.460948408932138*^9, 
   3.460948462573689*^9, {3.460948601228479*^9, 3.460948617552438*^9}, 
   3.460948802494253*^9, 3.460949640571453*^9, 3.460954978279376*^9, 
   3.4609551676924257`*^9, 3.460956292544258*^9, 3.4609579142478523`*^9, 
   3.460960947625119*^9, 3.4609737175605164`*^9, 3.460974112701829*^9, 
   3.4609796281605797`*^9, 3.461054293914579*^9, 3.461054402689093*^9, 
   3.46105554596367*^9, 3.461055778948669*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460800243362911*^9, 3.4608002973198147`*^9, 3.460893288670948*^9, 
   3.460895516749981*^9, 3.460947418702989*^9, 3.460947614141144*^9, 
   3.460947705000287*^9, 3.4609478074844627`*^9, 3.460948189545951*^9, 
   3.460948292412211*^9, 3.460948348442149*^9, 3.460948408932138*^9, 
   3.460948462573689*^9, {3.460948601228479*^9, 3.460948617552438*^9}, 
   3.460948802494253*^9, 3.460949640571453*^9, 3.460954978279376*^9, 
   3.4609551676924257`*^9, 3.460956292544258*^9, 3.4609579142478523`*^9, 
   3.460960947625119*^9, 3.4609737175605164`*^9, 3.460974112701829*^9, 
   3.4609796281605797`*^9, 3.461054293914579*^9, 3.461054402689093*^9, 
   3.46105554596367*^9, 3.461055778959887*^9}],

Cell[BoxData["2"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460800243362911*^9, 3.4608002973198147`*^9, 3.460893288670948*^9, 
   3.460895516749981*^9, 3.460947418702989*^9, 3.460947614141144*^9, 
   3.460947705000287*^9, 3.4609478074844627`*^9, 3.460948189545951*^9, 
   3.460948292412211*^9, 3.460948348442149*^9, 3.460948408932138*^9, 
   3.460948462573689*^9, {3.460948601228479*^9, 3.460948617552438*^9}, 
   3.460948802494253*^9, 3.460949640571453*^9, 3.460954978279376*^9, 
   3.4609551676924257`*^9, 3.460956292544258*^9, 3.4609579142478523`*^9, 
   3.460960947625119*^9, 3.4609737175605164`*^9, 3.460974112701829*^9, 
   3.4609796281605797`*^9, 3.461054293914579*^9, 3.461054402689093*^9, 
   3.46105554596367*^9, 3.461055778972136*^9}],

Cell[BoxData["2"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460800243362911*^9, 3.4608002973198147`*^9, 3.460893288670948*^9, 
   3.460895516749981*^9, 3.460947418702989*^9, 3.460947614141144*^9, 
   3.460947705000287*^9, 3.4609478074844627`*^9, 3.460948189545951*^9, 
   3.460948292412211*^9, 3.460948348442149*^9, 3.460948408932138*^9, 
   3.460948462573689*^9, {3.460948601228479*^9, 3.460948617552438*^9}, 
   3.460948802494253*^9, 3.460949640571453*^9, 3.460954978279376*^9, 
   3.4609551676924257`*^9, 3.460956292544258*^9, 3.4609579142478523`*^9, 
   3.460960947625119*^9, 3.4609737175605164`*^9, 3.460974112701829*^9, 
   3.4609796281605797`*^9, 3.461054293914579*^9, 3.461054402689093*^9, 
   3.46105554596367*^9, 3.461055778984188*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460800243362911*^9, 3.4608002973198147`*^9, 3.460893288670948*^9, 
   3.460895516749981*^9, 3.460947418702989*^9, 3.460947614141144*^9, 
   3.460947705000287*^9, 3.4609478074844627`*^9, 3.460948189545951*^9, 
   3.460948292412211*^9, 3.460948348442149*^9, 3.460948408932138*^9, 
   3.460948462573689*^9, {3.460948601228479*^9, 3.460948617552438*^9}, 
   3.460948802494253*^9, 3.460949640571453*^9, 3.460954978279376*^9, 
   3.4609551676924257`*^9, 3.460956292544258*^9, 3.4609579142478523`*^9, 
   3.460960947625119*^9, 3.4609737175605164`*^9, 3.460974112701829*^9, 
   3.4609796281605797`*^9, 3.461054293914579*^9, 3.461054402689093*^9, 
   3.46105554596367*^9, 3.461055778997574*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Nichtlinear", "/", "NorKorr"}]], "Input",
 CellChangeTimes->{{3.460367266700344*^9, 3.46036726904226*^9}, {
  3.460800444634096*^9, 3.460800460394889*^9}, {3.461054303563342*^9, 
  3.4610543621960487`*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"integ", "=", 
    RowBox[{"{", 
     RowBox[{"\"\<GH\>\"", ",", 
      RowBox[{"m", "=", "5"}], ",", 
      RowBox[{"eps", "=", 
       RowBox[{"10.", "^", 
        RowBox[{"-", "16"}]}]}], ",", 
      RowBox[{"ksigma", "=", "Infinity"}], ",", "0"}], "}"}]}], 
   ";"}]}]], "Input",
 CellChangeTimes->{{3.460367266700344*^9, 3.46036726904226*^9}, {
  3.460800444634096*^9, 3.460800460394889*^9}, {3.461054303563342*^9, 
  3.4610543621960487`*^9}, {3.461055847090377*^9, 3.461055848286789*^9}, {
  3.461055882020801*^9, 3.46105588446552*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "scoreii", ",", "k", 
      ",", "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
    RowBox[{
     StyleBox["BFGS",
      FontColor->RGBColor[0, 0, 1]], "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"Y", ",", "X", ",", 
         RowBox[{"-", "9"}]}], "}"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      "\t  ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"IdioNonlin", ",", 
          RowBox[{"{", "}"}], ",", "integ"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Lik", ",", "IndividualLikNonlin", ",", "Score", ",", "Hesse"}], 
         "}"}]}], "}"}], ",", "\[IndentingNewLine]", "            ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Sing", "=", "False"}], ",", 
          RowBox[{"2", "Pi"}], ",", "0", ",", 
          RowBox[{"onlynorkorr", "=", "0"}], ",", "\"\<NorKorr\>\"", ",", 
          RowBox[{"supp", "=", ".9"}]}], "}"}], ",", 
        RowBox[{"KMAX", "=", "20"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EPS1", "=", ".0001"}], ",", 
          RowBox[{"EPS2", "=", ".0001"}]}], "}"}], ",", "\[IndentingNewLine]",
         "             ", 
        RowBox[{"OPTION", "=", "0"}], ",", 
        RowBox[{"PRINT", "=", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1"}], "}"}]}]}], "}"}]}], "]"}]}], ";"}], 
  "                                                                           \
     "}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113330285616*^9, 3.460113346379695*^9}, {
   3.460200648978776*^9, 3.4602006503583603`*^9}, {3.460200794874672*^9, 
   3.4602007984595947`*^9}, 3.460201903279232*^9, {3.460201941045977*^9, 
   3.4602019411313553`*^9}, {3.460279278878285*^9, 3.460279290392777*^9}, {
   3.460279385569292*^9, 3.4602794078107224`*^9}, 3.460279483282811*^9, {
   3.460282734453003*^9, 3.46028273588818*^9}, {3.460283616696549*^9, 
   3.460283634147719*^9}, {3.4602836706901093`*^9, 3.460283671258127*^9}, {
   3.4602837458995867`*^9, 3.4602837460095263`*^9}, {3.460283977779047*^9, 
   3.4602839782382393`*^9}, {3.460284094017385*^9, 3.460284112248164*^9}, {
   3.4602842039019938`*^9, 3.460284237509654*^9}, {3.460285585933895*^9, 
   3.460285590933837*^9}, 3.460367196326754*^9, {3.460435757860738*^9, 
   3.460435758943184*^9}, {3.460435888109399*^9, 3.460435888167045*^9}, {
   3.4604359232590923`*^9, 3.4604359236923323`*^9}, {3.460800256155857*^9, 
   3.4608002648029137`*^9}, {3.460800465883931*^9, 3.46080049502407*^9}, 
   3.4608953686428633`*^9, {3.460895402378611*^9, 3.460895402446619*^9}, {
   3.460895484634429*^9, 3.460895486454823*^9}, 3.460947542476837*^9, {
   3.460947583326927*^9, 3.460947609050817*^9}, {3.460947747952683*^9, 
   3.4609477495979967`*^9}, {3.4609566751112213`*^9, 3.460956675874737*^9}, {
   3.4609735290978613`*^9, 3.46097353670392*^9}, {3.460974317479939*^9, 
   3.460974317553602*^9}, {3.460974870571419*^9, 3.4609748711835403`*^9}, {
   3.460978105142201*^9, 3.460978111222004*^9}, {3.460979559235765*^9, 
   3.460979559838581*^9}, {3.460979639713928*^9, 3.460979641892297*^9}, {
   3.461054317285483*^9, 3.461054320589488*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Tiefe von data = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["Tiefe von data = ", 5],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558890689907`*^9}],

Cell[BoxData["\<\"L\[ADoubleDot]nge der Paneldaten\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558890961847`*^9}],

Cell[BoxData[
 RowBox[{"{", "50", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055889119973*^9}],

Cell[BoxData["\<\"***********************LSDE1********************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558891344843`*^9}],

Cell[BoxData["\<\"***********************MODUL:    BFGS \
(skeleton)**************\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055889149805*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055889169033*^9}],

Cell[BoxData["\<\"Technical Output\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055889185123*^9}],

Cell[BoxData["IndividualLikNonlin"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.46105588920131*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558892165337`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"KMAX\"\>",
       HoldForm], 
      TagBox["\<\"EPS1\"\>",
       HoldForm], 
      TagBox["\<\"EPS2\"\>",
       HoldForm], 
      TagBox["\<\"K\"\>",
       HoldForm], 
      TagBox["\<\"Q\"\>",
       HoldForm], 
      TagBox["\<\"n\"\>",
       HoldForm], 
      TagBox["\<\"T\"\>",
       HoldForm], 
      TagBox["\<\"OPTION\"\>",
       HoldForm]},
     {"1", "20", "0.0001`", "0.0001`", "2", "1", "1", "49", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"KMAX", "EPS1", "EPS2", "K", "Q", "n", "T", "OPTION"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558892560377`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055889273754*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"MAXSTEP\"\>",
       HoldForm], 
      TagBox["\<\"MINSTEP\"\>",
       HoldForm], 
      TagBox["\<\"BOUND\"\>",
       HoldForm], 
      TagBox["\<\"STEPREDUCE\"\>",
       HoldForm], 
      TagBox["\<\"FMAX\"\>",
       HoldForm]},
     {"1", "1", "1.`*^-10", "1.`*^-6", "2", "1000"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"MAXSTEP", "MINSTEP", "BOUND", "STEPREDUCE", "FMAX"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055889290153*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055889336053*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"RESAMPLING\"\>",
       HoldForm], 
      TagBox["\<\"FDIGITS\"\>",
       HoldForm], 
      TagBox["\<\"TYP\"\>",
       HoldForm], 
      TagBox["\<\"YMAX\"\>",
       HoldForm], 
      TagBox["\<\"ANALGRAD\"\>",
       HoldForm], 
      TagBox["\<\"FACTOR\"\>",
       HoldForm], 
      TagBox["\<\"CSEED\"\>",
       HoldForm]},
     {"1", "True", "2", "1", "1.`*^8", "False", "1.`", 
      RowBox[{"-", "999"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {
      "RESAMPLING", "FDIGITS", "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}},
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055889387219*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558894326687`*^9}],

Cell[BoxData["\<\"    SCALING\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.46105588948421*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "::", "\<\"nmtx\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The first two levels of the \
one-dimensional list \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\
\\!\\({}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" cannot be \
transposed.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Transpose\\\", ButtonNote -> \\\"Transpose::nmtx\\\
\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.460113347438837*^9, 3.4601140477211742`*^9, 3.460114171488365*^9, 
   3.4601142582303123`*^9, 3.46011431981378*^9, 3.4601210026174927`*^9, 
   3.4602006082555428`*^9, 3.4602006525509787`*^9, 3.4602007997492933`*^9, {
   3.460201893745349*^9, 3.460201903902554*^9}, 3.4602019417761383`*^9, 
   3.460279294169009*^9, 3.460279424327683*^9, 3.4602794918395157`*^9, 
   3.460282465738028*^9, 3.4602825470673647`*^9, 3.460282687933013*^9, 
   3.4602827362471*^9, 3.460282807351432*^9, 3.460282913928569*^9, 
   3.460283210827161*^9, 3.460283352033407*^9, 3.460283407184712*^9, {
   3.460283619834437*^9, 3.460283671655117*^9}, 3.460283747410516*^9, 
   3.460283804801373*^9, {3.460283909419492*^9, 3.460283979704739*^9}, 
   3.46028403988277*^9, {3.4602840959065733`*^9, 3.460284112635261*^9}, 
   3.460284241484562*^9, 3.4602855917581997`*^9, {3.460367187530768*^9, 
   3.4603671971813374`*^9}, 3.460435693346806*^9, {3.460435725332974*^9, 
   3.460435760027495*^9}, 3.460435797489111*^9, 3.460435835765499*^9, {
   3.460435866970508*^9, 3.460435925364402*^9}, 3.460435963989526*^9, 
   3.460440284356594*^9, {3.460800275063458*^9, 3.460800302789452*^9}, {
   3.460800468359326*^9, 3.460800496223838*^9}, 3.460893308685207*^9, 
   3.460895369843894*^9, 3.4608954034235277`*^9, 3.460895519071595*^9, 
   3.460947436525774*^9, 3.460947545540031*^9, 3.460947586296083*^9, 
   3.460947619098731*^9, 3.460947708222899*^9, 3.460947753274775*^9, 
   3.460947810952606*^9, 3.4609482996507807`*^9, 3.460948351901083*^9, 
   3.460948412547164*^9, 3.460948465359805*^9, {3.460948604299255*^9, 
   3.460948621012168*^9}, 3.4609488054909363`*^9, 3.460949644132731*^9, 
   3.460954982053323*^9, 3.460955171436544*^9, 3.460956295547605*^9, 
   3.460956679624262*^9, 3.460957918022379*^9, 3.4609609505197687`*^9, 
   3.4609735398603287`*^9, 3.460973720827586*^9, 3.4609741158491*^9, 
   3.460974318811453*^9, 3.460974873402882*^9, 3.460978113897318*^9, 
   3.460979561901987*^9, {3.460979631200762*^9, 3.460979644279752*^9}, 
   3.46105437499102*^9, 3.461055550729926*^9, 3.4610557944420156`*^9, 
   3.4610558539182463`*^9, 3.461055889549943*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  RowBox[{"Transpose", "[", 
   RowBox[{"{", "}"}], "]"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
    0]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055889591131*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055889629071*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055889688581*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055889736423*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STARTWERT THETA0 = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "2.5`", "}"}]}],
  SequenceForm["STARTWERT THETA0 = ", {2.5}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055889785675*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.25`", "}"}]}],
  SequenceForm["Score: INC: ", {0.25}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558898339252`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"-", "72.78732575755993`"}], "}"}], ",", 
   RowBox[{"-", "9.237483219327544`"}]}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055889881979*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558899272947`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["BFGS: Iteration = ", 1],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055889976892*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -0.409386564375180\"\>",
     -0.40938656437517995`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-0.40938656437517995`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055890048748*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -9.237483219327540\"\>",
     -9.237483219327544,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-9.237483219327544, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558900951567`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     8.828096654952370\"\>",
     8.828096654952365,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[8.828096654952365, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055890143412*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055890190386*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.5000\"\>",
         1.5,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.5000\"\>",
         2.5,
         AutoDelete->True], 
        InterpretationBox["\<\"-1.0000\"\>",
         -1.,
         AutoDelete->True], 
        InterpretationBox["\<\"-72.7870\"\>",
         -72.78732575755993,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558902386*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558902852163`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055890334153*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.15000000000000002`", "}"}]}],
  SequenceForm["Score: INC: ", {0.15000000000000002`}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055890381178*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "15.571750558226785`"}],
  SequenceForm["NOISE  ", 15.571750558226785`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055890433885*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "303.85772412174356`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 303.85772412174356`, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055890484902*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558905504932`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "2"}],
  SequenceForm["BFGS: Iteration = ", 2],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055890595067*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     9.381870119608630\"\>",
     9.381870119608628,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[9.381870119608628, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558906473827`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -0.409386564375180\"\>",
     -0.40938656437517995`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-0.40938656437517995`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558907087297`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     9.791256683983810\"\>",
     9.791256683983807,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[9.791256683983807, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055890754583*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558907991962`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.5000\"\>",
         0.5,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.5000\"\>",
         1.5,
         AutoDelete->True], 
        InterpretationBox["\<\"-1.0000\"\>",
         -1.,
         AutoDelete->True], 
        InterpretationBox["\<\"-82.9300\"\>",
         -82.9301798247079,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055890846842*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055890894175*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055890944227*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.1`", "}"}]}],
  SequenceForm["Score: INC: ", {0.1}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558909924173`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "10.836942960540132`"}],
  SequenceForm["NOISE  ", 10.836942960540132`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558910527697`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "0.01739404805652665`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "1.`"}],
  SequenceForm["*BFGSUP ", 0.01739404805652665, "  ", 1.],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055891101881*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "2.7115329306812677`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 2.7115329306812677`, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.46105589114896*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055891197381*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "3"}],
  SequenceForm["BFGS: Iteration = ", 3],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055891243504*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     8.213305068114100\"\>",
     8.213305068114103,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     9.381870119608630\"\>",
     9.381870119608628,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[8.213305068114103, {20, 15}], "  LIKALT  ", 
   PaddedForm[9.381870119608628, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558913666487`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     9.381870119608630\"\>",
     9.381870119608628,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[13.923305679116186`, {20, 15}], "  LIKALT  ", 
   PaddedForm[9.381870119608628, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558915622473`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055891611335*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     9.381870119608630\"\>",
     9.381870119608628,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[9.381870119608628, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055891665452*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     4.541435559507558\"\>",
     4.541435559507558,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[4.541435559507558, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055891716317*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558917618027`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.3894\"\>",
         0.3893771166981585,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.5000\"\>",
         0.5,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1106\"\>",
         -0.1106228833018415,
         AutoDelete->True], 
        InterpretationBox["\<\"-25.4390\"\>",
         -25.439249780693398`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055891809655*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055891852929*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 57.49\"\>",
         57.490930044014505`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558919030027`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.1`", "}"}]}],
  SequenceForm["Score: INC: ", {0.1}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055891949223*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "5.402984544154373`"}],
  SequenceForm["NOISE  ", 5.402984544154373],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558920336723`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "2.0534344587244013`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 2.0534344587244013`, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055892087625*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055892132388*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "4"}],
  SequenceForm["BFGS: Iteration = ", 4],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055892178887*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     4.286036463536572\"\>",
     4.286036463536572,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[4.286036463536572, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558924583397`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     9.599841285315910\"\>",
     9.599841285315907,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[9.599841285315907, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055892660922*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     9.823888599310510\"\>",
     9.823888599310513,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[9.823888599310513, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055892866008*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    12.942402680756160\"\>",
     12.94240268075616,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[12.94240268075616, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055893067573*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.515059372779850\"\>",
     13.515059372779854`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
   PaddedForm[13.515059372779854`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055893266069*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.659883801970540\"\>",
     13.65988380197054,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
   PaddedForm[13.65988380197054, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.46105589346489*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116300\"\>",
     13.923305679116302`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 7, "  LIKNEU  ", 
   PaddedForm[13.923305679116302`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055893663673*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "8", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116150\"\>",
     13.923305679116147`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 8, "  LIKNEU  ", 
   PaddedForm[13.923305679116147`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558938650846`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "9", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116140\"\>",
     13.92330567911614,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 9, "  LIKNEU  ", 
   PaddedForm[13.92330567911614, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055894064279*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "10", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116210\"\>",
     13.923305679116208`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 10, "  LIKNEU  ", 
   PaddedForm[13.923305679116208`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055894263196*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "11", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116170\"\>",
     13.923305679116167`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 11, "  LIKNEU  ", 
   PaddedForm[13.923305679116167`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.46105589446889*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "12", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116260\"\>",
     13.923305679116263`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 12, "  LIKNEU  ", 
   PaddedForm[13.923305679116263`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558946708717`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "13", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.92330567911619,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 13, "  LIKNEU  ", 
   PaddedForm[13.92330567911619, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055894868137*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "14", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116280\"\>",
     13.923305679116277`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 14, "  LIKNEU  ", 
   PaddedForm[13.923305679116277`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558950667887`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "15", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116210\"\>",
     13.923305679116208`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 15, "  LIKNEU  ", 
   PaddedForm[13.923305679116208`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055895263351*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "16", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116194`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 16, "  LIKNEU  ", 
   PaddedForm[13.923305679116194`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055895467299*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "17", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116150\"\>",
     13.923305679116147`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 17, "  LIKNEU  ", 
   PaddedForm[13.923305679116147`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055895673286*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "18", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116220\"\>",
     13.923305679116222`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 18, "  LIKNEU  ", 
   PaddedForm[13.923305679116222`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055895868987*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "19", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116230\"\>",
     13.923305679116233`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 19, "  LIKNEU  ", 
   PaddedForm[13.923305679116233`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055896069818*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "20", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116130\"\>",
     13.923305679116133`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 20, "  LIKNEU  ", 
   PaddedForm[13.923305679116133`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558962652473`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "21", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116150\"\>",
     13.923305679116154`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 21, "  LIKNEU  ", 
   PaddedForm[13.923305679116154`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558965118847`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "22", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116220\"\>",
     13.923305679116222`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 22, "  LIKNEU  ", 
   PaddedForm[13.923305679116222`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.46105589671516*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "23", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116180\"\>",
     13.923305679116185`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 23, "  LIKNEU  ", 
   PaddedForm[13.923305679116185`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558969153214`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "24", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116160\"\>",
     13.923305679116162`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 24, "  LIKNEU  ", 
   PaddedForm[13.923305679116162`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558971157837`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "25", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116210\"\>",
     13.923305679116208`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 25, "  LIKNEU  ", 
   PaddedForm[13.923305679116208`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558973126507`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "26", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116210\"\>",
     13.923305679116213`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 26, "  LIKNEU  ", 
   PaddedForm[13.923305679116213`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055897519065*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "27", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116250\"\>",
     13.923305679116247`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 27, "  LIKNEU  ", 
   PaddedForm[13.923305679116247`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558977243958`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "28", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116230\"\>",
     13.923305679116234`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 28, "  LIKNEU  ", 
   PaddedForm[13.923305679116234`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.46105589792249*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "29", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116220\"\>",
     13.923305679116218`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 29, "  LIKNEU  ", 
   PaddedForm[13.923305679116218`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.46105589812416*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "30", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116240\"\>",
     13.923305679116243`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 30, "  LIKNEU  ", 
   PaddedForm[13.923305679116243`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055898333992*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "31", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116250\"\>",
     13.92330567911625,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 31, "  LIKNEU  ", 
   PaddedForm[13.92330567911625, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055898565445*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "32", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116270\"\>",
     13.923305679116272`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 32, "  LIKNEU  ", 
   PaddedForm[13.923305679116272`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558987767057`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "33", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116170\"\>",
     13.923305679116169`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    13.923305679116190\"\>",
     13.923305679116186`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 33, "  LIKNEU  ", 
   PaddedForm[13.923305679116169`, {20, 15}], "  LIKALT  ", 
   PaddedForm[13.923305679116186`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055898982766*^9}],

Cell[BoxData["\<\"ReturnCode = 4\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055899038322*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS:  ENDE DER ITERATION  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "20"}],
  SequenceForm["BFGS:  ENDE DER ITERATION  ", 3, "  ", 20],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558990882196`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {"1", 
       RowBox[{"-", "28.590595660850333`"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}]]]], "Print",\

 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055899140113*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.46105589919175*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 57.49\"\>",
         57.490930044014505`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055899246876*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"Likelihood\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm]},
      {"1", 
       RowBox[{"-", "9.237483219327544`"}], "2.5`"},
      {"2", 
       RowBox[{"-", "0.40938656437517995`"}], "1.5`"},
      {"3", "9.381870119608628`", "0.5`"},
      {"4", "13.923305679116186`", "0.3893771166981585`"},
      {"5", "13.923305679116186`", "0.3893771166981585`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"Likelihood", "THETA"}}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055899300303*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"INK: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.2154434690031884`", "}"}]}],
  SequenceForm["INK: ", {0.2154434690031884}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055899349029*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055899662809*^9}],

Cell[BoxData["\<\"ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558997059107`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.46105589975068*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {
         StyleBox["\[Null]",
          ShowStringCharacters->False], 
         TagBox["\<\"THETA\"\>",
          HoldForm], 
         TagBox["\<\"SCORE\"\>",
          HoldForm]},
        {"1", "0.3893771166981585`", 
         RowBox[{"-", "28.590595660850333`"}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxDividers->{
        "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
         "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.24]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
     "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[
     BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}]]], 
   "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
   "13.923305679116186`"}],
  SequenceForm[
   MatrixForm[{{0.3893771166981585, -28.590595660850333`}}, 
    TableHeadings -> {Automatic, {"THETA", "SCORE"}}], "   Likelihood = ", 
   13.923305679116186`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558997951117`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055899838188*^9}],

Cell[BoxData["\<\"WALD-TEST:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558998836203`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558999277153`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"CHI \"\>",
       HoldForm], 
      TagBox["\<\"U \"\>",
       HoldForm], 
      TagBox["\<\"PROB \"\>",
       HoldForm], 
      TagBox["\<\"ALPHA \"\>",
       HoldForm]},
     {"1", "16.277087843863356`", "1", "0.000054721647520628025`", "0.05`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", "ALPHA "}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610558999726*^9}],

Cell[BoxData["\<\"NULLHYPOTHESE THETA = 0 ABLEHNEN\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055900017158*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055900060049*^9}],

Cell[BoxData["\<\"BONFERRONI-KONFIDENZINTERVALLE:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055900103483*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055900166609*^9}],

Cell[BoxData["\<\"P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= \
1-ALPHA\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055900209041*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"QUANTIL Z(1-ALPHA/2U) = \"\>", "\[InvisibleSpace]", 
   "1.9599639845400527`"}],
  SequenceForm["QUANTIL Z(1-ALPHA/2U) = ", 1.9599639845400527`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055900253614*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"THETA\"\>",
       HoldForm], 
      TagBox["\<\"GRENZE\"\>",
       HoldForm], 
      TagBox["\<\"STD\"\>",
       HoldForm]},
     {"1", "0.3893771166981585`", "0.18916037323785517`", 
      "0.09651216794284395`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055900297064*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055900341961*^9}],

Cell[BoxData["\<\"Korrelation der ML-Sch\[ADoubleDot]tzer\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055900389805*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610559015413523`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "1.`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610559015872393`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055901628783*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND \
EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055901677452*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055901721599*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0.009314598561027716`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055901787685*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055901829425*^9}],

Cell[BoxData[
 RowBox[{"{", "0.009314598561027716`", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055901873682*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055901915856*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX \
UND EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055901959812*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055902005477*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "107.35835725481509`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610559020500603`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055902097946*^9}],

Cell[BoxData[
 RowBox[{"{", "107.35835725481509`", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055902142758*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055902186747*^9}],

Cell[BoxData["\<\"KOMPENSIERTE LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610559022301617`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055902307325*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"U =  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  Nue = \"\>", "\[InvisibleSpace]", "50"}],
  SequenceForm["U =  ", 1, "  Nue = ", 50],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055902361518*^9}],

Cell[BoxData["\<\"AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) \
AZENCOTT/DACUNHA-CASTELLE (A/D)\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.4610559024123917`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"LIK\"\>",
       HoldForm], 
      TagBox["\<\"AIC\"\>",
       HoldForm], 
      TagBox["\<\"SIC/RISS\"\>",
       HoldForm], 
      TagBox["\<\"A/D\"\>",
       HoldForm]},
     {
      TagBox["\<\"Kompensator\"\>",
       HoldForm], "0", "1", "1.956011502714073`", "1.3654186875213339`"},
     {
      TagBox["\<\"komp. Lik.\"\>",
       HoldForm], "13.923305679116186`", "12.923305679116186`", 
      "11.967294176402113`", "12.557886991594852`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {{"Kompensator", "komp. Lik."}, {
      "LIK", "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
    TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.4608953694725447`*^9, 
   3.460895402915329*^9, 3.460895518345941*^9, 3.460947436053938*^9, 
   3.460947545032947*^9, 3.460947585669757*^9, 3.460947618449395*^9, 
   3.4609477074411163`*^9, 3.460947752973959*^9, 3.460947810139888*^9, 
   3.4609482989322157`*^9, 3.460948351089509*^9, 3.4609484117280903`*^9, 
   3.460948464472485*^9, {3.460948603817629*^9, 3.460948620378895*^9}, 
   3.460948804905348*^9, 3.460949643214582*^9, 3.460954981444701*^9, 
   3.460955170567142*^9, 3.460956294846027*^9, 3.460956678850439*^9, 
   3.4609579175044813`*^9, 3.460960950075943*^9, 3.460973539471887*^9, 
   3.460973720089134*^9, 3.460974115271796*^9, 3.460974318549573*^9, 
   3.4609748731484327`*^9, 3.46097811345479*^9, 3.4609795614907913`*^9, {
   3.4609796306386757`*^9, 3.460979643933111*^9}, 3.461054374442752*^9, 
   3.4610555502757597`*^9, 3.461055793971953*^9, 3.461055853446156*^9, 
   3.461055902459956*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{"psii", "\[IndentingNewLine]", "LIKI"}], "Input",
 CellChangeTimes->{{3.460968711925699*^9, 3.460968723418686*^9}, {
  3.460978193324712*^9, 3.460978195507168*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "2.5`", "}"}], ",", 
   RowBox[{"{", "1.5`", "}"}], ",", 
   RowBox[{"{", "0.5`", "}"}], ",", 
   RowBox[{"{", "0.3893771166981585`", "}"}], ",", 
   RowBox[{"{", "0.3893771166981585`", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.460968714822977*^9, 3.460968724147056*^9}, 
   3.46097409988968*^9, 3.460978196061455*^9, 3.4609796627620983`*^9, 
   3.461055817352173*^9, 3.461055862035137*^9, 3.461055902771768*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "9.237483219327544`"}], ",", 
   RowBox[{"-", "0.40938656437517995`"}], ",", "9.381870119608628`", ",", 
   "13.923305679116186`", ",", "13.923305679116186`"}], "}"}]], "Output",
 CellChangeTimes->{{3.460968714822977*^9, 3.460968724147056*^9}, 
   3.46097409988968*^9, 3.460978196061455*^9, 3.4609796627620983`*^9, 
   3.461055817352173*^9, 3.461055862035137*^9, 3.461055902814595*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460978177235903*^9, 3.460978187564171*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "0.5`", "0.3893771166981585`", "0.09651216794284395`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.460113389973647*^9, 3.460114056100081*^9, 3.460114179071628*^9, 
   3.4601142697179193`*^9, 3.460114343759589*^9, 3.460121016537031*^9, 
   3.4602008503444023`*^9, 3.460201923221129*^9, 3.460201965915328*^9, 
   3.4602793122704687`*^9, 3.460279517413031*^9, 3.46028255805007*^9, 
   3.4603672164787407`*^9, 3.460800336801489*^9, {3.460800482426375*^9, 
   3.460800510638279*^9}, 3.460893981101018*^9, 3.4608953876618633`*^9, 
   3.460901286141897*^9, 3.4609481676941032`*^9, 3.460956267642015*^9, 
   3.460956657512209*^9, 3.460960937610713*^9, 3.460962093900219*^9, {
   3.4609687029694*^9, 3.4609687307939777`*^9}, 3.46097410288829*^9, 
   3.460978145749707*^9, {3.460978178745632*^9, 3.4609782059923267`*^9}, 
   3.4609796805720043`*^9, 3.461055812794685*^9, 3.461055906901926*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"integ", "=", 
   RowBox[{"{", 
    RowBox[{"\"\<GH\>\"", ",", 
     RowBox[{"m", "=", "5"}], ",", 
     RowBox[{"eps", "=", 
      RowBox[{"10.", "^", 
       RowBox[{"-", "16"}]}]}], ",", 
     RowBox[{"ksigma", "=", "Infinity"}], ",", "0"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "k", ",", 
     "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
   RowBox[{
    StyleBox["GRIDSEARCH",
     FontColor->RGBColor[0, 0, 1]], "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"Y", ",", "X", ",", 
        RowBox[{"-", "9"}]}], "}"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
     "\t  ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", 
         RowBox[{"{", "}"}], ",", "integ"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "Lik", ",", "IndividualLikNonlin", ",", "Score", ",", "Hesse"}], 
        "}"}]}], "}"}], ",", "\n", "\t        ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Sing", "=", "False"}], ",", 
         RowBox[{"2", "Pi"}], ",", "0", ",", 
         RowBox[{"onlynorkorr", "=", "0"}], ",", "\"\<NorKorr\>\"", ",", 
         RowBox[{"supp", "=", ".9"}]}], "}"}], ",", 
       RowBox[{"KMAX", "=", "20"}], ",", 
       RowBox[{"EPS2", "=", ".0001"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", 
         RowBox[{"nhalf", "=", "9"}]}], "}"}], ",", 
       RowBox[{"PRINT", "=", 
        RowBox[{"0", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1"}], "}"}]}]}]}], "}"}]}], "]"}]}], 
  ";"}], "\n"}], "Input",
 CellChangeTimes->{{3.460975156820698*^9, 3.460975200746744*^9}, {
   3.460975282221939*^9, 3.460975316561496*^9}, {3.460975369862314*^9, 
   3.460975385546159*^9}, {3.460975417254572*^9, 3.4609754477819347`*^9}, {
   3.460975481712237*^9, 3.460975486455926*^9}, 3.4609764770111094`*^9, {
   3.460976559121996*^9, 3.4609765605836353`*^9}, {3.460977047930294*^9, 
   3.460977049487256*^9}, {3.460977630605905*^9, 3.460977632771017*^9}, 
   3.460977821939395*^9, {3.4609779192246237`*^9, 3.460977921739793*^9}, {
   3.460977955184973*^9, 3.460977955263098*^9}, {3.460977993196138*^9, 
   3.460977993252756*^9}, {3.461063665953705*^9, 3.461063684949086*^9}, {
   3.46106374093513*^9, 3.4610637409937773`*^9}, 3.4610638119440813`*^9, {
   3.461063869361333*^9, 3.4610638694374847`*^9}, {3.46106392631745*^9, 
   3.461063926384259*^9}, {3.461063969475252*^9, 3.461063969809992*^9}, {
   3.461064007718966*^9, 3.4610640222631474`*^9}, 3.461064065078418*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"j = \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"   LIKALTj = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "9.237483219327544`"}]}],
  SequenceForm["j = ", 1, "   LIKALTj = ", -9.237483219327544],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064066120397*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["Suchrichtung  ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064066133257*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"-", "1"}], "}"}]}],
  SequenceForm["Suchrichtung  ", {-1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064068032386*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"j = \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"   LIKALTj = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "0.40938656437517995`"}]}],
  SequenceForm["j = ", 1, "   LIKALTj = ", -0.40938656437517995`],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064068242733*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["Suchrichtung  ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.46106406825916*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Acceleration Step  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.03125`", "}"}]}],
  SequenceForm["Acceleration Step  ", {0.03125}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.4610640694158278`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Acceleration Step, Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.03125`", "}"}]}],
  SequenceForm["Acceleration Step, Suchrichtung  ", {0.03125}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064069430778*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"j = \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"   LIKALTj = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "0.2652232527025844`"}]}],
  SequenceForm["j = ", 1, "   LIKALTj = ", -0.2652232527025844],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064070190585*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["Suchrichtung  ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.4610640702056847`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"-", "1"}], "}"}]}],
  SequenceForm["Suchrichtung  ", {-1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064072136307*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"j = \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"   LIKALTj = \"\>", "\[InvisibleSpace]", 
   "8.021364546327952`"}],
  SequenceForm["j = ", 1, "   LIKALTj = ", 8.021364546327952],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064072331753*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["Suchrichtung  ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064072347932*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Acceleration Step  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.0078125`", "}"}]}],
  SequenceForm["Acceleration Step  ", {0.0078125}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064073880269*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Acceleration Step, Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.0078125`", "}"}]}],
  SequenceForm["Acceleration Step, Suchrichtung  ", {0.0078125}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.4610640738942947`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"j = \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"   LIKALTj = \"\>", "\[InvisibleSpace]", 
   "8.202567124827178`"}],
  SequenceForm["j = ", 1, "   LIKALTj = ", 8.202567124827178],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064074852396*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["Suchrichtung  ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.4610640748970823`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"-", "1"}], "}"}]}],
  SequenceForm["Suchrichtung  ", {-1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064076783903*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"j = \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"   LIKALTj = \"\>", "\[InvisibleSpace]", 
   "8.594603412059818`"}],
  SequenceForm["j = ", 1, "   LIKALTj = ", 8.594603412059818],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064077371859*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["Suchrichtung  ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064077418908*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Acceleration Step  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.125`", "}"}]}],
  SequenceForm["Acceleration Step  ", {0.125}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.4610640781619463`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Acceleration Step, Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.125`", "}"}]}],
  SequenceForm["Acceleration Step, Suchrichtung  ", {0.125}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064078207056*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"j = \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"   LIKALTj = \"\>", "\[InvisibleSpace]", 
   "13.652203312961865`"}],
  SequenceForm["j = ", 1, "   LIKALTj = ", 13.652203312961865`],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064080094637*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["Suchrichtung  ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.4610640801376657`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"-", "1"}], "}"}]}],
  SequenceForm["Suchrichtung  ", {-1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064082033239*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"j = \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"   LIKALTj = \"\>", "\[InvisibleSpace]", 
   "13.923305679116167`"}],
  SequenceForm["j = ", 1, "   LIKALTj = ", 13.923305679116167`],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064083207553*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["Suchrichtung  ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064083250237*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Acceleration Step  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.015625`", "}"}]}],
  SequenceForm["Acceleration Step  ", {0.015625}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064084616954*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Acceleration Step, Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.015625`", "}"}]}],
  SequenceForm["Acceleration Step, Suchrichtung  ", {0.015625}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064084663093*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"j = \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"   LIKALTj = \"\>", "\[InvisibleSpace]", 
   "14.574977361632879`"}],
  SequenceForm["j = ", 1, "   LIKALTj = ", 14.574977361632879`],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064086889022*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["Suchrichtung  ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.4610640869566298`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"-", "1"}], "}"}]}],
  SequenceForm["Suchrichtung  ", {-1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064088881474*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"j = \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"   LIKALTj = \"\>", "\[InvisibleSpace]", 
   "14.880366466189347`"}],
  SequenceForm["j = ", 1, "   LIKALTj = ", 14.880366466189347`],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.4610640906393347`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["Suchrichtung  ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064090691166*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Acceleration Step  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.001953125`", "}"}]}],
  SequenceForm["Acceleration Step  ", {0.001953125}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.4610640927152433`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Acceleration Step, Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.001953125`", "}"}]}],
  SequenceForm["Acceleration Step, Suchrichtung  ", {0.001953125}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064092763225*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"j = \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"   LIKALTj = \"\>", "\[InvisibleSpace]", 
   "15.014617609952237`"}],
  SequenceForm["j = ", 1, "   LIKALTj = ", 15.014617609952237`],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.4610640949825706`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["Suchrichtung  ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.4610640950282593`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"-", "1"}], "}"}]}],
  SequenceForm["Suchrichtung  ", {-1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064097207106*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"j = \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"   LIKALTj = \"\>", "\[InvisibleSpace]", 
   "15.014617609952237`"}],
  SequenceForm["j = ", 1, "   LIKALTj = ", 15.014617609952237`],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.4610640993105392`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["Suchrichtung  ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064099358959*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"-", "1"}], "}"}]}],
  SequenceForm["Suchrichtung  ", {-1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.4610641015618467`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Acceleration Step  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.`", "}"}]}],
  SequenceForm["Acceleration Step  ", {0.}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.4610641039184647`*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064104032835*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.1`", "}"}]}],
  SequenceForm["Score: INC: ", {0.1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064104362912*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"INK: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.2154434690031884`", "}"}]}],
  SequenceForm["INK: ", {0.2154434690031884}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.4610641050592117`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064105489909*^9}],

Cell[BoxData["\<\"ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD\"\>"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064105540959*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064105591374*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {
         StyleBox["\[Null]",
          ShowStringCharacters->False], 
         TagBox["\<\"THETA\"\>",
          HoldForm], 
         TagBox["\<\"SCORE\"\>",
          HoldForm]},
        {"1", "0.40087890625`", 
         RowBox[{"-", "56.32747490343693`"}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxDividers->{
        "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
         "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.24]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
     "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[
     BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}]]], 
   "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
   "15.014617609952237`"}],
  SequenceForm[
   MatrixForm[{{0.40087890625, -56.32747490343693}}, 
    TableHeadings -> {Automatic, {"THETA", "SCORE"}}], "   Likelihood = ", 
   15.014617609952237`],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064105637823*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064105680888*^9}],

Cell[BoxData["\<\"WALD-TEST:\"\>"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064105728088*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064105774398*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"CHI \"\>",
       HoldForm], 
      TagBox["\<\"U \"\>",
       HoldForm], 
      TagBox["\<\"PROB \"\>",
       HoldForm], 
      TagBox["\<\"ALPHA \"\>",
       HoldForm]},
     {"1", "20.74234348836241`", "1", "5.254123077946815`*^-6", "0.05`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", "ALPHA "}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064105824347*^9}],

Cell[BoxData["\<\"NULLHYPOTHESE THETA = 0 ABLEHNEN\"\>"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064105875334*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064105925634*^9}],

Cell[BoxData["\<\"BONFERRONI-KONFIDENZINTERVALLE:\"\>"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064105995142*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064106048223*^9}],

Cell[BoxData["\<\"P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= \
1-ALPHA\"\>"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064106102598*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"QUANTIL Z(1-ALPHA/2U) = \"\>", "\[InvisibleSpace]", 
   "1.9599639845400527`"}],
  SequenceForm["QUANTIL Z(1-ALPHA/2U) = ", 1.9599639845400527`],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064106151621*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"THETA\"\>",
       HoldForm], 
      TagBox["\<\"GRENZE\"\>",
       HoldForm], 
      TagBox["\<\"STD\"\>",
       HoldForm]},
     {"1", "0.40087890625`", "0.1725171936915573`", "0.08802059377230961`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064106199337*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.46106410624697*^9}],

Cell[BoxData["\<\"Korrelation der ML-Sch\[ADoubleDot]tzer\"\>"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.4610641062945147`*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064106354684*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0.9999999999999999`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.46106410643148*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064106515799*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND \
EIGENWERTE\"\>"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064106608322*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064106706048*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0.007747624928029949`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.4610641067670794`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.4610641068632183`*^9}],

Cell[BoxData[
 RowBox[{"{", "0.007747624928029949`", "}"}]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064106916374*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064106963759*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX \
UND EIGENWERTE\"\>"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064107020618*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064107071694*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "129.0718135285723`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.46106410712302*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064107170828*^9}],

Cell[BoxData[
 RowBox[{"{", "129.0718135285723`", "}"}]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.4610641072158527`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.4610641072639027`*^9}],

Cell[BoxData["\<\"KOMPENSIERTE LIKELIHOOD\"\>"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.4610641073105183`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064107356814*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"U =  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  Nue = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "50", "}"}]}],
  SequenceForm["U =  ", 1, "  Nue = ", {50}],
  Editable->False]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064107408482*^9}],

Cell[BoxData["\<\"AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) \
AZENCOTT/DACUNHA-CASTELLE (A/D)\"\>"], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064107455534*^9}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {"\<\"\"\>", "\<\"LIK\"\>", "\<\"AIC\"\>", "\<\"SIC/RISS\"\>", "\<\"A/D\"\
\>"},
    {"\<\"Kompensator\"\>", "0", "1", GridBox[{
       {"1.956011502714073`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"1.3654186875213339`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"\<\"komp. Lik.\"\>", "15.014617609952237`", "14.014617609952237`", 
     GridBox[{
       {"13.058606107238164`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"13.649198922430903`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[1.4]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  TableForm[{{0, 1, {1.956011502714073}, {1.3654186875213339`}}, {
    15.014617609952237`, 14.014617609952237`, {13.058606107238164`}, {
     13.649198922430903`}}}, 
   TableHeadings -> {{"Kompensator", "komp. Lik."}, {
     "LIK", "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
   TableSpacing -> {1, 2}]]], "Print",
 CellChangeTimes->{3.461064028854377*^9, 3.461064107515193*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "0.5`", "0.40087890625`", "0.08802059377230961`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.460978602846575*^9, 3.46097940476475*^9, 3.4610637048238983`*^9, {
   3.4610638847833147`*^9, 3.461063936450362*^9}, 3.461063982746017*^9, 
   3.461065053235483*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"integ", "=", 
   RowBox[{"{", 
    RowBox[{"\"\<UT\>\"", ",", 
     RowBox[{"m", "=", "1"}], ",", 
     RowBox[{"eps", "=", 
      RowBox[{"10.", "^", 
       RowBox[{"-", "16"}]}]}], ",", 
     RowBox[{"ksigma", "=", "Infinity"}], ",", "0"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "k", ",", 
     "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
   RowBox[{
    StyleBox["GRIDSEARCH",
     FontColor->RGBColor[0, 0, 1]], "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"Y", ",", "X", ",", 
        RowBox[{"-", "9"}]}], "}"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
     "\t  ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", 
         RowBox[{"{", "}"}], ",", "integ"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
        "Lik", ",", "IndividualLikNonlin", ",", "Score", ",", "Hesse"}], 
        "}"}]}], "}"}], ",", "\n", "\t        ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Sing", "=", "False"}], ",", 
         RowBox[{"2", "Pi"}], ",", "0", ",", 
         RowBox[{"onlynorkorr", "=", "0"}], ",", "\"\<NorKorr\>\"", ",", 
         RowBox[{"supp", "=", ".9"}]}], "}"}], ",", 
       RowBox[{"KMAX", "=", "20"}], ",", 
       RowBox[{"EPS2", "=", ".0001"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", 
         RowBox[{"nhalf", "=", "9"}]}], "}"}], ",", 
       RowBox[{"PRINT", "=", 
        RowBox[{"0", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1"}], "}"}]}]}]}], "}"}]}], "]"}]}], 
  ";"}], "\n"}], "Input",
 CellChangeTimes->{{3.460975156820698*^9, 3.460975200746744*^9}, {
   3.460975282221939*^9, 3.460975316561496*^9}, {3.460975369862314*^9, 
   3.460975385546159*^9}, {3.460975417254572*^9, 3.4609754477819347`*^9}, {
   3.460975481712237*^9, 3.460975486455926*^9}, 3.4609764770111094`*^9, {
   3.460976559121996*^9, 3.4609765605836353`*^9}, {3.460977047930294*^9, 
   3.460977049487256*^9}, {3.460977630605905*^9, 3.460977632771017*^9}, 
   3.460977821939395*^9, {3.4609779192246237`*^9, 3.460977921739793*^9}, {
   3.460977955184973*^9, 3.460977955263098*^9}, {3.460977993196138*^9, 
   3.460977993252756*^9}, {3.461063665953705*^9, 3.461063684949086*^9}, {
   3.46106374093513*^9, 3.4610637409937773`*^9}, 3.4610638119440813`*^9, {
   3.461063869361333*^9, 3.4610638694374847`*^9}, {3.46106392631745*^9, 
   3.461063926384259*^9}, {3.461063969475252*^9, 3.461063969809992*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"j = \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"   LIKALTj = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "1499.9743991982366`"}]}],
  SequenceForm["j = ", 1, "   LIKALTj = ", -1499.9743991982366`],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.4610639706445103`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["Suchrichtung  ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063970657041*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"-", "1"}], "}"}]}],
  SequenceForm["Suchrichtung  ", {-1}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.4610639713104973`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"j = \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"   LIKALTj = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "433.6780437934503`"}]}],
  SequenceForm["j = ", 1, "   LIKALTj = ", -433.6780437934503],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063971381672*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["Suchrichtung  ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063971399823*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"-", "1"}], "}"}]}],
  SequenceForm["Suchrichtung  ", {-1}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.46106397203688*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Acceleration Step  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"-", "1.`"}], "}"}]}],
  SequenceForm["Acceleration Step  ", {-1.}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063972115254*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Acceleration Step, Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"-", "1.`"}], "}"}]}],
  SequenceForm["Acceleration Step, Suchrichtung  ", {-1.}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.4610639721294518`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"j = \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"   LIKALTj = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "75.52579016991815`"}]}],
  SequenceForm["j = ", 1, "   LIKALTj = ", -75.52579016991815],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063972309466*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["Suchrichtung  ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063972324129*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"j = \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"   LIKALTj = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "75.52579016991784`"}]}],
  SequenceForm["j = ", 1, "   LIKALTj = ", -75.52579016991784],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.4610639729715776`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["Suchrichtung  ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063972986643*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Acceleration Step  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.001953125`", "}"}]}],
  SequenceForm["Acceleration Step  ", {0.001953125}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.4610639736171618`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Acceleration Step, Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.001953125`", "}"}]}],
  SequenceForm["Acceleration Step, Suchrichtung  ", {0.001953125}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.4610639736316557`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"j = \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"   LIKALTj = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "75.52579016991783`"}]}],
  SequenceForm["j = ", 1, "   LIKALTj = ", -75.52579016991783],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.4610639742605267`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["Suchrichtung  ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063974274704*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"-", "1"}], "}"}]}],
  SequenceForm["Suchrichtung  ", {-1}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063974909007*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"j = \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"   LIKALTj = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "75.52579016991783`"}]}],
  SequenceForm["j = ", 1, "   LIKALTj = ", -75.52579016991783],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063975551402*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["Suchrichtung  ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.4610639755650873`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Suchrichtung  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"-", "1"}], "}"}]}],
  SequenceForm["Suchrichtung  ", {-1}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.4610639761994*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Acceleration Step  \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.`", "}"}]}],
  SequenceForm["Acceleration Step  ", {0.}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.4610639768508053`*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.46106397689332*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.1`", "}"}]}],
  SequenceForm["Score: INC: ", {0.1}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063976945393*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"INK: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.2154434690031884`", "}"}]}],
  SequenceForm["INK: ", {0.2154434690031884}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063977065424*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063977200015*^9}],

Cell[BoxData["\<\"ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD\"\>"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.4610639772399683`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063977299213*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {
         StyleBox["\[Null]",
          ShowStringCharacters->False], 
         TagBox["\<\"THETA\"\>",
          HoldForm], 
         TagBox["\<\"SCORE\"\>",
          HoldForm]},
        {"1", "0.25390625`", 
         RowBox[{"-", "3.410605131648481`*^-12"}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxDividers->{
        "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
         "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.24]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
     "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[
     BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}]]], 
   "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "75.52579016991783`"}]}],
  SequenceForm[
   MatrixForm[{{0.25390625, -3.410605131648481*^-12}}, 
    TableHeadings -> {Automatic, {"THETA", "SCORE"}}], 
   "   Likelihood = ", -75.52579016991783],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.4610639773603783`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063977414014*^9}],

Cell[BoxData["\<\"WALD-TEST:\"\>"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.4610639774669447`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.4610639775311203`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"CHI \"\>",
       HoldForm], 
      TagBox["\<\"U \"\>",
       HoldForm], 
      TagBox["\<\"PROB \"\>",
       HoldForm], 
      TagBox["\<\"ALPHA \"\>",
       HoldForm]},
     {"1", "9.60207512402024`", "1", "0.0019435760552822812`", "0.05`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", "ALPHA "}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063977585526*^9}],

Cell[BoxData["\<\"NULLHYPOTHESE THETA = 0 ABLEHNEN\"\>"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063977652953*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063977747876*^9}],

Cell[BoxData["\<\"BONFERRONI-KONFIDENZINTERVALLE:\"\>"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063977789402*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.46106397784829*^9}],

Cell[BoxData["\<\"P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= \
1-ALPHA\"\>"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063977903281*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"QUANTIL Z(1-ALPHA/2U) = \"\>", "\[InvisibleSpace]", 
   "1.9599639845400527`"}],
  SequenceForm["QUANTIL Z(1-ALPHA/2U) = ", 1.9599639845400527`],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063977968894*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"THETA\"\>",
       HoldForm], 
      TagBox["\<\"GRENZE\"\>",
       HoldForm], 
      TagBox["\<\"STD\"\>",
       HoldForm]},
     {"1", "0.25390625`", "0.16059755629542685`", "0.08193903437114151`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.4610639780317907`*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063978082884*^9}],

Cell[BoxData["\<\"Korrelation der ML-Sch\[ADoubleDot]tzer\"\>"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063978137497*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063978202485*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "1.`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063978299101*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063978342894*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND \
EIGENWERTE\"\>"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063978403883*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.4610639784691563`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0.006714005353675111`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063978538433*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063978605793*^9}],

Cell[BoxData[
 RowBox[{"{", "0.006714005353675111`", "}"}]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063978672288*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.4610639787387333`*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX \
UND EIGENWERTE\"\>"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063978806905*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063978900675*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "148.94238942669597`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063978944125*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063979013803*^9}],

Cell[BoxData[
 RowBox[{"{", "148.94238942669597`", "}"}]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063979072752*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.4610639791386633`*^9}],

Cell[BoxData["\<\"KOMPENSIERTE LIKELIHOOD\"\>"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063979189649*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063979255159*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"U =  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  Nue = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "50", "}"}]}],
  SequenceForm["U =  ", 1, "  Nue = ", {50}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.46106397932731*^9}],

Cell[BoxData["\<\"AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) \
AZENCOTT/DACUNHA-CASTELLE (A/D)\"\>"], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063979415865*^9}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {"\<\"\"\>", "\<\"LIK\"\>", "\<\"AIC\"\>", "\<\"SIC/RISS\"\>", "\<\"A/D\"\
\>"},
    {"\<\"Kompensator\"\>", "0", "1", GridBox[{
       {"1.956011502714073`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {"1.3654186875213339`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]},
    {"\<\"komp. Lik.\"\>", 
     RowBox[{"-", "75.52579016991783`"}], 
     RowBox[{"-", "76.52579016991783`"}], GridBox[{
       {
        RowBox[{"-", "77.4818016726319`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], GridBox[{
       {
        RowBox[{"-", "76.89120885743915`"}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.1]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[1.4]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  TableForm[{{
    0, 1, {1.956011502714073}, {
     1.3654186875213339`}}, {-75.52579016991783, -76.52579016991783, \
{-77.4818016726319}, {-76.89120885743915}}}, 
   TableHeadings -> {{"Kompensator", "komp. Lik."}, {
     "LIK", "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
   TableSpacing -> {1, 2}]]], "Print",
 CellChangeTimes->{
  3.460976561672834*^9, 3.460976618070512*^9, {3.460977029699313*^9, 
   3.4609770510525827`*^9}, {3.4609771434161*^9, 3.460977167375759*^9}, 
   3.460977198632484*^9, 3.460977347754587*^9, 3.460977470719572*^9, {
   3.460977511405946*^9, 3.460977533372007*^9}, {3.460977615141067*^9, 
   3.46097763378931*^9}, 3.4609777292494717`*^9, 3.46097782305131*^9, 
   3.4609779261512814`*^9, 3.46097795624446*^9, 3.460977994485819*^9, 
   3.460978230098847*^9, 3.4609784797431393`*^9, 3.4609787400048647`*^9, 
   3.461063686558175*^9, 3.461063742194809*^9, 3.461063813204768*^9, 
   3.461063870648508*^9, 3.461063927312289*^9, 3.461063979459304*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "0.5`", "0.25390625`", "0.08193903437114151`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.460978602846575*^9, 3.46097940476475*^9, 3.4610637048238983`*^9, {
   3.4610638847833147`*^9, 3.461063936450362*^9}, 3.461063982746017*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"THETA", "\[IndentingNewLine]", 
 RowBox[{"LIKI", "//", "plot1"}]}], "Input",
 CellChangeTimes->{{3.4609780519756727`*^9, 3.460978054206498*^9}, {
  3.460978279603469*^9, 3.4609782807948*^9}, {3.4609794152737837`*^9, 
  3.460979417437869*^9}}],

Cell[BoxData[
 RowBox[{"{", "0.25390625`", "}"}]], "Output",
 CellChangeTimes->{
  3.460978056608849*^9, {3.460978277142726*^9, 3.460978281813428*^9}, {
   3.460979408285033*^9, 3.460979417544181*^9}, 3.4610637103083563`*^9, 
   3.461063940905793*^9, 3.461063986419786*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[0, 0, 1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
    {Opacity[1], 
     LineBox[{{0., -1499.9743991982366`}, {1., -433.6780437934503}, {
      2., -75.52579016991815}, {3., -75.52579016991784}, {
      4., -75.52579016991783}, {5., -75.52579016991783}, {
      6., -75.52579016991783}}]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, -1400.},
  DisplayFunction->Identity,
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.460978056608849*^9, {3.460978277142726*^9, 3.460978281813428*^9}, {
   3.460979408285033*^9, 3.460979417544181*^9}, 3.4610637103083563`*^9, 
   3.461063940905793*^9, 3.461063986440035*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Nichtlinear", "/", "NorKorr"}], ",", " ", "onlyNorkorr"}]], "Input",\

 CellChangeTimes->{{3.4608942301762238`*^9, 3.460894230773149*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "scoreii", ",", "k", 
      ",", "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
    RowBox[{"BFGS", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"Y", ",", "X", ",", 
         RowBox[{"-", "9"}]}], "}"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      "\t  ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"IdioNonlin", ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"m", "=", "50"}], ",", 
          RowBox[{"eps", "=", 
           RowBox[{"10.", "^", 
            RowBox[{"-", "16"}]}]}], ",", 
          RowBox[{"ksigma", "=", "Infinity"}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Lik", ",", "IndividualLikNonlin", ",", "Score", ",", "Hesse"}], 
         "}"}]}], "}"}], ",", "\[IndentingNewLine]", "            ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Sing", "=", "False"}], ",", 
          RowBox[{"2", "Pi"}], ",", "0", ",", 
          RowBox[{"onlynorkorr", "=", "1"}], ",", "\"\<NorKorr\>\""}], "}"}], 
        ",", 
        RowBox[{"KMAX", "=", "20"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EPS1", "=", ".0001"}], ",", 
          RowBox[{"EPS2", "=", ".0001"}]}], "}"}], ",", "\[IndentingNewLine]",
         "             ", 
        RowBox[{"OPTION", "=", "0"}], ",", 
        RowBox[{"PRINT", "=", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1"}], "}"}]}]}], "}"}]}], "]"}]}], ";"}], 
  "                                                                           \
     "}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113330285616*^9, 3.460113346379695*^9}, {
   3.460200648978776*^9, 3.4602006503583603`*^9}, {3.460200794874672*^9, 
   3.4602007984595947`*^9}, 3.460201903279232*^9, {3.460201941045977*^9, 
   3.4602019411313553`*^9}, {3.460279278878285*^9, 3.460279290392777*^9}, {
   3.460279385569292*^9, 3.4602794078107224`*^9}, 3.460279483282811*^9, {
   3.460282734453003*^9, 3.46028273588818*^9}, {3.460283616696549*^9, 
   3.460283634147719*^9}, {3.4602836706901093`*^9, 3.460283671258127*^9}, {
   3.4602837458995867`*^9, 3.4602837460095263`*^9}, {3.460283977779047*^9, 
   3.4602839782382393`*^9}, {3.460284094017385*^9, 3.460284112248164*^9}, {
   3.4602842039019938`*^9, 3.460284237509654*^9}, {3.460285585933895*^9, 
   3.460285590933837*^9}, 3.460367196326754*^9, {3.460435757860738*^9, 
   3.460435758943184*^9}, {3.460435888109399*^9, 3.460435888167045*^9}, {
   3.4604359232590923`*^9, 3.4604359236923323`*^9}, {3.460800256155857*^9, 
   3.4608002648029137`*^9}, {3.460800465883931*^9, 3.46080049502407*^9}, {
   3.460894234690484*^9, 3.460894234764517*^9}, {3.460951234291463*^9, 
   3.460951235236864*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Tiefe von data = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["Tiefe von data = ", 5],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951238903522*^9}],

Cell[BoxData["\<\"L\[ADoubleDot]nge der Paneldaten\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951238922586*^9}],

Cell[BoxData[
 RowBox[{"{", "50", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.4609512389434843`*^9}],

Cell[BoxData["\<\"***********************LSDE1********************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951238965458*^9}],

Cell[BoxData["\<\"***********************MODUL:    BFGS \
(skeleton)**************\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951238984947*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951239002428*^9}],

Cell[BoxData["\<\"Technical Output\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.4609512390203533`*^9}],

Cell[BoxData["IndividualLikNonlin"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951239039151*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951239057015*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"KMAX\"\>",
       HoldForm], 
      TagBox["\<\"EPS1\"\>",
       HoldForm], 
      TagBox["\<\"EPS2\"\>",
       HoldForm], 
      TagBox["\<\"K\"\>",
       HoldForm], 
      TagBox["\<\"Q\"\>",
       HoldForm], 
      TagBox["\<\"n\"\>",
       HoldForm], 
      TagBox["\<\"T\"\>",
       HoldForm], 
      TagBox["\<\"OPTION\"\>",
       HoldForm]},
     {"1", "20", "0.0001`", "0.0001`", "2", "1", "1", "49", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"KMAX", "EPS1", "EPS2", "K", "Q", "n", "T", "OPTION"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.46095123907405*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951239088518*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"MAXSTEP\"\>",
       HoldForm], 
      TagBox["\<\"MINSTEP\"\>",
       HoldForm], 
      TagBox["\<\"BOUND\"\>",
       HoldForm], 
      TagBox["\<\"STEPREDUCE\"\>",
       HoldForm], 
      TagBox["\<\"FMAX\"\>",
       HoldForm]},
     {"1", "1", "1.`*^-10", "1.`*^-6", "4", "1000"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"MAXSTEP", "MINSTEP", "BOUND", "STEPREDUCE", "FMAX"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.4609512391053247`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951239122292*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"RESAMPLING\"\>",
       HoldForm], 
      TagBox["\<\"FDIGITS\"\>",
       HoldForm], 
      TagBox["\<\"TYP\"\>",
       HoldForm], 
      TagBox["\<\"YMAX\"\>",
       HoldForm], 
      TagBox["\<\"ANALGRAD\"\>",
       HoldForm], 
      TagBox["\<\"FACTOR\"\>",
       HoldForm], 
      TagBox["\<\"CSEED\"\>",
       HoldForm]},
     {"1", "True", "2", "1", "1.`*^8", "False", "1.`", 
      RowBox[{"-", "999"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {
      "RESAMPLING", "FDIGITS", "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}},
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951239185855*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951239266083*^9}],

Cell[BoxData["\<\"    SCALING\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.4609512393205423`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "::", "\<\"nmtx\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The first two levels of the \
one-dimensional list \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\
\\!\\({}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" cannot be \
transposed.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Transpose\\\", ButtonNote -> \\\"Transpose::nmtx\\\
\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.460113347438837*^9, 3.4601140477211742`*^9, 3.460114171488365*^9, 
   3.4601142582303123`*^9, 3.46011431981378*^9, 3.4601210026174927`*^9, 
   3.4602006082555428`*^9, 3.4602006525509787`*^9, 3.4602007997492933`*^9, {
   3.460201893745349*^9, 3.460201903902554*^9}, 3.4602019417761383`*^9, 
   3.460279294169009*^9, 3.460279424327683*^9, 3.4602794918395157`*^9, 
   3.460282465738028*^9, 3.4602825470673647`*^9, 3.460282687933013*^9, 
   3.4602827362471*^9, 3.460282807351432*^9, 3.460282913928569*^9, 
   3.460283210827161*^9, 3.460283352033407*^9, 3.460283407184712*^9, {
   3.460283619834437*^9, 3.460283671655117*^9}, 3.460283747410516*^9, 
   3.460283804801373*^9, {3.460283909419492*^9, 3.460283979704739*^9}, 
   3.46028403988277*^9, {3.4602840959065733`*^9, 3.460284112635261*^9}, 
   3.460284241484562*^9, 3.4602855917581997`*^9, {3.460367187530768*^9, 
   3.4603671971813374`*^9}, 3.460435693346806*^9, {3.460435725332974*^9, 
   3.460435760027495*^9}, 3.460435797489111*^9, 3.460435835765499*^9, {
   3.460435866970508*^9, 3.460435925364402*^9}, 3.460435963989526*^9, 
   3.460440284356594*^9, {3.460800275063458*^9, 3.460800302789452*^9}, {
   3.460800468359326*^9, 3.460800496223838*^9}, 3.460893308685207*^9, 
   3.460894237002737*^9, 3.460951239377091*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  RowBox[{"Transpose", "[", 
   RowBox[{"{", "}"}], "]"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
    0]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951239446969*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951239507848*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951239598371*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951239654894*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STARTWERT THETA0 = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "2.5`", "}"}]}],
  SequenceForm["STARTWERT THETA0 = ", {2.5}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951239707582*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.25`", "}"}]}],
  SequenceForm["Score: INC: ", {0.25}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951241913068*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "0.2784619620392732`", "}"}], ",", 
   RowBox[{"-", "147.39076739323482`"}]}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951244894907*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951244937255*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["BFGS: Iteration = ", 1],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951245011518*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -147.321664190211800\"\>",
     -147.32166419021178`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-147.32166419021178`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.4609512479405212`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -147.390767393234800\"\>",
     -147.39076739323482`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-147.39076739323482`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951247984016*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.069103203023047\"\>",
     0.0691032030230474,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.0691032030230474, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951248035475*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951248094923*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.7785\"\>",
         2.778461962039273,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.5000\"\>",
         2.5,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2785\"\>",
         0.2784619620392732,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2785\"\>",
         0.2784619620392732,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.4609512481665487`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951248217568*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.4609512482795362`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.2778461962039273`", "}"}]}],
  SequenceForm["Score: INC: ", {0.2778461962039273}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.4609512509537487`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.9693876761449252`"}],
  SequenceForm["NOISE  ", 1.9693876761449252`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951253931869*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "0.18234879814984564`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "12.896392498502047`"}],
  SequenceForm["*BFGSUP ", 0.18234879814984564`, "  ", 12.896392498502047`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.46095125397279*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.3661714778603428`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.3661714778603428, " = Elastizitaet(d l/l)/(d theta/theta)"],
  
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951254026884*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.4609512540835733`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "2"}],
  SequenceForm["BFGS: Iteration = ", 2],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.46095125449009*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -147.321143088540800\"\>",
     -147.32114308854082`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -147.321664190211800\"\>",
     -147.32166419021178`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[-147.32114308854082`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-147.32166419021178`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951259914832*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -147.321143088540800\"\>",
     -147.32114308854082`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-147.32114308854082`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.4609512599559383`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -147.321664190211800\"\>",
     -147.32166419021178`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-147.32166419021178`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951260008954*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000521101670955\"\>",
     0.0005211016709552041,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.0005211016709552041, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.4609512600657663`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.4609512601293097`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.7098\"\>",
         2.709830801141674,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.7785\"\>",
         2.778461962039273,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0686\"\>",
         -0.06863116089759908,
         AutoDelete->True], 
        InterpretationBox["\<\"-19.4150\"\>",
         -19.415414799409977`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951260193448*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.4609512602487173`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 70.72\"\>",
         70.72375924246236,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951260296455*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.27098308011416744`", "}"}]}],
  SequenceForm["Score: INC: ", {0.27098308011416744`}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951262951911*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.9956483730278785`"}],
  SequenceForm["NOISE  ", 1.9956483730278785`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951265913588*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "0.7719812385363433`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "3.0018706374694646`"}],
  SequenceForm["*BFGSUP ", 0.7719812385363433, "  ", 3.0018706374694646`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.46095126595783*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.009952442831154875`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.009952442831154875, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.46095126604*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.4609512660905724`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "3"}],
  SequenceForm["BFGS: Iteration = ", 3],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951266145438*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -146.703417153628400\"\>",
     -146.70341715362844`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-146.70341715362844`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951268924176*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -147.321143088540800\"\>",
     -147.32114308854082`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-147.32114308854082`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951268965127*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.617725934912386\"\>",
     0.6177259349123858,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.6177259349123858, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951269015463*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951269065371*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.7079\"\>",
         2.707863358714276,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.7098\"\>",
         2.709830801141674,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0020\"\>",
         -0.0019674424273978404`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.5411\"\>",
         -0.5410689308688075,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951269137248*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951269185212*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 275.\"\>",
         275.0113158759267,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951269241035*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.27078633587142764`", "}"}]}],
  SequenceForm["Score: INC: ", {0.27078633587142764`}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951271968938*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "0.33637610652171784`"}],
  SequenceForm["NOISE  ", 0.33637610652171784`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951274913808*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0521014762425655`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0521014762425655, " = Elastizitaet(d l/l)/(d theta/theta)"],
  
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951274955331*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951275008542*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "4"}],
  SequenceForm["BFGS: Iteration = ", 4],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.46095127506011*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -146.703417153628400\"\>",
     -146.70341715362838`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -146.703417153628400\"\>",
     -146.70341715362844`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[-146.70341715362838`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-146.70341715362844`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951281004583*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -146.703417153628400\"\>",
     -146.70341715362844`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -146.703417153628400\"\>",
     -146.70341715362844`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[-146.70341715362844`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-146.70341715362844`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951284056657*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -146.703417153628400\"\>",
     -146.70341715362838`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -146.703417153628400\"\>",
     -146.70341715362844`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[-146.70341715362838`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-146.70341715362844`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951287017214*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -146.703417153628300\"\>",
     -146.70341715362835`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -146.703417153628400\"\>",
     -146.70341715362844`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[-146.70341715362835`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-146.70341715362844`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951289998908*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -146.703417153628400\"\>",
     -146.70341715362838`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -146.703417153628400\"\>",
     -146.70341715362844`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
   PaddedForm[-146.70341715362838`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-146.70341715362844`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, {3.460800468097117*^9, 
   3.460800495927718*^9}, 3.46089330837293*^9, 3.460894236526106*^9, 
   3.460951292957058*^9}]
}, Open  ]],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.460951294573145*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "0.5`", "0.7273677135629004`", "0.06797048796548832`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.460113389973647*^9, 3.460114056100081*^9, 3.460114179071628*^9, 
   3.4601142697179193`*^9, 3.460114343759589*^9, 3.460121016537031*^9, 
   3.4602008503444023`*^9, 3.460201923221129*^9, 3.460201965915328*^9, 
   3.4602793122704687`*^9, 3.460279517413031*^9, 3.46028255805007*^9, 
   3.4603672164787407`*^9, 3.460800336801489*^9, {3.460800482426375*^9, 
   3.460800510638279*^9}, 3.460893981101018*^9, 3.460894289710239*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Nichtlinear", "/", "NorKorr"}], ",", " ", "onlyNorkorr"}]], "Input",\

 CellChangeTimes->{{3.460367266700344*^9, 3.46036726904226*^9}, {
   3.460800444634096*^9, 3.460800446133922*^9}, 3.4609525350024*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "scoreii", ",", "k", 
      ",", "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
    RowBox[{"BFGS", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"Y", ",", "X", ",", 
         RowBox[{"-", "9"}]}], "}"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      "\t  ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"IdioNonlin", ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"m", "=", "100"}], ",", 
          RowBox[{"eps", "=", 
           RowBox[{"10.", "^", 
            RowBox[{"-", "16"}]}]}], ",", 
          RowBox[{"ksigma", "=", "Infinity"}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Lik", ",", "IndividualLikNonlin", ",", "Score", ",", "Hesse"}], 
         "}"}]}], "}"}], ",", "\[IndentingNewLine]", "            ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Sing", "=", "False"}], ",", 
          RowBox[{"2", "Pi"}], ",", "0", ",", 
          RowBox[{"onlynorkorr", "=", "1"}], ",", "\"\<NorKorr\>\"", ",", 
          RowBox[{"support", "=", "Automatic"}]}], "}"}], ",", 
        RowBox[{"KMAX", "=", "20"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EPS1", "=", ".0001"}], ",", 
          RowBox[{"EPS2", "=", ".0001"}]}], "}"}], ",", "\[IndentingNewLine]",
         "             ", 
        RowBox[{"OPTION", "=", "0"}], ",", 
        RowBox[{"PRINT", "=", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1"}], "}"}]}]}], "}"}]}], "]"}]}], ";"}], 
  "                                                                           \
     "}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113330285616*^9, 3.460113346379695*^9}, {
   3.460200648978776*^9, 3.4602006503583603`*^9}, {3.460200794874672*^9, 
   3.4602007984595947`*^9}, 3.460201903279232*^9, {3.460201941045977*^9, 
   3.4602019411313553`*^9}, {3.460279278878285*^9, 3.460279290392777*^9}, {
   3.460279385569292*^9, 3.4602794078107224`*^9}, 3.460279483282811*^9, {
   3.460282734453003*^9, 3.46028273588818*^9}, {3.460283616696549*^9, 
   3.460283634147719*^9}, {3.4602836706901093`*^9, 3.460283671258127*^9}, {
   3.4602837458995867`*^9, 3.4602837460095263`*^9}, {3.460283977779047*^9, 
   3.4602839782382393`*^9}, {3.460284094017385*^9, 3.460284112248164*^9}, {
   3.4602842039019938`*^9, 3.460284237509654*^9}, {3.460285585933895*^9, 
   3.460285590933837*^9}, 3.460367196326754*^9, {3.460435757860738*^9, 
   3.460435758943184*^9}, {3.460435888109399*^9, 3.460435888167045*^9}, {
   3.4604359232590923`*^9, 3.4604359236923323`*^9}, {3.460800256155857*^9, 
   3.4608002648029137`*^9}, 3.46089401382297*^9, {3.460894325881374*^9, 
   3.460894341428179*^9}, {3.460952543293243*^9, 3.460952551118792*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Tiefe von data = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["Tiefe von data = ", 5],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.4609525526707983`*^9}],

Cell[BoxData["\<\"L\[ADoubleDot]nge der Paneldaten\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.4609525527404833`*^9}],

Cell[BoxData[
 RowBox[{"{", "50", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952552793089*^9}],

Cell[BoxData["\<\"***********************LSDE1********************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.4609525528458633`*^9}],

Cell[BoxData["\<\"***********************MODUL:    BFGS \
(skeleton)**************\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952552897794*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.46095255291462*^9}],

Cell[BoxData["\<\"Technical Output\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.46095255292934*^9}],

Cell[BoxData["IndividualLikNonlin"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.46095255294268*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.4609525529560823`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"KMAX\"\>",
       HoldForm], 
      TagBox["\<\"EPS1\"\>",
       HoldForm], 
      TagBox["\<\"EPS2\"\>",
       HoldForm], 
      TagBox["\<\"K\"\>",
       HoldForm], 
      TagBox["\<\"Q\"\>",
       HoldForm], 
      TagBox["\<\"n\"\>",
       HoldForm], 
      TagBox["\<\"T\"\>",
       HoldForm], 
      TagBox["\<\"OPTION\"\>",
       HoldForm]},
     {"1", "20", "0.0001`", "0.0001`", "2", "1", "1", "49", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"KMAX", "EPS1", "EPS2", "K", "Q", "n", "T", "OPTION"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952553013917*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952553090661*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"MAXSTEP\"\>",
       HoldForm], 
      TagBox["\<\"MINSTEP\"\>",
       HoldForm], 
      TagBox["\<\"BOUND\"\>",
       HoldForm], 
      TagBox["\<\"STEPREDUCE\"\>",
       HoldForm], 
      TagBox["\<\"FMAX\"\>",
       HoldForm]},
     {"1", "1", "1.`*^-10", "1.`*^-6", "4", "1000"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"MAXSTEP", "MINSTEP", "BOUND", "STEPREDUCE", "FMAX"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.46095255313544*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.4609525532117157`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"RESAMPLING\"\>",
       HoldForm], 
      TagBox["\<\"FDIGITS\"\>",
       HoldForm], 
      TagBox["\<\"TYP\"\>",
       HoldForm], 
      TagBox["\<\"YMAX\"\>",
       HoldForm], 
      TagBox["\<\"ANALGRAD\"\>",
       HoldForm], 
      TagBox["\<\"FACTOR\"\>",
       HoldForm], 
      TagBox["\<\"CSEED\"\>",
       HoldForm]},
     {"1", "True", "2", "1", "1.`*^8", "False", "1.`", 
      RowBox[{"-", "999"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {
      "RESAMPLING", "FDIGITS", "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}},
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952553261801*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952553323432*^9}],

Cell[BoxData["\<\"    SCALING\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.4609525533778687`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "::", "\<\"nmtx\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The first two levels of the \
one-dimensional list \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\
\\!\\({}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" cannot be \
transposed.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Transpose\\\", ButtonNote -> \\\"Transpose::nmtx\\\
\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.460113347438837*^9, 3.4601140477211742`*^9, 3.460114171488365*^9, 
   3.4601142582303123`*^9, 3.46011431981378*^9, 3.4601210026174927`*^9, 
   3.4602006082555428`*^9, 3.4602006525509787`*^9, 3.4602007997492933`*^9, {
   3.460201893745349*^9, 3.460201903902554*^9}, 3.4602019417761383`*^9, 
   3.460279294169009*^9, 3.460279424327683*^9, 3.4602794918395157`*^9, 
   3.460282465738028*^9, 3.4602825470673647`*^9, 3.460282687933013*^9, 
   3.4602827362471*^9, 3.460282807351432*^9, 3.460282913928569*^9, 
   3.460283210827161*^9, 3.460283352033407*^9, 3.460283407184712*^9, {
   3.460283619834437*^9, 3.460283671655117*^9}, 3.460283747410516*^9, 
   3.460283804801373*^9, {3.460283909419492*^9, 3.460283979704739*^9}, 
   3.46028403988277*^9, {3.4602840959065733`*^9, 3.460284112635261*^9}, 
   3.460284241484562*^9, 3.4602855917581997`*^9, {3.460367187530768*^9, 
   3.4603671971813374`*^9}, 3.460435693346806*^9, {3.460435725332974*^9, 
   3.460435760027495*^9}, 3.460435797489111*^9, 3.460435835765499*^9, {
   3.460435866970508*^9, 3.460435925364402*^9}, 3.460435963989526*^9, 
   3.460440284356594*^9, {3.460800275063458*^9, 3.460800302789452*^9}, 
   3.460893988423676*^9, 3.460894037807211*^9, 3.4608943443245583`*^9, 
   3.4608944245151253`*^9, 3.460952553429626*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  RowBox[{"Transpose", "[", 
   RowBox[{"{", "}"}], "]"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
    0]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952553482416*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952553609578*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952553676318*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952553717615*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STARTWERT THETA0 = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "2.5`", "}"}]}],
  SequenceForm["STARTWERT THETA0 = ", {2.5}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952553775683*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.25`", "}"}]}],
  SequenceForm["Score: INC: ", {0.25}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952558865858*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"-", "7.230502208071584`"}], "}"}], ",", 
   RowBox[{"-", "144.75292685093638`"}]}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.4609525650544662`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.4609525650934553`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["BFGS: Iteration = ", 1],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.4609525651512127`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -134.908125485624300\"\>",
     -134.90812548562434`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-134.90812548562434`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952571275339*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -144.752926850936400\"\>",
     -144.75292685093638`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-144.75292685093638`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952571325337*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     9.844801365312040\"\>",
     9.844801365312037,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[9.844801365312037, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952571375968*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952571423077*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.5000\"\>",
         1.5,
         AutoDelete->True], 
        InterpretationBox["\<\" 2.5000\"\>",
         2.5,
         AutoDelete->True], 
        InterpretationBox["\<\"-1.0000\"\>",
         -0.9999999999999999,
         AutoDelete->True], 
        InterpretationBox["\<\"-7.2305\"\>",
         -7.230502208071584,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952571478263*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.4609525715452557`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.4609525716079397`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.15000000000000002`", "}"}]}],
  SequenceForm["Score: INC: ", {0.15000000000000002`}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952577641325*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.292740830828465`"}],
  SequenceForm["NOISE  ", 3.292740830828465],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.46095258394407*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.28571562321816524`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.28571562321816524`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952583961237*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.46095258397569*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "2"}],
  SequenceForm["BFGS: Iteration = ", 2],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.4609525839892683`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -143.154775554070700\"\>",
     -143.15477555407065`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -134.908125485624300\"\>",
     -134.90812548562434`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[-143.15477555407065`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-134.90812548562434`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952596320693*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -136.704382779139900\"\>",
     -136.70438277913988`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -134.908125485624300\"\>",
     -134.90812548562434`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[-136.70438277913988`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-134.90812548562434`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.4609526024697437`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -134.890718654438600\"\>",
     -134.89071865443861`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -134.908125485624300\"\>",
     -134.90812548562434`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[-134.89071865443861`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-134.90812548562434`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952608564961*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -134.890718654438600\"\>",
     -134.89071865443861`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-134.89071865443861`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952608578595*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -134.908125485624300\"\>",
     -134.90812548562434`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-134.90812548562434`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952608591877*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.017406831185724\"\>",
     0.01740683118572406,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.01740683118572406, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952608633416*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.4609526086851597`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.4844\"\>",
         1.484375,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.5000\"\>",
         1.5,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0156\"\>",
         -0.015625,
         AutoDelete->True], 
        InterpretationBox["\<\"-25.6970\"\>",
         -25.696906100213063`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.4609526087356*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952608791648*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952608848981*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.1484375`", "}"}]}],
  SequenceForm["Score: INC: ", {0.1484375}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952614737052*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "5.16128204008814`"}],
  SequenceForm["NOISE  ", 5.16128204008814],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952620990333*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.2851859317956768`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.2851859317956768, " = Elastizitaet(d l/l)/(d theta/theta)"],
  
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952621028146*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.46095262107961*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "3"}],
  SequenceForm["BFGS: Iteration = ", 3],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.4609526211291523`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -143.342125713553000\"\>",
     -143.342125713553,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -134.890718654438600\"\>",
     -134.89071865443861`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[-143.342125713553, {20, 15}], "  LIKALT  ", 
   PaddedForm[-134.89071865443861`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952633428019*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -136.745168408265200\"\>",
     -136.74516840826516`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -134.890718654438600\"\>",
     -134.89071865443861`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[-136.74516840826516`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-134.89071865443861`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952639585576*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -136.453868857709600\"\>",
     -136.45386885770964`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -134.890718654438600\"\>",
     -134.89071865443861`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[-136.45386885770964`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-134.89071865443861`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952645728088*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -134.890718654438700\"\>",
     -134.89071865443867`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -134.890718654438600\"\>",
     -134.89071865443861`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[-134.89071865443867`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-134.89071865443861`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952651885215*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -134.890718654438800\"\>",
     -134.89071865443884`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -134.890718654438600\"\>",
     -134.89071865443861`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
   PaddedForm[-134.89071865443884`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-134.89071865443861`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952658031234*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -134.890718654438700\"\>",
     -134.89071865443867`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -134.890718654438600\"\>",
     -134.89071865443861`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
   PaddedForm[-134.89071865443867`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-134.89071865443861`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952664205831*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -134.890718654438600\"\>",
     -134.89071865443861`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"  -134.890718654438600\"\>",
     -134.89071865443861`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 7, "  LIKNEU  ", 
   PaddedForm[-134.89071865443861`, {20, 15}], "  LIKALT  ", 
   PaddedForm[-134.89071865443861`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460279424101527*^9, 3.4602794915511417`*^9, 3.460282465537628*^9, 
   3.460282546246922*^9, 3.4602826876717157`*^9, 3.460282736022657*^9, 
   3.460282807076584*^9, 3.460282913672113*^9, 3.460283210282558*^9, 
   3.460283351791383*^9, 3.4602834070062532`*^9, {3.460283619376721*^9, 
   3.460283671395679*^9}, 3.460283747141637*^9, 3.460283804003125*^9, {
   3.460283908741098*^9, 3.4602839793492117`*^9}, 3.460284039652686*^9, {
   3.4602840954689093`*^9, 3.460284112431067*^9}, 3.460284241116866*^9, 
   3.460285591072196*^9, {3.460367187077641*^9, 3.4603671969390717`*^9}, 
   3.460435692661553*^9, {3.4604357247360363`*^9, 3.460435759767291*^9}, 
   3.460435797064102*^9, 3.460435835015622*^9, {3.460435866592462*^9, 
   3.4604359250231256`*^9}, 3.460435963407968*^9, 3.4604402835609217`*^9, {
   3.460800274676119*^9, 3.4608003021249447`*^9}, 3.46089398769868*^9, 
   3.4608940373328533`*^9, 3.460894343830059*^9, 3.460894423990407*^9, 
   3.460952670347458*^9}]
}, Open  ]],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.460952676071456*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "0.5`", "0.4793862822078073`", "0.005883114625976594`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.460894523181237*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["idiographisches Modell, nichtlinear, P=1", "Section",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460112339653429*^9, 3.460112348475265*^9}, {
  3.460262521364668*^9, 3.4602625343677998`*^9}, {3.46054792195807*^9, 
  3.460547924645691*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"<<", "Kronecker.m"}]], "Input",
 CellChangeTimes->{{3.46026403353458*^9, 3.4602640402033443`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Set", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Correlation\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Options[Correlation]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/Set\\\", ButtonNote -> \
\\\"Set::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4602640404221287`*^9, 3.460279177814375*^9, 
  3.460363882363975*^9, 3.460701403877467*^9, 3.4607125165816793`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDelayed", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(KroneckerProduct\\), \\\"MT\\\
\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(KroneckerProduct[\\(\\(a_, b_\
\\)\\)]\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/SetDelayed\\\", ButtonNote -> \
\\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4602640404221287`*^9, 3.460279177814375*^9, 
  3.460363882363975*^9, 3.460701403877467*^9, 3.4607125166398153`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDelayed", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Correlation\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Correlation[y_]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/SetDelayed\\\", ButtonNote -> \
\\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4602640404221287`*^9, 3.460279177814375*^9, 
  3.460363882363975*^9, 3.460701403877467*^9, 3.4607125166472397`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDelayed", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Correlation\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Correlation[\\(\\(x_, y_, \\(\
\\(scatter_ : 0\\)\\), opts___\\)\\)]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/SetDelayed\\\", ButtonNote -> \
\\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4602640404221287`*^9, 3.460279177814375*^9, 
  3.460363882363975*^9, 3.460701403877467*^9, 3.460712516653963*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Further output of \\\\\\\"\\\
\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(SetDelayed :: \\\"write\\\
\"\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" will be \
suppressed during this calculation.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/stop\\\", \
ButtonNote -> \\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4602640404221287`*^9, 3.460279177814375*^9, 
  3.460363882363975*^9, 3.460701403877467*^9, 3.4607125166588717`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"<<", "Kalman.exakt.impl.m"}]], "Input",
 CellChangeTimes->{{3.460263837588685*^9, 3.460263853906254*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"newpkg\"\>"}], 
  RowBox[{
  ":", " "}], \
"\<\"\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"NumericalMath`GaussianQuadrature`\\\
\"\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is now \
available as the \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"Numerical Differential \
Equation Analysis Package\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\". See the Compatibility \
Guide for updating information.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, \
ButtonData:>\\\"paclet:Compatibility/Tutorials/NumericalMath/\
GaussianQuadrature\\\", ButtonNote -> \\\"General::newpkg\\\"]\\)\"\>"}]], \
"Message", "MSG",
 CellChangeTimes->{3.460263854361351*^9, 3.4602640433774548`*^9, 
  3.460279180358728*^9, 3.460363884441977*^9, 3.4607014059098043`*^9, 
  3.4607125184747877`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "::", "\<\"wrsym\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Symbol \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(RandomMultinomial\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/Clear\\\", ButtonNote -> \
\\\"Clear::wrsym\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.460263854361351*^9, 3.4602640433774548`*^9, 
  3.460279180358728*^9, 3.460363884441977*^9, 3.4607014059098043`*^9, 
  3.460712518521914*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDelayed", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(RandomMultinomial\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(RandomMultinomial[\\(\\(xij_, \
pij_, n_\\)\\)]\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/SetDelayed\\\", ButtonNote -> \
\\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.460263854361351*^9, 3.4602640433774548`*^9, 
  3.460279180358728*^9, 3.460363884441977*^9, 3.4607014059098043`*^9, 
  3.460712518526361*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "::", "\<\"wrsym\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Symbol \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(RandomNumbers\\), \\\"MT\\\"]\
\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is Protected.\\\\\\\"\\\", \\\"MT\
\\\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\
\", ButtonFrame->None, ButtonData:>\\\"paclet:ref/Clear\\\", ButtonNote -> \\\
\"Clear::wrsym\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.460263854361351*^9, 3.4602640433774548`*^9, 
  3.460279180358728*^9, 3.460363884441977*^9, 3.4607014059098043`*^9, 
  3.460712518530595*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDelayed", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(RandomNumbers\\), \\\"MT\\\"]\
\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \\\"MT\\\"]\\)\
\[NoBreak]\\!\\(\\*StyleBox[\\!\\(RandomNumbers[\\(\\(\\(\\({x1_, x2_, \
dx_}\\)\\), density_, n_\\)\\)]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/SetDelayed\\\", ButtonNote -> \
\\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.460263854361351*^9, 3.4602640433774548`*^9, 
  3.460279180358728*^9, 3.460363884441977*^9, 3.4607014059098043`*^9, 
  3.460712518534924*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["EDM/  h=eta-eta^3", "Subsection",
 PageWidth->Infinity,
 CellChangeTimes->{{3.46089078443408*^9, 3.460890796158636*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"??", "Logistic"}]], "Input",
 CellChangeTimes->{{3.460434794971136*^9, 3.4604347955208197`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "Idio", "]"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Idio", "[", 
   RowBox[{"th_", ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "beta", ",", "gamma", ",", "sigma", ",", "\[IndentingNewLine]", 
      "             ", "sigmazeta", ",", "lambdaeta", ",", "taueta", ",", 
      "sigmaepsilon"}], "}"}], ",", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"beta", "=", 
      RowBox[{"{", 
       RowBox[{"{", "0", "}"}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"gamma", "=", 
      RowBox[{
       RowBox[{"{", "0", "}"}], "//", "Spalte"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"sigmazeta", "=", "I1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"lambdaeta", "=", "I1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"taueta", "=", 
      RowBox[{
       RowBox[{"{", "0", "}"}], "//", "Spalte"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"sigmaepsilon", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"th", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "^", "2"}], "I1"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"lambdaeta", ",", "taueta", ",", "sigmaepsilon"}], "}"}]}], 
      "}"}]}]}], "\[IndentingNewLine]", "]"}]}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460112411326638*^9, 3.460112486848282*^9}, {
   3.460112574501026*^9, 3.460112833350883*^9}, 3.460113258604714*^9, {
   3.4601981935531387`*^9, 3.4601982253887444`*^9}, {3.46019833150395*^9, 
   3.460198339518457*^9}, {3.460198463453682*^9, 3.460198495668239*^9}, {
   3.4602012679397707`*^9, 3.4602012745935698`*^9}, {3.460437742137166*^9, 
   3.4604377442837257`*^9}, {3.460459421523945*^9, 3.460459423450386*^9}, {
   3.460547952763468*^9, 3.4605479815918913`*^9}, 3.4608896552166653`*^9},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"IdioNonlin", ",", "eta"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"IdioNonlin", "[", 
   RowBox[{"th_", ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "beta", ",", "gamma", ",", "sigma", ",", "\[IndentingNewLine]", 
      "             ", "sigmazeta", ",", "lambdaeta", ",", "taueta", ",", 
      "sigmaepsilon", ",", "x", ",", "theta", ",", "h", ",", "dh"}], "}"}], 
    ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"beta", "=", 
      RowBox[{"{", 
       RowBox[{"{", "0", "}"}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"gamma", "=", 
      RowBox[{
       RowBox[{"{", "0", "}"}], "//", "Spalte"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"sigmazeta", "=", "I1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"c1", "=", 
      RowBox[{"{", 
       RowBox[{"-", "1"}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"c2", "=", 
      RowBox[{"{", "0", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"c3", "=", 
      RowBox[{"{", "1", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"h", "[", 
         RowBox[{"eta_", ",", "x_", ",", "theta_"}], "]"}], ":=", 
        RowBox[{
         RowBox[{"Plus", "@@", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Logistic", "[", 
              RowBox[{"100", 
               RowBox[{"(", 
                RowBox[{"eta", "-", "#"}], ")"}]}], "]"}], "&"}], ",", 
            RowBox[{"{", 
             RowBox[{"c1", ",", "c2"}], "}"}]}], "]"}]}], "-", "1"}]}], ";"}],
       "*)"}], "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"h", "[", 
         RowBox[{"eta_", ",", "x_", ",", "theta_"}], "]"}], ":=", 
        RowBox[{
         RowBox[{"Plus", "@@", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Heaviside", "[", 
              RowBox[{"(", 
               RowBox[{"eta", "-", "#"}], ")"}], "]"}], "&"}], ",", 
            RowBox[{"{", 
             RowBox[{"c1", ",", "c2", ",", "c3"}], "}"}]}], "]"}]}], "-", 
         "1"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"h", "[", 
       RowBox[{"eta_", ",", "x_", ",", "theta_"}], "]"}], ":=", 
      RowBox[{"eta", "-", 
       RowBox[{"eta", "^", "3"}]}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"P", ",", "Q"}], "}"}], "=", 
      RowBox[{"gamma", "//", "Dimensions"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Off", "[", 
      RowBox[{"Part", "::", "\"\<partd\>\""}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"etai", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"eta", "[", 
         RowBox[{"[", "i", "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "P"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"hilf", "=", 
      RowBox[{"Outer", "[", 
       RowBox[{"D", ",", 
        RowBox[{"h", "[", 
         RowBox[{"etai", ",", "x", ",", "theta"}], "]"}], ",", "etai"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"dh", "[", 
       RowBox[{"eta_", ",", "x_", ",", "theta_"}], "]"}], "=", "hilf"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"sigmaepsilon", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"th", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "^", "2"}], "I1"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"h", ",", "dh", ",", "sigmaepsilon"}], "}"}]}], "}"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460112411326638*^9, 3.460112486848282*^9}, {
   3.460112574501026*^9, 3.460112833350883*^9}, 3.460113258604714*^9, {
   3.4601981935531387`*^9, 3.4601982253887444`*^9}, {3.46019833150395*^9, 
   3.460198339518457*^9}, {3.460198463453682*^9, 3.460198495668239*^9}, {
   3.4602012679397707`*^9, 3.4602012745935698`*^9}, {3.460262544333317*^9, 
   3.460262672020108*^9}, {3.4602627586317263`*^9, 3.46026276001101*^9}, {
   3.4602704141975107`*^9, 3.46027041438337*^9}, {3.460280467176902*^9, 
   3.460280473085874*^9}, {3.4602806924891443`*^9, 3.460280711976782*^9}, {
   3.46028116644274*^9, 3.460281167729628*^9}, {3.460281474946793*^9, 
   3.460281508316875*^9}, {3.4602815479174967`*^9, 3.4602815484137983`*^9}, {
   3.4602816507807617`*^9, 3.460281676993616*^9}, {3.460284307808282*^9, 
   3.460284309899661*^9}, {3.4602847275090322`*^9, 3.460284736183663*^9}, {
   3.4602856192308903`*^9, 3.460285624220776*^9}, {3.460285710934456*^9, 
   3.460285717823205*^9}, {3.4602859764427147`*^9, 3.460285978161388*^9}, {
   3.460286261013752*^9, 3.460286261455785*^9}, {3.4602862948772097`*^9, 
   3.46028629819168*^9}, 3.4603642740349617`*^9, 3.4603644544831877`*^9, 
   3.460365456780478*^9, 3.4603665095654716`*^9, {3.460366607243189*^9, 
   3.4603666125853157`*^9}, {3.4603697272002287`*^9, 3.460369730933084*^9}, {
   3.46037151872565*^9, 3.460371519963439*^9}, {3.460373536249193*^9, 
   3.46037353630791*^9}, {3.460377010128886*^9, 3.4603770349211197`*^9}, {
   3.460377168908317*^9, 3.460377169368896*^9}, 3.46037765815534*^9, 
   3.460431475811249*^9, {3.4604319304909678`*^9, 3.4604319341933823`*^9}, {
   3.460432429495256*^9, 3.460432430269183*^9}, {3.4604331102297277`*^9, 
   3.4604331102918997`*^9}, {3.460433492904319*^9, 3.460433500341628*^9}, {
   3.4604343556223097`*^9, 3.460434355679142*^9}, {3.460434545548963*^9, 
   3.460434546745728*^9}, {3.46043493786023*^9, 3.460434967965836*^9}, {
   3.460435089839349*^9, 3.460435118610239*^9}, {3.460437529942061*^9, 
   3.4604375424215612`*^9}, 3.460438912806677*^9, 3.460439035722678*^9, {
   3.4604393410536213`*^9, 3.460439342272788*^9}, 3.460439840453356*^9, {
   3.460440333630175*^9, 3.460440355270155*^9}, {3.4604590838600483`*^9, 
   3.4604590936409283`*^9}, {3.46045943423339*^9, 3.460459435215295*^9}, {
   3.460460115325142*^9, 3.460460115390798*^9}, {3.460547992936483*^9, 
   3.460548038244534*^9}, {3.460548359779351*^9, 3.4605483699587107`*^9}, {
   3.460607630987466*^9, 3.4606076310422907`*^9}, {3.460608028038039*^9, 
   3.4606080556295424`*^9}, 3.460608089104917*^9, {3.460608139554899*^9, 
   3.4606081483374147`*^9}, {3.460608214125181*^9, 3.460608226072637*^9}, {
   3.460608705678046*^9, 3.460608717278057*^9}, {3.460619616995446*^9, 
   3.460619658298368*^9}, {3.460619735227*^9, 3.460619739401353*^9}, {
   3.4606231103903027`*^9, 3.460623110906802*^9}, {3.460690346282659*^9, 
   3.460690419159034*^9}, {3.4606905257299547`*^9, 3.4606906307676983`*^9}, {
   3.460690786155035*^9, 3.460690811739747*^9}, {3.460690873004724*^9, 
   3.460691043764667*^9}, {3.4606966176838903`*^9, 3.460696618983362*^9}, {
   3.460697850245064*^9, 3.460697850302597*^9}, {3.460700187295094*^9, 
   3.4607002046616793`*^9}, {3.4607018108184977`*^9, 
   3.4607018108805733`*^9}, {3.460712535147476*^9, 3.460712535219802*^9}, 
   3.460713023647132*^9, 3.460713884919587*^9, {3.460718120812653*^9, 
   3.460718129370597*^9}, {3.460865844261911*^9, 3.460865862403343*^9}, {
   3.460889824238564*^9, 3.460889838019496*^9}, {3.4608908486505127`*^9, 
   3.460890858609293*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Clear", "[", 
  RowBox[{"h", ",", "dh"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"h", ",", "dh", ",", "sigmaepsilon"}], "}"}]}], "}"}], "=", 
   RowBox[{"IdioNonlin", "[", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}]}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{"beta", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"gamma", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"sigmazeta", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"sigmaepsilon", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"h", "[", 
       RowBox[{
        RowBox[{"{", "x", "}"}], ",", "0", ",", "theta"}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", 
     RowBox[{
      RowBox[{"dh", "[", 
       RowBox[{
        RowBox[{"{", "x", "}"}], ",", "0", ",", "theta"}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"dh", "[", 
  RowBox[{
   RowBox[{"{", "eta", "}"}], ",", "0", ",", "theta"}], "]"}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.46011249354161*^9, 3.460112502635364*^9}, {
   3.460112738246236*^9, 3.460112740427596*^9}, {3.4601985014479733`*^9, 
   3.4601985021073637`*^9}, {3.460262678368519*^9, 3.460262744386445*^9}, {
   3.460270452868237*^9, 3.460270456266705*^9}, {3.46028153495817*^9, 
   3.4602816223627872`*^9}, {3.460284322897622*^9, 3.4602843302074947`*^9}, {
   3.460548484950382*^9, 3.460548486261179*^9}, {3.460608728173007*^9, 
   3.4606087292975283`*^9}, {3.460690405244627*^9, 3.460690406366933*^9}, {
   3.4606910751289682`*^9, 3.460691083080337*^9}, 3.4606913598661013`*^9, {
   3.460890874967895*^9, 3.460890879096386*^9}, {3.460891126812511*^9, 
   3.460891155626816*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", "0", "}"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", "0", "}"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", "1", "}"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"h$6756507", ",", "dh$6756507", ",", 
     RowBox[{"{", 
      RowBox[{"{", "1", "}"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, {
   3.460548021222658*^9, 3.460548040796109*^9}, 3.460548374878003*^9, 
   3.460548406506942*^9, 3.460548487069503*^9, 3.460607637374864*^9, {
   3.460608045966167*^9, 3.4606080584538183`*^9}, 3.46060809217841*^9, {
   3.460608142532516*^9, 3.460608150079648*^9}, {3.4606081896361923`*^9, 
   3.460608228433215*^9}, 3.460608418281057*^9, 3.460608655937346*^9, 
   3.460608730822871*^9, {3.460619630850037*^9, 3.4606196602967854`*^9}, 
   3.460619746403996*^9, 3.460623113839085*^9, 3.46069042381326*^9, 
   3.46069063707929*^9, {3.4606907970240583`*^9, 3.460690817321019*^9}, 
   3.460690876868802*^9, {3.4606909173516817`*^9, 3.46069094205059*^9}, {
   3.4606910004991207`*^9, 3.460691050887487*^9}, 3.46069108323332*^9, {
   3.460691355605454*^9, 3.4606913606607523`*^9}, 3.460696622255847*^9, 
   3.460697853635994*^9, 3.4607002219193287`*^9, {3.460701397461886*^9, 
   3.460701423907084*^9}, {3.460701819255274*^9, 3.460701824911387*^9}, {
   3.460712523625782*^9, 3.4607125391126328`*^9}, 3.460713027007635*^9, 
   3.460713888382205*^9, 3.46071813317126*^9, {3.460864788295946*^9, 
   3.460864807844152*^9}, {3.460865849613262*^9, 3.460865865750284*^9}, 
   3.460889846600136*^9, {3.460890866115128*^9, 3.460890880181699*^9}, {
   3.460891136232211*^9, 3.460891165579183*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, {
   3.460548021222658*^9, 3.460548040796109*^9}, 3.460548374878003*^9, 
   3.460548406506942*^9, 3.460548487069503*^9, 3.460607637374864*^9, {
   3.460608045966167*^9, 3.4606080584538183`*^9}, 3.46060809217841*^9, {
   3.460608142532516*^9, 3.460608150079648*^9}, {3.4606081896361923`*^9, 
   3.460608228433215*^9}, 3.460608418281057*^9, 3.460608655937346*^9, 
   3.460608730822871*^9, {3.460619630850037*^9, 3.4606196602967854`*^9}, 
   3.460619746403996*^9, 3.460623113839085*^9, 3.46069042381326*^9, 
   3.46069063707929*^9, {3.4606907970240583`*^9, 3.460690817321019*^9}, 
   3.460690876868802*^9, {3.4606909173516817`*^9, 3.46069094205059*^9}, {
   3.4606910004991207`*^9, 3.460691050887487*^9}, 3.46069108323332*^9, {
   3.460691355605454*^9, 3.4606913606607523`*^9}, 3.460696622255847*^9, 
   3.460697853635994*^9, 3.4607002219193287`*^9, {3.460701397461886*^9, 
   3.460701423907084*^9}, {3.460701819255274*^9, 3.460701824911387*^9}, {
   3.460712523625782*^9, 3.4607125391126328`*^9}, 3.460713027007635*^9, 
   3.460713888382205*^9, 3.46071813317126*^9, {3.460864788295946*^9, 
   3.460864807844152*^9}, {3.460865849613262*^9, 3.460865865750284*^9}, 
   3.460889846600136*^9, {3.460890866115128*^9, 3.460890880181699*^9}, {
   3.460891136232211*^9, 3.4608911655914516`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, {
   3.460548021222658*^9, 3.460548040796109*^9}, 3.460548374878003*^9, 
   3.460548406506942*^9, 3.460548487069503*^9, 3.460607637374864*^9, {
   3.460608045966167*^9, 3.4606080584538183`*^9}, 3.46060809217841*^9, {
   3.460608142532516*^9, 3.460608150079648*^9}, {3.4606081896361923`*^9, 
   3.460608228433215*^9}, 3.460608418281057*^9, 3.460608655937346*^9, 
   3.460608730822871*^9, {3.460619630850037*^9, 3.4606196602967854`*^9}, 
   3.460619746403996*^9, 3.460623113839085*^9, 3.46069042381326*^9, 
   3.46069063707929*^9, {3.4606907970240583`*^9, 3.460690817321019*^9}, 
   3.460690876868802*^9, {3.4606909173516817`*^9, 3.46069094205059*^9}, {
   3.4606910004991207`*^9, 3.460691050887487*^9}, 3.46069108323332*^9, {
   3.460691355605454*^9, 3.4606913606607523`*^9}, 3.460696622255847*^9, 
   3.460697853635994*^9, 3.4607002219193287`*^9, {3.460701397461886*^9, 
   3.460701423907084*^9}, {3.460701819255274*^9, 3.460701824911387*^9}, {
   3.460712523625782*^9, 3.4607125391126328`*^9}, 3.460713027007635*^9, 
   3.460713888382205*^9, 3.46071813317126*^9, {3.460864788295946*^9, 
   3.460864807844152*^9}, {3.460865849613262*^9, 3.460865865750284*^9}, 
   3.460889846600136*^9, {3.460890866115128*^9, 3.460890880181699*^9}, {
   3.460891136232211*^9, 3.460891165601549*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, {
   3.460548021222658*^9, 3.460548040796109*^9}, 3.460548374878003*^9, 
   3.460548406506942*^9, 3.460548487069503*^9, 3.460607637374864*^9, {
   3.460608045966167*^9, 3.4606080584538183`*^9}, 3.46060809217841*^9, {
   3.460608142532516*^9, 3.460608150079648*^9}, {3.4606081896361923`*^9, 
   3.460608228433215*^9}, 3.460608418281057*^9, 3.460608655937346*^9, 
   3.460608730822871*^9, {3.460619630850037*^9, 3.4606196602967854`*^9}, 
   3.460619746403996*^9, 3.460623113839085*^9, 3.46069042381326*^9, 
   3.46069063707929*^9, {3.4606907970240583`*^9, 3.460690817321019*^9}, 
   3.460690876868802*^9, {3.4606909173516817`*^9, 3.46069094205059*^9}, {
   3.4606910004991207`*^9, 3.460691050887487*^9}, 3.46069108323332*^9, {
   3.460691355605454*^9, 3.4606913606607523`*^9}, 3.460696622255847*^9, 
   3.460697853635994*^9, 3.4607002219193287`*^9, {3.460701397461886*^9, 
   3.460701423907084*^9}, {3.460701819255274*^9, 3.460701824911387*^9}, {
   3.460712523625782*^9, 3.4607125391126328`*^9}, 3.460713027007635*^9, 
   3.460713888382205*^9, 3.46071813317126*^9, {3.460864788295946*^9, 
   3.460864807844152*^9}, {3.460865849613262*^9, 3.460865865750284*^9}, 
   3.460889846600136*^9, {3.460890866115128*^9, 3.460890880181699*^9}, {
   3.460891136232211*^9, 3.4608911656110764`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, {
   3.460548021222658*^9, 3.460548040796109*^9}, 3.460548374878003*^9, 
   3.460548406506942*^9, 3.460548487069503*^9, 3.460607637374864*^9, {
   3.460608045966167*^9, 3.4606080584538183`*^9}, 3.46060809217841*^9, {
   3.460608142532516*^9, 3.460608150079648*^9}, {3.4606081896361923`*^9, 
   3.460608228433215*^9}, 3.460608418281057*^9, 3.460608655937346*^9, 
   3.460608730822871*^9, {3.460619630850037*^9, 3.4606196602967854`*^9}, 
   3.460619746403996*^9, 3.460623113839085*^9, 3.46069042381326*^9, 
   3.46069063707929*^9, {3.4606907970240583`*^9, 3.460690817321019*^9}, 
   3.460690876868802*^9, {3.4606909173516817`*^9, 3.46069094205059*^9}, {
   3.4606910004991207`*^9, 3.460691050887487*^9}, 3.46069108323332*^9, {
   3.460691355605454*^9, 3.4606913606607523`*^9}, 3.460696622255847*^9, 
   3.460697853635994*^9, 3.4607002219193287`*^9, {3.460701397461886*^9, 
   3.460701423907084*^9}, {3.460701819255274*^9, 3.460701824911387*^9}, {
   3.460712523625782*^9, 3.4607125391126328`*^9}, 3.460713027007635*^9, 
   3.460713888382205*^9, 3.46071813317126*^9, {3.460864788295946*^9, 
   3.460864807844152*^9}, {3.460865849613262*^9, 3.460865865750284*^9}, 
   3.460889846600136*^9, {3.460890866115128*^9, 3.460890880181699*^9}, {
   3.460891136232211*^9, 3.4608911656203136`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwtlnk4FOgDx8fMMG6SqyZy5c7RziSU99XlaBcrm3aFTFtrlwoxqZVsW46t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     "]]}, 
   {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJw11Pk/FHgcx/ExMpMZV0MkLdKQq1pnjvSZlIZqrZVOIRYdRgqNaol2V+l4
TKkWTbpEp6SSehDfb+MIacl93+cMM8OMMKZs+3js/vB+vP6A9+PxXB4U4R1C
JBAIAd/3b5FGZNf8PBn3ZyXkzc87Yn8nbs4xHhmbCo+FWrEdsfxX3un+P8k4
v0zVu3zcATu8oRl8UCbjYiO3Jt3etTjX71UAR5OEw66/vHqgxQ4P/RAkzP2q
iK19xN+eFlrhNfpbd9lSiTgv9GpYR6IlFpc2EOKNCJj4gXp17IAJHi9KjSg0
lCP7L4366hcNsX6kLNlp4wy64DybqZOmg9nGGSfXFE0j9ok+zdjD2vhTi0cg
fe002sHnzkZvXIxj4caPahZfkJh10oyurInbVBxqemlSRG9vtROXq+LaUfI5
98sSVNB2S3O6k4rLypvXP6dKUMaJ5GXPFCg4NyEmJ3bBJIq8TM41iSDhB37M
0P6ECeS78IIT/+0CnO6ko7/lqxilGawT71NXxGqj4XprxkRIy9u/4E7pPCKW
mM9kfxGiu1ROKV8sR9Ppww3mCkJU5Wd8zt1Ghnq8Ajkm2mNI+vGC3TqZFDWY
64dlGgrQ5PDu5XWnJ1HFgnamkQUfXUnnlJ3SFaMXb30U9BkjiHEn8MhCo2Hk
vq1iYNBuGIl1L/Hiz/Sh7m7nimcWQ0jK9GAhsw6kSl5x2UVnACWkxQtD/D6g
TG5KpJJqPxJPaLG4NrnIeTVl5ydiH7qbWUnLPPgY6p70ORZ0dCNOwRlC6qFa
oNEWtD8RdKKWQKrOMuUm8D5pHHtT1o6qnE3iTDzb4WrP5h8uKbcha/ohXd9l
PVDPPFgcu6QF1ZWQ00OC+0Dr+fmA8JVNqFx+pNw6fgB8tJ8S/O0bkHrN7TQe
awiux1Xf83SrQ9lOqbTFq0agYWDcFXxqUTrstjXHo7B0MMBD2FqNbMDi3AED
AVwkDKj4UysR5Ifkmm8fA7newdpP68rQ+0xybpTvOBxZO3bN5ch79Jay6Kyr
gxBQVk/OXihE9JEz1qmjQsjoGLFzyniFSC57Xx+LEAFlZd9JG8oj5KfMVaur
FMFds0H1wTvJyPynDevfzohAfslN9qaJAyntq46Hy0Tg6bs40dP5ETxy4TdI
KkSQ87g6MWZ/HgREsf22BosgP0utknn/HbyLrVOLrhZCl5cpSSWKB8V7vo2E
Kwihz7NyZfT1cgilyAQOiuMwtO2wR8frKnjFKdNp/CwA/hZq2Kbmv+HB0H6W
azgfggf0WFO7P4OX0YwkaHIEfFa8zHDfXA8JLcwkyZZh2BTk3nrTphHslb3M
pOxBsL3XpS4ybIbIPI3mYHY/0HuiN7uqtYJt2/lkN49e0DKgxv011wZyKfuF
ZXcnSNLX8p2busB9x5WlGuH18LNt7vk4dg+YOnE4l/yqgM7dpN95phcONl2k
LDIogJqQcGZ6Wj9c8WS9riVglPlRoWPu/gDsdmwaMi6pQaesUo76Ph+EfQq/
FR23aEH0r8U3lpYPw7bqxskX8gFUpK7ISakegeAi2tnZh6NopxHzd1r995+f
qce8SRSiJGbNYUqPAExL6Y5bWVK0fK9mwNmhMRhx3FjcbjKNCli7thPHx2Em
Z0PkQ9ksEiR3O8tmRTCT0hUqHp9HLq5/9AbFiKHVLLRrf5gCTizUzqqYEEOa
/4MEHp+IF+e4WF4fmoD1H4lPj1JI2O7aRSeLWgkYvrBIPfFJBWc/L5EJfKRg
PhWhpPteDRtVzxVkt0qh9DaFX7tfA2sosZxX90/Bk/ANHvnRNMxnb1tn9WUa
koynPCSj2vhUW9r5441zQFokyfExNcTYQqmrQpHAmP5aN+FLNcFVG2/lq2sS
GR2ngpfE3LXEPL25vKlviozOem+sUmyFjycIsphaJIY0Kk51uNUOn/aWZxf/
QmIQ3ILi6/bY4yS6ap7dZRJDb1mLgWG7PeZWrOatoJAZJzrYY73fvb3PhUou
k8woKruzZOcBB5zN8qpdlEhmaLzeE2UpdMD56wObk3hkRtSTTHnwd7//853x
v+//AISUEgA=
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, {
   3.460548021222658*^9, 3.460548040796109*^9}, 3.460548374878003*^9, 
   3.460548406506942*^9, 3.460548487069503*^9, 3.460607637374864*^9, {
   3.460608045966167*^9, 3.4606080584538183`*^9}, 3.46060809217841*^9, {
   3.460608142532516*^9, 3.460608150079648*^9}, {3.4606081896361923`*^9, 
   3.460608228433215*^9}, 3.460608418281057*^9, 3.460608655937346*^9, 
   3.460608730822871*^9, {3.460619630850037*^9, 3.4606196602967854`*^9}, 
   3.460619746403996*^9, 3.460623113839085*^9, 3.46069042381326*^9, 
   3.46069063707929*^9, {3.4606907970240583`*^9, 3.460690817321019*^9}, 
   3.460690876868802*^9, {3.4606909173516817`*^9, 3.46069094205059*^9}, {
   3.4606910004991207`*^9, 3.460691050887487*^9}, 3.46069108323332*^9, {
   3.460691355605454*^9, 3.4606913606607523`*^9}, 3.460696622255847*^9, 
   3.460697853635994*^9, 3.4607002219193287`*^9, {3.460701397461886*^9, 
   3.460701423907084*^9}, {3.460701819255274*^9, 3.460701824911387*^9}, {
   3.460712523625782*^9, 3.4607125391126328`*^9}, 3.460713027007635*^9, 
   3.460713888382205*^9, 3.46071813317126*^9, {3.460864788295946*^9, 
   3.460864807844152*^9}, {3.460865849613262*^9, 3.460865865750284*^9}, 
   3.460889846600136*^9, {3.460890866115128*^9, 3.460890880181699*^9}, {
   3.460891136232211*^9, 3.460891165629075*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"1", "-", 
    RowBox[{"3", " ", 
     SuperscriptBox["eta", "2"]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, {
   3.460548021222658*^9, 3.460548040796109*^9}, 3.460548374878003*^9, 
   3.460548406506942*^9, 3.460548487069503*^9, 3.460607637374864*^9, {
   3.460608045966167*^9, 3.4606080584538183`*^9}, 3.46060809217841*^9, {
   3.460608142532516*^9, 3.460608150079648*^9}, {3.4606081896361923`*^9, 
   3.460608228433215*^9}, 3.460608418281057*^9, 3.460608655937346*^9, 
   3.460608730822871*^9, {3.460619630850037*^9, 3.4606196602967854`*^9}, 
   3.460619746403996*^9, 3.460623113839085*^9, 3.46069042381326*^9, 
   3.46069063707929*^9, {3.4606907970240583`*^9, 3.460690817321019*^9}, 
   3.460690876868802*^9, {3.4606909173516817`*^9, 3.46069094205059*^9}, {
   3.4606910004991207`*^9, 3.460691050887487*^9}, 3.46069108323332*^9, {
   3.460691355605454*^9, 3.4606913606607523`*^9}, 3.460696622255847*^9, 
   3.460697853635994*^9, 3.4607002219193287`*^9, {3.460701397461886*^9, 
   3.460701423907084*^9}, {3.460701819255274*^9, 3.460701824911387*^9}, {
   3.460712523625782*^9, 3.4607125391126328`*^9}, 3.460713027007635*^9, 
   3.460713888382205*^9, 3.46071813317126*^9, {3.460864788295946*^9, 
   3.460864807844152*^9}, {3.460865849613262*^9, 3.460865865750284*^9}, 
   3.460889846600136*^9, {3.460890866115128*^9, 3.460890880181699*^9}, {
   3.460891136232211*^9, 3.460891165668005*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Simulation/dt=1", "Subsection",
 PageWidth->Infinity,
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Theta", "=", 
  RowBox[{"{", "1", "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", "1"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"q", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"X", "=", 
  RowBox[{"Shape", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", "1"}], "}"}]}], "]"}]}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460112861196432*^9, 3.460112900249464*^9}, {
   3.460112950538982*^9, 3.4601129539374437`*^9}, {3.460113005467535*^9, 
   3.460113006401746*^9}, {3.460113958542322*^9, 3.460113959287684*^9}, 
   3.4601141435117283`*^9, {3.46011422532432*^9, 3.460114228762265*^9}, {
   3.460114299482638*^9, 3.460114299662619*^9}, {3.460120919663384*^9, 
   3.460120925946155*^9}, {3.460370026377693*^9, 3.460370026423751*^9}, {
   3.460370337087948*^9, 3.460370337140321*^9}, {3.460371593295773*^9, 
   3.460371593877831*^9}, {3.460377254178602*^9, 3.4603772542338552`*^9}, 
   3.460427451561919*^9, 3.4604329049294033`*^9, 3.460433078433264*^9, 
   3.460437042733672*^9, 3.460444571968473*^9, 3.460460037897266*^9, 
   3.460460803716981*^9, {3.46060873633524*^9, 3.460608739837797*^9}, {
   3.460713821809268*^9, 3.46071384751449*^9}, {3.460716661557922*^9, 
   3.460716661602404*^9}, 3.460889999784049*^9, 3.460890928598757*^9},
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", "1", "}"}]], "Output",
 CellChangeTimes->{
  3.45982787174109*^9, {3.460112887861902*^9, 3.460112900786964*^9}, 
   3.460112954913162*^9, {3.460113000282473*^9, 3.460113007967648*^9}, 
   3.460113265712655*^9, 3.460113964238937*^9, 3.460114146876112*^9, 
   3.4601142349213667`*^9, 3.460114304518387*^9, 3.460120929697301*^9, {
   3.460126878115456*^9, 3.460126894622835*^9}, 3.4601274604024973`*^9, 
   3.460197817926371*^9, 3.460198252562779*^9, 3.460198349161854*^9, 
   3.460198506587408*^9, 3.460199526323365*^9, 3.460199563520813*^9, 
   3.460199653793846*^9, 3.4602004848983727`*^9, 3.4602006007365503`*^9, 
   3.460201290106146*^9, 3.460201878664384*^9, 3.460254150649612*^9, 
   3.4602704732126837`*^9, 3.460279153501918*^9, 3.460279212991139*^9, 
   3.4602816948847113`*^9, {3.460284336364369*^9, 3.460284358322968*^9}, 
   3.460284752117095*^9, 3.460285736075243*^9, 3.46028598941461*^9, 
   3.460286271965789*^9, 3.4602863067892523`*^9, 3.4603638961194057`*^9, 
   3.460366621961207*^9, 3.460369741827793*^9, 3.4603700297393913`*^9, 
   3.460370341259691*^9, 3.460371529118987*^9, 3.4603715972424173`*^9, 
   3.46037354416546*^9, 3.460377043299438*^9, 3.460377177822056*^9, 
   3.460377257847652*^9, 3.46037766509881*^9, 3.460427455891576*^9, {
   3.4604329057405024`*^9, 3.460432914614367*^9}, 3.4604330817497673`*^9, 
   3.460433119701372*^9, 3.46043457776158*^9, 3.460434977961318*^9, 
   3.460437046144434*^9, 3.460437552873603*^9, 3.460437900974538*^9, 
   3.460439351382359*^9, 3.46044036674789*^9, 3.46044457492516*^9, 
   3.460444772196126*^9, 3.4604449403037977`*^9, 3.4604449975762653`*^9, 
   3.4604591002378387`*^9, 3.460460040416348*^9, 3.460460125733479*^9, 
   3.4604608064131107`*^9, 3.460548053632538*^9, 3.4605484930771112`*^9, 
   3.4606076422002163`*^9, 3.460608244649225*^9, 3.460608745001939*^9, 
   3.460619679921056*^9, 3.4606197599822598`*^9, 3.460623117967696*^9, 
   3.460691263727468*^9, 3.460696628972677*^9, 3.4606978602136717`*^9, 
   3.460700234024102*^9, {3.4607014273053827`*^9, 3.460701436962193*^9}, 
   3.460701829931427*^9, 3.4607125703048763`*^9, 3.4607130323824987`*^9, {
   3.460713826203504*^9, 3.460713850678028*^9}, 3.460713892650769*^9, 
   3.4607166649851627`*^9, 3.460718138496252*^9, 3.46086481432125*^9, 
   3.460889886823989*^9, 3.460890003213298*^9, 3.460890890138509*^9, 
   3.460890931774623*^9, 3.4608911698607683`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "1", "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.45982787174109*^9, {3.460112887861902*^9, 3.460112900786964*^9}, 
   3.460112954913162*^9, {3.460113000282473*^9, 3.460113007967648*^9}, 
   3.460113265712655*^9, 3.460113964238937*^9, 3.460114146876112*^9, 
   3.4601142349213667`*^9, 3.460114304518387*^9, 3.460120929697301*^9, {
   3.460126878115456*^9, 3.460126894622835*^9}, 3.4601274604024973`*^9, 
   3.460197817926371*^9, 3.460198252562779*^9, 3.460198349161854*^9, 
   3.460198506587408*^9, 3.460199526323365*^9, 3.460199563520813*^9, 
   3.460199653793846*^9, 3.4602004848983727`*^9, 3.4602006007365503`*^9, 
   3.460201290106146*^9, 3.460201878664384*^9, 3.460254150649612*^9, 
   3.4602704732126837`*^9, 3.460279153501918*^9, 3.460279212991139*^9, 
   3.4602816948847113`*^9, {3.460284336364369*^9, 3.460284358322968*^9}, 
   3.460284752117095*^9, 3.460285736075243*^9, 3.46028598941461*^9, 
   3.460286271965789*^9, 3.4602863067892523`*^9, 3.4603638961194057`*^9, 
   3.460366621961207*^9, 3.460369741827793*^9, 3.4603700297393913`*^9, 
   3.460370341259691*^9, 3.460371529118987*^9, 3.4603715972424173`*^9, 
   3.46037354416546*^9, 3.460377043299438*^9, 3.460377177822056*^9, 
   3.460377257847652*^9, 3.46037766509881*^9, 3.460427455891576*^9, {
   3.4604329057405024`*^9, 3.460432914614367*^9}, 3.4604330817497673`*^9, 
   3.460433119701372*^9, 3.46043457776158*^9, 3.460434977961318*^9, 
   3.460437046144434*^9, 3.460437552873603*^9, 3.460437900974538*^9, 
   3.460439351382359*^9, 3.46044036674789*^9, 3.46044457492516*^9, 
   3.460444772196126*^9, 3.4604449403037977`*^9, 3.4604449975762653`*^9, 
   3.4604591002378387`*^9, 3.460460040416348*^9, 3.460460125733479*^9, 
   3.4604608064131107`*^9, 3.460548053632538*^9, 3.4605484930771112`*^9, 
   3.4606076422002163`*^9, 3.460608244649225*^9, 3.460608745001939*^9, 
   3.460619679921056*^9, 3.4606197599822598`*^9, 3.460623117967696*^9, 
   3.460691263727468*^9, 3.460696628972677*^9, 3.4606978602136717`*^9, 
   3.460700234024102*^9, {3.4607014273053827`*^9, 3.460701436962193*^9}, 
   3.460701829931427*^9, 3.4607125703048763`*^9, 3.4607130323824987`*^9, {
   3.460713826203504*^9, 3.460713850678028*^9}, 3.460713892650769*^9, 
   3.4607166649851627`*^9, 3.460718138496252*^9, 3.46086481432125*^9, 
   3.460889886823989*^9, 3.460890003213298*^9, 3.460890890138509*^9, 
   3.460890931774623*^9, 3.4608911698965273`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["n"], "Input",
 CellChangeTimes->{3.460199566938484*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{{3.4601995670369167`*^9, 3.460199582472732*^9}, 
   3.460199654184558*^9, 3.4602006010382977`*^9, 3.460201878968666*^9, 
   3.460270473397647*^9, 3.460279153636557*^9, 3.460279213141574*^9, 
   3.460284358508081*^9, 3.4602847523334084`*^9, 3.460285736259516*^9, 
   3.460285989579775*^9, 3.460286272109499*^9, 3.460286306972591*^9, 
   3.460363896269546*^9, 3.460366622129072*^9, 3.4603697420542707`*^9, 
   3.460370029977702*^9, 3.46037034147106*^9, 3.46037152934341*^9, 
   3.4603715974458637`*^9, 3.46037354437654*^9, 3.460377043500943*^9, 
   3.46037717804631*^9, 3.460377258106838*^9, 3.460377665294299*^9, 
   3.460427456109329*^9, 3.4604329148012323`*^9, 3.460433081953985*^9, 
   3.460433119910708*^9, 3.460434577965878*^9, 3.460434978185719*^9, 
   3.4604370463382597`*^9, 3.460437553079526*^9, 3.4604403669551992`*^9, 
   3.4604445751168613`*^9, 3.460444772429595*^9, 3.460444940510421*^9, 
   3.460444997808488*^9, 3.460459100440379*^9, 3.460460040620708*^9, 
   3.460460125951755*^9, 3.460460806611047*^9, 3.460548055525713*^9, 
   3.4605484932949047`*^9, 3.460607642412746*^9, 3.4606082448640223`*^9, 
   3.460608745210497*^9, 3.460619680207026*^9, 3.460619760198594*^9, 
   3.4606231181930923`*^9, 3.46069662924555*^9, 3.460697860489114*^9, 
   3.4607002342409487`*^9, {3.460701429715391*^9, 3.460701437133135*^9}, 
   3.4607018300775137`*^9, 3.4607125704667187`*^9, 3.460713032628922*^9, {
   3.460713826373352*^9, 3.4607138508667097`*^9}, 3.4607138928206863`*^9, 
   3.460716665202499*^9, 3.460718138690967*^9, 3.460864814531962*^9, 
   3.4608898870577097`*^9, 3.460890003459161*^9, 3.460890890358988*^9, 
   3.4608909319936447`*^9, 3.4608911701363897`*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SeedRandom", "[", "12345689999999", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Y", ",", "X", ",", "ETA"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"ZETA", ",", "EPSILON"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"h", ",", "dh", ",", "sigmaepsilon"}], "}"}]}], "}"}]}], 
    "}"}], "=", "\[IndentingNewLine]", 
   RowBox[{"LISRELsimulNonlin", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", ",", "\"\<Gauss[]\>\"", ",", "X"}], "}"}], ",", "Theta", 
     ",", 
     RowBox[{"{", 
      RowBox[{"IdioNonlin", ",", 
       RowBox[{"{", "}"}]}], "}"}]}], "]"}]}], ";"}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601129177677603`*^9, 3.46011292950504*^9}, {
   3.4601129714155407`*^9, 3.460112981316517*^9}, {3.460198511433001*^9, 
   3.4601985124151077`*^9}, {3.460262802763719*^9, 3.460262821284783*^9}, {
   3.4604447675941477`*^9, 3.460444768681939*^9}, {3.4604449364164333`*^9, 
   3.4604449370413017`*^9}, {3.4604449897999277`*^9, 
   3.4604449936057873`*^9}, {3.460691241307849*^9, 3.4606912420027313`*^9}, {
   3.460691310350938*^9, 3.460691330168746*^9}, 3.460691537321001*^9, 
   3.4606915914665956`*^9},
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[{"beta", "\[IndentingNewLine]", "gamma", "\[IndentingNewLine]", \
"sigmazeta", "\[IndentingNewLine]", "h"}], "Input",
 CellChangeTimes->{{3.4601269097587757`*^9, 3.460126910241324*^9}, {
  3.46026300740036*^9, 3.4602630224003677`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "0", "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.460126911291768*^9, {3.460127448010219*^9, 3.460127463752602*^9}, 
   3.46019781849335*^9, 3.460198255524288*^9, 3.460198352058052*^9, 
   3.4601985156112556`*^9, 3.4601995266377697`*^9, 3.460199577399457*^9, 
   3.46019965430007*^9, 3.460200566230009*^9, 3.460200601139563*^9, 
   3.460201879055964*^9, 3.460254153231098*^9, {3.46026300470542*^9, 
   3.4602630225053473`*^9}, 3.460270473521778*^9, 3.4602791537878532`*^9, 
   3.460279213318447*^9, 3.460281700761509*^9, {3.460284339881637*^9, 
   3.460284358605403*^9}, 3.460284752501553*^9, 3.460285736426825*^9, 
   3.460285989707677*^9, 3.460286272224893*^9, 3.460286307114214*^9, 
   3.4603638964211063`*^9, 3.460366622238628*^9, 3.4603697421688843`*^9, 
   3.460370030103874*^9, 3.460370341630898*^9, 3.460371529458281*^9, 
   3.460371597568221*^9, 3.460373544538747*^9, 3.460377043635038*^9, 
   3.460377178198557*^9, 3.460377258262187*^9, 3.460377665441781*^9, 
   3.460427456233851*^9, 3.4604319457565603`*^9, {3.460432909977116*^9, 
   3.460432914941457*^9}, 3.4604330820901012`*^9, 3.460433120037969*^9, 
   3.4604345780819597`*^9, 3.460434978336451*^9, 3.460437046470871*^9, 
   3.460437553217643*^9, 3.460440367108382*^9, 3.460444575278883*^9, 
   3.4604447725558567`*^9, 3.460444940639205*^9, 3.460444997936206*^9, 
   3.4604591005903893`*^9, 3.460460040743739*^9, 3.460460126074955*^9, 
   3.4604608067430067`*^9, 3.4605480597630033`*^9, 3.460548493404709*^9, 
   3.4606076425432262`*^9, 3.460608245014324*^9, 3.460608745338059*^9, 
   3.460619680405828*^9, 3.4606197603657637`*^9, 3.4606231183423357`*^9, 
   3.460691605419422*^9, 3.460696629409348*^9, 3.460697860664282*^9, 
   3.460700234375003*^9, 3.4607014372166843`*^9, 3.460701830238104*^9, 
   3.460712570839595*^9, 3.460713032766006*^9, {3.460713826555271*^9, 
   3.460713851031199*^9}, 3.460713892969797*^9, 3.4607166653863897`*^9, 
   3.460718138826419*^9, 3.4608648146571503`*^9, 3.4608898871581984`*^9, 
   3.460890003549169*^9, 3.46089089045548*^9, 3.460890932093438*^9, 
   3.460891170285268*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "0", "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.460126911291768*^9, {3.460127448010219*^9, 3.460127463752602*^9}, 
   3.46019781849335*^9, 3.460198255524288*^9, 3.460198352058052*^9, 
   3.4601985156112556`*^9, 3.4601995266377697`*^9, 3.460199577399457*^9, 
   3.46019965430007*^9, 3.460200566230009*^9, 3.460200601139563*^9, 
   3.460201879055964*^9, 3.460254153231098*^9, {3.46026300470542*^9, 
   3.4602630225053473`*^9}, 3.460270473521778*^9, 3.4602791537878532`*^9, 
   3.460279213318447*^9, 3.460281700761509*^9, {3.460284339881637*^9, 
   3.460284358605403*^9}, 3.460284752501553*^9, 3.460285736426825*^9, 
   3.460285989707677*^9, 3.460286272224893*^9, 3.460286307114214*^9, 
   3.4603638964211063`*^9, 3.460366622238628*^9, 3.4603697421688843`*^9, 
   3.460370030103874*^9, 3.460370341630898*^9, 3.460371529458281*^9, 
   3.460371597568221*^9, 3.460373544538747*^9, 3.460377043635038*^9, 
   3.460377178198557*^9, 3.460377258262187*^9, 3.460377665441781*^9, 
   3.460427456233851*^9, 3.4604319457565603`*^9, {3.460432909977116*^9, 
   3.460432914941457*^9}, 3.4604330820901012`*^9, 3.460433120037969*^9, 
   3.4604345780819597`*^9, 3.460434978336451*^9, 3.460437046470871*^9, 
   3.460437553217643*^9, 3.460440367108382*^9, 3.460444575278883*^9, 
   3.4604447725558567`*^9, 3.460444940639205*^9, 3.460444997936206*^9, 
   3.4604591005903893`*^9, 3.460460040743739*^9, 3.460460126074955*^9, 
   3.4604608067430067`*^9, 3.4605480597630033`*^9, 3.460548493404709*^9, 
   3.4606076425432262`*^9, 3.460608245014324*^9, 3.460608745338059*^9, 
   3.460619680405828*^9, 3.4606197603657637`*^9, 3.4606231183423357`*^9, 
   3.460691605419422*^9, 3.460696629409348*^9, 3.460697860664282*^9, 
   3.460700234375003*^9, 3.4607014372166843`*^9, 3.460701830238104*^9, 
   3.460712570839595*^9, 3.460713032766006*^9, {3.460713826555271*^9, 
   3.460713851031199*^9}, 3.460713892969797*^9, 3.4607166653863897`*^9, 
   3.460718138826419*^9, 3.4608648146571503`*^9, 3.4608898871581984`*^9, 
   3.460890003549169*^9, 3.46089089045548*^9, 3.460890932093438*^9, 
   3.460891170321412*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "1.`", "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.460126911291768*^9, {3.460127448010219*^9, 3.460127463752602*^9}, 
   3.46019781849335*^9, 3.460198255524288*^9, 3.460198352058052*^9, 
   3.4601985156112556`*^9, 3.4601995266377697`*^9, 3.460199577399457*^9, 
   3.46019965430007*^9, 3.460200566230009*^9, 3.460200601139563*^9, 
   3.460201879055964*^9, 3.460254153231098*^9, {3.46026300470542*^9, 
   3.4602630225053473`*^9}, 3.460270473521778*^9, 3.4602791537878532`*^9, 
   3.460279213318447*^9, 3.460281700761509*^9, {3.460284339881637*^9, 
   3.460284358605403*^9}, 3.460284752501553*^9, 3.460285736426825*^9, 
   3.460285989707677*^9, 3.460286272224893*^9, 3.460286307114214*^9, 
   3.4603638964211063`*^9, 3.460366622238628*^9, 3.4603697421688843`*^9, 
   3.460370030103874*^9, 3.460370341630898*^9, 3.460371529458281*^9, 
   3.460371597568221*^9, 3.460373544538747*^9, 3.460377043635038*^9, 
   3.460377178198557*^9, 3.460377258262187*^9, 3.460377665441781*^9, 
   3.460427456233851*^9, 3.4604319457565603`*^9, {3.460432909977116*^9, 
   3.460432914941457*^9}, 3.4604330820901012`*^9, 3.460433120037969*^9, 
   3.4604345780819597`*^9, 3.460434978336451*^9, 3.460437046470871*^9, 
   3.460437553217643*^9, 3.460440367108382*^9, 3.460444575278883*^9, 
   3.4604447725558567`*^9, 3.460444940639205*^9, 3.460444997936206*^9, 
   3.4604591005903893`*^9, 3.460460040743739*^9, 3.460460126074955*^9, 
   3.4604608067430067`*^9, 3.4605480597630033`*^9, 3.460548493404709*^9, 
   3.4606076425432262`*^9, 3.460608245014324*^9, 3.460608745338059*^9, 
   3.460619680405828*^9, 3.4606197603657637`*^9, 3.4606231183423357`*^9, 
   3.460691605419422*^9, 3.460696629409348*^9, 3.460697860664282*^9, 
   3.460700234375003*^9, 3.4607014372166843`*^9, 3.460701830238104*^9, 
   3.460712570839595*^9, 3.460713032766006*^9, {3.460713826555271*^9, 
   3.460713851031199*^9}, 3.460713892969797*^9, 3.4607166653863897`*^9, 
   3.460718138826419*^9, 3.4608648146571503`*^9, 3.4608898871581984`*^9, 
   3.460890003549169*^9, 3.46089089045548*^9, 3.460890932093438*^9, 
   3.4608911703737717`*^9}],

Cell[BoxData["h$6756532"], "Output",
 CellChangeTimes->{
  3.460126911291768*^9, {3.460127448010219*^9, 3.460127463752602*^9}, 
   3.46019781849335*^9, 3.460198255524288*^9, 3.460198352058052*^9, 
   3.4601985156112556`*^9, 3.4601995266377697`*^9, 3.460199577399457*^9, 
   3.46019965430007*^9, 3.460200566230009*^9, 3.460200601139563*^9, 
   3.460201879055964*^9, 3.460254153231098*^9, {3.46026300470542*^9, 
   3.4602630225053473`*^9}, 3.460270473521778*^9, 3.4602791537878532`*^9, 
   3.460279213318447*^9, 3.460281700761509*^9, {3.460284339881637*^9, 
   3.460284358605403*^9}, 3.460284752501553*^9, 3.460285736426825*^9, 
   3.460285989707677*^9, 3.460286272224893*^9, 3.460286307114214*^9, 
   3.4603638964211063`*^9, 3.460366622238628*^9, 3.4603697421688843`*^9, 
   3.460370030103874*^9, 3.460370341630898*^9, 3.460371529458281*^9, 
   3.460371597568221*^9, 3.460373544538747*^9, 3.460377043635038*^9, 
   3.460377178198557*^9, 3.460377258262187*^9, 3.460377665441781*^9, 
   3.460427456233851*^9, 3.4604319457565603`*^9, {3.460432909977116*^9, 
   3.460432914941457*^9}, 3.4604330820901012`*^9, 3.460433120037969*^9, 
   3.4604345780819597`*^9, 3.460434978336451*^9, 3.460437046470871*^9, 
   3.460437553217643*^9, 3.460440367108382*^9, 3.460444575278883*^9, 
   3.4604447725558567`*^9, 3.460444940639205*^9, 3.460444997936206*^9, 
   3.4604591005903893`*^9, 3.460460040743739*^9, 3.460460126074955*^9, 
   3.4604608067430067`*^9, 3.4605480597630033`*^9, 3.460548493404709*^9, 
   3.4606076425432262`*^9, 3.460608245014324*^9, 3.460608745338059*^9, 
   3.460619680405828*^9, 3.4606197603657637`*^9, 3.4606231183423357`*^9, 
   3.460691605419422*^9, 3.460696629409348*^9, 3.460697860664282*^9, 
   3.460700234375003*^9, 3.4607014372166843`*^9, 3.460701830238104*^9, 
   3.460712570839595*^9, 3.460713032766006*^9, {3.460713826555271*^9, 
   3.460713851031199*^9}, 3.460713892969797*^9, 3.4607166653863897`*^9, 
   3.460718138826419*^9, 3.4608648146571503`*^9, 3.4608898871581984`*^9, 
   3.460890003549169*^9, 3.46089089045548*^9, 3.460890932093438*^9, 
   3.460891170426756*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"Y", "\[IndentingNewLine]", "ETA", "\[IndentingNewLine]", 
 RowBox[{"ETA", "^", "2"}]}], "Input",
 CellChangeTimes->{{3.460263029570212*^9, 3.460263076361992*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"-", "0.7881842610772917`"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.460263033034795*^9, 3.4602630471827707`*^9}, 
   3.4602630772167892`*^9, 3.460270473585662*^9, 3.4602791540048*^9, 
   3.460279213559284*^9, 3.460281704010305*^9, {3.4602843427261763`*^9, 
   3.460284358667742*^9}, 3.460284752756671*^9, 3.460285736694447*^9, 
   3.460285989950755*^9, 3.460286272384079*^9, 3.460286307342223*^9, 
   3.460363896672715*^9, 3.460366622305064*^9, 3.4603697424206533`*^9, 
   3.4603700301714983`*^9, 3.4603703417015457`*^9, 3.460371529532394*^9, 
   3.460371597632999*^9, 3.4603735446237793`*^9, 3.460377043887631*^9, 
   3.460377178440894*^9, 3.460377258343234*^9, 3.460377665634234*^9, 
   3.460427456327112*^9, 3.460432915039525*^9, 3.460433082177577*^9, 
   3.460433120294201*^9, 3.460434578318264*^9, 3.460434978586213*^9, 
   3.460437046533617*^9, 3.4604375532813597`*^9, 3.460440367300915*^9, 
   3.4604445755277157`*^9, 3.4604447726233263`*^9, 3.460444940885169*^9, 
   3.460444998006908*^9, 3.460459100825345*^9, 3.4604600408257113`*^9, 
   3.460460126235815*^9, 3.460460806817445*^9, 3.460548062844584*^9, 
   3.46054849348066*^9, 3.46060764268402*^9, 3.460608245251642*^9, 
   3.4606087455722637`*^9, 3.4606196806439257`*^9, 3.460619760584269*^9, 
   3.4606231184718227`*^9, 3.4606966296325293`*^9, 3.46069786086654*^9, 
   3.4607002345979347`*^9, 3.4607014372790737`*^9, 3.460701830452524*^9, 
   3.460712571040741*^9, 3.460713032985733*^9, {3.460713826625201*^9, 
   3.460713851107033*^9}, 3.4607138931533623`*^9, 3.460716665605091*^9, 
   3.460718139048274*^9, 3.460864814731645*^9, 3.460889887237143*^9, 
   3.46089000373172*^9, 3.4608908905551987`*^9, 3.460890932261243*^9, 
   3.460891170531417*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"-", "0.5209211781380665`"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.460263033034795*^9, 3.4602630471827707`*^9}, 
   3.4602630772167892`*^9, 3.460270473585662*^9, 3.4602791540048*^9, 
   3.460279213559284*^9, 3.460281704010305*^9, {3.4602843427261763`*^9, 
   3.460284358667742*^9}, 3.460284752756671*^9, 3.460285736694447*^9, 
   3.460285989950755*^9, 3.460286272384079*^9, 3.460286307342223*^9, 
   3.460363896672715*^9, 3.460366622305064*^9, 3.4603697424206533`*^9, 
   3.4603700301714983`*^9, 3.4603703417015457`*^9, 3.460371529532394*^9, 
   3.460371597632999*^9, 3.4603735446237793`*^9, 3.460377043887631*^9, 
   3.460377178440894*^9, 3.460377258343234*^9, 3.460377665634234*^9, 
   3.460427456327112*^9, 3.460432915039525*^9, 3.460433082177577*^9, 
   3.460433120294201*^9, 3.460434578318264*^9, 3.460434978586213*^9, 
   3.460437046533617*^9, 3.4604375532813597`*^9, 3.460440367300915*^9, 
   3.4604445755277157`*^9, 3.4604447726233263`*^9, 3.460444940885169*^9, 
   3.460444998006908*^9, 3.460459100825345*^9, 3.4604600408257113`*^9, 
   3.460460126235815*^9, 3.460460806817445*^9, 3.460548062844584*^9, 
   3.46054849348066*^9, 3.46060764268402*^9, 3.460608245251642*^9, 
   3.4606087455722637`*^9, 3.4606196806439257`*^9, 3.460619760584269*^9, 
   3.4606231184718227`*^9, 3.4606966296325293`*^9, 3.46069786086654*^9, 
   3.4607002345979347`*^9, 3.4607014372790737`*^9, 3.460701830452524*^9, 
   3.460712571040741*^9, 3.460713032985733*^9, {3.460713826625201*^9, 
   3.460713851107033*^9}, 3.4607138931533623`*^9, 3.460716665605091*^9, 
   3.460718139048274*^9, 3.460864814731645*^9, 3.460889887237143*^9, 
   3.46089000373172*^9, 3.4608908905551987`*^9, 3.460890932261243*^9, 
   3.460891170570438*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "0.2713588738327512`", "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.460263033034795*^9, 3.4602630471827707`*^9}, 
   3.4602630772167892`*^9, 3.460270473585662*^9, 3.4602791540048*^9, 
   3.460279213559284*^9, 3.460281704010305*^9, {3.4602843427261763`*^9, 
   3.460284358667742*^9}, 3.460284752756671*^9, 3.460285736694447*^9, 
   3.460285989950755*^9, 3.460286272384079*^9, 3.460286307342223*^9, 
   3.460363896672715*^9, 3.460366622305064*^9, 3.4603697424206533`*^9, 
   3.4603700301714983`*^9, 3.4603703417015457`*^9, 3.460371529532394*^9, 
   3.460371597632999*^9, 3.4603735446237793`*^9, 3.460377043887631*^9, 
   3.460377178440894*^9, 3.460377258343234*^9, 3.460377665634234*^9, 
   3.460427456327112*^9, 3.460432915039525*^9, 3.460433082177577*^9, 
   3.460433120294201*^9, 3.460434578318264*^9, 3.460434978586213*^9, 
   3.460437046533617*^9, 3.4604375532813597`*^9, 3.460440367300915*^9, 
   3.4604445755277157`*^9, 3.4604447726233263`*^9, 3.460444940885169*^9, 
   3.460444998006908*^9, 3.460459100825345*^9, 3.4604600408257113`*^9, 
   3.460460126235815*^9, 3.460460806817445*^9, 3.460548062844584*^9, 
   3.46054849348066*^9, 3.46060764268402*^9, 3.460608245251642*^9, 
   3.4606087455722637`*^9, 3.4606196806439257`*^9, 3.460619760584269*^9, 
   3.4606231184718227`*^9, 3.4606966296325293`*^9, 3.46069786086654*^9, 
   3.4607002345979347`*^9, 3.4607014372790737`*^9, 3.460701830452524*^9, 
   3.460712571040741*^9, 3.460713032985733*^9, {3.460713826625201*^9, 
   3.460713851107033*^9}, 3.4607138931533623`*^9, 3.460716665605091*^9, 
   3.460718139048274*^9, 3.460864814731645*^9, 3.460889887237143*^9, 
   3.46089000373172*^9, 3.4608908905551987`*^9, 3.460890932261243*^9, 
   3.4608911706266327`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ETA", "//", "Dimensions"}]], "Input",
 PageWidth->Infinity],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{
  3.459827872458929*^9, 3.460113028341502*^9, 3.460113964807403*^9, 
   3.46011414827166*^9, 3.460114235541856*^9, 3.4601143050197973`*^9, 
   3.460120930265955*^9, 3.460197818944401*^9, 3.460198380551972*^9, 
   3.460198528048911*^9, 3.460199526923008*^9, 3.460199654699679*^9, 
   3.4602004944230347`*^9, 3.4602006013585*^9, 3.460201879315258*^9, 
   3.46027047416743*^9, 3.4602791548111553`*^9, 3.460279214363113*^9, 
   3.46028435906882*^9, 3.460284753641265*^9, 3.460285737565564*^9, 
   3.460285990772867*^9, 3.46028627322434*^9, 3.460286308148344*^9, 
   3.460363897526703*^9, 3.4603666230008783`*^9, 3.4603697432870293`*^9, 
   3.46037003095713*^9, 3.460370342313846*^9, 3.46037153038381*^9, 
   3.460371598482769*^9, 3.460373545202051*^9, 3.4603770447549477`*^9, 
   3.460377179328969*^9, 3.460377259205921*^9, 3.460377666503717*^9, 
   3.460427457213079*^9, 3.4604329156403217`*^9, 3.460433083019814*^9, 
   3.460433121125299*^9, 3.4604345791671953`*^9, 3.4604349794001617`*^9, 
   3.4604370473376923`*^9, 3.460437553846479*^9, 3.4604403681705227`*^9, 
   3.460444576412815*^9, 3.4604447731938972`*^9, 3.4604449417584248`*^9, 
   3.460444998767621*^9, 3.460459101746324*^9, 3.46046004142026*^9, 
   3.4604601270576067`*^9, 3.460460807634131*^9, 3.4605484936631536`*^9, 
   3.460607642868312*^9, 3.460608245436234*^9, 3.4606087457572803`*^9, 
   3.460619680824728*^9, 3.460619760751773*^9, 3.4606231186542187`*^9, 
   3.460696629811714*^9, 3.460697861033092*^9, 3.460700234777237*^9, 
   3.4607014373458557`*^9, 3.4607018306187057`*^9, 3.4607125712251472`*^9, 
   3.460713033168374*^9, {3.460713826751793*^9, 3.460713851230269*^9}, 
   3.460713893321103*^9, 3.4607166657715473`*^9, 3.46071813921427*^9, 
   3.460864814815153*^9, 3.460889887317305*^9, 3.460890003949829*^9, 
   3.46089089063437*^9, 3.460890932476581*^9, 3.460891170731094*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"ETA", "\[IndentingNewLine]", "Y"}], "Input",
 CellChangeTimes->{{3.460114000133006*^9, 3.460114009445375*^9}, {
  3.460437707958293*^9, 3.460437712698263*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"-", "0.5209211781380665`"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.459827872527598*^9, 3.46011303067655*^9, 3.46011396489058*^9, {
   3.4601139984758797`*^9, 3.460114009526347*^9}, 3.46011414834797*^9, 
   3.460114235624238*^9, 3.4601143050940447`*^9, 3.460120930349319*^9, 
   3.460197819413198*^9, 3.460198381508251*^9, 3.46019852964046*^9, 
   3.460199526993176*^9, 3.460199654815744*^9, 3.460200496332955*^9, 
   3.460200601423087*^9, 3.460201879378018*^9, 3.460270474250579*^9, 
   3.460279154911991*^9, 3.4602792144465427`*^9, 3.460284359140807*^9, 
   3.460284753724605*^9, 3.460285737649325*^9, 3.4602859908555183`*^9, 
   3.460286273308621*^9, 3.460286308214764*^9, 3.460363897608238*^9, 
   3.460366623184637*^9, 3.460369743366684*^9, 3.460370031031135*^9, 
   3.4603703425137777`*^9, 3.460371530458078*^9, 3.4603715985520267`*^9, 
   3.4603735454327793`*^9, 3.460377044823373*^9, 3.460377179413405*^9, 
   3.4603772592727413`*^9, 3.460377666570675*^9, 3.460427457300247*^9, 
   3.460432915847116*^9, 3.460433083104856*^9, 3.460433121209031*^9, 
   3.460434579250781*^9, 3.460434979484872*^9, 3.46043704741685*^9, 
   3.4604375539298477`*^9, {3.460437706464828*^9, 3.4604377134974957`*^9}, 
   3.460439052589326*^9, 3.460439859095868*^9, {3.4604403682553453`*^9, 
   3.460440379020708*^9}, 3.460444576485385*^9, 3.4604447734082127`*^9, {
   3.460444941829196*^9, 3.4604449544662857`*^9}, 3.460444998837132*^9, 
   3.460459101818636*^9, 3.460460041624042*^9, 3.460460127127924*^9, 
   3.460460807717482*^9, 3.460548089211431*^9, 3.460548493749118*^9, 
   3.460607642954199*^9, 3.4606082455374393`*^9, 3.460608745846874*^9, 
   3.4606196809257383`*^9, 3.4606197608356133`*^9, 3.4606231187404957`*^9, 
   3.460696629894595*^9, 3.4606978611182623`*^9, 3.4607002348606663`*^9, 
   3.460701437407476*^9, 3.460701830704104*^9, 3.460712571326243*^9, 
   3.460713033253351*^9, {3.460713826856152*^9, 3.4607138513167543`*^9}, 
   3.460713893422844*^9, 3.4607166658582582`*^9, 3.460718139316086*^9, 
   3.460864814892069*^9, 3.460889887393464*^9, 3.460890004035535*^9, 
   3.460890890740594*^9, 3.460890932579611*^9, 3.460891170817173*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"-", "0.7881842610772917`"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.459827872527598*^9, 3.46011303067655*^9, 3.46011396489058*^9, {
   3.4601139984758797`*^9, 3.460114009526347*^9}, 3.46011414834797*^9, 
   3.460114235624238*^9, 3.4601143050940447`*^9, 3.460120930349319*^9, 
   3.460197819413198*^9, 3.460198381508251*^9, 3.46019852964046*^9, 
   3.460199526993176*^9, 3.460199654815744*^9, 3.460200496332955*^9, 
   3.460200601423087*^9, 3.460201879378018*^9, 3.460270474250579*^9, 
   3.460279154911991*^9, 3.4602792144465427`*^9, 3.460284359140807*^9, 
   3.460284753724605*^9, 3.460285737649325*^9, 3.4602859908555183`*^9, 
   3.460286273308621*^9, 3.460286308214764*^9, 3.460363897608238*^9, 
   3.460366623184637*^9, 3.460369743366684*^9, 3.460370031031135*^9, 
   3.4603703425137777`*^9, 3.460371530458078*^9, 3.4603715985520267`*^9, 
   3.4603735454327793`*^9, 3.460377044823373*^9, 3.460377179413405*^9, 
   3.4603772592727413`*^9, 3.460377666570675*^9, 3.460427457300247*^9, 
   3.460432915847116*^9, 3.460433083104856*^9, 3.460433121209031*^9, 
   3.460434579250781*^9, 3.460434979484872*^9, 3.46043704741685*^9, 
   3.4604375539298477`*^9, {3.460437706464828*^9, 3.4604377134974957`*^9}, 
   3.460439052589326*^9, 3.460439859095868*^9, {3.4604403682553453`*^9, 
   3.460440379020708*^9}, 3.460444576485385*^9, 3.4604447734082127`*^9, {
   3.460444941829196*^9, 3.4604449544662857`*^9}, 3.460444998837132*^9, 
   3.460459101818636*^9, 3.460460041624042*^9, 3.460460127127924*^9, 
   3.460460807717482*^9, 3.460548089211431*^9, 3.460548493749118*^9, 
   3.460607642954199*^9, 3.4606082455374393`*^9, 3.460608745846874*^9, 
   3.4606196809257383`*^9, 3.4606197608356133`*^9, 3.4606231187404957`*^9, 
   3.460696629894595*^9, 3.4606978611182623`*^9, 3.4607002348606663`*^9, 
   3.460701437407476*^9, 3.460701830704104*^9, 3.460712571326243*^9, 
   3.460713033253351*^9, {3.460713826856152*^9, 3.4607138513167543`*^9}, 
   3.460713893422844*^9, 3.4607166658582582`*^9, 3.460718139316086*^9, 
   3.460864814892069*^9, 3.460889887393464*^9, 3.460890004035535*^9, 
   3.460890890740594*^9, 3.460890932579611*^9, 3.46089117086442*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"plot1", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ETA", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"n", "//", "Range"}], ",", "All"}], " ", "]"}], "]"}], "//", 
     "Transpose"}], "//", "AddTimeAxis"}], ",", 
   RowBox[{"farbmodell", "\[Rule]", "Hue"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "3"}], ",", "3"}], "}"}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plot1", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Y", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"n", "//", "Range"}], ",", "All"}], " ", "]"}], "]"}], "//", 
      "Transpose"}], "//", "AddTimeAxis"}], ",", 
    RowBox[{"farbmodell", "\[Rule]", "Hue"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3"}], ",", "3"}], "}"}]}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113047733139*^9, 3.4601131167734203`*^9}, {
  3.46011396933543*^9, 3.460113989452705*^9}, {3.460114029168693*^9, 
  3.460114031766469*^9}, {3.460114161512141*^9, 3.460114164229396*^9}, {
  3.460120949297063*^9, 3.460120987997653*^9}, {3.460370039524664*^9, 
  3.460370040016472*^9}, {3.460371539333914*^9, 3.460371544125806*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
    {Opacity[1], 
     LineBox[{{0., -0.5209211781380665}, {0., -0.5209211781380665}}]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->True,
  PlotRange->{{0., 0.}, {-3, 3}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellChangeTimes->{
  3.459827873013823*^9, {3.460113055090554*^9, 3.460113095483087*^9}, 
   3.460113273581389*^9, {3.460113964976376*^9, 3.4601139901177692`*^9}, 
   3.460114033131361*^9, {3.460114150107635*^9, 3.460114164412263*^9}, 
   3.460114235720495*^9, 3.460114305171029*^9, {3.460120930436802*^9, 
   3.460120988296579*^9}, 3.460197819516024*^9, 3.460198382848845*^9, 
   3.4601985329563026`*^9, 3.4601995270581903`*^9, 3.460199655234778*^9, 
   3.460200501606188*^9, 3.460200601492147*^9, 3.460201879429142*^9, 
   3.460263155619897*^9, 3.460270474422586*^9, 3.460279155040721*^9, 
   3.460279214531389*^9, 3.460281725875258*^9, 3.460284359234613*^9, 
   3.4602847538095922`*^9, 3.460285737715163*^9, 3.460285990939274*^9, 
   3.4602862733933067`*^9, 3.460286308282538*^9, 3.460363898395814*^9, 
   3.460364466117779*^9, 3.4603666232531223`*^9, 3.460369743455418*^9, {
   3.460370031100134*^9, 3.460370040128583*^9}, 3.4603703425836487`*^9, {
   3.460371530559222*^9, 3.460371545091758*^9}, 3.4603715986232557`*^9, 
   3.460373545549732*^9, 3.460377044924808*^9, 3.460377179522697*^9, 
   3.460377259356626*^9, 3.460377666635418*^9, {3.4604274573851433`*^9, 
   3.4604274826315393`*^9}, 3.460431486420775*^9, 3.460431951982443*^9, 
   3.460432442105898*^9, 3.460432915923843*^9, 3.460433083188562*^9, 
   3.460433121276486*^9, 3.460434371750841*^9, 3.460434579330331*^9, 
   3.460434979549678*^9, 3.4604351320544157`*^9, 3.460437047500869*^9, 
   3.460437554166368*^9, 3.4604377000545588`*^9, 3.4604389249118958`*^9, 
   3.460439049759118*^9, 3.460439356387733*^9, 3.460439855697237*^9, 
   3.46044036838757*^9, 3.460444576617157*^9, 3.460444773535759*^9, 
   3.460444941960794*^9, 3.460444998952558*^9, 3.4604591019466887`*^9, 
   3.460459450661531*^9, 3.460460041769643*^9, 3.460460127257649*^9, 
   3.460460807831476*^9, 3.4605480906506033`*^9, 3.460548493883357*^9, 
   3.46060764308528*^9, 3.460608245671123*^9, 3.460608745990651*^9, 
   3.460619681059555*^9, 3.4606197609662323`*^9, 3.460623118855435*^9, 
   3.460691610687475*^9, 3.460696630024538*^9, 3.460697861235483*^9, 
   3.460700234991631*^9, 3.460701437471643*^9, 3.4607018308345337`*^9, 
   3.4607125715771837`*^9, 3.460713033388028*^9, {3.460713826987383*^9, 
   3.4607138514303427`*^9}, 3.460713893553914*^9, 3.460716665990963*^9, 
   3.460718139451044*^9, 3.4608648150278177`*^9, 3.46088988752421*^9, 
   3.460890004189228*^9, 3.460890890889306*^9, 3.4608909327270203`*^9, 
   3.4608911709864388`*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
    {Opacity[1], 
     LineBox[{{0., -0.7881842610772917}, {0., -0.7881842610772917}}]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->True,
  PlotRange->{{0., 0.}, {-3, 3}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellChangeTimes->{
  3.459827873013823*^9, {3.460113055090554*^9, 3.460113095483087*^9}, 
   3.460113273581389*^9, {3.460113964976376*^9, 3.4601139901177692`*^9}, 
   3.460114033131361*^9, {3.460114150107635*^9, 3.460114164412263*^9}, 
   3.460114235720495*^9, 3.460114305171029*^9, {3.460120930436802*^9, 
   3.460120988296579*^9}, 3.460197819516024*^9, 3.460198382848845*^9, 
   3.4601985329563026`*^9, 3.4601995270581903`*^9, 3.460199655234778*^9, 
   3.460200501606188*^9, 3.460200601492147*^9, 3.460201879429142*^9, 
   3.460263155619897*^9, 3.460270474422586*^9, 3.460279155040721*^9, 
   3.460279214531389*^9, 3.460281725875258*^9, 3.460284359234613*^9, 
   3.4602847538095922`*^9, 3.460285737715163*^9, 3.460285990939274*^9, 
   3.4602862733933067`*^9, 3.460286308282538*^9, 3.460363898395814*^9, 
   3.460364466117779*^9, 3.4603666232531223`*^9, 3.460369743455418*^9, {
   3.460370031100134*^9, 3.460370040128583*^9}, 3.4603703425836487`*^9, {
   3.460371530559222*^9, 3.460371545091758*^9}, 3.4603715986232557`*^9, 
   3.460373545549732*^9, 3.460377044924808*^9, 3.460377179522697*^9, 
   3.460377259356626*^9, 3.460377666635418*^9, {3.4604274573851433`*^9, 
   3.4604274826315393`*^9}, 3.460431486420775*^9, 3.460431951982443*^9, 
   3.460432442105898*^9, 3.460432915923843*^9, 3.460433083188562*^9, 
   3.460433121276486*^9, 3.460434371750841*^9, 3.460434579330331*^9, 
   3.460434979549678*^9, 3.4604351320544157`*^9, 3.460437047500869*^9, 
   3.460437554166368*^9, 3.4604377000545588`*^9, 3.4604389249118958`*^9, 
   3.460439049759118*^9, 3.460439356387733*^9, 3.460439855697237*^9, 
   3.46044036838757*^9, 3.460444576617157*^9, 3.460444773535759*^9, 
   3.460444941960794*^9, 3.460444998952558*^9, 3.4604591019466887`*^9, 
   3.460459450661531*^9, 3.460460041769643*^9, 3.460460127257649*^9, 
   3.460460807831476*^9, 3.4605480906506033`*^9, 3.460548493883357*^9, 
   3.46060764308528*^9, 3.460608245671123*^9, 3.460608745990651*^9, 
   3.460619681059555*^9, 3.4606197609662323`*^9, 3.460623118855435*^9, 
   3.460691610687475*^9, 3.460696630024538*^9, 3.460697861235483*^9, 
   3.460700234991631*^9, 3.460701437471643*^9, 3.4607018308345337`*^9, 
   3.4607125715771837`*^9, 3.460713033388028*^9, {3.460713826987383*^9, 
   3.4607138514303427`*^9}, 3.460713893553914*^9, 3.460716665990963*^9, 
   3.460718139451044*^9, 3.4608648150278177`*^9, 3.46088988752421*^9, 
   3.460890004189228*^9, 3.460890890889306*^9, 3.4608909327270203`*^9, 
   3.460891171036223*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ML-Sch\[ADoubleDot]tzung", "Subsection",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["ML", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[{"Theta", "\[IndentingNewLine]", "Y"}], "Input",
 CellChangeTimes->{{3.460427516601119*^9, 3.460427517953906*^9}, {
   3.4604302860648613`*^9, 3.460430286459763*^9}, 3.4604320351169157`*^9, {
   3.460459207514338*^9, 3.460459209125545*^9}}],

Cell[BoxData[
 RowBox[{"{", "1", "}"}]], "Output",
 CellChangeTimes->{{3.460444788235248*^9, 3.460444817682623*^9}, 
   3.4604450103485413`*^9, 3.460459143269252*^9, 3.4604592096793203`*^9, 
   3.460459927811483*^9, 3.46046040805451*^9, 3.460461792764674*^9, 
   3.460548131585779*^9, 3.4605486584763927`*^9, 3.460608751013831*^9, 
   3.4606197029909687`*^9, {3.460619766962469*^9, 3.46061978031246*^9}, 
   3.4606231255195627`*^9, 3.460700237436638*^9, 3.4607014474766912`*^9, 
   3.4607125749914618`*^9, 3.460864820015126*^9, 3.460865290700837*^9, 
   3.460889914481102*^9, 3.460890531238562*^9, 3.4608909051890297`*^9, 
   3.460890935958137*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"-", "0.7881842610772917`"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.460444788235248*^9, 3.460444817682623*^9}, 
   3.4604450103485413`*^9, 3.460459143269252*^9, 3.4604592096793203`*^9, 
   3.460459927811483*^9, 3.46046040805451*^9, 3.460461792764674*^9, 
   3.460548131585779*^9, 3.4605486584763927`*^9, 3.460608751013831*^9, 
   3.4606197029909687`*^9, {3.460619766962469*^9, 3.46061978031246*^9}, 
   3.4606231255195627`*^9, 3.460700237436638*^9, 3.4607014474766912`*^9, 
   3.4607125749914618`*^9, 3.460864820015126*^9, 3.460865290700837*^9, 
   3.460889914481102*^9, 3.460890531238562*^9, 3.4608909051890297`*^9, 
   3.460890935967175*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"VALS", "//", "Flatten"}], ",", "WEIGHT"}], "}"}], "//", 
      "Transpose"}], "//", "plot1"}], ",", "\[IndentingNewLine]", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       StyleBox[
        RowBox[{"GaussD", 
         StyleBox["ichte",
          FontSlant->"Italic"]}]], 
       StyleBox["[",
        FontSlant->"Italic"], 
       StyleBox[
        RowBox[{"x", ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}],
        FontSlant->"Italic"], 
       StyleBox["]",
        FontSlant->"Italic"]}], 
      StyleBox[",",
       FontSlant->"Italic"], 
      StyleBox[
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"-", "10"}], ",", "10"}], "}"}],
       FontSlant->"Italic"]}], "]"}]}], "}"}], "//", "Show"}]], "Input",
 CellChangeTimes->{{3.460621535780631*^9, 3.460621545331935*^9}, {
  3.460622055033049*^9, 3.460622057014207*^9}, {3.460622114665539*^9, 
  3.4606221170063562`*^9}, {3.4606221493268843`*^9, 3.460622283410459*^9}, {
  3.460622330190056*^9, 3.460622333996092*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {RGBColor[0, 0, 1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
     {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ/TPabt7NEoUDqtGOdxYu2mzTy6Kx3qlb/sBU9+cz
fPU+28R37NWbqi93wMu3YOLZMANb12XLH5ZfkznQwFZkdDo+w3b128Zju+ul
DxRpiEhxfp1vqxHkZ2OqLXXAOVVrw7zKS7b9XCdm774hceDkHufbE54y2U1i
vn5Po0P8QBX/Po9kVUO7nv59wZGWYgcSpNsnp62Jtjt+SDxK+43IgXsqAYfm
vGi2myDFolG/QPjAFD6/0x7TV9qt2u87zSxM6EDukQ0z3xSetXMpTPlkwit4
4Eljhqp14ju7/hkrVu3t4j+w9dOyDWfUeOy3VH38a/yX50DqW6vSNWXq9oeu
TM+cVch1oEzOPPTeHEf76sJp7geesx/gtp+o0nM93L7j1q/OsnjWA3JGYbuW
K+baz7fI6+i/wXRATmeflaVIg/3sk30X7wUxHFj9lm1bA88Ee1Nv9v+Fc37v
l70vv+/Tnzn2Lxb2yD2f8m1/b9JctQ2bl9vPU4ooOdn3cX8Ty67Wq70b7SXX
Cbn2Cr/cL/HmvPuG/u32X+9lXzQRu7d/Qt97TZlVe+wtzT6eT+I7sl+1mvVu
3dz99nYQvr0UlP8Lot4epl4KYp69CNS8BRD77Cuh9r2EuMe+C+oeE4h77aWg
7p0F8Y/Dcqh/ZkL866AI9W8XJDwcYOFRBwkvBxZoeB2DhKdDNTQ8t0HC2yEd
Gt59kPhw2AyND2h8OTyGxtdqSHw6ZEPjExrfDpOg8X0akh4cHkPTQwckvThk
S0HSSxskPTlI8UHTEyS9ORyApjdoenRwhabHNZD06lACTa8WkPTsUAdNz8mQ
9O7gA03vUyD5wWEOND9A84vD+yhIfgEAUMKFqw==
       "]]}}}, {{}, {}, 
    {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJw11vk/1OsCwHHGvoxl7GMsQ6WkbFky8/0+j0lScW2JykmNrGVtmiKjIlQn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      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.460701466499126*^9, {3.460702868135065*^9, 3.460702880994237*^9}, 
   3.4607125767377453`*^9, 3.4607126210681877`*^9, 3.46071389693813*^9, 
   3.4607166756847563`*^9, {3.460718325367756*^9, 3.460718332435192*^9}, 
   3.460864823509678*^9, 3.4608899192326317`*^9, 3.4608909066607723`*^9, 
   3.460890941621625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"scaling", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pp", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m", "=", "100"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"IndividualLikNonlinNorKorr", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Y", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"IdioNonlin", ",", 
     RowBox[{"{", "}"}], ",", "m", ",", 
     RowBox[{"eps", "=", 
      RowBox[{"10.", "^", 
       RowBox[{"-", "16"}]}]}], ",", 
     RowBox[{"ksigma", "=", "Infinity"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0", ",", 
     RowBox[{"onlyNorKorr", "=", "0"}]}], "}"}]}], "]"}], "\n", 
 RowBox[{"IndividualLikNonlinNorKorr", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Y", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"IdioNonlin", ",", 
     RowBox[{"{", "}"}], ",", "m", ",", 
     RowBox[{"eps", "=", 
      RowBox[{"10.", "^", 
       RowBox[{"-", "16"}]}]}], ",", 
     RowBox[{"ksigma", "=", "Infinity"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0", ",", 
     RowBox[{"onlyNorKorr", "=", "1"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"IndividualLik", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Y", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
    RowBox[{"{", 
     RowBox[{"Idio", ",", 
      RowBox[{"{", "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Singular", "=", "False"}], ",", 
      RowBox[{"2", "Pi"}], " ", ",", "0"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.460264864897327*^9, 3.460264932378791*^9}, {
   3.460265489300803*^9, 3.460265492492799*^9}, {3.46027038606568*^9, 
   3.460270391802556*^9}, {3.4602704971596107`*^9, 3.4602705817118692`*^9}, {
   3.46027367414145*^9, 3.460273674236417*^9}, {3.460279775378045*^9, 
   3.4602797754444103`*^9}, {3.4602799530257587`*^9, 
   3.4602799533811693`*^9}, {3.460280067013379*^9, 3.460280067130088*^9}, {
   3.4602801040742397`*^9, 3.460280104129944*^9}, {3.4602801453821163`*^9, 
   3.4602801673531218`*^9}, {3.46028174693688*^9, 3.460281763776168*^9}, {
   3.4602818356559362`*^9, 3.460281835739462*^9}, {3.460281898670804*^9, 
   3.460281898732609*^9}, {3.460282025318959*^9, 3.460282025741701*^9}, {
   3.460282062175247*^9, 3.460282071535883*^9}, {3.460283778391947*^9, 
   3.4602837888805027`*^9}, {3.4602838305963707`*^9, 3.460283854615387*^9}, {
   3.46028477341341*^9, 3.460284779157151*^9}, {3.460285035206752*^9, 
   3.460285046973556*^9}, {3.46028555906642*^9, 3.460285574425418*^9}, {
   3.4602857519094887`*^9, 3.4602857519715776`*^9}, {3.460285881590439*^9, 
   3.4602858816380377`*^9}, {3.460286117999454*^9, 3.460286123654068*^9}, {
   3.4602863340289307`*^9, 3.4602863377475977`*^9}, {3.4603641927287188`*^9, 
   3.460364197580667*^9}, {3.460365058304535*^9, 3.4603650587979116`*^9}, {
   3.460365091217347*^9, 3.460365126318194*^9}, {3.4603652464521227`*^9, 
   3.460365260029804*^9}, {3.460365412299954*^9, 3.460365434375272*^9}, {
   3.460365485584791*^9, 3.460365520950554*^9}, {3.460366663535665*^9, 
   3.460366678997499*^9}, {3.4603667867732773`*^9, 3.4603667868283587`*^9}, {
   3.460367092714067*^9, 3.460367098883337*^9}, {3.460369235357655*^9, 
   3.460369263924768*^9}, {3.460369362646221*^9, 3.46036936313859*^9}, {
   3.46036946785526*^9, 3.4603694691077127`*^9}, {3.46037339069245*^9, 
   3.460373390747698*^9}, {3.460373605599341*^9, 3.4603736056503153`*^9}, {
   3.460377091108459*^9, 3.460377126962656*^9}, {3.460377288435691*^9, 
   3.460377301095058*^9}, {3.4603774697122087`*^9, 3.460377479788327*^9}, {
   3.460377585320611*^9, 3.460377603716568*^9}, {3.4603776957101793`*^9, 
   3.460377736561165*^9}, {3.460377923292104*^9, 3.4603779233524303`*^9}, {
   3.460378105932313*^9, 3.46037817981962*^9}, {3.460427531315346*^9, 
   3.460427537420005*^9}, {3.460427638978484*^9, 3.4604276390230217`*^9}, {
   3.4604277414332314`*^9, 3.460427769573126*^9}, {3.4604279604982853`*^9, 
   3.460427960554902*^9}, {3.460430680071252*^9, 3.460430680172152*^9}, {
   3.460430712203142*^9, 3.460430712557424*^9}, {3.460430775931464*^9, 
   3.460430776020101*^9}, {3.460430814349124*^9, 3.460430814950081*^9}, {
   3.46043100067663*^9, 3.460431000775926*^9}, {3.460431035518139*^9, 
   3.460431043615539*^9}, {3.460431139283386*^9, 3.460431139330926*^9}, {
   3.4604311987514153`*^9, 3.460431233744923*^9}, {3.460431314274002*^9, 
   3.460431314321568*^9}, {3.4604316727142878`*^9, 3.4604316728008432`*^9}, {
   3.460431886035831*^9, 3.46043189177104*^9}, {3.460432099991972*^9, 
   3.460432100073539*^9}, {3.460432236204804*^9, 3.4604322362468243`*^9}, {
   3.4604323376555843`*^9, 3.460432357162323*^9}, {3.460432403219545*^9, 
   3.460432403269651*^9}, {3.460432564446265*^9, 3.4604325911495867`*^9}, {
   3.460432813689516*^9, 3.460432813733564*^9}, {3.460432944239506*^9, 
   3.460432989199974*^9}, {3.460433097024789*^9, 3.460433097139295*^9}, {
   3.460433291653358*^9, 3.46043329173923*^9}, {3.460433672964451*^9, 
   3.460433673010107*^9}, {3.460433845665332*^9, 3.4604338457416363`*^9}, {
   3.4604344009903316`*^9, 3.460434401033557*^9}, {3.4604346235115023`*^9, 
   3.460434638473834*^9}, {3.460434675871023*^9, 3.460434675925946*^9}, {
   3.4604350413113747`*^9, 3.4604350414069347`*^9}, {3.460436666989565*^9, 
   3.460436677468376*^9}, {3.460437023691847*^9, 3.460437023772811*^9}, {
   3.460437179838045*^9, 3.460437214787621*^9}, {3.4604373750456057`*^9, 
   3.460437375101828*^9}, {3.460437455923118*^9, 3.4604374559862347`*^9}, {
   3.460437643282413*^9, 3.4604376433404827`*^9}, {3.460439284564681*^9, 
   3.46043929340877*^9}, {3.460439393566842*^9, 3.460439393962884*^9}, {
   3.46044000098571*^9, 3.460440001044331*^9}, {3.460443930270521*^9, 
   3.460443930334333*^9}, {3.460443966799687*^9, 3.46044399790462*^9}, {
   3.460444060284606*^9, 3.460444061730588*^9}, {3.460444101336812*^9, 
   3.46044410138903*^9}, {3.460444186536171*^9, 3.460444194286351*^9}, {
   3.460444233408099*^9, 3.460444248920389*^9}, {3.460444338058318*^9, 
   3.460444355662019*^9}, {3.460444400012597*^9, 3.460444431012135*^9}, {
   3.460444591036777*^9, 3.4604446631572647`*^9}, {3.46044479971354*^9, 
   3.460444799768903*^9}, {3.460444831583193*^9, 3.460444859781989*^9}, {
   3.46044502143334*^9, 3.460445021504759*^9}, {3.460459950502769*^9, 
   3.460459971711813*^9}, {3.460460068419449*^9, 3.460460088588605*^9}, {
   3.460460154598343*^9, 3.46046015516997*^9}, {3.460460281436612*^9, 
   3.460460281521656*^9}, {3.4604604120265713`*^9, 3.460460412125514*^9}, {
   3.4604607607833633`*^9, 3.4604607621971283`*^9}, {3.460460826677142*^9, 
   3.460460827186878*^9}, {3.4604608962826014`*^9, 3.4604608963501987`*^9}, {
   3.460460962965583*^9, 3.460460963358262*^9}, {3.46046100555375*^9, 
   3.4604610220017967`*^9}, {3.46046105589403*^9, 3.460461056004932*^9}, {
   3.460461154113535*^9, 3.460461154227416*^9}, {3.460461800671767*^9, 
   3.4604618154025*^9}, {3.46046184541817*^9, 3.46046186011173*^9}, {
   3.460461896620476*^9, 3.460461896672694*^9}, {3.460461952952413*^9, 
   3.4604619533933907`*^9}, {3.460462913572587*^9, 3.460462920740217*^9}, {
   3.460548175219633*^9, 3.460548179294363*^9}, {3.460548260239588*^9, 
   3.460548260297719*^9}, {3.460548333262265*^9, 3.460548333779482*^9}, {
   3.460548675566861*^9, 3.460548693804049*^9}, {3.460548972449188*^9, 
   3.4605491929429903`*^9}, {3.460549257251377*^9, 3.460549267901092*^9}, {
   3.4605496024993763`*^9, 3.4605496337333307`*^9}, {3.460549667762332*^9, 
   3.46054966825324*^9}, {3.460607544492757*^9, 3.460607557468165*^9}, {
   3.460607591423718*^9, 3.460607615734179*^9}, {3.4606076546131697`*^9, 
   3.460607711208377*^9}, {3.460607950300333*^9, 3.460607950788868*^9}, {
   3.460608254691515*^9, 3.460608332544549*^9}, {3.460608365633368*^9, 
   3.4606083656943207`*^9}, {3.460608434510606*^9, 3.460608528562172*^9}, {
   3.460608559009796*^9, 3.460608584467407*^9}, {3.460608755712895*^9, 
   3.4606087818086443`*^9}, {3.460608915820417*^9, 3.46060895109648*^9}, {
   3.4606090353514013`*^9, 3.460609089338924*^9}, {3.460619799153166*^9, 
   3.4606198362306223`*^9}, 3.460619905423987*^9, {3.460621024814104*^9, 
   3.460621075759169*^9}, {3.460621192179472*^9, 3.4606212134045153`*^9}, {
   3.4606214203824053`*^9, 3.460621428920328*^9}, {3.4606215045280933`*^9, 
   3.460621505423924*^9}, {3.460621613387906*^9, 3.460621638578682*^9}, {
   3.460621694074709*^9, 3.460621703411603*^9}, {3.4606217660430403`*^9, 
   3.460621767329904*^9}, {3.460621806996888*^9, 3.4606218076980343`*^9}, {
   3.460621883288566*^9, 3.46062188333815*^9}, {3.460621970939987*^9, 
   3.4606219893319883`*^9}, {3.460622107014687*^9, 3.460622107100986*^9}, {
   3.460622297972288*^9, 3.460622306665023*^9}, {3.460622338760532*^9, 
   3.460622398767516*^9}, {3.460622676496147*^9, 3.4606226765399942`*^9}, {
   3.4606227120282917`*^9, 3.460622766881015*^9}, {3.4606229263578787`*^9, 
   3.460622944163636*^9}, {3.4606229791390038`*^9, 3.460622982600178*^9}, {
   3.4606230423052397`*^9, 3.460623049675028*^9}, {3.4606231523155127`*^9, 
   3.460623159744812*^9}, {3.460623194195408*^9, 3.460623258120954*^9}, {
   3.460687849143656*^9, 3.460687889401013*^9}, {3.460690081391994*^9, 
   3.460690099337471*^9}, {3.460690130038103*^9, 3.46069013008521*^9}, 
   3.4606902754485703`*^9, {3.460698988112274*^9, 3.460698991400546*^9}, 
   3.460699028468751*^9, {3.460700313321166*^9, 3.460700333126775*^9}, {
   3.460700615798884*^9, 3.4607006190760393`*^9}, 3.460701679102146*^9, 
   3.460716635576797*^9, 3.460716739992663*^9, {3.460890946141396*^9, 
   3.460890952906789*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "1", "}"}], "}"}]], "Print",
 CellChangeTimes->{
  3.4607125941610928`*^9, 3.460713036837367*^9, {3.4607138313300943`*^9, 
   3.4607138550169573`*^9}, {3.460713899250411*^9, 3.460713912167659*^9}, {
   3.460716625964521*^9, 3.460716636089563*^9}, 3.460716672114872*^9, 
   3.4607167405833178`*^9, 3.46071814579046*^9, 3.460718328304133*^9, 
   3.460864847870467*^9, 3.4608899021408253`*^9, 3.4608900104100113`*^9, 
   3.4608909006918163`*^9, {3.460890938409459*^9, 3.460890953532361*^9}, 
   3.46089117646599*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"-", "6"}], "}"}]], "Print",
 CellChangeTimes->{
  3.4607125941610928`*^9, 3.460713036837367*^9, {3.4607138313300943`*^9, 
   3.4607138550169573`*^9}, {3.460713899250411*^9, 3.460713912167659*^9}, {
   3.460716625964521*^9, 3.460716636089563*^9}, 3.460716672114872*^9, 
   3.4607167405833178`*^9, 3.46071814579046*^9, 3.460718328304133*^9, 
   3.460864847870467*^9, 3.4608899021408253`*^9, 3.4608900104100113`*^9, 
   3.4608909006918163`*^9, {3.460890938409459*^9, 3.460890953532361*^9}, 
   3.4608911764759283`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"-", "0.7881842610772917`"}], "}"}]], "Print",
 CellChangeTimes->{
  3.4607125941610928`*^9, 3.460713036837367*^9, {3.4607138313300943`*^9, 
   3.4607138550169573`*^9}, {3.460713899250411*^9, 3.460713912167659*^9}, {
   3.460716625964521*^9, 3.460716636089563*^9}, 3.460716672114872*^9, 
   3.4607167405833178`*^9, 3.46071814579046*^9, 3.460718328304133*^9, 
   3.460864847870467*^9, 3.4608899021408253`*^9, 3.4608900104100113`*^9, 
   3.4608909006918163`*^9, {3.460890938409459*^9, 3.460890953532361*^9}, 
   3.460891176486168*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0, 0, 1], PointSize[0.02], Thickness[0.02], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQzcv1xH/xOskDDFAgHvmzWHS6BJz/wYl9we5GcThf
SnWuc26eGJyfUJ5+nyVWFM5frLVgabyvCJxfkaimEWsvDOenGtwWvG8kBOdv
kI96eUJdEM6fJd10+7+sAJzvKSwleVWLD863y4u5+1CaB84PP7Hb6gcf14GO
0nm3Nnl9ECz4Z1n5hpnjwPqKpXXnZzeqBNQYb5/yi/VAoqH++gOZiQa+8dlb
TnxiPrDIaJVNRuEy831TmRYlvmE8wGTcwFP9+IF1W4Lz2+Jz//ebLeRg152k
bXfsR25P1LHf+yOfTF1SWRBgfzy03tLgwPf9x9+emnX43gX7CkeP7et3f96/
6+w2rr8mDA5qP76laBW+37/lddq9w3HcDquPzeewyX2+X5X3bqRcA7eDmrDd
A8Vr9/YfcxHymaDK4fCa79j0OSvO7u9dKXu+W4nFYYVdcbvHgUn28R5mcSuv
/bcPWz7V/rr2Rfuz9kve5F39YR/z8Tun6LQH9uz761/Ob/5qb1KueuXftBf2
XlUbXRX/fLdXlwr+NsXng73TxbBGr7uMDk821an0+H2xt5rbbKgWzuXgXuG9
clngD/sVzDI606v/2k/tadJWD/tjv33hK19v41X2x6Zb7NfQY3BY8MfhQ3zE
fru13ovzTY2YHI4utXHzrN5ko2HIIh1rzuLgu0RyjcOWnRY7fuXoHrFlc/iS
2PlqrtJGw13ipgYTXDkctBj23VfIZ1S7PtP603M/Lgfp5b5/wn91Cu9P3rv5
cySPAyz+VnDGhd1N44PzI67zer6wEoDzA18yzah1FoTzE9/eWurmKwTnC/yL
PhcTIQzna+ovf3IrRQTOD/+hkHS3SBTOF3F9MbupSQzOP/JJluH1ZHGEewQ6
YiyXS8D5F9WqDCbvkYTzD15P4VG8IgXnAwC19iMo
           "]]}}, {}}, {{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.01], Thickness[0.01], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQzcv1xH/xOskDqtGOdxYu2mwjHvmzWHS6xIGp7s9n
+Op9tvngxL5gd6P4AS/fgolnwwxspVTnOufmiR1oYCsyOh2fYZtQnn6fJVb0
QJGGiBTn1/m2i7UWLI33FTngnKq1YV7lJduKRDWNWHvhAyf3ON+e8JTJLtXg
tuB9I6EDVfz7PJJVDe02yEe9PKEueCBBun1y2ppou1nSTbf/ywocuKcScGjO
i2Y7T2EpyatafAem8Pmd9pi+0s4uL+buQ2meA7lHNsx8U3jWLvzEbqsffFwH
njRmqFonvrMr+GdZ+YaZ48DWT8s2nFHjsQ+oMd4+5RfrgdS3VqVrytTtfeOz
t5z4xHygTM489N4cR/t9U5kWJb5hPMBtP1Gl53q4fVuC89vic//3yxmF7Vqu
mGt/7EduT9Sx3/vldPZZWYo02B8Prbc0OPB9/+q3bNsaeCbYVzh6bF+/+/N+
2fvy+z79mWOv9uNbilbh+/29SXPVNmxebr/62HwOm9zn+5tYdrVe7d1oryZs
90Dx2r39Em/Ou2/o327/mu/Y9Dkrzu6f0PdeU2bVHvsVdsXtHgcm2atWs96t
m7vfPmz5VPvr2hftpaD8mI/fOUWnPbCHqTcpV73yb9oLexGoeepSwd+m+Hyw
r4Ta92RTnUqP3xf7Lqh73Cu8Vy4L/GEvBXXv1J4mbfWwP/bLof45Nt1iv4Ye
g4Mi1L9rvRfnmxoxOcDCQ8OQRTrWnMWBBRpeO37l6B6xZXOohobnLnFTgwmu
HA7p0PC+PtP603M/LofN0PjYn7x38+dIHofH0PhawRkXdjeNzyEbGp8R13k9
X1gJOEyCxnfgS6YZtc6CDo+h6SHx7a2lbr5CDtlSkPQi8C/6XEyEsIMUHyQ9
aeovf3IrRcThADS9hf9QSLpbJOrgCk2PIq4vZjc1iTmUQNPrkU+yDK8nizvU
QdPzCoGOGMvlEg4+0PR+Ua3KYPIeSYc50Pxw8HoKj+IVKYf3UZD8AgAmE3xT

           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{-0.7881842610772917}, {1}},
      PlotRange->{{-4, 4}, {0, 10}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {193.5, -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.02], Thickness[0.02], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQzcv1xH/xOskDqtGOdxYu2mwjHvmzWHS6xIGp7s9n
+Op9tvngxL5gd6P4AS/fgolnwwxspVTnOufmiR1oYCsyOh2fYZtQnn6fJVb0
QJGGiBTn1/m2i7UWLI33FTngnKq1YV7lJduKRDWNWHvhAyf3ON+e8JTJLtXg
tuB9I6EDVfz7PJJVDe02yEe9PKEueCBBun1y2ppou1nSTbf/ywocuKcScGjO
i2Y7T2EpyatafAem8Pmd9pi+0s4uL+buQ2meA7lHNsx8U3jWLvzEbqsffFwH
njRmqFonvrMr+GdZ+YaZ48DWT8s2nFHjsQ+oMd4+5RfrgdS3VqVrytTtfeOz
t5z4xHygTM489N4cR/t9U5kWJb5hPMBtP1Gl53q4fVuC89vic//3yxmF7Vqu
mGt/7EduT9Sx3/vldPZZWYo02B8Prbc0OPB9/+q3bNsaeCbYVzh6bF+/+/N+
2fvy+z79mWOv9uNbilbh+/29SXPVNmxebr/62HwOm9zn+5tYdrVe7d1oryZs
90Dx2r39Em/Ou2/o327/mu/Y9Dkrzu6f0PdeU2bVHvsVdsXtHgcm2atWs96t
m7vfPmz5VPvr2hftpaD8mI/fOUWnPbCHqTcpV73yb9oLexGoeepSwd+m+Hyw
r4Ta92RTnUqP3xf7Lqh73Cu8Vy4L/GEvBXXv1J4mbfWwP/bLof45Nt1iv4Ye
g4Mi1L9rvRfnmxoxOcDCQ8OQRTrWnMWBBRpeO37l6B6xZXOohobnLnFTgwmu
HA7p0PC+PtP603M/LofN0PjYn7x38+dIHofH0PhawRkXdjeNzyEbGp8R13k9
X1gJOEyCxnfgS6YZtc6CDo+h6SHx7a2lbr5CDtlSkPQi8C/6XEyEsIMUHyQ9
aeovf3IrRcThADS9hf9QSLpbJOrgCk2PIq4vZjc1iTmUQNPrkU+yDK8nizvU
QdPzCoGOGMvlEg4+0PR+Ua3KYPIeSYc50Pxw8HoKj+IVKYf3UZD8AgAmE3xT

           "]]}}, {}}, {{}, 
        {RGBColor[1, 0, 0], PointSize[0.02], Thickness[0.02], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQzcv1xH/xOskDDFAgHvmzWHS6BJz/wYl9we5GcThf
SnWuc26eGJyfUJ5+nyVWFM5frLVgabyvCJxfkaimEWsvDOenGtwWvG8kBOdv
kI96eUJdEM6fJd10+7+sAJzvKSwleVWLD863y4u5+1CaB84PP7Hb6gcf14H5
z06xCj3IFiz4Z1n5hpnjgEJDYEWWIadKQI3x9im/WA8IT/RXcOH6ou8bn73l
xCfmAylLbXYI/Xc23zeVaVHiG8YDPacDNyrlt1m3JTi/LT73f3+//MkMd59b
tsd+5PZEHfu9P9LV++vZTaz2x0PrLQ0OfN//0CV1lvvmXvsKR4/t63d/3m8R
Zj9jZcQhe7Uf31K0Ct/v/7NkoYyJ2WX71cfmc9jkPt8vYHhf/LvYdXs1YbsH
itfu7dd9wj3lXcp1+9d8x6bPWXF2/8btGyct2X7VfoVdcbvHgUn25y/kMi8s
vGQftnyq/XXti/aCJVkLfC+dtY/5+J1TdNoDe18HfuveayftTcpVr/yb9sL+
Ud21bcJnTturSwV/m+LzwX7jhA0lF9wu2z/ZVKfS4/fFXvbivE072m/au1d4
r1wW+MN+qdwn/4xDJ+yn9jRpq4f9sX/V0Bn4ManI/th0i/0aegwOHG6GBYU7
G+3Wei/ONzVicogzVN5iZVNgo2HIIh1rzuKwVe1wl83zAosdv3J0j9iyORyp
Xqr8ziHBcJe4qcEEVw4H44nvHr79sUz1+kzrT8/9uBycntrPM3ysJrw/ee/m
z5E8DrD4W8EZF3Y3jQ/Oj7jO6/nCSgDOD3zJNKPWWRDOT3x7a6mbrxCcL/Av
+lxMhDCcr6m//MmtFBE4P/yHQtLdIlE4X8T1xeymJjE4/8gnWYbXk8UR7hHo
iLFcLgHnX1SrMpi8RxLOP3g9hUfxihScDwCGiiW9
           "]]}}, {}}, {{}, 
        {RGBColor[1, 1, 0], PointSize[0.015], Thickness[0.015], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJwBUQOu/CFib1JlAgAAADQAAAACAAAADQrkT6OuGcBs6ASMKn2RPhdZ+XMV
lxjAJJJTdNTIqD7wQgegu4EXwBd0s6NDs8A+GiWdQ21uFsDNPZCmRW/VPmB3
Z98EXRXAWHGzJ/o86j6jKqClX00UwOlgZ8Szq/4+eGEmKF0/E8BpJs6TSSMR
P2Uw2xHfMhLA5DF8/01UIj+wH1rpyCcRwCdRB/6AxzI/mhuC2/8dEMAQimZw
iXJCP0kTGhnVKg7AtdCsVmxjUT8+blzd4RsMwE9DFuwkel8/V8i7OvgOCsCl
E+bLQmBrP3D+OXnsAwjAPbdl8Drkdj9QfDO3lPoFwJ9GKiXwaYI/TV9rtMjy
A8DoPsCG84KMP76VAqJh7AHAuVqBoPVAlT+GYEPtc87/vx9vTkPAhZ4/xvht
jFrG+7/kGcf3WB6lP8dVfzkwwPe/0UZcPhkrrD94QUi3r7vzv3q/T/GtHLI/
Jvj2ZCpx778GlG9rJXa2P6vGnwg8bee/sGB5JRneuj8mEz7gIdbev5Xv7O23
AL8/6w7Gl5yozb9iSSvI50HBP6g+c4dIwJI/2rPUd5OJwj9Wp5U/1yvRP7LV
vxmrNsM/XPH3CRWW4D+YKjuvNzfDPzR3JdT+lug/Mt72mwqLwj8nGlP2lEzw
P0XAGfzKQ8E/5LJ+JIxO9D8cfR36AAS/P0d4S6mmUfg/Y37c15Pfuj+VjIIr
J1b8P5IWwlzbdLY/xpc4vyguAEDv6/BiOhiyP61Lo281MgJAhbGx4VAcrD8o
MQQbXTcEQKQwBAgjC6U/uPpsLcQ9BkAxsiDUh1qeP7oXNTCQRQhAc0zR2ywV
lT/XmTvy504KQOyDKetyMYw/v2O9s/NZDEBXYDztbiOCP6gJXlbdZg5AzB/Z
2AVydj9Y1w1J6DoQQGWc3Qo2smo/UekCmH1DEUCRZjX9w39eP2Ht2qVGTRJA
p/K+vAm5UD8Q/lvOXFgTQHsHqKXKlkE/KS+n5NpkFEAKa+gfrLoxP1f4IGLd
chVAXOLXHyQcIT8UReibgoIWQNh/72hGlg8/xPIdAOuTF0DyPn88QNv7PqgQ
iFw5pxhAAxJLKTFx5z7RJnowk7wZQLwTZd6VzNI+wddkDCHUGkC4XthUsLC8
PhnTg1Q=
           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{-0.7881842610772917}, None},
      PlotRange->{{-4, 4}, {0, 0.7978175629309906}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {580.5, -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1ok7FPoaB/AxkkJIdEikhAhD6eQwM+8oNURjTyFLp7JUCDdapKxJsu9C
JUvJsZOl38iVCGMsMxnaZJvJiQaNrXHvfZ5z8z7P9/k+n7/g++4842N9DovB
YML+m/81n3qob3VVgor551Qfd01OPV8zJeIkf9BxzTmm3upVteK/DL0ZIR4+
m355X7BWUmqhCPVAg72irYSzCGHP2YAZ8Q1U/EmlYNHrdcrEcnkB2zAhqnMx
PsI/eUH3e5/E/A0qlip8hszUspAyOFZ3KFbYG0ttb8v28bIuNcjP/pdKojyW
unmhZ2pLlKHhiXNDdoVXBKhBqrIy8U26+DJT8W+6uwWoGL+VpKPkLPxGbaPI
RjqGyqRp6wcuLuHPSAUokkMw1EnBIW2bZitC44+CGromhprlvpWsKZVHSB8O
5bELVlFi3UaF+b0cQu3b2ts6c3wkwVvademWFpFRPyUaaMRHWoEyiY9p7sQf
xTtTm+7/REWHMVpZ57OJMhknlNYNr6DSXPL4aGs7Ue9OzNNj6isoi+4udsWE
S7QNpOolXFlGlwgCweUd0uB/fv4ls2UJLcXPVZme2w+SsSJVrtJL6D1ruZ3T
dBxKKncUs88uIrlBrRxM2p9gytLL8ateQLWCpxVi7l2BccyxpGWhBSSwt12v
aUMUhKm53Ak/wUM8ctDKklYKKFECgjcV/kBd3R+K/2p+CE0B0X6pvHkElxQn
zAKfgUNWjvsOk3kUF/+ssKKrEn7e3m7pnz+HukZUpg+71kOeR6Z+G2YO9d/g
8CTbqDB+IHWjzwsuatH1ipUhvoHo7dLcVzJcZNMSW76r7y1oCiaytvp9RwRm
fG6oGg1obIkWr+4ZlCrisN1dmg5+PbHPXmrMoIdB/QaZ53tBsKF6KIr7DcGb
P+d9cvtg14CFa2Lc36hzdsRi/6N+IE2zR7M1p9AxboS5nf8AuGwM9yxs56Dr
jp64u7IMuKms+K38PBup5Jw1fJ/GgGxCnV+j4CSqx8h6i/EY0GBvzXudN45S
vP15yoZMYF2euk4njKFGVWUw92CCkNjJicvcL0j041BB1i0m6BS0WEsVjqB1
3rtyC6OZ4EDCvaxw/IxumO3PReFMiGBlqttIfkI5Ou9xlX5McGWLaUxEv0e4
4+u9pm2YUKMwitkzy0JCkdT0B3uYIGbdwPRweoeeYGydm2cY4BaZWFrcOoD4
Rje32JUwoCSdozNn2IfC1avz5E4zYOHpoUpiRQ+6lj9QhsUy4M61AxekrDoR
vlzmoG/WACjljvkUEtoQT02Yvao+ALUtKQF4jVcIPZu4kFTaDw96YriPtOqR
BOdFhpVGP3BidGWGQ9JQr3OTwN5NfUCoCrNSiUuGDlPHdWyvXpAjiJdGq5WB
duHc38Gv6ZDqXaUT8VsLxNsoMB7e7oGsrTGnz2W8gfBaNW5XJw3yXrrdPSLf
DaY1akGZBd1gvT97KLGbDgaeo8NmKV1gFyXMDY3rhyHZgtuaDzqBNEQzIO9k
wos24nYW7S1o4NLDRCsH4XL3Nvyw4luQDnPtpBkPw3KSnPvyvQ7gM/bIJDM+
gIuFu8KX7R0QkLKgrVn1CSi5aqTf6e3ghZxsxH9+hlJnJUZ+STu4sKmBM0e+
wGV6sL5ARTvYblHJ7r0/CkETzr9bj7aD7wxHzHp2DIKzhp38rTrgXldZMN1+
Ah42f9FqXe6AoqdXvlk2TkJ8VEiN6ORb+HcU3qVHiQOqHUWOG+S74NNZbI9F
xFdYNj9I/ZHeDStGb0g09hRsMX5gZr+vB2R33C+nUL4Bp1Xy0W6gw4EVm13d
FdPAoRmnJPv2wt7qEuezd2aAdLj6kUl9H+Av4krcDn4H1SJCNG3rAJgrVyw6
j3+Hl/6RSiiAAadZemSnFC6c8dRLuFDPBO+E2uRTxrPg2frRSKH1Hdw0MRg5
MTsLZeY17DnPQYhbbcTZPpqDdRWntmVeHYS8Ggi2spoHMYokJbftHTx9fooZ
NjcPLO8V7Ko9E6rz/XVr0n5AvhK7xXfnAFCzYmMmDXjAOhXuYIfvhY7EwrFt
H3hw/GCA9F3UBf3RzXD89gK8x+1bFap9DR9vDWWE7F6EkVn2V9XNVOAEzs+W
ty3CAM1U2K2nCua8JSijXkuwKHzVctytCBLBgTImvwxHRmpfuC6lgY7kE8p4
5zKYCoXkkP8Ih+5P05SJ4BW4n+6hq1t0ES6WG1hMav8E3/x1NaUlliASGmHB
/vgTvkyHy27ehoMi6x4LTjwfptI7Mwwer4ejyvKWX41WQcZMxeEU/x1xbPac
5RR3FT7oZxiTzfKJgM3X3myOIWVcnX7iQ7pIjBGROVCSgyHhMM2RP901iUyp
SEPydwyJxVdPlhMYJSjL84xGDguQPmeX8qXlkgg+yh4mwakCpCdhfuv1Px4k
NOwdpMiyBUhiPqFKxn29eGG9Y3aVhlgSI5RmysWewdvgGxwp97EkdpriDBIf
NfQoN67umcCSDNQ3H8WRjhveVO0WtzESJPW90wi8o59v8FTyc7P9nCBpGr8j
NDJS7g/s2Po9bg5CpHHRLcnXmmb0Gv6im3jJbSAxyubStaQ+qzpdW8wiF4uQ
+AktcfXqUhJmz0ajXHw3kf6/t1hvywSbV2uu02nMJEuL//LumqTnuLo1s4JW
a5RFJH45wfAC9TenNZvwGe2ipWv+5z/45f8AYrHlgw==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk81Psex8duxhhblBw3SyISuql7snz/RKTNMmXfriUKEcexJCJL2Y59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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc7lQ8fgM85xuE4RmR95VsSGdmU+XweklXZ2WWEJFkZpSRJyMoORUOR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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1ok7FPoaB/AxkkJIdEikhAhD6eQwM+8oNURjTyFLp7JUCDdapKxJsu9C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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk81Psex8duxhhblBw3SyISuql7snz/RKTNMmXfriUKEcexJCJL2Y59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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc7lQ8fgM85xuE4RmR95VsSGdmU+XweklXZ2WWEJFkZpSRJyMoORUOR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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxF1ok7FPoaB/AxkkJIdEikhAhD6eQwM+8oNURjTyFLp7JUCDdapKxJsu9C
JUvJsZOl38iVCGMsMxnaZJvJiQaNrXHvfZ5z8z7P9/k+n7/g++4842N9DovB
YML+m/81n3qob3VVgor551Qfd01OPV8zJeIkf9BxzTmm3upVteK/DL0ZIR4+
m355X7BWUmqhCPVAg72irYSzCGHP2YAZ8Q1U/EmlYNHrdcrEcnkB2zAhqnMx
PsI/eUH3e5/E/A0qlip8hszUspAyOFZ3KFbYG0ttb8v28bIuNcjP/pdKojyW
unmhZ2pLlKHhiXNDdoVXBKhBqrIy8U26+DJT8W+6uwWoGL+VpKPkLPxGbaPI
RjqGyqRp6wcuLuHPSAUokkMw1EnBIW2bZitC44+CGromhprlvpWsKZVHSB8O
5bELVlFi3UaF+b0cQu3b2ts6c3wkwVvademWFpFRPyUaaMRHWoEyiY9p7sQf
xTtTm+7/REWHMVpZ57OJMhknlNYNr6DSXPL4aGs7Ue9OzNNj6isoi+4udsWE
S7QNpOolXFlGlwgCweUd0uB/fv4ls2UJLcXPVZme2w+SsSJVrtJL6D1ruZ3T
dBxKKncUs88uIrlBrRxM2p9gytLL8ateQLWCpxVi7l2BccyxpGWhBSSwt12v
aUMUhKm53Ak/wUM8ctDKklYKKFECgjcV/kBd3R+K/2p+CE0B0X6pvHkElxQn
zAKfgUNWjvsOk3kUF/+ssKKrEn7e3m7pnz+HukZUpg+71kOeR6Z+G2YO9d/g
8CTbqDB+IHWjzwsuatH1ipUhvoHo7dLcVzJcZNMSW76r7y1oCiaytvp9RwRm
fG6oGg1obIkWr+4ZlCrisN1dmg5+PbHPXmrMoIdB/QaZ53tBsKF6KIr7DcGb
P+d9cvtg14CFa2Lc36hzdsRi/6N+IE2zR7M1p9AxboS5nf8AuGwM9yxs56Dr
jp64u7IMuKms+K38PBup5Jw1fJ/GgGxCnV+j4CSqx8h6i/EY0GBvzXudN45S
vP15yoZMYF2euk4njKFGVWUw92CCkNjJicvcL0j041BB1i0m6BS0WEsVjqB1
3rtyC6OZ4EDCvaxw/IxumO3PReFMiGBlqttIfkI5Ou9xlX5McGWLaUxEv0e4
4+u9pm2YUKMwitkzy0JCkdT0B3uYIGbdwPRweoeeYGydm2cY4BaZWFrcOoD4
Rje32JUwoCSdozNn2IfC1avz5E4zYOHpoUpiRQ+6lj9QhsUy4M61AxekrDoR
vlzmoG/WACjljvkUEtoQT02Yvao+ALUtKQF4jVcIPZu4kFTaDw96YriPtOqR
BOdFhpVGP3BidGWGQ9JQr3OTwN5NfUCoCrNSiUuGDlPHdWyvXpAjiJdGq5WB
duHc38Gv6ZDqXaUT8VsLxNsoMB7e7oGsrTGnz2W8gfBaNW5XJw3yXrrdPSLf
DaY1akGZBd1gvT97KLGbDgaeo8NmKV1gFyXMDY3rhyHZgtuaDzqBNEQzIO9k
wos24nYW7S1o4NLDRCsH4XL3Nvyw4luQDnPtpBkPw3KSnPvyvQ7gM/bIJDM+
gIuFu8KX7R0QkLKgrVn1CSi5aqTf6e3ghZxsxH9+hlJnJUZ+STu4sKmBM0e+
wGV6sL5ARTvYblHJ7r0/CkETzr9bj7aD7wxHzHp2DIKzhp38rTrgXldZMN1+
Ah42f9FqXe6AoqdXvlk2TkJ8VEiN6ORb+HcU3qVHiQOqHUWOG+S74NNZbI9F
xFdYNj9I/ZHeDStGb0g09hRsMX5gZr+vB2R33C+nUL4Bp1Xy0W6gw4EVm13d
FdPAoRmnJPv2wt7qEuezd2aAdLj6kUl9H+Av4krcDn4H1SJCNG3rAJgrVyw6
j3+Hl/6RSiiAAadZemSnFC6c8dRLuFDPBO+E2uRTxrPg2frRSKH1Hdw0MRg5
MTsLZeY17DnPQYhbbcTZPpqDdRWntmVeHYS8Ggi2spoHMYokJbftHTx9fooZ
NjcPLO8V7Ko9E6rz/XVr0n5AvhK7xXfnAFCzYmMmDXjAOhXuYIfvhY7EwrFt
H3hw/GCA9F3UBf3RzXD89gK8x+1bFap9DR9vDWWE7F6EkVn2V9XNVOAEzs+W
ty3CAM1U2K2nCua8JSijXkuwKHzVctytCBLBgTImvwxHRmpfuC6lgY7kE8p4
5zKYCoXkkP8Ih+5P05SJ4BW4n+6hq1t0ES6WG1hMav8E3/x1NaUlliASGmHB
/vgTvkyHy27ehoMi6x4LTjwfptI7Mwwer4ejyvKWX41WQcZMxeEU/x1xbPac
5RR3FT7oZxiTzfKJgM3X3myOIWVcnX7iQ7pIjBGROVCSgyHhMM2RP901iUyp
SEPydwyJxVdPlhMYJSjL84xGDguQPmeX8qXlkgg+yh4mwakCpCdhfuv1Px4k
NOwdpMiyBUhiPqFKxn29eGG9Y3aVhlgSI5RmysWewdvgGxwp97EkdpriDBIf
NfQoN67umcCSDNQ3H8WRjhveVO0WtzESJPW90wi8o59v8FTyc7P9nCBpGr8j
NDJS7g/s2Po9bg5CpHHRLcnXmmb0Gv6im3jJbSAxyubStaQ+qzpdW8wiF4uQ
+AktcfXqUhJmz0ajXHw3kf6/t1hvywSbV2uu02nMJEuL//LumqTnuLo1s4JW
a5RFJH45wfAC9TenNZvwGe2ipWv+5z/45f8AYrHlgw==
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk81Psex8duxhhblBw3SyISuql7snz/RKTNMmXfriUKEcexJCJL2Y59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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc7lQ8fgM85xuE4RmR95VsSGdmU+XweklXZ2WWEJFkZpSRJyMoORUOR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          "]]}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      Frame->True,
      GridLines->{{-0.7881842610772917}, None},
      PlotRange->{{-4, 4}, {0, 0.7978175629309906}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {967.5, -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}]}, {}},
  ContentSelectable->True,
  ImageSize->{765., Automatic},
  PlotRangePadding->{6, 5}]], "Print",
 CellChangeTimes->{
  3.4607125941610928`*^9, 3.460713036837367*^9, {3.4607138313300943`*^9, 
   3.4607138550169573`*^9}, {3.460713899250411*^9, 3.460713912167659*^9}, {
   3.460716625964521*^9, 3.460716636089563*^9}, 3.460716672114872*^9, 
   3.4607167405833178`*^9, 3.46071814579046*^9, 3.460718328304133*^9, 
   3.460864847870467*^9, 3.4608899021408253`*^9, 3.4608900104100113`*^9, 
   3.4608909006918163`*^9, {3.460890938409459*^9, 3.460890953532361*^9}, 
   3.460891176700124*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"-", "1.404348602421444`"}]], "Output",
 CellChangeTimes->{
  3.4605486948259277`*^9, 3.4605487302383738`*^9, {3.460548942020789*^9, 
   3.4605491932066317`*^9}, {3.460549258834635*^9, 3.460549268506208*^9}, 
   3.46054930285188*^9, {3.460549416954996*^9, 3.460549454863381*^9}, {
   3.460549588146182*^9, 3.460549603690003*^9}, {3.460549634506207*^9, 
   3.460549668574503*^9}, 3.460607558766708*^9, {3.460607593319531*^9, 
   3.460607711503766*^9}, 3.4606078350805283`*^9, 3.460607900416376*^9, 
   3.4606079523498783`*^9, {3.4606082496246*^9, 3.4606083332594213`*^9}, 
   3.460608366349736*^9, {3.460608435462336*^9, 3.460608585202838*^9}, {
   3.460608758434499*^9, 3.4606087821685743`*^9}, {3.460608916822608*^9, 
   3.460608951788578*^9}, {3.46060903760701*^9, 3.460609090568944*^9}, 
   3.4606196889607763`*^9, {3.460619782657147*^9, 3.460619837176239*^9}, {
   3.460619894843831*^9, 3.46061991829001*^9}, 3.4606201603760843`*^9, 
   3.4606202144476957`*^9, 3.460620298069223*^9, 3.4606209222373657`*^9, 
   3.4606209756890182`*^9, {3.4606210251998863`*^9, 3.460621076850589*^9}, 
   3.4606211069084263`*^9, {3.460621193995138*^9, 3.4606212147854347`*^9}, 
   3.460621324509781*^9, {3.460621421398328*^9, 3.460621429364738*^9}, {
   3.460621501046996*^9, 3.460621506697133*^9}, {3.4606216150042057`*^9, 
   3.4606216392977943`*^9}, {3.460621695351623*^9, 3.460621733480344*^9}, 
   3.460621767776497*^9, {3.460621808613926*^9, 3.460621818947822*^9}, 
   3.4606218845579567`*^9, {3.460621966533445*^9, 3.460621990133649*^9}, 
   3.4606220631159353`*^9, 3.460622108278281*^9, 3.460622307422531*^9, {
   3.460622340194387*^9, 3.460622399876563*^9}, 3.460622677678253*^9, {
   3.4606227139032288`*^9, 3.460622724724502*^9}, {3.4606227631708183`*^9, 
   3.460622767762048*^9}, {3.460622936064171*^9, 3.4606229457541103`*^9}, 
   3.460622983907041*^9, {3.46062304456255*^9, 3.4606230504849653`*^9}, 
   3.460623100158823*^9, {3.460623130786044*^9, 3.460623160624483*^9}, {
   3.460623195112233*^9, 3.4606232589115973`*^9}, {3.460687841068869*^9, 
   3.460687890651434*^9}, 3.460687926945773*^9, {3.460690060174603*^9, 
   3.460690084761283*^9}, 3.46069027837682*^9, 3.46069166838479*^9, {
   3.460691707361595*^9, 3.460691723114663*^9}, 3.460693622036282*^9, 
   3.460693812591682*^9, 3.460694883680513*^9, 3.460696638080707*^9, 
   3.460697706266652*^9, 3.460697869993202*^9, 3.4606989934428387`*^9, 
   3.460699029777727*^9, 3.4607002745050917`*^9, {3.460700324810555*^9, 
   3.460700334725389*^9}, 3.460700620207369*^9, 3.4607014596003847`*^9, 
   3.460701680361329*^9, 3.460702875928625*^9, 3.460704476325636*^9, {
   3.460712578457333*^9, 3.460712594414483*^9}, 3.460713037123517*^9, {
   3.460713831567202*^9, 3.460713855301291*^9}, {3.460713899587134*^9, 
   3.4607139124348*^9}, {3.4607166262362223`*^9, 3.460716636335408*^9}, 
   3.460716672423882*^9, 3.460716740872676*^9, 3.460718146097331*^9, 
   3.460718328616887*^9, 3.46086484816509*^9, 3.460889902387048*^9, 
   3.460890010674266*^9, 3.460890900999786*^9, {3.460890938739053*^9, 
   3.460890953819108*^9}, 3.460891176785737*^9}],

Cell[BoxData[
 RowBox[{"-", "2.146124098212869`"}]], "Output",
 CellChangeTimes->{
  3.4605486948259277`*^9, 3.4605487302383738`*^9, {3.460548942020789*^9, 
   3.4605491932066317`*^9}, {3.460549258834635*^9, 3.460549268506208*^9}, 
   3.46054930285188*^9, {3.460549416954996*^9, 3.460549454863381*^9}, {
   3.460549588146182*^9, 3.460549603690003*^9}, {3.460549634506207*^9, 
   3.460549668574503*^9}, 3.460607558766708*^9, {3.460607593319531*^9, 
   3.460607711503766*^9}, 3.4606078350805283`*^9, 3.460607900416376*^9, 
   3.4606079523498783`*^9, {3.4606082496246*^9, 3.4606083332594213`*^9}, 
   3.460608366349736*^9, {3.460608435462336*^9, 3.460608585202838*^9}, {
   3.460608758434499*^9, 3.4606087821685743`*^9}, {3.460608916822608*^9, 
   3.460608951788578*^9}, {3.46060903760701*^9, 3.460609090568944*^9}, 
   3.4606196889607763`*^9, {3.460619782657147*^9, 3.460619837176239*^9}, {
   3.460619894843831*^9, 3.46061991829001*^9}, 3.4606201603760843`*^9, 
   3.4606202144476957`*^9, 3.460620298069223*^9, 3.4606209222373657`*^9, 
   3.4606209756890182`*^9, {3.4606210251998863`*^9, 3.460621076850589*^9}, 
   3.4606211069084263`*^9, {3.460621193995138*^9, 3.4606212147854347`*^9}, 
   3.460621324509781*^9, {3.460621421398328*^9, 3.460621429364738*^9}, {
   3.460621501046996*^9, 3.460621506697133*^9}, {3.4606216150042057`*^9, 
   3.4606216392977943`*^9}, {3.460621695351623*^9, 3.460621733480344*^9}, 
   3.460621767776497*^9, {3.460621808613926*^9, 3.460621818947822*^9}, 
   3.4606218845579567`*^9, {3.460621966533445*^9, 3.460621990133649*^9}, 
   3.4606220631159353`*^9, 3.460622108278281*^9, 3.460622307422531*^9, {
   3.460622340194387*^9, 3.460622399876563*^9}, 3.460622677678253*^9, {
   3.4606227139032288`*^9, 3.460622724724502*^9}, {3.4606227631708183`*^9, 
   3.460622767762048*^9}, {3.460622936064171*^9, 3.4606229457541103`*^9}, 
   3.460622983907041*^9, {3.46062304456255*^9, 3.4606230504849653`*^9}, 
   3.460623100158823*^9, {3.460623130786044*^9, 3.460623160624483*^9}, {
   3.460623195112233*^9, 3.4606232589115973`*^9}, {3.460687841068869*^9, 
   3.460687890651434*^9}, 3.460687926945773*^9, {3.460690060174603*^9, 
   3.460690084761283*^9}, 3.46069027837682*^9, 3.46069166838479*^9, {
   3.460691707361595*^9, 3.460691723114663*^9}, 3.460693622036282*^9, 
   3.460693812591682*^9, 3.460694883680513*^9, 3.460696638080707*^9, 
   3.460697706266652*^9, 3.460697869993202*^9, 3.4606989934428387`*^9, 
   3.460699029777727*^9, 3.4607002745050917`*^9, {3.460700324810555*^9, 
   3.460700334725389*^9}, 3.460700620207369*^9, 3.4607014596003847`*^9, 
   3.460701680361329*^9, 3.460702875928625*^9, 3.460704476325636*^9, {
   3.460712578457333*^9, 3.460712594414483*^9}, 3.460713037123517*^9, {
   3.460713831567202*^9, 3.460713855301291*^9}, {3.460713899587134*^9, 
   3.4607139124348*^9}, {3.4607166262362223`*^9, 3.460716636335408*^9}, 
   3.460716672423882*^9, 3.460716740872676*^9, 3.460718146097331*^9, 
   3.460718328616887*^9, 3.46086484816509*^9, 3.460889902387048*^9, 
   3.460890010674266*^9, 3.460890900999786*^9, {3.460890938739053*^9, 
   3.460890953819108*^9}, 3.4608911768537207`*^9}],

Cell[BoxData[
 RowBox[{"-", "1.4208207308371343`"}]], "Output",
 CellChangeTimes->{
  3.4605486948259277`*^9, 3.4605487302383738`*^9, {3.460548942020789*^9, 
   3.4605491932066317`*^9}, {3.460549258834635*^9, 3.460549268506208*^9}, 
   3.46054930285188*^9, {3.460549416954996*^9, 3.460549454863381*^9}, {
   3.460549588146182*^9, 3.460549603690003*^9}, {3.460549634506207*^9, 
   3.460549668574503*^9}, 3.460607558766708*^9, {3.460607593319531*^9, 
   3.460607711503766*^9}, 3.4606078350805283`*^9, 3.460607900416376*^9, 
   3.4606079523498783`*^9, {3.4606082496246*^9, 3.4606083332594213`*^9}, 
   3.460608366349736*^9, {3.460608435462336*^9, 3.460608585202838*^9}, {
   3.460608758434499*^9, 3.4606087821685743`*^9}, {3.460608916822608*^9, 
   3.460608951788578*^9}, {3.46060903760701*^9, 3.460609090568944*^9}, 
   3.4606196889607763`*^9, {3.460619782657147*^9, 3.460619837176239*^9}, {
   3.460619894843831*^9, 3.46061991829001*^9}, 3.4606201603760843`*^9, 
   3.4606202144476957`*^9, 3.460620298069223*^9, 3.4606209222373657`*^9, 
   3.4606209756890182`*^9, {3.4606210251998863`*^9, 3.460621076850589*^9}, 
   3.4606211069084263`*^9, {3.460621193995138*^9, 3.4606212147854347`*^9}, 
   3.460621324509781*^9, {3.460621421398328*^9, 3.460621429364738*^9}, {
   3.460621501046996*^9, 3.460621506697133*^9}, {3.4606216150042057`*^9, 
   3.4606216392977943`*^9}, {3.460621695351623*^9, 3.460621733480344*^9}, 
   3.460621767776497*^9, {3.460621808613926*^9, 3.460621818947822*^9}, 
   3.4606218845579567`*^9, {3.460621966533445*^9, 3.460621990133649*^9}, 
   3.4606220631159353`*^9, 3.460622108278281*^9, 3.460622307422531*^9, {
   3.460622340194387*^9, 3.460622399876563*^9}, 3.460622677678253*^9, {
   3.4606227139032288`*^9, 3.460622724724502*^9}, {3.4606227631708183`*^9, 
   3.460622767762048*^9}, {3.460622936064171*^9, 3.4606229457541103`*^9}, 
   3.460622983907041*^9, {3.46062304456255*^9, 3.4606230504849653`*^9}, 
   3.460623100158823*^9, {3.460623130786044*^9, 3.460623160624483*^9}, {
   3.460623195112233*^9, 3.4606232589115973`*^9}, {3.460687841068869*^9, 
   3.460687890651434*^9}, 3.460687926945773*^9, {3.460690060174603*^9, 
   3.460690084761283*^9}, 3.46069027837682*^9, 3.46069166838479*^9, {
   3.460691707361595*^9, 3.460691723114663*^9}, 3.460693622036282*^9, 
   3.460693812591682*^9, 3.460694883680513*^9, 3.460696638080707*^9, 
   3.460697706266652*^9, 3.460697869993202*^9, 3.4606989934428387`*^9, 
   3.460699029777727*^9, 3.4607002745050917`*^9, {3.460700324810555*^9, 
   3.460700334725389*^9}, 3.460700620207369*^9, 3.4607014596003847`*^9, 
   3.460701680361329*^9, 3.460702875928625*^9, 3.460704476325636*^9, {
   3.460712578457333*^9, 3.460712594414483*^9}, 3.460713037123517*^9, {
   3.460713831567202*^9, 3.460713855301291*^9}, {3.460713899587134*^9, 
   3.4607139124348*^9}, {3.4607166262362223`*^9, 3.460716636335408*^9}, 
   3.460716672423882*^9, 3.460716740872676*^9, 3.460718146097331*^9, 
   3.460718328616887*^9, 3.46086484816509*^9, 3.460889902387048*^9, 
   3.460890010674266*^9, 3.460890900999786*^9, {3.460890938739053*^9, 
   3.460890953819108*^9}, 3.460891176900565*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"scaling", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pp", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m", "=", "100"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Y1", "=", 
   RowBox[{"{", 
    RowBox[{"{", "2", "}"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"IndividualLikNonlin", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Y1", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"IdioNonlin", ",", 
     RowBox[{"{", "}"}], ",", "m", ",", 
     RowBox[{"eps", "=", 
      RowBox[{"10.", "^", 
       RowBox[{"-", "16"}]}]}], ",", 
     RowBox[{"ksigma", "=", "Infinity"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0", ",", 
     RowBox[{"onlyNorKorr", "=", "0"}], ",", "\"\<NorKorr\>\"", ",", "0"}], 
    "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"IndividualLikNonlin", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Y1", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"IdioNonlin", ",", 
     RowBox[{"{", "}"}], ",", "m", ",", 
     RowBox[{"eps", "=", 
      RowBox[{"10.", "^", 
       RowBox[{"-", "16"}]}]}], ",", 
     RowBox[{"ksigma", "=", "Infinity"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0", ",", 
     RowBox[{"onlyNorKorr", "=", "0"}], ",", "\"\<StochLin\>\"", ",", "0"}], 
    "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"IndividualLikNonlin", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Y1", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"IdioNonlin", ",", 
     RowBox[{"{", "}"}], ",", "m", ",", 
     RowBox[{"eps", "=", 
      RowBox[{"10.", "^", 
       RowBox[{"-", "16"}]}]}], ",", 
     RowBox[{"ksigma", "=", "Infinity"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0", ",", 
     RowBox[{"onlyNorKorr", "=", "0"}], ",", "\"\<EKF\>\"", ",", "0"}], 
    "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.460264864897327*^9, 3.460264932378791*^9}, {
   3.460265489300803*^9, 3.460265492492799*^9}, {3.46027038606568*^9, 
   3.460270391802556*^9}, {3.4602704971596107`*^9, 3.4602705817118692`*^9}, {
   3.46027367414145*^9, 3.460273674236417*^9}, {3.460279775378045*^9, 
   3.4602797754444103`*^9}, {3.4602799530257587`*^9, 
   3.4602799533811693`*^9}, {3.460280067013379*^9, 3.460280067130088*^9}, {
   3.4602801040742397`*^9, 3.460280104129944*^9}, {3.4602801453821163`*^9, 
   3.4602801673531218`*^9}, {3.46028174693688*^9, 3.460281763776168*^9}, {
   3.4602818356559362`*^9, 3.460281835739462*^9}, {3.460281898670804*^9, 
   3.460281898732609*^9}, {3.460282025318959*^9, 3.460282025741701*^9}, {
   3.460282062175247*^9, 3.460282071535883*^9}, {3.460283778391947*^9, 
   3.4602837888805027`*^9}, {3.4602838305963707`*^9, 3.460283854615387*^9}, {
   3.46028477341341*^9, 3.460284779157151*^9}, {3.460285035206752*^9, 
   3.460285046973556*^9}, {3.46028555906642*^9, 3.460285574425418*^9}, {
   3.4602857519094887`*^9, 3.4602857519715776`*^9}, {3.460285881590439*^9, 
   3.4602858816380377`*^9}, {3.460286117999454*^9, 3.460286123654068*^9}, {
   3.4602863340289307`*^9, 3.4602863377475977`*^9}, {3.4603641927287188`*^9, 
   3.460364197580667*^9}, {3.460365058304535*^9, 3.4603650587979116`*^9}, {
   3.460365091217347*^9, 3.460365126318194*^9}, {3.4603652464521227`*^9, 
   3.460365260029804*^9}, {3.460365412299954*^9, 3.460365434375272*^9}, {
   3.460365485584791*^9, 3.460365520950554*^9}, {3.460366663535665*^9, 
   3.460366678997499*^9}, {3.4603667867732773`*^9, 3.4603667868283587`*^9}, {
   3.460367092714067*^9, 3.460367098883337*^9}, {3.460369235357655*^9, 
   3.460369263924768*^9}, {3.460369362646221*^9, 3.46036936313859*^9}, {
   3.46036946785526*^9, 3.4603694691077127`*^9}, {3.46037339069245*^9, 
   3.460373390747698*^9}, {3.460373605599341*^9, 3.4603736056503153`*^9}, {
   3.460377091108459*^9, 3.460377126962656*^9}, {3.460377288435691*^9, 
   3.460377301095058*^9}, {3.4603774697122087`*^9, 3.460377479788327*^9}, {
   3.460377585320611*^9, 3.460377603716568*^9}, {3.4603776957101793`*^9, 
   3.460377736561165*^9}, {3.460377923292104*^9, 3.4603779233524303`*^9}, {
   3.460378105932313*^9, 3.46037817981962*^9}, {3.460427531315346*^9, 
   3.460427537420005*^9}, {3.460427638978484*^9, 3.4604276390230217`*^9}, {
   3.4604277414332314`*^9, 3.460427769573126*^9}, {3.4604279604982853`*^9, 
   3.460427960554902*^9}, {3.460430680071252*^9, 3.460430680172152*^9}, {
   3.460430712203142*^9, 3.460430712557424*^9}, {3.460430775931464*^9, 
   3.460430776020101*^9}, {3.460430814349124*^9, 3.460430814950081*^9}, {
   3.46043100067663*^9, 3.460431000775926*^9}, {3.460431035518139*^9, 
   3.460431043615539*^9}, {3.460431139283386*^9, 3.460431139330926*^9}, {
   3.4604311987514153`*^9, 3.460431233744923*^9}, {3.460431314274002*^9, 
   3.460431314321568*^9}, {3.4604316727142878`*^9, 3.4604316728008432`*^9}, {
   3.460431886035831*^9, 3.46043189177104*^9}, {3.460432099991972*^9, 
   3.460432100073539*^9}, {3.460432236204804*^9, 3.4604322362468243`*^9}, {
   3.4604323376555843`*^9, 3.460432357162323*^9}, {3.460432403219545*^9, 
   3.460432403269651*^9}, {3.460432564446265*^9, 3.4604325911495867`*^9}, {
   3.460432813689516*^9, 3.460432813733564*^9}, {3.460432944239506*^9, 
   3.460432989199974*^9}, {3.460433097024789*^9, 3.460433097139295*^9}, {
   3.460433291653358*^9, 3.46043329173923*^9}, {3.460433672964451*^9, 
   3.460433673010107*^9}, {3.460433845665332*^9, 3.4604338457416363`*^9}, {
   3.4604344009903316`*^9, 3.460434401033557*^9}, {3.4604346235115023`*^9, 
   3.460434638473834*^9}, {3.460434675871023*^9, 3.460434675925946*^9}, {
   3.4604350413113747`*^9, 3.4604350414069347`*^9}, {3.460436666989565*^9, 
   3.460436677468376*^9}, {3.460437023691847*^9, 3.460437023772811*^9}, {
   3.460437179838045*^9, 3.460437214787621*^9}, {3.4604373750456057`*^9, 
   3.460437375101828*^9}, {3.460437455923118*^9, 3.4604374559862347`*^9}, {
   3.460437643282413*^9, 3.4604376433404827`*^9}, {3.460439284564681*^9, 
   3.46043929340877*^9}, {3.460439393566842*^9, 3.460439393962884*^9}, {
   3.46044000098571*^9, 3.460440001044331*^9}, {3.460443930270521*^9, 
   3.460443930334333*^9}, {3.460443966799687*^9, 3.46044399790462*^9}, {
   3.460444060284606*^9, 3.460444061730588*^9}, {3.460444101336812*^9, 
   3.46044410138903*^9}, {3.460444186536171*^9, 3.460444194286351*^9}, {
   3.460444233408099*^9, 3.460444248920389*^9}, {3.460444338058318*^9, 
   3.460444355662019*^9}, {3.460444400012597*^9, 3.460444431012135*^9}, {
   3.460444591036777*^9, 3.4604446631572647`*^9}, {3.46044479971354*^9, 
   3.460444799768903*^9}, {3.460444831583193*^9, 3.460444859781989*^9}, {
   3.46044502143334*^9, 3.460445021504759*^9}, {3.460459950502769*^9, 
   3.460459971711813*^9}, {3.460460068419449*^9, 3.460460088588605*^9}, {
   3.460460154598343*^9, 3.46046015516997*^9}, {3.460460281436612*^9, 
   3.460460281521656*^9}, {3.4604604120265713`*^9, 3.460460412125514*^9}, {
   3.4604607607833633`*^9, 3.4604607621971283`*^9}, {3.460460826677142*^9, 
   3.460460827186878*^9}, {3.4604608962826014`*^9, 3.4604608963501987`*^9}, {
   3.460460962965583*^9, 3.460460963358262*^9}, {3.46046100555375*^9, 
   3.4604610220017967`*^9}, {3.46046105589403*^9, 3.460461056004932*^9}, {
   3.460461154113535*^9, 3.460461154227416*^9}, {3.460461800671767*^9, 
   3.4604618154025*^9}, {3.46046184541817*^9, 3.46046186011173*^9}, {
   3.460461896620476*^9, 3.460461896672694*^9}, {3.460461952952413*^9, 
   3.4604619533933907`*^9}, {3.460462913572587*^9, 3.460462920740217*^9}, {
   3.460548175219633*^9, 3.460548179294363*^9}, {3.460548260239588*^9, 
   3.460548260297719*^9}, {3.460548333262265*^9, 3.460548333779482*^9}, {
   3.460548675566861*^9, 3.460548693804049*^9}, {3.460548972449188*^9, 
   3.4605491929429903`*^9}, {3.460549257251377*^9, 3.460549267901092*^9}, {
   3.4605496024993763`*^9, 3.4605496337333307`*^9}, {3.460549667762332*^9, 
   3.46054966825324*^9}, {3.460607544492757*^9, 3.460607557468165*^9}, {
   3.460607591423718*^9, 3.460607615734179*^9}, {3.4606076546131697`*^9, 
   3.460607711208377*^9}, {3.460607950300333*^9, 3.460607950788868*^9}, {
   3.460608254691515*^9, 3.460608332544549*^9}, {3.460608365633368*^9, 
   3.4606083656943207`*^9}, {3.460608434510606*^9, 3.460608528562172*^9}, {
   3.460608559009796*^9, 3.460608584467407*^9}, {3.460608755712895*^9, 
   3.4606087818086443`*^9}, {3.460608915820417*^9, 3.46060895109648*^9}, {
   3.4606090353514013`*^9, 3.460609089338924*^9}, {3.460619799153166*^9, 
   3.4606198362306223`*^9}, 3.460619905423987*^9, {3.460621024814104*^9, 
   3.460621075759169*^9}, {3.460621192179472*^9, 3.4606212134045153`*^9}, {
   3.4606214203824053`*^9, 3.460621428920328*^9}, {3.4606215045280933`*^9, 
   3.460621505423924*^9}, {3.460621613387906*^9, 3.460621638578682*^9}, {
   3.460621694074709*^9, 3.460621703411603*^9}, {3.4606217660430403`*^9, 
   3.460621767329904*^9}, {3.460621806996888*^9, 3.4606218076980343`*^9}, {
   3.460621883288566*^9, 3.46062188333815*^9}, {3.460621970939987*^9, 
   3.4606219893319883`*^9}, {3.460622107014687*^9, 3.460622107100986*^9}, {
   3.460622297972288*^9, 3.460622306665023*^9}, {3.460622338760532*^9, 
   3.460622398767516*^9}, {3.460622676496147*^9, 3.4606226765399942`*^9}, {
   3.4606227120282917`*^9, 3.460622766881015*^9}, {3.4606229263578787`*^9, 
   3.460622944163636*^9}, {3.4606229791390038`*^9, 3.460622982600178*^9}, {
   3.4606230423052397`*^9, 3.460623049675028*^9}, {3.4606231523155127`*^9, 
   3.460623159744812*^9}, {3.460623194195408*^9, 3.460623258120954*^9}, {
   3.460687849143656*^9, 3.460687889401013*^9}, {3.460690081391994*^9, 
   3.460690099337471*^9}, {3.460690130038103*^9, 3.46069013008521*^9}, 
   3.4606902754485703`*^9, {3.4606937256675873`*^9, 3.460693732963479*^9}, {
   3.46069380256997*^9, 3.460693821921266*^9}, {3.460694110007152*^9, 
   3.460694111753396*^9}, {3.46069438482207*^9, 3.460694412630849*^9}, {
   3.4606948097984943`*^9, 3.460694811995069*^9}, {3.4606949315352297`*^9, 
   3.460694942467441*^9}, {3.46069553282626*^9, 3.460695537762641*^9}, {
   3.4606959645065536`*^9, 3.4606960446581793`*^9}, {3.460696241341283*^9, 
   3.460696252439539*^9}, {3.4606966463545427`*^9, 3.460696646787632*^9}, 
   3.460698002134129*^9, {3.460699006868629*^9, 3.460699016312397*^9}, {
   3.4606992398575487`*^9, 3.46069924875381*^9}, {3.460699414491041*^9, 
   3.460699445356464*^9}, {3.460699542245335*^9, 3.460699574543728*^9}, {
   3.4606997815193663`*^9, 3.460699790038615*^9}, {3.460700625492282*^9, 
   3.460700639053712*^9}, {3.460701666209906*^9, 3.4607016674378977`*^9}, {
   3.4607044130681334`*^9, 3.460704413273118*^9}, {3.46070445138295*^9, 
   3.4607044514347343`*^9}, {3.460704492762239*^9, 3.460704516605468*^9}, {
   3.4607046279131327`*^9, 3.460704646387837*^9}, {3.460704755792667*^9, 
   3.4607047772650547`*^9}, {3.4607049514390507`*^9, 3.460704951499386*^9}, {
   3.460705149340721*^9, 3.460705174028206*^9}, {3.460705209320664*^9, 
   3.460705214762663*^9}, {3.4607052725452003`*^9, 3.460705285058607*^9}, {
   3.4607053271048403`*^9, 3.46070533838897*^9}, {3.460712609690332*^9, 
   3.460712613264339*^9}, {3.460713281802175*^9, 3.460713293515684*^9}, {
   3.460713956024549*^9, 3.4607139942787857`*^9}, {3.460714187777926*^9, 
   3.460714188152686*^9}, 3.460716611301156*^9, 3.4607167259037523`*^9, {
   3.4608650674253807`*^9, 3.460865088349908*^9}, {3.460865124990815*^9, 
   3.4608651294206467`*^9}, {3.460865194415337*^9, 3.4608652054777203`*^9}, {
   3.460865298260353*^9, 3.460865342651475*^9}, {3.4608653827759123`*^9, 
   3.460865442420289*^9}, {3.4608655984805727`*^9, 3.460865598657593*^9}, {
   3.4608656299199553`*^9, 3.4608656306521683`*^9}, {3.4608656759784813`*^9, 
   3.460865762208869*^9}, {3.460865894459096*^9, 3.460865895021585*^9}, {
   3.460865928120473*^9, 3.46086592860039*^9}, {3.4608659870899563`*^9, 
   3.460865999817178*^9}, {3.4608660346281967`*^9, 3.460866038189959*^9}, {
   3.460866071630413*^9, 3.4608660772735577`*^9}, {3.460866170540369*^9, 
   3.460866171848431*^9}, {3.4608662044093227`*^9, 3.460866227143955*^9}, {
   3.460866590514419*^9, 3.460866603123413*^9}, {3.4608840970493317`*^9, 
   3.460884162606284*^9}, {3.460884255293991*^9, 3.4608842558022203`*^9}, {
   3.460884853534459*^9, 3.4608848951349287`*^9}, {3.4608900321748543`*^9, 
   3.46089003666643*^9}, {3.460890114523884*^9, 3.460890189585753*^9}, {
   3.4608902652075033`*^9, 3.460890287409711*^9}, {3.460890424487276*^9, 
   3.460890449506103*^9}, {3.460890483227208*^9, 3.460890502598156*^9}, {
   3.460890550250969*^9, 3.460890587325244*^9}, {3.460890957047615*^9, 
   3.4608909683402433`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0, 0, 1], PointSize[0.03], Thickness[0.03], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQzeaS5bp/q/QBBigQmFyfaThPCs5/WdM79XqHJJwv
HK9s2VkqAedHbnx7RSFFHM6fk6I2uzpEDM4vnL1GttJNFM6Py0pk/20pAuev
jHxw74meMJw/OZTjorSqEJw/z1m4qU1GEM6XKDR5wiMqAOd72pxQNZDlg/OT
itxSVIR4DtzenjE74Ykig9MH+0VnOLgObBa8+SzWeoOk/eXy+QyMHAeOSDye
rv3UTWsDJ3/vzF+sB6p/bp50+8IkE1OVdQ8LvzIfCCq+0/Rj+zSr0AJnw9SP
jAfOevj/WTvlsu0a2xn8C+78378/I/1P0u9o+1jNxF75G7/3xwpvPd279Z39
j+QpHKxXv+9n+djQpu3B5mB1OuMW7+XP+/eF3D4mNfujfczNgDkfFr/fv3Pa
1Jhtr6/atwQrX2Jb/Hz/mv3THRsmH7Nfkf3m/C7X+/snB9688/PZUfuKD7MN
L3Sf2+9Ykntl1vkL9gdSOgrDfdvt36Vtv6+ddt/+qt9zf7s9F+xXzmk9ENH+
xr4lpcTBK+GB/QyGKfdvXPhq/2/q6TkWKS/szQ49VrvD9dM+aYLRZTPTD/Zt
kT+fN3h+tN+wJDN0u+UX++33Ty7Vz7tgv9w9YsVD+x/2slvuHV2RUWlful6X
87f7H/vSGyltWyt22pnt/a6vqsngEDRpvo7GbRPbY20JTj36TA41H2IvijLG
Wp1YrOEaYc7ikHtwvfBnxmjTp6r67Bsc2ByuBt5N0hdj0D37fsOJ3d4cDpe3
eW7elL5YftvUwOylEVwOuZ/vm9XfFuTeb8W/fEY6jwMsPjfE/XQ5XMEH52ds
Dtmg5SYA54sfuXrDIVAQzjf4qvB+X6wQnB+3b1bOwWxhOF+aO2lZWrUInH96
x3Su8z2icP76a4zpsgvE4Pwbbz5blW8Vh/NPzL0nxnpWAs4HABv5NsA=
           
           "]]}}, {}}, {{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.01], Thickness[0.01], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQzeaS5bp/q/QB1WjHOwsXbbYRmFyfaThP6sBU9+cz
fPU+27ys6Z16vUPygJdvwcSzYQa2wvHKlp2lEgca2IqMTsdn2EZufHtFIUX8
QJGGiBTn1/m2c1LUZleHiB1wTtXaMK/ykm3h7DWylW6iB07ucb494SmTXVxW
IvtvS5EDVfz7PJJVDe1WRj6490RP+ECCdPvktDXRdpNDOS5KqwoduKcScGjO
i2a7ec7CTW0yggem8Pmd9pi+0k6i0OQJj6jAgdwjG2a+KTxr52lzQtVAlu/A
k8YMVevEd3ZJRW4pKkI8B7Z+WrbhjBqPvdMH+0VnOLgOpL61Kl1Tpm5vf7l8
PgMjx4EyOfPQe3Mc7Tdw8vfO/MV6gNt+okrP9XB7U5V1Dwu/Mh+QMwrbtVwx
1z60wNkw9SPjATmdfVaWIg32a2xn8C+483//6rds2xp4JtjHaib2yt/4vV/2
vvy+T3/m2P9InsLBevX7/t6kuWobNi+3tzqdcYv38uf9TSy7Wq/2brSPuRkw
58Pi9/sl3px339C/3b4lWPkS2+Ln+yf0vdeUWbXHfkX2m/O7XO/vV61mvVs3
d799xYfZhhe6z+2XgvIPpHQUhvu228PUX/V77m+354K9CMy8lBIHr4QH9pVQ
+/5NPT3HIuWFfRfUPUkTjC6bmX6wl4K6d8OSzNDtll/sl0P9s9w9YsVD+x/2
ilD/lq7X5fzt/sceFh5me7/rq2oyOLBAw+tYW4JTjz6TQzU0PE8s1nCNMGdx
SIeG91NVffYNDmwOm6Hxcfb9hhO7vTkcHkPja9vUwOylEVwO2dD43G/Fv3xG
Oo/DJGh8b4j76XK4gs/hMTQ9ZGwO2aDlJuCQLQVJL+JHrt5wCBR0kOKDpCeD
rwrv98UKORyApbd9s3IOZgs7uELTozR30rK0ahGHEmh6Pb1jOtf5HlGHOmh6
Xn+NMV12gZiDDzS933jz2ap8q7jDHGh+ODH3nhjrWQmH91GQ/AIAHfp8Zg==

           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{2}, {1}},
      PlotRange->{{-3, 3}, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {193.5, -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.03], Thickness[0.03], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQzeaS5bp/q/QB1WjHOwsXbbYRmFyfaThP6sBU9+cz
fPU+27ys6Z16vUPygJdvwcSzYQa2wvHKlp2lEgca2IqMTsdn2EZufHtFIUX8
QJGGiBTn1/m2c1LUZleHiB1wTtXaMK/ykm3h7DWylW6iB07ucb494SmTXVxW
IvtvS5EDVfz7PJJVDe1WRj6490RP+ECCdPvktDXRdpNDOS5KqwoduKcScGjO
i2a7ec7CTW0yggem8Pmd9pi+0k6i0OQJj6jAgdwjG2a+KTxr52lzQtVAlu/A
k8YMVevEd3ZJRW4pKkI8B7Z+WrbhjBqPvdMH+0VnOLgOpL61Kl1Tpm5vf7l8
PgMjx4EyOfPQe3Mc7Tdw8vfO/MV6gNt+okrP9XB7U5V1Dwu/Mh+QMwrbtVwx
1z60wNkw9SPjATmdfVaWIg32a2xn8C+483//6rds2xp4JtjHaib2yt/4vV/2
vvy+T3/m2P9InsLBevX7/t6kuWobNi+3tzqdcYv38uf9TSy7Wq/2brSPuRkw
58Pi9/sl3px339C/3b4lWPkS2+Ln+yf0vdeUWbXHfkX2m/O7XO/vV61mvVs3
d799xYfZhhe6z+2XgvIPpHQUhvu228PUX/V77m+354K9CMy8lBIHr4QH9pVQ
+/5NPT3HIuWFfRfUPUkTjC6bmX6wl4K6d8OSzNDtll/sl0P9s9w9YsVD+x/2
ilD/lq7X5fzt/sceFh5me7/rq2oyOLBAw+tYW4JTjz6TQzU0PE8s1nCNMGdx
SIeG91NVffYNDmwOm6Hxcfb9hhO7vTkcHkPja9vUwOylEVwO2dD43G/Fv3xG
Oo/DJGh8b4j76XK4gs/hMTQ9ZGwO2aDlJuCQLQVJL+JHrt5wCBR0kOKDpCeD
rwrv98UKORyApbd9s3IOZgs7uELTozR30rK0ahGHEmh6Pb1jOtf5HlGHOmh6
Xn+NMV12gZiDDzS933jz2ap8q7jDHGh+ODH3nhjrWQmH91GQ/AIAHfp8Zg==

           "]]}}, {}}, {{}, 
        {RGBColor[1, 0, 0], PointSize[0.02], Thickness[0.02], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQzeaS5bp/q/QBBigQmFyfaThPCs5/WdM79XqHJJwv
HK9s2VkqAedHbnx7RSFFHM6fk6I2uzpEDM4vnL1GttJNFM6Py0pk/20pAuev
jHxw74meMJw/OZTjorSqEJw/z1m4qU1GEM6XKDR5wiMqAOd72pxQNZDlg/OT
itxSVIR44HynD/aLznBwHfiwKvPJ/9AkSfvL5fMZGDkOeAukFv+exai1gZO/
d+Yv1gPNYpsc1H4GmZiqrHtY+JX5gNgplXf6n2KsQgucDVM/Mh6ozm+TUkqa
Z7vGdgb/gjv/929are8wtVbTPlYzsVf+xu/9GTcNK1+s2W//I3kKB+vV7/u/
iSte6ZO8aW91OuMW7+XP+5Xibb9dfXLEPuZmwJwPi9/vDzf8816icJV9S7Dy
JbbFz/cnub7YxLh1lv2K7Dfnd7ne3198f7L/1pYZ9hUfZhte6D63/7vqtyBW
/YX2B1I6CsN92+2LDBYwSbqvsb/q99zfbs8F+zX6srvdrm+1b0kpcfBKeGD/
62H/e6nU3fb/pp6eY5Hywv7MAr4XZx/ssE+aYHTZzPSDfYb5I00N01X2G5Zk
hm63/GIvLH2QdWtwk/1y94gVD+1/2DvKJbKmSanYl67X5fzt/sf+aWTU/O29
0XZme7/rq2oyOPz8p3JOdcdZm2NtCU49+kwO9x9zTr1m/sryxGIN1whzFoeG
YnPj1RfvmjxV1Wff4MDmsOqct4z1gxKds+83nNjtzeEgG9K6fGc5j/y2qYHZ
SyO4HKpqrogdLc/h2m/Fv3xGOo8DLP42xP10OVzBB+dnbA7ZoOUmAOeLH7l6
wyFQEM43+Krwfl+sEJwft29WzsFsYThfmjtpWVq1CJx/esd0rvM9onD++muM
6bILxOD8G28+W5VvFYfzT8y9J8Z6VgLOBwAD4yPI
           "]]}}, {}}, {{}, 
        {RGBColor[1, 1, 0], PointSize[0.015], Thickness[0.015], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJwBUQOu/CFib1JlAgAAADQAAAACAAAABkRqRb+1G8AvEE0fJqDbPhCTf2kx
nhrA06de43sL8T7pfI2V14gZwIWc3e71BQQ/E18jOYl1GMB9CIqD3WwWP1mx
7dQgZBfAU2G+FMj5Jz+cZCabe1QWwDiDvHvefzg/cZusHXlGFcDGApbXD/RH
P15qYQf7ORTAkaKUgBduVj+pWeDe5C4TwAjOHh9qImQ/k1UI0RslEsCteiI+
DldxP55DE4KGHBHA8B8IdQytfD8YcTTkDBUQwLCJC4v8x4Y/STzIJTAdDsDi
nhegIWaRP2JyRmQkEgzAfuZerWSQmT9C8D+izAgKwP7JnfzvEqI/P9N3nwAB
CMD9cKesSZuoP7AJD42Z+gXA3PZKDkMisD81JK7hcfUDwG4G+EzBYrQ/VXBD
MWXxAcCNMG2kutO4P6w9mA+g3P+/sYTYspwmvT9dKWGNH9j7vy3DZCrggMA/
+GOUCAXV978own0CAgbCPzrLaNoN0/O/4I/qaPT8wj9c2VCc8KPvv08njBTH
TMM/hFMj0gaj579Znm10d+3CP6hr7M+6Rd+/fCWidkDpwT948Jsx0IvOv6lR
mCrQWsA/wGSIcVdNhz+IqtJcotG8P9VO508+vNA/3YGQ7Jt/uD+EZHRASmDg
P5hQf86AF7Q//pXLnDhk6D+6vemMQsqvP2KQMtM2NfA/nEwSYJ9BqD+wpGlV
tzn0P5CQH1zN2KE/p0dYqOE/+D/lQRpTZlGZP3WvLQn7R/w/17/Uec9OkT82
vfcvJSkAQJFZiSevzIY/xoZgQowvAkDMUaZ2Fe18P8ijKEVYNwRAreVVSWGq
cT/lJS8HsEAGQBI/rOJww2Q/ze+wyLtLCEC/eX+r7HhXP7aVUWulWApAsD3T
gb6BST+/Og+nmGcMQOHFhjmgoDo/sF75RMN4DkARQMsrl68qP2izVLAqRhBA
AKhvkPKnGT8XxNXYQFERQLEqVCiMpAc/MPUg775dEkDFljSocd30Pl6+mmzB
axNAnLWK7eGd4T4bC2KmZnsUQKqCZnAnbsw+y7iXCs+MFUBaLOLJBua1Pq/W
AWcdoBZA38YZ7JEUoD7Y7PM6d7UXQDxd79Rle4Y+yJ3eFgXNGEDmRRN3T+Bt
PunRilk=
           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{2}, None},
      PlotRange->{{-3, 3}, {0, 0.7843698638105241}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {580.5, -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk41Pv/h8cMjaWypcgWWSplCcmYmfe3RShRklPJ3kJpU1EnpJxChOyN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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlXk41PsfxcdYBpObfUm4RIUuKRLi/ZXccZV7kW66pJDlZ6tcRlw/S4mS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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk31Iv/x2dhhpGEKIUSEbKViYjX+5YtIUukkCxdClfWUiRZSsRVEa4t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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk41Pv/h8cMjaWypcgWWSplCcmYmfe3RShRklPJ3kJpU1EnpJxChOyN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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlXk41PsfxcdYBpObfUm4RIUuKRLi/ZXccZV7kW66pJDlZ6tcRlw/S4mS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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk31Iv/x2dhhpGEKIUSEbKViYjX+5YtIUukkCxdClfWUiRZSsRVEa4t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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk41Pv/h8cMjaWypcgWWSplCcmYmfe3RShRklPJ3kJpU1EnpJxChOyN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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlXk41PsfxcdYBpObfUm4RIUuKRLi/ZXccZV7kW66pJDlZ6tcRlw/S4mS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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk31Iv/x2dhhpGEKIUSEbKViYjX+5YtIUukkCxdClfWUiRZSsRVEa4t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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk41Pv/h8cMjaWypcgWWSplCcmYmfe3RShRklPJ3kJpU1EnpJxChOyN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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlXk41PsfxcdYBpObfUm4RIUuKRLi/ZXccZV7kW66pJDlZ6tcRlw/S4mS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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk31Iv/x2dhhpGEKIUSEbKViYjX+5YtIUukkCxdClfWUiRZSsRVEa4t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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk41Pv/h8cMjaWypcgWWSplCcmYmfe3RShRklPJ3kJpU1EnpJxChOyN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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlXk41PsfxcdYBpObfUm4RIUuKRLi/ZXccZV7kW66pJDlZ6tcRlw/S4mS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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvk31Iv/x2dhhpGEKIUSEbKViYjX+5YtIUukkCxdClfWUiRZSsRVEa4t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          "]]}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      Frame->True,
      GridLines->{{2, 0, -0.36363636363674273`}, None},
      PlotRange->{{-3, 3}, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {967.5, -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}]}, {}},
  ContentSelectable->True,
  ImageSize->{621., Automatic},
  PlotRangePadding->{6, 5}]], "Print",
 CellChangeTimes->{
  3.46070451917115*^9, {3.4607046303750753`*^9, 3.460704648904955*^9}, {
   3.4607047577968493`*^9, 3.46070477859319*^9}, 3.460704954247167*^9, 
   3.4607050368531113`*^9, {3.460705128436154*^9, 3.460705175118433*^9}, 
   3.460705215569192*^9, {3.460705274472828*^9, 3.460705286163951*^9}, {
   3.460705328448756*^9, 3.460705339224861*^9}, 3.460705436687511*^9, {
   3.460712600376568*^9, 3.4607126147235003`*^9}, 3.460713047876918*^9, {
   3.460713282521329*^9, 3.460713294551167*^9}, {3.460713834968994*^9, 
   3.460713860036693*^9}, 3.460713902558764*^9, {3.460713957325048*^9, 
   3.460713995695146*^9}, 3.460714037951282*^9, 3.460714131146854*^9, {
   3.460714181968012*^9, 3.460714208204916*^9}, 3.460714288368878*^9, 
   3.460714320506762*^9, 3.460715344636594*^9, 3.4607156113978767`*^9, 
   3.460715886246475*^9, 3.460715921874712*^9, 3.460716010317369*^9, {
   3.460716602712977*^9, 3.460716612332562*^9}, 3.4607166808613367`*^9, 
   3.460716728278655*^9, 3.460717947774094*^9, 3.4607181538085213`*^9, 
   3.460864852779917*^9, 3.4608649440956497`*^9, {3.460865054515229*^9, 
   3.4608650996454573`*^9}, 3.460865131062428*^9, 3.4608652063886013`*^9, 
   3.4608652375708027`*^9, {3.460865304978962*^9, 3.46086534669381*^9}, {
   3.460865383703322*^9, 3.4608653942322607`*^9}, 3.460865443237199*^9, 
   3.460865487147558*^9, 3.460865524133155*^9, 3.460865599301724*^9, 
   3.460865631528137*^9, {3.460865678064745*^9, 3.4608657627915583`*^9}, {
   3.460865888638105*^9, 3.460865895896729*^9}, 3.460865937576189*^9, {
   3.460865987678075*^9, 3.460866000022244*^9}, 3.460866039071653*^9, 
   3.460866078288553*^9, 3.4608661727274227`*^9, {3.46086620527229*^9, 
   3.4608662286114283`*^9}, {3.460866591783491*^9, 3.460866605728109*^9}, {
   3.460884097643346*^9, 3.460884163155167*^9}, 3.460884256662903*^9, {
   3.460884582123115*^9, 3.4608846116249857`*^9}, 3.4608846679279823`*^9, {
   3.4608848296710052`*^9, 3.460884896153452*^9}, {3.460888708395012*^9, 
   3.460888733025832*^9}, 3.460888856973765*^9, 3.460889348450428*^9, 
   3.460889410038197*^9, 3.4608899257122517`*^9, 3.460890038266615*^9, {
   3.460890116133047*^9, 3.460890159630308*^9}, 3.460890191415696*^9, {
   3.460890270481584*^9, 3.460890308143527*^9}, {3.460890431748641*^9, 
   3.46089045135244*^9}, {3.460890488240271*^9, 3.460890504344252*^9}, {
   3.460890552097582*^9, 3.460890588805337*^9}, 3.46089091061549*^9, {
   3.460890958035729*^9, 3.460890970194047*^9}, 3.460891182333213*^9}],

Cell[BoxData[
 RowBox[{"-", "2.6941985340205687`"}]], "Output",
 CellChangeTimes->{
  3.4606944285880413`*^9, 3.460694710821148*^9, 3.460694813752266*^9, 
   3.4606948686565523`*^9, 3.460694908824984*^9, 3.460694943743373*^9, {
   3.4606955286647463`*^9, 3.460695539377111*^9}, {3.4606959743468847`*^9, 
   3.460696046934908*^9}, 3.460696164888945*^9, {3.46069624289347*^9, 
   3.460696254104011*^9}, 3.46069664856536*^9, 3.4606978773565187`*^9, 
   3.460698003355398*^9, 3.460698428704109*^9, 3.460699017700994*^9, 
   3.460699198261404*^9, {3.4606992404204206`*^9, 3.460699250004673*^9}, {
   3.460699420002788*^9, 3.460699448542591*^9}, {3.460699551492279*^9, 
   3.4606995760372458`*^9}, 3.460699628821332*^9, {3.4606997766246853`*^9, 
   3.46069979233737*^9}, 3.460699846509027*^9, 3.460699991426691*^9, 
   3.460700120962723*^9, 3.460700150978692*^9, 3.460700290202798*^9, 
   3.460700350015143*^9, 3.460700640543497*^9, 3.46070113823307*^9, 
   3.460701477583243*^9, 3.460701669557947*^9, 3.4607028883471003`*^9, 
   3.460703284824523*^9, 3.460703470343832*^9, {3.460703818260503*^9, 
   3.460703838762457*^9}, {3.4607039225852947`*^9, 3.460703937086619*^9}, 
   3.460704031751749*^9, 3.460704109348311*^9, 3.460704324286234*^9, {
   3.460704404777562*^9, 3.460704452506097*^9}, {3.460704497969942*^9, 
   3.460704519204072*^9}, {3.460704630407476*^9, 3.460704648938583*^9}, {
   3.460704757832714*^9, 3.4607047786437263`*^9}, 3.4607049542830973`*^9, 
   3.460705036891027*^9, {3.460705128472733*^9, 3.460705175152998*^9}, 
   3.4607052156065817`*^9, {3.460705274511199*^9, 3.460705286201747*^9}, {
   3.460705328482711*^9, 3.460705339258251*^9}, 3.4607054367225018`*^9, {
   3.460712600408203*^9, 3.4607126147571*^9}, 3.460713047908724*^9, {
   3.460713282554874*^9, 3.4607132945848017`*^9}, {3.460713835058514*^9, 
   3.4607138601197033`*^9}, 3.4607139026455917`*^9, {3.460713957091056*^9, 
   3.460713995382338*^9}, 3.460714037957024*^9, 3.460714131191308*^9, {
   3.460714181974341*^9, 3.4607142082382517`*^9}, 3.4607142884014807`*^9, 
   3.4607143205417843`*^9, 3.4607153449128113`*^9, 3.460715611660941*^9, 
   3.46071588650872*^9, 3.4607159221362133`*^9, 3.460716010350465*^9, {
   3.460716602744968*^9, 3.460716612368623*^9}, 3.4607166808947973`*^9, 
   3.460716728310671*^9, 3.4607179478075523`*^9, 3.460718153890011*^9, 
   3.460864853569865*^9, 3.460864944632353*^9, {3.4608650549224043`*^9, 
   3.4608651000694838`*^9}, 3.460865131533939*^9, 3.460865206868553*^9, 
   3.460865237994265*^9, {3.460865305414671*^9, 3.460865347127034*^9}, {
   3.4608653841410217`*^9, 3.460865394663265*^9}, 3.4608654436569023`*^9, 
   3.460865487559341*^9, 3.4608655245522413`*^9, 3.460865599731702*^9, 
   3.46086563194384*^9, {3.460865678567177*^9, 3.460865763215781*^9}, {
   3.4608658890662947`*^9, 3.460865896275236*^9}, 3.460865937973333*^9, {
   3.460865988090621*^9, 3.460866000404463*^9}, 3.460866039460979*^9, 
   3.460866078684072*^9, 3.460866173126914*^9, {3.460866205645241*^9, 
   3.460866228977401*^9}, {3.460866592131584*^9, 3.460866606116922*^9}, {
   3.460884097973241*^9, 3.4608841635609827`*^9}, 3.4608842571343107`*^9, {
   3.460884582522368*^9, 3.4608846120265217`*^9}, 3.4608846683227043`*^9, {
   3.460884830077977*^9, 3.46088489660178*^9}, {3.460888708916758*^9, 
   3.460888733443715*^9}, 3.460888857374319*^9, 3.460889348847591*^9, 
   3.46088941044028*^9, 3.460889926088251*^9, 3.460890038615594*^9, {
   3.4608901161774*^9, 3.460890159674868*^9}, 3.460890191459124*^9, {
   3.4608902705254993`*^9, 3.460890308461899*^9}, {3.460890431792459*^9, 
   3.460890451396481*^9}, {3.460890488285193*^9, 3.460890504385693*^9}, {
   3.460890552139698*^9, 3.4608905888481092`*^9}, 3.460890910715507*^9, {
   3.460890958146579*^9, 3.46089097024151*^9}, 3.460891182379198*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0, 0, 1], PointSize[0.03], Thickness[0.03], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ7bzz4GLP14IHGKDAfG3l9wl+CH5ENW+9yGYBON9b
5mbNXgkEv+rarmtv//HB+fni0f1R53jhfLaN7MfnzOeB87dkBFRPKuI+YFTy
RuP6ghecnx9p7Zd25zrQON/0bKPJQ/F7CQz1UrKcB7wrnRsWch1SWrJA1Kfo
C/uBLeL7zzmXyGvvlVLV4zjLduDWp9qd+xWKDR9VmlcdWsZ6oLF9p6ZokrqZ
XvH7tR2NLAe6rgVMiLw62XJa8Hw/51jmAyv/b9b7xcxoMzN75unblkwHCp4X
Hdh/eIXtJg+nZBtxxgPrpdUfll7eb9d/7ZfIglf/968w9XVb9i3DnifMfA3L
ir/7nT9UHbnvddy+ftOf03Vpv/dzKUpUn9z1yT7wZvji56o/91+uKy267f/X
/tFzUx3JZ9/23+W71hhb/cX+B9dfjnfLvuw/fu9h34bjj+1TLU4mO2Z82q8q
EaUSc/ai/YzPX8+90/yw/79xCOMbvkP2Oe2evkuuv97PEZ245fPXbfar1718
2hf9fL+3Z2CDj/xm+2d+7lND7z/av/ZtUOaz+1vsZ3U5Xk84emd/L/NcNwaB
vfb+DkVO605d3q9fLq7ybOcJe5+ZstnMc47ut1/1Yt3Jphv2D/IKJtS+mbO/
T6lvVRv3a3uFckO14HN77MteMadzffpv/+Z1mdcaywv2WkvZN8nMEHYQedfy
VtLlpj3bC4fJezI0HLa8uRq5T/Oh/cnp286bB9k5BFUY/bbe8tRemfHx1P7U
IAcnCS/2W46v7AM+PfR7IpXqsGBaV8v7S+/s2VeJmk6eWeqwI+Jq1OvNH+0l
PfkkHa43OhTM2nCojOGL/U7ZQIYo4xYHm2UT/3n5f7M3/Gnd9iGuwmGHWnrK
7AU/7O0u//N1nBvqcEVrz5O5X37Zf2XOu/5yiYCDmxl7bLf3X/sShwyBmL6p
9r+OlX6Zv/S//SsBkX9/dl60e+nZd6iXkdFh/vzzU9u7lth+5XjHqWjE5HDm
8F62iU0vrVmzn+qsS2F2mBeZrtwZUGCpq+lnGDOTxUFx+d/vM7d9N33Xo6YU
eoHV4eFmw4wdmmaGDEu3VR3jZHf4s73Q1VnwtBYAnWqB7A==
           "]]}}, {}}, {{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.01], Thickness[0.01], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ7bzz4GLP14IHVKMd7yxctNnGfG3l9wl+ggemuj+f
4av32SaimrdeZLPAAS/fgolnwwxsvWVu1uyVEDjQwFZkdDo+w7bq2q5rb//x
HSjSEJHi/DrfNl88uj/qHO8B51StDfMqL9mybWQ/Pmc+z4GTe5xvT3jKZLcl
I6B6UhH3gSr+fR7JqoZ2nx9p7Zd25zqQIN0+OW1NtN29BIZ6KVnOA/dUAg7N
edFst2SBqE/RF/YDU/j8TntMX2m3V0pVj+Ms24HcIxtmvik8a/eo0rzq0DLW
A08aM1StE9/Z6RW/X9vRyHJg66dlG86o8dhPC57v5xzLfCD1rVXpmjJ1+5nZ
M0/ftmQ6UCZnHnpvjqP9Jg+nZBtxxgPc9hNVeq6H2/df+yWy4NX//XJGYbuW
K+ba84SZr2FZ8Xe/nM4+K0uRBvv6TX9O16X93r/6Ldu2Bp4J9oE3wxc/V/25
X/a+/L5Pf+bYP3puqiP57Nv+3qS5ahs2L7f/wfWX492yL/ubWHa1Xu3daJ9q
cTLZMePTfok359039G+3n/H567l3mh/2T+h7rymzao99Trun75Lrr/erVrPe
rZu73371updP+6Kf75eC8p/5uU8Nvf8Irn5Wl+P1hKN39otAzfN3KHJad+ry
/kqofT4zZbOZ5xzd3wV1z4O8ggm1b+bsl4K6V6HcUC343B775VD/vHld5rXG
8oK9ItS/Iu9a3kq63LSHhceWN1cj92k+tGeBhldQhdFv6y1P7auh4ekk4cV+
y/GVfTo0vBdM62p5f+md/WZofOyIuBr1evNH+8fQ+CqYteFQGcMX+2xofNos
m/jPy/+b/SRofO9QS0+ZveCH/WNoeriitefJ3C+/7LOlIOnFzYw9ttv7r70U
HyQ9/TpW+mX+0v/2B6Dp7aVn36FeRkYHV2h6/MrxjlPRiMmhBJpeWbOf6qxL
YXaog6ZnXU0/w5iZLA4+0PT+rkdNKfQCq8McaH5gWLqt6hgnu8P7KEh+AQAu
QJNq
           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{2}, {1}},
      PlotRange->{{-3, 3}, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {193.5, -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.03], Thickness[0.03], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ7bzz4GLP14IHVKMd7yxctNnGfG3l9wl+ggemuj+f
4av32SaimrdeZLPAAS/fgolnwwxsvWVu1uyVEDjQwFZkdDo+w7bq2q5rb//x
HSjSEJHi/DrfNl88uj/qHO8B51StDfMqL9mybWQ/Pmc+z4GTe5xvT3jKZLcl
I6B6UhH3gSr+fR7JqoZ2nx9p7Zd25zqQIN0+OW1NtN29BIZ6KVnOA/dUAg7N
edFst2SBqE/RF/YDU/j8TntMX2m3V0pVj+Ms24HcIxtmvik8a/eo0rzq0DLW
A08aM1StE9/Z6RW/X9vRyHJg66dlG86o8dhPC57v5xzLfCD1rVXpmjJ1+5nZ
M0/ftmQ6UCZnHnpvjqP9Jg+nZBtxxgPc9hNVeq6H2/df+yWy4NX//XJGYbuW
K+ba84SZr2FZ8Xe/nM4+K0uRBvv6TX9O16X93r/6Ldu2Bp4J9oE3wxc/V/25
X/a+/L5Pf+bYP3puqiP57Nv+3qS5ahs2L7f/wfWX492yL/ubWHa1Xu3daJ9q
cTLZMePTfok359039G+3n/H567l3mh/2T+h7rymzao99Trun75Lrr/erVrPe
rZu73371updP+6Kf75eC8p/5uU8Nvf8Irn5Wl+P1hKN39otAzfN3KHJad+ry
/kqofT4zZbOZ5xzd3wV1z4O8ggm1b+bsl4K6V6HcUC343B775VD/vHld5rXG
8oK9ItS/Iu9a3kq63LSHhceWN1cj92k+tGeBhldQhdFv6y1P7auh4ekk4cV+
y/GVfTo0vBdM62p5f+md/WZofOyIuBr1evNH+8fQ+CqYteFQGcMX+2xofNos
m/jPy/+b/SRofO9QS0+ZveCH/WNoeriitefJ3C+/7LOlIOnFzYw9ttv7r70U
HyQ9/TpW+mX+0v/2B6Dp7aVn36FeRkYHV2h6/MrxjlPRiMmhBJpeWbOf6qxL
YXaog6ZnXU0/w5iZLA4+0PT+rkdNKfQCq8McaH5gWLqt6hgnu8P7KEh+AQAu
QJNq
           "]]}}, {}}, {{}, 
        {RGBColor[1, 0, 0], PointSize[0.02], Thickness[0.02], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxFxw1QiwEcx/FntdmWLFzpRbtTNOrovJSZbP+nQi8ylCyN89Lm5aJSpCId
Qld6mZd6lmgum7eZai2leB7dldNIkiU6EumyWmG9iC3cufzuvve7j8vO2FCx
BYIgXn/6+/7Vj0qC9NMI5N/Yd5JH8vj/HXFkSpqteuqE1zi3H33g8N8puvu6
fjNjwrH2wtzIpikTnlRGfVxUbD3hij3rj5yLn0zM4sw+v3ykjva9ywOfGWBF
1K5N1bXy38x4tx1Jc2LSCfOjDzyp6bXLNZldSLyRSlCqTpiS6aEeD5zcPGnP
JhERO2wKhDJiYVcyO6VOQSGY+w9YKblnvT0TBu5kHCcTNW2Ox0ezGJz8sGK+
/1ZL4mqZJJqpyfGRRku1bzkWxAL7jQZ/u0BueaBf1Ap7ErFKQIGlmhherm7M
VvZlHOcFWd2sJbPAehNbSb5hwtHAUsfB9RJIK/+lPbbrJ77BwdyruF4PG9oF
JT1uP3D78V3TD4a9hq4e7/mOn4fxOPG9zpEMHYxamWgGhRHvF9bvSL/eCOJl
T6J893zDq61jGBirBrDvQ00G90F8kJHbKXmuhH1ngtZea9Pj3xKorcsrr8Jt
VW93jrAHZ4RvUu/dVgif+QEXw9934SZaimtCYwEUZvq2ba/vwGFqA7clRArr
0Hg/VeNLPHuOmI5FXYEQKTPasqge/6VN1UnkJdAZE5eX2leEj5+XOyuYt2DW
4UWssKZaEHbkdEjmlkGfPjFYyWmGyMEfNi2YBmwN6f2OK9uBlX45ISmxGir6
Xm1+6P4BvLaoLx7Ir4HQpMU/fSq6wbsUsXP5eB/8HIKpb3y/AHm3zuysrQRZ
fmb6QIsB5FK3haLSu1AV8SpSr/4Ky+YmtWChMogrLK1LRIwQi53CTs8+BSsU
EnPwumEYitVgzZWRUMXaLbokGwWRSmnnXD4DWj1qP102jkFhxrDA65yKt3op
dWvWGhOQouZhF3JteGMNh4zF8nFgJwWotS9cub1BOXXZJBLKOOmkYmue+gzR
DHSXxRZo1rs278NoN4cS3T1fJbJEFXlV4oFVXPYCd/6iLVIyWqDPbuWUXFhi
OMtyDW+moCaBKDP/mcwTkVemNNCpaJ6AKiIhyLzfxh99bQ==
           "]]}}, {}}, {{}, 
        {RGBColor[1, 1, 0], PointSize[0.015], Thickness[0.015], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJwBUQOu/CFib1JlAgAAADQAAAACAAAAQ7nBo0nrEcC/bNyBHaSqPTetefeQ
ThHAovceCnm/2j1Yew1/FLMQwJrfejDnFAg+SxzZfL0YEMAYU34OU4EzPnrW
utbt/g7AkXqYYXOCXD5vF1uPWs4NwAZlENWb2YI+BrEHx5yfDMDKuPu2QJum
PrRoUHuScgvAFEKW5n2kyD7z4iq/G0cKwACAHq4Zd+g+3mAAfxodCcAIgII4
qikGP6SgFUxy9AfAB3QMIptZIj+9GiUuCM0GwCi8NOSo0Ds/4nk3esKmBcBP
cChI7lJTPy5z762IgQTAz8qH+4akaD+WU59OQ10DwKpl++Dw33w/mWuZy9s5
AsB0v23RiR6PP7JIQmM8FwHArwxGxS/gnj+P1voUoOr/v5pzQnmUOaw/DFY3
rASo/b9T1ygVH8q3P3+y/Mt+Zvu/2VDQ6Ll/wj9R2Vej5yX5v0UFoRaLjso/
4uc1LBnm9r8on5TflprRP/gK/QjupvS/8jy6mISP1T9lOMljQWjyvyHs5xH1
Ztg/mPP1zu4p8L+WdBZ/5obZP2yHSU2k1+u/dUbmE0ev2D+rrunljlvnv7/G
6cMMEdY/5k5HlVXf4r/Txf5pNzzSP5qKQddgxdy/gJLMd3fbyz9PQHJCrsrT
v0BzTW0UqsM/TJkdawOcxb+SfWSyUKa5P+BucJB97Jy/uTdLdYrmrj8gdzEm
U868P18U6d0QL6E/7Ot2Sqw50D9ySUpjqaKRPxTuhO0ZRNk/s7W5/M6wgD+0
7NVZvinhP+HPIPJ6HW0/Ungy+zu05T/vw7FsZWJXP0IYSgfaQeo/wC4LKKxH
QT+gloqE79LuP5CRTrc0eSc/uFjVWuuz8T9ti8Rb5UYNP3CasMJ2APQ/NUfY
PTu+8D48ppH+Sk/2P2gDosrUidE+uCZnZJug+D/hFUMo8cywPtQqvOSd9Po/
eFLrAE1jjT5GNgddi0v9P3+BiqUQbWc++sZ19J+l/z9Zdy0QjvxAPulJjsKN
AQFAxX1cLX1cFj71CO4JITICQDf8iGORqOo9BWvlLK5kA0Bc0c0tbrW8PS0p
TjFcmQRAc0ed+3jZiz3ujCYiVdAFQJu5ANnYQlg9AKW2esYJB0C3ImhSbuoi
PfW7nSk=
           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{2}, None},
      PlotRange->{{-3, 3}, {0, 0.7977173311407053}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {580.5, -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk41Pv/h8cMjaWypcgWWSplCcmYmfe3RShRklPJ3kJpU1EnpJxChOyN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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk4VYvfhjfbkC3pmOKQDDtCwokjw1q/lRIiyVQRIsUp0iltJUUJlUxN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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnc4lY//h8/AyQiZDaFIpEicCM/zfiKzkt2wqaiOlIREKiEl0lAklVH2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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk41Pv/h8cMjaWypcgWWSplCcmYmfe3RShRklPJ3kJpU1EnpJxChOyN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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk4VYvfhjfbkC3pmOKQDDtCwokjw1q/lRIiyVQRIsUp0iltJUUJlUxN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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnc4lY//h8/AyQiZDaFIpEicCM/zfiKzkt2wqaiOlIREKiEl0lAklVH2
SHb1PIQoKiORnX0c85Rj+35+1/X743Xd1/3v/ddri6uX5SkKiUQq/m//R1zY
u3t1lUbQptOKlBpaUEft+JyLlTSipPqwOrm/E11yq7zWf4tGCFz7PXuX04/G
32Oa2RjRCF7D6DOhAWOoVrGIzGdeGhHX/OpWatMM2tqrPalVz0PIlp7V+Jo5
j/rwueEZUTzEJYpDhponGUQ07kZLWfAQcq+0Bh7co0GeQ4FTlCgP4avBYTzL
E4JiekR+0w9u4ubAH3NJXBw+rnWiSkZxEx1xFjEyeZuhalDDxu4gN7E7tVDL
WlEevn7ge/NiDTehvv7i4hltZWh63DvXX81FKHpMD9Sa7oE2zyJTxRAuQu8q
rTTKWwt6DCITGBgX8dBGqm4bhsHQZteJvGUq4X92zsE6yAAmkWA7F5xKdF8g
Mww+HYQ5h4TadTeohM2Hltlv7RZAvlZKr9SjEmy2lhyj3Rb4EluTvLmohKFa
X3G1lAOIfmQLydVQiHCLdKG+y64g1S0c1BxOIeJ4HUs+H3YHhZVdzBATCpE5
k/STbuwJqtIHj2rwUwgX3kduvUe8YY1VYNbmb2Si6IDTt/MFvtAbnk2mxZCJ
viOd8we5AqHkfbftlBWZ8Hr9+4bB3htwf1ooq12CTHAEc/eOrQ0FD4X95E/t
JALDXC37kyMAs/O2zUogEQ85im6iEtGw/n5y5mOn/1weca+tfABTVS2k4K0k
IpVXboP13VhwNXfPvUys4raRVaI5zs+gX2Kbw7jOKh6Zp4NdiHgJJ7v+8J0q
XsELwvVMw3uSYSj5ZUnnnhX8lEuLFqXyDXicdTxtnbOMf6+MlmJhWcDcLSVW
r7SMJ5bOltgV5QGD016hn7qET7Yjg3MZBTD+4YlXuewSXvhln54PTzH4iA1Y
8acu4pbBR/WNI8tg4exuLTulRTwoKaXwgv9HuF4RKJWZvYDP7Lt+WNqjAnjW
15EW1Rbw4dE9RRL1nyDyvPigadE8HqAjU9x3pgZEql3q4rXnceWgvaEpenUg
7b0Qo60/h/PQvWlcr7+D77akK6ofOLj/g1Ct9I+N0NBm4iKvycHrqpmJn780
QyDE7RZUnsUv1TTx/9Nug98CWt/7RP7iG4ylfkrQ+uDHKC3cOJqNr/PvCdYz
+APVNb/QXH42HjjNdmu83g951/1yArlm8BKPvPrmvkF47WB0uv/6NK5erCne
vzoECdqS0qbLU7i79i7ttwIj8EBy+GfelSn8tBBtIolrFARHPTepsiZxgzlp
Z/2BUaB82jGXNTuBaw/5q8kmMIGTMNyygzyBs7y3zxbvGwOWb0p+Gv84ztlY
5EIuH4Nec5coBQkWrnxLMtdUmgUtO6TPpciO4T5G/BL6riyo5eow2qrMxD+t
36xFCWPB++4n8i/po7iw2mvTtREsyC+xJktjI/geIbzl+DkWGB+qHRikD+Mc
pwX15wos6OnRqc1WHsIlrncFTLwfA99LuZmXtwz+188FYauOwVqaXDQiOYBz
/6w/8OsGE1LiY7251/bjAuqKVmjhKOio8Nk2UP7gY0tnN6o3jEBTRdC+x3O9
+MHnnSSxhmFoyvizr6yzB89642R/rWQIRES4OjLGuvC2Lk1QeDMIlle2BT5b
6MD9pegOp+4MQLORx8fA9W34mgnrT3I6f0AsN8LJc3srPudDLskR7ANriUyS
494W/ELtkFVidQ+0DIzrgfUPXDhXWVtWpQM2DjqZTLTX4xs42ZFnKO1wlzQg
4Mhfh8d1pF4RH22F85qsh8j5ClwwkW4lON8EeGpvzgkox4XOpbNrFBohqXOE
rp1UgKvS3P2Cer7BS6VBocEXMXjQne6OJ9m1sBRpsFDcGgVv1ovK3M6vBjM7
8VAznTQIvGIRGDZXCTnp9aF+zu9gOeuq5/R1AopSBeuMkt/D8GpmS+P999Bt
rsgjcKkS1jnWtQ4+KYE/ZnXbfR7VwLqClVREuBCGDp016Sz8AqNSTiWHZ/KB
acp/7sCvb8A2OROgw8iBkwObGP+ONYJzW1O+DzsdrOXeJhkbNsPwmJecBe9r
OOBq3P5M/ScIi97cn/MyCTRedQtNyv6C+fvNgU+PvwD5Xh9DPcF2OEv3VGXq
xYOYDH/Q48Xf0OE0bU0fegxcjq8KRkY6Yb9N4VzbrgfATtBk6rR2w+Z2Y6mn
/FFwRCMvIsi3F8ymgjtUjtwG+fgD0l03+qA3tvWo/f0QWFhte6t77w/kJ5b0
3rEMhu+nPI0SnvbDxAK9uXvKH1K+kjsXkwfAv30vTqu4BAFqsRfscgehmaEe
IS3rBUee7OAuLxsC+9wDg/InPUB++WPcxpphwJMD3XdS3eCDEDUqtn4EUuO8
JDmJDmC71eimSPMo/NYoc/7x1xYmNe76RrUz4bPJVsV9BRZw2+j7Wb7eMcD1
lxjZ2w/ClhOiTmFDLAj6LOuvU3oAyhhHrSjj45Dl419N9gewDH5mdI09AYVd
ixN7qzVhLKZHZ2F+EhKkNWuoXWqA6IX0ufpNgXecwrEAVBlCyyVSa6enoFW7
80tzjjw0aGR4qDCmYavY7d/39GVAPAfZ+WhoGhoCdTmCYZLgsL1xct55BtI4
2QbsxHWQ+vJkgVPHDHDGLZ9NGfHB+IY532obNpgxVH2Hb1KB/vCutvIPNuhz
M7hv/VpCs3I/LYxZ/wUZ82+1cVl/0a31i2VZ7X9hoC1pT9fVcTRuRP2qp+M/
kLzYZt8zOoAKczN0VPr/wfFr2Zt9Q7rQsC0pixPusyDkPlqmV9yCLiOd5bms
Wajia7jyc7we9TkhFnjhIgeEtMRbmJJVKNP3kK7aLAfKCrQN91eVo/bU2eoN
3nMgM+5jwPegAP0W/eIIZWIOKvndX0r5ZqKYlEk788w8qIZYejXvSkbfps24
Ng/Ogwb5lER5RjwqT09glbssQNKmY8gJnwdobIWBb0rXAvy9aO9G9oxA15hN
rkYeX4QwFavRC1430IDfTyMu/1yEkMGm8JAGP3QT37BQqd0SdFjs3rHJ3At9
v48eu9S3BF+NSz6eDjyJ2p8JkcI8lsEkJDPhRPoJdPlpY1LIxDLYvxXReb3f
Ak2slVH67LMCLwQzYsc1DVF0zjOXb3EFsm8nW+j46KI929/TzW6swrXL9HRD
mT0ooczdXUslYe+Ou++o/aeAVqisL803IGHhcjckJndtRivVlB/Fh5OwQyO8
k0reImiVBuoVUkfCUoQZNy+p09BqTQtTBj8ZC73najlDW0ZqtE9uszlMxr5T
tdJK180gtYgfCY0mY+Inu5x9nYeQOuxOh0IjGSuSnxe4GNOBfNF/XiQkSsFY
wwKizIEfSN2Kh2+kOQUrSSl5cPBQNVJbqrGXN4qCbUi8EptSVoZ89iHNhn6l
YG1VC/qX3+YhNar1hRReKqZs26NvUZWCVDOfXA42pGLiYTWibkVxSFWqG30p
hIr5qfi1WORHI5+cVf/5V1AxlsBwQNbFEKRy0+K7fytUrKfsV54V4YccU9zA
frGfC/N2WY+s5J1DJjU01UxvcWFMjdSTaYLOSNh+G6+/NVzYGR+ZbqEwS0TK
7FJ2Ii839tdhV/rd/QbI2xMxY8aHuDFi56tXe/W1EGP3XCV2FDeWLtLx3DhS
Gem+1OD+vJEba66POzYpJYNcvj6WaiTGg/HkCJeKBaxDrlkuZX204MHSdsrG
CFzkQm7Lr31Hj+bBjNbOyOg3cHRjZjeXZ9XzYBvf4WqrsWO68bUqlXJ8NGxW
8qiFYWuPbnI81MUb0TBjkeGjNiZNulkM8x/rQmnYwZpC0p3RKt0i1OXX7Uoa
Vhb/WbjyW7Hu//9rrEepxISxmKH7P4KKnh8=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk41Pv/h8cMjaWypcgWWSplCcmYmfe3RShRklPJ3kJpU1EnpJxChOyN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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk4VYvfhjfbkC3pmOKQDDtCwokjw1q/lRIiyVQRIsUp0iltJUUJlUxN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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnc4lY//h8/AyQiZDaFIpEicCM/zfiKzkt2wqaiOlIREKiEl0lAklVH2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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk41Pv/h8cMjaWypcgWWSplCcmYmfe3RShRklPJ3kJpU1EnpJxChOyN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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk4VYvfhjfbkC3pmOKQDDtCwokjw1q/lRIiyVQRIsUp0iltJUUJlUxN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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnc4lY//h8/AyQiZDaFIpEicCM/zfiKzkt2wqaiOlIREKiEl0lAklVH2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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk41Pv/h8cMjaWypcgWWSplCcmYmfe3RShRklPJ3kJpU1EnpJxChOyN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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk4VYvfhjfbkC3pmOKQDDtCwokjw1q/lRIiyVQRIsUp0iltJUUJlUxN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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlnc4lY//h8/AyQiZDaFIpEicCM/zfiKzkt2wqaiOlIREKiEl0lAklVH2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          "]]}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      Frame->True,
      GridLines->{{2, 0, -0.8000000000000411}, None},
      PlotRange->{{-3, 3}, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {967.5, -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}]}, {}},
  ContentSelectable->True,
  ImageSize->{621., Automatic},
  PlotRangePadding->{6, 5}]], "Print",
 CellChangeTimes->{
  3.46070451917115*^9, {3.4607046303750753`*^9, 3.460704648904955*^9}, {
   3.4607047577968493`*^9, 3.46070477859319*^9}, 3.460704954247167*^9, 
   3.4607050368531113`*^9, {3.460705128436154*^9, 3.460705175118433*^9}, 
   3.460705215569192*^9, {3.460705274472828*^9, 3.460705286163951*^9}, {
   3.460705328448756*^9, 3.460705339224861*^9}, 3.460705436687511*^9, {
   3.460712600376568*^9, 3.4607126147235003`*^9}, 3.460713047876918*^9, {
   3.460713282521329*^9, 3.460713294551167*^9}, {3.460713834968994*^9, 
   3.460713860036693*^9}, 3.460713902558764*^9, {3.460713957325048*^9, 
   3.460713995695146*^9}, 3.460714037951282*^9, 3.460714131146854*^9, {
   3.460714181968012*^9, 3.460714208204916*^9}, 3.460714288368878*^9, 
   3.460714320506762*^9, 3.460715344636594*^9, 3.4607156113978767`*^9, 
   3.460715886246475*^9, 3.460715921874712*^9, 3.460716010317369*^9, {
   3.460716602712977*^9, 3.460716612332562*^9}, 3.4607166808613367`*^9, 
   3.460716728278655*^9, 3.460717947774094*^9, 3.4607181538085213`*^9, 
   3.460864852779917*^9, 3.4608649440956497`*^9, {3.460865054515229*^9, 
   3.4608650996454573`*^9}, 3.460865131062428*^9, 3.4608652063886013`*^9, 
   3.4608652375708027`*^9, {3.460865304978962*^9, 3.46086534669381*^9}, {
   3.460865383703322*^9, 3.4608653942322607`*^9}, 3.460865443237199*^9, 
   3.460865487147558*^9, 3.460865524133155*^9, 3.460865599301724*^9, 
   3.460865631528137*^9, {3.460865678064745*^9, 3.4608657627915583`*^9}, {
   3.460865888638105*^9, 3.460865895896729*^9}, 3.460865937576189*^9, {
   3.460865987678075*^9, 3.460866000022244*^9}, 3.460866039071653*^9, 
   3.460866078288553*^9, 3.4608661727274227`*^9, {3.46086620527229*^9, 
   3.4608662286114283`*^9}, {3.460866591783491*^9, 3.460866605728109*^9}, {
   3.460884097643346*^9, 3.460884163155167*^9}, 3.460884256662903*^9, {
   3.460884582123115*^9, 3.4608846116249857`*^9}, 3.4608846679279823`*^9, {
   3.4608848296710052`*^9, 3.460884896153452*^9}, {3.460888708395012*^9, 
   3.460888733025832*^9}, 3.460888856973765*^9, 3.460889348450428*^9, 
   3.460889410038197*^9, 3.4608899257122517`*^9, 3.460890038266615*^9, {
   3.460890116133047*^9, 3.460890159630308*^9}, 3.460890191415696*^9, {
   3.460890270481584*^9, 3.460890308143527*^9}, {3.460890431748641*^9, 
   3.46089045135244*^9}, {3.460890488240271*^9, 3.460890504344252*^9}, {
   3.460890552097582*^9, 3.460890588805337*^9}, 3.46089091061549*^9, {
   3.460890958035729*^9, 3.460890970194047*^9}, 3.460891182861326*^9}],

Cell[BoxData[
 RowBox[{"-", "2.692943136058435`"}]], "Output",
 CellChangeTimes->{
  3.4606944285880413`*^9, 3.460694710821148*^9, 3.460694813752266*^9, 
   3.4606948686565523`*^9, 3.460694908824984*^9, 3.460694943743373*^9, {
   3.4606955286647463`*^9, 3.460695539377111*^9}, {3.4606959743468847`*^9, 
   3.460696046934908*^9}, 3.460696164888945*^9, {3.46069624289347*^9, 
   3.460696254104011*^9}, 3.46069664856536*^9, 3.4606978773565187`*^9, 
   3.460698003355398*^9, 3.460698428704109*^9, 3.460699017700994*^9, 
   3.460699198261404*^9, {3.4606992404204206`*^9, 3.460699250004673*^9}, {
   3.460699420002788*^9, 3.460699448542591*^9}, {3.460699551492279*^9, 
   3.4606995760372458`*^9}, 3.460699628821332*^9, {3.4606997766246853`*^9, 
   3.46069979233737*^9}, 3.460699846509027*^9, 3.460699991426691*^9, 
   3.460700120962723*^9, 3.460700150978692*^9, 3.460700290202798*^9, 
   3.460700350015143*^9, 3.460700640543497*^9, 3.46070113823307*^9, 
   3.460701477583243*^9, 3.460701669557947*^9, 3.4607028883471003`*^9, 
   3.460703284824523*^9, 3.460703470343832*^9, {3.460703818260503*^9, 
   3.460703838762457*^9}, {3.4607039225852947`*^9, 3.460703937086619*^9}, 
   3.460704031751749*^9, 3.460704109348311*^9, 3.460704324286234*^9, {
   3.460704404777562*^9, 3.460704452506097*^9}, {3.460704497969942*^9, 
   3.460704519204072*^9}, {3.460704630407476*^9, 3.460704648938583*^9}, {
   3.460704757832714*^9, 3.4607047786437263`*^9}, 3.4607049542830973`*^9, 
   3.460705036891027*^9, {3.460705128472733*^9, 3.460705175152998*^9}, 
   3.4607052156065817`*^9, {3.460705274511199*^9, 3.460705286201747*^9}, {
   3.460705328482711*^9, 3.460705339258251*^9}, 3.4607054367225018`*^9, {
   3.460712600408203*^9, 3.4607126147571*^9}, 3.460713047908724*^9, {
   3.460713282554874*^9, 3.4607132945848017`*^9}, {3.460713835058514*^9, 
   3.4607138601197033`*^9}, 3.4607139026455917`*^9, {3.460713957091056*^9, 
   3.460713995382338*^9}, 3.460714037957024*^9, 3.460714131191308*^9, {
   3.460714181974341*^9, 3.4607142082382517`*^9}, 3.4607142884014807`*^9, 
   3.4607143205417843`*^9, 3.4607153449128113`*^9, 3.460715611660941*^9, 
   3.46071588650872*^9, 3.4607159221362133`*^9, 3.460716010350465*^9, {
   3.460716602744968*^9, 3.460716612368623*^9}, 3.4607166808947973`*^9, 
   3.460716728310671*^9, 3.4607179478075523`*^9, 3.460718153890011*^9, 
   3.460864853569865*^9, 3.460864944632353*^9, {3.4608650549224043`*^9, 
   3.4608651000694838`*^9}, 3.460865131533939*^9, 3.460865206868553*^9, 
   3.460865237994265*^9, {3.460865305414671*^9, 3.460865347127034*^9}, {
   3.4608653841410217`*^9, 3.460865394663265*^9}, 3.4608654436569023`*^9, 
   3.460865487559341*^9, 3.4608655245522413`*^9, 3.460865599731702*^9, 
   3.46086563194384*^9, {3.460865678567177*^9, 3.460865763215781*^9}, {
   3.4608658890662947`*^9, 3.460865896275236*^9}, 3.460865937973333*^9, {
   3.460865988090621*^9, 3.460866000404463*^9}, 3.460866039460979*^9, 
   3.460866078684072*^9, 3.460866173126914*^9, {3.460866205645241*^9, 
   3.460866228977401*^9}, {3.460866592131584*^9, 3.460866606116922*^9}, {
   3.460884097973241*^9, 3.4608841635609827`*^9}, 3.4608842571343107`*^9, {
   3.460884582522368*^9, 3.4608846120265217`*^9}, 3.4608846683227043`*^9, {
   3.460884830077977*^9, 3.46088489660178*^9}, {3.460888708916758*^9, 
   3.460888733443715*^9}, 3.460888857374319*^9, 3.460889348847591*^9, 
   3.46088941044028*^9, 3.460889926088251*^9, 3.460890038615594*^9, {
   3.4608901161774*^9, 3.460890159674868*^9}, 3.460890191459124*^9, {
   3.4608902705254993`*^9, 3.460890308461899*^9}, {3.460890431792459*^9, 
   3.460890451396481*^9}, {3.460890488285193*^9, 3.460890504385693*^9}, {
   3.460890552139698*^9, 3.4608905888481092`*^9}, 3.460890910715507*^9, {
   3.460890958146579*^9, 3.46089097024151*^9}, 3.460891182991596*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0, 0, 1], PointSize[0.03], Thickness[0.03], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQzfFRZOk9V+EDDFBgf6fSS8hPCM7/6bHmqWWEIJz/
aufNRsMUAThf6I/VkfWP+eD8G/+nR8ow8cL5ZYc2uOYrcx+4f23r/kR1U747
J/IOFblzHjDuaBBasHy34san0qFfctkP1Ew1/fZ51VI9xxUz849MYz3gJPHS
yq/8htmSbRay2w4yH1i4MN3SKuyYtVxWzM557xgPrOA7v9Ymv9Xu8eqMdaGy
DAeuvnng4Lf7ob3DyqLyjNl/9t+ewHWsvyTT4cwU3Wat/z/2M/btWHDSvtGh
ja1HZVXq1/0/oz4WKn5JceBjetm36NzH/dVvl+q3Odg4HFhZnLuo+M3+snW/
RXPPiTuUxMeLvPZ9un/KU9avFy4yOLxI+7nHKfzO/ofmp+Zd2/LZ/sbO2YZa
hmf2/54sViqW9MGeYR3jrvkTE+y7GRW+////3r6j+oP10rVn7O3bF6TWxr63
N6ub8yux8459rnx52qajr+0Djny9czvmqf0HlX658BlP7KXs3prFlLyxL5T8
6CH15Jr954TOJxePfrSfLqtjnTJ1r/0N2VbBSYFf7U+fD5WO3N1pX/wgonH5
3R/2E9YfyozMV7Wf8KExwjvrj704j/zKpK50O63/Sgbbv/+351xkOSmGXdB2
7m7JxUKHGR0WLl75sebkAas7OvPDX3QxOxx6mubw0f+D2c3r4kerglkdJq/n
vrFO/olB0auY2S9k2B3cKkTKN01eqs7ZWOIe+JzDoWn79iwu9w+SbsxuQlc3
cTncnWjl95pJkS391DTHqfU8DrD4nx+y03qLLx+c/ynU5PoqPgE4X8B0XYz/
dwQ/KHoO3+0HgnC+ypUz5kmnheD8a596tX5tE4bz01LME3cuFoHzLRNvLNo+
URTOf/P/tA5foxicz1Un++h6oTic/xCcniXg/D/g9C4J57uA84MUnA/JL9Jw
PgAFv0On
           "]]}}, {}}, {{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.01], Thickness[0.01], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQzfFRZOk9V+EDqtGOdxYu2mxjf6fSS8hP6MBU9+cz
fPU+2/z0WPPUMkLwgJdvwcSzYQa2r3bebDRMETjQwFZkdDo+w1boj9WR9Y/5
DhRpiEhxfp1ve+P/9EgZJt4DzqlaG+ZVXrItO7TBNV+Z+8DJPc63Jzxlsrtz
Iu9QkTvngSr+fR7JqoZ2G59Kh37JZT+QIN0+OW1NtJ3jipn5R6axHrinEnBo
zotmuyXbLGS3HWQ+MIXP77TH9JV2clkxO+e9YzyQe2TDzDeFZ+0er85YFyrL
cOBJY4aqdeI7O4eVReUZs//s3/pp2YYzajz2Z6boNmv9/7E/9a1V6Zoydfs2
th6VValf95fJmYfem+Noz8f0sm/RuY/7ue0nqvRcD7c/sLI4d1Hxm/1yRmG7
livm2pfEx4u89n26X05nn5WlSIP9i7Sfe5zC7+xf/ZZtWwPPBPsbO2cbahme
2S97X37fpz9z7BnWMe6aPzHBvjdprtqGzcvtO6o/WC9de8a+iWVX69XejfZm
dXN+JXbesZd4c959Q/92+4AjX+/cjnlqP6HvvabMqj32UnZvzWJK3tirVrPe
rZu73/5zQueTi0c/2ktB+TdkWwUnBX6Fqy9+ENG4/O4PexGoeRM+NEZ4Z/2x
r4Tap/VfyWD79//2XVD3zN0tuVjoMKODFNS9d3Tmh7/oYnZYDvXPzeviR6uC
WR0Uof4tehUz+4UMuwMsPDgbS9wDn3M4sEDDy43ZTejqJi6Hamh4pp+a5ji1
nschHRre80N2Wm/x5XPYDI2PT6Em11fxCTg8hsaXgOm6GP/vAg7Z0PgMip7D
d/uBoMMkaHyrXDljnnRayOExND1c+9Sr9WubsEO2FCS9pKWYJ+5cLOIgxQdJ
T5aJNxZtnyjqcACa3t78P63D1yjm4ApNj1x1so+uF4o7lEDT60NwepZwqIOm
5z/g9C7p4ANN7y7g/CDlMAeaHyD5RdrhfRQkvwAAOTmIjg==
           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{2}, {1}},
      PlotRange->{{-3, 3}, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {193.5, -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.03], Thickness[0.03], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQzfFRZOk9V+EDqtGOdxYu2mxjf6fSS8hP6MBU9+cz
fPU+2/z0WPPUMkLwgJdvwcSzYQa2r3bebDRMETjQwFZkdDo+w1boj9WR9Y/5
DhRpiEhxfp1ve+P/9EgZJt4DzqlaG+ZVXrItO7TBNV+Z+8DJPc63Jzxlsrtz
Iu9QkTvngSr+fR7JqoZ2G59Kh37JZT+QIN0+OW1NtJ3jipn5R6axHrinEnBo
zotmuyXbLGS3HWQ+MIXP77TH9JV2clkxO+e9YzyQe2TDzDeFZ+0er85YFyrL
cOBJY4aqdeI7O4eVReUZs//s3/pp2YYzajz2Z6boNmv9/7E/9a1V6Zoydfs2
th6VValf95fJmYfem+Noz8f0sm/RuY/7ue0nqvRcD7c/sLI4d1Hxm/1yRmG7
livm2pfEx4u89n26X05nn5WlSIP9i7Sfe5zC7+xf/ZZtWwPPBPsbO2cbahme
2S97X37fpz9z7BnWMe6aPzHBvjdprtqGzcvtO6o/WC9de8a+iWVX69XejfZm
dXN+JXbesZd4c959Q/92+4AjX+/cjnlqP6HvvabMqj32UnZvzWJK3tirVrPe
rZu73/5zQueTi0c/2ktB+TdkWwUnBX6Fqy9+ENG4/O4PexGoeRM+NEZ4Z/2x
r4Tap/VfyWD79//2XVD3zN0tuVjoMKODFNS9d3Tmh7/oYnZYDvXPzeviR6uC
WR0Uof4tehUz+4UMuwMsPDgbS9wDn3M4sEDDy43ZTejqJi6Hamh4pp+a5ji1
nschHRre80N2Wm/x5XPYDI2PT6Em11fxCTg8hsaXgOm6GP/vAg7Z0PgMip7D
d/uBoMMkaHyrXDljnnRayOExND1c+9Sr9WubsEO2FCS9pKWYJ+5cLOIgxQdJ
T5aJNxZtnyjqcACa3t78P63D1yjm4ApNj1x1so+uF4o7lEDT60NwepZwqIOm
5z/g9C7p4ANN7y7g/CDlMAeaHyD5RdrhfRQkvwAAOTmIjg==
           "]]}}, {}}, {{}, 
        {RGBColor[1, 0, 0], PointSize[0.02], Thickness[0.02], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQzfFRZOk9V+EDDFBgf6fSS8hPCM7/6bHmqWWEIJz/
aufNRsMUAThf6I/VkfWP+eD8G/+nR8ow8cL5ZYc2uOYrcx+oE13YuVn3Is+d
E3mHitw5Dzzaz5P0VKlYYeNT6dAvuewHmKTCJVwFKnQdV8zMPzKN9YBeJt+C
uP4jpku2WchuO8h8YErx4ukeF09ZyWXF7Jz3jvHAgu97+/PjF9o+Xp2xLlSW
4cA6noPbmKKF7B1WFpVnzP6zn339PJmUu+vtz0zRbdb6/2P/3B5ziV17b9i3
sfWorEr9uv8Zp7T4heAL9nxML/sWnfu435v/Q77ypm32B1YW5y4qfrO/IIx/
peyORfYl8fEir32f7n9hGHGKacYM+xdpP/c4hd/ZH/N1t7xH2Uz7GztnG2oZ
ntl/4tSNjvUnFtozrGPcNX9igv2jKdKz4w+utu+o/mC9dO0Z+2NKjg+c1m2x
N6ub8yux84698JPgP7F1u+wDjny9czvmqX2ZVOo/U77d9lJ2b81iSt7Yx91Y
kfd962b7zwmdTy4e/Whfy835/emp+fY3ZFsFJwV+ta94xOnDm1dgX/wgonH5
3R/2CZnTnn36zmc/4UNjhHfWH/trF+wsdAOD7LT+Kxls//7fvrNrn2Wrzm+b
ubslFwsdZnSYdW15T5nqKqs7OvPDX3QxO1xcN42tauZ1s5vXxY9WBbM6/DlW
x3dg10mDolcxs1/IsDu8Sze7NM+gXZ2zscQ98DmHg+N74Wix76cl3ZjdhK5u
4nJ4c8v05Urjb6zpp6Y5Tq3ncYDF//yQndZbfPng/E+hJtdX8QnA+QKm62L8
vyP4QdFz+G4/EITzVa6cMU86LQTnX/vUq/VrmzCcn5ZinrhzsQicb5l4Y9H2
iaJw/pv/p3X4GsXgfK462UfXC8Xh/Ifg9CwB5/8Bp3dJON8FnB+k4HxIfpGG
8wFcG0I/
           "]]}}, {}}, {{}, 
        {RGBColor[1, 1, 0], PointSize[0.015], Thickness[0.015], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJwBUQOu/CFib1JlAgAAADQAAAACAAAACPEUpd5FE8Cowq/7hqHBPT/ceUoS
ThLALvapg59J5j35SKzlOVgRwHD68SakQAo+6rnZgTFkEMB8R1V3oOAsPhL8
OsSv4w7A//0tCza5TT7Y/5dZHAINwFgq8s84rmw+dsKwRW8jC8Cfwz+xhvyJ
PtzIbsJyRwnAtJx3jqAkpj6x5RtV9G0HwHgFuTjjxME+QaiZb8SWBcBSNsfx
JeTaPqS2OB22wQPAlYWSn6Q18z4ealy5nu4BwLMxpzqp7wk/46torlUdAMDk
GNa1G5AgP0Cpcndom/y/b0Zx4FgHND/MlC2DKv/4v+K1AjUL80Y/hgaMJKpl
9b9d+A7/VO9YPw4C6Y6izvG/M3MtNOu0aT/AqXNtonPsvzg7sjl2KXk/dF9f
FOtN5b8wmTAgN2WHP+hm+bxCV9y/itkWD1GslD/YuZsxKjHMv0DAxBw2XqE/
AK4Bup+RYD8SNc6iX8GrP4h78Dulrcw/bT0WpGkZtT82fpz6YYncP44DC1TX
hr4/UMT13Ntc5T824cPZ3QTFPxo+7TZcdOw/HmHrgeWNyz/zYInk0cXxP6LN
LmXZMdE/2B2FEZJR9T/FoVkqoW7UP3PgWIGn3fg/0XOOeMUd1z+Q8IFYS2r8
P4uvUwlC5tg/Kv8iMLf3/z829KrHQYjZP527GaMSwwFAPPJFuaPr2D/cLJ9X
6IoDQFqvl0HSJdc/2dcXxXpTBUC9a0JE/nTUP3LqXJvoHAdA0MrYKTIy0T8J
gXRHUecIQB9J9poJfcs/RgNGEtWyCkCQLtmsvuHEP2fKlkGVfwxAqNH9aNgj
vj+fVLk7tE0OQAwfCPk5p7Q/8lU016oOEEBdX4K3JdyqPxA1rlxP9xBAxvk+
vzmQoD9SW5wO2+ARQH+8oQWnW5M/JNTMN2LLEkBtmf3vAWyFP9byjSr6thNA
PzWpSwttdj9mZDdhuaMUQP2ETcQEMGY/OWHYoreRFUBtDmkwM7lUP+z/yywO
gRZA/4dzy0FAQj8Kfh3i13EXQJNWC1SpRS4/4bnZgTFkGEBbpcejZJsXP/xI
rOU5WBlAGxkmjHJIAT9E3HlKEk4aQObNKANZt+c+CPEUpd5FG0DdLJMPtXDO
Pq63kAc=
           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{2}, None},
      PlotRange->{{-3, 3}, {0, 0.7978829288255216}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {580.5, -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk41Pv/h8cMjaWypcgWWSplCcmYmfe3RShRklPJ3kJpU1EnpJxChOyN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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk0lXsfhvdgCEc7kgYyZBMpQ9mIen6PY6ZEkSYZUknUydTRkQwVIqUk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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc71vsfx+/hvu+QPTtChEIqHY6sz+uTEkoOIp2ELyUqVDKOkoYkkXmM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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk41Pv/h8cMjaWypcgWWSplCcmYmfe3RShRklPJ3kJpU1EnpJxChOyN
nZlSROjYRj6D7JMl+75H9n1ffud/Xf8Hr+u+7qf3o5eM7T2T63gcDkf/b/9H
JODUtblJZPmUjkn8NCQesCTRUh8UEVnuYnz0YG0fpTW7Ivf+f4gsT6eYEAZt
/uDRbCHpMh4iS7rHJFvbOkjlq0Wmlb/wFhZPJVdE3fSU+m9J24mv6wQWUbow
k2F4mjRJeW5ugwiselW7rLOetaQli6hywRcEli/yyB/WPKPDG9OU4MRJYOnK
SkcutCmQhQtm+feW4llfsOfSVqbeZIkuAbd6LzyrXLz9wzmvPrLCxqERTwM8
qxqnleIepkFRkTrzlwYfnrUsa6TchntB4b7gmiJZzcF6aa9S9njXD0qP1xcO
4jsO1qLwpOPEIzw1J7/LbOoCB6vAlW24rZREDZzmT2ndycEyEeNfvSx9j2qv
cIyjuBXHciOJGdy+GU3FzJ3MUqJwLJq+5O35vlKqaGBicqgVjqXflNsWyxyn
Tv1owD2XxbEI+y0yHM8LgO25m2mPWZuIefhyBY6gBv075S3GdTaRfLXxkbSR
s3Cts4/3evYGUvpUZSXndgN+J8bldBzeQBNWt8dTTrmB/S3LG6ap6+jtUIeq
ZWYgjKhK7GDvX0fXC31V/vTHgeNia+EJxhq68jByJjQqFca/h99j7llDSv7T
/OniufBox8AFPsYqSlp8o21vUQQrt1SPmu9fRVMM9St2nBXgUegqkfxlBeVo
ZEQ2z9bAFtEK3KraCrrYfUTb6lg9+N0VGTydtYzUnlsPkbmbQKjEpoJGWkbR
MQ4pHoItECGe+mWkYAk96N2ZakJuBSmnlXekE0voUuPF9gevWsFZPuGpyvdF
9DHkwabZZAv8bDGwkdNaRJwSXi05tGaQ85vWF0tfQCFbrXdLFDWCK7xX3a60
gBqV6QR6TD00zGCiBMY8Cn5Izli2rgOlD8Obi1LzyFaTe0nqajW8vBw4NBYx
h0BzKiuTUgltW4/W9ArNoZbobU3JnqVQ+4fopR8wi8zJ9B94g2IoKW2mpvHN
IqzMY8jXlQV5iR8XRLxnkOTDw45UtXz46uGS6so5gxbe+/G5KebABwu9G/0e
0yhY7KPCs5JvEEXaJXV6fQqJx1dIWs6lQ9CuocavT6fQ/XZeBTwlDbb/uSOu
MjaJzKcH2nKtkwFffGApZWECZfh3lxXYJcFi1FDDAY4JRD0e6l8/yIAxZ3p6
Et84Eg4Zxxp/JULPORt/hZ1jSIbtdL1LLAEaDkjdpu8ZRS+bf431psRBOWe7
nqzSCLryTRj8cLGQ3xUuF6f5B31ocwjdKhIN6TmmHFLYMDpaydGT7xUJ+obl
A4OaQ+hQso1bqQYNurt1yr8o/UYvscbcOY334PwwLfmxzCCylg1uOeoeAduI
ewMouwZQ6PgbRhV3BNBpYU5c2/rRJ2OJ9pLqcNBR5jX7ie9DAvp2guyqcPhV
6KYdutSDSoKunq9c+88/92nndXSj1zqv+5hWESAkxNn+ebQTsU3lIg8MR4DJ
U3nXyJV25K6WAyW09xDUc0rSj6cNyVQcDUpwoUG9nn2Bq2gLohtyb2o8j4Qd
aT5WdxSbUNmKfJJGRhSY7kzGWR5pQGtli40+gjEQ4saON9L9hYKbErW1YmKh
YWD8OJjWIrl/wivj/+u1e9DKYKKVjRRMBO2Ko+LBFzew1ZKvAkk9CebhoCfA
mrh97U9yCeJswIRpRYlwV2ssmHK3ECmxfdoTluiAGD2pV4CJbj0xJyzrfoCE
jmFNUkImshkIr9H6/BHi9g/yD8a+Qwa9/hJG3z7Dmp/uSnaTP7yxs5hUdU0B
I3ORV0Y6ScCn7pg0fykVshjbK/QS8+FT+2VTU9l06Dq3b8vWh0XA33cqYUA+
A/qMKhQfhZRCUuXcXbGDmTBymu/2yeZqSPKT6L6s+S9cGxB3nL9UB/uK4/gD
ZLLAdG9Ggv6peojgi+wM4sqGk7b6rZHqjfBWfV3kVVc2aMR38U/uaQbsQvrc
/U85INfz6NTx7a1Qmyvwx8wuF3ZI87mFrrbB+Yu2HUd48oDTMj5zeLgD6k7e
7dgdkQezUVojOk1dkCoWJi67jQnGGl993Jx74KmAlVLYbSbI0U5Kdb7oBeKD
CZoCgwkrmy0Z5Ld98M/qZGBnFhNqrt/Ri4rohzmz6J59MUygV3F0rCYOQJzX
RN7kJSb8rRZ23zxtEH6XW7p/HswD4/ADXMy837AvKrnB9UQeyK0XvN9dOgQC
BfiV80658J2f4B/GHgbx4IXgbU9ywExW76VQ/R9QdW68h7uQDZMavs7+rSMg
dKHj1DhXFnjr1dzi7RkF26BFk6yQbyBzRdjq9e8xiFt4oHWLMxPyHP+6gB8f
h5vUPveT5ukw+q5bZ2V5ElTcsCTP3GSgHPfstXWZgg8B0Tabd5LgFXMno3x6
CiYcfv2xVWPAT43P9sqO05BU1+nYLJQAIqmUgyG/p4FwRjLU+VgMWCjWTS5b
z8BwCH93dk0EMOKuZVq1z4DqCHen/WAwjIstOZdcnIWzVRPfRfcGgGawL0mp
dhYkA81fe+d4QUpa8cqo6RyotJ+c9BJ5AbLs1byU1jmQT6/TnU53gffD6s/u
WM5DKmu6evH1PRDgctRR7p+H5WcWLiTea/Bahr46cXMBfvybv+hIvgTrlA5m
2tgCOM6/ritlnYFHV3a43n+wCHfSq256T1FgxNmQrLawCCFglal6QhmuEhZK
xJyW4Ej+8jgiSkF1QKwxfmIJ3ogoFqh18wEmYdA64rAMDi9dbj4VWKJmJM3Y
1g8uQ/pInK+PVj9VTjNqjGmzAueMTNS6jrCpYYW6zvTOFYB3C/bfRzKo3EaT
m36XV8FXPk/RDB9O/bstwudx4yoYRPa8e6X+lCrOO8Sfa74GZMmJiwY1F6n5
2ppha71r4GArUsZvqUq96uApgdmvA53NkBwU5KKuR9QleE6sQ5fkcRejjSZK
TLn0/rJHG6AiUzvAxjMo1KU7abyrG/DZf7M2MP8epVsxX9PoxSb4fRzNEn2j
TmEpcXWVE3DYyz4dV7bpLLlQWTQ3XReHNcmbjPVyfSUXqSmF0Lxw2PeoYn/V
nmvkHxrUe54VOGzdh+3twCNCLtE6f9qRjwPzLYryiJdm6ZSSrslfPMuBme4J
4zd+YqtTTnHBUQM4sBwSp9VBvk1S5YnoLH5hPCbaHl9qjt9Dqtiwd/Y7h8cu
/XVGwsI6Wbs8V+MIjz8eM5bo6jf8qKpdqsL+F89DwKK4ArtvOO85WiS++m1+
g4BRdXwTcV1+mo89Rhl6O7ZgI8+quN82mh1yN1lLKTi/BZOKrZF3WBE/6C23
7ZtmwBZM6OvA9uK+mgO0cuWivbxEbDo7aO0w17piIg0qaHpELLjR++3fgY8V
UhzP1Qq+ImL2j2KOxVa3ymVRbZq9i4gYY+bQgtyo4t7//4uYk8390XA3a5n/
AYkrIco=
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk0lXsfhvdgCEc7kgYyZBMpQ9mIen6PY6ZEkSYZUknUydTRkQwVIqUk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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc71vsfx+/hvu+QPTtChEIqHY6sz+uTEkoOIp2ELyUqVDKOkoYkkXmM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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk41Pv/h8cMjaWypcgWWSplCcmYmfe3RShRklPJ3kJpU1EnpJxChOyN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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk0lXsfhvdgCEc7kgYyZBMpQ9mIen6PY6ZEkSYZUknUydTRkQwVIqUk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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc71vsfx+/hvu+QPTtChEIqHY6sz+uTEkoOIp2ELyUqVDKOkoYkkXmM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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk41Pv/h8cMjaWypcgWWSplCcmYmfe3RShRklPJ3kJpU1EnpJxChOyN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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk0lXsfhvdgCEc7kgYyZBMpQ9mIen6PY6ZEkSYZUknUydTRkQwVIqUk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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc71vsfx+/hvu+QPTtChEIqHY6sz+uTEkoOIp2ELyUqVDKOkoYkkXmM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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk41Pv/h8cMjaWypcgWWSplCcmYmfe3RShRklPJ3kJpU1EnpJxChOyN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          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk0lXsfhvdgCEc7kgYyZBMpQ9mIen6PY6ZEkSYZUknUydTRkQwVIqUk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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlvc71vsfx+/hvu+QPTtChEIqHY6sz+uTEkoOIp2ELyUqVDKOkoYkkXmM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          "]]}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      Frame->True,
      GridLines->{{2, 0, 1}, None},
      PlotRange->{{-3, 3}, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {967.5, -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}]}, {}},
  ContentSelectable->True,
  ImageSize->{621., Automatic},
  PlotRangePadding->{6, 5}]], "Print",
 CellChangeTimes->{
  3.46070451917115*^9, {3.4607046303750753`*^9, 3.460704648904955*^9}, {
   3.4607047577968493`*^9, 3.46070477859319*^9}, 3.460704954247167*^9, 
   3.4607050368531113`*^9, {3.460705128436154*^9, 3.460705175118433*^9}, 
   3.460705215569192*^9, {3.460705274472828*^9, 3.460705286163951*^9}, {
   3.460705328448756*^9, 3.460705339224861*^9}, 3.460705436687511*^9, {
   3.460712600376568*^9, 3.4607126147235003`*^9}, 3.460713047876918*^9, {
   3.460713282521329*^9, 3.460713294551167*^9}, {3.460713834968994*^9, 
   3.460713860036693*^9}, 3.460713902558764*^9, {3.460713957325048*^9, 
   3.460713995695146*^9}, 3.460714037951282*^9, 3.460714131146854*^9, {
   3.460714181968012*^9, 3.460714208204916*^9}, 3.460714288368878*^9, 
   3.460714320506762*^9, 3.460715344636594*^9, 3.4607156113978767`*^9, 
   3.460715886246475*^9, 3.460715921874712*^9, 3.460716010317369*^9, {
   3.460716602712977*^9, 3.460716612332562*^9}, 3.4607166808613367`*^9, 
   3.460716728278655*^9, 3.460717947774094*^9, 3.4607181538085213`*^9, 
   3.460864852779917*^9, 3.4608649440956497`*^9, {3.460865054515229*^9, 
   3.4608650996454573`*^9}, 3.460865131062428*^9, 3.4608652063886013`*^9, 
   3.4608652375708027`*^9, {3.460865304978962*^9, 3.46086534669381*^9}, {
   3.460865383703322*^9, 3.4608653942322607`*^9}, 3.460865443237199*^9, 
   3.460865487147558*^9, 3.460865524133155*^9, 3.460865599301724*^9, 
   3.460865631528137*^9, {3.460865678064745*^9, 3.4608657627915583`*^9}, {
   3.460865888638105*^9, 3.460865895896729*^9}, 3.460865937576189*^9, {
   3.460865987678075*^9, 3.460866000022244*^9}, 3.460866039071653*^9, 
   3.460866078288553*^9, 3.4608661727274227`*^9, {3.46086620527229*^9, 
   3.4608662286114283`*^9}, {3.460866591783491*^9, 3.460866605728109*^9}, {
   3.460884097643346*^9, 3.460884163155167*^9}, 3.460884256662903*^9, {
   3.460884582123115*^9, 3.4608846116249857`*^9}, 3.4608846679279823`*^9, {
   3.4608848296710052`*^9, 3.460884896153452*^9}, {3.460888708395012*^9, 
   3.460888733025832*^9}, 3.460888856973765*^9, 3.460889348450428*^9, 
   3.460889410038197*^9, 3.4608899257122517`*^9, 3.460890038266615*^9, {
   3.460890116133047*^9, 3.460890159630308*^9}, 3.460890191415696*^9, {
   3.460890270481584*^9, 3.460890308143527*^9}, {3.460890431748641*^9, 
   3.46089045135244*^9}, {3.460890488240271*^9, 3.460890504344252*^9}, {
   3.460890552097582*^9, 3.460890588805337*^9}, 3.46089091061549*^9, {
   3.460890958035729*^9, 3.460890970194047*^9}, 3.460891183424302*^9}],

Cell[BoxData[
 RowBox[{"-", "2.69286286687119`"}]], "Output",
 CellChangeTimes->{
  3.4606944285880413`*^9, 3.460694710821148*^9, 3.460694813752266*^9, 
   3.4606948686565523`*^9, 3.460694908824984*^9, 3.460694943743373*^9, {
   3.4606955286647463`*^9, 3.460695539377111*^9}, {3.4606959743468847`*^9, 
   3.460696046934908*^9}, 3.460696164888945*^9, {3.46069624289347*^9, 
   3.460696254104011*^9}, 3.46069664856536*^9, 3.4606978773565187`*^9, 
   3.460698003355398*^9, 3.460698428704109*^9, 3.460699017700994*^9, 
   3.460699198261404*^9, {3.4606992404204206`*^9, 3.460699250004673*^9}, {
   3.460699420002788*^9, 3.460699448542591*^9}, {3.460699551492279*^9, 
   3.4606995760372458`*^9}, 3.460699628821332*^9, {3.4606997766246853`*^9, 
   3.46069979233737*^9}, 3.460699846509027*^9, 3.460699991426691*^9, 
   3.460700120962723*^9, 3.460700150978692*^9, 3.460700290202798*^9, 
   3.460700350015143*^9, 3.460700640543497*^9, 3.46070113823307*^9, 
   3.460701477583243*^9, 3.460701669557947*^9, 3.4607028883471003`*^9, 
   3.460703284824523*^9, 3.460703470343832*^9, {3.460703818260503*^9, 
   3.460703838762457*^9}, {3.4607039225852947`*^9, 3.460703937086619*^9}, 
   3.460704031751749*^9, 3.460704109348311*^9, 3.460704324286234*^9, {
   3.460704404777562*^9, 3.460704452506097*^9}, {3.460704497969942*^9, 
   3.460704519204072*^9}, {3.460704630407476*^9, 3.460704648938583*^9}, {
   3.460704757832714*^9, 3.4607047786437263`*^9}, 3.4607049542830973`*^9, 
   3.460705036891027*^9, {3.460705128472733*^9, 3.460705175152998*^9}, 
   3.4607052156065817`*^9, {3.460705274511199*^9, 3.460705286201747*^9}, {
   3.460705328482711*^9, 3.460705339258251*^9}, 3.4607054367225018`*^9, {
   3.460712600408203*^9, 3.4607126147571*^9}, 3.460713047908724*^9, {
   3.460713282554874*^9, 3.4607132945848017`*^9}, {3.460713835058514*^9, 
   3.4607138601197033`*^9}, 3.4607139026455917`*^9, {3.460713957091056*^9, 
   3.460713995382338*^9}, 3.460714037957024*^9, 3.460714131191308*^9, {
   3.460714181974341*^9, 3.4607142082382517`*^9}, 3.4607142884014807`*^9, 
   3.4607143205417843`*^9, 3.4607153449128113`*^9, 3.460715611660941*^9, 
   3.46071588650872*^9, 3.4607159221362133`*^9, 3.460716010350465*^9, {
   3.460716602744968*^9, 3.460716612368623*^9}, 3.4607166808947973`*^9, 
   3.460716728310671*^9, 3.4607179478075523`*^9, 3.460718153890011*^9, 
   3.460864853569865*^9, 3.460864944632353*^9, {3.4608650549224043`*^9, 
   3.4608651000694838`*^9}, 3.460865131533939*^9, 3.460865206868553*^9, 
   3.460865237994265*^9, {3.460865305414671*^9, 3.460865347127034*^9}, {
   3.4608653841410217`*^9, 3.460865394663265*^9}, 3.4608654436569023`*^9, 
   3.460865487559341*^9, 3.4608655245522413`*^9, 3.460865599731702*^9, 
   3.46086563194384*^9, {3.460865678567177*^9, 3.460865763215781*^9}, {
   3.4608658890662947`*^9, 3.460865896275236*^9}, 3.460865937973333*^9, {
   3.460865988090621*^9, 3.460866000404463*^9}, 3.460866039460979*^9, 
   3.460866078684072*^9, 3.460866173126914*^9, {3.460866205645241*^9, 
   3.460866228977401*^9}, {3.460866592131584*^9, 3.460866606116922*^9}, {
   3.460884097973241*^9, 3.4608841635609827`*^9}, 3.4608842571343107`*^9, {
   3.460884582522368*^9, 3.4608846120265217`*^9}, 3.4608846683227043`*^9, {
   3.460884830077977*^9, 3.46088489660178*^9}, {3.460888708916758*^9, 
   3.460888733443715*^9}, 3.460888857374319*^9, 3.460889348847591*^9, 
   3.46088941044028*^9, 3.460889926088251*^9, 3.460890038615594*^9, {
   3.4608901161774*^9, 3.460890159674868*^9}, 3.460890191459124*^9, {
   3.4608902705254993`*^9, 3.460890308461899*^9}, {3.460890431792459*^9, 
   3.460890451396481*^9}, {3.460890488285193*^9, 3.460890504385693*^9}, {
   3.460890552139698*^9, 3.4608905888481092`*^9}, 3.460890910715507*^9, {
   3.460890958146579*^9, 3.46089097024151*^9}, 3.460891183545394*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"pp", "=", "0"}], ";", 
   RowBox[{"IndividualLikNonlin", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Y1", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
     RowBox[{"{", 
      RowBox[{"IdioNonlin", ",", 
       RowBox[{"{", "}"}], ",", "m", ",", 
       RowBox[{"eps", "=", 
        RowBox[{"10.", "^", 
         RowBox[{"-", "12"}]}]}], ",", 
       RowBox[{"ksigma", "=", "Infinity"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Singular", "=", "False"}], ",", 
       RowBox[{"2", "Pi"}], " ", ",", "0", ",", 
       RowBox[{"onlyNorKorr", "=", "1"}], ",", "\"\<NorKorr\>\""}], "}"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.460264864897327*^9, 3.460264932378791*^9}, {
   3.460265489300803*^9, 3.460265492492799*^9}, {3.46027038606568*^9, 
   3.460270391802556*^9}, {3.4602704971596107`*^9, 3.4602705817118692`*^9}, {
   3.46027367414145*^9, 3.460273674236417*^9}, {3.460279775378045*^9, 
   3.4602797754444103`*^9}, {3.4602799530257587`*^9, 
   3.4602799533811693`*^9}, {3.460280067013379*^9, 3.460280067130088*^9}, {
   3.4602801040742397`*^9, 3.460280104129944*^9}, {3.4602801453821163`*^9, 
   3.4602801673531218`*^9}, {3.46028174693688*^9, 3.460281763776168*^9}, {
   3.4602818356559362`*^9, 3.460281835739462*^9}, {3.460281898670804*^9, 
   3.460281898732609*^9}, {3.460282025318959*^9, 3.460282025741701*^9}, {
   3.460282062175247*^9, 3.460282071535883*^9}, {3.460283778391947*^9, 
   3.4602837888805027`*^9}, {3.4602838305963707`*^9, 3.460283854615387*^9}, {
   3.46028477341341*^9, 3.460284779157151*^9}, {3.460285035206752*^9, 
   3.460285046973556*^9}, {3.46028555906642*^9, 3.460285574425418*^9}, {
   3.4602857519094887`*^9, 3.4602857519715776`*^9}, {3.460285881590439*^9, 
   3.4602858816380377`*^9}, {3.460286117999454*^9, 3.460286123654068*^9}, {
   3.4602863340289307`*^9, 3.4602863377475977`*^9}, {3.4603641927287188`*^9, 
   3.460364197580667*^9}, {3.460365058304535*^9, 3.4603650587979116`*^9}, {
   3.460365091217347*^9, 3.460365126318194*^9}, {3.4603652464521227`*^9, 
   3.460365260029804*^9}, {3.460365412299954*^9, 3.460365434375272*^9}, {
   3.460365485584791*^9, 3.460365520950554*^9}, {3.460366663535665*^9, 
   3.460366678997499*^9}, {3.4603667867732773`*^9, 3.4603667868283587`*^9}, {
   3.460367092714067*^9, 3.460367098883337*^9}, {3.460369235357655*^9, 
   3.460369263924768*^9}, {3.460369362646221*^9, 3.46036936313859*^9}, {
   3.46036946785526*^9, 3.4603694691077127`*^9}, {3.46037339069245*^9, 
   3.460373390747698*^9}, {3.460373605599341*^9, 3.4603736056503153`*^9}, {
   3.460377091108459*^9, 3.460377126962656*^9}, {3.460377288435691*^9, 
   3.460377301095058*^9}, {3.4603774697122087`*^9, 3.460377479788327*^9}, {
   3.460377585320611*^9, 3.460377603716568*^9}, {3.4603776957101793`*^9, 
   3.460377736561165*^9}, {3.460377923292104*^9, 3.4603779233524303`*^9}, {
   3.460378105932313*^9, 3.46037817981962*^9}, {3.460427531315346*^9, 
   3.460427537420005*^9}, {3.460427638978484*^9, 3.4604276390230217`*^9}, {
   3.4604277414332314`*^9, 3.460427769573126*^9}, {3.4604279604982853`*^9, 
   3.460427960554902*^9}, {3.460430680071252*^9, 3.460430680172152*^9}, {
   3.460430712203142*^9, 3.460430712557424*^9}, {3.460430775931464*^9, 
   3.460430776020101*^9}, {3.460430814349124*^9, 3.460430814950081*^9}, {
   3.46043100067663*^9, 3.460431000775926*^9}, {3.460431035518139*^9, 
   3.460431043615539*^9}, {3.460431139283386*^9, 3.460431139330926*^9}, {
   3.4604311987514153`*^9, 3.460431233744923*^9}, {3.460431314274002*^9, 
   3.460431314321568*^9}, {3.4604316727142878`*^9, 3.4604316728008432`*^9}, {
   3.460431886035831*^9, 3.46043189177104*^9}, {3.460432099991972*^9, 
   3.460432100073539*^9}, {3.460432236204804*^9, 3.4604322362468243`*^9}, {
   3.4604323376555843`*^9, 3.460432357162323*^9}, {3.460432403219545*^9, 
   3.460432403269651*^9}, {3.460432564446265*^9, 3.4604325911495867`*^9}, {
   3.460432813689516*^9, 3.460432813733564*^9}, {3.460432944239506*^9, 
   3.460432989199974*^9}, {3.460433097024789*^9, 3.460433097139295*^9}, {
   3.460433291653358*^9, 3.46043329173923*^9}, {3.460433672964451*^9, 
   3.460433673010107*^9}, {3.460433845665332*^9, 3.4604338457416363`*^9}, {
   3.4604344009903316`*^9, 3.460434401033557*^9}, {3.4604346235115023`*^9, 
   3.460434638473834*^9}, {3.460434675871023*^9, 3.460434675925946*^9}, {
   3.4604350413113747`*^9, 3.4604350414069347`*^9}, {3.460436666989565*^9, 
   3.460436677468376*^9}, {3.460437023691847*^9, 3.460437023772811*^9}, {
   3.460437179838045*^9, 3.460437214787621*^9}, {3.4604373750456057`*^9, 
   3.460437375101828*^9}, {3.460437455923118*^9, 3.4604374559862347`*^9}, {
   3.460437643282413*^9, 3.4604376433404827`*^9}, {3.460439284564681*^9, 
   3.46043929340877*^9}, {3.460439393566842*^9, 3.460439393962884*^9}, {
   3.46044000098571*^9, 3.460440001044331*^9}, {3.460443930270521*^9, 
   3.460443930334333*^9}, {3.460443966799687*^9, 3.46044399790462*^9}, {
   3.460444060284606*^9, 3.460444061730588*^9}, {3.460444101336812*^9, 
   3.46044410138903*^9}, {3.460444186536171*^9, 3.460444194286351*^9}, {
   3.460444233408099*^9, 3.460444248920389*^9}, {3.460444338058318*^9, 
   3.460444355662019*^9}, {3.460444400012597*^9, 3.460444431012135*^9}, {
   3.460444591036777*^9, 3.4604446631572647`*^9}, {3.46044479971354*^9, 
   3.460444799768903*^9}, {3.460444831583193*^9, 3.460444859781989*^9}, {
   3.46044502143334*^9, 3.460445021504759*^9}, {3.460459950502769*^9, 
   3.460459971711813*^9}, {3.460460068419449*^9, 3.460460088588605*^9}, {
   3.460460154598343*^9, 3.46046015516997*^9}, {3.460460281436612*^9, 
   3.460460281521656*^9}, {3.4604604120265713`*^9, 3.460460412125514*^9}, {
   3.4604607607833633`*^9, 3.4604607621971283`*^9}, {3.460460826677142*^9, 
   3.460460827186878*^9}, {3.4604608962826014`*^9, 3.4604608963501987`*^9}, {
   3.460460962965583*^9, 3.460460963358262*^9}, {3.46046100555375*^9, 
   3.4604610220017967`*^9}, {3.46046105589403*^9, 3.460461056004932*^9}, {
   3.460461154113535*^9, 3.460461154227416*^9}, {3.460461800671767*^9, 
   3.4604618154025*^9}, {3.46046184541817*^9, 3.46046186011173*^9}, {
   3.460461896620476*^9, 3.460461896672694*^9}, {3.460461952952413*^9, 
   3.4604619533933907`*^9}, {3.460462913572587*^9, 3.460462920740217*^9}, {
   3.460548175219633*^9, 3.460548179294363*^9}, {3.460548260239588*^9, 
   3.460548260297719*^9}, {3.460548333262265*^9, 3.460548333779482*^9}, {
   3.460548675566861*^9, 3.460548693804049*^9}, {3.460548972449188*^9, 
   3.4605491929429903`*^9}, {3.460549257251377*^9, 3.460549267901092*^9}, {
   3.4605496024993763`*^9, 3.4605496337333307`*^9}, {3.460549667762332*^9, 
   3.46054966825324*^9}, {3.460607544492757*^9, 3.460607557468165*^9}, {
   3.460607591423718*^9, 3.460607615734179*^9}, {3.4606076546131697`*^9, 
   3.460607711208377*^9}, {3.460607950300333*^9, 3.460607950788868*^9}, {
   3.460608254691515*^9, 3.460608332544549*^9}, {3.460608365633368*^9, 
   3.4606083656943207`*^9}, {3.460608434510606*^9, 3.460608528562172*^9}, {
   3.460608559009796*^9, 3.460608584467407*^9}, {3.460608755712895*^9, 
   3.4606087818086443`*^9}, {3.460608915820417*^9, 3.46060895109648*^9}, {
   3.4606090353514013`*^9, 3.460609089338924*^9}, {3.460619799153166*^9, 
   3.4606198362306223`*^9}, 3.460619905423987*^9, {3.460621024814104*^9, 
   3.460621075759169*^9}, {3.460621192179472*^9, 3.4606212134045153`*^9}, {
   3.4606214203824053`*^9, 3.460621428920328*^9}, {3.4606215045280933`*^9, 
   3.460621505423924*^9}, {3.460621613387906*^9, 3.460621638578682*^9}, {
   3.460621694074709*^9, 3.460621703411603*^9}, {3.4606217660430403`*^9, 
   3.460621767329904*^9}, {3.460621806996888*^9, 3.4606218076980343`*^9}, {
   3.460621883288566*^9, 3.46062188333815*^9}, {3.460621970939987*^9, 
   3.4606219893319883`*^9}, {3.460622107014687*^9, 3.460622107100986*^9}, {
   3.460622297972288*^9, 3.460622306665023*^9}, {3.460622338760532*^9, 
   3.460622398767516*^9}, {3.460622676496147*^9, 3.4606226765399942`*^9}, {
   3.4606227120282917`*^9, 3.460622766881015*^9}, {3.4606229263578787`*^9, 
   3.460622944163636*^9}, {3.4606229791390038`*^9, 3.460622982600178*^9}, {
   3.4606230423052397`*^9, 3.460623049675028*^9}, {3.4606231523155127`*^9, 
   3.460623159744812*^9}, {3.460623194195408*^9, 3.460623258120954*^9}, {
   3.460687849143656*^9, 3.460687889401013*^9}, {3.460690081391994*^9, 
   3.460690099337471*^9}, {3.460690130038103*^9, 3.46069013008521*^9}, 
   3.4606902754485703`*^9, {3.4606937256675873`*^9, 3.460693732963479*^9}, {
   3.46069380256997*^9, 3.460693821921266*^9}, {3.460694110007152*^9, 
   3.460694111753396*^9}, {3.46069438482207*^9, 3.460694412630849*^9}, {
   3.460700373473871*^9, 3.46070038225313*^9}, {3.460700651313466*^9, 
   3.460700661253717*^9}, {3.460888878230307*^9, 3.460888934701251*^9}, {
   3.460888985458818*^9, 3.460888985528965*^9}, 3.460889017477508*^9, {
   3.460889075042487*^9, 3.460889076981966*^9}, {3.46088929895837*^9, 
   3.460889299290349*^9}}],

Cell[BoxData[
 RowBox[{"-", "2.299704345348462`"}]], "Output",
 CellChangeTimes->{{3.460888884820653*^9, 3.460888935898259*^9}, 
   3.460888987025817*^9, 3.460889017894083*^9, {3.460889072159395*^9, 
   3.460889078345962*^9}, {3.460889294360515*^9, 3.460889300116984*^9}, 
   3.460890179590364*^9, 3.4608909800518913`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IndividualLik", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Y", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"Idio", ",", 
     RowBox[{"{", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.460264864897327*^9, 3.460264932378791*^9}, {
   3.460265489300803*^9, 3.460265492492799*^9}, {3.46027038606568*^9, 
   3.460270391802556*^9}, {3.4602704971596107`*^9, 3.4602705817118692`*^9}, {
   3.46027367414145*^9, 3.460273674236417*^9}, {3.460279775378045*^9, 
   3.4602797754444103`*^9}, {3.4602799530257587`*^9, 
   3.4602799533811693`*^9}, {3.460280067013379*^9, 3.460280067130088*^9}, {
   3.4602801040742397`*^9, 3.460280104129944*^9}, {3.4602801453821163`*^9, 
   3.4602801673531218`*^9}, {3.46028174693688*^9, 3.460281763776168*^9}, {
   3.4602818356559362`*^9, 3.460281835739462*^9}, {3.460281898670804*^9, 
   3.460281898732609*^9}, {3.460282025318959*^9, 3.460282025741701*^9}, {
   3.460282062175247*^9, 3.460282071535883*^9}, {3.460283778391947*^9, 
   3.4602837888805027`*^9}, {3.4602838305963707`*^9, 3.460283854615387*^9}, {
   3.46028477341341*^9, 3.460284779157151*^9}, {3.460285035206752*^9, 
   3.460285046973556*^9}, {3.46028555906642*^9, 3.460285574425418*^9}, {
   3.4602857519094887`*^9, 3.4602857519715776`*^9}, {3.460285881590439*^9, 
   3.4602858816380377`*^9}, {3.460286117999454*^9, 3.460286123654068*^9}, {
   3.4602863340289307`*^9, 3.4602863377475977`*^9}, {3.4603641927287188`*^9, 
   3.460364197580667*^9}, {3.460365058304535*^9, 3.4603650587979116`*^9}, {
   3.460365091217347*^9, 3.460365126318194*^9}, {3.4603652464521227`*^9, 
   3.460365260029804*^9}, {3.460365412299954*^9, 3.460365434375272*^9}, {
   3.460365485584791*^9, 3.460365520950554*^9}, {3.460366663535665*^9, 
   3.460366678997499*^9}, {3.4603667867732773`*^9, 3.4603667868283587`*^9}, {
   3.460367092714067*^9, 3.460367098883337*^9}, {3.460369235357655*^9, 
   3.460369263924768*^9}, {3.460369362646221*^9, 3.46036936313859*^9}, {
   3.46036946785526*^9, 3.4603694691077127`*^9}, {3.46037339069245*^9, 
   3.460373390747698*^9}, {3.460373605599341*^9, 3.4603736056503153`*^9}, {
   3.460377091108459*^9, 3.460377126962656*^9}, {3.460377288435691*^9, 
   3.460377301095058*^9}, {3.4603774697122087`*^9, 3.460377479788327*^9}, {
   3.460377585320611*^9, 3.460377603716568*^9}, {3.4603776957101793`*^9, 
   3.460377736561165*^9}, {3.460377923292104*^9, 3.4603779233524303`*^9}, {
   3.460378105932313*^9, 3.46037817981962*^9}, {3.460427531315346*^9, 
   3.460427537420005*^9}, {3.460427638978484*^9, 3.4604276390230217`*^9}, {
   3.4604277414332314`*^9, 3.460427769573126*^9}, {3.4604279604982853`*^9, 
   3.460427960554902*^9}, {3.460430680071252*^9, 3.460430680172152*^9}, {
   3.460430712203142*^9, 3.460430712557424*^9}, {3.460430775931464*^9, 
   3.460430776020101*^9}, {3.460430814349124*^9, 3.460430814950081*^9}, {
   3.46043100067663*^9, 3.460431000775926*^9}, {3.460431035518139*^9, 
   3.460431043615539*^9}, {3.460431139283386*^9, 3.460431139330926*^9}, {
   3.4604311987514153`*^9, 3.460431233744923*^9}, {3.460431314274002*^9, 
   3.460431314321568*^9}, {3.4604316727142878`*^9, 3.4604316728008432`*^9}, {
   3.460431886035831*^9, 3.46043189177104*^9}, {3.460432099991972*^9, 
   3.460432100073539*^9}, {3.460432236204804*^9, 3.4604322362468243`*^9}, {
   3.4604323376555843`*^9, 3.460432357162323*^9}, {3.460432403219545*^9, 
   3.460432403269651*^9}, {3.460432564446265*^9, 3.4604325911495867`*^9}, {
   3.460432813689516*^9, 3.460432813733564*^9}, {3.460432944239506*^9, 
   3.460432989199974*^9}, {3.460433097024789*^9, 3.460433097139295*^9}, {
   3.460433291653358*^9, 3.46043329173923*^9}, {3.460433672964451*^9, 
   3.460433673010107*^9}, {3.460433845665332*^9, 3.4604338457416363`*^9}, {
   3.4604344009903316`*^9, 3.460434401033557*^9}, {3.4604346235115023`*^9, 
   3.460434638473834*^9}, {3.460434675871023*^9, 3.460434675925946*^9}, {
   3.4604350413113747`*^9, 3.4604350414069347`*^9}, {3.460436666989565*^9, 
   3.460436677468376*^9}, {3.460437023691847*^9, 3.460437023772811*^9}, {
   3.460437179838045*^9, 3.460437214787621*^9}, {3.4604373750456057`*^9, 
   3.460437375101828*^9}, {3.460437455923118*^9, 3.4604374559862347`*^9}, {
   3.460437643282413*^9, 3.4604376433404827`*^9}, {3.460439284564681*^9, 
   3.46043929340877*^9}, {3.460439393566842*^9, 3.460439393962884*^9}, {
   3.46044000098571*^9, 3.460440001044331*^9}, {3.460443930270521*^9, 
   3.460443930334333*^9}, {3.460443966799687*^9, 3.46044399790462*^9}, {
   3.460444060284606*^9, 3.460444061730588*^9}, {3.460444101336812*^9, 
   3.46044410138903*^9}, {3.460444186536171*^9, 3.460444194286351*^9}, {
   3.460444233408099*^9, 3.460444248920389*^9}, {3.460444338058318*^9, 
   3.460444355662019*^9}, {3.460444400012597*^9, 3.460444431012135*^9}, {
   3.460444591036777*^9, 3.4604446631572647`*^9}, {3.46044479971354*^9, 
   3.460444799768903*^9}, {3.460444831583193*^9, 3.460444859781989*^9}, {
   3.46044502143334*^9, 3.460445021504759*^9}, {3.460459950502769*^9, 
   3.460459971711813*^9}, {3.460460068419449*^9, 3.460460088588605*^9}, {
   3.460460154598343*^9, 3.46046015516997*^9}, {3.460460281436612*^9, 
   3.460460281521656*^9}, {3.4604604120265713`*^9, 3.460460412125514*^9}, {
   3.4604607607833633`*^9, 3.4604607621971283`*^9}, {3.460460826677142*^9, 
   3.460460827186878*^9}, {3.4604608962826014`*^9, 3.4604608963501987`*^9}, {
   3.460460962965583*^9, 3.460460963358262*^9}, {3.46046100555375*^9, 
   3.4604610220017967`*^9}, {3.46046105589403*^9, 3.460461056004932*^9}, {
   3.460461154113535*^9, 3.460461154227416*^9}, {3.460461800671767*^9, 
   3.4604618154025*^9}, {3.46046184541817*^9, 3.46046186011173*^9}, {
   3.460461896620476*^9, 3.460461896672694*^9}, {3.460461952952413*^9, 
   3.4604619533933907`*^9}, {3.460462913572587*^9, 3.460462920740217*^9}, {
   3.460548175219633*^9, 3.460548179294363*^9}, {3.460548260239588*^9, 
   3.460548260297719*^9}, {3.460548333262265*^9, 3.460548333779482*^9}, {
   3.460548675566861*^9, 3.460548693804049*^9}, {3.460548972449188*^9, 
   3.4605491929429903`*^9}, {3.460549257251377*^9, 3.460549267901092*^9}, {
   3.4605496024993763`*^9, 3.4605496337333307`*^9}, {3.460549667762332*^9, 
   3.46054966825324*^9}, {3.460607544492757*^9, 3.460607557468165*^9}, {
   3.460607591423718*^9, 3.460607615734179*^9}, {3.4606076546131697`*^9, 
   3.460607711208377*^9}, {3.460607950300333*^9, 3.460607950788868*^9}, {
   3.460608254691515*^9, 3.460608332544549*^9}, {3.460608365633368*^9, 
   3.4606083656943207`*^9}, {3.460608434510606*^9, 3.460608528562172*^9}, {
   3.460608559009796*^9, 3.460608584467407*^9}, {3.460608755712895*^9, 
   3.4606087818086443`*^9}, {3.460608915820417*^9, 3.46060895109648*^9}, {
   3.4606090353514013`*^9, 3.460609089338924*^9}, {3.460619799153166*^9, 
   3.4606198362306223`*^9}, 3.460619905423987*^9, {3.460621024814104*^9, 
   3.460621075759169*^9}, {3.460621192179472*^9, 3.4606212134045153`*^9}, {
   3.4606214203824053`*^9, 3.460621428920328*^9}, {3.4606215045280933`*^9, 
   3.460621505423924*^9}, {3.460621613387906*^9, 3.460621638578682*^9}, {
   3.460621694074709*^9, 3.460621703411603*^9}, {3.4606217660430403`*^9, 
   3.460621767329904*^9}, {3.460621806996888*^9, 3.4606218076980343`*^9}, {
   3.460621883288566*^9, 3.46062188333815*^9}, {3.460621970939987*^9, 
   3.4606219893319883`*^9}, {3.460622107014687*^9, 3.460622107100986*^9}, {
   3.460622297972288*^9, 3.460622306665023*^9}, {3.460622338760532*^9, 
   3.460622398767516*^9}, {3.460622676496147*^9, 3.4606226765399942`*^9}, {
   3.4606227120282917`*^9, 3.460622766881015*^9}, {3.4606229263578787`*^9, 
   3.460622944163636*^9}, {3.4606229791390038`*^9, 3.460622982600178*^9}, {
   3.4606230423052397`*^9, 3.460623049675028*^9}, {3.4606231523155127`*^9, 
   3.460623159744812*^9}, {3.460623194195408*^9, 3.460623258120954*^9}, {
   3.460687849143656*^9, 3.460687889401013*^9}, {3.460690081391994*^9, 
   3.460690099337471*^9}, {3.460690130038103*^9, 3.46069013008521*^9}, 
   3.4606902754485703`*^9, {3.4606937256675873`*^9, 3.460693732963479*^9}, {
   3.46069380256997*^9, 3.460693821921266*^9}, {3.460694110007152*^9, 
   3.460694111753396*^9}, {3.46069438482207*^9, 3.460694412630849*^9}, {
   3.460700373473871*^9, 3.46070038225313*^9}, {3.460700651313466*^9, 
   3.460700661253717*^9}, 3.460888878230307*^9, {3.460890989143062*^9, 
   3.460890989350485*^9}}],

Cell[BoxData[
 RowBox[{"-", "1.4208207308371343`"}]], "Output",
 CellChangeTimes->{
  3.460699071134611*^9, 3.460700383202607*^9, 3.46070066241743*^9, 
   3.460701489362689*^9, 3.460702904308734*^9, 3.460712642396553*^9, 
   3.460716687888165*^9, 3.460718166989811*^9, 3.4608887391818447`*^9, 
   3.460888849886539*^9, 3.460888880867415*^9, 3.460889307315928*^9, {
   3.460890984961978*^9, 3.460890990686756*^9}}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Y1", "=", 
   RowBox[{"{", 
    RowBox[{"{", "2", "}"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"l0", " ", "=", " ", 
   RowBox[{
    RowBox[{"IndividualLikNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Y1", ",", " ", "X", ",", " ", 
        RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
      RowBox[{"{", 
       RowBox[{"IdioNonlin", ",", " ", 
        RowBox[{"{", "}"}], ",", " ", "#1", ",", " ", 
        RowBox[{"eps", " ", "=", " ", 
         RowBox[{"1", "/", 
          RowBox[{"10.", "^", "16"}]}]}], ",", " ", 
        RowBox[{"ksigma", " ", "=", " ", "Infinity"}], ",", " ", "0"}], "}"}],
       ",", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
        RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
        RowBox[{"onlyNorKorr", " ", "=", " ", "0"}], ",", " ", 
        "\"\<NorKorr\>\"", ",", "0"}], "}"}]}], "]"}], " ", "&"}]}], " ", 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"l1", " ", "=", " ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y1", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", " ", "#1", ",", " ", 
         RowBox[{"eps", " ", "=", " ", 
          RowBox[{"1", "/", 
           RowBox[{"10.", "^", "16"}]}]}], ",", " ", 
         RowBox[{"ksigma", " ", "=", " ", "Infinity"}], ",", " ", "0"}], 
        "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "0"}], ",", " ", 
         "\"\<StochLin\>\"", ",", "0"}], "}"}]}], "]"}], " ", "&"}]}], " ", 
   ";"}], " "}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"l2", " ", "=", " ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y1", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", " ", "#1", ",", " ", 
         RowBox[{"eps", " ", "=", " ", 
          RowBox[{"1", "/", 
           RowBox[{"10.", "^", "16"}]}]}], ",", " ", 
         RowBox[{"ksigma", " ", "=", " ", "Infinity"}], ",", " ", "0"}], 
        "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "0"}], ",", " ", "\"\<EKF\>\"",
          ",", "0"}], "}"}]}], "]"}], " ", "&"}]}], " ", ";"}], " ", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"l0lin", " ", "=", " ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y1", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", " ", "#1", ",", " ", 
         RowBox[{"eps", " ", "=", " ", 
          RowBox[{"1", "/", 
           RowBox[{"10.", "^", "16"}]}]}], ",", " ", 
         RowBox[{"ksigma", " ", "=", " ", "Infinity"}], ",", " ", "0"}], 
        "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "1"}], ",", " ", 
         "\"\<NorKorr\>\""}], "}"}]}], "]"}], " ", "&"}]}], " ", ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"l1lin", " ", "=", " ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y1", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", " ", "#1", ",", " ", 
         RowBox[{"eps", " ", "=", " ", 
          RowBox[{"1", "/", 
           RowBox[{"10.", "^", "16"}]}]}], ",", " ", 
         RowBox[{"ksigma", " ", "=", " ", "Infinity"}], ",", " ", "0"}], 
        "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "1"}], ",", " ", 
         "\"\<StochLin\>\""}], "}"}]}], "]"}], " ", "&"}]}], " ", ";"}], 
  " "}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"l2lin", " ", "=", "  ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y1", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", " ", "#1", ",", " ", 
         RowBox[{"eps", " ", "=", " ", 
          RowBox[{"1", "/", 
           RowBox[{"10.", "^", "16"}]}]}], ",", " ", 
         RowBox[{"ksigma", " ", "=", " ", "Infinity"}], ",", " ", "0"}], 
        "}"}], ",", "   ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "1"}], ",", " ", 
         "\"\<EKF\>\""}], "}"}]}], "]"}], " ", "&"}]}], " ", ";"}], 
  " "}]}], "Input",
 CellChangeTimes->{{3.460866690417755*^9, 3.4608666908088093`*^9}, {
  3.46086676290909*^9, 3.4608667899620447`*^9}, {3.460866822738378*^9, 
  3.460866870907132*^9}, {3.460866934606393*^9, 3.460867079046795*^9}, {
  3.460867138617878*^9, 3.460867138676441*^9}, {3.460867208773748*^9, 
  3.4608672094046373`*^9}, {3.460867252883388*^9, 3.460867347526499*^9}, {
  3.460867394413104*^9, 3.460867395652351*^9}, {3.460887846023217*^9, 
  3.460887849741935*^9}, {3.4608897367048473`*^9, 3.4608897379260893`*^9}, {
  3.460889769763714*^9, 3.460889769844699*^9}, {3.460890600335511*^9, 
  3.4608906004235477`*^9}, {3.4608910734617443`*^9, 3.4608910735476513`*^9}, {
  3.460891226283064*^9, 3.460891226366171*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pp", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"l0", "[", "10", "]"}], "\[IndentingNewLine]", 
 RowBox[{"l1", "[", "10", "]"}], "\[IndentingNewLine]", 
 RowBox[{"l2", "[", "10", "]"}], "\[IndentingNewLine]", 
 RowBox[{"l2lin", "[", "10", "]"}]}], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGCQAGIQfXqi0tNvx1867lh0Hkz//6H0CkTvez33LYg+xDbh
B4hOYpgEps0WlaZ/B9Kmh7rAdIyI0U/5Ey8dz/DEg2mXswayh4B0ursxmE77
HKYDomWUz4DpK8sn2IDohNOTbEG08BzHOBCtqWSXAKL3eTytA9F7LT7Wg2jm
pSGTQbTCzslgmkHGezaIzqrKA9Mrl6SsBNFnpketAtHdXLKWp4H0j0QnKxDd
ccbAEURPMhF3BfOfXFotdxJoz+IrYHrHHLmTINqlXgNMz9ZZdA5EZxguAdNf
foZeAdHXBOqvgeiinI9fQfSm66zfQPSUeYv+g+iDqwwY5YH0L/WKTBAt4NAB
pnm7DP6DaJFDmowKQHqC8QN9EB1tmmsAogGj29d/
  "]],

Cell[BoxData[
 RowBox[{"-", "2.483429528553369`"}]], "Output",
 CellChangeTimes->{
  3.4602821586290083`*^9, {3.460282194672504*^9, 3.460282221034252*^9}, {
   3.460282304124085*^9, 3.4602823096094847`*^9}, 3.460282367700007*^9, 
   3.4602826444891653`*^9, {3.460283191195128*^9, 3.460283196443349*^9}, 
   3.460283538479665*^9, 3.4602841996563187`*^9, 3.460284409519916*^9, 
   3.460364431619211*^9, {3.4603662767860107`*^9, 3.460366326918507*^9}, 
   3.460367142375352*^9, 3.460369509450536*^9, 3.460435649149485*^9, 
   3.460439471087428*^9, 3.460440271569412*^9, 3.460548292309108*^9, {
   3.4606980666425333`*^9, 3.460698116411084*^9}, 3.460698199230464*^9, {
   3.460698342895336*^9, 3.460698347089931*^9}, 3.460698387658757*^9, {
   3.460698464476142*^9, 3.460698471121516*^9}, {3.4606985974210863`*^9, 
   3.460698605644109*^9}, 3.4606986715579033`*^9, {3.4606988664647093`*^9, 
   3.460698885285829*^9}, 3.4606989539947653`*^9, 3.460699091679224*^9, {
   3.460699128326627*^9, 3.460699136744446*^9}, {3.4606992844926853`*^9, 
   3.4606992930867147`*^9}, 3.4606993563387203`*^9, 3.460699395066133*^9, {
   3.46069946832483*^9, 3.460699475642068*^9}, 3.460700396741952*^9, 
   3.460700670871602*^9, 3.4607014955117397`*^9, 3.460701686286664*^9, 
   3.4607029778271503`*^9, 3.4607045343296432`*^9, 3.460704583786036*^9, 
   3.460705006337816*^9, 3.460712648456737*^9, 3.4607130758606462`*^9, 
   3.460713922767914*^9, 3.460714216772244*^9, 3.460714335040298*^9, 
   3.460715094807499*^9, {3.460715236127408*^9, 3.4607152417533503`*^9}, 
   3.460715272166308*^9, 3.460715931802145*^9, 3.460715996563827*^9, 
   3.460716286449524*^9, 3.460716577625821*^9, 3.46071669162184*^9, {
   3.46071681976187*^9, 3.460716834028303*^9}, {3.4607170060678062`*^9, 
   3.460717100708589*^9}, 3.460717933975918*^9, 3.460718170891859*^9, 
   3.460866634064*^9, 3.460866671610235*^9, 3.460866712097299*^9, {
   3.460866771793648*^9, 3.460866793641797*^9}, 3.4608668370874767`*^9, 
   3.4608671410558577`*^9, 3.4608672137641582`*^9, 3.460867399901455*^9, 
   3.4608878519656687`*^9, {3.460887896605866*^9, 3.4608879047948008`*^9}, 
   3.460888055897314*^9, {3.4608881256499443`*^9, 3.460888139371533*^9}, {
   3.4608881769852877`*^9, 3.4608881823439074`*^9}, {3.4608882281854486`*^9, 
   3.4608882453075047`*^9}, 3.460888325464295*^9, 3.460888416931632*^9, 
   3.460888497637518*^9, {3.4608885739449387`*^9, 3.46088858640056*^9}, 
   3.460888622838238*^9, 3.460889420873407*^9, 3.4608897416678677`*^9, 
   3.460889773343731*^9, {3.46089060421344*^9, 3.460890633917891*^9}, 
   3.4608910124379396`*^9, 3.4608910764416237`*^9, 3.4608912009203243`*^9, 
   3.460891231222142*^9}],

Cell[BoxData[
 RowBox[{"-", "2.6633998394926754`"}]], "Output",
 CellChangeTimes->{
  3.4602821586290083`*^9, {3.460282194672504*^9, 3.460282221034252*^9}, {
   3.460282304124085*^9, 3.4602823096094847`*^9}, 3.460282367700007*^9, 
   3.4602826444891653`*^9, {3.460283191195128*^9, 3.460283196443349*^9}, 
   3.460283538479665*^9, 3.4602841996563187`*^9, 3.460284409519916*^9, 
   3.460364431619211*^9, {3.4603662767860107`*^9, 3.460366326918507*^9}, 
   3.460367142375352*^9, 3.460369509450536*^9, 3.460435649149485*^9, 
   3.460439471087428*^9, 3.460440271569412*^9, 3.460548292309108*^9, {
   3.4606980666425333`*^9, 3.460698116411084*^9}, 3.460698199230464*^9, {
   3.460698342895336*^9, 3.460698347089931*^9}, 3.460698387658757*^9, {
   3.460698464476142*^9, 3.460698471121516*^9}, {3.4606985974210863`*^9, 
   3.460698605644109*^9}, 3.4606986715579033`*^9, {3.4606988664647093`*^9, 
   3.460698885285829*^9}, 3.4606989539947653`*^9, 3.460699091679224*^9, {
   3.460699128326627*^9, 3.460699136744446*^9}, {3.4606992844926853`*^9, 
   3.4606992930867147`*^9}, 3.4606993563387203`*^9, 3.460699395066133*^9, {
   3.46069946832483*^9, 3.460699475642068*^9}, 3.460700396741952*^9, 
   3.460700670871602*^9, 3.4607014955117397`*^9, 3.460701686286664*^9, 
   3.4607029778271503`*^9, 3.4607045343296432`*^9, 3.460704583786036*^9, 
   3.460705006337816*^9, 3.460712648456737*^9, 3.4607130758606462`*^9, 
   3.460713922767914*^9, 3.460714216772244*^9, 3.460714335040298*^9, 
   3.460715094807499*^9, {3.460715236127408*^9, 3.4607152417533503`*^9}, 
   3.460715272166308*^9, 3.460715931802145*^9, 3.460715996563827*^9, 
   3.460716286449524*^9, 3.460716577625821*^9, 3.46071669162184*^9, {
   3.46071681976187*^9, 3.460716834028303*^9}, {3.4607170060678062`*^9, 
   3.460717100708589*^9}, 3.460717933975918*^9, 3.460718170891859*^9, 
   3.460866634064*^9, 3.460866671610235*^9, 3.460866712097299*^9, {
   3.460866771793648*^9, 3.460866793641797*^9}, 3.4608668370874767`*^9, 
   3.4608671410558577`*^9, 3.4608672137641582`*^9, 3.460867399901455*^9, 
   3.4608878519656687`*^9, {3.460887896605866*^9, 3.4608879047948008`*^9}, 
   3.460888055897314*^9, {3.4608881256499443`*^9, 3.460888139371533*^9}, {
   3.4608881769852877`*^9, 3.4608881823439074`*^9}, {3.4608882281854486`*^9, 
   3.4608882453075047`*^9}, 3.460888325464295*^9, 3.460888416931632*^9, 
   3.460888497637518*^9, {3.4608885739449387`*^9, 3.46088858640056*^9}, 
   3.460888622838238*^9, 3.460889420873407*^9, 3.4608897416678677`*^9, 
   3.460889773343731*^9, {3.46089060421344*^9, 3.460890633917891*^9}, 
   3.4608910124379396`*^9, 3.4608910764416237`*^9, 3.4608912009203243`*^9, 
   3.460891231232634*^9}],

Cell[BoxData[
 RowBox[{"-", "2.475294388924284`"}]], "Output",
 CellChangeTimes->{
  3.4602821586290083`*^9, {3.460282194672504*^9, 3.460282221034252*^9}, {
   3.460282304124085*^9, 3.4602823096094847`*^9}, 3.460282367700007*^9, 
   3.4602826444891653`*^9, {3.460283191195128*^9, 3.460283196443349*^9}, 
   3.460283538479665*^9, 3.4602841996563187`*^9, 3.460284409519916*^9, 
   3.460364431619211*^9, {3.4603662767860107`*^9, 3.460366326918507*^9}, 
   3.460367142375352*^9, 3.460369509450536*^9, 3.460435649149485*^9, 
   3.460439471087428*^9, 3.460440271569412*^9, 3.460548292309108*^9, {
   3.4606980666425333`*^9, 3.460698116411084*^9}, 3.460698199230464*^9, {
   3.460698342895336*^9, 3.460698347089931*^9}, 3.460698387658757*^9, {
   3.460698464476142*^9, 3.460698471121516*^9}, {3.4606985974210863`*^9, 
   3.460698605644109*^9}, 3.4606986715579033`*^9, {3.4606988664647093`*^9, 
   3.460698885285829*^9}, 3.4606989539947653`*^9, 3.460699091679224*^9, {
   3.460699128326627*^9, 3.460699136744446*^9}, {3.4606992844926853`*^9, 
   3.4606992930867147`*^9}, 3.4606993563387203`*^9, 3.460699395066133*^9, {
   3.46069946832483*^9, 3.460699475642068*^9}, 3.460700396741952*^9, 
   3.460700670871602*^9, 3.4607014955117397`*^9, 3.460701686286664*^9, 
   3.4607029778271503`*^9, 3.4607045343296432`*^9, 3.460704583786036*^9, 
   3.460705006337816*^9, 3.460712648456737*^9, 3.4607130758606462`*^9, 
   3.460713922767914*^9, 3.460714216772244*^9, 3.460714335040298*^9, 
   3.460715094807499*^9, {3.460715236127408*^9, 3.4607152417533503`*^9}, 
   3.460715272166308*^9, 3.460715931802145*^9, 3.460715996563827*^9, 
   3.460716286449524*^9, 3.460716577625821*^9, 3.46071669162184*^9, {
   3.46071681976187*^9, 3.460716834028303*^9}, {3.4607170060678062`*^9, 
   3.460717100708589*^9}, 3.460717933975918*^9, 3.460718170891859*^9, 
   3.460866634064*^9, 3.460866671610235*^9, 3.460866712097299*^9, {
   3.460866771793648*^9, 3.460866793641797*^9}, 3.4608668370874767`*^9, 
   3.4608671410558577`*^9, 3.4608672137641582`*^9, 3.460867399901455*^9, 
   3.4608878519656687`*^9, {3.460887896605866*^9, 3.4608879047948008`*^9}, 
   3.460888055897314*^9, {3.4608881256499443`*^9, 3.460888139371533*^9}, {
   3.4608881769852877`*^9, 3.4608881823439074`*^9}, {3.4608882281854486`*^9, 
   3.4608882453075047`*^9}, 3.460888325464295*^9, 3.460888416931632*^9, 
   3.460888497637518*^9, {3.4608885739449387`*^9, 3.46088858640056*^9}, 
   3.460888622838238*^9, 3.460889420873407*^9, 3.4608897416678677`*^9, 
   3.460889773343731*^9, {3.46089060421344*^9, 3.460890633917891*^9}, 
   3.4608910124379396`*^9, 3.4608910764416237`*^9, 3.4608912009203243`*^9, 
   3.460891231238843*^9}],

Cell[BoxData[
 RowBox[{"-", "2.2655121234846454`"}]], "Output",
 CellChangeTimes->{
  3.4602821586290083`*^9, {3.460282194672504*^9, 3.460282221034252*^9}, {
   3.460282304124085*^9, 3.4602823096094847`*^9}, 3.460282367700007*^9, 
   3.4602826444891653`*^9, {3.460283191195128*^9, 3.460283196443349*^9}, 
   3.460283538479665*^9, 3.4602841996563187`*^9, 3.460284409519916*^9, 
   3.460364431619211*^9, {3.4603662767860107`*^9, 3.460366326918507*^9}, 
   3.460367142375352*^9, 3.460369509450536*^9, 3.460435649149485*^9, 
   3.460439471087428*^9, 3.460440271569412*^9, 3.460548292309108*^9, {
   3.4606980666425333`*^9, 3.460698116411084*^9}, 3.460698199230464*^9, {
   3.460698342895336*^9, 3.460698347089931*^9}, 3.460698387658757*^9, {
   3.460698464476142*^9, 3.460698471121516*^9}, {3.4606985974210863`*^9, 
   3.460698605644109*^9}, 3.4606986715579033`*^9, {3.4606988664647093`*^9, 
   3.460698885285829*^9}, 3.4606989539947653`*^9, 3.460699091679224*^9, {
   3.460699128326627*^9, 3.460699136744446*^9}, {3.4606992844926853`*^9, 
   3.4606992930867147`*^9}, 3.4606993563387203`*^9, 3.460699395066133*^9, {
   3.46069946832483*^9, 3.460699475642068*^9}, 3.460700396741952*^9, 
   3.460700670871602*^9, 3.4607014955117397`*^9, 3.460701686286664*^9, 
   3.4607029778271503`*^9, 3.4607045343296432`*^9, 3.460704583786036*^9, 
   3.460705006337816*^9, 3.460712648456737*^9, 3.4607130758606462`*^9, 
   3.460713922767914*^9, 3.460714216772244*^9, 3.460714335040298*^9, 
   3.460715094807499*^9, {3.460715236127408*^9, 3.4607152417533503`*^9}, 
   3.460715272166308*^9, 3.460715931802145*^9, 3.460715996563827*^9, 
   3.460716286449524*^9, 3.460716577625821*^9, 3.46071669162184*^9, {
   3.46071681976187*^9, 3.460716834028303*^9}, {3.4607170060678062`*^9, 
   3.460717100708589*^9}, 3.460717933975918*^9, 3.460718170891859*^9, 
   3.460866634064*^9, 3.460866671610235*^9, 3.460866712097299*^9, {
   3.460866771793648*^9, 3.460866793641797*^9}, 3.4608668370874767`*^9, 
   3.4608671410558577`*^9, 3.4608672137641582`*^9, 3.460867399901455*^9, 
   3.4608878519656687`*^9, {3.460887896605866*^9, 3.4608879047948008`*^9}, 
   3.460888055897314*^9, {3.4608881256499443`*^9, 3.460888139371533*^9}, {
   3.4608881769852877`*^9, 3.4608881823439074`*^9}, {3.4608882281854486`*^9, 
   3.4608882453075047`*^9}, 3.460888325464295*^9, 3.460888416931632*^9, 
   3.460888497637518*^9, {3.4608885739449387`*^9, 3.46088858640056*^9}, 
   3.460888622838238*^9, 3.460889420873407*^9, 3.4608897416678677`*^9, 
   3.460889773343731*^9, {3.46089060421344*^9, 3.460890633917891*^9}, 
   3.4608910124379396`*^9, 3.4608910764416237`*^9, 3.4608912009203243`*^9, 
   3.46089123124476*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"l0", "[", "mm", "]"}], ",", 
           RowBox[{"l1", "[", "mm", "]"}], ",", 
           RowBox[{"l2", "[", "mm", "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"mm", ",", "2", ",", 
           RowBox[{"M", "=", "100"}]}], "}"}]}], "]"}], "//", 
       RowBox[{
        RowBox[{"AddTimeAxis", "[", 
         RowBox[{"#", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "M", ",", "1"}], "}"}]}], "]"}], "&"}]}], "//", 
      RowBox[{
       RowBox[{"plot1", "[", 
        RowBox[{"#", ",", 
         RowBox[{"PlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}], "&"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"l0lin", "[", "mm", "]"}], ",", 
           RowBox[{"l1lin", "[", "mm", "]"}], ",", 
           RowBox[{"l2lin", "[", "mm", "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"mm", ",", "2", ",", 
           RowBox[{"M", "=", "20"}]}], "}"}]}], "]"}], "//", 
       RowBox[{
        RowBox[{"AddTimeAxis", "[", 
         RowBox[{"#", ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "M", ",", "1"}], "}"}]}], "]"}], "&"}]}], "//", 
      RowBox[{
       RowBox[{"plot1", "[", 
        RowBox[{"#", ",", 
         RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], "&"}]}]}], "}"}], "//",
    "GraphicsRow"}], "\[IndentingNewLine]", "\[IndentingNewLine]"}]], "Input",\

 CellChangeTimes->{{3.460281783177149*^9, 3.460281824576651*^9}, {
   3.460281910255617*^9, 3.460281943368555*^9}, {3.460281981836998*^9, 
   3.4602819975731277`*^9}, {3.4602820319744387`*^9, 3.460282053018779*^9}, {
   3.460282118996468*^9, 3.460282133562097*^9}, {3.460282239307322*^9, 
   3.460282241400333*^9}, {3.46028239420243*^9, 3.4602824371035967`*^9}, {
   3.460284414532241*^9, 3.4602844151683893`*^9}, {3.460284789442216*^9, 
   3.4602847924493017`*^9}, {3.4603644911795893`*^9, 3.460364500191489*^9}, {
   3.4603695897129087`*^9, 3.460369625240038*^9}, {3.460439520790577*^9, 
   3.46043953878603*^9}, {3.460439576047587*^9, 3.46043961923698*^9}, {
   3.460548309147976*^9, 3.4605483174968367`*^9}, {3.460698218433448*^9, 
   3.4606982189993668`*^9}, {3.46069831865662*^9, 3.46069832472578*^9}, {
   3.4606986846777077`*^9, 3.460698686195219*^9}, {3.460698801081359*^9, 
   3.460698839662919*^9}, 3.4606988983413677`*^9, {3.460699493303959*^9, 
   3.460699521539399*^9}, {3.460703038834033*^9, 3.4607030392870197`*^9}, {
   3.460704537168377*^9, 3.460704565215843*^9}, {3.460704964492584*^9, 
   3.4607049654824247`*^9}, {3.460716586378721*^9, 3.4607165874503813`*^9}, {
   3.460716698553081*^9, 3.460716698621357*^9}, {3.460716874013295*^9, 
   3.4607168854884872`*^9}, {3.460717105177659*^9, 3.460717118490457*^9}, {
   3.460717189751791*^9, 3.460717263423542*^9}, {3.460718184809017*^9, 
   3.460718184886208*^9}, {3.460718268047081*^9, 3.460718284726698*^9}, {
   3.460866726962734*^9, 3.460866746396637*^9}, {3.46086680842523*^9, 
   3.460866814009818*^9}, {3.4608669860584373`*^9, 3.460866986674747*^9}, {
   3.460867125303936*^9, 3.460867126893998*^9}, {3.460890639626153*^9, 
   3.460890679985465*^9}, {3.460891030288026*^9, 3.4608910439786158`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{{}, {}, 
        {RGBColor[0, 0, 1], PointSize[0.003], Thickness[0.003], 
         Dashing[{}], {}, 
         {Opacity[1], 
          LineBox[{{7.376421516548695, -2.625853084490999}, {
           8., -2.727435296746364}, {
           8.523970804839283, -2.7711019766913734`}}], 
          LineBox[{{13.386221160209775`, -2.7711019766913734`}, {
           14., -2.6369327751009752`}, {15., -2.6939708567765845`}, {
           16., -2.7423382331530926`}, {
           16.820690996154433`, -2.625853084490999}}], LineBox[CompressedData["
1:eJw90Q1MjHEcB/AnJJlEhPWqlGKXsXnp9e7bdb1f1710z9WVcDmvrSSVt3K5
iKvQCq2iJSsjlRRZxXmbNg0jmcRIjBhTW/Iu1u+57Xb77nPf5//8fn8nTbJc
O45hGOno99+vVu0aV2axDJUDlgHXTEyNzP/PcvAWLa8yZyaO5RXw9NOza1Xk
ntgdWmZ99wBlL8wrKDdpvkTZG4OzDDv/eFH2gWad3628Icq+uFHbsH6VPWU/
TPIwtJ7+Q5mP8Yn5e8vdKQtQOmXu7YjXlAGrdxkVW8VjWQe03yna7NBE7o8N
6W6WW3aQ+4Pf05gasp9ciEnpF+OMleRCNObrbWq05AGweYjNZ1vJA9CfuauJ
x5KLYC4QPjt7k1yElRWOxlLOA/HFTqLmtZEH4vFAIR5oyINgJsl0mH6OPAhq
+ZmENWnkweg2CcrtPkYejCsdnlOfc/sOgWTa/Uf1OeQhsAtapegrIQ+F+9Ec
l/sZ5KF4x+d1dZ8iD4M+u9MnNYU8DIssZoosq8nDIRV6xIo5D0ep2+vZ26rI
xYgpZX1/0vvqRrObeOmLcvIIhCwUFJZkkkfA/brL9eRicgk6nLuTnOk+dBKE
99qNzMwnj0SCb9W+NwXkkYgfShZ67yOXQs3LFTUVjWVIIZ7/NP6Cjv4vhajX
Yuov2p9RisWbDBtasqgvQ4upZEf7cerLYPPp3CvrPdSX4Rub8TWe68vwbPAl
X5BNfTn67XMtDNz5cvDfr76Qzd2HHFlvZy37cZj6cnTJ/V/N5+5PAXVNQ9Jq
mhcKSB39ggvzqK9A7fYT+4UHqa+Atl4zEnGI+lE42Vdt/p32hyi0z6nusD1C
/Sg0mGls6mhfxijUj/Qq35MzStxrNeSoyaHEQOCE4k6ur4RVSyV6uL4SHw60
3xmmeRgW51PqHg9x57NIchksq6H307GI/SHN0tK8Rhau9yYnONF9MiqYNmfm
fab5oIJ9zIKuCm5+FRJrcmzjKBtV2Ktf8lxmoH40Znz83ann9hcNeZqggKXn
6aKxUcwURNJ5xmi0XX3S2MbtPwYx2gnDl0f9L64ua0k=
           "]], 
          LineBox[{{4.280356776260829, -2.7711019766913734`}, {
           4.491156375030999, -2.625853084490999}}], 
          LineBox[{{5.395841743089081, -2.625853084490999}, {
           5.559827841224331, -2.7711019766913734`}}], 
          LineBox[{{6.653667575759962, -2.7711019766913734`}, {
           6.897191372277574, -2.625853084490999}}], 
          LineBox[{{9.121191620571144, -2.7711019766913734`}, {
           9.564911359443087, -2.625853084490999}}], 
          LineBox[{{10.32123757632432, -2.625853084490999}, {
           10.64884772330502, -2.7711019766913734`}}], 
          LineBox[{{11.385463783343983`, -2.7711019766913734`}, {
           11.745085107476106`, -2.625853084490999}}], 
          LineBox[{{12.309525502930416`, -2.625853084490999}, {
           12.746188775579597`, -2.7711019766913734`}}], 
          LineBox[{{17.124404481157963`, -2.625853084490999}, {
           17.834400421888002`, -2.7711019766913734`}}], 
          LineBox[{{18.155419393790112`, -2.7711019766913734`}, {
           18.821768547331267`, -2.625853084490999}}], 
          LineBox[{{19.180765666412515`, -2.625853084490999}, {
           19.856589416932913`, -2.7711019766913734`}}], 
          LineBox[{{20.16838844432009, -2.7711019766913734`}, {
           20.96192060596999, -2.625853084490999}}]}}}, {{}, {}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.003], Thickness[0.003], 
         Dashing[{}], {}, 
         {Opacity[1], 
          LineBox[{{10.957678948186755`, -2.6910760282725805`}, {
           11., -2.6922990742856157`}, {
           11.126344692557629`, -2.694498251081817}}], 
          LineBox[{{16.70959998196747, -2.694498251081817}, {
           17., -2.6912898902267104`}, {
           17.085293495798172`, -2.6910760282725805`}}], 
          LineBox[{{23.34877019584496, -2.694498251081817}, {
           24., -2.6922656855188123`}, {25., -2.6919779856589128`}, {
           25.840873699614473`, -2.694498251081817}}], LineBox[CompressedData["
1:eJxFkWtIU3EYxk/euojL0g+auPAyKz8omklq6TM3dW5Tt7OrkRCWGbIQCirU
bCAhmVlBWRObJVZShkFLhC5OTKwYJBmzLKxMxA9zKgWJaZbRef8HDoeH3/P7
n/c9J6q0ki/z4ThO8fdefRrqqwNKA/fi3ujBcb7e38n9uzLxpKiyILhJyFk4
e/PD6aZzQgZE631fNZz/n61Ax6YsmUPInBTHF62O70LfKkVzQnfNg0aBZ+OU
65jnIvFsPAq/MHOFuAye1/OPfRoELkPHxvQqD50vR1XtaPFz4nLcVo3FpBHP
QYB35b2B5svB1MSzrJdCn8tFYtDwcCvxXPAZ10Y7ieehc/7NeAvxPNSKpr0D
xBXwQl9RSVyBPM5b9pN4PppjfwVmEM+HY84StY3mU+Kk2N4dQlyJdyV14XLi
KowoZ1vXEFeh/EjDooq4GpfsS4d8iKvR9bmtkfkFeOuVqEXEC1Cd5EQq8UK4
BnriI4kXIjlUnr2deBGCzlRk7iBeBD/p4adi4hroJbVziUKGBpapG+4t1Nfg
hdulThKyU4NJ9+T1CPK1WAz1n0kgXwtE2EVbyddiaUPdRDz5WqTvl+6JIZ9H
YdfwTBz5PMqjIxyUrTzm/UvEseTzMO5aGWT76ZBpCnNFk69DpOdOGdtXh51R
+UPEnTp09Ph5ma+HRRHQQvNAj7CrxV/p/1r14JqX+tn79bB/quml+TgDfiTY
3BLyDVi22YYoWw0IkX2zUd9pwOWP7anEOSPup6QtsP2NCP79cC3zjbglaV1m
vhG9B0pimW/CQkrSEPNNCBsRW5hvQvJd3xPMN8FY0dvHfDOi+1wS5psxO7Z5
Hfv+ZsSlH52mvtOML/3tu9n+xagf3ze4yv8Aa9dIAg==
           "]], 
          LineBox[{{4.848175482729267, -2.694498251081817}, {
           4.855710269814162, -2.6910760282725805`}}], 
          LineBox[{{6.305916534872323, -2.6910760282725805`}, {
           6.367727935151059, -2.694498251081817}}], 
          LineBox[{{7.346978396862708, -2.694498251081817}, {
           7.380899270121088, -2.6910760282725805`}}], 
          LineBox[{{8.48099050637604, -2.6910760282725805`}, {
           8.507344243688635, -2.694498251081817}}], 
          LineBox[{{9.672900729342585, -2.694498251081817}, {
           9.708896348659659, -2.6910760282725805`}}], 
          LineBox[{{12.390104468151717`, -2.694498251081817}, {
           12.477894649266005`, -2.6910760282725805`}}], 
          LineBox[{{13.457058071795187`, -2.6910760282725805`}, {
           13.533910781399172`, -2.694498251081817}}], 
          LineBox[{{14.530196180890984`, -2.694498251081817}, {
           14.617619385498628`, -2.6910760282725805`}}], 
          LineBox[{{15.570653398000209`, -2.6910760282725805`}, {
           15.701121175082669`, -2.694498251081817}}], 
          LineBox[{{18.200592657918403`, -2.6910760282725805`}, {
           18.499904521549595`, -2.694498251081817}}], 
          LineBox[{{19.37843062000764, -2.694498251081817}, {
           19.604924917617705`, -2.6910760282725805`}}], 
          LineBox[{{20.40564464274868, -2.6910760282725805`}, {
           20.638198409198935`, -2.694498251081817}}], 
          LineBox[{{21.450462588817864`, -2.694498251081817}, {
           21.74000463157833, -2.6910760282725805`}}], 
          LineBox[{{22.399563615281796`, -2.6910760282725805`}, {
           22.844534870284374`, -2.694498251081817}}], 
          LineBox[{{26.10561614482117, -2.694498251081817}, {
           26.86346241003376, -2.6910760282725805`}}], 
          LineBox[{{27.125305956137836`, -2.6910760282725805`}, {
           27.820811500738625`, -2.694498251081817}}], 
          LineBox[{{28.197819657108553`, -2.694498251081817}, {
           28.96564052126646, -2.6910760282725805`}}]}}}, {{}, {}, 
        {RGBColor[1, 0, 0], PointSize[0.003], Thickness[0.003], 
         Dashing[{}], {}, 
         {Opacity[1], 
          LineBox[{{8.81701620325146, -2.736704048955333}, {
           9., -2.680897962407049}, {9.161785209166784, -2.647634345265702}}],
           LineBox[{{11.89245537745551, -2.736704048955333}, {
           12., -2.7149566811482044`}, {
           12.375806557443427`, -2.647634345265702}}], 
          LineBox[{{14.7205325627188, -2.736704048955333}, {
           15., -2.695799523210084}, {
           15.442230971958496`, -2.647634345265702}}], 
          LineBox[{{17.500489757580418`, -2.736704048955333}, {
           18., -2.6585214531221752`}, {
           18.683848431466156`, -2.647634345265702}}], 
          LineBox[{{21.23759439495784, -2.647634345265702}, {
           22., -2.7033029100717214`}, {23., -2.7335688752716467`}, {
           23.858823639546245`, -2.647634345265702}}], 
          LineBox[{{25.082141474851593`, -2.736704048955333}, {
           26., -2.6820562148212925`}, {27., -2.6677510154467843`}, {
           27.988880262722713`, -2.736704048955333}}], LineBox[CompressedData["
1:eJw90n0s1HEcB/DfGcX0uIiZh0T+iEYjuhW9OefZuSd3Z0MLeapGmqdU7kwJ
HUkaycM685hMtJvL7KZsFdMWm1KTlZrVUmYk1S01n99v++23z16/z+fz/X6+
X8eEDPFJI4ZhQtfff9/lpNnCZKOjSNS3W43MmeiZ/48vqh3W+Bxfiv2Q61eo
UvdSfAw+3AdmtrUUA5aO783TFRuxEih92dBsN0ruj7F5dUtMLLk/Brc/XeXW
kwcgjVck1FCsDECFlX5oKYmch7YSS4t2LTkPplMD3vvTyQPhkbF4iEPrUQai
wue055dqcj4meuMfDWeR8xHm1hL/uIM8COZmlU55Z8mDIGlL6ObWkQcjNf7U
UE45eTBGdHn1+ZfIQ3C/w2nSsok8BPYGsctMDnkoWnibuZm3yUPx4c7BtOJi
8jAIthxZU10lD8MF/xMdXjXk4Tju9adHepE8HEs9xtmf2PlHYEr3wt5URR6B
PqvWtK5K8ki8yUm/rrlGHgnvTaq9T9j+Asw3N3TG3SQXgMMrr2ylekwUYhND
bz2/QR6FBZPRdx+vkAuxmuWqvkDzgRBrW+sKZBX0vxB9jb5d6ssbsV6I1ii7
lP4qyhdBE7Qy5kIOEVrH7xll0vqVIrw9Y/vNv5TyRZgp6iwtL6N8MbRdTe5T
asoXY7ikempfCeWL0Xmge7yM6unFKG7RuAaSMxLsngzUvWbzJTCspC5wqL5S
ArlzVXcvxXoJpg35yd9pnowUOxzLagrp/CCF++HfFtbs/qXY2VDxI5dcL0Xb
SJtuD/VjovG5yVHrRPURjTlDs70De9+i4R1hHWxN/fTROJe0bbmM5sHIwHHr
n9jFrl8Gm6+VuSBXysC/6zfwkM2XwelVsY0zOz85fjYucZXs+ckRUpXimcn2
l0NWer5Ayu5fjoJwrVzI7l8B41lR0jT1gwLMs0V+HHvfFFjIUcZ5sPkKZNeL
BINUn4lBf+14z691/wtAMFVz
           "]], 
          LineBox[{{5.393127123666137, -2.736704048955333}, {
           5.549879065731726, -2.647634345265702}}], 
          LineBox[{{7.087852821494141, -2.647634345265702}, {
           7.328049780320607, -2.736704048955333}}], 
          LineBox[{{10.390015776240617`, -2.647634345265702}, {
           10.59158591912271, -2.736704048955333}}], 
          LineBox[{{13.365003047310248`, -2.647634345265702}, {
           13.65574819369982, -2.736704048955333}}], 
          LineBox[{{16.266262098106033`, -2.647634345265702}, {
           16.65665413345316, -2.736704048955333}}], 
          LineBox[{{19.035415014757085`, -2.647634345265702}, {
           19.662129053888584`, -2.736704048955333}}], 
          LineBox[{{20.31092828137664, -2.736704048955333}, {
           20.88766659328083, -2.647634345265702}}], 
          LineBox[{{24.13069359181983, -2.647634345265702}, {
           24.954753155116514`, -2.736704048955333}}]}}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, -2.7600000000000002`},
      DisplayFunction->Identity,
      Frame->True,
      PlotRange->{All, {-2.7711019766913734`, -2.625853084490999}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, 
        Scaled[0.02]}], {192., -116.80842387373012`}, 
     ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{{}, {}, 
        {RGBColor[0, 0, 1], PointSize[0.003], Thickness[0.003], 
         Dashing[{}], {}, 
         {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBmIQDQUOa/Uli/5Esh+AcDkcdI+5Kzv8ZYDyBRyOz5FL
PZ3KBOWLOBxF4Us4HEHhyzicROEroKlXctiLwldxOIXCV0Pja6DxtRwOo/B1
0OzTQ1NvgGa/IZp6I4f9KHxjh8sofBOHg1A+ALPZUUE=
           "]]}}}, {{}, {}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.003], Thickness[0.003], 
         Dashing[{}], {}, 
         {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBmIQDQUOa/Uli/5Esh+AcDkcdI+5Kzv8ZYDyBRz0UPgi
aHwJBy0UvgwaX8FBA4Wv5KCNwldBM0/NwQiFr4HG13IwROHroOnXQ+MbOOig
8A0dNFH4RmjqjR1MUfgmDvpQPgBAz0j2
           "]]}}}, {{}, {}, 
        {RGBColor[1, 0, 0], PointSize[0.003], Thickness[0.003], 
         Dashing[{}], {}, 
         {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBmIQDQUOr8t+XDwiz3QAwuVA4wug8UXQ+BJofBk0vgIa
XwmNr4LGV0Pja6DxtdD4Omh8PTS+ARrfEI1vhMY3RuObwPkAcTlkcA==
           "]]}}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{5., -2.9},
      DisplayFunction->Identity,
      Frame->True,
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {576., -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}]}, {}},
  ContentSelectable->True,
  ImageSize->{796., Automatic},
  PlotRangePadding->{6, 5}]], "Output",
 CellChangeTimes->{{3.460281797946806*^9, 3.460281825798993*^9}, {
   3.460281904342657*^9, 3.460281945448979*^9}, {3.460281984036024*^9, 
   3.460281999907948*^9}, 3.460282036560417*^9, 3.460282135587686*^9, 
   3.460282242514032*^9, 3.4602823726324577`*^9, {3.460282416693921*^9, 
   3.460282441098826*^9}, 3.4602826518405313`*^9, 3.4602832036099043`*^9, 
   3.4602835481939077`*^9, {3.460284391325081*^9, 3.460284420594182*^9}, 
   3.460284799893792*^9, {3.460364417441619*^9, 3.460364434654419*^9}, {
   3.460364477824107*^9, 3.460364501892661*^9}, 3.460367145808325*^9, 
   3.460369518021393*^9, {3.4603696154135933`*^9, 3.460369627668434*^9}, 
   3.4604356684680777`*^9, 3.460439475436892*^9, 3.4604395415998383`*^9, {
   3.460439582340852*^9, 3.460439621927959*^9}, {3.4604402659294558`*^9, 
   3.46044027553581*^9}, {3.4605482869730167`*^9, 3.46054831765944*^9}, 
   3.460698128820739*^9, {3.4606982007291613`*^9, 3.460698247354405*^9}, 
   3.460698325889138*^9, 3.46069839312781*^9, 3.460698511192573*^9, 
   3.460698688355796*^9, 3.460698803312311*^9, 3.460698840322803*^9, 
   3.460698899193131*^9, 3.460699097328401*^9, {3.4606994876957207`*^9, 
   3.460699522585226*^9}, {3.460700411415139*^9, 3.4607004303196898`*^9}, 
   3.4607006077872477`*^9, 3.460700673410165*^9, 3.460701497746229*^9, 
   3.46070159114614*^9, 3.460702985828713*^9, 3.4607030464194813`*^9, 
   3.460704560161771*^9, 3.4607045931315203`*^9, {3.4607049981244307`*^9, 
   3.460705011400508*^9}, 3.46071265181137*^9, 3.4607130795428762`*^9, 
   3.460713925825474*^9, 3.4607142201264067`*^9, 3.460714273212161*^9, 
   3.4607143495075502`*^9, 3.46071599997359*^9, {3.460716582062931*^9, 
   3.460716588106329*^9}, {3.46071669432895*^9, 3.460716699866613*^9}, 
   3.4607168221764174`*^9, {3.4607168868735*^9, 3.460716913970245*^9}, 
   3.460716959105864*^9, 3.4607170689942093`*^9, {3.460717109732251*^9, 
   3.460717120616603*^9}, {3.4607171942571907`*^9, 3.460717217819908*^9}, 
   3.460717264622147*^9, 3.460717938622671*^9, {3.4607181737444973`*^9, 
   3.460718185942861*^9}, 3.4607182860528383`*^9, 3.4608666840102997`*^9, {
   3.460866716192235*^9, 3.460866875075344*^9}, {3.4608669490308123`*^9, 
   3.460867013792041*^9}, {3.460867045104608*^9, 3.460867090705942*^9}, {
   3.460867129241324*^9, 3.460867143567214*^9}, {3.460867232902383*^9, 
   3.460867312096705*^9}, 3.460867353518095*^9, 3.4608674053107977`*^9, 
   3.4608882382937317`*^9, 3.460889426803895*^9, 3.460889747321299*^9, 
   3.460889778161243*^9, {3.460890661864031*^9, 3.4608906851827793`*^9}, 
   3.460891019176798*^9, 3.460891051548173*^9, 3.460891085640848*^9, 
   3.4608912426751432`*^9}]
}, Open  ]],

Cell[TextData[StyleBox["Math7/Intel/ OS X",
 FontColor->RGBColor[1, 0, 0]]], "Text",
 PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"THETA0", "=", "Theta"}], "\n", 
 RowBox[{"F0", "=", 
  RowBox[{"IdentityMatrix", "[", 
   RowBox[{"Length", "[", "THETA0", "]"}], "]"}]}], "\n", 
 RowBox[{"SCALING", "=", "1"}], "\n", 
 RowBox[{"FISHER", "=", "True"}], "\n", 
 RowBox[{"MAXSTEP", "=", "1"}], "\n", 
 RowBox[{"STEPREDUCE", "=", "4"}], "\[IndentingNewLine]", 
 RowBox[{"FDIGITS", "=", "16"}], "\[IndentingNewLine]", 
 RowBox[{"pp", "=", "0"}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601143146009274`*^9, 3.460114315759859*^9}, 
   3.460282522110393*^9, {3.460283799592029*^9, 3.4602838013662*^9}, {
   3.4604357137809753`*^9, 3.460435744591599*^9}, {3.460435786839238*^9, 
   3.4604357909828987`*^9}, {3.460435825453755*^9, 3.460435826628525*^9}, {
   3.460435861768526*^9, 3.460435863165637*^9}, {3.460435902549529*^9, 
   3.460435902612645*^9}, {3.460435960264574*^9, 3.460435960325345*^9}, {
   3.460701708750058*^9, 3.4607017099740763`*^9}, {3.460701760363098*^9, 
   3.460701760922386*^9}, {3.46088944348444*^9, 3.460889444497266*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", "1", "}"}]], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460700676314569*^9, 3.4607007346245403`*^9, 3.460701595843239*^9, 
   3.460701653839116*^9, {3.460701689533342*^9, 3.460701710077276*^9}, 
   3.4607017618903503`*^9, 3.4607173158128653`*^9, {3.460889436888294*^9, 
   3.460889445699613*^9}, 3.4608912559872417`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "1", "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460700676314569*^9, 3.4607007346245403`*^9, 3.460701595843239*^9, 
   3.460701653839116*^9, {3.460701689533342*^9, 3.460701710077276*^9}, 
   3.4607017618903503`*^9, 3.4607173158128653`*^9, {3.460889436888294*^9, 
   3.460889445699613*^9}, 3.460891256005123*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460700676314569*^9, 3.4607007346245403`*^9, 3.460701595843239*^9, 
   3.460701653839116*^9, {3.460701689533342*^9, 3.460701710077276*^9}, 
   3.4607017618903503`*^9, 3.4607173158128653`*^9, {3.460889436888294*^9, 
   3.460889445699613*^9}, 3.460891256013527*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460700676314569*^9, 3.4607007346245403`*^9, 3.460701595843239*^9, 
   3.460701653839116*^9, {3.460701689533342*^9, 3.460701710077276*^9}, 
   3.4607017618903503`*^9, 3.4607173158128653`*^9, {3.460889436888294*^9, 
   3.460889445699613*^9}, 3.460891256021742*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460700676314569*^9, 3.4607007346245403`*^9, 3.460701595843239*^9, 
   3.460701653839116*^9, {3.460701689533342*^9, 3.460701710077276*^9}, 
   3.4607017618903503`*^9, 3.4607173158128653`*^9, {3.460889436888294*^9, 
   3.460889445699613*^9}, 3.4608912560299473`*^9}],

Cell[BoxData["4"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460700676314569*^9, 3.4607007346245403`*^9, 3.460701595843239*^9, 
   3.460701653839116*^9, {3.460701689533342*^9, 3.460701710077276*^9}, 
   3.4607017618903503`*^9, 3.4607173158128653`*^9, {3.460889436888294*^9, 
   3.460889445699613*^9}, 3.4608912560382233`*^9}],

Cell[BoxData["16"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460700676314569*^9, 3.4607007346245403`*^9, 3.460701595843239*^9, 
   3.460701653839116*^9, {3.460701689533342*^9, 3.460701710077276*^9}, 
   3.4607017618903503`*^9, 3.4607173158128653`*^9, {3.460889436888294*^9, 
   3.460889445699613*^9}, 3.4608912560463753`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460700676314569*^9, 3.4607007346245403`*^9, 3.460701595843239*^9, 
   3.460701653839116*^9, {3.460701689533342*^9, 3.460701710077276*^9}, 
   3.4607017618903503`*^9, 3.4607173158128653`*^9, {3.460889436888294*^9, 
   3.460889445699613*^9}, 3.460891256054648*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["Y"], "Input",
 CellChangeTimes->{3.460889506265583*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"-", "0.7881842610772917`"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.460889507239225*^9, 3.460891260383546*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Nichtlinear", "/", "EKF"}]], "Input",
 CellChangeTimes->{{3.460367266700344*^9, 3.46036726904226*^9}, {
  3.460717488899807*^9, 3.460717490381888*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "scoreii", ",", "k", 
      ",", "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
    RowBox[{"BFGS", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"Y", ",", "X", ",", 
         RowBox[{"-", "9"}]}], "}"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      "\t  ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"IdioNonlin", ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"m", "=", "100"}], ",", 
          RowBox[{"eps", "=", 
           RowBox[{"10.", "^", 
            RowBox[{"-", "16"}]}]}], ",", 
          RowBox[{"ksigma", "=", "Infinity"}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Lik", ",", "IndividualLikNonlin", ",", "Score", ",", "Hesse"}], 
         "}"}]}], "}"}], ",", "\[IndentingNewLine]", "            ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Sing", "=", "False"}], ",", 
          RowBox[{"2", "Pi"}], ",", "0", ",", 
          RowBox[{"onlynorkorr", "=", "0"}], ",", 
          RowBox[{"method", "=", "\"\<EKF\>\""}]}], "}"}], ",", 
        RowBox[{"KMAX", "=", "20"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EPS1", "=", ".0001"}], ",", 
          RowBox[{"EPS2", "=", ".0001"}]}], "}"}], ",", "\[IndentingNewLine]",
         "             ", 
        RowBox[{"OPTION", "=", "0"}], ",", 
        RowBox[{"PRINT", "=", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1"}], "}"}]}]}], "}"}]}], "]"}]}], ";"}], 
  "                                                                           \
     "}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113330285616*^9, 3.460113346379695*^9}, {
   3.460200648978776*^9, 3.4602006503583603`*^9}, {3.460200794874672*^9, 
   3.4602007984595947`*^9}, 3.460201903279232*^9, {3.460201941045977*^9, 
   3.4602019411313553`*^9}, {3.460279278878285*^9, 3.460279290392777*^9}, {
   3.460279385569292*^9, 3.4602794078107224`*^9}, 3.460279483282811*^9, {
   3.460282734453003*^9, 3.46028273588818*^9}, {3.460283616696549*^9, 
   3.460283634147719*^9}, {3.4602836706901093`*^9, 3.460283671258127*^9}, {
   3.4602837458995867`*^9, 3.4602837460095263`*^9}, {3.460283977779047*^9, 
   3.4602839782382393`*^9}, {3.460284094017385*^9, 3.460284112248164*^9}, {
   3.4602842039019938`*^9, 3.460284237509654*^9}, {3.460285585933895*^9, 
   3.460285590933837*^9}, 3.460367196326754*^9, {3.460435757860738*^9, 
   3.460435758943184*^9}, {3.460435888109399*^9, 3.460435888167045*^9}, {
   3.4604359232590923`*^9, 3.4604359236923323`*^9}, {3.4607004849549637`*^9, 
   3.460700501505876*^9}, {3.460700547802786*^9, 3.460700549451239*^9}, {
   3.460701009705194*^9, 3.460701010780252*^9}, {3.460701735855749*^9, 
   3.4607017420189333`*^9}, {3.460717416622799*^9, 3.4607174212496634`*^9}, 
   3.4607176912487583`*^9, 3.4607177366199493`*^9, {3.460717797857451*^9, 
   3.4607178001074667`*^9}, {3.460889512504839*^9, 3.460889513030223*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Tiefe von data = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["Tiefe von data = ", 5],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912640587683`*^9}],

Cell[BoxData["\<\"L\[ADoubleDot]nge der Paneldaten\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.46089126407304*^9}],

Cell[BoxData[
 RowBox[{"{", "1", "}"}]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891264085909*^9}],

Cell[BoxData["\<\"***********************LSDE1********************************\
**\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891264098665*^9}],

Cell[BoxData["\<\"***********************MODUL:    BFGS \
(skeleton)**************\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912641126547`*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891264123474*^9}],

Cell[BoxData["\<\"Technical Output\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891264133526*^9}],

Cell[BoxData["IndividualLikNonlin"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891264145005*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891264154839*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"KMAX\"\>",
       HoldForm], 
      TagBox["\<\"EPS1\"\>",
       HoldForm], 
      TagBox["\<\"EPS2\"\>",
       HoldForm], 
      TagBox["\<\"K\"\>",
       HoldForm], 
      TagBox["\<\"Q\"\>",
       HoldForm], 
      TagBox["\<\"n\"\>",
       HoldForm], 
      TagBox["\<\"T\"\>",
       HoldForm], 
      TagBox["\<\"OPTION\"\>",
       HoldForm]},
     {"1", "20", "0.0001`", "0.0001`", "1", "1", "1", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"KMAX", "EPS1", "EPS2", "K", "Q", "n", "T", "OPTION"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912641651983`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891264210751*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"MAXSTEP\"\>",
       HoldForm], 
      TagBox["\<\"MINSTEP\"\>",
       HoldForm], 
      TagBox["\<\"BOUND\"\>",
       HoldForm], 
      TagBox["\<\"STEPREDUCE\"\>",
       HoldForm], 
      TagBox["\<\"FMAX\"\>",
       HoldForm]},
     {"1", "1", "1.`*^-10", "1.`*^-6", "4", "1000"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"MAXSTEP", "MINSTEP", "BOUND", "STEPREDUCE", "FMAX"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912642609243`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891264310959*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"RESAMPLING\"\>",
       HoldForm], 
      TagBox["\<\"FDIGITS\"\>",
       HoldForm], 
      TagBox["\<\"TYP\"\>",
       HoldForm], 
      TagBox["\<\"YMAX\"\>",
       HoldForm], 
      TagBox["\<\"ANALGRAD\"\>",
       HoldForm], 
      TagBox["\<\"FACTOR\"\>",
       HoldForm], 
      TagBox["\<\"CSEED\"\>",
       HoldForm]},
     {"1", "True", "16", "1", "1.`*^8", "False", "1.`", 
      RowBox[{"-", "999"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {
      "RESAMPLING", "FDIGITS", "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}},
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891264363777*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912644112463`*^9}],

Cell[BoxData["\<\"    SCALING\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891264461123*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "::", "\<\"nmtx\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The first two levels of the \
one-dimensional list \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\
\\!\\({}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" cannot be \
transposed.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Transpose\\\", ButtonNote -> \\\"Transpose::nmtx\\\
\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.460701718139843*^9, 3.46070176477265*^9}, 
   3.460717350774433*^9, 3.460717421982737*^9, 3.460717692294409*^9, 
   3.46071773860679*^9, 3.460717801322158*^9, 3.460889471278419*^9, 
   3.460889515229188*^9, 3.4608912645232363`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  RowBox[{"Transpose", "[", 
   RowBox[{"{", "}"}], "]"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
    0]]]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891264563404*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912646143837`*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912646618233`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891264710617*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STARTWERT THETA0 = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["STARTWERT THETA0 = ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891264764082*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912648132133`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"-", "0.3674468696117401`"}], "}"}], ",", 
   RowBox[{"-", "1.4043330342417935`"}]}], "}"}]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912648855677`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891264957844*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["BFGS: Iteration = ", 1],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891265027967*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.351051906951833\"\>",
     -1.351051906951833,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-1.351051906951833, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891265069119*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.404333034241793\"\>",
     -1.4043330342417935`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-1.4043330342417935`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891265132049*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.053281127289960\"\>",
     0.053281127289960484`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.053281127289960484`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912651826143`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891265230022*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.6326\"\>",
         0.6325531303882599,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\"-0.3674\"\>",
         -0.3674468696117401,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.3674\"\>",
         -0.3674468696117401,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912652853527`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891265334509*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891265382592*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891265430036*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "9.504285136685553`*^-9"}],
  SequenceForm["NOISE  ", 9.504285136685553*^-9],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891265479272*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "4.266837505160521`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "7.406463660036624`"}],
  SequenceForm["*BFGSUP ", 4.266837505160521, "  ", 7.406463660036624],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891265547454*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.20012177744770493`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.20012177744770493`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891265585745*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912656470833`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "2"}],
  SequenceForm["BFGS: Iteration = ", 2],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.46089126569701*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.345757796279983\"\>",
     -1.345757796279983,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-1.345757796279983, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891265747395*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.351051906951833\"\>",
     -1.351051906951833,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-1.351051906951833, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912657973223`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.005294110671850\"\>",
     0.005294110671850039,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.005294110671850039, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891265855942*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891265913021*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7883\"\>",
         0.7883151587075433,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6326\"\>",
         0.6325531303882599,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1558\"\>",
         0.15576202831928346`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2704\"\>",
         0.2703749090433121,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891265975524*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891266051694*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.736\"\>",
         1.7358204175994252`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891266090446*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891266145012*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "6.175361111360189`*^-9"}],
  SequenceForm["NOISE  ", 6.175361111360189*^-9],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891266209057*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "15.491595916294813`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "23.744991571466617`"}],
  SequenceForm["*BFGSUP ", 15.491595916294813`, "  ", 23.744991571466617`],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891266275053*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.10703750728996635`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.10703750728996635`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891266345696*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891266402651*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "3"}],
  SequenceForm["BFGS: Iteration = ", 3],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891266454768*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.340632281814441\"\>",
     -1.3406322818144414`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-1.3406322818144414`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891266508926*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.345757796279983\"\>",
     -1.345757796279983,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-1.345757796279983, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891266569848*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.005125514465542\"\>",
     0.0051255144655415474`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.0051255144655415474`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891266638503*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.46089126668346*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7342\"\>",
         0.7341746615883136,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7883\"\>",
         0.7883151587075433,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0541\"\>",
         -0.054140497119229705`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1440\"\>",
         -0.14404655992984772`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912667485247`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912668044786`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.661\"\>",
         2.660606525511289,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891266865501*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912669203568`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "2.7177564643210417`*^-9"}],
  
  SequenceForm["NOISE  ", 2.7177564643210417`*^-9],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891266993917*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "174.73168609186934`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "128.22563834120547`"}],
  SequenceForm["*BFGSUP ", 174.73168609186934`, "  ", 128.22563834120547`],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891267050179*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.02859769195435536`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.02859769195435536, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891267113495*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912671916656`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "4"}],
  SequenceForm["BFGS: Iteration = ", 4],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891267230754*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.340367143417900\"\>",
     -1.3403671434178996`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-1.3403671434178996`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891267293331*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.340632281814441\"\>",
     -1.3406322818144414`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-1.3406322818144414`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.46089126734613*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000265138396542\"\>",
     0.000265138396541742,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.000265138396541742, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891267406067*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912674629593`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7145\"\>",
         0.7145384907191804,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7342\"\>",
         0.7341746615883136,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0196\"\>",
         -0.019636170869133118`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0383\"\>",
         -0.03833898901939392,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912675171413`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912675655117`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.952\"\>",
         1.9524676819583247`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891267616166*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.46089126766621*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "7.533227375233764`*^-10"}],
  
  SequenceForm["NOISE  ", 7.533227375233764*^-10],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891267743619*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "1007.354275945328`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "1328.3194775228208`"}],
  SequenceForm["*BFGSUP ", 1007.354275945328, "  ", 1328.3194775228208`],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891267781165*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.009113655300457817`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.009113655300457817, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891267836206*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891267896667*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["BFGS: Iteration = ", 5],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912679494123`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.340339281171401\"\>",
     -1.3403392811714012`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-1.3403392811714012`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891268000483*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.340367143417900\"\>",
     -1.3403671434178996`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-1.3403671434178996`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891268055079*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000027862246498\"\>",
     0.000027862246498422394`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.000027862246498422394`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891268116281*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891268166898*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7193\"\>",
         0.7192832284482206,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7145\"\>",
         0.7145384907191804,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0047\"\>",
         0.004744737729040131,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0122\"\>",
         0.012215644121170044`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891268219656*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891268292201*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.575\"\>",
         2.574566776663816,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912683347883`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912683832417`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.886029110664822`*^-10"}],
  
  SequenceForm["NOISE  ", 1.886029110664822*^-10],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912684335747`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "16651.735725011924`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "17253.269923002725`"}],
  SequenceForm["*BFGSUP ", 16651.735725011924`, "  ", 17253.269923002725`],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891268484276*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0003292323024428124`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0003292323024428124, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891268536511*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891268584693*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "6"}],
  SequenceForm["BFGS: Iteration = ", 6],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912686525297`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.340339244402849\"\>",
     -1.3403392444028492`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-1.3403392444028492`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891268706493*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.340339281171401\"\>",
     -1.3403392811714012`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-1.3403392811714012`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891268774419*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     3.676855198087026\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-8\"\>"]}],
     3.6768551980870257`*^-8,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[3.6768551980870257`*^-8, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891268864361*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891268903158*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7191\"\>",
         0.7191178034582185,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7193\"\>",
         0.7192832284482206,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0002\"\>",
         -0.00016542499000201844`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0004\"\>",
         -0.0004412829875946045,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891268954783*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891269006814*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.668\"\>",
         2.6675714932140555`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891269068934*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891269118084*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "6.623812609518609`*^-12"}],
  
  SequenceForm["NOISE  ", 6.623812609518609*^-12],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891269167158*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "1.3799894232120343`*^7", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "1.3698773915770974`*^7"}],
  SequenceForm[
  "*BFGSUP ", 1.3799894232120343`*^7, "  ", 1.3698773915770974`*^7],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912692203293`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "2.412487728437408`*^-6",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 2.412487728437408*^-6, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891269270048*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912693176603`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891269397772*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "7"}],
  SequenceForm["BFGS: Iteration = ", 7],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891269434023*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.340339244400880\"\>",
     -1.3403392444008795`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-1.3403392444008795`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891269484271*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.340339244402849\"\>",
     -1.3403392444028492`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-1.3403392444028492`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891269539624*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     1.969757690289953\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-12\"\>"]}],
     1.9697576902899527`*^-12,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[1.9697576902899527`*^-12, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891269610189*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891269670479*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7191\"\>",
         0.7191165823396407,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7191\"\>",
         0.7191178034582185,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891269721987*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891269770808*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.648\"\>",
         2.648024555480975,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891269828318*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912698854437`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "4.8627768478581856`*^-14"}],
  SequenceForm["NOISE  ", 4.8627768478581856`*^-14],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912699649973`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "2.556133833743873`*^11", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "2.5325749965665103`*^11"}],
  SequenceForm[
  "*BFGSUP ", 2.556133833743873*^11, "  ", 2.5325749965665103`*^11],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912700027037`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "2.2234909939547955`*^-8", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 2.2234909939547955`*^-8, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891270058219*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891270124432*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891270176291*^9}],

Cell[BoxData["\<\"ReturnCode = 3\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891270241963*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS:  ENDE DER ITERATION  \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "20"}],
  SequenceForm["BFGS:  ENDE DER ITERATION  ", 7, "  ", 20],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891270289652*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {"1", 
       RowBox[{"-", "2.9802322387695312`*^-8"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}]]]], "Print",\

 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891270345254*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912704100637`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.624\"\>",
         2.6236187992092597`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891270476658*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"Likelihood\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm]},
      {"1", 
       RowBox[{"-", "1.4043330342417935`"}], "1"},
      {"2", 
       RowBox[{"-", "1.351051906951833`"}], "0.6325531303882599`"},
      {"3", 
       RowBox[{"-", "1.345757796279983`"}], "0.7883151587075433`"},
      {"4", 
       RowBox[{"-", "1.3406322818144414`"}], "0.7341746615883136`"},
      {"5", 
       RowBox[{"-", "1.3403671434178996`"}], "0.7145384907191804`"},
      {"6", 
       RowBox[{"-", "1.3403392811714012`"}], "0.7192832284482206`"},
      {"7", 
       RowBox[{"-", "1.3403392444028492`"}], "0.7191178034582185`"},
      {"8", 
       RowBox[{"-", "1.3403392444008795`"}], "0.7191165823396407`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"Likelihood", "THETA"}}]]]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.46089127055024*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"INK: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "6.055454452393343`*^-6", "}"}]}],
  SequenceForm["INK: ", {6.055454452393343*^-6}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891270587904*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891270658567*^9}],

Cell[BoxData["\<\"ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891270708399*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891270755825*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {
         StyleBox["\[Null]",
          ShowStringCharacters->False], 
         TagBox["\<\"THETA\"\>",
          HoldForm], 
         TagBox["\<\"SCORE\"\>",
          HoldForm]},
        {"1", "0.7191165823396407`", 
         RowBox[{"-", "2.9802322387695312`*^-8"}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxDividers->{
        "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
         "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.24]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
     "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[
     BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}]]], 
   "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "1.3403392444008795`"}]}],
  SequenceForm[
   MatrixForm[{{0.7191165823396407, -2.9802322387695312`*^-8}}, 
    TableHeadings -> {Automatic, {"THETA", "SCORE"}}], 
   "   Likelihood = ", -1.3403392444008795`],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.46089127081026*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912708646097`*^9}],

Cell[BoxData["\<\"WALD-TEST:\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891270920497*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891270993269*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"CHI \"\>",
       HoldForm], 
      TagBox["\<\"U \"\>",
       HoldForm], 
      TagBox["\<\"PROB \"\>",
       HoldForm], 
      TagBox["\<\"ALPHA \"\>",
       HoldForm]},
     {"1", "1.3697365191857254`", "1", "0.2418571585053837`", "0.05`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", "ALPHA "}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891271060433*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891271105187*^9}],

Cell[BoxData["\<\"BONFERRONI-KONFIDENZINTERVALLE:\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891271163412*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912712193727`*^9}],

Cell[BoxData["\<\"P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= \
1-ALPHA\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912712755404`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"QUANTIL Z(1-ALPHA/2U) = \"\>", "\[InvisibleSpace]", 
   "1.9599639845400527`"}],
  SequenceForm["QUANTIL Z(1-ALPHA/2U) = ", 1.9599639845400527`],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891271330323*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"THETA\"\>",
       HoldForm], 
      TagBox["\<\"GRENZE\"\>",
       HoldForm], 
      TagBox["\<\"STD\"\>",
       HoldForm]},
     {"1", "0.7191165823396407`", "1.204283890760338`", 
      "0.6144418470235048`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891271383946*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891271450347*^9}],

Cell[BoxData["\<\"Korrelation der ML-Sch\[ADoubleDot]tzer\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891271508442*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912715767307`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "1.`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891271619982*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891271674542*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND \
EIGENWERTE\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891271732819*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.46089127179994*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0.3775387833736561`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.46089127186581*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891271910592*^9}],

Cell[BoxData[
 RowBox[{"{", "0.3775387833736561`", "}"}]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912719660673`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891272014257*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX \
UND EIGENWERTE\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891272066495*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891272130405*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "2.6487344983847243`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891272181761*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891272236013*^9}],

Cell[BoxData[
 RowBox[{"{", "2.6487344983847243`", "}"}]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891272302454*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891272355068*^9}],

Cell[BoxData["\<\"KOMPENSIERTE LIKELIHOOD\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891272413478*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891272473803*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"U =  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  Nue = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["U =  ", 1, "  Nue = ", 1],
  Editable->False]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891272536998*^9}],

Cell[BoxData["\<\"AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) \
AZENCOTT/DACUNHA-CASTELLE (A/D)\"\>"], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.4608912725977907`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"LIK\"\>",
       HoldForm], 
      TagBox["\<\"AIC\"\>",
       HoldForm], 
      TagBox["\<\"SIC/RISS\"\>",
       HoldForm], 
      TagBox["\<\"A/D\"\>",
       HoldForm]},
     {
      TagBox["\<\"Kompensator\"\>",
       HoldForm], "0", "1", "0.`", "Indeterminate"},
     {
      TagBox["\<\"komp. Lik.\"\>",
       HoldForm], 
      RowBox[{"-", "1.3403392444008795`"}], 
      RowBox[{"-", "2.3403392444008793`"}], 
      RowBox[{"-", "1.3403392444008795`"}], "Indeterminate"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {{"Kompensator", "komp. Lik."}, {
      "LIK", "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
    TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{{3.4607017177786627`*^9, 3.460701764426313*^9}, 
   3.460717350564419*^9, 3.4607174217835007`*^9, 3.460717692062907*^9, 
   3.4607177384817038`*^9, 3.460717801067116*^9, 3.460889470823174*^9, 
   3.460889514846829*^9, 3.460891272688017*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "1", "0.7191165823396407`", "0.6144418470235048`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.460113389973647*^9, 3.460114056100081*^9, 
  3.460114179071628*^9, 3.4601142697179193`*^9, 3.460114343759589*^9, 
  3.460121016537031*^9, 3.4602008503444023`*^9, 3.460201923221129*^9, 
  3.460201965915328*^9, 3.4602793122704687`*^9, 3.460279517413031*^9, 
  3.46028255805007*^9, 3.4603672164787407`*^9, 3.460717430644471*^9, 
  3.460717486228737*^9, 3.460717698196558*^9, 3.460717750532782*^9, 
  3.46071781120669*^9, 3.4608894839451923`*^9, 3.4608895265522013`*^9, 
  3.460891279235524*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Nichtlinear", ",", " ", "NorKorr"}]], "Input",
 CellChangeTimes->{{3.460367266700344*^9, 3.4603672898119717`*^9}, {
  3.46071751379565*^9, 3.4607175158172903`*^9}, {3.460717574664137*^9, 
  3.460717587669468*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "scoreii", ",", "k", 
      ",", "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
    RowBox[{"BFGS", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"Y", ",", "X", ",", 
         RowBox[{"-", "9"}]}], "}"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      "\t  ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"IdioNonlin", ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"m", "=", "100"}], ",", 
          RowBox[{"eps", "=", 
           RowBox[{"10.", "^", 
            RowBox[{"-", "16"}]}]}], ",", 
          RowBox[{"ksigma", "=", "Infinity"}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Lik", ",", "IndividualLikNonlin", ",", "Score", ",", "Hesse"}], 
         "}"}]}], "}"}], ",", "\[IndentingNewLine]", "            ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Sing", "=", "False"}], ",", 
          RowBox[{"2", "Pi"}], ",", "0", ",", 
          RowBox[{"onlynorkorr", "=", "0"}], ",", 
          RowBox[{"method", "=", "\"\<NorKorr\>\""}]}], "}"}], ",", 
        RowBox[{"KMAX", "=", "20"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EPS1", "=", ".0001"}], ",", 
          RowBox[{"EPS2", "=", ".0001"}]}], "}"}], ",", "\[IndentingNewLine]",
         "             ", 
        RowBox[{"OPTION", "=", "0"}], ",", 
        RowBox[{"PRINT", "=", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1"}], "}"}]}]}], "}"}]}], "]"}]}], ";"}], 
  "                                                                           \
     "}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113330285616*^9, 3.460113346379695*^9}, {
   3.460200648978776*^9, 3.4602006503583603`*^9}, {3.460200794874672*^9, 
   3.4602007984595947`*^9}, 3.460201903279232*^9, {3.460201941045977*^9, 
   3.4602019411313553`*^9}, {3.460279278878285*^9, 3.460279290392777*^9}, {
   3.460279385569292*^9, 3.4602794078107224`*^9}, 3.460279483282811*^9, {
   3.460282734453003*^9, 3.46028273588818*^9}, {3.460283616696549*^9, 
   3.460283634147719*^9}, {3.4602836706901093`*^9, 3.460283671258127*^9}, {
   3.4602837458995867`*^9, 3.4602837460095263`*^9}, {3.460283977779047*^9, 
   3.4602839782382393`*^9}, {3.460284094017385*^9, 3.460284112248164*^9}, {
   3.4602842039019938`*^9, 3.460284237509654*^9}, {3.460285585933895*^9, 
   3.460285590933837*^9}, 3.460367196326754*^9, {3.460435757860738*^9, 
   3.460435758943184*^9}, {3.460435888109399*^9, 3.460435888167045*^9}, {
   3.4604359232590923`*^9, 3.4604359236923323`*^9}, {3.4607004849549637`*^9, 
   3.460700501505876*^9}, {3.460700547802786*^9, 3.460700549451239*^9}, {
   3.460701009705194*^9, 3.460701010780252*^9}, {3.460701735855749*^9, 
   3.4607017420189333`*^9}, {3.460717416622799*^9, 3.4607174212496634`*^9}, {
   3.460717524522689*^9, 3.460717524583459*^9}, {3.46071760178517*^9, 
   3.46071760964034*^9}, 3.4607177051758137`*^9, 3.460717757149786*^9, {
   3.460717815582903*^9, 3.4607178169820967`*^9}, {3.460889543070612*^9, 
   3.460889545084868*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Tiefe von data = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["Tiefe von data = ", 5],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891290753562*^9}],

Cell[BoxData["\<\"L\[ADoubleDot]nge der Paneldaten\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912907670717`*^9}],

Cell[BoxData[
 RowBox[{"{", "1", "}"}]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891290780971*^9}],

Cell[BoxData["\<\"***********************LSDE1********************************\
**\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891290794571*^9}],

Cell[BoxData["\<\"***********************MODUL:    BFGS \
(skeleton)**************\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912908091288`*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912908223047`*^9}],

Cell[BoxData["\<\"Technical Output\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891290835576*^9}],

Cell[BoxData["IndividualLikNonlin"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891290849125*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891290869525*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"KMAX\"\>",
       HoldForm], 
      TagBox["\<\"EPS1\"\>",
       HoldForm], 
      TagBox["\<\"EPS2\"\>",
       HoldForm], 
      TagBox["\<\"K\"\>",
       HoldForm], 
      TagBox["\<\"Q\"\>",
       HoldForm], 
      TagBox["\<\"n\"\>",
       HoldForm], 
      TagBox["\<\"T\"\>",
       HoldForm], 
      TagBox["\<\"OPTION\"\>",
       HoldForm]},
     {"1", "20", "0.0001`", "0.0001`", "1", "1", "1", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"KMAX", "EPS1", "EPS2", "K", "Q", "n", "T", "OPTION"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891290892165*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.46089129091109*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"MAXSTEP\"\>",
       HoldForm], 
      TagBox["\<\"MINSTEP\"\>",
       HoldForm], 
      TagBox["\<\"BOUND\"\>",
       HoldForm], 
      TagBox["\<\"STEPREDUCE\"\>",
       HoldForm], 
      TagBox["\<\"FMAX\"\>",
       HoldForm]},
     {"1", "1", "1.`*^-10", "1.`*^-6", "4", "1000"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"MAXSTEP", "MINSTEP", "BOUND", "STEPREDUCE", "FMAX"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891290924214*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891290935278*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"RESAMPLING\"\>",
       HoldForm], 
      TagBox["\<\"FDIGITS\"\>",
       HoldForm], 
      TagBox["\<\"TYP\"\>",
       HoldForm], 
      TagBox["\<\"YMAX\"\>",
       HoldForm], 
      TagBox["\<\"ANALGRAD\"\>",
       HoldForm], 
      TagBox["\<\"FACTOR\"\>",
       HoldForm], 
      TagBox["\<\"CSEED\"\>",
       HoldForm]},
     {"1", "True", "16", "1", "1.`*^8", "False", "1.`", 
      RowBox[{"-", "999"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {
      "RESAMPLING", "FDIGITS", "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}},
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912909456043`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891290992773*^9}],

Cell[BoxData["\<\"    SCALING\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891291047846*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "::", "\<\"nmtx\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The first two levels of the \
one-dimensional list \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\
\\!\\({}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" cannot be \
transposed.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Transpose\\\", ButtonNote -> \\\"Transpose::nmtx\\\
\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4607175292445707`*^9, 3.4607176114482727`*^9, 
  3.460717706528014*^9, 3.460717759262171*^9, 3.4607178186032333`*^9, 
  3.46088955033464*^9, 3.4608912911167707`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  RowBox[{"Transpose", "[", 
   RowBox[{"{", "}"}], "]"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
    0]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912911550617`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891291214232*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912912699747`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891291316091*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STARTWERT THETA0 = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["STARTWERT THETA0 = ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891291366867*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891291415066*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"-", "0.366645872592926`"}], "}"}], ",", 
   RowBox[{"-", "1.404348602421444`"}]}], "}"}]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912914701233`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891291527343*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["BFGS: Iteration = ", 1],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891291580572*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.351852856076209\"\>",
     -1.351852856076209,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-1.351852856076209, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891291654256*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.404348602421444\"\>",
     -1.404348602421444,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-1.404348602421444, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912917030582`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.052495746345235\"\>",
     0.052495746345234906`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.052495746345234906`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912917496967`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912918001347`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.6334\"\>",
         0.633354127407074,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\"-0.3666\"\>",
         -0.366645872592926,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.3666\"\>",
         -0.366645872592926,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891291851222*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891291899373*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912919611*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891292003996*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "9.431560865635902`*^-9"}],
  SequenceForm["NOISE  ", 9.431560865635902*^-9],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891292051076*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "4.309131431294627`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "7.4388602370464865`"}],
  SequenceForm["*BFGSUP ", 4.309131431294627, "  ", 7.4388602370464865`],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891292099093*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.19698553851466205`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.19698553851466205`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891292168461*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912922078333`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "2"}],
  SequenceForm["BFGS: Iteration = ", 2],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891292253141*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.346000807972822\"\>",
     -1.3460008079728216`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-1.3460008079728216`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912923270807`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.351852856076209\"\>",
     -1.351852856076209,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-1.351852856076209, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912923816347`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.005852048103387\"\>",
     0.005852048103387464,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.005852048103387464, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912924432907`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891292505946*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7876\"\>",
         0.7876119185737096,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6334\"\>",
         0.633354127407074,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1543\"\>",
         0.15425779116663565`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2663\"\>",
         0.266295462846756,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891292560575*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891292614699*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.726\"\>",
         1.7263015425852468`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912926794863`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891292758239*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "6.064455382315259`*^-9"}],
  SequenceForm["NOISE  ", 6.064455382315259*^-9],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891292796179*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "15.928731773897665`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "24.343842225638447`"}],
  SequenceForm["*BFGSUP ", 15.928731773897665`, "  ", 24.343842225638447`],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891292848773*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.10451943847714794`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.10451943847714794`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891292903594*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891292975355*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "3"}],
  SequenceForm["BFGS: Iteration = ", 3],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891293026022*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.341251810171070\"\>",
     -1.3412518101710704`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-1.3412518101710704`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891293077763*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.346000807972822\"\>",
     -1.3460008079728216`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-1.3460008079728216`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912931252203`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.004748997801751\"\>",
     0.004748997801751198,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.004748997801751198, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912931781883`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891293229641*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7343\"\>",
         0.734288522099275,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7876\"\>",
         0.7876119185737096,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0533\"\>",
         -0.05332339647443464,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1407\"\>",
         -0.14068324863910675`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891293309627*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891293354126*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.638\"\>",
         2.6383024702216016`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891293417926*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891293463093*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "2.5829736127747083`*^-9"}],
  
  SequenceForm["NOISE  ", 2.5829736127747083`*^-9],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891293516433*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "173.60155436812377`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "133.3029643498474`"}],
  SequenceForm["*BFGSUP ", 173.60155436812377`, "  ", 133.3029643498474],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891293566514*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.02434828121649621`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.02434828121649621, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912936150217`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912936662703`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "4"}],
  SequenceForm["BFGS: Iteration = ", 4],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912937182198`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.341032937865498\"\>",
     -1.3410329378654982`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-1.3410329378654982`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891293772663*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.341251810171070\"\>",
     -1.3412518101710704`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-1.3412518101710704`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.46089129386077*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000218872305572\"\>",
     0.00021887230557227078`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.00021887230557227078`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891293898238*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891293944786*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7182\"\>",
         0.7181684177686191,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7343\"\>",
         0.734288522099275,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0161\"\>",
         -0.01612010433065591,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0327\"\>",
         -0.03265717625617981,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891293999419*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891294052567*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.026\"\>",
         2.025866308698452,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891294117455*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912941653643`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "5.761606747256565`*^-10"}],
  
  SequenceForm["NOISE  ", 5.761606747256565*^-10],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912942134457`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "1604.385217608341`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "1899.5622117929524`"}],
  SequenceForm["*BFGSUP ", 1604.385217608341, "  ", 1899.5622117929524`],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891294266695*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.004480361321844821`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.004480361321844821, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891294315805*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891294392088*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["BFGS: Iteration = ", 5],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912944303226`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.341025680010125\"\>",
     -1.3410256800101255`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-1.3410256800101255`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.46089129448449*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.341032937865498\"\>",
     -1.3410329378654982`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-1.3410329378654982`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.46089129453373*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     7.257855372699851\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-6\"\>"]}],
     7.257855372699851*^-6,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[7.257855372699851*^-6, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912945837183`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891294660491*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7207\"\>",
         0.7206733549129383,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7182\"\>",
         0.7181684177686191,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0025\"\>",
         0.002504937144319228,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0060\"\>",
         0.006008312106132507,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891294722734*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891294785447*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.399\"\>",
         2.398587972460043,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891294843666*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891294913293*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "9.252509869384085`*^-11"}],
  
  SequenceForm["NOISE  ", 9.252509869384085*^-11],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912949697123`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "64293.00473657062`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "66443.22179134504`"}],
  SequenceForm["*BFGSUP ", 64293.00473657062, "  ", 66443.22179134504],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891295017795*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0001498421407541714`",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0001498421407541714, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891295066704*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912951165037`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "6"}],
  SequenceForm["BFGS: Iteration = ", 6],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891295165731*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.341025671820514\"\>",
     -1.3410256718205145`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-1.3410256718205145`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912952216578`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.341025680010125\"\>",
     -1.3410256800101255`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-1.3410256800101255`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891295286989*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     8.189610989362000\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-9\"\>"]}],
     8.189610989361995*^-9,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[8.189610989361995*^-9, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.46089129534367*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891295428533*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7206\"\>",
         0.7205922908341107,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7207\"\>",
         0.7206733549129383,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0001\"\>",
         -0.00008106407882759804,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0002\"\>",
         -0.00020094215869903564`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891295466198*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912955217743`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.479\"\>",
         2.4788064159266736`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891295571754*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912956206837`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.0120350658080497`*^-12"}],
  SequenceForm["NOISE  ", 3.0120350658080497`*^-12],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891295668758*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "6.175677618833787`*^7", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "6.1390403025930226`*^7"}],
  SequenceForm["*BFGSUP ", 6.175677618833787*^7, "  ", 6.1390403025930226`*^7],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891295722171*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "8.889411444968703`*^-7",
    "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 8.889411444968703*^-7, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891295775569*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.46089129584277*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912959291973`*^9}],

Cell[BoxData["\<\"ReturnCode = 3\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912959717712`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS:  ENDE DER ITERATION  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "20"}],
  SequenceForm["BFGS:  ENDE DER ITERATION  ", 6, "  ", 20],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891296023901*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {"1", 
       RowBox[{"-", "1.1920928955078125`*^-6"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}]]]], "Print",\

 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891296073412*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891296118949*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.464\"\>",
         2.4641008532070496`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891296171226*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"Likelihood\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm]},
      {"1", 
       RowBox[{"-", "1.404348602421444`"}], "1"},
      {"2", 
       RowBox[{"-", "1.351852856076209`"}], "0.633354127407074`"},
      {"3", 
       RowBox[{"-", "1.3460008079728216`"}], "0.7876119185737096`"},
      {"4", 
       RowBox[{"-", "1.3412518101710704`"}], "0.734288522099275`"},
      {"5", 
       RowBox[{"-", "1.3410329378654982`"}], "0.7181684177686191`"},
      {"6", 
       RowBox[{"-", "1.3410256800101255`"}], "0.7206733549129383`"},
      {"7", 
       RowBox[{"-", "1.3410256718205145`"}], "0.7205922908341107`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"Likelihood", "THETA"}}]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891296223999*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"INK: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "6.055454452393343`*^-6", "}"}]}],
  SequenceForm["INK: ", {6.055454452393343*^-6}],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891296275741*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912963284483`*^9}],

Cell[BoxData["\<\"ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891296390173*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891296457892*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {
         StyleBox["\[Null]",
          ShowStringCharacters->False], 
         TagBox["\<\"THETA\"\>",
          HoldForm], 
         TagBox["\<\"SCORE\"\>",
          HoldForm]},
        {"1", "0.7205922908341107`", 
         RowBox[{"-", "1.1920928955078125`*^-6"}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxDividers->{
        "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
         "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.24]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
     "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[
     BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}]]], 
   "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "1.3410256718205145`"}]}],
  SequenceForm[
   MatrixForm[{{0.7205922908341107, -1.1920928955078125`*^-6}}, 
    TableHeadings -> {Automatic, {"THETA", "SCORE"}}], 
   "   Likelihood = ", -1.3410256718205145`],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891296502446*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912965588703`*^9}],

Cell[BoxData["\<\"WALD-TEST:\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891296606926*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912966593447`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"CHI \"\>",
       HoldForm], 
      TagBox["\<\"U \"\>",
       HoldForm], 
      TagBox["\<\"PROB \"\>",
       HoldForm], 
      TagBox["\<\"ALPHA \"\>",
       HoldForm]},
     {"1", "1.279819286054681`", "1", "0.2579326386930423`", "0.05`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", "ALPHA "}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912967165537`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891296778185*^9}],

Cell[BoxData["\<\"BONFERRONI-KONFIDENZINTERVALLE:\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891296839394*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912968892727`*^9}],

Cell[BoxData["\<\"P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= \
1-ALPHA\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912969424953`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"QUANTIL Z(1-ALPHA/2U) = \"\>", "\[InvisibleSpace]", 
   "1.9599639845400527`"}],
  SequenceForm["QUANTIL Z(1-ALPHA/2U) = ", 1.9599639845400527`],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891297025674*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"THETA\"\>",
       HoldForm], 
      TagBox["\<\"GRENZE\"\>",
       HoldForm], 
      TagBox["\<\"STD\"\>",
       HoldForm]},
     {"1", "0.7205922908341107`", "1.2484276459270887`", "0.6369645849487682`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912970649548`*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891297121607*^9}],

Cell[BoxData["\<\"Korrelation der ML-Sch\[ADoubleDot]tzer\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891297179058*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912972290173`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "1.0000000000000002`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912972800007`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891297326339*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND \
EIGENWERTE\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891297380254*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891297430925*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0.4057238824789566`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891297476591*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891297543517*^9}],

Cell[BoxData[
 RowBox[{"{", "0.4057238824789566`", "}"}]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891297587194*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891297659019*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX \
UND EIGENWERTE\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912977157497`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891297777279*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "2.4647304316670744`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912978364153`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912978866787`*^9}],

Cell[BoxData[
 RowBox[{"{", "2.4647304316670744`", "}"}]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891297938758*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891298001254*^9}],

Cell[BoxData["\<\"KOMPENSIERTE LIKELIHOOD\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891298059761*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912981283216`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"U =  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  Nue = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["U =  ", 1, "  Nue = ", 1],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912981671658`*^9}],

Cell[BoxData["\<\"AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) \
AZENCOTT/DACUNHA-CASTELLE (A/D)\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608912982168407`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"LIK\"\>",
       HoldForm], 
      TagBox["\<\"AIC\"\>",
       HoldForm], 
      TagBox["\<\"SIC/RISS\"\>",
       HoldForm], 
      TagBox["\<\"A/D\"\>",
       HoldForm]},
     {
      TagBox["\<\"Kompensator\"\>",
       HoldForm], "0", "1", "0.`", "Indeterminate"},
     {
      TagBox["\<\"komp. Lik.\"\>",
       HoldForm], 
      RowBox[{"-", "1.3410256718205145`"}], 
      RowBox[{"-", "2.3410256718205145`"}], 
      RowBox[{"-", "1.3410256718205145`"}], "Indeterminate"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {{"Kompensator", "komp. Lik."}, {
      "LIK", "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
    TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891298271883*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "1", "0.7205922908341107`", "0.6369645849487682`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.4603673130895653`*^9, 3.4607175575060387`*^9, {3.460717623410822*^9, 
   3.460717631849646*^9}, 3.4607177103844147`*^9, 3.460717770338664*^9, 
   3.460717831260625*^9, 3.460889561024633*^9, 3.46089130585718*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Nichtlinear", ",", " ", "StochLin"}]], "Input",
 CellChangeTimes->{{3.460717864870357*^9, 3.460717867572139*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "scoreii", ",", "k", 
      ",", "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
    RowBox[{"BFGS", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"Y", ",", "X", ",", 
         RowBox[{"-", "9"}]}], "}"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      "\t  ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"IdioNonlin", ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"m", "=", "100"}], ",", 
          RowBox[{"eps", "=", 
           RowBox[{"10.", "^", 
            RowBox[{"-", "16"}]}]}], ",", 
          RowBox[{"ksigma", "=", "Infinity"}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Lik", ",", "IndividualLikNonlin", ",", "Score", ",", "Hesse"}], 
         "}"}]}], "}"}], ",", "\[IndentingNewLine]", "            ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Sing", "=", "False"}], ",", 
          RowBox[{"2", "Pi"}], ",", "0", ",", 
          RowBox[{"onlynorkorr", "=", "0"}], ",", 
          RowBox[{"method", "=", "\"\<StochLin\>\""}]}], "}"}], ",", 
        RowBox[{"KMAX", "=", "20"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EPS1", "=", ".0001"}], ",", 
          RowBox[{"EPS2", "=", ".0001"}]}], "}"}], ",", "\[IndentingNewLine]",
         "             ", 
        RowBox[{"OPTION", "=", "0"}], ",", 
        RowBox[{"PRINT", "=", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1"}], "}"}]}]}], "}"}]}], "]"}]}], ";"}], 
  "                                                                           \
     "}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113330285616*^9, 3.460113346379695*^9}, {
   3.460200648978776*^9, 3.4602006503583603`*^9}, {3.460200794874672*^9, 
   3.4602007984595947`*^9}, 3.460201903279232*^9, {3.460201941045977*^9, 
   3.4602019411313553`*^9}, {3.460279278878285*^9, 3.460279290392777*^9}, {
   3.460279385569292*^9, 3.4602794078107224`*^9}, 3.460279483282811*^9, {
   3.460282734453003*^9, 3.46028273588818*^9}, {3.460283616696549*^9, 
   3.460283634147719*^9}, {3.4602836706901093`*^9, 3.460283671258127*^9}, {
   3.4602837458995867`*^9, 3.4602837460095263`*^9}, {3.460283977779047*^9, 
   3.4602839782382393`*^9}, {3.460284094017385*^9, 3.460284112248164*^9}, {
   3.4602842039019938`*^9, 3.460284237509654*^9}, {3.460285585933895*^9, 
   3.460285590933837*^9}, 3.460367196326754*^9, {3.460435757860738*^9, 
   3.460435758943184*^9}, {3.460435888109399*^9, 3.460435888167045*^9}, {
   3.4604359232590923`*^9, 3.4604359236923323`*^9}, {3.4607004849549637`*^9, 
   3.460700501505876*^9}, {3.460700547802786*^9, 3.460700549451239*^9}, {
   3.460701009705194*^9, 3.460701010780252*^9}, {3.460701735855749*^9, 
   3.4607017420189333`*^9}, {3.460717416622799*^9, 3.4607174212496634`*^9}, {
   3.460717524522689*^9, 3.460717524583459*^9}, {3.46071760178517*^9, 
   3.46071760964034*^9}, 3.4607177051758137`*^9, 3.460717757149786*^9, {
   3.460717815582903*^9, 3.4607178169820967`*^9}, 3.460717874002067*^9, {
   3.4608895729115887`*^9, 3.460889574068149*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Tiefe von data = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["Tiefe von data = ", 5],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9}],

Cell[BoxData["\<\"L\[ADoubleDot]nge der Paneldaten\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574858794*^9}],

Cell[BoxData[
 RowBox[{"{", "1", "}"}]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895748823967`*^9}],

Cell[BoxData["\<\"***********************LSDE1********************************\
**\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574891046*^9}],

Cell[BoxData["\<\"***********************MODUL:    BFGS \
(skeleton)**************\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574903247*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895749118156`*^9}],

Cell[BoxData["\<\"Technical Output\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895749231358`*^9}],

Cell[BoxData["IndividualLikNonlin"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895749316673`*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574938898*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"KMAX\"\>",
       HoldForm], 
      TagBox["\<\"EPS1\"\>",
       HoldForm], 
      TagBox["\<\"EPS2\"\>",
       HoldForm], 
      TagBox["\<\"K\"\>",
       HoldForm], 
      TagBox["\<\"Q\"\>",
       HoldForm], 
      TagBox["\<\"n\"\>",
       HoldForm], 
      TagBox["\<\"T\"\>",
       HoldForm], 
      TagBox["\<\"OPTION\"\>",
       HoldForm]},
     {"1", "20", "0.0001`", "0.0001`", "1", "1", "1", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"KMAX", "EPS1", "EPS2", "K", "Q", "n", "T", "OPTION"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574983975*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889575032258*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"MAXSTEP\"\>",
       HoldForm], 
      TagBox["\<\"MINSTEP\"\>",
       HoldForm], 
      TagBox["\<\"BOUND\"\>",
       HoldForm], 
      TagBox["\<\"STEPREDUCE\"\>",
       HoldForm], 
      TagBox["\<\"FMAX\"\>",
       HoldForm]},
     {"1", "1", "1.`*^-10", "1.`*^-6", "4", "1000"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"MAXSTEP", "MINSTEP", "BOUND", "STEPREDUCE", "FMAX"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889575080883*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889575129589*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"RESAMPLING\"\>",
       HoldForm], 
      TagBox["\<\"FDIGITS\"\>",
       HoldForm], 
      TagBox["\<\"TYP\"\>",
       HoldForm], 
      TagBox["\<\"YMAX\"\>",
       HoldForm], 
      TagBox["\<\"ANALGRAD\"\>",
       HoldForm], 
      TagBox["\<\"FACTOR\"\>",
       HoldForm], 
      TagBox["\<\"CSEED\"\>",
       HoldForm]},
     {"1", "True", "16", "1", "1.`*^8", "False", "1.`", 
      RowBox[{"-", "999"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {
      "RESAMPLING", "FDIGITS", "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}},
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895751794453`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889575229455*^9}],

Cell[BoxData["\<\"    SCALING\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895753016853`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "::", "\<\"nmtx\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The first two levels of the \
one-dimensional list \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\
\\!\\({}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" cannot be \
transposed.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Transpose\\\", ButtonNote -> \\\"Transpose::nmtx\\\
\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.46071787686753*^9, 3.460889575351853*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  RowBox[{"Transpose", "[", 
   RowBox[{"{", "}"}], "]"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
    0]]]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.46088957539723*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895754517603`*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889575497304*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889575548016*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STARTWERT THETA0 = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["STARTWERT THETA0 = ", {1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889575598609*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889575647334*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"-", "0.36715105175971985`"}], "}"}], ",", 
   RowBox[{"-", "1.4043582939516384`"}]}], "}"}]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889575696891*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895757495317`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["BFGS: Iteration = ", 1],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889575812642*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.350993112696159\"\>",
     -1.350993112696159,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-1.350993112696159, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889575852355*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.404358293951638\"\>",
     -1.4043582939516384`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-1.4043582939516384`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.46088957589811*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.053365181255479\"\>",
     0.0533651812554794,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.0533651812554794, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889575969239*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889576015883*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.6328\"\>",
         0.6328489482402802,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\"-0.3672\"\>",
         -0.36715105175971985`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.3672\"\>",
         -0.36715105175971985`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889576066691*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895761175117`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889576165318*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889576214869*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "9.436773140691912`*^-9"}],
  SequenceForm["NOISE  ", 9.436773140691912*^-9],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889576265113*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "4.300825493093787`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "7.418403415094216`"}],
  SequenceForm["*BFGSUP ", 4.300825493093787, "  ", 7.418403415094216],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889576332608*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.1969958773562467`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.1969958773562467, " = Elastizitaet(d l/l)/(d theta/theta)"],
  
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895763661013`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889576431654*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "2"}],
  SequenceForm["BFGS: Iteration = ", 2],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895764901857`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.345563466068746\"\>",
     -1.345563466068746,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-1.345563466068746, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895765488243`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.350993112696159\"\>",
     -1.350993112696159,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-1.350993112696159, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889576606544*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.005429646627413\"\>",
     0.005429646627412854,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.005429646627412854, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889576656735*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889576710561*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7871\"\>",
         0.7871438751886284,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6328\"\>",
         0.6328489482402802,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1543\"\>",
         0.1542949269483483,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.2661\"\>",
         0.26614007353782654`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889576768553*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889576821912*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1.725\"\>",
         1.7248789626564942`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889576891144*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889576939681*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "6.103275884683512`*^-9"}],
  SequenceForm["NOISE  ", 6.103275884683512*^-9],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889576991927*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "15.823606117074533`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "24.352193182122097`"}],
  SequenceForm["*BFGSUP ", 15.823606117074533`, "  ", 24.352193182122097`],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889577042609*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.10660503304312387`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.10660503304312387`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889577091268*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889577142887*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "3"}],
  SequenceForm["BFGS: Iteration = ", 3],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895771921253`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.340623507142995\"\>",
     -1.340623507142995,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-1.340623507142995, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889577245204*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.345563466068746\"\>",
     -1.345563466068746,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-1.345563466068746, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889577298994*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.004939958925751\"\>",
     0.0049399589257510534`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.0049399589257510534`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889577348731*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889577424131*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7331\"\>",
         0.7331069468375422,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7871\"\>",
         0.7871438751886284,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0540\"\>",
         -0.05403692835108621,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.1434\"\>",
         -0.14344383776187897`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889577470394*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889577526725*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.655\"\>",
         2.65455202838145,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889577585705*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889577645232*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "2.649908514840149`*^-9"}],
  SequenceForm["NOISE  ", 2.649908514840149*^-9],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889577698193*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "169.6924296308766`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "129.01121036757237`"}],
  SequenceForm["*BFGSUP ", 169.6924296308766, "  ", 129.01121036757237`],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889577748959*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.0256511333642478`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.0256511333642478, " = Elastizitaet(d l/l)/(d theta/theta)"],
  
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895777982607`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895778479767`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "4"}],
  SequenceForm["BFGS: Iteration = ", 4],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889577899139*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.340382460108626\"\>",
     -1.340382460108626,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-1.340382460108626, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895779577208`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.340623507142995\"\>",
     -1.340623507142995,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-1.340623507142995, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889577997274*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000241047034369\"\>",
     0.00024104703436900188`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.00024104703436900188`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895780496817`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889578100314*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7161\"\>",
         0.7160674343463196,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7331\"\>",
         0.7331069468375422,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0170\"\>",
         -0.017039512491222628`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0344\"\>",
         -0.03438851237297058,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895781484413`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895781984997`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.018\"\>",
         2.018162925182557,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895782483253`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895783168087`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "6.120293161160362`*^-10"}],
  
  SequenceForm["NOISE  ", 6.120293161160362*^-10],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895783602743`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "1428.8634335449583`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "1706.590979922706`"}],
  SequenceForm["*BFGSUP ", 1428.8634335449583`, "  ", 1706.590979922706],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889578415824*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.004986695935824029`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.004986695935824029, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889578476674*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889578512248*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["BFGS: Iteration = ", 5],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895785656013`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.340373551383691\"\>",
     -1.340373551383691,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-1.340373551383691, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889578613716*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.340382460108626\"\>",
     -1.340382460108626,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-1.340382460108626, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889578665189*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     8.908724935086100\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-6\"\>"]}],
     8.908724935086099*^-6,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[8.908724935086099*^-6, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889578717367*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889578767177*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7188\"\>",
         0.718840413959674,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7161\"\>",
         0.7160674343463196,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0028\"\>",
         0.002772979613354442,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0067\"\>",
         0.0066840797662734985`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889578817224*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895788626213`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.41\"\>",
         2.410432350127466,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889578920999*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889578996059*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.0321610233177125`*^-10"}],
  SequenceForm["NOISE  ", 1.0321610233177125`*^-10],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889579031806*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "52062.61534205792`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "53952.51563569631`"}],
  SequenceForm["*BFGSUP ", 52062.61534205792, "  ", 53952.51563569631],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889579084074*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "0.00018102088590821896`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.00018102088590821896`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895791343403`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889579185131*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "6"}],
  SequenceForm["BFGS: Iteration = ", 6],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889579240438*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.340373539518717\"\>",
     -1.3403735395187173`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-1.3403735395187173`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.46088957931958*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -1.340373551383691\"\>",
     -1.340373551383691,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-1.340373551383691, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889579364912*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     1.186497367022810\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-8\"\>"]}],
     1.1864973670228096`*^-8,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[1.1864973670228096`*^-8, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889579416791*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889579492972*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.7187\"\>",
         0.7187432793789453,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.7188\"\>",
         0.718840413959674,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0001\"\>",
         -0.00009713458072869691,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0002\"\>",
         -0.0002426356077194214,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889579529756*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889579587413*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.498\"\>",
         2.497932311018237,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.46088957963447*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889579687427*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.640421297745888`*^-12"}],
  
  SequenceForm["NOISE  ", 3.640421297745888*^-12],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889579738501*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "4.272372787671431`*^7", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "4.242985957712627`*^7"}],
  SequenceForm["*BFGSUP ", 4.272372787671431*^7, "  ", 4.242985957712627*^7],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889579806169*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "1.2451230977822747`*^-6", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 1.2451230977822747`*^-6, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895798708153`*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889579922144*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889579982926*^9}],

Cell[BoxData["\<\"ReturnCode = 3\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895800178843`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS:  ENDE DER ITERATION  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "20"}],
  SequenceForm["BFGS:  ENDE DER ITERATION  ", 6, "  ", 20],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.46088958007444*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {"1", 
       RowBox[{"-", "1.6689300537109375`*^-6"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}]]]], "Print",\

 CellChangeTimes->{3.46071787611558*^9, 3.46088958013669*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889580188509*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 2.481\"\>",
         2.480750684853892,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889580235735*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"Likelihood\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm]},
      {"1", 
       RowBox[{"-", "1.4043582939516384`"}], "1"},
      {"2", 
       RowBox[{"-", "1.350993112696159`"}], "0.6328489482402802`"},
      {"3", 
       RowBox[{"-", "1.345563466068746`"}], "0.7871438751886284`"},
      {"4", 
       RowBox[{"-", "1.340623507142995`"}], "0.7331069468375422`"},
      {"5", 
       RowBox[{"-", "1.340382460108626`"}], "0.7160674343463196`"},
      {"6", 
       RowBox[{"-", "1.340373551383691`"}], "0.718840413959674`"},
      {"7", 
       RowBox[{"-", "1.3403735395187173`"}], "0.7187432793789453`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"Likelihood", "THETA"}}]]]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895802949657`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"INK: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "6.055454452393343`*^-6", "}"}]}],
  SequenceForm["INK: ", {6.055454452393343*^-6}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889580351842*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895804069843`*^9}],

Cell[BoxData["\<\"ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889580453579*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889580522017*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {
         StyleBox["\[Null]",
          ShowStringCharacters->False], 
         TagBox["\<\"THETA\"\>",
          HoldForm], 
         TagBox["\<\"SCORE\"\>",
          HoldForm]},
        {"1", "0.7187432793789453`", 
         RowBox[{"-", "1.6689300537109375`*^-6"}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxDividers->{
        "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
         "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.24]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
     "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[
     BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}]]], 
   "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "1.3403735395187173`"}]}],
  SequenceForm[
   MatrixForm[{{0.7187432793789453, -1.6689300537109375`*^-6}}, 
    TableHeadings -> {Automatic, {"THETA", "SCORE"}}], 
   "   Likelihood = ", -1.3403735395187173`],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889580571207*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895806445007`*^9}],

Cell[BoxData["\<\"WALD-TEST:\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889580700398*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889580750293*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"CHI \"\>",
       HoldForm], 
      TagBox["\<\"U \"\>",
       HoldForm], 
      TagBox["\<\"PROB \"\>",
       HoldForm], 
      TagBox["\<\"ALPHA \"\>",
       HoldForm]},
     {"1", "1.2820640960836427`", "1", "0.25751560405763996`", "0.05`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", "ALPHA "}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889580798471*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889580854005*^9}],

Cell[BoxData["\<\"BONFERRONI-KONFIDENZINTERVALLE:\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889580907103*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895809754667`*^9}],

Cell[BoxData["\<\"P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= \
1-ALPHA\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889581037005*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"QUANTIL Z(1-ALPHA/2U) = \"\>", "\[InvisibleSpace]", 
   "1.9599639845400527`"}],
  SequenceForm["QUANTIL Z(1-ALPHA/2U) = ", 1.9599639845400527`],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889581070304*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"THETA\"\>",
       HoldForm], 
      TagBox["\<\"GRENZE\"\>",
       HoldForm], 
      TagBox["\<\"STD\"\>",
       HoldForm]},
     {"1", "0.7187432793789453`", "1.2441335991907585`", "0.6347737045192292`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889581128356*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889581179356*^9}],

Cell[BoxData["\<\"Korrelation der ML-Sch\[ADoubleDot]tzer\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889581239418*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895813007936`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0.9999999999999998`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889581349125*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895814098597`*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND \
EIGENWERTE\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.46088958146795*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889581521378*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0.40293765594906567`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889581608027*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889581647901*^9}],

Cell[BoxData[
 RowBox[{"{", "0.40293765594906567`", "}"}]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889581713242*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889581765007*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX \
UND EIGENWERTE\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895818261013`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889581881062*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "2.4817735082233354`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889581942457*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889581999795*^9}],

Cell[BoxData[
 RowBox[{"{", "2.4817735082233354`", "}"}]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889582050908*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889582105793*^9}],

Cell[BoxData["\<\"KOMPENSIERTE LIKELIHOOD\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889582192765*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.4608895822279654`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"U =  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  Nue = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["U =  ", 1, "  Nue = ", 1],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889582282143*^9}],

Cell[BoxData["\<\"AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) \
AZENCOTT/DACUNHA-CASTELLE (A/D)\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889582334697*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"LIK\"\>",
       HoldForm], 
      TagBox["\<\"AIC\"\>",
       HoldForm], 
      TagBox["\<\"SIC/RISS\"\>",
       HoldForm], 
      TagBox["\<\"A/D\"\>",
       HoldForm]},
     {
      TagBox["\<\"Kompensator\"\>",
       HoldForm], "0", "1", "0.`", "Indeterminate"},
     {
      TagBox["\<\"komp. Lik.\"\>",
       HoldForm], 
      RowBox[{"-", "1.3403735395187173`"}], 
      RowBox[{"-", "2.3403735395187173`"}], 
      RowBox[{"-", "1.3403735395187173`"}], "Indeterminate"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {{"Kompensator", "komp. Lik."}, {
      "LIK", "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
    TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889582385297*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "1", "0.7187432793789453`", "0.6347737045192292`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.4603673130895653`*^9, 3.4607175575060387`*^9, {3.460717623410822*^9, 
   3.460717631849646*^9}, 3.4607177103844147`*^9, 3.460717770338664*^9, 
   3.460717831260625*^9, 3.460717899904481*^9, 3.460889583909008*^9}]
}, Open  ]],

Cell[BoxData["Linear"], "Input",
 CellChangeTimes->{{3.4603672747359133`*^9, 3.4603672757633257`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "scoreii", ",", "k", 
      ",", "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
    RowBox[{"BFGS", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"Y", ",", "X", ",", 
         RowBox[{"-", "9"}]}], "}"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      "\t  ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Idio", ",", 
          RowBox[{"{", "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Lik", ",", "IndividualLik", ",", "Score", ",", "Hesse"}], 
         "}"}]}], "}"}], ",", "\[IndentingNewLine]", "            ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Sing", "=", "False"}], ",", "1"}], "}"}], ",", 
        RowBox[{"KMAX", "=", "30"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EPS1", "=", ".0001"}], ",", 
          RowBox[{"EPS2", "=", ".0001"}]}], "}"}], ",", "\[IndentingNewLine]",
         "             ", 
        RowBox[{"OPTION", "=", "0"}], ",", 
        RowBox[{"PRINT", "=", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1"}], "}"}]}]}], "}"}]}], "]"}]}], ";"}], 
  "                                                                           \
     "}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113330285616*^9, 3.460113346379695*^9}, {
   3.460200648978776*^9, 3.4602006503583603`*^9}, {3.460200794874672*^9, 
   3.4602007984595947`*^9}, 3.460201903279232*^9, {3.460201941045977*^9, 
   3.4602019411313553`*^9}, {3.460279278878285*^9, 3.460279290392777*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Tiefe von data = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["Tiefe von data = ", 5],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9}],

Cell[BoxData["\<\"L\[ADoubleDot]nge der Paneldaten\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675009983*^9}],

Cell[BoxData[
 RowBox[{"{", "1", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675016033*^9}],

Cell[BoxData["\<\"***********************LSDE1********************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896750219088`*^9}],

Cell[BoxData["\<\"***********************MODUL:    BFGS \
(skeleton)**************\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675028345*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675034729*^9}],

Cell[BoxData["\<\"Technical Output\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896750414133`*^9}],

Cell[BoxData["IndividualLik"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675047635*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675054178*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"KMAX\"\>",
       HoldForm], 
      TagBox["\<\"EPS1\"\>",
       HoldForm], 
      TagBox["\<\"EPS2\"\>",
       HoldForm], 
      TagBox["\<\"K\"\>",
       HoldForm], 
      TagBox["\<\"Q\"\>",
       HoldForm], 
      TagBox["\<\"n\"\>",
       HoldForm], 
      TagBox["\<\"T\"\>",
       HoldForm], 
      TagBox["\<\"OPTION\"\>",
       HoldForm]},
     {"1", "30", "0.0001`", "0.0001`", "1", "1", "1", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"KMAX", "EPS1", "EPS2", "K", "Q", "n", "T", "OPTION"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896750615253`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675068489*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"MAXSTEP\"\>",
       HoldForm], 
      TagBox["\<\"MINSTEP\"\>",
       HoldForm], 
      TagBox["\<\"BOUND\"\>",
       HoldForm], 
      TagBox["\<\"STEPREDUCE\"\>",
       HoldForm], 
      TagBox["\<\"FMAX\"\>",
       HoldForm]},
     {"1", "1", "1.`*^-10", "1.`*^-6", "4", "1000"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"MAXSTEP", "MINSTEP", "BOUND", "STEPREDUCE", "FMAX"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675076219*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675083194*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"RESAMPLING\"\>",
       HoldForm], 
      TagBox["\<\"FDIGITS\"\>",
       HoldForm], 
      TagBox["\<\"TYP\"\>",
       HoldForm], 
      TagBox["\<\"YMAX\"\>",
       HoldForm], 
      TagBox["\<\"ANALGRAD\"\>",
       HoldForm], 
      TagBox["\<\"FACTOR\"\>",
       HoldForm], 
      TagBox["\<\"CSEED\"\>",
       HoldForm]},
     {"1", "True", "16", "1", "1.`*^8", "False", "1.`", 
      RowBox[{"-", "999"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {
      "RESAMPLING", "FDIGITS", "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}},
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896750898848`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.46088967509649*^9}],

Cell[BoxData["\<\"    SCALING\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675102573*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "::", "\<\"nmtx\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The first two levels of the \
one-dimensional list \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\
\\!\\({}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" cannot be \
transposed.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Transpose\\\", ButtonNote -> \\\"Transpose::nmtx\\\
\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.460113347438837*^9, 3.4601140477211742`*^9, 3.460114171488365*^9, 
   3.4601142582303123`*^9, 3.46011431981378*^9, 3.4601210026174927`*^9, 
   3.4602006082555428`*^9, 3.4602006525509787`*^9, 3.4602007997492933`*^9, {
   3.460201893745349*^9, 3.460201903902554*^9}, 3.4602019417761383`*^9, 
   3.460279294169009*^9, 3.4603672286821957`*^9, 3.4608896046990023`*^9, 
   3.4608896751100187`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  RowBox[{"Transpose", "[", 
   RowBox[{"{", "}"}], "]"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
    0]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675115801*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675119259*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675125437*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896751896152`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STARTWERT THETA0 = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1", "}"}]}],
  SequenceForm["STARTWERT THETA0 = ", {1}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675247135*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675314295*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"-", "0.3446913957595825`"}], "}"}], ",", 
   RowBox[{"-", "0.5018821976324617`"}]}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675361586*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896754141817`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["BFGS: Iteration = ", 1],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896754670553`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -0.395939208596315\"\>",
     -0.3959392085963154,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-0.3959392085963154, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675542905*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -0.501882197632462\"\>",
     -0.5018821976324617,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-0.5018821976324617, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675582533*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.105942989036146\"\>",
     0.1059429890361463,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.1059429890361463, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675636139*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675683777*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.6553\"\>",
         0.6553086042404175,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\"-0.3447\"\>",
         -0.3446913957595825,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.3447\"\>",
         -0.3446913957595825,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675717567*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.46088967575287*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896757853937`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675817169*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "8.998697231810127`*^-9"}],
  SequenceForm["NOISE  ", 8.998697231810127*^-9],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896758493977`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "33.93532328015516`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "8.416647035272595`"}],
  SequenceForm["*BFGSUP ", 33.93532328015516, "  ", 8.416647035272595],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675881501*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.6546483584337595`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.6546483584337595, " = Elastizitaet(d l/l)/(d theta/theta)"],
  
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675922566*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675966114*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "2"}],
  SequenceForm["BFGS: Iteration = ", 2],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896760120907`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -0.333765021813102\"\>",
     -0.3337650218131024,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-0.3337650218131024, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889676047776*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -0.395939208596315\"\>",
     -0.3959392085963154,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-0.3959392085963154, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889676079629*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.062174186783213\"\>",
     0.06217418678321296,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.06217418678321296, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889676111792*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889676143999*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\"-0.3447\"\>",
         -0.3446913957595823,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.6553\"\>",
         0.6553086042404175,
         AutoDelete->True], 
        InterpretationBox["\<\"-1.0000\"\>",
         -0.9999999999999998,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.2592\"\>",
         -0.25920095294713974`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889676176879*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896762088203`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.248\"\>",
         0.24802024031975312`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896762498503`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889676304853*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "5.904119582123002`*^-9"}],
  SequenceForm["NOISE  ", 5.904119582123002*^-9],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896763370743`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "2.523858297004463`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "4.031929001886211`"}],
  SequenceForm["*BFGSUP ", 2.523858297004463, "  ", 4.031929001886211],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889676368416*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.4105217628407304`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.4105217628407304, " = Elastizitaet(d l/l)/(d theta/theta)"],
  
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889676400483*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889676446357*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "3"}],
  SequenceForm["BFGS: Iteration = ", 3],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889676494193*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -0.310617453170668\"\>",
     -0.3106174531706676,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-0.3106174531706676, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889676527073*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -0.333765021813102\"\>",
     -0.3337650218131024,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-0.3337650218131024, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896765596027`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.023147568642435\"\>",
     0.023147568642434835`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.023147568642434835`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889676598715*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889676643076*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.0011\"\>",
         0.001122128553315782,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.3447\"\>",
         -0.3446913957595823,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.3458\"\>",
         0.3458135243128981,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1370\"\>",
         0.13701780512928963`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889676685728*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896767318573`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.3962\"\>",
         0.3962187580764295,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889676774597*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889676805107*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "2.048057834436179`*^-9"}],
  SequenceForm["NOISE  ", 2.048057834436179*^-9],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896768368998`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "21.03952459710586`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "21.104789250700314`"}],
  SequenceForm["*BFGSUP ", 21.03952459710586, "  ", 21.104789250700314`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889676869413*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.001368337618134047`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.001368337618134047, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889676908663*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889676955635*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "4"}],
  SequenceForm["BFGS: Iteration = ", 4],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889677002531*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -0.310617215231578\"\>",
     -0.3106172152315776,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-0.3106172152315776, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896770462723`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -0.310617453170668\"\>",
     -0.3106174531706676,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-0.3106174531706676, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896770792427`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     2.379390899864830\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-7\"\>"]}],
     2.3793908998648305`*^-7,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[2.3793908998648305`*^-7, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896771124783`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896771446257`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.0001\"\>",
         0.00005273147929338675,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0011\"\>",
         0.001122128553315782,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0011\"\>",
         -0.0010693970740223953`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0004\"\>",
         -0.00042502954602241516`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896771769876`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896772171164`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.3974\"\>",
         0.39744782957346503`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.46088967726134*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889677317316*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "6.631140081481135`*^-12"}],
  
  SequenceForm["NOISE  ", 6.631140081481135*^-12],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889677358521*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "2.308614925308565`*^6", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "2.2000972963179187`*^6"}],
  SequenceForm["*BFGSUP ", 2.308614925308565*^6, "  ", 2.2000972963179187`*^6],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896773894033`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "0.00006431946103101948`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.00006431946103101948, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889677430937*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889677478498*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889677530492*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["BFGS: Iteration = ", 5],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889677563346*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -0.310617214704978\"\>",
     -0.31061721470497816`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-0.31061721470497816`, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889677595923*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -0.310617215231578\"\>",
     -0.3106172152315776,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-0.3106172152315776, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889677647986*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     5.265994307279698\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-10\"\>"]}],
     5.265994307279698*^-10,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[5.265994307279698*^-10, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889677681342*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889677712619*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 0.0001\"\>",
         0.00005273147929338675,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0001\"\>",
         -0.0000527469558353914,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0000\"\>",
         -0.000019978731870651245`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889677745716*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889677776814*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.3788\"\>",
         0.3787655904351963,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889677808419*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.46088967783969*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "2.9770630405323573`*^-13"}],
  SequenceForm["NOISE  ", 2.9770630405323573`*^-13],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896778768387`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm["relgrad = ", 0., " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889677939498*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889677989171*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889678031003*^9}],

Cell[BoxData["\<\"ReturnCode = 3\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889678062964*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS:  ENDE DER ITERATION  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "30"}],
  SequenceForm["BFGS:  ENDE DER ITERATION  ", 5, "  ", 30],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889678093843*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {"1", "0.`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}]]]], "Print",\

 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889678126401*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.46088967815771*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.3788\"\>",
         0.3787655904351963,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889678196381*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"Likelihood\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm]},
      {"1", 
       RowBox[{"-", "0.5018821976324617`"}], "1"},
      {"2", 
       RowBox[{"-", "0.3959392085963154`"}], "0.6553086042404175`"},
      {"3", 
       RowBox[{"-", "0.3337650218131024`"}], 
       RowBox[{"-", "0.3446913957595823`"}]},
      {"4", 
       RowBox[{"-", "0.3106174531706676`"}], "0.001122128553315782`"},
      {"5", 
       RowBox[{"-", "0.3106172152315776`"}], "0.00005273147929338675`"},
      {"6", 
       RowBox[{"-", "0.31061721470497816`"}], 
       RowBox[{"-", "1.5476542004647597`*^-8"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"Likelihood", "THETA"}}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889678227605*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"INK: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "6.055454452393343`*^-6", "}"}]}],
  SequenceForm["INK: ", {6.055454452393343*^-6}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.46088967825896*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889678288527*^9}],

Cell[BoxData["\<\"ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889678332073*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889678378055*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {
         StyleBox["\[Null]",
          ShowStringCharacters->False], 
         TagBox["\<\"THETA\"\>",
          HoldForm], 
         TagBox["\<\"SCORE\"\>",
          HoldForm]},
        {"1", 
         RowBox[{"-", "1.5476542004647597`*^-8"}], "0.`"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxDividers->{
        "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
         "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.24]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
     "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[
     BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}]]], 
   "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "0.31061721470497816`"}]}],
  SequenceForm[
   MatrixForm[{{-1.5476542004647597`*^-8, 0.}}, 
    TableHeadings -> {Automatic, {"THETA", "SCORE"}}], 
   "   Likelihood = ", -0.31061721470497816`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889678418544*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889678467067*^9}],

Cell[BoxData["\<\"WALD-TEST:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889678496882*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889678526888*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"CHI \"\>",
       HoldForm], 
      TagBox["\<\"U \"\>",
       HoldForm], 
      TagBox["\<\"PROB \"\>",
       HoldForm], 
      TagBox["\<\"ALPHA \"\>",
       HoldForm]},
     {"1", "9.072321785577354`*^-17", "1", "0.9999999924002504`", "0.05`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", "ALPHA "}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889678566629*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889678598914*^9}],

Cell[BoxData["\<\"BONFERRONI-KONFIDENZINTERVALLE:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896786465187`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889678677503*^9}],

Cell[BoxData["\<\"P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= \
1-ALPHA\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889678717545*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"QUANTIL Z(1-ALPHA/2U) = \"\>", "\[InvisibleSpace]", 
   "1.9599639845400527`"}],
  SequenceForm["QUANTIL Z(1-ALPHA/2U) = ", 1.9599639845400527`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889678749956*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"THETA\"\>",
       HoldForm], 
      TagBox["\<\"GRENZE\"\>",
       HoldForm], 
      TagBox["\<\"STD\"\>",
       HoldForm]},
     {"1", 
      RowBox[{"-", "1.5476542004647597`*^-8"}], "3.184657989299821`", 
      "1.6248553618433803`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889678782189*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.46088967883212*^9}],

Cell[BoxData["\<\"Korrelation der ML-Sch\[ADoubleDot]tzer\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896788676643`*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889678901636*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "1.0000000000000002`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889678947826*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896789795732`*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND \
EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896790198107`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889679071617*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "2.6401549469111827`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889679122447*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889679171628*^9}],

Cell[BoxData[
 RowBox[{"{", "2.6401549469111827`", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889679221921*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889679271955*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX \
UND EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889679347938*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889679384614*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0.3787656482699767`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889679419367*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889679453402*^9}],

Cell[BoxData[
 RowBox[{"{", "0.3787656482699767`", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889679507698*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889679565727*^9}],

Cell[BoxData["\<\"KOMPENSIERTE LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889679600397*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896796348248`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"U =  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  Nue = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["U =  ", 1, "  Nue = ", 1],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896796688623`*^9}],

Cell[BoxData["\<\"AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) \
AZENCOTT/DACUNHA-CASTELLE (A/D)\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.4608896797030087`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"LIK\"\>",
       HoldForm], 
      TagBox["\<\"AIC\"\>",
       HoldForm], 
      TagBox["\<\"SIC/RISS\"\>",
       HoldForm], 
      TagBox["\<\"A/D\"\>",
       HoldForm]},
     {
      TagBox["\<\"Kompensator\"\>",
       HoldForm], "0", "1", "0.`", "Indeterminate"},
     {
      TagBox["\<\"komp. Lik.\"\>",
       HoldForm], 
      RowBox[{"-", "0.31061721470497816`"}], 
      RowBox[{"-", "1.3106172147049782`"}], 
      RowBox[{"-", "0.31061721470497816`"}], "Indeterminate"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {{"Kompensator", "komp. Lik."}, {
      "LIK", "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
    TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889679738483*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "1", 
       RowBox[{"-", "1.5476542004647597`*^-8"}], "1.6248553618433803`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.460113389973647*^9, 3.460114056100081*^9, 
  3.460114179071628*^9, 3.4601142697179193`*^9, 3.460114343759589*^9, 
  3.460121016537031*^9, 3.4602008503444023`*^9, 3.460201923221129*^9, 
  3.460201965915328*^9, 3.4602793122704687`*^9, 3.460889685603642*^9}]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["EDM/ h=sum theta(eta-ci)  (ordinal)", "Subsection",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460890802961763*^9, 3.4608908188954353`*^9}, {
  3.460891328104759*^9, 3.460891331572171*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", "Logistic"}]], "Input",
 CellChangeTimes->{{3.460434794971136*^9, 3.4604347955208197`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox["\<\"Logistic[x_]:= Module[{xx=Exp[-x]}, 1/(1+xx)]\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.4608913591684303`*^9},
 CellTags->"Info3460898558-4560556"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "Logistic", "]"}], "=", 
      RowBox[{"{", 
       RowBox[{"Listable", ",", "Protected"}], "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"Logistic", "[", "x_", "]"}], ":=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Hermann`Kronecker`Private`xx", "=", 
             RowBox[{"Exp", "[", 
              RowBox[{"-", "x"}], "]"}]}], "}"}], ",", 
           FractionBox["1", 
            RowBox[{"1", "+", "Hermann`Kronecker`Private`xx"}]]}], "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[Hermann`Kronecker`Logistic],
  Editable->False]], "Print",
 CellChangeTimes->{3.460891359241466*^9},
 CellTags->"Info3460898558-4560556"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Heaviside", "[", 
  RowBox[{"{", 
   RowBox[{"0", ",", "0"}], "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Logistic", "[", 
    RowBox[{"100", 
     RowBox[{"{", " ", 
      RowBox[{"x", ",", 
       RowBox[{"10", " ", "x"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.460280327728023*^9, 3.460280341674404*^9}, {
  3.460434466158127*^9, 3.460434495620612*^9}, {3.4604345344447107`*^9, 
  3.4604345363154173`*^9}, {3.4604347450454597`*^9, 3.460434759093851*^9}, {
  3.460434831060215*^9, 3.4604349201005907`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["1", "2"], ",", 
   FractionBox["1", "2"]}], "}"}]], "Output",
 CellChangeTimes->{
  3.460434496327834*^9, 3.460434537579938*^9, 3.460434571430604*^9, 
   3.460434760012538*^9, 3.4604348407942944`*^9, {3.460434872905922*^9, 
   3.460434920637085*^9}, 3.460460119454465*^9, {3.460701396968033*^9, 
   3.4607014166096287`*^9}, 3.460701818816984*^9, 3.46071252296481*^9, 
   3.460864787771489*^9, 3.4608913596316347`*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJw9zn0803kAB/BVr5Ruh0QhNFIk4ZLrtvb7fZFOx6vkMXk4K6F0N2KX1ykp
zzuPKeo8pVIbaXmah2b7egp1YiZP60jOhiXT6HCMM/e6fV6vz+vzev/30TsX
7Oy/HoPBuK1WtlkV53JS6EJ48ITaedCcjB8adC9hhAuhghbnZzvdbPxyxyed
I3uF8GMYOPrhcRletz42rfWtAEYxPm+/ONCKR8t2rnONEUCVlJuzfjrD+DuW
2bsWjAUwJcQtyrxsDv+xVgPN543CEHOpKDloK+Feo/rVcb1RuF69jpHHsyF8
7lb+cq1+BHKp4wmuS48JdX8/qeoyGYZPZ5rX/ThIOhIW8IXT18SH0phbNap+
+4gqKVsqSWp8+MG69JFbnA2xpGJX0cT5AdjpH9i2tNGLKMTY317c2A+3HnwQ
ONaUTIwx9E2Mde+D2n6pAUeXCom4k5TIr2m9MD/L0TA9n0NkU6ihWXM9UEIw
6E5y7yV65uQH7jreA69/IdPHHaaJ0pvap8IK30Kf7B3FF3AKSMGF7O9aMW/h
vAO7cWCLLnLUUUNvp083PJAfRcD5H0KEllmKwbU8yDMiMRdLHRCqtpqkUZ0H
z+BcoxLbzyEmGzL420O7oKM3k3w4/lekc0K5KaiDC3ffV44UudxCQrkpTznG
XHindsZpMJ6GbGAx3yVIOqBpXW+AHakB0e9xJGWkvYHdB6IvlRYPIFbiidFc
k3aY6E7fMTIrQXwVYy/SXr2GFvoFz05jsOj13bpTZQGvICaOpmjPMEBzkZrQ
ug1tcNbwjKdXMoqyTjvPtRS0wEDtg3v709xR/uXJq13IS6h04/Dt3qIQdCPW
Y+yypAl67BkW3x2LR82fNDmr0hrh4NaIf1qv3kc9rcw45V4N8HgtvcH2ERON
42fvc1Gph+/v4ihz7DcoaQJrPEZlw83W9jr9IaNolc4oxmjmBaw22/ygWGMJ
xTqz+i5418ArIxZsDcdt4Gx8BqPoJRNafH+DXEg1BiX3ROazRyrgsS1pvOT3
1mC+2KYCLS+Fmh15rBfKHiAxwvKSqlMJfEA63FO7PwTg7guCaQgN2swx2eqP
40B1UyaFaPwQKpCFC0q0XJDHTZI8PJAN4/9Q+4gjl4N2zcnFdoV0GNwT0bVb
vwWIkr5R/zMqHOYGS8N/UekDSGWM0540CugJY2qPT/0FNBElBtUwHej8kOek
GC8C+imsTfb7c8AzUy08VvAJZJErzeN2PAJR3yK0fiAGOduTfPx/pwPV4YJ8
MlsMCjhnfzu2kwHKbRtOmEyIgbNF7ruMjjKgtexqbjEvBm4JmyTRaZXA7+Lm
aHepGFi96yTY6VWDlhbcPoUVMTA2uxfzVUUtoFNdLhWuWi2G1N5pWwew19LJ
Q6te7jVSv9PLAYoOluUzq6ZkzpuaVNYDNWFU5OKqg6C3i5K0AZgP9Xosr9p3
oj58+lgTGMIIz6+s2nXbnlxeajO4Fbe3VeaQaRHWeeYluMntn5Q5+U1pZNfp
VvB8W/KCzPTiK1On6tqAAaVbKnNzAtGXi3sNXly3XZF5ybrNqnOiHcRWi9Zs
ueSi31HeCVIzpWv24R+y887kAdLcypoLqkCkk1MPGFn5z68zaAKtoT6AWcs0
mCUrnxwN4sv9UxnBcdx0UG7BjP+pScl7uV2ILK+TqSNyrxcoGJ31FMjNet51
PEhzXG7viIUcuyKR3A5PRxN8Qz7JbVB1+5lZzZTcy/U23bKf//tfYVGyOA==

     "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQBGIQPW1z0uzeFc/2F+nvNr/MJ8Zw727YmnXlz/YbZ3D9
cTu9gOHfubey1mrP9vetyH/SE9TKKHegpf/4laf7d0S3sWQJZTPZbZRmDGl+
un/vFFH+KfqBzFNMZ8n/1Hq639N2RZx6uCfL650SdvMuPdk/e1f91UXrnFhn
HBKtfqH4ZH91xcOF3P4m7B8v83+tOfBo/6K57l0n/4tz7/m2bNtFnQf7ncIP
6JSLRgsVp33dd/3wrf0L+jMar3lYSkXNnpcu73F1f8qRbtEFlp8Viy70rt6n
dWH/jaNvdmcuUNe8Vfim+qLt0f3CFw8KMLD+MEhsm7Ru5dGt++8Gz5R6s9vZ
Ys2MVwZfrDfvv3D6aO3SMA3LH6ucNttt2rD/lk5KXwoLn5XC/Kf5y22X71+3
xXypz5Vr1tsPTy2x0Vq0/1Xofa7n6nts5l7o/rRId9b+DWW9jFdjFtqekXzz
+wzbhP1iup+zX2S22r3qNhS9U1++f5HgnRDr4Cx72y3Ngar9JfaH4ox/mZ16
by9py7euU32C/eplaVv+/39vr9S7m91Le7Z9wbT//0H8aXlbDFrFF9szgMEH
+wX7ErtcpdfB+aHt7J+a+rfA+f+uaYhOubYPzg8RVp1zqe8InG/6J1jp3Kbz
CPO22dcGBl6F87/k8fs9yboF5z/9nBrw5tN9OD/YZne0X98jOJ/pKZtGYtRT
OH/3+oseWZIv4PyYqp+z3Ve+gvO9Vz9pjy94C+erbJu8Vn/HO4T7DzhdBvkb
xgcAHTMm+g==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.460434496327834*^9, 3.460434537579938*^9, 3.460434571430604*^9, 
   3.460434760012538*^9, 3.4604348407942944`*^9, {3.460434872905922*^9, 
   3.460434920637085*^9}, 3.460460119454465*^9, {3.460701396968033*^9, 
   3.4607014166096287`*^9}, 3.460701818816984*^9, 3.46071252296481*^9, 
   3.460864787771489*^9, 3.460891359651112*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Heaviside", "[", "0", "]"}]], "Input",
 CellChangeTimes->{{3.4606086136810217`*^9, 3.460608636136427*^9}}],

Cell[BoxData[
 FractionBox["1", "2"]], "Output",
 CellChangeTimes->{{3.460608617276992*^9, 3.460608636631384*^9}, {
   3.460701397056037*^9, 3.460701416680518*^9}, 3.460701818885385*^9, 
   3.460712523223983*^9, 3.46086478785963*^9, 3.460891359723319*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Plus", "@@", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Heaviside", "[", 
       RowBox[{"x", "-", "#"}], "]"}], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{"c1", ",", "c2"}], "}"}]}], "]"}]}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"x", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"x1", ",", "x2"}], "}"}]}], ",", 
    RowBox[{"c1", "->", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "2"}]}], "}"}]}], ",", 
    RowBox[{"c2", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.4602804139401493`*^9, 3.460280447538992*^9}, {
  3.460280544317827*^9, 3.460280657628171*^9}, {3.460434506601823*^9, 
  3.4604345076725397`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"Sign", "[", "x1", "]"}]}], ")"}]}], "+", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"Sign", "[", 
         RowBox[{"1", "+", "x1"}], "]"}]}], ")"}]}]}], ",", 
    RowBox[{
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"Sign", "[", "x2", "]"}]}], ")"}]}], "+", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"Sign", "[", 
         RowBox[{"1", "+", "x2"}], "]"}]}], ")"}]}]}]}], "}"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.460280411758966*^9, 3.4602804482063417`*^9}, {
   3.46028057425738*^9, 3.460280658292327*^9}, 3.46028563184229*^9, 
   3.4602857219474*^9, 3.460285983590343*^9, 3.460286266378318*^9, 
   3.460286301805153*^9, 3.460363891030834*^9, 3.460377024341406*^9, 
   3.460434509256716*^9, 3.460434571668792*^9, 3.460460119542832*^9, {
   3.460701397136538*^9, 3.460701416729549*^9}, 3.460701818939452*^9, 
   3.4607125233090467`*^9, 3.460864787910483*^9, 3.460891359808722*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Heaviside", "[", 
     RowBox[{"x", "+", "1"}], "]"}], "+", 
    RowBox[{"Heaviside", "[", 
     RowBox[{"x", "-", "1"}], "]"}], "-", "1"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
   RowBox[{"Axes", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.460280204140476*^9, 3.460280237625312*^9}, {
  3.460280316434142*^9, 3.4602803948226748`*^9}, {3.460281179896861*^9, 
  3.460281180607788*^9}, {3.460281264433981*^9, 3.460281466138386*^9}, {
  3.4604345209580584`*^9, 3.4604345275791397`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAGIQvV+g6N7//+wHGMDgw36L7ULyxzkR/A2xm+P7hNng
/GeySe82/GWG8/XlvMNNuJng/A9HrjDUKzHA+W/3Ts/frfBnP4wvV/RropXz
Dzi/xn6mAZ/2Nzj/Fo/F+YdCX+D8o8eu263n/gznb2goX1fD8gnOXxbrnva4
4SOcP8dKXM7r7wc4f5L486sbKhF8vpe50vpv3kP5wDA4rPVjzbd3cP73Oc+v
aDEi+A8CEvvUxN7A+Rt3hDDKObyA8y+temS56859OP/Kk7dO9iEX4PwFmk/5
n86fCOe/8uLOdrl+zh7G/zzH/JX1tXtwvsrffTOljj2H8/fyM/dNO/MCzg9T
cm8SuvwSzu9wP5/F9eA1nK8YJRzf9uwNnL8rJzyY6e1bOD+ofrZ73ed3cP7r
ifetf/18D+fbOjU/TCr/AOV/sG/dLbb0xEcE/6zJqgy9nI9wvug6W50pzxD8
pQtSNsff/gTnm07uttK+8BnOF2DNsdZ7/BXOf1XmY2P47TucX3VrRmfp1d9w
/gFt1nsnmBkcYPxTznO38QszwfmHpH9v+fqPGc4vbXi91F2EDc6fdULvkDIX
O5wPTe9wPgDcCfWB
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.460280319796722*^9, 3.460280354786551*^9, {3.460280389749917*^9, 
   3.460280394994143*^9}, 3.4602811810928717`*^9, 3.460281274494234*^9, {
   3.460281308314047*^9, 3.460281466274333*^9}, 3.460285631915004*^9, 
   3.4602857220189037`*^9, 3.460285983666174*^9, 3.460286266453809*^9, 
   3.460286301892166*^9, 3.460363891107939*^9, 3.460377024417347*^9, 
   3.4604345292437963`*^9, 3.4604345717561197`*^9, 3.46046011964497*^9, {
   3.460701397236611*^9, 3.460701416807397*^9}, 3.4607018190162983`*^9, 
   3.460712523390944*^9, 3.460864787988351*^9, 3.4608913599004602`*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "Idio", "]"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Idio", "[", 
   RowBox[{"th_", ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "beta", ",", "gamma", ",", "sigma", ",", "\[IndentingNewLine]", 
      "             ", "sigmazeta", ",", "lambdaeta", ",", "taueta", ",", 
      "sigmaepsilon"}], "}"}], ",", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"beta", "=", 
      RowBox[{"{", 
       RowBox[{"{", "0", "}"}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"gamma", "=", 
      RowBox[{
       RowBox[{"{", "0", "}"}], "//", "Spalte"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"sigmazeta", "=", "I1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"lambdaeta", "=", "I1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"taueta", "=", 
      RowBox[{
       RowBox[{"{", "0", "}"}], "//", "Spalte"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"sigmaepsilon", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"th", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "^", "2"}], "I1"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"lambdaeta", ",", "taueta", ",", "sigmaepsilon"}], "}"}]}], 
      "}"}]}]}], "\[IndentingNewLine]", "]"}]}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460112411326638*^9, 3.460112486848282*^9}, {
   3.460112574501026*^9, 3.460112833350883*^9}, 3.460113258604714*^9, {
   3.4601981935531387`*^9, 3.4601982253887444`*^9}, {3.46019833150395*^9, 
   3.460198339518457*^9}, {3.460198463453682*^9, 3.460198495668239*^9}, {
   3.4602012679397707`*^9, 3.4602012745935698`*^9}, {3.460437742137166*^9, 
   3.4604377442837257`*^9}, {3.460459421523945*^9, 3.460459423450386*^9}, {
   3.460547952763468*^9, 3.4605479815918913`*^9}, 3.4608896552166653`*^9},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"IdioNonlin", ",", "eta"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"IdioNonlin", "[", 
   RowBox[{"th_", ",", 
    RowBox[{"{", "}"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "beta", ",", "gamma", ",", "sigma", ",", "\[IndentingNewLine]", 
      "             ", "sigmazeta", ",", "lambdaeta", ",", "taueta", ",", 
      "sigmaepsilon", ",", "x", ",", "theta", ",", "h", ",", "dh"}], "}"}], 
    ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"beta", "=", 
      RowBox[{"{", 
       RowBox[{"{", "0", "}"}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"gamma", "=", 
      RowBox[{
       RowBox[{"{", "0", "}"}], "//", "Spalte"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"sigmazeta", "=", "I1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"c1", "=", 
      RowBox[{"{", 
       RowBox[{"-", "1"}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"c2", "=", 
      RowBox[{"{", "0", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"c3", "=", 
      RowBox[{"{", "1", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"h", "[", 
         RowBox[{"eta_", ",", "x_", ",", "theta_"}], "]"}], ":=", 
        RowBox[{
         RowBox[{"Plus", "@@", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Logistic", "[", 
              RowBox[{"100", 
               RowBox[{"(", 
                RowBox[{"eta", "-", "#"}], ")"}]}], "]"}], "&"}], ",", 
            RowBox[{"{", 
             RowBox[{"c1", ",", "c2"}], "}"}]}], "]"}]}], "-", "1"}]}], ";"}],
       "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"h", "[", 
       RowBox[{"eta_", ",", "x_", ",", "theta_"}], "]"}], ":=", 
      RowBox[{
       RowBox[{"Plus", "@@", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Heaviside", "[", 
            RowBox[{"(", 
             RowBox[{"eta", "-", "#"}], ")"}], "]"}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{"c1", ",", "c2", ",", "c3"}], "}"}]}], "]"}]}], "-", 
       "1"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
        RowBox[{"h", "[", 
         RowBox[{"eta_", ",", "x_", ",", "theta_"}], "]"}], ":=", 
        RowBox[{"eta", "-", 
         RowBox[{"eta", "^", "3"}]}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"P", ",", "Q"}], "}"}], "=", 
      RowBox[{"gamma", "//", "Dimensions"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Off", "[", 
      RowBox[{"Part", "::", "\"\<partd\>\""}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"etai", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"eta", "[", 
         RowBox[{"[", "i", "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "P"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"hilf", "=", 
      RowBox[{"Outer", "[", 
       RowBox[{"D", ",", 
        RowBox[{"h", "[", 
         RowBox[{"etai", ",", "x", ",", "theta"}], "]"}], ",", "etai"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"dh", "[", 
       RowBox[{"eta_", ",", "x_", ",", "theta_"}], "]"}], "=", "hilf"}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"sigmaepsilon", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"th", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "^", "2"}], "I1"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"h", ",", "dh", ",", "sigmaepsilon"}], "}"}]}], "}"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460112411326638*^9, 3.460112486848282*^9}, {
   3.460112574501026*^9, 3.460112833350883*^9}, 3.460113258604714*^9, {
   3.4601981935531387`*^9, 3.4601982253887444`*^9}, {3.46019833150395*^9, 
   3.460198339518457*^9}, {3.460198463453682*^9, 3.460198495668239*^9}, {
   3.4602012679397707`*^9, 3.4602012745935698`*^9}, {3.460262544333317*^9, 
   3.460262672020108*^9}, {3.4602627586317263`*^9, 3.46026276001101*^9}, {
   3.4602704141975107`*^9, 3.46027041438337*^9}, {3.460280467176902*^9, 
   3.460280473085874*^9}, {3.4602806924891443`*^9, 3.460280711976782*^9}, {
   3.46028116644274*^9, 3.460281167729628*^9}, {3.460281474946793*^9, 
   3.460281508316875*^9}, {3.4602815479174967`*^9, 3.4602815484137983`*^9}, {
   3.4602816507807617`*^9, 3.460281676993616*^9}, {3.460284307808282*^9, 
   3.460284309899661*^9}, {3.4602847275090322`*^9, 3.460284736183663*^9}, {
   3.4602856192308903`*^9, 3.460285624220776*^9}, {3.460285710934456*^9, 
   3.460285717823205*^9}, {3.4602859764427147`*^9, 3.460285978161388*^9}, {
   3.460286261013752*^9, 3.460286261455785*^9}, {3.4602862948772097`*^9, 
   3.46028629819168*^9}, 3.4603642740349617`*^9, 3.4603644544831877`*^9, 
   3.460365456780478*^9, 3.4603665095654716`*^9, {3.460366607243189*^9, 
   3.4603666125853157`*^9}, {3.4603697272002287`*^9, 3.460369730933084*^9}, {
   3.46037151872565*^9, 3.460371519963439*^9}, {3.460373536249193*^9, 
   3.46037353630791*^9}, {3.460377010128886*^9, 3.4603770349211197`*^9}, {
   3.460377168908317*^9, 3.460377169368896*^9}, 3.46037765815534*^9, 
   3.460431475811249*^9, {3.4604319304909678`*^9, 3.4604319341933823`*^9}, {
   3.460432429495256*^9, 3.460432430269183*^9}, {3.4604331102297277`*^9, 
   3.4604331102918997`*^9}, {3.460433492904319*^9, 3.460433500341628*^9}, {
   3.4604343556223097`*^9, 3.460434355679142*^9}, {3.460434545548963*^9, 
   3.460434546745728*^9}, {3.46043493786023*^9, 3.460434967965836*^9}, {
   3.460435089839349*^9, 3.460435118610239*^9}, {3.460437529942061*^9, 
   3.4604375424215612`*^9}, 3.460438912806677*^9, 3.460439035722678*^9, {
   3.4604393410536213`*^9, 3.460439342272788*^9}, 3.460439840453356*^9, {
   3.460440333630175*^9, 3.460440355270155*^9}, {3.4604590838600483`*^9, 
   3.4604590936409283`*^9}, {3.46045943423339*^9, 3.460459435215295*^9}, {
   3.460460115325142*^9, 3.460460115390798*^9}, {3.460547992936483*^9, 
   3.460548038244534*^9}, {3.460548359779351*^9, 3.4605483699587107`*^9}, {
   3.460607630987466*^9, 3.4606076310422907`*^9}, {3.460608028038039*^9, 
   3.4606080556295424`*^9}, 3.460608089104917*^9, {3.460608139554899*^9, 
   3.4606081483374147`*^9}, {3.460608214125181*^9, 3.460608226072637*^9}, {
   3.460608705678046*^9, 3.460608717278057*^9}, {3.460619616995446*^9, 
   3.460619658298368*^9}, {3.460619735227*^9, 3.460619739401353*^9}, {
   3.4606231103903027`*^9, 3.460623110906802*^9}, {3.460690346282659*^9, 
   3.460690419159034*^9}, {3.4606905257299547`*^9, 3.4606906307676983`*^9}, {
   3.460690786155035*^9, 3.460690811739747*^9}, {3.460690873004724*^9, 
   3.460691043764667*^9}, {3.4606966176838903`*^9, 3.460696618983362*^9}, {
   3.460697850245064*^9, 3.460697850302597*^9}, {3.460700187295094*^9, 
   3.4607002046616793`*^9}, {3.4607018108184977`*^9, 
   3.4607018108805733`*^9}, {3.460712535147476*^9, 3.460712535219802*^9}, 
   3.460713023647132*^9, 3.460713884919587*^9, {3.460718120812653*^9, 
   3.460718129370597*^9}, {3.460865844261911*^9, 3.460865862403343*^9}, {
   3.460889824238564*^9, 3.460889838019496*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dh", "[", 
  RowBox[{
   RowBox[{"{", "eta", "}"}], ",", "0", ",", "theta"}], "]"}]], "Input",
 CellChangeTimes->{{3.4606913943823147`*^9, 3.460691410341382*^9}, {
  3.460889868368339*^9, 3.460889878726543*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"1", "-", 
    RowBox[{"3", " ", 
     SuperscriptBox["eta", "2"]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.460691388658765*^9, 3.460691411092546*^9}, 
   3.4607002107195787`*^9, {3.460701397406048*^9, 3.460701416970748*^9}, 
   3.460701819196553*^9, 3.460712523556485*^9, {3.460864788229685*^9, 
   3.460864804059931*^9}, {3.460889843042243*^9, 3.460889879874631*^9}, 
   3.460891360097748*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Clear", "[", 
  RowBox[{"h", ",", "dh"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"h", ",", "dh", ",", "sigmaepsilon"}], "}"}]}], "}"}], "=", 
   RowBox[{"IdioNonlin", "[", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}]}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{"beta", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"gamma", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"sigmazeta", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"sigmaepsilon", "//", "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"h", "[", 
       RowBox[{
        RowBox[{"{", "x", "}"}], ",", "0", ",", "theta"}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", 
     RowBox[{
      RowBox[{"dh", "[", 
       RowBox[{
        RowBox[{"{", "x", "}"}], ",", "0", ",", "theta"}], "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.46011249354161*^9, 3.460112502635364*^9}, {
   3.460112738246236*^9, 3.460112740427596*^9}, {3.4601985014479733`*^9, 
   3.4601985021073637`*^9}, {3.460262678368519*^9, 3.460262744386445*^9}, {
   3.460270452868237*^9, 3.460270456266705*^9}, {3.46028153495817*^9, 
   3.4602816223627872`*^9}, {3.460284322897622*^9, 3.4602843302074947`*^9}, {
   3.460548484950382*^9, 3.460548486261179*^9}, {3.460608728173007*^9, 
   3.4606087292975283`*^9}, {3.460690405244627*^9, 3.460690406366933*^9}, {
   3.4606910751289682`*^9, 3.460691083080337*^9}, 3.4606913598661013`*^9, {
   3.46089138125605*^9, 3.460891385940321*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", "0", "}"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", "0", "}"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", "1", "}"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"h$6769747", ",", "dh$6769747", ",", 
     RowBox[{"{", 
      RowBox[{"{", "1", "}"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, {
   3.460548021222658*^9, 3.460548040796109*^9}, 3.460548374878003*^9, 
   3.460548406506942*^9, 3.460548487069503*^9, 3.460607637374864*^9, {
   3.460608045966167*^9, 3.4606080584538183`*^9}, 3.46060809217841*^9, {
   3.460608142532516*^9, 3.460608150079648*^9}, {3.4606081896361923`*^9, 
   3.460608228433215*^9}, 3.460608418281057*^9, 3.460608655937346*^9, 
   3.460608730822871*^9, {3.460619630850037*^9, 3.4606196602967854`*^9}, 
   3.460619746403996*^9, 3.460623113839085*^9, 3.46069042381326*^9, 
   3.46069063707929*^9, {3.4606907970240583`*^9, 3.460690817321019*^9}, 
   3.460690876868802*^9, {3.4606909173516817`*^9, 3.46069094205059*^9}, {
   3.4606910004991207`*^9, 3.460691050887487*^9}, 3.46069108323332*^9, {
   3.460691355605454*^9, 3.4606913606607523`*^9}, 3.460696622255847*^9, 
   3.460697853635994*^9, 3.4607002219193287`*^9, {3.460701397461886*^9, 
   3.460701423907084*^9}, {3.460701819255274*^9, 3.460701824911387*^9}, {
   3.460712523625782*^9, 3.4607125391126328`*^9}, 3.460713027007635*^9, 
   3.460713888382205*^9, 3.46071813317126*^9, {3.460864788295946*^9, 
   3.460864807844152*^9}, {3.460865849613262*^9, 3.460865865750284*^9}, 
   3.460889846600136*^9, {3.460891360175969*^9, 3.460891387119933*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, {
   3.460548021222658*^9, 3.460548040796109*^9}, 3.460548374878003*^9, 
   3.460548406506942*^9, 3.460548487069503*^9, 3.460607637374864*^9, {
   3.460608045966167*^9, 3.4606080584538183`*^9}, 3.46060809217841*^9, {
   3.460608142532516*^9, 3.460608150079648*^9}, {3.4606081896361923`*^9, 
   3.460608228433215*^9}, 3.460608418281057*^9, 3.460608655937346*^9, 
   3.460608730822871*^9, {3.460619630850037*^9, 3.4606196602967854`*^9}, 
   3.460619746403996*^9, 3.460623113839085*^9, 3.46069042381326*^9, 
   3.46069063707929*^9, {3.4606907970240583`*^9, 3.460690817321019*^9}, 
   3.460690876868802*^9, {3.4606909173516817`*^9, 3.46069094205059*^9}, {
   3.4606910004991207`*^9, 3.460691050887487*^9}, 3.46069108323332*^9, {
   3.460691355605454*^9, 3.4606913606607523`*^9}, 3.460696622255847*^9, 
   3.460697853635994*^9, 3.4607002219193287`*^9, {3.460701397461886*^9, 
   3.460701423907084*^9}, {3.460701819255274*^9, 3.460701824911387*^9}, {
   3.460712523625782*^9, 3.4607125391126328`*^9}, 3.460713027007635*^9, 
   3.460713888382205*^9, 3.46071813317126*^9, {3.460864788295946*^9, 
   3.460864807844152*^9}, {3.460865849613262*^9, 3.460865865750284*^9}, 
   3.460889846600136*^9, {3.460891360175969*^9, 3.460891387157242*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, {
   3.460548021222658*^9, 3.460548040796109*^9}, 3.460548374878003*^9, 
   3.460548406506942*^9, 3.460548487069503*^9, 3.460607637374864*^9, {
   3.460608045966167*^9, 3.4606080584538183`*^9}, 3.46060809217841*^9, {
   3.460608142532516*^9, 3.460608150079648*^9}, {3.4606081896361923`*^9, 
   3.460608228433215*^9}, 3.460608418281057*^9, 3.460608655937346*^9, 
   3.460608730822871*^9, {3.460619630850037*^9, 3.4606196602967854`*^9}, 
   3.460619746403996*^9, 3.460623113839085*^9, 3.46069042381326*^9, 
   3.46069063707929*^9, {3.4606907970240583`*^9, 3.460690817321019*^9}, 
   3.460690876868802*^9, {3.4606909173516817`*^9, 3.46069094205059*^9}, {
   3.4606910004991207`*^9, 3.460691050887487*^9}, 3.46069108323332*^9, {
   3.460691355605454*^9, 3.4606913606607523`*^9}, 3.460696622255847*^9, 
   3.460697853635994*^9, 3.4607002219193287`*^9, {3.460701397461886*^9, 
   3.460701423907084*^9}, {3.460701819255274*^9, 3.460701824911387*^9}, {
   3.460712523625782*^9, 3.4607125391126328`*^9}, 3.460713027007635*^9, 
   3.460713888382205*^9, 3.46071813317126*^9, {3.460864788295946*^9, 
   3.460864807844152*^9}, {3.460865849613262*^9, 3.460865865750284*^9}, 
   3.460889846600136*^9, {3.460891360175969*^9, 3.460891387214343*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, {
   3.460548021222658*^9, 3.460548040796109*^9}, 3.460548374878003*^9, 
   3.460548406506942*^9, 3.460548487069503*^9, 3.460607637374864*^9, {
   3.460608045966167*^9, 3.4606080584538183`*^9}, 3.46060809217841*^9, {
   3.460608142532516*^9, 3.460608150079648*^9}, {3.4606081896361923`*^9, 
   3.460608228433215*^9}, 3.460608418281057*^9, 3.460608655937346*^9, 
   3.460608730822871*^9, {3.460619630850037*^9, 3.4606196602967854`*^9}, 
   3.460619746403996*^9, 3.460623113839085*^9, 3.46069042381326*^9, 
   3.46069063707929*^9, {3.4606907970240583`*^9, 3.460690817321019*^9}, 
   3.460690876868802*^9, {3.4606909173516817`*^9, 3.46069094205059*^9}, {
   3.4606910004991207`*^9, 3.460691050887487*^9}, 3.46069108323332*^9, {
   3.460691355605454*^9, 3.4606913606607523`*^9}, 3.460696622255847*^9, 
   3.460697853635994*^9, 3.4607002219193287`*^9, {3.460701397461886*^9, 
   3.460701423907084*^9}, {3.460701819255274*^9, 3.460701824911387*^9}, {
   3.460712523625782*^9, 3.4607125391126328`*^9}, 3.460713027007635*^9, 
   3.460713888382205*^9, 3.46071813317126*^9, {3.460864788295946*^9, 
   3.460864807844152*^9}, {3.460865849613262*^9, 3.460865865750284*^9}, 
   3.460889846600136*^9, {3.460891360175969*^9, 3.4608913872803907`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "1"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, {
   3.460548021222658*^9, 3.460548040796109*^9}, 3.460548374878003*^9, 
   3.460548406506942*^9, 3.460548487069503*^9, 3.460607637374864*^9, {
   3.460608045966167*^9, 3.4606080584538183`*^9}, 3.46060809217841*^9, {
   3.460608142532516*^9, 3.460608150079648*^9}, {3.4606081896361923`*^9, 
   3.460608228433215*^9}, 3.460608418281057*^9, 3.460608655937346*^9, 
   3.460608730822871*^9, {3.460619630850037*^9, 3.4606196602967854`*^9}, 
   3.460619746403996*^9, 3.460623113839085*^9, 3.46069042381326*^9, 
   3.46069063707929*^9, {3.4606907970240583`*^9, 3.460690817321019*^9}, 
   3.460690876868802*^9, {3.4606909173516817`*^9, 3.46069094205059*^9}, {
   3.4606910004991207`*^9, 3.460691050887487*^9}, 3.46069108323332*^9, {
   3.460691355605454*^9, 3.4606913606607523`*^9}, 3.460696622255847*^9, 
   3.460697853635994*^9, 3.4607002219193287`*^9, {3.460701397461886*^9, 
   3.460701423907084*^9}, {3.460701819255274*^9, 3.460701824911387*^9}, {
   3.460712523625782*^9, 3.4607125391126328`*^9}, 3.460713027007635*^9, 
   3.460713888382205*^9, 3.46071813317126*^9, {3.460864788295946*^9, 
   3.460864807844152*^9}, {3.460865849613262*^9, 3.460865865750284*^9}, 
   3.460889846600136*^9, {3.460891360175969*^9, 3.4608913873419123`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwB2IQvV+g6N7//+wHGMDgw36L7ULyxzkR/A2xm+P7hNng
/GeySe82/GWG8/XlvMNNuJng/A9HrjDUKzHA+W/3Ts/frfBnP4wvV/RropXz
Dzi/xn6mAZ/2Nzj/Fo/F+YdCX+D8o8eu263n/gznb2goX1fD8gnOXxbrnva4
4SOcP8dKXM7r7wc4f5L486sbKhF8vpe50vpv3kP5wDA4rPVjzbd3cP73Oc+v
aDEi+A8CEvvUxN7A+Rt3hDDKObyA8y+temS56859OP/Kk7dO9iEX4Hypp/Ge
726egfO7GZ7wxHGfhPPzzN9Mts07COfvX/pgXZT9bjh/0Z0XplaLNsP5XOqP
Ko25VsD5CzSf8j+dPxHO/9Pj+mv7tT57qH/t/aJFW/2sV8D561aeaS1P2ALn
b1vKd9J98R44/5HfSfWSKcfg/Fde3Nku18/B+SYL7/G/V7gO53+eY/7K+to9
OF/l776ZUseew/kd7uezuB68hvNfT7xv/evnezjf1qn5YVL5ByifwaF1t9jS
Ex8R/LMmqzL0cj7C+aLrbHWmPEPwly5I2Rx/+xOcbzq520r7wmc4X4A1x1rv
8Vc4/1WZj43ht+9wftWtGZ2lV3/D+Qe0We+dYGZwgPFPOc/dxi/MBOcfkv69
5es/Zji/tOH1UncRNjh/1gm9Q8pc7HA+NH/B+QB5LBPq
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.459827826340725*^9, {3.460112589026173*^9, 3.460112645706539*^9}, {
   3.460112680644568*^9, 3.4601126992780447`*^9}, 3.460112741184455*^9, {
   3.460112773110125*^9, 3.460112802211834*^9}, 3.460112835576881*^9, {
   3.460112996852702*^9, 3.460112998129455*^9}, 3.46011326304838*^9, 
   3.4601268906623707`*^9, 3.46012745910156*^9, 3.46019781254928*^9, 
   3.460198231181933*^9, 3.460198343038764*^9, 3.460198503339554*^9, 
   3.46020047888968*^9, 3.460201279693128*^9, 3.4602541440216722`*^9, {
   3.460262687855897*^9, 3.460262766060566*^9}, 3.460270418953549*^9, {
   3.460270449676453*^9, 3.4602704571082497`*^9}, 3.46027914925277*^9, {
   3.46028152540451*^9, 3.4602816224796143`*^9}, {3.460281654904982*^9, 
   3.460281681240129*^9}, {3.460284313327487*^9, 3.460284331326235*^9}, 
   3.460284740666381*^9, 3.4602856320272818`*^9, 3.460285722131914*^9, 
   3.460285983775586*^9, 3.460286266563493*^9, 3.460286302006546*^9, 
   3.460363891270259*^9, 3.4603642763310747`*^9, 3.4603644569440937`*^9, 
   3.460365458950597*^9, 3.4603665144126472`*^9, 3.4603666156355267`*^9, 
   3.460369735669664*^9, 3.46037152411382*^9, 3.4603735396953707`*^9, {
   3.460377024525313*^9, 3.4603770371904182`*^9}, 3.460377173469585*^9, 
   3.4603776606105556`*^9, 3.4604314786863728`*^9, 3.46043194014754*^9, 
   3.460432433131618*^9, 3.460433112955955*^9, 3.460433504215876*^9, 
   3.4604343643017817`*^9, {3.4604345511264277`*^9, 3.4604345718682127`*^9}, 
   3.46043497327184*^9, 3.460435122644699*^9, 3.4604375457784357`*^9, 
   3.460438915691066*^9, 3.460439039731208*^9, 3.460439345188586*^9, 
   3.460439843729848*^9, 3.4604403622274027`*^9, 3.460444925753624*^9, 
   3.460459096807026*^9, 3.4604594437020187`*^9, 3.460460119856394*^9, {
   3.460548021222658*^9, 3.460548040796109*^9}, 3.460548374878003*^9, 
   3.460548406506942*^9, 3.460548487069503*^9, 3.460607637374864*^9, {
   3.460608045966167*^9, 3.4606080584538183`*^9}, 3.46060809217841*^9, {
   3.460608142532516*^9, 3.460608150079648*^9}, {3.4606081896361923`*^9, 
   3.460608228433215*^9}, 3.460608418281057*^9, 3.460608655937346*^9, 
   3.460608730822871*^9, {3.460619630850037*^9, 3.4606196602967854`*^9}, 
   3.460619746403996*^9, 3.460623113839085*^9, 3.46069042381326*^9, 
   3.46069063707929*^9, {3.4606907970240583`*^9, 3.460690817321019*^9}, 
   3.460690876868802*^9, {3.4606909173516817`*^9, 3.46069094205059*^9}, {
   3.4606910004991207`*^9, 3.460691050887487*^9}, 3.46069108323332*^9, {
   3.460691355605454*^9, 3.4606913606607523`*^9}, 3.460696622255847*^9, 
   3.460697853635994*^9, 3.4607002219193287`*^9, {3.460701397461886*^9, 
   3.460701423907084*^9}, {3.460701819255274*^9, 3.460701824911387*^9}, {
   3.460712523625782*^9, 3.4607125391126328`*^9}, 3.460713027007635*^9, 
   3.460713888382205*^9, 3.46071813317126*^9, {3.460864788295946*^9, 
   3.460864807844152*^9}, {3.460865849613262*^9, 3.460865865750284*^9}, 
   3.460889846600136*^9, {3.460891360175969*^9, 3.460891387398613*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Simulation/dt=1", "Subsection",
 PageWidth->Infinity,
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Theta", "=", 
  RowBox[{"{", ".1", "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", "1"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"q", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"X", "=", 
  RowBox[{"Shape", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", "1"}], "}"}]}], "]"}]}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460112861196432*^9, 3.460112900249464*^9}, {
   3.460112950538982*^9, 3.4601129539374437`*^9}, {3.460113005467535*^9, 
   3.460113006401746*^9}, {3.460113958542322*^9, 3.460113959287684*^9}, 
   3.4601141435117283`*^9, {3.46011422532432*^9, 3.460114228762265*^9}, {
   3.460114299482638*^9, 3.460114299662619*^9}, {3.460120919663384*^9, 
   3.460120925946155*^9}, {3.460370026377693*^9, 3.460370026423751*^9}, {
   3.460370337087948*^9, 3.460370337140321*^9}, {3.460371593295773*^9, 
   3.460371593877831*^9}, {3.460377254178602*^9, 3.4603772542338552`*^9}, 
   3.460427451561919*^9, 3.4604329049294033`*^9, 3.460433078433264*^9, 
   3.460437042733672*^9, 3.460444571968473*^9, 3.460460037897266*^9, 
   3.460460803716981*^9, {3.46060873633524*^9, 3.460608739837797*^9}, {
   3.460713821809268*^9, 3.46071384751449*^9}, {3.460716661557922*^9, 
   3.460716661602404*^9}, 3.460889999784049*^9},
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", "0.1`", "}"}]], "Output",
 CellChangeTimes->{
  3.45982787174109*^9, {3.460112887861902*^9, 3.460112900786964*^9}, 
   3.460112954913162*^9, {3.460113000282473*^9, 3.460113007967648*^9}, 
   3.460113265712655*^9, 3.460113964238937*^9, 3.460114146876112*^9, 
   3.4601142349213667`*^9, 3.460114304518387*^9, 3.460120929697301*^9, {
   3.460126878115456*^9, 3.460126894622835*^9}, 3.4601274604024973`*^9, 
   3.460197817926371*^9, 3.460198252562779*^9, 3.460198349161854*^9, 
   3.460198506587408*^9, 3.460199526323365*^9, 3.460199563520813*^9, 
   3.460199653793846*^9, 3.4602004848983727`*^9, 3.4602006007365503`*^9, 
   3.460201290106146*^9, 3.460201878664384*^9, 3.460254150649612*^9, 
   3.4602704732126837`*^9, 3.460279153501918*^9, 3.460279212991139*^9, 
   3.4602816948847113`*^9, {3.460284336364369*^9, 3.460284358322968*^9}, 
   3.460284752117095*^9, 3.460285736075243*^9, 3.46028598941461*^9, 
   3.460286271965789*^9, 3.4602863067892523`*^9, 3.4603638961194057`*^9, 
   3.460366621961207*^9, 3.460369741827793*^9, 3.4603700297393913`*^9, 
   3.460370341259691*^9, 3.460371529118987*^9, 3.4603715972424173`*^9, 
   3.46037354416546*^9, 3.460377043299438*^9, 3.460377177822056*^9, 
   3.460377257847652*^9, 3.46037766509881*^9, 3.460427455891576*^9, {
   3.4604329057405024`*^9, 3.460432914614367*^9}, 3.4604330817497673`*^9, 
   3.460433119701372*^9, 3.46043457776158*^9, 3.460434977961318*^9, 
   3.460437046144434*^9, 3.460437552873603*^9, 3.460437900974538*^9, 
   3.460439351382359*^9, 3.46044036674789*^9, 3.46044457492516*^9, 
   3.460444772196126*^9, 3.4604449403037977`*^9, 3.4604449975762653`*^9, 
   3.4604591002378387`*^9, 3.460460040416348*^9, 3.460460125733479*^9, 
   3.4604608064131107`*^9, 3.460548053632538*^9, 3.4605484930771112`*^9, 
   3.4606076422002163`*^9, 3.460608244649225*^9, 3.460608745001939*^9, 
   3.460619679921056*^9, 3.4606197599822598`*^9, 3.460623117967696*^9, 
   3.460691263727468*^9, 3.460696628972677*^9, 3.4606978602136717`*^9, 
   3.460700234024102*^9, {3.4607014273053827`*^9, 3.460701436962193*^9}, 
   3.460701829931427*^9, 3.4607125703048763`*^9, 3.4607130323824987`*^9, {
   3.460713826203504*^9, 3.460713850678028*^9}, 3.460713892650769*^9, 
   3.4607166649851627`*^9, 3.460718138496252*^9, 3.46086481432125*^9, 
   3.460889886823989*^9, 3.460890003213298*^9, 3.460891400334725*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "1", "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.45982787174109*^9, {3.460112887861902*^9, 3.460112900786964*^9}, 
   3.460112954913162*^9, {3.460113000282473*^9, 3.460113007967648*^9}, 
   3.460113265712655*^9, 3.460113964238937*^9, 3.460114146876112*^9, 
   3.4601142349213667`*^9, 3.460114304518387*^9, 3.460120929697301*^9, {
   3.460126878115456*^9, 3.460126894622835*^9}, 3.4601274604024973`*^9, 
   3.460197817926371*^9, 3.460198252562779*^9, 3.460198349161854*^9, 
   3.460198506587408*^9, 3.460199526323365*^9, 3.460199563520813*^9, 
   3.460199653793846*^9, 3.4602004848983727`*^9, 3.4602006007365503`*^9, 
   3.460201290106146*^9, 3.460201878664384*^9, 3.460254150649612*^9, 
   3.4602704732126837`*^9, 3.460279153501918*^9, 3.460279212991139*^9, 
   3.4602816948847113`*^9, {3.460284336364369*^9, 3.460284358322968*^9}, 
   3.460284752117095*^9, 3.460285736075243*^9, 3.46028598941461*^9, 
   3.460286271965789*^9, 3.4602863067892523`*^9, 3.4603638961194057`*^9, 
   3.460366621961207*^9, 3.460369741827793*^9, 3.4603700297393913`*^9, 
   3.460370341259691*^9, 3.460371529118987*^9, 3.4603715972424173`*^9, 
   3.46037354416546*^9, 3.460377043299438*^9, 3.460377177822056*^9, 
   3.460377257847652*^9, 3.46037766509881*^9, 3.460427455891576*^9, {
   3.4604329057405024`*^9, 3.460432914614367*^9}, 3.4604330817497673`*^9, 
   3.460433119701372*^9, 3.46043457776158*^9, 3.460434977961318*^9, 
   3.460437046144434*^9, 3.460437552873603*^9, 3.460437900974538*^9, 
   3.460439351382359*^9, 3.46044036674789*^9, 3.46044457492516*^9, 
   3.460444772196126*^9, 3.4604449403037977`*^9, 3.4604449975762653`*^9, 
   3.4604591002378387`*^9, 3.460460040416348*^9, 3.460460125733479*^9, 
   3.4604608064131107`*^9, 3.460548053632538*^9, 3.4605484930771112`*^9, 
   3.4606076422002163`*^9, 3.460608244649225*^9, 3.460608745001939*^9, 
   3.460619679921056*^9, 3.4606197599822598`*^9, 3.460623117967696*^9, 
   3.460691263727468*^9, 3.460696628972677*^9, 3.4606978602136717`*^9, 
   3.460700234024102*^9, {3.4607014273053827`*^9, 3.460701436962193*^9}, 
   3.460701829931427*^9, 3.4607125703048763`*^9, 3.4607130323824987`*^9, {
   3.460713826203504*^9, 3.460713850678028*^9}, 3.460713892650769*^9, 
   3.4607166649851627`*^9, 3.460718138496252*^9, 3.46086481432125*^9, 
   3.460889886823989*^9, 3.460890003213298*^9, 3.460891400344426*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["n"], "Input",
 CellChangeTimes->{3.460199566938484*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{{3.4601995670369167`*^9, 3.460199582472732*^9}, 
   3.460199654184558*^9, 3.4602006010382977`*^9, 3.460201878968666*^9, 
   3.460270473397647*^9, 3.460279153636557*^9, 3.460279213141574*^9, 
   3.460284358508081*^9, 3.4602847523334084`*^9, 3.460285736259516*^9, 
   3.460285989579775*^9, 3.460286272109499*^9, 3.460286306972591*^9, 
   3.460363896269546*^9, 3.460366622129072*^9, 3.4603697420542707`*^9, 
   3.460370029977702*^9, 3.46037034147106*^9, 3.46037152934341*^9, 
   3.4603715974458637`*^9, 3.46037354437654*^9, 3.460377043500943*^9, 
   3.46037717804631*^9, 3.460377258106838*^9, 3.460377665294299*^9, 
   3.460427456109329*^9, 3.4604329148012323`*^9, 3.460433081953985*^9, 
   3.460433119910708*^9, 3.460434577965878*^9, 3.460434978185719*^9, 
   3.4604370463382597`*^9, 3.460437553079526*^9, 3.4604403669551992`*^9, 
   3.4604445751168613`*^9, 3.460444772429595*^9, 3.460444940510421*^9, 
   3.460444997808488*^9, 3.460459100440379*^9, 3.460460040620708*^9, 
   3.460460125951755*^9, 3.460460806611047*^9, 3.460548055525713*^9, 
   3.4605484932949047`*^9, 3.460607642412746*^9, 3.4606082448640223`*^9, 
   3.460608745210497*^9, 3.460619680207026*^9, 3.460619760198594*^9, 
   3.4606231181930923`*^9, 3.46069662924555*^9, 3.460697860489114*^9, 
   3.4607002342409487`*^9, {3.460701429715391*^9, 3.460701437133135*^9}, 
   3.4607018300775137`*^9, 3.4607125704667187`*^9, 3.460713032628922*^9, {
   3.460713826373352*^9, 3.4607138508667097`*^9}, 3.4607138928206863`*^9, 
   3.460716665202499*^9, 3.460718138690967*^9, 3.460864814531962*^9, 
   3.4608898870577097`*^9, 3.460890003459161*^9, 3.4608914005634336`*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SeedRandom", "[", "12345689999999", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Y", ",", "X", ",", "ETA"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"ZETA", ",", "EPSILON"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"beta", ",", "gamma", ",", "sigmazeta"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"h", ",", "dh", ",", "sigmaepsilon"}], "}"}]}], "}"}]}], 
    "}"}], "=", "\[IndentingNewLine]", 
   RowBox[{"LISRELsimulNonlin", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", ",", "\"\<Gauss[]\>\"", ",", "X"}], "}"}], ",", "Theta", 
     ",", 
     RowBox[{"{", 
      RowBox[{"IdioNonlin", ",", 
       RowBox[{"{", "}"}]}], "}"}]}], "]"}]}], ";"}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601129177677603`*^9, 3.46011292950504*^9}, {
   3.4601129714155407`*^9, 3.460112981316517*^9}, {3.460198511433001*^9, 
   3.4601985124151077`*^9}, {3.460262802763719*^9, 3.460262821284783*^9}, {
   3.4604447675941477`*^9, 3.460444768681939*^9}, {3.4604449364164333`*^9, 
   3.4604449370413017`*^9}, {3.4604449897999277`*^9, 
   3.4604449936057873`*^9}, {3.460691241307849*^9, 3.4606912420027313`*^9}, {
   3.460691310350938*^9, 3.460691330168746*^9}, 3.460691537321001*^9, 
   3.4606915914665956`*^9},
 TextJustification->0,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"plot1", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ETA", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"n", "//", "Range"}], ",", "All"}], " ", "]"}], "]"}], "//", 
     "Transpose"}], "//", "AddTimeAxis"}], ",", 
   RowBox[{"farbmodell", "\[Rule]", "Hue"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "3"}], ",", "3"}], "}"}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plot1", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Y", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"n", "//", "Range"}], ",", "All"}], " ", "]"}], "]"}], "//", 
      "Transpose"}], "//", "AddTimeAxis"}], ",", 
    RowBox[{"farbmodell", "\[Rule]", "Hue"}], ",", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3"}], ",", "3"}], "}"}]}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113047733139*^9, 3.4601131167734203`*^9}, {
  3.46011396933543*^9, 3.460113989452705*^9}, {3.460114029168693*^9, 
  3.460114031766469*^9}, {3.460114161512141*^9, 3.460114164229396*^9}, {
  3.460120949297063*^9, 3.460120987997653*^9}, {3.460370039524664*^9, 
  3.460370040016472*^9}, {3.460371539333914*^9, 3.460371544125806*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
    {Opacity[1], 
     LineBox[{{0., -0.5209211781380665}, {0., -0.5209211781380665}}]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->True,
  PlotRange->{{0., 0.}, {-3, 3}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellChangeTimes->{
  3.459827873013823*^9, {3.460113055090554*^9, 3.460113095483087*^9}, 
   3.460113273581389*^9, {3.460113964976376*^9, 3.4601139901177692`*^9}, 
   3.460114033131361*^9, {3.460114150107635*^9, 3.460114164412263*^9}, 
   3.460114235720495*^9, 3.460114305171029*^9, {3.460120930436802*^9, 
   3.460120988296579*^9}, 3.460197819516024*^9, 3.460198382848845*^9, 
   3.4601985329563026`*^9, 3.4601995270581903`*^9, 3.460199655234778*^9, 
   3.460200501606188*^9, 3.460200601492147*^9, 3.460201879429142*^9, 
   3.460263155619897*^9, 3.460270474422586*^9, 3.460279155040721*^9, 
   3.460279214531389*^9, 3.460281725875258*^9, 3.460284359234613*^9, 
   3.4602847538095922`*^9, 3.460285737715163*^9, 3.460285990939274*^9, 
   3.4602862733933067`*^9, 3.460286308282538*^9, 3.460363898395814*^9, 
   3.460364466117779*^9, 3.4603666232531223`*^9, 3.460369743455418*^9, {
   3.460370031100134*^9, 3.460370040128583*^9}, 3.4603703425836487`*^9, {
   3.460371530559222*^9, 3.460371545091758*^9}, 3.4603715986232557`*^9, 
   3.460373545549732*^9, 3.460377044924808*^9, 3.460377179522697*^9, 
   3.460377259356626*^9, 3.460377666635418*^9, {3.4604274573851433`*^9, 
   3.4604274826315393`*^9}, 3.460431486420775*^9, 3.460431951982443*^9, 
   3.460432442105898*^9, 3.460432915923843*^9, 3.460433083188562*^9, 
   3.460433121276486*^9, 3.460434371750841*^9, 3.460434579330331*^9, 
   3.460434979549678*^9, 3.4604351320544157`*^9, 3.460437047500869*^9, 
   3.460437554166368*^9, 3.4604377000545588`*^9, 3.4604389249118958`*^9, 
   3.460439049759118*^9, 3.460439356387733*^9, 3.460439855697237*^9, 
   3.46044036838757*^9, 3.460444576617157*^9, 3.460444773535759*^9, 
   3.460444941960794*^9, 3.460444998952558*^9, 3.4604591019466887`*^9, 
   3.460459450661531*^9, 3.460460041769643*^9, 3.460460127257649*^9, 
   3.460460807831476*^9, 3.4605480906506033`*^9, 3.460548493883357*^9, 
   3.46060764308528*^9, 3.460608245671123*^9, 3.460608745990651*^9, 
   3.460619681059555*^9, 3.4606197609662323`*^9, 3.460623118855435*^9, 
   3.460691610687475*^9, 3.460696630024538*^9, 3.460697861235483*^9, 
   3.460700234991631*^9, 3.460701437471643*^9, 3.4607018308345337`*^9, 
   3.4607125715771837`*^9, 3.460713033388028*^9, {3.460713826987383*^9, 
   3.4607138514303427`*^9}, 3.460713893553914*^9, 3.460716665990963*^9, 
   3.460718139451044*^9, 3.4608648150278177`*^9, 3.46088988752421*^9, 
   3.460890004189228*^9, {3.460891401054*^9, 3.460891417275784*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[1.], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
    {Opacity[1], 
     LineBox[{{0., -0.04086196671944009}, {0., -0.04086196671944009}}]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->True,
  PlotRange->{{0., 0.}, {-3, 3}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellChangeTimes->{
  3.459827873013823*^9, {3.460113055090554*^9, 3.460113095483087*^9}, 
   3.460113273581389*^9, {3.460113964976376*^9, 3.4601139901177692`*^9}, 
   3.460114033131361*^9, {3.460114150107635*^9, 3.460114164412263*^9}, 
   3.460114235720495*^9, 3.460114305171029*^9, {3.460120930436802*^9, 
   3.460120988296579*^9}, 3.460197819516024*^9, 3.460198382848845*^9, 
   3.4601985329563026`*^9, 3.4601995270581903`*^9, 3.460199655234778*^9, 
   3.460200501606188*^9, 3.460200601492147*^9, 3.460201879429142*^9, 
   3.460263155619897*^9, 3.460270474422586*^9, 3.460279155040721*^9, 
   3.460279214531389*^9, 3.460281725875258*^9, 3.460284359234613*^9, 
   3.4602847538095922`*^9, 3.460285737715163*^9, 3.460285990939274*^9, 
   3.4602862733933067`*^9, 3.460286308282538*^9, 3.460363898395814*^9, 
   3.460364466117779*^9, 3.4603666232531223`*^9, 3.460369743455418*^9, {
   3.460370031100134*^9, 3.460370040128583*^9}, 3.4603703425836487`*^9, {
   3.460371530559222*^9, 3.460371545091758*^9}, 3.4603715986232557`*^9, 
   3.460373545549732*^9, 3.460377044924808*^9, 3.460377179522697*^9, 
   3.460377259356626*^9, 3.460377666635418*^9, {3.4604274573851433`*^9, 
   3.4604274826315393`*^9}, 3.460431486420775*^9, 3.460431951982443*^9, 
   3.460432442105898*^9, 3.460432915923843*^9, 3.460433083188562*^9, 
   3.460433121276486*^9, 3.460434371750841*^9, 3.460434579330331*^9, 
   3.460434979549678*^9, 3.4604351320544157`*^9, 3.460437047500869*^9, 
   3.460437554166368*^9, 3.4604377000545588`*^9, 3.4604389249118958`*^9, 
   3.460439049759118*^9, 3.460439356387733*^9, 3.460439855697237*^9, 
   3.46044036838757*^9, 3.460444576617157*^9, 3.460444773535759*^9, 
   3.460444941960794*^9, 3.460444998952558*^9, 3.4604591019466887`*^9, 
   3.460459450661531*^9, 3.460460041769643*^9, 3.460460127257649*^9, 
   3.460460807831476*^9, 3.4605480906506033`*^9, 3.460548493883357*^9, 
   3.46060764308528*^9, 3.460608245671123*^9, 3.460608745990651*^9, 
   3.460619681059555*^9, 3.4606197609662323`*^9, 3.460623118855435*^9, 
   3.460691610687475*^9, 3.460696630024538*^9, 3.460697861235483*^9, 
   3.460700234991631*^9, 3.460701437471643*^9, 3.4607018308345337`*^9, 
   3.4607125715771837`*^9, 3.460713033388028*^9, {3.460713826987383*^9, 
   3.4607138514303427`*^9}, 3.460713893553914*^9, 3.460716665990963*^9, 
   3.460718139451044*^9, 3.4608648150278177`*^9, 3.46088988752421*^9, 
   3.460890004189228*^9, {3.460891401054*^9, 3.46089141731048*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ML-Sch\[ADoubleDot]tzung", "Subsection",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell["ML", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[{"Theta", "\[IndentingNewLine]", "Y"}], "Input",
 CellChangeTimes->{{3.460427516601119*^9, 3.460427517953906*^9}, {
   3.4604302860648613`*^9, 3.460430286459763*^9}, 3.4604320351169157`*^9, {
   3.460459207514338*^9, 3.460459209125545*^9}}],

Cell[BoxData[
 RowBox[{"{", "0.1`", "}"}]], "Output",
 CellChangeTimes->{{3.460444788235248*^9, 3.460444817682623*^9}, 
   3.4604450103485413`*^9, 3.460459143269252*^9, 3.4604592096793203`*^9, 
   3.460459927811483*^9, 3.46046040805451*^9, 3.460461792764674*^9, 
   3.460548131585779*^9, 3.4605486584763927`*^9, 3.460608751013831*^9, 
   3.4606197029909687`*^9, {3.460619766962469*^9, 3.46061978031246*^9}, 
   3.4606231255195627`*^9, 3.460700237436638*^9, 3.4607014474766912`*^9, 
   3.4607125749914618`*^9, 3.460864820015126*^9, 3.460865290700837*^9, 
   3.460889914481102*^9, 3.460890531238562*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"-", "0.04086196671944009`"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.460444788235248*^9, 3.460444817682623*^9}, 
   3.4604450103485413`*^9, 3.460459143269252*^9, 3.4604592096793203`*^9, 
   3.460459927811483*^9, 3.46046040805451*^9, 3.460461792764674*^9, 
   3.460548131585779*^9, 3.4605486584763927`*^9, 3.460608751013831*^9, 
   3.4606197029909687`*^9, {3.460619766962469*^9, 3.46061978031246*^9}, 
   3.4606231255195627`*^9, 3.460700237436638*^9, 3.4607014474766912`*^9, 
   3.4607125749914618`*^9, 3.460864820015126*^9, 3.460865290700837*^9, 
   3.460889914481102*^9, 3.4608905312489347`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"scaling", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pp", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m", "=", "100"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"IndividualLikNonlinNorKorr", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Y", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"IdioNonlin", ",", 
     RowBox[{"{", "}"}], ",", "m", ",", 
     RowBox[{"eps", "=", 
      RowBox[{"10.", "^", 
       RowBox[{"-", "16"}]}]}], ",", 
     RowBox[{"ksigma", "=", "Infinity"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0", ",", 
     RowBox[{"onlyNorKorr", "=", "0"}]}], "}"}]}], "]"}], "\n", 
 RowBox[{"IndividualLikNonlinNorKorr", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Y", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"IdioNonlin", ",", 
     RowBox[{"{", "}"}], ",", "m", ",", 
     RowBox[{"eps", "=", 
      RowBox[{"10.", "^", 
       RowBox[{"-", "16"}]}]}], ",", 
     RowBox[{"ksigma", "=", "Infinity"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0", ",", 
     RowBox[{"onlyNorKorr", "=", "1"}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"IndividualLik", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Y", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
    RowBox[{"{", 
     RowBox[{"Idio", ",", 
      RowBox[{"{", "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Singular", "=", "False"}], ",", 
      RowBox[{"2", "Pi"}], " ", ",", "0"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.460264864897327*^9, 3.460264932378791*^9}, {
   3.460265489300803*^9, 3.460265492492799*^9}, {3.46027038606568*^9, 
   3.460270391802556*^9}, {3.4602704971596107`*^9, 3.4602705817118692`*^9}, {
   3.46027367414145*^9, 3.460273674236417*^9}, {3.460279775378045*^9, 
   3.4602797754444103`*^9}, {3.4602799530257587`*^9, 
   3.4602799533811693`*^9}, {3.460280067013379*^9, 3.460280067130088*^9}, {
   3.4602801040742397`*^9, 3.460280104129944*^9}, {3.4602801453821163`*^9, 
   3.4602801673531218`*^9}, {3.46028174693688*^9, 3.460281763776168*^9}, {
   3.4602818356559362`*^9, 3.460281835739462*^9}, {3.460281898670804*^9, 
   3.460281898732609*^9}, {3.460282025318959*^9, 3.460282025741701*^9}, {
   3.460282062175247*^9, 3.460282071535883*^9}, {3.460283778391947*^9, 
   3.4602837888805027`*^9}, {3.4602838305963707`*^9, 3.460283854615387*^9}, {
   3.46028477341341*^9, 3.460284779157151*^9}, {3.460285035206752*^9, 
   3.460285046973556*^9}, {3.46028555906642*^9, 3.460285574425418*^9}, {
   3.4602857519094887`*^9, 3.4602857519715776`*^9}, {3.460285881590439*^9, 
   3.4602858816380377`*^9}, {3.460286117999454*^9, 3.460286123654068*^9}, {
   3.4602863340289307`*^9, 3.4602863377475977`*^9}, {3.4603641927287188`*^9, 
   3.460364197580667*^9}, {3.460365058304535*^9, 3.4603650587979116`*^9}, {
   3.460365091217347*^9, 3.460365126318194*^9}, {3.4603652464521227`*^9, 
   3.460365260029804*^9}, {3.460365412299954*^9, 3.460365434375272*^9}, {
   3.460365485584791*^9, 3.460365520950554*^9}, {3.460366663535665*^9, 
   3.460366678997499*^9}, {3.4603667867732773`*^9, 3.4603667868283587`*^9}, {
   3.460367092714067*^9, 3.460367098883337*^9}, {3.460369235357655*^9, 
   3.460369263924768*^9}, {3.460369362646221*^9, 3.46036936313859*^9}, {
   3.46036946785526*^9, 3.4603694691077127`*^9}, {3.46037339069245*^9, 
   3.460373390747698*^9}, {3.460373605599341*^9, 3.4603736056503153`*^9}, {
   3.460377091108459*^9, 3.460377126962656*^9}, {3.460377288435691*^9, 
   3.460377301095058*^9}, {3.4603774697122087`*^9, 3.460377479788327*^9}, {
   3.460377585320611*^9, 3.460377603716568*^9}, {3.4603776957101793`*^9, 
   3.460377736561165*^9}, {3.460377923292104*^9, 3.4603779233524303`*^9}, {
   3.460378105932313*^9, 3.46037817981962*^9}, {3.460427531315346*^9, 
   3.460427537420005*^9}, {3.460427638978484*^9, 3.4604276390230217`*^9}, {
   3.4604277414332314`*^9, 3.460427769573126*^9}, {3.4604279604982853`*^9, 
   3.460427960554902*^9}, {3.460430680071252*^9, 3.460430680172152*^9}, {
   3.460430712203142*^9, 3.460430712557424*^9}, {3.460430775931464*^9, 
   3.460430776020101*^9}, {3.460430814349124*^9, 3.460430814950081*^9}, {
   3.46043100067663*^9, 3.460431000775926*^9}, {3.460431035518139*^9, 
   3.460431043615539*^9}, {3.460431139283386*^9, 3.460431139330926*^9}, {
   3.4604311987514153`*^9, 3.460431233744923*^9}, {3.460431314274002*^9, 
   3.460431314321568*^9}, {3.4604316727142878`*^9, 3.4604316728008432`*^9}, {
   3.460431886035831*^9, 3.46043189177104*^9}, {3.460432099991972*^9, 
   3.460432100073539*^9}, {3.460432236204804*^9, 3.4604322362468243`*^9}, {
   3.4604323376555843`*^9, 3.460432357162323*^9}, {3.460432403219545*^9, 
   3.460432403269651*^9}, {3.460432564446265*^9, 3.4604325911495867`*^9}, {
   3.460432813689516*^9, 3.460432813733564*^9}, {3.460432944239506*^9, 
   3.460432989199974*^9}, {3.460433097024789*^9, 3.460433097139295*^9}, {
   3.460433291653358*^9, 3.46043329173923*^9}, {3.460433672964451*^9, 
   3.460433673010107*^9}, {3.460433845665332*^9, 3.4604338457416363`*^9}, {
   3.4604344009903316`*^9, 3.460434401033557*^9}, {3.4604346235115023`*^9, 
   3.460434638473834*^9}, {3.460434675871023*^9, 3.460434675925946*^9}, {
   3.4604350413113747`*^9, 3.4604350414069347`*^9}, {3.460436666989565*^9, 
   3.460436677468376*^9}, {3.460437023691847*^9, 3.460437023772811*^9}, {
   3.460437179838045*^9, 3.460437214787621*^9}, {3.4604373750456057`*^9, 
   3.460437375101828*^9}, {3.460437455923118*^9, 3.4604374559862347`*^9}, {
   3.460437643282413*^9, 3.4604376433404827`*^9}, {3.460439284564681*^9, 
   3.46043929340877*^9}, {3.460439393566842*^9, 3.460439393962884*^9}, {
   3.46044000098571*^9, 3.460440001044331*^9}, {3.460443930270521*^9, 
   3.460443930334333*^9}, {3.460443966799687*^9, 3.46044399790462*^9}, {
   3.460444060284606*^9, 3.460444061730588*^9}, {3.460444101336812*^9, 
   3.46044410138903*^9}, {3.460444186536171*^9, 3.460444194286351*^9}, {
   3.460444233408099*^9, 3.460444248920389*^9}, {3.460444338058318*^9, 
   3.460444355662019*^9}, {3.460444400012597*^9, 3.460444431012135*^9}, {
   3.460444591036777*^9, 3.4604446631572647`*^9}, {3.46044479971354*^9, 
   3.460444799768903*^9}, {3.460444831583193*^9, 3.460444859781989*^9}, {
   3.46044502143334*^9, 3.460445021504759*^9}, {3.460459950502769*^9, 
   3.460459971711813*^9}, {3.460460068419449*^9, 3.460460088588605*^9}, {
   3.460460154598343*^9, 3.46046015516997*^9}, {3.460460281436612*^9, 
   3.460460281521656*^9}, {3.4604604120265713`*^9, 3.460460412125514*^9}, {
   3.4604607607833633`*^9, 3.4604607621971283`*^9}, {3.460460826677142*^9, 
   3.460460827186878*^9}, {3.4604608962826014`*^9, 3.4604608963501987`*^9}, {
   3.460460962965583*^9, 3.460460963358262*^9}, {3.46046100555375*^9, 
   3.4604610220017967`*^9}, {3.46046105589403*^9, 3.460461056004932*^9}, {
   3.460461154113535*^9, 3.460461154227416*^9}, {3.460461800671767*^9, 
   3.4604618154025*^9}, {3.46046184541817*^9, 3.46046186011173*^9}, {
   3.460461896620476*^9, 3.460461896672694*^9}, {3.460461952952413*^9, 
   3.4604619533933907`*^9}, {3.460462913572587*^9, 3.460462920740217*^9}, {
   3.460548175219633*^9, 3.460548179294363*^9}, {3.460548260239588*^9, 
   3.460548260297719*^9}, {3.460548333262265*^9, 3.460548333779482*^9}, {
   3.460548675566861*^9, 3.460548693804049*^9}, {3.460548972449188*^9, 
   3.4605491929429903`*^9}, {3.460549257251377*^9, 3.460549267901092*^9}, {
   3.4605496024993763`*^9, 3.4605496337333307`*^9}, {3.460549667762332*^9, 
   3.46054966825324*^9}, {3.460607544492757*^9, 3.460607557468165*^9}, {
   3.460607591423718*^9, 3.460607615734179*^9}, {3.4606076546131697`*^9, 
   3.460607711208377*^9}, {3.460607950300333*^9, 3.460607950788868*^9}, {
   3.460608254691515*^9, 3.460608332544549*^9}, {3.460608365633368*^9, 
   3.4606083656943207`*^9}, {3.460608434510606*^9, 3.460608528562172*^9}, {
   3.460608559009796*^9, 3.460608584467407*^9}, {3.460608755712895*^9, 
   3.4606087818086443`*^9}, {3.460608915820417*^9, 3.46060895109648*^9}, {
   3.4606090353514013`*^9, 3.460609089338924*^9}, {3.460619799153166*^9, 
   3.4606198362306223`*^9}, 3.460619905423987*^9, {3.460621024814104*^9, 
   3.460621075759169*^9}, {3.460621192179472*^9, 3.4606212134045153`*^9}, {
   3.4606214203824053`*^9, 3.460621428920328*^9}, {3.4606215045280933`*^9, 
   3.460621505423924*^9}, {3.460621613387906*^9, 3.460621638578682*^9}, {
   3.460621694074709*^9, 3.460621703411603*^9}, {3.4606217660430403`*^9, 
   3.460621767329904*^9}, {3.460621806996888*^9, 3.4606218076980343`*^9}, {
   3.460621883288566*^9, 3.46062188333815*^9}, {3.460621970939987*^9, 
   3.4606219893319883`*^9}, {3.460622107014687*^9, 3.460622107100986*^9}, {
   3.460622297972288*^9, 3.460622306665023*^9}, {3.460622338760532*^9, 
   3.460622398767516*^9}, {3.460622676496147*^9, 3.4606226765399942`*^9}, {
   3.4606227120282917`*^9, 3.460622766881015*^9}, {3.4606229263578787`*^9, 
   3.460622944163636*^9}, {3.4606229791390038`*^9, 3.460622982600178*^9}, {
   3.4606230423052397`*^9, 3.460623049675028*^9}, {3.4606231523155127`*^9, 
   3.460623159744812*^9}, {3.460623194195408*^9, 3.460623258120954*^9}, {
   3.460687849143656*^9, 3.460687889401013*^9}, {3.460690081391994*^9, 
   3.460690099337471*^9}, {3.460690130038103*^9, 3.46069013008521*^9}, 
   3.4606902754485703`*^9, {3.460698988112274*^9, 3.460698991400546*^9}, 
   3.460699028468751*^9, {3.460700313321166*^9, 3.460700333126775*^9}, {
   3.460700615798884*^9, 3.4607006190760393`*^9}, 3.460701679102146*^9, 
   3.460716635576797*^9, 3.460716739992663*^9, {3.460891442248104*^9, 
   3.46089146569773*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "0.010000000000000002`", "}"}], "}"}]], "Print",
 CellChangeTimes->{
  3.4607125941610928`*^9, 3.460713036837367*^9, {3.4607138313300943`*^9, 
   3.4607138550169573`*^9}, {3.460713899250411*^9, 3.460713912167659*^9}, {
   3.460716625964521*^9, 3.460716636089563*^9}, 3.460716672114872*^9, 
   3.4607167405833178`*^9, 3.46071814579046*^9, 3.460718328304133*^9, 
   3.460864847870467*^9, 3.4608899021408253`*^9, 3.4608900104100113`*^9, {
   3.460891428856482*^9, 3.4608914666964827`*^9}}],

Cell[BoxData[
 RowBox[{"{", "2", "}"}]], "Print",
 CellChangeTimes->{
  3.4607125941610928`*^9, 3.460713036837367*^9, {3.4607138313300943`*^9, 
   3.4607138550169573`*^9}, {3.460713899250411*^9, 3.460713912167659*^9}, {
   3.460716625964521*^9, 3.460716636089563*^9}, 3.460716672114872*^9, 
   3.4607167405833178`*^9, 3.46071814579046*^9, 3.460718328304133*^9, 
   3.460864847870467*^9, 3.4608899021408253`*^9, 3.4608900104100113`*^9, {
   3.460891428856482*^9, 3.460891466706459*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"-", "0.04086196671944009`"}], "}"}]], "Print",
 CellChangeTimes->{
  3.4607125941610928`*^9, 3.460713036837367*^9, {3.4607138313300943`*^9, 
   3.4607138550169573`*^9}, {3.460713899250411*^9, 3.460713912167659*^9}, {
   3.460716625964521*^9, 3.460716636089563*^9}, 3.460716672114872*^9, 
   3.4607167405833178`*^9, 3.46071814579046*^9, 3.460718328304133*^9, 
   3.460864847870467*^9, 3.4608899021408253`*^9, 3.4608900104100113`*^9, {
   3.460891428856482*^9, 3.460891466716734*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0, 0, 1], PointSize[0.02], Thickness[0.02], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJwBUQOu/CFib1JlAgAAADQAAAACAAAAJoWyExAbC8C7ZY3O4ypyPkLhMSHC
JgrAxiILNylwOz78eu4XYTQJwCGa/uwrXgc+HtrdhMlDCMCgjsVzOl3WPVxt
E6PaVAfAv+BZXUL5pz24lj0IdmcGwOP8xjoFs3w97lQRXX97BcDxlhgZwCFT
Pdosjx/ckATAfuUt/7BWLD0cvnVtc6cDwFads6PRQwc9CImI1S2/AsCoEeRl
1yDlPHqvkS711wHABQKQCrYvxTwoKDhztPEAwHrf0/Thaqc8DBzsoVcMAMC/
QqPUqnyMPBWklkCXT/6/xCcnHgQLczxt1fJC/If8v6Syzjww8ls86y35HbvB
+r+eYgj7hXtGPG3agOex/Pi/mf67rn/PMzxorNzRvzj3v5aX4ZMhGiM8RrOs
CMV19b+nfrQjuCMUPD6mWJCis/O/MfoOrVgzBzwMW8onOvLxv8AHXwd9L/07
LukLLG4x8L9CFOsqIgn0O29f7vpC4uy/YUjjsIy3EUCWMlnMbmLpvwWxFE2A
8QxAmukaAyfj5b8xZOMyJ8cJQD2F9kgzZOK/0joNz4UHCUB9aoQYt8rdv52h
P5YZfgpAxKE7pM/M1r/RIrKMk5EOQJgffiOAnM+/cbhVWTM6E0AwbClpL53B
v4x9lgwBYBpA0AMdpE/WnL8r+HnML7sjQOjc39Ir17Q/9HvOfiuNTzv4R+It
2XbIPxeTjC8bHVw7DlhBePZD0z8aMLYVKFxrO6w8AZ3hT9o/E3W3JYIZfTti
+sj51K/gP7AocQK47JA7XqG5Zuc55D/TJFVQqYylO2DwrLBpxuc/JsCVBMwP
vjusjfSrn1XrP0Ki3xta/9Y7srV3ss/n7j8VlMqpjlHzOxTz03uhPvE/fdz/
rH7/LC63AYfyIgvzPwz5puVzfU0u17R0QJTZ9D8QbZsWfIlwLvQeT3AfqvY/
9RVIVFF9lC5l/IHU8Hz4Pxd3C8RwGbwumUyGTzdS+j+XsfGaE1/lLjHQ3qUk
Kvw/KXu3TwcSEi99fYrb7QT+Pw5ABMWCB0Ev61Yfn8vi/z8KKmVAlO9xL15M
oGL94QBA2/PY7kEtpS+osuNrXtQBQOE1UG19H9wvhlZkXqzIAkAKJRjnxRQV
ME/lkSI=
           "]]}}, {}}, {{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.01], Thickness[0.01], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQrda6SVhAmvuAarTjnYWLNts4PTRUPKTGdWCq+/MZ
vnqfbf5UvRNPNOE84OVbMPFsmIGt3K27LSedOQ40sBUZnY7PsI3JFV58K4T9
QJGGiBTn1/m2O6bZcpSlsx1wTtXaMK/yku27EMHY+mrWAyf3ON+e8JTJ7pZO
v/ydCSwHqvj3eSSrGtrJ7CvNLV7OfCBBun1y2ppoO47Ojqu6+5kO3FMJODTn
RbNd1fqJel+vMx6Ywud32mP6SjsNDYviLR8ZDuQe2TDzTeFZOx6ZNwvDeRgO
PGnMULVOfGcnumSaw3T/f/u3flq24Ywaj33u1U9Of9r/7E99a1W6pkzd/rXu
T9ndB3/tL5MzD703x9E+91bD841/fuzntp+o0nM93D5jzZ2L+y2+75czCtu1
XDHX3m3zGo6jpV/3y+nss7IUabC3WxYxYdHmz/tXv2Xb1sAzwZ4n+pS61aeP
+2Xvy+/79GeOvd5Lbp08ww/7e5Pmqm3YvNw+P/7dL6dHb/Y3sexqvdq70X6a
UeSZvKSX+yXenHff0L/dftZLKWb1x0/3T+h7rymzao+9bes3D+OUR/tVq1nv
1s3db1+b1SKx/dTd/VJQ/pGF1kvOn7kGVz9Dvk65Yc75/SJQ8wxyNDP15x7c
Xwm17wKz7BL/a3P2d0Hd8+LO/Uva17fYS0Hd+8P9ke7NshP2y6H+4YtwrPjm
fNleEerfNTaMcx/637KHhUfSrxM/r6x/YM8CDa+4hTvTnls+sa+GhmfChzUb
Mo89t0+Hhvea3i+r54e+tt8MjY9NW8s3nX/+zv4xNL5EPl+uXmj30T4bGp/b
Gds/KXF/tp8Eje/rW0ocptz8Yv8Ymh6+yPkXyK/6Zp8tBUkvqX8ar3yo+WEv
xQdJTzN92vzNg37ZH4CmN8ML95aqaP2xd4Wmx9rarttvWf7Zl0DT6+sw+fmn
H/23r4Om5zifBUl/HzI4+EDT+4pNj7PjrjA6zIHmh7awlLg1J5gc3kdB8gsA
yguc8g==
           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{-0.04086196671944009}, {1}},
      PlotRange->{{-4, 4}, {0, 10}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {193.5, -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.02], Thickness[0.02], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQrda6SVhAmvuAarTjnYWLNts4PTRUPKTGdWCq+/MZ
vnqfbf5UvRNPNOE84OVbMPFsmIGt3K27LSedOQ40sBUZnY7PsI3JFV58K4T9
QJGGiBTn1/m2O6bZcpSlsx1wTtXaMK/yku27EMHY+mrWAyf3ON+e8JTJ7pZO
v/ydCSwHqvj3eSSrGtrJ7CvNLV7OfCBBun1y2ppoO47Ojqu6+5kO3FMJODTn
RbNd1fqJel+vMx6Ywud32mP6SjsNDYviLR8ZDuQe2TDzTeFZOx6ZNwvDeRgO
PGnMULVOfGcnumSaw3T/f/u3flq24Ywaj33u1U9Of9r/7E99a1W6pkzd/rXu
T9ndB3/tL5MzD703x9E+91bD841/fuzntp+o0nM93D5jzZ2L+y2+75czCtu1
XDHX3m3zGo6jpV/3y+nss7IUabC3WxYxYdHmz/tXv2Xb1sAzwZ4n+pS61aeP
+2Xvy+/79GeOvd5Lbp08ww/7e5Pmqm3YvNw+P/7dL6dHb/Y3sexqvdq70X6a
UeSZvKSX+yXenHff0L/dftZLKWb1x0/3T+h7rymzao+9bes3D+OUR/tVq1nv
1s3db1+b1SKx/dTd/VJQ/pGF1kvOn7kGVz9Dvk65Yc75/SJQ8wxyNDP15x7c
Xwm17wKz7BL/a3P2d0Hd8+LO/Uva17fYS0Hd+8P9ke7NshP2y6H+4YtwrPjm
fNleEerfNTaMcx/637KHhUfSrxM/r6x/YM8CDa+4hTvTnls+sa+GhmfChzUb
Mo89t0+Hhvea3i+r54e+tt8MjY9NW8s3nX/+zv4xNL5EPl+uXmj30T4bGp/b
Gds/KXF/tp8Eje/rW0ocptz8Yv8Ymh6+yPkXyK/6Zp8tBUkvqX8ar3yo+WEv
xQdJTzN92vzNg37ZH4CmN8ML95aqaP2xd4Wmx9rarttvWf7Zl0DT6+sw+fmn
H/23r4Om5zifBUl/HzI4+EDT+4pNj7PjrjA6zIHmh7awlLg1J5gc3kdB8gsA
yguc8g==
           "]]}}, {}}, {{}, 
        {RGBColor[1, 0, 0], PointSize[0.02], Thickness[0.02], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQrda6SVhAmvuAmaa41rG7L6ydHhoqHlLjgvP/VL0T
TzThhPPlbt1tOenMAefH5AovvhXCDufvmGbLUZbOBue/CxGMra9mhfNv6fTL
35nAAufL7CvNLV7ODOdzdHZc1d3PBOdXrZ+o9/U6I5yvoWFRvOUjA5zPI/Nm
YTgPgi+6ZJrDdP9/+2H83KufnP60/4HzX+v+lN198BdC/lbD841/fsD5GWvu
XNxv8R3Od9u8huNo6Vc4325ZxIRFmz/D+TzRp9StPn2E8/VecuvkGX6A8/Pj
3/1yevRm/6Vce6b30bwO04wiz+QlvYTzZ72UYlZ//BTOt2395mGc8gjOr81q
kdh+6i6cf2Sh9ZLzZ67B+TPk65Qb5pyH8w1yNDP15x6E8y8wyy7xvzYHzn9x
5/4l7etb7ENjyrZcOahj/cP9ke7NshNwPl+EY8U358tw/hobxrkP/W/B+Um/
Tvy8sv4BnB+3cGfac8sncH7ChzUbMo89R+jv/bJ6fuhrOH/T1vJN55+/g/NF
Pl+uXmj30b6D03mZfpy77nbG9k9K3J/h/OtbShym3PwC53+R8y+QX/UNzk/9
03jlQ80POH+mT5u/edAvON/wwr2lKlp/4Pza2q7bb1n+wfmvw+Tnn370H86P
81mQ9PchgwOMv2LT4+y4K4xwfltYStyaE0xwPgA4Vodp
           "]]}}, {}}, {{}, 
        {RGBColor[1, 1, 0], PointSize[0.015], Thickness[0.015], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJwBUQOu/CFib1JlAgAAADQAAAACAAAAJoWyExAbC8CXKKDESOZlPULhMSHC
JgrA+QHURCYAnT38eu4XYTQJwJnYijCnBtE9HtrdhMlDCMBea6UARMoBPlxt
E6PaVAfAXUGPs4KYMD64lj0IdmcGwEEor5LmuVs+7lQRXX97BcDfIcwstsuE
Ptosjx/ckATA+ELR+DsUrD4cvnVtc6cDwE4/zlTwGdE+CImI1S2/AsCkxMEn
qtTyPnqvkS711wHA2FXwwnLHEj8oKDhztPEAwIw5g05p/TA/DBzsoVcMAMC5
r4Vbze5LPxWklkCXT/6/HCM504nkZD9t1fJC/If8vzj6xCs3eXw/6y35HbvB
+r+4riUpS7KRP23agOex/Pi/apGtjlIVpD9orNzRvzj3v/NNFaMB1LQ/RrOs
CMV19b+mhUROVsHDPz6mWJCis/O/ygQnsBQm0T8MW8onOvLxvyQZPQWoQ9s/
LukLLG4x8L8OfF4CjdvjP29f7vpC4uy/t6Iwf4yD6j+WMlnMbmLpv5xIARXW
OvA/mukaAyfj5b/kCIRVCDnyPz2F9kgzZOK/zigA14zE8j99aoQYt8rdv69h
iIoxu/E/xKE7pM/M1r9BpvvM27vuP5gffiOAnM+/e0LOvl5u6D8wbClpL53B
v85qCRltz+E/0AMdpE/WnL++t5niqM7XP+jc39Ir17Q/d1rBw30qzT/4R+It
2XbIPyMKrWq/XcA/DlhBePZD0z8wk22WKtGwP6w8AZ3hT9o/vghMbJWfnz9i
+sj51K/gP4IUd7adL4s/XqG5Zuc55D+UsmZz/1l1P2DwrLBpxuc/UT9hMYCc
Xj+sjfSrn1XrP5fbSlzWAUQ/srV3ss/n7j/c5M+VM9EnPxTz03uhPvE/Zvjb
b3vJCT+3AYfyIgvzP2M98y9XW+k+17R0QJTZ9D9HqEFQ6ZvGPvQeT3AfqvY/
psGcMmk/oj5l/IHU8Hz4P1ddaOKanHo+mUyGTzdS+j95P35Fpn5RPjHQ3qUk
Kvw/RRE8gsawJD59fYrb7QT+Pww+zLaX9PU961Yfn8vi/z8r55AKhNjEPV5M
oGL94QBA564Fbs6nkT2osuNrXtQBQD/543Hhllo9hlZkXqzIAkCN7V7qT7wh
PUuQp9I=
           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{-0.04086196671944009}, None},
      PlotRange->{{-4, 4}, {0, 7.33977893364086}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {580.5, -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQBGIQ/e+A0+X///kPmGuKax27+8J6nmee5pbtfHC+/aWZ
9Rn5vHC+Ua3u5GnLueB8W42Ukg98HHC+3UZpxpBmVjj/42X+rzUHmOD8Pd+W
bbuowwDnF6d93Xf98K/9MH7U7Hnp8h5f4fxnptM483d+gvOLLvSu3qf1Ac5n
3r31dvund/sv59ozvY/mdVC66p8wqf8tnO/w/uWTOTpv4Px4zpbM5Sdfwflz
bHcU7WF+AeffKnxTfdH2KZzfemuWZrDAAzg/sW3SupVHr8L5CvOf5i+3PQ7n
v+o2FL1TPx3Ot93SHKjaP8U+LKZsy5WDOtaStnzrOtU3wPlKvbvZvbR3w/nT
8rYYtIofhvMX7EvscpU+B+eHtrN/auq/Auf/u6YhOuXaPTg/RFh1zqW+J3C+
6Z9gpXOb3iPM22ZfGxj41b6T03mZfpy77pc8fr8nWb/g/KefUwPefPoP5wfb
7I7262NygPGZnrJpJEaxwvm711/0yJLkgPNjqn7Odl/JBed7r37SHl/AC+er
bJu8Vn8HH5wPTX9wPgBfoS6E
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk4VI8egMeewWhBJNkS2YqUaM75nYiR7ESEECXJUqT4U0glIROyJVKJ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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vk/VAsfwPGZsY81N0VKlkiSpZRl5pzvscvV0NhSthalkr10E4WQpJCd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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQBGIQ/e+A0+X///kPmGuKax27+8J6nmee5pbtfHC+/aWZ
9Rn5vHC+Ua3u5GnLueB8W42Ukg98HHC+3UZpxpBmVjj/42X+rzUHmOD8Pd+W
bbuowwDnF6d93Xf98K/9MH7U7Hnp8h5f4fxnptM483d+gvOLLvSu3qf1Ac5n
3r31dvund/sv59ozvY/mdVC66p8wqf8tnO/w/uWTOTpv4Px4zpbM5Sdfwflz
bHcU7WF+AeffKnxTfdH2KZzfemuWZrDAAzg/sW3SupVHr8L5CvOf5i+3PQ7n
v+o2FL1TPx3Ot93SHKjaP8U+LKZsy5WDOtaStnzrOtU3wPlKvbvZvbR3w/nT
8rYYtIofhvMX7EvscpU+B+eHtrN/auq/Auf/u6YhOuXaPTg/RFh1zqW+J3C+
6Z9gpXOb3iPM22ZfGxj41b6T03mZfpy77pc8fr8nWb/g/KefUwPefPoP5wfb
7I7262NygPGZnrJpJEaxwvm711/0yJLkgPNjqn7Odl/JBed7r37SHl/AC+er
bJu8Vn8HH5wPTX9wPgBfoS6E
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk4VI8egMeewWhBJNkS2YqUaM75nYiR7ESEECXJUqT4U0glIROyJVKJ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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vk/VAsfwPGZsY81N0VKlkiSpZRl5pzvscvV0NhSthalkr10E4WQpJCd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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQBGIQ/e+A0+X///kPmGuKax27+8J6nmee5pbtfHC+/aWZ
9Rn5vHC+Ua3u5GnLueB8W42Ukg98HHC+3UZpxpBmVjj/42X+rzUHmOD8Pd+W
bbuowwDnF6d93Xf98K/9MH7U7Hnp8h5f4fxnptM483d+gvOLLvSu3qf1Ac5n
3r31dvund/sv59ozvY/mdVC66p8wqf8tnO/w/uWTOTpv4Px4zpbM5Sdfwflz
bHcU7WF+AeffKnxTfdH2KZzfemuWZrDAAzg/sW3SupVHr8L5CvOf5i+3PQ7n
v+o2FL1TPx3Ot93SHKjaP8U+LKZsy5WDOtaStnzrOtU3wPlKvbvZvbR3w/nT
8rYYtIofhvMX7EvscpU+B+eHtrN/auq/Auf/u6YhOuXaPTg/RFh1zqW+J3C+
6Z9gpXOb3iPM22ZfGxj41b6T03mZfpy77pc8fr8nWb/g/KefUwPefPoP5wfb
7I7262NygPGZnrJpJEaxwvm711/0yJLkgPNjqn7Odl/JBed7r37SHl/AC+er
bJu8Vn8HH5wPTX9wPgBfoS6E
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlmk4VI8egMeewWhBJNkS2YqUaM75nYiR7ESEECXJUqT4U0glIROyJVKJ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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQ/e+A0+X///kPMECB2uKzL96sRfD9WiP+3YxG8Od5
5mlu2c4H59tfmlmfkc8L5xvV6k6etpwLzrfVSCn5wMcB59ttlGYMaWaF8z9e
5v9ac4AJzt/zbdm2izoMcH5x2td91w//2g/jR82ely7v8RXOL7rQu3qf1gc4
/1bhm+qLtk/h/MS2SetWHr0K57/qNhS9Uz8dzg9tZ//U1H/FHsYPEVadc6nv
CZxv+idY6dym93D+gm32tYGBX+H8L3n8fk+yfsH5Tz+nBrz59B/OD7bZHe3X
x+QA4zM9ZdNIjGKF83evv+iRJckB58dU/ZztvpILzvde/aQ9voAXoT8vYGLw
IQR/h8GeWe4ifHC+yrbJa/V3IPi3Kv5vU+bih/MnWmcfEI9B8D3+XTvJvQ7B
h6YHOB8AKsKJ/Q==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwt1vk/VAsfwPGZsY81N0VKlkiSpZRl5pzvscvV0NhSthalkr10E4WQpJCd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          "]]}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      Frame->True,
      GridLines->{{-0.04086196671944009}, None},
      PlotRange->{{-4, 4}, {0, 7.33977893364086}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {967.5, -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}]}, {}},
  ContentSelectable->True,
  ImageSize->{765., Automatic},
  PlotRangePadding->{6, 5}]], "Print",
 CellChangeTimes->{
  3.4607125941610928`*^9, 3.460713036837367*^9, {3.4607138313300943`*^9, 
   3.4607138550169573`*^9}, {3.460713899250411*^9, 3.460713912167659*^9}, {
   3.460716625964521*^9, 3.460716636089563*^9}, 3.460716672114872*^9, 
   3.4607167405833178`*^9, 3.46071814579046*^9, 3.460718328304133*^9, 
   3.460864847870467*^9, 3.4608899021408253`*^9, 3.4608900104100113`*^9, {
   3.460891428856482*^9, 3.460891466891271*^9}}]
}, Open  ]],

Cell[BoxData["0.22585804490915673`"], "Output",
 CellChangeTimes->{
  3.4605486948259277`*^9, 3.4605487302383738`*^9, {3.460548942020789*^9, 
   3.4605491932066317`*^9}, {3.460549258834635*^9, 3.460549268506208*^9}, 
   3.46054930285188*^9, {3.460549416954996*^9, 3.460549454863381*^9}, {
   3.460549588146182*^9, 3.460549603690003*^9}, {3.460549634506207*^9, 
   3.460549668574503*^9}, 3.460607558766708*^9, {3.460607593319531*^9, 
   3.460607711503766*^9}, 3.4606078350805283`*^9, 3.460607900416376*^9, 
   3.4606079523498783`*^9, {3.4606082496246*^9, 3.4606083332594213`*^9}, 
   3.460608366349736*^9, {3.460608435462336*^9, 3.460608585202838*^9}, {
   3.460608758434499*^9, 3.4606087821685743`*^9}, {3.460608916822608*^9, 
   3.460608951788578*^9}, {3.46060903760701*^9, 3.460609090568944*^9}, 
   3.4606196889607763`*^9, {3.460619782657147*^9, 3.460619837176239*^9}, {
   3.460619894843831*^9, 3.46061991829001*^9}, 3.4606201603760843`*^9, 
   3.4606202144476957`*^9, 3.460620298069223*^9, 3.4606209222373657`*^9, 
   3.4606209756890182`*^9, {3.4606210251998863`*^9, 3.460621076850589*^9}, 
   3.4606211069084263`*^9, {3.460621193995138*^9, 3.4606212147854347`*^9}, 
   3.460621324509781*^9, {3.460621421398328*^9, 3.460621429364738*^9}, {
   3.460621501046996*^9, 3.460621506697133*^9}, {3.4606216150042057`*^9, 
   3.4606216392977943`*^9}, {3.460621695351623*^9, 3.460621733480344*^9}, 
   3.460621767776497*^9, {3.460621808613926*^9, 3.460621818947822*^9}, 
   3.4606218845579567`*^9, {3.460621966533445*^9, 3.460621990133649*^9}, 
   3.4606220631159353`*^9, 3.460622108278281*^9, 3.460622307422531*^9, {
   3.460622340194387*^9, 3.460622399876563*^9}, 3.460622677678253*^9, {
   3.4606227139032288`*^9, 3.460622724724502*^9}, {3.4606227631708183`*^9, 
   3.460622767762048*^9}, {3.460622936064171*^9, 3.4606229457541103`*^9}, 
   3.460622983907041*^9, {3.46062304456255*^9, 3.4606230504849653`*^9}, 
   3.460623100158823*^9, {3.460623130786044*^9, 3.460623160624483*^9}, {
   3.460623195112233*^9, 3.4606232589115973`*^9}, {3.460687841068869*^9, 
   3.460687890651434*^9}, 3.460687926945773*^9, {3.460690060174603*^9, 
   3.460690084761283*^9}, 3.46069027837682*^9, 3.46069166838479*^9, {
   3.460691707361595*^9, 3.460691723114663*^9}, 3.460693622036282*^9, 
   3.460693812591682*^9, 3.460694883680513*^9, 3.460696638080707*^9, 
   3.460697706266652*^9, 3.460697869993202*^9, 3.4606989934428387`*^9, 
   3.460699029777727*^9, 3.4607002745050917`*^9, {3.460700324810555*^9, 
   3.460700334725389*^9}, 3.460700620207369*^9, 3.4607014596003847`*^9, 
   3.460701680361329*^9, 3.460702875928625*^9, 3.460704476325636*^9, {
   3.460712578457333*^9, 3.460712594414483*^9}, 3.460713037123517*^9, {
   3.460713831567202*^9, 3.460713855301291*^9}, {3.460713899587134*^9, 
   3.4607139124348*^9}, {3.4607166262362223`*^9, 3.460716636335408*^9}, 
   3.460716672423882*^9, 3.460716740872676*^9, 3.460718146097331*^9, 
   3.460718328616887*^9, 3.46086484816509*^9, 3.460889902387048*^9, 
   3.460890010674266*^9, {3.4608914292251368`*^9, 3.460891466935093*^9}}],

Cell[BoxData[
 RowBox[{"-", "1.047250270559874`"}]], "Output",
 CellChangeTimes->{
  3.4605486948259277`*^9, 3.4605487302383738`*^9, {3.460548942020789*^9, 
   3.4605491932066317`*^9}, {3.460549258834635*^9, 3.460549268506208*^9}, 
   3.46054930285188*^9, {3.460549416954996*^9, 3.460549454863381*^9}, {
   3.460549588146182*^9, 3.460549603690003*^9}, {3.460549634506207*^9, 
   3.460549668574503*^9}, 3.460607558766708*^9, {3.460607593319531*^9, 
   3.460607711503766*^9}, 3.4606078350805283`*^9, 3.460607900416376*^9, 
   3.4606079523498783`*^9, {3.4606082496246*^9, 3.4606083332594213`*^9}, 
   3.460608366349736*^9, {3.460608435462336*^9, 3.460608585202838*^9}, {
   3.460608758434499*^9, 3.4606087821685743`*^9}, {3.460608916822608*^9, 
   3.460608951788578*^9}, {3.46060903760701*^9, 3.460609090568944*^9}, 
   3.4606196889607763`*^9, {3.460619782657147*^9, 3.460619837176239*^9}, {
   3.460619894843831*^9, 3.46061991829001*^9}, 3.4606201603760843`*^9, 
   3.4606202144476957`*^9, 3.460620298069223*^9, 3.4606209222373657`*^9, 
   3.4606209756890182`*^9, {3.4606210251998863`*^9, 3.460621076850589*^9}, 
   3.4606211069084263`*^9, {3.460621193995138*^9, 3.4606212147854347`*^9}, 
   3.460621324509781*^9, {3.460621421398328*^9, 3.460621429364738*^9}, {
   3.460621501046996*^9, 3.460621506697133*^9}, {3.4606216150042057`*^9, 
   3.4606216392977943`*^9}, {3.460621695351623*^9, 3.460621733480344*^9}, 
   3.460621767776497*^9, {3.460621808613926*^9, 3.460621818947822*^9}, 
   3.4606218845579567`*^9, {3.460621966533445*^9, 3.460621990133649*^9}, 
   3.4606220631159353`*^9, 3.460622108278281*^9, 3.460622307422531*^9, {
   3.460622340194387*^9, 3.460622399876563*^9}, 3.460622677678253*^9, {
   3.4606227139032288`*^9, 3.460622724724502*^9}, {3.4606227631708183`*^9, 
   3.460622767762048*^9}, {3.460622936064171*^9, 3.4606229457541103`*^9}, 
   3.460622983907041*^9, {3.46062304456255*^9, 3.4606230504849653`*^9}, 
   3.460623100158823*^9, {3.460623130786044*^9, 3.460623160624483*^9}, {
   3.460623195112233*^9, 3.4606232589115973`*^9}, {3.460687841068869*^9, 
   3.460687890651434*^9}, 3.460687926945773*^9, {3.460690060174603*^9, 
   3.460690084761283*^9}, 3.46069027837682*^9, 3.46069166838479*^9, {
   3.460691707361595*^9, 3.460691723114663*^9}, 3.460693622036282*^9, 
   3.460693812591682*^9, 3.460694883680513*^9, 3.460696638080707*^9, 
   3.460697706266652*^9, 3.460697869993202*^9, 3.4606989934428387`*^9, 
   3.460699029777727*^9, 3.4607002745050917`*^9, {3.460700324810555*^9, 
   3.460700334725389*^9}, 3.460700620207369*^9, 3.4607014596003847`*^9, 
   3.460701680361329*^9, 3.460702875928625*^9, 3.460704476325636*^9, {
   3.460712578457333*^9, 3.460712594414483*^9}, 3.460713037123517*^9, {
   3.460713831567202*^9, 3.460713855301291*^9}, {3.460713899587134*^9, 
   3.4607139124348*^9}, {3.4607166262362223`*^9, 3.460716636335408*^9}, 
   3.460716672423882*^9, 3.460716740872676*^9, 3.460718146097331*^9, 
   3.460718328616887*^9, 3.46086484816509*^9, 3.460889902387048*^9, 
   3.460890010674266*^9, {3.4608914292251368`*^9, 3.4608914670182133`*^9}}],

Cell[BoxData[
 RowBox[{"-", "0.924740282950158`"}]], "Output",
 CellChangeTimes->{
  3.4605486948259277`*^9, 3.4605487302383738`*^9, {3.460548942020789*^9, 
   3.4605491932066317`*^9}, {3.460549258834635*^9, 3.460549268506208*^9}, 
   3.46054930285188*^9, {3.460549416954996*^9, 3.460549454863381*^9}, {
   3.460549588146182*^9, 3.460549603690003*^9}, {3.460549634506207*^9, 
   3.460549668574503*^9}, 3.460607558766708*^9, {3.460607593319531*^9, 
   3.460607711503766*^9}, 3.4606078350805283`*^9, 3.460607900416376*^9, 
   3.4606079523498783`*^9, {3.4606082496246*^9, 3.4606083332594213`*^9}, 
   3.460608366349736*^9, {3.460608435462336*^9, 3.460608585202838*^9}, {
   3.460608758434499*^9, 3.4606087821685743`*^9}, {3.460608916822608*^9, 
   3.460608951788578*^9}, {3.46060903760701*^9, 3.460609090568944*^9}, 
   3.4606196889607763`*^9, {3.460619782657147*^9, 3.460619837176239*^9}, {
   3.460619894843831*^9, 3.46061991829001*^9}, 3.4606201603760843`*^9, 
   3.4606202144476957`*^9, 3.460620298069223*^9, 3.4606209222373657`*^9, 
   3.4606209756890182`*^9, {3.4606210251998863`*^9, 3.460621076850589*^9}, 
   3.4606211069084263`*^9, {3.460621193995138*^9, 3.4606212147854347`*^9}, 
   3.460621324509781*^9, {3.460621421398328*^9, 3.460621429364738*^9}, {
   3.460621501046996*^9, 3.460621506697133*^9}, {3.4606216150042057`*^9, 
   3.4606216392977943`*^9}, {3.460621695351623*^9, 3.460621733480344*^9}, 
   3.460621767776497*^9, {3.460621808613926*^9, 3.460621818947822*^9}, 
   3.4606218845579567`*^9, {3.460621966533445*^9, 3.460621990133649*^9}, 
   3.4606220631159353`*^9, 3.460622108278281*^9, 3.460622307422531*^9, {
   3.460622340194387*^9, 3.460622399876563*^9}, 3.460622677678253*^9, {
   3.4606227139032288`*^9, 3.460622724724502*^9}, {3.4606227631708183`*^9, 
   3.460622767762048*^9}, {3.460622936064171*^9, 3.4606229457541103`*^9}, 
   3.460622983907041*^9, {3.46062304456255*^9, 3.4606230504849653`*^9}, 
   3.460623100158823*^9, {3.460623130786044*^9, 3.460623160624483*^9}, {
   3.460623195112233*^9, 3.4606232589115973`*^9}, {3.460687841068869*^9, 
   3.460687890651434*^9}, 3.460687926945773*^9, {3.460690060174603*^9, 
   3.460690084761283*^9}, 3.46069027837682*^9, 3.46069166838479*^9, {
   3.460691707361595*^9, 3.460691723114663*^9}, 3.460693622036282*^9, 
   3.460693812591682*^9, 3.460694883680513*^9, 3.460696638080707*^9, 
   3.460697706266652*^9, 3.460697869993202*^9, 3.4606989934428387`*^9, 
   3.460699029777727*^9, 3.4607002745050917`*^9, {3.460700324810555*^9, 
   3.460700334725389*^9}, 3.460700620207369*^9, 3.4607014596003847`*^9, 
   3.460701680361329*^9, 3.460702875928625*^9, 3.460704476325636*^9, {
   3.460712578457333*^9, 3.460712594414483*^9}, 3.460713037123517*^9, {
   3.460713831567202*^9, 3.460713855301291*^9}, {3.460713899587134*^9, 
   3.4607139124348*^9}, {3.4607166262362223`*^9, 3.460716636335408*^9}, 
   3.460716672423882*^9, 3.460716740872676*^9, 3.460718146097331*^9, 
   3.460718328616887*^9, 3.46086484816509*^9, 3.460889902387048*^9, 
   3.460890010674266*^9, {3.4608914292251368`*^9, 3.46089146702818*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"scaling", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pp", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"m", "=", "200"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Y1", "=", 
   RowBox[{"{", 
    RowBox[{"{", "2", "}"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"IndividualLikNonlin", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Y1", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"IdioNonlin", ",", 
     RowBox[{"{", "}"}], ",", "m", ",", 
     RowBox[{"eps", "=", 
      RowBox[{"10.", "^", 
       RowBox[{"-", "16"}]}]}], ",", 
     RowBox[{"ksigma", "=", "Infinity"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0", ",", 
     RowBox[{"onlyNorKorr", "=", "0"}], ",", "\"\<NorKorr\>\"", ",", "0"}], 
    "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"IndividualLikNonlin", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Y1", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"IdioNonlin", ",", 
     RowBox[{"{", "}"}], ",", "m", ",", 
     RowBox[{"eps", "=", 
      RowBox[{"10.", "^", 
       RowBox[{"-", "16"}]}]}], ",", 
     RowBox[{"ksigma", "=", "Infinity"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0", ",", 
     RowBox[{"onlyNorKorr", "=", "0"}], ",", "\"\<StochLin\>\"", ",", "0"}], 
    "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"IndividualLikNonlin", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Y1", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
   RowBox[{"{", 
    RowBox[{"IdioNonlin", ",", 
     RowBox[{"{", "}"}], ",", "m", ",", 
     RowBox[{"eps", "=", 
      RowBox[{"10.", "^", 
       RowBox[{"-", "16"}]}]}], ",", 
     RowBox[{"ksigma", "=", "Infinity"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Singular", "=", "False"}], ",", 
     RowBox[{"2", "Pi"}], " ", ",", "0", ",", 
     RowBox[{"onlyNorKorr", "=", "1"}], ",", "\"\<NorKorr\>\"", ",", "0"}], 
    "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.460264864897327*^9, 3.460264932378791*^9}, {
   3.460265489300803*^9, 3.460265492492799*^9}, {3.46027038606568*^9, 
   3.460270391802556*^9}, {3.4602704971596107`*^9, 3.4602705817118692`*^9}, {
   3.46027367414145*^9, 3.460273674236417*^9}, {3.460279775378045*^9, 
   3.4602797754444103`*^9}, {3.4602799530257587`*^9, 
   3.4602799533811693`*^9}, {3.460280067013379*^9, 3.460280067130088*^9}, {
   3.4602801040742397`*^9, 3.460280104129944*^9}, {3.4602801453821163`*^9, 
   3.4602801673531218`*^9}, {3.46028174693688*^9, 3.460281763776168*^9}, {
   3.4602818356559362`*^9, 3.460281835739462*^9}, {3.460281898670804*^9, 
   3.460281898732609*^9}, {3.460282025318959*^9, 3.460282025741701*^9}, {
   3.460282062175247*^9, 3.460282071535883*^9}, {3.460283778391947*^9, 
   3.4602837888805027`*^9}, {3.4602838305963707`*^9, 3.460283854615387*^9}, {
   3.46028477341341*^9, 3.460284779157151*^9}, {3.460285035206752*^9, 
   3.460285046973556*^9}, {3.46028555906642*^9, 3.460285574425418*^9}, {
   3.4602857519094887`*^9, 3.4602857519715776`*^9}, {3.460285881590439*^9, 
   3.4602858816380377`*^9}, {3.460286117999454*^9, 3.460286123654068*^9}, {
   3.4602863340289307`*^9, 3.4602863377475977`*^9}, {3.4603641927287188`*^9, 
   3.460364197580667*^9}, {3.460365058304535*^9, 3.4603650587979116`*^9}, {
   3.460365091217347*^9, 3.460365126318194*^9}, {3.4603652464521227`*^9, 
   3.460365260029804*^9}, {3.460365412299954*^9, 3.460365434375272*^9}, {
   3.460365485584791*^9, 3.460365520950554*^9}, {3.460366663535665*^9, 
   3.460366678997499*^9}, {3.4603667867732773`*^9, 3.4603667868283587`*^9}, {
   3.460367092714067*^9, 3.460367098883337*^9}, {3.460369235357655*^9, 
   3.460369263924768*^9}, {3.460369362646221*^9, 3.46036936313859*^9}, {
   3.46036946785526*^9, 3.4603694691077127`*^9}, {3.46037339069245*^9, 
   3.460373390747698*^9}, {3.460373605599341*^9, 3.4603736056503153`*^9}, {
   3.460377091108459*^9, 3.460377126962656*^9}, {3.460377288435691*^9, 
   3.460377301095058*^9}, {3.4603774697122087`*^9, 3.460377479788327*^9}, {
   3.460377585320611*^9, 3.460377603716568*^9}, {3.4603776957101793`*^9, 
   3.460377736561165*^9}, {3.460377923292104*^9, 3.4603779233524303`*^9}, {
   3.460378105932313*^9, 3.46037817981962*^9}, {3.460427531315346*^9, 
   3.460427537420005*^9}, {3.460427638978484*^9, 3.4604276390230217`*^9}, {
   3.4604277414332314`*^9, 3.460427769573126*^9}, {3.4604279604982853`*^9, 
   3.460427960554902*^9}, {3.460430680071252*^9, 3.460430680172152*^9}, {
   3.460430712203142*^9, 3.460430712557424*^9}, {3.460430775931464*^9, 
   3.460430776020101*^9}, {3.460430814349124*^9, 3.460430814950081*^9}, {
   3.46043100067663*^9, 3.460431000775926*^9}, {3.460431035518139*^9, 
   3.460431043615539*^9}, {3.460431139283386*^9, 3.460431139330926*^9}, {
   3.4604311987514153`*^9, 3.460431233744923*^9}, {3.460431314274002*^9, 
   3.460431314321568*^9}, {3.4604316727142878`*^9, 3.4604316728008432`*^9}, {
   3.460431886035831*^9, 3.46043189177104*^9}, {3.460432099991972*^9, 
   3.460432100073539*^9}, {3.460432236204804*^9, 3.4604322362468243`*^9}, {
   3.4604323376555843`*^9, 3.460432357162323*^9}, {3.460432403219545*^9, 
   3.460432403269651*^9}, {3.460432564446265*^9, 3.4604325911495867`*^9}, {
   3.460432813689516*^9, 3.460432813733564*^9}, {3.460432944239506*^9, 
   3.460432989199974*^9}, {3.460433097024789*^9, 3.460433097139295*^9}, {
   3.460433291653358*^9, 3.46043329173923*^9}, {3.460433672964451*^9, 
   3.460433673010107*^9}, {3.460433845665332*^9, 3.4604338457416363`*^9}, {
   3.4604344009903316`*^9, 3.460434401033557*^9}, {3.4604346235115023`*^9, 
   3.460434638473834*^9}, {3.460434675871023*^9, 3.460434675925946*^9}, {
   3.4604350413113747`*^9, 3.4604350414069347`*^9}, {3.460436666989565*^9, 
   3.460436677468376*^9}, {3.460437023691847*^9, 3.460437023772811*^9}, {
   3.460437179838045*^9, 3.460437214787621*^9}, {3.4604373750456057`*^9, 
   3.460437375101828*^9}, {3.460437455923118*^9, 3.4604374559862347`*^9}, {
   3.460437643282413*^9, 3.4604376433404827`*^9}, {3.460439284564681*^9, 
   3.46043929340877*^9}, {3.460439393566842*^9, 3.460439393962884*^9}, {
   3.46044000098571*^9, 3.460440001044331*^9}, {3.460443930270521*^9, 
   3.460443930334333*^9}, {3.460443966799687*^9, 3.46044399790462*^9}, {
   3.460444060284606*^9, 3.460444061730588*^9}, {3.460444101336812*^9, 
   3.46044410138903*^9}, {3.460444186536171*^9, 3.460444194286351*^9}, {
   3.460444233408099*^9, 3.460444248920389*^9}, {3.460444338058318*^9, 
   3.460444355662019*^9}, {3.460444400012597*^9, 3.460444431012135*^9}, {
   3.460444591036777*^9, 3.4604446631572647`*^9}, {3.46044479971354*^9, 
   3.460444799768903*^9}, {3.460444831583193*^9, 3.460444859781989*^9}, {
   3.46044502143334*^9, 3.460445021504759*^9}, {3.460459950502769*^9, 
   3.460459971711813*^9}, {3.460460068419449*^9, 3.460460088588605*^9}, {
   3.460460154598343*^9, 3.46046015516997*^9}, {3.460460281436612*^9, 
   3.460460281521656*^9}, {3.4604604120265713`*^9, 3.460460412125514*^9}, {
   3.4604607607833633`*^9, 3.4604607621971283`*^9}, {3.460460826677142*^9, 
   3.460460827186878*^9}, {3.4604608962826014`*^9, 3.4604608963501987`*^9}, {
   3.460460962965583*^9, 3.460460963358262*^9}, {3.46046100555375*^9, 
   3.4604610220017967`*^9}, {3.46046105589403*^9, 3.460461056004932*^9}, {
   3.460461154113535*^9, 3.460461154227416*^9}, {3.460461800671767*^9, 
   3.4604618154025*^9}, {3.46046184541817*^9, 3.46046186011173*^9}, {
   3.460461896620476*^9, 3.460461896672694*^9}, {3.460461952952413*^9, 
   3.4604619533933907`*^9}, {3.460462913572587*^9, 3.460462920740217*^9}, {
   3.460548175219633*^9, 3.460548179294363*^9}, {3.460548260239588*^9, 
   3.460548260297719*^9}, {3.460548333262265*^9, 3.460548333779482*^9}, {
   3.460548675566861*^9, 3.460548693804049*^9}, {3.460548972449188*^9, 
   3.4605491929429903`*^9}, {3.460549257251377*^9, 3.460549267901092*^9}, {
   3.4605496024993763`*^9, 3.4605496337333307`*^9}, {3.460549667762332*^9, 
   3.46054966825324*^9}, {3.460607544492757*^9, 3.460607557468165*^9}, {
   3.460607591423718*^9, 3.460607615734179*^9}, {3.4606076546131697`*^9, 
   3.460607711208377*^9}, {3.460607950300333*^9, 3.460607950788868*^9}, {
   3.460608254691515*^9, 3.460608332544549*^9}, {3.460608365633368*^9, 
   3.4606083656943207`*^9}, {3.460608434510606*^9, 3.460608528562172*^9}, {
   3.460608559009796*^9, 3.460608584467407*^9}, {3.460608755712895*^9, 
   3.4606087818086443`*^9}, {3.460608915820417*^9, 3.46060895109648*^9}, {
   3.4606090353514013`*^9, 3.460609089338924*^9}, {3.460619799153166*^9, 
   3.4606198362306223`*^9}, 3.460619905423987*^9, {3.460621024814104*^9, 
   3.460621075759169*^9}, {3.460621192179472*^9, 3.4606212134045153`*^9}, {
   3.4606214203824053`*^9, 3.460621428920328*^9}, {3.4606215045280933`*^9, 
   3.460621505423924*^9}, {3.460621613387906*^9, 3.460621638578682*^9}, {
   3.460621694074709*^9, 3.460621703411603*^9}, {3.4606217660430403`*^9, 
   3.460621767329904*^9}, {3.460621806996888*^9, 3.4606218076980343`*^9}, {
   3.460621883288566*^9, 3.46062188333815*^9}, {3.460621970939987*^9, 
   3.4606219893319883`*^9}, {3.460622107014687*^9, 3.460622107100986*^9}, {
   3.460622297972288*^9, 3.460622306665023*^9}, {3.460622338760532*^9, 
   3.460622398767516*^9}, {3.460622676496147*^9, 3.4606226765399942`*^9}, {
   3.4606227120282917`*^9, 3.460622766881015*^9}, {3.4606229263578787`*^9, 
   3.460622944163636*^9}, {3.4606229791390038`*^9, 3.460622982600178*^9}, {
   3.4606230423052397`*^9, 3.460623049675028*^9}, {3.4606231523155127`*^9, 
   3.460623159744812*^9}, {3.460623194195408*^9, 3.460623258120954*^9}, {
   3.460687849143656*^9, 3.460687889401013*^9}, {3.460690081391994*^9, 
   3.460690099337471*^9}, {3.460690130038103*^9, 3.46069013008521*^9}, 
   3.4606902754485703`*^9, {3.4606937256675873`*^9, 3.460693732963479*^9}, {
   3.46069380256997*^9, 3.460693821921266*^9}, {3.460694110007152*^9, 
   3.460694111753396*^9}, {3.46069438482207*^9, 3.460694412630849*^9}, {
   3.4606948097984943`*^9, 3.460694811995069*^9}, {3.4606949315352297`*^9, 
   3.460694942467441*^9}, {3.46069553282626*^9, 3.460695537762641*^9}, {
   3.4606959645065536`*^9, 3.4606960446581793`*^9}, {3.460696241341283*^9, 
   3.460696252439539*^9}, {3.4606966463545427`*^9, 3.460696646787632*^9}, 
   3.460698002134129*^9, {3.460699006868629*^9, 3.460699016312397*^9}, {
   3.4606992398575487`*^9, 3.46069924875381*^9}, {3.460699414491041*^9, 
   3.460699445356464*^9}, {3.460699542245335*^9, 3.460699574543728*^9}, {
   3.4606997815193663`*^9, 3.460699790038615*^9}, {3.460700625492282*^9, 
   3.460700639053712*^9}, {3.460701666209906*^9, 3.4607016674378977`*^9}, {
   3.4607044130681334`*^9, 3.460704413273118*^9}, {3.46070445138295*^9, 
   3.4607044514347343`*^9}, {3.460704492762239*^9, 3.460704516605468*^9}, {
   3.4607046279131327`*^9, 3.460704646387837*^9}, {3.460704755792667*^9, 
   3.4607047772650547`*^9}, {3.4607049514390507`*^9, 3.460704951499386*^9}, {
   3.460705149340721*^9, 3.460705174028206*^9}, {3.460705209320664*^9, 
   3.460705214762663*^9}, {3.4607052725452003`*^9, 3.460705285058607*^9}, {
   3.4607053271048403`*^9, 3.46070533838897*^9}, {3.460712609690332*^9, 
   3.460712613264339*^9}, {3.460713281802175*^9, 3.460713293515684*^9}, {
   3.460713956024549*^9, 3.4607139942787857`*^9}, {3.460714187777926*^9, 
   3.460714188152686*^9}, 3.460716611301156*^9, 3.4607167259037523`*^9, {
   3.4608650674253807`*^9, 3.460865088349908*^9}, {3.460865124990815*^9, 
   3.4608651294206467`*^9}, {3.460865194415337*^9, 3.4608652054777203`*^9}, {
   3.460865298260353*^9, 3.460865342651475*^9}, {3.4608653827759123`*^9, 
   3.460865442420289*^9}, {3.4608655984805727`*^9, 3.460865598657593*^9}, {
   3.4608656299199553`*^9, 3.4608656306521683`*^9}, {3.4608656759784813`*^9, 
   3.460865762208869*^9}, {3.460865894459096*^9, 3.460865895021585*^9}, {
   3.460865928120473*^9, 3.46086592860039*^9}, {3.4608659870899563`*^9, 
   3.460865999817178*^9}, {3.4608660346281967`*^9, 3.460866038189959*^9}, {
   3.460866071630413*^9, 3.4608660772735577`*^9}, {3.460866170540369*^9, 
   3.460866171848431*^9}, {3.4608662044093227`*^9, 3.460866227143955*^9}, {
   3.460866590514419*^9, 3.460866603123413*^9}, {3.4608840970493317`*^9, 
   3.460884162606284*^9}, {3.460884255293991*^9, 3.4608842558022203`*^9}, {
   3.460884853534459*^9, 3.4608848951349287`*^9}, {3.4608900321748543`*^9, 
   3.46089003666643*^9}, {3.460890114523884*^9, 3.460890189585753*^9}, {
   3.4608902652075033`*^9, 3.460890287409711*^9}, {3.460890424487276*^9, 
   3.460890449506103*^9}, {3.460890483227208*^9, 3.460890502598156*^9}, {
   3.460890550250969*^9, 3.460890587325244*^9}, {3.460891579456242*^9, 
   3.460891620327457*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0, 0, 1], PointSize[0.03], Thickness[0.03], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJwBsQRO+yFib1JlAgAAAEoAAAACAAAAJ1Bdz3EV9r9MxwSpoTaMGhsLo2KP
wPS/70ikPnFXYxrhEuPqhmzzv9VmXn165zsaSQ9GCFAZ8r9OKHxWYCsVGkUJ
vZXixvC/PuB109rh8BkeM1RLberuv6rQUjvikFYwXhp3/YhI7L88mOF0v9sz
MPL86jEJqOm/c1CNKpFYEjBmcMw13wjnv2MUK/8dyfEvghgErvxq5L+KkZ4p
OxbSL94cR5JTzuG/9Zff83VJsy8Mk7VQrGXev98vg9wBj5UvpGgs/+0w2b/h
Vf1NcUB5L8xZOtlR/tO/Bg9R+ef7Xi/IWUAVfJvNv/BcLUci6EMveJOyczI+
w79RYJbky8cqLxBH3gIqybG/rsG48rjaEi8AMqxV0xiHPzH/r7nWYYI80LXv
ssiItz/QzGd+kFVsPLgEqtUfFMY/n1aYiffWVjzgM48xdzDQPxphpVJ4QEM8
vGe1Cn9V1T/OvTB1MfcwPFz9DTM+edo/7i7rpHtBHzzE+e4fy5vfPyqPBuIB
Fw48v7pRAp5e4j+hNVpy3UT+O8ct02vT7uQ/JeqMlQPQ7zvpHturkH7nP1UZ
OS+oduE7Iu9iiOAN6j8/I4DKvQbUO25rZrDNnOw/qRSbVAD8xzvq0j2+Yivv
P2gzMUIL/707A4/1HNXc8D/bdASs7IA1QKwDrk3XI/I/jP1psspRLUDgI1Em
vWrzP4mV+Qsm3iRAE7YR1oux9D/2R333lgIfQPrPYIdI+PU/kyTv/WQNGEA7
YP9g+D73P9FaAjNIeRNALoINh6CF+D9sZjraK3UQQIQ/GBxGzPk/890hTzkJ
DUB4YSZC7hL7PzB9DXJTvApAufHEG55Z/D94Eri0GrIJQJ8LFM1aoP0/R2xG
vzrHCUDSndR8Kef+PyFiZMCk/gpAA9+7qgcXAED9eCrKQIINQFgZGMOIugBA
L6dGtz7WEEAgbAOiGl4BQIBbG4nsDhRA/UV55b8BAkBn6Vlp2fIYQBAlei97
pQJArX63OEgzIEAbGZwmT0kDQE/Q9kc7+CVAaBWedj7tA0ALKVoZPR0vQCly
/tBLkQRAeBRLX/4CN0CkAZXteTUFQEZ/c4YXx0FALCExi8vZBUARSQJxSrJM
QOIzPHBDfgZAPhpzgR0zWEBc+mBr5CIHQM1belKQU2VAj0A4VLHHB0DJrQhn
1qRzQChj+wutbAhAJIRew13qgkCpND1+2hEJQJUKvNttC5NAEtOpoTy3CUCo
M8PAng2kQBYKznjWXApAfbt3k2YWtkBy5uYSqwILQLqVTcpWdMlAEiy6jL2o
C0Bn4IWeSrPeQO5teBERTwxA04QekXhh80A6k6nbqPUMQMsNX8BtnwlBGqgk
NoicDUCzRUflsb0hQfjmE32yQw5AzwuXQqG9OUHw/AUfK+sOQLbQolV0klNB
GqANnvWSD0DgRPg1sDRvQblTeMiKHRBAyK1pn6MXikHO9jNSx3EQQCXJj7UX
5KZBwbI4TjLGEEBgEfmHYhTFQUP02qrNGhFAKGoXSE9i5EElNYJjm28RQAdg
meA3tQRCNDNygZ3EEUCkkQjkThwmQnbEoBzWGRJAarQ5wD7TSEKm8RsD
           
           "]]}}, {}}, {{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.01], Thickness[0.01], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJw1lHlQ00cYhkPCDZEkiHIJBTUtRykQQArkt2sRQVHkkLZUm6FkBJXDgBWC
CFSskooDFhQ7A1IUccJZQAGl0KUlw6GBUFKwgBOOIgzUAOXQCAHaTjZ/7Ozs
zM7u973f8742UedCT5FJJNLh/9b/+/vBX0oSTd4gu/O2TF5BjY+FQVlUXvsK
SuOV5ftT//SZYPw1dy1uGQVXdAyaXCCzDxkd1A02W0LlaQ/lENmz/fTabk92
LiJx6PDUeFAo24p1PDB+bh7ti9bd+qYuhc0xT9kQBLxGO7ppudeUxewl5ZyL
nnAW+Qt51tZd7exonth9THcG7Wp6MucRNcnOMtWsVZ6dQsILEtkMg0LILP3z
w/omkITzQ7gXsiUMCxqDq0/J0B1Ei7NM3k88OO24JXceRtMpN5LdhjiEOMJr
OGRTinwESv7FgVSiOwKaXCrqRbKtM0YBV24R/IKG865EByK43i4seS1B85eR
7XvqUU9EufyATSdBcq0Ol5pmg9a38X3+DBnR37jQ0C1oBkdzd8bciVkmnmhW
Dlpv7wTP9lQf5j7TAeOsPJcU535Qlkidsmu2AK0xjfqZ4YNArrVlPPKTEzi5
QWURqSOAl525TjAhEL2bt35eNAY8JV2tfnbBALWEkEs4k2DUPu3E5d84oOtD
aax0fgp42x/J+fpFLJi1Gq26mTEDtMm2+yWKFGC7ECUYp86BtYhbxmv3r4CE
2Oi63uLX4FPPntDA4lwwN8D+JcphAUxnkto8HxcCSt6q5eDLRVDdf7OoVbsU
VFNqj77YvQQ+5ga0iwXlYHx3CLPt7DJItxd89/v1KmDcRB/KqV8BzmdOjFqJ
6sCaJDI7QLEKXgY5VGQlPALekVuRCuIt0HBsCivkNQKnLGp26VUFmHGVtTld
bQLfAlPLg+J3YBaf+V8xP5lnrAOlg+r+039EFiURSiDF7/1osL33i9INwMT/
Ddz945LdzCZIw/VQxn6u1NlJggSu93Mz0w5BCwnW4H7ei6PcN+doQDnud8Mv
9RXSIMMjWA/a3osfpZWToQLrZWFWzDx2iAIVGio9T5uUJBNyCjyA9bZL2uwP
/F4TTuB5PNC4LU9114IeeF6ONi45z4e1YAKe5yTLh+eboQ1fqee9Fhk7ZasD
72Ee8qDn8fouHSjGvHzAXTeoidOFgZinCjd2xghdDz7CvDGkFfd8mvWgmscd
+n38oZP60A3zmjQ9zagiG8BRzDPDseVGm9AA7sO8z8fz6fRjhlDtB6+CilHh
qiEsxH4xF+7xEBRTYQ/2k2LaOL3BdxtU+21RqWXt8Pc2qPajeSm1ZDXfCHIf
qvz6NIzffX0XDZoOqvzc94YV2pVIg2q//9rgGeTaSYN6n6nywHdlpLLXnA4l
6aq82OuexS06R4f1IlWeuLGSLt8V0eFjjipvkkWllkNmDOiA8+hf10IrCA==

           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{2}, {1}},
      PlotRange->{{-3, 3}, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {193.5, -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.03], Thickness[0.03], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJw1lHlQ00cYhkPCDZEkiHIJBTUtRykQQArkt2sRQVHkkLZUm6FkBJXDgBWC
CFSskooDFhQ7A1IUccJZQAGl0KUlw6GBUFKwgBOOIgzUAOXQCAHaTjZ/7Ozs
zM7u973f8742UedCT5FJJNLh/9b/+/vBX0oSTd4gu/O2TF5BjY+FQVlUXvsK
SuOV5ftT//SZYPw1dy1uGQVXdAyaXCCzDxkd1A02W0LlaQ/lENmz/fTabk92
LiJx6PDUeFAo24p1PDB+bh7ti9bd+qYuhc0xT9kQBLxGO7ppudeUxewl5ZyL
nnAW+Qt51tZd7exonth9THcG7Wp6MucRNcnOMtWsVZ6dQsILEtkMg0LILP3z
w/omkITzQ7gXsiUMCxqDq0/J0B1Ei7NM3k88OO24JXceRtMpN5LdhjiEOMJr
OGRTinwESv7FgVSiOwKaXCrqRbKtM0YBV24R/IKG865EByK43i4seS1B85eR
7XvqUU9EufyATSdBcq0Ol5pmg9a38X3+DBnR37jQ0C1oBkdzd8bciVkmnmhW
Dlpv7wTP9lQf5j7TAeOsPJcU535Qlkidsmu2AK0xjfqZ4YNArrVlPPKTEzi5
QWURqSOAl525TjAhEL2bt35eNAY8JV2tfnbBALWEkEs4k2DUPu3E5d84oOtD
aax0fgp42x/J+fpFLJi1Gq26mTEDtMm2+yWKFGC7ECUYp86BtYhbxmv3r4CE
2Oi63uLX4FPPntDA4lwwN8D+JcphAUxnkto8HxcCSt6q5eDLRVDdf7OoVbsU
VFNqj77YvQQ+5ga0iwXlYHx3CLPt7DJItxd89/v1KmDcRB/KqV8BzmdOjFqJ
6sCaJDI7QLEKXgY5VGQlPALekVuRCuIt0HBsCivkNQKnLGp26VUFmHGVtTld
bQLfAlPLg+J3YBaf+V8xP5lnrAOlg+r+039EFiURSiDF7/1osL33i9INwMT/
Ddz945LdzCZIw/VQxn6u1NlJggSu93Mz0w5BCwnW4H7ei6PcN+doQDnud8Mv
9RXSIMMjWA/a3osfpZWToQLrZWFWzDx2iAIVGio9T5uUJBNyCjyA9bZL2uwP
/F4TTuB5PNC4LU9114IeeF6ONi45z4e1YAKe5yTLh+eboQ1fqee9Fhk7ZasD
72Ee8qDn8fouHSjGvHzAXTeoidOFgZinCjd2xghdDz7CvDGkFfd8mvWgmscd
+n38oZP60A3zmjQ9zagiG8BRzDPDseVGm9AA7sO8z8fz6fRjhlDtB6+CilHh
qiEsxH4xF+7xEBRTYQ/2k2LaOL3BdxtU+21RqWXt8Pc2qPajeSm1ZDXfCHIf
qvz6NIzffX0XDZoOqvzc94YV2pVIg2q//9rgGeTaSYN6n6nywHdlpLLXnA4l
6aq82OuexS06R4f1IlWeuLGSLt8V0eFjjipvkkWllkNmDOiA8+hf10IrCA==

           "]]}}, {}}, {{}, 
        {RGBColor[1, 0, 0], PointSize[0.02], Thickness[0.02], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxFyn0w0wEcx/HZLA+z2JBthhAl8jQ652F27TzlynNHJ7fmyHnIQ3dMRLnK
Ut2K8xfWKu7mIZfdSUSr7Dwcw1l06Dy1OIsRxrBR/dH398fn3ve6+9iys6NT
0CgU6uLf/evpyGujueY74rgGVytsRZGFJe41m/dpG7xA/KF4mLkFDjMO1o8k
b4KDDHqqF/s2wNa02PAshVLcXVqc7raLdU2iFGi5oavgTY3Cw0C4Ak7NGfae
018Gl5F0WzXpcvAsNaQyZmQBbFTVHtmSMguuT3M5WnOfAg8n+E5FHcrAAwkM
8+IaKZhTJbrlSe8Fm4TMos8OtoFRni1xMlJ54CMcO/4L4anfWPu6aIDbAX6v
2zRhY9YHnqfxPArcx8DdN9oNS+MmwIlaPI1eOA2W7ClthmrmwOKuKDQ/aRHc
f06WIVPKwSvWM83PSpbBduts7jxeAb6ZkfpWWrsKVowHfGQ7r4MxPBV14vtG
oJw5ePeKwpjRgmm99M1+EzxvH+XYk74FNn1HmHzctg3eH2WVh6pVYD/WEUtN
3wW7luHLBQ/U4PuBJGrw8B6Yc93xgpJ4AO78LbHkJ2jAL3Bm0qsCLXi87mux
0/IhGDP3oUnPAsX473gyqZfbhfhkJuYVJUkHrA0q/CnWQYNNHG67FTUgtiTX
OkaEYcBp5vx8+hpip7zDsfDnuuB6neq1Qm8s2MXW4/HQFOJFmn8Os+QYOHGf
lSG30wPzGD6xbf2IzyQf4N5k6oMbvQJKpgkGYKKs8aV/B+IThiOcyURDcN7S
ErEZjUP+Ll1PeoSIlVkcAiHCCOxb1TgjVCGmCE+d59biweol0zsi5nHwhgZr
4/wLMUWA56sqjcGdMZyBCisT8MgOLbo/F/Fnkc9lzz7EzO3pJimFAHbwLkuu
yUbsRcu7VydBnC8RUCfJRPAfN3Qicw==
           "]]}}, {}}, {{}, 
        {RGBColor[1, 1, 0], PointSize[0.015], Thickness[0.015], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJwBsQRO+yFib1JlAgAAAEoAAAACAAAAJ1Bdz3EV9r92/bbKODzfPBsLo2KP
wPS/ya4UngPIBj3hEuPqhmzzvyQhDNrSlC89SQ9GCFAZ8r9gLqV8c9BUPUUJ
vZXixvC/nxXIOpgZej0eM1RLberuvyAcdaILJp89Xhp3/YhI7L99NlaToLLB
PfL86jEJqOm/WW+9zSAo4z1mcMw13wjnv+tWYw2jwgM+ghgErvxq5L/niK1c
Y24jPt4cR5JTzuG/1W5HV9w4Qj4Mk7VQrGXevw2bZSRRTWA+pGgs/+0w2b9y
btvO7NV7PsxZOtlR/tO/0tsw/ZKvlj7IWUAVfJvNv+eD8pydp7E+eJOyczI+
w78CRh64Jj/KPhBH3gIqybG/JJ/0rOKj4j4AMqxV0xiHP+ivU/5dTfk+0LXv
ssiItz/YSghzRWoQP7gEqtUfFMY/87cE1zRdJD/gM48xdzDQPxxfDbXEKDg/
vGe1Cn9V1T8iARv5NWpLP1z9DTM+edo/hHTJ8/LCXT/E+e4fy5vfP/BCQ+Yq
6m4/v7pRAp5e4j/mOdDmVLt+P8ct02vT7uQ/b5sse5s9jT/pHturkH7nPzJg
5/0copo/Iu9iiOAN6j9WtV41lDmnP25rZrDNnOw/n9QeXWdksz/q0j2+Yivv
Pwba6VvdAr8/A4/1HNXc8D+IfLD3Or/HP6wDrk3XI/I/5OZ8lqZq0T/gI1Em
vWrzPz3XaxZ3eNg/E7YR1oux9D/DB8WsknfgP/rPYIdI+PU/sIjpAws75T87
YP9g+D73P8ZrNJ/mOOo/LoINh6CF+D/3mjpvHQfvP4Q/GBxGzPk/IXwD0C2W
8T94YSZC7hL7P4rtl+yNGfM/ufHEG55Z/D+A9itecN/zP58LFM1aoP0/ejOT
OyfP8z/SndR8Kef+P5mVj86h6vI/A9+7qgcXAEDEpiZMDE7xP1gZGMOIugBA
MffQIjlU7j8gbAOiGl4BQBGLDwZGdek//UV55b8BAkCFiC5xyHfkPxAlei97
pQJA3dZkTE+F3z8bGZwmT0kDQBi1QXhFPtc/aBWedj7tA0A+mTQWeGnQPyly
/tBLkQRAlqtCNNMwxj+kAZXteTUFQAzXB81Vubw/LCExi8vZBUAGYue4dMux
P+IzPHBDfgZAPwjIP/MZpT9c+mBr5CIHQJe7+1S98Zc/j0A4VLHHB0B9xLxs
wv6JPyhj+wutbAhA8Juw2wX/ej+pND1+2hEJQJkpdtMn0Go/EtOpoTy3CUBD
QRzF7XZZPxYKznjWXApAIJ03DIYeRz9y5uYSqwILQGCNpQ2pDzQ/Eiy6jL2o
C0C/nSlkG6IgP+5teBERTwxA+rPXDB5ZCj86k6nbqPUMQNoS02/s7fM+Gqgk
NoicDUB2acmwjMjcPvjmE32yQw5AEKM0borWwz7w/AUfK+sOQBUA4ecsF6o+
GqANnvWSD0DFU/LiIl2QPrlTeMiKHRBADcWvSBuScz7O9jNSx3EQQPt3ut7H
TlY+wbI4TjLGEECR82QZgTk4PkP02qrNGhFA/g4LjiENGT4lNYJjm28RQNKh
0CvVqPg9NDNygZ3EEUBq+Ei+WBjXPXbEoBzWGRJARugYC9eRtD2mLDAa
           
           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{2}, None},
      PlotRange->{{-3, 3}, {0, 7.978845608028653}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {580.5, -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHwpbqybJ2VYtbbBeSP86J4G+I3Rzf
J8wG5z+TTXq34S8znK8v5x1uws0E5384coWhXokBzn+7d3r+boU/+2F8uaJf
E62cf8D5t3gszj8U+gLn873MldZ/837/3vqaLP3vrHobd4Qwyjm8gPMvrXpk
uevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs6+izsp4pBgr/XnOeav
rK/dg/NV/u6bKXXsOZzf4X4+i+vBazj/9cT71r9+vofzbZ2aHyaVf7B/6nyy
IewVv0PrbrGlJz4i+GdNVmXo5XyE80XX2epMeYbgL12Qsjn+9ic433Ryt5X2
hc9wvgBrjrXe469w/qsyHxvDb9/h/KpbMzpLr/6G8w9os947wczgAOOfcp67
jV+YCc4/JP17y9d/zHB+acPrpe4ibHD+rBN6h5S52OF8aHqA8wFHS/+u
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk31fkfgC8XNxRCFGWyZZtDQsL9fF6fkLWRUFK2yKSyNNZMWcqSYohU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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk41Hsfh4cZpggllRKnNCXLQ8LBMP/vP8kgaeEklOgILVqEji2FEQ7T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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHwpbqybJ2VYtbbBeSP86J4G+I3Rzf
J8wG5z+TTXq34S8znK8v5x1uws0E5384coWhXokBzn+7d3r+boU/+2F8uaJf
E62cf8D5t3gszj8U+gLn873MldZ/837/3vqaLP3vrHobd4Qwyjm8gPMvrXpk
uevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs6+izsp4pBgr/XnOeav
rK/dg/NV/u6bKXXsOZzf4X4+i+vBazj/9cT71r9+vofzbZ2aHyaVf7B/6nyy
IewVv0PrbrGlJz4i+GdNVmXo5XyE80XX2epMeYbgL12Qsjn+9ic433Ryt5X2
hc9wvgBrjrXe469w/qsyHxvDb9/h/KpbMzpLr/6G8w9os947wczgAOOfcp67
jV+YCc4/JP17y9d/zHB+acPrpe4ibHD+rBN6h5S52OF8aHqA8wFHS/+u
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk31fkfgC8XNxRCFGWyZZtDQsL9fF6fkLWRUFK2yKSyNNZMWcqSYohU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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk41Hsfh4cZpggllRKnNCXLQ8LBMP/vP8kgaeEklOgILVqEji2FEQ7T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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHwpbqybJ2VYtbbBeSP86J4G+I3Rzf
J8wG5z+TTXq34S8znK8v5x1uws0E5384coWhXokBzn+7d3r+boU/+2F8uaJf
E62cf8D5t3gszj8U+gLn873MldZ/837/3vqaLP3vrHobd4Qwyjm8gPMvrXpk
uevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs6+izsp4pBgr/XnOeav
rK/dg/NV/u6bKXXsOZzf4X4+i+vBazj/9cT71r9+vofzbZ2aHyaVf7B/6nyy
IewVv0PrbrGlJz4i+GdNVmXo5XyE80XX2epMeYbgL12Qsjn+9ic433Ryt5X2
hc9wvgBrjrXe469w/qsyHxvDb9/h/KpbMzpLr/6G8w9os947wczgAOOfcp67
jV+YCc4/JP17y9d/zHB+acPrpe4ibHD+rBN6h5S52OF8aHqA8wFHS/+u
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk31fkfgC8XNxRCFGWyZZtDQsL9fF6fkLWRUFK2yKSyNNZMWcqSYohU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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk41Hsfh4cZpggllRKnNCXLQ8LBMP/vP8kgaeEklOgILVqEji2FEQ7T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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHwpbqybJ2VYtbbBeSP86J4G+I3Rzf
J8wG5z+TTXq34S8znK8v5x1uws0E5384coWhXokBzn+7d3r+boU/+2F8uaJf
E62cf8D5t3gszj8U+gLn873MldZ/837/3vqaLP3vrHobd4Qwyjm8gPMvrXpk
uevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs6+izsp4pBgr/XnOeav
rK/dg/NV/u6bKXXsOZzf4X4+i+vBazj/9cT71r9+vofzbZ2aHyaVf7B/6nyy
IewVv0PrbrGlJz4i+GdNVmXo5XyE80XX2epMeYbgL12Qsjn+9ic433Ryt5X2
hc9wvgBrjrXe469w/qsyHxvDb9/h/KpbMzpLr/6G8w9os947wczgAOOfcp67
jV+YCc4/JP17y9d/zHB+acPrpe4ibHD+rBN6h5S52OF8aHqA8wFHS/+u
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk31fkfgC8XNxRCFGWyZZtDQsL9fF6fkLWRUFK2yKSyNNZMWcqSYohU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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk41Hsfh4cZpggllRKnNCXLQ8LBMP/vP8kgaeEklOgILVqEji2FEQ7T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          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHwpbqybJ2VYtbbBeSP86J4G+I3Rzf
J8wG5z+TTXq34S8znK8v5x1uws0E5384coWhXokBzn+7d3r+boU/+2F8uaJf
E62cf8D5t3gszj8U+gLn873MldZ/837/3vqaLP3vrHobd4Qwyjm8gPMvrXpk
uevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs6+izsp4pBgr/XnOeav
rK/dg/NV/u6bKXXsOZzf4X4+i+vBazj/9cT71r9+vofzbZ2aHyaVf7B/6nyy
IewVv0PrbrGlJz4i+GdNVmXo5XyE80XX2epMeYbgL12Qsjn+9ic433Ryt5X2
hc9wvgBrjrXe469w/qsyHxvDb9/h/KpbMzpLr/6G8w9os947wczgAOOfcp67
jV+YCc4/JP17y9d/zHB+acPrpe4ibHD+rBN6h5S52OF8aHqA8wFHS/+u
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJwtlvk31fkfgC8XNxRCFGWyZZtDQsL9fF6fkLWRUFK2yKSyNNZMWcqSYohU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          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJwtlmk41Hsfh4cZpggllRKnNCXLQ8LBMP/vP8kgaeEklOgILVqEji2FEQ7T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          "]]}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      Frame->True,
      GridLines->{{2, 0, 1.5724976717447616`}, None},
      PlotRange->{{-3, 3}, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {967.5, -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}]}, {}},
  ContentSelectable->True,
  ImageSize->{621., Automatic},
  PlotRangePadding->{6, 5}]], "Print",
 CellChangeTimes->{
  3.46070451917115*^9, {3.4607046303750753`*^9, 3.460704648904955*^9}, {
   3.4607047577968493`*^9, 3.46070477859319*^9}, 3.460704954247167*^9, 
   3.4607050368531113`*^9, {3.460705128436154*^9, 3.460705175118433*^9}, 
   3.460705215569192*^9, {3.460705274472828*^9, 3.460705286163951*^9}, {
   3.460705328448756*^9, 3.460705339224861*^9}, 3.460705436687511*^9, {
   3.460712600376568*^9, 3.4607126147235003`*^9}, 3.460713047876918*^9, {
   3.460713282521329*^9, 3.460713294551167*^9}, {3.460713834968994*^9, 
   3.460713860036693*^9}, 3.460713902558764*^9, {3.460713957325048*^9, 
   3.460713995695146*^9}, 3.460714037951282*^9, 3.460714131146854*^9, {
   3.460714181968012*^9, 3.460714208204916*^9}, 3.460714288368878*^9, 
   3.460714320506762*^9, 3.460715344636594*^9, 3.4607156113978767`*^9, 
   3.460715886246475*^9, 3.460715921874712*^9, 3.460716010317369*^9, {
   3.460716602712977*^9, 3.460716612332562*^9}, 3.4607166808613367`*^9, 
   3.460716728278655*^9, 3.460717947774094*^9, 3.4607181538085213`*^9, 
   3.460864852779917*^9, 3.4608649440956497`*^9, {3.460865054515229*^9, 
   3.4608650996454573`*^9}, 3.460865131062428*^9, 3.4608652063886013`*^9, 
   3.4608652375708027`*^9, {3.460865304978962*^9, 3.46086534669381*^9}, {
   3.460865383703322*^9, 3.4608653942322607`*^9}, 3.460865443237199*^9, 
   3.460865487147558*^9, 3.460865524133155*^9, 3.460865599301724*^9, 
   3.460865631528137*^9, {3.460865678064745*^9, 3.4608657627915583`*^9}, {
   3.460865888638105*^9, 3.460865895896729*^9}, 3.460865937576189*^9, {
   3.460865987678075*^9, 3.460866000022244*^9}, 3.460866039071653*^9, 
   3.460866078288553*^9, 3.4608661727274227`*^9, {3.46086620527229*^9, 
   3.4608662286114283`*^9}, {3.460866591783491*^9, 3.460866605728109*^9}, {
   3.460884097643346*^9, 3.460884163155167*^9}, 3.460884256662903*^9, {
   3.460884582123115*^9, 3.4608846116249857`*^9}, 3.4608846679279823`*^9, {
   3.4608848296710052`*^9, 3.460884896153452*^9}, {3.460888708395012*^9, 
   3.460888733025832*^9}, 3.460888856973765*^9, 3.460889348450428*^9, 
   3.460889410038197*^9, 3.4608899257122517`*^9, 3.460890038266615*^9, {
   3.460890116133047*^9, 3.460890159630308*^9}, 3.460890191415696*^9, {
   3.460890270481584*^9, 3.460890308143527*^9}, {3.460890431748641*^9, 
   3.46089045135244*^9}, {3.460890488240271*^9, 3.460890504344252*^9}, {
   3.460890552097582*^9, 3.460890588805337*^9}, {3.460891455180016*^9, 
   3.4608914721018267`*^9}, {3.460891583880372*^9, 3.4608916217756577`*^9}}],

Cell[BoxData[
 RowBox[{"-", "0.47921397277386335`"}]], "Output",
 CellChangeTimes->{
  3.4606944285880413`*^9, 3.460694710821148*^9, 3.460694813752266*^9, 
   3.4606948686565523`*^9, 3.460694908824984*^9, 3.460694943743373*^9, {
   3.4606955286647463`*^9, 3.460695539377111*^9}, {3.4606959743468847`*^9, 
   3.460696046934908*^9}, 3.460696164888945*^9, {3.46069624289347*^9, 
   3.460696254104011*^9}, 3.46069664856536*^9, 3.4606978773565187`*^9, 
   3.460698003355398*^9, 3.460698428704109*^9, 3.460699017700994*^9, 
   3.460699198261404*^9, {3.4606992404204206`*^9, 3.460699250004673*^9}, {
   3.460699420002788*^9, 3.460699448542591*^9}, {3.460699551492279*^9, 
   3.4606995760372458`*^9}, 3.460699628821332*^9, {3.4606997766246853`*^9, 
   3.46069979233737*^9}, 3.460699846509027*^9, 3.460699991426691*^9, 
   3.460700120962723*^9, 3.460700150978692*^9, 3.460700290202798*^9, 
   3.460700350015143*^9, 3.460700640543497*^9, 3.46070113823307*^9, 
   3.460701477583243*^9, 3.460701669557947*^9, 3.4607028883471003`*^9, 
   3.460703284824523*^9, 3.460703470343832*^9, {3.460703818260503*^9, 
   3.460703838762457*^9}, {3.4607039225852947`*^9, 3.460703937086619*^9}, 
   3.460704031751749*^9, 3.460704109348311*^9, 3.460704324286234*^9, {
   3.460704404777562*^9, 3.460704452506097*^9}, {3.460704497969942*^9, 
   3.460704519204072*^9}, {3.460704630407476*^9, 3.460704648938583*^9}, {
   3.460704757832714*^9, 3.4607047786437263`*^9}, 3.4607049542830973`*^9, 
   3.460705036891027*^9, {3.460705128472733*^9, 3.460705175152998*^9}, 
   3.4607052156065817`*^9, {3.460705274511199*^9, 3.460705286201747*^9}, {
   3.460705328482711*^9, 3.460705339258251*^9}, 3.4607054367225018`*^9, {
   3.460712600408203*^9, 3.4607126147571*^9}, 3.460713047908724*^9, {
   3.460713282554874*^9, 3.4607132945848017`*^9}, {3.460713835058514*^9, 
   3.4607138601197033`*^9}, 3.4607139026455917`*^9, {3.460713957091056*^9, 
   3.460713995382338*^9}, 3.460714037957024*^9, 3.460714131191308*^9, {
   3.460714181974341*^9, 3.4607142082382517`*^9}, 3.4607142884014807`*^9, 
   3.4607143205417843`*^9, 3.4607153449128113`*^9, 3.460715611660941*^9, 
   3.46071588650872*^9, 3.4607159221362133`*^9, 3.460716010350465*^9, {
   3.460716602744968*^9, 3.460716612368623*^9}, 3.4607166808947973`*^9, 
   3.460716728310671*^9, 3.4607179478075523`*^9, 3.460718153890011*^9, 
   3.460864853569865*^9, 3.460864944632353*^9, {3.4608650549224043`*^9, 
   3.4608651000694838`*^9}, 3.460865131533939*^9, 3.460865206868553*^9, 
   3.460865237994265*^9, {3.460865305414671*^9, 3.460865347127034*^9}, {
   3.4608653841410217`*^9, 3.460865394663265*^9}, 3.4608654436569023`*^9, 
   3.460865487559341*^9, 3.4608655245522413`*^9, 3.460865599731702*^9, 
   3.46086563194384*^9, {3.460865678567177*^9, 3.460865763215781*^9}, {
   3.4608658890662947`*^9, 3.460865896275236*^9}, 3.460865937973333*^9, {
   3.460865988090621*^9, 3.460866000404463*^9}, 3.460866039460979*^9, 
   3.460866078684072*^9, 3.460866173126914*^9, {3.460866205645241*^9, 
   3.460866228977401*^9}, {3.460866592131584*^9, 3.460866606116922*^9}, {
   3.460884097973241*^9, 3.4608841635609827`*^9}, 3.4608842571343107`*^9, {
   3.460884582522368*^9, 3.4608846120265217`*^9}, 3.4608846683227043`*^9, {
   3.460884830077977*^9, 3.46088489660178*^9}, {3.460888708916758*^9, 
   3.460888733443715*^9}, 3.460888857374319*^9, 3.460889348847591*^9, 
   3.46088941044028*^9, 3.460889926088251*^9, 3.460890038615594*^9, {
   3.4608901161774*^9, 3.460890159674868*^9}, 3.460890191459124*^9, {
   3.4608902705254993`*^9, 3.460890308461899*^9}, {3.460890431792459*^9, 
   3.460890451396481*^9}, {3.460890488285193*^9, 3.460890504385693*^9}, {
   3.460890552139698*^9, 3.4608905888481092`*^9}, {3.460891455286799*^9, 
   3.460891472150818*^9}, {3.460891584175662*^9, 3.460891621817917*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0, 0, 1], PointSize[0.03], Thickness[0.03], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJwBsQRO+yFib1JlAgAAAEoAAAACAAAAkOic4VOK6T+xV1IrpymVPtrimwEJ
beo/PMeO91dhaT4HunItLU/rPx/ei2s5HkA+2hno9sUw7D93m0i0PasVPlWn
qsjYEe0/qhYro2jR7j131onoavLtP76mljQCLMc91jCNeYHS7j87Oas2vmmi
PQq37H0hsu8/09AJrmjpfj2CZnbsp0jwP7k70UBDFN5ByPRPqAi48D9gvY8Q
6iK8QRgJyEc1J/E/2I297jXEm0F+ACkTMJbxPxbtI7+o5XxBm9WBRvsE8j8x
tdbBK7RfQVLdWxKZc/I/c9O6AelTQkFat2ecC+LyPwlbe5HeUiZB5B0iAFVQ
8z/bmod23KIMQRsycU93vvM/l4Qom1xW80DK2TqTdCz0PwBFmZgLfdtArLT0
y06a9D85gLOJFY/EQEcpLvIHCPU/w69gLAgtsEC5/hT3oXX1P+PloGGsxZpA
lvH0xB7j9T9JzvwY40uHQPyqsj+AUPY/nUsmwulPdUCuekJFyL32PwE/zddQ
fmRAYy4brvgq9z+BE/BKrbVUQLpcpU0TmPc/H/3khYn9RUDyc6fyGQX4P8Ch
8iMciDhAktmuZw5y+D87HYBaT78sQIhjdnPy3vg/qN8Nf/SwIUCDcErZx0v5
PyDzV3Ud3hZAwOFqWZC4+T8cO41UFwoPQEo2a7FNJfo/V1YN2HseBkAgBZGc
AZL6P3z9BFedjABA0BEx1K3++j/0onA7rf/5Pz41CxBUa/s/a2roBmNw9T8x
U6UG9tf7P3G8Xt4Mj/I/pZOlbZVE/D8RQ6u1VN3wP20WLPozsfw/9p7Wj0YW
8D/hVixh0x39P9aScOm2G/A/1HTGV3WK/T8WJtZyf+7wP0KYoJMb9/0/02v8
wriu8j/ypEDLx2P+P5MbwcsGpPU/yHNmtnvQ/j8KAOW8B1H6P1PIZg45Pf8/
gmcd47TMAECQOYeOAar/PxBF5hU4hQZARaMtemsLAECrBtG2P7MPQEBoEYDd
QQBAdrMemAduF0APG5W6V3gAQCMv7vz9LyJArCYWDduuAECeAzG3qqgtQNc9
21xo5QBAnO+FDpNnOUCzl0eRABwBQK8QIXX/3EZAi38PlKRSAUDcXXxjTp9V
QD5cblFViQFAvgINQfJ9ZUCsVV64E8ABQLopWLPfdHZAZsDRuuD2AUDzPVze
yKuIQLJ67k29LQJA3pjYGfiAnEAlaEtqqmQCQN3UDxMEUrFA/DswDKmbAkBx
+QVyqCXGQBnG1zO60gJA61KYnaDN3UBa+bTl3gkDQLxyGCQgHPVAYOa6KhhB
A0AyDfADX30PQTzqpxBneANAw5YibkC9KEHKVFSqzK8DQIwL2HOhekRBgNAE
EErnA0DvE5tDTN5hQaTawF/gHgRAznNwZFBwgEHIoa29kFYEQN/ShPqY559B
SKdtVFyOBEC4dQAq0lXAQdSIhVVExgRAmb8kNZCo4UFqX8b5Sf4EQCI6aBUG
KQRCNiu+gW42BUCAW2LEy1EoQpXOLjazbgVA/rhcZj0DT0KIJoxoGacFQMee
6P786XRCU9yBc6LfBUBgPRrWh9mdQuWagbtPGAZAXkm8xuSNxkLt4y1O
           
           "]]}}, {}}, {{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.01], Thickness[0.01], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJw1lGsw3FcYxvfqUhW3VhkhZRod6zJEsiHs/z0ydJW4dFlGGGmzLULpJusW
RhGTZklqxL3hQ4TNokhcim6JnVZZYkLEJUi2qFvUprFui0V19u/DmTPvzJlz
zvs+z+8xv/wd6xsSgUDwOlz/73lL5TMBOW/AimdhyS2od52cLSNqxi5DKrcy
n6n90lVddM3W1u8f8K/5Y/TDBBJj0nhp80/7FRCkPpShLhqDLayVvNSTwQBr
Ym7al8VIGsteipbL4GyExkHG4yTGmP2P1zOH34KhRDf3B2U54722lTTzpn+B
Wc09caJXzLgRkbgi9HwHpq3ty/TLswzJul+1Rvs7qE4YlC7qkzEjTQnzzKer
MBheyj7XZYF9T7AysC9ehZIu3W+PJ7phZaOZn+1S5LCQdCfx9Fg4xnodqv8T
Tw6ufGVyyvB17GJbZLnWrBykB1d0PLMKsTlTCwLbfw0wjouDo6wBMzl11S/p
yRr0hQhk7uY9WP/EuYJ4m3Xo2Ip9xtSXYnUt6099762DT+5HkSWRaxjTyk6u
rrEB/Z/UeXH61eHX/Q+2KhI2oPKq9pxVmwkUr653m/29ATLqgcHkIztQ1jZB
hv8mcG+l72KWCBpSzntIOjfBabC3w8PKHzh2Jg0K2hZM0VJDM38PB1GYwMeg
dAtcaBdux4/HgJwnlBtTFaBGsnAbVCRB/kRD5LFrCtgJKTTYeZAFfE4iTy5V
QJBTH8u7PBeyuF4Tvd7bsJBO6HRqKQbxTHRIXvs21A3llXWo3Qcvekyjz8kd
cOZ4igf4AviYerecmL8DaTR+9vOcn2FIz2Gkfn8H7K+ETpl1PwbsjJZuYMwu
vPK1rrkR1wwOAQK1zfFdINq0BhRzfwFBgSC2yF0Ji6eknXY3WyHW0GbHsVEJ
b/B6Jsjmqxeme6C0Vp0fie8JTsjZgxf4fedL7xeYbO2BJf6evAo97eXsQyr+
HwkvojV1aP9QL9V/AyQRx5wZB1CP95PnfCuXWHsAMrxfj0rblBgtArqAzwNF
6WW8diMgBT4vHZMiUXDyYU1UzbPO0lB7qoGA3PF5jzOmwqLmCWgG16O5hHmX
cJyI6Lhet9N1CqtYRBSH64mFxX3BziaieVzvOnZ4u4GYiCpwP0SIn4umN4lo
APdLU8pbn05bEvLG/XQyyju69msSasb9pnSxf7+mjISO/GjcM+4oGiah07hf
L263zEs1yWgK9/OXCyKakRsZncX97ros1I1MJqMjHvoDA2sHHpFRMc5LxhBF
12uRjPpwnqomxZemzSjoiDdJRX1nXhAFHfHoKYwNDMulIM5DFa8j/Jts9x4K
MhpV8Rx9qWf7830KOuKdbv0kM45ORZrBqjwoemZHb46josE0VV7wLe9EGQup
qLFblScBrzJ5D/6iopZwVd7M38v8zc9IDVnjefQfxwIt+A==
           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{2}, {1}},
      PlotRange->{{-3, 3}, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {193.5, -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{{}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.03], Thickness[0.03], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJw1lGsw3FcYxvfqUhW3VhkhZRod6zJEsiHs/z0ydJW4dFlGGGmzLULpJusW
RhGTZklqxL3hQ4TNokhcim6JnVZZYkLEJUi2qFvUprFui0V19u/DmTPvzJlz
zvs+z+8xv/wd6xsSgUDwOlz/73lL5TMBOW/AimdhyS2od52cLSNqxi5DKrcy
n6n90lVddM3W1u8f8K/5Y/TDBBJj0nhp80/7FRCkPpShLhqDLayVvNSTwQBr
Ym7al8VIGsteipbL4GyExkHG4yTGmP2P1zOH34KhRDf3B2U54722lTTzpn+B
Wc09caJXzLgRkbgi9HwHpq3ty/TLswzJul+1Rvs7qE4YlC7qkzEjTQnzzKer
MBheyj7XZYF9T7AysC9ehZIu3W+PJ7phZaOZn+1S5LCQdCfx9Fg4xnodqv8T
Tw6ufGVyyvB17GJbZLnWrBykB1d0PLMKsTlTCwLbfw0wjouDo6wBMzl11S/p
yRr0hQhk7uY9WP/EuYJ4m3Xo2Ip9xtSXYnUt6099762DT+5HkSWRaxjTyk6u
rrEB/Z/UeXH61eHX/Q+2KhI2oPKq9pxVmwkUr653m/29ATLqgcHkIztQ1jZB
hv8mcG+l72KWCBpSzntIOjfBabC3w8PKHzh2Jg0K2hZM0VJDM38PB1GYwMeg
dAtcaBdux4/HgJwnlBtTFaBGsnAbVCRB/kRD5LFrCtgJKTTYeZAFfE4iTy5V
QJBTH8u7PBeyuF4Tvd7bsJBO6HRqKQbxTHRIXvs21A3llXWo3Qcvekyjz8kd
cOZ4igf4AviYerecmL8DaTR+9vOcn2FIz2Gkfn8H7K+ETpl1PwbsjJZuYMwu
vPK1rrkR1wwOAQK1zfFdINq0BhRzfwFBgSC2yF0Ji6eknXY3WyHW0GbHsVEJ
b/B6Jsjmqxeme6C0Vp0fie8JTsjZgxf4fedL7xeYbO2BJf6evAo97eXsQyr+
HwkvojV1aP9QL9V/AyQRx5wZB1CP95PnfCuXWHsAMrxfj0rblBgtArqAzwNF
6WW8diMgBT4vHZMiUXDyYU1UzbPO0lB7qoGA3PF5jzOmwqLmCWgG16O5hHmX
cJyI6Lhet9N1CqtYRBSH64mFxX3BziaieVzvOnZ4u4GYiCpwP0SIn4umN4lo
APdLU8pbn05bEvLG/XQyyju69msSasb9pnSxf7+mjISO/GjcM+4oGiah07hf
L263zEs1yWgK9/OXCyKakRsZncX97ros1I1MJqMjHvoDA2sHHpFRMc5LxhBF
12uRjPpwnqomxZemzSjoiDdJRX1nXhAFHfHoKYwNDMulIM5DFa8j/Jts9x4K
MhpV8Rx9qWf7830KOuKdbv0kM45ORZrBqjwoemZHb46josE0VV7wLe9EGQup
qLFblScBrzJ5D/6iopZwVd7M38v8zc9IDVnjefQfxwIt+A==
           "]]}}, {}}, {{}, 
        {RGBColor[1, 0, 0], PointSize[0.02], Thickness[0.02], Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJxF0ltM0nEcBfA/5jVKJZuTkS7btGniMCebmYqmaTjD5GIZy9IChsNKvGWr
oNZSS4fXTH3IklFMaV6WRsOxVkjamhlpapqalplZ/iO8RpeHft+Hs7PPzuvx
Tj+dfMoGwzDm3/xrxWzDJLvkc2QxMf3wE1Jp2MhUPcFJMofsoM2mUllfYCfP
Wp7R5pG5KrXxLekrcv5g8awYBw/SSs/JBxaQN3bOX/Bu+4Z8WZA3r4r/Hjm9
77mMN+fCMJpZ9xy7wB5OxriQnYvIFzE/N1oNuP6NfP+aLY6cPHZ0yy0pOLVT
2ECcAk977sC4ST+QKbvPsvK7wb3DeypzAszIzR3mvoN14Di/QNzB8SfyI+vW
pcZccM2i+anXB/C6ui1SlmRB1hRGxxp14IxAimbZfwlZy1cmutWCcakKJ9st
I1cMa4TO2eCijDwpPg6+coY53JOwgqyfFB9RdIGZ9MzWRJ9V5O125Q2ECnA/
KcjUYgVHhBBdOZlryEFspb1lCKysVEqqY9aRJe4Bq8Gt4ElewInXnr+QTTmG
lNwScHTt7UrKEhhvYvT1ZFjhD1LBw/P9YLZR4Bwa/htZEXqtjKAGx96lFmYS
McZ/M0Qk2VgU2IVSrU0pADf7um8e1YCHwkf5ohlw+824cmwbAfn6JZeqpmRw
BD/rELcY3Mw91uWmBwv0r7QTFnBb4UKijmqD7CNKEKtPgtfDaJvu14PJhqFg
7QA4daVjZtxpA/Lxj1p/jyjw3jmVq7AA3MvhqF88AMv6bV2Zn8BNI/q0CS9b
ZGNji07BA8erJBx+GdhUdJUbYwCL0wwrB6xg+q5ueRbdDrn6ZSC9PQtc5HtD
RFaB2e/k0jvvwTN18scsD3vkP8lkOQo=
           "]]}}, {}}, {{}, 
        {RGBColor[1, 1, 0], PointSize[0.015], Thickness[0.015], 
         Dashing[{}], {}, 
         {Opacity[1], PointBox[CompressedData["
1:eJwBsQRO+yFib1JlAgAAAEoAAAACAAAAkOic4VOK6T9s+fq7UfrlPNrimwEJ
beo/2ntX0l5TEj0HunItLU/rP7EN67E/2zw92hno9sUw7D+eDUxI4nZlPVWn
qsjYEe0/4g5pZC4vjj131onoavLtP2qjKjN4ErQ91jCNeYHS7j9+n0ttgULZ
PQq37H0hsu8//ytK8L4X/j2CZnbsp0jwP1rBqwsM+iA+yPRPqAi48D8GokVE
IiZCPhgJyEc1J/E/KRRN8AhkYj5+ACkTMJbxPwfX8M3Sq4E+m9WBRvsE8j9z
17MmVhugPlLdWxKZc/I/ItZduKPcuz5at2ecC+LyP+dqr2nm39Y+5B0iAFVQ
8z+PzUNFC9XxPhsycU93vvM/l1YPF0FoCj/K2TqTdCz0P/vbPailkyI/rLT0
y06a9D9QPIKoktY4P0cpLvIHCPU/Q7djMH2RTz+5/hT3oXX1Pxq46MDiEmM/
lvH0xB7j9T+b/LcqZOt1P/yqsj+AUPY/A9BoUdf1hz+uekJFyL32P+NXiW/l
6pg/Yy4brvgq9z+xBqNcSaioP7pcpU0TmPc/hV8X2Kk4tz/yc6fyGQX4P9MR
bSrX0MQ/ktmuZw5y+D8MtVShZcPRP4hjdnPy3vg/r0Oe8Ubd3D+DcErZx0v5
PxvgVaecVOY/wOFqWZC4+T+bXmzhl3PwP0o2a7FNJfo/CvrGNhMW9z8gBZGc
AZL6P7F3Imgp2/4/0BEx1K3++j+ehB79JKQDQD41CxBUa/s/9d33YIzRB0Ax
U6UG9tf7P4Jga5ragwtApZOlbZVE/D8c0HrgekcOQG0WLPozsfw/ShuTECW+
D0DhVixh0x39P0Z40VBtsw9A1HTGV3WK/T9TlJiqxygOQEKYoJMb9/0/c/uK
iDVVC0DypEDLx2P+PyyvRjy2mAdAyHNmtnvQ/j/Fumc+bWcDQFPIZg45Pf8/
8Nh7dXFl/j+QOYeOAar/PyFcHyjCrPY/RaMtemsLAEB8ToMVzhvwP0BoEYDd
QQBApTQtF3PL5T8PG5W6V3gAQJS0DNGpE9w/rCYWDduuAEBJbC6OojfRP9c9
21xo5QBAYUfLeb0ZxD+zl0eRABwBQLohef2zVbY/i38PlKRSAUABvzT63J2n
Pz5cblFViQFAEGGJYYXClz+sVV64E8ABQF6CzDdDvYY/ZsDRuuD2AUCIDDKT
vbJ0P7J67k29LQJA/SUvRj/qYT8laEtqqmQCQNzNsDR+e00//DswDKmbAkDD
HKW7mA43PxnG1zO60gJAYamtakgiIT9a+bTl3gkDQIZAURqfMAg/YOa6KhhB
A0AmBNnBXTfwPjzqpxBneANA7QfJbCCk1D7KVFSqzK8DQA7k50ph77g+gNAE
EErnA0Awq97dB5ScPqTawF/gHgRAoAtGcUgQfz7Ioa29kFYEQDJoas9fAWA+
SKdtVFyOBEDZDAS+qUI/PtSIhVVExgRAeMIEhf7qHD5qX8b5Sf4EQNH34qZQ
VPk9Niu+gW42BUCofh5TVP/UPZXOLjazbgVAZKplTTp3sD2IJoxoGacFQN2/
RLWcaog9U9yBc6LfBUBMGVpLcxthPeWagbtPGAZATm5YmAmkNj2oOylu
           
           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      GridLines->{{2}, None},
      PlotRange->{{-3, 3}, {0, 7.978845608028653}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {580.5, -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHwpbqybJ2VYtbbBeSP86J4G+I3Rzf
J8wG5z+TTXq34S8znK8v5x1uws0E5384coWhXokBzn+7d3r+boU/+2F8uaJf
E62cf8D5t3gszj8U+gLn873MldZ/837/3vqaLP3vrHobd4Qwyjm8gPMvrXpk
uevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs6+izsp4pBgr/XnOeav
rK/dg/NV/u6bKXXsOZzf4X4+i+vBazj/9cT71r9+vofzbZ2aHyaVf7B/6nyy
IewVv0PrbrGlJz4i+GdNVmXo5XyE80XX2epMeYbgL12Qsjn+9ic433Ryt5X2
hc9wvgBrjrXe469w/qsyHxvDb9/h/KpbMzpLr/6G8w9os947wczgAOOfcp67
jV+YCc4/JP17y9d/zHB+acPrpe4ibHD+rBN6h5S52OF8aHqA8wFHS/+u
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJxF1Ik3lHscBvAxY6xFV0qKyFopUzFhzPt+fyE0IiRJWVIdS1w7nRTX2mYt
V0jRolLKWrbR2JdSKNkqKkTD2MY+lnvvOZ3bc85znvP5B54tTp6WZ4gEAuH4
v/1vWWt8elZWBCsIv2JPS33uXfXbi6eqgvsiflu7SEKuXvi3c+0KHGLXCvzv
H7JOo7lLpIrrMcp9cVJuApTNJkc1RYkVbzX83pjeq1g1XtNGCFEgVFy0qX/z
qjdFglN+07NMfpH1KbZ2X/xK9IbNPgsJNP05llUeNXA1pUS2e5V28zeJKVbe
mZDyavMRBbGfHpsoI2Msi7Fna/XS0lTziq34NqMhFmvf/UluxG2190++65R+
7mWZducyfJViKG39HD2wamH122TY7pTo3JOxbUB8ID2B9chLK8huqYjKZoie
Neh4B23NX08oWHlrc9O02LrtPcBzDZKWH0qlKS29StlYNwhi84VSJINr9HJx
UmxS0xDYK4gYnMQr6dYKRmESH35C7LDtONNiij6meS0gtosNzXrtNTZmKthl
o2Y3ka/DkEfTkltstsa22K51iPoxAvIpwdWyzEis1P3oYSKHA2bfd+UzGQWY
Zcgto2DuKJzyoNgXD/Ziwwm9ugvzY1Bud+uWUKIQjumFf3MKHAd14XbaUw8K
Hlm2PrNhYhxSNTH7x/2W+FvNJy7q7hPgeP2HzMPj/vi659iOxB8TYLnANrxb
kITbqbaOzTtOgvb7rnal3Jd4ZsbpAodPkxAalFvXYvER50jPBdQe4cKzRqK2
WvskTr1xjabWwgX5HnXGpIk4ZOdULwxbTcGyCkeL3bEdFJp4pdldU+Aun2fA
77YfUoY0gjzsp4H5Ud59ts4B1pDdddX7poHMzDDq5/hD1JYHvFHnGWCM3lcJ
V4mGJexzWc7IDMRPH19Z9y4D/GwlL3h5z8LsDmXMOisf2AEH6btnZsGJXyWG
YlgNJ0gztdI+c+BTySo8WtMK7+LSDxFH5yAim18Wq+gBJHOgi+06D188Q4zL
eUOQ/3jS6cPAPLwnjhzYK8YFJWraSNnJBQjeub5JhcGDpMr9AQ++LIDKz9wJ
BxsiEjIbW4k+xgPX8UvRraqC6Hx38hX/jzzw5dU/tfQSRZtEBsVLji+ClL4U
t/SFGGLqUJMWvy1C8dA5Mo0tjk64hssglyU4WhDycmOTGFpKbr0XProETW38
sSeSRdGdBrlt9X7LkJ73ov3qtADC5zxyRHjLsDXYWfY5kw/1qjKpZqErcGxU
19/fZx4q1Mg9DSQC8uZmyVO441CpvqEkbz8BNQZFEGjbB6Bqt1pi6iUC6rxx
w5CX2gk1mrhneCMBSTo+pnXffQ21WhYMd1E+1GTS6RvWXgp1tNPKR0z5UBZD
8rK4ehY0YIEEPI4Pfd3606B4+W9oRFc/qbTyoYkE+UTjvlB4rX/7pfhaIjIx
fqiRtf4sNC67BESbE9GF0Kthj6KsoKFEc69wLBF9ia9PktHFoN6PMBP5hojm
RFyiyHGKUEdpekEUJqEu4s0Y32QhqGXf9A8xJKFBzkTXhTUcvCbzFHUxnIR2
Hd5zc6NiC17tSJk+V0lCLPOK8uL2XLxqE69wepmEkq9Uzg6FxeM2W6W56fv4
0Z/aps46LW74mKbWbkYEP3KKLOxMpBvgUfuOeE7V8SO1Zj65i6dlcBkz32d3
hMmo2feRnl/4JJZvmzBsfJCMFGjWGSTvOszYOWcbN5aMFA8YEKaMU7Ae37fO
t1vJ6JTkPUnueTfM/6/hTCNJAcRwNZnuq9PBgi0Xs19ZCKBjGheCmotEsctK
qwupcQJIM/+5hCPxMz1hRrYsu0kA1fgIL8mkPKGnNqhXKYoIol0zk7buzED6
/VRoTDUSRMo+B4LfD+rTs93NW/6IFESOh2qpww7i9Jf4yY7LVYIouMinw4ve
ofvrn5HuDrGOKbUM3X8Ary2smA==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJxF1Ik71HkcB/AxY0xG5eqS3EloWWUymPl9vjmW1DqibLkpRo106lwqCRHN
EppKx6ISOVOZatzGkSubx5FjRXIMNUzjGLO7z9OzvZ/n/byf1z/w1vIP3XUA
j8PhPP7tf8tVONYrkZDKcN/jbcF+erTihxcCKsIHL/8w9bmSRq3sD+d7Ffkk
KMv872E1f36+mFD2k0cTP9zEWsZYfYe7qRy+bPtxnU3tbZlLp6racRHauDJO
8O86y63ilSZep4ZyNBe4sVHFMgnNsWvUj82xLKxFXJ3cJbP6mWVqXUupzQNK
01y5gBvmX4bmtJd/DlE1Hp/kuniaUtM2FOoVvHCTUkcj3GmfGf5KteeGbdl/
m5f29HHbnGnLaB+yjds/TliBWws3x86MLXISbb6nPyQ/dJfFLa4lp1NJnZRR
B7lDNh1NED1htSHkOosquG02avm+FwobTl/MlbywWC9+c3NtzSeo3uoBVSmZ
tNfyhISUxhHQoXHHHmZ10fZo211SevcZsresXuqZvpw+aRoXltA5CjH2/bsY
3ogeY9d8kNw/Bg3L5Tuebz9C19qn7HNleBxKjzqw2g3S6aVMd1f8xATof3r7
bUBSR98VccsuXMCHidHAuMSuafoYq89ybnYS+LW69xW1NTC6VeSA/6kpWHZh
484kJ2ssirMqk/dlCrpxSvGrLgZib02zGUbML0CNOn5Y/CAGW/mUvil5+Ask
bS7du23PY8xLr3Vy1vcrPOE6aB4+y8My7+0v8un+Cl4jI/4WZsPYhIoorHq3
AJJt84ebp/BASYqzMGwRAGlGu0TaXR1y8irnxtymgVPwER+0QAXtxvnSnM5p
eFvlwDBXd4WbI1vOhXjPgK6qosEzo0OgQGRaGg3OQFtSxXqX6YtwRStjnh8k
BJuSEPJB2RQQ03s4eeNCOHOAHGqv9RhO7Ftx/sjRb6Cvwawxv1cKo2E7aSbC
byDyPH1LTKkHT4KwWuWYCPZ3sz7cXtEBTYl3nfB8ETi8q3qzVmEQ0LrtnaPB
s3BNGnnLx05A4aOv/u+GZsHPZ8hAdHIG1lNuj3P85kCn9FzZDSSGlHLbsIwP
c9DtU5kgKcSjJY6Tkvi98/C8q0jDjSmDznalxZ78ax7K+/PTDlBlkSr5k/xL
jwVYaplR/ymTjF6ZU1IWBhbAlxjg16VGRp7BkesQQwztl4IbK16TkDit9UEk
XwypghLRE2lplM7T0K89sQibGWf1J50kgIlC8sjzi+D8syN3tkQIfXqvKI4X
JbDyfXtXMIsPZYbEXh4BhxTb+sOFyoNQbrTmZYEtDhmujJsnuL6HChPDZHY0
DhmkRis27eBBlSkWGlmHQ7rexT31qS+g2szFgSknhdhezB45vYdQY7Ffd/ev
Uqgzdn481zYZePRTOCxRCtGepSXbXLoAdehq94ZWKdT3woq0BB8M9dZ3SuSV
8ejydtcH3XdcoG6RERbvjEc7Zu2Hz0xSgffSdKtsAh6pClJvR7A0ofYEThjV
gEeJS74e6X0iDTXGjc/wsgTUkkS2ztg6glWPpp6M+IWAsGU0x9Z79VhVZgBl
IZKADJU2Iwh/glX6Gs+cLiegQGPyYlTWVaxCdb54ZpGA5jiO74jbGNhvG1UE
d7dJozihqYq6rhU2aWpm4nBZGt2Bco9Aigp2Zdvu0OkaadSjeI26z2qKvs7x
eG66LBH5ehWGnz9TSS/cxxqz30lERUN6dtGPbtDtg/L0BQlEVFB0uf2EVyC9
9/jboDutROTVk+uccZRCP3lhLNNuhQza48tYbbuaQA/ftZDzxkUG1XZkMz0H
22gx65cVUxJlkEK0ZufTuPs0llCNk9Mog3g2Y7ZC9mEam2dUoUMmoaF8HLNN
3pz2Jxvq2HYktOjrJim2IdBymM4tilEk5JolVclobbAswfw6YipIKOtjslNU
1x+W3/8Z9VWrX2ctulv+A4ZNqC4=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHwpbqybJ2VYtbbBeSP86J4G+I3Rzf
J8wG5z+TTXq34S8znK8v5x1uws0E5384coWhXokBzn+7d3r+boU/+2F8uaJf
E62cf8D5t3gszj8U+gLn873MldZ/837/3vqaLP3vrHobd4Qwyjm8gPMvrXpk
uevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs6+izsp4pBgr/XnOeav
rK/dg/NV/u6bKXXsOZzf4X4+i+vBazj/9cT71r9+vofzbZ2aHyaVf7B/6nyy
IewVv0PrbrGlJz4i+GdNVmXo5XyE80XX2epMeYbgL12Qsjn+9ic433Ryt5X2
hc9wvgBrjrXe469w/qsyHxvDb9/h/KpbMzpLr/6G8w9os947wczgAOOfcp67
jV+YCc4/JP17y9d/zHB+acPrpe4ibHD+rBN6h5S52OF8aHqA8wFHS/+u
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJxF1Ik3lHscBvAxY6xFV0qKyFopUzFhzPt+fyE0IiRJWVIdS1w7nRTX2mYt
V0jRolLKWrbR2JdSKNkqKkTD2MY+lnvvOZ3bc85znvP5B54tTp6WZ4gEAuH4
v/1vWWt8elZWBCsIv2JPS33uXfXbi6eqgvsiflu7SEKuXvi3c+0KHGLXCvzv
H7JOo7lLpIrrMcp9cVJuApTNJkc1RYkVbzX83pjeq1g1XtNGCFEgVFy0qX/z
qjdFglN+07NMfpH1KbZ2X/xK9IbNPgsJNP05llUeNXA1pUS2e5V28zeJKVbe
mZDyavMRBbGfHpsoI2Msi7Fna/XS0lTziq34NqMhFmvf/UluxG2190++65R+
7mWZducyfJViKG39HD2wamH122TY7pTo3JOxbUB8ID2B9chLK8huqYjKZoie
Neh4B23NX08oWHlrc9O02LrtPcBzDZKWH0qlKS29StlYNwhi84VSJINr9HJx
UmxS0xDYK4gYnMQr6dYKRmESH35C7LDtONNiij6meS0gtosNzXrtNTZmKthl
o2Y3ka/DkEfTkltstsa22K51iPoxAvIpwdWyzEis1P3oYSKHA2bfd+UzGQWY
Zcgto2DuKJzyoNgXD/Ziwwm9ugvzY1Bud+uWUKIQjumFf3MKHAd14XbaUw8K
Hlm2PrNhYhxSNTH7x/2W+FvNJy7q7hPgeP2HzMPj/vi659iOxB8TYLnANrxb
kITbqbaOzTtOgvb7rnal3Jd4ZsbpAodPkxAalFvXYvER50jPBdQe4cKzRqK2
WvskTr1xjabWwgX5HnXGpIk4ZOdULwxbTcGyCkeL3bEdFJp4pdldU+Aun2fA
77YfUoY0gjzsp4H5Ud59ts4B1pDdddX7poHMzDDq5/hD1JYHvFHnGWCM3lcJ
V4mGJexzWc7IDMRPH19Z9y4D/GwlL3h5z8LsDmXMOisf2AEH6btnZsGJXyWG
YlgNJ0gztdI+c+BTySo8WtMK7+LSDxFH5yAim18Wq+gBJHOgi+06D188Q4zL
eUOQ/3jS6cPAPLwnjhzYK8YFJWraSNnJBQjeub5JhcGDpMr9AQ++LIDKz9wJ
BxsiEjIbW4k+xgPX8UvRraqC6Hx38hX/jzzw5dU/tfQSRZtEBsVLji+ClL4U
t/SFGGLqUJMWvy1C8dA5Mo0tjk64hssglyU4WhDycmOTGFpKbr0XProETW38
sSeSRdGdBrlt9X7LkJ73ov3qtADC5zxyRHjLsDXYWfY5kw/1qjKpZqErcGxU
19/fZx4q1Mg9DSQC8uZmyVO441CpvqEkbz8BNQZFEGjbB6Bqt1pi6iUC6rxx
w5CX2gk1mrhneCMBSTo+pnXffQ21WhYMd1E+1GTS6RvWXgp1tNPKR0z5UBZD
8rK4ehY0YIEEPI4Pfd3606B4+W9oRFc/qbTyoYkE+UTjvlB4rX/7pfhaIjIx
fqiRtf4sNC67BESbE9GF0Kthj6KsoKFEc69wLBF9ia9PktHFoN6PMBP5hojm
RFyiyHGKUEdpekEUJqEu4s0Y32QhqGXf9A8xJKFBzkTXhTUcvCbzFHUxnIR2
Hd5zc6NiC17tSJk+V0lCLPOK8uL2XLxqE69wepmEkq9Uzg6FxeM2W6W56fv4
0Z/aps46LW74mKbWbkYEP3KKLOxMpBvgUfuOeE7V8SO1Zj65i6dlcBkz32d3
hMmo2feRnl/4JJZvmzBsfJCMFGjWGSTvOszYOWcbN5aMFA8YEKaMU7Ae37fO
t1vJ6JTkPUnueTfM/6/hTCNJAcRwNZnuq9PBgi0Xs19ZCKBjGheCmotEsctK
qwupcQJIM/+5hCPxMz1hRrYsu0kA1fgIL8mkPKGnNqhXKYoIol0zk7buzED6
/VRoTDUSRMo+B4LfD+rTs93NW/6IFESOh2qpww7i9Jf4yY7LVYIouMinw4ve
ofvrn5HuDrGOKbUM3X8Ary2smA==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJxF1Ik71HkcB/AxY0xG5eqS3EloWWUymPl9vjmW1DqibLkpRo106lwqCRHN
EppKx6ISOVOZatzGkSubx5FjRXIMNUzjGLO7z9OzvZ/n/byf1z/w1vIP3XUA
j8PhPP7tf8tVONYrkZDKcN/jbcF+erTihxcCKsIHL/8w9bmSRq3sD+d7Ffkk
KMv872E1f36+mFD2k0cTP9zEWsZYfYe7qRy+bPtxnU3tbZlLp6racRHauDJO
8O86y63ilSZep4ZyNBe4sVHFMgnNsWvUj82xLKxFXJ3cJbP6mWVqXUupzQNK
01y5gBvmX4bmtJd/DlE1Hp/kuniaUtM2FOoVvHCTUkcj3GmfGf5KteeGbdl/
m5f29HHbnGnLaB+yjds/TliBWws3x86MLXISbb6nPyQ/dJfFLa4lp1NJnZRR
B7lDNh1NED1htSHkOosquG02avm+FwobTl/MlbywWC9+c3NtzSeo3uoBVSmZ
tNfyhISUxhHQoXHHHmZ10fZo211SevcZsresXuqZvpw+aRoXltA5CjH2/bsY
3ogeY9d8kNw/Bg3L5Tuebz9C19qn7HNleBxKjzqw2g3S6aVMd1f8xATof3r7
bUBSR98VccsuXMCHidHAuMSuafoYq89ybnYS+LW69xW1NTC6VeSA/6kpWHZh
484kJ2ssirMqk/dlCrpxSvGrLgZib02zGUbML0CNOn5Y/CAGW/mUvil5+Ask
bS7du23PY8xLr3Vy1vcrPOE6aB4+y8My7+0v8un+Cl4jI/4WZsPYhIoorHq3
AJJt84ebp/BASYqzMGwRAGlGu0TaXR1y8irnxtymgVPwER+0QAXtxvnSnM5p
eFvlwDBXd4WbI1vOhXjPgK6qosEzo0OgQGRaGg3OQFtSxXqX6YtwRStjnh8k
BJuSEPJB2RQQ03s4eeNCOHOAHGqv9RhO7Ftx/sjRb6Cvwawxv1cKo2E7aSbC
byDyPH1LTKkHT4KwWuWYCPZ3sz7cXtEBTYl3nfB8ETi8q3qzVmEQ0LrtnaPB
s3BNGnnLx05A4aOv/u+GZsHPZ8hAdHIG1lNuj3P85kCn9FzZDSSGlHLbsIwP
c9DtU5kgKcSjJY6Tkvi98/C8q0jDjSmDznalxZ78ax7K+/PTDlBlkSr5k/xL
jwVYaplR/ymTjF6ZU1IWBhbAlxjg16VGRp7BkesQQwztl4IbK16TkDit9UEk
XwypghLRE2lplM7T0K89sQibGWf1J50kgIlC8sjzi+D8syN3tkQIfXqvKI4X
JbDyfXtXMIsPZYbEXh4BhxTb+sOFyoNQbrTmZYEtDhmujJsnuL6HChPDZHY0
DhmkRis27eBBlSkWGlmHQ7rexT31qS+g2szFgSknhdhezB45vYdQY7Ffd/ev
Uqgzdn481zYZePRTOCxRCtGepSXbXLoAdehq94ZWKdT3woq0BB8M9dZ3SuSV
8ejydtcH3XdcoG6RERbvjEc7Zu2Hz0xSgffSdKtsAh6pClJvR7A0ofYEThjV
gEeJS74e6X0iDTXGjc/wsgTUkkS2ztg6glWPpp6M+IWAsGU0x9Z79VhVZgBl
IZKADJU2Iwh/glX6Gs+cLiegQGPyYlTWVaxCdb54ZpGA5jiO74jbGNhvG1UE
d7dJozihqYq6rhU2aWpm4nBZGt2Bco9Aigp2Zdvu0OkaadSjeI26z2qKvs7x
eG66LBH5ehWGnz9TSS/cxxqz30lERUN6dtGPbtDtg/L0BQlEVFB0uf2EVyC9
9/jboDutROTVk+uccZRCP3lhLNNuhQza48tYbbuaQA/ftZDzxkUG1XZkMz0H
22gx65cVUxJlkEK0ZufTuPs0llCNk9Mog3g2Y7ZC9mEam2dUoUMmoaF8HLNN
3pz2Jxvq2HYktOjrJim2IdBymM4tilEk5JolVclobbAswfw6YipIKOtjslNU
1x+W3/8Z9VWrX2ctulv+A4ZNqC4=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHwpbqybJ2VYtbbBeSP86J4G+I3Rzf
J8wG5z+TTXq34S8znK8v5x1uws0E5384coWhXokBzn+7d3r+boU/+2F8uaJf
E62cf8D5t3gszj8U+gLn873MldZ/837/3vqaLP3vrHobd4Qwyjm8gPMvrXpk
uevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs6+izsp4pBgr/XnOeav
rK/dg/NV/u6bKXXsOZzf4X4+i+vBazj/9cT71r9+vofzbZ2aHyaVf7B/6nyy
IewVv0PrbrGlJz4i+GdNVmXo5XyE80XX2epMeYbgL12Qsjn+9ic433Ryt5X2
hc9wvgBrjrXe469w/qsyHxvDb9/h/KpbMzpLr/6G8w9os947wczgAOOfcp67
jV+YCc4/JP17y9d/zHB+acPrpe4ibHD+rBN6h5S52OF8aHqA8wFHS/+u
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJxF1Ik3lHscBvAxY6xFV0qKyFopUzFhzPt+fyE0IiRJWVIdS1w7nRTX2mYt
V0jRolLKWrbR2JdSKNkqKkTD2MY+lnvvOZ3bc85znvP5B54tTp6WZ4gEAuH4
v/1vWWt8elZWBCsIv2JPS33uXfXbi6eqgvsiflu7SEKuXvi3c+0KHGLXCvzv
H7JOo7lLpIrrMcp9cVJuApTNJkc1RYkVbzX83pjeq1g1XtNGCFEgVFy0qX/z
qjdFglN+07NMfpH1KbZ2X/xK9IbNPgsJNP05llUeNXA1pUS2e5V28zeJKVbe
mZDyavMRBbGfHpsoI2Msi7Fna/XS0lTziq34NqMhFmvf/UluxG2190++65R+
7mWZducyfJViKG39HD2wamH122TY7pTo3JOxbUB8ID2B9chLK8huqYjKZoie
Neh4B23NX08oWHlrc9O02LrtPcBzDZKWH0qlKS29StlYNwhi84VSJINr9HJx
UmxS0xDYK4gYnMQr6dYKRmESH35C7LDtONNiij6meS0gtosNzXrtNTZmKthl
o2Y3ka/DkEfTkltstsa22K51iPoxAvIpwdWyzEis1P3oYSKHA2bfd+UzGQWY
Zcgto2DuKJzyoNgXD/Ziwwm9ugvzY1Bud+uWUKIQjumFf3MKHAd14XbaUw8K
Hlm2PrNhYhxSNTH7x/2W+FvNJy7q7hPgeP2HzMPj/vi659iOxB8TYLnANrxb
kITbqbaOzTtOgvb7rnal3Jd4ZsbpAodPkxAalFvXYvER50jPBdQe4cKzRqK2
WvskTr1xjabWwgX5HnXGpIk4ZOdULwxbTcGyCkeL3bEdFJp4pdldU+Aun2fA
77YfUoY0gjzsp4H5Ud59ts4B1pDdddX7poHMzDDq5/hD1JYHvFHnGWCM3lcJ
V4mGJexzWc7IDMRPH19Z9y4D/GwlL3h5z8LsDmXMOisf2AEH6btnZsGJXyWG
YlgNJ0gztdI+c+BTySo8WtMK7+LSDxFH5yAim18Wq+gBJHOgi+06D188Q4zL
eUOQ/3jS6cPAPLwnjhzYK8YFJWraSNnJBQjeub5JhcGDpMr9AQ++LIDKz9wJ
BxsiEjIbW4k+xgPX8UvRraqC6Hx38hX/jzzw5dU/tfQSRZtEBsVLji+ClL4U
t/SFGGLqUJMWvy1C8dA5Mo0tjk64hssglyU4WhDycmOTGFpKbr0XProETW38
sSeSRdGdBrlt9X7LkJ73ov3qtADC5zxyRHjLsDXYWfY5kw/1qjKpZqErcGxU
19/fZx4q1Mg9DSQC8uZmyVO441CpvqEkbz8BNQZFEGjbB6Bqt1pi6iUC6rxx
w5CX2gk1mrhneCMBSTo+pnXffQ21WhYMd1E+1GTS6RvWXgp1tNPKR0z5UBZD
8rK4ehY0YIEEPI4Pfd3606B4+W9oRFc/qbTyoYkE+UTjvlB4rX/7pfhaIjIx
fqiRtf4sNC67BESbE9GF0Kthj6KsoKFEc69wLBF9ia9PktHFoN6PMBP5hojm
RFyiyHGKUEdpekEUJqEu4s0Y32QhqGXf9A8xJKFBzkTXhTUcvCbzFHUxnIR2
Hd5zc6NiC17tSJk+V0lCLPOK8uL2XLxqE69wepmEkq9Uzg6FxeM2W6W56fv4
0Z/aps46LW74mKbWbkYEP3KKLOxMpBvgUfuOeE7V8SO1Zj65i6dlcBkz32d3
hMmo2feRnl/4JJZvmzBsfJCMFGjWGSTvOszYOWcbN5aMFA8YEKaMU7Ae37fO
t1vJ6JTkPUnueTfM/6/hTCNJAcRwNZnuq9PBgi0Xs19ZCKBjGheCmotEsctK
qwupcQJIM/+5hCPxMz1hRrYsu0kA1fgIL8mkPKGnNqhXKYoIol0zk7buzED6
/VRoTDUSRMo+B4LfD+rTs93NW/6IFESOh2qpww7i9Jf4yY7LVYIouMinw4ve
ofvrn5HuDrGOKbUM3X8Ary2smA==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJxF1Ik71HkcB/AxY0xG5eqS3EloWWUymPl9vjmW1DqibLkpRo106lwqCRHN
EppKx6ISOVOZatzGkSubx5FjRXIMNUzjGLO7z9OzvZ/n/byf1z/w1vIP3XUA
j8PhPP7tf8tVONYrkZDKcN/jbcF+erTihxcCKsIHL/8w9bmSRq3sD+d7Ffkk
KMv872E1f36+mFD2k0cTP9zEWsZYfYe7qRy+bPtxnU3tbZlLp6racRHauDJO
8O86y63ilSZep4ZyNBe4sVHFMgnNsWvUj82xLKxFXJ3cJbP6mWVqXUupzQNK
01y5gBvmX4bmtJd/DlE1Hp/kuniaUtM2FOoVvHCTUkcj3GmfGf5KteeGbdl/
m5f29HHbnGnLaB+yjds/TliBWws3x86MLXISbb6nPyQ/dJfFLa4lp1NJnZRR
B7lDNh1NED1htSHkOosquG02avm+FwobTl/MlbywWC9+c3NtzSeo3uoBVSmZ
tNfyhISUxhHQoXHHHmZ10fZo211SevcZsresXuqZvpw+aRoXltA5CjH2/bsY
3ogeY9d8kNw/Bg3L5Tuebz9C19qn7HNleBxKjzqw2g3S6aVMd1f8xATof3r7
bUBSR98VccsuXMCHidHAuMSuafoYq89ybnYS+LW69xW1NTC6VeSA/6kpWHZh
484kJ2ssirMqk/dlCrpxSvGrLgZib02zGUbML0CNOn5Y/CAGW/mUvil5+Ask
bS7du23PY8xLr3Vy1vcrPOE6aB4+y8My7+0v8un+Cl4jI/4WZsPYhIoorHq3
AJJt84ebp/BASYqzMGwRAGlGu0TaXR1y8irnxtymgVPwER+0QAXtxvnSnM5p
eFvlwDBXd4WbI1vOhXjPgK6qosEzo0OgQGRaGg3OQFtSxXqX6YtwRStjnh8k
BJuSEPJB2RQQ03s4eeNCOHOAHGqv9RhO7Ftx/sjRb6Cvwawxv1cKo2E7aSbC
byDyPH1LTKkHT4KwWuWYCPZ3sz7cXtEBTYl3nfB8ETi8q3qzVmEQ0LrtnaPB
s3BNGnnLx05A4aOv/u+GZsHPZ8hAdHIG1lNuj3P85kCn9FzZDSSGlHLbsIwP
c9DtU5kgKcSjJY6Tkvi98/C8q0jDjSmDznalxZ78ax7K+/PTDlBlkSr5k/xL
jwVYaplR/ymTjF6ZU1IWBhbAlxjg16VGRp7BkesQQwztl4IbK16TkDit9UEk
XwypghLRE2lplM7T0K89sQibGWf1J50kgIlC8sjzi+D8syN3tkQIfXqvKI4X
JbDyfXtXMIsPZYbEXh4BhxTb+sOFyoNQbrTmZYEtDhmujJsnuL6HChPDZHY0
DhmkRis27eBBlSkWGlmHQ7rexT31qS+g2szFgSknhdhezB45vYdQY7Ffd/ev
Uqgzdn481zYZePRTOCxRCtGepSXbXLoAdehq94ZWKdT3woq0BB8M9dZ3SuSV
8ejydtcH3XdcoG6RERbvjEc7Zu2Hz0xSgffSdKtsAh6pClJvR7A0ofYEThjV
gEeJS74e6X0iDTXGjc/wsgTUkkS2ztg6glWPpp6M+IWAsGU0x9Z79VhVZgBl
IZKADJU2Iwh/glX6Gs+cLiegQGPyYlTWVaxCdb54ZpGA5jiO74jbGNhvG1UE
d7dJozihqYq6rhU2aWpm4nBZGt2Bco9Aigp2Zdvu0OkaadSjeI26z2qKvs7x
eG66LBH5ehWGnz9TSS/cxxqz30lERUN6dtGPbtDtg/L0BQlEVFB0uf2EVyC9
9/jboDutROTVk+uccZRCP3lhLNNuhQza48tYbbuaQA/ftZDzxkUG1XZkMz0H
22gx65cVUxJlkEK0ZufTuPs0llCNk9Mog3g2Y7ZC9mEam2dUoUMmoaF8HLNN
3pz2Jxvq2HYktOjrJim2IdBymM4tilEk5JolVclobbAswfw6YipIKOtjslNU
1x+W3/8Z9VWrX2ctulv+A4ZNqC4=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHwpbqybJ2VYtbbBeSP86J4G+I3Rzf
J8wG5z+TTXq34S8znK8v5x1uws0E5384coWhXokBzn+7d3r+boU/+2F8uaJf
E62cf8D5t3gszj8U+gLn873MldZ/837/3vqaLP3vrHobd4Qwyjm8gPMvrXpk
uevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs6+izsp4pBgr/XnOeav
rK/dg/NV/u6bKXXsOZzf4X4+i+vBazj/9cT71r9+vofzbZ2aHyaVf7B/6nyy
IewVv0PrbrGlJz4i+GdNVmXo5XyE80XX2epMeYbgL12Qsjn+9ic433Ryt5X2
hc9wvgBrjrXe469w/qsyHxvDb9/h/KpbMzpLr/6G8w9os947wczgAOOfcp67
jV+YCc4/JP17y9d/zHB+acPrpe4ibHD+rBN6h5S52OF8aHqA8wFHS/+u
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJxF1Ik3lHscBvAxY6xFV0qKyFopUzFhzPt+fyE0IiRJWVIdS1w7nRTX2mYt
V0jRolLKWrbR2JdSKNkqKkTD2MY+lnvvOZ3bc85znvP5B54tTp6WZ4gEAuH4
v/1vWWt8elZWBCsIv2JPS33uXfXbi6eqgvsiflu7SEKuXvi3c+0KHGLXCvzv
H7JOo7lLpIrrMcp9cVJuApTNJkc1RYkVbzX83pjeq1g1XtNGCFEgVFy0qX/z
qjdFglN+07NMfpH1KbZ2X/xK9IbNPgsJNP05llUeNXA1pUS2e5V28zeJKVbe
mZDyavMRBbGfHpsoI2Msi7Fna/XS0lTziq34NqMhFmvf/UluxG2190++65R+
7mWZducyfJViKG39HD2wamH122TY7pTo3JOxbUB8ID2B9chLK8huqYjKZoie
Neh4B23NX08oWHlrc9O02LrtPcBzDZKWH0qlKS29StlYNwhi84VSJINr9HJx
UmxS0xDYK4gYnMQr6dYKRmESH35C7LDtONNiij6meS0gtosNzXrtNTZmKthl
o2Y3ka/DkEfTkltstsa22K51iPoxAvIpwdWyzEis1P3oYSKHA2bfd+UzGQWY
Zcgto2DuKJzyoNgXD/Ziwwm9ugvzY1Bud+uWUKIQjumFf3MKHAd14XbaUw8K
Hlm2PrNhYhxSNTH7x/2W+FvNJy7q7hPgeP2HzMPj/vi659iOxB8TYLnANrxb
kITbqbaOzTtOgvb7rnal3Jd4ZsbpAodPkxAalFvXYvER50jPBdQe4cKzRqK2
WvskTr1xjabWwgX5HnXGpIk4ZOdULwxbTcGyCkeL3bEdFJp4pdldU+Aun2fA
77YfUoY0gjzsp4H5Ud59ts4B1pDdddX7poHMzDDq5/hD1JYHvFHnGWCM3lcJ
V4mGJexzWc7IDMRPH19Z9y4D/GwlL3h5z8LsDmXMOisf2AEH6btnZsGJXyWG
YlgNJ0gztdI+c+BTySo8WtMK7+LSDxFH5yAim18Wq+gBJHOgi+06D188Q4zL
eUOQ/3jS6cPAPLwnjhzYK8YFJWraSNnJBQjeub5JhcGDpMr9AQ++LIDKz9wJ
BxsiEjIbW4k+xgPX8UvRraqC6Hx38hX/jzzw5dU/tfQSRZtEBsVLji+ClL4U
t/SFGGLqUJMWvy1C8dA5Mo0tjk64hssglyU4WhDycmOTGFpKbr0XProETW38
sSeSRdGdBrlt9X7LkJ73ov3qtADC5zxyRHjLsDXYWfY5kw/1qjKpZqErcGxU
19/fZx4q1Mg9DSQC8uZmyVO441CpvqEkbz8BNQZFEGjbB6Bqt1pi6iUC6rxx
w5CX2gk1mrhneCMBSTo+pnXffQ21WhYMd1E+1GTS6RvWXgp1tNPKR0z5UBZD
8rK4ehY0YIEEPI4Pfd3606B4+W9oRFc/qbTyoYkE+UTjvlB4rX/7pfhaIjIx
fqiRtf4sNC67BESbE9GF0Kthj6KsoKFEc69wLBF9ia9PktHFoN6PMBP5hojm
RFyiyHGKUEdpekEUJqEu4s0Y32QhqGXf9A8xJKFBzkTXhTUcvCbzFHUxnIR2
Hd5zc6NiC17tSJk+V0lCLPOK8uL2XLxqE69wepmEkq9Uzg6FxeM2W6W56fv4
0Z/aps46LW74mKbWbkYEP3KKLOxMpBvgUfuOeE7V8SO1Zj65i6dlcBkz32d3
hMmo2feRnl/4JJZvmzBsfJCMFGjWGSTvOszYOWcbN5aMFA8YEKaMU7Ae37fO
t1vJ6JTkPUnueTfM/6/hTCNJAcRwNZnuq9PBgi0Xs19ZCKBjGheCmotEsctK
qwupcQJIM/+5hCPxMz1hRrYsu0kA1fgIL8mkPKGnNqhXKYoIol0zk7buzED6
/VRoTDUSRMo+B4LfD+rTs93NW/6IFESOh2qpww7i9Jf4yY7LVYIouMinw4ve
ofvrn5HuDrGOKbUM3X8Ary2smA==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJxF1Ik71HkcB/AxY0xG5eqS3EloWWUymPl9vjmW1DqibLkpRo106lwqCRHN
EppKx6ISOVOZatzGkSubx5FjRXIMNUzjGLO7z9OzvZ/n/byf1z/w1vIP3XUA
j8PhPP7tf8tVONYrkZDKcN/jbcF+erTihxcCKsIHL/8w9bmSRq3sD+d7Ffkk
KMv872E1f36+mFD2k0cTP9zEWsZYfYe7qRy+bPtxnU3tbZlLp6racRHauDJO
8O86y63ilSZep4ZyNBe4sVHFMgnNsWvUj82xLKxFXJ3cJbP6mWVqXUupzQNK
01y5gBvmX4bmtJd/DlE1Hp/kuniaUtM2FOoVvHCTUkcj3GmfGf5KteeGbdl/
m5f29HHbnGnLaB+yjds/TliBWws3x86MLXISbb6nPyQ/dJfFLa4lp1NJnZRR
B7lDNh1NED1htSHkOosquG02avm+FwobTl/MlbywWC9+c3NtzSeo3uoBVSmZ
tNfyhISUxhHQoXHHHmZ10fZo211SevcZsresXuqZvpw+aRoXltA5CjH2/bsY
3ogeY9d8kNw/Bg3L5Tuebz9C19qn7HNleBxKjzqw2g3S6aVMd1f8xATof3r7
bUBSR98VccsuXMCHidHAuMSuafoYq89ybnYS+LW69xW1NTC6VeSA/6kpWHZh
484kJ2ssirMqk/dlCrpxSvGrLgZib02zGUbML0CNOn5Y/CAGW/mUvil5+Ask
bS7du23PY8xLr3Vy1vcrPOE6aB4+y8My7+0v8un+Cl4jI/4WZsPYhIoorHq3
AJJt84ebp/BASYqzMGwRAGlGu0TaXR1y8irnxtymgVPwER+0QAXtxvnSnM5p
eFvlwDBXd4WbI1vOhXjPgK6qosEzo0OgQGRaGg3OQFtSxXqX6YtwRStjnh8k
BJuSEPJB2RQQ03s4eeNCOHOAHGqv9RhO7Ftx/sjRb6Cvwawxv1cKo2E7aSbC
byDyPH1LTKkHT4KwWuWYCPZ3sz7cXtEBTYl3nfB8ETi8q3qzVmEQ0LrtnaPB
s3BNGnnLx05A4aOv/u+GZsHPZ8hAdHIG1lNuj3P85kCn9FzZDSSGlHLbsIwP
c9DtU5kgKcSjJY6Tkvi98/C8q0jDjSmDznalxZ78ax7K+/PTDlBlkSr5k/xL
jwVYaplR/ymTjF6ZU1IWBhbAlxjg16VGRp7BkesQQwztl4IbK16TkDit9UEk
XwypghLRE2lplM7T0K89sQibGWf1J50kgIlC8sjzi+D8syN3tkQIfXqvKI4X
JbDyfXtXMIsPZYbEXh4BhxTb+sOFyoNQbrTmZYEtDhmujJsnuL6HChPDZHY0
DhmkRis27eBBlSkWGlmHQ7rexT31qS+g2szFgSknhdhezB45vYdQY7Ffd/ev
Uqgzdn481zYZePRTOCxRCtGepSXbXLoAdehq94ZWKdT3woq0BB8M9dZ3SuSV
8ejydtcH3XdcoG6RERbvjEc7Zu2Hz0xSgffSdKtsAh6pClJvR7A0ofYEThjV
gEeJS74e6X0iDTXGjc/wsgTUkkS2ztg6glWPpp6M+IWAsGU0x9Z79VhVZgBl
IZKADJU2Iwh/glX6Gs+cLiegQGPyYlTWVaxCdb54ZpGA5jiO74jbGNhvG1UE
d7dJozihqYq6rhU2aWpm4nBZGt2Bco9Aigp2Zdvu0OkaadSjeI26z2qKvs7x
eG66LBH5ehWGnz9TSS/cxxqz30lERUN6dtGPbtDtg/L0BQlEVFB0uf2EVyC9
9/jboDutROTVk+uccZRCP3lhLNNuhQza48tYbbuaQA/ftZDzxkUG1XZkMz0H
22gx65cVUxJlkEK0ZufTuPs0llCNk9Mog3g2Y7ZC9mEam2dUoUMmoaF8HLNN
3pz2Jxvq2HYktOjrJim2IdBymM4tilEk5JolVclobbAswfw6YipIKOtjslNU
1x+W3/8Z9VWrX2ctulv+A4ZNqC4=
          "]]}}, {{}, {}, 
        {Hue[0.], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHwpbqybJ2VYtbbBeSP86J4G+I3Rzf
J8wG5z+TTXq34S8znK8v5x1uws0E5384coWhXokBzn+7d3r+boU/+2F8uaJf
E62cf8D5t3gszj8U+gLn873MldZ/837/3vqaLP3vrHobd4Qwyjm8gPMvrXpk
uevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs6+izsp4pBgr/XnOeav
rK/dg/NV/u6bKXXsOZzf4X4+i+vBazj/9cT71r9+vofzbZ2aHyaVf7B/6nyy
IewVv0PrbrGlJz4i+GdNVmXo5XyE80XX2epMeYbgL12Qsjn+9ic433Ryt5X2
hc9wvgBrjrXe469w/qsyHxvDb9/h/KpbMzpLr/6G8w9os947wczgAOOfcp67
jV+YCc4/JP17y9d/zHB+acPrpe4ibHD+rBN6h5S52OF8aHqA8wFHS/+u
          "]]}, 
        {Hue[0.1], Thickness[0.007], LineBox[CompressedData["
1:eJxF1Ik3lHscBvAxY6xFV0qKyFopUzFhzPt+fyE0IiRJWVIdS1w7nRTX2mYt
V0jRolLKWrbR2JdSKNkqKkTD2MY+lnvvOZ3bc85znvP5B54tTp6WZ4gEAuH4
v/1vWWt8elZWBCsIv2JPS33uXfXbi6eqgvsiflu7SEKuXvi3c+0KHGLXCvzv
H7JOo7lLpIrrMcp9cVJuApTNJkc1RYkVbzX83pjeq1g1XtNGCFEgVFy0qX/z
qjdFglN+07NMfpH1KbZ2X/xK9IbNPgsJNP05llUeNXA1pUS2e5V28zeJKVbe
mZDyavMRBbGfHpsoI2Msi7Fna/XS0lTziq34NqMhFmvf/UluxG2190++65R+
7mWZducyfJViKG39HD2wamH122TY7pTo3JOxbUB8ID2B9chLK8huqYjKZoie
Neh4B23NX08oWHlrc9O02LrtPcBzDZKWH0qlKS29StlYNwhi84VSJINr9HJx
UmxS0xDYK4gYnMQr6dYKRmESH35C7LDtONNiij6meS0gtosNzXrtNTZmKthl
o2Y3ka/DkEfTkltstsa22K51iPoxAvIpwdWyzEis1P3oYSKHA2bfd+UzGQWY
Zcgto2DuKJzyoNgXD/Ziwwm9ugvzY1Bud+uWUKIQjumFf3MKHAd14XbaUw8K
Hlm2PrNhYhxSNTH7x/2W+FvNJy7q7hPgeP2HzMPj/vi659iOxB8TYLnANrxb
kITbqbaOzTtOgvb7rnal3Jd4ZsbpAodPkxAalFvXYvER50jPBdQe4cKzRqK2
WvskTr1xjabWwgX5HnXGpIk4ZOdULwxbTcGyCkeL3bEdFJp4pdldU+Aun2fA
77YfUoY0gjzsp4H5Ud59ts4B1pDdddX7poHMzDDq5/hD1JYHvFHnGWCM3lcJ
V4mGJexzWc7IDMRPH19Z9y4D/GwlL3h5z8LsDmXMOisf2AEH6btnZsGJXyWG
YlgNJ0gztdI+c+BTySo8WtMK7+LSDxFH5yAim18Wq+gBJHOgi+06D188Q4zL
eUOQ/3jS6cPAPLwnjhzYK8YFJWraSNnJBQjeub5JhcGDpMr9AQ++LIDKz9wJ
BxsiEjIbW4k+xgPX8UvRraqC6Hx38hX/jzzw5dU/tfQSRZtEBsVLji+ClL4U
t/SFGGLqUJMWvy1C8dA5Mo0tjk64hssglyU4WhDycmOTGFpKbr0XProETW38
sSeSRdGdBrlt9X7LkJ73ov3qtADC5zxyRHjLsDXYWfY5kw/1qjKpZqErcGxU
19/fZx4q1Mg9DSQC8uZmyVO441CpvqEkbz8BNQZFEGjbB6Bqt1pi6iUC6rxx
w5CX2gk1mrhneCMBSTo+pnXffQ21WhYMd1E+1GTS6RvWXgp1tNPKR0z5UBZD
8rK4ehY0YIEEPI4Pfd3606B4+W9oRFc/qbTyoYkE+UTjvlB4rX/7pfhaIjIx
fqiRtf4sNC67BESbE9GF0Kthj6KsoKFEc69wLBF9ia9PktHFoN6PMBP5hojm
RFyiyHGKUEdpekEUJqEu4s0Y32QhqGXf9A8xJKFBzkTXhTUcvCbzFHUxnIR2
Hd5zc6NiC17tSJk+V0lCLPOK8uL2XLxqE69wepmEkq9Uzg6FxeM2W6W56fv4
0Z/aps46LW74mKbWbkYEP3KKLOxMpBvgUfuOeE7V8SO1Zj65i6dlcBkz32d3
hMmo2feRnl/4JJZvmzBsfJCMFGjWGSTvOszYOWcbN5aMFA8YEKaMU7Ae37fO
t1vJ6JTkPUnueTfM/6/hTCNJAcRwNZnuq9PBgi0Xs19ZCKBjGheCmotEsctK
qwupcQJIM/+5hCPxMz1hRrYsu0kA1fgIL8mkPKGnNqhXKYoIol0zk7buzED6
/VRoTDUSRMo+B4LfD+rTs93NW/6IFESOh2qpww7i9Jf4yY7LVYIouMinw4ve
ofvrn5HuDrGOKbUM3X8Ary2smA==
          "]]}, 
        {Hue[0.2], Thickness[0.007], LineBox[CompressedData["
1:eJxTTMoPSmViYGBQAmIQvV+g6N7//+wHGKAgzmrWusJDCP6f5EN1j1sQfIvt
QvLHORH8DbGb4/uE2eD8Z7JJ7zb8ZYbz9eW8w024meD8D0euMNQrMcD5b/dO
z9+t8Gc/jC9X9GuilfMPOP8Wj8X5h0Jf4Hy+l7nS+m/ew/kbd4Qwyjm8gPMv
rXpkuevOfTj/ypO3TvYhF+D8BZpP+Z/Onwjnv/Lizna5fs4exv88x/yV9bV7
cL7K330zpY49h/NfT7xv/evnezjfdHK3lfaFz3D+qzIfG8Nv3+H8qlszOkuv
/obzD2iz3jvBzOAA459ynruNX5gJzj8k/XvL13/McH5pw+ul7iJscH5d0J81
+wIR/A4V3i2m/Qj+rBN6h5S52OH8xbPsT85yR/DX5ARcEGxF8LfZJV7vOITg
Q9MDnA8Ax7aK2w==
          "]]}, 
        {Hue[0.30000000000000004`], Thickness[0.007], LineBox[CompressedData["

1:eJxF1Ik71HkcB/AxY0xG5eqS3EloWWUymPl9vjmW1DqibLkpRo106lwqCRHN
EppKx6ISOVOZatzGkSubx5FjRXIMNUzjGLO7z9OzvZ/n/byf1z/w1vIP3XUA
j8PhPP7tf8tVONYrkZDKcN/jbcF+erTihxcCKsIHL/8w9bmSRq3sD+d7Ffkk
KMv872E1f36+mFD2k0cTP9zEWsZYfYe7qRy+bPtxnU3tbZlLp6racRHauDJO
8O86y63ilSZep4ZyNBe4sVHFMgnNsWvUj82xLKxFXJ3cJbP6mWVqXUupzQNK
01y5gBvmX4bmtJd/DlE1Hp/kuniaUtM2FOoVvHCTUkcj3GmfGf5KteeGbdl/
m5f29HHbnGnLaB+yjds/TliBWws3x86MLXISbb6nPyQ/dJfFLa4lp1NJnZRR
B7lDNh1NED1htSHkOosquG02avm+FwobTl/MlbywWC9+c3NtzSeo3uoBVSmZ
tNfyhISUxhHQoXHHHmZ10fZo211SevcZsresXuqZvpw+aRoXltA5CjH2/bsY
3ogeY9d8kNw/Bg3L5Tuebz9C19qn7HNleBxKjzqw2g3S6aVMd1f8xATof3r7
bUBSR98VccsuXMCHidHAuMSuafoYq89ybnYS+LW69xW1NTC6VeSA/6kpWHZh
484kJ2ssirMqk/dlCrpxSvGrLgZib02zGUbML0CNOn5Y/CAGW/mUvil5+Ask
bS7du23PY8xLr3Vy1vcrPOE6aB4+y8My7+0v8un+Cl4jI/4WZsPYhIoorHq3
AJJt84ebp/BASYqzMGwRAGlGu0TaXR1y8irnxtymgVPwER+0QAXtxvnSnM5p
eFvlwDBXd4WbI1vOhXjPgK6qosEzo0OgQGRaGg3OQFtSxXqX6YtwRStjnh8k
BJuSEPJB2RQQ03s4eeNCOHOAHGqv9RhO7Ftx/sjRb6Cvwawxv1cKo2E7aSbC
byDyPH1LTKkHT4KwWuWYCPZ3sz7cXtEBTYl3nfB8ETi8q3qzVmEQ0LrtnaPB
s3BNGnnLx05A4aOv/u+GZsHPZ8hAdHIG1lNuj3P85kCn9FzZDSSGlHLbsIwP
c9DtU5kgKcSjJY6Tkvi98/C8q0jDjSmDznalxZ78ax7K+/PTDlBlkSr5k/xL
jwVYaplR/ymTjF6ZU1IWBhbAlxjg16VGRp7BkesQQwztl4IbK16TkDit9UEk
XwypghLRE2lplM7T0K89sQibGWf1J50kgIlC8sjzi+D8syN3tkQIfXqvKI4X
JbDyfXtXMIsPZYbEXh4BhxTb+sOFyoNQbrTmZYEtDhmujJsnuL6HChPDZHY0
DhmkRis27eBBlSkWGlmHQ7rexT31qS+g2szFgSknhdhezB45vYdQY7Ffd/ev
Uqgzdn481zYZePRTOCxRCtGepSXbXLoAdehq94ZWKdT3woq0BB8M9dZ3SuSV
8ejydtcH3XdcoG6RERbvjEc7Zu2Hz0xSgffSdKtsAh6pClJvR7A0ofYEThjV
gEeJS74e6X0iDTXGjc/wsgTUkkS2ztg6glWPpp6M+IWAsGU0x9Z79VhVZgBl
IZKADJU2Iwh/glX6Gs+cLiegQGPyYlTWVaxCdb54ZpGA5jiO74jbGNhvG1UE
d7dJozihqYq6rhU2aWpm4nBZGt2Bco9Aigp2Zdvu0OkaadSjeI26z2qKvs7x
eG66LBH5ehWGnz9TSS/cxxqz30lERUN6dtGPbtDtg/L0BQlEVFB0uf2EVyC9
9/jboDutROTVk+uccZRCP3lhLNNuhQza48tYbbuaQA/ftZDzxkUG1XZkMz0H
22gx65cVUxJlkEK0ZufTuPs0llCNk9Mog3g2Y7ZC9mEam2dUoUMmoaF8HLNN
3pz2Jxvq2HYktOjrJim2IdBymM4tilEk5JolVclobbAswfw6YipIKOtjslNU
1x+W3/8Z9VWrX2ctulv+A4ZNqC4=
          "]]}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      Frame->True,
      GridLines->{{2, 0, 1.780003264209258}, None},
      PlotRange->{{-3, 3}, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {967.5, -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}]}, {}},
  ContentSelectable->True,
  ImageSize->{621., Automatic},
  PlotRangePadding->{6, 5}]], "Print",
 CellChangeTimes->{
  3.46070451917115*^9, {3.4607046303750753`*^9, 3.460704648904955*^9}, {
   3.4607047577968493`*^9, 3.46070477859319*^9}, 3.460704954247167*^9, 
   3.4607050368531113`*^9, {3.460705128436154*^9, 3.460705175118433*^9}, 
   3.460705215569192*^9, {3.460705274472828*^9, 3.460705286163951*^9}, {
   3.460705328448756*^9, 3.460705339224861*^9}, 3.460705436687511*^9, {
   3.460712600376568*^9, 3.4607126147235003`*^9}, 3.460713047876918*^9, {
   3.460713282521329*^9, 3.460713294551167*^9}, {3.460713834968994*^9, 
   3.460713860036693*^9}, 3.460713902558764*^9, {3.460713957325048*^9, 
   3.460713995695146*^9}, 3.460714037951282*^9, 3.460714131146854*^9, {
   3.460714181968012*^9, 3.460714208204916*^9}, 3.460714288368878*^9, 
   3.460714320506762*^9, 3.460715344636594*^9, 3.4607156113978767`*^9, 
   3.460715886246475*^9, 3.460715921874712*^9, 3.460716010317369*^9, {
   3.460716602712977*^9, 3.460716612332562*^9}, 3.4607166808613367`*^9, 
   3.460716728278655*^9, 3.460717947774094*^9, 3.4607181538085213`*^9, 
   3.460864852779917*^9, 3.4608649440956497`*^9, {3.460865054515229*^9, 
   3.4608650996454573`*^9}, 3.460865131062428*^9, 3.4608652063886013`*^9, 
   3.4608652375708027`*^9, {3.460865304978962*^9, 3.46086534669381*^9}, {
   3.460865383703322*^9, 3.4608653942322607`*^9}, 3.460865443237199*^9, 
   3.460865487147558*^9, 3.460865524133155*^9, 3.460865599301724*^9, 
   3.460865631528137*^9, {3.460865678064745*^9, 3.4608657627915583`*^9}, {
   3.460865888638105*^9, 3.460865895896729*^9}, 3.460865937576189*^9, {
   3.460865987678075*^9, 3.460866000022244*^9}, 3.460866039071653*^9, 
   3.460866078288553*^9, 3.4608661727274227`*^9, {3.46086620527229*^9, 
   3.4608662286114283`*^9}, {3.460866591783491*^9, 3.460866605728109*^9}, {
   3.460884097643346*^9, 3.460884163155167*^9}, 3.460884256662903*^9, {
   3.460884582123115*^9, 3.4608846116249857`*^9}, 3.4608846679279823`*^9, {
   3.4608848296710052`*^9, 3.460884896153452*^9}, {3.460888708395012*^9, 
   3.460888733025832*^9}, 3.460888856973765*^9, 3.460889348450428*^9, 
   3.460889410038197*^9, 3.4608899257122517`*^9, 3.460890038266615*^9, {
   3.460890116133047*^9, 3.460890159630308*^9}, 3.460890191415696*^9, {
   3.460890270481584*^9, 3.460890308143527*^9}, {3.460890431748641*^9, 
   3.46089045135244*^9}, {3.460890488240271*^9, 3.460890504344252*^9}, {
   3.460890552097582*^9, 3.460890588805337*^9}, {3.460891455180016*^9, 
   3.4608914721018267`*^9}, {3.460891583880372*^9, 3.460891622241083*^9}}],

Cell[BoxData[
 RowBox[{"-", "0.48133853203508803`"}]], "Output",
 CellChangeTimes->{
  3.4606944285880413`*^9, 3.460694710821148*^9, 3.460694813752266*^9, 
   3.4606948686565523`*^9, 3.460694908824984*^9, 3.460694943743373*^9, {
   3.4606955286647463`*^9, 3.460695539377111*^9}, {3.4606959743468847`*^9, 
   3.460696046934908*^9}, 3.460696164888945*^9, {3.46069624289347*^9, 
   3.460696254104011*^9}, 3.46069664856536*^9, 3.4606978773565187`*^9, 
   3.460698003355398*^9, 3.460698428704109*^9, 3.460699017700994*^9, 
   3.460699198261404*^9, {3.4606992404204206`*^9, 3.460699250004673*^9}, {
   3.460699420002788*^9, 3.460699448542591*^9}, {3.460699551492279*^9, 
   3.4606995760372458`*^9}, 3.460699628821332*^9, {3.4606997766246853`*^9, 
   3.46069979233737*^9}, 3.460699846509027*^9, 3.460699991426691*^9, 
   3.460700120962723*^9, 3.460700150978692*^9, 3.460700290202798*^9, 
   3.460700350015143*^9, 3.460700640543497*^9, 3.46070113823307*^9, 
   3.460701477583243*^9, 3.460701669557947*^9, 3.4607028883471003`*^9, 
   3.460703284824523*^9, 3.460703470343832*^9, {3.460703818260503*^9, 
   3.460703838762457*^9}, {3.4607039225852947`*^9, 3.460703937086619*^9}, 
   3.460704031751749*^9, 3.460704109348311*^9, 3.460704324286234*^9, {
   3.460704404777562*^9, 3.460704452506097*^9}, {3.460704497969942*^9, 
   3.460704519204072*^9}, {3.460704630407476*^9, 3.460704648938583*^9}, {
   3.460704757832714*^9, 3.4607047786437263`*^9}, 3.4607049542830973`*^9, 
   3.460705036891027*^9, {3.460705128472733*^9, 3.460705175152998*^9}, 
   3.4607052156065817`*^9, {3.460705274511199*^9, 3.460705286201747*^9}, {
   3.460705328482711*^9, 3.460705339258251*^9}, 3.4607054367225018`*^9, {
   3.460712600408203*^9, 3.4607126147571*^9}, 3.460713047908724*^9, {
   3.460713282554874*^9, 3.4607132945848017`*^9}, {3.460713835058514*^9, 
   3.4607138601197033`*^9}, 3.4607139026455917`*^9, {3.460713957091056*^9, 
   3.460713995382338*^9}, 3.460714037957024*^9, 3.460714131191308*^9, {
   3.460714181974341*^9, 3.4607142082382517`*^9}, 3.4607142884014807`*^9, 
   3.4607143205417843`*^9, 3.4607153449128113`*^9, 3.460715611660941*^9, 
   3.46071588650872*^9, 3.4607159221362133`*^9, 3.460716010350465*^9, {
   3.460716602744968*^9, 3.460716612368623*^9}, 3.4607166808947973`*^9, 
   3.460716728310671*^9, 3.4607179478075523`*^9, 3.460718153890011*^9, 
   3.460864853569865*^9, 3.460864944632353*^9, {3.4608650549224043`*^9, 
   3.4608651000694838`*^9}, 3.460865131533939*^9, 3.460865206868553*^9, 
   3.460865237994265*^9, {3.460865305414671*^9, 3.460865347127034*^9}, {
   3.4608653841410217`*^9, 3.460865394663265*^9}, 3.4608654436569023`*^9, 
   3.460865487559341*^9, 3.4608655245522413`*^9, 3.460865599731702*^9, 
   3.46086563194384*^9, {3.460865678567177*^9, 3.460865763215781*^9}, {
   3.4608658890662947`*^9, 3.460865896275236*^9}, 3.460865937973333*^9, {
   3.460865988090621*^9, 3.460866000404463*^9}, 3.460866039460979*^9, 
   3.460866078684072*^9, 3.460866173126914*^9, {3.460866205645241*^9, 
   3.460866228977401*^9}, {3.460866592131584*^9, 3.460866606116922*^9}, {
   3.460884097973241*^9, 3.4608841635609827`*^9}, 3.4608842571343107`*^9, {
   3.460884582522368*^9, 3.4608846120265217`*^9}, 3.4608846683227043`*^9, {
   3.460884830077977*^9, 3.46088489660178*^9}, {3.460888708916758*^9, 
   3.460888733443715*^9}, 3.460888857374319*^9, 3.460889348847591*^9, 
   3.46088941044028*^9, 3.460889926088251*^9, 3.460890038615594*^9, {
   3.4608901161774*^9, 3.460890159674868*^9}, 3.460890191459124*^9, {
   3.4608902705254993`*^9, 3.460890308461899*^9}, {3.460890431792459*^9, 
   3.460890451396481*^9}, {3.460890488285193*^9, 3.460890504385693*^9}, {
   3.460890552139698*^9, 3.4608905888481092`*^9}, {3.460891455286799*^9, 
   3.460891472150818*^9}, {3.460891584175662*^9, 3.460891622290492*^9}}],

Cell[BoxData[
 RowBox[{"-", "2.2223777205592814`"}]], "Output",
 CellChangeTimes->{
  3.4606944285880413`*^9, 3.460694710821148*^9, 3.460694813752266*^9, 
   3.4606948686565523`*^9, 3.460694908824984*^9, 3.460694943743373*^9, {
   3.4606955286647463`*^9, 3.460695539377111*^9}, {3.4606959743468847`*^9, 
   3.460696046934908*^9}, 3.460696164888945*^9, {3.46069624289347*^9, 
   3.460696254104011*^9}, 3.46069664856536*^9, 3.4606978773565187`*^9, 
   3.460698003355398*^9, 3.460698428704109*^9, 3.460699017700994*^9, 
   3.460699198261404*^9, {3.4606992404204206`*^9, 3.460699250004673*^9}, {
   3.460699420002788*^9, 3.460699448542591*^9}, {3.460699551492279*^9, 
   3.4606995760372458`*^9}, 3.460699628821332*^9, {3.4606997766246853`*^9, 
   3.46069979233737*^9}, 3.460699846509027*^9, 3.460699991426691*^9, 
   3.460700120962723*^9, 3.460700150978692*^9, 3.460700290202798*^9, 
   3.460700350015143*^9, 3.460700640543497*^9, 3.46070113823307*^9, 
   3.460701477583243*^9, 3.460701669557947*^9, 3.4607028883471003`*^9, 
   3.460703284824523*^9, 3.460703470343832*^9, {3.460703818260503*^9, 
   3.460703838762457*^9}, {3.4607039225852947`*^9, 3.460703937086619*^9}, 
   3.460704031751749*^9, 3.460704109348311*^9, 3.460704324286234*^9, {
   3.460704404777562*^9, 3.460704452506097*^9}, {3.460704497969942*^9, 
   3.460704519204072*^9}, {3.460704630407476*^9, 3.460704648938583*^9}, {
   3.460704757832714*^9, 3.4607047786437263`*^9}, 3.4607049542830973`*^9, 
   3.460705036891027*^9, {3.460705128472733*^9, 3.460705175152998*^9}, 
   3.4607052156065817`*^9, {3.460705274511199*^9, 3.460705286201747*^9}, {
   3.460705328482711*^9, 3.460705339258251*^9}, 3.4607054367225018`*^9, {
   3.460712600408203*^9, 3.4607126147571*^9}, 3.460713047908724*^9, {
   3.460713282554874*^9, 3.4607132945848017`*^9}, {3.460713835058514*^9, 
   3.4607138601197033`*^9}, 3.4607139026455917`*^9, {3.460713957091056*^9, 
   3.460713995382338*^9}, 3.460714037957024*^9, 3.460714131191308*^9, {
   3.460714181974341*^9, 3.4607142082382517`*^9}, 3.4607142884014807`*^9, 
   3.4607143205417843`*^9, 3.4607153449128113`*^9, 3.460715611660941*^9, 
   3.46071588650872*^9, 3.4607159221362133`*^9, 3.460716010350465*^9, {
   3.460716602744968*^9, 3.460716612368623*^9}, 3.4607166808947973`*^9, 
   3.460716728310671*^9, 3.4607179478075523`*^9, 3.460718153890011*^9, 
   3.460864853569865*^9, 3.460864944632353*^9, {3.4608650549224043`*^9, 
   3.4608651000694838`*^9}, 3.460865131533939*^9, 3.460865206868553*^9, 
   3.460865237994265*^9, {3.460865305414671*^9, 3.460865347127034*^9}, {
   3.4608653841410217`*^9, 3.460865394663265*^9}, 3.4608654436569023`*^9, 
   3.460865487559341*^9, 3.4608655245522413`*^9, 3.460865599731702*^9, 
   3.46086563194384*^9, {3.460865678567177*^9, 3.460865763215781*^9}, {
   3.4608658890662947`*^9, 3.460865896275236*^9}, 3.460865937973333*^9, {
   3.460865988090621*^9, 3.460866000404463*^9}, 3.460866039460979*^9, 
   3.460866078684072*^9, 3.460866173126914*^9, {3.460866205645241*^9, 
   3.460866228977401*^9}, {3.460866592131584*^9, 3.460866606116922*^9}, {
   3.460884097973241*^9, 3.4608841635609827`*^9}, 3.4608842571343107`*^9, {
   3.460884582522368*^9, 3.4608846120265217`*^9}, 3.4608846683227043`*^9, {
   3.460884830077977*^9, 3.46088489660178*^9}, {3.460888708916758*^9, 
   3.460888733443715*^9}, 3.460888857374319*^9, 3.460889348847591*^9, 
   3.46088941044028*^9, 3.460889926088251*^9, 3.460890038615594*^9, {
   3.4608901161774*^9, 3.460890159674868*^9}, 3.460890191459124*^9, {
   3.4608902705254993`*^9, 3.460890308461899*^9}, {3.460890431792459*^9, 
   3.460890451396481*^9}, {3.460890488285193*^9, 3.460890504385693*^9}, {
   3.460890552139698*^9, 3.4608905888481092`*^9}, {3.460891455286799*^9, 
   3.460891472150818*^9}, {3.460891584175662*^9, 3.460891622476602*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"pp", "=", "0"}], ";", 
   RowBox[{"IndividualLikNonlin", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Y1", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
     RowBox[{"{", 
      RowBox[{"IdioNonlin", ",", 
       RowBox[{"{", "}"}], ",", "m", ",", 
       RowBox[{"eps", "=", 
        RowBox[{"10.", "^", 
         RowBox[{"-", "12"}]}]}], ",", 
       RowBox[{"ksigma", "=", "Infinity"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Singular", "=", "False"}], ",", 
       RowBox[{"2", "Pi"}], " ", ",", "0", ",", 
       RowBox[{"onlyNorKorr", "=", "1"}], ",", "\"\<NorKorr\>\""}], "}"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.460264864897327*^9, 3.460264932378791*^9}, {
   3.460265489300803*^9, 3.460265492492799*^9}, {3.46027038606568*^9, 
   3.460270391802556*^9}, {3.4602704971596107`*^9, 3.4602705817118692`*^9}, {
   3.46027367414145*^9, 3.460273674236417*^9}, {3.460279775378045*^9, 
   3.4602797754444103`*^9}, {3.4602799530257587`*^9, 
   3.4602799533811693`*^9}, {3.460280067013379*^9, 3.460280067130088*^9}, {
   3.4602801040742397`*^9, 3.460280104129944*^9}, {3.4602801453821163`*^9, 
   3.4602801673531218`*^9}, {3.46028174693688*^9, 3.460281763776168*^9}, {
   3.4602818356559362`*^9, 3.460281835739462*^9}, {3.460281898670804*^9, 
   3.460281898732609*^9}, {3.460282025318959*^9, 3.460282025741701*^9}, {
   3.460282062175247*^9, 3.460282071535883*^9}, {3.460283778391947*^9, 
   3.4602837888805027`*^9}, {3.4602838305963707`*^9, 3.460283854615387*^9}, {
   3.46028477341341*^9, 3.460284779157151*^9}, {3.460285035206752*^9, 
   3.460285046973556*^9}, {3.46028555906642*^9, 3.460285574425418*^9}, {
   3.4602857519094887`*^9, 3.4602857519715776`*^9}, {3.460285881590439*^9, 
   3.4602858816380377`*^9}, {3.460286117999454*^9, 3.460286123654068*^9}, {
   3.4602863340289307`*^9, 3.4602863377475977`*^9}, {3.4603641927287188`*^9, 
   3.460364197580667*^9}, {3.460365058304535*^9, 3.4603650587979116`*^9}, {
   3.460365091217347*^9, 3.460365126318194*^9}, {3.4603652464521227`*^9, 
   3.460365260029804*^9}, {3.460365412299954*^9, 3.460365434375272*^9}, {
   3.460365485584791*^9, 3.460365520950554*^9}, {3.460366663535665*^9, 
   3.460366678997499*^9}, {3.4603667867732773`*^9, 3.4603667868283587`*^9}, {
   3.460367092714067*^9, 3.460367098883337*^9}, {3.460369235357655*^9, 
   3.460369263924768*^9}, {3.460369362646221*^9, 3.46036936313859*^9}, {
   3.46036946785526*^9, 3.4603694691077127`*^9}, {3.46037339069245*^9, 
   3.460373390747698*^9}, {3.460373605599341*^9, 3.4603736056503153`*^9}, {
   3.460377091108459*^9, 3.460377126962656*^9}, {3.460377288435691*^9, 
   3.460377301095058*^9}, {3.4603774697122087`*^9, 3.460377479788327*^9}, {
   3.460377585320611*^9, 3.460377603716568*^9}, {3.4603776957101793`*^9, 
   3.460377736561165*^9}, {3.460377923292104*^9, 3.4603779233524303`*^9}, {
   3.460378105932313*^9, 3.46037817981962*^9}, {3.460427531315346*^9, 
   3.460427537420005*^9}, {3.460427638978484*^9, 3.4604276390230217`*^9}, {
   3.4604277414332314`*^9, 3.460427769573126*^9}, {3.4604279604982853`*^9, 
   3.460427960554902*^9}, {3.460430680071252*^9, 3.460430680172152*^9}, {
   3.460430712203142*^9, 3.460430712557424*^9}, {3.460430775931464*^9, 
   3.460430776020101*^9}, {3.460430814349124*^9, 3.460430814950081*^9}, {
   3.46043100067663*^9, 3.460431000775926*^9}, {3.460431035518139*^9, 
   3.460431043615539*^9}, {3.460431139283386*^9, 3.460431139330926*^9}, {
   3.4604311987514153`*^9, 3.460431233744923*^9}, {3.460431314274002*^9, 
   3.460431314321568*^9}, {3.4604316727142878`*^9, 3.4604316728008432`*^9}, {
   3.460431886035831*^9, 3.46043189177104*^9}, {3.460432099991972*^9, 
   3.460432100073539*^9}, {3.460432236204804*^9, 3.4604322362468243`*^9}, {
   3.4604323376555843`*^9, 3.460432357162323*^9}, {3.460432403219545*^9, 
   3.460432403269651*^9}, {3.460432564446265*^9, 3.4604325911495867`*^9}, {
   3.460432813689516*^9, 3.460432813733564*^9}, {3.460432944239506*^9, 
   3.460432989199974*^9}, {3.460433097024789*^9, 3.460433097139295*^9}, {
   3.460433291653358*^9, 3.46043329173923*^9}, {3.460433672964451*^9, 
   3.460433673010107*^9}, {3.460433845665332*^9, 3.4604338457416363`*^9}, {
   3.4604344009903316`*^9, 3.460434401033557*^9}, {3.4604346235115023`*^9, 
   3.460434638473834*^9}, {3.460434675871023*^9, 3.460434675925946*^9}, {
   3.4604350413113747`*^9, 3.4604350414069347`*^9}, {3.460436666989565*^9, 
   3.460436677468376*^9}, {3.460437023691847*^9, 3.460437023772811*^9}, {
   3.460437179838045*^9, 3.460437214787621*^9}, {3.4604373750456057`*^9, 
   3.460437375101828*^9}, {3.460437455923118*^9, 3.4604374559862347`*^9}, {
   3.460437643282413*^9, 3.4604376433404827`*^9}, {3.460439284564681*^9, 
   3.46043929340877*^9}, {3.460439393566842*^9, 3.460439393962884*^9}, {
   3.46044000098571*^9, 3.460440001044331*^9}, {3.460443930270521*^9, 
   3.460443930334333*^9}, {3.460443966799687*^9, 3.46044399790462*^9}, {
   3.460444060284606*^9, 3.460444061730588*^9}, {3.460444101336812*^9, 
   3.46044410138903*^9}, {3.460444186536171*^9, 3.460444194286351*^9}, {
   3.460444233408099*^9, 3.460444248920389*^9}, {3.460444338058318*^9, 
   3.460444355662019*^9}, {3.460444400012597*^9, 3.460444431012135*^9}, {
   3.460444591036777*^9, 3.4604446631572647`*^9}, {3.46044479971354*^9, 
   3.460444799768903*^9}, {3.460444831583193*^9, 3.460444859781989*^9}, {
   3.46044502143334*^9, 3.460445021504759*^9}, {3.460459950502769*^9, 
   3.460459971711813*^9}, {3.460460068419449*^9, 3.460460088588605*^9}, {
   3.460460154598343*^9, 3.46046015516997*^9}, {3.460460281436612*^9, 
   3.460460281521656*^9}, {3.4604604120265713`*^9, 3.460460412125514*^9}, {
   3.4604607607833633`*^9, 3.4604607621971283`*^9}, {3.460460826677142*^9, 
   3.460460827186878*^9}, {3.4604608962826014`*^9, 3.4604608963501987`*^9}, {
   3.460460962965583*^9, 3.460460963358262*^9}, {3.46046100555375*^9, 
   3.4604610220017967`*^9}, {3.46046105589403*^9, 3.460461056004932*^9}, {
   3.460461154113535*^9, 3.460461154227416*^9}, {3.460461800671767*^9, 
   3.4604618154025*^9}, {3.46046184541817*^9, 3.46046186011173*^9}, {
   3.460461896620476*^9, 3.460461896672694*^9}, {3.460461952952413*^9, 
   3.4604619533933907`*^9}, {3.460462913572587*^9, 3.460462920740217*^9}, {
   3.460548175219633*^9, 3.460548179294363*^9}, {3.460548260239588*^9, 
   3.460548260297719*^9}, {3.460548333262265*^9, 3.460548333779482*^9}, {
   3.460548675566861*^9, 3.460548693804049*^9}, {3.460548972449188*^9, 
   3.4605491929429903`*^9}, {3.460549257251377*^9, 3.460549267901092*^9}, {
   3.4605496024993763`*^9, 3.4605496337333307`*^9}, {3.460549667762332*^9, 
   3.46054966825324*^9}, {3.460607544492757*^9, 3.460607557468165*^9}, {
   3.460607591423718*^9, 3.460607615734179*^9}, {3.4606076546131697`*^9, 
   3.460607711208377*^9}, {3.460607950300333*^9, 3.460607950788868*^9}, {
   3.460608254691515*^9, 3.460608332544549*^9}, {3.460608365633368*^9, 
   3.4606083656943207`*^9}, {3.460608434510606*^9, 3.460608528562172*^9}, {
   3.460608559009796*^9, 3.460608584467407*^9}, {3.460608755712895*^9, 
   3.4606087818086443`*^9}, {3.460608915820417*^9, 3.46060895109648*^9}, {
   3.4606090353514013`*^9, 3.460609089338924*^9}, {3.460619799153166*^9, 
   3.4606198362306223`*^9}, 3.460619905423987*^9, {3.460621024814104*^9, 
   3.460621075759169*^9}, {3.460621192179472*^9, 3.4606212134045153`*^9}, {
   3.4606214203824053`*^9, 3.460621428920328*^9}, {3.4606215045280933`*^9, 
   3.460621505423924*^9}, {3.460621613387906*^9, 3.460621638578682*^9}, {
   3.460621694074709*^9, 3.460621703411603*^9}, {3.4606217660430403`*^9, 
   3.460621767329904*^9}, {3.460621806996888*^9, 3.4606218076980343`*^9}, {
   3.460621883288566*^9, 3.46062188333815*^9}, {3.460621970939987*^9, 
   3.4606219893319883`*^9}, {3.460622107014687*^9, 3.460622107100986*^9}, {
   3.460622297972288*^9, 3.460622306665023*^9}, {3.460622338760532*^9, 
   3.460622398767516*^9}, {3.460622676496147*^9, 3.4606226765399942`*^9}, {
   3.4606227120282917`*^9, 3.460622766881015*^9}, {3.4606229263578787`*^9, 
   3.460622944163636*^9}, {3.4606229791390038`*^9, 3.460622982600178*^9}, {
   3.4606230423052397`*^9, 3.460623049675028*^9}, {3.4606231523155127`*^9, 
   3.460623159744812*^9}, {3.460623194195408*^9, 3.460623258120954*^9}, {
   3.460687849143656*^9, 3.460687889401013*^9}, {3.460690081391994*^9, 
   3.460690099337471*^9}, {3.460690130038103*^9, 3.46069013008521*^9}, 
   3.4606902754485703`*^9, {3.4606937256675873`*^9, 3.460693732963479*^9}, {
   3.46069380256997*^9, 3.460693821921266*^9}, {3.460694110007152*^9, 
   3.460694111753396*^9}, {3.46069438482207*^9, 3.460694412630849*^9}, {
   3.460700373473871*^9, 3.46070038225313*^9}, {3.460700651313466*^9, 
   3.460700661253717*^9}, {3.460888878230307*^9, 3.460888934701251*^9}, {
   3.460888985458818*^9, 3.460888985528965*^9}, 3.460889017477508*^9, {
   3.460889075042487*^9, 3.460889076981966*^9}, {3.46088929895837*^9, 
   3.460889299290349*^9}}],

Cell[BoxData[
 RowBox[{"-", "2.222377720560364`"}]], "Output",
 CellChangeTimes->{{3.460888884820653*^9, 3.460888935898259*^9}, 
   3.460888987025817*^9, 3.460889017894083*^9, {3.460889072159395*^9, 
   3.460889078345962*^9}, {3.460889294360515*^9, 3.460889300116984*^9}, 
   3.460890179590364*^9, 3.460891487441186*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"IndividualLik", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Y", ",", "X", ",", "miss"}], "}"}], ",", "Theta", ",", 
    RowBox[{"{", 
     RowBox[{"Idio", ",", 
      RowBox[{"{", "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Singular", "=", "False"}], ",", 
      RowBox[{"2", "Pi"}], " ", ",", "0"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.460264864897327*^9, 3.460264932378791*^9}, {
   3.460265489300803*^9, 3.460265492492799*^9}, {3.46027038606568*^9, 
   3.460270391802556*^9}, {3.4602704971596107`*^9, 3.4602705817118692`*^9}, {
   3.46027367414145*^9, 3.460273674236417*^9}, {3.460279775378045*^9, 
   3.4602797754444103`*^9}, {3.4602799530257587`*^9, 
   3.4602799533811693`*^9}, {3.460280067013379*^9, 3.460280067130088*^9}, {
   3.4602801040742397`*^9, 3.460280104129944*^9}, {3.4602801453821163`*^9, 
   3.4602801673531218`*^9}, {3.46028174693688*^9, 3.460281763776168*^9}, {
   3.4602818356559362`*^9, 3.460281835739462*^9}, {3.460281898670804*^9, 
   3.460281898732609*^9}, {3.460282025318959*^9, 3.460282025741701*^9}, {
   3.460282062175247*^9, 3.460282071535883*^9}, {3.460283778391947*^9, 
   3.4602837888805027`*^9}, {3.4602838305963707`*^9, 3.460283854615387*^9}, {
   3.46028477341341*^9, 3.460284779157151*^9}, {3.460285035206752*^9, 
   3.460285046973556*^9}, {3.46028555906642*^9, 3.460285574425418*^9}, {
   3.4602857519094887`*^9, 3.4602857519715776`*^9}, {3.460285881590439*^9, 
   3.4602858816380377`*^9}, {3.460286117999454*^9, 3.460286123654068*^9}, {
   3.4602863340289307`*^9, 3.4602863377475977`*^9}, {3.4603641927287188`*^9, 
   3.460364197580667*^9}, {3.460365058304535*^9, 3.4603650587979116`*^9}, {
   3.460365091217347*^9, 3.460365126318194*^9}, {3.4603652464521227`*^9, 
   3.460365260029804*^9}, {3.460365412299954*^9, 3.460365434375272*^9}, {
   3.460365485584791*^9, 3.460365520950554*^9}, {3.460366663535665*^9, 
   3.460366678997499*^9}, {3.4603667867732773`*^9, 3.4603667868283587`*^9}, {
   3.460367092714067*^9, 3.460367098883337*^9}, {3.460369235357655*^9, 
   3.460369263924768*^9}, {3.460369362646221*^9, 3.46036936313859*^9}, {
   3.46036946785526*^9, 3.4603694691077127`*^9}, {3.46037339069245*^9, 
   3.460373390747698*^9}, {3.460373605599341*^9, 3.4603736056503153`*^9}, {
   3.460377091108459*^9, 3.460377126962656*^9}, {3.460377288435691*^9, 
   3.460377301095058*^9}, {3.4603774697122087`*^9, 3.460377479788327*^9}, {
   3.460377585320611*^9, 3.460377603716568*^9}, {3.4603776957101793`*^9, 
   3.460377736561165*^9}, {3.460377923292104*^9, 3.4603779233524303`*^9}, {
   3.460378105932313*^9, 3.46037817981962*^9}, {3.460427531315346*^9, 
   3.460427537420005*^9}, {3.460427638978484*^9, 3.4604276390230217`*^9}, {
   3.4604277414332314`*^9, 3.460427769573126*^9}, {3.4604279604982853`*^9, 
   3.460427960554902*^9}, {3.460430680071252*^9, 3.460430680172152*^9}, {
   3.460430712203142*^9, 3.460430712557424*^9}, {3.460430775931464*^9, 
   3.460430776020101*^9}, {3.460430814349124*^9, 3.460430814950081*^9}, {
   3.46043100067663*^9, 3.460431000775926*^9}, {3.460431035518139*^9, 
   3.460431043615539*^9}, {3.460431139283386*^9, 3.460431139330926*^9}, {
   3.4604311987514153`*^9, 3.460431233744923*^9}, {3.460431314274002*^9, 
   3.460431314321568*^9}, {3.4604316727142878`*^9, 3.4604316728008432`*^9}, {
   3.460431886035831*^9, 3.46043189177104*^9}, {3.460432099991972*^9, 
   3.460432100073539*^9}, {3.460432236204804*^9, 3.4604322362468243`*^9}, {
   3.4604323376555843`*^9, 3.460432357162323*^9}, {3.460432403219545*^9, 
   3.460432403269651*^9}, {3.460432564446265*^9, 3.4604325911495867`*^9}, {
   3.460432813689516*^9, 3.460432813733564*^9}, {3.460432944239506*^9, 
   3.460432989199974*^9}, {3.460433097024789*^9, 3.460433097139295*^9}, {
   3.460433291653358*^9, 3.46043329173923*^9}, {3.460433672964451*^9, 
   3.460433673010107*^9}, {3.460433845665332*^9, 3.4604338457416363`*^9}, {
   3.4604344009903316`*^9, 3.460434401033557*^9}, {3.4604346235115023`*^9, 
   3.460434638473834*^9}, {3.460434675871023*^9, 3.460434675925946*^9}, {
   3.4604350413113747`*^9, 3.4604350414069347`*^9}, {3.460436666989565*^9, 
   3.460436677468376*^9}, {3.460437023691847*^9, 3.460437023772811*^9}, {
   3.460437179838045*^9, 3.460437214787621*^9}, {3.4604373750456057`*^9, 
   3.460437375101828*^9}, {3.460437455923118*^9, 3.4604374559862347`*^9}, {
   3.460437643282413*^9, 3.4604376433404827`*^9}, {3.460439284564681*^9, 
   3.46043929340877*^9}, {3.460439393566842*^9, 3.460439393962884*^9}, {
   3.46044000098571*^9, 3.460440001044331*^9}, {3.460443930270521*^9, 
   3.460443930334333*^9}, {3.460443966799687*^9, 3.46044399790462*^9}, {
   3.460444060284606*^9, 3.460444061730588*^9}, {3.460444101336812*^9, 
   3.46044410138903*^9}, {3.460444186536171*^9, 3.460444194286351*^9}, {
   3.460444233408099*^9, 3.460444248920389*^9}, {3.460444338058318*^9, 
   3.460444355662019*^9}, {3.460444400012597*^9, 3.460444431012135*^9}, {
   3.460444591036777*^9, 3.4604446631572647`*^9}, {3.46044479971354*^9, 
   3.460444799768903*^9}, {3.460444831583193*^9, 3.460444859781989*^9}, {
   3.46044502143334*^9, 3.460445021504759*^9}, {3.460459950502769*^9, 
   3.460459971711813*^9}, {3.460460068419449*^9, 3.460460088588605*^9}, {
   3.460460154598343*^9, 3.46046015516997*^9}, {3.460460281436612*^9, 
   3.460460281521656*^9}, {3.4604604120265713`*^9, 3.460460412125514*^9}, {
   3.4604607607833633`*^9, 3.4604607621971283`*^9}, {3.460460826677142*^9, 
   3.460460827186878*^9}, {3.4604608962826014`*^9, 3.4604608963501987`*^9}, {
   3.460460962965583*^9, 3.460460963358262*^9}, {3.46046100555375*^9, 
   3.4604610220017967`*^9}, {3.46046105589403*^9, 3.460461056004932*^9}, {
   3.460461154113535*^9, 3.460461154227416*^9}, {3.460461800671767*^9, 
   3.4604618154025*^9}, {3.46046184541817*^9, 3.46046186011173*^9}, {
   3.460461896620476*^9, 3.460461896672694*^9}, {3.460461952952413*^9, 
   3.4604619533933907`*^9}, {3.460462913572587*^9, 3.460462920740217*^9}, {
   3.460548175219633*^9, 3.460548179294363*^9}, {3.460548260239588*^9, 
   3.460548260297719*^9}, {3.460548333262265*^9, 3.460548333779482*^9}, {
   3.460548675566861*^9, 3.460548693804049*^9}, {3.460548972449188*^9, 
   3.4605491929429903`*^9}, {3.460549257251377*^9, 3.460549267901092*^9}, {
   3.4605496024993763`*^9, 3.4605496337333307`*^9}, {3.460549667762332*^9, 
   3.46054966825324*^9}, {3.460607544492757*^9, 3.460607557468165*^9}, {
   3.460607591423718*^9, 3.460607615734179*^9}, {3.4606076546131697`*^9, 
   3.460607711208377*^9}, {3.460607950300333*^9, 3.460607950788868*^9}, {
   3.460608254691515*^9, 3.460608332544549*^9}, {3.460608365633368*^9, 
   3.4606083656943207`*^9}, {3.460608434510606*^9, 3.460608528562172*^9}, {
   3.460608559009796*^9, 3.460608584467407*^9}, {3.460608755712895*^9, 
   3.4606087818086443`*^9}, {3.460608915820417*^9, 3.46060895109648*^9}, {
   3.4606090353514013`*^9, 3.460609089338924*^9}, {3.460619799153166*^9, 
   3.4606198362306223`*^9}, 3.460619905423987*^9, {3.460621024814104*^9, 
   3.460621075759169*^9}, {3.460621192179472*^9, 3.4606212134045153`*^9}, {
   3.4606214203824053`*^9, 3.460621428920328*^9}, {3.4606215045280933`*^9, 
   3.460621505423924*^9}, {3.460621613387906*^9, 3.460621638578682*^9}, {
   3.460621694074709*^9, 3.460621703411603*^9}, {3.4606217660430403`*^9, 
   3.460621767329904*^9}, {3.460621806996888*^9, 3.4606218076980343`*^9}, {
   3.460621883288566*^9, 3.46062188333815*^9}, {3.460621970939987*^9, 
   3.4606219893319883`*^9}, {3.460622107014687*^9, 3.460622107100986*^9}, {
   3.460622297972288*^9, 3.460622306665023*^9}, {3.460622338760532*^9, 
   3.460622398767516*^9}, {3.460622676496147*^9, 3.4606226765399942`*^9}, {
   3.4606227120282917`*^9, 3.460622766881015*^9}, {3.4606229263578787`*^9, 
   3.460622944163636*^9}, {3.4606229791390038`*^9, 3.460622982600178*^9}, {
   3.4606230423052397`*^9, 3.460623049675028*^9}, {3.4606231523155127`*^9, 
   3.460623159744812*^9}, {3.460623194195408*^9, 3.460623258120954*^9}, {
   3.460687849143656*^9, 3.460687889401013*^9}, {3.460690081391994*^9, 
   3.460690099337471*^9}, {3.460690130038103*^9, 3.46069013008521*^9}, 
   3.4606902754485703`*^9, {3.4606937256675873`*^9, 3.460693732963479*^9}, {
   3.46069380256997*^9, 3.460693821921266*^9}, {3.460694110007152*^9, 
   3.460694111753396*^9}, {3.46069438482207*^9, 3.460694412630849*^9}, {
   3.460700373473871*^9, 3.46070038225313*^9}, {3.460700651313466*^9, 
   3.460700661253717*^9}, 3.460888878230307*^9}],

Cell[BoxData[
 RowBox[{"-", "0.924740282950158`"}]], "Output",
 CellChangeTimes->{3.460699071134611*^9, 3.460700383202607*^9, 
  3.46070066241743*^9, 3.460701489362689*^9, 3.460702904308734*^9, 
  3.460712642396553*^9, 3.460716687888165*^9, 3.460718166989811*^9, 
  3.4608887391818447`*^9, 3.460888849886539*^9, 3.460888880867415*^9, 
  3.460889307315928*^9, 3.460891489227569*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Y1", "=", 
   RowBox[{"{", 
    RowBox[{"{", "2", "}"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"l0", " ", "=", " ", 
   RowBox[{
    RowBox[{"IndividualLikNonlin", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Y1", ",", " ", "X", ",", " ", 
        RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
      RowBox[{"{", 
       RowBox[{"IdioNonlin", ",", " ", 
        RowBox[{"{", "}"}], ",", " ", "#1", ",", " ", 
        RowBox[{"eps", " ", "=", " ", 
         RowBox[{"1", "/", 
          RowBox[{"10.", "^", "16"}]}]}], ",", " ", 
        RowBox[{"ksigma", " ", "=", " ", "Infinity"}], ",", " ", "0"}], "}"}],
       ",", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
        RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
        RowBox[{"onlyNorKorr", " ", "=", " ", "0"}], ",", " ", 
        "\"\<NorKorr\>\"", ",", "0"}], "}"}]}], "]"}], " ", "&"}]}], " ", 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"l1", " ", "=", " ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y1", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", " ", "#1", ",", " ", 
         RowBox[{"eps", " ", "=", " ", 
          RowBox[{"1", "/", 
           RowBox[{"10.", "^", "16"}]}]}], ",", " ", 
         RowBox[{"ksigma", " ", "=", " ", "Infinity"}], ",", " ", "0"}], 
        "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "0"}], ",", " ", 
         "\"\<StochLin\>\"", ",", "0"}], "}"}]}], "]"}], " ", "&"}]}], " ", 
   ";"}], " "}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"l2", " ", "=", " ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y1", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", " ", "#1", ",", " ", 
         RowBox[{"eps", " ", "=", " ", 
          RowBox[{"1", "/", 
           RowBox[{"10.", "^", "16"}]}]}], ",", " ", 
         RowBox[{"ksigma", " ", "=", " ", "Infinity"}], ",", " ", "0"}], 
        "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "0"}], ",", " ", "\"\<EKF\>\"",
          ",", "0"}], "}"}]}], "]"}], " ", "&"}]}], " ", ";"}], " ", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"l0lin", " ", "=", " ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y1", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", " ", "#1", ",", " ", 
         RowBox[{"eps", " ", "=", " ", 
          RowBox[{"1", "/", 
           RowBox[{"10.", "^", "16"}]}]}], ",", " ", 
         RowBox[{"ksigma", " ", "=", " ", "Infinity"}], ",", " ", "0"}], 
        "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "1"}], ",", " ", 
         "\"\<NorKorr\>\""}], "}"}]}], "]"}], " ", "&"}]}], " ", ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"l1lin", " ", "=", " ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y1", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", " ", "#1", ",", " ", 
         RowBox[{"eps", " ", "=", " ", 
          RowBox[{"1", "/", 
           RowBox[{"10.", "^", "16"}]}]}], ",", " ", 
         RowBox[{"ksigma", " ", "=", " ", "Infinity"}], ",", " ", "0"}], 
        "}"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "1"}], ",", " ", 
         "\"\<StochLin\>\""}], "}"}]}], "]"}], " ", "&"}]}], " ", ";"}], 
  " "}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"l2lin", " ", "=", "  ", 
    RowBox[{
     RowBox[{"IndividualLikNonlin", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Y1", ",", " ", "X", ",", " ", 
         RowBox[{"-", "9"}]}], "}"}], ",", " ", "Theta", ",", " ", 
       RowBox[{"{", 
        RowBox[{"IdioNonlin", ",", " ", 
         RowBox[{"{", "}"}], ",", " ", "#1", ",", " ", 
         RowBox[{"eps", " ", "=", " ", 
          RowBox[{"1", "/", 
           RowBox[{"10.", "^", "16"}]}]}], ",", " ", 
         RowBox[{"ksigma", " ", "=", " ", "Infinity"}], ",", " ", "0"}], 
        "}"}], ",", "   ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Singular", " ", "=", " ", "False"}], ",", " ", 
         RowBox[{"2", "*", "Pi"}], ",", " ", "0", ",", " ", 
         RowBox[{"onlyNorKorr", " ", "=", " ", "1"}], ",", " ", 
         "\"\<EKF\>\""}], "}"}]}], "]"}], " ", "&"}]}], " ", ";"}], 
  " "}]}], "Input",
 CellChangeTimes->{{3.460866690417755*^9, 3.4608666908088093`*^9}, {
  3.46086676290909*^9, 3.4608667899620447`*^9}, {3.460866822738378*^9, 
  3.460866870907132*^9}, {3.460866934606393*^9, 3.460867079046795*^9}, {
  3.460867138617878*^9, 3.460867138676441*^9}, {3.460867208773748*^9, 
  3.4608672094046373`*^9}, {3.460867252883388*^9, 3.460867347526499*^9}, {
  3.460867394413104*^9, 3.460867395652351*^9}, {3.460887846023217*^9, 
  3.460887849741935*^9}, {3.4608897367048473`*^9, 3.4608897379260893`*^9}, {
  3.460889769763714*^9, 3.460889769844699*^9}, {3.460890600335511*^9, 
  3.4608906004235477`*^9}, {3.460892262623529*^9, 3.460892262709601*^9}, {
  3.4608926938988523`*^9, 3.460892694695682*^9}, {3.460892740847497*^9, 
  3.460892742207755*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pp", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"l0", "[", "10", "]"}], "\[IndentingNewLine]", 
 RowBox[{"l1", "[", "10", "]"}]}], "Input",
 CellChangeTimes->{{3.460282153080297*^9, 3.460282158488613*^9}, {
   3.460282193092895*^9, 3.460282220935027*^9}, {3.460282308500825*^9, 
   3.4602823085625467`*^9}, {3.460283195676051*^9, 3.460283196336207*^9}, {
   3.4603662815649853`*^9, 3.460366282970312*^9}, {3.460698345525057*^9, 
   3.460698345602466*^9}, {3.4606984667172117`*^9, 3.460698470379286*^9}, {
   3.460698596520487*^9, 3.460698604587326*^9}, {3.460698866050302*^9, 
   3.46069888194167*^9}, {3.4606991271651297`*^9, 3.460699135538176*^9}, {
   3.460699290645143*^9, 3.4606992926163483`*^9}, {3.460699354347168*^9, 
   3.460699355452443*^9}, {3.4606994671451*^9, 3.46069947483103*^9}, {
   3.460717000907537*^9, 3.460717010074459*^9}, {3.460717065524967*^9, 
   3.4607170967251673`*^9}, {3.460887902590397*^9, 3.460887902644988*^9}, {
   3.4608881369566307`*^9, 3.4608881372655354`*^9}, {3.460888181067945*^9, 
   3.460888181131031*^9}, {3.460888226686762*^9, 3.460888243970805*^9}, {
   3.460888495544488*^9, 3.46088849618258*^9}, {3.4608885730818577`*^9, 
   3.460888585520844*^9}, {3.46088941975488*^9, 3.46088942025782*^9}, {
   3.460890617516852*^9, 3.460890633304941*^9}, 3.460891521857493*^9}],

Cell[BoxData[
 RowBox[{"-", "0.6367436572460381`"}]], "Output",
 CellChangeTimes->{
  3.4602821586290083`*^9, {3.460282194672504*^9, 3.460282221034252*^9}, {
   3.460282304124085*^9, 3.4602823096094847`*^9}, 3.460282367700007*^9, 
   3.4602826444891653`*^9, {3.460283191195128*^9, 3.460283196443349*^9}, 
   3.460283538479665*^9, 3.4602841996563187`*^9, 3.460284409519916*^9, 
   3.460364431619211*^9, {3.4603662767860107`*^9, 3.460366326918507*^9}, 
   3.460367142375352*^9, 3.460369509450536*^9, 3.460435649149485*^9, 
   3.460439471087428*^9, 3.460440271569412*^9, 3.460548292309108*^9, {
   3.4606980666425333`*^9, 3.460698116411084*^9}, 3.460698199230464*^9, {
   3.460698342895336*^9, 3.460698347089931*^9}, 3.460698387658757*^9, {
   3.460698464476142*^9, 3.460698471121516*^9}, {3.4606985974210863`*^9, 
   3.460698605644109*^9}, 3.4606986715579033`*^9, {3.4606988664647093`*^9, 
   3.460698885285829*^9}, 3.4606989539947653`*^9, 3.460699091679224*^9, {
   3.460699128326627*^9, 3.460699136744446*^9}, {3.4606992844926853`*^9, 
   3.4606992930867147`*^9}, 3.4606993563387203`*^9, 3.460699395066133*^9, {
   3.46069946832483*^9, 3.460699475642068*^9}, 3.460700396741952*^9, 
   3.460700670871602*^9, 3.4607014955117397`*^9, 3.460701686286664*^9, 
   3.4607029778271503`*^9, 3.4607045343296432`*^9, 3.460704583786036*^9, 
   3.460705006337816*^9, 3.460712648456737*^9, 3.4607130758606462`*^9, 
   3.460713922767914*^9, 3.460714216772244*^9, 3.460714335040298*^9, 
   3.460715094807499*^9, {3.460715236127408*^9, 3.4607152417533503`*^9}, 
   3.460715272166308*^9, 3.460715931802145*^9, 3.460715996563827*^9, 
   3.460716286449524*^9, 3.460716577625821*^9, 3.46071669162184*^9, {
   3.46071681976187*^9, 3.460716834028303*^9}, {3.4607170060678062`*^9, 
   3.460717100708589*^9}, 3.460717933975918*^9, 3.460718170891859*^9, 
   3.460866634064*^9, 3.460866671610235*^9, 3.460866712097299*^9, {
   3.460866771793648*^9, 3.460866793641797*^9}, 3.4608668370874767`*^9, 
   3.4608671410558577`*^9, 3.4608672137641582`*^9, 3.460867399901455*^9, 
   3.4608878519656687`*^9, {3.460887896605866*^9, 3.4608879047948008`*^9}, 
   3.460888055897314*^9, {3.4608881256499443`*^9, 3.460888139371533*^9}, {
   3.4608881769852877`*^9, 3.4608881823439074`*^9}, {3.4608882281854486`*^9, 
   3.4608882453075047`*^9}, 3.460888325464295*^9, 3.460888416931632*^9, 
   3.460888497637518*^9, {3.4608885739449387`*^9, 3.46088858640056*^9}, 
   3.460888622838238*^9, 3.460889420873407*^9, 3.4608897416678677`*^9, 
   3.460889773343731*^9, {3.46089060421344*^9, 3.460890633917891*^9}, 
   3.460891523335093*^9, 3.46089226587453*^9}],

Cell[BoxData[
 RowBox[{"-", "0.5598056511078544`"}]], "Output",
 CellChangeTimes->{
  3.4602821586290083`*^9, {3.460282194672504*^9, 3.460282221034252*^9}, {
   3.460282304124085*^9, 3.4602823096094847`*^9}, 3.460282367700007*^9, 
   3.4602826444891653`*^9, {3.460283191195128*^9, 3.460283196443349*^9}, 
   3.460283538479665*^9, 3.4602841996563187`*^9, 3.460284409519916*^9, 
   3.460364431619211*^9, {3.4603662767860107`*^9, 3.460366326918507*^9}, 
   3.460367142375352*^9, 3.460369509450536*^9, 3.460435649149485*^9, 
   3.460439471087428*^9, 3.460440271569412*^9, 3.460548292309108*^9, {
   3.4606980666425333`*^9, 3.460698116411084*^9}, 3.460698199230464*^9, {
   3.460698342895336*^9, 3.460698347089931*^9}, 3.460698387658757*^9, {
   3.460698464476142*^9, 3.460698471121516*^9}, {3.4606985974210863`*^9, 
   3.460698605644109*^9}, 3.4606986715579033`*^9, {3.4606988664647093`*^9, 
   3.460698885285829*^9}, 3.4606989539947653`*^9, 3.460699091679224*^9, {
   3.460699128326627*^9, 3.460699136744446*^9}, {3.4606992844926853`*^9, 
   3.4606992930867147`*^9}, 3.4606993563387203`*^9, 3.460699395066133*^9, {
   3.46069946832483*^9, 3.460699475642068*^9}, 3.460700396741952*^9, 
   3.460700670871602*^9, 3.4607014955117397`*^9, 3.460701686286664*^9, 
   3.4607029778271503`*^9, 3.4607045343296432`*^9, 3.460704583786036*^9, 
   3.460705006337816*^9, 3.460712648456737*^9, 3.4607130758606462`*^9, 
   3.460713922767914*^9, 3.460714216772244*^9, 3.460714335040298*^9, 
   3.460715094807499*^9, {3.460715236127408*^9, 3.4607152417533503`*^9}, 
   3.460715272166308*^9, 3.460715931802145*^9, 3.460715996563827*^9, 
   3.460716286449524*^9, 3.460716577625821*^9, 3.46071669162184*^9, {
   3.46071681976187*^9, 3.460716834028303*^9}, {3.4607170060678062`*^9, 
   3.460717100708589*^9}, 3.460717933975918*^9, 3.460718170891859*^9, 
   3.460866634064*^9, 3.460866671610235*^9, 3.460866712097299*^9, {
   3.460866771793648*^9, 3.460866793641797*^9}, 3.4608668370874767`*^9, 
   3.4608671410558577`*^9, 3.4608672137641582`*^9, 3.460867399901455*^9, 
   3.4608878519656687`*^9, {3.460887896605866*^9, 3.4608879047948008`*^9}, 
   3.460888055897314*^9, {3.4608881256499443`*^9, 3.460888139371533*^9}, {
   3.4608881769852877`*^9, 3.4608881823439074`*^9}, {3.4608882281854486`*^9, 
   3.4608882453075047`*^9}, 3.460888325464295*^9, 3.460888416931632*^9, 
   3.460888497637518*^9, {3.4608885739449387`*^9, 3.46088858640056*^9}, 
   3.460888622838238*^9, 3.460889420873407*^9, 3.4608897416678677`*^9, 
   3.460889773343731*^9, {3.46089060421344*^9, 3.460890633917891*^9}, 
   3.460891523335093*^9, 3.460892265884111*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"l0", "[", "mm", "]"}], ",", 
          RowBox[{"l1", "[", "mm", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"mm", ",", "2", ",", 
          RowBox[{"M", "=", "100"}]}], "}"}]}], "]"}], "//", 
      RowBox[{
       RowBox[{"AddTimeAxis", "[", 
        RowBox[{"#", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "M", ",", "1"}], "}"}]}], "]"}], "&"}]}], "//", 
     RowBox[{
      RowBox[{"plot1", "[", 
       RowBox[{"#", ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}], "&"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"l0lin", "[", "mm", "]"}], ",", 
          RowBox[{"l1lin", "[", "mm", "]"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"mm", ",", "2", ",", 
          RowBox[{"M", "=", "20"}]}], "}"}]}], "]"}], "//", 
      RowBox[{
       RowBox[{"AddTimeAxis", "[", 
        RowBox[{"#", ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "M", ",", "1"}], "}"}]}], "]"}], "&"}]}], "//", 
     RowBox[{
      RowBox[{"plot1", "[", 
       RowBox[{"#", ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], "&"}]}]}], "}"}], "//",
   "GraphicsRow"}]], "Input",
 CellChangeTimes->{{3.460281783177149*^9, 3.460281824576651*^9}, {
   3.460281910255617*^9, 3.460281943368555*^9}, {3.460281981836998*^9, 
   3.4602819975731277`*^9}, {3.4602820319744387`*^9, 3.460282053018779*^9}, {
   3.460282118996468*^9, 3.460282133562097*^9}, {3.460282239307322*^9, 
   3.460282241400333*^9}, {3.46028239420243*^9, 3.4602824371035967`*^9}, {
   3.460284414532241*^9, 3.4602844151683893`*^9}, {3.460284789442216*^9, 
   3.4602847924493017`*^9}, {3.4603644911795893`*^9, 3.460364500191489*^9}, {
   3.4603695897129087`*^9, 3.460369625240038*^9}, {3.460439520790577*^9, 
   3.46043953878603*^9}, {3.460439576047587*^9, 3.46043961923698*^9}, {
   3.460548309147976*^9, 3.4605483174968367`*^9}, {3.460698218433448*^9, 
   3.4606982189993668`*^9}, {3.46069831865662*^9, 3.46069832472578*^9}, {
   3.4606986846777077`*^9, 3.460698686195219*^9}, {3.460698801081359*^9, 
   3.460698839662919*^9}, 3.4606988983413677`*^9, {3.460699493303959*^9, 
   3.460699521539399*^9}, {3.460703038834033*^9, 3.4607030392870197`*^9}, {
   3.460704537168377*^9, 3.460704565215843*^9}, {3.460704964492584*^9, 
   3.4607049654824247`*^9}, {3.460716586378721*^9, 3.4607165874503813`*^9}, {
   3.460716698553081*^9, 3.460716698621357*^9}, {3.460716874013295*^9, 
   3.4607168854884872`*^9}, {3.460717105177659*^9, 3.460717118490457*^9}, {
   3.460717189751791*^9, 3.460717263423542*^9}, {3.460718184809017*^9, 
   3.460718184886208*^9}, {3.460718268047081*^9, 3.460718284726698*^9}, {
   3.460866726962734*^9, 3.460866746396637*^9}, {3.46086680842523*^9, 
   3.460866814009818*^9}, {3.4608669860584373`*^9, 3.460866986674747*^9}, {
   3.460867125303936*^9, 3.460867126893998*^9}, {3.460890639626153*^9, 
   3.460890679985465*^9}, {3.460891528478506*^9, 3.460891549740889*^9}, {
   3.460892288177647*^9, 3.460892288225799*^9}, {3.46089274669418*^9, 
   3.460892746769897*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{{}, {}, 
        {RGBColor[0, 0, 1], PointSize[0.003], Thickness[0.003], 
         Dashing[{}], {}, 
         {Opacity[1], LineBox[CompressedData["
1:eJw1lA0s3Gccx29eWrMw4nUNiVWnNFpMp0rL10tR9XKO44Rc6FUm1pW1MbpI
/UW9pKOOqhHrctES7cRYTbSsbmbeq0dbtKquXuZOUWNWtpV18XsuuVw++fxf
nuf7/T334clkQYIGj8eTvP3+/0sfSP9pdE+o7WvfRh3E2QbmpSS1eG6zAXLd
dOq++FZN3hiyVsuXy9JlYnNIr63ZGo2MEVvA3iN7R5IxYyu0eRVcNHFZIN4N
aYiTZNZ/kHgPysqEr3LfmSK2wUDRVS+TLHa9LVzTJ3ak3Rsh3oeexiXtv+8o
ie3hWNf5sorfT3wAX13aM/mqdY7YEYqzb2ocstuInaCvahjXKZ0l/hiJGu4x
vy3OEzujM+1LgYfhE+KD8N4hvllYzJ73Cf5VR01N3H5B7AJZRFNvdvQD4kNo
ebBpJ16fJHZF7T3H+DFbtt/DSMwY8ncfekbsBsz3aK+WDBC7Y/kv+6DFRfb+
I2gosuz9qYn1cxTKG5dUj0bZfj2w7lDDFVT3EHuiXDZxIdqPMZCS7ZTNS+/a
Zg6IXXaLq6weJu+F9XmL5zfyVOS9sBn9c05IKjHPG5dfCPamHKb9c95Q3hTv
0jx/n7wPbIrd8iy2KE/OB7zY5MJftNh6fXF3q+OI7+gMeV/kb+z6oUTzIflj
8JBWiCvl0+SPwUJjqcrZZ5y8H/w+821duEPzwflB8dBtv1HUU/L+WDF7Ymre
QX1w/ih//f6SeRLLLwDSP3U0DcdoXrgA2LvqvpuXqCB/HBnDbZOta9QXdxyK
qThhdxrrMxAH63WlB8Kfkw8Ev76qTmzJ+jyBUu0reve7qE/uBAKmN9sL5I/J
B8G3oSxfN5T2wwXBwuS1ZDr1d/LB4E72nUufp/VywcgIVpta/8rmMwTp3W9y
O7+h88SFwODanNLMjPlQ2Ep6vDPzWD6hMF+6G73ox/rlw8o563yEKXnw0RCv
6H7v3BBdz4fj5+pTbTWUn5yPnq7N8v7rLJ8wnN658mOHK3mEQSsZhdp7af1c
GJZv7fc+O0D5ysMw3KxUlhux8yyARlFD/6N48hBApchU7Rtn8yCAcW1xzOwf
lL9cgGY7n15LTXa+wsG7sPpdtTV5hKPU5oOLCTVsXsIhM5uzXxNRP/JwrEua
S85osf+HCAzo6j0eL56g+yMQa2iSmmPK+n7LO4/miAepP3kE+J8m5ISeovXx
hJA9+z4lU588hMiY9FtpCqDncUIkGl/29BBQv3Ih+vQkDuoN9v5I1BlX+JRX
0LwiEhHiylgX0PxzkTgdM1OfP0P9yyPRM2y7emuQ5ReFAWvTfh1n8ojCGe2r
geIM1ncUZJVXHAxyaD7kUZBvuDre/oj1LwJ/IWut9Oko3S8CZ6GfKdpi+YvQ
1GKn/tqZvFwEmdV1we5idr6iwW881KIqGmn/D0aPExY=
           "]]}}}, {{}, {}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.003], Thickness[0.003], 
         Dashing[{}], {}, 
         {Opacity[1], 
          LineBox[{{9.739948574565904, -0.6500194581570693}, {
           10., -0.5598056511078544}, {
           10.090303393378633`, -0.6500194581570693}}], 
          LineBox[{{11.983566466349304`, -0.6500194581570693}, {
           12., -0.6348352286348422}, {13., -0.35993852482538147`}, {
           14., -0.48173077337855674`}, {
           14.480512405333348`, -0.6500194581570693}}], 
          LineBox[CompressedData["
1:eJw1UwtMU2cYvfgIqCSiXTY2wETUWgudOlErKp6C8rK2t+/KqhJY3WAmDFwQ
g8ViKqiQ+JaCDUWHoQ63BYQixmBVEPGxbgtjm7ysopjgHFmsUUNQNv/vJjc3
J+f7zne+8/93bkaO2jyJ4zj9xPvfN1FfUpL16WKklqlO++8OXeX+f5bANS5u
4tofMLwUrnp3+vyfHjH8GbLnzhj0nvQxvAz8seI5mRGEYxCUUWc5GPmQ4eUo
aAsZ6/2Q+BX4Zbt+zt/F/QyvhP1a/5Uo318MSxEsih27fYHmr0Kt93V9i5nq
Y+EJc0Zv/oDqV+PV/uFp9apBhtcAgb8fNlX2MrwW3CcN4cPzSC8O9pHdo5rz
pLcOjtBeQdR24gFTkDLE+2LgPbYCxo99eTmSPsbL0OgTKHKFrN4qg7vWf1gT
T/vF483bZ5KeUuLj0S7ctf9iPtPjEpCdu1ozcxqrtyagacE2s+g8+V+P8IpJ
ll1KNs+6HmMdlahupH02wGaUN53LYP6tG3DJ/fmOHwtJPxGj99p/mPUv8Yng
b5SLvqsm/SSE5E+f3vEn7ZcEV82wrWEl7Z+Mmjb/7IqLrN6ajD2n4s41/0r6
KagSexfaJ9N+KbAJC2J2rCH9VFj9uohXmcSnYk/oiCfAR/xGZI/8I0orJn4j
bp284kj+gs5DjqDC5uHnfxAvR36cOC50G/nbBNO87vRF0ZTfJohEZ1sf1xKv
QFGldXw8lngFjo11KwaeEq+EdK0z2T1E+SrBRZojjlrIH48H3cervy5hfsAj
eNaJJ+UB5IfH0Lo6XveC8R4e1y8cSCuUkb5q4n8xW1ZZWF5QwfOyNevRFupX
QZonCEgbZ7xHhegzzkWtApqvhrwrqepyCsNQY0nb9b0qJZ2nGuUx+vv9lxnv
UcMu5OSmBurXYLY452CzgM2DBqbFLU+6Aum8Ncg73dlQImG8R4OBluONdhX5
1yLEe0/Mb6V+LfpQ+mWOgfxP4EOZZY99LD+PFrFZjkhpMPXrcOkjp3BnGOWn
w2+Tu/jnN6lfh3BzxR2XjfLTAUU193c7yb8eQTMcFYEj1K+H9PvSl0fcdB/1
EDky+h4qKD89wp+68n4uoPtjwDdTr52I3En5GzB6o0Ob20P5GTBFktZT56V+
A1yON5b0bPq/jbDJUld8Jab8jeC0WyVhnXRfjJgiqyqKSqD8jTji/7Yz8xnN
34zQ5VH7ptoHr74D9nfQAw==
           "]]}}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{0, 0},
      DisplayFunction->Identity,
      Frame->True,
      PlotRange->{All, {-1.0353860077118284`, 0.09537413886042279}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, 
        Scaled[0.02]}], {192., -116.80842387373012`}, 
     ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{{}, {}, 
        {RGBColor[0, 0, 1], PointSize[0.003], Thickness[0.003], 
         Dashing[{}], {}, 
         {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBmIQDQUOk1t52WJ9GQ5AuBwOZrXJD+JY2aF8AYdYK0Hd
nBQOKF/EwZvN1pXhAxOUL+FgOGHp1oIHzFC+jIPKPNtLdYd+7YfwFRxOuIUf
Os8MU6/kMGNZY3btf5i8isOqD0a66/gYofJqDld5ljzUW8QF5Ws4+Ce3R2TX
wtyn5bBWYYYQrwJMvY7DjPfb067KweT1HA7GrrsmYs4G5Rs4XD99U4J913+o
fYYOIuc/nbL/zQKVN3JIWiPbdz4SJm/s4Fh/VvVGM4xv4vDIb03wCYH/+wFm
JFLI
           "]]}}}, {{}, {}, 
        {RGBColor[0., 0.980407, 0.6039], PointSize[0.003], Thickness[0.003], 
         Dashing[{}], {}, 
         {Opacity[1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBmIQDQUOk1t52WJ9GQ5AuBwOe9b6qc77yA7lCzi4JQa6
7E7jgPJFHA42MToLHmKG8iUc3kk56c39A+PLOET8yPNYpPx7P4Sv4DD1vJnL
aQsmqLySg5ee/os9KTB5FYcTKgead4QwQuXVHCKeLZwdeIQXytdwuDW9cZ72
eZj7tBzOduk/F4yEmafjIKRw9fm9Cpi8nsPRSLa7u37C3G/gUO7AMFHSFiZv
6LBOyYanrIANyjdyeHf5wop2QZi8sYOtZ56PDNw8E4dpcWZbGR7+3w8AEdRQ
AA==
           "]]}}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      AxesOrigin->{5., -3.},
      DisplayFunction->Identity,
      Frame->True,
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {576., -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}]}, {}},
  ContentSelectable->True,
  ImageSize->{796., Automatic},
  PlotRangePadding->{6, 5}]], "Output",
 CellChangeTimes->{{3.460281797946806*^9, 3.460281825798993*^9}, {
   3.460281904342657*^9, 3.460281945448979*^9}, {3.460281984036024*^9, 
   3.460281999907948*^9}, 3.460282036560417*^9, 3.460282135587686*^9, 
   3.460282242514032*^9, 3.4602823726324577`*^9, {3.460282416693921*^9, 
   3.460282441098826*^9}, 3.4602826518405313`*^9, 3.4602832036099043`*^9, 
   3.4602835481939077`*^9, {3.460284391325081*^9, 3.460284420594182*^9}, 
   3.460284799893792*^9, {3.460364417441619*^9, 3.460364434654419*^9}, {
   3.460364477824107*^9, 3.460364501892661*^9}, 3.460367145808325*^9, 
   3.460369518021393*^9, {3.4603696154135933`*^9, 3.460369627668434*^9}, 
   3.4604356684680777`*^9, 3.460439475436892*^9, 3.4604395415998383`*^9, {
   3.460439582340852*^9, 3.460439621927959*^9}, {3.4604402659294558`*^9, 
   3.46044027553581*^9}, {3.4605482869730167`*^9, 3.46054831765944*^9}, 
   3.460698128820739*^9, {3.4606982007291613`*^9, 3.460698247354405*^9}, 
   3.460698325889138*^9, 3.46069839312781*^9, 3.460698511192573*^9, 
   3.460698688355796*^9, 3.460698803312311*^9, 3.460698840322803*^9, 
   3.460698899193131*^9, 3.460699097328401*^9, {3.4606994876957207`*^9, 
   3.460699522585226*^9}, {3.460700411415139*^9, 3.4607004303196898`*^9}, 
   3.4607006077872477`*^9, 3.460700673410165*^9, 3.460701497746229*^9, 
   3.46070159114614*^9, 3.460702985828713*^9, 3.4607030464194813`*^9, 
   3.460704560161771*^9, 3.4607045931315203`*^9, {3.4607049981244307`*^9, 
   3.460705011400508*^9}, 3.46071265181137*^9, 3.4607130795428762`*^9, 
   3.460713925825474*^9, 3.4607142201264067`*^9, 3.460714273212161*^9, 
   3.4607143495075502`*^9, 3.46071599997359*^9, {3.460716582062931*^9, 
   3.460716588106329*^9}, {3.46071669432895*^9, 3.460716699866613*^9}, 
   3.4607168221764174`*^9, {3.4607168868735*^9, 3.460716913970245*^9}, 
   3.460716959105864*^9, 3.4607170689942093`*^9, {3.460717109732251*^9, 
   3.460717120616603*^9}, {3.4607171942571907`*^9, 3.460717217819908*^9}, 
   3.460717264622147*^9, 3.460717938622671*^9, {3.4607181737444973`*^9, 
   3.460718185942861*^9}, 3.4607182860528383`*^9, 3.4608666840102997`*^9, {
   3.460866716192235*^9, 3.460866875075344*^9}, {3.4608669490308123`*^9, 
   3.460867013792041*^9}, {3.460867045104608*^9, 3.460867090705942*^9}, {
   3.460867129241324*^9, 3.460867143567214*^9}, {3.460867232902383*^9, 
   3.460867312096705*^9}, 3.460867353518095*^9, 3.4608674053107977`*^9, 
   3.4608882382937317`*^9, 3.460889426803895*^9, 3.460889747321299*^9, 
   3.460889778161243*^9, {3.460890661864031*^9, 3.4608906851827793`*^9}, {
   3.460891545627667*^9, 3.460891555725103*^9}, {3.46089225593861*^9, 
   3.460892272844404*^9}, 3.460892323573344*^9, {3.460892733922864*^9, 
   3.4608927523029327`*^9}}]
}, Open  ]],

Cell[TextData[StyleBox["Math7/Intel/ OS X",
 FontColor->RGBColor[1, 0, 0]]], "Text",
 PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"THETA0", "=", "Theta"}], "\n", 
 RowBox[{"F0", "=", 
  RowBox[{"IdentityMatrix", "[", 
   RowBox[{"Length", "[", "THETA0", "]"}], "]"}]}], "\n", 
 RowBox[{"SCALING", "=", "1"}], "\n", 
 RowBox[{"FISHER", "=", "True"}], "\n", 
 RowBox[{"MAXSTEP", "=", "1"}], "\n", 
 RowBox[{"STEPREDUCE", "=", "4"}], "\[IndentingNewLine]", 
 RowBox[{"FDIGITS", "=", "16"}], "\[IndentingNewLine]", 
 RowBox[{"pp", "=", "0"}]}], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.4601143146009274`*^9, 3.460114315759859*^9}, 
   3.460282522110393*^9, {3.460283799592029*^9, 3.4602838013662*^9}, {
   3.4604357137809753`*^9, 3.460435744591599*^9}, {3.460435786839238*^9, 
   3.4604357909828987`*^9}, {3.460435825453755*^9, 3.460435826628525*^9}, {
   3.460435861768526*^9, 3.460435863165637*^9}, {3.460435902549529*^9, 
   3.460435902612645*^9}, {3.460435960264574*^9, 3.460435960325345*^9}, {
   3.460701708750058*^9, 3.4607017099740763`*^9}, {3.460701760363098*^9, 
   3.460701760922386*^9}, {3.46088944348444*^9, 3.460889444497266*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", "0.1`", "}"}]], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460700676314569*^9, 3.4607007346245403`*^9, 3.460701595843239*^9, 
   3.460701653839116*^9, {3.460701689533342*^9, 3.460701710077276*^9}, 
   3.4607017618903503`*^9, 3.4607173158128653`*^9, {3.460889436888294*^9, 
   3.460889445699613*^9}, 3.4608916264329767`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "1", "}"}], "}"}]], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460700676314569*^9, 3.4607007346245403`*^9, 3.460701595843239*^9, 
   3.460701653839116*^9, {3.460701689533342*^9, 3.460701710077276*^9}, 
   3.4607017618903503`*^9, 3.4607173158128653`*^9, {3.460889436888294*^9, 
   3.460889445699613*^9}, 3.4608916264500027`*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460700676314569*^9, 3.4607007346245403`*^9, 3.460701595843239*^9, 
   3.460701653839116*^9, {3.460701689533342*^9, 3.460701710077276*^9}, 
   3.4607017618903503`*^9, 3.4607173158128653`*^9, {3.460889436888294*^9, 
   3.460889445699613*^9}, 3.46089162645572*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460700676314569*^9, 3.4607007346245403`*^9, 3.460701595843239*^9, 
   3.460701653839116*^9, {3.460701689533342*^9, 3.460701710077276*^9}, 
   3.4607017618903503`*^9, 3.4607173158128653`*^9, {3.460889436888294*^9, 
   3.460889445699613*^9}, 3.460891626461504*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460700676314569*^9, 3.4607007346245403`*^9, 3.460701595843239*^9, 
   3.460701653839116*^9, {3.460701689533342*^9, 3.460701710077276*^9}, 
   3.4607017618903503`*^9, 3.4607173158128653`*^9, {3.460889436888294*^9, 
   3.460889445699613*^9}, 3.460891626467161*^9}],

Cell[BoxData["4"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460700676314569*^9, 3.4607007346245403`*^9, 3.460701595843239*^9, 
   3.460701653839116*^9, {3.460701689533342*^9, 3.460701710077276*^9}, 
   3.4607017618903503`*^9, 3.4607173158128653`*^9, {3.460889436888294*^9, 
   3.460889445699613*^9}, 3.46089162650425*^9}],

Cell[BoxData["16"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460700676314569*^9, 3.4607007346245403`*^9, 3.460701595843239*^9, 
   3.460701653839116*^9, {3.460701689533342*^9, 3.460701710077276*^9}, 
   3.4607017618903503`*^9, 3.4607173158128653`*^9, {3.460889436888294*^9, 
   3.460889445699613*^9}, 3.460891626569419*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.460113323020094*^9, 3.46011404625578*^9, 3.460114170109331*^9, 
   3.460114257388714*^9, 3.4601143175730677`*^9, 3.460121001268158*^9, 
   3.460200607083859*^9, 3.4602007904542923`*^9, 3.460201889717943*^9, 
   3.4602648604104147`*^9, 3.460279157774687*^9, 3.4602817293562117`*^9, {
   3.460282522557749*^9, 3.460282543367861*^9}, 3.460282615088135*^9, 
   3.4602832080034637`*^9, 3.4602838014762897`*^9, 3.460367166211542*^9, 
   3.460435686205719*^9, {3.4604357203675623`*^9, 3.460435745697218*^9}, 
   3.460435791109538*^9, 3.4604358336593733`*^9, 3.4604358641132107`*^9, 
   3.460435907026135*^9, 3.460435961185676*^9, 3.460440279873008*^9, 
   3.460700676314569*^9, 3.4607007346245403`*^9, 3.460701595843239*^9, 
   3.460701653839116*^9, {3.460701689533342*^9, 3.460701710077276*^9}, 
   3.4607017618903503`*^9, 3.4607173158128653`*^9, {3.460889436888294*^9, 
   3.460889445699613*^9}, 3.460891626620336*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["Y"], "Input",
 CellChangeTimes->{3.460889506265583*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"-", "0.7881842610772917`"}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.460889507239225*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Nichtlinear", ",", " ", "NorKorr"}]], "Input",
 CellChangeTimes->{{3.460367266700344*^9, 3.4603672898119717`*^9}, {
  3.46071751379565*^9, 3.4607175158172903`*^9}, {3.460717574664137*^9, 
  3.460717587669468*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "scoreii", ",", "k", 
      ",", "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
    RowBox[{"BFGS", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"Y", ",", "X", ",", 
         RowBox[{"-", "9"}]}], "}"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      "\t  ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"IdioNonlin", ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"m", "=", "100"}], ",", 
          RowBox[{"eps", "=", 
           RowBox[{"10.", "^", 
            RowBox[{"-", "16"}]}]}], ",", 
          RowBox[{"ksigma", "=", "Infinity"}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Lik", ",", "IndividualLikNonlin", ",", "Score", ",", "Hesse"}], 
         "}"}]}], "}"}], ",", "\[IndentingNewLine]", "            ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Sing", "=", "False"}], ",", 
          RowBox[{"2", "Pi"}], ",", "0", ",", 
          RowBox[{"onlynorkorr", "=", "0"}], ",", 
          RowBox[{"method", "=", "\"\<NorKorr\>\""}]}], "}"}], ",", 
        RowBox[{"KMAX", "=", "20"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EPS1", "=", ".0001"}], ",", 
          RowBox[{"EPS2", "=", ".0001"}]}], "}"}], ",", "\[IndentingNewLine]",
         "             ", 
        RowBox[{"OPTION", "=", "0"}], ",", 
        RowBox[{"PRINT", "=", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1"}], "}"}]}]}], "}"}]}], "]"}]}], ";"}], 
  "                                                                           \
     "}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113330285616*^9, 3.460113346379695*^9}, {
   3.460200648978776*^9, 3.4602006503583603`*^9}, {3.460200794874672*^9, 
   3.4602007984595947`*^9}, 3.460201903279232*^9, {3.460201941045977*^9, 
   3.4602019411313553`*^9}, {3.460279278878285*^9, 3.460279290392777*^9}, {
   3.460279385569292*^9, 3.4602794078107224`*^9}, 3.460279483282811*^9, {
   3.460282734453003*^9, 3.46028273588818*^9}, {3.460283616696549*^9, 
   3.460283634147719*^9}, {3.4602836706901093`*^9, 3.460283671258127*^9}, {
   3.4602837458995867`*^9, 3.4602837460095263`*^9}, {3.460283977779047*^9, 
   3.4602839782382393`*^9}, {3.460284094017385*^9, 3.460284112248164*^9}, {
   3.4602842039019938`*^9, 3.460284237509654*^9}, {3.460285585933895*^9, 
   3.460285590933837*^9}, 3.460367196326754*^9, {3.460435757860738*^9, 
   3.460435758943184*^9}, {3.460435888109399*^9, 3.460435888167045*^9}, {
   3.4604359232590923`*^9, 3.4604359236923323`*^9}, {3.4607004849549637`*^9, 
   3.460700501505876*^9}, {3.460700547802786*^9, 3.460700549451239*^9}, {
   3.460701009705194*^9, 3.460701010780252*^9}, {3.460701735855749*^9, 
   3.4607017420189333`*^9}, {3.460717416622799*^9, 3.4607174212496634`*^9}, {
   3.460717524522689*^9, 3.460717524583459*^9}, {3.46071760178517*^9, 
   3.46071760964034*^9}, 3.4607177051758137`*^9, 3.460717757149786*^9, {
   3.460717815582903*^9, 3.4607178169820967`*^9}, {3.460889543070612*^9, 
   3.460889545084868*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Tiefe von data = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["Tiefe von data = ", 5],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916458549356`*^9}],

Cell[BoxData["\<\"L\[ADoubleDot]nge der Paneldaten\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891645866852*^9}],

Cell[BoxData[
 RowBox[{"{", "1", "}"}]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891645878593*^9}],

Cell[BoxData["\<\"***********************LSDE1********************************\
**\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891645889735*^9}],

Cell[BoxData["\<\"***********************MODUL:    BFGS \
(skeleton)**************\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891645902048*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891645913889*^9}],

Cell[BoxData["\<\"Technical Output\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916459227543`*^9}],

Cell[BoxData["IndividualLikNonlin"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.46089164593292*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891645945237*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"KMAX\"\>",
       HoldForm], 
      TagBox["\<\"EPS1\"\>",
       HoldForm], 
      TagBox["\<\"EPS2\"\>",
       HoldForm], 
      TagBox["\<\"K\"\>",
       HoldForm], 
      TagBox["\<\"Q\"\>",
       HoldForm], 
      TagBox["\<\"n\"\>",
       HoldForm], 
      TagBox["\<\"T\"\>",
       HoldForm], 
      TagBox["\<\"OPTION\"\>",
       HoldForm]},
     {"1", "20", "0.0001`", "0.0001`", "1", "1", "1", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"KMAX", "EPS1", "EPS2", "K", "Q", "n", "T", "OPTION"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891645954434*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891645966132*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"MAXSTEP\"\>",
       HoldForm], 
      TagBox["\<\"MINSTEP\"\>",
       HoldForm], 
      TagBox["\<\"BOUND\"\>",
       HoldForm], 
      TagBox["\<\"STEPREDUCE\"\>",
       HoldForm], 
      TagBox["\<\"FMAX\"\>",
       HoldForm]},
     {"1", "1", "1.`*^-10", "1.`*^-6", "4", "1000"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"MAXSTEP", "MINSTEP", "BOUND", "STEPREDUCE", "FMAX"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916459756002`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891646022067*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"RESAMPLING\"\>",
       HoldForm], 
      TagBox["\<\"FDIGITS\"\>",
       HoldForm], 
      TagBox["\<\"TYP\"\>",
       HoldForm], 
      TagBox["\<\"YMAX\"\>",
       HoldForm], 
      TagBox["\<\"ANALGRAD\"\>",
       HoldForm], 
      TagBox["\<\"FACTOR\"\>",
       HoldForm], 
      TagBox["\<\"CSEED\"\>",
       HoldForm]},
     {"1", "True", "16", "1", "1.`*^8", "False", "1.`", 
      RowBox[{"-", "999"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {
      "RESAMPLING", "FDIGITS", "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}},
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891646077754*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916461272*^9}],

Cell[BoxData["\<\"    SCALING\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916461752357`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "::", "\<\"nmtx\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The first two levels of the \
one-dimensional list \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\
\\!\\({}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" cannot be \
transposed.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Transpose\\\", ButtonNote -> \\\"Transpose::nmtx\\\
\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4607175292445707`*^9, 3.4607176114482727`*^9, 
  3.460717706528014*^9, 3.460717759262171*^9, 3.4607178186032333`*^9, 
  3.46088955033464*^9, 3.460891646226864*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  RowBox[{"Transpose", "[", 
   RowBox[{"{", "}"}], "]"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
    0]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916462824*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.46089164634207*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891646382576*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916464278193`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STARTWERT THETA0 = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.1`", "}"}]}],
  SequenceForm["STARTWERT THETA0 = ", {0.1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891646478074*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891646528658*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"-", "7.5507558435201645`"}], "}"}], ",", "0.2258580449091565`"}],
   "}"}]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916465790253`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891646634047*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["BFGS: Iteration = ", 1],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891646696073*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -0.224013991027457\"\>",
     -0.22401399102745678`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.225858044909157\"\>",
     0.2258580449091565,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[-0.22401399102745678`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2258580449091565, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891646745843*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.661512680888983\"\>",
     0.6615126808889829,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.225858044909157\"\>",
     0.2258580449091565,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[0.6615126808889829, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2258580449091565, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891646796797*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.661512680888983\"\>",
     0.6615126808889829,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.6615126808889829, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916468674183`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.225858044909157\"\>",
     0.2258580449091565,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.2258580449091565, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891646910734*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.435654635979826\"\>",
     0.43565463597982634`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.43565463597982634`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891646986463*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.46089164704795*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.0375\"\>",
         0.037500000000000006`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1000\"\>",
         0.1,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0625\"\>",
         -0.0625,
         AutoDelete->True], 
        InterpretationBox["\<\"-7.5508\"\>",
         -7.5507558435201645`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891647098308*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891647148951*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916471980658`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891647247939*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.9171249210359065`*^-7"}],
  
  SequenceForm["NOISE  ", 1.9171249210359065`*^-7],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891647299644*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "1.2436256838846709`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "256.`"}],
  SequenceForm["*BFGSUP ", 1.2436256838846709`, "  ", 256.],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891647367751*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "8.034391281839584`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 8.034391281839584, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.46089164740807*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891647459571*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "2"}],
  SequenceForm["BFGS: Iteration = ", 2],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891647510662*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.666482075972682\"\>",
     0.6664820759726819,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.661512680888983\"\>",
     0.6615126808889829,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[0.6664820759726819, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.6615126808889829, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916475657263`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.666482075972682\"\>",
     0.6664820759726819,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.6664820759726819, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891647616045*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.661512680888983\"\>",
     0.6615126808889829,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.6615126808889829, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891647673985*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.004969395083699\"\>",
     0.004969395083699091,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.004969395083699091, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891647726606*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916477803793`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.0440\"\>",
         0.04395477158228132,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0375\"\>",
         0.037500000000000006`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0065\"\>",
         0.006454771582281309,
         AutoDelete->True], 
        InterpretationBox["\<\" 5.3149\"\>",
         5.314851716160774,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891647840554*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891647918619*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 205.8\"\>",
         205.849720954895,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916479728193`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.46089164801903*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.196849193085825`*^-7"}],
  SequenceForm["NOISE  ", 1.196849193085825*^-7],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891648074995*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "19.288559856933464`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "116.59715690692128`"}],
  SequenceForm["*BFGSUP ", 19.288559856933464`, "  ", 116.59715690692128`],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891648139594*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "4.07672967439447`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 4.07672967439447, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891648190373*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.46089164824226*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "3"}],
  SequenceForm["BFGS: Iteration = ", 3],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891648306604*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.670285647281892\"\>",
     0.6702856472818919,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.6702856472818919, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891648359171*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.666482075972682\"\>",
     0.6664820759726819,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.6664820759726819, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916484215193`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.003803571309210\"\>",
     0.003803571309209941,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.003803571309209941, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916484855423`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916485355663`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.0418\"\>",
         0.04177122757811518,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0440\"\>",
         0.04395477158228132,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0022\"\>",
         -0.0021835440041661327`,
         AutoDelete->True], 
        InterpretationBox["\<\"-2.7171\"\>",
         -2.7170672565698624`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891648593462*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916486595497`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1244.\"\>",
         1244.3382186875026`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.46089164871052*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916487583113`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "5.05718362742158`*^-8"}],
  SequenceForm["NOISE  ", 5.05718362742158*^-8],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891648810615*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "224.46085337607298`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "168.5534563891643`"}],
  SequenceForm["*BFGSUP ", 224.46085337607298`, "  ", 168.5534563891643],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891648855633*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "1.0096460052980087`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 1.0096460052980087`, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916489035807`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916489887*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "4"}],
  SequenceForm["BFGS: Iteration = ", 4],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891649075843*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.670488279405533\"\>",
     0.6704882794055331,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.6704882794055331, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891649119872*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.670285647281892\"\>",
     0.6702856472818919,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.6702856472818919, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891649178616*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000202632123641\"\>",
     0.00020263212364124428`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.00020263212364124428`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.46089164922784*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916492779512`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.0410\"\>",
         0.041046969149397795`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0418\"\>",
         0.04177122757811518,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0007\"\>",
         -0.0007242584287173839,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.6768\"\>",
         -0.6767512261867523,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891649330742*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891649382375*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 934.4\"\>",
         934.4057305418401,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916494306793`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891649477233*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.2008164240739916`*^-8"}],
  
  SequenceForm["NOISE  ", 1.2008164240739916`*^-8],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891649530611*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "1713.365174704996`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "2040.2218320761162`"}],
  SequenceForm["*BFGSUP ", 1713.365174704996, "  ", 2040.2218320761162`],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916496073*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.19255077038660692`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.19255077038660692`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891649669527*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891649731263*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["BFGS: Iteration = ", 5],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891649781485*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.670495469623911\"\>",
     0.6704954696239114,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.6704954696239114, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.46089164983823*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.670488279405533\"\>",
     0.6704882794055331,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.6704882794055331, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916499070463`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     7.190218378250179\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-6\"\>"]}],
     7.190218378250179*^-6,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[7.190218378250179*^-6, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916499687767`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891650032715*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.0412\"\>",
         0.041163000007102386`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0410\"\>",
         0.041046969149397795`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0001\"\>",
         0.00011603085770459108`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1291\"\>",
         0.12910303473472595`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891650093709*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916501296663`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1113.\"\>",
         1112.6612117564105`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891650180257*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916502363567`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.996286025374161`*^-9"}],
  SequenceForm["NOISE  ", 1.996286025374161*^-9],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916503008747`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "64331.52454984031`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "66755.96009516394`"}],
  SequenceForm["*BFGSUP ", 64331.52454984031, "  ", 66755.96009516394],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916503466063`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.007256503388364811`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.007256503388364811, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891650398836*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891650453751*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "6"}],
  SequenceForm["BFGS: Iteration = ", 6],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891650518302*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.670495479910546\"\>",
     0.670495479910546,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.670495479910546, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891650566375*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.670495469623911\"\>",
     0.6704954696239114,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.6704954696239114, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891650630147*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     1.028663465518775\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-8\"\>"]}],
     1.0286634655187754`*^-8,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[1.0286634655187754`*^-8, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916506680393`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891650718883*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.0412\"\>",
         0.04115878601129778,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0412\"\>",
         0.041163000007102386`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\"-0.0049\"\>",
         -0.0048654526472091675`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891650770296*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891650836231*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1155.\"\>",
         1154.593614424642,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891650886846*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.46089165093503*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "7.299783000291882`*^-11"}],
  
  SequenceForm["NOISE  ", 7.299783000291882*^-11],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891650985441*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "4.91099669448739`*^7", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "4.877335727602982`*^7"}],
  SequenceForm["*BFGSUP ", 4.91099669448739*^7, "  ", 4.877335727602982*^7],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891651035355*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", 
   "0.00004973754447424504`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.00004973754447424504, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891651087125*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891651149377*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891651197657*^9}],

Cell[BoxData["\<\"ReturnCode = 3\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916512607307`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS:  ENDE DER ITERATION  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "20"}],
  SequenceForm["BFGS:  ENDE DER ITERATION  ", 6, "  ", 20],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916513240633`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {"1", 
       RowBox[{"-", "0.000033348798751831055`"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}]]]], "Print",\

 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891651390665*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891651461343*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1147.\"\>",
         1146.6797957361214`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916515211697`*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"Likelihood\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm]},
      {"1", "0.2258580449091565`", "0.1`"},
      {"2", "0.6615126808889829`", "0.037500000000000006`"},
      {"3", "0.6664820759726819`", "0.04395477158228132`"},
      {"4", "0.6702856472818919`", "0.04177122757811518`"},
      {"5", "0.6704882794055331`", "0.041046969149397795`"},
      {"6", "0.6704954696239114`", "0.041163000007102386`"},
      {"7", "0.670495479910546`", "0.04115878601129778`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"Likelihood", "THETA"}}]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916515738277`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"INK: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "6.055454452393343`*^-6", "}"}]}],
  SequenceForm["INK: ", {6.055454452393343*^-6}],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916516170473`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891651673929*^9}],

Cell[BoxData["\<\"ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891651754098*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891651807694*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {
         StyleBox["\[Null]",
          ShowStringCharacters->False], 
         TagBox["\<\"THETA\"\>",
          HoldForm], 
         TagBox["\<\"SCORE\"\>",
          HoldForm]},
        {"1", "0.04115878601129778`", 
         RowBox[{"-", "0.000033348798751831055`"}]}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxDividers->{
        "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
         "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.24]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
     "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[
     BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}]]], 
   "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
   "0.670495479910546`"}],
  SequenceForm[
   MatrixForm[{{0.04115878601129778, -0.000033348798751831055`}}, 
    TableHeadings -> {Automatic, {"THETA", "SCORE"}}], "   Likelihood = ", 
   0.670495479910546],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916518547297`*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916519123287`*^9}],

Cell[BoxData["\<\"WALD-TEST:\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891651973164*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.46089165201971*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"CHI \"\>",
       HoldForm], 
      TagBox["\<\"U \"\>",
       HoldForm], 
      TagBox["\<\"PROB \"\>",
       HoldForm], 
      TagBox["\<\"ALPHA \"\>",
       HoldForm]},
     {"1", "1.9430286072135285`", "1", "0.16334006965974168`", "0.05`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", "ALPHA "}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891652074788*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891652124712*^9}],

Cell[BoxData["\<\"BONFERRONI-KONFIDENZINTERVALLE:\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891652176231*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891652243922*^9}],

Cell[BoxData["\<\"P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= \
1-ALPHA\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.46089165232364*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"QUANTIL Z(1-ALPHA/2U) = \"\>", "\[InvisibleSpace]", 
   "1.9599639845400527`"}],
  SequenceForm["QUANTIL Z(1-ALPHA/2U) = ", 1.9599639845400527`],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891652372416*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"THETA\"\>",
       HoldForm], 
      TagBox["\<\"GRENZE\"\>",
       HoldForm], 
      TagBox["\<\"STD\"\>",
       HoldForm]},
     {"1", "0.04115878601129778`", "0.05787234098438219`", 
      "0.029527247153963987`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916524274797`*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916524853163`*^9}],

Cell[BoxData["\<\"Korrelation der ML-Sch\[ADoubleDot]tzer\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891652544189*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891652606558*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "1.0000000000000002`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891652660735*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916527113247`*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND \
EIGENWERTE\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891652760503*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.46089165281208*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0.0008718583244912744`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891652888321*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.4608916529255123`*^9}],

Cell[BoxData[
 RowBox[{"{", "0.0008718583244912744`", "}"}]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891653000106*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891653050612*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX \
UND EIGENWERTE\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891653100914*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891653151252*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "1146.975342104459`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891653206937*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891653268981*^9}],

Cell[BoxData[
 RowBox[{"{", "1146.975342104459`", "}"}]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891653332109*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891653410173*^9}],

Cell[BoxData["\<\"KOMPENSIERTE LIKELIHOOD\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891653460433*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891653516828*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"U =  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  Nue = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["U =  ", 1, "  Nue = ", 1],
  Editable->False]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891653568849*^9}],

Cell[BoxData["\<\"AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) \
AZENCOTT/DACUNHA-CASTELLE (A/D)\"\>"], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891653617722*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"LIK\"\>",
       HoldForm], 
      TagBox["\<\"AIC\"\>",
       HoldForm], 
      TagBox["\<\"SIC/RISS\"\>",
       HoldForm], 
      TagBox["\<\"A/D\"\>",
       HoldForm]},
     {
      TagBox["\<\"Kompensator\"\>",
       HoldForm], "0", "1", "0.`", "Indeterminate"},
     {
      TagBox["\<\"komp. Lik.\"\>",
       HoldForm], "0.670495479910546`", 
      RowBox[{"-", "0.32950452008945397`"}], "0.670495479910546`", 
      "Indeterminate"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {{"Kompensator", "komp. Lik."}, {
      "LIK", "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
    TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.460717528970559*^9, 3.460717611161662*^9, 
  3.460717706004313*^9, 3.4607177583935623`*^9, 3.4607178178321037`*^9, 
  3.460889549913975*^9, 3.460891653676372*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "0.1`", "0.04115878601129778`", "0.029527247153963987`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.4603673130895653`*^9, 3.4607175575060387`*^9, {3.460717623410822*^9, 
   3.460717631849646*^9}, 3.4607177103844147`*^9, 3.460717770338664*^9, 
   3.460717831260625*^9, 3.460889561024633*^9, 3.460891675685521*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Nichtlinear", ",", " ", "StochLin"}]], "Input",
 CellChangeTimes->{{3.460717864870357*^9, 3.460717867572139*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "scoreii", ",", "k", 
      ",", "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
    RowBox[{"BFGS", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"Y", ",", "X", ",", 
         RowBox[{"-", "9"}]}], "}"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      "\t  ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"IdioNonlin", ",", 
          RowBox[{"{", "}"}], ",", 
          RowBox[{"m", "=", "100"}], ",", 
          RowBox[{"eps", "=", 
           RowBox[{"10.", "^", 
            RowBox[{"-", "16"}]}]}], ",", 
          RowBox[{"ksigma", "=", "Infinity"}], ",", "0"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "Lik", ",", "IndividualLikNonlin", ",", "Score", ",", "Hesse"}], 
         "}"}]}], "}"}], ",", "\[IndentingNewLine]", "            ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Sing", "=", "False"}], ",", 
          RowBox[{"2", "Pi"}], ",", "0", ",", 
          RowBox[{"onlynorkorr", "=", "0"}], ",", 
          RowBox[{"method", "=", "\"\<StochLin\>\""}]}], "}"}], ",", 
        RowBox[{"KMAX", "=", "20"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EPS1", "=", ".0001"}], ",", 
          RowBox[{"EPS2", "=", ".0001"}]}], "}"}], ",", "\[IndentingNewLine]",
         "             ", 
        RowBox[{"OPTION", "=", "0"}], ",", 
        RowBox[{"PRINT", "=", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1"}], "}"}]}]}], "}"}]}], "]"}]}], ";"}], 
  "                                                                           \
     "}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113330285616*^9, 3.460113346379695*^9}, {
   3.460200648978776*^9, 3.4602006503583603`*^9}, {3.460200794874672*^9, 
   3.4602007984595947`*^9}, 3.460201903279232*^9, {3.460201941045977*^9, 
   3.4602019411313553`*^9}, {3.460279278878285*^9, 3.460279290392777*^9}, {
   3.460279385569292*^9, 3.4602794078107224`*^9}, 3.460279483282811*^9, {
   3.460282734453003*^9, 3.46028273588818*^9}, {3.460283616696549*^9, 
   3.460283634147719*^9}, {3.4602836706901093`*^9, 3.460283671258127*^9}, {
   3.4602837458995867`*^9, 3.4602837460095263`*^9}, {3.460283977779047*^9, 
   3.4602839782382393`*^9}, {3.460284094017385*^9, 3.460284112248164*^9}, {
   3.4602842039019938`*^9, 3.460284237509654*^9}, {3.460285585933895*^9, 
   3.460285590933837*^9}, 3.460367196326754*^9, {3.460435757860738*^9, 
   3.460435758943184*^9}, {3.460435888109399*^9, 3.460435888167045*^9}, {
   3.4604359232590923`*^9, 3.4604359236923323`*^9}, {3.4607004849549637`*^9, 
   3.460700501505876*^9}, {3.460700547802786*^9, 3.460700549451239*^9}, {
   3.460701009705194*^9, 3.460701010780252*^9}, {3.460701735855749*^9, 
   3.4607017420189333`*^9}, {3.460717416622799*^9, 3.4607174212496634`*^9}, {
   3.460717524522689*^9, 3.460717524583459*^9}, {3.46071760178517*^9, 
   3.46071760964034*^9}, 3.4607177051758137`*^9, 3.460717757149786*^9, {
   3.460717815582903*^9, 3.4607178169820967`*^9}, 3.460717874002067*^9, {
   3.4608895729115887`*^9, 3.460889574068149*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Tiefe von data = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["Tiefe von data = ", 5],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891678470298*^9}],

Cell[BoxData["\<\"L\[ADoubleDot]nge der Paneldaten\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916784819393`*^9}],

Cell[BoxData[
 RowBox[{"{", "1", "}"}]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916784933987`*^9}],

Cell[BoxData["\<\"***********************LSDE1********************************\
**\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089167850531*^9}],

Cell[BoxData["\<\"***********************MODUL:    BFGS \
(skeleton)**************\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916785171967`*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891678529562*^9}],

Cell[BoxData["\<\"Technical Output\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891678542104*^9}],

Cell[BoxData["IndividualLikNonlin"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089167855338*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891678564213*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"KMAX\"\>",
       HoldForm], 
      TagBox["\<\"EPS1\"\>",
       HoldForm], 
      TagBox["\<\"EPS2\"\>",
       HoldForm], 
      TagBox["\<\"K\"\>",
       HoldForm], 
      TagBox["\<\"Q\"\>",
       HoldForm], 
      TagBox["\<\"n\"\>",
       HoldForm], 
      TagBox["\<\"T\"\>",
       HoldForm], 
      TagBox["\<\"OPTION\"\>",
       HoldForm]},
     {"1", "20", "0.0001`", "0.0001`", "1", "1", "1", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"KMAX", "EPS1", "EPS2", "K", "Q", "n", "T", "OPTION"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891678575231*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891678584856*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"MAXSTEP\"\>",
       HoldForm], 
      TagBox["\<\"MINSTEP\"\>",
       HoldForm], 
      TagBox["\<\"BOUND\"\>",
       HoldForm], 
      TagBox["\<\"STEPREDUCE\"\>",
       HoldForm], 
      TagBox["\<\"FMAX\"\>",
       HoldForm]},
     {"1", "1", "1.`*^-10", "1.`*^-6", "4", "1000"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"MAXSTEP", "MINSTEP", "BOUND", "STEPREDUCE", "FMAX"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891678594934*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891678605743*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"RESAMPLING\"\>",
       HoldForm], 
      TagBox["\<\"FDIGITS\"\>",
       HoldForm], 
      TagBox["\<\"TYP\"\>",
       HoldForm], 
      TagBox["\<\"YMAX\"\>",
       HoldForm], 
      TagBox["\<\"ANALGRAD\"\>",
       HoldForm], 
      TagBox["\<\"FACTOR\"\>",
       HoldForm], 
      TagBox["\<\"CSEED\"\>",
       HoldForm]},
     {"1", "True", "16", "1", "1.`*^8", "False", "1.`", 
      RowBox[{"-", "999"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {
      "RESAMPLING", "FDIGITS", "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}},
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916786644793`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891678713313*^9}],

Cell[BoxData["\<\"    SCALING\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891678768187*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "::", "\<\"nmtx\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The first two levels of the \
one-dimensional list \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\
\\!\\({}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" cannot be \
transposed.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Transpose\\\", ButtonNote -> \\\"Transpose::nmtx\\\
\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.46071787686753*^9, 3.460889575351853*^9, 
  3.460891678813148*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  RowBox[{"Transpose", "[", 
   RowBox[{"{", "}"}], "]"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
    0]]]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891678856772*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891678951289*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089167899304*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891679042951*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STARTWERT THETA0 = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.1`", "}"}]}],
  SequenceForm["STARTWERT THETA0 = ", {0.1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891679091605*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891679140723*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "1.4066895991563797`", "}"}], ",", "0.2250864439865401`"}], 
  "}"}]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891679191354*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891679241358*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["BFGS: Iteration = ", 1],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891679298461*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -0.901858601253734\"\>",
     -0.9018586012537342,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.225086443986540\"\>",
     0.2250864439865401,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[-0.9018586012537342, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2250864439865401, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891679343276*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -0.225133623225588\"\>",
     -0.22513362322558828`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.225086443986540\"\>",
     0.2250864439865401,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[-0.22513362322558828`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2250864439865401, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891679393463*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.128618780017044\"\>",
     0.1286187800170444,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.225086443986540\"\>",
     0.2250864439865401,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[0.1286187800170444, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2250864439865401, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891679457612*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.187957921344891\"\>",
     0.18795792134489142`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.225086443986540\"\>",
     0.2250864439865401,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[0.18795792134489142`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2250864439865401, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891679498158*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.226432465555367\"\>",
     0.22643246555536667`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.225086443986540\"\>",
     0.2250864439865401,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
   PaddedForm[0.22643246555536667`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2250864439865401, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916795444107`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.226432465555367\"\>",
     0.22643246555536667`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.22643246555536667`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891679594338*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.225086443986540\"\>",
     0.2250864439865401,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.2250864439865401, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891679647908*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.001346021568827\"\>",
     0.001346021568826572,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.001346021568826572, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916796938457`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916797443542`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1010\"\>",
         0.1009765625,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1000\"\>",
         0.1,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0010\"\>",
         0.0009765624999999998,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.4067\"\>",
         1.4066895991563797`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891679794479*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891679843254*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916798929777`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891679955531*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "4.108192519503007`*^-8"}],
  SequenceForm["NOISE  ", 4.108192519503007*^-8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891679993338*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "18150.278353752998`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "1.0485760000000005`*^6"}],
  SequenceForm["*BFGSUP ", 18150.278353752998`, "  ", 1.0485760000000005`*^6],
  
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891680043536*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "5.9632426308801625`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 5.9632426308801625`, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891680094344*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891680147656*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "2"}],
  SequenceForm["BFGS: Iteration = ", 2],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916801953707`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.165326803385608\"\>",
     0.16532680338560746`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.226432465555367\"\>",
     0.22643246555536667`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[0.16532680338560746`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22643246555536667`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891680245584*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228345256383250\"\>",
     0.2283452563832502,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.226432465555367\"\>",
     0.22643246555536667`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[0.2283452563832502, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22643246555536667`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916803010387`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228345256383250\"\>",
     0.2283452563832502,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.2283452563832502, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891680346532*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.226432465555367\"\>",
     0.22643246555536667`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.22643246555536667`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916803965*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.001912790827884\"\>",
     0.001912790827883537,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.001912790827883537, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916804584427`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891680498331*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1024\"\>",
         0.1024373416770707,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1010\"\>",
         0.1009765625,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0015\"\>",
         0.0014607791770707074`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.3503\"\>",
         1.3502717316150665`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891680555064*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891680601981*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 57.77\"\>",
         57.7718963623047,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891680647684*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916806976767`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.903383505310387`*^-8"}],
  SequenceForm["NOISE  ", 3.903383505310387*^-8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891680748823*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "8448.603834240483`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "8111.744023633577`"}],
  SequenceForm["*BFGSUP ", 8448.603834240483, "  ", 8111.744023633577],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916808004723`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "5.558445209090915`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 5.558445209090915, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916808475122`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891680904167*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "3"}],
  SequenceForm["BFGS: Iteration = ", 3],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916809761763`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.166809580894842\"\>",
     0.166809580894842,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228345256383250\"\>",
     0.2283452563832502,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[0.166809580894842, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2283452563832502, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916810179863`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.187911917802705\"\>",
     0.1879119178027051,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228345256383250\"\>",
     0.2283452563832502,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[0.1879119178027051, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2283452563832502, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916810671062`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186608542767618\"\>",
     0.1866085427676183,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228345256383250\"\>",
     0.2283452563832502,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[0.1866085427676183, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2283452563832502, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916811158667`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228458490411274\"\>",
     0.22845849041127364`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228345256383250\"\>",
     0.2283452563832502,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[0.22845849041127364`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2283452563832502, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891681168852*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228458490411274\"\>",
     0.22845849041127364`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.22845849041127364`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916812171097`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228345256383250\"\>",
     0.2283452563832502,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.2283452563832502, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916812692537`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000113234028023\"\>",
     0.00011323402802343452`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.00011323402802343452`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891681317865*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891681368539*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1025\"\>",
         0.10252672560648614`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1024\"\>",
         0.1024373416770707,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0001\"\>",
         0.00008938392941543392,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.2692\"\>",
         1.269244596362114,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891681418188*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916814830227`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 55.47\"\>",
         55.46843528769068,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891681521697*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891681570557*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.77544255858453`*^-8"}],
  SequenceForm["NOISE  ", 3.77544255858453*^-8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089168162075*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "2.3150556936939536`*^6", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "2.2564992804894554`*^6"}],
  SequenceForm[
  "*BFGSUP ", 2.3150556936939536`*^6, "  ", 2.2564992804894554`*^6],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891681668408*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "5.534537208051621`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 5.534537208051621, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891681719343*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916817681503`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916818177643`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "4"}],
  SequenceForm["BFGS: Iteration = ", 4],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891681867814*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.167040827329628\"\>",
     0.16704082732962844`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228458490411274\"\>",
     0.22845849041127364`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[0.16704082732962844`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22845849041127364`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916819182997`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.188055152493006\"\>",
     0.18805515249300564`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228458490411274\"\>",
     0.22845849041127364`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[0.18805515249300564`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22845849041127364`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891682003093*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186729188605578\"\>",
     0.1867291886055782,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228458490411274\"\>",
     0.22845849041127364`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[0.1867291886055782, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22845849041127364`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916820412483`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228573774890606\"\>",
     0.22857377489060582`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228458490411274\"\>",
     0.22845849041127364`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[0.22857377489060582`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22845849041127364`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916820862103`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228573774890606\"\>",
     0.22857377489060582`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.22857377489060582`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891682137142*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228458490411274\"\>",
     0.22845849041127364`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.22845849041127364`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891682188614*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000115284479332\"\>",
     0.00011528447933217834`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.00011528447933217834`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891682237544*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891682292667*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1026\"\>",
         0.10261807990307092`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1025\"\>",
         0.10252672560648614`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0001\"\>",
         0.00009135429658479025,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.2644\"\>",
         1.2644120156764984`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891682338604*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891682388761*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 54.07\"\>",
         54.065431193508246`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916824386663`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891682505021*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.760903810601235`*^-8"}],
  SequenceForm["NOISE  ", 3.760903810601235*^-8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891682541074*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "2.2229753104439783`*^6", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "2.2162684961440163`*^6"}],
  SequenceForm[
  "*BFGSUP ", 2.2229753104439783`*^6, "  ", 2.2162684961440163`*^6],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891682588224*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "5.510202595872977`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 5.510202595872977, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891682654999*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916827045803`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891682755941*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["BFGS: Iteration = ", 5],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916828073673`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.167132766551565\"\>",
     0.16713276655156473`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228573774890606\"\>",
     0.22857377489060582`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[0.16713276655156473`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22857377489060582`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089168285574*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.188161371716681\"\>",
     0.18816137171668057`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228573774890606\"\>",
     0.22857377489060582`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[0.18816137171668057`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22857377489060582`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891682912961*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186841655788981\"\>",
     0.18684165578898138`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228573774890606\"\>",
     0.22857377489060582`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[0.18684165578898138`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22857377489060582`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891682967005*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228688509313529\"\>",
     0.2286885093135289,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228573774890606\"\>",
     0.22857377489060582`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[0.2286885093135289, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22857377489060582`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891683040744*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228688509313529\"\>",
     0.2286885093135289,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.2286885093135289, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891683077405*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228573774890606\"\>",
     0.22857377489060582`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.22857377489060582`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891683125296*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000114734422923\"\>",
     0.00011473442292309066`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.00011473442292309066`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916831760483`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891683225458*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1027\"\>",
         0.10270935380094004`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1026\"\>",
         0.10261807990307092`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0001\"\>",
         0.00009127389786910947,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.2595\"\>",
         1.259487807750702,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891683280074*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891683325791*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 53.9\"\>",
         53.902313409267144`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891683383246*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916834322863`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.746256616032895`*^-8"}],
  SequenceForm["NOISE  ", 3.746256616032895*^-8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891683478817*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "2.23348324038999`*^6", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "2.2268932558566537`*^6"}],
  SequenceForm["*BFGSUP ", 2.23348324038999*^6, "  ", 2.2268932558566537`*^6],
  
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916835420837`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "5.485988139761757`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 5.485988139761757, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891683577342*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891683631463*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916836766367`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "6"}],
  SequenceForm["BFGS: Iteration = ", 6],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089168372613*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.167223883873962\"\>",
     0.16722388387396192`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228688509313529\"\>",
     0.2286885093135289,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[0.16722388387396192`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2286885093135289, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891683778096*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.188266975874821\"\>",
     0.18826697587482055`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228688509313529\"\>",
     0.2286885093135289,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[0.18826697587482055`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2286885093135289, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916838269463`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186953562958090\"\>",
     0.18695356295808963`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228688509313529\"\>",
     0.2286885093135289,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[0.18695356295808963`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2286885093135289, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089168388078*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186615581685557\"\>",
     0.1866155816855568,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228688509313529\"\>",
     0.2286885093135289,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[0.1866155816855568, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2286885093135289, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891683929212*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228717095929898\"\>",
     0.2287170959298983,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228688509313529\"\>",
     0.2286885093135289,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
   PaddedForm[0.2287170959298983, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2286885093135289, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891683990036*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228717095929898\"\>",
     0.2287170959298983,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.2287170959298983, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891684044483*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228688509313529\"\>",
     0.2286885093135289,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.2286885093135289, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891684081479*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.000028586616369\"\>",
     0.000028586616369397078`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.000028586616369397078`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891684130197*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891684182673*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1027\"\>",
         0.10273215066683115`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1027\"\>",
         0.10270935380094004`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0.000022796865891119385`,
         AutoDelete->True], 
        InterpretationBox["\<\" 1.2546\"\>",
         1.2545824497938156`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891684230609*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891684281156*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 53.74\"\>",
         53.74327240763593,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916843310423`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916843822327`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.73712489842859`*^-8"}],
  SequenceForm["NOISE  ", 3.73712489842859*^-8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891684430773*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "3.587214557350939`*^7", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "3.580350995754006`*^7"}],
  SequenceForm["*BFGSUP ", 3.587214557350939*^7, "  ", 3.580350995754006*^7],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891684479402*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "5.47995597227642`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 5.47995597227642, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916845470667`*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891684582584*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891684646961*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "7"}],
  SequenceForm["BFGS: Iteration = ", 7],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916846996517`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.167253871619209\"\>",
     0.16725387161920935`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228717095929898\"\>",
     0.2287170959298983,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[0.16725387161920935`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287170959298983, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891684748618*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.188295300563955\"\>",
     0.18829530056395472`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228717095929898\"\>",
     0.2287170959298983,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[0.18829530056395472`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287170959298983, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891684799203*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186981973123306\"\>",
     0.18698197312330622`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228717095929898\"\>",
     0.2287170959298983,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[0.18698197312330622`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287170959298983, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891684849147*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186644002535252\"\>",
     0.18664400253525182`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228717095929898\"\>",
     0.2287170959298983,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[0.18664400253525182`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287170959298983, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891684899722*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186558897885917\"\>",
     0.18655889788591695`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228717095929898\"\>",
     0.2287170959298983,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
   PaddedForm[0.18655889788591695`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287170959298983, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891684962409*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228724244944930\"\>",
     0.2287242449449296,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228717095929898\"\>",
     0.2287170959298983,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
   PaddedForm[0.2287242449449296, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287170959298983, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891685017947*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228724244944930\"\>",
     0.2287242449449296,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.2287242449449296, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891685080718*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228717095929898\"\>",
     0.2287170959298983,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.2287170959298983, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916851213493`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     7.149015031293615\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-6\"\>"]}],
     7.149015031293615*^-6,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[7.149015031293615*^-6, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891685174995*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916852177877`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1027\"\>",
         0.10273785524310657`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1027\"\>",
         0.10273215066683115`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1.2534\"\>",
         1.253359615802765,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891685274048*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891685318577*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 53.64\"\>",
         53.64044324737991,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916853736687`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891685417673*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.7348468318043615`*^-8"}],
  
  SequenceForm["NOISE  ", 3.7348468318043615`*^-8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891685471579*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "5.729612356282003`*^8", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "5.72876304586802`*^8"}],
  SequenceForm["*BFGSUP ", 5.729612356282003*^8, "  ", 5.72876304586802*^8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891685518511*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "5.478447050783064`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 5.478447050783064, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891685581386*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916856236258`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891685673373*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "8"}],
  SequenceForm["BFGS: Iteration = ", 8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891685720787*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.167259321939309\"\>",
     0.1672593219393088,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228724244944930\"\>",
     0.2287242449449296,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[0.1672593219393088, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287242449449296, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916857697477`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.188301817759118\"\>",
     0.18830181775911803`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228724244944930\"\>",
     0.2287242449449296,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[0.18830181775911803`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287242449449296, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891685820915*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186988929737489\"\>",
     0.18698892973748937`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228724244944930\"\>",
     0.2287242449449296,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[0.18698892973748937`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287242449449296, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089168587248*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186651072644266\"\>",
     0.18665107264426606`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228724244944930\"\>",
     0.2287242449449296,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[0.18665107264426606`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287242449449296, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916859215612`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186565996601522\"\>",
     0.1865659966015223,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228724244944930\"\>",
     0.2287242449449296,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
   PaddedForm[0.1865659966015223, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287242449449296, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916859905252`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228731391530013\"\>",
     0.2287313915300131,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228724244944930\"\>",
     0.2287242449449296,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
   PaddedForm[0.2287313915300131, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287242449449296, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089168603983*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228731391530013\"\>",
     0.2287313915300131,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.2287313915300131, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916860977173`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228724244944930\"\>",
     0.2287242449449296,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.2287242449449296, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891686141778*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     7.146585083495083\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-6\"\>"]}],
     7.146585083495083*^-6,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[7.146585083495083*^-6, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891686190412*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891686240632*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1027\"\>",
         0.1027435592723878,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1027\"\>",
         0.10273785524310657`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1.2531\"\>",
         1.2530536651611328`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891686297327*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891686345324*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 53.63\"\>",
         53.63249203109724,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891686390945*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891686441675*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.733935205474381`*^-8"}],
  SequenceForm["NOISE  ", 3.733935205474381*^-8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891686490631*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "5.732395349602089`*^8", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "5.730711303970045`*^8"}],
  SequenceForm["*BFGSUP ", 5.732395349602089*^8, "  ", 5.730711303970045*^8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891686540744*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "5.476938802973227`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 5.476938802973227, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916865996037`*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916866435423`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916866917753`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "9"}],
  SequenceForm["BFGS: Iteration = ", 9],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089168674076*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.167265671335057\"\>",
     0.16726567133505688`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228731391530013\"\>",
     0.2287313915300131,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[0.16726567133505688`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287313915300131, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916867915983`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.188308581714860\"\>",
     0.18830858171486042`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228731391530013\"\>",
     0.2287313915300131,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[0.18830858171486042`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287313915300131, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891686841015*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186995949216658\"\>",
     0.18699594921665752`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228731391530013\"\>",
     0.2287313915300131,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[0.18699594921665752`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287313915300131, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891686900113*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186658156866659\"\>",
     0.1866581568666592,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228731391530013\"\>",
     0.2287313915300131,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[0.1866581568666592, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287313915300131, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891686966247*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186573097064845\"\>",
     0.18657309706484493`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228731391530013\"\>",
     0.2287313915300131,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
   PaddedForm[0.18657309706484493`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287313915300131, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916870151377`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228738536726269\"\>",
     0.22873853672626865`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228731391530013\"\>",
     0.2287313915300131,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
   PaddedForm[0.22873853672626865`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287313915300131, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916870766706`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228738536726269\"\>",
     0.22873853672626865`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.22873853672626865`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089168711456*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228731391530013\"\>",
     0.2287313915300131,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.2287313915300131, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916871657743`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     7.145196255553543\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-6\"\>"]}],
     7.145196255553543*^-6,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[7.145196255553543*^-6, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891687211384*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891687261416*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1027\"\>",
         0.10274926358528853`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1027\"\>",
         0.1027435592723878,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1.2527\"\>",
         1.2527478337287903`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916873315496`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891687380496*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 53.62\"\>",
         53.616736041073494`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916874279537`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891687479294*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.7330237789845455`*^-8"}],
  
  SequenceForm["NOISE  ", 3.7330237789845455`*^-8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891687530349*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "5.475430747799204`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 5.475430747799204, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089168759585*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916876354856`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891687686377*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "10"}],
  SequenceForm["BFGS: Iteration = ", 10],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891687729608*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.167270202075868\"\>",
     0.16727020207586807`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228738536726269\"\>",
     0.22873853672626865`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[0.16727020207586807`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22873853672626865`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916877787333`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.188314842084729\"\>",
     0.1883148420847287,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228738536726269\"\>",
     0.22873853672626865`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[0.1883148420847287, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22873853672626865`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891687831827*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.187002835799816\"\>",
     0.18700283579981614`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228738536726269\"\>",
     0.22873853672626865`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[0.18700283579981614`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22873853672626865`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891687879903*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186665206466425\"\>",
     0.1866652064664247,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228738536726269\"\>",
     0.22873853672626865`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[0.1866652064664247, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22873853672626865`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891687931302*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186580187832312\"\>",
     0.18658018783231234`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228738536726269\"\>",
     0.22873853672626865`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
   PaddedForm[0.18658018783231234`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22873853672626865`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891687993209*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186558894815382\"\>",
     0.18655889481538201`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228738536726269\"\>",
     0.22873853672626865`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
   PaddedForm[0.18655889481538201`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22873853672626865`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891688042553*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228740322316850\"\>",
     0.22874032231685004`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228738536726269\"\>",
     0.22873853672626865`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 7, "  LIKNEU  ", 
   PaddedForm[0.22874032231685004`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22873853672626865`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916880961647`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228740322316850\"\>",
     0.22874032231685004`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.22874032231685004`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891688134033*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228738536726269\"\>",
     0.22873853672626865`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.22873853672626865`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891688181459*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     1.785590581393492\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-6\"\>"]}],
     1.7855905813934925`*^-6,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[1.7855905813934925`*^-6, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916882335873`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891688287324*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1028\"\>",
         0.10275068931538436`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1027\"\>",
         0.10274926358528853`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1.2524\"\>",
         1.252442017197609,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891688334041*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891688385007*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 53.62\"\>",
         53.616736041073494`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891688433433*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891688481983*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.732454345595215`*^-8"}],
  SequenceForm["NOISE  ", 3.732454345595215*^-8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891688532095*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "9.189735166267649`*^9", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "9.175399719439127`*^9"}],
  SequenceForm["*BFGSUP ", 9.189735166267649*^9, "  ", 9.175399719439127*^9],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891688602172*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "5.47505433569864`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 5.47505433569864, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916886519127`*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891688699106*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916887490387`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "11"}],
  SequenceForm["BFGS: Iteration = ", 11],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916888005857`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.167280993368654\"\>",
     0.16728099336865365`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228740322316850\"\>",
     0.22874032231685004`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[0.16728099336865365`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874032231685004`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891688851091*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.188319076187404\"\>",
     0.18831907618740362`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228740322316850\"\>",
     0.22874032231685004`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[0.18831907618740362`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874032231685004`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916889288263`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.187005255997380\"\>",
     0.1870052559973796,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228740322316850\"\>",
     0.22874032231685004`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[0.1870052559973796, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874032231685004`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891688976388*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186667145013332\"\>",
     0.1866671450133317,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228740322316850\"\>",
     0.22874032231685004`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[0.1866671450133317, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874032231685004`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891689030489*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186582004163505\"\>",
     0.18658200416350512`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228740322316850\"\>",
     0.22874032231685004`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
   PaddedForm[0.18658200416350512`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874032231685004`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891689090135*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186560680479280\"\>",
     0.18656068047927987`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228740322316850\"\>",
     0.22874032231685004`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
   PaddedForm[0.18656068047927987`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874032231685004`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916891535788`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228742110479036\"\>",
     0.22874211047903636`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228740322316850\"\>",
     0.22874032231685004`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 7, "  LIKNEU  ", 
   PaddedForm[0.22874211047903636`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874032231685004`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891689194566*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228742110479036\"\>",
     0.22874211047903636`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.22874211047903636`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916892422657`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228740322316850\"\>",
     0.22874032231685004`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.22874032231685004`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916892943087`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     1.788162186322495\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-6\"\>"]}],
     1.788162186322495*^-6,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[1.788162186322495*^-6, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891689342857*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916893896027`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1028\"\>",
         0.10275211718599052`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1028\"\>",
         0.10275068931538436`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1.2524\"\>",
         1.252365693449974,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916894381533`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089168948741*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 53.53\"\>",
         53.533097083613974`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916895373497`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891689587205*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.7322267276707066`*^-8"}],
  
  SequenceForm["NOISE  ", 3.7322267276707066`*^-8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916896699657`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "5.4746774119187815`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 5.4746774119187815`, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089168970608*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916897593517`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891689804431*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "12"}],
  SequenceForm["BFGS: Iteration = ", 12],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891689855503*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.167282126887485\"\>",
     0.1672821268874849,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228742110479036\"\>",
     0.22874211047903636`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[0.1672821268874849, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874211047903636`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891689905726*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.188320642784592\"\>",
     0.1883206427845916,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228742110479036\"\>",
     0.22874211047903636`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[0.1883206427845916, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874211047903636`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891689961103*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.187006979408300\"\>",
     0.18700697940830024`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228742110479036\"\>",
     0.22874211047903636`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[0.18700697940830024`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874211047903636`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891690007024*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186668909247917\"\>",
     0.18666890924791701`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228742110479036\"\>",
     0.22874211047903636`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[0.18666890924791701`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874211047903636`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891690056776*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186583778707683\"\>",
     0.1865837787076825,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228742110479036\"\>",
     0.22874211047903636`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
   PaddedForm[0.1865837787076825, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874211047903636`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916901072187`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186562457607374\"\>",
     0.1865624576073741,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228742110479036\"\>",
     0.22874211047903636`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
   PaddedForm[0.1865624576073741, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874211047903636`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891690170534*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228743898422849\"\>",
     0.22874389842284915`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228742110479036\"\>",
     0.22874211047903636`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 7, "  LIKNEU  ", 
   PaddedForm[0.22874389842284915`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874211047903636`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891690215542*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228743898422849\"\>",
     0.22874389842284915`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.22874389842284915`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891690265139*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228742110479036\"\>",
     0.22874211047903636`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.22874211047903636`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891690327367*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     1.787943812781023\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-6\"\>"]}],
     1.7879438127810232`*^-6,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[1.7879438127810232`*^-6, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916903759737`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891690428815*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1028\"\>",
         0.10275354496945809`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1028\"\>",
         0.10275211718599052`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1.2523\"\>",
         1.2522892653942108`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916904783154`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916905275707`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 53.53\"\>",
         53.533097083613974`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891690576091*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891690632812*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.7319988210882116`*^-8"}],
  
  SequenceForm["NOISE  ", 3.7319988210882116`*^-8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891690688012*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "9.153287223350233`*^9", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "9.163321674348305`*^9"}],
  SequenceForm["*BFGSUP ", 9.153287223350233*^9, "  ", 9.163321674348305*^9],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916907289133`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "5.474300108397546`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 5.474300108397546, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916907792683`*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891690825533*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891690881258*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "13"}],
  SequenceForm["BFGS: Iteration = ", 13],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891690949188*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.167276481467495\"\>",
     0.16727648146749452`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228743898422849\"\>",
     0.22874389842284915`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[0.16727648146749452`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874389842284915`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891690997038*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.188320335595366\"\>",
     0.18832033559536643`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228743898422849\"\>",
     0.22874389842284915`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[0.18832033559536643`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874389842284915`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891691045089*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.187008211873610\"\>",
     0.1870082118736096,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228743898422849\"\>",
     0.22874389842284915`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[0.1870082118736096, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874389842284915`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916910946836`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186670549156616\"\>",
     0.18667054915661563`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228743898422849\"\>",
     0.22874389842284915`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[0.18667054915661563`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874389842284915`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089169114639*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186585521919015\"\>",
     0.1865855219190149,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228743898422849\"\>",
     0.22874389842284915`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
   PaddedForm[0.1865855219190149, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874389842284915`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891691213046*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186564226735015\"\>",
     0.18656422673501494`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228743898422849\"\>",
     0.22874389842284915`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
   PaddedForm[0.18656422673501494`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874389842284915`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891691251038*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186558900538213\"\>",
     0.18655890053821267`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228743898422849\"\>",
     0.22874389842284915`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 7, "  LIKNEU  ", 
   PaddedForm[0.18655890053821267`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874389842284915`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891691314431*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "8", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744344874996\"\>",
     0.2287443448749964,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228743898422849\"\>",
     0.22874389842284915`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 8, "  LIKNEU  ", 
   PaddedForm[0.2287443448749964, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874389842284915`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089169136623*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744344874996\"\>",
     0.2287443448749964,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.2287443448749964, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916914136143`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228743898422849\"\>",
     0.22874389842284915`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.22874389842284915`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891691463674*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     4.464521472513638\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-7\"\>"]}],
     4.4645214725136384`*^-7,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[4.4645214725136384`*^-7, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891691513289*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916915638742`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1028\"\>",
         0.1027539015026591,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1028\"\>",
         0.10275354496945809`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1.2522\"\>",
         1.2522127479314804`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916916173477`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891691663857*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 53.59\"\>",
         53.5917836763487,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916917294073`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891691770981*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.731856246247389`*^-8"}],
  SequenceForm["NOISE  ", 3.731856246247389*^-8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916918173447`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "1.4636557402537357`*^11", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "1.4679181203087387`*^11"}],
  SequenceForm[
  "*BFGSUP ", 1.4636557402537357`*^11, "  ", 1.4679181203087387`*^11],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916918659163`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "5.474205649641221`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 5.474205649641221, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916919141283`*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891691970727*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916920160007`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "14"}],
  SequenceForm["BFGS: Iteration = ", 14],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891692065987*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.167258802192203\"\>",
     0.1672588021922028,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744344874996\"\>",
     0.2287443448749964,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[0.1672588021922028, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287443448749964, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891692116191*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.188315763927334\"\>",
     0.18831576392733385`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744344874996\"\>",
     0.2287443448749964,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[0.18831576392733385`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287443448749964, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891692167865*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.187007342414223\"\>",
     0.18700734241422245`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744344874996\"\>",
     0.2287443448749964,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[0.18700734241422245`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287443448749964, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891692233382*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186670660924828\"\>",
     0.1866706609248281,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744344874996\"\>",
     0.2287443448749964,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[0.1866706609248281, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287443448749964, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891692276339*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186585882556936\"\>",
     0.18658588255693598`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744344874996\"\>",
     0.2287443448749964,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
   PaddedForm[0.18658588255693598`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287443448749964, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891692337878*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186564649814367\"\>",
     0.18656464981436716`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744344874996\"\>",
     0.2287443448749964,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
   PaddedForm[0.18656464981436716`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287443448749964, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089169239014*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186559339241945\"\>",
     0.18655933924194512`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744344874996\"\>",
     0.2287443448749964,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 7, "  LIKNEU  ", 
   PaddedForm[0.18655933924194512`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287443448749964, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916924461527`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "8", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744790017190\"\>",
     0.22874479001718973`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744344874996\"\>",
     0.2287443448749964,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 8, "  LIKNEU  ", 
   PaddedForm[0.22874479001718973`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287443448749964, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891692513874*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744790017190\"\>",
     0.22874479001718973`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.22874479001718973`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891692574925*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744344874996\"\>",
     0.2287443448749964,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.2287443448749964, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891692646803*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     4.451421933282518\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-7\"\>"]}],
     4.451421933282518*^-7,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[4.451421933282518*^-7, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891692708222*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916927938137`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1028\"\>",
         0.10275425699515775`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1028\"\>",
         0.1027539015026591,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1.2522\"\>",
         1.2521935850381851`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891692843175*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891692894452*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 53.75\"\>",
         53.747850805777965`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891692962521*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916930268383`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.7317993140106864`*^-8"}],
  
  SequenceForm["NOISE  ", 3.7317993140106864`*^-8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916930870123`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "1.4771295709782877`*^11", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "1.4722379726720328`*^11"}],
  SequenceForm[
  "*BFGSUP ", 1.4771295709782877`*^11, "  ", 1.4722379726720328`*^11],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891693143927*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "5.47411174374761`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 5.47411174374761, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916932037973`*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891693261187*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916933320913`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "15"}],
  SequenceForm["BFGS: Iteration = ", 15],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891693408217*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.167279576896758\"\>",
     0.16727957689675765`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744790017190\"\>",
     0.22874479001718973`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[0.16727957689675765`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874479001718973`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891693455422*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.188321816016518\"\>",
     0.1883218160165181,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744790017190\"\>",
     0.22874479001718973`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[0.1883218160165181, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874479001718973`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891693512701*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.187009254343462\"\>",
     0.18700925434346183`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744790017190\"\>",
     0.22874479001718973`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[0.18700925434346183`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874479001718973`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891693577611*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186671475144550\"\>",
     0.18667147514454996`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744790017190\"\>",
     0.22874479001718973`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[0.18667147514454996`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874479001718973`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089169362881*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186586418338873\"\>",
     0.18658641833887324`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744790017190\"\>",
     0.22874479001718973`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
   PaddedForm[0.18658641833887324`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874479001718973`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916936835423`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186565115734715\"\>",
     0.18656511573471457`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744790017190\"\>",
     0.22874479001718973`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
   PaddedForm[0.18656511573471457`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874479001718973`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916937329082`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186559787681110\"\>",
     0.18655978768111026`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744790017190\"\>",
     0.22874479001718973`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 7, "  LIKNEU  ", 
   PaddedForm[0.18655978768111026`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874479001718973`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891693784848*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "8", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745236624798\"\>",
     0.2287452366247975,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744790017190\"\>",
     0.22874479001718973`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 8, "  LIKNEU  ", 
   PaddedForm[0.2287452366247975, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874479001718973`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891693838138*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745236624798\"\>",
     0.2287452366247975,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.2287452366247975, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891693894307*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228744790017190\"\>",
     0.22874479001718973`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.22874479001718973`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891693977285*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     4.466076077846992\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-7\"\>"]}],
     4.466076077846992*^-7,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[4.466076077846992*^-7, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916940231333`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916940812683`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1028\"\>",
         0.102754613663377,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1028\"\>",
         0.10275425699515775`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1.2522\"\>",
         1.2521745413541794`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891694128768*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891694181005*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 53.57\"\>",
         53.569861751106046`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891694231257*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891694283074*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.7317424261829046`*^-8"}],
  
  SequenceForm["NOISE  ", 3.7317424261829046`*^-8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891694337617*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "5.474017412292923`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 5.474017412292923, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891694384871*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891694434635*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916945132437`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "16"}],
  SequenceForm["BFGS: Iteration = ", 16],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891694559223*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.167279859915925\"\>",
     0.1672798599159253,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745236624798\"\>",
     0.2287452366247975,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[0.1672798599159253, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287452366247975, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891694617032*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.188322207266949\"\>",
     0.18832220726694926`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745236624798\"\>",
     0.2287452366247975,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[0.18832220726694926`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287452366247975, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891694666519*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.187009684774646\"\>",
     0.1870096847746463,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745236624798\"\>",
     0.2287452366247975,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[0.1870096847746463, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287452366247975, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891694717434*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186671915775629\"\>",
     0.18667191577562847`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745236624798\"\>",
     0.2287452366247975,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[0.18667191577562847`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287452366247975, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891694766773*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186586861545822\"\>",
     0.1865868615458215,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745236624798\"\>",
     0.2287452366247975,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
   PaddedForm[0.1865868615458215, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287452366247975, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916948179827`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186565559587255\"\>",
     0.18656555958725507`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745236624798\"\>",
     0.2287452366247975,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
   PaddedForm[0.18656555958725507`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287452366247975, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891694869196*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186560231695153\"\>",
     0.1865602316951529,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745236624798\"\>",
     0.2287452366247975,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 7, "  LIKNEU  ", 
   PaddedForm[0.1865602316951529, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287452366247975, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891694916347*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "8", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186558899571936\"\>",
     0.18655889957193628`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745236624798\"\>",
     0.2287452366247975,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 8, "  LIKNEU  ", 
   PaddedForm[0.18655889957193628`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287452366247975, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891694969058*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "9", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745348273929\"\>",
     0.22874534827392856`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745236624798\"\>",
     0.2287452366247975,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 9, "  LIKNEU  ", 
   PaddedForm[0.22874534827392856`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.2287452366247975, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891695047303*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745348273929\"\>",
     0.22874534827392856`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.22874534827392856`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891695086273*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745236624798\"\>",
     0.2287452366247975,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.2287452366247975, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891695138947*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     1.116491310515499\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-7\"\>"]}],
     1.1164913105154994`*^-7,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[1.1164913105154994`*^-7, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089169518946*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089169524019*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1028\"\>",
         0.10275470282906934`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1028\"\>",
         0.102754613663377,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1.2522\"\>",
         1.2521554082632065`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891695293613*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891695354086*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 53.57\"\>",
         53.569861751106046`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891695405198*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891695460865*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.731706632592591`*^-8"}],
  SequenceForm["NOISE  ", 3.731706632592591*^-8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916955218277`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "2.294606700554483`*^12", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "2.3479232814745327`*^12"}],
  SequenceForm[
  "*BFGSUP ", 2.294606700554483*^12, "  ", 2.3479232814745327`*^12],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891695598308*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "5.473993373552024`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 5.473993373552024, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891695639058*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916956848793`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891695739523*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "17"}],
  SequenceForm["BFGS: Iteration = ", 17],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916957888803`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.167139087763714\"\>",
     0.16713908776371422`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745348273929\"\>",
     0.22874534827392856`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[0.16713908776371422`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874534827392856`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916958426647`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.188283457991576\"\>",
     0.18828345799157642`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745348273929\"\>",
     0.22874534827392856`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[0.18828345799157642`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874534827392856`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891695906398*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186999622972981\"\>",
     0.18699962297298067`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745348273929\"\>",
     0.22874534827392856`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[0.18699962297298067`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874534827392856`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891695956902*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186669454333187\"\>",
     0.18666945433318682`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745348273929\"\>",
     0.22874534827392856`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[0.18666945433318682`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874534827392856`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891696011243*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186586327607301\"\>",
     0.18658632760730054`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745348273929\"\>",
     0.22874534827392856`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
   PaddedForm[0.18658632760730054`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874534827392856`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891696080625*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186565509248225\"\>",
     0.18656550924822524`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745348273929\"\>",
     0.22874534827392856`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
   PaddedForm[0.18656550924822524`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874534827392856`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891696164537*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186560302363876\"\>",
     0.18656030236387622`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745348273929\"\>",
     0.22874534827392856`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 7, "  LIKNEU  ", 
   PaddedForm[0.18656030236387622`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874534827392856`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891696203725*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "8", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186559000499341\"\>",
     0.1865590004993407,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745348273929\"\>",
     0.22874534827392856`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 8, "  LIKNEU  ", 
   PaddedForm[0.1865590004993407, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874534827392856`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891696263858*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "9", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186558675024243\"\>",
     0.1865586750242425,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745348273929\"\>",
     0.22874534827392856`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 9, "  LIKNEU  ", 
   PaddedForm[0.1865586750242425, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874534827392856`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891696326593*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "10", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745375552208\"\>",
     0.22874537555220775`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745348273929\"\>",
     0.22874534827392856`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 10, "  LIKNEU  ", 
   PaddedForm[0.22874537555220775`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874534827392856`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916963961067`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745375552208\"\>",
     0.22874537555220775`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.22874537555220775`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891696462708*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745348273929\"\>",
     0.22874534827392856`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.22874534827392856`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916965274887`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     2.727827919102310\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-8\"\>"]}],
     2.7278279191023103`*^-8,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[2.7278279191023103`*^-8, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916965940237`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891696664651*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1028\"\>",
         0.10275472461421434`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1028\"\>",
         0.10275470282906934`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1.2522\"\>",
         1.252150520682335,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916967500267`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891696789291*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 54.81\"\>",
         54.81459003863286,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891696855287*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891696903666*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.731697861830696`*^-8"}],
  SequenceForm["NOISE  ", 3.731697861830696*^-8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891696959095*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "4.59774234248642`*^13", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "3.843995937619049`*^13"}],
  SequenceForm["*BFGSUP ", 4.59774234248642*^13, "  ", 3.843995937619049*^13],
  
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891697013582*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "5.473988356187556`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 5.473988356187556, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891697077594*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916971297398`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891697191698*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "18"}],
  SequenceForm["BFGS: Iteration = ", 18],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916972664413`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.123229412316636\"\>",
     0.1232294123166362,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745375552208\"\>",
     0.22874537555220775`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[0.1232294123166362, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874537555220775`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089169731929*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.188609585233092\"\>",
     0.18860958523309157`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745375552208\"\>",
     0.22874537555220775`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[0.18860958523309157`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874537555220775`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891697382506*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.187085356106055\"\>",
     0.18708535610605503`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745375552208\"\>",
     0.22874537555220775`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[0.18708535610605503`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874537555220775`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891697448155*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186691175667809\"\>",
     0.18669117566780868`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745375552208\"\>",
     0.22874537555220775`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[0.18669117566780868`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874537555220775`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916975148993`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186591795117621\"\>",
     0.18659179511762125`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745375552208\"\>",
     0.22874537555220775`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
   PaddedForm[0.18659179511762125`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874537555220775`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891697582246*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186566897521933\"\>",
     0.186566897521933,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745375552208\"\>",
     0.22874537555220775`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
   PaddedForm[0.186566897521933, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874537555220775`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916976513023`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186560669840557\"\>",
     0.18656066984055708`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745375552208\"\>",
     0.22874537555220775`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 7, "  LIKNEU  ", 
   PaddedForm[0.18656066984055708`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874537555220775`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891697718308*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "8", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186559112715002\"\>",
     0.18655911271500192`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745375552208\"\>",
     0.22874537555220775`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 8, "  LIKNEU  ", 
   PaddedForm[0.18655911271500192`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874537555220775`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891697811211*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "9", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186558723420786\"\>",
     0.1865587234207855,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745375552208\"\>",
     0.22874537555220775`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 9, "  LIKNEU  ", 
   PaddedForm[0.1865587234207855, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874537555220775`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891697850183*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "10", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745408179264\"\>",
     0.22874540817926392`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745375552208\"\>",
     0.22874537555220775`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 10, "  LIKNEU  ", 
   PaddedForm[0.22874540817926392`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874537555220775`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891697916086*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745408179264\"\>",
     0.22874540817926392`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.22874540817926392`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891697981698*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745375552208\"\>",
     0.22874537555220775`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.22874537555220775`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891698036899*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     3.262705616791095\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-8\"\>"]}],
     3.262705616791095*^-8,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[3.262705616791095*^-8, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891698092964*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891698149506*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1028\"\>",
         0.10275475067105866`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1028\"\>",
         0.10275472461421434`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1.2521\"\>",
         1.252149522304535,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916982145987`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916982634706`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 45.83\"\>",
         45.828375262283544`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891698346961*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891698387959*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.731694331321478`*^-8"}],
  SequenceForm["NOISE  ", 3.731694331321478*^-8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916984461117`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "2.7994340562097652`*^13", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "3.2138226179211977`*^13"}],
  SequenceForm[
  "*BFGSUP ", 2.7994340562097652`*^13, "  ", 3.2138226179211977`*^13],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891698500392*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "5.473981582250681`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 5.473981582250681, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891698557287*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891698621462*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916986815357`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "19"}],
  SequenceForm["BFGS: Iteration = ", 19],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891698735804*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.167392313220455\"\>",
     0.16739231322045534`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745408179264\"\>",
     0.22874540817926392`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[0.16739231322045534`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874540817926392`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891698796085*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.188353458144039\"\>",
     0.18835345814403892`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745408179264\"\>",
     0.22874540817926392`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[0.18835345814403892`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874540817926392`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891698851549*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.187017999470345\"\>",
     0.18701799947034492`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745408179264\"\>",
     0.22874540817926392`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[0.18701799947034492`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874540817926392`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891698917873*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186674146298264\"\>",
     0.1866741462982635,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745408179264\"\>",
     0.22874540817926392`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[0.1866741462982635, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874540817926392`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916989722567`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186587548613913\"\>",
     0.18658754861391258`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745408179264\"\>",
     0.22874540817926392`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
   PaddedForm[0.18658754861391258`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874540817926392`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891699026276*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186565859382553\"\>",
     0.18656585938255343`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745408179264\"\>",
     0.22874540817926392`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
   PaddedForm[0.18656585938255343`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874540817926392`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891699088489*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186560434584048\"\>",
     0.18656043458404747`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745408179264\"\>",
     0.22874540817926392`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 7, "  LIKNEU  ", 
   PaddedForm[0.18656043458404747`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874540817926392`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891699150383*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "8", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186559078228714\"\>",
     0.18655907822871365`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745408179264\"\>",
     0.22874540817926392`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 8, "  LIKNEU  ", 
   PaddedForm[0.18655907822871365`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874540817926392`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089169920761*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "9", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186558739130151\"\>",
     0.18655873913015086`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745408179264\"\>",
     0.22874540817926392`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 9, "  LIKNEU  ", 
   PaddedForm[0.18655873913015086`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874540817926392`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089169925513*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "10", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745436599346\"\>",
     0.22874543659934576`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745408179264\"\>",
     0.22874540817926392`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 10, "  LIKNEU  ", 
   PaddedForm[0.22874543659934576`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874540817926392`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891699345252*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745436599346\"\>",
     0.22874543659934576`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.22874543659934576`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608916994052153`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745408179264\"\>",
     0.22874540817926392`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.22874540817926392`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891703569742*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     2.842008184344991\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-8\"\>"]}],
     2.8420081843449907`*^-8,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[2.8420081843449907`*^-8, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891703614971*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891703676846*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1028\"\>",
         0.10275477336812262`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1028\"\>",
         0.10275475067105866`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1.2521\"\>",
         1.252148151397705,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089170373284*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891703791519*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 52.61\"\>",
         52.61215874465698,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608917038530293`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891703912567*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "3.731690489949813`*^-8"}],
  SequenceForm["NOISE  ", 3.731690489949813*^-8],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891703956542*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "5.473975625563276`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 5.473975625563276, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891704012308*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608917040673018`*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891704138932*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "20"}],
  SequenceForm["BFGS: Iteration = ", 20],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608917041765127`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.167392331095354\"\>",
     0.16739233109535356`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745436599346\"\>",
     0.22874543659934576`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
   PaddedForm[0.16739233109535356`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874543659934576`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891704228422*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.188353482997623\"\>",
     0.18835348299762278`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745436599346\"\>",
     0.22874543659934576`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
   PaddedForm[0.18835348299762278`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874543659934576`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891704283758*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.187018026849264\"\>",
     0.18701802684926427`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745436599346\"\>",
     0.22874543659934576`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
   PaddedForm[0.18701802684926427`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874543659934576`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891704345483*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186674174335036\"\>",
     0.18667417433503575`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745436599346\"\>",
     0.22874543659934576`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
   PaddedForm[0.18667417433503575`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874543659934576`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891704400703*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186587576816843\"\>",
     0.18658757681684257`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745436599346\"\>",
     0.22874543659934576`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 5, "  LIKNEU  ", 
   PaddedForm[0.18658757681684257`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874543659934576`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891704462578*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "6", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186565887627132\"\>",
     0.1865658876271319,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745436599346\"\>",
     0.22874543659934576`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 6, "  LIKNEU  ", 
   PaddedForm[0.1865658876271319, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874543659934576`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608917045183153`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "7", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186560462839046\"\>",
     0.18656046283904582`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745436599346\"\>",
     0.22874543659934576`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 7, "  LIKNEU  ", 
   PaddedForm[0.18656046283904582`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874543659934576`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891704580964*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "8", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186559106486317\"\>",
     0.18655910648631657`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745436599346\"\>",
     0.22874543659934576`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 8, "  LIKNEU  ", 
   PaddedForm[0.18655910648631657`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874543659934576`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608917046360083`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "9", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186558767388403\"\>",
     0.18655876738840305`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745436599346\"\>",
     0.22874543659934576`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 9, "  LIKNEU  ", 
   PaddedForm[0.18655876738840305`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874543659934576`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608917060487423`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "10", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.186558682613317\"\>",
     0.18655868261331698`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745436599346\"\>",
     0.22874543659934576`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 10, "  LIKNEU  ", 
   PaddedForm[0.18655868261331698`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874543659934576`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891706089099*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "11", 
   "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745443704354\"\>",
     0.22874544370435435`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ], "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", 
   "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745436599346\"\>",
     0.22874543659934576`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["STEP-REDUCTION:  ", 11, "  LIKNEU  ", 
   PaddedForm[0.22874544370435435`, {20, 15}], "  LIKALT  ", 
   PaddedForm[0.22874543659934576`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891706155209*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745443704354\"\>",
     0.22874544370435435`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[0.22874544370435435`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891706222637*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.228745436599346\"\>",
     0.22874543659934576`,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[0.22874543659934576`, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891706289901*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     7.105008581476113\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-9\"\>"]}],
     7.105008581476113*^-9,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[7.105008581476113*^-9, {20, 15}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891706354191*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891706421733*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.1028\"\>",
         0.10275477904238314`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1028\"\>",
         0.10275477336812262`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\" 1.2521\"\>",
         1.2521469444036484`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.4608917064895372`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891706553858*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 52.61\"\>",
         52.61215874465698,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891706647167*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891706686625*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "0.04218678239095364`"}],
  SequenceForm["NOISE  ", 0.04218678239095364],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891706736494*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "62.24929516275075`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "5.903306534719071`*^14"}],
  SequenceForm["*BFGSUP ", 62.24929516275075, "  ", 5.903306534719071*^14],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891706789342*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "1.237666527506561`*^7", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 1.237666527506561*^7, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.46089170685561*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891706926806*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS:  ENDE DER ITERATION  \"\>", "\[InvisibleSpace]", "20", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "20"}],
  SequenceForm["BFGS:  ENDE DER ITERATION  ", 20, "  ", 20],
  Editable->False]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891707013137*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {"1", 
       RowBox[{"-", "2.831105789925158`*^6"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}]]]], "Print",\

 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891707079031*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891707150168*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox[
         RowBox[{"\<\" 4.989\"\>", "\[Times]", 
          SuperscriptBox["10", "\<\"14\"\>"]}],
         4.9893850157015344`*^14,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891707228581*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"Likelihood\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm]},
      {"1", "0.2250864439865401`", "0.1`"},
      {"2", "0.22643246555536667`", "0.1009765625`"},
      {"3", "0.2283452563832502`", "0.1024373416770707`"},
      {"4", "0.22845849041127364`", "0.10252672560648614`"},
      {"5", "0.22857377489060582`", "0.10261807990307092`"},
      {"6", "0.2286885093135289`", "0.10270935380094004`"},
      {"7", "0.2287170959298983`", "0.10273215066683115`"},
      {"8", "0.2287242449449296`", "0.10273785524310657`"},
      {"9", "0.2287313915300131`", "0.1027435592723878`"},
      {"10", "0.22873853672626865`", "0.10274926358528853`"},
      {"11", "0.22874032231685004`", "0.10275068931538436`"},
      {"12", "0.22874211047903636`", "0.10275211718599052`"},
      {"13", "0.22874389842284915`", "0.10275354496945809`"},
      {"14", "0.2287443448749964`", "0.1027539015026591`"},
      {"15", "0.22874479001718973`", "0.10275425699515775`"},
      {"16", "0.2287452366247975`", "0.102754613663377`"},
      {"17", "0.22874534827392856`", "0.10275470282906934`"},
      {"18", "0.22874537555220775`", "0.10275472461421434`"},
      {"19", "0.22874540817926392`", "0.10275475067105866`"},
      {"20", "0.22874543659934576`", "0.10275477336812262`"},
      {"21", "0.22874544370435435`", "0.10275477904238314`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"Likelihood", "THETA"}}]]]], "Print",
 CellChangeTimes->{3.46071787611558*^9, 3.460889574835803*^9, 
  3.460891707270742*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "0.1`", "0.10275477904238314`", "4.4768906923540337`*^-8"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.4603673130895653`*^9, 3.4607175575060387`*^9, {3.460717623410822*^9, 
   3.460717631849646*^9}, 3.4607177103844147`*^9, 3.460717770338664*^9, 
   3.460717831260625*^9, 3.460717899904481*^9, 3.460889583909008*^9, 
   3.460891711112677*^9}]
}, Open  ]],

Cell[BoxData["Linear"], "Input",
 CellChangeTimes->{{3.4603672747359133`*^9, 3.4603672757633257`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "THETA", ",", "COV", ",", "LIKI", ",", "psii", ",", "scoreii", ",", "k", 
      ",", "ReturnCode"}], "}"}], "=", "\[IndentingNewLine]", 
    RowBox[{"BFGS", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"Y", ",", "X", ",", 
         RowBox[{"-", "9"}]}], "}"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"THETA0", ",", "F0"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      "\t  ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Idio", ",", 
          RowBox[{"{", "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"Lik", ",", "IndividualLik", ",", "Score", ",", "Hesse"}], 
         "}"}]}], "}"}], ",", "\[IndentingNewLine]", "            ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Sing", "=", "False"}], ",", "1"}], "}"}], ",", 
        RowBox[{"KMAX", "=", "30"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"EPS1", "=", ".0001"}], ",", 
          RowBox[{"EPS2", "=", ".0001"}]}], "}"}], ",", "\[IndentingNewLine]",
         "             ", 
        RowBox[{"OPTION", "=", "0"}], ",", 
        RowBox[{"PRINT", "=", 
         RowBox[{"{", 
          RowBox[{
          "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", 
           ",", "1", ",", "1"}], "}"}]}]}], "}"}]}], "]"}]}], ";"}], 
  "                                                                           \
     "}]], "Input",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113330285616*^9, 3.460113346379695*^9}, {
   3.460200648978776*^9, 3.4602006503583603`*^9}, {3.460200794874672*^9, 
   3.4602007984595947`*^9}, 3.460201903279232*^9, {3.460201941045977*^9, 
   3.4602019411313553`*^9}, {3.460279278878285*^9, 3.460279290392777*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Tiefe von data = \"\>", "\[InvisibleSpace]", "5"}],
  SequenceForm["Tiefe von data = ", 5],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891741518045*^9}],

Cell[BoxData["\<\"L\[ADoubleDot]nge der Paneldaten\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891741523869*^9}],

Cell[BoxData[
 RowBox[{"{", "1", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917415322113`*^9}],

Cell[BoxData["\<\"***********************LSDE1********************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891741540304*^9}],

Cell[BoxData["\<\"***********************MODUL:    BFGS \
(skeleton)**************\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891741548954*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891741557272*^9}],

Cell[BoxData["\<\"Technical Output\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.46089174156567*^9}],

Cell[BoxData["IndividualLik"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891741614766*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891741681526*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"KMAX\"\>",
       HoldForm], 
      TagBox["\<\"EPS1\"\>",
       HoldForm], 
      TagBox["\<\"EPS2\"\>",
       HoldForm], 
      TagBox["\<\"K\"\>",
       HoldForm], 
      TagBox["\<\"Q\"\>",
       HoldForm], 
      TagBox["\<\"n\"\>",
       HoldForm], 
      TagBox["\<\"T\"\>",
       HoldForm], 
      TagBox["\<\"OPTION\"\>",
       HoldForm]},
     {"1", "30", "0.0001`", "0.0001`", "1", "1", "1", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"KMAX", "EPS1", "EPS2", "K", "Q", "n", "T", "OPTION"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917417507133`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891741818493*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"MAXSTEP\"\>",
       HoldForm], 
      TagBox["\<\"MINSTEP\"\>",
       HoldForm], 
      TagBox["\<\"BOUND\"\>",
       HoldForm], 
      TagBox["\<\"STEPREDUCE\"\>",
       HoldForm], 
      TagBox["\<\"FMAX\"\>",
       HoldForm]},
     {"1", "1", "1.`*^-10", "1.`*^-6", "4", "1000"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {"MAXSTEP", "MINSTEP", "BOUND", "STEPREDUCE", "FMAX"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917418812857`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891741952973*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"RESAMPLING\"\>",
       HoldForm], 
      TagBox["\<\"FDIGITS\"\>",
       HoldForm], 
      TagBox["\<\"TYP\"\>",
       HoldForm], 
      TagBox["\<\"YMAX\"\>",
       HoldForm], 
      TagBox["\<\"ANALGRAD\"\>",
       HoldForm], 
      TagBox["\<\"FACTOR\"\>",
       HoldForm], 
      TagBox["\<\"CSEED\"\>",
       HoldForm]},
     {"1", "True", "16", "1", "1.`*^8", "False", "1.`", 
      RowBox[{"-", "999"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {
     Automatic, {
      "RESAMPLING", "FDIGITS", "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}},
     TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891742038559*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891742075542*^9}],

Cell[BoxData["\<\"    SCALING\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891742132251*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Transpose", "::", "\<\"nmtx\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The first two levels of the \
one-dimensional list \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\
\\!\\({}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" cannot be \
transposed.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Transpose\\\", ButtonNote -> \\\"Transpose::nmtx\\\
\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.460113347438837*^9, 3.4601140477211742`*^9, 3.460114171488365*^9, 
   3.4601142582303123`*^9, 3.46011431981378*^9, 3.4601210026174927`*^9, 
   3.4602006082555428`*^9, 3.4602006525509787`*^9, 3.4602007997492933`*^9, {
   3.460201893745349*^9, 3.460201903902554*^9}, 3.4602019417761383`*^9, 
   3.460279294169009*^9, 3.4603672286821957`*^9, 3.4608896046990023`*^9, 
   3.4608896751100187`*^9, 3.460891742196467*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 TagBox[
  RowBox[{"Transpose", "[", 
   RowBox[{"{", "}"}], "]"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
    0]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917422496767`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891742298688*^9}],

Cell[BoxData["\<\"************************************************************\
**\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891742367177*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.46089174243327*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"STARTWERT THETA0 = \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "0.1`", "}"}]}],
  SequenceForm["STARTWERT THETA0 = ", {0.1}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891742499016*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891742559732*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"-", "0.09884622954996303`"}], "}"}], ",", 
   RowBox[{"-", "0.005801749745485348`"}]}], "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891742598241*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917426511087`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["BFGS: Iteration = ", 1],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917427174597`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -0.000835514643433\"\>",
     -0.0008355146434334485,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-0.0008355146434334485, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891742787572*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -0.005801749745485\"\>",
     -0.005801749745485348,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-0.005801749745485348, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891742853527*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"     0.004966235102052\"\>",
     0.004966235102051899,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[0.004966235102051899, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891742912922*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891742984601*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.0012\"\>",
         0.0011537704500369783`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.1000\"\>",
         0.1,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0988\"\>",
         -0.09884622954996303,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0988\"\>",
         -0.09884622954996303,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917430569696`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.46089174313876*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891743180825*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.46089174324625*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.4900874514313378`*^-9"}],
  
  SequenceForm["NOISE  ", 1.4900874514313378`*^-9],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917433069983`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "103.55481514310641`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "102.34809982558974`"}],
  SequenceForm["*BFGSUP ", 103.55481514310641`, "  ", 102.34809982558974`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891743369817*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "1.3786072874986963`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 1.3786072874986963`, " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891743418391*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917434687023`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "2"}],
  SequenceForm["BFGS: Iteration = ", 2],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917435198183`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -0.000834850229917\"\>",
     -0.0008348502299167515,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-0.0008348502299167515, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891743579558*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -0.000835514643433\"\>",
     -0.0008355146434334485,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-0.0008355146434334485, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891743637871*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     6.644135166970592\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-7\"\>"]}],
     6.644135166970593*^-7,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[6.644135166970593*^-7, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891743718152*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891743762475*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\"-0.0000\"\>",
         -0.000011656748708979443`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0012\"\>",
         0.0011537704500369783`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0012\"\>",
         -0.0011654271987459578`,
         AutoDelete->True], 
        InterpretationBox["\<\"-0.0012\"\>",
         -0.001151846576249227,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917438212233`*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917438724957`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.9883\"\>",
         0.9883470863634004,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891743933374*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917439832497`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.733708966319969`*^-11"}],
  
  SequenceForm["NOISE  ", 1.733708966319969*^-11],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891744037394*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "737494.4697873261`", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "744938.1478498515`"}],
  SequenceForm["*BFGSUP ", 737494.4697873261, "  ", 744938.1478498515],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891744088563*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "0.013925630846871939`", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 0.013925630846871939`, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891744140109*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.46089174419844*^9}],

Cell[BoxData["\<\"------------------------------------------------------------\
-----\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891744283381*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS: Iteration = \"\>", "\[InvisibleSpace]", "3"}],
  SequenceForm["BFGS: Iteration = ", 3],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891744338544*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -0.000834850162090\"\>",
     -0.0008348501620904257,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU  ", 
   PaddedForm[-0.0008348501620904257, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891744396442*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox["\<\"    -0.000834850229917\"\>",
     -0.0008348502299167515,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKALT  ", 
   PaddedForm[-0.0008348502299167515, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891744446268*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
   TagBox[
    InterpretationBox[
     RowBox[{"\<\"     6.782632582750386\"\>", "\[Times]", 
      SuperscriptBox["10", "\<\"-11\"\>"]}],
     6.782632582750386*^-11,
     AutoDelete->True],
    PaddedForm[#, {20, 15}]& ]}],
  SequenceForm["LIKNEU - LIKALT  ", 
   PaddedForm[6.782632582750386*^-11, {20, 15}]],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891744489827*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891744538946*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"THETA1\"\>",
         HoldForm], 
        TagBox["\<\"THETA\"\>",
         HoldForm], 
        TagBox["\<\"STEP\"\>",
         HoldForm], 
        TagBox["\<\"SCORE\"\>",
         HoldForm]},
       {
        InterpretationBox["\<\" 1.0000\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.0000\"\>",
         0,
         Editable->False], 
        InterpretationBox["\<\"-0.0000\"\>",
         -0.000011656748708979443`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0.000011645349211629197`,
         AutoDelete->True], 
        InterpretationBox["\<\" 0.0000\"\>",
         0.000011625816114246845`,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[
    BoxForm`e$, 
     TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP", "SCORE"}}]]],
  PaddedForm[#, {5, 4}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891744593116*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891744675935*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.9983\"\>",
         0.9983226696746159,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917447394543`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Score: INC: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "1.4901161193847656`*^-8", "}"}]}],
  SequenceForm["Score: INC: ", {1.4901161193847656`*^-8}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891744805872*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"NOISE  \"\>", "\[InvisibleSpace]", "1.733490738106691`*^-13"}],
  
  SequenceForm["NOISE  ", 1.733490738106691*^-13],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891744856141*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"*BFGSUP \"\>", "\[InvisibleSpace]", "7.390982528831844`*^9", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", 
   "7.386250531180644`*^9"}],
  SequenceForm["*BFGSUP ", 7.390982528831844*^9, "  ", 7.386250531180644*^9],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891744902582*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"relgrad = \"\>", "\[InvisibleSpace]", "8.91573719129665`*^-6", 
   "\[InvisibleSpace]", "\<\" = Elastizitaet(d l/l)/(d theta/theta)\"\>"}],
  SequenceForm[
  "relgrad = ", 8.91573719129665*^-6, 
   " = Elastizitaet(d l/l)/(d theta/theta)"],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917449577637`*^9}],

Cell[BoxData["\<\"ReturnCode = 1\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.46089174501159*^9}],

Cell[BoxData["\<\"ReturnCode = 2\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917450671167`*^9}],

Cell[BoxData["\<\"ReturnCode = 3\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891745128153*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"BFGS:  ENDE DER ITERATION  \"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"  \"\>", "\[InvisibleSpace]", "30"}],
  SequenceForm["BFGS:  ENDE DER ITERATION  ", 3, "  ", 30],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891745173648*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"SCORE\"\>",
        HoldForm]},
      {"1", "7.443304639309645`*^-9"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}]]]], "Print",\

 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891745224331*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917452740097`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", 
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False]},
       {
        InterpretationBox["\<\" 1\"\>",
         1,
         Editable->False], 
        InterpretationBox["\<\" 0.9977\"\>",
         0.9976835042443621,
         AutoDelete->True]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.24]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
    "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  NumberForm[#, 4, NumberSigns -> {"-", " "}]& ]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891745343947*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], 
       TagBox["\<\"Likelihood\"\>",
        HoldForm], 
       TagBox["\<\"THETA\"\>",
        HoldForm]},
      {"1", 
       RowBox[{"-", "0.005801749745485348`"}], "0.1`"},
      {"2", 
       RowBox[{"-", "0.0008355146434334485`"}], "0.0011537704500369783`"},
      {"3", 
       RowBox[{"-", "0.0008348502299167515`"}], 
       RowBox[{"-", "0.000011656748708979443`"}]},
      {"4", 
       RowBox[{"-", "0.0008348501620904257`"}], 
       RowBox[{"-", "1.1399497350245356`*^-8"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"Likelihood", "THETA"}}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891745387739*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"INK: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "6.055454452393343`*^-6", "}"}]}],
  SequenceForm["INK: ", {6.055454452393343*^-6}],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891745447575*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917454983377`*^9}],

Cell[BoxData["\<\"ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891745547452*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891745599477*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", 
     TagBox[GridBox[{
        {
         StyleBox["\[Null]",
          ShowStringCharacters->False], 
         TagBox["\<\"THETA\"\>",
          HoldForm], 
         TagBox["\<\"SCORE\"\>",
          HoldForm]},
        {"1", 
         RowBox[{"-", "1.1399497350245356`*^-8"}], "7.443304639309645`*^-9"}
       },
       GridBoxAlignment->{
        "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
         "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
       GridBoxDividers->{
        "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
         "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.7]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.24]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
     "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[
     BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}]]], 
   "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
   RowBox[{"-", "0.0008348501620904257`"}]}],
  SequenceForm[
   MatrixForm[{{-1.1399497350245356`*^-8, 7.443304639309645*^-9}}, 
    TableHeadings -> {Automatic, {"THETA", "SCORE"}}], 
   "   Likelihood = ", -0.0008348501620904257],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891745662045*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891745712205*^9}],

Cell[BoxData["\<\"WALD-TEST:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891745763185*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917458137074`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"CHI \"\>",
       HoldForm], 
      TagBox["\<\"U \"\>",
       HoldForm], 
      TagBox["\<\"PROB \"\>",
       HoldForm], 
      TagBox["\<\"ALPHA \"\>",
       HoldForm]},
     {"1", "1.2973156715479558`*^-16", "1", "0.9999999909121136`", "0.05`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", "ALPHA "}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891745874888*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917459108353`*^9}],

Cell[BoxData["\<\"BONFERRONI-KONFIDENZINTERVALLE:\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891745964313*^9}],

Cell[BoxData["\<\"------------------------------------------------------\"\>"]\
, "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891746014474*^9}],

Cell[BoxData["\<\"P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= \
1-ALPHA\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891746061109*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"QUANTIL Z(1-ALPHA/2U) = \"\>", "\[InvisibleSpace]", 
   "1.9599639845400527`"}],
  SequenceForm["QUANTIL Z(1-ALPHA/2U) = ", 1.9599639845400527`],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891746115687*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"THETA\"\>",
       HoldForm], 
      TagBox["\<\"GRENZE\"\>",
       HoldForm], 
      TagBox["\<\"STD\"\>",
       HoldForm]},
     {"1", 
      RowBox[{"-", "1.1399497350245356`*^-8"}], "1.9616022942997493`", 
      "1.0008358876860082`"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
    TableDirections -> {Column, Row}, TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891746166851*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891746215641*^9}],

Cell[BoxData["\<\"Korrelation der ML-Sch\[ADoubleDot]tzer\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917462657557`*^9}],

Cell[BoxData["\<\"-------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891746315185*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "1.`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891746377071*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917464131327`*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND \
EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891746467589*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891746517247*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "1.0016724740802398`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891746568104*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891746617156*^9}],

Cell[BoxData[
 RowBox[{"{", "1.0016724740802398`", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891746667564*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891746712579*^9}],

Cell[BoxData["\<\"GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX \
UND EIGENWERTE\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891746773555*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891746838203*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1"},
      {"1", "0.9983303184189267`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891746919217*^9}],

Cell[BoxData["\<\"\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917469591017`*^9}],

Cell[BoxData[
 RowBox[{"{", "0.9983303184189267`", "}"}]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917470203257`*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891747068985*^9}],

Cell[BoxData["\<\"KOMPENSIERTE LIKELIHOOD\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891747121834*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.46089174718714*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"U =  \"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"  Nue = \"\>", "\[InvisibleSpace]", "1"}],
  SequenceForm["U =  ", 1, "  Nue = ", 1],
  Editable->False]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891747253478*^9}],

Cell[BoxData["\<\"AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) \
AZENCOTT/DACUNHA-CASTELLE (A/D)\"\>"], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.4608917473205748`*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {
      StyleBox["\[Null]",
       ShowStringCharacters->False], 
      TagBox["\<\"LIK\"\>",
       HoldForm], 
      TagBox["\<\"AIC\"\>",
       HoldForm], 
      TagBox["\<\"SIC/RISS\"\>",
       HoldForm], 
      TagBox["\<\"A/D\"\>",
       HoldForm]},
     {
      TagBox["\<\"Kompensator\"\>",
       HoldForm], "0", "1", "0.`", "Indeterminate"},
     {
      TagBox["\<\"komp. Lik.\"\>",
       HoldForm], 
      RowBox[{"-", "0.0008348501620904257`"}], 
      RowBox[{"-", "1.0008348501620905`"}], 
      RowBox[{"-", "0.0008348501620904257`"}], "Indeterminate"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxDividers->{
     "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
      "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[1.4]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
  Function[BoxForm`e$, 
   TableForm[
   BoxForm`e$, 
    TableHeadings -> {{"Kompensator", "komp. Lik."}, {
      "LIK", "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
    TableSpacing -> {1, 2}]]]], "Print",
 PageWidth->Infinity,
 CellChangeTimes->{{3.460113334275879*^9, 3.460113346954095*^9}, 
   3.460114046995338*^9, 3.460114170809881*^9, 3.4601142577461433`*^9, 
   3.460114319138585*^9, 3.460121001916587*^9, 3.460200607557255*^9, 
   3.460200652466147*^9, 3.460200799623768*^9, {3.460201893225623*^9, 
   3.460201903837278*^9}, 3.4602019417096663`*^9, 3.460279293743909*^9, 
   3.460367228287848*^9, 3.4608896044249687`*^9, 3.460889675005745*^9, 
   3.460891747371139*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"std", "=", 
   SqrtBox[
    RowBox[{"VecDiag", "[", "COV", "]"}]]}], ";"}], "\n", 
 RowBox[{"MatrixForm", "[", 
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{"Theta", ",", "THETA", ",", "std"}], "}"}], "]"}], 
  "]"}]}], "Input",
 PageWidth->Infinity,
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       StyleBox["\[Null]",
        ShowStringCharacters->False], "1", "2", "3"},
      {"1", "0.1`", 
       RowBox[{"-", "1.1399497350245356`*^-8"}], "1.0008358876860082`"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.24]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
   "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.460113389973647*^9, 3.460114056100081*^9, 
  3.460114179071628*^9, 3.4601142697179193`*^9, 3.460114343759589*^9, 
  3.460121016537031*^9, 3.4602008503444023`*^9, 3.460201923221129*^9, 
  3.460201965915328*^9, 3.4602793122704687`*^9, 3.460889685603642*^9, 
  3.460891748811496*^9}]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]]
},
AutoGeneratedPackage->None,
ScreenStyleEnvironment->"Working",
PrintingStyleEnvironment->"Working",
WindowToolbars->{},
WindowSize->{1359, 824},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowSelection->True,
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
Magnification->1,
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (February 18, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3460467319-4560556"->{
  Cell[441523, 11311, 194, 4, 42, "Print",
   CellTags->"Info3460467319-4560556"],
  Cell[441720, 11317, 1290, 36, 64, "Print",
   CellTags->"Info3460467319-4560556"]},
 "Info3460898558-4560556"->{
  Cell[6832275, 134202, 196, 4, 42, "Print",
   CellTags->"Info3460898558-4560556"],
  Cell[6832474, 134208, 1288, 36, 64, "Print",
   CellTags->"Info3460898558-4560556"]},
 "Info3461062918-2707977"->{
  Cell[2275283, 48833, 196, 4, 42, "Print",
   CellTags->"Info3461062918-2707977"],
  Cell[2275482, 48839, 1290, 36, 64, "Print",
   CellTags->"Info3461062918-2707977"]},
 "Info3461062927-3135492"->{
  Cell[4505288, 88924, 196, 4, 42, "Print",
   CellTags->"Info3461062927-3135492"],
  Cell[4505487, 88930, 1290, 36, 64, "Print",
   CellTags->"Info3461062927-3135492"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3460467319-4560556", 7566766, 151391},
 {"Info3460898558-4560556", 7566964, 151396},
 {"Info3461062918-2707977", 7567166, 151401},
 {"Info3461062927-3135492", 7567366, 151406}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 27, 0, 34, "Subsection"],
Cell[CellGroupData[{
Cell[619, 26, 53, 1, 27, "Input"],
Cell[675, 29, 1658, 27, 103, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2370, 61, 286, 7, 43, "Input"],
Cell[2659, 70, 931, 16, 23, "Message"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3639, 92, 218, 4, 67, "Section"],
Cell[CellGroupData[{
Cell[3882, 100, 89, 2, 34, "Subsection"],
Cell[3974, 104, 137, 6, 56, "Text"],
Cell[4114, 112, 236, 9, 71, "Text"],
Cell[CellGroupData[{
Cell[4375, 125, 332, 10, 27, "Input"],
Cell[4710, 137, 262, 6, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5009, 148, 633, 19, 58, "Input"],
Cell[5645, 169, 138, 3, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5820, 177, 403, 13, 27, "Input"],
Cell[6226, 192, 1062, 29, 57, "Output"]
}, Open  ]],
Cell[7303, 224, 443, 14, 43, "Input"],
Cell[CellGroupData[{
Cell[7771, 242, 112, 3, 27, "Input"],
Cell[7886, 247, 212, 6, 27, "Output"]
}, Open  ]],
Cell[8113, 256, 582, 19, 48, "Input"],
Cell[CellGroupData[{
Cell[8720, 279, 116, 3, 27, "Input"],
Cell[8839, 284, 286, 9, 47, "Output"]
}, Open  ]],
Cell[9140, 296, 1206, 34, 133, "Input"],
Cell[CellGroupData[{
Cell[10371, 334, 137, 4, 27, "Input"],
Cell[10511, 340, 161, 4, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10709, 349, 275, 7, 27, "Input"],
Cell[10987, 358, 472, 14, 33, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11496, 377, 460, 14, 58, "Input"],
Cell[11959, 393, 190, 5, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12186, 403, 482, 15, 58, "Input"],
Cell[12671, 420, 186, 5, 47, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[12906, 431, 79, 2, 26, "Subsection"],
Cell[12988, 435, 2788, 69, 268, "Input"],
Cell[CellGroupData[{
Cell[15801, 508, 955, 24, 103, "Input"],
Cell[16759, 534, 1606, 37, 85, "Output"],
Cell[18368, 573, 1533, 37, 85, "Output"],
Cell[19904, 612, 1606, 37, 85, "Output"],
Cell[21513, 651, 1606, 37, 85, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[23168, 694, 114, 3, 34, "Subsection"],
Cell[CellGroupData[{
Cell[23307, 701, 884, 22, 73, "Input"],
Cell[24194, 725, 780, 13, 27, "Output"],
Cell[24977, 740, 737, 12, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25751, 757, 69, 1, 27, "Input"],
Cell[25823, 760, 168, 2, 27, "Output"]
}, Open  ]],
Cell[26006, 765, 1075, 31, 58, "Input"],
Cell[CellGroupData[{
Cell[27106, 800, 98, 1, 27, "Input"],
Cell[27207, 803, 749, 18, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27993, 826, 655, 12, 27, "Input"],
Cell[28651, 840, 797, 23, 20, "Print"],
Cell[29451, 865, 2589, 46, 430, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32077, 916, 291, 8, 27, "Input"],
Cell[32371, 926, 1240, 31, 97, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[33648, 962, 337, 8, 27, "Input"],
Cell[33988, 972, 874, 24, 20, "Print"],
Cell[34865, 998, 2157, 41, 374, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[37059, 1044, 136, 4, 27, "Input"],
Cell[37198, 1050, 469, 8, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[37704, 1063, 178, 5, 27, "Input"],
Cell[37885, 1070, 1611, 36, 43, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[39533, 1111, 83, 2, 27, "Input"],
Cell[39619, 1115, 439, 8, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40095, 1128, 145, 3, 27, "Input"],
Cell[40243, 1133, 660, 13, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40940, 1151, 781, 21, 43, "Input"],
Cell[41724, 1174, 999, 20, 249, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[42772, 1200, 100, 2, 27, "Subsection"],
Cell[CellGroupData[{
Cell[42897, 1206, 32, 0, 24, "Subsubsection"],
Cell[CellGroupData[{
Cell[42954, 1210, 206, 6, 27, "Input"],
Cell[43163, 1218, 424, 10, 70, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[43624, 1233, 117, 3, 27, "Input"],
Cell[43744, 1238, 450, 8, 70, "Output"]
}, Open  ]],
Cell[44209, 1249, 209, 8, 46, "Input"],
Cell[CellGroupData[{
Cell[44443, 1261, 85, 2, 27, "Input"],
Cell[44531, 1265, 2278, 51, 70, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[46846, 1321, 76, 2, 27, "Input"],
Cell[46925, 1325, 664, 12, 70, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[47626, 1342, 69, 1, 27, "Input"],
Cell[47698, 1345, 218, 3, 70, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[47953, 1353, 246, 8, 46, "Input"],
Cell[48202, 1363, 629, 12, 70, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[48868, 1380, 316, 9, 58, "Input"],
Cell[49187, 1391, 1528, 35, 70, "Output"],
Cell[50718, 1428, 490, 9, 70, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[51245, 1442, 125, 1, 43, "Input"],
Cell[51373, 1445, 702, 19, 70, "Output"],
Cell[52078, 1466, 369, 7, 70, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[52484, 1478, 545, 16, 27, "Input"],
Cell[53032, 1496, 415, 7, 70, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[53484, 1508, 466, 14, 27, "Input"],
Cell[53953, 1524, 336, 5, 70, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[54326, 1534, 469, 14, 27, "Input"],
Cell[54798, 1550, 409, 6, 70, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[55244, 1561, 95, 1, 27, "Input"],
Cell[55342, 1564, 187, 4, 70, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[55566, 1573, 470, 12, 27, "Input"],
Cell[56039, 1587, 417, 6, 70, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[56505, 1599, 27, 0, 18, "Subsubsection"],
Cell[CellGroupData[{
Cell[56557, 1603, 435, 10, 103, "Input"],
Cell[56995, 1615, 348, 7, 27, "Output"],
Cell[57346, 1624, 599, 14, 27, "Output"],
Cell[57948, 1640, 258, 4, 27, "Output"],
Cell[58209, 1646, 263, 4, 27, "Output"],
Cell[58475, 1652, 258, 4, 27, "Output"],
Cell[58736, 1658, 258, 4, 27, "Output"]
}, Open  ]],
Cell[59009, 1665, 106, 2, 26, "Text"],
Cell[CellGroupData[{
Cell[59140, 1671, 1850, 49, 88, "Input"],
Cell[CellGroupData[{
Cell[61015, 1724, 450, 7, 20, "Print"],
Cell[61468, 1733, 447, 7, 20, "Print"],
Cell[61918, 1742, 448, 7, 20, "Print"],
Cell[62369, 1751, 402, 6, 20, "Print"],
Cell[62774, 1759, 383, 6, 20, "Print"],
Cell[63160, 1767, 448, 7, 20, "Print"],
Cell[63611, 1776, 1804, 50, 38, "Print"],
Cell[65418, 1828, 386, 6, 20, "Print"],
Cell[65807, 1836, 1626, 43, 42, "Print"],
Cell[67436, 1881, 384, 6, 20, "Print"],
Cell[67823, 1889, 1783, 49, 38, "Print"],
Cell[69609, 1940, 384, 6, 20, "Print"],
Cell[69996, 1948, 395, 6, 20, "Print"]
}, Open  ]],
Cell[70406, 1957, 882, 15, 23, "Message"],
Cell[CellGroupData[{
Cell[71313, 1976, 563, 13, 20, "Print"],
Cell[71879, 1991, 384, 6, 20, "Print"],
Cell[72266, 1999, 448, 7, 20, "Print"],
Cell[72717, 2008, 386, 6, 20, "Print"],
Cell[73106, 2016, 636, 13, 20, "Print"],
Cell[73745, 2031, 612, 13, 20, "Print"],
Cell[74360, 2046, 451, 7, 20, "Print"],
Cell[74814, 2055, 522, 10, 20, "Print"],
Cell[75339, 2067, 691, 16, 20, "Print"],
Cell[76033, 2085, 687, 16, 20, "Print"],
Cell[76723, 2103, 707, 16, 20, "Print"],
Cell[77433, 2121, 386, 6, 20, "Print"],
Cell[77822, 2129, 3437, 105, 86, "Print"],
Cell[81262, 2236, 385, 6, 20, "Print"],
Cell[81650, 2244, 1388, 34, 78, "Print"],
Cell[83041, 2280, 664, 13, 20, "Print"],
Cell[83708, 2295, 453, 7, 20, "Print"],
Cell[84164, 2304, 524, 10, 20, "Print"],
Cell[84691, 2316, 693, 16, 20, "Print"],
Cell[85387, 2334, 689, 16, 20, "Print"],
Cell[86079, 2352, 709, 16, 20, "Print"],
Cell[86791, 2370, 386, 6, 20, "Print"],
Cell[87180, 2378, 3534, 105, 86, "Print"],
Cell[90717, 2485, 387, 6, 20, "Print"],
Cell[91107, 2493, 1728, 38, 78, "Print"],
Cell[92838, 2533, 663, 12, 20, "Print"],
Cell[93504, 2547, 451, 7, 20, "Print"],
Cell[93958, 2556, 522, 10, 20, "Print"],
Cell[94483, 2568, 688, 16, 20, "Print"],
Cell[95174, 2586, 693, 16, 20, "Print"],
Cell[95870, 2604, 711, 16, 20, "Print"],
Cell[96584, 2622, 386, 6, 20, "Print"],
Cell[96973, 2630, 3548, 105, 86, "Print"],
Cell[100524, 2737, 385, 6, 20, "Print"],
Cell[100912, 2745, 1762, 39, 78, "Print"],
Cell[102677, 2786, 663, 12, 20, "Print"],
Cell[103343, 2800, 451, 7, 20, "Print"],
Cell[103797, 2809, 522, 10, 20, "Print"],
Cell[104322, 2821, 693, 16, 20, "Print"],
Cell[105018, 2839, 689, 16, 20, "Print"],
Cell[105710, 2857, 715, 16, 20, "Print"],
Cell[106428, 2875, 384, 6, 20, "Print"],
Cell[106815, 2883, 3543, 105, 86, "Print"],
Cell[110361, 2990, 385, 6, 20, "Print"],
Cell[110749, 2998, 1754, 39, 78, "Print"],
Cell[112506, 3039, 670, 13, 20, "Print"],
Cell[113179, 3054, 451, 7, 20, "Print"],
Cell[113633, 3063, 524, 10, 20, "Print"],
Cell[114160, 3075, 695, 16, 20, "Print"],
Cell[114858, 3093, 693, 16, 20, "Print"],
Cell[115554, 3111, 715, 16, 20, "Print"],
Cell[116272, 3129, 386, 6, 20, "Print"],
Cell[116661, 3137, 3546, 105, 86, "Print"],
Cell[120210, 3244, 387, 6, 20, "Print"],
Cell[120600, 3252, 1765, 40, 78, "Print"],
Cell[122368, 3294, 670, 13, 20, "Print"],
Cell[123041, 3309, 451, 7, 20, "Print"],
Cell[123495, 3318, 524, 10, 20, "Print"],
Cell[124022, 3330, 693, 16, 20, "Print"],
Cell[124718, 3348, 693, 16, 20, "Print"],
Cell[125414, 3366, 711, 16, 20, "Print"],
Cell[126128, 3384, 386, 6, 20, "Print"],
Cell[126517, 3392, 3550, 105, 86, "Print"],
Cell[130070, 3499, 385, 6, 20, "Print"],
Cell[130458, 3507, 1711, 38, 78, "Print"],
Cell[132172, 3547, 672, 13, 20, "Print"],
Cell[132847, 3562, 451, 7, 20, "Print"],
Cell[133301, 3571, 522, 10, 20, "Print"],
Cell[133826, 3583, 693, 16, 20, "Print"],
Cell[134522, 3601, 693, 16, 20, "Print"],
Cell[135218, 3619, 717, 16, 20, "Print"],
Cell[135938, 3637, 384, 6, 20, "Print"],
Cell[136325, 3645, 3557, 105, 86, "Print"],
Cell[139885, 3752, 385, 6, 20, "Print"],
Cell[140273, 3760, 1710, 38, 78, "Print"],
Cell[141986, 3800, 670, 13, 20, "Print"],
Cell[142659, 3815, 451, 7, 20, "Print"],
Cell[143113, 3824, 522, 10, 20, "Print"],
Cell[143638, 3836, 693, 16, 20, "Print"],
Cell[144334, 3854, 693, 16, 20, "Print"],
Cell[145030, 3872, 714, 16, 20, "Print"],
Cell[145747, 3890, 386, 6, 20, "Print"],
Cell[146136, 3898, 3565, 105, 86, "Print"],
Cell[149704, 4005, 385, 6, 20, "Print"],
Cell[150092, 4013, 1719, 38, 78, "Print"],
Cell[151814, 4053, 663, 12, 20, "Print"],
Cell[152480, 4067, 453, 7, 20, "Print"],
Cell[152936, 4076, 522, 10, 20, "Print"],
Cell[153461, 4088, 689, 16, 20, "Print"],
Cell[154153, 4106, 693, 16, 20, "Print"],
Cell[154849, 4124, 711, 16, 20, "Print"],
Cell[155563, 4142, 384, 6, 20, "Print"],
Cell[155950, 4150, 3561, 105, 86, "Print"],
Cell[159514, 4257, 385, 6, 20, "Print"],
Cell[159902, 4265, 1814, 42, 78, "Print"],
Cell[161719, 4309, 663, 12, 20, "Print"],
Cell[162385, 4323, 453, 7, 20, "Print"],
Cell[162841, 4332, 524, 10, 20, "Print"],
Cell[163368, 4344, 1078, 24, 20, "Print"],
Cell[164449, 4370, 693, 16, 20, "Print"],
Cell[165145, 4388, 691, 16, 20, "Print"],
Cell[165839, 4406, 715, 16, 20, "Print"],
Cell[166557, 4424, 384, 6, 20, "Print"],
Cell[166944, 4432, 3558, 105, 86, "Print"],
Cell[170505, 4539, 385, 6, 20, "Print"],
Cell[170893, 4547, 1897, 44, 78, "Print"],
Cell[172793, 4593, 664, 13, 20, "Print"],
Cell[173460, 4608, 451, 7, 20, "Print"],
Cell[173914, 4617, 526, 10, 20, "Print"],
Cell[174443, 4629, 1084, 24, 20, "Print"],
Cell[175530, 4655, 693, 16, 20, "Print"],
Cell[176226, 4673, 693, 16, 20, "Print"],
Cell[176922, 4691, 717, 16, 20, "Print"],
Cell[177642, 4709, 384, 6, 20, "Print"],
Cell[178029, 4717, 3559, 105, 86, "Print"],
Cell[181591, 4824, 385, 6, 20, "Print"],
Cell[181979, 4832, 1853, 43, 78, "Print"],
Cell[183835, 4877, 663, 12, 20, "Print"],
Cell[184501, 4891, 451, 7, 20, "Print"],
Cell[184955, 4900, 523, 10, 20, "Print"],
Cell[185481, 4912, 693, 16, 20, "Print"],
Cell[186177, 4930, 693, 16, 20, "Print"],
Cell[186873, 4948, 713, 16, 20, "Print"],
Cell[187589, 4966, 386, 6, 20, "Print"],
Cell[187978, 4974, 3554, 105, 86, "Print"],
Cell[191535, 5081, 385, 6, 20, "Print"],
Cell[191923, 5089, 1847, 43, 78, "Print"],
Cell[193773, 5134, 670, 13, 20, "Print"],
Cell[194446, 5149, 451, 7, 20, "Print"],
Cell[194900, 5158, 524, 10, 20, "Print"],
Cell[195427, 5170, 693, 16, 20, "Print"],
Cell[196123, 5188, 695, 16, 20, "Print"],
Cell[196821, 5206, 713, 16, 20, "Print"],
Cell[197537, 5224, 386, 6, 20, "Print"],
Cell[197926, 5232, 3549, 105, 86, "Print"],
Cell[201478, 5339, 385, 6, 20, "Print"],
Cell[201866, 5347, 1847, 43, 78, "Print"],
Cell[203716, 5392, 669, 13, 20, "Print"],
Cell[204388, 5407, 450, 7, 20, "Print"],
Cell[204841, 5416, 526, 10, 20, "Print"],
Cell[205370, 5428, 688, 16, 20, "Print"],
Cell[206061, 5446, 692, 16, 20, "Print"],
Cell[206756, 5464, 715, 16, 20, "Print"],
Cell[207474, 5482, 384, 6, 20, "Print"],
Cell[207861, 5490, 3561, 105, 86, "Print"],
Cell[211425, 5597, 385, 6, 20, "Print"],
Cell[211813, 5605, 1850, 43, 78, "Print"],
Cell[213666, 5650, 674, 13, 20, "Print"],
Cell[214343, 5665, 451, 7, 20, "Print"],
Cell[214797, 5674, 524, 10, 20, "Print"],
Cell[215324, 5686, 689, 16, 20, "Print"],
Cell[216016, 5704, 689, 16, 20, "Print"],
Cell[216708, 5722, 719, 16, 20, "Print"],
Cell[217430, 5740, 384, 6, 20, "Print"],
Cell[217817, 5748, 3570, 105, 86, "Print"],
Cell[221390, 5855, 385, 6, 20, "Print"],
Cell[221778, 5863, 1843, 43, 78, "Print"],
Cell[223624, 5908, 672, 13, 20, "Print"],
Cell[224299, 5923, 451, 7, 20, "Print"],
Cell[224753, 5932, 524, 10, 20, "Print"],
Cell[225280, 5944, 693, 16, 20, "Print"],
Cell[225976, 5962, 689, 16, 20, "Print"],
Cell[226668, 5980, 719, 16, 20, "Print"],
Cell[227390, 5998, 386, 6, 20, "Print"],
Cell[227779, 6006, 3566, 105, 86, "Print"],
Cell[231348, 6113, 385, 6, 20, "Print"],
Cell[231736, 6121, 1847, 43, 78, "Print"],
Cell[233586, 6166, 674, 13, 20, "Print"],
Cell[234263, 6181, 451, 7, 20, "Print"],
Cell[234717, 6190, 524, 10, 20, "Print"],
Cell[235244, 6202, 691, 16, 20, "Print"],
Cell[235938, 6220, 695, 16, 20, "Print"],
Cell[236636, 6238, 715, 16, 20, "Print"],
Cell[237354, 6256, 384, 6, 20, "Print"],
Cell[237741, 6264, 3566, 105, 86, "Print"],
Cell[241310, 6371, 385, 6, 20, "Print"],
Cell[241698, 6379, 1889, 44, 78, "Print"],
Cell[243590, 6425, 671, 13, 20, "Print"],
Cell[244264, 6440, 453, 7, 20, "Print"],
Cell[244720, 6449, 524, 10, 20, "Print"],
Cell[245247, 6461, 693, 16, 20, "Print"],
Cell[245943, 6479, 689, 16, 20, "Print"],
Cell[246635, 6497, 784, 18, 23, "Print"],
Cell[247422, 6517, 384, 6, 20, "Print"],
Cell[247809, 6525, 3562, 105, 86, "Print"],
Cell[251374, 6632, 385, 6, 20, "Print"],
Cell[251762, 6640, 1885, 44, 78, "Print"],
Cell[253650, 6686, 671, 13, 20, "Print"],
Cell[254324, 6701, 451, 7, 20, "Print"],
Cell[254778, 6710, 524, 10, 20, "Print"],
Cell[255305, 6722, 695, 16, 20, "Print"],
Cell[256003, 6740, 695, 16, 20, "Print"],
Cell[256701, 6758, 786, 18, 23, "Print"],
Cell[257490, 6778, 384, 6, 20, "Print"],
Cell[257877, 6786, 3567, 105, 86, "Print"],
Cell[261447, 6893, 387, 6, 20, "Print"],
Cell[261837, 6901, 1889, 44, 78, "Print"],
Cell[263729, 6947, 677, 14, 20, "Print"],
Cell[264409, 6963, 400, 6, 20, "Print"],
Cell[264812, 6971, 451, 7, 20, "Print"],
Cell[265266, 6980, 524, 10, 20, "Print"],
Cell[265793, 6992, 693, 16, 20, "Print"],
Cell[266489, 7010, 693, 16, 20, "Print"],
Cell[267185, 7028, 790, 18, 23, "Print"],
Cell[267978, 7048, 384, 6, 20, "Print"],
Cell[268365, 7056, 3572, 105, 86, "Print"],
Cell[271940, 7163, 385, 6, 20, "Print"],
Cell[272328, 7171, 1888, 44, 78, "Print"],
Cell[274219, 7217, 680, 14, 23, "Print"],
Cell[274902, 7233, 398, 6, 20, "Print"],
Cell[275303, 7241, 451, 7, 20, "Print"],
Cell[275757, 7250, 526, 10, 20, "Print"],
Cell[276286, 7262, 692, 16, 20, "Print"],
Cell[276981, 7280, 693, 16, 20, "Print"],
Cell[277677, 7298, 785, 18, 23, "Print"],
Cell[278465, 7318, 384, 6, 20, "Print"],
Cell[278852, 7326, 3459, 105, 86, "Print"],
Cell[282314, 7433, 387, 6, 20, "Print"],
Cell[282704, 7441, 1887, 44, 78, "Print"],
Cell[284594, 7487, 680, 14, 23, "Print"],
Cell[285277, 7503, 397, 6, 20, "Print"],
Cell[285677, 7511, 400, 6, 20, "Print"],
Cell[286080, 7519, 398, 6, 20, "Print"],
Cell[286481, 7527, 618, 11, 20, "Print"],
Cell[287102, 7540, 1514, 38, 98, "Print"],
Cell[288619, 7580, 385, 6, 20, "Print"],
Cell[289007, 7588, 1888, 44, 78, "Print"],
Cell[290898, 7634, 5960, 147, 376, "Print"],
Cell[296861, 7783, 761, 16, 26, "Print"],
Cell[297625, 7801, 444, 7, 20, "Print"],
Cell[298072, 7810, 431, 6, 20, "Print"],
Cell[298506, 7818, 442, 7, 20, "Print"],
Cell[298951, 7827, 2314, 54, 90, "Print"],
Cell[301268, 7883, 440, 7, 20, "Print"],
Cell[301711, 7892, 394, 6, 20, "Print"],
Cell[302108, 7900, 442, 7, 20, "Print"],
Cell[302553, 7909, 1560, 40, 38, "Print"],
Cell[304116, 7951, 440, 7, 20, "Print"],
Cell[304559, 7960, 417, 6, 20, "Print"],
Cell[304979, 7968, 440, 7, 20, "Print"],
Cell[305422, 7977, 440, 7, 20, "Print"],
Cell[305865, 7986, 573, 11, 20, "Print"],
Cell[306441, 7999, 1812, 45, 86, "Print"],
Cell[308256, 8046, 443, 7, 20, "Print"],
Cell[308702, 8055, 423, 6, 20, "Print"],
Cell[309128, 8063, 441, 7, 20, "Print"],
Cell[309572, 8072, 1792, 41, 78, "Print"],
Cell[311367, 8115, 442, 7, 20, "Print"],
Cell[311812, 8124, 448, 7, 22, "Print"],
Cell[312263, 8133, 444, 7, 20, "Print"],
Cell[312710, 8142, 1796, 41, 78, "Print"],
Cell[314509, 8185, 386, 6, 20, "Print"],
Cell[314898, 8193, 523, 10, 20, "Print"],
Cell[315424, 8205, 442, 7, 20, "Print"],
Cell[315869, 8214, 459, 7, 22, "Print"],
Cell[316331, 8223, 442, 7, 20, "Print"],
Cell[316776, 8232, 1880, 44, 78, "Print"],
Cell[318659, 8278, 386, 6, 20, "Print"],
Cell[319048, 8286, 523, 10, 20, "Print"],
Cell[319574, 8298, 444, 7, 20, "Print"],
Cell[320021, 8307, 407, 6, 20, "Print"],
Cell[320431, 8315, 442, 7, 20, "Print"],
Cell[320876, 8324, 610, 12, 20, "Print"],
Cell[321489, 8338, 458, 7, 20, "Print"],
Cell[321950, 8347, 1807, 48, 56, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[323806, 8401, 331, 11, 50, "Input"],
Cell[324140, 8414, 1462, 35, 85, "Output"]
}, Open  ]],
Cell[325617, 8452, 205, 7, 27, "Input",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[325847, 8463, 1772, 48, 88, "Input"],
Cell[CellGroupData[{
Cell[327644, 8515, 550, 12, 20, "Print"],
Cell[328197, 8529, 595, 11, 20, "Print"],
Cell[328795, 8542, 601, 11, 20, "Print"],
Cell[329399, 8555, 606, 12, 20, "Print"],
Cell[330008, 8569, 606, 12, 20, "Print"],
Cell[330617, 8583, 606, 12, 20, "Print"],
Cell[331226, 8597, 599, 11, 20, "Print"],
Cell[331828, 8610, 606, 12, 20, "Print"],
Cell[332437, 8624, 600, 12, 20, "Print"],
Cell[333040, 8638, 599, 11, 20, "Print"],
Cell[333642, 8651, 601, 11, 20, "Print"],
Cell[334246, 8664, 606, 12, 20, "Print"],
Cell[334855, 8678, 606, 12, 20, "Print"],
Cell[335464, 8692, 608, 12, 20, "Print"],
Cell[336075, 8706, 610, 12, 20, "Print"],
Cell[336688, 8720, 608, 12, 20, "Print"],
Cell[337299, 8734, 608, 12, 20, "Print"],
Cell[337910, 8748, 607, 12, 20, "Print"],
Cell[338520, 8762, 609, 12, 20, "Print"],
Cell[339132, 8776, 616, 13, 20, "Print"],
Cell[339751, 8791, 336, 5, 20, "Print"],
Cell[340090, 8798, 613, 13, 23, "Print"],
Cell[340706, 8813, 334, 5, 20, "Print"],
Cell[341043, 8820, 614, 13, 23, "Print"],
Cell[341660, 8835, 334, 5, 20, "Print"],
Cell[341997, 8842, 336, 5, 20, "Print"],
Cell[342336, 8849, 334, 5, 20, "Print"],
Cell[342673, 8856, 699, 15, 26, "Print"],
Cell[343375, 8873, 378, 6, 20, "Print"],
Cell[343756, 8881, 365, 5, 20, "Print"],
Cell[344124, 8888, 378, 6, 20, "Print"],
Cell[344505, 8896, 2261, 54, 90, "Print"],
Cell[346769, 8952, 376, 6, 20, "Print"],
Cell[347148, 8960, 332, 5, 20, "Print"],
Cell[347483, 8967, 376, 6, 20, "Print"],
Cell[347862, 8975, 1497, 39, 38, "Print"],
Cell[349362, 9016, 376, 6, 20, "Print"],
Cell[349741, 9024, 351, 5, 20, "Print"],
Cell[350095, 9031, 376, 6, 20, "Print"],
Cell[350474, 9039, 376, 6, 20, "Print"],
Cell[350853, 9047, 512, 10, 20, "Print"],
Cell[351368, 9059, 1747, 44, 86, "Print"],
Cell[353118, 9105, 379, 6, 20, "Print"],
Cell[353500, 9113, 361, 5, 20, "Print"],
Cell[353864, 9120, 377, 6, 20, "Print"],
Cell[354244, 9128, 1702, 39, 78, "Print"],
Cell[355949, 9169, 378, 6, 20, "Print"],
Cell[356330, 9177, 382, 6, 22, "Print"],
Cell[356715, 9185, 378, 6, 20, "Print"],
Cell[357096, 9193, 1731, 40, 78, "Print"],
Cell[358830, 9235, 322, 5, 20, "Print"],
Cell[359155, 9242, 457, 9, 20, "Print"],
Cell[359615, 9253, 378, 6, 20, "Print"],
Cell[359996, 9261, 395, 6, 22, "Print"],
Cell[360394, 9269, 378, 6, 20, "Print"],
Cell[360775, 9277, 1823, 43, 78, "Print"],
Cell[362601, 9322, 320, 5, 20, "Print"],
Cell[362924, 9329, 461, 9, 20, "Print"],
Cell[363388, 9340, 378, 6, 20, "Print"],
Cell[363769, 9348, 342, 5, 20, "Print"],
Cell[364114, 9355, 378, 6, 20, "Print"],
Cell[364495, 9363, 546, 11, 20, "Print"],
Cell[365044, 9376, 394, 6, 20, "Print"],
Cell[365441, 9384, 1741, 47, 56, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[367231, 9437, 331, 11, 50, "Input"],
Cell[367565, 9450, 1413, 34, 85, "Output"]
}, Open  ]],
Cell[368993, 9487, 441, 15, 27, "Input",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[369459, 9506, 1874, 50, 88, "Input"],
Cell[CellGroupData[{
Cell[371358, 9560, 621, 13, 20, "Print"],
Cell[371982, 9575, 680, 13, 20, "Print"],
Cell[372665, 9590, 677, 12, 20, "Print"],
Cell[373345, 9604, 682, 13, 20, "Print"],
Cell[374030, 9619, 682, 13, 20, "Print"],
Cell[374715, 9634, 682, 13, 20, "Print"],
Cell[375400, 9649, 682, 13, 20, "Print"],
Cell[376085, 9664, 682, 13, 20, "Print"],
Cell[376770, 9679, 675, 12, 20, "Print"],
Cell[377448, 9693, 675, 12, 20, "Print"],
Cell[378126, 9707, 677, 12, 20, "Print"],
Cell[378806, 9721, 684, 13, 20, "Print"],
Cell[379493, 9736, 681, 13, 20, "Print"],
Cell[380177, 9751, 675, 12, 20, "Print"],
Cell[380855, 9765, 684, 13, 20, "Print"],
Cell[381542, 9780, 683, 13, 20, "Print"],
Cell[382228, 9795, 677, 12, 20, "Print"],
Cell[382908, 9809, 683, 13, 20, "Print"],
Cell[383594, 9824, 683, 13, 20, "Print"],
Cell[384280, 9839, 691, 14, 20, "Print"],
Cell[384974, 9855, 410, 6, 20, "Print"],
Cell[385387, 9863, 675, 12, 23, "Print"],
Cell[386065, 9877, 409, 6, 20, "Print"],
Cell[386477, 9885, 692, 14, 23, "Print"],
Cell[387172, 9901, 410, 6, 20, "Print"],
Cell[387585, 9909, 410, 6, 20, "Print"],
Cell[387998, 9917, 410, 6, 20, "Print"],
Cell[388411, 9925, 775, 16, 26, "Print"],
Cell[389189, 9943, 456, 7, 20, "Print"],
Cell[389648, 9952, 441, 6, 20, "Print"],
Cell[390092, 9960, 456, 7, 20, "Print"],
Cell[390551, 9969, 2319, 54, 90, "Print"],
Cell[392873, 10025, 452, 7, 20, "Print"],
Cell[393328, 10034, 408, 6, 20, "Print"],
Cell[393739, 10042, 454, 7, 20, "Print"],
Cell[394196, 10051, 1569, 40, 38, "Print"],
Cell[395768, 10093, 454, 7, 20, "Print"],
Cell[396225, 10102, 429, 6, 20, "Print"],
Cell[396657, 10110, 452, 7, 20, "Print"],
Cell[397112, 10119, 452, 7, 20, "Print"],
Cell[397567, 10128, 586, 11, 20, "Print"],
Cell[398156, 10141, 1817, 44, 86, "Print"],
Cell[399976, 10187, 453, 7, 20, "Print"],
Cell[400432, 10196, 437, 6, 20, "Print"],
Cell[400872, 10204, 453, 7, 20, "Print"],
Cell[401328, 10213, 1786, 41, 78, "Print"],
Cell[403117, 10256, 454, 7, 20, "Print"],
Cell[403574, 10265, 458, 7, 22, "Print"],
Cell[404035, 10274, 454, 7, 20, "Print"],
Cell[404492, 10283, 1799, 40, 78, "Print"],
Cell[406294, 10325, 396, 6, 20, "Print"],
Cell[406693, 10333, 533, 10, 20, "Print"],
Cell[407229, 10345, 456, 7, 20, "Print"],
Cell[407688, 10354, 469, 7, 22, "Print"],
Cell[408160, 10363, 456, 7, 20, "Print"],
Cell[408619, 10372, 1900, 44, 78, "Print"],
Cell[410522, 10418, 396, 6, 20, "Print"],
Cell[410921, 10426, 536, 10, 20, "Print"],
Cell[411460, 10438, 454, 7, 20, "Print"],
Cell[411917, 10447, 419, 6, 20, "Print"],
Cell[412339, 10455, 456, 7, 20, "Print"],
Cell[412798, 10464, 622, 12, 20, "Print"],
Cell[413423, 10478, 470, 7, 20, "Print"],
Cell[413896, 10487, 1819, 48, 56, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[415764, 10541, 331, 11, 50, "Input"],
Cell[416098, 10554, 1490, 36, 97, "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[417649, 10597, 31, 0, 26, "Subsection"],
Cell[417683, 10599, 656, 20, 43, "Input"],
Cell[CellGroupData[{
Cell[418364, 10623, 125, 1, 43, "Input"],
Cell[418492, 10626, 236, 5, 27, "Output"],
Cell[418731, 10633, 304, 7, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[419072, 10645, 196, 5, 27, "Input"],
Cell[419271, 10652, 242, 7, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[419550, 10664, 2666, 80, 208, "Input"],
Cell[422219, 10746, 1672, 33, 260, "Output"]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[423952, 10786, 280, 5, 37, "Section"],
Cell[CellGroupData[{
Cell[424257, 10795, 122, 2, 27, "Input"],
Cell[424382, 10799, 748, 14, 23, "Message"],
Cell[425133, 10815, 788, 14, 23, "Message"],
Cell[425924, 10831, 766, 14, 23, "Message"],
Cell[426693, 10847, 816, 15, 23, "Message"],
Cell[427512, 10864, 682, 12, 23, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[428231, 10881, 129, 2, 27, "Input"],
Cell[428363, 10885, 903, 18, 23, "Message"],
Cell[429269, 10905, 636, 12, 23, "Message"],
Cell[429908, 10919, 822, 14, 23, "Message"],
Cell[430733, 10935, 632, 11, 23, "Message"],
Cell[431368, 10948, 845, 15, 23, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[432250, 10968, 89, 2, 34, "Subsection"],
Cell[432342, 10972, 137, 6, 56, "Text"],
Cell[432482, 10980, 236, 9, 71, "Text"],
Cell[CellGroupData[{
Cell[432743, 10993, 332, 10, 27, "Input"],
Cell[433078, 11005, 262, 6, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[433377, 11016, 633, 19, 58, "Input"],
Cell[434013, 11037, 138, 3, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[434188, 11045, 403, 13, 27, "Input"],
Cell[434594, 11060, 1062, 29, 57, "Output"]
}, Open  ]],
Cell[435671, 11092, 443, 14, 43, "Input"],
Cell[CellGroupData[{
Cell[436139, 11110, 112, 3, 27, "Input"],
Cell[436254, 11115, 212, 6, 27, "Output"]
}, Open  ]],
Cell[436481, 11124, 582, 19, 48, "Input"],
Cell[CellGroupData[{
Cell[437088, 11147, 116, 3, 27, "Input"],
Cell[437207, 11152, 286, 9, 47, "Output"]
}, Open  ]],
Cell[437508, 11164, 1206, 34, 133, "Input"],
Cell[CellGroupData[{
Cell[438739, 11202, 137, 4, 27, "Input"],
Cell[438879, 11208, 161, 4, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[439077, 11217, 275, 7, 27, "Input"],
Cell[439355, 11226, 472, 14, 33, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[439864, 11245, 460, 14, 58, "Input"],
Cell[440327, 11261, 190, 5, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[440554, 11271, 482, 15, 58, "Input"],
Cell[441039, 11288, 186, 5, 47, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[441274, 11299, 79, 2, 26, "Subsection"],
Cell[CellGroupData[{
Cell[441378, 11305, 120, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[441523, 11311, 194, 4, 42, "Print",
 CellTags->"Info3460467319-4560556"],
Cell[441720, 11317, 1290, 36, 64, "Print",
 CellTags->"Info3460467319-4560556"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[443059, 11359, 684, 17, 43, "Input"],
Cell[443746, 11378, 328, 8, 46, "Output"],
Cell[444077, 11388, 3136, 58, 242, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[447250, 11451, 799, 25, 27, "Input"],
Cell[448052, 11478, 3942, 128, 81, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[452031, 11611, 633, 15, 27, "Input"],
Cell[452667, 11628, 1403, 28, 238, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[454107, 11661, 94, 1, 27, "Input"],
Cell[454204, 11664, 71, 1, 27, "Output"]
}, Open  ]],
Cell[454290, 11668, 2834, 69, 268, "Input"],
Cell[457127, 11739, 7615, 172, 463, "Input"],
Cell[CellGroupData[{
Cell[464767, 11915, 96, 1, 27, "Input"],
Cell[464866, 11918, 1161, 35, 33, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[466064, 11958, 1852, 45, 148, "Input"],
Cell[467919, 12005, 2933, 55, 97, "Output"],
Cell[470855, 12062, 2860, 55, 97, "Output"],
Cell[473718, 12119, 2935, 55, 97, "Output"],
Cell[476656, 12176, 3041, 59, 137, "Output"],
Cell[479700, 12237, 5366, 88, 240, "Output"],
Cell[485069, 12327, 2349, 41, 33, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[487467, 12374, 114, 3, 34, "Subsection"],
Cell[CellGroupData[{
Cell[487606, 12381, 1267, 28, 73, "Input"],
Cell[488876, 12411, 1829, 27, 27, "Output"],
Cell[490708, 12440, 1806, 27, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[492551, 12472, 69, 1, 27, "Input"],
Cell[492623, 12475, 1088, 15, 27, "Output"]
}, Open  ]],
Cell[493726, 12493, 1322, 34, 58, "Input"],
Cell[CellGroupData[{
Cell[495073, 12531, 248, 3, 73, "Input"],
Cell[495324, 12536, 1817, 31, 27, "Output"],
Cell[497144, 12569, 1637, 27, 27, "Output"],
Cell[498784, 12598, 1825, 31, 27, "Output"],
Cell[500612, 12631, 1485, 21, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[502134, 12657, 177, 2, 58, "Input"],
Cell[502314, 12661, 1347, 23, 27, "Output"],
Cell[503664, 12686, 1346, 22, 27, "Output"],
Cell[505013, 12710, 1297, 22, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[506347, 12737, 761, 13, 27, "Input"],
Cell[507111, 12752, 1926, 39, 20, "Print"],
Cell[509040, 12793, 2923, 48, 430, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[512000, 12846, 291, 8, 27, "Input"],
Cell[512294, 12856, 2223, 45, 97, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[514554, 12906, 397, 9, 27, "Input"],
Cell[514954, 12917, 1920, 39, 20, "Print"],
Cell[516877, 12958, 2086, 36, 374, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[519000, 12999, 136, 4, 27, "Input"],
Cell[519139, 13005, 617, 13, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[519793, 13023, 178, 5, 27, "Input"],
Cell[519974, 13030, 2600, 50, 55, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[522611, 13085, 83, 2, 27, "Input"],
Cell[522697, 13089, 609, 13, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[523343, 13107, 174, 2, 43, "Input"],
Cell[523520, 13111, 1748, 28, 27, "Output"],
Cell[525271, 13141, 1751, 29, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[527059, 13175, 1347, 36, 73, "Input"],
Cell[528409, 13213, 2393, 40, 249, "Output"],
Cell[530805, 13255, 2390, 40, 249, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[533244, 13301, 100, 2, 35, "Subsection"],
Cell[CellGroupData[{
Cell[533369, 13307, 119, 1, 24, "Subsubsection"],
Cell[CellGroupData[{
Cell[533513, 13312, 96, 1, 27, "Input"],
Cell[533612, 13315, 209, 4, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[533858, 13324, 176, 3, 27, "Input"],
Cell[534037, 13329, 279, 5, 27, "Output"]
}, Open  ]],
Cell[534331, 13337, 3848, 88, 88, "Input"],
Cell[CellGroupData[{
Cell[538204, 13429, 2009, 35, 43, "Input"],
Cell[540216, 13466, 3645, 64, 238, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[543910, 13536, 27, 0, 24, "Subsubsection"],
Cell[CellGroupData[{
Cell[543962, 13540, 253, 3, 43, "Input"],
Cell[544218, 13545, 328, 6, 27, "Output"],
Cell[544549, 13553, 487, 11, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[545073, 13569, 185, 2, 43, "Input"],
Cell[545261, 13573, 186, 2, 27, "Output"],
Cell[545450, 13577, 191, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[545678, 13584, 123, 2, 27, "Input"],
Cell[545804, 13588, 238, 3, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[546079, 13596, 224, 4, 43, "Input"],
Cell[546306, 13602, 188, 2, 27, "Output"],
Cell[546497, 13606, 191, 2, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[546725, 13613, 6947, 106, 73, "Input"],
Cell[553675, 13721, 738740, 12705, 161, 697703, 12030, "CachedBoxData", \
"BoxData", "Print"],
Cell[1292418, 26428, 352, 6, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1292807, 26439, 7005, 110, 43, "Input"],
Cell[1299815, 26551, 495, 8, 27, "Output"],
Cell[1300313, 26561, 497, 8, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1300847, 26574, 97, 1, 27, "Input"],
Cell[1300947, 26577, 160, 4, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1301144, 26586, 96, 1, 27, "Input"],
Cell[1301243, 26589, 73, 1, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1301353, 26595, 2108, 58, 58, "Input"],
Cell[1303464, 26655, 226, 4, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1303727, 26664, 365, 7, 27, "Input"],
Cell[1304095, 26673, 568, 9, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1304700, 26687, 1443, 34, 43, "Input"],
Cell[1306146, 26723, 1948, 36, 238, "Output"]
}, Open  ]],
Cell[1308109, 26762, 106, 2, 26, "Text"],
Cell[CellGroupData[{
Cell[1308240, 26768, 857, 16, 118, "Input"],
Cell[1309100, 26786, 788, 13, 27, "Output"],
Cell[1309891, 26801, 1039, 20, 27, "Output"],
Cell[1310933, 26823, 698, 10, 27, "Output"],
Cell[1311634, 26835, 701, 10, 27, "Output"],
Cell[1312338, 26847, 698, 10, 27, "Output"],
Cell[1313039, 26859, 698, 10, 27, "Output"],
Cell[1313740, 26871, 700, 10, 27, "Output"]
}, Open  ]],
Cell[1314455, 26884, 102, 1, 27, "Input"],
Cell[CellGroupData[{
Cell[1314582, 26889, 2857, 66, 88, "Input"],
Cell[CellGroupData[{
Cell[1317464, 26959, 1344, 21, 20, "Print"],
Cell[1318811, 26982, 1240, 17, 20, "Print"],
Cell[1320054, 27001, 1223, 18, 20, "Print"],
Cell[1321280, 27021, 1270, 18, 20, "Print"],
Cell[1322553, 27041, 1270, 18, 20, "Print"],
Cell[1323826, 27061, 1270, 18, 20, "Print"],
Cell[1325099, 27081, 1224, 17, 20, "Print"],
Cell[1326326, 27100, 1217, 17, 20, "Print"],
Cell[1327546, 27119, 1272, 18, 20, "Print"],
Cell[1328821, 27139, 2585, 60, 38, "Print"],
Cell[1331409, 27201, 1206, 17, 20, "Print"],
Cell[1332618, 27220, 2449, 54, 42, "Print"],
Cell[1335070, 27276, 1206, 17, 20, "Print"],
Cell[1336279, 27295, 2604, 60, 42, "Print"],
Cell[1338886, 27357, 1206, 17, 20, "Print"],
Cell[1340095, 27376, 1217, 17, 20, "Print"]
}, Open  ]],
Cell[1341327, 27396, 1697, 27, 23, "Message"],
Cell[CellGroupData[{
Cell[1343049, 27427, 1385, 24, 20, "Print"],
Cell[1344437, 27453, 1206, 17, 20, "Print"],
Cell[1345646, 27472, 1270, 18, 20, "Print"],
Cell[1346919, 27492, 1208, 17, 20, "Print"],
Cell[1348130, 27511, 1458, 24, 20, "Print"],
Cell[1349591, 27537, 1434, 23, 20, "Print"],
Cell[1351028, 27562, 1480, 25, 20, "Print"],
Cell[1352511, 27589, 1273, 18, 20, "Print"],
Cell[1353787, 27609, 1344, 21, 20, "Print"],
Cell[1355134, 27632, 1510, 27, 20, "Print"],
Cell[1356647, 27661, 1511, 27, 20, "Print"],
Cell[1358161, 27690, 1527, 27, 20, "Print"],
Cell[1359691, 27719, 1208, 17, 20, "Print"],
Cell[1360902, 27738, 4343, 117, 78, "Print"],
Cell[1365248, 27857, 1208, 17, 20, "Print"],
Cell[1366459, 27876, 4097, 119, 78, "Print"],
Cell[1370559, 27997, 1434, 23, 20, "Print"],
Cell[1371996, 28022, 1357, 21, 20, "Print"],
Cell[1373356, 28045, 1473, 23, 20, "Print"],
Cell[1374832, 28070, 1488, 24, 20, "Print"],
Cell[1376323, 28096, 1272, 18, 20, "Print"],
Cell[1377598, 28116, 1346, 21, 20, "Print"],
Cell[1378947, 28139, 1896, 35, 20, "Print"],
Cell[1380846, 28176, 1898, 35, 20, "Print"],
Cell[1382747, 28213, 1511, 27, 20, "Print"],
Cell[1384261, 28242, 1511, 27, 20, "Print"],
Cell[1385775, 28271, 1535, 27, 20, "Print"],
Cell[1387313, 28300, 1208, 17, 20, "Print"],
Cell[1388524, 28319, 4422, 117, 78, "Print"],
Cell[1392949, 28438, 1208, 17, 20, "Print"],
Cell[1394160, 28457, 4465, 119, 78, "Print"],
Cell[1398628, 28578, 1432, 23, 20, "Print"],
Cell[1400063, 28603, 1357, 21, 20, "Print"],
Cell[1401423, 28626, 1488, 24, 20, "Print"],
Cell[1402914, 28652, 1273, 18, 20, "Print"],
Cell[1404190, 28672, 1344, 21, 20, "Print"],
Cell[1405537, 28695, 1894, 35, 20, "Print"],
Cell[1407434, 28732, 1896, 35, 20, "Print"],
Cell[1409333, 28769, 1513, 27, 20, "Print"],
Cell[1410849, 28798, 1510, 27, 20, "Print"],
Cell[1412362, 28827, 1531, 27, 20, "Print"],
Cell[1413896, 28856, 1206, 17, 20, "Print"],
Cell[1415105, 28875, 4424, 117, 78, "Print"],
Cell[1419532, 28994, 1206, 17, 20, "Print"],
Cell[1420741, 29013, 4463, 119, 78, "Print"],
Cell[1425207, 29134, 1431, 23, 20, "Print"],
Cell[1426641, 29159, 1357, 21, 20, "Print"],
Cell[1428001, 29182, 1476, 23, 20, "Print"],
Cell[1429480, 29207, 1490, 24, 20, "Print"],
Cell[1430973, 29233, 1273, 18, 20, "Print"],
Cell[1432249, 29253, 1344, 21, 20, "Print"],
Cell[1433596, 29276, 1511, 27, 20, "Print"],
Cell[1435110, 29305, 1511, 27, 20, "Print"],
Cell[1436624, 29334, 1527, 27, 20, "Print"],
Cell[1438154, 29363, 1206, 17, 20, "Print"],
Cell[1439363, 29382, 4449, 117, 78, "Print"],
Cell[1443815, 29501, 1206, 17, 20, "Print"],
Cell[1445024, 29520, 4454, 119, 78, "Print"],
Cell[1449481, 29641, 1432, 23, 20, "Print"],
Cell[1450916, 29666, 1357, 21, 20, "Print"],
Cell[1452276, 29689, 1471, 23, 20, "Print"],
Cell[1453750, 29714, 1486, 24, 20, "Print"],
Cell[1455239, 29740, 1273, 18, 20, "Print"],
Cell[1456515, 29760, 1344, 21, 20, "Print"],
Cell[1457862, 29783, 1896, 35, 20, "Print"],
Cell[1459761, 29820, 1513, 27, 20, "Print"],
Cell[1461277, 29849, 1513, 27, 20, "Print"],
Cell[1462793, 29878, 1535, 27, 20, "Print"],
Cell[1464331, 29907, 1206, 17, 20, "Print"],
Cell[1465540, 29926, 4450, 117, 78, "Print"],
Cell[1469993, 30045, 1206, 17, 20, "Print"],
Cell[1471202, 30064, 4459, 119, 78, "Print"],
Cell[1475664, 30185, 1470, 24, 20, "Print"],
Cell[1477137, 30211, 1357, 21, 20, "Print"],
Cell[1478497, 30234, 1488, 24, 20, "Print"],
Cell[1479988, 30260, 1273, 18, 20, "Print"],
Cell[1481264, 30280, 1346, 21, 20, "Print"],
Cell[1482613, 30303, 1896, 35, 20, "Print"],
Cell[1484512, 30340, 1896, 35, 20, "Print"],
Cell[1486411, 30377, 1896, 35, 20, "Print"],
Cell[1488310, 30414, 1900, 35, 20, "Print"],
Cell[1490213, 30451, 1896, 35, 20, "Print"],
Cell[1492112, 30488, 1896, 35, 20, "Print"],
Cell[1494011, 30525, 1898, 35, 20, "Print"],
Cell[1495912, 30562, 1898, 35, 20, "Print"]
}, Open  ]],
Cell[1497825, 30600, 173, 3, 27, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[1498035, 30608, 331, 11, 50, "Input"],
Cell[1498369, 30621, 1557, 36, 85, "Output"]
}, Open  ]],
Cell[1499941, 30660, 138, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[1500104, 30666, 2756, 65, 88, "Input"],
Cell[CellGroupData[{
Cell[1502885, 30735, 1149, 19, 20, "Print"],
Cell[1504037, 30756, 1046, 15, 20, "Print"],
Cell[1505086, 30773, 1031, 16, 20, "Print"],
Cell[1506120, 30791, 1078, 16, 20, "Print"],
Cell[1507201, 30809, 1078, 16, 20, "Print"],
Cell[1508282, 30827, 1078, 16, 20, "Print"],
Cell[1509363, 30845, 1030, 15, 20, "Print"],
Cell[1510396, 30862, 1027, 15, 20, "Print"],
Cell[1511426, 30879, 1078, 16, 20, "Print"],
Cell[1512507, 30897, 2391, 58, 38, "Print"],
Cell[1514901, 30957, 1014, 15, 20, "Print"],
Cell[1515918, 30974, 2257, 52, 42, "Print"],
Cell[1518178, 31028, 1014, 15, 20, "Print"],
Cell[1519195, 31045, 2415, 58, 42, "Print"],
Cell[1521613, 31105, 1014, 15, 20, "Print"],
Cell[1522630, 31122, 1024, 15, 20, "Print"]
}, Open  ]],
Cell[1523669, 31140, 1507, 24, 23, "Message"],
Cell[CellGroupData[{
Cell[1525201, 31168, 1195, 22, 20, "Print"],
Cell[1526399, 31192, 1014, 15, 20, "Print"],
Cell[1527416, 31209, 1078, 16, 20, "Print"],
Cell[1528497, 31227, 1014, 15, 20, "Print"],
Cell[1529514, 31244, 1268, 22, 20, "Print"],
Cell[1530785, 31268, 1416, 25, 26, "Print"],
Cell[1532204, 31295, 1293, 23, 20, "Print"],
Cell[1533500, 31320, 1081, 16, 20, "Print"],
Cell[1534584, 31338, 1152, 19, 20, "Print"],
Cell[1535739, 31359, 1319, 25, 20, "Print"],
Cell[1537061, 31386, 1319, 25, 20, "Print"],
Cell[1538383, 31413, 1339, 25, 20, "Print"],
Cell[1539725, 31440, 1014, 15, 20, "Print"],
Cell[1540742, 31457, 4169, 115, 78, "Print"],
Cell[1544914, 31574, 1014, 15, 20, "Print"],
Cell[1545931, 31591, 3905, 117, 78, "Print"],
Cell[1549839, 31710, 1411, 25, 26, "Print"],
Cell[1551253, 31737, 1171, 19, 23, "Print"],
Cell[1552427, 31758, 1279, 21, 20, "Print"],
Cell[1553709, 31781, 1298, 22, 20, "Print"],
Cell[1555010, 31805, 1081, 16, 20, "Print"],
Cell[1556094, 31823, 1154, 19, 20, "Print"],
Cell[1557251, 31844, 1318, 25, 20, "Print"],
Cell[1558572, 31871, 1319, 25, 20, "Print"],
Cell[1559894, 31898, 1343, 25, 20, "Print"],
Cell[1561240, 31925, 1014, 15, 20, "Print"],
Cell[1562257, 31942, 4244, 115, 78, "Print"],
Cell[1566504, 32059, 1016, 15, 20, "Print"],
Cell[1567523, 32076, 4309, 117, 78, "Print"],
Cell[1571835, 32195, 1411, 25, 26, "Print"],
Cell[1573249, 32222, 1169, 19, 23, "Print"],
Cell[1574421, 32243, 1282, 21, 20, "Print"],
Cell[1575706, 32266, 1293, 21, 20, "Print"],
Cell[1577002, 32289, 1081, 16, 20, "Print"],
Cell[1578086, 32307, 1152, 19, 20, "Print"],
Cell[1579241, 32328, 1319, 25, 20, "Print"],
Cell[1580563, 32355, 1318, 25, 20, "Print"],
Cell[1581884, 32382, 1339, 25, 20, "Print"],
Cell[1583226, 32409, 1014, 15, 20, "Print"],
Cell[1584243, 32426, 4254, 115, 78, "Print"],
Cell[1588500, 32543, 1014, 15, 20, "Print"],
Cell[1589517, 32560, 4281, 117, 78, "Print"],
Cell[1593801, 32679, 1416, 25, 26, "Print"],
Cell[1595220, 32706, 1171, 19, 23, "Print"],
Cell[1596394, 32727, 1279, 21, 20, "Print"],
Cell[1597676, 32750, 1293, 21, 20, "Print"],
Cell[1598972, 32773, 1081, 16, 20, "Print"],
Cell[1600056, 32791, 1152, 19, 20, "Print"],
Cell[1601211, 32812, 1319, 25, 20, "Print"],
Cell[1602533, 32839, 1319, 25, 20, "Print"],
Cell[1603855, 32866, 1344, 25, 20, "Print"],
Cell[1605202, 32893, 1016, 15, 20, "Print"],
Cell[1606221, 32910, 4269, 115, 78, "Print"],
Cell[1610493, 33027, 1014, 15, 20, "Print"],
Cell[1611510, 33044, 4286, 117, 78, "Print"],
Cell[1615799, 33163, 1414, 25, 26, "Print"],
Cell[1617216, 33190, 1178, 20, 23, "Print"],
Cell[1618397, 33212, 1281, 21, 20, "Print"],
Cell[1619681, 33235, 1304, 22, 20, "Print"],
Cell[1620988, 33259, 1081, 16, 20, "Print"],
Cell[1622072, 33277, 1151, 19, 20, "Print"],
Cell[1623226, 33298, 1325, 25, 20, "Print"],
Cell[1624554, 33325, 1319, 25, 20, "Print"],
Cell[1625876, 33352, 1349, 25, 20, "Print"],
Cell[1627228, 33379, 1014, 15, 20, "Print"],
Cell[1628245, 33396, 4278, 115, 78, "Print"],
Cell[1632526, 33513, 1014, 15, 20, "Print"],
Cell[1633543, 33530, 4293, 117, 78, "Print"],
Cell[1637839, 33649, 1411, 25, 26, "Print"],
Cell[1639253, 33676, 1176, 20, 23, "Print"],
Cell[1640432, 33698, 1282, 21, 20, "Print"],
Cell[1641717, 33721, 1301, 22, 20, "Print"],
Cell[1643021, 33745, 1081, 16, 20, "Print"],
Cell[1644105, 33763, 1151, 19, 20, "Print"],
Cell[1645259, 33784, 1319, 25, 20, "Print"],
Cell[1646581, 33811, 1323, 25, 20, "Print"],
Cell[1647907, 33838, 1347, 25, 20, "Print"],
Cell[1649257, 33865, 1014, 15, 20, "Print"],
Cell[1650274, 33882, 4274, 115, 78, "Print"],
Cell[1654551, 33999, 1013, 15, 20, "Print"],
Cell[1655567, 34016, 4276, 117, 78, "Print"],
Cell[1659846, 34135, 1411, 25, 26, "Print"],
Cell[1661260, 34162, 1178, 19, 23, "Print"],
Cell[1662441, 34183, 1274, 21, 20, "Print"],
Cell[1663718, 34206, 1301, 22, 20, "Print"],
Cell[1665022, 34230, 1081, 16, 20, "Print"],
Cell[1666106, 34248, 1154, 19, 20, "Print"],
Cell[1667263, 34269, 1323, 25, 20, "Print"],
Cell[1668589, 34296, 1319, 25, 20, "Print"],
Cell[1669911, 34323, 1349, 25, 20, "Print"],
Cell[1671263, 34350, 1014, 15, 20, "Print"],
Cell[1672280, 34367, 4278, 115, 78, "Print"],
Cell[1676561, 34484, 1014, 15, 20, "Print"],
Cell[1677578, 34501, 4275, 117, 78, "Print"],
Cell[1681856, 34620, 1411, 25, 26, "Print"],
Cell[1683270, 34647, 1176, 20, 23, "Print"],
Cell[1684449, 34669, 1281, 21, 20, "Print"],
Cell[1685733, 34692, 1300, 22, 20, "Print"],
Cell[1687036, 34716, 1081, 16, 20, "Print"],
Cell[1688120, 34734, 1152, 19, 20, "Print"],
Cell[1689275, 34755, 1319, 25, 20, "Print"],
Cell[1690597, 34782, 1325, 25, 20, "Print"],
Cell[1691925, 34809, 1418, 27, 23, "Print"],
Cell[1693346, 34838, 1013, 15, 20, "Print"],
Cell[1694362, 34855, 4269, 115, 78, "Print"],
Cell[1698634, 34972, 1014, 15, 20, "Print"],
Cell[1699651, 34989, 4284, 117, 78, "Print"],
Cell[1703938, 35108, 1416, 25, 26, "Print"],
Cell[1705357, 35135, 1173, 19, 23, "Print"],
Cell[1706533, 35156, 1282, 21, 20, "Print"],
Cell[1707818, 35179, 1310, 23, 20, "Print"],
Cell[1709131, 35204, 1081, 16, 20, "Print"],
Cell[1710215, 35222, 1154, 19, 20, "Print"],
Cell[1711372, 35243, 1325, 25, 20, "Print"],
Cell[1712700, 35270, 1321, 25, 20, "Print"],
Cell[1714024, 35297, 1414, 27, 23, "Print"],
Cell[1715441, 35326, 1014, 15, 20, "Print"],
Cell[1716458, 35343, 4279, 115, 78, "Print"],
Cell[1720740, 35460, 1016, 15, 20, "Print"],
Cell[1721759, 35477, 4281, 117, 78, "Print"],
Cell[1726043, 35596, 1411, 25, 26, "Print"],
Cell[1727457, 35623, 1176, 19, 23, "Print"],
Cell[1728636, 35644, 1297, 22, 23, "Print"],
Cell[1729936, 35668, 1309, 23, 20, "Print"],
Cell[1731248, 35693, 1083, 16, 20, "Print"],
Cell[1732334, 35711, 1154, 19, 20, "Print"],
Cell[1733491, 35732, 1321, 25, 20, "Print"],
Cell[1734815, 35759, 1323, 25, 20, "Print"],
Cell[1736141, 35786, 1418, 27, 23, "Print"],
Cell[1737562, 35815, 1014, 15, 20, "Print"],
Cell[1738579, 35832, 4284, 115, 78, "Print"],
Cell[1742866, 35949, 1014, 15, 20, "Print"],
Cell[1743883, 35966, 4279, 117, 78, "Print"],
Cell[1748165, 36085, 1413, 25, 26, "Print"],
Cell[1749581, 36112, 1176, 20, 23, "Print"],
Cell[1750760, 36134, 1278, 21, 20, "Print"],
Cell[1752041, 36157, 1301, 22, 20, "Print"],
Cell[1753345, 36181, 1081, 16, 20, "Print"],
Cell[1754429, 36199, 1154, 19, 20, "Print"],
Cell[1755586, 36220, 1319, 25, 20, "Print"],
Cell[1756908, 36247, 1319, 25, 20, "Print"],
Cell[1758230, 36274, 1416, 27, 23, "Print"],
Cell[1759649, 36303, 1016, 15, 20, "Print"],
Cell[1760668, 36320, 4257, 115, 78, "Print"],
Cell[1764928, 36437, 1014, 15, 20, "Print"],
Cell[1765945, 36454, 4268, 117, 78, "Print"],
Cell[1770216, 36573, 1414, 25, 26, "Print"],
Cell[1771633, 36600, 1178, 20, 23, "Print"],
Cell[1772814, 36622, 1287, 21, 23, "Print"],
Cell[1774104, 36645, 1308, 23, 20, "Print"],
Cell[1775415, 36670, 1083, 16, 20, "Print"],
Cell[1776501, 36688, 1154, 19, 20, "Print"],
Cell[1777658, 36709, 1317, 25, 20, "Print"],
Cell[1778978, 36736, 1321, 25, 20, "Print"],
Cell[1780302, 36763, 1414, 27, 23, "Print"],
Cell[1781719, 36792, 1014, 15, 20, "Print"],
Cell[1782736, 36809, 4282, 115, 78, "Print"],
Cell[1787021, 36926, 1016, 15, 20, "Print"],
Cell[1788040, 36943, 4273, 117, 78, "Print"],
Cell[1792316, 37062, 1413, 25, 26, "Print"],
Cell[1793732, 37089, 1173, 19, 23, "Print"],
Cell[1794908, 37110, 1293, 21, 23, "Print"],
Cell[1796204, 37133, 1308, 23, 20, "Print"],
Cell[1797515, 37158, 1081, 16, 20, "Print"],
Cell[1798599, 37176, 1154, 19, 20, "Print"],
Cell[1799756, 37197, 1318, 25, 20, "Print"],
Cell[1801077, 37224, 1317, 25, 20, "Print"],
Cell[1802397, 37251, 1414, 27, 23, "Print"],
Cell[1803814, 37280, 1016, 15, 20, "Print"],
Cell[1804833, 37297, 4289, 115, 78, "Print"],
Cell[1809125, 37414, 1016, 15, 20, "Print"],
Cell[1810144, 37431, 4274, 117, 78, "Print"],
Cell[1814421, 37550, 1411, 25, 26, "Print"],
Cell[1815835, 37577, 1176, 19, 23, "Print"],
Cell[1817014, 37598, 1296, 22, 23, "Print"],
Cell[1818313, 37622, 1310, 23, 20, "Print"],
Cell[1819626, 37647, 1030, 15, 20, "Print"],
Cell[1820659, 37664, 1081, 16, 20, "Print"],
Cell[1821743, 37682, 1154, 19, 20, "Print"],
Cell[1822900, 37703, 1319, 25, 20, "Print"],
Cell[1824222, 37730, 1319, 25, 20, "Print"],
Cell[1825544, 37757, 1416, 27, 23, "Print"],
Cell[1826963, 37786, 1014, 15, 20, "Print"],
Cell[1827980, 37803, 4268, 115, 78, "Print"],
Cell[1832251, 37920, 1014, 15, 20, "Print"],
Cell[1833268, 37937, 4279, 117, 78, "Print"],
Cell[1837550, 38056, 1416, 25, 26, "Print"],
Cell[1838969, 38083, 1176, 19, 23, "Print"],
Cell[1840148, 38104, 1293, 21, 23, "Print"],
Cell[1841444, 38127, 1308, 23, 23, "Print"],
Cell[1842755, 38152, 1030, 15, 20, "Print"],
Cell[1843788, 38169, 1083, 16, 20, "Print"],
Cell[1844874, 38187, 1154, 19, 20, "Print"],
Cell[1846031, 38208, 1323, 25, 20, "Print"],
Cell[1847357, 38235, 1319, 25, 20, "Print"],
Cell[1848679, 38262, 1415, 27, 23, "Print"],
Cell[1850097, 38291, 1016, 15, 20, "Print"],
Cell[1851116, 38308, 4153, 115, 78, "Print"],
Cell[1855272, 38425, 1014, 15, 20, "Print"],
Cell[1856289, 38442, 4278, 117, 78, "Print"],
Cell[1860570, 38561, 1411, 25, 26, "Print"],
Cell[1861984, 38588, 1176, 19, 23, "Print"],
Cell[1863163, 38609, 1300, 22, 23, "Print"],
Cell[1864466, 38633, 1301, 22, 23, "Print"],
Cell[1865770, 38657, 1028, 15, 20, "Print"],
Cell[1866801, 38674, 1028, 15, 20, "Print"],
Cell[1867832, 38691, 1028, 15, 20, "Print"],
Cell[1868863, 38708, 1248, 20, 20, "Print"],
Cell[1870114, 38730, 2117, 46, 90, "Print"],
Cell[1872234, 38778, 1014, 15, 20, "Print"],
Cell[1873251, 38795, 4276, 117, 78, "Print"],
Cell[1877530, 38914, 5300, 120, 248, "Print"],
Cell[1882833, 39036, 1393, 25, 26, "Print"],
Cell[1884229, 39063, 1072, 16, 20, "Print"],
Cell[1885304, 39081, 1059, 15, 20, "Print"],
Cell[1886366, 39098, 1072, 16, 20, "Print"],
Cell[1887441, 39116, 2860, 60, 90, "Print"],
Cell[1890304, 39178, 1070, 16, 20, "Print"],
Cell[1891377, 39196, 1026, 15, 20, "Print"],
Cell[1892406, 39213, 1070, 16, 20, "Print"],
Cell[1893479, 39231, 2190, 49, 38, "Print"],
Cell[1895672, 39282, 1046, 15, 20, "Print"],
Cell[1896721, 39299, 1072, 16, 20, "Print"],
Cell[1897796, 39317, 1045, 15, 20, "Print"],
Cell[1898844, 39334, 1070, 16, 20, "Print"],
Cell[1899917, 39352, 1072, 16, 20, "Print"],
Cell[1900992, 39370, 1206, 20, 20, "Print"],
Cell[1902201, 39392, 2418, 53, 86, "Print"],
Cell[1904622, 39447, 1071, 16, 20, "Print"],
Cell[1905696, 39465, 1053, 15, 20, "Print"],
Cell[1906752, 39482, 1070, 16, 20, "Print"],
Cell[1907825, 39500, 2544, 53, 78, "Print"],
Cell[1910372, 39555, 1071, 16, 20, "Print"],
Cell[1911446, 39573, 1078, 16, 22, "Print"],
Cell[1912527, 39591, 1072, 16, 20, "Print"],
Cell[1913602, 39609, 2538, 53, 78, "Print"],
Cell[1916143, 39664, 1014, 15, 20, "Print"],
Cell[1917160, 39681, 1152, 19, 20, "Print"],
Cell[1918315, 39702, 1071, 16, 20, "Print"],
Cell[1919389, 39720, 1087, 16, 22, "Print"],
Cell[1920479, 39738, 1072, 16, 20, "Print"],
Cell[1921554, 39756, 2343, 47, 78, "Print"],
Cell[1923900, 39805, 1014, 15, 20, "Print"],
Cell[1924917, 39822, 1154, 19, 20, "Print"],
Cell[1926074, 39843, 1072, 16, 20, "Print"],
Cell[1927149, 39861, 1037, 15, 20, "Print"],
Cell[1928189, 39878, 1074, 16, 20, "Print"],
Cell[1929266, 39896, 1211, 20, 20, "Print"],
Cell[1930480, 39918, 1090, 16, 20, "Print"],
Cell[1931573, 39936, 2454, 58, 56, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1934076, 40000, 331, 11, 50, "Input"],
Cell[1934410, 40013, 1250, 31, 85, "Output"]
}, Open  ]],
Cell[1935675, 40047, 102, 1, 27, "Input"],
Cell[CellGroupData[{
Cell[1935802, 40052, 1893, 49, 88, "Input"],
Cell[CellGroupData[{
Cell[1937720, 40105, 570, 11, 20, "Print"],
Cell[1938293, 40118, 466, 7, 20, "Print"],
Cell[1938762, 40127, 451, 8, 20, "Print"],
Cell[1939216, 40137, 500, 8, 20, "Print"],
Cell[1939719, 40147, 500, 8, 20, "Print"],
Cell[1940222, 40157, 500, 8, 20, "Print"],
Cell[1940725, 40167, 450, 7, 20, "Print"],
Cell[1941178, 40176, 439, 7, 20, "Print"],
Cell[1941620, 40185, 498, 8, 20, "Print"],
Cell[1942121, 40195, 1811, 50, 38, "Print"],
Cell[1943935, 40247, 434, 7, 20, "Print"],
Cell[1944372, 40256, 1677, 44, 42, "Print"],
Cell[1946052, 40302, 436, 7, 20, "Print"],
Cell[1946491, 40311, 1833, 50, 42, "Print"],
Cell[1948327, 40363, 436, 7, 20, "Print"],
Cell[1948766, 40372, 445, 7, 20, "Print"]
}, Open  ]],
Cell[1949226, 40382, 932, 16, 23, "Message"],
Cell[CellGroupData[{
Cell[1950183, 40402, 613, 14, 20, "Print"],
Cell[1950799, 40418, 436, 7, 20, "Print"],
Cell[1951238, 40427, 500, 8, 20, "Print"],
Cell[1951741, 40437, 434, 7, 20, "Print"],
Cell[1952178, 40446, 686, 14, 20, "Print"],
Cell[1952867, 40462, 834, 17, 26, "Print"],
Cell[1953704, 40481, 665, 14, 20, "Print"],
Cell[1954372, 40497, 503, 8, 20, "Print"],
Cell[1954878, 40507, 572, 11, 20, "Print"],
Cell[1955453, 40520, 743, 17, 20, "Print"],
Cell[1956199, 40539, 741, 17, 20, "Print"],
Cell[1956943, 40558, 759, 17, 20, "Print"],
Cell[1957705, 40577, 436, 7, 20, "Print"],
Cell[1958144, 40586, 3580, 107, 78, "Print"],
Cell[1961727, 40695, 434, 7, 20, "Print"],
Cell[1962164, 40704, 3325, 109, 78, "Print"],
Cell[1965492, 40815, 833, 17, 26, "Print"],
Cell[1966328, 40834, 597, 12, 23, "Print"],
Cell[1966928, 40848, 700, 13, 20, "Print"],
Cell[1967631, 40863, 718, 14, 20, "Print"],
Cell[1968352, 40879, 501, 8, 20, "Print"],
Cell[1968856, 40889, 572, 11, 20, "Print"],
Cell[1969431, 40902, 739, 17, 20, "Print"],
Cell[1970173, 40921, 743, 17, 20, "Print"],
Cell[1970919, 40940, 763, 17, 20, "Print"],
Cell[1971685, 40959, 436, 7, 20, "Print"],
Cell[1972124, 40968, 3675, 107, 78, "Print"],
Cell[1975802, 41077, 434, 7, 20, "Print"],
Cell[1976239, 41086, 3735, 109, 78, "Print"],
Cell[1979977, 41197, 826, 17, 26, "Print"],
Cell[1980806, 41216, 591, 11, 23, "Print"],
Cell[1981400, 41229, 698, 13, 20, "Print"],
Cell[1982101, 41244, 711, 13, 20, "Print"],
Cell[1982815, 41259, 501, 8, 20, "Print"],
Cell[1983319, 41269, 572, 11, 20, "Print"],
Cell[1983894, 41282, 743, 17, 20, "Print"],
Cell[1984640, 41301, 739, 17, 20, "Print"],
Cell[1985382, 41320, 761, 17, 20, "Print"],
Cell[1986146, 41339, 436, 7, 20, "Print"],
Cell[1986585, 41348, 3689, 107, 78, "Print"],
Cell[1990277, 41457, 436, 7, 20, "Print"],
Cell[1990716, 41466, 3726, 109, 78, "Print"],
Cell[1994445, 41577, 826, 17, 26, "Print"],
Cell[1995274, 41596, 597, 12, 23, "Print"],
Cell[1995874, 41610, 698, 13, 20, "Print"],
Cell[1996575, 41625, 720, 14, 20, "Print"],
Cell[1997298, 41641, 501, 8, 20, "Print"],
Cell[1997802, 41651, 572, 11, 20, "Print"],
Cell[1998377, 41664, 743, 17, 20, "Print"],
Cell[1999123, 41683, 743, 17, 20, "Print"],
Cell[1999869, 41702, 763, 17, 20, "Print"],
Cell[2000635, 41721, 434, 7, 20, "Print"],
Cell[2001072, 41730, 3692, 107, 78, "Print"],
Cell[2004767, 41839, 434, 7, 20, "Print"],
Cell[2005204, 41848, 3728, 109, 78, "Print"],
Cell[2008935, 41959, 823, 17, 26, "Print"],
Cell[2009761, 41978, 597, 12, 23, "Print"],
Cell[2010361, 41992, 699, 13, 20, "Print"],
Cell[2011063, 42007, 720, 14, 20, "Print"],
Cell[2011786, 42023, 501, 8, 20, "Print"],
Cell[2012290, 42033, 571, 11, 20, "Print"],
Cell[2012864, 42046, 743, 17, 20, "Print"],
Cell[2013610, 42065, 743, 17, 20, "Print"],
Cell[2014356, 42084, 769, 17, 20, "Print"],
Cell[2015128, 42103, 434, 7, 20, "Print"],
Cell[2015565, 42112, 3695, 107, 78, "Print"],
Cell[2019263, 42221, 434, 7, 20, "Print"],
Cell[2019700, 42230, 3706, 109, 78, "Print"],
Cell[2023409, 42341, 831, 17, 26, "Print"],
Cell[2024243, 42360, 596, 11, 23, "Print"],
Cell[2024842, 42373, 704, 13, 20, "Print"],
Cell[2025549, 42388, 715, 13, 20, "Print"],
Cell[2026267, 42403, 501, 8, 20, "Print"],
Cell[2026771, 42413, 572, 11, 20, "Print"],
Cell[2027346, 42426, 737, 17, 20, "Print"],
Cell[2028086, 42445, 742, 17, 20, "Print"],
Cell[2028831, 42464, 765, 17, 20, "Print"],
Cell[2029599, 42483, 434, 7, 20, "Print"],
Cell[2030036, 42492, 3703, 107, 78, "Print"],
Cell[2033742, 42601, 434, 7, 20, "Print"],
Cell[2034179, 42610, 3705, 109, 78, "Print"],
Cell[2037887, 42721, 830, 17, 26, "Print"],
Cell[2038720, 42740, 596, 11, 23, "Print"],
Cell[2039319, 42753, 696, 13, 20, "Print"],
Cell[2040018, 42768, 719, 14, 20, "Print"],
Cell[2040740, 42784, 501, 8, 20, "Print"],
Cell[2041244, 42794, 571, 11, 20, "Print"],
Cell[2041818, 42807, 743, 17, 20, "Print"],
Cell[2042564, 42826, 737, 17, 20, "Print"],
Cell[2043304, 42845, 765, 17, 20, "Print"],
Cell[2044072, 42864, 434, 7, 20, "Print"],
Cell[2044509, 42873, 3700, 107, 78, "Print"],
Cell[2048212, 42982, 434, 7, 20, "Print"],
Cell[2048649, 42991, 3702, 109, 78, "Print"],
Cell[2052354, 43102, 833, 17, 26, "Print"],
Cell[2053190, 43121, 598, 11, 23, "Print"],
Cell[2053791, 43134, 699, 13, 20, "Print"],
Cell[2054493, 43149, 719, 14, 20, "Print"],
Cell[2055215, 43165, 501, 8, 20, "Print"],
Cell[2055719, 43175, 572, 11, 20, "Print"],
Cell[2056294, 43188, 743, 17, 20, "Print"],
Cell[2057040, 43207, 745, 17, 20, "Print"],
Cell[2057788, 43226, 763, 17, 20, "Print"],
Cell[2058554, 43245, 434, 7, 20, "Print"],
Cell[2058991, 43254, 3691, 107, 78, "Print"],
Cell[2062685, 43363, 433, 7, 20, "Print"],
Cell[2063121, 43372, 3714, 109, 78, "Print"],
Cell[2066838, 43483, 831, 17, 26, "Print"],
Cell[2067672, 43502, 596, 12, 23, "Print"],
Cell[2068271, 43516, 695, 13, 20, "Print"],
Cell[2068969, 43531, 722, 14, 20, "Print"],
Cell[2069694, 43547, 501, 8, 20, "Print"],
Cell[2070198, 43557, 571, 11, 20, "Print"],
Cell[2070772, 43570, 739, 17, 20, "Print"],
Cell[2071514, 43589, 743, 17, 20, "Print"],
Cell[2072260, 43608, 769, 17, 20, "Print"],
Cell[2073032, 43627, 433, 7, 20, "Print"],
Cell[2073468, 43636, 3686, 107, 78, "Print"],
Cell[2077157, 43745, 434, 7, 20, "Print"],
Cell[2077594, 43754, 3716, 109, 78, "Print"],
Cell[2081313, 43865, 831, 17, 26, "Print"],
Cell[2082147, 43884, 598, 11, 23, "Print"],
Cell[2082748, 43897, 696, 13, 20, "Print"],
Cell[2083447, 43912, 713, 13, 20, "Print"],
Cell[2084163, 43927, 501, 8, 20, "Print"],
Cell[2084667, 43937, 574, 11, 20, "Print"],
Cell[2085244, 43950, 739, 17, 20, "Print"],
Cell[2085986, 43969, 739, 17, 20, "Print"],
Cell[2086728, 43988, 767, 17, 20, "Print"],
Cell[2087498, 44007, 434, 7, 20, "Print"],
Cell[2087935, 44016, 3694, 107, 78, "Print"],
Cell[2091632, 44125, 434, 7, 20, "Print"],
Cell[2092069, 44134, 3706, 109, 78, "Print"],
Cell[2095778, 44245, 831, 17, 26, "Print"],
Cell[2096612, 44264, 598, 12, 23, "Print"],
Cell[2097213, 44278, 698, 13, 20, "Print"],
Cell[2097914, 44293, 721, 14, 20, "Print"],
Cell[2098638, 44309, 503, 8, 20, "Print"],
Cell[2099144, 44319, 574, 11, 20, "Print"],
Cell[2099721, 44332, 739, 17, 20, "Print"],
Cell[2100463, 44351, 739, 17, 20, "Print"],
Cell[2101205, 44370, 834, 19, 23, "Print"],
Cell[2102042, 44391, 436, 7, 20, "Print"],
Cell[2102481, 44400, 3704, 107, 78, "Print"],
Cell[2106188, 44509, 434, 7, 20, "Print"],
Cell[2106625, 44518, 3711, 109, 78, "Print"],
Cell[2110339, 44629, 826, 17, 26, "Print"],
Cell[2111168, 44648, 596, 11, 23, "Print"],
Cell[2111767, 44661, 704, 13, 20, "Print"],
Cell[2112474, 44676, 721, 14, 20, "Print"],
Cell[2113198, 44692, 501, 8, 20, "Print"],
Cell[2113702, 44702, 574, 11, 20, "Print"],
Cell[2114279, 44715, 739, 17, 20, "Print"],
Cell[2115021, 44734, 739, 17, 20, "Print"],
Cell[2115763, 44753, 836, 19, 23, "Print"],
Cell[2116602, 44774, 436, 7, 20, "Print"],
Cell[2117041, 44783, 3696, 107, 78, "Print"],
Cell[2120740, 44892, 434, 7, 20, "Print"],
Cell[2121177, 44901, 3719, 109, 78, "Print"],
Cell[2124899, 45012, 829, 17, 26, "Print"],
Cell[2125731, 45031, 598, 11, 23, "Print"],
Cell[2126332, 45044, 701, 13, 20, "Print"],
Cell[2127036, 45059, 722, 14, 20, "Print"],
Cell[2127761, 45075, 501, 8, 20, "Print"],
Cell[2128265, 45085, 574, 11, 20, "Print"],
Cell[2128842, 45098, 737, 17, 20, "Print"],
Cell[2129582, 45117, 739, 17, 20, "Print"],
Cell[2130324, 45136, 834, 19, 23, "Print"],
Cell[2131161, 45157, 434, 7, 20, "Print"],
Cell[2131598, 45166, 3702, 107, 78, "Print"],
Cell[2135303, 45275, 436, 7, 20, "Print"],
Cell[2135742, 45284, 3717, 109, 78, "Print"],
Cell[2139462, 45395, 831, 17, 26, "Print"],
Cell[2140296, 45414, 596, 12, 23, "Print"],
Cell[2140895, 45428, 697, 13, 20, "Print"],
Cell[2141595, 45443, 724, 14, 20, "Print"],
Cell[2142322, 45459, 501, 8, 20, "Print"],
Cell[2142826, 45469, 576, 11, 20, "Print"],
Cell[2143405, 45482, 745, 17, 20, "Print"],
Cell[2144153, 45501, 735, 17, 20, "Print"],
Cell[2144891, 45520, 834, 19, 23, "Print"],
Cell[2145728, 45541, 434, 7, 20, "Print"],
Cell[2146165, 45550, 3695, 107, 78, "Print"],
Cell[2149863, 45659, 434, 7, 20, "Print"],
Cell[2150300, 45668, 3703, 109, 78, "Print"],
Cell[2154006, 45779, 833, 17, 26, "Print"],
Cell[2154842, 45798, 598, 12, 23, "Print"],
Cell[2155443, 45812, 704, 13, 20, "Print"],
Cell[2156150, 45827, 723, 14, 20, "Print"],
Cell[2156876, 45843, 501, 8, 20, "Print"],
Cell[2157380, 45853, 574, 11, 20, "Print"],
Cell[2157957, 45866, 739, 17, 20, "Print"],
Cell[2158699, 45885, 743, 17, 20, "Print"],
Cell[2159445, 45904, 840, 19, 23, "Print"],
Cell[2160288, 45925, 434, 7, 20, "Print"],
Cell[2160725, 45934, 3689, 107, 78, "Print"],
Cell[2164417, 46043, 433, 7, 20, "Print"],
Cell[2164853, 46052, 3704, 109, 78, "Print"],
Cell[2168560, 46163, 833, 17, 26, "Print"],
Cell[2169396, 46182, 596, 11, 23, "Print"],
Cell[2169995, 46195, 702, 13, 20, "Print"],
Cell[2170700, 46210, 723, 14, 20, "Print"],
Cell[2171426, 46226, 501, 8, 20, "Print"],
Cell[2171930, 46236, 574, 11, 20, "Print"],
Cell[2172507, 46249, 742, 17, 20, "Print"],
Cell[2173252, 46268, 739, 17, 20, "Print"],
Cell[2173994, 46287, 838, 19, 23, "Print"],
Cell[2174835, 46308, 434, 7, 20, "Print"],
Cell[2175272, 46317, 3697, 107, 78, "Print"],
Cell[2178972, 46426, 434, 7, 20, "Print"],
Cell[2179409, 46435, 3708, 109, 78, "Print"],
Cell[2183120, 46546, 832, 17, 26, "Print"],
Cell[2183955, 46565, 596, 12, 23, "Print"],
Cell[2184554, 46579, 713, 13, 23, "Print"],
Cell[2185270, 46594, 732, 15, 20, "Print"],
Cell[2186005, 46611, 448, 7, 20, "Print"],
Cell[2186456, 46620, 501, 8, 20, "Print"],
Cell[2186960, 46630, 574, 11, 20, "Print"],
Cell[2187537, 46643, 745, 17, 20, "Print"],
Cell[2188285, 46662, 743, 17, 20, "Print"],
Cell[2189031, 46681, 838, 19, 23, "Print"],
Cell[2189872, 46702, 436, 7, 20, "Print"],
Cell[2190311, 46711, 3640, 107, 78, "Print"],
Cell[2193954, 46820, 434, 7, 20, "Print"],
Cell[2194391, 46829, 3713, 109, 78, "Print"],
Cell[2198107, 46940, 833, 17, 26, "Print"],
Cell[2198943, 46959, 596, 12, 23, "Print"],
Cell[2199542, 46973, 711, 13, 23, "Print"],
Cell[2200256, 46988, 728, 15, 23, "Print"],
Cell[2200987, 47005, 448, 7, 20, "Print"],
Cell[2201438, 47014, 501, 8, 20, "Print"],
Cell[2201942, 47024, 574, 11, 20, "Print"],
Cell[2202519, 47037, 743, 17, 20, "Print"],
Cell[2203265, 47056, 745, 17, 20, "Print"],
Cell[2204013, 47075, 841, 19, 23, "Print"],
Cell[2204857, 47096, 434, 7, 20, "Print"],
Cell[2205294, 47105, 3570, 107, 78, "Print"],
Cell[2208867, 47214, 434, 7, 20, "Print"],
Cell[2209304, 47223, 3714, 109, 78, "Print"],
Cell[2213021, 47334, 830, 17, 26, "Print"],
Cell[2213854, 47353, 596, 11, 23, "Print"],
Cell[2214453, 47366, 718, 14, 23, "Print"],
Cell[2215174, 47382, 728, 15, 23, "Print"],
Cell[2215905, 47399, 448, 7, 20, "Print"],
Cell[2216356, 47408, 448, 7, 20, "Print"],
Cell[2216807, 47417, 448, 7, 20, "Print"],
Cell[2217258, 47426, 667, 12, 20, "Print"],
Cell[2217928, 47440, 1629, 42, 90, "Print"],
Cell[2219560, 47484, 434, 7, 20, "Print"],
Cell[2219997, 47493, 3716, 109, 78, "Print"],
Cell[2223716, 47604, 5270, 124, 290, "Print"],
Cell[2228989, 47730, 813, 17, 26, "Print"],
Cell[2229805, 47749, 492, 8, 20, "Print"],
Cell[2230300, 47759, 479, 7, 20, "Print"],
Cell[2230782, 47768, 492, 8, 20, "Print"],
Cell[2231277, 47778, 2384, 56, 90, "Print"],
Cell[2233664, 47836, 490, 8, 20, "Print"],
Cell[2234157, 47846, 446, 7, 20, "Print"],
Cell[2234606, 47855, 490, 8, 20, "Print"],
Cell[2235099, 47865, 1610, 41, 38, "Print"],
Cell[2236712, 47908, 492, 8, 20, "Print"],
Cell[2237207, 47918, 464, 7, 20, "Print"],
Cell[2237674, 47927, 490, 8, 20, "Print"],
Cell[2238167, 47937, 490, 8, 20, "Print"],
Cell[2238660, 47947, 624, 12, 20, "Print"],
Cell[2239287, 47961, 1835, 44, 86, "Print"],
Cell[2241125, 48007, 493, 8, 20, "Print"],
Cell[2241621, 48017, 473, 7, 20, "Print"],
Cell[2242097, 48026, 491, 8, 20, "Print"],
Cell[2242591, 48036, 1942, 45, 78, "Print"],
Cell[2244536, 48083, 492, 8, 20, "Print"],
Cell[2245031, 48093, 498, 8, 22, "Print"],
Cell[2245532, 48103, 492, 8, 20, "Print"],
Cell[2246027, 48113, 1928, 45, 78, "Print"],
Cell[2247958, 48160, 434, 7, 20, "Print"],
Cell[2248395, 48169, 573, 11, 20, "Print"],
Cell[2248971, 48182, 492, 8, 20, "Print"],
Cell[2249466, 48192, 507, 8, 22, "Print"],
Cell[2249976, 48202, 492, 8, 20, "Print"],
Cell[2250471, 48212, 1770, 39, 78, "Print"],
Cell[2252244, 48253, 434, 7, 20, "Print"],
Cell[2252681, 48262, 573, 11, 20, "Print"],
Cell[2253257, 48275, 492, 8, 20, "Print"],
Cell[2253752, 48285, 457, 7, 20, "Print"],
Cell[2254212, 48294, 492, 8, 20, "Print"],
Cell[2254707, 48304, 632, 12, 20, "Print"],
Cell[2255342, 48318, 508, 8, 20, "Print"],
Cell[2255853, 48328, 1873, 50, 56, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[2257775, 48384, 331, 11, 50, "Input"],
Cell[2258109, 48397, 1485, 35, 85, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2259655, 48439, 31, 0, 34, "Subsection"],
Cell[2259689, 48441, 656, 20, 43, "Input"],
Cell[CellGroupData[{
Cell[2260370, 48465, 125, 1, 43, "Input"],
Cell[2260498, 48468, 236, 5, 27, "Output"],
Cell[2260737, 48475, 304, 7, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2261078, 48487, 196, 5, 27, "Input"],
Cell[2261277, 48494, 242, 7, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2261556, 48506, 2666, 80, 208, "Input"],
Cell[2264225, 48588, 1672, 33, 260, "Output"]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2265958, 48628, 282, 5, 37, "Section"],
Cell[CellGroupData[{
Cell[2266265, 48637, 122, 2, 27, "Input"],
Cell[2266390, 48641, 821, 15, 23, "Message"],
Cell[2267214, 48658, 861, 15, 23, "Message"],
Cell[2268078, 48675, 837, 15, 23, "Message"],
Cell[2268918, 48692, 886, 16, 23, "Message"],
Cell[2269807, 48710, 755, 13, 23, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2270599, 48728, 129, 2, 27, "Input"],
Cell[2270731, 48732, 971, 19, 23, "Message"],
Cell[2271705, 48753, 704, 13, 23, "Message"],
Cell[2272412, 48768, 890, 15, 23, "Message"],
Cell[2273305, 48785, 698, 12, 23, "Message"],
Cell[2274006, 48799, 911, 16, 23, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2274954, 48820, 159, 3, 34, "Subsection"],
Cell[CellGroupData[{
Cell[2275138, 48827, 120, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[2275283, 48833, 196, 4, 42, "Print",
 CellTags->"Info3461062918-2707977"],
Cell[2275482, 48839, 1290, 36, 64, "Print",
 CellTags->"Info3461062918-2707977"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2276821, 48881, 684, 17, 43, "Input"],
Cell[2277508, 48900, 378, 9, 46, "Output"],
Cell[2277889, 48911, 3186, 59, 242, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2281112, 48975, 799, 25, 27, "Input"],
Cell[2281914, 49002, 1239, 36, 46, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2283190, 49043, 633, 15, 27, "Input"],
Cell[2283826, 49060, 1451, 29, 238, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2285314, 49094, 94, 1, 27, "Input"],
Cell[2285411, 49097, 118, 2, 27, "Output"]
}, Open  ]],
Cell[2285544, 49102, 2322, 58, 238, "Input"],
Cell[2287869, 49162, 7223, 160, 433, "Input"],
Cell[CellGroupData[{
Cell[2295117, 49326, 96, 1, 27, "Input"],
Cell[2295216, 49329, 214, 3, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2295467, 49337, 1855, 45, 148, "Input"],
Cell[2297325, 49384, 3131, 57, 69, "Output"],
Cell[2300459, 49443, 3116, 57, 69, "Output"],
Cell[2303578, 49502, 3131, 57, 69, "Output"],
Cell[2306712, 49561, 3185, 59, 89, "Output"],
Cell[2309900, 49622, 5660, 92, 240, "Output"],
Cell[2315563, 49716, 2441, 40, 33, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[2318053, 49762, 114, 3, 26, "Subsection"],
Cell[CellGroupData[{
Cell[2318192, 49769, 1302, 27, 73, "Input"],
Cell[2319497, 49798, 2056, 30, 27, "Output"]
}, Open  ]],
Cell[2321568, 49831, 1322, 34, 58, "Input"],
Cell[CellGroupData[{
Cell[2322915, 49869, 248, 3, 73, "Input"],
Cell[2323166, 49874, 1867, 31, 27, "Output"],
Cell[2325036, 49907, 1814, 29, 27, "Output"],
Cell[2326853, 49938, 1867, 31, 27, "Output"],
Cell[2328723, 49971, 1731, 25, 27, "Output"]
}, Open  ]],
Cell[2330469, 49999, 122, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[2330616, 50005, 95, 1, 27, "Input"],
Cell[2330714, 50008, 410, 12, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2331161, 50025, 826, 14, 27, "Input"],
Cell[2331990, 50041, 3224, 52, 98, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2335251, 50098, 338, 9, 27, "Input"],
Cell[2335592, 50109, 2332, 46, 69, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2337961, 50160, 468, 10, 27, "Input"],
Cell[2338432, 50172, 2307, 39, 87, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2340776, 50216, 136, 4, 27, "Input"],
Cell[2340915, 50222, 1647, 25, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2342599, 50252, 83, 2, 27, "Input"],
Cell[2342685, 50256, 165, 4, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2342887, 50265, 174, 2, 43, "Input"],
Cell[2343064, 50269, 7541, 183, 118, "Output"],
Cell[2350608, 50454, 7737, 198, 118, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2358382, 50657, 1250, 31, 73, "Input"],
Cell[2359635, 50690, 11719, 249, 243, "Output"],
Cell[2371357, 50941, 11745, 249, 240, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[2383151, 51196, 100, 2, 27, "Subsection"],
Cell[CellGroupData[{
Cell[2383276, 51202, 119, 1, 24, "Subsubsection"],
Cell[CellGroupData[{
Cell[2383420, 51207, 125, 2, 27, "Input"],
Cell[2383548, 51211, 138, 3, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2383723, 51219, 510, 8, 58, "Input"],
Cell[2384236, 51229, 224, 4, 27, "Output"],
Cell[2384463, 51235, 221, 4, 27, "Output"],
Cell[2384687, 51241, 225, 4, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2384949, 51250, 6198, 140, 133, "Input"],
Cell[2391150, 51392, 6044, 103, 237, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2397243, 51501, 27, 0, 24, "Subsubsection"],
Cell[CellGroupData[{
Cell[2397295, 51505, 404, 6, 43, "Input"],
Cell[2397702, 51513, 506, 8, 27, "Output"],
Cell[2398211, 51523, 584, 11, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2398832, 51539, 10406, 178, 103, "Input"],
Cell[2409241, 51719, 355294, 6038, 160, 304720, 5217, "CachedBoxData", \
"BoxData", "Print"],
Cell[2764538, 57759, 4043, 57, 27, "Output"],
Cell[CellGroupData[{
Cell[2768606, 57820, 3863, 55, 20, "Print"],
Cell[2772472, 57877, 3871, 55, 20, "Print"],
Cell[2776346, 57934, 336360, 5747, 160, 285025, 4913, "CachedBoxData", \
"BoxData", "Print"]
}, Open  ]],
Cell[3112721, 63684, 4044, 57, 27, "Output"],
Cell[CellGroupData[{
Cell[3116790, 63745, 3837, 55, 20, "Print"],
Cell[3120630, 63802, 3867, 55, 20, "Print"],
Cell[3124500, 63859, 337265, 5754, 160, 282390, 4862, "CachedBoxData", \
"BoxData", "Print"]
}, Open  ]],
Cell[3461780, 69616, 4045, 57, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3465862, 69678, 7005, 110, 43, "Input"],
Cell[3472870, 69790, 612, 10, 27, "Output"],
Cell[3473485, 69802, 611, 10, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3474133, 69817, 288, 5, 27, "Input"],
Cell[3474424, 69824, 242, 5, 27, "Output"]
}, Open  ]],
Cell[3474681, 69832, 6629, 158, 118, "Input"],
Cell[CellGroupData[{
Cell[3481335, 69994, 1086, 17, 73, "Input"],
Cell[3482424, 70013, 2386, 34, 27, "Output"],
Cell[3484813, 70049, 2386, 34, 27, "Output"],
Cell[3487202, 70085, 2385, 34, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3489624, 70124, 3283, 71, 73, "Input"],
Cell[3492910, 70197, 5504, 107, 209, "Output"]
}, Open  ]],
Cell[3498429, 70307, 69, 1, 27, "Input"],
Cell[3498501, 70310, 106, 2, 26, "Text"],
Cell[CellGroupData[{
Cell[3498632, 70316, 1056, 19, 133, "Input"],
Cell[3499691, 70337, 821, 13, 27, "Output"],
Cell[3500515, 70352, 841, 14, 27, "Output"],
Cell[3501359, 70368, 798, 12, 27, "Output"],
Cell[3502160, 70382, 801, 12, 27, "Output"],
Cell[3502964, 70396, 796, 12, 27, "Output"],
Cell[3503763, 70410, 796, 12, 27, "Output"],
Cell[3504562, 70424, 797, 12, 27, "Output"],
Cell[3505362, 70438, 796, 12, 27, "Output"]
}, Open  ]],
Cell[3506173, 70453, 179, 3, 27, "Input"],
Cell[CellGroupData[{
Cell[3506377, 70460, 3116, 70, 88, "Input"],
Cell[CellGroupData[{
Cell[3509518, 70534, 1539, 24, 20, "Print"],
Cell[3511060, 70560, 1435, 20, 20, "Print"],
Cell[3512498, 70582, 1419, 21, 20, "Print"],
Cell[3513920, 70605, 1467, 21, 20, "Print"],
Cell[3515390, 70628, 1467, 21, 20, "Print"],
Cell[3516860, 70651, 1467, 21, 20, "Print"],
Cell[3518330, 70674, 1419, 20, 20, "Print"],
Cell[3519752, 70696, 1414, 20, 20, "Print"],
Cell[3521169, 70718, 1467, 21, 20, "Print"],
Cell[3522639, 70741, 2781, 63, 38, "Print"],
Cell[3525423, 70806, 1403, 20, 20, "Print"],
Cell[3526829, 70828, 2646, 57, 42, "Print"],
Cell[3529478, 70887, 1405, 20, 20, "Print"],
Cell[3530886, 70909, 2804, 63, 42, "Print"],
Cell[3533693, 70974, 1403, 20, 20, "Print"],
Cell[3535099, 70996, 1414, 20, 20, "Print"]
}, Open  ]],
Cell[3536528, 71019, 1887, 29, 23, "Message"],
Cell[CellGroupData[{
Cell[3538440, 71052, 1582, 27, 20, "Print"],
Cell[3540025, 71081, 1403, 20, 20, "Print"],
Cell[3541431, 71103, 1469, 21, 20, "Print"],
Cell[3542903, 71126, 1405, 20, 20, "Print"],
Cell[3544311, 71148, 1576, 25, 20, "Print"],
Cell[3545890, 71175, 1599, 25, 26, "Print"],
Cell[3547492, 71202, 1522, 24, 20, "Print"],
Cell[3549017, 71228, 1470, 21, 20, "Print"],
Cell[3550490, 71251, 1541, 24, 20, "Print"],
Cell[3552034, 71277, 1712, 30, 20, "Print"],
Cell[3553749, 71309, 1712, 30, 20, "Print"],
Cell[3555464, 71341, 1728, 30, 20, "Print"],
Cell[3557195, 71373, 1403, 20, 20, "Print"],
Cell[3558601, 71395, 3070, 72, 36, "Print"],
Cell[3561674, 71469, 1403, 20, 20, "Print"],
Cell[3563080, 71491, 2587, 56, 36, "Print"],
Cell[3565670, 71549, 1599, 25, 26, "Print"],
Cell[3567272, 71576, 1565, 24, 20, "Print"],
Cell[3568840, 71602, 1642, 25, 20, "Print"],
Cell[3570485, 71629, 1678, 26, 20, "Print"],
Cell[3572166, 71657, 1470, 21, 20, "Print"],
Cell[3573639, 71680, 1541, 24, 20, "Print"],
Cell[3575183, 71706, 1712, 30, 20, "Print"],
Cell[3576898, 71738, 1712, 30, 20, "Print"],
Cell[3578613, 71770, 1724, 30, 20, "Print"],
Cell[3580340, 71802, 1403, 20, 20, "Print"],
Cell[3581746, 71824, 3102, 72, 36, "Print"],
Cell[3584851, 71898, 1403, 20, 20, "Print"],
Cell[3586257, 71920, 2608, 56, 36, "Print"],
Cell[3588868, 71978, 1599, 25, 26, "Print"],
Cell[3590470, 72005, 1567, 25, 20, "Print"],
Cell[3592040, 72032, 1677, 26, 20, "Print"],
Cell[3593720, 72060, 1678, 26, 20, "Print"],
Cell[3595401, 72088, 1470, 21, 20, "Print"],
Cell[3596874, 72111, 1541, 24, 20, "Print"],
Cell[3598418, 72137, 1714, 30, 20, "Print"],
Cell[3600135, 72169, 1712, 30, 20, "Print"],
Cell[3601850, 72201, 1728, 30, 20, "Print"],
Cell[3603581, 72233, 1403, 20, 20, "Print"],
Cell[3604987, 72255, 3120, 72, 36, "Print"],
Cell[3608110, 72329, 1403, 20, 20, "Print"],
Cell[3609516, 72351, 2608, 56, 36, "Print"],
Cell[3612127, 72409, 1601, 25, 26, "Print"],
Cell[3613731, 72436, 1567, 24, 20, "Print"],
Cell[3615301, 72462, 1676, 26, 20, "Print"],
Cell[3616980, 72490, 1678, 26, 20, "Print"],
Cell[3618661, 72518, 1472, 21, 20, "Print"],
Cell[3620136, 72541, 1543, 24, 20, "Print"],
Cell[3621682, 72567, 2101, 38, 20, "Print"],
Cell[3623786, 72607, 2101, 38, 20, "Print"],
Cell[3625890, 72647, 1711, 30, 20, "Print"],
Cell[3627604, 72679, 1712, 30, 20, "Print"],
Cell[3629319, 72711, 1724, 30, 20, "Print"],
Cell[3631046, 72743, 1403, 20, 20, "Print"],
Cell[3632452, 72765, 3121, 72, 36, "Print"],
Cell[3635576, 72839, 1403, 20, 20, "Print"],
Cell[3636982, 72861, 2610, 56, 36, "Print"],
Cell[3639595, 72919, 1599, 25, 26, "Print"],
Cell[3641197, 72946, 1565, 24, 20, "Print"],
Cell[3642765, 72972, 1669, 26, 20, "Print"],
Cell[3644437, 73000, 1678, 26, 20, "Print"],
Cell[3646118, 73028, 1470, 21, 20, "Print"],
Cell[3647591, 73051, 1541, 24, 20, "Print"],
Cell[3649135, 73077, 2103, 38, 20, "Print"],
Cell[3651241, 73117, 1714, 30, 20, "Print"],
Cell[3652958, 73149, 1712, 30, 20, "Print"],
Cell[3654673, 73181, 1728, 30, 20, "Print"],
Cell[3656404, 73213, 1403, 20, 20, "Print"],
Cell[3657810, 73235, 3121, 72, 36, "Print"],
Cell[3660934, 73309, 1403, 20, 20, "Print"],
Cell[3662340, 73331, 2610, 56, 36, "Print"],
Cell[3664953, 73389, 1599, 25, 26, "Print"],
Cell[3666555, 73416, 1566, 25, 23, "Print"],
Cell[3668124, 73443, 1670, 26, 20, "Print"],
Cell[3669797, 73471, 1685, 27, 20, "Print"],
Cell[3671485, 73500, 1470, 21, 20, "Print"],
Cell[3672958, 73523, 1540, 24, 20, "Print"],
Cell[3674501, 73549, 1708, 30, 20, "Print"],
Cell[3676212, 73581, 1714, 30, 20, "Print"],
Cell[3677929, 73613, 1728, 30, 20, "Print"],
Cell[3679660, 73645, 1403, 20, 20, "Print"],
Cell[3681066, 73667, 3123, 72, 36, "Print"],
Cell[3684192, 73741, 1405, 20, 20, "Print"]
}, Open  ]],
Cell[3685612, 73764, 1787, 28, 23, "Message"],
Cell[CellGroupData[{
Cell[3687424, 73796, 2611, 56, 36, "Print"],
Cell[3690038, 73854, 1599, 25, 26, "Print"],
Cell[3691640, 73881, 1560, 24, 23, "Print"],
Cell[3693203, 73907, 1671, 26, 20, "Print"],
Cell[3694877, 73935, 1689, 27, 20, "Print"],
Cell[3696569, 73964, 1469, 21, 20, "Print"],
Cell[3698041, 73987, 1541, 24, 20, "Print"],
Cell[3699585, 74013, 1708, 30, 20, "Print"],
Cell[3701296, 74045, 1710, 30, 20, "Print"],
Cell[3703009, 74077, 1738, 30, 20, "Print"],
Cell[3704750, 74109, 1403, 20, 20, "Print"],
Cell[3706156, 74131, 3119, 72, 36, "Print"],
Cell[3709278, 74205, 1402, 20, 20, "Print"]
}, Open  ]],
Cell[3710695, 74228, 1787, 28, 23, "Message"],
Cell[CellGroupData[{
Cell[3712507, 74260, 2611, 56, 36, "Print"],
Cell[3715121, 74318, 1599, 25, 26, "Print"],
Cell[3716723, 74345, 1562, 24, 23, "Print"],
Cell[3718288, 74371, 1668, 26, 20, "Print"],
Cell[3719959, 74399, 1698, 28, 20, "Print"],
Cell[3721660, 74429, 1470, 21, 20, "Print"],
Cell[3723133, 74452, 1541, 24, 20, "Print"],
Cell[3724677, 74478, 1714, 30, 20, "Print"],
Cell[3726394, 74510, 1708, 30, 20, "Print"],
Cell[3728105, 74542, 1806, 32, 23, "Print"],
Cell[3729914, 74576, 1403, 20, 20, "Print"],
Cell[3731320, 74598, 3100, 72, 36, "Print"],
Cell[3734423, 74672, 1403, 20, 20, "Print"]
}, Open  ]],
Cell[3735841, 74695, 1787, 28, 23, "Message"],
Cell[3737631, 74725, 1909, 29, 23, "Message"],
Cell[CellGroupData[{
Cell[3739565, 74758, 2611, 56, 36, "Print"],
Cell[3742179, 74816, 1601, 25, 26, "Print"],
Cell[3743783, 74843, 1565, 25, 23, "Print"],
Cell[3745351, 74870, 1675, 26, 23, "Print"],
Cell[3747029, 74898, 1696, 28, 23, "Print"],
Cell[3748728, 74928, 1419, 20, 20, "Print"],
Cell[3750150, 74950, 1417, 20, 20, "Print"],
Cell[3751570, 74972, 1419, 20, 20, "Print"],
Cell[3752992, 74994, 1637, 25, 20, "Print"],
Cell[3754632, 75021, 2412, 49, 36, "Print"],
Cell[3757047, 75072, 1403, 20, 20, "Print"],
Cell[3758453, 75094, 2611, 56, 36, "Print"],
Cell[3761067, 75152, 3132, 68, 150, "Print"],
Cell[3764202, 75222, 1582, 25, 26, "Print"],
Cell[3765787, 75249, 1461, 21, 20, "Print"],
Cell[3767251, 75272, 1448, 20, 20, "Print"],
Cell[3768702, 75294, 1461, 21, 20, "Print"],
Cell[3770166, 75317, 2911, 60, 36, "Print"],
Cell[3773080, 75379, 1459, 21, 20, "Print"],
Cell[3774542, 75402, 1413, 20, 20, "Print"],
Cell[3775958, 75424, 1459, 21, 20, "Print"],
Cell[3777420, 75447, 2560, 54, 38, "Print"],
Cell[3779983, 75503, 1435, 20, 20, "Print"],
Cell[3781421, 75525, 1459, 21, 20, "Print"],
Cell[3782883, 75548, 1436, 20, 20, "Print"],
Cell[3784322, 75570, 1459, 21, 20, "Print"],
Cell[3785784, 75593, 1461, 21, 20, "Print"],
Cell[3787248, 75616, 1593, 25, 20, "Print"],
Cell[3788844, 75643, 2540, 52, 38, "Print"],
Cell[3791387, 75697, 1460, 21, 20, "Print"],
Cell[3792850, 75720, 1444, 20, 20, "Print"],
Cell[3794297, 75742, 1460, 21, 20, "Print"],
Cell[3795760, 75765, 2280, 45, 36, "Print"],
Cell[3798043, 75812, 1461, 21, 20, "Print"],
Cell[3799507, 75835, 1465, 21, 22, "Print"],
Cell[3800975, 75858, 1461, 21, 20, "Print"],
Cell[3802439, 75881, 2301, 45, 36, "Print"],
Cell[3804743, 75928, 1403, 20, 20, "Print"],
Cell[3806149, 75950, 1443, 21, 20, "Print"],
Cell[3807595, 75973, 1461, 21, 20, "Print"],
Cell[3809059, 75996, 1478, 21, 22, "Print"],
Cell[3810540, 76019, 1461, 21, 20, "Print"],
Cell[3812004, 76042, 2298, 45, 36, "Print"],
Cell[3814305, 76089, 1403, 20, 20, "Print"],
Cell[3815711, 76111, 1436, 21, 20, "Print"],
Cell[3817150, 76134, 1463, 21, 20, "Print"],
Cell[3818616, 76157, 1428, 20, 20, "Print"],
Cell[3820047, 76179, 1463, 21, 20, "Print"],
Cell[3821513, 76202, 1603, 25, 20, "Print"],
Cell[3823119, 76229, 1476, 21, 20, "Print"],
Cell[3824598, 76252, 2891, 64, 56, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[3827538, 76322, 331, 11, 50, "Input"],
Cell[3827872, 76335, 1447, 33, 55, "Output"]
}, Open  ]],
Cell[3829334, 76371, 173, 4, 27, "Input"],
Cell[CellGroupData[{
Cell[3829532, 76379, 3042, 69, 88, "Input"],
Cell[CellGroupData[{
Cell[3832599, 76452, 1489, 23, 20, "Print"],
Cell[3834091, 76477, 1385, 19, 20, "Print"],
Cell[3835479, 76498, 1369, 20, 20, "Print"],
Cell[3836851, 76520, 1419, 20, 20, "Print"],
Cell[3838273, 76542, 1419, 20, 20, "Print"],
Cell[3839695, 76564, 1419, 20, 20, "Print"],
Cell[3841117, 76586, 1369, 19, 20, "Print"],
Cell[3842489, 76607, 1364, 19, 20, "Print"],
Cell[3843856, 76628, 1419, 20, 20, "Print"],
Cell[3845278, 76650, 2731, 62, 38, "Print"],
Cell[3848012, 76714, 1353, 19, 20, "Print"],
Cell[3849368, 76735, 2596, 56, 42, "Print"],
Cell[3851967, 76793, 1353, 19, 20, "Print"],
Cell[3853323, 76814, 2752, 62, 42, "Print"],
Cell[3856078, 76878, 1353, 19, 20, "Print"],
Cell[3857434, 76899, 1363, 19, 20, "Print"]
}, Open  ]],
Cell[3858812, 76921, 1841, 29, 23, "Message"],
Cell[CellGroupData[{
Cell[3860678, 76954, 1532, 26, 20, "Print"],
Cell[3862213, 76982, 1352, 19, 20, "Print"],
Cell[3863568, 77003, 1417, 20, 20, "Print"],
Cell[3864988, 77025, 1353, 19, 20, "Print"],
Cell[3866344, 77046, 1524, 24, 20, "Print"],
Cell[3867871, 77072, 1549, 24, 26, "Print"],
Cell[3869423, 77098, 1472, 23, 20, "Print"],
Cell[3870898, 77123, 1420, 20, 20, "Print"],
Cell[3872321, 77145, 1491, 23, 20, "Print"],
Cell[3873815, 77170, 2053, 37, 20, "Print"],
Cell[3875871, 77209, 1662, 29, 20, "Print"],
Cell[3877536, 77240, 1662, 29, 20, "Print"],
Cell[3879201, 77271, 1672, 29, 20, "Print"],
Cell[3880876, 77302, 1353, 19, 20, "Print"],
Cell[3882232, 77323, 3022, 71, 36, "Print"],
Cell[3885257, 77396, 1355, 19, 20, "Print"],
Cell[3886615, 77417, 2537, 55, 36, "Print"],
Cell[3889155, 77474, 1549, 24, 26, "Print"],
Cell[3890707, 77500, 1512, 23, 23, "Print"],
Cell[3892222, 77525, 1589, 24, 20, "Print"],
Cell[3893814, 77551, 1639, 26, 20, "Print"],
Cell[3895456, 77579, 1420, 20, 20, "Print"],
Cell[3896879, 77601, 1493, 23, 20, "Print"],
Cell[3898375, 77626, 1660, 29, 20, "Print"],
Cell[3900038, 77657, 1662, 29, 20, "Print"],
Cell[3901703, 77688, 1680, 29, 20, "Print"],
Cell[3903386, 77719, 1353, 19, 20, "Print"],
Cell[3904742, 77740, 3051, 71, 36, "Print"],
Cell[3907796, 77813, 1353, 19, 20, "Print"],
Cell[3909152, 77834, 2560, 55, 36, "Print"],
Cell[3911715, 77891, 1549, 24, 26, "Print"],
Cell[3913267, 77917, 1510, 23, 23, "Print"],
Cell[3914780, 77942, 1617, 25, 20, "Print"],
Cell[3916400, 77969, 1638, 26, 20, "Print"],
Cell[3918041, 77997, 1420, 20, 20, "Print"],
Cell[3919464, 78019, 1491, 23, 20, "Print"],
Cell[3920958, 78044, 1658, 29, 20, "Print"],
Cell[3922619, 78075, 1658, 29, 20, "Print"],
Cell[3924280, 78106, 1686, 29, 20, "Print"],
Cell[3925969, 78137, 1353, 19, 20, "Print"],
Cell[3927325, 78158, 3069, 71, 36, "Print"],
Cell[3930397, 78231, 1353, 19, 20, "Print"],
Cell[3931753, 78252, 2559, 55, 36, "Print"],
Cell[3934315, 78309, 1549, 24, 26, "Print"],
Cell[3935867, 78335, 1518, 24, 23, "Print"],
Cell[3937388, 78361, 1615, 25, 20, "Print"],
Cell[3939006, 78388, 1646, 27, 20, "Print"],
Cell[3940655, 78417, 1422, 20, 20, "Print"],
Cell[3942080, 78439, 1491, 23, 20, "Print"],
Cell[3943574, 78464, 1662, 29, 20, "Print"],
Cell[3945239, 78495, 1660, 29, 20, "Print"],
Cell[3946902, 78526, 1755, 31, 23, "Print"],
Cell[3948660, 78559, 1353, 19, 20, "Print"],
Cell[3950016, 78580, 3070, 71, 36, "Print"],
Cell[3953089, 78653, 1355, 19, 20, "Print"],
Cell[3954447, 78674, 2562, 55, 36, "Print"],
Cell[3957012, 78731, 1549, 24, 26, "Print"],
Cell[3958564, 78757, 1515, 23, 23, "Print"],
Cell[3960082, 78782, 1615, 25, 20, "Print"],
Cell[3961700, 78809, 1640, 26, 23, "Print"],
Cell[3963343, 78837, 1367, 19, 20, "Print"],
Cell[3964713, 78858, 1367, 19, 20, "Print"],
Cell[3966083, 78879, 1367, 19, 20, "Print"],
Cell[3967453, 78900, 1583, 24, 20, "Print"],
Cell[3969039, 78926, 2358, 48, 36, "Print"],
Cell[3971400, 78976, 1355, 19, 20, "Print"],
Cell[3972758, 78997, 2558, 55, 36, "Print"],
Cell[3975319, 79054, 2755, 59, 94, "Print"],
Cell[3978077, 79115, 1534, 24, 26, "Print"],
Cell[3979614, 79141, 1411, 20, 20, "Print"],
Cell[3981028, 79163, 1398, 19, 20, "Print"],
Cell[3982429, 79184, 1413, 20, 20, "Print"],
Cell[3983845, 79206, 2854, 59, 36, "Print"],
Cell[3986702, 79267, 1409, 20, 20, "Print"],
Cell[3988114, 79289, 1363, 19, 20, "Print"],
Cell[3989480, 79310, 1408, 20, 20, "Print"],
Cell[3990891, 79332, 2511, 53, 38, "Print"],
Cell[3993405, 79387, 1385, 19, 20, "Print"],
Cell[3994793, 79408, 1409, 20, 20, "Print"],
Cell[3996205, 79430, 1386, 19, 20, "Print"],
Cell[3997594, 79451, 1409, 20, 20, "Print"],
Cell[3999006, 79473, 1408, 20, 20, "Print"],
Cell[4000417, 79495, 1543, 24, 20, "Print"],
Cell[4001963, 79521, 2488, 51, 38, "Print"],
Cell[4004454, 79574, 1412, 20, 20, "Print"],
Cell[4005869, 79596, 1394, 19, 20, "Print"],
Cell[4007266, 79617, 1412, 20, 20, "Print"],
Cell[4008681, 79639, 2230, 44, 36, "Print"],
Cell[4010914, 79685, 1410, 20, 20, "Print"],
Cell[4012327, 79707, 1414, 20, 22, "Print"],
Cell[4013744, 79729, 1413, 20, 20, "Print"],
Cell[4015160, 79751, 2248, 44, 36, "Print"],
Cell[4017411, 79797, 1353, 19, 20, "Print"],
Cell[4018767, 79818, 1388, 20, 20, "Print"],
Cell[4020158, 79840, 1410, 20, 20, "Print"],
Cell[4021571, 79862, 1426, 20, 22, "Print"],
Cell[4023000, 79884, 1413, 20, 20, "Print"],
Cell[4024416, 79906, 2245, 44, 36, "Print"],
Cell[4026664, 79952, 1353, 19, 20, "Print"],
Cell[4028020, 79973, 1385, 20, 20, "Print"],
Cell[4029408, 79995, 1410, 20, 20, "Print"],
Cell[4030821, 80017, 1376, 19, 20, "Print"],
Cell[4032200, 80038, 1411, 20, 20, "Print"],
Cell[4033614, 80060, 1553, 24, 20, "Print"],
Cell[4035170, 80086, 1427, 20, 20, "Print"],
Cell[4036600, 80108, 2841, 63, 56, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[4039490, 80177, 331, 11, 50, "Input"],
Cell[4039824, 80190, 1418, 32, 55, "Output"]
}, Open  ]],
Cell[4041257, 80225, 175, 3, 27, "Input"],
Cell[CellGroupData[{
Cell[4041457, 80232, 3060, 69, 88, "Input"],
Cell[CellGroupData[{
Cell[4044542, 80305, 1489, 23, 20, "Print"],
Cell[4046034, 80330, 1385, 19, 20, "Print"],
Cell[4047422, 80351, 1369, 20, 20, "Print"],
Cell[4048794, 80373, 1417, 20, 20, "Print"],
Cell[4050214, 80395, 1417, 20, 20, "Print"],
Cell[4051634, 80417, 1417, 20, 20, "Print"],
Cell[4053054, 80439, 1371, 19, 20, "Print"],
Cell[4054428, 80460, 1364, 19, 20, "Print"],
Cell[4055795, 80481, 1419, 20, 20, "Print"],
Cell[4057217, 80503, 2731, 62, 38, "Print"],
Cell[4059951, 80567, 1355, 19, 20, "Print"],
Cell[4061309, 80588, 2596, 56, 42, "Print"],
Cell[4063908, 80646, 1353, 19, 20, "Print"],
Cell[4065264, 80667, 2752, 62, 42, "Print"],
Cell[4068019, 80731, 1353, 19, 20, "Print"],
Cell[4069375, 80752, 1364, 19, 20, "Print"]
}, Open  ]],
Cell[4070754, 80774, 1843, 29, 23, "Message"],
Cell[CellGroupData[{
Cell[4072622, 80807, 1534, 26, 20, "Print"],
Cell[4074159, 80835, 1353, 19, 20, "Print"],
Cell[4075515, 80856, 1417, 20, 20, "Print"],
Cell[4076935, 80878, 1353, 19, 20, "Print"],
Cell[4078291, 80899, 1526, 24, 20, "Print"],
Cell[4079820, 80925, 1549, 24, 26, "Print"],
Cell[4081372, 80951, 1490, 24, 20, "Print"],
Cell[4082865, 80977, 1420, 20, 20, "Print"],
Cell[4084288, 80999, 1493, 23, 20, "Print"],
Cell[4085784, 81024, 2043, 37, 20, "Print"],
Cell[4087830, 81063, 2047, 37, 20, "Print"],
Cell[4089880, 81102, 2043, 37, 20, "Print"],
Cell[4091926, 81141, 1660, 29, 20, "Print"],
Cell[4093589, 81172, 1660, 29, 20, "Print"],
Cell[4095252, 81203, 1674, 29, 20, "Print"],
Cell[4096929, 81234, 1353, 19, 20, "Print"],
Cell[4098285, 81255, 3031, 71, 36, "Print"],
Cell[4101319, 81328, 1355, 19, 20, "Print"],
Cell[4102677, 81349, 2537, 55, 36, "Print"],
Cell[4105217, 81406, 1551, 24, 26, "Print"],
Cell[4106771, 81432, 1515, 23, 20, "Print"],
Cell[4108289, 81457, 1592, 24, 20, "Print"],
Cell[4109884, 81483, 1633, 26, 20, "Print"],
Cell[4111520, 81511, 1420, 20, 20, "Print"],
Cell[4112943, 81533, 1491, 23, 20, "Print"],
Cell[4114437, 81558, 1662, 29, 20, "Print"],
Cell[4116102, 81589, 1658, 29, 20, "Print"],
Cell[4117763, 81620, 1682, 29, 20, "Print"],
Cell[4119448, 81651, 1355, 19, 20, "Print"],
Cell[4120806, 81672, 3060, 71, 36, "Print"],
Cell[4123869, 81745, 1353, 19, 20, "Print"]
}, Open  ]],
Cell[4125237, 81767, 1741, 28, 23, "Message"],
Cell[CellGroupData[{
Cell[4127003, 81799, 2561, 55, 36, "Print"],
Cell[4129567, 81856, 1551, 24, 26, "Print"],
Cell[4131121, 81882, 1510, 23, 23, "Print"],
Cell[4132634, 81907, 1620, 25, 20, "Print"],
Cell[4134257, 81934, 1634, 25, 20, "Print"],
Cell[4135894, 81961, 1420, 20, 20, "Print"],
Cell[4137317, 81983, 1491, 23, 20, "Print"],
Cell[4138811, 82008, 1664, 29, 20, "Print"],
Cell[4140478, 82039, 1662, 29, 20, "Print"],
Cell[4142143, 82070, 1686, 29, 20, "Print"],
Cell[4143832, 82101, 1355, 19, 20, "Print"],
Cell[4145190, 82122, 3072, 71, 36, "Print"],
Cell[4148265, 82195, 1355, 19, 20, "Print"]
}, Open  ]],
Cell[4149635, 82217, 1741, 28, 23, "Message"],
Cell[CellGroupData[{
Cell[4151401, 82249, 2559, 55, 36, "Print"],
Cell[4153963, 82306, 1549, 24, 26, "Print"],
Cell[4155515, 82332, 1510, 23, 23, "Print"],
Cell[4157028, 82357, 1618, 25, 20, "Print"],
Cell[4158649, 82384, 1642, 26, 20, "Print"],
Cell[4160294, 82412, 1422, 20, 20, "Print"],
Cell[4161719, 82434, 1491, 23, 20, "Print"],
Cell[4163213, 82459, 1662, 29, 20, "Print"],
Cell[4164878, 82490, 1662, 29, 20, "Print"],
Cell[4166543, 82521, 1759, 31, 23, "Print"],
Cell[4168305, 82554, 1355, 19, 20, "Print"],
Cell[4169663, 82575, 3050, 71, 36, "Print"],
Cell[4172716, 82648, 1353, 19, 20, "Print"]
}, Open  ]],
Cell[4174084, 82670, 1743, 28, 23, "Message"],
Cell[4175830, 82700, 1863, 29, 23, "Message"],
Cell[CellGroupData[{
Cell[4177718, 82733, 2561, 55, 36, "Print"],
Cell[4180282, 82790, 1549, 24, 26, "Print"],
Cell[4181834, 82816, 1510, 23, 23, "Print"],
Cell[4183347, 82841, 1636, 26, 23, "Print"],
Cell[4184986, 82869, 1642, 26, 23, "Print"],
Cell[4186631, 82897, 1367, 19, 20, "Print"],
Cell[4188001, 82918, 1420, 20, 20, "Print"],
Cell[4189424, 82940, 1493, 23, 20, "Print"],
Cell[4190920, 82965, 1367, 19, 20, "Print"],
Cell[4192290, 82986, 1587, 24, 20, "Print"],
Cell[4193880, 83012, 2359, 48, 36, "Print"],
Cell[4196242, 83062, 1353, 19, 20, "Print"],
Cell[4197598, 83083, 2563, 55, 36, "Print"],
Cell[4200164, 83140, 2841, 61, 108, "Print"],
Cell[4203008, 83203, 1532, 24, 26, "Print"],
Cell[4204543, 83229, 1411, 20, 20, "Print"],
Cell[4205957, 83251, 1398, 19, 20, "Print"],
Cell[4207358, 83272, 1413, 20, 20, "Print"],
Cell[4208774, 83294, 2854, 59, 36, "Print"],
Cell[4211631, 83355, 1411, 20, 20, "Print"],
Cell[4213045, 83377, 1365, 19, 20, "Print"],
Cell[4214413, 83398, 1409, 20, 20, "Print"],
Cell[4215825, 83420, 2509, 53, 38, "Print"],
Cell[4218337, 83475, 1387, 19, 20, "Print"],
Cell[4219727, 83496, 1411, 20, 20, "Print"],
Cell[4221141, 83518, 1386, 19, 20, "Print"],
Cell[4222530, 83539, 1411, 20, 20, "Print"],
Cell[4223944, 83561, 1409, 20, 20, "Print"],
Cell[4225356, 83583, 1541, 24, 20, "Print"],
Cell[4226900, 83609, 2488, 51, 38, "Print"],
Cell[4229391, 83662, 1410, 20, 20, "Print"],
Cell[4230804, 83684, 1392, 19, 20, "Print"],
Cell[4232199, 83705, 1410, 20, 20, "Print"],
Cell[4233612, 83727, 2230, 44, 36, "Print"],
Cell[4235845, 83773, 1411, 20, 20, "Print"],
Cell[4237259, 83795, 1415, 20, 22, "Print"],
Cell[4238677, 83817, 1411, 20, 20, "Print"],
Cell[4240091, 83839, 2250, 44, 36, "Print"],
Cell[4242344, 83885, 1355, 19, 20, "Print"],
Cell[4243702, 83906, 1390, 20, 20, "Print"],
Cell[4245095, 83928, 1411, 20, 20, "Print"],
Cell[4246509, 83950, 1426, 20, 22, "Print"],
Cell[4247938, 83972, 1411, 20, 20, "Print"],
Cell[4249352, 83994, 2247, 44, 36, "Print"],
Cell[4251602, 84040, 1355, 19, 20, "Print"],
Cell[4252960, 84061, 1385, 20, 20, "Print"],
Cell[4254348, 84083, 1413, 20, 20, "Print"],
Cell[4255764, 84105, 1376, 19, 20, "Print"],
Cell[4257143, 84126, 1411, 20, 20, "Print"],
Cell[4258557, 84148, 1553, 24, 20, "Print"],
Cell[4260113, 84174, 1427, 20, 20, "Print"],
Cell[4261543, 84196, 2842, 63, 56, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[4264434, 84265, 331, 11, 50, "Input"],
Cell[4264768, 84278, 1013, 26, 55, "Output"]
}, Open  ]],
Cell[4265796, 84307, 255, 4, 27, "Input"],
Cell[CellGroupData[{
Cell[4266076, 84315, 2899, 66, 88, "Input"],
Cell[CellGroupData[{
Cell[4269000, 84385, 1247, 20, 20, "Print"],
Cell[4270250, 84407, 1141, 16, 20, "Print"],
Cell[4271394, 84425, 1125, 17, 20, "Print"],
Cell[4272522, 84444, 1173, 17, 20, "Print"],
Cell[4273698, 84463, 1173, 17, 20, "Print"],
Cell[4274874, 84482, 1172, 17, 20, "Print"],
Cell[4276049, 84501, 1125, 16, 20, "Print"],
Cell[4277177, 84519, 1122, 16, 20, "Print"],
Cell[4278302, 84537, 1175, 17, 20, "Print"],
Cell[4279480, 84556, 2487, 59, 38, "Print"],
Cell[4281970, 84617, 1111, 16, 20, "Print"],
Cell[4283084, 84635, 2354, 53, 42, "Print"],
Cell[4285441, 84690, 1108, 16, 20, "Print"],
Cell[4286552, 84708, 2508, 59, 42, "Print"],
Cell[4289063, 84769, 1109, 16, 20, "Print"],
Cell[4290175, 84787, 1122, 16, 20, "Print"]
}, Open  ]],
Cell[4291312, 84806, 1607, 25, 23, "Message"],
Cell[CellGroupData[{
Cell[4292944, 84835, 1288, 23, 20, "Print"],
Cell[4294235, 84860, 1111, 16, 20, "Print"],
Cell[4295349, 84878, 1173, 17, 20, "Print"],
Cell[4296525, 84897, 1111, 16, 20, "Print"],
Cell[4297639, 84915, 1282, 21, 20, "Print"],
Cell[4298924, 84938, 1305, 21, 26, "Print"],
Cell[4300232, 84961, 1226, 20, 20, "Print"],
Cell[4301461, 84983, 1176, 17, 20, "Print"],
Cell[4302640, 85002, 1247, 20, 20, "Print"],
Cell[4303890, 85024, 1414, 26, 20, "Print"],
Cell[4305307, 85052, 1414, 26, 20, "Print"],
Cell[4306724, 85080, 1434, 26, 20, "Print"],
Cell[4308161, 85108, 1109, 16, 20, "Print"],
Cell[4309273, 85126, 2774, 68, 36, "Print"],
Cell[4312050, 85196, 1109, 16, 20, "Print"],
Cell[4313162, 85214, 2295, 52, 36, "Print"],
Cell[4315460, 85268, 1305, 21, 26, "Print"],
Cell[4316768, 85291, 1266, 20, 23, "Print"],
Cell[4318037, 85313, 1345, 21, 20, "Print"],
Cell[4319385, 85336, 1389, 23, 20, "Print"],
Cell[4320777, 85361, 1176, 17, 20, "Print"],
Cell[4321956, 85380, 1247, 20, 20, "Print"],
Cell[4323206, 85402, 1414, 26, 20, "Print"],
Cell[4324623, 85430, 1414, 26, 20, "Print"],
Cell[4326040, 85458, 1430, 26, 20, "Print"],
Cell[4327473, 85486, 1111, 16, 20, "Print"],
Cell[4328587, 85504, 2808, 68, 36, "Print"],
Cell[4331398, 85574, 1109, 16, 20, "Print"],
Cell[4332510, 85592, 2315, 52, 36, "Print"],
Cell[4334828, 85646, 1305, 21, 26, "Print"],
Cell[4336136, 85669, 1274, 21, 23, "Print"],
Cell[4337413, 85692, 1381, 22, 20, "Print"],
Cell[4338797, 85716, 1386, 22, 20, "Print"],
Cell[4340186, 85740, 1176, 17, 20, "Print"],
Cell[4341365, 85759, 1247, 20, 20, "Print"],
Cell[4342615, 85781, 1412, 26, 20, "Print"],
Cell[4344030, 85809, 1412, 26, 20, "Print"],
Cell[4345445, 85837, 1432, 26, 20, "Print"],
Cell[4346880, 85865, 1107, 16, 20, "Print"],
Cell[4347990, 85883, 2819, 68, 36, "Print"],
Cell[4350812, 85953, 1107, 16, 20, "Print"],
Cell[4351922, 85971, 2314, 52, 36, "Print"],
Cell[4354239, 86025, 1302, 21, 26, "Print"],
Cell[4355544, 86048, 1270, 21, 23, "Print"],
Cell[4356817, 86071, 1376, 22, 20, "Print"],
Cell[4358196, 86095, 1386, 22, 20, "Print"],
Cell[4359585, 86119, 1174, 17, 20, "Print"],
Cell[4360762, 86138, 1245, 20, 20, "Print"],
Cell[4362010, 86160, 1412, 26, 20, "Print"],
Cell[4363425, 86188, 1412, 26, 20, "Print"],
Cell[4364840, 86216, 1430, 26, 20, "Print"],
Cell[4366273, 86244, 1106, 16, 20, "Print"],
Cell[4367382, 86262, 2817, 68, 36, "Print"],
Cell[4370202, 86332, 1109, 16, 20, "Print"],
Cell[4371314, 86350, 2311, 52, 36, "Print"],
Cell[4373628, 86404, 1300, 21, 26, "Print"],
Cell[4374931, 86427, 1264, 20, 23, "Print"],
Cell[4376198, 86449, 1369, 22, 20, "Print"],
Cell[4377570, 86473, 1392, 23, 20, "Print"],
Cell[4378965, 86498, 1174, 17, 20, "Print"],
Cell[4380142, 86517, 1245, 20, 20, "Print"],
Cell[4381390, 86539, 1412, 26, 20, "Print"],
Cell[4382805, 86567, 1412, 26, 20, "Print"],
Cell[4384220, 86595, 1438, 26, 20, "Print"],
Cell[4385661, 86623, 1107, 16, 20, "Print"],
Cell[4386771, 86641, 2822, 68, 36, "Print"],
Cell[4389596, 86711, 1107, 16, 20, "Print"],
Cell[4390706, 86729, 2311, 52, 36, "Print"],
Cell[4393020, 86783, 1302, 21, 26, "Print"],
Cell[4394325, 86806, 1264, 20, 23, "Print"],
Cell[4395592, 86828, 1369, 22, 20, "Print"],
Cell[4396964, 86852, 1396, 23, 20, "Print"],
Cell[4398363, 86877, 1174, 17, 20, "Print"],
Cell[4399540, 86896, 1245, 20, 20, "Print"],
Cell[4400788, 86918, 1412, 26, 20, "Print"],
Cell[4402203, 86946, 1412, 26, 20, "Print"],
Cell[4403618, 86974, 1507, 28, 23, "Print"],
Cell[4405128, 87004, 1106, 16, 20, "Print"],
Cell[4406237, 87022, 2827, 68, 36, "Print"],
Cell[4409067, 87092, 1107, 16, 20, "Print"],
Cell[4410177, 87110, 2312, 52, 36, "Print"],
Cell[4412492, 87164, 1302, 21, 26, "Print"],
Cell[4413797, 87187, 1271, 20, 23, "Print"],
Cell[4415071, 87209, 1369, 22, 20, "Print"],
Cell[4416443, 87233, 1392, 23, 23, "Print"],
Cell[4417838, 87258, 1120, 16, 20, "Print"],
Cell[4418961, 87276, 1174, 17, 20, "Print"],
Cell[4420138, 87295, 1244, 20, 20, "Print"],
Cell[4421385, 87317, 1410, 26, 20, "Print"],
Cell[4422798, 87345, 1414, 26, 20, "Print"],
Cell[4424215, 87373, 1510, 28, 23, "Print"],
Cell[4425728, 87403, 1109, 16, 20, "Print"],
Cell[4426840, 87421, 2805, 68, 36, "Print"],
Cell[4429648, 87491, 1107, 16, 20, "Print"],
Cell[4430758, 87509, 2312, 52, 36, "Print"],
Cell[4433073, 87563, 1303, 21, 26, "Print"],
Cell[4434379, 87586, 1269, 21, 23, "Print"],
Cell[4435651, 87609, 1384, 22, 23, "Print"],
Cell[4437038, 87633, 1393, 23, 23, "Print"],
Cell[4438434, 87658, 1123, 16, 20, "Print"],
Cell[4439560, 87676, 1121, 16, 20, "Print"],
Cell[4440684, 87694, 1121, 16, 20, "Print"],
Cell[4441808, 87712, 1339, 21, 20, "Print"],
Cell[4443150, 87735, 2094, 44, 36, "Print"],
Cell[4445247, 87781, 1107, 16, 20, "Print"],
Cell[4446357, 87799, 2314, 52, 36, "Print"],
Cell[4448674, 87853, 2746, 62, 136, "Print"],
Cell[4451423, 87917, 1287, 21, 20, "Print"],
Cell[4452713, 87940, 1165, 17, 20, "Print"],
Cell[4453881, 87959, 1152, 16, 20, "Print"],
Cell[4455036, 87977, 1165, 17, 20, "Print"],
Cell[4456204, 87996, 2584, 55, 36, "Print"],
Cell[4458791, 88053, 1163, 17, 20, "Print"],
Cell[4459957, 88072, 1117, 16, 20, "Print"],
Cell[4461077, 88090, 1163, 17, 20, "Print"],
Cell[4462243, 88109, 2266, 50, 38, "Print"],
Cell[4464512, 88161, 1139, 16, 20, "Print"],
Cell[4465654, 88179, 1165, 17, 20, "Print"],
Cell[4466822, 88198, 1138, 16, 20, "Print"],
Cell[4467963, 88216, 1163, 17, 20, "Print"],
Cell[4469129, 88235, 1163, 17, 20, "Print"],
Cell[4470295, 88254, 1299, 21, 20, "Print"],
Cell[4471597, 88277, 2231, 47, 38, "Print"],
Cell[4473831, 88326, 1164, 17, 20, "Print"],
Cell[4474998, 88345, 1146, 16, 20, "Print"],
Cell[4476147, 88363, 1166, 17, 20, "Print"],
Cell[4477316, 88382, 2000, 41, 36, "Print"],
Cell[4479319, 88425, 1167, 17, 20, "Print"],
Cell[4480489, 88444, 1171, 17, 22, "Print"],
Cell[4481663, 88463, 1165, 17, 20, "Print"],
Cell[4482831, 88482, 2004, 41, 36, "Print"],
Cell[4484838, 88525, 1107, 16, 20, "Print"],
Cell[4485948, 88543, 1142, 17, 20, "Print"],
Cell[4487093, 88562, 1165, 17, 20, "Print"],
Cell[4488261, 88581, 1179, 17, 22, "Print"],
Cell[4489443, 88600, 1167, 17, 20, "Print"],
Cell[4490613, 88619, 2001, 41, 36, "Print"],
Cell[4492617, 88662, 1109, 16, 20, "Print"],
Cell[4493729, 88680, 1139, 17, 20, "Print"],
Cell[4494871, 88699, 1165, 17, 20, "Print"],
Cell[4496039, 88718, 1130, 16, 20, "Print"],
Cell[4497172, 88736, 1167, 17, 20, "Print"],
Cell[4498342, 88755, 1309, 21, 20, "Print"],
Cell[4499654, 88778, 1181, 17, 20, "Print"],
Cell[4500838, 88797, 2592, 60, 56, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[4503479, 88863, 331, 11, 50, "Input"],
Cell[4503813, 88876, 1087, 28, 55, "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[4504961, 88911, 157, 3, 26, "Subsection"],
Cell[CellGroupData[{
Cell[4505143, 88918, 120, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[4505288, 88924, 196, 4, 42, "Print",
 CellTags->"Info3461062927-3135492"],
Cell[4505487, 88930, 1290, 36, 64, "Print",
 CellTags->"Info3461062927-3135492"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4506826, 88972, 684, 17, 43, "Input"],
Cell[4507513, 88991, 452, 10, 46, "Output"],
Cell[4507968, 89003, 3262, 60, 242, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4511267, 89068, 799, 25, 27, "Input"],
Cell[4512069, 89095, 2057, 62, 46, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4514163, 89162, 633, 15, 27, "Input"],
Cell[4514799, 89179, 1523, 30, 238, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4516359, 89214, 94, 1, 27, "Input"],
Cell[4516456, 89217, 188, 3, 27, "Output"]
}, Open  ]],
Cell[4516659, 89223, 2436, 60, 238, "Input"],
Cell[4519098, 89285, 7488, 165, 433, "Input"],
Cell[CellGroupData[{
Cell[4526611, 89454, 96, 1, 27, "Input"],
Cell[4526710, 89457, 776, 20, 33, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4527523, 89482, 1855, 45, 148, "Input"],
Cell[4529381, 89529, 3319, 60, 69, "Output"],
Cell[4532703, 89591, 3302, 60, 69, "Output"],
Cell[4536008, 89653, 3319, 60, 69, "Output"],
Cell[4539330, 89715, 3317, 60, 69, "Output"],
Cell[4542650, 89777, 3404, 55, 238, "Output"],
Cell[4546057, 89834, 3603, 74, 47, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4549709, 89914, 114, 3, 34, "Subsection"],
Cell[CellGroupData[{
Cell[4549848, 89921, 1425, 31, 73, "Input"],
Cell[4551276, 89954, 2387, 36, 47, "Output"]
}, Open  ]],
Cell[4553678, 89993, 1322, 34, 58, "Input"],
Cell[CellGroupData[{
Cell[4555025, 90031, 248, 3, 73, "Input"],
Cell[4555276, 90036, 2151, 35, 27, "Output"],
Cell[4557430, 90073, 2098, 33, 27, "Output"],
Cell[4559531, 90108, 2152, 35, 27, "Output"],
Cell[4561686, 90145, 2015, 29, 27, "Output"]
}, Open  ]],
Cell[4563716, 90177, 122, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[4563863, 90183, 95, 1, 27, "Input"],
Cell[4563961, 90186, 670, 16, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4564668, 90207, 826, 14, 27, "Input"],
Cell[4565497, 90223, 3494, 56, 98, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4569028, 90284, 338, 9, 27, "Input"],
Cell[4569369, 90295, 2616, 50, 69, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4572022, 90350, 468, 10, 27, "Input"],
Cell[4572493, 90362, 2561, 43, 87, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4575091, 90410, 190, 4, 27, "Input"],
Cell[4575284, 90416, 315, 8, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4575636, 90429, 136, 4, 27, "Input"],
Cell[4575775, 90435, 1915, 29, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4577727, 90469, 83, 2, 27, "Input"],
Cell[4577813, 90473, 422, 7, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4578272, 90485, 174, 2, 43, "Input"],
Cell[4578449, 90489, 7834, 187, 118, "Output"],
Cell[4586286, 90678, 7574, 174, 118, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4593897, 90857, 145, 3, 27, "Input"],
Cell[4594045, 90862, 3529, 120, 58, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4597611, 90987, 1250, 31, 73, "Input"],
Cell[4598864, 91020, 12013, 253, 243, "Output"],
Cell[4610880, 91275, 9581, 154, 238, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4620510, 91435, 100, 2, 35, "Subsection"],
Cell[CellGroupData[{
Cell[4620635, 91441, 119, 1, 24, "Subsubsection"],
Cell[CellGroupData[{
Cell[4620779, 91446, 125, 2, 27, "Input"],
Cell[4620907, 91450, 187, 4, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4621131, 91459, 531, 8, 43, "Input"],
Cell[4621665, 91469, 348, 6, 27, "Output"],
Cell[4622016, 91477, 348, 6, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4622401, 91488, 1109, 31, 43, "Input"],
Cell[4623513, 91521, 1564, 30, 238, "Output"]
}, Open  ]],
Cell[4625092, 91554, 6397, 139, 118, "Input"],
Cell[CellGroupData[{
Cell[4631514, 91697, 3417, 54, 27, "Input"],
Cell[4634934, 91753, 17450, 298, 243, 3407, 66, "CachedBoxData", "BoxData", \
"Output"]
}, Open  ]],
Cell[4652399, 92054, 6424, 140, 118, "Input"],
Cell[CellGroupData[{
Cell[4658848, 92198, 3218, 51, 43, "Input"],
Cell[4662069, 92251, 6035, 103, 248, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4668141, 92359, 1484, 31, 27, "Input"],
Cell[4669628, 92392, 835, 12, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4670500, 92409, 7083, 156, 148, "Input"],
Cell[4677586, 92567, 17223, 293, 235, 3028, 59, "CachedBoxData", "BoxData", \
"Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4694858, 92866, 27, 0, 24, "Subsubsection"],
Cell[CellGroupData[{
Cell[4694910, 92870, 455, 6, 43, "Input"],
Cell[4695368, 92878, 696, 10, 27, "Output"],
Cell[4696067, 92890, 3940, 125, 58, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4700044, 93020, 11109, 186, 103, "Input"],
Cell[4711156, 93208, 5302, 75, 27, "Output"],
Cell[CellGroupData[{
Cell[4716483, 93287, 928, 18, 23, "Print"],
Cell[4717414, 93307, 296827, 5113, 129, 275192, 4756, "CachedBoxData", \
"BoxData", "Print"]
}, Open  ]],
Cell[5014256, 98423, 5249, 72, 27, "Output"],
Cell[5019508, 98497, 168013, 3001, 129, 151399, 2727, "CachedBoxData", \
"BoxData", "Print"],
Cell[5187524, 101500, 5249, 72, 27, "Output"],
Cell[5192776, 101574, 5268, 73, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5198081, 101652, 7110, 111, 43, "Input"],
Cell[5205194, 101765, 781, 12, 27, "Output"],
Cell[5205978, 101779, 781, 12, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5206796, 101796, 96, 1, 27, "Input"],
Cell[5206895, 101799, 142, 4, 47, "Output"]
}, Open  ]],
Cell[5207052, 101806, 177, 3, 26, "Text"],
Cell[5207232, 101811, 398, 13, 27, "Input"],
Cell[5207633, 101826, 3577, 82, 179, "Code"],
Cell[CellGroupData[{
Cell[5211235, 101912, 115, 2, 27, "Input"],
Cell[5211353, 101916, 91, 1, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5211481, 101922, 824, 23, 27, "Input"],
Cell[5212308, 101947, 1907, 38, 256, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5214252, 101990, 823, 23, 27, "Input"],
Cell[5215078, 102015, 4107, 78, 256, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5219222, 102098, 1113, 26, 27, "Input"],
Cell[5220338, 102126, 4213, 80, 256, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5224588, 102211, 1193, 29, 27, "Input"],
Cell[5225784, 102242, 4246, 80, 256, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5230067, 102327, 1250, 29, 27, "Input"],
Cell[5231320, 102358, 4061, 78, 256, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5235418, 102441, 293, 4, 27, "Input"],
Cell[5235714, 102447, 313, 7, 47, "Output"]
}, Open  ]],
Cell[5236042, 102457, 5200, 122, 133, "Input"],
Cell[CellGroupData[{
Cell[5241267, 102583, 1365, 21, 73, "Input"],
Cell[5242635, 102606, 276, 5, 27, "Output"],
Cell[5242914, 102613, 276, 5, 27, "Output"],
Cell[5243193, 102620, 278, 5, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5243508, 102630, 3326, 71, 73, "Input"],
Cell[5246837, 102703, 3852, 76, 260, "Output"]
}, Open  ]],
Cell[5250704, 102782, 3318, 70, 73, "Input"],
Cell[CellGroupData[{
Cell[5254047, 102856, 2580, 48, 58, "Input"],
Cell[CellGroupData[{
Cell[5256652, 102908, 695, 14, 20, "Print"],
Cell[5257350, 102924, 695, 14, 20, "Print"],
Cell[5258048, 102940, 699, 14, 20, "Print"],
Cell[5258750, 102956, 697, 14, 20, "Print"],
Cell[5259450, 102972, 701, 14, 20, "Print"],
Cell[5260154, 102988, 701, 14, 20, "Print"],
Cell[5260858, 103004, 703, 14, 20, "Print"],
Cell[5261564, 103020, 703, 14, 20, "Print"],
Cell[5262270, 103036, 701, 14, 23, "Print"],
Cell[5262974, 103052, 703, 14, 23, "Print"],
Cell[5263680, 103068, 701, 14, 23, "Print"],
Cell[5264384, 103084, 703, 14, 23, "Print"],
Cell[5265090, 103100, 701, 14, 23, "Print"],
Cell[5265794, 103116, 703, 14, 23, "Print"],
Cell[5266500, 103132, 701, 14, 23, "Print"],
Cell[5267204, 103148, 701, 14, 23, "Print"],
Cell[5267908, 103164, 703, 14, 23, "Print"],
Cell[5268614, 103180, 703, 14, 23, "Print"],
Cell[5269320, 103196, 703, 14, 23, "Print"],
Cell[5270026, 103212, 703, 14, 23, "Print"],
Cell[5270732, 103228, 705, 14, 23, "Print"],
Cell[5271440, 103244, 703, 14, 23, "Print"],
Cell[5272146, 103260, 703, 14, 23, "Print"],
Cell[5272852, 103276, 703, 14, 23, "Print"],
Cell[5273558, 103292, 703, 14, 23, "Print"],
Cell[5274264, 103308, 705, 14, 23, "Print"],
Cell[5274972, 103324, 703, 14, 23, "Print"],
Cell[5275678, 103340, 703, 14, 23, "Print"],
Cell[5276384, 103356, 703, 14, 23, "Print"],
Cell[5277090, 103372, 703, 14, 23, "Print"]
}, Closed]],
Cell[5277808, 103389, 1623, 32, 236, "Output"]
}, Open  ]],
Cell[5279446, 103424, 106, 2, 26, "Text"],
Cell[CellGroupData[{
Cell[5279577, 103430, 1967, 32, 133, "Input"],
Cell[5281547, 103464, 1414, 21, 27, "Output"],
Cell[5282964, 103487, 1434, 22, 27, "Output"],
Cell[5284401, 103511, 1388, 20, 27, "Output"],
Cell[5285792, 103533, 1392, 20, 27, "Output"],
Cell[5287187, 103555, 1389, 20, 27, "Output"],
Cell[5288579, 103577, 1389, 20, 27, "Output"],
Cell[5289971, 103599, 1389, 20, 27, "Output"],
Cell[5291363, 103621, 1389, 20, 27, "Output"]
}, Open  ]],
Cell[5292767, 103644, 230, 4, 27, "Input"],
Cell[5293000, 103650, 611, 15, 43, "Input"],
Cell[CellGroupData[{
Cell[5293636, 103669, 3523, 74, 88, "Input"],
Cell[CellGroupData[{
Cell[5297184, 103747, 2378, 36, 20, "Print"],
Cell[5299565, 103785, 2274, 32, 20, "Print"],
Cell[5301842, 103819, 2256, 33, 20, "Print"],
Cell[5304101, 103854, 2306, 33, 20, "Print"],
Cell[5306410, 103889, 2304, 33, 20, "Print"],
Cell[5308717, 103924, 2304, 33, 20, "Print"],
Cell[5311024, 103959, 2256, 32, 20, "Print"],
Cell[5313283, 103993, 2250, 32, 20, "Print"],
Cell[5315536, 104027, 2306, 33, 20, "Print"],
Cell[5317845, 104062, 3620, 75, 38, "Print"],
Cell[5321468, 104139, 2240, 32, 20, "Print"],
Cell[5323711, 104173, 3483, 69, 42, "Print"],
Cell[5327197, 104244, 2240, 32, 20, "Print"],
Cell[5329440, 104278, 3638, 75, 42, "Print"],
Cell[5333081, 104355, 2242, 32, 20, "Print"],
Cell[5335326, 104389, 2250, 32, 20, "Print"]
}, Open  ]],
Cell[5337591, 104424, 2718, 41, 23, "Message"],
Cell[CellGroupData[{
Cell[5340334, 104469, 2419, 39, 20, "Print"],
Cell[5342756, 104510, 2240, 32, 20, "Print"],
Cell[5344999, 104544, 2304, 33, 20, "Print"],
Cell[5347306, 104579, 2240, 32, 20, "Print"],
Cell[5349549, 104613, 2411, 37, 20, "Print"],
Cell[5351963, 104652, 2401, 37, 20, "Print"],
Cell[5354367, 104691, 2375, 37, 20, "Print"],
Cell[5356745, 104730, 2309, 33, 20, "Print"],
Cell[5359057, 104765, 2378, 36, 20, "Print"],
Cell[5361438, 104803, 2551, 42, 20, "Print"],
Cell[5363992, 104847, 2547, 42, 20, "Print"],
Cell[5366542, 104891, 2561, 42, 20, "Print"],
Cell[5369106, 104935, 2240, 32, 20, "Print"],
Cell[5371349, 104969, 3904, 84, 36, "Print"],
Cell[5375256, 105055, 2242, 32, 20, "Print"],
Cell[5377501, 105089, 3424, 68, 36, "Print"],
Cell[5380928, 105159, 2430, 37, 20, "Print"],
Cell[5383361, 105198, 2392, 36, 20, "Print"],
Cell[5385756, 105236, 2518, 38, 20, "Print"],
Cell[5388277, 105276, 2309, 33, 20, "Print"],
Cell[5390589, 105311, 2378, 36, 20, "Print"],
Cell[5392970, 105349, 2545, 42, 20, "Print"],
Cell[5395518, 105393, 2553, 42, 20, "Print"],
Cell[5398074, 105437, 2561, 42, 20, "Print"],
Cell[5400638, 105481, 2242, 32, 20, "Print"],
Cell[5402883, 105515, 3905, 84, 36, "Print"],
Cell[5406791, 105601, 2240, 32, 20, "Print"],
Cell[5409034, 105635, 3424, 68, 36, "Print"],
Cell[5412461, 105705, 2399, 37, 20, "Print"],
Cell[5414863, 105744, 2394, 36, 20, "Print"],
Cell[5417260, 105782, 2472, 37, 20, "Print"],
Cell[5419735, 105821, 2517, 38, 20, "Print"],
Cell[5422255, 105861, 2307, 33, 20, "Print"],
Cell[5424565, 105896, 2378, 36, 20, "Print"],
Cell[5426946, 105934, 2928, 50, 20, "Print"],
Cell[5429877, 105986, 2932, 50, 20, "Print"],
Cell[5432812, 106038, 2547, 42, 20, "Print"],
Cell[5435362, 106082, 2543, 42, 20, "Print"],
Cell[5437908, 106126, 2561, 42, 20, "Print"],
Cell[5440472, 106170, 2242, 32, 20, "Print"],
Cell[5442717, 106204, 3939, 84, 36, "Print"],
Cell[5446659, 106290, 2240, 32, 20, "Print"],
Cell[5448902, 106324, 3449, 68, 36, "Print"],
Cell[5452354, 106394, 2397, 37, 20, "Print"],
Cell[5454754, 106433, 2391, 36, 20, "Print"],
Cell[5457148, 106471, 2518, 38, 20, "Print"],
Cell[5459669, 106511, 2307, 33, 20, "Print"],
Cell[5461979, 106546, 2378, 36, 20, "Print"],
Cell[5464360, 106584, 2932, 50, 20, "Print"],
Cell[5467295, 106636, 2930, 50, 20, "Print"],
Cell[5470228, 106688, 2930, 50, 20, "Print"],
Cell[5473161, 106740, 2930, 50, 20, "Print"],
Cell[5476094, 106792, 2934, 50, 20, "Print"],
Cell[5479031, 106844, 2929, 50, 20, "Print"],
Cell[5481963, 106896, 2934, 50, 20, "Print"],
Cell[5484900, 106948, 2936, 50, 20, "Print"],
Cell[5487839, 107000, 2930, 50, 20, "Print"],
Cell[5490772, 107052, 2936, 50, 20, "Print"],
Cell[5493711, 107104, 2935, 50, 20, "Print"],
Cell[5496649, 107156, 2938, 50, 20, "Print"],
Cell[5499590, 107208, 2932, 50, 20, "Print"],
Cell[5502525, 107260, 2938, 50, 20, "Print"],
Cell[5505466, 107312, 2936, 50, 20, "Print"],
Cell[5508405, 107364, 2936, 50, 20, "Print"],
Cell[5511344, 107416, 2936, 50, 20, "Print"],
Cell[5514283, 107468, 2936, 50, 20, "Print"],
Cell[5517222, 107520, 2936, 50, 20, "Print"],
Cell[5520161, 107572, 2938, 50, 20, "Print"],
Cell[5523102, 107624, 2938, 50, 20, "Print"],
Cell[5526043, 107676, 2935, 50, 20, "Print"],
Cell[5528981, 107728, 2938, 50, 20, "Print"],
Cell[5531922, 107780, 2938, 50, 20, "Print"],
Cell[5534863, 107832, 2938, 50, 20, "Print"],
Cell[5537804, 107884, 2936, 50, 20, "Print"],
Cell[5540743, 107936, 2938, 50, 20, "Print"],
Cell[5543684, 107988, 2935, 50, 20, "Print"],
Cell[5546622, 108040, 2935, 50, 20, "Print"],
Cell[5549560, 108092, 2936, 50, 20, "Print"],
Cell[5552499, 108144, 2932, 50, 20, "Print"],
Cell[5555434, 108196, 2938, 50, 20, "Print"],
Cell[5558375, 108248, 2936, 50, 20, "Print"],
Cell[5561314, 108300, 2254, 32, 20, "Print"],
Cell[5563571, 108334, 2474, 37, 20, "Print"],
Cell[5566048, 108373, 3245, 61, 36, "Print"],
Cell[5569296, 108436, 2239, 32, 20, "Print"],
Cell[5571538, 108470, 3447, 68, 36, "Print"],
Cell[5574988, 108540, 3558, 69, 94, "Print"],
Cell[5578549, 108611, 2413, 37, 20, "Print"],
Cell[5580965, 108650, 2298, 33, 20, "Print"],
Cell[5583266, 108685, 2287, 32, 20, "Print"],
Cell[5585556, 108719, 2297, 33, 20, "Print"],
Cell[5587856, 108754, 3726, 72, 36, "Print"],
Cell[5591585, 108828, 2296, 33, 20, "Print"],
Cell[5593884, 108863, 2252, 32, 20, "Print"],
Cell[5596139, 108897, 2298, 33, 20, "Print"],
Cell[5598440, 108932, 3419, 66, 38, "Print"],
Cell[5601862, 109000, 2272, 32, 20, "Print"],
Cell[5604137, 109034, 2296, 33, 20, "Print"],
Cell[5606436, 109069, 2271, 32, 20, "Print"],
Cell[5608710, 109103, 2296, 33, 20, "Print"],
Cell[5611009, 109138, 2296, 33, 20, "Print"],
Cell[5613308, 109173, 2430, 37, 20, "Print"],
Cell[5615741, 109212, 3375, 64, 38, "Print"],
Cell[5619119, 109278, 2297, 33, 20, "Print"],
Cell[5621419, 109313, 2279, 32, 20, "Print"],
Cell[5623701, 109347, 2299, 33, 20, "Print"],
Cell[5626003, 109382, 3119, 57, 36, "Print"],
Cell[5629125, 109441, 2298, 33, 20, "Print"],
Cell[5631426, 109476, 2302, 33, 22, "Print"],
Cell[5633731, 109511, 2298, 33, 20, "Print"],
Cell[5636032, 109546, 3135, 57, 36, "Print"],
Cell[5639170, 109605, 2240, 32, 20, "Print"],
Cell[5641413, 109639, 2275, 33, 20, "Print"],
Cell[5643691, 109674, 2298, 33, 20, "Print"],
Cell[5645992, 109709, 2313, 33, 22, "Print"],
Cell[5648308, 109744, 2298, 33, 20, "Print"],
Cell[5650609, 109779, 3135, 57, 36, "Print"],
Cell[5653747, 109838, 2240, 32, 20, "Print"],
Cell[5655990, 109872, 2273, 33, 20, "Print"],
Cell[5658266, 109907, 2298, 33, 20, "Print"],
Cell[5660567, 109942, 2265, 32, 20, "Print"],
Cell[5662835, 109976, 2298, 33, 20, "Print"],
Cell[5665136, 110011, 2440, 37, 20, "Print"],
Cell[5667579, 110050, 2316, 33, 20, "Print"],
Cell[5669898, 110085, 3648, 73, 56, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[5673595, 110164, 178, 2, 37, "Input"],
Cell[5673776, 110168, 475, 10, 27, "Output"],
Cell[5674254, 110180, 441, 8, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5674732, 110193, 397, 12, 56, "Input"],
Cell[5675132, 110207, 1779, 37, 55, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5676948, 110249, 2831, 69, 103, "Input"],
Cell[CellGroupData[{
Cell[5679804, 110322, 357, 7, 20, "Print"],
Cell[5680164, 110331, 254, 6, 20, "Print"],
Cell[5680421, 110339, 275, 7, 20, "Print"],
Cell[5680699, 110348, 362, 7, 20, "Print"],
Cell[5681064, 110357, 253, 6, 20, "Print"],
Cell[5681320, 110365, 279, 6, 20, "Print"],
Cell[5681602, 110373, 305, 6, 20, "Print"],
Cell[5681910, 110381, 359, 7, 20, "Print"],
Cell[5682272, 110390, 256, 6, 20, "Print"],
Cell[5682531, 110398, 275, 7, 20, "Print"],
Cell[5682809, 110407, 341, 7, 20, "Print"],
Cell[5683153, 110416, 254, 6, 20, "Print"],
Cell[5683410, 110424, 281, 6, 20, "Print"],
Cell[5683694, 110432, 311, 6, 20, "Print"],
Cell[5684008, 110440, 341, 7, 20, "Print"],
Cell[5684352, 110449, 256, 6, 20, "Print"],
Cell[5684611, 110457, 275, 7, 20, "Print"],
Cell[5684889, 110466, 341, 7, 20, "Print"],
Cell[5685233, 110475, 254, 6, 20, "Print"],
Cell[5685490, 110483, 275, 6, 20, "Print"],
Cell[5685768, 110491, 301, 6, 20, "Print"],
Cell[5686072, 110499, 344, 7, 20, "Print"],
Cell[5686419, 110508, 256, 6, 20, "Print"],
Cell[5686678, 110516, 275, 7, 20, "Print"],
Cell[5686956, 110525, 344, 7, 20, "Print"],
Cell[5687303, 110534, 254, 6, 20, "Print"],
Cell[5687560, 110542, 279, 6, 20, "Print"],
Cell[5687842, 110550, 307, 6, 20, "Print"],
Cell[5688152, 110558, 344, 7, 20, "Print"],
Cell[5688499, 110567, 256, 6, 20, "Print"],
Cell[5688758, 110575, 275, 7, 20, "Print"],
Cell[5689036, 110584, 346, 7, 20, "Print"],
Cell[5689385, 110593, 254, 6, 20, "Print"],
Cell[5689642, 110601, 287, 6, 20, "Print"],
Cell[5689932, 110609, 313, 6, 20, "Print"],
Cell[5690248, 110617, 346, 7, 20, "Print"],
Cell[5690597, 110626, 256, 6, 20, "Print"],
Cell[5690856, 110634, 275, 7, 20, "Print"],
Cell[5691134, 110643, 346, 7, 20, "Print"],
Cell[5691483, 110652, 254, 6, 20, "Print"],
Cell[5691740, 110660, 277, 7, 20, "Print"],
Cell[5692020, 110669, 269, 6, 20, "Print"],
Cell[5692292, 110677, 112, 1, 20, "Print"],
Cell[5692407, 110680, 255, 6, 20, "Print"],
Cell[5692665, 110688, 273, 6, 20, "Print"],
Cell[5692941, 110696, 156, 2, 20, "Print"],
Cell[5693100, 110700, 143, 1, 20, "Print"],
Cell[5693246, 110703, 156, 2, 20, "Print"],
Cell[5693405, 110707, 1569, 41, 36, "Print"],
Cell[5694977, 110750, 154, 2, 20, "Print"],
Cell[5695134, 110754, 108, 1, 20, "Print"],
Cell[5695245, 110757, 154, 2, 20, "Print"],
Cell[5695402, 110761, 1276, 35, 42, "Print"],
Cell[5696681, 110798, 130, 1, 20, "Print"],
Cell[5696814, 110801, 154, 2, 20, "Print"],
Cell[5696971, 110805, 129, 1, 20, "Print"],
Cell[5697103, 110808, 154, 2, 20, "Print"],
Cell[5697260, 110812, 154, 2, 20, "Print"],
Cell[5697417, 110816, 288, 6, 20, "Print"],
Cell[5697708, 110824, 1220, 32, 38, "Print"],
Cell[5698931, 110858, 154, 2, 20, "Print"],
Cell[5699088, 110862, 139, 1, 20, "Print"],
Cell[5699230, 110865, 155, 2, 20, "Print"],
Cell[5699388, 110869, 990, 26, 36, "Print"],
Cell[5700381, 110897, 156, 2, 20, "Print"],
Cell[5700540, 110901, 160, 2, 22, "Print"],
Cell[5700703, 110905, 156, 2, 20, "Print"],
Cell[5700862, 110909, 995, 26, 36, "Print"],
Cell[5701860, 110937, 100, 1, 20, "Print"],
Cell[5701963, 110940, 133, 2, 20, "Print"],
Cell[5702099, 110944, 156, 2, 20, "Print"],
Cell[5702258, 110948, 171, 2, 22, "Print"],
Cell[5702432, 110952, 156, 2, 20, "Print"],
Cell[5702591, 110956, 989, 26, 36, "Print"],
Cell[5703583, 110984, 98, 1, 20, "Print"],
Cell[5703684, 110987, 132, 2, 20, "Print"],
Cell[5703819, 110991, 158, 2, 20, "Print"],
Cell[5703980, 110995, 123, 1, 20, "Print"],
Cell[5704106, 110998, 156, 2, 20, "Print"],
Cell[5704265, 111002, 324, 7, 20, "Print"],
Cell[5704592, 111011, 172, 2, 20, "Print"],
Cell[5704767, 111015, 2907, 72, 56, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[5707723, 111093, 277, 9, 50, "Input"],
Cell[5708003, 111104, 1155, 29, 55, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5709195, 111138, 2757, 68, 103, "Input"],
Cell[CellGroupData[{
Cell[5711977, 111210, 960, 16, 20, "Print"],
Cell[5712940, 111228, 852, 15, 20, "Print"],
Cell[5713795, 111245, 875, 16, 20, "Print"],
Cell[5714673, 111263, 955, 16, 20, "Print"],
Cell[5715631, 111281, 852, 15, 20, "Print"],
Cell[5716486, 111298, 872, 16, 20, "Print"],
Cell[5717361, 111316, 886, 16, 20, "Print"],
Cell[5718250, 111334, 916, 16, 20, "Print"],
Cell[5719169, 111352, 955, 16, 20, "Print"],
Cell[5720127, 111370, 852, 15, 20, "Print"],
Cell[5720982, 111387, 957, 16, 20, "Print"],
Cell[5721942, 111405, 852, 15, 20, "Print"],
Cell[5722797, 111422, 885, 15, 20, "Print"],
Cell[5723685, 111439, 913, 15, 20, "Print"],
Cell[5724601, 111456, 957, 16, 20, "Print"],
Cell[5725561, 111474, 852, 15, 20, "Print"],
Cell[5726416, 111491, 873, 16, 20, "Print"],
Cell[5727292, 111509, 955, 16, 20, "Print"],
Cell[5728250, 111527, 854, 15, 20, "Print"],
Cell[5729107, 111544, 871, 16, 20, "Print"],
Cell[5729981, 111562, 867, 15, 20, "Print"],
Cell[5730851, 111579, 709, 10, 20, "Print"],
Cell[5731563, 111591, 853, 15, 20, "Print"],
Cell[5732419, 111608, 869, 15, 20, "Print"],
Cell[5733291, 111625, 754, 11, 20, "Print"],
Cell[5734048, 111638, 743, 10, 20, "Print"],
Cell[5734794, 111650, 754, 11, 20, "Print"],
Cell[5735551, 111663, 2186, 50, 40, "Print"],
Cell[5737740, 111715, 752, 11, 20, "Print"],
Cell[5738495, 111728, 708, 10, 20, "Print"],
Cell[5739206, 111740, 754, 11, 20, "Print"],
Cell[5739963, 111753, 1873, 44, 38, "Print"],
Cell[5741839, 111799, 728, 10, 20, "Print"],
Cell[5742570, 111811, 752, 11, 20, "Print"],
Cell[5743325, 111824, 727, 10, 20, "Print"],
Cell[5744055, 111836, 751, 11, 20, "Print"],
Cell[5744809, 111849, 752, 11, 20, "Print"],
Cell[5745564, 111862, 886, 15, 20, "Print"],
Cell[5746453, 111879, 1818, 41, 38, "Print"],
Cell[5748274, 111922, 753, 11, 20, "Print"],
Cell[5749030, 111935, 735, 10, 20, "Print"],
Cell[5749768, 111947, 753, 11, 20, "Print"],
Cell[5750524, 111960, 1573, 35, 36, "Print"],
Cell[5752100, 111997, 754, 11, 20, "Print"],
Cell[5752857, 112010, 758, 11, 22, "Print"],
Cell[5753618, 112023, 756, 11, 20, "Print"],
Cell[5754377, 112036, 1591, 35, 36, "Print"],
Cell[5755971, 112073, 696, 10, 20, "Print"],
Cell[5756670, 112085, 731, 11, 20, "Print"],
Cell[5757404, 112098, 756, 11, 20, "Print"],
Cell[5758163, 112111, 769, 11, 22, "Print"],
Cell[5758935, 112124, 754, 11, 20, "Print"],
Cell[5759692, 112137, 1589, 35, 36, "Print"],
Cell[5761284, 112174, 696, 10, 20, "Print"],
Cell[5761983, 112186, 729, 11, 20, "Print"],
Cell[5762715, 112199, 756, 11, 20, "Print"],
Cell[5763474, 112212, 719, 10, 20, "Print"],
Cell[5764196, 112224, 754, 11, 20, "Print"],
Cell[5764953, 112237, 921, 16, 20, "Print"],
Cell[5765877, 112255, 770, 11, 20, "Print"],
Cell[5766650, 112268, 3581, 85, 56, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[5770280, 112359, 277, 9, 50, "Input"],
Cell[5770560, 112370, 1126, 28, 55, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5771723, 112403, 257, 4, 43, "Input"],
Cell[5771983, 112409, 273, 5, 27, "Output"],
Cell[5772259, 112416, 808, 18, 234, "Output"]
}, Open  ]],
Cell[5773082, 112437, 173, 4, 27, "Input"],
Cell[CellGroupData[{
Cell[5773280, 112445, 3091, 70, 88, "Input"],
Cell[CellGroupData[{
Cell[5776396, 112519, 1515, 24, 20, "Print"],
Cell[5777914, 112545, 1411, 20, 20, "Print"],
Cell[5779328, 112567, 1397, 21, 20, "Print"],
Cell[5780728, 112590, 1443, 21, 20, "Print"],
Cell[5782174, 112613, 1443, 21, 20, "Print"],
Cell[5783620, 112636, 1443, 21, 20, "Print"],
Cell[5785066, 112659, 1397, 20, 20, "Print"],
Cell[5786466, 112681, 1390, 20, 20, "Print"],
Cell[5787859, 112703, 1443, 21, 20, "Print"],
Cell[5789305, 112726, 2756, 63, 38, "Print"],
Cell[5792064, 112791, 1379, 20, 20, "Print"],
Cell[5793446, 112813, 2624, 57, 42, "Print"],
Cell[5796073, 112872, 1379, 20, 20, "Print"],
Cell[5797455, 112894, 2777, 63, 42, "Print"],
Cell[5800235, 112959, 1379, 20, 20, "Print"],
Cell[5801617, 112981, 1392, 20, 20, "Print"]
}, Open  ]],
Cell[5803024, 113004, 1863, 29, 23, "Message"],
Cell[CellGroupData[{
Cell[5804912, 113037, 1558, 27, 20, "Print"],
Cell[5806473, 113066, 1379, 20, 20, "Print"],
Cell[5807855, 113088, 1443, 21, 20, "Print"],
Cell[5809301, 113111, 1379, 20, 20, "Print"],
Cell[5810683, 113133, 1550, 25, 20, "Print"],
Cell[5812236, 113160, 1538, 25, 20, "Print"],
Cell[5813777, 113187, 1496, 24, 20, "Print"],
Cell[5815276, 113213, 1446, 21, 20, "Print"],
Cell[5816725, 113236, 1517, 24, 20, "Print"],
Cell[5818245, 113262, 1690, 30, 20, "Print"],
Cell[5819938, 113294, 1688, 30, 20, "Print"],
Cell[5821629, 113326, 1702, 30, 20, "Print"],
Cell[5823334, 113358, 1379, 20, 20, "Print"],
Cell[5824716, 113380, 3075, 72, 36, "Print"],
Cell[5827794, 113454, 1379, 20, 20, "Print"],
Cell[5829176, 113476, 2565, 56, 36, "Print"],
Cell[5831744, 113534, 1568, 25, 20, "Print"],
Cell[5833315, 113561, 1531, 24, 20, "Print"],
Cell[5834849, 113587, 1648, 26, 20, "Print"],
Cell[5836500, 113615, 1659, 27, 20, "Print"],
Cell[5838162, 113644, 1448, 21, 20, "Print"],
Cell[5839613, 113667, 1516, 24, 20, "Print"],
Cell[5841132, 113693, 2077, 38, 20, "Print"],
Cell[5843212, 113733, 1690, 30, 20, "Print"],
Cell[5844905, 113765, 1688, 30, 20, "Print"],
Cell[5846596, 113797, 1710, 30, 20, "Print"],
Cell[5848309, 113829, 1381, 20, 20, "Print"],
Cell[5849693, 113851, 3092, 72, 36, "Print"],
Cell[5852788, 113925, 1381, 20, 20, "Print"],
Cell[5854172, 113947, 2584, 56, 36, "Print"],
Cell[5856759, 114005, 1569, 25, 20, "Print"],
Cell[5858331, 114032, 1531, 24, 20, "Print"],
Cell[5859865, 114058, 1645, 26, 20, "Print"],
Cell[5861513, 114086, 1660, 27, 20, "Print"],
Cell[5863176, 114115, 1448, 21, 20, "Print"],
Cell[5864627, 114138, 1517, 24, 20, "Print"],
Cell[5866147, 114164, 1688, 30, 20, "Print"],
Cell[5867838, 114196, 1688, 30, 20, "Print"],
Cell[5869529, 114228, 1702, 30, 20, "Print"],
Cell[5871234, 114260, 1379, 20, 20, "Print"],
Cell[5872616, 114282, 3093, 72, 36, "Print"],
Cell[5875712, 114356, 1379, 20, 20, "Print"],
Cell[5877094, 114378, 2583, 56, 36, "Print"],
Cell[5879680, 114436, 1569, 25, 20, "Print"],
Cell[5881252, 114463, 1533, 24, 20, "Print"],
Cell[5882788, 114489, 1659, 27, 20, "Print"],
Cell[5884450, 114518, 1446, 21, 20, "Print"],
Cell[5885899, 114541, 1516, 24, 20, "Print"],
Cell[5887418, 114567, 2077, 38, 20, "Print"],
Cell[5889498, 114607, 2077, 38, 20, "Print"],
Cell[5891578, 114647, 2077, 38, 20, "Print"],
Cell[5893658, 114687, 2077, 38, 20, "Print"],
Cell[5895738, 114727, 2077, 38, 20, "Print"]
}, Open  ]],
Cell[5897830, 114768, 77, 1, 27, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[5897944, 114774, 331, 11, 50, "Input"],
Cell[5898278, 114787, 1418, 32, 55, "Output"]
}, Open  ]],
Cell[5899711, 114822, 240, 5, 27, "Input"],
Cell[CellGroupData[{
Cell[5899976, 114831, 3110, 69, 88, "Input"],
Cell[CellGroupData[{
Cell[5903111, 114904, 1517, 24, 20, "Print"],
Cell[5904631, 114930, 1413, 20, 20, "Print"],
Cell[5906047, 114952, 1395, 21, 20, "Print"],
Cell[5907445, 114975, 1445, 21, 20, "Print"],
Cell[5908893, 114998, 1443, 21, 20, "Print"],
Cell[5910339, 115021, 1442, 21, 20, "Print"],
Cell[5911784, 115044, 1394, 20, 20, "Print"],
Cell[5913181, 115066, 1389, 20, 20, "Print"],
Cell[5914573, 115088, 1445, 21, 20, "Print"],
Cell[5916021, 115111, 2757, 63, 38, "Print"],
Cell[5918781, 115176, 1379, 20, 20, "Print"],
Cell[5920163, 115198, 2621, 57, 42, "Print"],
Cell[5922787, 115257, 1381, 20, 20, "Print"],
Cell[5924171, 115279, 2777, 63, 42, "Print"],
Cell[5926951, 115344, 1379, 20, 20, "Print"],
Cell[5928333, 115366, 1392, 20, 20, "Print"]
}, Open  ]],
Cell[5929740, 115389, 1865, 29, 23, "Message"],
Cell[CellGroupData[{
Cell[5931630, 115422, 1558, 27, 20, "Print"],
Cell[5933191, 115451, 1379, 20, 20, "Print"],
Cell[5934573, 115473, 1443, 21, 20, "Print"],
Cell[5936019, 115496, 1379, 20, 20, "Print"],
Cell[5937401, 115518, 1550, 25, 20, "Print"],
Cell[5938954, 115545, 1538, 25, 20, "Print"],
Cell[5940495, 115572, 1517, 25, 20, "Print"],
Cell[5942015, 115599, 1448, 21, 20, "Print"],
Cell[5943466, 115622, 1519, 24, 20, "Print"],
Cell[5944988, 115648, 1688, 30, 20, "Print"],
Cell[5946679, 115680, 1688, 30, 20, "Print"],
Cell[5948370, 115712, 1700, 30, 20, "Print"],
Cell[5950073, 115744, 1379, 20, 20, "Print"],
Cell[5951455, 115766, 3060, 72, 36, "Print"],
Cell[5954518, 115840, 1381, 20, 20, "Print"],
Cell[5955902, 115862, 2565, 56, 36, "Print"],
Cell[5958470, 115920, 1569, 25, 20, "Print"],
Cell[5960042, 115947, 1527, 24, 20, "Print"],
Cell[5961572, 115973, 1663, 27, 20, "Print"],
Cell[5963238, 116002, 1445, 21, 20, "Print"],
Cell[5964686, 116025, 1519, 24, 20, "Print"],
Cell[5966208, 116051, 2077, 38, 20, "Print"],
Cell[5968288, 116091, 2079, 38, 20, "Print"],
Cell[5970370, 116131, 2077, 38, 20, "Print"],
Cell[5972450, 116171, 1688, 30, 20, "Print"],
Cell[5974141, 116203, 1688, 30, 20, "Print"],
Cell[5975832, 116235, 1704, 30, 20, "Print"],
Cell[5977539, 116267, 1381, 20, 20, "Print"],
Cell[5978923, 116289, 3056, 72, 36, "Print"],
Cell[5981982, 116363, 1379, 20, 20, "Print"],
Cell[5983364, 116385, 2563, 56, 36, "Print"],
Cell[5985930, 116443, 1548, 25, 20, "Print"],
Cell[5987481, 116470, 1526, 24, 20, "Print"],
Cell[5989010, 116496, 1659, 27, 20, "Print"],
Cell[5990672, 116525, 1445, 21, 20, "Print"],
Cell[5992120, 116548, 1519, 24, 20, "Print"],
Cell[5993642, 116574, 2071, 38, 20, "Print"],
Cell[5995716, 116614, 2077, 38, 20, "Print"],
Cell[5997796, 116654, 2077, 38, 20, "Print"],
Cell[5999876, 116694, 2077, 38, 20, "Print"],
Cell[6001956, 116734, 2077, 38, 20, "Print"],
Cell[6004036, 116774, 2077, 38, 20, "Print"],
Cell[6006116, 116814, 2077, 38, 20, "Print"]
}, Open  ]],
Cell[6008208, 116855, 77, 1, 27, "Output"]
}, Closed]],
Cell[CellGroupData[{
Cell[6008322, 116861, 331, 11, 50, "Input"],
Cell[6008656, 116874, 1013, 26, 55, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6009742, 116908, 278, 5, 67, "Section"],
Cell[CellGroupData[{
Cell[6010045, 116917, 122, 2, 27, "Input"],
Cell[6010170, 116921, 794, 14, 23, "Message"],
Cell[6010967, 116937, 836, 14, 23, "Message"],
Cell[6011806, 116953, 810, 14, 23, "Message"],
Cell[6012619, 116969, 861, 15, 23, "Message"],
Cell[6013483, 116986, 728, 12, 23, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6014248, 117003, 129, 2, 27, "Input"],
Cell[6014380, 117007, 954, 19, 23, "Message"],
Cell[6015337, 117028, 685, 13, 23, "Message"],
Cell[6016025, 117043, 871, 15, 23, "Message"],
Cell[6016899, 117060, 679, 12, 23, "Message"],
Cell[6017581, 117074, 892, 16, 23, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6018510, 117095, 158, 3, 34, "Subsection"],
Cell[6018671, 117100, 120, 2, 27, "Input"],
Cell[6018794, 117104, 2096, 50, 223, "Input"],
Cell[6020893, 117156, 7567, 159, 373, "Input"],
Cell[CellGroupData[{
Cell[6028485, 117319, 2125, 50, 148, "Input"],
Cell[6030613, 117371, 3454, 57, 27, "Output"],
Cell[6034070, 117430, 3946, 68, 55, "Output"],
Cell[6038019, 117500, 3944, 68, 55, "Output"],
Cell[6041966, 117570, 3946, 68, 55, "Output"],
Cell[6045915, 117640, 3946, 68, 55, "Output"],
Cell[6049864, 117710, 8664, 141, 240, "Output"],
Cell[6058531, 117853, 3185, 48, 33, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[6061765, 117907, 114, 3, 26, "Subsection"],
Cell[CellGroupData[{
Cell[6061904, 117914, 1368, 27, 73, "Input"],
Cell[6063275, 117943, 2413, 35, 27, "Output"],
Cell[6065691, 117980, 2436, 36, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6068164, 118021, 69, 1, 27, "Input"],
Cell[6068236, 118024, 1721, 24, 27, "Output"]
}, Open  ]],
Cell[6069972, 118051, 1429, 36, 58, "Input"],
Cell[CellGroupData[{
Cell[6071426, 118091, 248, 3, 73, "Input"],
Cell[6071677, 118096, 2124, 32, 27, "Output"],
Cell[6073804, 118130, 2124, 32, 27, "Output"],
Cell[6075931, 118164, 2128, 32, 27, "Output"],
Cell[6078062, 118198, 2087, 30, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6080186, 118233, 177, 2, 58, "Input"],
Cell[6080366, 118237, 1778, 27, 27, "Output"],
Cell[6082147, 118266, 1778, 27, 27, "Output"],
Cell[6083928, 118295, 1761, 26, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6085726, 118326, 83, 2, 27, "Input"],
Cell[6085812, 118330, 1945, 29, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6087794, 118364, 174, 2, 43, "Input"],
Cell[6087971, 118368, 2206, 33, 27, "Output"],
Cell[6090180, 118403, 2205, 33, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6092422, 118441, 1347, 36, 73, "Input"],
Cell[6093772, 118479, 2928, 48, 249, "Output"],
Cell[6096703, 118529, 2926, 48, 249, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[6099678, 118583, 100, 2, 27, "Subsection"],
Cell[CellGroupData[{
Cell[6099803, 118589, 27, 0, 24, "Subsubsection"],
Cell[CellGroupData[{
Cell[6099855, 118593, 253, 3, 43, "Input"],
Cell[6100111, 118598, 648, 10, 27, "Output"],
Cell[6100762, 118610, 708, 12, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6101507, 118627, 1165, 36, 43, "Input"],
Cell[6102675, 118665, 5687, 99, 242, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6108399, 118769, 9885, 162, 133, "Input"],
Cell[CellGroupData[{
Cell[6118309, 118935, 557, 10, 20, "Print"],
Cell[6118869, 118947, 555, 10, 20, "Print"],
Cell[6119427, 118959, 571, 10, 20, "Print"],
Cell[6120001, 118971, 38474, 663, 173, "Print"]
}, Open  ]],
Cell[6158490, 119637, 3118, 44, 27, "Output"],
Cell[6161611, 119683, 3120, 44, 27, "Output"],
Cell[6164734, 119729, 3119, 44, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6167890, 119778, 12873, 206, 118, "Input"],
Cell[6180766, 119986, 60625, 1035, 142, "Print"],
Cell[6241394, 121023, 3791, 53, 27, "Output"],
Cell[6245188, 121078, 71150, 1205, 142, "Print"],
Cell[6316341, 122285, 3790, 53, 27, "Output"],
Cell[6320134, 122340, 66794, 1139, 142, "Print"],
Cell[6386931, 123481, 3789, 53, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6390757, 123539, 8989, 133, 43, "Input"],
Cell[6399749, 123674, 322, 5, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6400108, 123684, 8509, 122, 27, "Input"],
Cell[6408620, 123808, 413, 7, 27, "Output"]
}, Open  ]],
Cell[6409048, 123818, 6405, 157, 133, "Input"],
Cell[CellGroupData[{
Cell[6415478, 123979, 751, 15, 88, "Input"],
Cell[6416232, 123996, 2661, 38, 27, "Output"],
Cell[6418896, 124036, 2662, 38, 27, "Output"],
Cell[6421561, 124076, 2661, 38, 27, "Output"],
Cell[6424225, 124116, 2661, 38, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6426923, 124159, 3492, 75, 73, "Input"],
Cell[6430418, 124236, 14263, 247, 276, "Output"]
}, Open  ]],
Cell[6444696, 124486, 106, 2, 26, "Text"],
Cell[CellGroupData[{
Cell[6444827, 124492, 1078, 20, 133, "Input"],
Cell[6445908, 124514, 990, 15, 27, "Output"],
Cell[6446901, 124531, 1011, 16, 27, "Output"],
Cell[6447915, 124549, 966, 14, 27, "Output"],
Cell[6448884, 124565, 969, 14, 27, "Output"],
Cell[6449856, 124581, 968, 14, 27, "Output"],
Cell[6450827, 124597, 968, 14, 27, "Output"],
Cell[6451798, 124613, 969, 14, 27, "Output"],
Cell[6452770, 124629, 966, 14, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6453773, 124648, 69, 1, 27, "Input"],
Cell[6453845, 124651, 174, 4, 27, "Output"]
}, Open  ]],
Cell[6454034, 124658, 175, 3, 27, "Input"],
Cell[CellGroupData[{
Cell[6454234, 124665, 3316, 72, 88, "Input"],
Cell[CellGroupData[{
Cell[6457575, 124741, 432, 8, 20, "Print"],
Cell[6458010, 124751, 325, 4, 20, "Print"],
Cell[6458338, 124757, 309, 5, 20, "Print"],
Cell[6458650, 124764, 358, 5, 20, "Print"],
Cell[6459011, 124771, 360, 5, 20, "Print"],
Cell[6459374, 124778, 358, 5, 20, "Print"],
Cell[6459735, 124785, 310, 4, 20, "Print"],
Cell[6460048, 124791, 305, 4, 20, "Print"],
Cell[6460356, 124797, 358, 5, 20, "Print"],
Cell[6460717, 124804, 1673, 47, 38, "Print"],
Cell[6462393, 124853, 294, 4, 20, "Print"],
Cell[6462690, 124859, 1539, 41, 42, "Print"],
Cell[6464232, 124902, 294, 4, 20, "Print"],
Cell[6464529, 124908, 1693, 47, 42, "Print"],
Cell[6466225, 124957, 296, 4, 20, "Print"],
Cell[6466524, 124963, 305, 4, 20, "Print"]
}, Open  ]],
Cell[6466844, 124970, 822, 14, 23, "Message"],
Cell[CellGroupData[{
Cell[6467691, 124988, 473, 11, 20, "Print"],
Cell[6468167, 125001, 296, 4, 20, "Print"],
Cell[6468466, 125007, 360, 5, 20, "Print"],
Cell[6468829, 125014, 294, 4, 20, "Print"],
Cell[6469126, 125020, 460, 9, 20, "Print"],
Cell[6469589, 125031, 492, 9, 26, "Print"],
Cell[6470084, 125042, 433, 9, 20, "Print"],
Cell[6470520, 125053, 361, 5, 20, "Print"],
Cell[6470884, 125060, 432, 8, 20, "Print"],
Cell[6471319, 125070, 599, 14, 20, "Print"],
Cell[6471921, 125086, 603, 14, 20, "Print"],
Cell[6472527, 125102, 625, 14, 20, "Print"],
Cell[6473155, 125118, 294, 4, 20, "Print"],
Cell[6473452, 125124, 1990, 56, 36, "Print"],
Cell[6475445, 125182, 294, 4, 20, "Print"],
Cell[6475742, 125188, 1478, 40, 36, "Print"],
Cell[6477223, 125230, 490, 9, 26, "Print"],
Cell[6477716, 125241, 451, 8, 23, "Print"],
Cell[6478170, 125251, 556, 10, 20, "Print"],
Cell[6478729, 125263, 578, 11, 20, "Print"],
Cell[6479310, 125276, 363, 5, 20, "Print"],
Cell[6479676, 125283, 431, 8, 20, "Print"],
Cell[6480110, 125293, 599, 14, 20, "Print"],
Cell[6480712, 125309, 601, 14, 20, "Print"],
Cell[6481316, 125325, 621, 14, 20, "Print"],
Cell[6481940, 125341, 294, 4, 20, "Print"],
Cell[6482237, 125347, 2006, 56, 36, "Print"],
Cell[6484246, 125405, 294, 4, 20, "Print"],
Cell[6484543, 125411, 1501, 40, 36, "Print"],
Cell[6486047, 125453, 490, 9, 26, "Print"],
Cell[6486540, 125464, 451, 8, 23, "Print"],
Cell[6486994, 125474, 562, 10, 20, "Print"],
Cell[6487559, 125486, 578, 11, 20, "Print"],
Cell[6488140, 125499, 361, 5, 20, "Print"],
Cell[6488504, 125506, 432, 8, 20, "Print"],
Cell[6488939, 125516, 603, 14, 20, "Print"],
Cell[6489545, 125532, 599, 14, 20, "Print"],
Cell[6490147, 125548, 625, 14, 20, "Print"],
Cell[6490775, 125564, 293, 4, 20, "Print"],
Cell[6491071, 125570, 2013, 56, 36, "Print"],
Cell[6493087, 125628, 296, 4, 20, "Print"],
Cell[6493386, 125634, 1499, 40, 36, "Print"],
Cell[6494888, 125676, 492, 9, 26, "Print"],
Cell[6495383, 125687, 457, 9, 23, "Print"],
Cell[6495843, 125698, 562, 10, 20, "Print"],
Cell[6496408, 125710, 573, 10, 20, "Print"],
Cell[6496984, 125722, 363, 5, 20, "Print"],
Cell[6497350, 125729, 432, 8, 20, "Print"],
Cell[6497785, 125739, 603, 14, 20, "Print"],
Cell[6498391, 125755, 602, 14, 20, "Print"],
Cell[6498996, 125771, 621, 14, 20, "Print"],
Cell[6499620, 125787, 296, 4, 20, "Print"],
Cell[6499919, 125793, 2012, 56, 36, "Print"],
Cell[6501934, 125851, 296, 4, 20, "Print"],
Cell[6502233, 125857, 1501, 40, 36, "Print"],
Cell[6503737, 125899, 489, 9, 26, "Print"],
Cell[6504229, 125910, 456, 9, 23, "Print"],
Cell[6504688, 125921, 559, 10, 20, "Print"],
Cell[6505250, 125933, 579, 11, 20, "Print"],
Cell[6505832, 125946, 361, 5, 20, "Print"],
Cell[6506196, 125953, 434, 8, 20, "Print"],
Cell[6506633, 125963, 603, 14, 20, "Print"],
Cell[6507239, 125979, 603, 14, 20, "Print"],
Cell[6507845, 125995, 629, 14, 20, "Print"],
Cell[6508477, 126011, 294, 4, 20, "Print"],
Cell[6508774, 126017, 2009, 56, 36, "Print"],
Cell[6510786, 126075, 294, 4, 20, "Print"],
Cell[6511083, 126081, 1501, 40, 36, "Print"],
Cell[6512587, 126123, 492, 9, 26, "Print"],
Cell[6513082, 126134, 458, 9, 23, "Print"],
Cell[6513543, 126145, 562, 10, 20, "Print"],
Cell[6514108, 126157, 581, 11, 20, "Print"],
Cell[6514692, 126170, 361, 5, 20, "Print"],
Cell[6515056, 126177, 434, 8, 20, "Print"],
Cell[6515493, 126187, 603, 14, 20, "Print"],
Cell[6516099, 126203, 603, 14, 20, "Print"],
Cell[6516705, 126219, 698, 16, 23, "Print"],
Cell[6517406, 126237, 294, 4, 20, "Print"],
Cell[6517703, 126243, 2014, 56, 36, "Print"],
Cell[6519720, 126301, 294, 4, 20, "Print"],
Cell[6520017, 126307, 1501, 40, 36, "Print"],
Cell[6521521, 126349, 490, 9, 26, "Print"],
Cell[6522014, 126360, 456, 9, 23, "Print"],
Cell[6522473, 126371, 579, 11, 23, "Print"],
Cell[6523055, 126384, 581, 11, 23, "Print"],
Cell[6523639, 126397, 310, 4, 20, "Print"],
Cell[6523952, 126403, 361, 5, 20, "Print"],
Cell[6524316, 126410, 432, 8, 20, "Print"],
Cell[6524751, 126420, 603, 14, 20, "Print"],
Cell[6525357, 126436, 603, 14, 20, "Print"],
Cell[6525963, 126452, 701, 16, 23, "Print"],
Cell[6526667, 126470, 294, 4, 20, "Print"],
Cell[6526964, 126476, 1968, 56, 36, "Print"],
Cell[6528935, 126534, 294, 4, 20, "Print"],
Cell[6529232, 126540, 1499, 40, 36, "Print"],
Cell[6530734, 126582, 492, 9, 26, "Print"],
Cell[6531229, 126593, 458, 8, 23, "Print"],
Cell[6531690, 126603, 580, 11, 23, "Print"],
Cell[6532273, 126616, 588, 12, 23, "Print"],
Cell[6532864, 126630, 308, 4, 20, "Print"],
Cell[6533175, 126636, 308, 4, 20, "Print"],
Cell[6533486, 126642, 308, 4, 20, "Print"],
Cell[6533797, 126648, 526, 9, 20, "Print"],
Cell[6534326, 126659, 1303, 33, 40, "Print"],
Cell[6535632, 126694, 296, 4, 20, "Print"],
Cell[6535931, 126700, 1501, 40, 36, "Print"],
Cell[6537435, 126742, 1952, 50, 136, "Print"],
Cell[6539390, 126794, 473, 9, 26, "Print"],
Cell[6539866, 126805, 352, 5, 20, "Print"],
Cell[6540221, 126812, 339, 4, 20, "Print"],
Cell[6540563, 126818, 352, 5, 20, "Print"],
Cell[6540918, 126825, 1801, 44, 40, "Print"],
Cell[6542722, 126871, 352, 5, 20, "Print"],
Cell[6543077, 126878, 304, 4, 20, "Print"],
Cell[6543384, 126884, 350, 5, 20, "Print"],
Cell[6543737, 126891, 1470, 38, 38, "Print"],
Cell[6545210, 126931, 350, 5, 20, "Print"],
Cell[6545563, 126938, 325, 4, 20, "Print"],
Cell[6545891, 126944, 352, 5, 20, "Print"],
Cell[6546246, 126951, 352, 5, 20, "Print"],
Cell[6546601, 126958, 484, 9, 20, "Print"],
Cell[6547088, 126969, 1426, 36, 38, "Print"],
Cell[6548517, 127007, 351, 5, 20, "Print"],
Cell[6548871, 127014, 333, 4, 20, "Print"],
Cell[6549207, 127020, 353, 5, 20, "Print"],
Cell[6549563, 127027, 1171, 29, 36, "Print"],
Cell[6550737, 127058, 352, 5, 20, "Print"],
Cell[6551092, 127065, 356, 5, 22, "Print"],
Cell[6551451, 127072, 351, 5, 20, "Print"],
Cell[6551805, 127079, 1186, 29, 36, "Print"],
Cell[6552994, 127110, 294, 4, 20, "Print"],
Cell[6553291, 127116, 329, 5, 20, "Print"],
Cell[6553623, 127123, 352, 5, 20, "Print"],
Cell[6553978, 127130, 367, 5, 22, "Print"],
Cell[6554348, 127137, 352, 5, 20, "Print"],
Cell[6554703, 127144, 1187, 29, 36, "Print"],
Cell[6555893, 127175, 294, 4, 20, "Print"],
Cell[6556190, 127181, 327, 5, 20, "Print"],
Cell[6556520, 127188, 352, 5, 20, "Print"],
Cell[6556875, 127195, 317, 4, 20, "Print"],
Cell[6557195, 127201, 352, 5, 20, "Print"],
Cell[6557550, 127208, 492, 9, 20, "Print"],
Cell[6558045, 127219, 370, 5, 20, "Print"],
Cell[6558418, 127226, 1734, 47, 56, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[6560201, 127279, 331, 11, 50, "Input"],
Cell[6560535, 127292, 1479, 33, 55, "Output"]
}, Open  ]],
Cell[6562029, 127328, 237, 4, 27, "Input"],
Cell[CellGroupData[{
Cell[6562291, 127336, 3416, 74, 88, "Input"],
Cell[CellGroupData[{
Cell[6565732, 127414, 354, 7, 20, "Print"],
Cell[6566089, 127423, 252, 3, 20, "Print"],
Cell[6566344, 127428, 233, 4, 20, "Print"],
Cell[6566580, 127434, 282, 4, 20, "Print"],
Cell[6566865, 127440, 284, 4, 20, "Print"],
Cell[6567152, 127446, 284, 4, 20, "Print"],
Cell[6567439, 127452, 234, 3, 20, "Print"],
Cell[6567676, 127457, 229, 3, 20, "Print"],
Cell[6567908, 127462, 282, 4, 20, "Print"],
Cell[6568193, 127468, 1595, 46, 38, "Print"],
Cell[6569791, 127516, 217, 3, 20, "Print"],
Cell[6570011, 127521, 1461, 40, 42, "Print"],
Cell[6571475, 127563, 218, 3, 20, "Print"],
Cell[6571696, 127568, 1619, 46, 42, "Print"],
Cell[6573318, 127616, 218, 3, 20, "Print"],
Cell[6573539, 127621, 229, 3, 20, "Print"]
}, Open  ]],
Cell[6573783, 127627, 755, 13, 23, "Message"],
Cell[CellGroupData[{
Cell[6574563, 127644, 399, 10, 20, "Print"],
Cell[6574965, 127656, 218, 3, 20, "Print"],
Cell[6575186, 127661, 284, 4, 20, "Print"],
Cell[6575473, 127667, 218, 3, 20, "Print"],
Cell[6575694, 127672, 384, 8, 20, "Print"],
Cell[6576081, 127682, 414, 8, 26, "Print"],
Cell[6576498, 127692, 355, 8, 20, "Print"],
Cell[6576856, 127702, 285, 4, 20, "Print"],
Cell[6577144, 127708, 356, 7, 20, "Print"],
Cell[6577503, 127717, 523, 13, 20, "Print"],
Cell[6578029, 127732, 525, 13, 20, "Print"],
Cell[6578557, 127747, 549, 13, 20, "Print"],
Cell[6579109, 127762, 220, 3, 20, "Print"],
Cell[6579332, 127767, 1909, 55, 36, "Print"],
Cell[6581244, 127824, 218, 3, 20, "Print"],
Cell[6581465, 127829, 1400, 39, 36, "Print"],
Cell[6582868, 127870, 414, 8, 26, "Print"],
Cell[6583285, 127880, 375, 7, 23, "Print"],
Cell[6583663, 127889, 483, 9, 20, "Print"],
Cell[6584149, 127900, 502, 10, 20, "Print"],
Cell[6584654, 127912, 287, 4, 20, "Print"],
Cell[6584944, 127918, 356, 7, 20, "Print"],
Cell[6585303, 127927, 529, 13, 20, "Print"],
Cell[6585835, 127942, 525, 13, 20, "Print"],
Cell[6586363, 127957, 547, 13, 20, "Print"],
Cell[6586913, 127972, 218, 3, 20, "Print"],
Cell[6587134, 127977, 1928, 55, 36, "Print"],
Cell[6589065, 128034, 218, 3, 20, "Print"],
Cell[6589286, 128039, 1427, 39, 36, "Print"],
Cell[6590716, 128080, 414, 8, 26, "Print"],
Cell[6591133, 128090, 375, 7, 23, "Print"],
Cell[6591511, 128099, 486, 9, 20, "Print"],
Cell[6592000, 128110, 502, 10, 20, "Print"],
Cell[6592505, 128122, 285, 4, 20, "Print"],
Cell[6592793, 128128, 356, 7, 20, "Print"],
Cell[6593152, 128137, 527, 13, 20, "Print"],
Cell[6593682, 128152, 529, 13, 20, "Print"],
Cell[6594214, 128167, 547, 13, 20, "Print"],
Cell[6594764, 128182, 218, 3, 20, "Print"],
Cell[6594985, 128187, 1932, 55, 36, "Print"],
Cell[6596920, 128244, 218, 3, 20, "Print"],
Cell[6597141, 128249, 1425, 39, 36, "Print"],
Cell[6598569, 128290, 414, 8, 26, "Print"],
Cell[6598986, 128300, 381, 8, 23, "Print"],
Cell[6599370, 128310, 483, 9, 20, "Print"],
Cell[6599856, 128321, 499, 9, 20, "Print"],
Cell[6600358, 128332, 287, 4, 20, "Print"],
Cell[6600648, 128338, 358, 7, 20, "Print"],
Cell[6601009, 128347, 527, 13, 20, "Print"],
Cell[6601539, 128362, 526, 13, 20, "Print"],
Cell[6602068, 128377, 551, 13, 20, "Print"],
Cell[6602622, 128392, 218, 3, 20, "Print"],
Cell[6602843, 128397, 1931, 55, 36, "Print"],
Cell[6604777, 128454, 218, 3, 20, "Print"],
Cell[6604998, 128459, 1423, 39, 36, "Print"],
Cell[6606424, 128500, 416, 8, 26, "Print"],
Cell[6606843, 128510, 382, 8, 23, "Print"],
Cell[6607228, 128520, 483, 9, 20, "Print"],
Cell[6607714, 128531, 503, 10, 20, "Print"],
Cell[6608220, 128543, 285, 4, 20, "Print"],
Cell[6608508, 128549, 358, 7, 20, "Print"],
Cell[6608869, 128558, 526, 13, 20, "Print"],
Cell[6609398, 128573, 526, 13, 20, "Print"],
Cell[6609927, 128588, 620, 15, 23, "Print"],
Cell[6610550, 128605, 218, 3, 20, "Print"],
Cell[6610771, 128610, 1932, 55, 36, "Print"],
Cell[6612706, 128667, 218, 3, 20, "Print"],
Cell[6612927, 128672, 1423, 39, 36, "Print"],
Cell[6614353, 128713, 414, 8, 26, "Print"],
Cell[6614770, 128723, 382, 8, 23, "Print"],
Cell[6615155, 128733, 480, 9, 20, "Print"],
Cell[6615638, 128744, 505, 10, 20, "Print"],
Cell[6616146, 128756, 287, 4, 20, "Print"],
Cell[6616436, 128762, 356, 7, 20, "Print"],
Cell[6616795, 128771, 529, 13, 20, "Print"],
Cell[6617327, 128786, 527, 13, 20, "Print"],
Cell[6617857, 128801, 617, 15, 23, "Print"],
Cell[6618477, 128818, 218, 3, 20, "Print"],
Cell[6618698, 128823, 1939, 55, 36, "Print"],
Cell[6620640, 128880, 220, 3, 20, "Print"],
Cell[6620863, 128885, 1425, 39, 36, "Print"],
Cell[6622291, 128926, 416, 8, 26, "Print"],
Cell[6622710, 128936, 380, 7, 23, "Print"],
Cell[6623093, 128945, 495, 9, 23, "Print"],
Cell[6623591, 128956, 505, 10, 23, "Print"],
Cell[6624099, 128968, 231, 3, 20, "Print"],
Cell[6624333, 128973, 234, 3, 20, "Print"],
Cell[6624570, 128978, 234, 3, 20, "Print"],
Cell[6624807, 128983, 450, 8, 20, "Print"],
Cell[6625260, 128993, 1227, 32, 40, "Print"],
Cell[6626490, 129027, 218, 3, 20, "Print"],
Cell[6626711, 129032, 1425, 39, 36, "Print"],
Cell[6628139, 129073, 1793, 47, 122, "Print"],
Cell[6629935, 129122, 397, 8, 26, "Print"],
Cell[6630335, 129132, 278, 4, 20, "Print"],
Cell[6630616, 129138, 263, 3, 20, "Print"],
Cell[6630882, 129143, 276, 4, 20, "Print"],
Cell[6631161, 129149, 1726, 43, 40, "Print"],
Cell[6632890, 129194, 276, 4, 20, "Print"],
Cell[6633169, 129200, 228, 3, 20, "Print"],
Cell[6633400, 129205, 276, 4, 20, "Print"],
Cell[6633679, 129211, 1395, 37, 38, "Print"],
Cell[6635077, 129250, 274, 4, 20, "Print"],
Cell[6635354, 129256, 249, 3, 20, "Print"],
Cell[6635606, 129261, 276, 4, 20, "Print"],
Cell[6635885, 129267, 276, 4, 20, "Print"],
Cell[6636164, 129273, 408, 8, 20, "Print"],
Cell[6636575, 129283, 1346, 34, 38, "Print"],
Cell[6637924, 129319, 275, 4, 20, "Print"],
Cell[6638202, 129325, 257, 3, 20, "Print"],
Cell[6638462, 129330, 277, 4, 20, "Print"],
Cell[6638742, 129336, 1113, 28, 36, "Print"],
Cell[6639858, 129366, 276, 4, 20, "Print"],
Cell[6640137, 129372, 280, 4, 22, "Print"],
Cell[6640420, 129378, 276, 4, 20, "Print"],
Cell[6640699, 129384, 1111, 28, 36, "Print"],
Cell[6641813, 129414, 218, 3, 20, "Print"],
Cell[6642034, 129419, 251, 4, 20, "Print"],
Cell[6642288, 129425, 276, 4, 20, "Print"],
Cell[6642567, 129431, 293, 4, 22, "Print"],
Cell[6642863, 129437, 276, 4, 20, "Print"],
Cell[6643142, 129443, 1113, 28, 36, "Print"],
Cell[6644258, 129473, 220, 3, 20, "Print"],
Cell[6644481, 129478, 251, 4, 20, "Print"],
Cell[6644735, 129484, 276, 4, 20, "Print"],
Cell[6645014, 129490, 241, 3, 20, "Print"],
Cell[6645258, 129495, 278, 4, 20, "Print"],
Cell[6645539, 129501, 418, 8, 20, "Print"],
Cell[6645960, 129511, 294, 4, 20, "Print"],
Cell[6646257, 129517, 1658, 46, 56, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[6647964, 129569, 331, 11, 50, "Input"],
Cell[6648298, 129582, 1202, 29, 55, "Output"]
}, Open  ]],
Cell[6649515, 129614, 137, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[6649677, 129620, 3441, 74, 88, "Input"],
Cell[CellGroupData[{
Cell[6653143, 129698, 233, 5, 20, "Print"],
Cell[6653379, 129705, 129, 1, 20, "Print"],
Cell[6653511, 129708, 114, 2, 20, "Print"],
Cell[6653628, 129712, 161, 2, 20, "Print"],
Cell[6653792, 129716, 161, 2, 20, "Print"],
Cell[6653956, 129720, 163, 2, 20, "Print"],
Cell[6654122, 129724, 115, 1, 20, "Print"],
Cell[6654240, 129727, 110, 1, 20, "Print"],
Cell[6654353, 129730, 161, 2, 20, "Print"],
Cell[6654517, 129734, 1474, 44, 38, "Print"],
Cell[6655994, 129780, 97, 1, 20, "Print"],
Cell[6656094, 129783, 1340, 38, 42, "Print"],
Cell[6657437, 129823, 97, 1, 20, "Print"],
Cell[6657537, 129826, 1498, 44, 42, "Print"],
Cell[6659038, 129872, 97, 1, 20, "Print"],
Cell[6659138, 129875, 110, 1, 20, "Print"]
}, Open  ]],
Cell[6659263, 129879, 631, 11, 23, "Message"],
Cell[CellGroupData[{
Cell[6659919, 129894, 275, 8, 20, "Print"],
Cell[6660197, 129904, 99, 1, 20, "Print"],
Cell[6660299, 129907, 161, 2, 20, "Print"],
Cell[6660463, 129911, 97, 1, 20, "Print"],
Cell[6660563, 129914, 263, 6, 20, "Print"],
Cell[6660829, 129922, 293, 6, 26, "Print"],
Cell[6661125, 129930, 235, 6, 20, "Print"],
Cell[6661363, 129938, 166, 2, 20, "Print"],
Cell[6661532, 129942, 235, 5, 20, "Print"],
Cell[6661770, 129949, 402, 11, 20, "Print"],
Cell[6662175, 129962, 405, 11, 20, "Print"],
Cell[6662583, 129975, 420, 11, 20, "Print"],
Cell[6663006, 129988, 97, 1, 20, "Print"],
Cell[6663106, 129991, 1795, 53, 36, "Print"],
Cell[6664904, 130046, 99, 1, 20, "Print"],
Cell[6665006, 130049, 1281, 37, 36, "Print"],
Cell[6666290, 130088, 293, 6, 26, "Print"],
Cell[6666586, 130096, 254, 5, 23, "Print"],
Cell[6666843, 130103, 359, 7, 20, "Print"],
Cell[6667205, 130112, 379, 8, 20, "Print"],
Cell[6667587, 130122, 164, 2, 20, "Print"],
Cell[6667754, 130126, 237, 5, 20, "Print"],
Cell[6667994, 130133, 404, 11, 20, "Print"],
Cell[6668401, 130146, 402, 11, 20, "Print"],
Cell[6668806, 130159, 424, 11, 20, "Print"],
Cell[6669233, 130172, 97, 1, 20, "Print"],
Cell[6669333, 130175, 1809, 53, 36, "Print"],
Cell[6671145, 130230, 97, 1, 20, "Print"],
Cell[6671245, 130233, 1304, 37, 36, "Print"],
Cell[6672552, 130272, 293, 6, 26, "Print"],
Cell[6672848, 130280, 254, 5, 23, "Print"],
Cell[6673105, 130287, 365, 7, 20, "Print"],
Cell[6673473, 130296, 381, 8, 20, "Print"],
Cell[6673857, 130306, 164, 2, 20, "Print"],
Cell[6674024, 130310, 237, 5, 20, "Print"],
Cell[6674264, 130317, 402, 11, 20, "Print"],
Cell[6674669, 130330, 402, 11, 20, "Print"],
Cell[6675074, 130343, 428, 11, 20, "Print"],
Cell[6675505, 130356, 97, 1, 20, "Print"],
Cell[6675605, 130359, 1812, 53, 36, "Print"],
Cell[6677420, 130414, 97, 1, 20, "Print"],
Cell[6677520, 130417, 1301, 37, 36, "Print"],
Cell[6678824, 130456, 293, 6, 26, "Print"],
Cell[6679120, 130464, 254, 5, 23, "Print"],
Cell[6679377, 130471, 362, 7, 20, "Print"],
Cell[6679742, 130480, 379, 8, 20, "Print"],
Cell[6680124, 130490, 166, 2, 20, "Print"],
Cell[6680293, 130494, 235, 5, 20, "Print"],
Cell[6680531, 130501, 404, 11, 20, "Print"],
Cell[6680938, 130514, 402, 11, 20, "Print"],
Cell[6681343, 130527, 432, 11, 20, "Print"],
Cell[6681778, 130540, 97, 1, 20, "Print"],
Cell[6681878, 130543, 1815, 53, 36, "Print"],
Cell[6683696, 130598, 99, 1, 20, "Print"],
Cell[6683798, 130601, 1304, 37, 36, "Print"],
Cell[6685105, 130640, 295, 6, 26, "Print"],
Cell[6685403, 130648, 261, 6, 23, "Print"],
Cell[6685667, 130656, 362, 7, 20, "Print"],
Cell[6686032, 130665, 382, 8, 20, "Print"],
Cell[6686417, 130675, 164, 2, 20, "Print"],
Cell[6686584, 130679, 237, 5, 20, "Print"],
Cell[6686824, 130686, 402, 11, 20, "Print"],
Cell[6687229, 130699, 402, 11, 20, "Print"],
Cell[6687634, 130712, 497, 13, 23, "Print"],
Cell[6688134, 130727, 97, 1, 20, "Print"],
Cell[6688234, 130730, 1812, 53, 36, "Print"],
Cell[6690049, 130785, 99, 1, 20, "Print"],
Cell[6690151, 130788, 1301, 37, 36, "Print"],
Cell[6691455, 130827, 293, 6, 26, "Print"],
Cell[6691751, 130835, 259, 5, 23, "Print"],
Cell[6692013, 130842, 359, 7, 20, "Print"],
Cell[6692375, 130851, 393, 9, 20, "Print"],
Cell[6692771, 130862, 164, 2, 20, "Print"],
Cell[6692938, 130866, 235, 5, 20, "Print"],
Cell[6693176, 130873, 405, 11, 20, "Print"],
Cell[6693584, 130886, 402, 11, 20, "Print"],
Cell[6693989, 130899, 501, 13, 23, "Print"],
Cell[6694493, 130914, 97, 1, 20, "Print"],
Cell[6694593, 130917, 1815, 53, 36, "Print"],
Cell[6696411, 130972, 97, 1, 20, "Print"],
Cell[6696511, 130975, 1301, 37, 36, "Print"],
Cell[6697815, 131014, 293, 6, 26, "Print"],
Cell[6698111, 131022, 259, 6, 23, "Print"],
Cell[6698373, 131030, 371, 7, 23, "Print"],
Cell[6698747, 131039, 393, 9, 23, "Print"],
Cell[6699143, 131050, 111, 1, 20, "Print"],
Cell[6699257, 131053, 111, 1, 20, "Print"],
Cell[6699371, 131056, 113, 1, 20, "Print"],
Cell[6699487, 131059, 328, 6, 20, "Print"],
Cell[6699818, 131067, 1105, 30, 40, "Print"],
Cell[6700926, 131099, 97, 1, 20, "Print"],
Cell[6701026, 131102, 1302, 37, 36, "Print"],
Cell[6702331, 131141, 1672, 45, 122, "Print"],
Cell[6704006, 131188, 276, 6, 26, "Print"],
Cell[6704285, 131196, 157, 2, 20, "Print"],
Cell[6704445, 131200, 142, 1, 20, "Print"],
Cell[6704590, 131203, 155, 2, 20, "Print"],
Cell[6704748, 131207, 1605, 41, 40, "Print"],
Cell[6706356, 131250, 155, 2, 20, "Print"],
Cell[6706514, 131254, 107, 1, 20, "Print"],
Cell[6706624, 131257, 153, 2, 20, "Print"],
Cell[6706780, 131261, 1274, 35, 38, "Print"],
Cell[6708057, 131298, 153, 2, 20, "Print"],
Cell[6708213, 131302, 128, 1, 20, "Print"],
Cell[6708344, 131305, 155, 2, 20, "Print"],
Cell[6708502, 131309, 153, 2, 20, "Print"],
Cell[6708658, 131313, 287, 6, 20, "Print"],
Cell[6708948, 131321, 1223, 32, 38, "Print"],
Cell[6710174, 131355, 154, 2, 20, "Print"],
Cell[6710331, 131359, 136, 1, 20, "Print"],
Cell[6710470, 131362, 156, 2, 20, "Print"],
Cell[6710629, 131366, 990, 26, 36, "Print"],
Cell[6711622, 131394, 157, 2, 20, "Print"],
Cell[6711782, 131398, 158, 2, 22, "Print"],
Cell[6711943, 131402, 155, 2, 20, "Print"],
Cell[6712101, 131406, 991, 26, 36, "Print"],
Cell[6713095, 131434, 97, 1, 20, "Print"],
Cell[6713195, 131437, 131, 2, 20, "Print"],
Cell[6713329, 131441, 155, 2, 20, "Print"],
Cell[6713487, 131445, 172, 2, 22, "Print"],
Cell[6713662, 131449, 155, 2, 20, "Print"],
Cell[6713820, 131453, 990, 26, 36, "Print"],
Cell[6714813, 131481, 97, 1, 20, "Print"],
Cell[6714913, 131484, 130, 2, 20, "Print"],
Cell[6715046, 131488, 155, 2, 20, "Print"],
Cell[6715204, 131492, 120, 1, 20, "Print"],
Cell[6715327, 131495, 157, 2, 20, "Print"],
Cell[6715487, 131499, 295, 6, 20, "Print"],
Cell[6715785, 131507, 171, 2, 20, "Print"],
Cell[6715959, 131511, 1537, 44, 56, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[6717545, 131561, 331, 11, 50, "Input"],
Cell[6717879, 131574, 1203, 29, 55, "Output"]
}, Open  ]],
Cell[6719097, 131606, 102, 1, 27, "Input"],
Cell[CellGroupData[{
Cell[6719224, 131611, 1893, 49, 88, "Input"],
Cell[CellGroupData[{
Cell[6721142, 131664, 616, 11, 20, "Print"],
Cell[6721761, 131677, 512, 7, 20, "Print"],
Cell[6722276, 131686, 495, 8, 20, "Print"],
Cell[6722774, 131696, 546, 8, 20, "Print"],
Cell[6723323, 131706, 544, 8, 20, "Print"],
Cell[6723870, 131716, 544, 8, 20, "Print"],
Cell[6724417, 131726, 498, 7, 20, "Print"],
Cell[6724918, 131735, 485, 7, 20, "Print"],
Cell[6725406, 131744, 544, 8, 20, "Print"],
Cell[6725953, 131754, 1859, 50, 38, "Print"],
Cell[6727815, 131806, 480, 7, 20, "Print"],
Cell[6728298, 131815, 1723, 44, 42, "Print"],
Cell[6730024, 131861, 480, 7, 20, "Print"],
Cell[6730507, 131870, 1881, 50, 42, "Print"],
Cell[6732391, 131922, 479, 7, 20, "Print"],
Cell[6732873, 131931, 491, 7, 20, "Print"]
}, Open  ]],
Cell[6733379, 131941, 984, 17, 23, "Message"],
Cell[CellGroupData[{
Cell[6734388, 131962, 659, 14, 20, "Print"],
Cell[6735050, 131978, 480, 7, 20, "Print"],
Cell[6735533, 131987, 544, 8, 20, "Print"],
Cell[6736080, 131997, 482, 7, 20, "Print"],
Cell[6736565, 132006, 646, 12, 20, "Print"],
Cell[6737214, 132020, 676, 12, 26, "Print"],
Cell[6737893, 132034, 617, 12, 20, "Print"],
Cell[6738513, 132048, 549, 8, 20, "Print"],
Cell[6739065, 132058, 620, 11, 20, "Print"],
Cell[6739688, 132071, 787, 17, 20, "Print"],
Cell[6740478, 132090, 787, 17, 20, "Print"],
Cell[6741268, 132109, 803, 17, 20, "Print"],
Cell[6742074, 132128, 480, 7, 20, "Print"],
Cell[6742557, 132137, 2174, 59, 36, "Print"],
Cell[6744734, 132198, 479, 7, 20, "Print"],
Cell[6745216, 132207, 1666, 43, 36, "Print"],
Cell[6746885, 132252, 676, 12, 26, "Print"],
Cell[6747564, 132266, 639, 11, 23, "Print"],
Cell[6748206, 132279, 742, 13, 20, "Print"],
Cell[6748951, 132294, 760, 14, 20, "Print"],
Cell[6749714, 132310, 547, 8, 20, "Print"],
Cell[6750264, 132320, 620, 11, 20, "Print"],
Cell[6750887, 132333, 787, 17, 20, "Print"],
Cell[6751677, 132352, 787, 17, 20, "Print"],
Cell[6752467, 132371, 805, 17, 20, "Print"],
Cell[6753275, 132390, 480, 7, 20, "Print"],
Cell[6753758, 132399, 2195, 59, 36, "Print"],
Cell[6755956, 132460, 482, 7, 20, "Print"],
Cell[6756441, 132469, 1690, 43, 36, "Print"],
Cell[6758134, 132514, 676, 12, 26, "Print"],
Cell[6758813, 132528, 639, 11, 23, "Print"],
Cell[6759455, 132541, 742, 13, 20, "Print"],
Cell[6760200, 132556, 760, 14, 20, "Print"],
Cell[6760963, 132572, 547, 8, 20, "Print"],
Cell[6761513, 132582, 618, 11, 20, "Print"],
Cell[6762134, 132595, 787, 17, 20, "Print"],
Cell[6762924, 132614, 789, 17, 20, "Print"],
Cell[6763716, 132633, 809, 17, 20, "Print"],
Cell[6764528, 132652, 480, 7, 20, "Print"],
Cell[6765011, 132661, 2195, 59, 36, "Print"],
Cell[6767209, 132722, 482, 7, 20, "Print"],
Cell[6767694, 132731, 1687, 43, 36, "Print"],
Cell[6769384, 132776, 676, 12, 26, "Print"],
Cell[6770063, 132790, 639, 11, 23, "Print"],
Cell[6770705, 132803, 745, 13, 20, "Print"],
Cell[6771453, 132818, 765, 14, 20, "Print"],
Cell[6772221, 132834, 547, 8, 20, "Print"],
Cell[6772771, 132844, 618, 11, 20, "Print"],
Cell[6773392, 132857, 789, 17, 20, "Print"],
Cell[6774184, 132876, 789, 17, 20, "Print"],
Cell[6774976, 132895, 886, 19, 23, "Print"],
Cell[6775865, 132916, 482, 7, 20, "Print"],
Cell[6776350, 132925, 2209, 59, 36, "Print"],
Cell[6778562, 132986, 482, 7, 20, "Print"],
Cell[6779047, 132995, 1688, 43, 36, "Print"],
Cell[6780738, 133040, 676, 12, 26, "Print"],
Cell[6781417, 133054, 642, 12, 23, "Print"],
Cell[6782062, 133068, 759, 13, 23, "Print"],
Cell[6782824, 133083, 773, 15, 20, "Print"],
Cell[6783600, 133100, 494, 7, 20, "Print"],
Cell[6784097, 133109, 547, 8, 20, "Print"],
Cell[6784647, 133119, 618, 11, 20, "Print"],
Cell[6785268, 133132, 791, 17, 20, "Print"],
Cell[6786062, 133151, 787, 17, 20, "Print"],
Cell[6786852, 133170, 883, 19, 23, "Print"],
Cell[6787738, 133191, 480, 7, 20, "Print"],
Cell[6788221, 133200, 2187, 59, 36, "Print"],
Cell[6790411, 133261, 480, 7, 20, "Print"],
Cell[6790894, 133270, 1687, 43, 36, "Print"],
Cell[6792584, 133315, 675, 12, 26, "Print"],
Cell[6793262, 133329, 644, 11, 23, "Print"],
Cell[6793909, 133342, 722, 12, 20, "Print"],
Cell[6794634, 133356, 494, 7, 20, "Print"],
Cell[6795131, 133365, 494, 7, 20, "Print"],
Cell[6795628, 133374, 494, 7, 20, "Print"],
Cell[6796125, 133383, 712, 12, 20, "Print"],
Cell[6796840, 133397, 1446, 35, 36, "Print"],
Cell[6798289, 133434, 479, 7, 20, "Print"],
Cell[6798771, 133443, 1687, 43, 36, "Print"],
Cell[6800461, 133488, 2034, 51, 110, "Print"],
Cell[6802498, 133541, 658, 12, 26, "Print"],
Cell[6803159, 133555, 538, 8, 20, "Print"],
Cell[6803700, 133565, 525, 7, 20, "Print"],
Cell[6804228, 133574, 538, 8, 20, "Print"],
Cell[6804769, 133584, 1958, 47, 40, "Print"],
Cell[6806730, 133633, 536, 8, 20, "Print"],
Cell[6807269, 133643, 490, 7, 20, "Print"],
Cell[6807762, 133652, 536, 8, 20, "Print"],
Cell[6808301, 133662, 1660, 41, 42, "Print"],
Cell[6809964, 133705, 536, 8, 20, "Print"],
Cell[6810503, 133715, 513, 7, 20, "Print"],
Cell[6811019, 133724, 536, 8, 20, "Print"],
Cell[6811558, 133734, 536, 8, 20, "Print"],
Cell[6812097, 133744, 670, 12, 20, "Print"],
Cell[6812770, 133758, 1638, 40, 42, "Print"],
Cell[6814411, 133800, 536, 8, 20, "Print"],
Cell[6814950, 133810, 521, 7, 20, "Print"],
Cell[6815474, 133819, 537, 8, 20, "Print"],
Cell[6816014, 133829, 1373, 32, 36, "Print"],
Cell[6817390, 133863, 540, 8, 20, "Print"],
Cell[6817933, 133873, 544, 8, 22, "Print"],
Cell[6818480, 133883, 538, 8, 20, "Print"],
Cell[6819021, 133893, 1373, 32, 36, "Print"],
Cell[6820397, 133927, 480, 7, 20, "Print"],
Cell[6820880, 133936, 513, 8, 20, "Print"],
Cell[6821396, 133946, 538, 8, 20, "Print"],
Cell[6821937, 133956, 553, 8, 22, "Print"],
Cell[6822493, 133966, 538, 8, 20, "Print"],
Cell[6823034, 133976, 1373, 32, 36, "Print"],
Cell[6824410, 134010, 480, 7, 20, "Print"],
Cell[6824893, 134019, 513, 8, 20, "Print"],
Cell[6825409, 134029, 538, 8, 20, "Print"],
Cell[6825950, 134039, 503, 7, 20, "Print"],
Cell[6826456, 134048, 540, 8, 20, "Print"],
Cell[6826999, 134058, 680, 12, 20, "Print"],
Cell[6827682, 134072, 556, 8, 20, "Print"],
Cell[6828241, 134082, 1922, 50, 56, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[6830212, 134138, 331, 11, 50, "Input"],
Cell[6830546, 134151, 1270, 30, 59, "Output"]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[6831877, 134188, 228, 4, 26, "Subsection"],
Cell[CellGroupData[{
Cell[6832130, 134196, 120, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[6832275, 134202, 196, 4, 42, "Print",
 CellTags->"Info3460898558-4560556"],
Cell[6832474, 134208, 1288, 36, 64, "Print",
 CellTags->"Info3460898558-4560556"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6833811, 134250, 684, 17, 43, "Input"],
Cell[6834498, 134269, 473, 10, 46, "Output"],
Cell[6834974, 134281, 3279, 60, 242, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6838290, 134346, 130, 2, 27, "Input"],
Cell[6838423, 134350, 255, 4, 46, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6838715, 134359, 799, 25, 27, "Input"],
Cell[6839517, 134386, 1276, 35, 46, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6840830, 134426, 633, 15, 27, "Input"],
Cell[6841466, 134443, 1549, 30, 238, "Output"]
}, Open  ]],
Cell[6843030, 134476, 2096, 50, 223, "Input"],
Cell[6845129, 134528, 7497, 158, 373, "Input"],
Cell[CellGroupData[{
Cell[6852651, 134690, 235, 5, 27, "Input"],
Cell[6852889, 134697, 461, 10, 33, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6853387, 134712, 1955, 46, 133, "Input"],
Cell[6855345, 134760, 3404, 56, 27, "Output"],
Cell[6858752, 134818, 3894, 67, 55, "Output"],
Cell[6862649, 134887, 3894, 67, 55, "Output"],
Cell[6866546, 134956, 3896, 67, 55, "Output"],
Cell[6870445, 135025, 3896, 67, 55, "Output"],
Cell[6874344, 135094, 4012, 63, 238, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[6878405, 135163, 114, 3, 26, "Subsection"],
Cell[CellGroupData[{
Cell[6878544, 135170, 1347, 27, 73, "Input"],
Cell[6879894, 135199, 2366, 34, 27, "Output"],
Cell[6882263, 135235, 2386, 35, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6884686, 135275, 69, 1, 27, "Input"],
Cell[6884758, 135278, 1671, 23, 27, "Output"]
}, Open  ]],
Cell[6886444, 135304, 1429, 36, 58, "Input"],
Cell[CellGroupData[{
Cell[6887898, 135344, 1347, 36, 73, "Input"],
Cell[6889248, 135382, 2897, 47, 249, "Output"],
Cell[6892148, 135431, 2898, 47, 249, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[6895095, 135484, 100, 2, 27, "Subsection"],
Cell[CellGroupData[{
Cell[6895220, 135490, 27, 0, 24, "Subsubsection"],
Cell[CellGroupData[{
Cell[6895272, 135494, 253, 3, 43, "Input"],
Cell[6895528, 135499, 601, 9, 27, "Output"],
Cell[6896132, 135510, 661, 11, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6896830, 135526, 9884, 162, 133, "Input"],
Cell[CellGroupData[{
Cell[6906739, 135692, 530, 9, 20, "Print"],
Cell[6907272, 135703, 485, 8, 20, "Print"],
Cell[6907760, 135713, 522, 9, 20, "Print"],
Cell[6908285, 135724, 33836, 587, 173, "Print"]
}, Open  ]],
Cell[6942136, 136314, 3057, 42, 27, "Output"],
Cell[6945196, 136358, 3074, 43, 27, "Output"],
Cell[6948273, 136403, 3071, 43, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6951381, 136451, 12875, 206, 118, "Input"],
Cell[6964259, 136659, 50713, 868, 142, "Print"],
Cell[7014975, 137529, 3795, 53, 27, "Output"],
Cell[7018773, 137584, 38017, 660, 142, "Print"],
Cell[7056793, 138246, 3795, 53, 27, "Output"],
Cell[7060591, 138301, 3794, 53, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7064422, 138359, 8989, 133, 43, "Input"],
Cell[7073414, 138494, 320, 5, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7073771, 138504, 8531, 123, 58, "Input"],
Cell[7082305, 138629, 381, 6, 27, "Output"]
}, Open  ]],
Cell[7082701, 138638, 6452, 158, 133, "Input"],
Cell[CellGroupData[{
Cell[7089178, 138800, 1355, 20, 58, "Input"],
Cell[7090536, 138822, 2607, 37, 27, "Output"],
Cell[7093146, 138861, 2608, 37, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7095791, 138903, 3381, 73, 43, "Input"],
Cell[7099175, 138978, 8080, 142, 276, "Output"]
}, Open  ]],
Cell[7107270, 139123, 106, 2, 26, "Text"],
Cell[CellGroupData[{
Cell[7107401, 139129, 1078, 20, 133, "Input"],
Cell[7108482, 139151, 993, 15, 27, "Output"],
Cell[7109478, 139168, 1013, 16, 27, "Output"],
Cell[7110494, 139186, 965, 14, 27, "Output"],
Cell[7111462, 139202, 969, 14, 27, "Output"],
Cell[7112434, 139218, 966, 14, 27, "Output"],
Cell[7113403, 139234, 965, 14, 27, "Output"],
Cell[7114371, 139250, 967, 14, 27, "Output"],
Cell[7115341, 139266, 966, 14, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7116344, 139285, 69, 1, 27, "Input"],
Cell[7116416, 139288, 152, 4, 27, "Output"]
}, Open  ]],
Cell[7116583, 139295, 237, 4, 27, "Input"],
Cell[CellGroupData[{
Cell[7116845, 139303, 3416, 74, 88, "Input"],
Cell[CellGroupData[{
Cell[7120286, 139381, 356, 7, 20, "Print"],
Cell[7120645, 139390, 250, 3, 20, "Print"],
Cell[7120898, 139395, 233, 4, 20, "Print"],
Cell[7121134, 139401, 282, 4, 20, "Print"],
Cell[7121419, 139407, 282, 4, 20, "Print"],
Cell[7121704, 139413, 282, 4, 20, "Print"],
Cell[7121989, 139419, 236, 3, 20, "Print"],
Cell[7122228, 139424, 228, 3, 20, "Print"],
Cell[7122459, 139429, 282, 4, 20, "Print"],
Cell[7122744, 139435, 1595, 46, 38, "Print"],
Cell[7124342, 139483, 218, 3, 20, "Print"],
Cell[7124563, 139488, 1463, 40, 42, "Print"],
Cell[7126029, 139530, 218, 3, 20, "Print"],
Cell[7126250, 139535, 1617, 46, 42, "Print"],
Cell[7127870, 139583, 216, 3, 20, "Print"],
Cell[7128089, 139588, 231, 3, 20, "Print"]
}, Open  ]],
Cell[7128335, 139594, 753, 13, 23, "Message"],
Cell[CellGroupData[{
Cell[7129113, 139611, 395, 10, 20, "Print"],
Cell[7129511, 139623, 217, 3, 20, "Print"],
Cell[7129731, 139628, 282, 4, 20, "Print"],
Cell[7130016, 139634, 220, 3, 20, "Print"],
Cell[7130239, 139639, 389, 8, 20, "Print"],
Cell[7130631, 139649, 414, 8, 26, "Print"],
Cell[7131048, 139659, 341, 8, 20, "Print"],
Cell[7131392, 139669, 285, 4, 20, "Print"],
Cell[7131680, 139675, 356, 7, 20, "Print"],
Cell[7132039, 139684, 914, 21, 20, "Print"],
Cell[7132956, 139707, 908, 21, 20, "Print"],
Cell[7133867, 139730, 525, 13, 20, "Print"],
Cell[7134395, 139745, 523, 13, 20, "Print"],
Cell[7134921, 139760, 545, 13, 20, "Print"],
Cell[7135469, 139775, 217, 3, 20, "Print"],
Cell[7135689, 139780, 1907, 55, 36, "Print"],
Cell[7137599, 139837, 218, 3, 20, "Print"],
Cell[7137820, 139842, 1404, 39, 36, "Print"],
Cell[7139227, 139883, 414, 8, 26, "Print"],
Cell[7139644, 139893, 381, 8, 23, "Print"],
Cell[7140028, 139903, 453, 8, 20, "Print"],
Cell[7140484, 139913, 492, 9, 20, "Print"],
Cell[7140979, 139924, 285, 4, 20, "Print"],
Cell[7141267, 139930, 356, 7, 20, "Print"],
Cell[7141626, 139939, 910, 21, 20, "Print"],
Cell[7142539, 139962, 523, 13, 20, "Print"],
Cell[7143065, 139977, 523, 13, 20, "Print"],
Cell[7143591, 139992, 545, 13, 20, "Print"],
Cell[7144139, 140007, 220, 3, 20, "Print"],
Cell[7144362, 140012, 1933, 55, 36, "Print"],
Cell[7146298, 140069, 218, 3, 20, "Print"],
Cell[7146519, 140074, 1424, 39, 36, "Print"],
Cell[7147946, 140115, 413, 8, 26, "Print"],
Cell[7148362, 140125, 375, 7, 23, "Print"],
Cell[7148740, 140134, 486, 9, 20, "Print"],
Cell[7149229, 140145, 491, 9, 20, "Print"],
Cell[7149723, 140156, 284, 4, 20, "Print"],
Cell[7150010, 140162, 356, 7, 20, "Print"],
Cell[7150369, 140171, 523, 13, 20, "Print"],
Cell[7150895, 140186, 525, 13, 20, "Print"],
Cell[7151423, 140201, 547, 13, 20, "Print"],
Cell[7151973, 140216, 220, 3, 20, "Print"],
Cell[7152196, 140221, 1937, 55, 36, "Print"],
Cell[7154136, 140278, 220, 3, 20, "Print"],
Cell[7154359, 140283, 1424, 39, 36, "Print"],
Cell[7155786, 140324, 416, 8, 26, "Print"],
Cell[7156205, 140334, 373, 7, 23, "Print"],
Cell[7156581, 140343, 483, 9, 20, "Print"],
Cell[7157067, 140354, 498, 9, 20, "Print"],
Cell[7157568, 140365, 283, 4, 20, "Print"],
Cell[7157854, 140371, 356, 7, 20, "Print"],
Cell[7158213, 140380, 523, 13, 20, "Print"],
Cell[7158739, 140395, 523, 13, 20, "Print"],
Cell[7159265, 140410, 550, 13, 20, "Print"],
Cell[7159818, 140425, 220, 3, 20, "Print"],
Cell[7160041, 140430, 1937, 55, 36, "Print"],
Cell[7161981, 140487, 218, 3, 20, "Print"],
Cell[7162202, 140492, 1425, 39, 36, "Print"],
Cell[7163630, 140533, 414, 8, 26, "Print"],
Cell[7164047, 140543, 381, 8, 23, "Print"],
Cell[7164431, 140553, 481, 9, 20, "Print"],
Cell[7164915, 140564, 502, 10, 20, "Print"],
Cell[7165420, 140576, 285, 4, 20, "Print"],
Cell[7165708, 140582, 356, 7, 20, "Print"],
Cell[7166067, 140591, 522, 13, 20, "Print"],
Cell[7166592, 140606, 525, 13, 20, "Print"],
Cell[7167120, 140621, 620, 15, 23, "Print"],
Cell[7167743, 140638, 218, 3, 20, "Print"],
Cell[7167964, 140643, 1941, 55, 36, "Print"],
Cell[7169908, 140700, 220, 3, 20, "Print"],
Cell[7170131, 140705, 1425, 39, 36, "Print"],
Cell[7171559, 140746, 416, 8, 26, "Print"],
Cell[7171978, 140756, 377, 7, 23, "Print"],
Cell[7172358, 140765, 482, 9, 20, "Print"],
Cell[7172843, 140776, 503, 10, 20, "Print"],
Cell[7173349, 140788, 285, 4, 20, "Print"],
Cell[7173637, 140794, 356, 7, 20, "Print"],
Cell[7173996, 140803, 521, 13, 20, "Print"],
Cell[7174520, 140818, 523, 13, 20, "Print"],
Cell[7175046, 140833, 624, 15, 23, "Print"],
Cell[7175673, 140850, 218, 3, 20, "Print"],
Cell[7175894, 140855, 1919, 55, 36, "Print"],
Cell[7177816, 140912, 218, 3, 20, "Print"],
Cell[7178037, 140917, 1423, 39, 36, "Print"],
Cell[7179463, 140958, 413, 8, 26, "Print"],
Cell[7179879, 140968, 380, 8, 23, "Print"],
Cell[7180262, 140978, 490, 9, 23, "Print"],
Cell[7180755, 140989, 511, 11, 20, "Print"],
Cell[7181269, 141002, 232, 3, 20, "Print"],
Cell[7181504, 141007, 232, 3, 20, "Print"],
Cell[7181739, 141012, 234, 3, 20, "Print"],
Cell[7181976, 141017, 452, 8, 20, "Print"],
Cell[7182431, 141027, 1228, 32, 36, "Print"],
Cell[7183662, 141061, 218, 3, 20, "Print"],
Cell[7183883, 141066, 1427, 39, 36, "Print"],
Cell[7185313, 141107, 1649, 40, 122, "Print"],
Cell[7186965, 141149, 399, 8, 26, "Print"],
Cell[7187367, 141159, 276, 4, 20, "Print"],
Cell[7187646, 141165, 263, 3, 20, "Print"],
Cell[7187912, 141170, 276, 4, 20, "Print"],
Cell[7188191, 141176, 1713, 43, 36, "Print"],
Cell[7189907, 141221, 276, 4, 20, "Print"],
Cell[7190186, 141227, 228, 3, 20, "Print"],
Cell[7190417, 141232, 273, 4, 20, "Print"],
Cell[7190693, 141238, 1395, 37, 38, "Print"],
Cell[7192091, 141277, 274, 4, 20, "Print"],
Cell[7192368, 141283, 249, 3, 20, "Print"],
Cell[7192620, 141288, 274, 4, 20, "Print"],
Cell[7192897, 141294, 273, 4, 20, "Print"],
Cell[7193173, 141300, 408, 8, 20, "Print"],
Cell[7193584, 141310, 1357, 35, 38, "Print"],
Cell[7194944, 141347, 277, 4, 20, "Print"],
Cell[7195224, 141353, 257, 3, 20, "Print"],
Cell[7195484, 141358, 275, 4, 20, "Print"],
Cell[7195762, 141364, 1111, 28, 36, "Print"],
Cell[7196876, 141394, 278, 4, 20, "Print"],
Cell[7197157, 141400, 280, 4, 22, "Print"],
Cell[7197440, 141406, 275, 4, 20, "Print"],
Cell[7197718, 141412, 1114, 28, 36, "Print"],
Cell[7198835, 141442, 220, 3, 20, "Print"],
Cell[7199058, 141447, 254, 4, 20, "Print"],
Cell[7199315, 141453, 276, 4, 20, "Print"],
Cell[7199594, 141459, 291, 4, 22, "Print"],
Cell[7199888, 141465, 276, 4, 20, "Print"],
Cell[7200167, 141471, 1110, 28, 36, "Print"],
Cell[7201280, 141501, 218, 3, 20, "Print"],
Cell[7201501, 141506, 250, 4, 20, "Print"],
Cell[7201754, 141512, 276, 4, 20, "Print"],
Cell[7202033, 141518, 241, 3, 20, "Print"],
Cell[7202277, 141523, 276, 4, 20, "Print"],
Cell[7202556, 141529, 416, 8, 20, "Print"],
Cell[7202975, 141539, 292, 4, 20, "Print"],
Cell[7203270, 141545, 1620, 45, 56, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[7204939, 141596, 331, 11, 50, "Input"],
Cell[7205273, 141609, 1209, 29, 55, "Output"]
}, Open  ]],
Cell[7206497, 141641, 137, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[7206659, 141647, 3441, 74, 88, "Input"],
Cell[CellGroupData[{
Cell[7210125, 141725, 258, 6, 20, "Print"],
Cell[7210386, 141733, 156, 2, 20, "Print"],
Cell[7210545, 141737, 139, 3, 20, "Print"],
Cell[7210687, 141742, 185, 3, 20, "Print"],
Cell[7210875, 141747, 188, 3, 20, "Print"],
Cell[7211066, 141752, 186, 3, 20, "Print"],
Cell[7211255, 141757, 138, 2, 20, "Print"],
Cell[7211396, 141761, 132, 2, 20, "Print"],
Cell[7211531, 141765, 186, 3, 20, "Print"],
Cell[7211720, 141770, 1499, 45, 38, "Print"],
Cell[7213222, 141817, 122, 2, 20, "Print"],
Cell[7213347, 141821, 1365, 39, 42, "Print"],
Cell[7214715, 141862, 122, 2, 20, "Print"],
Cell[7214840, 141866, 1523, 45, 42, "Print"],
Cell[7216366, 141913, 122, 2, 20, "Print"],
Cell[7216491, 141917, 133, 2, 20, "Print"]
}, Open  ]],
Cell[7216639, 141922, 656, 12, 23, "Message"],
Cell[CellGroupData[{
Cell[7217320, 141938, 301, 9, 20, "Print"],
Cell[7217624, 141949, 122, 2, 20, "Print"],
Cell[7217749, 141953, 185, 3, 20, "Print"],
Cell[7217937, 141958, 122, 2, 20, "Print"],
Cell[7218062, 141962, 293, 7, 20, "Print"],
Cell[7218358, 141971, 318, 7, 26, "Print"],
Cell[7218679, 141980, 223, 6, 20, "Print"],
Cell[7218905, 141988, 189, 3, 20, "Print"],
Cell[7219097, 141993, 260, 6, 20, "Print"],
Cell[7219360, 142001, 814, 20, 20, "Print"],
Cell[7220177, 142023, 818, 20, 20, "Print"],
Cell[7220998, 142045, 812, 20, 20, "Print"],
Cell[7221813, 142067, 816, 20, 20, "Print"],
Cell[7222632, 142089, 818, 20, 20, "Print"],
Cell[7223453, 142111, 431, 12, 20, "Print"],
Cell[7223887, 142125, 427, 12, 20, "Print"],
Cell[7224317, 142139, 451, 12, 20, "Print"],
Cell[7224771, 142153, 124, 2, 20, "Print"],
Cell[7224898, 142157, 1815, 54, 36, "Print"],
Cell[7226716, 142213, 122, 2, 20, "Print"],
Cell[7226841, 142217, 1308, 38, 36, "Print"],
Cell[7228152, 142257, 318, 7, 26, "Print"],
Cell[7228473, 142266, 279, 6, 23, "Print"],
Cell[7228755, 142274, 399, 9, 23, "Print"],
Cell[7229157, 142285, 400, 8, 20, "Print"],
Cell[7229560, 142295, 189, 3, 20, "Print"],
Cell[7229752, 142300, 262, 6, 20, "Print"],
Cell[7230017, 142308, 820, 20, 20, "Print"],
Cell[7230840, 142330, 818, 20, 20, "Print"],
Cell[7231661, 142352, 427, 12, 20, "Print"],
Cell[7232091, 142366, 429, 12, 20, "Print"],
Cell[7232523, 142380, 451, 12, 20, "Print"],
Cell[7232977, 142394, 122, 2, 20, "Print"],
Cell[7233102, 142398, 1831, 54, 36, "Print"],
Cell[7234936, 142454, 122, 2, 20, "Print"],
Cell[7235061, 142458, 1326, 38, 36, "Print"],
Cell[7236390, 142498, 320, 7, 26, "Print"],
Cell[7236713, 142507, 279, 6, 23, "Print"],
Cell[7236995, 142515, 386, 8, 20, "Print"],
Cell[7237384, 142525, 399, 8, 20, "Print"],
Cell[7237786, 142535, 189, 3, 20, "Print"],
Cell[7237978, 142540, 262, 6, 20, "Print"],
Cell[7238243, 142548, 812, 20, 20, "Print"],
Cell[7239058, 142570, 814, 20, 20, "Print"],
Cell[7239875, 142592, 814, 20, 20, "Print"],
Cell[7240692, 142614, 816, 20, 20, "Print"],
Cell[7241511, 142636, 433, 12, 20, "Print"],
Cell[7241947, 142650, 429, 12, 20, "Print"],
Cell[7242379, 142664, 455, 12, 20, "Print"],
Cell[7242837, 142678, 122, 2, 20, "Print"],
Cell[7242962, 142682, 1837, 54, 36, "Print"],
Cell[7244802, 142738, 124, 2, 20, "Print"],
Cell[7244929, 142742, 1327, 38, 36, "Print"],
Cell[7246259, 142782, 318, 7, 26, "Print"],
Cell[7246580, 142791, 276, 6, 23, "Print"],
Cell[7246859, 142799, 405, 9, 23, "Print"],
Cell[7247267, 142810, 397, 8, 20, "Print"],
Cell[7247667, 142820, 138, 2, 20, "Print"],
Cell[7247808, 142824, 191, 3, 20, "Print"],
Cell[7248002, 142829, 260, 6, 20, "Print"],
Cell[7248265, 142837, 822, 20, 20, "Print"],
Cell[7249090, 142859, 820, 20, 20, "Print"],
Cell[7249913, 142881, 818, 20, 20, "Print"],
Cell[7250734, 142903, 822, 20, 20, "Print"],
Cell[7251559, 142925, 431, 12, 20, "Print"],
Cell[7251993, 142939, 431, 12, 20, "Print"],
Cell[7252427, 142953, 455, 12, 20, "Print"],
Cell[7252885, 142967, 122, 2, 20, "Print"],
Cell[7253010, 142971, 1841, 54, 36, "Print"],
Cell[7254854, 143027, 122, 2, 20, "Print"],
Cell[7254979, 143031, 1331, 38, 36, "Print"],
Cell[7256313, 143071, 318, 7, 26, "Print"],
Cell[7256634, 143080, 279, 6, 23, "Print"],
Cell[7256916, 143088, 405, 9, 23, "Print"],
Cell[7257324, 143099, 397, 8, 20, "Print"],
Cell[7257724, 143109, 138, 2, 20, "Print"],
Cell[7257865, 143113, 189, 3, 20, "Print"],
Cell[7258057, 143118, 262, 6, 20, "Print"],
Cell[7258322, 143126, 819, 20, 20, "Print"],
Cell[7259144, 143148, 820, 20, 20, "Print"],
Cell[7259967, 143170, 820, 20, 20, "Print"],
Cell[7260790, 143192, 816, 20, 20, "Print"],
Cell[7261609, 143214, 427, 12, 20, "Print"],
Cell[7262039, 143228, 431, 12, 20, "Print"],
Cell[7262473, 143242, 457, 12, 20, "Print"],
Cell[7262933, 143256, 122, 2, 20, "Print"],
Cell[7263058, 143260, 1839, 54, 36, "Print"],
Cell[7264900, 143316, 122, 2, 20, "Print"],
Cell[7265025, 143320, 1328, 38, 36, "Print"],
Cell[7266356, 143360, 320, 7, 26, "Print"],
Cell[7266679, 143369, 279, 6, 23, "Print"],
Cell[7266961, 143377, 402, 9, 23, "Print"],
Cell[7267366, 143388, 397, 8, 20, "Print"],
Cell[7267766, 143398, 136, 2, 20, "Print"],
Cell[7267905, 143402, 191, 3, 20, "Print"],
Cell[7268099, 143407, 259, 6, 20, "Print"],
Cell[7268361, 143415, 816, 20, 20, "Print"],
Cell[7269180, 143437, 818, 20, 20, "Print"],
Cell[7270001, 143459, 815, 20, 20, "Print"],
Cell[7270819, 143481, 812, 20, 20, "Print"],
Cell[7271634, 143503, 812, 20, 20, "Print"],
Cell[7272449, 143525, 427, 12, 20, "Print"],
Cell[7272879, 143539, 427, 12, 20, "Print"],
Cell[7273309, 143553, 457, 12, 20, "Print"],
Cell[7273769, 143567, 122, 2, 20, "Print"],
Cell[7273894, 143571, 1843, 54, 36, "Print"],
Cell[7275740, 143627, 122, 2, 20, "Print"],
Cell[7275865, 143631, 1329, 38, 36, "Print"],
Cell[7277197, 143671, 320, 7, 26, "Print"],
Cell[7277520, 143680, 277, 6, 23, "Print"],
Cell[7277800, 143688, 396, 8, 23, "Print"],
Cell[7278199, 143698, 397, 8, 20, "Print"],
Cell[7278599, 143708, 136, 2, 20, "Print"],
Cell[7278738, 143712, 189, 3, 20, "Print"],
Cell[7278930, 143717, 262, 6, 20, "Print"],
Cell[7279195, 143725, 816, 20, 20, "Print"],
Cell[7280014, 143747, 816, 20, 20, "Print"],
Cell[7280833, 143769, 816, 20, 20, "Print"],
Cell[7281652, 143791, 816, 20, 20, "Print"],
Cell[7282471, 143813, 816, 20, 20, "Print"],
Cell[7283290, 143835, 812, 20, 20, "Print"],
Cell[7284105, 143857, 427, 12, 20, "Print"],
Cell[7284535, 143871, 429, 12, 20, "Print"],
Cell[7284967, 143885, 522, 14, 23, "Print"],
Cell[7285492, 143901, 124, 2, 20, "Print"],
Cell[7285619, 143905, 1817, 54, 36, "Print"],
Cell[7287439, 143961, 122, 2, 20, "Print"],
Cell[7287564, 143965, 1329, 38, 36, "Print"],
Cell[7288896, 144005, 318, 7, 26, "Print"],
Cell[7289217, 144014, 285, 7, 23, "Print"],
Cell[7289505, 144023, 394, 8, 23, "Print"],
Cell[7289902, 144033, 397, 8, 20, "Print"],
Cell[7290302, 144043, 138, 2, 20, "Print"],
Cell[7290443, 144047, 189, 3, 20, "Print"],
Cell[7290635, 144052, 260, 6, 20, "Print"],
Cell[7290898, 144060, 814, 20, 20, "Print"],
Cell[7291715, 144082, 816, 20, 20, "Print"],
Cell[7292534, 144104, 815, 20, 20, "Print"],
Cell[7293352, 144126, 818, 20, 20, "Print"],
Cell[7294173, 144148, 814, 20, 20, "Print"],
Cell[7294990, 144170, 811, 20, 20, "Print"],
Cell[7295804, 144192, 429, 12, 20, "Print"],
Cell[7296236, 144206, 427, 12, 20, "Print"],
Cell[7296666, 144220, 522, 14, 23, "Print"],
Cell[7297191, 144236, 122, 2, 20, "Print"],
Cell[7297316, 144240, 1817, 54, 36, "Print"],
Cell[7299136, 144296, 122, 2, 20, "Print"],
Cell[7299261, 144300, 1327, 38, 36, "Print"],
Cell[7300591, 144340, 318, 7, 26, "Print"],
Cell[7300912, 144349, 279, 6, 23, "Print"],
Cell[7301194, 144357, 396, 8, 23, "Print"],
Cell[7301593, 144367, 399, 8, 20, "Print"],
Cell[7301995, 144377, 138, 2, 20, "Print"],
Cell[7302136, 144381, 191, 3, 20, "Print"],
Cell[7302330, 144386, 259, 6, 20, "Print"],
Cell[7302592, 144394, 818, 20, 20, "Print"],
Cell[7303413, 144416, 816, 20, 20, "Print"],
Cell[7304232, 144438, 816, 20, 20, "Print"],
Cell[7305051, 144460, 812, 20, 20, "Print"],
Cell[7305866, 144482, 818, 20, 20, "Print"],
Cell[7306687, 144504, 818, 20, 20, "Print"],
Cell[7307508, 144526, 430, 12, 20, "Print"],
Cell[7307941, 144540, 429, 12, 20, "Print"],
Cell[7308373, 144554, 522, 14, 23, "Print"],
Cell[7308898, 144570, 122, 2, 20, "Print"],
Cell[7309023, 144574, 1819, 54, 36, "Print"],
Cell[7310845, 144630, 122, 2, 20, "Print"],
Cell[7310970, 144634, 1331, 38, 36, "Print"],
Cell[7312304, 144674, 318, 7, 26, "Print"],
Cell[7312625, 144683, 285, 7, 23, "Print"],
Cell[7312913, 144692, 396, 8, 20, "Print"],
Cell[7313312, 144702, 138, 2, 20, "Print"],
Cell[7313453, 144706, 189, 3, 20, "Print"],
Cell[7313645, 144711, 262, 6, 20, "Print"],
Cell[7313910, 144719, 822, 20, 20, "Print"],
Cell[7314735, 144741, 816, 20, 20, "Print"],
Cell[7315554, 144763, 820, 20, 20, "Print"],
Cell[7316377, 144785, 816, 20, 20, "Print"],
Cell[7317196, 144807, 820, 20, 20, "Print"],
Cell[7318019, 144829, 820, 20, 20, "Print"],
Cell[7318842, 144851, 822, 20, 20, "Print"],
Cell[7319667, 144873, 431, 12, 20, "Print"],
Cell[7320101, 144887, 431, 12, 20, "Print"],
Cell[7320535, 144901, 528, 14, 23, "Print"],
Cell[7321066, 144917, 122, 2, 20, "Print"],
Cell[7321191, 144921, 1817, 54, 36, "Print"],
Cell[7323011, 144977, 122, 2, 20, "Print"],
Cell[7323136, 144981, 1329, 38, 36, "Print"],
Cell[7324468, 145021, 318, 7, 26, "Print"],
Cell[7324789, 145030, 279, 6, 23, "Print"],
Cell[7325071, 145038, 396, 8, 23, "Print"],
Cell[7325470, 145048, 397, 8, 20, "Print"],
Cell[7325870, 145058, 136, 2, 20, "Print"],
Cell[7326009, 145062, 191, 3, 20, "Print"],
Cell[7326203, 145067, 264, 6, 20, "Print"],
Cell[7326470, 145075, 820, 20, 20, "Print"],
Cell[7327293, 145097, 822, 20, 20, "Print"],
Cell[7328118, 145119, 816, 20, 20, "Print"],
Cell[7328937, 145141, 816, 20, 20, "Print"],
Cell[7329756, 145163, 820, 20, 20, "Print"],
Cell[7330579, 145185, 822, 20, 20, "Print"],
Cell[7331404, 145207, 820, 20, 20, "Print"],
Cell[7332227, 145229, 433, 12, 20, "Print"],
Cell[7332663, 145243, 433, 12, 20, "Print"],
Cell[7333099, 145257, 522, 14, 23, "Print"],
Cell[7333624, 145273, 124, 2, 20, "Print"],
Cell[7333751, 145277, 1819, 54, 36, "Print"],
Cell[7335573, 145333, 121, 2, 20, "Print"],
Cell[7335697, 145337, 1331, 38, 36, "Print"],
Cell[7337031, 145377, 318, 7, 26, "Print"],
Cell[7337352, 145386, 287, 7, 23, "Print"],
Cell[7337642, 145395, 399, 8, 20, "Print"],
Cell[7338044, 145405, 138, 2, 20, "Print"],
Cell[7338185, 145409, 189, 3, 20, "Print"],
Cell[7338377, 145414, 262, 6, 20, "Print"],
Cell[7338642, 145422, 816, 20, 20, "Print"],
Cell[7339461, 145444, 816, 20, 20, "Print"],
Cell[7340280, 145466, 820, 20, 20, "Print"],
Cell[7341103, 145488, 820, 20, 20, "Print"],
Cell[7341926, 145510, 818, 20, 20, "Print"],
Cell[7342747, 145532, 816, 20, 20, "Print"],
Cell[7343566, 145554, 820, 20, 20, "Print"],
Cell[7344389, 145576, 431, 12, 20, "Print"],
Cell[7344823, 145590, 431, 12, 20, "Print"],
Cell[7345257, 145604, 528, 14, 23, "Print"],
Cell[7345788, 145620, 122, 2, 20, "Print"],
Cell[7345913, 145624, 1821, 54, 36, "Print"],
Cell[7347737, 145680, 124, 2, 20, "Print"],
Cell[7347864, 145684, 1329, 38, 36, "Print"],
Cell[7349196, 145724, 318, 7, 26, "Print"],
Cell[7349517, 145733, 285, 7, 23, "Print"],
Cell[7349805, 145742, 398, 8, 23, "Print"],
Cell[7350206, 145752, 399, 8, 20, "Print"],
Cell[7350608, 145762, 136, 2, 20, "Print"],
Cell[7350747, 145766, 189, 3, 20, "Print"],
Cell[7350939, 145771, 262, 6, 20, "Print"],
Cell[7351204, 145779, 820, 20, 20, "Print"],
Cell[7352027, 145801, 820, 20, 20, "Print"],
Cell[7352850, 145823, 818, 20, 20, "Print"],
Cell[7353671, 145845, 819, 20, 20, "Print"],
Cell[7354493, 145867, 816, 20, 20, "Print"],
Cell[7355312, 145889, 820, 20, 20, "Print"],
Cell[7356135, 145911, 820, 20, 20, "Print"],
Cell[7356958, 145933, 815, 20, 20, "Print"],
Cell[7357776, 145955, 429, 12, 20, "Print"],
Cell[7358208, 145969, 431, 12, 20, "Print"],
Cell[7358642, 145983, 526, 14, 23, "Print"],
Cell[7359171, 145999, 124, 2, 20, "Print"],
Cell[7359298, 146003, 1819, 54, 36, "Print"],
Cell[7361120, 146059, 122, 2, 20, "Print"],
Cell[7361245, 146063, 1328, 38, 36, "Print"],
Cell[7362576, 146103, 318, 7, 26, "Print"],
Cell[7362897, 146112, 281, 6, 23, "Print"],
Cell[7363181, 146120, 411, 9, 23, "Print"],
Cell[7363595, 146131, 399, 8, 20, "Print"],
Cell[7363997, 146141, 136, 2, 20, "Print"],
Cell[7364136, 146145, 191, 3, 20, "Print"],
Cell[7364330, 146150, 262, 6, 20, "Print"],
Cell[7364595, 146158, 812, 20, 20, "Print"],
Cell[7365410, 146180, 816, 20, 20, "Print"],
Cell[7366229, 146202, 816, 20, 20, "Print"],
Cell[7367048, 146224, 812, 20, 20, "Print"],
Cell[7367863, 146246, 816, 20, 20, "Print"],
Cell[7368682, 146268, 815, 20, 20, "Print"],
Cell[7369500, 146290, 818, 20, 20, "Print"],
Cell[7370321, 146312, 816, 20, 20, "Print"],
Cell[7371140, 146334, 431, 12, 20, "Print"],
Cell[7371574, 146348, 427, 12, 20, "Print"],
Cell[7372004, 146362, 522, 14, 23, "Print"],
Cell[7372529, 146378, 124, 2, 20, "Print"],
Cell[7372656, 146382, 1817, 54, 36, "Print"],
Cell[7374476, 146438, 122, 2, 20, "Print"],
Cell[7374601, 146442, 1329, 38, 36, "Print"],
Cell[7375933, 146482, 320, 7, 26, "Print"],
Cell[7376256, 146491, 287, 7, 23, "Print"],
Cell[7376546, 146500, 409, 9, 23, "Print"],
Cell[7376958, 146511, 397, 8, 20, "Print"],
Cell[7377358, 146521, 136, 2, 20, "Print"],
Cell[7377497, 146525, 191, 3, 20, "Print"],
Cell[7377691, 146530, 262, 6, 20, "Print"],
Cell[7377956, 146538, 820, 20, 20, "Print"],
Cell[7378779, 146560, 816, 20, 20, "Print"],
Cell[7379598, 146582, 820, 20, 20, "Print"],
Cell[7380421, 146604, 819, 20, 20, "Print"],
Cell[7381243, 146626, 822, 20, 20, "Print"],
Cell[7382068, 146648, 822, 20, 20, "Print"],
Cell[7382893, 146670, 820, 20, 20, "Print"],
Cell[7383716, 146692, 816, 20, 20, "Print"],
Cell[7384535, 146714, 427, 12, 20, "Print"],
Cell[7384965, 146728, 431, 12, 20, "Print"],
Cell[7385399, 146742, 524, 14, 23, "Print"],
Cell[7385926, 146758, 124, 2, 20, "Print"],
Cell[7386053, 146762, 1816, 54, 36, "Print"],
Cell[7387872, 146818, 122, 2, 20, "Print"],
Cell[7387997, 146822, 1329, 38, 36, "Print"],
Cell[7389329, 146862, 318, 7, 26, "Print"],
Cell[7389650, 146871, 285, 7, 23, "Print"],
Cell[7389938, 146880, 397, 8, 20, "Print"],
Cell[7390338, 146890, 136, 2, 20, "Print"],
Cell[7390477, 146894, 191, 3, 20, "Print"],
Cell[7390671, 146899, 262, 6, 20, "Print"],
Cell[7390936, 146907, 812, 20, 20, "Print"],
Cell[7391751, 146929, 816, 20, 20, "Print"],
Cell[7392570, 146951, 812, 20, 20, "Print"],
Cell[7393385, 146973, 816, 20, 20, "Print"],
Cell[7394204, 146995, 814, 20, 20, "Print"],
Cell[7395021, 147017, 816, 20, 20, "Print"],
Cell[7395840, 147039, 812, 20, 20, "Print"],
Cell[7396655, 147061, 816, 20, 20, "Print"],
Cell[7397474, 147083, 816, 20, 20, "Print"],
Cell[7398293, 147105, 431, 12, 20, "Print"],
Cell[7398727, 147119, 427, 12, 20, "Print"],
Cell[7399157, 147133, 525, 14, 23, "Print"],
Cell[7399685, 147149, 121, 2, 20, "Print"],
Cell[7399809, 147153, 1816, 54, 36, "Print"],
Cell[7401628, 147209, 122, 2, 20, "Print"],
Cell[7401753, 147213, 1329, 38, 36, "Print"],
Cell[7403085, 147253, 318, 7, 26, "Print"],
Cell[7403406, 147262, 281, 6, 23, "Print"],
Cell[7403690, 147270, 406, 9, 23, "Print"],
Cell[7404099, 147281, 397, 8, 20, "Print"],
Cell[7404499, 147291, 138, 2, 20, "Print"],
Cell[7404640, 147295, 189, 3, 20, "Print"],
Cell[7404832, 147300, 264, 6, 20, "Print"],
Cell[7405099, 147308, 822, 20, 20, "Print"],
Cell[7405924, 147330, 820, 20, 20, "Print"],
Cell[7406747, 147352, 820, 20, 20, "Print"],
Cell[7407570, 147374, 820, 20, 20, "Print"],
Cell[7408393, 147396, 820, 20, 20, "Print"],
Cell[7409216, 147418, 820, 20, 20, "Print"],
Cell[7410039, 147440, 820, 20, 20, "Print"],
Cell[7410862, 147462, 816, 20, 20, "Print"],
Cell[7411681, 147484, 816, 20, 20, "Print"],
Cell[7412500, 147506, 824, 20, 20, "Print"],
Cell[7413327, 147528, 431, 12, 20, "Print"],
Cell[7413761, 147542, 433, 12, 20, "Print"],
Cell[7414197, 147556, 528, 14, 23, "Print"],
Cell[7414728, 147572, 122, 2, 20, "Print"],
Cell[7414853, 147576, 1819, 54, 36, "Print"],
Cell[7416675, 147632, 122, 2, 20, "Print"],
Cell[7416800, 147636, 1327, 38, 36, "Print"],
Cell[7418130, 147676, 318, 7, 26, "Print"],
Cell[7418451, 147685, 279, 6, 23, "Print"],
Cell[7418733, 147693, 401, 9, 23, "Print"],
Cell[7419137, 147704, 397, 8, 20, "Print"],
Cell[7419537, 147714, 138, 2, 20, "Print"],
Cell[7419678, 147718, 189, 3, 20, "Print"],
Cell[7419870, 147723, 264, 6, 20, "Print"],
Cell[7420137, 147731, 815, 20, 20, "Print"],
Cell[7420955, 147753, 820, 20, 20, "Print"],
Cell[7421778, 147775, 820, 20, 20, "Print"],
Cell[7422601, 147797, 822, 20, 20, "Print"],
Cell[7423426, 147819, 820, 20, 20, "Print"],
Cell[7424249, 147841, 816, 20, 20, "Print"],
Cell[7425068, 147863, 820, 20, 20, "Print"],
Cell[7425891, 147885, 820, 20, 20, "Print"],
Cell[7426714, 147907, 816, 20, 20, "Print"],
Cell[7427533, 147929, 822, 20, 20, "Print"],
Cell[7428358, 147951, 431, 12, 20, "Print"],
Cell[7428792, 147965, 431, 12, 20, "Print"],
Cell[7429226, 147979, 522, 14, 23, "Print"],
Cell[7429751, 147995, 122, 2, 20, "Print"],
Cell[7429876, 147999, 1819, 54, 36, "Print"],
Cell[7431698, 148055, 124, 2, 20, "Print"],
Cell[7431825, 148059, 1329, 38, 36, "Print"],
Cell[7433157, 148099, 318, 7, 26, "Print"],
Cell[7433478, 148108, 281, 6, 23, "Print"],
Cell[7433762, 148116, 409, 9, 23, "Print"],
Cell[7434174, 148127, 397, 8, 20, "Print"],
Cell[7434574, 148137, 136, 2, 20, "Print"],
Cell[7434713, 148141, 191, 3, 20, "Print"],
Cell[7434907, 148146, 262, 6, 20, "Print"],
Cell[7435172, 148154, 820, 20, 20, "Print"],
Cell[7435995, 148176, 820, 20, 20, "Print"],
Cell[7436818, 148198, 820, 20, 20, "Print"],
Cell[7437641, 148220, 818, 20, 20, "Print"],
Cell[7438462, 148242, 820, 20, 20, "Print"],
Cell[7439285, 148264, 820, 20, 20, "Print"],
Cell[7440108, 148286, 820, 20, 20, "Print"],
Cell[7440931, 148308, 819, 20, 20, "Print"],
Cell[7441753, 148330, 819, 20, 20, "Print"],
Cell[7442575, 148352, 822, 20, 20, "Print"],
Cell[7443400, 148374, 433, 12, 20, "Print"],
Cell[7443836, 148388, 431, 12, 20, "Print"],
Cell[7444270, 148402, 526, 14, 23, "Print"],
Cell[7444799, 148418, 122, 2, 20, "Print"],
Cell[7444924, 148422, 1816, 54, 36, "Print"],
Cell[7446743, 148478, 122, 2, 20, "Print"],
Cell[7446868, 148482, 1329, 38, 36, "Print"],
Cell[7448200, 148522, 318, 7, 26, "Print"],
Cell[7448521, 148531, 279, 6, 23, "Print"],
Cell[7448803, 148539, 397, 8, 20, "Print"],
Cell[7449203, 148549, 138, 2, 20, "Print"],
Cell[7449344, 148553, 189, 3, 20, "Print"],
Cell[7449536, 148558, 264, 6, 20, "Print"],
Cell[7449803, 148566, 820, 20, 20, "Print"],
Cell[7450626, 148588, 820, 20, 20, "Print"],
Cell[7451449, 148610, 820, 20, 20, "Print"],
Cell[7452272, 148632, 820, 20, 20, "Print"],
Cell[7453095, 148654, 820, 20, 20, "Print"],
Cell[7453918, 148676, 818, 20, 20, "Print"],
Cell[7454739, 148698, 820, 20, 20, "Print"],
Cell[7455562, 148720, 822, 20, 20, "Print"],
Cell[7456387, 148742, 822, 20, 20, "Print"],
Cell[7457212, 148764, 822, 20, 20, "Print"],
Cell[7458037, 148786, 822, 20, 20, "Print"],
Cell[7458862, 148808, 431, 12, 20, "Print"],
Cell[7459296, 148822, 431, 12, 20, "Print"],
Cell[7459730, 148836, 522, 14, 23, "Print"],
Cell[7460255, 148852, 122, 2, 20, "Print"],
Cell[7460380, 148856, 1821, 54, 36, "Print"],
Cell[7462204, 148912, 122, 2, 20, "Print"],
Cell[7462329, 148916, 1327, 38, 36, "Print"],
Cell[7463659, 148956, 318, 7, 26, "Print"],
Cell[7463980, 148965, 275, 6, 20, "Print"],
Cell[7464258, 148973, 392, 8, 23, "Print"],
Cell[7464653, 148983, 406, 9, 23, "Print"],
Cell[7465062, 148994, 136, 2, 20, "Print"],
Cell[7465201, 148998, 356, 7, 20, "Print"],
Cell[7465560, 149007, 1129, 31, 40, "Print"],
Cell[7466692, 149040, 122, 2, 20, "Print"],
Cell[7466817, 149044, 1412, 40, 40, "Print"],
Cell[7468232, 149086, 2402, 53, 318, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[7470683, 149145, 331, 11, 50, "Input"],
Cell[7471017, 149158, 1237, 30, 59, "Output"]
}, Open  ]],
Cell[7472269, 149191, 102, 1, 27, "Input"],
Cell[CellGroupData[{
Cell[7472396, 149196, 1893, 49, 88, "Input"],
Cell[CellGroupData[{
Cell[7474314, 149249, 642, 12, 20, "Print"],
Cell[7474959, 149263, 538, 8, 20, "Print"],
Cell[7475500, 149273, 523, 9, 20, "Print"],
Cell[7476026, 149284, 570, 9, 20, "Print"],
Cell[7476599, 149295, 570, 9, 20, "Print"],
Cell[7477172, 149306, 570, 9, 20, "Print"],
Cell[7477745, 149317, 521, 8, 20, "Print"],
Cell[7478269, 149327, 511, 8, 20, "Print"],
Cell[7478783, 149337, 570, 9, 20, "Print"],
Cell[7479356, 149348, 1885, 51, 38, "Print"],
Cell[7481244, 149401, 506, 8, 20, "Print"],
Cell[7481753, 149411, 1751, 45, 42, "Print"],
Cell[7483507, 149458, 506, 8, 20, "Print"],
Cell[7484016, 149468, 1905, 51, 42, "Print"],
Cell[7485924, 149521, 506, 8, 20, "Print"],
Cell[7486433, 149531, 517, 8, 20, "Print"]
}, Open  ]],
Cell[7486965, 149542, 1006, 17, 23, "Message"],
Cell[CellGroupData[{
Cell[7487996, 149563, 687, 15, 20, "Print"],
Cell[7488686, 149580, 506, 8, 20, "Print"],
Cell[7489195, 149590, 570, 9, 20, "Print"],
Cell[7489768, 149601, 505, 8, 20, "Print"],
Cell[7490276, 149611, 677, 13, 20, "Print"],
Cell[7490956, 149626, 702, 13, 26, "Print"],
Cell[7491661, 149641, 646, 13, 20, "Print"],
Cell[7492310, 149656, 575, 9, 20, "Print"],
Cell[7492888, 149667, 646, 12, 20, "Print"],
Cell[7493537, 149681, 819, 18, 20, "Print"],
Cell[7494359, 149701, 817, 18, 20, "Print"],
Cell[7495179, 149721, 833, 18, 20, "Print"],
Cell[7496015, 149741, 506, 8, 20, "Print"],
Cell[7496524, 149751, 2211, 60, 36, "Print"],
Cell[7498738, 149813, 505, 8, 20, "Print"],
Cell[7499246, 149823, 1690, 44, 36, "Print"],
Cell[7500939, 149869, 701, 13, 26, "Print"],
Cell[7501643, 149884, 671, 13, 23, "Print"],
Cell[7502317, 149899, 774, 14, 20, "Print"],
Cell[7503094, 149915, 784, 14, 20, "Print"],
Cell[7503881, 149931, 575, 9, 20, "Print"],
Cell[7504459, 149942, 646, 12, 20, "Print"],
Cell[7505108, 149956, 819, 18, 20, "Print"],
Cell[7505930, 149976, 819, 18, 20, "Print"],
Cell[7506752, 149996, 906, 20, 23, "Print"],
Cell[7507661, 150018, 506, 8, 20, "Print"],
Cell[7508170, 150028, 2237, 60, 36, "Print"],
Cell[7510410, 150090, 508, 8, 20, "Print"],
Cell[7510921, 150100, 1713, 44, 36, "Print"],
Cell[7512637, 150146, 704, 13, 26, "Print"],
Cell[7513344, 150161, 668, 13, 23, "Print"],
Cell[7514015, 150176, 768, 14, 20, "Print"],
Cell[7514786, 150192, 792, 15, 20, "Print"],
Cell[7515581, 150209, 519, 8, 20, "Print"],
Cell[7516103, 150219, 573, 9, 20, "Print"],
Cell[7516679, 150230, 644, 12, 20, "Print"],
Cell[7517326, 150244, 819, 18, 20, "Print"],
Cell[7518148, 150264, 819, 18, 20, "Print"],
Cell[7518970, 150284, 909, 20, 23, "Print"],
Cell[7519882, 150306, 506, 8, 20, "Print"],
Cell[7520391, 150316, 2217, 60, 36, "Print"],
Cell[7522611, 150378, 506, 8, 20, "Print"],
Cell[7523120, 150388, 1715, 44, 36, "Print"],
Cell[7524838, 150434, 702, 13, 26, "Print"],
Cell[7525543, 150449, 668, 13, 23, "Print"],
Cell[7526214, 150464, 780, 14, 23, "Print"],
Cell[7526997, 150480, 793, 15, 23, "Print"],
Cell[7527793, 150497, 519, 8, 20, "Print"],
Cell[7528315, 150507, 522, 8, 20, "Print"],
Cell[7528840, 150517, 520, 8, 20, "Print"],
Cell[7529363, 150527, 738, 13, 20, "Print"],
Cell[7530104, 150542, 1491, 36, 40, "Print"],
Cell[7531598, 150580, 508, 8, 20, "Print"],
Cell[7532109, 150590, 1713, 44, 36, "Print"],
Cell[7533825, 150636, 1911, 48, 82, "Print"],
Cell[7535739, 150686, 685, 13, 26, "Print"],
Cell[7536427, 150701, 566, 9, 20, "Print"],
Cell[7536996, 150712, 551, 8, 20, "Print"],
Cell[7537550, 150722, 564, 9, 20, "Print"],
Cell[7538117, 150733, 2025, 48, 40, "Print"],
Cell[7540145, 150783, 562, 9, 20, "Print"],
Cell[7540710, 150794, 516, 8, 20, "Print"],
Cell[7541229, 150804, 564, 9, 20, "Print"],
Cell[7541796, 150815, 1687, 42, 42, "Print"],
Cell[7543486, 150859, 564, 9, 20, "Print"],
Cell[7544053, 150870, 537, 8, 20, "Print"],
Cell[7544593, 150880, 562, 9, 20, "Print"],
Cell[7545158, 150891, 562, 9, 20, "Print"],
Cell[7545723, 150902, 696, 13, 20, "Print"],
Cell[7546422, 150917, 1665, 41, 42, "Print"],
Cell[7548090, 150960, 563, 9, 20, "Print"],
Cell[7548656, 150971, 547, 8, 20, "Print"],
Cell[7549206, 150981, 563, 9, 20, "Print"],
Cell[7549772, 150992, 1383, 33, 36, "Print"],
Cell[7551158, 151027, 566, 9, 20, "Print"],
Cell[7551727, 151038, 568, 9, 22, "Print"],
Cell[7552298, 151049, 564, 9, 20, "Print"],
Cell[7552865, 151060, 1399, 33, 36, "Print"],
Cell[7554267, 151095, 506, 8, 20, "Print"],
Cell[7554776, 151105, 539, 9, 20, "Print"],
Cell[7555318, 151116, 564, 9, 20, "Print"],
Cell[7555885, 151127, 579, 9, 22, "Print"],
Cell[7556467, 151138, 564, 9, 20, "Print"],
Cell[7557034, 151149, 1399, 33, 36, "Print"],
Cell[7558436, 151184, 508, 8, 20, "Print"],
Cell[7558947, 151194, 541, 9, 20, "Print"],
Cell[7559491, 151205, 564, 9, 20, "Print"],
Cell[7560058, 151216, 529, 8, 20, "Print"],
Cell[7560590, 151226, 563, 9, 20, "Print"],
Cell[7561156, 151237, 704, 13, 20, "Print"],
Cell[7561863, 151252, 582, 9, 20, "Print"],
Cell[7562448, 151263, 1952, 51, 56, "Print"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[7564449, 151320, 331, 11, 50, "Input"],
Cell[7564783, 151333, 1298, 31, 59, "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]]
}
]
*)

(* End of internal cache information *)
