(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     42751,       1171]
NotebookOptionsPosition[     37913,       1011]
NotebookOutlinePosition[     39595,       1063]
CellTagsIndexPosition[     39299,       1053]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"??", "Shape"}]], "Input",
 CellChangeTimes->{{3.460630177612606*^9, 3.460630180271325*^9}}],

Cell[BoxData[
 StyleBox["\<\"Shape[A_,p_], Umformen auf Dimension p ={p1,p2,....}\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.46063018051042*^9},
 CellTags->"Info3460637380-4560556"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Partition", "[", 
  RowBox[{
   RowBox[{"12", "//", "Range"}], ",", "3"}], "]"}]], "Input",
 CellChangeTimes->{{3.4606412496521873`*^9, 3.460641289247788*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "5", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "8", ",", "9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10", ",", "11", ",", "12"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.4606412597395277`*^9, 3.460641289847715*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Partition", "[", 
  RowBox[{
   RowBox[{"10", "//", "Range"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.460630255143997*^9, 3.460630304449274*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Partition", "::", "\<\"pdep\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Depth \\\\\\\"\\\", \\\"MT\\\
\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(2\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" requested in object \
with dimensions \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\({10}\\), \\\"MT\\\"]\\)\
\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\".\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/Partition\\\", ButtonNote -> \\\
\"Partition::pdep\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.4606302973670483`*^9, 3.4606303045686903`*^9}}],

Cell[BoxData[
 RowBox[{"Partition", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7", ",", "8",
      ",", "9", ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "2"}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{{3.460630297368017*^9, 3.460630304571652*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"x", "=", 
  RowBox[{"RandomReal", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
    RowBox[{"{", "100", "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"y", "=", 
  RowBox[{"RandomReal", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
    RowBox[{"{", "100", "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.460631056314672*^9, 3.460631144784725*^9}, {
  3.460631208811984*^9, 3.4606312101135693`*^9}, {3.4606312924263983`*^9, 
  3.460631292801738*^9}, {3.460631805988291*^9, 3.4606318223903933`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.01113799782749414`", ",", 
   RowBox[{"-", "0.565541958489522`"}], ",", 
   RowBox[{"-", "0.38009758238593694`"}], ",", 
   RowBox[{"-", "0.6394357320966759`"}], ",", 
   RowBox[{"-", "0.6996468715493327`"}], ",", "0.10413534643579547`", ",", 
   "0.07390698829471454`", ",", 
   RowBox[{"-", "0.9555418591381009`"}], ",", "0.6801719693394253`", ",", 
   "0.13914224753043358`", ",", 
   RowBox[{"-", "0.7440211430807704`"}], ",", 
   RowBox[{"-", "0.9788330091762121`"}], ",", 
   RowBox[{"-", "0.332634573140151`"}], ",", 
   RowBox[{"-", "0.47775651526568375`"}], ",", "0.5368780381025213`", ",", 
   RowBox[{"-", "0.3629703964053639`"}], ",", "0.839656093184705`", ",", 
   RowBox[{"-", "0.25208887651483236`"}], ",", "0.5103450534649983`", ",", 
   "0.5327097580506388`", ",", "0.818107867082591`", ",", 
   RowBox[{"-", "0.5036343676803079`"}], ",", 
   RowBox[{"-", "0.42698296998207663`"}], ",", "0.6426143504135875`", ",", 
   RowBox[{"-", "0.0397837284508733`"}], ",", "0.9885131777189287`", ",", 
   RowBox[{"-", "0.006522299176783708`"}], ",", "0.2837517316838989`", ",", 
   "0.054622049188480126`", ",", 
   RowBox[{"-", "0.9534245298819499`"}], ",", 
   RowBox[{"-", "0.8119681325826074`"}], ",", "0.35025616157026906`", ",", 
   RowBox[{"-", "0.8560547626012709`"}], ",", "0.4773155548477499`", ",", 
   RowBox[{"-", "0.04747269049595326`"}], ",", 
   RowBox[{"-", "0.4873921876576688`"}], ",", "0.5099022801567061`", ",", 
   RowBox[{"-", "0.14712560898986649`"}], ",", 
   RowBox[{"-", "0.7079011461522056`"}], ",", "0.8092357870512141`", ",", 
   RowBox[{"-", "0.20708631283668133`"}], ",", 
   RowBox[{"-", "0.7242593500239294`"}], ",", 
   RowBox[{"-", "0.3955966418942731`"}], ",", 
   RowBox[{"-", "0.8854734921243312`"}], ",", 
   RowBox[{"-", "0.91012572448596`"}], ",", 
   RowBox[{"-", "0.5720922935303161`"}], ",", "0.9733511807907052`", ",", 
   "0.57141873241362`", ",", "0.13210851321550932`", ",", 
   RowBox[{"-", "0.8102869334504397`"}], ",", 
   RowBox[{"-", "0.30868860678635635`"}], ",", 
   RowBox[{"-", "0.6807863785449748`"}], ",", "0.06435564608375177`", ",", 
   "0.13391104689896993`", ",", 
   RowBox[{"-", "0.571520503281354`"}], ",", "0.8410658660728498`", ",", 
   RowBox[{"-", "0.5780108571528473`"}], ",", 
   RowBox[{"-", "0.29753822278385655`"}], ",", 
   RowBox[{"-", "0.9532742520112003`"}], ",", "0.9280957138922705`", ",", 
   RowBox[{"-", "0.19034131228310258`"}], ",", 
   RowBox[{"-", "0.44245392970199005`"}], ",", "0.7879421114278164`", ",", 
   "0.4783978289216626`", ",", 
   RowBox[{"-", "0.6551994414374582`"}], ",", "0.8242512985153878`", ",", 
   RowBox[{"-", "0.5412399355891675`"}], ",", "0.9082936441394414`", ",", 
   "0.2717007310766637`", ",", "0.782952606605305`", ",", 
   "0.20348087411035243`", ",", 
   RowBox[{"-", "0.11232030005359217`"}], ",", "0.9686722290550365`", ",", 
   RowBox[{"-", "0.4873884578395211`"}], ",", 
   RowBox[{"-", "0.27577797896976897`"}], ",", "0.7275066222597522`", ",", 
   "0.04845661868351314`", ",", "0.47836063517443606`", ",", 
   RowBox[{"-", "0.4540640269543288`"}], ",", "0.2803878687539707`", ",", 
   RowBox[{"-", "0.7716791418970179`"}], ",", 
   RowBox[{"-", "0.31141048756697876`"}], ",", 
   RowBox[{"-", "0.23311411129134108`"}], ",", "0.05227402518940716`", ",", 
   "0.7625306237484053`", ",", 
   RowBox[{"-", "0.02336908901275514`"}], ",", 
   RowBox[{"-", "0.23625307162824027`"}], ",", 
   RowBox[{"-", "0.40169799162230335`"}], ",", 
   RowBox[{"-", "0.5512789953942665`"}], ",", "0.52032775448474`", ",", 
   "0.22679582595170045`", ",", "0.5344829040755075`", ",", 
   RowBox[{"-", "0.1016749820978764`"}], ",", 
   RowBox[{"-", "0.7453830521180089`"}], ",", 
   RowBox[{"-", "0.2832609245240123`"}], ",", "0.18339326757315755`", ",", 
   "0.18143975317893046`", ",", "0.243280712090034`", ",", 
   RowBox[{"-", "0.4635159171027077`"}], ",", 
   RowBox[{"-", "0.7535825961137186`"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.4606310707172947`*^9, 3.46063110251315*^9, {3.460631134833214*^9, 
   3.460631145246532*^9}, 3.46063121024867*^9, 3.46063129322735*^9, {
   3.460631808330707*^9, 3.460631822806211*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "0.48742443749299147`"}], ",", "0.25403444256522034`", ",", 
   "0.008278503481033539`", ",", 
   RowBox[{"-", "0.9031462581968954`"}], ",", "0.8502621143959668`", ",", 
   RowBox[{"-", "0.06027869554138965`"}], ",", 
   RowBox[{"-", "0.1772259991341847`"}], ",", "0.1608441513784693`", ",", 
   RowBox[{"-", "0.4938862238584356`"}], ",", "0.7727101754983519`", ",", 
   RowBox[{"-", "0.16452687846316527`"}], ",", 
   RowBox[{"-", "0.8415558296837076`"}], ",", "0.1271807159586409`", ",", 
   "0.05239252197947675`", ",", 
   RowBox[{"-", "0.4730218202357044`"}], ",", "0.1470230099115164`", ",", 
   "0.6103684666707574`", ",", 
   RowBox[{"-", "0.6916537758659302`"}], ",", "0.7379554723432915`", ",", 
   "0.5546012172725758`", ",", 
   RowBox[{"-", "0.913659646684378`"}], ",", 
   RowBox[{"-", "0.01827597367810352`"}], ",", 
   RowBox[{"-", "0.6369886107127054`"}], ",", 
   RowBox[{"-", "0.25700276094404817`"}], ",", 
   RowBox[{"-", "0.21987653773079074`"}], ",", "0.4598103161632525`", ",", 
   "0.9580951186456876`", ",", "0.01741308689854515`", ",", 
   RowBox[{"-", "0.43125235801843065`"}], ",", "0.10241087307761632`", ",", 
   RowBox[{"-", "0.019631900483498832`"}], ",", "0.8558876565856357`", ",", 
   RowBox[{"-", "0.33081529684080735`"}], ",", 
   RowBox[{"-", "0.7769911402582221`"}], ",", 
   RowBox[{"-", "0.4778004791566448`"}], ",", 
   RowBox[{"-", "0.853948639926557`"}], ",", "0.7893620501666021`", ",", 
   "0.7312027400457728`", ",", "0.5620660583887709`", ",", 
   RowBox[{"-", "0.6809462515247007`"}], ",", 
   RowBox[{"-", "0.3338651371435408`"}], ",", "0.4729801411999581`", ",", 
   RowBox[{"-", "0.34826122866234144`"}], ",", 
   RowBox[{"-", "0.615980864128173`"}], ",", "0.8127736984998264`", ",", 
   "0.22056116547352467`", ",", "0.554614152999664`", ",", 
   "0.6347435796528993`", ",", 
   RowBox[{"-", "0.11578367220498587`"}], ",", 
   RowBox[{"-", "0.5268428241657954`"}], ",", 
   RowBox[{"-", "0.20849539879996515`"}], ",", 
   RowBox[{"-", "0.18082165702023545`"}], ",", "0.5705223936542101`", ",", 
   RowBox[{"-", "0.42795786887878506`"}], ",", 
   RowBox[{"-", "0.6655072734873855`"}], ",", "0.6741309468071339`", ",", 
   RowBox[{"-", "0.6276882582575278`"}], ",", 
   RowBox[{"-", "0.7499293169092729`"}], ",", "0.028528079397886152`", ",", 
   RowBox[{"-", "0.008546423128275471`"}], ",", "0.7822678109638832`", ",", 
   "0.6777455725991448`", ",", "0.0011745986437565747`", ",", 
   RowBox[{"-", "0.8771794998823421`"}], ",", 
   RowBox[{"-", "0.44279568647426926`"}], ",", 
   RowBox[{"-", "0.9008463302821741`"}], ",", 
   RowBox[{"-", "0.49109027194623955`"}], ",", "0.6751573134906024`", ",", 
   "0.5635230616741738`", ",", 
   RowBox[{"-", "0.8875055699696022`"}], ",", "0.488616790064921`", ",", 
   "0.05107662863071516`", ",", "0.1552465646920207`", ",", 
   RowBox[{"-", "0.7561203771966625`"}], ",", 
   RowBox[{"-", "0.14763899877195286`"}], ",", 
   RowBox[{"-", "0.6749297110639629`"}], ",", 
   RowBox[{"-", "0.8977830868438832`"}], ",", 
   RowBox[{"-", "0.11044378980493219`"}], ",", "0.9956232939906688`", ",", 
   RowBox[{"-", "0.1487374114299711`"}], ",", 
   RowBox[{"-", "0.9809638945383923`"}], ",", 
   RowBox[{"-", "0.6262796036333875`"}], ",", 
   RowBox[{"-", "0.48172445529951924`"}], ",", 
   RowBox[{"-", "0.8881319186968075`"}], ",", 
   RowBox[{"-", "0.19702326385010016`"}], ",", 
   RowBox[{"-", "0.07875058500695298`"}], ",", 
   RowBox[{"-", "0.9516755443585558`"}], ",", 
   RowBox[{"-", "0.4498227448010126`"}], ",", "0.4993058827346868`", ",", 
   "0.8927853572125648`", ",", "0.7955974036291358`", ",", 
   "0.7841774552491185`", ",", "0.19428024814519818`", ",", 
   "0.44610511005817255`", ",", "0.9177617942922844`", ",", 
   "0.5300856306182484`", ",", 
   RowBox[{"-", "0.000568076449361854`"}], ",", 
   RowBox[{"-", "0.32299806492998906`"}], ",", 
   RowBox[{"-", "0.19883228239356576`"}], ",", "0.19709973549203053`"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.4606310707172947`*^9, 3.46063110251315*^9, {3.460631134833214*^9, 
   3.460631145246532*^9}, 3.46063121024867*^9, 3.46063129322735*^9, {
   3.460631808330707*^9, 3.4606318228140163`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ListCorrelate", "[", 
   RowBox[{"x", ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"0", "x"}]}], "}"}], "//", "Flatten"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], "]"}], "//", "plot1"}]], "Input",
 CellChangeTimes->{{3.460631147960512*^9, 3.460631157488536*^9}, {
   3.4606312813623533`*^9, 3.460631302969204*^9}, 3.460631336097374*^9, {
   3.460631782076461*^9, 3.460631799106409*^9}, {3.460631833606798*^9, 
   3.46063187608995*^9}, {3.460631936011243*^9, 3.460631980355503*^9}, {
   3.4606320283971577`*^9, 3.4606320794618263`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[0, 0, 1], PointSize[0.003], Thickness[0.003], Dashing[{}], {}, 
    {Opacity[1], LineBox[CompressedData["
1:eJw1VAlQlGUYXjlW7haBUIa4AwwiCEWMBR7kWhBhD1iWgBpzOKdEiThcyPVC
ygIKCRVynKRycFJAcYAJ2ilkGKJAuQlWaAKWY2C5l1Kmmn3/nfnnn2ee7zne
9/tn7d/LEqZosVislP+e/9/MLy/GgWfNBjRIFVjiMpriPbDyE9FI5RUuVBqw
iNfDeq9iUd49SjwH7bNmB9j7jeQabA51bkX2Nzv9xO+FTbLUeMyeQ3priEb3
WWWcYbAd2hYqXEYvmxB2gJ1DodJxaJP0ThB33Q/74VIHYWfsmMQcH2wyoDxX
dK1sft7o+GegBr8GZ8fVJL+FEcLusLP13S5t7yO9B3Skg72vxjH+ngjwrx9y
jd8h7IUvHY2efiudIf2b4M9yTQ9Z2FOeN75fMR7XbVATfwDRLc3nipXa1P8g
vi4Wf/FGmDad98GJ9OQ72VZaxB+Cyu7xrvk0po8vnijq+9fOm9L5w3AwYtU7
JhkTfgsPzMxjkx4zff2g1fe0butTXeK5YA/FlST165G/P4zuVH9wUX+d+gVg
sKRX5x3tZ4QDIWvd7dzre4UwYORjOXlSd0GDZUB1vjRJ15BD/kFAuk7O3eu0
f1kQAizNkhPNmH5HMKUoj7hnsEuTLzuCBzcc67zYz8k/GGIO71Lz0hb5ByNo
4MJHTnnMPkKwNH31rEClJv8QpP/S+FtZVg/pQ5G6u76l+srfpA+FXep8t89D
ymOFwf7m6bLSah3KD8PheckjD2vmew3HkA1XHn1vm/zDoccfHvrkzA758zDJ
qbodUz9GPA/5nJV8F1dj0keg2+X92vBxxj8C4benllJi9YmPxMCNoDX/dKZ/
JNolbQflz2ifrKOouvxCmsf+g/ofxfWCihwWZ53uMwrb1mr3Dv014qPQmMBb
CB1j7usYRC5nrzUWTZH/MQQEezqH8/8iPho1Ia1si3H6HmTRuLUoqotYvUD+
MVCG20y0ddF9yWIwEqqWcr9qIT0fzdpviz7LmNRg8FGT6JGQVcyi83z47hNy
f+xTavzkfMT4aTUUfScnvQAvlRVk5YXQ9w4BluaUv0c8mad5BHDe1lrZ/yvN
JxfglsHdwpti4llCwO3a/Fb6tMYfQpQ3ZyrVG8s0rxA5m6uGqRnkLxeCq6eY
TDNh5hdhQm56cvKfReovQu2I6VzVqQ3KF+GUtNxyUNpE+SKozUfO591X0X5i
YVOYrZLt2aD8WKiufuweWDlF+lggz/Dd5SKaVx6LEO91dlqigvLjIJt5HjoX
VEn5cXAyDhMI98xQ/zg4KJJO29ZNkz4OneLeFokWoxdjr/2cHufnftKL4TYx
WNuYO0v5Yly0ynYoyeym/Ysx1eBn0VEwTPp4mFSdaPAfXiZ9PNxeyTQ8/oj+
f2XxUAlKW6OUTaSPR2Rj58Oe15n9SZBcaPuyVzNz/xLwFJ1tVrXM/BLkfuhR
82JljPpLwNrgB5V5nqP9JUDz7uH+C3kZ2GY=
      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->True,
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{
  3.460631158252931*^9, 3.4606312136711493`*^9, {3.460631284767465*^9, 
   3.4606313040273457`*^9}, 3.460631337009674*^9, {3.46063178242293*^9, 
   3.460631876711355*^9}, {3.460631936851283*^9, 3.460631981521653*^9}, 
   3.4606320298638897`*^9, 3.4606320804950743`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"ListCorrelate", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x1", ",", "x2", ",", "x3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x1", ",", "x2", ",", "x3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", "0"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"ListCorrelate", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x1", ",", "x2", ",", "x3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x1", ",", "x2", ",", "x3", ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.460631347052519*^9, 3.4606313750058327`*^9}, {
  3.4606314204155703`*^9, 3.460631442136932*^9}, {3.460631598337246*^9, 
  3.460631721373643*^9}, {3.4606321039921923`*^9, 3.460632122092287*^9}, {
  3.4606322371697693`*^9, 3.460632254432631*^9}, {3.460632298940624*^9, 
  3.4606323348270903`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SuperscriptBox["x1", "2"], "+", 
    SuperscriptBox["x2", "2"], "+", 
    SuperscriptBox["x3", "2"]}], ",", 
   RowBox[{
    RowBox[{"x1", " ", "x2"}], "+", 
    RowBox[{"x2", " ", "x3"}]}], ",", 
   RowBox[{"x1", " ", "x3"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.4606313632846813`*^9, 3.460631375136601*^9}, {
  3.4606314227679377`*^9, 3.4606314429401493`*^9}, {3.460631619518415*^9, 
  3.4606317229332952`*^9}, {3.460632107195513*^9, 3.460632123970209*^9}, {
  3.460632239143371*^9, 3.4606322552220917`*^9}, {3.460632307911139*^9, 
  3.460632336019582*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SuperscriptBox["x1", "2"], "+", 
    SuperscriptBox["x2", "2"], "+", 
    SuperscriptBox["x3", "2"]}], ",", 
   RowBox[{
    RowBox[{"x1", " ", "x2"}], "+", 
    RowBox[{"x2", " ", "x3"}]}], ",", 
   RowBox[{"x1", " ", "x3"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.4606313632846813`*^9, 3.460631375136601*^9}, {
  3.4606314227679377`*^9, 3.4606314429401493`*^9}, {3.460631619518415*^9, 
  3.4606317229332952`*^9}, {3.460632107195513*^9, 3.460632123970209*^9}, {
  3.460632239143371*^9, 3.4606322552220917`*^9}, {3.460632307911139*^9, 
  3.460632336021536*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", "Korrelation"}]], "Input",
 CellChangeTimes->{{3.460632340842067*^9, 3.460632375054995*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Information", "::", "\<\"notfound\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Symbol \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"Korrelation\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" not \
found.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/Information\\\", ButtonNote -> \
\\\"Information::notfound\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.460632355851288*^9, 3.4606323758219624`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", "Compress"}]], "Input",
 CellChangeTimes->{{3.460634494712618*^9, 3.4606344988448973`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  StyleBox["\<\"Compress[a_,b_] := Delete[b,Position[a,False]]\"\>", "MSG"], 
  "\[NonBreakingSpace]", 
  ButtonBox[
   StyleBox["\[RightSkeleton]", "SR"],
   Active->True,
   BaseStyle->"Link",
   ButtonData->"paclet:ref/Compress"]}]], "Print", "PrintUsage",
 CellChangeTimes->{3.460634499853941*^9},
 CellTags->"Info3460641699-3983420"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{
         RowBox[{"Compress", "[", 
          RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
         RowBox[{"Delete", "[", 
          RowBox[{"b", ",", 
           RowBox[{"Position", "[", 
            RowBox[{"a", ",", "False"}], "]"}]}], "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"Options", "[", "Compress", "]"}], "=", 
         RowBox[{"{", 
          RowBox[{"Method", "\[Rule]", 
           RowBox[{"{", "}"}]}], "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[Compress],
  Editable->False]], "Print",
 CellChangeTimes->{3.460634499892173*^9},
 CellTags->"Info3460641699-3983420"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", "APLCompress"}]], "Input",
 CellChangeTimes->{{3.4606345259531717`*^9, 3.460634530892467*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox["\<\"APLCompress[a_,b_] := Delete[b,Position[a,0]]\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.4606352832802143`*^9},
 CellTags->"Info3460642483-4615935"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "APLCompress", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"APLCompress", "[", 
          RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
         RowBox[{"Delete", "[", 
          RowBox[{"b", ",", 
           RowBox[{"Position", "[", 
            RowBox[{"a", ",", "0"}], "]"}]}], "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[Hermann`Kronecker`APLCompress],
  Editable->False]], "Print",
 CellChangeTimes->{3.460635283339411*^9},
 CellTags->"Info3460642483-4615935"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "TF1"}]], "Input",
 CellChangeTimes->{{3.460634542644519*^9, 3.460634543812048*^9}, {
  3.460634946641511*^9, 3.460634947670206*^9}, {3.460635021538267*^9, 
  3.460635028664338*^9}}],

Cell[CellGroupData[{

Cell["Global`TF1", "Print", "PrintUsage",
 CellChangeTimes->{3.4606350806431503`*^9},
 CellTags->"Info3460642280-9984658"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{"TF1", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"1", "\[Rule]", "True"}], ",", 
           RowBox[{"0", "\[Rule]", "False"}]}], "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`TF1],
  Editable->False]], "Print",
 CellChangeTimes->{3.460635080687913*^9},
 CellTags->"Info3460642280-9984658"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"APLCompress", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
   RowBox[{"x", "=", 
    RowBox[{"{", 
     RowBox[{"a", ",", 
      RowBox[{"{", 
       RowBox[{"b", ",", "gg"}], "}"}], ",", "c"}], "}"}]}]}], "]"}]], "Input",\

 CellChangeTimes->{{3.460634566235825*^9, 3.4606346156046247`*^9}, {
  3.460634707367311*^9, 3.460634707831552*^9}, {3.4606351197751904`*^9, 
  3.460635129118334*^9}, {3.46063529074512*^9, 3.460635291676423*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"a", ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "gg"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.460634567220915*^9, 3.460634616480023*^9}, 
   3.460634709109333*^9, 3.460635129315399*^9, 3.460635232613831*^9, {
   3.460635287308034*^9, 3.460635292831601*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Position", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"True", ",", "True", ",", "False"}], "}"}], ",", "True"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.46063463409046*^9, 3.460634654620488*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "1", "}"}], ",", 
   RowBox[{"{", "2", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.460634649304735*^9, 3.460634655245569*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", "TF1"}]], "Input",
 CellChangeTimes->{{3.4606351004588947`*^9, 3.460635102394786*^9}}],

Cell[CellGroupData[{

Cell["Global`TF1", "Print", "PrintUsage",
 CellChangeTimes->{3.460635102590714*^9},
 CellTags->"Info3460642302-4180231"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {GridBox[{
       {
        RowBox[{"TF1", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"1", "\[Rule]", "True"}], ",", 
           RowBox[{"0", "\[Rule]", "False"}]}], "}"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[$CellContext`TF1],
  Editable->False]], "Print",
 CellChangeTimes->{3.460635102636718*^9},
 CellTags->"Info3460642302-4180231"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"1", "/.", "TF1"}]], "Input",
 CellChangeTimes->{{3.4606350382563057`*^9, 3.46063504735063*^9}, {
  3.460635091077313*^9, 3.4606351110744*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.460635047461195*^9, {3.460635085918888*^9, 3.460635111379746*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Extract", "[", 
  RowBox[{"x", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.460634670553892*^9, 3.460634737593214*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Extract", "::", "\<\"partd\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Part specification \
\\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\({1, 2}\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is longer than depth \
of object.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/Extract\\\", ButtonNote -> \
\\\"Extract::partd\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.460634737907042*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Extract", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", 
     RowBox[{"{", 
      RowBox[{"b", ",", "gg"}], "}"}], ",", "c"}], "}"}], ",", 
   RowBox[{"Position", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", "1"}], "]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{"a", ",", 
    RowBox[{"{", 
     RowBox[{"b", ",", "gg"}], "}"}], ",", "c"}], "}"}], "[", 
  RowBox[{"[", 
   RowBox[{
    RowBox[{"Position", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", "1"}], "]"}], "//", 
    "Flatten"}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.4606347567341537`*^9, 3.460634800377021*^9}, {
  3.4606411491281567`*^9, 3.460641176277166*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"a", ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "gg"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.4606347759792957`*^9, 3.460634800453903*^9}, {
  3.460641164184064*^9, 3.4606411772507563`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"a", ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "gg"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.4606347759792957`*^9, 3.460634800453903*^9}, {
  3.460641164184064*^9, 3.460641177253927*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"<<", "Kronecker.m"}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.460635007117434*^9, 3.460635013862816*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Set", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Correlation\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Options[Correlation]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/Set\\\", ButtonNote -> \
\\\"Set::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.460635016659953*^9, 3.46063507529072*^9, 
  3.4606352275927963`*^9, 3.460635277912477*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDelayed", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(KroneckerProduct\\), \\\"MT\\\
\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(KroneckerProduct[\\(\\(a_, b_\
\\)\\)]\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/SetDelayed\\\", ButtonNote -> \
\\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.460635016659953*^9, 3.46063507529072*^9, 
  3.4606352275927963`*^9, 3.460635277930738*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDelayed", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Correlation\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Correlation[y_]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/SetDelayed\\\", ButtonNote -> \
\\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.460635016659953*^9, 3.46063507529072*^9, 
  3.4606352275927963`*^9, 3.46063527795969*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDelayed", "::", "\<\"write\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Tag \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Correlation\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Correlation[\\(\\(x_, y_, \\(\
\\(scatter_ : 0\\)\\), opts___\\)\\)]\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" is \
Protected.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/SetDelayed\\\", ButtonNote -> \
\\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.460635016659953*^9, 3.46063507529072*^9, 
  3.4606352275927963`*^9, 3.460635277992836*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"General", "::", "\<\"stop\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Further output of \\\\\\\"\\\
\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(SetDelayed :: \\\"write\\\
\"\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" will be \
suppressed during this calculation.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/stop\\\", \
ButtonNote -> \\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.460635016659953*^9, 3.46063507529072*^9, 
  3.4606352275927963`*^9, 3.4606352780256853`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Flatten", "[", 
  RowBox[{
   RowBox[{"Shape", "[", 
    RowBox[{
     RowBox[{"20", "//", "Range"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "2", ",", "2"}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"flatten", "[", 
  RowBox[{
   RowBox[{"Shape", "[", 
    RowBox[{
     RowBox[{"20", "//", "Range"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "2", ",", "2"}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.460641591991756*^9, 3.460641684179329*^9}, {
  3.460641716120954*^9, 3.460641803527504*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", "11"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10", ",", "12"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"13", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"14", ",", "16"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"17", ",", "19"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"18", ",", "20"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.460641600444601*^9, 3.460641608743244*^9}, {
  3.4606416508592854`*^9, 3.460641685192998*^9}, {3.4606417193404903`*^9, 
  3.460641726131372*^9}, {3.4606417593646603`*^9, 3.460641804680873*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", "11"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10", ",", "12"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"13", ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"14", ",", "16"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"17", ",", "19"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"18", ",", "20"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.460641600444601*^9, 3.460641608743244*^9}, {
  3.4606416508592854`*^9, 3.460641685192998*^9}, {3.4606417193404903`*^9, 
  3.460641726131372*^9}, {3.4606417593646603`*^9, 3.460641804683358*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"??", "flatten"}]], "Input",
 CellChangeTimes->{{3.460641736139995*^9, 3.460641738389776*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox["\<\"flatten[a,ijk], Flatten an den Dimensionen ijk, diese \
werden\\n\\tzusammengefa't\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.460641739097073*^9},
 CellTags->"Info3460648938-6376568"],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{
      RowBox[{"Attributes", "[", "flatten", "]"}], "=", 
      RowBox[{"{", "Protected", "}"}]}]},
    {" "},
    {GridBox[{
       {
        RowBox[{
         RowBox[{"flatten", "[", 
          RowBox[{"a_", ",", "Hermann`Kronecker`Private`ijk_"}], "]"}], ":=", 
         
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "i", ",", "k", ",", "c", ",", "perm", ",", "b", ",", "p"}], "}"}],
            ",", 
           RowBox[{
            RowBox[{"i", "=", 
             RowBox[{"First", "[", "Hermann`Kronecker`Private`ijk", "]"}]}], 
            ";", 
            RowBox[{"k", "=", 
             RowBox[{"Range", "[", 
              RowBox[{"TensorRank", "[", "a", "]"}], "]"}]}], ";", 
            RowBox[{"c", "=", 
             RowBox[{"Complement", "[", 
              RowBox[{"k", ",", "Hermann`Kronecker`Private`ijk"}], "]"}]}], 
            ";", 
            RowBox[{"perm", "=", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                "#1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
                "&"}], ")"}], "/@", 
              RowBox[{"Sort", "[", 
               RowBox[{"Transpose", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Join", "[", 
                   RowBox[{"Hermann`Kronecker`Private`ijk", ",", "c"}], "]"}],
                   ",", "k"}], "}"}], "]"}], "]"}]}]}], ";", 
            RowBox[{"b", "=", 
             RowBox[{"Flatten", "[", 
              RowBox[{
               RowBox[{"Transpose", "[", 
                RowBox[{"a", ",", "perm"}], "]"}], ",", 
               RowBox[{
                RowBox[{"Length", "[", "Hermann`Kronecker`Private`ijk", "]"}],
                 "-", "1"}]}], "]"}]}], ";", 
            RowBox[{"p", "=", 
             RowBox[{"Range", "[", 
              RowBox[{
               RowBox[{"Length", "[", "c", "]"}], "+", "1"}], "]"}]}], ";", 
            RowBox[{"p", "=", 
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"{", "i", "}"}], ",", 
               RowBox[{"Complement", "[", 
                RowBox[{"p", ",", 
                 RowBox[{"{", "i", "}"}]}], "]"}]}], "]"}]}], ";", 
            RowBox[{"Transpose", "[", 
             RowBox[{"b", ",", "p"}], "]"}]}]}], "]"}]}]},
       {" "},
       {
        RowBox[{
         RowBox[{"flatten", "[", "a_", "]"}], ":=", 
         RowBox[{"Flatten", "[", "a", "]"}]}]}
      },
      BaselinePosition->{Baseline, {1, 1}},
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{"Columns" -> {{
           Scaled[0.999]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  Definition[Hermann`Kronecker`flatten],
  Editable->False]], "Print",
 CellChangeTimes->{3.460641739127554*^9},
 CellTags->"Info3460648938-6376568"]
}, Open  ]]
}, Open  ]]
},
WindowSize->{883, 772},
WindowMargins->{{86, Automatic}, {37, Automatic}},
ShowSelection->True,
FrontEndVersion->"7.0 for Mac OS X x86 (32-bit) (February 18, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3460637380-4560556"->{
  Cell[685, 26, 200, 4, 42, "Print",
   CellTags->"Info3460637380-4560556"]},
 "Info3460641699-3983420"->{
  Cell[17984, 422, 362, 10, 39, "Print",
   CellTags->"Info3460641699-3983420"],
  Cell[18349, 434, 1510, 43, 53, "Print",
   CellTags->"Info3460641699-3983420"]},
 "Info3460642280-9984658"->{
  Cell[21657, 541, 122, 2, 39, "Print",
   CellTags->"Info3460642280-9984658"],
  Cell[21782, 545, 890, 25, 20, "Print",
   CellTags->"Info3460642280-9984658"]},
 "Info3460642302-4180231"->{
  Cell[24163, 627, 120, 2, 39, "Print",
   CellTags->"Info3460642302-4180231"],
  Cell[24286, 631, 890, 25, 20, "Print",
   CellTags->"Info3460642302-4180231"]},
 "Info3460642483-4615935"->{
  Cell[20056, 489, 196, 4, 42, "Print",
   CellTags->"Info3460642483-4615935"],
  Cell[20255, 495, 1118, 32, 53, "Print",
   CellTags->"Info3460642483-4615935"]},
 "Info3460648938-6376568"->{
  Cell[34430, 915, 228, 4, 60, "Print",
   CellTags->"Info3460648938-6376568"],
  Cell[34661, 921, 3224, 86, 159, "Print",
   CellTags->"Info3460648938-6376568"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3460637380-4560556", 38238, 1022},
 {"Info3460641699-3983420", 38345, 1025},
 {"Info3460642280-9984658", 38538, 1030},
 {"Info3460642302-4180231", 38729, 1035},
 {"Info3460642483-4615935", 38920, 1040},
 {"Info3460648938-6376568", 39112, 1045}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 115, 2, 27, "Input"],
Cell[685, 26, 200, 4, 42, "Print",
 CellTags->"Info3460637380-4560556"]
}, Open  ]],
Cell[CellGroupData[{
Cell[922, 35, 183, 4, 27, "Input"],
Cell[1108, 41, 400, 11, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1545, 57, 230, 6, 27, "Input"],
Cell[1778, 65, 739, 13, 23, "Message"],
Cell[2520, 80, 342, 9, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2899, 94, 639, 17, 43, "Input"],
Cell[3541, 113, 4184, 74, 178, "Output"],
Cell[7728, 189, 4212, 77, 178, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11977, 271, 648, 15, 27, "Input"],
Cell[12628, 288, 2197, 41, 244, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14862, 334, 919, 23, 43, "Input"],
Cell[15784, 359, 620, 15, 33, "Output"],
Cell[16407, 376, 620, 15, 33, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17064, 396, 121, 2, 27, "Input"],
Cell[17188, 400, 614, 11, 23, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17839, 416, 120, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[17984, 422, 362, 10, 39, "Print",
 CellTags->"Info3460641699-3983420"],
Cell[18349, 434, 1510, 43, 53, "Print",
 CellTags->"Info3460641699-3983420"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[19908, 483, 123, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[20056, 489, 196, 4, 42, "Print",
 CellTags->"Info3460642483-4615935"],
Cell[20255, 495, 1118, 32, 53, "Print",
 CellTags->"Info3460642483-4615935"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[21422, 533, 210, 4, 27, "Input"],
Cell[CellGroupData[{
Cell[21657, 541, 122, 2, 39, "Print",
 CellTags->"Info3460642280-9984658"],
Cell[21782, 545, 890, 25, 20, "Print",
 CellTags->"Info3460642280-9984658"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[22721, 576, 502, 13, 27, "Input"],
Cell[23226, 591, 309, 7, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23572, 603, 224, 6, 27, "Input"],
Cell[23799, 611, 187, 5, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24023, 621, 115, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[24163, 627, 120, 2, 39, "Print",
 CellTags->"Info3460642302-4180231"],
Cell[24286, 631, 890, 25, 20, "Print",
 CellTags->"Info3460642302-4180231"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[25225, 662, 166, 3, 27, "Input"],
Cell[25394, 667, 122, 2, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25553, 674, 198, 5, 27, "Input"],
Cell[25754, 681, 590, 11, 23, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26381, 697, 795, 25, 43, InheritFromParent],
Cell[27179, 724, 242, 6, 27, "Output"],
Cell[27424, 732, 240, 6, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27701, 743, 157, 3, 43, "Input"],
Cell[27861, 748, 769, 14, 23, "Message"],
Cell[28633, 764, 811, 14, 23, "Message"],
Cell[29447, 780, 784, 14, 23, "Message"],
Cell[30234, 796, 838, 15, 23, "Message"],
Cell[31075, 813, 705, 12, 23, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31817, 830, 688, 20, 43, "Input"],
Cell[32508, 852, 870, 25, 27, "Output"],
Cell[33381, 879, 870, 25, 27, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[34288, 909, 117, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[34430, 915, 228, 4, 60, "Print",
 CellTags->"Info3460648938-6376568"],
Cell[34661, 921, 3224, 86, 159, "Print",
 CellTags->"Info3460648938-6376568"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
