(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   1499430,      40887]*)
(*NotebookOutlinePosition[   1501193,      40941]*)
(*  CellTagsIndexPosition[   1501009,      40933]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["CAR(2)/SEM/ 1 Komponente", "Section",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \($Path\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({"/Applications/Mathematica 5.2.app/AddOns/JLink", 
      "/Applications/Mathematica 5.2.app/AddOns/NETLink", 
      "/Users/hermannsinger/Library/Mathematica/Kernel", 
      "/Users/hermannsinger/Library/Mathematica/Autoload", 
      "/Users/hermannsinger/Library/Mathematica/Applications", 
      "/Library/Mathematica/Kernel", "/Library/Mathematica/Autoload", 
      "/Library/Mathematica/Applications", ".", "/Users/hermannsinger", 
      "/Applications/Mathematica 5.2.app/AddOns/StandardPackages", 
      "/Applications/Mathematica 5.2.app/AddOns/StandardPackages/StartUp", 
      "/Applications/Mathematica 5.2.app/AddOns/Autoload", 
      "/Applications/Mathematica 5.2.app/AddOns/Applications", 
      "/Applications/Mathematica 5.2.app/AddOns/ExtraPackages", 
      "/Applications/Mathematica 5.2.app/SystemFiles/Graphics/Packages", 
      "/Applications/Mathematica 5.2.app/Configuration/Kernel", "/SDE/", 
      "/SDE/code/"}\)], "Output"]
}, Open  ]],

Cell[BoxData[""], "Input"],

Cell[BoxData[{
    \(<< "\</Mathematica/Hermann.Notebooks/LISREL/SEM/SEM0.3/SEM.impl.m\>"\), \
"\[IndentingNewLine]", 
    \(<< Graphics`Graphics`\)}], "Input"],

Cell[CellGroupData[{

Cell["Matrizen /SDE", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell["\<\
SDE:
dy  = A y dt + B x dt + G dw
z_t = H y_t + D x_t + eps_t\
\>", "Text",
  FontWeight->"Bold",
  FontColor->RGBColor[0, 0, 1]],

Cell["\<\
EDM:
y_{t+1} = astern y_t + bstern x_t + u_t
z_t = H y_t + D x_t +  eps_t
E[y_0] = mue; Var[y_0] = Sigma; \
\>", "Text",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}},
  FontWeight->"Bold",
  FontColor->RGBColor[1, 0, 0]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Theta = {16, 4, 1, 2, 0, 0, 1, 0, 1}\)], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({16, 4, 1, 2, 0, 0, 1, 0, 1}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(Unprotect[A]\), "\[IndentingNewLine]", 
    \(Clear[A]\), "\n", 
    \(A[{\[Omega]02_, gamma_, b_, g_, mu1_, mu2_, Sigma11_, Sigma12_, 
          Sigma22_}] := {{0, 1}, {\(-\[Omega]02\), \(-gamma\)}}\)}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({"A"}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(A[Theta]\)], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{0, 1}, {\(-16\), \(-4\)}}\)], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(Clear[B]\), "\n", 
    \(B[{w02_, gamma_, b_, g_, mu1_, mu2_, Sigma11_, Sigma12_, 
          Sigma22_}] := {{0}, {b}}\)}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(B[Theta]\)], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{0}, {1}}\)], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(Clear[Omega]\), "\n", 
    \(Omega[{w02_, gamma_, b_, g_, mu1_, mu2_, Sigma11_, Sigma12_, 
          Sigma22_}] := {{0, 0}, {0, g\^2}}\)}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(Omega[Theta]\)], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{0, 0}, {0, 4}}\)], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(Clear[Mue]\), "\n", 
    \(\(\(Mue[{w02_, gamma_, b_, g_, mu1_, mu2_, Sigma11_, Sigma12_, 
          Sigma22_}] := {mu1, mu2}\)\(\n\)
    \)\), "\[IndentingNewLine]", 
    \(Clear[Sigma]\), "\n", 
    \(Sigma[{w02_, gamma_, b_, g_, mu1_, mu2_, Sigma11_, Sigma12_, 
          Sigma22_}] := \[IndentingNewLine]\ \ Module[{root}, \
\[IndentingNewLine]root = {{Sigma11, 0}, {Sigma12, 
              Sigma22}}; \[IndentingNewLine]root . 
          Transpose[root]]\)}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(Mue[Theta + 1]\)], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({1, 1}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Sigma[{w02_, gamma_, b_, g_, mu1_, mu2_, Sigma11_, Sigma12_, 
        Sigma22_}]\)], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{Sigma11_\^2, Sigma11_\ Sigma12_}, {Sigma11_\ Sigma12_, 
        Sigma12_\^2 + Sigma22_\^2}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(Clear[H]\), "\n", 
    \(H[{w02_, gamma_, b_, g_, mu1_, mu2_, Sigma11_, Sigma12_, 
          Sigma22_}] := {{1, 0}}\), "\n", 
    \(H[Theta]\)}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{1, 0}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(Clear[R]\), "\n", 
    \(R[{w02_, gamma_, b_, g_, mu1_, mu2_, Sigma11_, Sigma12_, 
          Sigma22_}] := {{1\/10. \^8}}\), "\n", 
    \(R[Theta]\)}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{1.`*^-8}}\)], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["EDM", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[{
    \(Clear[STERN]\), "\n", 
    \(STERN[Theta_, Deltat_] := 
      Module[{L, p, a, b, omega, Ip, Ip2, astern, bstern, 
          ostern}, \[IndentingNewLine]\[IndentingNewLine]a = 
          N[A[Theta]]; \[IndentingNewLine]b = 
          N[B[Theta]]; \[IndentingNewLine]omega = 
          N[Omega[Theta]]; \[IndentingNewLine]\[IndentingNewLine]p = 
          Length[a]; \[IndentingNewLine]Ip = 
          IdentityMatrix[p]; \[IndentingNewLine]Ip2 = 
          IdentityMatrix[p\^2]; \[IndentingNewLine]astern = 
          MatrixExp[a\ Deltat]; \[IndentingNewLine]bstern = 
          Inverse[a] . \((astern - Ip)\) . b; \[IndentingNewLine]L = 
          KroneckerProduct[a, Ip] + 
            KroneckerProduct[Ip, a]; \[IndentingNewLine]ostern = 
          Inverse[L] . \((KroneckerProduct[astern, astern] - Ip2)\) . 
            Flatten[omega]; \[IndentingNewLine]ostern = 
          Shape[ostern, {p, p}]; \[IndentingNewLine]{astern, bstern, 
          ostern}]\)}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(\({astern, bstern, ostern} = STERN[Theta, 2];\)\)], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[{
    \(astern // MatrixForm\), "\n", 
    \(bstern // MatrixForm\), "\n", 
    \(ostern // MatrixForm\)}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2"},
              {"1", "0.020993373219534036`", "0.0031787739058363297`"},
              {"2", \(-0.05086038249338126`\), "0.008278277596188717`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1"},
              {"1", "0.061187914173779126`"},
              {"2", "0.0031787739058363297`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2"},
              {"1", "0.03123117514450483`", "0.000020209207088851912`"},
              {"2", "0.00002020920708885191`", "0.4998848982316648`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[BoxData[{
    \(Clear[SubDiagonalMatrix]\), "\n", 
    \(SubDiagonalMatrix[
        astern_, {T_, p_}] := \[IndentingNewLine]Module[{beta, 
          null = Shape[
              0, {p, p}]}, \[IndentingNewLine]\[IndentingNewLine]beta = 
          IdentityMatrix[T]; \[IndentingNewLine]beta = 
          RotateLeft[
            beta, \(-1\)]; \[IndentingNewLine]beta\[LeftDoubleBracket]1, 
            T\[RightDoubleBracket] = 0; \[IndentingNewLine]beta = 
          beta /. \[InvisibleSpace]{1 \[Rule] astern, 
              0 \[Rule] null}; \[IndentingNewLine]beta = 
          BlockMatrix[beta]\[IndentingNewLine]]\)}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(SubDiagonalMatrix[astern, {4, 2}] // MatrixForm\)], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8"},
              {"1", "0", "0", "0", "0", "0", "0", "0", "0"},
              {"2", "0", "0", "0", "0", "0", "0", "0", "0"},
              {"3", "0.020993373219534036`", "0.0031787739058363297`", "0", 
                "0", "0", "0", "0", "0"},
              {"4", \(-0.05086038249338126`\), "0.008278277596188717`", "0", 
                "0", "0", "0", "0", "0"},
              {"5", "0", "0", "0.020993373219534036`", 
                "0.0031787739058363297`", "0", "0", "0", "0"},
              {"6", "0", "0", \(-0.05086038249338126`\), 
                "0.008278277596188717`", "0", "0", "0", "0"},
              {"7", "0", "0", "0", "0", "0.020993373219534036`", 
                "0.0031787739058363297`", "0", "0"},
              {"8", "0", "0", "0", "0", \(-0.05086038249338126`\), 
                "0.008278277596188717`", "0", "0"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(?? BlockMatrix\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    RowBox[{"\<\"BlockMatrix[block] gives a matrix composed of a matrix of \
matrices.\"\>", " ", 
      ButtonBox[
        StyleBox["Mehr\[Ellipsis]",
          "SR"],
        ButtonData:>"LinearAlgebra`MatrixManipulation`",
        Active->True,
        ButtonStyle->"AddOnsLink"]}]], "Print",
  CellTags->"Info3431059188-3291986"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {\(BlockMatrix[
                      LinearAlgebra`MatrixManipulation`Private`block_] := 
                    AppendColumns @@ 
                      Apply[AppendRows, 
                        LinearAlgebra`MatrixManipulation`Private`block, \
{1}]\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ "BlockMatrix"],
      Editable->False]], "Print",
  CellTags->"Info3431059188-3291986"]
}, Open  ]],

Cell[BoxData[{
    \(\(\(Clear[SystemEDMdet]\)\(\[IndentingNewLine]\)
    \)\), "\n", 
    \(SystemEDMdet[
        Theta_, {Deltat_, T_}] := \[IndentingNewLine]Module[{astern, bstern, 
          ostern, p, q, beta, gamma, 
          sigma, \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ sigmazeta, 
          lambdaeta, taueta, 
          sigmaepsilon}, \[IndentingNewLine]\[IndentingNewLine]{astern, 
            bstern, ostern} = 
          STERN[Theta, Deltat]; \[IndentingNewLine]\[IndentingNewLine]{p, 
            q} = Dimensions[bstern]; \[IndentingNewLine]null = 
          Shape[0, {p, p}]; \[IndentingNewLine]beta = 
          SubDiagonalMatrix[astern, {T + 1, p}]; \[IndentingNewLine]mu = 
          Mue[Theta]; \[IndentingNewLine]gamma = 
          Spalte[Flatten[{1, Shape[2, T]}]]; \[IndentingNewLine]gamma = 
          gamma /. \[InvisibleSpace]{1 \[Rule] Spalte[mu], 
              2 \[Rule] bstern}; \[IndentingNewLine]gamma = 
          BlockMatrix[gamma]; \[IndentingNewLine]sigma = 
          Sigma[Theta]; \[IndentingNewLine]sigmazeta = 
          Flatten[{1, Shape[2, T]}]; \[IndentingNewLine]sigmazeta = 
          sigmazeta /. \[InvisibleSpace]{1 \[Rule] sigma, 
              2 \[Rule] ostern}; \[IndentingNewLine]sigmazeta = 
          BlockDiagonalMatrix[sigmazeta]; \[IndentingNewLine]h = 
          H[Theta]; \[IndentingNewLine]lambdaeta = 
          KroneckerProduct[IdentityMatrix[T + 1], h]; \[IndentingNewLine]{kp, 
            p} = Dimensions[lambdaeta]; \[IndentingNewLine]{p, q} = 
          Dimensions[gamma]; \[IndentingNewLine]taueta = 
          Shape[0, {kp, q}]; \[IndentingNewLine]sigmaepsilon = 
          IdentityMatrix[kp]\/10. \^8; \[IndentingNewLine]{{beta, gamma, 
            sigmazeta}, {lambdaeta, taueta, 
            sigmaepsilon}}\[IndentingNewLine]]\)}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(\({{beta, gamma, sigmazeta}, {lambdaeta, taueta, sigmaepsilon}} = 
        SystemEDMdet[Theta, {2. , 3}];\)\)], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[{
    \(beta // MatrixForm\), "\[IndentingNewLine]", 
    \(gamma // MatrixForm\)}], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8"},
              {"1", "0", "0", "0", "0", "0", "0", "0", "0"},
              {"2", "0", "0", "0", "0", "0", "0", "0", "0"},
              {"3", "0.020993373219534036`", "0.0031787739058363297`", "0", 
                "0", "0", "0", "0", "0"},
              {"4", \(-0.05086038249338126`\), "0.008278277596188717`", "0", 
                "0", "0", "0", "0", "0"},
              {"5", "0", "0", "0.020993373219534036`", 
                "0.0031787739058363297`", "0", "0", "0", "0"},
              {"6", "0", "0", \(-0.05086038249338126`\), 
                "0.008278277596188717`", "0", "0", "0", "0"},
              {"7", "0", "0", "0", "0", "0.020993373219534036`", 
                "0.0031787739058363297`", "0", "0"},
              {"8", "0", "0", "0", "0", \(-0.05086038249338126`\), 
                "0.008278277596188717`", "0", "0"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1"},
              {"1", "0"},
              {"2", "0"},
              {"3", "0.061187914173779126`"},
              {"4", "0.0031787739058363297`"},
              {"5", "0.061187914173779126`"},
              {"6", "0.0031787739058363297`"},
              {"7", "0.061187914173779126`"},
              {"8", "0.0031787739058363297`"}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Simulation", "Subsection",
  PageWidth->Infinity,
  TextJustification->0,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[{
    \(Theta = {16, 4, 1, 2, 0, 0, 1, 0, 1}\), "\n", 
    \(n = 500\), "\n", 
    \(Deltat =  .5\), "\n", 
    \(T = 5\), "\n", 
    \(\(X = Shape[1, {n, 1}];\)\)}], "Input",
  PageWidth->Infinity,
  TextJustification->0,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({16, 4, 1, 2, 0, 0, 1, 0, 1}\)], "Output"],

Cell[BoxData[
    \(500\)], "Output"],

Cell[BoxData[
    \(0.5`\)], "Output"],

Cell[BoxData[
    \(5\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(?? LISRELsimul\)], "Input"],

Cell["Global`LISRELsimul", "Print",
  CellTags->"Info3431059219-4812943"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {\(LISRELsimul[{n_, Generator_}, 
                      Theta_, {System_, ThetaFix_}] := 
                    Block[{p, q, beta, gamma, B1, muexi, sigmaxi, XI, 
                        sigmazeta, ZETA, ETA, sigmaepsilon, lambdaeta, kp, 
                        EPSILON, sigmadelta, lambdaxi, kq, Y, X, 
                        DELTA}, {{beta, gamma, muexi, sigmaxi, 
                            sigmazeta}, {lambdaeta, lambdaxi, sigmaepsilon, 
                            sigmadelta}} = System[Theta, ThetaFix]; {p, q} = 
                        Dimensions[gamma]; B1 = IdentityMatrix[p] - beta; 
                      sigmaxi = symmetric[sigmaxi]; 
                      XI = RandomGauss[muexi, sigmaxi, n, Generator]; 
                      sigmazeta = symmetric[sigmazeta]; 
                      ZETA = RandomGauss[Shape[0, {p}], sigmazeta, n, 
                          Generator]; 
                      ETA = \((XI . Transpose[gamma] + ZETA)\) . 
                          Transpose[Inverse[B1]]; 
                      sigmaepsilon = symmetric[sigmaepsilon]; 
                      kp = Length[lambdaeta]; 
                      EPSILON = 
                        RandomGauss[Shape[0, {kp}], sigmaepsilon, n, 
                          Generator]; sigmadelta = symmetric[sigmadelta]; 
                      kq = Length[lambdaxi]; 
                      DELTA = 
                        RandomGauss[Shape[0, {kq}], sigmadelta, n, 
                          Generator]; 
                      Y = ETA . Transpose[lambdaeta] + EPSILON; 
                      X = XI . Transpose[lambdaxi] + DELTA; {{Y, X, ETA, 
                          XI}, {ZETA, EPSILON, 
                          DELTA}, {{beta, gamma, muexi, sigmaxi, 
                            sigmazeta}, {lambdaeta, lambdaxi, sigmaepsilon, 
                            sigmadelta}}}]\)},
                {" "},
                {\(LISRELsimul[{n_, Generator_, X_}, 
                      Theta_, {System_, ThetaFix_}, comp_ : True] := 
                    Block[{p, q, beta, gamma, B1, sigmazeta, ZETA, ETA, 
                        sigmaepsilon, lambdaeta, kp, EPSILON, kq, 
                        Y}, {{beta, gamma, sigmazeta}, {lambdaeta, taueta, 
                            sigmaepsilon}} = 
                        System[Theta, ThetaFix]; {p, q} = Dimensions[gamma]; 
                      B1 = IdentityMatrix[p] - beta; 
                      If[comp, 
                        RandomGauss[Shape[0, q], IdentityMatrix[q], n, 
                          Generator]]; sigmazeta = symmetric[sigmazeta]; 
                      ZETA = RandomGauss[Shape[0, {p}], sigmazeta, n, 
                          Generator]; 
                      ETA = \((X . Transpose[gamma] + ZETA)\) . 
                          Transpose[Inverse[B1]]; 
                      sigmaepsilon = symmetric[sigmaepsilon]; 
                      kp = Length[lambdaeta]; 
                      EPSILON = 
                        RandomGauss[Shape[0, {kp}], sigmaepsilon, n, 
                          Generator]; 
                      Y = ETA . Transpose[lambdaeta] + 
                          X . Transpose[taueta] + EPSILON; {{Y, X, 
                          ETA}, {ZETA, 
                          EPSILON}, {{beta, gamma, sigmazeta}, {lambdaeta, 
                            taueta, sigmaepsilon}}}]\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ "LISRELsimul"],
      Editable->False]], "Print",
  CellTags->"Info3431059219-4812943"]
}, Open  ]],

Cell[BoxData[{
    \(\(SeedRandom[12345689999999];\)\), "\n", 
    \(\({{Y, X, ETA}, {ZETA, 
            EPSILON}, {{beta, gamma, sigmazeta}, {lambdaeta, taueta, 
              sigmaepsilon}}} = \[IndentingNewLine]LISRELsimul[{n, Gauss, X}, 
          Theta, {SystemEDMdet, {Deltat, T}}];\)\)}], "Input",
  PageWidth->Infinity,
  TextJustification->0,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(X\)], "Input",
  PageWidth->Infinity,
  TextJustification->0,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, \
{1}, {1}, {1}, {1}, {1}, {1}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Y // MatrixForm\)], "Input",
  PageWidth->Infinity,
  TextJustification->0,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", 
                "6"},
              {"1", \(-1.5204927688665557`\), \(-0.31488339975500296`\), 
                "0.2873785265480737`", 
                "0.2992683913546465`", \(-0.3425220954111383`\), 
                "0.03876190705466289`"},
              {"2", "1.480171459414143`", 
                "0.3369396397953924`", \(-0.5038508934372664`\), \
\(-0.04709107522862935`\), "0.25231257347420866`", "0.1656640736659872`"},
              {"3", "0.01818699459938948`", 
                "0.04934875034624223`", \(-0.049281997694933584`\), 
                "0.08793573266493412`", \(-0.012292015174289846`\), \
\(-0.36210376595422517`\)},
              {"4", \(-0.2136178709371661`\), "0.08302795230762915`", 
                "0.015522468189457633`", \(-0.013005310425956958`\), 
                "0.08225678822952595`", \(-0.05804307368415867`\)},
              {"5", "0.17236710961870405`", "0.27852598709451964`", 
                "0.18499193548842335`", "0.15756357013536004`", 
                "0.010783086831086846`", "0.23841190470913753`"},
              {"6", \(-0.5276324560096376`\), "0.24939050401161883`", 
                "0.22529872120405908`", "0.15804049456346567`", 
                "0.2864072645899886`", "0.17764180137612037`"},
              {"7", "1.0438890534936047`", 
                "0.06959130630684275`", \(-0.20731966887098555`\), 
                "0.2291299683616847`", 
                "0.251966008441948`", \(-0.1642668649339693`\)},
              {"8", \(-0.2763816385525319`\), \(-0.12193969966093221`\), 
                "0.2019239719325127`", "0.20350593578627132`", 
                "0.2138686723831956`", "0.21518842652469883`"},
              {"9", \(-1.2258155882853288`\), \(-0.19206452443023334`\), 
                "0.43564182956294795`", "0.025277287135046293`", 
                "0.03393432722724468`", \(-0.19529625879770607`\)},
              {
                "10", \(-0.16271982559354722`\), \(-0.38522048430767375`\), \
\(-0.13682428968764818`\), "0.4166933096680087`", 
                "0.15348991291412364`", \(-0.06652948019175615`\)},
              {"11", \(-1.4687836323041967`\), \(-0.29501157211928114`\), 
                "0.31299219187977423`", "0.3377979115955405`", 
                "0.3792723927261181`", "0.1096678586661461`"},
              {"12", "1.1748826472006406`", 
                "0.3484626275481624`", \(-0.2737645002164578`\), \
\(-0.33398209505958143`\), "0.17701536155657038`", "0.2611060555977866`"},
              {"13", "1.0998437634218226`", 
                "0.0128602377589377`", \(-0.2846452787375916`\), \
\(-0.026277659778696408`\), "0.1876505603329475`", "0.05529493682521718`"},
              {"14", "0.19760150246365688`", \(-0.12646654966264018`\), 
                "0.07731556184146637`", \(-0.14176989881293475`\), 
                "0.01038022899702879`", "0.19851632998586902`"},
              {"15", "0.22335137170750252`", 
                "0.3117368477675333`", \(-0.300754692540608`\), 
                "0.011885058381301801`", 
                "0.09059528071679201`", \(-0.07400089418294846`\)},
              {"16", \(-0.5686376423838773`\), "0.027893977694869652`", 
                "0.1527577555971894`", "0.1888989896770133`", 
                "0.23784236232282338`", \(-0.18080297693941885`\)},
              {"17", "1.3072521331068754`", 
                "0.15808217161658322`", \(-0.019145434814389913`\), 
                "0.4537296128692987`", "0.1723839345385377`", 
                "0.03257109139731879`"},
              {"18", "0.19617534307012816`", 
                "0.234468068383966`", \(-0.10338100558742563`\), \
\(-0.15249072210250758`\), \(-0.13396888413542452`\), "0.3993283733084768`"},
              {"19", "1.3055229487113782`", 
                "0.3450206021031837`", \(-0.053660545143785494`\), 
                "0.14506104791134355`", \(-0.12394087791120724`\), 
                "0.05729717040452352`"},
              {"20", "0.47836801777806076`", 
                "0.24593550997715724`", \(-0.08432394168474154`\), 
                "0.2960339835200774`", "0.040324642541533076`", 
                "0.19526194236735434`"},
              {"21", \(-1.0711098618189885`\), "0.0826677840295155`", 
                "0.5313044135436265`", "0.12575753032084547`", 
                "0.11312207999161836`", "0.15158426884055884`"},
              {"22", \(-1.0198238009081804`\), "0.15767436843835816`", 
                "0.1553421198903849`", "0.08885630468674802`", 
                "0.12701325219148427`", "0.3351858704836624`"},
              {"23", "0.8470398657763394`", 
                "0.017570863761133308`", \(-0.10803351265284569`\), 
                "0.22231430777327052`", "0.1666921793521981`", 
                "0.021287960241226193`"},
              {"24", \(-2.091219127892049`\), \(-0.18870449235984338`\), 
                "0.7372902485211935`", "0.2636539337719685`", 
                "0.06071541278914414`", "0.02482079303669172`"},
              {"25", "0.3221182867675234`", \(-0.17550602373897325`\), 
                "0.16530043275466252`", 
                "0.20856760785200276`", \(-0.037665692743630824`\), 
                "0.06315653461509313`"},
              {"26", \(-0.5031514027812818`\), "0.04786391750499753`", 
                "0.4548183959412094`", "0.3347361949478249`", 
                "0.3501090986273901`", \(-0.06801308199205353`\)},
              {"27", \(-0.8046891164512703`\), "0.05880984950034065`", 
                "0.35352982100517516`", "0.23359290755680392`", 
                "0.27266658978322056`", "0.02352249265814884`"},
              {"28", \(-0.6443278516125555`\), "0.2694288908677308`", 
                "0.26251621094963773`", 
                "0.13973696069618508`", \(-0.16852968293868997`\), \
\(-0.033678072966085576`\)},
              {"29", "1.1145314759456477`", "0.35888768588107933`", 
                "0.1962974880148366`", \(-0.005874620342394047`\), 
                "0.14521802710540327`", "0.15684503980173964`"},
              {"30", \(-0.01720254497740519`\), \(-0.07932941136840589`\), 
                "0.05776966727386056`", \(-0.13865757959836966`\), 
                "0.06748878857659993`", \(-0.12885219829442907`\)},
              {"31", "0.37485214906683106`", \(-0.10026412659269279`\), 
                "0.11458190650764308`", "0.004518048451946799`", 
                "0.09669548922064808`", "0.08747237370047152`"},
              {"32", \(-0.5993734783905588`\), \(-0.0288019371130307`\), 
                "0.2986740678884863`", \(-0.21593918407578142`\), \
\(-0.1262883142710752`\), "0.38003873800594434`"},
              {"33", \(-2.300912631539204`\), \(-0.09423492801764446`\), 
                "0.3798583255394309`", "0.0006428711843965841`", 
                "0.12373929285224661`", \(-0.04913226130011245`\)},
              {"34", \(-0.71671515506477`\), "0.27838012309806337`", 
                "0.18089456494501452`", "0.09024937884692166`", 
                "0.24411553687535248`", "0.1116405849014336`"},
              {"35", 
                "1.794402357536778`", \(-0.03533905350017988`\), \
\(-0.2910325453952359`\), "0.06345817095512762`", \(-0.017784796439653642`\), 
                "0.17251828130197258`"},
              {"36", \(-0.6669534787528444`\), \(-0.22893199978763426`\), 
                "0.5319482913513416`", "0.12848218030651962`", 
                "0.02643971649714939`", \(-0.05807126456267411`\)},
              {"37", "0.502459938067349`", "0.012955920387255664`", 
                "0.18399159093635184`", \(-0.033359758421066504`\), \
\(-0.018083528520195596`\), "0.0593737482231787`"},
              {"38", "0.8555745045563542`", \(-0.003049986151913729`\), 
                "0.2352970867889665`", 
                "0.2517444296630648`", \(-0.14320647221045282`\), 
                "0.08365505105124624`"},
              {"39", "0.9927023445305961`", \(-0.03379267304697794`\), 
                "0.23774880228905826`", \(-0.010188602528451976`\), \
\(-0.013885299385129477`\), "0.06165230089848156`"},
              {"40", "0.43792219632439705`", "0.07566152768266488`", 
                "0.01830916762378675`", "0.08000371744451912`", 
                "0.18412005150682564`", \(-0.2287413913750131`\)},
              {"41", \(-0.6332247009749709`\), \(-0.10641744167545505`\), 
                "0.18291684434916164`", \(-0.15308828299450974`\), 
                "0.03254966130260605`", "0.25652014381695665`"},
              {
                "42", \(-0.04885600749199475`\), \(-0.32019241690030104`\), \
\(-0.036095398981157885`\), "0.4206803222061199`", 
                "0.10034257191263411`", \(-0.16860647508719365`\)},
              {"43", "0.3191933318342083`", "0.027440174133633463`", 
                "0.24098403109131905`", "0.418357040618421`", 
                "0.22646434297911489`", "0.06854977805897096`"},
              {"44", \(-0.5952364639707133`\), 
                "0.316426216732599`", \(-0.07897354873627725`\), 
                "0.021275146467082375`", "0.4195082987066505`", 
                "0.06965966582670245`"},
              {"45", "0.5676647381969534`", "0.25119325582220065`", 
                "0.07733107717612923`", \(-0.09690775545644682`\), \
\(-0.06526093118320077`\), "0.3530661577509488`"},
              {"46", \(-1.215021293180042`\), "0.2206033298770909`", 
                "0.21913573554920543`", "0.03707397858223304`", 
                "0.3207144354981843`", "0.25206601073482293`"},
              {"47", "0.2888321059760326`", 
                "0.3456905734387709`", \(-0.24058569118260592`\), \
\(-0.25242850269221795`\), \(-0.30333949353308587`\), 
                "0.09201973233205503`"},
              {"48", \(-1.8261564363066622`\), \(-0.06734288981601877`\), 
                "0.3490022593015709`", "0.27296183067797886`", 
                "0.20029500842011175`", \(-0.052914692136325915`\)},
              {"49", 
                "0.02508926775512304`", \(-0.4305025690380141`\), \
\(-0.13989438862347003`\), "0.2509107940165592`", "0.36820638385688853`", 
                "0.3175775722403808`"},
              {"50", "0.24422792452997594`", \(-0.23782478821455308`\), 
                "0.007793499579746383`", "0.28562899731544095`", 
                "0.2972262593467207`", \(-0.25846848011546086`\)},
              {"51", "1.7312526456472006`", 
                "0.13228070150139373`", \(-0.12645299628683718`\), \
\(-0.10302534111979227`\), "0.1701019240230688`", "0.07201270160600325`"},
              {"52", "1.0449817234831467`", "0.40289917983992546`", 
                "0.06898176447548311`", 
                "0.15686100867135278`", \(-0.09567538365089202`\), \
\(-0.006780541961830627`\)},
              {"53", "0.05510154017427007`", \(-0.007837078553253647`\), 
                "0.26383850404681025`", "0.2805003972303349`", 
                "0.02782779962784579`", "0.2934459452105518`"},
              {"54", "0.06735749297706857`", 
                "0.14558530904971925`", \(-0.12325930847616541`\), 
                "0.355495633164034`", "0.25118646265598993`", 
                "0.37197670525588933`"},
              {"55", "0.7124177974282395`", "0.04723423938744722`", 
                "0.17090176995704964`", \(-0.1258333291389298`\), 
                "0.14693949605337792`", \(-0.048682553562403`\)},
              {"56", \(-1.564797697805608`\), \(-0.11386146983643848`\), 
                "0.23381403604464843`", \(-0.08402728328855087`\), 
                "0.13202289262302977`", \(-0.15064134636212137`\)},
              {"57", "1.4224297684673541`", "0.09774779471967653`", 
                "0.10507003143482434`", \(-0.07506557218131776`\), \
\(-0.07276075743966925`\), "0.008180877525857663`"},
              {"58", "2.403144529159946`", 
                "0.30243944393556904`", \(-0.22032312722869193`\), 
                "0.41305690660672073`", "0.28857603266560883`", 
                "0.16661474817985203`"},
              {"59", \(-0.6295919217160479`\), \(-0.2083330790625227`\), 
                "0.2899939828315373`", "0.0881629859824428`", 
                "0.3342299208476893`", "0.023121845198824684`"},
              {"60", "1.1351200739752176`", 
                "0.14848024545362418`", \(-0.20251494091593103`\), 
                "0.2829583793497866`", \(-0.09577353509782263`\), \
\(-0.10170836727317445`\)},
              {"61", "0.20006227226994103`", "0.3519244261827092`", 
                "0.33010937015732605`", \(-0.007509751061503531`\), 
                "0.34335343272212415`", "0.1561468361116095`"},
              {"62", "1.6165730432509695`", "0.27284029673921645`", 
                "0.04541938639846874`", \(-0.041230465771846435`\), 
                "0.07619384224670249`", "0.17241642548761918`"},
              {"63", \(-0.34785796293514526`\), "0.18332427978615504`", 
                "0.25240207596319564`", "0.39051954198068173`", 
                "0.19530206479078804`", \(-0.26233493209463843`\)},
              {"64", \(-0.8835604030453638`\), \(-0.23506675974581107`\), 
                "0.4863084067716339`", "0.25772642235813176`", 
                "0.16723185780971062`", \(-0.15376821009594605`\)},
              {"65", \(-1.0339081902497234`\), \(-0.39302951148213705`\), 
                "0.2290423191427985`", 
                "0.13490667239706552`", \(-0.16718912656759308`\), \
\(-0.12770815271254832`\)},
              {"66", \(-0.1266852448558896`\), 
                "0.0971070577528689`", \(-0.09001270299553843`\), 
                "0.21966700567480515`", \(-0.039315926379530776`\), \
\(-0.0837307474911168`\)},
              {"67", \(-1.4449388360414497`\), \(-0.1851539946600331`\), 
                "0.0314567876205417`", \(-0.2371168748960264`\), \
\(-0.2869649823860364`\), "0.23839915265766704`"},
              {"68", 
                "0.5488842186650197`", \(-0.06734292229444556`\), \
\(-0.18754042641146348`\), "0.07312550386916539`", "0.08051129899908241`", 
                "0.374275394091695`"},
              {"69", "0.5228561496997699`", 
                "0.18976271401219152`", \(-0.19417935734717098`\), 
                "0.05526176985163576`", "0.13270301366710474`", 
                "0.015372880778911384`"},
              {"70", "0.2792220104759568`", 
                "0.0773984839472692`", \(-0.1046378812483625`\), 
                "0.050272518892547004`", 
                "0.06797244627943627`", \(-0.2697876766361458`\)},
              {"71", \(-0.4039346549276795`\), "0.36803395357388813`", 
                "0.054727452340732376`", \(-0.12471567441875141`\), 
                "0.1109752263685273`", \(-0.060877334935268194`\)},
              {"72", \(-0.5373593163169922`\), 
                "0.031381402754036`", \(-0.10556420283914777`\), 
                "0.20898863658752923`", "0.07785183928310774`", 
                "0.12305080585991658`"},
              {"73", \(-0.9854088670014337`\), "0.17607105392825495`", 
                "0.5062252872418358`", \(-0.02446657350804663`\), \
\(-0.09379453092837813`\), \(-0.10425458817309456`\)},
              {"74", "0.17683283577948672`", "0.1027214347750169`", 
                "0.17358830106609333`", \(-0.12581412016441182`\), 
                "0.16341912127826722`", "0.18938304105608203`"},
              {"75", "1.0519025206587598`", 
                "0.2522483096026141`", \(-0.12796825671240625`\), \
\(-0.4085753136656961`\), \(-0.258412520927408`\), "0.41323222988067604`"},
              {"76", "0.4146294577728985`", "0.01394005227752433`", 
                "0.22390028315736385`", 
                "0.13727412197348848`", \(-0.026148959034714186`\), 
                "0.1828598190732574`"},
              {"77", "1.0074512186675724`", \(-0.00802352319538572`\), 
                "0.07242617351024748`", "0.2858443846815038`", 
                "0.264850065580063`", "0.21976294844926564`"},
              {"78", "1.0473479587230379`", "0.2789245340856806`", 
                "0.029941916870194228`", "0.11673884935492868`", 
                "0.21449039595226477`", "0.1914609820353889`"},
              {"79", \(-1.2560944814496984`\), \(-0.24772683038970167`\), 
                "0.11668205212619176`", \(-0.1492839715640189`\), 
                "0.090798635730712`", "0.35270320323936866`"},
              {"80", "0.2773113616806607`", 
                "0.5498673095748807`", \(-0.07823731345953058`\), \
\(-0.1723023045171181`\), \(-0.03431115065991208`\), \
\(-0.05779794931410268`\)},
              {"81", \(-1.0099461489230321`\), \(-0.45853950839563296`\), 
                "0.4173993761445784`", "0.36545256013466154`", 
                "0.22080378093153055`", "0.2909590427452326`"},
              {"82", \(-0.5337717770674729`\), \(-0.03887555448088119`\), 
                "0.10106036093249225`", "0.08823149241474704`", 
                "0.04428602155649694`", "0.24678595362112785`"},
              {"83", "0.1786586211989035`", "0.120349674863973`", 
                "0.044381480784718076`", \(-0.06437336602381347`\), 
                "0.3353508863880427`", "0.09718432977496261`"},
              {"84", "0.060605139460129034`", "0.2023285136397567`", 
                "0.07396551832843468`", \(-0.09814530703743585`\), 
                "0.1742447195704732`", "0.057344207601860174`"},
              {"85", \(-0.8047318970756352`\), \(-0.23582092414726105`\), 
                "0.31574780318768025`", "0.25774709291715403`", 
                "0.16952341242439942`", "0.36487197739242627`"},
              {"86", "1.7153641393885366`", 
                "0.2945189672845393`", \(-0.3333610918618245`\), 
                "0.134897062110092`", \(-0.15485084114557662`\), 
                "0.05904601074500096`"},
              {"87", "1.0023068669261288`", 
                "0.15832640661436942`", \(-0.1965219188015238`\), 
                "0.17344837031536173`", 
                "0.10995792811240324`", \(-0.03204775186306329`\)},
              {"88", "0.0627614362147663`", \(-0.10660750531861947`\), 
                "0.30288517066754606`", \(-0.03733854890303139`\), 
                "0.12847764103483714`", \(-0.11204288214840827`\)},
              {"89", "1.4080253575652906`", "0.324472704657102`", 
                "0.033425867685275924`", 
                "0.2963815761438129`", \(-0.002650661149833783`\), \
\(-0.26064396570599857`\)},
              {"90", "0.623699246895105`", "0.4540639191825474`", 
                "0.26834300003305034`", "0.13892702268069987`", 
                "0.15566518682630484`", \(-0.03514725005509734`\)},
              {"91", 
                "0.4222299060069513`", \(-0.0008776324015571175`\), \
\(-0.1780835059879753`\), \(-0.050955094093617086`\), 
                "0.0982268347057089`", \(-0.029583362031947384`\)},
              {"92", "0.56955864046113`", "0.4888310807019835`", 
                "0.005785779256594679`", \(-0.005731626197667575`\), 
                "0.1637242775869467`", "0.1428264423156081`"},
              {"93", "1.0156049172187285`", 
                "0.03155004539868148`", \(-0.10314492937168884`\), 
                "0.1830800124612071`", "0.4447882215734272`", 
                "0.019083624337729047`"},
              {"94", "0.2602229147761648`", "0.3710800826540217`", 
                "0.20922831349562182`", "0.01945300526929613`", 
                "0.23812507217262074`", "0.1651035587810381`"},
              {"95", \(-0.15282901447906325`\), "0.1420087139494121`", 
                "0.11993870428292293`", "0.05870588992304677`", 
                "0.3584342280017883`", \(-0.007419823979234748`\)},
              {"96", \(-0.6131329585023164`\), \(-0.027222492440601327`\), 
                "0.4497309211410605`", "0.16444246037896743`", 
                "0.3388658579263431`", "0.16175593036197924`"},
              {"97", "0.728481654883112`", 
                "0.14659792036675864`", \(-0.012528874500705358`\), 
                "0.19179736517628063`", 
                "0.3669305030139672`", \(-0.076974649602043`\)},
              {"98", "0.29269263100685244`", 
                "0.22810683588404757`", \(-0.0052778655494105245`\), 
                "0.1324058410224441`", "0.08973569891351336`", 
                "0.23329125356063465`"},
              {
                "99", \(-0.06724295871592058`\), \(-0.4837831914284223`\), \
\(-0.08888276050402999`\), "0.08451178538964373`", "0.39895855985826056`", 
                "0.3494657174239011`"},
              {"100", \(-1.1842880367816493`\), "0.10062976275441493`", 
                "0.4253987044359249`", 
                "0.23570846734247203`", \(-0.060620061532272174`\), 
                "0.0424213435294237`"},
              {"101", \(-0.6882017712914209`\), "0.1084543199539691`", 
                "0.08962384578096426`", "0.17595924245369784`", 
                "0.098884271956565`", "0.4081045891520685`"},
              {"102", "0.7918029874911249`", "0.47595432218456546`", 
                "0.1683765231412176`", \(-0.2710305891953821`\), \
\(-0.26505525618685266`\), \(-0.24003488052020835`\)},
              {
                "103", \(-0.8376413096667462`\), \(-0.047101355413384595`\), \
\(-0.00035453814805776673`\), \(-0.18134138471298422`\), 
                "0.18144840056641626`", "0.07375303485679961`"},
              {"104", "1.7881086995505728`", 
                "0.2069144017337688`", \(-0.19660681383990153`\), 
                "0.1896472282912499`", 
                "0.10233112719839155`", \(-0.006635516373354688`\)},
              {"105", \(-0.9137496015207369`\), \(-0.013957759282898635`\), 
                "0.255152881913829`", 
                "0.031938032525099684`", \(-0.3085825462542418`\), \
\(-0.19811777918186896`\)},
              {"106", "0.13741827615906135`", "0.1152848446460356`", 
                "0.09979604222970981`", 
                "0.15086791129690413`", \(-0.053899239501413454`\), \
\(-0.05253385426174549`\)},
              {"107", \(-0.38589615377383674`\), "0.018767111478734038`", 
                "0.1990233552834352`", "0.39818355312269005`", 
                "0.2150050392177546`", "0.0948756708350074`"},
              {"108", "0.37918616006663003`", "0.07356818866935554`", 
                "0.05795315266458121`", \(-0.04156243795646368`\), \
\(-0.0046429245893016904`\), \(-0.2008834295317771`\)},
              {"109", \(-1.223914908308332`\), \(-0.029384994000044597`\), 
                "0.35663269617778987`", \(-0.20738541708517746`\), 
                "0.3129329760605037`", "0.3606291023058855`"},
              {"110", "1.1152394451018226`", "0.10802273185111393`", 
                "0.22456831225473062`", 
                "0.18764516473068224`", \(-0.16751907902864682`\), 
                "0.02046607667990861`"},
              {"111", \(-1.1019565469040775`\), \(-0.18230791756652442`\), 
                "0.2843649850799334`", \(-0.09954429781536606`\), 
                "0.05989824919515424`", "0.2559663267460446`"},
              {"112", "0.804567791552889`", "0.16846144110896086`", 
                "0.28014351885539795`", \(-0.15627315346247597`\), 
                "0.2021613667469112`", "0.38904113649227245`"},
              {"113", "1.0384053709044698`", 
                "0.2462129416959796`", \(-0.19073575689327713`\), \
\(-0.20711430646383772`\), "0.15170591882016513`", "0.12107748496485549`"},
              {"114", "2.909736741343181`", 
                "0.8720711310146325`", \(-0.07842540031033088`\), \
\(-0.21955532830502422`\), "0.2056069484059367`", "0.35752023937136207`"},
              {"115", "1.1847767683323207`", 
                "0.3348705457135105`", \(-0.0047113787679617875`\), 
                "0.17668449393784982`", 
                "0.004379493527104872`", \(-0.0917733570922812`\)},
              {"116", \(-2.4241075300674155`\), "0.03190529220688432`", 
                "0.43967942053355086`", 
                "0.007325118644362132`", \(-0.08774189874464076`\), 
                "0.0632981931832773`"},
              {"117", \(-1.2920725630762637`\), \(-0.5433448240896629`\), 
                "0.012311162173077978`", "0.44902898114567996`", 
                "0.2379791912080737`", "0.10940306467332463`"},
              {"118", "0.7522944829973799`", 
                "0.3470677845233356`", \(-0.05122664665693864`\), \
\(-0.0330758486046247`\), "0.38024006616988315`", "0.1217176586079446`"},
              {"119", "1.1837133004909837`", 
                "0.3839760470083232`", \(-0.09868665081044271`\), 
                "0.014270708473504852`", "0.036383682787337196`", 
                "0.16816356162057283`"},
              {"120", \(-1.8649210193280998`\), \(-0.39565851998817075`\), 
                "0.0034460353903447848`", "0.07949582643199951`", 
                "0.1846444756705508`", \(-0.04379196340717714`\)},
              {"121", \(-1.633808496586543`\), "0.016362975797415052`", 
                "0.2666450627458613`", "0.09099826939482628`", 
                "0.43404554230285103`", "0.03074698741951348`"},
              {"122", \(-0.4497034809334174`\), \(-0.16131160970063`\), 
                "0.10807915850311581`", 
                "0.4187279814226058`", \(-0.0816564453594357`\), \
\(-0.30362867281439876`\)},
              {"123", "0.25886000417465066`", 
                "0.3369504407725906`", \(-0.17295584041714054`\), \
\(-0.3230087705199523`\), \(-0.09540454266710564`\), "0.3988767330979851`"},
              {"124", \(-2.967703857183769`\), \(-0.47487153288729916`\), 
                "0.2837156036721545`", 
                "0.0025865439868882917`", \(-0.03705621972197085`\), 
                "0.03861041211891366`"},
              {"125", "1.1606699067271626`", "0.07418612688581529`", 
                "0.022343734894861023`", "0.2026485781945506`", 
                "0.2773924806806196`", \(-0.011180181370578466`\)},
              {"126", \(-0.10836656755231926`\), "0.0627254816377828`", 
                "0.018531630156254125`", 
                "0.14330984526243395`", \(-0.22019466839555268`\), 
                "0.23464573927941818`"},
              {"127", "0.935770271269002`", "0.32277190531622846`", 
                "0.3547950335336586`", \(-0.0457450179853951`\), 
                "0.2979328448725726`", "0.19035556607026116`"},
              {"128", \(-1.9379935355273343`\), "0.14631503387903422`", 
                "0.5334895971742789`", 
                "0.08351116712026793`", \(-0.25125256806462587`\), \
\(-0.038708413403467874`\)},
              {"129", "3.1038695285882727`", 
                "0.643632052207627`", \(-0.4984737534183936`\), 
                "0.25815146904874764`", "0.18245857788230727`", 
                "0.032429647918313195`"},
              {"130", \(-1.1005709630137437`\), \(-0.3341072357820944`\), 
                "0.1854689649651085`", \(-0.019979481220249947`\), \
\(-0.2770921028956878`\), \(-0.11976733731211689`\)},
              {"131", \(-1.5769650378751736`\), \(-0.2626291248624314`\), 
                "0.515385284037093`", 
                "0.29352791440866277`", \(-0.12557843516321612`\), 
                "0.09050666976587024`"},
              {"132", \(-0.677193432373814`\), \(-0.03945178617637715`\), 
                "0.34305537525102575`", "0.14403649253839668`", 
                "0.023277415992165894`", \(-0.04012498550068315`\)},
              {"133", "0.06748052745704708`", "0.16160107888733138`", 
                "0.03177110937422411`", 
                "0.3284858330993366`", \(-0.008607254506086416`\), 
                "0.0785525714628004`"},
              {"134", \(-0.6303057667080597`\), "0.02486968729695848`", 
                "0.11585889393333769`", \(-0.10141286252805458`\), 
                "0.13048486848591254`", \(-0.010898596481490231`\)},
              {"135", \(-0.1890921042847657`\), \(-0.035536932008112726`\), 
                "0.3169067010709549`", "0.0489907119901294`", 
                "0.22093443460658754`", "0.4314493196069011`"},
              {"136", "1.2076324167126828`", 
                "0.24972983482847794`", \(-0.0982378154274221`\), 
                "0.1460085537142784`", "0.10480209925449693`", 
                "0.12199748310935868`"},
              {"137", "0.6558963565376518`", 
                "0.043193882125442826`", \(-0.14804546662441648`\), \
\(-0.008761426291129821`\), 
                "0.15981495720499658`", \(-0.08398385096867864`\)},
              {"138", "1.5426659067159578`", 
                "0.10500940731858542`", \(-0.15440889208814884`\), \
\(-0.08664427673171055`\), \(-0.3431298557626677`\), "0.04024833296644497`"},
              {"139", \(-0.5544319476329161`\), \(-0.2764481768069825`\), 
                "0.2806925378011886`", "0.35544918807770254`", 
                "0.2241343916556857`", "0.09170493417060763`"},
              {"140", \(-0.3850411394042789`\), \(-0.1183275342691464`\), 
                "0.17669802478100277`", "0.29454918396656266`", 
                "0.03537666528921922`", \(-0.05979078294852345`\)},
              {"141", \(-0.519787396905867`\), \(-0.10750214485688554`\), 
                "0.0986710886192834`", "0.006846174047005681`", 
                "0.23342016886533323`", "0.23399869497336243`"},
              {"142", "0.032450088125951244`", \(-0.2768840975874769`\), 
                "0.14712366545449077`", "0.14054153659502916`", 
                "0.02878065773843121`", "0.06106443854667767`"},
              {"143", \(-0.3616907344720769`\), \(-0.047674042302074504`\), 
                "0.06918322800344107`", "0.03493477843809921`", 
                "0.18920909733813937`", "0.015765112272978197`"},
              {"144", \(-0.4660183914772242`\), \(-0.08205811678426263`\), 
                "0.13923732324345342`", \(-0.10639956019376358`\), 
                "0.0019694969769446396`", "0.05691590405884739`"},
              {"145", \(-0.12224697895369441`\), \(-0.07480753376160613`\), 
                "0.12339960106816703`", 
                "0.15703409570011168`", \(-0.22635094919840373`\), 
                "0.04657053011182359`"},
              {"146", \(-0.028797547099183644`\), "0.2625382146963737`", 
                "0.14150524695524216`", "0.038392202234955826`", 
                "0.4098246561419516`", \(-0.03052645911959269`\)},
              {"147", "1.4069857472444767`", 
                "0.10339917116301552`", \(-0.26997742257961327`\), \
\(-0.11668752298034409`\), "0.19761693937820368`", \(-0.1804954633527803`\)},
              {"148", "1.6641509751789658`", 
                "0.17684920443486307`", \(-0.06944147880608298`\), 
                "0.208438146839975`", 
                "0.05709304422200516`", \(-0.007591583192101685`\)},
              {"149", \(-1.5420750749908483`\), "0.02657595518426376`", 
                "0.11101290021539448`", "0.06683144408199009`", 
                "0.2894032228183258`", "0.33819265065408677`"},
              {"150", "0.3468896722018268`", "0.45936800971488595`", 
                "0.4230797756825337`", 
                "0.02772930822364235`", \(-0.05504799048772443`\), \
\(-0.12013620367199696`\)},
              {"151", "0.09390478436212087`", "0.21875109611543408`", 
                "0.0874120158711755`", 
                "0.26016410040254273`", \(-0.03352434323742663`\), 
                "0.05416193688605921`"},
              {"152", \(-0.0331169138624508`\), \(-0.3883357653632411`\), 
                "0.1662532730536573`", "0.022498850402136214`", 
                "0.030155292997023006`", "0.04522757660122231`"},
              {"153", \(-0.030582187027859087`\), \(-0.37451256268845834`\), 
                "0.08679795278218767`", "0.16740274974852665`", 
                "0.009959881692367773`", \(-0.12576015664428045`\)},
              {"154", "1.8674631672460562`", 
                "0.22123077536965932`", \(-0.3063459501489507`\), \
\(-0.21016923329209314`\), \(-0.13975480075120197`\), 
                "0.20631382158522385`"},
              {"155", "1.865603490966829`", 
                "0.6064322445300641`", \(-0.41923653730208565`\), \
\(-0.12900480613053164`\), "0.235637949109537`", "0.13767245719471966`"},
              {"156", \(-0.6121463821593377`\), "0.369181638704155`", 
                "0.17286129413224635`", \(-0.21135872754626353`\), 
                "0.4807864119590205`", "0.09012286950618313`"},
              {"157", \(-1.0034379706449392`\), "0.20907092127963944`", 
                "0.41873854752527906`", "0.11754296575453979`", 
                "0.17615656533978497`", "0.09035965438172523`"},
              {"158", "0.6059615201689168`", "0.23951990907809523`", 
                "0.0013955754826787696`", "0.15832486808920102`", 
                "0.26475090816754765`", "0.208562628721367`"},
              {"159", "0.975278724030327`", "0.2324121543072572`", 
                "0.04006984300538979`", "0.028343679044695907`", 
                "0.11425199809451773`", "0.07565711268436556`"},
              {"160", "0.758934574714068`", "0.11179609668783853`", 
                "0.001886380196502289`", "0.019163936506382213`", 
                "0.23279279969167915`", "0.25618704188935143`"},
              {"161", "1.2235453573781785`", "0.08490175313887392`", 
                "0.06644648367065081`", \(-0.01755454015132165`\), \
\(-0.13436956860115112`\), \(-0.040087278020089684`\)},
              {"162", \(-0.67860618940214`\), "0.028899632325268883`", 
                "0.2486461849936251`", \(-0.037734966454839765`\), 
                "0.32178330698477825`", "0.2819397587928476`"},
              {"163", "0.12347269588785773`", "0.204097967039288`", 
                "0.25875930976984646`", \(-0.3598592298400681`\), 
                "0.004474468909184239`", "0.1720808376540121`"},
              {"164", \(-0.5919882541094793`\), 
                "0.07678708997830874`", \(-0.2686788669896842`\), 
                "0.1865239293634134`", "0.12966074987150183`", 
                "0.00022694659952951537`"},
              {
                "165", \(-0.05601914670889513`\), \(-0.09743631124329112`\), \
\(-0.14997157936461175`\), "0.05809987357466121`", "0.23791308417470472`", 
                "0.28223494043573477`"},
              {"166", \(-0.29675673139413267`\), "0.02889728552219451`", 
                "0.039777339745991416`", "0.0013350439462764673`", 
                "0.005556271399124159`", "0.08808743151162217`"},
              {
                "167", \(-0.21353626410160592`\), \(-0.2576237013258122`\), \
\(-0.18079641050971776`\), "0.2599630086194441`", "0.2246276670572786`", 
                "0.33320994535847015`"},
              {"168", 
                "1.4639916610689316`", \(-0.05103011956597019`\), \
\(-0.48564348987866457`\), \(-0.00040967576002118734`\), 
                "0.44434434336880557`", "0.3435898482729183`"},
              {"169", "0.9885658550981505`", 
                "0.10213637658270935`", \(-0.24705788746143068`\), 
                "0.02521597001627937`", 
                "0.029834636309832626`", \(-0.10081978216857886`\)},
              {"170", \(-1.1979922353833448`\), "0.014763468749889572`", 
                "0.03545753767382588`", \(-0.20709917184556767`\), 
                "0.01106894390231725`", "0.054319237910013175`"},
              {"171", "0.4046189264887757`", "0.27349941784193144`", 
                "0.27788932288707957`", \(-0.04724308646559122`\), 
                "0.020476156250434602`", \(-0.07862318005811562`\)},
              {"172", "0.10097522145134012`", \(-0.1412750215011108`\), 
                "0.05490093918194715`", 
                "0.17270423603924978`", \(-0.26226193764399874`\), \
\(-0.027337016860953658`\)},
              {"173", \(-1.4528155629582271`\), \(-0.07820851619504181`\), 
                "0.44042436926562395`", \(-0.0871981203686274`\), 
                "0.05425066312875387`", "0.10065462274522732`"},
              {"174", \(-0.8578150802905586`\), \(-0.1073176466758838`\), 
                "0.11309526644307387`", 
                "0.21947737038366813`", \(-0.07627507547492998`\), 
                "0.24956835868140745`"},
              {"175", "0.39454761468687566`", "0.19441074319203913`", 
                "0.04077208610324906`", "0.12044342784472897`", 
                "0.06543061517252245`", "0.15335449888362945`"},
              {"176", "1.38814162864184`", 
                "0.49299299685965353`", \(-0.031205309673735627`\), \
\(-0.18593152257195952`\), "0.0522737705661363`", "0.22600591028482248`"},
              {"177", "0.6153202886280934`", 
                "0.5358115060697213`", \(-0.06029586278162423`\), 
                "0.17003973368156083`", "0.42452617782026975`", 
                "0.1447210062930301`"},
              {"178", \(-0.49289338971295804`\), "0.2361508181881449`", 
                "0.38455420340782037`", 
                "0.13502342544738313`", \(-0.14730248208828314`\), \
\(-0.10505468924979028`\)},
              {"179", "1.9513186667072122`", 
                "0.11682664463878369`", \(-0.3037007856978339`\), \
\(-0.1807585604472001`\), "0.029441917068984608`", "0.19422290240081871`"},
              {"180", \(-2.618347111670825`\), \(-0.2584567212860538`\), 
                "0.4272527797956275`", "0.502929777135076`", 
                "0.17715880966312403`", \(-0.16342064835413542`\)},
              {"181", \(-0.5696950101364728`\), \(-0.25284841541187386`\), 
                "0.14250446883132076`", 
                "0.0704746594388682`", \(-0.1101613001555113`\), 
                "0.08123778645819495`"},
              {"182", "1.8946472149776135`", 
                "0.41060773039566634`", \(-0.30468388765541743`\), \
\(-0.3239536924227783`\), \(-0.11831132634340429`\), "0.2760800834558173`"},
              {
                "183", \(-1.1529264992645012`\), \(-0.01902282047620938`\), \
\(-0.01815269195246446`\), "0.24269312734567292`", 
                "0.21973843508978846`", \(-0.2906130486145261`\)},
              {"184", "1.7131258286471782`", 
                "0.1045030300168237`", \(-0.25239164019085514`\), 
                "0.2730921383339954`", "0.5791449557140445`", 
                "0.039924663141329815`"},
              {"185", \(-0.1576834190663409`\), "0.16867049212671684`", 
                "0.25885114817865673`", 
                "0.10580058887628713`", \(-0.004388856494786421`\), 
                "0.030226492908340962`"},
              {"186", "2.2556311239517024`", 
                "0.4018292480526586`", \(-0.15456812567243342`\), 
                "0.2533781216976458`", \(-0.08033587373146368`\), \
\(-0.09186724374096615`\)},
              {"187", "0.6478602948228938`", 
                "0.013611288279812181`", \(-0.06625930673668692`\), \
\(-0.06480086237785872`\), "0.23244301877527143`", "0.08280592195028706`"},
              {"188", "0.8160340032418293`", 
                "0.187446772246553`", \(-0.5274319760290698`\), \
\(-0.16724688224851514`\), \(-0.053219499342386505`\), 
                "0.29925869048473397`"},
              {"189", "0.04453888049461792`", "0.18455517379579445`", 
                "0.0190871135381435`", "0.2563116528696036`", 
                "0.15234309521782013`", "0.03382499687355367`"},
              {"190", \(-0.6118793182104403`\), "0.14356539031797996`", 
                "0.30982740736081754`", "0.13789376709990547`", 
                "0.07549039562932708`", \(-0.09117920398237468`\)},
              {"191", "0.19922578814358863`", 
                "0.020090966803514333`", \(-0.005259557327052433`\), 
                "0.06414913471956084`", "0.2028799902043214`", 
                "0.2527824269507145`"},
              {"192", "0.37929461116537816`", "0.2531289205732028`", 
                "0.127250762842169`", "0.07468738597229137`", 
                "0.008041439410578728`", "0.363341633357693`"},
              {"193", \(-0.6313202162860886`\), \(-0.4127310584019913`\), 
                "0.21971155422234628`", 
                "0.05868544840538432`", \(-0.1047895410477373`\), \
\(-0.14707113760261695`\)},
              {"194", "1.3813649409284239`", "0.35482259780192393`", 
                "0.06952106843020585`", \(-0.1604440455264109`\), 
                "0.4990591789376051`", "0.3128020543138612`"},
              {"195", "1.7990792389309336`", 
                "0.4275371382498035`", \(-0.022380092468696572`\), 
                "0.3155484621577152`", "0.0894015960650679`", 
                "0.2009860515343748`"},
              {"196", "0.910077859712631`", 
                "0.16840090897138038`", \(-0.0858140598273939`\), 
                "0.033257338836881443`", \(-0.055705203533563036`\), \
\(-0.10237171841570605`\)},
              {"197", \(-0.799995178549197`\), \(-0.12566113417050356`\), 
                
                "0.315262328414115`", \(-0.3619470495757523`\), \
\(-0.28455140059286854`\), "0.16442397547441487`"},
              {"198", "1.3158987244989424`", 
                "0.2647674899108145`", \(-0.4706099659990108`\), 
                "0.2530194585388159`", "0.45750468238622427`", 
                "0.32314220612266087`"},
              {"199", \(-0.42230917818810965`\), \(-0.10105194653812376`\), 
                "0.08319365645716002`", \(-0.11468891428161879`\), 
                "0.2411032772956307`", \(-0.2547857077996534`\)},
              {"200", "1.7646790533100762`", "0.18417047794111002`", 
                "0.03712997384190547`", 
                "0.04752759194400022`", \(-0.12750840621102674`\), 
                "0.05975403948445044`"},
              {"201", \(-1.7974272171054253`\), \(-0.239801069423329`\), 
                "0.21472736839900142`", "0.19640318369122306`", 
                "0.22240929787371155`", "0.04632232279397496`"},
              {"202", "0.6015437050047167`", "0.1839401504073946`", 
                "0.22969963263147258`", "0.2559955120006204`", 
                "0.14358213402415193`", \(-0.07789451310576274`\)},
              {"203", \(-0.30234153266079267`\), \(-0.0360376264346407`\), 
                "0.004213528675013613`", \(-0.11275731568555566`\), \
\(-0.32189662452227435`\), "0.1277921367360994`"},
              {"204", "0.7649564058963509`", 
                "0.18930263939808167`", \(-0.12031040445306239`\), 
                "0.17412893038248617`", 
                "0.08657573708183029`", \(-0.06616655885908285`\)},
              {"205", \(-2.3332928322051116`\), \(-0.1457374593500002`\), 
                "0.33230298703586303`", "0.2510259894967629`", 
                "0.03772786387958225`", "0.21375958640315904`"},
              {"206", 
                "0.11327288956432596`", \(-0.1152511771571034`\), \
\(-0.09459959001331292`\), \(-0.49632511423198167`\), \
\(-0.006228038770456246`\), "0.239079981321157`"},
              {"207", 
                "0.476144396208638`", \(-0.02885156463177233`\), \
\(-0.29609941027433534`\), \(-0.12772458498430483`\), "0.13260809569699808`", 
                "0.3596009875658931`"},
              {"208", \(-0.7956374173318105`\), \(-0.20054454548837358`\), 
                "0.13947722382063193`", "0.2536423811185231`", 
                "0.01656671690558636`", \(-0.057603041442508426`\)},
              {"209", "0.6638030768585925`", 
                "0.16325065717146597`", \(-0.1274254146993194`\), \
\(-0.1255155923887224`\), "0.04026272392706331`", "0.33350018230947476`"},
              {"210", "0.8979503063249903`", "0.2780121360288118`", 
                "0.08019117847131375`", \(-0.05412786188005101`\), 
                "0.21082890871139626`", "0.03246263632052877`"},
              {"211", \(-0.3124414181711891`\), 
                "0.15652735701867718`", \(-0.11477511847057836`\), \
\(-0.3079696036078772`\), \(-0.10895409041662119`\), "0.11614160124097633`"},
              {"212", "2.2356400443802094`", 
                "0.4484167113379646`", \(-0.3096188175939335`\), 
                "0.16378605694258325`", "0.4426913326554278`", 
                "0.2419249922462338`"},
              {"213", \(-1.8207717800706558`\), \(-0.10152200639656406`\), 
                "0.4964202704608294`", 
                "0.0730724276329882`", \(-0.04640740711224825`\), 
                "0.00541868732960585`"},
              {"214", \(-0.5467190245645722`\), "0.28753032295569164`", 
                "0.2686234720220123`", "0.06858736915943871`", 
                "0.035578743861759556`", "0.06883152523213479`"},
              {"215", "0.3503136438898946`", "0.09107687664928686`", 
                "0.1421854020391178`", 
                "0.04400598225990581`", \(-0.15064806637027595`\), \
\(-0.026745999975097755`\)},
              {"216", \(-0.6415159275181408`\), \(-0.09028158325707344`\), 
                "0.4420107600303806`", "0.20983287746605067`", 
                "0.18774515516961668`", \(-0.028769318641559908`\)},
              {"217", "1.0903773187708956`", 
                "0.3428389479047337`", \(-0.16541690756881453`\), 
                "0.15992779910167818`", 
                "0.07890361726280729`", \(-0.08257284057866765`\)},
              {"218", \(-1.762177545845063`\), \(-0.389197275497543`\), 
                "0.37195236418958283`", 
                "0.1552563943601508`", \(-0.04490402174889001`\), 
                "0.19614681289428293`"},
              {
                "219", \(-0.18323766718298665`\), \(-0.018262644206526676`\), \
\(-0.07725888594254114`\), \(-0.0166036149813697`\), "0.37255734643808713`", 
                "0.049177336080311634`"},
              {"220", \(-1.1915768465112966`\), \(-0.16355190932770666`\), 
                "0.16649181700242394`", \(-0.03266286383040944`\), 
                "0.12819395905585942`", "0.3432349817429117`"},
              {"221", \(-0.03227761920082954`\), 
                "0.19261388906724172`", \(-0.1005212302073849`\), 
                "0.041347154722423216`", "0.10387325363324124`", 
                "0.059498095835740845`"},
              {"222", \(-0.8714611867726866`\), "0.14401360263452728`", 
                "0.32880436021608833`", \(-0.008733749982419025`\), 
                "0.08048702954309093`", "0.5101448250348497`"},
              {"223", \(-0.4990898209729816`\), \(-0.13580404565176787`\), 
                "0.154586150162525`", \(-0.16038075011813158`\), \
\(-0.0828771747677159`\), \(-0.0586824634327918`\)},
              {"224", \(-1.2421027265761544`\), \(-0.05864447998131111`\), 
                "0.09363957346937928`", "0.09746047527596757`", 
                "0.19960762679218388`", \(-0.17178328773102028`\)},
              {
                "225", \(-0.7857931354602004`\), \(-0.3997029621735042`\), \
\(-0.044965473956646664`\), "0.06187808569790303`", "0.009514506915566712`", 
                "0.057160878521354645`"},
              {"226", "0.6252315440482534`", 
                "0.2515510622584744`", \(-0.0647060533498394`\), 
                "0.30502264423676356`", "0.3509469246138289`", 
                "0.3024165244697222`"},
              {"227", \(-2.3088847292475254`\), \(-0.1415909304273651`\), 
                "0.33783108748117807`", \(-0.33092954697797855`\), \
\(-0.011114599632168286`\), \(-0.06245866966911577`\)},
              {"228", "0.6299555508982102`", 
                "0.05070247029265262`", \(-0.37497779025671635`\), \
\(-0.08790643683865929`\), "0.07000214270800753`", "0.29555613581259715`"},
              {"229", "0.06217514110542765`", \(-0.1893009984611744`\), 
                "0.08040168754649087`", "0.1100066424066822`", 
                "0.14663195479666277`", \(-0.22292525362266377`\)},
              {"230", \(-1.2142153036685193`\), \(-0.12600591612498682`\), 
                "0.38681274042433844`", "0.3060298159112392`", 
                "0.06070638339697593`", \(-0.16700169752096897`\)},
              {"231", \(-2.6191458795357336`\), \(-0.14750851010363217`\), 
                "0.17450720910862486`", 
                "0.1074927069295052`", \(-0.09895464245869791`\), 
                "0.021760702141733337`"},
              {"232", 
                "0.614960807219879`", \(-0.1625333888897674`\), \
\(-0.10198690324405627`\), "0.37546934993217523`", 
                "0.005663124427368507`", \(-0.0813319578713385`\)},
              {"233", "1.0942977608511715`", 
                "0.38447147963058764`", \(-0.31525325275591554`\), 
                "0.061959508152608325`", "0.28320096923437876`", 
                "0.12968374125247606`"},
              {"234", "1.448711270779237`", 
                "0.3481126676341098`", \(-0.1310114258430677`\), 
                "0.10699016279697085`", \(-0.055403840819167195`\), 
                "0.1693515225509861`"},
              {"235", "0.1540006968705768`", 
                "0.31588449577770084`", \(-0.003743639730612874`\), \
\(-0.13987942494679945`\), "0.19655360663178253`", "0.0023902809084868724`"},
              {"236", \(-0.986213640945026`\), \(-0.07623179185621663`\), 
                "0.4275923875099381`", 
                "0.2254746089561616`", \(-0.029605295895931454`\), 
                "0.04437314494494791`"},
              {"237", \(-0.0795991785659438`\), \(-0.09766130280808313`\), 
                "0.17716865027548223`", 
                "0.07234947396959278`", \(-0.2230904847197955`\), 
                "0.28850680491044856`"},
              {"238", "1.603104092823129`", 
                "0.3648620985665098`", \(-0.34024752565106686`\), \
\(-0.14830887356391706`\), \(-0.143316910598273`\), "0.15446156554511453`"},
              {"239", "0.8825923722050344`", "0.05882860625941227`", 
                "0.0009363894900346787`", "0.15451515443178385`", 
                "0.36730464892961595`", "0.3924212793766532`"},
              {"240", \(-0.7448014863222435`\), "0.04272099626671468`", 
                "0.2215040658222151`", 
                "0.14963217027376857`", \(-0.0581480898113994`\), \
\(-0.12482225058502512`\)},
              {"241", "0.8533485396478009`", "0.21207423571619885`", 
                "0.016394099066899592`", 
                "0.10483949011023738`", \(-0.11750218012805015`\), 
                "0.1346242774241149`"},
              {"242", "0.18103777531778834`", "0.39555099379186526`", 
                "0.09843202612852212`", "0.11820455177418666`", 
                "0.14624415114285105`", "0.3214019417906156`"},
              {"243", "0.5124555159695331`", 
                "0.13127752443705618`", \(-0.005818485107110741`\), 
                "0.04121590661121053`", "0.19870221341087493`", 
                "0.052243678230023446`"},
              {"244", "0.9858270880937381`", 
                "0.2178926932786296`", \(-0.2168304439943536`\), \
\(-0.16909640677684734`\), \(-0.18314152979558299`\), \(-0.08252815009176186`\
\)},
              {"245", \(-1.5131071283929685`\), "0.045778802914584055`", 
                "0.13582911626236222`", \(-0.10072059974323372`\), \
\(-0.07355878547298525`\), "0.07761740939206954`"},
              {"246", "1.07349493027228`", "0.2190158914595553`", 
                "0.05805026563082443`", \(-0.0865104251095353`\), \
\(-0.10726702108163977`\), "0.3626557831238314`"},
              {"247", \(-0.42889206218467985`\), \(-0.13568257494748934`\), 
                "0.2718402815997732`", 
                "0.06866806783243275`", \(-0.07329525504672833`\), \
\(-0.04983364510928422`\)},
              {"248", \(-1.2196775705599103`\), "0.1018910591281183`", 
                "0.30705704572302855`", \(-0.03063541057149821`\), \
\(-0.07884410522618848`\), \(-0.11417342219333551`\)},
              {"249", "1.6217453120278076`", 
                "0.40026243612294676`", \(-0.5222187305369244`\), 
                "0.2250413705948288`", "0.13449143450817955`", 
                "0.0007427298151345158`"},
              {"250", "1.221730392730059`", 
                "0.21951183187745352`", \(-0.20370429255025793`\), 
                "0.0007370299427534309`", \(-0.036384149438686106`\), 
                "0.19456922048052847`"},
              {"251", "0.3700785578024029`", \(-0.14401135127965006`\), 
                "0.22960790175749127`", 
                "0.3559714838358763`", \(-0.10653217044215557`\), 
                "0.04848496378142278`"},
              {"252", \(-0.7799938819092681`\), \(-0.2583002247125366`\), 
                "0.29864600016620796`", "0.1649050575600831`", 
                "0.16032560934584356`", \(-0.01939039304760639`\)},
              {"253", "0.8467127670255239`", 
                "0.21619984341275275`", \(-0.01477549645482817`\), 
                "0.2666282619025942`", "0.09339074588393588`", 
                "0.18214888402053114`"},
              {"254", 
                "0.20562775190197352`", \(-0.055945815528346064`\), \
\(-0.05091676517210904`\), \(-0.14131134576441673`\), \
\(-0.008728746440759813`\), "0.14982844699530956`"},
              {"255", \(-1.1845054255692091`\), \(-0.15899803519187322`\), 
                "0.3443672324732255`", "0.28646827519234613`", 
                "0.23111965057323056`", "0.4036951654537059`"},
              {"256", \(-1.4754398810064608`\), \(-0.3379684367200534`\), 
                "0.05058484195261456`", 
                "0.25687180548793304`", \(-0.15436445522571368`\), 
                "0.018428355353063884`"},
              {
                "257", \(-0.961812567284189`\), \(-0.2172062126511299`\), \
\(-0.08315925863362084`\), \(-0.05849228322252923`\), "0.4035186991687173`", 
                "0.07993696019471716`"},
              {"258", \(-0.9284928850180225`\), \(-0.2202114294310692`\), 
                "0.3991535581365675`", 
                "0.13216145184543157`", \(-0.007931875228450182`\), 
                "0.1684757172856516`"},
              {"259", "1.771885092592672`", "0.0936258262801485`", 
                "0.03125118810248648`", 
                "0.20448549730646476`", \(-0.0491047246477156`\), 
                "0.28151862744309536`"},
              {"260", "0.8517614756957105`", 
                "0.13951619689020073`", \(-0.2256969856768353`\), 
                "0.14047106351003424`", \(-0.022196057091390924`\), \
\(-0.15798056559557455`\)},
              {"261", \(-0.1314935484726695`\), "0.07065124534393229`", 
                "0.041363926112242405`", "0.28956405780164307`", 
                "0.020436519277545286`", "0.21994727888778262`"},
              {"262", \(-0.01085089176698692`\), "0.2525179021212623`", 
                "0.005905153553719966`", 
                "0.06715705339308253`", \(-0.03334020470695947`\), 
                "0.12988132684445405`"},
              {"263", "0.47788960311297113`", "0.1888253629316526`", 
                "0.07258990341285536`", "0.07917076941560425`", 
                "0.06594848389250138`", \(-0.23179701984939255`\)},
              {"264", \(-1.570856148417938`\), \(-0.13755738219535416`\), 
                "0.3948008517586568`", 
                "0.031671855130921515`", \(-0.21624159542362725`\), 
                "0.08652130940151731`"},
              {"265", \(-1.2899717680710627`\), \(-0.004513876793333636`\), 
                "0.1443011707290104`", "0.060933490669989945`", 
                "0.30768141968563817`", \(-0.07451027987425493`\)},
              {"266", "0.6527217177815947`", \(-0.23769803317149804`\), 
                "0.028647644612616735`", \(-0.019426262097204224`\), \
\(-0.31394271825756476`\), "0.08950806412995145`"},
              {"267", \(-0.39317258483583317`\), "0.11329364006898546`", 
                "0.048545199335014166`", \(-0.005220061434219727`\), 
                "0.0389809544862014`", \(-0.0948900919342655`\)},
              {"268", \(-0.5782155346071661`\), 
                "0.02344154501261671`", \(-0.2461667251098954`\), \
\(-0.10283959885431693`\), "0.32451380256082896`", "0.007489191399398259`"},
              {"269", 
                "0.1254618274845173`", \(-0.3731146787486645`\), \
\(-0.04918720750573056`\), "0.17733762130401556`", 
                "0.020359738159805615`", \(-0.037877707410485933`\)},
              {"270", \(-0.7306956977145072`\), \(-0.02085641542283487`\), 
                "0.09434031155252566`", "0.06856867137616955`", 
                "0.30566923201610957`", \(-0.27212936403964466`\)},
              {"271", "0.4518429406292235`", "0.35517446022430865`", 
                "0.2569228811043408`", \(-0.0924423885491619`\), \
\(-0.25470811946781274`\), \(-0.006558231576519435`\)},
              {
                "272", \(-1.3676332642703952`\), \(-0.07464915571334889`\), \
\(-0.06655012508559074`\), "0.08406429636008682`", 
                "0.0609286658665008`", \(-0.24538917221917192`\)},
              {"273", 
                "0.6070407033832439`", \(-0.023236565244943528`\), \
\(-0.08629450846904695`\), \(-0.12990816633681349`\), 
                "0.030672614535052253`", \(-0.008625761364396857`\)},
              {"274", \(-0.9603403572450562`\), \(-0.10092800564460884`\), 
                "0.13013857815143698`", "0.18491961129920567`", 
                "0.01949911974832025`", "0.1877680016403044`"},
              {"275", "0.6987950434471304`", "0.5227812740480833`", 
                "0.1318735663241593`", 
                "0.1699333561226307`", \(-0.08786387746076608`\), \
\(-0.24195890728449995`\)},
              {"276", "0.7232344901885932`", 
                "0.4142546035619195`", \(-0.2857883359955642`\), \
\(-0.007733327105485776`\), 
                "0.3118072147144431`", \(-0.09086122744652321`\)},
              {"277", \(-2.341193907960529`\), \(-0.34599983592466577`\), 
                "0.46913770785069736`", 
                "0.06512589637400445`", \(-0.37440393718806947`\), 
                "0.09398158993715965`"},
              {"278", "0.8168879928344681`", "0.24410504979831024`", 
                "0.31460325790814536`", \(-0.027997604301738765`\), 
                "0.41144806601151485`", "0.33427591523708017`"},
              {
                "279", \(-0.45106677832846426`\), \(-0.21007002838508`\), \
\(-0.14163515853552433`\), \(-0.012682549022351506`\), "0.3647320378104955`", 
                "0.1540053523493722`"},
              {"280", \(-1.741439289059585`\), \(-0.25259895373668634`\), 
                "0.48985866863727434`", \(-0.039551983657527816`\), 
                "0.167634206149554`", "0.019434834244055926`"},
              {"281", "0.8469049339150752`", "0.4804460172913102`", 
                "0.0019907752233463407`", \(-0.09710150641348168`\), 
                "0.09543737467476508`", "0.17307988349377296`"},
              {"282", 
                "0.0624930530910914`", \(-0.14201256234917947`\), \
\(-0.18335316233548016`\), "0.06721663898589679`", "0.20630279152887754`", 
                "0.06458662773586588`"},
              {"283", "0.47691239133434504`", 
                "0.014391146334999251`", \(-0.03833664377243749`\), \
\(-0.012283231468290957`\), \(-0.06457900333771012`\), 
                "0.11445979314048373`"},
              {"284", \(-0.030659682210106863`\), \(-0.0035067389572197324`\),
                 "0.07421169890742911`", "0.08195853176715376`", 
                "0.008442051026915035`", \(-0.08769842039303134`\)},
              {"285", "0.1338809862255075`", \(-0.020097819773412292`\), 
                "0.011592716808826866`", "0.012799122791469178`", 
                "0.016848349608963573`", \(-0.079948141216384`\)},
              {"286", "0.8476810045001795`", "0.1858460889452895`", 
                "0.01806551020323818`", "0.14695834254842036`", 
                "0.24883864299725741`", \(-0.0894709052201229`\)},
              {"287", \(-0.15402044612304824`\), "0.04593126063414947`", 
                "0.18216396260875958`", "0.012786274231672884`", 
                "0.09002971648480727`", "0.15636254106978992`"},
              {"288", \(-0.4119621105679264`\), "0.10809501502310065`", 
                "0.29089225643106253`", "0.06395905132902484`", 
                "0.13948204872902156`", \(-0.023990297700797955`\)},
              {"289", "0.4634014534432121`", 
                "0.26611993502003317`", \(-0.12166107042281`\), 
                "0.24842419921468203`", \(-0.005083031165252668`\), \
\(-0.03392374289136618`\)},
              {"290", \(-0.5142205278508112`\), "0.1262390444717155`", 
                "0.2873620617713008`", 
                "0.21056364410543948`", \(-0.05573326606823651`\), 
                "0.31310079237690164`"},
              {"291", \(-0.37109509566693105`\), "0.01614491071799683`", 
                "0.06531064752597225`", "0.06286499736160789`", 
                "0.08573591073764865`", \(-0.26159659698426324`\)},
              {"292", \(-1.185318756535644`\), \(-0.08638308473419307`\), 
                "0.40708616219470856`", "0.10528142989302704`", 
                "0.33989512533298943`", \(-0.07127941213100082`\)},
              {"293", \(-2.1452788985988973`\), \(-0.31068927044690486`\), 
                "0.41411534015972207`", "0.009987882448418898`", 
                "0.12272092129570668`", "0.017567724611302606`"},
              {"294", \(-0.5228904679339481`\), \(-0.14423064340406697`\), 
                "0.5168134242351393`", 
                "0.2553632807383542`", \(-0.010851691319456453`\), \
\(-0.1106656875354358`\)},
              {"295", \(-0.4816432864183965`\), \(-0.17356987075974026`\), 
                "0.19931062899681387`", "0.1140483229834664`", 
                "0.15701654245355265`", \(-0.1268722400759613`\)},
              {"296", \(-1.5704972662034296`\), "0.033469413370979584`", 
                "0.4346723973473213`", \(-0.1796952032313245`\), 
                "0.30379179880120216`", "0.0018025719254320624`"},
              {"297", "1.212220835359096`", 
                "0.3027200018631006`", \(-0.2017421771584294`\), \
\(-0.00745905526062507`\), "0.17825926710903342`", "0.06012648046950337`"},
              {"298", "1.3737634063218471`", 
                "0.3361617901467775`", \(-0.2869761139466123`\), 
                "0.2501482348231755`", "0.4219660693548724`", 
                "0.1505896061510529`"},
              {"299", 
                "0.5185912483756674`", \(-0.05514582060151026`\), \
\(-0.17239578322165813`\), "0.06300194236261328`", "0.1553009206978196`", 
                "0.1530093928167844`"},
              {"300", 
                "0.6511487354198219`", \(-0.11485141517209176`\), \
\(-0.14452966599170358`\), "0.05147091861269723`", "0.4592253410084895`", 
                "0.13860846083591735`"},
              {
                "301", \(-1.1436706844915412`\), \(-0.4912427377224733`\), \
\(-0.06919795183784204`\), 
                "0.23194107059167976`", \(-0.2001773714619474`\), \
\(-0.00036815407775281773`\)},
              {"302", "1.8353290237446194`", 
                "0.31440590690667436`", \(-0.3171174377654856`\), \
\(-0.16018470908887822`\), \(-0.13659265722387898`\), \(-0.06459295871999207`\
\)},
              {"303", "0.5329104795773344`", "0.1435786601906093`", 
                "0.09671442949924948`", "0.14843699512664021`", 
                "0.012395438122432947`", "0.1154299254466783`"},
              {"304", "0.006132295548343625`", "0.08437778654557604`", 
                "0.32720140577148005`", 
                "0.2511073995097201`", \(-0.12181782354237926`\), 
                "0.11412167794417229`"},
              {"305", \(-0.20007432825479035`\), \(-0.268720999445003`\), 
                "0.07764626777984084`", "0.12689403628064994`", 
                "0.06433927887562665`", "0.11644319075925016`"},
              {"306", \(-0.16097985052098104`\), "0.015179428692105871`", 
                "0.17796671400701947`", \(-0.0011290517829298202`\), 
                "0.001152336300690912`", "0.04593802750125`"},
              {"307", "0.20936722522513676`", 
                "0.19299169684884243`", \(-0.19090215897706753`\), \
\(-0.05677922976230328`\), "0.1697168693845709`", \(-0.06438113593731601`\)},
              {"308", "0.5131466606927074`", "0.07422384262468473`", 
                "0.08318474733440834`", 
                "0.06343101138572037`", \(-0.0209133023404226`\), 
                "0.3010005706827239`"},
              {"309", "0.37730346147248095`", 
                "0.21492225425114012`", \(-0.19081615294802523`\), 
                "0.1825582083603191`", 
                "0.08339098705492845`", \(-0.021938574639804212`\)},
              {"310", "0.9828234889689326`", 
                "0.007550640056462101`", \(-0.05734240557999719`\), 
                "0.14756251835703174`", "0.30973344596154384`", 
                "0.2577598495629484`"},
              {"311", \(-0.5185581597384784`\), "0.2571550792691146`", 
                "0.2445031190133227`", "0.0396961534008334`", 
                "0.13166684390692796`", "0.0999930922203955`"},
              {"312", \(-0.037216148727675806`\), \(-0.3908606908719737`\), 
                "0.07382427066248985`", 
                "0.02556814651216194`", \(-0.1814466673239747`\), 
                "0.09423916600273699`"},
              {"313", \(-0.4092619998243481`\), "0.15163173148763448`", 
                "0.20635612166438877`", 
                "0.10707716745521173`", \(-0.10506858454565893`\), 
                "0.21345077699923595`"},
              {"314", \(-0.28685632268158034`\), "0.14484590300918618`", 
                "0.03162700562615887`", "0.10280360272248978`", 
                "0.03120786886530904`", "0.1633780351001463`"},
              {"315", "0.099056509371228`", "0.36855339633206424`", 
                "0.27719199893841867`", \(-0.043243458504936244`\), 
                "0.3076226225227591`", "0.1401743721359473`"},
              {"316", \(-1.4848565708099475`\), \(-0.3053523870824211`\), 
                "0.43175474718950463`", "0.2550436547021464`", 
                "0.23716135278733885`", "0.1308367157989182`"},
              {"317", "0.033377838900039994`", "0.06122181643277597`", 
                "0.03162636347870384`", \(-0.28191863235158166`\), 
                "0.277284621867423`", "0.3035486337857192`"},
              {"318", "1.426772496446479`", 
                "0.4012403167042134`", \(-0.26464188961494706`\), \
\(-0.18209653240464596`\), "0.12681473000844226`", "0.05412439825594217`"},
              {"319", "0.47913798588381207`", 
                "0.31276712588105676`", \(-0.009492799825358694`\), 
                "0.212142695901018`", 
                "0.16968742234596296`", \(-0.21724404761998423`\)},
              {"320", "0.021334302914160514`", "0.19970793158729466`", 
                "0.08638949823061264`", \(-0.05872459819261163`\), 
                "0.30534462935750045`", "0.02876654655859783`"},
              {"321", "0.379918193941212`", 
                "0.03611292568189071`", \(-0.11078461076611351`\), 
                "0.20902459433401935`", "0.23106400914535155`", 
                "0.05235569314680726`"},
              {"322", \(-0.41988374670493583`\), \(-0.10594117926351786`\), 
                "0.20928095991368645`", 
                "0.0020903940053804255`", \(-0.08058207131413761`\), \
\(-0.10857650597945051`\)},
              {"323", "1.289370735784247`", 
                "0.05748876092852765`", \(-0.2189286127936852`\), 
                "0.3034727175422247`", \(-0.1872856614360529`\), \
\(-0.07903169564863044`\)},
              {"324", \(-1.5059954841223626`\), "0.07748940166432745`", 
                "0.39267449948789834`", \(-0.05109226454753758`\), \
\(-0.06307180712076738`\), \(-0.31425332412874685`\)},
              {
                "325", \(-0.7868148976024918`\), \(-0.29599445767194293`\), \
\(-0.2863349829632638`\), "0.3239806743766495`", 
                "0.011360787964200854`", \(-0.042012155555331256`\)},
              {
                "326", \(-1.1868552143957334`\), \(-0.2261736949897456`\), \
\(-0.03971043455395679`\), "0.08673476398306919`", "0.05720962054048212`", 
                "0.006706543121190544`"},
              {"327", \(-0.41377864401621556`\), "0.1687677079011286`", 
                "0.06281883599713958`", "0.045846639999388074`", 
                "0.2907203057537167`", "0.30879885809753044`"},
              {"328", \(-0.5121349424793734`\), \(-0.13455753105657728`\), 
                "0.042828693772394275`", 
                "0.1067348452926756`", \(-0.026005557010598295`\), 
                "0.1181391471881764`"},
              {"329", \(-0.7949590882874099`\), "0.08893298322474212`", 
                "0.33946912328902146`", 
                "0.23754441045445754`", \(-0.06526037620343443`\), \
\(-0.09066796751531453`\)},
              {"330", "0.6254979467989219`", "0.05571569389070857`", 
                "0.07892410397122188`", "0.2151530895810055`", 
                "0.01922068028295728`", \(-0.0587204390281239`\)},
              {"331", "0.25960621715357746`", \(-0.11266533921476797`\), 
                "0.1144094305872548`", \(-0.15889769274636453`\), 
                "0.12557773291744964`", \(-0.1076593742397423`\)},
              {"332", \(-1.7560393961172418`\), \(-0.4341700227265415`\), 
                "0.5070293338512012`", \(-0.0032581068591352636`\), \
\(-0.12298137480957173`\), "0.1266342722090225`"},
              {"333", "0.6594144284320588`", 
                "0.5832108968916938`", \(-0.12569740748680355`\), 
                "0.07942124604794096`", "0.049525066859619694`", 
                "0.21228916590296226`"},
              {"334", "1.6308114709111967`", 
                "0.3865101859058998`", \(-0.19276442685312709`\), 
                "0.16433031450510185`", "0.1408752110156861`", 
                "0.015842505148957214`"},
              {"335", "0.602462314445189`", 
                "0.024703408714106135`", \(-0.3171562695694556`\), 
                "0.1961740054371466`", "0.07200372346656261`", 
                "0.007894368188805222`"},
              {"336", "0.875619428064916`", 
                "0.08345934003289447`", \(-0.012795824851519118`\), 
                "0.09886168397236572`", \(-0.03873337305375813`\), 
                "0.24987978131846486`"},
              {"337", \(-0.003237093625839366`\), "0.003602844839846792`", 
                "0.0926053190143029`", "0.09455942785396777`", 
                "0.09600189855654763`", \(-0.12810457672305522`\)},
              {"338", "0.05947249990350774`", \(-0.0004096936333223458`\), 
                "0.17122025836491442`", \(-0.013372118645704631`\), 
                "0.22929606539571512`", "0.11995963899473722`"},
              {"339", \(-0.9047225259174475`\), "0.14818850790043436`", 
                "0.2455408042910407`", "0.11742125768208621`", 
                "0.07040870667147535`", "0.3269382558509623`"},
              {"340", "0.7329061121110486`", 
                "0.2657596176901969`", \(-0.10667544240837054`\), 
                "0.2134283506957035`", \(-0.004981410585744033`\), \
\(-0.13301225712280357`\)},
              {"341", "0.2716490395783738`", 
                "0.2538118201989047`", \(-0.005571895293883799`\), \
\(-0.06449241409863951`\), \(-0.2751267382566198`\), "0.1903837236661691`"},
              {"342", \(-1.6198956023209388`\), "0.1438418690229308`", 
                "0.5360055885675213`", "0.11974159437392873`", 
                "0.07583763423842761`", "0.4786313335867282`"},
              {"343", \(-0.18643403414000145`\), \(-0.09313655553547734`\), 
                "0.30996884754081094`", \(-0.14896169010822702`\), 
                "0.12425439206763236`", \(-0.07679678319617077`\)},
              {"344", \(-0.43101879316961395`\), \(-0.042421442081834834`\), 
                "0.17617580555749107`", "0.26711143744576016`", 
                "0.01427416672200495`", "0.23630886072157342`"},
              {"345", "0.8905751382702779`", 
                "0.014178697420882964`", \(-0.23850639442797394`\), 
                "0.17132584098198872`", "0.027823067928212368`", 
                "0.005524864763385452`"},
              {"346", "0.9984302280765571`", \(-0.19904283449712212`\), 
                "0.027499976131723947`", "0.4150687797635917`", 
                "0.4291592628393264`", "0.4105060990300603`"},
              {"347", \(-1.0016225501661402`\), \(-0.04368508193001359`\), 
                "0.24690441521714612`", "0.4065538545345559`", 
                "0.04112432032882101`", "0.06400401308676393`"},
              {"348", \(-0.21128051014645569`\), "0.16862861571719806`", 
                "0.1997747547627353`", "0.05644441599158127`", 
                "0.2635861362451393`", "0.19817997704364837`"},
              {
                "349", \(-1.0369732623564483`\), \(-0.10383224955841013`\), \
\(-0.016065990838369626`\), "0.2760813169272739`", \(-0.17805896298019003`\), 
                "0.126509341033311`"},
              {
                "350", \(-0.9074233961643203`\), \(-0.43792999520669973`\), \
\(-0.12097452443517041`\), \(-0.12426606006095291`\), "0.36464302357748674`", 
                "0.0984965964078051`"},
              {"351", "0.9381473905569927`", "0.4002854408098493`", 
                "0.3076162941267994`", 
                "0.2642063091758437`", \(-0.004754519872752504`\), 
                "0.20000549599522147`"},
              {"352", \(-0.5841368439420096`\), "0.022496196928906014`", 
                "0.15066890465957167`", \(-0.02813141870623063`\), \
\(-0.07025491553589672`\), \(-0.05381317277925049`\)},
              {"353", "1.3554431137508753`", "0.46855949366231536`", 
                "0.3980348260251191`", 
                "0.07071629208960961`", \(-0.024374706149956633`\), 
                "0.09060559592084963`"},
              {"354", \(-1.4464076444015872`\), \(-0.11970943885468753`\), 
                "0.24143322778143564`", "0.15175454589928095`", 
                "0.13986470609981924`", \(-0.15523554667049408`\)},
              {"355", "0.5377375828263479`", 
                "0.40657457078286463`", \(-0.18502091458948663`\), \
\(-0.009178047644454559`\), \(-0.19358092862122656`\), \
\(-0.05423739539027848`\)},
              {"356", "0.8237529276413745`", 
                "0.27540602393680524`", \(-0.0709908737884693`\), \
\(-0.2883334439856103`\), "0.1249463324205815`", \(-0.05576554822795947`\)},
              {"357", 
                "0.5253902686836406`", \(-0.13989350956689767`\), \
\(-0.3207177489815265`\), "0.06282713112174364`", "0.014385023723115883`", 
                "0.12345598549594536`"},
              {"358", \(-1.6100479257797666`\), \(-0.6782144080200585`\), 
                "0.3276495689998854`", \(-0.011734623433563508`\), 
                "0.00314278902435383`", \(-0.012653065273269953`\)},
              {"359", "0.5999989327443329`", "0.07681981503879176`", 
                "0.0074575368044634965`", "0.19920180346691507`", 
                "0.026220764648415728`", "0.05915649141700394`"},
              {"360", \(-1.1557455657625517`\), \(-0.5148941453806405`\), 
                "0.20256508089287895`", "0.584442905204082`", 
                "0.2671980088396386`", \(-0.3017699407089874`\)},
              {"361", \(-1.8360411431178318`\), \(-0.2532747881952503`\), 
                "0.32582184515039664`", "0.4157916736988483`", 
                "0.3785023008292144`", "0.21481093519573236`"},
              {"362", "0.06154642417802603`", "0.002671980393697372`", 
                "0.2969270165668665`", \(-0.0833779006095458`\), \
\(-0.15532889288698126`\), "0.19529520762611027`"},
              {"363", \(-0.3111226493798833`\), \(-0.05151117501878036`\), 
                "0.014126753433010923`", \(-0.0033263815124065215`\), 
                "0.13665816615838552`", \(-0.09747964225896416`\)},
              {"364", \(-0.536474396814986`\), \(-0.032305229111595446`\), 
                "0.25118457776264264`", 
                "0.002158483038248258`", \(-0.23114970825986464`\), 
                "0.21908598901511384`"},
              {"365", "0.3886783806391584`", 
                "0.06465839237024948`", \(-0.33127465488850766`\), \
\(-0.3914895380617551`\), \(-0.07109724584809889`\), "0.28389715841362434`"},
              {"366", "0.7245102368707702`", "0.32752141596210144`", 
                "0.02287801823683063`", \(-0.06069103070028237`\), 
                "0.1535359295314305`", "0.261882977820477`"},
              {"367", "0.9551942567986543`", 
                "0.0924203822299516`", \(-0.33459213161064444`\), 
                "0.03914332800131048`", "0.0827741883839561`", 
                "0.18106575221155496`"},
              {"368", \(-0.21082032029606335`\), "0.023988655848834254`", 
                "0.3793302750670615`", "0.35505609334122573`", 
                "0.07335181041966048`", "0.15889525346807803`"},
              {"369", \(-1.5011267082345636`\), "0.09158824951504589`", 
                "0.4561553757464099`", \(-0.0626930478942023`\), \
\(-0.001043255079244515`\), \(-0.013901715918728146`\)},
              {
                "370", \(-0.32403673399091937`\), \(-0.16525405739143614`\), \
\(-0.01055324629745173`\), 
                "0.2855329736935393`", \(-0.07788444688095922`\), \
\(-0.032997881470278004`\)},
              {"371", \(-0.31265352204937064`\), "0.27754631080013736`", 
                "0.31072719424099515`", "0.21337703828011026`", 
                "0.12077131391752298`", "0.2568365322695631`"},
              {"372", \(-0.4455241668484313`\), \(-0.03619381281231491`\), 
                "0.10653027709276168`", "0.0568247895515057`", 
                "0.2446941446453958`", "0.24832469190637446`"},
              {"373", \(-1.462009448424072`\), \(-0.18851940190824273`\), 
                "0.2800575240047685`", \(-0.013964079679826923`\), 
                "0.12738910387179211`", "0.6074072227291566`"},
              {
                "374", \(-0.5328621221651231`\), \(-0.04766903263736191`\), \
\(-0.011753491094062093`\), "0.010766551152299563`", 
                "0.050454423045457275`", \(-0.09568919614135662`\)},
              {"375", \(-0.09101579357698791`\), "0.10858824436791586`", 
                "0.37144137610575545`", 
                "0.339233179752268`", \(-0.011268381604778123`\), 
                "0.1897573541065416`"},
              {"376", "1.6049056987777566`", "0.20049098105072494`", 
                "0.18255328232202947`", "0.29541601929582145`", 
                "0.11863848671526889`", "0.04552644319539407`"},
              {"377", "0.8939001993400176`", 
                "0.18428442485918273`", \(-0.3968704596955352`\), 
                "0.0295709487003802`", "0.08942617924544165`", 
                "0.07253325041689301`"},
              {"378", "0.42667428459119394`", "0.26618855684191844`", 
                "0.3610472996906584`", "0.19367659596167863`", 
                "0.5876110259362993`", "0.056129068052645344`"},
              {"379", \(-0.5526798163902286`\), \(-0.07032791775178286`\), 
                "0.06108270283507781`", \(-0.2686137315950215`\), 
                "0.06539664965166911`", "0.010672905555591954`"},
              {"380", \(-0.7302179900742919`\), \(-0.15219172028010322`\), 
                "0.25619020646168084`", "0.15397594158187547`", 
                "0.273377063458045`", "0.2824306090878796`"},
              {"381", \(-1.3630136150003773`\), "0.08259559722522668`", 
                "0.44607508131742973`", \(-0.09326458664819418`\), \
\(-0.24411091902053655`\), "0.16275553034533807`"},
              {"382", \(-0.4006120901795662`\), \(-0.37219468009838447`\), 
                "0.3205414845017681`", "0.013854046503003101`", 
                "0.001968078630569007`", \(-0.10833228297904929`\)},
              {"383", "0.34465915078277687`", "0.027091717279558114`", 
                
                "0.03655651260884688`", \(-0.08700425920439575`\), \
\(-0.14188185623260116`\), "0.08647113227048657`"},
              {"384", "0.5205214008248975`", "0.1488058734803138`", 
                "0.10914853959746466`", "0.15826267614325845`", 
                "0.0489558810323562`", "0.12798114015314088`"},
              {"385", "0.7722767329579844`", 
                "0.17999055181593254`", \(-0.4424485112415224`\), 
                "0.3106094523472647`", \(-0.08606451050300329`\), \
\(-0.1427979862656946`\)},
              {"386", "0.9796333039415159`", 
                "0.07680403546224976`", \(-0.1947773210406115`\), \
\(-0.14087717950895243`\), \(-0.21361841165595766`\), 
                "0.31785386116153297`"},
              {"387", \(-0.9143891563887087`\), \(-0.1544077204795685`\), 
                "0.4609728619187309`", 
                "0.06540671499324237`", \(-0.33062188723944236`\), \
\(-0.17682876145791737`\)},
              {"388", \(-0.32644588507543904`\), "0.021218104572185148`", 
                "0.05185089916568563`", 
                "0.014707440684163964`", \(-0.014155451628220368`\), 
                "0.26391709518778916`"},
              {"389", \(-0.16619916721499325`\), 
                "0.334553092415208`", \(-0.14390889543135288`\), 
                "0.04075289982441013`", "0.16175685835269885`", 
                "0.14463318834632`"},
              {"390", "0.8327152928120178`", 
                "0.14996273777913677`", \(-0.14473059413919295`\), 
                "0.11035599751621572`", 
                "0.0619756304144361`", \(-0.0259632958186508`\)},
              {"391", \(-0.1596353851244959`\), "0.21491137255742268`", 
                "0.4334551948153784`", 
                "0.04452636692141124`", \(-0.24922610886824753`\), \
\(-0.17483299226197763`\)},
              {"392", \(-0.8183044020787407`\), \(-0.06367538092513554`\), 
                "0.33675247143558046`", "0.12160201040725244`", 
                "0.0011295269066906532`", "0.06538455937430436`"},
              {"393", \(-1.8378146662332628`\), \(-0.41974368917973076`\), 
                "0.27746025933319807`", "0.42693629395558164`", 
                "0.13300606407787124`", \(-0.04406356352667577`\)},
              {"394", \(-0.8682113410580101`\), "0.22268357917088874`", 
                "0.36781337777707557`", "0.03934148597398802`", 
                "0.08312573802511311`", "0.11166529602159433`"},
              {"395", "0.07487168434814412`", "0.004268828286183555`", 
                "0.39478946055673325`", "0.17976632643109988`", 
                "0.04868878881029553`", \(-0.1749490229046283`\)},
              {"396", "0.4180697459072686`", 
                "0.27592812151214696`", \(-0.021456046139577495`\), 
                "0.578127654289983`", 
                "0.1550285114061311`", \(-0.1697615489425124`\)},
              {"397", "1.4944965482849728`", "0.5223503652265695`", 
                "0.05909375849818783`", 
                "0.05140525387870198`", \(-0.14717793516724065`\), 
                "0.05117035858076463`"},
              {"398", 
                "0.17555288465418165`", \(-0.03820412922743526`\), \
\(-0.4503676563199596`\), "0.11472380458685918`", 
                "0.23186747077234118`", \(-0.24161630607747148`\)},
              {"399", "1.1233907419506468`", 
                "0.23725101318943365`", \(-0.18627414596591546`\), 
                "0.10592704784085111`", \(-0.0894252736746607`\), \
\(-0.05394887452312285`\)},
              {"400", \(-0.009597366630751803`\), \(-0.17491112288159602`\), 
                "0.33601890709502485`", 
                "0.13593288372056828`", \(-0.17800579604564803`\), 
                "0.3157271846375104`"},
              {"401", "0.9862544887761936`", "0.15727438014814277`", 
                "0.13620082587945895`", \(-0.13422301390054533`\), 
                "0.04345049519829587`", "0.07438074262318703`"},
              {
                "402", \(-0.6702100918973287`\), \(-0.09466514392259143`\), \
\(-0.10494383939390542`\), \(-0.09100659319153044`\), "0.06727237509273762`", 
                "0.04671914283456668`"},
              {"403", "0.026086280937536375`", "0.03163168789721192`", 
                "0.02205721168938986`", "0.022050987936169313`", 
                "0.0012705029058713616`", "0.23166679643227697`"},
              {"404", "0.3615819804660405`", 
                "0.14186768632033508`", \(-0.05114164128880151`\), \
\(-0.052280592714982144`\), "0.26129532637533237`", "0.16899172424097628`"},
              {"405", \(-0.6868211871797232`\), \(-0.2928434707008238`\), 
                "0.09448719495213606`", "0.0386776621236987`", 
                "0.17831836184390337`", "0.14132797340838218`"},
              {"406", \(-2.056780561059624`\), \(-0.16963835582051182`\), 
                "0.26238720867376414`", \(-0.20672988374460172`\), 
                "0.273601278677436`", "0.16601596199535984`"},
              {"407", "0.3097413206509063`", 
                "0.12713865978366595`", \(-0.00795020368892438`\), \
\(-0.10901170338644416`\), 
                "0.12597942017178435`", \(-0.09907321625471904`\)},
              {"408", \(-1.3253814362156808`\), \(-0.03030846248208114`\), 
                "0.17268347943488804`", \(-0.019760199022163808`\), 
                "0.1300620829706812`", "0.014568191883315535`"},
              {"409", "0.9007831270242838`", "0.228402474093097`", 
                "0.25109563297667564`", "0.10592446864283432`", 
                "0.2147810462794033`", "0.10929731322060428`"},
              {"410", \(-1.4797298311860263`\), \(-0.09176400660953185`\), 
                "0.4588079334305248`", \(-0.08702376289850952`\), \
\(-0.24789462467048`\), "0.2747258062939761`"},
              {"411", \(-1.290211991566138`\), "0.03048881021238701`", 
                "0.518218108914657`", 
                "0.24085395935688564`", \(-0.045178059205161075`\), 
                "0.03945023963583232`"},
              {"412", \(-1.1901308520396394`\), "0.06479658543631783`", 
                "0.24439888330166426`", \(-0.20487009990168809`\), \
\(-0.18394545820626013`\), "0.006094112290742577`"},
              {"413", \(-0.5374379891286396`\), \(-0.21256766225883933`\), 
                "0.03272728842625755`", 
                "0.09229695171744641`", \(-0.4184615561467083`\), \
\(-0.02255612810436865`\)},
              {"414", 
                "0.9940803150269714`", \(-0.10594231615766754`\), \
\(-0.3425952055264242`\), \(-0.2069782002782526`\), \
\(-0.19730035943849472`\), \(-0.29387770597544105`\)},
              {"415", \(-0.9110913254557943`\), \(-0.15165320754704903`\), 
                "0.1369363052213395`", "0.09900926431161677`", 
                "0.348460269077904`", "0.1654932280264604`"},
              {"416", "0.2786136038348066`", "0.30936805057215494`", 
                "0.15631201534637404`", 
                "0.21807849680138194`", \(-0.5034014640853048`\), \
\(-0.028909404088444453`\)},
              {"417", "0.6095420448839811`", "0.2653337436942021`", 
                "0.04914630959797915`", 
                "0.07700724523923407`", \(-0.025843998220108043`\), 
                "0.0028369220070814626`"},
              {"418", 
                "0.46376090960808397`", \(-0.31566403016475464`\), \
\(-0.03713083028336955`\), "0.27007438386954985`", 
                "0.17878971242940958`", \(-0.40011870440315644`\)},
              {"419", \(-0.007414257831274024`\), "0.30309648643160986`", 
                "0.18508806125919522`", \(-0.004313534253959639`\), 
                "0.02037983274846215`", "0.08345568376730897`"},
              {
                "420", \(-1.0280154756264885`\), \(-0.2652401503854769`\), \
\(-0.006856415589631455`\), 
                "0.3168519469546953`", \(-0.19057108921271998`\), \
\(-0.15620360780858017`\)},
              {"421", "0.21013844101726042`", "0.0496276671665`", 
                "0.15988414125459163`", 
                "0.16197567512637798`", \(-0.05484063431100309`\), 
                "0.22710729741814337`"},
              {"422", "0.7944768233028078`", 
                "0.09344032362132301`", \(-0.41489699278481773`\), 
                "0.23206265633858275`", 
                "0.177248081334914`", \(-0.11023640801243147`\)},
              {"423", "0.35652054716371095`", \(-0.11377021380134633`\), 
                "0.0580534450697085`", "0.10479601226253636`", 
                "0.15867504404354837`", "0.227797595480724`"},
              {"424", \(-0.12669292903297008`\), \(-0.02562826447892392`\), 
                "0.11505018421022367`", 
                "0.07779880900496407`", \(-0.2616870429287741`\), 
                "0.1499393963368181`"},
              {"425", "0.753542185878883`", "0.1645988944214045`", 
                "0.03880766429886292`", "0.2292905846413438`", 
                "0.10178814827239424`", \(-0.19127734176566089`\)},
              {"426", "0.443047322884819`", "0.42225835417475077`", 
                "0.00802269417734982`", 
                "0.0006191406935072762`", \(-0.022757421173470654`\), \
\(-0.07483740451210212`\)},
              {"427", \(-0.3116730374513283`\), "0.16137767221401778`", 
                "0.09839519635552205`", "0.09620945554777376`", 
                "0.041870094196920844`", "0.32722949651116295`"},
              {"428", 
                "0.28557240066001377`", \(-0.001258542634144519`\), \
\(-0.08800957583508583`\), "0.09436556750241913`", "0.16342129211438605`", 
                "0.06987377971795039`"},
              {"429", 
                "0.2186517934696906`", \(-0.058604440822544616`\), \
\(-0.07628721585779889`\), "0.12075294298423522`", "0.09703863094857229`", 
                "0.4055655524479549`"},
              {
                "430", \(-0.4001529493521962`\), \(-0.1561999413136196`\), \
\(-0.07551124037384949`\), \(-0.24175933984697345`\), \(-0.09558420392710994`\
\), "0.10933955519302331`"},
              {"431", "1.1544998146292036`", 
                "0.6584192633332547`", \(-0.18035768502564814`\), 
                "0.03273549311843805`", "0.07218876054020748`", 
                "0.024203712083813347`"},
              {"432", "0.15972616192029346`", 
                "0.2243322426401904`", \(-0.08137454972339668`\), 
                "0.13212443530675874`", 
                "0.008892022420175331`", \(-0.03954689436504281`\)},
              {"433", "1.9322867637286976`", 
                "0.5324318994354755`", \(-0.039930720747983726`\), 
                "0.37765444017665833`", "0.138378700298376`", 
                "0.03082113949655053`"},
              {"434", "1.2557623995206586`", 
                "0.03630036471516568`", \(-0.33272390594108187`\), 
                "0.013288080891039536`", "0.21377326994963428`", 
                "0.060041366985683325`"},
              {"435", 
                "1.4290163712252009`", \(-0.13650339058903338`\), \
\(-0.19667832820480877`\), "0.3929443327712986`", "0.13188583886284172`", 
                "0.03249165006951354`"},
              {"436", \(-0.7596526947462399`\), \(-0.06368972890350608`\), 
                "0.18040840028748018`", \(-0.0040902191829194755`\), 
                "0.3402197163418002`", "0.16564958695405094`"},
              {"437", \(-0.17599187965743465`\), \(-0.05537853900898679`\), 
                "0.4359151713347233`", "0.12536226981025608`", 
                "0.10794488010926939`", \(-0.17463929007319512`\)},
              {"438", \(-0.18117289569574788`\), "0.05996240538363434`", 
                "0.4123218818425831`", "0.33718954859900435`", 
                "0.15667384158131878`", "0.09260447852049869`"},
              {"439", \(-1.8356049196874378`\), \(-0.5204019749215073`\), 
                "0.3692539767607688`", 
                "0.2505884055450361`", \(-0.05928166707437312`\), \
\(-0.013439002743653207`\)},
              {"440", \(-1.2273786014090873`\), 
                "0.007012950336526866`", \(-0.1881508906504438`\), 
                "0.37784779541967817`", "0.31520148015758664`", 
                "0.1595637829261487`"},
              {"441", \(-2.1524883933256223`\), \(-0.2989002165850305`\), 
                "0.43846934357124845`", \(-0.30616185322529504`\), \
\(-0.0555257933115871`\), "0.33887229290964244`"},
              {"442", "0.00485467234951451`", "0.16394218106639938`", 
                "0.17298804098269893`", "0.19741403731216267`", 
                "0.11863817991964173`", "0.1307092991827119`"},
              {"443", "0.5424064827983369`", "0.2758463399269822`", 
                "0.05385372878036785`", "0.22509841314638912`", 
                "0.41445902432564224`", "0.04339750795731767`"},
              {"444", \(-0.1284298056676462`\), "0.01862116381222016`", 
                "0.015856957418490327`", "0.17817914581730263`", 
                "0.0627112355664588`", "0.005029393807486948`"},
              {"445", "1.6521364097660838`", 
                "0.18242625472510923`", \(-0.07838798997907456`\), 
                "0.41843415223899255`", 
                "0.28906749862822556`", \(-0.020540725795342274`\)},
              {"446", \(-0.9804351104005754`\), "0.06603753358309636`", 
                "0.20919582616382001`", \(-0.12746748639461009`\), 
                "0.011947624960788087`", "0.18522070659561257`"},
              {"447", "0.8241380205453311`", "0.22544240221521536`", 
                "0.12800254974469094`", "0.2399467581871425`", 
                "0.33818015615066865`", "0.20862993317071046`"},
              {"448", \(-0.73061526127168`\), \(-0.32550376688026006`\), 
                "0.1532396806417119`", "0.07106824416147595`", 
                "0.16384012807727066`", \(-0.08195364388613406`\)},
              {"449", \(-0.07736883732065675`\), "0.05966658182229902`", 
                "0.08037181551764203`", "0.3004931763189264`", 
                "0.17593194249489635`", "0.11953612226745106`"},
              {"450", 
                "0.7788254970077149`", \(-0.0006330449175971376`\), \
\(-0.3472383539696751`\), "0.1703124268484248`", "0.22426620867991368`", 
                "0.31353852009694333`"},
              {"451", \(-1.8076594478178003`\), \(-0.3200209616314013`\), 
                "0.2434532691108992`", \(-0.20070530947928217`\), 
                "0.040135625048939305`", \(-0.23674148764476227`\)},
              {"452", "1.548923811592359`", 
                "0.6705382565135042`", \(-0.23221373309428853`\), \
\(-0.08504967651487527`\), "0.3068876340090686`", "0.09320871835527608`"},
              {"453", \(-0.07244303189231865`\), "0.3886018235323556`", 
                "0.18399955613280208`", \(-0.05241368622542213`\), 
                "0.007222796745782956`", "0.43006537501598247`"},
              {"454", "1.0287907904785376`", 
                "0.13148963398932295`", \(-0.25059065865388425`\), \
\(-0.1875859220847919`\), "0.17554797003368217`", "0.06913703480857296`"},
              {"455", "1.5441798549180155`", 
                "0.39228069848981`", \(-0.1045985758326619`\), 
                "0.3846540968338355`", \(-0.059783493406159474`\), \
\(-0.0975635706855944`\)},
              {"456", 
                "0.3146295797200754`", \(-0.05563853163368301`\), \
\(-0.1783020321229092`\), "0.23143938167660777`", "0.02630454754532467`", 
                "0.0464911454670777`"},
              {"457", "1.275339493051463`", 
                "0.2257689182992629`", \(-0.09817145058745308`\), 
                "0.13479011175339434`", "0.24877683237231865`", 
                "0.06179851705965519`"},
              {"458", \(-0.785070391260841`\), \(-0.13202597810831046`\), 
                "0.07951396073390553`", 
                "0.3459980320935339`", \(-0.027714615776800663`\), \
\(-0.11440401446071628`\)},
              {"459", \(-1.363486028768191`\), \(-0.14733421027003035`\), 
                "0.4021525052766828`", 
                "0.13918839046196863`", \(-0.07185212856428921`\), 
                "0.05377049444194517`"},
              {"460", "1.408159861228248`", 
                "0.2899396114802236`", \(-0.3340742608768295`\), 
                "0.06496116165610807`", 
                "0.08723071974806601`", \(-0.1045024599632428`\)},
              {"461", \(-2.553807144262281`\), \(-0.1274260884671854`\), 
                "0.23058008358894688`", \(-0.25998623500314305`\), \
\(-0.20818627833292472`\), "0.13957982138550543`"},
              {"462", \(-0.34822487470398655`\), "0.04502150788851928`", 
                "0.2468941459103357`", 
                "0.02905002687716728`", \(-0.16662834983039124`\), \
\(-0.050640685685559884`\)},
              {"463", "0.2802704379698936`", 
                "0.05674067910312651`", \(-0.0732853944938061`\), 
                "0.06661505622514403`", 
                "0.2578815691236961`", \(-0.19584566267349374`\)},
              {"464", \(-1.5013775952755257`\), "0.1632911025868172`", 
                "0.19751546741502674`", "0.08425439298375732`", 
                "0.08897045772131962`", "0.3394095474893876`"},
              {"465", "0.6974172817339322`", "0.26133154087120325`", 
                "0.027362234297218534`", "0.0025429506457302726`", 
                "0.28121850278213034`", "0.2694392638576685`"},
              {"466", "0.31301980832985987`", 
                "0.07561428015586077`", \(-0.10524520202213357`\), \
\(-0.26926238283919374`\), \(-0.0280103537431857`\), "0.2217753848362984`"},
              {"467", "0.13891453708570586`", "0.3252134529240492`", 
                "0.11465779491962759`", "0.23396063121983837`", 
                "0.2414087913604531`", \(-0.2838290206227466`\)},
              {"468", "0.09760245605094553`", 
                "0.23361051055627607`", \(-0.08629240026770138`\), 
                "0.1847833163930916`", 
                "0.2860137809652443`", \(-0.08026527637524244`\)},
              {"469", "0.5839457582572132`", "0.0403545462567945`", 
                "0.19582555203740803`", 
                "0.00293846985517621`", \(-0.029235525010354986`\), 
                "0.49364623347041253`"},
              {"470", "0.4703906070108621`", 
                "0.09693953513438897`", \(-0.12084973479500347`\), 
                "0.18983738946030737`", 
                "0.23405063376901392`", \(-0.16225130255464762`\)},
              {"471", 
                "0.12813432346619807`", \(-0.027796122602969067`\), \
\(-0.12204993532108942`\), \(-0.01292728548097663`\), 
                "0.10616097048817145`", \(-0.034837170032535454`\)},
              {"472", "0.629989584152866`", 
                "0.39560403601350325`", \(-0.221702963884991`\), 
                "0.10810391504556356`", "0.2998251042755613`", 
                "0.08036077885384262`"},
              {"473", "0.6287048042228434`", 
                "0.16294146063574175`", \(-0.07200034161642174`\), \
\(-0.07645673628911988`\), "0.0324753702653254`", \(-0.09423849615744607`\)},
              {"474", \(-1.1156417603251432`\), \(-0.19850431197245796`\), 
                "0.21462939684758708`", \(-0.2105697575947981`\), 
                "0.07971013266743773`", "0.44794477919739584`"},
              {"475", \(-0.8982776731259553`\), \(-0.007873126160950376`\), 
                "0.24070403918540406`", "0.10696115349759565`", 
                "0.22773963989729193`", "0.10047851392777386`"},
              {"476", \(-2.027231299841302`\), \(-0.08052487562150176`\), 
                "0.2916761198095273`", \(-0.18466659662125426`\), \
\(-0.30343732465643325`\), \(-0.023818635326879552`\)},
              {"477", "0.3138618383163921`", "0.4370324177345365`", 
                "0.12306197714437574`", \(-0.17155410874784277`\), \
\(-0.04141467775084172`\), "0.2579088503884099`"},
              {"478", "0.308377868777266`", "0.18638056721681395`", 
                "0.12664128985778186`", "0.2159995717057564`", 
                "0.1614245437003199`", "0.01841863423803052`"},
              {"479", \(-1.6741739033032719`\), \(-0.30092643795934887`\), 
                "0.4514216322389519`", "0.1327769657412797`", 
                "0.05515827914920701`", \(-0.2553534466158145`\)},
              {"480", "0.16753587500806305`", \(-0.03388593750622577`\), 
                "0.15500224075684724`", \(-0.11630837874680082`\), \
\(-0.001887732364849135`\), "0.06453078942335128`"},
              {"481", "2.2571688461941823`", 
                "0.4237808737939255`", \(-0.36061362414555137`\), \
\(-0.04057585817660965`\), "0.149372045123679`", "0.09148594517983309`"},
              {"482", 
                "0.8280487787715446`", \(-0.08188367930257812`\), \
\(-0.358103572920482`\), "0.1079867178203469`", "0.4642769287102046`", 
                "0.04332726097763609`"},
              {"483", "0.9363414214540978`", 
                "0.35755532901102044`", \(-0.2081899188068003`\), 
                "0.10924534041561812`", 
                "0.18893848426635348`", \(-0.005084997249007763`\)},
              {"484", "0.4578894612929428`", 
                "0.41071241494455446`", \(-0.12269267530598167`\), \
\(-0.08897709587937858`\), "0.1814814809855582`", "0.1644146945708257`"},
              {"485", \(-0.7717738738584183`\), \(-0.05070221564318857`\), 
                "0.20694817509182356`", "0.5052526025800071`", 
                "0.2187421521974235`", \(-0.27401469083139224`\)},
              {"486", "0.13872732006699776`", \(-0.05664387077579992`\), 
                "0.09582211934602307`", \(-0.04153309776007755`\), \
\(-0.0756270653603139`\), \(-0.05369544538138394`\)},
              {
                "487", \(-0.626810449173631`\), \(-0.435928917854391`\), \
\(-0.03431038409850531`\), \(-0.16494786414669269`\), \(-0.06899556571352683`\
\), "0.13069591856734533`"},
              {"488", \(-1.480931422853662`\), \(-0.2357970784371533`\), 
                "0.32734756975086055`", 
                "0.03142494944313468`", \(-0.1034403667104458`\), 
                "0.41288478732464795`"},
              {"489", "1.4810070444893983`", 
                "0.5180432170681881`", \(-0.010170638033766352`\), 
                "0.13120591459343367`", \(-0.01971331837235887`\), 
                "0.04307376313420133`"},
              {"490", "0.3906501597660836`", "0.21024672996866725`", 
                "0.06421801901912132`", "0.11967347199754608`", 
                "0.00737940900400094`", "0.17693731405320312`"},
              {"491", \(-0.09013347126650861`\), "0.35403427516937797`", 
                "0.39341238895892977`", "0.06265260061278011`", 
                "0.06979275532637907`", "0.0996205377970914`"},
              {"492", "0.18857281472381324`", "0.3120196823741721`", 
                "0.19547124368826876`", \(-0.19395317902525017`\), \
\(-0.13624170947712877`\), \(-0.004024604322612295`\)},
              {"493", \(-0.5732063103685755`\), \(-0.06601857903116463`\), 
                "0.2580713585755232`", "0.08935642703969097`", 
                "0.050949669748181006`", "0.21770964847314037`"},
              {"494", "0.2980542607686508`", 
                "0.1374779601773052`", \(-0.10906899759996024`\), \
\(-0.1934124114837302`\), \(-0.21625522223170895`\), 
                "0.006568569291018608`"},
              {"495", "2.0878025517248004`", 
                "0.42566584906749017`", \(-0.04673872391198097`\), \
\(-0.22817202203364645`\), \(-0.0010852440546676224`\), 
                "0.272894969025896`"},
              {"496", 
                "0.9568169133309332`", \(-0.011739494209362909`\), \
\(-0.12582763231692576`\), "0.03711946290810844`", "0.20312672681744698`", 
                "0.18552140462481298`"},
              {"497", "2.2795888664529382`", 
                "0.15375155812432684`", \(-0.4617325710967535`\), 
                "0.06392017787941089`", "0.3977586219117459`", 
                "0.21131159488973164`"},
              {"498", \(-0.02516161327995233`\), 
                "0.2724920969891629`", \(-0.036174552972613135`\), 
                "0.011452701836774257`", \(-0.015383476957933634`\), 
                "0.18033025922392268`"},
              {"499", 
                "1.163686345459873`", \(-0.0713564207994549`\), \
\(-0.05757165740469639`\), "0.021243474502063407`", \(-0.06279117723637762`\),
                 "0.020011187708011115`"},
              {"500", "0.04062031633138112`", \(-0.2360791513615731`\), 
                "0.254180698294619`", \(-0.04486690427230396`\), \
\(-0.3119860829783983`\), \(-0.025391056916296284`\)}
              },
            RowSpacings->0.6,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ETA // Dimensions\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({500, 12}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(1 + Range[1, 2 \((T + 1)\), 2]\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({2, 4, 6, 8, 10, 12}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DisplayTogetherArray[\[IndentingNewLine]plot1[\(ETA[\([100 // Range, 
                0 + Range[1, 2 \((T + 1)\), 2]\ ]\)] // Transpose\) // 
          AddTimeAxis, 
        farbmodell \[Rule] 
          Hue], \[IndentingNewLine]plot1[\(ETA[\([100 // Range, 
                1 + Range[1, 2 \((T + 1)\), 2]\ ]\)] // Transpose\) // 
          AddTimeAxis, farbmodell \[Rule] Hue]\[IndentingNewLine]]\)], "Input",\

  PageWidth->Infinity],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .30902 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.00735755 0.47619 [
[ 0 0 0 0 ]
[ 1 .30902 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .30902 L
0 .30902 L
closepath
clip
newpath
% Start of sub-graphic
p
0.0238095 0.00735755 0.5 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.190476 0.30263 0.125131 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -3 -9 ]
[.21429 -0.0125 3 0 ]
[.40476 -0.0125 -3 -9 ]
[.40476 -0.0125 3 0 ]
[.59524 -0.0125 -3 -9 ]
[.59524 -0.0125 3 0 ]
[.78571 -0.0125 -3 -9 ]
[.78571 -0.0125 3 0 ]
[.97619 -0.0125 -3 -9 ]
[.97619 -0.0125 3 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .05237 -12 -4.5 ]
[-0.0125 .05237 0 4.5 ]
[-0.0125 .1775 -12 -4.5 ]
[-0.0125 .1775 0 4.5 ]
[-0.0125 .30263 -6 -4.5 ]
[-0.0125 .30263 0 4.5 ]
[-0.0125 .42776 -6 -4.5 ]
[-0.0125 .42776 0 4.5 ]
[-0.0125 .55289 -6 -4.5 ]
[-0.0125 .55289 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .30748 -5 -6 ]
[.97619 .30748 5 6 ]
[.97619 .32336 -5 -6 ]
[.97619 .32336 5 6 ]
[.97619 .25731 -5 -6 ]
[.97619 .25731 5 6 ]
[.97619 .29538 -5 -6 ]
[.97619 .29538 5 6 ]
[.97619 .33246 -5 -6 ]
[.97619 .33246 5 6 ]
[.97619 .32487 -5 -6 ]
[.97619 .32487 5 6 ]
[.97619 .28207 -5 -6 ]
[.97619 .28207 5 6 ]
[.97619 .32955 -5 -6 ]
[.97619 .32955 5 6 ]
[.97619 .27822 -5 -6 ]
[.97619 .27822 5 6 ]
[.97619 .2943 -5 -6 ]
[.97619 .2943 5 6 ]
[.97619 .31636 -5 -6 ]
[.97619 .31636 5 6 ]
[.97619 .33532 -5 -6 ]
[.97619 .33532 5 6 ]
[.97619 .30956 -5 -6 ]
[.97619 .30956 5 6 ]
[.97619 .32746 -5 -6 ]
[.97619 .32746 5 6 ]
[.97619 .29339 -5 -6 ]
[.97619 .29339 5 6 ]
[.97619 .28002 -5 -6 ]
[.97619 .28002 5 6 ]
[.97619 .30671 -5 -6 ]
[.97619 .30671 5 6 ]
[.97619 .35262 -5 -6 ]
[.97619 .35262 5 6 ]
[.97619 .30978 -5 -6 ]
[.97619 .30978 5 6 ]
[.97619 .32706 -5 -6 ]
[.97619 .32706 5 6 ]
[.97619 .32159 -5 -6 ]
[.97619 .32159 5 6 ]
[.97619 .34458 -5 -6 ]
[.97619 .34458 5 6 ]
[.97619 .30529 -5 -6 ]
[.97619 .30529 5 6 ]
[.97619 .30576 -5 -6 ]
[.97619 .30576 5 6 ]
[.97619 .31055 -5 -6 ]
[.97619 .31055 5 6 ]
[.97619 .29411 -5 -6 ]
[.97619 .29411 5 6 ]
[.97619 .30559 -5 -6 ]
[.97619 .30559 5 6 ]
[.97619 .29842 -5 -6 ]
[.97619 .29842 5 6 ]
[.97619 .32226 -5 -6 ]
[.97619 .32226 5 6 ]
[.97619 .28652 -5 -6 ]
[.97619 .28652 5 6 ]
[.97619 .31356 -5 -6 ]
[.97619 .31356 5 6 ]
[.97619 .35019 -5 -6 ]
[.97619 .35019 5 6 ]
[.97619 .29648 -5 -6 ]
[.97619 .29648 5 6 ]
[.97619 .3166 -5 -6 ]
[.97619 .3166 5 6 ]
[.97619 .32422 -5 -6 ]
[.97619 .32422 5 6 ]
[.97619 .29536 -5 -6 ]
[.97619 .29536 5 6 ]
[.97619 .31007 -5 -6 ]
[.97619 .31007 5 6 ]
[.97619 .31309 -5 -6 ]
[.97619 .31309 5 6 ]
[.97619 .31032 -5 -6 ]
[.97619 .31032 5 6 ]
[.97619 .27402 -5 -6 ]
[.97619 .27402 5 6 ]
[.97619 .33474 -5 -6 ]
[.97619 .33474 5 6 ]
[.97619 .28153 -5 -6 ]
[.97619 .28153 5 6 ]
[.97619 .31121 -5 -6 ]
[.97619 .31121 5 6 ]
[.97619 .31137 -5 -6 ]
[.97619 .31137 5 6 ]
[.97619 .34681 -5 -6 ]
[.97619 .34681 5 6 ]
[.97619 .33416 -5 -6 ]
[.97619 .33416 5 6 ]
[.97619 .31415 -5 -6 ]
[.97619 .31415 5 6 ]
[.97619 .29601 -5 -6 ]
[.97619 .29601 5 6 ]
[.97619 .34238 -5 -6 ]
[.97619 .34238 5 6 ]
[.97619 .27027 -5 -6 ]
[.97619 .27027 5 6 ]
[.97619 .31163 -5 -6 ]
[.97619 .31163 5 6 ]
[.97619 .30177 -5 -6 ]
[.97619 .30177 5 6 ]
[.97619 .33933 -5 -6 ]
[.97619 .33933 5 6 ]
[.97619 .34917 -5 -6 ]
[.97619 .34917 5 6 ]
[.97619 .29654 -5 -6 ]
[.97619 .29654 5 6 ]
[.97619 .28378 -5 -6 ]
[.97619 .28378 5 6 ]
[.97619 .30366 -5 -6 ]
[.97619 .30366 5 6 ]
[.97619 .32348 -5 -6 ]
[.97619 .32348 5 6 ]
[.97619 .30554 -5 -6 ]
[.97619 .30554 5 6 ]
[.97619 .28991 -5 -6 ]
[.97619 .28991 5 6 ]
[.97619 .32217 -5 -6 ]
[.97619 .32217 5 6 ]
[.97619 .32422 -5 -6 ]
[.97619 .32422 5 6 ]
[.97619 .26979 -5 -6 ]
[.97619 .26979 5 6 ]
[.97619 .28339 -5 -6 ]
[.97619 .28339 5 6 ]
[.97619 .28666 -5 -6 ]
[.97619 .28666 5 6 ]
[.97619 .29214 -5 -6 ]
[.97619 .29214 5 6 ]
[.97619 .33247 -5 -6 ]
[.97619 .33247 5 6 ]
[.97619 .34948 -5 -6 ]
[.97619 .34948 5 6 ]
[.97619 .30455 -5 -6 ]
[.97619 .30455 5 6 ]
[.97619 .26887 -5 -6 ]
[.97619 .26887 5 6 ]
[.97619 .295 -5 -6 ]
[.97619 .295 5 6 ]
[.97619 .31803 -5 -6 ]
[.97619 .31803 5 6 ]
[.97619 .28959 -5 -6 ]
[.97619 .28959 5 6 ]
[.97619 .32633 -5 -6 ]
[.97619 .32633 5 6 ]
[.97619 .35433 -5 -6 ]
[.97619 .35433 5 6 ]
[.97619 .32553 -5 -6 ]
[.97619 .32553 5 6 ]
[.97619 .33013 -5 -6 ]
[.97619 .33013 5 6 ]
[.97619 .32658 -5 -6 ]
[.97619 .32658 5 6 ]
[.97619 .34677 -5 -6 ]
[.97619 .34677 5 6 ]
[.97619 .29538 -5 -6 ]
[.97619 .29538 5 6 ]
[.97619 .33905 -5 -6 ]
[.97619 .33905 5 6 ]
[.97619 .3335 -5 -6 ]
[.97619 .3335 5 6 ]
[.97619 .31478 -5 -6 ]
[.97619 .31478 5 6 ]
[.97619 .30979 -5 -6 ]
[.97619 .30979 5 6 ]
[.97619 .34831 -5 -6 ]
[.97619 .34831 5 6 ]
[.97619 .31002 -5 -6 ]
[.97619 .31002 5 6 ]
[.97619 .2986 -5 -6 ]
[.97619 .2986 5 6 ]
[.97619 .28861 -5 -6 ]
[.97619 .28861 5 6 ]
[.97619 .27001 -5 -6 ]
[.97619 .27001 5 6 ]
[.97619 .29824 -5 -6 ]
[.97619 .29824 5 6 ]
[.97619 .29891 -5 -6 ]
[.97619 .29891 5 6 ]
[.97619 .32054 -5 -6 ]
[.97619 .32054 5 6 ]
[.97619 .30501 -5 -6 ]
[.97619 .30501 5 6 ]
[.97619 .3233 -5 -6 ]
[.97619 .3233 5 6 ]
[.97619 .3017 -5 -6 ]
[.97619 .3017 5 6 ]
[.97619 .32287 -5 -6 ]
[.97619 .32287 5 6 ]
[.97619 .29301 -5 -6 ]
[.97619 .29301 5 6 ]
[.97619 .33182 -5 -6 ]
[.97619 .33182 5 6 ]
[.97619 .34636 -5 -6 ]
[.97619 .34636 5 6 ]
[.97619 .30794 -5 -6 ]
[.97619 .30794 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .05237 m
.00625 .05237 L
s
[(-2)] -0.0125 .05237 1 0 Mshowa
0 .1775 m
.00625 .1775 L
s
[(-1)] -0.0125 .1775 1 0 Mshowa
0 .30263 m
.00625 .30263 L
s
[(0)] -0.0125 .30263 1 0 Mshowa
0 .42776 m
.00625 .42776 L
s
[(1)] -0.0125 .42776 1 0 Mshowa
0 .55289 m
.00625 .55289 L
s
[(2)] -0.0125 .55289 1 0 Mshowa
.125 Mabswid
0 .07739 m
.00375 .07739 L
s
0 .10242 m
.00375 .10242 L
s
0 .12745 m
.00375 .12745 L
s
0 .15247 m
.00375 .15247 L
s
0 .20253 m
.00375 .20253 L
s
0 .22755 m
.00375 .22755 L
s
0 .25258 m
.00375 .25258 L
s
0 .2776 m
.00375 .2776 L
s
0 .32766 m
.00375 .32766 L
s
0 .35268 m
.00375 .35268 L
s
0 .37771 m
.00375 .37771 L
s
0 .40273 m
.00375 .40273 L
s
0 .45279 m
.00375 .45279 L
s
0 .47781 m
.00375 .47781 L
s
0 .50284 m
.00375 .50284 L
s
0 .52787 m
.00375 .52787 L
s
0 .02734 m
.00375 .02734 L
s
0 .00232 m
.00375 .00232 L
s
0 .57792 m
.00375 .57792 L
s
0 .60294 m
.00375 .60294 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .05237 m
1 .05237 L
s
.99375 .1775 m
1 .1775 L
s
.99375 .30263 m
1 .30263 L
s
.99375 .42776 m
1 .42776 L
s
.99375 .55289 m
1 .55289 L
s
.125 Mabswid
.99625 .07739 m
1 .07739 L
s
.99625 .10242 m
1 .10242 L
s
.99625 .12745 m
1 .12745 L
s
.99625 .15247 m
1 .15247 L
s
.99625 .20253 m
1 .20253 L
s
.99625 .22755 m
1 .22755 L
s
.99625 .25258 m
1 .25258 L
s
.99625 .2776 m
1 .2776 L
s
.99625 .32766 m
1 .32766 L
s
.99625 .35268 m
1 .35268 L
s
.99625 .37771 m
1 .37771 L
s
.99625 .40273 m
1 .40273 L
s
.99625 .45279 m
1 .45279 L
s
.99625 .47781 m
1 .47781 L
s
.99625 .50284 m
1 .50284 L
s
.99625 .52787 m
1 .52787 L
s
.99625 .02734 m
1 .02734 L
s
.99625 .00232 m
1 .00232 L
s
.99625 .57792 m
1 .57792 L
s
.99625 .60294 m
1 .60294 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .30748 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .11239 m
.21429 .2632 L
.40476 .33859 L
.59524 .34008 L
.78571 .25977 L
.97619 .30748 L
s
1 0 .6 r
gsave
.97619 .32336 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .48783 m
.21429 .34479 L
.40476 .23959 L
.59524 .29671 L
.78571 .33419 L
.97619 .32336 L
s
.8 0 1 r
gsave
.97619 .25731 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .3049 m
.21429 .3088 L
.40476 .29644 L
.59524 .31365 L
.78571 .30111 L
.97619 .25731 L
s
.2 0 1 r
gsave
.97619 .29538 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .27592 m
.21429 .31303 L
.40476 .30456 L
.59524 .30101 L
.78571 .31293 L
.97619 .29538 L
s
0 .4 1 r
gsave
.97619 .33246 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .32419 m
.21429 .33749 L
.40476 .32579 L
.59524 .32236 L
.78571 .30395 L
.97619 .33246 L
s
0 1 1 r
gsave
.97619 .32487 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .2366 m
.21429 .33383 L
.40476 .33083 L
.59524 .32241 L
.78571 .33849 L
.97619 .32487 L
s
0 1 .4 r
gsave
.97619 .28207 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .43324 m
.21429 .31132 L
.40476 .27668 L
.59524 .33133 L
.78571 .33416 L
.97619 .28207 L
s
.2 1 0 r
gsave
.97619 .32955 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .26804 m
.21429 .28736 L
.40476 .32792 L
.59524 .3281 L
.78571 .32939 L
.97619 .32955 L
s
.8 1 0 r
gsave
.97619 .27822 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .14924 m
.21429 .27861 L
.40476 .35713 L
.59524 .3058 L
.78571 .3069 L
.97619 .27822 L
s
1 .6 0 r
gsave
.97619 .2943 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .28226 m
.21429 .25442 L
.40476 .28551 L
.59524 .35476 L
.78571 .32184 L
.97619 .2943 L
s
1 0 0 r
gsave
.97619 .31636 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .11885 m
.21429 .26571 L
.40476 .34179 L
.59524 .34491 L
.78571 .35009 L
.97619 .31636 L
s
1 0 .6 r
gsave
.97619 .33532 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .44964 m
.21429 .34622 L
.40476 .26838 L
.59524 .26083 L
.78571 .32477 L
.97619 .33532 L
s
.8 0 1 r
gsave
.97619 .30956 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .44024 m
.21429 .30423 L
.40476 .267 L
.59524 .29934 L
.78571 .32612 L
.97619 .30956 L
s
.2 0 1 r
gsave
.97619 .32746 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .32737 m
.21429 .2868 L
.40476 .31229 L
.59524 .28488 L
.78571 .30391 L
.97619 .32746 L
s
0 .4 1 r
gsave
.97619 .29339 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .33057 m
.21429 .34165 L
.40476 .26497 L
.59524 .30412 L
.78571 .31398 L
.97619 .29339 L
s
0 1 1 r
gsave
.97619 .28002 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .23149 m
.21429 .30611 L
.40476 .32176 L
.59524 .32626 L
.78571 .33238 L
.97619 .28002 L
s
0 1 .4 r
gsave
.97619 .30671 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .46622 m
.21429 .32242 L
.40476 .30023 L
.59524 .3594 L
.78571 .3242 L
.97619 .30671 L
s
.2 1 0 r
gsave
.97619 .35262 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .3272 m
.21429 .33196 L
.40476 .2897 L
.59524 .28358 L
.78571 .28586 L
.97619 .35262 L
s
.8 1 0 r
gsave
.97619 .30978 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .466 m
.21429 .34581 L
.40476 .29592 L
.59524 .32082 L
.78571 .28715 L
.97619 .30978 L
s
1 .6 0 r
gsave
.97619 .32706 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .36249 m
.21429 .3334 L
.40476 .29209 L
.59524 .33968 L
.78571 .30764 L
.97619 .32706 L
s
1 0 0 r
gsave
.97619 .32159 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .1686 m
.21429 .31296 L
.40476 .36912 L
.59524 .31836 L
.78571 .31681 L
.97619 .32159 L
s
1 0 .6 r
gsave
.97619 .34458 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .17501 m
.21429 .32233 L
.40476 .32206 L
.59524 .31375 L
.78571 .31853 L
.97619 .34458 L
s
.8 0 1 r
gsave
.97619 .30529 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .40863 m
.21429 .30482 L
.40476 .28912 L
.59524 .33044 L
.78571 .32351 L
.97619 .30529 L
s
.2 0 1 r
gsave
.97619 .30576 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .04095 m
.21429 .27903 L
.40476 .39488 L
.59524 .33562 L
.78571 .31023 L
.97619 .30576 L
s
0 .4 1 r
gsave
.97619 .31055 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .34291 m
.21429 .28067 L
.40476 .32331 L
.59524 .32873 L
.78571 .29792 L
.97619 .31055 L
s
0 1 1 r
gsave
.97619 .29411 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .23967 m
.21429 .30861 L
.40476 .35954 L
.59524 .34451 L
.78571 .34643 L
.97619 .29411 L
s
0 1 .4 r
gsave
.97619 .30559 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .20193 m
.21429 .31 L
.40476 .34689 L
.59524 .33185 L
.78571 .33677 L
.97619 .30559 L
s
.2 1 0 r
gsave
.97619 .29842 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .22198 m
.21429 .33634 L
.40476 .33546 L
.59524 .32009 L
.78571 .28153 L
.97619 .29842 L
s
.8 1 0 r
gsave
.97619 .32226 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .44211 m
.21429 .34754 L
.40476 .3272 L
.59524 .30188 L
.78571 .32081 L
.97619 .32226 L
s
1 .6 0 r
gsave
.97619 .28652 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30048 m
.21429 .29271 L
.40476 .30986 L
.59524 .28527 L
.78571 .31108 L
.97619 .28652 L
s
1 0 0 r
gsave
.97619 .31356 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .34952 m
.21429 .2901 L
.40476 .31697 L
.59524 .3032 L
.78571 .31471 L
.97619 .31356 L
s
1 0 .6 r
gsave
.97619 .35019 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .22763 m
.21429 .29902 L
.40476 .34 L
.59524 .27561 L
.78571 .28681 L
.97619 .35019 L
s
.8 0 1 r
gsave
.97619 .29648 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01472 m
.21429 .29083 L
.40476 .35019 L
.59524 .30272 L
.78571 .31812 L
.97619 .29648 L
s
.2 0 1 r
gsave
.97619 .3166 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .21295 m
.21429 .33745 L
.40476 .32527 L
.59524 .31392 L
.78571 .33319 L
.97619 .3166 L
s
0 .4 1 r
gsave
.97619 .32422 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .52717 m
.21429 .2982 L
.40476 .26622 L
.59524 .31057 L
.78571 .3004 L
.97619 .32422 L
s
0 1 1 r
gsave
.97619 .29536 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .21918 m
.21429 .27397 L
.40476 .36919 L
.59524 .31873 L
.78571 .30593 L
.97619 .29536 L
s
0 1 .4 r
gsave
.97619 .31007 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .36549 m
.21429 .30426 L
.40476 .32565 L
.59524 .29846 L
.78571 .30037 L
.97619 .31007 L
s
.2 1 0 r
gsave
.97619 .31309 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .40969 m
.21429 .30225 L
.40476 .33206 L
.59524 .33413 L
.78571 .28472 L
.97619 .31309 L
s
.8 1 0 r
gsave
.97619 .31032 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .42685 m
.21429 .29842 L
.40476 .33237 L
.59524 .30137 L
.78571 .30089 L
.97619 .31032 L
s
1 .6 0 r
gsave
.97619 .27402 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .35741 m
.21429 .3121 L
.40476 .30492 L
.59524 .31263 L
.78571 .32569 L
.97619 .27402 L
s
1 0 0 r
gsave
.97619 .33474 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .22338 m
.21429 .28932 L
.40476 .32553 L
.59524 .28347 L
.78571 .30671 L
.97619 .33474 L
s
1 0 .6 r
gsave
.97619 .28153 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .29651 m
.21429 .26257 L
.40476 .29812 L
.59524 .35529 L
.78571 .31518 L
.97619 .28153 L
s
.8 0 1 r
gsave
.97619 .31121 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .34258 m
.21429 .30609 L
.40476 .33277 L
.59524 .35499 L
.78571 .33095 L
.97619 .31121 L
s
.2 0 1 r
gsave
.97619 .31137 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .22815 m
.21429 .34223 L
.40476 .29272 L
.59524 .3053 L
.78571 .35513 L
.97619 .31137 L
s
0 .4 1 r
gsave
.97619 .34681 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .37368 m
.21429 .33408 L
.40476 .31232 L
.59524 .29049 L
.78571 .29446 L
.97619 .34681 L
s
0 1 1 r
gsave
.97619 .33416 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .15058 m
.21429 .33025 L
.40476 .33005 L
.59524 .30725 L
.78571 .34274 L
.97619 .33416 L
s
0 1 .4 r
gsave
.97619 .31415 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .33875 m
.21429 .34588 L
.40476 .27254 L
.59524 .27105 L
.78571 .26466 L
.97619 .31415 L
s
.2 1 0 r
gsave
.97619 .29601 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .07413 m
.21429 .2942 L
.40476 .34632 L
.59524 .33679 L
.78571 .32769 L
.97619 .29601 L
s
.8 1 0 r
gsave
.97619 .34238 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30579 m
.21429 .24878 L
.40476 .28513 L
.59524 .33403 L
.78571 .34871 L
.97619 .34238 L
s
1 .6 0 r
gsave
.97619 .27027 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .33319 m
.21429 .27286 L
.40476 .3036 L
.59524 .33836 L
.78571 .33984 L
.97619 .27027 L
s
1 0 0 r
gsave
.97619 .31163 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .51928 m
.21429 .31918 L
.40476 .28679 L
.59524 .28974 L
.78571 .32394 L
.97619 .31163 L
s
1 0 .6 r
gsave
.97619 .30177 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .43339 m
.21429 .35304 L
.40476 .31127 L
.59524 .32226 L
.78571 .29067 L
.97619 .30177 L
s
.8 0 1 r
gsave
.97619 .33933 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30953 m
.21429 .30165 L
.40476 .33567 L
.59524 .33773 L
.78571 .3061 L
.97619 .33933 L
s
.2 0 1 r
gsave
.97619 .34917 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .31105 m
.21429 .32086 L
.40476 .28721 L
.59524 .34711 L
.78571 .33408 L
.97619 .34917 L
s
0 .4 1 r
gsave
.97619 .29654 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .39176 m
.21429 .30855 L
.40476 .324 L
.59524 .28689 L
.78571 .32102 L
.97619 .29654 L
s
0 1 1 r
gsave
.97619 .28378 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .10683 m
.21429 .28838 L
.40476 .3319 L
.59524 .29212 L
.78571 .31915 L
.97619 .28378 L
s
0 1 .4 r
gsave
.97619 .30366 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .48062 m
.21429 .31488 L
.40476 .31578 L
.59524 .29323 L
.78571 .2935 L
.97619 .30366 L
s
.2 1 0 r
gsave
.97619 .32348 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .60332 m
.21429 .34048 L
.40476 .27505 L
.59524 .3543 L
.78571 .33875 L
.97619 .32348 L
s
.8 1 0 r
gsave
.97619 .30554 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .22385 m
.21429 .27657 L
.40476 .3389 L
.59524 .31366 L
.78571 .34445 L
.97619 .30554 L
s
1 .6 0 r
gsave
.97619 .28991 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .44468 m
.21429 .32122 L
.40476 .2773 L
.59524 .33802 L
.78571 .29065 L
.97619 .28991 L
s
1 0 0 r
gsave
.97619 .32217 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .32765 m
.21429 .34665 L
.40476 .34395 L
.59524 .30169 L
.78571 .34558 L
.97619 .32217 L
s
1 0 .6 r
gsave
.97619 .32422 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .5049 m
.21429 .33678 L
.40476 .3083 L
.59524 .29748 L
.78571 .31217 L
.97619 .32422 L
s
.8 0 1 r
gsave
.97619 .26979 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .25912 m
.21429 .32559 L
.40476 .33422 L
.59524 .35149 L
.78571 .32708 L
.97619 .26979 L
s
.2 0 1 r
gsave
.97619 .28339 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .19207 m
.21429 .27322 L
.40476 .36347 L
.59524 .33489 L
.78571 .32354 L
.97619 .28339 L
s
0 .4 1 r
gsave
.97619 .28666 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .17325 m
.21429 .25345 L
.40476 .33131 L
.59524 .31951 L
.78571 .2817 L
.97619 .28666 L
s
0 1 1 r
gsave
.97619 .29214 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .2868 m
.21429 .31476 L
.40476 .29138 L
.59524 .33011 L
.78571 .29772 L
.97619 .29214 L
s
0 1 .4 r
gsave
.97619 .33247 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .12183 m
.21429 .27945 L
.40476 .30656 L
.59524 .27295 L
.78571 .26671 L
.97619 .33247 L
s
.2 1 0 r
gsave
.97619 .34948 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .37129 m
.21429 .2942 L
.40476 .27917 L
.59524 .31178 L
.78571 .31271 L
.97619 .34948 L
s
.8 1 0 r
gsave
.97619 .30455 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .36805 m
.21429 .32638 L
.40476 .27834 L
.59524 .30954 L
.78571 .31924 L
.97619 .30455 L
s
1 .6 0 r
gsave
.97619 .26887 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .33759 m
.21429 .31234 L
.40476 .28954 L
.59524 .30892 L
.78571 .31112 L
.97619 .26887 L
s
1 0 0 r
gsave
.97619 .295 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .25206 m
.21429 .34869 L
.40476 .30949 L
.59524 .28701 L
.78571 .31651 L
.97619 .295 L
s
1 0 .6 r
gsave
.97619 .31803 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .23542 m
.21429 .30655 L
.40476 .28941 L
.59524 .3288 L
.78571 .31236 L
.97619 .31803 L
s
.8 0 1 r
gsave
.97619 .28959 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .17933 m
.21429 .32468 L
.40476 .36599 L
.59524 .29957 L
.78571 .29087 L
.97619 .28959 L
s
.2 0 1 r
gsave
.97619 .32633 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .32475 m
.21429 .31551 L
.40476 .32434 L
.59524 .28688 L
.78571 .32309 L
.97619 .32633 L
s
0 .4 1 r
gsave
.97619 .35433 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .43425 m
.21429 .33419 L
.40476 .28661 L
.59524 .2515 L
.78571 .27029 L
.97619 .35433 L
s
0 1 1 r
gsave
.97619 .32553 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .35453 m
.21429 .30437 L
.40476 .33065 L
.59524 .31979 L
.78571 .29935 L
.97619 .32553 L
s
0 1 .4 r
gsave
.97619 .33013 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .42869 m
.21429 .30162 L
.40476 .31169 L
.59524 .33841 L
.78571 .33578 L
.97619 .33013 L
s
.2 1 0 r
gsave
.97619 .32658 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .43367 m
.21429 .33754 L
.40476 .30639 L
.59524 .31726 L
.78571 .32946 L
.97619 .32658 L
s
.8 1 0 r
gsave
.97619 .34677 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .14548 m
.21429 .27164 L
.40476 .31723 L
.59524 .28395 L
.78571 .31398 L
.97619 .34677 L
s
1 .6 0 r
gsave
.97619 .29538 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .33732 m
.21429 .37142 L
.40476 .29282 L
.59524 .28106 L
.78571 .29837 L
.97619 .29538 L
s
1 0 0 r
gsave
.97619 .33905 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .17626 m
.21429 .24527 L
.40476 .35484 L
.59524 .34837 L
.78571 .33024 L
.97619 .33905 L
s
1 0 .6 r
gsave
.97619 .3335 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .23584 m
.21429 .29775 L
.40476 .31528 L
.59524 .31367 L
.78571 .30818 L
.97619 .3335 L
s
.8 0 1 r
gsave
.97619 .31478 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .325 m
.21429 .3177 L
.40476 .30819 L
.59524 .29457 L
.78571 .34458 L
.97619 .31478 L
s
.2 0 1 r
gsave
.97619 .30979 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .31022 m
.21429 .32792 L
.40476 .3119 L
.59524 .29034 L
.78571 .32446 L
.97619 .30979 L
s
0 .4 1 r
gsave
.97619 .34831 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .20193 m
.21429 .27314 L
.40476 .34215 L
.59524 .33489 L
.78571 .32385 L
.97619 .34831 L
s
0 1 1 r
gsave
.97619 .31002 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .5173 m
.21429 .33949 L
.40476 .2609 L
.59524 .31951 L
.78571 .28325 L
.97619 .31002 L
s
0 1 .4 r
gsave
.97619 .2986 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .42805 m
.21429 .32244 L
.40476 .27802 L
.59524 .32433 L
.78571 .31639 L
.97619 .2986 L
s
.2 1 0 r
gsave
.97619 .28861 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .31046 m
.21429 .2893 L
.40476 .34052 L
.59524 .29795 L
.78571 .31871 L
.97619 .28861 L
s
.8 1 0 r
gsave
.97619 .27001 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .47883 m
.21429 .34323 L
.40476 .30679 L
.59524 .33971 L
.78571 .3023 L
.97619 .27001 L
s
1 .6 0 r
gsave
.97619 .29824 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .38067 m
.21429 .35945 L
.40476 .33621 L
.59524 .32 L
.78571 .3221 L
.97619 .29824 L
s
1 0 0 r
gsave
.97619 .29891 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .35547 m
.21429 .30253 L
.40476 .28035 L
.59524 .29627 L
.78571 .31491 L
.97619 .29891 L
s
1 0 .6 r
gsave
.97619 .32054 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .37389 m
.21429 .36378 L
.40476 .30336 L
.59524 .30192 L
.78571 .32312 L
.97619 .32054 L
s
.8 0 1 r
gsave
.97619 .30501 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .42972 m
.21429 .30659 L
.40476 .28972 L
.59524 .32556 L
.78571 .35828 L
.97619 .30501 L
s
.2 0 1 r
gsave
.97619 .3233 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .33518 m
.21429 .34905 L
.40476 .32884 L
.59524 .30506 L
.78571 .33243 L
.97619 .3233 L
s
0 .4 1 r
gsave
.97619 .3017 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .28351 m
.21429 .32038 L
.40476 .31764 L
.59524 .30998 L
.78571 .34747 L
.97619 .3017 L
s
0 1 1 r
gsave
.97619 .32287 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .22589 m
.21429 .2992 L
.40476 .35891 L
.59524 .32321 L
.78571 .34503 L
.97619 .32287 L
s
0 1 .4 r
gsave
.97619 .29301 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .3938 m
.21429 .32098 L
.40476 .30105 L
.59524 .32662 L
.78571 .34852 L
.97619 .29301 L
s
.2 1 0 r
gsave
.97619 .33182 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .33924 m
.21429 .33116 L
.40476 .30197 L
.59524 .31921 L
.78571 .31386 L
.97619 .33182 L
s
.8 1 0 r
gsave
.97619 .34636 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .29421 m
.21429 .2421 L
.40476 .29151 L
.59524 .3132 L
.78571 .35257 L
.97619 .34636 L
s
1 .6 0 r
gsave
.97619 .30794 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .15443 m
.21429 .31523 L
.40476 .35585 L
.59524 .3321 L
.78571 .29504 L
.97619 .30794 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.5 0.00735755 0.97619 0.301659 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.190476 0.343455 0.0716104 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -3 -9 ]
[.21429 -0.0125 3 0 ]
[.40476 -0.0125 -3 -9 ]
[.40476 -0.0125 3 0 ]
[.59524 -0.0125 -3 -9 ]
[.59524 -0.0125 3 0 ]
[.78571 -0.0125 -3 -9 ]
[.78571 -0.0125 3 0 ]
[.97619 -0.0125 -3 -9 ]
[.97619 -0.0125 3 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .05701 -12 -4.5 ]
[-0.0125 .05701 0 4.5 ]
[-0.0125 .20023 -12 -4.5 ]
[-0.0125 .20023 0 4.5 ]
[-0.0125 .34346 -6 -4.5 ]
[-0.0125 .34346 0 4.5 ]
[-0.0125 .48668 -6 -4.5 ]
[-0.0125 .48668 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .36195 -5 -6 ]
[.97619 .36195 5 6 ]
[.97619 .24235 -5 -6 ]
[.97619 .24235 5 6 ]
[.97619 .39283 -5 -6 ]
[.97619 .39283 5 6 ]
[.97619 .36102 -5 -6 ]
[.97619 .36102 5 6 ]
[.97619 .35624 -5 -6 ]
[.97619 .35624 5 6 ]
[.97619 .30336 -5 -6 ]
[.97619 .30336 5 6 ]
[.97619 .34213 -5 -6 ]
[.97619 .34213 5 6 ]
[.97619 .35493 -5 -6 ]
[.97619 .35493 5 6 ]
[.97619 .28596 -5 -6 ]
[.97619 .28596 5 6 ]
[.97619 .44236 -5 -6 ]
[.97619 .44236 5 6 ]
[.97619 .31659 -5 -6 ]
[.97619 .31659 5 6 ]
[.97619 .28957 -5 -6 ]
[.97619 .28957 5 6 ]
[.97619 .33185 -5 -6 ]
[.97619 .33185 5 6 ]
[.97619 .35144 -5 -6 ]
[.97619 .35144 5 6 ]
[.97619 .29805 -5 -6 ]
[.97619 .29805 5 6 ]
[.97619 .31365 -5 -6 ]
[.97619 .31365 5 6 ]
[.97619 .28363 -5 -6 ]
[.97619 .28363 5 6 ]
[.97619 .37135 -5 -6 ]
[.97619 .37135 5 6 ]
[.97619 .30446 -5 -6 ]
[.97619 .30446 5 6 ]
[.97619 .3356 -5 -6 ]
[.97619 .3356 5 6 ]
[.97619 .36219 -5 -6 ]
[.97619 .36219 5 6 ]
[.97619 .25521 -5 -6 ]
[.97619 .25521 5 6 ]
[.97619 .34015 -5 -6 ]
[.97619 .34015 5 6 ]
[.97619 .2537 -5 -6 ]
[.97619 .2537 5 6 ]
[.97619 .33306 -5 -6 ]
[.97619 .33306 5 6 ]
[.97619 .27415 -5 -6 ]
[.97619 .27415 5 6 ]
[.97619 .28347 -5 -6 ]
[.97619 .28347 5 6 ]
[.97619 .30667 -5 -6 ]
[.97619 .30667 5 6 ]
[.97619 .24536 -5 -6 ]
[.97619 .24536 5 6 ]
[.97619 .38565 -5 -6 ]
[.97619 .38565 5 6 ]
[.97619 .2701 -5 -6 ]
[.97619 .2701 5 6 ]
[.97619 .47817 -5 -6 ]
[.97619 .47817 5 6 ]
[.97619 .2951 -5 -6 ]
[.97619 .2951 5 6 ]
[.97619 .26822 -5 -6 ]
[.97619 .26822 5 6 ]
[.97619 .2811 -5 -6 ]
[.97619 .2811 5 6 ]
[.97619 .36359 -5 -6 ]
[.97619 .36359 5 6 ]
[.97619 .32787 -5 -6 ]
[.97619 .32787 5 6 ]
[.97619 .32199 -5 -6 ]
[.97619 .32199 5 6 ]
[.97619 .36394 -5 -6 ]
[.97619 .36394 5 6 ]
[.97619 .31984 -5 -6 ]
[.97619 .31984 5 6 ]
[.97619 .36696 -5 -6 ]
[.97619 .36696 5 6 ]
[.97619 .35047 -5 -6 ]
[.97619 .35047 5 6 ]
[.97619 .33435 -5 -6 ]
[.97619 .33435 5 6 ]
[.97619 .29802 -5 -6 ]
[.97619 .29802 5 6 ]
[.97619 .40935 -5 -6 ]
[.97619 .40935 5 6 ]
[.97619 .35026 -5 -6 ]
[.97619 .35026 5 6 ]
[.97619 .35562 -5 -6 ]
[.97619 .35562 5 6 ]
[.97619 .38055 -5 -6 ]
[.97619 .38055 5 6 ]
[.97619 .35319 -5 -6 ]
[.97619 .35319 5 6 ]
[.97619 .26548 -5 -6 ]
[.97619 .26548 5 6 ]
[.97619 .32872 -5 -6 ]
[.97619 .32872 5 6 ]
[.97619 .39277 -5 -6 ]
[.97619 .39277 5 6 ]
[.97619 .36254 -5 -6 ]
[.97619 .36254 5 6 ]
[.97619 .35839 -5 -6 ]
[.97619 .35839 5 6 ]
[.97619 .32163 -5 -6 ]
[.97619 .32163 5 6 ]
[.97619 .37405 -5 -6 ]
[.97619 .37405 5 6 ]
[.97619 .42311 -5 -6 ]
[.97619 .42311 5 6 ]
[.97619 .34499 -5 -6 ]
[.97619 .34499 5 6 ]
[.97619 .27686 -5 -6 ]
[.97619 .27686 5 6 ]
[.97619 .36201 -5 -6 ]
[.97619 .36201 5 6 ]
[.97619 .36391 -5 -6 ]
[.97619 .36391 5 6 ]
[.97619 .36905 -5 -6 ]
[.97619 .36905 5 6 ]
[.97619 .32531 -5 -6 ]
[.97619 .32531 5 6 ]
[.97619 .28241 -5 -6 ]
[.97619 .28241 5 6 ]
[.97619 .34767 -5 -6 ]
[.97619 .34767 5 6 ]
[.97619 .36986 -5 -6 ]
[.97619 .36986 5 6 ]
[.97619 .41535 -5 -6 ]
[.97619 .41535 5 6 ]
[.97619 .30595 -5 -6 ]
[.97619 .30595 5 6 ]
[.97619 .29316 -5 -6 ]
[.97619 .29316 5 6 ]
[.97619 .32895 -5 -6 ]
[.97619 .32895 5 6 ]
[.97619 .26455 -5 -6 ]
[.97619 .26455 5 6 ]
[.97619 .40924 -5 -6 ]
[.97619 .40924 5 6 ]
[.97619 .27558 -5 -6 ]
[.97619 .27558 5 6 ]
[.97619 .26794 -5 -6 ]
[.97619 .26794 5 6 ]
[.97619 .35319 -5 -6 ]
[.97619 .35319 5 6 ]
[.97619 .36637 -5 -6 ]
[.97619 .36637 5 6 ]
[.97619 .34367 -5 -6 ]
[.97619 .34367 5 6 ]
[.97619 .33865 -5 -6 ]
[.97619 .33865 5 6 ]
[.97619 .30834 -5 -6 ]
[.97619 .30834 5 6 ]
[.97619 .24969 -5 -6 ]
[.97619 .24969 5 6 ]
[.97619 .39321 -5 -6 ]
[.97619 .39321 5 6 ]
[.97619 .39238 -5 -6 ]
[.97619 .39238 5 6 ]
[.97619 .20876 -5 -6 ]
[.97619 .20876 5 6 ]
[.97619 .37498 -5 -6 ]
[.97619 .37498 5 6 ]
[.97619 .29283 -5 -6 ]
[.97619 .29283 5 6 ]
[.97619 .38978 -5 -6 ]
[.97619 .38978 5 6 ]
[.97619 .36382 -5 -6 ]
[.97619 .36382 5 6 ]
[.97619 .30832 -5 -6 ]
[.97619 .30832 5 6 ]
[.97619 .39654 -5 -6 ]
[.97619 .39654 5 6 ]
[.97619 .30457 -5 -6 ]
[.97619 .30457 5 6 ]
[.97619 .30919 -5 -6 ]
[.97619 .30919 5 6 ]
[.97619 .38106 -5 -6 ]
[.97619 .38106 5 6 ]
[.97619 .26504 -5 -6 ]
[.97619 .26504 5 6 ]
[.97619 .31047 -5 -6 ]
[.97619 .31047 5 6 ]
[.97619 .32804 -5 -6 ]
[.97619 .32804 5 6 ]
[.97619 .3195 -5 -6 ]
[.97619 .3195 5 6 ]
[.97619 .30982 -5 -6 ]
[.97619 .30982 5 6 ]
[.97619 .36906 -5 -6 ]
[.97619 .36906 5 6 ]
[.97619 .3377 -5 -6 ]
[.97619 .3377 5 6 ]
[.97619 .37799 -5 -6 ]
[.97619 .37799 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .05701 m
.00625 .05701 L
s
[(-4)] -0.0125 .05701 1 0 Mshowa
0 .20023 m
.00625 .20023 L
s
[(-2)] -0.0125 .20023 1 0 Mshowa
0 .34346 m
.00625 .34346 L
s
[(0)] -0.0125 .34346 1 0 Mshowa
0 .48668 m
.00625 .48668 L
s
[(2)] -0.0125 .48668 1 0 Mshowa
.125 Mabswid
0 .09282 m
.00375 .09282 L
s
0 .12862 m
.00375 .12862 L
s
0 .16443 m
.00375 .16443 L
s
0 .23604 m
.00375 .23604 L
s
0 .27184 m
.00375 .27184 L
s
0 .30765 m
.00375 .30765 L
s
0 .37926 m
.00375 .37926 L
s
0 .41507 m
.00375 .41507 L
s
0 .45087 m
.00375 .45087 L
s
0 .02121 m
.00375 .02121 L
s
0 .52248 m
.00375 .52248 L
s
0 .55829 m
.00375 .55829 L
s
0 .59409 m
.00375 .59409 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .05701 m
1 .05701 L
s
.99375 .20023 m
1 .20023 L
s
.99375 .34346 m
1 .34346 L
s
.99375 .48668 m
1 .48668 L
s
.125 Mabswid
.99625 .09282 m
1 .09282 L
s
.99625 .12862 m
1 .12862 L
s
.99625 .16443 m
1 .16443 L
s
.99625 .23604 m
1 .23604 L
s
.99625 .27184 m
1 .27184 L
s
.99625 .30765 m
1 .30765 L
s
.99625 .37926 m
1 .37926 L
s
.99625 .41507 m
1 .41507 L
s
.99625 .45087 m
1 .45087 L
s
.99625 .02121 m
1 .02121 L
s
.99625 .52248 m
1 .52248 L
s
.99625 .55829 m
1 .55829 L
s
.99625 .59409 m
1 .59409 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
1 0 0 r
gsave
.97619 .36195 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .40463 m
.21429 .47726 L
.40476 .41696 L
.59524 .3205 L
.78571 .36642 L
.97619 .36195 L
s
1 0 .6 r
gsave
.97619 .24235 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .40039 m
.21429 .09302 L
.40476 .36739 L
.59524 .39913 L
.78571 .35346 L
.97619 .24235 L
s
.8 0 1 r
gsave
.97619 .39283 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .29772 m
.21429 .35524 L
.40476 .27591 L
.59524 .43841 L
.78571 .34808 L
.97619 .39283 L
s
.2 0 1 r
gsave
.97619 .36102 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .4474 m
.21429 .39466 L
.40476 .30401 L
.59524 .35631 L
.78571 .27025 L
.97619 .36102 L
s
0 .4 1 r
gsave
.97619 .35624 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .32395 m
.21429 .26552 L
.40476 .43644 L
.59524 .33583 L
.78571 .25091 L
.97619 .35624 L
s
0 1 1 r
gsave
.97619 .30336 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .33747 m
.21429 .45961 L
.40476 .29253 L
.59524 .38299 L
.78571 .39358 L
.97619 .30336 L
s
0 1 .4 r
gsave
.97619 .34213 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .40179 m
.21429 .18191 L
.40476 .35444 L
.59524 .36042 L
.78571 .28434 L
.97619 .34213 L
s
.2 1 0 r
gsave
.97619 .35493 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .2146 m
.21429 .40625 L
.40476 .37999 L
.59524 .38449 L
.78571 .3844 L
.97619 .35493 L
s
.8 1 0 r
gsave
.97619 .28596 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .28781 m
.21429 .48932 L
.40476 .32573 L
.59524 .32587 L
.78571 .36327 L
.97619 .28596 L
s
1 .6 0 r
gsave
.97619 .44236 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .28155 m
.21429 .32241 L
.40476 .48021 L
.59524 .39672 L
.78571 .24526 L
.97619 .44236 L
s
1 0 0 r
gsave
.97619 .31659 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .28124 m
.21429 .60332 L
.40476 .34866 L
.59524 .34449 L
.78571 .30329 L
.97619 .31659 L
s
1 0 .6 r
gsave
.97619 .28957 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .39117 m
.21429 .16155 L
.40476 .31099 L
.59524 .41449 L
.78571 .43162 L
.97619 .28957 L
s
.8 0 1 r
gsave
.97619 .33185 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .31914 m
.21429 .25904 L
.40476 .40154 L
.59524 .33824 L
.78571 .38744 L
.97619 .33185 L
s
.2 0 1 r
gsave
.97619 .35144 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .32113 m
.21429 .35715 L
.40476 .32693 L
.59524 .39017 L
.78571 .40605 L
.97619 .35144 L
s
0 .4 1 r
gsave
.97619 .29805 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .40868 m
.21429 .25928 L
.40476 .27794 L
.59524 .47387 L
.78571 .29466 L
.97619 .29805 L
s
0 1 1 r
gsave
.97619 .31365 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .36001 m
.21429 .4313 L
.40476 .33423 L
.59524 .37322 L
.78571 .25886 L
.97619 .31365 L
s
0 1 .4 r
gsave
.97619 .28363 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .26985 m
.21429 .27255 L
.40476 .41987 L
.59524 .35189 L
.78571 .34103 L
.97619 .28363 L
s
.2 1 0 r
gsave
.97619 .37135 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .42867 m
.21429 .3357 L
.40476 .32482 L
.59524 .31215 L
.78571 .32747 L
.97619 .37135 L
s
.8 1 0 r
gsave
.97619 .30446 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .35051 m
.21429 .23866 L
.40476 .3529 L
.59524 .38069 L
.78571 .3469 L
.97619 .30446 L
s
1 .6 0 r
gsave
.97619 .3356 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .38368 m
.21429 .29103 L
.40476 .40745 L
.59524 .29737 L
.78571 .34803 L
.97619 .3356 L
s
1 0 0 r
gsave
.97619 .36219 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .27912 m
.21429 .52593 L
.40476 .28641 L
.59524 .38709 L
.78571 .29133 L
.97619 .36219 L
s
1 0 .6 r
gsave
.97619 .25521 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .36139 m
.21429 .4995 L
.40476 .2865 L
.59524 .34523 L
.78571 .39337 L
.97619 .25521 L
s
.8 0 1 r
gsave
.97619 .34015 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .2779 m
.21429 .20688 L
.40476 .41914 L
.59524 .35258 L
.78571 .37857 L
.97619 .34015 L
s
.2 0 1 r
gsave
.97619 .2537 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .36747 m
.21429 .56464 L
.40476 .38989 L
.59524 .27807 L
.78571 .37305 L
.97619 .2537 L
s
0 .4 1 r
gsave
.97619 .33306 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .26119 m
.21429 .37172 L
.40476 .39418 L
.59524 .30133 L
.78571 .38642 L
.97619 .33306 L
s
0 1 1 r
gsave
.97619 .27415 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .32889 m
.21429 .44277 L
.40476 .2849 L
.59524 .28922 L
.78571 .38554 L
.97619 .27415 L
s
0 1 .4 r
gsave
.97619 .28347 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .34272 m
.21429 .43527 L
.40476 .31504 L
.59524 .30562 L
.78571 .32526 L
.97619 .28347 L
s
.2 1 0 r
gsave
.97619 .30667 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .41798 m
.21429 .39077 L
.40476 .33357 L
.59524 .32501 L
.78571 .27907 L
.97619 .30667 L
s
.8 1 0 r
gsave
.97619 .24536 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .36401 m
.21429 .16679 L
.40476 .37351 L
.59524 .30022 L
.78571 .33914 L
.97619 .24536 L
s
1 .6 0 r
gsave
.97619 .38565 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .29132 m
.21429 .37628 L
.40476 .32057 L
.59524 .37519 L
.78571 .23804 L
.97619 .38565 L
s
1 0 0 r
gsave
.97619 .2701 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .25793 m
.21429 .35283 L
.40476 .3447 L
.59524 .29424 L
.78571 .37588 L
.97619 .2701 L
s
1 0 .6 r
gsave
.97619 .47817 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .27689 m
.21429 .46735 L
.40476 .29132 L
.59524 .24686 L
.78571 .386 L
.97619 .47817 L
s
.8 0 1 r
gsave
.97619 .2951 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .41662 m
.21429 .59174 L
.40476 .28755 L
.59524 .26675 L
.78571 .37284 L
.97619 .2951 L
s
.2 0 1 r
gsave
.97619 .26822 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .47282 m
.21429 .42524 L
.40476 .29015 L
.59524 .3492 L
.78571 .43331 L
.97619 .26822 L
s
0 .4 1 r
gsave
.97619 .2811 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30495 m
.21429 .18266 L
.40476 .33056 L
.59524 .41048 L
.78571 .38733 L
.97619 .2811 L
s
0 1 1 r
gsave
.97619 .36359 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .29263 m
.21429 .49005 L
.40476 .35169 L
.59524 .343 L
.78571 .36598 L
.97619 .36359 L
s
0 1 .4 r
gsave
.97619 .32787 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .24354 m
.21429 .29446 L
.40476 .30988 L
.59524 .34718 L
.78571 .33971 L
.97619 .32787 L
s
.2 1 0 r
gsave
.97619 .32199 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .35301 m
.21429 .29633 L
.40476 .39658 L
.59524 .21959 L
.78571 .33445 L
.97619 .32199 L
s
.8 1 0 r
gsave
.97619 .36394 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .27404 m
.21429 .33314 L
.40476 .41494 L
.59524 .29802 L
.78571 .37444 L
.97619 .36394 L
s
1 .6 0 r
gsave
.97619 .31984 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .27391 m
.21429 .38572 L
.40476 .28795 L
.59524 .39548 L
.78571 .30853 L
.97619 .31984 L
s
1 0 0 r
gsave
.97619 .36696 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30337 m
.21429 .45025 L
.40476 .32438 L
.59524 .32389 L
.78571 .3941 L
.97619 .36696 L
s
1 0 .6 r
gsave
.97619 .35047 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .26151 m
.21429 .34915 L
.40476 .36427 L
.59524 .36046 L
.78571 .30475 L
.97619 .35047 L
s
.8 0 1 r
gsave
.97619 .33435 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .33565 m
.21429 .34465 L
.40476 .43619 L
.59524 .33173 L
.78571 .3549 L
.97619 .33435 L
s
.2 0 1 r
gsave
.97619 .29802 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .32533 m
.21429 .45278 L
.40476 .22489 L
.59524 .39043 L
.78571 .32228 L
.97619 .29802 L
s
0 .4 1 r
gsave
.97619 .40935 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .38587 m
.21429 .30882 L
.40476 .34202 L
.59524 .34576 L
.78571 .47862 L
.97619 .40935 L
s
0 1 1 r
gsave
.97619 .35026 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .43024 m
.21429 .54295 L
.40476 .24422 L
.59524 .47202 L
.78571 .32925 L
.97619 .35026 L
s
0 1 .4 r
gsave
.97619 .35562 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .35015 m
.21429 .34271 L
.40476 .29123 L
.59524 .3192 L
.78571 .37281 L
.97619 .35562 L
s
.2 1 0 r
gsave
.97619 .38055 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .36497 m
.21429 .60088 L
.40476 .33942 L
.59524 .27814 L
.78571 .34091 L
.97619 .38055 L
s
.8 1 0 r
gsave
.97619 .35319 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .29006 m
.21429 .35918 L
.40476 .40018 L
.59524 .4136 L
.78571 .36001 L
.97619 .35319 L
s
1 .6 0 r
gsave
.97619 .26548 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .26891 m
.21429 .323 L
.40476 .37259 L
.59524 .37723 L
.78571 .33477 L
.97619 .26548 L
s
1 0 0 r
gsave
.97619 .32872 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .27847 m
.21429 .15097 L
.40476 .4023 L
.59524 .29606 L
.78571 .40892 L
.97619 .32872 L
s
1 0 .6 r
gsave
.97619 .39277 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .41593 m
.21429 .27461 L
.40476 .34019 L
.59524 .26765 L
.78571 .33993 L
.97619 .39277 L
s
.8 0 1 r
gsave
.97619 .36254 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .36819 m
.21429 .3423 L
.40476 .39903 L
.59524 .3194 L
.78571 .30467 L
.97619 .36254 L
s
.2 0 1 r
gsave
.97619 .35839 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .34638 m
.21429 .29332 L
.40476 .34678 L
.59524 .43532 L
.78571 .33693 L
.97619 .35839 L
s
0 .4 1 r
gsave
.97619 .32163 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .38634 m
.21429 .3124 L
.40476 .35915 L
.59524 .32842 L
.78571 .3516 L
.97619 .32163 L
s
0 1 1 r
gsave
.97619 .37405 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .34415 m
.21429 .54709 L
.40476 .30667 L
.59524 .35689 L
.78571 .35894 L
.97619 .37405 L
s
0 1 .4 r
gsave
.97619 .42311 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .2566 m
.21429 .21507 L
.40476 .37465 L
.59524 .31544 L
.78571 .3333 L
.97619 .42311 L
s
.2 1 0 r
gsave
.97619 .34499 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .28625 m
.21429 .01472 L
.40476 .46743 L
.59524 .38403 L
.78571 .36081 L
.97619 .34499 L
s
.8 1 0 r
gsave
.97619 .27686 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .28427 m
.21429 .36709 L
.40476 .34907 L
.59524 .36176 L
.78571 .44725 L
.97619 .27686 L
s
1 .6 0 r
gsave
.97619 .36201 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .38879 m
.21429 .25119 L
.40476 .3898 L
.59524 .3609 L
.78571 .2729 L
.97619 .36201 L
s
1 0 0 r
gsave
.97619 .36391 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .31002 m
.21429 .40754 L
.40476 .34247 L
.59524 .35409 L
.78571 .36936 L
.97619 .36391 L
s
1 0 .6 r
gsave
.97619 .36905 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .41656 m
.21429 .16371 L
.40476 .35621 L
.59524 .31107 L
.78571 .36883 L
.97619 .36905 L
s
.8 0 1 r
gsave
.97619 .32531 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .42697 m
.21429 .32362 L
.40476 .33049 L
.59524 .36694 L
.78571 .34526 L
.97619 .32531 L
s
.2 0 1 r
gsave
.97619 .28241 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .3474 m
.21429 .41886 L
.40476 .36108 L
.59524 .37733 L
.78571 .33002 L
.97619 .28241 L
s
0 .4 1 r
gsave
.97619 .34767 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .30899 m
.21429 .47944 L
.40476 .40109 L
.59524 .34538 L
.78571 .35436 L
.97619 .34767 L
s
0 1 1 r
gsave
.97619 .36986 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .35332 m
.21429 .3128 L
.40476 .33498 L
.59524 .42894 L
.78571 .34384 L
.97619 .36986 L
s
0 1 .4 r
gsave
.97619 .41535 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .32005 m
.21429 .45161 L
.40476 .33908 L
.59524 .23617 L
.78571 .45129 L
.97619 .41535 L
s
.2 1 0 r
gsave
.97619 .30595 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .29061 m
.21429 .22198 L
.40476 .45144 L
.59524 .31565 L
.78571 .4002 L
.97619 .30595 L
s
.8 1 0 r
gsave
.97619 .29316 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .28237 m
.21429 .26245 L
.40476 .29614 L
.59524 .35804 L
.78571 .38942 L
.97619 .29316 L
s
1 .6 0 r
gsave
.97619 .32895 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .37247 m
.21429 .34222 L
.40476 .27496 L
.59524 .33428 L
.78571 .2667 L
.97619 .32895 L
s
1 0 0 r
gsave
.97619 .26455 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .56353 m
.21429 .40715 L
.40476 .3183 L
.59524 .37927 L
.78571 .2886 L
.97619 .26455 L
s
1 0 .6 r
gsave
.97619 .40924 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .51394 m
.21429 .36673 L
.40476 .36939 L
.59524 .40643 L
.78571 .27696 L
.97619 .40924 L
s
.8 0 1 r
gsave
.97619 .27558 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .34706 m
.21429 .49915 L
.40476 .30827 L
.59524 .32598 L
.78571 .35451 L
.97619 .27558 L
s
.2 0 1 r
gsave
.97619 .26794 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .29661 m
.21429 .37518 L
.40476 .29757 L
.59524 .3945 L
.78571 .39816 L
.97619 .26794 L
s
0 .4 1 r
gsave
.97619 .35319 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .35885 m
.21429 .26586 L
.40476 .32511 L
.59524 .33419 L
.78571 .51289 L
.97619 .35319 L
s
0 1 1 r
gsave
.97619 .36637 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .2991 m
.21429 .27617 L
.40476 .37575 L
.59524 .30081 L
.78571 .30928 L
.97619 .36637 L
s
0 1 .4 r
gsave
.97619 .34367 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .29721 m
.21429 .25111 L
.40476 .42367 L
.59524 .30375 L
.78571 .34416 L
.97619 .34367 L
s
.2 1 0 r
gsave
.97619 .33865 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .36028 m
.21429 .23755 L
.40476 .28652 L
.59524 .38177 L
.78571 .29251 L
.97619 .33865 L
s
.8 1 0 r
gsave
.97619 .30834 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .27897 m
.21429 .48947 L
.40476 .30285 L
.59524 .34212 L
.78571 .37174 L
.97619 .30834 L
s
1 .6 0 r
gsave
.97619 .24969 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .41821 m
.21429 .31305 L
.40476 .24638 L
.59524 .31658 L
.78571 .38282 L
.97619 .24969 L
s
1 0 0 r
gsave
.97619 .39321 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .27716 m
.21429 .42751 L
.40476 .40056 L
.59524 .31185 L
.78571 .37383 L
.97619 .39321 L
s
1 0 .6 r
gsave
.97619 .39238 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .27306 m
.21429 .42723 L
.40476 .36422 L
.59524 .30307 L
.78571 .35841 L
.97619 .39238 L
s
.8 0 1 r
gsave
.97619 .20876 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .39318 m
.21429 .34681 L
.40476 .31127 L
.59524 .39612 L
.78571 .39587 L
.97619 .20876 L
s
.2 0 1 r
gsave
.97619 .37498 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .423 m
.21429 .26934 L
.40476 .26914 L
.59524 .41161 L
.78571 .28936 L
.97619 .37498 L
s
0 .4 1 r
gsave
.97619 .29283 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .20727 m
.21429 .459 L
.40476 .3906 L
.59524 .21875 L
.78571 .36938 L
.97619 .29283 L
s
0 1 1 r
gsave
.97619 .38978 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .48968 m
.21429 .12028 L
.40476 .33717 L
.59524 .31768 L
.78571 .3824 L
.97619 .38978 L
s
0 1 .4 r
gsave
.97619 .36382 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .343 m
.21429 .23763 L
.40476 .3455 L
.59524 .41624 L
.78571 .28445 L
.97619 .36382 L
s
.2 1 0 r
gsave
.97619 .30832 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .27229 m
.21429 .37078 L
.40476 .34 L
.59524 .28377 L
.78571 .27825 L
.97619 .30832 L
s
.8 1 0 r
gsave
.97619 .39654 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .34242 m
.21429 .21165 L
.40476 .39546 L
.59524 .31807 L
.78571 .31558 L
.97619 .39654 L
s
1 .6 0 r
gsave
.97619 .30457 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .31094 m
.21429 .34192 L
.40476 .33088 L
.59524 .3553 L
.78571 .3272 L
.97619 .30457 L
s
1 0 0 r
gsave
.97619 .30919 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .35492 m
.21429 .23395 L
.40476 .39894 L
.59524 .35072 L
.78571 .34553 L
.97619 .30919 L
s
1 0 .6 r
gsave
.97619 .38106 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.000 0.600 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .48466 m
.21429 .24914 L
.40476 .36347 L
.59524 .40938 L
.78571 .34097 L
.97619 .38106 L
s
.8 0 1 r
gsave
.97619 .26504 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .40154 m
.21429 .22472 L
.40476 .4082 L
.59524 .37417 L
.78571 .32486 L
.97619 .26504 L
s
.2 0 1 r
gsave
.97619 .31047 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 0.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .3503 m
.21429 .33855 L
.40476 .35285 L
.59524 .33753 L
.78571 .36557 L
.97619 .31047 L
s
0 .4 1 r
gsave
.97619 .32804 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.400 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .39878 m
.21429 .37385 L
.40476 .31156 L
.59524 .39942 L
.78571 .312 L
.97619 .32804 L
s
0 1 1 r
gsave
.97619 .3195 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 1.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .35613 m
.21429 .46427 L
.40476 .27003 L
.59524 .3837 L
.78571 .41188 L
.97619 .3195 L
s
0 1 .4 r
gsave
.97619 .30982 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 1.000 0.400 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .32426 m
.21429 .3084 L
.40476 .34595 L
.59524 .31815 L
.78571 .29942 L
.97619 .30982 L
s
.2 1 0 r
gsave
.97619 .36906 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.200 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .36279 m
.21429 .36969 L
.40476 .29554 L
.59524 .36893 L
.78571 .32194 L
.97619 .36906 L
s
.8 1 0 r
gsave
.97619 .3377 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.800 1.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .17529 m
.21429 .41408 L
.40476 .32704 L
.59524 .43528 L
.78571 .31678 L
.97619 .3377 L
s
1 .6 0 r
gsave
.97619 .37799 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
1.000 0.600 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .44468 m
.21429 .46285 L
.40476 .37113 L
.59524 .29448 L
.78571 .33907 L
.97619 .37799 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
MathSubEnd
P
% End of sub-graphic
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{662.75, 204.812},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000:F0000c2000`400?l00000o`00003ooooooooo
oooooiSooooo003oooooooooooooV?ooool00?oooooooooooonHooooo`00oooooooooooooiSooooo
003oooooooooooooV?ooool00?oooooooooooonHooooo`00:?ooool2o`0003Gooooo0ol0000doooo
o`Go0000=?ooool3o`0003Kooooo0ol0000dooooo`?o00008?ooool2o`0003Gooooo0ol0000doooo
o`Go0000=?ooool3o`0003Kooooo0ol0000dooooo`?o00006_ooool002Oooooo00Co0000oooooooo
oooo0000=Oooool00ol0003oooooooooo`0dooooo`04o`000?ooooooooooo`0003?ooooo00Go0000
ooooooooooooooooo`00000fooooo`03o`000?oooooooooo03;ooooo00Go0000oooooooooooooooo
o`00000Nooooo`04o`000?ooooooooooo`0003Gooooo00?o0000ooooooooool0=?ooool01?l0003o
ooooooooool0000cooooo`05o`000?ooooooooooooooool00000=_ooool00ol0003oooooooooo`0b
ooooo`05o`000?ooooooooooooooool000006Oooool002Oooooo00Co0000oooooooooooo0000=Ooo
ool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo03Oooooo00?o0000ooooooooool0<Ooo
ool5o`0003Oooooo00?o0000ooooooooool07?ooool01?l0003oooooooooool0000eooooo`03o`00
0?oooooooooo03Gooooo00?o0000ooooooooool0=oooool00ol0003oooooooooo`0aooooo`Go0000
=oooool00ol0003oooooooooo`0Gooooo`009oooool01?l0003oooooooooool0000eooooo`03o`00
0?oooooooooo03Kooooo00?o0000ooooooooool0=?ooool2o`0003Cooooo00Co0000oooooooooooo
0000>?ooool00ol0003oooooooooo`0Looooo`04o`000?ooooooooooo`0003Gooooo00?o0000oooo
ooooool0=_ooool00ol0003oooooooooo`0dooooo`;o0000=?ooool01?l0003oooooooooool0000h
ooooo`03o`000?oooooooooo01Oooooo000Wooooo`04o`000?ooooooooooo`0003Gooooo00?o0000
ooooooooool0<oooool01Ol0003ooooooooooooooooo000003Oooooo00?o0000ooooooooool0<_oo
ool00ol0003oooooo`00000dooooo`Co00007oooool01?l0003oooooooooool0000eooooo`03o`00
0?oooooooooo03?ooooo00Go0000ooooooooooooooooo`00000gooooo`03o`000?oooooooooo03;o
oooo00?o0000ooooool00000=?ooool4o`0001[ooooo000Wooooo`04o`000?ooooooooooo`0003Co
oooo0_l0000eooooo`05o`000?ooooooooooooooool00000<oooool01Ol0003ooooooooooooooooo
000003Gooooo0_l0000dooooo`03o`000?oooooooooo023ooooo00Co0000oooooooooooo0000=?oo
ool2o`0003Gooooo00Go0000ooooooooooooooooo`00000cooooo`05o`000?ooooooooooooooool0
0000=Oooool2o`0003Cooooo00?o0000ooooooooool06oooool002Sooooo0_l0000fooooo`03o`00
0?oooooooooo03Cooooo0ol0000eooooo`?o0000=oooool00ol0003oooooooooo`0booooo`Go0000
7oooool2o`0003Kooooo00?o0000ooooooooool0=?ooool3o`0003Gooooo0ol0000gooooo`03o`00
0?oooooooooo03;ooooo1Ol0000Iooooo`00oooooooooooooiSooooo003oooooooooooooV?ooool0
0?oooooooooooonHooooo`00oooooooooooooiSooooo000Roooooooo0000:?l0000Coooooooo0000
:?l0000Cooooo`008_ooool2o`0000Gooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003ooooooooo
o`03ooooo`;o00004oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02?ooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool02Oooool00ol0003oooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o
0000ooooooooool01?ooool00ol0003oooooooooo`0Aooooo`008_ooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0e
ooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`04
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0e
ooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0e
ooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0A
ooooo`008_ooool00ol0003oooooooooo`3oooooobCooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`3oooooobCooooo00?o0000ooooooooool04Oooool002;ooooo00?o0000oooooooo
ool0oooooolTooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0oooooolTooooo`03
o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooooooo00?ooooo0_o<0?oooooooaoooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0kooooo`;o<ol0i_ooool00ol0003ooooo
ooooo`0Aooooo`008_ooool00ol0003oooooooooo`03ooooo`;oc03ooooooolOooooo`03o`000?oo
oooooooo017ooooo0_l0000looooo`;o<ol0iOooool2o`0001?ooooo000Rooooo`03o`000?oooooo
oooo00?ooooo0oo<0?oooooooakooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0j
ooooo`Co<ol0iOooool00ol0003oooooooooo`0Aooooo`008_ooool2o`0000Gooooo0oo<0?oooooo
oacooooo0_l0000Cooooo`03o`000?oooooooooo03Wooooo1Olco`3Uooooo`03o`000?oooooooooo
017ooooo000Rooooo`03o`000?oooooooooo00Gooooo0_o<0?oooooooagooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`0iooooo`;o<ol000?ooooooc?o0?lco`00iOooool00ol0003o
ooooooooo`0Aooooo`008_ooool00ol0003oooooooooo`05ooooo`?oc03ooooooolLooooo`03o`00
0?oooooooooo017ooooo00?o0000ooooooooool0>?ooool3oc?o0004oooooolco`3o<ol0oc?o0>Co
oooo00?o0000ooooooooool04Oooool002;ooooo00?o0000ooooooooool01_ooool3ol`0oooooooo
6oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo03Oooooo0olco`03ooooo`;o<ol0
i?ooool00ol0003oooooooooo`0Aooooo`008_ooool00ol0003oooooooooo`03ooooo`;o<`3o0_oo
ool2ol`0oooooooo6oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo03Kooooo0olc
o`04ooooo`?o<ol0hoooool00ol0003oooooooooo`0Aooooo`006Oooool5o`0000Cooooo00?o0000
ooooooooool00oooool2oc<0o`;ooooo0oo<0?oooooooa[ooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`0fooooo`;o<ol01_ooool2oc?o0>?ooooo00?o0000ooooooooool04Oooool0
01[ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`03ooooo`?o<`3o0_ooool3
ol`0oooooooo6Oooool00ol0003oooooooooo`0:ooooo`?o00001?ooool00ol0003oooooooooo`0e
ooooo`?o<ol01_ooool3oc?o0>;ooooo00?o0000ooooooooool04Oooool001?ooooo1Ol00003oooo
o`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool3oc<0o`;ooooo0oo<0?oooooo
oaSooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo
03Cooooo0olco`08ooooo`;o<ol0h_ooool00ol0003oooooooooo`0Aooooo`007?ooool00ol0003o
ooooooooo`03ooooo`?o00001Oooool3oc<0o`;ooooo0_o<0?oooooooaKooooo0ol00004ooooo`Go
000000?oooooo`000?l000000ol00004ooooo`03o`000?oooooooooo03Cooooo0_lco`09ooooo`;o
<ol0h_ooool00ol0003oooooooooo`0Aooooo`006Oooool01Ol0003ooooooooooooooooo000000Co
oooo00?o0000ooooooooool01_ooool3oc<0o`04ooooooo<0?ooc03ool`0oooooooo5oooool00ol0
003oooooooooo`08ooooo`04o`000?ooooooooooo`0000Gooooo0ol0000cooooo`?o<ol02Oooool3
oc?o0=oooooo0ol0000Cooooo`006Oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000
ooooooooool01oooool2oc<0o`;ooooo0oo<0?oooooooaKooooo00?o0000ooooooooool02Oooool0
0ol0003oooooo`000005ooooo`03o`000?oooooooooo03;ooooo0olco`0;ooooo`;o<ol0hOooool0
0ol0003oooooooooo`0Aooooo`006_ooool3o`0000Gooooo00?o0000ooooooooool01oooool3oc<0
o`;ooooo0_o<0?oooooooaKooooo00?o0000ooooooooool02_ooool2o`0000Gooooo00?o0000oooo
ooooool0<Oooool3oc?o00cooooo0olco`3Pooooo`03o`000?oooooooooo017ooooo000Rooooo`03
o`000?oooooooooo00Sooooo0olc0?l01?ooooooc03ool`0ooo<0?oooooooaGooooo00?o0000oooo
ooooool02oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo037ooooo0_lco`0>oooo
o`;o<ol0h?ooool00ol0003oooooooooo`0Aooooo`008_ooool00ol0003oooooooooo`09ooooo`?o
<`3o00Cooooool`0ooo<0?ooc03ooooooolDooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool0<?ooool3oc?o00kooooo0olco`3Oooooo`03o`000?oooooooooo017ooooo000Rooooo`03
o`000?oooooooooo00?ooooo0_lco`05ooooo`?o<`3o00?ooooool`0ooo<0?l0oooooolDooooo`03
o`000?oooooooooo017ooooo00?o0000ooooooooool0;oooool3oc?o013ooooo0_lco`3Oooooo`03
o`000?oooooooooo017ooooo000Rooooo`;o00001?ooool2oc?o00Kooooo0_lc0?l01?ooooooc03o
ol`0ooo<0?oooooooa;ooooo0_l0000Cooooo`03o`000?oooooooooo02oooooo0_lco`0Aooooo`;o
<ol0goooool00ol0003oooooooooo`0Aooooo`008_ooool00ol0003oooooooooo`03ooooo`?o<ol0
1Oooool3oc<0o`04ooooooo<0?ooc03ool`0oooooooo4_ooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo02kooooo0olco`0Aooooo`?o<ol0g_ooool00ol0003oooooooooo`0Aooooo`00
8_ooool00ol0003oooooooooo`04ooooo`?o<ol01Oooool3oc<0o`03ooooooo<0?ooc03o0?oooooo
4_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo02gooooo0olco`0Cooooo`;o<ol0
g_ooool00ol0003oooooooooo`0Aooooo`008_ooool00ol0003oooooooooo`05ooooo`?o<ol01Ooo
ool3oc<0o`?oc03ooooooolAooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0;?oo
ool3oc?o01Cooooo0olco`3Mooooo`03o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooo
oooo00Kooooo0olco`05ooooo`?o<`3o0oo<0?oooooooa3ooooo00?o0000ooooooooool04Oooool2
o`0002gooooo0_lco`0Fooooo`;o<ol0g?ooool2o`0001?ooooo000Rooooo`03o`000?oooooooooo
00Oooooo0olco`05ooooo`;o<`3o00Cooooool`0ooo<0?ooc03oooooool?ooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool0:oooool3oc?o00gooooo0_oo09T7ooooo`?o<ol0g?ooool0
0ol0003oooooooooo`0Aooooo`008_ooool00ol0003oooooooooo`08ooooo`?o<ol01?ooool3oc<0
o`03ooooooo<0?ooc03o0?oooooo3oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo
02[ooooo0olco`0>ooooo`;oo`2I2?ooool2oc?o0=cooooo00?o0000ooooooooool04Oooool002;o
oooo0_l0000:ooooo`;o<ol01Oooool3oc<0o`?oc03oooooool=ooooo`;o00004oooool00ol0003o
ooooooooo`0Zooooo`;o<ol03_ooool4ool0V@Oooooo0_lco`3Looooo`03o`000?oooooooooo017o
oooo000Rooooo`03o`000?oooooooooo00Wooooo0olco`05ooooo`?o<`3o0oo<0?ooooooo`gooooo
00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Yooooo`?o<ol03Oooool6ool0V@Kooooo
0olco`3Kooooo`03o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooooooo00?ooooo0ol0
ool4ooooo`?o<ol01Oooool3oc<0o`;oc03oooooool=ooooo`03o`000?oooooooooo017ooooo00?o
0000ooooooooool0:?ooool3oc?o00kooooo0_oo09T2ooooo`;oo`2I1oooool2oc?o0=_ooooo00?o
0000ooooooooool04Oooool002;ooooo00?o0000ooooooooool00oooool4o`3oo`Cooooo0olco`05
ooooo`;o<`3o0oo<0?ooooooo`cooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0X
ooooo`;o<ol03_ooool3ool0V@;ooooo0ooo09T6ooooo`?o<ol0f_ooool00ol0003oooooooooo`0A
ooooo`008_ooool00ol0003oooooooooo`03ooooo`;oo`000ol0ool4ooooo`?o<ol01?ooool3oc<0
o`?oc03oooooool;ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool09oooool3oc?o
00kooooo0_oo09T4ooooo`?oo`2I1_ooool2oc?o0=[ooooo00?o0000ooooooooool04Oooool002;o
oooo00?o0000ooooooooool00oooool3ool000?o0?oo1?ooool3oc?o00Cooooo0olc0?l2ol`0oooo
oooo2oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo02Kooooo0olco`0>ooooo`?o
o`2I1Oooool3ool0V@Gooooo0olco`3Iooooo`03o`000?oooooooooo017ooooo000Rooooo`03o`00
0?oooooooooo00?ooooo0ol0ofH01?oo003o0?ooo`3oool0ool4ooooo`?o<ol01?ooool2oc<0o`?o
c03oooooool:ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool09Oooool3oc?o00ko
oooo0ooo09T2ooooo`;o0?oo0oooool2ool0V@Kooooo0_lco`3Iooooo`03o`000?oooooooooo017o
oooo000Rooooo`03o`000?oooooooooo00?ooooo1?l0ofH01?oo003o0?ooo`3oool0ool4ooooo`;o
<ol01Oooool2oc<0o`?oc03oooooool9ooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool09Oooool2oc?o00oooooo0_oo09T3ooooo`;o0?oo0oooool3ool0V@Gooooo0_lco`3Iooooo`03
o`000?oooooooooo017ooooo000Rooooo`;o00001_ooool3o`3oIP04ool00?l0oooo0?ooo`3oo`?o
oooo0olco`05ooooo`;o<`3o0_o<0?ooooooo`Sooooo0_l0000Cooooo`;o00009Oooool3oc?o00ko
oooo0ooo09T2ooooo`Co0?oo0oooool3ool0V@Cooooo0olco`3Gooooo`;o00004oooool002;ooooo
00?o0000ooooooooool01_ooool3o`3oIP04ool00?l0oooo0?ooo`3oo`?ooooo0olco`04ooooo`;o
<`3o0oo<0?ooooooo`Sooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Sooooo`?o
<ol03_ooool3ool0V@?ooooo1Ol0ool3ooooo`;oo`2I1Oooool2oc?o0=Sooooo00?o0000oooooooo
ool04Oooool002;ooooo00?o0000ooooooooool01oooool3o`3oIP04ool00?l0oooo0?ooo`3oo`?o
oooo0olco`04ooooo`;o<`3o0oo<0?ooooooo`Oooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`0Sooooo`;o<ol03oooool2ool0V@?ooooo0ol0ool01?oooooo0?ooo`3oool0ool2oooo
o`?oo`2I1?ooool3oc?o0=Oooooo00?o0000ooooooooool04Oooool002;ooooo00?o0000oooooooo
ool02?ooool4o`3oIP?o0?oo00?oo`00ooooooooool00olco`04ooooo`;o<`3o0oo<0?ooooooo`Ko
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Rooooo`?o<ol03_ooool3ool0V@?o
oooo0_l0ool3ooooo`?o0?oo0_ooool3ool0V@Cooooo0_lco`3Gooooo`03o`000?oooooooooo017o
oooo000Rooooo`03o`000?oooooooooo00Wooooo1?l0ofH3o`3oo`03ool00?oooooooooo00?o<ol0
1?ooool2oc<0o`;oc03oooooool6ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0
8Oooool3oc?o00oooooo0_oo09T3ooooo`?o0?oo1?ooool3o`3oo`;ooooo0_oo09T4ooooo`;o<ol0
eoooool00ol0003oooooooooo`0Aooooo`008_ooool00ol0003oooooooooo`03ooooo`?oc?l01Ooo
ool3o`3oIP?o0?oo00?oo`00ooooooooool00olco`04ooooo`04oc<0ooo<0?ooc03ool`0oooooooo
1Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo023ooooo0olco`0?ooooo`?oo`2I
0oooool2o`3oo`Kooooo0ol0ool01?ooooooo`2Iool0VOoo09T3ooooo`?o<ol0e_ooool00ol0003o
ooooooooo`0Aooooo`008_ooool00ol0003oooooooooo`03ooooo`Coc?l01Oooool3o`3oIP?o0?oo
00?oo`00ooooooooool00olco`03ooooo`;o<`3o0oo<0?ooooooo`Cooooo00?o0000ooooooooool0
4Oooool00ol0003oooooooooo`0Pooooo`;o<ol03oooool3ool0V@?ooooo0ol0ool7ooooo`?o0?oo
00Coooooool0VOoo09Woo`2I0oooool2oc?o0=Kooooo00?o0000ooooooooool04Oooool002;ooooo
0_l00004ooooo`;o0?oo1?o<o`04ooooo`Co0?mV0_l0ool2ool00003oooooolco`3o<ol000Cooooo
0_lc0?l2ol`0oooooooo0oooool2o`0001?ooooo00?o0000ooooooooool07oooool3oc?o00oooooo
0_oo09T4ooooo`;o0?oo00Coooooool00?oo003oo`001Oooool3o`3oo`04oooooooo09Woo`2Iool0
V@;ooooo0olco`3Eooooo`03o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooooooo00?o
oooo0oooV@04olco00Cooooo1?l0ofH2o`3oo`;oo`000olco`04ooooo`04oc<0ooo<0?ooc03ool`0
oooooooo0oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo01kooooo0olco`0?oooo
o`?oo`2I0oooool3o`3oo`Coo`001_ooool2o`3oo`;ooooo0_oo09T3ooooo`;o<ol0eOooool00ol0
003oooooooooo`0Aooooo`008_ooool00ol0003oooooooooo`03ooooo`CooiT000?o0?ooolco0?o<
o`000_o<o`04ooooo`?o0?mV0_l0ool2ool000?o<ol01?ooool01?lc0?ooc03ool`0ooo<0?oooooo
o`;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Nooooo`;o<ol03oooool3ool0
V@Cooooo0_l0ool6ool000Gooooo0ol0ool01?ooooooo`2Iool0VOoo09T2ooooo`?o<ol0e?ooool0
0ol0003oooooooooo`0Aooooo`008_ooool00ol0003oooooooooo`05ooooo`?ooiT000?o0?ooolco
0?o<o`000_o<o`04ooooo`?o0?mV0_l0ool2ool000?o<ol01?ooool00olc0?ooc03ool`0o`3ooooo
o`;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0Mooooo`?o<ol03oooool2ool0
V@Cooooo0ol0ool2ool00003oooooooo09Woo`2I00;oo`001Oooool3o`3oo`04oooooooo09Woo`2I
ool0V@;ooooo0_lco`3Dooooo`03o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooooooo
00Kooooo0oooV@02o`3oo`Coc?l00oooool3o`3oIP;o0?oo0_oo0003oc?o00?ooooo00Co<`3ool`0
ooo<0?ooc03oooooool1ooooo`03o`000?oooooooooo017ooooo0_l0000Mooooo`?o<ol03oooool3
ool0V@?ooooo00Coo`00o`3oool0ooooo`000oooool2ool0V@?oo`001Oooool3o`3oo`03oooooooo
09Woo`2I00;ooooo0_lco`3Cooooo`;o00004oooool001[ooooo0ol00005ooooo`03o`000?oooooo
oooo00?ooooo0ooo00001?oooooooiT0oonI0?ooV@02o`3oo`Coc?l00oooool4o`3oIP;o0?oo00Co
o`00oc?o0?lco`3o<ol00oooool01?lc0?ooc03ool`0ooo<0?ooooooo`03o`000?oooooooooo017o
oooo00?o0000ooooooooool06oooool3oc?o013ooooo0_oo09T3ooooo`04ool00?l0oooo0?ooo`3o
o`?ooooo1?oo09T2ool000Kooooo0ol0ool3ool0V@04oooooolco`3o<ol0oc?o0=?ooooo00?o0000
ooooooooool04Oooool001_ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`03oooo
o`?o06Ko00?oo`00ooooooooV@000oooV@000ol0ooooc?l0olco0003olco00;ooooo1?l0ofH2o`3o
o`04ool00?lco`3o<ol0oc?o00?ooooo00?o<`3ool`0ooo<0?l0ooooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo01_ooooo0_lco`0@ooooo`?oo`2I00?oooooool00?oo00000ol0ool3
ooooo`Koo`2I0_oo0006ooooo`?o0?oo0ooo09T00ooooooo<ol0oc?o003Cooooo`03o`000?oooooo
oooo017ooooo000Cooooo`Go00000oooool00ol0003oooooooooo`04ooooo`?o00000oooool3ool0
00?o06Ko1?ooV@000ol0ooooc?l0olco0003olco00?ooooo0ol0ofH2o`3oo`03ool00?lco`3o<ol0
00Cooooo0oo<0?olooooo`?o00004oooool00ol0003oooooooooo`03ooooo`;oc?l05Oooool3oc?o
00oooooo0ooo09T01?ooooooo`00ool00?oo0002o`3oo`?ooooo0ooo09T2olco00?oo`2I0_oo0000
0ooo09Woooooooooo`03ooooo`?o0?oo0_oo09T01?oooooo<ol0oc?o0?lco`3Booooo`03o`000?oo
oooooooo017ooooo000Kooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool6
ool000;o06Ko0oooV@000ol0ooooc?l0olco0004olco00;ooooo0ol0ofH2o`3oo`?o<ol01?ooool3
ol`0oogooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`03ooooo`;oc?l05?ooool3
oc?o013ooooo0_oo09T4ool000?o0?oo0_ooool3ool0V@04olco0?ooooooooooolco00?oo`2I0_oo
00000ooo09Woooooooooo`03ooooo`?o0?oo0_oo09T00ooooooo<ol0oc?o003Booooo`03o`000?oo
oooooooo017ooooo000Kooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00oooool2
ol`0o`Ooo`000oooV@000ol0ooooooooolco0004olco00;ooooo1?l0ofH01?l0oooo<ol0oc?o0?lc
o`03ooooo`04oc<0ooo<0?ooc03ool`0oocooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`03ooooo`?oc?l04oooool2oc?o013ooooo0_oo09T4ool00003ooooool0oooo0?oo00;ooooo
1?oo09T4o`1Vo`04olco0?oo09Woo`2Iool0V@;oo`0000?oo`2Iooooooooool00oooool3o`3oo`;o
o`2I0olco`3Aooooo`03o`000?oooooooooo017ooooo000Jooooo`;o00001_ooool00ol0003ooooo
ooooo`05ooooo`?oc03o1Ooo0003oonI0003o`3oooooooooc?l000Goc?l000?oooooo`3oI_l0ofH0
0_l0ofH01?l0oooo<ol0oc?o0?lco`03ooooo`03oc<0ooo<0?ooc03o0?cooooo00?o0000oooooooo
ool04Oooool00ol0003oooooooooo`04ooooo`?oc?l04Oooool3oc?o013ooooo1?oo0002ooooo`?o
0?oo0_ooool3ool0V@Ko06Ko00Goc?l0ool0VOoo09Woo`2Iool00003ool0V@Cooooo0_l0ool3ool0
V@;o<ol0dOooool00ol0003oooooooooo`0Aooooo`006oooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Kooooo1?o<0?l01?oo09Woo`00ool00?oo0004oonI0003ooooooo<o`3oc?l0
00Coc?l00_ooool3o`3oIP04o`3ooolco`3o<ol0oc?o00?ooooo0oo<0?okooooo`03o`000?oooooo
oooo017ooooo00?o0000ooooooooool01Oooool3olco00oooooo0olco`0@ooooo`Coo`000oooool2
o`3oo`;ooooo0ooo09T3o`1Vo`;o0?mV0ol0I_l01Oo<o`3oo`2Iool0VOoo09Woo`0000?oo`2I0ooo
ool3o`3oo`;oo`2I0_lco`3Aooooo`03o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooo
oooo00?ooooo0olc0?l00oooooooc03ool`0o`02ol`0o`04ool0VOoo003oo`00ool000CooiT000?o
o`00ooooooo<o`001Oo<o`001Ooooooo0?mVo`3oI_l0ofKo0?oo00?o<ol00oooool3ol`0oo[ooooo
00?o0000ooooooooool02?ooool5o`0000Cooooo00?o0000ooooooooool01_ooool3olco00gooooo
0olco`0?ooooo`Coo`001?ooool3o`3oo`04ooooooo<o`3oo`2Iool0V@?o06Ko0_l0ofH2ooooo`Co
06Ko0ooo09T01?oo003oo`2Iool0VOoo09T3ooooo`?o0?oo00Coo`2Ioc?o0?lco`3o<ol0d?ooool0
0ol0003oooooooooo`0Aooooo`008_ooool00ol0003oooooooooo`03ooooo`Ko<`3o0oo<0?l01Ooo
09Woo`00ool00?oo003ooooo00?ooiT00ooo0005olco0005ooooool0ofKo0?mVo`3oI_l0ool00olc
o`000ooo003oooooooooo`02ol`0oo[ooooo00?o0000ooooooooool02Oooool01?l0003ooooooooo
ool00004ooooo`03o`000?oooooooooo00Oooooo0_o<o`0=ooooo`;o<ol03oooool4ool000Gooooo
0_l0ool00oooooooc?l0ool0V@02ool0V@04o`1Vool0ofKo0?mVo`3oIPCooooo1?l0I_l3ool0V@04
ool00?oo09Woo`2Iool0V@?ooooo0ol0ool00ooo09Wo<ol0oc?o003@ooooo`03o`000?oooooooooo
017ooooo000Rooooo`03o`000?oooooooooo00Gooooo1Olc0?l3ol`0o`;oo`2I0ooo0003oonI00Go
o`001?o<o`04o`3oIP;o<ol00_oo00001?ooooooc03ool`0ooo<0?oiooooo`03o`000?oooooooooo
00;ooooo1Ol00003ooooo`03o`000?oooooooooo00Cooooo0ol00007ooooo`?oc?l02oooool3oc?o
00gooooo1?oo0002ool0V@Cooooo0ol0ool01Ol0I_ooo`2Iool0VOoo09Wo06Ko00?o0?mV1_ooool0
1?l0ofKo06Koo`1Vool0I_l3ool0V@03oooooooo09Woo`2I00;oo`2I0_ooool3o`3oo`?o<ol0cOoo
ool3o`0001?ooooo000Rooooo`;o00001?ooool3o`1Vo`;ooooo0olc0?l4ol`0o`04ool0VOoo003o
o`00ool000?ooiT01ooo0002olco00Co0?mV0_lco`02ool00004ooooooo<0?ooc03ool`0ooOooooo
0_l0000=ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02?ooool3olco00Wooooo
0olco`0=ooooo`Coo`000_oo09T5ooooo`;o0?oo00Go06Koool0VOoo09Woo`2Iooooo`03o`3oIPSo
oooo00Co0?mVo`1Vool0I_oo06Ko0ooo09T00oooooooo`2Iool0V@02ool0V@;ooooo0ol0ool2oc?o
0<oooooo00?o0000ooooooooool04Oooool002;ooooo00?o0000ooooooooool00oooool6o`1Vo`03
oooooolc0?oo<`3o00Coc03o00Coo`2Iool00?oo003oo`000oooV@000ooooooo06Koool00006ool0
0004olco0?l0ofKo0?mVo`3oIP;o<ol00_oo00001?ooooooc03ool`0oolc0?ogooooo`03o`000?oo
oooooooo00Sooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo00?ooooo
0_l0I_l4ooooo`?oc?l02?ooool2oc?o00cooooo1?oo00000oooooooo`2Iool0V@05ooooo`?o0?oo
00Co06Koool0VOoo09Wooooo0ol0ofH2ooooo`?oc03o1Oooool01?l0ofKo06Koo`1Vool0I_l3ool0
V@;ooooo0ooo09T2ooooo`?o0?oo0_lco`3>ooooo`03o`000?oooooooooo017ooooo000Rooooo`03
o`000?oooooooooo00Gooooo1ol0I_l00ooooooo<`3ool`0o`02ol`0o`04oc<0oooo09Woo`00ool0
00CooiT000?oooooo`1Vool0I_l01_oo00000oo<o`3o0?mVo`3oIP02oc?o00;oo`000oo<0?l00olc
0?ooooooooooo`3dooooo`03o`000?oooooooooo00Sooooo00Go0000ooooooooooooooooo`000004
ooooo`03o`000?oooooooooo00?ooooo0_l0I_l5ooooo`?oc?l01_ooool3oc?o00_ooooo1?oo0000
1?ooooooo`2Iool0VOoo09T5ooooo`;o0?oo00Co06Koool0VOoo09Woo`2I0ol0ofH3ol`0o`Coc?l0
1Oooool01?l0ofKo06Koo`1Vool0I_l3ool0V@;ooooo0ooo09T2ooooo`?o0?oo00?o<ol0oooooooo
ool0`oooool3ol`0o`Kooooo00?o0000ooooooooool04Oooool002;ooooo00?o0000ooooooooool0
0oooool3oc<0o`03ooooool0ofKo06Ko00Ko06Ko1?o<0?l2oc<0o`03ool00?ooV@3ooiT000;ooiT0
0oooool2o`1Vo`Koo`0000?o0?mVoc?o0?lco`000_oo0003ol`0ooKooooo00?o0000ooooooooool0
2Oooool3o`0000Gooooo00?o0000ooooooooool00oooool3o`1Vo`Gooooo0_o<o`05ooooo`?o<ol0
2_ooool4ool000?ooooo0_oo09T4ooooo`04o`1Vool0oooo0?ooo`3oo`?oo`2I00?ooooool`0ooo<
0?l00oo<0?l6olco00Gooooo0_l0ofH2o`1Vo`?oo`2I0_ooool4ool0V@04ooooool0oooo0?ooo`3o
olCooooo1?o<0?l6ooooo`03o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooooooo00?o
oooo1?lc0?l2ooooo`;o0?mV1ol0I_l2ol`0o`?o<`3o00Coo`00oonI0?ooV@3ooiT01?ooool2o`1V
o`Ooo`0000?o<ol0ool00?oo00000_o<0?l00olc0?ooooooooooo`3cooooo`03o`000?oooooooooo
017ooooo00?o0000ooooooooool00oooool01?lco`3o06Koo`1Vool0I_l4ooooo`?oc?l01?ooool2
oc?o00Wooooo1Ooo0003ooooo`?oo`2I0oooool2o`1Vo`;o0?oo0ooo09T3ol`0o`;o0?mV1?o<o`02
o`3oIP?oc?l01_ooool00ol0ofKo06Koool00003ool0V@;ooooo1?oo09T01?oooooo0?ooo`3ooolc
o`1Dooooo`Co06KoJ_ooool3ol`0o`Sooooo00?o0000ooooooooool04Oooool002;ooooo00?o0000
ooooooooool00oooool4o`3oo`;o<`3o00?oooooo`3oI_l0ofH00_l0ofH6o`1Vo`03ol`0oolc0?oo
<`3o00;o<`3o0oooV@05ooooo`;o06Ko00?oc?l0ool00?oo00001Ooo0003ol`0o`03oc<0oooooooo
oooo0?;ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`03ooooo`;o<ol00ol0I_l4
ooooo`?oc?l00_ooool3oc?o00Sooooo1?oo0004ooooo`?oo`2I0_ooool3o`1Vo`?o0?oo0_oo09T5
o`3oIPCoc?l00olco`001?l0ofKoc?l0olco0?o<o`06ooooo`03o`3oI_l0I_ooo`0000?oo`2I0ooo
ool3ool0V@?o0?oo00?oo`2Iooooooooool0D?ooool6o`1VofSooooo0oo<0?l9ooooo`03o`000?oo
oooooooo017ooooo000Rooooo`03o`000?oooooooooo00?ooooo1?o<o`03o`3oo`;ooooo1Ol0ofH6
o`1Vo`?o<`3o0oooV@05ooooo`;oc?l000?o06Koolco0?o<o`001ooo00000oo<0?oo<`3oooooo`3b
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool01?ooool2oc?o00;o06Ko1Oooool3
olco00?o<ol01oooool4ool000Kooooo0_oo09T2ooooo`Co06Ko0_l0ool3ool0V@Co0?mV0oo<o`02
oc?o00Coc03o00Co0?mVolco0?o<o`3oc?l01_ooool00ol0ofKoc?l0ool00003ool0V@?ooooo0ooo
09T3o`3ooacooooo0olc0?lbooooo`?o06Ko0_lco`03o`1VofKooooo0oo<0?l:ooooo`03o`000?oo
oooooooo017ooooo000Rooooo`;o00001?ooool3o`3oo`Goc?l00ol0ool5o`3oIPOo06Ko00?o<`3o
oonI0?ooV@000_ooV@05ooooo`Koc?l01_oo00000olc0?ooooooooooo`3_ooooo`;o00004oooool0
0ol0003oooooooooo`05ooooo`04oc?o0?l0I_oo06Koo`1Vo`Gooooo0oo<o`000olco`3ooooooooo
o`05ooooo`Coo`001_ooool3ool0V@;o06Ko0ol0ofH3o`3oo`;oo`2I0ol0ofH4olco00;o<ol01_o<
0?l01?l0ofKoc?l0olco0?o<o`06ooooo`03o`3oI_o<o`3oo`0000?oo`2I0oooool3ool0V@?o0?oo
6oooool4oc<0oc3ooooo0ol0I_l01?lco`3ooooooooooolco`03o`1VofCooooo0oo<0?l;ooooo`03
o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooooooo00?ooooo1_l0ool5olco00?o0?oo
0ol0ofH2ooooo`Ko06Ko1?ooV@000olc0?ooooooooooo`02ooooo`Ooc?l000?o0?mVool00?oo0000
1?oo003`ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool01_ooool01?lco`3o06Ko
o`1Vool0I_l5ooooo`;oc?l01_ooool4ool000Oooooo00?oo`2Io`3oI_l0ofH01_l0ofH2o`3oo`;o
o`2I0ol0ofH4olco00;o<ol00oo<0?l00ooooooo<ol0ol`0o`02ol`0o`04o`3oI_o<o`3oc?l0olco
00Kooooo00?o0?mVool00?oo00000ooo09T4ooooo`03ool0VOlco`3o0?oo00;o0?oo6Oooool6oc<0
obkooooo0ol0I_l00olco`3oooooooooo`03ooooo`Co06KoHOooool3ol`0o`cooooo00?o0000oooo
ooooool04Oooool002;ooooo00?o0000ooooooooool00oooool2ool0V@Oo0?oo1_o<o`03o`3oo`04
o`3oI_ooooooc03ool`0o`Go06Ko0oooV@02oc<0o`Cooooo1_o<o`000ol0ofKo06Koool00006ool0
0>gooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`07ooooo`04oc?o0?l0I_oo06Ko
o`1Vo`?ooooo00Co<ol0olco0?o<o`3oc?l01?ooool4ool000Gooooo2_l0ofH01oo<o`3o0?ooo`3o
ool0ooooo`2Io`3oI_lco`001?o<o`000olco`3oooooooooo`03ol`0o`Coo`000oo<0?l01?l0ofKo
c?l0olco0?o<o`06ooooo`03o`3oI_oo003oo`0000?oo`2I1?ooool00ooo09Wo<ol0o`3oo`02o`3o
oaOooooo0olc0?l2ooooo`?o<`3o;?ooool3o`1Vo`03oc?o0?oooooooooo00Gooooo1?l0I_l00olc
o`3oooooooooo`1Looooo`?oc03o3Oooool00ol0003oooooooooo`0Aooooo`008_ooool00ol0003o
ooooooooo`03ooooo`Goo`2I1_l0ool8olco00;o0?oo1?o<0?l3o`1Vo`?ooiT01?lc0?l2ooooo`Oo
c?l00ol0I_l7ool00>[ooooo00?o0000ooooooooool04Oooool2o`0000Wooooo00?o<ol0o`1Vool0
I_l00_ooool3oc?o00?oc?l000?oooooool00?oo00000_oo0003ooooo`Wo0?mV00?o06Kool`0ooo<
0?l00oo<o`02o`3oo`?o<ol01?o<o`03ooooo`?oc03o1_oo0004ol`0o`?oc?l01_ooool00ol0ofKo
o`00ool00003ool0V@Cooooo0_lco`03o`3ooaGooooo0olc0?l4ooooo`?o<`3o:_ooool3o`1Vo`03
oc?o0?oooooooooo00?o0?mV1Oooool3o`1Vo`03oc?o0?oooooooooo02[ooooo1?ooV@0/ooooo`?o
c03o3Oooool2o`0001?ooooo000Rooooo`03o`000?oooooooooo00?ooooo0_l0ool6ool0V@Ko0?oo
2?o<o`04ol`0o`03ool0VOoo003o06Ko00?ooiT00_l0I_l3oc<0o`;ooooo1_o<o`05o`1Vo`Coo`00
1_o<o`0cooooo`Goo`2I[?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00Wooooo
0ol0I_l00ooooooo<ol0oc?o0002ooooo`?oc?l00_oo000:o`3oIPCo06Ko00?oc03oooooooo<o`00
0_o<o`03o`3oo`03oc?o0?o<o`3oc?l000;oc?l01?ooool3ol`0o`?oo`000_l0ofH3ool000Coc03o
0oo<o`06ooooo`03o`3oI_oo003oo`0000?oo`2I00?o06Koooooooooool00olco`03o`3ooa?ooooo
0olc0?l6ooooo`?o<`3o:?ooool3o`1Vo`03oc?o0?oooooo0?mV00Co0?mV1_ooool3o`1Vo`;o<ol0
:Oooool6oonI02[ooooo0oo<0?l6ooooo`?oo`2I1_ooool00ol0003oooooooooo`0Aooooo`008_oo
ool00ol0003oooooooooo`03ooooo`Go0?oo1Ooo09T7o`3oo`03ool00?o<o`3oc?l000Coc?l00oo<
0?l00ol0ooooo`2Io`3oo`04oonI00?o06Ko0olc0?l2olco0003o`3oooo<o`3oc?l000;oc?l01?l0
I_l=olco02gooooo2_oo09VYooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool00ooo
ool4o`3oIP?ooooo0ol0I_l2oc?o00;ooooo00Coo`00olco0?o<o`3oc?l01ol0ofH2ol`0o`Co06Ko
00?oc03oooooooooool00_o<o`02oc?o00;o0?oo00?o<ol0olco0?o<o`000_o<o`04ooooo`?oc03o
0ooo00001?l0ofKoooooooooool0ofH3ool000?oc03o00Co<ol0olco0?o<o`3oc?l01_ooool00ol0
ofKoo`00ool00003ool0V@03o`1Voooooooooooo00;o<ol000Coo`2Io`3oool0oooo0?oo4Oooool3
oc<0o`;ooooo0_l0ool4ooooo`?o<`3o9_ooool3o`1Vo`03oc?o0?l0ofKo0?mV00Ko0?mV1_ooool4
o`1Vo`;o<ol09Oooool9oonI02Sooooo0oo<0?l5ooooo`;oo`2I0oo<o`06ooooo`03o`000?oooooo
oooo017ooooo000Rooooo`03o`000?oooooooooo00Gooooo1_l0ool5ool0V@Ko0?oo0ooo0003olco
00Coc03o00?oc?l0o`3oooooV@000oooV@05o`1Vo`;o<`3o00?oc?l0o`3oooo<o`002oo<o`03ool0
00Soc?l0:?ooool5ool0V@?ooooo2?oo09VUooooo`03o`000?oooooooooo017ooooo00?o0000oooo
ooooool00oooool8o`3oIP?o06Ko1Ol0ofH2olco00;o0?mV0oooool3ol`0o`Co06Ko00?oo`2Ioooo
ooooool01?lco`02o`3oo`Coc?l01Oooool3ol`0o`;oo`0000?o0?mVoc?o0?ooool00ooo09T01?o<
o`3oo`00ool00?oo0003ol`0o`04oc?o0?o<o`3oc?l0olco00;o<ol01?ooool3ool000?oo`2I00?o
06Kooooooolco`000_lco`000ooo09Wo0?ooo`3oo`0Aooooo`;o<`3o0_ooool4oonI00Cooooo1?lc
0?lSooooo`?o06Ko1Ol0ofH3ool0V@?o0?mV1_ooool4o`1Vo`;o<ol08oooool7oonI0003oooooooo
V@3ooiT000;ooiT09Oooool3ol`0o`Gooooo00?oo`2Iolco0?o<o`000oo<o`06ooooo`03o`000?oo
oooooooo017ooooo000Rooooo`;o00001?ooool3ool000;ooooo1Ol0ool6ool0V@Ko0?oo0ooo0000
0oo<o`3oc03ool`0o`02ol`0o`?oc?l00oooV@07o`1Vo`03oc<0ooo<o`3oc?l000Koc?l01Ol0I_l0
0oo<o`3oo`00ool00002ool000Woc?l08_ooool5ool0V@Sooooo2?oo09TWooooo`[o06KoL?ooool2
o`0001?ooooo00?o0000ooooooooool01_ooool4o`3oIP;o<ol00_l0I_l5o`3oIP?oc?l000?ooooo
ol`0ooo<0?l00_o<0?l4o`1Vo`;oo`2I00?ooooooc?o0?lco`001?lco`000ol0ooooc?l0olco0002
olco00Gooooo0oo<0?l01?oo003o0?mVoc?o0?ooool2o`3oIPCoo`2I00Coooooool00?oo003oo`00
0oo<0?l01?lco`3oc?l0olco0?o<o`05oc?o0004oooooooo003oo`00ool000?oo`2I0_l0I_l2oc?o
0005ool0VOl0oooo0?ooo`3ooooo09T03_ooool2oc<0o`[ooiT00_ooool4oc<0ob3ooooo1?l0I_l4
o`3oIPKoo`2I0ol0ofH7ooooo`?o06Ko0olco`0Pooooo`WooiT000?ooooooonI0?ooV@000_ooV@0S
ooooo`?oc03o1?ooool00ooo09Woc?l0olco0002olco00?ooiT01_ooool00ol0003oooooooooo`0A
ooooo`008_ooool00ol0003oooooooooo`03ooooo`Goo`000oooool4o`3oo`03oc<0oooo09Woo`2I
00?oo`2I1ol0ool3ool000?oc03o0oo<o`03oonI00;o0?oo00?o06Koolco0?o<o`003?o<o`05o`1V
o`03oonI0?oo003oo`0000;oo`002oo<o`0Mooooo`Coo`2I3_ooool8ool0VAkooooo6?l0I_mXoooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool01Oooool5o`3oIP;o<ol00ol0I_l2ool0
0003o`3oI_oooooooooo00?oc?l00oo<0?l4o`1Vo`03ool0VOlco`3o<ol000Co<ol00_oo09T01Ol0
ooooc?l0olco0?o<o`3o0?mV00Gooooo0oo<0?l00ooo003o0?mVoc?o0003o`3oIPOoo`2I0ooo0004
ol`0o`?oc?l02?lco`001Ooo003oo`2Iool0VOoo09Wo06Ko00;o<ol000?oooooool0VOl0ool00_l0
ool00ooo09Woooooooooo`0:ooooo`OooiT00_l0ool7oonI0004oooooolc0?oo<`3ooc<0oakooooo
1?l0I_l3o`3oIPGoo`2I0oooool01?oo09Wo0?mVo`3oI_l0ofH7ooooo`?o06Ko1?lco`0Looooo`Oo
oiT00_l0I_l3oonI0003o`1VoooooooooiT000;ooiT08Oooool3ol`0o`?ooooo00?oo`2Iolco0?o<
o`000oo<o`04oonI00Kooooo00?o0000ooooooooool04Oooool002;ooooo00?o0000ooooooooool0
0oooool2ol`0o`Goo`000oooool3o`3oo`?o<`3o1Ooo09T6o`3oo`;oo`001?o<0?l2olco00?ooiT0
1oo<o`03o`1Vo`03o`3oI_o<o`3oc?l000;oc?l00ooo0005o`1Vo`Goo`003Oo<o`0Gooooo`Coo`2I
4oooool8ool0VAGooooo3?l0I_l8oooooa?o06Ko7_ooool5ool003;ooooo1?o<0?l6ooooo`03o`00
0?oooooooooo017ooooo00?o0000ooooooooool00oooool6o`3oIP?o<ol000Coo`00o`1Vool0I_oo
06Ko1Ol0ofH3olco00Co06Ko1olco`000oo<o`3oo`2Iool0V@04olco0003o`3oI_oooooooooo00;o
oooo00Koo`00ol`0ooo<0?ooc03oo`3oI_lco`04o`3oIP?oo`2I00?o06Koo`3oI_oo09T01?oo09T2
ool000Coc03o0oo<o`000ol0ofKooooooc?o0008oc?o0006ool0VOlco`3o<ol0oc?o0?ooooooo`2I
0ol0ool00ooo09Woooooooooo`06ooooo`OooiT000?oooooo`3oool0ool00_ooool3o`3oo`OooiT0
0_lc0?lKooooo`04ool0VOl0I_oo06Koo`1Vo`Co0?mV0_oo09T8ooooo`04ool0VOl0ofKo0?mVo`3o
IPOooooo1?l0I_l4oc?o01Wooooo1oooV@000ol0I_oo0?ooo`3oo`03o`3oo`03oonI0?l0I_oo06Ko
00?ooiT07oooool3ol`0o`?ooooo1Oo<o`04oonI00;o<`3o1_ooool00ol0003oooooooooo`0Aoooo
o`008_ooool00ol0003oooooooooo`03ooooo`Coc03o1Ooo0003ooooo`?o0?oo0olc0?l6ool0V@Ko
0?oo0oo<0?l3olco00CooiT01?o<o`07o`1Vo`?oc?l01?oo09T5o`1Vo`Goo`000_ooV@0<olco01;o
oooo1Ooo09T6ooooo`Go0?oo3Oooool8ool0V@_ooooo3Ol0I_l:ool0V@cooooo5?l0I_lAooooo`co
o`00:_ooool8ol`0o`Kooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`03ooooo`?o
0?mV0_oo0003oc?o00?oo`000ol0I_l5o`3oIP?oc?l000?o0?mVoc?o0?lco`001?lco`03olco00;o
o`2I1?o<o`001?l0ofKoooooooooool0ofH2ool000?oc03o00Co<ol0o`3oI_l0ofKo0?mV0_o<o`03
ool0V@?oc?l00_l0ofH4ool0V@;oo`000oo<0?l01Ol0ofKoc?l0olco0?o<o`3o0?mV00Cooooo2Olc
o`000ol0I_ooo`2Iool0V@03o`3oo`;oo`2I0oooool7oonI00?ooooo0ol0ool3ooooo`?o0?oo0_oo
ool7oonI01Kooooo1?oo09T3o`1Vo`?o0?mV3Oooool01?oo09Wo0?mVo`3oI_l0ofH7ooooo`Co06Ko
1?lco`0Fooooo`SooiT000?o06Koo`3oool0ool01ol0ool00ol0I_oooiT0oonI0002oonI01cooooo
0oo<0?l2ooooo`Goc?l000?ooooooonI0?ooV@000_ooV@000olc0?ooooooooooo`06ooooo`03o`00
0?oooooooooo017ooooo000Rooooo`03o`000?oooooooooo00Gooooo1?o<0?l5ool000?ooooo0ol0
ool4oc<0o`Goo`2I1?l0ool7olco00CooiT01_o<o`07o`1Vo`;oc?l01Ooo09T4o`1Vo`Coo`001_oo
V@0;olco00cooooo1Ooo09T5ooooo`_o0?oo1ooooolAool0V@co06Ko4ooo09TBoooooaCo06Ko4?l0
ofH7ool002;ooooo2_o<0?l9ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool00ooo
ool5ool0V@;o<ol00_oo0003ol`0o`;o06Ko0_o<0?l2ooooo`;o0?mV0_o<o`04oc?o00;oo`2I0oo<
o`000ooo09Woc?l0olco0002olco0003o`3oool0ofKo0?mV00;o0?mV0_oo0003ol`0o`03oc?o0?o<
o`3oc?l000?oc?l00ooo09T5o`1Vo`?o0?mV1?oo09T01Ooo003oc03ool`0ooo<0?oo0?mV00?oc?l0
00?o0?mVo`1Vool0I_l00_l0I_l3ool000Wo<ol00ol0ool00ooo09WooiT0oonI0005oonI00;o<`3o
0oooool3o`3oo`Gooooo0ol0ool4ooooo`KooiT03oooool8ool0V@?o06Ko0_l0ofHAooooo`?o0?mV
00?oo`2Iooooooooool01Oooool3o`1Vo`03oooooolco`3o<ol000;o<ol04oooool7oonI0003oooo
ool0oooo0?oo00;o0?oo0oooool6o`3oo`CooiT06_ooool3ol`0o`03ooooooo<o`3oc?l000?oc?l0
0_ooool3oonI0003ool00?o<0?ooc03o00;oc03o1_ooool00ol0003oooooooooo`0Aooooo`008_oo
ool00ol0003oooooooooo`03ooooo`Go<ol00oo<0?l5ool000?ooooo0_l0ool5oc<0o`03oc?o0?oo
09Woo`2I00Soc?l000?o0?oool`0ooo<0?l00_o<o`03oonI00;oo`2I1_o<o`07o`1Vo`?oo`000ooo
09T4o`1Vo`Coo`000_ooool7oonI00_oc?l01Oooool5ool0V@?ooooo0_l0I_l6o`3oo`?o06Ko1ol0
ool?ool0V@co06Ko1_oo09T?ooooo`Ooo`2I1OoooolDo`3oIQ?o06Ko2ol0ofH7ool001[ooooo2_o<
0?l3ooooo`CooiT01_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00?ooooo1?oo
V@03oc?o00;oo`000oo<0?l3o`1Vo`03o`3oI_l0I_oo<ol000;o<ol00oo<o`000olco`3o0?mVo`3o
IP04o`3oIP03ooooooo<o`3oc?l000;oc?l000Co0?ooo`3oI_l0ofKo0?mV0_oo0004ol`0o`Ooc?l0
0_oo09T00ol0I_oo<`3ooc<0o`07oc<0o`Goo`2I0oo<0?l01?l0ofKoc?l0olco0?o<o`0Aoc<0o`?o
0?oo4olc0?l2ooooo`;o0?oo1oooool6oonI00Sooooo2_oo09T01_l0ofKo06Koo`1Vool0I_oo0?mV
oc?o00Oooooo1?o<0?l4ool0V@Cooooo0ol0ofH00ooo09Woooooooooo`05ooooo`?o06Ko00?ooooo
oc?o0?lco`000olco`0@ooooo`?ooiT000Co06KooonI0?ooV@3ooiT01Ol0ool5oonI0003oooooooo
V@3o0?oo00Co0?oo0oooV@0Hooooo`?oc03o0oo<o`04ool000?ooiT01oo<0?l6ooooo`03o`000?oo
oooooooo017ooooo000Rooooo`03o`000?oooooooooo00?ooooo2?lco`02ol`0o`Goo`0000?o<ol0
ooooooooool00_ooV@03oc<0o`Soc?l000?oo`2Io`3oool0ool01?l0ool00oo<o`3o0?oooonI0002
oonI00Goo`2I1Oo<o`06o`1Vo`03olco0?ooV@3oo`0000;oo`0000Coooooool0VOl0I_oo06Ko1Ooo
0003ool0V@?ooooo1_ooV@0;olco00;oo`2I1Ol0I_l6o`3oo`;o06Ko1ol0ofH8o`3oo`Ko0?mV3?l0
I_m3o`3oIQ3o06Ko2Ol0ofH7ool001;ooooo2Oo<0?l4ooooo`?ooiT01Oo<o`06ooooo`03o`000?oo
oooooooo017ooooo0_l00004ooooo`Ko<ol000GooiT0ool0VOoo09Woo`2Iool00002o`3oIP?o06Ko
1Olco`07olco0003o`3oI_o<o`3oc?l000;oc?l00ol0ool2o`3oIP;oo`001?o<0?l3o`3oIPCooiT0
0ooo09T<oc<0o`Coo`2I0oo<0?l01?l0ofKoc?l0olco0?o<o`0Aoc<0o`?o0?oo3olc0?l3o`3oo`03
oc<0oooooooo0?oo00;o0?oo1oooool00olc0?oooiT0oonI0005oonI0003oooooooo09Woo`2I00Oo
o`2I0oooool2o`3oIP?o06Ko00?o<ol0ol`0ooo<0?l02?o<0?l:ool0V@;ooooo0_l0ofH2ool0V@Oo
oooo1?l0I_l00ooooooo<ol0oc?o0002oc?o00gooooo2?ooV@03o`3oo`gooiT000?o06Koo`3oool0
ool01?ooV@02o`3ooa;ooooo00Coo`00ol`0ooo<0?ooc03o1ooo00000oooV@3oc03ool`0o`05ol`0
o`?o<`3o1Oooool2o`0001?ooooo000Rooooo`03o`000?oooooooooo00?ooooo1Olc0?l00ooooooo
<ol0oc?o0003oc?o0003ol`0oooo003oo`0000;oo`0000?oc03ooonI0?ooV@002?o<o`000olc0?oo
c?l0ool0V@04ool0V@Oo0?oo0oooV@04ool000;ooooo00Co<ol0olco0?o<o`3oc?l00_l0ofH6o`1V
o`;oc?l00oooV@000ooooooo06Koo`1Vo`05ool000Koo`2I1?ooool4oonI00coc?l01_l0ool01?l0
I_oo0?mVo`3oI_l0ofH4oc?o00Ko0?mV2?l0ool9o`1Voc_o0?mV3_ooool6ool000?ooooo2_l0I_l:
o`3oIPOoo`002Oooool:ol`0o`?ooooo0_ooV@0;olco00Kooooo00?o0000ooooooooool04Oooool0
0ol0003oooooooooo`03ooooo`Go<ol01_ooV@000ooo09Wo<ol0oc?o0003o`1Vo`Soc?l00ol0ofH4
olco0004o`3oI_l0oooo0?ooo`3oIP?oo`000oo<0?l3o`3oIPCooiT000Co06Koool0VOoo09Woo`2I
0olc0?l3o`3oo`04o`3oI_l0I_oo06Koo`1Vo`?o0?mV0_l0I_l3ool0V@?oc03o00?o0?mVolco0?o<
o`001_o<o`02ool000;oc?l01oooV@001?l0I_oo0?ooo`3oool0ool6oc?o00?o06Ko0_l0ool2oooo
o`03oonI0?l0oooo0?oo00?o0?oo00Coooooo`3oool0oooo0?oo1oooool3oc<0o`OooiT00ooo09T4
ooooo`;oc03o0_l0ofH3o`1Vo`03oc?o0?o<0?ooc03o00Koc03o1ooo09T2ooooo`Koo`2I0ol0ofH3
ool0V@Kooooo1?l0I_l2ooooo`Co<ol02Oooool00ol0I_oooiT0oonI0005oonI00;o0?oo4OooV@00
0ooooooo06Koo`1Vo`04oonI00Co0?oo1oooool8ool000?oc03o1_oo0007ol`0o`Co<`3o0_o<0?l6
ooooo`03o`000?oooooooooo017ooooo000Rooooo`;o00001?ooool4oc<0o`[ooiT00_oo0008olco
0003oc<0ooo<o`3oc?l000Goc?l01Ooo09T5o`3oo`?ooiT00ooo0004oonI00?o0?oo0ol0ofH7o`1V
o`Coc?l000?ooiT0o`1Vool0I_l01?oo000:ool0V@03ooooool0I_oo06Ko00?o06Ko2Oo<o`03o`3o
o`;oc?l01?lco`06o`3oIP04olco0?lco`3o0?mVooooo`Go06Ko1ol0ool3o`1Vo`03ol`0oooooooo
oooo00Sooooo2?oo09T<o`3oIR3oo`2I2oooool5ool000cooooo1_l0I_l<o`3oIPKoo`000_ooool:
ol`0o`;ooooo3_o<o`04oonI00Gooooo0_l0000Cooooo`03o`000?oooooooooo00?ooooo0_oo0005
oc?o00Soc?l00ol0I_l00oo<o`3o0?mVo`3oIP02o`3oIP?oc?l000Co0?mVolco0?o<o`3oc?l00_oo
09T00ol0oooo0?mVool00003ool000Goc03o00?o06Koo`3oool0ool00ol0ool3ool0V@?o<`3o1_l0
ool00ooo09Wo06Kool`0o`03o`3oIP;o06Ko0ooo09T3ol`0o`05o`3oI_o<o`3oc?l0olco0?l0ofH0
1?o<o`07oonI0005ooooool0I_oo06Koo`1Vooooool00_l0ool00ooo09Wo<ol0oc?o0007oc?o00?o
oiT01ol0ool01?lc0?oo0?ooo`3oool0ool5ooooo`?oo`2I0olc0?l00ooo09WooiT0oonI0005oonI
00Coc03o0ol0ofH3o`1Vo`04oc?o0?o<0?ooc03ool`0o`Cooooo1_oo09T00ooooooo<ol0oc?o0004
oc?o0003ol`0oooo09Woo`2I00;oo`2I0ol0ofH3ool0V@Oooooo0ol0I_l2ooooo`Go<ol01Oooool0
0ol0I_oooiT0oonI0002oonI01?o<ol02?ooV@02o`1Vo`?ooiT00_l0ool?ool000?oc03o0_o<o`00
0ooo09Wooooool`0o`06ol`0o`03oonI0?oooooo<`3o00?o<`3o0oo<0?l6ooooo`03o`000?oooooo
oooo017ooooo000Rooooo`03o`000?oooooooooo00?ooooo1Ol0I_l7oonI00Soc?l00oo<0?l6olco
00?oo`2I0_lc0?l6ool0V@?o0?oo2OooV@001?lco`3o0?ooo`3oool0ool5o`3oIPKo06Ko1_o<o`00
0ol0I_ooo`00ool00002ool00003o`1VooooV@3oo`2I00[oo`2I0_l0I_l2ol`0o`03oc?o0?o<o`3o
c?l000Ooc?l000?o<ol0o`3oI_oo00003Ooo0006o`1Vo`03ooooool0oooo0?oo00Go0?oo1Ol0I_l2
ol`0o`Kooooo2ol0ofHAoonI00;o<ol09ooo09T4ooooo`Wo0?oo1?l0I_l5o`3oIPoo06Ko0oo<0?l0
0oooooooc?l0olco000<olco0003ol`0ooooV@3ooiT000;ooiT000?oo`2Ioc<0oolc0?l00_lc0?l6
ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool00oooool3ool00003ool0VOlco`3o
<ol000?o<ol01_o<o`000ol0ofKo06Koo`1Vo`06o`3oIPGoc?l00ooo09T00ol0ofKoo`00ool00002
ool000?oc03o2?l0ool3ool0V@?o<`3o0_oo09T2ooooo`Go0?oo0_oo09T3o`3oIP?o06Ko0_oo09T4
ol`0o`?oc?l00_l0ofH6oonI00Koc?l00_l0I_l3o`3oo`;o<`3o0_oo09T7oc?o00?o0?oo00?o06Ko
ol`0ooooV@001?l0ool2oonI0004o`3ooooo09Woo`2Iool0V@Goc03o0olc0?l3ol`0o`KooiT01?l0
ofH3o`1Vo`03oc?o0?oooooooooo00?ooooo1_oo09T00ooooooo<ol0oc?o000:oc?o0003ol`0oooo
09Woo`2I00?o0?mV00?oo`2Ioc?o0?lco`00<olco`000oooV@3oo`00ool0000?ool000Cooooo00Ko
c?l0ol`0ooo<0?ooc03oolco0?oo09T7ol`0o`;ooiT000?ooooooc<0oolc0?l00_lc0?l3ol`0o`;o
<`3o1_ooool00ol0003oooooooooo`0Aooooo`008_ooool00ol0003oooooooooo`03ooooo`Wo06Ko
2?o<o`05ool000Coc03o00?o0?oooc<0oolc0?l01_lc0?l2o`3oo`;oo`2I0_o<0?l00ooo09Wo0?oo
o`3oo`04oonI0004o`3ooolco`3oo`00ool000;o<ol00ol0ool3o`1Vo`04o`3oool0ofKo0?mVo`3o
IPKo06Ko1Oo<o`05ool00004o`1VooooV@3ooiT0oonI00[o<ol01?l0ool2ool000Soc?l06ooo0004
o`3oo`03ool00?ooV@3ooiT002gooiT02_lco`0Cool0VAGo0?oo1Ol0ofH:o`1Vo`goc?l000?ooiT0
o`1Vool0I_l03_l0I_l6ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool00oooool2
olco00;oo`000_oo09T5oc?o00Go0?mV0ol0I_l01?l0ofKooiT0oc?o0?oo09T5olco00;o0?oo00?o
0?mVool00?oo00000_oo00001?lco`3oc03ool`0ooo<0?l6o`3oo`?o06Ko0_oo09T3oc<0o`;oo`2I
1Oooool5o`3oo`03ool0VOl0ofKo0?mV00;o0?mV00Co<ol0o`1Vool0I_ooo`2I0oo<0?l01?l0I_oo
c?l0olco0?o<o`02o`3oIP;ooiT00ooo0009olco00?o0?oo00?oooooool0VOooV@001?ooV@02oc?o
00?o0?oo0olco`07o`3oo`CooiT01_o<0?l3oc<0o`03ol`0ool0oooo0?oo00;o0?oo1OooV@04o`1V
o`04oc?o0?ooooooooooooooo`Ooo`2I<olco`09oonI00?oo`2I1?l0ofH00ooo09Wo<ol0oc?o000<
oc?o00?oo`000oooool7o`3oo`;oc?l02_o<0?l2oonI00;oo`2I00?oc03ooc<0oolc0?l00_lc0?l0
0oo<0?oo<`3ooc<0o`03oc<0o`Kooooo00?o0000ooooooooool04Oooool002;ooooo00?o0000oooo
ooooool00oooool4o`3oo`03o`1Vooo<o`3oc?l000Koc?l00_l0I_l4olco00Goo`001Oo<0?l3oc<0
o`03oc?o0?lc0?oo<`3o00;o<`3o0_l0ool00oooV@3oo`2Iol`0o`02ol`0o`03ool0VOl0oooooiT0
00;ooiT00_l0ool9oc?o00;oo`000_l0ool2oc<0o`Oo06Ko1?o<o`05ool000Oo<ol03ooo0008olco
00Goc03o0_ooV@000ol0ofKoo`00ool0000Kool000_ooiT01?o<o`09oc<0o`;oc?l05oooV@0=oc?o
00_o0?oo1olco`0?o`3oo`03o`3oI_lco`3oc?l000coc?l04_o<0?l5oc?o00Kooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`03ooooo`?oc?l00_oo0003ool0V@Go<ol00ol0ofH01?oo
09Wo06Koo`1Vool0I_l2o`3oo`Koc?l00_l0ofH4ool00007oc?o0?o<0?ooc03ool`0ool0I_oooooo
oonI0005o`1Vo`05o`3oI_oo09Woo`2Iool0VOlc0?l00ooo09T7ooooo`03o`3oI_l0oooo0?oo00;o
0?oo00?oo`2Io`3oI_l0ofH00_l0ofH3oc?o0005ool0VOo<0?ooc03ool`0oooo09T00oo<o`03o`3o
IP04oooooooo003oo`00olco00;o<ol00_oo09T5olco00?o0?oo1OooV@000ol0ooooooooo`3oo`02
o`3oo`Ko<ol00_o<0?l4o`3oo`KooiT01?l0ool3oc<0o`?o0?oo0ol0ofH2oonI00Co06Ko00?ooiT0
o`3oool0ool01_oo09TJoc?o00Coo`2I1_ooool4o`1Vo`03ooooool0I_oo06Ko00Go<ol03?ooV@02
oc?o00?oo`2I2?l0ofH01?oo09Woo`00ool00?oo000Aoc?o00;o0?oo0oo<o`08ol`0o`?ooiT00_oo
09T00oo<0?oo<`3ooc<0o`02oc<0o`03ol`0oolc0?oo<`3o00;o<`3o00?o06Koo`3oI_l0ofH01_oo
ool00ol0003oooooooooo`0Aooooo`008_ooool00ol0003oooooooooo`05ooooo`Soc?l02_l0I_l0
0olc0?ooo`00ool00003ool000Goc03o1Olc0?l6oonI00Go<ol00oooV@04o`3oo`oo<ol01_l0I_l0
1?lco`3oc?l0olco0?o<o`0@ool000coc03o3?o<o`03ol`0o`;ooiT02Ol0ofH00oooV@3oo`00ool0
000Kool000oo<`3o2?o<o`0DoonI00_o0?oo4oo<0?l4o`3oo`goc?l04_o<0?l7oc?o00Co0?mV1_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00?ooooo0_lco`02olco00;oo`001?oo
09T5oc?o00?o0?oo0ol0I_l4olco0004o`3oooo<o`3oc?l0olco00?oo`0000?o0?oooc?o0?o<0?l0
0_o<0?l00ooooooooiT0o`1Vo`06o`1Vo`?oo`2I00?o<`3oool0VOoo09T00_l0ofH6oc<0o`?ooooo
00?o0?mVo`3oool0ool00_l0ool01?oo09Wo0?mVo`3oI_l0ofH3oonI0005ool00?o<0?ooc03ool`0
oooo09T00oo<o`04o`3oIP;oo`0000?oc?l0oc?o0?lco`000ooo09T01?oooooo<`3ooonI0?ooV@03
o`3oo`03oonI0?o<o`3oc?l000;oc?l00ol0ool01?o<o`3o0?mVo`3oI_l0ofH5oc?o0003ool0VOlc
0?oo0?oo00?o0?oo1oooV@02ooooo`?o<`3o1Ol0ofH01?l0oooo06Koo`1Vool0I_l6oonI00;oo`2I
3Olco`06o`3oo`04oooooolc0?oo<`3ooc<0o`Co<ol00ol0ofH6ool0V@Gooooo1_l0I_l8oonI0003
oc?o0?ooV@3ooiT000?ooiT00_ooool3ool0V@Co0?mV0_lc0?l6o`3oIP03ool0VOl0ofKooiT000Co
oiT000?o<`3ooooooolco`003?lco`07ol`0o`GooiT000?o<`3ool`0ooo<0?l01_lc0?l3olco0004
o`3oI_l0I_oo06Koo`1Vo`Kooooo00?o0000ooooooooool04Oooool001_ooooo0_l00005ooooo`03
o`000?oooooooooo00?ooooo1_o<o`02ool0V@;oc?l01?l0ool;o`1Vo`?oo`001Oo<0?l?oc?o00?o
oiT01_l0ool=oc?o00koo`005oo<0?l4oonI017oc?l02_l0ofH2olco0003ool00?l0oooo0?oo00Go
0?oo6ooo0009oc<0o`_oc?l00_o<0?l4oonI00_o0?oo2?ooV@000oo<0?oooiT0oonI000:oonI00ko
c?l02ol0ool6oonI00_o<ol01ol0ofH6ooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool00oooool3o`3oIP;oc?l00ooo0003ool0V@03o`3ooolco`3o<ol000;o<ol00ol0ool4olco0004
ool0VOl0ofKo0?mVool000?oc?l000?oo`00o`3ooolco`000oo<0?l00ooooooo06Koo`1Vo`06o`1V
o`?oo`2I00?o<`3oool0VOoo09T03?lc0?l2o`3oIPCo0?oo1oooV@001?oo003oc03ool`0ooo<0?l2
ool0V@;oc?l01Ol0ofH01Ooo003o<ol0oc?o0?lco`3oo`2I00KooiT01Ol0ool01?o<o`3o0?ooo`3o
ool0ool2olco00Co<ol000?oc?l0oc?o0?lco`000olco`000ol0ofKo0?ooo`3oo`03o`3oo`03oooo
ooooV@3ooiT000GooiT01Ol0ofH2ooooo`?o06Ko0ooo09T7oonI00Wo<ol00_ooool00ooo003ooiT0
oonI0003oonI00?o0?oo00?ooooooc<0oolc0?l00_lc0?l2oc?o00?o0?mV00?o<ol0ool0VOoo09T0
1Ooo09T00ooooooo06Koo`1Vo`03o`1Vo`OooiT00_lco`05oonI00;ooooo00Co0?mVool0VOoo09Wo
o`2I1?l0ofH00olc0?oo<ol0oc?o0003oc<0o`Ko0?mV00?o06KooonI0?ooV@001?ooV@03o`1Vo`;o
oiT00olco`08ol`0o`;o<ol01?ooV@03ol`0o`Go<`3o0_l0I_l2olco00Ko06Ko1_ooool00ol0003o
ooooooooo`0Aooooo`006_ooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00?o
oooo0oo<o`000ooo09WooiT0olco0007olco00CooiT00_l0ool;o`1Vo`go<ol000?o06Koo`3oooo<
0?l00_o<0?l00ooo09WooiT0oonI0002oonI00Oo0?oo00?oo`2Iool00?oo00002_oo000Gol`0o`Oo
06Ko00?o0?mVo`3oool0ool01_ooV@04ool0V@;o0?oo4oo<o`05o`3oIP;o<`3o2?l0ool5oc<0o`Go
c03o5_oo0006oc<0o`Koc?l02ol0ool00oo<0?oooiT0oonI000XoonI00So0?oo3_lco`07o`3oIP?o
o`001_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00?ooooo0ol0ofH01?l0oooo
c?l0olco0?o<o`02ool000?oo`2I00?o0?oooonI0?lco`000olco`04olco0003ool0VOl0ofKo0?mV
00?oo`000_o<o`02o`3oo`?oc03o2Ol0I_l3ool0V@So<`3o1?lco`07oc<0o`OooiT000Go0?mVoc?o
0?lco`3o<ol0ool00003ol`0o`?oo`2I00?oc?l0o`1Vool0ofH00ol0ofH00ol0I_oooiT0oonI0005
oonI0003ol`0ool0I_oo06Ko00?o0?oo00Co0?mVo`3oool0oooo0?oo3olco`000olc0?oo0?ooo`3o
o`02o`3oo`?o0?mV2?ooV@000olc0?ooooooo`1Vo`02o`1Vo`Goo`2I0_lco`000oooV@3o<ol0oc?o
0006oc?o0004oc<0ooooooooo`00ool000cooiT000?o0?oooooooolc0?l01?lc0?l3o`3oIP?o<ol0
1_oo09T00ol0I_oooiT0o`1Vo`02o`1Vo`?ooiT00olco`05oonI00;ooooo00Co0?mVool0VOoo09Wo
o`2I5?l0ofH00ol0I_oooiT0oonI0004oonI00;o06Ko00?ooiT0ol`0ooo<0?l01_o<0?l;oc?o00Co
<`3o0ol0I_l00oo<o`3o06Koo`1Vo`04o`1Vo`;o<`3o1_ooool00ol0003oooooooooo`0Aooooo`00
6_ooool01?l0003oooooooooool00004ooooo`?o00000oooool2oonI00Ooc?l01OooV@0:oc?o00_o
06Ko00?o0?oool`0ooo<0?l00_o<0?l2oc<0o`Soc03o1?ooV@02ool000Oo0?oo5_o<0?l4o`3oIP[o
c?l01?l0ofH3oonI00?o0?mV2olco`06ool0V@03ol`0ooo<o`3oc?l001;oc?l07?oo09TBool000Wo
0?oo1oo<o`000oooV@3o0?oooonI000:oonI00[oc?l07OooV@02oc?o00Goo`002?l0ofH2ool000Co
06Ko1?ooool3o`0001?ooooo00?o0000ooooooooool00oooool5o`3oo`?oc?l00_oo0004ool0V@03
olco0?lco`3o<ol000?oc?l000?o06Koo`3oI_l0ofH01?oo00001?lco`3oc?l0olco0?o<o`03ol`0
o`Co06Ko00KooiT0o`1Vool0I_oo06Kooooooolc0?l2ool0V@Ko<`3o0olco`03ooooo`Co<ol000?o
<`3ooonI0?ooV@001OooV@02o`3oo`?o0?mV0_lco`02oonI00?oc03o0ooo09T2olco0003o`1Vool0
ofKo0?mV00;o0?mV0_l0I_l00oooV@3oo`2Iool0V@02ool0V@?o0?mV1?l0ool6oc?o00;oc?l02_lc
o`02oc<0o`Co0?oo1?l0ofH6oonI00?o06Ko0ooo09T;oc?o00?ooiT00_oo0006oonI00?oo`2I2_oo
V@03o`3oo`;o0?mV1_lco`000ooo09WooiT0oonI0003oonI00Co06Ko00?o<ol0o`3oooooV@001?oo
V@000olco`3o0?mVo`3oIP0Zo`3oIP03ol`0ooooV@3ooiT000;ooiT03_lco`04o`1Vo`03olco0?lc
0?oo<`3o00;o<`3o1_ooool00ol0003oooooooooo`0Aooooo`006_ooool01?l0003oooooooooool0
0004ooooo`03o`000?oooooooooo00?ooooo1Oo<o`0Coc?o00Goc03o2ol0I_l2o`3oo`Woc03o00Co
o`00oonI0?ooV@3ooiT01?o<0?l7o`3oo`Soc03o1Olco`06o`3oIP03o`1Voooo003oo`0000;oo`00
1?l0I_l00oo<o`3o0?mVo`3oIP05o`3oIQgo<ol01Oo<0?lDolco00Soo`2I2_lc0?l:ool0VA?oo`00
0oo<o`0;oonI00_oc?l000?oc03oo`3oool0ool03Ol0ool00oo<0?oo06KooonI000LoonI00Oo06Ko
1_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00?ooooo1?oo00000ol0oooo<`3o
olco0002olco00;oo`001?oo09T4olco00?o<ol01?oo0002oc?o0005o`3oooo<o`3oc?l0olco0?o<
0?l00ol0I_l4oonI00?o<`3o0ooo09T2oc<0o`Co<ol02?ooool7oonI00Co<`3o0_l0ool3o`3oIP;o
<ol00_ooV@03ol`0o`Coo`2I00?oc?l0oonI0?l0ofH01?l0ofH3o`1Vo`;oo`2I1?l0ofH6oc?o0003
oc<0ooo<o`3oc?l000Goc?l02Olco`000olc0?oo0?ooo`3oo`03o`3oo`Go0?mV00?oo`2IoonI0?l0
I_l00_l0I_l3oonI00So<ol000?oooooool00?oo00002OooV@0:ool0V@[ooiT03_l0ool2o`1Voa?o
0?mV2?o<0?l5ool00003oc<0ool0ofKo0?mV02Go0?mV0_lco`07oonI00Kooooo00?o0000oooooooo
ool04Oooool001[ooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`03ooooo`oo
<ol04?o<0?l3ool000_o06Ko0_lco`06ool000?ooiT01_o<0?l7o`3oo`Go0?mV2?lco`000ol0oooo
06Koo`3oIP0:o`3oIPoo<ol000?oo`2Iolco0?o<o`001?o<o`02o`3oIQOo<ol01?o<0?lColco00So
06Ko2?lc0?l<ool0V@Soo`002oooV@0:olco00Soo`2I1_ooV@04o`3oo`03oc?o0?oo003oo`00017o
o`005_ooV@06ooooo`03o`000?oooooooooo017ooooo0_l00004ooooo`?o06Ko0_oo00000ol0oooo
o`00olco0002olco0004oc<0oooo003oo`00ool0V@Coc?l000?o0?mVoc?o0?oo00000ooo0004oc?o
0003o`3oooo<0?ooc?l000;oc?l000Co06KooonI0?o<o`3oc?l01Olc0?l3ool0V@04oonI0?lco`3o
<ol0oc?o00co0?mV0oooV@02oc?o0003oonI0?oooooooooo00Co<`3o00Ko0?ooo`3oI_l0ofKo0?mV
o`3ooolco`02oonI00?oc03o1?oo09T00oo<o`3o0?mVo`3oIP05o`3oIPCo06Ko00?o0?oooc?o0?lc
o`001?lco`02oc<0o`?oc?l00oo<0?l4olco00Ko<ol000Coc?l0oc?o0?lc0?oo<`3o1Ol0ool4ool0
V@?o06Ko00?ooiT0oc?o0?lco`001_lco`03o`3oIPCoo`001_ooV@04ool0V@Co0?mV2?oo09T00ol0
ofKooiT0oonI0007oonI00;o0?oo5?l0ofH00ol0oooo<ol0o`3oIP03o`3oIP03oc<0ool0oooo0?oo
00So0?oo0oo<0?l01?oo09WooiT0oonI0?ooV@03oc<0o`Ooc03o0olco`001Olc0?ooc03ool`0ooo<
0?oo<`3o01go0?mV1Oooool2o`0001?ooooo000Jooooo`04o`000?ooooooooooo`0000Cooooo00?o
0000ooooooooool00oooool6oc?o00_o<`3o1oooV@02oc<0o`Oo06Ko1_oo000;o`1Vo`;oo`000_o<
0?l7oonI00_o0?oo4?l0ofH?oc?o00Goo`2I0_o<o`06oc<0o`Woc?l01Ol0ofHGoc?o00;o06Ko4Oo<
o`06o`1Vo`[o<`3o2?oo09T;oonI00?oo`005Olco`0Fool000KooiT01ol0ofH8o`1Vo`SooiT01_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00?ooooo1OooV@03ool000?oc?l000?o
<`3oolco0?o<o`000_o<o`02o`3oIPGoo`000olco`000ol0I_ooc03ool`0o`02ol`0o`?oc?l000?o
<`3oo`3oI_l0ofH07Ol0ofH2oc?o0003oonI0?oooooo0?mV00;o0?mV0_lc0?l3o`3oIP04o`3ooolc
o`3ooiT0oonI00?oc03o00?ooiT0ool0VOoo09T00_oo09T2o`3oIP03oc?o0?l0ofKo0?mV00;o0?mV
00?o06Kooc?o0?lco`001?lco`03o`3oo`03o`3oI_o<o`3oc03o00Go06Ko0oo<0?l2oc<0o`;oc?l0
1_lco`03oc<0o`Co0?oo0_oo09T00ol0I_oo<ol0oc?o0006oc?o00KooiT00_l0ofH6oonI00Coo`2I
0oooV@05ool000;o06Ko2?oo09T2o`3oIP[ooiT02?l0ofH3o`1Vo`?oc03o00?oo`00ool0VOlco`00
1?l0ofH00olc0?oo0?ooo`3oo`05o`3oo`Wo06Ko0_o<0?l00ooo09Woc03ool`0o`05ol`0o`Go0?mV
00Ko<ol0ol`0ooo<0?ooc03ooc?o0?o<0?lCoonI00[o0?mV1_ooool00ol0003oooooooooo`0Aoooo
o`006oooool2o`0000Gooooo00?o0000ooooooooool00ooooolSoc<0o`Woo`002ol0I_l5oonI00;o
<`3o4ol0ofH?oc?o02Go06Ko2?l0ofHGoc?o00goc?l01Ol0I_l9oc?o00_ooiT09_lco`02ool000_o
oiT00_lc0?l8o`3oIPOo06Ko1Oo<0?l2ool000Goc03o1_ooool00ol0003oooooooooo`0Aooooo`03
o`000?oooooooooo00?ooooo2oooV@04olco00;o0?mV1?oo000;o`3oIP;oc?l04?l0ofH3o`3oo`Go
oiT00_l0ool;o`3oIP05o`1Vool0ofKo0?mVo`3oI_ooool00ol0ofH2o`3oo`;ooiT01?o<0?l5ool0
V@03o`3oI_lco`3o<ol000Oo<ol000?o0?ooo`1Vooo<0?l00_l0ool:o`1Vo`;o0?mV00?oc03ooc<0
oolc0?l00_lc0?l7oc?o00;o<`3o1?l0ool6oc?o00;o<`3o0ooo000:oonI00?oo`2I1?l0ofH8ool0
00oo0?mV2_ooV@0Golco00;o06Ko2?o<o`0<o`1Vo`Co0?mV5?ooV@05ool000Oo<`3o0ol0ool6oooo
o`03o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooooooo00[ooooo1?lc0?l4oonI01Ko
<`3o2?oo0004ol`0o`Ko06Ko00?o0?mVoonI0?ooV@001oooV@09o`3oIPoo<ol09_l0I_l5olco00Wo
<`3o2ol0ofHCoc?o00_oc?l01?lco`0;oonI00ko<ol02_oo09T9ool001?o<ol00olc0?l8o`3oIPKo
06Ko1_o<0?l:ool0V@Kooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`03ooooo`?o
0?mV00Co06KooonI0?ooV@3ooiT06Ol0ofH3olco0003o`3oI_oo09Wo<`3o00;o<`3o0_oo09T2olco
00Oo0?oo1OooV@03ooooo`;o06Ko1?l0ool;o`3oIP03oonI0?l0ofKo0?mV00;o0?mV0_l0ool00ooo
V@3oc03ool`0o`02ol`0o`03o`3oI_oo09Woo`2I00;oo`2I1_lco`03o`3oo`;oc03o1ol0I_l00oo<
0?ooo`00ool00005o`1Vo`03ol`0ool0ofKo0?mV00Go<`3o1olco`05o`3oo`03olco0?o<0?ooc03o
00Ooc03o1_ooV@03ool0V@04o`3oool0ofKo0?mVo`3oIP?o0?oo4_l0ofH:olco00WooiT04Oo<o`03
o`1Voa;oc?l03_l0I_l4oonI0004oc?o0?l0I_oo06Koo`1Vo`Koo`002?lc0?l3oonI00?o0?oo1_oo
ool00ol0003oooooooooo`0Aooooo`008_ooool00ol0003oooooooooo`03ooooo`;o06Ko1_lc0?l0
0oooV@3o<`3ooc<0o`03oc<0o`[oc03o2Olc0?l8ool000?o<`3o2?o<0?l7o`3oIP_ooiT03?lco`03
o`1Vo`Ooc?l01ooo09T3o`3ooa?o<`3o0ooo000Aoc<0o`Coc?l01?l0ool>o`3oIPgo<ol01Oo<o`0;
oonI0003o`1VooooV@3o<`3o00ko<`3o0_ooV@0Lool0VACo<ol00ol0I_l6ol`0o`?oo`2I1Olc0?l6
o`3oo`Kooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`03oooooaKo0?mV0_ooV@03
ol`0o`Ko<ol00oo<o`03oc<0o`?oo`2I2?l0ool5oonI00koc03o00?o0?ooo`3oI_l0ofH02_l0ofH4
o`3oo`?oc03o00?o<`3ooc?o0?lco`001?lco`02ol`0o`?o0?oo1ol0I_l2o`3oo`;o06Ko1?oo0006
o`1Vo`;o0?mV1?lc0?l8oc?o00Co0?oo1?o<o`02ol`0o`KooiT01_l0ool@o`3oIQOoc?l02_ooV@04
o`3oIP03oc<0oooo09Woo`2I00;ooiT01?l0I_l4olco00Co<ol00_o<0?lColco013o06Ko2?lc0?l4
oonI00Go0?oo1_ooool00ol0003oooooooooo`0Aooooo`008_ooool2o`0000Cooooo7_o<0?l8ool0
00So<`3o1?o<0?l9o`3oIP03ol`0oolco`3o<ol000;o<ol02_ooV@000olco`3o<`3ooc<0o`07o`3o
o`Goc?l01ooo09T5oc?o0003o`1Vool0oooo0?oo00Ko0?oo5olc0?l5oc?o00;oc?l04OooV@0Ao`3o
IP;o0?oo2oooV@04olco00Oo06Ko0oooV@0?oc<0o`CooiT06Ooo09T3o`3oIQCo<ol03_l0ool5oooo
o`;o00004oooool00ol0003oooooooooo`03ooooo`So0?mV0_o<o`02o`3oIPCoo`0000?o<ol0oonI
0?ooV@001?ooV@03ol`0o`CooiT01?lco`03olco0004oc<0oooo09Woo`2Iool0V@Co0?oo0ol0I_l4
oonI0003olco0?o<0?ooc03o00koc03o1_ooV@0;o`3oIP03o`3oooo<0?oo<ol000Go<ol00ooo09T3
o`3oo`Go06Ko0_o<o`001?o<0?oo0?ooo`3oool0ool4olco00Wo06Ko3_lco`06o`3oo`KooiT000?o
0?ooo`3oI_l0ofH03Ol0ofH2olco00;oc03o1ol0ool7ool00004ool0VOoo003o0?mVo`3oIPSoo`2I
1Ol0ofH:oonI00?oo`2I1?l0I_l5olco00Wo<ol01oooV@0Dolco013o06Ko1Ol0ool2ol`0o`Kooooo
00?o0000ooooooooool04Oooool002;ooooo00?o0000ooooooooool00oooool?ol`0o`_ooiT02?oo
00000ol0oooooiT0oonI0004oonI00;o06Ko00Co<`3ool`0ooo<0?ooc03o5Olco`000olc0?oooiT0
oonI0008oonI0003olco0?l0oooo0?oo00Ko0?oo1Ooo09T00olc0?ooc03ool`0o`09oc?o00;o0?oo
4_lc0?l4oc?o01OooiT00oo<o`0:o`3oo`Ko0?mV2oooV@03o`3oo`_oc?l03?l0I_l?oc<0o`Koo`00
1?l0I_l9oc<0o`So0?mV0ol0I_l5oc<0oa?o<ol000?oo`2Ioc?o0?lco`000_lco`06ooooo`03o`00
0?oooooooooo017ooooo00?o0000ooooooooool00oooool3oc<0o`;o0?mV1?o<o`000ol0ofKoo`00
ool00003ool000;o<ol000?o06Koool00?oo00000_oo09T3ol`0o`[ooiT00oo<o`02ool0V@03o`3o
ool0I_oo06Ko00?o06Ko1OooV@05ol`0o`;ooooo3_ooV@08ol`0o`Go0?mV1_lco`001Oo<0?ooc?l0
olco0?oo09Wo06Ko00?o0?oo0ol0I_l3o`3oIPCooiT02?o<o`000oooV@3o06Koo`1Vo`06o`1Vo`?o
<ol01_l0ool6oc?o00KooiT03?l0ofH6olco00Soc03o1ol0ool7ool00005ool0VOooV@3ooiT0oonI
0?l0ofH02?oo09T4oc?o00;o0?mV2OooV@02oc?o00Coc?l00_lco`04ol`0o`Wo<ol000Coc?l0oc?o
0?lco`3o<ol00ol0ool3ol`0o`03oonI0?oo003oc?l001?oc?l01Ol0I_l5o`3oo`Co06Ko1_ooool0
0ol0003oooooooooo`0Aooooo`008_ooool00ol0003oooooooooo`03oooooaGooiT000?oo`00o`3o
oooo00001?oo000Qoc?o00Go0?oo0olco`04olco00_ooiT01ol0ool5oc<0o`;oc03o4olc0?l00ol0
oooooiT0oonI000EoonI00Coc03o1?l0ofH00oo<o`3o0?ooo`3oo`09o`3oo`03olco0?ooV@3ooiT0
00gooiT03Ol0ofH:olco00So06Ko1oo<0?lHoc<0o`Oo0?mV0ol0I_l3oc<0o`oo0?oo3olco`06oooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool00oooool2o`3oo`;o<`3o0oo<o`02o`3o
IPCoo`000oo<o`03o`1Vo`;oo`000oo<0?l3o`3oo`;o06Ko1oooV@02olco0004ool0VOooV@3ooiT0
oonI00;o06Ko1OooV@000oooooooc03ool`0o`02ol`0o`Goc?l00oooV@000ooooooooiT0oonI0006
oonI00?o0?mV00?ooiT0o`1Vooo<0?l01_o<0?l6oc?o00Oo0?mV0_l0ool00ol0I_ooo`2IoonI0006
oonI00Goc?l00_ooV@04olco00GooiT01Ol0I_l9o`3oo`;o<ol01_ooV@07o`3oIP;oc?l00ooo0006
olco00So06Ko0_ooV@03ol`0o`Oo0?oo1ooo00001?oo09Woc?l0o`3oI_l0ofH9ool0V@Go0?mV3?oo
V@03ol`0o`Co<`3o1?ooV@09oc?o00;oc03o2ooo0002o`1Vo`?o<`3o4oo<o`05o`1Vo`Kooooo00?o
0000ooooooooool04Oooool002;ooooo00?o0000ooooooooool00oooool9oc<0obOo<ol01?l0ofH0
0oooV@3o06Koo`1Vo`02oc?o00Ko0?oo00?o<ol0olco0?o<o`002Oo<o`03ool000[ooiT01_l0ool>
oc<0oaKooiT03oo<0?l;o`3ooa3ooiT01_o<o`03ol`0o`ko0?mV2_o<o`000ol0oooo06Koo`1Vo`05
o`1Vo`Ooc03o0_l0ofH<oc<0o`03ool00?l0I_oo0?mV00Ko0?mV00?o06Koo`3oool0ool03ol0ool0
0ol0I_ooo`00ool00009ool000?oc03o1_lco`06ooooo`03o`000?oooooooooo00[ooooo0_l00005
ooooo`03o`000?oooooooooo00?ooooo0_o<0?l4olco0003o`3oI_oo003oo`0000;oo`000olco`03
olco0003o`1Voooo09Woo`2I00?oc03o00Goo`2Io`3oool0oooo0?oooc<0o`02o`1Vo`Co<`3o00?o
c?l0oonI0?o<o`000_o<o`0:oonI00?oc03o0oooool5olco00[ooiT01oo<0?l3oonI00Ko<ol00ooo
V@000ol0I_oo0?mVo`3oIP09o`3oIP03ool0VOooV@3ooiT000Koc?l01?l0ool2oc?o00Coc?l01Ooo
V@05o`1Vo`Ko0?mV1_ooV@04oc?o0003o`3oooo<o`3oc?l000?oc?l00_oo0008olco00_o<`3o00?o
c03oo`1Vool0I_l00ol0I_l7o`3oo`Ooo`000_o<0?l4oc?o00;oo`2I00?o0?mVoonI0?ooV@000_oo
V@08oc?o00[ooiT01Ol0ofH2oc<0o`Co0?oo2Olco`04ool000Co06Ko2?lc0?l4o`3oIP;o<ol000?o
c03oolco0?o<o`003Oo<o`06ooooo`03o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooo
oooo00?ooooo7Olco`06ool000Coc?l03?l0ofH2o`1Vo`;o<ol01?l0ool;olco00Koc03o0ooo09T4
oc<0o`[ooiT01?l0ool3oc<0oa?ooiT000?o<ol0ol`0ooo<0?l01?o<0?l>o`1Vo`So0?oo4OooV@0<
olco00So0?mV1?o<0?l:o`3oIP_oc?l01?l0ool4o`1Vo`Koc03o1?l0ofH2ol`0o`;o06Ko2?l0ofH=
o`3ooa7o06Ko3?oo0006ooooo`03o`000?oooooooooo00Wooooo00Co0000oooooooooooo00001?oo
ool00ol0003oooooooooo`03ooooo`03ol`0ooo<o`3oc?l000;oc?l000?o0?mVool00?oo00000_oo
0003oc?o00;o06Ko0oo<o`001Ol0ooooc03ool`0ooo<0?ooo`0000?o0?oo00?oo`2Iol`0ool0I_l0
0_l0I_l4oc<0o`;oo`2I0oo<o`000olco`3ooiT0oonI0004oonI01;o<`3o3OooV@06oc?o00;ooiT0
1ol0I_l2o`3oo`Oo0?mV1_o<o`000ol0ofKo<ol0oc?o0006oc?o00Goc?l000?oc03oo`3oI_l0ofH0
2Ol0ofH6oonI00;o<`3o1_lco`000ol0ooooc?l0ool0000Loc<0o`03ol`0ooooV@3o<ol000Oo0?oo
1ooo0006oonI00Wo<ol000?oc03oolco0?o<o`000_o<o`03o`3oIP[ooiT00_l0ofH00olc0?ooo`00
ool00005ool000Wo<ol000?o06Kooc<0oolc0?l02Olc0?l6o`3oIP03oonI0?l0oooo0?oo00?o0?oo
0ooo00000olco`3oc?l0olco0004olco00Kooooo00?o0000ooooooooool04Oooool002;ooooo00?o
0000ooooooooool00oooool:oc?o01_o<`3o1_l0ofH00ooo003o0?mVo`3oIP03o`3oIP;o06Ko0olc
o`000ol0ooooc?l0olco0008olco00Goo`004Olc0?l;oonI00;o0?oo2OooV@02o`1Vo`Co<ol05?l0
I_l5o`3ooa7ooiT02Olc0?l6olco00[o0?mV2Ooo0006ol`0o`Oo0?mV2_o<o`08o`3oo`04o`1Vooo<
0?ooc03ool`0o`;o06Ko00?o0?ooo`3oI_l0ofH01_l0ofH8o`3oo`03ol`0oolc0?oo<`3o00go<`3o
4Ol0I_l4ool000Kooooo00?o0000ooooooooool02Oooool01?l0003oooooooooool00004ooooo`?o
00000oooool3olco0003o`3oI_oo003oo`0000;oo`000olco`03o`1Vo`;o0?oo0_o<o`03ol`0o`04
o`3oooo<0?oo0?ooo`3oo`?oo`2I2_lc0?l3olco02;o<`3o1_lco`000olc0?oo06Koo`1Vo`08o`1V
o`?o0?oo00?oo`00olco0?o<o`001oo<o`06o`3oIPCo<ol000Co0?ooo`3oI_l0ofKo0?mV1Oo<o`07
o`3oIPWooiT01Olc0?l6oc?o00co<`3o2Oo<o`0>oc<0o`Co0?oo2?ooV@09oc?o00;o06Ko00?oc03o
olco0?o<o`000oo<o`02o`1Vo`03oonI0?l0ofKo0?mV00?oo`2I2oooV@04ool00003o`3oI_o<0?oo
c?l000;oc?l02Olco`000olc0?ooc?l0olco0002o`3oIPKo<`3o00?o0?mVo`3oool0ool01?l0ool9
o`3oIP?o<ol01?ooool3o`0001?ooooo000Rooooo`03o`000?oooooooooo00?ooooo1?o<0?l2ool0
00?o0?oo2?oo0005oonI00co<`3o1_l0ofH;oc<0o`;o<ol000?o0?ooolco0?o<o`001?o<o`000ooo
003o<`3ooc<0o`0Aoc<0o`Coc03o4_ooV@000ol0oooo<`3ooc<0o`07ool000oo06Ko0oo<0?l2o`3o
oa7ooiT02_lc0?l5ol`0o`;o<ol01_lc0?l00oo<0?ooo`00ool0000Aool000Go<ol02?o<0?l4o`3o
IP[oc?l00ol0ofH4o`3oo`Oo0?mV1?l0ool5ol`0o`_oc?l03Olc0?l@olco00Kooooo00?o0000oooo
ooooool02Oooool01?l0003oooooooooool00004ooooo`03o`000?oooooooooo00?ooooo0_o<o`05
ool000;o<ol07_lc0?l3olco00Ko<`3o4?ooV@09oc<0o`Ko<ol02?l0I_l4oc<0o`?o0?oo0_o<0?l0
0ooo003oc?l0olco0004olco00;oo`2I4?l0ofH4olco0004ool0VOl0I_oo06Koo`1Vo`KooiT00_l0
I_l:oc<0o`Ko<ol00_l0ool7olco00Go06Ko2oo<o`0>oc<0o`;ooiT02Olco`04o`1Vo`;oo`001?o<
o`04ool000Ooo`2I0ooo00000ooo09WooiT0oonI0009oonI0003ol`0ool0I_oo06Ko00Go<`3o2Olc
o`04o`3oIP;o<`3o1_l0ool>o`3oIPKooooo00?o0000ooooooooool04Oooool002;ooooo00?o0000
ooooooooool00oooool2ool000?o0?oo2?oo00000oooV@3o<ol0oonI000;oonI00Coc?l000?o06Ko
o`3oI_l0ofH01?l0ofHQoc<0o`?oo`2I00?ooiT0ool00?ooV@004?ooV@03ool00003o`3oooooV@3o
oiT000SooiT000?oc?l0ol`0oooo00000ooo0009oc?o00;oc?l04OooV@0Zool001Co<ol02_o<0?l;
olco00Ko0?mV2?o<0?l/olco00Kooooo00?o0000ooooooooool02Oooool01?l0003oooooooooool0
0004ooooo`03o`000?oooooooooo00?ooooo7Olc0?l2ool0V@04o`1Voooo09Woo`2Iool0V@GooiT0
0_o<o`000oooV@3o<ol0oc?o0002oc?o00?ooiT04Oo<0?l3olco00Ko<ol01ol0I_l7oc<0o`?o0?oo
0olc0?l5olco00Ko<`3o00?oo`2Io`3oI_l0ofH02?l0ofH5oc<0o`?oc?l01_ooV@000olc0?oo06Ko
o`1Vo`04o`1Vo`Go<`3o00?oc?l0oonI0?ooV@000_ooV@000ol0oooo<ol0oc?o0004oc?o00CooiT0
1Oo<o`000ol0I_ooo`00ool0000Aool000Go<`3o2Olco`06o`1Vo`;oo`001?o<o`03ool000Ooo`2I
1ooo0003ol`0o`03o`3ooooo09WooiT000[ooiT00_lc0?l5olco00Wo<ol01Ol0ool2oc<0o`03o`1V
ool0ofKo0?mV00?o0?mV2Ol0I_l6ooooo`03o`000?oooooooooo017ooooo000Rooooo`;o00001?oo
ool2o`3oo`Soo`0000?ooiT0oc?o0?lco`000olco`05olco00SooiT01_l0ofH4ol`0o`Co0?mV00?o
oiT0o`1Voolco`001?lco`0<oc<0o`Woo`2I3_ooV@02ooooo`_oc03o00?oo`00ooooool0ool02ooo
V@04ool0017ooiT0:Ooo000@oc?o01?ooooo2Oo<0?laolco00Sooooo0olc0?l4o`1Vo`Gooooo0_l0
000;ooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool00oooool:oc<0o`Go0?mV
0oo<0?l00ol0ooooc?l0olco0003o`3oo`Co<`3o0ooo09T00ol0I_ooo`2Iool0V@05oonI0005oc<0
ooo<o`3oc?l0olco0?lc0?l01Olco`06ol`0o`03ool00?oo09Woo`2I00;oo`2I1oo<0?l7oc?o00Ko
06Ko00Coo`00oc<0oolc0?ooo`001Olco`03o`3oo`;o<`3o1Oo<o`0Hoc<0o`OooiT01Ol0ool00oo<
o`3o06Koo`1Vo`03o`1Vo`Koc?l000Go<`3ool`0ooo<0?oo<ol0o`3oo`07oc?o00?ooiT06?oo0009
oc?o00;o<`3o1Ol0I_l2oc<0o`;oo`001?o<o`000ol0I_ooo`2Iool0V@05ool0V@;o06Ko1?oo09T5
ol`0o`Oo06Ko0_lc0?l;oonI00Coc?l02olco`06oc<0o`Ko0?mV00?ooiT0olco0?o<o`000ol0I_l6
ooooo`03o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooooooo00?ooooo1_oo00000ooo
V@3oooooo`3oIP03oc?o00[oc?l01?l0I_l00oooV@3o0?mVo`3oIP04o`3oIP?oc03o00?ooiT0o`3o
I_l0ofH00ol0ofH00ol0I_oo<ol0oc?o0003oc?o0003ool00?oo09Woc?l000;oc?l00_lco`04ool0
V@03ooooooooV@3oo`2I00Koo`2I2OooV@0?ooooo`[oc03o1?l0oolCoonI0003o`3ooooo003oo`00
00goo`001_ooool7oc<0o`Oooooo0ol0ofH4ol`0o`So<ol01_l0ofHRooooo`Ooc03o4?o<o`0Yoooo
o`;o06Ko1_ooool00ol0003oooooooooo`0:ooooo`;o00001Oooool00ol0003oooooooooo`03oooo
o`?o0?oo0_lco`000ol0I_oo<`3ooc<0o`03oc<0o`03ool0VOooV@3oc03o00?oc03o0_l0ofH01?o<
o`3o0?ooo`3oool0ool4oc<0o`?oo`001?oo09T00ol0I_oooiT0oonI0004oonI00?oc?l00_o<0?l5
oc?o00Koc?l01Ooo0003ol`0o`Ko<ol01_l0I_l00ooo09Wo<ol0oc?o0008oc?o00?o0?oo00?o0?mV
olco0?o<o`000oo<o`02ol`0o`;oo`000_o<o`000ol0oooo0?mVo`3oIP0=oc<0o`;o0?mV1_ooV@04
olco0003o`3oooo<o`3oc?l000Coc?l01Ol0I_l2olco0005o`3oI_lc0?oo<`3ooc<0oooo00000olc
o`02o`3oo`Ko<ol01_oo000;oonI00Coo`002Olco`04ol`0o`Go06Ko1?lc0?l4olco00;o<`3o1Ooo
09T3o`3oo`Co06Ko1ooo09T3o`1Vo`So<`3o00?oc?l0ool0VOoo09T02oooV@000oo<o`3o0?ooo`3o
o`02o`3oo`Wo<ol01?lc0?l6o`3oIPCo06Ko1_ooool00ol0003oooooooooo`0Aooooo`008_ooool0
0ol0003oooooooooo`03ooooo`?oo`000_ooV@000ol0ofKo<ol0olco0009olco00Oo06Ko1_l0ofH4
ol`0o`03oonI0?l0ofKo0?mV00?o0?mV1?ooV@02oc?o0003ool00?oo09Woc?l000;oc?l01oooV@07
ool0V@CooiT06Oooool3oc<0o`[oc03o1?l0ool6oonI00Co0?oo0_o<0?l8oc<0o`cooooo2?lc0?l=
ooooo`?o0?mV1?oo09T6o`3oIRgooooo1Oo<0?lmooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool00oooool5o`3oo`?oc03o1?lc0?l4ol`0o`Co0?mV0_l0ool3oc<0o`GooiT00ooo09T3
o`1Vo`Koc03o0oo<o`02ol`0o`03oc<0oolco`3o<ol000?o<ol01oo<o`02ooooo`Ko<ol01_l0I_l;
oc?o00;oo`000_l0ool8olco00?oc03o0_oo0002olco00;o0?oo0ol0ofH4ool0V@03oc<0oooo09Wo
o`2I00;oo`2I1_ooV@03o`3oIP03o`3oooo<o`3oc?l000;oc?l000Co06Koool00?oo003oo`001?o<
o`05o`1Vo`03ol`0oolc0?oo<`3o00?o<`3o0_oo00000ol0I_ooo`00o`3oo`02o`3oo`Ko<ol000?o
c?l0oonI0?ooV@001OooV@04olco00;o06Ko2Olco`04ol`0o`;o0?mV1Ol0I_l2olco00;o0?oo1Oo<
o`0:oc<0o`03ool0VOl0oooo06Ko00?o06Ko1_oo09T8oc<0o`;oc?l01?lc0?l2olco0003oc?o0?oo
09Woo`2I00_ooiT00ooo09T00ol0oooo<ol0oc?o0007oc?o00;o<`3o00?o0?ooo`3oI_l0ofH01?l0
ofH00olc0?ooooooooooo`04ooooo`03o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooo
oooo00?ooooo0_ooV@0;olco00Wo06Ko1ol0ofH4ol`0o`Go0?mV2OooV@0?ool0V@CooiT07_ooool4
oc<0o`03ooooooo<0?ooc03o00Soc03o1Ol0ool4ol`0o`Co<`3o0_l0ool>ooooo`So<`3o4oooool5
o`3oIWCooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`03oooooa3o<ol00oooV@03
o`3oo`;o<`3o1OooV@05ool0V@;o06Ko1oo<0?l3olco00Co<`3o1Olco`05olco00Ko<ol01Ol0I_l8
oc?o00Coc?l00ooo00000ol0ooooc?l0olco0007olco00Goc03o0_oo0002olco00;o0?oo1?lc0?l5
ool0V@KooiT000?o06Koo`3oI_l0ofH01?l0ofH00ol0ooooc?l0olco0008olco00;o0?mV1Ol0I_l0
0oo<0?oo<`3ooc<0o`06ool000Co0?oo1_lco`001?o<0?oooiT0oonI0?ooV@04olco00Wo<ol01?o<
0?l2ool0V@;o0?mV1Ol0I_l00ooo003o<ol0oc?o0002oc?o00Coc?l01?oo09T>oc<0o`03o`1Voolc
o`3o<ol000Oo<`3o00?o06Kool`0ooo<0?l01?oo09T2oc<0o`03olco0?l0ofKo0?mV00Go<ol00_oo
09T00ol0oooooiT0oonI0009oonI00?o0?oo2Olco`000ol0oooo0?mVo`3oIP03o`3oIPKooooo00?o
0000ooooooooool04Oooool002;ooooo00?o0000ooooooooool00oooool8olco00_o06Ko1_l0ofH0
0olco`3o0?mVol`0o`03ol`0oacoo`2I1?ooV@0Rooooo`Go<`3o0oooool00ooo003oc03ool`0o`09
ol`0o`Go0?oo3oooool7oc<0oi3ooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`03
ooooobco<ol00_o<o`02oonI00Co<`3o2olco`05o`1Vo`Go<ol03?oo09T5olco00;o<ol00oo<o`00
1?l0ofKoc03ool`0ool0ofH3ol`0o`;oo`000_o<o`02o`3oo`Goo`2I1_ooV@000ooo09Wo06Koo`1V
o`02o`3oo`;o<`3o1Ol0ofH6olco0003ool00?l0ofKo0?mV00;o0?mV0_l0ool6o`1Vo`Soo`001?l0
ool7oc?o0003ol`0oolco`3o<ol000Oo<ol01?o<0?l2olco00;oo`2I00?o<`3oo`1Vool0I_l01?l0
I_l3ol`0o`;oo`001?o<o`04ool0V@Ko0?oo00?oc?l0ool00?oo00003_lc0?l00ol0I_oooiT0ol`0
o`02ol`0o`_oo`2I0_lco`02ool000Go0?oo0ooo09T;oonI00;o0?oo2Olco`02o`3oIPKooooo00?o
0000ooooooooool04Oooool002;ooooo00?o0000ooooooooool00oooool3olco00;o<ol01?l0I_l8
ool0V@Ko0?mV0ooo09T4ol`0oa;oo`2I00?o0?oooonI0?ooV@002_ooV@0Vooooo`Co<`3o1Oooool2
ool00004o`3oooo<0?ooc03ool`0o`Go0?oo3_ooool8oc<0oi?ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`03ooooo`?oc03o0_ooV@05o`3oo`;oc03o0oooV@0Moc?o00?oc?l03_lc
o`04o`1Vo`03oc?o0?oo09Woo`2I00ooo`2I1Oo<o`03ool0V@?oc?l00ol0ofH3ool0V@?oc03o0_oo
0002olco00Coo`2I1_ooV@08ool0V@?o<`3o00?o0?mVolco0?o<o`001oo<o`02o`3oIP;o<`3o1?oo
0006o`1Vo`Go<`3o0ooo0004o`3oo`_o<ol01?o<0?l3o`1Vo`04oc<0oooo09Woo`2Iool0V@Ko06Ko
0oo<o`000ooo09Wo<ol0ool0V@04olco00;oo`2I0olco`09o`3oo`03olco0?oo003oo`0000?oo`00
1Olc0?l2o`1Vo`;ooiT00oo<0?l00ooo09Wo<`3ooc<0o`02oc<0o`Woo`2I1Ol0ool6ool0V@04olco
0?oo09Woo`2Iool0V@_ooiT000?o06Kooc?o0?lco`001Olco`06ooooo`03o`000?oooooooooo017o
oooo000Rooooo`03o`000?oooooooooo00?ooooo3_oo09T6o`3oIPCoo`2I1?o<0?l00ooo09WooiT0
oonI0003oonI00Go<ol000Co06Koool0VOoo09Woo`2I0oo<o`02o`3oo`04oooooolco`3o<ol0oc?o
00;ooooo1?ooV@0[ooooo`Co<`3o1_ooool01?oo003o0?ooo`3oool0ool?ooooo`So<`3oU_ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00?ooooo1oooV@05o`3oo`06ol`0ool0I_oo
06Koo`1Voooo09Wo<`3o0_l0ool00olc0?oo06Kool`0o`04ol`0o`?oo`2I0oo<0?l2oc?o0005ool0
0?l0I_oo06Koo`1Voooo00000oooool2oc?o00?oc?l02_lco`04o`1Vo`CooiT00ol0I_l7olco00Go
o`001Oo<o`04ool0V@?oc?l00_o<0?l3o`3oIP?oo`2I0oo<0?l2ool000;oc?l000?oo`2IoonI0?oo
V@000oooV@03o`3oo`;o06Ko2_oo09T3olco00?o0?mV1?o<o`08ool000;o<`3o1Ol0I_l5oc<0o`;o
o`001Ol0ool2ol`0o`?o<ol01?o<0?l2oc?o00;o<`3o00Goc?l0o`1Vool0I_oo06Koool0V@05o`1V
o`Koc?l000?oo`2Iolco0?o<o`000_o<o`001?oo09Wo<ol0o`3oI_l0ofH5oc?o0003ool00?o<o`3o
c?l000Oo0?oo1Ooo0002o`1Vo`Coo`000oo<0?l00oo<o`3o<`3ooc<0o`02oc<0o`03ool0VOlco`3o
<ol000?o<ol00_oo09T5o`3oo`[oo`2I1?o<o`03ool0V@_ooiT00olco`06ooooo`03o`000?oooooo
oooo017ooooo000Rooooo`;o00001?ooool:ool0V@03oonI0?l0ofKo0?mV00Go0?mV1OooV@04ol`0
o`Co0?mV00?o06Kooc?o0?lco`000olco`001?l0ofKoo`2Iool0VOoo09T4olco00;o0?oo00Cooooo
oc?o0?lco`3o<ol0<oooool5oc<0oaCooooo1olc0?nIooooo`;o00004oooool00ol0003ooooooooo
o`03ooooo`OooiT00_o<0?l4o`3oo`04ol`0oooo09Woo`2Ioc<0o`?o0?oo1_o<0?l3ool0V@;oc03o
00Koo`2Ioc?o0?lco`3o<ol0oooooooo0002o`1Vo`03ool0VOoo003oo`0000;ooooo0_l0I_l3olco
00[o06Ko1OooV@04o`1Vo`Go<ol000?oc?l0ool00?oo00000ooo0005olco0005o`3ooooo003oo`00
ool00?o<0?l00oo<o`03ol`0o`Co0?mV0ooo09T3ol`0o`;oo`001OooV@04o`3oo`?o06Ko1?oo09T0
0oo<o`3oo`2Iool0V@07ool0V@04o`3oI_oo003oo`00ool000Coc?l00_oo0003oc?o00GooiT01Ol0
I_l01?lc0?ooc03ooc<0oolc0?l3ol`0o`Co0?oo1?o<0?l3oc?o0003oc<0ooooV@3oo`0000Coc?l0
1_l0I_l5oc?o00;oo`2I3?o<o`05oc?o0004ool00?o<o`3oo`00ol`0o`Oo0?oo00?oo`2Iool00?oo
00001?oo0003ol`0o`Soo`000_lco`02oc<0o`Go0?oo00?oc?l0ool0VOoo09T03?oo09T5olco00Co
o`2I2OooV@06ooooo`03o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooooooo00?ooooo
2OooV@06o`3oIPCo<ol000?oooooo`3oI_o<0?l00oo<0?l4o`3oIP03o`1Voolco`3o<ol000?o<ol0
0_l0ofH3ool0V@Coc?l00_l0ool2ooooo`;o<ol0=_ooool4oc<0oa3ooooo1olc0?nMooooo`03o`00
0?oooooooooo017ooooo0_l00005ooooo`GooiT00oo<0?l2ool0V@Co0?oo0_lc0?l2o`3oo`Coc03o
00?ooiT0o`1Voooo09T00_oo09T00oo<o`3o<`3oool00002ool000?ooooo2ol0I_l3olco00?o06Ko
00?oo`2IoonI0?ooV@001_ooV@000ooooooo<`3ooc?o0007oc?o00Coo`001_o<o`02o`3oo`03ool0
0?o<o`3oc?l000Coc?l00oo<0?l2oc?o00Ooo`2I0_o<0?l6oonI0004oc?o0?l0oooo0?oooc?o00?o
06Ko0_lco`000ol0I_ooc?l0olco0004olco0003ool00?oo09Woo`2I00Soo`2I1Oo<o`000olco`3o
oiT0oonI0007oonI00Go06Ko1oo<0?l4o`3oo`[o<ol000?oo`2Io`1Vool0I_l00ol0I_l01?l0ofKo
<ol0oc?o0?lco`04ool0V@Coc?l000?o06Koo`3oool0ool03?o<o`02oc?o00?oo`0000?o06Koo`3o
ool0ool01Ol0ool3oonI00?oc03o2ooo0005o`3oo`Goo`001?l0ofH:ool0V@Koc?l000?o06Kooooo
oooo09T00ooo09T4oonI00Gooooo0_l0000Cooooo`008_ooool00ol0003oooooooooo`03ooooo`Ko
oiT01_l0ofH00oo<0?oo<ol0oc?o0003oc?o0003olco0?o<0?ooc03o00?oc03o0ol0ofH00ol0I_oo
<ol0oc?o0003oc?o00;o0?mV0ooo09T4olco00?o0?oo0_ooool3oc?o03Sooooo1?lc0?l:ooooo`So
<`3oX?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00?ooooo1?ooV@001?l0I_oo
c03ool`0ooo<0?l2ool0V@;oc03o1ol0ool3oonI0003o`3oooo<0?ooo`2I00;oo`2I00?oc?l0o`1V
ool0I_l03ol0I_l3ooooo`;oc?l00_oo09T2ooooo`KooiT000?ooooooc?o0?lco`001_lco`000ooo
ooooo`00ool00002ool000Koc?l00ol0ool7olco00?oc03o1ooo09T00ol0ofKo<ol0oc?o0005oonI
00;oo`0000Coc?l0oonI0?lco`3o<ol00ol0I_l00olco`3oc?l0olco0004olco00Soo`002?oo09T5
olco0003o`3oI_l0oooo0?oo00Ooc03o1Ol0I_l2ol`0o`Co<`3o2?l0ool4oc?o00Go06Ko00?o0?mV
o`1Vool0I_l01Ooo09T4olco0003o`1Vool0oooo0?oo00?o0?oo4Oo<o`000ooo003o06Koo`1Vo`0H
o`3oo`koo`000_ooool7ool0V@Koc?l01Oooool3ool0V@Kooooo00?o0000ooooooooool04Oooool0
02;ooooo00?o0000ooooooooool01?ooool3o`1Vo`Ko0?mV00?oc03ooc?o0?lco`000olco`000ooo
oooo0?mVol`0o`03ol`0o`?o0?mV00?o06Kooc?o0?lco`000olco`03o`3oIP;oo`2I00?o06Koolco
0?o<o`000_o<o`03o`3oo`;ooooo0olco`0jooooo`Go<`3o1Oooool8oc<0oj?ooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`03ooooo`?ooiT000?o06Kool`0ooo<0?l01_o<0?l2oc<0
o`Go0?oo00?ooiT0o`1Vool0I_l03ol0I_l2ooooo`?o06Ko0_oo09T3ool00005ooooooo<o`3oc?l0
olco0?lco`001?ooool2oonI00Oo<ol00oooool4ool000Goc?l00_oo0003o`3oo`;oc03o0_lc0?l3
olco0003ol`0oooo09Woo`2I00Goo`2I00Co<ol0ol`0ool0ofKo0?mV1OooV@02ol`0o`?oo`0000?o
c?l0oonI0?l0I_l00_l0I_l6olco00Woo`0000?o0?mVool0VOoo09T02?oo09T4olco00Woc03o00?o
o`2Ioc?o0?l0I_l01?l0I_l2ol`0o`?o<`3o00?o<ol0o`3oool0ool02ol0ool2o`3oIPOoo`2I1?o<
o`05o`3oo`?oc?l00_l0ool2oc?o00?o0?mV0_lco`0<olco0003o`1Vool0oooo0?oo02[o0?oo0ooo
09T5olco00?oo`2I00?ooooooonI0?ooV@001_ooool00ol0003oooooooooo`0Aooooo`008_ooool0
0ol0003oooooooooo`03ooooo`03o`1Vool0ofKo0?mV00Co0?mV00?ooooool`0ooo<0?l01?lco`00
0oooooooc?l0ol`0o`03ol`0o`Co0?mV1Olco`001Ooo09Wo0?mVo`3oI_l0ofKoo`2I00;o06Ko0oo<
o`03o`3oo`?ooooo0olco`0mooooo`Co<`3o00?ooooooc<0oolc0?l01Olc0?nWooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool00oooool2oonI00Woc03o00?o<`3oo`1Vool0I_l00_l0
I_l4o`3oo`Wo06Ko0_o<o`02o`3oIPGo<`3o0_ooool2o`1Vo`?oo`2I00Coo`00ool0VOoo09Woo`2I
0oo<o`0:oc?o00Cooooo1?oo0005olco0003ool00?l0ofKo0?mV00?o0?oo1?lc0?l2olco00Ooo`2I
00?o0?ooolco0?lco`000_lco`05oonI00Goc03o0ooo0006olco00Woo`001?l0ofH3ooooo`;oc03o
00?oo`2Iol`0ooo<0?l01Oo<0?l4olco0004ol`0oooo09Woo`2Io`3oIPGo06Ko0_oo09T6o`1Vo`;o
c03o1_lc0?l?o`3oo`Coc?l01Ol0ool2olco00So0?oo0ol0ofH2o`3oo`;o06Ko00?oo`00oc?o0?lc
o`002?o<o`03ol`0o`;o<`3o1?lco`000ooo003o0?ooo`3oo`0To`3oo`Koc?l00ol0ool6ooooo`03
o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooooooo00?ooooo1Ol0ofH2ooooo`03ol`0
oolco`3o<ol000;o<ol00_ooool00ol0ofKoc03ool`0o`02ol`0o`?o0?mV1Olco`02ool0V@?o0?mV
00?oo`2Io`1Vooo<o`000oo<o`03o`3oo`Cooooo0_lco`10ooooo`Oo<`3oZ_ooool00ol0003ooooo
ooooo`0Aooooo`03o`000?oooooooooo00?ooooo1?o<0?l>o`1Vo`Co0?oo0ooo09T2ool000;o06Ko
0oo<o`02o`3oIPKo<`3o0ol0I_l6ool0V@04ool00?o<o`3oc?l0olco00Ko<ol000?o<`3ooooooooo
ool00_ooool4ool000Goc?l000Co0?ooo`3oI_l0ofKo0?mV0ol0ool4oc<0o`Ooo`2I00?o<ol0o`3o
ool0ool00_l0ool6oonI00?o0?mV1Oo<0?l3ool00003olco0?oo003oo`0000Ooo`000_l0I_l4o`3o
IP;ooooo3Oo<0?l00ooo09Woc?l0olco0003olco00Goo`2I1Ol0I_l00olc0?oo06Koo`1Vo`04o`1V
o`;oc03o0_lc0?l6o`1Vo`03o`3oI_oo09Woo`2I00Ko0?oo1Oo<o`04o`3oo`03oc<0ooo<0?ooc03o
01goc03o0_lc0?l3oc?o0003ool00?l0oooo0?oo00?o0?oo0olc0?l4olco013ooooo1?l0ofH2o`1V
o`So0?oo1_o<o`000ol0ooooooooooooo`04ooooo`03o`000?oooooooooo017ooooo000Rooooo`03
o`000?oooooooooo00?ooooo0_l0ofH3ooooo`03ol`0oolco`3o<ol000?o<ol00_ooool4ol`0o`?o
0?mV1Olco`02ool0V@Co0?mV00?oc?l0o`1Vooo<o`000oo<o`03o`3oo`Cooooo0olco`11ooooo`?o
<`3o[Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00?ooooo3Ol0I_l01?ooV@3o
0?ooo`3oool0ool2ol`0o`Go0?oo0_ooool2ool000;o06Ko0oo<o`03o`3oIP03ool00?lc0?oo<`3o
00;o<`3o0ol0I_l4ool0V@?oo`000oo<o`001?lco`3o<`3ooc<0oolc0?l3ooooo`Goo`001Oo<o`02
oc<0o`03o`3oI_lc0?oo<`3o00?o0?oo0_lc0?l7ool0V@?oc03o0ol0ool6oonI0003oc?o0?o<o`3o
c?l000;o0?mV0ol0I_l3ol`0o`Soo`000ol0I_l2olco00;o0?mV3?o<0?l4ooooo`Co<`3o00?oo`2I
olco0?o<o`000oo<o`07ool0V@?o<ol00_lc0?l:o`1Vo`03oc<0oooo09Woo`2I00Goo`2I0oo<0?l4
olco00go0?oo6?o<0?l01Olc0?oo<ol0oc?o0?lco`3oo`0000Go0?oo0_lc0?l2ool0V@?oc?l05?oo
ool01_l0ofKo06Koo`1Vool0I_oo0?mVoonI00Gooooo0_oo09T2ool000Coc?l01_ooool00ol0003o
ooooooooo`0Aooooo`008_ooool2o`0000Oooooo00?oc03ooc?o0?lco`000olco`02ooooo`03o`3o
I_o<0?ooc03o00;oc03o0_l0ofH5oc?o0003oonI0?oo09Woo`2I00Co0?mV1Oo<o`001?oo09Wo0?oo
o`3oool0ool4ooooo`?o<ol0lOooool2o`0001?ooooo00?o0000ooooooooool00oooool5o`1Vo`;o
o`2I0olc0?l3oonI0003ooooool0oooo0?oo00;oc03o00?oo`2Iol`0oooo09T01Ol0ool3ool00003
o`3oool0I_ooc?l000;oc?l00ol0ofH3ool000;o<`3o0ol0I_l4ool0V@03oc<0oooo003oo`0000;o
c?l000?oo`00oc?o0?ooool00_ooool5ool000Goc?l01_lc0?l3o`3oo`Ooo`2I0oo<0?l01?o<o`3o
c03oo`3oool0ool5oonI0003oooooolco`3o<ol000;o<ol01ol0I_l3ol`0o`Coo`000_l0I_l2olco
00goc03o0olco`08ooooo`Go<`3o1?o<o`0;ool0V@;o<`3o1_l0I_l7ool0V@Coc03o1?o<o`07ol`0
o`oo0?oo4Olc0?l2oc?o0003ool00?l0oooo0?oo00?o0?oo0olc0?l2ool0V@?oc?l05Oooool3o`1V
o`Co0?mV1_ooool4ool0V@;oc?l01_ooool00ol0003oooooooooo`0Aooooo`008_ooool00ol0003o
ooooooooo`04ooooo`;oc03o1?lco`03ooooo`Coc03o0_l0ofH5oc?o0004oonI0?oo09Woo`2Iolco
00?o0?mV1_o<o`001?oo09Wo0?ooo`3oool0ool5ooooo`;o<ol0loooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo00?ooooo0_o<0?l01?l0I_ooo`2Iool0VOoo09T3oc<0o`;ooiT000?o
<`3ool`0ool0ool01?l0ool4ool0V@03ol`0ool0oooo0?oo00;o0?oo0olco`000ol0oooo06Koolco
0002olco00Co0?mV0_oo0002ool0V@?o06Ko00Coo`00ool0VOoo09Woo`2I0_lc0?l3olco00Koo`00
1_o<o`000olco`3o<`3ooc<0o`04oc<0o`?o0?oo1Ooo09T2olco00?oc03o00?oo`00ooooool0ool0
1OooV@001?o<0?ooooooooooooooool7o`1Vo`Coo`000oo<0?l00ooo003o06Kool`0o`0;ol`0o`Co
c?l01?lco`0;ooooo`Go<`3o1?o<o`000ol0oooo0?mVo`3oIP0:ool0V@;o06Ko1_oo09T00ooooooo
c?l0olco0007olco00;o0?oo00?o<`3oo`1Vool0I_l00ol0I_l5olco00;ooooo3ol0ool5oc<0o`?o
o`000_lco`000ooo003o0?ooo`3oo`03o`3oo`04ool0VOlc0?oo<`3ooc<0o`;oo`2I0oo<o`0Eoooo
o`?o06Ko0_ooool5o`3oIPGooooo1?oo09T7ooooo`03o`000?oooooooooo017ooooo000Rooooo`03
o`000?oooooooooo00?ooooo00?oc03ooc?o0?lco`000_lco`03ooooo`03o`3oI_o<0?ooc03o00;o
c03o0_l0ofH4oc?o0003oonI0?oo09Woo`2I00;oc?l00ol0ofH5olco00;oo`2I0ol0ool5ooooo`?o
<ol0loooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00?ooooo0_l0I_l2ool0V@Co
<`3o00?ooiT0oc?o0?o<0?l00_o<0?l2o`3oo`04oc?o0?l0oooo0?ooo`3oo`?oo`2I0oo<0?l4o`3o
o`;o<ol000?o0?ooo`1Vooo<o`000_o<o`04o`3oIP?oo`2I00Go<`3oo`1Vool0I_oo<`3oool00003
ool0V@;ooooo0oo<o`03ool000Koc?l01olc0?l01?oo09Wo0?ooo`3oool0ool3ool0V@04o`3oI_o<
o`3oc?l0olco00?oc03o00?oo`00oonI0?ooV@001?ooV@02ol`0o`;oo`001_l0I_l7ool00003o`1V
ooo<0?ooc03o00Soc03o0_l0ofH6olco00Co<ol04?o<o`000olc0?oo<ol0oc?o0005olco00;o0?oo
1?l0ofH:ool0V@03o`3oI_o<o`3oc?l000Soc?l00_l0ool00olc0?oo06Koo`1Vo`05o`1Vo`;o0?oo
1Oo<o`04ooooo`?o<`3o3ol0ool2ool000Go0?oo0_ooool3oc<0o`;oo`2I0oo<o`0Dooooo`Co06Ko
1Oooool5o`3oIPGooooo0ooo09T6ooooo`03o`000?oooooooooo017ooooo000Rooooo`03o`000?oo
oooooooo00?ooooo1?lco`03ooooo`Coc03o0_l0ofH4oc?o00;ooiT00oo<o`04o`3oIPGoc?l00_oo
09T3o`3oo`Gooooo0olco`3dooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool00ooo
ool00ol0I_ooo`2Iool0V@04oc<0o`03ool00?o<0?ooc03o00;oc03o0ol0ool2oc?o0004o`3ooooo
09Woo`2Iool0V@;o<ol00oo<0?l5o`3oo`03ool00?l0oooo06Ko00?oc?l000?o<`3oool0VOoo09T0
0_oo09T2ool000?o06Ko00?ooooooc<0oooo09T00ooo09T00olc0?ooc?l0olco0006olco00Oo<`3o
0ooo09T3o`3oo`04ool0VOl0ofKo0?mVo`3oIP?oc?l00oo<0?l00ooo003ooiT0oonI0003oonI00?o
o`001_l0I_l3ool00004oc?o0?l0I_oo06Koo`1Vo`?o0?mV0_o<o`04ol`0o`03olco0?l0ofKo0?mV
00?o0?mV00?oc03oo`3oI_o<0?l00oo<0?l4oc?o00;ooooo3_o<o`06oc?o00Goc?l00_l0ool00oo<
o`3o0?mVo`3oIP03o`3oIP?oo`2I0ol0ofH:olco0004o`3ooolc0?ooc03ool`0o`?o06Ko00?ooooo
o`3oool0I_l01Ol0I_l5olco00Gooooo1?lc0?l3o`3oIPgo0?oo0_ooool4oc<0o`03ool0VOoooooo
c?l000;oc?l00ooo09TAooooo`Co06Ko1oooool00oooV@3o0?mVo`3oIP04o`3oIP?o06Ko0_oo09T6
ooooo`03o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooooooo00?ooooo0_lco`03oooo
o`Goc03o00?o0?mVoc?o0?lco`000_lco`02oonI00?oc?l01Ol0ofH5olco00;oo`2I0ol0ool5oooo
o`?o<ol0mOooool00ol0003oooooooooo`0Aooooo`;o00001?ooool00ooo09WooiT0oc<0o`02oc<0
o`03oonI0?o<0?ooc03o00?oc03o00?o<ol0o`3oool0ool00olco`03ool0V@04o`3ooooo09Woo`2I
ool0V@Coc03o1_l0ool01?l0I_ooc?l0olco0?o<o`03ool0V@;o0?mV0_oo0003o`1Vo`;ooooo1?oo
09T00ooo003oc?l0olco0003olco00Go<`3o00?o0?mVool0VOoo09T00ooo09T3o`3oo`Co0?mV0oo<
o`03ool000GooiT00_oo0007o`1Vo`04oc?o0?o<0?ooc03oo`1Vo`?o<ol00ol0I_l3o`3oIPCoc?l0
00?oc03oo`3oI_l0ofH01?l0ofH5ol`0o`?o<ol04?ooool5oc?o00;oc?l00olc0?l4olco00?o0?oo
0_o<o`06o`3oIP?oc?l00_oo09T00ol0ooooc?l0olco0002olco00;o<`3o0oo<0?l3o`1Vo`04oooo
ool0oooo0?ooo`3oo`Ko06Ko00?oooooolco0?o<o`001?o<o`04ooooo`?o<`3o0ol0ofH6ooooo`Co
0?oo0oooool4oc<0o`03ool0VOooooooc?l000;oc?l01_oo09T>ooooo`?o06Ko2_ooool2oonI00Wo
0?mV1Oooool2o`0001?ooooo000Jooooo`?o00001Oooool00ol0003oooooooooo`07ooooo`Coc03o
00?o0?mVoc?o0?lco`000olco`02oonI00;oc?l01_l0ofH4olco00?oo`2I0ol0ool6ooooo`;o<ol0
m_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00?ooooo00GooiT0oc<0oolc0?oo
<`3ooc?o0004ol`0o`;o<ol00ol0ool2oc<0o`?oo`2I0ol0ool3ool0V@Coc03o00?oooooo`3oool0
ool00ol0ool01Ol0I_ooc?l0olco0?o<o`3o0?oo00Co0?mV0_oo0003o`1Vo`;ooooo00Goo`00ool0
VOoo09Woo`2Ioc<0o`02olco00Co<`3o00?oooooool0VOoo09T01Ooo09T3o`3oo`03o`3oI_oo003o
o`0000Koo`001OooV@000ooo003o06Koo`1Vo`05o`1Vo`04oooooolco`3o<ol0ool000Co06Ko1Olc
o`001?l0I_oo0?mVo`3oI_l0ofH2olco00Ko0?mV1Oo<0?l4oc?o00kooooo1_lco`02ooooo`;o06Ko
0_l0ool3oc<0o`Coc?l00ol0ool3olco00;o0?mV00Goc?l0ool0VOoo09Woo`2Io`3oo`04olco00?o
<`3o0ooo09T3o`1Vo`04ooooool0oooo0?ooo`3oo`;ooooo1ol0I_l00oooooooc?l0olco0004olco
00Cooooo0_lc0?l3o`3oIP03oc<0oooooooooooo00Sooooo0olc0?l00ooo09Woooooooooo`03olco
00Cooooo1Ooo09T;ooooo`?o06Ko2oooool00ol0I_oo0?mVo`3oIP08o`3oIPKooooo00?o0000oooo
ooooool04Oooool001_ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`05ooooo`Co
c03o00?o0?mVoc?o0?lco`000olco`02oonI00;oc?l000?oo`2Io`3oI_l0ofH01?l0ofH4olco00?o
o`2I0ol0ool6ooooo`?o<ol0m_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00?o
oooo0olc0?l4ol`0o`04oc?o0?ooooooooooool000;o0?oo0_lco`000olc0?ooo`2Iool0V@02oooo
o`?o0?oo00Coooooool0VOoo09Woo`2I0oo<0?l00olc0?ooo`00o`3oo`03o`3oo`06ool0VOo<o`3o
c?l0o`1Vool0oooo<`3o1?l0ofH00ooo003o06Koo`1Vo`02o`3oIP;oo`000ooo09T4oc<0o`Ooo`2I
0_oo0003o`3oo`Soo`001OooV@07o`1Vo`;ooiT000?ooooooc?o0?l0I_l01Ol0I_l00oo<0?oo<ol0
oc?o0003oc?o00;o06Ko1ol0ofH2ooooo`Coc03o00?o06Kooc?o0?lco`000_lco`0=ooooo`Ko<ol0
0oooool2oonI00;o06Ko0ol0ool2oc<0o`Goc?l00ol0ool4ooooo`?o0?oo1?o<o`02oc<0o`Coo`2I
0ol0I_l4o`3oo`Coo`2I1ol0I_l3ooooo`Goc?l01Oooool3o`3oIP;o<`3o1oooool3oc<0o`03ool0
VOooooooc?l000?oc?l01oooool5ool0V@Sooooo0ol0I_l8ooooo`oo0?mV1_ooool00ol0003ooooo
ooooo`0Aooooo`006oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Cooooo1?o<
0?l00ol0ofKo<ol0oc?o0002oc?o00?ooiT000?oc?l0ool0VOl0ofH01Ol0ofH4olco0004o`1Voooo
09Woo`2Iool0V@?o0?oo1_ooool3oc?o0?Oooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`03ooooo`;o<`3o1?o<0?l4ooooo`?o0?oo0_lco`03ool0V@03ool00?oooooooooo00?o0?oo
00Coo`00ool0VOoo09Woo`2I0oo<0?l00oooooooo`00o`3oo`04o`3oo`;oc?l000?o06Koo`3oool0
ool01?l0ofH3o`1Vo`?oo`0000?o0?ooool0VOoo09T02?oo09T4ool000?o0?oo1?oo0003olco00Go
oiT01_l0I_l00oo<0?ooooooooooo`02oonI00Ko06Ko1?lc0?l5oc?o00;o06Ko1?l0ofH2ooooo`Co
c03o00?o06Kooc?o0?lco`000_lco`0=ooooo`Go<ol01?ooool5oonI00;o06Ko0ol0ool00ooooooo
<`3ooc<0o`05olco00Ko0?oo1?o<o`02oc<0o`;oc03o0oooool3o`1Vo`Co0?oo1_oo09T3o`1Vo`03
ool0VOl0I_oo06Ko00;o06Ko0ooo09T5olco00Cooooo0_l0ofH5oc<0o`?ooooo0olc0?l00ooo09Wo
ooooolco0003olco00[ooooo1Ooo09T4ooooo`Co06Ko1?ooool;o`3oIP04ooooooooV@3ooiT0oonI
00?ooooo0_l0ofH6ooooo`03o`000?oooooooooo017ooooo000Kooooo`03o`000?oooooooooo00Co
oooo0ol00003ooooo`?oc03o00?o0?mVoc?o0?lco`000_lco`03oonI0003olco0?oo09Woo`2I00Ko
0?mV1?o<o`03ool0V@Co0?oo1_ooool3oc?o0?Kooooo0ol0000Cooooo`03o`000?oooooooooo00?o
oooo1_o<0?l4ooooo`;o0?oo0_ooool3ool0V@Go<`3o0ol0ool01?oo003oo`2Iool0VOoo09T3ol`0
o`?oo`2I1Ol0ool01Oo<o`3o06Koo`3oool0oooo<`3o00?o0?mV0ol0I_l01?oo003o<`3ooc<0oolc
0?l6ool0V@Koo`000ol0ool01?l0ofKoooooooooooooool2olco00GooiT01Ol0I_l00ol0ooooc03o
ol`0o`02ooooo`Ko06Ko00?oo`00oooooolc0?l00olc0?l2ool000Co<ol00_o<0?l01?l0I_oo0?mV
o`3oI_ooool5ol`0o`03oooooolco`3o<ol000;o<ol02oooool6oc?o00Cooooo1OooV@03ooooo`;o
06Ko0ol0ool2ooooo`;o<`3o1?o<o`03o`3oo`Goc?l000?o<`3ool`0ooo<0?l00oooool4o`1Vo`?o
0?oo2Oooool3o`1Vo`03ool0VOl0I_oo06Ko00;o06Ko1?oo09T5olco00;oo`2I0ol0ofH9oc<0o`;o
oooo0oo<o`0>ooooo`Goo`2I00?oooooo`1Vool0I_l00_l0I_l;o`3oIP03o`1Voooooooooooo00Co
oooo0oooV@0:ooooo`03o`000?oooooooooo017ooooo000Kooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool00oooool2ol`0o`Co<ol01?ooV@03ool0V@;o0?mV00Coc?l0o`3oI_l0ofKo
0?mV1?o<o`03ool0V@Co0?oo1oooool2oc?o0?Wooooo00?o0000ooooooooool04Oooool00ol0003o
ooooooooo`03ooooo`;oc03o00?o0?ooooooooo<0?l00_o<0?l2ooooo`?o0?oo00Coooooool0VOoo
09Woo`2I0_lco`05oc<0o`?o0?oo0_oo0002ool0V@Coc03o0_oo00000ooooooo0?ooo`3oo`02o`3o
o`06olco0?l0I_oo0?ooo`3ooooo09Wo0?mV0_oo0003o`1Vo`?o<`3o00?o0?mVool0VOoo09T00ooo
0003oc<0o`03ool00?l0ofKo0?oo00;o0?oo00Go0?mVooooooooooooooooolco0005oonI00Go06Ko
0_l0ool3ol`0o`Ko06Ko0_oo00001?ooV@3o<`3ooc<0oolc0?l4ool00003oooooolco`3o<ol000;o
<ol02?o<0?l2ooooo`?o<ol02oooool6oc?o00?ooooo1_ooV@06ooooo`;o06Ko0ol0ool4ooooo`03
oc<0ooo<o`3oc?l000Koc?l000?o<`3ool`0ooo<0?l01?ooool3o`1Vo`Co0?oo2oooool3o`1Vo`;o
oooo1?l0I_l01?ooooooo`2Iool0VOoo09T5olco0004ool0VOl0ofKo0?mVo`3oIP;oo`2I1Olc0?l2
ooooo`?oc?l04Oooool3ool0V@?o06Ko2?l0ofH3o`1Vo`[ooooo0oooV@09ooooo`03o`000?oooooo
oooo017ooooo000Jooooo`;o00001_ooool00ol0003oooooooooo`03ooooo`Co<ol01?ooV@03ool0
V@?o0?mV00?oc?l0o`3oI_l0ofH01?o<o`04ool0V@?o0?oo2?ooool3oc?o0?Wooooo00?o0000oooo
ooooool04Oooool00ol0003oooooooooo`03ooooo`Go0?oo0oo<0?l01?oooooo0?ooo`3oooooool3
ool0V@03oc<0oolco`3o<ol000?o<`3o0ooo0003o`3oo`;oo`000_oo09T4ol`0o`;oo`000_ooool4
o`3oo`03o`1Voolc0?oo<`3o00?oo`0000Go0?mVo`1Vool0I_ooo`00o`3oo`05o`3oIP;o0?oo0_lc
0?l00ooo003o0?mVo`3oo`02o`3oo`04ool0VOooooooooooooooo`GooiT01?l0I_l01Ooooooo0?oo
o`3oool0ooooc03o00Ko06Ko0olco`000ooo003ooiT0oc<0o`02oc<0o`03ool00?oooooooooo00Co
oooo0olco`06ol`0o`;ooooo1?lco`0:ooooo`Go<ol01?ooool6oonI00Wooooo0_l0I_l2o`3oo`Ko
oooo1Oo<o`000olc0?ooc03ool`0o`05ooooo`?o06Ko1?l0ool=ooooo`?o06Ko0_ooool4o`1Vo`Go
oooo1Oo<o`03o`3oIP?oo`2I0_lc0?l2ooooo`?oc?l04?ooool4o`3oIP?o06Ko1?l0ofH6o`1Vo`go
oooo0oooV@08ooooo`03o`000?oooooooooo017ooooo000Kooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool00oooool2oc?o00CooiT00ooo09T01?oooooo0?mVo`3oI_o<o`03o`3oIPCo
c?l01?oo09T3o`3oo`Sooooo0olco`3jooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool01Oooool4o`3oo`;oc03o0ol0ool00olc0?ooo`2Iool0V@02oc<0o`?o<ol00olc0?l2ooooo`04
ool00?l0oooo0?ooo`3oo`Goo`2I0oo<0?l2ool000;o<`3o1Ol0ool3ool00003ool0VOl0ofKo06Ko
00;o06Ko0_oo00000ol0oooo0?mVo`3oIP02o`3oo`;o<`3o0_l0ofH3o`3oo`;ooooo1_ooV@03o`1V
o`;o0?oo0_ooool2o`3oo`Ko06Ko00Cooooooc?o0?lco`3o<ol00_oo0003oc<0o`03oonI0?oooooo
oooo00Gooooo0olco`02ooooo`;oc03o0oooool4oc?o00Sooooo1_lco`04ooooo`GooiT03Oooool0
1?l0I_oo0?ooo`3oool0ool6ooooo`03ol`0ooo<o`3oc?l000;oc03o1_ooool3o`1Vo`?o0?oo4?oo
ool3o`1Vo`?ooooo0ol0I_l6ooooo`Coc?l00ol0ofH5ooooo`?oc?l03?ooool8o`3oIP?o06Ko0_oo
09T6o`1Voa7ooooo0oooV@07ooooo`03o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooo
oooo00?ooooo00?oc?l0oonI0?ooV@000_ooV@03ool0V@04ooooool0ofKoc?l0olco00?o0?mV0oo<
o`05ool0V@?o0?oo2Oooool2oc?o0?_ooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`07ooooo`Ko0?oo00Co<`3oool0VOoo09Woo`2I0oooool3oc?o00?o<`3o0oooool01?l0ooooo`2I
ool0VOoo09T2ool000;oo`2I0oo<0?l4oc<0o`Oo0?oo0_oo09T01?lc0?oo06Koo`1Vool0I_l2ool0
00;o0?oo00?oo`00oc<0ool0ofH00_l0ofH3o`3oo`03ooooooooV@3ooiT000CooiT00_l0I_l01?o<
0?oo0?ooo`3ooooo0002ooooo`03o`3oool0I_oo06Ko00?o06Ko1?oo0002oc?o00;oo`000olc0?l3
oonI00Oooooo0olco`04ooooo`Co<ol02?ooool6oc?o00?ooooo1_ooV@0@ooooo`04o`1Vool0oooo
0?ooo`3oo`Kooooo0_o<0?l7ooooo`;o06Ko1?l0oolBooooo`?o06Ko0oooool4o`1Vo`Kooooo0oo<
o`03o`3oIP?ooooo0oo<o`08ooooo`_o0?mV2_l0I_l2ool0VA?ooooo0oooV@06ooooo`03o`000?oo
oooooooo017ooooo000Rooooo`03o`000?oooooooooo00?ooooo0oooV@03ool0V@03ooooool0ofKo
0?mV00;oc?l00_l0ofH4olco00Goo`2I0ol0ool9ooooo`?o<ol0noooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo00?ooooo2?ooV@02o`3oo`?oo`2I1Oooool3oc?o00?o<`3o00?ooooo
ool0VOoo09T00_oo09T00ol0oooo<`3ooc<0o`03oc<0o`Coc03o0oooool00ooo003oc?l0o`3oo`04
o`3oo`?oo`2I0ol0I_l01?l0ofKoo`00ool00?lc0?l3o`3oIP?o0?oo1OooV@02o`1Vo`?oc03o0_l0
ool00ooo003oooooo`1Vo`05o`1Vo`03ol`0oooo003oo`0000;oo`000olco`001?oo003o<`3ooc<0
oolc0?l2ooooo`?ooiT01oooool3oc?o00;ooooo1?lco`07ooooo`Go<ol01?ooool6oonI01?ooooo
00Co06Koo`3oool0oooo0?oo3Oooool2o`1Vo`Co0?oo5?ooool3o`1Vo`?ooooo1?l0I_l8ooooo`04
olco0?l0ofKo0?mVo`3oIPCoc?l01?ooool;o`3oIPCooooo2Ol0I_l00oooooooo`2Iool0V@03ool0
VA;ooooo0_ooV@06ooooo`03o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooooooo00?o
oooo0_ooV@02ool0V@;ooooo00Co0?mVolco0?o<o`3oc?l00_l0ofH4olco00Goo`2I0ol0ool9oooo
o`?o<ol0o?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00?ooooo4oooV@03oc?o
00;o<`3o1?oo09T2o`3oo`Go<`3o00?oo`2Iol`0ooo<0?l00_o<0?l01?ooooooo`00ool00?oo0002
olco00Co0?oo0ooo09T2o`1Vo`Ko0?mV0_l0ool5oonI00;o06Ko00Coc?l0ol`0ooo<0?ooc03o0ol0
ool6o`1Vo`;oc03o0ooo00001Ooooooo<ol0oc?o0?lco`3oo`0000?o<`3o1?ooool4oonI00Gooooo
1olco`06ooooo`Ko<ol01?ooool5oonI01Oooooo00Co06Koo`3oool0oooo0?oo2oooool2o`1Vo`?o
0?oo5oooool3o`1Vo`Cooooo1?l0I_l8ooooo`?o0?mV0_o<o`0;o`3oIPSooooo1ol0I_l6ooooo`Go
o`2I6?ooool00ol0003oooooooooo`0Aooooo`008_ooool2o`0000Cooooo0_oo09T3ooooo`05o`3o
I_o<o`3oc?l0olco0?l0ofH01?o<o`02ool0V@04oooooooo09Woo`2Iool0V@?o0?oo2Oooool3oc?o
0?cooooo0_l0000Cooooo`;o00001?ooool3oc<0o`?ooooo00?o0?oooonI0?ooV@005OooV@001?l0
ooooooooooooooooool2ool000;oo`2I0oo<0?l2ool00004ooooool0ooooc?l0olco00Go0?oo00Co
o`2Io`1Vool0I_oo06Ko1?l0ofH00ol0oooooiT0oonI0003oonI0004o`1Vooo<o`3oc?l0olco00?o
c03o00?o0?ooo`1Vool0I_l01?l0I_l00ol0ooooo`00ol`0o`02ol`0o`?ooooo0olco`001?oo003o
<`3ooc<0oolc0?l6ooooo`CooiT01Oooool5oc?o00Gooooo1_lco`03ooooo`KooiT06_ooool01?l0
I_oo0?ooo`3oool0ool9ooooo`03o`1Vool0oooo0?oo00;o0?oo6Oooool4o`1Vo`?ooooo1?l0I_l8
ooooo`[o0?mV2oooool6o`1Vo`_ooooo1Ooo09TEooooo`;o00004oooool002;ooooo00?o0000oooo
ooooool01_ooool00ol0ofKoc?l0olco0002olco0003o`3oI_o<o`3oc?l000;oc?l01_oo09T3o`3o
o`[ooooo0_lco`3nooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool02?ooool3o`3o
o`;oo`2I1Ol0ool3oooooaOooiT000Goc03oool00?ooooooooooo`3oo`03olco00Go0?oo1Ol0I_l5
oonI00;ooooo0oo<o`03ol`0o`Ko06Ko0_l0ool01?oo003oc03ool`0ooo<0?l4ooooo`;o<ol000Co
o`00oc<0oolc0?oo<`3o2Oooool3oonI00Cooooo1?lco`04ooooo`Go<ol01?ooool6oonI01gooooo
00?o06Koo`3oool0ool02?ooool00ol0I_oo0?ooo`3oo`02o`3ooa_ooooo1?l0I_l4ooooo`Co06Ko
1oooool4o`3oIPgooooo1ol0I_l?ooooo`Koo`2I4oooool00ol0003oooooooooo`0Aooooo`008_oo
ool00ol0003oooooooooo`05ooooo`Coc?l00_l0ofH3olco00Ooo`2I0ol0ool:ooooo`?o<ol0o_oo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00Sooooo0_l0ool3ool0V@;ooooo1?l0
ool4oc<0o`Coo`2I00Gooooooc<0oolc0?oo<`3oooooo`0GoonI00?o0?oo0_l0I_l5oonI00?ooooo
0oo<o`03ol`0o`Co06Ko0_oo0003o`3oo`03ooooooo<0?ooc03o00Cooooo0olco`03oc<0o`_ooooo
0oooV@04ooooo`;o<ol00_ooool6oc?o00Cooooo1OooV@0Qooooo`?o0?oo1_ooool01?l0I_oo0?oo
o`3oool0oolOooooo`?o06Ko1?ooool4o`1VoaGooooo1ol0I_lCooooo`Koo`2I4Oooool00ol0003o
ooooooooo`0Aooooo`008_ooool00ol0003oooooooooo`04ooooo`Coc?l000?o0?mVolco0?o<o`00
0_o<o`02ool0V@05oooooooo09Woo`2Iool0VOl0I_l00ol0ool:ooooo`?o<ol0ooooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo00Oooooo0_l0ool3ool0V@03oooooolc0?oo<`3o00;o
<`3o1?l0ool01?lc0?ooo`2Iool0VOoo09T3oc?o0004oooooolc0?oo<`3ooc<0o`;ooooo0ol0ool2
ooooo`?oo`0000?ooooooonI0?ooV@004_ooV@04ooooo`?oc?l00oo<0?l3o`1Vo`03o`3ooooo003o
oooo00?o0?oo00Cooooool`0ooo<0?ooc03o0oooool3oc?o00?o<`3o3Oooool4oonI00;ooooo2?lc
o`03ooooo`KooiT09?ooool3o`3oo`Cooooo1?l0oolQooooo`?o06Ko1Oooool4o`1Voa3ooooo2Ol0
I_lGooooo`Goo`2I3oooool00ol0003oooooooooo`0Aooooo`008_ooool00ol0003oooooooooo`03
ooooo`?oc?l000?oooooo`3oI_o<o`000oo<o`02ool0V@05oooooooo09Woo`2Iool0VOl0I_l00ol0
ool:ooooo`?o<ol0ooooool1ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool01ooo
ool01?l0ooooo`2Iool0VOoo09T7oc<0o`?o0?oo0ooo09T2ooooo`?o<ol000Kooooooc<0oolc0?oo
<`3ooooooooo0003o`3oo`?oo`000oooool2ool0V@?oc03o0_oo0003olco00OooiT000?o0?oooooo
ooooool00_ooool3olco00?oc03o00?o06Koool00?l0ool00_l0ool01?oooooo0?ooo`3oool0ool2
ooooo`;oc03o0oooool3oc?o00;o<`3o4?ooool4oonI0003oooooolco`3o<ol000?o<ol01?ooool6
oonI02Oooooo0ol0ool2ooooo`Co0?oo8oooool3o`1Vo`Gooooo1?l0I_l<ooooo`[o06Ko6oooool5
ool0V@gooooo00?o0000ooooooooool04Oooool002;ooooo00?o0000ooooooooool00oooool2olco
0003ooooooo<o`3oc?l000;oc?l00ooo09T01Oooooooo`2Iool0VOoo09Wooooo00?o0?oo2oooool2
oc?o0?oooooo0_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00Gooooo00?o<`3o
o`3ooooo09T00_oo09T4oc<0o`Gooooo1?oo09T2o`3oo`;ooooo0_lco`02ooooo`;o<`3o0_ooool5
ool000Gooooo00?oo`00ool0VOo<0?l00_o<0?l00oooooooo`00olco0002olco00?o06Ko00?ooooo
o`3oool0ool00oooool01?oo003oc?l0olco0?o<o`03ol`0o`03ool00?oooooo0?oo00;o0?oo0_oo
ool2o`3oo`;ooooo0oo<0?l3ooooo`;o<ol00_lc0?lCooooo`?ooiT000?ooooooc?o0?lco`001?oo
ool5oonI02_ooooo1_l0oolVooooo`?o06Ko1_ooool3o`1Vo`Wooooo1_l0I_l2ooooo`?o06Ko7_oo
ool5ool0V@_ooooo00?o0000ooooooooool04Oooool002;ooooo00?o0000ooooooooool01Oooool4
olco00;oo`2I0_ooool3ool0V@Co0?oo2oooool3oc?o0?oooooo0_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo00?ooooo0olc0?l01?l0ooooo`2Iool0VOlc0?l8ooooo`Coo`2I1?l0
ool01Ooooooo<ol0oc?o0?lco`3ooooo00?o<`3o00?oooooool00?oo00000_oo00000ol0oooooooo
ooooo`04ooooo`03ool00?oo09Woc03o00?oc03o00Coooooolco0?o<o`3oc?l00ol0I_l01Ooo003o
ooooool00?oo003o06Ko00?oc?l00oo<0?l2ooooo`03ool00?l0oooo0?oo00;ooooo0ol0ool01?oo
ooooc03ool`0ooo<0?l3ooooo`?o<ol000?o<`3oooooooooool04oooool3oonI00?ooooo1_ooV@0^
ooooo`Co0?oo:?ooool3o`1Vo`Kooooo1?l0I_l4ooooo`Ko06Ko1?ooool3o`1Vob7ooooo1Ooo09T9
ooooo`03o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooooooo00Cooooo0oo<o`03ool0
V@;ooooo0ooo09T4o`3oo`_ooooo0olco`3oooooo`?ooooo00?o0000ooooooooool04Oooool00ol0
003oooooooooo`03ooooo`;o<`3o00Co0?ooool0VOoo09Woo`2I2?ooool3ool0V@04ooooooo<0?oo
c03ool`0o`Co0?oo0olco`000ooooooo<`3ooc<0o`04ool000?o0?oo1Oooool2ool00003ool0VOo<
0?ooc03o00;oc03o00Coooooolco0?o<o`3oc?l01_l0I_l3olco00?oc03o0_ooool01Ooo003o0?oo
o`3oool0oooooooo00?o0?oo0_ooool2ol`0o`?ooooo0olco`000olc0?ooooooooooo`0Eooooo`Wo
oiT0<Oooool2o`3oob[ooooo0ol0I_l6ooooo`_o06Ko1Oooool3o`1VobCooooo1Ooo09T7ooooo`03
o`000?oooooooooo017ooooo000Rooooo`;o00001?ooool3olco00?oo`2I00?oooooool0VOoo09T0
0_oo09T3o`3oo`03ool00?oooooooooo00[ooooo0_lco`3oooooo`?ooooo0_l0000:ooooo`Go0000
1?ooool00ol0003oooooooooo`05ooooo`?oo`2I1oooool4ool0V@?ooooo0oo<0?l4o`3oo`?o<ol0
00Goooooool00?oo003oo`00ooooo`02ool000?o0?oo1Oooool3ool00005ool0VOo<0?ooc03ool`0
ooooool00oo<o`04o`1Vo`?oc?l00oo<0?l2ooooo`05ool00?l0oooo0?ooo`3oooooool00ol0ool2
ooooo`?oc03o0oooool2oc?o0003oc<0oooooooooooo01Oooooo1OooV@1Qooooo`?o06Ko1oooool6
o`1Vo`Kooooo1?l0I_lWooooo`Coo`2I1_ooool00ol0003oooooooooo`0Aooooo`008_ooool00ol0
003oooooooooo`03ooooo`;oc?l00_oo09T2ooooo`Coo`2I0ol0ool00ooo003oooooooooo`0:oooo
o`?o<ol0ooooool4ooooo`03o`000?oooooooooo00Wooooo00Co0000oooooooooooo00001?ooool0
0ol0003oooooooooo`04ooooo`?oo`2I1oooool4ool0V@Gooooo0oo<0?l01?oooooo0?ooo`3oool0
ool2oc?o00?oo`000_lc0?l3ool000?o0?oo1Oooool3ool00005ool0VOo<0?ooc03ool`0ooooool0
0oo<o`02o`1Vo`?oc?l00oo<0?l3ooooo`04ool00?l0oooo0?ooooooo`?o0?oo0_ooool3ol`0o`?o
oooo0olco`000ooo003oooooooooo`0Hooooo`;ooiT0I?ooool3o`1Vo`Oooooo0_l0I_l8ooooo`Co
06Ko:_ooool2ool0V@Kooooo00?o0000ooooooooool04Oooool002;ooooo00?o0000ooooooooool0
0oooool3ool0V@;ooooo0ooo09T01Ooooooo0?ooo`3oool0ooooo`0000cooooo0olco`3oooooo`Go
oooo00?o0000ooooooooool02_ooool00ol0003oooooooooo`04ooooo`?o00000oooool3ool0V@Oo
oooo0ooo09T8ooooo`Coc03o00?oooooo`3ooooo00000ooo00001?oooooo<`3ooc<0oolc0?l2ool0
0004ooooool0oooo0?ooo`3oo`Gooooo0_oo00000oooooooo`2Iol`0o`03ol`0o`Koc?l00oo<0?l3
ooooo`05ool00?l0oooo0?ooo`3oooooool00_l0ool3ooooo`;oc03o0oooool3oc?o0003ool00?oo
oooooooo083ooooo0ol0I_l?ooooo`?o06Ko<_ooool3o`0001?ooooo000Rooooo`03o`000?oooooo
oooo00?ooooo0_oo09T2ooooo`?oo`2I00Goooooo`3oool0oooo0?ooool0000<ooooo`?o<ol0oooo
ool6ooooo`03o`000?oooooooooo00_ooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`03ooooo`;oo`2I00?o0?ooooooooooool00oooool4ool0V@[ooooo1?o<0?l4ool00003oc?o0?l0
oooooooo00?o<`3o0_oo00001?oooooo0?ooo`3oool0ool4ooooo`?oo`000_ooool4ol`0o`Coc?l0
0oo<0?l3ooooo`05ool00?l0oooo0?ooo`3oooooool00ol0ool2ooooo`?oc03o0_ooool3oc?o0003
ool00?oooooooooo08;ooooo0ol0I_l=ooooo`?o06Ko=Oooool00ol0003oooooooooo`0Aooooo`00
8_ooool00ol0003oooooooooo`06ooooo`?oo`2I00Koooooo`3oool0oooo0?ooool00?l0I_l<oooo
o`;o<ol0ooooool7ooooo`03o`000?oooooooooo00Sooooo00Go0000ooooooooooooooooo`000004
ooooo`03o`000?oooooooooo00?ooooo0_l0ool5ooooo`Coo`2I3Oooool01Oo<0?ooo`00ool00?oo
003ooooo00?o<ol000?o0?oooooooolc0?l00_lc0?l2ool00004ooooool0oooo0?ooo`3oo`Cooooo
0ooo0002ooooo`04ool0VOo<0?ooc03ool`0o`;oc?l00oo<0?l3ooooo`;oo`000_l0ool01?oooooo
0?ooo`3oool0ool3ooooo`;oc03o0_ooool01?lc0?oo<ol0oc?o0?oo0026ooooo`?o06Ko2oooool3
o`1VocKooooo00?o0000ooooooooool04Oooool002;ooooo00?o0000ooooooooool01Oooool3ool0
V@06ooooool0oooo0?ooo`3ooooo003o06Ko3?ooool3oc?o0?oooooo1oooool00ol0003ooooooooo
o`08ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`09ooooo`?oo`2I
3oooool3ool00003ol`0oooooooooooo00?o<ol00_l0ool3oc<0o`03ool00?oooooooooo00?o0?oo
1?ooool3ool000?ooooo1_o<0?l3ooooo`;oo`001_l0ool3ooooo`?oc03o0_lc0?l3oc?o0003ool0
0?oooooooooo08Gooooo0ol0I_l8ooooo`Co06Ko=oooool00ol0003oooooooooo`0Aooooo`008_oo
ool00ol0003oooooooooo`04ooooo`?oo`2I00Koooooo`3oool0oooo0?ooool00?l0I_l<ooooo`?o
<ol0ooooool8ooooo`03o`000?oooooooooo00Wooooo0ol00005ooooo`03o`000?oooooooooo00So
oooo0ooo09T?ooooo`?oo`000oo<0?l2ooooo`?o<ol00ol0ool2oc<0o`03ool00?oooooooooo00;o
0?oo1Oooool2ool000Cooooo1?o<0?l4ooooo`;oo`001Ol0ool3ooooo`?oc03o0_lc0?l3oc?o0003
ool00?oooooooooo08Oooooo0ol0I_l6ooooo`Co06Ko>?ooool00ol0003oooooooooo`0Aooooo`00
8_ooool2o`0000Cooooo0ooo09T01_oooooo0?ooo`3oool0ooooo`00o`1Vo`cooooo0olco`3ooooo
o`Sooooo0_l0000Cooooo`03o`000?oooooooooo00Kooooo1?oo09T>ooooo`Coo`000_ooool3ol`0
o`;ooooo0_lco`04o`3oo`;o<`3o0_ooool3o`3oo`Cooooo0ooo0004ooooo`;oc03o1?ooool2ool0
00Go0?oo1?ooool2ol`0o`;o<`3o0olco`000ooo003oooooooooo`29ooooo`?o06Ko1?ooool3o`1V
oc[ooooo00?o0000ooooooooool04Oooool002;ooooo00?o0000ooooooooool00oooool2ool0V@06
ooooool0oooo0?ooo`3ooooo003o06Ko3Oooool2oc?o0?oooooo2_ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo00Gooooo1?oo09T>ooooo`Coo`001?ooool3ol`0o`05oooooolco`3o
<ol0oc?o0?ooool01?l0ool00olc0?ooooooooooo`03o`3oo`Cooooo0ooo0008ooooo`;oo`001_l0
ool3ooooo`?oc03o0_lc0?l2oc?o0003ool00?oooooooooo08_ooooo0ol0I_l2ooooo`?o06Ko>ooo
ool00ol0003oooooooooo`0Aooooo`008_ooool00ol0003oooooooooo`05ooooo`?o0?oo00?oo`00
o`1Vooooool03?ooool3oc?o0?oooooo2_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooo
oooo00Cooooo0ooo09T?ooooo`?oo`001oooool3ol`0o`05oooooolco`3o<ol0oc?o0?ooool01Ol0
ool2ooooo`?o0?oo1?ooool3ool000Kooooo0ooo0005o`3oo`?ooooo0oo<0?l2oc<0o`?o<ol000?o
o`00ooooooooool0S?ooool6o`1Voccooooo00?o0000ooooooooool04Oooool002;ooooo00?o0000
ooooooooool01?ooool3o`3oo`03ool00?l0I_oo06Ko00cooooo0olco`3oooooo`_ooooo00?o0000
ooooooooool04Oooool00ol0003oooooooooo`03ooooo`?oo`2I3oooool3ool000Wooooo0oo<0?l0
1?oooooo<ol0oc?o0?lco`02ooooo`Go0?oo00Coooooo`3oool0oooo0?oo1?ooool3ool000Gooooo
0_oo0005o`3oo`Cooooo0_o<0?l2oc<0o`?o<ol000?oo`00ooooooooool0S_ooool4o`1Vocgooooo
00?o0000ooooooooool04Oooool002;ooooo00?o0000ooooooooool00oooool3o`3oo`03ool00?l0
I_oo06Ko00gooooo0_lco`3oooooo`cooooo00?o0000ooooooooool04Oooool00ol0003ooooooooo
o`03ooooo`;oo`2I3_ooool4ool000_ooooo0oo<0?l01?oooooo<ol0oc?o0?lco`02ooooo`03ool0
0?l0oooo0?oo00;o0?oo00Coooooo`3oool0oooo0?oo1?ooool2ool000Cooooo0_oo0005o`3oo`Co
oooo0oo<0?l01Olc0?oooooooc?o0?lco`3oo`0009;ooooo0_l0I_lnooooo`03o`000?oooooooooo
017ooooo000Rooooo`03o`000?oooooooooo00?ooooo0_l0ool00ooo003o06Koo`1Vo`0=ooooo`?o
<ol0ooooool<ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool04_ooool4ool000go
oooo0oo<0?l00ooooooo<ol0oc?o0003ooooo`03ool00?lc0?oo0?oo00Ko0?oo0oooool3ool000;o
oooo0ooo0004o`3oo`Gooooo0_o<0?l00olc0?oooooooc?o0002oc?o0=?ooooo00?o0000oooooooo
ool04Oooool002;ooooo00?o0000ooooooooool00oooool2ool000;o06Ko3Oooool3oc?o0?oooooo
3Oooool00ol0003oooooooooo`0Aooooo`;o00004_ooool3ool0013ooooo0oo<0?l3oc?o00;ooooo
0_oo00000olc0?oo0?ooo`3oo`05o`3oo`?ooooo1_oo0005o`3oo`Cooooo0oo<0?l01Ooooooo<ol0
oc?o0?lco`3oo`000=;ooooo0_l0000Cooooo`008_ooool2o`0000Cooooo0ol0I_l=ooooo`?o<ol0
ooooool=ooooo`;o00004oooool00ol0003oooooooooo`0@ooooo`?oo`004_ooool3ol`0o`?o<ol0
0_ooool2ool000;o<`3o1_l0ool3ooooo`Coo`001Ol0ool4ooooo`?oc03o00Gooooooc?o0?lco`3o
<ol0ool0003Dooooo`03o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooooooo00?ooooo
0_l0I_l>ooooo`;o<ol0ooooool?ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool0
3oooool3ool001Gooooo0_o<0?l3oc?o00;ooooo0_oo0003oc<0o`Go0?oo0oooool2ool00003oooo
ool0oooo0?oo00;o0?oo0oooool2oc<0o`;oc03o0_ooool2oc?o0003ool00?oooooooooo0=?ooooo
00?o0000ooooooooool04Oooool002;ooooo00?o0000ooooooooool04_ooool3oc?o0?oooooo3ooo
ool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00gooooo1?oo000Gooooo`;oc03o0olc
o`001?ooooooo`00ool00?oo0003oc<0o`Go0?oo1?ooool4o`3oo`?ooooo0_lc0?l3ol`0o`04oooo
oolco`3o<ol0oc?o0=Kooooo00?o0000ooooooooool04Oooool002;ooooo00?o0000ooooooooool0
4Oooool3oc?o0?oooooo4?ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00cooooo
1?oo000Iooooo`;oc03o0_lco`02ooooo`;oo`0000Gooooooc<0oolc0?oo<`3oooooo`04o`3oo`?o
oooo1?l0ool2ooooo`;o<`3o0oo<0?l01Ooooooo<ol0oc?o0?lco`3oo`000=Kooooo00?o0000oooo
ooooool04Oooool002;ooooo00?o0000ooooooooool04?ooool3oc?o0?oooooo4Oooool00ol0003o
ooooooooo`0Aooooo`03o`000?oooooooooo00_ooooo0ooo000Looooo`05ol`0oolco`3o<ol0oc?o
0?ooool00ooo00001?oooooo<`3ooc<0oolc0?l2ooooo`So0?oo0_ooool3oc<0o`;oc03o00Gooooo
oc?o0?lco`3o<ol0ool0003Gooooo`03o`000?oooooooooo017ooooo000Iooooo`Go00001?ooool0
0ol0003oooooooooo`0@ooooo`;o<ol0oooooolBooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool02_ooool3ool001kooooo00Goc03ooc?o0?lco`3o<ol0ooooo`03ool00004oooooolc
0?oo<`3ooc<0o`;ooooo1_l0ool2ooooo`?o<`3o0oo<0?l01?oooooo<ol0oc?o0?oo003Hooooo`03
o`000?oooooooooo017ooooo000Jooooo`04o`000?ooooooooooo`0000Cooooo00?o0000oooooooo
ool03oooool3oc?o0?oooooo4_ooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00So
oooo1?oo000Pooooo`05ol`0oolco`3o<ol0oc?o0?ooool00_oo0002ooooo`?o<`3o0_ooool4o`3o
o`;ooooo0olc0?l3ol`0o`04oooooolco`3o<ol0oc?o0=Wooooo00?o0000ooooooooool04Oooool0
01_ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0>ooooo`?o<ol0oooooolCoooo
o`03o`000?oooooooooo017ooooo00?o0000ooooooooool01oooool4ool002;ooooo00Coc03ooc?o
0?lco`3o<ol00ooo0002ooooo`?o<`3o0_ooool2o`3oo`;ooooo0olc0?l01?ooooooc03ool`0oooo
ool3oc?o0=[ooooo00?o0000ooooooooool04Oooool001cooooo00?o0000ooooooooool00oooool3
o`0000kooooo0_lco`3ooooooa;ooooo0ol0000Cooooo`03o`000?oooooooooo00Kooooo0ooo000U
ooooo`04ol`0oolco`3o<ol0ooooo`;oo`000oooool3oc<0o`Cooooo0olc0?l01Oooooooc03ool`0
ooo<0?oooooo00;o<ol000?oo`00ooooooooool0f?ooool00ol0003oooooooooo`0Aooooo`006Ooo
ool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool03Oooool3oc?o0?oooooo
5?ooool00ol0003oooooooooo`0Aooooo`;o00001_ooool3ool002Oooooo0olco`000oo<0?ooo`00
ool00003ooooo`?o<`3o0_ooool3oc<0o`;ooooo0_o<0?l01?oooooo<ol0oc?o0?lco`3Jooooo`;o
00004oooool001Wooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo00co
oooo0olco`3ooooooaGooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`04ooooo`?o
o`00:Oooool3oc?o0003ol`0oooo003oo`0000?ooooo1_lc0?l2ooooo`?oc03o0olco`3Looooo`03
o`000?oooooooooo017ooooo000Jooooo`?o00001Oooool00ol0003oooooooooo`0;ooooo`?o<ol0
oooooolFooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool00oooool3ool002_ooooo
0olco`000oo<0?ooo`00ooooo`03ooooo`Co<`3o0_ooool3ol`0o`?o<ol0gOooool00ol0003ooooo
ooooo`0Aooooo`008_ooool00ol0003oooooooooo`0;ooooo`;o<ol0oooooolGooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool00oooool2ool002gooooo0olco`000oo<0?ooo`00oooo
o`03ooooo`;o<`3o0oooool2ol`0o`04oooooolco`3o<ol0ool00=gooooo00?o0000ooooooooool0
4Oooool002;ooooo00?o0000ooooooooool02_ooool3oc?o0?oooooo5oooool00ol0003ooooooooo
o`0Aooooo`03o`000?oooooooooo03?ooooo0_lco`02ol`0o`Sooooo0oo<0?l3oc?o0=kooooo00?o
0000ooooooooool04Oooool002;ooooo00?o0000ooooooooool02Oooool3oc?o0?oooooo6?ooool0
0ol0003oooooooooo`0Aooooo`03o`000?oooooooooo03?ooooo0olco`02ol`0o`Kooooo0oo<0?l3
oc?o0=oooooo00?o0000ooooooooool04Oooool002;ooooo0_l00009ooooo`?o<ol0oooooolHoooo
o`;o00004oooool00ol0003oooooooooo`0dooooo`?o<ol00_o<0?l5ooooo`;oc03o0olco`3Poooo
o`03o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooooooo00Sooooo0_lco`3ooooooa[o
oooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`0eooooo`?o<ol00_o<0?l3ooooo`?o
c03o0_lco`000ooo003oooooooooo`3Nooooo`03o`000?oooooooooo017ooooo000Rooooo`03o`00
0?oooooooooo00Oooooo0olco`3ooooooa[ooooo00?o0000ooooooooool04Oooool00ol0003ooooo
ooooo`0fooooo`?o<ol00_o<0?l2ooooo`;oc03o0olco`3Qooooo`03o`000?oooooooooo017ooooo
000Rooooo`03o`000?oooooooooo00Kooooo0olco`3ooooooa_ooooo00?o0000ooooooooool04Ooo
ool00ol0003oooooooooo`0gooooo`;o<ol01Oo<0?l3oc?o0>;ooooo00?o0000ooooooooool04Ooo
ool002;ooooo00?o0000ooooooooool01_ooool2oc?o0?oooooo7?ooool00ol0003oooooooooo`0A
ooooo`03o`000?oooooooooo03Oooooo0olco`04ol`0o`;o<ol0hoooool00ol0003oooooooooo`0A
ooooo`008_ooool00ol0003oooooooooo`05ooooo`?o<ol0oooooolLooooo`03o`000?oooooooooo
017ooooo0_l0000iooooo`?o<ol00_o<0?l3oc?o0>;ooooo0_l0000Cooooo`008_ooool00ol0003o
ooooooooo`04ooooo`?o<ol0oooooolMooooo`03o`000?oooooooooo017ooooo00?o0000oooooooo
ool0>Oooool6oc?o0>Cooooo00?o0000ooooooooool04Oooool002;ooooo0_l00004ooooo`?o<ol0
oooooolMooooo`;o00004oooool00ol0003oooooooooo`0jooooo`Co<ol0iOooool00ol0003ooooo
ooooo`0Aooooo`008_ooool00ol0003oooooooooo`03ooooo`;o<ol0oooooolOooooo`03o`000?oo
oooooooo017ooooo00?o0000ooooooooool0>oooool2oc?o0>Kooooo00?o0000ooooooooool04Ooo
ool002;ooooo00?o0000ooooooooool0oooooolTooooo`03o`000?oooooooooo017ooooo00?o0000
ooooooooool0oooooolTooooo`03o`000?oooooooooo017ooooo000Rooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo
03Gooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo
00Cooooo00?o0000ooooooooool04Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
03Gooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`0eooooo`03o`000?oooooooooo
03Gooooo00?o0000ooooooooool0=Oooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
017ooooo000Rooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`04ooooo`03o`000?oooooooooo017ooooo00?o0000ooooooooool01?ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`09ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02Oooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Sooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool02?ooool00ol0003o
ooooooooo`08ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool04Oooool002;ooooo
ool0000Xo`0001?oooooool0000Xo`0001?ooooo003oooooooooooooV?ooool00?oooooooooooonH
ooooo`00oooooooooooooiSooooo003oooooooooooooV?ooool00001\
\>"],
  ImageRangeCache->{{{0, 661.75}, {203.812, 0}} -> {-0.0535214, -0.0154541, \
0.00318405, 0.00318405}, {{16.75, 330.875}, {198.938, 4.8125}} -> {-0.747016, \
-2.8961, 0.0178815, 0.0272195}, {{330.875, 644.938}, {198.938, 4.8125}} -> \
{-6.36349, -5.6307, 0.0178815, 0.047563}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  GraphicsArray  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ML-Sch\[ADoubleDot]tzung", "Subsection",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \({n, T, Deltat}\)], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({500, 5, 0.5`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(Dimensions[Y]\), "\n", 
    \(Dimensions[X]\)}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({500, 6}\)], "Output"],

Cell[BoxData[
    \({500, 1}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(Z = AppendRows[Y, X];\)\)], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(Dimensions[Z]\)], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({500, 7}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(M = Transpose[Z] . Z\/n;\)\)], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[
    \(MatrixForm[M]\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7"},
              {"1", "1.0349592444731668`", 
                "0.14693703616088843`", \(-0.15069618913137356`\), \
\(-0.003442931381295343`\), "0.020178428302338257`", "0.01075725560623585`", 
                "0.011149805299741185`"},
              {"2", "0.14693703616088843`", 
                "0.057816751393425375`", \(-0.012473031055030405`\), \
\(-0.001944253294077539`\), "0.007933857613291448`", "0.007504583622953189`", 
                "0.05789458307015081`"},
              {"3", \(-0.15069618913137356`\), \(-0.012473031055030405`\), 
                "0.05665117996102216`", 
                "0.008948265661868614`", \(-0.0009335996307154611`\), 
                "0.004189734036527467`", "0.07032166022400647`"},
              {"4", \(-0.003442931381295343`\), \(-0.001944253294077539`\), 
                "0.008948265661868614`", "0.03532108595256068`", 
                "0.010996007555891573`", \(-0.0009885864655822785`\), 
                "0.0716584549154854`"},
              {"5", "0.020178428302338257`", 
                "0.007933857613291448`", \(-0.0009335996307154611`\), 
                "0.010996007555891573`", "0.03749982916064589`", 
                "0.008287803425197247`", "0.07452636396150014`"},
              {"6", "0.01075725560623585`", "0.007504583622953189`", 
                "0.004189734036527467`", \(-0.0009885864655822785`\), 
                "0.008287803425197247`", "0.03345644298189694`", 
                "0.06963359093499422`"},
              {"7", "0.011149805299741185`", "0.05789458307015081`", 
                "0.07032166022400647`", "0.0716584549154854`", 
                "0.07452636396150014`", "0.06963359093499422`", "1.`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plus @@ Z/n\)], "Input"],

Cell[BoxData[
    \({0.011149805299741185`, 0.05789458307015081`, 0.07032166022400647`, 
      0.0716584549154854`, 0.07452636396150014`, 0.06963359093499422`, 
      1}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(m = Transpose[Z] . Shape[1, n]\/n\)], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({0.0111498052997412`, 0.0578945830701508`, 0.0703216602240064`, 
      0.07165845491548538`, 0.07452636396150021`, 0.06963359093499423`, 
      1.`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(S = M - Outer[Times, m, m]\), "\n", 
    \(MatrixForm[S]\), "\n", 
    \(Eigenvalues[S]\)}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{1.0348349263149446`, 
        0.14629152283174657`, \(-0.1514802619512258`\), \
\(-0.0042419092016832876`\), 0.01934747385446988`, 
        0.009980854624988841`, \(-1.3877787807814457`*^-17\)}, \
{0.14629152283174657`, 
        0.054464968644558784`, \(-0.016544274254500065`\), \
\(-0.0060928896648607634`\), 0.0036191848440060813`, 0.003473175908094265`, 
        6.938893903907228`*^-18}, {\(-0.1514802619512258`\), \
\(-0.016544274254500065`\), 0.05170604406436156`, 
        0.003909124143124569`, \(-0.0061744172749467145`\), \
\(-0.000707015685380649`\), 
        6.938893903907228`*^-17}, {\(-0.0042419092016832876`\), \
\(-0.0060928896648607634`\), 0.003909124143124569`, 0.030186151791686027`, 
        0.0056555634639413556`, \(-0.005978422002200914`\), 
        2.7755575615628914`*^-17}, {0.01934747385446988`, 
        0.0036191848440060813`, \(-0.0061744172749467145`\), 
        0.0056555634639413556`, 0.03194565023532389`, 
        0.0030982650832296456`, \(-6.938893903907228`*^-17\)}, \
{0.009980854624988841`, 
        0.003473175908094265`, \(-0.000707015685380649`\), \
\(-0.005978422002200914`\), 0.0030982650832296456`, 
        0.02860760599539483`, \(-1.3877787807814457`*^-17\)}, \
{\(-1.3877787807814457`*^-17\), 6.938893903907228`*^-18, 
        6.938893903907228`*^-17, 
        2.7755575615628914`*^-17, \(-6.938893903907228`*^-17\), \
\(-1.3877787807814457`*^-17\), 0.`}}\)], "Output"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7"},
              {"1", "1.0348349263149446`", 
                "0.14629152283174657`", \(-0.1514802619512258`\), \
\(-0.0042419092016832876`\), "0.01934747385446988`", 
                "0.009980854624988841`", \(-1.3877787807814457`*^-17\)},
              {"2", "0.14629152283174657`", 
                "0.054464968644558784`", \(-0.016544274254500065`\), \
\(-0.0060928896648607634`\), "0.0036191848440060813`", 
                "0.003473175908094265`", "6.938893903907228`*^-18"},
              {"3", \(-0.1514802619512258`\), \(-0.016544274254500065`\), 
                "0.05170604406436156`", 
                "0.003909124143124569`", \(-0.0061744172749467145`\), \
\(-0.000707015685380649`\), "6.938893903907228`*^-17"},
              {"4", \(-0.0042419092016832876`\), \(-0.0060928896648607634`\), 
                "0.003909124143124569`", "0.030186151791686027`", 
                "0.0056555634639413556`", \(-0.005978422002200914`\), 
                "2.7755575615628914`*^-17"},
              {"5", "0.01934747385446988`", 
                "0.0036191848440060813`", \(-0.0061744172749467145`\), 
                "0.0056555634639413556`", "0.03194565023532389`", 
                "0.0030982650832296456`", \(-6.938893903907228`*^-17\)},
              {"6", "0.009980854624988841`", 
                "0.003473175908094265`", \(-0.000707015685380649`\), \
\(-0.005978422002200914`\), "0.0030982650832296456`", 
                "0.02860760599539483`", \(-1.3877787807814457`*^-17\)},
              {"7", \(-1.3877787807814457`*^-17\), "6.938893903907228`*^-18", 
                "6.938893903907228`*^-17", 
                "2.7755575615628914`*^-17", \(-6.938893903907228`*^-17\), \
\(-1.3877787807814457`*^-17\), "0.`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"],

Cell[BoxData[
    \({1.0793065631502832`, 0.04088988411112978`, 0.03436398060358806`, 
      0.033992106812190954`, 0.026227166646169354`, 
      0.016965645722908682`, \(-3.1345005464416672`*^-31\)}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(?? Lik\)], "Input",
  PageWidth->Infinity],

Cell["Global`Lik", "Print",
  CellTags->"Info3411478494-5284832"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {\(Attributes[Lik] = {Protected}\)},
          {" "},
          {GridBox[{
                {\(Lik[data_, Theta_, {system_, LikN_}, misc_] := 
                    Plus @@ \(\((LikN[#1, Theta\ SCALING, system, misc] &)\) /@ 
                        data\)\)}
                },
              GridBaseline->{Baseline, {1, 1}},
              ColumnWidths->0.999,
              ColumnAlignments->{Left}]}
          },
        GridBaseline->{Baseline, {1, 1}},
        ColumnAlignments->{Left}],
      Definition[ "Lik"],
      Editable->False]], "Print",
  CellTags->"Info3411478494-5284832"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Lik[{{S, m, n, Deterministisch}}, 
      Theta, {{SystemEDMdet, {Deltat, T}}, LISRELlik}, {True, 1}]\)], "Input",\

  PageWidth->Infinity],

Cell[BoxData[
    \(2887.7236043713515`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(LISRELlik[{S, m, n, Deterministisch}, 
      Theta, {SystemEDMdet, {Deltat, T}}, {True, 1}]\)], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(2887.7236043713515`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(LISRELlik[{S, m, n, Deterministisch}, 
      Theta, {SystemEDMdet, {Deltat, T}}, {False, 1}]\)], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(2887.7236043713524`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(ETA // Dimensions\)\(\[IndentingNewLine]\)
    \)\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({500, 12}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(THETA0 = Theta\), "\n", 
    \(F0 = IdentityMatrix[Length[THETA0]]\), "\n", 
    \(SCALING\), "\n", 
    \(FISHER = True\), "\n", 
    \(MAXSTEP = 10\), "\n", 
    \(STEPREDUCE = 4\)}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({16, 4, 1, 2, 0, 0, 1, 0, 1}\)], "Output"],

Cell[BoxData[
    \({{1, 0, 0, 0, 0, 0, 0, 0, 0}, {0, 1, 0, 0, 0, 0, 0, 0, 0}, {0, 0, 1, 0, 
        0, 0, 0, 0, 0}, {0, 0, 0, 1, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 1, 0, 0, 0, 
        0}, {0, 0, 0, 0, 0, 1, 0, 0, 0}, {0, 0, 0, 0, 0, 0, 1, 0, 0}, {0, 0, 
        0, 0, 0, 0, 0, 1, 0}, {0, 0, 0, 0, 0, 0, 0, 0, 1}}\)], "Output"],

Cell[BoxData[
    \(1\)], "Output"],

Cell[BoxData[
    \(True\)], "Output"],

Cell[BoxData[
    \(10\)], "Output"],

Cell[BoxData[
    \(4\)], "Output"]
}, Open  ]],

Cell[TextData[StyleBox["Math5.0 / OS X",
  FontColor->RGBColor[1, 0, 0]]], "Text",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[
    \(\({THETA, COV, LIKI, psii, scoreii, k, 
          ReturnCode} = \[IndentingNewLine]BFGS[{{S, m, n, 
              Deterministisch}}, {THETA0, 
            F0}, \ \[IndentingNewLine]\t\ \ {{SystemEDMdet, {Deltat, 
                T}}, {Lik, LISRELlik, Score, 
              Hesse}}, \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ {{Sing = 
                False, 1}, 
            KMAX = 300, {EPS1 =  .0001, 
              EPS2 =  .0001}, \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ OPTION \
= 0, PRINT = {1, 1, 1, 1, 1, 1, 1, 1, 1}}];\)\)], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \("***********************LSDE1**********************************"\)], \
"Print"],

Cell[BoxData[
    \("***********************MODUL:    BFGS (skeleton)**************"\)], \
"Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    \("Technical Output"\)], "Print"],

Cell[BoxData[
    \(LISRELlik\)], "Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"KMAX\"\>", "\<\"EPS1\"\>", "\<\"EPS2\"\>", "\<\"K\
\"\>", "\<\"Q\"\>", "\<\"n\"\>", "\<\"T\"\>", "\<\"OPTION    \"\>"},
          {"1", "300", "0.0001`", "0.0001`", "K$26915", "Q$26915", "500", "5",
             "0"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"KMAX", "EPS1", "EPS2", "K",
           "Q", "n", "T", "OPTION    "}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"MAXSTEP\"\>", "\<\"MINSTEP\"\>", "\<\"BOUND\"\>", \
"\<\"STEPREDUCE\"\>", "\<\"FMAX\"\>"},
          {"1", "10", "1.`*^-10", "1.`*^-6", "4", "1000"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"MAXSTEP", "MINSTEP", 
          "BOUND", "STEPREDUCE", "FMAX"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"RESAMPLING\"\>", "\<\"FDIGITS\"\>", \
"\<\"TYP\"\>", "\<\"YMAX\"\>", "\<\"ANALGRAD\"\>", "\<\"FACTOR\"\>", \
"\<\"CSEED\"\>"},
          {"1", "True", "16", "1", "1000.`", "False", "1.`", \(-999\)}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"RESAMPLING", "FDIGITS", 
          "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}}, TableDirections -> {
          Column, Row}, TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \("    SCALING"\)], "Print"],

Cell[BoxData[
    RowBox[{\(Transpose::"nmtx"\), \(\(:\)\(\ \)\), "\<\"The first two levels \
of the one-dimensional list \\!\\({}\\) cannot be transposed. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Transpose::nmtx\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    TagBox[\(Transpose[{}]\),
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
          0]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("STARTWERT THETA0 = "\[InvisibleSpace]{16, 4, 1, 2, 
          0, 0, 1, 0, 1}\),
      SequenceForm[ "STARTWERT THETA0 = ", {16, 4, 1, 2, 0, 0, 1, 0, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.384185791015625`*^-7, 5.960464477539063`*^-8, 
          1.4901161193847656`*^-8, 2.9802322387695312`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.384185791015625*^-07, 5.9604644775390625*^-08, 
        1.4901161193847656*^-08, 2.9802322387695312*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({{6.0974578857421875`, 8.623878479003906`, 
        29.313507080078125`, \(-40.205963134765625`\), 5.574920654296875`, 
        5.65374755859375`, 
        17.479644775390625`, \(-17.899993896484375`\), \(-10.474609375`\)}, 
      2887.7236043713524`}\)], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]1\),
      SequenceForm[ "BFGS: Iteration = ", 1],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"-21496.703887168570000\"\>",
            -21496.703887168569,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2887.723604371353000\"\>",
            2887.7236043713524,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -21496.703887168569, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2887.7236043713524, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2402.409773846528000\"\>",
            2402.409773846528,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2887.723604371353000\"\>",
            2887.7236043713524,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2402.409773846528, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2887.7236043713524, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2878.971234419284000\"\>",
            2878.971234419284,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2887.723604371353000\"\>",
            2887.7236043713524,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2878.971234419284, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2887.7236043713524, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749803058627000\"\>",
            2889.7498030586271,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2887.723604371353000\"\>",
            2887.7236043713524,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 2889.7498030586271, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2887.7236043713524, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749803058627000\"\>",
            2889.7498030586271,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2889.7498030586271, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2887.723604371353000\"\>",
            2887.7236043713524,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2887.7236043713524, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     2.026198687274700\"\>",
            2.0261986872747002,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 2.0261986872747002, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0060\"\>",
                16.005924045342812,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0000\"\>",
                16,
                Editable->False], 
              InterpretationBox["\<\" 0.0059\"\>",
                0.0059240453428126205,
                AutoDelete->True], 
              InterpretationBox["\<\" 6.0975\"\>",
                6.0974578857421875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0084\"\>",
                4.0083786141860829,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.0084\"\>",
                0.0083786141860833149,
                AutoDelete->True], 
              InterpretationBox["\<\" 8.6239\"\>",
                8.6238784790039062,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0285\"\>",
                1.0284798268972553,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 0.0285\"\>",
                0.028479826897255266,
                AutoDelete->True], 
              InterpretationBox["\<\" 29.3140\"\>",
                29.313507080078125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9609\"\>",
                1.9609375,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\"-0.0391\"\>",
                -0.0390625,
                AutoDelete->True], 
              InterpretationBox["\<\"-40.2060\"\>",
                -40.205963134765625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0054\"\>",
                0.0054163691422720386,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0054\"\>",
                0.0054163691422720386,
                AutoDelete->True], 
              InterpretationBox["\<\" 5.5749\"\>",
                5.574920654296875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\" 0.0055\"\>",
                0.0054929541985428119,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0055\"\>",
                0.0054929541985428119,
                AutoDelete->True], 
              InterpretationBox["\<\" 5.6537\"\>",
                5.65374755859375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0170\"\>",
                1.0169825212680526,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 0.0170\"\>",
                0.016982521268052608,
                AutoDelete->True], 
              InterpretationBox["\<\" 17.4800\"\>",
                17.479644775390625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0174\"\>",
                -0.017390915602188743,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0174\"\>",
                -0.017390915602188743,
                AutoDelete->True], 
              InterpretationBox["\<\"-17.9000\"\>",
                -17.899993896484375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9898\"\>",
                0.98982328995976376,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.0102\"\>",
                -0.010176710040236242,
                AutoDelete->True], 
              InterpretationBox["\<\"-10.4750\"\>",
                -10.474609375,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.385068542561354`*^-7, 5.97294958559585`*^-8, 
          1.5325543685216535`*^-8, 2.922024577856064`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.5154220480740853`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3850685425613541*^-07, 5.9729495855958505*^-08, 
        1.5325543685216535*^-08, 2.9220245778560638*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5154220480740853*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]9.230222683577084`*^-7\),
      SequenceForm[ "NOISE  ", 9.2302226835770835*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.3907805011635069`\
\[InvisibleSpace]"  "\[InvisibleSpace]312.8715411041051`\),
      SequenceForm[ 
      "*BFGSUP ", 0.39078050116350688, "  ", 312.87154110410512],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.02010494698886006`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.020104946988860058, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]2\),
      SequenceForm[ "BFGS: Iteration = ", 2],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  1689.099421960314000\"\>",
            1689.0994219603135,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749803058627000\"\>",
            2889.7498030586271,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 1689.0994219603135, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2889.7498030586271, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2815.683744530564000\"\>",
            2815.6837445305637,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749803058627000\"\>",
            2889.7498030586271,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2815.6837445305637, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2889.7498030586271, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.235856226974000\"\>",
            2889.2358562269737,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749803058627000\"\>",
            2889.7498030586271,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2889.2358562269737, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2889.7498030586271, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820523057487000\"\>",
            2890.8205230574868,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749803058627000\"\>",
            2889.7498030586271,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 2890.8205230574868, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2889.7498030586271, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820523057487000\"\>",
            2890.8205230574868,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2890.8205230574868, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749803058627000\"\>",
            2889.7498030586271,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2889.7498030586271, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     1.070719998859659\"\>",
            1.0707199988596585,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 1.0707199988596585, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0130\"\>",
                16.012511305691792,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0060\"\>",
                16.005924045342812,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0066\"\>",
                0.0065872603489787627,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.6298\"\>",
                3.6297977197053579,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0024\"\>",
                4.0024138662853179,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0084\"\>",
                4.0083786141860829,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0060\"\>",
                -0.0059647479007648658,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.7255\"\>",
                -3.7254956327314455,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0675\"\>",
                1.0675423268972553,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0285\"\>",
                1.0284798268972553,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0391\"\>",
                0.039062499999999993,
                AutoDelete->True], 
              InterpretationBox["\<\" 21.7370\"\>",
                21.737012741423332,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9694\"\>",
                1.9693948662502174,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9609\"\>",
                1.9609375,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0085\"\>",
                0.0084573662502174275,
                AutoDelete->True], 
              InterpretationBox["\<\" 6.1501\"\>",
                6.1501182768924298,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0106\"\>",
                0.010594761159039894,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0054\"\>",
                0.0054163691422720386,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0052\"\>",
                0.0051783920167678549,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.8292\"\>",
                2.8292236328125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\" 0.0116\"\>",
                0.011591023430867316,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0055\"\>",
                0.0054929541985428119,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0061\"\>",
                0.0060980692323245045,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.3600\"\>",
                3.359954833984375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0180\"\>",
                1.0179550424350348,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0170\"\>",
                1.0169825212680526,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0010\"\>",
                0.00097252116698216622,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0217\"\>",
                0.02166575230690955,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0456\"\>",
                -0.045617902955044073,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0174\"\>",
                -0.017390915602188743,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0282\"\>",
                -0.02822698735285533,
                AutoDelete->True], 
              InterpretationBox["\<\"-15.8090\"\>",
                -15.8092041015625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9804\"\>",
                0.98035097459244869,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9898\"\>",
                0.98982328995976376,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0095\"\>",
                -0.0094723153673150293,
                AutoDelete->True], 
              InterpretationBox["\<\"-5.1666\"\>",
                -5.1666259765625,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.386050120844214`*^-7, 5.964061418600854`*^-8, 
          1.590762029435121`*^-8, 2.9346270356330535`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.5168712175414484`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3860501208442139*^-07, 5.9640614186008542*^-08, 
        1.5907620294351209*^-08, 2.9346270356330535*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5168712175414484*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.7317118219823884`*^-7\),
      SequenceForm[ "NOISE  ", 4.7317118219823884*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.2316238625521767`\
\[InvisibleSpace]"  "\[InvisibleSpace]504.40226552904835`\),
      SequenceForm[ "*BFGSUP ", 1.2316238625521767, "  ", 504.40226552904835],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.015567306396027153`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.015567306396027153, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]3\),
      SequenceForm[ "BFGS: Iteration = ", 3],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   787.592986889642100\"\>",
            787.59298688964213,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820523057487000\"\>",
            2890.8205230574868,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 787.59298688964213, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.8205230574868, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2592.203688623503000\"\>",
            2592.2036886235032,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820523057487000\"\>",
            2890.8205230574868,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2592.2036886235032, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.8205230574868, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2883.781363734600000\"\>",
            2883.7813637345998,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820523057487000\"\>",
            2890.8205230574868,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2883.7813637345998, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.8205230574868, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913622028648000\"\>",
            2890.9136220286482,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820523057487000\"\>",
            2890.8205230574868,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 2890.9136220286482, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.8205230574868, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913622028648000\"\>",
            2890.9136220286482,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2890.9136220286482, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820523057487000\"\>",
            2890.8205230574868,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2890.8205230574868, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.093098971161453\"\>",
            0.093098971161452937,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.093098971161452937, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0210\"\>",
                16.020921124825009,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0130\"\>",
                16.012511305691792,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0084\"\>",
                0.008409819133217214,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.8104\"\>",
                2.810445404798116,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0249\"\>",
                4.0248682358431989,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0024\"\>",
                4.0024138662853179,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0225\"\>",
                0.02245436955788091,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.7433\"\>",
                3.743293110729268,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0741\"\>",
                1.0741460123305808,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0675\"\>",
                1.0675423268972553,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0066\"\>",
                0.0066036854333255436,
                AutoDelete->True], 
              InterpretationBox["\<\" 9.5837\"\>",
                9.5836546930983371,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9696\"\>",
                1.9695737460811247,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9694\"\>",
                1.9693948662502174,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0002\"\>",
                0.00017887983090733849,
                AutoDelete->True], 
              InterpretationBox["\<\"-4.8748\"\>",
                -4.8747983436712632,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0026\"\>",
                0.002615981896916194,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0106\"\>",
                0.010594761159039894,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0080\"\>",
                -0.0079787792621236996,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.2707\"\>",
                0.27069091796875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\" 0.0013\"\>",
                0.0013249922630407859,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0116\"\>",
                0.011591023430867316,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0103\"\>",
                -0.010266031167826531,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0638\"\>",
                0.063751220703125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 0.9912\"\>",
                0.99119845027219478,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0180\"\>",
                1.0179550424350348,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0268\"\>",
                -0.026756592162840005,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.1112\"\>",
                -1.1111827006597035,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0758\"\>",
                -0.07576315709063984,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0456\"\>",
                -0.045617902955044073,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0301\"\>",
                -0.030145254135595771,
                AutoDelete->True], 
              InterpretationBox["\<\"-10.0170\"\>",
                -10.0169677734375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9591\"\>",
                0.95906584352548274,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9804\"\>",
                0.98035097459244869,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0213\"\>",
                -0.021285131066965939,
                AutoDelete->True], 
              InterpretationBox["\<\"-5.5827\"\>",
                -5.582733154296875,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3873032815493656`*^-7, 5.997521036629675`*^-8, 
          1.6006022875466657`*^-8, 2.9348935873525212`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3873032815493656*^-07, 5.9975210366296751*^-08, 
        1.6006022875466657*^-08, 2.9348935873525212*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]5.428191798273474`*^-7\),
      SequenceForm[ "NOISE  ", 5.428191798273474*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.9346357507186125`\
\[InvisibleSpace]"  "\[InvisibleSpace]414.36384798525427`\),
      SequenceForm[ 
      "*BFGSUP ", 0.93463575071861249, "  ", 414.36384798525427],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00993999146820461`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0099399914682046092, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]4\),
      SequenceForm[ "BFGS: Iteration = ", 4],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2400.737927503424000\"\>",
            2400.7379275034236,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913622028648000\"\>",
            2890.9136220286482,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2400.7379275034236, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.9136220286482, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2834.374014782661000\"\>",
            2834.3740147826611,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913622028648000\"\>",
            2890.9136220286482,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2834.3740147826611, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.9136220286482, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2888.114664141198000\"\>",
            2888.1146641411979,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913622028648000\"\>",
            2890.9136220286482,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2888.1146641411979, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.9136220286482, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144611648688000\"\>",
            2891.1446116486877,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913622028648000\"\>",
            2890.9136220286482,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 2891.1446116486877, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.9136220286482, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144611648688000\"\>",
            2891.1446116486877,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.1446116486877, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913622028648000\"\>",
            2890.9136220286482,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2890.9136220286482, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.230989620039509\"\>",
            0.23098962003950874,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.23098962003950874, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0320\"\>",
                16.032007608474412,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0210\"\>",
                16.020921124825009,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.01108648364940547,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.7936\"\>",
                1.7936332445800691,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0603\"\>",
                4.0603236250627788,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0249\"\>",
                4.0248682358431989,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0355\"\>",
                0.035455389219579581,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.6408\"\>",
                -0.64079913402129152,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0686\"\>",
                1.0685992654502745,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0741\"\>",
                1.0741460123305808,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0055\"\>",
                -0.0055467468803063018,
                AutoDelete->True], 
              InterpretationBox["\<\" 8.5411\"\>",
                8.5410896992491274,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9864\"\>",
                1.9863950669317847,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9696\"\>",
                1.9695737460811247,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0168\"\>",
                0.016821320850659988,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.1596\"\>",
                4.1596403902928172,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\"-0.0052\"\>",
                -0.0051878269141856972,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0026\"\>",
                0.002615981896916194,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0078\"\>",
                -0.0078038088111018911,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.4731\"\>",
                4.473052978515625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0170\"\>",
                -0.01700265082362238,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0013\"\>",
                0.0013249922630407859,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0183\"\>",
                -0.018327643086663164,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.7008\"\>",
                1.700775146484375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0021\"\>",
                1.0020581425710153,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9912\"\>",
                0.99119845027219478,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0109\"\>",
                0.010859692298820563,
                AutoDelete->True], 
              InterpretationBox["\<\" 26.4110\"\>",
                26.4110107421875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.1142\"\>",
                -0.11424695300862958,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0758\"\>",
                -0.07576315709063984,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0385\"\>",
                -0.038483795917989748,
                AutoDelete->True], 
              InterpretationBox["\<\"-6.6759\"\>",
                -6.675872802734375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9297\"\>",
                0.92972896684886908,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9591\"\>",
                0.95906584352548274,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0293\"\>",
                -0.02933687667661361,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.2837\"\>",
                -2.283721923828125,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.388955296348693`*^-7, 6.050353683624832`*^-8, 
          1.592336990610174`*^-8, 2.9599593087014328`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4931829908058276`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3889552963486928*^-07, 6.050353683624832*^-08, 
        1.5923369906101741*^-08, 2.9599593087014328*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4931829908058276*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]6.177140115792652`*^-7\),
      SequenceForm[ "NOISE  ", 6.1771401157926522*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.513146910237597`\
\[InvisibleSpace]"  "\[InvisibleSpace]453.57236727223517`\),
      SequenceForm[ "*BFGSUP ", 1.513146910237597, "  ", 453.57236727223517],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.008980205841610668`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0089802058416106681, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]5\),
      SequenceForm[ "BFGS: Iteration = ", 5],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2672.662300888521000\"\>",
            2672.6623008885213,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144611648688000\"\>",
            2891.1446116486877,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2672.6623008885213, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1446116486877, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2879.229930588415000\"\>",
            2879.2299305884148,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144611648688000\"\>",
            2891.1446116486877,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2879.2299305884148, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1446116486877, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.612499343803000\"\>",
            2890.6124993438025,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144611648688000\"\>",
            2891.1446116486877,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2890.6124993438025, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1446116486877, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161908042212000\"\>",
            2891.1619080422124,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144611648688000\"\>",
            2891.1446116486877,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 2891.1619080422124, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1446116486877, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161908042212000\"\>",
            2891.1619080422124,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.1619080422124, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144611648688000\"\>",
            2891.1446116486877,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.1446116486877, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.017296393524703\"\>",
            0.01729639352470258,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.01729639352470258, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0360\"\>",
                16.036081510890238,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0320\"\>",
                16.032007608474412,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0041\"\>",
                0.004073902415824635,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.6195\"\>",
                1.6194524331902664,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0691\"\>",
                4.0690888165707575,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0603\"\>",
                4.0603236250627788,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0088\"\>",
                0.0087651915079787479,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.7223\"\>",
                -3.7223442057298919,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0664\"\>",
                1.0663801671173636,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0686\"\>",
                1.0685992654502745,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0022\"\>",
                -0.0022190983329109962,
                AutoDelete->True], 
              InterpretationBox["\<\" 11.6330\"\>",
                11.632842703415838,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9896\"\>",
                1.9896289026644483,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9864\"\>",
                1.9863950669317847,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0032\"\>",
                0.0032338357326636277,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.5966\"\>",
                -0.59661829040725689,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0078\"\>",
                0.0077747072802436552,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0052\"\>",
                -0.0051878269141856972,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0130\"\>",
                0.012962534194429352,
                AutoDelete->True], 
              InterpretationBox["\<\" 8.7775\"\>",
                8.777496337890625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0150\"\>",
                -0.01503755521135783,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0170\"\>",
                -0.01700265082362238,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0020\"\>",
                0.0019650956122645499,
                AutoDelete->True], 
              InterpretationBox["\<\" 5.6328\"\>",
                5.6328125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0013\"\>",
                1.0012617974596063,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0021\"\>",
                1.0020581425710153,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0008\"\>",
                -0.0007963451114090563,
                AutoDelete->True], 
              InterpretationBox["\<\" 15.0430\"\>",
                15.043074851779831,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.1176\"\>",
                -0.11758516344185517,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1142\"\>",
                -0.11424695300862958,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0033\"\>",
                -0.0033382104332255868,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.0903\"\>",
                -3.09033203125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9262\"\>",
                0.92620310890457058,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9297\"\>",
                0.92972896684886908,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0035\"\>",
                -0.0035258579442984644,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.6285\"\>",
                0.6285400390625,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.389562355114555`*^-7, 6.063414836780366`*^-8, 
          1.5890302764138037`*^-8, 2.9647780994541172`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4919963441187237`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.389562355114555*^-07, 6.0634148367803655*^-08, 
        1.5890302764138037*^-08, 2.9647780994541172*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4919963441187237*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.583070139657695`*^-7\),
      SequenceForm[ "NOISE  ", 4.5830701396576949*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]10.015073380984672`\
\[InvisibleSpace]"  "\[InvisibleSpace]3809.8179290845574`\),
      SequenceForm[ "*BFGSUP ", 10.015073380984672, "  ", 3809.8179290845574],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.010114675342517358`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.010114675342517358, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]6\),
      SequenceForm[ "BFGS: Iteration = ", 6],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2886.605217726674000\"\>",
            2886.6052177266743,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161908042212000\"\>",
            2891.1619080422124,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2886.6052177266743, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1619080422124, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.002202721976000\"\>",
            2891.0022027219752,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161908042212000\"\>",
            2891.1619080422124,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2891.0022027219752, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1619080422124, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187317351246000\"\>",
            2891.1873173512458,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161908042212000\"\>",
            2891.1619080422124,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2891.1873173512458, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1619080422124, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187317351246000\"\>",
            2891.1873173512458,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.1873173512458, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161908042212000\"\>",
            2891.1619080422124,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.1619080422124, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.025409309033421\"\>",
            0.025409309033420868,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.025409309033420868, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0520\"\>",
                16.052103637073838,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0360\"\>",
                16.036081510890238,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0160\"\>",
                0.016022126183601056,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.8236\"\>",
                1.8235853966345035,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0780\"\>",
                4.0780434060250217,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0691\"\>",
                4.0690888165707575,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0090\"\>",
                0.0089545894542646092,
                AutoDelete->True], 
              InterpretationBox["\<\"-5.0925\"\>",
                -5.0925218795269487,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0657\"\>",
                1.0657014923727299,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0664\"\>",
                1.0663801671173636,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0007\"\>",
                -0.00067867474463376024,
                AutoDelete->True], 
              InterpretationBox["\<\" 12.1920\"\>",
                12.191575662300041,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9929\"\>",
                1.9929050173184553,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9896\"\>",
                1.9896289026644483,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0033\"\>",
                0.0032761146540070778,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.9952\"\>",
                -0.99521198973879454,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0053\"\>",
                0.0052793082570652093,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0078\"\>",
                0.0077747072802436552,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0025\"\>",
                -0.0024953990231784458,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.2958\"\>",
                2.29583740234375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0007\"\>",
                -0.00067688146405772871,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0150\"\>",
                -0.01503755521135783,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0144\"\>",
                0.014360673747300101,
                AutoDelete->True], 
              InterpretationBox["\<\" 5.2163\"\>",
                5.21630859375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0017\"\>",
                1.0016658825143565,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0013\"\>",
                1.0012617974596063,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0004\"\>",
                0.00040408505475027001,
                AutoDelete->True], 
              InterpretationBox["\<\" 15.7130\"\>",
                15.713388218695094,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.1169\"\>",
                -0.11690286320468403,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1176\"\>",
                -0.11758516344185517,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0007\"\>",
                0.00068230023717113781,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.2881\"\>",
                -3.2880859375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9283\"\>",
                0.92833365871338513,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9262\"\>",
                0.92620310890457058,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0021\"\>",
                0.0021305498088145746,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0345\"\>",
                1.0345458984375,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.391949837963855`*^-7, 6.076758214868637`*^-8, 
          1.5880189722370057`*^-8, 2.9696598907090057`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4925984777724095`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.391949837963855*^-07, 6.0767582148686375*^-08, 
        1.5880189722370057*^-08, 2.9696598907090057*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4925984777724095*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.6189642947176404`*^-7\),
      SequenceForm[ "NOISE  ", 4.6189642947176404*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]22.608854581669643`\
\[InvisibleSpace]"  "\[InvisibleSpace]1345.3110838443113`\),
      SequenceForm[ "*BFGSUP ", 22.608854581669643, "  ", 1345.3110838443113],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.010982048612836852`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.010982048612836852, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]7\),
      SequenceForm[ "BFGS: Iteration = ", 7],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2885.273775479052000\"\>",
            2885.2737754790523,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187317351246000\"\>",
            2891.1873173512458,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2885.2737754790523, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1873173512458, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.070951759501000\"\>",
            2891.0709517595014,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187317351246000\"\>",
            2891.1873173512458,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2891.0709517595014, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1873173512458, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247765951873000\"\>",
            2891.2477659518736,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187317351246000\"\>",
            2891.1873173512458,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2891.2477659518736, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1873173512458, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247765951873000\"\>",
            2891.2477659518736,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.2477659518736, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187317351246000\"\>",
            2891.1873173512458,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.1873173512458, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.060448600627751\"\>",
            0.060448600627751148,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.060448600627751148, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0990\"\>",
                16.09857522552117,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0520\"\>",
                16.052103637073838,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0465\"\>",
                0.046471588447330847,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9780\"\>",
                1.9780061470969119,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0790\"\>",
                4.0789758713851265,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0780\"\>",
                4.0780434060250217,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0009\"\>",
                0.00093246536010463095,
                AutoDelete->True], 
              InterpretationBox["\<\"-6.0906\"\>",
                -6.0905942008452598,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0639\"\>",
                1.0638777714411005,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0657\"\>",
                1.0657014923727299,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0018\"\>",
                -0.0018237209316294071,
                AutoDelete->True], 
              InterpretationBox["\<\" 11.8980\"\>",
                11.898488373300811,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9942\"\>",
                1.9942409206284815,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9929\"\>",
                1.9929050173184553,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0013\"\>",
                0.0013359033100262727,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.3658\"\>",
                -1.3658071029333214,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0064\"\>",
                0.0064205731213242065,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0053\"\>",
                0.0052793082570652093,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0011\"\>",
                0.0011412648642589976,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.2602\"\>",
                3.260162353515625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\" 0.0018\"\>",
                0.0018231202512645228,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0007\"\>",
                -0.00067688146405772871,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0025\"\>",
                0.0025000017153222515,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.8672\"\>",
                2.8671875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0026\"\>",
                1.0025759519097186,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0017\"\>",
                1.0016658825143565,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0009\"\>",
                0.0009100693953620827,
                AutoDelete->True], 
              InterpretationBox["\<\" 15.2840\"\>",
                15.283956448811113,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.1161\"\>",
                -0.1160505119804599,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1169\"\>",
                -0.11690286320468403,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0009\"\>",
                0.00085235122422412635,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.4691\"\>",
                -3.469085693359375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9353\"\>",
                0.93525953591610855,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9283\"\>",
                0.92833365871338513,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0069\"\>",
                0.0069258772027234331,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.8873\"\>",
                0.887298583984375,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3988746442677334`*^-7, 6.078147696532498`*^-8, 
          1.5853014162795253`*^-8, 2.9716505417652152`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4939545868481973`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3988746442677334*^-07, 6.0781476965324976*^-08, 
        1.5853014162795253*^-08, 2.9716505417652152*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4939545868481973*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.4549653252582284`*^-7\),
      SequenceForm[ "NOISE  ", 4.4549653252582284*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]16.55365414869131`\
\[InvisibleSpace]"  "\[InvisibleSpace]705.5895126661383`\),
      SequenceForm[ "*BFGSUP ", 16.553654148691312, "  ", 705.58951266613826],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.005207545720898706`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0052075457208987062, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]8\),
      SequenceForm[ "BFGS: Iteration = ", 8],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2879.217243945660000\"\>",
            2879.2172439456599,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247765951873000\"\>",
            2891.2477659518736,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2879.2172439456599, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.2477659518736, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.209165121304000\"\>",
            2891.2091651213041,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247765951873000\"\>",
            2891.2477659518736,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2891.2091651213041, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.2477659518736, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480890796199000\"\>",
            2891.4808907961992,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247765951873000\"\>",
            2891.2477659518736,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2891.4808907961992, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.2477659518736, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480890796199000\"\>",
            2891.4808907961992,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.4808907961992, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247765951873000\"\>",
            2891.2477659518736,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.2477659518736, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.233124844325630\"\>",
            0.23312484432562997,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.23312484432562997, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.2550\"\>",
                16.25482522552117,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0990\"\>",
                16.09857522552117,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.1563\"\>",
                0.15624999999999997,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.7537\"\>",
                0.75374283879353654,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.1057\"\>",
                4.1057238690877131,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0790\"\>",
                4.0789758713851265,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0267\"\>",
                0.02674799770258646,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.6912\"\>",
                -3.6911973510958402,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0887\"\>",
                1.0887174751688657,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0639\"\>",
                1.0638777714411005,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0248\"\>",
                0.024839703727765141,
                AutoDelete->True], 
              InterpretationBox["\<\" 13.1490\"\>",
                13.148735537531582,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0078\"\>",
                2.0078054336159963,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9942\"\>",
                1.9942409206284815,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0136\"\>",
                0.013564512987514816,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.6705\"\>",
                -0.67046395275514192,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0070\"\>",
                0.0070020168975568368,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0064\"\>",
                0.0064205731213242065,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0006\"\>",
                0.00058144377623263054,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.6470\"\>",
                2.64697265625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0089\"\>",
                -0.008884066190966473,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0018\"\>",
                0.0018231202512645228,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0107\"\>",
                -0.010707186442230995,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.5442\"\>",
                2.544219970703125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0058\"\>",
                1.0058326765656687,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0026\"\>",
                1.0025759519097186,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0033\"\>",
                0.003256724655950166,
                AutoDelete->True], 
              InterpretationBox["\<\" 14.6130\"\>",
                14.612809764935909,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0763\"\>",
                -0.076296707603555003,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1161\"\>",
                -0.1160505119804599,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0398\"\>",
                0.039753804376904893,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.0572\"\>",
                -1.05718994140625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9520\"\>",
                0.95203321109930716,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9353\"\>",
                0.93525953591610855,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0168\"\>",
                0.016773675183198597,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.2607\"\>",
                0.260650634765625,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.4221577086331204`*^-7, 6.118005319070389`*^-8, 
          1.62231545920501`*^-8, 2.991863241219515`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4988074847544263`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4221577086331204*^-07, 6.1180053190703886*^-08, 
        1.6223154592050102*^-08, 2.991863241219515*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4988074847544263*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.8500107995257623`*^-7\),
      SequenceForm[ "NOISE  ", 3.8500107995257623*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]5.761989104085884`\
\[InvisibleSpace]"  "\[InvisibleSpace]279.6681827246571`\),
      SequenceForm[ "*BFGSUP ", 5.7619891040858837, "  ", 279.66818272465707],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.006393693871949849`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0063936938719498489, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]9\),
      SequenceForm[ "BFGS: Iteration = ", 9],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2879.084146503241000\"\>",
            2879.0841465032404,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480890796199000\"\>",
            2891.4808907961992,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2879.0841465032404, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.4808907961992, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.892187374736000\"\>",
            2890.8921873747358,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480890796199000\"\>",
            2891.4808907961992,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2890.8921873747358, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.4808907961992, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.555724894612000\"\>",
            2891.555724894612,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480890796199000\"\>",
            2891.4808907961992,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2891.555724894612, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.4808907961992, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.555724894612000\"\>",
            2891.555724894612,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.555724894612, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480890796199000\"\>",
            2891.4808907961992,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.4808907961992, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.074834098412794\"\>",
            0.074834098412793537,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.074834098412793537, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.327518280953711,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.2550\"\>",
                16.25482522552117,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0727\"\>",
                0.07269305543254069,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.8757\"\>",
                0.87573154947863152,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.1002\"\>",
                4.1002319457222276,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.1057\"\>",
                4.1057238690877131,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0055\"\>",
                -0.0054919233654858448,
                AutoDelete->True], 
              InterpretationBox["\<\"-4.5028\"\>",
                -4.5027976166481922,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0951\"\>",
                1.0951042956846715,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0887\"\>",
                1.0887174751688657,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0064\"\>",
                0.0063868205158057459,
                AutoDelete->True], 
              InterpretationBox["\<\" 9.4701\"\>",
                9.4700520720873502,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0131\"\>",
                2.0130605480182684,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0078\"\>",
                2.0078054336159963,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0053\"\>",
                0.0052551144022720923,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.9393\"\>",
                -0.93926643799151199,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0071\"\>",
                0.0071246021421149551,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0070\"\>",
                0.0070020168975568368,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0001\"\>",
                0.00012258524455811812,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.2848\"\>",
                2.284820556640625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0039\"\>",
                -0.0038670150317943438,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0089\"\>",
                -0.008884066190966473,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0050\"\>",
                0.0050170511591721293,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.0974\"\>",
                3.097442626953125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0077\"\>",
                1.0077409959575525,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0058\"\>",
                1.0058326765656687,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0019\"\>",
                0.0019083193918837469,
                AutoDelete->True], 
              InterpretationBox["\<\" 11.2240\"\>",
                11.224175349454656,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0463\"\>",
                -0.046330789770475805,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0763\"\>",
                -0.076296707603555003,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0300\"\>",
                0.029965917833079194,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.0033\"\>",
                -2.003265380859375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9191\"\>",
                0.9191470948941155,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9520\"\>",
                0.95203321109930716,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0329\"\>",
                -0.032886116205191655,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.9973\"\>",
                -0.99725341796875,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.4329898179998564`*^-7, 6.109821715537053`*^-8, 
          1.6318325634072296`*^-8, 2.999693971899552`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.501651102241207`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4329898179998564*^-07, 6.1098217155370528*^-08, 
        1.6318325634072296*^-08, 2.9996939718995517*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5016511022412069*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.061253705895901`*^-7\),
      SequenceForm[ "NOISE  ", 3.0612537058959008*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]6.369547254022716`\
\[InvisibleSpace]"  "\[InvisibleSpace]415.74174235696665`\),
      SequenceForm[ "*BFGSUP ", 6.3695472540227156, "  ", 415.74174235696665],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.003859093173586021`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0038590931735860211, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]10\),
      SequenceForm[ "BFGS: Iteration = ", 10],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.694842196116000\"\>",
            2891.6948421961156,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.6948421961156, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.555724894612000\"\>",
            2891.555724894612,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.555724894612, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.139117301503575\"\>",
            0.13911730150357471,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.13911730150357471, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.2230\"\>",
                16.222594967617123,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.327518280953711,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1049\"\>",
                -0.10492331333658729,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.4619\"\>",
                0.46189291058418813,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0745\"\>",
                4.0744723977539392,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.1002\"\>",
                4.1002319457222276,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0258\"\>",
                -0.025759547968288724,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.7215\"\>",
                -2.7215004191717336,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.1323\"\>",
                1.132288336938932,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0951\"\>",
                1.0951042956846715,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0372\"\>",
                0.037184041254260475,
                AutoDelete->True], 
              InterpretationBox["\<\" 8.6261\"\>",
                8.6260657433405505,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9968\"\>",
                1.996790110173204,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0131\"\>",
                2.0130605480182684,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0163\"\>",
                -0.016270437845064385,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.5566\"\>",
                -0.55662206341418818,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0132\"\>",
                0.013167021549738381,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0071\"\>",
                0.0071246021421149551,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0060\"\>",
                0.0060424194076234266,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0708\"\>",
                2.07080078125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\" 0.0022\"\>",
                0.0021871354058114901,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0039\"\>",
                -0.0038670150317943438,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0061\"\>",
                0.0060541504376058338,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9366\"\>",
                1.936614990234375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0219\"\>",
                1.0219044448545969,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0077\"\>",
                1.0077409959575525,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0142\"\>",
                0.014163448897044401,
                AutoDelete->True], 
              InterpretationBox["\<\" 9.3196\"\>",
                9.3195505123917446,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0894\"\>",
                -0.089441942757950033,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0463\"\>",
                -0.046330789770475805,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0431\"\>",
                -0.043111152987474234,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.4850\"\>",
                -2.485015869140625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9403\"\>",
                0.9402544894375986,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9191\"\>",
                0.9191470948941155,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0211\"\>",
                0.021107394543483069,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.7343\"\>",
                1.73431396484375,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.4173550259496455`*^-7, 6.071436997881441`*^-8, 
          1.6872411026640714`*^-8, 2.9754491301971733`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.522756285748775`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4173550259496455*^-07, 6.0714369978814411*^-08, 
        1.6872411026640714*^-08, 2.9754491301971733*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5227562857487751*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.0795242451617612`*^-7\),
      SequenceForm[ "NOISE  ", 2.0795242451617612*^-07],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.973824845851568`\
\[InvisibleSpace]"  "\[InvisibleSpace]1.5351015876205794`\),
      SequenceForm[ 
      "*BFGSUP ", 0.97382484585156803, "  ", 1.5351015876205794],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0022028903523872777`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0022028903523872777, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]11\),
      SequenceForm[ "BFGS: Iteration = ", 11],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772427329953000\"\>",
            2891.7724273299532,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.7724273299532, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.694842196116000\"\>",
            2891.6948421961156,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.6948421961156, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.077585133837601\"\>",
            0.077585133837601461,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.077585133837601461, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.3360\"\>",
                16.336232268993172,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.2230\"\>",
                16.222594967617123,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.1136\"\>",
                0.11363730137604983,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0768\"\>",
                -0.076829163934073089,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0966\"\>",
                4.0966264005017532,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0745\"\>",
                4.0744723977539392,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0222\"\>",
                0.022154002747814362,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.5634\"\>",
                1.5634138725380486,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.1251\"\>",
                1.1251341132783275,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.1323\"\>",
                1.132288336938932,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0072\"\>",
                -0.0071542236606045662,
                AutoDelete->True], 
              InterpretationBox["\<\"-4.6359\"\>",
                -4.6359004629345844,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0100\"\>",
                2.0100196699465975,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9968\"\>",
                1.996790110173204,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0132\"\>",
                0.013229559773393598,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.5465\"\>",
                1.5464578096735451,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0110\"\>",
                0.011039733162989696,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0132\"\>",
                0.013167021549738381,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0021\"\>",
                -0.0021272883867486845,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.0968\"\>",
                -1.096832275390625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0032\"\>",
                -0.0032199752252887685,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0022\"\>",
                0.0021871354058114901,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0054\"\>",
                -0.0054071106311002586,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.4967\"\>",
                -1.496734619140625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0175\"\>",
                1.017480499988364,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0219\"\>",
                1.0219044448545969,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0044\"\>",
                -0.0044239448662329681,
                AutoDelete->True], 
              InterpretationBox["\<\"-4.2940\"\>",
                -4.2939738915449501,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0566\"\>",
                -0.056580654441346391,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0894\"\>",
                -0.089441942757950033,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0329\"\>",
                0.032861288316603642,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.5256\"\>",
                1.525604248046875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9393\"\>",
                0.93934628391881003,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9403\"\>",
                0.9402544894375986,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0009\"\>",
                -0.00090820551878854103,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1622\"\>",
                -0.1622314453125,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.434288303404029`*^-7, 6.104449034484853`*^-8, 
          1.6765804786657206`*^-8, 2.995162710467871`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.516164094192332`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.434288303404029*^-07, 6.1044490344848531*^-08, 
        1.6765804786657206*^-08, 2.9951627104678713*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.516164094192332*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]7.2082807449975`*^-8\),
      SequenceForm[ "NOISE  ", 7.2082807449975003*^-08],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]6.158649838676744`\
\[InvisibleSpace]"  "\[InvisibleSpace]6.280077894795498`\),
      SequenceForm[ "*BFGSUP ", 6.1586498386767436, "  ", 6.2800778947954976],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00022235683728662325`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.00022235683728662325, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]12\),
      SequenceForm[ "BFGS: Iteration = ", 12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592267190000\"\>",
            2891.7725922671893,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.7725922671893, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772427329953000\"\>",
            2891.7724273299532,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.7724273299532, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000164937236150\"\>",
            0.00016493723614985356,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.00016493723614985356, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.328043081824493,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.3360\"\>",
                16.336232268993172,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0082\"\>",
                -0.0081891871686784017,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0394\"\>",
                -0.03936068981549682,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952201543699092,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0966\"\>",
                4.0966264005017532,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0014\"\>",
                -0.0014062461318443658,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0314\"\>",
                0.031399395312474737,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.1246923448173853,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.1251\"\>",
                1.1251341132783275,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0004\"\>",
                -0.00044176846094219375,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0687\"\>",
                0.068703832261730421,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091841964786159,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0100\"\>",
                2.0100196699465975,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0008\"\>",
                -0.00083547346798148287,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1003\"\>",
                -0.10034263686259526,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011140366816199525,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0110\"\>",
                0.011039733162989696,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0001\"\>",
                0.00010063365320982954,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0568\"\>",
                0.056793212890625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.0027856397480388456,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0032\"\>",
                -0.0032199752252887685,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0004\"\>",
                0.00043433547724992284,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0651\"\>",
                0.0650634765625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172681695475434,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0175\"\>",
                1.017480499988364,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0002\"\>",
                -0.00021233044082055792,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2015\"\>",
                -0.20149485896397484,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.058033206381407298,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0566\"\>",
                -0.056580654441346391,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0015\"\>",
                -0.0014525519400609074,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0612\"\>",
                0.0611572265625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9389\"\>",
                0.93890287703043673,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9393\"\>",
                0.93934628391881003,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0004\"\>",
                -0.00044340688837325346,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0310\"\>",
                -0.031036376953125,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.4330680194235583`*^-7, 6.10235356445597`*^-8, 
          1.675922192361035`*^-8, 2.9939177579859136`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.5158476971798292`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4330680194235583*^-07, 6.1023535644559699*^-08, 
        1.675922192361035*^-08, 2.9939177579859136*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5158476971798292*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.1424057054681816`*^-9\),
      SequenceForm[ "NOISE  ", 3.1424057054681816*^-09],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2968.4523936727996`\
\[InvisibleSpace]"  "\[InvisibleSpace]2999.894333628204`\),
      SequenceForm[ "*BFGSUP ", 2968.4523936727996, "  ", 2999.8943336282041],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.000011028138666886708`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 1.1028138666886708*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]13\),
      SequenceForm[ "BFGS: Iteration = ", 13],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592813899000\"\>",
            2891.7725928138989,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.7725928138989, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592267190000\"\>",
            2891.7725922671893,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.7725922671893, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     5.467095434141811"\[Times]10\^"-7"\),
            5.467095434141811*^-07,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 5.467095434141811*^-07, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.328236601019487,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.328043081824493,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0002\"\>",
                0.00019351919499469667,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0020\"\>",
                0.0019531347988739822,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952186428750581,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952201543699092,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0054\"\>",
                -0.0053803435653485901,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.1247373716127844,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.1246923448173853,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                4.5026795398976351*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0094\"\>",
                0.0093884181571134134,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091806507492538,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091841964786159,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0082\"\>",
                -0.0081565142120106349,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011149015608373686,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011140366816199525,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0047\"\>",
                0.004730224609375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.002785221153950915,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.0027856397480388456,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0029\"\>",
                0.002899169921875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172690210023767,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172681695475434,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0001\"\>",
                5.9999081930526714*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.057979766212023442,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.058033206381407298,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0001\"\>",
                5.3440169383852535*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0018\"\>",
                -0.0018310546875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9390\"\>",
                0.93896274645433997,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9389\"\>",
                0.93890287703043673,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0001\"\>",
                5.9869423903206149*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0049\"\>",
                0.004852294921875,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.4330968560307454`*^-7, 6.102351312153128`*^-8, 
          1.6759892875146634`*^-8, 2.993912474437436`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.5158489659464012`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4330968560307454*^-07, 6.1023513121531279*^-08, 
        1.6759892875146634*^-08, 2.9939124744374361*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5158489659464012*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.4973293998743937`*^-10\),
      SequenceForm[ "NOISE  ", 1.4973293998743937*^-10],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]953758.5473402741`\
\[InvisibleSpace]"  "\[InvisibleSpace]932331.1867120136`\),
      SequenceForm[ "*BFGSUP ", 953758.54734027409, "  ", 932331.18671201356],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]2.3217134031161605`*^-7\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 2.3217134031161605*^-07, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]14\),
      SequenceForm[ "BFGS: Iteration = ", 14],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592815243000\"\>",
            2891.7725928152431,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.7725928152431, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592813899000\"\>",
            2891.7725928138989,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.7725928138989, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     1.344233169220388"\[Times]10\^"-9"\),
            1.3442331692203879*^-09,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 1.3442331692203879*^-09, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.328248262848614,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.328236601019487,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                1.166182912785147*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                1.495205091435021*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952191241974827,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952186428750581,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0001\"\>",
                -0.00014904004296862187,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.124737658673455,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.1247373716127844,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0001\"\>",
                -5.4266140514634466*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091812732103378,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091806507492538,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0001\"\>",
                9.113439783611156*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011149746098419873,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011149015608373686,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0004\"\>",
                0.000396728515625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.0027835901090260099,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.002785221153950915,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0003\"\>",
                0.00030517578125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172683482563627,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172690210023767,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0007\"\>",
                -0.00065998934882381655,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.057975144478137577,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.057979766212023442,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0002\"\>",
                0.00018310546875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9390\"\>",
                0.93896463800869834,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9390\"\>",
                0.93896274645433997,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0002\"\>",
                0.00018310546875,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.433098593778702`*^-7, 6.102352029379431`*^-8, 
          1.6759897152683958`*^-8, 2.993913401976731`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.5158479634767215`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4330985937787018*^-07, 6.1023520293794314*^-08, 
        1.6759897152683958*^-08, 2.9939134019767311*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5158479634767215*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.0289355023932704`*^-11\),
      SequenceForm[ "NOISE  ", 1.0289355023932704*^-11],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]4.0145192508336765`*^8\
\[InvisibleSpace]"  "\[InvisibleSpace]3.8941303844513714`*^8\),
      SequenceForm[ "*BFGSUP ", 401451925.08336765, "  ", 389413038.44513714],
      
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]4.2212970965728745`*^-8\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 4.2212970965728745*^-08, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("ReturnCode = 1"\)], "Print"],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print"],

Cell[BoxData[
    \("ReturnCode = 3"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS:  ENDE DER ITERATION  "\[InvisibleSpace]14\
\[InvisibleSpace]"  "\[InvisibleSpace]300\),
      SequenceForm[ "BFGS:  ENDE DER ITERATION  ", 14, "  ", 300],
      Editable->False]], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"SCORE\"\>"},
          {"1", \(-7.4760201177088`*^-6\)},
          {"2", \(-7.452001272576681`*^-6\)},
          {"3", \(-0.0000271330633322914`\)},
          {"4", "0.`"},
          {"5", "0.000030517578125`"},
          {"6", "0.000030517578125`"},
          {"7", \(-0.000029999535695088036`\)},
          {"8", "0.000030517578125`"},
          {"9", \(-0.000030517578125`\)}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"Likelihood\"\>", "\<\"THETA\"\>", "\<\"\"\>", "\<\
\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
          {"1", "2887.7236043713524`", "16", "4", "1", "2", "0", "0", "1", 
            "0", "1"},
          {"2", "2889.749803058627`", "16.005924045342812`", 
            "4.008378614186083`", "1.0284798268972553`", "1.9609375`", 
            "0.005416369142272039`", "0.005492954198542812`", 
            "1.0169825212680526`", \(-0.017390915602188743`\), 
            "0.9898232899597638`"},
          {"3", "2890.8205230574868`", "16.012511305691792`", 
            "4.002413866285318`", "1.0675423268972553`", 
            "1.9693948662502174`", "0.010594761159039894`", 
            "0.011591023430867316`", 
            "1.0179550424350348`", \(-0.04561790295504407`\), 
            "0.9803509745924487`"},
          {"4", "2890.913622028648`", "16.02092112482501`", 
            "4.024868235843199`", "1.0741460123305808`", 
            "1.9695737460811247`", "0.002615981896916194`", 
            "0.0013249922630407859`", 
            "0.9911984502721948`", \(-0.07576315709063984`\), 
            "0.9590658435254827`"},
          {"5", "2891.1446116486877`", "16.032007608474412`", 
            "4.060323625062779`", "1.0685992654502745`", 
            "1.9863950669317847`", \(-0.005187826914185697`\), \
\(-0.01700265082362238`\), "1.0020581425710153`", \(-0.11424695300862958`\), 
            "0.9297289668488691`"},
          {"6", "2891.1619080422124`", "16.036081510890238`", 
            "4.0690888165707575`", "1.0663801671173636`", 
            "1.9896289026644483`", 
            "0.007774707280243655`", \(-0.01503755521135783`\), 
            "1.0012617974596063`", \(-0.11758516344185517`\), 
            "0.9262031089045706`"},
          {"7", "2891.187317351246`", "16.052103637073838`", 
            "4.078043406025022`", "1.06570149237273`", "1.9929050173184553`", 
            "0.005279308257065209`", \(-0.0006768814640577287`\), 
            "1.0016658825143565`", \(-0.11690286320468403`\), 
            "0.9283336587133851`"},
          {"8", "2891.2477659518736`", "16.09857522552117`", 
            "4.0789758713851265`", "1.0638777714411005`", 
            "1.9942409206284815`", "0.0064205731213242065`", 
            "0.0018231202512645228`", 
            "1.0025759519097186`", \(-0.1160505119804599`\), 
            "0.9352595359161086`"},
          {"9", "2891.480890796199`", "16.25482522552117`", 
            "4.105723869087713`", "1.0887174751688657`", 
            "2.0078054336159963`", 
            "0.007002016897556837`", \(-0.008884066190966473`\), 
            "1.0058326765656687`", \(-0.076296707603555`\), 
            "0.9520332110993072`"},
          {"10", "2891.555724894612`", "16.32751828095371`", 
            "4.100231945722228`", "1.0951042956846715`", 
            "2.0130605480182684`", 
            "0.007124602142114955`", \(-0.0038670150317943438`\), 
            "1.0077409959575525`", \(-0.046330789770475805`\), 
            "0.9191470948941155`"},
          {"11", "2891.6948421961156`", "16.222594967617123`", 
            "4.074472397753939`", "1.132288336938932`", "1.996790110173204`", 
            "0.01316702154973838`", "0.00218713540581149`", 
            "1.0219044448545969`", \(-0.08944194275795003`\), 
            "0.9402544894375986`"},
          {"12", "2891.772427329953`", "16.33623226899317`", 
            "4.096626400501753`", "1.1251341132783275`", 
            "2.0100196699465975`", 
            "0.011039733162989696`", \(-0.0032199752252887685`\), 
            "1.017480499988364`", \(-0.05658065444134639`\), 
            "0.93934628391881`"},
          {"13", "2891.7725922671893`", "16.328043081824493`", 
            "4.095220154369909`", "1.1246923448173853`", "2.009184196478616`",
             "0.011140366816199525`", \(-0.0027856397480388456`\), 
            "1.0172681695475434`", \(-0.0580332063814073`\), 
            "0.9389028770304367`"},
          {"14", "2891.772592813899`", "16.328236601019487`", 
            "4.095218642875058`", "1.1247373716127844`", "2.009180650749254`",
             "0.011149015608373686`", \(-0.002785221153950915`\), 
            "1.0172690210023767`", \(-0.05797976621202344`\), 
            "0.93896274645434`"},
          {"15", "2891.772592815243`", "16.328248262848614`", 
            "4.095219124197483`", "1.124737658673455`", "2.009181273210338`", 
            "0.011149746098419873`", \(-0.00278359010902601`\), 
            "1.0172683482563627`", \(-0.05797514447813758`\), 
            "0.9389646380086983`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"Likelihood", "THETA"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("INK: "\[InvisibleSpace]{0.0000988749636430505`, 
          0.000024798412879148014`, 6.810797662988637`*^-6, 
          0.000012166505686526865`, 6.055454452393343`*^-6, 
          6.055454452393343`*^-6, 6.160022148727813`*^-6, 
          6.055454452393343`*^-6, 6.055454452393343`*^-6}\),
      SequenceForm[ 
      "INK: ", {9.8874963643050503*^-05, 2.4798412879148014*^-05, 
        6.8107976629886368*^-06, 1.2166505686526865*^-05, 
        6.0554544523933429*^-06, 6.0554544523933429*^-06, 
        6.1600221487278128*^-06, 6.0554544523933429*^-06, 
        6.0554544523933429*^-06}],
      Editable->False]], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{
        TagBox[
          RowBox[{"(", "\[NoBreak]", 
            TagBox[GridBox[{
                  {
                    StyleBox["\[Null]",
                      ShowStringCharacters->False], 
                    TagBox["\<\"THETA\"\>",
                      HoldForm], 
                    TagBox["\<\"SCORE\"\>",
                      HoldForm]},
                  {"1", "16.328248262848614`", \(-7.4760201177088`*^-6\)},
                  {"2", "4.095219124197483`", \(-7.452001272576681`*^-6\)},
                  {"3", "1.124737658673455`", \(-0.0000271330633322914`\)},
                  {"4", "2.009181273210338`", "0.`"},
                  {"5", "0.011149746098419873`", "0.000030517578125`"},
                  {"6", \(-0.00278359010902601`\), "0.000030517578125`"},
                  {"7", 
                    "1.0172683482563627`", \(-0.000029999535695088036`\)},
                  {"8", \(-0.05797514447813758`\), "0.000030517578125`"},
                  {"9", "0.9389646380086983`", \(-0.000030517578125`\)}
                  },
                RowSpacings->0,
                ColumnSpacings->1,
                ColumnAlignments->{Left},
                RowLines->{True, False},
                ColumnLines->{True, False}],
              {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
            "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ 
            BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}]]], 
        "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
        "2891.772592815243`"}],
      SequenceForm[ 
        MatrixForm[ {{16.328248262848614, -7.4760201177087998*^-06}, {
          4.0952191241974827, -7.4520012725766807*^-06}, {
          1.124737658673455, -2.71330633322914*^-05}, {2.0091812732103378, 
          0.0}, {0.011149746098419873, 
          3.0517578125*^-05}, {-0.0027835901090260099, 3.0517578125*^-05}, {
          
          1.0172683482563627, -2.9999535695088036*^-05}, \
{-0.057975144478137577, 3.0517578125*^-05}, {
          0.93896463800869834, -3.0517578125*^-05}}, TableHeadings -> {
          Automatic, {"THETA", "SCORE"}}], "   Likelihood = ", 
        2891.7725928152431],
      Editable->False]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("WALD-TEST:"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"CHI \"\>", "\<\"U \"\>", "\<\"PROB \"\>", \
"\<\"ALPHA \"\>"},
          {"1", "3711.49250789778`", "9", "0", "0.05`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", 
          "ALPHA "}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    \("NULLHYPOTHESE THETA = 0 ABLEHNEN"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("BONFERRONI-KONFIDENZINTERVALLE:"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= 1-ALPHA"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("QUANTIL Z(1-ALPHA/2U) = \
"\[InvisibleSpace]2.7729212946086634`\),
      SequenceForm[ "QUANTIL Z(1-ALPHA/2U) = ", 2.7729212946086634],
      Editable->False]], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"THETA\"\>", "\<\"GRENZE\"\>", "\<\"STD\"\>"},
          {"1", "16.328248262848614`", "1.5479403113108712`", 
            "0.5582344923819155`"},
          {"2", "4.095219124197483`", "0.3181926460374108`", 
            "0.11474997384746063`"},
          {"3", "1.124737658673455`", "0.2014288574125603`", 
            "0.07264139007630491`"},
          {"4", "2.009181273210338`", "0.17335780531772446`", 
            "0.06251811245230099`"},
          {"5", "0.011149746098419873`", "0.12615067402541374`", 
            "0.04549378097051872`"},
          {"6", \(-0.00278359010902601`\), "0.2233939243036103`", 
            "0.08056266318771857`"},
          {"7", "1.0172683482563627`", "0.08920122551425805`", 
            "0.03216868278507949`"},
          {"8", \(-0.05797514447813758`\), "0.44984486508978233`", 
            "0.16222777976584005`"},
          {"9", "0.9389646380086983`", "0.29952545504843714`", 
            "0.10801801537995276`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("Korrelation der ML-Sch\[ADoubleDot]tzer"\)], "Print"],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", "1.0000000000000002`", "0.7266017597914224`", 
                "0.5447885410506045`", 
                "0.8048765933400123`", \(-0.000025692022568200175`\), \
\(-0.10181180508002527`\), "0.000028189605094904847`", "0.8226704221176038`", 
                "0.06642959716542557`"},
              {"2", "0.7266017597914219`", "1.0000000000000002`", 
                "0.4087208004119728`", 
                "0.7954374928001505`", \(-0.000014540357422107966`\), \
\(-0.05630577801828278`\), "0.000011565999548941405`", "0.38524016610298323`",
                 "0.13711283747024924`"},
              {"3", "0.544788541050601`", "0.4087208004119707`", 
                "1.0000000000000002`", 
                "0.4442289268709827`", \(-0.00002452127758228429`\), \
\(-0.2699686845117272`\), "0.000013613452919964717`", "0.44238056745674215`", 
                "0.038629193493537155`"},
              {"4", "0.8048765933400086`", "0.7954374928001481`", 
                "0.44422892687098336`", 
                "1.0000000000000002`", \(-0.00001742287051281046`\), \
\(-0.074060719292415`\), "0.000010886866656762641`", 
                "0.567334831594642`", \(-0.07410880581857845`\)},
              {
                "5", \(-0.0000256920225694645`\), \(-0.000014540357423188102`\
\), \(-0.000024521277583019417`\), \(-0.0000174228705139125`\), 
                "1.0000000000000002`", \(-0.032164377165132076`\), \
\(-8.88816610116708`*^-6\), \(-0.000028690219954470705`\), \
\(-0.000015109969528142984`\)},
              {
                "6", \(-0.10181180508002488`\), \(-0.05630577801828261`\), \
\(-0.2699686845117272`\), \(-0.07406071929241521`\), \
\(-0.03216437716513187`\), "0.9999999999999998`", 
                "3.98107174333727`*^-6", \(-0.09169454676067881`\), \
\(-0.0034417877804888263`\)},
              {"7", "0.000028189605095305497`", "0.000011565999549246363`", 
                "0.000013613452919779987`", 
                "0.000010886866657114006`", \(-8.888166101211868`*^-6\), 
                "3.981071743554209`*^-6", "1.`", \(-0.011265271343218832`\), 
                "0.00003345460825622773`"},
              {"8", "0.8226704221176017`", "0.38524016610298184`", 
                "0.44238056745674414`", 
                "0.5673348315946434`", \(-0.000028690219953524583`\), \
\(-0.09169454676067891`\), \(-0.011265271343219026`\), "1.0000000000000002`", 
                "0.01463920300860865`"},
              {"9", "0.0664295971654232`", "0.1371128374702472`", 
                "0.038629193493536156`", \(-0.07410880581858041`\), \
\(-0.000015109969528096304`\), \(-0.0034417877804889343`\), 
                "0.00003345460825633546`", "0.014639203008607028`", 
                "1.0000000000000002`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND EIGENWERTE"\)], \
"Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", "0.3116257484848949`", "0.04654421477323603`", 
                "0.02209168172881143`", 
                "0.028090005385784655`", \(-6.524796851385782`*^-7\), \
\(-0.004578767790434735`\), "5.062195779467267`*^-7", "0.07450197315338057`", 
                "0.004005663654503295`"},
              {"2", "0.046544214773235996`", "0.0131675564979929`", 
                "0.003406932127684071`", 
                "0.005706430208518361`", \(-7.590662985761564`*^-8\), \
\(-0.0005205223399619048`\), "4.269421614392383`*^-8", "0.00717148973605154`",
                 "0.0016995224559818473`"},
              {"3", "0.022091681728811288`", "0.003406932127684053`", 
                "0.00527677155221789`", 
                "0.0020174224005915582`", \(-8.103623818956883`*^-8\), \
\(-0.0015799063734008784`\), "3.181161503345542`*^-8", 
                "0.0052132123112932725`", "0.0003031070103598699`"},
              {"4", "0.02809000538578453`", "0.005706430208518343`", 
                "0.0020174224005915613`", 
                "0.003908514384598553`", \(-4.955387245062995`*^-8\), \
\(-0.0003730161174551866`\), "2.1894853273796645`*^-8", 
                "0.005754008906376429`", \(-0.0005004628746594563`\)},
              {
                "5", \(-6.524796851706873`*^-7\), \
\(-7.590662986325439`*^-8\), \(-8.103623819199823`*^-8\), \
\(-4.955387245376436`*^-8\), 
                "0.0020696841069935312`", \(-0.00011788566368399119`\), \
\(-1.30076089625392`*^-8\), \(-2.117440105873146`*^-7\), \
\(-7.425262551785446`*^-8\)},
              {
                "6", \(-0.004578767790434718`\), \(-0.0005205223399619033`\), \
\(-0.0015799063734008784`\), \(-0.0003730161174551876`\), \
\(-0.00011788566368399042`\), "0.006490342699897784`", 
                "1.0317324654912623`*^-8", \(-0.0011984020605325407`\), \
\(-0.000029951190987259697`\)},
              {"7", "5.062195779539214`*^-7", "4.2694216145049536`*^-8", 
                "3.181161503302375`*^-8", 
                "2.1894853274503282`*^-8", \(-1.3007608962604747`*^-8\), 
                "1.0317324655474841`*^-8", 
                "0.0010348241521270696`", \(-0.00005878955320108308`\), 
                "1.1624798149893296`*^-7"},
              {"8", "0.07450197315338038`", "0.0071714897360515145`", 
                "0.005213212311293296`", 
                "0.005754008906376443`", \(-2.1174401058033187`*^-7\), \
\(-0.001198402060532542`\), \(-0.00005878955320108409`\), 
                "0.026317852527753906`", "0.00025653040783867715`"},
              {"9", "0.004005663654503152`", "0.001699522455981822`", 
                "0.0003031070103598621`", \(-0.0005004628746594697`\), \
\(-7.425262551762506`*^-8\), \(-0.000029951190987260632`\), 
                "1.162479814993073`*^-7", "0.00025653040783864874`", 
                "0.01166789164662371`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \({0.000817885834211318`, 0.001034047975713506`, 0.002065573878335809`, 
      0.0031503245573329232`, 0.0032049980240141753`, 0.006907634136186958`, 
      0.010634154652143835`, 0.012789993455299705`, 
      0.3409545735398505`}\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX UND \
EIGENWERTE"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", 
                "29.79979320973503`", \(-44.19091201873693`\), \
\(-18.67731683259087`\), \(-58.47908529931684`\), \(-0.04348230821855161`\), \
\(-0.7589466635351564`\), \(-3.182108712406772`\), \(-55.82862544556761`\), \
\(-4.591276038098594`\)},
              {"2", \(-44.19091201873693`\), 
                "307.22779708145214`", \(-6.477371520110542`\), \
\(-290.3428370037089`\), \(-0.3066158359705222`\), \(-5.3737264289352265`\), 
                "6.061709436058651`", 
                "106.34194267595909`", \(-44.2162747753639`\)},
              {"3", \(-18.67731683259087`\), \(-6.477371520110542`\), 
                "288.8555168431068`", "0.001371975464070814`", 
                "3.2334301115958617`", "56.67737129115304`", "0", 
                "0", \(-0.0027565474097151423`\)},
              {"4", \(-58.47908529931684`\), \(-290.3428370037089`\), 
                "0.001371975464070814`", "1114.1403534701817`", 
                "0.001543112471216434`", "0", 
                "0.004550753418784892`", \(-0.001543112471216434`\), 
                "110.15508375778515`"},
              {"5", \(-0.04348230821855161`\), \(-0.3066158359705222`\), 
                "3.2334301115958617`", "0.001543112471216434`", 
                "483.70776391175457`", "9.518205526449934`", 
                "0.006095525698680351`", "0.003100392679625386`", 
                "0.003100392679625386`"},
              {"6", \(-0.7589466635351564`\), \(-5.3737264289352265`\), 
                "56.67737129115304`", "0", "9.518205526449934`", 
                "167.07706111233242`", \(-0.0030477628493401753`\), \
\(-0.006200785359250772`\), "0"},
              {"7", \(-3.182108712406772`\), "6.061709436058651`", "0", 
                "0.004550753418784892`", 
                "0.006095525698680351`", \(-0.0030477628493401753`\), 
                "966.8896309182958`", 
                "9.515115615640028`", \(-0.009143288548020526`\)},
              {"8", \(-55.82862544556761`\), "106.34194267595909`", 
                "0", \(-0.001543112471216434`\), 
                "0.003100392679625386`", \(-0.006200785359250772`\), 
                "9.515115615640028`", "167.08326189769167`", 
                "0.003100392679625386`"},
              {
                "9", \(-4.591276038098594`\), \(-44.2162747753639`\), \
\(-0.0027565474097151423`\), "110.15508375778515`", "0.003100392679625386`", 
                "0", \(-0.009143288548020526`\), "0.003100392679625386`", 
                "98.44676875614488`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \({1222.6645311252926`, 967.0731179662989`, 484.1269588506221`, 
      317.427611600312`, 312.01267286509164`, 144.76736611762766`, 
      94.0366237572444`, 78.18612288543717`, 2.9329420327694207`}\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("KOMPENSIERTE LIKELIHOOD"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("U =  "\[InvisibleSpace]9\[InvisibleSpace]"  Nue = "\
\[InvisibleSpace]3000\),
      SequenceForm[ "U =  ", 9, "  Nue = ", 3000],
      Editable->False]], "Print"],

Cell[BoxData[
    \("AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) AZENCOTT/DACUNHA-CASTELLE \
(A/D)"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"LIK\"\>", "\<\"AIC\"\>", "\<\"SIC/RISS\"\>", \
"\<\"A/D\"\>"},
          {"\<\"Kompensator\"\>", "0", "9", "36.028654054426106`", 
            "93.70428336945712`"},
          {"\<\"komp. Lik.\"\>", "2891.772592815243`", "2882.772592815243`", 
            "2855.743938760817`", "2798.068309445786`"}
          },
        RowSpacings->1,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {{"Kompensator", "komp. Lik."}, {"LIK", 
          "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {1, 2}]]]], "Print"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{\({THETA, COV, LIKI, psii, scoreii, k, ReturnCode}\), "=", "\n",
         "    ", 
        RowBox[{"BFGS", "[", 
          
          RowBox[{\({{S, m, n, Deterministisch}}\), ",", \({THETA0, F0}\), 
            ",", "\n", 
            "                   ", \({{SystemEDMdet, {Deltat, T}}, {Lik, 
                LISRELlik, Score, Hesse}}\), ",", "\n", "                   ",
             
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{
                    RowBox[{"Sing", "=", 
                      StyleBox["True",
                        FontColor->RGBColor[1, 0, 0]]}], ",", "1"}], "}"}], 
                ",", \(KMAX = 300\), ",", \({EPS1 =  .0001, EPS2 =  .0001}\), 
                ",", "\n", "                    ", \(OPTION = 0\), 
                ",", \(PRINT = {1, 1, 1, 1, 1, 1, 1, 1, 1}\)}], "}"}]}], 
          "]"}]}], ";"}]], "Input",
  PageWidth->Infinity,
  AutoIndent->False,
  TextAlignment->Left,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    RowBox[{\(General::"spell"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(Sing\\)\\\" is similar to existing symbols \
\\!\\({Sign, Sin, Sinh}\\). \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell\\\"]\\)\"\>"}]], "Message",
  PageWidth->Infinity],

Cell[BoxData[
    \("***********************LSDE1**********************************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("***********************MODUL:    BFGS (skeleton)**************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("Technical Output"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(LISRELlik\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"KMAX\"\>", "\<\"EPS1\"\>", "\<\"EPS2\"\>", "\<\"K\
\"\>", "\<\"Q\"\>", "\<\"n\"\>", "\<\"T\"\>", "\<\"OPTION    \"\>"},
          {"1", "300", "0.0001`", "0.0001`", "K$2049668", "Q$2049668", "500", 
            "5", "0"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"KMAX", "EPS1", "EPS2", "K",
           "Q", "n", "T", "OPTION    "}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"MAXSTEP\"\>", "\<\"MINSTEP\"\>", "\<\"BOUND\"\>", \
"\<\"STEPREDUCE\"\>", "\<\"FMAX\"\>"},
          {"1", "10", "1.`*^-10", "1.`*^-6", "4", "1000"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"MAXSTEP", "MINSTEP", 
          "BOUND", "STEPREDUCE", "FMAX"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"RESAMPLING\"\>", "\<\"FDIGITS\"\>", \
"\<\"TYP\"\>", "\<\"YMAX\"\>", "\<\"ANALGRAD\"\>", "\<\"FACTOR\"\>", \
"\<\"CSEED\"\>"},
          {"1", "True", "16", "1", "1000.`", "False", "1.`", \(-999\)}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"RESAMPLING", "FDIGITS", 
          "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}}, TableDirections -> {
          Column, Row}, TableSpacing -> {0, 2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("    SCALING"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    RowBox[{\(Transpose::"nmtx"\), \(\(:\)\(\ \)\), "\<\"The first two levels \
of the one-dimensional list \\!\\({}\\) cannot be transposed. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Transpose::nmtx\\\"]\\)\"\>"}]], \
"Message",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[\(Transpose[{}]\),
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
          0]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("STARTWERT THETA0 = "\[InvisibleSpace]{16, 4, 1, 2, 
          0, 0, 1, 0, 1}\),
      SequenceForm[ "STARTWERT THETA0 = ", {16, 4, 1, 2, 0, 0, 1, 0, 1}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.384185791015625`*^-7, 5.960464477539063`*^-8, 
          1.4901161193847656`*^-8, 2.9802322387695312`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.384185791015625*^-07, 5.9604644775390625*^-08, 
        1.4901161193847656*^-08, 2.9802322387695312*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \({{6.097469329833984`, 8.623847961425781`, 
        29.3134765625`, \(-40.2059326171875`\), 5.574920654296875`, 
        5.65374755859375`, 
        17.479522705078125`, \(-17.90020751953125`\), \
\(-10.474700927734375`\)}, 2887.7236043713533`}\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]1\),
      SequenceForm[ "BFGS: Iteration = ", 1],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"-21496.774854163090000\"\>",
            -21496.774854163094,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2887.723604371353000\"\>",
            2887.7236043713533,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -21496.774854163094, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2887.7236043713533, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2402.409760566619000\"\>",
            2402.4097605666188,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2887.723604371353000\"\>",
            2887.7236043713533,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2402.4097605666188, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2887.7236043713533, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2878.971259838367000\"\>",
            2878.9712598383667,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2887.723604371353000\"\>",
            2887.7236043713533,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2878.9712598383667, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2887.7236043713533, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749807040135000\"\>",
            2889.7498070401357,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2887.723604371353000\"\>",
            2887.7236043713533,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 2889.7498070401357, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2887.7236043713533, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749807040135000\"\>",
            2889.7498070401357,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2889.7498070401357, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2887.723604371353000\"\>",
            2887.7236043713533,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2887.7236043713533, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     2.026202668782389\"\>",
            2.0262026687823891,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 2.0262026687823891, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0060\"\>",
                16.00592406095798,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0000\"\>",
                16,
                Editable->False], 
              InterpretationBox["\<\" 0.0059\"\>",
                0.0059240609579796245,
                AutoDelete->True], 
              InterpretationBox["\<\" 6.0975\"\>",
                6.0974693298339844,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0084\"\>",
                4.008378590896041,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.0084\"\>",
                0.0083785908960407381,
                AutoDelete->True], 
              InterpretationBox["\<\" 8.6238\"\>",
                8.6238479614257812,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0285\"\>",
                1.0284798188646707,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 0.0285\"\>",
                0.028479818864670714,
                AutoDelete->True], 
              InterpretationBox["\<\" 29.3130\"\>",
                29.3134765625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9609\"\>",
                1.9609375,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\"-0.0391\"\>",
                -0.0390625,
                AutoDelete->True], 
              InterpretationBox["\<\"-40.2060\"\>",
                -40.2059326171875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0054\"\>",
                0.0054163732534680152,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0054\"\>",
                0.0054163732534680152,
                AutoDelete->True], 
              InterpretationBox["\<\" 5.5749\"\>",
                5.574920654296875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\" 0.0055\"\>",
                0.0054929583678692759,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0055\"\>",
                0.0054929583678692759,
                AutoDelete->True], 
              InterpretationBox["\<\" 5.6537\"\>",
                5.65374755859375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0170\"\>",
                1.016982415559619,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 0.0170\"\>",
                0.016982415559618904,
                AutoDelete->True], 
              InterpretationBox["\<\" 17.4800\"\>",
                17.479522705078125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0174\"\>",
                -0.017391136350180799,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0174\"\>",
                -0.017391136350180799,
                AutoDelete->True], 
              InterpretationBox["\<\"-17.9000\"\>",
                -17.90020751953125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9898\"\>",
                0.98982319328628854,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.0102\"\>",
                -0.010176806713711451,
                AutoDelete->True], 
              InterpretationBox["\<\"-10.4750\"\>",
                -10.474700927734375,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False]},
              {
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 0\"\>",
                  0,
                  Editable->False], 
                InterpretationBox["\<\" 1\"\>",
                  1,
                  Editable->False]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3850685448881954`*^-7, 5.972949550890984`*^-8, 
          1.5325543565521697`*^-8, 2.922024577856064`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.5154218905562445`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3850685448881954*^-07, 5.9729495508909836*^-08, 
        1.5325543565521697*^-08, 2.9220245778560638*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5154218905562445*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]9.230218161401186`*^-7\),
      SequenceForm[ "NOISE  ", 9.2302181614011856*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.3907826982378276`\
\[InvisibleSpace]"  "\[InvisibleSpace]312.87100439421755`\),
      SequenceForm[ 
      "*BFGSUP ", 0.39078269823782757, "  ", 312.87100439421755],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.020104746309191884`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.020104746309191884, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]2\),
      SequenceForm[ "BFGS: Iteration = ", 2],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  1689.090674196350000\"\>",
            1689.0906741963497,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749807040135000\"\>",
            2889.7498070401357,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 1689.0906741963497, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2889.7498070401357, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2815.683027455543000\"\>",
            2815.6830274555432,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749807040135000\"\>",
            2889.7498070401357,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2815.6830274555432, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2889.7498070401357, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.235837527591000\"\>",
            2889.2358375275903,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749807040135000\"\>",
            2889.7498070401357,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2889.2358375275903, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2889.7498070401357, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820531509937000\"\>",
            2890.8205315099372,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749807040135000\"\>",
            2889.7498070401357,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 2890.8205315099372, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2889.7498070401357, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820531509937000\"\>",
            2890.8205315099372,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2890.8205315099372, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749807040135000\"\>",
            2889.7498070401357,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2889.7498070401357, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     1.070724469801462\"\>",
            1.070724469801462,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 1.070724469801462, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0130\"\>",
                16.012511252700875,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0060\"\>",
                16.00592406095798,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0066\"\>",
                0.0065871917428943416,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.6298\"\>",
                3.6297614899530446,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0024\"\>",
                4.0024137622278602,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0084\"\>",
                4.008378590896041,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0060\"\>",
                -0.0059648286681806733,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.7255\"\>",
                -3.7254956543778412,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0675\"\>",
                1.0675423188646707,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0285\"\>",
                1.0284798188646707,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0391\"\>",
                0.039062499999999993,
                AutoDelete->True], 
              InterpretationBox["\<\" 21.7370\"\>",
                21.737012911192721,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9694\"\>",
                1.9693949069307879,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9609\"\>",
                1.9609375,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0085\"\>",
                0.0084574069307879404,
                AutoDelete->True], 
              InterpretationBox["\<\" 6.1500\"\>",
                6.1499782121513942,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0106\"\>",
                0.010594755276505234,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0054\"\>",
                0.0054163732534680152,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0052\"\>",
                0.0051783820230372193,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.8292\"\>",
                2.8292236328125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\" 0.0116\"\>",
                0.011590968679506772,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0055\"\>",
                0.0054929583678692759,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0061\"\>",
                0.0060980103116374963,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.3599\"\>",
                3.35992431640625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0180\"\>",
                1.0179550364043373,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0170\"\>",
                1.016982415559619,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0010\"\>",
                0.0009726208447182321,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0218\"\>",
                0.02178578644013059,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0456\"\>",
                -0.045618576986488787,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0174\"\>",
                -0.017391136350180799,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0282\"\>",
                -0.028227440636307992,
                AutoDelete->True], 
              InterpretationBox["\<\"-15.8090\"\>",
                -15.8094482421875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9804\"\>",
                0.98035052448921645,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9898\"\>",
                0.98982319328628854,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0095\"\>",
                -0.0094726687970720612,
                AutoDelete->True], 
              InterpretationBox["\<\"-5.1668\"\>",
                -5.166839599609375,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 3.369\"\>",
                  3.3687232275499128,
                  AutoDelete->True], 
                InterpretationBox["\<\" 11.89\"\>",
                  11.893406055596953,
                  AutoDelete->True], 
                InterpretationBox["\<\" 7.253\"\>",
                  7.253481827837347,
                  AutoDelete->True], 
                InterpretationBox["\<\"-44.63\"\>",
                  -44.630343412580316,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.638\"\>",
                  2.6377396101414892,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.202\"\>",
                  2.2018388188122557,
                  AutoDelete->True], 
                InterpretationBox["\<\" 16.8\"\>",
                  16.803674521730127,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.984\"\>",
                  -1.9839637378177837,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.1\"\>",
                  -5.0997074984157837,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 11.89\"\>",
                  11.893406055596953,
                  AutoDelete->True], 
                InterpretationBox["\<\" 60.57\"\>",
                  60.574854831498264,
                  AutoDelete->True], 
                InterpretationBox["\<\" 36.49\"\>",
                  36.488672819010219,
                  AutoDelete->True], 
                InterpretationBox["\<\"-223.6\"\>",
                  -223.60704612367107,
                  AutoDelete->True], 
                InterpretationBox["\<\" 13.24\"\>",
                  13.23628763861605,
                  AutoDelete->True], 
                InterpretationBox["\<\" 11.06\"\>",
                  11.055384768256141,
                  AutoDelete->True], 
                InterpretationBox["\<\" 84.2\"\>",
                  84.204946012155702,
                  AutoDelete->True], 
                InterpretationBox["\<\"-10.04\"\>",
                  -10.044226286596173,
                  AutoDelete->True], 
                InterpretationBox["\<\"-25.59\"\>",
                  -25.588582438919296,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 7.253\"\>",
                  7.2534818278373479,
                  AutoDelete->True], 
                InterpretationBox["\<\" 36.49\"\>",
                  36.488672819010219,
                  AutoDelete->True], 
                InterpretationBox["\<\" 23.18\"\>",
                  23.17825194328897,
                  AutoDelete->True], 
                InterpretationBox["\<\"-136.9\"\>",
                  -136.90023833566269,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.081\"\>",
                  8.0810623060257178,
                  AutoDelete->True], 
                InterpretationBox["\<\" 6.742\"\>",
                  6.7424941909363039,
                  AutoDelete->True], 
                InterpretationBox["\<\" 51.54\"\>",
                  51.53668847098745,
                  AutoDelete->True], 
                InterpretationBox["\<\"-6.035\"\>",
                  -6.0352535441504696,
                  AutoDelete->True], 
                InterpretationBox["\<\"-15.62\"\>",
                  -15.624574717571555,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-44.63\"\>",
                  -44.630343412580324,
                  AutoDelete->True], 
                InterpretationBox["\<\"-223.6\"\>",
                  -223.6070461236711,
                  AutoDelete->True], 
                InterpretationBox["\<\"-136.9\"\>",
                  -136.90023833566269,
                  AutoDelete->True], 
                InterpretationBox["\<\" 840.3\"\>",
                  840.26399670215244,
                  AutoDelete->True], 
                InterpretationBox["\<\"-49.67\"\>",
                  -49.672346593501047,
                  AutoDelete->True], 
                InterpretationBox["\<\"-41.49\"\>",
                  -41.485677369102,
                  AutoDelete->True], 
                InterpretationBox["\<\"-316.\"\>",
                  -316.04088805326472,
                  AutoDelete->True], 
                InterpretationBox["\<\" 37.66\"\>",
                  37.661741930845722,
                  AutoDelete->True], 
                InterpretationBox["\<\" 96.03\"\>",
                  96.027998506335493,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 2.638\"\>",
                  2.6377396101414896,
                  AutoDelete->True], 
                InterpretationBox["\<\" 13.24\"\>",
                  13.236287638616052,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.081\"\>",
                  8.0810623060257178,
                  AutoDelete->True], 
                InterpretationBox["\<\"-49.67\"\>",
                  -49.672346593501047,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.937\"\>",
                  3.936874250758494,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.452\"\>",
                  2.4518970562110876,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.7\"\>",
                  18.702864684110633,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.214\"\>",
                  -2.2138523695770411,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.678\"\>",
                  -5.6779348137368499,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 2.202\"\>",
                  2.2018388188122557,
                  AutoDelete->True], 
                InterpretationBox["\<\" 11.06\"\>",
                  11.055384768256143,
                  AutoDelete->True], 
                InterpretationBox["\<\" 6.742\"\>",
                  6.7424941909363039,
                  AutoDelete->True], 
                InterpretationBox["\<\"-41.49\"\>",
                  -41.485677369102,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.452\"\>",
                  2.4518970562110876,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.047\"\>",
                  3.0467119115146013,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.62\"\>",
                  15.619692809295756,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.844\"\>",
                  -1.8442400690331688,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.74\"\>",
                  -4.7404051661640629,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 16.8\"\>",
                  16.803674521730127,
                  AutoDelete->True], 
                InterpretationBox["\<\" 84.2\"\>",
                  84.204946012155716,
                  AutoDelete->True], 
                InterpretationBox["\<\" 51.54\"\>",
                  51.53668847098745,
                  AutoDelete->True], 
                InterpretationBox["\<\"-316.\"\>",
                  -316.04088805326472,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.7\"\>",
                  18.702864684110633,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.62\"\>",
                  15.619692809295756,
                  AutoDelete->True], 
                InterpretationBox["\<\" 120.\"\>",
                  120.00961774441443,
                  AutoDelete->True], 
                InterpretationBox["\<\"-14.17\"\>",
                  -14.171134923786388,
                  AutoDelete->True], 
                InterpretationBox["\<\"-36.16\"\>",
                  -36.157121077814125,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-1.984\"\>",
                  -1.9839637378177841,
                  AutoDelete->True], 
                InterpretationBox["\<\"-10.04\"\>",
                  -10.044226286596173,
                  AutoDelete->True], 
                InterpretationBox["\<\"-6.035\"\>",
                  -6.0352535441504687,
                  AutoDelete->True], 
                InterpretationBox["\<\" 37.66\"\>",
                  37.661741930845714,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.214\"\>",
                  -2.2138523695770407,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.844\"\>",
                  -1.8442400690331686,
                  AutoDelete->True], 
                InterpretationBox["\<\"-14.17\"\>",
                  -14.171134923786386,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.614\"\>",
                  2.6135900442560072,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.281\"\>",
                  4.2813216248038,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-5.1\"\>",
                  -5.0997074984157837,
                  AutoDelete->True], 
                InterpretationBox["\<\"-25.59\"\>",
                  -25.5885824389193,
                  AutoDelete->True], 
                InterpretationBox["\<\"-15.62\"\>",
                  -15.624574717571555,
                  AutoDelete->True], 
                InterpretationBox["\<\" 96.03\"\>",
                  96.027998506335479,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.678\"\>",
                  -5.6779348137368499,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.74\"\>",
                  -4.7404051661640629,
                  AutoDelete->True], 
                InterpretationBox["\<\"-36.16\"\>",
                  -36.157121077814125,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.281\"\>",
                  4.2813216248038,
                  AutoDelete->True], 
                InterpretationBox["\<\" 11.98\"\>",
                  11.977270861971739,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.386050112947952`*^-7, 5.964061263543159`*^-8, 
          1.590762017465637`*^-8, 2.9346270962518273`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.516871208555009`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.386050112947952*^-07, 5.964061263543159*^-08, 
        1.5907620174656371*^-08, 2.9346270962518273*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5168712085550089*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.731698204859472`*^-7\),
      SequenceForm[ "NOISE  ", 4.7316982048594723*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.2316022830085673`\
\[InvisibleSpace]"  "\[InvisibleSpace]504.3976546967447`\),
      SequenceForm[ "*BFGSUP ", 1.2316022830085673, "  ", 504.39765469674472],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.015567074102706515`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.015567074102706515, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]3\),
      SequenceForm[ "BFGS: Iteration = ", 3],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   787.672147583363900\"\>",
            787.67214758336388,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820531509937000\"\>",
            2890.8205315099372,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 787.67214758336388, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.8205315099372, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2592.205616855527000\"\>",
            2592.2056168555278,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820531509937000\"\>",
            2890.8205315099372,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2592.2056168555278, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.8205315099372, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2883.781335774908000\"\>",
            2883.7813357749073,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820531509937000\"\>",
            2890.8205315099372,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2883.7813357749073, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.8205315099372, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913609995775000\"\>",
            2890.913609995775,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820531509937000\"\>",
            2890.8205315099372,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 2890.913609995775, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.8205315099372, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913609995775000\"\>",
            2890.913609995775,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2890.913609995775, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820531509937000\"\>",
            2890.8205315099372,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2890.8205315099372, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.093078485837850\"\>",
            0.093078485837850167,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.093078485837850167, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0210\"\>",
                16.020920726671555,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0130\"\>",
                16.012511252700875,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0084\"\>",
                0.0084094739706782797,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.8104\"\>",
                2.8104034852153545,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0249\"\>",
                4.0248685305822534,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0024\"\>",
                4.0024137622278602,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0225\"\>",
                0.022454768354393067,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.7434\"\>",
                3.7433694559841491,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0741\"\>",
                1.0741460432279177,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0675\"\>",
                1.0675423188646707,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0066\"\>",
                0.0066037243632469933,
                AutoDelete->True], 
              InterpretationBox["\<\" 9.5837\"\>",
                9.5836833519712474,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9696\"\>",
                1.9695736777863113,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9694\"\>",
                1.9693949069307879,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0002\"\>",
                0.00017877085552351935,
                AutoDelete->True], 
              InterpretationBox["\<\"-4.8749\"\>",
                -4.8748602266397301,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0026\"\>",
                0.002615998650764147,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0106\"\>",
                0.010594755276505234,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0080\"\>",
                -0.0079787566257410875,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.2707\"\>",
                0.27069091796875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\" 0.0013\"\>",
                0.0013252327123107633,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0116\"\>",
                0.011590968679506772,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0103\"\>",
                -0.010265735967196009,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0638\"\>",
                0.06378173828125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 0.9912\"\>",
                0.99119828936629228,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0180\"\>",
                1.0179550364043373,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0268\"\>",
                -0.026756747038044947,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.1112\"\>",
                -1.1112126865414371,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0758\"\>",
                -0.075762324397641356,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0456\"\>",
                -0.045618576986488787,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0301\"\>",
                -0.030143747411152569,
                AutoDelete->True], 
              InterpretationBox["\<\"-10.0170\"\>",
                -10.016876220703125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9591\"\>",
                0.95906662503069373,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9804\"\>",
                0.98035052448921645,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0213\"\>",
                -0.021283899458522725,
                AutoDelete->True], 
              InterpretationBox["\<\"-5.5826\"\>",
                -5.5826416015625,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 4.184\"\>",
                  4.1835927737584964,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.369\"\>",
                  4.3686802298809324,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.45\"\>",
                  19.446043780313008,
                  AutoDelete->True], 
                InterpretationBox["\<\"-33.53\"\>",
                  -33.525193483777549,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.21\"\>",
                  5.2102892421994813,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.517\"\>",
                  5.5169784903527033,
                  AutoDelete->True], 
                InterpretationBox["\<\" 17.95\"\>",
                  17.946937748696445,
                  AutoDelete->True], 
                InterpretationBox["\<\"-7.777\"\>",
                  -7.7772748849113267,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.663\"\>",
                  -4.6630822627027246,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 4.369\"\>",
                  4.3686802298809324,
                  AutoDelete->True], 
                InterpretationBox["\<\" 129.3\"\>",
                  129.26588711118933,
                  AutoDelete->True], 
                InterpretationBox["\<\"-75.23\"\>",
                  -75.23227691069529,
                  AutoDelete->True], 
                InterpretationBox["\<\"-325.\"\>",
                  -325.00010647431947,
                  AutoDelete->True], 
                InterpretationBox["\<\"-10.29\"\>",
                  -10.289242862943338,
                  AutoDelete->True], 
                InterpretationBox["\<\"-19.25\"\>",
                  -19.253381116698755,
                  AutoDelete->True], 
                InterpretationBox["\<\" 73.78\"\>",
                  73.782939150887373,
                  AutoDelete->True], 
                InterpretationBox["\<\" 43.19\"\>",
                  43.186257912822917,
                  AutoDelete->True], 
                InterpretationBox["\<\"-29.43\"\>",
                  -29.430887340151436,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 19.45\"\>",
                  19.446043780313012,
                  AutoDelete->True], 
                InterpretationBox["\<\"-75.23\"\>",
                  -75.232276910695305,
                  AutoDelete->True], 
                InterpretationBox["\<\" 204.7\"\>",
                  204.66107229938893,
                  AutoDelete->True], 
                InterpretationBox["\<\" 28.\"\>",
                  27.998908743205902,
                  AutoDelete->True], 
                InterpretationBox["\<\" 46.32\"\>",
                  46.321511459813721,
                  AutoDelete->True], 
                InterpretationBox["\<\" 56.01\"\>",
                  56.013063210735652,
                  AutoDelete->True], 
                InterpretationBox["\<\" 68.5\"\>",
                  68.495057136272649,
                  AutoDelete->True], 
                InterpretationBox["\<\"-92.43\"\>",
                  -92.42681888829911,
                  AutoDelete->True], 
                InterpretationBox["\<\"-9.299\"\>",
                  -9.2988381068942871,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-33.53\"\>",
                  -33.525193483777556,
                  AutoDelete->True], 
                InterpretationBox["\<\"-325.\"\>",
                  -325.00010647431952,
                  AutoDelete->True], 
                InterpretationBox["\<\" 28.\"\>",
                  27.998908743205902,
                  AutoDelete->True], 
                InterpretationBox["\<\" 989.9\"\>",
                  989.92729229023382,
                  AutoDelete->True], 
                InterpretationBox["\<\"-14.95\"\>",
                  -14.947835898629272,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.251\"\>",
                  3.251295846132102,
                  AutoDelete->True], 
                InterpretationBox["\<\"-300.7\"\>",
                  -300.65691150452017,
                  AutoDelete->True], 
                InterpretationBox["\<\"-40.9\"\>",
                  -40.902766311011746,
                  AutoDelete->True], 
                InterpretationBox["\<\" 101.7\"\>",
                  101.70270190448392,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 5.21\"\>",
                  5.2102892421994822,
                  AutoDelete->True], 
                InterpretationBox["\<\"-10.29\"\>",
                  -10.289242862943336,
                  AutoDelete->True], 
                InterpretationBox["\<\" 46.32\"\>",
                  46.321511459813721,
                  AutoDelete->True], 
                InterpretationBox["\<\"-14.95\"\>",
                  -14.947835898629272,
                  AutoDelete->True], 
                InterpretationBox["\<\" 11.99\"\>",
                  11.991784777838159,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.83\"\>",
                  12.829722738473066,
                  AutoDelete->True], 
                InterpretationBox["\<\" 22.27\"\>",
                  22.272994235633178,
                  AutoDelete->True], 
                InterpretationBox["\<\"-20.43\"\>",
                  -20.426180196071059,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.354\"\>",
                  -4.3544294147040521,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 5.517\"\>",
                  5.5169784903527033,
                  AutoDelete->True], 
                InterpretationBox["\<\"-19.25\"\>",
                  -19.253381116698751,
                  AutoDelete->True], 
                InterpretationBox["\<\" 56.01\"\>",
                  56.013063210735652,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.251\"\>",
                  3.2512958461320949,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.83\"\>",
                  12.829722738473066,
                  AutoDelete->True], 
                InterpretationBox["\<\" 16.42\"\>",
                  16.417272778082683,
                  AutoDelete->True], 
                InterpretationBox["\<\" 20.22\"\>",
                  20.219075251531414,
                  AutoDelete->True], 
                InterpretationBox["\<\"-25.31\"\>",
                  -25.311165003004202,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.037\"\>",
                  -3.0366778739167239,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 17.95\"\>",
                  17.946937748696445,
                  AutoDelete->True], 
                InterpretationBox["\<\" 73.78\"\>",
                  73.782939150887387,
                  AutoDelete->True], 
                InterpretationBox["\<\" 68.5\"\>",
                  68.495057136272635,
                  AutoDelete->True], 
                InterpretationBox["\<\"-300.7\"\>",
                  -300.65691150452017,
                  AutoDelete->True], 
                InterpretationBox["\<\" 22.27\"\>",
                  22.272994235633178,
                  AutoDelete->True], 
                InterpretationBox["\<\" 20.22\"\>",
                  20.219075251531414,
                  AutoDelete->True], 
                InterpretationBox["\<\" 121.6\"\>",
                  121.59060735489508,
                  AutoDelete->True], 
                InterpretationBox["\<\"-22.25\"\>",
                  -22.253797481902875,
                  AutoDelete->True], 
                InterpretationBox["\<\"-35.58\"\>",
                  -35.576807293876776,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-7.777\"\>",
                  -7.7772748849113276,
                  AutoDelete->True], 
                InterpretationBox["\<\" 43.19\"\>",
                  43.186257912822917,
                  AutoDelete->True], 
                InterpretationBox["\<\"-92.43\"\>",
                  -92.42681888829911,
                  AutoDelete->True], 
                InterpretationBox["\<\"-40.9\"\>",
                  -40.902766311011753,
                  AutoDelete->True], 
                InterpretationBox["\<\"-20.43\"\>",
                  -20.426180196071059,
                  AutoDelete->True], 
                InterpretationBox["\<\"-25.31\"\>",
                  -25.311165003004202,
                  AutoDelete->True], 
                InterpretationBox["\<\"-22.25\"\>",
                  -22.253797481902872,
                  AutoDelete->True], 
                InterpretationBox["\<\" 43.71\"\>",
                  43.711683349782767,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.241\"\>",
                  1.2407565135245906,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-4.663\"\>",
                  -4.6630822627027246,
                  AutoDelete->True], 
                InterpretationBox["\<\"-29.43\"\>",
                  -29.43088734015144,
                  AutoDelete->True], 
                InterpretationBox["\<\"-9.299\"\>",
                  -9.2988381068942871,
                  AutoDelete->True], 
                InterpretationBox["\<\" 101.7\"\>",
                  101.7027019044839,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.354\"\>",
                  -4.3544294147040521,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.037\"\>",
                  -3.0366778739167239,
                  AutoDelete->True], 
                InterpretationBox["\<\"-35.58\"\>",
                  -35.576807293876776,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.241\"\>",
                  1.240756513524591,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.17\"\>",
                  12.165962867388455,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3873032222198777`*^-7, 5.997521475825091`*^-8, 
          1.6006023335872855`*^-8, 2.934893485585319`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3873032222198777*^-07, 5.9975214758250912*^-08, 
        1.6006023335872855*^-08, 2.934893485585319*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]5.428173608379439`*^-7\),
      SequenceForm[ "NOISE  ", 5.4281736083794385*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.9346459265056217`\
\[InvisibleSpace]"  "\[InvisibleSpace]414.37929042844854`\),
      SequenceForm[ 
      "*BFGSUP ", 0.93464592650562173, "  ", 414.37929042844854],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.009940339870066671`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0099403398700666709, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]4\),
      SequenceForm[ "BFGS: Iteration = ", 4],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2400.755139582835000\"\>",
            2400.7551395828355,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913609995775000\"\>",
            2890.913609995775,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2400.7551395828355, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.913609995775, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2834.379007201175000\"\>",
            2834.3790072011748,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913609995775000\"\>",
            2890.913609995775,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2834.3790072011748, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.913609995775, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2888.115013801754000\"\>",
            2888.1150138017533,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913609995775000\"\>",
            2890.913609995775,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2888.1150138017533, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.913609995775, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144593154619000\"\>",
            2891.1445931546195,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913609995775000\"\>",
            2890.913609995775,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 2891.1445931546195, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.913609995775, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144593154619000\"\>",
            2891.1445931546195,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.1445931546195, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913609995775000\"\>",
            2890.913609995775,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2890.913609995775, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.230983158844538\"\>",
            0.23098315884453768,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.23098315884453768, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0320\"\>",
                16.03200665870169,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0210\"\>",
                16.020920726671555,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011085932030134445,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.7937\"\>",
                1.7936961494677837,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0603\"\>",
                4.0603234685511786,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0249\"\>",
                4.0248685305822534,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0355\"\>",
                0.035454937968924967,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.6411\"\>",
                -0.64105688375394398,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0686\"\>",
                1.0685994148185871,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0741\"\>",
                1.0741460432279177,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0055\"\>",
                -0.0055466284093307252,
                AutoDelete->True], 
              InterpretationBox["\<\" 8.5410\"\>",
                8.541032631540725,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9864\"\>",
                1.9863940521166998,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9696\"\>",
                1.9695736777863113,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0168\"\>",
                0.016820374330388545,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.1596\"\>",
                4.15962504001849,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\"-0.0052\"\>",
                -0.0051878007849384929,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0026\"\>",
                0.002615998650764147,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0078\"\>",
                -0.0078037994357026399,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.4730\"\>",
                4.472991943359375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0170\"\>",
                -0.01700169192674833,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0013\"\>",
                0.0013252327123107633,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0183\"\>",
                -0.018326924639059092,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.7007\"\>",
                1.700714111328125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0021\"\>",
                1.0020570953145878,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9912\"\>",
                0.99119828936629228,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0109\"\>",
                0.010858805948295455,
                AutoDelete->True], 
              InterpretationBox["\<\" 26.4110\"\>",
                26.410980224609375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.1142\"\>",
                -0.11424315508107885,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0758\"\>",
                -0.075762324397641356,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0385\"\>",
                -0.038480830683437502,
                AutoDelete->True], 
              InterpretationBox["\<\"-6.6761\"\>",
                -6.67608642578125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9297\"\>",
                0.92973211971593128,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9591\"\>",
                0.95906662503069373,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0293\"\>",
                -0.029334505314762491,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.2839\"\>",
                -2.28387451171875,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 5.1\"\>",
                  5.0997896830570406,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.469\"\>",
                  8.4685116321858036,
                  AutoDelete->True], 
                InterpretationBox["\<\" 20.27\"\>",
                  20.266532680202126,
                  AutoDelete->True], 
                InterpretationBox["\<\"-42.02\"\>",
                  -42.023689690317475,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.212\"\>",
                  1.2121947429631201,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.96\"\>",
                  3.9603314914460106,
                  AutoDelete->True], 
                InterpretationBox["\<\"-8.187\"\>",
                  -8.1865927667768688,
                  AutoDelete->True], 
                InterpretationBox["\<\"-10.77\"\>",
                  -10.773898743807123,
                  AutoDelete->True], 
                InterpretationBox["\<\"-7.699\"\>",
                  -7.6985698012499526,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 8.469\"\>",
                  8.4685116321858036,
                  AutoDelete->True], 
                InterpretationBox["\<\" 147.1\"\>",
                  147.14416539068239,
                  AutoDelete->True], 
                InterpretationBox["\<\"-71.19\"\>",
                  -71.18644956121112,
                  AutoDelete->True], 
                InterpretationBox["\<\"-361.9\"\>",
                  -361.90701583543955,
                  AutoDelete->True], 
                InterpretationBox["\<\"-27.52\"\>",
                  -27.516201317414684,
                  AutoDelete->True], 
                InterpretationBox["\<\"-25.96\"\>",
                  -25.962853381897148,
                  AutoDelete->True], 
                InterpretationBox["\<\"-38.97\"\>",
                  -38.973574535369295,
                  AutoDelete->True], 
                InterpretationBox["\<\" 29.73\"\>",
                  29.733171384912751,
                  AutoDelete->True], 
                InterpretationBox["\<\"-42.82\"\>",
                  -42.816723719434151,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 20.27\"\>",
                  20.266532680202129,
                  AutoDelete->True], 
                InterpretationBox["\<\"-71.19\"\>",
                  -71.186449561211134,
                  AutoDelete->True], 
                InterpretationBox["\<\" 205.1\"\>",
                  205.09640335304306,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.49\"\>",
                  19.49012082125423,
                  AutoDelete->True], 
                InterpretationBox["\<\" 42.21\"\>",
                  42.209927208538062,
                  AutoDelete->True], 
                InterpretationBox["\<\" 54.41\"\>",
                  54.413992496792559,
                  AutoDelete->True], 
                InterpretationBox["\<\" 41.74\"\>",
                  41.741761671040251,
                  AutoDelete->True], 
                InterpretationBox["\<\"-95.08\"\>",
                  -95.075457570001475,
                  AutoDelete->True], 
                InterpretationBox["\<\"-12.18\"\>",
                  -12.175226245011142,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-42.02\"\>",
                  -42.023689690317482,
                  AutoDelete->True], 
                InterpretationBox["\<\"-361.9\"\>",
                  -361.90701583543961,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.49\"\>",
                  19.49012082125423,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1066.\"\>",
                  1066.0646314257574,
                  AutoDelete->True], 
                InterpretationBox["\<\" 20.54\"\>",
                  20.544926053114835,
                  AutoDelete->True], 
                InterpretationBox["\<\" 17.08\"\>",
                  17.075592193586409,
                  AutoDelete->True], 
                InterpretationBox["\<\"-68.29\"\>",
                  -68.292531454455627,
                  AutoDelete->True], 
                InterpretationBox["\<\"-13.\"\>",
                  -13.001741435641815,
                  AutoDelete->True], 
                InterpretationBox["\<\" 129.4\"\>",
                  129.38556327811096,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 1.212\"\>",
                  1.212194742963121,
                  AutoDelete->True], 
                InterpretationBox["\<\"-27.52\"\>",
                  -27.516201317414684,
                  AutoDelete->True], 
                InterpretationBox["\<\" 42.21\"\>",
                  42.209927208538062,
                  AutoDelete->True], 
                InterpretationBox["\<\" 20.54\"\>",
                  20.544926053114835,
                  AutoDelete->True], 
                InterpretationBox["\<\" 28.5\"\>",
                  28.49654597635832,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.26\"\>",
                  19.258933163704718,
                  AutoDelete->True], 
                InterpretationBox["\<\" 130.4\"\>",
                  130.37280965085964,
                  AutoDelete->True], 
                InterpretationBox["\<\"-7.288\"\>",
                  -7.2875374677743885,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.612\"\>",
                  8.6115728143914758,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 3.96\"\>",
                  3.9603314914460106,
                  AutoDelete->True], 
                InterpretationBox["\<\"-25.96\"\>",
                  -25.962853381897141,
                  AutoDelete->True], 
                InterpretationBox["\<\" 54.41\"\>",
                  54.413992496792559,
                  AutoDelete->True], 
                InterpretationBox["\<\" 17.08\"\>",
                  17.075592193586402,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.26\"\>",
                  19.258933163704718,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.92\"\>",
                  18.921675299266131,
                  AutoDelete->True], 
                InterpretationBox["\<\" 62.33\"\>",
                  62.327162279001875,
                  AutoDelete->True], 
                InterpretationBox["\<\"-20.2\"\>",
                  -20.19587671374352,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.013\"\>",
                  2.0125294161681015,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-8.187\"\>",
                  -8.1865927667768688,
                  AutoDelete->True], 
                InterpretationBox["\<\"-38.97\"\>",
                  -38.973574535369266,
                  AutoDelete->True], 
                InterpretationBox["\<\" 41.74\"\>",
                  41.741761671040237,
                  AutoDelete->True], 
                InterpretationBox["\<\"-68.29\"\>",
                  -68.292531454455656,
                  AutoDelete->True], 
                InterpretationBox["\<\" 130.4\"\>",
                  130.37280965085961,
                  AutoDelete->True], 
                InterpretationBox["\<\" 62.33\"\>",
                  62.327162279001868,
                  AutoDelete->True], 
                InterpretationBox["\<\" 829.6\"\>",
                  829.55008037277867,
                  AutoDelete->True], 
                InterpretationBox["\<\" 63.61\"\>",
                  63.612647426220519,
                  AutoDelete->True], 
                InterpretationBox["\<\" 49.24\"\>",
                  49.239821775226893,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-10.77\"\>",
                  -10.773898743807123,
                  AutoDelete->True], 
                InterpretationBox["\<\" 29.73\"\>",
                  29.733171384912751,
                  AutoDelete->True], 
                InterpretationBox["\<\"-95.08\"\>",
                  -95.075457570001475,
                  AutoDelete->True], 
                InterpretationBox["\<\"-13.\"\>",
                  -13.001741435641822,
                  AutoDelete->True], 
                InterpretationBox["\<\"-7.288\"\>",
                  -7.2875374677743885,
                  AutoDelete->True], 
                InterpretationBox["\<\"-20.2\"\>",
                  -20.19587671374352,
                  AutoDelete->True], 
                InterpretationBox["\<\" 63.61\"\>",
                  63.612647426220541,
                  AutoDelete->True], 
                InterpretationBox["\<\" 53.51\"\>",
                  53.508722502390327,
                  AutoDelete->True], 
                InterpretationBox["\<\" 11.19\"\>",
                  11.187428182586336,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-7.699\"\>",
                  -7.6985698012499526,
                  AutoDelete->True], 
                InterpretationBox["\<\"-42.82\"\>",
                  -42.816723719434158,
                  AutoDelete->True], 
                InterpretationBox["\<\"-12.18\"\>",
                  -12.175226245011142,
                  AutoDelete->True], 
                InterpretationBox["\<\" 129.4\"\>",
                  129.38556327811094,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.612\"\>",
                  8.611572814391474,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.013\"\>",
                  2.0125294161681007,
                  AutoDelete->True], 
                InterpretationBox["\<\" 49.24\"\>",
                  49.239821775226893,
                  AutoDelete->True], 
                InterpretationBox["\<\" 11.19\"\>",
                  11.187428182586334,
                  AutoDelete->True], 
                InterpretationBox["\<\" 22.14\"\>",
                  22.139593415788475,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3889551548215284`*^-7, 6.050353450404374`*^-8, 
          1.5923372131863044`*^-8, 2.9599577965091166`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4931814302721437`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3889551548215284*^-07, 6.0503534504043738*^-08, 
        1.5923372131863044*^-08, 2.9599577965091166*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4931814302721437*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]6.177310360271276`*^-7\),
      SequenceForm[ "NOISE  ", 6.1773103602712757*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.513313446163883`\
\[InvisibleSpace]"  "\[InvisibleSpace]453.6088587717426`\),
      SequenceForm[ "*BFGSUP ", 1.5133134461638831, "  ", 453.60885877174258],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.008981314230236837`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0089813142302368372, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]5\),
      SequenceForm[ "BFGS: Iteration = ", 5],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2672.667298410380000\"\>",
            2672.6672984103802,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144593154619000\"\>",
            2891.1445931546195,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2672.6672984103802, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1445931546195, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2879.230128397071000\"\>",
            2879.2301283970714,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144593154619000\"\>",
            2891.1445931546195,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2879.2301283970714, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1445931546195, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.612489826320000\"\>",
            2890.6124898263206,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144593154619000\"\>",
            2891.1445931546195,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2890.6124898263206, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1445931546195, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161889263353000\"\>",
            2891.1618892633533,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144593154619000\"\>",
            2891.1445931546195,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 2891.1618892633533, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1445931546195, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161889263353000\"\>",
            2891.1618892633533,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.1618892633533, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144593154619000\"\>",
            2891.1445931546195,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.1445931546195, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.017296108733717\"\>",
            0.017296108733717119,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.017296108733717119, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0360\"\>",
                16.03608116207862,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0320\"\>",
                16.03200665870169,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0041\"\>",
                0.0040745033769312841,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.6197\"\>",
                1.6196524009100359,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0691\"\>",
                4.0690885222099231,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0603\"\>",
                4.0603234685511786,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0088\"\>",
                0.008765053658744219,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.7229\"\>",
                -3.7228704724363126,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0664\"\>",
                1.0663801446545476,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0686\"\>",
                1.0685994148185871,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0022\"\>",
                -0.0022192701640396419,
                AutoDelete->True], 
              InterpretationBox["\<\" 11.6330\"\>",
                11.63269828496813,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9896\"\>",
                1.9896278329056363,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9864\"\>",
                1.9863940521166998,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0032\"\>",
                0.0032337807889364807,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.5958\"\>",
                -0.59578897672714715,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0078\"\>",
                0.0077746898569166977,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0052\"\>",
                -0.0051878007849384929,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0130\"\>",
                0.012962490641855191,
                AutoDelete->True], 
              InterpretationBox["\<\" 8.7775\"\>",
                8.777496337890625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0150\"\>",
                -0.015036959971286186,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0170\"\>",
                -0.01700169192674833,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0020\"\>",
                0.0019647319554621442,
                AutoDelete->True], 
              InterpretationBox["\<\" 5.6326\"\>",
                5.632598876953125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0013\"\>",
                1.0012608195143478,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0021\"\>",
                1.0020570953145878,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0008\"\>",
                -0.00079627580024006252,
                AutoDelete->True], 
              InterpretationBox["\<\" 15.0440\"\>",
                15.044247860714227,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.1176\"\>",
                -0.11758157839060221,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1142\"\>",
                -0.11424315508107885,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0033\"\>",
                -0.0033384233095233606,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.0909\"\>",
                -3.09088134765625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9262\"\>",
                0.92620664640574379,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9297\"\>",
                0.92973211971593128,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0035\"\>",
                -0.0035254733101874663,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.6284\"\>",
                0.62835693359375,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 5.123\"\>",
                  5.123360873365205,
                  AutoDelete->True], 
                InterpretationBox["\<\" 9.288\"\>",
                  9.2881669443961847,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.35\"\>",
                  19.346203458605014,
                  AutoDelete->True], 
                InterpretationBox["\<\"-40.82\"\>",
                  -40.822837884037611,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.02293\"\>",
                  0.022929885703394159,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.904\"\>",
                  2.9036263412395003,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.521\"\>",
                  -5.5206867459733129,
                  AutoDelete->True], 
                InterpretationBox["\<\"-11.64\"\>",
                  -11.635295569923453,
                  AutoDelete->True], 
                InterpretationBox["\<\"-8.437\"\>",
                  -8.4372467663183102,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 9.288\"\>",
                  9.2881669443961847,
                  AutoDelete->True], 
                InterpretationBox["\<\" 161.5\"\>",
                  161.51412891054082,
                  AutoDelete->True], 
                InterpretationBox["\<\"-85.57\"\>",
                  -85.567307749946906,
                  AutoDelete->True], 
                InterpretationBox["\<\"-339.7\"\>",
                  -339.71049736154538,
                  AutoDelete->True], 
                InterpretationBox["\<\"-47.57\"\>",
                  -47.571486374649744,
                  AutoDelete->True], 
                InterpretationBox["\<\"-44.29\"\>",
                  -44.292634510493755,
                  AutoDelete->True], 
                InterpretationBox["\<\" 14.16\"\>",
                  14.155210747735836,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.98\"\>",
                  12.983049017240507,
                  AutoDelete->True], 
                InterpretationBox["\<\"-56.41\"\>",
                  -56.408776709600104,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 19.35\"\>",
                  19.346203458605018,
                  AutoDelete->True], 
                InterpretationBox["\<\"-85.57\"\>",
                  -85.56730774994692,
                  AutoDelete->True], 
                InterpretationBox["\<\" 219.1\"\>",
                  219.05633356855571,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.005\"\>",
                  -3.0047450608005661,
                  AutoDelete->True], 
                InterpretationBox["\<\" 62.08\"\>",
                  62.084806698503044,
                  AutoDelete->True], 
                InterpretationBox["\<\" 72.71\"\>",
                  72.709400324555247,
                  AutoDelete->True], 
                InterpretationBox["\<\"-13.\"\>",
                  -13.000641775050099,
                  AutoDelete->True], 
                InterpretationBox["\<\"-77.91\"\>",
                  -77.906835001972198,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.585\"\>",
                  1.5851278942745566,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-40.82\"\>",
                  -40.822837884037618,
                  AutoDelete->True], 
                InterpretationBox["\<\"-339.7\"\>",
                  -339.71049736154544,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.005\"\>",
                  -3.0047450608005661,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1100.\"\>",
                  1100.1668854062552,
                  AutoDelete->True], 
                InterpretationBox["\<\"-10.56\"\>",
                  -10.560928626054991,
                  AutoDelete->True], 
                InterpretationBox["\<\"-11.27\"\>",
                  -11.268914201096894,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.75\"\>",
                  12.746987929079893,
                  AutoDelete->True], 
                InterpretationBox["\<\"-38.61\"\>",
                  -38.610215116285168,
                  AutoDelete->True], 
                InterpretationBox["\<\" 108.5\"\>",
                  108.49364267488812,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 0.02293\"\>",
                  0.022929885703395048,
                  AutoDelete->True], 
                InterpretationBox["\<\"-47.57\"\>",
                  -47.571486374649737,
                  AutoDelete->True], 
                InterpretationBox["\<\" 62.08\"\>",
                  62.084806698503044,
                  AutoDelete->True], 
                InterpretationBox["\<\"-10.56\"\>",
                  -10.560928626054991,
                  AutoDelete->True], 
                InterpretationBox["\<\" 56.4\"\>",
                  56.397881287947996,
                  AutoDelete->True], 
                InterpretationBox["\<\" 44.82\"\>",
                  44.818829700386338,
                  AutoDelete->True], 
                InterpretationBox["\<\" 55.51\"\>",
                  55.511501635318226,
                  AutoDelete->True], 
                InterpretationBox["\<\" 16.27\"\>",
                  16.273410270175599,
                  AutoDelete->True], 
                InterpretationBox["\<\" 27.65\"\>",
                  27.65274448975596,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 2.904\"\>",
                  2.9036263412394998,
                  AutoDelete->True], 
                InterpretationBox["\<\"-44.29\"\>",
                  -44.292634510493755,
                  AutoDelete->True], 
                InterpretationBox["\<\" 72.71\"\>",
                  72.709400324555247,
                  AutoDelete->True], 
                InterpretationBox["\<\"-11.27\"\>",
                  -11.268914201096905,
                  AutoDelete->True], 
                InterpretationBox["\<\" 44.82\"\>",
                  44.818829700386345,
                  AutoDelete->True], 
                InterpretationBox["\<\" 42.3\"\>",
                  42.297054128164845,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.618\"\>",
                  -5.6177717039432693,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.215\"\>",
                  1.2153053813902517,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.37\"\>",
                  19.367698187614934,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-5.521\"\>",
                  -5.5206867459733129,
                  AutoDelete->True], 
                InterpretationBox["\<\" 14.16\"\>",
                  14.155210747735872,
                  AutoDelete->True], 
                InterpretationBox["\<\"-13.\"\>",
                  -13.000641775050127,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.75\"\>",
                  12.746987929079864,
                  AutoDelete->True], 
                InterpretationBox["\<\" 55.51\"\>",
                  55.511501635318183,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.618\"\>",
                  -5.6177717039432622,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1020.\"\>",
                  1020.2460817165879,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.162\"\>",
                  3.1624135827182087,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.4372\"\>",
                  -0.43721864273444311,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-11.64\"\>",
                  -11.635295569923453,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.98\"\>",
                  12.983049017240507,
                  AutoDelete->True], 
                InterpretationBox["\<\"-77.91\"\>",
                  -77.906835001972198,
                  AutoDelete->True], 
                InterpretationBox["\<\"-38.61\"\>",
                  -38.610215116285175,
                  AutoDelete->True], 
                InterpretationBox["\<\" 16.27\"\>",
                  16.273410270175599,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.215\"\>",
                  1.2153053813902481,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.162\"\>",
                  3.1624135827182371,
                  AutoDelete->True], 
                InterpretationBox["\<\" 72.65\"\>",
                  72.651899532802503,
                  AutoDelete->True], 
                InterpretationBox["\<\" 26.88\"\>",
                  26.882318794823384,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-8.437\"\>",
                  -8.4372467663183102,
                  AutoDelete->True], 
                InterpretationBox["\<\"-56.41\"\>",
                  -56.408776709600119,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.585\"\>",
                  1.5851278942745566,
                  AutoDelete->True], 
                InterpretationBox["\<\" 108.5\"\>",
                  108.49364267488809,
                  AutoDelete->True], 
                InterpretationBox["\<\" 27.65\"\>",
                  27.65274448975596,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.37\"\>",
                  19.367698187614934,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.4372\"\>",
                  -0.437218642734436,
                  AutoDelete->True], 
                InterpretationBox["\<\" 26.88\"\>",
                  26.88231879482338,
                  AutoDelete->True], 
                InterpretationBox["\<\" 34.94\"\>",
                  34.938040732829506,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3895623031375736`*^-7, 6.063414398148541`*^-8, 
          1.5890302429415994`*^-8, 2.9647765053892676`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.49199488686673`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3895623031375736*^-07, 6.0634143981485413*^-08, 
        1.5890302429415994*^-08, 2.9647765053892676*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4919948868667301*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.5834243467032525`*^-7\),
      SequenceForm[ "NOISE  ", 4.5834243467032525*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]10.01514383896953`\
\[InvisibleSpace]"  "\[InvisibleSpace]3809.8541146397974`\),
      SequenceForm[ "*BFGSUP ", 10.01514383896953, "  ", 3809.8541146397974],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.010115562067855736`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.010115562067855736, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]6\),
      SequenceForm[ "BFGS: Iteration = ", 6],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2886.606141022256000\"\>",
            2886.6061410222555,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161889263353000\"\>",
            2891.1618892633533,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2886.6061410222555, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1618892633533, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.002249021648000\"\>",
            2891.0022490216484,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161889263353000\"\>",
            2891.1618892633533,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2891.0022490216484, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1618892633533, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187304770175000\"\>",
            2891.1873047701747,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161889263353000\"\>",
            2891.1618892633533,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2891.1873047701747, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1618892633533, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187304770175000\"\>",
            2891.1873047701747,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.1873047701747, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161889263353000\"\>",
            2891.1618892633533,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.1618892633533, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.025415506821446\"\>",
            0.025415506821445888,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.025415506821445888, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0520\"\>",
                16.052105975165475,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0360\"\>",
                16.03608116207862,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0160\"\>",
                0.016024813086853624,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.8237\"\>",
                1.8237452930970091,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0780\"\>",
                4.0780436850005444,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0691\"\>",
                4.0690885222099231,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0090\"\>",
                0.0089551627906215882,
                AutoDelete->True], 
              InterpretationBox["\<\"-5.0929\"\>",
                -5.0929197402937456,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0657\"\>",
                1.0657019038834785,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0664\"\>",
                1.0663801446545476,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0007\"\>",
                -0.00067824077106903359,
                AutoDelete->True], 
              InterpretationBox["\<\" 12.1920\"\>",
                12.191547301193397,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9929\"\>",
                1.9929040875544584,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9896\"\>",
                1.9896278329056363,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0033\"\>",
                0.0032762546488221841,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.9945\"\>",
                -0.99452229975952589,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0053\"\>",
                0.0052797181523784389,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0078\"\>",
                0.0077746898569166977,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0025\"\>",
                -0.0024949717045382584,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.2959\"\>",
                2.2958984375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0007\"\>",
                -0.00067779327562618799,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0150\"\>",
                -0.015036959971286186,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0144\"\>",
                0.014359166695659998,
                AutoDelete->True], 
              InterpretationBox["\<\" 5.2162\"\>",
                5.216156005859375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0017\"\>",
                1.0016649821199686,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0013\"\>",
                1.0012608195143478,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0004\"\>",
                0.00040416260562070789,
                AutoDelete->True], 
              InterpretationBox["\<\" 15.7150\"\>",
                15.714592253005517,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.1169\"\>",
                -0.11689948061190197,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1176\"\>",
                -0.11758157839060221,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0007\"\>",
                0.0006820977787002384,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.2884\"\>",
                -3.28839111328125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9283\"\>",
                0.92833941093944816,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9262\"\>",
                0.92620664640574379,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0021\"\>",
                0.0021327645337043161,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0345\"\>",
                1.034515380859375,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 5.388\"\>",
                  5.3880299837871197,
                  AutoDelete->True], 
                InterpretationBox["\<\" 6.838\"\>",
                  6.8382916852992164,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.39\"\>",
                  19.393207866316569,
                  AutoDelete->True], 
                InterpretationBox["\<\"-41.58\"\>",
                  -41.58175924459016,
                  AutoDelete->True], 
                InterpretationBox["\<\"-14.05\"\>",
                  -14.052041924469888,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.522\"\>",
                  1.5220632120749673,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.567\"\>",
                  -5.5670031107980398,
                  AutoDelete->True], 
                InterpretationBox["\<\"-11.75\"\>",
                  -11.747982894727228,
                  AutoDelete->True], 
                InterpretationBox["\<\"-7.666\"\>",
                  -7.666214790091491,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 6.838\"\>",
                  6.8382916852992164,
                  AutoDelete->True], 
                InterpretationBox["\<\" 179.5\"\>",
                  179.50718415948529,
                  AutoDelete->True], 
                InterpretationBox["\<\"-90.72\"\>",
                  -90.717809055251678,
                  AutoDelete->True], 
                InterpretationBox["\<\"-334.4\"\>",
                  -334.36832485456102,
                  AutoDelete->True], 
                InterpretationBox["\<\" 43.26\"\>",
                  43.263742039650232,
                  AutoDelete->True], 
                InterpretationBox["\<\"-37.36\"\>",
                  -37.3594895599661,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.213\"\>",
                  8.2131973480708265,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.02\"\>",
                  15.024185683821258,
                  AutoDelete->True], 
                InterpretationBox["\<\"-61.85\"\>",
                  -61.845782629346083,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 19.39\"\>",
                  19.393207866316573,
                  AutoDelete->True], 
                InterpretationBox["\<\"-90.72\"\>",
                  -90.717809055251692,
                  AutoDelete->True], 
                InterpretationBox["\<\" 214.3\"\>",
                  214.31754418057295,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.834\"\>",
                  -4.8335330604802103,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.87\"\>",
                  19.871802272142148,
                  AutoDelete->True], 
                InterpretationBox["\<\" 66.57\"\>",
                  66.569529994121481,
                  AutoDelete->True], 
                InterpretationBox["\<\"-19.42\"\>",
                  -19.422465659945857,
                  AutoDelete->True], 
                InterpretationBox["\<\"-76.92\"\>",
                  -76.922071713867552,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.433\"\>",
                  3.4334498053540603,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-41.58\"\>",
                  -41.581759244590167,
                  AutoDelete->True], 
                InterpretationBox["\<\"-334.4\"\>",
                  -334.36832485456108,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.834\"\>",
                  -4.8335330604802111,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1102.\"\>",
                  1101.7385403064366,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.63\"\>",
                  15.626512812199408,
                  AutoDelete->True], 
                InterpretationBox["\<\"-9.411\"\>",
                  -9.4108154566761151,
                  AutoDelete->True], 
                InterpretationBox["\<\" 10.59\"\>",
                  10.59111802981479,
                  AutoDelete->True], 
                InterpretationBox["\<\"-37.93\"\>",
                  -37.928539308135825,
                  AutoDelete->True], 
                InterpretationBox["\<\" 106.9\"\>",
                  106.89346450054684,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-14.05\"\>",
                  -14.052041924469886,
                  AutoDelete->True], 
                InterpretationBox["\<\" 43.26\"\>",
                  43.263742039650239,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.87\"\>",
                  19.871802272142148,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.63\"\>",
                  15.626512812199405,
                  AutoDelete->True], 
                InterpretationBox["\<\" 472.7\"\>",
                  472.66632109552921,
                  AutoDelete->True], 
                InterpretationBox["\<\" 68.98\"\>",
                  68.977718717099407,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.32\"\>",
                  4.3200637436006843,
                  AutoDelete->True], 
                InterpretationBox["\<\" 30.67\"\>",
                  30.671766441505127,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9667\"\>",
                  0.96668911807655888,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 1.522\"\>",
                  1.5220632120749669,
                  AutoDelete->True], 
                InterpretationBox["\<\"-37.36\"\>",
                  -37.3594895599661,
                  AutoDelete->True], 
                InterpretationBox["\<\" 66.57\"\>",
                  66.569529994121481,
                  AutoDelete->True], 
                InterpretationBox["\<\"-9.411\"\>",
                  -9.4108154566761257,
                  AutoDelete->True], 
                InterpretationBox["\<\" 68.98\"\>",
                  68.977718717099421,
                  AutoDelete->True], 
                InterpretationBox["\<\" 42.19\"\>",
                  42.189565524062196,
                  AutoDelete->True], 
                InterpretationBox["\<\"-13.34\"\>",
                  -13.339751691137341,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.051\"\>",
                  3.051157348773581,
                  AutoDelete->True], 
                InterpretationBox["\<\" 17.47\"\>",
                  17.467967028734513,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-5.567\"\>",
                  -5.5670031107980398,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.213\"\>",
                  8.213197348070862,
                  AutoDelete->True], 
                InterpretationBox["\<\"-19.42\"\>",
                  -19.422465659945885,
                  AutoDelete->True], 
                InterpretationBox["\<\" 10.59\"\>",
                  10.591118029814762,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.32\"\>",
                  4.3200637436006417,
                  AutoDelete->True], 
                InterpretationBox["\<\"-13.34\"\>",
                  -13.339751691137332,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1012.\"\>",
                  1011.5891240985553,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.54\"\>",
                  4.5396318945638265,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.74\"\>",
                  1.7400172959038649,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-11.75\"\>",
                  -11.747982894727228,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.02\"\>",
                  15.024185683821258,
                  AutoDelete->True], 
                InterpretationBox["\<\"-76.92\"\>",
                  -76.922071713867552,
                  AutoDelete->True], 
                InterpretationBox["\<\"-37.93\"\>",
                  -37.928539308135832,
                  AutoDelete->True], 
                InterpretationBox["\<\" 30.67\"\>",
                  30.671766441505127,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.051\"\>",
                  3.0511573487735775,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.54\"\>",
                  4.539631894563855,
                  AutoDelete->True], 
                InterpretationBox["\<\" 72.49\"\>",
                  72.487207730129754,
                  AutoDelete->True], 
                InterpretationBox["\<\" 26.19\"\>",
                  26.191807391089213,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-7.666\"\>",
                  -7.666214790091491,
                  AutoDelete->True], 
                InterpretationBox["\<\"-61.85\"\>",
                  -61.845782629346097,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.433\"\>",
                  3.4334498053540603,
                  AutoDelete->True], 
                InterpretationBox["\<\" 106.9\"\>",
                  106.89346450054681,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9667\"\>",
                  0.96668911807655888,
                  AutoDelete->True], 
                InterpretationBox["\<\" 17.47\"\>",
                  17.467967028734513,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.74\"\>",
                  1.7400172959038716,
                  AutoDelete->True], 
                InterpretationBox["\<\" 26.19\"\>",
                  26.19180739108921,
                  AutoDelete->True], 
                InterpretationBox["\<\" 36.57\"\>",
                  36.56723268010569,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3919501863666586`*^-7, 6.076758630574561`*^-8, 
          1.5880195854358055`*^-8, 2.9696585052526867`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4925971360802182`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3919501863666586*^-07, 6.0767586305745607*^-08, 
        1.5880195854358055*^-08, 2.9696585052526867*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4925971360802182*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.6192547149901426`*^-7\),
      SequenceForm[ "NOISE  ", 4.6192547149901426*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]22.61158521387642`\
\[InvisibleSpace]"  "\[InvisibleSpace]1345.209988074029`\),
      SequenceForm[ "*BFGSUP ", 22.61158521387642, "  ", 1345.2099880740291],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.010982608095719158`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.010982608095719158, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]7\),
      SequenceForm[ "BFGS: Iteration = ", 7],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2885.268332727747000\"\>",
            2885.2683327277464,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187304770175000\"\>",
            2891.1873047701747,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2885.2683327277464, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1873047701747, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.070653651223000\"\>",
            2891.070653651223,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187304770175000\"\>",
            2891.1873047701747,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2891.070653651223, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1873047701747, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247752815606000\"\>",
            2891.2477528156064,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187304770175000\"\>",
            2891.1873047701747,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2891.2477528156064, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1873047701747, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247752815606000\"\>",
            2891.2477528156064,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.2477528156064, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187304770175000\"\>",
            2891.1873047701747,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.1873047701747, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.060448045431713\"\>",
            0.060448045431712671,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.060448045431712671, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0990\"\>",
                16.098588653766868,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0520\"\>",
                16.052105975165475,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0465\"\>",
                0.046482678601391436,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9781\"\>",
                1.9781066203235085,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0790\"\>",
                4.0789744809669246,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0780\"\>",
                4.0780436850005444,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0009\"\>",
                0.00093079596638027983,
                AutoDelete->True], 
              InterpretationBox["\<\"-6.0910\"\>",
                -6.0910053704647371,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0639\"\>",
                1.0638764871756077,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0657\"\>",
                1.0657019038834785,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0018\"\>",
                -0.0018254167078707313,
                AutoDelete->True], 
              InterpretationBox["\<\" 11.8980\"\>",
                11.898483778811638,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9942\"\>",
                1.9942399061962799,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9929\"\>",
                1.9929040875544584,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0013\"\>",
                0.0013358186418216075,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.3652\"\>",
                -1.3652258415983112,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0064\"\>",
                0.0064215890968302453,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0053\"\>",
                0.0052797181523784389,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0011\"\>",
                0.0011418709444518059,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.2600\"\>",
                3.259979248046875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\" 0.0018\"\>",
                0.0018213398625695505,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0007\"\>",
                -0.00067779327562618799,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0025\"\>",
                0.0024991331381957384,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.8673\"\>",
                2.867340087890625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0026\"\>",
                1.0025752682904323,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0017\"\>",
                1.0016649821199686,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0009\"\>",
                0.00091028617046379429,
                AutoDelete->True], 
              InterpretationBox["\<\" 15.2850\"\>",
                15.284701391957707,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.1160\"\>",
                -0.11604860495855496,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1169\"\>",
                -0.11689948061190197,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0009\"\>",
                0.00085087565334701794,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.4697\"\>",
                -3.469696044921875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9353\"\>",
                0.93526593578774497,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9283\"\>",
                0.92833941093944816,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0069\"\>",
                0.0069265248482967964,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.8867\"\>",
                0.886749267578125,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 4.834\"\>",
                  4.834464031218042,
                  AutoDelete->True], 
                InterpretationBox["\<\" 6.405\"\>",
                  6.4050498283276394,
                  AutoDelete->True], 
                InterpretationBox["\<\" 11.07\"\>",
                  11.068122030395093,
                  AutoDelete->True], 
                InterpretationBox["\<\"-42.28\"\>",
                  -42.27997167248936,
                  AutoDelete->True], 
                InterpretationBox["\<\"-12.06\"\>",
                  -12.062198560903358,
                  AutoDelete->True], 
                InterpretationBox["\<\"-9.8\"\>",
                  -9.8003801542240403,
                  AutoDelete->True], 
                InterpretationBox["\<\"-16.48\"\>",
                  -16.479810831795994,
                  AutoDelete->True], 
                InterpretationBox["\<\"-10.41\"\>",
                  -10.411202478842332,
                  AutoDelete->True], 
                InterpretationBox["\<\"-8.802\"\>",
                  -8.8015992173578965,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 6.405\"\>",
                  6.4050498283276394,
                  AutoDelete->True], 
                InterpretationBox["\<\" 193.5\"\>",
                  193.51376518947094,
                  AutoDelete->True], 
                InterpretationBox["\<\"-63.71\"\>",
                  -63.712053153559481,
                  AutoDelete->True], 
                InterpretationBox["\<\"-327.7\"\>",
                  -327.66563342077518,
                  AutoDelete->True], 
                InterpretationBox["\<\" 25.35\"\>",
                  25.346241576201781,
                  AutoDelete->True], 
                InterpretationBox["\<\" 24.37\"\>",
                  24.373929144980657,
                  AutoDelete->True], 
                InterpretationBox["\<\" 44.2\"\>",
                  44.199624573449576,
                  AutoDelete->True], 
                InterpretationBox["\<\" 13.62\"\>",
                  13.615704744061283,
                  AutoDelete->True], 
                InterpretationBox["\<\"-56.78\"\>",
                  -56.78060306030001,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 11.07\"\>",
                  11.068122030395099,
                  AutoDelete->True], 
                InterpretationBox["\<\"-63.71\"\>",
                  -63.712053153559495,
                  AutoDelete->True], 
                InterpretationBox["\<\" 167.4\"\>",
                  167.4451864141308,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.605\"\>",
                  1.6050029267023351,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.291\"\>",
                  4.2905253953148996,
                  AutoDelete->True], 
                InterpretationBox["\<\" 61.25\"\>",
                  61.249022800862811,
                  AutoDelete->True], 
                InterpretationBox["\<\"-79.49\"\>",
                  -79.494225324334693,
                  AutoDelete->True], 
                InterpretationBox["\<\"-62.55\"\>",
                  -62.554067636265437,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.2705\"\>",
                  0.27049039430259514,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-42.28\"\>",
                  -42.279971672489367,
                  AutoDelete->True], 
                InterpretationBox["\<\"-327.7\"\>",
                  -327.66563342077524,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.605\"\>",
                  1.6050029267023342,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1105.\"\>",
                  1104.5210172950378,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.295\"\>",
                  8.2952893320489896,
                  AutoDelete->True], 
                InterpretationBox["\<\" 11.98\"\>",
                  11.981125216593803,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.33\"\>",
                  19.327269353758673,
                  AutoDelete->True], 
                InterpretationBox["\<\"-37.48\"\>",
                  -37.482865037116895,
                  AutoDelete->True], 
                InterpretationBox["\<\" 108.5\"\>",
                  108.46996371724606,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-12.06\"\>",
                  -12.062198560903356,
                  AutoDelete->True], 
                InterpretationBox["\<\" 25.35\"\>",
                  25.346241576201788,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.291\"\>",
                  4.2905253953148978,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.295\"\>",
                  8.295289332048986,
                  AutoDelete->True], 
                InterpretationBox["\<\" 492.\"\>",
                  491.95154677303248,
                  AutoDelete->True], 
                InterpretationBox["\<\" 13.84\"\>",
                  13.841866368670409,
                  AutoDelete->True], 
                InterpretationBox["\<\"-16.9\"\>",
                  -16.900412392122607,
                  AutoDelete->True], 
                InterpretationBox["\<\" 29.2\"\>",
                  29.198940886424488,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.035\"\>",
                  -3.0345679960269587,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-9.8\"\>",
                  -9.8003801542240421,
                  AutoDelete->True], 
                InterpretationBox["\<\" 24.37\"\>",
                  24.373929144980657,
                  AutoDelete->True], 
                InterpretationBox["\<\" 61.25\"\>",
                  61.249022800862804,
                  AutoDelete->True], 
                InterpretationBox["\<\" 11.98\"\>",
                  11.981125216593792,
                  AutoDelete->True], 
                InterpretationBox["\<\" 13.84\"\>",
                  13.841866368670424,
                  AutoDelete->True], 
                InterpretationBox["\<\" 158.\"\>",
                  158.0004833629535,
                  AutoDelete->True], 
                InterpretationBox["\<\"-17.43\"\>",
                  -17.428597583644994,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.31\"\>",
                  18.313660858757075,
                  AutoDelete->True], 
                InterpretationBox["\<\" 23.54\"\>",
                  23.543671883846567,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-16.48\"\>",
                  -16.479810831795994,
                  AutoDelete->True], 
                InterpretationBox["\<\" 44.2\"\>",
                  44.199624573449611,
                  AutoDelete->True], 
                InterpretationBox["\<\"-79.49\"\>",
                  -79.494225324334721,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.33\"\>",
                  19.327269353758645,
                  AutoDelete->True], 
                InterpretationBox["\<\"-16.9\"\>",
                  -16.90041239212265,
                  AutoDelete->True], 
                InterpretationBox["\<\"-17.43\"\>",
                  -17.428597583644979,
                  AutoDelete->True], 
                InterpretationBox["\<\" 934.7\"\>",
                  934.66498688694105,
                  AutoDelete->True], 
                InterpretationBox["\<\" 23.27\"\>",
                  23.273371809183725,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.163\"\>",
                  -2.1627465743548164,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-10.41\"\>",
                  -10.411202478842332,
                  AutoDelete->True], 
                InterpretationBox["\<\" 13.62\"\>",
                  13.615704744061283,
                  AutoDelete->True], 
                InterpretationBox["\<\"-62.55\"\>",
                  -62.554067636265437,
                  AutoDelete->True], 
                InterpretationBox["\<\"-37.48\"\>",
                  -37.482865037116902,
                  AutoDelete->True], 
                InterpretationBox["\<\" 29.2\"\>",
                  29.198940886424488,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.31\"\>",
                  18.313660858757071,
                  AutoDelete->True], 
                InterpretationBox["\<\" 23.27\"\>",
                  23.273371809183754,
                  AutoDelete->True], 
                InterpretationBox["\<\" 69.68\"\>",
                  69.679104595520741,
                  AutoDelete->True], 
                InterpretationBox["\<\" 27.91\"\>",
                  27.914838642259078,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-8.802\"\>",
                  -8.8015992173578965,
                  AutoDelete->True], 
                InterpretationBox["\<\"-56.78\"\>",
                  -56.780603060300024,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.2705\"\>",
                  0.27049039430259514,
                  AutoDelete->True], 
                InterpretationBox["\<\" 108.5\"\>",
                  108.46996371724603,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.035\"\>",
                  -3.0345679960269587,
                  AutoDelete->True], 
                InterpretationBox["\<\" 23.54\"\>",
                  23.543671883846571,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.163\"\>",
                  -2.1627465743548098,
                  AutoDelete->True], 
                InterpretationBox["\<\" 27.91\"\>",
                  27.914838642259074,
                  AutoDelete->True], 
                InterpretationBox["\<\" 36.71\"\>",
                  36.709469899774469,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3988766452322703`*^-7, 6.078145624647922`*^-8, 
          1.585299502574813`*^-8, 2.9716490301434396`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4939535681760793`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3988766452322703*^-07, 6.0781456246479222*^-08, 
        1.5852995025748129*^-08, 2.9716490301434396*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4939535681760793*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.455182138410278`*^-7\),
      SequenceForm[ "NOISE  ", 4.4551821384102781*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]16.54062255859846`\
\[InvisibleSpace]"  "\[InvisibleSpace]705.4173795435212`\),
      SequenceForm[ "*BFGSUP ", 16.540622558598461, "  ", 705.41737954352118],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.005206395232288842`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0052063952322888418, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]8\),
      SequenceForm[ "BFGS: Iteration = ", 8],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2879.218368953551000\"\>",
            2879.2183689535514,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247752815606000\"\>",
            2891.2477528156064,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2879.2183689535514, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.2477528156064, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.209302491111000\"\>",
            2891.209302491111,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247752815606000\"\>",
            2891.2477528156064,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2891.209302491111, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.2477528156064, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480888931324000\"\>",
            2891.4808889313235,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247752815606000\"\>",
            2891.2477528156064,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2891.4808889313235, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.2477528156064, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480888931324000\"\>",
            2891.4808889313235,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.4808889313235, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247752815606000\"\>",
            2891.2477528156064,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.2477528156064, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.233136115717116\"\>",
            0.2331361157171159,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.2331361157171159, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.2550\"\>",
                16.254838653766868,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0990\"\>",
                16.098588653766868,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.1563\"\>",
                0.15625,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.7533\"\>",
                0.75332895446997361,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.1057\"\>",
                4.105715015983308,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0790\"\>",
                4.0789744809669246,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0267\"\>",
                0.026740535016383467,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.6904\"\>",
                -3.6903831063087891,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0887\"\>",
                1.0887151553890786,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0639\"\>",
                1.0638764871756077,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0248\"\>",
                0.024838668213470912,
                AutoDelete->True], 
              InterpretationBox["\<\" 13.1490\"\>",
                13.149497226983641,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0078\"\>",
                2.0078033259365009,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9942\"\>",
                1.9942399061962799,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0136\"\>",
                0.013563419740221096,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.6697\"\>",
                -0.66968384784433477,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0070\"\>",
                0.0070065439778675765,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0064\"\>",
                0.0064215890968302453,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0006\"\>",
                0.00058495488103733136,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.6465\"\>",
                2.646484375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0089\"\>",
                -0.008895688852179482,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0018\"\>",
                0.0018213398625695505,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0107\"\>",
                -0.010717028714749033,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.5446\"\>",
                2.5445556640625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0058\"\>",
                1.0058321741618075,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0026\"\>",
                1.0025752682904323,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0033\"\>",
                0.0032569058713751296,
                AutoDelete->True], 
              InterpretationBox["\<\" 14.6140\"\>",
                14.613519830222748,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0763\"\>",
                -0.076295927254525234,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1160\"\>",
                -0.11604860495855496,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0398\"\>",
                0.039752677704029724,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.0566\"\>",
                -1.05657958984375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9520\"\>",
                0.95203381739646575,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9353\"\>",
                0.93526593578774497,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0168\"\>",
                0.016767881608720732,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.2600\"\>",
                0.259979248046875,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 28.97\"\>",
                  28.97284188387189,
                  AutoDelete->True], 
                InterpretationBox["\<\"-40.15\"\>",
                  -40.15312815811199,
                  AutoDelete->True], 
                InterpretationBox["\<\"-18.33\"\>",
                  -18.329115616473636,
                  AutoDelete->True], 
                InterpretationBox["\<\"-55.91\"\>",
                  -55.905574692509489,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.7442\"\>",
                  -0.74424275228728121,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.238\"\>",
                  -4.2380457146301787,
                  AutoDelete->True], 
                InterpretationBox["\<\"-8.09\"\>",
                  -8.08968541457096,
                  AutoDelete->True], 
                InterpretationBox["\<\"-58.12\"\>",
                  -58.115500682806903,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.594\"\>",
                  3.5937842812275242,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-40.15\"\>",
                  -40.15312815811199,
                  AutoDelete->True], 
                InterpretationBox["\<\" 282.4\"\>",
                  282.44770194445709,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.556\"\>",
                  -1.5555769917418516,
                  AutoDelete->True], 
                InterpretationBox["\<\"-301.5\"\>",
                  -301.47932116187718,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.405\"\>",
                  4.4054338494706506,
                  AutoDelete->True], 
                InterpretationBox["\<\" 14.56\"\>",
                  14.564711753770677,
                  AutoDelete->True], 
                InterpretationBox["\<\" 33.58\"\>",
                  33.582130972825027,
                  AutoDelete->True], 
                InterpretationBox["\<\" 105.8\"\>",
                  105.79550976094714,
                  AutoDelete->True], 
                InterpretationBox["\<\"-80.74\"\>",
                  -80.738054011733198,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-18.33\"\>",
                  -18.329115616473633,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.556\"\>",
                  -1.5555769917418587,
                  AutoDelete->True], 
                InterpretationBox["\<\" 168.9\"\>",
                  168.94982672912084,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.8\"\>",
                  18.795113145710001,
                  AutoDelete->True], 
                InterpretationBox["\<\"-15.08\"\>",
                  -15.084491809767519,
                  AutoDelete->True], 
                InterpretationBox["\<\" 48.69\"\>",
                  48.694127654835533,
                  AutoDelete->True], 
                InterpretationBox["\<\"-124.7\"\>",
                  -124.70361757184111,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.511\"\>",
                  -5.510561377762599,
                  AutoDelete->True], 
                InterpretationBox["\<\"-14.52\"\>",
                  -14.516073428132906,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-55.91\"\>",
                  -55.905574692509497,
                  AutoDelete->True], 
                InterpretationBox["\<\"-301.5\"\>",
                  -301.47932116187724,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.8\"\>",
                  18.795113145709998,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1112.\"\>",
                  1112.2020248575845,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.004\"\>",
                  2.0037046661961178,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.942\"\>",
                  8.9417587954503084,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.2\"\>",
                  15.199276835219459,
                  AutoDelete->True], 
                InterpretationBox["\<\"-10.54\"\>",
                  -10.536487031431076,
                  AutoDelete->True], 
                InterpretationBox["\<\" 101.5\"\>",
                  101.46765721500745,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.7442\"\>",
                  -0.74424275228727765,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.405\"\>",
                  4.4054338494706542,
                  AutoDelete->True], 
                InterpretationBox["\<\"-15.08\"\>",
                  -15.08449180976752,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.004\"\>",
                  2.0037046661961133,
                  AutoDelete->True], 
                InterpretationBox["\<\" 496.3\"\>",
                  496.34676643316527,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.51\"\>",
                  15.507518572343239,
                  AutoDelete->True], 
                InterpretationBox["\<\"-18.67\"\>",
                  -18.670936153504918,
                  AutoDelete->True], 
                InterpretationBox["\<\" 6.66\"\>",
                  6.6596471822302412,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.828\"\>",
                  2.8277815288968164,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-4.238\"\>",
                  -4.2380457146301804,
                  AutoDelete->True], 
                InterpretationBox["\<\" 14.56\"\>",
                  14.564711753770677,
                  AutoDelete->True], 
                InterpretationBox["\<\" 48.69\"\>",
                  48.694127654835526,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.942\"\>",
                  8.9417587954502977,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.51\"\>",
                  15.507518572343251,
                  AutoDelete->True], 
                InterpretationBox["\<\" 158.3\"\>",
                  158.30790800953554,
                  AutoDelete->True], 
                InterpretationBox["\<\"-21.39\"\>",
                  -21.392956656286607,
                  AutoDelete->True], 
                InterpretationBox["\<\" 7.143\"\>",
                  7.1432910403032928,
                  AutoDelete->True], 
                InterpretationBox["\<\" 26.45\"\>",
                  26.452140457466641,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-8.09\"\>",
                  -8.08968541457096,
                  AutoDelete->True], 
                InterpretationBox["\<\" 33.58\"\>",
                  33.582130972825063,
                  AutoDelete->True], 
                InterpretationBox["\<\"-124.7\"\>",
                  -124.70361757184112,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.2\"\>",
                  15.199276835219429,
                  AutoDelete->True], 
                InterpretationBox["\<\"-18.67\"\>",
                  -18.670936153504961,
                  AutoDelete->True], 
                InterpretationBox["\<\"-21.39\"\>",
                  -21.392956656286593,
                  AutoDelete->True], 
                InterpretationBox["\<\" 901.9\"\>",
                  901.88164365938678,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.617\"\>",
                  5.6169745071447039,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.461\"\>",
                  2.4612723859671721,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-58.12\"\>",
                  -58.115500682806911,
                  AutoDelete->True], 
                InterpretationBox["\<\" 105.8\"\>",
                  105.79550976094716,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.511\"\>",
                  -5.5105613777625919,
                  AutoDelete->True], 
                InterpretationBox["\<\"-10.54\"\>",
                  -10.536487031431079,
                  AutoDelete->True], 
                InterpretationBox["\<\" 6.66\"\>",
                  6.6596471822302412,
                  AutoDelete->True], 
                InterpretationBox["\<\" 7.143\"\>",
                  7.1432910403032874,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.617\"\>",
                  5.6169745071447288,
                  AutoDelete->True], 
                InterpretationBox["\<\" 163.9\"\>",
                  163.92398395782124,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.428\"\>",
                  3.4275401510718453,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 3.594\"\>",
                  3.5937842812275225,
                  AutoDelete->True], 
                InterpretationBox["\<\"-80.74\"\>",
                  -80.738054011733226,
                  AutoDelete->True], 
                InterpretationBox["\<\"-14.52\"\>",
                  -14.516073428132906,
                  AutoDelete->True], 
                InterpretationBox["\<\" 101.5\"\>",
                  101.46765721500742,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.828\"\>",
                  2.8277815288968156,
                  AutoDelete->True], 
                InterpretationBox["\<\" 26.45\"\>",
                  26.452140457466644,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.461\"\>",
                  2.4612723859671783,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.428\"\>",
                  3.4275401510718453,
                  AutoDelete->True], 
                InterpretationBox["\<\" 43.07\"\>",
                  43.071877356832772,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.4221597095976573`*^-7, 6.117992126916808`*^-8, 
          1.622312002463756`*^-8, 2.9918601005323245`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4988067361143343`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4221597095976573*^-07, 6.1179921269168079*^-08, 
        1.6223120024637559*^-08, 2.9918601005323245*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4988067361143343*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.850221428342788`*^-7\),
      SequenceForm[ "NOISE  ", 3.8502214283427878*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]5.762963258853753`\
\[InvisibleSpace]"  "\[InvisibleSpace]279.6090749119696`\),
      SequenceForm[ "*BFGSUP ", 5.7629632588537527, "  ", 279.60907491196963],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0063900526400226445`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0063900526400226445, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]9\),
      SequenceForm[ "BFGS: Iteration = ", 9],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2879.085305104738000\"\>",
            2879.0853051047379,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480888931324000\"\>",
            2891.4808889313235,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2879.0853051047379, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.4808889313235, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.892210602790000\"\>",
            2890.8922106027894,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480888931324000\"\>",
            2891.4808889313235,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2890.8922106027894, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.4808889313235, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.555698056919000\"\>",
            2891.555698056919,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480888931324000\"\>",
            2891.4808889313235,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2891.555698056919, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.4808889313235, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.555698056919000\"\>",
            2891.555698056919,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.555698056919, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480888931324000\"\>",
            2891.4808889313235,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.4808889313235, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.074809125595493\"\>",
            0.074809125595493242,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.074809125595493242, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.327513922528595,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.2550\"\>",
                16.254838653766868,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0727\"\>",
                0.072675268761728709,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.8748\"\>",
                0.87482777461322347,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.1002\"\>",
                4.1002223738771688,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.1057\"\>",
                4.105715015983308,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0055\"\>",
                -0.0054926421061392613,
                AutoDelete->True], 
              InterpretationBox["\<\"-4.5002\"\>",
                -4.5002429579164298,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0951\"\>",
                1.0950983988506591,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0887\"\>",
                1.0887151553890786,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0064\"\>",
                0.0063832434615804243,
                AutoDelete->True], 
              InterpretationBox["\<\" 9.4716\"\>",
                9.4715859146593608,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0131\"\>",
                2.013057362355001,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0078\"\>",
                2.0078033259365009,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0053\"\>",
                0.0052540364185000542,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.9387\"\>",
                -0.93873544197811221,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0071\"\>",
                0.0071284719746286937,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0070\"\>",
                0.0070065439778675765,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0001\"\>",
                0.00012192799676111698,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.2827\"\>",
                2.282745361328125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0039\"\>",
                -0.0038763182476389702,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0089\"\>",
                -0.008895688852179482,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0050\"\>",
                0.0050193706045405118,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.0994\"\>",
                3.09942626953125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0077\"\>",
                1.0077400043722577,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0058\"\>",
                1.0058321741618075,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0019\"\>",
                0.0019078302104503157,
                AutoDelete->True], 
              InterpretationBox["\<\" 11.2250\"\>",
                11.224878790231442,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0463\"\>",
                -0.046337034026563535,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0763\"\>",
                -0.076295927254525234,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0300\"\>",
                0.029958893227961698,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.0016\"\>",
                -2.001617431640625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9191\"\>",
                0.91914823723266592,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9520\"\>",
                0.95203381739646575,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0329\"\>",
                -0.032885580163799853,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.9973\"\>",
                -0.997344970703125,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 29.04\"\>",
                  29.038191123488353,
                  AutoDelete->True], 
                InterpretationBox["\<\"-40.62\"\>",
                  -40.623566144280545,
                  AutoDelete->True], 
                InterpretationBox["\<\"-21.25\"\>",
                  -21.248640080702813,
                  AutoDelete->True], 
                InterpretationBox["\<\"-56.08\"\>",
                  -56.076429355343286,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.068\"\>",
                  -1.0682197385043579,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.916\"\>",
                  -3.916149794361742,
                  AutoDelete->True], 
                InterpretationBox["\<\"-10.84\"\>",
                  -10.844995351934079,
                  AutoDelete->True], 
                InterpretationBox["\<\"-58.75\"\>",
                  -58.749546766333239,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.707\"\>",
                  2.7066076754890238,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-40.62\"\>",
                  -40.623566144280545,
                  AutoDelete->True], 
                InterpretationBox["\<\" 285.8\"\>",
                  285.75415296683536,
                  AutoDelete->True], 
                InterpretationBox["\<\" 17.3\"\>",
                  17.296470514141063,
                  AutoDelete->True], 
                InterpretationBox["\<\"-300.3\"\>",
                  -300.30949781795601,
                  AutoDelete->True], 
                InterpretationBox["\<\" 6.443\"\>",
                  6.4425064513779748,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.3\"\>",
                  12.301383202423679,
                  AutoDelete->True], 
                InterpretationBox["\<\" 51.27\"\>",
                  51.271870906298247,
                  AutoDelete->True], 
                InterpretationBox["\<\" 110.1\"\>",
                  110.07066865419267,
                  AutoDelete->True], 
                InterpretationBox["\<\"-74.84\"\>",
                  -74.836535362884348,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-21.25\"\>",
                  -21.24864008070281,
                  AutoDelete->True], 
                InterpretationBox["\<\" 17.3\"\>",
                  17.296470514141056,
                  AutoDelete->True], 
                InterpretationBox["\<\" 240.9\"\>",
                  240.89621406482865,
                  AutoDelete->True], 
                InterpretationBox["\<\" 24.8\"\>",
                  24.803890870707164,
                  AutoDelete->True], 
                InterpretationBox["\<\"-8.584\"\>",
                  -8.5842597157243858,
                  AutoDelete->True], 
                InterpretationBox["\<\" 35.77\"\>",
                  35.770397489054211,
                  AutoDelete->True], 
                InterpretationBox["\<\"-59.56\"\>",
                  -59.557573910163313,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.\"\>",
                  15.003009933239568,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.01\"\>",
                  12.01494091024145,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-56.08\"\>",
                  -56.076429355343294,
                  AutoDelete->True], 
                InterpretationBox["\<\"-300.3\"\>",
                  -300.30949781795607,
                  AutoDelete->True], 
                InterpretationBox["\<\" 24.8\"\>",
                  24.803890870707157,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1113.\"\>",
                  1112.6036119878431,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.629\"\>",
                  2.6292904512002515,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.141\"\>",
                  8.1406363664770733,
                  AutoDelete->True], 
                InterpretationBox["\<\" 20.79\"\>",
                  20.79360560393534,
                  AutoDelete->True], 
                InterpretationBox["\<\"-9.096\"\>",
                  -9.0957647858763693,
                  AutoDelete->True], 
                InterpretationBox["\<\" 103.4\"\>",
                  103.42323265085848,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-1.068\"\>",
                  -1.0682197385043544,
                  AutoDelete->True], 
                InterpretationBox["\<\" 6.443\"\>",
                  6.4425064513779784,
                  AutoDelete->True], 
                InterpretationBox["\<\"-8.584\"\>",
                  -8.5842597157243894,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.629\"\>",
                  2.6292904512002471,
                  AutoDelete->True], 
                InterpretationBox["\<\" 496.9\"\>",
                  496.8658241734862,
                  AutoDelete->True], 
                InterpretationBox["\<\" 14.11\"\>",
                  14.110348601577511,
                  AutoDelete->True], 
                InterpretationBox["\<\"-12.91\"\>",
                  -12.911733904378256,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.738\"\>",
                  8.7378309314636606,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.439\"\>",
                  5.4394906102680682,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-3.916\"\>",
                  -3.9161497943617438,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.3\"\>",
                  12.301383202423679,
                  AutoDelete->True], 
                InterpretationBox["\<\" 35.77\"\>",
                  35.770397489054204,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.141\"\>",
                  8.1406363664770627,
                  AutoDelete->True], 
                InterpretationBox["\<\" 14.11\"\>",
                  14.110348601577524,
                  AutoDelete->True], 
                InterpretationBox["\<\" 159.9\"\>",
                  159.85718909532514,
                  AutoDelete->True], 
                InterpretationBox["\<\"-33.52\"\>",
                  -33.521158578632168,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.215\"\>",
                  4.2147832875239768,
                  AutoDelete->True], 
                InterpretationBox["\<\" 22.41\"\>",
                  22.408604878249559,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-10.84\"\>",
                  -10.844995351934079,
                  AutoDelete->True], 
                InterpretationBox["\<\" 51.27\"\>",
                  51.271870906298282,
                  AutoDelete->True], 
                InterpretationBox["\<\"-59.56\"\>",
                  -59.557573910163327,
                  AutoDelete->True], 
                InterpretationBox["\<\" 20.79\"\>",
                  20.793605603935312,
                  AutoDelete->True], 
                InterpretationBox["\<\"-12.91\"\>",
                  -12.911733904378298,
                  AutoDelete->True], 
                InterpretationBox["\<\"-33.52\"\>",
                  -33.521158578632154,
                  AutoDelete->True], 
                InterpretationBox["\<\" 960.6\"\>",
                  960.6350810262295,
                  AutoDelete->True], 
                InterpretationBox["\<\" 24.61\"\>",
                  24.608877180153151,
                  AutoDelete->True], 
                InterpretationBox["\<\" 26.88\"\>",
                  26.883031264573631,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-58.75\"\>",
                  -58.749546766333246,
                  AutoDelete->True], 
                InterpretationBox["\<\" 110.1\"\>",
                  110.07066865419269,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.\"\>",
                  15.003009933239575,
                  AutoDelete->True], 
                InterpretationBox["\<\"-9.096\"\>",
                  -9.0957647858763728,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.738\"\>",
                  8.7378309314636606,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.215\"\>",
                  4.2147832875239715,
                  AutoDelete->True], 
                InterpretationBox["\<\" 24.61\"\>",
                  24.608877180153179,
                  AutoDelete->True], 
                InterpretationBox["\<\" 169.\"\>",
                  169.03206770341987,
                  AutoDelete->True], 
                InterpretationBox["\<\" 10.28\"\>",
                  10.284749104300476,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\" 2.707\"\>",
                  2.706607675489022,
                  AutoDelete->True], 
                InterpretationBox["\<\"-74.84\"\>",
                  -74.836535362884376,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.01\"\>",
                  12.014940910241446,
                  AutoDelete->True], 
                InterpretationBox["\<\" 103.4\"\>",
                  103.42323265085845,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.439\"\>",
                  5.4394906102680665,
                  AutoDelete->True], 
                InterpretationBox["\<\" 22.41\"\>",
                  22.408604878249562,
                  AutoDelete->True], 
                InterpretationBox["\<\" 26.88\"\>",
                  26.883031264573631,
                  AutoDelete->True], 
                InterpretationBox["\<\" 10.28\"\>",
                  10.284749104300476,
                  AutoDelete->True], 
                InterpretationBox["\<\" 52.18\"\>",
                  52.179990568788412,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.4329891685439043`*^-7, 6.109807452376438`*^-8, 
          1.6318237764398144`*^-8, 2.999689224891366`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.5016496246639755`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4329891685439043*^-07, 6.1098074523764384*^-08, 
        1.6318237764398144*^-08, 2.999689224891366*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5016496246639755*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.061495269590522`*^-7\),
      SequenceForm[ "NOISE  ", 3.0614952695905221*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]6.3703314446277215`\
\[InvisibleSpace]"  "\[InvisibleSpace]415.8367694520271`\),
      SequenceForm[ "*BFGSUP ", 6.3703314446277215, "  ", 415.83676945202711],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0038556737022785903`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0038556737022785903, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]10\),
      SequenceForm[ "BFGS: Iteration = ", 10],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.694842582603000\"\>",
            2891.6948425826031,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.6948425826031, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.555698056919000\"\>",
            2891.555698056919,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.555698056919, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.139144525684060\"\>",
            0.13914452568405977,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.13914452568405977, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.2230\"\>",
                16.222592219935684,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.327513922528595,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1049\"\>",
                -0.10492170259291157,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.4609\"\>",
                0.46093606026708134,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0745\"\>",
                4.0744777554025013,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.1002\"\>",
                4.1002223738771688,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0257\"\>",
                -0.025744618474667413,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.7191\"\>",
                -2.7190952702229865,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.1323\"\>",
                1.1322872018898731,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0951\"\>",
                1.0950983988506591,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0372\"\>",
                0.03718880303921393,
                AutoDelete->True], 
              InterpretationBox["\<\" 8.6282\"\>",
                8.6282022498313822,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9968\"\>",
                1.9967914572989656,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0131\"\>",
                2.013057362355001,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0163\"\>",
                -0.016265905056035437,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.5563\"\>",
                -0.55631974795938821,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0132\"\>",
                0.013162839189780628,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0071\"\>",
                0.0071284719746286937,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0060\"\>",
                0.006034367215151935,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0691\"\>",
                2.069061279296875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\" 0.0022\"\>",
                0.0022016015399883302,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0039\"\>",
                -0.0038763182476389702,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0061\"\>",
                0.0060779197876273004,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9384\"\>",
                1.938446044921875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0219\"\>",
                1.021904514658722,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0077\"\>",
                1.0077400043722577,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0142\"\>",
                0.014164510286464276,
                AutoDelete->True], 
              InterpretationBox["\<\" 9.3205\"\>",
                9.3204681781279248,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0894\"\>",
                -0.089441067182822714,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0463\"\>",
                -0.046337034026563535,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0431\"\>",
                -0.043104033156259172,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.4834\"\>",
                -2.4833984375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9403\"\>",
                0.94025135878035482,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9191\"\>",
                0.91914823723266592,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0211\"\>",
                0.021103121547688865,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.7339\"\>",
                1.73394775390625,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 30.05\"\>",
                  30.051771676597955,
                  AutoDelete->True], 
                InterpretationBox["\<\"-44.92\"\>",
                  -44.920100619290729,
                  AutoDelete->True], 
                InterpretationBox["\<\"-19.87\"\>",
                  -19.866168919593086,
                  AutoDelete->True], 
                InterpretationBox["\<\"-57.\"\>",
                  -57.001343421934735,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.7076\"\>",
                  -0.70755608018282345,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.13\"\>",
                  -1.1303525465771451,
                  AutoDelete->True], 
                InterpretationBox["\<\"-6.821\"\>",
                  -6.8207098805683133,
                  AutoDelete->True], 
                InterpretationBox["\<\"-57.3\"\>",
                  -57.301496446494603,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.406\"\>",
                  -4.4062145397242567,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-44.92\"\>",
                  -44.920100619290729,
                  AutoDelete->True], 
                InterpretationBox["\<\" 303.9\"\>",
                  303.90789156886774,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.05\"\>",
                  12.054362644543218,
                  AutoDelete->True], 
                InterpretationBox["\<\"-296.4\"\>",
                  -296.39930395976063,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.061\"\>",
                  5.0608726805450583,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5444\"\>",
                  0.5443750711611095,
                  AutoDelete->True], 
                InterpretationBox["\<\" 34.79\"\>",
                  34.791858050513767,
                  AutoDelete->True], 
                InterpretationBox["\<\" 103.7\"\>",
                  103.68964779320382,
                  AutoDelete->True], 
                InterpretationBox["\<\"-44.3\"\>",
                  -44.301582961969444,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-19.87\"\>",
                  -19.866168919593079,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.05\"\>",
                  12.054362644543211,
                  AutoDelete->True], 
                InterpretationBox["\<\" 236.3\"\>",
                  236.31971315101745,
                  AutoDelete->True], 
                InterpretationBox["\<\" 23.65\"\>",
                  23.651981196343485,
                  AutoDelete->True], 
                InterpretationBox["\<\"-9.631\"\>",
                  -9.6312568662884761,
                  AutoDelete->True], 
                InterpretationBox["\<\" 39.03\"\>",
                  39.027570881379802,
                  AutoDelete->True], 
                InterpretationBox["\<\"-60.12\"\>",
                  -60.119498146886691,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.52\"\>",
                  19.516158966662921,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.7\"\>",
                  -1.7002663595646954,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-57.\"\>",
                  -57.001343421934742,
                  AutoDelete->True], 
                InterpretationBox["\<\"-296.4\"\>",
                  -296.39930395976069,
                  AutoDelete->True], 
                InterpretationBox["\<\" 23.65\"\>",
                  23.651981196343478,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1113.\"\>",
                  1113.4457562713906,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.326\"\>",
                  2.3262837859141547,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.608\"\>",
                  5.6077396894955562,
                  AutoDelete->True], 
                InterpretationBox["\<\" 17.22\"\>",
                  17.224006475080888,
                  AutoDelete->True], 
                InterpretationBox["\<\"-10.46\"\>",
                  -10.460198549429398,
                  AutoDelete->True], 
                InterpretationBox["\<\" 110.\"\>",
                  109.98192518677644,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.7076\"\>",
                  -0.70755608018281979,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.061\"\>",
                  5.0608726805450619,
                  AutoDelete->True], 
                InterpretationBox["\<\"-9.631\"\>",
                  -9.6312568662884797,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.326\"\>",
                  2.3262837859141503,
                  AutoDelete->True], 
                InterpretationBox["\<\" 496.6\"\>",
                  496.62767210794982,
                  AutoDelete->True], 
                InterpretationBox["\<\" 14.97\"\>",
                  14.972426356160904,
                  AutoDelete->True], 
                InterpretationBox["\<\"-12.92\"\>",
                  -12.920746649633724,
                  AutoDelete->True], 
                InterpretationBox["\<\" 9.858\"\>",
                  9.8575253015858166,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.953\"\>",
                  1.9526850498146611,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-1.13\"\>",
                  -1.1303525465771469,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5444\"\>",
                  0.5443750711611095,
                  AutoDelete->True], 
                InterpretationBox["\<\" 39.03\"\>",
                  39.027570881379795,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.608\"\>",
                  5.6077396894955456,
                  AutoDelete->True], 
                InterpretationBox["\<\" 14.97\"\>",
                  14.972426356160916,
                  AutoDelete->True], 
                InterpretationBox["\<\" 167.5\"\>",
                  167.46832855403937,
                  AutoDelete->True], 
                InterpretationBox["\<\"-22.97\"\>",
                  -22.96850607951135,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.408\"\>",
                  8.4077860145436407,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.522\"\>",
                  2.5222579264193428,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-6.821\"\>",
                  -6.8207098805683133,
                  AutoDelete->True], 
                InterpretationBox["\<\" 34.79\"\>",
                  34.791858050513802,
                  AutoDelete->True], 
                InterpretationBox["\<\"-60.12\"\>",
                  -60.119498146886713,
                  AutoDelete->True], 
                InterpretationBox["\<\" 17.22\"\>",
                  17.224006475080859,
                  AutoDelete->True], 
                InterpretationBox["\<\"-12.92\"\>",
                  -12.920746649633767,
                  AutoDelete->True], 
                InterpretationBox["\<\"-22.97\"\>",
                  -22.968506079511336,
                  AutoDelete->True], 
                InterpretationBox["\<\" 970.9\"\>",
                  970.94722935663196,
                  AutoDelete->True], 
                InterpretationBox["\<\" 32.73\"\>",
                  32.734714769575575,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.116\"\>",
                  -5.1157120865747139,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-57.3\"\>",
                  -57.30149644649461,
                  AutoDelete->True], 
                InterpretationBox["\<\" 103.7\"\>",
                  103.68964779320383,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.52\"\>",
                  19.516158966662928,
                  AutoDelete->True], 
                InterpretationBox["\<\"-10.46\"\>",
                  -10.460198549429402,
                  AutoDelete->True], 
                InterpretationBox["\<\" 9.858\"\>",
                  9.8575253015858166,
                  AutoDelete->True], 
                InterpretationBox["\<\" 8.408\"\>",
                  8.4077860145436354,
                  AutoDelete->True], 
                InterpretationBox["\<\" 32.73\"\>",
                  32.734714769575611,
                  AutoDelete->True], 
                InterpretationBox["\<\" 170.1\"\>",
                  170.10395636402433,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.699\"\>",
                  1.6994558142270204,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-4.406\"\>",
                  -4.4062145397242594,
                  AutoDelete->True], 
                InterpretationBox["\<\"-44.3\"\>",
                  -44.301582961969473,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.7\"\>",
                  -1.7002663595647007,
                  AutoDelete->True], 
                InterpretationBox["\<\" 110.\"\>",
                  109.98192518677641,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.953\"\>",
                  1.9526850498146593,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.522\"\>",
                  2.5222579264193428,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.116\"\>",
                  -5.1157120865747139,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.699\"\>",
                  1.6994558142270204,
                  AutoDelete->True], 
                InterpretationBox["\<\" 99.6\"\>",
                  99.601423724807375,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.417354616513205`*^-7, 6.071444981399926`*^-8, 
          1.6872394113091723`*^-8, 2.9754511375709855`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.5227563897650272`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4173546165132052*^-07, 6.0714449813999256*^-08, 
        1.6872394113091723*^-08, 2.9754511375709855*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5227563897650272*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.0797299556248016`*^-7\),
      SequenceForm[ "NOISE  ", 2.0797299556248016*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.9737735147235623`\
\[InvisibleSpace]"  "\[InvisibleSpace]1.5349554789801791`\),
      SequenceForm[ 
      "*BFGSUP ", 0.97377351472356233, "  ", 1.5349554789801791],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0022006424509502754`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0022006424509502754, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]11\),
      SequenceForm[ "BFGS: Iteration = ", 11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772427541464000\"\>",
            2891.7724275414639,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.7724275414639, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.694842582603000\"\>",
            2891.6948425826031,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.6948425826031, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.077584958860825\"\>",
            0.077584958860825282,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.077584958860825282, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.3360\"\>",
                16.336219338216104,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.2230\"\>",
                16.222592219935684,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.1136\"\>",
                0.11362711828042067,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0764\"\>",
                -0.076407793150337799,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0966\"\>",
                4.0966251945164469,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0745\"\>",
                4.0744777554025013,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0221\"\>",
                0.022147439113945903,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.5618\"\>",
                1.5618164603656344,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.1251\"\>",
                1.1251336718878522,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.1323\"\>",
                1.1322872018898731,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0072\"\>",
                -0.0071535300020208444,
                AutoDelete->True], 
              InterpretationBox["\<\"-4.6364\"\>",
                -4.6363632967471604,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0100\"\>",
                2.01001840865607,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9968\"\>",
                1.9967914572989656,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0132\"\>",
                0.013226951357104506,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.5466\"\>",
                1.5466401660548359,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0110\"\>",
                0.011039761161214651,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0132\"\>",
                0.013162839189780628,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0021\"\>",
                -0.002123078028565976,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.0950\"\>",
                -1.095001220703125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0032\"\>",
                -0.0032203337907391232,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0022\"\>",
                0.0022016015399883302,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0054\"\>",
                -0.0054219353307274534,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.4990\"\>",
                -1.49896240234375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0175\"\>",
                1.0174804691310311,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0219\"\>",
                1.021904514658722,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0044\"\>",
                -0.0044240455276909445,
                AutoDelete->True], 
              InterpretationBox["\<\"-4.2941\"\>",
                -4.2940631885350067,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0566\"\>",
                -0.056584882997367421,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0894\"\>",
                -0.089441067182822714,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0329\"\>",
                0.032856184185455294,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.5247\"\>",
                1.524749755859375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9393\"\>",
                0.93934889963315671,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9403\"\>",
                0.94025135878035482,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0009\"\>",
                -0.0009024591471980595,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1618\"\>",
                -0.161773681640625,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 30.01\"\>",
                  30.006817709303842,
                  AutoDelete->True], 
                InterpretationBox["\<\"-45.24\"\>",
                  -45.236288564348193,
                  AutoDelete->True], 
                InterpretationBox["\<\"-19.03\"\>",
                  -19.030062911009257,
                  AutoDelete->True], 
                InterpretationBox["\<\"-57.71\"\>",
                  -57.708114440291141,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.5159\"\>",
                  -0.51585118510444417,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.7032\"\>",
                  -0.70320664167026092,
                  AutoDelete->True], 
                InterpretationBox["\<\"-6.291\"\>",
                  -6.2912732819816348,
                  AutoDelete->True], 
                InterpretationBox["\<\"-57.64\"\>",
                  -57.641719898256603,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.641\"\>",
                  -4.6410723528023201,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-45.24\"\>",
                  -45.236288564348193,
                  AutoDelete->True], 
                InterpretationBox["\<\" 310.4\"\>",
                  310.40480362623191,
                  AutoDelete->True], 
                InterpretationBox["\<\"-7.229\"\>",
                  -7.2293724500124057,
                  AutoDelete->True], 
                InterpretationBox["\<\"-290.\"\>",
                  -289.95473064852183,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5067\"\>",
                  0.50666079571968758,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.694\"\>",
                  -5.6944647643472841,
                  AutoDelete->True], 
                InterpretationBox["\<\" 16.94\"\>",
                  16.938545486814142,
                  AutoDelete->True], 
                InterpretationBox["\<\" 110.\"\>",
                  110.03323283508726,
                  AutoDelete->True], 
                InterpretationBox["\<\"-44.97\"\>",
                  -44.967199533512741,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-19.03\"\>",
                  -19.030062911009249,
                  AutoDelete->True], 
                InterpretationBox["\<\"-7.229\"\>",
                  -7.2293724500124057,
                  AutoDelete->True], 
                InterpretationBox["\<\" 293.4\"\>",
                  293.38279404110801,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.857\"\>",
                  3.8565620622975842,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.835\"\>",
                  3.835480468315021,
                  AutoDelete->True], 
                InterpretationBox["\<\" 57.75\"\>",
                  57.754886988171975,
                  AutoDelete->True], 
                InterpretationBox["\<\"-7.704\"\>",
                  -7.7043249340662427,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6341\"\>",
                  0.63407713922596542,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1781\"\>",
                  -0.17807586438751422,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-57.71\"\>",
                  -57.708114440291148,
                  AutoDelete->True], 
                InterpretationBox["\<\"-290.\"\>",
                  -289.95473064852189,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.857\"\>",
                  3.85656206229757,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1117.\"\>",
                  1117.2771556810671,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.386\"\>",
                  -2.3862791802372763,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.2239\"\>",
                  0.22388131966081737,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.697\"\>",
                  -2.6969310921096898,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.373\"\>",
                  -4.3729245639543475,
                  AutoDelete->True], 
                InterpretationBox["\<\" 107.6\"\>",
                  107.58051734075046,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.5159\"\>",
                  -0.51585118510444072,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.5067\"\>",
                  0.50666079571969114,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.835\"\>",
                  3.8354804683150174,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.386\"\>",
                  -2.3862791802372798,
                  AutoDelete->True], 
                InterpretationBox["\<\" 499.8\"\>",
                  499.80523584132516,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.41\"\>",
                  19.407014028586534,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.5743\"\>",
                  -0.57431562810243975,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.395\"\>",
                  5.3951662019555684,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.287\"\>",
                  2.2866808892001855,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.7032\"\>",
                  -0.70320664167026248,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.694\"\>",
                  -5.6944647643472841,
                  AutoDelete->True], 
                InterpretationBox["\<\" 57.75\"\>",
                  57.754886988171975,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.2239\"\>",
                  0.2238813196608076,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.41\"\>",
                  19.407014028586548,
                  AutoDelete->True], 
                InterpretationBox["\<\" 173.2\"\>",
                  173.206511720181,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.13\"\>",
                  -5.1295520125925833,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.381\"\>",
                  2.3806568770894776,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.708\"\>",
                  3.7084879984101029,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-6.291\"\>",
                  -6.2912732819816339,
                  AutoDelete->True], 
                InterpretationBox["\<\" 16.94\"\>",
                  16.938545486814171,
                  AutoDelete->True], 
                InterpretationBox["\<\"-7.704\"\>",
                  -7.7043249340662356,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.697\"\>",
                  -2.6969310921097183,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.5743\"\>",
                  -0.57431562810247883,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.13\"\>",
                  -5.1295520125925655,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1018.\"\>",
                  1018.0981588890662,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.13\"\>",
                  15.125559025568315,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.79\"\>",
                  -4.7899718633826822,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-57.64\"\>",
                  -57.641719898256611,
                  AutoDelete->True], 
                InterpretationBox["\<\" 110.\"\>",
                  110.03323283508726,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.6341\"\>",
                  0.63407713922597253,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.373\"\>",
                  -4.3729245639543537,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.395\"\>",
                  5.3951662019555675,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.381\"\>",
                  2.3806568770894705,
                  AutoDelete->True], 
                InterpretationBox["\<\" 15.13\"\>",
                  15.12555902556835,
                  AutoDelete->True], 
                InterpretationBox["\<\" 176.3\"\>",
                  176.28139171149706,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.91\"\>",
                  0.91004683419357857,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-4.641\"\>",
                  -4.6410723528023237,
                  AutoDelete->True], 
                InterpretationBox["\<\"-44.97\"\>",
                  -44.967199533512769,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.1781\"\>",
                  -0.17807586438751599,
                  AutoDelete->True], 
                InterpretationBox["\<\" 107.6\"\>",
                  107.58051734075043,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.287\"\>",
                  2.2866808892001846,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.708\"\>",
                  3.708487998410102,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.79\"\>",
                  -4.7899718633826858,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.91\"\>",
                  0.91004683419357857,
                  AutoDelete->True], 
                InterpretationBox["\<\" 98.49\"\>",
                  98.485973315932711,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.4342863765680945`*^-7, 6.104447237426709`*^-8, 
          1.6765798209426585`*^-8, 2.995160830998525`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.5161640482113228`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4342863765680945*^-07, 6.1044472374267085*^-08, 
        1.6765798209426585*^-08, 2.995160830998525*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5161640482113228*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]7.209104510644662`*^-8\),
      SequenceForm[ "NOISE  ", 7.2091045106446615*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]6.158715536852138`\
\[InvisibleSpace]"  "\[InvisibleSpace]6.280437747419039`\),
      SequenceForm[ "*BFGSUP ", 6.1587155368521378, "  ", 6.2804377474190387],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00022229351781029208`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.00022229351781029208, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]12\),
      SequenceForm[ "BFGS: Iteration = ", 12],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592233009000\"\>",
            2891.7725922330087,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.7725922330087, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772427541464000\"\>",
            2891.7724275414639,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.7724275414639, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000164691544796\"\>",
            0.00016469154479636927,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.00016469154479636927, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.32801041689342,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.3360\"\>",
                16.336219338216104,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0082\"\>",
                -0.0082089213226826715,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0393\"\>",
                -0.039349512412655656,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952158035035495,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0966\"\>",
                4.0966251945164469,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0014\"\>",
                -0.0014093910128977506,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0313\"\>",
                0.031339809007601797,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.124690031347898,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.1251\"\>",
                1.1251336718878522,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0004\"\>",
                -0.00044364053995409779,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0686\"\>",
                0.068622488674346477,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091815138133109,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0100\"\>",
                2.01001840865607,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0008\"\>",
                -0.00083689484275921021,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1004\"\>",
                -0.10040343077034811,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011140444568479882,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0110\"\>",
                0.011039761161214651,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0001\"\>",
                0.00010068340726523102,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0568\"\>",
                0.056793212890625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.0027852511143634153,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0032\"\>",
                -0.0032203337907391232,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0004\"\>",
                0.00043508267637570809,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0651\"\>",
                0.065093994140625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172680108600618,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0175\"\>",
                1.0174804691310311,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0002\"\>",
                -0.00021245827096932991,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2016\"\>",
                -0.2015848449192307,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.058043065638296795,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0566\"\>",
                -0.056584882997367421,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0015\"\>",
                -0.0014581826409293713,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0609\"\>",
                0.060943603515625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9389\"\>",
                0.93890054971915526,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9393\"\>",
                0.93934889963315671,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0004\"\>",
                -0.00044834991400141694,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0314\"\>",
                -0.03143310546875,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 29.98\"\>",
                  29.978609429945376,
                  AutoDelete->True], 
                InterpretationBox["\<\"-44.84\"\>",
                  -44.83611568890985,
                  AutoDelete->True], 
                InterpretationBox["\<\"-20.18\"\>",
                  -20.181109375194858,
                  AutoDelete->True], 
                InterpretationBox["\<\"-57.34\"\>",
                  -57.341828518049212,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.7784\"\>",
                  -0.77843855921682192,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.066\"\>",
                  -1.0655535119075412,
                  AutoDelete->True], 
                InterpretationBox["\<\"-7.418\"\>",
                  -7.417852127804041,
                  AutoDelete->True], 
                InterpretationBox["\<\"-57.24\"\>",
                  -57.244118083017462,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.689\"\>",
                  -4.6889555859274283,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-44.84\"\>",
                  -44.83611568890985,
                  AutoDelete->True], 
                InterpretationBox["\<\" 309.5\"\>",
                  309.51103753637688,
                  AutoDelete->True], 
                InterpretationBox["\<\"-6.1\"\>",
                  -6.0999054200982172,
                  AutoDelete->True], 
                InterpretationBox["\<\"-289.6\"\>",
                  -289.60090086468699,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.3909\"\>",
                  0.39085867148114062,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.734\"\>",
                  -5.7337422471703636,
                  AutoDelete->True], 
                InterpretationBox["\<\" 20.48\"\>",
                  20.483782520912371,
                  AutoDelete->True], 
                InterpretationBox["\<\" 108.9\"\>",
                  108.87462919980332,
                  AutoDelete->True], 
                InterpretationBox["\<\"-44.61\"\>",
                  -44.608939451055747,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-20.18\"\>",
                  -20.18110937519485,
                  AutoDelete->True], 
                InterpretationBox["\<\"-6.1\"\>",
                  -6.0999054200982243,
                  AutoDelete->True], 
                InterpretationBox["\<\" 294.7\"\>",
                  294.71417049553315,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.166\"\>",
                  1.166398017806678,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.326\"\>",
                  5.3259728374362485,
                  AutoDelete->True], 
                InterpretationBox["\<\" 59.43\"\>",
                  59.428658160980241,
                  AutoDelete->True], 
                InterpretationBox["\<\"-14.15\"\>",
                  -14.154145505327897,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.616\"\>",
                  2.6161103578596325,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.112\"\>",
                  -1.111829449080838,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-57.34\"\>",
                  -57.341828518049219,
                  AutoDelete->True], 
                InterpretationBox["\<\"-289.6\"\>",
                  -289.60090086468705,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.166\"\>",
                  1.1663980178066637,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1119.\"\>",
                  1118.9608185487425,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.433\"\>",
                  -3.4333262862869174,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.081\"\>",
                  -1.0811081678037979,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.499\"\>",
                  -2.4989784974668474,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.335\"\>",
                  -4.3353282214190898,
                  AutoDelete->True], 
                InterpretationBox["\<\" 107.8\"\>",
                  107.82978631735945,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.7784\"\>",
                  -0.77843855921681837,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.3909\"\>",
                  0.39085867148114239,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.326\"\>",
                  5.3259728374362449,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.433\"\>",
                  -3.4333262862869209,
                  AutoDelete->True], 
                InterpretationBox["\<\" 500.4\"\>",
                  500.44515654389693,
                  AutoDelete->True], 
                InterpretationBox["\<\" 20.19\"\>",
                  20.193269394279664,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.075\"\>",
                  -1.0746626661855636,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.497\"\>",
                  5.4973852626298463,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.099\"\>",
                  2.0987297641688674,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-1.066\"\>",
                  -1.0655535119075428,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.734\"\>",
                  -5.7337422471703672,
                  AutoDelete->True], 
                InterpretationBox["\<\" 59.43\"\>",
                  59.428658160980255,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.081\"\>",
                  -1.0811081678038095,
                  AutoDelete->True], 
                InterpretationBox["\<\" 20.19\"\>",
                  20.193269394279682,
                  AutoDelete->True], 
                InterpretationBox["\<\" 174.2\"\>",
                  174.16096563673531,
                  AutoDelete->True], 
                InterpretationBox["\<\"-6.133\"\>",
                  -6.1333456525698296,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.635\"\>",
                  2.6346370574092495,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.441\"\>",
                  3.4410437249792145,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-7.418\"\>",
                  -7.4178521278040401,
                  AutoDelete->True], 
                InterpretationBox["\<\" 20.48\"\>",
                  20.483782520912399,
                  AutoDelete->True], 
                InterpretationBox["\<\"-14.15\"\>",
                  -14.15414550532789,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.499\"\>",
                  -2.4989784974668687,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.075\"\>",
                  -1.0746626661856027,
                  AutoDelete->True], 
                InterpretationBox["\<\"-6.133\"\>",
                  -6.1333456525698189,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1005.\"\>",
                  1005.4418031652157,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.35\"\>",
                  19.351549650134913,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.868\"\>",
                  -5.8676236980542367,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-57.24\"\>",
                  -57.244118083017469,
                  AutoDelete->True], 
                InterpretationBox["\<\" 108.9\"\>",
                  108.87462919980332,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.616\"\>",
                  2.6161103578596396,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.335\"\>",
                  -4.335328221419096,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.497\"\>",
                  5.4973852626298454,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.635\"\>",
                  2.6346370574092441,
                  AutoDelete->True], 
                InterpretationBox["\<\" 19.35\"\>",
                  19.351549650134949,
                  AutoDelete->True], 
                InterpretationBox["\<\" 174.9\"\>",
                  174.87669679860596,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.284\"\>",
                  1.2841652364901961,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-4.689\"\>",
                  -4.6889555859274319,
                  AutoDelete->True], 
                InterpretationBox["\<\"-44.61\"\>",
                  -44.608939451055775,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.112\"\>",
                  -1.1118294490808394,
                  AutoDelete->True], 
                InterpretationBox["\<\" 107.8\"\>",
                  107.82978631735942,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.099\"\>",
                  2.0987297641688665,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.441\"\>",
                  3.4410437249792136,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.868\"\>",
                  -5.8676236980542384,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.284\"\>",
                  1.2841652364901959,
                  AutoDelete->True], 
                InterpretationBox["\<\" 98.43\"\>",
                  98.426238072589626,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.433063151969525`*^-7, 6.102347081159874`*^-8, 
          1.6759187450228602`*^-8, 2.9939137605031`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.515847460717055`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4330631519695252*^-07, 6.1023470811598741*^-08, 
        1.6759187450228602*^-08, 2.9939137605030997*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5158474607170549*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.1437468884612737`*^-9\),
      SequenceForm[ "NOISE  ", 3.1437468884612737*^-09],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2948.5480207179194`\
\[InvisibleSpace]"  "\[InvisibleSpace]2989.319476714146`\),
      SequenceForm[ "*BFGSUP ", 2948.5480207179194, "  ", 2989.3194767141458],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.000011112564608965516`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 1.1112564608965516*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]13\),
      SequenceForm[ "BFGS: Iteration = ", 13],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592814112000\"\>",
            2891.7725928141122,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.7725928141122, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592233009000\"\>",
            2891.7725922330087,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.7725922330087, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     5.811034498037770"\[Times]10\^"-7"\),
            5.8110344980377704*^-07,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 5.8110344980377704*^-07, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.328243774244218,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.32801041689342,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0002\"\>",
                0.00023335735079577229,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0020\"\>",
                0.0019680909642473777,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952196956498197,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952158035035495,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0053\"\>",
                -0.0053058292084169935,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.1247379210042783,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.124690031347898,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                4.7889656380208698*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0094\"\>",
                0.0093884374689400807,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091812897946939,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091815138133109,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0080\"\>",
                -0.0080350126243621447,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011148906128470127,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011140444568479882,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0047\"\>",
                0.004669189453125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.0027857509394063062,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.0027852511143634153,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0029\"\>",
                0.00286865234375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172689321804007,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172680108600618,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0001\"\>",
                0.00014999772822502566,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.057977598238320834,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.058043065638296795,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0001\"\>",
                6.5467399975961912*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0014\"\>",
                -0.001434326171875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9390\"\>",
                0.93896328641209614,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9389\"\>",
                0.93890054971915526,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0001\"\>",
                6.2736692940885584*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0051\"\>",
                0.005096435546875,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 30.38\"\>",
                  30.383591692095884,
                  AutoDelete->True], 
                InterpretationBox["\<\"-45.61\"\>",
                  -45.61409424819081,
                  AutoDelete->True], 
                InterpretationBox["\<\"-19.33\"\>",
                  -19.325468234484742,
                  AutoDelete->True], 
                InterpretationBox["\<\"-57.9\"\>",
                  -57.899148245567979,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.4481\"\>",
                  -0.4480616819744665,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.9894\"\>",
                  -0.98938282962181523,
                  AutoDelete->True], 
                InterpretationBox["\<\"-6.553\"\>",
                  -6.5531893563901615,
                  AutoDelete->True], 
                InterpretationBox["\<\"-57.67\"\>",
                  -57.674739959706372,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.936\"\>",
                  -3.9360950937896786,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-45.61\"\>",
                  -45.61409424819081,
                  AutoDelete->True], 
                InterpretationBox["\<\" 310.5\"\>",
                  310.53459027931575,
                  AutoDelete->True], 
                InterpretationBox["\<\"-6.128\"\>",
                  -6.1284592013999148,
                  AutoDelete->True], 
                InterpretationBox["\<\"-290.2\"\>",
                  -290.17517454316595,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7023\"\>",
                  0.70227843528639955,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.109\"\>",
                  -5.1085168633717046,
                  AutoDelete->True], 
                InterpretationBox["\<\" 17.57\"\>",
                  17.571461512138143,
                  AutoDelete->True], 
                InterpretationBox["\<\" 109.9\"\>",
                  109.90517002913136,
                  AutoDelete->True], 
                InterpretationBox["\<\"-45.61\"\>",
                  -45.611207275056032,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-19.33\"\>",
                  -19.325468234484735,
                  AutoDelete->True], 
                InterpretationBox["\<\"-6.128\"\>",
                  -6.1284592013999211,
                  AutoDelete->True], 
                InterpretationBox["\<\" 291.\"\>",
                  290.98281802015214,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.63\"\>",
                  5.6300550424032849,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.779\"\>",
                  2.779415481607229,
                  AutoDelete->True], 
                InterpretationBox["\<\" 56.94\"\>",
                  56.943563991907681,
                  AutoDelete->True], 
                InterpretationBox["\<\"-8.036\"\>",
                  -8.0360175487643701,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.009\"\>",
                  1.0090548217624917,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.044\"\>",
                  -1.0438604489215035,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-57.9\"\>",
                  -57.899148245567986,
                  AutoDelete->True], 
                InterpretationBox["\<\"-290.2\"\>",
                  -290.17517454316601,
                  AutoDelete->True], 
                InterpretationBox["\<\" 5.63\"\>",
                  5.6300550424032672,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1114.\"\>",
                  1113.9827301598809,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.5836\"\>",
                  -0.58364824520301584,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.509\"\>",
                  1.5088276890046295,
                  AutoDelete->True], 
                InterpretationBox["\<\"-8.059\"\>",
                  -8.0592043908570155,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.033\"\>",
                  -3.0326397466993669,
                  AutoDelete->True], 
                InterpretationBox["\<\" 108.3\"\>",
                  108.34443880110223,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.4481\"\>",
                  -0.44806168197446206,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.7023\"\>",
                  0.70227843528640133,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.779\"\>",
                  2.7794154816072236,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.5836\"\>",
                  -0.58364824520301939,
                  AutoDelete->True], 
                InterpretationBox["\<\" 498.8\"\>",
                  498.8141500140614,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.71\"\>",
                  18.705487351394904,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.144\"\>",
                  2.1443472720352545,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.738\"\>",
                  4.737678987030602,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.821\"\>",
                  1.8209922261596283,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-0.9894\"\>",
                  -0.9893828296218159,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.109\"\>",
                  -5.1085168633717073,
                  AutoDelete->True], 
                InterpretationBox["\<\" 56.94\"\>",
                  56.943563991907695,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.509\"\>",
                  1.5088276890046179,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.71\"\>",
                  18.705487351394922,
                  AutoDelete->True], 
                InterpretationBox["\<\" 172.9\"\>",
                  172.91129500357488,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.921\"\>",
                  -3.9207878459917609,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.221\"\>",
                  2.220573397338323,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.855\"\>",
                  2.8552734609872776,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-6.553\"\>",
                  -6.5531893563901571,
                  AutoDelete->True], 
                InterpretationBox["\<\" 17.57\"\>",
                  17.571461512138171,
                  AutoDelete->True], 
                InterpretationBox["\<\"-8.036\"\>",
                  -8.036017548764363,
                  AutoDelete->True], 
                InterpretationBox["\<\"-8.059\"\>",
                  -8.0592043908570368,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.144\"\>",
                  2.1443472720352155,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.921\"\>",
                  -3.9207878459917431,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1004.\"\>",
                  1003.963374362746,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.97\"\>",
                  18.972312755165099,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.081\"\>",
                  -3.0805807792517061,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-57.67\"\>",
                  -57.674739959706379,
                  AutoDelete->True], 
                InterpretationBox["\<\" 109.9\"\>",
                  109.90517002913136,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.009\"\>",
                  1.0090548217624988,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.033\"\>",
                  -3.0326397466993731,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.738\"\>",
                  4.7376789870306029,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.221\"\>",
                  2.2205733973383177,
                  AutoDelete->True], 
                InterpretationBox["\<\" 18.97\"\>",
                  18.972312755165134,
                  AutoDelete->True], 
                InterpretationBox["\<\" 175.2\"\>",
                  175.24681551577982,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.292\"\>",
                  0.2919742459809509,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-3.936\"\>",
                  -3.9360950937896821,
                  AutoDelete->True], 
                InterpretationBox["\<\"-45.61\"\>",
                  -45.61120727505606,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.044\"\>",
                  -1.043860448921504,
                  AutoDelete->True], 
                InterpretationBox["\<\" 108.3\"\>",
                  108.3444388011022,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.821\"\>",
                  1.8209922261596265,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.855\"\>",
                  2.8552734609872767,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.081\"\>",
                  -3.0805807792517115,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.292\"\>",
                  0.29197424598095068,
                  AutoDelete->True], 
                InterpretationBox["\<\" 99.41\"\>",
                  99.407234700109257,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.4330979249245253`*^-7, 6.10235288090977`*^-8, 
          1.6759901061717842`*^-8, 2.9939134266893475`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.515848833591343`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4330979249245253*^-07, 6.1023528809097703*^-08, 
        1.6759901061717842*^-08, 2.9939134266893475*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.515848833591343*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.4973322861478192`*^-10\),
      SequenceForm[ "NOISE  ", 1.4973322861478192*^-10],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]889823.6941748458`\
\[InvisibleSpace]"  "\[InvisibleSpace]866497.5357643529`\),
      SequenceForm[ "*BFGSUP ", 889823.69417484582, "  ", 866497.53576435288],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]2.638310685359078`*^-7\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 2.638310685359078*^-07, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]14\),
      SequenceForm[ "BFGS: Iteration = ", 14],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592815099000\"\>",
            2891.7725928150985,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.7725928150985, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592814112000\"\>",
            2891.7725928141122,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.7725928141122, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     9.863470040727410"\[Times]10\^"-10"\),
            9.8634700407274067*^-10,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 9.8634700407274067*^-10, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.328256410826775,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.328243774244218,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                1.2636582556192024*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                1.3083038802492886*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952197987713213,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952196956498197,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0002\"\>",
                -0.00018630000581786578,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.124738171649635,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.1247379210042783,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0001\"\>",
                -5.4266114007698544*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091818388000156,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091812897946939,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0001\"\>",
                6.0756245899778227*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011149743195313698,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011148906128470127,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0005\"\>",
                0.000457763671875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.0027835749965165798,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.0027857509394063062,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0004\"\>",
                0.000396728515625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172682523589731,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172689321804007,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0007\"\>",
                -0.00065998940645022812,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.057972064544328163,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.057977598238320834,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0002\"\>",
                0.000244140625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9390\"\>",
                0.93896513631126877,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9390\"\>",
                0.93896328641209614,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0002\"\>",
                0.00018310546875,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 30.43\"\>",
                  30.42827167536074,
                  AutoDelete->True], 
                InterpretationBox["\<\"-45.47\"\>",
                  -45.471816138239511,
                  AutoDelete->True], 
                InterpretationBox["\<\"-18.91\"\>",
                  -18.909358242813102,
                  AutoDelete->True], 
                InterpretationBox["\<\"-58.28\"\>",
                  -58.280171548915419,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.084\"\>",
                  -1.0843966994415981,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.581\"\>",
                  -1.5812382654361339,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.4\"\>",
                  -5.3999237352760776,
                  AutoDelete->True], 
                InterpretationBox["\<\"-58.15\"\>",
                  -58.148599211654769,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.08\"\>",
                  -4.0799911152617963,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-45.47\"\>",
                  -45.471816138239511,
                  AutoDelete->True], 
                InterpretationBox["\<\" 309.5\"\>",
                  309.46300914884733,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.981\"\>",
                  -5.9812633078260706,
                  AutoDelete->True], 
                InterpretationBox["\<\"-290.2\"\>",
                  -290.23594801684237,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.984\"\>",
                  2.9837614818811504,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.181\"\>",
                  -3.1807178998892613,
                  AutoDelete->True], 
                InterpretationBox["\<\" 14.57\"\>",
                  14.571195371661782,
                  AutoDelete->True], 
                InterpretationBox["\<\" 111.\"\>",
                  110.95709197740248,
                  AutoDelete->True], 
                InterpretationBox["\<\"-44.56\"\>",
                  -44.56297532197982,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-18.91\"\>",
                  -18.909358242813092,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.981\"\>",
                  -5.9812633078260768,
                  AutoDelete->True], 
                InterpretationBox["\<\" 293.9\"\>",
                  293.94815442688309,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.972\"\>",
                  2.9719343986115092,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1811\"\>",
                  0.18112591961656044,
                  AutoDelete->True], 
                InterpretationBox["\<\" 54.38\"\>",
                  54.376858872186141,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.45\"\>",
                  -2.4504693343279556,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.426\"\>",
                  -1.4256697083749437,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.22\"\>",
                  -1.2201822125154718,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-58.28\"\>",
                  -58.280171548915433,
                  AutoDelete->True], 
                InterpretationBox["\<\"-290.2\"\>",
                  -290.23594801684243,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.972\"\>",
                  2.9719343986115057,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1116.\"\>",
                  1116.3607681629671,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.586\"\>",
                  1.5864381441055886,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.674\"\>",
                  3.6740372844135045,
                  AutoDelete->True], 
                InterpretationBox["\<\"-12.85\"\>",
                  -12.849863372826448,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.9275\"\>",
                  -0.92752478829505591,
                  AutoDelete->True], 
                InterpretationBox["\<\" 108.4\"\>",
                  108.4327655708864,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-1.084\"\>",
                  -1.0843966994415937,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.984\"\>",
                  2.9837614818811558,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.1811\"\>",
                  0.18112591961655511,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.586\"\>",
                  1.586438144105585,
                  AutoDelete->True], 
                InterpretationBox["\<\" 495.7\"\>",
                  495.70535951318772,
                  AutoDelete->True], 
                InterpretationBox["\<\" 16.36\"\>",
                  16.362728366273636,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.573\"\>",
                  4.5728474997414867,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.251\"\>",
                  4.2508039790718772,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.386\"\>",
                  -0.3860333792230044,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-1.581\"\>",
                  -1.5812382654361345,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.181\"\>",
                  -3.1807178998892605,
                  AutoDelete->True], 
                InterpretationBox["\<\" 54.38\"\>",
                  54.376858872186148,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.674\"\>",
                  3.6740372844134965,
                  AutoDelete->True], 
                InterpretationBox["\<\" 16.36\"\>",
                  16.362728366273657,
                  AutoDelete->True], 
                InterpretationBox["\<\" 171.2\"\>",
                  171.21792800613485,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.512\"\>",
                  -2.5120056474804913,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.094\"\>",
                  2.0939336022752357,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9944\"\>",
                  0.99440944690688271,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-5.4\"\>",
                  -5.3999237352760732,
                  AutoDelete->True], 
                InterpretationBox["\<\" 14.57\"\>",
                  14.57119537166181,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.45\"\>",
                  -2.4504693343279493,
                  AutoDelete->True], 
                InterpretationBox["\<\"-12.85\"\>",
                  -12.849863372826469,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.573\"\>",
                  4.5728474997414477,
                  AutoDelete->True], 
                InterpretationBox["\<\"-2.512\"\>",
                  -2.5120056474804735,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1005.\"\>",
                  1004.5276735390778,
                  AutoDelete->True], 
                InterpretationBox["\<\" 17.95\"\>",
                  17.948988144741342,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2017\"\>",
                  -0.20171632867047773,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-58.15\"\>",
                  -58.148599211654769,
                  AutoDelete->True], 
                InterpretationBox["\<\" 111.\"\>",
                  110.95709197740248,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.426\"\>",
                  -1.4256697083749348,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.9275\"\>",
                  -0.92752478829506213,
                  AutoDelete->True], 
                InterpretationBox["\<\" 4.251\"\>",
                  4.2508039790718781,
                  AutoDelete->True], 
                InterpretationBox["\<\" 2.094\"\>",
                  2.0939336022752308,
                  AutoDelete->True], 
                InterpretationBox["\<\" 17.95\"\>",
                  17.948988144741378,
                  AutoDelete->True], 
                InterpretationBox["\<\" 176.\"\>",
                  175.97103394612705,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.7122\"\>",
                  -0.71222399758476929,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-4.08\"\>",
                  -4.0799911152617998,
                  AutoDelete->True], 
                InterpretationBox["\<\"-44.56\"\>",
                  -44.562975321979849,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.22\"\>",
                  -1.2201822125154793,
                  AutoDelete->True], 
                InterpretationBox["\<\" 108.4\"\>",
                  108.43276557088637,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.386\"\>",
                  -0.38603337922300973,
                  AutoDelete->True], 
                InterpretationBox["\<\" 0.9944\"\>",
                  0.99440944690688005,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.2017\"\>",
                  -0.20171632867048306,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.7122\"\>",
                  -0.71222399758476773,
                  AutoDelete->True], 
                InterpretationBox["\<\" 98.38\"\>",
                  98.382193322727034,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.4330998079220615`*^-7, 6.102353034572782`*^-8, 
          1.6759904796624705`*^-8, 2.993914244771027`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.5158478205784755`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4330998079220615*^-07, 6.102353034572782*^-08, 
        1.6759904796624705*^-08, 2.9939142447710269*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5158478205784755*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.251677628739189`*^-11\),
      SequenceForm[ "NOISE  ", 1.251677628739189*^-11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]3.051000861392237`*^8\
\[InvisibleSpace]"  "\[InvisibleSpace]2.8163414669307685`*^8\),
      SequenceForm[ "*BFGSUP ", 305100086.13922369, "  ", 281634146.69307685],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]6.33194564485963`*^-8\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 6.3319456448596298*^-08, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]15\),
      SequenceForm[ "BFGS: Iteration = ", 15],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592815010000\"\>",
            2891.7725928150103,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592815099000\"\>",
            2891.7725928150985,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2891.7725928150103, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.7725928150985, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592815082000\"\>",
            2891.7725928150821,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592815099000\"\>",
            2891.7725928150985,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2891.7725928150821, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.7725928150985, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 4"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS:  ENDE DER ITERATION  "\[InvisibleSpace]14\
\[InvisibleSpace]"  "\[InvisibleSpace]300\),
      SequenceForm[ "BFGS:  ENDE DER ITERATION  ", 14, "  ", 300],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"SCORE\"\>"},
          {"1", "1.8690040967732914`*^-6"},
          {"2", "7.4520000450662295`*^-6"},
          {"3", \(-0.000027133050957308908`\)},
          {"4", "0.000045567171973682534`"},
          {"5", "0.000030517578125`"},
          {"6", \(-0.000030517578125`\)},
          {"7", "0.00017999723113877917`"},
          {"8", "0.000091552734375`"},
          {"9", \(-0.00006103515625`\)}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {
                InterpretationBox["\<\" 30.42\"\>",
                  30.418433243434208,
                  AutoDelete->True], 
                InterpretationBox["\<\"-45.45\"\>",
                  -45.448273145708882,
                  AutoDelete->True], 
                InterpretationBox["\<\"-18.8\"\>",
                  -18.802240807780446,
                  AutoDelete->True], 
                InterpretationBox["\<\"-58.45\"\>",
                  -58.452067921347926,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.309\"\>",
                  -1.309305625034302,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.581\"\>",
                  -1.5812551946120583,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.842\"\>",
                  -5.842039422600795,
                  AutoDelete->True], 
                InterpretationBox["\<\"-58.53\"\>",
                  -58.526102537488626,
                  AutoDelete->True], 
                InterpretationBox["\<\"-3.919\"\>",
                  -3.9193636487789103,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-45.45\"\>",
                  -45.448273145708882,
                  AutoDelete->True], 
                InterpretationBox["\<\" 311.1\"\>",
                  311.14154623078349,
                  AutoDelete->True], 
                InterpretationBox["\<\"-7.225\"\>",
                  -7.2245846208542863,
                  AutoDelete->True], 
                InterpretationBox["\<\"-287.9\"\>",
                  -287.94604555645412,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.746\"\>",
                  1.7457883377605947,
                  AutoDelete->True], 
                InterpretationBox["\<\"-7.621\"\>",
                  -7.6211106709281413,
                  AutoDelete->True], 
                InterpretationBox["\<\" 29.6\"\>",
                  29.597341895829686,
                  AutoDelete->True], 
                InterpretationBox["\<\" 114.7\"\>",
                  114.74672750435865,
                  AutoDelete->True], 
                InterpretationBox["\<\"-49.39\"\>",
                  -49.387785210372272,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-18.8\"\>",
                  -18.802240807780436,
                  AutoDelete->True], 
                InterpretationBox["\<\"-7.225\"\>",
                  -7.2245846208542925,
                  AutoDelete->True], 
                InterpretationBox["\<\" 293.3\"\>",
                  293.34341068968348,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.775\"\>",
                  3.7747439829311396,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.64\"\>",
                  3.6403441343102507,
                  AutoDelete->True], 
                InterpretationBox["\<\" 56.9\"\>",
                  56.903265153718984,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.584\"\>",
                  -5.5835520255788955,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.042\"\>",
                  1.0424097085496435,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.4428\"\>",
                  -0.44281571818302945,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-58.45\"\>",
                  -58.45206792134794,
                  AutoDelete->True], 
                InterpretationBox["\<\"-287.9\"\>",
                  -287.94604555645418,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.775\"\>",
                  3.7747439829311356,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1115.\"\>",
                  1115.3915550263719,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.266\"\>",
                  -4.2664327472733756,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.134\"\>",
                  -1.1344590055092381,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.449\"\>",
                  -5.4494183462294075,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.398\"\>",
                  -4.3979022585689815,
                  AutoDelete->True], 
                InterpretationBox["\<\" 106.4\"\>",
                  106.43103526339928,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-1.309\"\>",
                  -1.3093056250342971,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.746\"\>",
                  1.7457883377605965,
                  AutoDelete->True], 
                InterpretationBox["\<\" 3.64\"\>",
                  3.6403441343102454,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.266\"\>",
                  -4.2664327472733792,
                  AutoDelete->True], 
                InterpretationBox["\<\" 492.4\"\>",
                  492.38233898543893,
                  AutoDelete->True], 
                InterpretationBox["\<\" 20.91\"\>",
                  20.908474996459724,
                  AutoDelete->True], 
                InterpretationBox["\<\"-19.83\"\>",
                  -19.834703681216752,
                  AutoDelete->True], 
                InterpretationBox["\<\"-7.334\"\>",
                  -7.3340028109666537,
                  AutoDelete->True], 
                InterpretationBox["\<\" 7.832\"\>",
                  7.8320840936939717,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-1.581\"\>",
                  -1.5812551946120588,
                  AutoDelete->True], 
                InterpretationBox["\<\"-7.621\"\>",
                  -7.6211106709281404,
                  AutoDelete->True], 
                InterpretationBox["\<\" 56.9\"\>",
                  56.903265153718991,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.134\"\>",
                  -1.1344590055092469,
                  AutoDelete->True], 
                InterpretationBox["\<\" 20.91\"\>",
                  20.908474996459745,
                  AutoDelete->True], 
                InterpretationBox["\<\" 182.6\"\>",
                  182.58327283986449,
                  AutoDelete->True], 
                InterpretationBox["\<\"-38.26\"\>",
                  -38.264500267896722,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.294\"\>",
                  -5.2941973701980309,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.36\"\>",
                  12.360033782997807,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-5.842\"\>",
                  -5.8420394226007906,
                  AutoDelete->True], 
                InterpretationBox["\<\" 29.6\"\>",
                  29.597341895829707,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.584\"\>",
                  -5.5835520255788893,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.449\"\>",
                  -5.449418346229427,
                  AutoDelete->True], 
                InterpretationBox["\<\"-19.83\"\>",
                  -19.834703681216759,
                  AutoDelete->True], 
                InterpretationBox["\<\"-38.26\"\>",
                  -38.264500267896686,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1097.\"\>",
                  1097.1235491231319,
                  AutoDelete->True], 
                InterpretationBox["\<\" 24.22\"\>",
                  24.223537982254363,
                  AutoDelete->True], 
                InterpretationBox["\<\"-28.74\"\>",
                  -28.73524428280691,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-58.53\"\>",
                  -58.526102537488626,
                  AutoDelete->True], 
                InterpretationBox["\<\" 114.7\"\>",
                  114.74672750435866,
                  AutoDelete->True], 
                InterpretationBox["\<\" 1.042\"\>",
                  1.0424097085496529,
                  AutoDelete->True], 
                InterpretationBox["\<\"-4.398\"\>",
                  -4.3979022585689886,
                  AutoDelete->True], 
                InterpretationBox["\<\"-7.334\"\>",
                  -7.3340028109666529,
                  AutoDelete->True], 
                InterpretationBox["\<\"-5.294\"\>",
                  -5.2941973701980363,
                  AutoDelete->True], 
                InterpretationBox["\<\" 24.22\"\>",
                  24.223537982254406,
                  AutoDelete->True], 
                InterpretationBox["\<\" 166.3\"\>",
                  166.28799561933062,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.936\"\>",
                  -1.9363875407371518,
                  AutoDelete->True]},
              {
                InterpretationBox["\<\"-3.919\"\>",
                  -3.9193636487789139,
                  AutoDelete->True], 
                InterpretationBox["\<\"-49.39\"\>",
                  -49.3877852103723,
                  AutoDelete->True], 
                InterpretationBox["\<\"-0.4428\"\>",
                  -0.442815718183037,
                  AutoDelete->True], 
                InterpretationBox["\<\" 106.4\"\>",
                  106.43103526339925,
                  AutoDelete->True], 
                InterpretationBox["\<\" 7.832\"\>",
                  7.8320840936939629,
                  AutoDelete->True], 
                InterpretationBox["\<\" 12.36\"\>",
                  12.360033782997805,
                  AutoDelete->True], 
                InterpretationBox["\<\"-28.74\"\>",
                  -28.735244282806914,
                  AutoDelete->True], 
                InterpretationBox["\<\"-1.936\"\>",
                  -1.9363875407371502,
                  AutoDelete->True], 
                InterpretationBox["\<\" 107.1\"\>",
                  107.12505498847467,
                  AutoDelete->True]}
              }], "\[NoBreak]", ")"}],
        Function[ BoxForm`e$, 
          MatrixForm[ BoxForm`e$]]],
      (NumberForm[ #, 4, NumberSigns -> {"-", " "}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"Likelihood\"\>", "\<\"THETA\"\>", "\<\"\"\>", "\<\
\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
          {"1", "2887.7236043713533`", "16", "4", "1", "2", "0", "0", "1", 
            "0", "1"},
          {"2", "2889.7498070401357`", "16.00592406095798`", 
            "4.008378590896041`", "1.0284798188646707`", "1.9609375`", 
            "0.005416373253468015`", "0.005492958367869276`", 
            "1.016982415559619`", \(-0.0173911363501808`\), 
            "0.9898231932862885`"},
          {"3", "2890.820531509937`", "16.012511252700875`", 
            "4.00241376222786`", "1.0675423188646707`", "1.969394906930788`", 
            "0.010594755276505234`", "0.011590968679506772`", 
            "1.0179550364043373`", \(-0.04561857698648879`\), 
            "0.9803505244892164`"},
          {"4", "2890.913609995775`", "16.020920726671555`", 
            "4.024868530582253`", "1.0741460432279177`", 
            "1.9695736777863113`", "0.002615998650764147`", 
            "0.0013252327123107633`", 
            "0.9911982893662923`", \(-0.07576232439764136`\), 
            "0.9590666250306937`"},
          {"5", "2891.1445931546195`", "16.03200665870169`", 
            "4.060323468551179`", "1.0685994148185871`", 
            "1.9863940521166998`", \(-0.005187800784938493`\), \
\(-0.01700169192674833`\), "1.0020570953145878`", \(-0.11424315508107885`\), 
            "0.9297321197159313`"},
          {"6", "2891.1618892633533`", "16.03608116207862`", 
            "4.069088522209923`", "1.0663801446545476`", 
            "1.9896278329056363`", 
            "0.007774689856916698`", \(-0.015036959971286186`\), 
            "1.0012608195143478`", \(-0.11758157839060221`\), 
            "0.9262066464057438`"},
          {"7", "2891.1873047701747`", "16.052105975165475`", 
            "4.078043685000544`", "1.0657019038834785`", 
            "1.9929040875544584`", 
            "0.005279718152378439`", \(-0.000677793275626188`\), 
            "1.0016649821199686`", \(-0.11689948061190197`\), 
            "0.9283394109394482`"},
          {"8", "2891.2477528156064`", "16.098588653766868`", 
            "4.078974480966925`", "1.0638764871756077`", 
            "1.9942399061962799`", "0.006421589096830245`", 
            "0.0018213398625695505`", 
            "1.0025752682904323`", \(-0.11604860495855496`\), 
            "0.935265935787745`"},
          {"9", "2891.4808889313235`", "16.254838653766868`", 
            "4.105715015983308`", "1.0887151553890786`", "2.007803325936501`",
             "0.0070065439778675765`", \(-0.008895688852179482`\), 
            "1.0058321741618075`", \(-0.07629592725452523`\), 
            "0.9520338173964658`"},
          {"10", "2891.555698056919`", "16.327513922528595`", 
            "4.100222373877169`", "1.095098398850659`", "2.013057362355001`", 
            "0.007128471974628694`", \(-0.0038763182476389702`\), 
            "1.0077400043722577`", \(-0.046337034026563535`\), 
            "0.9191482372326659`"},
          {"11", "2891.694842582603`", "16.222592219935684`", 
            "4.074477755402501`", "1.132287201889873`", "1.9967914572989656`",
             "0.013162839189780628`", "0.00220160153998833`", 
            "1.021904514658722`", \(-0.08944106718282271`\), 
            "0.9402513587803548`"},
          {"12", "2891.772427541464`", "16.336219338216104`", 
            "4.096625194516447`", "1.1251336718878522`", "2.01001840865607`", 
            "0.011039761161214651`", \(-0.003220333790739123`\), 
            "1.017480469131031`", \(-0.05658488299736742`\), 
            "0.9393488996331567`"},
          {"13", "2891.7725922330087`", "16.32801041689342`", 
            "4.0952158035035495`", "1.124690031347898`", "2.009181513813311`",
             "0.011140444568479882`", \(-0.0027852511143634153`\), 
            "1.0172680108600618`", \(-0.058043065638296795`\), 
            "0.9389005497191553`"},
          {"14", "2891.772592814112`", "16.328243774244218`", 
            "4.09521969564982`", "1.1247379210042783`", "2.009181289794694`", 
            "0.011148906128470127`", \(-0.0027857509394063062`\), 
            "1.0172689321804007`", \(-0.057977598238320834`\), 
            "0.9389632864120961`"},
          {"15", "2891.7725928150985`", "16.328256410826775`", 
            "4.095219798771321`", "1.124738171649635`", "2.0091818388000156`",
             "0.011149743195313698`", \(-0.00278357499651658`\), 
            "1.0172682523589731`", \(-0.05797206454432816`\), 
            "0.9389651363112688`"},
          {"16", "2891.7725928150985`", "16.328256410826775`", 
            "4.095219798771321`", "1.124738171649635`", "2.0091818388000156`",
             "0.011149743195313698`", \(-0.00278357499651658`\), 
            "1.0172682523589731`", \(-0.05797206454432816`\), 
            "0.9389651363112688`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"Likelihood", "THETA"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("INK: "\[InvisibleSpace]{0.00009887501298276114`, 
          0.000024798416963999168`, 6.81080076929253`*^-6, 
          0.000012166509111429397`, 6.055454452393343`*^-6, 
          6.055454452393343`*^-6, 6.160021568025539`*^-6, 
          6.055454452393343`*^-6, 6.055454452393343`*^-6}\),
      SequenceForm[ 
      "INK: ", {9.8875012982761138*^-05, 2.4798416963999168*^-05, 
        6.8108007692925303*^-06, 1.2166509111429397*^-05, 
        6.0554544523933429*^-06, 6.0554544523933429*^-06, 
        6.1600215680255387*^-06, 6.0554544523933429*^-06, 
        6.0554544523933429*^-06}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{
        TagBox[GridBox[{
              {"\<\"\"\>", "\<\"THETA\"\>", "\<\"SCORE\"\>"},
              {"1", "16.328256410826775`", "1.8690040967732914`*^-6"},
              {"2", "4.095219798771321`", "7.4520000450662295`*^-6"},
              {"3", "1.124738171649635`", \(-0.000027133050957308908`\)},
              {"4", "2.0091818388000156`", "0.000045567171973682534`"},
              {"5", "0.011149743195313698`", "0.000030517578125`"},
              {"6", \(-0.00278357499651658`\), \(-0.000030517578125`\)},
              {"7", "1.0172682523589731`", "0.00017999723113877917`"},
              {"8", \(-0.05797206454432816`\), "0.000091552734375`"},
              {"9", "0.9389651363112688`", \(-0.00006103515625`\)}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            RowAlignments->Baseline,
            ColumnAlignments->{Left}],
          Function[ BoxForm`e$, 
            TableForm[ 
            BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}, 
              TableDirections -> {Column, Row}, TableSpacing -> {0, 1}]]], 
        "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
        "2891.7725928150985`"}],
      SequenceForm[ 
        TableForm[ {{16.328256410826775, 1.8690040967732914*^-06}, {
          4.0952197987713213, 7.4520000450662295*^-06}, {
          1.124738171649635, -2.7133050957308908*^-05}, {2.0091818388000156, 
          4.5567171973682534*^-05}, {0.011149743195313698, 
          3.0517578125*^-05}, {-0.0027835749965165798, -3.0517578125*^-05}, {
          1.0172682523589731, 0.00017999723113877917}, {-0.057972064544328163,
           9.1552734375*^-05}, {0.93896513631126877, -6.103515625*^-05}}, 
          TableHeadings -> {Automatic, {"THETA", "SCORE"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 1}], 
        "   Likelihood = ", 2891.7725928150985],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("WALD-TEST:"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"CHI \"\>", "\<\"U \"\>", "\<\"PROB \"\>", \
"\<\"ALPHA \"\>"},
          {"1", "3711.537119242976`", "9", "0", "0.05`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", 
          "ALPHA "}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("NULLHYPOTHESE THETA = 0 ABLEHNEN"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("BONFERRONI-KONFIDENZINTERVALLE:"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= 1-ALPHA"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("QUANTIL Z(1-ALPHA/2U) = \
"\[InvisibleSpace]2.7729212946086625`\),
      SequenceForm[ "QUANTIL Z(1-ALPHA/2U) = ", 2.7729212946086625],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"THETA\"\>", "\<\"GRENZE\"\>", "\<\"STD\"\>"},
          {"1", "16.328256410826775`", "1.5474345007953287`", 
            "0.5580520816815017`"},
          {"2", "4.095219798771321`", "0.3181662078847098`", 
            "0.11474043944316567`"},
          {"3", "1.124738171649635`", "0.20141202257323246`", 
            "0.07263531891973782`"},
          {"4", "2.0091818388000156`", "0.17333418815776178`", 
            "0.06250959538403492`"},
          {"5", "0.011149743195313698`", "0.1261494572167335`", 
            "0.04549334215219288`"},
          {"6", \(-0.00278357499651658`\), "0.2233895763263503`", 
            "0.08056109517449425`"},
          {"7", "1.0172682523589731`", "0.0892022350895519`", 
            "0.032169046868725085`"},
          {"8", \(-0.05797206454432816`\), "0.4496369523598523`", 
            "0.16215280009355937`"},
          {"9", "0.9389651363112688`", "0.2995294298356682`", 
            "0.10801944880946947`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("Korrelation der ML-Sch\[ADoubleDot]tzer"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1.`", "0.7265600613998319`", "0.5447027637967193`", 
              "0.8048212752884495`", \(-0.000029817013797360802`\), \
\(-0.10187908411753233`\), \(-0.00017170777951616898`\), 
              "0.8225389687783109`", "0.06605472919966077`"},
            {"0.7265600613998286`", "0.9999999999999998`", 
              "0.4086311319319928`", 
              "0.7953871514516272`", \(-0.000010449670290034382`\), \
\(-0.056324703574811466`\), \(-0.00009847405390544397`\), 
              "0.38503505982081765`", "0.13694463747111943`"},
            {"0.544702763796718`", "0.4086311319319938`", 
              "1.0000000000000002`", 
              "0.4441270513771955`", \(-0.000014775590099615934`\), \
\(-0.26998241329147127`\), \(-0.00009762133105567019`\), 
              "0.4422503452821187`", "0.038426431817709064`"},
            {"0.8048212752884462`", "0.7953871514516275`", 
              "0.4441270513771946`", 
              "0.9999999999999998`", \(-0.000016527007388602015`\), \
\(-0.074095458319544`\), \(-0.00012579633232111313`\), 
              "0.5671666255690372`", \(-0.07441982919169242`\)},
            {\(-0.000029817013796007853`\), \(-0.000010449670289075024`\), \
\(-0.00001477559009892246`\), \(-0.000016527007387575736`\), 
              "0.9999999999999999`", \(-0.032166418449945236`\), 
              "5.095452979693023`*^-7", \(-0.0000396924193495683`\), \
\(-0.000013957062463456501`\)},
            {\(-0.10187908411753424`\), \(-0.05632470357481318`\), \
\(-0.26998241329147343`\), \(-0.07409545831954593`\), \
\(-0.032166418449944965`\), "1.0000000000000002`", 
              "0.000020356140455610202`", \(-0.09177857668744911`\), \
\(-0.003424448103783474`\)},
            {\(-0.0001717077795196005`\), \(-0.00009847405390819576`\), \
\(-0.00009762133105788666`\), \(-0.00012579633232408526`\), 
              "5.095452979984535`*^-7", "0.00002035614045582759`", 
              "1.`", \(-0.01149179859740258`\), \(-9.28951786308528`*^-7\)},
            {"0.8225389687783122`", "0.385035059820821`", 
              "0.4422503452821208`", 
              
              "0.5671666255690406`", \(-0.00003969241935078905`\), \
\(-0.0917785766874478`\), \(-0.011491798597399887`\), "1.0000000000000002`", 
              "0.01414784855236485`"},
            {"0.06605472919966128`", "0.13694463747111962`", 
              "0.038426431817709675`", \(-0.07441982919169203`\), \
\(-0.000013957062463762099`\), \(-0.0034244481037835604`\), \
\(-9.289517866767849`*^-7\), "0.014147848552365512`", "1.`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND EIGENWERTE"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0.3114221258690574`", "0.04652246979771676`", 
              "0.02207914029634616`", 
              "0.02807507134934435`", \(-7.56984038267833`*^-7\), \
\(-0.004580207210181552`\), \(-3.082498671008718`*^-6\), 
              "0.07443131080947335`", "0.003981810668164944`"},
            {"0.046522469797716556`", "0.013165368443610768`", 
              "0.0034056170171303047`", 
              "0.005704817659530153`", \(-5.4546506372790284`*^-8\), \
\(-0.0005206439008760789`\), \(-3.6347665217220026`*^-7\), 
              "0.0071637634676939245`", "0.0016973190921971055`"},
            {"0.0220791402963461`", "0.003405617017130313`", 
              "0.0052758895545720235`", 
              "0.002016516416572407`", \(-4.8824805909639266`*^-8\), \
\(-0.0015798239168944657`\), \(-2.2810287865281787`*^-7\), 
              "0.0052088335658746375`", "0.0003014948259287208`"},
            {"0.028075071349344238`", "0.005704817659530155`", 
              "0.002016516416572403`", 
              "0.003907449515075758`", \(-4.699901458749113`*^-8\), \
\(-0.00037313298122942793`\), \(-2.5296058699918666`*^-7\), 
              "0.005748860993459653`", \(-0.0005025014433782994`\)},
            {\(-7.569840382334848`*^-7\), \(-5.45465063677825`*^-8\), \
\(-4.8824805907347744`*^-8\), \(-4.699901458457262`*^-8\), 
              "0.0020696441801764894`", \(-0.00011788971347354223`\), 
              "7.45708056342426`*^-10", \(-2.9280592928492536`*^-7\), \
\(-6.858731824172231`*^-8\)},
            {\(-0.004580207210181638`\), \(-0.0005206439008760947`\), \
\(-0.0015798239168944785`\), \(-0.00037313298122943763`\), \
\(-0.00011788971347354124`\), "0.006490090055713922`", 
              "5.275443714848169`*^-8", \(-0.001198922560223454`\), \
\(-0.000029800112762616372`\)},
            {\(-3.0824986710703208`*^-6\), \(-3.6347665218235735`*^-7\), \
\(-2.2810287865799695`*^-7\), \(-2.5296058700516327`*^-7\), 
              "7.457080563850881`*^-10", "5.275443714904506`*^-8", 
              "0.0010348475764422312`", \(-0.00005994468081541986`\), \
\(-3.2279985020472372`*^-9\)},
            {"0.07443131080947346`", "0.007163763467693987`", 
              "0.005208833565874663`", 
              "0.005748860993459688`", \(-2.928059292939307`*^-7\), \
\(-0.0011989225602234367`\), \(-0.000059944680815405815`\), 
              "0.02629353057818183`", "0.0002478088496427391`"},
            {"0.003981810668164975`", "0.0016973190921971079`", 
              "0.00030149482592872556`", \(-0.0005025014433782968`\), \
\(-6.858731824322406`*^-8\), \(-0.000029800112762617124`\), \
\(-3.2279985033268865`*^-9\), "0.0002478088496427507`", 
              "0.011668201321101595`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \({0.0008178833827339859`, 0.001034066106979395`, 0.0020655355186586684`, 
      0.003150187351715422`, 0.0032049799946853095`, 0.0069071378411105335`, 
      0.010630736017554286`, 0.012792277747082309`, 
      0.34072434313341005`}\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX UND \
EIGENWERTE"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {
              "29.799775097756662`", \(-44.191392713818196`\), \
\(-18.677636635179862`\), \(-58.47800009376771`\), \(-0.04329240753996677`\), \
\(-0.7585665268516107`\), \(-3.1791209322892287`\), \(-55.829357102395925`\), \
\(-4.592982657825686`\)},
            {\(-44.191392713818196`\), 
              "307.2280656033988`", \(-6.478713725140565`\), \
\(-290.3438378698992`\), \(-0.307372861477562`\), \(-5.374482619776385`\), 
              "6.063941682662687`", 
              "106.34116808306105`", \(-44.2192957960134`\)},
            {\(-18.677636635179862`\), \(-6.478713725140565`\), 
              "288.86015502513425`", "0.0013719744521190952`", 
              "3.2279155445719816`", "56.67183234915062`", 
              "0.0027097534461564604`", \(-0.0027565461524952876`\), \
\(-0.0027565461524952876`\)},
            {\(-58.47800009376771`\), \(-290.3438378698992`\), 
              "0.0013719744521190952`", "1114.1404942337708`", "0", 
              "0.001543112036826441`", \(-0.0030338350444891467`\), 
              "0.007715560184132204`", "110.17202698126057`"},
            {\(-0.04329240753996677`\), \(-0.307372861477562`\), 
              "3.2279155445719816`", "0", "483.71706508979344`", 
              "9.518205526449934`", "0", "0.006200785359250772`", 
              "0.003100392679625386`"},
            {\(-0.7585665268516107`\), \(-5.374482619776385`\), 
              "56.67183234915062`", "0.001543112036826441`", 
              "9.518205526449934`", "167.08326189769167`", "0", 
              "0.003100392679625386`", "0.003100392679625386`"},
            {\(-3.1791209322892287`\), "6.063941682662687`", 
              "0.0027097534461564604`", \(-0.0030338350444891467`\), "0", "0",
               "966.871837052827`", "9.551689670265223`", "0"},
            {\(-55.829357102395925`\), 
              "106.34116808306105`", \(-0.0027565461524952876`\), 
              "0.007715560184132204`", "0.006200785359250772`", 
              "0.003100392679625386`", "9.551689670265223`", 
              "167.12046660984717`", "0.03410431947587925`"},
            {\(-4.592982657825686`\), \(-44.2192957960134`\), \
\(-0.0027565461524952876`\), "110.17202698126057`", "0.003100392679625386`", 
              "0.003100392679625386`", "0", "0.03410431947587925`", 
              "98.44676875614488`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \({1222.668195870715`, 967.05616135229`, 484.13594971699484`, 
      317.4414370800689`, 312.0144280645309`, 144.7777680138521`, 
      94.06686407683563`, 78.17216134382966`, 2.9349238472475436`}\)], "Print",\

  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("KOMPENSIERTE LIKELIHOOD"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("U =  "\[InvisibleSpace]9\[InvisibleSpace]"  Nue = "\
\[InvisibleSpace]3000\),
      SequenceForm[ "U =  ", 9, "  Nue = ", 3000],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) AZENCOTT/DACUNHA-CASTELLE \
(A/D)"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"LIK\"\>", "\<\"AIC\"\>", "\<\"SIC/RISS\"\>", \
"\<\"A/D\"\>"},
          {"\<\"Kompensator\"\>", "0", "9", "36.028654054426106`", 
            "93.70428336945712`"},
          {"\<\"komp. Lik.\"\>", "2891.7725928150985`", "2882.7725928150985`",
             "2855.7439387606723`", "2798.0683094456413`"}
          },
        RowSpacings->0,
        ColumnSpacings->1,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {{"Kompensator", "komp. Lik."}, {"LIK", 
          "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 1}]]]], "Print",
  PageWidth->Infinity]
}, Closed]],

Cell[TextData[StyleBox["Math 4.2 / OS 9:",
  FontColor->RGBColor[0, 1, 0]]], "Text",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\({THETA, COV, LIKI, psii, scoreii, k, 
          ReturnCode} = \[IndentingNewLine]BFGS[{{S, m, n, 
              Deterministisch}}, {THETA0, 
            F0}, \ \[IndentingNewLine]\t\ \ {{SystemEDMdet, {Deltat, 
                T}}, {Lik, LISRELlik, Score, 
              Hesse}}, \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ {{Sing = 
                False, 1}, 
            KMAX = 300, {EPS1 =  .0001, 
              EPS2 =  .0001}, \[IndentingNewLine]\ \ \ \ \ \ \ \ \ \ \ \ \ \
OPTION = 0, 
            PRINT = {1, 1, 1, 1, 1, 1, 1, 1, 
                1}}];\)\(\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \)\)\)], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(Sing\)\" is similar to \
existing symbols \!\({Sign, Sin, Sinh}\)."\)], "Message",
  PageWidth->Infinity],

Cell[BoxData[
    \("***********************LSDE1**********************************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("***********************MODUL:    BFGS (skeleton)**************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("Technical Output"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(LISRELlik\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"KMAX\"\>", "\<\"EPS1\"\>", "\<\"EPS2\"\>", "\<\"K\
\"\>", "\<\"Q\"\>", "\<\"n\"\>", "\<\"T\"\>", "\<\"OPTION    \"\>"},
          {"1", "300", "0.0001`", "0.0001`", "K$1287", "Q$1287", "500", "5", 
            "0"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"KMAX", "EPS1", "EPS2", "K",
           "Q", "n", "T", "OPTION    "}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"MAXSTEP\"\>", "\<\"MINSTEP\"\>", "\<\"BOUND\"\>", \
"\<\"STEPREDUCE\"\>", "\<\"FMAX\"\>"},
          {"1", "10", "1.`*^-10", "1.`*^-6", "4", "1000"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"MAXSTEP", "MINSTEP", 
          "BOUND", "STEPREDUCE", "FMAX"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"RESAMPLING\"\>", "\<\"FDIGITS\"\>", \
"\<\"TYP\"\>", "\<\"YMAX\"\>", "\<\"ANALGRAD\"\>", "\<\"FACTOR\"\>", \
"\<\"CSEED\"\>"},
          {"1", "True", "16", "1", "1000.`", "False", "1.`", \(-999\)}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"RESAMPLING", "FDIGITS", 
          "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}}, TableDirections -> {
          Column, Row}, TableSpacing -> {0, 2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("    SCALING"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(Transpose::"nmtx" \(\(:\)\(\ \)\) 
      "The first two levels of the one-dimensional list \!\({}\) cannot be \
transposed."\)], "Message",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[\(Transpose[{}]\),
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
          0]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("STARTWERT THETA0 = "\[InvisibleSpace]{16, 4, 1, 2, 
          0, 0, 1, 0, 1}\),
      SequenceForm[ "STARTWERT THETA0 = ", {16, 4, 1, 2, 0, 0, 1, 0, 1}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.384185791015625`*^-7, 5.960464477539063`*^-8, 
          1.4901161193847656`*^-8, 2.9802322387695312`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.384185791015625*^-07, 5.9604644775390625*^-08, 
        1.4901161193847656*^-08, 2.9802322387695312*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \({{6.0974578857421875`, 8.623878479003906`, 
        29.313507080078125`, \(-40.205963134765625`\), 5.574951171875`, 
        5.65374755859375`, 
        17.479583740234375`, \(-17.900115966796875`\), \(-10.474578857421875`\
\)}, 2887.7236043713524`}\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]1\),
      SequenceForm[ "BFGS: Iteration = ", 1],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"-21496.688211656810000\"\>",
            -21496.688211656812,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2887.723604371353000\"\>",
            2887.7236043713524,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -21496.688211656812, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2887.7236043713524, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2402.409945090742000\"\>",
            2402.409945090742,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2887.723604371353000\"\>",
            2887.7236043713524,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2402.409945090742, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2887.7236043713524, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2878.971250539083000\"\>",
            2878.9712505390835,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2887.723604371353000\"\>",
            2887.7236043713524,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2878.9712505390835, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2887.7236043713524, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749804862984000\"\>",
            2889.7498048629841,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2887.723604371353000\"\>",
            2887.7236043713524,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 2889.7498048629841, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2887.7236043713524, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749804862984000\"\>",
            2889.7498048629841,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2889.7498048629841, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2887.723604371353000\"\>",
            2887.7236043713524,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2887.7236043713524, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     2.026200491631698\"\>",
            2.0262004916316982,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 2.0262004916316982, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0060\"\>",
                16.005924045342812,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0000\"\>",
                16,
                Editable->False], 
              InterpretationBox["\<\" 0.0059\"\>",
                0.0059240453428126205,
                AutoDelete->True], 
              InterpretationBox["\<\" 6.0975\"\>",
                6.0974578857421875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0084\"\>",
                4.0083786141860829,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.0084\"\>",
                0.0083786141860833149,
                AutoDelete->True], 
              InterpretationBox["\<\" 8.6239\"\>",
                8.6238784790039062,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0285\"\>",
                1.0284798268972553,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 0.0285\"\>",
                0.028479826897255266,
                AutoDelete->True], 
              InterpretationBox["\<\" 29.3140\"\>",
                29.313507080078125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9609\"\>",
                1.9609375,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\"-0.0391\"\>",
                -0.0390625,
                AutoDelete->True], 
              InterpretationBox["\<\"-40.2060\"\>",
                -40.205963134765625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0054\"\>",
                0.0054163987919260336,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0054\"\>",
                0.0054163987919260336,
                AutoDelete->True], 
              InterpretationBox["\<\" 5.5750\"\>",
                5.574951171875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\" 0.0055\"\>",
                0.0054929541985428119,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0055\"\>",
                0.0054929541985428119,
                AutoDelete->True], 
              InterpretationBox["\<\" 5.6537\"\>",
                5.65374755859375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0170\"\>",
                1.0169824619687446,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 0.0170\"\>",
                0.016982461968744617,
                AutoDelete->True], 
              InterpretationBox["\<\" 17.4800\"\>",
                17.479583740234375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0174\"\>",
                -0.017391034200804723,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0174\"\>",
                -0.017391034200804723,
                AutoDelete->True], 
              InterpretationBox["\<\"-17.9000\"\>",
                -17.900115966796875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9898\"\>",
                0.98982331960941772,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.0102\"\>",
                -0.010176680390582246,
                AutoDelete->True], 
              InterpretationBox["\<\"-10.4750\"\>",
                -10.474578857421875,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.385068542561354`*^-7, 5.97294958559585`*^-8, 
          1.5325543685216535`*^-8, 2.922024577856064`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.5154219597112308`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3850685425613541*^-07, 5.9729495855958505*^-08, 
        1.5325543685216535*^-08, 2.9220245778560638*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5154219597112308*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]9.230213840479942`*^-7\),
      SequenceForm[ "NOISE  ", 9.2302138404799422*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.3907805595698477`\
\[InvisibleSpace]"  "\[InvisibleSpace]312.8713620945449`\),
      SequenceForm[ "*BFGSUP ", 0.3907805595698477, "  ", 312.87136209454491],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.02010488361252729`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.02010488361252729, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]2\),
      SequenceForm[ "BFGS: Iteration = ", 2],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  1689.100781439250000\"\>",
            1689.1007814392497,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749804862984000\"\>",
            2889.7498048629841,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 1689.1007814392497, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2889.7498048629841, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2815.683485107842000\"\>",
            2815.683485107842,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749804862984000\"\>",
            2889.7498048629841,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2815.683485107842, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2889.7498048629841, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.235836267919000\"\>",
            2889.2358362679192,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749804862984000\"\>",
            2889.7498048629841,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2889.2358362679192, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2889.7498048629841, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820524010507000\"\>",
            2890.8205240105062,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749804862984000\"\>",
            2889.7498048629841,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 2890.8205240105062, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2889.7498048629841, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820524010507000\"\>",
            2890.8205240105062,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2890.8205240105062, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749804862984000\"\>",
            2889.7498048629841,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2889.7498048629841, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     1.070719147522141\"\>",
            1.0707191475221407,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 1.0707191475221407, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0130\"\>",
                16.012511297922781,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0060\"\>",
                16.005924045342812,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0066\"\>",
                0.0065872525799696522,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.6298\"\>",
                3.6297862798492,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0024\"\>",
                4.0024137905182338,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0084\"\>",
                4.0083786141860829,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0060\"\>",
                -0.0059648236678488736,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.7255\"\>",
                -3.7254956327314455,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0675\"\>",
                1.0675423268972553,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0285\"\>",
                1.0284798268972553,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0391\"\>",
                0.0390625,
                AutoDelete->True], 
              InterpretationBox["\<\" 21.7370\"\>",
                21.736953396402988,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9694\"\>",
                1.9693949947378093,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9609\"\>",
                1.9609375,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0085\"\>",
                0.0084574947378093009,
                AutoDelete->True], 
              InterpretationBox["\<\" 6.1501\"\>",
                6.1500560258964141,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0106\"\>",
                0.010594798258354183,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0054\"\>",
                0.0054163987919260336,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0052\"\>",
                0.0051783994664281489,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.8292\"\>",
                2.8292236328125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\" 0.0116\"\>",
                0.011590876543777195,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0055\"\>",
                0.0054929541985428119,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0061\"\>",
                0.0060979223452343832,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.3599\"\>",
                3.35986328125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0180\"\>",
                1.0179549572914366,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0170\"\>",
                1.0169824619687446,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0010\"\>",
                0.00097249532269197024,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0217\"\>",
                0.021695761539153376,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0456\"\>",
                -0.045618064481149218,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0174\"\>",
                -0.017391034200804723,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0282\"\>",
                -0.028227030280344498,
                AutoDelete->True], 
              InterpretationBox["\<\"-15.8090\"\>",
                -15.809173583984375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9804\"\>",
                0.9803509438651935,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9898\"\>",
                0.98982331960941772,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0095\"\>",
                -0.0094723757442242533,
                AutoDelete->True], 
              InterpretationBox["\<\"-5.1667\"\>",
                -5.166656494140625,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.386050119686541`*^-7, 5.964061305699101`*^-8, 
          1.590762029435121`*^-8, 2.9346272270944853`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.5168710906676003`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3860501196865412*^-07, 5.9640613056991007*^-08, 
        1.5907620294351209*^-08, 2.9346272270944853*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5168710906676003*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.7317075263587554`*^-7\),
      SequenceForm[ "NOISE  ", 4.7317075263587554*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.2316251707700028`\
\[InvisibleSpace]"  "\[InvisibleSpace]504.40040973854434`\),
      SequenceForm[ "*BFGSUP ", 1.2316251707700028, "  ", 504.40040973854434],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.015567264164021592`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.015567264164021592, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]3\),
      SequenceForm[ "BFGS: Iteration = ", 3],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   787.573455204487500\"\>",
            787.57345520448757,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820524010507000\"\>",
            2890.8205240105062,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 787.57345520448757, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.8205240105062, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2592.201208036612000\"\>",
            2592.2012080366121,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820524010507000\"\>",
            2890.8205240105062,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2592.2012080366121, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.8205240105062, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2883.781325197700000\"\>",
            2883.7813251977,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820524010507000\"\>",
            2890.8205240105062,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2883.7813251977, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.8205240105062, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913624363905000\"\>",
            2890.913624363905,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820524010507000\"\>",
            2890.8205240105062,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 2890.913624363905, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.8205240105062, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913624363905000\"\>",
            2890.913624363905,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2890.913624363905, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820524010507000\"\>",
            2890.8205240105062,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2890.8205240105062, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.093100353398768\"\>",
            0.093100353398767766,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.093100353398767766, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0210\"\>",
                16.020921070599076,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0130\"\>",
                16.012511297922781,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0084\"\>",
                0.0084097726762931337,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.8104\"\>",
                2.8104377827283575,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0249\"\>",
                4.0248681462096023,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0024\"\>",
                4.0024137905182338,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0225\"\>",
                0.022454355691368486,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.7433\"\>",
                3.7433465551446821,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0741\"\>",
                1.0741460545948123,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0675\"\>",
                1.0675423268972553,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0066\"\>",
                0.0066037276975570965,
                AutoDelete->True], 
              InterpretationBox["\<\" 9.5836\"\>",
                9.5836261063366166,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9696\"\>",
                1.9695740473967751,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9694\"\>",
                1.9693949947378093,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0002\"\>",
                0.00017905265896582415,
                AutoDelete->True], 
              InterpretationBox["\<\"-4.8750\"\>",
                -4.8749684806976958,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0026\"\>",
                0.0026155335534231074,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0106\"\>",
                0.010594798258354183,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0080\"\>",
                -0.0079792647049310751,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.2706\"\>",
                0.2706298828125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\" 0.0013\"\>",
                0.0013249747060127444,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0116\"\>",
                0.011590876543777195,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0103\"\>",
                -0.010265901837764451,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0638\"\>",
                0.063751220703125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 0.9912\"\>",
                0.991198381919289,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0180\"\>",
                1.0179549572914366,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0268\"\>",
                -0.026756575372147619,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.1111\"\>",
                -1.1111228349989293,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0758\"\>",
                -0.075763637996883737,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0456\"\>",
                -0.045618064481149218,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0301\"\>",
                -0.030145573515734523,
                AutoDelete->True], 
              InterpretationBox["\<\"-10.0170\"\>",
                -10.016998291015625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9591\"\>",
                0.95906523444310821,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9804\"\>",
                0.9803509438651935,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0213\"\>",
                -0.021285709422085349,
                AutoDelete->True], 
              InterpretationBox["\<\"-5.5828\"\>",
                -5.58282470703125,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.387303273469072`*^-7, 5.997520903065208`*^-8, 
          1.6006023505252783`*^-8, 2.934894036347829`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.387303273469072*^-07, 5.9975209030652081*^-08, 
        1.6006023505252783*^-08, 2.934894036347829*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]5.428209988167509`*^-7\),
      SequenceForm[ "NOISE  ", 5.4282099881675094*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.9346271099030597`\
\[InvisibleSpace]"  "\[InvisibleSpace]414.3582565297732`\),
      SequenceForm[ "*BFGSUP ", 0.93462710990305975, "  ", 414.3582565297732],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.009939896452769614`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0099398964527696136, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]4\),
      SequenceForm[ "BFGS: Iteration = ", 4],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2400.731760815368000\"\>",
            2400.7317608153685,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913624363905000\"\>",
            2890.913624363905,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2400.7317608153685, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.913624363905, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2834.372898789663000\"\>",
            2834.3728987896634,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913624363905000\"\>",
            2890.913624363905,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2834.3728987896634, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.913624363905, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2888.114573287109000\"\>",
            2888.1145732871091,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913624363905000\"\>",
            2890.913624363905,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2888.1145732871091, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.913624363905, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144611839802000\"\>",
            2891.1446118398017,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913624363905000\"\>",
            2890.913624363905,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 2891.1446118398017, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.913624363905, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144611839802000\"\>",
            2891.1446118398017,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.1446118398017, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913624363905000\"\>",
            2890.913624363905,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2890.913624363905, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.230987475896654\"\>",
            0.23098747589665436,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.23098747589665436, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0320\"\>",
                16.032007387961794,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0210\"\>",
                16.020921070599076,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011086317362719268,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.7936\"\>",
                1.7936161069298378,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0603\"\>",
                4.0603235302668823,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0249\"\>",
                4.0248681462096023,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0355\"\>",
                0.035455384057280402,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.6407\"\>",
                -0.64067024995052202,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0686\"\>",
                1.0685992738347576,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0741\"\>",
                1.0741460545948123,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0055\"\>",
                -0.0055467807600545612,
                AutoDelete->True], 
              InterpretationBox["\<\" 8.5411\"\>",
                8.5410609521708469,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9864\"\>",
                1.9863956120405604,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9696\"\>",
                1.9695740473967751,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0168\"\>",
                0.016821564643785349,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.1593\"\>",
                4.1593143692903451,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\"-0.0052\"\>",
                -0.0051886036918331801,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0026\"\>",
                0.0026155335534231074,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0078\"\>",
                -0.0078041372452562876,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.4732\"\>",
                4.473236083984375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0170\"\>",
                -0.017002396372501762,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0013\"\>",
                0.0013249747060127444,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0183\"\>",
                -0.018327371078514506,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.7007\"\>",
                1.70074462890625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0021\"\>",
                1.0020584546136868,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9912\"\>",
                0.991198381919289,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0109\"\>",
                0.010860072694397874,
                AutoDelete->True], 
              InterpretationBox["\<\" 26.4110\"\>",
                26.411102294921875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.1142\"\>",
                -0.11424757102072987,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0758\"\>",
                -0.075763637996883737,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0385\"\>",
                -0.038483933023846131,
                AutoDelete->True], 
              InterpretationBox["\<\"-6.6758\"\>",
                -6.67578125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9297\"\>",
                0.92972770093917811,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9591\"\>",
                0.95906523444310821,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0293\"\>",
                -0.029337533503930101,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.2837\"\>",
                -2.28369140625,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.388955263489752`*^-7, 6.050353542367939`*^-8, 
          1.5923370031040275`*^-8, 2.9599601209768062`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4931834557856423`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3889552634897522*^-07, 6.0503535423679386*^-08, 
        1.5923370031040275*^-08, 2.9599601209768062*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4931834557856423*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]6.177103140725765`*^-7\),
      SequenceForm[ "NOISE  ", 6.177103140725765*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]1.5131253504750268`\
\[InvisibleSpace]"  "\[InvisibleSpace]453.56702634559144`\),
      SequenceForm[ "*BFGSUP ", 1.5131253504750268, "  ", 453.56702634559144],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00898014250780708`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0089801425078070794, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]5\),
      SequenceForm[ "BFGS: Iteration = ", 5],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2672.636606812258000\"\>",
            2672.6366068122575,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144611839802000\"\>",
            2891.1446118398017,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2672.6366068122575, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1446118398017, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2879.228606201821000\"\>",
            2879.2286062018206,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144611839802000\"\>",
            2891.1446118398017,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2879.2286062018206, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1446118398017, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.612435594978000\"\>",
            2890.6124355949778,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144611839802000\"\>",
            2891.1446118398017,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2890.6124355949778, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1446118398017, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161908462257000\"\>",
            2891.1619084622571,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144611839802000\"\>",
            2891.1446118398017,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 2891.1619084622571, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1446118398017, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161908462257000\"\>",
            2891.1619084622571,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.1619084622571, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144611839802000\"\>",
            2891.1446118398017,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.1446118398017, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.017296622455433\"\>",
            0.017296622455432953,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.017296622455432953, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0360\"\>",
                16.036081237257584,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0320\"\>",
                16.032007387961794,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0041\"\>",
                0.0040738492957897781,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.6194\"\>",
                1.6194410342210275,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0691\"\>",
                4.0690890398697181,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0603\"\>",
                4.0603235302668823,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0088\"\>",
                0.0087655096028355275,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.7222\"\>",
                -3.7221714235787431,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0664\"\>",
                1.0663798849418091,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0686\"\>",
                1.0685992738347576,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0022\"\>",
                -0.0022193888929483707,
                AutoDelete->True], 
              InterpretationBox["\<\" 11.6330\"\>",
                11.632785495168443,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9896\"\>",
                1.9896296172939518,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9864\"\>",
                1.9863956120405604,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0032\"\>",
                0.0032340052533914349,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.5972\"\>",
                -0.59715584194333393,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0078\"\>",
                0.0077746304148790845,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0052\"\>",
                -0.0051886036918331801,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0130\"\>",
                0.012963234106712265,
                AutoDelete->True], 
              InterpretationBox["\<\" 8.7779\"\>",
                8.777862548828125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0150\"\>",
                -0.01503738675626304,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0170\"\>",
                -0.017002396372501762,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0020\"\>",
                0.0019650096162387221,
                AutoDelete->True], 
              InterpretationBox["\<\" 5.6328\"\>",
                5.63275146484375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0013\"\>",
                1.001262046399118,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0021\"\>",
                1.0020584546136868,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0008\"\>",
                -0.00079640821456876561,
                AutoDelete->True], 
              InterpretationBox["\<\" 15.0430\"\>",
                15.042735163571951,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.1176\"\>",
                -0.11758626674616371,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1142\"\>",
                -0.11424757102072987,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0033\"\>",
                -0.0033386957254338424,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.0903\"\>",
                -3.09033203125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9262\"\>",
                0.92620114306293599,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9297\"\>",
                0.92972770093917811,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0035\"\>",
                -0.0035265578762421106,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.6285\"\>",
                0.62847900390625,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.389562314340112`*^-7, 6.063415169521746`*^-8, 
          1.5890298559394615`*^-8, 2.96477916433506`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4919967150675028`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3895623143401122*^-07, 6.0634151695217463*^-08, 
        1.5890298559394615*^-08, 2.9647791643350599*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4919967150675028*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.582987147827425`*^-7\),
      SequenceForm[ "NOISE  ", 4.5829871478274253*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]10.014032518871684`\
\[InvisibleSpace]"  "\[InvisibleSpace]3809.4784479796613`\),
      SequenceForm[ "*BFGSUP ", 10.014032518871684, "  ", 3809.4784479796613],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.010114633119160457`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.010114633119160457, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]6\),
      SequenceForm[ "BFGS: Iteration = ", 6],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2886.605026271505000\"\>",
            2886.6050262715048,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161908462257000\"\>",
            2891.1619084622571,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2886.6050262715048, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1619084622571, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.002188072789000\"\>",
            2891.0021880727891,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161908462257000\"\>",
            2891.1619084622571,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2891.0021880727891, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1619084622571, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187316237341000\"\>",
            2891.1873162373413,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161908462257000\"\>",
            2891.1619084622571,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2891.1873162373413, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1619084622571, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187316237341000\"\>",
            2891.1873162373413,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.1873162373413, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161908462257000\"\>",
            2891.1619084622571,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.1619084622571, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.025407775084204\"\>",
            0.025407775084204332,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.025407775084204332, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0520\"\>",
                16.052102665354685,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0360\"\>",
                16.036081237257584,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0160\"\>",
                0.016021428097100058,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.8236\"\>",
                1.8235778155229967,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0780\"\>",
                4.0780443386512957,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0691\"\>",
                4.0690890398697181,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0090\"\>",
                0.0089552987815778255,
                AutoDelete->True], 
              InterpretationBox["\<\"-5.0923\"\>",
                -5.0923416035431455,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0657\"\>",
                1.0657018286195981,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0664\"\>",
                1.0663798849418091,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0007\"\>",
                -0.00067805632221115491,
                AutoDelete->True], 
              InterpretationBox["\<\" 12.1920\"\>",
                12.1916933600163,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9929\"\>",
                1.9929059786132997,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9896\"\>",
                1.9896296172939518,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0033\"\>",
                0.0032763613193479237,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.9957\"\>",
                -0.99573313520194362,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0053\"\>",
                0.0052794208148129523,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0078\"\>",
                0.0077746304148790845,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0025\"\>",
                -0.0024952096000661322,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.2960\"\>",
                2.29595947265625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0007\"\>",
                -0.00067681064844467634,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0150\"\>",
                -0.01503738675626304,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0144\"\>",
                0.014360576107818364,
                AutoDelete->True], 
              InterpretationBox["\<\" 5.2163\"\>",
                5.21630859375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0017\"\>",
                1.001666087153942,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0013\"\>",
                1.001262046399118,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0004\"\>",
                0.00040404075482397919,
                AutoDelete->True], 
              InterpretationBox["\<\" 15.7130\"\>",
                15.713170958157907,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.1169\"\>",
                -0.11690339520674732,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1176\"\>",
                -0.11758626674616371,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0007\"\>",
                0.00068287153941639311,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.2879\"\>",
                -3.287872314453125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9283\"\>",
                0.92833169523779657,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9262\"\>",
                0.92620114306293599,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0021\"\>",
                0.0021305521748605691,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0347\"\>",
                1.03472900390625,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.3919496931664176`*^-7, 6.076759604590082`*^-8, 
          1.588019473283884`*^-8, 2.9696613231499488`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4925987827091545`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3919496931664176*^-07, 6.0767596045900817*^-08, 
        1.588019473283884*^-08, 2.9696613231499488*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4925987827091545*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.6189042156282603`*^-7\),
      SequenceForm[ "NOISE  ", 4.6189042156282603*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]22.608213782530072`\
\[InvisibleSpace]"  "\[InvisibleSpace]1345.3220699519957`\),
      SequenceForm[ "*BFGSUP ", 22.608213782530072, "  ", 1345.3220699519957],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.010982608052159408`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.010982608052159408, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]7\),
      SequenceForm[ "BFGS: Iteration = ", 7],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2885.270665669194000\"\>",
            2885.2706656691944,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187316237341000\"\>",
            2891.1873162373413,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2885.2706656691944, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1873162373413, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.070750076734000\"\>",
            2891.0707500767335,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187316237341000\"\>",
            2891.1873162373413,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2891.0707500767335, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1873162373413, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247753332570000\"\>",
            2891.24775333257,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187316237341000\"\>",
            2891.1873162373413,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2891.24775333257, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1873162373413, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247753332570000\"\>",
            2891.24775333257,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.24775333257, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187316237341000\"\>",
            2891.1873162373413,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.1873162373413, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.060437095228735\"\>",
            0.060437095228735416,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.060437095228735416, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0990\"\>",
                16.098575067571577,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0520\"\>",
                16.052102665354685,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0465\"\>",
                0.04647240221689293,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9781\"\>",
                1.9781070281927311,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0790\"\>",
                4.0789761769431863,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0780\"\>",
                4.0780443386512957,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0009\"\>",
                0.00093183829189035503,
                AutoDelete->True], 
              InterpretationBox["\<\"-6.0907\"\>",
                -6.0906826085866639,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0639\"\>",
                1.063875909209562,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0657\"\>",
                1.0657018286195981,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0018\"\>",
                -0.0018259194100359608,
                AutoDelete->True], 
              InterpretationBox["\<\" 11.8980\"\>",
                11.898370074599837,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9942\"\>",
                1.9942415571734267,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9929\"\>",
                1.9929059786132997,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0013\"\>",
                0.0013355785601269715,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.3664\"\>",
                -1.3664495945268358,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0064\"\>",
                0.0064208414010879424,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0053\"\>",
                0.0052794208148129523,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0011\"\>",
                0.0011414205862749899,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.2600\"\>",
                3.260040283203125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\" 0.0018\"\>",
                0.0018259839770758683,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0007\"\>",
                -0.00067681064844467634,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0025\"\>",
                0.0025027946255205447,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.8672\"\>",
                2.8671875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0026\"\>",
                1.0025761288252086,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0017\"\>",
                1.001666087153942,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0009\"\>",
                0.00091004167126657216,
                AutoDelete->True], 
              InterpretationBox["\<\" 15.2840\"\>",
                15.283770525404451,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.1161\"\>",
                -0.11605361778868467,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1169\"\>",
                -0.11690339520674732,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0008\"\>",
                0.00084977741806264626,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.4692\"\>",
                -3.46917724609375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9353\"\>",
                0.93525829978250563,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9283\"\>",
                0.92833169523779657,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0069\"\>",
                0.0069266045447090793,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.8875\"\>",
                0.887481689453125,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.39887462073141`*^-7, 6.078148151849488`*^-8, 
          1.5852986413382917`*^-8, 2.9716514902910987`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4939548504728208`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.3988746207314099*^-07, 6.0781481518494878*^-08, 
        1.5852986413382917*^-08, 2.9716514902910987*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4939548504728208*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]4.45492362890571`*^-7\),
      SequenceForm[ "NOISE  ", 4.4549236289057102*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]16.546494012164285`\
\[InvisibleSpace]"  "\[InvisibleSpace]705.5722018374186`\),
      SequenceForm[ "*BFGSUP ", 16.546494012164285, "  ", 705.57220183741856],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.005206986320230549`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0052069863202305489, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]8\),
      SequenceForm[ "BFGS: Iteration = ", 8],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2879.218369906707000\"\>",
            2879.2183699067073,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247753332570000\"\>",
            2891.24775333257,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2879.2183699067073, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.24775333257, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.209264175874000\"\>",
            2891.2092641758741,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247753332570000\"\>",
            2891.24775333257,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2891.2092641758741, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.24775333257, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480879194477000\"\>",
            2891.480879194477,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247753332570000\"\>",
            2891.24775333257,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2891.480879194477, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.24775333257, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480879194477000\"\>",
            2891.480879194477,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.480879194477, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247753332570000\"\>",
            2891.24775333257,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.24775333257, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.233125861906956\"\>",
            0.23312586190695583,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.23312586190695583, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.2550\"\>",
                16.254825067571577,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0990\"\>",
                16.098575067571577,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.1563\"\>",
                0.15625,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.7536\"\>",
                0.75358550561837234,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.1057\"\>",
                4.1057222323476941,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0790\"\>",
                4.0789761769431863,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0267\"\>",
                0.026746055404507779,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.6908\"\>",
                -3.6908005457590316,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0887\"\>",
                1.088713089649594,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0639\"\>",
                1.063875909209562,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0248\"\>",
                0.024837180440031928,
                AutoDelete->True], 
              InterpretationBox["\<\" 13.1490\"\>",
                13.149160147281505,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0078\"\>",
                2.0078048698534947,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9942\"\>",
                1.9942415571734267,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0136\"\>",
                0.013563312680067838,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.6709\"\>",
                -0.67089221853066328,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0070\"\>",
                0.0070053935154979121,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0064\"\>",
                0.0064208414010879424,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0006\"\>",
                0.00058455211440996925,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.6468\"\>",
                2.646820068359375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0089\"\>",
                -0.0088826313196614104,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0018\"\>",
                0.0018259839770758683,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0107\"\>",
                -0.010708615296737278,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.5438\"\>",
                2.5438232421875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0058\"\>",
                1.0058324279140622,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0026\"\>",
                1.0025761288252086,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0033\"\>",
                0.0032562990888536174,
                AutoDelete->True], 
              InterpretationBox["\<\" 14.6130\"\>",
                14.612715868857528,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0763\"\>",
                -0.076303581540724294,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1161\"\>",
                -0.11605361778868467,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0398\"\>",
                0.039750036247960377,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.0566\"\>",
                -1.05657958984375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9520\"\>",
                0.95203417350873587,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9353\"\>",
                0.93525829978250563,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0168\"\>",
                0.016775873726230198,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.2608\"\>",
                0.260772705078125,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.422157685096797`*^-7, 6.118002880137703`*^-8, 
          1.6223089242720515`*^-8, 2.991862401147924`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.4988071142346594`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4221576850967969*^-07, 6.1180028801377029*^-08, 
        1.6223089242720515*^-08, 2.9918624011479239*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.4988071142346594*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.8500424324310667`*^-7\),
      SequenceForm[ "NOISE  ", 3.8500424324310667*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]5.762309301923977`\
\[InvisibleSpace]"  "\[InvisibleSpace]279.5759682564918`\),
      SequenceForm[ "*BFGSUP ", 5.7623093019239766, "  ", 279.57596825649182],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.006392163523026533`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0063921635230265329, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]9\),
      SequenceForm[ "BFGS: Iteration = ", 9],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2879.082649445904000\"\>",
            2879.0826494459038,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480879194477000\"\>",
            2891.480879194477,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2879.0826494459038, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.480879194477, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.892108923869000\"\>",
            2890.8921089238684,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480879194477000\"\>",
            2891.480879194477,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2890.8921089238684, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.480879194477, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.555726647921000\"\>",
            2891.5557266479209,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480879194477000\"\>",
            2891.480879194477,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2891.5557266479209, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.480879194477, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.555726647921000\"\>",
            2891.5557266479209,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.5557266479209, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480879194477000\"\>",
            2891.480879194477,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.480879194477, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.074847453443908\"\>",
            0.074847453443908307,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.074847453443908307, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.3275306828833,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.2550\"\>",
                16.254825067571577,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0727\"\>",
                0.072705615311724023,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.8752\"\>",
                0.87516456889077554,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.1002\"\>",
                4.1002303835875811,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.1057\"\>",
                4.1057222323476941,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0055\"\>",
                -0.0054918487601131674,
                AutoDelete->True], 
              InterpretationBox["\<\"-4.5017\"\>",
                -4.5017216356954961,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0951\"\>",
                1.0951012706875969,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0887\"\>",
                1.088713089649594,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0064\"\>",
                0.0063881810380027994,
                AutoDelete->True], 
              InterpretationBox["\<\" 9.4712\"\>",
                9.4712114539601924,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0131\"\>",
                2.0130605789752334,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0078\"\>",
                2.0078048698534947,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0053\"\>",
                0.0052557091217385332,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.9392\"\>",
                -0.93922110330160014,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0071\"\>",
                0.0071281360435657068,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0070\"\>",
                0.0070053935154979121,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0001\"\>",
                0.0001227425280677951,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.2832\"\>",
                2.283203125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0039\"\>",
                -0.0038660239614011528,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0089\"\>",
                -0.0088826313196614104,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0050\"\>",
                0.0050166073582602576,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.0974\"\>",
                3.097412109375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0077\"\>",
                1.0077411008705812,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0058\"\>",
                1.0058324279140622,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0019\"\>",
                0.0019086729565190796,
                AutoDelete->True], 
              InterpretationBox["\<\" 11.2240\"\>",
                11.224481530367036,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0463\"\>",
                -0.046333979096894351,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0763\"\>",
                -0.076303581540724294,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0300\"\>",
                0.029969602443829946,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.0020\"\>",
                -2.001953125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9191\"\>",
                0.919146954281992,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9520\"\>",
                0.95203417350873587,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0329\"\>",
                -0.032887219226743911,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.9974\"\>",
                -0.9974365234375,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.4329916660313755`*^-7, 6.109819387775035`*^-8, 
          1.6318280558103277`*^-8, 2.999694018029024`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.501651258573802`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4329916660313755*^-07, 6.1098193877750353*^-08, 
        1.6318280558103277*^-08, 2.9996940180290243*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5016512585738021*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.061294673289953`*^-7\),
      SequenceForm[ "NOISE  ", 3.061294673289953*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]6.368656119671145`\
\[InvisibleSpace]"  "\[InvisibleSpace]415.67219649543523`\),
      SequenceForm[ "*BFGSUP ", 6.3686561196711446, "  ", 415.67219649543523],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.003857151228947212`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.003857151228947212, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]10\),
      SequenceForm[ "BFGS: Iteration = ", 10],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.694829611611000\"\>",
            2891.6948296116111,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.6948296116111, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.555726647921000\"\>",
            2891.5557266479209,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.5557266479209, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.139102963690220\"\>",
            0.13910296369022035,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.13910296369022035, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.2230\"\>",
                16.222577282283858,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.3275306828833,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1050\"\>",
                -0.1049534005994411,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.4612\"\>",
                0.46121595018770933,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0745\"\>",
                4.0744713231368292,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.1002\"\>",
                4.1002303835875811,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0258\"\>",
                -0.025759060450751749,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.7201\"\>",
                -2.7201319636216836,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.1323\"\>",
                1.132289770047928,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0951\"\>",
                1.0951012706875969,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0372\"\>",
                0.037188499360331063,
                AutoDelete->True], 
              InterpretationBox["\<\" 8.6271\"\>",
                8.6271206633239217,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9968\"\>",
                1.9967892408694774,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0131\"\>",
                2.0130605789752334,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0163\"\>",
                -0.016271338105756025,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.5564\"\>",
                -0.55637949819462662,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0132\"\>",
                0.013164158432283569,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0071\"\>",
                0.0071281360435657068,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0060\"\>",
                0.0060360223887178611,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0691\"\>",
                2.069122314453125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\" 0.0022\"\>",
                0.0021887708922760582,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0039\"\>",
                -0.0038660239614011528,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0061\"\>",
                0.006054794853677211,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9366\"\>",
                1.936614990234375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0219\"\>",
                1.0219047987458139,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0077\"\>",
                1.0077411008705812,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0142\"\>",
                0.014163697875232587,
                AutoDelete->True], 
              InterpretationBox["\<\" 9.3195\"\>",
                9.3195192590069524,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0894\"\>",
                -0.08944434507125798,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0463\"\>",
                -0.046333979096894351,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0431\"\>",
                -0.043110365974363622,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.4836\"\>",
                -2.483612060546875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9403\"\>",
                0.94025312245981629,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9191\"\>",
                0.919146954281992,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0211\"\>",
                0.021106168177824298,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.7343\"\>",
                1.7342529296875,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.417352390629628`*^-7, 6.071435396577163`*^-8, 
          1.687243238162887`*^-8, 2.9754478348336777`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.522756813087782`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.417352390629628*^-07, 6.0714353965771634*^-08, 
        1.687243238162887*^-08, 2.9754478348336777*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5227568130877821*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]2.0796432151287495`*^-7\),
      SequenceForm[ "NOISE  ", 2.0796432151287495*^-07],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]0.9737820200753826`\
\[InvisibleSpace]"  "\[InvisibleSpace]1.5350811466936352`\),
      SequenceForm[ 
      "*BFGSUP ", 0.97378202007538261, "  ", 1.5350811466936352],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.002202193829222613`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0022021938292226132, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]11\),
      SequenceForm[ "BFGS: Iteration = ", 11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772427480516000\"\>",
            2891.7724274805164,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.7724274805164, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.694829611611000\"\>",
            2891.6948296116111,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.6948296116111, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.077597868905286\"\>",
            0.077597868905286305,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.077597868905286305, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.3360\"\>",
                16.336227538005211,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.2230\"\>",
                16.222577282283858,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.1137\"\>",
                0.11365025572135418,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0765\"\>",
                -0.076509447193531158,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0966\"\>",
                4.0966255735060946,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0745\"\>",
                4.0744713231368292,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0222\"\>",
                0.022154250369265226,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.5629\"\>",
                1.5629199483144263,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.1251\"\>",
                1.1251337704251629,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.1323\"\>",
                1.132289770047928,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0072\"\>",
                -0.0071559996227651117,
                AutoDelete->True], 
              InterpretationBox["\<\"-4.6367\"\>",
                -4.6367301102528469,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0100\"\>",
                2.0100192507924377,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9968\"\>",
                1.9967892408694774,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0132\"\>",
                0.013230009922960504,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.5463\"\>",
                1.5462597997053447,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0110\"\>",
                0.011039818128155153,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0132\"\>",
                0.013164158432283569,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0021\"\>",
                -0.0021243403041284153,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.0955\"\>",
                -1.095489501953125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0032\"\>",
                -0.0032196073335307189,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0022\"\>",
                0.0021887708922760582,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0054\"\>",
                -0.0054083782258067771,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.4970\"\>",
                -1.497039794921875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0175\"\>",
                1.0174804931282753,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0219\"\>",
                1.0219047987458139,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0044\"\>",
                -0.0044243056175385992,
                AutoDelete->True], 
              InterpretationBox["\<\"-4.2943\"\>",
                -4.2943009022020471,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0566\"\>",
                -0.056581912396028562,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0894\"\>",
                -0.08944434507125798,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0329\"\>",
                0.032862432675229418,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.5251\"\>",
                1.525146484375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9393\"\>",
                0.93934568188630974,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9403\"\>",
                0.94025312245981629,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0009\"\>",
                -0.00090744057350651346,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1621\"\>",
                -0.162078857421875,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.434287598431887`*^-7, 6.104447802165292`*^-8, 
          1.6765799677746936`*^-8, 2.995162085879501`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.5161640839700032`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4342875984318869*^-07, 6.1044478021652916*^-08, 
        1.6765799677746936*^-08, 2.9951620858795013*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5161640839700032*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]7.20956171133538`*^-8\),
      SequenceForm[ "NOISE  ", 7.20956171133538*^-08],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]6.157798452655083`\
\[InvisibleSpace]"  "\[InvisibleSpace]6.2791342746163785`\),
      SequenceForm[ "*BFGSUP ", 6.1577984526550829, "  ", 6.2791342746163785],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0002223357307883564`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.00022233573078835639, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]12\),
      SequenceForm[ "BFGS: Iteration = ", 12],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592268802000\"\>",
            2891.7725922688014,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.7725922688014, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772427480516000\"\>",
            2891.7724274805164,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.7724274805164, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000164788285019\"\>",
            0.00016478828501931275,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.00016478828501931275, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.328041642055425,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.3360\"\>",
                16.336227538005211,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0082\"\>",
                -0.0081858959497872179,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0394\"\>",
                -0.039356965030128907,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952201266550361,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0966\"\>",
                4.0966255735060946,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0014\"\>",
                -0.0014054468510585464,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0314\"\>",
                0.031444098308300854,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.1246922745766621,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.1251\"\>",
                1.1251337704251629,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0004\"\>",
                -0.00044149584850085451,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0687\"\>",
                0.068676729686374269,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091840069717679,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0100\"\>",
                2.0100192507924377,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0008\"\>",
                -0.00083524382066995934,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1004\"\>",
                -0.10037302324583987,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011140294890640582,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0110\"\>",
                0.011039818128155153,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0001\"\>",
                0.00010047676248542933,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0567\"\>",
                0.05670166015625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.0027858613637945229,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0032\"\>",
                -0.0032196073335307189,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0004\"\>",
                0.0004337459697361961,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0650\"\>",
                0.064971923828125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.017268146175331,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0175\"\>",
                1.0174804931282753,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0002\"\>",
                -0.00021234695294434144,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2015\"\>",
                -0.20152485360328606,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.058033875935975796,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0566\"\>",
                -0.056581912396028562,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0015\"\>",
                -0.0014519635399472331,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0612\"\>",
                0.0611572265625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9389\"\>",
                0.93890353394594039,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9393\"\>",
                0.93934568188630974,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0004\"\>",
                -0.00044214794036938815,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0309\"\>",
                -0.03094482421875,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.4330678048812486`*^-7, 6.102353523157591`*^-8, 
          1.675922087694201`*^-8, 2.993917475598705`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.5158476623525188`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4330678048812486*^-07, 6.1023535231575908*^-08, 
        1.675922087694201*^-08, 2.9939174755987047*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5158476623525188*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.1424483386951525`*^-9\),
      SequenceForm[ "NOISE  ", 3.1424483386951525*^-09],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2970.938480100258`\
\[InvisibleSpace]"  "\[InvisibleSpace]3002.5495266021585`\),
      SequenceForm[ "*BFGSUP ", 2970.9384801002579, "  ", 3002.5495266021585],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.000011007032181393707`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 1.1007032181393707*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]13\),
      SequenceForm[ "BFGS: Iteration = ", 13],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592813858000\"\>",
            2891.7725928138575,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.7725928138575, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592268802000\"\>",
            2891.7725922688014,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.7725922688014, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     5.450560820463579"\[Times]10\^"-7"\),
            5.4505608204635791*^-07,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 5.4505608204635791*^-07, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.328236517782944,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.328041642055425,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0002\"\>",
                0.00019487572751974245,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0019\"\>",
                0.0019493969137359549,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952186634294758,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952201266550361,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0054\"\>",
                -0.0053952476006575278,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.1247372919829668,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.1246922745766621,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                4.5017406304772548*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0094\"\>",
                0.0093612845852328683,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091806416619349,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091840069717679,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0081\"\>",
                -0.0080957588176012001,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011149063027999692,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011140294890640582,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0048\"\>",
                0.004791259765625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.0027854470123875306,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.0027858613637945229,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0029\"\>",
                0.002899169921875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172690241722548,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.017268146175331,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0001\"\>",
                8.9998624963550611*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.057979850775971488,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.058033875935975796,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0001\"\>",
                5.4025160004310425*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0018\"\>",
                -0.001800537109375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9390\"\>",
                0.93896297781963811,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9389\"\>",
                0.93890353394594039,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0001\"\>",
                5.9443873697672817*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0048\"\>",
                0.00482177734375,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.433096843627534`*^-7, 6.102351342781597`*^-8, 
          1.6759891688569885`*^-8, 2.993912460896276`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.5158489706698877`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4330968436275339*^-07, 6.1023513427815971*^-08, 
        1.6759891688569885*^-08, 2.9939124608962758*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5158489706698877*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.475405077480007`*^-10\),
      SequenceForm[ "NOISE  ", 1.4754050774800069*^-10],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]961091.9922030554`\
\[InvisibleSpace]"  "\[InvisibleSpace]935373.5190582795`\),
      SequenceForm[ "*BFGSUP ", 961091.99220305542, "  ", 935373.51905827946],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]1.899583693458704`*^-7\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 1.8995836934587039*^-07, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]14\),
      SequenceForm[ "BFGS: Iteration = ", 14],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592815167000\"\>",
            2891.7725928151667,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.7725928151667, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592813858000\"\>",
            2891.7725928138575,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.7725928138575, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     1.309217623202130"\[Times]10\^"-9"\),
            1.3092176232021302*^-09,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 1.3092176232021302*^-09, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.328256404032523,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.328236517782944,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                1.9886249576862007*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                1.4952050990571364*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952200812605826,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952186634294758,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0001\"\>",
                -0.00013413603799851403,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.1247381690933493,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.1247372919829668,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0000\"\>",
                -2.7133072178300428*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091819753146543,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091806416619349,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0001\"\>",
                0.00010632346462302032,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011149770042335718,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011149063027999692,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0004\"\>",
                0.000396728515625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.0027833976806647385,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.0027854470123875306,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0004\"\>",
                0.000396728515625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172684703357293,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172690241722548,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0005\"\>",
                -0.00053999128371865564,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.057972585679956355,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.057979850775971488,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0003\"\>",
                0.000274658203125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9390\"\>",
                0.93896458262596483,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9390\"\>",
                0.93896297781963811,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0002\"\>",
                0.000152587890625,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.433099806909639`*^-7, 6.102353455514584`*^-8, 
          1.675990475853308`*^-8, 2.9939144481936906`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.5158481453891535`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.433099806909639*^-07, 6.1023534555145838*^-08, 
        1.675990475853308*^-08, 2.9939144481936906*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5158481453891535*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]1.0281636479397418`*^-11\),
      SequenceForm[ "NOISE  ", 1.0281636479397418*^-11],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]2.3031554828415093`*^8\
\[InvisibleSpace]"  "\[InvisibleSpace]2.5919910216727972`*^8\),
      SequenceForm[ "*BFGSUP ", 230315548.28415093, "  ", 259199102.16727972],
      
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]7.387269919002726`*^-8\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 7.3872699190027258*^-08, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]15\),
      SequenceForm[ "BFGS: Iteration = ", 15],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592815245000\"\>",
            2891.7725928152454,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.7725928152454, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592815167000\"\>",
            2891.7725928151667,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.7725928151667, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     7.867129170335829"\[Times]10\^"-11"\),
            7.8671291703358293*^-11,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 7.8671291703358293*^-11, {20, 15}]],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.32825054060331,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.328256404032523,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0000\"\>",
                -1.3083028682856939*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952192471092577,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952200812605826,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.1247376781743257,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.1247381690933493,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0000\"\>",
                -2.713305101897644*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091814436354491,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091819753146543,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0000\"\>",
                -1.5189056292534527*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011149856045382196,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011149770042335718,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0000\"\>",
                3.0517578125*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.0027833823974440495,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.0027833976806647385,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0000\"\>",
                -3.0517578125*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172683198477637,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172684703357293,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0001\"\>",
                -0.00014999766047466446,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.057974097426677751,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.057972585679956355,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0000\"\>",
                -3.0517578125*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9390\"\>",
                0.93896456886733837,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9390\"\>",
                0.93896458262596483,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("Score: INC: \
"\[InvisibleSpace]{2.4330989331906006`*^-7, 6.102352212532249`*^-8, 
          1.6759897443269576`*^-8, 2.993913655929937`*^-8, 
          1.4901161193847656`*^-8, 1.4901161193847656`*^-8, 
          1.51584792114461`*^-8, 1.4901161193847656`*^-8, 
          1.4901161193847656`*^-8}\),
      SequenceForm[ 
      "Score: INC: ", {2.4330989331906006*^-07, 6.1023522125322486*^-08, 
        1.6759897443269576*^-08, 2.9939136559299367*^-08, 
        1.4901161193847656*^-08, 1.4901161193847656*^-08, 
        1.5158479211446102*^-08, 1.4901161193847656*^-08, 
        1.4901161193847656*^-08}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("NOISE  "\[InvisibleSpace]3.1446340192059346`*^-12\),
      SequenceForm[ "NOISE  ", 3.1446340192059346*^-12],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("*BFGSUP "\[InvisibleSpace]8.325450420194603`*^9\
\[InvisibleSpace]"  "\[InvisibleSpace]5.918100422029173`*^9\),
      SequenceForm[ "*BFGSUP ", 8325450420.194603, "  ", 5918100422.0291729],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]2.1106485482864356`*^-8\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 2.1106485482864356*^-08, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 1"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ReturnCode = 3"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("BFGS:  ENDE DER ITERATION  "\[InvisibleSpace]15\
\[InvisibleSpace]"  "\[InvisibleSpace]300\),
      SequenceForm[ "BFGS:  ENDE DER ITERATION  ", 15, "  ", 300],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"SCORE\"\>"},
          {"1", "3.738009537410296`*^-6"},
          {"2", "0.`"},
          {"3", \(-0.000027133062861854274`\)},
          {"4", \(-0.000030378120623870528`\)},
          {"5", \(-0.00006103515625`\)},
          {"6", "0.`"},
          {"7", "0.`"},
          {"8", \(-0.000030517578125`\)},
          {"9", \(-0.000030517578125`\)}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"Likelihood\"\>", "\<\"THETA\"\>", "\<\"\"\>", "\<\
\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
          {"1", "2887.7236043713524`", "16", "4", "1", "2", "0", "0", "1", 
            "0", "1"},
          {"2", "2889.749804862984`", "16.005924045342812`", 
            "4.008378614186083`", "1.0284798268972553`", "1.9609375`", 
            "0.005416398791926034`", "0.005492954198542812`", 
            "1.0169824619687446`", \(-0.017391034200804723`\), 
            "0.9898233196094177`"},
          {"3", "2890.8205240105062`", "16.01251129792278`", 
            "4.002413790518234`", "1.0675423268972553`", 
            "1.9693949947378093`", "0.010594798258354183`", 
            "0.011590876543777195`", 
            "1.0179549572914366`", \(-0.04561806448114922`\), 
            "0.9803509438651935`"},
          {"4", "2890.913624363905`", "16.020921070599076`", 
            "4.024868146209602`", "1.0741460545948123`", "1.969574047396775`",
             "0.0026155335534231074`", "0.0013249747060127444`", 
            "0.991198381919289`", \(-0.07576363799688374`\), 
            "0.9590652344431082`"},
          {"5", "2891.1446118398017`", "16.032007387961794`", 
            "4.060323530266882`", "1.0685992738347576`", 
            "1.9863956120405604`", \(-0.00518860369183318`\), \
\(-0.01700239637250176`\), "1.0020584546136868`", \(-0.11424757102072987`\), 
            "0.9297277009391781`"},
          {"6", "2891.161908462257`", "16.036081237257584`", 
            "4.069089039869718`", "1.0663798849418091`", 
            "1.9896296172939518`", 
            "0.0077746304148790845`", \(-0.01503738675626304`\), 
            "1.001262046399118`", \(-0.11758626674616371`\), 
            "0.926201143062936`"},
          {"7", "2891.1873162373413`", "16.052102665354685`", 
            "4.078044338651296`", "1.065701828619598`", "1.9929059786132997`",
             "0.005279420814812952`", \(-0.0006768106484446763`\), 
            "1.001666087153942`", \(-0.11690339520674732`\), 
            "0.9283316952377966`"},
          {"8", "2891.24775333257`", "16.098575067571577`", 
            "4.078976176943186`", "1.063875909209562`", "1.9942415571734267`",
             "0.006420841401087942`", "0.0018259839770758683`", 
            "1.0025761288252086`", \(-0.11605361778868467`\), 
            "0.9352582997825056`"},
          {"9", "2891.480879194477`", "16.254825067571577`", 
            "4.105722232347694`", "1.088713089649594`", "2.0078048698534947`",
             "0.007005393515497912`", \(-0.00888263131966141`\), 
            "1.0058324279140622`", \(-0.0763035815407243`\), 
            "0.9520341735087359`"},
          {"10", "2891.555726647921`", "16.3275306828833`", 
            "4.100230383587581`", "1.0951012706875969`", 
            "2.0130605789752334`", 
            "0.007128136043565707`", \(-0.003866023961401153`\), 
            "1.0077411008705812`", \(-0.04633397909689435`\), 
            "0.919146954281992`"},
          {"11", "2891.694829611611`", "16.222577282283858`", 
            "4.074471323136829`", "1.132289770047928`", "1.9967892408694774`",
             "0.013164158432283569`", "0.002188770892276058`", 
            "1.0219047987458139`", \(-0.08944434507125798`\), 
            "0.9402531224598163`"},
          {"12", "2891.7724274805164`", "16.33622753800521`", 
            "4.096625573506095`", "1.125133770425163`", "2.0100192507924377`",
             "0.011039818128155153`", \(-0.003219607333530719`\), 
            "1.0174804931282753`", \(-0.05658191239602856`\), 
            "0.9393456818863097`"},
          {"13", "2891.7725922688014`", "16.328041642055425`", 
            "4.095220126655036`", "1.124692274576662`", "2.009184006971768`", 
            "0.011140294890640582`", \(-0.002785861363794523`\), 
            "1.017268146175331`", \(-0.058033875935975796`\), 
            "0.9389035339459404`"},
          {"14", "2891.7725928138575`", "16.328236517782944`", 
            "4.095218663429476`", "1.1247372919829668`", "2.009180641661935`",
             "0.011149063027999692`", \(-0.0027854470123875306`\), 
            "1.0172690241722548`", \(-0.05797985077597149`\), 
            "0.9389629778196381`"},
          {"15", "2891.7725928151667`", "16.328256404032523`", 
            "4.095220081260583`", "1.1247381690933493`", 
            "2.0091819753146543`", 
            "0.011149770042335718`", \(-0.0027833976806647385`\), 
            "1.0172684703357293`", \(-0.057972585679956355`\), 
            "0.9389645826259648`"},
          {"16", "2891.7725928152454`", "16.32825054060331`", 
            "4.095219247109258`", "1.1247376781743257`", "2.009181443635449`",
             "0.011149856045382196`", \(-0.0027833823974440495`\), 
            "1.0172683198477637`", \(-0.05797409742667775`\), 
            "0.9389645688673384`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"Likelihood", "THETA"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("INK: "\[InvisibleSpace]{0.00009887497743589033`, 
          0.00002479841362343467`, 6.810797781075271`*^-6, 
          0.000012166506718528365`, 6.055454452393343`*^-6, 
          6.055454452393343`*^-6, 6.1600219767008355`*^-6, 
          6.055454452393343`*^-6, 6.055454452393343`*^-6}\),
      SequenceForm[ 
      "INK: ", {9.8874977435890326*^-05, 2.4798413623434669*^-05, 
        6.8107977810752711*^-06, 1.2166506718528365*^-05, 
        6.0554544523933429*^-06, 6.0554544523933429*^-06, 
        6.1600219767008355*^-06, 6.0554544523933429*^-06, 
        6.0554544523933429*^-06}],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[
      RowBox[{
        TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
                {"16.32825054060331`", "3.738009537410296`*^-6"},
                {"4.095219247109258`", "0.`"},
                {"1.1247376781743257`", \(-0.000027133062861854274`\)},
                {"2.009181443635449`", \(-0.000030378120623870528`\)},
                {"0.011149856045382196`", \(-0.00006103515625`\)},
                {\(-0.0027833823974440495`\), "0.`"},
                {"1.0172683198477637`", "0.`"},
                {\(-0.05797409742667775`\), \(-0.000030517578125`\)},
                {"0.9389645688673384`", \(-0.000030517578125`\)}
                }], "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ 
            BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}]]], 
        "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
        "2891.7725928152454`"}],
      SequenceForm[ 
        MatrixForm[ {{16.32825054060331, 3.7380095374102962*^-06}, {
          4.0952192471092577, 0.0}, {
          1.1247376781743257, -2.7133062861854274*^-05}, {
          2.0091814436354491, -3.0378120623870528*^-05}, {
          0.011149856045382196, -6.103515625*^-05}, {-0.0027833823974440495, 
          0.0}, {1.0172683198477637, 
          0.0}, {-0.057974097426677751, -3.0517578125*^-05}, {
          0.93896456886733837, -3.0517578125*^-05}}, TableHeadings -> {
          Automatic, {"THETA", "SCORE"}}], "   Likelihood = ", 
        2891.7725928152454],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("WALD-TEST:"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"CHI \"\>", "\<\"U \"\>", "\<\"PROB \"\>", \
"\<\"ALPHA \"\>"},
          {"1", "3711.502648762848`", "9", "0", "0.05`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", 
          "ALPHA "}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("NULLHYPOTHESE THETA = 0 ABLEHNEN"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("BONFERRONI-KONFIDENZINTERVALLE:"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= 1-ALPHA"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("QUANTIL Z(1-ALPHA/2U) = \
"\[InvisibleSpace]2.7729212946086625`\),
      SequenceForm[ "QUANTIL Z(1-ALPHA/2U) = ", 2.7729212946086625],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"THETA\"\>", "\<\"GRENZE\"\>", "\<\"STD\"\>"},
          {"1", "16.32825054060331`", "1.5478160915278467`", 
            "0.5581896949391372`"},
          {"2", "4.095219247109258`", "0.31817918056755184`", 
            "0.11474511778829839`"},
          {"3", "1.1247376781743257`", "0.20141917603716275`", 
            "0.07263789867702995`"},
          {"4", "2.009181443635449`", "0.1733492454903949`", 
            "0.06251502551746943`"},
          {"5", "0.011149856045382196`", "0.12614950328948055`", 
            "0.0454933587674308`"},
          {"6", \(-0.0027833823974440495`\), "0.2233880661953971`", 
            "0.0805605505752097`"},
          {"7", "1.0172683198477637`", "0.08920180810251857`", 
            "0.032168892884176674`"},
          {"8", \(-0.05797409742667775`\), "0.4498163795556019`", 
            "0.16221750701333326`"},
          {"9", "0.9389645688673384`", "0.29952402350152096`", 
            "0.108017499120469`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("Korrelation der ML-Sch\[ADoubleDot]tzer"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1.`", "0.7265630392645379`", "0.5447470672293857`", 
              "0.8048490486169473`", \(-0.000024978262639002693`\), \
\(-0.10184396615647985`\), \(-1.7101035885993339`*^-6\), 
              "0.8226381637994817`", "0.06637538221501467`"},
            {"0.7265630392645389`", "0.9999999999999999`", 
              "0.4086789218608907`", 
              "0.7954182483146088`", \(-0.000012995811136570726`\), \
\(-0.056306932758930214`\), \(-5.734223305461866`*^-6\), "0.385145453820537`",
               "0.13706070908393703`"},
            {"0.5447470672293832`", "0.4086789218608886`", 
              "0.9999999999999999`", 
              "0.4441911135207977`", \(-0.00001663061880926979`\), \
\(-0.2699510625205437`\), "8.363095515327943`*^-6", "0.44231773577610767`", 
              "0.0385676034836431`"},
            {"0.8048490486169496`", "0.7954182483146099`", 
              "0.44419111352080093`", 
              "1.0000000000000002`", \(-0.000020352652992659715`\), \
\(-0.07407716591096111`\), \(-4.225208778064835`*^-6\), 
              "0.5672636289553029`", \(-0.07416990524080205`\)},
            {\(-0.00002497826263700507`\), \(-0.000012995811135467067`\), \
\(-0.000016630618807977856`\), \(-0.000020352652991202256`\), 
              "0.9999999999999998`", \(-0.03217652580150718`\), \
\(-4.201785593428483`*^-6\), \(-0.00002802444029759325`\), 
              "0.000014225685308954121`"},
            {\(-0.10184396615647516`\), \(-0.056306932758926835`\), \
\(-0.2699510625205421`\), \(-0.0740771659109571`\), \(-0.03217652580150679`\),
               "1.0000000000000002`", \(-2.738832063663703`*^-6\), \
\(-0.09174141095382109`\), \(-0.003427350610624002`\)},
            {\(-1.710103591174879`*^-6\), \(-5.734223307631755`*^-6\), 
              "8.363095513973005`*^-6", \(-4.225208780363507`*^-6\), \
\(-4.201785593377233`*^-6\), \(-2.7388320639158496`*^-6\), 
              "1.0000000000000002`", \(-0.01129988452078372`\), 
              "1.225514477762058`*^-7"},
            {"0.8226381637994828`", "0.38514545382053744`", 
              "0.4423177357761106`", 
              "0.5672636289553022`", \(-0.000028024440299454138`\), \
\(-0.09174141095382535`\), \(-0.01129988452078161`\), "0.9999999999999998`", 
              "0.014595939177872953`"},
            {"0.06637538221501452`", "0.13706070908393675`", 
              "0.03856760348364312`", \(-0.07416990524080234`\), 
              "0.00001422568530907248`", \(-0.003427350610624553`\), 
              "1.225514478933473`*^-7", "0.014595939177872587`", 
              "0.9999999999999998`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND EIGENWERTE"\)], \
"Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0.311575735536247`", "0.04653603011263531`", 
              "0.022087165601494353`", 
              "0.028085403148084217`", \(-6.342961044094633`*^-7\), \
\(-0.004579726512604825`\), \(-3.070720917706418`*^-8\), 
              "0.07448835624496548`", "0.004002054213171764`"},
            {"0.04653603011263537`", "0.013166442056250473`", 
              "0.003406275157714214`", 
              "0.0057057689215114045`", \(-6.783996407766799`*^-8\), \
\(-0.0005204973373279595`\), \(-2.1166299263802596`*^-8\), 
              "0.007168969204556101`", "0.001698796307955992`"},
            {"0.02208716560149425`", "0.003406275157714196`", 
              "0.00527626432421447`", 
              "0.0020170541185329433`", \(-5.495657808554972`*^-8\), \
\(-0.0015796858898610572`\), "1.954188456763554`*^-8", 
              "0.005211891291192805`", "0.000302607748053876`"},
            {"0.028085403148084297`", "0.005705768921511412`", 
              "0.002017054118532958`", 
              "0.0039081284154498545`", \(-5.7883321314066757`*^-8\), \
\(-0.00037307074716698164`\), \(-8.497060309848901`*^-9\), 
              "0.005752638381274612`", \(-0.0005008483587841866`\)},
            {\(-6.342961043587358`*^-7\), \(-6.783996407190674`*^-8\), \
\(-5.4956578081280466`*^-8\), \(-5.788332130992172`*^-8\), 
              "0.0020696456919421726`", \(-0.00011792600272624631`\), \
\(-6.149191301723611`*^-9\), \(-2.0681530383617235`*^-7\), 
              "6.990613917045051`*^-8"},
            {\(-0.004579726512604614`\), \(-0.0005204973373279283`\), \
\(-0.001579685889861048`\), \(-0.00037307074716696147`\), \
\(-0.00011792600272624488`\), 
              "0.00649000230898092`", \(-7.097803040594964`*^-9\), \
\(-0.0011989071869460042`\), \(-0.000029824630907331242`\)},
            {\(-3.0707209223311557`*^-8\), \(-2.1166299271812143`*^-8\), 
              "1.9541884564469483`*^-8", \(-8.497060314471618`*^-9\), \
\(-6.1491913016486065`*^-9\), \(-7.097803041248412`*^-9\), 
              "0.0010348376693936328`", \(-0.00005896683834781935`\), 
              "4.258421823613833`*^-10"},
            {"0.0744883562449656`", "0.007168969204556109`", 
              "0.0052118912911928396`", 
              "0.005752638381274606`", \(-2.0681530384990535`*^-7\), \
\(-0.0011989071869460597`\), \(-0.00005896683834780835`\), 
              "0.026314519581620822`", "0.0002557548544855753`"},
            {"0.004002054213171754`", "0.0016987963079559889`", 
              "0.0003026077480538762`", \(-0.0005008483587841886`\), 
              "6.990613917103213`*^-8", \(-0.00002982463090733604`\), 
              "4.25842182768427`*^-10", "0.00025575485448556885`", 
              "0.01166778011624052`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \({0.0008178869926436728`, 0.0010340606023836578`, 0.002065534008248914`, 
      0.003150299662600972`, 0.0032050110203270163`, 0.006907090801020218`, 
      0.010634688828625845`, 0.012790079620038199`, 
      0.34089870416447227`}\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX UND \
EIGENWERTE"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {
              "29.79977326685895`", \(-44.19099725993525`\), \
\(-18.677482724057953`\), \(-58.47869415853404`\), \(-0.04310254405546122`\), \
\(-0.7585667995663768`\), \(-3.181361734108909`\), \(-55.828617657598315`\), \
\(-4.591275397625781`\)},
            {\(-44.19099725993525`\), 
              "307.227963507777`", \(-6.478717440397057`\), \
\(-290.34355727818723`\), \(-0.3058587506524381`\), \(-5.374483343766481`\), 
              "6.062453648014052`", 
              "106.34572486484487`", \(-44.21400221993326`\)},
            {\(-18.677482724057953`\), \(-6.478717440397057`\), 
              "288.85795766246144`", "0", "3.2306735081722433`", 
              "56.669100666386505`", \(-0.005419508910558096`\), 
              "0.005513094723843419`", "0.0027565473619217094`"},
            {\(-58.47869415853404`\), \(-290.34355727818723`\), "0", 
              "1114.1378603693179`", "0", "0", "0.0015169177199538604`", 
              "0.001543112340324764`", "110.1566175264236`"},
            {\(-0.04310254405546122`\), \(-0.3058587506524381`\), 
              "3.2306735081722433`", "0", "483.71706508979344`", 
              "9.52130591912956`", "0.003047762934453091`", 
              "0.003100392679625386`", \(-0.003100392679625386`\)},
            {\(-0.7585667995663768`\), \(-5.374483343766481`\), 
              "56.669100666386505`", "0", "9.52130591912956`", 
              "167.08326189769167`", "0", "0", "0"},
            {\(-3.181361734108909`\), 
              "6.062453648014052`", \(-0.005419508910558096`\), 
              "0.0015169177199538604`", "0.003047762934453091`", "0", 
              "966.8777008153518`", "9.521211407231457`", "0"},
            {\(-55.828617657598315`\), "106.34572486484487`", 
              "0.005513094723843419`", "0.001543112340324764`", 
              "0.003100392679625386`", "0", "9.521211407231457`", 
              "167.08326189769167`", "0.003100392679625386`"},
            {\(-4.591275397625781`\), \(-44.21400221993326`\), 
              "0.0027565473619217094`", 
              "110.1566175264236`", \(-0.003100392679625386`\), "0", "0", 
              "0.003100392679625386`", "98.44676875614488`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \({1222.6627993773072`, 967.0613092645216`, 484.136303738598`, 
      317.4301200205104`, 312.0114076543697`, 144.77875400918344`, 
      94.0319003324533`, 78.18559615792395`, 2.933422708223418`}\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("KOMPENSIERTE LIKELIHOOD"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    InterpretationBox[\("U =  "\[InvisibleSpace]9\[InvisibleSpace]"  Nue = "\
\[InvisibleSpace]3000\),
      SequenceForm[ "U =  ", 9, "  Nue = ", 3000],
      Editable->False]], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    \("AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) AZENCOTT/DACUNHA-CASTELLE \
(A/D)"\)], "Print",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"LIK\"\>", "\<\"AIC\"\>", "\<\"SIC/RISS\"\>", \
"\<\"A/D\"\>"},
          {"\<\"Kompensator\"\>", "0", "9", "36.028654054426106`", 
            "93.7042833694571`"},
          {"\<\"komp. Lik.\"\>", "2891.7725928152454`", "2882.7725928152454`",
             "2855.743938760819`", "2798.068309445788`"}
          },
        RowSpacings->1,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {{"Kompensator", "komp. Lik."}, {"LIK", 
          "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {1, 2}]]]], "Print",
  PageWidth->Infinity]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ETA // Dimensions\)], "Input",
  PageWidth->Infinity],

Cell[BoxData[
    \({500, 12}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[TextData[StyleBox["Math 5.2/OS X /Intel",
  FontColor->RGBColor[0, 0, 1]]], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{
      RowBox[{\({THETA, COV, LIKI, psii, scoreii, k, ReturnCode}\), "=", "\n",
         "    ", 
        RowBox[{"BFGS", "[", 
          
          RowBox[{\({{S, m, n, Deterministisch}}\), ",", \({THETA0, F0}\), 
            ",", "\n", 
            "                   ", \({{SystemEDMdet, {Deltat, T}}, {Lik, 
                LISRELlik, Score, Hesse}}\), ",", "\n", "                   ",
             
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{
                    RowBox[{"Sing", "=", 
                      StyleBox["False",
                        FontColor->RGBColor[1, 0, 0]]}], ",", "1"}], "}"}], 
                ",", \(KMAX = 300\), ",", \({EPS1 =  .0001, EPS2 =  .0001}\), 
                ",", "\n", "                       ", \(OPTION = 0\), 
                ",", \(PRINT = {1, 1, 1, 1, 1, 1, 1, 1, 1}\)}], "}"}]}], 
          "]"}]}], ";"}]], "Input",
  PageWidth->Infinity,
  AutoIndent->False,
  TextAlignment->Left,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \("***********************LSDE1**********************************"\)], \
"Print"],

Cell[BoxData[
    \("***********************MODUL:    BFGS (skeleton)**************"\)], \
"Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    \("Technical Output"\)], "Print"],

Cell[BoxData[
    \(LISRELlik\)], "Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"KMAX\"\>", "\<\"EPS1\"\>", "\<\"EPS2\"\>", "\<\"K\
\"\>", "\<\"Q\"\>", "\<\"n\"\>", "\<\"T\"\>", "\<\"OPTION    \"\>"},
          {"1", "300", "0.0001`", "0.0001`", "K$39898", "Q$39898", "500", "5",
             "0"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"KMAX", "EPS1", "EPS2", "K",
           "Q", "n", "T", "OPTION    "}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"MAXSTEP\"\>", "\<\"MINSTEP\"\>", "\<\"BOUND\"\>", \
"\<\"STEPREDUCE\"\>", "\<\"FMAX\"\>"},
          {"1", "10", "1.`*^-10", "1.`*^-6", "4", "1000"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"MAXSTEP", "MINSTEP", 
          "BOUND", "STEPREDUCE", "FMAX"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"RESAMPLING\"\>", "\<\"FDIGITS\"\>", \
"\<\"TYP\"\>", "\<\"YMAX\"\>", "\<\"ANALGRAD\"\>", "\<\"FACTOR\"\>", \
"\<\"CSEED\"\>"},
          {"1", "True", "16", "1", "1000.`", "False", "1.`", \(-999\)}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"RESAMPLING", "FDIGITS", 
          "TYP", "YMAX", "ANALGRAD", "FACTOR", "CSEED"}}, TableDirections -> {
          Column, Row}, TableSpacing -> {0, 2}]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \("    SCALING"\)], "Print"],

Cell[BoxData[
    RowBox[{\(Transpose::"nmtx"\), \(\(:\)\(\ \)\), "\<\"The first two levels \
of the one-dimensional list \\!\\({}\\) cannot be transposed. \
\\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Transpose::nmtx\\\"]\\)\"\>"}]], \
"Message"],

Cell[BoxData[
    TagBox[\(Transpose[{}]\),
      Function[ BoxForm`e$, 
        MatrixForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCALING"}}, TableDepth -> 
          0]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \("**************************************************************"\)], \
"Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("STARTWERT THETA0 = "\[InvisibleSpace]{16, 4, 1, 2, 
          0, 0, 1, 0, 1}\),
      SequenceForm[ "STARTWERT THETA0 = ", {16, 4, 1, 2, 0, 0, 1, 0, 1}],
      Editable->False]], "Print"],

Cell[BoxData[
    \({{6.0974578857421875`, 8.623878479003906`, 
        29.313507080078125`, \(-40.205963134765625`\), 5.574920654296875`, 
        5.65374755859375`, 
        17.479644775390625`, \(-17.899993896484375`\), \(-10.474609375`\)}, 
      2887.7236043713524`}\)], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]1\),
      SequenceForm[ "BFGS: Iteration = ", 1],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"-21496.703887168570000\"\>",
            -21496.703887168569,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2887.723604371353000\"\>",
            2887.7236043713524,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ -21496.703887168569, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2887.7236043713524, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2402.409773846528000\"\>",
            2402.409773846528,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2887.723604371353000\"\>",
            2887.7236043713524,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2402.409773846528, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2887.7236043713524, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2878.971234419284000\"\>",
            2878.971234419284,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2887.723604371353000\"\>",
            2887.7236043713524,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2878.971234419284, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2887.7236043713524, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749803058627000\"\>",
            2889.7498030586271,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2887.723604371353000\"\>",
            2887.7236043713524,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 2889.7498030586271, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2887.7236043713524, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749803058627000\"\>",
            2889.7498030586271,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2889.7498030586271, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2887.723604371353000\"\>",
            2887.7236043713524,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2887.7236043713524, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     2.026198687274700\"\>",
            2.0261986872747002,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 2.0261986872747002, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0060\"\>",
                16.005924045342812,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0000\"\>",
                16,
                Editable->False], 
              InterpretationBox["\<\" 0.0059\"\>",
                0.0059240453428126205,
                AutoDelete->True], 
              InterpretationBox["\<\" 6.0975\"\>",
                6.0974578857421875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0084\"\>",
                4.0083786141860829,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 0.0084\"\>",
                0.0083786141860833149,
                AutoDelete->True], 
              InterpretationBox["\<\" 8.6239\"\>",
                8.6238784790039062,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0285\"\>",
                1.0284798268972553,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 0.0285\"\>",
                0.028479826897255266,
                AutoDelete->True], 
              InterpretationBox["\<\" 29.3140\"\>",
                29.313507080078125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9609\"\>",
                1.9609375,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\"-0.0391\"\>",
                -0.0390625,
                AutoDelete->True], 
              InterpretationBox["\<\"-40.2060\"\>",
                -40.205963134765625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0054\"\>",
                0.0054163691422720386,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0054\"\>",
                0.0054163691422720386,
                AutoDelete->True], 
              InterpretationBox["\<\" 5.5749\"\>",
                5.574920654296875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\" 0.0055\"\>",
                0.0054929541985428119,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0055\"\>",
                0.0054929541985428119,
                AutoDelete->True], 
              InterpretationBox["\<\" 5.6537\"\>",
                5.65374755859375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0170\"\>",
                1.0169825212680526,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 0.0170\"\>",
                0.016982521268052608,
                AutoDelete->True], 
              InterpretationBox["\<\" 17.4800\"\>",
                17.479644775390625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0174\"\>",
                -0.017390915602188743,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0174\"\>",
                -0.017390915602188743,
                AutoDelete->True], 
              InterpretationBox["\<\"-17.9000\"\>",
                -17.899993896484375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9898\"\>",
                0.98982328995976376,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\"-0.0102\"\>",
                -0.010176710040236242,
                AutoDelete->True], 
              InterpretationBox["\<\"-10.4750\"\>",
                -10.474609375,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("F"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", "1", "0", "0", "0", "0", "0", "0", "0", "0"},
              {"2", "0", "1", "0", "0", "0", "0", "0", "0", "0"},
              {"3", "0", "0", "1", "0", "0", "0", "0", "0", "0"},
              {"4", "0", "0", "0", "1", "0", "0", "0", "0", "0"},
              {"5", "0", "0", "0", "0", "1", "0", "0", "0", "0"},
              {"6", "0", "0", "0", "0", "0", "1", "0", "0", "0"},
              {"7", "0", "0", "0", "0", "0", "0", "1", "0", "0"},
              {"8", "0", "0", "0", "0", "0", "0", "0", "1", "0"},
              {"9", "0", "0", "0", "0", "0", "0", "0", "0", "1"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.02010494698886006`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.020104946988860058, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]2\),
      SequenceForm[ "BFGS: Iteration = ", 2],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  1689.099421960314000\"\>",
            1689.0994219603135,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749803058627000\"\>",
            2889.7498030586271,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 1689.0994219603135, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2889.7498030586271, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2815.683744530564000\"\>",
            2815.6837445305637,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749803058627000\"\>",
            2889.7498030586271,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2815.6837445305637, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2889.7498030586271, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.235856226974000\"\>",
            2889.2358562269737,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749803058627000\"\>",
            2889.7498030586271,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2889.2358562269737, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2889.7498030586271, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820523057487000\"\>",
            2890.8205230574868,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749803058627000\"\>",
            2889.7498030586271,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 2890.8205230574868, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2889.7498030586271, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820523057487000\"\>",
            2890.8205230574868,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2890.8205230574868, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2889.749803058627000\"\>",
            2889.7498030586271,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2889.7498030586271, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     1.070719998859659\"\>",
            1.0707199988596585,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 1.0707199988596585, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0130\"\>",
                16.012511305691792,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0060\"\>",
                16.005924045342812,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0066\"\>",
                0.0065872603489787627,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.6298\"\>",
                3.6297977197053579,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0024\"\>",
                4.0024138662853179,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0084\"\>",
                4.0083786141860829,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0060\"\>",
                -0.0059647479007648658,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.7255\"\>",
                -3.7254956327314455,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0675\"\>",
                1.0675423268972553,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0285\"\>",
                1.0284798268972553,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0391\"\>",
                0.039062499999999993,
                AutoDelete->True], 
              InterpretationBox["\<\" 21.7370\"\>",
                21.737012741423332,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9694\"\>",
                1.9693948662502174,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9609\"\>",
                1.9609375,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0085\"\>",
                0.0084573662502174275,
                AutoDelete->True], 
              InterpretationBox["\<\" 6.1501\"\>",
                6.1501182768924298,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0106\"\>",
                0.010594761159039894,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0054\"\>",
                0.0054163691422720386,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0052\"\>",
                0.0051783920167678549,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.8292\"\>",
                2.8292236328125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\" 0.0116\"\>",
                0.011591023430867316,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0055\"\>",
                0.0054929541985428119,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0061\"\>",
                0.0060980692323245045,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.3600\"\>",
                3.359954833984375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0180\"\>",
                1.0179550424350348,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0170\"\>",
                1.0169825212680526,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0010\"\>",
                0.00097252116698216622,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0217\"\>",
                0.02166575230690955,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0456\"\>",
                -0.045617902955044073,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0174\"\>",
                -0.017390915602188743,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0282\"\>",
                -0.02822698735285533,
                AutoDelete->True], 
              InterpretationBox["\<\"-15.8090\"\>",
                -15.8092041015625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9804\"\>",
                0.98035097459244869,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9898\"\>",
                0.98982328995976376,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0095\"\>",
                -0.0094723153673150293,
                AutoDelete->True], 
              InterpretationBox["\<\"-5.1666\"\>",
                -5.1666259765625,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("F"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", "3.3686179413857067`", "11.89313841108319`", 
                "7.2533292265787`", \(-44.62939303344863`\), 
                "2.6376735881940365`", "2.2017542369448133`", 
                "16.80348793029766`", \(-1.9839433187367734`\), \
\(-5.099697745672515`\)},
              {"2", "11.89313841108319`", "60.57481394400735`", 
                "36.48870527877413`", \(-223.6071635607357`\), 
                "13.236245809211072`", "11.055202538840042`", 
                "84.20584828233397`", \(-10.044342123613884`\), \
\(-25.589090910658335`\)},
              {"3", "7.2533292265787`", "36.48870527877413`", 
                "23.178306961123845`", \(-136.90052694925896`\), 
                "8.081049467680282`", "6.742393099977748`", 
                "51.53732278768968`", \(-6.035335825928925`\), \
\(-15.624912114089804`\)},
              {
                "4", \(-44.62939303344863`\), \(-223.6071635607357`\), \
\(-136.90052694925896`\), 
                "840.2654548591129`", \(-49.6722499169731`\), \
\(-41.4850437642867`\), \(-316.04465785232065`\), "37.66222352382138`", 
                "96.03002401617842`"},
              {"5", "2.6376735881940365`", "13.236245809211072`", 
                "8.081049467680282`", \(-49.6722499169731`\), 
                "3.9368576855284507`", "2.4518504725953094`", 
                "18.70301893320701`", \(-2.213872847258789`\), \
\(-5.678033918548246`\)},
              {"6", "2.2017542369448133`", "11.05520253884004`", 
                "6.742393099977748`", \(-41.4850437642867`\), 
                "2.4518504725953094`", "3.0466456390554457`", 
                "15.619613437700107`", \(-1.844232304334082`\), \
\(-4.740424685824351`\)},
              {"7", "16.80348793029766`", "84.20584828233397`", 
                "51.53732278768969`", \(-316.04465785232065`\), 
                "18.703018933207005`", "15.619613437700108`", 
                "120.01225022358565`", \(-14.171461174230487`\), \
\(-36.158252541946425`\)},
              {
                "8", \(-1.9839433187367734`\), \(-10.044342123613884`\), \
\(-6.035335825928925`\), 
                "37.66222352382138`", \(-2.213872847258789`\), \
\(-1.844232304334082`\), \(-14.171461174230487`\), "2.6136325479546354`", 
                "4.281461412889923`"},
              {
                "9", \(-5.099697745672515`\), \(-25.589090910658335`\), \
\(-15.624912114089806`\), 
                "96.03002401617842`", \(-5.678033918548246`\), \
\(-4.740424685824352`\), \(-36.158252541946425`\), "4.281461412889923`", 
                "11.97771592740436`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.015567306396027153`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.015567306396027153, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]3\),
      SequenceForm[ "BFGS: Iteration = ", 3],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"   787.592986889642100\"\>",
            787.59298688964213,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820523057487000\"\>",
            2890.8205230574868,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 787.59298688964213, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.8205230574868, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2592.203688623503000\"\>",
            2592.2036886235032,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820523057487000\"\>",
            2890.8205230574868,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2592.2036886235032, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.8205230574868, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2883.781363734600000\"\>",
            2883.7813637345998,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820523057487000\"\>",
            2890.8205230574868,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2883.7813637345998, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.8205230574868, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913622028648000\"\>",
            2890.9136220286482,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820523057487000\"\>",
            2890.8205230574868,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 2890.9136220286482, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.8205230574868, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913622028648000\"\>",
            2890.9136220286482,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2890.9136220286482, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.820523057487000\"\>",
            2890.8205230574868,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2890.8205230574868, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.093098971161453\"\>",
            0.093098971161452937,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.093098971161452937, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0210\"\>",
                16.020921124825009,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0130\"\>",
                16.012511305691792,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0084\"\>",
                0.008409819133217214,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.8104\"\>",
                2.810445404798116,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0249\"\>",
                4.0248682358431989,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0024\"\>",
                4.0024138662853179,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0225\"\>",
                0.02245436955788091,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.7433\"\>",
                3.743293110729268,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0741\"\>",
                1.0741460123305808,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0675\"\>",
                1.0675423268972553,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0066\"\>",
                0.0066036854333255436,
                AutoDelete->True], 
              InterpretationBox["\<\" 9.5837\"\>",
                9.5836546930983371,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9696\"\>",
                1.9695737460811247,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9694\"\>",
                1.9693948662502174,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0002\"\>",
                0.00017887983090733849,
                AutoDelete->True], 
              InterpretationBox["\<\"-4.8748\"\>",
                -4.8747983436712632,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0026\"\>",
                0.002615981896916194,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0106\"\>",
                0.010594761159039894,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0080\"\>",
                -0.0079787792621236996,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.2707\"\>",
                0.27069091796875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\" 0.0013\"\>",
                0.0013249922630407859,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0116\"\>",
                0.011591023430867316,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0103\"\>",
                -0.010266031167826531,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0638\"\>",
                0.063751220703125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 0.9912\"\>",
                0.99119845027219478,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0180\"\>",
                1.0179550424350348,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0268\"\>",
                -0.026756592162840005,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.1112\"\>",
                -1.1111827006597035,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0758\"\>",
                -0.07576315709063984,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0456\"\>",
                -0.045617902955044073,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0301\"\>",
                -0.030145254135595771,
                AutoDelete->True], 
              InterpretationBox["\<\"-10.0170\"\>",
                -10.0169677734375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9591\"\>",
                0.95906584352548274,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9804\"\>",
                0.98035097459244869,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0213\"\>",
                -0.021285131066965939,
                AutoDelete->True], 
              InterpretationBox["\<\"-5.5827\"\>",
                -5.582733154296875,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("F"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", "4.183490094681049`", "4.368410214280583`", 
                "19.446047988998885`", \(-33.52404746498416`\), 
                "5.210250313023559`", "5.51699032576158`", 
                "17.94661225418074`", \(-7.776977131349106`\), \
\(-4.6627604181086175`\)},
              {"2", "4.3684102142805825`", 
                "129.2656448842067`", \(-75.23332126994416`\), \
\(-325.0016823174732`\), \(-10.289456293336245`\), \(-19.25434577456233`\), 
                "73.78514496466543`", 
                "43.1834430350964`", \(-29.43423046025522`\)},
              {"3", "19.446047988998888`", \(-75.23332126994416`\), 
                "204.6651619062209`", "28.003064266538757`", 
                "46.32225866793452`", "56.01485435147342`", 
                "68.49378516054458`", \(-92.42359952215212`\), \
\(-9.294486753549297`\)},
              {"4", \(-33.52404746498416`\), \(-325.0016823174732`\), 
                "28.003064266538757`", 
                "989.9334945426288`", \(-14.946884724840352`\), 
                "3.253858950467098`", \(-300.66233904212663`\), \
\(-40.899660563271`\), "101.70901006547746`"},
              {"5", "5.210250313023559`", \(-10.289456293336245`\), 
                "46.32225866793452`", \(-14.946884724840352`\), 
                "11.991909378354705`", "12.830050280038002`", 
                "22.272738611883675`", \(-20.425462764392098`\), \
\(-4.3535442813382845`\)},
              {"6", "5.51699032576158`", \(-19.25434577456233`\), 
                "56.01485435147341`", "3.253858950467091`", 
                "12.830050280038`", "16.41793619852556`", 
                "20.218552970471663`", \(-25.31064156277186`\), \
\(-3.0353979447780346`\)},
              {"7", "17.94661225418074`", "73.78514496466543`", 
                "68.49378516054459`", \(-300.66233904212663`\), 
                "22.27273861188367`", "20.218552970471666`", 
                "121.59284888361823`", \(-22.252728425072767`\), \
\(-35.57758019041832`\)},
              {"8", \(-7.776977131349106`\), 
                "43.1834430350964`", \(-92.4235995221521`\), \
\(-40.899660563270984`\), \(-20.425462764392098`\), \(-25.310641562771863`\), \
\(-22.25272842507277`\), "43.70766423163227`", "1.2388423918778688`"},
              {
                "9", \(-4.6627604181086175`\), \(-29.43423046025522`\), \
\(-9.294486753549297`\), 
                "101.70901006547746`", \(-4.3535442813382845`\), \
\(-3.0353979447780355`\), \(-35.57758019041832`\), "1.2388423918778688`", 
                "12.166726031321343`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00993999146820461`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0099399914682046092, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]4\),
      SequenceForm[ "BFGS: Iteration = ", 4],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2400.737927503424000\"\>",
            2400.7379275034236,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913622028648000\"\>",
            2890.9136220286482,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2400.7379275034236, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.9136220286482, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2834.374014782661000\"\>",
            2834.3740147826611,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913622028648000\"\>",
            2890.9136220286482,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2834.3740147826611, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.9136220286482, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2888.114664141198000\"\>",
            2888.1146641411979,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913622028648000\"\>",
            2890.9136220286482,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2888.1146641411979, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.9136220286482, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144611648688000\"\>",
            2891.1446116486877,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913622028648000\"\>",
            2890.9136220286482,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 2891.1446116486877, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2890.9136220286482, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144611648688000\"\>",
            2891.1446116486877,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.1446116486877, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.913622028648000\"\>",
            2890.9136220286482,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2890.9136220286482, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.230989620039509\"\>",
            0.23098962003950874,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.23098962003950874, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0320\"\>",
                16.032007608474412,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0210\"\>",
                16.020921124825009,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.01108648364940547,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.7936\"\>",
                1.7936332445800691,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0603\"\>",
                4.0603236250627788,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0249\"\>",
                4.0248682358431989,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0355\"\>",
                0.035455389219579581,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.6408\"\>",
                -0.64079913402129152,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0686\"\>",
                1.0685992654502745,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0741\"\>",
                1.0741460123305808,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0055\"\>",
                -0.0055467468803063018,
                AutoDelete->True], 
              InterpretationBox["\<\" 8.5411\"\>",
                8.5410896992491274,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9864\"\>",
                1.9863950669317847,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9696\"\>",
                1.9695737460811247,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0168\"\>",
                0.016821320850659988,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.1596\"\>",
                4.1596403902928172,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\"-0.0052\"\>",
                -0.0051878269141856972,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0026\"\>",
                0.002615981896916194,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0078\"\>",
                -0.0078038088111018911,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.4731\"\>",
                4.473052978515625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0170\"\>",
                -0.01700265082362238,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0013\"\>",
                0.0013249922630407859,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0183\"\>",
                -0.018327643086663164,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.7008\"\>",
                1.700775146484375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0021\"\>",
                1.0020581425710153,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9912\"\>",
                0.99119845027219478,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0109\"\>",
                0.010859692298820563,
                AutoDelete->True], 
              InterpretationBox["\<\" 26.4110\"\>",
                26.4110107421875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.1142\"\>",
                -0.11424695300862958,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0758\"\>",
                -0.07576315709063984,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0385\"\>",
                -0.038483795917989748,
                AutoDelete->True], 
              InterpretationBox["\<\"-6.6759\"\>",
                -6.675872802734375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9297\"\>",
                0.92972896684886908,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9591\"\>",
                0.95906584352548274,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0293\"\>",
                -0.02933687667661361,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.2837\"\>",
                -2.283721923828125,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("F"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", "5.0998760860629355`", "8.468311146850615`", 
                "20.26655109866405`", \(-42.02329414899242`\), 
                "1.2117296819872716`", 
                "3.9601134481129048`", \(-8.189331425232556`\), \
\(-10.774186108438542`\), \(-7.698769626644796`\)},
              {"2", "8.468311146850615`", 
                "147.14099643596222`", \(-71.18820352280271`\), \
\(-361.90518497139436`\), \(-27.51516478769529`\), \(-25.963608194942104`\), \
\(-38.96155122347443`\), "29.730286771285208`", \(-42.819895427121644`\)},
              {"3", "20.266551098664053`", \(-71.18820352280271`\), 
                "205.10033993888703`", "19.495125770466984`", 
                "42.21099689024486`", "54.4158449552919`", 
                "41.74298181841879`", \(-95.07225134108396`\), \
\(-12.170821550933335`\)},
              {"4", \(-42.02329414899242`\), \(-361.90518497139436`\), 
                "19.495125770466984`", "1066.069226687467`", 
                "20.545823092478905`", 
                "17.07870564196834`", \(-68.30167903572175`\), \
\(-12.996498631141833`\), "129.39349198294397`"},
              {"5", "1.2117296819872716`", \(-27.51516478769529`\), 
                "42.21099689024486`", "20.545823092478912`", 
                "28.496970345896965`", "19.259643733021925`", 
                "130.37294911801575`", \(-7.285574166599426`\), 
                "8.613463773406863`"},
              {"6", "3.9601134481129048`", \(-25.963608194942104`\), 
                "54.415844955291895`", "17.078705641968334`", 
                "19.259643733021925`", "18.922591626163975`", 
                "62.32853716063856`", \(-20.194658176114203`\), 
                "2.0144090840272297`"},
              {"7", \(-8.18933142523256`\), \(-38.961551223474416`\), 
                "41.742981818418805`", \(-68.30167903572172`\), 
                "130.37294911801575`", "62.32853716063856`", 
                "829.5446421030937`", "63.62063650599806`", 
                "49.244408626767964`"},
              {"8", \(-10.774186108438542`\), 
                "29.73028677128521`", \(-95.07225134108394`\), \
\(-12.996498631141819`\), \(-7.285574166599426`\), \(-20.194658176114203`\), 
                "63.62063650599805`", "53.50650772158606`", 
                "11.187109346543329`"},
              {
                "9", \(-7.698769626644796`\), \(-42.819895427121644`\), \
\(-12.170821550933335`\), "129.39349198294397`", "8.613463773406863`", 
                "2.014409084027229`", "49.244408626767964`", 
                "11.187109346543329`", "22.141752226637593`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.008980205841610668`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0089802058416106681, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]5\),
      SequenceForm[ "BFGS: Iteration = ", 5],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2672.662300888521000\"\>",
            2672.6623008885213,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144611648688000\"\>",
            2891.1446116486877,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2672.6623008885213, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1446116486877, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2879.229930588415000\"\>",
            2879.2299305884148,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144611648688000\"\>",
            2891.1446116486877,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2879.2299305884148, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1446116486877, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.612499343803000\"\>",
            2890.6124993438025,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144611648688000\"\>",
            2891.1446116486877,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2890.6124993438025, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1446116486877, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "4", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161908042212000\"\>",
            2891.1619080422124,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144611648688000\"\>",
            2891.1446116486877,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 4, "  LIKNEU  ", 
        PaddedForm[ 2891.1619080422124, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1446116486877, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161908042212000\"\>",
            2891.1619080422124,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.1619080422124, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.144611648688000\"\>",
            2891.1446116486877,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.1446116486877, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.017296393524703\"\>",
            0.01729639352470258,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.01729639352470258, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0360\"\>",
                16.036081510890238,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0320\"\>",
                16.032007608474412,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0041\"\>",
                0.004073902415824635,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.6195\"\>",
                1.6194524331902664,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0691\"\>",
                4.0690888165707575,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0603\"\>",
                4.0603236250627788,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0088\"\>",
                0.0087651915079787479,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.7223\"\>",
                -3.7223442057298919,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0664\"\>",
                1.0663801671173636,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0686\"\>",
                1.0685992654502745,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0022\"\>",
                -0.0022190983329109962,
                AutoDelete->True], 
              InterpretationBox["\<\" 11.6330\"\>",
                11.632842703415838,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9896\"\>",
                1.9896289026644483,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9864\"\>",
                1.9863950669317847,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0032\"\>",
                0.0032338357326636277,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.5966\"\>",
                -0.59661829040725689,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0078\"\>",
                0.0077747072802436552,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0052\"\>",
                -0.0051878269141856972,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0130\"\>",
                0.012962534194429352,
                AutoDelete->True], 
              InterpretationBox["\<\" 8.7775\"\>",
                8.777496337890625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0150\"\>",
                -0.01503755521135783,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0170\"\>",
                -0.01700265082362238,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0020\"\>",
                0.0019650956122645499,
                AutoDelete->True], 
              InterpretationBox["\<\" 5.6328\"\>",
                5.6328125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0013\"\>",
                1.0012617974596063,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0021\"\>",
                1.0020581425710153,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0008\"\>",
                -0.0007963451114090563,
                AutoDelete->True], 
              InterpretationBox["\<\" 15.0430\"\>",
                15.043074851779831,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.1176\"\>",
                -0.11758516344185517,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1142\"\>",
                -0.11424695300862958,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0033\"\>",
                -0.0033382104332255868,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.0903\"\>",
                -3.09033203125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9262\"\>",
                0.92620310890457058,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9297\"\>",
                0.92972896684886908,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0035\"\>",
                -0.0035258579442984644,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.6285\"\>",
                0.6285400390625,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("F"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", "5.1235178055031865`", "9.288441400932868`", 
                "19.345658806049364`", \(-40.821365525922246`\), 
                "0.021718594575455885`", 
                "2.9026682689220102`", \(-5.5210427462375895`\), \
\(-11.636323278853684`\), \(-8.43797938054884`\)},
              {"2", "9.288441400932868`", 
                "161.5068765765519`", \(-85.56664413999877`\), \
\(-339.70910959506256`\), \(-47.56621639686966`\), \(-44.29048866657063`\), 
                "14.162337347765309`", 
                "12.981911095586241`", \(-56.40940724109646`\)},
              {"3", "19.345658806049368`", \(-85.56664413999877`\), 
                "219.05952950075311`", \(-3.001854559412731`\), 
                "62.08395940973715`", 
                "72.71046571197914`", \(-13.00058865190374`\), \
\(-77.90347210177238`\), "1.588541870812481`"},
              {
                "4", \(-40.821365525922246`\), \(-339.70910959506256`\), \
\(-3.001854559412731`\), 
                "1100.1798802563335`", \(-10.561676843232473`\), \
\(-11.26880841302227`\), "12.752085492145738`", \(-38.60915213242454`\), 
                "108.49992651610266`"},
              {"5", "0.021718594575456107`", \(-47.56621639686966`\), 
                "62.08395940973715`", \(-10.561676843232465`\), 
                "56.394432234443116`", "44.81735402186658`", 
                "55.51305397698356`", "16.274638423960724`", 
                "27.652468164036094`"},
              {"6", "2.9026682689220102`", \(-44.29048866657064`\), 
                "72.71046571197913`", \(-11.268808413022278`\), 
                "44.81735402186658`", 
                "42.29721171474967`", \(-5.618725513133427`\), 
                "1.2169953819707544`", "19.368521902921536`"},
              {"7", \(-5.521042746237593`\), 
                "14.162337347765323`", \(-13.000588651903726`\), 
                "12.752085492145767`", 
                "55.51305397698356`", \(-5.618725513133427`\), 
                "1020.2609062031097`", 
                "3.164750085858813`", \(-0.4330084669936767`\)},
              {"8", \(-11.636323278853684`\), 
                "12.981911095586245`", \(-77.90347210177237`\), \
\(-38.609152132424526`\), "16.27463842396073`", "1.2169953819707544`", 
                "3.164750085858799`", "72.65123111237514`", 
                "26.881924932089575`"},
              {"9", \(-8.43797938054884`\), \(-56.40940724109646`\), 
                "1.5885418708124828`", "108.49992651610265`", 
                "27.652468164036094`", 
                "19.368521902921536`", \(-0.4330084669936767`\), 
                "26.881924932089575`", "34.93906382620675`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.010114675342517358`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.010114675342517358, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]6\),
      SequenceForm[ "BFGS: Iteration = ", 6],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2886.605217726674000\"\>",
            2886.6052177266743,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161908042212000\"\>",
            2891.1619080422124,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2886.6052177266743, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1619080422124, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.002202721976000\"\>",
            2891.0022027219752,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161908042212000\"\>",
            2891.1619080422124,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2891.0022027219752, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1619080422124, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187317351246000\"\>",
            2891.1873173512458,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161908042212000\"\>",
            2891.1619080422124,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2891.1873173512458, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1619080422124, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187317351246000\"\>",
            2891.1873173512458,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.1873173512458, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.161908042212000\"\>",
            2891.1619080422124,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.1619080422124, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.025409309033421\"\>",
            0.025409309033420868,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.025409309033420868, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0520\"\>",
                16.052103637073838,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0360\"\>",
                16.036081510890238,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0160\"\>",
                0.016022126183601056,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.8236\"\>",
                1.8235853966345035,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0780\"\>",
                4.0780434060250217,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0691\"\>",
                4.0690888165707575,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0090\"\>",
                0.0089545894542646092,
                AutoDelete->True], 
              InterpretationBox["\<\"-5.0925\"\>",
                -5.0925218795269487,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0657\"\>",
                1.0657014923727299,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0664\"\>",
                1.0663801671173636,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0007\"\>",
                -0.00067867474463376024,
                AutoDelete->True], 
              InterpretationBox["\<\" 12.1920\"\>",
                12.191575662300041,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9929\"\>",
                1.9929050173184553,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9896\"\>",
                1.9896289026644483,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0033\"\>",
                0.0032761146540070778,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.9952\"\>",
                -0.99521198973879454,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0053\"\>",
                0.0052793082570652093,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0078\"\>",
                0.0077747072802436552,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0025\"\>",
                -0.0024953990231784458,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.2958\"\>",
                2.29583740234375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0007\"\>",
                -0.00067688146405772871,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0150\"\>",
                -0.01503755521135783,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0144\"\>",
                0.014360673747300101,
                AutoDelete->True], 
              InterpretationBox["\<\" 5.2163\"\>",
                5.21630859375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0017\"\>",
                1.0016658825143565,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0013\"\>",
                1.0012617974596063,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0004\"\>",
                0.00040408505475027001,
                AutoDelete->True], 
              InterpretationBox["\<\" 15.7130\"\>",
                15.713388218695094,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.1169\"\>",
                -0.11690286320468403,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1176\"\>",
                -0.11758516344185517,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0007\"\>",
                0.00068230023717113781,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.2881\"\>",
                -3.2880859375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9283\"\>",
                0.92833365871338513,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9262\"\>",
                0.92620310890457058,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0021\"\>",
                0.0021305498088145746,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0345\"\>",
                1.0345458984375,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("F"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", "5.388386911147233`", "6.8376773540222615`", 
                "19.392774218743998`", \(-41.58008510721274`\), \
\(-14.055776077843406`\), 
                "1.5208696255690977`", \(-5.566864387319229`\), \
\(-11.74967655985398`\), \(-7.667111570283512`\)},
              {"2", "6.837677354022261`", 
                "179.50355891963557`", \(-90.71656613405746`\), \
\(-334.36853879028695`\), "43.277272617669524`", \(-37.35614849485326`\), 
                "8.219207329748613`", 
                "15.02685267775617`", \(-61.84478328784638`\)},
              {"3", "19.392774218744`", \(-90.71656613405746`\), 
                "214.31929850730793`", \(-4.828820100148256`\), 
                "19.878385056134448`", 
                "66.57059870854326`", \(-19.42262812156256`\), \
\(-76.92020299762193`\), "3.4353967927517193`"},
              {
                "4", \(-41.58008510721274`\), \(-334.36853879028695`\), \
\(-4.828820100148256`\), "1101.7503517282162`", 
                "15.617182943769706`", \(-9.41078294094766`\), 
                "10.597975307875242`", \(-37.926912407776335`\), 
                "106.90097326060891`"},
              {"5", \(-14.055776077843408`\), "43.277272617669524`", 
                "19.878385056134448`", "15.617182943769713`", 
                "472.66787863403437`", "68.98018776491945`", 
                "4.324197901972447`", "30.688578067593085`", 
                "0.9761647515638501`"},
              {"6", "1.5208696255690977`", \(-37.356148494853265`\), 
                "66.57059870854324`", \(-9.410782940947668`\), 
                "68.98018776491944`", 
                "42.19009766515201`", \(-13.34072211159193`\), 
                "3.0538295702805636`", "17.46912507318825`"},
              {"7", \(-5.5668643873192325`\), 
                "8.219207329748627`", \(-19.422628121562546`\), 
                "10.59797530787527`", 
                "4.324197901972454`", \(-13.34072211159193`\), 
                "1011.6056769979305`", "4.5396832999562395`", 
                "1.7429456689904717`"},
              {"8", \(-11.74967655985398`\), 
                "15.026852677756171`", \(-76.92020299762191`\), \
\(-37.92691240777632`\), "30.688578067593088`", "3.0538295702805636`", 
                "4.539683299956225`", "72.48770567780944`", 
                "26.190740048464388`"},
              {"9", \(-7.667111570283512`\), \(-61.844783287846376`\), 
                "3.435396792751721`", "106.9009732606089`", 
                "0.9761647515638536`", "17.46912507318825`", 
                "1.7429456689904717`", "26.190740048464388`", 
                "36.56698985698493`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.010982048612836852`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.010982048612836852, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]7\),
      SequenceForm[ "BFGS: Iteration = ", 7],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2885.273775479052000\"\>",
            2885.2737754790523,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187317351246000\"\>",
            2891.1873173512458,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2885.2737754790523, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1873173512458, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.070951759501000\"\>",
            2891.0709517595014,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187317351246000\"\>",
            2891.1873173512458,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2891.0709517595014, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1873173512458, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247765951873000\"\>",
            2891.2477659518736,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187317351246000\"\>",
            2891.1873173512458,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2891.2477659518736, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.1873173512458, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247765951873000\"\>",
            2891.2477659518736,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.2477659518736, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.187317351246000\"\>",
            2891.1873173512458,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.1873173512458, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.060448600627751\"\>",
            0.060448600627751148,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.060448600627751148, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.0990\"\>",
                16.09857522552117,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0520\"\>",
                16.052103637073838,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0465\"\>",
                0.046471588447330847,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9780\"\>",
                1.9780061470969119,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0790\"\>",
                4.0789758713851265,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0780\"\>",
                4.0780434060250217,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0009\"\>",
                0.00093246536010463095,
                AutoDelete->True], 
              InterpretationBox["\<\"-6.0906\"\>",
                -6.0905942008452598,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0639\"\>",
                1.0638777714411005,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0657\"\>",
                1.0657014923727299,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0018\"\>",
                -0.0018237209316294071,
                AutoDelete->True], 
              InterpretationBox["\<\" 11.8980\"\>",
                11.898488373300811,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9942\"\>",
                1.9942409206284815,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9929\"\>",
                1.9929050173184553,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0013\"\>",
                0.0013359033100262727,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.3658\"\>",
                -1.3658071029333214,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0064\"\>",
                0.0064205731213242065,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0053\"\>",
                0.0052793082570652093,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0011\"\>",
                0.0011412648642589976,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.2602\"\>",
                3.260162353515625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\" 0.0018\"\>",
                0.0018231202512645228,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0007\"\>",
                -0.00067688146405772871,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0025\"\>",
                0.0025000017153222515,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.8672\"\>",
                2.8671875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0026\"\>",
                1.0025759519097186,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0017\"\>",
                1.0016658825143565,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0009\"\>",
                0.0009100693953620827,
                AutoDelete->True], 
              InterpretationBox["\<\" 15.2840\"\>",
                15.283956448811113,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.1161\"\>",
                -0.1160505119804599,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1169\"\>",
                -0.11690286320468403,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0009\"\>",
                0.00085235122422412635,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.4691\"\>",
                -3.469085693359375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9353\"\>",
                0.93525953591610855,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9283\"\>",
                0.92833365871338513,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0069\"\>",
                0.0069258772027234331,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.8873\"\>",
                0.887298583984375,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("F"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", "4.83528019621056`", "6.403285223173878`", 
                "11.067409708169397`", \(-42.27785513968357`\), \
\(-12.064137695710402`\), \(-9.80485702076167`\), \(-16.477626567821986`\), \
\(-10.412205313185304`\), \(-8.800831481114002`\)},
              {"2", "6.403285223173876`", 
                "193.50750992255067`", \(-63.71117403572536`\), \
\(-327.67056457761004`\), "25.35706714671991`", "24.377277631690376`", 
                "44.19188200815457`", 
                "13.611463477854297`", \(-56.79171184208788`\)},
              {"3", "11.0674097081694`", \(-63.711174035725364`\), 
                "167.44312552836013`", "1.6119701589194744`", 
                "4.295276045937388`", 
                "61.24926702153752`", \(-79.49759665509204`\), \
\(-62.55447066800646`\), "0.26851765060597144`"},
              {"4", \(-42.27785513968357`\), \(-327.67056457761004`\), 
                "1.6119701589194744`", "1104.530161078536`", 
                "8.287809648433676`", "11.97693862438292`", 
                "19.332342939670163`", \(-37.48514897717453`\), 
                "108.47288349648299`"},
              {"5", \(-12.064137695710404`\), "25.35706714671991`", 
                "4.295276045937388`", "8.287809648433685`", 
                "491.96117256750915`", 
                "13.830594336526445`", \(-16.887177728915102`\), 
                "29.221772879544783`", \(-3.014268888329094`\)},
              {"6", \(-9.80485702076167`\), "24.37727763169037`", 
                "61.249267021537506`", "11.976938624382909`", 
                "13.830594336526424`", 
                "158.01717063352294`", \(-17.454489743315122`\), 
                "18.30027832062762`", "23.51711052116239`"},
              {"7", \(-16.47762656782199`\), 
                "44.191882008154586`", \(-79.49759665509202`\), 
                "19.33234293967019`", \(-16.8871777289151`\), \
\(-17.45448974331513`\), "934.6784491922242`", 
                "23.26676559346474`", \(-2.166712039857697`\)},
              {"8", \(-10.412205313185304`\), 
                "13.611463477854299`", \(-62.554470668006445`\), \
\(-37.48514897717452`\), "29.221772879544787`", "18.30027832062762`", 
                "23.26676559346472`", "69.67740528725133`", 
                "27.910568807402825`"},
              {"9", \(-8.800831481114002`\), \(-56.791711842087864`\), 
                "0.2685176506059732`", 
                "108.47288349648298`", \(-3.01426888832909`\), 
                "23.51711052116239`", \(-2.1667120398576962`\), 
                "27.910568807402825`", "36.705659955638`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.005207545720898706`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0052075457208987062, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]8\),
      SequenceForm[ "BFGS: Iteration = ", 8],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2879.217243945660000\"\>",
            2879.2172439456599,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247765951873000\"\>",
            2891.2477659518736,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2879.2172439456599, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.2477659518736, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.209165121304000\"\>",
            2891.2091651213041,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247765951873000\"\>",
            2891.2477659518736,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2891.2091651213041, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.2477659518736, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480890796199000\"\>",
            2891.4808907961992,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247765951873000\"\>",
            2891.2477659518736,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2891.4808907961992, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.2477659518736, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480890796199000\"\>",
            2891.4808907961992,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.4808907961992, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.247765951873000\"\>",
            2891.2477659518736,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.2477659518736, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.233124844325630\"\>",
            0.23312484432562997,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.23312484432562997, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.2550\"\>",
                16.25482522552117,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.0990\"\>",
                16.09857522552117,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.1563\"\>",
                0.15624999999999997,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.7537\"\>",
                0.75374283879353654,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.1057\"\>",
                4.1057238690877131,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0790\"\>",
                4.0789758713851265,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0267\"\>",
                0.02674799770258646,
                AutoDelete->True], 
              InterpretationBox["\<\"-3.6912\"\>",
                -3.6911973510958402,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0887\"\>",
                1.0887174751688657,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0639\"\>",
                1.0638777714411005,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0248\"\>",
                0.024839703727765141,
                AutoDelete->True], 
              InterpretationBox["\<\" 13.1490\"\>",
                13.148735537531582,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0078\"\>",
                2.0078054336159963,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9942\"\>",
                1.9942409206284815,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0136\"\>",
                0.013564512987514816,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.6705\"\>",
                -0.67046395275514192,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0070\"\>",
                0.0070020168975568368,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0064\"\>",
                0.0064205731213242065,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0006\"\>",
                0.00058144377623263054,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.6470\"\>",
                2.64697265625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0089\"\>",
                -0.008884066190966473,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0018\"\>",
                0.0018231202512645228,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0107\"\>",
                -0.010707186442230995,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.5442\"\>",
                2.544219970703125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0058\"\>",
                1.0058326765656687,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0026\"\>",
                1.0025759519097186,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0033\"\>",
                0.003256724655950166,
                AutoDelete->True], 
              InterpretationBox["\<\" 14.6130\"\>",
                14.612809764935909,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0763\"\>",
                -0.076296707603555003,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1161\"\>",
                -0.1160505119804599,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0398\"\>",
                0.039753804376904893,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.0572\"\>",
                -1.05718994140625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9520\"\>",
                0.95203321109930716,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9353\"\>",
                0.93525953591610855,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0168\"\>",
                0.016773675183198597,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.2607\"\>",
                0.260650634765625,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("F"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", 
                "28.97225816189359`", \(-40.147673420238206`\), \
\(-18.324398571531436`\), \(-55.90431968766573`\), \(-0.7480752876017789`\), \
\(-4.236544949394034`\), \(-8.083962396580183`\), \(-58.1097130958569`\), 
                "3.5964997166770516`"},
              {"2", \(-40.14767342023821`\), 
                "282.4184824474656`", \(-1.5691663013665575`\), \
\(-301.4853626023399`\), "4.4224285746580385`", "14.557608035560186`", 
                "33.57043977253629`", 
                "105.76932310899703`", \(-80.75046754163981`\)},
              {"3", \(-18.324398571531432`\), \(-1.5691663013665718`\), 
                "168.9304643103365`", 
                "18.802356606074223`", \(-15.077652726306319`\), 
                "48.68829122457671`", \(-124.71482334923311`\), \
\(-5.527011194274628`\), \(-14.519357393928564`\)},
              {"4", \(-55.90431968766574`\), \(-301.4853626023399`\), 
                "18.802356606074227`", "1112.2125430404883`", 
                "1.9967528802062393`", "8.934017036833975`", 
                "15.203109651111845`", \(-10.539295176840508`\), 
                "101.46863300246366`"},
              {"5", \(-0.7480752876017807`\), 
                "4.4224285746580385`", \(-15.077652726306319`\), 
                "1.996752880206249`", "496.35444779501944`", 
                "15.498657552255818`", \(-18.658237954017522`\), 
                "6.688010074924595`", "2.848228213477424`"},
              {"6", \(-4.236544949394034`\), "14.557608035560179`", 
                "48.688291224576695`", "8.934017036833964`", 
                "15.498657552255796`", 
                "158.32771557626515`", \(-21.415249729025682`\), 
                "7.118995341563011`", "26.429107836233705`"},
              {"7", \(-8.083962396580185`\), 
                "33.5704397725363`", \(-124.71482334923309`\), 
                "15.203109651111873`", \(-18.65823795401752`\), \
\(-21.415249729025692`\), "901.8943063587957`", "5.6043934527983446`", 
                "2.459168871226778`"},
              {"8", \(-58.1097130958569`\), 
                "105.76932310899703`", \(-5.527011194274607`\), \
\(-10.539295176840493`\), "6.688010074924598`", "7.118995341563011`", 
                "5.604393452798316`", "163.90089343899774`", 
                "3.421463718250074`"},
              {"9", 
                "3.5964997166770534`", \(-80.75046754163981`\), \
\(-14.519357393928564`\), "101.46863300246365`", "2.848228213477428`", 
                "26.429107836233708`", "2.4591688712267787`", 
                "3.421463718250074`", "43.07045303949418`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.006393693871949849`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0063936938719498489, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]9\),
      SequenceForm[ "BFGS: Iteration = ", 9],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "1", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2879.084146503241000\"\>",
            2879.0841465032404,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480890796199000\"\>",
            2891.4808907961992,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 1, "  LIKNEU  ", 
        PaddedForm[ 2879.0841465032404, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.4808907961992, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "2", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2890.892187374736000\"\>",
            2890.8921873747358,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480890796199000\"\>",
            2891.4808907961992,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 2, "  LIKNEU  ", 
        PaddedForm[ 2890.8921873747358, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.4808907961992, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"STEP-REDUCTION:  \"\>", "\[InvisibleSpace]", "3", 
        "\[InvisibleSpace]", "\<\"  LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.555724894612000\"\>",
            2891.555724894612,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)], 
        "\[InvisibleSpace]", "\<\"  LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480890796199000\"\>",
            2891.4808907961992,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "STEP-REDUCTION:  ", 3, "  LIKNEU  ", 
        PaddedForm[ 2891.555724894612, {20, 15}], "  LIKALT  ", 
        PaddedForm[ 2891.4808907961992, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.555724894612000\"\>",
            2891.555724894612,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.555724894612, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.480890796199000\"\>",
            2891.4808907961992,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.4808907961992, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.074834098412794\"\>",
            0.074834098412793537,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.074834098412793537, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.327518280953711,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.2550\"\>",
                16.25482522552117,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0727\"\>",
                0.07269305543254069,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.8757\"\>",
                0.87573154947863152,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.1002\"\>",
                4.1002319457222276,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.1057\"\>",
                4.1057238690877131,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0055\"\>",
                -0.0054919233654858448,
                AutoDelete->True], 
              InterpretationBox["\<\"-4.5028\"\>",
                -4.5027976166481922,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.0951\"\>",
                1.0951042956846715,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0887\"\>",
                1.0887174751688657,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0064\"\>",
                0.0063868205158057459,
                AutoDelete->True], 
              InterpretationBox["\<\" 9.4701\"\>",
                9.4700520720873502,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0131\"\>",
                2.0130605480182684,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0078\"\>",
                2.0078054336159963,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0053\"\>",
                0.0052551144022720923,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.9393\"\>",
                -0.93926643799151199,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0071\"\>",
                0.0071246021421149551,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0070\"\>",
                0.0070020168975568368,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0001\"\>",
                0.00012258524455811812,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.2848\"\>",
                2.284820556640625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0039\"\>",
                -0.0038670150317943438,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0089\"\>",
                -0.008884066190966473,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0050\"\>",
                0.0050170511591721293,
                AutoDelete->True], 
              InterpretationBox["\<\" 3.0974\"\>",
                3.097442626953125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0077\"\>",
                1.0077409959575525,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0058\"\>",
                1.0058326765656687,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0019\"\>",
                0.0019083193918837469,
                AutoDelete->True], 
              InterpretationBox["\<\" 11.2240\"\>",
                11.224175349454656,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0463\"\>",
                -0.046330789770475805,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0763\"\>",
                -0.076296707603555003,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0300\"\>",
                0.029965917833079194,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.0033\"\>",
                -2.003265380859375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9191\"\>",
                0.9191470948941155,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9520\"\>",
                0.95203321109930716,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0329\"\>",
                -0.032886116205191655,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.9973\"\>",
                -0.99725341796875,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("F"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", 
                "29.038262906906255`", \(-40.62147136612063`\), \
\(-21.25450712919088`\), \(-56.07570059334326`\), \(-1.0719564209241492`\), \
\(-3.9143202094097616`\), \(-10.848540862617167`\), \(-58.74701904039688`\), 
                "2.7054954040910726`"},
              {"2", \(-40.62147136612064`\), "285.7404482522271`", 
                "17.32038388687924`", \(-300.31431881196005`\), 
                "6.455505030481813`", "12.296817885851034`", 
                "51.291375347073085`", 
                "110.05798683076641`", \(-74.8345342506737`\)},
              {"3", \(-21.254507129190877`\), "17.320383886879227`", 
                "240.89839764196844`", 
                "24.806359802812196`", \(-8.610634638484637`\), 
                "35.79948287399354`", \(-59.56383211494335`\), 
                "15.009518948066308`", "12.024762391733612`"},
              {"4", \(-56.075700593343264`\), \(-300.31431881196005`\), 
                "24.8063598028122`", "1112.613254674341`", 
                "2.619333180341383`", "8.136437255746479`", 
                "20.79198225029405`", \(-9.098607578358134`\), 
                "103.42299363060704`"},
              {"5", \(-1.071956420924151`\), 
                "6.455505030481813`", \(-8.610634638484639`\), 
                "2.6193331803413926`", "496.866701980208`", 
                "14.110234823778567`", \(-12.931127802378391`\), 
                "8.759436004201074`", "5.449144027126442`"},
              {"6", \(-3.9143202094097616`\), "12.296817885851025`", 
                "35.799482873993526`", "8.136437255746468`", 
                "14.110234823778546`", 
                "159.86628279748555`", \(-33.50891001638066`\), 
                "4.196685940874125`", "22.39629108241022`"},
              {"7", \(-10.84854086261717`\), 
                "51.29137534707309`", \(-59.56383211494331`\), 
                "20.79198225029408`", \(-12.931127802378386`\), \
\(-33.50891001638067`\), "960.6386217683687`", "24.61356783543576`", 
                "26.88774468260703`"},
              {"8", \(-58.74701904039688`\), "110.05798683076641`", 
                "15.00951894806633`", \(-9.09860757835812`\), 
                "8.759436004201078`", "4.196685940874125`", 
                "24.61356783543573`", "169.01937697453775`", 
                "10.288221185650023`"},
              {"9", "2.7054954040910744`", \(-74.8345342506737`\), 
                "12.024762391733612`", "103.42299363060702`", 
                "5.4491440271264455`", "22.396291082410222`", 
                "26.88774468260703`", "10.288221185650023`", 
                "52.18541797671682`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.003859093173586021`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0038590931735860211, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]10\),
      SequenceForm[ "BFGS: Iteration = ", 10],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.694842196116000\"\>",
            2891.6948421961156,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.6948421961156, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.555724894612000\"\>",
            2891.555724894612,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.555724894612, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.139117301503575\"\>",
            0.13911730150357471,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.13911730150357471, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.2230\"\>",
                16.222594967617123,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.327518280953711,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1049\"\>",
                -0.10492331333658729,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.4619\"\>",
                0.46189291058418813,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0745\"\>",
                4.0744723977539392,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.1002\"\>",
                4.1002319457222276,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0258\"\>",
                -0.025759547968288724,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.7215\"\>",
                -2.7215004191717336,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.1323\"\>",
                1.132288336938932,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0951\"\>",
                1.0951042956846715,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0372\"\>",
                0.037184041254260475,
                AutoDelete->True], 
              InterpretationBox["\<\" 8.6261\"\>",
                8.6260657433405505,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 1.9968\"\>",
                1.996790110173204,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0131\"\>",
                2.0130605480182684,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0163\"\>",
                -0.016270437845064385,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.5566\"\>",
                -0.55662206341418818,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0132\"\>",
                0.013167021549738381,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0071\"\>",
                0.0071246021421149551,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0060\"\>",
                0.0060424194076234266,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0708\"\>",
                2.07080078125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\" 0.0022\"\>",
                0.0021871354058114901,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0039\"\>",
                -0.0038670150317943438,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0061\"\>",
                0.0060541504376058338,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9366\"\>",
                1.936614990234375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0219\"\>",
                1.0219044448545969,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0077\"\>",
                1.0077409959575525,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0142\"\>",
                0.014163448897044401,
                AutoDelete->True], 
              InterpretationBox["\<\" 9.3196\"\>",
                9.3195505123917446,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0894\"\>",
                -0.089441942757950033,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0463\"\>",
                -0.046330789770475805,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0431\"\>",
                -0.043111152987474234,
                AutoDelete->True], 
              InterpretationBox["\<\"-2.4850\"\>",
                -2.485015869140625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9403\"\>",
                0.9402544894375986,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9191\"\>",
                0.9191470948941155,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0211\"\>",
                0.021107394543483069,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.7343\"\>",
                1.73431396484375,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("F"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", 
                "30.05128646724213`", \(-44.916671133568144`\), \
\(-19.871546505103428`\), \(-57.000849792810214`\), \(-0.7108970097210752`\), \
\(-1.1297395800061336`\), \(-6.825691975684477`\), \(-57.29907894060259`\), \
\(-4.4061778367456395`\)},
              {"2", \(-44.91667113356815`\), "303.89322696397875`", 
                "12.072579048316118`", \(-296.4020883792094`\), 
                "5.071459441718615`", "0.5416305086306483`", 
                "34.81119543475718`", 
                "103.67646315429695`", \(-44.2977921215401`\)},
              {"3", \(-19.871546505103424`\), "12.072579048316104`", 
                "236.33284644227712`", 
                "23.652163698503404`", \(-9.65628591095734`\), 
                "39.06259508013619`", \(-60.11366354374387`\), 
                "19.524867258980724`", \(-1.701062016068441`\)},
              {"4", \(-57.00084979281022`\), \(-296.4020883792094`\), 
                "23.652163698503408`", "1113.4563178845206`", 
                "2.3155323239198986`", "5.602479999604784`", 
                "17.219951604848724`", \(-10.463745634263805`\), 
                "109.9854915788907`"},
              {"5", \(-0.710897009721077`\), 
                "5.071459441718615`", \(-9.656285910957342`\), 
                "2.3155323239199084`", "496.62858745207257`", 
                "14.974363781116468`", \(-12.937702306142402`\), 
                "9.880735962903032`", "1.9567176610587147`"},
              {"6", \(-1.1297395800061336`\), "0.5416305086306394`", 
                "39.06259508013617`", "5.602479999604772`", 
                "14.974363781116447`", 
                "167.47557920184556`", \(-22.954970009717037`\), 
                "8.388527308427044`", "2.5127532563584403`"},
              {"7", \(-6.825691975684481`\), 
                "34.81119543475718`", \(-60.113663543743826`\), 
                "17.219951604848752`", \(-12.937702306142398`\), \
\(-22.954970009717044`\), "970.9576494867792`", 
                "32.740186347953944`", \(-5.11441387038866`\)},
              {"8", \(-57.29907894060259`\), "103.67646315429695`", 
                "19.52486725898074`", \(-10.463745634263791`\), 
                "9.880735962903035`", "8.388527308427044`", 
                "32.740186347953916`", "170.09031938964256`", 
                "1.7035460276602112`"},
              {
                "9", \(-4.406177836745638`\), \(-44.2977921215401`\), \
\(-1.701062016068441`\), "109.98549157889069`", "1.9567176610587178`", 
                "2.512753256358444`", \(-5.114413870388667`\), 
                "1.7035460276602095`", "99.61059970597884`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.0022028903523872777`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.0022028903523872777, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]11\),
      SequenceForm[ "BFGS: Iteration = ", 11],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772427329953000\"\>",
            2891.7724273299532,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.7724273299532, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.694842196116000\"\>",
            2891.6948421961156,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.6948421961156, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.077585133837601\"\>",
            0.077585133837601461,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.077585133837601461, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.3360\"\>",
                16.336232268993172,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.2230\"\>",
                16.222594967617123,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.1136\"\>",
                0.11363730137604983,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0768\"\>",
                -0.076829163934073089,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0966\"\>",
                4.0966264005017532,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0745\"\>",
                4.0744723977539392,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0222\"\>",
                0.022154002747814362,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.5634\"\>",
                1.5634138725380486,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.1251\"\>",
                1.1251341132783275,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.1323\"\>",
                1.132288336938932,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0072\"\>",
                -0.0071542236606045662,
                AutoDelete->True], 
              InterpretationBox["\<\"-4.6359\"\>",
                -4.6359004629345844,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0100\"\>",
                2.0100196699465975,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.9968\"\>",
                1.996790110173204,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0132\"\>",
                0.013229559773393598,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.5465\"\>",
                1.5464578096735451,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0110\"\>",
                0.011039733162989696,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0132\"\>",
                0.013167021549738381,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0021\"\>",
                -0.0021272883867486845,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.0968\"\>",
                -1.096832275390625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0032\"\>",
                -0.0032199752252887685,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0022\"\>",
                0.0021871354058114901,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0054\"\>",
                -0.0054071106311002586,
                AutoDelete->True], 
              InterpretationBox["\<\"-1.4967\"\>",
                -1.496734619140625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0175\"\>",
                1.017480499988364,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0219\"\>",
                1.0219044448545969,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0044\"\>",
                -0.0044239448662329681,
                AutoDelete->True], 
              InterpretationBox["\<\"-4.2940\"\>",
                -4.2939738915449501,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0566\"\>",
                -0.056580654441346391,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0894\"\>",
                -0.089441942757950033,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0329\"\>",
                0.032861288316603642,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.5256\"\>",
                1.525604248046875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9393\"\>",
                0.93934628391881003,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9403\"\>",
                0.9402544894375986,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0009\"\>",
                -0.00090820551878854103,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1622\"\>",
                -0.1622314453125,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("F"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", 
                "30.00640500738875`", \(-45.234940116364186`\), \
\(-19.030375140670454`\), \(-57.70949524711698`\), \(-0.5173969287514741`\), \
\(-0.7016942550570613`\), \(-6.291802955905383`\), \(-57.64112742635477`\), \
\(-4.640930121223434`\)},
              {"2", \(-45.23494011636419`\), 
                "310.403299811332`", \(-7.228568392453052`\), \
\(-289.9518935304554`\), "0.5050488889893758`", \(-5.694149045934802`\), 
                "16.940307946369963`", 
                "110.02995367144251`", \(-44.96603183339221`\)},
              {"3", \(-19.03037514067045`\), \(-7.228568392453067`\), 
                "293.3835248879256`", "3.8619666282229304`", 
                "3.8318530804208635`", 
                "57.759291872737975`", \(-7.705717066832122`\), 
                "0.6346813144500025`", \(-0.17308621306415617`\)},
              {"4", \(-57.70949524711699`\), \(-289.9518935304554`\), 
                "3.861966628222934`", 
                "1117.2878739300106`", \(-2.402439674879442`\), 
                "0.2256542259903087`", \(-2.6976847941701756`\), \
\(-4.373244589204144`\), "107.58322866891783`"},
              {"5", \(-0.5173969287514761`\), "0.5050488889893776`", 
                "3.8318530804208617`", \(-2.402439674879432`\), 
                "499.8170007770762`", 
                "19.409000021470618`", \(-0.5696162882136875`\), 
                "5.408687805131038`", "2.293836219699779`"},
              {"6", \(-0.7016942550570613`\), \(-5.694149045934809`\), 
                "57.759291872737954`", "0.22565422599029805`", 
                "19.409000021470597`", 
                "173.19755476682948`", \(-5.144506395997183`\), 
                "2.3668000618243887`", "3.697873813030693`"},
              {"7", \(-6.2918029559053865`\), 
                "16.94030794636997`", \(-7.705717066832065`\), \
\(-2.697684794170147`\), \(-0.5696162882136804`\), \(-5.14450639599719`\), 
                "1018.1049593087531`", 
                "15.122412386015412`", \(-4.783442034521485`\)},
              {"8", \(-57.64112742635477`\), "110.02995367144251`", 
                "0.6346813144500203`", \(-4.373244589204129`\), 
                "5.4086878051310405`", "2.366800061824387`", 
                "15.122412386015384`", "176.27464505511344`", 
                "0.9122968636640296`"},
              {
                "9", \(-4.640930121223432`\), \(-44.96603183339221`\), \
\(-0.17308621306415972`\), "107.58322866891781`", "2.293836219699782`", 
                "3.6978738130306974`", \(-4.783442034521496`\), 
                "0.9122968636640278`", "98.49598766742056`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.00022235683728662325`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 0.00022235683728662325, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]12\),
      SequenceForm[ "BFGS: Iteration = ", 12],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592267190000\"\>",
            2891.7725922671893,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.7725922671893, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772427329953000\"\>",
            2891.7724273299532,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.7724273299532, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"     0.000164937236150\"\>",
            0.00016493723614985356,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 0.00016493723614985356, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.328043081824493,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.3360\"\>",
                16.336232268993172,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0082\"\>",
                -0.0081891871686784017,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0394\"\>",
                -0.03936068981549682,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952201543699092,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0966\"\>",
                4.0966264005017532,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0014\"\>",
                -0.0014062461318443658,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0314\"\>",
                0.031399395312474737,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.1246923448173853,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.1251\"\>",
                1.1251341132783275,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0004\"\>",
                -0.00044176846094219375,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0687\"\>",
                0.068703832261730421,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091841964786159,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0100\"\>",
                2.0100196699465975,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0008\"\>",
                -0.00083547346798148287,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.1003\"\>",
                -0.10034263686259526,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011140366816199525,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0110\"\>",
                0.011039733162989696,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0001\"\>",
                0.00010063365320982954,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0568\"\>",
                0.056793212890625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.0027856397480388456,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0032\"\>",
                -0.0032199752252887685,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0004\"\>",
                0.00043433547724992284,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0651\"\>",
                0.0650634765625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172681695475434,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0175\"\>",
                1.017480499988364,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0002\"\>",
                -0.00021233044082055792,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.2015\"\>",
                -0.20149485896397484,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.058033206381407298,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0566\"\>",
                -0.056580654441346391,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0015\"\>",
                -0.0014525519400609074,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0612\"\>",
                0.0611572265625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9389\"\>",
                0.93890287703043673,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9393\"\>",
                0.93934628391881003,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0004\"\>",
                -0.00044340688837325346,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0310\"\>",
                -0.031036376953125,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("F"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", 
                "29.977981508983834`", \(-44.83412398272178`\), \
\(-20.18155332248014`\), \(-57.343347758080775`\), \(-0.780405876668565`\), \
\(-1.0634653815499595`\), \(-7.419255009451805`\), \(-57.24296263435252`\), \
\(-4.688931733897626`\)},
              {"2", \(-44.834123982721785`\), 
                "309.5079103395879`", \(-6.100228068894385`\), \
\(-289.5977804852048`\), "0.3895252049605178`", \(-5.734453179957214`\), 
                "20.48697777703387`", 
                "108.8682842859584`", \(-44.61102888459204`\)},
              {"3", \(-20.181553322480138`\), \(-6.100228068894399`\), 
                "294.72602589462167`", "1.1708413789450418`", 
                "5.324037001842257`", 
                "59.4351899389356`", \(-14.144152544758185`\), 
                "2.6199393577958183`", \(-1.0950153784625103`\)},
              {"4", \(-57.34334775808078`\), \(-289.5977804852048`\), 
                "1.1708413789450454`", 
                "1118.970829173217`", \(-3.450288511792276`\), \
\(-1.0781068902410764`\), \(-2.5013427247333873`\), \(-4.337202861689351`\), 
                "107.82821105560794`"},
              {"5", \(-0.780405876668567`\), "0.38952520496051957`", 
                "5.324037001842255`", \(-3.4502885117922664`\), 
                "500.4580593545579`", 
                "20.195429134479728`", \(-1.0711889739983285`\), 
                "5.512775762593066`", "2.1084663532120027`"},
              {"6", \(-1.0634653815499595`\), \(-5.734453179957223`\), 
                "59.43518993893558`", \(-1.078106890241087`\), 
                "20.195429134479706`", 
                "174.1510936250203`", \(-6.142400123556357`\), 
                "2.621002343429234`", "3.4348701305079627`"},
              {"7", \(-7.419255009451809`\), 
                "20.48697777703388`", \(-14.144152544758114`\), \
\(-2.501342724733359`\), \(-1.0711889739983214`\), \(-6.142400123556357`\), 
                "1005.458989394314`", 
                "19.35246931071795`", \(-5.851595196113201`\)},
              {"8", \(-57.24296263435252`\), "108.8682842859584`", 
                "2.619939357795836`", \(-4.3372028616893346`\), 
                "5.512775762593068`", "2.6210023434292324`", 
                "19.352469310717915`", "174.86583441960136`", 
                "1.2833718357261747`"},
              {
                "9", \(-4.688931733897625`\), \(-44.61102888459204`\), \
\(-1.095015378462513`\), "107.82821105560792`", "2.1084663532120063`", 
                "3.434870130507967`", \(-5.8515951961132115`\), 
                "1.283371835726173`", "98.43670561444864`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]0.000011028138666886708`\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 1.1028138666886708*^-05, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]13\),
      SequenceForm[ "BFGS: Iteration = ", 13],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592813899000\"\>",
            2891.7725928138989,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.7725928138989, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592267190000\"\>",
            2891.7725922671893,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.7725922671893, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     5.467095434141811"\[Times]10\^"-7"\),
            5.467095434141811*^-07,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 5.467095434141811*^-07, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.328236601019487,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.328043081824493,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0002\"\>",
                0.00019351919499469667,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0020\"\>",
                0.0019531347988739822,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952186428750581,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952201543699092,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0054\"\>",
                -0.0053803435653485901,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.1247373716127844,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.1246923448173853,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                4.5026795398976351*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0094\"\>",
                0.0093884181571134134,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091806507492538,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091841964786159,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0082\"\>",
                -0.0081565142120106349,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011149015608373686,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011140366816199525,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0047\"\>",
                0.004730224609375,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.002785221153950915,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.0027856397480388456,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0029\"\>",
                0.002899169921875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172690210023767,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172681695475434,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0001\"\>",
                5.9999081930526714*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.057979766212023442,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.058033206381407298,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0001\"\>",
                5.3440169383852535*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0018\"\>",
                -0.0018310546875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9390\"\>",
                0.93896274645433997,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9389\"\>",
                0.93890287703043673,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0001\"\>",
                5.9869423903206149*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0049\"\>",
                0.004852294921875,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("F"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", 
                "30.397003351333097`", \(-45.63714708587082`\), \
\(-19.343479342143993`\), \(-57.88606372081056`\), \(-0.45928906279845416`\), \
\(-1.004619824258187`\), \(-6.493037717503255`\), \(-57.74640961266046`\), \
\(-3.9523229648773937`\)},
              {"2", \(-45.637147085870836`\), 
                "310.5658200172206`", \(-6.095784588247625`\), \
\(-290.21079887016276`\), "0.7240760038991496`", \(-5.0760679100269455`\), 
                "17.461220956092998`", 
                "109.98457890401708`", \(-45.60584731001415`\)},
              {"3", \(-19.34347934214399`\), \(-6.095784588247638`\), 
                "291.0098354893908`", "5.62021402141951`", 
                "2.785704962070616`", 
                "56.97091097266013`", \(-8.103976558392468`\), 
                "1.1058363830163458`", \(-1.0173838737598455`\)},
              {"4", \(-57.88606372081057`\), \(-290.21079887016276`\), 
                "5.620214021419514`", 
                "1113.9927019707586`", \(-0.6015912749112604`\), 
                "1.4958559061959713`", \(-7.999272320183895`\), \
\(-3.1645696714365092`\), "108.3066636606761`"},
              {"5", \(-0.45928906279845527`\), "0.7240760038991514`", 
                "2.7857049620706142`", \(-0.6015912749112489`\), 
                "498.82814581902625`", "18.717604113663917`", 
                "2.108624783690953`", "4.827815157182849`", 
                "1.8497780843965295`"},
              {"6", \(-1.004619824258187`\), \(-5.0760679100269535`\), 
                "56.97091097266011`", "1.4958559061959606`", 
                "18.717604113663896`", 
                "172.92306344888001`", \(-4.007195004115786`\), 
                "2.3074574330407156`", "2.870059831241311`"},
              {"7", \(-6.493037717503262`\), 
                "17.461220956093005`", \(-8.103976558392382`\), \
\(-7.9992723201838665`\), "2.1086247836909564`", \(-4.007195004115779`\), 
                "1004.2542259649437`", 
                "18.63350076722955`", \(-3.139537839848887`\)},
              {"8", \(-57.74640961266046`\), "109.98457890401708`", 
                "1.1058363830163618`", \(-3.1645696714364924`\), 
                "4.82781515718285`", "2.307457433040714`", 
                "18.633500767229513`", "175.4230154038412`", 
                "0.26708564687146863`"},
              {
                "9", \(-3.952322964877392`\), \(-45.60584731001415`\), \
\(-1.0173838737598473`\), "108.30666366067608`", "1.849778084396533`", 
                "2.870059831241316`", \(-3.1395378398488942`\), 
                "0.2670856468714651`", "99.3703944069959`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]2.3217134031161605`*^-7\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 2.3217134031161605*^-07, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("-----------------------------------------------------------------"\)], \
"Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS: Iteration = "\[InvisibleSpace]14\),
      SequenceForm[ "BFGS: Iteration = ", 14],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592815243000\"\>",
            2891.7725928152431,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU  ", 
        PaddedForm[ 2891.7725928152431, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox["\<\"  2891.772592813899000\"\>",
            2891.7725928138989,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKALT  ", 
        PaddedForm[ 2891.7725928138989, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"LIKNEU - LIKALT  \"\>", "\[InvisibleSpace]", 
        TagBox[
          InterpretationBox[\("     1.344233169220388"\[Times]10\^"-9"\),
            1.3442331692203879*^-09,
            AutoDelete->True],
          (PaddedForm[ #, {20, 15}]&)]}],
      SequenceForm[ "LIKNEU - LIKALT  ", 
        PaddedForm[ 1.3442331692203879*^-09, {20, 15}]],
      Editable->False]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    TagBox[
      TagBox[GridBox[{
            {"\<\"\"\>", "\<\"THETA1\"\>", "\<\"THETA\"\>", "\<\"STEP\"\>", "\
\<\"SCORE\"\>"},
            {
              InterpretationBox["\<\" 1.0000\"\>",
                1,
                Editable->False], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.328248262848614,
                AutoDelete->True], 
              InterpretationBox["\<\" 16.3280\"\>",
                16.328236601019487,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                1.166182912785147*^-05,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                1.495205091435021*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 2.0000\"\>",
                2,
                Editable->False], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952191241974827,
                AutoDelete->True], 
              InterpretationBox["\<\" 4.0952\"\>",
                4.0952186428750581,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0001\"\>",
                -0.00014904004296862187,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 3.0000\"\>",
                3,
                Editable->False], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.124737658673455,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.1247\"\>",
                1.1247373716127844,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0001\"\>",
                -5.4266140514634466*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 4.0000\"\>",
                4,
                Editable->False], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091812732103378,
                AutoDelete->True], 
              InterpretationBox["\<\" 2.0092\"\>",
                2.0091806507492538,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0001\"\>",
                9.113439783611156*^-05,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 5.0000\"\>",
                5,
                Editable->False], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011149746098419873,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0111\"\>",
                0.011149015608373686,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0004\"\>",
                0.000396728515625,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 6.0000\"\>",
                6,
                Editable->False], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.0027835901090260099,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0028\"\>",
                -0.002785221153950915,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0003\"\>",
                0.00030517578125,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 7.0000\"\>",
                7,
                Editable->False], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172683482563627,
                AutoDelete->True], 
              InterpretationBox["\<\" 1.0173\"\>",
                1.0172690210023767,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\"-0.0007\"\>",
                -0.00065998934882381655,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 8.0000\"\>",
                8,
                Editable->False], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.057975144478137577,
                AutoDelete->True], 
              InterpretationBox["\<\"-0.0580\"\>",
                -0.057979766212023442,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0002\"\>",
                0.00018310546875,
                AutoDelete->True]},
            {
              InterpretationBox["\<\" 9.0000\"\>",
                9,
                Editable->False], 
              InterpretationBox["\<\" 0.9390\"\>",
                0.93896463800869834,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.9390\"\>",
                0.93896274645433997,
                AutoDelete->True], 
              InterpretationBox["\<\" 0.0000\"\>",
                0,
                Editable->False], 
              InterpretationBox["\<\" 0.0002\"\>",
                0.00018310546875,
                AutoDelete->True]}
            },
          RowSpacings->0,
          ColumnSpacings->2,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        Function[ BoxForm`e$, 
          TableForm[ 
          BoxForm`e$, TableHeadings -> {Automatic, {"THETA1", "THETA", "STEP",
             "SCORE"}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
            2}]]],
      (PaddedForm[ #, {5, 4}]&)]], "Print"],

Cell[BoxData[
    \("F"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", 
                "30.423250362096045`", \(-45.51008088711035`\), \
\(-18.98413990902354`\), \(-58.27956820057214`\), \(-1.062158561148006`\), \
\(-1.4887673241138728`\), \(-5.271353520478792`\), \(-58.13540933229298`\), \
\(-4.156929888625421`\)},
              {"2", \(-45.51008088711036`\), 
                "309.6776746381673`", \(-6.114351663311162`\), \
\(-289.9751903191941`\), "2.830575089635282`", \(-3.4755472338526046`\), 
                "14.169881477782496`", 
                "110.8489802562293`", \(-44.56192013972644`\)},
              {"3", \(-18.98413990902354`\), \(-6.114351663311175`\), 
                "293.8731319001626`", "2.7364608905138788`", 
                "0.4091476641219298`", 
                "54.95576033854179`", \(-2.1449101997670983`\), \
\(-1.0063399526737697`\), \(-1.4391685496808346`\)},
              {"4", \(-58.27956820057216`\), \(-289.97519031919404`\), 
                "2.7364608905138965`", "1116.844090225986`", 
                "1.2813148643988197`", 
                "3.1377577386118185`", \(-13.206624997582814`\), \
\(-1.2450396700451032`\), "108.4772093071506`"},
              {"5", \(-1.0621585611480056`\), "2.83057508963528`", 
                "0.40914766412192094`", "1.2813148643988312`", 
                "495.8780237865377`", "16.65313106400715`", 
                "4.819811296422516`", 
                "4.578271865432191`", \(-0.2512333939481799`\)},
              {"6", \(-1.4887673241138728`\), \(-3.4755472338526108`\), 
                "54.955760338541765`", "3.137757738611808`", 
                "16.653131064007127`", 
                "171.5043020469376`", \(-2.388088597407007`\), 
                "2.273652578364164`", "1.3061525403163126`"},
              {"7", \(-5.271353520478799`\), 
                "14.169881477782504`", \(-2.144910199767013`\), \
\(-13.206624997582786`\), "4.81981129642252`", \(-2.388088597407`\), 
                "1004.7452822171085`", 
                "17.35281421350283`", \(-0.20466082855265455`\)},
              {"8", \(-58.13540933229298`\), 
                "110.8489802562293`", \(-1.0063399526737538`\), \
\(-1.245039670045088`\), "4.578271865432192`", "2.273652578364162`", 
                "17.352814213502793`", 
                "176.16637841924236`", \(-0.41893987001244204`\)},
              {
                "9", \(-4.156929888625418`\), \(-44.56192013972644`\), \
\(-1.4391685496808364`\), "108.47720930715059`", \(-0.25123339394817634`\), 
                "1.3061525403163214`", \(-0.2046608285526621`\), \
\(-0.41893987001244737`\), "98.21207974626611`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("relgrad = "\[InvisibleSpace]4.2212970965728745`*^-8\
\[InvisibleSpace]" = Elastizitaet(d l/l)/(d theta/theta)"\),
      SequenceForm[ 
      "relgrad = ", 4.2212970965728745*^-08, 
        " = Elastizitaet(d l/l)/(d theta/theta)"],
      Editable->False]], "Print"],

Cell[BoxData[
    \("ReturnCode = 1"\)], "Print"],

Cell[BoxData[
    \("ReturnCode = 2"\)], "Print"],

Cell[BoxData[
    \("ReturnCode = 3"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("BFGS:  ENDE DER ITERATION  "\[InvisibleSpace]14\
\[InvisibleSpace]"  "\[InvisibleSpace]300\),
      SequenceForm[ "BFGS:  ENDE DER ITERATION  ", 14, "  ", 300],
      Editable->False]], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"SCORE\"\>"},
          {"1", \(-7.4760201177088`*^-6\)},
          {"2", \(-7.452001272576681`*^-6\)},
          {"3", \(-0.0000271330633322914`\)},
          {"4", "0.`"},
          {"5", "0.000030517578125`"},
          {"6", "0.000030517578125`"},
          {"7", \(-0.000029999535695088036`\)},
          {"8", "0.000030517578125`"},
          {"9", \(-0.000030517578125`\)}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"SCORE"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    \("F"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", 
                "30.53812938619136`", \(-45.917121041350974`\), \
\(-18.912474617599997`\), \(-57.9896451919502`\), \(-0.07483248104992368`\), \
\(-0.7926950935808956`\), \(-7.100847399339278`\), \(-57.82767556784681`\), \
\(-3.2996482548111716`\)},
              {"2", \(-45.91712104135099`\), 
                "309.07564477218915`", \(-7.72159171180372`\), \
\(-289.8660710879397`\), "5.040238934829517`", \(-1.375503512688824`\), 
                "11.674449775803623`", 
                "112.80286381201914`", \(-46.077323199394456`\)},
              {"3", \(-18.912474617599997`\), \(-7.721591711803733`\), 
                "293.02193339412173`", "3.669614842580268`", 
                "4.803793104581597`", 
                "58.41296834667047`", \(-9.229523815727719`\), 
                "1.2009514790135838`", "0.10328974795578372`"},
              {"4", \(-57.98964519195022`\), \(-289.86607108793964`\), 
                "3.6696148425802857`", "1116.94407893975`", 
                "0.6000696692230396`", 
                "2.3560648489421085`", \(-12.833171326790396`\), \
\(-2.160662819040053`\), "109.79462323412126`"},
              {"5", \(-0.07483248104992324`\), "5.040238934829519`", 
                "4.803793104581589`", "0.6000696692230512`", 
                "488.42583546121523`", "9.88531507096624`", 
                "14.163758760673021`", \(-1.2770476845666874`\), 
                "2.8665968269245283`"},
              {"6", \(-0.7926950935808952`\), \(-1.3755035126888302`\), 
                "58.41296834667044`", "2.3560648489420997`", 
                "9.885315070966215`", "165.52176716827302`", 
                "6.580690922189772`", \(-2.6618408144653323`\), 
                "3.1005214756405026`"},
              {"7", \(-7.100847399339285`\), 
                "11.674449775803623`", \(-9.229523815727633`\), \
\(-12.833171326790367`\), "14.16375876067301`", "6.580690922189794`", 
                "994.4535538873154`", 
                "25.821369806894705`", \(-7.172544643329687`\)},
              {"8", \(-57.82767556784681`\), "112.80286381201914`", 
                "1.2009514790136002`", \(-2.160662819040038`\), \
\(-1.277047684566683`\), \(-2.6618408144653376`\), "25.82136980689467`", 
                "172.4573199026387`", \(-0.3891859820862851`\)},
              {"9", \(-3.2996482548111685`\), \(-46.07732319939445`\), 
                "0.10328974795578238`", "109.79462323412125`", 
                "2.8665968269245283`", 
                "3.100521475640508`", \(-7.172544643329687`\), \
\(-0.3891859820862922`\), "103.47617100053402`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"Likelihood\"\>", "\<\"THETA\"\>", "\<\"\"\>", "\<\
\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
          {"1", "2887.7236043713524`", "16", "4", "1", "2", "0", "0", "1", 
            "0", "1"},
          {"2", "2889.749803058627`", "16.005924045342812`", 
            "4.008378614186083`", "1.0284798268972553`", "1.9609375`", 
            "0.005416369142272039`", "0.005492954198542812`", 
            "1.0169825212680526`", \(-0.017390915602188743`\), 
            "0.9898232899597638`"},
          {"3", "2890.8205230574868`", "16.012511305691792`", 
            "4.002413866285318`", "1.0675423268972553`", 
            "1.9693948662502174`", "0.010594761159039894`", 
            "0.011591023430867316`", 
            "1.0179550424350348`", \(-0.04561790295504407`\), 
            "0.9803509745924487`"},
          {"4", "2890.913622028648`", "16.02092112482501`", 
            "4.024868235843199`", "1.0741460123305808`", 
            "1.9695737460811247`", "0.002615981896916194`", 
            "0.0013249922630407859`", 
            "0.9911984502721948`", \(-0.07576315709063984`\), 
            "0.9590658435254827`"},
          {"5", "2891.1446116486877`", "16.032007608474412`", 
            "4.060323625062779`", "1.0685992654502745`", 
            "1.9863950669317847`", \(-0.005187826914185697`\), \
\(-0.01700265082362238`\), "1.0020581425710153`", \(-0.11424695300862958`\), 
            "0.9297289668488691`"},
          {"6", "2891.1619080422124`", "16.036081510890238`", 
            "4.0690888165707575`", "1.0663801671173636`", 
            "1.9896289026644483`", 
            "0.007774707280243655`", \(-0.01503755521135783`\), 
            "1.0012617974596063`", \(-0.11758516344185517`\), 
            "0.9262031089045706`"},
          {"7", "2891.187317351246`", "16.052103637073838`", 
            "4.078043406025022`", "1.06570149237273`", "1.9929050173184553`", 
            "0.005279308257065209`", \(-0.0006768814640577287`\), 
            "1.0016658825143565`", \(-0.11690286320468403`\), 
            "0.9283336587133851`"},
          {"8", "2891.2477659518736`", "16.09857522552117`", 
            "4.0789758713851265`", "1.0638777714411005`", 
            "1.9942409206284815`", "0.0064205731213242065`", 
            "0.0018231202512645228`", 
            "1.0025759519097186`", \(-0.1160505119804599`\), 
            "0.9352595359161086`"},
          {"9", "2891.480890796199`", "16.25482522552117`", 
            "4.105723869087713`", "1.0887174751688657`", 
            "2.0078054336159963`", 
            "0.007002016897556837`", \(-0.008884066190966473`\), 
            "1.0058326765656687`", \(-0.076296707603555`\), 
            "0.9520332110993072`"},
          {"10", "2891.555724894612`", "16.32751828095371`", 
            "4.100231945722228`", "1.0951042956846715`", 
            "2.0130605480182684`", 
            "0.007124602142114955`", \(-0.0038670150317943438`\), 
            "1.0077409959575525`", \(-0.046330789770475805`\), 
            "0.9191470948941155`"},
          {"11", "2891.6948421961156`", "16.222594967617123`", 
            "4.074472397753939`", "1.132288336938932`", "1.996790110173204`", 
            "0.01316702154973838`", "0.00218713540581149`", 
            "1.0219044448545969`", \(-0.08944194275795003`\), 
            "0.9402544894375986`"},
          {"12", "2891.772427329953`", "16.33623226899317`", 
            "4.096626400501753`", "1.1251341132783275`", 
            "2.0100196699465975`", 
            "0.011039733162989696`", \(-0.0032199752252887685`\), 
            "1.017480499988364`", \(-0.05658065444134639`\), 
            "0.93934628391881`"},
          {"13", "2891.7725922671893`", "16.328043081824493`", 
            "4.095220154369909`", "1.1246923448173853`", "2.009184196478616`",
             "0.011140366816199525`", \(-0.0027856397480388456`\), 
            "1.0172681695475434`", \(-0.0580332063814073`\), 
            "0.9389028770304367`"},
          {"14", "2891.772592813899`", "16.328236601019487`", 
            "4.095218642875058`", "1.1247373716127844`", "2.009180650749254`",
             "0.011149015608373686`", \(-0.002785221153950915`\), 
            "1.0172690210023767`", \(-0.05797976621202344`\), 
            "0.93896274645434`"},
          {"15", "2891.772592815243`", "16.328248262848614`", 
            "4.095219124197483`", "1.124737658673455`", "2.009181273210338`", 
            "0.011149746098419873`", \(-0.00278359010902601`\), 
            "1.0172683482563627`", \(-0.05797514447813758`\), 
            "0.9389646380086983`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"Likelihood", "THETA"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    InterpretationBox[\("INK: "\[InvisibleSpace]{0.0000988749636430505`, 
          0.000024798412879148014`, 6.810797662988637`*^-6, 
          0.000012166505686526865`, 6.055454452393343`*^-6, 
          6.055454452393343`*^-6, 6.160022148727813`*^-6, 
          6.055454452393343`*^-6, 6.055454452393343`*^-6}\),
      SequenceForm[ 
      "INK: ", {9.8874963643050503*^-05, 2.4798412879148014*^-05, 
        6.8107976629886368*^-06, 1.2166505686526865*^-05, 
        6.0554544523933429*^-06, 6.0554544523933429*^-06, 
        6.1600221487278128*^-06, 6.0554544523933429*^-06, 
        6.0554544523933429*^-06}],
      Editable->False]], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("ML-Sch\[ADoubleDot]tzer, SCORE UND LIKELIHOOD"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{
        TagBox[
          RowBox[{"(", "\[NoBreak]", 
            TagBox[GridBox[{
                  {
                    StyleBox["\[Null]",
                      ShowStringCharacters->False], 
                    TagBox["\<\"THETA\"\>",
                      HoldForm], 
                    TagBox["\<\"SCORE\"\>",
                      HoldForm]},
                  {"1", "16.328248262848614`", \(-7.4760201177088`*^-6\)},
                  {"2", "4.095219124197483`", \(-7.452001272576681`*^-6\)},
                  {"3", "1.124737658673455`", \(-0.0000271330633322914`\)},
                  {"4", "2.009181273210338`", "0.`"},
                  {"5", "0.011149746098419873`", "0.000030517578125`"},
                  {"6", \(-0.00278359010902601`\), "0.000030517578125`"},
                  {"7", 
                    "1.0172683482563627`", \(-0.000029999535695088036`\)},
                  {"8", \(-0.05797514447813758`\), "0.000030517578125`"},
                  {"9", "0.9389646380086983`", \(-0.000030517578125`\)}
                  },
                RowSpacings->0,
                ColumnSpacings->1,
                ColumnAlignments->{Left},
                RowLines->{True, False},
                ColumnLines->{True, False}],
              {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
            "\[NoBreak]", ")"}],
          Function[ BoxForm`e$, 
            MatrixForm[ 
            BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "SCORE"}}]]], 
        "\[InvisibleSpace]", "\<\"   Likelihood = \"\>", "\[InvisibleSpace]", 
        "2891.772592815243`"}],
      SequenceForm[ 
        MatrixForm[ {{16.328248262848614, -7.4760201177087998*^-06}, {
          4.0952191241974827, -7.4520012725766807*^-06}, {
          1.124737658673455, -2.71330633322914*^-05}, {2.0091812732103378, 
          0.0}, {0.011149746098419873, 
          3.0517578125*^-05}, {-0.0027835901090260099, 3.0517578125*^-05}, {
          
          1.0172683482563627, -2.9999535695088036*^-05}, \
{-0.057975144478137577, 3.0517578125*^-05}, {
          0.93896463800869834, -3.0517578125*^-05}}, TableHeadings -> {
          Automatic, {"THETA", "SCORE"}}], "   Likelihood = ", 
        2891.7725928152431],
      Editable->False]], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("WALD-TEST:"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"CHI \"\>", "\<\"U \"\>", "\<\"PROB \"\>", \
"\<\"ALPHA \"\>"},
          {"1", "3711.49250789778`", "9", "0", "0.05`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"CHI ", "U ", "PROB ", 
          "ALPHA "}}, TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    \("NULLHYPOTHESE THETA = 0 ABLEHNEN"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("BONFERRONI-KONFIDENZINTERVALLE:"\)], "Print"],

Cell[BoxData[
    \("------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("P{THETA AUS [THDACH-GRENZE,THDACH+GRENZE] } >= 1-ALPHA"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("QUANTIL Z(1-ALPHA/2U) = \
"\[InvisibleSpace]2.7729212946086634`\),
      SequenceForm[ "QUANTIL Z(1-ALPHA/2U) = ", 2.7729212946086634],
      Editable->False]], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"THETA\"\>", "\<\"GRENZE\"\>", "\<\"STD\"\>"},
          {"1", "16.328248262848614`", "1.5479403113108712`", 
            "0.5582344923819155`"},
          {"2", "4.095219124197483`", "0.3181926460374108`", 
            "0.11474997384746063`"},
          {"3", "1.124737658673455`", "0.2014288574125603`", 
            "0.07264139007630491`"},
          {"4", "2.009181273210338`", "0.1733578053177245`", 
            "0.062518112452301`"},
          {"5", "0.011149746098419873`", "0.12615067402541374`", 
            "0.04549378097051872`"},
          {"6", \(-0.00278359010902601`\), "0.22339392430361033`", 
            "0.08056266318771858`"},
          {"7", "1.0172683482563627`", "0.08920122551425803`", 
            "0.032168682785079485`"},
          {"8", \(-0.05797514447813758`\), "0.4498448650897824`", 
            "0.16222777976584007`"},
          {"9", "0.9389646380086983`", "0.29952545504843714`", 
            "0.10801801537995276`"}
          },
        RowSpacings->0,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {Automatic, {"THETA", "GRENZE", "STD"}}, 
          TableDirections -> {Column, Row}, TableSpacing -> {0, 
          2}]]]], "Print"],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("Korrelation der ML-Sch\[ADoubleDot]tzer"\)], "Print"],

Cell[BoxData[
    \("-------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", "1.`", "0.726601759791422`", "0.5447885410506044`", 
                "0.8048765933400118`", \(-0.000025692022568190017`\), \
\(-0.1018118050800252`\), "0.000028189605094906266`", "0.8226704221176032`", 
                "0.06642959716542557`"},
              {"2", "0.7266017597914215`", "1.`", "0.4087208004119727`", 
                "0.7954374928001502`", \(-0.00001454035742208766`\), \
\(-0.056305778018282744`\), "0.00001156599954891961`", "0.3852401661029829`", 
                "0.13711283747024935`"},
              {"3", "0.5447885410506007`", "0.4087208004119704`", "1.`", 
                "0.4442289268709824`", \(-0.000024521277582179726`\), \
\(-0.2699686845117271`\), "0.000013613452920060143`", "0.44238056745674187`", 
                "0.03862919349353711`"},
              {"4", "0.804876593340009`", "0.7954374928001485`", 
                "0.44422892687098353`", 
                "1.0000000000000002`", \(-0.000017422870512794844`\), \
\(-0.07406071929241506`\), "0.000010886866656751798`", 
                "0.5673348315946423`", \(-0.0741088058185785`\)},
              {
                "5", \(-0.000025692022568061326`\), \
\(-0.000014540357422201151`\), \(-0.000024521277582383167`\), \
\(-0.000017422870512788864`\), 
                "1.0000000000000002`", \(-0.03216437716513216`\), \
\(-8.888166101173032`*^-6\), \(-0.00002869021995327645`\), \
\(-0.000015109969528096734`\)},
              {
                "6", \(-0.10181180508002498`\), \(-0.056305778018282675`\), \
\(-0.26996868451172734`\), \(-0.07406071929241527`\), \(-0.032164377165132`\),
                 "0.9999999999999998`", 
                "3.981071743326076`*^-6", \(-0.09169454676067886`\), \
\(-0.0034417877804888085`\)},
              {"7", "0.000028189605096743853`", "0.000011565999550297598`", 
                "0.00001361345292097001`", 
                "0.000010886866658306349`", \(-8.88816610122464`*^-6\), 
                "3.981071743542535`*^-6", 
                "1.0000000000000002`", \(-0.011265271343217536`\), 
                "0.00003345460825622305`"},
              {"8", "0.8226704221176017`", "0.38524016610298206`", 
                "0.44238056745674426`", 
                "0.5673348315946434`", \(-0.00002869021995353604`\), \
\(-0.0916945467606789`\), \(-0.011265271343219014`\), "0.9999999999999999`", 
                "0.01463920300860867`"},
              {"9", "0.06642959716542342`", "0.13711283747024733`", 
                "0.03862919349353628`", \(-0.07410880581858023`\), \
\(-0.000015109969528093106`\), \(-0.0034417877804889955`\), 
                "0.00003345460825634116`", "0.014639203008607209`", 
                "1.0000000000000002`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE KOVARIANZMATRIX UND EIGENWERTE"\)], \
"Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", "0.3116257484848948`", "0.04654421477323601`", 
                "0.022091681728811423`", 
                "0.02809000538578465`", \(-6.524796851383203`*^-7\), \
\(-0.004578767790434733`\), "5.062195779467521`*^-7", "0.07450197315338054`", 
                "0.004005663654503295`"},
              {"2", "0.046544214773235976`", "0.013167556497992899`", 
                "0.00340693212768407`", 
                "0.005706430208518359`", \(-7.590662985750963`*^-8\), \
\(-0.0005205223399619046`\), "4.269421614384336`*^-8", 
                "0.007171489736051535`", "0.0016995224559818488`"},
              {"3", "0.022091681728811277`", "0.0034069321276840514`", 
                "0.005276771552217889`", 
                "0.0020174224005915574`", \(-8.103623818922327`*^-8\), \
\(-0.0015799063734008782`\), "3.18116150336784`*^-8", "0.005213212311293271`",
                 "0.0003031070103598696`"},
              {"4", "0.028090005385784548`", "0.005706430208518347`", 
                "0.0020174224005915626`", 
                "0.0039085143845985545`", \(-4.955387245058555`*^-8\), \
\(-0.00037301611745518696`\), "2.1894853273774834`*^-8", 
                "0.0057540089063764345`", \(-0.0005004628746594569`\)},
              {
                "5", \(-6.52479685135052`*^-7\), \(-7.59066298581021`*^-8\), \
\(-8.103623818989559`*^-8\), \(-4.955387245056854`*^-8\), 
                "0.0020696841069935312`", \(-0.0001178856636839915`\), \
\(-1.300760896254791`*^-8\), \(-2.1174401057850064`*^-7\), \
\(-7.425262551762718`*^-8\)},
              {
                "6", \(-0.004578767790434723`\), \(-0.0005205223399619039`\), \
\(-0.0015799063734008795`\), \(-0.000373016117455188`\), \
\(-0.00011788566368399093`\), "0.006490342699897786`", 
                "1.0317324654883612`*^-8", \(-0.0011984020605325418`\), \
\(-0.000029951190987259548`\)},
              {"7", "5.062195779797508`*^-7", "4.2694216148930006`*^-8", 
                "3.181161503580456`*^-8", 
                "2.1894853276901233`*^-8", \(-1.3007608962623436`*^-8\), 
                "1.0317324655444586`*^-8", 
                "0.0010348241521270693`", \(-0.00005878955320107632`\), 
                "1.1624798149891665`*^-7"},
              {"8", "0.0745019731533804`", "0.00717148973605152`", 
                "0.0052132123112932985`", 
                "0.005754008906376446`", \(-2.1174401058041652`*^-7\), \
\(-0.0011984020605325422`\), \(-0.00005878955320108404`\), 
                "0.026317852527753913`", "0.0002565304078386776`"},
              {"9", "0.004005663654503165`", "0.0016995224559818239`", 
                "0.0003031070103598631`", \(-0.0005004628746594685`\), \
\(-7.425262551760935`*^-8\), \(-0.000029951190987261174`\), 
                "1.1624798149932707`*^-7", "0.000256530407838652`", 
                "0.01166789164662371`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \({0.000817885834211318`, 0.001034047975713506`, 0.002065573878335809`, 
      0.0031503245573329232`, 0.0032049980240141753`, 0.006907634136186958`, 
      0.010634154652143835`, 0.012789993455299705`, 
      0.3409545735398505`}\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("GESCH\[CapitalADoubleDot]TZTE FISHER-INFORMATIONS-MATRIX UND \
EIGENWERTE"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3", "4", "5", "6", 
                "7", "8", "9"},
              {"1", 
                "29.79979320973503`", \(-44.19091201873693`\), \
\(-18.67731683259087`\), \(-58.47908529931684`\), \(-0.04348230821855161`\), \
\(-0.7589466635351564`\), \(-3.182108712406772`\), \(-55.82862544556761`\), \
\(-4.591276038098594`\)},
              {"2", \(-44.19091201873693`\), 
                "307.22779708145214`", \(-6.477371520110542`\), \
\(-290.3428370037089`\), \(-0.3066158359705222`\), \(-5.3737264289352265`\), 
                "6.061709436058651`", 
                "106.34194267595909`", \(-44.2162747753639`\)},
              {"3", \(-18.67731683259087`\), \(-6.477371520110542`\), 
                "288.8555168431068`", "0.001371975464070814`", 
                "3.2334301115958617`", "56.67737129115304`", "0", 
                "0", \(-0.0027565474097151423`\)},
              {"4", \(-58.47908529931684`\), \(-290.3428370037089`\), 
                "0.001371975464070814`", "1114.1403534701817`", 
                "0.001543112471216434`", "0", 
                "0.004550753418784892`", \(-0.001543112471216434`\), 
                "110.15508375778515`"},
              {"5", \(-0.04348230821855161`\), \(-0.3066158359705222`\), 
                "3.2334301115958617`", "0.001543112471216434`", 
                "483.70776391175457`", "9.518205526449934`", 
                "0.006095525698680351`", "0.003100392679625386`", 
                "0.003100392679625386`"},
              {"6", \(-0.7589466635351564`\), \(-5.3737264289352265`\), 
                "56.67737129115304`", "0", "9.518205526449934`", 
                "167.07706111233242`", \(-0.0030477628493401753`\), \
\(-0.006200785359250772`\), "0"},
              {"7", \(-3.182108712406772`\), "6.061709436058651`", "0", 
                "0.004550753418784892`", 
                "0.006095525698680351`", \(-0.0030477628493401753`\), 
                "966.8896309182958`", 
                "9.515115615640028`", \(-0.009143288548020526`\)},
              {"8", \(-55.82862544556761`\), "106.34194267595909`", 
                "0", \(-0.001543112471216434`\), 
                "0.003100392679625386`", \(-0.006200785359250772`\), 
                "9.515115615640028`", "167.08326189769167`", 
                "0.003100392679625386`"},
              {
                "9", \(-4.591276038098594`\), \(-44.2162747753639`\), \
\(-0.0027565474097151423`\), "110.15508375778515`", "0.003100392679625386`", 
                "0", \(-0.009143288548020526`\), "0.003100392679625386`", 
                "98.44676875614488`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Print"],

Cell[BoxData[
    \(\*"\<\"\"\>"\)], "Print"],

Cell[BoxData[
    \({1222.6645311252926`, 967.0731179662989`, 484.1269588506221`, 
      317.427611600312`, 312.01267286509164`, 144.76736611762766`, 
      94.0366237572444`, 78.18612288543717`, 2.9329420327694207`}\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    \("KOMPENSIERTE LIKELIHOOD"\)], "Print"],

Cell[BoxData[
    \("--------------------------------------------------------"\)], "Print"],

Cell[BoxData[
    InterpretationBox[\("U =  "\[InvisibleSpace]9\[InvisibleSpace]"  Nue = "\
\[InvisibleSpace]3000\),
      SequenceForm[ "U =  ", 9, "  Nue = ", 3000],
      Editable->False]], "Print"],

Cell[BoxData[
    \("AKAIKE (AIC) SCHWARZ/RISSANEN (SIC/RISS) AZENCOTT/DACUNHA-CASTELLE \
(A/D)"\)], "Print"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\"\>", "\<\"LIK\"\>", "\<\"AIC\"\>", "\<\"SIC/RISS\"\>", \
"\<\"A/D\"\>"},
          {"\<\"Kompensator\"\>", "0", "9", "36.028654054426106`", 
            "93.70428336945712`"},
          {"\<\"komp. Lik.\"\>", "2891.772592815243`", "2882.772592815243`", 
            "2855.743938760817`", "2798.068309445786`"}
          },
        RowSpacings->1,
        ColumnSpacings->2,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      Function[ BoxForm`e$, 
        TableForm[ 
        BoxForm`e$, TableHeadings -> {{"Kompensator", "komp. Lik."}, {"LIK", 
          "AIC", "SIC/RISS", "A/D"}}, TableDirections -> {Column, Row}, 
          TableSpacing -> {1, 2}]]]], "Print"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Sigma[THETA]\)], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{1.0348348923642283`, \(-0.058976279463199`\)}, {\(-0.058976279463199`\
\), 0.8850157088080669`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(std = \@VecDiag[COV];\)\), "\n", 
    \(MatrixForm[Transpose[{Theta, THETA, std}]]\)}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3"},
              {"1", "16", "16.328248262848614`", "0.5582344923819155`"},
              {"2", "4", "4.095219124197483`", "0.11474997384746063`"},
              {"3", "1", "1.124737658673455`", "0.07264139007630491`"},
              {"4", "2", "2.009181273210338`", "0.062518112452301`"},
              {"5", "0", "0.011149746098419873`", "0.04549378097051872`"},
              {"6", "0", \(-0.00278359010902601`\), "0.08056266318771858`"},
              {"7", "1", "1.0172683482563627`", "0.032168682785079485`"},
              {"8", "0", \(-0.05797514447813758`\), "0.16222777976584007`"},
              {"9", "1", "0.9389646380086983`", "0.10801801537995276`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell[BoxData[
    RowBox[{"mit", " ", 
      RowBox[{
        StyleBox["Pseudoinverser",
          FontColor->RGBColor[1, 0, 0]], ":"}]}]], "Input",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(std = \@VecDiag[COV];\)\), "\n", 
    \(MatrixForm[Transpose[{Theta, THETA, std}]]\)}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", 
        TagBox[GridBox[{
              {
                StyleBox["\[Null]",
                  ShowStringCharacters->False], "1", "2", "3"},
              {"1", "16", "16.32824940642994`", "0.5581661466537567`"},
              {"2", "4", "4.095218903509878`", "0.11475139578698118`"},
              {"3", "1", "1.1247375764249103`", "0.0726397399510191`"},
              {"4", "2", "2.0091813449234825`", "0.06251102725406399`"},
              {"5", "0", "0.011149759577202175`", "0.04549350569895188`"},
              {"6", "0", \(-0.0027833872723627803`\), 
                "0.08056225515947472`"},
              {"7", "1", "1.0172683355716772`", "0.032168757089771155`"},
              {"8", "0", \(-0.057974508145981735`\), "0.16219276789209916`"},
              {"9", "1", "0.9389640453965162`", "0.10800799970507788`"}
              },
            RowSpacings->0,
            ColumnSpacings->1,
            ColumnAlignments->{Left},
            RowLines->{True, False},
            ColumnLines->{True, False}],
          {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}], 
        "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output"]
}, Open  ]],

Cell["OS X/PPC", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Sigma[THETA]\)], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({{1.0348349132682533`, \(-0.05897556275003073`\)}, \
{\(-0.05897556275003073`\), 0.8850158773678912`}}\)], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(std = \@VecDiag[COV];\)\), "\n", 
    \(MatrixForm[Transpose[{Theta, THETA, std}]]\)}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"16", "16.32825050791772`", "0.5582299017773841`"},
            {"4", "4.095219440142075`", "0.11474849733412715`"},
            {"1", "1.124737705756985`", "0.07264280802039912`"},
            {"2", "2.009181464643148`", "0.06251738777274213`"},
            {"0", "0.011149796846916702`", "0.04549381330459913`"},
            {"0", \(-0.0027834956511216457`\), "0.08056141306887082`"},
            {"1", "1.0172683585309499`", "0.03216894414753807`"},
            {"0", \(-0.05797443934577704`\), "0.16222937309275545`"},
            {"1", "0.9389647713042455`", "0.10801735469983996`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[BoxData[
    RowBox[{"mit", " ", 
      RowBox[{
        StyleBox["Pseudoinverser",
          FontColor->RGBColor[1, 0, 0]], ":"}]}]], "Input",
  PageWidth->Infinity,
  Evaluatable->False,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(std = \@VecDiag[COV];\)\), "\n", 
    \(MatrixForm[Transpose[{Theta, THETA, std}]]\)}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(std\\)\\\" is similar to existing symbol \
\\\"\\!\\(STD\\)\\\". \\!\\(\\*ButtonBox[\\\"Mehr\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"16", "16.328256410826775`", "0.5580520816815017`"},
            {"4", "4.095219798771321`", "0.11474043944316567`"},
            {"1", "1.124738171649635`", "0.07263531891973782`"},
            {"2", "2.0091818388000156`", "0.06250959538403492`"},
            {"0", "0.011149743195313698`", "0.04549334215219288`"},
            {"0", \(-0.00278357499651658`\), "0.08056109517449425`"},
            {"1", "1.0172682523589731`", "0.032169046868725085`"},
            {"0", \(-0.05797206454432816`\), "0.16215280009355937`"},
            {"1", "0.9389651363112688`", "0.10801944880946947`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[TextData[StyleBox["Math 4.2 / OS 9",
  FontColor->RGBColor[0, 1, 0]]], "Text",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(std = \@VecDiag[COV];\)\), "\n", 
    \(MatrixForm[Transpose[{Theta, THETA, std}]]\)}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(std\)\" is similar to \
existing symbol \"\!\(STD\)\"."\)], "Message",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"16", "16.32825054060331`", "0.5581896949391372`"},
            {"4", "4.095219247109258`", "0.11474511778829839`"},
            {"1", "1.1247376781743257`", "0.07263789867702995`"},
            {"2", "2.009181443635449`", "0.06251502551746943`"},
            {"0", "0.011149856045382196`", "0.0454933587674308`"},
            {"0", \(-0.0027833823974440495`\), "0.0805605505752097`"},
            {"1", "1.0172683198477637`", "0.032168892884176674`"},
            {"0", \(-0.05797409742667775`\), "0.16221750701333326`"},
            {"1", "0.9389645688673384`", "0.108017499120469`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  PageWidth->Infinity]
}, Open  ]],

Cell[BoxData[
    RowBox[{"mit", " ", 
      RowBox[{
        StyleBox["Pseudoinverser",
          FontColor->RGBColor[1, 0, 0]], ":"}]}]], "Input",
  PageWidth->Infinity],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(std = \@VecDiag[COV];\)\), "\n", 
    \(MatrixForm[Transpose[{Theta, THETA, std}]]\)}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(std\)\" is similar to \
existing symbol \"\!\(STD\)\"."\)], "Message",
  PageWidth->Infinity],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"16", "16.32824662119773`", "0.5582256281542466`"},
            {"4", "4.095218621312162`", "0.1147505582961673`"},
            {"1", "1.1247374091497768`", "0.07263934584868048`"},
            {"2", "2.009181125284732`", "0.06251752581102019`"},
            {"0", "0.011149690572758589`", "0.04549334124079739`"},
            {"0", \(-0.0027835751608992518`\), "0.08055884992992401`"},
            {"1", "1.017268254868184`", "0.03216898513122606`"},
            {"0", \(-0.0579752739409705`\), "0.16222770211573703`"},
            {"1", "0.9389637794940406`", "0.10802530595603477`"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  PageWidth->Infinity]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Smoothing", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(Dimensions[Y]\), "\n", 
    \(Dimensions[X]\)}], "Input",
  PageWidth->Infinity,
  ImageRegion->{{-0, 1}, {0, 1}}],

Cell[BoxData[
    \({500, 6}\)], "Output"],

Cell[BoxData[
    \({500, 1}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(THETA\)], "Input"],

Cell[BoxData[
    \({16.328248262848614`, 4.095219124197483`, 1.124737658673455`, 
      2.009181273210338`, 0.011149746098419873`, \(-0.00278359010902601`\), 
      1.0172683482563627`, \(-0.05797514447813758`\), 
      0.9389646380086983`}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(\({{mueetay, sigmaetay}, {mueeta, sigmaeta}, {mueY, sigmaY}} = 
        NormalCorrelation[{Y, X}, 
          THETA, {SystemEDMdet, {Deltat, T}}];\)\(\[IndentingNewLine]\)
    \)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(mueeta // Dimensions\)], "Input"],

Cell[BoxData[
    \({500, 12}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(mueetay // Dimensions\)], "Input"],

Cell[BoxData[
    \({500, 12}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(stdetay = \(sigmaetay // VecDiag\) // Sqrt\)], "Input"],

Cell[BoxData[
    \({0.00009999999918033063`, 0.7886100619141443`, 0.00009999998427630007`, 
      0.6020662127598301`, 0.00009999998155118517`, 0.5817934695204557`, 
      0.00009999998137924763`, 0.5803021402865678`, 0.00009999998190993337`, 
      0.5847156451681433`, 0.00009999998253181638`, 
      0.632120023288967`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ETA // Dimensions\)], "Input"],

Cell[BoxData[
    \({500, 12}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(i = 1; \ z = 2;\), "\[IndentingNewLine]", 
    \(\(m = mueetay[\([i]\)];\)\[IndentingNewLine]\), "\[IndentingNewLine]", 
    \(KI = {ETA[\([i]\)], m, m + z\ stdetay, m - z\ stdetay}\)}], "Input"],

Cell[BoxData[
    \({{\(-1.5203141988405118`\), 
        0.8543262646541159`, \(-0.31508462946689264`\), 1.86846440833242`, 
        0.28738773583118765`, 1.0264645714011944`, 
        0.29925161414771473`, \(-0.32056098468341343`\), \
\(-0.3425376338951981`\), 0.32063040084810585`, 0.03873014921203064`, 
        0.2583291485552782`}, {\(-1.5204927552827214`\), \
\(-0.2629795152638196`\), \(-0.3148833722467675`\), 2.4831176505766224`, 
        0.287378564936811`, 0.4171207981312566`, 
        0.29926828810227424`, \(-0.9003076369009962`\), \
\(-0.34252194443963757`\), \(-0.34471748699576543`\), 0.03876188031738354`, 
        0.8311192565534895`}, {\(-1.5202927552843608`\), 
        1.314240608564469`, \(-0.3146833722782149`\), 3.6872500760962827`, 
        0.2875785648999134`, 1.580707737172168`, 0.29946828806503273`, 
        0.26029664367213934`, \(-0.3423219444758177`\), 0.8247138033405212`, 
        0.038961880282447174`, 
        2.0953593031314233`}, {\(-1.520692755281082`\), \
\(-1.8401996390921083`\), \(-0.31508337221532007`\), 1.2789852250569622`, 
        0.28717856497370864`, \(-0.7464661409096549`\), 
        0.29906828813951575`, \(-2.0609119174741317`\), \
\(-0.34272194440345743`\), \(-1.514148777332052`\), 
        0.03856188035231991`, \(-0.4331207900244445`\)}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(plot1[\(KI[\([All, {1, 3, 5, 7, 9, 11}]\)] // Transpose\) // 
        AddTimeAxis, color \[Rule] {10, 1, 2, 2}]\), "\[IndentingNewLine]", 
    \(plot1[\(KI[\([All, {1, 3, 5, 7, 9, 11} + 1]\)] // Transpose\) // 
        AddTimeAxis, color \[Rule] {10, 1, 2, 2}, 
      PlotLabel -> "\<True and smoothed trajectory (velocity)\>"]\)}], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.190476 0.506477 0.32338 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -3 -9 ]
[.21429 -0.0125 3 0 ]
[.40476 -0.0125 -3 -9 ]
[.40476 -0.0125 3 0 ]
[.59524 -0.0125 -3 -9 ]
[.59524 -0.0125 3 0 ]
[.78571 -0.0125 -3 -9 ]
[.78571 -0.0125 3 0 ]
[.97619 -0.0125 -3 -9 ]
[.97619 -0.0125 3 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .02141 -24 -4.5 ]
[-0.0125 .02141 0 4.5 ]
[-0.0125 .10225 -30 -4.5 ]
[-0.0125 .10225 0 4.5 ]
[-0.0125 .1831 -12 -4.5 ]
[-0.0125 .1831 0 4.5 ]
[-0.0125 .26394 -30 -4.5 ]
[-0.0125 .26394 0 4.5 ]
[-0.0125 .34479 -24 -4.5 ]
[-0.0125 .34479 0 4.5 ]
[-0.0125 .42563 -30 -4.5 ]
[-0.0125 .42563 0 4.5 ]
[-0.0125 .50648 -6 -4.5 ]
[-0.0125 .50648 0 4.5 ]
[-0.0125 .58732 -24 -4.5 ]
[-0.0125 .58732 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.97619 .519 -5 -6 ]
[.97619 .519 5 6 ]
[.97619 .51901 -5 -6 ]
[.97619 .51901 5 6 ]
[.97619 .51908 -5 -6 ]
[.97619 .51908 5 6 ]
[.97619 .51895 -5 -6 ]
[.97619 .51895 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .02141 m
.00625 .02141 L
s
[(-1.5)] -0.0125 .02141 1 0 Mshowa
0 .10225 m
.00625 .10225 L
s
[(-1.25)] -0.0125 .10225 1 0 Mshowa
0 .1831 m
.00625 .1831 L
s
[(-1)] -0.0125 .1831 1 0 Mshowa
0 .26394 m
.00625 .26394 L
s
[(-0.75)] -0.0125 .26394 1 0 Mshowa
0 .34479 m
.00625 .34479 L
s
[(-0.5)] -0.0125 .34479 1 0 Mshowa
0 .42563 m
.00625 .42563 L
s
[(-0.25)] -0.0125 .42563 1 0 Mshowa
0 .50648 m
.00625 .50648 L
s
[(0)] -0.0125 .50648 1 0 Mshowa
0 .58732 m
.00625 .58732 L
s
[(0.25)] -0.0125 .58732 1 0 Mshowa
.125 Mabswid
0 .03758 m
.00375 .03758 L
s
0 .05374 m
.00375 .05374 L
s
0 .06991 m
.00375 .06991 L
s
0 .08608 m
.00375 .08608 L
s
0 .11842 m
.00375 .11842 L
s
0 .13459 m
.00375 .13459 L
s
0 .15076 m
.00375 .15076 L
s
0 .16693 m
.00375 .16693 L
s
0 .19927 m
.00375 .19927 L
s
0 .21543 m
.00375 .21543 L
s
0 .2316 m
.00375 .2316 L
s
0 .24777 m
.00375 .24777 L
s
0 .28011 m
.00375 .28011 L
s
0 .29628 m
.00375 .29628 L
s
0 .31245 m
.00375 .31245 L
s
0 .32862 m
.00375 .32862 L
s
0 .36096 m
.00375 .36096 L
s
0 .37712 m
.00375 .37712 L
s
0 .39329 m
.00375 .39329 L
s
0 .40946 m
.00375 .40946 L
s
0 .4418 m
.00375 .4418 L
s
0 .45797 m
.00375 .45797 L
s
0 .47414 m
.00375 .47414 L
s
0 .49031 m
.00375 .49031 L
s
0 .52265 m
.00375 .52265 L
s
0 .53881 m
.00375 .53881 L
s
0 .55498 m
.00375 .55498 L
s
0 .57115 m
.00375 .57115 L
s
0 .00524 m
.00375 .00524 L
s
0 .60349 m
.00375 .60349 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .02141 m
1 .02141 L
s
.99375 .10225 m
1 .10225 L
s
.99375 .1831 m
1 .1831 L
s
.99375 .26394 m
1 .26394 L
s
.99375 .34479 m
1 .34479 L
s
.99375 .42563 m
1 .42563 L
s
.99375 .50648 m
1 .50648 L
s
.99375 .58732 m
1 .58732 L
s
.125 Mabswid
.99625 .03758 m
1 .03758 L
s
.99625 .05374 m
1 .05374 L
s
.99625 .06991 m
1 .06991 L
s
.99625 .08608 m
1 .08608 L
s
.99625 .11842 m
1 .11842 L
s
.99625 .13459 m
1 .13459 L
s
.99625 .15076 m
1 .15076 L
s
.99625 .16693 m
1 .16693 L
s
.99625 .19927 m
1 .19927 L
s
.99625 .21543 m
1 .21543 L
s
.99625 .2316 m
1 .2316 L
s
.99625 .24777 m
1 .24777 L
s
.99625 .28011 m
1 .28011 L
s
.99625 .29628 m
1 .29628 L
s
.99625 .31245 m
1 .31245 L
s
.99625 .32862 m
1 .32862 L
s
.99625 .36096 m
1 .36096 L
s
.99625 .37712 m
1 .37712 L
s
.99625 .39329 m
1 .39329 L
s
.99625 .40946 m
1 .40946 L
s
.99625 .4418 m
1 .4418 L
s
.99625 .45797 m
1 .45797 L
s
.99625 .47414 m
1 .47414 L
s
.99625 .49031 m
1 .49031 L
s
.99625 .52265 m
1 .52265 L
s
.99625 .53881 m
1 .53881 L
s
.99625 .55498 m
1 .55498 L
s
.99625 .57115 m
1 .57115 L
s
.99625 .00524 m
1 .00524 L
s
.99625 .60349 m
1 .60349 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
0 0 0 r
gsave
.97619 .519 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .01484 m
.21429 .40458 L
.40476 .59941 L
.59524 .60325 L
.78571 .39571 L
.97619 .519 L
s
.1 .1 .9 r
gsave
.97619 .51901 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.100 0.100 0.900 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01478 m
.21429 .40465 L
.40476 .59941 L
.59524 .60325 L
.78571 .39571 L
.97619 .51901 L
s
.1 .9 .8 r
gsave
.97619 .51908 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.100 0.900 0.800 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01484 m
.21429 .40471 L
.40476 .59947 L
.59524 .60332 L
.78571 .39578 L
.97619 .51908 L
s
gsave
.97619 .51895 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.100 0.900 0.800 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .01472 m
.21429 .40459 L
.40476 .59934 L
.59524 .60319 L
.78571 .39565 L
.97619 .51895 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`009_ooool2
o`0002gooooo0ol0000/ooooo`Go0000;Oooool3o`0002kooooo0ol0000/ooooo`?o00001oooool0
02Gooooo00Co0000oooooooooooo0000;Oooool00ol0003oooooooooo`0/ooooo`04o`000?oooooo
ooooo`0002cooooo00Go0000ooooooooooooooooo`00000^ooooo`03o`000?oooooooooo02[ooooo
00Go0000ooooooooooooooooo`000006ooooo`009Oooool01?l0003oooooooooool0000]ooooo`03
o`000?oooooooooo02gooooo00?o0000ooooooooool0<?ooool00ol0003oooooooooo`0Yooooo`Go
0000;oooool00ol0003oooooooooo`04ooooo`009Oooool01?l0003oooooooooool0000]ooooo`03
o`000?oooooooooo02kooooo00?o0000ooooooooool0;Oooool2o`0002cooooo00Co0000oooooooo
oooo0000<?ooool00ol0003oooooooooo`04ooooo`009Oooool01?l0003oooooooooool0000]oooo
o`03o`000?oooooooooo02_ooooo00Go0000ooooooooooooooooo`00000`ooooo`03o`000?oooooo
oooo02[ooooo00?o0000ooooool00000;?ooool4o`0000Oooooo000Uooooo`04o`000?oooooooooo
o`0002cooooo0_l0000]ooooo`05o`000?ooooooooooooooool00000;?ooool01Ol0003ooooooooo
oooooooo000002gooooo0_l0000/ooooo`03o`000?oooooooooo00Sooooo000Vooooo`;o0000;_oo
ool00ol0003oooooooooo`0/ooooo`?o0000;_ooool3o`0002oooooo00?o0000ooooooooool0:_oo
ool5o`0000Kooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo
000Qooooooko00000Oooool0027ooooo0_l00004ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool00_ooool2o`00007ooooo000Qooooo`03o`000?oooooooooo0?[ooooo0Ol00001oooo
o`003Oooool3o`0000Cooooo00?o0000ooooooooool00_ooool3o`0000Gooooo00?o0000oooooooo
ool00_ooool2oaWVc?Kooooo0Ol00001ooooo`003_ooool00ol0003oooooooooo`07ooooo`05o`00
0?ooooooooooooooool000001?ooool00ol0003oooooooooo`02ooooo`;o6NK<m_ooool1o`00007o
oooo0006ooooo`Go00000oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo00;ooooo
0_l00003ooooo`?o6NK<m?ooool2o`00007ooooo000>ooooo`03o`000?oooooooooo00_ooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`;o6NK<mOooool1o`00007ooooo000>
ooooo`03o`000?oooooooooo00Oooooo1?l00005ooooo`03o`000?oooooooooo00?ooooo0olIi/cd
ooooo`7o00000Oooool000gooooo0_l00009ooooo`03o`000?oooooooooo00Kooooo00?o0000oooo
ooooool01?ooool2oaWVc?Cooooo0Ol00001ooooo`003_ooool00ol0003oooooooooo`07ooooo`Go
00001?ooool2o`0000Gooooo0olIi/cbooooo`;o00000Oooool0027ooooo00?o0000ooooooooool0
1Oooool2oaWVc??ooooo0Ol00001ooooo`008Oooool00ol0003oooooooooo`05ooooo`?o6NK<l_oo
ool1o`00007ooooo000Qooooo`03o`000?oooooooooo00Kooooo0_lIi/cbooooo`7o00000Oooool0
027ooooo0_l00007ooooo`?o6NK<l?ooool2o`00007ooooo000Qooooo`03o`000?oooooooooo00Oo
oooo0_lIi/caooooo`7o00000Oooool0027ooooo00?o0000ooooooooool01oooool3oaWVc?3ooooo
0Ol00001ooooo`008Oooool00ol0003oooooooooo`08ooooo`;o6NK<l?ooool1o`00007ooooo000Q
ooooo`;o00002Oooool3oaWVc>kooooo0_l00001ooooo`008Oooool00ol0003oooooooooo`09oooo
o`;o6NK<koooool1o`00007ooooo000Qooooo`03o`000?oooooooooo00Wooooo0olIi/c^ooooo`7o
00000Oooool0027ooooo00?o0000ooooooooool02_ooool2oaWVc>kooooo0Ol00001ooooo`008Ooo
ool00ol0003oooooooooo`0:ooooo`;o6NK<k_ooool1o`00007ooooo000Qooooo`;o00002oooool3
oaWVc>cooooo0_l00001ooooo`001oooool3o`0000Cooooo00Co0000oooooooooooooooo1Ol00002
ooooo`?o00001Oooool00ol0003oooooooooo`0;ooooo`;o6NK<kOooool1o`00007ooooo0008oooo
o`03o`000?oooooooooo00Sooooo00Ko0000oooooooooooo0000ooooool00003ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool02oooool3oaWVc>cooooo0Ol00001ooooo`001Ol00003
ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo00cooooo0_lIi/c/ooooo`7o00000Oooool000Sooooo00?o0000oooo
ooooool02_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00;ooooo0_l0000=oooo
o`?o6NK<j_ooool2o`00007ooooo0008ooooo`03o`000?oooooooooo00Oooooo00Ko0000oooooooo
ooooooooo`000?ooool4o`0000Gooooo00?o0000ooooooooool03Oooool2oaWVc>_ooooo0Ol00001
ooooo`001oooool2o`0000Wooooo00Oo0000ooooooooooooooooo`000?oooooo000000Sooooo00?o
0000ooooooooool03Oooool3oaWVc>[ooooo0Ol00001ooooo`002?ooool00ol0003oooooooooo`08
ooooo`?o00000_ooool5o`0000Cooooo00?o0000ooooooooool03_ooool2oaWVc>[ooooo0Ol00001
ooooo`008Oooool2o`0000oooooo0olIi/cXooooo`;o00000Oooool0027ooooo00?o0000oooooooo
ool03oooool2oaWVc>Wooooo0Ol00001ooooo`008Oooool00ol0003oooooooooo`0?ooooo`?o6NK<
j?ooool1o`00007ooooo000Qooooo`03o`000?oooooooooo013ooooo0_lIi/cXooooo`7o00000Ooo
ool0027ooooo0_l0000Aooooo`?o6NK<i_ooool2o`00007ooooo000Qooooo`03o`000?oooooooooo
017ooooo0_lIi/cWooooo`7o00000Oooool0027ooooo00?o0000ooooooooool04Oooool3oaWVc>Ko
oooo0Ol00001ooooo`008Oooool00ol0003oooooooooo`0Booooo`;o6NK<i_ooool1o`00007ooooo
000Qooooo`;o00004oooool3oaWVc>Cooooo0_l00001ooooo`008Oooool00ol0003oooooooooo`0C
ooooo`;o6NK<iOooool1o`00007ooooo000Qooooo`03o`000?oooooooooo01?ooooo0olIi/cToooo
o`7o00000Oooool0027ooooo00?o0000ooooooooool05?ooool2oaWVc>Cooooo0Ol00001ooooo`00
8Oooool2o`0001Gooooo0olIi/cRooooo`;o00000Oooool0027ooooo00?o0000ooooooooool05Ooo
ool2oaWVc>?ooooo0Ol00001ooooo`006Oooool3o`0000Gooooo00?o0000ooooooooool05Oooool3
oaWVc>;ooooo0Ol00001ooooo`006_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
01Kooooo0_lIi/cRooooo`7o00000Oooool001;ooooo1Ol00003ooooo`03o`000?oooooooooo00Co
oooo0_l0000Gooooo`?o6NK<h?ooool2o`00007ooooo000Jooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool05oooool2oaWVc>7ooooo0Ol00001ooooo`006_ooool00ol0003ooooooooo
o`04ooooo`03o`000?oooooooooo01Oooooo0olIi/cPooooo`7o00000Oooool001Wooooo0_l00006
ooooo`03o`000?oooooooooo01Sooooo0_lIi/cPooooo`7o00000Oooool001[ooooo00?o0000oooo
ooooool01?ooool2o`0001Wooooo0olIi/cNooooo`;o00000Oooool0027ooooo00?o0000oooooooo
ool06Oooool2oaWVc=oooooo0Ol00001ooooo`008Oooool00ol0003oooooooooo`0Iooooo`?o6NK<
g_ooool1o`00007ooooo000Qooooo`03o`000?oooooooooo01[ooooo0_lIi/cNooooo`7o00000Ooo
ool0027ooooo0_l0000Kooooo`;o6NK<gOooool2o`00007ooooo000Qooooo`03o`000?oooooooooo
01[ooooo0olIi/cMooooo`7o00000Oooool0027ooooo00?o0000ooooooooool06oooool2oaWVc=go
oooo0Ol00001ooooo`008Oooool00ol0003oooooooooo`0Kooooo`?o6NK<g?ooool1o`00007ooooo
000Qooooo`;o00007Oooool2oaWVc=_ooooo0_l00001ooooo`008Oooool00ol0003oooooooooo`0L
ooooo`?o6NK<foooool1o`00007ooooo000Qooooo`03o`000?oooooooooo01gooooo0_lIi/cKoooo
o`7o00000Oooool0027ooooo00?o0000ooooooooool07Oooool3oaWVc=[ooooo0Ol00001ooooo`00
8Oooool00ol0003oooooooooo`0Nooooo`;o6NK<f_ooool1o`00007ooooo000Qooooo`;o00007ooo
ool3oaWVc=Sooooo0_l00001ooooo`002?ooool2o`0000Cooooo00?o0000ooooooooool00oooool0
0ol0003oooooooooo`02ooooo`?o00001Oooool00ol0003oooooooooo`0Oooooo`;o6NK<fOooool1
o`00007ooooo0007ooooo`04o`000?ooooooooooo`0000Wooooo00Go0000ooooooooooooooooo`00
0003ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool07oooool3oaWVc=Sooooo0Ol0
0001ooooo`001Ol00002ooooo`04o`000?ooooooooooo`0000[ooooo00?o0000ooooooooool01?oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo023ooooo0_lIi/cHooooo`7o00000Ooo
ool000Oooooo00Co0000oooooooooooo00002_ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00;ooooo0_l0000Qooooo`?o6NK<e_ooool2o`00007ooooo0007ooooo`04o`000?oooooo
ooooo`0000_ooooo00?o0000ooooool000000ol00005ooooo`03o`000?oooooooooo027ooooo0_lI
i/cGooooo`7o00000Oooool000Oooooo00Co0000oooooooooooo00001oooool01ol0003ooooooooo
oooooooo0000ooooool000002?ooool00ol0003oooooooooo`0Qooooo`?o6NK<e_ooool1o`00007o
oooo0008ooooo`;o00002?ooool5o`000003ooooool0003o000000?o00001?ooool00ol0003ooooo
ooooo`0Rooooo`;o6NK<e_ooool1o`00007ooooo000Qooooo`;o00008oooool3oaWVc=Cooooo0_l0
0001ooooo`008Oooool00ol0003oooooooooo`0Sooooo`;o6NK<eOooool1o`00007ooooo000Qoooo
o`03o`000?oooooooooo02?ooooo0olIi/cDooooo`7o00000Oooool0027ooooo00?o0000oooooooo
ool09?ooool2oaWVc=Cooooo0Ol00001ooooo`008Oooool2o`0002Gooooo0olIi/cBooooo`;o0000
0Oooool0027ooooo00?o0000ooooooooool09Oooool2oaWVc=?ooooo0Ol00001ooooo`008Oooool0
0ol0003oooooooooo`0Uooooo`?o6NK<d_ooool1o`00007ooooo000Qooooo`03o`000?oooooooooo
02Kooooo0_lIi/cBooooo`7o00000Oooool0027ooooo0_l0000Wooooo`?o6NK<d?ooool2o`00007o
oooo000Qooooo`03o`000?oooooooooo02Oooooo0_lIi/cAooooo`7o00000Oooool0027ooooo00?o
0000ooooooooool09oooool3oaWVc=3ooooo0Ol00001ooooo`008Oooool00ol0003oooooooooo`0X
ooooo`;o6NK<d?ooool1o`00007ooooo000Qooooo`;o0000:Oooool3oaWVc<kooooo0_l00001oooo
o`008Oooool00ol0003oooooooooo`0Yooooo`;o6NK<coooool1o`00007ooooo000>ooooo`;o0000
1?ooool00ol0003oooooooooo`02ooooo`?o00001Oooool00ol0003oooooooooo`0Yooooo`?o6NK<
c_ooool1o`00007ooooo000=ooooo`04o`000?ooooooooooo`0000Oooooo00Go0000oooooooooooo
ooooo`000004ooooo`03o`000?oooooooooo02[ooooo0_lIi/c>ooooo`7o00000Oooool000Kooooo
1Ol00002ooooo`04o`000?ooooooooooo`0000_ooooo00?o0000ooooooooool00_ooool2o`0002_o
oooo0_lIi/c=ooooo`;o00000Oooool000gooooo00Co0000oooooooooooo00002oooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo02[ooooo0olIi/c=ooooo`7o00000Oooool000gooooo
00Co0000oooooooooooo00001oooool4o`0000Gooooo00?o0000ooooooooool0:oooool2oaWVc<go
oooo0Ol00001ooooo`003Oooool01?l0003oooooooooool00007ooooo`03o`000?oooooooooo00Ko
oooo00?o0000ooooooooool0:oooool3oaWVc<cooooo0Ol00001ooooo`003_ooool2o`0000Sooooo
1Ol00004ooooo`;o0000;Oooool2oaWVc<_ooooo0_l00001ooooo`008Oooool00ol0003ooooooooo
o`0/ooooo`?o6NK<boooool1o`00007ooooo000Qooooo`03o`000?oooooooooo02gooooo0_lIi/c;
ooooo`7o00000Oooool0027ooooo00?o0000ooooooooool0;Oooool3oaWVc<[ooooo0Ol00001oooo
o`008Oooool2o`0002oooooo0_lIi/c9ooooo`;o00000Oooool0027ooooo00?o0000ooooooooool0
;_ooool3oaWVc<Wooooo0Ol00001ooooo`008Oooool00ol0003oooooooooo`0_ooooo`;o6NK<bOoo
ool1o`00007ooooo000Qooooo`03o`000?oooooooooo02oooooo0olIi/c8ooooo`7o00000Oooool0
027ooooo0_l0000aooooo`;o6NK<aoooool2o`00007ooooo000Qooooo`03o`000?oooooooooo033o
oooo0olIi/b@ooooo`?o6NK<=?ooool1o`00007ooooo000Qooooo`03o`000?oooooooooo037ooooo
0_lIi/b@ooooo`Co6NK<<oooool1o`00007ooooo000Qooooo`03o`000?oooooooooo037ooooo0olI
i/b>ooooo`Oo6NK<<Oooool1o`00007ooooo000Qooooo`03o`000?oooooooooo03;ooooo0_lIi/b=
ooooo`?o6NK<0_ooool4oaWVc33ooooo0Ol00001ooooo`008Oooool2o`0003?ooooo0olIi/b;oooo
o`?o6NK<1Oooool4oaWVc2gooooo0_l00001ooooo`002?ooool2o`0000Cooooo00Co0000oooooooo
oooooooo1Ol00002ooooo`?o00001Oooool00ol0003oooooooooo`0cooooo`?o6NK<ROooool3oaWV
c0Oooooo1OlIi/`/ooooo`7o00000Oooool000Oooooo00Co0000oooooooooooo00002?ooool01_l0
003oooooooooool0003oooooo`0000?ooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`0dooooo`?o6NK<Qoooool3oaWVc0[ooooo1?lIi/`[ooooo`7o00000Oooool000Go00000_ooool0
1?l0003oooooooooool00009ooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`0eooooo`?o6NK<QOooool3oaWVc0gooooo1?lIi/`Yooooo`7o00000Ooo
ool000Oooooo00Co0000oooooooooooo00002_ooool00ol0003oooooooooo`04ooooo`03o`000?oo
oooooooo00;ooooo0_l0000gooooo`?o6NK<Poooool3oaWVc0oooooo1?lIi/`Wooooo`;o00000Ooo
ool000Oooooo00Co0000oooooooooooo00001oooool01_l0003ooooooooooooooooo0000ooooo`Co
00001Oooool00ol0003oooooooooo`0gooooo`?o6NK<POooool3oaWVc1;ooooo1?lIi/`Vooooo`7o
00000Oooool000Oooooo00Co0000oooooooooooo00001oooool01ol0003ooooooooooooooooo0000
ooooool000002?ooool00ol0003oooooooooo`0hooooo`?o6NK<Ooooool3oaWVc1Cooooo1?lIi/`U
ooooo`7o00000Oooool000Sooooo0_l00009ooooo`?o00000_ooool5o`0000Cooooo00?o0000oooo
ooooool0>Oooool3oaWVc7gooooo0olIi/`Gooooo`Co6NK<8oooool1o`00007ooooo000Qooooo`;o
0000>oooool3oaWVc7cooooo0_lIi/`Iooooo`Co6NK<8Oooool2o`00007ooooo000Qooooo`03o`00
0?oooooooooo03_ooooo0olIi/ajooooo`?o6NK<6oooool4oaWVc23ooooo0Ol00001ooooo`008Ooo
ool00ol0003oooooooooo`0looooo`?o6NK<N?ooool3oaWVc1gooooo1?lIi/`Oooooo`7o00000Ooo
ool0027ooooo00?o0000ooooooooool0?Oooool3oaWVc7Kooooo0olIi/`Pooooo`Co6NK<7Oooool1
o`00007ooooo000Qooooo`;o0000?oooool3oaWVc7Cooooo0olIi/`Rooooo`Go6NK<6_ooool2o`00
007ooooo000Qooooo`03o`000?oooooooooo03oooooo0olIi/abooooo`?o6NK<9Oooool4oaWVc1[o
oooo0Ol00001ooooo`008Oooool00ol0003oooooooooo`10ooooo`?o6NK<L?ooool3oaWVc2Sooooo
1?lIi/`Hooooo`7o00000Oooool0027ooooo00?o0000ooooooooool0@Oooool3oaWVc6kooooo0olI
i/`Zooooo`Co6NK<5oooool1o`00007ooooo000Qooooo`;o0000@oooool3oaWVc6cooooo0olIi/`]
ooooo`Co6NK<5?ooool2o`00007ooooo000Qooooo`03o`000?oooooooooo04?ooooo0olIi/aZoooo
o`?o6NK<;oooool4oaWVc1Cooooo0Ol00001ooooo`008Oooool00ol0003oooooooooo`14ooooo`?o
6NK<JOooool2oaWVc3;ooooo1?lIi/`Booooo`7o00000Oooool0027ooooo00?o0000ooooooooool0
AOooool3oaWVc6Oooooo0olIi/`cooooo`Co6NK<4Oooool1o`00007ooooo000Qooooo`;o0000Aooo
ool3oaWVc6Gooooo0olIi/`fooooo`Co6NK<3_ooool2o`00007ooooo000Qooooo`03o`000?oooooo
oooo04Oooooo0olIi/aSooooo`?o6NK<>?ooool4oaWVc0kooooo0Ol00001ooooo`006_ooool2o`00
00Gooooo00?o0000ooooooooool0B?ooool3oaWVc67ooooo0olIi/`kooooo`Co6NK<3?ooool1o`00
007ooooo000Iooooo`04o`000?ooooooooooo`0000Cooooo00?o0000ooooooooool0BOooool3oaWV
c5oooooo0olIi/`mooooo`Go6NK<2_ooool1o`00007ooooo000Iooooo`04o`000?ooooooooooo`00
00Cooooo0_l0001;ooooo`;o6NK<G_ooool3oaWVc43ooooo1?lIi/`8ooooo`;o00000Oooool001Wo
oooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`1:ooooo`?o6NK<G?ooool3oaWV
c4?ooooo1?lIi/`7ooooo`7o00000Oooool001Wooooo00Co0000oooooooooooo00001?ooool00ol0
003oooooooooo`1;ooooo`?o6NK<F_ooool3oaWVc4Gooooo1?lIi/`6ooooo`7o00000Oooool001Wo
oooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`1<ooooo`?o6NK<F?ooool3oaWV
c4Sooooo0olIi/`5ooooo`7o00000Oooool001[ooooo0_l00005ooooo`;o0000C_ooool3oaWVc5Ko
oooo0olIi/a:ooooo`;o6NK<1?ooool2o`00007ooooo000Qooooo`03o`000?oooooooooo04kooooo
0olIi/aEooooo`;o6NK<D_ooool1o`00007ooooo000Qooooo`03o`000?oooooooooo04oooooo0olI
i/aCooooo`?o6NK<D_ooool1o`00007ooooo000Qooooo`03o`000?oooooooooo053ooooo0olIi/aA
ooooo`?o6NK<Doooool1o`00007ooooo000Qooooo`;o0000D_ooool3oaWVc4oooooo0olIi/aCoooo
o`;o00000Oooool0027ooooo00?o0000ooooooooool0D_ooool3oaWVc4gooooo0olIi/aEooooo`7o
00000Oooool0027ooooo00?o0000ooooooooool0Doooool3oaWVc4_ooooo0olIi/aFooooo`7o0000
0Oooool0027ooooo00?o0000ooooooooool0E?ooool3oaWVc4Wooooo0olIi/aGooooo`7o00000Ooo
ool0027ooooo00?o0000ooooooooool0EOooool3oaWVc4Oooooo0olIi/aHooooo`7o00000Oooool0
027ooooo0_l0001Gooooo`?o6NK<AOooool3oaWVc5Sooooo0_l00001ooooo`008Oooool00ol0003o
ooooooooo`1Gooooo`?o6NK<@oooool3oaWVc5[ooooo0Ol00001ooooo`008Oooool00ol0003ooooo
ooooo`1Hooooo`?o6NK<@_ooool2oaWVc5_ooooo0Ol00001ooooo`008Oooool00ol0003ooooooooo
o`1Iooooo`?o6NK<@?ooool3oaWVc5_ooooo0Ol00001ooooo`008Oooool2o`0005_ooooo0olIi/`n
ooooo`?o6NK<Foooool2o`00007ooooo0008ooooo`;o00001?ooool01?l0003oooooooooooooool5
o`0000;ooooo0ol00005ooooo`03o`000?oooooooooo05_ooooo0olIi/`looooo`?o6NK<GOooool1
o`00007ooooo0007ooooo`04o`000?ooooooooooo`0000Sooooo00Ko0000oooooooooooo0000oooo
ool00003ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0G?ooool3oaWVc3[ooooo
0olIi/aNooooo`7o00000Oooool000Oooooo00Co0000oooooooooooo00002Oooool00ol0003ooooo
ooooo`05ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0GOooool3oaWVc3Sooooo
0olIi/aOooooo`7o00000Oooool000Oooooo00Co0000oooooooooooo00002_ooool00ol0003ooooo
ooooo`04ooooo`03o`000?oooooooooo00;ooooo0_l0001Oooooo`?o6NK<=_ooool3oaWVc5oooooo
0_l00001ooooo`001oooool01?l0003oooooooooool00007ooooo`06o`000?ooooooooooooooool0
003ooooo1?l00005ooooo`03o`000?oooooooooo05oooooo0olIi/`dooooo`?o6NK<HOooool1o`00
007ooooo0007ooooo`04o`000?ooooooooooo`0000Oooooo00Oo0000ooooooooooooooooo`000?oo
oooo000000Sooooo00?o0000ooooooooool0H?ooool3oaWVc3;ooooo0olIi/aRooooo`7o00000Ooo
ool000Sooooo0_l00009ooooo`?o00000_ooool5o`0000Cooooo00?o0000ooooooooool0HOoooolL
oaWVc1Oooooo0olIi/aSooooo`7o00000Oooool0027ooooo0_l0001SooooocCo6NK<Hoooool2o`00
007ooooo000Qooooo`03o`000?oooooooooo07cooooo6OlIi/aUooooo`7o00000Oooool0027ooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo
00?o0000ooooooooool0;_ooool00ol0003oooooooooo`0]ooooo`03o`000?oooooooooo02gooooo
00?o0000ooooooooool00oooool1o`00007ooooo000Qooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o
0000ooooooooool01_ooool00ol0003oooooooooo`03ooooo`7o00000Oooool0027oooooo_l00001
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.811461, -1.76313, \
0.0206937, 0.0121889}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.190476 0.22575 0.102399 [
[.02381 -0.0125 -3 -9 ]
[.02381 -0.0125 3 0 ]
[.21429 -0.0125 -3 -9 ]
[.21429 -0.0125 3 0 ]
[.40476 -0.0125 -3 -9 ]
[.40476 -0.0125 3 0 ]
[.59524 -0.0125 -3 -9 ]
[.59524 -0.0125 3 0 ]
[.78571 -0.0125 -3 -9 ]
[.78571 -0.0125 3 0 ]
[.97619 -0.0125 -3 -9 ]
[.97619 -0.0125 3 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .02095 -12 -4.5 ]
[-0.0125 .02095 0 4.5 ]
[-0.0125 .12335 -12 -4.5 ]
[-0.0125 .12335 0 4.5 ]
[-0.0125 .22575 -6 -4.5 ]
[-0.0125 .22575 0 4.5 ]
[-0.0125 .32815 -6 -4.5 ]
[-0.0125 .32815 0 4.5 ]
[-0.0125 .43055 -6 -4.5 ]
[-0.0125 .43055 0 4.5 ]
[-0.0125 .53295 -6 -4.5 ]
[-0.0125 .53295 0 4.5 ]
[ 0 0 -0.125 0 ]
[ 0 .61803 .125 0 ]
[ 1 0 .125 0 ]
[.5 .63053 -119 0 ]
[.5 .63053 119 12 ]
[.97619 .2522 -5 -6 ]
[.97619 .2522 5 6 ]
[.97619 .31086 -5 -6 ]
[.97619 .31086 5 6 ]
[.97619 .44031 -5 -6 ]
[.97619 .44031 5 6 ]
[.97619 .1814 -5 -6 ]
[.97619 .1814 5 6 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
[(0)] .02381 -0.0125 0 1 Mshowa
.21429 0 m
.21429 .00625 L
s
[(1)] .21429 -0.0125 0 1 Mshowa
.40476 0 m
.40476 .00625 L
s
[(2)] .40476 -0.0125 0 1 Mshowa
.59524 0 m
.59524 .00625 L
s
[(3)] .59524 -0.0125 0 1 Mshowa
.78571 0 m
.78571 .00625 L
s
[(4)] .78571 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(5)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.0619 0 m
.0619 .00375 L
s
.1 0 m
.1 .00375 L
s
.1381 0 m
.1381 .00375 L
s
.17619 0 m
.17619 .00375 L
s
.25238 0 m
.25238 .00375 L
s
.29048 0 m
.29048 .00375 L
s
.32857 0 m
.32857 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.44286 0 m
.44286 .00375 L
s
.48095 0 m
.48095 .00375 L
s
.51905 0 m
.51905 .00375 L
s
.55714 0 m
.55714 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.67143 0 m
.67143 .00375 L
s
.70952 0 m
.70952 .00375 L
s
.74762 0 m
.74762 .00375 L
s
.82381 0 m
.82381 .00375 L
s
.8619 0 m
.8619 .00375 L
s
.9 0 m
.9 .00375 L
s
.9381 0 m
.9381 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .02095 m
.00625 .02095 L
s
[(-2)] -0.0125 .02095 1 0 Mshowa
0 .12335 m
.00625 .12335 L
s
[(-1)] -0.0125 .12335 1 0 Mshowa
0 .22575 m
.00625 .22575 L
s
[(0)] -0.0125 .22575 1 0 Mshowa
0 .32815 m
.00625 .32815 L
s
[(1)] -0.0125 .32815 1 0 Mshowa
0 .43055 m
.00625 .43055 L
s
[(2)] -0.0125 .43055 1 0 Mshowa
0 .53295 m
.00625 .53295 L
s
[(3)] -0.0125 .53295 1 0 Mshowa
.125 Mabswid
0 .04143 m
.00375 .04143 L
s
0 .06191 m
.00375 .06191 L
s
0 .08239 m
.00375 .08239 L
s
0 .10287 m
.00375 .10287 L
s
0 .14383 m
.00375 .14383 L
s
0 .16431 m
.00375 .16431 L
s
0 .18479 m
.00375 .18479 L
s
0 .20527 m
.00375 .20527 L
s
0 .24623 m
.00375 .24623 L
s
0 .26671 m
.00375 .26671 L
s
0 .28719 m
.00375 .28719 L
s
0 .30767 m
.00375 .30767 L
s
0 .34863 m
.00375 .34863 L
s
0 .36911 m
.00375 .36911 L
s
0 .38959 m
.00375 .38959 L
s
0 .41007 m
.00375 .41007 L
s
0 .45103 m
.00375 .45103 L
s
0 .47151 m
.00375 .47151 L
s
0 .49199 m
.00375 .49199 L
s
0 .51247 m
.00375 .51247 L
s
0 .00047 m
.00375 .00047 L
s
0 .55343 m
.00375 .55343 L
s
0 .5739 m
.00375 .5739 L
s
0 .59438 m
.00375 .59438 L
s
0 .61486 m
.00375 .61486 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
.02381 .61178 m
.02381 .61803 L
s
.21429 .61178 m
.21429 .61803 L
s
.40476 .61178 m
.40476 .61803 L
s
.59524 .61178 m
.59524 .61803 L
s
.78571 .61178 m
.78571 .61803 L
s
.97619 .61178 m
.97619 .61803 L
s
.125 Mabswid
.0619 .61428 m
.0619 .61803 L
s
.1 .61428 m
.1 .61803 L
s
.1381 .61428 m
.1381 .61803 L
s
.17619 .61428 m
.17619 .61803 L
s
.25238 .61428 m
.25238 .61803 L
s
.29048 .61428 m
.29048 .61803 L
s
.32857 .61428 m
.32857 .61803 L
s
.36667 .61428 m
.36667 .61803 L
s
.44286 .61428 m
.44286 .61803 L
s
.48095 .61428 m
.48095 .61803 L
s
.51905 .61428 m
.51905 .61803 L
s
.55714 .61428 m
.55714 .61803 L
s
.63333 .61428 m
.63333 .61803 L
s
.67143 .61428 m
.67143 .61803 L
s
.70952 .61428 m
.70952 .61803 L
s
.74762 .61428 m
.74762 .61803 L
s
.82381 .61428 m
.82381 .61803 L
s
.8619 .61428 m
.8619 .61803 L
s
.9 .61428 m
.9 .61803 L
s
.9381 .61428 m
.9381 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
.99375 .02095 m
1 .02095 L
s
.99375 .12335 m
1 .12335 L
s
.99375 .22575 m
1 .22575 L
s
.99375 .32815 m
1 .32815 L
s
.99375 .43055 m
1 .43055 L
s
.99375 .53295 m
1 .53295 L
s
.125 Mabswid
.99625 .04143 m
1 .04143 L
s
.99625 .06191 m
1 .06191 L
s
.99625 .08239 m
1 .08239 L
s
.99625 .10287 m
1 .10287 L
s
.99625 .14383 m
1 .14383 L
s
.99625 .16431 m
1 .16431 L
s
.99625 .18479 m
1 .18479 L
s
.99625 .20527 m
1 .20527 L
s
.99625 .24623 m
1 .24623 L
s
.99625 .26671 m
1 .26671 L
s
.99625 .28719 m
1 .28719 L
s
.99625 .30767 m
1 .30767 L
s
.99625 .34863 m
1 .34863 L
s
.99625 .36911 m
1 .36911 L
s
.99625 .38959 m
1 .38959 L
s
.99625 .41007 m
1 .41007 L
s
.99625 .45103 m
1 .45103 L
s
.99625 .47151 m
1 .47151 L
s
.99625 .49199 m
1 .49199 L
s
.99625 .51247 m
1 .51247 L
s
.99625 .00047 m
1 .00047 L
s
.99625 .55343 m
1 .55343 L
s
.99625 .5739 m
1 .5739 L
s
.99625 .59438 m
1 .59438 L
s
.99625 .61486 m
1 .61486 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
.5 .63053 -180 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(True) show
93.000 13.000 moveto
(and) show
117.000 13.000 moveto
(smoothed) show
171.000 13.000 moveto
(trajectory) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
237.000 13.000 moveto
(H) show
243.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(velocity) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
291.000 13.000 moveto
(L) show
297.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 0 r
gsave
.97619 .2522 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.01 w
.02381 .31323 m
.21429 .41708 L
.40476 .33086 L
.59524 .19292 L
.78571 .25858 L
.97619 .2522 L
s
.1 .1 .9 r
gsave
.97619 .31086 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.100 0.100 0.900 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .19882 m
.21429 .48002 L
.40476 .26846 L
.59524 .13356 L
.78571 .19045 L
.97619 .31086 L
s
.1 .9 .8 r
gsave
.97619 .44031 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.100 0.900 0.800 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .36033 m
.21429 .60332 L
.40476 .38761 L
.59524 .2524 L
.78571 .3102 L
.97619 .44031 L
s
gsave
.97619 .1814 -66 -10 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.100 0.900 0.800 setrgbcolor
0.000 0.000 rmoveto
69.000 13.000 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .03732 m
.21429 .35672 L
.40476 .14931 L
.59524 .01472 L
.78571 .0707 L
.97619 .1814 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`008_ooool2o`0002_ooooo0ol0000Zooooo`Go0000:oooool3o`0002cooooo0ol0000Zoooo
o`?o00005Oooool0027ooooo00Co0000oooooooooooo0000:oooool00ol0003oooooooooo`0Zoooo
o`04o`000?ooooooooooo`0002[ooooo00Go0000ooooooooooooooooo`00000/ooooo`03o`000?oo
oooooooo02Sooooo00Go0000ooooooooooooooooo`00000Dooooo`008Oooool01?l0003ooooooooo
ool0000[ooooo`03o`000?oooooooooo02_ooooo00?o0000ooooooooool0;_ooool00ol0003ooooo
ooooo`0Wooooo`Go0000;Oooool00ol0003oooooooooo`0Booooo`008Oooool01?l0003ooooooooo
ool0000[ooooo`03o`000?oooooooooo02cooooo00?o0000ooooooooool0:oooool2o`0002[ooooo
00Co0000oooooooooooo0000;_ooool00ol0003oooooooooo`0Booooo`008Oooool01?l0003ooooo
ooooool0000[ooooo`03o`000?oooooooooo02Wooooo00Go0000ooooooooooooooooo`00000^oooo
o`03o`000?oooooooooo02Sooooo00?o0000ooooool00000:_ooool4o`0001Gooooo000Qooooo`04
o`000?ooooooooooo`0002[ooooo0_l0000[ooooo`05o`000?ooooooooooooooool00000:_ooool0
1Ol0003ooooooooooooooooo000002_ooooo0_l0000Zooooo`03o`000?oooooooooo01Kooooo000R
ooooo`;o0000;?ooool00ol0003oooooooooo`0Zooooo`?o0000;?ooool3o`0002gooooo00?o0000
ooooooooool0:?ooool5o`0001Cooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo
003oooooob7ooooo000MooooooCo00003oooool001gooooo00?o0000ooooooooool00oooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01_ooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool01oooool00ol0
003oooooooooo`06ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool03Oooool001Co
oooo1Ol00004ooooo`03o`000?oooooooooo0?3ooooo00?o0000ooooooooool03Oooool001Gooooo
00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`2<ooooo`Go6NK<Goooool00ol0003o
ooooooooo`0=ooooo`003_ooool5o`0000?ooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`2;ooooo`Wo6NK<G?ooool00ol0003oooooooooo`0=ooooo`005oooool00ol0003ooooooooo
o`03ooooo`?o0000ROooool4oaWVc0?ooooo1olIi/aGooooo`?o00003oooool001Cooooo00Go0000
ooooooooooooooooo`000004ooooo`03o`000?oooooooooo08Sooooo1?lIi/`7ooooo`So6NK<EOoo
ool00ol0003oooooooooo`0=ooooo`005?ooool01Ol0003ooooooooooooooooo000000Cooooo00?o
0000ooooooooool0Qoooool3oaWVc0cooooo2?lIi/aBooooo`03o`000?oooooooooo00gooooo000E
ooooo`?o00001Oooool00ol0003oooooooooo`25ooooo`Co6NK<4Oooool7oaWVc4oooooo00?o0000
ooooooooool03Oooool001gooooo00?o0000ooooooooool00_ooool2oaWVc83ooooo1?lIi/`Eoooo
o`Oo6NK<C?ooool00ol0003oooooooooo`0=ooooo`007Oooool2o`0000?ooooo0_lIi/anooooo`Co
6NK<6_ooool8oaWVc4Oooooo0_l0000?ooooo`007Oooool00ol0003oooooooooo`02ooooo`?o6NK<
O?ooool4oaWVc1kooooo2?lIi/a5ooooo`03o`000?oooooooooo00gooooo000Mooooo`03o`000?oo
oooooooo00?ooooo0_lIi/ajooooo`Co6NK<9?ooool7oaWVc4;ooooo00?o0000ooooooooool03Ooo
ool001gooooo00?o0000ooooooooool00oooool3oaWVc7Sooooo1?lIi/`Xooooo`So6NK<?_ooool0
0ol0003oooooooooo`0=ooooo`007Oooool00ol0003oooooooooo`04ooooo`?o6NK<M_ooool3oaWV
c2gooooo2?lIi/`kooooo`03o`000?oooooooooo00gooooo000Mooooo`;o00001_ooool2oaWVc7Co
oooo1?lIi/`booooo`Oo6NK<=oooool2o`0000oooooo000Mooooo`03o`000?oooooooooo00Gooooo
0olIi/abooooo`Co6NK<=_ooool7oaWVc3Gooooo00?o0000ooooooooool03Oooool001gooooo00?o
0000ooooooooool01_ooool2oaWVc73ooooo1?lIi/`kooooo`Oo6NK<<_ooool00ol0003ooooooooo
o`0=ooooo`007Oooool00ol0003oooooooooo`06ooooo`?o6NK<K_ooool4oaWVc3oooooo1_lIi/``
ooooo`03o`000?oooooooooo00gooooo000Mooooo`03o`000?oooooooooo00Oooooo0olIi/a[oooo
o`Co6NK<A?ooool4oaWVc2oooooo00?o0000ooooooooool03Oooool001gooooo0_l00009ooooo`;o
6NK<J_ooool4oaWVc4Oooooo1?lIi/`/ooooo`;o00003oooool001gooooo00?o0000ooooooooool0
2?ooool3oaWVc6Sooooo0olIi/a:ooooo`Go6NK<:oooool00ol0003oooooooooo`0=ooooo`007Ooo
ool00ol0003oooooooooo`09ooooo`;o6NK<I_ooool4oaWVc4gooooo1?lIi/`Zooooo`03o`000?oo
oooooooo00gooooo000Mooooo`03o`000?oooooooooo00Wooooo0olIi/aTooooo`Co6NK<D?ooool4
oaWVc2Sooooo00?o0000ooooooooool03Oooool001gooooo00?o0000ooooooooool02_ooool3oaWV
c67ooooo1?lIi/aCooooo`Go6NK<9_ooool00ol0003oooooooooo`0=ooooo`007Oooool2o`0000co
oooo0_lIi/aPooooo`Co6NK<E_ooool4oaWVc2Cooooo0_l0000?ooooo`007Oooool00ol0003ooooo
ooooo`0;ooooo`?o6NK<G_ooool3oaWVc5[ooooo1?lIi/`Sooooo`03o`000?oooooooooo00gooooo
000Eooooo`?o00001Oooool00ol0003oooooooooo`0<ooooo`;o6NK<G?ooool4oaWVc5cooooo1OlI
i/`Qooooo`03o`000?oooooooooo00gooooo000Fooooo`03o`000?oooooooooo00Cooooo00?o0000
ooooooooool03?ooool3oaWVc5[ooooo1?lIi/aOooooo`Go6NK<7oooool00ol0003oooooooooo`0=
ooooo`003_ooool5o`0000?ooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0=oooo
o`?o6NK<Eoooool4oaWVc6?ooooo1?lIi/`Nooooo`03o`000?oooooooooo00gooooo000Fooooo`03
o`000?oooooooooo00Cooooo0ol0000>ooooo`;o6NK<E_ooool4oaWVc6Kooooo1?lIi/`Jooooo`?o
00003oooool001Kooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`0>ooooo`?o6NK<
Doooool4oaWVc6Wooooo1OlIi/`Jooooo`03o`000?oooooooooo00gooooo000Eooooo`;o00001_oo
ool00ol0003oooooooooo`0?ooooo`;o6NK<D_ooool4oaWVc2Gooooo1OlI6NI2ooooo`Co6NK<6Ooo
ool00ol0003oooooooooo`0=ooooo`005_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooo
oooo00oooooo0olIi/a@ooooo`?o6NK<9_ooool9oaTIiT7ooooo1?lIi/`Gooooo`03o`000?oooooo
oooo00gooooo000Mooooo`;o00004Oooool3oaWVc4gooooo1?lIi/`Uooooo`Co6AWV0oooool7oaTI
iSoooooo1OlIi/`Dooooo`;o00003oooool001gooooo00?o0000ooooooooool04Oooool2oaWVc4co
oooo1?lIi/`Uooooo`Co6AWV1oooool8oaTIiSgooooo1OlIi/`Cooooo`03o`000?oooooooooo00go
oooo000Mooooo`03o`000?oooooooooo017ooooo0olIi/a:ooooo`?o6NK<9_ooool3oaTIiPcooooo
2?lI6NHlooooo`Co6NK<4_ooool00ol0003oooooooooo`0=ooooo`007Oooool00ol0003ooooooooo
o`0Booooo`;o6NK<B_ooool2oaWVc2Gooooo1?lI6NHAooooo`Oo6AWV>oooool4oaWVc13ooooo00?o
0000ooooooooool03Oooool001gooooo00?o0000ooooooooool04_ooool3oaWVc4Sooooo0olIi/`T
ooooo`Co6AWV5Oooool7oaTIiSWooooo1OlIi/`>ooooo`03o`000?oooooooooo00gooooo000Moooo
o`;o00005?ooool3oaWVc4Kooooo0olIi/`Sooooo`Co6AWV6_ooool8oaTIiSOooooo1?lIi/`<oooo
o`;o00003oooool001gooooo00?o0000ooooooooool05?ooool2oaWVc4Gooooo0olIi/`Sooooo`Co
6AWV7_ooool8oaTIiSKooooo1?lIi/`;ooooo`03o`000?oooooooooo00gooooo000Mooooo`03o`00
0?oooooooooo01Cooooo0olIi/a3ooooo`?o6NK<8_ooool4oaTIiRCooooo1olI6NHdooooo`Go6NK<
2Oooool00ol0003oooooooooo`0=ooooo`007Oooool00ol0003oooooooooo`0Eooooo`;o6NK<@_oo
ool3oaWVc2;ooooo1?lI6NHXooooo`So6AWV<_ooool4oaWVc0Sooooo00?o0000ooooooooool03Ooo
ool001gooooo00?o0000ooooooooool05Oooool3oaWVc43ooooo0olIi/`Rooooo`?o6AWV;Oooool8
oaTIiS7ooooo1?lIi/`6ooooo`03o`000?oooooooooo00gooooo000Mooooo`;o00005oooool3oaWV
c3kooooo0olIi/`Qooooo`Co6AWV<_ooool7oaTIiRoooooo1?lIi/`4ooooo`;o00003oooool001go
oooo00?o0000ooooooooool05oooool2oaWVc3gooooo0olIi/`Qooooo`Co6AWV=_ooool7oaTIiRko
oooo0_lIi/`5ooooo`03o`000?oooooooooo00gooooo000Mooooo`03o`000?oooooooooo01Oooooo
0olIi/`kooooo`?o6NK<8?ooool4oaTIiQ3ooooo1?l0000Wooooo`Oo6AWV<_ooool00ol0003ooooo
ooooo`0=ooooo`007Oooool00ol0003oooooooooo`0Hooooo`;o6NK<>_ooool3oaWVc23ooooo1?lI
6NH@ooooo`So00009oooool5oaTIiS7ooooo00?o0000ooooooooool03Oooool001gooooo00?o0000
ooooooooool00_ooool2oaTIiQCooooo0olIi/`hooooo`?o6NK<7oooool4oaTIiQ7ooooo0ol00002
ooooo`Oo00009oooool4oaTIiRoooooo00?o0000ooooooooool03Oooool001gooooo0_l00003oooo
o`;o6AWV5Oooool3oaWVc3Kooooo0olIi/`Oooooo`Co6AWV4?ooool4o`0000Kooooo1ol0000Uoooo
o`Go6AWV;?ooool2o`0000oooooo000Mooooo`03o`000?oooooooooo00;ooooo0olI6NHEooooo`;o
6NK<=_ooool2oaWVc1oooooo0olI6NHAooooo`Co00002_ooool7o`0002Cooooo1?lI6NH/ooooo`03
o`000?oooooooooo00gooooo000Mooooo`03o`000?oooooooooo00?ooooo0olI6NHDooooo`?o6NK<
=?ooool3oaWVc1gooooo1?lI6NH@ooooo`Co00003oooool7o`0002?ooooo1?lI6NHZooooo`03o`00
0?oooooooooo00gooooo000Fooooo`;o00001Oooool00ol0003oooooooooo`04ooooo`;o6AWV5Ooo
ool2oaWVc3?ooooo0olIi/`Mooooo`Co6AWV4?ooool4o`0001?ooooo1ol0000Qooooo`Co6AWV:Ooo
ool00ol0003oooooooooo`0=ooooo`005Oooool01?l0003oooooooooool00004ooooo`03o`000?oo
oooooooo00Cooooo0olI6NHDooooo`?o6NK<<Oooool3oaWVc1cooooo1?lI6NHAooooo`?o00006?oo
ool7o`00023ooooo1?lI6NHWooooo`03o`000?oooooooooo00gooooo000Eooooo`04o`000?oooooo
ooooo`0000Cooooo0ol00005ooooo`?o6AWV5?ooool3oaWVc2oooooo0olIi/`Looooo`Co6AWV4?oo
ool4o`0001cooooo1_l0000Oooooo`Co6AWV9?ooool3o`0000oooooo000Eooooo`04o`000?oooooo
ooooo`0000Cooooo00?o0000ooooooooool01_ooool2oaTIiQGooooo0_lIi/`^ooooo`?o6NK<7?oo
ool3oaTIiQ7ooooo1?l0000Pooooo`Ko00007_ooool4oaTIiRCooooo00?o0000ooooooooool03Ooo
ool001Gooooo00Co0000oooooooooooo00001?ooool00ol0003oooooooooo`06ooooo`?o6AWV5?oo
ool3oaWVc2cooooo0olIi/`Kooooo`Co6AWV4?ooool4o`0002Cooooo1ol0000Looooo`Go6AWV8_oo
ool00ol0003oooooooooo`0=ooooo`005Oooool01?l0003oooooooooool00004ooooo`03o`000?oo
oooooooo00Oooooo0olI6NHDooooo`;o6NK<:oooool3oaWVc1_ooooo1?lI6NH@ooooo`Co0000:?oo
ool7o`0001_ooooo1?lI6NHQooooo`03o`000?oooooooooo00gooooo000Fooooo`;o00001Oooool0
0ol0003oooooooooo`08ooooo`;o6AWV5?ooool3oaWVc2Wooooo0olIi/`Jooooo`Co6AWV4Oooool3
o`0002gooooo1ol0000Jooooo`Co6AWV7oooool00ol0003oooooooooo`0=ooooo`007Oooool2o`00
00Wooooo0olI6NHDooooo`?o6NK<9oooool3oaWVc1[ooooo1?lI6NH@ooooo`Co0000<Oooool7o`00
01Sooooo1?lI6NHMooooo`;o00003oooool001gooooo00?o0000ooooooooool02Oooool3oaTIiQCo
oooo0_lIi/`Vooooo`?o6NK<6Oooool4oaTIiQ7ooooo1?l0000eooooo`Oo00005oooool4oaTIiQco
oooo00?o0000ooooooooool03Oooool001gooooo00?o0000ooooooooool02_ooool2oaTIiQCooooo
0olIi/`Tooooo`?o6NK<6Oooool4oaTIiQ7ooooo0ol0000Aooooo`Go6NK<9?ooool7o`0001Gooooo
1OlI6NHEo`0000Gooooo00?o0000ooooooooool03Oooool001gooooo00?o0000ooooooooool02_oo
ool3oaTIiQCooooo0_lIi/`Tooooo`;o6NK<6Oooool3oaTIiQ7ooooo1?l0000Aooooo`Wo6NK<9?oo
oolKo`0000Co6AWV5?l00005ooooo`03o`000?oooooooooo00gooooo000Mooooo`03o`000?oooooo
oooo00_ooooo0olI6NHCooooo`?o6NK<8_ooool3oaWVc1Oooooo1?lI6NHAooooo`Co00004?ooool4
oaWVc0?ooooo1olIi/`ToooooaSo00000_ooool4oaTIiQOooooo00?o0000ooooooooool03Oooool0
01gooooo0_l0000=ooooo`;o6AWV5?ooool3oaWVc23ooooo0olIi/`Gooooo`Co6AWV4?ooool4o`00
017ooooo1?lIi/`7ooooo`So6NK<>oooool4oaTIiQGooooo0_l0000?ooooo`007Oooool00ol0003o
ooooooooo`0<ooooo`?o6AWV5?ooool2oaWVc1oooooo0olIi/`Gooooo`?o6AWV4Oooool4o`00017o
oooo0olIi/`<ooooo`So6NK<>_ooool4oaTIiQCooooo00?o0000ooooooooool03Oooool001gooooo
00?o0000ooooooooool03Oooool3oaTIiQ?ooooo0olIi/`Mooooo`?o6NK<6?ooool2oaTIiQ7ooooo
0ol0000Aooooo`Co6NK<4Oooool7oaWVc3Sooooo1OlI6NHBooooo`03o`000?oooooooooo00gooooo
000Mooooo`03o`000?oooooooooo00kooooo0olI6NHCooooo`;o6NK<7?ooool3oaWVc1Sooooo0olI
6NH?ooooo`Co00004Oooool4oaWVc1Gooooo1olIi/`gooooo`Co6AWV4Oooool00ol0003ooooooooo
o`0=ooooo`007Oooool00ol0003oooooooooo`0?ooooo`;o6AWV4oooool3oaWVc1[ooooo0olIi/`H
ooooo`?o6AWV3oooool4o`00013ooooo1?lIi/`Jooooo`So6NK<=Oooool4oaTIiPoooooo00?o0000
ooooooooool03Oooool001gooooo0_l0000@ooooo`?o6AWV4oooool3oaWVc1Sooooo0olIi/`Hoooo
o`?o6AWV3oooool3o`00017ooooo1?lIi/`Nooooo`So6NK<<oooool4oaTIiPgooooo0_l0000?oooo
o`007Oooool00ol0003oooooooooo`0@ooooo`?o6AWV4oooool2oaWVc1Oooooo0olIi/`Hooooo`?o
6AWV3_ooool4o`00013ooooo1?lIi/`Tooooo`Oo6NK<<_ooool4oaTIiPcooooo00?o0000oooooooo
ool03Oooool001gooooo00?o0000ooooooooool04Oooool2oaTIiQ?ooooo0olIi/`Eooooo`?o6NK<
6?ooool3oaTIiPkooooo1?l0000@ooooo`Co6NK<:?ooool8oaWVc2oooooo1?lI6NH;ooooo`03o`00
0?oooooooooo00gooooo000Mooooo`03o`000?oooooooooo017ooooo0olI6NHCooooo`;o6NK<5?oo
ool3oaWVc1Sooooo0olI6NH=ooooo`Co00004Oooool3oaWVc2gooooo2?lIi/`^ooooo`Co6AWV2Ooo
ool00ol0003oooooooooo`0=ooooo`007Oooool00ol0003oooooooooo`0Booooo`?o6AWV4_ooool3
oaWVc1;ooooo0olIi/`Hooooo`?o6AWV3Oooool4o`00013ooooo1?lIi/`booooo`Oo6NK<;?ooool5
oaTIiPOooooo00?o0000ooooooooool03Oooool001gooooo0_l0000Dooooo`;o6AWV4oooool3oaWV
c13ooooo0olIi/`Hooooo`?o6AWV3Oooool3o`00017ooooo1?lIi/`fooooo`Oo6NK<:oooool4oaTI
iPGooooo0_l0000?ooooo`007Oooool00ol0003oooooooooo`0Cooooo`?o6AWV4oooool2oaWVc13o
oooo0_lIi/`Hooooo`?o6AWV3?ooool4o`00013ooooo1?lIi/`kooooo`Oo6NK<:_ooool3oaTIiPGo
oooo00?o0000ooooooooool03Oooool001gooooo00?o0000ooooooooool00_ooool3o`0000oooooo
0olI6NHBooooo`?o6NK<3_ooool3oaWVc1Sooooo0_lI6NH<ooooo`Co00004?ooool4oaWVc3oooooo
1OlIi/`Zooooo`;o6AWV1Oooool00ol0003oooooooooo`0=ooooo`005Oooool3o`0000Gooooo00?o
0000ooooooooool00_ooool5o`0000kooooo0_lI6NHCooooo`;o6NK<3Oooool3oaWVc1Sooooo0olI
6NH:ooooo`Co00004?ooool4oaWVc4Cooooo1?lIi/`_ooooo`03o`000?oooooooooo00gooooo000F
ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool01?ooool5o`0000cooooo0olI6NHB
ooooo`?o6NK<2oooool3oaWVc1Sooooo0olI6NH:ooooo`Co00004?ooool4oaWVc4Kooooo1?lIi/`^
ooooo`03o`000?oooooooooo00gooooo000Fooooo`03o`000?oooooooooo00Cooooo0ol00006oooo
o`Co00003?ooool3oaTIiQ;ooooo0olIi/`9ooooo`?o6NK<6?ooool3oaTIiP[ooooo0ol0000Aoooo
o`?o6NK<B_ooool4oaWVc2[ooooo0ol0000?ooooo`005_ooool00ol0003oooooooooo`04ooooo`03
o`000?oooooooooo00Sooooo1?l0000;ooooo`;o6AWV4oooool2oaWVc0Sooooo0olIi/`Hooooo`?o
6AWV2Oooool4o`00013ooooo1?lIi/a<ooooo`Co6NK<:oooool00ol0003oooooooooo`0=ooooo`00
5_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00Wooooo1Ol00009ooooo`?o6AWV
4_ooool3oaWVc0Kooooo0olIi/`Hooooo`?o6AWV2?ooool5o`00013ooooo1?lIi/a?ooooo`Co6NK<
:Oooool00ol0003oooooooooo`0=ooooo`005Oooool2o`0000Kooooo00?o0000ooooooooool02ooo
ool5o`0000Sooooo0olI6NHBooooo`;o6NK<1Oooool3oaWVc1Sooooo0olI6NH7ooooo`Go00004?oo
ool4oaWVc5;ooooo1?lIi/`Xooooo`03o`000?oooooooooo00gooooo000Fooooo`03o`000?oooooo
oooo00Cooooo00?o0000ooooooooool03Oooool5o`0000Oooooo0_lI6NHBooooo`?o6NK<0oooool3
oaWVc1Sooooo0olI6NH5ooooo`Ko00004Oooool4oaWVc5Gooooo1?lIi/`Vooooo`03o`000?oooooo
oooo00gooooo000Mooooo`;o00004?ooool5o`0000Gooooo0olI6NHBooooo`?o6NK<00CooooooaWV
c?lIi/co6NK<6?ooool3oaTIiPCooooo1_l0000Booooo`?o6NK<F?ooool4oaWVc2Cooooo0_l0000?
ooooo`007Oooool00ol0003oooooooooo`0Aooooo`Co00001Oooool3oaTIiQ;ooooo1OlIi/`Hoooo
o`?o6AWV0oooool5o`0001?ooooo1?lIi/aKooooo`Co6NK<8oooool00ol0003oooooooooo`0=oooo
o`007Oooool00ol0003oooooooooo`0Cooooo`Co00001?ooool2oaTIiQ;ooooo1?lIi/`Iooooo`;o
6AWV0_ooool5o`0001Cooooo1?lIi/aMooooo`Co6NK<8_ooool00ol0003oooooooooo`0=ooooo`00
7Oooool00ol0003oooooooooo`02ooooo`;o6NK<4?ooool5o`0000;ooooo0olI6NHBooooo`;o6NK<
6Oooool3oaTIiPGo00005?ooool4oaWVc67ooooo1?lIi/`Pooooo`03o`000?oooooooooo00gooooo
000Mooooo`03o`000?oooooooooo00;ooooo0_lIi/`Booooo`Go000000CooooooaTIi_lI6NKo6AWV
:oooool3oaTIiPCo00005Oooool4oaWVc6?ooooo1?lIi/`Oooooo`03o`000?oooooooooo00gooooo
000Mooooo`;o00000oooool3oaWVc1?ooooo1Ol00002oaTIiR[ooooo0olI6NH3o`0001Gooooo1?lI
i/aWooooo`Co6NK<7?ooool2o`0000oooooo000Mooooo`03o`000?oooooooooo00?ooooo0olIi/`D
ooooo`?o00000olI6NHWooooo`05o`000?lI6NKo6AWVoaTIi_l000005oooool4oaWVc6Wooooo1?lI
i/`Looooo`03o`000?oooooooooo00gooooo000Mooooo`03o`000?oooooooooo00Cooooo0olIi/`E
ooooo`;o00000olI6NHTooooo`;o00000olI6NHHooooo`?o6NK<KOooool3oaWVc1_ooooo00?o0000
ooooooooool03Oooool001gooooo00?o0000ooooooooool01Oooool3oaWVc1Kooooo00Co0000oaTI
i_lI6NKo00008Oooool3o`0000?o6AWV5oooool4oaWVc6oooooo1?lIi/`Iooooo`03o`000?oooooo
oooo00gooooo000Mooooo`03o`000?oooooooooo00Kooooo0_lIi/`Gooooo`?o6AWV0_l0000Loooo
o`Go00000olI6NHGooooo`Co6NK<LOooool4oaWVc1Sooooo00?o0000ooooooooool03Oooool001go
oooo0_l00007ooooo`?o6NK<5oooool3oaTIiP?o00006?ooool6o`0000?o6AWV5oooool3oaWVc7Go
oooo1?lIi/`Eooooo`;o00003oooool001gooooo00?o0000ooooooooool01oooool3oaWVc1Oooooo
0_lI6NH5o`0001Cooooo1Ol00002ooooo`?o6AWV6?ooool2oaWVc7Oooooo1?lIi/`Eooooo`03o`00
0?oooooooooo00gooooo000Mooooo`03o`000?oooooooooo00Sooooo0olIi/`Fooooo`?o6AWV00?o
ooooo`000?l000000ol0000@ooooo`Go00000oooool3oaTIiQSooooo0olIi/aiooooo`Co6NK<4ooo
ool00ol0003oooooooooo`0=ooooo`007Oooool00ol0003oooooooooo`09ooooo`;o6NK<5oooool3
oaTIiP;ooooo1Ol0000<ooooo`Go00001Oooool2oaTIiQSooooo0olIi/akooooo`Co6NK<4_ooool0
0ol0003oooooooooo`0=ooooo`007Oooool00ol0003oooooooooo`09ooooo`?o6NK<5oooool2oaTI
iPCooooo1?l00008ooooo`Ko00001_ooool3oaTIiQOooooo0olIi/anooooo`Co6NK<4?ooool00ol0
003oooooooooo`0=ooooo`007Oooool2o`0000_ooooo0olIi/`Fooooo`?o6AWV1Oooool4o`0000Co
oooo1_l00007ooooo`?o6AWV5oooool3oaWVc83ooooo1?lIi/`>ooooo`;o00003oooool001gooooo
00?o0000ooooooooool02oooool3oaWVc1Kooooo0olI6NH5ooooo`[o00002Oooool3oaTIiQOooooo
0olIi/b3ooooo`Co6NK<3Oooool00ol0003oooooooooo`0=ooooo`007Oooool00ol0003ooooooooo
o`0<ooooo`?o6NK<5_ooool3oaTIiPKooooo1_l0000:ooooo`?o6AWV5oooool3oaWVc8Gooooo1?lI
i/`<ooooo`03o`000?oooooooooo00gooooo000Dooooo`Go00001?ooool00ol0003oooooooooo`0=
ooooo`;o6NK<5oooool2oaTIiPSooooo0_l0000;ooooo`?o6AWV5oooool3oaWVc8Sooooo1?lIi/`:
ooooo`03o`000?oooooooooo00gooooo000Eooooo`04o`000?ooooooooooo`0000Cooooo00?o0000
ooooooooool03Oooool3oaWVc1Kooooo0olI6NHCooooo`?o6AWV5oooool3oaWVc8[ooooo1?lIi/`9
ooooo`03o`000?oooooooooo00gooooo000Fooooo`03o`000?oooooooooo00Cooooo0ol0000>oooo
o`?o6NK<5_ooool3oaTIiQ7ooooo0olI6NHHooooo`;o6NK<SOooool4oaWVc0Gooooo0ol0000?oooo
o`005oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00oooooo0olIi/`Fooooo`;o
6AWV4?ooool3oaTIiQSooooo0olIi/b>ooooo`Co6NK<1_ooool00ol0003oooooooooo`0=ooooo`00
5?ooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool04?ooool2oaWVc1Ko
oooo0olI6NH>ooooo`?o6AWV6?ooool3oaWVc97ooooo0olIi/`5ooooo`03o`000?oooooooooo00go
oooo000Dooooo`05o`000?ooooooooooooooool000001?ooool00ol0003oooooooooo`0@ooooo`?o
6NK<5_ooool3oaTIiPgooooo0_lI6NHHooooo`?o6NK<Toooool2oaWVc0Gooooo00?o0000oooooooo
ool03Oooool001Gooooo0ol00005ooooo`03o`000?oooooooooo017ooooo0olIi/`Fooooo`;o6AWV
3?ooool3oaTIiQOooooo0olIi/bKooooo`03o`000?oooooooooo00gooooo000Mooooo`;o00004ooo
ool3oaWVc1Gooooo0olI6NH:ooooo`?o6AWV5oooool3oaWVc9_ooooo0_l0000?ooooo`007Oooool0
0ol0003oooooooooo`0Cooooo`?o6NK<5Oooool3oaTIiPSooooo0olI6NHGooooo`?o6NK<WOooool0
0ol0003oooooooooo`0=ooooo`007Oooool00ol0003oooooooooo`0Dooooo`;o6NK<5_ooool2oaTI
iPOooooo0olI6NHGooooo`?o6NK<W_ooool00ol0003oooooooooo`0=ooooo`007Oooool00ol0003o
ooooooooo`0Dooooo`?o6NK<5Oooool3oaTIiPGooooo0olI6NHHooooo`;o6NK<Woooool00ol0003o
ooooooooo`0=ooooo`007Oooool00ol0003oooooooooo`0Eooooo`?o6NK<5Oooool3oaTIiP?ooooo
0olI6NHHooooo`?o6NK<Woooool00ol0003oooooooooo`0=ooooo`007Oooool2o`0001Oooooo0olI
i/`Eooooo`;o6AWV0_ooool3oaTIiQSooooo0olIi/bOooooo`;o00003oooool001gooooo00?o0000
ooooooooool05oooool2oaWVc1Gooooo1_lI6NHHooooo`?o6NK<XOooool00ol0003oooooooooo`0=
ooooo`007Oooool00ol0003oooooooooo`0Gooooo`?o6NK<5Oooool4oaTIiQSooooo0olIi/bRoooo
o`03o`000?oooooooooo00gooooo000Mooooo`03o`000?oooooooooo01Sooooo0olIi/`Eooooo`;o
6AWV6?ooool3oaWVc:?ooooo00?o0000ooooooooool03Oooool001gooooo00?o0000ooooooooool0
6Oooool3oaWVc2gooooo0olIi/bTooooo`03o`000?oooooooooo00gooooo000Mooooo`;o00006ooo
ool3oaWVc2_ooooo0olIi/bTooooo`;o00003oooool001gooooo00?o0000ooooooooool06oooool2
oaWVc2[ooooo0olIi/bVooooo`03o`000?oooooooooo00gooooo000Mooooo`03o`000?oooooooooo
01_ooooo0olIi/`Yooooo`;o6NK<Yoooool00ol0003oooooooooo`0=ooooo`007Oooool00ol0003o
ooooooooo`0Looooo`?o6NK<9oooool3oaWVc:Oooooo00?o0000ooooooooool03Oooool001gooooo
00?o0000ooooooooool07Oooool3oaWVc2Gooooo0olIi/bXooooo`03o`000?oooooooooo00gooooo
000Mooooo`;o00007oooool2oaWVc2Cooooo0olIi/bXooooo`;o00003oooool001gooooo00?o0000
ooooooooool07_ooool3oaWVc2;ooooo0olIi/bZooooo`03o`000?oooooooooo00gooooo000Eoooo
o`?o00001Oooool00ol0003oooooooooo`0Oooooo`?o6NK<8?ooool3oaWVc:_ooooo00?o0000oooo
ooooool03Oooool001Cooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo
023ooooo0olIi/`Nooooo`?o6NK<[?ooool00ol0003oooooooooo`0=ooooo`006?ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo027ooooo0olIi/`Looooo`?o6NK<[Oooool00ol0003o
ooooooooo`0=ooooo`005_ooool2o`0000Gooooo0ol0000Rooooo`;o6NK<6oooool3oaWVc:cooooo
0ol0000?ooooo`006?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo02;ooooo0olI
i/`Jooooo`;o6NK<[oooool00ol0003oooooooooo`0=ooooo`005?ooool01Ol0003ooooooooooooo
oooo000000Cooooo00?o0000ooooooooool08oooool3oaWVc1Sooooo0olIi/b_ooooo`03o`000?oo
oooooooo00gooooo000Eooooo`?o00001Oooool00ol0003oooooooooo`0Tooooo`?o6NK<5_ooool3
oaWVc;3ooooo00?o0000ooooooooool03Oooool001gooooo00?o0000ooooooooool09Oooool2oaWV
c1Gooooo0olIi/baooooo`03o`000?oooooooooo00gooooo000Mooooo`;o00009_ooool3oaWVc1?o
oooo0olIi/baooooo`;o00003oooool001gooooo00?o0000ooooooooool09_ooool3oaWVc17ooooo
0olIi/bcooooo`03o`000?oooooooooo00gooooo000Mooooo`03o`000?oooooooooo02Oooooo0olI
i/`?ooooo`?o6NK<]?ooool00ol0003oooooooooo`0=ooooo`007Oooool00ol0003oooooooooo`0X
ooooo`?o6NK<3Oooool3oaWVc;Gooooo00?o0000ooooooooool03Oooool001gooooo00?o0000oooo
ooooool0:Oooool2oaWVc0gooooo0_lIi/bfooooo`03o`000?oooooooooo00gooooo000Mooooo`;o
0000:_ooool3oaWVc0_ooooo0olIi/beooooo`;o00003oooool001gooooo00?o0000ooooooooool0
:_ooool3oaWVc0Wooooo0olIi/bgooooo`03o`000?oooooooooo00gooooo000Mooooo`03o`000?oo
oooooooo02_ooooo0olIi/`7ooooo`?o6NK<^?ooool00ol0003oooooooooo`0=ooooo`007Oooool0
0ol0003oooooooooo`0/ooooo`;o6NK<1_ooool3oaWVc;Wooooo00?o0000ooooooooool03Oooool0
01gooooo00?o0000ooooooooool0;?ooool3oaWVc0Cooooo0olIi/bjooooo`03o`000?oooooooooo
00gooooo000Mooooo`;o0000;_ooool3oaWVc0;ooooo0olIi/bjooooo`;o00003oooool001gooooo
00?o0000ooooooooool0;_ooool6oaWVc;cooooo00?o0000ooooooooool03Oooool001gooooo00?o
0000ooooooooool0;oooool4oaWVc;gooooo00?o0000ooooooooool03Oooool001gooooo00?o0000
ooooooooool0<?ooool2oaWVc;kooooo00?o0000ooooooooool03Oooool001gooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02_ooooo00?o0000oooo
ooooool0;?ooool00ol0003oooooooooo`0[ooooo`03o`000?oooooooooo02_ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`0=ooooo`007Oooooodo`0000oooooo003oooooob7ooooo
003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo002Qooooo`;o00008Oooool3o`0000go
oooo00?o0000ooooooooool0:Oooool3o`0000Cooooo00?o0000ooooooooool05_ooool00:?ooooo
00?o0000ooooooooool07oooool00ol0003oooooooooo`0;ooooo`03o`000?oooooooooo02_ooooo
00?o0000ooooooooool01?ooool00ol0003oooooooooo`0Eooooo`008oooool3o`0000;ooooo0ol0
0005ooooo`;o000000?oooooo`000?ooool00ol00009ooooo`Co000000Goooooo`000?l0003o0000
ooooo`02o`000003ooooool0003o000000;o00001oooool4o`0000;ooooo00Go0000ooooool0003o
ooooo`000002ooooo`?o00000oooool3o`0000Cooooo0_l00002ooooo`Ko000000Coooooo`000?l0
003o00000oooool4o`0000Wooooo0_l00002ooooo`?o00001?ooool4o`0000Cooooo00Co0000oooo
oooooooooooo0ol00003ooooo`?o00001?ooool2o`0000?ooooo0ol00002ooooo`?o00001Oooool0
0ol0003oooooooooo`09ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool3
o`0000;ooooo1Ol00002ooooo`?o00000oooool3o`0000;ooooo1Ol00003ooooo`;o00001?ooool0
0ol0003oooooooooo`04ooooo`03o`000?oooooooooo01Cooooo000Tooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool00oooool01_l0003oooooooooool0003oooooo`0000_ooooo00Co
0000oooooooooooo00000oooool01_l0003oooooooooool0003oooooo`0000;ooooo00?o0000oooo
ooooool02_ooool02Ol0003oooooo`000?oooooo0000ooooool0003oooooo`000003ooooo`03o`00
0?oooooo000000?ooooo00Co0000oooooooooooo00000_ooool01?l0003oooooooooool00002oooo
o`03o`000?oooooo000000Gooooo00Co0000oooooooooooo00002Oooool01?l0003oooooooooool0
0002ooooo`03o`000?oooooooooo00;ooooo00Co0000oooooooooooo00001Oooool01?l0003ooooo
ooooool00005ooooo`05o`000?ooooooooooooooool000000_ooool01_l0003oooooooooool0003o
ooooo`0000?ooooo00Co0000oooooooooooo00001_ooool00ol0003oooooooooo`09ooooo`03o`00
0?oooooooooo00?ooooo00Go0000ooooooooooooooooo`000007ooooo`05o`000?oooooooooooooo
ool000000oooool00ol0003oooooo`000003ooooo`05o`000?ooooooooooooooool000001?ooool0
1?l0003oooooooooool00003ooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool05?oo
ool002Cooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`05o`000?oooooo
ooooo`000?ooool01Ol00008ooooo`?o00000oooool01_l0003oooooooooool0003oooooo`0000;o
oooo00?o0000ooooooooool01oooool3o`0000;ooooo00Oo0000ooooool0003oooooo`000?oooooo
000000?ooooo00?o0000ooooool000000oooool01?l0003oooooooooool00005ooooo`05o`000?oo
ooooooooo`000?ooool01Ol000001Ooooooo0000oooooooooooo000000Wooooo00?o0000oooooooo
ool00oooool00ol0003oooooooooo`03ooooo`?o00001Oooool00ol0003oooooooooo`05o`000003
ooooool0003ooooo00Gooooo00?o0000ooooooooool00_ooool01Ol0003ooooooooooooooooo0000
00;ooooo00?o0000ooooooooool00oooool00ol0003oooooo`00000:ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooool000000_ooool5o`0000?ooooo00Go0000ooooooooooooooooo`000003
ooooo`03o`000?oooooo000000Oooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03
ooooo`03o`000?oooooo000000Gooooo00?o0000ooooooooool05?ooool002Cooooo00?o0000oooo
ooooool00_ooool2o`0000Cooooo00Ko0000oooooooooooo0000ooooool00003ooooo`03o`000?oo
oooooooo00Gooooo00Co0000oooooooooooo00000oooool01_l0003oooooooooool0003oooooo`00
00;ooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`03ooooo`07o`000?oooooo0000
ooooool0003oooooo`000003ooooo`03o`000?oooooo000000?ooooo00Co0000oooooooooooo0000
1Oooool01_l0003oooooooooool0003oooooo`0000?ooooo00?o0000ooooool000000_ooool00ol0
003oooooooooo`07ooooo`03o`000?oooooooooo00?ooooo0_l00003ooooo`04o`000?oooooooooo
o`0000Gooooo00Co0000oooooooooooo00000oooool00ol0003oooooo`000003ooooo`04o`000?oo
ooooooooo`0000Cooooo00Go0000ooooooooooooooooo`000002ooooo`;o00001?ooool00ol0003o
ooooo`00000:ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool000000_ooool01Ol0003o
oooooooooooooooo000000?ooooo00Go0000ooooooooooooooooo`000003ooooo`03o`000?oooooo
000000?ooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo00?ooooo00?o
0000ooooool000001Oooool00ol0003oooooooooo`0Dooooo`008_ooool01_l0003oooooo`000?oo
oooo0000ooooo`;o000000Coooooo`000?l0003ooooo0_l000000ooooooo0000o`000002ooooo`?o
00002Oooool2o`0000?ooooo1?l00003ooooo`?o00002Oooool4o`000005ooooool0003o0000oooo
ool000000oooool3o`0000?ooooo0ol00002ooooo`Co00000oooool3o`0000?ooooo0ol00003oooo
o`?o00002?ooool4o`0000;ooooo0_l000000ooooooo0000o`000002ooooo`;o00001?ooool3o`00
00?ooooo0ol00003ooooo`?o00000_ooool4o`0000?ooooo0ol00002ooooo`;o000000Coooooo`00
0?l0003ooooo0_l000000ooooooo0000o`00000:ooooo`03o`000?oooooooooo00;o000000?ooooo
o`000?l000000_ooool3o`0000Cooooo00?o0000ooooooooool00_ooool3o`0000?ooooo0ol00002
ooooo`?o00000oooool4o`0000;ooooo0_l000000ooooooo0000o`000003ooooo`03o`000?oooooo
oooo01Gooooo000Rooooo`05o`000?oooooo0000ooooool00000:?ooool00ol0003oooooooooo`0O
ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool07_ooool00ol0003oooooooooo`0=
ooooo`03o`000?oooooooooo01Cooooo00?o0000ooooooooool02Oooool00ol0003oooooooooo`0F
ooooo`008_ooool5o`0002Oooooo0_l0000Qooooo`03o`000?oooooooooo00;ooooo0_l0000<oooo
o`;o00002Oooool00ol0003oooooooooo`0Aooooo`03o`000?oooooooooo00gooooo00?o0000oooo
ooooool0;?ooool3o`00017ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0Roooo
o`00oooooolQooooo`00oooooolQooooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.768034, -2.68915, \
0.0216493, 0.0402707}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Closed]]
}, Closed]]
},
FrontEndVersion->"5.2 for Macintosh",
ScreenRectangle->{{37, 1440}, {0, 878}},
AutoGeneratedPackage->None,
ScreenStyleEnvironment->"Working",
PrintingStyleEnvironment->"Working",
WindowToolbars->"EditBar",
WindowSize->{1171, 820},
WindowMargins->{{29, Automatic}, {Automatic, 4}},
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
ShowSelection->True,
ShowCellLabel->True,
ShowCellTags->False,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
Magnification->1,
StyleDefinitions -> "Default.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Info3431059188-3291986"->{
    Cell[13003, 418, 347, 9, 23, "Print",
      CellTags->"Info3431059188-3291986"],
    Cell[13353, 429, 673, 18, 23, "Print",
      CellTags->"Info3431059188-3291986"]},
  "Info3431059219-4812943"->{
    Cell[19344, 596, 73, 1, 23, "Print",
      CellTags->"Info3431059219-4812943"],
    Cell[19420, 599, 3768, 69, 298, "Print",
      CellTags->"Info3431059219-4812943"]},
  "Info3411478494-5284832"->{
    Cell[471043, 13962, 65, 1, 23, "Print",
      CellTags->"Info3411478494-5284832"],
    Cell[471111, 13965, 643, 17, 54, "Print",
      CellTags->"Info3411478494-5284832"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Info3431059188-3291986", 1500402, 40914},
  {"Info3431059219-4812943", 1500604, 40919},
  {"Info3411478494-5284832", 1500807, 40924}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 100, 2, 69, "Section"],

Cell[CellGroupData[{
Cell[1901, 59, 61, 2, 27, "Input"],
Cell[1965, 63, 971, 15, 107, "Output"]
}, Open  ]],
Cell[2951, 81, 26, 0, 27, "Input"],
Cell[2980, 83, 160, 3, 43, "Input"],

Cell[CellGroupData[{
Cell[3165, 90, 92, 2, 38, "Subsection"],
Cell[3260, 94, 139, 6, 68, "Text"],
Cell[3402, 102, 241, 9, 86, "Text"],

Cell[CellGroupData[{
Cell[3668, 115, 126, 3, 27, "Input"],
Cell[3797, 120, 62, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3896, 126, 291, 6, 59, "Input"],
Cell[4190, 134, 39, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[4266, 140, 98, 3, 27, "Input"],
Cell[4367, 145, 61, 1, 27, "Output"]
}, Open  ]],
Cell[4443, 149, 209, 5, 43, "Input"],

Cell[CellGroupData[{
Cell[4677, 158, 98, 3, 27, "Input"],
Cell[4778, 163, 44, 1, 27, "Output"]
}, Open  ]],
Cell[4837, 167, 226, 5, 47, "Input"],

Cell[CellGroupData[{
Cell[5088, 176, 102, 3, 27, "Input"],
Cell[5193, 181, 50, 1, 27, "Output"]
}, Open  ]],
Cell[5258, 185, 551, 12, 139, "Input"],

Cell[CellGroupData[{
Cell[5834, 201, 104, 3, 27, "Input"],
Cell[5941, 206, 40, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6018, 212, 170, 4, 27, "Input"],
Cell[6191, 218, 127, 2, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6355, 225, 232, 6, 59, "Input"],
Cell[6590, 233, 42, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[6669, 239, 238, 6, 78, "Input"],
Cell[6910, 247, 45, 1, 29, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[7004, 254, 82, 2, 30, "Subsection"],
Cell[7089, 258, 1049, 20, 279, "Input"],
Cell[8141, 280, 137, 3, 27, "Input"],

Cell[CellGroupData[{
Cell[8303, 287, 186, 5, 59, "Input"],
Cell[8492, 294, 710, 18, 65, "Output"],
Cell[9205, 314, 653, 18, 65, "Output"],
Cell[9861, 334, 709, 18, 65, "Output"]
}, Open  ]],
Cell[10585, 355, 692, 14, 171, "Input"],

Cell[CellGroupData[{
Cell[11302, 373, 137, 3, 27, "Input"],
Cell[11442, 378, 1451, 31, 149, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[12930, 414, 70, 2, 27, "Input"],
Cell[13003, 418, 347, 9, 23, "Print",
  CellTags->"Info3431059188-3291986"],
Cell[13353, 429, 673, 18, 23, "Print",
  CellTags->"Info3431059188-3291986"]
}, Open  ]],
Cell[14041, 450, 1874, 33, 469, "Input"],
Cell[15918, 485, 197, 4, 27, "Input"],

Cell[CellGroupData[{
Cell[16140, 493, 129, 3, 43, "Input"],
Cell[16272, 498, 1451, 31, 149, "Output"],
Cell[17726, 531, 891, 24, 149, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[18666, 561, 113, 3, 30, "Subsection"],

Cell[CellGroupData[{
Cell[18804, 568, 269, 8, 91, "Input"],
Cell[19076, 578, 62, 1, 27, "Output"],
Cell[19141, 581, 37, 1, 27, "Output"],
Cell[19181, 584, 38, 1, 27, "Output"],
Cell[19222, 587, 35, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19294, 593, 47, 1, 27, "Input"],
Cell[19344, 596, 73, 1, 23, "Print",
  CellTags->"Info3431059219-4812943"],
Cell[19420, 599, 3768, 69, 298, "Print",
  CellTags->"Info3431059219-4812943"]
}, Open  ]],
Cell[23203, 671, 385, 8, 59, "Input"],

Cell[CellGroupData[{
Cell[23613, 683, 115, 4, 27, "Input"],
Cell[23731, 689, 2600, 34, 283, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[26368, 728, 129, 4, 27, "Input"],
Cell[26500, 734, 104612, 1748, 7037, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[131149, 2487, 73, 2, 27, "Input"],
Cell[131225, 2491, 43, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[131305, 2497, 86, 2, 27, "Input"],
Cell[131394, 2501, 54, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[131485, 2507, 455, 9, 75, "Input"],
Cell[131943, 2518, 330627, 11209, 213, 230675, 9971, "GraphicsData", \
"PostScript", "Graphics"],
Cell[462573, 13729, 135, 3, 27, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[462757, 13738, 103, 2, 30, "Subsection"],

Cell[CellGroupData[{
Cell[462885, 13744, 104, 3, 27, "Input"],
Cell[462992, 13749, 48, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[463077, 13755, 135, 4, 43, "Input"],
Cell[463215, 13761, 42, 1, 27, "Output"],
Cell[463260, 13764, 42, 1, 27, "Output"]
}, Open  ]],
Cell[463317, 13768, 115, 3, 27, "Input"],

Cell[CellGroupData[{
Cell[463457, 13775, 103, 3, 27, "Input"],
Cell[463563, 13780, 42, 1, 27, "Output"]
}, Open  ]],
Cell[463620, 13784, 118, 3, 42, "Input"],

Cell[CellGroupData[{
Cell[463763, 13791, 69, 2, 27, "Input"],
Cell[463835, 13795, 2285, 44, 95, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[466157, 13844, 44, 1, 27, "Input"],
Cell[466204, 13847, 183, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[466424, 13855, 123, 3, 42, "Input"],
Cell[466550, 13860, 182, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[466769, 13868, 179, 5, 59, "Input"],
Cell[466951, 13875, 1441, 26, 137, "Output"],
Cell[468395, 13903, 2330, 45, 117, "Output"],
Cell[470728, 13950, 213, 3, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[470978, 13958, 62, 2, 27, "Input"],
Cell[471043, 13962, 65, 1, 23, "Print",
  CellTags->"Info3411478494-5284832"],
Cell[471111, 13965, 643, 17, 54, "Print",
  CellTags->"Info3411478494-5284832"]
}, Open  ]],

Cell[CellGroupData[{
Cell[471791, 13987, 158, 4, 27, "Input"],
Cell[471952, 13993, 53, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[472042, 13999, 181, 4, 27, "Input"],
Cell[472226, 14005, 53, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[472316, 14011, 182, 4, 27, "Input"],
Cell[472501, 14017, 53, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[472591, 14023, 109, 3, 43, "Input"],
Cell[472703, 14028, 43, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[472783, 14034, 272, 8, 107, "Input"],
Cell[473058, 14044, 62, 1, 27, "Output"],
Cell[473123, 14047, 322, 4, 43, "Output"],
Cell[473448, 14053, 35, 1, 27, "Output"],
Cell[473486, 14056, 38, 1, 27, "Output"],
Cell[473527, 14059, 36, 1, 27, "Output"],
Cell[473566, 14062, 35, 1, 27, "Output"]
}, Open  ]],
Cell[473616, 14066, 105, 2, 32, "Text"],

Cell[CellGroupData[{
Cell[473746, 14072, 619, 12, 91, "Input"],
Cell[474368, 14086, 99, 2, 22, "Print"],
Cell[474470, 14090, 99, 2, 22, "Print"],
Cell[474572, 14094, 99, 2, 22, "Print"],
Cell[474674, 14098, 51, 1, 22, "Print"],
Cell[474728, 14101, 42, 1, 22, "Print"],
Cell[474773, 14104, 99, 2, 22, "Print"],
Cell[474875, 14108, 663, 15, 31, "Print"],
Cell[475541, 14125, 45, 1, 22, "Print"],
Cell[475589, 14128, 590, 14, 33, "Print"],
Cell[476182, 14144, 45, 1, 22, "Print"],
Cell[476230, 14147, 657, 15, 31, "Print"],
Cell[476890, 14164, 45, 1, 22, "Print"],
Cell[476938, 14167, 46, 1, 22, "Print"],
Cell[476987, 14170, 323, 5, 21, "Message"],
Cell[477313, 14177, 197, 5, 22, "Print"],
Cell[477513, 14184, 45, 1, 22, "Print"],
Cell[477561, 14187, 99, 2, 22, "Print"],
Cell[477663, 14191, 45, 1, 22, "Print"],
Cell[477711, 14194, 226, 4, 22, "Print"],
Cell[477940, 14200, 681, 13, 24, "Print"],
Cell[478624, 14215, 284, 5, 22, "Print"],
Cell[478911, 14222, 102, 2, 22, "Print"],
Cell[479016, 14226, 159, 3, 22, "Print"],
Cell[479178, 14231, 830, 18, 22, "Print"],
Cell[480011, 14251, 826, 18, 22, "Print"],
Cell[480840, 14271, 826, 18, 22, "Print"],
Cell[481669, 14291, 828, 18, 22, "Print"],
Cell[482500, 14311, 394, 10, 22, "Print"],
Cell[482897, 14323, 394, 10, 22, "Print"],
Cell[483294, 14335, 412, 10, 22, "Print"],
Cell[483709, 14347, 45, 1, 22, "Print"],
Cell[483757, 14350, 5913, 159, 111, "Print"],
Cell[489673, 14511, 45, 1, 22, "Print"],
Cell[489721, 14514, 680, 13, 24, "Print"],
Cell[490404, 14529, 180, 3, 24, "Print"],
Cell[490587, 14534, 266, 5, 22, "Print"],
Cell[490856, 14541, 298, 6, 22, "Print"],
Cell[491157, 14549, 102, 2, 22, "Print"],
Cell[491262, 14553, 159, 3, 22, "Print"],
Cell[491424, 14558, 828, 18, 22, "Print"],
Cell[492255, 14578, 828, 18, 22, "Print"],
Cell[493086, 14598, 828, 18, 22, "Print"],
Cell[493917, 14618, 828, 18, 22, "Print"],
Cell[494748, 14638, 394, 10, 22, "Print"],
Cell[495145, 14650, 394, 10, 22, "Print"],
Cell[495542, 14662, 412, 10, 22, "Print"],
Cell[495957, 14674, 45, 1, 22, "Print"],
Cell[496005, 14677, 6094, 159, 111, "Print"],
Cell[502102, 14838, 45, 1, 22, "Print"],
Cell[502150, 14841, 681, 13, 24, "Print"],
Cell[502834, 14856, 181, 3, 24, "Print"],
Cell[503018, 14861, 266, 5, 22, "Print"],
Cell[503287, 14868, 299, 6, 22, "Print"],
Cell[503589, 14876, 102, 2, 22, "Print"],
Cell[503694, 14880, 159, 3, 22, "Print"],
Cell[503856, 14885, 828, 18, 22, "Print"],
Cell[504687, 14905, 828, 18, 22, "Print"],
Cell[505518, 14925, 828, 18, 22, "Print"],
Cell[506349, 14945, 828, 18, 22, "Print"],
Cell[507180, 14965, 394, 10, 22, "Print"],
Cell[507577, 14977, 394, 10, 22, "Print"],
Cell[507974, 14989, 416, 10, 22, "Print"],
Cell[508393, 15001, 45, 1, 22, "Print"],
Cell[508441, 15004, 6100, 159, 111, "Print"],
Cell[514544, 15165, 45, 1, 22, "Print"],
Cell[514592, 15168, 683, 13, 24, "Print"],
Cell[515278, 15183, 179, 3, 24, "Print"],
Cell[515460, 15188, 267, 5, 22, "Print"],
Cell[515730, 15195, 299, 6, 22, "Print"],
Cell[516032, 15203, 102, 2, 22, "Print"],
Cell[516137, 15207, 159, 3, 22, "Print"],
Cell[516299, 15212, 828, 18, 22, "Print"],
Cell[517130, 15232, 828, 18, 22, "Print"],
Cell[517961, 15252, 828, 18, 22, "Print"],
Cell[518792, 15272, 828, 18, 22, "Print"],
Cell[519623, 15292, 394, 10, 22, "Print"],
Cell[520020, 15304, 394, 10, 22, "Print"],
Cell[520417, 15316, 414, 10, 22, "Print"],
Cell[520834, 15328, 45, 1, 22, "Print"],
Cell[520882, 15331, 6100, 159, 111, "Print"],
Cell[526985, 15492, 45, 1, 22, "Print"],
Cell[527033, 15495, 680, 13, 24, "Print"],
Cell[527716, 15510, 180, 3, 24, "Print"],
Cell[527899, 15515, 257, 4, 22, "Print"],
Cell[528159, 15521, 300, 6, 22, "Print"],
Cell[528462, 15529, 102, 2, 22, "Print"],
Cell[528567, 15533, 159, 3, 22, "Print"],
Cell[528729, 15538, 828, 18, 22, "Print"],
Cell[529560, 15558, 828, 18, 22, "Print"],
Cell[530391, 15578, 828, 18, 22, "Print"],
Cell[531222, 15598, 828, 18, 22, "Print"],
Cell[532053, 15618, 394, 10, 22, "Print"],
Cell[532450, 15630, 394, 10, 22, "Print"],
Cell[532847, 15642, 414, 10, 22, "Print"],
Cell[533264, 15654, 45, 1, 22, "Print"],
Cell[533312, 15657, 6094, 159, 111, "Print"],
Cell[539409, 15818, 45, 1, 22, "Print"],
Cell[539457, 15821, 681, 13, 24, "Print"],
Cell[540141, 15836, 180, 3, 24, "Print"],
Cell[540324, 15841, 266, 5, 22, "Print"],
Cell[540593, 15848, 299, 6, 22, "Print"],
Cell[540895, 15856, 102, 2, 22, "Print"],
Cell[541000, 15860, 159, 3, 22, "Print"],
Cell[541162, 15865, 828, 18, 22, "Print"],
Cell[541993, 15885, 828, 18, 22, "Print"],
Cell[542824, 15905, 828, 18, 22, "Print"],
Cell[543655, 15925, 394, 10, 22, "Print"],
Cell[544052, 15937, 394, 10, 22, "Print"],
Cell[544449, 15949, 416, 10, 22, "Print"],
Cell[544868, 15961, 45, 1, 22, "Print"],
Cell[544916, 15964, 6099, 159, 111, "Print"],
Cell[551018, 16125, 45, 1, 22, "Print"],
Cell[551066, 16128, 681, 13, 24, "Print"],
Cell[551750, 16143, 181, 3, 24, "Print"],
Cell[551934, 16148, 266, 5, 22, "Print"],
Cell[552203, 16155, 299, 6, 22, "Print"],
Cell[552505, 16163, 102, 2, 22, "Print"],
Cell[552610, 16167, 159, 3, 22, "Print"],
Cell[552772, 16172, 828, 18, 22, "Print"],
Cell[553603, 16192, 828, 18, 22, "Print"],
Cell[554434, 16212, 828, 18, 22, "Print"],
Cell[555265, 16232, 394, 10, 22, "Print"],
Cell[555662, 16244, 394, 10, 22, "Print"],
Cell[556059, 16256, 416, 10, 22, "Print"],
Cell[556478, 16268, 45, 1, 22, "Print"],
Cell[556526, 16271, 6100, 159, 111, "Print"],
Cell[562629, 16432, 45, 1, 22, "Print"],
Cell[562677, 16435, 683, 13, 24, "Print"],
Cell[563363, 16450, 181, 3, 24, "Print"],
Cell[563547, 16455, 264, 5, 22, "Print"],
Cell[563814, 16462, 300, 6, 22, "Print"],
Cell[564117, 16470, 102, 2, 22, "Print"],
Cell[564222, 16474, 159, 3, 22, "Print"],
Cell[564384, 16479, 828, 18, 22, "Print"],
Cell[565215, 16499, 828, 18, 22, "Print"],
Cell[566046, 16519, 828, 18, 22, "Print"],
Cell[566877, 16539, 394, 10, 22, "Print"],
Cell[567274, 16551, 394, 10, 22, "Print"],
Cell[567671, 16563, 414, 10, 22, "Print"],
Cell[568088, 16575, 45, 1, 22, "Print"],
Cell[568136, 16578, 6093, 159, 111, "Print"],
Cell[574232, 16739, 45, 1, 22, "Print"],
Cell[574280, 16742, 679, 13, 24, "Print"],
Cell[574962, 16757, 181, 3, 24, "Print"],
Cell[575146, 16762, 264, 5, 22, "Print"],
Cell[575413, 16769, 300, 6, 22, "Print"],
Cell[575716, 16777, 102, 2, 22, "Print"],
Cell[575821, 16781, 159, 3, 22, "Print"],
Cell[575983, 16786, 828, 18, 22, "Print"],
Cell[576814, 16806, 828, 18, 22, "Print"],
Cell[577645, 16826, 826, 18, 22, "Print"],
Cell[578474, 16846, 392, 10, 22, "Print"],
Cell[578869, 16858, 394, 10, 22, "Print"],
Cell[579266, 16870, 416, 10, 22, "Print"],
Cell[579685, 16882, 45, 1, 22, "Print"],
Cell[579733, 16885, 6107, 159, 111, "Print"],
Cell[585843, 17046, 45, 1, 22, "Print"],
Cell[585891, 17049, 681, 13, 24, "Print"],
Cell[586575, 17064, 180, 3, 24, "Print"],
Cell[586758, 17069, 265, 5, 22, "Print"],
Cell[587026, 17076, 300, 6, 22, "Print"],
Cell[587329, 17084, 102, 2, 22, "Print"],
Cell[587434, 17088, 161, 3, 22, "Print"],
Cell[587598, 17093, 394, 10, 22, "Print"],
Cell[587995, 17105, 392, 10, 22, "Print"],
Cell[588390, 17117, 414, 10, 22, "Print"],
Cell[588807, 17129, 45, 1, 22, "Print"],
Cell[588855, 17132, 6095, 159, 111, "Print"],
Cell[594953, 17293, 45, 1, 22, "Print"],
Cell[595001, 17296, 682, 13, 24, "Print"],
Cell[595686, 17311, 181, 3, 24, "Print"],
Cell[595870, 17316, 266, 5, 22, "Print"],
Cell[596139, 17323, 301, 6, 22, "Print"],
Cell[596443, 17331, 102, 2, 22, "Print"],
Cell[596548, 17335, 161, 3, 22, "Print"],
Cell[596712, 17340, 394, 10, 22, "Print"],
Cell[597109, 17352, 394, 10, 22, "Print"],
Cell[597506, 17364, 416, 10, 22, "Print"],
Cell[597925, 17376, 45, 1, 22, "Print"],
Cell[597973, 17379, 6105, 159, 111, "Print"],
Cell[604081, 17540, 45, 1, 22, "Print"],
Cell[604129, 17543, 678, 13, 24, "Print"],
Cell[604810, 17558, 178, 3, 24, "Print"],
Cell[604991, 17563, 264, 5, 22, "Print"],
Cell[605258, 17570, 303, 6, 22, "Print"],
Cell[605564, 17578, 102, 2, 22, "Print"],
Cell[605669, 17582, 161, 3, 22, "Print"],
Cell[605833, 17587, 394, 10, 22, "Print"],
Cell[606230, 17599, 394, 10, 22, "Print"],
Cell[606627, 17611, 420, 10, 22, "Print"],
Cell[607050, 17623, 45, 1, 22, "Print"],
Cell[607098, 17626, 6122, 159, 111, "Print"],
Cell[613223, 17787, 45, 1, 22, "Print"],
Cell[613271, 17790, 680, 13, 24, "Print"],
Cell[613954, 17805, 181, 3, 24, "Print"],
Cell[614138, 17810, 265, 5, 22, "Print"],
Cell[614406, 17817, 305, 6, 22, "Print"],
Cell[614714, 17825, 102, 2, 22, "Print"],
Cell[614819, 17829, 161, 3, 22, "Print"],
Cell[614983, 17834, 394, 10, 22, "Print"],
Cell[615380, 17846, 394, 10, 22, "Print"],
Cell[615777, 17858, 432, 10, 24, "Print"],
Cell[616212, 17870, 45, 1, 22, "Print"],
Cell[616260, 17873, 6022, 159, 111, "Print"],
Cell[622285, 18034, 45, 1, 22, "Print"],
Cell[622333, 18037, 682, 13, 24, "Print"],
Cell[623018, 18052, 182, 3, 24, "Print"],
Cell[623203, 18057, 264, 5, 22, "Print"],
Cell[623470, 18064, 304, 6, 24, "Print"],
Cell[623777, 18072, 102, 2, 22, "Print"],
Cell[623882, 18076, 161, 3, 22, "Print"],
Cell[624046, 18081, 394, 10, 22, "Print"],
Cell[624443, 18093, 394, 10, 22, "Print"],
Cell[624840, 18105, 434, 10, 24, "Print"],
Cell[625277, 18117, 45, 1, 22, "Print"],
Cell[625325, 18120, 5955, 159, 111, "Print"],
Cell[631283, 18281, 45, 1, 22, "Print"],
Cell[631331, 18284, 681, 13, 24, "Print"],
Cell[632015, 18299, 182, 3, 24, "Print"],
Cell[632200, 18304, 272, 5, 24, "Print"],
Cell[632475, 18311, 304, 6, 24, "Print"],
Cell[632782, 18319, 49, 1, 22, "Print"],
Cell[632834, 18322, 49, 1, 22, "Print"],
Cell[632886, 18325, 49, 1, 22, "Print"],
Cell[632938, 18328, 233, 4, 22, "Print"],
Cell[633174, 18334, 776, 21, 115, "Print"],
Cell[633953, 18357, 45, 1, 22, "Print"],
Cell[634001, 18360, 5011, 93, 171, "Print"],
Cell[639015, 18455, 663, 12, 24, "Print"],
Cell[639681, 18469, 91, 1, 22, "Print"],
Cell[639775, 18472, 80, 1, 22, "Print"],
Cell[639858, 18475, 91, 1, 22, "Print"],
Cell[639952, 18478, 2308, 48, 115, "Print"],
Cell[642263, 18528, 89, 1, 22, "Print"],
Cell[642355, 18531, 45, 1, 22, "Print"],
Cell[642403, 18534, 89, 1, 22, "Print"],
Cell[642495, 18537, 540, 14, 31, "Print"],
Cell[643038, 18553, 67, 1, 22, "Print"],
Cell[643108, 18556, 89, 1, 22, "Print"],
Cell[643200, 18559, 66, 1, 22, "Print"],
Cell[643269, 18562, 89, 1, 22, "Print"],
Cell[643361, 18565, 89, 1, 22, "Print"],
Cell[643453, 18568, 208, 4, 22, "Print"],
Cell[643664, 18574, 1370, 30, 111, "Print"],
Cell[645037, 18606, 90, 1, 22, "Print"],
Cell[645130, 18609, 74, 1, 22, "Print"],
Cell[645207, 18612, 90, 1, 22, "Print"],
Cell[645300, 18615, 3357, 64, 117, "Print"],
Cell[648660, 18681, 91, 1, 22, "Print"],
Cell[648754, 18684, 97, 2, 22, "Print"],
Cell[648854, 18688, 91, 1, 22, "Print"],
Cell[648948, 18691, 3466, 66, 129, "Print"],
Cell[652417, 18759, 45, 1, 22, "Print"],
Cell[652465, 18762, 261, 4, 22, "Print"],
Cell[652729, 18768, 91, 1, 22, "Print"],
Cell[652823, 18771, 108, 2, 22, "Print"],
Cell[652934, 18775, 91, 1, 22, "Print"],
Cell[653028, 18778, 3140, 60, 111, "Print"],
Cell[656171, 18840, 45, 1, 22, "Print"],
Cell[656219, 18843, 229, 3, 22, "Print"],
Cell[656451, 18848, 91, 1, 22, "Print"],
Cell[656545, 18851, 58, 1, 22, "Print"],
Cell[656606, 18854, 91, 1, 22, "Print"],
Cell[656700, 18857, 201, 4, 22, "Print"],
Cell[656904, 18863, 109, 2, 22, "Print"],
Cell[657016, 18867, 741, 17, 51, "Print"]
}, Closed]],

Cell[CellGroupData[{
Cell[657794, 18889, 1053, 25, 88, "Input"],
Cell[658850, 18916, 383, 6, 21, "Message"],
Cell[659236, 18924, 122, 3, 22, "Print"],
Cell[659361, 18929, 122, 3, 22, "Print"],
Cell[659486, 18934, 122, 3, 22, "Print"],
Cell[659611, 18939, 74, 2, 22, "Print"],
Cell[659688, 18943, 65, 2, 22, "Print"],
Cell[659756, 18947, 122, 3, 22, "Print"],
Cell[659881, 18952, 690, 16, 31, "Print"],
Cell[660574, 18970, 68, 2, 22, "Print"],
Cell[660645, 18974, 613, 15, 33, "Print"],
Cell[661261, 18991, 68, 2, 22, "Print"],
Cell[661332, 18995, 680, 16, 31, "Print"],
Cell[662015, 19013, 68, 2, 22, "Print"],
Cell[662086, 19017, 69, 2, 22, "Print"],
Cell[662158, 19021, 346, 6, 21, "Message"],
Cell[662507, 19029, 220, 6, 22, "Print"],
Cell[662730, 19037, 68, 2, 22, "Print"],
Cell[662801, 19041, 122, 3, 22, "Print"],
Cell[662926, 19046, 68, 2, 22, "Print"],
Cell[662997, 19050, 249, 5, 22, "Print"],
Cell[663249, 19057, 704, 14, 41, "Print"],
Cell[663956, 19073, 299, 6, 22, "Print"],
Cell[664258, 19081, 125, 3, 23, "Print"],
Cell[664386, 19086, 182, 4, 23, "Print"],
Cell[664571, 19092, 853, 19, 23, "Print"],
Cell[665427, 19113, 851, 19, 23, "Print"],
Cell[666281, 19134, 851, 19, 23, "Print"],
Cell[667135, 19155, 851, 19, 23, "Print"],
Cell[667989, 19176, 417, 11, 23, "Print"],
Cell[668409, 19189, 417, 11, 23, "Print"],
Cell[668829, 19202, 435, 11, 23, "Print"],
Cell[669267, 19215, 68, 2, 23, "Print"],
Cell[669338, 19219, 5931, 160, 111, "Print"],
Cell[675272, 19381, 68, 2, 23, "Print"],
Cell[675343, 19385, 9009, 260, 149, "Print"],
Cell[684355, 19647, 705, 14, 43, "Print"],
Cell[685063, 19663, 203, 4, 25, "Print"],
Cell[685269, 19669, 290, 6, 23, "Print"],
Cell[685562, 19677, 322, 7, 23, "Print"],
Cell[685887, 19686, 125, 3, 23, "Print"],
Cell[686015, 19691, 182, 4, 23, "Print"],
Cell[686200, 19697, 851, 19, 23, "Print"],
Cell[687054, 19718, 851, 19, 23, "Print"],
Cell[687908, 19739, 851, 19, 23, "Print"],
Cell[688762, 19760, 851, 19, 23, "Print"],
Cell[689616, 19781, 417, 11, 23, "Print"],
Cell[690036, 19794, 417, 11, 23, "Print"],
Cell[690456, 19807, 433, 11, 23, "Print"],
Cell[690892, 19820, 68, 2, 23, "Print"],
Cell[690963, 19824, 6115, 160, 111, "Print"],
Cell[697081, 19986, 68, 2, 23, "Print"],
Cell[697152, 19990, 10791, 260, 149, "Print"],
Cell[707946, 20252, 701, 14, 43, "Print"],
Cell[708650, 20268, 203, 4, 25, "Print"],
Cell[708856, 20274, 288, 6, 23, "Print"],
Cell[709147, 20282, 322, 7, 23, "Print"],
Cell[709472, 20291, 125, 3, 23, "Print"],
Cell[709600, 20296, 182, 4, 23, "Print"],
Cell[709785, 20302, 851, 19, 23, "Print"],
Cell[710639, 20323, 851, 19, 23, "Print"],
Cell[711493, 20344, 851, 19, 23, "Print"],
Cell[712347, 20365, 849, 19, 23, "Print"],
Cell[713199, 20386, 415, 11, 23, "Print"],
Cell[713617, 20399, 417, 11, 23, "Print"],
Cell[714037, 20412, 439, 11, 23, "Print"],
Cell[714479, 20425, 68, 2, 23, "Print"],
Cell[714550, 20429, 6127, 160, 111, "Print"],
Cell[720680, 20591, 68, 2, 23, "Print"],
Cell[720751, 20595, 10810, 260, 149, "Print"],
Cell[731564, 20857, 704, 14, 43, "Print"],
Cell[732271, 20873, 203, 4, 25, "Print"],
Cell[732477, 20879, 290, 6, 23, "Print"],
Cell[732770, 20887, 323, 7, 23, "Print"],
Cell[733096, 20896, 125, 3, 23, "Print"],
Cell[733224, 20901, 182, 4, 23, "Print"],
Cell[733409, 20907, 849, 19, 23, "Print"],
Cell[734261, 20928, 849, 19, 23, "Print"],
Cell[735113, 20949, 849, 19, 23, "Print"],
Cell[735965, 20970, 849, 19, 23, "Print"],
Cell[736817, 20991, 417, 11, 23, "Print"],
Cell[737237, 21004, 415, 11, 23, "Print"],
Cell[737655, 21017, 437, 11, 23, "Print"],
Cell[738095, 21030, 68, 2, 23, "Print"],
Cell[738166, 21034, 6122, 160, 111, "Print"],
Cell[744291, 21196, 68, 2, 23, "Print"],
Cell[744362, 21200, 10804, 260, 149, "Print"],
Cell[755169, 21462, 706, 14, 43, "Print"],
Cell[755878, 21478, 203, 4, 25, "Print"],
Cell[756084, 21484, 287, 6, 23, "Print"],
Cell[756374, 21492, 323, 7, 23, "Print"],
Cell[756700, 21501, 125, 3, 23, "Print"],
Cell[756828, 21506, 182, 4, 23, "Print"],
Cell[757013, 21512, 851, 19, 23, "Print"],
Cell[757867, 21533, 851, 19, 23, "Print"],
Cell[758721, 21554, 851, 19, 23, "Print"],
Cell[759575, 21575, 851, 19, 23, "Print"],
Cell[760429, 21596, 417, 11, 23, "Print"],
Cell[760849, 21609, 417, 11, 23, "Print"],
Cell[761269, 21622, 439, 11, 23, "Print"],
Cell[761711, 21635, 68, 2, 23, "Print"],
Cell[761782, 21639, 6128, 160, 111, "Print"],
Cell[767913, 21801, 68, 2, 23, "Print"],
Cell[767984, 21805, 10824, 260, 149, "Print"],
Cell[778811, 22067, 704, 14, 43, "Print"],
Cell[779518, 22083, 204, 4, 25, "Print"],
Cell[779725, 22089, 280, 5, 23, "Print"],
Cell[780008, 22096, 322, 7, 23, "Print"],
Cell[780333, 22105, 125, 3, 23, "Print"],
Cell[780461, 22110, 182, 4, 23, "Print"],
Cell[780646, 22116, 851, 19, 23, "Print"],
Cell[781500, 22137, 851, 19, 23, "Print"],
Cell[782354, 22158, 851, 19, 23, "Print"],
Cell[783208, 22179, 417, 11, 23, "Print"],
Cell[783628, 22192, 417, 11, 23, "Print"],
Cell[784048, 22205, 439, 11, 23, "Print"],
Cell[784490, 22218, 68, 2, 23, "Print"],
Cell[784561, 22222, 6127, 160, 111, "Print"],
Cell[790691, 22384, 68, 2, 23, "Print"],
Cell[790762, 22388, 10806, 260, 149, "Print"],
Cell[801571, 22650, 706, 14, 43, "Print"],
Cell[802280, 22666, 204, 4, 25, "Print"],
Cell[802487, 22672, 279, 5, 23, "Print"],
Cell[802769, 22679, 322, 7, 23, "Print"],
Cell[803094, 22688, 125, 3, 23, "Print"],
Cell[803222, 22693, 182, 4, 23, "Print"],
Cell[803407, 22699, 851, 19, 23, "Print"],
Cell[804261, 22720, 849, 19, 23, "Print"],
Cell[805113, 22741, 851, 19, 23, "Print"],
Cell[805967, 22762, 417, 11, 23, "Print"],
Cell[806387, 22775, 417, 11, 23, "Print"],
Cell[806807, 22788, 439, 11, 23, "Print"],
Cell[807249, 22801, 68, 2, 23, "Print"],
Cell[807320, 22805, 6134, 160, 111, "Print"],
Cell[813457, 22967, 68, 2, 23, "Print"],
Cell[813528, 22971, 10808, 260, 149, "Print"],
Cell[824339, 23233, 705, 14, 43, "Print"],
Cell[825047, 23249, 203, 4, 25, "Print"],
Cell[825253, 23255, 287, 6, 23, "Print"],
Cell[825543, 23263, 323, 7, 23, "Print"],
Cell[825869, 23272, 125, 3, 23, "Print"],
Cell[825997, 23277, 182, 4, 23, "Print"],
Cell[826182, 23283, 851, 19, 23, "Print"],
Cell[827036, 23304, 849, 19, 23, "Print"],
Cell[827888, 23325, 851, 19, 23, "Print"],
Cell[828742, 23346, 417, 11, 23, "Print"],
Cell[829162, 23359, 417, 11, 23, "Print"],
Cell[829582, 23372, 435, 11, 23, "Print"],
Cell[830020, 23385, 68, 2, 23, "Print"],
Cell[830091, 23389, 6104, 160, 111, "Print"],
Cell[836198, 23551, 68, 2, 23, "Print"],
Cell[836269, 23555, 10812, 260, 149, "Print"],
Cell[847084, 23817, 705, 14, 43, "Print"],
Cell[847792, 23833, 203, 4, 25, "Print"],
Cell[847998, 23839, 287, 6, 23, "Print"],
Cell[848288, 23847, 324, 7, 23, "Print"],
Cell[848615, 23856, 125, 3, 23, "Print"],
Cell[848743, 23861, 182, 4, 23, "Print"],
Cell[848928, 23867, 851, 19, 23, "Print"],
Cell[849782, 23888, 851, 19, 23, "Print"],
Cell[850636, 23909, 849, 19, 23, "Print"],
Cell[851488, 23930, 415, 11, 23, "Print"],
Cell[851906, 23943, 417, 11, 23, "Print"],
Cell[852326, 23956, 439, 11, 23, "Print"],
Cell[852768, 23969, 68, 2, 23, "Print"],
Cell[852839, 23973, 6131, 160, 111, "Print"],
Cell[858973, 24135, 68, 2, 23, "Print"],
Cell[859044, 24139, 10801, 260, 149, "Print"],
Cell[869848, 24401, 704, 14, 43, "Print"],
Cell[870555, 24417, 203, 4, 25, "Print"],
Cell[870761, 24423, 288, 6, 23, "Print"],
Cell[871052, 24431, 324, 7, 23, "Print"],
Cell[871379, 24440, 125, 3, 23, "Print"],
Cell[871507, 24445, 184, 4, 23, "Print"],
Cell[871694, 24451, 417, 11, 23, "Print"],
Cell[872114, 24464, 415, 11, 23, "Print"],
Cell[872532, 24477, 437, 11, 23, "Print"],
Cell[872972, 24490, 68, 2, 23, "Print"],
Cell[873043, 24494, 6117, 160, 111, "Print"],
Cell[879163, 24656, 68, 2, 23, "Print"],
Cell[879234, 24660, 10812, 260, 149, "Print"],
Cell[890049, 24922, 705, 14, 43, "Print"],
Cell[890757, 24938, 204, 4, 25, "Print"],
Cell[890964, 24944, 290, 6, 23, "Print"],
Cell[891257, 24952, 324, 7, 23, "Print"],
Cell[891584, 24961, 125, 3, 23, "Print"],
Cell[891712, 24966, 184, 4, 23, "Print"],
Cell[891899, 24972, 417, 11, 23, "Print"],
Cell[892319, 24985, 417, 11, 23, "Print"],
Cell[892739, 24998, 439, 11, 23, "Print"],
Cell[893181, 25011, 68, 2, 23, "Print"],
Cell[893252, 25015, 6128, 160, 111, "Print"],
Cell[899383, 25177, 68, 2, 23, "Print"],
Cell[899454, 25181, 10843, 260, 149, "Print"],
Cell[910300, 25443, 704, 14, 43, "Print"],
Cell[911007, 25459, 203, 4, 25, "Print"],
Cell[911213, 25465, 287, 6, 23, "Print"],
Cell[911503, 25473, 326, 7, 23, "Print"],
Cell[911832, 25482, 125, 3, 23, "Print"],
Cell[911960, 25487, 184, 4, 23, "Print"],
Cell[912147, 25493, 417, 11, 23, "Print"],
Cell[912567, 25506, 417, 11, 23, "Print"],
Cell[912987, 25519, 443, 11, 23, "Print"],
Cell[913433, 25532, 68, 2, 23, "Print"],
Cell[913504, 25536, 6145, 160, 111, "Print"],
Cell[919652, 25698, 68, 2, 23, "Print"],
Cell[919723, 25702, 10829, 260, 149, "Print"],
Cell[930555, 25964, 701, 14, 43, "Print"],
Cell[931259, 25980, 204, 4, 25, "Print"],
Cell[931466, 25986, 288, 6, 23, "Print"],
Cell[931757, 25994, 328, 7, 23, "Print"],
Cell[932088, 26003, 125, 3, 23, "Print"],
Cell[932216, 26008, 184, 4, 23, "Print"],
Cell[932403, 26014, 417, 11, 23, "Print"],
Cell[932823, 26027, 417, 11, 23, "Print"],
Cell[933243, 26040, 457, 11, 25, "Print"],
Cell[933703, 26053, 68, 2, 23, "Print"],
Cell[933774, 26057, 6044, 160, 111, "Print"],
Cell[939821, 26219, 68, 2, 23, "Print"],
Cell[939892, 26223, 10828, 260, 149, "Print"],
Cell[950723, 26485, 703, 14, 43, "Print"],
Cell[951429, 26501, 205, 4, 25, "Print"],
Cell[951637, 26507, 287, 6, 23, "Print"],
Cell[951927, 26515, 325, 7, 25, "Print"],
Cell[952255, 26524, 125, 3, 23, "Print"],
Cell[952383, 26529, 184, 4, 23, "Print"],
Cell[952570, 26535, 417, 11, 23, "Print"],
Cell[952990, 26548, 417, 11, 23, "Print"],
Cell[953410, 26561, 458, 11, 25, "Print"],
Cell[953871, 26574, 68, 2, 23, "Print"],
Cell[953942, 26578, 5981, 160, 111, "Print"],
Cell[959926, 26740, 68, 2, 23, "Print"],
Cell[959997, 26744, 10836, 260, 149, "Print"],
Cell[970836, 27006, 704, 14, 43, "Print"],
Cell[971543, 27022, 203, 4, 25, "Print"],
Cell[971749, 27028, 294, 6, 25, "Print"],
Cell[972046, 27036, 325, 7, 25, "Print"],
Cell[972374, 27045, 72, 2, 23, "Print"],
Cell[972449, 27049, 125, 3, 23, "Print"],
Cell[972577, 27054, 184, 4, 23, "Print"],
Cell[972764, 27060, 851, 19, 23, "Print"],
Cell[973618, 27081, 851, 19, 23, "Print"],
Cell[974472, 27102, 72, 2, 23, "Print"],
Cell[974547, 27106, 256, 5, 23, "Print"],
Cell[974806, 27113, 818, 22, 117, "Print"],
Cell[975627, 27137, 68, 2, 23, "Print"],
Cell[975698, 27141, 10826, 260, 149, "Print"],
Cell[986527, 27403, 5306, 96, 181, "Print"],
Cell[991836, 27501, 686, 13, 43, "Print"],
Cell[992525, 27516, 114, 2, 23, "Print"],
Cell[992642, 27520, 103, 2, 23, "Print"],
Cell[992748, 27524, 114, 2, 23, "Print"],
Cell[992865, 27528, 2001, 37, 117, "Print"],
Cell[994869, 27567, 112, 2, 23, "Print"],
Cell[994984, 27571, 68, 2, 23, "Print"],
Cell[995055, 27575, 112, 2, 23, "Print"],
Cell[995170, 27579, 564, 15, 31, "Print"],
Cell[995737, 27596, 90, 2, 23, "Print"],
Cell[995830, 27600, 112, 2, 23, "Print"],
Cell[995945, 27604, 89, 2, 23, "Print"],
Cell[996037, 27608, 112, 2, 23, "Print"],
Cell[996152, 27612, 112, 2, 23, "Print"],
Cell[996267, 27616, 231, 5, 23, "Print"],
Cell[996501, 27623, 1392, 31, 111, "Print"],
Cell[997896, 27656, 113, 2, 23, "Print"],
Cell[998012, 27660, 97, 2, 23, "Print"],
Cell[998112, 27664, 113, 2, 23, "Print"],
Cell[998228, 27668, 2742, 49, 157, "Print"],
Cell[1000973, 27719, 114, 2, 23, "Print"],
Cell[1001090, 27723, 120, 3, 22, "Print"],
Cell[1001213, 27728, 114, 2, 22, "Print"],
Cell[1001330, 27732, 2897, 51, 175, "Print"],
Cell[1004230, 27785, 68, 2, 22, "Print"],
Cell[1004301, 27789, 287, 5, 22, "Print"],
Cell[1004591, 27796, 114, 2, 22, "Print"],
Cell[1004708, 27800, 131, 3, 22, "Print"],
Cell[1004842, 27805, 114, 2, 22, "Print"],
Cell[1004959, 27809, 2544, 45, 149, "Print"],
Cell[1007506, 27856, 68, 2, 22, "Print"],
Cell[1007577, 27860, 252, 5, 22, "Print"],
Cell[1007832, 27867, 114, 2, 22, "Print"],
Cell[1007949, 27871, 81, 2, 22, "Print"],
Cell[1008033, 27875, 114, 2, 22, "Print"],
Cell[1008150, 27879, 224, 5, 22, "Print"],
Cell[1008377, 27886, 132, 3, 22, "Print"],
Cell[1008512, 27891, 768, 18, 41, "Print"]
}, Closed]],
Cell[1009295, 27912, 107, 2, 29, "Text"],

Cell[CellGroupData[{
Cell[1009427, 27918, 825, 16, 91, "Input"],
Cell[1010255, 27936, 213, 4, 21, "Message"],
Cell[1010471, 27942, 122, 3, 22, "Print"],
Cell[1010596, 27947, 122, 3, 22, "Print"],
Cell[1010721, 27952, 122, 3, 22, "Print"],
Cell[1010846, 27957, 74, 2, 22, "Print"],
Cell[1010923, 27961, 65, 2, 22, "Print"],
Cell[1010991, 27965, 122, 3, 22, "Print"],
Cell[1011116, 27970, 684, 16, 31, "Print"],
Cell[1011803, 27988, 68, 2, 22, "Print"],
Cell[1011874, 27992, 613, 15, 33, "Print"],
Cell[1012490, 28009, 68, 2, 22, "Print"],
Cell[1012561, 28013, 680, 16, 31, "Print"],
Cell[1013244, 28031, 68, 2, 22, "Print"],
Cell[1013315, 28035, 69, 2, 22, "Print"],
Cell[1013387, 28039, 182, 4, 21, "Message"],
Cell[1013572, 28045, 220, 6, 22, "Print"],
Cell[1013795, 28053, 68, 2, 22, "Print"],
Cell[1013866, 28057, 122, 3, 22, "Print"],
Cell[1013991, 28062, 68, 2, 22, "Print"],
Cell[1014062, 28066, 249, 5, 22, "Print"],
Cell[1014314, 28073, 704, 14, 41, "Print"],
Cell[1015021, 28089, 305, 6, 22, "Print"],
Cell[1015329, 28097, 125, 3, 22, "Print"],
Cell[1015457, 28102, 182, 4, 22, "Print"],
Cell[1015642, 28108, 853, 19, 22, "Print"],
Cell[1016498, 28129, 849, 19, 22, "Print"],
Cell[1017350, 28150, 851, 19, 22, "Print"],
Cell[1018204, 28171, 851, 19, 22, "Print"],
Cell[1019058, 28192, 417, 11, 22, "Print"],
Cell[1019478, 28205, 417, 11, 22, "Print"],
Cell[1019898, 28218, 435, 11, 22, "Print"],
Cell[1020336, 28231, 68, 2, 22, "Print"],
Cell[1020407, 28235, 5939, 160, 111, "Print"],
Cell[1026349, 28397, 68, 2, 22, "Print"],
Cell[1026420, 28401, 703, 14, 41, "Print"],
Cell[1027126, 28417, 203, 4, 24, "Print"],
Cell[1027332, 28423, 288, 6, 22, "Print"],
Cell[1027623, 28431, 320, 7, 22, "Print"],
Cell[1027946, 28440, 125, 3, 22, "Print"],
Cell[1028074, 28445, 182, 4, 22, "Print"],
Cell[1028259, 28451, 851, 19, 22, "Print"],
Cell[1029113, 28472, 849, 19, 22, "Print"],
Cell[1029965, 28493, 851, 19, 22, "Print"],
Cell[1030819, 28514, 851, 19, 22, "Print"],
Cell[1031673, 28535, 417, 11, 22, "Print"],
Cell[1032093, 28548, 417, 11, 22, "Print"],
Cell[1032513, 28561, 435, 11, 22, "Print"],
Cell[1032951, 28574, 68, 2, 22, "Print"],
Cell[1033022, 28578, 6104, 160, 111, "Print"],
Cell[1039129, 28740, 68, 2, 22, "Print"],
Cell[1039200, 28744, 704, 14, 41, "Print"],
Cell[1039907, 28760, 204, 4, 24, "Print"],
Cell[1040114, 28766, 289, 6, 22, "Print"],
Cell[1040406, 28774, 322, 7, 22, "Print"],
Cell[1040731, 28783, 125, 3, 22, "Print"],
Cell[1040859, 28788, 182, 4, 22, "Print"],
Cell[1041044, 28794, 851, 19, 22, "Print"],
Cell[1041898, 28815, 851, 19, 22, "Print"],
Cell[1042752, 28836, 845, 19, 22, "Print"],
Cell[1043600, 28857, 849, 19, 22, "Print"],
Cell[1044452, 28878, 415, 11, 22, "Print"],
Cell[1044870, 28891, 417, 11, 22, "Print"],
Cell[1045290, 28904, 439, 11, 22, "Print"],
Cell[1045732, 28917, 68, 2, 22, "Print"],
Cell[1045803, 28921, 6126, 160, 111, "Print"],
Cell[1051932, 29083, 68, 2, 22, "Print"],
Cell[1052003, 29087, 702, 14, 41, "Print"],
Cell[1052708, 29103, 203, 4, 24, "Print"],
Cell[1052914, 29109, 288, 6, 22, "Print"],
Cell[1053205, 29117, 323, 7, 22, "Print"],
Cell[1053531, 29126, 125, 3, 22, "Print"],
Cell[1053659, 29131, 182, 4, 22, "Print"],
Cell[1053844, 29137, 849, 19, 22, "Print"],
Cell[1054696, 29158, 849, 19, 22, "Print"],
Cell[1055548, 29179, 849, 19, 22, "Print"],
Cell[1056400, 29200, 849, 19, 22, "Print"],
Cell[1057252, 29221, 417, 11, 22, "Print"],
Cell[1057672, 29234, 415, 11, 22, "Print"],
Cell[1058090, 29247, 437, 11, 22, "Print"],
Cell[1058530, 29260, 68, 2, 22, "Print"],
Cell[1058601, 29264, 6116, 160, 111, "Print"],
Cell[1064720, 29426, 68, 2, 22, "Print"],
Cell[1064791, 29430, 705, 14, 41, "Print"],
Cell[1065499, 29446, 202, 4, 24, "Print"],
Cell[1065704, 29452, 289, 6, 22, "Print"],
Cell[1065996, 29460, 322, 7, 22, "Print"],
Cell[1066321, 29469, 125, 3, 22, "Print"],
Cell[1066449, 29474, 182, 4, 22, "Print"],
Cell[1066634, 29480, 851, 19, 22, "Print"],
Cell[1067488, 29501, 851, 19, 22, "Print"],
Cell[1068342, 29522, 851, 19, 22, "Print"],
Cell[1069196, 29543, 851, 19, 22, "Print"],
Cell[1070050, 29564, 417, 11, 22, "Print"],
Cell[1070470, 29577, 417, 11, 22, "Print"],
Cell[1070890, 29590, 439, 11, 22, "Print"],
Cell[1071332, 29603, 68, 2, 22, "Print"],
Cell[1071403, 29607, 6127, 160, 111, "Print"],
Cell[1077533, 29769, 68, 2, 22, "Print"],
Cell[1077604, 29773, 703, 14, 41, "Print"],
Cell[1078310, 29789, 203, 4, 24, "Print"],
Cell[1078516, 29795, 289, 6, 22, "Print"],
Cell[1078808, 29803, 322, 7, 22, "Print"],
Cell[1079133, 29812, 125, 3, 22, "Print"],
Cell[1079261, 29817, 182, 4, 22, "Print"],
Cell[1079446, 29823, 851, 19, 22, "Print"],
Cell[1080300, 29844, 851, 19, 22, "Print"],
Cell[1081154, 29865, 851, 19, 22, "Print"],
Cell[1082008, 29886, 417, 11, 22, "Print"],
Cell[1082428, 29899, 417, 11, 22, "Print"],
Cell[1082848, 29912, 439, 11, 22, "Print"],
Cell[1083290, 29925, 68, 2, 22, "Print"],
Cell[1083361, 29929, 6124, 160, 111, "Print"],
Cell[1089488, 30091, 68, 2, 22, "Print"],
Cell[1089559, 30095, 704, 14, 41, "Print"],
Cell[1090266, 30111, 204, 4, 24, "Print"],
Cell[1090473, 30117, 289, 6, 22, "Print"],
Cell[1090765, 30125, 322, 7, 22, "Print"],
Cell[1091090, 30134, 125, 3, 22, "Print"],
Cell[1091218, 30139, 182, 4, 22, "Print"],
Cell[1091403, 30145, 851, 19, 22, "Print"],
Cell[1092257, 30166, 851, 19, 22, "Print"],
Cell[1093111, 30187, 847, 19, 22, "Print"],
Cell[1093961, 30208, 413, 11, 22, "Print"],
Cell[1094377, 30221, 417, 11, 22, "Print"],
Cell[1094797, 30234, 439, 11, 22, "Print"],
Cell[1095239, 30247, 68, 2, 22, "Print"],
Cell[1095310, 30251, 6122, 160, 111, "Print"],
Cell[1101435, 30413, 68, 2, 22, "Print"],
Cell[1101506, 30417, 704, 14, 41, "Print"],
Cell[1102213, 30433, 202, 4, 24, "Print"],
Cell[1102418, 30439, 288, 6, 22, "Print"],
Cell[1102709, 30447, 323, 7, 22, "Print"],
Cell[1103035, 30456, 125, 3, 22, "Print"],
Cell[1103163, 30461, 182, 4, 22, "Print"],
Cell[1103348, 30467, 847, 19, 22, "Print"],
Cell[1104198, 30488, 847, 19, 22, "Print"],
Cell[1105048, 30509, 845, 19, 22, "Print"],
Cell[1105896, 30530, 415, 11, 22, "Print"],
Cell[1106314, 30543, 413, 11, 22, "Print"],
Cell[1106730, 30556, 437, 11, 22, "Print"],
Cell[1107170, 30569, 68, 2, 22, "Print"],
Cell[1107241, 30573, 6110, 160, 111, "Print"],
Cell[1113354, 30735, 68, 2, 22, "Print"],
Cell[1113425, 30739, 704, 14, 41, "Print"],
Cell[1114132, 30755, 204, 4, 24, "Print"],
Cell[1114339, 30761, 287, 6, 22, "Print"],
Cell[1114629, 30769, 323, 7, 22, "Print"],
Cell[1114955, 30778, 125, 3, 22, "Print"],
Cell[1115083, 30783, 182, 4, 22, "Print"],
Cell[1115268, 30789, 849, 19, 22, "Print"],
Cell[1116120, 30810, 849, 19, 22, "Print"],
Cell[1116972, 30831, 849, 19, 22, "Print"],
Cell[1117824, 30852, 417, 11, 22, "Print"],
Cell[1118244, 30865, 415, 11, 22, "Print"],
Cell[1118662, 30878, 439, 11, 22, "Print"],
Cell[1119104, 30891, 68, 2, 22, "Print"],
Cell[1119175, 30895, 6112, 160, 111, "Print"],
Cell[1125290, 31057, 68, 2, 22, "Print"],
Cell[1125361, 31061, 704, 14, 41, "Print"],
Cell[1126068, 31077, 202, 4, 24, "Print"],
Cell[1126273, 31083, 288, 6, 22, "Print"],
Cell[1126564, 31091, 322, 7, 22, "Print"],
Cell[1126889, 31100, 125, 3, 22, "Print"],
Cell[1127017, 31105, 184, 4, 22, "Print"],
Cell[1127204, 31111, 417, 11, 22, "Print"],
Cell[1127624, 31124, 417, 11, 22, "Print"],
Cell[1128044, 31137, 437, 11, 22, "Print"],
Cell[1128484, 31150, 68, 2, 22, "Print"],
Cell[1128555, 31154, 6117, 160, 111, "Print"],
Cell[1134675, 31316, 68, 2, 22, "Print"],
Cell[1134746, 31320, 701, 14, 41, "Print"],
Cell[1135450, 31336, 204, 4, 24, "Print"],
Cell[1135657, 31342, 290, 6, 22, "Print"],
Cell[1135950, 31350, 323, 7, 22, "Print"],
Cell[1136276, 31359, 125, 3, 22, "Print"],
Cell[1136404, 31364, 184, 4, 22, "Print"],
Cell[1136591, 31370, 417, 11, 22, "Print"],
Cell[1137011, 31383, 417, 11, 22, "Print"],
Cell[1137431, 31396, 439, 11, 22, "Print"],
Cell[1137873, 31409, 68, 2, 22, "Print"],
Cell[1137944, 31413, 6129, 160, 111, "Print"],
Cell[1144076, 31575, 68, 2, 22, "Print"],
Cell[1144147, 31579, 704, 14, 41, "Print"],
Cell[1144854, 31595, 200, 4, 24, "Print"],
Cell[1145057, 31601, 288, 6, 22, "Print"],
Cell[1145348, 31609, 325, 7, 22, "Print"],
Cell[1145676, 31618, 125, 3, 22, "Print"],
Cell[1145804, 31623, 184, 4, 22, "Print"],
Cell[1145991, 31629, 417, 11, 22, "Print"],
Cell[1146411, 31642, 417, 11, 22, "Print"],
Cell[1146831, 31655, 443, 11, 22, "Print"],
Cell[1147277, 31668, 68, 2, 22, "Print"],
Cell[1147348, 31672, 6145, 160, 111, "Print"],
Cell[1153496, 31834, 68, 2, 22, "Print"],
Cell[1153567, 31838, 703, 14, 41, "Print"],
Cell[1154273, 31854, 204, 4, 24, "Print"],
Cell[1154480, 31860, 288, 6, 22, "Print"],
Cell[1154771, 31868, 328, 7, 22, "Print"],
Cell[1155102, 31877, 125, 3, 22, "Print"],
Cell[1155230, 31882, 184, 4, 22, "Print"],
Cell[1155417, 31888, 417, 11, 22, "Print"],
Cell[1155837, 31901, 417, 11, 22, "Print"],
Cell[1156257, 31914, 457, 11, 24, "Print"],
Cell[1156717, 31927, 68, 2, 22, "Print"],
Cell[1156788, 31931, 6046, 160, 111, "Print"],
Cell[1162837, 32093, 68, 2, 22, "Print"],
Cell[1162908, 32097, 704, 14, 41, "Print"],
Cell[1163615, 32113, 204, 4, 24, "Print"],
Cell[1163822, 32119, 287, 6, 22, "Print"],
Cell[1164112, 32127, 326, 7, 24, "Print"],
Cell[1164441, 32136, 125, 3, 22, "Print"],
Cell[1164569, 32141, 184, 4, 22, "Print"],
Cell[1164756, 32147, 417, 11, 22, "Print"],
Cell[1165176, 32160, 417, 11, 22, "Print"],
Cell[1165596, 32173, 457, 11, 24, "Print"],
Cell[1166056, 32186, 68, 2, 22, "Print"],
Cell[1166127, 32190, 5985, 160, 111, "Print"],
Cell[1172115, 32352, 68, 2, 22, "Print"],
Cell[1172186, 32356, 702, 14, 41, "Print"],
Cell[1172891, 32372, 205, 4, 24, "Print"],
Cell[1173099, 32378, 295, 6, 24, "Print"],
Cell[1173397, 32386, 326, 7, 24, "Print"],
Cell[1173726, 32395, 72, 2, 22, "Print"],
Cell[1173801, 32399, 125, 3, 22, "Print"],
Cell[1173929, 32404, 184, 4, 22, "Print"],
Cell[1174116, 32410, 417, 11, 22, "Print"],
Cell[1174536, 32423, 417, 11, 22, "Print"],
Cell[1174956, 32436, 458, 11, 24, "Print"],
Cell[1175417, 32449, 68, 2, 22, "Print"],
Cell[1175488, 32453, 5925, 160, 111, "Print"],
Cell[1181416, 32615, 68, 2, 22, "Print"],
Cell[1181487, 32619, 703, 14, 41, "Print"],
Cell[1182193, 32635, 205, 4, 24, "Print"],
Cell[1182401, 32641, 285, 5, 24, "Print"],
Cell[1182689, 32648, 327, 7, 24, "Print"],
Cell[1183019, 32657, 72, 2, 22, "Print"],
Cell[1183094, 32661, 72, 2, 22, "Print"],
Cell[1183169, 32665, 72, 2, 22, "Print"],
Cell[1183244, 32669, 256, 5, 22, "Print"],
Cell[1183503, 32676, 768, 22, 113, "Print"],
Cell[1184274, 32700, 68, 2, 22, "Print"],
Cell[1184345, 32704, 5306, 96, 181, "Print"],
Cell[1189654, 32802, 687, 13, 41, "Print"],
Cell[1190344, 32817, 114, 2, 22, "Print"],
Cell[1190461, 32821, 103, 2, 22, "Print"],
Cell[1190567, 32825, 114, 2, 22, "Print"],
Cell[1190684, 32829, 1610, 32, 151, "Print"],
Cell[1192297, 32863, 112, 2, 22, "Print"],
Cell[1192412, 32867, 68, 2, 22, "Print"],
Cell[1192483, 32871, 112, 2, 22, "Print"],
Cell[1192598, 32875, 564, 15, 31, "Print"],
Cell[1193165, 32892, 90, 2, 22, "Print"],
Cell[1193258, 32896, 112, 2, 22, "Print"],
Cell[1193373, 32900, 89, 2, 22, "Print"],
Cell[1193465, 32904, 112, 2, 22, "Print"],
Cell[1193580, 32908, 112, 2, 22, "Print"],
Cell[1193695, 32912, 231, 5, 22, "Print"],
Cell[1193929, 32919, 1392, 31, 111, "Print"],
Cell[1195324, 32952, 113, 2, 22, "Print"],
Cell[1195440, 32956, 97, 2, 22, "Print"],
Cell[1195540, 32960, 113, 2, 22, "Print"],
Cell[1195656, 32964, 2798, 49, 173, "Print"],
Cell[1198457, 33015, 114, 2, 22, "Print"],
Cell[1198574, 33019, 120, 3, 22, "Print"],
Cell[1198697, 33024, 114, 2, 22, "Print"],
Cell[1198814, 33028, 2922, 51, 175, "Print"],
Cell[1201739, 33081, 68, 2, 22, "Print"],
Cell[1201810, 33085, 286, 5, 22, "Print"],
Cell[1202099, 33092, 114, 2, 22, "Print"],
Cell[1202216, 33096, 131, 3, 22, "Print"],
Cell[1202350, 33101, 114, 2, 22, "Print"],
Cell[1202467, 33105, 2394, 42, 149, "Print"],
Cell[1204864, 33149, 68, 2, 22, "Print"],
Cell[1204935, 33153, 250, 4, 22, "Print"],
Cell[1205188, 33159, 114, 2, 22, "Print"],
Cell[1205305, 33163, 81, 2, 22, "Print"],
Cell[1205389, 33167, 114, 2, 22, "Print"],
Cell[1205506, 33171, 224, 5, 22, "Print"],
Cell[1205733, 33178, 132, 3, 22, "Print"],
Cell[1205868, 33183, 765, 18, 53, "Print"]
}, Closed]],

Cell[CellGroupData[{
Cell[1206670, 33206, 73, 2, 24, "Input"],
Cell[1206746, 33210, 66, 2, 27, "Output"]
}, Open  ]],
Cell[1206827, 33215, 88, 1, 32, "Text"],

Cell[CellGroupData[{
Cell[1206940, 33220, 1057, 25, 91, "Input"],
Cell[1208000, 33247, 99, 2, 22, "Print"],
Cell[1208102, 33251, 99, 2, 22, "Print"],
Cell[1208204, 33255, 99, 2, 22, "Print"],
Cell[1208306, 33259, 51, 1, 22, "Print"],
Cell[1208360, 33262, 42, 1, 22, "Print"],
Cell[1208405, 33265, 99, 2, 22, "Print"],
Cell[1208507, 33269, 663, 15, 31, "Print"],
Cell[1209173, 33286, 45, 1, 22, "Print"],
Cell[1209221, 33289, 590, 14, 33, "Print"],
Cell[1209814, 33305, 45, 1, 22, "Print"],
Cell[1209862, 33308, 657, 15, 31, "Print"],
Cell[1210522, 33325, 45, 1, 22, "Print"],
Cell[1210570, 33328, 46, 1, 22, "Print"],
Cell[1210619, 33331, 323, 5, 21, "Message"],
Cell[1210945, 33338, 197, 5, 22, "Print"],
Cell[1211145, 33345, 45, 1, 22, "Print"],
Cell[1211193, 33348, 99, 2, 22, "Print"],
Cell[1211295, 33352, 45, 1, 22, "Print"],
Cell[1211343, 33355, 226, 4, 22, "Print"],
Cell[1211572, 33361, 284, 5, 22, "Print"],
Cell[1211859, 33368, 102, 2, 22, "Print"],
Cell[1211964, 33372, 159, 3, 22, "Print"],
Cell[1212126, 33377, 830, 18, 22, "Print"],
Cell[1212959, 33397, 826, 18, 22, "Print"],
Cell[1213788, 33417, 826, 18, 22, "Print"],
Cell[1214617, 33437, 828, 18, 22, "Print"],
Cell[1215448, 33457, 394, 10, 22, "Print"],
Cell[1215845, 33469, 394, 10, 22, "Print"],
Cell[1216242, 33481, 412, 10, 22, "Print"],
Cell[1216657, 33493, 45, 1, 22, "Print"],
Cell[1216705, 33496, 5913, 159, 111, "Print"],
Cell[1222621, 33657, 36, 1, 22, "Print"],
Cell[1222660, 33660, 1208, 26, 111, "Print"],
Cell[1223871, 33688, 298, 6, 22, "Print"],
Cell[1224172, 33696, 102, 2, 22, "Print"],
Cell[1224277, 33700, 159, 3, 22, "Print"],
Cell[1224439, 33705, 828, 18, 22, "Print"],
Cell[1225270, 33725, 828, 18, 22, "Print"],
Cell[1226101, 33745, 828, 18, 22, "Print"],
Cell[1226932, 33765, 828, 18, 22, "Print"],
Cell[1227763, 33785, 394, 10, 22, "Print"],
Cell[1228160, 33797, 394, 10, 22, "Print"],
Cell[1228557, 33809, 412, 10, 22, "Print"],
Cell[1228972, 33821, 45, 1, 22, "Print"],
Cell[1229020, 33824, 6094, 159, 111, "Print"],
Cell[1235117, 33985, 36, 1, 22, "Print"],
Cell[1235156, 33988, 3202, 65, 111, "Print"],
Cell[1238361, 34055, 299, 6, 22, "Print"],
Cell[1238663, 34063, 102, 2, 22, "Print"],
Cell[1238768, 34067, 159, 3, 22, "Print"],
Cell[1238930, 34072, 828, 18, 22, "Print"],
Cell[1239761, 34092, 828, 18, 22, "Print"],
Cell[1240592, 34112, 828, 18, 22, "Print"],
Cell[1241423, 34132, 828, 18, 22, "Print"],
Cell[1242254, 34152, 394, 10, 22, "Print"],
Cell[1242651, 34164, 394, 10, 22, "Print"],
Cell[1243048, 34176, 416, 10, 22, "Print"],
Cell[1243467, 34188, 45, 1, 22, "Print"],
Cell[1243515, 34191, 6100, 159, 111, "Print"],
Cell[1249618, 34352, 36, 1, 22, "Print"],
Cell[1249657, 34355, 3170, 62, 111, "Print"],
Cell[1252830, 34419, 299, 6, 22, "Print"],
Cell[1253132, 34427, 102, 2, 22, "Print"],
Cell[1253237, 34431, 159, 3, 22, "Print"],
Cell[1253399, 34436, 828, 18, 22, "Print"],
Cell[1254230, 34456, 828, 18, 22, "Print"],
Cell[1255061, 34476, 828, 18, 22, "Print"],
Cell[1255892, 34496, 828, 18, 22, "Print"],
Cell[1256723, 34516, 394, 10, 22, "Print"],
Cell[1257120, 34528, 394, 10, 22, "Print"],
Cell[1257517, 34540, 414, 10, 22, "Print"],
Cell[1257934, 34552, 45, 1, 22, "Print"],
Cell[1257982, 34555, 6100, 159, 111, "Print"],
Cell[1264085, 34716, 36, 1, 22, "Print"],
Cell[1264124, 34719, 3214, 61, 111, "Print"],
Cell[1267341, 34782, 300, 6, 22, "Print"],
Cell[1267644, 34790, 102, 2, 22, "Print"],
Cell[1267749, 34794, 159, 3, 22, "Print"],
Cell[1267911, 34799, 828, 18, 22, "Print"],
Cell[1268742, 34819, 828, 18, 22, "Print"],
Cell[1269573, 34839, 828, 18, 22, "Print"],
Cell[1270404, 34859, 828, 18, 22, "Print"],
Cell[1271235, 34879, 394, 10, 22, "Print"],
Cell[1271632, 34891, 394, 10, 22, "Print"],
Cell[1272029, 34903, 414, 10, 22, "Print"],
Cell[1272446, 34915, 45, 1, 22, "Print"],
Cell[1272494, 34918, 6094, 159, 111, "Print"],
Cell[1278591, 35079, 36, 1, 22, "Print"],
Cell[1278630, 35082, 3288, 64, 111, "Print"],
Cell[1281921, 35148, 299, 6, 22, "Print"],
Cell[1282223, 35156, 102, 2, 22, "Print"],
Cell[1282328, 35160, 159, 3, 22, "Print"],
Cell[1282490, 35165, 828, 18, 22, "Print"],
Cell[1283321, 35185, 828, 18, 22, "Print"],
Cell[1284152, 35205, 828, 18, 22, "Print"],
Cell[1284983, 35225, 394, 10, 22, "Print"],
Cell[1285380, 35237, 394, 10, 22, "Print"],
Cell[1285777, 35249, 416, 10, 22, "Print"],
Cell[1286196, 35261, 45, 1, 22, "Print"],
Cell[1286244, 35264, 6099, 159, 111, "Print"],
Cell[1292346, 35425, 36, 1, 22, "Print"],
Cell[1292385, 35428, 3267, 64, 111, "Print"],
Cell[1295655, 35494, 299, 6, 22, "Print"],
Cell[1295957, 35502, 102, 2, 22, "Print"],
Cell[1296062, 35506, 159, 3, 22, "Print"],
Cell[1296224, 35511, 828, 18, 22, "Print"],
Cell[1297055, 35531, 828, 18, 22, "Print"],
Cell[1297886, 35551, 828, 18, 22, "Print"],
Cell[1298717, 35571, 394, 10, 22, "Print"],
Cell[1299114, 35583, 394, 10, 22, "Print"],
Cell[1299511, 35595, 416, 10, 22, "Print"],
Cell[1299930, 35607, 45, 1, 22, "Print"],
Cell[1299978, 35610, 6100, 159, 111, "Print"],
Cell[1306081, 35771, 36, 1, 22, "Print"],
Cell[1306120, 35774, 3216, 61, 111, "Print"],
Cell[1309339, 35837, 300, 6, 22, "Print"],
Cell[1309642, 35845, 102, 2, 22, "Print"],
Cell[1309747, 35849, 159, 3, 22, "Print"],
Cell[1309909, 35854, 828, 18, 22, "Print"],
Cell[1310740, 35874, 828, 18, 22, "Print"],
Cell[1311571, 35894, 828, 18, 22, "Print"],
Cell[1312402, 35914, 394, 10, 22, "Print"],
Cell[1312799, 35926, 394, 10, 22, "Print"],
Cell[1313196, 35938, 414, 10, 22, "Print"],
Cell[1313613, 35950, 45, 1, 22, "Print"],
Cell[1313661, 35953, 6093, 159, 111, "Print"],
Cell[1319757, 36114, 36, 1, 22, "Print"],
Cell[1319796, 36117, 3235, 62, 111, "Print"],
Cell[1323034, 36181, 300, 6, 22, "Print"],
Cell[1323337, 36189, 102, 2, 22, "Print"],
Cell[1323442, 36193, 159, 3, 22, "Print"],
Cell[1323604, 36198, 828, 18, 22, "Print"],
Cell[1324435, 36218, 828, 18, 22, "Print"],
Cell[1325266, 36238, 826, 18, 22, "Print"],
Cell[1326095, 36258, 392, 10, 22, "Print"],
Cell[1326490, 36270, 394, 10, 22, "Print"],
Cell[1326887, 36282, 416, 10, 22, "Print"],
Cell[1327306, 36294, 45, 1, 22, "Print"],
Cell[1327354, 36297, 6107, 159, 111, "Print"],
Cell[1333464, 36458, 36, 1, 22, "Print"],
Cell[1333503, 36461, 3267, 62, 111, "Print"],
Cell[1336773, 36525, 300, 6, 22, "Print"],
Cell[1337076, 36533, 102, 2, 22, "Print"],
Cell[1337181, 36537, 161, 3, 22, "Print"],
Cell[1337345, 36542, 394, 10, 22, "Print"],
Cell[1337742, 36554, 392, 10, 22, "Print"],
Cell[1338137, 36566, 414, 10, 22, "Print"],
Cell[1338554, 36578, 45, 1, 22, "Print"],
Cell[1338602, 36581, 6095, 159, 111, "Print"],
Cell[1344700, 36742, 36, 1, 22, "Print"],
Cell[1344739, 36745, 3264, 62, 111, "Print"],
Cell[1348006, 36809, 301, 6, 22, "Print"],
Cell[1348310, 36817, 102, 2, 22, "Print"],
Cell[1348415, 36821, 161, 3, 22, "Print"],
Cell[1348579, 36826, 394, 10, 22, "Print"],
Cell[1348976, 36838, 394, 10, 22, "Print"],
Cell[1349373, 36850, 416, 10, 22, "Print"],
Cell[1349792, 36862, 45, 1, 22, "Print"],
Cell[1349840, 36865, 6105, 159, 111, "Print"],
Cell[1355948, 37026, 36, 1, 22, "Print"],
Cell[1355987, 37029, 3254, 62, 111, "Print"],
Cell[1359244, 37093, 303, 6, 22, "Print"],
Cell[1359550, 37101, 102, 2, 22, "Print"],
Cell[1359655, 37105, 161, 3, 22, "Print"],
Cell[1359819, 37110, 394, 10, 22, "Print"],
Cell[1360216, 37122, 394, 10, 22, "Print"],
Cell[1360613, 37134, 420, 10, 22, "Print"],
Cell[1361036, 37146, 45, 1, 22, "Print"],
Cell[1361084, 37149, 6122, 159, 111, "Print"],
Cell[1367209, 37310, 36, 1, 22, "Print"],
Cell[1367248, 37313, 3251, 62, 111, "Print"],
Cell[1370502, 37377, 305, 6, 22, "Print"],
Cell[1370810, 37385, 102, 2, 22, "Print"],
Cell[1370915, 37389, 161, 3, 22, "Print"],
Cell[1371079, 37394, 394, 10, 22, "Print"],
Cell[1371476, 37406, 394, 10, 22, "Print"],
Cell[1371873, 37418, 432, 10, 24, "Print"],
Cell[1372308, 37430, 45, 1, 22, "Print"],
Cell[1372356, 37433, 6022, 159, 111, "Print"],
Cell[1378381, 37594, 36, 1, 22, "Print"],
Cell[1378420, 37597, 3248, 62, 111, "Print"],
Cell[1381671, 37661, 304, 6, 24, "Print"],
Cell[1381978, 37669, 102, 2, 22, "Print"],
Cell[1382083, 37673, 161, 3, 22, "Print"],
Cell[1382247, 37678, 394, 10, 22, "Print"],
Cell[1382644, 37690, 394, 10, 22, "Print"],
Cell[1383041, 37702, 434, 10, 24, "Print"],
Cell[1383478, 37714, 45, 1, 22, "Print"],
Cell[1383526, 37717, 5955, 159, 111, "Print"],
Cell[1389484, 37878, 36, 1, 22, "Print"],
Cell[1389523, 37881, 3211, 62, 111, "Print"],
Cell[1392737, 37945, 304, 6, 24, "Print"],
Cell[1393044, 37953, 49, 1, 22, "Print"],
Cell[1393096, 37956, 49, 1, 22, "Print"],
Cell[1393148, 37959, 49, 1, 22, "Print"],
Cell[1393200, 37962, 233, 4, 22, "Print"],
Cell[1393436, 37968, 776, 21, 115, "Print"],
Cell[1394215, 37991, 36, 1, 22, "Print"],
Cell[1394254, 37994, 3218, 61, 111, "Print"],
Cell[1397475, 38057, 5011, 93, 171, "Print"],
Cell[1402489, 38152, 663, 12, 24, "Print"],
Cell[1403155, 38166, 91, 1, 22, "Print"],
Cell[1403249, 38169, 80, 1, 22, "Print"],
Cell[1403332, 38172, 91, 1, 22, "Print"],
Cell[1403426, 38175, 2308, 48, 115, "Print"],
Cell[1405737, 38225, 89, 1, 22, "Print"],
Cell[1405829, 38228, 45, 1, 22, "Print"],
Cell[1405877, 38231, 89, 1, 22, "Print"],
Cell[1405969, 38234, 540, 14, 31, "Print"],
Cell[1406512, 38250, 67, 1, 22, "Print"],
Cell[1406582, 38253, 89, 1, 22, "Print"],
Cell[1406674, 38256, 66, 1, 22, "Print"],
Cell[1406743, 38259, 89, 1, 22, "Print"],
Cell[1406835, 38262, 89, 1, 22, "Print"],
Cell[1406927, 38265, 208, 4, 22, "Print"],
Cell[1407138, 38271, 1368, 30, 111, "Print"],
Cell[1408509, 38303, 90, 1, 22, "Print"],
Cell[1408602, 38306, 74, 1, 22, "Print"],
Cell[1408679, 38309, 90, 1, 22, "Print"],
Cell[1408772, 38312, 3308, 63, 117, "Print"],
Cell[1412083, 38377, 91, 1, 22, "Print"],
Cell[1412177, 38380, 97, 2, 22, "Print"],
Cell[1412277, 38384, 91, 1, 22, "Print"],
Cell[1412371, 38387, 3466, 65, 129, "Print"],
Cell[1415840, 38454, 45, 1, 22, "Print"],
Cell[1415888, 38457, 261, 4, 22, "Print"],
Cell[1416152, 38463, 91, 1, 22, "Print"],
Cell[1416246, 38466, 108, 2, 22, "Print"],
Cell[1416357, 38470, 91, 1, 22, "Print"],
Cell[1416451, 38473, 3140, 60, 111, "Print"],
Cell[1419594, 38535, 45, 1, 22, "Print"],
Cell[1419642, 38538, 229, 3, 22, "Print"],
Cell[1419874, 38543, 91, 1, 22, "Print"],
Cell[1419968, 38546, 58, 1, 22, "Print"],
Cell[1420029, 38549, 91, 1, 22, "Print"],
Cell[1420123, 38552, 201, 4, 22, "Print"],
Cell[1420327, 38558, 109, 2, 22, "Print"],
Cell[1420439, 38562, 741, 17, 51, "Print"]
}, Closed]],

Cell[CellGroupData[{
Cell[1421217, 38584, 102, 3, 24, "Input"],
Cell[1421322, 38589, 132, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1421491, 38596, 176, 4, 48, "Input"],
Cell[1421670, 38602, 1231, 25, 115, "Output"]
}, Open  ]],
Cell[1422916, 38630, 227, 7, 27, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1423168, 38641, 176, 4, 48, "Input"],
Cell[1423347, 38647, 1253, 26, 115, "Output"]
}, Open  ]],
Cell[1424615, 38676, 24, 0, 30, "Text"],

Cell[CellGroupData[{
Cell[1424664, 38680, 102, 3, 27, "Input"],
Cell[1424769, 38685, 159, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1424965, 38693, 176, 4, 48, "Input"],
Cell[1425144, 38699, 804, 15, 153, "Output"]
}, Open  ]],
Cell[1425963, 38717, 227, 7, 27, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1426215, 38728, 176, 4, 48, "Input"],
Cell[1426394, 38734, 377, 6, 21, "Message"],
Cell[1426774, 38742, 805, 15, 153, "Output"]
}, Open  ]],
Cell[1427594, 38760, 106, 2, 32, "Text"],

Cell[CellGroupData[{
Cell[1427725, 38766, 176, 4, 48, "Input"],
Cell[1427904, 38772, 202, 4, 21, "Message"],
Cell[1428109, 38778, 802, 15, 153, "Output"]
}, Open  ]],
Cell[1428926, 38796, 171, 5, 27, "Input"],

Cell[CellGroupData[{
Cell[1429122, 38805, 176, 4, 48, "Input"],
Cell[1429301, 38811, 202, 4, 21, "Message"],
Cell[1429506, 38817, 802, 15, 153, "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[1430357, 38838, 31, 0, 30, "Subsection"],

Cell[CellGroupData[{
Cell[1430413, 38842, 135, 4, 43, "Input"],
Cell[1430551, 38848, 42, 1, 27, "Output"],
Cell[1430596, 38851, 42, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1430675, 38857, 38, 1, 27, "Input"],
Cell[1430716, 38860, 255, 4, 27, "Output"]
}, Open  ]],
Cell[1430986, 38867, 212, 4, 43, "Input"],

Cell[CellGroupData[{
Cell[1431223, 38875, 53, 1, 27, "Input"],
Cell[1431279, 38878, 43, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1431359, 38884, 54, 1, 27, "Input"],
Cell[1431416, 38887, 43, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1431496, 38893, 75, 1, 27, "Input"],
Cell[1431574, 38896, 337, 5, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1431948, 38906, 50, 1, 27, "Input"],
Cell[1432001, 38909, 43, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1432081, 38915, 216, 3, 75, "Input"],
Cell[1432300, 38920, 1312, 21, 75, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1433649, 38946, 362, 5, 59, "Input"],
Cell[1434014, 38953, 27131, 886, 186, 10227, 673, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1461148, 39841, 130, 3, 27, "Output"],
Cell[1461281, 39846, 37976, 1031, 186, 11696, 702, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1499260, 40879, 130, 3, 27, "Output"]
}, Open  ]]
}, Closed]]
}, Closed]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

